'+--------------------------------------------------------------------------+
'|                                MovieBox                                  |
'|                                                                          |
'|                          DirectX Movie player                            |
'|                                                                          |
'|           with full crystal and blur effect in composited mode           |
'|                                                                          |
'|                Example of what is going on behind the hood.              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2009                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-04-2007 (MM-DD-YYYY)            |
'|                        Last revised : 01-31-2010 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "MovieBox.exe"
#OPTION VERSION5

'#OPTIMIZE SPEED
'#OPTIMIZE SIZE

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO

'------------------------------------------------------------------------------------------
' Movie section
'------------------------------------------------------------------------------------------
#INCLUDE "MovieBox.INC"   ' Active movie

$Version              = "Version 2.61"
$MOVIEXT              = ".avi.wmv.mpeg.mpg.mov.qt.mkv.mp4.flv." '// See also sOptions to setup the common dialog file selector
%OAFALSE              = 0
%OATRUE               = -1
%E_POINTER            = &H80004003
%CLSCTX_INPROC_SERVER = &H1???
%WM_MOVIENOTIFY       = %WM_USER + 13

GLOBAL gbMoviePlaying, gnContainerW, gnContainerH, gbMuteMode, gbFullScreen AS LONG
GLOBAL gMovieDuration AS DOUBLE, gmWidth, gmHeight AS LONG

GLOBAL pIMediaControl        AS IMediaControl
GLOBAL pIGraphBuilder        AS IGraphBuilder
GLOBAL pIMediaEventEx        AS IMediaEventEx
GLOBAL pIVideoWindow         AS IVideoWindow
GLOBAL pIBasicVideo          AS IBasicVideo
GLOBAL pIBasicAudio          AS IBasicAudio
GLOBAL pIMediaPosition       AS IMediaPosition

GLOBAL ghVideoHandle   AS LONG

'// Include the Skin Engine interface
#INCLUDE "ZSKIN2.INC"

DECLARE FUNCTION zMovieContainer (BYVAL hOwner AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL W AS LONG, BYVAL H AS LONG, BYVAL UseID AS LONG, BYVAL ARGB AS LONG) AS LONG

TYPE OPENFILENAME
    lStructSize       AS DWORD
    hWndOwner         AS DWORD
    hInstance         AS DWORD
    lpstrFilter       AS ASCIIZ PTR
    lpstrCustomFilter AS ASCIIZ PTR
    nMaxCustFilter    AS DWORD
    nFilterIndex      AS DWORD
    lpstrFile         AS ASCIIZ PTR
    nMaxFile          AS DWORD
    lpstrFileTitle    AS ASCIIZ PTR
    nMaxFileTitle     AS DWORD
    lpstrInitialDir   AS ASCIIZ PTR
    lpstrTitle        AS ASCIIZ PTR
    Flags             AS DWORD
    nFileOffset       AS WORD
    nFileExtension    AS WORD
    lpstrDefExt       AS ASCIIZ PTR
    lCustData         AS LONG
    lpfnHook          AS DWORD
    lpTemplateName    AS ASCIIZ PTR
END TYPE

DECLARE FUNCTION GetOpenFileName LIB "COMDLG32.DLL" ALIAS "GetOpenFileNameA" (lpofn AS OPENFILENAME) AS LONG

FUNCTION OpenFileDialog (BYVAL hWnd AS DWORD, _            ' parent window
                         BYVAL sCaption AS STRING, _       ' caption
                         sFileSpec AS STRING, _            ' filename
                         BYVAL sInitialDir AS STRING, _    ' start directory
                         BYVAL sFilter AS STRING, _        ' filename filter
                         BYVAL sDefExtension AS STRING, _  ' default extension
                         dFlags AS DWORD _                 ' flags
                         ) AS LONG

    LOCAL ix          AS LONG
    LOCAL ofn         AS OPENFILENAME
    LOCAL szFileTitle AS ASCIIZ * %MAX_PATH

    ' Filter is a sequence of ASCIIZ strings with a final (extra) $NUL terminator
    REPLACE "|" WITH $NUL IN sFilter
    sFilter = sFilter + $NUL

    IF LEN(sInitialDir) = 0 THEN
        sInitialDir = CURDIR$
    END IF

    ix = INSTR(sFileSpec, $NUL)
    IF ix THEN
        sFileSpec = LEFT$(sFileSpec, ix) + SPACE$(8192 - ix)
    ELSE
        sFileSpec = sFileSpec + $NUL + SPACE$(8192 - (LEN(sFileSpec) + 1))
    END IF

    ofn.lStructSize      = SIZEOF(ofn)
    ofn.hWndOwner        = hWnd
    ofn.lpstrFilter      = STRPTR(sFilter)
    ofn.nFilterIndex     = 1
    ofn.lpstrFile        = STRPTR(sFileSpec)
    ofn.nMaxFile         = LEN(sFileSpec)
    ofn.lpstrFileTitle   = VARPTR(szFileTitle)
    ofn.nMaxFileTitle    = SIZEOF(szFileTitle)
    ofn.lpstrInitialDir  = STRPTR(sInitialDir)
    IF LEN(sCaption) THEN
        ofn.lpstrTitle   = STRPTR(sCaption)
    END IF
    ofn.Flags            = dFlags
    IF LEN(sDefExtension) THEN
        ofn.lpstrDefExt  = STRPTR(sDefExtension)
    END IF

    FUNCTION = GetOpenFilename(ofn)

    ix = INSTR(-1, sFileSpec, $NUL)
    IF ix THEN
        sFileSpec = LEFT$(sFileSpec, ix - 1)
    ELSE
        sFileSpec = ""
    END IF

    dFlags = ofn.Flags

END FUNCTION

FUNCTION FileOpen (BYVAL hWnd AS DWORD) AS STRING

    LOCAL sPath    AS STRING
    LOCAL sOptions AS STRING
    LOCAL dwStyle  AS DWORD
    LOCAL sfile    AS STRING

    sPath  = CURDIR$
    sOptions = "Video Files (*.MPG;*MPEG;*.AVI;*.MOV;*.QT;*.WMV;*.MKV;*.FLV)|*.MPG;*.MPEG;*.AVI;*.MOV;*.QT;*.WMV;*.MKV;*.FLV|"
    sfile    = "*.MPG;*.MPEG;*.AVI;*.MOV;*.QT;*.WMV;*.MKV;*.FLV"
    dwStyle = &H00080000 OR &H00001000
    IF OpenFileDialog(hWnd, "", sfile, sPath, sOptions, "MPG", dwStyle) THEN
       FUNCTION = sfile
    END IF

END FUNCTION

%OFN_ENABLEHOOK                                 = &H00000020
%OFN_FILEMUSTEXIST                              = &H00001000
%OFN_EXPLORER                                   = &H00080000 ' new look commdlg
%OFN_LONGNAMES                                  = &H00200000 ' force long names for 3.x modules
%OFN_EX_NOPLACESBAR                             = &H00000001

TYPE OPENFILENAMEEX
    lStructSize       AS DWORD
    hWndOwner         AS DWORD
    hInstance         AS DWORD
    lpstrFilter       AS ASCIIZ PTR
    lpstrCustomFilter AS ASCIIZ PTR
    nMaxCustFilter    AS DWORD
    nFilterIndex      AS DWORD
    lpstrFile         AS ASCIIZ PTR
    nMaxFile          AS DWORD
    lpstrFileTitle    AS ASCIIZ PTR
    nMaxFileTitle     AS DWORD
    lpstrInitialDir   AS ASCIIZ PTR
    lpstrTitle        AS ASCIIZ PTR
    Flags             AS DWORD
    nFileOffset       AS WORD
    nFileExtension    AS WORD
    lpstrDefExt       AS ASCIIZ PTR
    lCustData         AS LONG
    lpfnHook          AS DWORD
    lpTemplateName    AS ASCIIZ PTR
    '--- new Windows 2000 structure members ---
    pvReserved        AS LONG
    dwReserved        AS DWORD
    FlagsEx           AS DWORD
END TYPE

DECLARE FUNCTION GetSaveFileName LIB "COMDLG32.DLL" ALIAS "GetSaveFileNameA" (lpofn AS OPENFILENAME) AS LONG

FUNCTION SaveFileDialog (BYVAL hWnd AS DWORD, _          ' parent window
                          BYVAL Caption AS STRING, _      ' caption
                          Filespec AS STRING, _           ' filename
                          BYVAL InitialDir AS STRING, _   ' start directory
                          BYVAL Filter AS STRING, _       ' filename filter
                          BYVAL DefExtension AS STRING, _ ' default extension
                          Flags AS DWORD ) AS LONG        ' flags

    LOCAL Ofn         AS OPENFILENAMEEX
    LOCAL zFile       AS ASCIIZ * %MAX_PATH
    LOCAL zFileTitle  AS ASCIIZ * %MAX_PATH
    LOCAL zInitialDir AS ASCIIZ * %MAX_PATH
    LOCAL zTitle      AS ASCIIZ * %MAX_PATH
    LOCAL zDefExt     AS ASCIIZ * %MAX_PATH

    REPLACE $zLim WITH $NUL IN Filter
    Filter = Filter + $NUL

    IF LEN(InitialDir) = 0 THEN InitialDir = CURDIR$

    zInitialDir = InitialDir   + $NUL
    zFile       = Filespec     + $NUL
    zDefExt     = DefExtension + $NUL
    zTitle      = Caption      + $NUL

    ofn.lStructSize       = SIZEOF(ofn)
    ofn.hWndOwner         = hWnd
    ofn.lpstrFilter       = STRPTR(Filter)
    ofn.lpstrFile         = VARPTR(zFile)
    ofn.nMaxFile          = SIZEOF(zFile)
    ofn.lpstrFileTitle    = VARPTR(zFileTitle)
    ofn.nMaxFileTitle     = SIZEOF(zFileTitle)
    ofn.lpstrInitialDir   = VARPTR(zInitialDir)
    IF LEN(zTitle) THEN
        ofn.lpstrTitle    = VARPTR(zTitle)
    END IF
    ofn.Flags             = Flags
    'ofn.lpfnHook          = CODEPTR(DlgHookProc)
    ofn.lpstrDefExt       = VARPTR(zDefExt)

    ofn.FlagsEx           = %OFN_EX_NOPLACESBAR

    ofn.nFilterIndex      = 1 ' JPG
    'ofn.nFilterIndex      = 1 ' BMP

    FUNCTION = GetSaveFilename(BYVAL VARPTR(ofn))

    Filespec = RTRIM$(InitialDir, $Anti) + $Anti + Filespec

    Filespec = zFile
    Flags = ofn.Flags

END FUNCTION

FUNCTION FileSave (BYVAL hWnd AS LONG) AS STRING
    LOCAL sFilter, sFileName, sPath, sPicFile AS STRING, nCount AS LONG
    STATIC sLayerPath AS STRING

    sPath = sLayerPath
    sPicFile = "Capture.jpg" ' "Untitled.png"

    sFilter = "*.JPG (JPEG File Interchange)|*.JPG;*.JPEG|" + _
              "*.BMP (Windows Bitmap)|*.BMP|" + _
              "*.TIF (Tagged Image File)|*.TIF;*.TIFF|"

    'Style& = %OFN_FILEMUSTEXIST OR %OFN_ENABLEHOOK OR %OFN_EXPLORER
    Style& = &H00080000 OR &H00001000

    IF SaveFileDialog(hWnd, "Save AS", sPicFile, sPath, sFilter, "JPG", Style&) THEN
       CALL apiSleep(100)
       sLayerPath = PATHNAME$(PATH, sPicFile)
       sFileName = PATHNAME$(NAME, sPicFile)
       nCount = PARSECOUNT(sFileName, $Dot)
       IF nCount > 2 THEN sPicFile = sLayerPath + PARSE$(sFileName, $Dot, 1) + $Dot + PARSE$(sFileName, $Dot, nCount)

       FUNCTION = sPicFile

    END IF
END FUNCTION
'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
%WM_DROPFILES = &H233

DECLARE SUB DragAcceptFiles LIB "SHELL32.DLL" ALIAS "DragAcceptFiles" (BYVAL hwnd AS DWORD, BYVAL fAccept AS LONG)
DECLARE SUB DragFinish LIB "SHELL32.DLL" ALIAS "DragFinish" (BYVAL hDrop AS DWORD)
DECLARE FUNCTION DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (BYVAL hDrop AS DWORD, BYVAL uiFile AS DWORD, lpStr AS ASCIIZ, BYVAL cch AS DWORD) AS DWORD

%XMIN_SIZE = 546
%YMIN_SIZE = 384

%ID_AEROBUTTON       = 1
%ID_MOVIECONTAINER   = 2

%ID_BTN_PAUSE        = 3
%ID_BTN_PLAY         = 4

%ID_FULLSCREEN       = 5

%ID_TRACK_SEARCH     = 6
%ID_TRACK_VOL        = 7

%ID_TIME             = 8
%ID_DURATION         = 9
%ID_ELLAPSED         = 10

%ID_MUTE_ON          = 11
%ID_MUTE_OFF         = 12

%ID_AEROCRYSTAL      = 13
%ID_AEROBLUR         = 14
%ID_AERODISABLE      = 15
%ID_BTN_ABOUT        = 16
%ID_BTN_HELP         = 17
%ID_TITLE            = 18

%ID_BTN_BACKL        = 19
%ID_BTN_BACKR        = 20
%ID_Background       = 21
%ID_SIZE             = 22
%ID_SNAPSHOT         = 23
'%ID_VERSION          = 24

%AERO_TIMER          = 1

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WNDCLASSEXA
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZMOVIEBOX"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          CALL PlayFromCommand(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,EXE.Name$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL ' Don't paint the class window background
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
'
     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()
'
     ' Window Extended Style
       dwExStyle = 0
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "MovieBox"
       hMain = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                             zClass, _               ' Class Name
                             (MyTitle$), _           ' Window Title
                             dwStyle, _              ' Defined Window Style
                             x, y, _                 ' Window Position
                             rc.nRight - rc.nLeft, _ ' Calculate Window Width
                             rc.nBottom - rc.nTop, _ ' Calculate Window Height
                             %NULL, _                ' No Parent Window
                             %NULL, _                ' No Menu
                             wc.hInstance, _         ' Instance
                             BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          'CALL zInitSkin(hMain, "MovieBox.zsk")
          'CALL zInitSkin(hMain, "DarkCrystal.zsk")
          CALL zInitSkin(hMain, "MovieBoxSkin.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls(hMain)

'         // To perform movie file drag and drop
          CALL DragAcceptFiles(hMain, %TRUE)

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(5) ' 5 = UseStep for layered animation

          CALL PlayFromCommand(hMain)

'//    LOCAL pIAudioEndpointVolume AS IAudioEndpointVolume
'//
'//    'LET pIAudioEndpointVolume = NEWCOM CLSID $IID_IAudioEndpointVolume
'//    'IF NOT ISNOTHING(pIAudioEndpointVolume) THEN' EXIT SUB
'//    ''IF ISOBJECT(pIAudioEndpointVolume) THEN
'//    '
'//    '   LOCAL currentVolume AS SINGLE
'//    '   pIAudioEndpointVolume.GetMasterVolumeLevel(currentVolume)
'//    '   pIAudioEndpointVolume.SetMasterVolumeLevel(currentVolume, "")
'//
'//msgbox str$(ISOBJECT(pIAudioEndpointVolume))'currentVolume)
'//'pIAudioEndpointVolume = NOTHING
'//    'END IF

          IF SK_AEROEMULATE() THEN CALL SetTimer(hMain, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(hMain, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND
          IF SK_AEROEMULATE() THEN CALL KillTimer(hMain, %AERO_TIMER)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// To parse the command line when files are dropped onto the desktop icon
SUB PlayFromCommand(BYVAL hFound AS LONG)
    LOCAL K, S1, S2, Count, nCount AS LONG
    LOCAL sDataString AS STRING

    Cline$ = COMMAND$
    DO
       S1 = INSTR(Cline$, $DQ)
       IF S1 THEN
          S2 = INSTR(S1 + 1, Cline$, $DQ)
          IF S2 THEN
             sDataString = MID$(Cline$, S1 + 1, S2 - S1 - 1)
             REPLACE $SPC WITH CHR$(1) IN sDataString
             Cline$ = LEFT$(Cline$, S1 - 1) + sDataString + MID$(Cline$, S2 + 1)
             IF S2 > LEN(Cline$) THEN EXIT DO
          END IF
       ELSE
          REPLACE $SPC WITH CHR$(1) IN Cline$
          EXIT DO
       END IF
    LOOP
    REPLACE $SPC WITH $zLim IN Cline$
    REPLACE CHR$(1) WITH $SPC IN Cline$
    S1 = 1
    DO
       S1 = INSTR(S1, Cline$, $SPC)
       IF S1 THEN
          IF MID$(Cline$, S1 + 2, 2) = ":\" THEN MID$(Cline$, S1, 1) = $zLim
          S1 = S1 + 1
       END IF
    LOOP UNTIL S1 = 0
    Count = PARSECOUNT(Cline$, $zLim)
    IF Count THEN
       nCount = 0
       sDataString = ""
       FOR K = 1 TO Count
           sDataString = sDataString + $zLim + LCASE$(PARSE$(Cline$, $zLim, K)): INCR nCount
       NEXT
       IF nCount THEN
          CALL zSendPrivateMsg(hFound, %ZM_STRINGDATA, TRIM$(sDataString, $zLim))
       END IF
       sDataString = ""
    END IF

END SUB

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL Item AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF Item > 0 THEN
       DECR Item
       nLEN = SendMessage(hList, %LB_GETTEXTLEN, Item, 0)
       sItem = SPACE$(nLEN)
       CALL SendMessage(hList, %LB_GETTEXT, Item, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

'// Fill the bakground listbox
'// Warning: Currently only JPG files!
SUB DetectBackground()
    LOCAL hList, WashFind, hFind, BackgroundCount, nSelected AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL zBackground AS ASCIIZ * %MAX_PATH
    LOCAL sBackgroundPath AS STRING
    LOCAL nActiveBackgroundSize AS QUAD
    LOCAL nItemSize AS QUAD

'   // Size of the current active background image
    nActiveBackgroundSize = zsFileSize((SK_CENTERFORM()))

    sBackgroundPath = EXE.Path$ + "Background\"

    hList = zGetMainItem(%ID_Background)
    CALL ListDeleteAll(hList)

    WashFind = FindFirstFile((sBackgroundPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sBackgroundPath + fd.cFileName: CALL CharLower(zTmp)
             IF INSTR(".jpg.", RIGHT$(zTmp, 4) + ".") THEN
                nItemSize = MAK(QUAD, fd.nFileSizeLow, fd.nFileSizeHigh)
                IF ListAdd(hList, zTmp) > -1 THEN
                   INCR BackgroundCount
'                  // If same size, then we assume it is our current background...
                   IF nItemSize = nActiveBackgroundSize THEN zBackground = zTmp
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    nSelected = ListFindString(hList, zBackground)
    CALL ListSelectPlus(hList, nSelected)

    IF BackgroundCount < 2 THEN
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)
    END IF

END SUB

'// Add child controls to main window
SUB AddChildControls(BYVAL hMain AS LONG)

    LOCAL hCtrl, imgW, imgH AS LONG

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

    hCtrl = zFrameButton(hMain, (SK_FOLDER() + "Aero.png"), "", 3, %YMIN_SIZE - 69, %XMIN_SIZE - 6, 66, %ID_AEROBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    CALL zGetImageSize(zGetProperty(hMain, %FORM_TopMid), 0, imgH)
    gnContainerW = %XMIN_SIZE - 6
    gnContainerH = %YMIN_SIZE - 69 - imgH
    hCtrl = zMovieContainer(hMain, 3, imgH, gnContainerW, gnContainerH, %ID_MOVIECONTAINER, zColorARGB(255, 0))
    CALL zSetAnchorMode(hCtrl, %ANCHOR_HEIGHT_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_TOP)

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Pause.png"), -100, -100, %ID_BTN_PAUSE, 0)
    CALL zGetImageSize(zGetButImageBackProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL ShowWindow(hCtrl, %SW_HIDE): CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    CALL MoveWindow(hCtrl, (%XMIN_SIZE - imgW) \ 2, %YMIN_SIZE - 56, imgW, imgH, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Pause")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Play.png"), -100, -100, %ID_BTN_PLAY, 0)
    CALL zGetImageSize(zGetButImageBackProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
    CALL MoveWindow(hCtrl, (%XMIN_SIZE - imgW) \ 2, %YMIN_SIZE - 56, imgW, imgH, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Play")

    'hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_FullScreen.png"), (%XMIN_SIZE - imgW) \ 2 - 30, %YMIN_SIZE - 44, %ID_FULLSCREEN, 0)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    'CALL zSetZorder(hCtrl, %HWND_TOP)
    'CALL zCreateToolTip(hCtrl, "Full screen")

    hCtrl = zPushButtonEx(hMain, (SK_FOLDER() + "BTN_Hover.png"), "", (%XMIN_SIZE - imgW) \ 2 - 30, %YMIN_SIZE - 44, 25, 25, %ID_FULLSCREEN, SK_BTNTEXTCOLOR(), 0, 0, (SK_FOLDER() + "FullScreen.png"))
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Full screen")

    hCtrl = zPushButtonEx(hMain, (SK_FOLDER() + "BTN_Hover.png"), "", (%XMIN_SIZE - imgW) \ 2 - 60, %YMIN_SIZE - 44, 25, 25, %ID_SNAPSHOT, SK_BTNTEXTCOLOR(), 0, 0, (SK_FOLDER() + "SnapShot.png"))
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "SnapShot")


    hCtrl = zTrackbarEx(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 10, %YMIN_SIZE - 69, %XMIN_SIZE - 20, 14, %ID_TRACK_SEARCH, 0, 100, 0, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Search")

    IF Vista() THEN
       hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "AERO Crystal mode", 10, %YMIN_SIZE - 41, 130, 18, %ID_AEROCRYSTAL, SK_BTNTEXTCOLOR(), 0)
       CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
       CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
       CALL zSetZorder(hCtrl, %HWND_TOP)
       CALL zCreateToolTip(hCtrl, "Switch Skin display to CRYSTAL mode")

       hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "AERO Blur mode", 10, %YMIN_SIZE - 41 + 18, 130, 18, %ID_AEROBLUR, SK_BTNTEXTCOLOR(), 0)
       CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
       CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
       CALL zSetZorder(hCtrl, %HWND_TOP)
       CALL zCreateToolTip(hCtrl, "Switch Skin display to BLUR mode")
    END IF

    hCtrl = zTrackbarEx(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 436, %YMIN_SIZE - 36, 100, 11, %ID_TRACK_VOL, 1, 100, 50, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Change audio volume")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Mute_Off.png"), 409, %YMIN_SIZE - 43, %ID_MUTE_OFF, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Mute Off")
    CALL ShowWindow(hCtrl, %SW_HIDE)

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Mute_On.png"), 409, %YMIN_SIZE - 43, %ID_MUTE_ON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Mute On")


    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_BackL.png"), 307, %YMIN_SIZE - 37, %ID_BTN_BACKL, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Previous background")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_BackR.png"), 323, %YMIN_SIZE - 37, %ID_BTN_BACKR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Next background")

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(hMain, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(hMain, %ID_LED), %HWND_TOP)

    hCtrl = zStaticLabelEx(hMain, TIME$, 10, %YMIN_SIZE - 56, 54, 15, %ID_TIME, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL EnableWindow(hCtrl, %TRUE): CALL zCreateToolTip(hCtrl, "Current time")

    hCtrl = zStaticLabelEx(hMain, "", 64, %YMIN_SIZE - 56, 70, 15, %ID_SIZE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL EnableWindow(hCtrl, %TRUE): CALL zCreateToolTip(hCtrl, "True video size")

    hCtrl = zStaticLabelEx(hMain, "00:00:00", %XMIN_SIZE - 112, %YMIN_SIZE - 56, 54, 15, %ID_DURATION, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL EnableWindow(hCtrl, %TRUE): CALL zCreateToolTip(hCtrl, "Movie duration")

    hCtrl = zStaticLabelEx(hMain, "00:00:00", %XMIN_SIZE - 57, %YMIN_SIZE - 56, 54, 15, %ID_ELLAPSED, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL EnableWindow(hCtrl, %TRUE): CALL zCreateToolTip(hCtrl, "Movie ellapsed")

    hCtrl = zPushButton(hMain, (SK_FOLDER() + "BTN_About.png"), "", %XMIN_SIZE - 105, %YMIN_SIZE - 22, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Help.png"), 7, 4, %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

    hCtrl = zStaticLabelEx(hMain, "", 29, 22, 420, 15, %ID_TITLE, SK_INACTIVECAPTION(), %BS_LABEL_LEFT, 1)

    'LOCAL Alpha, Red, Green, Blue AS BYTE
    'CALL zSplitColorARGB(SK_INACTIVECAPTION(), Alpha, Red, Green, Blue)
    'hCtrl = zStaticLabelEx(hMain, $Version, 451, 22, 70, 15, %ID_VERSION, zColorARGB(32, RGB(Red, Green, Blue)), %BS_LABEL_RIGHT, 1)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)

    hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, hMain, %ID_Background, zsInstance(), BYVAL %NULL)
    CALL DetectBackground()

END SUB

SUB DetectMovieHD(BYREF lWidth AS LONG, BYREF lHeight AS LONG)
    IF lHeight > 1079 THEN
       lWidth = (1280 / 3) * 2: lHeight = (720 / 3) * 2
    END IF
    IF lWidth > 856 THEN
       lWidth = lWidth * .66: lHeight = lHeight * .66
    END IF
END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
    LOCAL rc AS RECT, lWidth, lHeight, xPos, yPos, xSize, ySize AS LONG
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)
    IF ChangeBackground THEN CALL zUpdateWindow(hWnd, 0)

    IF ISOBJECT(pIVideoWindow) THEN
       CALL GetClientRect(zGetMainItem(%ID_MOVIECONTAINER), rc)

'      // 04-14-08
'      // Make sure aspect ratio is preserved
       IF ISOBJECT(pIBasicVideo) THEN
          ' Detect HD movie
          lWidth = gmWidth: lHeight = gmHeight
          CALL DetectMovieHD(lWidth, lHeight)
          CALL zIconiseEx(lWidth, lHeight, rc.nRight, rc.nBottom, xPos, yPos, xSize, ySize, 1)
          rc.nLeft = rc.nLeft + xPos: rc.nTop = rc.nTop + yPos
          rc.nRight = xSize: rc.nBottom = ySize
       END IF

       pIVideoWindow.SetWindowPosition(rc.nLeft, rc.nTop, rc.nRight, rc.nBottom)
       IF ghVideoHandle THEN CALL zUpdateWindow(ghVideoHandle, 0)
    END IF

END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
    LOCAL sDataString AS STRING, hDC, dwData, hFound, ARGBcolor AS LONG
    LOCAL hList, nItem, Img AS LONG
    LOCAL szFileName AS ASCIIZ * %MAX_PATH
    LOCAL Alpha, Red, Green, Blue AS BYTE

    STATIC IsMoving, IsMaximized, nACTIVECAPTION, nINACTIVECAPTION AS LONG

    SELECT CASE LONG Msg
    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_DROPFILES '// Drag & drop
         LOCAL nFilesDropped AS LONG
         CALL SetForegroundWindow(hWnd)
         CALL zUpdateWindow(hWnd, %TRUE)
         nFilesDropped = DragQueryFile(wParam, -1, "", 0)
         szFileName = ""
         IF nFilesDropped > 0 THEN
            CALL DragQueryFile(wParam, 0, szFileName, %MAX_PATH)
            szFileName = LCASE$(szFileName)
         END IF
         CALL DragFinish(wParam)
         CALL CheckMovieName(szFileName)

    CASE %WM_COPYDATA
       ' wParam holds the string length
       ' lParam holds the Byte array address
         dwData = zGetPrivateMsg(sDataString, wParam, lParam)
         szFileName = ""
         IF dwData = %ZM_STRINGDATA THEN
            IF LEN(sDataString) THEN szFileName = LCASE$(PARSE$(sDataString, $zLim, 1))
         END IF
         CALL CheckMovieName(szFileName)
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LOWRD(wParam)

         CASE %ID_BTN_PLAY
              IF gbMoviePlaying THEN
                 CALL MoviePlay()
              ELSE
                 szFileName = LCASE$(FileOpen(hWnd))
                 IF LEN(szFileName) THEN CALL CheckMovieName(szFileName)
              END IF

         CASE %ID_BTN_PAUSE
              IF gbMoviePlaying THEN CALL MoviePause()

         CASE %ID_MUTE_OFF
              CALL ShowWindow(zGetMainItem(%ID_MUTE_OFF), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_MUTE_OFF), %HWND_BOTTOM)
              CALL ShowWindow(zGetMainItem(%ID_MUTE_ON), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_MUTE_ON), %HWND_TOP)
              gbMuteMode = 0
              IF ISOBJECT(pIBasicAudio) THEN
                 UseVolume& = MIN&(((100 - zGetTrackValue(zGetMainItem(%ID_TRACK_VOL))) * -50) + 1250, 0)
                 pIBasicAudio.Volume = UseVolume&
              END IF

         CASE %ID_MUTE_ON
              CALL ShowWindow(zGetMainItem(%ID_MUTE_ON), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_MUTE_ON), %HWND_BOTTOM)
              CALL ShowWindow(zGetMainItem(%ID_MUTE_OFF), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_MUTE_OFF), %HWND_TOP)
              gbMuteMode = -1
              IF ISOBJECT(pIBasicAudio) THEN
                 pIBasicAudio.Volume = -10000
              END IF

         CASE %ID_FULLSCREEN
              gbFullScreen = NOT gbFullScreen
              CALL zREMOVEBORDER(gbFullScreen, 1)
              IF gbFullScreen THEN
                 CALL zPAINTBACKCOLOR(zColorARGB(255, 0), 1)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_HELP), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_RESTORE), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_MAXIMIZE), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_CLOSE), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_MINIMIZE), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_LED), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_ABOUT), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)


                 CALL ShowWindow(zGetMainItem(%ID_AEROBUTTON), %SW_HIDE)

                 IF Vista() THEN
                    CALL ShowWindow(zGetMainItem(%ID_AEROCRYSTAL), %SW_HIDE)
                    CALL ShowWindow(zGetMainItem(%ID_AEROBLUR), %SW_HIDE)
                 END IF

                 CALL zSplitColorARGB(SK_BTNTEXTCOLOR(), Alpha, Red, Green, Blue)
                 ARGBcolor = zColorARGB(64, RGB(Red, Green, Blue))
                 CALL zSetImageProperty(zGetMainItem(%ID_TIME), %PROP_TEXT_COLOR, ARGBColor)
                 CALL zSetImageProperty(zGetMainItem(%ID_SIZE), %PROP_TEXT_COLOR, ARGBColor)
                 CALL zSetImageProperty(zGetMainItem(%ID_DURATION), %PROP_TEXT_COLOR, ARGBColor)
                 CALL zSetImageProperty(zGetMainItem(%ID_ELLAPSED), %PROP_TEXT_COLOR, ARGBColor)

                 nACTIVECAPTION  = SK_ACTIVECAPTION()
                 nINACTIVECAPTION = SK_INACTIVECAPTION()
                 CALL zSplitColorARGB(nACTIVECAPTION, Alpha, Red, Green, Blue)
                 gColorCaption = zColorARGB(16, RGB(Red, Green, Blue))
                 CALL zACTIVECAPTION(gColorCaption, %WRITE)
                 CALL zINACTIVECAPTION(gColorCaption, %WRITE)

                 IsMaximized = IsZoomed(hWnd)
                 IF IsMaximized = 0 THEN
                    CALL ShowWindow(hWnd, %SW_MAXIMIZE)
                 END IF
              ELSE
                 CALL ShowWindow(zGetMainItem(%ID_BTN_HELP), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_CLOSE), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_MINIMIZE), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_LED), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_ABOUT), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_SHOW)

                 CALL ShowWindow(zGetMainItem(%ID_AEROBUTTON), %SW_SHOW)

                 IF Vista() THEN
                    CALL ShowWindow(zGetMainItem(%ID_AEROCRYSTAL), %SW_SHOW)
                    CALL ShowWindow(zGetMainItem(%ID_AEROBLUR), %SW_SHOW)
                 END IF

                 CALL zSetImageProperty(zGetMainItem(%ID_TIME), %PROP_TEXT_COLOR, SK_BTNTEXTCOLOR())
                 CALL zSetImageProperty(zGetMainItem(%ID_SIZE), %PROP_TEXT_COLOR, SK_BTNTEXTCOLOR())
                 CALL zSetImageProperty(zGetMainItem(%ID_DURATION), %PROP_TEXT_COLOR, SK_BTNTEXTCOLOR())
                 CALL zSetImageProperty(zGetMainItem(%ID_ELLAPSED), %PROP_TEXT_COLOR, SK_BTNTEXTCOLOR())

                 CALL zACTIVECAPTION(nACTIVECAPTION, %WRITE)
                 CALL zINACTIVECAPTION(nINACTIVECAPTION, %WRITE)
                 gColorCaption = nACTIVECAPTION

                 IF IsMaximized THEN
                    CALL ShowWindow(zGetMainItem(%ID_RESTORE), %SW_SHOW)
                    CALL ShowWindow(zGetMainItem(%ID_MAXIMIZE), %SW_HIDE)
                 ELSE
                    CALL ShowWindow(hWnd, %SW_RESTORE)

                    CALL ShowWindow(zGetMainItem(%ID_MAXIMIZE), %SW_SHOW)
                    CALL ShowWindow(zGetMainItem(%ID_RESTORE), %SW_HIDE)
                 END IF
              END IF
              CALL zDrawBackground()
              CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), 0)
              CALL zUpdateWindow(hWnd, 0)
              IF ghVideoHandle THEN CALL zUpdateWindow(ghVideoHandle, 0)

         CASE %ID_SNAPSHOT
              '// Must Pause before using GetCurrentImage
              IF gbMoviePlaying THEN CALL MoviePause()
              szFileName = FileSave(hWnd)
              IF LEN(szFileName) THEN CALL TakeSnapShot(szFileName)
              IF gbMoviePlaying THEN CALL MoviePlay()

         CASE %ID_TRACK_SEARCH
              IF ISOBJECT(pIMediaPosition) THEN pIMediaPosition.CurrentPosition = lParam / 10

         CASE %ID_TRACK_VOL
              IF gbMuteMode = 0 THEN
                 UseVolume& = MIN&(((100 - lParam) * -50) + 1250, 0)
                 IF ISOBJECT(pIBasicAudio) THEN
                    pIBasicAudio.Volume = UseVolume&
                 END IF
              END IF

         CASE %ID_AEROCRYSTAL

              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
'//                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
'//                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(0, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_SHOW)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
              CALL zUpdateWindow(hWnd, 0)

         CASE %ID_AEROBLUR
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
'//                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(6, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
                 CALL zUSEVISTABLUR(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_SHOW)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
              CALL zUpdateWindow(hWnd, 0)

         CASE %ID_AERODISABLE
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE)) THEN
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%FALSE, %WRITE)
                 CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                 CALL zUpdateWindow(hWnd, 0)
              ELSE
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)
              END IF
'         CASE %ID_TRACK_OPACITY
'              IF SK_AEROEMULATE() THEN
'                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
'                 CALL zAEROCOLOR(zColorARGB(lParam, RGB(Red, Green, Blue)), %WRITE)
'                 CALL GetWindowRect(hWnd, rc)
'                 CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
'                 CALL zUpdateWindow(hWnd, 0)
'              END IF

         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_HELP
              sDataString = EXE.Path$ + "MovieBox.chm"
              IF ISFILE((sDataString)) THEN
                 hFound = FindWindow("HH Parent", "MovieBox")
                 IF hFound THEN
                    IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
                 ELSE
                    CALL ShellExecute(BYVAL 0, "open", (sDataString), "", "", %SW_SHOW)
                 END IF
              ELSE
                 Message$ = "                           " + $Version + _
                            "||         Copyright  " + RIGHT$(Date$, 4) + " Patrice TERRIER  " + _
                            "|                pterrier@zapsolution.com" + _
                            "||                   www.zapsolution.com"
                            REPLACE $zLim WITH $CR IN Message$
                 CALL MessageBox(0, (Message$), "MovieBox", %MB_OK)
              END IF

         CASE %ID_BTN_BACKL
              hList = zGetMainItem(%ID_Background)
              nItem = ListGetCursel(hList)
              IF nItem > 1 THEN
                 DECR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = ListCount(hList)
                 CALL ListSelectPlus(hList, nItem)
              END IF
              Img = zCreateImageFromFile((ListGetText(hList, nItem)))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (ListGetText(hList, nItem)), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)
              END IF

         CASE %ID_BTN_BACKR
              hList = zGetMainItem(%ID_Background)
              nItem = ListGetCursel(hList)
              IF nItem < ListCount(hList) THEN
                 INCR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = 1
                 CALL ListSelectPlus(hList, nItem)
              END IF
              Img = zCreateImageFromFile((ListGetText(hList, nItem)))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (ListGetText(hList, nItem)), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)
              END IF

         END SELECT

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG, p AS POINTAPI
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut, RedrawVideo AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            RedrawVideo = 0
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
               IF ghVideoHandle THEN RedrawVideo = -1
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)

            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            ' We must do that for XP, to force a complete redraw of the video section
            IF RedrawVideo THEN CALL zUpdateWindow(ghVideoHandle, 1)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
'        // If there is a movie playing then stop it
         CALL MovieClose()

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

'        //START AERO section ---------------------------------------------------------
         CASE %WM_TIMER
              IF zDwmIsCompositionEnabled() = 0 THEN
                 IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                    IF zIsLButtonDown() = 0 THEN IsMoving = 0
                    IF IsMoving = 0 OR (zIsLButtonDown() AND IsMoving) THEN
                       CALL GetWindowRect(hWnd, rc)
                       CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                       CALL zUpdateWindow(hWnd, 0)
                    END IF
                 END IF
              END IF

         CASE %WM_NCLBUTTONDOWN
              IsMoving = -1

         CASE %WM_MOVING
              IF zDwmIsCompositionEnabled() = 0 THEN
                 IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                    DIM rw AS RECT PTR
                    rw = lparam
                    CALL zMoveBackground(@rw.nLeft, @rw.nTop, 0)
                    CALL zUpdateWindow(hWnd, 0)
                    FUNCTION = 1: EXIT FUNCTION
                 END IF
              END IF
'        //END AERO section ---------------------------------------------------------

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

'------------------------------------------------------------------------------------------
' Movie section
'------------------------------------------------------------------------------------------

SUB CheckMovieName(zFileName AS ASCIIZ)
    IF LEN(zFileName) THEN
       LOCAL So AS LONG, sExt AS STRING
       So = INSTR(-1, zFileName, $Dot)
       IF So THEN
          sExt = LCASE$(MID$(zFileName, So))
          IF INSTR($MOVIEXT, sExt + $Dot) THEN
             CALL MoviePlayNewMedia(zFileName)
          END IF
       END IF
    END IF
END SUB

FUNCTION MovieToTime(BYVAL MovieLocation AS DOUBLE) AS STRING
    LOCAL HH, MM, SS AS LONG

    HH = MovieLocation \ 3600
    MM = (MovieLocation - HH * 3600) \ 60
    SS = MovieLocation - HH * 3600 - MM * 60

    L$ = ":"
    FUNCTION  = RIGHT$("00" + LTRIM$(STR$(HH)), 2) + L$ + _
                RIGHT$("00" + LTRIM$(STR$(MM)), 2) + L$ + _
                RIGHT$("00" + LTRIM$(STR$(SS)), 2)

END FUNCTION

'// We handle the movie container control messages there
FUNCTION MovieProc (BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

    SELECT CASE LONG Msg

    CASE %WM_TIMER
         LOCAL MovieLocation AS DOUBLE, tLocation AS LONG
         CALL zSetCTLText(zGetMainItem(%ID_TIME), TIME$)
         IF ISOBJECT(pIMediaPosition) THEN
            MovieLocation = pIMediaPosition.CurrentPosition

            IF gbMoviePlaying THEN
               IF MovieLocation >= gMovieDuration THEN CALL MovieClose()
            END IF

            IF gbMoviePlaying THEN
               tLocation = MovieLocation * 10
               CALL zSetCTLText(zGetMainItem(%ID_ELLAPSED), MovieToTime(MovieLocation))
               CALL zSetTrackValue(zGetMainItem(%ID_TRACK_SEARCH), tLocation)
            END IF

         END IF

    CASE %WM_DESTROY
         CALL KillTimer(hWnd, 1)

    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

'// Create a Movie container control
FUNCTION zMovieContainer (BYVAL hOwner AS LONG, _
                          BYVAL x AS LONG, BYVAL y AS LONG, BYVAL W AS LONG, BYVAL H AS LONG, BYVAL UseID AS LONG, _
                          BYVAL ARGB AS LONG) AS LONG
    LOCAL wc  AS WNDCLASSEXA
    LOCAL zClass AS ASCIIZ * 16
    LOCAL hCtrl, IsInitialized, dwStyle AS LONG

    zClass = "ZMOVIECONTAINER"
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance, zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS OR %CS_PARENTDC
       wc.lpfnWndProc   = CODEPTR(MovieProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance
       wc.hIcon         = %NULL ' LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL ' Don't paint the class window background
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
       dwStyle = %WS_CHILD OR %WS_VISIBLE
       hCtrl = CreateWindowEx(0, zClass, "", dwStyle, x, y, W, H, hOwner, UseID, zsInstance, BYVAL %NULL)
       CALL zSetImageProperty(hCtrl, %PROP_STYLE, %FILLRECTANGLE)
       CALL zSetImageProperty(hCtrl, %PROP_COLOR, ARGB)
       CALL SetTimer(hCtrl, 1, 1000, %NULL)
       CALL zSetZorder(hCtrl, %HWND_BOTTOM)
       ' Enable drag background to force XP to redraw the whole video window
       CALL zDRAG_BACKGROUND(1, 1)
       FUNCTION = hCtrl
    END IF
END FUNCTION

SUB MovieClose()
    IF ISOBJECT(pIMediaControl) THEN
       pIMediaControl.Stop
       pIMediaControl = NOTHING
    END IF
    IF ISOBJECT(pIVideoWindow) THEN
       pIVideoWindow.Visible = %OAFALSE
       pIVideoWindow.Owner = %NULL
       pIVideoWindow = NOTHING
    END IF
    pIMediaEventEx = NOTHING
    pIGraphBuilder = NOTHING
    pIBasicVideo = NOTHING
    pIBasicAudio = NOTHING
    pIMediaPosition = NOTHING
    CALL zSetCTLText(zGetMainItem(%ID_DURATION), "00:00:00")
    CALL zSetCTLText(zGetMainItem(%ID_ELLAPSED), "00:00:00")
    CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_BOTTOM)
    CALL ShowWindow(zGetMainItem(%ID_BTN_PLAY), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_BTN_PLAY), %HWND_TOP)
    CALL zSetCTLText(zGetMainItem(%ID_TITLE), "")
    CALL zSetCTLText(zGetMainItem(%ID_SIZE), "")

    gbMoviePlaying = 0

    CALL zSetTrackValue(zGetMainItem(%ID_TRACK_SEARCH), 0)

END SUB

SUB MoviePlay()
    CALL ShowWindow(zGetMainItem(%ID_BTN_PLAY), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PLAY), %HWND_BOTTOM)
    CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_TOP)
    pIMediaControl.Run
    gbMoviePlaying = -1
END SUB

SUB MoviePause()
    CALL ShowWindow(zGetMainItem(%ID_BTN_PAUSE), %SW_HIDE): CALL zSetZorder(zGetMainItem(%ID_BTN_PAUSE), %HWND_BOTTOM)
    CALL ShowWindow(zGetMainItem(%ID_BTN_PLAY), %SW_SHOW): CALL zSetZorder(zGetMainItem(%ID_BTN_PLAY), %HWND_TOP)
    pIMediaControl.Pause
END SUB

FUNCTION DetectVideoHandle(BYVAL hWnd AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL sVideoCaption AS STRING, nRet AS LONG
    IF zGetCTLText(hWnd) = LTRIM$(STR$(zMainWindow(0))) THEN
       ghVideoHandle = hWnd
       nRet = %FALSE
    ELSE
       nRet = %TRUE
    END IF
    FUNCTION = nRet
END FUNCTION

SUB MoviePlayNewMedia(zThisMovie AS ASCIIZ)

    LOCAL swMovieName, sVideoCaption AS STRING, hParent, nRetLNG, x, y, lWidth, lHeight, InZoomMode AS LONG

    '// I must check it there,
    '// because IsZoomed is not reliable when used after calling the IVideoWindowInterface.
    InZoomMode = IsZoomed(zMainWindow(0))

    hParent = zGetMainItem(%ID_MOVIECONTAINER)
    swMovieName = UCODE$(zThisMovie)

    ' If there is a movie playing then stop it
    CALL MovieClose()
    ' Create an instance of the IGraphBuilder object
    pIGraphBuilder = NEWCOM CLSID $CLSID_FilgraphManager
    IF ISNOTHING(pIGraphBuilder) THEN EXIT SUB

    ' Retrieve interface pointers
    pIMediaControl = pIGraphBuilder:  IF ISNOTHING(pIMediaControl) THEN EXIT SUB
    pIMediaEventEx = pIGraphBuilder:  IF ISNOTHING(pIMediaEventEx) THEN EXIT SUB
    pIVideoWindow = pIGraphBuilder:   IF ISNOTHING(pIVideoWindow) THEN EXIT SUB
    pIBasicVideo = pIGraphBuilder:    IF ISNOTHING(pIBasicVideo) THEN EXIT SUB
    pIBasicAudio = pIGraphBuilder:    IF ISNOTHING(pIBasicAudio) THEN EXIT SUB
    pIMediaPosition = pIGraphBuilder: IF ISNOTHING(pIMediaPosition) THEN EXIT SUB

    ' Render the file
    IF pIGraphBuilder.RenderFile(STRPTR(swMovieName), %NULL) = 0 THEN

       ' Set the window owner and style
       pIVideoWindow.Owner = hParent
       pIVideoWindow.WindowStyle = %WS_CHILD' OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN)
       sVideoCaption = UCODE$(LTRIM$(STR$(zMainWindow(0))))
       pIVideoWindow.Caption = sVideoCaption
       CALL EnumChildWindows(hParent, CODEPTR(DetectVideoHandle), 0)

       ' Retrieve the real video size
       pIBasicVideo.GetVideoSize(lWidth, lHeight)
       gmWidth = lWidth: gmHeight = lHeight
       ' Detect HD movie
       CALL DetectMovieHD(lWidth, lHeight)

       CALL zSetCTLText(zGetMainItem(%ID_SIZE), (LTRIM$(STR$(gmWidth)) + " x" + STR$(gmHeight)))

       ' Adjust the main window to match the movie size
       LOCAL rc, rw AS RECT, UseW, UseH, DeltaX, DeltaY, So AS LONG
       LOCAL Aspect AS SINGLE, sMovieName AS STRING

       UseW = lWidth: UseH = lHeight
       IF UseW < gnContainerW THEN Aspect = gnContainerW / UseW: UseW = UseW * Aspect: UseH = UseH * Aspect
       IF UseH < gnContainerH THEN Aspect = gnContainerH / UseH: UseW = UseW * Aspect: UseH = UseH * Aspect

       CALL GetClientRect(hParent, rc)
       IF InZoomMode THEN
          UseW = rc.nRight: UseH = rc.nBottom
       ELSE
          DeltaX = rc.nRight - UseW
          DeltaY = rc.nBottom - UseH
          CALL GetWindowRect(zMainWindow(0), rw)

'//          x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - (rw.nRight - rw.nLeft - DeltaX)) \ 2, 0)
'//          y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - (rw.nBottom - rw.nTop - DeltaY)) \ 2, 0)
          x = rw.nLeft: y = rw.nTop
          IF x + rw.nRight - rw.nLeft - DeltaX > GetSystemMetrics(%SM_CXSCREEN) THEN
             x = GetSystemMetrics(%SM_CXSCREEN) - (rw.nRight - rw.nLeft - DeltaX)
          END IF
          IF y + rw.nBottom - rw.nTop - DeltaY > GetSystemMetrics(%SM_CYSCREEN) THEN
             y = GetSystemMetrics(%SM_CYSCREEN) - (rw.nBottom - rw.nTop - DeltaY)
          END IF

          CALL MoveWindow(zMainWindow(0), x, y, rw.nRight - rw.nLeft - DeltaX, rw.nBottom - rw.nTop - DeltaY, %TRUE)
          CALL zUpdateWindow(zMainWindow(0), 0)
       END IF
       ' Resize the DirectX window
       'CALL IVideoWindow_SetWindowPosition(pIVideoWindow, 0, 0, UseW, UseH)
       'pIVideoWindow.SetWindowPosition(0, 0, UseW, UseH)
       CALL MoveWindow(ghVideoHandle, 0, 0, UseW, UseH, 0)

       ' Setup the video Audio level
       IF gbMuteMode THEN
          IF ISOBJECT(pIBasicAudio) THEN pIBasicAudio.Volume = -10000
       ELSE
          UseVolume& = MIN&(((100 - zGetTrackValue(zGetMainItem(%ID_TRACK_VOL))) * -50) + 1250, 0)
          IF ISOBJECT(pIBasicAudio) THEN pIBasicAudio.Volume = UseVolume&
       END IF

       LOCAL tMax AS LONG
       gMovieDuration = pIMediaPosition.Duration
       tMax = gMovieDuration * 10
       CALL zSetCTLText(zGetMainItem(%ID_DURATION), MovieToTime(gMovieDuration))
       CALL zSetTrackMinMax(zGetMainItem(%ID_TRACK_SEARCH), 0, tMax)
       CALL zSetTrackValue(zGetMainItem(%ID_TRACK_SEARCH), 0)

       sMovieName = PATHNAME$(NAME, zThisMovie)
       sMovieName = UCASE$(LEFT$(sMovieName, 1)) + MID$(sMovieName, 2)
       CALL zSetCTLText(zGetMainItem(%ID_TITLE), (sMovieName))

       pIVideoWindow.Visible = %OATRUE
       IF ghVideoHandle THEN CALL zUpdateWindow(ghVideoHandle, 0)

       ' Run the movie
       CALL MoviePlay()

    END IF

END SUB

%PixelFormatGDI         = &h00020000 ' Is a GDI-supported format
%PixelFormatAlpha       = &h00040000 ' Has an alpha component
%PixelFormatCanonical   = &h00200000
%SHIFT_LEFT_32_8 = 8192
%PixelFormat32bppARGB       = 10 OR %SHIFT_LEFT_32_8 OR %PixelFormatAlpha OR %PixelFormatGDI OR %PixelFormatCanonical

TYPE MYGUIDAPI
    Data1 AS DWORD
    Data2 AS WORD
    Data3 AS WORD
    Data4(0 to 7) AS BYTE ' Patrice
END TYPE

TYPE ImageCodecInfo
    ClassID AS MYGUIDAPI
    FormatID AS MYGUIDAPI
    CodecName AS LONG         ' String Pointer; const WCHAR*
    DllName AS LONG           ' String Pointer; const WCHAR*
    FormatDescription AS LONG ' String Pointer; const WCHAR*
    FilenameExtension AS LONG ' String Pointer; const WCHAR*
    MimeType AS LONG          ' String Pointer; const WCHAR*
    flags AS LONG
    Version AS LONG
    SigCount AS LONG
    SigSize AS LONG
    SigPattern AS LONG        ' Byte Array Pointer; BYTE*
    SigMask AS LONG           ' Byte Array Pointer; BYTE*
END TYPE

DECLARE FUNCTION GdipCreateBitmapFromScan0 LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromScan0" (BYVAL nWidth&, BYVAL Height&, BYVAL stride&, BYVAL PixelFormat&, scan0 AS ANY, nBitmap&) AS LONG
DECLARE FUNCTION GdipSaveImageToFile LIB "gdiplus.dll" ALIAS "GdipSaveImageToFile" (BYVAL nImage&, zFilName AS ASCIIZ, clsidEncoder AS MYGUIDAPI, encoderParams AS ANY) AS LONG
DECLARE FUNCTION GdipGetImageEncoders LIB "gdiplus.dll" ALIAS "GdipGetImageEncoders" (BYVAL numEncoders&, BYVAL SIZE&, encoders AS ANY) AS LONG
DECLARE FUNCTION GdipGetImageEncodersSize LIB "gdiplus.dll" ALIAS "GdipGetImageEncodersSize" (numEncoders&, SIZE&) AS LONG
DECLARE FUNCTION GdipImageRotateFlip LIB "gdiplus.dll" ALIAS "GdipImageRotateFlip" (BYVAL nImage&, BYVAL rfType&) AS LONG

FUNCTION PtrToStrW(BYVAL lpsz&) AS STRING
    DIM sOut AS STRING
    DIM lLen AS LONG
  ' Patrice
  ' Warning, use: lLen = lstrlenW(lpsz) instead
  ' if DECLARE FUNCTION lstrlenw LIB "KERNEL32.DLL" ALIAS "lstrlenW" (BYVAL lpString AS ANY) AS LONG
    lLen = lstrlenW(BYVAL lpsz&)
    IF lLen THEN
       sOut = UCODE$(STRING$(lLen, 0))
       CALL MoveMemory(BYVAL STRPTR(sOut), BYVAL lpsz&, lLen * 2)
       FUNCTION = ACODE$(sOut)
    END IF
END FUNCTION

FUNCTION GetEncoderClsid(strMimeType AS STRING, ClassID AS MYGUIDAPI) AS LONG
    DIM num AS LONG, Size AS LONG, I AS LONG
    DIM ICI() AS ImageCodecInfo
    DIM buffer() AS BYTE
  ' Get the encoder array size
    CALL GdipGetImageEncodersSize(num, Size)
    IF Size THEN
     ' Allocate room for the arrays dynamically
       REDIM ICI(1 TO num) AS ImageCodecInfo
       REDIM buffer(1 TO Size) AS BYTE
     ' Get the array and string data
       CALL GdipGetImageEncoders(num, Size, buffer(1))
     ' Copy the class headers
       CALL MoveMemory(BYVAL VARPTR (ICI(1)), buffer(1), (LEN(ICI(1)) * num))
     ' Loop through all the codecs
       FOR I = 1 TO num
         ' Must convert the pointer into a usable string
           IF PtrToStrW(ICI(I).MimeType) = strMimeType THEN
              ClassID = ICI(I).ClassID   ' Save the class id
              FUNCTION = I               ' return the index number for success
              EXIT FOR
           END IF
       NEXT
     ' Free the memory
       ERASE ICI(), buffer()
    ELSE
       FUNCTION = -1 ' Failure flag
    END IF
END FUNCTION

FUNCTION SaveImageToFile(zFullName AS ASCIIZ, BYVAL Img AS LONG, BYVAL nQuality AS LONG) AS LONG
    LOCAL encoderCLSID AS MYGUIDAPI, sGetType, sPicFile AS STRING
    LOCAL So, ImageType AS LONG

    sPicFile = zFullName
    So = INSTR(-1, sPicFile, $Dot)
    IF So THEN
       ImageType = INSTR(".BMP.JPG.TIF.", UCASE$(MID$(sPicFile, So)) + $Dot)
       IF ImageType THEN
          sGetType = PARSE$("bmp,jpeg,tiff", (ImageType \ 4) + 1)
          IF LEN(sGetType) THEN
             sGetType = "image/" + sGetType
             CALL GetEncoderClsid(sGetType, encoderCLSID)
             ErrCode& = GdipSaveImageToFile(Img, (UCODE$(sPicFile)), encoderCLSID, BYVAL 0)
             FUNCTION = ErrCode&
          END IF
       END IF
    END IF
END FUNCTION

SUB TakeSnapShot(szFileName AS ASCIIZ)
    LOCAL nBufSize, imgData, nWidth, nHeight, Img, NewImg, nHeaderSize AS LONG

    pIBasicVideo.GetVideoSize(nWidth, nHeight)
    nHeaderSize = SIZEOF(BITMAPINFOHEADER) '// 40-bytes
    nBufSize = nWidth * nHeight * 4 + nHeaderSize

    IF nBufSize > nHeaderSize THEN
       REDIM PixelArray(nBufSize - 1) AS BYTE
       imgData = VARPTR(PixelArray(0))

       pIBasicVideo.GetCurrentImage(BYVAL VARPTR(nBufSize), BYVAL imgData)

       IF GdipCreateBitmapFromScan0(nWidth, nHeight, nWidth * 4, %PixelFormat32bppARGB, BYVAL VARPTR(PixelArray(nHeaderSize)), Img) = 0 THEN
          IF Img THEN
             CALL GdipImageRotateFlip(img, 6) ' // Flip verticaly
             CALL SaveImageToFile(szFileName, Img, 0)
             CALL GdipDisposeImage(Img)
          END IF
       END IF

       ERASE PixelArray()
    END IF
END SUB

'SUB TakeSnapShot(szFileName AS ASCIIZ)
'    LOCAL nBufSize, imgData, hFile, nWritten, nWidth, nHeight AS LONG
'    LOCAL bfh AS BITMAPFILEHEADER
'    LOCAL bih AS BITMAPINFOHEADER
'
'    nWidth  = pIBasicVideo.VideoWidth
'    nHeight = pIBasicVideo.VideoHeight
'    'nBufSize = nWidth * nHeight * 4
'
'    pIBasicVideo.GetCurrentImage(BYVAL VARPTR(nBufSize), BYVAL %NULL)
'    IF nBufSize THEN
'       REDIM PixelArray(nBufSize - 1) AS BYTE
'       imgData = VARPTR(PixelArray(0))
'
'       pIBasicVideo.GetCurrentImage(BYVAL VARPTR(nBufSize), BYVAL imgData)
'
'       '// save DIB file as Bitmap.
'       bfh.bfType = CVI("BM")
'       bfh.bfOffBits = SIZEOF(BITMAPINFOHEADER) + SIZEOF(BITMAPFILEHEADER)
'       bfh.bfSize = bfh.bfOffBits + nBufSize
'
'       bih.biSize   = SIZEOF(bih)
'       bih.biWidth  = nWidth
'       bih.biHeight = nHeight
'       bih.biPlanes = 1
'       bih.biBitCount = 32
'
'       IF zsFOpen(szFileName, 1, 0, hFile) = 0 THEN
'          CALL WriteFile(hFile, BYVAL VARPTR(bfh), SIZEOF(bfh), nWritten, BYVAL %NULL)
'          CALL WriteFile(hFile, BYVAL VARPTR(bih), SIZEOF(bih), nWritten, BYVAL %NULL)
'          CALL WriteFile(hFile, BYVAL imgData, nBufSize, nWritten, BYVAL %NULL)
'          CALL zsFClose(hFile)
'       END IF
'
'    END IF
'END SUB
