' ########################################################################################
' Library name: QuartzTypeLib
' Version: 1.0
' Documentation string: ActiveMovie control type library
' Path: C:\WINDOWS\system32\quartz.dll
' Library GUID: {56A868B0-0AD4-11CE-B03A-0020AF0BA770}
' ########################################################################################

#IF NOT %DEF(%CONTROL_INC)
    %CONTROL_INC = 1

' ########################################################################################
' Translation of strmif.h
' Desc: Streams interfaces
' Copyright (C) Microsoft Corporation, 1999-2002.
' ########################################################################################

#IF NOT %DEF(%STRMIF_INC)
    %STRMIF_INC = 1

'/* header files for imported files */
'//+-------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//--------------------------------------------------------------------------

#IF NOT %DEF(%UNKNWN_INC)
    %UNKNWN_INC = 1

'/* header files for imported files */
'//+-------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//--------------------------------------------------------------------------

#IF NOT %DEF(%WTYPES_INC)
    %WTYPES_INC = 1

#IF NOT %DEF(%GUIDDEF_INC)
    %GUIDDEF_INC = 1

#IF NOT %DEF(%IID_DEFINED) '--------------------------------------------------

$GUID_NULL = GUID$("{00000000-0000-0000-0000-000000000000}")

$IID_NULL = $GUID_NULL
$CLSID_NULL = $GUID_NULL
$FMTID_NULL = $GUID_NULL

#ENDIF ' #IF NOT %DEF(%IID_DEFINED) ------------------------------------------

#ENDIF   ' #IF NOT %DEF(%GUIDDEF_INC)


TYPE RECTL
   nLeft   AS LONG   ' LONG left
   nTop    AS LONG   ' LONG top
   nRight  AS LONG   ' LONG right
   nBottom AS LONG   ' LONG bottom
END TYPE

TYPE tagRECTL
   Left   AS LONG
   Top    AS LONG
   Right  AS LONG
   Bottom AS LONG
END TYPE

TYPE POINTAPI
   x AS LONG   ' LONG x
   y AS LONG   ' LONG y
END TYPE

TYPE POINTL
   x AS LONG   ' LONG x
   y AS LONG   ' LONG y
END TYPE

TYPE APISIZE
   cx AS LONG   ' LONG cx
   cy AS LONG   ' LONG cy
END TYPE

TYPE SIZEL
   cx AS LONG   ' LONG x
   cy AS LONG   ' LONG y
END TYPE

TYPE PALETTEENTRY
   peRed   AS BYTE   ' BYTE peRed
   peGreen AS BYTE   ' BYTE peGreen
   peBlue  AS BYTE   ' BYTE peBlue
   peFlags AS BYTE   ' BYTE peFlags
END TYPE

TYPE RECT
   nLeft   AS LONG   ' LONG left
   nTop    AS LONG   ' LONG top
   nRight  AS LONG   ' LONG right
   nBottom AS LONG   ' LONG bottom
END TYPE

TYPE LARGE_INTEGER
   LowPart  AS DWORD
   HighPart AS LONG
END TYPE

TYPE ULARGE_INTEGER
   LowPart  AS DWORD
   HighPart AS DWORD
END TYPE

#IF NOT %DEF(%FILETIME_DEFINED)
%FILETIME_DEFINED = 1
TYPE FILETIME
   dwLowDateTime  AS DWORD   ' DWORD dwLowDateTime
   dwHighDateTime AS DWORD   ' DWORD dwHighDateTime
END TYPE
#ENDIF

#IF NOT %DEF(%SYSTEMTIME_DEFINED)
%SYSTEMTIME_DEFINED = 1
TYPE SYSTEMTIME
   wYear         AS WORD   ' WORD wYear
   wMonth        AS WORD   ' WORD wMonth
   wDayOfWeek    AS WORD   ' WORD wDayOfWeek
   wDay          AS WORD   ' WORD wDay
   wHour         AS WORD   ' WORD wHour
   wMinute       AS WORD   ' WORD wMinute
   wSecond       AS WORD   ' WORD wSeconf
   wMilliseconds AS WORD   ' WORD wMilliseconds
END TYPE
#ENDIF

#IF NOT %DEF(%SECURITY_ATTRIBUTES_DEFINED)
%SECURITY_ATTRIBUTES_DEFINED = 1
TYPE SECURITY_ATTRIBUTES
   nLength              AS DWORD   ' DWORD nLength
   lpSecurityDescriptor AS DWORD   ' LPVOID lpSecurityDescriptor
   bInheritHandle       AS LONG    ' BOOL bInheritHandle
END TYPE
#ENDIF

#IF NOT %DEF(%ACL_DEFINED)
%ACL_DEFINED = 1
TYPE ACL
   AclRevision AS BYTE   ' UCHAR AclRevision
   Sbz1        AS BYTE   ' UCHAR Sbz1
   AclSize     AS WORD   ' USHORT AclSize
   AceCount    AS WORD   ' USHORT AceCount
   Sbz2        AS WORD   ' USHORT Sbz2
END TYPE
#ENDIF

'#endif //_WINBASE_

TYPE COAUTHIDENTITY
   pUser          AS DWORD   ' /* [size_is] */ USHORT *User
   UserLength     AS DWORD   ' /* [range] */ ULONG UserLength
   Domain         AS DWORD   ' /* [size_is] */ USHORT *Domain
   DomainLength   AS DWORD   ' /* [range] */ ULONG DomainLength
   Password       AS DWORD   ' /* [size_is] */ USHORT *Password
   PasswordLength AS DWORD   ' /* [range] */ ULONG PasswordLength
   Flags          AS DWORD   ' ULONG Flags
END TYPE

TYPE COAUTHINFO
   dwAuthnSvc           AS DWORD                ' DWORD  dwAuthnSvc
   dwAuthzSvc           AS DWORD                ' DWORD  dwAuthzSvc
   pwszServerPrincName  AS WORD PTR             ' LPWSTR pwszServerPrincName
   dwAuthnLevel         AS DWORD                ' DWORD  dwAuthnLevel
   dwImpersonationLevel AS DWORD                ' DWORD  dwImpersonationLevel
   pAuthIdentityData    AS COAUTHIDENTITY PTR   ' COAUTHIDENTITY *pAuthIdentityData
   dwCapabilities       AS DWORD                ' DWORD dwCapabilities
END TYPE

#IF NOT %DEF(%OBJECTID_DEFINED)
%OBJECTID_DEFINED = 1
TYPE OBJECTID
   Lineage    AS GUID    ' GUID Lineage
   Uniquifier AS DWORD   ' unsigned long Uniquifier
END TYPE
#ENDIF

' MEMCTX enum
%MEMCTX_TASK      = 1
%MEMCTX_SHARED    = 2
%MEMCTX_MACSYSTEM = 3
%MEMCTX_UNKNOWN   = -1
%MEMCTX_SAME      = -2

#IF NOT %DEF(%ROTFLAGS_DEFINED)
%ROTFLAGS_DEFINED = 1
%ROTFLAGS_REGISTRATIONKEEPSALIVE = &H1
%ROTFLAGS_ALLOWANYCLIENT = &H2
#ENDIF

#IF NOT %DEF(%ROTREGFLAGS_DEFINED)
%ROTREGFLAGS_DEFINED = 1
%ROTREGFLAGS_ALLOWANYCLIENT = &H1
#ENDIF

#IF NOT %DEF(%ROT_COMPARE_MAX_DEFINED)
%ROT_COMPARE_MAX_DEFINED = 1
%ROT_COMPARE_MAX = 2048
#ENDIF

#IF NOT %DEF(%DCOMSCM_REMOTECALL_FLAGS_DEFINED)
%DCOMSCM_REMOTECALL_FLAGS_DEFINED = 1
%DCOMSCM_ACTIVATION_USE_ALL_AUTHNSERVICES = &H1
%DCOMSCM_ACTIVATION_DISALLOW_UNSECURE_CALL = &H2
%DCOMSCM_RESOLVE_USE_ALL_AUTHNSERVICES = &H4
%DCOMSCM_RESOLVE_DISALLOW_UNSECURE_CALL = &H8
%DCOMSCM_PING_USE_MID_AUTHNSERVICE = &H10
%DCOMSCM_PING_DISALLOW_UNSECURE_CALL = &H20
#ENDIF

' CLSCTX enum
%CLSCTX_INPROC_SERVER          = &H1???      ' Component is allowed in the same process space.
                                             ' Requires that the component be implemented as a DLL
%CLSCTX_INPROC_HANDLER         = &H2???      ' Part is in-proc and the rest local or remote
%CLSCTX_LOCAL_SERVER           = &H4???      ' Different process, same machine
%CLSCTX_INPROC_SERVER16        = &H8???
%CLSCTX_REMOTE_SERVER          = &H10???     ' Components may reside on remote computers (DCOM)
%CLSCTX_INPROC_HANDLER16       = &H20???
%CLSCTX_RESERVED1              = &H40???
%CLSCTX_RESERVED2              = &H80???
%CLSCTX_RESERVED3              = &H100???
%CLSCTX_RESERVED4              = &H200???
%CLSCTX_NO_CODE_DOWNLOAD       = &H400???
%CLSCTX_RESERVED5              = &H800???
%CLSCTX_NO_CUSTOM_MARSHAL      = &H1000???
%CLSCTX_ENABLE_CODE_DOWNLOAD   = &H2000???
%CLSCTX_NO_FAILURE_LOG         = &H4000???
%CLSCTX_DISABLE_AAA            = &H8000???
%CLSCTX_ENABLE_AAA             = &H10000???
%CLSCTX_FROM_DEFAULT_CONTEXT   = &H20000???
%CLSCTX_ACTIVATE_32_BIT_SERVER = &H40000???
%CLSCTX_ACTIVATE_64_BIT_SERVER = &H80000???
%CLSCTX_ENABLE_CLOAKING        = &H100000???
%CLSCTX_PS_DLL                 = &H80000000???

%CLSCTX_VALID_MASK = _
   %CLSCTX_INPROC_SERVER OR _
   %CLSCTX_INPROC_HANDLER OR _
   %CLSCTX_LOCAL_SERVER OR _
   %CLSCTX_INPROC_SERVER16 OR _
   %CLSCTX_REMOTE_SERVER OR _
   %CLSCTX_NO_CODE_DOWNLOAD OR _
   %CLSCTX_NO_CUSTOM_MARSHAL OR _
   %CLSCTX_ENABLE_CODE_DOWNLOAD OR _
   %CLSCTX_NO_FAILURE_LOG OR _
   %CLSCTX_DISABLE_AAA OR _
   %CLSCTX_ENABLE_AAA OR _
   %CLSCTX_FROM_DEFAULT_CONTEXT OR _
   %CLSCTX_ACTIVATE_32_BIT_SERVER OR _
   %CLSCTX_ACTIVATE_64_BIT_SERVER OR _
   %CLSCTX_ENABLE_CLOAKING OR _
   %CLSCTX_PS_DLL

' MSHLFLAGS enum
%MSHLFLAGS_NORMAL      = 0
%MSHLFLAGS_TABLESTRONG = 1
%MSHLFLAGS_TABLEWEAK   = 2
%MSHLFLAGS_NOPING      = 4
%MSHLFLAGS_RESERVED1   = 8
%MSHLFLAGS_RESERVED2   = 16
%MSHLFLAGS_RESERVED3   = 32
%MSHLFLAGS_RESERVED4   = 64

' MSHCTX enum
%MSHCTX_LOCAL            = 0
%MSHCTX_NOSHAREDMEM      = 1
%MSHCTX_DIFFERENTMACHINE = 2
%MSHCTX_INPROC           = 3
%MSHCTX_CROSSCTX         = 4

' DVASPECT enum
%DVASPECT_CONTENT   = 1
%DVASPECT_THUMBNAIL = 2
%DVASPECT_ICON      = 4
%DVASPECT_DOCPRINT  = 8

' STGC enum
%STGC_DEFAULT                            = 0
%STGC_OVERWRITE                          = 1
%STGC_ONLYIFCURRENT                      = 2
%STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE = 4
%STGC_CONSOLIDATE                        = 8

' STGMOVE enum
%STGMOVE_MOVE        = 0
%STGMOVE_COPY        = 1
%STGMOVE_SHALLOWCOPY = 2

' STATFLAG enum
%STATFLAG_DEFAULT = 0
%STATFLAG_NONAME  = 1
%STATFLAG_NOOPEN  = 2

TYPE BYTE_BLOB
   cbSize AS DWORD      ' unsigned long clSize
   abData(0) AS BYTE    ' /* [size_is] */ byte abData[ 1 ]
END TYPE

TYPE WORD_BLOB
   cbSize AS DWORD      ' unsigned long clSize
   asData(0) AS WORD    ' /* [size_is] */ unsigned short asData[ 1 ]
END TYPE

TYPE DWORD_BLOB
   cbSize AS DWORD       ' unsigned long clSize
   alData(0) AS DWORD    ' /* [size_is] */ unsigned long alData[ 1 ]
END TYPE

TYPE FLAGGED_BYTE_BLOB
   fFlags AS DWORD      ' unsigned long fFlags
   clSize AS DWORD      ' unsigned long clSize
   abData(0) AS BYTE    ' /* [size_is] */ byte abData[ 1 ]
END TYPE

TYPE FLAGGED_WORD_BLOB
   fFlags AS DWORD      ' unsigned long fFlags
   clSize AS DWORD      ' unsigned long clSize
   asData(0) AS WORD    ' /* [size_is] */ unsigned short asData[ 1 ]
END TYPE

TYPE BYTE_SIZEDARR
   clSize AS DWORD      ' unsigned long
   pData AS BYTE PTR    ' byte *
END TYPE

TYPE SHORT_SIZEDARR
   clSize AS DWORD      ' unsigned long
   pData AS WORD PTR    ' unsigned short *
END TYPE

MACRO WORD_SIZEDARR = SHORT_SIZEDARR

TYPE LONG_SIZEDARR
   clSize AS DWORD      ' unsigned long
   pData AS DWORD PTR   ' unsigned long *
END TYPE

MACRO DWORD_SIZEDARR = LONG_SIZEDARR

TYPE HYPER_SIZEDARR
   clSize AS DWORD      ' unsigned long
   pData AS QUAD PTR    ' hyper *
END TYPE

%WDT_INPROC_CALL   = &H48746457???
%WDT_REMOTE_CALL   = &H52746457???
%WDT_INPROC64_CALL = &H50746457???

#IF NOT %DEF(%TEXTMETRICW_DEFINED)
%TEXTMETRICW_DEFINED = 1
TYPE TEXTMETRICW
   tmHeight           AS LONG   ' LONG tmHeight
   tmAscent           AS LONG   ' LONG tmAscent
   tmDescent          AS LONG   ' LONG tmDescent
   tmInternalLeading  AS LONG   ' LONG tmInternalLeading
   tmExternalLeading  AS LONG   ' LONG tmExternalLeading
   tmAveCharWidth     AS LONG   ' LONG tmAveCharWidth
   tmMaxCharWidth     AS LONG   ' LONG tmMaxCharWidth
   tmWeight           AS LONG   ' LONG tmWeight
   tmOverhang         AS LONG   ' LONG tmOverhang
   tmDigitizedAspectX AS LONG   ' LONG tmDigitizedAspectX
   tmDigitizedAspectY AS LONG   ' LONG tmDigitizedAspectY
   tmFirstChar        AS WORD   ' WCHAR tmFirstChar
   tmLastChar         AS WORD   ' WCHAR tmLastChar
   tmDefaultChar      AS WORD   ' WCHAR tmDefaultChar
   tmBreakChar        AS WORD   ' WCHAR tmBreakChar
   tmItalic           AS BYTE   ' BYTE tmItalic
   tmUnderlined       AS BYTE   ' BYTE tmUnderlined
   tmStruckOut        AS BYTE   ' BYTE tmStruckOut
   tmPitchAndFamily   AS BYTE   ' BYTE tmPitchAndFamily
   tmCharSet          AS BYTE   ' BYTE tmCharSet
END TYPE
#ENDIF

#IF NOT %DEF(%MSG_DEFINED)
%MSG_DEFINED = 1
TYPE tagMSG
   hwnd    AS DWORD      ' HWND hwnd
   message AS DWORD      ' UINT message
   wParam  AS DWORD      ' WPARAM wParam
   lParam  AS LONG       ' LPARAM lParam
   time    AS DWORD      ' DWORD time
   pt      AS POINTAPI   ' POINT pt
END TYPE
#ENDIF

#IF NOT %DEF(%DECIMAL_DEFINED)
    %DECIMAL_DEFINED = 1

TYPE DECIMAL
   wReserved AS WORD
   scale     AS BYTE    ' // The number of decimal places for the number.
                        ' // Valid values are from 0 to 28. So 12.345 is represented
                        ' // as 12345 with a scale of 3.
   sign      AS BYTE    ' // 0 for positive numbers or %DECIMAL_NEG (&H80) for
                        ' // negative numbers. So -1 is represented as
                        ' // 1 with the %DECIMAL_NEG bit set.
   Hi32      AS DWORD   ' // The high 32 bits of your number
   Lo64      AS QUAD    ' // The low 64 bits of your number. This is an _int64 (QUAD in PB)
END TYPE

%DECIMAL_NEG = &H80?

#ENDIF

%VARIANT_TRUE = -1%
%VARIANT_FALSE = 0%

'/* The BSTRBLOB structure is used by some implementations */
'/* of the IPropertyStorage interface when marshaling BSTRs */
'/* on systems which don't support BSTR marshaling. */

%VT_EMPTY            = 0
%VT_NULL             = 1
%VT_I2               = 2
%VT_I4               = 3
%VT_R4               = 4
%VT_R8               = 5
%VT_CY               = 6
%VT_DATE             = 7
%VT_BSTR             = 8
%VT_DISPATCH         = 9
%VT_ERROR            = 10
%VT_BOOL             = 11
%VT_VARIANT          = 12
%VT_UNKNOWN          = 13
%VT_DECIMAL          = 14
%VT_I1               = 16
%VT_UI1              = 17
%VT_UI2              = 18
%VT_UI4              = 19
%VT_I8               = 20
%VT_UI8              = 21
%VT_INT              = 22
%VT_UINT             = 23
%VT_VOID             = 24
%VT_HRESULT          = 25
%VT_PTR              = 26
%VT_SAFEARRAY        = 27
%VT_CARRAY           = 28
%VT_USERDEFINED      = 29
%VT_LPSTR            = 30
%VT_LPWSTR           = 31
%VT_RECORD           = 36
%VT_INT_PTR          = 37
%VT_UINT_PTR         = 38
%VT_FILETIME         = 64
%VT_BLOB             = 65
%VT_STREAM           = 66
%VT_STORAGE          = 67
%VT_STREAMED_OBJECT  = 68
%VT_STORED_OBJECT    = 69
%VT_BLOB_OBJECT      = 70
%VT_CF               = 71
%VT_CLSID            = 72
%VT_VERSIONED_STREAM = 73
%VT_BSTR_BLOB        = &Hfff
%VT_VECTOR           = &H1000
%VT_ARRAY            = &H2000
%VT_BYREF            = &H4000
%VT_RESERVED         = &H8000
%VT_ILLEGAL          = &Hffff
%VT_ILLEGALMASKED    = &Hfff
%VT_TYPEMASK         = &Hfff

' Note: The following equates are for VBer's that are used to vbxxx constants.
%vbEmpty           = 0     ' &H0 (VT_EMPTY)
%vbNull            = 1     ' &H1 (VT_NULL)
%vbInteger         = 2     ' &H2 (VT_UI2)
%vbLong            = 3     ' &H3 (VT_I4)
%vbSingle          = 4     ' &H4 (VT_R4)
%vbDouble          = 5     ' &H5 (VT_R8)
%vbCurrency        = 6     ' &H6 (VT_CY)
%vbDate            = 7     ' &H7 (VT_DATE)
%vbString          = 8     ' &H8 (VT_BSTR)
%vbObject          = 9     ' &H9 (VT_DISPATCH)
%vbError           = 10    ' &HA (VT_ERROR)
%vbBoolean         = 11    ' &HB (VT_BOOL)
%vbVariant         = 12    ' &HC (VT_VARIANT)
%vbDataObject      = 13    ' &HD (VT_UNKNOWN)
%vbDecimal         = 14    ' &HE (VT_DECIMAL)
%vbByte            = 17    ' &H11 (VT_UI1)
%vbWord            = 18    ' &H12 (VT_UI2)
%vbDWord           = 19    ' &H13 (VT_UI4)
%vbQuad            = 20    ' &H14 (VT_I8)
%vbUserDefinedType = 36    ' &H24 (VT_RECORD)
%vbClsid           = 72    ' &H48 (VT_CLSID)
%vbArray           = 8192  ' &H2000 (VT_ARRAY)

#IF NOT %DEF(%PROPERTYKEY_DEFINED)
%PROPERTYKEY_DEFINED = 1
TYPE PROPERTYKEY
   fmtid AS GUID
   pid   AS DWORD
END TYPE
#ENDIF

' Note: Value is declared as Value(0 TO 5) in PB's WIN32API.INC,
' but declaring it as STRING * 6 allows to use CHR$(x, x, x, x, x, x)
' and also to assign to it predefined constants.
#IF NOT %DEF(%SID_IDENTIFIER_AUTHORITY_DEFINED)
%SID_IDENTIFIER_AUTHORITY_DEFINED = 1
TYPE SID_IDENTIFIER_AUTHORITY
   Value AS STRING * 6
END TYPE
#ENDIF

#IF NOT %DEF(%SID_DEFINED)
%SID_DEFINED = 1
TYPE SID
   Revision             AS BYTE   ' BYTE Revision
   SubAuthorityCount    AS BYTE   ' BYTE SubAuthorityCount
   IdentifierAuthority  AS SID_IDENTIFIER_AUTHORITY   ' SID_IDENTIFIER_AUTHORITY IdentifierAuthority
   SubAuthority(0)      AS DWORD  ' /* [size_is] */ ULONG SubAuthority[ 1 ]
END TYPE
#ENDIF

#IF NOT %DEF(%SECURITY_DESCRIPTOR_DEFINED)
%SECURITY_DESCRIPTOR_DEFINED = 1
TYPE SECURITY_DESCRIPTOR
   Revision AS BYTE       ' BYTE
   Sbz1     AS BYTE       ' BYTE
   nControl AS WORD       ' SECURITY_DESCRIPTOR_CONTROL
   Owner    AS SID PTR    ' PSID
   Group    AS SID PTR    ' PSID
   Sacl     AS ACL PTR    ' PACL
   Dacl     AS ACL PTR    ' PACL
END TYPE
#ENDIF

#IF NOT %DEF(%SID_AND_ATTRIBUTES_DEFINED)
%SID_AND_ATTRIBUTES_DEFINED = 1
TYPE SID_AND_ATTRIBUTES
   Sid        AS SID PTR   ' SID *Sid
   Attributes AS DWORD     ' DWORD Attributes
END TYPE
#ENDIF

TYPE CSPLATFORM
   dwPlatformId    AS DWORD   ' DWORD dwPlatformId
   dwVersionHi     AS DWORD   ' DWORD dwVersionHi
   dwVersionLo     AS DWORD   ' DWORD dwVersionLo
   dwProcessorArch AS DWORD   ' DWORD dwProcessorArch
END TYPE

TYPE QUERYCONTEXT
   dwContext   AS DWORD        ' DWORD dwContext
   Platform    AS CSPLATFORM   ' CSPLATFORM Platform
   Locale      AS DWORD        ' LCID Locale
   dwVersionHi AS DWORD        ' DWORD dwVersionHi
   dwVersionLo AS DWORD        ' DWORD dwVersionLo
END TYPE

' TYSPEC enum
%TYSPEC_CLSID       = 0
%TYSPEC_FILEEXT     = %TYSPEC_CLSID       + 1
%TYSPEC_MIMETYPE    = %TYSPEC_FILEEXT     + 1
%TYSPEC_FILENAME    = %TYSPEC_MIMETYPE    + 1
%TYSPEC_PROGID      = %TYSPEC_FILENAME    + 1
%TYSPEC_PACKAGENAME = %TYSPEC_PROGID      + 1
%TYSPEC_OBJECTID    = %TYSPEC_PACKAGENAME + 1

TYPE uCLSSPEC_ByName
   pPackageName AS WORD PTR   ' LPOLESTR pPackageName
   PolicyId     AS GUID       ' GUID PolicyId
END TYPE

TYPE uCLSSPEC_ByObjectId
   ObjectId AS GUID        ' GUID ObjectId
   PolicyId AS GUID        ' GUID PolicyId
END TYPE

UNION uCLSSPEC
   clsid      AS GUID       ' CLSID clsid
   pFileExt   AS WORD PTR   ' LPOLESTR pFileExt
   pMimeType  AS WORD PTR   ' LPOLESTR pMimeType
   pProgId    AS WORD PTR   ' LPOLESTR pProgId
   pFileName  AS WORD PTR   ' LPOLESTR pFileName
   ByName     AS uCLSSPEC_ByName
   ByObjectId AS uCLSSPEC_ByObjectId
END UNION

#ENDIF   ' #IF NOT %DEF(%WTYPES_INC)

'//+-------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//--------------------------------------------------------------------------

#IF NOT %DEF(%OAIDL_INC)
    %OAIDL_INC = 1

#IF NOT %DEF(%IOleAutomationTypes_INTERFACE_DEFINED)
    %IOleAutomationTypes_INTERFACE_DEFINED = 1

'typedef CY CURRENCY;

TYPE SAFEARRAYBOUND
   cElements AS DWORD   ' ULONG cElements
   lLbound   AS LONG    ' LONG lLbound
END TYPE

' SF_TYPE enum
%SF_ERROR    = %VT_ERROR
%SF_I1       = %VT_I1
%SF_I2       = %VT_I2
%SF_I4       = %VT_I4
%SF_I8       = %VT_I8
%SF_BSTR     = %VT_BSTR
%SF_UNKNOWN  = %VT_UNKNOWN
%SF_DISPATCH = %VT_DISPATCH
%SF_VARIANT  = %VT_VARIANT
%SF_RECORD   = %VT_RECORD
%SF_HAVEIID  = %VT_UNKNOWN OR %VT_RESERVED

TYPE SAFEARRAY
   cDims        AS WORD             ' USHORT
   fFeatures    AS WORD             ' USHORT
   cbElements   AS DWORD            ' ULONG
   cLocks       AS DWORD            ' ULONG
   pvData       AS DWORD            ' PVOID
   rgsabound(0) AS SAFEARRAYBOUND   ' SAFEARRAYBOUND rgsabound[ 1 ]
END TYPE

%FADF_AUTO        = &H1???    ' An array that is allocated on the stack.
%FADF_STATIC      = &H2???    ' An array that is statically allocated.
%FADF_EMBEDDED    = &H4???    ' An array that is embedded in a structure.
%FADF_FIXEDSIZE   = &H10???   ' An array that may not be resized or reallocated.
%FADF_RECORD      = &H20???   ' An array containing records. When set there will be a pointer to the IRecordinfo interface at negative offset 4 in the array descriptor.
%FADF_HAVEIID     = &H40???   ' An array that has an IID identifying interface. When set there will be a guid at negative offset 16 in the safearray descriptor. Flag is set only when %FADF_DISPATCH or %FADF_UNKNOWN is also set.
%FADF_HAVEVARTYPE = &H80???   ' An array that has a VT type. When set there will be a VT tag at negative offset 4 in the array descriptor that specifies the element type.
%FADF_BSTR        = &H100???  ' An array of BSTRs.
%FADF_UNKNOWN     = &H200???  ' An array of IUnknown*.
%FADF_DISPATCH    = &H400???  ' An array of IDispatch*.
%FADF_VARIANT     = &H800???  ' An array of VARIANTs.
%FADF_RESERVED    = &HF008??? ' Bits reserved for future use.

'/* VARIANT STRUCTURE
' *
' *  VARTYPE vt;
' *  WORD wReserved1;
' *  WORD wReserved2;
' *  WORD wReserved3;
' *  union {
' *    LONGLONG       VT_I8
' *    LONG           VT_I4
' *    BYTE           VT_UI1
' *    SHORT          VT_I2
' *    FLOAT          VT_R4
' *    DOUBLE         VT_R8
' *    VARIANT_BOOL   VT_BOOL
' *    SCODE          VT_ERROR
' *    CY             VT_CY
' *    DATE           VT_DATE
' *    BSTR           VT_BSTR
' *    IUnknown *     VT_UNKNOWN
' *    IDispatch *    VT_DISPATCH
' *    SAFEARRAY *    VT_ARRAY
' *    BYTE *         VT_BYREF|VT_UI1
' *    SHORT *        VT_BYREF|VT_I2
' *    LONG *         VT_BYREF|VT_I4
' *    LONGLONG *     VT_BYREF|VT_I8
' *    FLOAT *        VT_BYREF|VT_R4
' *    DOUBLE *       VT_BYREF|VT_R8
' *    VARIANT_BOOL * VT_BYREF|VT_BOOL
' *    SCODE *        VT_BYREF|VT_ERROR
' *    CY *           VT_BYREF|VT_CY
' *    DATE *         VT_BYREF|VT_DATE
' *    BSTR *         VT_BYREF|VT_BSTR
' *    IUnknown **    VT_BYREF|VT_UNKNOWN
' *    IDispatch **   VT_BYREF|VT_DISPATCH
' *    SAFEARRAY **   VT_BYREF|VT_ARRAY
' *    VARIANT *      VT_BYREF|VT_VARIANT
' *    PVOID          VT_BYREF (Generic ByRef)
' *    CHAR           VT_I1
' *    USHORT         VT_UI2
' *    ULONG          VT_UI4
' *    ULONGLONG      VT_UI8
' *    INT            VT_INT
' *    UINT           VT_UINT
' *    DECIMAL *      VT_BYREF|VT_DECIMAL
' *    CHAR *         VT_BYREF|VT_I1
' *    USHORT *       VT_BYREF|VT_UI2
' *    ULONG *        VT_BYREF|VT_UI4
' *    ULONGLONG *    VT_BYREF|VT_UI8
' *    INT *          VT_BYREF|VT_INT
' *    UINT *         VT_BYREF|VT_UINT
' *  }
' */

'struct tagVARIANT
'    {
'    union
'        {
'        struct __tagVARIANT
'            {
'            VARTYPE vt;
'            WORD wReserved1;
'            WORD wReserved2;
'            WORD wReserved3;
'            union
'                {
'                LONGLONG llVal;
'                LONG lVal;
'                BYTE bVal;
'                SHORT iVal;
'                FLOAT fltVal;
'                DOUBLE dblVal;
'                VARIANT_BOOL boolVal;
'                _VARIANT_BOOL bool;
'                SCODE scode;
'                CY cyVal;
'                DATE date;
'                BSTR bstrVal;
'                IUnknown *punkVal;
'                IDispatch *pdispVal;
'                SAFEARRAY *parray;
'                BYTE *pbVal;
'                SHORT *piVal;
'                LONG *plVal;
'                LONGLONG *pllVal;
'                FLOAT *pfltVal;
'                DOUBLE *pdblVal;
'                VARIANT_BOOL *pboolVal;
'                _VARIANT_BOOL *pbool;
'                SCODE *pscode;
'                CY *pcyVal;
'                DATE *pdate;
'                BSTR *pbstrVal;
'                IUnknown **ppunkVal;
'                IDispatch **ppdispVal;
'                SAFEARRAY **pparray;
'                VARIANT *pvarVal;
'                PVOID byref;
'                CHAR cVal;
'                USHORT uiVal;
'                ULONG ulVal;
'                ULONGLONG ullVal;
'                INT intVal;
'                UINT uintVal;
'                DECIMAL *pdecVal;
'                CHAR *pcVal;
'                USHORT *puiVal;
'                ULONG *pulVal;
'                ULONGLONG *pullVal;
'                INT *pintVal;
'                UINT *puintVal;
'                struct __tagBRECORD
'                    {
'                    PVOID pvRecord;
'                    IRecordInfo *pRecInfo;
'                    }    __VARIANT_NAME_4;
'                }    __VARIANT_NAME_3;
'            }    __VARIANT_NAME_2;
'        DECIMAL decVal;
'        }    __VARIANT_NAME_1;
'    } ;

TYPE BRECORD
   pvRecord  AS DWORD
   pRecInfo  AS DWORD  ' IRecordInfo interface
END TYPE

UNION VARIANTDATA_UNION
   llVal                         AS QUAD         ' LONGLONG          // VT_I8
   lVal                          AS LONG         ' LONG              // VT_I4
   bVal                          AS BYTE         ' BYTE              // VT_UI1
   iVal                          AS INTEGER      ' SHORT             // VT_I2
   fltVal                        AS SINGLE       ' FLOAT             // VT_R4
   dblVal                        AS DOUBLE       ' DOUBLE            // VT_R8
   boolVal                       AS INTEGER      ' VARIANT_BOOL      // VT_BOOL
   bool                          AS INTEGER      ' _VARIANT_BOOL
   scode                         AS LONG         ' SCODE             // VT_ERROR
   cyVal                         AS CUR          ' CY                // VT_CY
   date                          AS DOUBLE       ' DATE              // VT_DATE
   bstrVal                       AS DWORD        ' BSTR              // VT_BSTR
   punkVal                       AS DWORD        ' IUnknown*         // VT_UNKNOWN
   pdispVal                      AS DWORD        ' IDispatch*        // VT_DISPATCH
   parray                        AS DWORD        ' SAFEARRAY*        // VT_ARRAY
   pbVal                         AS BYTE PTR     ' BYTE*             // VT_BYREF|VT_UI1
   piVal                         AS INTEGER PTR  ' SHORT*            // VT_BYREF|VT_I2
   plVal                         AS LONG PTR     ' LONG*             // VT_BYREF|VT_I4
   pllVal                        AS QUAD PTR     ' LONGLONG*         // VT_BYREF|VT_I8
   pfltVal                       AS SINGLE PTR   ' FLOAT*            ' VT_BYREF|VT_R4
   pdblVal                       AS DOUBLE PTR   ' DOUBLE*           ' VT_BYREF|VT_R8
   pboolVal                      AS INTEGER PTR  ' VARIANT_BOOL*     ' VT_BYREF|VT_BOOL
   pbool                         AS INTEGER PTR  ' _VARIANT_BOOL*
   pscode                        AS LONG PTR     ' SCODE*            ' VT_BYREF|VT_ERROR
   pcyVal                        AS CUR PTR      ' CY*               ' VT_BYREF|VT_CY
   pdate                         AS DOUBLE PTR   ' DATE*             ' VT_BYREF|VT_DATE
   pbstrVal                      AS DWORD        ' BSTR*             ' VT_BYREF|VT_BSTR
   ppunkVal                      AS DWORD PTR    ' IUnknown**        ' VT_BYREF|VT_UNKNOWN
   ppdispVal                     AS DWORD PTR    ' IDispatch**       ' VT_BYREF|VT_DISPATCH
   pparray                       AS DWORD PTR    ' SAFEARRAY**       ' VT_BYREF|VT_ARRAY
   pvarVal                       AS VARIANT PTR  ' VARIANT*          ' VT_BYREF|VT_VARIANT
   pByRef                        AS DWORD PTR    ' PVOID             // Generic BYREF (void*)
   cVal                          AS BYTE         ' CHAR              // VT_I1
   uiVal                         AS WORD         ' USHORT            // VT_UI2
   ulVal                         AS DWORD        ' ULONG             // VT_UI4
   intVal                        AS LONG         ' INT               // VT_INT
   uintVal                       AS DWORD        ' UINT              // VT_UINT
   pdecVal                       AS DECIMAL PTR  ' DECIMAL*          // VT_BYREF|VT_DECIMAL
   pcVal                         AS BYTE PTR     ' CHAR*             // VT_BYREF|VT_I1
   puiVal                        AS WORD PTR     ' USHORT*           // VT_BYREF|VT_UI2
   pulVal                        AS DWORD PTR    ' ULONG*            // VT_BYREF|VT_UI4
   pullVal                       AS QUAD PTR     ' ULONGLONG*        // VT_BYREF|VT_UI8
   pintVal                       AS LONG PTR     ' INT*              // VT_BYREF|VT_INT
   puintVal                      AS DWORD PTR    ' UINT*             // VT_BYREF|VT_UINT
   BRECORD                                       ' VT_RECORD
END UNION

TYPE tagVARIANT
   vt         AS WORD  'VARTYPE
   wReserved1 AS WORD
   wReserved2 AS WORD
   wReserved3 AS WORD
   VARIANTDATA_UNION
END TYPE

' For backwards compatibility
TYPE VARIANTAPI
   vt         AS WORD  'VARTYPE
   wReserved1 AS WORD
   wReserved2 AS WORD
   wReserved3 AS WORD
   vd         AS VARIANTDATA_UNION
END TYPE


'typedef LONG DISPID;
'typedef DISPID MEMBERID;
'typedef DWORD HREFTYPE;

' TYPEKIND enum
%TKIND_ENUM       = 0
%TKIND_RECORD     = %TKIND_ENUM + 1
%TKIND_MODULE     = %TKIND_RECORD + 1
%TKIND_INTERFACE  = %TKIND_MODULE + 1
%TKIND_DISPATCH   = %TKIND_INTERFACE + 1
%TKIND_COCLASS    = %TKIND_DISPATCH + 1
%TKIND_ALIAS      = %TKIND_COCLASS + 1
%TKIND_UNION      = %TKIND_ALIAS + 1
%TKIND_MAX        = %TKIND_UNION + 1

'typedef struct tagTYPEDESC
'    {
'    /* [switch_is][switch_type] */ union
'        {
'        /* [case()] */ struct tagTYPEDESC *lptdesc;
'        /* [case()] */ struct tagARRAYDESC *lpadesc;
'        /* [case()] */ HREFTYPE hreftype;
'        /* [default] */  /* Empty union arm */
'        }    ;
'    VARTYPE vt;
'    }    TYPEDESC;

UNION TYPEDESCDATA
   lptdesc  AS DWORD    ' VT_PTR - the pointed-at type
   lpadesc  AS DWORD    ' VT_CARRAY
   hreftype AS DWORD    ' VT_USERDEFINED - this is used to get a TypeInfo for the UDT
END UNION

TYPE TYPEDESC DWORD     ' // Must be DWORD aligned
   TYPEDESCDATA
   vt AS WORD           ' VARTYPE
END TYPE

'typedef struct tagARRAYDESC
'    {
'    TYPEDESC tdescElem;
'    USHORT cDims;
'    /* [size_is] */ SAFEARRAYBOUND rgbounds[ 1 ];
'    }    ARRAYDESC;

TYPE ARRAYDESC DWORD                ' // Must be DWORD aligned
   tdescElem   AS TYPEDESC         ' Element type
   cDims       AS WORD             ' Dimension count
   rgbounds(0) AS SAFEARRAYBOUND   ' Variable length array containing one element for each dimension.
END TYPE

'typedef struct tagPARAMDESCEX
'    {
'    ULONG cBytes;
'    VARIANTARG varDefaultValue;
'    }    PARAMDESCEX;

'typedef struct tagPARAMDESCEX *LPPARAMDESCEX;

TYPE PARAMDESCEX
   cBytes AS DWORD                 ' size of this struct
   filler AS DWORD
   varDefaultValue AS tagVARIANT   ' default value of this parameter
END TYPE

'typedef struct tagPARAMDESC
'    {
'    LPPARAMDESCEX pparamdescex;
'    USHORT wParamFlags;
'    }    PARAMDESC;

'typedef struct tagPARAMDESC *LPPARAMDESC;

TYPE PARAMDESC DWORD                 ' // Must be DWORD aligned
   pparamdescex AS PARAMDESCEX PTR   ' valid if PARAMFLAG_FHASDEFAULT
   wParamFlags  AS WORD              ' IN, OUT, etc
END TYPE

%PARAMFLAG_NONE         = &H0??
%PARAMFLAG_FIN          = &H1??
%PARAMFLAG_FOUT         = &H2??
%PARAMFLAG_FLCID        = &H4??
%PARAMFLAG_FRETVAL      = &H8??
%PARAMFLAG_FOPT         = &H10??
%PARAMFLAG_FHASDEFAULT  = &H20??
%PARAMFLAG_FHASCUSTDATA = &H40??

'typedef struct tagIDLDESC
'    {
'    ULONG_PTR dwReserved;
'    USHORT wIDLFlags;
'    }    IDLDESC;

'typedef struct tagIDLDESC *LPIDLDESC;

TYPE IDLDESC DWORD       ' // Must be DWORD aligned
   dwReserved AS DWORD   ' Reserved; set to a null reference
   wIDLFlags  AS WORD    ' Indicates an IDLFLAG value describing the type
END TYPE

%IDLFLAG_NONE    = 0??   ' Whether the parameter passes or receives information is unspecified.
%IDLFLAG_FIN     = 1??   ' The parameter passes information from the caller to the callee.
%IDLFLAG_FOUT    = 2??   ' The parameter returns information from the callee to the caller.
%IDLFLAG_FLCID   = 4??   ' The parameter is the local identifier of a client application.
%IDLFLAG_FRETVAL = 8??   ' The parameter is the return value of the member.

'typedef struct tagELEMDESC {
'    TYPEDESC tdesc;             /* the type of the element */
'    union {
'        IDLDESC idldesc;        /* info for remoting the element */
'        PARAMDESC paramdesc;    /* info about the parameter */
'    };
'} ELEMDESC, * LPELEMDESC;

UNION ELEMDESCUNION
   uidldesc   AS IDLDESC     ' Info for remoting the element (backward compatibility)
   uparamdesc AS PARAMDESC   ' info about the parameter
END UNION

TYPE ELEMDESC
   tdesc AS TYPEDESC         ' Type of the element
   ELEMDESCUNION
END TYPE

TYPE TYPEATTR
   guid             AS GUID      ' The GUID of the type information
   lcid             AS DWORD     ' Locale of member names and doc strings
   dwReserved       AS DWORD
   memidConstructor AS LONG      ' ID of constructor, or MEMBERID_NIL if none
   memidDestructor  AS LONG      ' ID of destructor, or MEMBERID_NIL if none
   lpstrSchema      AS DWORD     ' Reserved for future use
   cbSizeInstance   AS DWORD     ' The size of an instance of this type
   typekind         AS DWORD     ' The kind of type this information describes
   cFuncs           AS WORD      ' Number of functions
   cVars            AS WORD      ' Number of variables/data members
   cImplTypes       AS WORD      ' Number of implemented interfaces
   cbSizeVft        AS WORD      ' The size of this type's VTBL
   cbAlignment      AS WORD      ' Byte alignment for an instance of this type
   wTypeFlags       AS WORD
   wMajorVerNum     AS WORD      ' Major version number
   wMinorVerNum     AS WORD      ' Minor version number
   tdescAlias       AS TYPEDESC  ' If TypeKind == TKIND_ALIAS, specifies the type for which this type is an alias.
   idldescType      AS IDLDESC   ' IDL attributes of the described type
END TYPE

'typedef struct tagDISPPARAMS
'    {
'    /* [size_is] */ VARIANTARG *rgvarg;
'    /* [size_is] */ DISPID *rgdispidNamedArgs;
'    UINT cArgs;
'    UINT cNamedArgs;
'    }    DISPPARAMS;

' PB internal definition
'TYPE DispParams
'   VariantArgs AS VARIANT PTR
'   NamedDispId AS LONG PTR
'   CountArgs   AS DWORD
'   CountNamed  AS DWORD
'END TYPE

'typedef struct tagEXCEPINFO
'    {
'    WORD wCode;
'    WORD wReserved;
'    BSTR bstrSource;
'    BSTR bstrDescription;
'    BSTR bstrHelpFile;
'    DWORD dwHelpContext;
'    ULONG_PTR pvReserved;
'    ULONG_PTR pfnDeferredFillIn;
'    SCODE scode;
'    }    EXCEPINFO;

TYPE EXCEPINFO
   wCode             AS WORD   ' An error code describing the error.
   wReserved         AS WORD   ' Reserved
   bstrSource        AS DWORD  ' Source of the exception.
   bstrDescription   AS DWORD  ' Textual description of the error.
   bstrHelpFile      AS DWORD  ' Help file path.
   dwHelpContext     AS DWORD  ' Help context ID.
   pvReserved        AS DWORD  ' Reserved
   pfnDeferredFillIn AS DWORD  ' Pointer to function that fills in Help and description info.
   scode             AS LONG   ' An SCODE describing the error
END TYPE

' CALLCONV enum
%CC_FASTCALL   = 0
%CC_CDECL      = 1
%CC_MSCPASCAL  = %CC_CDECL + 1
%CC_PASCAL     = %CC_MSCPASCAL
%CC_MACPASCAL  = %CC_PASCAL + 1
%CC_STDCALL    = %CC_MACPASCAL + 1
%CC_FPFASTCALL = %CC_STDCALL + 1
%CC_SYSCALL    = %CC_FPFASTCALL + 1
%CC_MPWCDECL   = %CC_SYSCALL + 1
%CC_MPWPASCAL  = %CC_MPWCDECL + 1
%CC_MAX        = %CC_MPWPASCAL + 1

' FUNCKIND enum
%FUNC_VIRTUAL     = 0
%FUNC_PUREVIRTUAL = %FUNC_VIRTUAL + 1
%FUNC_NONVIRTUAL  = %FUNC_PUREVIRTUAL + 1
%FUNC_STATIC      = %FUNC_NONVIRTUAL + 1
%FUNC_DISPATCH    = %FUNC_STATIC + 1

' INVOKEKIND enum
%INVOKE_FUNC           = 1
%INVOKE_PROPERTYGET    = 2
%INVOKE_PROPERTYPUT    = 4
%INVOKE_PROPERTYPUTREF = 8

'typedef struct tagFUNCDESC
'    {
'    MEMBERID memid;
'    /* [size_is] */ SCODE *lprgscode;
'    /* [size_is] */ ELEMDESC *lprgelemdescParam;
'    FUNCKIND funckind;
'    INVOKEKIND invkind;
'    CALLCONV callconv;
'    SHORT cParams;
'    SHORT cParamsOpt;
'    SHORT oVft;
'    SHORT cScodes;
'    ELEMDESC elemdescFunc;
'    WORD wFuncFlags;
'    }    FUNCDESC;

TYPE FUNCDESC
   memid             AS LONG            ' Function memberID
   lprgscode         AS LONG PTR        ' SCODE
   lprgelemdescParam AS ELEMDESC PTR    ' Pointer to an ELEMDESC structure
   funckind          AS DWORD           ' Specifies whether the function is virtual, static, or dispatch-only.
   invkind           AS DWORD           ' Invocation kind. Indicates if this is a property function, and if so, what kind.
   callconv          AS DWORD           ' Specifies the function's calling convention
   cParams           AS INTEGER         ' Count of total number of parameters
   cParamsOpt        AS INTEGER         ' Count of optional parameters
   oVft              AS INTEGER         ' For FUNC_VIRTUAL, specifies the offset in the VTBL
   cScodes           AS INTEGER         ' Count of permitted return values
   elemdescFunc      AS ELEMDESC        ' Contains the return type of the function
   wFuncFlags        AS WORD            ' Flags
END TYPE

' VARKIND enum
%VAR_PERINSTANCE = 0
%VAR_STATIC      = %VAR_PERINSTANCE + 1
%VAR_CONST       = %VAR_STATIC + 1
%VAR_DISPATCH    = %VAR_CONST + 1

%IMPLTYPEFLAG_FDEFAULT       = &H1??
%IMPLTYPEFLAG_FSOURCE        = &H2??
%IMPLTYPEFLAG_FRESTRICTED    = &H4??
%IMPLTYPEFLAG_FDEFAULTVTABLE = &H8??

'typedef struct tagVARDESC
'    {
'    MEMBERID memid;
'    LPOLESTR lpstrSchema;
'    /* [switch_is][switch_type] */ union
'        {
'        /* [case()] */ ULONG oInst;
'        /* [case()] */ VARIANT *lpvarValue;
'        }    ;
'    ELEMDESC elemdescVar;
'    WORD wVarFlags;
'    VARKIND varkind;
'    }    VARDESC;

UNION VARDESCDATA
   oInst      AS DWORD              ' VAR_PERINSTANCE, the offset of this variable within the instance.
   lpvarValue AS tagVARIANT PTR     ' VAR_CONST, the value of the constant.
END UNION

TYPE VARDESC DWORD                  ' // Must be DWORD aligned
   memid       AS LONG              ' Variable memberID
   lpstrSchema AS WORD PTR          ' Reserved for future use
   VARDESCDATA
   elemdescVar AS ELEMDESC          ' Contains the variable type
   wVarFlags   AS WORD              ' Flags
   varkind     AS DWORD             ' Kind of variable
END TYPE

' TYPEFLAGS enum
%TYPEFLAG_FAPPOBJECT        = &H1??
%TYPEFLAG_FCANCREATE        = &H2??
%TYPEFLAG_FLICENSED         = &H4??
%TYPEFLAG_FPREDECLID        = &H8??
%TYPEFLAG_FHIDDEN           = &H10??
%TYPEFLAG_FCONTROL          = &H20??
%TYPEFLAG_FDUAL             = &H40??
%TYPEFLAG_FNONEXTENSIBLE    = &H80??
%TYPEFLAG_FOLEAUTOMATION    = &H100??
%TYPEFLAG_FRESTRICTED       = &H200??
%TYPEFLAG_FAGGREGATABLE     = &H400??
%TYPEFLAG_FREPLACEABLE      = &H800??
%TYPEFLAG_FDISPATCHABLE     = &H1000??
%TYPEFLAG_FREVERSEBIND      = &H2000??
%TYPEFLAG_FPROXY            = &H4000??

' FUNCFLAGS enum
%FUNCFLAG_FRESTRICTED       = &H1??
%FUNCFLAG_FSOURCE           = &H2??
%FUNCFLAG_FBINDABLE         = &H4??
%FUNCFLAG_FREQUESTEDIT      = &H8??
%FUNCFLAG_FDISPLAYBIND      = &H10??
%FUNCFLAG_FDEFAULTBIND      = &H20??
%FUNCFLAG_FHIDDEN           = &H40??
%FUNCFLAG_FUSESGETLASTERROR = &H80??
%FUNCFLAG_FDEFAULTCOLLELEM  = &H100??
%FUNCFLAG_FUIDEFAULT        = &H200??
%FUNCFLAG_FNONBROWSABLE     = &H400??
%FUNCFLAG_FREPLACEABLE      = &H800??
%FUNCFLAG_FIMMEDIATEBIND    = &H1000??

' VARFLAGS enum
%VARFLAG_FREADONLY         = &H1??
%VARFLAG_FSOURCE           = &H2??
%VARFLAG_FBINDABLE         = &H4??
%VARFLAG_FREQUESTEDIT      = &H8??
%VARFLAG_FDISPLAYBIND      = &H10??
%VARFLAG_FDEFAULTBIND      = &H20??
%VARFLAG_FHIDDEN           = &H40??
%VARFLAG_FRESTRICTED       = &H80??
%VARFLAG_FDEFAULTCOLLELEM  = &H100??
%VARFLAG_FUIDEFAULT        = &H200??
%VARFLAG_FNONBROWSABLE     = &H400??
%VARFLAG_FREPLACEABLE      = &H800??
%VARFLAG_FIMMEDIATEBIND    = &H1000??

'typedef struct tagCUSTDATAITEM
'    {
'    GUID guid;
'    VARIANTARG varValue;
'    }    CUSTDATAITEM;

TYPE CUSTDATAITEM
   guid     AS GUID            ' Unique identifier for this data item.
   varValue AS tagVARIANT      ' Value of this data item.
END TYPE

'typedef struct tagCUSTDATA
'    {
'    DWORD cCustData;
'    /* [size_is] */ LPCUSTDATAITEM prgCustData;
'    }    CUSTDATA;

TYPE CUSTDATA
   cCustData   AS DWORD              ' Number of custom data items in prgCustData.
   prgCustData AS CUSTDATAITEM PTR   ' Array of custom data items.
END TYPE

#ENDIF   ' /* __IOleAutomationTypes_INTERFACE_DEFINED__ */


' ########################################################################################
' ICreateTypeInfo interface
' IID = 00020405-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICreateTypeInfo_INTERFACE_DEFINED)
    %ICreateTypeInfo_INTERFACE_DEFINED = 1

$IID_ICreateTypeInfo = GUID$("{00020405-0000-0000-C000-000000000046}")

INTERFACE ICreateTypeInfo $IID_ICreateTypeInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetGuid ( _                         ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetTypeFlags ( _                    ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ UINT uTypeFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDocString ( _                    ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pStrDoc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpContext ( _                  ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVersion ( _                      ' VTable offset = 28
     BYVAL WORD _                             ' /* [in] */ WORD wMajorVerNum
   , BYVAL WORD _                             ' /* [in] */ WORD wMinorVerNum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddRefTypeInfo ( _                  ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ ITypeInfo *pTInfo
   , BYREF DWORD _                            ' /* [out] */ HREFTYPE *phRefType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddFuncDesc ( _                     ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF FUNCDESC _                         ' /* [in] */ FUNCDESC *pFuncDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddImplType ( _                     ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ HREFTYPE hRefType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetImplTypeFlags ( _                ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL LONG _                             ' /* [in] */ INT implTypeFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetAlignMent ( _                    ' VTable offset = 48
     BYVAL WORD _                             ' /* [in] */ WORD cbAlignment
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetSchema ( _                       ' VTable offset = 52
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pStrSchema
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddVarDesc ( _                      ' VTable offset = 56
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF VARDESC _                          ' /* [in] */ VARDESC *pVarDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFuncAndParamNames ( _            ' VTable offset = 60
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF STRING _                           ' /* [in] */ LPOLESTR *rgszNames [array]
   , BYVAL DWORD _                            ' /* [in] */ UINT cNames
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVarName ( _                      ' VTable offset = 64
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetTypeDescAlias ( _                ' VTable offset = 68
     BYREF TYPEDESC _                         ' /* [in] */ TYPEDESC *pTDescAlias
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DefineFuncAsDLLEntry ( _            ' VTable offset = 72
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szDllName
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szProcName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFuncDocString ( _                ' VTable offset = 76
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szDocString
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVarDocString ( _                 ' VTable offset = 80
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szDocString
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFuncHelpContext ( _              ' VTable offset = 84
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVarHelpContext ( _               ' VTable offset = 88
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetMops ( _                         ' VTable offset = 92
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ BSTR bstrMops
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetTypeIdldesc ( _                  ' VTable offset = 96
     BYREF IDLDESC _                          ' /* [in] */ IDLDESC *pIdlDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LayOut ( _                          ' VTable offset = 100
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICreateTypeInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' ICreateTypeInfo2 interface
' IID = 0002040E-0000-0000-C000-000000000046
' Inherited interface = ICreateTypeInfo
' ########################################################################################

#IF NOT %DEF(%ICreateTypeInfo2_INTERFACE_DEFINED)
    %ICreateTypeInfo2_INTERFACE_DEFINED = 1

$IID_ICreateTypeInfo2 = GUID$("{0002040E-0000-0000-C000-000000000046}")

INTERFACE ICreateTypeInfo2 $IID_ICreateTypeInfo2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetGuid ( _                         ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetTypeFlags ( _                    ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ UINT uTypeFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDocString ( _                    ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pStrDoc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpContext ( _                  ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVersion ( _                      ' VTable offset = 28
     BYVAL WORD _                             ' /* [in] */ WORD wMajorVerNum
   , BYVAL WORD _                             ' /* [in] */ WORD wMinorVerNum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddRefTypeInfo ( _                  ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ ITypeInfo *pTInfo
   , BYREF DWORD _                            ' /* [out] */ HREFTYPE *phRefType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddFuncDesc ( _                     ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF FUNCDESC _                         ' /* [in] */ FUNCDESC *pFuncDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddImplType ( _                     ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ HREFTYPE hRefType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetImplTypeFlags ( _                ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL LONG _                             ' /* [in] */ INT implTypeFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetAlignMent ( _                    ' VTable offset = 48
     BYVAL WORD _                             ' /* [in] */ WORD cbAlignment
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetSchema ( _                       ' VTable offset = 52
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pStrSchema
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddVarDesc ( _                      ' VTable offset = 56
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF VARDESC _                          ' /* [in] */ VARDESC *pVarDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFuncAndParamNames ( _            ' VTable offset = 60
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF STRING _                           ' /* [in] */ LPOLESTR *rgszNames [array]
   , BYVAL DWORD _                            ' /* [in] */ UINT cNames
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVarName ( _                      ' VTable offset = 64
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetTypeDescAlias ( _                ' VTable offset = 68
     BYREF TYPEDESC _                         ' /* [in] */ TYPEDESC *pTDescAlias
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DefineFuncAsDLLEntry ( _            ' VTable offset = 72
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szDllName
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szProcName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFuncDocString ( _                ' VTable offset = 76
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szDocString
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVarDocString ( _                 ' VTable offset = 80
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR szDocString
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFuncHelpContext ( _              ' VTable offset = 84
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVarHelpContext ( _               ' VTable offset = 88
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetMops ( _                         ' VTable offset = 92
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ BSTR bstrMops
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetTypeIdldesc ( _                  ' VTable offset = 96
     BYREF IDLDESC _                          ' /* [in] */ IDLDESC *pIdlDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LayOut ( _                          ' VTable offset = 100
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteFuncDesc ( _                  ' VTable offset = 104
     BYVAL DWORD _                            ' /* [in] */ UINT index
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteFuncDescByMemId ( _           ' VTable offset = 108
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL DWORD _                            ' /* [in] */ INVOKEKIND invKind
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteVarDesc ( _                   ' VTable offset = 112
     BYVAL DWORD _                            ' /* [in] */ UINT index
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteVarDescByMemId ( _            ' VTable offset = 116
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteImplType ( _                  ' VTable offset = 120
     BYVAL DWORD _                            ' /* [in] */ UINT index
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetCustData ( _                     ' VTable offset = 124
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYVAL VARIANT _                          ' /* [in] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFuncCustData ( _                 ' VTable offset = 128
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYVAL VARIANT _                          ' /* [in] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetParamCustData ( _                ' VTable offset = 132
     BYVAL DWORD _                            ' /* [in] */ UINT indexFunc
   , BYVAL DWORD _                            ' /* [in] */ UINT indexParam
   , BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYVAL VARIANT _                          ' /* [in] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVarCustData ( _                  ' VTable offset = 136
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYVAL VARIANT _                          ' /* [in] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetImplTypeCustData ( _             ' VTable offset = 140
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYVAL VARIANT _                          ' /* [in] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpStringContext ( _            ' VTable offset = 144
     BYVAL DWORD _                            ' /* [in] */ ULONG dwHelpStringContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFuncHelpStringContext ( _        ' VTable offset = 148
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ ULONG dwHelpStringContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVarHelpStringContext ( _         ' VTable offset = 152
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYVAL DWORD _                            ' /* [in] */ ULONG dwHelpStringContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Invalidate ( _                      ' VTable offset = 156
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetName ( _                         ' VTable offset = 160
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICreateTypeInfo2_INTERFACE_DEFINED__ */


' ########################################################################################
' ICreateTypeLib interface
' IID = 00020406-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICreateTypeLib_INTERFACE_DEFINED)
    %ICreateTypeLib_INTERFACE_DEFINED = 1

$IID_ICreateTypeLib = GUID$("{00020406-0000-0000-C000-000000000046}")

INTERFACE ICreateTypeLib $IID_ICreateTypeLib

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateTypeInfo ( _                  ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   , BYVAL DWORD _                            ' /* [in] */ TYPEKIND tkind
   , BYREF IUnknown _                         ' /* [out] */ ICreateTypeInfo **ppCTInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetName ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVersion ( _                      ' VTable offset = 20
     BYVAL WORD _                             ' /* [in] */ WORD wMajorVerNum
   , BYVAL WORD _                             ' /* [in] */ WORD wMinorVerNum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetGuid ( _                         ' VTable offset = 24
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDocString ( _                    ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szDoc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpFileName ( _                 ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szHelpFileName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpContext ( _                  ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetLCID ( _                         ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ LCID lcid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetLibFlags ( _                     ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ UINT uLibFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SaveAllChanges ( _                  ' VTable offset = 48
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICreateTypeLib_INTERFACE_DEFINED__ */


' ########################################################################################
' ICreateTypeLib2 interface
' IID = 0002040F-0000-0000-C000-000000000046
' Inherited interface = ICreateTypeLib
' ########################################################################################

#IF NOT %DEF(%ICreateTypeLib2_INTERFACE_DEFINED)
    %ICreateTypeLib2_INTERFACE_DEFINED = 1

$IID_ICreateTypeLib2 = GUID$("{0002040F-0000-0000-C000-000000000046}")

INTERFACE ICreateTypeLib2 $IID_ICreateTypeLib2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateTypeInfo ( _                  ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   , BYVAL DWORD _                            ' /* [in] */ TYPEKIND tkind
   , BYREF IUnknown _                         ' /* [out] */ ICreateTypeInfo **ppCTInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetName ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetVersion ( _                      ' VTable offset = 20
     BYVAL WORD _                             ' /* [in] */ WORD wMajorVerNum
   , BYVAL WORD _                             ' /* [in] */ WORD wMinorVerNum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetGuid ( _                         ' VTable offset = 24
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDocString ( _                    ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szDoc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpFileName ( _                 ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szHelpFileName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpContext ( _                  ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetLCID ( _                         ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ LCID lcid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetLibFlags ( _                     ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ UINT uLibFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SaveAllChanges ( _                  ' VTable offset = 48
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteTypeInfo ( _                  ' VTable offset = 52
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetCustData ( _                     ' VTable offset = 56
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYVAL VARIANT _                          ' /* [in] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpStringContext ( _            ' VTable offset = 60
     BYVAL DWORD _                            ' /* [in] */ ULONG dwHelpStringContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpStringDll ( _                ' VTable offset = 64
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szFileName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICreateTypeLib2_INTERFACE_DEFINED__ */


' ########################################################################################
' IDispatch interface
' IID = 00020400-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' NOTE: Renamed because of conflicts with the built-in PB definition.
' ########################################################################################

#IF NOT %DEF(%IDispatch_INTERFACE_DEFINED)
    %IDispatch_INTERFACE_DEFINED = 1

$IID_IDispatch = GUID$("{00020400-0000-0000-C000-000000000046}")

'/* DISPID reserved to indicate an "unknown" name */
'/* only reserved for data members (properties); reused as a method dispid below */
%DISPID_UNKNOWN                           = -1

'/* DISPID reserved for the "value" property */
%DISPID_VALUE                             = 0

'/* The following DISPID is reserved to indicate the param
' * that is the right-hand-side (or "put" value) of a PropertyPut
' */
%DISPID_PROPERTYPUT                       = -3

'/* DISPID reserved for the standard "NewEnum" method */
%DISPID_NEWENUM                           = -4

'/* DISPID reserved for the standard "Evaluate" method */
%DISPID_EVALUATE                          = -5

%DISPID_CONSTRUCTOR                       = -6

%DISPID_DESTRUCTOR                        = -7

%DISPID_COLLECT                           = -8

'/* The range -500 through -999 is reserved for Controls */
'/* The range 0x80010000 through 0x8001FFFF is reserved for Controls */
'/* The range -5000 through -5499 is reserved for ActiveX Accessability */
'/* The range -2000 through -2499 is reserved for VB5 */
'/* The range -3900 through -3999 is reserved for Forms */
'/* The range -5500 through -5550 is reserved for Forms */
'/* The remainder of the negative DISPIDs are reserved for future use */

INTERFACE COM_IDispatch $IID_IDispatch

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTypeInfoCount ( _                ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ unsigned int FAR* pctinfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeInfo ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ unsigned int iTInfo
   , BYVAL DWORD _                            ' /* [in] */ LCID lcid
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo FAR* FAR* ppTInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetIDsOfNames ( _                   ' VTable offset = 20
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF STRING _                           ' /* [in] */ OLECHAR FAR* FAR* rgszNames
   , BYVAL DWORD _                            ' /* [in] */ unsigned int cNames
   , BYVAL DWORD _                            ' /* [in] */ LCID lcid
   , BYREF LONG _                             ' /* [out] */ DISPID FAR* rgDispId
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Invoke ( _                          ' VTable offset = 24
     BYVAL LONG _                             ' /* [in] */ DISPID dispIdMember
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ LCID lcid
   , BYVAL WORD _                             ' /* [in] */ WORD wFlags
   , BYREF DISPPARAMS _                       ' /* [in] */ DISPPARAMS FAR* pDispParams
   , BYREF VARIANT _                          ' /* [out] */ VARIANT FAR* pVarResult
   , BYREF EXCEPINFO _                        ' /* [out] */ EXCEPINFO FAR*  pExcepInfo
   , BYREF DWORD _                            ' /* [out] */ unsigned int FAR*  puArgErr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDispatch_INTERFACE_DEFINED__ */

' *** As built into the PowerBASIC compiler ***

'INTERFACE IDispatch $IID_IDispatch

'   INHERIT IUnknown

'   ' =====================================================================================
'   METHOD GetTypeInfoCount ( _                ' VTable offset = 12
'     BYREF DWORD _                            ' /* [out] */ unsigned int FAR* pctinfo
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD GetTypeInfo ( _                     ' VTable offset = 16
'     BYVAL DWORD _                            ' /* [in] */ unsigned int iTInfo
'   , BYVAL DWORD _                            ' /* [in] */ LCID lcid
'   , BYREF DWORD _                            ' /* [out] */ ITypeInfo FAR* FAR* ppTInfo
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD GetIDsOfNames ( _                   ' VTable offset = 20
'     BYREF GUID _                             ' /* [in] */ REFIID riid
'   , BYREF STRING _                           ' /* [in] */ OLECHAR FAR* FAR* rgszNames
'   , BYVAL DWORD _                            ' /* [in] */ unsigned int cNames
'   , BYVAL DWORD _                            ' /* [in] */ LCID lcid
'   , BYREF LONG _                             ' /* [out] */ DISPID FAR* rgDispId
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD Invoke ( _                         ' VTable offset = 24
'     BYVAL LONG _                            ' /* [in] */ DISPID dispIdMember
'   , BYREF GUID _                            ' /* [in] */ REFIID riid
'   , BYVAL DWORD _                           ' /* [in] */ LCID lcid
'   , BYVAL DWORD _                           ' /* [in] */ WORD wFlags
'   , BYREF DISPPARAMS _                      ' /* [in] */ DISPPARAMS FAR* pDispParams
'   , BYREF VARIANT _                         ' /* [out] */ VARIANT FAR* pVarResult
'   , BYVAL DWORD _                           ' /* [out] */ EXCEPINFO FAR*  pExcepInfo
'   , BYREF DWORD _                           ' /* [out] */ unsigned int FAR*  puArgErr
'   ) AS LONG                                 ' HRESULT
'   ' =====================================================================================

'END INTERFACE


' ########################################################################################
' IEnumVARIANT interface
' IID = 00000002-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumVARIANT_INTERFACE_DEFINED)
    %IEnumVARIANT_INTERFACE_DEFINED = 1

$IID_IEnumVARIANT = GUID$("{00020404-0000-0000-C000-000000000046}")

INTERFACE IEnumVARIANT $IID_IEnumVARIANT

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ unsigned long celt
   , BYREF VARIANT _                          ' /* [out] */ VARIANT FAR* rgVar
   , BYREF DWORD _                            ' /* [out] */ unsigned long FAR* pCeltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ unsigned long celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumVARIANT _                     ' /* [out] */ IEnumVARIANT** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumVARIANT_INTERFACE_DEFINED__ */


' ########################################################################################
' ITypeComp interface
' IID = 00020403-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ITypeComp_INTERFACE_DEFINED)
    %ITypeComp_INTERFACE_DEFINED = 1

' DESCKIND enum
%DESCKIND_NONE           = 0
%DESCKIND_FUNCDESC       = %DESCKIND_NONE + 1
%DESCKIND_VARDESC        = %DESCKIND_FUNCDESC + 1
%DESCKIND_TYPECOMP       = %DESCKIND_VARDESC + 1
%DESCKIND_IMPLICITAPPOBJ = %DESCKIND_TYPECOMP + 1
%DESCKIND_MAX            = %DESCKIND_IMPLICITAPPOBJ + 1

UNION BINDPTR
   lpfuncdesc AS FUNCDESC PTR   ' FUNCDESC FAR*
   lpvardesc  AS VARDESC PTR    ' VARDESC FAR*
   lptcomp    AS DWORD PTR      ' ITypeComp FAR*
END UNION

$IID_ITypeComp = GUID$("{00020403-0000-0000-C000-000000000046}")

INTERFACE ITypeComp $IID_ITypeComp

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Bind ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   , BYVAL DWORD _                            ' /* [in] */ ULONG lHashVal
   , BYVAL WORD _                             ' /* [in] */ WORD wFlags
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTInfo
   , BYREF DWORD _                            ' /* [out] */ DESCKIND *pDescKindgs
   , BYVAL BINDPTR PTR _                      ' /* [out] */ BINDPTR *pBindPtr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BindType ( _                        ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR szName
   , BYVAL DWORD _                            ' /* [in] */ ULONG lHashVal
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTInfo
   , BYREF IUnknown _                         ' /* [out] */ ITypeComp **ppTComp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ITypeComp_INTERFACE_DEFINED__ */


' ########################################################################################
' ITypeInfo interface
' IID = 00020401-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ITypeInfo_INTERFACE_DEFINED)
    %ITypeInfo_INTERFACE_DEFINED = 1

$IID_ITypeInfo = GUID$("{00020401-0000-0000-C000-000000000046}")

INTERFACE ITypeInfo $IID_ITypeInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTypeAttr ( _                     ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ TYPEATTR **ppTypeAttr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeComp ( _                     ' VTable offset = 16
     BYREF IUnknown _                         ' /* [out] */ ITypeComp **ppTComp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFuncDesc ( _                     ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF DWORD _                            ' /* [out] */ FUNCDESC **ppFuncDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetVarDesc ( _                      ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF DWORD _                            ' /* [out] */ VARDESC **ppVarDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetNames ( _                        ' VTable offset = 28
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYREF STRING _                           ' /* [out] */ BSTR *rgBstrNames
   , BYVAL DWORD _                            ' /* [in] */ UINT cMaxNames
   , BYREF DWORD _                            ' /* [out] */ UINT *pcNames
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetRefTypeOfImplType ( _            ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF DWORD _                            ' /* [out] */ HREFTYPE *pRefType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetImplTypeFlags ( _                ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF LONG _                             ' /* [out] */ INT *pImplTypeFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetIDsOfNames ( _                   ' VTable offset = 40
     BYREF STRING _                           ' /* [in] */ LPOLESTR *rgszName [array]
   , BYVAL DWORD _                            ' /* [in] */ UINT cNames
   , BYREF LONG _                             ' /* [out] */ MEMBERID *pMemId
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Invoke ( _                          ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ PVOID pvInstance
   , BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL WORD _                             ' /* [in] */ WORD wFlags
   , BYREF DISPPARAMS _                       ' /* [out][in] */ DISPPARAMS *pDispParams
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarResult
   , BYREF EXCEPINFO _                        ' /* [out] */ EXCEPINFO *pExcepInfo
   , BYREF DWORD _                            ' /* [out] */ UINT *puArgErr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDocumentation ( _                ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrName
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrDocString
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwHelpContext
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrHelpFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDllEntry ( _                     ' VTable offset = 52
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL LONG _                             ' /* [in] */ INVOKEKIND invKind
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrDllName
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrName
   , BYREF WORD _                             ' /* [out] */ WORD *pwOrdinal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetRefTypeInfo ( _                  ' VTable offset = 56
     BYVAL DWORD _                            ' /* [in] */ HREFTYPE hRefType
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddressOfMember ( _                 ' VTable offset = 60
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL LONG _                             ' /* [in] */ INVOKEKIND invKind
   , BYREF DWORD _                            ' /* [out] */ PVOID *ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateInstance( _                   ' VTable offset = 64
     BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnkOuter
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ PVOID *ppvObj
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMops ( _                         ' VTable offset = 68
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrMops
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetContainingTypeLib ( _            ' VTable offset = 72
     BYREF IUnknown _                         ' /* [out] */ ITypeLib **ppTLib
   , BYREF DWORD _                            ' /* [out] */ UINT *pIndex
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseTypeAttr ( _                 ' VTable offset = 76
     BYVAL TYPEATTR PTR _                     ' /* [in] */ TYPEATTR *pTypeAttr
   )                                          ' void
   ' =====================================================================================
   METHOD ReleaseFuncDesc ( _                 ' VTable offset = 80
     BYVAL FUNCDESC PTR _                     ' /* [in] */ FUNCDESC *pFuncDesc
   )                                          ' void
   ' =====================================================================================
   METHOD ReleaseVarDesc ( _                  ' VTable offset = 84
     BYVAL VARDESC PTR _                      ' /* [in] */ VARDESC *pVarDesc
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ITypeInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' ITypeInfo2 interface
' IID = 00020412-0000-0000-C000-000000000046
' Inherited interface = ITypeInfo
' ########################################################################################

#IF NOT %DEF(%ITypeInfo2_INTERFACE_DEFINED)
    %ITypeInfo2_INTERFACE_DEFINED = 1

$IID_ITypeInfo2 = GUID$("{00020412-0000-0000-C000-000000000046}")

INTERFACE ITypeInfo2 $IID_ITypeInfo2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTypeAttr ( _                     ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ TYPEATTR **ppTypeAttr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeComp ( _                     ' VTable offset = 16
     BYREF IUnknown _                         ' /* [out] */ ITypeComp **ppTComp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFuncDesc ( _                     ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF DWORD _                            ' /* [out] */ FUNCDESC **ppFuncDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetVarDesc ( _                      ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF DWORD _                            ' /* [out] */ VARDESC **ppVarDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetNames ( _                        ' VTable offset = 28
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYREF STRING _                           ' /* [out] */ BSTR *rgBstrNames
   , BYVAL DWORD _                            ' /* [in] */ UINT cMaxNames
   , BYREF DWORD _                            ' /* [out] */ UINT *pcNames
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetRefTypeOfImplType ( _            ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF DWORD _                            ' /* [out] */ HREFTYPE *pRefType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetImplTypeFlags ( _                ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF LONG _                             ' /* [out] */ INT *pImplTypeFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetIDsOfNames ( _                   ' VTable offset = 40
     BYREF STRING _                           ' /* [in] */ LPOLESTR *rgszName [array]
   , BYVAL DWORD _                            ' /* [in] */ UINT cNames
   , BYREF LONG _                             ' /* [out] */ MEMBERID *pMemId
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Invoke ( _                          ' VTable offset = 44
     BYVAL IUnknown _                         ' /* [in] */ PVOID pvInstance
   , BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL WORD _                             ' /* [in] */ WORD wFlags
   , BYREF DISPPARAMS _                       ' /* [out][in] */ DISPPARAMS *pDispParams
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarResult
   , BYREF EXCEPINFO _                        ' /* [out] */ EXCEPINFO *pExcepInfo
   , BYREF DWORD _                            ' /* [out] */ UINT *puArgErr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDocumentation ( _                ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrName
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrDocString
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwHelpContext
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrHelpFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDllEntry ( _                     ' VTable offset = 52
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL LONG _                             ' /* [in] */ INVOKEKIND invKind
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrDllName
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrName
   , BYREF WORD _                             ' /* [out] */ WORD *pwOrdinal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetRefTypeInfo ( _                  ' VTable offset = 56
     BYVAL DWORD _                            ' /* [in] */ HREFTYPE hRefType
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddressOfMember ( _                 ' VTable offset = 60
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL LONG _                             ' /* [in] */ INVOKEKIND invKind
   , BYREF DWORD _                            ' /* [out] */ PVOID *ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateInstance( _                   ' VTable offset = 64
     BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnkOuter
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ PVOID *ppvObj
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMops ( _                         ' VTable offset = 68
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrMops
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetContainingTypeLib ( _            ' VTable offset = 72
     BYREF IUnknown _                         ' /* [out] */ ITypeLib **ppTLib
   , BYREF DWORD _                            ' /* [out] */ UINT *pIndex
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseTypeAttr ( _                 ' VTable offset = 76
     BYVAL TYPEATTR PTR _                     ' /* [in] */ TYPEATTR *pTypeAttr
   )                                          ' void
   ' =====================================================================================
   METHOD ReleaseFuncDesc ( _                 ' VTable offset = 80
     BYVAL FUNCDESC PTR _                     ' /* [in] */ FUNCDESC *pFuncDesc
   )                                          ' void
   ' =====================================================================================
   METHOD ReleaseVarDesc ( _                  ' VTable offset = 84
     BYVAL VARDESC PTR _                      ' /* [in] */ VARDESC *pVarDesc
   )                                          ' void
   ' =====================================================================================
   METHOD GetTypeKind ( _                     ' VTable offset = 88
     BYREF DWORD _                            ' /* [out] */ TYPEKIND *pTypeKind
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeFlags ( _                    ' VTable offset = 92
     BYREF DWORD _                            ' /* [out] */ ULONG *pTypeFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFuncIndexOfMemId ( _             ' VTable offset = 96
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL DWORD _                            ' /* [in] */ INVOKEKIND invKind
   , BYVAL DWORD _                            ' /* [out] */ UINT *pFuncIndex
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetVarIndexOfMemId ( _              ' VTable offset = 100
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL DWORD _                            ' /* [out] */ UINT *pVarIndex
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCustData ( _                     ' VTable offset = 104
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFuncCustData ( _                 ' VTable offset = 108
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetParamCustData ( _                ' VTable offset = 112
     BYVAL DWORD _                            ' /* [in] */ UINT indexFunc
   , BYVAL DWORD _                            ' /* [in] */ UINT indexParam
   , BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetVarCustData ( _                  ' VTable offset = 116
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetImplTypeCustData ( _             ' VTable offset = 120
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDocumentation2 ( _               ' VTable offset = 124
     BYVAL LONG _                             ' /* [in] */ MEMBERID memid
   , BYVAL DWORD _                            ' /* [in] */ LCID lcid
   , BYREF STRING _                           ' /* [out] */ BSTR *pbstrHelpString
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwHelpStringContext
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrHelpFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAllCustData ( _                  ' VTable offset = 128
     BYREF CUSTDATA _                         ' /* [out] */ CUSTDATA *pCustData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAllFuncCustData ( _              ' VTable offset = 132
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF CUSTDATA _                         ' /* [out] */ CUSTDATA *pCustData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAllParamCustData ( _             ' VTable offset = 136
     BYVAL DWORD _                            ' /* [in] */ UINT indexFunc
   , BYVAL DWORD _                            ' /* [in] */ UINT indexParam
   , BYREF CUSTDATA _                         ' /* [out] */ CUSTDATA *pCustData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAllVarCustData ( _               ' VTable offset = 140
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF CUSTDATA _                         ' /* [out] */ CUSTDATA *pCustData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAllImplTypeCustData ( _          ' VTable offset = 144
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF CUSTDATA _                         ' /* [out] */ CUSTDATA *pCustData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ITypeInfo2_INTERFACE_DEFINED__ */


' ########################################################################################
' ITypeLib interface
' IID = 00020402-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ITypeLib_INTERFACE_DEFINED)
    %ITypeLib_INTERFACE_DEFINED = 1

' SYSKIND enum
%SYS_WIN16 = 0
%SYS_WIN32 = 1
%SYS_MAC   = 2

' LIBFLAGS enum
%LIBFLAG_FRESTRICTED   = &H01??
%LIBFLAG_FCONTROL      = &H02??
%LIBFLAG_FHIDDEN       = &H04??
%LIBFLAG_FHASDISKIMAGE = &H08??

TYPE TLIBATTR
   guid         AS GUID     ' GUID
   lcid         AS DWORD    ' LCID
   syskind      AS LONG     ' SYSKIND
   wMajorVerNum AS WORD     ' WORD
   wMinorVerNum AS WORD     ' WORD
   wLibFlags    AS WORD     ' WORD
END TYPE

$IID_ITypeLib = GUID$("{00020402-0000-0000-C000-000000000046}")

INTERFACE ITypeLib $IID_ITypeLib

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTypeInfoCount ( _                ' VTable offset = 12
   ) AS DWORD                                 ' UINT
   ' =====================================================================================
   METHOD GetTypeInfo ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeInfoType ( _                 ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF DWORD _                            ' /* [out] */ TYPEKIND *pTKind
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeInfoOfGuid ( _               ' VTable offset = 24
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTinfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetLibAttr ( _                      ' VTable offset = 28
     BYREF DWORD _                            ' /* [out] */ TLIBATTR **ppTLibAttr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeComp ( _                     ' VTable offset = 32
     BYREF IUnknown _                         ' /* [out] */ ITypeComp **ppTComp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDocumentation ( _                ' VTable offset = 36
     BYVAL LONG _                             ' /* [in] */ INT index
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrName
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrDocString
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwHelpContext
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrHelpFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsName ( _                          ' VTable offset = 40
     BYVAL DWORD _                            ' /* [out][in] */ LPOLESTR szNameBuf
   , BYVAL DWORD _                            ' /* [in] */ ULONG lHashVal
   , BYREF LONG _                             ' /* [out] */ BOOL *pfName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FindName ( _                        ' VTable offset = 44
     BYVAL DWORD _                            ' /* [out][in] */ LPOLESTR szNameBuf
   , BYVAL DWORD _                            ' /* [in] */ ULONG lHashVal
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTInfo
   , BYREF LONG _                             ' /* [out] */ MEMBERID *rgMemId
   , BYREF DWORD _                            ' /* [out][in] */ USHORT *pcFound
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseTLibAttr ( _                 ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ TLIBATTR *pTLibAttr
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ITypeLib_INTERFACE_DEFINED__ */


' ########################################################################################
' ITypeLib2 interface
' IID = 00020411-0000-0000-C000-000000000046
' Inherited interface = ITypeLib
' ########################################################################################

#IF NOT %DEF(%ITypeLib2_INTERFACE_DEFINED)
    %ITypeLib2_INTERFACE_DEFINED = 1

$IID_ITypeLib2 = GUID$("{00020411-0000-0000-C000-000000000046}")

INTERFACE ITypeLib2 $IID_ITypeLib2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTypeInfoCount ( _                ' VTable offset = 12
   ) AS DWORD                                 ' UINT
   ' =====================================================================================
   METHOD GetTypeInfo ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeInfoType ( _                 ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ UINT index
   , BYREF DWORD _                            ' /* [out] */ TYPEKIND *pTKind
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeInfoOfGuid ( _               ' VTable offset = 24
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTinfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetLibAttr ( _                      ' VTable offset = 28
     BYREF DWORD _                            ' /* [out] */ TLIBATTR **ppTLibAttr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeComp ( _                     ' VTable offset = 32
     BYREF IUnknown _                         ' /* [out] */ ITypeComp **ppTComp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDocumentation ( _                ' VTable offset = 36
     BYVAL LONG _                             ' /* [in] */ INT index
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrName
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrDocString
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwHelpContext
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstrHelpFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsName ( _                          ' VTable offset = 40
     BYVAL DWORD _                            ' /* [out][in] */ LPOLESTR szNameBuf
   , BYVAL DWORD _                            ' /* [in] */ ULONG lHashVal
   , BYREF LONG _                             ' /* [out] */ BOOL *pfName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FindName ( _                        ' VTable offset = 44
     BYVAL DWORD _                            ' /* [out][in] */ LPOLESTR szNameBuf
   , BYVAL DWORD _                            ' /* [in] */ ULONG lHashVal
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTInfo
   , BYREF LONG _                             ' /* [out] */ MEMBERID *rgMemId
   , BYREF DWORD _                            ' /* [out][in] */ USHORT *pcFound
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseTLibAttr ( _                 ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ TLIBATTR *pTLibAttr
   )                                          ' void
   ' =====================================================================================
   METHOD GetCustData ( _                     ' VTable offset = 52
     BYREF GUID _                             ' /* [in] */ REFGUID guid
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarVal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetLibStatistics ( _                ' VTable offset = 56
     BYREF DWORD _                            ' /* [out] */ ULONG *pcUniqueNames
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcchUniqueNames
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDocumentation2 ( _               ' VTable offset = 60
     BYVAL LONG _                             ' /* [in] */ INT index
   , BYVAL DWORD _                            ' /* [in] */ LCID lcid
   , BYREF STRING _                           ' /* [out] */ BSTR *pbstrHelpString
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwHelpStringContext
   , BYREF STRING _                           ' /* [out] */ BSTR *pbstrHelpStringDll
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAllCustData ( _                  ' VTable offset = 64
     BYREF CUSTDATA _                         ' /* [out] */ CUSTDATA *pCustData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ITypeLib2_INTERFACE_DEFINED__ */


' ########################################################################################
' ITypeChangeEvents interface
' IID = 00020411-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ITypeChangeEvents_INTERFACE_DEFINED)
    %ITypeChangeEvents_INTERFACE_DEFINED = 1

$IID_ITypeChangeEvents = GUID$("{00020411-0000-0000-C000-000000000046}")

' enum CHANGEKIND
%CHANGEKIND_ADDMEMBER        = 0
%CHANGEKIND_DELETEMEMBER     = %CHANGEKIND_ADDMEMBER + 1
%CHANGEKIND_SETNAMES         = %CHANGEKIND_DELETEMEMBER + 1
%CHANGEKIND_SETDOCUMENTATION = %CHANGEKIND_SETNAMES + 1
%CHANGEKIND_GENERAL          = %CHANGEKIND_SETDOCUMENTATION + 1
%CHANGEKIND_INVALIDATE       = %CHANGEKIND_GENERAL + 1
%CHANGEKIND_CHANGEFAILED     = %CHANGEKIND_INVALIDATE + 1
%CHANGEKIND_MAX              = %CHANGEKIND_CHANGEFAILED + 1

'    MIDL_INTERFACE("00020410-0000-0000-C000-000000000046")
'    ITypeChangeEvents : public IUnknown
'    {
'    public:
'        virtual HRESULT STDMETHODCALLTYPE RequestTypeChange(
'            /* [in] */ CHANGEKIND changeKind,
'            /* [in] */ ITypeInfo *pTInfoBefore,
'            /* [in] */ LPOLESTR pStrName,
'            /* [out] */ INT *pfCancel) = 0;

'        virtual HRESULT STDMETHODCALLTYPE AfterTypeChange(
'            /* [in] */ CHANGEKIND changeKind,
'            /* [in] */ ITypeInfo *pTInfoAfter,
'            /* [in] */ LPOLESTR pStrName) = 0;

'    };

#ENDIF   ' /* __ITypeChangeEvents_INTERFACE_DEFINED__ */


' ########################################################################################
' IErrorInfo interface
' IID = 1CF2B120-547D-101B-8E65-08002B2BD119
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IErrorInfo_INTERFACE_DEFINED)
    %IErrorInfo_INTERFACE_DEFINED = 1

$IID_IErrorInfo = GUID$("{1CF2B120-547D-101B-8E65-08002B2BD119}")

INTERFACE IErrorInfo $IID_IErrorInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetGUID ( _                         ' VTable offset = 12
     BYREF GUID _                             ' /* [out] */ GUID *pGUID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSource ( _                       ' VTable offset = 16
     BYREF STRING _                           ' /* [out] */ BSTR *pBstrSource
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDescription ( _                  ' VTable offset = 20
     BYREF STRING _                           ' /* [out] */ BSTR *pBstrDescription
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetHelpFile ( _                     ' VTable offset = 24
     BYREF STRING _                           ' /* [out] */ BSTR *pBstrHelpFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetHelpContext ( _                  ' VTable offset = 28
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IErrorInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' ICreateErrorInfo interface
' IID = 22F03340-547D-101B-8E65-08002B2BD119
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICreateErrorInfo_INTERFACE_DEFINED)
    %ICreateErrorInfo_INTERFACE_DEFINED = 1

$IID_ICreateErrorInfo = GUID$("{22F03340-547D-101B-8E65-08002B2BD119}")

INTERFACE ICreateErrorInfo $IID_ICreateErrorInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetGUID ( _                         ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID rguid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetSource ( _                       ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szSource
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDescription ( _                  ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szDescription
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpFile ( _                     ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szHelpFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHelpContext ( _                  ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ DWORD dwHelpContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICreateErrorInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' ISupportErrorInfo interface
' IID = DF0B3D60-548F-101B-8E65-08002B2BD119
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISupportErrorInfo_INTERFACE_DEFINED)
    %ISupportErrorInfo_INTERFACE_DEFINED = 1

$IID_ISupportErrorInfo = GUID$("{DF0B3D60-548F-101B-8E65-08002B2BD119}")

INTERFACE ISupportErrorInfo $IID_ISupportErrorInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD InterfaceSupportsErrorInfo ( _      ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISupportErrorInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' ITypeFactory interface
' IID = 0000002E-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ITypeFactory_INTERFACE_DEFINED)
    %ITypeFactory_INTERFACE_DEFINED = 1

$IID_ITypeFactory = GUID$("{0000002E-0000-0000-C000-000000000046}")

INTERFACE ITypeFactory $IID_ITypeFactory

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateFromTypeInfo ( _              ' VTable offset = 12
     BYREF IUnknown _                         ' /* [in] */ ITypeInfo *pTypeInfo
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ IUnknown **ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   '  /* __ITypeFactory_INTERFACE_DEFINED__ */


' ########################################################################################
' ITypeMarshal interface
' IID = 0000002D-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ITypeMarshal_INTERFACE_DEFINED)
    %ITypeMarshal_INTERFACE_DEFINED = 1

$IID_ITypeMarshal = GUID$("{0000002D-0000-0000-C000-000000000046}")

INTERFACE ITypeMarshal $IID_ITypeMarshal

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Size ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ PVOID pvType
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ PVOID pvDestContext
   , BYREF DWORD _                            ' /* [out] */ ULONG *pSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Marshal ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ PVOID pvType
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ PVOID pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ ULONG cbBufferLength
   , BYVAL BYTE PTR _                         ' /* [out] */ BYTE *pBuffer
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcbWritten
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unmarshal ( _                       ' VTable offset = 20
     BYREF DWORD _                            ' /* [out] */ PVOID pvType
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   , BYVAL DWORD _                            ' /* [in] */ ULONG cbBufferLength
   , BYVAL BYTE PTR _                         ' /* [in] */ BYTE *pBuffer
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcbRead
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Free ( _                            ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ PVOID pvType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   '  /* __ITypeMarshal_INTERFACE_DEFINED__ */


' ########################################################################################
' IRecordInfo interface
' IID = 0000002F-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRecordInfo_INTERFACE_DEFINED)
    %IRecordInfo_INTERFACE_DEFINED = 1

$IID_IRecordInfo = GUID$("{0000002F-0000-0000-C000-000000000046}")

INTERFACE IRecordInfo $IID_IRecordInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD RecordInit ( _                      ' VTable offset = 12
     BYVAL DWORD _                            ' /* [out] */ PVOID pvNew
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RecordClear ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [out] */ PVOID pvExisting
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RecordCopy ( _                      ' VTable offset = 20
     BYVAL DWORD _                            ' /* [out] */ PVOID pvExisting
   , BYREF DWORD _                            ' /* [out] */ PVOID pvNew
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetGuid ( _                         ' VTable offset = 24
     BYREF GUID _                             ' /* [out] */ GUID *pguid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetName ( _                         ' VTable offset = 28
     BYREF STRING _                           ' /* [out] */ BSTR *pbstrName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSize ( _                         ' VTable offset = 32
     BYREF DWORD _                            ' /* [out] */ ULONG *pcbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTypeInfo ( _                     ' VTable offset = 36
     BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTypeInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetField ( _                        ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ PVOID pvData
   , BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szFieldName
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pvarField
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFieldNoCopy ( _                  ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ PVOID pvData
   , BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szFieldName
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pvarField
   , BYREF DWORD _                            ' /* [out] */ PVOID *ppvDataCArray
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PutField ( _                        ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ ULONG wFlags
   , BYVAL DWORD _                            ' /* [out][in] */ PVOID pvData
   , BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szFieldName
   , BYVAL VARIANT _                          ' /* [in] */ VARIANT *pvarField
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PutFieldNoCopy ( _                  ' VTable offset = 52
     BYVAL DWORD _                            ' /* [in] */ ULONG wFlags
   , BYVAL DWORD _                            ' /* [out][in] */ PVOID pvData
   , BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szFieldName
   , BYVAL VARIANT _                          ' /* [in] */ VARIANT *pvarField
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFieldNames ( _                   ' VTable offset = 56
     BYREF DWORD _                            ' /* [out][in] */ ULONG *pcNames
   , BYREF STRING _                           ' /* [out] */ BSTR *rgBstrNames
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsMatchingType ( _                  ' VTable offset = 60
     BYVAL DWORD _                            ' /* [in] */ IRecordInfo *pRecordInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RecordCreate ( _                    ' VTable offset = 64
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RecordCreateCopy ( _                ' VTable offset = 68
     BYVAL DWORD _                            ' /* [in] */ PVOID pvSource
   , BYREF DWORD _                            ' /* [in] */ [out] */ PVOID *ppvDest
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RecordDestroy ( _                   ' VTable offset = 72
     BYVAL DWORD _                            ' /* [in] */ PVOID pvRecord
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRecordInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' IErrorLog interface
' IID = 3127CA40-446E-11CE-8135-00AA004BB851
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IErrorLog_INTERFACE_DEFINED)
    %IErrorLog_INTERFACE_DEFINED = 1

$IID_IErrorLog = GUID$("{3127CA40-446E-11CE-8135-00AA004BB851}")

INTERFACE IErrorLog $IID_IErrorLog

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddError ( _                        ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszPropName
   , BYREF EXCEPINFO _                        ' /* [in] */ EXCEPINFO *pExcepInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   '  /* __IErrorLog_INTERFACE_DEFINED__ */


' ########################################################################################
' IPropertyBag interface
' IID = 22F55882-280B-11d0-A8A9-00A0C90C2004
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPropertyBag_INTERFACE_DEFINED)
    %IPropertyBag_INTERFACE_DEFINED = 1

$IID_IPropertyBag = GUID$("{55272A00-42CB-11CE-8135-00AA004BB851}")

INTERFACE IPropertyBag $IID_IPropertyBag

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Read ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszPropName
   , BYREF VARIANT _                          ' /* [in][out] */ VARIANT *pVar
   , BYVAL IUnknown _                         ' /* [in] */ IErrorLog *pErrorLog
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Write ( _                           ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszPropName
   , BYREF VARIANT _                          ' /* [in] */ VARIANT *pVar
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   '    /* __IPropertyBag_INTERFACE_DEFINED__ */

'//+---------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//  File:       OLE2.h
'//  Contents:   Main OLE2 header; Defines Linking and Emmebbeding interfaces, and API's.
'//              Also includes .h files for the compobj, and oleauto  subcomponents.
'//
'//----------------------------------------------------------------------------

#IF NOT %DEF(%OLE2_INC)
    %OLE2_INC = 1

'/*++ BUILD Version: 0001    Increment this if a change has global effects

'Copyright (c) Microsoft Corporation. All rights reserved.

'Module Name:


'    windows.h

'Abstract:

'    Master include file for Windows applications.

'--*/

#IF NOT %DEF(%WINDOWS)
    %WINDOWS = 1

'// 0x0500  - Windows 2000
'// 0x0501  - Windows XP
'// 0x0502  - Windows 2003
'// 0x0600  - Windows Vista
#IF NOT %DEF(%WINVER)
    %WINVER = &H0600  ' Assume Windows Vista
#ENDIF

#IF NOT %DEF(%WINDOWS_INC)
    %WINDOWS_INC = 1

'/*  If defined, the following flags inhibit definition
' *     of the indicated items.
' *
' *  NOGDICAPMASKS     - CC_*, LC_*, PC_*, CP_*, TC_*, RC_
' *  NOVIRTUALKEYCODES - VK_*
' *  NOWINMESSAGES     - WM_*, EM_*, LB_*, CB_*
' *  NOWINSTYLES       - WS_*, CS_*, ES_*, LBS_*, SBS_*, CBS_*
' *  NOSYSMETRICS      - SM_*
' *  NOMENUS           - MF_*
' *  NOICONS           - IDI_*
' *  NOKEYSTATES       - MK_*
' *  NOSYSCOMMANDS     - SC_*
' *  NORASTEROPS       - Binary and Tertiary raster ops
' *  NOSHOWWINDOW      - SW_*
' *  OEMRESOURCE       - OEM Resource values
' *  NOATOM            - Atom Manager routines
' *  NOCLIPBOARD       - Clipboard routines
' *  NOCOLOR           - Screen colors
' *  NOCTLMGR          - Control and Dialog routines
' *  NODRAWTEXT        - DrawText() and DT_*
' *  NOGDI             - All GDI defines and routines
' *  NOKERNEL          - All KERNEL defines and routines
' *  NOUSER            - All USER defines and routines
' *  NONLS             - All NLS defines and routines
' *  NOMB              - MB_* and MessageBox()
' *  NOMEMMGR          - GMEM_*, LMEM_*, GHND, LHND, associated routines
' *  NOMETAFILE        - typedef METAFILEPICT
' *  NOMINMAX          - Macros min(a,b) and max(a,b)
' *  NOMSG             - typedef MSG and associated routines
' *  NOOPENFILE        - OpenFile(), OemToAnsi, AnsiToOem, and OF_*
' *  NOSCROLL          - SB_* and scrolling routines
' *  NOSERVICE         - All Service Controller routines, SERVICE_ equates, etc.
' *  NOSOUND           - Sound driver routines
' *  NOTEXTMETRIC      - typedef TEXTMETRIC and associated routines
' *  NOWH              - SetWindowsHook and WH_*
' *  NOWINOFFSETS      - GWL_*, GCL_*, associated routines
' *  NOCOMM            - COMM driver routines
' *  NOKANJI           - Kanji support stuff.
' *  NOHELP            - Help engine interface.
' *  NOPROFILER        - Profiler interface.
' *  NODEFERWINDOWPOS  - DeferWindowPos routines
' *  NOMCX             - Modem Configuration Extensions
' */

' =============================================================================
' Include files
' =============================================================================

'/****************************************************************************
'*                                                                           *
'* windef.h -- Basic Windows Type Definitions                                *
'*                                                                           *
'* Copyright (c) Microsoft Corporation. All rights reserved.                 *
'*                                                                           *
'****************************************************************************/

#IF NOT %DEF(%WINDEF_INC)
    %WINDEF_INC = 1

'#ifndef NO_STRICT
'#ifndef STRICT
'#define STRICT 1
'#endif
'#endif /* NO_STRICT */

'// Win32 defines _WIN32 automatically,
'// but Macintosh doesn't, so if we are using
'// Win32 Functions, we must do it here

'#ifdef _MAC
'#ifndef _WIN32
'#define _WIN32
'#endif
'#endif //_MAC

'#ifndef WIN32
'#define WIN32
'#endif

'#ifndef WINVER
'#define WINVER 0x0500
'#endif /* WINVER */

'/*
' * BASETYPES is defined in ntdef.h if these types are already defined
' */

'#ifndef BASETYPES
'#define BASETYPES
'typedef unsigned long ULONG;
'typedef ULONG *PULONG;
'typedef unsigned short USHORT;
'typedef USHORT *PUSHORT;
'typedef unsigned char UCHAR;
'typedef UCHAR *PUCHAR;
'typedef char *PSZ;
'#endif  /* !BASETYPES */

'#define MAX_PATH          260
%MAX_PATH = 260

'#ifndef NULL
'#ifdef __cplusplus
'#define NULL    0
'#else
'#define NULL    ((void *)0)
'#endif
'#endif

%NULL = 0

'#ifndef FALSE
'#define FALSE               0
'#endif

%FALSE = 0

'#ifndef TRUE
'#define TRUE                1
'#endif

%TRUE = 1

'#ifndef IN
'#define IN
'#endif

'#ifndef OUT
'#define OUT
'#endif

'#ifndef OPTIONAL
'#define OPTIONAL
'#endif

'#undef far
'#undef near
'#undef pascal

'#define far
'#define near
'#if (!defined(_MAC)) && ((_MSC_VER >= 800) || defined(_STDCALL_SUPPORTED))
'#define pascal __stdcall
'#else
'#define pascal
'#endif

'#if defined(DOSWIN32) || defined(_MAC)
'#define cdecl _cdecl
'#ifndef CDECL
'#define CDECL _cdecl
'#endif
'#else
'#define cdecl
'#ifndef CDECL
'#define CDECL
'#endif
'#endif

'#ifdef _MAC
'#define CALLBACK    PASCAL
'#define WINAPI      CDECL
'#define WINAPIV     CDECL
'#define APIENTRY    WINAPI
'#define APIPRIVATE  CDECL
'#ifdef _68K_
'#define PASCAL      __pascal
'#else
'#define PASCAL
'#endif
'#elif (_MSC_VER >= 800) || defined(_STDCALL_SUPPORTED)
'#define CALLBACK    __stdcall
'#define WINAPI      __stdcall
'#define WINAPIV     __cdecl
'#define APIENTRY    WINAPI
'#define APIPRIVATE  __stdcall
'#define PASCAL      __stdcall
'#else
'#define CALLBACK
'#define WINAPI
'#define WINAPIV
'#define APIENTRY    WINAPI
'#define APIPRIVATE
'#define PASCAL      pascal
'#endif

'#ifdef _M_CEE_PURE
'#define WINAPI_INLINE  __clrcall
'#else
'#define WINAPI_INLINE  WINAPI
'#endif

'#undef FAR
'#undef  NEAR
'#define FAR                 far
'#define NEAR                near
'#ifndef CONST
'#define %              const
'#endif

'typedef unsigned long       DWORD;
'typedef int                 BOOL;
'typedef unsigned char       BYTE;
'typedef unsigned short      WORD;
'typedef float               FLOAT;
'typedef FLOAT               *PFLOAT;
'typedef BOOL near           *PBOOL;
'typedef BOOL far            *LPBOOL;
'typedef BYTE near           *PBYTE;
'typedef BYTE far            *LPBYTE;
'typedef int near            *PINT;
'typedef int far             *LPINT;
'typedef WORD near           *PWORD;
'typedef WORD far            *LPWORD;
'typedef long far            *LPLONG;
'typedef DWORD near          *PDWORD;
'typedef DWORD far           *LPDWORD;
'typedef void far            *LPVOID;
'typedef %void far      *LPCVOID;

'//
'//  File System time stamps are represented with the following structure:
'//

#IF NOT %DEF(%FILETIME_DEFINED)
%FILETIME_DEFINED = 1
TYPE FILETIME
   dwLowDateTime  AS DWORD   ' DWORD
   dwHighDateTime AS DWORD   ' DWORD
END TYPE
#ENDIF

'#ifndef NT_INCLUDED
'#include <winnt.h>
'#endif /* NT_INCLUDED */

'/*++ BUILD Version: 0066     Increment this if a change has global effects

'Copyright (c) Microsoft Corporation. All rights reserved.

'Module Name:

'    winnt.h

'Abstract:

'    This module defines the 32-Bit Windows types and constants that are
'    defined by NT, but exposed through the Win32 API.

'Revision History:

'--*/

#IF NOT %DEF(%WINNT_INC)
    %WINNT_INC = 1

'/***
'*ctype.h - character conversion macros and ctype macros
'*
'*       Copyright (c) 1985-2001, Microsoft Corporation. All rights reserved.
'*
'*Purpose:
'*       Defines macros for character classification/conversion.
'*       [ANSI/System V]
'*
'*       [Public]
'*
'****/

#IF NOT %DEF(%CTYPE_INC)
    %CTYPE_INC = 1

'typedef unsigned short wchar_t;
'typedef unsigned short wint_t;
'typedef unsigned short wctype_t;

#IF NOT %DEF(%WEOF)
'#define WEOF (wint_t)(0xFFFF)
%WEOF = &HFFFF??
#ENDIF

'/* set bit masks for the possible character types */

'#define _UPPER          0x1     /* upper case letter */
'#define _LOWER          0x2     /* lower case letter */
'#define _DIGIT          0x4     /* digit[0-9] */
'#define _SPACE          0x8     /* tab, carriage return, newline, */
'                                /* vertical tab or form feed */
'#define _PUNCT          0x10    /* punctuation character */
'#define _CONTROL        0x20    /* control character */
'#define _BLANK          0x40    /* space char */
'#define _HEX            0x80    /* hexadecimal digit */

'#define _LEADBYTE       0x8000                  /* multibyte leadbyte */
'#define _ALPHA          (0x0100|_UPPER|_LOWER)  /* alphabetic character */

%UPPER_          = &H1&    ' /* upper case letter */
%LOWER_          = &H2&    ' /* lower case letter */
%DIGIT_          = &H4&    ' /* digit[0-9] */
%SPACE_          = &H8&    ' /* tab, carriage return, newline, */
                           ' /* vertical tab or form feed */
%PUNCT_          = &H10&   ' /* punctuation character */
%CONTROL_        = &H20&   ' /* control character */
%BLANK_          = &H40&   ' /* space char */
%HEX_            = &H80&   ' /* hexadecimal digit */

%LEADBYTE_       = &H8000&                         ' /* multibyte leadbyte */
%ALPHA_          = &H0100& OR %UPPER_ OR %LOWER_   ' /* alphabetic character */


'/* character classification function prototypes */

#IF NOT %DEF(%CTYPE_DEFINED)
    %CTYPE_DEFINED = 1

DECLARE FUNCTION isctype_ CDECL LIB "msvcrt.dll" ALIAS "_isctype" (_
   BYVAL LONG _                             ' int c
 , BYVAL LONG _                             ' _ctype_t desc
 ) AS LONG                                  ' int

DECLARE FUNCTION isalpha CDECL LIB "msvcrt.dll" ALIAS "isalpha" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION isupper CDECL LIB "msvcrt.dll" ALIAS "isupper" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION islower CDECL LIB "msvcrt.dll" ALIAS "islower" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION isdigit CDECL LIB "msvcrt.dll" ALIAS "isdigit" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION isxdigit CDECL LIB "msvcrt.dll" ALIAS "isxdigit" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION isspace CDECL LIB "msvcrt.dll" ALIAS "isspace" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION ispunct CDECL LIB "msvcrt.dll" ALIAS "ispunct" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION isalnum CDECL LIB "msvcrt.dll" ALIAS "isalnum" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION isprint CDECL LIB "msvcrt.dll" ALIAS "isprint" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION isgraph CDECL LIB "msvcrt.dll" ALIAS "isgraph" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION iscntrl CDECL LIB "msvcrt.dll" ALIAS "iscntrl" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION toupper CDECL LIB "msvcrt.dll" ALIAS "toupper" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION toupper_ CDECL LIB "msvcrt.dll" ALIAS "_toupper" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION tolower CDECL LIB "msvcrt.dll" ALIAS "tolower" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION tolower_ CDECL LIB "msvcrt.dll" ALIAS "_tolower" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION isascii__ CDECL LIB "msvcrt.dll" ALIAS "__isascii" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION toascii__ CDECL LIB "msvcrt.dll" ALIAS "__toascii" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION iscsymf__ CDECL LIB "msvcrt.dll" ALIAS "__iscsymf" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION iscsym__ CDECL LIB "msvcrt.dll" ALIAS "__iscsym" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

#ENDIF   ' #IF NOT %DEF(%CTYPE_DEFINED)

#IF NOT %DEF(%WCTYPE_DEFINED)
    %WCTYPE_DEFINED = 1

'/* wide function prototypes, also declared in wchar.h  */

'/* character classification function prototypes */

DECLARE FUNCTION iswalpha CDECL LIB "msvcrt.dll" ALIAS "iswalpha" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswupper CDECL LIB "msvcrt.dll" ALIAS "iswupper" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswlower CDECL LIB "msvcrt.dll" ALIAS "iswlower" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswdigit CDECL LIB "msvcrt.dll" ALIAS "iswdigit" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswxdigit CDECL LIB "msvcrt.dll" ALIAS "iswxdigit" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswspace CDECL LIB "msvcrt.dll" ALIAS "iswspace" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswpunct CDECL LIB "msvcrt.dll" ALIAS "iswpunct" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswalnum CDECL LIB "msvcrt.dll" ALIAS "iswalnum" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswprint CDECL LIB "msvcrt.dll" ALIAS "iswprint" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswgraph CDECL LIB "msvcrt.dll" ALIAS "iswgraph" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswcntrl CDECL LIB "msvcrt.dll" ALIAS "iswcntrl" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswascii CDECL LIB "msvcrt.dll" ALIAS "iswascii" ( _
   BYVAL WORD _                             ' wint_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION isleadbyte CDECL LIB "msvcrt.dll" ALIAS "isleadbyte" ( _
   BYVAL LONG _                             ' int c
 ) AS LONG                                  ' int

DECLARE FUNCTION towupper CDECL LIB "msvcrt.dll" ALIAS "towupper" ( _
   BYVAL WORD _                             ' wchar_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION towlower CDECL LIB "msvcrt.dll" ALIAS "towlower" ( _
   BYVAL WORD _                             ' wchar_t c
 ) AS LONG                                  ' int

DECLARE FUNCTION iswctype CDECL LIB "msvcrt.dll" ALIAS "iswctype" ( _
   BYVAL WORD _                             ' wint_t c
 , BYVAL WORD _                             ' wctype_t desc
 ) AS LONG                                  ' int

'/* --------- The following functions are OBSOLETE --------- */
'_CRTIMP int __cdecl is_wctype(wint_t, wctype_t);
'DECLARE FUNCTION is_wctype CDECL LIB "msvcrt.dll" ALIAS "is_wctype" ( _
'   BYVAL WORD _                             ' wint_t c
' ) AS LONG                                  ' int
'/*  --------- The preceding functions are OBSOLETE --------- */

#ENDIF   ' #IF NOT %DEF(%WCTYPE_DEFINED)

#ENDIF   ' #IF NOT %DEF(%CTYPE_INC)


'#define ANYSIZE_ARRAY 1
%ANYSIZE_ARRAY = 1

%MAX_NATURAL_ALIGNMENT = 4   ' SIZEOF(DWORD)

%APPLICATION_ERROR_MASK       = &H20000000???
%ERROR_SEVERITY_SUCCESS       = &H00000000???
%ERROR_SEVERITY_INFORMATIONAL = &H40000000???
'%ERROR_SEVERITY_WARNING       = &H80000000???
'%ERROR_SEVERITY_ERROR         = &HC0000000???

'//
'// _M_IX86 included so that EM CONTEXT structure compiles with
'// x86 programs. *** TBD should this be for all architectures?
'//

'//
'// 16 byte aligned type for 128 bit floats
'//

'//
'// For we define a 128 bit structure and use __declspec(align(16)) pragma to
'// align to 128 bits.
'//

'#if defined(_M_IA64) && !defined(MIDL_PASS)
'__declspec(align(16))
'#endif
'typedef struct _FLOAT128 {
'    __int64 LowPart;
'    __int64 HighPart;
'} FLOAT128;

'typedef FLOAT128 *PFLOAT128;

TYPE FLOAT128
  LowPart  AS QUAD   ' __int64 LowPart
  HighPart AS QUAD   ' __int64 HighPart
END TYPE


'//
'// __int64 is only supported by 2.0 and later midl.
'// __midl is set by the 2.0 midl and not by 1.0 midl.
'//

%MAXLONGLONG                     = &H7fffffffffffffff&&

#IF NOT %DEF(%LUID_DEFINED)
%LUID_DEFINED = 1
TYPE LUID
  LowPart  AS DWORD
  HighPart AS LONG
END TYPE
#ENDIF

'#define _DWORDLONG_
'typedef ULONGLONG  DWORDLONG;
'typedef DWORDLONG *PDWORDLONG;

'#define ANSI_NULL ((CHAR)0)
'#define UNICODE_NULL ((WCHAR)0)
'#define UNICODE_STRING_MAX_BYTES ((WORD  ) 65534)
'#define UNICODE_STRING_MAX_CHARS (32767)
'typedef BYTE  BOOLEAN;
'typedef BOOLEAN *PBOOLEAN;

%ANSI_NULL = 0?
%UNICODE_NULL = 0??
%UNICODE_STRING_MAX_BYTES = 65534??
%UNICODE_STRING_MAX_CHARS = 32767??

'//
'//  Doubly linked list structure.  Can be used as either a list head, or
'//  as link words.
'//

TYPE LIST_ENTRY
   Flink AS LIST_ENTRY PTR   ' struct _LIST_ENTRY *Flink
   Blink AS LIST_ENTRY PTR   ' struct _LIST_ENTRY *Blink
END TYPE

'//
'//  Singly linked list structure. Can be used as either a list head, or
'//  as link words.
'//

TYPE SINGLE_LIST_ENTRY
   Next AS SINGLE_LIST_ENTRY PTR   ' struct _SINGLE_LIST_ENTRY *Next
END TYPE


#IF NOT %DEF(%OBJECTID_DEFINED) '----------------------------------------------
TYPE OBJECTID   ' // size is 20
   Lineage    AS GUID
   Uniquifier AS DWORD
END TYPE
%OBJECTID_DEFINED = 1
#ENDIF ' #IF NOT %DEF(%OBJECTID_DEFINED) --------------------------------------

%MINCHAR  = &H80?
%MAXCHAR  = &H7F?
%MINSHORT = &H8000%
%MAXSHORT = &H7FFF%
%MINLONG  = &H80000000&
%MAXLONG  = &H7FFFFFFF&
%MAXBYTE  = &HFF?
%MAXWORD  = &HFFFF??
%MAXDWORD = &HFFFFFFFF???

'%VER_SERVER_NT                      = &H80000000???
%VER_WORKSTATION_NT                 = &H40000000???
%VER_SUITE_SMALLBUSINESS            = &H00000001???
%VER_SUITE_ENTERPRISE               = &H00000002???
%VER_SUITE_BACKOFFICE               = &H00000004???
%VER_SUITE_COMMUNICATIONS           = &H00000008???
%VER_SUITE_TERMINAL                 = &H00000010???
%VER_SUITE_SMALLBUSINESS_RESTRICTED = &H00000020???
%VER_SUITE_EMBEDDEDNT               = &H00000040???
%VER_SUITE_DATACENTER               = &H00000080???
%VER_SUITE_SINGLEUSERTS             = &H00000100???
%VER_SUITE_PERSONAL                 = &H00000200???
%VER_SUITE_BLADE                    = &H00000400???
%VER_SUITE_EMBEDDED_RESTRICTED      = &H00000800???
%VER_SUITE_SECURITY_APPLIANCE       = &H00001000???
%VER_SUITE_STORAGE_SERVER           = &H00002000???
%VER_SUITE_COMPUTE_SERVER           = &H00004000???

'//
'// Product types
'// This list grows with each OS release.
'//
'// There is no ordering of values to ensure callers
'// do an equality test i.e. greater-than and less-than
'// comparisons are not useful.
'//
'// NOTE: Values in this list should never be deleted.
'//       When a product-type 'X' gets dropped from a
'//       OS release onwards, the value of 'X' continues
'//       to be used in the mapping table of GetProductInfo.
'//

%PRODUCT_UNDEFINED                       = &H00000000???

%PRODUCT_ULTIMATE                        = &H00000001???
%PRODUCT_HOME_BASIC                      = &H00000002???
%PRODUCT_HOME_PREMIUM                    = &H00000003???
%PRODUCT_ENTERPRISE                      = &H00000004???
%PRODUCT_HOME_BASIC_N                    = &H00000005???
%PRODUCT_BUSINESS                        = &H00000006???
%PRODUCT_STANDARD_SERVER                 = &H00000007???
%PRODUCT_DATACENTER_SERVER               = &H00000008???
%PRODUCT_SMALLBUSINESS_SERVER            = &H00000009???
%PRODUCT_ENTERPRISE_SERVER               = &H0000000A???
%PRODUCT_STARTER                         = &H0000000B???
%PRODUCT_DATACENTER_SERVER_CORE          = &H0000000C???
%PRODUCT_STANDARD_SERVER_CORE            = &H0000000D???
%PRODUCT_ENTERPRISE_SERVER_CORE          = &H0000000E???
%PRODUCT_ENTERPRISE_SERVER_IA64          = &H0000000F???
%PRODUCT_BUSINESS_N                      = &H00000010???
%PRODUCT_WEB_SERVER                      = &H00000011???
%PRODUCT_CLUSTER_SERVER                  = &H00000012???
%PRODUCT_HOME_SERVER                     = &H00000013???
%PRODUCT_STORAGE_EXPRESS_SERVER          = &H00000014???
%PRODUCT_STORAGE_STANDARD_SERVER         = &H00000015???
%PRODUCT_STORAGE_WORKGROUP_SERVER        = &H00000016???
%PRODUCT_STORAGE_ENTERPRISE_SERVER       = &H00000017???
%PRODUCT_SERVER_FOR_SMALLBUSINESS        = &H00000018???
%PRODUCT_SMALLBUSINESS_SERVER_PREMIUM    = &H00000019???

%PRODUCT_UNLICENSED                      = &HABCDABCD???

'#include <sdkddkver.h

'//
'//  Language IDs.
'//
'//  The following two combinations of primary language ID and
'//  sublanguage ID have special semantics:
'//
'//    Primary Language ID   Sublanguage ID      Result
'//    -------------------   ---------------     ------------------------
'//    LANG_NEUTRAL          SUBLANG_NEUTRAL     Language neutral
'//    LANG_NEUTRAL          SUBLANG_DEFAULT     User default language
'//    LANG_NEUTRAL          SUBLANG_SYS_DEFAULT System default language
'//    LANG_INVARIANT        SUBLANG_NEUTRAL     Invariant locale
'//

'//
'//  Primary language IDs.
'//

%LANG_NEUTRAL                     = &H00??
%LANG_INVARIANT                   = &H7f??

%LANG_AFRIKAANS                   = &H36??
%LANG_ALBANIAN                    = &H1c??
%LANG_ALSATIAN                    = &H84??
%LANG_AMHARIC                     = &H5e??
%LANG_ARABIC                      = &H01??
%LANG_ARMENIAN                    = &H2b??
%LANG_ASSAMESE                    = &H4d??
%LANG_AZERI                       = &H2c??
%LANG_BASHKIR                     = &H6d??
%LANG_BASQUE                      = &H2d??
%LANG_BELARUSIAN                  = &H23??
%LANG_BENGALI                     = &H45??
%LANG_BRETON                      = &H7e??
%LANG_BOSNIAN                     = &H1a??   ' // Use with SUBLANG_BOSNIAN_* Sublanguage IDs
%LANG_BOSNIAN_NEUTRAL             = &H781a?? '  // Use with the ConvertDefaultLocale function
%LANG_BULGARIAN                   = &H02??
%LANG_CATALAN                     = &H03??
%LANG_CHINESE                     = &H04??
%LANG_CHINESE_SIMPLIFIED          = &H04??   ' // Use with the ConvertDefaultLocale function
%LANG_CHINESE_TRADITIONAL         = &H7c04?? ' // Use with the ConvertDefaultLocale function
%LANG_CORSICAN                    = &H83??
%LANG_CROATIAN                    = &H1a??
%LANG_CZECH                       = &H05??
%LANG_DANISH                      = &H06??
%LANG_DARI                        = &H8c??
%LANG_DIVEHI                      = &H65??
%LANG_DUTCH                       = &H13??
%LANG_ENGLISH                     = &H09??
%LANG_ESTONIAN                    = &H25??
%LANG_FAEROESE                    = &H38??
%LANG_FARSI                       = &H29??   ' // Deprecated: use LANG_PERSIAN instead
%LANG_FILIPINO                    = &H64??
%LANG_FINNISH                     = &H0b??
%LANG_FRENCH                      = &H0c??
%LANG_FRISIAN                     = &H62??
%LANG_GALICIAN                    = &H56??
%LANG_GEORGIAN                    = &H37??
%LANG_GERMAN                      = &H07??
%LANG_GREEK                       = &H08??
%LANG_GREENLANDIC                 = &H6f??
%LANG_GUJARATI                    = &H47??
%LANG_HAUSA                       = &H68??
%LANG_HEBREW                      = &H0d??
%LANG_HINDI                       = &H39??
%LANG_HUNGARIAN                   = &H0e??
%LANG_ICELANDIC                   = &H0f??
%LANG_IGBO                        = &H70??
%LANG_INDONESIAN                  = &H21??
%LANG_INUKTITUT                   = &H5d??
%LANG_IRISH                       = &H3c??  ' // Use with the SUBLANG_IRISH_IRELAND Sublanguage ID
%LANG_ITALIAN                     = &H10??
%LANG_JAPANESE                    = &H11??
%LANG_KANNADA                     = &H4b??
%LANG_KASHMIRI                    = &H60??
%LANG_KAZAK                       = &H3f??
%LANG_KHMER                       = &H53??
%LANG_KICHE                       = &H86??
%LANG_KINYARWANDA                 = &H87??
%LANG_KONKANI                     = &H57??
%LANG_KOREAN                      = &H12??
%LANG_KYRGYZ                      = &H40??
%LANG_LAO                         = &H54??
%LANG_LATVIAN                     = &H26??
%LANG_LITHUANIAN                  = &H27??
%LANG_LOWER_SORBIAN               = &H2e??
%LANG_LUXEMBOURGISH               = &H6e??
%LANG_MACEDONIAN                  = &H2f??   ' the Former Yugoslav Republic of Macedonia
%LANG_MALAY                       = &H3e??
%LANG_MALAYALAM                   = &H4c??
%LANG_MANIPURI                    = &H58??
%LANG_MAORI                       = &H81??
%LANG_MAPUDUNGUN                  = &H7a??
%LANG_MARATHI                     = &H4e??
%LANG_MOHAWK                      = &H7c??
%LANG_MONGOLIAN                   = &H50??
%LANG_NEPALI                      = &H61??
%LANG_NORWEGIAN                   = &H14??
%LANG_OCCITAN                     = &H82??
%LANG_ORIYA                       = &H48??
%LANG_PASHTO                      = &H63??
%LANG_PERSIAN                     = &H29??
%LANG_POLISH                      = &H15??
%LANG_PORTUGUESE                  = &H16??
%LANG_PUNJABI                     = &H46??
%LANG_QUECHUA                     = &H6b??
%LANG_ROMANIAN                    = &H18??
%LANG_ROMANSH                     = &H17??
%LANG_RUSSIAN                     = &H19??
%LANG_SAMI                        = &H3b??
%LANG_SANSKRIT                    = &H4f??
%LANG_SERBIAN                     = &H1a??
%LANG_SERBIAN_NEUTRAL             = &H7c1a   ' // Use with the ConvertDefaultLocale function
%LANG_SINDHI                      = &H59??
%LANG_SINHALESE                   = &H5b??
%LANG_SLOVAK                      = &H1b??
%LANG_SLOVENIAN                   = &H24??
%LANG_SOTHO                       = &H6c??
%LANG_SPANISH                     = &H0a??
%LANG_SWAHILI                     = &H41??
%LANG_SWEDISH                     = &H1d??
%LANG_SYRIAC                      = &H5a??
%LANG_TAJIK                       = &H28??
%LANG_TAMAZIGHT                   = &H5f??
%LANG_TAMIL                       = &H49??
%LANG_TATAR                       = &H44??
%LANG_TELUGU                      = &H4a??
%LANG_THAI                        = &H1e??
%LANG_TIBETAN                     = &H51??
%LANG_TIGRIGNA                    = &H73??
%LANG_TSWANA                      = &H32??
%LANG_TURKISH                     = &H1f??
%LANG_TURKMEN                     = &H42??
%LANG_UIGHUR                      = &H80??
%LANG_UKRAINIAN                   = &H22??
%LANG_UPPER_SORBIAN               = &H2e??
%LANG_URDU                        = &H20??
%LANG_UZBEK                       = &H43??
%LANG_VIETNAMESE                  = &H2a??
%LANG_WELSH                       = &H52??
%LANG_WOLOF                       = &H88??
%LANG_XHOSA                       = &H34??
%LANG_YAKUT                       = &H85??
%LANG_YI                          = &H78??
%LANG_YORUBA                      = &H6a??
%LANG_ZULU                        = &H35??

'//
'//  Sublanguage IDs.
'//
'//  The name immediately following SUBLANG_ dictates which primary
'//  language ID that sublanguage ID can be combined with to form a
'//  valid language ID.
'//

%SUBLANG_NEUTRAL                  = &H00??  ' // language neutral
%SUBLANG_DEFAULT                  = &H01??  ' // user default
%SUBLANG_SYS_DEFAULT              = &H02??  ' // system default
%SUBLANG_CUSTOM_DEFAULT           = &H03??  ' // default custom language/locale
%SUBLANG_CUSTOM_UNSPECIFIED       = &H04??  ' // custom language/locale
%SUBLANG_UI_CUSTOM_DEFAULT        = &H05??  ' // Default custom MUI language/locale

%SUBLANG_AFRIKAANS_SOUTH_AFRICA              = &H01??   ' // Afrikaans (South Africa) = &H0436 af-ZA
%SUBLANG_ALBANIAN_ALBANIA                    = &H01??   ' // Albanian (Albania) = &H041c sq-AL
%SUBLANG_ALSATIAN_FRANCE                     = &H01??   ' // Alsatian (France) = &H0484
%SUBLANG_AMHARIC_ETHIOPIA                    = &H01??   ' // Amharic (Ethiopia) = &H045e
%SUBLANG_ARABIC_SAUDI_ARABIA                 = &H01??   ' // Arabic (Saudi Arabia)
%SUBLANG_ARABIC_IRAQ                         = &H02??   ' // Arabic (Iraq)
%SUBLANG_ARABIC_EGYPT                        = &H03??   ' // Arabic (Egypt)
%SUBLANG_ARABIC_LIBYA                        = &H04??   ' // Arabic (Libya)
%SUBLANG_ARABIC_ALGERIA                      = &H05??   ' // Arabic (Algeria)
%SUBLANG_ARABIC_MOROCCO                      = &H06??   ' // Arabic (Morocco)
%SUBLANG_ARABIC_TUNISIA                      = &H07??   ' // Arabic (Tunisia)
%SUBLANG_ARABIC_OMAN                         = &H08??   ' // Arabic (Oman)
%SUBLANG_ARABIC_YEMEN                        = &H09??   ' // Arabic (Yemen)
%SUBLANG_ARABIC_SYRIA                        = &H0a??   ' // Arabic (Syria)
%SUBLANG_ARABIC_JORDAN                       = &H0b??   ' // Arabic (Jordan)
%SUBLANG_ARABIC_LEBANON                      = &H0c??   ' // Arabic (Lebanon)
%SUBLANG_ARABIC_KUWAIT                       = &H0d??   ' // Arabic (Kuwait)
%SUBLANG_ARABIC_UAE                          = &H0e??   ' // Arabic (U.A.E)
%SUBLANG_ARABIC_BAHRAIN                      = &H0f??   ' // Arabic (Bahrain)
%SUBLANG_ARABIC_QATAR                        = &H10??   ' // Arabic (Qatar)
%SUBLANG_ARMENIAN_ARMENIA                    = &H01??   ' // Armenian (Armenia) = &H042b hy-AM
%SUBLANG_ASSAMESE_INDIA                      = &H01??   ' // Assamese (India) = &H044d
%SUBLANG_AZERI_LATIN                         = &H01??   ' // Azeri (Latin)
%SUBLANG_AZERI_CYRILLIC                      = &H02??   ' // Azeri (Cyrillic)
%SUBLANG_BASHKIR_RUSSIA                      = &H01??   ' // Bashkir (Russia) = &H046d ba-RU
%SUBLANG_BASQUE_BASQUE                       = &H01??   ' // Basque (Basque) = &H042d eu-ES
%SUBLANG_BELARUSIAN_BELARUS                  = &H01??   ' // Belarusian (Belarus) = &H0423 be-BY
%SUBLANG_BENGALI_INDIA                       = &H01??   ' // Bengali (India)
%SUBLANG_BENGALI_BANGLADESH                  = &H02??   ' // Bengali (Bangladesh)
%SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN    = &H05??   ' // Bosnian (Bosnia and Herzegovina - Latin) = &H141a bs-BA-Latn
%SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC = &H08??   ' // Bosnian (Bosnia and Herzegovina - Cyrillic) = &H201a bs-BA-Cyrl
%SUBLANG_BRETON_FRANCE                       = &H01??   ' // Breton (France) = &H047e
%SUBLANG_BULGARIAN_BULGARIA                  = &H01??   ' // Bulgarian (Bulgaria) = &H0402
%SUBLANG_CATALAN_CATALAN                     = &H01??   ' // Catalan (Catalan) = &H0403
%SUBLANG_CHINESE_TRADITIONAL                 = &H01??   ' // Chinese (Taiwan Region)
%SUBLANG_CHINESE_SIMPLIFIED                  = &H02??   ' // Chinese (PR China)
%SUBLANG_CHINESE_HONGKONG                    = &H03??   ' // Chinese (Hong Kong)
%SUBLANG_CHINESE_SINGAPORE                   = &H04??   ' // Chinese (Singapore)
%SUBLANG_CHINESE_MACAU                       = &H05??   ' // Chinese (Macau)
%SUBLANG_CORSICAN_FRANCE                     = &H01??   ' // Corsican (France) = &H0483
%SUBLANG_CZECH_CZECH_REPUBLIC                = &H01??   ' // Czech (Czech Republic) = &H0405
%SUBLANG_CROATIAN_CROATIA                    = &H01??   ' // Croatian (Croatia)
%SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN   = &H04??   ' // Croatian (Bosnia and Herzegovina - Latin) = &H101a hr-BA
%SUBLANG_DANISH_DENMARK                      = &H01??   ' // Danish (Denmark) = &H0406
%SUBLANG_DARI_AFGHANISTAN                    = &H01??   ' // Dari (Afghanistan)
%SUBLANG_DIVEHI_MALDIVES                     = &H01??   ' // Divehi (Maldives) = &H0465 div-MV
%SUBLANG_DUTCH                               = &H01??   ' // Dutch
%SUBLANG_DUTCH_BELGIAN                       = &H02??   ' // Dutch (Belgian)
%SUBLANG_ENGLISH_US                          = &H01??   ' // English (USA)
%SUBLANG_ENGLISH_UK                          = &H02??   ' // English (UK)
%SUBLANG_ENGLISH_AUS                         = &H03??   ' // English (Australian)
%SUBLANG_ENGLISH_CAN                         = &H04??   ' // English (Canadian)
%SUBLANG_ENGLISH_NZ                          = &H05??   ' // English (New Zealand)
%SUBLANG_ENGLISH_EIRE                        = &H06??   ' // English (Irish)
%SUBLANG_ENGLISH_SOUTH_AFRICA                = &H07??   ' // English (South Africa)
%SUBLANG_ENGLISH_JAMAICA                     = &H08??   ' // English (Jamaica)
%SUBLANG_ENGLISH_CARIBBEAN                   = &H09??   ' // English (Caribbean)
%SUBLANG_ENGLISH_BELIZE                      = &H0a??   ' // English (Belize)
%SUBLANG_ENGLISH_TRINIDAD                    = &H0b??   ' // English (Trinidad)
%SUBLANG_ENGLISH_ZIMBABWE                    = &H0c??   ' // English (Zimbabwe)
%SUBLANG_ENGLISH_PHILIPPINES                 = &H0d??   ' // English (Philippines)
%SUBLANG_ENGLISH_INDIA                       = &H10??   ' // English (India)
%SUBLANG_ENGLISH_MALAYSIA                    = &H11??   ' // English (Malaysia)
%SUBLANG_ENGLISH_SINGAPORE                   = &H12??   ' // English (Singapore)
%SUBLANG_ESTONIAN_ESTONIA                    = &H01??   ' // Estonian (Estonia) = &H0425 et-EE
%SUBLANG_FAEROESE_FAROE_ISLANDS              = &H01??   ' // Faroese (Faroe Islands) = &H0438 fo-FO
%SUBLANG_FILIPINO_PHILIPPINES                = &H01??   ' // Filipino (Philippines) = &H0464 fil-PH
%SUBLANG_FINNISH_FINLAND                     = &H01??   ' // Finnish (Finland) = &H040b
%SUBLANG_FRENCH                              = &H01??   ' // French
%SUBLANG_FRENCH_BELGIAN                      = &H02??   ' // French (Belgian)
%SUBLANG_FRENCH_CANADIAN                     = &H03??   ' // French (Canadian)
%SUBLANG_FRENCH_SWISS                        = &H04??   ' // French (Swiss)
%SUBLANG_FRENCH_LUXEMBOURG                   = &H05??   ' // French (Luxembourg)
%SUBLANG_FRENCH_MONACO                       = &H06??   ' // French (Monaco)
%SUBLANG_FRISIAN_NETHERLANDS                 = &H01??   ' // Frisian (Netherlands) = &H0462 fy-NL
%SUBLANG_GALICIAN_GALICIAN                   = &H01??   ' // Galician (Galician) = &H0456 gl-ES
%SUBLANG_GEORGIAN_GEORGIA                    = &H01??   ' // Georgian (Georgia) = &H0437 ka-GE
%SUBLANG_GERMAN                              = &H01??   ' // German
%SUBLANG_GERMAN_SWISS                        = &H02??   ' // German (Swiss)
%SUBLANG_GERMAN_AUSTRIAN                     = &H03??   ' // German (Austrian)
%SUBLANG_GERMAN_LUXEMBOURG                   = &H04??   ' // German (Luxembourg)
%SUBLANG_GERMAN_LIECHTENSTEIN                = &H05??   ' // German (Liechtenstein)
%SUBLANG_GREEK_GREECE                        = &H01??   ' // Greek (Greece)
%SUBLANG_GREENLANDIC_GREENLAND               = &H01??   ' // Greenlandic (Greenland) = &H046f kl-GL
%SUBLANG_GUJARATI_INDIA                      = &H01??   ' // Gujarati (India (Gujarati Script)) = &H0447 gu-IN
%SUBLANG_HAUSA_NIGERIA_LATIN                 = &H01??   ' // Hausa (Latin, Nigeria) = &H0468 ha-NG-Latn
%SUBLANG_HEBREW_ISRAEL                       = &H01??   ' // Hebrew (Israel) = &H040d
%SUBLANG_HINDI_INDIA                         = &H01??   ' // Hindi (India) = &H0439 hi-IN
%SUBLANG_HUNGARIAN_HUNGARY                   = &H01??   ' // Hungarian (Hungary) = &H040e
%SUBLANG_ICELANDIC_ICELAND                   = &H01??   ' // Icelandic (Iceland) = &H040f
%SUBLANG_IGBO_NIGERIA                        = &H01??   ' // Igbo (Nigeria) = &H0470 ig-NG
%SUBLANG_INDONESIAN_INDONESIA                = &H01??   ' // Indonesian (Indonesia) = &H0421 id-ID
%SUBLANG_INUKTITUT_CANADA                    = &H01??   ' // Inuktitut (Syllabics) (Canada) = &H045d iu-CA-Cans
%SUBLANG_INUKTITUT_CANADA_LATIN              = &H02??   ' // Inuktitut (Canada - Latin)
%SUBLANG_IRISH_IRELAND                       = &H02??   ' // Irish (Ireland)
%SUBLANG_ITALIAN                             = &H01??   ' // Italian
%SUBLANG_ITALIAN_SWISS                       = &H02??   ' // Italian (Swiss)
%SUBLANG_JAPANESE_JAPAN                      = &H01??   ' // Japanese (Japan) = &H0411
%SUBLANG_KANNADA_INDIA                       = &H01??   ' // Kannada (India (Kannada Script)) = &H044b kn-IN
%SUBLANG_KASHMIRI_SASIA                      = &H02??   ' // Kashmiri (South Asia)
%SUBLANG_KASHMIRI_INDIA                      = &H02??   ' // Kashmiri (India)
%SUBLANG_KASHMIRI_SASIA                      = &H02??   ' // Kashmiri (South Asia)
%SUBLANG_KASHMIRI_INDIA                      = &H02??   ' // For app compatibility only
%SUBLANG_KAZAK_KAZAKHSTAN                    = &H01??   ' // Kazakh (Kazakhstan) = &H043f kk-KZ
%SUBLANG_KHMER_CAMBODIA                      = &H01??   ' // Khmer (Cambodia) = &H0453 kh-KH
%SUBLANG_KICHE_GUATEMALA                     = &H01??   ' // K' //iche (Guatemala)
%SUBLANG_KINYARWANDA_RWANDA                  = &H01??   ' // Kinyarwanda (Rwanda) = &H0487 rw-RW
%SUBLANG_KONKANI_INDIA                       = &H01??   ' // Konkani (India) = &H0457 kok-IN
%SUBLANG_KOREAN                              = &H01??   ' // Korean (Extended Wansung)
%SUBLANG_KYRGYZ_KYRGYZSTAN                   = &H01??   ' // Kyrgyz (Kyrgyzstan) = &H0440 ky-KG
%SUBLANG_LAO_LAO                             = &H01??   ' // Lao (Lao PDR) = &H0454 lo-LA
%SUBLANG_LATVIAN_LATVIA                      = &H01??   ' // Latvian (Latvia) = &H0426 lv-LV
%SUBLANG_LITHUANIAN                          = &H01??   ' // Lithuanian
' //%SUBLANG_LITHUANIAN_CLASSIC       = &H02??  ' // Lithuanian (Classic)  Not in Vista SDK
%SUBLANG_LOWER_SORBIAN_GERMANY               = &H02??   ' // Lower Sorbian (Germany) = &H082e wee-DE
%SUBLANG_LUXEMBOURGISH_LUXEMBOURG            = &H01??   ' // Luxembourgish (Luxembourg) = &H046e lb-LU
%SUBLANG_MACEDONIAN_MACEDONIA                = &H01??   ' // Macedonian (Macedonia (FYROM)) = &H042f mk-MK
%SUBLANG_MALAY_MALAYSIA                      = &H01??   ' // Malay (Malaysia)
%SUBLANG_MALAY_BRUNEI_DARUSSALAM             = &H02??   ' // Malay (Brunei Darussalam)
%SUBLANG_MALAYALAM_INDIA                     = &H01??   ' // Malayalam (India (Malayalam Script) ) = &H044c ml-IN
%SUBLANG_MALTESE_MALTA                       = &H01??   ' // Maltese (Malta) = &H043a mt-MT
%SUBLANG_MAORI_NEW_ZEALAND                   = &H01??   ' // Maori (New Zealand) = &H0481 mi-NZ
%SUBLANG_MAPUDUNGUN_CHILE                    = &H01??   ' // Mapudungun (Chile) = &H047a arn-CL
%SUBLANG_MARATHI_INDIA                       = &H01??   ' // Marathi (India) = &H044e mr-IN
%SUBLANG_MOHAWK_MOHAWK                       = &H01??   ' // Mohawk (Mohawk) = &H047c moh-CA
%SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA         = &H01??   ' // Mongolian (Cyrillic, Mongolia)
%SUBLANG_MONGOLIAN_PRC                       = &H02??   ' // Mongolian (PRC)
%SUBLANG_NEPALI_INDIA                        = &H02??   ' // Nepali (India)
%SUBLANG_NEPALI_NEPAL                        = &H01??   ' // Nepali (Nepal) = &H0461 ne-NP
%SUBLANG_NORWEGIAN_BOKMAL                    = &H01??   ' // Norwegian (Bokmal)
%SUBLANG_NORWEGIAN_NYNORSK                   = &H02??   ' // Norwegian (Nynorsk)
%SUBLANG_OCCITAN_FRANCE                      = &H01??   ' // Occitan (France) = &H0482 oc-FR
%SUBLANG_ORIYA_INDIA                         = &H01??   ' // Oriya (India (Oriya Script)) = &H0448 or-IN
%SUBLANG_PASHTO_AFGHANISTAN                  = &H01??   ' // Pashto (Afghanistan)
%SUBLANG_PERSIAN_IRAN                        = &H01??   ' // Persian (Iran) = &H0429 fa-IR
%SUBLANG_POLISH_POLAND                       = &H01??   ' // Polish (Poland) = &H0415
%SUBLANG_PORTUGUESE                          = &H02??   ' // Portuguese
%SUBLANG_PORTUGUESE_BRAZILIAN                = &H01??   ' // Portuguese (Brazilian)
%SUBLANG_PUNJABI_INDIA                       = &H01??   ' // Punjabi (India (Gurmukhi Script)) = &H0446 pa-IN
%SUBLANG_QUECHUA_BOLIVIA                     = &H01??   ' // Quechua (Bolivia)
%SUBLANG_QUECHUA_ECUADOR                     = &H02??   ' // Quechua (Ecuador)
%SUBLANG_QUECHUA_PERU                        = &H03??   ' // Quechua (Peru)
%SUBLANG_ROMANIAN_ROMANIA                    = &H01??   ' // Romanian (Romania) = &H0418
%SUBLANG_ROMANSH_SWITZERLAND                 = &H01??   ' // Romansh (Switzerland) = &H0417 rm-CH
%SUBLANG_RUSSIAN_RUSSIA                      = &H01??   ' // Russian (Russia) = &H0419
%SUBLANG_SAMI_NORTHERN_NORWAY                = &H01??   ' // Northern Sami (Norway)
%SUBLANG_SAMI_NORTHERN_SWEDEN                = &H02??   ' // Northern Sami (Sweden)
%SUBLANG_SAMI_NORTHERN_FINLAND               = &H03??   ' // Northern Sami (Finland)
%SUBLANG_SAMI_LULE_NORWAY                    = &H04??   ' // Lule Sami (Norway)
%SUBLANG_SAMI_LULE_SWEDEN                    = &H05??   ' // Lule Sami (Sweden)
%SUBLANG_SAMI_SOUTHERN_NORWAY                = &H06??   ' // Southern Sami (Norway)
%SUBLANG_SAMI_SOUTHERN_SWEDEN                = &H07??   ' // Southern Sami (Sweden)
%SUBLANG_SAMI_SKOLT_FINLAND                  = &H08??   ' // Skolt Sami (Finland)
%SUBLANG_SAMI_INARI_FINLAND                  = &H09??   ' // Inari Sami (Finland)
%SUBLANG_SANSKRIT_INDIA                      = &H01??   ' // Sanskrit (India) = &H044f sa-IN
%SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN    = &H06??   ' // Serbian (Bosnia and Herzegovina - Latin)
%SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC = &H07??   ' // Serbian (Bosnia and Herzegovina - Cyrillic)
%SUBLANG_SERBIAN_CROATIA                     = &H01??   ' // Croatian (Croatia) = &H041a hr-HR
%SUBLANG_SERBIAN_LATIN                       = &H02??   ' // Serbian (Latin)
%SUBLANG_SERBIAN_CYRILLIC                    = &H03??   ' // Serbian (Cyrillic)
%SUBLANG_SINDHI_INDIA                        = &H01??   ' // Sindhi (India) reserved = &H0459
%SUBLANG_SINDHI_PAKISTAN                     = &H02??   ' // Sindhi (Pakistan) reserved = &H0859
%SUBLANG_SINDHI_AFGHANISTAN                  = &H02??   ' // For app compatibility only
%SUBLANG_SINHALESE_SRI_LANKA                 = &H01??   ' // Sinhalese (Sri Lanka)
%SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA         = &H01??   ' // Northern Sotho (South Africa)
%SUBLANG_SLOVAK_SLOVAKIA                     = &H01??   ' // Slovak (Slovakia) = &H041b sk-SK
%SUBLANG_SLOVENIAN_SLOVENIA                  = &H01??   ' // Slovenian (Slovenia) = &H0424 sl-SI
%SUBLANG_SPANISH                             = &H01??   ' // Spanish (Castilian)
%SUBLANG_SPANISH_MEXICAN                     = &H02??   ' // Spanish (Mexican)
%SUBLANG_SPANISH_MODERN                      = &H03??   ' // Spanish (Modern)
%SUBLANG_SPANISH_GUATEMALA                   = &H04??   ' // Spanish (Guatemala)
%SUBLANG_SPANISH_COSTA_RICA                  = &H05??   ' // Spanish (Costa Rica)
%SUBLANG_SPANISH_PANAMA                      = &H06??   ' // Spanish (Panama)
%SUBLANG_SPANISH_DOMINICAN_REPUBLIC          = &H07??   ' // Spanish (Dominican Republic)
%SUBLANG_SPANISH_VENEZUELA                   = &H08??   ' // Spanish (Venezuela)
%SUBLANG_SPANISH_COLOMBIA                    = &H09??   ' // Spanish (Colombia)
%SUBLANG_SPANISH_PERU                        = &H0a??   ' // Spanish (Peru)
%SUBLANG_SPANISH_ARGENTINA                   = &H0b??   ' // Spanish (Argentina)
%SUBLANG_SPANISH_ECUADOR                     = &H0c??   ' // Spanish (Ecuador)
%SUBLANG_SPANISH_CHILE                       = &H0d??   ' // Spanish (Chile)
%SUBLANG_SPANISH_URUGUAY                     = &H0e??   ' // Spanish (Uruguay)
%SUBLANG_SPANISH_PARAGUAY                    = &H0f??   ' // Spanish (Paraguay)
%SUBLANG_SPANISH_BOLIVIA                     = &H10??   ' // Spanish (Bolivia)
%SUBLANG_SPANISH_EL_SALVADOR                 = &H11??   ' // Spanish (El Salvador)
%SUBLANG_SPANISH_HONDURAS                    = &H12??   ' // Spanish (Honduras)
%SUBLANG_SPANISH_NICARAGUA                   = &H13??   ' // Spanish (Nicaragua)
%SUBLANG_SPANISH_PUERTO_RICO                 = &H14??   ' // Spanish (Puerto Rico)
%SUBLANG_SPANISH_US                          = &H15??   ' // Spanish (United States)
%SUBLANG_SWAHILI_KENYA                       = &H01??   ' // Swahili (Kenya) = &H0441 sw-KE
%SUBLANG_SWEDISH                             = &H01??   ' // Swedish
%SUBLANG_SWEDISH_FINLAND                     = &H02??   ' // Swedish (Finland)
%SUBLANG_SYRIAC_SYRIA                        = &H01??   ' // Syriac (Syria) = &H045a syr-SY
%SUBLANG_TAJIK_TAJIKISTAN                    = &H01??   ' // Tajik (Tajikistan) = &H0428 tg-TJ-Cyrl
%SUBLANG_TAMAZIGHT_ALGERIA_LATIN             = &H02??   ' // Tamazight (Latin, Algeria) = &H085f tmz-DZ-Latn
%SUBLANG_TAMIL_INDIA                         = &H01??   ' // Tamil (India)
%SUBLANG_TATAR_RUSSIA                        = &H01??   ' // Tatar (Russia) = &H0444 tt-RU
%SUBLANG_TELUGU_INDIA                        = &H01??   ' // Telugu (India (Telugu Script)) = &H044a te-IN
%SUBLANG_THAI_THAILAND                       = &H01??   ' // Thai (Thailand) = &H041e th-TH
%SUBLANG_TIBETAN_PRC                         = &H01??   ' // Tibetan (PRC)
%SUBLANG_TIGRIGNA_ERITREA                    = &H02??   ' // Tigrigna (Eritrea)
%SUBLANG_TSWANA_SOUTH_AFRICA                 = &H01??   ' // Setswana / Tswana (South Africa) = &H0432 tn-ZA
%SUBLANG_TURKISH_TURKEY                      = &H01??   ' // Turkish (Turkey) = &H041f tr-TR
%SUBLANG_TURKMEN_TURKMENISTAN                = &H01??   ' // Turkmen (Turkmenistan) = &H0442 tk-TM
%SUBLANG_UIGHUR_PRC                          = &H01??   ' // Uighur (PRC) = &H0480 ug-CN
%SUBLANG_UKRAINIAN_UKRAINE                   = &H01??   ' // Ukrainian (Ukraine) = &H0422 uk-UA
%SUBLANG_UPPER_SORBIAN_GERMANY               = &H01??   ' // Upper Sorbian (Germany) = &H042e wen-DE
%SUBLANG_URDU_PAKISTAN                       = &H01??   ' // Urdu (Pakistan)
%SUBLANG_URDU_INDIA                          = &H02??   ' // Urdu (India)
%SUBLANG_UZBEK_LATIN                         = &H01??   ' // Uzbek (Latin)
%SUBLANG_UZBEK_CYRILLIC                      = &H02??   ' // Uzbek (Cyrillic)
%SUBLANG_VIETNAMESE_VIETNAM                  = &H01??   ' // Vietnamese (Vietnam) = &H042a vi-VN
%SUBLANG_WELSH_UNITED_KINGDOM                = &H01??   ' // Welsh (United Kingdom) = &H0452 cy-GB
%SUBLANG_WOLOF_SENEGAL                       = &H01??   ' // Wolof (Senegal)
%SUBLANG_XHOSA_SOUTH_AFRICA                  = &H01??   ' // isiXhosa / Xhosa (South Africa) = &H0434 xh-ZA
%SUBLANG_YAKUT_RUSSIA                        = &H01??   ' // Yakut (Russia) = &H0485 sah-RU
%SUBLANG_YI_PRC                              = &H01??   ' // Yi (PRC)) = &H0478
%SUBLANG_YORUBA_NIGERIA                      = &H01??   ' // Yoruba (Nigeria) 046a yo-NG
%SUBLANG_ZULU_SOUTH_AFRICA                   = &H01??   ' // isiZulu / Zulu (South Africa) = &H0435 zu-ZA

'//
'//  Sorting IDs.
'//

%SORT_DEFAULT                     = &H0??     ' // sorting default

%SORT_INVARIANT_MATH              = &H1??     ' // Invariant (Mathematical Symbols)

%SORT_JAPANESE_XJIS               = &H0??     ' // Japanese XJIS order
%SORT_JAPANESE_UNICODE            = &H1??     ' // Japanese Unicode order
%SORT_JAPANESE_RADICALSTROKE      = &H4??     ' // Japanese radical/stroke order

%SORT_CHINESE_BIG5                = &H0??     ' // Chinese BIG5 order
%SORT_CHINESE_PRCP                = &H0??     ' // PRC Chinese Phonetic order
%SORT_CHINESE_UNICODE             = &H1??     ' // Chinese Unicode order
%SORT_CHINESE_PRC                 = &H2??     ' // PRC Chinese Stroke Count order
%SORT_CHINESE_BOPOMOFO            = &H3??     ' // Traditional Chinese Bopomofo order

%SORT_KOREAN_KSC                  = &H0??     ' // Korean KSC order
%SORT_KOREAN_UNICODE              = &H1??     ' // Korean Unicode order

%SORT_GERMAN_PHONE_BOOK           = &H1??     ' // German Phone Book order

%SORT_HUNGARIAN_DEFAULT           = &H0??     ' // Hungarian Default order
%SORT_HUNGARIAN_TECHNICAL         = &H1??     ' // Hungarian Technical order

%SORT_GEORGIAN_TRADITIONAL        = &H0??     ' // Georgian Traditional order
%SORT_GEORGIAN_MODERN             = &H1??     ' // Georgian Modern order

'//
'//  A language ID is a 16 bit value which is the combination of a
'//  primary language ID and a secondary language ID.  The bits are
'//  allocated as follows:
'//
'//       +-----------------------+-------------------------+
'//       |     Sublanguage ID    |   Primary Language ID   |
'//       +-----------------------+-------------------------+
'//        15                   10 9                       0   bit
'//
'//
'//  Language ID creation/extraction macros:
'//
'//    MAKELANGID    - construct language id from a primary language id and
'//                    a sublanguage id.
'//    PRIMARYLANGID - extract primary language id from a language id.
'//    SUBLANGID     - extract sublanguage id from a language id.
'//

'#define MAKELANGID(p, s)       ((((WORD  )(s)) << 10) | (WORD  )(p))
'#define PRIMARYLANGID(lgid)    ((WORD  )(lgid) & 0x3ff)
'#define SUBLANGID(lgid)        ((WORD  )(lgid) >> 10)

'   FUNCTION MAKELANGID (BYVAL p AS WORD, BYVAL s AS WORD) AS WORD
'      SHIFT LEFT s, 10
'      FUNCTION = s OR p
'   END FUNCTION

'   FUNCTION PRIMARYLANGID (BYVAL lgid AS WORD) AS WORD
'     FUNCTION = lgid AND &H3FF
'   END FUNCTION

'   FUNCTION SUBLANGID (BYVAL lgid AS WORD) AS WORD
'      SHIFT RIGHT lgid, 10
'      FUNCTION = lgid
'   END FUNCTION

'//
'//  A locale ID is a 32 bit value which is the combination of a
'//  language ID, a sort ID, and a reserved area.  The bits are
'//  allocated as follows:
'//
'//       +-------------+---------+-------------------------+
'//       |   Reserved  | Sort ID |      Language ID        |
'//       +-------------+---------+-------------------------+
'//        31         20 19     16 15                      0   bit
'//
'//
'//  Locale ID creation/extraction macros:
'//
'//    MAKELCID            - construct the locale id from a language id and a sort id.
'//    MAKESORTLCID        - construct the locale id from a language id, sort id, and sort version.
'//    LANGIDFROMLCID      - extract the language id from a locale id.
'//    SORTIDFROMLCID      - extract the sort id from a locale id.
'//    SORTVERSIONFROMLCID - extract the sort version from a locale id.
'//

%NLS_VALID_LOCALE_MASK = &H000fffff

'#define MAKELCID(lgid, srtid)  ((DWORD)((((DWORD)((WORD  )(srtid))) << 16) |  \
'                                         ((DWORD)((WORD  )(lgid)))))

'   FUNCTION MAKELCID (BYVAL wLanguageID AS WORD, BYVAL wSortID AS WORD) AS DWORD
'      FUNCTION = MAK(DWORD, wLanguageID, wSortID AND &H000F)
'   END FUNCTION

'#define MAKESORTLCID(lgid, srtid, ver)                                            \
'                               ((DWORD)((MAKELCID(lgid, srtid)) |             \
'                                    (((DWORD)((WORD  )(ver))) << 20)))
'#define LANGIDFROMLCID(lcid)   ((WORD  )(lcid))
'#define SORTIDFROMLCID(lcid)   ((WORD  )((((DWORD)(lcid)) >> 16) & 0xf))
'#define SORTVERSIONFROMLCID(lcid)  ((WORD  )((((DWORD)(lcid)) >> 20) & 0xf))

'   FUNCTION MAKESORTLCID (BYVAL lgid AS WORD, BYVAL srtid AS WORD, BYVAL ver AS WORD) AS DWORD
'      SHIFT LEFT ver, 20
'      FUNCTION = MAKELCID(lgid, srtid) OR ver
'   END FUNCTION

'   FUNCTION LANGIDFROMLCID (BYVAL lcid AS DWORD) AS WORD
'      FUNCTION = CWRD(lcid)
'   END FUNCTION

'   FUNCTION SORTIDFROMLCID (BYVAL lcid AS DWORD) AS WORD
'      SHIFT RIGHT lcid, 16
'      FUNCTION = CWRD(lcid) AND &HF
'   END FUNCTION

'   FUNCTION SORTVERSIONFROMLCID (BYVAL lcid AS DWORD) AS WORD
'      SHIFT RIGHT lcid, 20
'      FUNCTION = CWRD(lcid) AND &HF
'   END FUNCTION

'// 8 characters for language
'// 8 characters for region
'// 64 characters for suffix (script)
'// 2 characters for '-' separators
'// 2 characters for prefix like "i-" or "x-"
'// 1 null termination
%LOCALE_NAME_MAX_LENGTH   = 85

'//
'//  Default System and User IDs for language and locale.
'//

'#define LANG_SYSTEM_DEFAULT    (MAKELANGID(LANG_NEUTRAL, SUBLANG_SYS_DEFAULT))
'#define LANG_USER_DEFAULT      (MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT))

%LANG_SYSTEM_DEFAULT = &H0800???
%LANG_USER_DEFAULT   = &H0400???

'#define LOCALE_SYSTEM_DEFAULT  (MAKELCID(LANG_SYSTEM_DEFAULT, SORT_DEFAULT))
'#define LOCALE_USER_DEFAULT    (MAKELCID(LANG_USER_DEFAULT, SORT_DEFAULT))

%LOCALE_USER_DEFAULT     = &H0400???
%LOCALE_SYSTEM_DEFAULT   = &H0800???

'//
'//  Other special IDs for language and locale.
'//

'#define LOCALE_CUSTOM_DEFAULT                                                 \
'          (MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_CUSTOM_DEFAULT), SORT_DEFAULT))
%LOCALE_CUSTOM_DEFAULT     = &H0C00???

'#define LOCALE_CUSTOM_UNSPECIFIED                                             \
'          (MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_CUSTOM_UNSPECIFIED), SORT_DEFAULT))
%LOCALE_CUSTOM_UNSPECIFIED = &H1000???

'#define LOCALE_CUSTOM_UI_DEFAULT                                              \
'          (MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_UI_CUSTOM_DEFAULT), SORT_DEFAULT))
%LOCALE_CUSTOM_UI_DEFAULT  = &H1400???

'#define LOCALE_NEUTRAL                                                        \
'          (MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_NEUTRAL), SORT_DEFAULT))
%LOCALE_NEUTRAL = 0

'#define LOCALE_INVARIANT                                                      \
'          (MAKELCID(MAKELANGID(LANG_INVARIANT, SUBLANG_NEUTRAL), SORT_DEFAULT))
%LOCALE_INVARIANT = &H007F&

#IF NOT %DEF(%WIN32_NO_STATUS) '-----------------------------------------------
%STATUS_WAIT_0                   = &H00000000&
%STATUS_ABANDONED_WAIT_0         = &H00000080&
%STATUS_USER_APC                 = &H000000C0&
%STATUS_TIMEOUT                  = &H00000102&
%STATUS_PENDING                  = &H00000103&
%DBG_EXCEPTION_HANDLED           = &H00010001&
%DBG_CONTINUE                    = &H00010002&
%STATUS_SEGMENT_NOTIFICATION     = &H40000005&
%DBG_TERMINATE_THREAD            = &H40010003&
%DBG_TERMINATE_PROCESS           = &H40010004&
%DBG_CONTROL_C                   = &H40010005&
%DBG_CONTROL_BREAK               = &H40010008&
%DBG_COMMAND_EXCEPTION           = &H40010009&
%STATUS_GUARD_PAGE_VIOLATION     = &H80000001&
%STATUS_DATATYPE_MISALIGNMENT    = &H80000002&
%STATUS_BREAKPOINT               = &H80000003&
%STATUS_SINGLE_STEP              = &H80000004&
%DBG_EXCEPTION_NOT_HANDLED       = &H80010001&
%STATUS_ACCESS_VIOLATION         = &HC0000005&
%STATUS_IN_PAGE_ERROR            = &HC0000006&
%STATUS_INVALID_HANDLE           = &HC0000008&
%STATUS_NO_MEMORY                = &HC0000017&
%STATUS_ILLEGAL_INSTRUCTION      = &HC000001D&
%STATUS_NONCONTINUABLE_EXCEPTION = &HC0000025&
%STATUS_INVALID_DISPOSITION      = &HC0000026&
%STATUS_ARRAY_BOUNDS_EXCEEDED    = &HC000008C&
%STATUS_FLOAT_DENORMAL_OPERAND   = &HC000008D&
%STATUS_FLOAT_DIVIDE_BY_ZERO     = &HC000008E&
%STATUS_FLOAT_INEXACT_RESULT     = &HC000008F&
%STATUS_FLOAT_INVALID_OPERATION  = &HC0000090&
%STATUS_FLOAT_OVERFLOW           = &HC0000091&
%STATUS_FLOAT_STACK_CHECK        = &HC0000092&
%STATUS_FLOAT_UNDERFLOW          = &HC0000093&
%STATUS_INTEGER_DIVIDE_BY_ZERO   = &HC0000094&
%STATUS_INTEGER_OVERFLOW         = &HC0000095&
%STATUS_PRIVILEGED_INSTRUCTION   = &HC0000096&
%STATUS_STACK_OVERFLOW           = &HC00000FD&
%STATUS_CONTROL_C_EXIT           = &HC000013A&
%STATUS_FLOAT_MULTIPLE_FAULTS    = &HC00002B4&
%STATUS_FLOAT_MULTIPLE_TRAPS     = &HC00002B5&
%STATUS_ILLEGAL_VLM_REFERENCE    = &HC00002C0&   ' Not in Vista SDK
%STATUS_REG_NAT_CONSUMPTION      = &HC00002C9&
'#if defined(STATUS_SUCCESS) || (_WIN32_WINNT > 0x0500) || (_WIN32_FUSION >= 0x0100)
%STATUS_SXS_EARLY_DEACTIVATION   = &HC015000F&
%STATUS_SXS_INVALID_DEACTIVATION = &HC0150010&
'#endif

#ENDIF ' #IF NOT %DEF(%WIN32_NO_STATUS) ---------------------------------------

%MAXIMUM_WAIT_OBJECTS = 64  ' Maximum number of wait objects
%MAXIMUM_SUSPEND_COUNT = %MAXCHAR  ' Maximum times thread can be suspended

'typedef ULONG_PTR KSPIN_LOCK;
'typedef KSPIN_LOCK *PKSPIN_LOCK;

'//
'// The following values specify the type of failing access when the status is
'// STATUS_ACCESS_VIOLATION and the first parameter in the execpetion record.
'//

%EXCEPTION_READ_FAULT         = 0   ' // Access violation was caused by a read
%EXCEPTION_WRITE_FAULT        = 1   ' // Access violation was caused by a write
%EXCEPTION_EXECUTE_FAULT      = 8   ' // Access violation was caused by an instruction fetch

'// begin_wx86

'//
'//  Define the size of the 80387 save area, which is in the context frame.
'//

%SIZE_OF_80387_REGISTERS = 80

'//
'// The following flags control the contents of the CONTEXT structure.
'//

'#if !defined(RC_INVOKED)

%CONTEXT_i386            = &H00010000???    ' this assumes that i386 and
%CONTEXT_i486            = &H00010000???    ' i486 have identical context records

'// end_wx86

%CONTEXT_CONTROL         = %CONTEXT_i386 OR &H00000001??? ' SS:SP, CS:IP, FLAGS, BP
%CONTEXT_INTEGER         = %CONTEXT_i386 OR &H00000002??? ' AX, BX, CX, DX, SI, DI
%CONTEXT_SEGMENTS        = %CONTEXT_i386 OR &H00000004??? ' DS, ES, FS, GS
%CONTEXT_FLOATING_POINT  = %CONTEXT_i386 OR &H00000008??? ' 387 state
%CONTEXT_DEBUG_REGISTERS = %CONTEXT_i386 OR &H00000010??? ' DB 0-3,6,7
%CONTEXT_EXTENDED_REGISTERS = %CONTEXT_i386 OR &H00000020???  ' // cpu specific extensions

%CONTEXT_FULL            = %CONTEXT_CONTROL OR %CONTEXT_INTEGER OR %CONTEXT_SEGMENTS

%CONTEXT_ALL = %CONTEXT_CONTROL OR %CONTEXT_INTEGER OR %CONTEXT_SEGMENTS OR %CONTEXT_FLOATING_POINT OR %CONTEXT_DEBUG_REGISTERS OR %CONTEXT_EXTENDED_REGISTERS

'// begin_wx86

'#endif

%MAXIMUM_SUPPORTED_EXTENSION = 512

TYPE FLOATING_SAVE_AREA
   ControlWord   AS DWORD
   StatusWord    AS DWORD
   TagWord       AS DWORD
   ErrorOffset   AS DWORD
   ErrorSelector AS DWORD
   DataOffset    AS DWORD
   DataSelector  AS DWORD
   RegisterArea(%SIZE_OF_80387_REGISTERS - 1) AS BYTE
   Cr0NpxState   AS DWORD
END TYPE

'//
'// Context Frame
'//
'//  This frame has a several purposes: 1) it is used as an argument to
'//  NtContinue, 2) is is used to constuct a call frame for APC delivery,
'//  and 3) it is used in the user level thread creation routines.
'//
'//  The layout of the record conforms to a standard call frame.
'//

TYPE CONTEXT
   ContextFlags AS DWORD
   Dr0          AS DWORD
   Dr1          AS DWORD
   Dr2          AS DWORD
   Dr3          AS DWORD
   Dr6          AS DWORD
   Dr7          AS DWORD
   FloatSave    AS FLOATING_SAVE_AREA
   SegGs        AS DWORD
   SegFs        AS DWORD
   SegEs        AS DWORD
   SegDs        AS DWORD
   Edi          AS DWORD
   Esi          AS DWORD
   Ebx          AS DWORD
   Edx          AS DWORD
   Ecx          AS DWORD
   Eax          AS DWORD
   Ebp          AS DWORD
   Eip          AS DWORD
   SegCs        AS DWORD                ' MUST BE SANITIZED
   EFlags       AS DWORD                ' MUST BE SANITIZED
   Esp          AS DWORD
   segSs        AS DWORD
END TYPE

'// begin_ntminiport

'#endif //_X86_


'#ifndef _LDT_ENTRY_DEFINED
'#define _LDT_ENTRY_DEFINED

'typedef struct _LDT_ENTRY {
'    WORD    LimitLow;
'    WORD    BaseLow;
'    union {
'        struct {
'            BYTE    BaseMid;
'            BYTE    Flags1;     // Declare as bytes to avoid alignment
'            BYTE    Flags2;     // Problems.
'            BYTE    BaseHi;
'        } Bytes;
'        struct {
'            DWORD   BaseMid : 8;
'            DWORD   Type : 5;
'            DWORD   Dpl : 2;
'            DWORD   Pres : 1;
'            DWORD   LimitHi : 4;
'            DWORD   Sys : 1;
'            DWORD   Reserved_0 : 1;
'            DWORD   Default_Big : 1;
'            DWORD   Granularity : 1;
'            DWORD   BaseHi : 8;
'        } Bits;
'    } HighWord;
'} LDT_ENTRY, *PLDT_ENTRY;

'#endif

#IF NOT %DEF(%LDT_ENTRY_DEFINED) '---------------------------------------------
TYPE LDT_BYTES
   BaseMid AS BYTE
   Flags1  AS BYTE    ' // Declare as bytes to avoid alignment
   Flags2  AS BYTE    ' // Problems.
   BaseHi  AS BYTE
END TYPE

TYPE LDT_BITS
   BaseMid     AS BIT * 8 IN DWORD
   Type        AS BIT * 5
   Dpl         AS BIT * 2
   Pres        AS BIT * 1
   LimitHi     AS BIT * 4
   Sys         AS BIT * 1
   Reserved_0  AS BIT * 1
   Default_Big AS BIT * 1
   Granularity AS BIT * 1
   BaseHi      AS BIT * 8
END TYPE

UNION LDT_ENTRY_UNION
   Bytes AS LDT_BYTES
   Bits  AS LDT_BITS
END UNION

TYPE LDT_ENTRY
   LimitLow AS INTEGER
   BaseLow  AS INTEGER
   LDT_ENTRY_UNION
END TYPE
#ENDIF ' #IF NOT %DEF(%LDT_ENTRY_DEFINED) -------------------------------------

%WOW64_CONTEXT_i386      = &H00010000???   ' // this assumes that i386 and
%WOW64_CONTEXT_i486      = &H00010000???   ' // i486 have identical context records

%WOW64_CONTEXT_CONTROL            = %WOW64_CONTEXT_i386 OR &H00000001??? ' // SS:SP, CS:IP, FLAGS, BP
%WOW64_CONTEXT_INTEGER            = %WOW64_CONTEXT_i386 OR &H00000002??? ' // AX, BX, CX, DX, SI, DI
%WOW64_CONTEXT_SEGMENTS           = %WOW64_CONTEXT_i386 OR &H00000004??? ' // DS, ES, FS, GS
%WOW64_CONTEXT_FLOATING_POINT     = %WOW64_CONTEXT_i386 OR &H00000008??? ' // 387 state
%WOW64_CONTEXT_DEBUG_REGISTERS    = %WOW64_CONTEXT_i386 OR &H00000010??? ' // DB 0-3,6,7
%WOW64_CONTEXT_EXTENDED_REGISTERS = %WOW64_CONTEXT_i386 OR &H00000020??? ' // cpu specific extensions

%WOW64_CONTEXT_FULL = %WOW64_CONTEXT_CONTROL OR %WOW64_CONTEXT_INTEGER OR %WOW64_CONTEXT_SEGMENTS

%WOW64_CONTEXT_ALL  = %WOW64_CONTEXT_CONTROL OR %WOW64_CONTEXT_INTEGER OR %WOW64_CONTEXT_SEGMENTS OR _
                      %WOW64_CONTEXT_FLOATING_POINT OR %WOW64_CONTEXT_DEBUG_REGISTERS OR _
                      %WOW64_CONTEXT_EXTENDED_REGISTERS

'//
'//  Define the size of the 80387 save area, which is in the context frame.
'//

%WOW64_SIZE_OF_80387_REGISTERS     = 80

%WOW64_MAXIMUM_SUPPORTED_EXTENSION = 512

TYPE WOW64_FLOATING_SAVE_AREA
   ControlWord   AS DWORD   ' DWORD
   StatusWord    AS DWORD   ' DWORD
   TagWord       AS DWORD   ' DWORD
   ErrorOffset   AS DWORD   ' DWORD
   ErrorSelector AS DWORD   ' DWORD
   DataOffset    AS DWORD   ' DWORD
   DataSelector  AS DWORD   ' DWORD
   RegisterArea(%WOW64_SIZE_OF_80387_REGISTERS - 1) AS BYTE   ' BYTE
   Cr0NpxState   AS DWORD   ' DWORD
END TYPE

'//
'// Context Frame
'//
'//  This frame has a several purposes: 1) it is used as an argument to
'//  NtContinue, 2) is is used to constuct a call frame for APC delivery,
'//  and 3) it is used in the user level thread creation routines.
'//
'//  The layout of the record conforms to a standard call frame.
'//

TYPE WOW64_CONTEXT
   ContextFlags AS DWORD   ' DWORD
   Dr0          AS DWORD   ' DWORD
   Dr1          AS DWORD   ' DWORD
   Dr2          AS DWORD   ' DWORD
   Dr3          AS DWORD   ' DWORD
   Dr6          AS DWORD   ' DWORD
   Dr7          AS DWORD   ' DWORD
   FloatSave    AS WOW64_FLOATING_SAVE_AREA
   SegGs        AS DWORD   ' DWORD
   SegFs        AS DWORD   ' DWORD
   SegEs        AS DWORD   ' DWORD
   SegDs        AS DWORD   ' DWORD
   Edi          AS DWORD   ' DWORD
   Esi          AS DWORD   ' DWORD
   Ebx          AS DWORD   ' DWORD
   Edx          AS DWORD   ' DWORD
   Ecx          AS DWORD   ' DWORD
   Eax          AS DWORD   ' DWORD
   Ebp          AS DWORD   ' DWORD
   Eip          AS DWORD   ' DWORD
   SegCs        AS DWORD   ' DWORD             ' // MUST BE SANITIZED
   EFlags       AS DWORD   ' DWORD            ' // MUST BE SANITIZED
   Esp          AS DWORD   ' DWORD
   SegSs        AS DWORD   ' DWORD
   ExtendedRegisters(%WOW64_MAXIMUM_SUPPORTED_EXTENSION - 1) AS BYTE   ' BYTE
END TYPE

%EXCEPTION_NONCONTINUABLE     = &H1  ' Noncontinuable exception
%EXCEPTION_MAXIMUM_PARAMETERS = 15   ' maximum number of exception parameters

'//
'// Exception record definition.
'//

TYPE EXCEPTION_RECORD
   ExceptionCode    AS DWORD
   ExceptionFlags   AS DWORD
   pExceptionRecord AS EXCEPTION_RECORD PTR
   ExceptionAddress AS DWORD
   NumberParameters AS DWORD
   ExceptionInformation(%EXCEPTION_MAXIMUM_PARAMETERS - 1) AS DWORD
END TYPE

TYPE EXCEPTION_RECORD32
   ExceptionCode    AS DWORD
   ExceptionFlags   AS DWORD
   pExceptionRecord AS DWORD
   ExceptionAddress AS DWORD
   NumberParameters AS DWORD
   ExceptionInformation(%EXCEPTION_MAXIMUM_PARAMETERS - 1) AS DWORD
END TYPE

TYPE EXCEPTION_RECORD64
   ExceptionCode    AS DWORD
   ExceptionFlags   AS DWORD
   pExceptionRecord AS QUAD
   ExceptionAddress AS QUAD
   NumberParameters AS DWORD
   ExceptionInformation(%EXCEPTION_MAXIMUM_PARAMETERS - 1) AS QUAD
END TYPE

'//
'// Typedef for pointer returned by exception_info()
'//

'typedef struct _EXCEPTION_POINTERS {
'    PEXCEPTION_RECORD ExceptionRecord;
'    PCONTEXT ContextRecord;
'} EXCEPTION_POINTERS, *PEXCEPTION_POINTERS;
'typedef PVOID PACCESS_TOKEN;
'typedef PVOID PSECURITY_DESCRIPTOR;
'typedef PVOID PSID;

TYPE EXCEPTION_POINTERS
   pExceptionRecord AS EXCEPTION_RECORD PTR
   ContextRecord    AS CONTEXT PTR
END TYPE
'typedef PVOID PACCESS_TOKEN;
'typedef PVOID PSECURITY_DESCRIPTOR;
'typedef PVOID PSID;

'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//                             ACCESS MASK                            //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////

'//
'//  Define the access mask as a longword sized structure divided up as
'//  follows:
'//
'//       3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
'//       1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
'//      +---------------+---------------+-------------------------------+
'//      |G|G|G|G|Res'd|A| StandardRights|         SpecificRights        |
'//      |R|W|E|A|     |S|               |                               |
'//      +-+-------------+---------------+-------------------------------+
'//
'//      typedef struct _ACCESS_MASK {
'//          WORD   SpecificRights;
'//          BYTE  StandardRights;
'//          BYTE  AccessSystemAcl : 1;
'//          BYTE  Reserved : 3;
'//          BYTE  GenericAll : 1;
'//          BYTE  GenericExecute : 1;
'//          BYTE  GenericWrite : 1;
'//          BYTE  GenericRead : 1;
'//      } ACCESS_MASK;
'//      typedef ACCESS_MASK *PACCESS_MASK;
'//
'//  but to make life simple for programmer's we'll allow them to specify
'//  a desired access mask by simply OR'ing together mulitple single rights
'//  and treat an access mask as a DWORD.  For example
'//
'//      DesiredAccess = DELETE | READ_CONTROL
'//
'//  So we'll declare ACCESS_MASK as DWORD
'//

'typedef DWORD ACCESS_MASK;
'typedef ACCESS_MASK *PACCESS_MASK;


'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//                             ACCESS TYPES                           //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////


'//
'//  The following are masks for the predefined standard access types
'//

%DELETE                   = &H00010000???
%READ_CONTROL             = &H00020000???
%WRITE_DAC                = &H00040000???
%WRITE_OWNER              = &H00080000???
%SYNCHRONIZE              = &H00100000???

%STANDARD_RIGHTS_REQUIRED = &H000F0000???

%STANDARD_RIGHTS_READ     = %READ_CONTROL
%STANDARD_RIGHTS_WRITE    = %READ_CONTROL
%STANDARD_RIGHTS_EXECUTE  = %READ_CONTROL

%STANDARD_RIGHTS_ALL      = &H001F0000???

%SPECIFIC_RIGHTS_ALL      = &H0000FFFF???

'//
'// AccessSystemAcl access type
'//

%ACCESS_SYSTEM_SECURITY   = &H01000000???

'//
'// MaximumAllowed access type
'//

%MAXIMUM_ALLOWED          = &H02000000???

'//
'//  These are the generic rights.
'//

%GENERIC_READ             = &H80000000???
%GENERIC_WRITE            = &H40000000???
%GENERIC_EXECUTE          = &H20000000???
%GENERIC_ALL              = &H10000000???

'//
'//  Define the generic mapping array.  This is used to denote the
'//  mapping of each generic access right to a specific access mask.
'//

TYPE GENERIC_MAPPING
   GenericRead    AS DWORD   ' ACCESS_MASK
   GenericWrite   AS DWORD   ' ACCESS_MASK
   GenericExecute AS DWORD   ' ACCESS_MASK
   GenericAll     AS DWORD   ' ACCESS_MASK
END TYPE


'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//                        LUID_AND_ATTRIBUTES                         //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////
'//
'//


'#include <pshpack4.h>

'typedef struct _LUID_AND_ATTRIBUTES {
'    LUID Luid;
'    DWORD Attributes;
'    } LUID_AND_ATTRIBUTES, * PLUID_AND_ATTRIBUTES;
'typedef LUID_AND_ATTRIBUTES LUID_AND_ATTRIBUTES_ARRAY[ANYSIZE_ARRAY];
'typedef LUID_AND_ATTRIBUTES_ARRAY *PLUID_AND_ATTRIBUTES_ARRAY;

TYPE LUID_AND_ATTRIBUTES
   pLuid      AS LUID
   Attributes AS DWORD
END TYPE

'#include <poppack.h>

'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//              Security Id     (SID)                                 //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////
'//
'//
'// Pictorially the structure of an SID is as follows:
'//
'//         1   1   1   1   1   1
'//         5   4   3   2   1   0   9   8   7   6   5   4   3   2   1   0
'//      +---------------------------------------------------------------+
'//      |      SubAuthorityCount        |Reserved1 (SBZ)|   Revision    |
'//      +---------------------------------------------------------------+
'//      |                   IdentifierAuthority[0]                      |
'//      +---------------------------------------------------------------+
'//      |                   IdentifierAuthority[1]                      |
'//      +---------------------------------------------------------------+
'//      |                   IdentifierAuthority[2]                      |
'//      +---------------------------------------------------------------+
'//      |                                                               |
'//      +- -  -  -  -  -  -  -  SubAuthority[]  -  -  -  -  -  -  -  - -+
'//      |                                                               |
'//      +---------------------------------------------------------------+
'//
'//

'#ifndef SID_IDENTIFIER_AUTHORITY_DEFINED
'#define SID_IDENTIFIER_AUTHORITY_DEFINED
'typedef struct _SID_IDENTIFIER_AUTHORITY {
'    BYTE  Value[6];
'} SID_IDENTIFIER_AUTHORITY, *PSID_IDENTIFIER_AUTHORITY;
'#endif

' Note: Value is declared as Value(0 TO 5) in PB's WIN32API.INC,
' but declaring it as STRING * 6 allows to use CHR$(x, x, x, x, x, x)
' and also to assign to it predefined constants.
#IF NOT %DEF(%SID_IDENTIFIER_AUTHORITY_DEFINED)
%SID_IDENTIFIER_AUTHORITY_DEFINED = 1
TYPE SID_IDENTIFIER_AUTHORITY
   Value AS STRING * 6
END TYPE
#ENDIF

%SID_REVISION                    = 1     ' Current revision level
%SID_MAX_SUB_AUTHORITIES         = 15
%SID_RECOMMENDED_SUB_AUTHORITIES = 1     ' Will change to around 6 in a future release.

'#ifndef MIDL_PASS
'#define SECURITY_MAX_SID_SIZE  \
'      (sizeof(SID) - sizeof(DWORD) + (SID_MAX_SUB_AUTHORITIES * sizeof(DWORD)))
'#endif // MIDL_PASS

' SID_NAME_USE enum
%SidTypeUser           = 1
%SidTypeGroup          = 2
%SidTypeDomain         = 3
%SidTypeAlias          = 4
%SidTypeWellKnownGroup = 5
%SidTypeDeletedaccount = 6
%SidTypeInvalid        = 7
%SidTypeUnknown        = 8
%SidTypeComputer       = 9

%SID_HASH_SIZE = 32
'typedef ULONG_PTR SID_HASH_ENTRY, *PSID_HASH_ENTRY;

TYPE SID_AND_ATTRIBUTES_HASH
   SidCount AS DWORD   ' DWORD
   SidAttr  AS SID_AND_ATTRIBUTES PTR   ' PSID_AND_ATTRIBUTES
   Hash(%SID_HASH_SIZE - 1) AS DWORD    ' SID_HASH_ENTRY
END TYPE

'/////////////////////////////////////////////////////////////////////////////
'//                                                                         //
'// Universal well-known SIDs                                               //
'//                                                                         //
'//     Null SID                     S-1-0-0                                //
'//     World                        S-1-1-0                                //
'//     Local                        S-1-2-0                                //
'//     Creator Owner ID             S-1-3-0                                //
'//     Creator Group ID             S-1-3-1                                //
'//     Creator Owner Server ID      S-1-3-2                                //
'//     Creator Group Server ID      S-1-3-3                                //
'//                                                                         //
'//     (Non-unique IDs)             S-1-4                                  //
'//                                                                         //
'/////////////////////////////////////////////////////////////////////////////

'#define SECURITY_NULL_SID_AUTHORITY         {0,0,0,0,0,0}
'#define SECURITY_WORLD_SID_AUTHORITY        {0,0,0,0,0,1}
'#define SECURITY_LOCAL_SID_AUTHORITY        {0,0,0,0,0,2}
'#define SECURITY_CREATOR_SID_AUTHORITY      {0,0,0,0,0,3}
'#define SECURITY_NON_UNIQUE_AUTHORITY       {0,0,0,0,0,4}
'#define SECURITY_RESOURCE_MANAGER_AUTHORITY {0,0,0,0,0,9}

$SECURITY_NULL_SID_AUTHORITY         = CHR$(0,0,0,0,0,0)
$SECURITY_WORLD_SID_AUTHORITY        = CHR$(0,0,0,0,0,1)
$SECURITY_LOCAL_SID_AUTHORITY        = CHR$(0,0,0,0,0,2)
$SECURITY_CREATOR_SID_AUTHORITY      = CHR$(0,0,0,0,0,3)
$SECURITY_NON_UNIQUE_AUTHORITY       = CHR$(0,0,0,0,0,4)
$SECURITY_RESOURCE_MANAGER_AUTHORITY = CHR$(0,0,0,0,0,9)

%SECURITY_NULL_RID                 = &H00000000???
%SECURITY_WORLD_RID                = &H00000000???
%SECURITY_LOCAL_RID                = &H00000000???

%SECURITY_CREATOR_OWNER_RID        = &H00000000???
%SECURITY_CREATOR_GROUP_RID        = &H00000001???

%SECURITY_CREATOR_OWNER_SERVER_RID = &H00000002???
%SECURITY_CREATOR_GROUP_SERVER_RID = &H00000003???
%SECURITY_CREATOR_OWNER_RIGHTS_RID = &H00000004???


'///////////////////////////////////////////////////////////////////////////////
'//                                                                           //
'// NT well-known SIDs                                                        //
'//                                                                           //
'//     NT Authority            S-1-5                                         //
'//     Dialup                  S-1-5-1                                       //
'//                                                                           //
'//     Network                 S-1-5-2                                       //
'//     Batch                   S-1-5-3                                       //
'//     Interactive             S-1-5-4                                       //
'//     (Logon IDs)             S-1-5-5-X-Y                                   //
'//     Service                 S-1-5-6                                       //
'//     AnonymousLogon          S-1-5-7       (aka null logon session)        //
'//     Proxy                   S-1-5-8                                       //
'//     Enterprise DC (EDC)     S-1-5-9       (aka domain controller account) //
'//     Self                    S-1-5-10      (self RID)                      //
'//     Authenticated User      S-1-5-11      (Authenticated user somewhere)  //
'//     Restricted Code         S-1-5-12      (Running restricted code)       //
'//     Terminal Server         S-1-5-13      (Running on Terminal Server)    //
'//     Remote Logon            S-1-5-14      (Remote Interactive Logon)      //
'//     This Organization       S-1-5-15                                      //
'//                                                                           //
'//     Local System            S-1-5-18                                      //
'//     Local Service           S-1-5-19                                      //
'//     Network Service         S-1-5-20                                      //
'//                                                                           //
'//     (NT non-unique IDs)     S-1-5-0x15-... (NT Domain Sids)               //
'//                                                                           //
'//     (Built-in domain)       S-1-5-0x20                                    //
'//                                                                           //
'//     (Security Package IDs)  S-1-5-0x40                                    //
'//     NTLM Authentication     S-1-5-0x40-10                                 //
'//     SChannel Authentication S-1-5-0x40-14                                 //
'//     Digest Authentication   S-1-5-0x40-21                                 //
'//                                                                           //
'//     Other Organization      S-1-5-1000    (>=1000 can not be filtered)    //
'//                                                                           //
'//                                                                           //
'// NOTE: the relative identifier values (RIDs) determine which security      //
'//       boundaries the SID is allowed to cross.  Before adding new RIDs,    //
'//       a determination needs to be made regarding which range they should  //
'//       be added to in order to ensure proper "SID filtering"               //
'//                                                                           //
'///////////////////////////////////////////////////////////////////////////////


'#define SECURITY_NT_AUTHORITY           {0,0,0,0,0,5}   // ntifs
$SECURITY_NT_AUTHORITY                        = CHR$(0,0,0,0,0,5)

%SECURITY_DIALUP_RID                          = &H00000001???
%SECURITY_NETWORK_RID                         = &H00000002???
%SECURITY_BATCH_RID                           = &H00000003???
%SECURITY_INTERACTIVE_RID                     = &H00000004???
%SECURITY_LOGON_IDS_RID                       = &H00000005???
%SECURITY_LOGON_IDS_RID_COUNT                 = &H3???
%SECURITY_SERVICE_RID                         = &H00000006???
%SECURITY_ANONYMOUS_LOGON_RID                 = &H00000007???
%SECURITY_PROXY_RID                           = &H00000008???
%SECURITY_ENTERPRISE_CONTROLLERS_RID          = &H00000009???
%SECURITY_SERVER_LOGON_RID                    = %SECURITY_ENTERPRISE_CONTROLLERS_RID
%SECURITY_PRINCIPAL_SELF_RID                  = &H0000000A???
%SECURITY_AUTHENTICATED_USER_RID              = &H0000000B???
%SECURITY_RESTRICTED_CODE_RID                 = &H0000000C???
%SECURITY_TERMINAL_SERVER_RID                 = &H0000000D???
%SECURITY_REMOTE_LOGON_RID                    = &H0000000E???
%SECURITY_THIS_ORGANIZATION_RID               = &H0000000F???
%SECURITY_IUSER_RID                           = &H00000011???
%SECURITY_LOCAL_SYSTEM_RID                    = &H00000012???
%SECURITY_LOCAL_SERVICE_RID                   = &H00000013???
%SECURITY_NETWORK_SERVICE_RID                 = &H00000014???

%SECURITY_NT_NON_UNIQUE                       = &H00000015???
%SECURITY_NT_NON_UNIQUE_SUB_AUTH_COUNT        = &H3???

%SECURITY_ENTERPRISE_READONLY_CONTROLLERS_RID = &H00000016???

%SECURITY_BUILTIN_DOMAIN_RID                  = &H00000020???
%SECURITY_WRITE_RESTRICTED_CODE_RID           = &H00000021???


%SECURITY_PACKAGE_BASE_RID                    = &H00000040???
%SECURITY_PACKAGE_RID_COUNT                   = &H2???
%SECURITY_PACKAGE_NTLM_RID                    = &H0000000A???
%SECURITY_PACKAGE_SCHANNEL_RID                = &H0000000E???
%SECURITY_PACKAGE_DIGEST_RID                  = &H00000015???

%SECURITY_SERVICE_ID_BASE_RID                 = &H00000050???
%SECURITY_SERVICE_ID_RID_COUNT                = &H6???

%SECURITY_RESERVED_ID_BASE_RID                = &H00000051???

%SECURITY_MAX_ALWAYS_FILTERED                 = &H000003E7???
%SECURITY_MIN_NEVER_FILTERED                  = &H000003E8???

%SECURITY_OTHER_ORGANIZATION_RID              = &H000003E8???


'/////////////////////////////////////////////////////////////////////////////
'//                                                                         //
'// well-known domain relative sub-authority values (RIDs)...               //
'//                                                                         //
'/////////////////////////////////////////////////////////////////////////////

'// Well-known users ...

%FOREST_USER_RID_MAX                             = &H000001F3???

%DOMAIN_USER_RID_ADMIN                           = &H000001F4???
%DOMAIN_USER_RID_GUEST                           = &H000001F5???
%DOMAIN_USER_RID_KRBTGT                          = &H000001F6???

%DOMAIN_USER_RID_MAX                             = &H000003E7???


'// well-known groups ...

%DOMAIN_GROUP_RID_ADMINS                         = &H00000200???
%DOMAIN_GROUP_RID_USERS                          = &H00000201???
%DOMAIN_GROUP_RID_GUESTS                         = &H00000202???
%DOMAIN_GROUP_RID_COMPUTERS                      = &H00000202???
%DOMAIN_GROUP_RID_CONTROLLERS                    = &H00000202???
%DOMAIN_GROUP_RID_CERT_ADMINS                    = &H00000202???
%DOMAIN_GROUP_RID_SCHEMA_ADMINS                  = &H00000202???
%DOMAIN_GROUP_RID_ENTERPRISE_ADMINS              = &H00000207???
%DOMAIN_GROUP_RID_POLICY_ADMINS                  = &H00000208???
%DOMAIN_GROUP_RID_READONLY_CONTROLLERS           = &H00000209???

'// well-known aliases ...

%DOMAIN_ALIAS_RID_ADMINS                         = &H00000220???
%DOMAIN_ALIAS_RID_USERS                          = &H00000221???
%DOMAIN_ALIAS_RID_GUESTS                         = &H00000222???
%DOMAIN_ALIAS_RID_POWER_USERS                    = &H00000223???

%DOMAIN_ALIAS_RID_ACCOUNT_OPS                    = &H00000224???
%DOMAIN_ALIAS_RID_SYSTEM_OPS                     = &H00000225???
%DOMAIN_ALIAS_RID_PRINT_OPS                      = &H00000226???
%DOMAIN_ALIAS_RID_BACKUP_OPS                     = &H00000227???

%DOMAIN_ALIAS_RID_REPLICATOR                     = &H00000228???
%DOMAIN_ALIAS_RID_RAS_SERVERS                    = &H00000229???
%DOMAIN_ALIAS_RID_PREW2KCOMPACCESS               = &H0000022A???
%DOMAIN_ALIAS_RID_REMOTE_DESKTOP_USERS           = &H0000022B???
%DOMAIN_ALIAS_RID_NETWORK_CONFIGURATION_OPS      = &H0000022C???
%DOMAIN_ALIAS_RID_INCOMING_FOREST_TRUST_BUILDERS = &H0000022D???

%DOMAIN_ALIAS_RID_MONITORING_USERS               = &H0000022E???
%DOMAIN_ALIAS_RID_LOGGING_USERS                  = &H0000022F???
%DOMAIN_ALIAS_RID_AUTHORIZATIONACCESS            = &H00000230???
%DOMAIN_ALIAS_RID_TS_LICENSE_SERVERS             = &H00000231???
%DOMAIN_ALIAS_RID_DCOM_USERS                     = &H00000232???
%DOMAIN_ALIAS_RID_IUSERS                         = &H00000238???
%DOMAIN_ALIAS_RID_CRYPTO_OPERATORS               = &H00000239???
%DOMAIN_ALIAS_RID_CACHEABLE_PRINCIPALS_GROUP     = &H0000023B???
%DOMAIN_ALIAS_RID_NON_CACHEABLE_PRINCIPALS_GROUP = &H0000023C???
%DOMAIN_ALIAS_RID_EVENT_LOG_READERS_GROUP        = &H0000023D???

'#define SECURITY_MANDATORY_LABEL_AUTHORITY          {0,0,0,0,0,16}
$SECURITY_MANDATORY_LABEL_AUTHORITY          = CHR$(0,0,0,0,0,16)

%SECURITY_MANDATORY_UNTRUSTED_RID            = &H00000000???
%SECURITY_MANDATORY_LOW_RID                  = &H00001000???
%SECURITY_MANDATORY_MEDIUM_RID               = &H00002000???
%SECURITY_MANDATORY_HIGH_RID                 = &H00003000???
%SECURITY_MANDATORY_SYSTEM_RID               = &H00004000???
%SECURITY_MANDATORY_PROTECTED_PROCESS_RID    = &H00005000???

'//
'// SECURITY_MANDATORY_MAXIMUM_USER_RID is the highest RID that
'// can be set by a usermode caller.
'//

%SECURITY_MANDATORY_MAXIMUM_USER_RID   = %SECURITY_MANDATORY_SYSTEM_RID

'#define MANDATORY_LEVEL_TO_MANDATORY_RID(IL) (IL * 0x1000)
MACRO MANDATORY_LEVEL_TO_MANDATORY_RID(IL) = (IL * &H1000)

' WELL_KNOWN_SID_TYPE enum
%WinNullSid                                  = 0
%WinWorldSid                                 = 1
%WinLocalSid                                 = 2
%WinCreatorOwnerSid                          = 3
%WinCreatorGroupSid                          = 4
%WinCreatorOwnerServerSid                    = 5
%WinCreatorGroupServerSid                    = 6
%WinNtAuthoritySid                           = 7
%WinDialupSid                                = 8
%WinNetworkSid                               = 9
%WinBatchSid                                 = 10
%WinInteractiveSid                           = 11
%WinServiceSid                               = 12
%WinAnonymousSid                             = 13
%WinProxySid                                 = 14
%WinEnterpriseControllersSid                 = 15
%WinSelfSid                                  = 16
%WinAuthenticatedUserSid                     = 17
%WinRestrictedCodeSid                        = 18
%WinTerminalServerSid                        = 19
%WinRemoteLogonIdSid                         = 20
%WinLogonIdsSid                              = 21
%WinLocalSystemSid                           = 22
%WinLocalServiceSid                          = 23
%WinNetworkServiceSid                        = 24
%WinBuiltinDomainSid                         = 25
%WinBuiltinAdministratorsSid                 = 26
%WinBuiltinUsersSid                          = 27
%WinBuiltinGuestsSid                         = 28
%WinBuiltinPowerUsersSid                     = 29
%WinBuiltinAccountOperatorsSid               = 30
%WinBuiltinSystemOperatorsSid                = 31
%WinBuiltinPrintOperatorsSid                 = 32
%WinBuiltinBackupOperatorsSid                = 33
%WinBuiltinReplicatorSid                     = 34
%WinBuiltinPreWindows2000CompatibleAccessSid = 35
%WinBuiltinRemoteDesktopUsersSid             = 36
%WinBuiltinNetworkConfigurationOperatorsSid  = 37
%WinAccountAdministratorSid                  = 38
%WinAccountGuestSid                          = 39
%WinAccountKrbtgtSid                         = 40
%WinAccountDomainAdminsSid                   = 41
%WinAccountDomainUsersSid                    = 42
%WinAccountDomainGuestsSid                   = 43
%WinAccountComputersSid                      = 44
%WinAccountControllersSid                    = 45
%WinAccountCertAdminsSid                     = 46
%WinAccountSchemaAdminsSid                   = 47
%WinAccountEnterpriseAdminsSid               = 48
%WinAccountPolicyAdminsSid                   = 49
%WinAccountRasAndIasServersSid               = 50
%WinNTLMAuthenticationSid                    = 51
%WinDigestAuthenticationSid                  = 52
%WinSChannelAuthenticationSid                = 53
%WinThisOrganizationSid                      = 54
%WinOtherOrganizationSid                     = 55
%WinBuiltinIncomingForestTrustBuildersSid    = 56
%WinBuiltinPerfMonitoringUsersSid            = 57
%WinBuiltinPerfLoggingUsersSid               = 58
%WinBuiltinAuthorizationAccessSid            = 59
%WinBuiltinTerminalServerLicenseServersSid   = 60
%WinBuiltinDCOMUsersSid                      = 61
%WinBuiltinIUsersSid                         = 62
%WinIUserSid                                 = 63
%WinBuiltinCryptoOperatorsSid                = 64
%WinUntrustedLabelSid                        = 65
%WinLowLabelSid                              = 66
%WinMediumLabelSid                           = 67
%WinHighLabelSid                             = 68
%WinSystemLabelSid                           = 69
%WinWriteRestrictedCodeSid                   = 70
%WinCreatorOwnerRightsSid                    = 71
%WinCacheablePrincipalsGroupSid              = 72
%WinNonCacheablePrincipalsGroupSid           = 73
%WinEnterpriseReadonlyControllersSid         = 74
%WinAccountReadonlyControllersSid            = 75
%WinBuiltinEventLogReadersGroup              = 76

'//
'// Allocate the System Luid.  The first 1000 LUIDs are reserved.
'// Use #999 here (0x3E7 = 999)
'//

'#define SYSTEM_LUID                     { 0x3E7, 0x0 }
'#define ANONYMOUS_LOGON_LUID            { 0x3e6, 0x0 }
'#define LOCALSERVICE_LUID               { 0x3e5, 0x0 }
'#define NETWORKSERVICE_LUID             { 0x3e4, 0x0 }

MACRO SYSTEM_LUID                     = MKDWD$(&H3E7) & MKL$(&H0)
MACRO ANONYMOUS_LOGON_LUID            = MKDWD$(&H3e6) & MKL$(&H0)
MACRO LOCALSERVICE_LUID               = MKDWD$(&H3e5) & MKL$(&H0)
MACRO NETWORKSERVICE_LUID             = MKDWD$(&H3e4) & MKL$(&H0)

'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//                          User and Group related SID attributes     //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////

'//
'// Group attributes
'//

%SE_GROUP_MANDATORY          = &H00000001???
%SE_GROUP_ENABLED_BY_DEFAULT = &H00000002???
%SE_GROUP_ENABLED            = &H00000004???
%SE_GROUP_OWNER              = &H00000008???
%SE_GROUP_USE_FOR_DENY_ONLY  = &H00000010???
%SE_GROUP_INTEGRITY          = &H00000020???
%SE_GROUP_INTEGRITY_ENABLED  = &H00000040???
%SE_GROUP_LOGON_ID           = &HC0000000???
%SE_GROUP_RESOURCE           = &H20000000???

%SE_GROUP_VALID_ATTRIBUTES   = %SE_GROUP_MANDATORY          OR _
                               %SE_GROUP_ENABLED_BY_DEFAULT OR _
                               %SE_GROUP_ENABLED            OR _
                               %SE_GROUP_OWNER              OR _
                               %SE_GROUP_USE_FOR_DENY_ONLY  OR _
                               %SE_GROUP_LOGON_ID           OR _
                               %SE_GROUP_RESOURCE           OR _
                               %SE_GROUP_INTEGRITY          OR _
                               %SE_GROUP_INTEGRITY_ENABLED

'//
'// User attributes
'//

'// (None yet defined.)

'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//                         ACL  and  ACE                              //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////

'//
'//  Define an ACL and the ACE format.  The structure of an ACL header
'//  followed by one or more ACEs.  Pictorally the structure of an ACL header
'//  is as follows:
'//
'//       3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
'//       1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
'//      +-------------------------------+---------------+---------------+
'//      |            AclSize            |      Sbz1     |  AclRevision  |
'//      +-------------------------------+---------------+---------------+
'//      |              Sbz2             |           AceCount            |
'//      +-------------------------------+-------------------------------+
'//
'//  The current AclRevision is defined to be ACL_REVISION.
'//
'//  AclSize is the size, in bytes, allocated for the ACL.  This includes
'//  the ACL header, ACES, and remaining free space in the buffer.
'//
'//  AceCount is the number of ACES in the ACL.
'//

'// This is the *current* ACL revision

%ACL_REVISION     = 2
%ACL_REVISION_DS  = 4

'// This is the history of ACL revisions.  Add a new one whenever
'// ACL_REVISION is updated

%ACL_REVISION1    = 1
%ACL_REVISION2    = 2
%MIN_ACL_REVISION = %ACL_REVISION2
%ACL_REVISION3    = 3
%ACL_REVISION4    = 4
%MAX_ACL_REVISION = %ACL_REVISION4

#IF NOT %DEF(%ACL_DEFINED)
%ACL_DEFINED = 1
TYPE ACL
   AclRevision AS BYTE
   Sbz1        AS BYTE
   AclSize     AS WORD
   AceCount    AS WORD
   Sbz2        AS WORD
END TYPE
#ENDIF

'//
'//  The structure of an ACE is a common ace header followed by ace type
'//  specific data.  Pictorally the structure of the common ace header is
'//  as follows:
'//
'//       3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
'//       1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
'//      +---------------+-------+-------+---------------+---------------+
'//      |            AceSize            |    AceFlags   |     AceType   |
'//      +---------------+-------+-------+---------------+---------------+
'//
'//  AceType denotes the type of the ace, there are some predefined ace
'//  types
'//
'//  AceSize is the size, in bytes, of ace.
'//
'//  AceFlags are the Ace flags for audit and inheritance, defined shortly.

TYPE ACE_HEADER
   AceType  AS BYTE
   AceFlags AS BYTE
   AceSize  AS WORD
END TYPE


'//
'//  The following are the predefined ace types that go into the AceType
'//  field of an Ace header.
'//

%ACCESS_MIN_MS_ACE_TYPE                  = &H0?
%ACCESS_ALLOWED_ACE_TYPE                 = &H0?
%ACCESS_DENIED_ACE_TYPE                  = &H1?
%SYSTEM_AUDIT_ACE_TYPE                   = &H2?
%SYSTEM_ALARM_ACE_TYPE                   = &H3?
%ACCESS_MAX_MS_V2_ACE_TYPE               = &H3?

%ACCESS_ALLOWED_COMPOUND_ACE_TYPE        = &H4?
%ACCESS_MAX_MS_V3_ACE_TYPE               = &H4?

%ACCESS_MIN_MS_OBJECT_ACE_TYPE           = &H5?
%ACCESS_ALLOWED_OBJECT_ACE_TYPE          = &H5?
%ACCESS_DENIED_OBJECT_ACE_TYPE           = &H6?
%SYSTEM_AUDIT_OBJECT_ACE_TYPE            = &H7?
%SYSTEM_ALARM_OBJECT_ACE_TYPE            = &H8?
%ACCESS_MAX_MS_OBJECT_ACE_TYPE           = &H8?

%ACCESS_MAX_MS_V4_ACE_TYPE               = &H8?
%ACCESS_MAX_MS_ACE_TYPE                  = &H8?

%ACCESS_ALLOWED_CALLBACK_ACE_TYPE        = &H9?
%ACCESS_DENIED_CALLBACK_ACE_TYPE         = &HA?
%ACCESS_ALLOWED_CALLBACK_OBJECT_ACE_TYPE = &HB?
%ACCESS_DENIED_CALLBACK_OBJECT_ACE_TYPE  = &HC?
%SYSTEM_AUDIT_CALLBACK_ACE_TYPE          = &HD?
%SYSTEM_ALARM_CALLBACK_ACE_TYPE          = &HE?
%SYSTEM_AUDIT_CALLBACK_OBJECT_ACE_TYPE   = &HF?
%SYSTEM_ALARM_CALLBACK_OBJECT_ACE_TYPE   = &H10?

%SYSTEM_MANDATORY_LABEL_ACE_TYPE         = &H11?
%ACCESS_MAX_MS_V5_ACE_TYPE               = &H11?

'//
'//  The following are the inherit flags that go into the AceFlags field
'//  of an Ace header.
'//

%OBJECT_INHERIT_ACE       = &H1???
%CONTAINER_INHERIT_ACE    = &H2???
%NO_PROPAGATE_INHERIT_ACE = &H4???
%INHERIT_ONLY_ACE         = &H8???
%INHERITED_ACE            = &H10???
%VALID_INHERIT_FLAGS      = &H1F???

'//  The following are the currently defined ACE flags that go into the
'//  AceFlags field of an ACE header.  Each ACE type has its own set of
'//  AceFlags.
'//
'//  SUCCESSFUL_ACCESS_ACE_FLAG - used only with system audit and alarm ACE
'//  types to indicate that a message is generated for successful accesses.
'//
'//  FAILED_ACCESS_ACE_FLAG - used only with system audit and alarm ACE types
'//  to indicate that a message is generated for failed accesses.
'//

'//
'//  SYSTEM_AUDIT and SYSTEM_ALARM AceFlags
'//
'//  These control the signaling of audit and alarms for success or failure.
'//

%SUCCESSFUL_ACCESS_ACE_FLAG = &H40???
%FAILED_ACCESS_ACE_FLAG     = &H80???

'//
'//  We'll define the structure of the predefined ACE types.  Pictorally
'//  the structure of the predefined ACE's is as follows:
'//
'//       3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
'//       1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
'//      +---------------+-------+-------+---------------+---------------+
'//      |    AceFlags   | Resd  |Inherit|    AceSize    |     AceType   |
'//      +---------------+-------+-------+---------------+---------------+
'//      |                              Mask                             |
'//      +---------------------------------------------------------------+
'//      |                                                               |
'//      +                                                               +
'//      |                                                               |
'//      +                              Sid                              +
'//      |                                                               |
'//      +                                                               +
'//      |                                                               |
'//      +---------------------------------------------------------------+
'//
'//  Mask is the access mask associated with the ACE.  This is either the
'//  access allowed, access denied, audit, or alarm mask.
'//
'//  Sid is the Sid associated with the ACE.
'//

'//  The following are the four predefined ACE types.

'//  Examine the AceType field in the Header to determine
'//  which structure is appropriate to use for casting.


TYPE ACCESS_ALLOWED_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
END TYPE

TYPE ACCESS_DENIED_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
END TYPE

TYPE SYSTEM_AUDIT_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
END TYPE

TYPE SYSTEM_ALARM_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
END TYPE

TYPE SYSTEM_MANDATORY_LABEL_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
END TYPE

%SYSTEM_MANDATORY_LABEL_NO_WRITE_UP         = &H1
%SYSTEM_MANDATORY_LABEL_NO_READ_UP          = &H2
%SYSTEM_MANDATORY_LABEL_NO_EXECUTE_UP       = &H4

%SYSTEM_MANDATORY_LABEL_VALID_MASK = %SYSTEM_MANDATORY_LABEL_NO_WRITE_UP   OR _
                                     %SYSTEM_MANDATORY_LABEL_NO_READ_UP    OR _
                                     %SYSTEM_MANDATORY_LABEL_NO_EXECUTE_UP

TYPE ACCESS_ALLOWED_OBJECT_ACE
   Header              AS ACE_HEADER   ' ACE_HEADER
   Mask                AS DWORD        ' ACCESS_MASK
   Flags               AS DWORD        ' DWORD
   ObjectType          AS GUID         ' GUID
   InheritedObjectType AS GUID         ' GUID
   SidStart            AS DWORD        ' DWORD
END TYPE

TYPE ACCESS_DENIED_OBJECT_ACE
   Header              AS ACE_HEADER   ' ACE_HEADER
   Mask                AS DWORD        ' ACCESS_MASK
   Flags               AS DWORD        ' DWORD
   ObjectType          AS GUID         ' GUID
   InheritedObjectType AS GUID         ' GUID
   SidStart            AS DWORD        ' DWORD
END TYPE

TYPE SYSTEM_AUDIT_OBJECT_ACE
   Header              AS ACE_HEADER   ' ACE_HEADER
   Mask                AS DWORD        ' ACCESS_MASK
   Flags               AS DWORD        ' DWORD
   ObjectType          AS GUID         ' GUID
   InheritedObjectType AS GUID         ' GUID
   SidStart            AS DWORD        ' DWORD
END TYPE

TYPE SYSTEM_ALARM_OBJECT_ACE
   Header              AS ACE_HEADER   ' ACE_HEADER
   Mask                AS DWORD        ' ACCESS_MASK
   Flags               AS DWORD        ' DWORD
   ObjectType          AS GUID         ' GUID
   InheritedObjectType AS GUID         ' GUID
   SidStart            AS DWORD        ' DWORD
END TYPE

'//
'// Callback ace support in post Win2000.
'// Resource managers can put their own data after Sidstart + Length of the sid
'//

TYPE ACCESS_ALLOWED_CALLBACK_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
   ' // Opaque resouce manager specific data
END TYPE

TYPE ACCESS_DENIED_CALLBACK_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
   ' // Opaque resouce manager specific data
END TYPE

TYPE SYSTEM_AUDIT_CALLBACK_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
   ' // Opaque resouce manager specific data
END TYPE

TYPE SYSTEM_ALARM_CALLBACK_ACE
   Header   AS ACE_HEADER   ' ACE_HEADER
   Mask     AS DWORD        ' ACCESS_MASK
   SidStart AS DWORD        ' DWORD
   ' // Opaque resouce manager specific data
END TYPE

TYPE ACCESS_ALLOWED_CALLBACK_OBJECT_ACE
   Header              AS ACE_HEADER   ' ACE_HEADER
   Mask                AS DWORD        ' ACCESS_MASK
   Flags               AS DWORD        ' DWORD
   ObjectType          AS GUID         ' GUID
   InheritedObjectType AS GUID         ' GUID
   SidStart            AS DWORD        ' DWORD
   ' // Opaque resouce manager specific data
END TYPE

TYPE ACCESS_DENIED_CALLBACK_OBJECT_ACE
   Header              AS ACE_HEADER   ' ACE_HEADER
   Mask                AS DWORD        ' ACCESS_MASK
   Flags               AS DWORD        ' DWORD
   ObjectType          AS GUID         ' GUID
   InheritedObjectType AS GUID         ' GUID
   SidStart            AS DWORD        ' DWORD
   ' // Opaque resouce manager specific data
END TYPE

TYPE SYSTEM_AUDIT_CALLBACK_OBJECT_ACE
   Header              AS ACE_HEADER   ' ACE_HEADER
   Mask                AS DWORD        ' ACCESS_MASK
   Flags               AS DWORD        ' DWORD
   ObjectType          AS GUID         ' GUID
   InheritedObjectType AS GUID         ' GUID
   SidStart            AS DWORD        ' DWORD
   ' // Opaque resouce manager specific data
END TYPE

TYPE SYSTEM_ALARM_CALLBACK_OBJECT_ACE
   Header              AS ACE_HEADER   ' ACE_HEADER
   Mask                AS DWORD        ' ACCESS_MASK
   Flags               AS DWORD        ' DWORD
   ObjectType          AS GUID         ' GUID
   InheritedObjectType AS GUID         ' GUID
   SidStart            AS DWORD        ' DWORD
   ' // Opaque resouce manager specific data
END TYPE

'//
'// Currently define Flags for "OBJECT" ACE types.
'//

%ACE_OBJECT_TYPE_PRESENT           = &H1???
%ACE_INHERITED_OBJECT_TYPE_PRESENT = &H2???

'//
'//  The following declarations are used for setting and querying information
'//  about and ACL.  First are the various information classes available to
'//  the user.
'//

' ACL_INFORMATION_CLASS enum
%AclRevisionInformation = 1
%AclSizeInformation     = 2

'//
'//  This record is returned/sent if the user is requesting/setting the
'//  AclRevisionInformation
'//

TYPE ACL_REVISION_INFORMATION
   AclRevision AS DWORD
END TYPE

'//
'//  This record is returned if the user is requesting AclSizeInformation
'//

TYPE ACL_SIZE_INFORMATION
   AceCount      AS DWORD
   AclBytesInUse AS DWORD
   AclBytesFree  AS DWORD
END TYPE

'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//                             SECURITY_DESCRIPTOR                    //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////
'//
'//  Define the Security Descriptor and related data types.
'//  This is an opaque data structure.
'//

'//
'// Current security descriptor revision value
'//

%SECURITY_DESCRIPTOR_REVISION   = 1
%SECURITY_DESCRIPTOR_REVISION1  = 1

'#define SECURITY_DESCRIPTOR_MIN_LENGTH   (sizeof(SECURITY_DESCRIPTOR))

%SECURITY_DESCRIPTOR_MIN_LENGTH = 20  ' SIZEOF(SECURITY_DESCRIPTOR)

'typedef WORD   SECURITY_DESCRIPTOR_CONTROL, *PSECURITY_DESCRIPTOR_CONTROL;

%SE_OWNER_DEFAULTED       = &H0001???
%SE_GROUP_DEFAULTED       = &H0002???
%SE_DACL_PRESENT          = &H0004???
%SE_DACL_DEFAULTED        = &H0008???
%SE_SACL_PRESENT          = &H0010???
%SE_SACL_DEFAULTED        = &H0020???
%SE_DACL_AUTO_INHERIT_REQ = &H0100???
%SE_SACL_AUTO_INHERIT_REQ = &H0200???
%SE_DACL_AUTO_INHERITED   = &H0400???
%SE_SACL_AUTO_INHERITED   = &H0800???
%SE_DACL_PROTECTED        = &H1000???
%SE_SACL_PROTECTED        = &H2000???
%SE_RM_CONTROL_VALID      = &H4000???
%SE_SELF_RELATIVE         = &H8000???

'//
'//  Where:
'//
'//      SE_OWNER_DEFAULTED - This boolean flag, when set, indicates that the
'//          SID pointed to by the Owner field was provided by a
'//          defaulting mechanism rather than explicitly provided by the
'//          original provider of the security descriptor.  This may
'//          affect the treatment of the SID with respect to inheritence
'//          of an owner.
'//
'//      SE_GROUP_DEFAULTED - This boolean flag, when set, indicates that the
'//          SID in the Group field was provided by a defaulting mechanism
'//          rather than explicitly provided by the original provider of
'//          the security descriptor.  This may affect the treatment of
'//          the SID with respect to inheritence of a primary group.
'//
'//      SE_DACL_PRESENT - This boolean flag, when set, indicates that the
'//          security descriptor contains a discretionary ACL.  If this
'//          flag is set and the Dacl field of the SECURITY_DESCRIPTOR is
'//          null, then a null ACL is explicitly being specified.
'//
'//      SE_DACL_DEFAULTED - This boolean flag, when set, indicates that the
'//          ACL pointed to by the Dacl field was provided by a defaulting
'//          mechanism rather than explicitly provided by the original
'//          provider of the security descriptor.  This may affect the
'//          treatment of the ACL with respect to inheritence of an ACL.
'//          This flag is ignored if the DaclPresent flag is not set.
'//
'//      SE_SACL_PRESENT - This boolean flag, when set,  indicates that the
'//          security descriptor contains a system ACL pointed to by the
'//          Sacl field.  If this flag is set and the Sacl field of the
'//          SECURITY_DESCRIPTOR is null, then an empty (but present)
'//          ACL is being specified.
'//
'//      SE_SACL_DEFAULTED - This boolean flag, when set, indicates that the
'//          ACL pointed to by the Sacl field was provided by a defaulting
'//          mechanism rather than explicitly provided by the original
'//          provider of the security descriptor.  This may affect the
'//          treatment of the ACL with respect to inheritence of an ACL.
'//          This flag is ignored if the SaclPresent flag is not set.
'//
'//      SE_SELF_RELATIVE - This boolean flag, when set, indicates that the
'//          security descriptor is in self-relative form.  In this form,
'//          all fields of the security descriptor are contiguous in memory
'//          and all pointer fields are expressed as offsets from the
'//          beginning of the security descriptor.  This form is useful
'//          for treating security descriptors as opaque data structures
'//          for transmission in communication protocol or for storage on
'//          secondary media.
'//
'//
'//
'// Pictorially the structure of a security descriptor is as follows:
'//
'//       3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
'//       1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
'//      +---------------------------------------------------------------+
'//      |            Control            |Reserved1 (SBZ)|   Revision    |
'//      +---------------------------------------------------------------+
'//      |                            Owner                              |
'//      +---------------------------------------------------------------+
'//      |                            Group                              |
'//      +---------------------------------------------------------------+
'//      |                            Sacl                               |
'//      +---------------------------------------------------------------+
'//      |                            Dacl                               |
'//      +---------------------------------------------------------------+
'//
'// In general, this data structure should be treated opaquely to ensure future
'// compatibility.
'//
'//

TYPE SECURITY_DESCRIPTOR_RELATIVE
   Revision AS BYTE    ' BYTE
   Sbz1     AS BYTE    ' BYTE
   nControl AS WORD    ' SECURITY_DESCRIPTOR_CONTROL
   Owner    AS DWORD   ' DWORD
   Group    AS DWORD   ' DWORD
   Sacl     AS DWORD   ' DWORD
   Dacl     AS DWORD   ' DWORD
END TYPE


'// Where:
'//
'//     Revision - Contains the revision level of the security
'//         descriptor.  This allows this structure to be passed between
'//         systems or stored on disk even though it is expected to
'//         change in the future.
'//
'//     Control - A set of flags which qualify the meaning of the
'//         security descriptor or individual fields of the security
'//         descriptor.
'//
'//     Owner - is a pointer to an SID representing an object's owner.
'//         If this field is null, then no owner SID is present in the
'//         security descriptor.  If the security descriptor is in
'//         self-relative form, then this field contains an offset to
'//         the SID, rather than a pointer.
'//
'//     Group - is a pointer to an SID representing an object's primary
'//         group.  If this field is null, then no primary group SID is
'//         present in the security descriptor.  If the security descriptor
'//         is in self-relative form, then this field contains an offset to
'//         the SID, rather than a pointer.
'//
'//     Sacl - is a pointer to a system ACL.  This field value is only
'//         valid if the DaclPresent control flag is set.  If the
'//         SaclPresent flag is set and this field is null, then a null
'//         ACL  is specified.  If the security descriptor is in
'//         self-relative form, then this field contains an offset to
'//         the ACL, rather than a pointer.
'//
'//     Dacl - is a pointer to a discretionary ACL.  This field value is
'//         only valid if the DaclPresent control flag is set.  If the
'//         DaclPresent flag is set and this field is null, then a null
'//         ACL (unconditionally granting access) is specified.  If the
'//         security descriptor is in self-relative form, then this field
'//         contains an offset to the ACL, rather than a pointer.
'//

'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//               Object Type list for AccessCheckByType               //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////

TYPE OBJECT_TYPE_LIST
   Level      AS WORD
   Sbz        AS WORD
   ObjectType AS GUID PTR
END TYPE

'//
'// DS values for Level
'//

%ACCESS_OBJECT_GUID       = 0
%ACCESS_PROPERTY_SET_GUID = 1
%ACCESS_PROPERTY_GUID     = 2
%ACCESS_MAX_LEVEL         = 4

'//
'// Parameters to NtAccessCheckByTypeAndAditAlarm
'//

' AUDIT_EVENT_TYPE enum
%AuditEventObjectAccess           = 0
%AuditEventDirectoryServiceAccess = 1

%AUDIT_ALLOW_NO_PRIVILEGE = &H1

'//
'// DS values for Source and ObjectTypeName
'//

'#define ACCESS_DS_SOURCE_A "DS"
'#define ACCESS_DS_SOURCE_W L"DS"
'#define ACCESS_DS_OBJECT_TYPE_NAME_A "Directory Service Object"
'#define ACCESS_DS_OBJECT_TYPE_NAME_W L"Directory Service Object"

$ACCESS_DS_SOURCE             = "DS"
$ACCESS_DS_OBJECT_TYPE_NAME   = "Directory Service Object"

$ACCESS_DS_SOURCE_A           = "DS"
$ACCESS_DS_OBJECT_TYPE_NAME_A = "Directory Service Object"

'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//               Privilege Related Data Structures                    //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////


'//
'// Privilege attributes
'//

%SE_PRIVILEGE_ENABLED_BY_DEFAULT = &H00000001???
%SE_PRIVILEGE_ENABLED            = &H00000002???
%SE_PRIVILEGE_REMOVED            = &H00000004???
%SE_PRIVILEGE_USED_FOR_ACCESS    = &H80000000???

%SE_PRIVILEGE_VALID_ATTRIBUTES   = %SE_PRIVILEGE_ENABLED_BY_DEFAULT OR _
                                   %SE_PRIVILEGE_ENABLED            OR _
                                   %SE_PRIVILEGE_REMOVED            OR _
                                   %SE_PRIVILEGE_USED_FOR_ACCESS

'//
'// Privilege Set Control flags
'//

%PRIVILEGE_SET_ALL_NECESSARY = 1

'//
'//  Privilege Set - This is defined for a privilege set of one.
'//                  If more than one privilege is needed, then this structure
'//                  will need to be allocated with more space.
'//
'//  Note: don't change this structure without fixing the INITIAL_PRIVILEGE_SET
'//  structure (defined in se.h)
'//

TYPE PRIVILEGE_SET
   PrivilegeCount AS DWORD                ' DWORD
   nControl       AS DWORD                ' DWORD
   Privilege(0)   AS LUID_AND_ATTRIBUTES  ' LUID_AND_ATTRIBUTES Privilege[ANYSIZE_ARRAY]
END TYPE


'////////////////////////////////////////////////////////////////////////
'//                                                                    //
'//               NT Defined Privileges                                //
'//                                                                    //
'////////////////////////////////////////////////////////////////////////

'#define SE_CREATE_TOKEN_NAME              TEXT("SeCreateTokenPrivilege")
'#define SE_ASSIGNPRIMARYTOKEN_NAME        TEXT("SeAssignPrimaryTokenPrivilege")
'#define SE_LOCK_MEMORY_NAME               TEXT("SeLockMemoryPrivilege")
'#define SE_INCREASE_QUOTA_NAME            TEXT("SeIncreaseQuotaPrivilege")
'#define SE_UNSOLICITED_INPUT_NAME         TEXT("SeUnsolicitedInputPrivilege")
'#define SE_MACHINE_ACCOUNT_NAME           TEXT("SeMachineAccountPrivilege")
'#define SE_TCB_NAME                       TEXT("SeTcbPrivilege")
'#define SE_SECURITY_NAME                  TEXT("SeSecurityPrivilege")
'#define SE_TAKE_OWNERSHIP_NAME            TEXT("SeTakeOwnershipPrivilege")
'#define SE_LOAD_DRIVER_NAME               TEXT("SeLoadDriverPrivilege")
'#define SE_SYSTEM_PROFILE_NAME            TEXT("SeSystemProfilePrivilege")
'#define SE_SYSTEMTIME_NAME                TEXT("SeSystemtimePrivilege")
'#define SE_PROF_SINGLE_PROCESS_NAME       TEXT("SeProfileSingleProcessPrivilege")
'#define SE_INC_BASE_PRIORITY_NAME         TEXT("SeIncreaseBasePriorityPrivilege")
'#define SE_CREATE_PAGEFILE_NAME           TEXT("SeCreatePagefilePrivilege")
'#define SE_CREATE_PERMANENT_NAME          TEXT("SeCreatePermanentPrivilege")
'#define SE_BACKUP_NAME                    TEXT("SeBackupPrivilege")
'#define SE_RESTORE_NAME                   TEXT("SeRestorePrivilege")
'#define SE_SHUTDOWN_NAME                  TEXT("SeShutdownPrivilege")
'#define SE_DEBUG_NAME                     TEXT("SeDebugPrivilege")
'#define SE_AUDIT_NAME                     TEXT("SeAuditPrivilege")
'#define SE_SYSTEM_ENVIRONMENT_NAME        TEXT("SeSystemEnvironmentPrivilege")
'#define SE_CHANGE_NOTIFY_NAME             TEXT("SeChangeNotifyPrivilege")
'#define SE_REMOTE_SHUTDOWN_NAME           TEXT("SeRemoteShutdownPrivilege")
'#define SE_UNDOCK_NAME                    TEXT("SeUndockPrivilege")
'#define SE_SYNC_AGENT_NAME                TEXT("SeSyncAgentPrivilege")
'#define SE_ENABLE_DELEGATION_NAME         TEXT("SeEnableDelegationPrivilege")
'#define SE_MANAGE_VOLUME_NAME             TEXT("SeManageVolumePrivilege")
'#define SE_IMPERSONATE_NAME               TEXT("SeImpersonatePrivilege")
'#define SE_CREATE_GLOBAL_NAME             TEXT("SeCreateGlobalPrivilege")
'#define SE_TRUSTED_CREDMAN_ACCESS_NAME    TEXT("SeTrustedCredManAccessPrivilege")
'#define SE_RELABEL_NAME                   TEXT("SeRelabelPrivilege")
'#define SE_INC_WORKING_SET_NAME           TEXT("SeIncreaseWorkingSetPrivilege")
'#define SE_TIME_ZONE_NAME                 TEXT("SeTimeZonePrivilege")
'#define SE_CREATE_SYMBOLIC_LINK_NAME      TEXT("SeCreateSymbolicLinkPrivilege")

$SE_CREATE_TOKEN_NAME           = "SeCreateTokenPrivilege"
$SE_ASSIGNPRIMARYTOKEN_NAME     = "SeAssignPrimaryTokenPrivilege"
$SE_LOCK_MEMORY_NAME            = "SeLockMemoryPrivilege"
$SE_INCREASE_QUOTA_NAME         = "SeIncreaseQuotaPrivilege"
$SE_UNSOLICITED_INPUT_NAME      = "SeUnsolicitedInputPrivilege"
$SE_MACHINE_ACCOUNT_NAME        = "SeMachineAccountPrivilege"
$SE_TCB_NAME                    = "SeTcbPrivilege"
$SE_SECURITY_NAME               = "SeSecurityPrivilege"
$SE_TAKE_OWNERSHIP_NAME         = "SeTakeOwnershipPrivilege"
$SE_LOAD_DRIVER_NAME            = "SeLoadDriverPrivilege"
$SE_SYSTEM_PROFILE_NAME         = "SeSystemProfilePrivilege"
$SE_SYSTEMTIME_NAME             = "SeSystemtimePrivilege"
$SE_PROF_SINGLE_PROCESS_NAME    = "SeProfileSingleProcessPrivilege"
$SE_INC_BASE_PRIORITY_NAME      = "SeIncreaseBasePriorityPrivilege"
$SE_CREATE_PAGEFILE_NAME        = "SeCreatePagefilePrivilege"
$SE_CREATE_PERMANENT_NAME       = "SeCreatePermanentPrivilege"
$SE_BACKUP_NAME                 = "SeBackupPrivilege"
$SE_RESTORE_NAME                = "SeRestorePrivilege"
$SE_SHUTDOWN_NAME               = "SeShutdownPrivilege"
$SE_DEBUG_NAME                  = "SeDebugPrivilege"
$SE_AUDIT_NAME                  = "SeAuditPrivilege"
$SE_SYSTEM_ENVIRONMENT_NAME     = "SeSystemEnvironmentPrivilege"
$SE_CHANGE_NOTIFY_NAME          = "SeChangeNotifyPrivilege"
$SE_REMOTE_SHUTDOWN_NAME        = "SeRemoteShutdownPrivilege"
$SE_UNDOCK_NAME                 = "SeUndockPrivilege"
$SE_SYNC_AGENT_NAME             = "SeSyncAgentPrivilege"
$SE_ENABLE_DELEGATION_NAME      = "SeEnableDelegationPrivilege"
$SE_MANAGE_VOLUME_NAME          = "SeManageVolumePrivilege"
$SE_IMPERSONATE_NAME            = "SeImpersonatePrivilege"
$SE_CREATE_GLOBAL_NAME          = "SeCreateGlobalPrivilege"
$SE_TRUSTED_CREDMAN_ACCESS_NAME = "SeTrustedCredManAccessPrivilege"
$SE_RELABEL_NAME                = "SeRelabelPrivilege"
$SE_INC_WORKING_SET_NAME        = "SeIncreaseWorkingSetPrivilege"
$SE_TIME_ZONE_NAME              = "SeTimeZonePrivilege"
$SE_CREATE_SYMBOLIC_LINK_NAME   = "SeCreateSymbolicLinkPrivilege"

'////////////////////////////////////////////////////////////////////
'//                                                                //
'//           Security Quality Of Service                          //
'//                                                                //
'//                                                                //
'////////////////////////////////////////////////////////////////////

'//
'// Impersonation Level
'//
'// Impersonation level is represented by a pair of bits in Windows.
'// If a new impersonation level is added or lowest value is changed from
'// 0 to something else, fix the Windows CreateFile call.
'//

' SECURITY_IMPERSONATION_LEVEL enum
%SecurityAnonymous      = 0
%SecurityIdentification = 1
%SecurityImpersonation  = 2
%SecurityDelegation     = 3


'#define SECURITY_MAX_IMPERSONATION_LEVEL SecurityDelegation
'#define SECURITY_MIN_IMPERSONATION_LEVEL SecurityAnonymous
'#define DEFAULT_IMPERSONATION_LEVEL SecurityImpersonation
'#define VALID_IMPERSONATION_LEVEL(L) (((L) >= SECURITY_MIN_IMPERSONATION_LEVEL) && ((L) <= SECURITY_MAX_IMPERSONATION_LEVEL))

%SECURITY_MAX_IMPERSONATION_LEVEL = %SecurityDelegation
%DEFAULT_IMPERSONATION_LEVEL      = %SecurityImpersonation
%SECURITY_MIN_IMPERSONATION_LEVEL = %SecurityAnonymous

MACRO VALID_IMPERSONATION_LEVEL(L) = (L >= %SECURITY_MIN_IMPERSONATION_LEVEL) AND (L <= %SECURITY_MAX_IMPERSONATION_LEVEL)

'////////////////////////////////////////////////////////////////////
'//                                                                //
'//           Token Object Definitions                             //
'//                                                                //
'//                                                                //
'////////////////////////////////////////////////////////////////////


'//
'// Token Specific Access Rights.
'//

%TOKEN_ASSIGN_PRIMARY    = &H0001
%TOKEN_DUPLICATE         = &H0002
%TOKEN_IMPERSONATE       = &H0004
%TOKEN_QUERY             = &H0008
%TOKEN_QUERY_SOURCE      = &H0010
%TOKEN_ADJUST_PRIVILEGES = &H0020
%TOKEN_ADJUST_GROUPS     = &H0040
%TOKEN_ADJUST_DEFAULT    = &H0080
%TOKEN_ADJUST_SESSIONID  = &H0100

%TOKEN_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED  OR _
                    %TOKEN_ASSIGN_PRIMARY      OR _
                    %TOKEN_DUPLICATE           OR _
                    %TOKEN_IMPERSONATE         OR _
                    %TOKEN_QUERY               OR _
                    %TOKEN_QUERY_SOURCE        OR _
                    %TOKEN_ADJUST_PRIVILEGES   OR _
                    %TOKEN_ADJUST_GROUPS       OR _
                    %TOKEN_ADJUST_SESSIONID    OR _
                    %TOKEN_ADJUST_DEFAULT

'#if ((defined(_WIN32_WINNT) && (_WIN32_WINNT > 0x0400)) || (!defined(_WIN32_WINNT)))
'#define TOKEN_ALL_ACCESS  (TOKEN_ALL_ACCESS_P |\
'                          TOKEN_ADJUST_SESSIONID )
'#else
'#define TOKEN_ALL_ACCESS  (TOKEN_ALL_ACCESS_P)
'#endif

%TOKEN_READ       = %STANDARD_RIGHTS_READ OR %TOKEN_QUERY

%TOKEN_WRITE      = %STANDARD_RIGHTS_WRITE    OR _
                    %TOKEN_ADJUST_PRIVILEGES  OR _
                    %TOKEN_ADJUST_GROUPS      OR _
                    %TOKEN_ADJUST_DEFAULT

%TOKEN_EXECUTE    = %STANDARD_RIGHTS_EXECUTE

'//
'//
'// Token Types
'//

' TOKEN_TYPE enum
%TokenPrimary       = 1
%TokenImpersonation = 2

'//
'// Token elevation values describe the relative strength of a given token.
'// A full token is a token with all groups and privileges to which the principal
'// is authorized.  A limited token is one with some groups or privileges removed.
'//

' enum TOKEN_ELEVATION_TYPE
%TokenElevationTypeDefault = 1
%TokenElevationTypeFull    = 2
%TokenElevationTypeLimited = 3

'//
'// Token Information Classes.
'//

' TOKEN_INFORMATION_CLASS enum
%TokenUser                  = 1
%TokenGroups                = 2
%TokenPrivileges            = 3
%TokenOwner                 = 4
%TokenPrimaryGroup          = 5
%TokenDefaultDacl           = 6
%TokenSource                = 7
%TokenType                  = 8
%TokenImpersonationLevel    = 9
%TokenStatistics            = 10
%TokenRestrictedSids        = 11
%TokenSessionId             = 12
%TokenGroupsAndPrivileges   = 13
%TokenSessionReference      = 14
%TokenSandBoxInert          = 15
%TokenAuditPolicy           = 16
%TokenOrigin                = 17
%TokenElevationType         = 18
%TokenLinkedToken           = 19
%TokenElevation             = 20
%TokenHasRestrictions       = 21
%TokenAccessInformation     = 22
%TokenVirtualizationAllowed = 23
%TokenVirtualizationEnabled = 24
%TokenIntegrityLevel        = 25
%TokenUIAccess              = 26
%TokenMandatoryPolicy       = 27
%TokenLogonSid              = 28
%MaxTokenInfoClass          = 29   ' // MaxTokenInfoClass should always be the last enum

'//
'// Token information class structures
'//

TYPE TOKEN_USER
   User AS SID_AND_ATTRIBUTES
END TYPE

TYPE TOKEN_GROUPS
   GroupCount AS DWORD
   Groups(0)  AS SID_AND_ATTRIBUTES   ' array size may vary
END TYPE

TYPE TOKEN_PRIVILEGES
   PrivilegeCount AS DWORD
   Privileges(0)  AS LUID_AND_ATTRIBUTES  ' array size may vary
END TYPE

TYPE TOKEN_OWNER
   Owner AS SID PTR
END TYPE

TYPE TOKEN_PRIMARY_GROUP
   PrimaryGroup AS SID PTR
END TYPE

TYPE TOKEN_DEFAULT_DACL
   DefaultDacl AS ACL PTR
END TYPE

TYPE TOKEN_GROUPS_AND_PRIVILEGES
   SidCount            AS DWORD
   SidLength           AS DWORD
   Sids                AS SID_AND_ATTRIBUTES  PTR
   RestrictedSidCount  AS DWORD
   RestrictedSidLength AS DWORD
   RestrictedSids      AS SID_AND_ATTRIBUTES  PTR
   PrivilegeCount      AS DWORD
   PrivilegeLength     AS DWORD
   Privileges          AS LUID_AND_ATTRIBUTES PTR
   AuthenticationId    AS LUID
END TYPE

'//
'// Valid bits for each TOKEN_AUDIT_POLICY policy mask field.
'//

%TOKEN_AUDIT_SUCCESS_INCLUDE = &H1   ' Removed from Vista SDK
%TOKEN_AUDIT_SUCCESS_EXCLUDE = &H2   ' Removed from Vista SDK
%TOKEN_AUDIT_FAILURE_INCLUDE = &H4   ' Removed from Vista SDK
%TOKEN_AUDIT_FAILURE_EXCLUDE = &H8   ' Removed from Vista SDK

' Removed from Vista SDK
%VALID_AUDIT_POLICY_BITS = %TOKEN_AUDIT_SUCCESS_INCLUDE OR _
                           %TOKEN_AUDIT_SUCCESS_EXCLUDE OR _
                           %TOKEN_AUDIT_FAILURE_INCLUDE OR _
                           %TOKEN_AUDIT_FAILURE_EXCLUDE

'#define VALID_TOKEN_AUDIT_POLICY_ELEMENT(P) ((((P).PolicyMask & ~VALID_AUDIT_POLICY_BITS) == 0) && \
'                                             ((P).Category <= AuditEventMaxType))

' Removed from Vista SDK
TYPE TOKEN_AUDIT_POLICY_ELEMENT
   Category   AS DWORD
   PolicyMask AS DWORD
END TYPE

'FUNCTION VALID_TOKEN_AUDIT_POLICY_ELEMENT (BYREF P AS TOKEN_AUDIT_POLICY_ELEMENT) AS LONG
'   FUNCTION = ((P.PolicyMask AND NOT %VALID_AUDIT_POLICY_BITS) = 0) AND _
'      P.Category <= AuditEventMaxType)
'END FUNCTION

TYPE TOKEN_AUDIT_POLICY
   PolicyCount AS DWORD
   Policy(0)   AS TOKEN_AUDIT_POLICY_ELEMENT   ' Variable-length array
END TYPE

'#define PER_USER_AUDITING_POLICY_SIZE(p) \
'    ( sizeof(TOKEN_AUDIT_POLICY) + (((p)->PolicyCount > ANYSIZE_ARRAY) ? (sizeof(TOKEN_AUDIT_POLICY_ELEMENT) * ((p)->PolicyCount - ANYSIZE_ARRAY)) : 0) )
'#define PER_USER_AUDITING_POLICY_SIZE_BY_COUNT(C) \
'    ( sizeof(TOKEN_AUDIT_POLICY) + (((C) > ANYSIZE_ARRAY) ? (sizeof(TOKEN_AUDIT_POLICY_ELEMENT) * ((C) - ANYSIZE_ARRAY)) : 0) )

%TOKEN_SOURCE_LENGTH = 8

TYPE TOKEN_SOURCE
   SourceName AS ASCIIZ * %TOKEN_SOURCE_LENGTH
   SourceIdentifier AS LUID
END TYPE

TYPE TOKEN_STATISTICS
   TokenId            AS LUID    ' LUID
   AuthenticationId   AS LUID    ' LUID
   ExpirationTime     AS QUAD    ' LARGE_INTEGER
   TokenType          AS LONG    ' TOKEN_TYPE
   ImpersonationLevel AS LONG    ' SECURITY_IMPERSONATION_LEVEL
   DynamicCharged     AS DWORD   ' DWORD
   DynamicAvailable   AS DWORD   ' DWORD
   GroupCount         AS DWORD   ' DWORD
   PrivilegeCount     AS DWORD   ' DWORD
   ModifiedId         AS LUID    ' LUID
END TYPE

TYPE TOKEN_CONTROL
   TokenId          AS LUID
   AuthenticationId AS LUID
   ModifiedId       AS LUID
   TokenSource      AS TOKEN_SOURCE
END TYPE

TYPE TOKEN_ORIGIN
   OriginatingLogonSession AS LUID
END TYPE

' enum _MANDATORY_LEVEL
%MandatoryLevelUntrusted     = 0
%MandatoryLevelLow           = 1
%MandatoryLevelMedium        = 2
%MandatoryLevelHigh          = 3
%MandatoryLevelSystem        = 4
%MandatoryLevelSecureProcess = 5
%MandatoryLevelCount         = 6

'//
'// Security Tracking Mode
'//

%SECURITY_DYNAMIC_TRACKING = 1?   ' %TRUE
%SECURITY_STATIC_TRACKING  = 0?   ' %FALSE

'typedef BOOLEAN SECURITY_CONTEXT_TRACKING_MODE,
'                    * PSECURITY_CONTEXT_TRACKING_MODE;


'//
'// Quality Of Service
'//

TYPE SECURITY_QUALITY_OF_SERVICE
   Length              AS DWORD   ' DWORD
   Impersonationlevel  AS LONG    ' SECURITY_IMPERSONATION_LEVEL
   ContextTrackingMode AS BYTE    ' SECURITY_CONTEXT_TRACKING_MODE
   EffectiveOnly       AS BYTE    ' BOOLEAN
END TYPE

'//
'// Used to represent information related to a thread impersonation
'//

TYPE SE_IMPERSONATION_STATE
   Token         AS DWORD   ' PACCESS_TOKEN
   CopyOnOpen    AS BYTE    ' BOOLEAN
   EffectiveOnly AS BYTE    ' BOOLEAN
   Level         AS LONG    ' SECURITY_IMPERSONATION_LEVEL
END TYPE

%DISABLE_MAX_PRIVILEGE = &H1???
%SANDBOX_INERT         = &H2???
%LUA_TOKEN             = &H4???
%WRITE_RESTRICTED      = &H8???

'typedef DWORD SECURITY_INFORMATION, *PSECURITY_INFORMATION;

%OWNER_SECURITY_INFORMATION = &H00000001???
%GROUP_SECURITY_INFORMATION = &H00000002???
%DACL_SECURITY_INFORMATION  = &H00000004???
%SACL_SECURITY_INFORMATION  = &H00000008???
%LABEL_SECURITY_INFORMATION = &H00000010???

%PROTECTED_DACL_SECURITY_INFORMATION   = &H80000000???
%PROTECTED_SACL_SECURITY_INFORMATION   = &H40000000???
%UNPROTECTED_DACL_SECURITY_INFORMATION = &H20000000???
%UNPROTECTED_SACL_SECURITY_INFORMATION = &H10000000???

%PROCESS_TERMINATE                 = &H0001
%PROCESS_CREATE_THREAD             = &H0002
%PROCESS_SET_SESSIONID             = &H0004
%PROCESS_VM_OPERATION              = &H0008
%PROCESS_VM_READ                   = &H0010
%PROCESS_VM_WRITE                  = &H0020
%PROCESS_DUP_HANDLE                = &H0040
%PROCESS_CREATE_PROCESS            = &H0080
%PROCESS_SET_QUOTA                 = &H0100
%PROCESS_SET_INFORMATION           = &H0200
%PROCESS_QUERY_INFORMATION         = &H0400
%PROCESS_SUSPEND_RESUME            = &H0800
%PROCESS_QUERY_LIMITED_INFORMATION = &H1000
'#if (NTDDI_VERSION >= NTDDI_LONGHORN)
#IF %WINVER >= &H0600
%PROCESS_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &HFFFF
#ELSE
%PROCESS_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H0FFF
#ENDIF

'#if defined(_WIN64)

'#define MAXIMUM_PROCESSORS 64

'#else

'#define MAXIMUM_PROCESSORS 32

'#endif

%MAXIMUM_PROCESSORS = 32

%THREAD_TERMINATE            = &H0001
%THREAD_SUSPEND_RESUME       = &H0002
%THREAD_GET_CONTEXT          = &H0008
%THREAD_SET_CONTEXT          = &H0010
%THREAD_SET_INFORMATION      = &H0020
%THREAD_QUERY_INFORMATION    = &H0040
%THREAD_SET_THREAD_TOKEN     = &H0080
%THREAD_IMPERSONATE          = &H0100
%THREAD_DIRECT_IMPERSONATION = &H0200

%THREAD_SET_LIMITED_INFORMATION   = &H0400  ' // winnt
%THREAD_QUERY_LIMITED_INFORMATION = &H0800  ' // winnt
'#if (NTDDI_VERSION >= NTDDI_LONGHORN)
#IF %WINVER >= &H0600
%THREAD_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H0FFFF
#ELSE
%THREAD_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H03FF
#ENDIF

%JOB_OBJECT_ASSIGN_PROCESS           = &H0001
%JOB_OBJECT_SET_ATTRIBUTES           = &H0002
%JOB_OBJECT_QUERY                    = &H0004
%JOB_OBJECT_TERMINATE                = &H0008
%JOB_OBJECT_SET_SECURITY_ATTRIBUTES  = &H0010
%JOB_OBJECT_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H1F

TYPE JOB_SET_ARRAY
   JobHandle   AS DWORD   ' HANDLE // Handle to job object to insert
   MemberLevel AS DWORD   ' DWORD  // Level of this job in the set. Must be > 0. Can be sparse.
   Flags       AS DWORD   ' DWORD  // Unused. Must be zero
END TYPE

%FLS_MAXIMUM_AVAILABLE = 128
%TLS_MINIMUM_AVAILABLE = 64

'typedef struct _NT_TIB {
'    struct _EXCEPTION_REGISTRATION_RECORD *ExceptionList;
'    PVOID StackBase;
'    PVOID StackLimit;
'    PVOID SubSystemTib;
'    union {
'        PVOID FiberData;
'        DWORD Version;
'    };
'    PVOID ArbitraryUserPointer;
'    struct _NT_TIB *Self;
'} NT_TIB;
'typedef NT_TIB *PNT_TIB;

UNION NT_TIB_UNION
   FiberData AS DWORD
   Version   AS DWORD
END UNION

TYPE NT_TIB
   ExceptionList        AS DWORD
   StackBase            AS DWORD
   StackLimit           AS DWORD
   SubSystemTib         AS DWORD
   NT_TIB_UNION
   ArbitraryUserPointer AS DWORD
   Self                 AS NT_TIB PTR
END TYPE
'typedef NT_TIB *PNT_TIB;

'//
'// 32 and 64 bit specific version for wow64 and the debugger
'//
'typedef struct _NT_TIB32 {
'    DWORD ExceptionList;
'    DWORD StackBase;
'    DWORD StackLimit;
'    DWORD SubSystemTib;
'    union {
'        DWORD FiberData;
'        DWORD Version;
'    };
'    DWORD ArbitraryUserPointer;
'    DWORD Self;
'} NT_TIB32, *PNT_TIB32;

UNION NT_TIB32_UNION
   FiberData AS DWORD
   Version   AS DWORD
END UNION

TYPE NT_TIB32
   ExceptionList        AS DWORD
   StackBase            AS DWORD
   StackLimit           AS DWORD
   SubSystemTib         AS DWORD
   NT_TIB_UNION
   ArbitraryUserPointer AS DWORD
   Self                 AS DWORD
END TYPE

'typedef struct _NT_TIB64 {
'    DWORD64 ExceptionList;
'    DWORD64 StackBase;
'    DWORD64 StackLimit;
'    DWORD64 SubSystemTib;
'    union {
'        DWORD64 FiberData;
'        DWORD Version;
'    };
'    DWORD64 ArbitraryUserPointer;
'    DWORD64 Self;
'} NT_TIB64, *PNT_TIB64;

UNION NT_TIB64_UNION
   FiberData AS QUAD
   Version   AS DWORD
END UNION

TYPE NT_TIB64
   ExceptionList        AS QUAD
   StackBase            AS QUAD
   StackLimit           AS QUAD
   SubSystemTib         AS QUAD
   NT_TIB64_UNION
   ArbitraryUserPointer AS QUAD
   Self                 AS QUAD
END TYPE

'#if !defined(_X86_) && !defined(_IA64_) && !defined(_AMD64_)
'#define WX86
'#endif

%THREAD_BASE_PRIORITY_LOWRT = 15  ' value that gets a thread to LowRealtime-1
%THREAD_BASE_PRIORITY_MAX   = 2   ' maximum thread base priority boost
%THREAD_BASE_PRIORITY_MIN   = -2  ' minimum thread base priority boost
%THREAD_BASE_PRIORITY_IDLE  = -15 ' value that gets a thread to idle

TYPE QUOTA_LIMITS
   PagedPoolLimit        AS DWORD   ' SIZE_T
   NonPagedPoolLimit     AS DWORD   ' SIZE_T
   MinimumWorkingSetSize AS DWORD   ' SIZE_T
   MaximumWorkingSetSize AS DWORD   ' SIZE_T
   PagefileLimit         AS DWORD   ' SIZE_T
   TimeLimit             AS QUAD    ' LARGE_INTEGER
END TYPE

%QUOTA_LIMITS_HARDWS_MIN_ENABLE  = &H00000001???
%QUOTA_LIMITS_HARDWS_MIN_DISABLE = &H00000002???
%QUOTA_LIMITS_HARDWS_MAX_ENABLE  = &H00000004???
%QUOTA_LIMITS_HARDWS_MAX_DISABLE = &H00000008???
%QUOTA_LIMITS_USE_DEFAULT_LIMITS = &H00000010???

%PS_RATE_PHASE_BITS = 4
'#define PS_RATE_PHASE_MASK  ((1UL << PS_RATE_PHASE_BITS) - 1)
%PS_RATE_PHASE_MASK = &HF???

' enum PS_RATE_PHASE
%PsRateOneSecond   = 0
%PsRateTwoSecond   = 1
%PsRateThreeSecond = 2
%PsRateMaxPhase    = 3

TYPE RATE_QUOTA_LIMIT_STRUCT
   RatePhase   AS BIT * %PS_RATE_PHASE_BITS IN DWORD
   RatePercent AS BIT * 28
END TYPE

UNION RATE_QUOTA_LIMIT
   RateData AS DWORD
   RATE_QUOTA_LIMIT_STRUCT
END UNION

'#if !defined(SORTPP_PASS) && !defined(MIDL_PASS) && !defined(RC_INVOKED) && defined(_WIN64) && !defined(_X86AMD64_)
'C_ASSERT (sizeof (DWORD) * 8 - PS_RATE_PHASE_BITS == 28);
'#endif

TYPE QUOTA_LIMITS_EX
   PagedPoolLimit        AS DWORD   ' SIZE_T
   NonPagedPoolLimit     AS DWORD   ' SIZE_T
   MinimumWorkingSetSize AS DWORD   ' SIZE_T
   MaximumWorkingSetSize AS DWORD   ' SIZE_T
   PagefileLimit         AS DWORD   ' SIZE_T
   TimeLimit             AS QUAD    ' LARGE_INTEGER
   Reserved1             AS DWORD   ' SIZE_T
   Reserved2             AS DWORD   ' SIZE_T
   Reserved3             AS DWORD   ' SIZE_T
   Reserved4             AS DWORD   ' SIZE_T
   Flags                 AS DWORD   ' DWORD
   CpuRateLimit          AS RATE_QUOTA_LIMIT
END TYPE

TYPE IO_COUNTERS
   ReadOperationCount  AS QUAD   ' ULONGLONG
   WriteOperationCount AS QUAD   ' ULONGLONG
   OtherOperationCount AS QUAD   ' ULONGLONG
   ReadTransferCount   AS QUAD   ' ULONGLONG
   WriteTransferCount  AS QUAD   ' ULONGLONG
   OtherTransferCount  AS QUAD   ' ULONGLONG
END TYPE

TYPE JOBOBJECT_BASIC_ACCOUNTING_INFORMATION
   TotalUserTime             AS QUAD    ' LARGE_INTEGER
   TotalKernelTime           AS QUAD    ' LARGE_INTEGER
   ThisPeriodTotalUserTime   AS QUAD    ' LARGE_INTEGER
   ThisPeriodTotalKernelTime AS QUAD    ' LARGE_INTEGER
   TotalPageFaultCount       AS DWORD   ' DWORD
   TotalProcesses            AS DWORD   ' DWORD
   ActiveProcesses           AS DWORD   ' DWORD
   TotalTerminatedProcesses  AS DWORD   ' DWORD
END TYPE

TYPE JOBOBJECT_BASIC_LIMIT_INFORMATION
   PerProcessUserTimeLimit AS QUAD        ' LARGE_INTEGER
   PerJobUserTimeLimit     AS QUAD        ' LARGE_INTEGER
   LimitFlags              AS DWORD       ' DWORD
   MinimumWorkingSetSize   AS DWORD       ' SIZE_T
   MaximumWorkingSetSize   AS DWORD       ' SIZE_T
   ActiveProcessLimit      AS DWORD       ' DWORD
   Affinity                AS DWORD PTR   ' ULONG_PTR
   PriorityClass           AS DWORD       ' DWORD
   SchedulingClass         AS DWORD       ' DWORD
END TYPE

TYPE JOBOBJECT_EXTENDED_LIMIT_INFORMATION
   BasicLimitInformation AS JOBOBJECT_BASIC_LIMIT_INFORMATION
   IoInfo                AS IO_COUNTERS
   ProcessMemoryLimit    AS DWORD   ' SIZE_T
   JobMemoryLimit        AS DWORD   ' SIZE_T
   PeakProcessMemoryUsed AS DWORD   ' SIZE_T
   PeakJobMemoryUsed     AS DWORD   ' SIZE_T
END TYPE

TYPE JOBOBJECT_BASIC_PROCESS_ID_LIST
   NumberOfAssignedProcesses AS DWORD       ' DWORD
   NumberOfProcessIdsInList  AS DWORD       ' DWORD
   ProcessIdList(0)          AS DWORD PTR   ' ULONG_PTR ProcessIdList[1]
END TYPE

TYPE JOBOBJECT_BASIC_UI_RESTRICTIONS
   UIRestrictionsClass AS DWORD
END TYPE

TYPE JOBOBJECT_SECURITY_LIMIT_INFORMATION
   SecurityLimitFlags AS DWORD                  ' DWORD
   JobToken           AS DWORD                  ' HANDLE
   SidsToDisable      AS TOKEN_GROUPS PTR       ' PTOKEN_GROUPS
   PrivilegesToDelete AS TOKEN_PRIVILEGES PTR   ' PTOKEN_PRIVILEGES
   RestrictedSids     AS TOKEN_GROUPS PTR       ' PTOKEN_GROUPS
END TYPE

TYPE JOBOBJECT_END_OF_JOB_TIME_INFORMATION
   EndOfJobTimeAction AS DWORD
END TYPE

TYPE JOBOBJECT_ASSOCIATE_COMPLETION_PORT
   CompletionKey  AS DWORD   ' PVOID
   CompletionPort AS DWORD   ' HANDLE
END TYPE

TYPE JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION
   BasicInfo AS JOBOBJECT_BASIC_ACCOUNTING_INFORMATION
   IoInfo    AS IO_COUNTERS
END TYPE

TYPE JOBOBJECT_JOBSET_INFORMATION
   MemberLevel AS DWORD
END TYPE

%JOB_OBJECT_TERMINATE_AT_END_OF_JOB = 0
%JOB_OBJECT_POST_AT_END_OF_JOB      = 1

'//
'// Completion Port Messages for job objects
'//
'// These values are returned via the lpNumberOfBytesTransferred parameter
'//

%JOB_OBJECT_MSG_END_OF_JOB_TIME       = 1???
%JOB_OBJECT_MSG_END_OF_PROCESS_TIME   = 2???
%JOB_OBJECT_MSG_ACTIVE_PROCESS_LIMIT  = 3???
%JOB_OBJECT_MSG_ACTIVE_PROCESS_ZERO   = 4???
%JOB_OBJECT_MSG_NEW_PROCESS           = 6???
%JOB_OBJECT_MSG_EXIT_PROCESS          = 7???
%JOB_OBJECT_MSG_ABNORMAL_EXIT_PROCESS = 8???
%JOB_OBJECT_MSG_PROCESS_MEMORY_LIMIT  = 9???
%JOB_OBJECT_MSG_JOB_MEMORY_LIMIT      = 10???

'//
'// Basic Limits
'//
%JOB_OBJECT_LIMIT_WORKINGSET        = &H00000001???
%JOB_OBJECT_LIMIT_PROCESS_TIME      = &H00000002???
%JOB_OBJECT_LIMIT_JOB_TIME          = &H00000004???
%JOB_OBJECT_LIMIT_ACTIVE_PROCESS    = &H00000008???
%JOB_OBJECT_LIMIT_AFFINITY          = &H00000010???
%JOB_OBJECT_LIMIT_PRIORITY_CLASS    = &H00000020???
%JOB_OBJECT_LIMIT_PRESERVE_JOB_TIME = &H00000040???
%JOB_OBJECT_LIMIT_SCHEDULING_CLASS  = &H00000080???

'//
'// Extended Limits
'//
%JOB_OBJECT_LIMIT_PROCESS_MEMORY             = &H00000100???
%JOB_OBJECT_LIMIT_JOB_MEMORY                 = &H00000200???
%JOB_OBJECT_LIMIT_DIE_ON_UNHANDLED_EXCEPTION = &H00000400???
%JOB_OBJECT_LIMIT_BREAKAWAY_OK               = &H00000800???
%JOB_OBJECT_LIMIT_SILENT_BREAKAWAY_OK        = &H00001000???
%JOB_OBJECT_LIMIT_KILL_ON_JOB_CLOSE          = &H00002000???

%JOB_OBJECT_LIMIT_RESERVED1                  = &H00002000???
%JOB_OBJECT_LIMIT_RESERVED2                  = &H00004000???
%JOB_OBJECT_LIMIT_RESERVED3                  = &H00008000???
%JOB_OBJECT_LIMIT_RESERVED4                  = &H00010000???
%JOB_OBJECT_LIMIT_RESERVED5                  = &H00020000???
%JOB_OBJECT_LIMIT_RESERVED6                  = &H00040000???

%JOB_OBJECT_LIMIT_VALID_FLAGS          = &H0007ffff???

%JOB_OBJECT_BASIC_LIMIT_VALID_FLAGS    = &H000000ff???
%JOB_OBJECT_EXTENDED_LIMIT_VALID_FLAGS = &H00001fff???
%JOB_OBJECT_RESERVED_LIMIT_VALID_FLAGS = &H0007ffff???

'//
'// UI restrictions for jobs
'//

%JOB_OBJECT_UILIMIT_NONE              = &H00000000???

%JOB_OBJECT_UILIMIT_HANDLES           = &H00000001???
%JOB_OBJECT_UILIMIT_READCLIPBOARD     = &H00000002???
%JOB_OBJECT_UILIMIT_WRITECLIPBOARD    = &H00000004???
%JOB_OBJECT_UILIMIT_SYSTEMPARAMETERS  = &H00000008???
%JOB_OBJECT_UILIMIT_DISPLAYSETTINGS   = &H00000010???
%JOB_OBJECT_UILIMIT_GLOBALATOMS       = &H00000020???
%JOB_OBJECT_UILIMIT_DESKTOP           = &H00000040???
%JOB_OBJECT_UILIMIT_EXITWINDOWS       = &H00000080???

%JOB_OBJECT_UILIMIT_ALL               = &H000000FF???

%JOB_OBJECT_UI_VALID_FLAGS            = &H000000FF???

%JOB_OBJECT_SECURITY_NO_ADMIN         = &H00000001???
%JOB_OBJECT_SECURITY_RESTRICTED_TOKEN = &H00000002???
%JOB_OBJECT_SECURITY_ONLY_TOKEN       = &H00000004???
%JOB_OBJECT_SECURITY_FILTER_TOKENS    = &H00000008???

%JOB_OBJECT_SECURITY_VALID_FLAGS      = &H0000000f???

' JOBOBJECTINFOCLASS enum
%JobObjectBasicAccountingInformation         = 1
%JobObjectBasicLimitInformation              = 2
%JobObjectBasicProcessIdList                 = 3
%JobObjectBasicUIRestrictions                = 4
%JobObjectSecurityLimitInformation           = 5
%JobObjectEndOfJobTimeInformation            = 6
%JobObjectAssociateCompletionPortInformation = 7
%JobObjectBasicAndIoAccountingInformation    = 8
%JobObjectExtendedLimitInformation           = 9
%JobObjectJobSetInformation                  = 10
%MaxJobObjectInfoClass                       = 11

'//
%EVENT_MODIFY_STATE      = &H0002
%EVENT_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H3
%MUTANT_QUERY_STATE      = &H0001

%MUTEX_MODIFY_STATE = %MUTANT_QUERY_STATE   ' Removed from Vista SDK
%MUTANT_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR %MUTANT_QUERY_STATE
%MUTEX_ALL_ACCESS = %MUTANT_ALL_ACCESS   ' Removed from Vista SDK

%SEMAPHORE_MODIFY_STATE = &H0002
%SEMAPHORE_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H3

'//
'// Timer Specific Access Rights.
'//

%TIMER_QUERY_STATE       = &H0001
%TIMER_MODIFY_STATE      = &H0002

%TIMER_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR _
                          %TIMER_QUERY_STATE OR %TIMER_MODIFY_STATE

%TIME_ZONE_ID_UNKNOWN  = 0
%TIME_ZONE_ID_STANDARD = 1
%TIME_ZONE_ID_DAYLIGHT = 2

' LOGICAL_PROCESSOR_RELATIONSHIP enum
%RelationProcessorCore    = 0
%RelationNumaNode         = 1
%RelationCache            = 2
%RelationProcessorPackage = 3

%LTP_PC_SMT = &H1

' PROCESSOR_CACHE_TYPE enum
%CacheUnified = 0
%CacheInstruction = 1
%CacheData = 2
%CacheTrace = 3

%CACHE_FULLY_ASSOCIATIVE = &HFF

TYPE CACHE_DESCRIPTOR
   Level         AS BYTE    ' BYTE
   Associativity AS BYTE    ' BYTE
   LineSize      AS WORD    ' WORD
   Size          AS DWORD   ' DWORD
   Type          AS LONG    ' PROCESSOR_CACHE_TYPE
END TYPE

'typedef struct _SYSTEM_LOGICAL_PROCESSOR_INFORMATION {
'    ULONG_PTR   ProcessorMask;
'    LOGICAL_PROCESSOR_RELATIONSHIP Relationship;
'    union {
'        struct {
'            BYTE  Flags;
'        } ProcessorCore;
'        struct {
'            DWORD NodeNumber;
'        } NumaNode;
'        CACHE_DESCRIPTOR Cache;
'        ULONGLONG  Reserved[2];
'    };
'} SYSTEM_LOGICAL_PROCESSOR_INFORMATION, *PSYSTEM_LOGICAL_PROCESSOR_INFORMATION;

TYPE SYSTEM_LOGICAL_PROCESSOR_INFORMATION_ProcessorCore
   Flags AS BYTE
END TYPE

TYPE SYSTEM_LOGICAL_PROCESSOR_INFORMATION_NumaMode
   NodeNumber AS DWORD
END TYPE

UNION SYSTEM_LOGICAL_PROCESSOR_INFORMATION_UNION
   SYSTEM_LOGICAL_PROCESSOR_INFORMATION_ProcessorCore
   SYSTEM_LOGICAL_PROCESSOR_INFORMATION_NumaMode
   Cache       AS CACHE_DESCRIPTOR
   Reserved(1) AS QUAD
END UNION

TYPE SYSTEM_LOGICAL_PROCESSOR_INFORMATION
   ProcessorMask AS DWORD
   Relationship  AS LONG
   SYSTEM_LOGICAL_PROCESSOR_INFORMATION_UNION
END TYPE

%PROCESSOR_INTEL_386     = 386
%PROCESSOR_INTEL_486     = 486
%PROCESSOR_INTEL_PENTIUM = 586
%PROCESSOR_INTEL_IA64    = 2200
%PROCESSOR_AMD_X8664     = 8664
%PROCESSOR_MIPS_R4000    = 4000    ' incl R4101 & R3910 for Windows CE
%PROCESSOR_ALPHA_21064   = 21064
%PROCESSOR_PPC_601       = 601
%PROCESSOR_PPC_603       = 603
%PROCESSOR_PPC_604       = 604
%PROCESSOR_PPC_620       = 620
%PROCESSOR_HITACHI_SH3   = 10003   ' Windows CE
%PROCESSOR_HITACHI_SH3E  = 10004   ' Windows CE
%PROCESSOR_HITACHI_SH4   = 10005   ' Windows CE
%PROCESSOR_MOTOROLA_821  = 821     ' Windows CE
%PROCESSOR_SHx_SH3       = 103     ' Windows CE
%PROCESSOR_SHx_SH4       = 104     ' Windows CE
%PROCESSOR_STRONGARM     = 2577    ' Windows CE - = &HA11
%PROCESSOR_ARM720        = 1824    ' Windows CE - = &H720
%PROCESSOR_ARM820        = 2080    ' Windows CE - = &H820
%PROCESSOR_ARM920        = 2336    ' Windows CE - = &H920
%PROCESSOR_ARM_7TDMI     = 70001   ' Windows CE
%PROCESSOR_OPTIL         = &H494f  ' MSIL

%PROCESSOR_ARCHITECTURE_INTEL   = 0
%PROCESSOR_ARCHITECTURE_MIPS    = 1
%PROCESSOR_ARCHITECTURE_ALPHA   = 2
%PROCESSOR_ARCHITECTURE_PPC     = 3
%PROCESSOR_ARCHITECTURE_SHX     = 4
%PROCESSOR_ARCHITECTURE_ARM     = 5
%PROCESSOR_ARCHITECTURE_IA64    = 6
%PROCESSOR_ARCHITECTURE_ALPHA64 = 7
%PROCESSOR_ARCHITECTURE_MSIL    = 8
%PROCESSOR_ARCHITECTURE_AMD64           = 9
%PROCESSOR_ARCHITECTURE_IA32_ON_WIN64   = 10

%PROCESSOR_ARCHITECTURE_UNKNOWN = &HFFFF??

%PF_FLOATING_POINT_PRECISION_ERRATA = 0
%PF_FLOATING_POINT_EMULATED         = 1
%PF_COMPARE_EXCHANGE_DOUBLE         = 2
%PF_MMX_INSTRUCTIONS_AVAILABLE      = 3
%PF_PPC_MOVEMEM_64BIT_OK            = 4
%PF_ALPHA_BYTE_INSTRUCTIONS         = 5
%PF_XMMI_INSTRUCTIONS_AVAILABLE     = 6
%PF_3DNOW_INSTRUCTIONS_AVAILABLE    = 7
%PF_RDTSC_INSTRUCTION_AVAILABLE     = 8
%PF_PAE_ENABLED                     = 9
%PF_XMMI64_INSTRUCTIONS_AVAILABLE   = 10
%PF_SSE_DAZ_MODE_AVAILABLE          = 11
%PF_NX_ENABLED                      = 12
%PF_SSE3_INSTRUCTIONS_AVAILABLE     = 13
%PF_COMPARE_EXCHANGE128             = 14
%PF_COMPARE64_EXCHANGE128           = 15
%PF_CHANNELS_ENABLED                = 16

TYPE MEMORY_BASIC_INFORMATION
   BaseAddress       AS DWORD   ' PVOID
   AllocationBase    AS DWORD   ' PVOID
   AllocationProtect AS DWORD   ' DWORD
   RegionSize        AS DWORD   ' SIZE_T
   State             AS DWORD   ' DWORD
   Protect           AS DWORD   ' DWORD
   dType             AS DWORD   ' DWORD
END TYPE

TYPE MEMORY_BASIC_INFORMATION32
   BaseAddress       AS DWORD   ' DWORD
   AllocationBase    AS DWORD   ' DWORD
   AllocationProtect AS DWORD   ' DWORD
   RegionSize        AS DWORD   ' DWORD
   State             AS DWORD   ' DWORD
   Protect           AS DWORD   ' DWORD
   dType             AS DWORD   ' DWORD
END TYPE

TYPE MEMORY_BASIC_INFORMATION64   ' 16-bytes alignment
   BaseAddress       AS QUAD    ' ULONGLONG
   AllocationBase    AS QUAD    ' ULONGLONG
   AllocationProtect AS DWORD   ' DWORD
   alignment1        AS DWORD   ' DWORD
   RegionSize        AS QUAD    ' ULONGLONG
   State             AS DWORD   ' DWORD
   Protect           AS DWORD   ' DWORD
   dType             AS DWORD   ' DWORD
   alignment2        AS DWORD   ' DWORD
END TYPE

%SECTION_QUERY                = &H0001???
%SECTION_MAP_WRITE            = &H0002???
%SECTION_MAP_READ             = &H0004???
%SECTION_MAP_EXECUTE          = &H0008???
%SECTION_EXTEND_SIZE          = &H0010???
%SECTION_MAP_EXECUTE_EXPLICIT = &H0020???   ' // not included in SECTION_ALL_ACCESS

%SECTION_ALL_ACCESS  = %STANDARD_RIGHTS_REQUIRED OR %SECTION_QUERY _
                       OR %SECTION_MAP_WRITE _
                       OR %SECTION_MAP_READ _
                       OR %SECTION_MAP_EXECUTE _
                       OR %SECTION_EXTEND_SIZE

%SESSION_QUERY_ACCESS  = &H0001???
%SESSION_MODIFY_ACCESS = &H0002???

%SESSION_ALL_ACCESS    = %STANDARD_RIGHTS_REQUIRED OR _
                         %SESSION_QUERY_ACCESS     OR _
                         %SESSION_MODIFY_ACCESS

%PAGE_NOACCESS          = &H01???
%PAGE_READONLY          = &H02???
%PAGE_READWRITE         = &H04???
%PAGE_WRITECOPY         = &H08???
%PAGE_EXECUTE           = &H10???
%PAGE_EXECUTE_READ      = &H20???
%PAGE_EXECUTE_READWRITE = &H40???
%PAGE_EXECUTE_WRITECOPY = &H80???
%PAGE_GUARD             = &H100???
%PAGE_NOCACHE           = &H200???
%PAGE_WRITECOMBINE      = &H400???
%MEM_COMMIT             = &H1000???
%MEM_RESERVE            = &H2000???
%MEM_DECOMMIT           = &H4000???
%MEM_RELEASE            = &H8000???
%MEM_FREE               = &H10000???
%MEM_PRIVATE            = &H20000???
%MEM_MAPPED             = &H40000???
%MEM_RESET              = &H80000???
%MEM_TOP_DOWN           = &H100000???
%MEM_WRITE_WATCH        = &H200000???
%MEM_PHYSICAL           = &H400000???
%MEM_ROTATE             = &H800000???
%MEM_LARGE_PAGES        = &H20000000???
%MEM_4MB_PAGES          = &H80000000???
%SEC_FILE               = &H800000???
%SEC_IMAGE              = &H01000000???
'%SEC_VLM                = &H02000000???
%SEC_PROTECTED_IMAGE    = &H2000000???
%SEC_RESERVE            = &H04000000???
%SEC_COMMIT             = &H08000000???
%SEC_NOCACHE            = &H10000000???
%SEC_WRITECOMBINE       = &H40000000???
%SEC_LARGE_PAGES        = &H80000000???
%MEM_IMAGE              = %SEC_IMAGE
%WRITE_WATCH_FLAG_RESET = &H01???

'//
'// Define access rights to files and directories
'//

'//
'// The FILE_READ_DATA and FILE_WRITE_DATA constants are also defined in
'// devioctl.h as FILE_READ_ACCESS and FILE_WRITE_ACCESS. The values for these
'// constants *MUST* always be in sync.
'// The values are redefined in devioctl.h because they must be available to
'// both DOS and NT.
'//

%FILE_READ_DATA            = &H0001???    ' file & pipe
%FILE_LIST_DIRECTORY       = &H0001???    ' directory

%FILE_WRITE_DATA           = &H0002???    ' file & pipe
%FILE_ADD_FILE             = &H0002???    ' directory

%FILE_APPEND_DATA          = &H0004???    ' file
%FILE_ADD_SUBDIRECTORY     = &H0004???    ' directory
%FILE_CREATE_PIPE_INSTANCE = &H0004???    ' named pipe

%FILE_READ_EA              = &H0008???    ' file & directory

%FILE_WRITE_EA             = &H0010???    ' file & directory

%FILE_EXECUTE              = &H0020???    ' file
%FILE_TRAVERSE             = &H0020???    ' directory

%FILE_DELETE_CHILD         = &H0040???    ' directory

%FILE_READ_ATTRIBUTES      = &H0080???    ' all

%FILE_WRITE_ATTRIBUTES     = &H0100???    ' all

%FILE_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H1FF

%FILE_GENERIC_READ =   %STANDARD_RIGHTS_READ OR _
                       %FILE_READ_DATA       OR _
                       %FILE_READ_ATTRIBUTES OR _
                       %FILE_READ_EA         OR _
                       %SYNCHRONIZE

%FILE_GENERIC_WRITE =  %STANDARD_RIGHTS_WRITE OR _
                       %FILE_WRITE_DATA       OR _
                       %FILE_WRITE_ATTRIBUTES OR _
                       %FILE_WRITE_EA         OR _
                       %FILE_APPEND_DATA      OR _
                       %SYNCHRONIZE

%FILE_GENERIC_EXECUTE = %STANDARD_RIGHTS_EXECUTE OR _
                        %FILE_READ_ATTRIBUTES    OR _
                        %FILE_EXECUTE            OR _
                        %SYNCHRONIZE

%FILE_SHARE_READ                    = &H00000001???
%FILE_SHARE_WRITE                   = &H00000002???
%FILE_SHARE_DELETE                  = &H00000004???
%FILE_ATTRIBUTE_READONLY            = &H00000001???
%FILE_ATTRIBUTE_HIDDEN              = &H00000002???
%FILE_ATTRIBUTE_SYSTEM              = &H00000004???
%FILE_ATTRIBUTE_DIRECTORY           = &H00000010???
%FILE_ATTRIBUTE_ARCHIVE             = &H00000020???
%FILE_ATTRIBUTE_DEVICE              = &H00000040???
%FILE_ATTRIBUTE_NORMAL              = &H00000080???
%FILE_ATTRIBUTE_TEMPORARY           = &H00000100???
%FILE_ATTRIBUTE_SPARSE_FILE         = &H00000200???
%FILE_ATTRIBUTE_REPARSE_POINT       = &H00000400???
%FILE_ATTRIBUTE_COMPRESSED          = &H00000800???
%FILE_ATTRIBUTE_OFFLINE             = &H00001000???
%FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = &H00002000???
%FILE_ATTRIBUTE_ENCRYPTED           = &H00004000???
%FILE_ATTRIBUTE_VIRTUAL             = &H00010000???
%FILE_NOTIFY_CHANGE_FILE_NAME       = &H00000001???
%FILE_NOTIFY_CHANGE_DIR_NAME        = &H00000002???
%FILE_NOTIFY_CHANGE_ATTRIBUTES      = &H00000004???
%FILE_NOTIFY_CHANGE_SIZE            = &H00000008???
%FILE_NOTIFY_CHANGE_LAST_WRITE      = &H00000010???
%FILE_NOTIFY_CHANGE_LAST_ACCESS     = &H00000020???
%FILE_NOTIFY_CHANGE_CREATION        = &H00000040???
%FILE_NOTIFY_CHANGE_SECURITY        = &H00000100???
%FILE_ACTION_ADDED                  = &H00000001???
%FILE_ACTION_REMOVED                = &H00000002???
%FILE_ACTION_MODIFIED               = &H00000003???
%FILE_ACTION_RENAMED_OLD_NAME       = &H00000004???
%FILE_ACTION_RENAMED_NEW_NAME       = &H00000005???
%MAILSLOT_NO_MESSAGE                = &HFFFFFFFF???
%MAILSLOT_WAIT_FOREVER              = &HFFFFFFFF???
%FILE_CASE_SENSITIVE_SEARCH         = &H00000001???
%FILE_CASE_PRESERVED_NAMES          = &H00000002???
%FILE_UNICODE_ON_DISK               = &H00000004???
%FILE_PERSISTENT_ACLS               = &H00000008???
%FILE_FILE_COMPRESSION              = &H00000010???
%FILE_VOLUME_QUOTAS                 = &H00000020???
%FILE_SUPPORTS_SPARSE_FILES         = &H00000040???
%FILE_SUPPORTS_REPARSE_POINTS       = &H00000080???
%FILE_SUPPORTS_REMOTE_STORAGE       = &H00000100???
%FILE_VOLUME_IS_COMPRESSED          = &H00008000???
%FILE_SUPPORTS_OBJECT_IDS           = &H00010000???
%FILE_SUPPORTS_ENCRYPTION           = &H00020000???
%FILE_NAMED_STREAMS                 = &H00040000???
%FILE_READ_ONLY_VOLUME              = &H00080000???
%FILE_SEQUENTIAL_WRITE_ONCE         = &H00100000???
%FILE_SUPPORTS_TRANSACTIONS         = &H00200000???

'//
'// Define the file notification information structure
'//

TYPE FILE_NOTIFY_INFORMATION
   NextEntryOffset AS DWORD   ' DWORD
   Action          AS DWORD   ' DWORD
   FileNameLength  AS DWORD   ' DWORD
   FileName(0)     AS DWORD   ' WCHAR FileName[1]
END TYPE

'//
'// Define segement buffer structure for scatter/gather read/write.
'//

UNION FILE_SEGMENT_ELEMENT
   Buffer    AS QUAD   ' PVOID64
   Alignment AS QUAD   ' ULONGLONG
END UNION

'//
'// The reparse GUID structure is used by all 3rd party layered drivers to
'// store data in a reparse point. For non-Microsoft tags, The GUID field
'// cannot be GUID_NULL.
'// The constraints on reparse tags are defined below.
'// Microsoft tags can also be used with this format of the reparse point buffer.
'//

'typedef struct _REPARSE_GUID_DATA_BUFFER {
'    DWORD  ReparseTag;
'    WORD   ReparseDataLength;
'    WORD   Reserved;
'    GUID   ReparseGuid;
'    struct {
'        BYTE   DataBuffer[1];
'    } GenericReparseBuffer;
'} REPARSE_GUID_DATA_BUFFER, *PREPARSE_GUID_DATA_BUFFER;

TYPE REPARSE_GUID_DATA_BUFFER
   ReparseTag        AS DWORD
   ReparseDataLength AS WORD
   Reserved          AS WORD
   ReparseGuid       AS GUID
   DataBuffer(0)     AS BYTE   ' BYTE   DataBuffer[1]
END TYPE

'#define REPARSE_GUID_DATA_BUFFER_HEADER_SIZE   FIELD_OFFSET(REPARSE_GUID_DATA_BUFFER, GenericReparseBuffer)
%REPARSE_GUID_DATA_BUFFER_HEADER_SIZE = 24

'//
'// Maximum allowed size of the reparse data.
'//

'#define MAXIMUM_REPARSE_DATA_BUFFER_SIZE      ( 16 * 1024 )
%MAXIMUM_REPARSE_DATA_BUFFER_SIZE = 16 * 1024

'//
'// Predefined reparse tags.
'// These tags need to avoid conflicting with IO_REMOUNT defined in ntos\inc\io.h
'//

%IO_REPARSE_TAG_RESERVED_ZERO = 0
%IO_REPARSE_TAG_RESERVED_ONE  = 1

'//
'// The value of the following constant needs to satisfy the following conditions:
'//  (1) Be at least as large as the largest of the reserved tags.
'//  (2) Be strictly smaller than all the tags in use.
'//

%IO_REPARSE_TAG_RESERVED_RANGE = %IO_REPARSE_TAG_RESERVED_ONE

'//
'// The reparse tags are a DWORD. The 32 bits are laid out as follows:
'//
'//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
'//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
'//  +-+-+-+-+-----------------------+-------------------------------+
'//  |M|R|N|R|     Reserved bits     |       Reparse Tag Value       |
'//  +-+-+-+-+-----------------------+-------------------------------+
'//
'// M is the Microsoft bit. When set to 1, it denotes a tag owned by Microsoft.
'//   All ISVs must use a tag with a 0 in this position.
'//   Note: If a Microsoft tag is used by non-Microsoft software, the
'//   behavior is not defined.
'//
'// R is reserved.  Must be zero for non-Microsoft tags.
'//
'// N is name surrogate. When set to 1, the file represents another named
'//   entity in the system.
'//
'// The M and N bits are OR-able.
'// The following macros check for the M and N bit values:
'//

'//
'// Macro to determine whether a reparse point tag corresponds to a tag
'// owned by Microsoft.
'//

MACRO IsReparseTagMicrosoft(tag) = (tag AND &H80000000???)

'//
'// Macro to determine whether a reparse point tag is a name surrogate
'//

MACRO IsReparseTagNameSurrogate(tag) = (tag AND &H20000000???)

%IO_REPARSE_TAG_MOUNT_POINT    = &HA0000003???
%IO_REPARSE_TAG_HSM            = &HC0000004???
%IO_REPARSE_TAG_SIS            = &H80000007???
%IO_REPARSE_TAG_DFS            = &H8000000A???
%IO_REPARSE_TAG_FILTER_MANAGER = &H8000000B???  ' Removed from Vista SDK
%IO_REPARSE_TAG_SYMLINK        = &HA000000C???
%IO_REPARSE_TAG_DFSR           = &H80000012???

'//
'// I/O Completion Specific Access Rights.
'//

%IO_COMPLETION_MODIFY_STATE    = &H0002???
%IO_COMPLETION_ALL_ACCESS      = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H3

'//
'// Object Manager Symbolic Link Specific Access Rights.
'//

%DUPLICATE_CLOSE_SOURCE        = &H00000001???
%DUPLICATE_SAME_ACCESS         = &H00000002???

'//
'// =========================================
'// Define GUIDs which represent well-known power schemes
'// =========================================
'//

'//
'// Maximum Power Savings - indicates that very aggressive power savings measures will be used to help
'//                         stretch battery life.
'//
'// {a1841308-3541-4fab-bc81-f71556f20b4a}
'//
$GUID_MAX_POWER_SAVINGS = GUID$("{a1841308-3541-4fab-bc81-f71556f20b4a}")

'//
'// No Power Savings - indicates that almost no power savings measures will be used.
'//
'// {8c5e7fda-e8bf-4a96-9a85-a6e23a8c635c}
'//
$GUID_MIN_POWER_SAVINGS = GUID$("{8c5e7fda-e8bf-4a96-9a85-a6e23a8c635c}")

'//
'// Typical Power Savings - indicates that fairly aggressive power savings measures will be used.
'//
'// {381b4222-f694-41f0-9685-ff5bb260df2e}
'//
$GUID_TYPICAL_POWER_SAVINGS = GUID$("{381b4222-f694-41f0-9685-ff5bb260df2e}")

'//
'// This is a special GUID that represents "no subgroup" of settings.  That is, it indicates
'// that settings that are in the root of the power policy hierarchy as opposed to settings
'// that are buried under a subgroup of settings.  This should be used when querying for
'// power settings that may not fall into a subgroup.
'//
$NO_SUBGROUP_GUID = GUID$("{FEA3413E-7E05-4911-9A71-700331F1C294}")

'//
'// This is a special GUID that represents "every power scheme".  That is, it indicates
'// that any write to this power scheme should be reflected to every scheme present.
'// This allows users to write a single setting once and have it apply to all schemes.  They
'// can then apply custom settings to specific power schemes that they care about.
'//
$ALL_POWERSCHEMES_GUID = GUID$("{68A1E95E-13EA-41E1-8011-0C496CA490B0}")

'//
'// This is a special GUID that represents a 'personality' that each power scheme will have.
'// In other words, each power scheme will have this key indicating "I'm most like *this* base
'// power scheme."  This individual setting will have one of three settings:
'// GUID_MAX_POWER_SAVINGS
'// GUID_MIN_POWER_SAVINGS
'// GUID_TYPICAL_POWER_SAVINGS
'//
'// This allows several features:
'// 1. Drivers and applications can register for notification of this GUID.  So when this power
'//    scheme is activiated, this GUID's setting will be sent across the system and drivers/applications
'//    can see "GUID_MAX_POWER_SAVINGS" which will tell them in a generic fashion "get real aggressive
'//    about conserving power".
'// 2. UserB may install a driver or application which creates power settings, and UserB may modify
'//    those power settings.  Now UserA logs in.  How does he see those settings?  They simply don't
'//    exist in his private power key.  Well they do exist over in the system power key.  When we
'//    enumerate all the power settings in this system power key and don't find a corresponding entry
'//    in the user's private power key, then we can go look at this "personality" key in the users
'//    power scheme.  We can then go get a default value for the power setting, depending on which
'//    "personality" power scheme is being operated on.  Here's an example:
'//    A. UserB installs an application that creates a power setting Seetting1
'//    B. UserB changes Setting1 to have a value of 50 because that's one of the possible settings
'//       available for setting1.
'//    C. UserB logs out
'//    D. UserA logs in and his active power scheme is some custom scheme that was derived from
'//       the GUID_TYPICAL_POWER_SAVINGS.  But remember that UserA has no setting1 in his
'//       private power key.
'//    E. When activating UserA's selected power scheme, all power settings in the system power key will
'//       be enumerated (including Setting1).
'//    F. The power manager will see that UserA has no Setting1 power setting in his private power scheme.
'//    G. The power manager will query UserA's power scheme for its personality and retrieve
'//       GUID_TYPICAL_POWER_SAVINGS.
'//    H. The power manager then looks in Setting1 in the system power key and looks in its set of default
'//       values for the corresponding value for GUID_TYPICAL_POWER_SAVINGS power schemes.
'//    I. This derived power setting is applied.
$GUID_POWERSCHEME_PERSONALITY = GUID$("{245D8541-3943-4422-B025-13A784F679B7}")

'//
'// Define a special GUID which will be used to define the active power scheme.
'// User will register for this power setting GUID, and when the active power
'// scheme changes, they'll get a callback where the payload is the GUID
'// representing the active powerscheme.
'// ( 31F9F286-5084-42FE-B720-2B0264993763 }
'//
$GUID_ACTIVE_POWERSCHEME = GUID$("{31F9F286-5084-42FE-B720-2B0264993763}")

'//
'// =========================================
'// Define GUIDs which represent well-known power settings
'// =========================================
'//

'// Video settings
'// --------------
'//
'// Specifies the subgroup which will contain all of the video
'// settings for a single policy.
'//
$GUID_VIDEO_SUBGROUP = GUID$("{7516B95F-F776-4464-8C53-06167F40CC99}")

'//
'// Specifies (in seconds) how long we wait after the last user input has been
'// recieved before we power off the video.
'//
$GUID_VIDEO_POWERDOWN_TIMEOUT = GUID$("{3C0BC021-C8A8-4E07-A973-6B14CBCB2B7E}")

'//
'// Specifies if the operating system should use adaptive timers (based on
'// previous behavior) to power down the video,
'//
$GUID_VIDEO_ADAPTIVE_POWERDOWN = GUID$("{90959D22-D6A1-49B9-AF93-BCE885AD335B}")

'//
'// Specifies if the monitor is currently being powered or not.
'// 02731015-4510-4526-99E6-E5A17EBD1AEA
'//
$GUID_MONITOR_POWER_ON = GUID$("{02731015-4510-4526-99E6-E5A17EBD1AEA}")


'// Harddisk settings
'// -----------------
'//
'// Specifies the subgroup which will contain all of the harddisk
'// settings for a single policy.
'//
$GUID_DISK_SUBGROUP = GUID$("{0012EE47-9041-4B5D-9B77-535FBA8B1442}")

'//
'// Specifies (in seconds) how long we wait after the last disk access
'// before we power off the disk.
'//
$GUID_DISK_POWERDOWN_TIMEOUT = GUID$("{6738E2C4-E8A5-4A42-B16A-E040E769756E}")

'//
'// Specifies if the operating system should use adaptive timers (based on
'// previous behavior) to power down the disk,
'//
$GUID_DISK_ADAPTIVE_POWERDOWN = GUID$("{396A32E1-499A-40B2-9124-A96AFE707667}")

'// System sleep settings
'// ---------------------
'//
'// Specifies the subgroup which will contain all of the sleep
'// settings for a single policy.
'// { 238C9FA8-0AAD-41ED-83F4-97BE242C8F20 }
'//
$GUID_SLEEP_SUBGROUP = GUID$("{238C9FA8-0AAD-41ED-83F4-97BE242C8F20}")

'//
'// Specifies an idle treshold percentage (0-100). The system must be this idle
'// over a period of time in order to idle to sleep.
'//
$GUID_SLEEP_IDLE_THRESHOLD = GUID$("{81cd32e0-7833-44f3-8737-7081f38d1f70}")

'//
'// Specifies (in seconds) how long we wait after the system is deemed
'// "idle" before moving to standby (S1, S2 or S3).
'//
$GUID_STANDBY_TIMEOUT = GUID$("{29F6C1DB-86DA-48C5-9FDB-F2B67B1F44DA}")

'//
'// Specifies (in seconds) how long we wait after the system is deemed
'// "idle" before moving to hibernate (S4).
'//
$GUID_HIBERNATE_TIMEOUT = GUID$("{9D7815A6-7EE4-497E-8888-515A05F02364}")

'//
'// Specifies whether or not Fast S4 should be enabled if the system supports it
'// 94AC6D29-73CE-41A6-809F-6363BA21B47E
'//
$GUID_HIBERNATE_FASTS4_POLICY = GUID$("{94AC6D29-73CE-41A6-809F-6363BA21B47E}")

'//
'// Define a GUID for controlling the criticality of sleep state transitions.
'// Critical sleep transitions do not query applications, services or drivers
'// before transitioning the platform to a sleep state.
'//
'// {B7A27025-E569-46c2-A504-2B96CAD225A1}
'//
$GUID_CRITICAL_POWER_TRANSITION = GUID$("{B7A27025-E569-46c2-A504-2B96CAD225A1}")

'//
'// Specifies if the system is entering or exiting 'away mode'.
'// 98A7F580-01F7-48AA-9C0F-44352C29E5C0
'//
$GUID_SYSTEM_AWAYMODE = GUID$("{98A7F580-01F7-48AA-9C0F-44352C29E5C0}")

'// Specify whether away mode is allowed
'//
'// {25DFA149-5DD1-4736-B5AB-E8A37B5B8187}
'//
$GUID_ALLOW_AWAYMODE = GUID$("{25DFA149-5DD1-4736-B5AB-E8A37B5B8187}")

'//
'// Defines a guid for enabling/disabling standby (S1-S3) states. This does not
'// affect hibernation (S4).
'//
'// {abfc2519-3608-4c2a-94ea-171b0ed546ab}
'//
$GUID_ALLOW_STANDBY_STATES = GUID$("{abfc2519-3608-4c2a-94ea-171b0ed546ab}")

'//
'// Defines a guid for enabling/disabling the ability to wake via RTC.
'//
'// {BD3B718A-0680-4D9D-8AB2-E1D2B4AC806D}
'//
$GUID_ALLOW_RTC_WAKE = GUID$("{BD3B718A-0680-4D9D-8AB2-E1D2B4AC806D}")

'// System button actions
'// ---------------------
'//
'//
'// Specifies the subgroup which will contain all of the system button
'// settings for a single policy.
'//
$GUID_SYSTEM_BUTTON_SUBGROUP = GUID$("{4F971E89-EEBD-4455-A8DE-9E59040E7347}")

'// Specifies (in a POWER_ACTION_POLICY structure) the appropriate action to
'// take when the system power button is pressed.
'//
$GUID_POWERBUTTON_ACTION = GUID$("{7648EFA3-DD9C-4E3E-B566-50F929386280}")
$GUID_POWERBUTTON_ACTION_FLAGS = GUID$("{857E7FAC-034B-4704-ABB1-BCA54AA31478}")

'//
'// Specifies (in a POWER_ACTION_POLICY structure) the appropriate action to
'// take when the system sleep button is pressed.
'//
$GUID_SLEEPBUTTON_ACTION = GUID$("{96996BC0-AD50-47EC-923B-6F41874DD9EB}")
$GUID_SLEEPBUTTON_ACTION_FLAGS = GUID$("{2A160AB1-B69D-4743-B718-BF1441D5E493}")

'//
'// Specifies (in a POWER_ACTION_POLICY structure) the appropriate action to
'// take when the system sleep button is pressed.
'// { A7066653-8D6C-40A8-910E-A1F54B84C7E5 }
'//
$GUID_USERINTERFACEBUTTON_ACTION = GUID$("{A7066653-8D6C-40A8-910E-A1F54B84C7E5}")

'//
'// Specifies (in a POWER_ACTION_POLICY structure) the appropriate action to
'// take when the system lid is closed.
'//
$GUID_LIDCLOSE_ACTION = GUID$("{5CA83367-6E45-459F-A27B-476B1D01C936}")
$GUID_LIDCLOSE_ACTION_FLAGS = GUID$("{97E969AC-0D6C-4D08-927C-D7BD7AD7857B}")
$GUID_LIDOPEN_POWERSTATE = GUID$("{99FF10E7-23B1-4C07-A9D1-5C3206D741B4}")

'// Battery Discharge Settings
'// --------------------------
'//
'// Specifies the subgroup which will contain all of the battery discharge
'// settings for a single policy.
'//
$GUID_BATTERY_SUBGROUP = GUID$("{E73A048D-BF27-4F12-9731-8B2076E8891F}")

'//
'// 4 battery discharge alarm settings.
'//
'// GUID_BATTERY_DISCHARGE_ACTION_x - This is the action to take.  It is a value
'//                                   of type POWER_ACTION
'// GUID_BATTERY_DISCHARGE_LEVEL_x  - This is the battery level (%)
'// GUID_BATTERY_DISCHARGE_FLAGS_x  - Flags defined below:
'//                                   POWER_ACTION_POLICY->EventCode flags
'//                                   BATTERY_DISCHARGE_FLAGS_EVENTCODE_MASK
'//                                   BATTERY_DISCHARGE_FLAGS_ENABLE
$GUID_BATTERY_DISCHARGE_ACTION_0 = GUID$("{637EA02F-BBCB-4015-8E2C-A1C7B9C0B546}")
$GUID_BATTERY_DISCHARGE_LEVEL_0 = GUID$("{9A66D8D7-4FF7-4EF9-B5A2-5A326CA2A469}")
$GUID_BATTERY_DISCHARGE_FLAGS_0 = GUID$("{5dbb7c9f-38e9-40d2-9749-4f8a0e9f640f}")

$GUID_BATTERY_DISCHARGE_ACTION_1 = GUID$("{D8742DCB-3E6A-4B3C-B3FE-374623CDCF06}")
$GUID_BATTERY_DISCHARGE_LEVEL_1 = GUID$("{8183BA9A-E910-48DA-8769-14AE6DC1170A}")
$GUID_BATTERY_DISCHARGE_FLAGS_1 = GUID$("{bcded951-187b-4d05-bccc-f7e51960c258}")

$GUID_BATTERY_DISCHARGE_ACTION_2 = GUID$("{421CBA38-1A8E-4881-AC89-E33A8B04ECE4}")
$GUID_BATTERY_DISCHARGE_LEVEL_2 = GUID$("{07A07CA2-ADAF-40D7-B077-533AADED1BFA}")
$GUID_BATTERY_DISCHARGE_FLAGS_2 = GUID$("{7fd2f0c4-feb7-4da3-8117-e3fbedc46582}")

$GUID_BATTERY_DISCHARGE_ACTION_3 = GUID$("{80472613-9780-455E-B308-72D3003CF2F8}")
$GUID_BATTERY_DISCHARGE_LEVEL_3 = GUID$("{58AFD5A6-C2DD-47D2-9FBF-EF70CC5C5965}")
$GUID_BATTERY_DISCHARGE_FLAGS_3 = GUID$("{73613ccf-dbfa-4279-8356-4935f6bf62f3}")

'// Processor power settings
'// ------------------------
'//

'// Specifies the subgroup which will contain all of the processor
'// settings for a single policy.
'//
$GUID_PROCESSOR_SETTINGS_SUBGROUP = GUID$("{54533251-82BE-4824-96C1-47B60B740D00}")
$GUID_PROCESSOR_THROTTLE_POLICY = GUID$("{57027304-4AF6-4104-9260-E3D95248FC36}")

'//
'// Specifies a percentage (between 0 and 100) that the processor frequency
'// should never go above.  For example, if this value is set to 80, then
'// the processor frequency will never be throttled above 80 percent of its
'// maximum frequency by the system.
'//
$GUID_PROCESSOR_THROTTLE_MAXIMUM = GUID$("{BC5038F7-23E0-4960-96DA-33ABAF5935EC}")

'//
'// Specifies a percentage (between 0 and 100) that the processor frequency
'// should not drop below.  For example, if this value is set to 50, then the
'// processor frequency will never be throttled below 50 percent of its
'// maximum frequency by the system.
'//
$GUID_PROCESSOR_THROTTLE_MINIMUM = GUID$("{893DEE8E-2BEF-41E0-89C6-B55D0929964C}")

'//
'// Specifies processor power settings for CState policy data
'// {68F262A7-F621-4069-B9A5-4874169BE23C}
'//
$GUID_PROCESSOR_IDLESTATE_POLICY = GUID$("{68F262A7-F621-4069-B9A5-4874169BE23C}")

'//
'// Specifies processor power settings for PerfState policy data
'// {BBDC3814-18E9-4463-8A55-D197327C45C0}
'//
$GUID_PROCESSOR_PERFSTATE_POLICY = GUID$("{BBDC3814-18E9-4463-8A55-D197327C45C0}")

'//
'// Specifies active vs passive cooling.  Although not directly related to
'// processor settings, it is the processor that gets throttled if we're doing
'// passive cooling, so it is fairly strongly related.
'// {94D3A615-A899-4AC5-AE2B-E4D8F634367F}
'//
$GUID_SYSTEM_COOLING_POLICY = GUID$("{94D3A615-A899-4AC5-AE2B-E4D8F634367F}")

'// Lock Console on Wake
'// --------------------
'//

'// Specifies the behavior of the system when we wake from standby or
'// hibernate.  If this is set, then we will cause the console to lock
'// after we resume.
'//
$GUID_LOCK_CONSOLE_ON_WAKE = GUID$("{0E796BDB-100D-47D6-A2D5-F7D2DAA51F51}")

'// AC/DC power source
'// ------------------
'//

'// Specifies the power source for the system.  consumers may register for
'// notification when the power source changes and will be notified with
'// one of 3 values:
'// 0 - Indicates the system is being powered by an AC power source.
'// 1 - Indicates the system is being powered by a DC power source.
'// 2 - Indicates the system is being powered by a short-term DC power
'//     source.  For example, this would be the case if the system is
'//     being powed by a short-term battery supply in a backing UPS
'//     system.  When this value is recieved, the consumer should make
'//     preparations for either a system hibernate or system shutdown.
'//
'// { 5D3E9A59-E9D5-4B00-A6BD-FF34FF516548 }
$GUID_ACDC_POWER_SOURCE = GUID$("{5D3E9A59-E9D5-4B00-A6BD-FF34FF516548}")

'// Lid state changes
'// -----------------
'//
'// Specifies the current state of the lid (open or closed). The callback won't
'// be called at all until a lid device is found and its current state is known.
'//
'// Values:
'//
'// 0 - closed
'// 1 - opened
'//
'// { BA3E0F4D-B817-4094-A2D1-D56379E6A0F3 }
'//
$GUID_LIDSWITCH_STATE_CHANGE = GUID$("{BA3E0F4D-B817-4094-A2D1-D56379E6A0F3}")

'// Battery life remaining
'// ----------------------
'//

'// Specifies the percentage of battery life remaining.  The consumer
'// may register for notification in order to track battery life in
'// a fine-grained manner.
'//
'// Once registered, the consumer can expect to be notified as the battery
'// life percentage changes.
'//
'// The consumer will recieve a value between 0 and 100 (inclusive) which
'// indicates percent battery life remaining.
'//
'// { A7AD8041-B45A-4CAE-87A3-EECBB468A9E1 }
$GUID_BATTERY_PERCENTAGE_REMAINING = GUID$("{A7AD8041-B45A-4CAE-87A3-EECBB468A9E1}")

'// Notification to listeners that the system is fairly busy and won't be moving
'// into an idle state any time soon.  This can be used as a hint to listeners
'// that now might be a good time to do background tasks.
'//
$GUID_IDLE_BACKGROUND_TASK = GUID$("{515C31D8-F734-163D-A0FD-11A08C91E8F1}")

'// Notification to listeners that the system is fairly busy and won't be moving
'// into an idle state any time soon.  This can be used as a hint to listeners
'// that now might be a good time to do background tasks.
'//
'// { CF23F240-2A54-48D8-B114-DE1518FF052E }
$GUID_BACKGROUND_TASK_NOTIFICATION = GUID$("{CF23F240-2A54-48D8-B114-DE1518FF052E}")

'// Define a GUID that will represent the action of a direct experience button
'// on the platform.  Users will register for this DPPE setting and recieve
'// notification when the h/w button is pressed.
'//
'// { 1A689231-7399-4E9A-8F99-B71F999DB3FA }
'//
$GUID_APPLAUNCH_BUTTON = GUID$("{1A689231-7399-4E9A-8F99-B71F999DB3FA}")

'// PCI Express power settings
'// ------------------------
'//

'// Specifies the subgroup which will contain all of the PCI Express
'// settings for a single policy.
'//
'// {501a4d13-42af-4429-9fd1-a8218c268e20}
'//
$GUID_PCIEXPRESS_SETTINGS_SUBGROUP = GUID$("{501a4d13-42af-4429-9fd1-a8218c268e20}")

'// Specifies the PCI Express ASPM power policy.
'//
'// {ee12f906-d277-404b-b6da-e5fa1a576df5}
'//
$GUID_PCIEXPRESS_ASPM_POLICY = GUID$("{ee12f906-d277-404b-b6da-e5fa1a576df5}")

' SYSTEM_POWER_STATE enum
%PowerSystemUnspecified = 0
%PowerSystemWorking     = 1
%PowerSystemSleeping1   = 2
%PowerSystemSleeping2   = 3
%PowerSystemSleeping3   = 4
%PowerSystemHibernate   = 5
%PowerSystemShutdown    = 6
%PowerSystemMaximum     = 7

%POWER_SYSTEM_MAXIMUM = 7

' POWER_ACTION enum
%PowerActionNone          = 0
%PowerActionReserved      = 1
%PowerActionSleep         = 2
%PowerActionHibernate     = 3
%PowerActionShutdown      = 4
%PowerActionShutdownReset = 5
%PowerActionShutdownOff   = 6
%PowerActionWarmEject     = 7

' DEVICE_POWER_STATE enum
%PowerDeviceUnspecified = 0
%PowerDeviceD0          = 1
%PowerDeviceD1          = 2
%PowerDeviceD2          = 3
%PowerDeviceD3          = 4
%PowerDeviceMaximum     = 5

%ES_SYSTEM_REQUIRED   = &H00000001???
%ES_DISPLAY_REQUIRED  = &H00000002???
%ES_USER_PRESENT      = &H00000004???
%ES_AWAYMODE_REQUIRED = &H00000040???
%ES_CONTINUOUS        = &H80000000???

'typedef DWORD EXECUTION_STATE;

' LATENCY_TIME enum
%LT_DONT_CARE      = 0
%LT_LOWEST_LATENCY = 1

'#if (NTDDI_VERSION >= NTDDI_WINXP)

'//-----------------------------------------------------------------------------
'// Device Power Information
'// Accessable via CM_Get_DevInst_Registry_Property_Ex(CM_DRP_DEVICE_POWER_DATA)
'//-----------------------------------------------------------------------------

%PDCAP_D0_SUPPORTED              = &H00000001???
%PDCAP_D1_SUPPORTED              = &H00000002???
%PDCAP_D2_SUPPORTED              = &H00000004???
%PDCAP_D3_SUPPORTED              = &H00000008???
%PDCAP_WAKE_FROM_D0_SUPPORTED    = &H00000010???
%PDCAP_WAKE_FROM_D1_SUPPORTED    = &H00000020???
%PDCAP_WAKE_FROM_D2_SUPPORTED    = &H00000040???
%PDCAP_WAKE_FROM_D3_SUPPORTED    = &H00000080???
%PDCAP_WARM_EJECT_SUPPORTED      = &H00000100???

TYPE CM_POWER_DATA
   PD_Size                 AS DWORD   ' DWORD
   PD_MostRecentPowerState AS LONG    ' DEVICE_POWER_STATE
   PD_Capabilities         AS DWORD   ' DWORD
   PD_D1Latency            AS DWORD   ' DWORD
   PD_D2Latency            AS DWORD   ' DWORD
   PD_D3Latency            AS DWORD   ' DWORD
   PD_PowerStateMapping(%POWER_SYSTEM_MAXIMUM - 1) AS LONG   ' DEVICE_POWER_STATE
   PD_DeepestSystemWake    AS LONG    ' SYSTEM_POWER_STATE
END TYPE

'#endif // (NTDDI_VERSION >= NTDDI_WINXP)

' POWER_INFORMATION_LEVEL enum
%SystemPowerPolicyAc             = 0
%SystemPowerPolicyDc             = 1
%VerifySystemPolicyAc            = 2
%VerifySystemPolicyDc            = 3
%SystemPowerCapabilities         = 4
%SystemBatteryState              = 5
%SystemPowerStateHandler         = 6
%ProcessorStateHandler           = 7
%SystemPowerPolicyCurrent        = 8
%AdministratorPowerPolicy        = 9
%SystemReserveHiberFile          = 10
%ProcessorInformation            = 11
%SystemPowerInformation          = 12
%ProcessorStateHandler2          = 13
%LastWakeTime                    = 14   ' Compare with KeQueryInterruptTime()
%LastSleepTime                   = 15   ' Compare with KeQueryInterruptTime()
%SystemExecutionState            = 16
%SystemPowerStateNotifyHandler   = 17
%ProcessorPowerPolicyAc          = 18
%ProcessorPowerPolicyDc          = 19
%VerifyProcessorPowerPolicyAc    = 20
%VerifyProcessorPowerPolicyDc    = 21
%ProcessorPowerPolicyCurrent     = 22
%SystemPowerStateLogging         = 23
%SystemPowerLoggingEntry         = 24
%SetPowerSettingValue            = 25
%NotifyUserPowerSetting          = 26
%GetPowerTransitionVetoes        = 27
%SetPowerTransitionVeto          = 28
%SystemVideoState                = 29
%TraceApplicationPowerMessage    = 30
%TraceApplicationPowerMessageEnd = 31
%ProcessorPerfStates             = 32
%ProcessorIdleStates             = 33
%ProcessorThrottleStates         = 34
%SystemWakeSource                = 35
%SystemHiberFileInformation      = 36
%TraceServicePowerMessage        = 37
%ProcessorLoad                   = 38
%PowerShutdownNotification       = 39

'//
'// Power Transition Vetos
'//

%PO_TRANSITION_VETO_TYPE_WINDOW  = &H00000001???
%PO_TRANSITION_VETO_TYPE_SERVICE = &H00000002???
'//%PO_TRANSITION_VETO_TYPE_DRIVER  = &H00000004???

'#define PO_TRANSITION_VETO_TYPE_ALL     \
'    (PO_TRANSITION_VETO_TYPE_WINDOW | PO_TRANSITION_VETO_TYPE_SERVICE)
%PO_TRANSITION_VETO_TYPE_ALL = %PO_TRANSITION_VETO_TYPE_WINDOW OR %PO_TRANSITION_VETO_TYPE_SERVICE

TYPE PO_TRANSITION_VETO_REASON
   ResourceId       AS DWORD   ' DWORD
   ModuleNameOffset AS DWORD   ' DWORD
END TYPE

TYPE PO_TRANSITION_VETO_WINDOW
   Handle AS DWORD   ' HANDLE
END TYPE

TYPE PO_TRANSITION_VETO_SERVICE
   ServiceNameOffset AS DWORD
END TYPE

'/*

TYPE PO_TRANSITION_VETO_DRIVER
   InstancePathOffset AS DWORD   ' DWORD
   DriverNameOffset   AS DWORD   ' DWORD
END TYPE

'*/

UNION PO_TRANSITION_VETO_UNION
   Window  AS PO_TRANSITION_VETO_WINDOW
   Service AS PO_TRANSITION_VETO_SERVICE
   ' //Driver AS PO_TRANSITION_VETO_DRIVER
END UNION

TYPE PO_TRANSITION_VETO
   Type      AS DWORD
   Reason    AS PO_TRANSITION_VETO_REASON
   ProcessId AS DWORD
   PO_TRANSITION_VETO_UNION
END TYPE

TYPE PO_TRANSITION_VETOES
   Count AS DWORD
   Vetoes(0) AS PO_TRANSITION_VETO
END TYPE

'//
'// Power Setting definitions
'//

' enum SYSTEM_POWER_CONDITION
%PoAc               = 0
%PoDc               = 1
%PoHot              = 2
%PoConditionMaximum = 3

TYPE SET_POWER_SETTING_VALUE
   Version        AS DWORD
   Guid           AS GUID
   PowerCondition AS DWORD   ' SYSTEM_POWER_CONDITION
   DataLength     AS DWORD
   Data(0)        AS BYTE
END TYPE

%POWER_SETTING_VALUE_VERSION = &H1

TYPE NOTIFY_USER_POWER_SETTING
   Guid AS GUID
END TYPE

'//
'// Package definition for an experience button device notification.  When
'// someone registers for GUID_EXPERIENCE_BUTTON, this is the definition of
'// the setting data they'll get.
'//
TYPE APPLICATIONLAUNCH_SETTING_VALUE
   ActivationTime   AS QUAD    ' LARGE_INTEGER
   Flags            AS DWORD   ' DWORD
   ButtonInstanceID AS DWORD   ' DWORD
END TYPE

'//
'// define platform roles
'//

' enum POWER_PLATFORM_ROLE
%PlatformRoleUnspecified       = 0
%PlatformRoleDesktop           = 1
%PlatformRoleMobile            = 2
%PlatformRoleWorkstation       = 3
%PlatformRoleEnterpriseServer  = 4
%PlatformRoleSOHOServer        = 5
%PlatformRoleAppliancePC       = 6
%PlatformRolePerformanceServer = 7
%PlatformRoleMaximum           = 8

'//
'// Wake source tracking
'//

' enum PO_WAKE_SOURCE_TYPE
%DeviceWakeSourceType = 0
%FixedWakeSourceType  = 1

' enum PO_FIXED_WAKE_SOURCE_TYPE
%FixedWakeSourcePowerButton = 0
%FixedWakeSourceSleepButton = 1
%FixedWakeSourceRtc         = 2

TYPE PO_WAKE_SOURCE_HEADER
   Type AS DWORD   ' PO_WAKE_SOURCE_TYPE
   Size AS DWORD   ' DWORD
END TYPE

TYPE PO_WAKE_SOURCE_DEVICE
   Header          AS PO_WAKE_SOURCE_HEADER
   InstancePath(0) AS WORD PTR   ' WCHAR
END TYPE

TYPE PO_WAKE_SOURCE_FIXED
   Header              AS PO_WAKE_SOURCE_HEADER
   FixedWakeSourceType AS DWORD                   ' PO_FIXED_WAKE_SOURCE_TYPE
END TYPE

TYPE PO_WAKE_SOURCE_INFO
   Count      AS DWORD   ' DWORD
   Offsets(0) AS DWORD   ' DWORD
END TYPE

TYPE PO_WAKE_SOURCE_HISTORY
   Count      AS DWORD   ' DWORD
   Offsets(0) AS DWORD
END TYPE


'//
'// System power manager capabilities
'//

'#if (NTDDI_VERSION >= NTDDI_WINXP) || !defined(_BATCLASS_)
TYPE BATTERY_REPORTING_SCALE
   Granularity AS DWORD
   Capacity    AS DWORD
END TYPE
'#endif // (NTDDI_VERSION >= NTDDI_WINXP) || !defined(_BATCLASS_)

TYPE PPM_SIMULATED_PROCESSOR_LOAD
   Enabled AS BYTE   ' BOOLEAN
   PercentBusy(%MAXIMUM_PROCESSORS - 1) AS BYTE
END TYPE

TYPE PPM_WMI_LEGACY_PERFSTATE
   Frequency        AS DWORD   ' DWORD
   Flags            AS DWORD   ' DWORD
   PercentFrequency AS DWORD   ' DWORD
END TYPE

TYPE PPM_WMI_IDLE_STATE
   Latency        AS DWORD   ' DWORD
   Power          AS DWORD   ' DWORD
   TimeCheck      AS DWORD   ' DWORD
   PromotePercent AS BYTE    ' BYTE
   DemotePercent  AS BYTE    ' BYTE
   StateType      AS BYTE    ' BYTE
   Reserved       AS BYTE    ' BYTE
   StateFlags     AS DWORD   ' DWORD
   Context        AS DWORD   ' DWORD
   IdleHandler    AS DWORD   ' DWORD
   Reserved1      AS DWORD   ' DWORD // reserved for future use
END TYPE

TYPE PPM_WMI_IDLE_STATES
   Type             AS DWORD   ' DWORD
   Count            AS DWORD   ' DWORD
   TargetState      AS DWORD   ' DWORD // current idle state
   OldState         AS DWORD   ' DWORD // previous idle state
   TargetProcessors AS QUAD    ' DWORD64
   State(0)         AS PPM_WMI_IDLE_STATE
END TYPE

TYPE PPM_WMI_PERF_STATE
   Frequency        AS DWORD   ' DWORD // in Mhz
   Power            AS DWORD   ' DWORD// in milliwatts
   PercentFrequency AS BYTE    ' BYTE
   IncreaseLevel    AS BYTE    ' BYTE // goto higher state
   DecreaseLevel    AS BYTE    ' BYTE // goto lower state
   Type             AS BYTE    ' BYTE // performance or throttle
   IncreaseTime     AS DWORD   ' DWORD // in tick counts
   DecreaseTime     AS DWORD   ' DWORD // in tick counts
   Control          AS QUAD    ' DWORD64 // control value
   Status           AS QUAD    ' DWORD64 // control value
   HitCount         AS DWORD   ' DWORD
   Reserved1        AS DWORD   ' DWORD // reserved for future use
   Reserved2        AS DWORD   ' DWORD64
   Reserved3        AS DWORD   ' DWORD64
END TYPE

TYPE PPM_WMI_PERF_STATES
   Count             AS DWORD   ' DWORD
   MaxFrequency      AS DWORD   ' DWORD
   CurrentState      AS DWORD   ' DWORD // current state
   MaxPerfState      AS DWORD   ' DWORD // fastest state considering policy restrictions
   MinPerfState      AS DWORD   ' DWORD // slowest state considering policy restrictions
   LowestPerfState   AS DWORD   ' DWORD // slowest perf state, fixed, aka the "knee"
   ThermalConstraint AS DWORD   ' DWORD
   BusyAdjThreshold  AS BYTE    ' BYTE
   PolicyType        AS BYTE    ' BYTE // domain coordination
   Type              AS BYTE    ' BYTE
   Reserved          AS BYTE    ' BYTE
   TimerInterval     AS DWORD   ' DWORD
   TargetProcessors  AS QUAD    ' DWORD64 // domain affinity
   PStateHandler     AS DWORD   ' DWORD
   PStateContext     AS DWORD   ' DWORD
   TStateHandler     AS DWORD   ' DWORD
   TStateContext     AS DWORD   ' DWORD
   FeedbackHandler   AS DWORD   ' DWORD
   Reserved1         AS DWORD   ' DWORD
   Reserved2         AS QUAD    ' DWORD64
   State(0)          AS PPM_WMI_PERF_STATE
END TYPE

'//
'// Accounting info.
'//

%PROC_IDLE_BUCKET_COUNT = 6

TYPE PPM_IDLE_STATE_ACCOUNTING
   IdleTransitions    AS DWORD   ' DWORD
   FailedTransitions  AS DWORD   ' DWORD
   InvalidBucketIndex AS DWORD   ' DWORD
   TotalTime          AS QUAD    ' DWORD64
   IdleTimeBuckets(%PROC_IDLE_BUCKET_COUNT - 1) AS DWORD   ' DWORD
END TYPE

TYPE PPM_IDLE_ACCOUNTING
   StateCount       AS DWORD   ' DWORD
   TotalTransitions AS DWORD   ' DWORD
   ResetCount       AS DWORD   ' DWORD
   StartTime        AS QUAD    ' DWPRD64
   State(0)         AS PPM_IDLE_STATE_ACCOUNTING
END TYPE

'//
'// Definitions of coordination types for _PSD, _TSD, and _CSD BIOS objects from
'// the Acpi 3.0 specification
'//

%ACPI_PPM_SOFTWARE_ALL     = &HFC
%ACPI_PPM_SOFTWARE_ANY     = &HFD
%ACPI_PPM_HARDWARE_ALL     = &HFE

'//
'// Definition of Microsoft PPM coordination types.
'//

%MS_PPM_SOFTWARE_ALL       = &H1

'//
'// Processor Power Management WMI interface.
'//

$PPM_PERFSTATE_CHANGE_GUID = GUID$("{A5B32DDD-7F39-4abc-B892-900E43B59EBB}")
$PPM_PERFSTATE_DOMAIN_CHANGE_GUID = GUID$("{995e6b7f-d653-497a-b978-36a30c29bf01}")
$PPM_IDLESTATE_CHANGE_GUID = GUID$("{4838fe4f-f71c-4e51-9ecc-8430a7ac4c6c}")
$PPM_PERFSTATES_DATA_GUID = GUID$("{5708cc20-7d40-4bf4-b4aa-2b01338d0126}")
$PPM_IDLESTATES_DATA_GUID = GUID$("{ba138e10-e250-4ad7-8616-cf1a7ad410e7}")
$PPM_IDLE_ACCOUNTING_GUID = GUID$("{e2a26f78-ae07-4ee0-a30f-ce354f5a94cd}")
$PPM_THERMALCONSTRAINT_GUID = GUID$("{a852c2c8-1a4c-423b-8c2c-f30d82931a88}")
$PPM_PERFMON_PERFSTATE_GUID = GUID$("{7fd18652-0cfe-40d2-b0a1-0b066a87759e}")
$PPM_THERMAL_POLICY_CHANGE_GUID = GUID$("{48f377b8-6880-4c7b-8bdc-380176c6654d}")

TYPE PPM_PERFSTATE_EVENT
   State     AS DWORD   ' DWORD
   Status    AS DWORD   ' DWORD
   Latency   AS DWORD   ' DWORD
   Speed     AS DWORD   ' DWORD
   Processor AS DWORD   ' DWORD
END TYPE

TYPE PPM_PERFSTATE_DOMAIN_EVENT
   State      AS DWORD   ' DWORD
   Latency    AS DWORD   ' DWORD
   Speed      AS DWORD   ' DWORD
   Processors AS QUAD    ' DWORD64
END TYPE

TYPE PPM_IDLESTATE_EVENT
   NewState   AS DWORD   ' DWORD
   OldState   AS DWORD   ' DWORD
   Processors AS QUAD    ' DWORD64
END TYPE

TYPE PPM_THERMALCHANGE_EVENT
   ThermalConstraint AS DWORD   ' DWORD
   Processors        AS QUAD   ' DWORD64
END TYPE

'#pragma warning(push)
'#pragma warning(disable:4121)

TYPE PPM_THERMAL_POLICY_EVENT
   Mode       AS BYTE   ' BYTE
   Processors AS QUAD   ' DWORD64
END TYPE

'#pragma warning(pop)

'//
'// Power Policy Management interfaces
'//

TYPE POWER_ACTION_POLICY
   Action    AS LONG    ' POWER_ACTION
   Flags     AS DWORD   ' DWORD
   EventCode AS DWORD   ' DWORD
END TYPE

'// POWER_ACTION_POLICY->Flags:
%POWER_ACTION_QUERY_ALLOWED    = &H00000001???
%POWER_ACTION_UI_ALLOWED       = &H00000002???
%POWER_ACTION_OVERRIDE_APPS    = &H00000004???
%POWER_ACTION_LIGHTEST_FIRST   = &H10000000???
%POWER_ACTION_LOCK_CONSOLE     = &H20000000???
%POWER_ACTION_DISABLE_WAKES    = &H40000000???
%POWER_ACTION_CRITICAL         = &H80000000???

'// POWER_ACTION_POLICY->EventCode flags
%POWER_LEVEL_USER_NOTIFY_TEXT  = &H00000001???
%POWER_LEVEL_USER_NOTIFY_SOUND = &H00000002???
%POWER_LEVEL_USER_NOTIFY_EXEC  = &H00000004???
%POWER_USER_NOTIFY_BUTTON      = &H00000008???
%POWER_USER_NOTIFY_SHUTDOWN    = &H00000010???
%POWER_FORCE_TRIGGER_RESET     = &H80000000???

'// Note: for battery alarm EventCodes, the ID of the battery alarm << 16 is ORed
'// into the flags.  For example: DISCHARGE_POLICY_LOW << 16

'//
'// The GUID_BATTERY_DISCHARGE_FLAGS_x power settings use a subset of EventCode
'// flags.  The POWER_FORCE_TRIGGER_RESET flag doesn't make sense for a battery
'// alarm so it is overloaded for other purposes (gerneral enable/disable).
%BATTERY_DISCHARGE_FLAGS_EVENTCODE_MASK = &H00000007???
%BATTERY_DISCHARGE_FLAGS_ENABLE         = &H80000000???

'// system battery drain policies
TYPE SYSTEM_POWER_LEVEL
   Enabled        AS BYTE                  ' BOOLEAN
   Spare(2)       AS BYTE                  ' BYTE
   BatteryLevel   AS DWORD                 ' DWORD
   PowerPolicy    AS POWER_ACTION_POLICY   ' POWER_ACTION_POLICY
   MinSystemState AS LONG                  ' SYSTEM_POWER_STATE
END TYPE

'// Discharge policy constants
%NUM_DISCHARGE_POLICIES    = 4
%DISCHARGE_POLICY_CRITICAL = 0
%DISCHARGE_POLICY_LOW      = 1

'// system power policies
'typedef struct _SYSTEM_POWER_POLICY {
'    DWORD                   Revision;       // 1

'    // events
'    POWER_ACTION_POLICY     PowerButton;
'    POWER_ACTION_POLICY     SleepButton;
'    POWER_ACTION_POLICY     LidClose;
'    SYSTEM_POWER_STATE      LidOpenWake;
'    DWORD                   Reserved;

'    // "system idle" detection
'    POWER_ACTION_POLICY     Idle;
'    DWORD                   IdleTimeout;
'    BYTE                    IdleSensitivity;

'    // dynamic throttling policy
'    //      PO_THROTTLE_NONE, PO_THROTTLE_CONSTANT, PO_THROTTLE_DEGRADE, or PO_THROTTLE_ADAPTIVE
'    BYTE                    DynamicThrottle;

'    BYTE                    Spare2[2];

'    // meaning of power action "sleep"
'    SYSTEM_POWER_STATE      MinSleep;
'    SYSTEM_POWER_STATE      MaxSleep;
'    SYSTEM_POWER_STATE      ReducedLatencySleep;
'    DWORD                   WinLogonFlags;

'    // parameters for dozing
'    DWORD                   Spare3;
'    DWORD                   DozeS4Timeout;

'    // battery policies
'    DWORD                   BroadcastCapacityResolution;
'    SYSTEM_POWER_LEVEL      DischargePolicy[NUM_DISCHARGE_POLICIES];

'    // video policies
'    DWORD                   VideoTimeout;
'    BOOLEAN                 VideoDimDisplay;
'    DWORD                   VideoReserved[3];

'    // hard disk policies
'    DWORD                   SpindownTimeout;

'    // processor policies
'    BOOLEAN                 OptimizeForPower;
'    BYTE                    FanThrottleTolerance;
'    BYTE                    ForcedThrottle;
'    BYTE                    MinThrottle;
'    POWER_ACTION_POLICY     OverThrottled;

'} SYSTEM_POWER_POLICY, *PSYSTEM_POWER_POLICY;

TYPE SYSTEM_POWER_POLICY
   Revision                    AS DWORD                 ' DWORD
   ' events
   PowerButton                 AS POWER_ACTION_POLICY   ' POWER_ACTION_POLICY
   SleepButton                 AS POWER_ACTION_POLICY   ' POWER_ACTION_POLICY
   LidClose                    AS POWER_ACTION_POLICY   ' POWER_ACTION_POLICY
   LidOpenWake                 AS LONG                  ' SYSTEM_POWER_STATE
   Reserved                    AS DWORD                 ' DWORD
   ' "system idle" detection
   Idle                        AS POWER_ACTION_POLICY   ' POWER_ACTION_POLICY
   IdleTimeout                 AS DWORD                 ' DWORD
   IdleSensitivity             AS BYTE                  ' BYTE
   ' dynamic throttling policy
   '      PO_THROTTLE_NONE, PO_THROTTLE_CONSTANT, PO_THROTTLE_DEGRADE, or PO_THROTTLE_ADAPTIVE
   DynamicThrottle             AS BYTE                  ' BYTE
   Spare2(1)                   AS BYTE                  ' BYTE
   ' meaning of power action "sleep"
   MinSleep                    AS LONG                  ' SYSTEM_POWER_STATE
   MaxSleep                    AS LONG                  ' SYSTEM_POWER_STATE
   ReducedLatencySleep         AS LONG                  ' SYSTEM_POWER_STATE
   WinLogonFlags               AS DWORD                 ' DWORD
   ' parameters for dozing
   Spare3                      AS DWORD                 ' DWORD
   DozeS4Timeout               AS DWORD                 ' DWORD
   ' battery policies
   BroadcastCapacityResolution AS DWORD                 ' DWORD
   DischargePolicy(%NUM_DISCHARGE_POLICIES - 1) AS SYSTEM_POWER_LEVEL
   ' video policies
   VideoTimeout                AS DWORD                 ' DWORD
   VideoDimDisplay             AS BYTE                  ' BOOLEAN
   VideoReserved(2)            AS DWORD                 ' DWORD
   ' hard disk policies
   SpindownTimeout             AS DWORD                 ' DWORD
   ' processor policies
   OptimizeForPower            AS BYTE                  ' BOOLEAN
   FanThrottleTolerance        AS BYTE                  ' BYTE
   ForcedThrottle              AS BYTE                  ' BYTE
   MinThrottle                 AS BYTE                  ' BYTE
   OverThrottled               AS POWER_ACTION_POLICY   ' POWER_ACTION_POLICY
END TYPE

'// processor power policy state

'//
'// Processor Idle State Policy.
'//

%PROCESSOR_IDLESTATE_POLICY_COUNT = &H3

TYPE PROCESSOR_IDLESTATE_INFO
   TimeCheck      AS DWORD   ' DWORD
   DemotePercent  AS BYTE   ' BYTE
   PromotePercent AS BYTE   ' BYTE
   Spare(1)       AS BYTE   ' BYTE
END TYPE

TYPE PROCESSOR_IDLESTATE_POLICY_UNNAMED_STRUCT
   AllowScaling AS BIT * 1 IN WORD
   Disabled     AS BIT * 1
   Reserved     AS BIT * 14
END TYPE

UNION PROCESSOR_IDLESTATE_POLICY_UNNAMED_UNION
   AsWORD  AS WORD   ' DWORD
   PROCESSOR_IDLESTATE_POLICY_UNNAMED_STRUCT
END UNION

TYPE PROCESSOR_IDLESTATE_POLICY
   Revision    AS WORD    ' WORD
   Flags       AS PROCESSOR_IDLESTATE_POLICY_UNNAMED_UNION
   PolicyCount AS DWORD   ' DWORD
   Policy(%PROCESSOR_IDLESTATE_POLICY_COUNT - 1) AS PROCESSOR_IDLESTATE_INFO
END TYPE

'//
'// Legacy Processor Policy.  This is only provided to allow legacy
'// applications to compile.  New applications must use
'// PROCESSOR_IDLESTATE_POLICY.
'//

%PO_THROTTLE_NONE     = 0
%PO_THROTTLE_CONSTANT = 1
%PO_THROTTLE_DEGRADE  = 2
%PO_THROTTLE_ADAPTIVE = 3
%PO_THROTTLE_MAXIMUM  = 4   ' not a policy, just a limit

'typedef struct _PROCESSOR_POWER_POLICY_INFO {

'    // Time based information (will be converted to kernel units)
'    DWORD                   TimeCheck;                      // in US
'    DWORD                   DemoteLimit;                    // in US
'    DWORD                   PromoteLimit;                   // in US

'    // Percentage based information
'    BYTE                    DemotePercent;
'    BYTE                    PromotePercent;
'    BYTE                    Spare[2];

'    // Flags
'    DWORD                   AllowDemotion:1;
'    DWORD                   AllowPromotion:1;
'    DWORD                   Reserved:30;

'} PROCESSOR_POWER_POLICY_INFO, *PPROCESSOR_POWER_POLICY_INFO;

TYPE PROCESSOR_POWER_POLICY_INFO
   ' Time based information (will be converted to kernel units)
   TimeCheck      AS DWORD       ' DWORD // in US
   DemoteLimit    AS DWORD       ' DWORD // in US
   PromoteLimit   AS DWORD       ' DWORD // in US
   ' Percentage based information
   DemotePercent  AS BYTE        ' BYTE
   PromotePercent AS BYTE        ' BYTE
   Spare(1)       AS BYTE        ' BYTE
   ' Flags
   AllowDemotion  AS BIT * 1 IN DWORD
   AllowPromotion AS BIT * 1
   Reserved       AS BIT * 30
END TYPE

'// processor power policy
'typedef struct _PROCESSOR_POWER_POLICY {
'    DWORD                       Revision;       // 1

'    // Dynamic Throttling Policy
'    BYTE                        DynamicThrottle;
'    BYTE                        Spare[3];

'    // Flags
'    DWORD                       DisableCStates:1;
'    DWORD                       Reserved:31;

'    // System policy information
'    // The Array is last, in case it needs to be grown and the structure
'    // revision incremented.
'    DWORD                       PolicyCount;
'    PROCESSOR_POWER_POLICY_INFO Policy[3];

'} PROCESSOR_POWER_POLICY, *PPROCESSOR_POWER_POLICY;

TYPE PROCESSOR_POWER_POLICY
   Revision        AS DWORD
   ' Dynamic Throttling Policy
   DynamicThrottle AS BYTE
   Spare(2)        AS BYTE
   ' Flags
   DisableCStates  AS BIT * 1 IN DWORD
   Reserved        AS BIT * 31
   ' System policy information
   ' The Array is last, in case it needs to be grown and the structure
   ' revision incremented.
   PolicyCount     AS DWORD
   Policy(2)       AS PROCESSOR_POWER_POLICY_INFO
END TYPE

'//
'// Processor Perf State Policy.
'//

%PERFSTATE_POLICY_CHANGE_IDEAL  = &H00
%PERFSTATE_POLICY_CHANGE_SINGLE = &H01
%PERFSTATE_POLICY_CHANGE_ROCKET = &H02
%PERFSTATE_POLICY_CHANGE_MAX    = %PERFSTATE_POLICY_CHANGE_ROCKET

TYPE PROCESSOR_PERFSTATE_POLICY_UNNAMED_STRUCT
   NoDomainAccounting AS BIT * 1 IN BYTE
   IncreasePolicy     AS BIT * 2
   DecreasePolicy     AS BIT * 2
   Reserved           AS BIT * 3
END TYPE

UNION PROCESSOR_PERFSTATE_POLICY_UNNAMED_UNION
   AsBYTE AS BYTE   ' BYTE
   PROCESSOR_PERFSTATE_POLICY_UNNAMED_STRUCT
END UNION

TYPE PROCESSOR_PERFSTATE_POLICY
   Revision         AS DWORD   ' DWORD
   MaxThrottle      AS BYTE   ' BYTE
   MinThrottle      AS BYTE   ' BYTE
   BusyAdjThreshold AS BYTE   ' BYTE
   Flags            AS PROCESSOR_PERFSTATE_POLICY_UNNAMED_UNION
   TimeCheck        AS DWORD   ' DWORD
   IncreaseTime     AS DWORD   ' DWORD
   DecreaseTime     AS DWORD   ' DWORD
   IncreasePercent  AS DWORD   ' DWORD
   DecreasePercent  AS DWORD   ' DWORD
END TYPE

'// administrator power policy overrides
TYPE ADMINISTRATOR_POWER_POLICY
   ' meaning of power action "sleep"
   MinSleep           AS LONG    ' SYSTEM_POWER_STATE
   MaxSleep           AS LONG    ' SYSTEM_POWER_STATE
   ' video policies
   MinVideoTimeout    AS DWORD   ' DWORD
   MaxVideoTimeout    AS DWORD   ' DWORD
   ' disk policies
   MinSpindownTimeout AS DWORD   ' DWORD
   MaxSpindownTimeout AS DWORD   ' DWORD
END TYPE

TYPE SYSTEM_POWER_CAPABILITIES
   ' Misc supported system features
   PowerButtonPresent     AS BYTE   ' BOOLEAN
   SleepButtonPresent     AS BYTE   ' BOOLEAN
   LidPresent             AS BYTE   ' BOOLEAN
   SystemS1               AS BYTE   ' BOOLEAN
   SystemS2               AS BYTE   ' BOOLEAN
   SystemS3               AS BYTE   ' BOOLEAN
   SystemS4               AS BYTE   ' BOOLEAN  // hibernate
   SystemS5               AS BYTE   ' BOOLEAN  // off
   HiberFilePresent       AS BYTE   ' BOOLEAN
   FullWake               AS BYTE   ' BOOLEAN
   VideoDimPresent        AS BYTE   ' BOOLEAN
   ApmPresent             AS BYTE   ' BOOLEAN
   UpsPresent             AS BYTE   ' BOOLEAN

    ' Processors
   ThermalControl         AS BYTE   ' BOOLEAN
   ProcessorThrottle      AS BYTE   ' BOOLEAN
   ProcessorMinThrottle   AS BYTE   ' BYTE
   ProcessorMaxThrottle   AS BYTE   ' BYTE
   spare2(3)              AS BYTE   ' BYTE

    ' Disk
   DiskSpinDown           AS BYTE   ' BOOLEAN
   spare3(7)              AS BYTE   ' BYTE

    ' System Battery
   SystemBatteriesPresent AS BYTE   ' BOOLEAN
   BatteriesAreShortTerm  AS BYTE   ' BOOLEAN
   BatteryScale(2)        AS BATTERY_REPORTING_SCALE

    ' Wake
   AcOnLineWake           AS LONG   ' SYSTEM_POWER_STATE
   SoftLidWake            AS LONG   ' SYSTEM_POWER_STATE
   RtcWake                AS LONG   ' SYSTEM_POWER_STATE
   MinDeviceWakeState     AS LONG   ' SYSTEM_POWER_STATE ' note this may change on driver load
   DefaultLowLatencyWake  AS LONG   ' SYSTEM_POWER_STATE
END TYPE

TYPE SYSTEM_BATTERY_STATE
   AcOnLine          AS BYTE    ' BOOLEAN
   BatteryPresent    AS BYTE    ' BOOLEAN
   Charging          AS BYTE    ' BOOLEAN
   Discharging       AS BYTE    ' BOOLEAN
   Spare1(3)         AS BYTE    ' BOOLEAN

   MaxCapacity       AS DWORD   ' DWORD
   RemainingCapacity AS DWORD   ' DWORD
   Rate              AS DWORD   ' DWORD
   EstimatedTime     AS DWORD   ' DWORD

   DefaultAlert1     AS DWORD   ' DWORD
   DefaultAlert2     AS DWORD   ' DWORD
END TYPE

'//
'// Image Format
'//

'#ifndef _MAC

'#include "pshpack4.h"                   // 4 byte packing is the default

'#define IMAGE_DOS_SIGNATURE                 0x5A4D      // MZ
'#define IMAGE_OS2_SIGNATURE                 0x454E      // NE
'#define IMAGE_OS2_SIGNATURE_LE              0x454C      // LE
'#define IMAGE_VXD_SIGNATURE                 0x454C      // LE
'#define IMAGE_NT_SIGNATURE                  0x00004550  // PE00

'#include "pshpack2.h"                   // 16 bit headers are 2 byte packed

'#else

'#include "pshpack1.h"

%IMAGE_DOS_SIGNATURE    = &H5A4D      ' MZ
%IMAGE_OS2_SIGNATURE    = &H454E      ' NE
%IMAGE_OS2_SIGNATURE_LE = &H454C      ' LE
%IMAGE_VXD_SIGNATURE    = &H454C      ' LE
%IMAGE_NT_SIGNATURE     = &H00004550  ' PE00

TYPE IMAGE_DOS_HEADER
   e_magic    AS WORD   ' Magic number
   e_cblp     AS WORD   ' Bytes on last page of file
   e_cp       AS WORD   ' Pages in file
   e_crlc     AS WORD   ' Relocations
   e_cparhdr  AS WORD   ' Size of header in paragraphs
   e_minalloc AS WORD   ' Minimum extra paragraphs needed
   e_maxalloc AS WORD   ' Maximum extra paragraphs needed
   e_ss       AS WORD   ' Initial (relative) SS value
   e_sp       AS WORD   ' Initial SP value
   e_csum     AS WORD   ' Checksum
   e_ip       AS WORD   ' Initial IP value
   e_cs       AS WORD   ' Initial (relative) CS value
   e_lfarlc   AS WORD   ' File address of relocation table
   e_ovno     AS WORD   ' Overlay number
   e_res(3)   AS WORD   ' Reserved words
   e_oemid    AS WORD   ' OEM identifier (for e_oeminfo)
   e_oeminfo  AS WORD   ' OEM information; e_oemid specific
   e_res2(9)  AS WORD   ' Reserved words
   e_lfanew   AS LONG   ' File address of new exe header
END TYPE

TYPE IMAGE_OS2_HEADER      ' OS/2 .EXE header
   ne_magic        AS WORD   ' WORD // Magic number
   ne_ver          AS BYTE   ' CHAR // Version number
   ne_rev          AS BYTE   ' CHAR // Revision number
   ne_enttab       AS WORD   ' WORD // Offset of Entry Table
   ne_cbenttab     AS WORD   ' WORD // Number of bytes in Entry Table
   ne_crc          AS LONG   ' LONG // Checksum of whole file
   ne_flags        AS WORD   ' WORD // Flag word
   ne_autodata     AS WORD   ' WORD // Automatic data segment number
   ne_heap         AS WORD   ' WORD // Initial heap allocation
   ne_stack        AS WORD   ' WORD // Initial stack allocation
   ne_csip         AS LONG   ' LONG // Initial CS:IP setting
   ne_sssp         AS LONG   ' LONG // Initial SS:SP setting
   ne_cseg         AS WORD   ' WORD // Count of file segments
   ne_cmod         AS WORD   ' WORD // Entries in Module Reference Table
   ne_cbnrestab    AS WORD   ' WORD // Size of non-resident name table
   ne_segtab       AS WORD   ' WORD // Offset of Segment Table
   ne_rsrctab      AS WORD   ' WORD // Offset of Resource Table
   ne_restab       AS WORD   ' WORD // Offset of resident name table
   ne_modtab       AS WORD   ' WORD // Offset of Module Reference Table
   ne_imptab       AS WORD   ' WORD // Offset of Imported Names Table
   ne_nrestab      AS LONG   ' LONG // Offset of Non-resident Names Table
   ne_cmovent      AS WORD   ' WORD // Count of movable entries
   ne_align        AS WORD   ' WORD // Segment alignment shift count
   ne_cres         AS WORD   ' WORD // Count of resource segments
   ne_exetyp       AS BYTE   ' BYTE // Target Operating system
   ne_flagsothers  AS BYTE   ' BYTE // Other .EXE flags
   ne_pretthunks   AS WORD   ' WORD // offset to return thunks
   ne_psegrefbytes AS WORD   ' WORD // offset to segment ref. bytes
   ne_swaparea     AS WORD   ' WORD // Minimum code swap area size
   ne_expver       AS WORD   ' WORD // Expected Windows version number
END TYPE

TYPE IMAGE_VXD_HEADER       ' Windows VXD header
   e32_magic        AS WORD          ' WORD  // Magic number
   e32_border       AS BYTE          ' BYTE  // The byte ordering for the VXD
   e32_worder       AS BYTE          ' BYTE  // The word ordering for the VXD
   e32_level        AS DWORD         ' DWORD // The EXE format level for now = 0
   e32_cpu          AS WORD          ' WORD  // The CPU type
   e32_os           AS WORD          ' WORD  // The OS type
   e32_ver          AS DWORD         ' DWORD // Module version
   e32_mflags       AS DWORD         ' DWORD // Module flags
   e32_mpages       AS DWORD         ' DWORD // Module # pages
   e32_startobj     AS DWORD         ' DWORD // Object # for instruction pointer
   e32_eip          AS DWORD         ' DWORD // Extended instruction pointer
   e32_stackobj     AS DWORD         ' DWORD // Object # for stack pointer
   e32_esp          AS DWORD         ' DWORD // Extended stack pointer
   e32_pagesize     AS DWORD         ' DWORD // VXD page size
   e32_lastpagesize AS DWORD         ' DWORD // Last page size in VXD
   e32_fixupsize    AS DWORD         ' DWORD // Fixup section size
   e32_fixupsum     AS DWORD         ' DWORD // Fixup section checksum
   e32_ldrsize      AS DWORD         ' DWORD // Loader section size
   e32_ldrsum       AS DWORD         ' DWORD // Loader section checksum
   e32_objtab       AS DWORD         ' DWORD // Object table offset
   e32_objcnt       AS DWORD         ' DWORD // Number of objects in module
   e32_objmap       AS DWORD         ' DWORD // Object page map offset
   e32_itermap      AS DWORD         ' DWORD // Object iterated data map offset
   e32_rsrctab      AS DWORD         ' DWORD // Offset of Resource Table
   e32_rsrccnt      AS DWORD         ' DWORD // Number of resource entries
   e32_restab       AS DWORD         ' DWORD // Offset of resident name table
   e32_enttab       AS DWORD         ' DWORD // Offset of Entry Table
   e32_dirtab       AS DWORD         ' DWORD // Offset of Module Directive Table
   e32_dircnt       AS DWORD         ' DWORD // Number of module directives
   e32_fpagetab     AS DWORD         ' DWORD // Offset of Fixup Page Table
   e32_frectab      AS DWORD         ' DWORD // Offset of Fixup Record Table
   e32_impmod       AS DWORD         ' DWORD // Offset of Import Module Name Table
   e32_impmodcnt    AS DWORD         ' DWORD // Number of entries in Import Module Name Table
   e32_impproc      AS DWORD         ' DWORD // Offset of Import Procedure Name Table
   e32_pagesum      AS DWORD         ' DWORD // Offset of Per-Page Checksum Table
   e32_datapage     AS DWORD         ' DWORD // Offset of Enumerated Data Pages
   e32_preload      AS DWORD         ' DWORD // Number of preload pages
   e32_nrestab      AS DWORD         ' DWORD // Offset of Non-resident Names Table
   e32_cbnrestab    AS DWORD         ' DWORD // Size of Non-resident Name Table
   e32_nressum      AS DWORD         ' DWORD // Non-resident Name Table Checksum
   e32_autodata     AS DWORD         ' DWORD // Object # for automatic data object
   e32_debuginfo    AS DWORD         ' DWORD // Offset of the debugging information
   e32_debuglen     AS DWORD         ' DWORD // The length of the debugging info. in bytes
   e32_instpreload  AS DWORD         ' DWORD // Number of instance pages in preload section of VXD file
   e32_instdemand   AS DWORD         ' DWORD // Number of instance pages in demand load section of VXD file
   e32_heapsize     AS DWORD         ' DWORD // Size of heap - for 16-bit apps
   e32_res3         AS STRING * 12   ' BYTE  //Reserved words
   e32_winresoff    AS DWORD         ' DWORD
   e32_winreslen    AS DWORD         ' DWORD
   e32_devid        AS WORD          ' WORD  // Device ID for VxD
   e32_ddkver       AS WORD          ' WORD  // DDK version for VxD
END TYPE

'#ifndef _MAC
'#include "poppack.h"                    // Back to 4 byte packing
'#endif

'//
'// File header format.
'//

TYPE IMAGE_FILE_HEADER
   Machine              AS WORD
   NumberOfSections     AS WORD
   TimeDateStamp        AS DWORD
   PointerToSymbolTable AS DWORD
   NumberOfSymbols      AS DWORD
   SizeOfOptionalHeader AS WORD
   Characteristics      AS WORD
END TYPE

%IMAGE_SIZEOF_FILE_HEADER = 20

%IMAGE_FILE_RELOCS_STRIPPED         = &H00000001???  ' Relocation info stripped from file.
%IMAGE_FILE_EXECUTABLE_IMAGE        = &H00000002???  ' File is executable  (i.e. no unresolved externel references).
%IMAGE_FILE_LINE_NUMS_STRIPPED      = &H00000004???  ' Line nunbers stripped from file.
%IMAGE_FILE_LOCAL_SYMS_STRIPPED     = &H00000008???  ' Local symbols stripped from file.
%IMAGE_FILE_AGGRESIVE_WS_TRIM       = &H00000010???  ' Agressively trim working set
%IMAGE_FILE_LARGE_ADDRESS_AWARE     = &H00000020???  ' App can handle >2gb addresses
%IMAGE_FILE_BYTES_REVERSED_LO       = &H00000080???  ' Bytes of machine word are reversed.
%IMAGE_FILE_32BIT_MACHINE           = &H00000100???  ' 32 bit word machine.
%IMAGE_FILE_DEBUG_STRIPPED          = &H00000200???  ' Debugging info stripped from file in .DBG file
%IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP = &H00000400???  ' If Image is on removable media, copy and run from the swap file.
%IMAGE_FILE_NET_RUN_FROM_SWAP       = &H00000800???  ' If Image is on Net, copy and run from the swap file.
%IMAGE_FILE_SYSTEM                  = &H00001000???  ' System File.
%IMAGE_FILE_DLL                     = &H00002000???  ' File is a DLL.
%IMAGE_FILE_UP_SYSTEM_ONLY          = &H00004000???  ' File should only be run on a UP machine
%IMAGE_FILE_BYTES_REVERSED_HI       = &H00008000???  ' Bytes of machine word are reversed.

%IMAGE_FILE_MACHINE_UNKNOWN         = 0???
%IMAGE_FILE_MACHINE_I386            = &H014c???  ' Intel 386.
%IMAGE_FILE_MACHINE_R3000           = &H0162???  ' MIPS little-endian, = &H160 big-endian
%IMAGE_FILE_MACHINE_R4000           = &H0166???  ' MIPS little-endian
%IMAGE_FILE_MACHINE_R10000          = &H0168???  ' MIPS little-endian
%IMAGE_FILE_MACHINE_WCEMIPSV2       = &H0169???  ' MIPS little-endian WCE v2
%IMAGE_FILE_MACHINE_ALPHA           = &H0184???  ' Alpha_AXP
%IMAGE_FILE_MACHINE_SH3             = &H01a2???  ' SH3 little-endian
%IMAGE_FILE_MACHINE_SH3DSP          = &H01a3???
%IMAGE_FILE_MACHINE_SH3E            = &H01a4???  ' SH3E little-endian
%IMAGE_FILE_MACHINE_SH4             = &H01a6???  ' SH4 little-endian
%IMAGE_FILE_MACHINE_SH5             = &H01a8???  ' SH5
%IMAGE_FILE_MACHINE_ARM             = &H01c0???  ' ARM Little-Endian
%IMAGE_FILE_MACHINE_THUMB           = &H01c2???
%IMAGE_FILE_MACHINE_AM33            = &H01d3???
%IMAGE_FILE_MACHINE_POWERPC         = &H01F0???  ' IBM PowerPC Little-Endian
%IMAGE_FILE_MACHINE_POWERPCFP       = &H01f1???
%IMAGE_FILE_MACHINE_IA64            = &H0200???  ' Intel 64
%IMAGE_FILE_MACHINE_MIPS16          = &H0266???  ' MIPS
%IMAGE_FILE_MACHINE_ALPHA64         = &H0284???  ' ALPHA64
%IMAGE_FILE_MACHINE_MIPSFPU         = &H0366???  ' MIPS
%IMAGE_FILE_MACHINE_MIPSFPU16       = &H0466???  ' MIPS
%IMAGE_FILE_MACHINE_AXP64           = %IMAGE_FILE_MACHINE_ALPHA64
%IMAGE_FILE_MACHINE_TRICORE         = &H0520???  ' // Infineon
%IMAGE_FILE_MACHINE_CEF             = &H0CEF???
%IMAGE_FILE_MACHINE_EBC             = &H0EBC???  ' // EFI Byte Code
%IMAGE_FILE_MACHINE_AMD64           = &H8664???  ' // AMD64 (K8)
%IMAGE_FILE_MACHINE_M32R            = &H9041???  ' // M32R little-endian
%IMAGE_FILE_MACHINE_CEE             = &HC0EE???

'//
'// Directory format.
'//

TYPE IMAGE_DATA_DIRECTORY
   VirtualAddress AS DWORD
   nSize          AS DWORD
END TYPE

%IMAGE_NUMBEROF_DIRECTORY_ENTRIES   = 16

'//
'// Optional header format.
'//

TYPE IMAGE_OPTIONAL_HEADER
   ' Standard fields.
   Magic                       AS WORD
   MajorLinkerVersion          AS BYTE
   MinorLinkerVersion          AS BYTE
   SizeOfCode                  AS DWORD
   SizeOfInitializedData       AS DWORD
   SizeOfUninitializedData     AS DWORD
   AddressOfEntryPoint         AS DWORD
   BaseOfCode                  AS DWORD
   BaseOfData                  AS DWORD
   ' NT additional fields.
   ImageBase                   AS DWORD
   SectionAlignment            AS DWORD
   FileAlignment               AS DWORD
   MajorOperatingSystemVersion AS WORD
   MinorOperatingSystemVersion AS WORD
   MajorImageVersion           AS WORD
   MinorImageVersion           AS WORD
   MajorSubsystemVersion       AS WORD
   MinorSubsystemVersion       AS WORD
   Win32VersionValue           AS DWORD
   SizeOfImage                 AS DWORD
   SizeOfHeaders               AS DWORD
   CheckSum                    AS DWORD
   Subsystem                   AS WORD
   DllCharacteristics          AS WORD
   SizeOfStackReserve          AS DWORD
   SizeOfStackCommit           AS DWORD
   SizeOfHeapReserve           AS DWORD
   SizeOfHeapCommit            AS DWORD
   LoaderFlags                 AS DWORD
   NumberOfRvaAndSizes         AS DWORD
   DataDirectory(%IMAGE_NUMBEROF_DIRECTORY_ENTRIES - 1) AS IMAGE_DATA_DIRECTORY
END TYPE

TYPE IMAGE_ROM_OPTIONAL_HEADER
   Magic                   AS WORD
   MajorLinkerVersion      AS BYTE
   MinorLinkerVersion      AS BYTE
   SizeOfCode              AS DWORD
   SizeOfInitializedData   AS DWORD
   SizeOfUninitializedData AS DWORD
   AddressOfEntryPoint     AS DWORD
   BaseOfCode              AS DWORD
   BaseOfData              AS DWORD
   BaseOfBss               AS DWORD
   GprMask                 AS DWORD
   CprMask(3)              AS DWORD
   GpValue                 AS DWORD
END TYPE

TYPE IMAGE_OPTIONAL_HEADER64
   Magic                       AS WORD
   MajorLinkerVersion          AS BYTE
   MinorLinkerVersion          AS BYTE
   SizeOfCode                  AS DWORD
   SizeOfInitializedData       AS DWORD
   SizeOfUninitializedData     AS DWORD
   AddressOfEntryPoint         AS DWORD
   BaseOfCode                  AS DWORD
   ImageBase                   AS QUAD    ' ULONGLONG
   SectionAlignment            AS DWORD
   FileAlignment               AS DWORD
   MajorOperatingSystemVersion AS WORD
   MinorOperatingSystemVersion AS WORD
   MajorImageVersion           AS WORD
   MinorImageVersion           AS WORD
   MajorSubsystemVersion       AS WORD
   MinorSubsystemVersion       AS WORD
   Win32VersionValue           AS DWORD
   SizeOfImage                 AS DWORD
   SizeOfHeaders               AS DWORD
   CheckSum                    AS DWORD
   Subsystem                   AS WORD
   DllCharacteristics          AS WORD
   SizeOfStackReserve          AS QUAD    ' ULONGLONG
   SizeOfStackCommit           AS QUAD    ' ULONGLONG
   SizeOfHeapReserve           AS QUAD    ' ULONGLONG
   SizeOfHeapCommit            AS QUAD    ' ULONGLONG
   LoaderFlags                 AS DWORD
   NumberOfRvaAndSizes         AS DWORD
   DataDirectory(%IMAGE_NUMBEROF_DIRECTORY_ENTRIES - 1) AS IMAGE_DATA_DIRECTORY
END TYPE

'%IMAGE_SIZEOF_ROM_OPTIONAL_HEADER  =  56
'%IMAGE_SIZEOF_STD_OPTIONAL_HEADER  =  28
'%IMAGE_SIZEOF_NT_OPTIONAL32_HEADER = 224
'%IMAGE_SIZEOF_NT_OPTIONAL64_HEADER = 240

%IMAGE_NT_OPTIONAL_HDR32_MAGIC     = &H10b
%IMAGE_NT_OPTIONAL_HDR64_MAGIC     = &H20b
%IMAGE_ROM_OPTIONAL_HDR_MAGIC      = &H107

TYPE IMAGE_NT_HEADERS64
   Signature      AS DWORD
   FileHeader     AS IMAGE_FILE_HEADER
   OptionalHeader AS IMAGE_OPTIONAL_HEADER64
END TYPE

TYPE IMAGE_NT_HEADERS
   Signature      AS DWORD
   FileHeader     AS IMAGE_FILE_HEADER
   OptionalHeader AS IMAGE_OPTIONAL_HEADER
END TYPE

TYPE IMAGE_ROM_HEADER
   FileHeader     AS IMAGE_FILE_HEADER
   OptionalHeader AS IMAGE_ROM_OPTIONAL_HEADER
END TYPE

'// IMAGE_FIRST_SECTION doesn't need 32/64 versions since the file header is the same either way.

'#define IMAGE_FIRST_SECTION( ntheader ) ((PIMAGE_SECTION_HEADER)        \
'    ((ULONG_PTR)ntheader +                                              \
'     FIELD_OFFSET( IMAGE_NT_HEADERS, OptionalHeader ) +                 \
'     ((PIMAGE_NT_HEADERS)(ntheader))->FileHeader.SizeOfOptionalHeader   \
'    ))

'// Subsystem Values

%IMAGE_SUBSYSTEM_UNKNOWN                  = 0    ' Unknown subsystem.
%IMAGE_SUBSYSTEM_NATIVE                   = 1    ' Image doesn't require a subsystem.
%IMAGE_SUBSYSTEM_WINDOWS_GUI              = 2    ' Image runs in the Windows GUI subsystem.
%IMAGE_SUBSYSTEM_WINDOWS_CUI              = 3    ' Image runs in the Windows character subsystem.
%IMAGE_SUBSYSTEM_OS2_CUI                  = 5    ' image runs in the OS/2 character subsystem.
%IMAGE_SUBSYSTEM_POSIX_CUI                = 7    ' image runs in the Posix character subsystem.
%IMAGE_SUBSYSTEM_NATIVE_WINDOWS           = 8    ' image is a native Win9x driver.
%IMAGE_SUBSYSTEM_WINDOWS_CE_GUI           = 9    ' Image runs in the Windows CE subsystem.
%IMAGE_SUBSYSTEM_EFI_APPLICATION          = 10   '
%IMAGE_SUBSYSTEM_EFI_BOOT_SERVICE_DRIVER  = 11
%IMAGE_SUBSYSTEM_EFI_RUNTIME_DRIVER       = 12
%IMAGE_SUBSYSTEM_EFI_ROM                  = 13
%IMAGE_SUBSYSTEM_XBOX                     = 14
%IMAGE_SUBSYSTEM_WINDOWS_BOOT_APPLICATION = 16

'// DllCharacteristics Entries

'//      IMAGE_LIBRARY_PROCESS_INIT             0x0001     // Reserved.
'//      IMAGE_LIBRARY_PROCESS_TERM             0x0002     // Reserved.
'//      IMAGE_LIBRARY_THREAD_INIT              0x0004     // Reserved.
'//      IMAGE_LIBRARY_THREAD_TERM              0x0008     // Reserved.
%IMAGE_DLLCHARACTERISTICS_DYNAMIC_BASE          = &H0040   ' // DLL can move.
%IMAGE_DLLCHARACTERISTICS_FORCE_INTEGRITY       = &H0080   ' // Code Integrity Image
%IMAGE_DLLCHARACTERISTICS_NX_COMPAT             = &H0100   ' // Image is NX compatible
%IMAGE_DLLCHARACTERISTICS_NO_ISOLATION          = &H0200   ' // Image understands isolation and doesn't want it
%IMAGE_DLLCHARACTERISTICS_NO_SEH                = &H0400   ' // Image does not use SEH.  No SE handler may reside in this image
%IMAGE_DLLCHARACTERISTICS_NO_BIND               = &H0800   ' Do not bind this image.
'//                                             0x1000     // Reserved.
%IMAGE_DLLCHARACTERISTICS_WDM_DRIVER            = &H2000   ' Driver uses WDM model
'//                                             0x4000     // Reserved.
%IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER_AWARE = &H00008000

'// Directory Entries

%IMAGE_DIRECTORY_ENTRY_EXPORT         = 0  ' // Export Directory
%IMAGE_DIRECTORY_ENTRY_IMPORT         = 1  ' // Import Directory
%IMAGE_DIRECTORY_ENTRY_RESOURCE       = 2  ' // Resource Directory
%IMAGE_DIRECTORY_ENTRY_EXCEPTION      = 3  ' // Exception Directory
%IMAGE_DIRECTORY_ENTRY_SECURITY       = 4  ' // Security Directory
%IMAGE_DIRECTORY_ENTRY_BASERELOC      = 5  ' // Base Relocation Table
%IMAGE_DIRECTORY_ENTRY_DEBUG          = 6  ' // Debug Directory
'// IMAGE_DIRECTORY_ENTRY_COPYRIGHT     =  7   // (X86 usage)
%IMAGE_DIRECTORY_ENTRY_COPYRIGHT     =  7  ' // (X86 usage)
%IMAGE_DIRECTORY_ENTRY_ARCHITECTURE   = 7  ' // Architecture Specific Data
%IMAGE_DIRECTORY_ENTRY_GLOBALPTR      = 8  ' // RVA of GP
%IMAGE_DIRECTORY_ENTRY_TLS            = 9  ' // TLS Directory
%IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG    = 10  ' // Load Configuration Directory
%IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT   = 11  ' // Bound Import Directory in headers
%IMAGE_DIRECTORY_ENTRY_IAT            = 12  ' // Import Address Table
%IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT   = 13  ' // Delay Load Import Descriptors
%IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR = 14  ' // COM Runtime descriptor

'//
'// Non-COFF Object file header
'//

TYPE ANON_OBJECT_HEADER
   Sig1          AS WORD    ' WORD  // Must be %IMAGE_FILE_MACHINE_UNKNOWN
   Sig2          AS WORD    ' WORD  // Must be &HFFFF??
   Version       AS WORD    ' WORD  //  >= 1 (implies the ClassID field is present)
   Machine       AS WORD    ' WORD
   TimeDateStamp AS DWORD   ' DWORD
   ClassID       AS GUID    ' CLSID // Used to invoke CoCreateInstance
   SizeOfData    AS DWORD   ' DWORD // Size of data that follows the header
END TYPE

TYPE ANON_OBJECT_HEADER_V2
   Sig1           AS WORD    ' WORD  // Must be %IMAGE_FILE_MACHINE_UNKNOWN
   Sig2           AS WORD    ' WORD  // Must be &HFFFF??
   Version        AS WORD    ' WORD  //  >= 1 (implies the ClassID field is present)
   Machine        AS WORD    ' WORD
   TimeDateStamp  AS DWORD   ' DWORD
   ClassID        AS GUID    ' CLSID // Used to invoke CoCreateInstance
   SizeOfData     AS DWORD   ' DWORD // Size of data that follows the header
   Flags          AS DWORD   ' DWORD // 0x1 -> contains metadata
   MetaDataSize   AS DWORD   ' DWORD // Size of CLR metadata
   MetaDataOffset AS DWORD   ' DWORD // Offset of CLR metadata
END TYPE

'//
'// Section header format.
'//

%IMAGE_SIZEOF_SHORT_NAME = 8

'typedef struct _IMAGE_SECTION_HEADER {
'    BYTE    Name[IMAGE_SIZEOF_SHORT_NAME];
'    union {
'            DWORD   PhysicalAddress;
'            DWORD   VirtualSize;
'    } Misc;
'    DWORD   VirtualAddress;
'    DWORD   SizeOfRawData;
'    DWORD   PointerToRawData;
'    DWORD   PointerToRelocations;
'    DWORD   PointerToLinenumbers;
'    WORD    NumberOfRelocations;
'    WORD    NumberOfLinenumbers;
'    DWORD   Characteristics;
'} IMAGE_SECTION_HEADER, *PIMAGE_SECTION_HEADER;

UNION MiscUnionISH
   PhysicalAddress AS DWORD
   VirtualSize     AS DWORD
END UNION

TYPE IMAGE_SECTION_HEADER
   Name                 AS STRING * %IMAGE_SIZEOF_SHORT_NAME
   Misc                 AS MiscUnionISH
   VirtualAddress       AS DWORD
   SizeOfRawData        AS DWORD
   PointerToRawData     AS DWORD
   PointerToRelocations AS DWORD
   PointerToLinenumbers AS DWORD
   NumberOfRelocations  AS WORD
   NumberOfLinenumbers  AS WORD
   Characteristics      AS DWORD
END TYPE

'#define IMAGE_SIZEOF_SECTION_HEADER          40
%IMAGE_SIZEOF_SECTION_HEADER = 40

'//
'// Section characteristics.
'//
'//      IMAGE_SCN_TYPE_REG                   0x00000000  // Reserved.
'//      IMAGE_SCN_TYPE_DSECT                 0x00000001  // Reserved.
'//      IMAGE_SCN_TYPE_NOLOAD                0x00000002  // Reserved.
'//      IMAGE_SCN_TYPE_GROUP                 0x00000004  // Reserved.
'#define IMAGE_SCN_TYPE_NO_PAD                0x00000008  // Reserved.
%IMAGE_SCN_TYPE_NO_PAD               = &H00000008???  ' Reserved.
'//      IMAGE_SCN_TYPE_COPY                  0x00000010  // Reserved.

%IMAGE_SCN_CNT_CODE                  = &H00000020???  ' Section contains code.
%IMAGE_SCN_CNT_INITIALIZED_DATA      = &H00000040???  ' Section contains initialized data.
%IMAGE_SCN_CNT_UNINITIALIZED_DATA    = &H00000080???  ' Section contains uninitialized data.

%IMAGE_SCN_LNK_OTHER                 = &H00000100???  ' Reserved.
%IMAGE_SCN_LNK_INFO                  = &H00000200???  ' Section contains comments or some other type of information.
'     IMAGE_SCN_TYPE_OVER                 = &H00000400  ' Reserved.
%IMAGE_SCN_LNK_REMOVE                = &H00000800???  ' Section contents will not become part of image.
%IMAGE_SCN_LNK_COMDAT                = &H00001000???  ' Section contents comdat.

'//                                           0x00002000  // Reserved.
'//      IMAGE_SCN_MEM_PROTECTED - Obsolete   0x00004000
%IMAGE_SCN_NO_DEFER_SPEC_EXC         = &H00004000???  ' Reset speculative exceptions handling bits in the TLB entries for this section.
%IMAGE_SCN_GPREL                     = &H00008000???  ' Section content can be accessed relative to GP
%IMAGE_SCN_MEM_FARDATA               = &H00008000???
'     IMAGE_SCN_MEM_SYSHEAP  - Obsolete   = &H00010000
%IMAGE_SCN_MEM_PURGEABLE             = &H00020000???
%IMAGE_SCN_MEM_16BIT                 = &H00020000???
%IMAGE_SCN_MEM_LOCKED                = &H00040000???
%IMAGE_SCN_MEM_PRELOAD               = &H00080000???

%IMAGE_SCN_ALIGN_1BYTES              = &H00100000???
%IMAGE_SCN_ALIGN_2BYTES              = &H00200000???
%IMAGE_SCN_ALIGN_4BYTES              = &H00300000???
%IMAGE_SCN_ALIGN_8BYTES              = &H00400000???
%IMAGE_SCN_ALIGN_16BYTES             = &H00500000???  ' Default alignment if no others are specified.
%IMAGE_SCN_ALIGN_32BYTES             = &H00600000???
%IMAGE_SCN_ALIGN_64BYTES             = &H00700000???
%IMAGE_SCN_ALIGN_128BYTES            = &H00800000???
%IMAGE_SCN_ALIGN_256BYTES            = &H00900000???
%IMAGE_SCN_ALIGN_512BYTES            = &H00A00000???
%IMAGE_SCN_ALIGN_1024BYTES           = &H00B00000???
%IMAGE_SCN_ALIGN_2048BYTES           = &H00C00000???
%IMAGE_SCN_ALIGN_4096BYTES           = &H00D00000???
%IMAGE_SCN_ALIGN_8192BYTES           = &H00E00000???
' Unused                                   = &H00F00000
%IMAGE_SCN_ALIGN_MASK                = &H00F00000???

%IMAGE_SCN_LNK_NRELOC_OVFL           = &H01000000???  ' Section contains extended relocations.
%IMAGE_SCN_MEM_DISCARDABLE           = &H02000000???  ' Section can be discarded.
%IMAGE_SCN_MEM_NOT_CACHED            = &H04000000???  ' Section is not cachable.
%IMAGE_SCN_MEM_NOT_PAGED             = &H08000000???  ' Section is not pageable.
%IMAGE_SCN_MEM_SHARED                = &H10000000???  ' Section is shareable.
%IMAGE_SCN_MEM_EXECUTE               = &H20000000???  ' Section is executable.
%IMAGE_SCN_MEM_READ                  = &H40000000???  ' Section is readable.
%IMAGE_SCN_MEM_WRITE                 = &H80000000???  ' Section is writeable.

'//
'// TLS Chaacteristic Flags
'//
%IMAGE_SCN_SCALE_INDEX               = &H00000001???  ' Tls index is scaled

'#ifndef _MAC
'#include "pshpack2.h"                       // Symbols, relocs, and linenumbers are 2 byte packed
'#endif

'//
'// Symbol format.
'//

'typedef struct _IMAGE_SYMBOL {
'    union {
'        BYTE    ShortName[8];
'        struct {
'            DWORD   Short;     // if 0, use LongName
'            DWORD   Long;      // offset into string table
'        } Name;
'        DWORD   LongName[2];    // PBYTE [2]
'    } N;
'    DWORD   Value;
'    SHORT   SectionNumber;
'    WORD    Type;
'    BYTE    StorageClass;
'    BYTE    NumberOfAuxSymbols;
'} IMAGE_SYMBOL;
'typedef IMAGE_SYMBOL UNALIGNED *PIMAGE_SYMBOL;

UNION NameUnion
   dShort AS DWORD    ' if 0, use LongName
   dLong  AS DWORD    ' offset into string table
END UNION

UNION Nunion
   ShortName AS STRING * 8
   Name AS NameUnion
   LongName(1) AS DWORD
END UNION

TYPE IMAGE_SYMBOL
   N                  AS Nunion
   Value              AS DWORD
   SectionNumber      AS INTEGER
   wType              AS WORD
   StorageClass       AS BYTE
   NumberOfAuxSymbols AS BYTE
END TYPE

%IMAGE_SIZEOF_SYMBOL = 18

'//
'// Section values.
'//
'// Symbols have a section number of the section in which they are
'// defined. Otherwise, section numbers have the following meanings:
'//

'#define IMAGE_SYM_UNDEFINED           (SHORT)0          // Symbol is undefined or is common.
'#define IMAGE_SYM_ABSOLUTE            (SHORT)-1         // Symbol is an absolute value.
'#define IMAGE_SYM_DEBUG               (SHORT)-2         // Symbol is a special debug item.
'#define IMAGE_SYM_SECTION_MAX         0xFEFF            // Values 0xFF00-0xFFFF are special

%IMAGE_SYM_UNDEFINED   = 0%      ' // Symbol is undefined or is common.
%IMAGE_SYM_ABSOLUTE    = -1%     ' // Symbol is an absolute value.
%IMAGE_SYM_DEBUG       = -2%     ' // Symbol is a special debug item.
%IMAGE_SYM_SECTION_MAX = &HFEFF  ' // Values 0xFF00-0xFFFF are special


'//
'// Type (fundamental) values.
'//

%IMAGE_SYM_TYPE_NULL   = &H00000000???  ' no type.
%IMAGE_SYM_TYPE_VOID   = &H00000001???
%IMAGE_SYM_TYPE_CHAR   = &H00000002???  ' type character.
%IMAGE_SYM_TYPE_SHORT  = &H00000003???  ' type short integer.
%IMAGE_SYM_TYPE_INT    = &H00000004???
%IMAGE_SYM_TYPE_LONG   = &H00000005???
%IMAGE_SYM_TYPE_FLOAT  = &H00000006???
%IMAGE_SYM_TYPE_DOUBLE = &H00000007???
%IMAGE_SYM_TYPE_STRUCT = &H00000008???
%IMAGE_SYM_TYPE_UNION  = &H00000009???
%IMAGE_SYM_TYPE_ENUM   = &H0000000A???  ' enumeration.
%IMAGE_SYM_TYPE_MOE    = &H0000000B???  ' member of enumeration.
%IMAGE_SYM_TYPE_BYTE   = &H0000000C???
%IMAGE_SYM_TYPE_WORD   = &H0000000D???
%IMAGE_SYM_TYPE_UINT   = &H0000000E???
%IMAGE_SYM_TYPE_DWORD  = &H0000000F???
%IMAGE_SYM_TYPE_PCODE  = &H00008000???

'//
'// Type (derived) values.
'//

%IMAGE_SYM_DTYPE_NULL     = 0       ' no derived type.
%IMAGE_SYM_DTYPE_POINTER  = 1       ' pointer.
%IMAGE_SYM_DTYPE_FUNCTION = 2       ' function.
%IMAGE_SYM_DTYPE_ARRAY    = 3       ' array.

'//
'// Storage classes.
'//
%IMAGE_SYM_CLASS_END_OF_FUNCTION  = &HFF?   ' (BYTE )-1
%IMAGE_SYM_CLASS_NULL             = &H0000?
%IMAGE_SYM_CLASS_AUTOMATIC        = &H0001?
%IMAGE_SYM_CLASS_EXTERNAL         = &H0002?
%IMAGE_SYM_CLASS_STATIC           = &H0003?
%IMAGE_SYM_CLASS_REGISTER         = &H0004?
%IMAGE_SYM_CLASS_EXTERNAL_DEF     = &H0005?
%IMAGE_SYM_CLASS_LABEL            = &H0006?
%IMAGE_SYM_CLASS_UNDEFINED_LABEL  = &H0007?
%IMAGE_SYM_CLASS_MEMBER_OF_STRUCT = &H0008?
%IMAGE_SYM_CLASS_ARGUMENT         = &H0009?
%IMAGE_SYM_CLASS_STRUCT_TAG       = &H000A?
%IMAGE_SYM_CLASS_MEMBER_OF_UNION  = &H000B?
%IMAGE_SYM_CLASS_UNION_TAG        = &H000C?
%IMAGE_SYM_CLASS_TYPE_DEFINITION  = &H000D?
%IMAGE_SYM_CLASS_UNDEFINED_STATIC = &H000E?
%IMAGE_SYM_CLASS_ENUM_TAG         = &H000F?
%IMAGE_SYM_CLASS_MEMBER_OF_ENUM   = &H0010?
%IMAGE_SYM_CLASS_REGISTER_PARAM   = &H0011?
%IMAGE_SYM_CLASS_BIT_FIELD        = &H0012?

%IMAGE_SYM_CLASS_FAR_EXTERNAL     = &H0044?

%IMAGE_SYM_CLASS_BLOCK            = &H0064?
%IMAGE_SYM_CLASS_FUNCTION         = &H0065?
%IMAGE_SYM_CLASS_END_OF_STRUCT    = &H0066?
%IMAGE_SYM_CLASS_FILE             = &H0067?
' new
%IMAGE_SYM_CLASS_SECTION          = &H0068?
%IMAGE_SYM_CLASS_WEAK_EXTERNAL    = &H0069?

%IMAGE_SYM_CLASS_CLR_TOKEN        = &H006B?

'// type packing constants

%N_BTMASK = &H000F?
%N_TMASK  = &H0030?
%N_TMASK1 = &H00C0?
%N_TMASK2 = &H00F0?
%N_BTSHFT = 4?
%N_TSHIFT = 2?

'// MACROS

'// Basic Type of  x
'#define BTYPE(x) ((x) & N_BTMASK)

MACRO BTTYPE(x) = (x AND N_BTMASK)

'// Is x a pointer?
'#ifndef ISPTR
'#define ISPTR(x) (((x) & N_TMASK) == (IMAGE_SYM_DTYPE_POINTER << N_BTSHFT))
'#endif

'#IF NOT %DEF(%ISPTR)
'%ISPTR = 1
'FUNCTION ISPTR (BYVAL x AS DWORD) AS LONG
'   LOCAL value AS DWORD
'   value = %IMAGE_SYM_DTYPE_POINTER
'   SHIFT LEFT value, %N_BTSHFT
'   FUNCTION = (x AND %N_TMASK) = value
'END FUNCTION
'#ENDIF

'// Is x a function?
'#ifndef ISFCN
'#define ISFCN(x) (((x) & N_TMASK) == (IMAGE_SYM_DTYPE_FUNCTION << N_BTSHFT))
'#endif

'#IF NOT %DEF(%ISFCN)
'%ISFCN = 1
'FUNCTION ISFCN (BYVAL x AS DWORD) AS LONG
'   LOCAL value AS DWORD
'   value = %IMAGE_SYM_DTYPE_FUNCTION
'   SHIFT LEFT value, %N_BTSHFT
'   FUNCTION = (x AND %N_TMASK) = value
'END FUNCTION
'#ENDIF

'// Is x an array?

'#ifndef ISARY
'#define ISARY(x) (((x) & N_TMASK) == (IMAGE_SYM_DTYPE_ARRAY << N_BTSHFT))
'#endif

'#IF NOT %DEF(%ISARY)
'%ISARY = 1
'FUNCTION ISARY (BYVAL x AS DWORD) AS LONG
'   LOCAL value AS DWORD
'   value = %IMAGE_SYM_DTYPE_ARRAY
'   SHIFT LEFT value, %N_BTSHFT
'   FUNCTION = (x AND %N_TMASK) = value
'END FUNCTION
'#ENDIF

'// Is x a structure, union, or enumeration TAG?
'#ifndef ISTAG
'#define ISTAG(x) ((x)==IMAGE_SYM_CLASS_STRUCT_TAG || (x)==IMAGE_SYM_CLASS_UNION_TAG || (x)==IMAGE_SYM_CLASS_ENUM_TAG)
'#endif

'#IF NOT %DEF(%ISTAG)
'%ISTAG = 1
'FUNCTION ISTAG (BYVAL x AS DWORD) AS LONG
'   IF x = %IMAGE_SYM_CLASS_STRUCT_TAG OR x = %IMAGE_SYM_CLASS_UNION_TAG OR x = %IMAGE_SYM_CLASS_ENUM_TAG THEN FUNCTION = 1 ' %TRUE
'END FUNCTION
'#ENDIF

'#ifndef INCREF
'#define INCREF(x) ((((x)&~N_BTMASK)<<N_TSHIFT)|(IMAGE_SYM_DTYPE_POINTER<<N_BTSHFT)|((x)&N_BTMASK))
'#endif
'#ifndef DECREF
'#define DECREF(x) ((((x)>>N_TSHIFT)&~N_BTMASK)|((x)&N_BTMASK))
'#endif


'//
'// Auxiliary entry format.
'//

'typedef union _IMAGE_AUX_SYMBOL {
'    struct {
'        DWORD    TagIndex;                      // struct, union, or enum tag index
'        union {
'            struct {
'                WORD    Linenumber;             // declaration line number
'                WORD    Size;                   // size of struct, union, or enum
'            } LnSz;
'           DWORD    TotalSize;
'        } Misc;
'        union {
'            struct {                            // if ISFCN, tag, or .bb
'                DWORD    PointerToLinenumber;
'                DWORD    PointerToNextFunction;
'            } Function;
'            struct {                            // if ISARY, up to 4 dimen.
'                WORD     Dimension[4];
'            } Array;
'        } FcnAry;
'        WORD    TvIndex;                        // tv index
'    } Sym;
'    struct {
'        BYTE    Name[IMAGE_SIZEOF_SYMBOL];
'    } File;
'    struct {
'        DWORD   Length;                         // section length
'        WORD    NumberOfRelocations;            // number of relocation entries
'        WORD    NumberOfLinenumbers;            // number of line numbers
'        DWORD   CheckSum;                       // checksum for communal
'        SHORT   Number;                         // section number to associate with
'        BYTE    Selection;                      // communal selection type
'    } Section;
'} IMAGE_AUX_SYMBOL;
'typedef IMAGE_AUX_SYMBOL UNALIGNED *PIMAGE_AUX_SYMBOL;

TYPE LnSzType
   Linenumber AS WORD   ' declaration line number
   Size       AS WORD   ' size of struct, union, or enum
END TYPE

UNION MiscUnionST
   LnSz      AS LnSzType
   TotalSize AS DWORD
END UNION

TYPE FunctionType
   PointerToLinenumber   AS DWORD
   PointerToNextFunction AS DWORD
END TYPE

TYPE ArrayType
   Dimension(3) AS WORD
END TYPE

UNION FcnAryUnion
   Function AS FunctionType  ' if ISFCN, tag, or .bb
   Array AS ArrayType        ' if ISARY, up to 4 dimen.
END UNION

TYPE SymType DWORD
   TagIndex AS DWORD       ' struct, union, or enum tag index
   Misc     AS MiscUnionST
   FcnAry   AS FcnAryUnion
   TvIndex  AS WORD        ' tv index
END TYPE

TYPE FileType DWORD
   Name AS STRING * %IMAGE_SIZEOF_SYMBOL
END TYPE

TYPE SectionType DWORD
   Length              AS DWORD     ' section length
   NumberOfRelocations AS WORD      ' number of relocation entries
   NumberOfLinenumbers AS WORD      ' number of line numbers
   CheckSum            AS DWORD     ' checksum for communal
   Number              AS INTEGER   ' section number to associate with
   Selection           AS BYTE      ' communal selection type
END TYPE

UNION IMAGE_AUX_SYMBOL
   Sym     AS SymType
   File    AS FileType
   Section AS SectionType
END UNION

%IMAGE_SIZEOF_AUX_SYMBOL           = 18

' IMAGE_AUX_SYMBOL_TYPE enum
%IMAGE_AUX_SYMBOL_TYPE_TOKEN_DEF = 1

'#include <pshpack2.h>

TYPE IMAGE_AUX_SYMBOL_TOKEN_DEF BYTE
   bAuxType         AS BYTE     ' BYTE // IMAGE_AUX_SYMBOL_TYPE
   bReserved        AS BYTE     ' BYTE // Must be 0
   SymbolTableIndex AS DWORD    ' DWORD
   rgbReserved(11)  AS BYTE     ' BYTE rgbReserved[12] // Must be 0
END TYPE

'typedef IMAGE_AUX_SYMBOL_TOKEN_DEF UNALIGNED *PIMAGE_AUX_SYMBOL_TOKEN_DEF;

'#include <poppack.h>


'//
'// Communal selection types.
'//

%IMAGE_COMDAT_SELECT_NODUPLICATES   = 1
%IMAGE_COMDAT_SELECT_ANY            = 2
%IMAGE_COMDAT_SELECT_SAME_SIZE      = 3
%IMAGE_COMDAT_SELECT_EXACT_MATCH    = 4
%IMAGE_COMDAT_SELECT_ASSOCIATIVE    = 5
%IMAGE_COMDAT_SELECT_LARGEST        = 6
%IMAGE_COMDAT_SELECT_NEWEST         = 7

%IMAGE_WEAK_EXTERN_SEARCH_NOLIBRARY = 1
%IMAGE_WEAK_EXTERN_SEARCH_LIBRARY   = 2
%IMAGE_WEAK_EXTERN_SEARCH_ALIAS     = 3

'//
'// Relocation format.
'//

'typedef struct _IMAGE_RELOCATION {
'    union {
'        DWORD   VirtualAddress;
'        DWORD   RelocCount;             // Set to the real count when IMAGE_SCN_LNK_NRELOC_OVFL is set
'    };
'    DWORD   SymbolTableIndex;
'    WORD    Type;
'} IMAGE_RELOCATION;
'typedef IMAGE_RELOCATION UNALIGNED *PIMAGE_RELOCATION;

UNION IMAGE_RELOC_union
   VirtualAddress AS DWORD
   RelocCount AS DWORD  ' Set to the real count when IMAGE_SCN_LNK_NRELOC_OVFL is set
END UNION

TYPE IMAGE_RELOCATION DWORD
   IRU AS IMAGE_RELOC_union
   SymbolTableIndex AS DWORD
   wType AS WORD
END TYPE

%IMAGE_SIZEOF_RELOCATION = 10

'//
'// I386 relocation types.
'//
%IMAGE_REL_I386_ABSOLUTE = &H0000???  ' Reference is absolute, no relocation is necessary
%IMAGE_REL_I386_DIR16    = &H0001???  ' Direct 16-bit reference to the symbols virtual address
%IMAGE_REL_I386_REL16    = &H0002???  ' PC-relative 16-bit reference to the symbols virtual address
%IMAGE_REL_I386_DIR32    = &H0006???  ' Direct 32-bit reference to the symbols virtual address
%IMAGE_REL_I386_DIR32NB  = &H0007???  ' Direct 32-bit reference to the symbols virtual address, base not included
%IMAGE_REL_I386_SEG12    = &H0009???  ' Direct 16-bit reference to the segment-selector bits of a 32-bit virtual address
%IMAGE_REL_I386_SECTION  = &H000A???
%IMAGE_REL_I386_SECREL   = &H000B???
%IMAGE_REL_I386_TOKEN    = &H000C???  ' clr token
%IMAGE_REL_I386_SECREL7  = &H000D???  ' 7 bit offset from base of section containing target
%IMAGE_REL_I386_REL32    = &H0014???  ' PC-relative 32-bit reference to the symbols virtual address

'//
'// MIPS relocation types.
'//
%IMAGE_REL_MIPS_ABSOLUTE  = &H0000???  ' Reference is absolute, no relocation is necessary
%IMAGE_REL_MIPS_REFHALF   = &H0001???
%IMAGE_REL_MIPS_REFWORD   = &H0002???
%IMAGE_REL_MIPS_JMPADDR   = &H0003???
%IMAGE_REL_MIPS_REFHI     = &H0004???
%IMAGE_REL_MIPS_REFLO     = &H0005???
%IMAGE_REL_MIPS_GPREL     = &H0006???
%IMAGE_REL_MIPS_LITERAL   = &H0007???
%IMAGE_REL_MIPS_SECTION   = &H000A???
%IMAGE_REL_MIPS_SECREL    = &H000B???
%IMAGE_REL_MIPS_SECRELLO  = &H000C???  ' Low 16-bit section relative referemce (used for >32k TLS)
%IMAGE_REL_MIPS_SECRELHI  = &H000D???  ' High 16-bit section relative reference (used for >32k TLS)
%IMAGE_REL_MIPS_JMPADDR16 = &H0010???
%IMAGE_REL_MIPS_REFWORDNB = &H0022???
%IMAGE_REL_MIPS_PAIR      = &H0025???

'//
'// Alpha Relocation types.
'//
%IMAGE_REL_ALPHA_ABSOLUTE       = &H0000???
%IMAGE_REL_ALPHA_REFLONG        = &H0001???
%IMAGE_REL_ALPHA_REFQUAD        = &H0002???
%IMAGE_REL_ALPHA_GPREL32        = &H0003???
%IMAGE_REL_ALPHA_LITERAL        = &H0004???
%IMAGE_REL_ALPHA_LITUSE         = &H0005???
%IMAGE_REL_ALPHA_GPDISP         = &H0006???
%IMAGE_REL_ALPHA_BRADDR         = &H0007???
%IMAGE_REL_ALPHA_HINT           = &H0008???
%IMAGE_REL_ALPHA_INLINE_REFLONG = &H0009???
%IMAGE_REL_ALPHA_REFHI          = &H000A???
%IMAGE_REL_ALPHA_REFLO          = &H000B???
%IMAGE_REL_ALPHA_PAIR           = &H000C???
%IMAGE_REL_ALPHA_MATCH          = &H000D???
%IMAGE_REL_ALPHA_SECTION        = &H000E???
%IMAGE_REL_ALPHA_SECREL         = &H000F???
%IMAGE_REL_ALPHA_REFLONGNB      = &H0010???
%IMAGE_REL_ALPHA_SECRELLO       = &H0011???  ' Low 16-bit section relative reference
%IMAGE_REL_ALPHA_SECRELHI       = &H0012???  ' High 16-bit section relative reference
%IMAGE_REL_ALPHA_REFQ3          = &H0013???  ' High 16 bits of 48 bit reference
%IMAGE_REL_ALPHA_REFQ2          = &H0014???  ' Middle 16 bits of 48 bit reference
%IMAGE_REL_ALPHA_REFQ1          = &H0015???  ' Low 16 bits of 48 bit reference
%IMAGE_REL_ALPHA_GPRELLO        = &H0016???  ' Low 16-bit GP relative reference
%IMAGE_REL_ALPHA_GPRELHI        = &H0017???  ' High 16-bit GP relative reference

'//
'// IBM PowerPC relocation types.
'//
%IMAGE_REL_PPC_ABSOLUTE = &H0000???  ' NOP
%IMAGE_REL_PPC_ADDR64   = &H0001???  ' 64-bit address
%IMAGE_REL_PPC_ADDR32   = &H0002???  ' 32-bit address
%IMAGE_REL_PPC_ADDR24   = &H0003???  ' 26-bit address, shifted left 2 (branch absolute)
%IMAGE_REL_PPC_ADDR16   = &H0004???  ' 16-bit address
%IMAGE_REL_PPC_ADDR14   = &H0005???  ' 16-bit address, shifted left 2 (load doubleword)
%IMAGE_REL_PPC_REL24    = &H0006???  ' 26-bit PC-relative offset, shifted left 2 (branch relative)
%IMAGE_REL_PPC_REL14    = &H0007???  ' 16-bit PC-relative offset, shifted left 2 (br cond relative)
%IMAGE_REL_PPC_TOCREL16 = &H0008???  ' 16-bit offset from TOC base
%IMAGE_REL_PPC_TOCREL14 = &H0009???  ' 16-bit offset from TOC base, shifted left 2 (load doubleword)

%IMAGE_REL_PPC_ADDR32NB = &H000A???  ' 32-bit addr w/o image base
%IMAGE_REL_PPC_SECREL   = &H000B???  ' va of containing section (as in an image sectionhdr)
%IMAGE_REL_PPC_SECTION  = &H000C???  ' sectionheader number
%IMAGE_REL_PPC_IFGLUE   = &H000D???  ' substitute TOC restore instruction iff symbol is glue code
%IMAGE_REL_PPC_IMGLUE   = &H000E???  ' symbol is glue code; virtual address is TOC restore instruction
%IMAGE_REL_PPC_SECREL16 = &H000F???  ' va of containing section (limited to 16 bits)
%IMAGE_REL_PPC_REFHI    = &H0010???
%IMAGE_REL_PPC_REFLO    = &H0011???
%IMAGE_REL_PPC_PAIR     = &H0012???
%IMAGE_REL_PPC_SECRELLO = &H0013???  ' Low 16-bit section relative reference (used for >32k TLS)
%IMAGE_REL_PPC_SECRELHI = &H0014???  ' High 16-bit section relative reference (used for >32k TLS)
%IMAGE_REL_PPC_GPREL    = &H0015???
%IMAGE_REL_PPC_TOKEN    = &H0016???  ' clr token

%IMAGE_REL_PPC_TYPEMASK = &H00FF???  ' mask to isolate above values in IMAGE_RELOCATION.Type

'// Flag bits in IMAGE_RELOCATION.TYPE

%IMAGE_REL_PPC_NEG      = &H0100???  ' subtract reloc value rather than adding it
%IMAGE_REL_PPC_BRTAKEN  = &H0200???  ' fix branch prediction bit to predict branch taken
%IMAGE_REL_PPC_BRNTAKEN = &H0400???  ' fix branch prediction bit to predict branch not taken
%IMAGE_REL_PPC_TOCDEFN  = &H0800???  ' toc slot defined in file (or, data in toc)

'//
'// Hitachi SH3 relocation types.
'//
%IMAGE_REL_SH3_ABSOLUTE        = &H0000???  ' No relocation
%IMAGE_REL_SH3_DIRECT16        = &H0001???  ' 16 bit direct
%IMAGE_REL_SH3_DIRECT32        = &H0002???  ' 32 bit direct
%IMAGE_REL_SH3_DIRECT8         = &H0003???  ' 8 bit direct, -128..255
%IMAGE_REL_SH3_DIRECT8_WORD    = &H0004???  ' 8 bit direct .W (0 ext.)
%IMAGE_REL_SH3_DIRECT8_LONG    = &H0005???  ' 8 bit direct .L (0 ext.)
%IMAGE_REL_SH3_DIRECT4         = &H0006???  ' 4 bit direct (0 ext.)
%IMAGE_REL_SH3_DIRECT4_WORD    = &H0007???  ' 4 bit direct .W (0 ext.)
%IMAGE_REL_SH3_DIRECT4_LONG    = &H0008???  ' 4 bit direct .L (0 ext.)
%IMAGE_REL_SH3_PCREL8_WORD     = &H0009???  ' 8 bit PC relative .W
%IMAGE_REL_SH3_PCREL8_LONG     = &H000A???  ' 8 bit PC relative .L
%IMAGE_REL_SH3_PCREL12_WORD    = &H000B???  ' 12 LSB PC relative .W
%IMAGE_REL_SH3_STARTOF_SECTION = &H000C???  ' Start of EXE section
%IMAGE_REL_SH3_SIZEOF_SECTION  = &H000D???  ' Size of EXE section
%IMAGE_REL_SH3_SECTION         = &H000E???  ' Section table index
%IMAGE_REL_SH3_SECREL          = &H000F???  ' Offset within section
%IMAGE_REL_SH3_DIRECT32_NB     = &H0010???  ' 32 bit direct not based
%IMAGE_REL_SH3_GPREL4_LONG     = &H0011???  ' // GP-relative addressing
%IMAGE_REL_SH3_TOKEN           = &H0012???  ' // clr token
%IMAGE_REL_SHM_PCRELPT         = &H0013???  ' // Offset from current
                                            ' //  instruction in longwords
                                            ' //  if not NOMODE, insert the
                                            ' //  inverse of the low bit at
                                            ' //  bit 32 to select PTA/PTB
%IMAGE_REL_SHM_REFLO           = &H0014???  ' // Low bits of 32-bit address
%IMAGE_REL_SHM_REFHALF         = &H0015???  ' // High bits of 32-bit address
%IMAGE_REL_SHM_RELLO           = &H0016???  ' // Low bits of relative reference
%IMAGE_REL_SHM_RELHALF         = &H0017???  ' // High bits of relative reference
%IMAGE_REL_SHM_PAIR            = &H0018???  ' // offset operand for relocation

%IMAGE_REL_SH_NOMODE           = &H8000???  ' // relocation ignores section mode

%IMAGE_REL_ARM_ABSOLUTE        = &H0000???  ' No relocation required
%IMAGE_REL_ARM_ADDR32          = &H0001???  ' 32 bit address
%IMAGE_REL_ARM_ADDR32NB        = &H0002???  ' 32 bit address w/o image base
%IMAGE_REL_ARM_BRANCH24        = &H0003???  ' 24 bit offset << 2 & sign ext.
%IMAGE_REL_ARM_BRANCH11        = &H0004???  ' Thumb: 2 11 bit offsets
%IMAGE_REL_ARM_TOKEN           = &H0005???  ' clr token
%IMAGE_REL_ARM_GPREL12         = &H0006???  ' GP-relative addressing (ARM)
%IMAGE_REL_ARM_GPREL7          = &H0007???  ' GP-relative addressing (Thumb)
%IMAGE_REL_ARM_BLX24           = &H0008???
%IMAGE_REL_ARM_BLX11           = &H0009???
%IMAGE_REL_ARM_SECTION         = &H000E???  ' Section table index
%IMAGE_REL_ARM_SECREL          = &H000F???  ' Offset within section

%IMAGE_REL_AM_ABSOLUTE           = &H0000???
%IMAGE_REL_AM_ADDR32             = &H0001???
%IMAGE_REL_AM_ADDR32NB           = &H0002???
%IMAGE_REL_AM_CALL32             = &H0003???
%IMAGE_REL_AM_FUNCINFO           = &H0004???
%IMAGE_REL_AM_REL32_1            = &H0005???
%IMAGE_REL_AM_REL32_2            = &H0006???
%IMAGE_REL_AM_SECREL             = &H0007???
%IMAGE_REL_AM_SECTION            = &H0008???
%IMAGE_REL_AM_TOKEN              = &H0009???

'//
'// x64 relocations
'//
%IMAGE_REL_AMD64_ABSOLUTE        = &H0000???  ' // Reference is absolute, no relocation is necessary
%IMAGE_REL_AMD64_ADDR64          = &H0001???  ' // 64-bit address (VA).
%IMAGE_REL_AMD64_ADDR32          = &H0002???  ' // 32-bit address (VA).
%IMAGE_REL_AMD64_ADDR32NB        = &H0003???  ' // 32-bit address w/o image base (RVA).
%IMAGE_REL_AMD64_REL32           = &H0004???  ' // 32-bit relative address from byte following reloc
%IMAGE_REL_AMD64_REL32_1         = &H0005???  ' // 32-bit relative address from byte distance 1 from reloc
%IMAGE_REL_AMD64_REL32_2         = &H0006???  ' // 32-bit relative address from byte distance 2 from reloc
%IMAGE_REL_AMD64_REL32_3         = &H0007???  ' // 32-bit relative address from byte distance 3 from reloc
%IMAGE_REL_AMD64_REL32_4         = &H0008???  ' // 32-bit relative address from byte distance 4 from reloc
%IMAGE_REL_AMD64_REL32_5         = &H0009???  ' // 32-bit relative address from byte distance 5 from reloc
%IMAGE_REL_AMD64_SECTION         = &H000A???  ' // Section index
%IMAGE_REL_AMD64_SECREL          = &H000B???  ' // 32 bit offset from base of section containing target
%IMAGE_REL_AMD64_SECREL7         = &H000C???  ' // 7 bit unsigned offset from base of section containing target
%IMAGE_REL_AMD64_TOKEN           = &H000D???  ' // 32 bit metadata token
%IMAGE_REL_AMD64_SREL32          = &H000E???  ' // 32 bit signed span-dependent value emitted into object
%IMAGE_REL_AMD64_PAIR            = &H000F???
%IMAGE_REL_AMD64_SSPAN32         = &H0010???  ' // 32 bit signed span-dependent value applied at link time

'//
'// IA64 relocation types.
'//
%IMAGE_REL_IA64_ABSOLUTE   = &H0000???
%IMAGE_REL_IA64_IMM14      = &H0001???
%IMAGE_REL_IA64_IMM22      = &H0002???
%IMAGE_REL_IA64_IMM64      = &H0003???
%IMAGE_REL_IA64_DIR32      = &H0004???
%IMAGE_REL_IA64_DIR64      = &H0005???
%IMAGE_REL_IA64_PCREL21B   = &H0006???
%IMAGE_REL_IA64_PCREL21M   = &H0007???
%IMAGE_REL_IA64_PCREL21F   = &H0008???
%IMAGE_REL_IA64_GPREL22    = &H0009???
%IMAGE_REL_IA64_LTOFF22    = &H000A???
%IMAGE_REL_IA64_SECTION    = &H000B???
%IMAGE_REL_IA64_SECREL22   = &H000C???
%IMAGE_REL_IA64_SECREL64I  = &H000D???
%IMAGE_REL_IA64_SECREL32   = &H000E???
'//%IMAGE_REL_IA64_LTOFF64   = &H000F???   ' Not in Vista SDK
%IMAGE_REL_IA64_DIR32NB    = &H0010???
%IMAGE_REL_IA64_SREL14     = &H0011???
%IMAGE_REL_IA64_SREL22     = &H0012???
%IMAGE_REL_IA64_SREL32     = &H0013???
%IMAGE_REL_IA64_UREL32     = &H0014???
%IMAGE_REL_IA64_PCREL60X   = &H0015???   ' // This is always a BRL and never converted
%IMAGE_REL_IA64_PCREL60B   = &H0016???   ' // If possible, convert to MBB bundle with NOP.B in slot 1
%IMAGE_REL_IA64_PCREL60F   = &H0017???   ' // If possible, convert to MFB bundle with NOP.F in slot 1
%IMAGE_REL_IA64_PCREL60I   = &H0018???   ' // If possible, convert to MIB bundle with NOP.I in slot 1
%IMAGE_REL_IA64_PCREL60M   = &H0019???   ' // If possible, convert to MMB bundle with NOP.M in slot 1
%IMAGE_REL_IA64_IMMGPREL64 = &H001A???
%IMAGE_REL_IA64_TOKEN      = &H001B???   ' // clr token
%IMAGE_REL_IA64_GPREL32    = &H001C???
%IMAGE_REL_IA64_ADDEND     = &H001F???

'//
'// CEF relocation types.
'//
%IMAGE_REL_CEF_ABSOLUTE          = &H0000???  ' // Reference is absolute, no relocation is necessary
%IMAGE_REL_CEF_ADDR32            = &H0001???  ' // 32-bit address (VA).
%IMAGE_REL_CEF_ADDR64            = &H0002???  ' // 64-bit address (VA).
%IMAGE_REL_CEF_ADDR32NB          = &H0003???  ' // 32-bit address w/o image base (RVA).
%IMAGE_REL_CEF_SECTION           = &H0004???  ' // Section index
%IMAGE_REL_CEF_SECREL            = &H0005???  ' // 32 bit offset from base of section containing target
%IMAGE_REL_CEF_TOKEN             = &H0006???  ' // 32 bit metadata token

'//
'// clr relocation types.
'//
%IMAGE_REL_CEE_ABSOLUTE          = &H0000???  ' // Reference is absolute, no relocation is necessary
%IMAGE_REL_CEE_ADDR32            = &H0001???  ' // 32-bit address (VA).
%IMAGE_REL_CEE_ADDR64            = &H0002???  ' // 64-bit address (VA).
%IMAGE_REL_CEE_ADDR32NB          = &H0003???  ' // 32-bit address w/o image base (RVA).
%IMAGE_REL_CEE_SECTION           = &H0004???  ' // Section index
%IMAGE_REL_CEE_SECREL            = &H0005???  ' // 32 bit offset from base of section containing target
%IMAGE_REL_CEE_TOKEN             = &H0006???  ' // 32 bit metadata token

%IMAGE_REL_M32R_ABSOLUTE       = &H0000???   ' // No relocation required
%IMAGE_REL_M32R_ADDR32         = &H0001???   ' // 32 bit address
%IMAGE_REL_M32R_ADDR32NB       = &H0002???   ' // 32 bit address w/o image base
%IMAGE_REL_M32R_ADDR24         = &H0003???   ' // 24 bit address
%IMAGE_REL_M32R_GPREL16        = &H0004???   ' // GP relative addressing
%IMAGE_REL_M32R_PCREL24        = &H0005???   ' // 24 bit offset << 2 & sign ext.
%IMAGE_REL_M32R_PCREL16        = &H0006???   ' // 16 bit offset << 2 & sign ext.
%IMAGE_REL_M32R_PCREL8         = &H0007???   ' // 8 bit offset << 2 & sign ext.
%IMAGE_REL_M32R_REFHALF        = &H0008???   ' // 16 MSBs
%IMAGE_REL_M32R_REFHI          = &H0009???   ' // 16 MSBs; adj for LSB sign ext.
%IMAGE_REL_M32R_REFLO          = &H000A???   ' // 16 LSBs
%IMAGE_REL_M32R_PAIR           = &H000B???   ' // Link HI and LO
%IMAGE_REL_M32R_SECTION        = &H000C???   ' // Section table index
%IMAGE_REL_M32R_SECREL32       = &H000D???   ' // 32 bit section relative reference
%IMAGE_REL_M32R_TOKEN          = &H000E???   ' // clr token

%IMAGE_REL_EBC_ABSOLUTE        = &H0000???   ' // No relocation required
%IMAGE_REL_EBC_ADDR32NB        = &H0001???   ' // 32 bit address w/o image base
%IMAGE_REL_EBC_REL32           = &H0002???   ' // 32-bit relative address from byte following reloc
%IMAGE_REL_EBC_SECTION         = &H0003???   ' // Section table index
%IMAGE_REL_EBC_SECREL          = &H0004???   ' // Offset within section

'#define EXT_IMM64(Value, Address, Size, InstPos, ValPos)  /* Intel-IA64-Filler */           \
'    Value |= (((ULONGLONG)((*(Address) >> InstPos) & (((ULONGLONG)1 << Size) - 1))) << ValPos)  // Intel-IA64-Filler

'#define INS_IMM64(Value, Address, Size, InstPos, ValPos)  /* Intel-IA64-Filler */\
'    *(PDWORD)Address = (*(PDWORD)Address & ~(((1 << Size) - 1) << InstPos)) | /* Intel-IA64-Filler */\
'          ((DWORD)((((ULONGLONG)Value >> ValPos) & (((ULONGLONG)1 << Size) - 1))) << InstPos)  // Intel-IA64-Filler

%EMARCH_ENC_I17_IMM7B_INST_WORD_X        = 3  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM7B_SIZE_X             = 7  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM7B_INST_WORD_POS_X    = 4  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM7B_VAL_POS_X          = 0  ' // Intel-IA64-Filler

%EMARCH_ENC_I17_IMM9D_INST_WORD_X        = 3  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM9D_SIZE_X             = 9  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM9D_INST_WORD_POS_X    = 18 ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM9D_VAL_POS_X          = 7  ' // Intel-IA64-Filler

%EMARCH_ENC_I17_IMM5C_INST_WORD_X        = 3  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM5C_SIZE_X             = 5  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM5C_INST_WORD_POS_X    = 13 ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM5C_VAL_POS_X          = 16 ' // Intel-IA64-Filler

%EMARCH_ENC_I17_IC_INST_WORD_X           = 3  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IC_SIZE_X                = 1  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IC_INST_WORD_POS_X       = 12 ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IC_VAL_POS_X             = 21 ' // Intel-IA64-Filler

%EMARCH_ENC_I17_IMM41a_INST_WORD_X       = 1  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41a_SIZE_X            = 10 ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41a_INST_WORD_POS_X   = 14 ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41a_VAL_POS_X         = 22 ' // Intel-IA64-Filler

%EMARCH_ENC_I17_IMM41b_INST_WORD_X       = 1  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41b_SIZE_X            = 8  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41b_INST_WORD_POS_X   = 24 ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41b_VAL_POS_X         = 32 ' // Intel-IA64-Filler

%EMARCH_ENC_I17_IMM41c_INST_WORD_X       = 2  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41c_SIZE_X            = 23 ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41c_INST_WORD_POS_X   = 0  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_IMM41c_VAL_POS_X         = 40 ' // Intel-IA64-Filler

%EMARCH_ENC_I17_SIGN_INST_WORD_X         = 3  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_SIGN_SIZE_X              = 1  ' // Intel-IA64-Filler
%EMARCH_ENC_I17_SIGN_INST_WORD_POS_X     = 27 ' // Intel-IA64-Filler
%EMARCH_ENC_I17_SIGN_VAL_POS_X           = 63 ' // Intel-IA64-Filler

%X3_OPCODE_INST_WORD_X                   = 3  ' // Intel-IA64-Filler
%X3_OPCODE_SIZE_X                        = 4  ' // Intel-IA64-Filler
%X3_OPCODE_INST_WORD_POS_X               = 28 ' // Intel-IA64-Filler
%X3_OPCODE_SIGN_VAL_POS_X                = 0  ' // Intel-IA64-Filler

%X3_I_INST_WORD_X                        = 3  ' // Intel-IA64-Filler
%X3_I_SIZE_X                             = 1  ' // Intel-IA64-Filler
%X3_I_INST_WORD_POS_X                    = 27 ' // Intel-IA64-Filler
%X3_I_SIGN_VAL_POS_X                     = 59 ' // Intel-IA64-Filler

%X3_D_WH_INST_WORD_X                     = 3  ' // Intel-IA64-Filler
%X3_D_WH_SIZE_X                          = 3  ' // Intel-IA64-Filler
%X3_D_WH_INST_WORD_POS_X                 = 24 ' // Intel-IA64-Filler
%X3_D_WH_SIGN_VAL_POS_X                  = 0  ' // Intel-IA64-Filler

%X3_IMM20_INST_WORD_X                    = 3  ' // Intel-IA64-Filler
%X3_IMM20_SIZE_X                         = 20 ' // Intel-IA64-Filler
%X3_IMM20_INST_WORD_POS_X                = 4  ' // Intel-IA64-Filler
%X3_IMM20_SIGN_VAL_POS_X                 = 0  ' // Intel-IA64-Filler

%X3_IMM39_1_INST_WORD_X                  = 2  ' // Intel-IA64-Filler
%X3_IMM39_1_SIZE_X                       = 23 ' // Intel-IA64-Filler
%X3_IMM39_1_INST_WORD_POS_X              = 0  ' // Intel-IA64-Filler
%X3_IMM39_1_SIGN_VAL_POS_X               = 36 ' // Intel-IA64-Filler

%X3_IMM39_2_INST_WORD_X                  = 1  ' // Intel-IA64-Filler
%X3_IMM39_2_SIZE_X                       = 16 ' // Intel-IA64-Filler
%X3_IMM39_2_INST_WORD_POS_X              = 16 ' // Intel-IA64-Filler
%X3_IMM39_2_SIGN_VAL_POS_X               = 20 ' // Intel-IA64-Filler

%X3_P_INST_WORD_X                        = 3 ' // Intel-IA64-Filler
%X3_P_SIZE_X                             = 4 ' // Intel-IA64-Filler
%X3_P_INST_WORD_POS_X                    = 0 ' // Intel-IA64-Filler
%X3_P_SIGN_VAL_POS_X                     = 0 ' // Intel-IA64-Filler

%X3_TMPLT_INST_WORD_X                    = 0 ' // Intel-IA64-Filler
%X3_TMPLT_SIZE_X                         = 4 ' // Intel-IA64-Filler
%X3_TMPLT_INST_WORD_POS_X                = 0 ' // Intel-IA64-Filler
%X3_TMPLT_SIGN_VAL_POS_X                 = 0 ' // Intel-IA64-Filler

%X3_BTYPE_QP_INST_WORD_X                 = 2  ' // Intel-IA64-Filler
%X3_BTYPE_QP_SIZE_X                      = 9  ' // Intel-IA64-Filler
%X3_BTYPE_QP_INST_WORD_POS_X             = 23 ' // Intel-IA64-Filler
%X3_BTYPE_QP_INST_VAL_POS_X              = 0  ' // Intel-IA64-Filler

%X3_EMPTY_INST_WORD_X                    = 1  ' // Intel-IA64-Filler
%X3_EMPTY_SIZE_X                         = 2  ' // Intel-IA64-Filler
%X3_EMPTY_INST_WORD_POS_X                = 14 ' // Intel-IA64-Filler
%X3_EMPTY_INST_VAL_POS_X                 = 0  ' // Intel-IA64-Filler

'//
'// Line number format.
'//

'typedef struct _IMAGE_LINENUMBER {
'    union {
'        DWORD   SymbolTableIndex;               // Symbol table index of function name if Linenumber is 0.
'        DWORD   VirtualAddress;                 // Virtual address of line number.
'    } Type;
'    WORD    Linenumber;                         // Line number.
'} IMAGE_LINENUMBER;
'typedef IMAGE_LINENUMBER UNALIGNED *PIMAGE_LINENUMBER;

UNION IMAGE_LINENUMBER_UNION_Type
   SymbolTableIndex AS DWORD              ' // Symbol table index of function name if Linenumber is 0.
   VirtualAddress   AS DWORD              ' // Virtual address of line number.
END UNION

TYPE IMAGE_LINENUMBER DWORD
   Type       AS IMAGE_LINENUMBER_UNION_Type
   Linenumber AS WORD             ' // Line number.
END TYPE
'typedef IMAGE_LINENUMBER UNALIGNED *PIMAGE_LINENUMBER;

%IMAGE_SIZEOF_LINENUMBER             = 6

'#ifndef _MAC
'#include "poppack.h"                        // Back to 4 byte packing
'#endif

'//
'// Based relocation format.
'//

TYPE IMAGE_BASE_RELOCATION
   VirtualAddress AS DWORD
   SizeOfBlock    AS DWORD
'//  WORD    TypeOffset[1];
END TYPE


%IMAGE_SIZEOF_BASE_RELOCATION        = 8

'//
'// Based relocation types.
'//

%IMAGE_REL_BASED_ABSOLUTE             = 0
%IMAGE_REL_BASED_HIGH                 = 1
%IMAGE_REL_BASED_LOW                  = 2
%IMAGE_REL_BASED_HIGHLOW              = 3
%IMAGE_REL_BASED_HIGHADJ              = 4
%IMAGE_REL_BASED_MIPS_JMPADDR         = 5
%IMAGE_REL_BASED_MIPS_JMPADDR16       = 9
%IMAGE_REL_BASED_IA64_IMM64           = 9
%IMAGE_REL_BASED_DIR64                = 10

'//
'// Archive format.
'//

'#define IMAGE_ARCHIVE_START_SIZE             8
'#define IMAGE_ARCHIVE_START                  "!<arch>\n"
'#define IMAGE_ARCHIVE_END                    "`\n"
'#define IMAGE_ARCHIVE_PAD                    "\n"
'#define IMAGE_ARCHIVE_LINKER_MEMBER          "/               "
'#define IMAGE_ARCHIVE_LONGNAMES_MEMBER       "//              "

%IMAGE_ARCHIVE_START_SIZE            = 8
$IMAGE_ARCHIVE_START                 = "!<arch>\n"
$IMAGE_ARCHIVE_END                   = "`\n"
$IMAGE_ARCHIVE_PAD                   = "\n"
$IMAGE_ARCHIVE_LINKER_MEMBER         = "/               "
$IMAGE_ARCHIVE_LONGNAMES_MEMBER      = "//              "

'typedef struct _IMAGE_ARCHIVE_MEMBER_HEADER {
'    BYTE     Name[16];                          // File member name - `/' terminated.
'    BYTE     Date[12];                          // File member date - decimal.
'    BYTE     UserID[6];                         // File member user id - decimal.
'    BYTE     GroupID[6];                        // File member group id - decimal.
'    BYTE     Mode[8];                           // File member mode - octal.
'    BYTE     Size[10];                          // File member size - decimal.
'    BYTE     EndHeader[2];                      // String to end header.
'} IMAGE_ARCHIVE_MEMBER_HEADER, *PIMAGE_ARCHIVE_MEMBER_HEADER;

TYPE IMAGE_ARCHIVE_MEMBER_HEADER
   Name      (15) AS BYTE                   ' // File member name - `/' terminated.
   Date      (11) AS BYTE                   ' // File member date - decimal.
   UserID    (5)  AS BYTE                   ' // File member user id - decimal.
   GroupID   (5)  AS BYTE                   ' // File member group id - decimal.
   Mode      (7)  AS BYTE                   ' // File member mode - octal.
   Size      (9)  AS BYTE                   ' // File member size - decimal.
   EndHeader (1)  AS BYTE                   ' // String to end header.
END TYPE

%IMAGE_SIZEOF_ARCHIVE_MEMBER_HDR     = 60

'//
'// DLL support.
'//

'//
'// Export Format
'//

TYPE IMAGE_EXPORT_DIRECTORY
   Characteristics       AS DWORD
   TimeDateStamp         AS DWORD
   MajorVersion          AS WORD
   MinorVersion          AS WORD
   nName                 AS DWORD
   nBase                 AS DWORD
   NumberOfFunctions     AS DWORD
   NumberOfNames         AS DWORD
   AddressOfFunctions    AS DWORD   ' // RVA from base of image
   AddressOfNames        AS DWORD   ' // RVA from base of image
   AddressOfNameOrdinals AS DWORD   ' // RVA from base of image
END TYPE

'//
'// Import Format
'//

TYPE IMAGE_IMPORT_BY_NAME
   Hint    AS WORD   ' WORD
   Name(0) AS BYTE   ' BYTE    Name[1]
END TYPE

'#include "pshpack8.h"                       // Use align 8 for the 64-bit IAT.

'typedef struct _IMAGE_THUNK_DATA64 {
'    union {
'        ULONGLONG ForwarderString;  // PBYTE
'        ULONGLONG Function;         // PDWORD
'        ULONGLONG Ordinal;
'        ULONGLONG AddressOfData;    // PIMAGE_IMPORT_BY_NAME
'    } u1;
'} IMAGE_THUNK_DATA64;
'typedef IMAGE_THUNK_DATA64 * PIMAGE_THUNK_DATA64;

UNION IMAGE_THUNK_DATA64_UNION
   ForwarderString AS QUAD     ' // PBYTE
   Function        AS QUAD     ' // PDWORD
   Ordinal         AS QUAD
   AddressOfData   AS QUAD     ' // PIMAGE_IMPORT_BY_NAME
END UNION

TYPE IMAGE_THUNK_DATA64
   IMAGE_THUNK_DATA64_UNION
END TYPE

'#include "poppack.h"                        // Back to 4 byte packing

'typedef struct _IMAGE_THUNK_DATA32 {
'    union {
'        DWORD ForwarderString;      // PBYTE
'        DWORD Function;             // PDWORD
'        DWORD Ordinal;
'        DWORD AddressOfData;        // PIMAGE_IMPORT_BY_NAME
'    } u1;
'} IMAGE_THUNK_DATA32;
'typedef IMAGE_THUNK_DATA32 * PIMAGE_THUNK_DATA32;

UNION IMAGE_THUNK_DATA32_UNION
   ForwarderString AS DWORD     ' // PBYTE
   Function        AS DWORD     ' // PDWORD
   Ordinal         AS DWORD
   AddressOfData   AS DWORD     ' // PIMAGE_IMPORT_BY_NAME
END UNION

TYPE IMAGE_THUNK_DATA32
   IMAGE_THUNK_DATA32_UNION
END TYPE

'#define IMAGE_ORDINAL_FLAG64 0x8000000000000000
'#define IMAGE_ORDINAL_FLAG32 0x80000000
'#define IMAGE_ORDINAL64(Ordinal) (Ordinal & 0xffff)
'#define IMAGE_ORDINAL32(Ordinal) (Ordinal & 0xffff)
'#define IMAGE_SNAP_BY_ORDINAL64(Ordinal) ((Ordinal & IMAGE_ORDINAL_FLAG64) != 0)
'#define IMAGE_SNAP_BY_ORDINAL32(Ordinal) ((Ordinal & IMAGE_ORDINAL_FLAG32) != 0)

%IMAGE_ORDINAL_FLAG64 = &H8000000000000000&&
%IMAGE_ORDINAL_FLAG32 = &H80000000
MACRO IMAGE_ORDINAL64(Ordinal) = (Ordinal AND &Hffff)
MACRO IMAGE_ORDINAL32(Ordinal) = (Ordinal AND &Hffff)
MACRO IMAGE_SNAP_BY_ORDINAL64(Ordinal) = ((Ordinal AND IMAGE_ORDINAL_FLAG64) <> 0)
MACRO IMAGE_SNAP_BY_ORDINAL32(Ordinal) = ((Ordinal AND IMAGE_ORDINAL_FLAG32) <> 0)

'//
'// Thread Local Storage
'//

'typedef VOID
'(NTAPI *PIMAGE_TLS_CALLBACK) (
'    PVOID DllHandle,
'    DWORD Reason,
'    PVOID Reserved
'    );

'typedef struct _IMAGE_TLS_DIRECTORY64 {
'    ULONGLONG   StartAddressOfRawData;
'    ULONGLONG   EndAddressOfRawData;
'    ULONGLONG   AddressOfIndex;         // PDWORD
'    ULONGLONG   AddressOfCallBacks;     // PIMAGE_TLS_CALLBACK *;
'    DWORD   SizeOfZeroFill;
'    DWORD   Characteristics;
'} IMAGE_TLS_DIRECTORY64;
'typedef IMAGE_TLS_DIRECTORY64 * PIMAGE_TLS_DIRECTORY64;

'typedef struct _IMAGE_TLS_DIRECTORY32 {
'    DWORD   StartAddressOfRawData;
'    DWORD   EndAddressOfRawData;
'    DWORD   AddressOfIndex;             // PDWORD
'    DWORD   AddressOfCallBacks;         // PIMAGE_TLS_CALLBACK *
'    DWORD   SizeOfZeroFill;
'    DWORD   Characteristics;
'} IMAGE_TLS_DIRECTORY32;
'typedef IMAGE_TLS_DIRECTORY32 * PIMAGE_TLS_DIRECTORY32;

'typedef struct _IMAGE_IMPORT_DESCRIPTOR {
'    union {
'        DWORD   Characteristics;            // 0 for terminating null import descriptor
'        DWORD   OriginalFirstThunk;         // RVA to original unbound IAT (PIMAGE_THUNK_DATA)
'    };
'    DWORD   TimeDateStamp;                  // 0 if not bound,
'                                            // -1 if bound, and real date\time stamp
'                                            //     in IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT (new BIND)
'                                            // O.W. date/time stamp of DLL bound to (Old BIND)

'    DWORD   ForwarderChain;                 // -1 if no forwarders
'    DWORD   Name;
'    DWORD   FirstThunk;                     // RVA to IAT (if bound this IAT has actual addresses)
'} IMAGE_IMPORT_DESCRIPTOR;
'typedef IMAGE_IMPORT_DESCRIPTOR UNALIGNED *PIMAGE_IMPORT_DESCRIPTOR;

UNION IMAGE_IMPORT_DESCRIPTOR_UNION
   Characteristics    AS DWORD           ' // 0 for terminating null import descriptor
   OriginalFirstThunk AS DWORD        ' // RVA to original unbound IAT (PIMAGE_THUNK_DATA)
END UNION

'#ifdef _WIN64
'#define IMAGE_ORDINAL_FLAG              IMAGE_ORDINAL_FLAG64
'#define IMAGE_ORDINAL(Ordinal)          IMAGE_ORDINAL64(Ordinal)
'typedef IMAGE_THUNK_DATA64              IMAGE_THUNK_DATA;
'typedef PIMAGE_THUNK_DATA64             PIMAGE_THUNK_DATA;
'#define IMAGE_SNAP_BY_ORDINAL(Ordinal)  IMAGE_SNAP_BY_ORDINAL64(Ordinal)
'typedef IMAGE_TLS_DIRECTORY64           IMAGE_TLS_DIRECTORY;
'typedef PIMAGE_TLS_DIRECTORY64          PIMAGE_TLS_DIRECTORY;
'#else
'#define IMAGE_ORDINAL_FLAG              IMAGE_ORDINAL_FLAG32
'#define IMAGE_ORDINAL(Ordinal)          IMAGE_ORDINAL32(Ordinal)
'typedef IMAGE_THUNK_DATA32              IMAGE_THUNK_DATA;
'typedef PIMAGE_THUNK_DATA32             PIMAGE_THUNK_DATA;
'#define IMAGE_SNAP_BY_ORDINAL(Ordinal)  IMAGE_SNAP_BY_ORDINAL32(Ordinal)
'typedef IMAGE_TLS_DIRECTORY32           IMAGE_TLS_DIRECTORY;
'typedef PIMAGE_TLS_DIRECTORY32          PIMAGE_TLS_DIRECTORY;
'#endif

TYPE IMAGE_IMPORT_DESCRIPTOR
   IMAGE_IMPORT_DESCRIPTOR_UNION
   TimeDateStamp  AS DWORD   ' // 0 if not bound,
                             ' // -1 if bound, and real date\time stamp
                             ' //     in IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT (new BIND)
                             ' // O.W. date/time stamp of DLL bound to (Old BIND)
   ForwarderChain AS DWORD   ' // -1 if no forwarders
   Name           AS DWORD
   FirstThunk     AS DWORD   ' // RVA to IAT (if bound this IAT has actual addresses)
END TYPE

'//
'// New format import descriptors pointed to by DataDirectory[ IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT ]
'//

TYPE IMAGE_BOUND_IMPORT_DESCRIPTOR
   TimeDateStamp               AS DWORD
   OffsetModuleName            AS WORD
   NumberOfModuleForwarderRefs AS WORD
   '// Array of zero or more IMAGE_BOUND_FORWARDER_REF follows
END TYPE

TYPE IMAGE_BOUND_FORWARDER_REF
   TimeDateStamp    AS DWORD
   OffsetModuleName AS WORD
   Reserved         AS WORD
END TYPE

'//
'// Resource Format.
'//

'//
'// Resource directory consists of two counts, following by a variable length
'// array of directory entries.  The first count is the number of entries at
'// beginning of the array that have actual names associated with each entry.
'// The entries are in ascending order, case insensitive strings.  The second
'// count is the number of entries that immediately follow the named entries.
'// This second count identifies the number of entries that have 16-bit integer
'// Ids as their name.  These entries are also sorted in ascending order.
'//
'// This structure allows fast lookup by either name or number, but for any
'// given resource entry only one form of lookup is supported, not both.
'// This is consistant with the syntax of the .RC file and the .RES file.
'//

TYPE IMAGE_RESOURCE_DIRECTORY
   Characteristics      AS DWORD
   TimeDateStamp        AS DWORD
   MajorVersion         AS WORD
   MinorVersion         AS WORD
   NumberOfNamedEntries AS WORD
   NumberOfIdEntries    AS WORD
   '//  IMAGE_RESOURCE_DIRECTORY_ENTRY DirectoryEntries[];
END TYPE

%IMAGE_RESOURCE_NAME_IS_STRING       = &H80000000???
%IMAGE_RESOURCE_DATA_IS_DIRECTORY    = &H80000000???

'//
'// Each directory contains the 32-bit Name of the entry and an offset,
'// relative to the beginning of the resource directory of the data associated
'// with this directory entry.  If the name of the entry is an actual text
'// string instead of an integer Id, then the high order bit of the name field
'// is set to one and the low order 31-bits are an offset, relative to the
'// beginning of the resource directory of the string, which is of type
'// IMAGE_RESOURCE_DIRECTORY_STRING.  Otherwise the high bit is clear and the
'// low-order 16-bits are the integer Id that identify this resource directory
'// entry. If the directory entry is yet another resource directory (i.e. a
'// subdirectory), then the high order bit of the offset field will be
'// set to indicate this.  Otherwise the high bit is clear and the offset
'// field points to a resource data entry.
'//

'typedef struct _IMAGE_RESOURCE_DIRECTORY_ENTRY {
'    union {
'        struct {
'            DWORD NameOffset:31;
'            DWORD NameIsString:1;
'        };
'        DWORD   Name;
'        WORD    Id;
'    };
'    union {
'        DWORD   OffsetToData;
'        struct {
'            DWORD   OffsetToDirectory:31;
'            DWORD   DataIsDirectory:1;
'        };
'    };
'} IMAGE_RESOURCE_DIRECTORY_ENTRY, *PIMAGE_RESOURCE_DIRECTORY_ENTRY;

TYPE IMAGE_RESOURCE_DIRECTORY_ENTRY_UNION_STRUCT_1
   NameOffset   AS BIT * 31 IN DWORD
   NameIsString AS BIT * 1
END TYPE

UNION IMAGE_RESOURCE_DIRECTORY_ENTRY_UNION_1
   IMAGE_RESOURCE_DIRECTORY_ENTRY_UNION_STRUCT_1
   Name AS DWORD
   Id   AS WORD
END UNION

TYPE IMAGE_RESOURCE_DIRECTORY_ENTRY_UNION_STRUCT_2
   OffsetToDirectory AS BIT * 31 IN DWORD
   DataIsDirectory   AS BIT * 1
END TYPE

UNION IMAGE_RESOURCE_DIRECTORY_ENTRY_UNION_2
   OffsetToData AS DWORD
   IMAGE_RESOURCE_DIRECTORY_ENTRY_UNION_STRUCT_2
END UNION

TYPE IMAGE_RESOURCE_DIRECTORY_ENTRY
   IMAGE_RESOURCE_DIRECTORY_ENTRY_UNION_1
   IMAGE_RESOURCE_DIRECTORY_ENTRY_UNION_2
END TYPE

'//
'// For resource directory entries that have actual string names, the Name
'// field of the directory entry points to an object of the following type.
'// All of these string objects are stored together after the last resource
'// directory entry and before the first resource data object.  This minimizes
'// the impact of these variable length objects on the alignment of the fixed
'// size directory entry objects.
'//

TYPE IMAGE_RESOURCE_DIRECTORY_STRING
   Length        AS WORD   ' WORD
   NameString(0) AS BYTE   ' CHAR    NameString[ 1 ]
END TYPE

TYPE IMAGE_RESOURCE_DIR_STRING_U
   Length        AS WORD   ' WORD
   NameString(0) AS WORD   ' WCHAR   NameString[ 1 ]
END TYPE


'//
'// Each resource data entry describes a leaf node in the resource directory
'// tree.  It contains an offset, relative to the beginning of the resource
'// directory of the data for the resource, a size field that gives the number
'// of bytes of data at that offset, a CodePage that should be used when
'// decoding code point values within the resource data.  Typically for new
'// applications the code page would be the unicode code page.
'//

TYPE IMAGE_RESOURCE_DATA_ENTRY
   OffsetToData AS DWORD
   Size         AS DWORD
   CodePage     AS DWORD
   Reserved     AS DWORD
END TYPE

'//
'// Load Configuration Directory Entry
'//

TYPE IMAGE_LOAD_CONFIG_DIRECTORY32
   Size                          AS DWORD
   TimeDateStamp                 AS DWORD
   MajorVersion                  AS WORD
   MinorVersion                  AS WORD
   GlobalFlagsClear              AS DWORD
   GlobalFlagsSet                AS DWORD
   CriticalSectionDefaultTimeout AS DWORD
   DeCommitFreeBlockThreshold    AS DWORD
   DeCommitTotalFreeThreshold    AS DWORD
   LockPrefixTable               AS DWORD   ' // VA
   MaximumAllocationSize         AS DWORD
   VirtualMemoryThreshold        AS DWORD
   ProcessHeapFlags              AS DWORD
   ProcessAffinityMask           AS DWORD
   CSDVersion                    AS WORD
   Reserved1                     AS WORD
   EditList                      AS DWORD   ' // VA
   SecurityCookie                AS DWORD   ' // VA
   SEHandlerTable                AS DWORD   ' // VA
   SEHandlerCount                AS DWORD
END TYPE

TYPE IMAGE_LOAD_CONFIG_DIRECTORY64
   Size                          AS DWORD
   TimeDateStamp                 AS DWORD
   MajorVersion                  AS WORD
   MinorVersion                  AS WORD
   GlobalFlagsClear              AS DWORD
   GlobalFlagsSet                AS DWORD
   CriticalSectionDefaultTimeout AS DWORD
   DeCommitFreeBlockThreshold    AS QUAD
   DeCommitTotalFreeThreshold    AS QUAD    ' ULONGLONG
   LockPrefixTable               AS QUAD    ' ULONGLONG // VA
   MaximumAllocationSize         AS QUAD    ' ULONGLONG
   VirtualMemoryThreshold        AS QUAD    ' ULONGLONG
   ProcessAffinityMask           AS QUAD    ' ULONGLONG
   ProcessHeapFlags              AS DWORD
   CSDVersion                    AS WORD
   Reserved1                     AS WORD
   EditList                      AS QUAD    ' ULONGLONG // VA
   SecurityCookie                AS QUAD    ' ULONGLONG // VA
   SEHandlerTable                AS QUAD    ' ULONGLONG // VA
   SEHandlerCount                AS QUAD
END TYPE

'//
'// WIN CE Exception table format
'//

'//
'// Function table entry format.  Function table is pointed to by the
'// IMAGE_DIRECTORY_ENTRY_EXCEPTION directory entry.
'//

TYPE IMAGE_CE_RUNTIME_FUNCTION_ENTRY
   FuncStart     AS DWORD
   PrologLen     AS BIT   * 8  IN DWORD
   FuncLen       AS BIT   * 22
   ThirtyTwoBit  AS BIT   * 1
   ExceptionFlag AS BIT   * 1
END TYPE

TYPE IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY
   BeginAddress     AS QUAD   ' ULONGLONG
   EndAddress       AS QUAD   ' ULONGLONG
   ExceptionHandler AS QUAD   ' ULONGLONG
   HandlerData      AS QUAD   ' ULONGLONG
   PrologEndAddress AS QUAD   ' ULONGLONG
END TYPE

TYPE IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY
   BeginAddress     AS DWORD
   EndAddress       AS DWORD
   ExceptionHandler AS DWORD
   HandlerData      AS DWORD
   PrologEndAddress AS DWORD
END TYPE

TYPE IMAGE_RUNTIME_FUNCTION_ENTRY
   BeginAddress      AS DWORD
   EndAddress        AS DWORD
   UnwindInfoAddress AS DWORD
END TYPE

'//
'// Debug Format
'//

TYPE IMAGE_DEBUG_DIRECTORY
   Characteristics  AS DWORD
   TimeDateStamp    AS DWORD
   MajorVersion     AS WORD
   MinorVersion     AS WORD
   Type             AS DWORD
   SizeOfData       AS DWORD
   AddressOfRawData AS DWORD
   PointerToRawData AS DWORD
END TYPE

%IMAGE_DEBUG_TYPE_UNKNOWN         = 0
%IMAGE_DEBUG_TYPE_COFF            = 1
%IMAGE_DEBUG_TYPE_CODEVIEW        = 2
%IMAGE_DEBUG_TYPE_FPO             = 3
%IMAGE_DEBUG_TYPE_MISC            = 4
%IMAGE_DEBUG_TYPE_EXCEPTION       = 5
%IMAGE_DEBUG_TYPE_FIXUP           = 6
%IMAGE_DEBUG_TYPE_OMAP_TO_SRC     = 7
%IMAGE_DEBUG_TYPE_OMAP_FROM_SRC   = 8
%IMAGE_DEBUG_TYPE_BORLAND         = 9
%IMAGE_DEBUG_TYPE_RESERVED10      = 10
%IMAGE_DEBUG_TYPE_CLSID           = 11

TYPE IMAGE_COFF_SYMBOLS_HEADER
   NumberOfSymbols      AS DWORD
   LvaToFirstSymbol     AS DWORD
   NumberOfLinenumbers  AS DWORD
   LvaToFirstLinenumber AS DWORD
   RvaToFirstByteOfCode AS DWORD
   RvaToLastByteOfCode  AS DWORD
   RvaToFirstByteOfData AS DWORD
   RvaToLastByteOfData  AS DWORD
END TYPE

%FRAME_FPO      = 0
%FRAME_TRAP     = 1
%FRAME_TSS      = 2
%FRAME_NONFPO   = 3

TYPE FPO_DATA
   ulOffStart AS DWORD               ' // offset 1st byte of function code
   cbProcSize AS DWORD               ' // # bytes in function
   cdwLocals  AS DWORD               ' // # bytes in locals/4
   cdwParams  AS WORD                ' // # bytes in params/4
   cbProlog   AS BIT   * 8 IN WORD   ' // # bytes in prolog
   cbRegs     AS BIT   * 3           ' // # regs saved
   fHasSEH    AS BIT   * 1           ' // TRUE if SEH in func
   fUseBP     AS BIT   * 1           ' // TRUE if EBP has been allocated
   reserved   AS BIT   * 1           ' // reserved for future use
   cbFrame    AS BIT   * 2           ' // frame type
END TYPE

%SIZEOF_RFPO_DATA = 16

%IMAGE_DEBUG_MISC_EXENAME = 1

TYPE IMAGE_DEBUG_MISC
   DataType    AS DWORD          ' DWORD    // type of misc data, see defines
   Length      AS DWORD          ' DWORD    // total length of record, rounded to four
                                 '          // byte multiple.
   Unicode     AS BYTE           ' BOOLLEAN // TRUE if data is unicode string
   Reserved(2) AS BYTE           ' BYTE     // Reserved[ 3 ]
   Data(0)     AS BYTE           ' BYTE Data[ 1 ]  // Actual data
END TYPE

'//
'// Function table extracted from MIPS/ALPHA/IA64 images.  Does not contain
'// information needed only for runtime support.  Just those fields for
'// each entry needed by a debugger.
'//

TYPE IMAGE_FUNCTION_ENTRY
   StartingAddress AS DWORD
   EndingAddress   AS DWORD
   EndOfPrologue   AS DWORD
END TYPE

'typedef struct _IMAGE_FUNCTION_ENTRY64 {
'    ULONGLONG   StartingAddress;
'    ULONGLONG   EndingAddress;
'    union {
'        ULONGLONG   EndOfPrologue;
'        ULONGLONG   UnwindInfoAddress;
'    };
'} IMAGE_FUNCTION_ENTRY64, *PIMAGE_FUNCTION_ENTRY64;

UNION IMAGE_FUNCTION_ENTRY64_UNION
   EndOfPrologue     AS QUAD   ' ULONGLONG
   UnwindInfoAddress AS QUAD   ' ULONGLONG
END UNION

TYPE IMAGE_FUNCTION_ENTRY64
   StartingAddress AS QUAD   ' ULONGLONG
   EndingAddress   AS QUAD   ' ULONGLONG
   IMAGE_FUNCTION_ENTRY64_UNION
END TYPE

'//
'// Debugging information can be stripped from an image file and placed
'// in a separate .DBG file, whose file name part is the same as the
'// image file name part (e.g. symbols for CMD.EXE could be stripped
'// and placed in CMD.DBG).  This is indicated by the IMAGE_FILE_DEBUG_STRIPPED
'// flag in the Characteristics field of the file header.  The beginning of
'// the .DBG file contains the following structure which captures certain
'// information from the image file.  This allows a debug to proceed even if
'// the original image file is not accessable.  This header is followed by
'// zero of more IMAGE_SECTION_HEADER structures, followed by zero or more
'// IMAGE_DEBUG_DIRECTORY structures.  The latter structures and those in
'// the image file contain file offsets relative to the beginning of the
'// .DBG file.
'//
'// If symbols have been stripped from an image, the IMAGE_DEBUG_MISC structure
'// is left in the image file, but not mapped.  This allows a debugger to
'// compute the name of the .DBG file, from the name of the image in the
'// IMAGE_DEBUG_MISC structure.
'//

TYPE IMAGE_SEPARATE_DEBUG_HEADER
   Signature          AS WORD
   Flags              AS WORD
   Machine            AS WORD
   Characteristics    AS WORD
   TimeDateStamp      AS DWORD
   CheckSum           AS DWORD
   ImageBase          AS DWORD
   SizeOfImage        AS DWORD
   NumberOfSections   AS DWORD
   ExportedNamesSize  AS DWORD
   DebugDirectorySize AS DWORD
   SectionAlignment   AS DWORD
   Reserved(1)        AS DWORD
END TYPE

TYPE NON_PAGED_DEBUG_INFO
   Signature       AS WORD
   Flags           AS WORD
   Size            AS DWORD
   Machine         AS WORD
   Characteristics AS WORD
   TimeDateStamp   AS DWORD
   CheckSum        AS DWORD
   SizeOfImage     AS DWORD
   ImageBase       AS QUAD    ' ULONGLONG
   ' //DebugDirectorySize
   ' //IMAGE_DEBUG_DIRECTORY
END TYPE

%IMAGE_SEPARATE_DEBUG_SIGNATURE  = &H4944
%NON_PAGED_DEBUG_SIGNATURE       = &H494E

%IMAGE_SEPARATE_DEBUG_FLAGS_MASK = &H8000
%IMAGE_SEPARATE_DEBUG_MISMATCH   = &H8000  ' // when DBG was updated, the
                                           ' // old checksum didn't match.

'//
'//  The .arch section is made up of headers, each describing an amask position/value
'//  pointing to an array of IMAGE_ARCHITECTURE_ENTRY's.  Each "array" (both the header
'//  and entry arrays) are terminiated by a quadword of 0xffffffffL.
'//
'//  NOTE: There may be quadwords of 0 sprinkled around and must be skipped.
'//

TYPE IMAGE_ARCHITECTURE_HEADER
   AmaskValue    AS BIT   * 1  IN DWORD   ' // 1 -> code section depends on mask bit
                                                 ' // 0 -> new instruction depends on mask bit
   MBZ1          AS BIT   * 7             ' // MBZ
   AmaskShift    AS BIT   * 8             ' // Amask bit in question for this fixup
   MBZ2          AS BIT   * 16            ' // MBZ
   FirstEntryRVA AS DWORD                 ' // RVA into .arch section to array of ARCHITECTURE_ENTRY's
END TYPE

TYPE IMAGE_ARCHITECTURE_ENTRY
   FixupInstRVA AS DWORD   ' // RVA of instruction to fixup
   NewInst      AS DWORD   ' // fixup instruction (see alphaops.h)
END TYPE

'#include "poppack.h"                // Back to the initial value

'// The following structure defines the new import object.  Note the values of the first two fields,
'// which must be set as stated in order to differentiate old and new import members.
'// Following this structure, the linker emits two null-terminated strings used to recreate the
'// import at the time of use.  The first string is the import's name, the second is the dll's name.

%IMPORT_OBJECT_HDR_SIG2 = &Hffff

'typedef struct IMPORT_OBJECT_HEADER {
'    WORD    Sig1;                       // Must be IMAGE_FILE_MACHINE_UNKNOWN
'    WORD    Sig2;                       // Must be IMPORT_OBJECT_HDR_SIG2.
'    WORD    Version;
'    WORD    Machine;
'    DWORD   TimeDateStamp;              // Time/date stamp
'    DWORD   SizeOfData;                 // particularly useful for incremental links

'    union {
'        WORD    Ordinal;                // if grf & IMPORT_OBJECT_ORDINAL
'        WORD    Hint;
'    };

'    WORD    Type : 2;                   // IMPORT_TYPE
'    WORD    NameType : 3;               // IMPORT_NAME_TYPE
'    WORD    Reserved : 11;              // Reserved. Must be zero.
'} IMPORT_OBJECT_HEADER;

UNION IMPORT_OBJECT_HEADER_UNION
   Ordinal AS WORD                   ' // if grf & IMPORT_OBJECT_ORDINAL
   Hint    AS WORD
END UNION

TYPE IMPORT_OBJECT_HEADER
   Sig1          AS WORD    ' // Must be IMAGE_FILE_MACHINE_UNKNOWN
   Sig2          AS WORD    ' // Must be IMPORT_OBJECT_HDR_SIG2.
   Version       AS WORD
   Machine       AS WORD
   TimeDateStamp AS DWORD   ' // Time/date stamp
   SizeOfData    AS DWORD   ' // particularly useful for incremental links
   IMPORT_OBJECT_HEADER_UNION
   Type          AS BIT * 2  IN WORD   ' // IMPORT_TYPE
   NameType      AS BIT * 3            ' // IMPORT_NAME_TYPE
   Reserved      AS BIT * 11           ' // Reserved. Must be zero.
END TYPE

' IMPORT_OBJECT_TYPE enum
%IMPORT_OBJECT_CODE  = 0
%IMPORT_OBJECT_DATA  = 1
%IMPORT_OBJECT_CONST = 2

' IMPORT_OBJECT_NAME_TYPE enum
%IMPORT_OBJECT_ORDINAL = 0         ' // Import by ordinal
%IMPORT_OBJECT_NAME = 1            ' // Import name == public symbol name.
%IMPORT_OBJECT_NAME_NO_PREFIX = 2  ' // Import name == public symbol name skipping leading ?, @, or optionally _.
%IMPORT_OBJECT_NAME_UNDECORATE = 3 ' // Import name == public symbol name skipping leading ?, @, or optionally _
                                   ' // and truncating at first @

#IF NOT %DEF(%IMAGE_COR20_HEADER_DEFINED)  ' ----------------------------------
    %IMAGE_COR20_HEADER_DEFINED = 1
'#ifndef __IMAGE_COR20_HEADER_DEFINED__
'#define __IMAGE_COR20_HEADER_DEFINED__

'typedef enum ReplacesCorHdrNumericDefines
'{
'// COM+ Header entry point flags.
'    COMIMAGE_FLAGS_ILONLY               =0x00000001,
'    COMIMAGE_FLAGS_32BITREQUIRED        =0x00000002,
'    COMIMAGE_FLAGS_IL_LIBRARY           =0x00000004,
'    COMIMAGE_FLAGS_STRONGNAMESIGNED     =0x00000008,
'    COMIMAGE_FLAGS_TRACKDEBUGDATA       =0x00010000,

'// Version flags for image.
'    COR_VERSION_MAJOR_V2                =2,
'    COR_VERSION_MAJOR                   =COR_VERSION_MAJOR_V2,
'    COR_VERSION_MINOR                   =0,
'    COR_DELETED_NAME_LENGTH             =8,
'    COR_VTABLEGAP_NAME_LENGTH           =8,

'// Maximum size of a NativeType descriptor.
'    NATIVE_TYPE_MAX_CB                  =1,
'    COR_ILMETHOD_SECT_SMALL_MAX_DATASIZE=0xFF,

'// #defines for the MIH FLAGS
'    IMAGE_COR_MIH_METHODRVA             =0x01,
'    IMAGE_COR_MIH_EHRVA                 =0x02,
'    IMAGE_COR_MIH_BASICBLOCK            =0x08,

'// V-table constants
'    COR_VTABLE_32BIT                    =0x01,          // V-table slots are 32-bits in size.
'    COR_VTABLE_64BIT                    =0x02,          // V-table slots are 64-bits in size.
'    COR_VTABLE_FROM_UNMANAGED           =0x04,          // If set, transition from unmanaged.
'    COR_VTABLE_CALL_MOST_DERIVED        =0x10,          // Call most derived method described by

'// EATJ constants
'    IMAGE_COR_EATJ_THUNK_SIZE           =32,            // Size of a jump thunk reserved range.

'// Max name lengths
'    //@todo: Change to unlimited name lengths.
'    MAX_CLASS_NAME                      =1024,
'    MAX_PACKAGE_NAME                    =1024,
'} ReplacesCorHdrNumericDefines;

'// COM+ Header entry point flags.
%COMIMAGE_FLAGS_ILONLY               = &H00000001???
%COMIMAGE_FLAGS_32BITREQUIRED        = &H00000002???
%COMIMAGE_FLAGS_IL_LIBRARY           = &H00000004???
%COMIMAGE_FLAGS_STRONGNAMESIGNED     = &H00000008???
%COMIMAGE_FLAGS_TRACKDEBUGDATA       = &H00010000???

'// Version flags for image.
%COR_VERSION_MAJOR_V2                = 2
%COR_VERSION_MAJOR                   = %COR_VERSION_MAJOR_V2
%COR_VERSION_MINOR                   = 0
%COR_DELETED_NAME_LENGTH             = 8
%COR_VTABLEGAP_NAME_LENGTH           = 8

'// Maximum size of a NativeType descriptor.
%NATIVE_TYPE_MAX_CB                   = 1
%COR_ILMETHOD_SECT_SMALL_MAX_DATASIZE = &HFF

'// #defines for the MIH FLAGS
%IMAGE_COR_MIH_METHODRVA             = &H01
%IMAGE_COR_MIH_EHRVA                 = &H02
%IMAGE_COR_MIH_BASICBLOCK            = &H08

'// V-table constants
%COR_VTABLE_32BIT                    = &H01         ' // V-table slots are 32-bits in size.
%COR_VTABLE_64BIT                    = &H02         ' // V-table slots are 64-bits in size.
%COR_VTABLE_FROM_UNMANAGED           = &H04         ' // If set, transition from unmanaged.
%COR_VTABLE_CALL_MOST_DERIVED        = &H10         ' // Call most derived method described by

'// EATJ constants
%IMAGE_COR_EATJ_THUNK_SIZE           = 32           ' // Size of a jump thunk reserved range.

'// Max name lengths
'//@todo: Change to unlimited name lengths.
%MAX_CLASS_NAME                      = 1024
%MAX_PACKAGE_NAME                    = 1024

'// COM+ 2.0 header structure.
'typedef struct IMAGE_COR20_HEADER
'{
'    // Header versioning
'    DWORD                   cb;
'    WORD                    MajorRuntimeVersion;
'    WORD                    MinorRuntimeVersion;

'    // Symbol table and startup information
'    IMAGE_DATA_DIRECTORY    MetaData;
'    DWORD                   Flags;
'    DWORD                   EntryPointToken;

'    // Binding information
'    IMAGE_DATA_DIRECTORY    Resources;
'    IMAGE_DATA_DIRECTORY    StrongNameSignature;

'    // Regular fixup and binding information
'    IMAGE_DATA_DIRECTORY    CodeManagerTable;
'    IMAGE_DATA_DIRECTORY    VTableFixups;
'    IMAGE_DATA_DIRECTORY    ExportAddressTableJumps;

'    // Precompiled image info (internal use only - set to zero)
'    IMAGE_DATA_DIRECTORY    ManagedNativeHeader;

'} IMAGE_COR20_HEADER, *PIMAGE_COR20_HEADER;

'// COM+ 2.0 header structure.
TYPE IMAGE_COR20_HEADER
   ' // Header versioning
   cb AS DWORD
   MajorRuntimeVersion AS WORD
   MinorRuntimeVersion AS WORD

   ' // Symbol table and startup information
   MetaData AS IMAGE_DATA_DIRECTORY
   Flags AS DWORD
   EntryPointToken AS DWORD

   ' // Binding information
   Resources AS IMAGE_DATA_DIRECTORY
   StrongNameSignature AS IMAGE_DATA_DIRECTORY

   ' // Regular fixup and binding information
   CodeManagerTable AS IMAGE_DATA_DIRECTORY
   VTableFixups AS IMAGE_DATA_DIRECTORY
   ExportAddressTableJumps AS IMAGE_DATA_DIRECTORY

   ' // Precompiled image info (internal use only - set to zero)
   ManagedNativeHeader AS IMAGE_DATA_DIRECTORY

END TYPE

'#endif // __IMAGE_COR20_HEADER_DEFINED__
#ENDIF   ' #IF NOT %DEF(%IMAGE_COR20_HEADER_DEFINED)  -------------------------

'//
'// End Image Format
'//

'//
'// for move macros
'//
'#ifdef _MAC
'#ifndef _INC_STRING
'#include <string.h>
'#endif /* _INC_STRING */
'#else
'#include <string.h>
'#endif // _MAC


#IF NOT %DEF(%SLIST_HEADER)  ' ------------------------------------------------
    %SLIST_HEADER = 1
'#ifndef _SLIST_HEADER_
'#define _SLIST_HEADER_

'#if defined(_WIN64)

'//
'// The type SINGLE_LIST_ENTRY is not suitable for use with SLISTs.  For
'// WIN64, an entry on an SLIST is required to be 16-byte aligned, while a
'// SINGLE_LIST_ENTRY structure has only 8 byte alignment.
'//
'// Therefore, all SLIST code should use the SLIST_ENTRY type instead of the
'// SINGLE_LIST_ENTRY type.
'//

'#pragma warning(push)
'#pragma warning(disable:4324)   // structure padded due to align()
'typedef struct DECLSPEC_ALIGN(16) _SLIST_ENTRY *PSLIST_ENTRY;
'typedef struct DECLSPEC_ALIGN(16) _SLIST_ENTRY {
'    PSLIST_ENTRY Next;
'} SLIST_ENTRY;

TYPE SLIST_ENTRY   ' 16-byte alignment
   Next AS SLIST_ENTRY PTR
   filler1 AS DWORD
   filler2 AS DWORD
   filler3 AS DWORD
END TYPE

'typedef union _SLIST_HEADER {
'    ULONGLONG Alignment;
'    struct {
'        SLIST_ENTRY Next;
'        WORD   Depth;
'        WORD   Sequence;
'    };
'} SLIST_HEADER, *PSLIST_HEADER;

TYPE SLIST_HEADER
   Alignment AS QUAD
   Next      AS SLIST_ENTRY PTR
   Depth     AS WORD
   Sequence  AS WORD
END TYPE

#ENDIF   ' #IF NOT %DEF(%SLIST_HEADER) ----------------------------------------

DECLARE SUB RtlInitializeSListHead LIB "NTDLL.DLL" ALIAS "RtlInitializeSListHead" ( _
   BYREF SLIST_HEADER _                     ' IN PSLIST_HEADER ListHead
 )                                          ' VOID

DECLARE FUNCTION RtlFirstEntrySList LIB "NTDLL.DLL" ALIAS "RtlFirstEntrySList" ( _
   BYREF SLIST_HEADER _                     ' IN const SLIST_HEADER *ListHead
 ) AS DWORD                                 ' PSLIST_ENTRY

DECLARE FUNCTION RtlInterlockedPopEntrySList LIB "NTDLL.DLL" ALIAS "RtlInterlockedPopEntrySList" ( _
   BYREF SLIST_HEADER _                     ' IN PSLIST_HEADER ListHead
 ) AS DWORD                                 ' PSLIST_ENTRY

DECLARE FUNCTION RtlInterlockedPushEntrySList LIB "NTDLL.DLL" ALIAS "RtlInterlockedPushEntrySList" ( _
   BYREF SLIST_HEADER _                     ' IN PSLIST_HEADER ListHead
 , BYREF SLIST_ENTRY _                      ' IN PSLIST_ENTRY ListEntry
 ) AS DWORD                                 ' PSLIST_ENTRY

DECLARE FUNCTION RtlInterlockedFlushSList LIB "NTDLL.DLL" ALIAS "RtlInterlockedFlushSList" ( _
   BYREF SLIST_HEADER _                     ' IN PSLIST_HEADER ListHead
 ) AS DWORD                                 ' PSLIST_ENTRY

DECLARE FUNCTION RtlQueryDepthSList LIB "NTDLL.DLL" ALIAS "RtlQueryDepthSList" ( _
   BYREF SLIST_HEADER _                     ' IN PSLIST_HEADER ListHead
 ) AS WORD                                  ' WORD

'#ifndef _RTL_RUN_ONCE_DEF
'#define _RTL_RUN_ONCE_DEF

'//
'// Run once
'//

%RTL_RUN_ONCE_INIT = 0   ' // Static initializer

'//
'// Run once flags
'//

%RTL_RUN_ONCE_CHECK_ONLY     = &H00000001???
%RTL_RUN_ONCE_ASYNC          = &H00000002???
%RTL_RUN_ONCE_INIT_FAILED    = &H00000004???

'//
'// The context stored in the run once structure must leave the following number
'// of low order bits unused.
'//

%RTL_RUN_ONCE_CTX_RESERVED_BITS = 2

UNION RTL_RUN_ONCE
   Ptr AS DWORD   ' PVOID
END UNION

'typedef
'DWORD /* LOGICAL */
'(NTAPI *PRTL_RUN_ONCE_INIT_FN) (
'    __inout PRTL_RUN_ONCE RunOnce,
'    __inout_opt PVOID Parameter,
'    __deref_opt_out_opt PVOID *Context
'    );

'#endif // _RTL_RUN_ONCE_DEF

'#if !defined(MIDL_PASS) && !defined(SORTPP_PASS)

'VOID
'//FORCEINLINE
'RtlRunOnceInitialize (
'    __out PRTL_RUN_ONCE RunOnce
'    );

DECLARE SUB RtlRunOnceInitialize LIB "KERNEL32.DLL" ALIAS "RtlRunOnceInitialize" (BYREF RTL_RUN_ONCE)

'#endif // !defined(MIDL_PASS) && !defined(SORTPP_PASS)

DECLARE FUNCTION RtlRunOnceExecuteOnce LIB "KERNEL32.DLL" ALIAS "RtlRunOnceExecuteOnce" ( _
   BYREF RTL_RUN_ONCE _                       ' __inout PRTL_RUN_ONCE RunOnce
 , BYVAL DWORD _                              ' __in __callback PRTL_RUN_ONCE_INIT_FN InitFn
 , BYREF ANY _                                ' __inout_opt PVOID Parameter
 , BYREF ANY _                                ' __deref_opt_out_opt PVOID *Context
 ) AS DWORD                                   ' DWORD

DECLARE FUNCTION RtlRunOnceBeginInitialize LIB "KERNEL32.DLL" ALIAS "RtlRunOnceBeginInitialize" ( _
   BYREF RTL_RUN_ONCE _                       ' __inout PRTL_RUN_ONCE RunOnce
 , BYVAL DWORD _                              ' __in DWORD Flags
 , BYREF ANY _                                ' __deref_opt_out_opt PVOID *Context
 ) AS DWORD                                   ' DWORD

DECLARE FUNCTION RtlRunOnceComplete LIB "KERNEL32.DLL" ALIAS "RtlRunOnceComplete" ( _
   BYREF RTL_RUN_ONCE _                       ' __inout PRTL_RUN_ONCE RunOnce
 , BYVAL DWORD _                              ' __in DWORD Flags
 , BYVAL DWORD _                              ' __in_opt PVOID Context
 ) AS DWORD                                   ' DWORD


%HEAP_NO_SERIALIZE             = &H00000001???
%HEAP_GROWABLE                 = &H00000002???
%HEAP_GENERATE_EXCEPTIONS      = &H00000004???
%HEAP_ZERO_MEMORY              = &H00000008???
%HEAP_REALLOC_IN_PLACE_ONLY    = &H00000010???
%HEAP_TAIL_CHECKING_ENABLED    = &H00000020???
%HEAP_FREE_CHECKING_ENABLED    = &H00000040???
%HEAP_DISABLE_COALESCE_ON_FREE = &H00000080???
%HEAP_CREATE_ALIGN_16          = &H00010000???
%HEAP_CREATE_ENABLE_TRACING    = &H00020000???
%HEAP_MAXIMUM_TAG              = &H00000FFF???
%HEAP_PSEUDO_TAG_FLAG          = &H00008000???
%HEAP_TAG_SHIFT                = 18???

'#if !defined(MIDL_PASS)
'FORCEINLINE
'DWORD
'HEAP_MAKE_TAG_FLAGS (
'    IN DWORD TagBase,
'    IN DWORD Tag
'    )

'{
'    __assume_bound(TagBase);
'    return ((DWORD)((TagBase) + ((Tag) << HEAP_TAG_SHIFT)));
'}
'#endif

'#define HEAP_MAKE_TAG_FLAGS( b, o ) ((DWORD)((b) + ((o) << 18)))

'FUNCTION HEAP_MAKE_TAG_FLAGS (BYVAL b AS DWORD, BYVAL o AS DWORD) AS DWORD
'   SHIFT LEFT o, 18
'   FUNCTION = b + o
'END FUNCTION

'#if (NTDDI_VERSION > NTDDI_WINXP)
DECLARE FUNCTION RtlCaptureStackBackTrace LIB "KERNEL32.DLL" ALIAS "RtlCaptureStackBackTrace" ( _
   BYVAL DWORD _                              ' __in DWORD FramesToSkip
 , BYVAL DWORD _                              ' __in DWORD FramesToCapture
 , BYREF ANY _                                ' __out_ecount(FramesToCapture) PVOID *BackTrace
 , BYREF DWORD _                              ' __out_opt PDWORD BackTraceHash
 ) AS WORD                                    ' WORD
'#endif

'#if (NTDDI_VERSION > NTDDI_WIN2K)
DECLARE SUB RtlCaptureContext LIB "KERNEL32.DLL" ALIAS "RtlCaptureContext" ( _
   BYREF CONTEXT _                          ' OUT PCONTEXT ContextRecord
 )                                          ' VOID
'#endif

%IS_TEXT_UNICODE_ASCII16            = &H0001???
%IS_TEXT_UNICODE_REVERSE_ASCII16    = &H0010???

%IS_TEXT_UNICODE_STATISTICS         = &H0002???
%IS_TEXT_UNICODE_REVERSE_STATISTICS = &H0020???

%IS_TEXT_UNICODE_CONTROLS           = &H0004???
%IS_TEXT_UNICODE_REVERSE_CONTROLS   = &H0040???

%IS_TEXT_UNICODE_SIGNATURE          = &H0008???
%IS_TEXT_UNICODE_REVERSE_SIGNATURE  = &H0080???

%IS_TEXT_UNICODE_ILLEGAL_CHARS      = &H0100???
%IS_TEXT_UNICODE_ODD_LENGTH         = &H0200???
%IS_TEXT_UNICODE_DBCS_LEADBYTE      = &H0400???
%IS_TEXT_UNICODE_NULL_BYTES         = &H1000???

%IS_TEXT_UNICODE_UNICODE_MASK       = &H000F???
%IS_TEXT_UNICODE_REVERSE_MASK       = &H00F0???
%IS_TEXT_UNICODE_NOT_UNICODE_MASK   = &H0F00???
%IS_TEXT_UNICODE_NOT_ASCII_MASK     = &HF000???

%COMPRESSION_FORMAT_NONE            = &H0000??
%COMPRESSION_FORMAT_DEFAULT         = &H0001??
%COMPRESSION_FORMAT_LZNT1           = &H0002??
%COMPRESSION_ENGINE_STANDARD        = &H0000??
%COMPRESSION_ENGINE_MAXIMUM         = &H0100??
%COMPRESSION_ENGINE_HIBER           = &H0200??

'#if _DBG_MEMCPY_INLINE_ && !defined(MIDL_PASS) && !defined(_MEMCPY_INLINE_) && !defined(_CRTBLD)
'#define _MEMCPY_INLINE_
'FORCEINLINE
'PVOID
'__cdecl
'memcpy_inline (
'    void *dst,
'    %void *src,
'    size_t size
'    )
'{
'    //
'    // Make sure the source and destination do not overlap such that the
'    // move destroys the destination.
'    //
'    if (((char *)dst > (char *)src) &&
'        ((char *)dst < ((char *)src + size))) {
'        __debugbreak();
'    }
'    return memcpy(dst, src, size);
'}
'#define memcpy memcpy_inline
'#endif

DECLARE FUNCTION RtlCompareMemory LIB "NTDLL.DLL" ALIAS "RtlCompareMemory" ( _
   BYREF ANY _                              ' const VOID *Source1
 , BYREF ANY _                              ' const VOID *Source2
 , BYVAL DWORD _                            ' SIZE_T Length
 ) AS DWORD                                 ' SIZE_T

'#define RtlEqualMemory(Destination,Source,Length) (!memcmp((Destination),(Source),(Length)))
'#define RtlMoveMemory(Destination,Source,Length) memmove((Destination),(Source),(Length))
'#define RtlCopyMemory(Destination,Source,Length) memcpy((Destination),(Source),(Length))
'#define RtlFillMemory(Destination,Length,Fill) memset((Destination),(Fill),(Length))
'#define RtlZeroMemory(Destination,Length) memset((Destination),0,(Length))

DECLARE SUB RtlMoveMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" ( _
   BYREF ANY _                              ' PVOID Destination
 , BYREF ANY _                              ' const VOID* Source
 , BYVAL LONG _                             ' SIZE_T Length
 )                                          ' void

DECLARE SUB MoveMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" ( _
   BYREF ANY _                              ' PVOID Destination
 , BYREF ANY _                              ' const VOID* Source
 , BYVAL LONG _                             ' SIZE_T Length
 )                                          ' void

' Parameters declared BYVAL for compatibility with PB's Win32Api.
' CopyMemory is an anomaly (it has BYVAL DWORD parameters instead of BYREF ANY)
' caused because is a wrapper for RtlMoveMemory when PB didn't allowed to
' have multiple declarations for the same alias. You can use RtlCopyMemory,
' RtlMoveMemory or MoveMemory instead of CopyMemory.
DECLARE SUB CopyMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" ( _
   BYVAL DWORD _                            ' PVOID Destination
 , BYVAL DWORD _                            ' const VOID* Source
 , BYVAL LONG _                             ' SIZE_T Length
 )                                          ' void

DECLARE SUB RtlCopyMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" ( _
   BYREF ANY _                              ' PVOID Destination
 , BYREF ANY _                              ' const VOID* Source
 , BYVAL LONG _                             ' SIZE_T Length
 )                                          ' void


'   SUB FillMemory (BYVAL pDestination AS DWORD, BYVAL cbLength AS LONG, BYVAL bFill AS BYTE)
'      LOCAL ix AS LONG
'      LOCAL pDest AS BYTE PTR
'      pDest = pDestination
'      FOR ix = 1 TO cbLength
'         @pDest = bFill
'         INCR pDest
'      NEXT
'   END SUB

'   SUB ZeroMemory (BYVAL pDestination AS DWORD, BYVAL cbLength AS LONG)
'      FillMemory pDestination, cbLength, 0
'   END SUB

' RtlFillMemory is not supported on Windows 98 or Windows Me.
DECLARE SUB RtlFillMemory LIB "KERNEL32.DLL" ALIAS "RtlFillMemory" ( _
   BYREF ANY _                              ' PVOID Destination
 , BYVAL DWORD _                            ' SIZE_T Length
 , BYVAL BYTE _                             ' BYTE Fill
 )                                          ' VOID

DECLARE SUB RtlZeroMemory LIB "KERNEL32.DLL" ALIAS "RtlZeroMemory" ( _
   BYREF ANY _                              ' PVOID Destination
 , BYVAL DWORD _                            ' SIZE_T Length
 )                                          ' VOID

%SEF_DACL_AUTO_INHERIT             = &H01???
%SEF_SACL_AUTO_INHERIT             = &H02???
%SEF_DEFAULT_DESCRIPTOR_FOR_OBJECT = &H04???
%SEF_AVOID_PRIVILEGE_CHECK         = &H08???
%SEF_AVOID_OWNER_CHECK             = &H10???
%SEF_DEFAULT_OWNER_FROM_PARENT     = &H20???
%SEF_DEFAULT_GROUP_FROM_PARENT     = &H40???
%SEF_MACL_NO_WRITE_UP              = &H100???
%SEF_MACL_NO_READ_UP               = &H200???
%SEF_MACL_NO_EXECUTE_UP            = &H400???
%SEF_AVOID_OWNER_RESTRICTION       = &H1000???

%SEF_MACL_VALID_FLAGS              = %SEF_MACL_NO_WRITE_UP   OR _
                                     %SEF_MACL_NO_READ_UP    OR _
                                     %SEF_MACL_NO_EXECUTE_UP

TYPE MESSAGE_RESOURCE_ENTRY
   Length  AS WORD   ' WORD
   Flags   AS WORD   ' WORD
   Text(0) AS BYTE   ' BYTE  Text[ 1 ]
END TYPE

%MESSAGE_RESOURCE_UNICODE = &H0001

TYPE MESSAGE_RESOURCE_BLOCK
   LowId           AS DWORD
   HighId          AS DWORD
   OffsetToEntries AS DWORD
END TYPE

TYPE MESSAGE_RESOURCE_DATA
   NumberOfBlocks AS DWORD               ' DWORD
   Blocks(0) AS MESSAGE_RESOURCE_BLOCK   ' MESSAGE_RESOURCE_BLOCK Blocks[ 1 ]
END TYPE

TYPE OSVERSIONINFOA
   dwOSVersionInfoSize AS DWORD
   dwMajorVersion      AS DWORD
   dwMinorVersion      AS DWORD
   dwBuildNumber       AS DWORD
   dwPlatformId        AS DWORD
   szCSDVersion        AS ASCIIZ * 128  ' CHAR   szCSDVersion[ 128 ];     // Maintenance string for PSS usage
END TYPE

TYPE OSVERSIONINFOW
   dwOSVersionInfoSize AS DWORD
   dwMajorVersion      AS DWORD
   dwMinorVersion      AS DWORD
   dwBuildNumber       AS DWORD
   dwPlatformId        AS DWORD
   szCSDVersion        AS STRING * 128 * 2  ' WCHAR  szCSDVersion[ 128 ];     // Maintenance string for PSS usage
END TYPE

MACRO OSVERSIONINFO = OSVERSIONINFOA

TYPE OSVERSIONINFOEXA
   dwOSVersionInfoSize AS DWORD
   dwMajorVersion      AS DWORD
   dwMinorVersion      AS DWORD
   dwBuildNumber       AS DWORD
   dwPlatformId        AS DWORD
   szCSDVersion        AS ASCIIZ * 128   ' CHAR   szCSDVersion[ 128 ];     // Maintenance string for PSS usage
   wServicePackMajor   AS WORD
   wServicePackMinor   AS WORD
   wSuiteMask          AS WORD
   wProductType        AS BYTE
   wReserved           AS BYTE
END TYPE

TYPE OSVERSIONINFOEXW
   dwOSVersionInfoSize AS DWORD
   dwMajorVersion      AS DWORD
   dwMinorVersion      AS DWORD
   dwBuildNumber       AS DWORD
   dwPlatformId        AS DWORD
   szCSDVersion        AS ASCIIZ * 128 * 2   ' WCHAR  szCSDVersion[ 128 ];     // Maintenance string for PSS usage
   wServicePackMajor   AS WORD
   wServicePackMinor   AS WORD
   wSuiteMask          AS WORD
   wProductType        AS BYTE
   wReserved           AS BYTE
END TYPE

MACRO OSVERSIONINFOEX = OSVERSIONINFOEXA

'//
'// RtlVerifyVersionInfo() conditions
'//

%VER_EQUAL                       = 1
%VER_GREATER                     = 2
%VER_GREATER_EQUAL               = 3
%VER_LESS                        = 4
%VER_LESS_EQUAL                  = 5
%VER_AND                         = 6
%VER_OR                          = 7

%VER_CONDITION_MASK              = 7
%VER_NUM_BITS_PER_CONDITION_MASK = 3

'//
'// RtlVerifyVersionInfo() type mask bits
'//

%VER_MINORVERSION                = &H0000001???
%VER_MAJORVERSION                = &H0000002???
%VER_BUILDNUMBER                 = &H0000004???
%VER_PLATFORMID                  = &H0000008???
%VER_SERVICEPACKMINOR            = &H0000010???
%VER_SERVICEPACKMAJOR            = &H0000020???
%VER_SUITENAME                   = &H0000040???
%VER_PRODUCT_TYPE                = &H0000080???

'//
'// RtlVerifyVersionInfo() os product type values
'//

%VER_NT_WORKSTATION              = &H0000001???
%VER_NT_DOMAIN_CONTROLLER        = &H0000002???
%VER_NT_SERVER                   = &H0000003???

'//
'// dwPlatformId defines:
'//

%VER_PLATFORM_WIN32s            = 0
%VER_PLATFORM_WIN32_WINDOWS     = 1
%VER_PLATFORM_WIN32_NT          = 2


'//
'//
'// VerifyVersionInfo() macro to set the condition mask
'//
'// For documentation sakes here's the old version of the macro that got
'// changed to call an API
'// #define VER_SET_CONDITION(_m_,_t_,_c_)  _m_=(_m_|(_c_<<(1<<_t_)))
'//

'#define VER_SET_CONDITION(_m_,_t_,_c_)  \
'        ((_m_)=VerSetConditionMask((_m_),(_t_),(_c_)))

'#if (NTDDI_VERSION >= NTDDI_WIN2K)
DECLARE FUNCTION VerSetConditionMask LIB "KERNEL32.DLL" ALIAS "VerSetConditionMask" ( _
   BYVAL QUAD _                        ' IN  ULONGLONG   ConditionMask
 , BYVAL DWORD _                       ' IN  DWORD   TypeMask
 , BYVAL BYTE _                        ' IN  BYTE    Condition
 ) AS QUAD                             ' ULONGLONG
'#endif

'#if (NTDDI_VERSION >= NTDDI_LONGHORN)
#IF %WINVER >= &H0600

DECLARE FUNCTION RtlGetProductInfo LIB "KERNEL32.DLL" ALIAS "RtlGetProductInfo" ( _
   BYVAL DWORD _                       ' __in  DWORD  OSMajorVersion
 , BYVAL DWORD _                       ' __in  DWORD  OSMinorVersion
 , BYVAL DWORD _                       ' __in  DWORD  SpMajorVersion
 , BYVAL DWORD _                       ' __in  DWORD  SpMinorVersion
 , BYREF DWORD _                       ' __out PDWORD ReturnedProductType
 ) AS BYTE                             ' BOOLEAN

#ENDIF

'typedef struct _RTL_CRITICAL_SECTION_DEBUG {
'    WORD   Type;
'    WORD   CreatorBackTraceIndex;
'    struct _RTL_CRITICAL_SECTION *CriticalSection;
'    LIST_ENTRY ProcessLocksList;
'    DWORD EntryCount;
'    DWORD ContentionCount;
'    DWORD Spare[ 2 ];
'} RTL_CRITICAL_SECTION_DEBUG, *PRTL_CRITICAL_SECTION_DEBUG, RTL_RESOURCE_DEBUG, *PRTL_RESOURCE_DEBUG;

TYPE RTL_CRITICAL_SECTION_DEBUG
   wType                 AS WORD
   CreatorBackTraceIndex AS WORD
   CriticalSection       AS RTL_CRITICAL_SECTION_DEBUG PTR
   ProcessLocksList      AS LIST_ENTRY
   EntryCount            AS DWORD
   ContentionCount       AS DWORD
   Spare(1)              AS DWORD
END TYPE

%RTL_CRITSECT_TYPE = 0
%RTL_RESOURCE_TYPE = 1

'//
'// These flags define the upper byte of the critical section SpinCount field
'//
%RTL_CRITICAL_SECTION_FLAG_NO_DEBUG_INFO         = &H01000000???
%RTL_CRITICAL_SECTION_FLAG_DYNAMIC_SPIN          = &H02000000???
%RTL_CRITICAL_SECTION_FLAG_STATIC_INIT           = &H04000000???
%RTL_CRITICAL_SECTION_ALL_FLAG_BITS              = &HFF000000???
%RTL_CRITICAL_SECTION_FLAG_RESERVED              = (%RTL_CRITICAL_SECTION_ALL_FLAG_BITS AND (NOT(%RTL_CRITICAL_SECTION_FLAG_NO_DEBUG_INFO OR %RTL_CRITICAL_SECTION_FLAG_DYNAMIC_SPIN OR %RTL_CRITICAL_SECTION_FLAG_STATIC_INIT)))

'//
'// These flags define possible values stored in the Flags field of a critsec debuginfo.
'//
%RTL_CRITICAL_SECTION_DEBUG_FLAG_STATIC_INIT     = &H00000001???

'#pragma pack(push, 8)

'typedef struct _RTL_CRITICAL_SECTION {
'    PRTL_CRITICAL_SECTION_DEBUG DebugInfo;

'    //
'    //  The following three fields control entering and exiting the critical
'    //  section for the resource
'    //

'    LONG LockCount;
'    LONG RecursionCount;
'    HANDLE OwningThread;        // from the thread's ClientId->UniqueThread
'    HANDLE LockSemaphore;
'    ULONG_PTR SpinCount;        // force size on 64-bit systems when packed
'} RTL_CRITICAL_SECTION, *PRTL_CRITICAL_SECTION;

TYPE RTL_CRITICAL_SECTION
   DebugInfo      AS RTL_CRITICAL_SECTION_DEBUG PTR
   LockCount      AS LONG
   RecursionCount AS LONG
   OwningThread   AS DWORD   ' // from the thread's ClientId->UniqueThread
   LockSemaphore  AS DWORD
   SpinCount      AS DWORD   ' // force size on 64-bit systems when packed
END TYPE

MACRO CRITICAL_SECTION = RTL_CRITICAL_SECTION

'#pragma pack(pop)

' Not in Vista SDK
'typedef VOID (NTAPI * RTL_VERIFIER_DLL_LOAD_CALLBACK) (
'    PWSTR DllName,
'    PVOID DllBase,
'    SIZE_T DllSize,
'    PVOID Reserved
'    );

' Not in Vista SDK
'typedef VOID (NTAPI * RTL_VERIFIER_DLL_UNLOAD_CALLBACK) (
'    PWSTR DllName,
'    PVOID DllBase,
'    SIZE_T DllSize,
'    PVOID Reserved
'    );

' Not in Vista SDK
'typedef VOID (NTAPI * RTL_VERIFIER_NTDLLHEAPFREE_CALLBACK) (
'    PVOID AllocationBase,
'    SIZE_T AllocationSize
'    );

' Not in Vista SDK
TYPE RTL_VERIFIER_THUNK_DESCRIPTOR
   ThunkName       AS BYTE PTR   ' PCHAR
   ThunkOldAddress AS DWORD      ' PVOID
   ThunkNewAddress AS DWORD      ' PVOID
END TYPE

' Not in Vista SDK
TYPE RTL_VERIFIER_DLL_DESCRIPTOR
   DllName    AS WORD PTR   ' PWCHAR
   DllFlags   AS DWORD      ' DWORD
   DllAddress AS DWORD      ' PVOID
   DllThunks  AS RTL_VERIFIER_THUNK_DESCRIPTOR PTR   ' PRTL_VERIFIER_THUNK_DESCRIPTOR
END TYPE

'typedef struct _RTL_VERIFIER_PROVIDER_DESCRIPTOR {

'    //
'    // Filled by verifier provider DLL
'    //

'    DWORD Length;
'    PRTL_VERIFIER_DLL_DESCRIPTOR ProviderDlls;
'    RTL_VERIFIER_DLL_LOAD_CALLBACK ProviderDllLoadCallback;
'    RTL_VERIFIER_DLL_UNLOAD_CALLBACK ProviderDllUnloadCallback;

'    //
'    // Filled by verifier engine
'    //

'    PWSTR VerifierImage;
'    DWORD VerifierFlags;
'    DWORD VerifierDebug;

'    PVOID RtlpGetStackTraceAddress;
'    PVOID RtlpDebugPageHeapCreate;
'    PVOID RtlpDebugPageHeapDestroy;

'    //
'    // Filled by verifier provider DLL
'    //

'    RTL_VERIFIER_NTDLLHEAPFREE_CALLBACK ProviderNtdllHeapFreeCallback;

'} RTL_VERIFIER_PROVIDER_DESCRIPTOR, *PRTL_VERIFIER_PROVIDER_DESCRIPTOR;

' Not in Vista SDK
TYPE RTL_VERIFIER_PROVIDER_DESCRIPTOR
   Length                        AS DWORD
   ProviderDlls                  AS RTL_VERIFIER_DLL_DESCRIPTOR PTR
   ProviderDllLoadCallback       AS DWORD
   ProviderDllUnloadCallback     AS DWORD
   VerifierImage                 AS DWORD
   VerifierFlags                 AS DWORD
   VerifierDebug                 AS DWORD
   RtlpGetStackTraceAddress      AS DWORD
   RtlpDebugPageHeapCreate       AS DWORD
   RtlpDebugPageHeapDestroy      AS DWORD
   ProviderNtdllHeapFreeCallback AS DWORD
END TYPE

'//
'// Application verifier standard flags
'//
' Not in Vista SDK

%RTL_VRF_FLG_FULL_PAGE_HEAP                   = &H00000001???
%RTL_VRF_FLG_RESERVED_DONOTUSE                = &H00000002??? ' // old RTL_VRF_FLG_LOCK_CHECKS
%RTL_VRF_FLG_HANDLE_CHECKS                    = &H00000004???
%RTL_VRF_FLG_STACK_CHECKS                     = &H00000008???
%RTL_VRF_FLG_APPCOMPAT_CHECKS                 = &H00000010???
%RTL_VRF_FLG_TLS_CHECKS                       = &H00000020???
%RTL_VRF_FLG_DIRTY_STACKS                     = &H00000040???
%RTL_VRF_FLG_RPC_CHECKS                       = &H00000080???
%RTL_VRF_FLG_COM_CHECKS                       = &H00000100???
%RTL_VRF_FLG_DANGEROUS_APIS                   = &H00000200???
%RTL_VRF_FLG_RACE_CHECKS                      = &H00000400???
%RTL_VRF_FLG_DEADLOCK_CHECKS                  = &H00000800???
%RTL_VRF_FLG_FIRST_CHANCE_EXCEPTION_CHECKS    = &H00001000???
%RTL_VRF_FLG_VIRTUAL_MEM_CHECKS               = &H00002000???
%RTL_VRF_FLG_ENABLE_LOGGING                   = &H00004000???
%RTL_VRF_FLG_FAST_FILL_HEAP                   = &H00008000???
%RTL_VRF_FLG_VIRTUAL_SPACE_TRACKING           = &H00010000???
%RTL_VRF_FLG_ENABLED_SYSTEM_WIDE              = &H00020000???
%RTL_VRF_FLG_MISCELLANEOUS_CHECKS             = &H00020000???
%RTL_VRF_FLG_LOCK_CHECKS                      = &H00040000???

'//
'// Application verifier standard stop codes
'//
' Not in Vista SDK

%APPLICATION_VERIFIER_INTERNAL_ERROR               = &H80000000???
%APPLICATION_VERIFIER_INTERNAL_WARNING             = &H40000000???
%APPLICATION_VERIFIER_NO_BREAK                     = &H20000000???
%APPLICATION_VERIFIER_CONTINUABLE_BREAK            = &H10000000???

%APPLICATION_VERIFIER_UNKNOWN_ERROR                    = &H0001???
%APPLICATION_VERIFIER_ACCESS_VIOLATION                 = &H0002???
%APPLICATION_VERIFIER_UNSYNCHRONIZED_ACCESS            = &H0003???
%APPLICATION_VERIFIER_EXTREME_SIZE_REQUEST             = &H0004???
%APPLICATION_VERIFIER_BAD_HEAP_HANDLE                  = &H0005???
%APPLICATION_VERIFIER_SWITCHED_HEAP_HANDLE             = &H0006???
%APPLICATION_VERIFIER_DOUBLE_FREE                      = &H0007???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK             = &H0008???
%APPLICATION_VERIFIER_DESTROY_PROCESS_HEAP             = &H0009???
%APPLICATION_VERIFIER_UNEXPECTED_EXCEPTION             = &H000A???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK_EXCEPTION_RAISED_FOR_HEADER = &H000B???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK_EXCEPTION_RAISED_FOR_PROBING = &H000C???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK_HEADER      = &H000D???
%APPLICATION_VERIFIER_CORRUPTED_FREED_HEAP_BLOCK       = &H000E???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK_SUFFIX      = &H000F???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK_START_STAMP = &H0010???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK_END_STAMP   = &H0011???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_BLOCK_PREFIX      = &H0012???
%APPLICATION_VERIFIER_FIRST_CHANCE_ACCESS_VIOLATION    = &H0013???
%APPLICATION_VERIFIER_CORRUPTED_HEAP_LIST              = &H0014???

%APPLICATION_VERIFIER_TERMINATE_THREAD_CALL        = &H0100???
%APPLICATION_VERIFIER_STACK_OVERFLOW               = &H0101???
%APPLICATION_VERIFIER_INVALID_EXIT_PROCESS_CALL    = &H0102???

%APPLICATION_VERIFIER_EXIT_THREAD_OWNS_LOCK        = &H0200???
%APPLICATION_VERIFIER_LOCK_IN_UNLOADED_DLL         = &H0201???
%APPLICATION_VERIFIER_LOCK_IN_FREED_HEAP           = &H0202???
%APPLICATION_VERIFIER_LOCK_DOUBLE_INITIALIZE       = &H0203???
%APPLICATION_VERIFIER_LOCK_IN_FREED_MEMORY         = &H0204???
%APPLICATION_VERIFIER_LOCK_CORRUPTED               = &H0205???
%APPLICATION_VERIFIER_LOCK_INVALID_OWNER           = &H0206???
%APPLICATION_VERIFIER_LOCK_INVALID_RECURSION_COUNT = &H0207???
%APPLICATION_VERIFIER_LOCK_INVALID_LOCK_COUNT      = &H0208???
%APPLICATION_VERIFIER_LOCK_OVER_RELEASED           = &H0209???
%APPLICATION_VERIFIER_LOCK_NOT_INITIALIZED         = &H0210???
%APPLICATION_VERIFIER_LOCK_ALREADY_INITIALIZED     = &H0211???
%APPLICATION_VERIFIER_LOCK_IN_FREED_VMEM           = &H0212???
%APPLICATION_VERIFIER_LOCK_IN_UNMAPPED_MEM         = &H0213???
%APPLICATION_VERIFIER_THREAD_NOT_LOCK_OWNER        = &H0214???

%APPLICATION_VERIFIER_INVALID_HANDLE               = &H0300???
%APPLICATION_VERIFIER_INVALID_TLS_VALUE            = &H0301???
%APPLICATION_VERIFIER_INCORRECT_WAIT_CALL          = &H0302???
%APPLICATION_VERIFIER_NULL_HANDLE                  = &H0303???
%APPLICATION_VERIFIER_WAIT_IN_DLLMAIN              = &H0304???

%APPLICATION_VERIFIER_COM_ERROR                    = &H0400???
%APPLICATION_VERIFIER_COM_API_IN_DLLMAIN           = &H0401???
%APPLICATION_VERIFIER_COM_UNHANDLED_EXCEPTION      = &H0402???
%APPLICATION_VERIFIER_COM_UNBALANCED_COINIT        = &H0403???
%APPLICATION_VERIFIER_COM_UNBALANCED_OLEINIT       = &H0404???
%APPLICATION_VERIFIER_COM_UNBALANCED_SWC           = &H0405???
%APPLICATION_VERIFIER_COM_NULL_DACL                = &H0406???
%APPLICATION_VERIFIER_COM_UNSAFE_IMPERSONATION     = &H0407???
%APPLICATION_VERIFIER_COM_SMUGGLED_WRAPPER         = &H0408???
%APPLICATION_VERIFIER_COM_SMUGGLED_PROXY           = &H0409???
%APPLICATION_VERIFIER_COM_CF_SUCCESS_WITH_NULL     = &H040A???
%APPLICATION_VERIFIER_COM_GCO_SUCCESS_WITH_NULL    = &H040B???
%APPLICATION_VERIFIER_COM_OBJECT_IN_FREED_MEMORY   = &H040C???
%APPLICATION_VERIFIER_COM_OBJECT_IN_UNLOADED_DLL   = &H040D???
%APPLICATION_VERIFIER_COM_VTBL_IN_FREED_MEMORY     = &H040E???
%APPLICATION_VERIFIER_COM_VTBL_IN_UNLOADED_DLL     = &H040F???
%APPLICATION_VERIFIER_COM_HOLDING_LOCKS_ON_CALL    = &H0410???

%APPLICATION_VERIFIER_RPC_ERROR                    = &H0500???

%APPLICATION_VERIFIER_INVALID_FREEMEM              = &H0600???
%APPLICATION_VERIFIER_INVALID_ALLOCMEM             = &H0601???
%APPLICATION_VERIFIER_INVALID_MAPVIEW              = &H0602???
%APPLICATION_VERIFIER_PROBE_INVALID_ADDRESS        = &H0603???
%APPLICATION_VERIFIER_PROBE_FREE_MEM               = &H0604???
%APPLICATION_VERIFIER_PROBE_GUARD_PAGE             = &H0605???
%APPLICATION_VERIFIER_PROBE_NULL                   = &H0606???
%APPLICATION_VERIFIER_PROBE_INVALID_START_OR_SIZE  = &H0607???
%APPLICATION_VERIFIER_SIZE_HEAP_UNEXPECTED_EXCEPTION = &H0618???


'#define VERIFIER_STOP(Code, Msg, P1, S1, P2, S2, P3, S3, P4, S4) {  \
'        RtlApplicationVerifierStop ((Code),                         \
'                                    (Msg),                          \
'                                    (ULONG_PTR)(P1),(S1),           \
'                                    (ULONG_PTR)(P2),(S2),           \
'                                    (ULONG_PTR)(P3),(S3),           \
'                                    (ULONG_PTR)(P4),(S4));          \
'  }

' Not in Vista SDK
DECLARE SUB RtlApplicationVerifierStop LIB "NTDLL.DLL" ALIAS "RtlApplicationVerifierStop" ( _
   BYVAL DWORD _                            ' __in ULONG_PTR Code
 , BYVAL DWORD _                            ' __in PSTR Message
 , BYVAL DWORD _                            ' __in ULONG_PTR Param1
 , BYVAL DWORD _                            ' __in PSTR Description1
 , BYVAL DWORD _                            ' __in ULONG_PTR Param2
 , BYVAL DWORD _                            ' __in PSTR Description2
 , BYVAL DWORD _                            ' __in ULONG_PTR Param3
 , BYVAL DWORD _                            ' __in PSTR Description3
 , BYVAL DWORD _                            ' __in ULONG_PTR Param4
 , BYVAL DWORD _                            ' __in PSTR Description4
 )                                          ' void

'typedef LONG (NTAPI *PVECTORED_EXCEPTION_HANDLER)(
'    struct _EXCEPTION_POINTERS *ExceptionInfo
'    );

TYPE RTL_SRWLOCK
   Ptr AS DWORD   ' PVOID
END TYPE
%RTL_SRWLOCK_INIT = 0

TYPE RTL_CONDITION_VARIABLE
   Ptr AS DWORD   ' PVOID
END TYPE
%RTL_CONDITION_VARIABLE_INIT = 0
%RTL_CONDITION_VARIABLE_LOCKMODE_SHARED = &H1

'typedef LONG (NTAPI *PVECTORED_EXCEPTION_HANDLER)(
'    struct _EXCEPTION_POINTERS *ExceptionInfo
'    );

' HEAP_INFORMATION_CLASS enum
%HeapCompatibilityInformation      = 0
%HeapEnableTerminationOnCorruption = 1

' Not in Vista SDK
DECLARE FUNCTION RtlSetHeapInformation LIB "NTDLL.DLL" ALIAS "RtlSetHeapInformation" ( _
   BYVAL DWORD _                            ' IN PVOID HeapHandle
 , BYVAL DWORD _                            ' IN HEAP_INFORMATION_CLASS HeapInformationClass
 , BYVAL DWORD _                            ' IN PVOID HeapInformation OPTIONAL
 , BYVAL DWORD _                            ' IN SIZE_T HeapInformationLength OPTIONAL
 ) AS DWORD                                 ' DWORD

' Not in Vista SDK
DECLARE FUNCTION RtlQueryHeapInformation LIB "NTDLL.DLL" ALIAS "RtlQueryHeapInformation" ( _
   BYVAL DWORD _                            ' IN PVOID HeapHandle
 , BYVAL DWORD _                            ' IN HEAP_INFORMATION_CLASS HeapInformationClass
 , BYREF ANY _                              ' OUT PVOID HeapInformation OPTIONAL
 , BYVAL DWORD _                            ' IN SIZE_T HeapInformationLength OPTIONAL
 , BYREF DWORD _                            ' OUT PSIZE_T ReturnLength OPTIONAL
 ) AS DWORD                                 ' DWORD

'//
'//  Multiple alloc-free APIS
'//
' Not in Vista SDK

'DWORD
'NTAPI
'RtlMultipleAllocateHeap (
'    IN PVOID HeapHandle,
'    IN DWORD Flags,
'    IN SIZE_T Size,
'    IN DWORD Count,
'    OUT PVOID * Array
'    );

'DWORD
'NTAPI
'RtlMultipleFreeHeap (
'    IN PVOID HeapHandle,
'    IN DWORD Flags,
'    IN DWORD Count,
'    OUT PVOID * Array
'    );

%WT_EXECUTEDEFAULT              = &H00000000???
%WT_EXECUTEINIOTHREAD           = &H00000001???
%WT_EXECUTEINUITHREAD           = &H00000002???
%WT_EXECUTEINWAITTHREAD         = &H00000004???
%WT_EXECUTEONLYONCE             = &H00000008???
%WT_EXECUTEINTIMERTHREAD        = &H00000020???
%WT_EXECUTELONGFUNCTION         = &H00000010???
%WT_EXECUTEINPERSISTENTIOTHREAD = &H00000040???
%WT_EXECUTEINPERSISTENTTHREAD   = &H00000080???
%WT_TRANSFER_IMPERSONATION      = &H00000100???

'#define WT_SET_MAX_THREADPOOL_THREADS(Flags, Limit)  ((Flags) |= (Limit)<<16)
'FUNCTION WT_SET_MAX_THREADPOOL_THREADS (BYVAL Flags AS DWORD, BYVAL Limit AS DWORD) AS DWORD
'   SHIFT LEFT Limit, 16
'   FUNCTION = Flags OR Limit
'END FUNCTION

'typedef VOID (NTAPI * WAITORTIMERCALLBACKFUNC) (PVOID, BOOLEAN );
'typedef VOID (NTAPI * WORKERCALLBACKFUNC) (PVOID );
'typedef VOID (NTAPI * APC_CALLBACK_FUNCTION) (DWORD   , PVOID, PVOID);
'typedef
'VOID
'(NTAPI *PFLS_CALLBACK_FUNCTION) (
'    IN PVOID lpFlsData
'    );

%WT_EXECUTEINLONGTHREAD         = &H00000010???
%WT_EXECUTEDELETEWAIT           = &H00000008???

'ACTIVATION_CONTEXT_INFO_CLASS enum
%ActivationContextBasicInformation                       = 1
%ActivationContextDetailedInformation                    = 2
%AssemblyDetailedInformationInActivationContext          = 3
%FileInformationInAssemblyOfAssemblyInActivationContext  = 4
%RunlevelInformationInActivationContext                  = 5
%MaxActivationContextInfoClass                           = 6

'//
'// compatibility with old names
'//
%AssemblyDetailedInformationInActivationContxt           = 3
%FileInformationInAssemblyOfAssemblyInActivationContxt   = 4

'#define ACTIVATIONCONTEXTINFOCLASS ACTIVATION_CONTEXT_INFO_CLASS

TYPE ACTIVATION_CONTEXT_QUERY_INDEX
   ulAssemblyIndex       AS DWORD
   ulFileIndexInAssembly AS DWORD
END TYPE

%ACTIVATION_CONTEXT_PATH_TYPE_NONE        = 1
%ACTIVATION_CONTEXT_PATH_TYPE_WIN32_FILE  = 2
%ACTIVATION_CONTEXT_PATH_TYPE_URL         = 3
%ACTIVATION_CONTEXT_PATH_TYPE_ASSEMBLYREF = 4

TYPE ASSEMBLY_FILE_DETAILED_INFORMATION
   ulFlags          AS DWORD      ' DWORD
   ulFilenameLength AS DWORD      ' DWORD
   ulPathLength     AS DWORD      ' DWORD
   lpFileName       AS WORD PTR   ' PCWSTR
   lpFilePath       AS WORD PTR   ' PCWSTR
END TYPE

'//
'// compatibility with old names
'// The new names use "file" consistently.
'//
'#define  _ASSEMBLY_DLL_REDIRECTION_DETAILED_INFORMATION  _ASSEMBLY_FILE_DETAILED_INFORMATION
'#define   ASSEMBLY_DLL_REDIRECTION_DETAILED_INFORMATION   ASSEMBLY_FILE_DETAILED_INFORMATION
'#define  PASSEMBLY_DLL_REDIRECTION_DETAILED_INFORMATION  PASSEMBLY_FILE_DETAILED_INFORMATION
'#define PCASSEMBLY_DLL_REDIRECTION_DETAILED_INFORMATION PCASSEMBLY_FILE_DETAILED_INFORMATION

'typedef struct _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION {
'    DWORD ulFlags;
'    DWORD ulEncodedAssemblyIdentityLength;      // in bytes
'    DWORD ulManifestPathType;                   // ACTIVATION_CONTEXT_PATH_TYPE_*
'    DWORD ulManifestPathLength;                 // in bytes
'    LARGE_INTEGER liManifestLastWriteTime;      // FILETIME
'    DWORD ulPolicyPathType;                     // ACTIVATION_CONTEXT_PATH_TYPE_*
'    DWORD ulPolicyPathLength;                   // in bytes
'    LARGE_INTEGER liPolicyLastWriteTime;        // FILETIME
'    DWORD ulMetadataSatelliteRosterIndex;

'    DWORD ulManifestVersionMajor;               // 1
'    DWORD ulManifestVersionMinor;               // 0
'    DWORD ulPolicyVersionMajor;                 // 0
'    DWORD ulPolicyVersionMinor;                 // 0
'    DWORD ulAssemblyDirectoryNameLength;        // in bytes

'    PCWSTR lpAssemblyEncodedAssemblyIdentity;
'    PCWSTR lpAssemblyManifestPath;
'    PCWSTR lpAssemblyPolicyPath;
'    PCWSTR lpAssemblyDirectoryName;

'    DWORD  ulFileCount;
'} ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION, * PACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION;

'typedef %struct _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION * PCACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION ;

TYPE ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION
   ulFlags                           AS DWORD
   ulEncodedAssemblyIdentityLength   AS DWORD    ' // in bytes
   ulManifestPathType                AS DWORD    ' // ACTIVATION_CONTEXT_PATH_TYPE_*
   ulManifestPathLength              AS DWORD    ' // in bytes
   liManifestLastWriteTime           AS FILETIME ' // FILETIME
   ulPolicyPathType                  AS DWORD    ' // ACTIVATION_CONTEXT_PATH_TYPE_*
   ulPolicyPathLength                AS DWORD    ' // in bytes
   liPolicyLastWriteTime             AS FILETIME ' // FILETIME
   ulMetadataSatelliteRosterIndex    AS DWORD
   ulManifestVersionMajor            AS DWORD    ' // 1
   ulManifestVersionMinor            AS DWORD    ' // 0
   ulPolicyVersionMajor              AS DWORD    ' // 0
   ulPolicyVersionMinor              AS DWORD    ' // 0
   ulAssemblyDirectoryNameLength     AS DWORD    ' // in bytes
   lpAssemblyEncodedAssemblyIdentity AS DWORD
   lpAssemblyManifestPath            AS DWORD
   lpAssemblyPolicyPath              AS DWORD
   lpAssemblyDirectoryName           AS DWORD
   ulFileCount                       AS DWORD
END TYPE

' enum ACTCTX_REQUESTED_RUN_LEVEL
%ACTCTX_RUN_LEVEL_UNSPECIFIED       = 0
%ACTCTX_RUN_LEVEL_AS_INVOKER        = 1
%ACTCTX_RUN_LEVEL_HIGHEST_AVAILABLE = 2
%ACTCTX_RUN_LEVEL_REQUIRE_ADMIN     = 3
%ACTCTX_RUN_LEVEL_NUMBERS           = 4

TYPE ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION
   ulFlags  AS DWORD   ' DWORD
   RunLevel AS DWORD   ' ACTCTX_REQUESTED_RUN_LEVEL
   UiAccess AS DWORD   ' DWORD
END TYPE

TYPE ACTIVATION_CONTEXT_DETAILED_INFORMATION
   dwFlags                      AS DWORD      ' DWORD
   ulFormatVersion              AS DWORD      ' DWORD
   ulAssemblyCount              AS DWORD      ' DWORD
   ulRootManifestPathType       AS DWORD      ' DWORD
   ulRootManifestPathChars      AS DWORD      ' DWORD
   ulRootConfigurationPathType  AS DWORD      ' DWORD
   ulRootConfigurationPathChars AS DWORD      ' DWORD
   ulAppDirPathType             AS DWORD      ' DWORD
   ulAppDirPathChars            AS DWORD      ' DWORD
   lpRootManifestPath           AS WORD PTR   ' PCWSTR
   lpRootConfigurationPath      AS WORD PTR   ' PCWSTR
   lpAppDirPath                 AS WORD PTR   ' PCWSTR
END TYPE

%DLL_PROCESS_ATTACH   = 1
%DLL_THREAD_ATTACH    = 2
%DLL_THREAD_DETACH    = 3
%DLL_PROCESS_DETACH   = 0
%DLL_PROCESS_VERIFIER = 4

'//
'// Defines for the READ flags for Eventlogging
'//
%EVENTLOG_SEQUENTIAL_READ = &H0001???
%EVENTLOG_SEEK_READ       = &H0002???
%EVENTLOG_FORWARDS_READ   = &H0004???
%EVENTLOG_BACKWARDS_READ  = &H0008???

'//
'// The types of events that can be logged.
'//
%EVENTLOG_SUCCESS               = &H0000???
%EVENTLOG_ERROR_TYPE            = &H0001???
%EVENTLOG_WARNING_TYPE          = &H0002???
%EVENTLOG_INFORMATION_TYPE      = &H0004???
%EVENTLOG_AUDIT_SUCCESS         = &H0008???
%EVENTLOG_AUDIT_FAILURE         = &H0010???

'//
'// Defines for the WRITE flags used by Auditing for paired events
'// These are not implemented in Product 1
'//

%EVENTLOG_START_PAIRED_EVENT    = &H0001???
%EVENTLOG_END_PAIRED_EVENT      = &H0002???
%EVENTLOG_END_ALL_PAIRED_EVENTS = &H0004???
%EVENTLOG_PAIRED_EVENT_ACTIVE   = &H0008???
%EVENTLOG_PAIRED_EVENT_INACTIVE = &H0010???

'//
'// Structure that defines the header of the Eventlog record. This is the
'// fixed-sized portion before all the variable-length strings, binary
'// data and pad bytes.
'//
'// TimeGenerated is the time it was generated at the client.
'// TimeWritten is the time it was put into the log at the server end.
'//

'typedef struct _EVENTLOGRECORD {
'    DWORD  Length;        // Length of full record
'    DWORD  Reserved;      // Used by the service
'    DWORD  RecordNumber;  // Absolute record number
'    DWORD  TimeGenerated; // Seconds since 1-1-1970
'    DWORD  TimeWritten;   // Seconds since 1-1-1970
'    DWORD  EventID;
'    WORD   EventType;
'    WORD   NumStrings;
'    WORD   EventCategory;
'    WORD   ReservedFlags; // For use with paired events (auditing)
'    DWORD  ClosingRecordNumber; // For use with paired events (auditing)
'    DWORD  StringOffset;  // Offset from beginning of record
'    DWORD  UserSidLength;
'    DWORD  UserSidOffset;
'    DWORD  DataLength;
'    DWORD  DataOffset;    // Offset from beginning of record
'    //
'    // Then follow:
'    //
'    // WCHAR SourceName[]
'    // WCHAR Computername[]
'    // SID   UserSid
'    // WCHAR Strings[]
'    // BYTE  Data[]
'    // CHAR  Pad[]
'    // DWORD Length;
'    //
'} EVENTLOGRECORD, *PEVENTLOGRECORD;

TYPE EVENTLOGRECORD
   Length              AS DWORD   ' Length of full record
   Reserved            AS DWORD   ' Used by the service
   RecordNumber        AS DWORD   ' Absolute record number
   TimeGenerated       AS DWORD   ' Seconds since 1-1-1970
   TimeWritten         AS DWORD   ' Seconds since 1-1-1970
   EventID             AS DWORD
   EventType           AS WORD
   NumStrings          AS WORD
   EventCategory       AS WORD
   ReservedFlags       AS WORD    ' For use with paired events (auditing)
   ClosingRecordNumber AS DWORD   ' For use with paired events (auditing)
   StringOffset        AS DWORD   ' Offset from beginning of record
   UserSidLength       AS DWORD
   UserSidOffset       AS DWORD
   DataLength          AS DWORD
   DataOffset          AS DWORD   ' Offset from beginning of record
   '
   ' Then follow:
   '
   ' WCHAR SourceName[]
   ' WCHAR Computername[]
   ' SID   UserSid
   ' WCHAR Strings[]
   ' BYTE  Data[]
   ' CHAR  Pad[]
   ' DWORD Length;
END TYPE

'//SS: start of changes to support clustering
'//SS: ideally the
%MAXLOGICALLOGNAMESIZE = 256

'#if _MSC_VER >= 1200
'#pragma warning(push)
'#endif
'#pragma warning(disable : 4200)
'typedef struct _EVENTSFORLOGFILE{
'    DWORD         ulSize;
'    WCHAR         szLogicalLogFile[MAXLOGICALLOGNAMESIZE];        //name of the logical file-security/application/system
'    DWORD         ulNumRecords;
'   EVENTLOGRECORD    pEventLogRecords[];
'}EVENTSFORLOGFILE, *PEVENTSFORLOGFILE;

TYPE EVENTSFORLOGFILE
   ulSize AS DWORD
   szLogicalLogFile (%MAXLOGICALLOGNAMESIZE - 1) AS DWORD  ' //name of the logical file-security/application/system
   ulNumRecords        AS DWORD
   pEventLogRecords(0) AS EVENTLOGRECORD
END TYPE

'typedef struct _PACKEDEVENTINFO{
'    DWORD               ulSize;  //total size of the structure
'    DWORD               ulNumEventsForLogFile; //number of EventsForLogFile structure that follow
'    DWORD             ulOffsets[];           //the offsets from the start of this structure to the EVENTSFORLOGFILE structure
'}PACKEDEVENTINFO, *PPACKEDEVENTINFO;

TYPE PACKEDEVENTINFO
   ulSize                AS DWORD   ' //total size of the structure
   ulNumEventsForLogFile AS DWORD   ' //number of EventsForLogFile structure that follow
   ulOffsets(0)          AS DWORD   ' //the offsets from the start of this structure to the EVENTSFORLOGFILE structure
END TYPE

'#if _MSC_VER >= 1200
'#pragma warning(pop)
'#else
'#pragma warning(default : 4200)
'#endif
'//SS: end of changes to support clustering
'//

'//
'// Registry Specific Access Rights.
'//

%KEY_QUERY_VALUE         = &H0001???
%KEY_SET_VALUE           = &H0002???
%KEY_CREATE_SUB_KEY      = &H0004???
%KEY_ENUMERATE_SUB_KEYS  = &H0008???
%KEY_NOTIFY              = &H0010???
%KEY_CREATE_LINK         = &H0020???
%KEY_WOW64_32KEY         = &H0200???
%KEY_WOW64_64KEY         = &H0100???
%KEY_WOW64_RES           = &H0300???

%KEY_READ               = %STANDARD_RIGHTS_READ OR %KEY_QUERY_VALUE OR %KEY_ENUMERATE_SUB_KEYS OR %KEY_NOTIFY AND (NOT %SYNCHRONIZE)
%KEY_WRITE              = %STANDARD_RIGHTS_WRITE OR %KEY_SET_VALUE OR %KEY_CREATE_SUB_KEY AND (NOT %SYNCHRONIZE)
%KEY_EXECUTE            = %KEY_READ
%KEY_ALL_ACCESS         = %STANDARD_RIGHTS_ALL OR %KEY_QUERY_VALUE OR %KEY_SET_VALUE OR %KEY_CREATE_SUB_KEY OR %KEY_ENUMERATE_SUB_KEYS OR %KEY_NOTIFY OR %KEY_CREATE_LINK AND (NOT %SYNCHRONIZE)

'//
'// Open/Create Options
'//

%REG_OPTION_RESERVED             = &H00000000???     ' Parameter is reserved
%REG_OPTION_NON_VOLATILE         = &H00000000???     ' Key is preserved when system is rebooted
%REG_OPTION_VOLATILE             = &H00000001???     ' Key is not preserved when system is rebooted
%REG_OPTION_CREATE_LINK          = &H00000002???     ' Created key is a symbolic link
%REG_OPTION_BACKUP_RESTORE       = &H00000004???     ' open for backup or restore
%REG_OPTION_OPEN_LINK            = &H00000008???     ' Open symbolic link

%REG_LEGAL_OPTION                = %REG_OPTION_RESERVED OR %REG_OPTION_NON_VOLATILE OR %REG_OPTION_VOLATILE OR %REG_OPTION_CREATE_LINK OR %REG_OPTION_BACKUP_RESTORE OR %REG_OPTION_OPEN_LINK


'//
'// Key creation/open disposition
'//

%REG_CREATED_NEW_KEY          = &H00000001???     ' New Registry Key created
%REG_OPENED_EXISTING_KEY      = &H00000002???     ' Existing Key opened

'//
'// hive format to be used by Reg(Nt)SaveKeyEx
'//
%REG_STANDARD_FORMAT    = 1
%REG_LATEST_FORMAT      = 2
%REG_NO_COMPRESSION     = 4

'//
'// Key restore flags
'//

%REG_WHOLE_HIVE_VOLATILE      = &H00000001???   ' // Restore whole hive volatile
%REG_REFRESH_HIVE             = &H00000002???   ' // Unwind changes to last flush
%REG_NO_LAZY_FLUSH            = &H00000004???   ' // Never lazy flush this hive
%REG_FORCE_RESTORE            = &H00000008???   ' // Force the restore process even when we have open handles on subkeys
%REG_APP_HIVE                 = &H00000010???   ' // Loads the hive visible to the calling process
%REG_PROCESS_PRIVATE          = &H00000020???   ' // Hive cannot be mounted by any other process while in use
%REG_START_JOURNAL            = &H00000040???   ' // Starts Hive Journal
%REG_HIVE_EXACT_FILE_GROWTH   = &H00000080???   ' // Grow hive file in exact 4k increments
%REG_HIVE_NO_RM               = &H00000100???   ' // No RM is started for this hive (no transactions)
%REG_HIVE_SINGLE_LOG          = &H00000200???   ' // Legacy single logging is used for this hive

'//
'// Unload Flags
'//
%REG_FORCE_UNLOAD             = 1

'//
'// Notify filter values
'//
%REG_NOTIFY_CHANGE_NAME          = &H00000001???     ' Create or delete (child)
%REG_NOTIFY_CHANGE_ATTRIBUTES    = &H00000002???
%REG_NOTIFY_CHANGE_LAST_SET      = &H00000004???     ' Time stamp
%REG_NOTIFY_CHANGE_SECURITY      = &H00000008???

%REG_LEGAL_CHANGE_FILTER         = %REG_NOTIFY_CHANGE_NAME OR %REG_NOTIFY_CHANGE_ATTRIBUTES OR %REG_NOTIFY_CHANGE_LAST_SET OR %REG_NOTIFY_CHANGE_SECURITY

'//
'//
'// Predefined Value Types.
'//

%REG_NONE                        = 0     ' No value type
%REG_SZ                          = 1     ' Unicode nul terminated string
%REG_EXPAND_SZ                   = 2     ' Unicode nul terminated string
%REG_BINARY                      = 3     ' Free form binary
%REG_DWORD                       = 4     ' 32-bit number
%REG_DWORD_LITTLE_ENDIAN         = 4     ' 32-bit number (same as MACRO REG_DWORD)
%REG_DWORD_BIG_ENDIAN            = 5     ' 32-bit number
%REG_LINK                        = 6     ' Symbolic Link (unicode)
%REG_MULTI_SZ                    = 7     ' Multiple Unicode strings
%REG_RESOURCE_LIST               = 8     ' Resource list in the resource map
%REG_FULL_RESOURCE_DESCRIPTOR    = 9     ' Resource list in the hardware description
%REG_RESOURCE_REQUIREMENTS_LIST  = 10
%REG_QWORD                       = 11    ' 64-bit number
%REG_QWORD_LITTLE_ENDIAN         = 11    ' 64-bit number (same as MACRO REG_QWORD)

'//
'// Service Types (Bit Mask)
'//
%SERVICE_KERNEL_DRIVER        = &H00000001???
%SERVICE_FILE_SYSTEM_DRIVER   = &H00000002???
%SERVICE_ADAPTER              = &H00000004???
%SERVICE_RECOGNIZER_DRIVER    = &H00000008???

%SERVICE_DRIVER = %SERVICE_KERNEL_DRIVER OR %SERVICE_FILE_SYSTEM_DRIVER OR %SERVICE_RECOGNIZER_DRIVER

%SERVICE_WIN32_OWN_PROCESS    = &H00000010???
%SERVICE_WIN32_SHARE_PROCESS  = &H00000020???
%SERVICE_WIN32 = %SERVICE_WIN32_OWN_PROCESS OR %SERVICE_WIN32_SHARE_PROCESS

%SERVICE_INTERACTIVE_PROCESS  = &H00000100???

%SERVICE_TYPE_ALL = %SERVICE_WIN32 OR %SERVICE_ADAPTER OR %SERVICE_DRIVER OR %SERVICE_INTERACTIVE_PROCESS

'//
'// Start Type
'//

%SERVICE_BOOT_START     = &H00000000???
%SERVICE_SYSTEM_START   = &H00000001???
%SERVICE_AUTO_START     = &H00000002???
%SERVICE_DEMAND_START   = &H00000003???
%SERVICE_DISABLED       = &H00000004???

'//
'// Error control type
'//
%SERVICE_ERROR_IGNORE   = &H00000000???
%SERVICE_ERROR_NORMAL   = &H00000001???
%SERVICE_ERROR_SEVERE   = &H00000002???
%SERVICE_ERROR_CRITICAL = &H00000003???

'//
'//
'// Define the registry driver node enumerations
'//

' SERVICE_NODE_TYPE enum
%DriverType               = %SERVICE_KERNEL_DRIVER
%FileSystemType           = %SERVICE_FILE_SYSTEM_DRIVER
%Win32ServiceOwnProcess   = %SERVICE_WIN32_OWN_PROCESS
%Win32ServiceShareProcess = %SERVICE_WIN32_SHARE_PROCESS
%AdapterType              = %SERVICE_ADAPTER
%RecognizerType           = %SERVICE_RECOGNIZER_DRIVER

' SERVICE_LOAD_TYPE enum
%BootLoad    = %SERVICE_BOOT_START
%SystemLoad  = %SERVICE_SYSTEM_START
%AutoLoad    = %SERVICE_AUTO_START
%DemandLoad  = %SERVICE_DEMAND_START
%DisableLoad = %SERVICE_DISABLED

' SERVICE_ERROR_TYPE enum
%IgnoreError   = %SERVICE_ERROR_IGNORE
%NormalError   = %SERVICE_ERROR_NORMAL
%SevereError   = %SERVICE_ERROR_SEVERE
%CriticalError = %SERVICE_ERROR_CRITICAL


'//
'// IOCTL_TAPE_ERASE definitions
'//

%TAPE_ERASE_SHORT           = 0???
%TAPE_ERASE_LONG            = 1???

TYPE TAPE_ERASE DWORD
   Type      AS DWORD   ' DWORD
   Immediate AS BYTE    ' BOOLEAN
END TYPE

'//
'// IOCTL_TAPE_PREPARE definitions
'//

%TAPE_LOAD                  = 0???
%TAPE_UNLOAD                = 1???
%TAPE_TENSION               = 2???
%TAPE_LOCK                  = 3???
%TAPE_UNLOCK                = 4???
%TAPE_FORMAT                = 5???

TYPE TAPE_PREPARE DWORD
   Operation AS DWORD   ' DWORD
   Immediate AS BYTE    ' BOOLEAN
END TYPE

'//
'// IOCTL_TAPE_WRITE_MARKS definitions
'//

%TAPE_SETMARKS              = 0???
%TAPE_FILEMARKS             = 1???
%TAPE_SHORT_FILEMARKS       = 2???
%TAPE_LONG_FILEMARKS        = 3???

TYPE TAPE_WRITE_MARKS DWORD
   Type      AS DWORD   ' DWORD
   Count     AS DWORD   ' DWORD
   Immediate AS BYTE    ' BOOLEAN
END TYPE

'//
'// IOCTL_TAPE_GET_POSITION definitions
'//

%TAPE_ABSOLUTE_POSITION       = 0???
%TAPE_LOGICAL_POSITION        = 1???
%TAPE_PSEUDO_LOGICAL_POSITION = 2???

TYPE TAPE_GET_POSITION
   Type      AS DWORD   ' DWORD
   Partition AS DWORD   ' DWORD
   Offset    AS QUAD    ' LARGE_INTEGER
END TYPE

'//
'// IOCTL_TAPE_SET_POSITION definitions
'//

%TAPE_REWIND                 = 0???
%TAPE_ABSOLUTE_BLOCK         = 1???
%TAPE_LOGICAL_BLOCK          = 2???
%TAPE_PSEUDO_LOGICAL_BLOCK   = 3???
%TAPE_SPACE_END_OF_DATA      = 4???
%TAPE_SPACE_RELATIVE_BLOCKS  = 5???
%TAPE_SPACE_FILEMARKS        = 6???
%TAPE_SPACE_SEQUENTIAL_FMKS  = 7???
%TAPE_SPACE_SETMARKS         = 8???
%TAPE_SPACE_SEQUENTIAL_SMKS  = 9???

TYPE TAPE_SET_POSITION DWORD
   Method    AS DWORD   ' DWORD
   Partition AS DWORD   ' DWORD
   Offset    AS QUAD    ' LARGE_INTEGER
   Immediate AS BYTE    ' BOOLEAN
END TYPE

'//
'// IOCTL_TAPE_GET_DRIVE_PARAMS definitions
'//

'//
'// Definitions for FeaturesLow parameter
'//

%TAPE_DRIVE_FIXED            = &H00000001???
%TAPE_DRIVE_SELECT           = &H00000002???
%TAPE_DRIVE_INITIATOR        = &H00000004???

%TAPE_DRIVE_ERASE_SHORT      = &H00000010???
%TAPE_DRIVE_ERASE_LONG       = &H00000020???
%TAPE_DRIVE_ERASE_BOP_ONLY   = &H00000040???
%TAPE_DRIVE_ERASE_IMMEDIATE  = &H00000080???

%TAPE_DRIVE_TAPE_CAPACITY    = &H00000100???
%TAPE_DRIVE_TAPE_REMAINING   = &H00000200???
%TAPE_DRIVE_FIXED_BLOCK      = &H00000400???
%TAPE_DRIVE_VARIABLE_BLOCK   = &H00000800???

%TAPE_DRIVE_WRITE_PROTECT    = &H00001000???
%TAPE_DRIVE_EOT_WZ_SIZE      = &H00002000???

%TAPE_DRIVE_ECC              = &H00010000???
%TAPE_DRIVE_COMPRESSION      = &H00020000???
%TAPE_DRIVE_PADDING          = &H00040000???
%TAPE_DRIVE_REPORT_SMKS      = &H00080000???

%TAPE_DRIVE_GET_ABSOLUTE_BLK = &H00100000???
%TAPE_DRIVE_GET_LOGICAL_BLK  = &H00200000???
%TAPE_DRIVE_SET_EOT_WZ_SIZE  = &H00400000???

%TAPE_DRIVE_EJECT_MEDIA      = &H01000000???
%TAPE_DRIVE_CLEAN_REQUESTS   = &H02000000???
%TAPE_DRIVE_SET_CMP_BOP_ONLY = &H04000000???

%TAPE_DRIVE_RESERVED_BIT     = &H80000000???   ' //don't use this bit!
'//                                              //can't be a low features bit!
'//                                              //reserved; high features only


'//
'// Definitions for FeaturesHigh parameter
'//

%TAPE_DRIVE_LOAD_UNLOAD      = &H80000001???
%TAPE_DRIVE_TENSION          = &H80000002???
%TAPE_DRIVE_LOCK_UNLOCK      = &H80000004???
%TAPE_DRIVE_REWIND_IMMEDIATE = &H80000008???

%TAPE_DRIVE_SET_BLOCK_SIZE   = &H80000010???
%TAPE_DRIVE_LOAD_UNLD_IMMED  = &H80000020???
%TAPE_DRIVE_TENSION_IMMED    = &H80000040???
%TAPE_DRIVE_LOCK_UNLK_IMMED  = &H80000080???

%TAPE_DRIVE_SET_ECC          = &H80000100???
%TAPE_DRIVE_SET_COMPRESSION  = &H80000200???
%TAPE_DRIVE_SET_PADDING      = &H80000400???
%TAPE_DRIVE_SET_REPORT_SMKS  = &H80000800???

%TAPE_DRIVE_ABSOLUTE_BLK     = &H80001000???
%TAPE_DRIVE_ABS_BLK_IMMED    = &H80002000???
%TAPE_DRIVE_LOGICAL_BLK      = &H80004000???
%TAPE_DRIVE_LOG_BLK_IMMED    = &H80008000???

%TAPE_DRIVE_END_OF_DATA      = &H80010000???
%TAPE_DRIVE_RELATIVE_BLKS    = &H80020000???
%TAPE_DRIVE_FILEMARKS        = &H80040000???
%TAPE_DRIVE_SEQUENTIAL_FMKS  = &H80080000???

%TAPE_DRIVE_SETMARKS         = &H80100000???
%TAPE_DRIVE_SEQUENTIAL_SMKS  = &H80200000???
%TAPE_DRIVE_REVERSE_POSITION = &H80400000???
%TAPE_DRIVE_SPACE_IMMEDIATE  = &H80800000???

%TAPE_DRIVE_WRITE_SETMARKS   = &H81000000???
%TAPE_DRIVE_WRITE_FILEMARKS  = &H82000000???
%TAPE_DRIVE_WRITE_SHORT_FMKS = &H84000000???
%TAPE_DRIVE_WRITE_LONG_FMKS  = &H88000000???

%TAPE_DRIVE_WRITE_MARK_IMMED = &H90000000???
%TAPE_DRIVE_FORMAT           = &HA0000000???
%TAPE_DRIVE_FORMAT_IMMEDIATE = &HC0000000???
%TAPE_DRIVE_HIGH_FEATURES    = &H80000000???  ' //mask for high features flag

TYPE TAPE_GET_DRIVE_PARAMETERS
   ECC                   AS BYTE    ' BOOLEAN
   Compression           AS BYTE    ' BOOLEAN
   DataPadding           AS BYTE    ' BOOLEAN
   ReportSetmarks        AS BYTE    ' BOOLEAN
   DefaultBlockSize      AS DWORD   ' DWORD
   MaximumBlockSize      AS DWORD   ' DWORD
   MinimumBlockSize      AS DWORD   ' DWORD
   MaximumPartitionCount AS DWORD   ' DWORD
   FeaturesLow           AS DWORD   ' DWORD
   FeaturesHigh          AS DWORD   ' DWORD
   EOTWarningZoneSize    AS DWORD   ' DWORD
END TYPE

'//
'// IOCTL_TAPE_SET_DRIVE_PARAMETERS definitions
'//

TYPE TAPE_SET_DRIVE_PARAMETERS
   ECC                AS BYTE    ' BOOLEAN
   Compression        AS BYTE    ' BOOLEAN
   DataPadding        AS BYTE    ' BOOLEAN
   ReportSetmarks     AS BYTE    ' BOOLEAN
   EOTWarningZoneSize AS DWORD   ' DWORD
END TYPE

'//
'// IOCTL_TAPE_GET_MEDIA_PARAMETERS definitions
'//

TYPE TAPE_GET_MEDIA_PARAMETERS DWORD
   Capacity       AS QUAD    ' LARGE_INTEGER
   Remaining      AS QUAD    ' LARGE_INTEGER
   BlockSize      AS DWORD   ' DWORD
   PartitionCount AS DWORD   ' DWORD
   WriteProtected AS BYTE    ' BOOLEAN
END TYPE

'//
'// IOCTL_TAPE_SET_MEDIA_PARAMETERS definitions
'//

TYPE TAPE_SET_MEDIA_PARAMETERS
   BlockSize AS DWORD
END TYPE

'//
'// IOCTL_TAPE_CREATE_PARTITION definitions
'//

%TAPE_FIXED_PARTITIONS      = 0???
%TAPE_SELECT_PARTITIONS     = 1???
%TAPE_INITIATOR_PARTITIONS  = 2???

TYPE TAPE_CREATE_PARTITION
   Method AS DWORD
   Count  AS DWORD
   Size   AS DWORD
END TYPE

'//
'// WMI Methods
'//
%TAPE_QUERY_DRIVE_PARAMETERS      = 0???
%TAPE_QUERY_MEDIA_CAPACITY        = 1???
%TAPE_CHECK_FOR_DRIVE_PROBLEM     = 2???
%TAPE_QUERY_IO_ERROR_DATA         = 3???
%TAPE_QUERY_DEVICE_ERROR_DATA     = 4???

TYPE TAPE_WMI_OPERATIONS
   Method         AS DWORD   ' DWORD
   DataBufferSize AS DWORD   ' DWORD
   DataBuffer     AS DWORD   ' PVOID
END TYPE

'//
'// Type of drive errors
'//
' TAPE_DRIVE_PROBLEM_TYPE enum
%TapeDriveProblemNone         = 0
%TapeDriveReadWriteWarning    = 1
%TapeDriveReadWriteError      = 2
%TapeDriveReadWarning         = 3
%TapeDriveWriteWarning        = 4
%TapeDriveReadError           = 5
%TapeDriveWriteError          = 6
%TapeDriveHardwareError       = 7
%TapeDriveUnsupportedMedia    = 8
%TapeDriveScsiConnectionError = 9
%TapeDriveTimetoClean         = 10
%TapeDriveCleanDriveNow       = 11
%TapeDriveMediaLifeExpired    = 12
%TapeDriveSnappedTape         = 13

#IF NOT %DEF(%NTTMAPI)
    %NTTMAPI = 1


'//
'// Types for Nt level TM calls
'//

'//
'// KTM Tm object rights
'//
%TRANSACTIONMANAGER_QUERY_INFORMATION     = &H0001???
%TRANSACTIONMANAGER_SET_INFORMATION       = &H0002???
%TRANSACTIONMANAGER_RECOVER               = &H0004???
%TRANSACTIONMANAGER_RENAME                = &H0008???
%TRANSACTIONMANAGER_CREATE_RM             = &H0010???

'// The following right is intended for DTC's use only; it will be
'// deprecated, and no one else should take a dependency on it.
%TRANSACTIONMANAGER_BIND_TRANSACTION      = &H0020???

'//
'// Generic mappings for transaction manager rights.
'//

%TRANSACTIONMANAGER_GENERIC_READ          = %STANDARD_RIGHTS_READ OR _
                                            %TRANSACTIONMANAGER_QUERY_INFORMATION

%TRANSACTIONMANAGER_GENERIC_WRITE         = %STANDARD_RIGHTS_WRITE               OR _
                                            %TRANSACTIONMANAGER_SET_INFORMATION  OR _
                                            %TRANSACTIONMANAGER_RECOVER          OR _
                                            %TRANSACTIONMANAGER_RENAME           OR _
                                            %TRANSACTIONMANAGER_CREATE_RM

%TRANSACTIONMANAGER_GENERIC_EXECUTE       = %STANDARD_RIGHTS_EXECUTE

%TRANSACTIONMANAGER_ALL_ACCESS            = %STANDARD_RIGHTS_REQUIRED            OR _
                                            %TRANSACTIONMANAGER_GENERIC_READ     OR _
                                            %TRANSACTIONMANAGER_GENERIC_WRITE    OR _
                                            %TRANSACTIONMANAGER_GENERIC_EXECUTE  OR _
                                            %TRANSACTIONMANAGER_BIND_TRANSACTION

'//
'// KTM transaction object rights.
'//
%TRANSACTION_QUERY_INFORMATION     = &H0001???
%TRANSACTION_SET_INFORMATION       = &H0002???
%TRANSACTION_ENLIST                = &H0004???
%TRANSACTION_COMMIT                = &H0008???
%TRANSACTION_ROLLBACK              = &H0010???
%TRANSACTION_PROPAGATE             = &H0020???
%TRANSACTION_SAVEPOINT             = &H0040???
%TRANSACTION_MARSHALL              = %TRANSACTION_QUERY_INFORMATION

'//
'// Generic mappings for transaction rights.
'// Resource managers, when enlisting, should generally use the macro
'// TRANSACTION_RESOURCE_MANAGER_RIGHTS when opening a transaction.
'// It's the same as generic read and write except that it does not allow
'// a commit decision to be made.
'//

%TRANSACTION_GENERIC_READ            = %STANDARD_RIGHTS_READ          OR _
                                       %TRANSACTION_QUERY_INFORMATION OR _
                                       %SYNCHRONIZE

%TRANSACTION_GENERIC_WRITE           = %STANDARD_RIGHTS_WRITE         OR _
                                       %TRANSACTION_SET_INFORMATION   OR _
                                       %TRANSACTION_COMMIT            OR _
                                       %TRANSACTION_ENLIST            OR _
                                       %TRANSACTION_ROLLBACK          OR _
                                       %TRANSACTION_PROPAGATE         OR _
                                       %TRANSACTION_SAVEPOINT         OR _
                                       %SYNCHRONIZE

%TRANSACTION_GENERIC_EXECUTE         = %STANDARD_RIGHTS_EXECUTE       OR _
                                       %TRANSACTION_COMMIT            OR _
                                       %TRANSACTION_ROLLBACK          OR _
                                       %SYNCHRONIZE

%TRANSACTION_ALL_ACCESS              = %STANDARD_RIGHTS_REQUIRED      OR _
                                       %TRANSACTION_GENERIC_READ      OR _
                                       %TRANSACTION_GENERIC_WRITE     OR _
                                       %TRANSACTION_GENERIC_EXECUTE

%TRANSACTION_RESOURCE_MANAGER_RIGHTS = %TRANSACTION_GENERIC_READ      OR _
                                       %STANDARD_RIGHTS_WRITE         OR _
                                       %TRANSACTION_SET_INFORMATION   OR _
                                       %TRANSACTION_ENLIST            OR _
                                       %TRANSACTION_ROLLBACK          OR _
                                       %TRANSACTION_PROPAGATE         OR _
                                       %SYNCHRONIZE

'//
'// KTM resource manager object rights.
'//
%RESOURCEMANAGER_QUERY_INFORMATION     = &H0001???
%RESOURCEMANAGER_SET_INFORMATION       = &H0002???
%RESOURCEMANAGER_RECOVER               = &H0004???
%RESOURCEMANAGER_ENLIST                = &H0008???
%RESOURCEMANAGER_GET_NOTIFICATION      = &H0010???
%RESOURCEMANAGER_REGISTER_PROTOCOL     = &H0020???
%RESOURCEMANAGER_COMPLETE_PROPAGATION  = &H0040???

'//
'// Generic mappings for resource manager rights.
'//
%RESOURCEMANAGER_GENERIC_READ        = %STANDARD_RIGHTS_READ                 OR _
                                       %RESOURCEMANAGER_QUERY_INFORMATION    OR _
                                       %SYNCHRONIZE

%RESOURCEMANAGER_GENERIC_WRITE       = %STANDARD_RIGHTS_WRITE                OR _
                                       %RESOURCEMANAGER_SET_INFORMATION      OR _
                                       %RESOURCEMANAGER_RECOVER              OR _
                                       %RESOURCEMANAGER_ENLIST               OR _
                                       %RESOURCEMANAGER_GET_NOTIFICATION     OR _
                                       %RESOURCEMANAGER_REGISTER_PROTOCOL    OR _
                                       %RESOURCEMANAGER_COMPLETE_PROPAGATION OR _
                                       %SYNCHRONIZE

%RESOURCEMANAGER_GENERIC_EXECUTE     = %STANDARD_RIGHTS_EXECUTE              OR _
                                       %RESOURCEMANAGER_RECOVER              OR _
                                       %RESOURCEMANAGER_ENLIST               OR _
                                       %RESOURCEMANAGER_GET_NOTIFICATION     OR _
                                       %RESOURCEMANAGER_COMPLETE_PROPAGATION OR _
                                       %SYNCHRONIZE

%RESOURCEMANAGER_ALL_ACCESS          = %STANDARD_RIGHTS_REQUIRED             OR _
                                       %RESOURCEMANAGER_GENERIC_READ         OR _
                                       %RESOURCEMANAGER_GENERIC_WRITE        OR _
                                       %RESOURCEMANAGER_GENERIC_EXECUTE


'//
'// KTM enlistment object rights.
'//
%ENLISTMENT_QUERY_INFORMATION     = &H0001???
%ENLISTMENT_SET_INFORMATION       = &H0002???
%ENLISTMENT_RECOVER               = &H0004???
%ENLISTMENT_SUBORDINATE_RIGHTS    = &H0008???
%ENLISTMENT_SUPERIOR_RIGHTS       = &H0010???

'//
'// Generic mappings for enlistment rights.
'//
%ENLISTMENT_GENERIC_READ        = %STANDARD_RIGHTS_READ           OR _
                                  %ENLISTMENT_QUERY_INFORMATION

%ENLISTMENT_GENERIC_WRITE       = %STANDARD_RIGHTS_WRITE          OR _
                                  %ENLISTMENT_SET_INFORMATION     OR _
                                  %ENLISTMENT_RECOVER             OR _
                                  %ENLISTMENT_SUBORDINATE_RIGHTS  OR _
                                  %ENLISTMENT_SUPERIOR_RIGHTS

%ENLISTMENT_GENERIC_EXECUTE     = %STANDARD_RIGHTS_EXECUTE        OR _
                                  %ENLISTMENT_RECOVER             OR _
                                  %ENLISTMENT_SUBORDINATE_RIGHTS  OR _
                                  %ENLISTMENT_SUPERIOR_RIGHTS

%ENLISTMENT_ALL_ACCESS          = %STANDARD_RIGHTS_REQUIRED       OR _
                                  %ENLISTMENT_GENERIC_READ        OR _
                                  %ENLISTMENT_GENERIC_WRITE       OR _
                                  %ENLISTMENT_GENERIC_EXECUTE


'//
'// Transaction outcomes.
'//

' enum TRANSACTION_OUTCOME
%TransactionOutcomeUndetermined  = 1
%TransactionOutcomeCommitted     = 2
%TransactionOutcomeAborted       = 3

' enum TRANSACTION_STATE
%TransactionStateNormal          = 1
%TransactionStateIndoubt         = 2
%TransactionStateCommittedNotify = 3

TYPE TRANSACTION_BASIC_INFORMATION
   TransactionId AS GUID    ' GUID
   State         AS DWORD   ' DWORD
   Outcome       AS DWORD   ' DWORD
END TYPE

TYPE TRANSACTIONMANAGER_BASIC_INFORMATION
   TmIdentity   AS GUID   ' GUID
   VirtualClock AS QUAD   ' LARGE_INTEGER
END TYPE

TYPE TRANSACTIONMANAGER_LOG_INFORMATION
   LogIdentity AS GUID   ' GUID
END TYPE

TYPE TRANSACTIONMANAGER_LOGPATH_INFORMATION
   LogPathLength AS DWORD   ' DWORD
   LogPathAS     AS STRING * 1 * 2   ' __field_ecount(LogPathLength) WCHAR // Variable size
'//  Data[1];                                        // Variable size data not declared
END TYPE

TYPE TRANSACTION_PROPERTIES_INFORMATION
   IsolationLevel    AS DWORD   ' DWORD
   IsolationFlags    AS DWORD   ' DWORD
   Timeout           AS QUAD   ' LARGE_INTEGER
   Outcome           AS DWORD   ' DWORD
   DescriptionLength AS DWORD   ' DWORD
   Description       AS STRING * 1 * 2   ' WCHAR // Variable size
'//          Data[1];            // Variable size data not declared
END TYPE

'// The following info-class is intended for DTC's use only; it will be
'// deprecated, and no one else should take a dependency on it.
TYPE TRANSACTION_BIND_INFORMATION
   TmHandle AS DWORD   ' HANDLE
END TYPE

TYPE TRANSACTION_ENLISTMENT_PAIR
   EnlistmentId      AS GUID   ' GUID
   ResourceManagerId AS GUID   ' GUID
END TYPE

TYPE TRANSACTION_ENLISTMENTS_INFORMATION
   NumberOfEnlistments AS DWORD   ' DWORD
   EnlistmentPair(0)   AS TRANSACTION_ENLISTMENT_PAIR   ' // Variable size
END TYPE

TYPE TRANSACTION_FULL_INFORMATION
'// Not currently defined
   NameLength AS DWORD   ' DWORD
END TYPE

TYPE RESOURCEMANAGER_BASIC_INFORMATION
   ResourceManagerId AS GUID   ' GUID
   DescriptionLength AS DWORD   ' DWORD
   Description       AS STRING * 1 * 2   ' WCHAR // Variable size
END TYPE

TYPE RESOURCEMANAGER_COMPLETION_INFORMATION
   IoCompletionPortHandle AS DWORD   ' HANDLE
   CompletionKey          AS DWORD   ' ULONG_PTR
END TYPE

TYPE TRANSACTION_NAME_INFORMATION
   NameLength AS DWORD            ' DWORD
   Name(0)    AS STRING * 1 * 2   ' WCHAR // Variable length string
END TYPE

' enum _TRANSACTION_INFORMATION_CLASS
%TransactionBasicInformation      = 0
%TransactionPropertiesInformation = 1
%TransactionEnlistmentInformation = 2
%TransactionFullInformation       = 3
'// The following info-class is intended for DTC's use only; it will be
'// deprecated, and no one else should take a dependency on it.
%TransactionBindInformation       = 4   ' // private and deprecated
'//    TransactionNameInformation

' enum _TRANSACTIONMANAGER_INFORMATION_CLASS
%TransactionManagerBasicInformation       = 0
%TransactionManagerLogInformation         = 1
%TransactionManagerLogPathInformation     = 2
%TransactionManagerOnlineProbeInformation = 3

' enum _RESOURCEMANAGER_INFORMATION_CLASS
%ResourceManagerBasicInformation      = 0
%ResourceManagerCompletionInformation = 1
%ResourceManagerFullInformation       = 2
%ResourceManagerNameInformation       = 3

TYPE ENLISTMENT_BASIC_INFORMATION
   EnlistmentId      AS GUID   ' GUID
   TransactionId     AS GUID   ' GUID
   ResourceManagerId AS GUID   ' GUID
END TYPE

' enum _ENLISTMENT_INFORMATION_CLASS
%EnlistmentBasicInformation    = 0
%EnlistmentRecoveryInformation = 1
%EnlistmentFullInformation     = 2
%EnlistmentNameInformation     = 3

TYPE TRANSACTION_LIST_ENTRY
   UOW AS GUID   ' UOW
END TYPE

TYPE TRANSACTION_LIST_INFORMATION
   NumberOfTransactions      AS DWORD   ' DWORD
   TransactionInformation(0) AS TRANSACTION_LIST_ENTRY   ' // Var size
END TYPE

'//
'// Types of objects known to the kernel transaction manager.
'//

' enum KTMOBJECT_TYPE
%KTMOBJECT_TRANSACTION         = 0
%KTMOBJECT_TRANSACTION_MANAGER = 1
%KTMOBJECT_RESOURCE_MANAGER    = 2
%KTMOBJECT_ENLISTMENT          = 3
%KTMOBJECT_INVALID             = 4

'//
'// KTMOBJECT_CURSOR
'//
'// Used by NtEnumerateTransactionObject to enumerate a transaction
'// object namespace (e.g. enlistments in a resource manager).
'//

TYPE KTMOBJECT_CURSOR
   LastQuery     AS GUID   ' GUID
   ObjectIdCount AS DWORD   ' DWORD
   ObjectIds(0)  AS GUID   ' GUID
END TYPE

#ENDIF ' // _NTTMAPI_


'typedef DWORD TP_VERSION, *PTP_VERSION;

'typedef struct _TP_CALLBACK_INSTANCE TP_CALLBACK_INSTANCE, *PTP_CALLBACK_INSTANCE;

'typedef VOID (NTAPI *PTP_SIMPLE_CALLBACK)(
'    __inout     PTP_CALLBACK_INSTANCE Instance,
'    __inout_opt PVOID                 Context
'    );

'typedef struct _TP_POOL TP_POOL, *PTP_POOL;
'typedef struct _TP_CLEANUP_GROUP TP_CLEANUP_GROUP, *PTP_CLEANUP_GROUP;

'typedef VOID (NTAPI *PTP_CLEANUP_GROUP_CANCEL_CALLBACK)(
'    __inout_opt PVOID ObjectContext,
'    __inout_opt PVOID CleanupContext
'    );

'//
'// Do not manipulate this structure directly!  Allocate space for it
'// and use the inline interfaces below.
'//

'typedef struct _TP_CALLBACK_ENVIRON {
'    TP_VERSION                         Version;
'    PTP_POOL                           Pool;
'    PTP_CLEANUP_GROUP                  CleanupGroup;
'    PTP_CLEANUP_GROUP_CANCEL_CALLBACK  CleanupGroupCancelCallback;
'    PVOID                              RaceDll;
'    struct _ACTIVATION_CONTEXT        *ActivationContext;
'    PTP_SIMPLE_CALLBACK                FinalizationCallback;
'    union {
'        DWORD                          Flags;
'        struct {
'            DWORD                      LongFunction :  1;
'            DWORD                      Private      : 31;
'        } s;
'    } u;
'} TP_CALLBACK_ENVIRON, *PTP_CALLBACK_ENVIRON;

TYPE TP_CALLBACK_ENVIRON_UNION_STRUCT
   LongFunction AS BIT * 1 IN DWORD
   Private      AS BIT * 31
END TYPE

UNION TP_CALLBACK_ENVIRON_UNION
   Flags AS DWORD   ' DWORD
   TP_CALLBACK_ENVIRON_UNION_STRUCT
END UNION

TYPE TP_CALLBACK_ENVIRON
   Version                    AS DWORD   ' TP_VERSION
   Pool                       AS DWORD   ' PTP_POOL
   CleanupGroup               AS DWORD   ' PTP_CLEANUP_GROUP
   CleanupGroupCancelCallback AS DWORD   ' PTP_CLEANUP_GROUP_CANCEL_CALLBACK
   RaceDll                    AS DWORD   ' PVOID
   ActivationContext          AS DWORD   ' struct _ACTIVATION_CONTEXT *
   FinalizationCallback       AS DWORD   ' PTP_SIMPLE_CALLBACK
   TP_CALLBACK_ENVIRON_UNION
END TYPE

'#if !defined(MIDL_PASS)

'FORCEINLINE
'VOID
'TpInitializeCallbackEnviron(
'    __out PTP_CALLBACK_ENVIRON CallbackEnviron
'    )
'{
'    CallbackEnviron->Version = 1;
'    CallbackEnviron->Pool = NULL;
'    CallbackEnviron->CleanupGroup = NULL;
'    CallbackEnviron->CleanupGroupCancelCallback = NULL;
'    CallbackEnviron->RaceDll = NULL;
'    CallbackEnviron->ActivationContext = NULL;
'    CallbackEnviron->FinalizationCallback = NULL;
'    CallbackEnviron->u.Flags = 0;
'}

MACRO TpInitializeCallbackEnviron (CallbackEnviron)
   CallbackEnviron.Version = 1
   CallbackEnviron.Pool = %NULL
   CallbackEnviron.CleanupGroup = %NULL
   CallbackEnviron.CleanupGroupCancelCallback = %NULL
   CallbackEnviron.RaceDll = %NULL
   CallbackEnviron.ActivationContext = %NULL
   CallbackEnviron.FinalizationCallback = %NULL
   CallbackEnviron.Flags = 0
END MACRO

'FORCEINLINE
'VOID
'TpSetCallbackThreadpool(
'    __inout PTP_CALLBACK_ENVIRON CallbackEnviron,
'    __in    PTP_POOL             Pool
'    )
'{
'    CallbackEnviron->Pool = Pool;
'}

MACRO TpSetCallbackThreadpool (CallbackEnviron, Pool)
   CallbackEnviron.Pool = Pool
END MACRO

'FORCEINLINE
'VOID
'TpSetCallbackCleanupGroup(
'    __inout  PTP_CALLBACK_ENVIRON              CallbackEnviron,
'    __in     PTP_CLEANUP_GROUP                 CleanupGroup,
'    __in_opt PTP_CLEANUP_GROUP_CANCEL_CALLBACK CleanupGroupCancelCallback
'    )
'{
'    CallbackEnviron->CleanupGroup = CleanupGroup;
'    CallbackEnviron->CleanupGroupCancelCallback = CleanupGroupCancelCallback;
'}

MACRO TpSetCallbackCleanupGroup (CallbackEnviron, CleanupGroup, CleanupGroupCancelCallback)
   CallbackEnviron.CleanupGroup = CleanupGroup
   CallbackEnviron.CleanupGroupCancelCallback = CleanupGroupCancelCallback
END MACRO

'FORCEINLINE
'VOID
'TpSetCallbackActivationContext(
'    __inout  PTP_CALLBACK_ENVIRON CallbackEnviron,
'    __in_opt struct _ACTIVATION_CONTEXT *ActivationContext
'    )
'{
'    CallbackEnviron->ActivationContext = ActivationContext;
'}

MACRO TpSetCallbackActivationContext (CallbackEnviron, ActivationContext)
   CallbackEnviron.ActivationContext = ActivationContext
END MACRO

'FORCEINLINE
'VOID
'TpSetCallbackNoActivationContext(
'    __inout PTP_CALLBACK_ENVIRON CallbackEnviron
'    )
'{
'    CallbackEnviron->ActivationContext = (struct _ACTIVATION_CONTEXT *)(LONG_PTR) -1; // INVALID_ACTIVATION_CONTEXT
'}

MACRO TpSetCallbackNoActivationContext (CallbackEnviron)
   CallbackEnviron.ActivationContext = -1   ' // INVALID_ACTIVATION_CONTEXT
END MACRO

'FORCEINLINE
'VOID
'TpSetCallbackLongFunction(
'    __inout PTP_CALLBACK_ENVIRON CallbackEnviron
'    )
'{
'    CallbackEnviron->u.s.LongFunction = 1;
'}

MACRO TpSetCallbackLongFunction (CallbackEnviron)
   CallbackEnviron.LongFunction = 1
END MACRO

'FORCEINLINE
'VOID
'TpSetCallbackRaceWithDll(
'    __inout PTP_CALLBACK_ENVIRON CallbackEnviron,
'    __in    PVOID                DllHandle
'    )
'{
'    CallbackEnviron->RaceDll = DllHandle;
'}

MACRO TpSetCallbackRaceWithDll (CallbackEnviron, DllHandle)
   CallbackEnviron.RaceDll = DllHandle
END MACRO

'FORCEINLINE
'VOID
'TpSetCallbackFinalizationCallback(
'    __inout PTP_CALLBACK_ENVIRON CallbackEnviron,
'    __in    PTP_SIMPLE_CALLBACK  FinalizationCallback
'    )
'{
'    CallbackEnviron->FinalizationCallback = FinalizationCallback;
'}

MACRO TpSetCallbackFinalizationCallback (CallbackEnviron, FinalizationCallback)
   CallbackEnviron.FinalizationCallback = FinalizationCallback
END MACRO

'FORCEINLINE
'VOID
'TpDestroyCallbackEnviron(
'    __in PTP_CALLBACK_ENVIRON CallbackEnviron
'    )
'{
'    //
'    // For the current version of the callback environment, no actions
'    // need to be taken to tear down an initialized structure.  This
'    // may change in a future release.
'    //

'    UNREFERENCED_PARAMETER(CallbackEnviron);
'}

'#endif // !defined(MIDL_PASS)


'typedef struct _TP_WORK TP_WORK, *PTP_WORK;

'typedef VOID (NTAPI *PTP_WORK_CALLBACK)(
'    __inout     PTP_CALLBACK_INSTANCE Instance,
'    __inout_opt PVOID                 Context,
'    __inout     PTP_WORK              Work
'    );

'typedef struct _TP_TIMER TP_TIMER, *PTP_TIMER;

'typedef VOID (NTAPI *PTP_TIMER_CALLBACK)(
'    __inout     PTP_CALLBACK_INSTANCE Instance,
'    __inout_opt PVOID                 Context,
'    __inout     PTP_TIMER             Timer
'    );

'typedef DWORD    TP_WAIT_RESULT;

'typedef struct _TP_WAIT TP_WAIT, *PTP_WAIT;

'typedef VOID (NTAPI *PTP_WAIT_CALLBACK)(
'    __inout     PTP_CALLBACK_INSTANCE Instance,
'    __inout_opt PVOID                 Context,
'    __inout     PTP_WAIT              Wait,
'    __in        TP_WAIT_RESULT        WaitResult
'    );

'typedef struct _TP_IO TP_IO, *PTP_IO;


'#if (_WIN32_WINNT > 0x0500) || (_WIN32_FUSION >= 0x0100) || ISOLATION_AWARE_ENABLED // winnt_only
%ACTIVATION_CONTEXT_SECTION_ASSEMBLY_INFORMATION         = 1
%ACTIVATION_CONTEXT_SECTION_DLL_REDIRECTION              = 2
%ACTIVATION_CONTEXT_SECTION_WINDOW_CLASS_REDIRECTION     = 3
%ACTIVATION_CONTEXT_SECTION_COM_SERVER_REDIRECTION       = 4
%ACTIVATION_CONTEXT_SECTION_COM_INTERFACE_REDIRECTION    = 5
%ACTIVATION_CONTEXT_SECTION_COM_TYPE_LIBRARY_REDIRECTION = 6
%ACTIVATION_CONTEXT_SECTION_COM_PROGID_REDIRECTION       = 7
%ACTIVATION_CONTEXT_SECTION_GLOBAL_OBJECT_RENAME_TABLE   = 8
%ACTIVATION_CONTEXT_SECTION_CLR_SURROGATES               = 9
%ACTIVATION_CONTEXT_SECTION_APPLICATION_SETTINGS         = 10
'#endif // winnt_only

#ENDIF   ' #IF NOT %DEF(%WINNT_INC)


'#include <specstrings.h>

'/* Types use for passing & returning polymorphic values */
'typedef UINT_PTR            WPARAM;
'typedef LONG_PTR            LPARAM;
'typedef LONG_PTR            LRESULT;

'#ifndef NOMINMAX

'#ifndef max
'#define max(a,b)            (((a) > (b)) ? (a) : (b))
'#endif

'#ifndef min
'#define min(a,b)            (((a) < (b)) ? (a) : (b))
'#endif

'#endif  /* NOMINMAX */

'#define MAKEWORD(a, b)      ((WORD)(((BYTE)((DWORD_PTR)(a) & 0xff)) | ((WORD)((BYTE)((DWORD_PTR)(b) & 0xff))) << 8))
'#define MAKELONG(a, b)      ((LONG)(((WORD)((DWORD_PTR)(a) & 0xffff)) | ((DWORD)((WORD)((DWORD_PTR)(b) & 0xffff))) << 16))
'#define LOWORD(l)           ((WORD)((DWORD_PTR)(l) & 0xffff))
'#define HIWORD(l)           ((WORD)((DWORD_PTR)(l) >> 16))
'#define LOBYTE(w)           ((BYTE)((DWORD_PTR)(w) & 0xff))
'#define HIBYTE(w)           ((BYTE)((DWORD_PTR)(w) >> 8))


'#ifndef WIN_INTERNAL
'DECLARE_HANDLE            (HWND);
'DECLARE_HANDLE            (HHOOK);
'#ifdef WINABLE
'DECLARE_HANDLE            (HEVENT);
'#endif
'#endif

'typedef WORD                ATOM;

'typedef HANDLE NEAR         *SPHANDLE;
'typedef HANDLE FAR          *LPHANDLE;
'typedef HANDLE              HGLOBAL;
'typedef HANDLE              HLOCAL;
'typedef HANDLE              GLOBALHANDLE;
'typedef HANDLE              LOCALHANDLE;

'#ifndef _MAC
'#ifdef _WIN64
'typedef INT_PTR (FAR WINAPI *FARPROC)();
'typedef INT_PTR (NEAR WINAPI *NEARPROC)();
'typedef INT_PTR (WINAPI *PROC)();
'#else
'typedef int (FAR WINAPI *FARPROC)();
'typedef int (NEAR WINAPI *NEARPROC)();
'typedef int (WINAPI *PROC)();
'#endif  // _WIN64
'#else
'typedef int (CALLBACK *FARPROC)();
'typedef int (CALLBACK *NEARPROC)();
'typedef int (CALLBACK *PROC)();
'#endif

'#if !defined(_MAC) || !defined(GDI_INTERNAL)
'#ifdef STRICT
'typedef void NEAR* HGDIOBJ;
'#else
'DECLARE_HANDLE(HGDIOBJ);
'#endif
'#endif

'DECLARE_HANDLE(HKEY);
'typedef HKEY *PHKEY;

'#if !defined(_MAC) || !defined(WIN_INTERNAL)
'DECLARE_HANDLE(HACCEL);
'#endif
'#if !defined(_MAC) || !defined(GDI_INTERNAL)
'DECLARE_HANDLE(HBITMAP);
'DECLARE_HANDLE(HBRUSH);
'#endif
'#if(WINVER >= 0x0400)
'DECLARE_HANDLE(HCOLORSPACE);
'#endif /* WINVER >= 0x0400 */
'#if !defined(_MAC) || !defined(GDI_INTERNAL)
'DECLARE_HANDLE(HDC);
'#endif
'DECLARE_HANDLE(HGLRC);          // OpenGL
'DECLARE_HANDLE(HDESK);
'DECLARE_HANDLE(HENHMETAFILE);
'#if !defined(_MAC) || !defined(GDI_INTERNAL)
'DECLARE_HANDLE(HFONT);
'#endif
'DECLARE_HANDLE(HICON);
'#if !defined(_MAC) || !defined(WIN_INTERNAL)
'DECLARE_HANDLE(HMENU);
'#endif
'DECLARE_HANDLE(HMETAFILE);
'DECLARE_HANDLE(HINSTANCE);
'typedef HINSTANCE HMODULE;      /* HMODULEs can be used in place of HINSTANCEs */
'#if !defined(_MAC) || !defined(GDI_INTERNAL)
'DECLARE_HANDLE(HPALETTE);
'DECLARE_HANDLE(HPEN);
'#endif
'DECLARE_HANDLE(HRGN);
'DECLARE_HANDLE(HRSRC);
'DECLARE_HANDLE(HSTR);
'DECLARE_HANDLE(HTASK);
'DECLARE_HANDLE(HWINSTA);
'DECLARE_HANDLE(HKL);

'#if(WINVER >= 0x0500)
'#ifndef _MAC
'DECLARE_HANDLE(HMONITOR);
'DECLARE_HANDLE(HWINEVENTHOOK);
'#endif
'DECLARE_HANDLE(HUMPD);
'#endif /* WINVER >= 0x0500 */

'#ifndef _MAC
'typedef int HFILE;
'typedef HICON HCURSOR;      /* HICONs & HCURSORs are polymorphic */
'#else
'typedef short HFILE;
'DECLARE_HANDLE(HCURSOR);    /* HICONs & HCURSORs are not polymorphic */
'#endif

'typedef DWORD   COLORREF;
'typedef DWORD   *LPCOLORREF;

'#define HFILE_ERROR ((HFILE)-1)

%HFILE_ERROR = &HFFFFFFFF???

TYPE POINTS
   x AS INTEGER   ' SHORT
   y AS INTEGER   ' SHORT
END TYPE

'/* mode selections for the device mode function */
%DM_UPDATE      = 1
%DM_COPY        = 2
%DM_PROMPT      = 4
%DM_MODIFY      = 8

%DM_IN_BUFFER   = %DM_MODIFY
%DM_IN_PROMPT   = %DM_PROMPT
%DM_OUT_BUFFER  = %DM_COPY
%DM_OUT_DEFAULT = %DM_UPDATE

'/* device capabilities indices */
%DC_FIELDS            = 1
%DC_PAPERS            = 2
%DC_PAPERSIZE         = 3
%DC_MINEXTENT         = 4
%DC_MAXEXTENT         = 5
%DC_BINS              = 6
%DC_DUPLEX            = 7
%DC_SIZE              = 8
%DC_EXTRA             = 9
%DC_VERSION           = 10
%DC_DRIVER            = 11
%DC_BINNAMES          = 12
%DC_ENUMRESOLUTIONS   = 13
%DC_FILEDEPENDENCIES  = 14
%DC_TRUETYPE          = 15
%DC_PAPERNAMES        = 16
%DC_ORIENTATION       = 17
%DC_COPIES            = 18

#ENDIF   ' #IF NOT %DEF(%WINDEF)

'/************************************************************************
'*                                                                       *
'*   winbase.h -- This module defines the 32-Bit Windows Base APIs       *
'*                                                                       *
'*   Copyright (c) Microsoft Corp. All rights reserved.                  *
'*                                                                       *
'************************************************************************/

#IF NOT %DEF(%WINBASE)
    %WINBASE = 1

'/*
' * Compatibility macros
' */

'#define DefineHandleTable(w)            ((w),TRUE)
'#define LimitEmsPages(dw)
'#define SetSwapAreaSize(w)              (w)
'#define LockSegment(w)                  GlobalFix((HANDLE)(w))
'#define UnlockSegment(w)                GlobalUnfix((HANDLE)(w))
'#define GetCurrentTime()                GetTickCount()

'#define Yield()

'#define INVALID_HANDLE_VALUE ((HANDLE)(LONG_PTR)-1)
'#define INVALID_FILE_SIZE ((DWORD)0xFFFFFFFF)
'#define INVALID_SET_FILE_POINTER ((DWORD)-1)
'#define INVALID_FILE_ATTRIBUTES ((DWORD)-1)

%INVALID_HANDLE_VALUE     = &HFFFFFFFF???
%INVALID_FILE_SIZE        = &HFFFFFFFF???
%INVALID_SET_FILE_POINTER = &HFFFFFFFF???
%INVALID_FILE_ATTRIBUTES  = &HFFFFFFFF???

%FILE_BEGIN   = 0
%FILE_CURRENT = 1
%FILE_END     = 2

'#define TIME_ZONE_ID_INVALID ((DWORD)0xFFFFFFFF)
%TIME_ZONE_ID_INVALID  = &HFFFFFFFF???

'#define WAIT_FAILED ((DWORD)0xFFFFFFFF)
'#define WAIT_OBJECT_0       ((STATUS_WAIT_0 ) + 0 )
%WAIT_FAILED      = &HFFFFFFFF???
%WAIT_OBJECT_0    = %STATUS_WAIT_0

'#define WAIT_ABANDONED         ((STATUS_ABANDONED_WAIT_0 ) + 0 )
'#define WAIT_ABANDONED_0       ((STATUS_ABANDONED_WAIT_0 ) + 0 )

%WAIT_ABANDONED   = %STATUS_ABANDONED_WAIT_0
%WAIT_ABANDONED_0 = %STATUS_ABANDONED_WAIT_0

%WAIT_IO_COMPLETION                 = %STATUS_USER_APC
%STILL_ACTIVE                       = %STATUS_PENDING
%STATUS_POSSIBLE_DEADLOCK           = &HC0000194&
%EXCEPTION_ACCESS_VIOLATION         = %STATUS_ACCESS_VIOLATION
%EXCEPTION_DATATYPE_MISALIGNMENT    = %STATUS_DATATYPE_MISALIGNMENT
%EXCEPTION_BREAKPOINT               = %STATUS_BREAKPOINT
%EXCEPTION_SINGLE_STEP              = %STATUS_SINGLE_STEP
%EXCEPTION_ARRAY_BOUNDS_EXCEEDED    = %STATUS_ARRAY_BOUNDS_EXCEEDED
%EXCEPTION_FLT_DENORMAL_OPERAND     = %STATUS_FLOAT_DENORMAL_OPERAND
%EXCEPTION_FLT_DIVIDE_BY_ZERO       = %STATUS_FLOAT_DIVIDE_BY_ZERO
%EXCEPTION_FLT_INEXACT_RESULT       = %STATUS_FLOAT_INEXACT_RESULT
%EXCEPTION_FLT_INVALID_OPERATION    = %STATUS_FLOAT_INVALID_OPERATION
%EXCEPTION_FLT_OVERFLOW             = %STATUS_FLOAT_OVERFLOW
%EXCEPTION_FLT_STACK_CHECK          = %STATUS_FLOAT_STACK_CHECK
%EXCEPTION_FLT_UNDERFLOW            = %STATUS_FLOAT_UNDERFLOW
%EXCEPTION_INT_DIVIDE_BY_ZERO       = %STATUS_INTEGER_DIVIDE_BY_ZERO
%EXCEPTION_INT_OVERFLOW             = %STATUS_INTEGER_OVERFLOW
%EXCEPTION_PRIV_INSTRUCTION         = %STATUS_PRIVILEGED_INSTRUCTION
%EXCEPTION_IN_PAGE_ERROR            = %STATUS_IN_PAGE_ERROR
%EXCEPTION_ILLEGAL_INSTRUCTION      = %STATUS_ILLEGAL_INSTRUCTION
%EXCEPTION_NONCONTINUABLE_EXCEPTION = %STATUS_NONCONTINUABLE_EXCEPTION
%EXCEPTION_STACK_OVERFLOW           = %STATUS_STACK_OVERFLOW
%EXCEPTION_INVALID_DISPOSITION      = %STATUS_INVALID_DISPOSITION
%EXCEPTION_GUARD_PAGE               = %STATUS_GUARD_PAGE_VIOLATION
%EXCEPTION_INVALID_HANDLE           = %STATUS_INVALID_HANDLE
%EXCEPTION_POSSIBLE_DEADLOCK        = %STATUS_POSSIBLE_DEADLOCK
%CONTROL_C_EXIT                     = %STATUS_CONTROL_C_EXIT

'//
'// File creation flags must start at the high end since they
'// are combined with the attributes
'//

%FILE_FLAG_WRITE_THROUGH       = &H80000000???
%FILE_FLAG_OVERLAPPED          = &H40000000???
%FILE_FLAG_NO_BUFFERING        = &H20000000???
%FILE_FLAG_RANDOM_ACCESS       = &H10000000???
%FILE_FLAG_SEQUENTIAL_SCAN     = &H08000000???
%FILE_FLAG_DELETE_ON_CLOSE     = &H04000000???
%FILE_FLAG_BACKUP_SEMANTICS    = &H02000000???
%FILE_FLAG_POSIX_SEMANTICS     = &H01000000???
%FILE_FLAG_OPEN_REPARSE_POINT  = &H00200000???
%FILE_FLAG_OPEN_NO_RECALL      = &H00100000???
%FILE_FLAG_FIRST_PIPE_INSTANCE = &H00080000???

%CREATE_NEW        = 1
%CREATE_ALWAYS     = 2
%OPEN_EXISTING     = 3
%OPEN_ALWAYS       = 4
%TRUNCATE_EXISTING = 5

'#if(_WIN32_WINNT >= 0x0400)
'//
'// Define possible return codes from the CopyFileEx callback routine
'//

%PROGRESS_CONTINUE = 0
%PROGRESS_CANCEL   = 1
%PROGRESS_STOP     = 2
%PROGRESS_QUIET    = 3

'//
'// Define CopyFileEx callback routine state change values
'//

%CALLBACK_CHUNK_FINISHED  = &H00000000???
%CALLBACK_STREAM_SWITCHED = &H00000001???

'//
'// Define CopyFileEx option flags
'//

%COPY_FILE_FAIL_IF_EXISTS              = &H00000001???
%COPY_FILE_RESTARTABLE                 = &H00000002???
%COPY_FILE_OPEN_SOURCE_FOR_WRITE       = &H00000004???
%COPY_FILE_ALLOW_DECRYPTED_DESTINATION = &H00000008???

'//
'//  Gap for private copyfile flags
'//

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600
%COPY_FILE_COPY_SYMLINK                = &H00000800???
#ENDIF

'#endif /* _WIN32_WINNT >= 0x0400 */

'#if (_WIN32_WINNT >= 0x0500)
'//
'// Define ReplaceFile option flags
'//

%REPLACEFILE_WRITE_THROUGH       = &H00000001???
%REPLACEFILE_IGNORE_MERGE_ERRORS = &H00000002???

'#endif // #if (_WIN32_WINNT >= 0x0500)

'//
'// Define the NamedPipe definitions
'//


'//
'// Define the dwOpenMode values for CreateNamedPipe
'//

%PIPE_ACCESS_INBOUND   = &H00000001???
%PIPE_ACCESS_OUTBOUND  = &H00000002???
%PIPE_ACCESS_DUPLEX    = &H00000003???

'//
'// Define the Named Pipe End flags for GetNamedPipeInfo
'//

%PIPE_CLIENT_END       = &H00000000???
%PIPE_SERVER_END       = &H00000001???

'//
'// Define the dwPipeMode values for CreateNamedPipe
'//

%PIPE_WAIT                  = &H00000000???
%PIPE_NOWAIT                = &H00000001???
%PIPE_READMODE_BYTE         = &H00000000???
%PIPE_READMODE_MESSAGE      = &H00000002???
%PIPE_TYPE_BYTE             = &H00000000???
%PIPE_TYPE_MESSAGE          = &H00000004???
%PIPE_ACCEPT_REMOTE_CLIENTS = &H00000000???
%PIPE_REJECT_REMOTE_CLIENTS = &H00000008???

'//
'// Define the well known values for CreateNamedPipe nMaxInstances
'//

%PIPE_UNLIMITED_INSTANCES = 255

'//
'// Define the Security Quality of Service bits to be passed
'// into CreateFile
'//

'#define SECURITY_ANONYMOUS          ( SecurityAnonymous      << 16 )
'#define SECURITY_IDENTIFICATION     ( SecurityIdentification << 16 )
'#define SECURITY_IMPERSONATION      ( SecurityImpersonation  << 16 )
'#define SECURITY_DELEGATION         ( SecurityDelegation     << 16 )

%SECURITY_ANONYMOUS        = 0???
%SECURITY_IDENTIFICATION   = &H00010000???
%SECURITY_IMPERSONATION    = &H00020000???
%SECURITY_DELEGATION       = &H00030000???

%SECURITY_CONTEXT_TRACKING = &H00040000???
%SECURITY_EFFECTIVE_ONLY   = &H00080000???

%SECURITY_SQOS_PRESENT     = &H00100000???
%SECURITY_VALID_SQOS_FLAGS = &H001F0000???

'//
'//  File structures
'//

TYPE OVERLAPPED_UNION_STRUCT
   Offset       AS DWORD   ' DWORD Offset
   OffsetHigh   AS DWORD   ' DWORD OffsetHigh
END TYPE

UNION OVERLAPPED_UNION
   OVERLAPPED_UNION_STRUCT
   Pointer AS DWORD        ' PVOID Pointer
END UNION

TYPE OVERLAPPED
   Internal          AS DWORD   ' ULONG_PTR Internal
   InternalHigh      AS DWORD   ' ULONG_PTR InternalHigh
   OVERLAPPED_UNION
   hEvent            AS DWORD   ' HANDLE  hEvent
END TYPE

TYPE OVERLAPPED_ENTRY
   lpCompletionKey            AS DWORD            ' ULONG_PTR
   lpOverlapped               AS OVERLAPPED PTR   ' LPOVERLAPPED
   Internal                   AS DWORD            ' ULONG_PTR
   dwNumberOfBytesTransferred AS DWORD            ' DWORD
END TYPE

#IF NOT %DEF(%SECURITY_ATTRIBUTES_DEFINED)
%SECURITY_ATTRIBUTES_DEFINED = 1
TYPE SECURITY_ATTRIBUTES
   nLength              AS DWORD   ' DWORD nLength
   lpSecurityDescriptor AS DWORD   ' LPVOID lpSecurityDescriptor
   bInheritHandle       AS LONG    ' BOOL bInheritHandle
END TYPE
#ENDIF

TYPE PROCESS_INFORMATION
   hProcess    AS DWORD   ' HANDLE hProcess
   hThread     AS DWORD   ' HANDLE hThread
   dwProcessId AS DWORD   ' DWORD dwProcessId
   dwThreadId  AS DWORD   ' DWORD dwThreadId
END TYPE

'//
'//  File System time stamps are represented with the following structure:
'//

#IF NOT %DEF(%FILETIME_DEFINED)
%FILETIME_DEFINED = 1
TYPE FILETIME
   dwLowDateTime  AS DWORD   ' DWORD dwLowDateTime
   dwHighDateTime AS DWORD   ' DWORD dwHighDateTime
END TYPE
#ENDIF

'//
'// System time is represented with the following structure:
'//

#IF NOT %DEF(%SYSTEMTIME_DEFINED)
%SYSTEMTIME_DEFINED = 1
TYPE SYSTEMTIME
   wYear         AS WORD   ' WORD wYear
   wMonth        AS WORD   ' WORD wMonth
   wDayOfWeek    AS WORD   ' WORD wDayOfWeek
   wDay          AS WORD   ' WORD wDay
   wHour         AS WORD   ' WORD wHour
   wMinute       AS WORD   ' WORD wMinute
   wSecond       AS WORD   ' WORD wSecond
   wMilliseconds AS WORD   ' WORD wMilliseconds
END TYPE
#ENDIF

'typedef DWORD (WINAPI *PTHREAD_START_ROUTINE)(
'    LPVOID lpThreadParameter
'    );
'typedef PTHREAD_START_ROUTINE LPTHREAD_START_ROUTINE;

'#if(_WIN32_WINNT >= 0x0400)
'typedef VOID (WINAPI *PFIBER_START_ROUTINE)(
'    LPVOID lpFiberParameter
'    );
'typedef PFIBER_START_ROUTINE LPFIBER_START_ROUTINE;
'#endif /* _WIN32_WINNT >= 0x0400 */

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600
'//
'// Define one-time initialization primitive
'//

'typedef RTL_RUN_ONCE INIT_ONCE;
'typedef PRTL_RUN_ONCE PINIT_ONCE;
'typedef PRTL_RUN_ONCE LPINIT_ONCE;

MACRO INIT_ONCE = RTL_RUN_ONCE

%INIT_ONCE_STATIC_INIT   = %RTL_RUN_ONCE_INIT

'//
'// Run once flags
'//

%INIT_ONCE_CHECK_ONLY        = %RTL_RUN_ONCE_CHECK_ONLY
%INIT_ONCE_ASYNC             = %RTL_RUN_ONCE_ASYNC
%INIT_ONCE_INIT_FAILED       = %RTL_RUN_ONCE_INIT_FAILED

'//
'// The context stored in the run once structure must leave the following number
'// of low order bits unused.
'//

%INIT_ONCE_CTX_RESERVED_BITS = %RTL_RUN_ONCE_CTX_RESERVED_BITS

'typedef
'BOOL
'(WINAPI *PINIT_ONCE_FN) (
'    __inout PINIT_ONCE InitOnce,
'    __inout_opt PVOID Parameter,
'    __deref_opt_out_opt PVOID *Context
'    );

'FUNCTION INIT_ONCE_FN ( _
'   BYREF INIT_ONCE _                   ' __inout PINIT_ONCE InitOnce
' , BYREF DWORD _                       ' __inout_opt PVOID Parameter
' , BYREF DWORD _                       ' __deref_opt_out_opt PVOID *Context
' ) AS LONG                             ' BOOL

DECLARE SUB InitOnceInitialize LIB "KERNEL32.DLL" ALIAS "InitOnceInitialize" ( _
   BYREF INIT_ONCE _                   ' __out PINIT_ONCE InitOnce
 )                                     ' VOID

DECLARE FUNCTION InitOnceExecuteOnce LIB "KERNEL32.DLL" ALIAS "InitOnceExecuteOnce" ( _
   BYREF INIT_ONCE _                   ' __inout PINIT_ONCE InitOnce
 , BYVAL DWORD _                       ' __in __callback PINIT_ONCE_FN InitFn
 , BYREF ANY _                         ' __inout_opt PVOID Parameter
 , BYREF DWORD _                       ' __deref_opt_out_opt LPVOID *Context
 ) AS LONG                             ' BOOL

DECLARE FUNCTION InitOnceBeginInitialize LIB "KERNEL32.DLL" ALIAS "InitOnceBeginInitialize" ( _
   BYREF INIT_ONCE _                   ' __inout LPINIT_ONCE lpInitOnce
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYREF LONG _                        ' __out PBOOL fPending
 , BYREF DWORD _                       ' __deref_opt_out_opt LPVOID *lpContext
 ) AS LONG                             ' BOOL

DECLARE FUNCTION InitOnceComplete LIB "KERNEL32.DLL" ALIAS "InitOnceComplete" ( _
   BYREF INIT_ONCE _                   ' __inout LPINIT_ONCE lpInitOnce
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in_opt LPVOID lpContext
 ) AS LONG                             ' BOOL

#ENDIF   ' #if (_WIN32_WINNT >= 0x0600)

'//
'// Define the slim r/w lock
'//

'typedef RTL_SRWLOCK SRWLOCK, *PSRWLOCK;
MACRO SRWLOCK = RTL_SRWLOCK

%SRWLOCK_INIT = %RTL_SRWLOCK_INIT

DECLARE SUB InitializeSRWLock LIB "KERNEL32.DLL" ALIAS "InitializeSRWLock" ( _
   BYREF SRWLOCK _                     ' __out PSRWLOCK SRWLock
 )                                     ' VOID

DECLARE SUB ReleaseSRWLockExclusive LIB "KERNEL32.DLL" ALIAS "ReleaseSRWLockExclusive" ( _
   BYREF SRWLOCK _                     ' __out PSRWLOCK SRWLock
 )                                     ' VOID

DECLARE SUB ReleaseSRWLockShared LIB "KERNEL32.DLL" ALIAS "ReleaseSRWLockShared" ( _
   BYREF SRWLOCK _                     ' __inout PSRWLOCK SRWLock
 )                                     ' VOID

DECLARE SUB AcquireSRWLockExclusive LIB "KERNEL32.DLL" ALIAS "AcquireSRWLockExclusive" ( _
   BYREF SRWLOCK _                     ' __inout PSRWLOCK SRWLock
 )                                     ' VOID

DECLARE SUB AcquireSRWLockShared LIB "KERNEL32.DLL" ALIAS "AcquireSRWLockShared" ( _
   BYREF SRWLOCK _                     ' __inout PSRWLOCK SRWLock
 )                                     ' VOID

'//
'// Define condition variable
'//

'typedef RTL_CONDITION_VARIABLE CONDITION_VARIABLE, *PCONDITION_VARIABLE;
MACRO CONDITION_VARIABLE = RTL_CONDITION_VARIABLE

DECLARE SUB InitializeConditionVariable LIB "KERNEL32.DLL" ALIAS "InitializeConditionVariable" ( _
   BYREF CONDITION_VARIABLE _          ' __out PCONDITION_VARIABLE ConditionVariable
 )                                     ' VOID

DECLARE SUB WakeConditionVariable LIB "KERNEL32.DLL" ALIAS "WakeConditionVariable" ( _
   BYREF CONDITION_VARIABLE _          ' __inout PCONDITION_VARIABLE ConditionVariable
 )                                     ' VOID

DECLARE SUB WakeAllConditionVariable LIB "KERNEL32.DLL" ALIAS "WakeAllConditionVariable" ( _
   BYREF CONDITION_VARIABLE _          ' __inout PCONDITION_VARIABLE ConditionVariable
 )                                     ' VOID

DECLARE FUNCTION SleepConditionVariableCS LIB "KERNEL32.DLL" ALIAS "SleepConditionVariableCS" ( _
   BYREF CONDITION_VARIABLE _          ' __inout PCONDITION_VARIABLE ConditionVariable
 , BYREF CRITICAL_SECTION _            ' __inout PCRITICAL_SECTION CriticalSection
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SleepConditionVariableSRW LIB "KERNEL32.DLL" ALIAS "SleepConditionVariableSRW" ( _
   BYREF CONDITION_VARIABLE _          ' __inout PCONDITION_VARIABLE ConditionVariable
 , BYREF SRWLOCK _                     ' __inout PSRWLOCK SRWLock
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 , BYVAL DWORD _                       ' __in ULONG Flags
 ) AS LONG                             ' BOOL

'//
'// Static initializer for the condition variable
'//

%CONDITION_VARIABLE_INIT = %RTL_CONDITION_VARIABLE_INIT

'//
'// Flags for condition variables
'//
%CONDITION_VARIABLE_LOCKMODE_SHARED = %RTL_CONDITION_VARIABLE_LOCKMODE_SHARED

DECLARE FUNCTION EncodePointer LIB "KERNEL32.DLL" ALIAS "EncodePointer" ( _
   BYVAL DWORD _                       ' __in_opt PVOID Ptr
 ) AS DWORD                            ' PVOID

DECLARE FUNCTION DecodePointer LIB "KERNEL32.DLL" ALIAS "DecodePointer" ( _
   BYVAL DWORD _                       ' __in_opt PVOID Ptr
 ) AS DWORD                            ' PVOID

DECLARE FUNCTION EncodeSystemPointer LIB "KERNEL32.DLL" ALIAS "EncodeSystemPointer" ( _
   BYVAL DWORD _                       ' __in_opt PVOID Ptr
 ) AS DWORD                            ' PVOID

DECLARE FUNCTION DecodeSystemPointer LIB "KERNEL32.DLL" ALIAS "DecodeSystemPointer" ( _
   BYVAL DWORD _                       ' __in_opt PVOID Ptr
 ) AS DWORD                            ' PVOID

'#if defined(_X86_)
'typedef PLDT_ENTRY LPLDT_ENTRY;
'#else
'typedef LPVOID LPLDT_ENTRY;
'#endif

%MUTEX_MODIFY_STATE = %MUTANT_QUERY_STATE
%MUTEX_ALL_ACCESS   = %MUTANT_ALL_ACCESS

'//
'// Serial provider type.
'//

%SP_SERIALCOMM      = &H00000001???

'//
'// Provider SubTypes
'//

%PST_UNSPECIFIED    = &H00000000???
%PST_RS232          = &H00000001???
%PST_PARALLELPORT   = &H00000002???
%PST_RS422          = &H00000003???
%PST_RS423          = &H00000004???
%PST_RS449          = &H00000005???
%PST_FAX            = &H00000021???
%PST_SCANNER        = &H00000022???
%PST_NETWORK_BRIDGE = &H00000100???
%PST_LAT            = &H00000101???
%PST_TCPIP_TELNET   = &H00000102???
%PST_X25            = &H00000103???

'//
'// Provider capabilities flags.
'//

%PCF_DTRDSR        = &H0001???
%PCF_RTSCTS        = &H0002???
%PCF_RLSD          = &H0004???
%PCF_PARITY_CHECK  = &H0008???
%PCF_XONXOFF       = &H0010???
%PCF_SETXCHAR      = &H0020???
%PCF_TOTALTIMEOUTS = &H0040???
%PCF_INTTIMEOUTS   = &H0080???
%PCF_SPECIALCHARS  = &H0100???
%PCF_16BITMODE     = &H0200???

'//
'// Comm provider settable parameters.
'//

%SP_PARITY         = &H0001???
%SP_BAUD           = &H0002???
%SP_DATABITS       = &H0004???
%SP_STOPBITS       = &H0008???
%SP_HANDSHAKING    = &H0010???
%SP_PARITY_CHECK   = &H0020???
%SP_RLSD           = &H0040???

'//
'// Settable baud rates in the provider.
'//

%BAUD_075          = &H00000001???
%BAUD_110          = &H00000002???
%BAUD_134_5        = &H00000004???
%BAUD_150          = &H00000008???
%BAUD_300          = &H00000010???
%BAUD_600          = &H00000020???
%BAUD_1200         = &H00000040???
%BAUD_1800         = &H00000080???
%BAUD_2400         = &H00000100???
%BAUD_4800         = &H00000200???
%BAUD_7200         = &H00000400???
%BAUD_9600         = &H00000800???
%BAUD_14400        = &H00001000???
%BAUD_19200        = &H00002000???
%BAUD_38400        = &H00004000???
%BAUD_56K          = &H00008000???
%BAUD_128K         = &H00010000???
%BAUD_115200       = &H00020000???
%BAUD_57600        = &H00040000???
%BAUD_USER         = &H10000000???

'//
'// Settable Data Bits
'//

%DATABITS_5        = &H0001??
%DATABITS_6        = &H0002??
%DATABITS_7        = &H0004??
%DATABITS_8        = &H0008??
%DATABITS_16       = &H0010??
%DATABITS_16X      = &H0020??

'//
'// Settable Stop and Parity bits.
'//

%STOPBITS_10       = &H0001??
%STOPBITS_15       = &H0002??
%STOPBITS_20       = &H0004??
%PARITY_NONE       = &H0100??
%PARITY_ODD        = &H0200??
%PARITY_EVEN       = &H0400??
%PARITY_MARK       = &H0800??
%PARITY_SPACE      = &H1000??

TYPE COMMPROP
   wPacketLength       AS WORD       ' WORD wPacketLength
   wPacketVersion      AS WORD       ' WORD wPacketVersion
   dwServiceMask       AS DWORD      ' DWORD dwServiceMask
   dwReserved1         AS DWORD      ' DWORD dwReserved1
   dwMaxTxQueue        AS DWORD      ' DWORD dwMaxTxQueue
   dwMaxRxQueue        AS DWORD      ' DWORD dwMaxRxQueue
   dwMaxBaud           AS DWORD      ' DWORD dwMaxBaud
   dwProvSubType       AS DWORD      ' DWORD dwProvSubType
   dwProvCapabilities  AS DWORD      ' DWORD dwProvCapabilities
   dwSettableParams    AS DWORD      ' DWORD dwSettableParams
   dwSettableBaud      AS DWORD      ' DWORD dwSettableBaud
   wSettableData       AS WORD       ' WORD wSettableData
   wSettableStopParity AS WORD       ' WORD wSettableStopParity
   dwCurrentTxQueue    AS DWORD      ' DWORD dwCurrentTxQueue
   dwCurrentRxQueue    AS DWORD      ' DWORD dwCurrentRxQueue
   dwProvSpec1         AS DWORD      ' DWORD dwProvSpec1
   dwProvSpec2         AS DWORD      ' DWORD dwProvSpec2
   wcProvChar(0)       AS WORD       ' WCHAR wcProvChar[1] ' any size
END TYPE

'//
'// Set dwProvSpec1 to COMMPROP_INITIALIZED to indicate that wPacketLength
'// is valid before a call to GetCommProperties().
'//
%COMMPROP_INITIALIZED = &HE73CF52E???

TYPE COMSTAT
   fCtsHold  AS BIT * 1 IN DWORD   ' DWORD fCtsHold : 1
   fDsrHold  AS BIT * 1            ' DWORD fDsrHold : 1
   fRlsdHold AS BIT * 1            ' DWORD fRlsdHold : 1
   fXoffHold AS BIT * 1            ' DWORD fXoffHold : 1
   fXoffSent AS BIT * 1            ' DWORD fXoffSent : 1
   fEof      AS BIT * 1            ' DWORD fEof : 1
   fTxim     AS BIT * 1            ' DWORD fTxim : 1
   fReserved AS BIT * 25           ' DWORD fReserved : 25
   cbInQue   AS DWORD              ' DWORD cbInQue
   cbOutQue  AS DWORD              ' DWORD cbOutQue
END TYPE

'//
'// DTR Control Flow Values.
'//
%DTR_CONTROL_DISABLE   = &H00???
%DTR_CONTROL_ENABLE    = &H01???
%DTR_CONTROL_HANDSHAKE = &H02???

'//
'// RTS Control Flow Values
'//
%RTS_CONTROL_DISABLE   = &H00???
%RTS_CONTROL_ENABLE    = &H01???
%RTS_CONTROL_HANDSHAKE = &H02???
%RTS_CONTROL_TOGGLE    = &H03???

TYPE DCB
   DCBlength         AS DWORD               ' DWORD DCBlength;      /* sizeof(DCB)                     */
   BaudRate          AS DWORD               ' DWORD BaudRate;       /* Baudrate at which running       */
   fBinary           AS BIT * 1  IN DWORD   ' DWORD fBinary: 1;     /* Binary Mode (skip EOF check)    */
   fParity           AS BIT * 1             ' DWORD fParity: 1;     /* Enable parity checking          */
   fOutxCtsFlow      AS BIT * 1             ' DWORD fOutxCtsFlow:1; /* CTS handshaking on output       */
   fOutxDsrFlow      AS BIT * 1             ' DWORD fOutxDsrFlow:1; /* DSR handshaking on output       */
   fDtrControl       AS BIT * 2             ' DWORD fDtrControl:2;  /* DTR Flow control                */
   fDsrSensitivity   AS BIT * 1             ' DWORD fDsrSensitivity:1; /* DSR Sensitivity              */
   fTXContinueOnXoff AS BIT * 1             ' DWORD fTXContinueOnXoff: 1; /* Continue TX when Xoff sent */
   fOutX             AS BIT * 1             ' DWORD fOutX: 1;       /* Enable output X-ON/X-OFF        */
   fInX              AS BIT * 1             ' DWORD fInX: 1;        /* Enable input X-ON/X-OFF         */
   fErrorChar        AS BIT * 1             ' DWORD fErrorChar: 1;  /* Enable Err Replacement          */
   fNull             AS BIT * 1             ' DWORD fNull: 1;       /* Enable Null stripping           */
   fRtsControl       AS BIT * 2             ' DWORD fRtsControl:2;  /* Rts Flow control                */
   fAbortOnError     AS BIT * 1             ' DWORD fAbortOnError:1; /* Abort all reads and writes on Error */
   fDummy2           AS BIT * 17            ' DWORD fDummy2:17;     /* Reserved                        */
   wReserved         AS WORD                ' WORD wReserved;       /* Not currently used              */
   XonLim            AS WORD                ' WORD XonLim;          /* Transmit X-ON threshold         */
   XoffLim           AS WORD                ' WORD XoffLim;         /* Transmit X-OFF threshold        */
   ByteSize          AS BYTE                ' BYTE ByteSize;        /* Number of bits/byte, 4-8        */
   Parity            AS BYTE                ' BYTE Parity;          /* 0-4=None,Odd,Even,Mark,Space    */
   StopBits          AS BYTE                ' BYTE StopBits;        /* 0,1,2 = 1, 1.5, 2               */
   XonChar           AS BYTE                ' char XonChar;         /* Tx and Rx X-ON character        */
   XoffChar          AS BYTE                ' char XoffChar;        /* Tx and Rx X-OFF character       */
   ErrorChar         AS BYTE                ' char ErrorChar;       /* Error replacement char          */
   EofChar           AS BYTE                ' char EofChar;         /* End of Input character          */
   EvtChar           AS BYTE                ' char EvtChar;         /* Received Event character        */
   wReserved2        AS WORD                ' WORD wReserved1;      /* Fill for now.                   */
END TYPE

TYPE COMMTIMEOUTS
   ReadIntervalTimeout         AS DWORD   ' DWORD ReadIntervalTimeout;          /* Maximum time between read chars. */
   ReadTotalTimeoutMultiplier  AS DWORD   ' DWORD ReadTotalTimeoutMultiplier;   /* Multiplier of characters.        */
   ReadTotalTimeoutConstant    AS DWORD   ' DWORD ReadTotalTimeoutConstant;     /* Constant in milliseconds.        */
   WriteTotalTimeoutMultiplier AS DWORD   ' DWORD WriteTotalTimeoutMultiplier;  /* Multiplier of characters.        */
   WriteTotalTimeoutConstant   AS DWORD   ' DWORD WriteTotalTimeoutConstant;    /* Constant in milliseconds.        */
END TYPE

TYPE COMMCONFIG
   dwSize            AS DWORD      ' DWORD dwSize;               /* Size of the entire struct */
   wVersion          AS WORD       ' WORD wVersion;              /* version of the structure */
   wReserved         AS WORD       ' WORD wReserved;             /* alignment */
   dcbx              AS DCB        ' DCB dcb;                    /* device control block */
   dwProviderSubType AS DWORD      ' DWORD dwProviderSubType;    /* ordinal value for identifying
                                   '                                provider-defined data structure format*/
   dwProviderOffset  AS DWORD      ' DWORD dwProviderOffset;     /* Specifies the offset of provider specific
                                   '                                data field in bytes from the start */
   dwProviderSize    AS DWORD      ' DWORD dwProviderSize;       /* size of the provider-specific data field */
   wcProviderData(0) AS WORD       ' WCHAR wcProviderData[1];    /* provider-specific data */ any size
END TYPE

TYPE SYSTEM_INFO_UNION_STRUCT
   wProcessorArchitecture AS WORD   ' WORD wProcessorArchitecture
   wReserved              AS WORD   ' WORD wReserved
END TYPE

UNION SYSTEM_INFO_UNION
   dwOemId AS DWORD   ' DWORD dwOemId;          // Obsolete field...do not use
END UNION

TYPE SYSTEM_INFO
   SYSTEM_INFO_UNION
   dwPageSize                  AS DWORD   ' DWORD dwPageSize
   lpMinimumApplicationAddress AS DWORD   ' LPVOID lpMinimumApplicationAddress
   lpMaximumApplicationAddress AS DWORD   ' LPVOID lpMaximumApplicationAddress
   dwActiveProcessorMask       AS DWORD   ' DWORD_PTR dwActiveProcessorMask
   dwNumberOfProcessors        AS DWORD   ' DWORD dwNumberOfProcessors;
   dwProcessorType             AS DWORD   ' DWORD dwProcessorType
   dwAllocationGranularity     AS DWORD   ' DWORD dwAllocationGranularity
   wProcessorLevel             AS WORD    ' WORD wProcessorLevel
   wProcessorRevision          AS WORD    ' WORD wProcessorRevision
END TYPE


'//
'//

'#define FreeModule(hLibModule) FreeLibrary((hLibModule))
'#define MakeProcInstance(lpProc,hInstance) (lpProc)
'#define FreeProcInstance(lpProc) (lpProc)

'/* Global Memory Flags */
%GMEM_FIXED          = &H0000???
%GMEM_MOVEABLE       = &H0002???
%GMEM_NOCOMPACT      = &H0010???
%GMEM_NODISCARD      = &H0020???
%GMEM_ZEROINIT       = &H0040???
%GMEM_MODIFY         = &H0080???
%GMEM_DISCARDABLE    = &H0100???
%GMEM_NOT_BANKED     = &H1000???
%GMEM_SHARE          = &H2000???
%GMEM_DDESHARE       = &H2000???
%GMEM_NOTIFY         = &H4000???
%GMEM_LOWER          = %GMEM_NOT_BANKED
%GMEM_VALID_FLAGS    = &H7F72???
%GMEM_INVALID_HANDLE = &H00008000???

%GHND = %GMEM_MOVEABLE OR %GMEM_ZEROINIT
%GPTR = %GMEM_FIXED OR %GMEM_ZEROINIT

'#define GlobalLRUNewest( h )    ((HANDLE)(h))
'#define GlobalLRUOldest( h )    ((HANDLE)(h))
'#define GlobalDiscard( h )      GlobalReAlloc( (h), 0, GMEM_MOVEABLE )

'/* Flags returned by GlobalFlags (in addition to GMEM_DISCARDABLE) */
%GMEM_DISCARDED = &H4000???
%GMEM_LOCKCOUNT = &H00FF???

TYPE MEMORYSTATUS
   dwLength        AS DWORD   ' DWORD dwLength
   dwMemoryLoad    AS DWORD   ' DWORD dwMemoryLoad
   dwTotalPhys     AS DWORD   ' SIZE_T dwTotalPhys
   dwAvailPhys     AS DWORD   ' SIZE_T dwAvailPhys
   dwTotalPageFile AS DWORD   ' SIZE_T dwTotalPageFile
   dwAvailPageFile AS DWORD   ' SIZE_T dwAvailPageFile
   dwTotalVirtual  AS DWORD   ' SIZE_T dwTotalVirtual
   dwAvailVirtual  AS DWORD   ' SIZE_T dwAvailVirtual
END TYPE

'/* Local Memory Flags */
%LMEM_FIXED          = &H0000???
%LMEM_MOVEABLE       = &H0002???
%LMEM_NOCOMPACT      = &H0010???
%LMEM_NODISCARD      = &H0020???
%LMEM_ZEROINIT       = &H0040???
%LMEM_MODIFY         = &H0080???
%LMEM_DISCARDABLE    = &H0F00???
%LMEM_VALID_FLAGS    = &H0F72???
%LMEM_INVALID_HANDLE = &H8000???

%LHND = %LMEM_MOVEABLE + %LMEM_ZEROINIT
%LPTR = %LMEM_FIXED + %LMEM_ZEROINIT

%NONZEROLHND  = %LMEM_MOVEABLE
%NONZEROLPTR  = %LMEM_FIXED

'#define LocalDiscard( h )   LocalReAlloc( (h), 0, LMEM_MOVEABLE )

'/* Flags returned by LocalFlags (in addition to LMEM_DISCARDABLE) */
%LMEM_DISCARDED      = &H4000???
%LMEM_LOCKCOUNT      = &H00FF???

'//
'// NUMA values
'//
%NUMA_NO_PREFERRED_NODE = &HFFFFFFFF???   ' ((DWORD) -1)

'//
'// dwCreationFlag values
'//

%DEBUG_PROCESS                     = &H00000001???
%DEBUG_ONLY_THIS_PROCESS           = &H00000002???

%CREATE_SUSPENDED                  = &H00000004???

%DETACHED_PROCESS                  = &H00000008???

%CREATE_NEW_CONSOLE                = &H00000010???

%NORMAL_PRIORITY_CLASS             = &H00000020???
%IDLE_PRIORITY_CLASS               = &H00000040???
%HIGH_PRIORITY_CLASS               = &H00000080???
%REALTIME_PRIORITY_CLASS           = &H00000100???

%CREATE_NEW_PROCESS_GROUP          = &H00000200???
%CREATE_UNICODE_ENVIRONMENT        = &H00000400???

%CREATE_SEPARATE_WOW_VDM           = &H00000800???
%CREATE_SHARED_WOW_VDM             = &H00001000???
%CREATE_FORCEDOS                   = &H00002000???

%BELOW_NORMAL_PRIORITY_CLASS       = &H00004000???
%ABOVE_NORMAL_PRIORITY_CLASS       = &H00008000???

%STACK_SIZE_PARAM_IS_A_RESERVATION = &H00010000???
%INHERIT_CALLER_PRIORITY           = &H00020000???

%CREATE_PROTECTED_PROCESS          = &H00040000???

%EXTENDED_STARTUPINFO_PRESENT      = &H00080000???

%PROCESS_MODE_BACKGROUND_BEGIN     = &H00100000???
%PROCESS_MODE_BACKGROUND_END       = &H00200000???

%CREATE_BREAKAWAY_FROM_JOB         = &H01000000???
%CREATE_PRESERVE_CODE_AUTHZ_LEVEL  = &H02000000???

%CREATE_DEFAULT_ERROR_MODE         = &H04000000???
%CREATE_NO_WINDOW                  = &H08000000???

%PROFILE_USER                      = &H10000000???
%PROFILE_KERNEL                    = &H20000000???
%PROFILE_SERVER                    = &H40000000???

%CREATE_IGNORE_SYSTEM_DEFAULT      = &H80000000???

%THREAD_PRIORITY_LOWEST        = %THREAD_BASE_PRIORITY_MIN
%THREAD_PRIORITY_BELOW_NORMAL  = %THREAD_PRIORITY_LOWEST + 1
%THREAD_PRIORITY_NORMAL        = 0
%THREAD_PRIORITY_HIGHEST       = %THREAD_BASE_PRIORITY_MAX
%THREAD_PRIORITY_ABOVE_NORMAL  = %THREAD_PRIORITY_HIGHEST - 1
%THREAD_PRIORITY_ERROR_RETURN  = %MAXLONG

%THREAD_PRIORITY_TIME_CRITICAL = %THREAD_BASE_PRIORITY_LOWRT
%THREAD_PRIORITY_IDLE          = %THREAD_BASE_PRIORITY_IDLE

%THREAD_MODE_BACKGROUND_BEGIN  = &H00010000???
%THREAD_MODE_BACKGROUND_END    = &H00020000???

'//
'// GetFinalPathNameByHandle
'//

%VOLUME_NAME_DOS  = &H0     ' //default
%VOLUME_NAME_GUID = &H1
%VOLUME_NAME_NT   = &H2
%VOLUME_NAME_NONE = &H4

%FILE_NAME_NORMALIZED = &H0   ' //default
%FILE_NAME_OPENED     = &H8

'//
'// Debug APIs
'//
%EXCEPTION_DEBUG_EVENT      = 1
%CREATE_THREAD_DEBUG_EVENT  = 2
%CREATE_PROCESS_DEBUG_EVENT = 3
%EXIT_THREAD_DEBUG_EVENT    = 4
%EXIT_PROCESS_DEBUG_EVENT   = 5
%LOAD_DLL_DEBUG_EVENT       = 6
%UNLOAD_DLL_DEBUG_EVENT     = 7
%OUTPUT_DEBUG_STRING_EVENT  = 8
%RIP_EVENT                  = 9

TYPE EXCEPTION_DEBUG_INFO
  ExceptionRecord AS EXCEPTION_RECORD   ' EXCEPTION_RECORD ExceptionRecord
  dwFirstChange   AS DWORD              ' DWORD dwFirstChance
END TYPE

TYPE CREATE_THREAD_DEBUG_INFO
   hThread           AS DWORD   ' HANDLE hThread
   lpThreadLocalBase AS DWORD   ' LPVOID lpThreadLocalBase
   lpStartAddress    AS DWORD   ' LPTHREAD_START_ROUTINE lpStartAddress
END TYPE

TYPE CREATE_PROCESS_DEBUG_INFO
   hFile                 AS DWORD       ' HANDLE hFile
   hProcess              AS DWORD       ' HANDLE hProcess
   hThread               AS DWORD       ' HANDLE hThread
   lpBaseOfImage         AS DWORD       ' LPVOID lpBaseOfImage
   dwDebugInfoFileOffset AS DWORD       ' DWORD dwDebugInfoFileOffset
   nDebugInfoSize        AS DWORD       ' DWORD nDebugInfoSize
   lpThreadLocalBase     AS DWORD       ' LPVOID lpThreadLocalBase
   lpStartAddress        AS DWORD       ' LPTHREAD_START_ROUTINE lpStartAddress
   lpImageName           AS DWORD PTR   ' LPVOID lpImageName
   fUnicode              AS WORD        ' WORD fUnicode
END TYPE

TYPE EXIT_THREAD_DEBUG_INFO
   dwExitCode AS DWORD   ' DWORD dwExitCode
END TYPE

TYPE EXIT_PROCESS_DEBUG_INFO
   dwExitCode AS DWORD   ' DWORD dwExitCode
END TYPE

TYPE LOAD_DLL_DEBUG_INFO
   hFile                 AS DWORD        ' HANDLE hFile
   lpBaseOfDll           AS LONG         ' LPVOID lpBaseOfDll
   dwDebugInfoFileOffset AS DWORD        ' DWORD dwDebugInfoFileOffset
   nDebugInfoSize        AS DWORD        ' DWORD nDebugInfoSize;
   lpImageName           AS ASCIIZ PTR   ' LPVOID lpImageName
   fUnicode              AS WORD         ' WORD fUnicode
END TYPE

TYPE UNLOAD_DLL_DEBUG_INFO
   lpBaseOfDll AS LONG   ' LPVOID lpBaseOfDll
END TYPE

TYPE OUTPUT_DEBUG_STRING_INFO
   lpDebugStringData  AS ASCIIZ PTR   ' LPSTR lpDebugStringData
   fUnicode           AS WORD         ' WORD fUnicode
   nDebugStringLength AS WORD         ' WORD nDebugStringLength
END TYPE

TYPE RIP_INFO
   dwError AS DWORD   ' DWORD dwError
   dwType  AS DWORD   ' DWORD dwType
END TYPE

UNION DEBUGEVENTUNION
   deuException         AS EXCEPTION_DEBUG_INFO        ' EXCEPTION_DEBUG_INFO Exception
   deuCreateThread      AS CREATE_THREAD_DEBUG_INFO    ' CREATE_THREAD_DEBUG_INFO CreateThread
   deuCreateProcessInfo AS CREATE_PROCESS_DEBUG_INFO   ' CREATE_PROCESS_DEBUG_INFO CreateProcessInfo
   deuExitThread        AS EXIT_THREAD_DEBUG_INFO      ' EXIT_THREAD_DEBUG_INFO ExitThread
   deuExitProcess       AS EXIT_PROCESS_DEBUG_INFO     ' EXIT_PROCESS_DEBUG_INFO ExitProcess
   deuLoadDll           AS LOAD_DLL_DEBUG_INFO         ' LOAD_DLL_DEBUG_INFO LoadDll
   deuUnloadDll         AS UNLOAD_DLL_DEBUG_INFO       ' UNLOAD_DLL_DEBUG_INFO UnloadDll
   deuDebugString       AS OUTPUT_DEBUG_STRING_INFO    ' OUTPUT_DEBUG_STRING_INFO DebugString
   deuRipInfo           AS RIP_INFO                    ' RIP_INFO RipInfo
END UNION

TYPE DEBUG_EVENT
   dwDebugEventCode AS DWORD   ' DWORD dwDebugEventCode
   dwProcessId      AS DWORD   ' DWORD dwProcessId
   dwThreadId       AS DWORD   ' DWORD dwThreadId
   DEBUGEVENTUNION
END TYPE

'//
'// JIT Debugging Info. This structure is defined to have constant size in
'// both the emulated and native environment.
'//

TYPE JIT_DEBUG_INFO
   dwSize                  AS DWORD   ' DWORD
   dwProcessorArchitecture AS DWORD   ' DWORD
   dwThreadID              AS DWORD   ' DWORD
   dwReserved0             AS DWORD   ' DWORD
   lpExceptionAddress      AS QUAD    ' ULONG64
   lpExceptionRecord       AS QUAD    ' ULONG64
   lpContextRecord         AS QUAD    ' ULONG64
END TYPE

%DRIVE_UNKNOWN     = 0
%DRIVE_NO_ROOT_DIR = 1
%DRIVE_REMOVABLE   = 2
%DRIVE_FIXED       = 3
%DRIVE_REMOTE      = 4
%DRIVE_CDROM       = 5
%DRIVE_RAMDISK     = 6

'#ifndef _MAC
'#define GetFreeSpace(w)                 (0x100000L)
'#else
'WINBASEAPI DWORD WINAPI GetFreeSpace(__in UINT);
'#endif

%FILE_TYPE_UNKNOWN = &H0000???
%FILE_TYPE_DISK    = &H0001???
%FILE_TYPE_CHAR    = &H0002???
%FILE_TYPE_PIPE    = &H0003???
%FILE_TYPE_REMOTE  = &H8000???

%STD_INPUT_HANDLE  = &HFFFFFFF6???   ' ((DWORD)-10)
%STD_OUTPUT_HANDLE = &HFFFFFFF5???   ' ((DWORD)-11)
%STD_ERROR_HANDLE  = &HFFFFFFF4???   ' ((DWORD)-12)

%NOPARITY    = 0
%ODDPARITY   = 1
%EVENPARITY  = 2
%MARKPARITY  = 3
%SPACEPARITY = 4

%ONESTOPBIT   = 0
%ONE5STOPBITS = 1
%TWOSTOPBITS  = 2

%IGNORE   = 0               ' Ignore signal
%INFINITE = &HFFFFFFFF???   ' Infinite timeout

'//
'// Baud rates at which the communication device operates
'//

%CBR_110      = 110
%CBR_300      = 300
%CBR_600      = 600
%CBR_1200     = 1200
%CBR_2400     = 2400
%CBR_4800     = 4800
%CBR_9600     = 9600
%CBR_14400    = 14400
%CBR_19200    = 19200
%CBR_38400    = 38400
%CBR_56000    = 56000
%CBR_57600    = 57600
%CBR_115200   = 115200
%CBR_128000   = 128000
%CBR_256000   = 256000

'//
'// Error Flags
'//

%CE_RXOVER   = &H0001???    ' Receive Queue overflow
%CE_OVERRUN  = &H0002???    ' Receive Overrun Error
%CE_RXPARITY = &H0004???    ' Receive Parity Error
%CE_FRAME    = &H0008???    ' Receive Framing error
%CE_BREAK    = &H0010???    ' Break Detected
%CE_TXFULL   = &H0100???    ' TX Queue is full
%CE_PTO      = &H0200???    ' LPTx Timeout
%CE_IOE      = &H0400???    ' LPTx I/O Error
%CE_DNS      = &H0800???    ' LPTx Device not selected
%CE_OOP      = &H1000???    ' LPTx Out-Of-Paper
%CE_MODE     = &H8000???    ' Requested mode unsupported

%IE_BADID    = -1        ' Invalid or unsupported id
%IE_OPEN     = -2        ' Device Already Open
%IE_NOPEN    = -3        ' Device Not Open
%IE_MEMORY   = -4        ' Unable to allocate queues
%IE_DEFAULT  = -5        ' Error in default parameters
%IE_HARDWARE = -10       ' Hardware Not Present
%IE_BYTESIZE = -11       ' Illegal Byte Size
%IE_BAUDRATE = -12       ' Unsupported BaudRate

'//
'// Events
'//

%EV_RXCHAR   = &H0001???    ' Any Character received
%EV_RXFLAG   = &H0002???    ' Received certain character
%EV_TXEMPTY  = &H0004???    ' Transmitt Queue Empty
%EV_CTS      = &H0008???    ' CTS changed state
%EV_DSR      = &H0010???    ' DSR changed state
%EV_RLSD     = &H0020???    ' RLSD changed state
%EV_BREAK    = &H0040???    ' BREAK received
%EV_ERR      = &H0080???    ' Line status error occurred
%EV_RING     = &H0100???    ' Ring signal detected
%EV_PERR     = &H0200???    ' Printer error occured
%EV_RX80FULL = &H0400???    ' Receive buffer is 80 percent full
%EV_EVENT1   = &H0800???    ' Provider specific event 1
%EV_EVENT2   = &H1000???    ' Provider specific event 2

'//
'// Escape Functions
'//

%SETXOFF  = 1         ' Simulate XOFF received
%SETXON   = 2         ' Simulate XON received
%SETRTS   = 3         ' Set RTS high
%CLRRTS   = 4         ' Set RTS low
%SETDTR   = 5         ' Set DTR high
%CLRDTR   = 6         ' Set DTR low
%RESETDEV = 7         ' Reset device if possible
%SETBREAK = 8         ' Set the device break line
%CLRBREAK = 9         ' Clear the device break line

'//
'// PURGE function flags.
'//
%PURGE_TXABORT = &H0001???       ' Kill the pending/current writes to the comm port.
%PURGE_RXABORT = &H0002???       ' Kill the pending/current reads to the comm port.
%PURGE_TXCLEAR = &H0004???       ' Kill the transmit queue if there.
%PURGE_RXCLEAR = &H0008???       ' Kill the typeahead buffer if there.

'#define LPTx                0x80    // Set if ID is for LPT device

%LPTx = &H80      ' Set if ID is for LPT device

'//
'// Modem Status Flags
'//
%MS_CTS_ON  = &H0010???
%MS_DSR_ON  = &H0020???
%MS_RING_ON = &H0040???
%MS_RLSD_ON = &H0080???

'//
'// WaitSoundState() Constants
'//

%S_QUEUEEMPTY   = 0
%S_THRESHOLD    = 1
%S_ALLTHRESHOLD = 2

'//
'// Accent Modes
'//

%S_NORMAL       = 0
%S_LEGATO       = 1
%S_STACCATO     = 2

'//
'// SetSoundNoise() Sources
'//

%S_PERIOD512    = 0   ' Freq = N/512 high pitch, less coarse hiss
%S_PERIOD1024   = 1   ' Freq = N/1024
%S_PERIOD2048   = 2   ' Freq = N/2048 low pitch, more coarse hiss
%S_PERIODVOICE  = 3   ' Source is frequency from voice channel (3)
%S_WHITE512     = 4   ' Freq = N/512 high pitch, less coarse hiss
%S_WHITE1024    = 5   ' Freq = N/1024
%S_WHITE2048    = 6   ' Freq = N/2048 low pitch, more coarse hiss
%S_WHITEVOICE   = 7   ' Source is frequency from voice channel (3)

%S_SERDVNA      = -1  ' Device not available
%S_SEROFM       = -2  ' Out of memory
%S_SERMACT      = -3  ' Music active
%S_SERQFUL      = -4  ' Queue full
%S_SERBDNT      = -5  ' Invalid note
%S_SERDLN       = -6  ' Invalid note length
%S_SERDCC       = -7  ' Invalid note count
%S_SERDTP       = -8  ' Invalid tempo
%S_SERDVL       = -9  ' Invalid volume
%S_SERDMD       = -10 ' Invalid mode
%S_SERDSH       = -11 ' Invalid shape
%S_SERDPT       = -12 ' Invalid pitch
%S_SERDFQ       = -13 ' Invalid frequency
%S_SERDDR       = -14 ' Invalid duration
%S_SERDSR       = -15 ' Invalid source
%S_SERDST       = -16 ' Invalid state

%NMPWAIT_WAIT_FOREVER      = &HFFFFFFFF???
%NMPWAIT_NOWAIT            = &H00000001???
%NMPWAIT_USE_DEFAULT_WAIT  = &H00000000???

%FS_CASE_IS_PRESERVED      = %FILE_CASE_PRESERVED_NAMES
%FS_CASE_SENSITIVE         = %FILE_CASE_SENSITIVE_SEARCH
%FS_UNICODE_STORED_ON_DISK = %FILE_UNICODE_ON_DISK
%FS_PERSISTENT_ACLS        = %FILE_PERSISTENT_ACLS
%FS_VOL_IS_COMPRESSED      = %FILE_VOLUME_IS_COMPRESSED
%FS_FILE_COMPRESSION       = %FILE_FILE_COMPRESSION
%FS_FILE_ENCRYPTION        = %FILE_SUPPORTS_ENCRYPTION

%FILE_MAP_COPY       = %SECTION_QUERY
%FILE_MAP_WRITE      = %SECTION_MAP_WRITE
%FILE_MAP_READ       = %SECTION_MAP_READ
%FILE_MAP_ALL_ACCESS = %SECTION_ALL_ACCESS
%FILE_MAP_EXECUTE    = %SECTION_MAP_EXECUTE_EXPLICIT   ' // not included in FILE_MAP_ALL_ACCESS

%OF_READ             = &H00000000???
%OF_WRITE            = &H00000001???
%OF_READWRITE        = &H00000002???
%OF_SHARE_COMPAT     = &H00000000???
%OF_SHARE_EXCLUSIVE  = &H00000010???
%OF_SHARE_DENY_WRITE = &H00000020???
%OF_SHARE_DENY_READ  = &H00000030???
%OF_SHARE_DENY_NONE  = &H00000040???
%OF_PARSE            = &H00000100???
%OF_DELETE           = &H00000200???
%OF_VERIFY           = &H00000400???
%OF_CANCEL           = &H00000800???
%OF_CREATE           = &H00001000???
%OF_PROMPT           = &H00002000???
%OF_EXIST            = &H00004000???
%OF_REOPEN           = &H00008000???

%OFS_MAXPATHNAME = 128

TYPE OFSTRUCT
   cBytes     AS BYTE                        ' BYTE cBytes
   fFixedDisk AS BYTE                        ' BYTE fFixedDisk
   nErrCode   AS WORD                        ' WORD nErrCode
   Reserved1  AS WORD                        ' WORD Reserved1
   Reserved2  AS WORD                        ' WORD Reserved2
   szPathName AS ASCIIZ * %OFS_MAXPATHNAME   ' CHAR szPathName[OFS_MAXPATHNAME]
END TYPE

#IF NOT %DEF(%NOWINBASEINTERLOCK) ' -------------------------------------------

#IF NOT %DEF(%NTOS) ' ---------------------------------------------------------

DECLARE FUNCTION InterlockedIncrement LIB "KERNEL32.DLL" ALIAS "InterlockedIncrement" ( _
   BYREF LONG _                        ' __inout LONG volatile *Addend
 ) AS LONG                             ' LONG

DECLARE FUNCTION InterlockedDecrement LIB "KERNEL32.DLL" ALIAS "InterlockedDecrement" ( _
   BYREF LONG _                        ' __inout LONG volatile *Addend
 ) AS LONG                             ' LONG

DECLARE FUNCTION InterlockedExchange LIB "KERNEL32.DLL" ALIAS "InterlockedExchange" ( _
   BYREF LONG _                        ' __inout LONG volatile *Target
 , BYVAL LONG _                        ' __in    LONG Value
 ) AS LONG                             ' LONG

'#define InterlockedExchangePointer(Target, Value) \
'    (PVOID)InterlockedExchange((PLONG)(Target), (LONG)(Value))

'FUNCTION InterlockedExchangePointer (BYREF pTarget AS LONG, BYVAL nValue AS LONG) AS LONG
'   FUNCTION = InterlockedExchange(pTarget, nValue)
'END FUNCTION

DECLARE FUNCTION InterlockedExchangeAdd LIB "KERNEL32.DLL" ALIAS "InterlockedExchangeAdd" ( _
   BYREF LONG _                        ' __inout LONG volatile *Addend
 , BYVAL LONG _                        ' __in    LONG Value
 ) AS LONG                             ' LONG

DECLARE FUNCTION InterlockedCompareExchange LIB "KERNEL32.DLL" ALIAS "InterlockedCompareExchange" ( _
   BYREF LONG _                        ' __inout LONG volatile *Destination
 , BYVAL LONG _                        ' __in    LONG ExChange
 , BYVAL LONG _                        ' __in    LONG Comperand
 ) AS LONG                             ' LONG

'#if (_WIN32_WINNT >= 0x0502)

DECLARE FUNCTION InterlockedCompareExchange64 LIB "KERNEL32.DLL" ALIAS "InterlockedCompareExchange64" ( _
   BYREF QUAD _                        ' __inout LONGLONG volatile *Destination
 , BYVAL QUAD _                        ' __in    LONGLONG ExChange
 , BYVAL QUAD _                        ' __in    LONGLONG Comperand
 ) AS LONG                             ' LONG

'#endif

DECLARE SUB InitializeSListHead LIB "KERNEL32.DLL" ALIAS "InitializeSListHead" ( _
   BYREF SLIST_HEADER _                ' __inout PSLIST_HEADER ListHead
 )                                     ' VOID

DECLARE FUNCTION InterlockedPopEntrySList LIB "KERNEL32.DLL" ALIAS "InterlockedPopEntrySList" ( _
   BYREF SLIST_HEADER _                ' __inout PSLIST_HEADER ListHead
 ) AS DWORD                            ' PSLIST_ENTRY

DECLARE FUNCTION InterlockedPushEntrySList LIB "KERNEL32.DLL" ALIAS "InterlockedPushEntrySList" ( _
   BYREF SLIST_HEADER, _               ' __inout PSLIST_HEADER ListHead
   BYREF SLIST_ENTRY _                 ' __inout PSLIST_ENTRY ListEntry
 ) AS DWORD                            ' PSLIST_ENTRY

DECLARE FUNCTION InterlockedFlushSList LIB "KERNEL32.DLL" ALIAS "InterlockedFlushSList" ( _
   BYREF SLIST_HEADER _                ' __inout PSLIST_HEADER ListHead
 ) AS DWORD                            ' PSLIST_ENTRY

DECLARE FUNCTION QueryDepthSList LIB "KERNEL32.DLL" ALIAS "QueryDepthSList" ( _
   BYREF SLIST_HEADER _                ' __inout PSLIST_HEADER ListHead
 ) AS WORD                             ' USHORT

#ENDIF   ' #IF NOT %DEF(%NTOS) ------------------------------------------------

#ENDIF   ' #IF NOT %DEF(%NOWINBASEINTERLOCK) ----------------------------------

DECLARE FUNCTION FreeResource LIB "KERNEL32.DLL" ALIAS "FreeResource" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hResData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LockResource LIB "KERNEL32.DLL" ALIAS "LockResource" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hResData
 ) AS DWORD                            ' LPVOID

'#define UnlockResource(hResData) ((hResData), 0)
'#define MAXINTATOM 0xC000
'#define MAKEINTATOM(i)  (LPTSTR)((ULONG_PTR)((WORD)(i)))
'#define INVALID_ATOM ((ATOM)0)

%MAXINTATOM   = &HC000??
%INVALID_ATOM = 0??

DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" ( _
   BYVAL DWORD _                       ' __in HMODULE hLibModule
 ) AS LONG                             ' BOOL

DECLARE SUB FreeLibraryAndExitThread LIB "KERNEL32.DLL" ALIAS "FreeLibraryAndExitThread" ( _
   BYVAL DWORD _                       ' __in HMODULE hLibModule
 , BYVAL DWORD _                       ' __in DWORD dwExitCode
 )                                     ' VOID

DECLARE FUNCTION DisableThreadLibraryCalls LIB "KERNEL32.DLL" ALIAS "DisableThreadLibraryCalls" ( _
   BYVAL DWORD _                       ' __in HMODULE hLibModule
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" ( _
   BYVAL DWORD _                       ' __in HMODULE hModule
 , BYREF ASCIIZ _                      ' __in LPCSTR lpProcName
 ) AS LONG                             ' FARPROC

DECLARE FUNCTION GetVersion LIB "KERNEL32.DLL" ALIAS "GetVersion" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GlobalAlloc LIB "KERNEL32.DLL" ALIAS "GlobalAlloc" ( _
   BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in SIZE_T dwBytes
 ) AS DWORD                            ' HGLOBAL

DECLARE FUNCTION GlobalReAlloc LIB "KERNEL32.DLL" ALIAS "GlobalReAlloc" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
 , BYVAL DWORD _                       ' __in SIZE_T dwBytes
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS DWORD                            ' HGLOBAL

DECLARE FUNCTION GlobalSize LIB "KERNEL32.DLL" ALIAS "GlobalSize" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION GlobalFlags LIB "KERNEL32.DLL" ALIAS "GlobalFlags" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GlobalLock LIB "KERNEL32.DLL" ALIAS "GlobalLock" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION GlobalHandle LIB "KERNEL32.DLL" ALIAS "GlobalHandle" ( _
   BYVAL DWORD _                       ' __in LPCVOID pMem
 ) AS DWORD                            ' HGLOBAL

DECLARE FUNCTION GlobalUnlock LIB "KERNEL32.DLL" ALIAS "GlobalUnlock" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GlobalFree LIB "KERNEL32.DLL" ALIAS "GlobalFree" ( _
   BYVAL DWORD _                       ' __deref HGLOBAL hMem
 ) AS DWORD                            ' HGLOBAL

DECLARE FUNCTION GlobalCompact LIB "KERNEL32.DLL" ALIAS "GlobalCompact" ( _
   BYVAL DWORD _                       ' __in DWORD dwMinFree
 ) AS DWORD                            ' SIZE_T

DECLARE SUB GlobalFix LIB "KERNEL32.DLL" ALIAS "GlobalFix" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
 )                                     ' VOID

DECLARE SUB GlobalUnfix LIB "KERNEL32.DLL" ALIAS "GlobalUnfix" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
 )                                     ' VOID

DECLARE FUNCTION GlobalWire LIB "KERNEL32.DLL" ALIAS "GlobalWire" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
   ) AS LONG                           ' LPVOID

DECLARE FUNCTION GlobalUnWire LIB "KERNEL32.DLL" ALIAS "GlobalUnWire" ( _
   BYVAL DWORD _                       ' __in HGLOBAL hMem
 ) AS LONG                             ' BOOL

DECLARE SUB GlobalMemoryStatus LIB "KERNEL32.DLL" ALIAS "GlobalMemoryStatus" ( _
   BYREF MEMORYSTATUS _                ' __out LPMEMORYSTATUS lpBuffer
 )                                     ' VOID

TYPE MEMORYSTATUSEX
   dwLength                AS DWORD   ' DWORD dwLength
   dwMemoryLoad            AS DWORD   ' DWORD dwMemoryLoad
   ullTotalPhys            AS QUAD    ' DWORDLONG ullTotalPhys
   ullAvailPhys            AS QUAD    ' DWORDLONG ullAvailPhys
   ullTotalPageFile        AS QUAD    ' DWORDLONG ullTotalPageFile
   ullAvailPageFile        AS QUAD    ' DWORDLONG ullAvailPageFile
   ullTotalVirtual         AS QUAD    ' DWORDLONG ullTotalVirtual
   ullAvailVirtual         AS QUAD    ' DWORDLONG ullAvailVirtual
   ullAvailExtendedVirtual AS QUAD    ' DWORDLONG ullAvailExtendedVirtual
END TYPE

DECLARE FUNCTION GlobalMemoryStatusEx LIB "KERNEL32.DLL" ALIAS "GlobalMemoryStatusEx" ( _
   BYREF MEMORYSTATUSEX _              ' __out LPMEMORYSTATUSEX lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LocalAlloc LIB "KERNEL32.DLL" ALIAS "LocalAlloc" ( _
   BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in SIZE_T uBytes
 ) AS DWORD                            ' HLOCAL

DECLARE FUNCTION LocalReAlloc LIB "KERNEL32.DLL" ALIAS "LocalReAlloc" ( _
   BYVAL DWORD _                       ' __in HLOCAL hMem
 , BYVAL DWORD _                       ' __in SIZE_T uBytes
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS DWORD                            ' HLOCAL

DECLARE FUNCTION LocalLock LIB "KERNEL32.DLL" ALIAS "LocalLock" ( _
   BYVAL DWORD _                       ' __in HLOCAL hMem
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION LocalHandle LIB "KERNEL32.DLL" ALIAS "LocalHandle" ( _
   BYVAL DWORD _                       ' __in LPCVOID pMem
 ) AS DWORD                            ' HLOCAL

DECLARE FUNCTION LocalUnlock LIB "KERNEL32.DLL" ALIAS "LocalUnlock" ( _
   BYVAL DWORD _                       ' __in HLOCAL hMem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LocalSize LIB "KERNEL32.DLL" ALIAS "LocalSize" ( _
   BYVAL DWORD _                       ' __in HLOCAL hMem
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION LocalFlags LIB "KERNEL32.DLL" ALIAS "LocalFlags" ( _
   BYVAL DWORD _                       ' __in HLOCAL hMem
 ) AS DWORD                            ' UINT

DECLARE FUNCTION LocalFree LIB "KERNEL32.DLL" ALIAS "LocalFree" ( _
   BYVAL DWORD _                       ' __deref HLOCAL hMem
 ) AS DWORD                            ' HLOCAL

DECLARE FUNCTION LocalShrink LIB "KERNEL32.DLL" ALIAS "LocalShrink" ( _
   BYVAL DWORD _                       ' __in HLOCAL hMem
 , BYVAL DWORD _                       ' __in UINT cbNewSize
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION LocalCompact LIB "KERNEL32.DLL" ALIAS "LocalCompact" ( _
   BYVAL DWORD _                       ' __in UINT uMinFree
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION FlushInstructionCache LIB "KERNEL32.DLL" ALIAS "FlushInstructionCache" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in_bcount_opt(dwSize) LPCVOID lpBaseAddress
 , BYVAL DWORD _                       ' __in SIZE_T dwSize
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE SUB FlushProcessWriteBuffers LIB "KERNEL32.DLL" ALIAS "FlushProcessWriteBuffers" ( _
 )                                     ' VOID

DECLARE FUNCTION QueryThreadCycleTime LIB "KERNEL32.DLL" ALIAS "QueryThreadCycleTime" ( _
   BYVAL DWORD _                       ' __in HANDLE ThreadHandle
 , BYREF QUAD _                        ' __out PULONG64 CycleTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION QueryProcessCycleTime LIB "KERNEL32.DLL" ALIAS "QueryProcessCycleTime" ( _
   BYVAL DWORD _                       ' __in HANDLE ProcessHandle
 , BYREF QUAD _                        ' __out PULONG64 CycleTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION QueryIdleProcessorCycleTime LIB "KERNEL32.DLL" ALIAS "QueryIdleProcessorCycleTime" ( _
   BYREF QUAD _                        ' __inout PULONG BufferLength
 , BYREF QUAD _                        ' __out_bcount_opt(*BufferLength) PULONG64 ProcessorIdleCycleTime
 ) AS LONG                             ' BOOL

#ENDIF   ' #if (_WIN32_WINNT >= 0x0600)

DECLARE FUNCTION VirtualAlloc LIB "KERNEL32.DLL" ALIAS "VirtualAlloc" ( _
   BYVAL DWORD _                       ' __in_opt LPVOID lpAddress
 , BYVAL DWORD _                       ' __in     SIZE_T dwSize
 , BYVAL DWORD _                       ' __in     DWORD flAllocationType
 , BYVAL DWORD _                       ' __in     DWORD flProtect
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION VirtualFree LIB "KERNEL32.DLL" ALIAS "VirtualFree" ( _
   BYVAL DWORD _                       ' __in LPVOID lpAddress
 , BYVAL DWORD _                       ' __in SIZE_T dwSize
 , BYVAL DWORD _                       ' __in DWORD dwFreeType
 ) AS LONG                             ' BOOL

DECLARE FUNCTION VirtualProtect LIB "KERNEL32.DLL" ALIAS "VirtualProtect" ( _
   BYVAL DWORD _                       ' __in  LPVOID lpAddress
 , BYVAL DWORD _                       ' __in  SIZE_T dwSize
 , BYVAL DWORD _                       ' __in  DWORD flNewProtect
 , BYREF DWORD _                       ' __out PDWORD lpflOldProtect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION VirtualQuery LIB "KERNEL32.DLL" ALIAS "VirtualQuery" ( _
   BYVAL DWORD _                       ' __in_opt LPCVOID lpAddress
 , BYREF MEMORY_BASIC_INFORMATION _    ' __out_bcount_part(dwLength, return) PMEMORY_BASIC_INFORMATION lpBuffer
 , BYVAL DWORD _                       ' __in     SIZE_T dwLength
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION VirtualAllocEx LIB "KERNEL32.DLL" ALIAS "VirtualAllocEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE hProcess
 , BYVAL DWORD _                       ' __in_opt LPVOID lpAddress
 , BYVAL DWORD _                       ' __in     SIZE_T dwSize
 , BYVAL DWORD _                       ' __in     DWORD flAllocationType
 , BYVAL DWORD _                       ' __in     DWORD flProtect
 ) AS DWORD                            ' LPVOID

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION VirtualAllocExNuma LIB "KERNEL32.DLL" ALIAS "VirtualAllocExNuma" ( _
   BYVAL DWORD _                       ' __in     HANDLE hProcess
 , BYVAL DWORD _                       ' __in_opt LPVOID lpAddress
 , BYVAL DWORD _                       ' __in     SIZE_T dwSize
 , BYVAL DWORD _                       ' __in     DWORD  flAllocationType
 , BYVAL DWORD _                       ' __in     DWORD  flProtect
 , BYVAL DWORD _                       ' __in     DWORD  nndPreferred
 ) AS DWORD                            ' LPVOID

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION GetWriteWatch LIB "KERNEL32.DLL" ALIAS "GetWriteWatch" ( _
   BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in PVOID lpBaseAddress
 , BYVAL DWORD _                       ' __in SIZE_T dwRegionSize
 , BYREF ANY _                         ' __out_ecount_part(*lpdwCount, *lpdwCount) PVOID *lpAddresses
 , BYREF DWORD _                       ' __inout ULONG_PTR *lpdwCount
 , BYREF DWORD _                       ' __out PULONG lpdwGranularity
 ) AS DWORD                            ' UINT

DECLARE FUNCTION ResetWriteWatch LIB "KERNEL32.DLL" ALIAS "ResetWriteWatch" ( _
   BYVAL DWORD _                       ' __in LPVOID lpBaseAddress
 , BYVAL DWORD _                       ' __in SIZE_T dwRegionSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetLargePageMinimum LIB "KERNEL32.DLL" ALIAS "GetLargePageMinimum" ( _
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION EnumSystemFirmwareTables LIB "KERNEL32.DLL" ALIAS "EnumSystemFirmwareTables" ( _
   BYVAL DWORD _                       ' __in DWORD FirmwareTableProviderSignature
 , BYREF ANY _                         ' __out_bcount_part_opt(BufferSize, return) PVOID pFirmwareTableEnumBuffer
 , BYVAL DWORD _                       ' __in DWORD BufferSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetSystemFirmwareTable LIB "KERNEL32.DLL" ALIAS "GetSystemFirmwareTable" ( _
   BYVAL DWORD _                       ' __in DWORD FirmwareTableProviderSignature
 , BYVAL DWORD _                       ' __in DWORD FirmwareTableID
 , BYREF ANY _                         ' __out_bcount_part_opt(BufferSize, return) PVOID pFirmwareTableBuffer
 , BYVAL DWORD _                       ' __in DWORD BufferSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION VirtualFreeEx LIB "KERNEL32.DLL" ALIAS "VirtualFreeEx" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in LPVOID lpAddress
 , BYVAL DWORD _                       ' __in SIZE_T dwSize
 , BYVAL DWORD _                       ' __in DWORD  dwFreeType
 ) AS LONG                             ' BOOL

DECLARE FUNCTION VirtualProtectEx LIB "KERNEL32.DLL" ALIAS "VirtualProtectEx" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYVAL DWORD _                       ' __in  LPVOID lpAddress
 , BYVAL DWORD _                       ' __in  SIZE_T dwSize
 , BYVAL DWORD _                       ' __in  DWORD flNewProtect
 , BYREF DWORD _                       ' __out PDWORD lpflOldProtect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION VirtualQueryEx LIB "KERNEL32.DLL" ALIAS "VirtualQueryEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE hProcess
 , BYVAL DWORD _                       ' __in_opt LPCVOID lpAddress
 , BYREF MEMORY_BASIC_INFORMATION _    ' __out_bcount_part(dwLength, return) PMEMORY_BASIC_INFORMATION lpBuffer
 , BYVAL DWORD _                       ' __in     SIZE_T dwLength
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION HeapCreate LIB "KERNEL32.DLL" ALIAS "HeapCreate" ( _
   BYVAL DWORD _                       ' __in DWORD flOptions
 , BYVAL DWORD _                       ' __in SIZE_T dwInitialSize
 , BYVAL DWORD _                       ' __in SIZE_T dwMaximumSize
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION HeapDestroy LIB "KERNEL32.DLL" ALIAS "HeapDestroy" ( _
   BYVAL DWORD _                       ' __in HANDLE hHeap
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HeapAlloc LIB "KERNEL32.DLL" ALIAS "HeapAlloc" ( _
   BYVAL DWORD _                       ' __in HANDLE hHeap
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in SIZE_T dwBytes
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION HeapReAlloc LIB "KERNEL32.DLL" ALIAS "HeapReAlloc" ( _
   BYVAL DWORD _                       ' __inout HANDLE hHeap
 , BYVAL DWORD _                       ' __in    DWORD dwFlags
 , BYVAL DWORD _                       ' __deref LPVOID lpMem
 , BYVAL DWORD _                       ' __in    SIZE_T dwBytes
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION HeapFree LIB "KERNEL32.DLL" ALIAS "HeapFree" ( _
   BYVAL DWORD _                       ' __inout HANDLE hHeap
 , BYVAL DWORD _                       ' __in    DWORD dwFlags
 , BYVAL DWORD _                       ' __deref LPVOID lpMem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HeapSize LIB "KERNEL32.DLL" ALIAS "HeapSize" ( _
   BYVAL DWORD _                       ' __in HANDLE hHeap
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in LPCVOID lpMem
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION HeapValidate LIB "KERNEL32.DLL" ALIAS "HeapValidate" ( _
   BYVAL DWORD _                       ' __in     HANDLE hHeap
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in_opt LPCVOID lpMem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HeapCompact LIB "KERNEL32.DLL" ALIAS "HeapCompact" ( _
   BYVAL DWORD _                       ' __in HANDLE hHeap
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' SIZE_T

DECLARE FUNCTION GetProcessHeap LIB "KERNEL32.DLL" ALIAS "GetProcessHeap" ( _
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetProcessHeaps LIB "KERNEL32.DLL" ALIAS "GetProcessHeaps" ( _
   BYVAL DWORD _                       ' __in DWORD NumberOfHeaps
 , BYREF DWORD _                       ' __out_ecount_part(NumberOfHeaps, return) PHANDLE ProcessHeaps
 ) AS DWORD                            ' DWORD

TYPE PROCESS_HEAP_ENTRY_Block
   hMem          AS DWORD
   dwReserved(2) AS DWORD
END TYPE

TYPE PROCESS_HEAP_ENTRY_Region
   dwCommittedSize   AS DWORD
   dwUnCommittedSize AS DWORD
   lpFirstBlock      AS DWORD
   lpLastBlock       AS DWORD
END TYPE

UNION PROCESS_HEAP_ENTRY_UNION
   PROCESS_HEAP_ENTRY_Block
   PROCESS_HEAP_ENTRY_Region
END UNION

TYPE PROCESS_HEAP_ENTRY
   lpData       AS DWORD
   cbData       AS DWORD
   cbOverhead   AS BYTE
   iRegionIndex AS BYTE
   wFlags       AS WORD
   PROCESS_HEAP_ENTRY_UNION
END TYPE

%PROCESS_HEAP_REGION            = &H0001??
%PROCESS_HEAP_UNCOMMITTED_RANGE = &H0002??
%PROCESS_HEAP_ENTRY_BUSY        = &H0004??
%PROCESS_HEAP_ENTRY_MOVEABLE    = &H0010??
%PROCESS_HEAP_ENTRY_DDESHARE    = &H0020??

DECLARE FUNCTION HeapLock LIB "KERNEL32.DLL" ALIAS "HeapLock" ( _
   BYVAL DWORD _                       ' __in HANDLE hHeap
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HeapUnlock LIB "KERNEL32.DLL" ALIAS "HeapUnlock" ( _
   BYVAL DWORD _                       ' __in HANDLE hHeap
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HeapWalk LIB "KERNEL32.DLL" ALIAS "HeapWalk" ( _
   BYVAL DWORD _                       ' __in    HANDLE hHeap
 , BYREF PROCESS_HEAP_ENTRY _          ' __inout LPPROCESS_HEAP_ENTRY lpEntry
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HeapSetInformation LIB "KERNEL32.DLL" ALIAS "HeapSetInformation" ( _
   BYVAL DWORD _                       ' __in HANDLE HeapHandle
 , BYVAL LONG _                        ' __in HEAP_INFORMATION_CLASS HeapInformationClass
 , BYREF ANY _                         ' __in_bcount_opt(HeapInformationLength) PVOID HeapInformation
 , BYVAL DWORD _                       ' __in SIZE_T HeapInformationLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HeapQueryInformation LIB "KERNEL32.DLL" ALIAS "HeapQueryInformation" ( _
   BYVAL DWORD _                       ' __in      HANDLE HeapHandle
 , BYVAL LONG _                        ' __in      HEAP_INFORMATION_CLASS HeapInformationClass
 , BYREF ANY _                         ' __out_bcount_part_opt(HeapInformationLength, *ReturnLength) PVOID HeapInformation,
 , BYVAL DWORD _                       ' __in      SIZE_T HeapInformationLength,
 , BYREF DWORD _                       ' __out_opt PSIZE_T ReturnLength
 ) AS LONG                             ' BOOL

'// GetBinaryType return values.

%SCS_32BIT_BINARY = 0
%SCS_DOS_BINARY   = 1
%SCS_WOW_BINARY   = 2
%SCS_PIF_BINARY   = 3
%SCS_POSIX_BINARY = 4
%SCS_OS216_BINARY = 5
%SCS_64BIT_BINARY = 6


'#if defined(_WIN64)
'# define SCS_THIS_PLATFORM_BINARY SCS_64BIT_BINARY
'#else
'# define SCS_THIS_PLATFORM_BINARY SCS_32BIT_BINARY
'#endif

DECLARE FUNCTION GetBinaryType LIB "KERNEL32.DLL" ALIAS "GetBinaryTypeA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpApplicationName
 , BYREF DWORD _                       ' __out LPDWORD  lpBinaryType
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetBinaryTypeW LIB "KERNEL32.DLL" ALIAS "GetBinaryTypeW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpApplicationName
 , BYREF DWORD _                       ' __out LPDWORD  lpBinaryType
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetShortPathName LIB "KERNEL32.DLL" ALIAS "GetShortPathNameA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszLongPath
 , BYREF ASCIIZ _                      ' __out_ecount_part(cchBuffer, return + 1) LPSTR  lpszShortPath
 , BYVAL DWORD _                       ' __in DWORD cchBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetShortPathNameW LIB "KERNEL32.DLL" ALIAS "GetShortPathNameW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszLongPath
 , BYVAL DWORD _                       ' __out_ecount_part(cchBuffer, return + 1) LPWSTR  lpszShortPath
 , BYVAL DWORD _                       ' __in DWORD cchBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetLongPathName LIB "KERNEL32.DLL" ALIAS "GetLongPathNameA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszShortPath
 , BYREF ASCIIZ _                      ' __out_ecount_part(cchBuffer, return + 1) LPSTR  lpszLongPath
 , BYVAL DWORD _                       ' __in DWORD cchBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetLongPathNameW LIB "KERNEL32.DLL" ALIAS "GetLongPathNameW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszShortPath
 , BYVAL DWORD _                       ' __out_ecount_part(cchBuffer, return + 1) LPWSTR  lpszLongPath
 , BYVAL DWORD _                       ' __in DWORD cchBuffer
 ) AS DWORD                            ' DWORD

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION GetLongPathNameTransacted LIB "KERNEL32.DLL" ALIAS "GetLongPathNameTransactedA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpszShortPath
 , BYREF ASCIIZ _                      ' __out_ecount_part(cchBuffer, return + 1) LPSTR  lpszLongPath
 , BYVAL DWORD _                       ' __in     DWORD cchBuffer
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetLongPathNameTransactedW LIB "KERNEL32.DLL" ALIAS "GetLongPathNameTransactedW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpszShortPath
 , BYVAL DWORD _                       ' __out_ecount_part(cchBuffer, return + 1) LPWSTR  lpszLongPath
 , BYVAL DWORD _                       ' __in     DWORD cchBuffer
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS DWORD                            ' DWORD

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION GetProcessAffinityMask LIB "KERNEL32.DLL" ALIAS "GetProcessAffinityMask" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF DWORD _                       ' __out PDWORD_PTR lpProcessAffinityMask
 , BYREF DWORD _                       ' __out PDWORD_PTR lpSystemAffinityMask
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetProcessAffinityMask LIB "KERNEL32.DLL" ALIAS "SetProcessAffinityMask" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in DWORD_PTR dwProcessAffinityMask
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0501

DECLARE FUNCTION GetProcessHandleCount LIB "KERNEL32.DLL" ALIAS "GetProcessHandleCount" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF DWORD _                       ' __out PDWORD pdwHandleCount
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION GetProcessTimes LIB "KERNEL32.DLL" ALIAS "GetProcessTimes" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF FILETIME _                    ' __out LPFILETIME lpCreationTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpExitTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpKernelTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpUserTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcessIoCounters LIB "KERNEL32.DLL" ALIAS "GetProcessIoCounters" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF DWORD _                       ' __out PIO_COUNTERS lpIoCounters
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcessWorkingSetSize LIB "KERNEL32.DLL" ALIAS "GetProcessWorkingSetSize" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF DWORD _                       ' __out PSIZE_T lpMinimumWorkingSetSize
 , BYREF DWORD _                       ' __out PSIZE_T lpMaximumWorkingSetSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcessWorkingSetSizeEx LIB "KERNEL32.DLL" ALIAS "GetProcessWorkingSetSizeEx" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF DWORD _                       ' __out PSIZE_T lpMinimumWorkingSetSize
 , BYREF DWORD _                       ' __out PSIZE_T lpMaximumWorkingSetSize
 , BYREF DWORD _                       ' __out PDWORD Flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetProcessWorkingSetSize LIB "KERNEL32.DLL" ALIAS "SetProcessWorkingSetSize" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in SIZE_T dwMinimumWorkingSetSize
 , BYVAL DWORD _                       ' __in SIZE_T dwMaximumWorkingSetSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetProcessWorkingSetSizeEx LIB "KERNEL32.DLL" ALIAS "SGetProcessWorkingSetSizeEx" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in SIZE_T dwMinimumWorkingSetSize
 , BYVAL DWORD _                       ' __in SIZE_T dwMaximumWorkingSetSize
 , BYVAL DWORD _                       ' __in DWORD Flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OpenProcess LIB "KERNEL32.DLL" ALIAS "OpenProcess" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in DWORD dwProcessId
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetCurrentProcess LIB "KERNEL32.DLL" ALIAS "GetCurrentProcess" ( _
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetCurrentProcessId LIB "KERNEL32.DLL" ALIAS "GetCurrentProcessId" ( _
 ) AS DWORD                            ' DWORD

DECLARE SUB ExitProcess LIB "KERNEL32.DLL" ALIAS "ExitProcess" ( _
   BYVAL DWORD _                       ' __in UINT uExitCode
 )                                     ' VOID

DECLARE FUNCTION TerminateProcess LIB "KERNEL32.DLL" ALIAS "TerminateProcess" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in UINT uExitCode
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetExitCodeProcess LIB "KERNEL32.DLL" ALIAS "GetExitCodeProcess" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF DWORD _                       ' __out LPDWORD lpExitCode
 ) AS LONG                             ' BOOL

DECLARE SUB FatalExit LIB "KERNEL32.DLL" ALIAS "FatalExit" ( _
   BYVAL LONG _                        ' __in int ExitCode
 )                                     ' VOID

DECLARE FUNCTION GetEnvironmentStrings LIB "KERNEL32.DLL" ALIAS "GetEnvironmentStringsA" ( _
 ) AS DWORD                            ' LPCH

DECLARE FUNCTION GetEnvironmentStringsW LIB "KERNEL32.DLL" ALIAS "GetEnvironmentStringsW" ( _
 ) AS DWORD                            ' LPWCH

' *** It is not in the export list of kernel32.dll ***
'WINBASEAPI
'BOOL
'WINAPI
'SetEnvironmentStringsA(
'    __in __nullnullterminated LPCH NewEnvironment
'    );

'DECLARE FUNCTION SetEnvironmentStrings _
'   LIB "KERNEL32.DLL" ALIAS "SetEnvironmentStringsA" ( _
'   BYREF ASCIIZ _
'   ) AS LONG

' *** It is not in the export list of kernel32.dll ***
'WINBASEAPI
'BOOL
'WINAPI
'SetEnvironmentStringsW(
'    __in __nullnullterminated LPWCH NewEnvironment
'    );

'DECLARE FUNCTION SetEnvironmentStringsW _
'   LIB "KERNEL32.DLL" ALIAS "SetEnvironmentStringsW" ( _
'   BYVAL DWORD _
'   ) AS LONG

DECLARE FUNCTION FreeEnvironmentStrings LIB "KERNEL32.DLL" ALIAS "FreeEnvironmentStringsA" ( _
   BYREF ASCIIZ _                      ' __in __nullnullterminated LPCH
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FreeEnvironmentStringsW LIB "KERNEL32.DLL" ALIAS "FreeEnvironmentStringsW" ( _
   BYVAL DWORD _                       ' __in __nullnullterminated LPWCH
 ) AS LONG                             ' BOOL

DECLARE SUB RaiseException LIB "KERNEL32.DLL" ALIAS "RaiseException" ( _
   BYVAL DWORD _                       ' __in DWORD dwExceptionCode
 , BYVAL DWORD _                       ' __in DWORD dwExceptionFlags
 , BYVAL DWORD _                       ' __in DWORD nNumberOfArguments
 , BYREF DWORD _                       ' __in_ecount_opt(nNumberOfArguments) CONST ULONG_PTR *lpArguments
 )                                     ' VOID

'__callback
'WINBASEAPI
'LONG
'WINAPI
'UnhandledExceptionFilter(
'    __in struct _EXCEPTION_POINTERS *ExceptionInfo
'    );

'FUNCTION UnhandledExceptionFilter _
'   BYREF EXCEPTION_POINTERS _          ' __in struct _EXCEPTION_POINTERS *ExceptionInfo
' ) AS LONG                             ' LONG

'typedef LONG (WINAPI *PTOP_LEVEL_EXCEPTION_FILTER)(
'    __in struct _EXCEPTION_POINTERS *ExceptionInfo
'    );
'typedef PTOP_LEVEL_EXCEPTION_FILTER LPTOP_LEVEL_EXCEPTION_FILTER;

DECLARE FUNCTION SetUnhandledExceptionFilter LIB "KERNEL32.DLL" ALIAS "SetUnhandledExceptionFilter" ( _
   BYVAL DWORD _                       ' __in LPTOP_LEVEL_EXCEPTION_FILTER lpTopLevelExceptionFilter
 ) AS DWORD                            ' LPTOP_LEVEL_EXCEPTION_FILTER

'#if(_WIN32_WINNT >= 0x0400)

'//
'// Fiber creation flags
'//

%FIBER_FLAG_FLOAT_SWITCH = &H1???    ' // context switch floating point

DECLARE FUNCTION CreateFiber LIB "KERNEL32.DLL" ALIAS "CreateFiber" ( _
   BYVAL DWORD _                       ' __in     SIZE_T dwStackSize
 , BYVAL DWORD _                       ' __in     LPFIBER_START_ROUTINE lpStartAddress
 , BYVAL DWORD _                       ' __in_opt LPVOID lpParameter
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION CreateFiberEx LIB "KERNEL32.DLL" ALIAS "CreateFiberEx" ( _
   BYVAL DWORD _                       ' __in     SIZE_T dwStackCommitSize
 , BYVAL DWORD _                       ' __in     SIZE_T dwStackReserveSize
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in     LPFIBER_START_ROUTINE lpStartAddress
 , BYVAL DWORD _                       ' __in_opt LPVOID lpParameter
 ) AS DWORD                            ' LPVOID

DECLARE SUB DeleteFiber LIB "KERNEL32.DLL" ALIAS "DeleteFiber" ( _
   BYVAL DWORD _                       ' __in LPVOID lpFiber
 )                                     ' VOID

DECLARE FUNCTION ConvertThreadToFiber LIB "KERNEL32.DLL" ALIAS "ConvertThreadToFiber" ( _
   BYVAL DWORD _                       ' __in_opt LPVOID lpParameter
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION ConvertThreadToFiberEx LIB "KERNEL32.DLL" ALIAS "ConvertThreadToFiberEx" ( _
   BYVAL DWORD _                       ' __in_opt LPVOID lpParameter
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 ) AS DWORD                            ' LPVOID

'#if (_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION ConvertFiberToThread LIB "KERNEL32.DLL" ALIAS "ConvertFiberToThread" ( _
 ) AS LONG                             ' BOOL

'#endif

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE FUNCTION IsThreadAFiber LIB "KERNEL32.DLL" ALIAS "IsThreadAFiber" ( _
 ) AS LONG                             ' BOOL

#ENDIF

DECLARE SUB SwitchToFiber LIB "KERNEL32.DLL" ALIAS "SwitchToFiber" ( _
   BYVAL DWORD _                       ' __in LPVOID lpFiber
 )                                     ' VOID

DECLARE FUNCTION SwitchToThread LIB "KERNEL32.DLL" ALIAS "SwitchToThread" ( _
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >= 0x0400 */

DECLARE FUNCTION CreateThread LIB "KERNEL32.DLL" ALIAS "CreateThread" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt  LPSECURITY_ATTRIBUTES lpThreadAttributes
 , BYVAL DWORD _                       ' __in      SIZE_T dwStackSize
 , BYVAL DWORD _                       ' __in      LPTHREAD_START_ROUTINE lpStartAddress
 , BYVAL DWORD _                       ' __in_opt  LPVOID lpParameter
 , BYVAL DWORD _                       ' __in      DWORD dwCreationFlags
 , BYREF DWORD _                       ' __out_opt LPDWORD lpThreadId
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateRemoteThread LIB "KERNEL32.DLL" ALIAS "CreateRemoteThread" ( _
   BYVAL DWORD _                       ' __in      HANDLE hProcess
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt  LPSECURITY_ATTRIBUTES lpThreadAttributes
 , BYVAL DWORD _                       ' __in      SIZE_T dwStackSize
 , BYVAL DWORD _                       ' __in      LPTHREAD_START_ROUTINE lpStartAddress
 , BYVAL DWORD _                       ' __in_opt  LPVOID lpParameter
 , BYVAL DWORD _                       ' __in      DWORD dwCreationFlags
 , BYREF DWORD _                       ' __out_opt LPDWORD lpThreadId
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetCurrentThread LIB "KERNEL32.DLL" ALIAS "GetCurrentThread" ( _
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetCurrentThreadId LIB "KERNEL32.DLL" ALIAS "GetCurrentThreadId" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetThreadStackGuarantee LIB "KERNEL32.DLL" ALIAS "SetThreadStackGuarantee" ( _
   BYREF DWORD _                       ' __inout PULONG StackSizeInBytes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcessIdOfThread LIB "KERNEL32.DLL" ALIAS "GetProcessIdOfThread" ( _
   BYVAL DWORD _                       ' __in HANDLE Thread
 ) AS DWORD                            ' DWORD

'#if (_WIN32_WINNT >= 0x0502)

DECLARE FUNCTION GetThreadId LIB "KERNEL32.DLL" ALIAS "GetThreadId" ( _
   BYVAL DWORD _                       ' __in HANDLE Thread
 ) AS DWORD                            ' DWORD

'#endif // _WIN32_WINNT >= 0x0502

DECLARE FUNCTION GetProcessId LIB "KERNEL32.DLL" ALIAS "GetProcessId" ( _
   BYVAL DWORD _                       ' __in HANDLE Process
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetCurrentProcessorNumber LIB "KERNEL32.DLL" ALIAS "GetCurrentProcessorNumber" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetThreadAffinityMask LIB "KERNEL32.DLL" ALIAS "SetThreadAffinityMask" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 , BYVAL DWORD _                       ' __in DWORD_PTR dwThreadAffinityMask
 ) AS DWORD                            ' DWORD_PTR

'#if(_WIN32_WINNT >= 0x0400)

DECLARE FUNCTION SetThreadIdealProcessor LIB "KERNEL32.DLL" ALIAS "SetThreadIdealProcessor" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 , BYVAL DWORD _                       ' __in DWORD dwIdealProcessor
 ) AS DWORD                            ' HANDLE

'#endif /* _WIN32_WINNT >= 0x0400 */

DECLARE FUNCTION SetProcessPriorityBoost LIB "KERNEL32.DLL" ALIAS "SetProcessPriorityBoost" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL LONG _                        ' __in BOOL bDisablePriorityBoost
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcessPriorityBoost LIB "KERNEL32.DLL" ALIAS "GetProcessPriorityBoost" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF LONG _                        ' __out PBOOL  pDisablePriorityBoost
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RequestWakeupLatency LIB "KERNEL32.DLL" ALIAS "RequestWakeupLatency" ( _
   BYVAL LONG _                        ' __in LATENCY_TIME latency
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsSystemResumeAutomatic LIB "KERNEL32.DLL" ALIAS "IsSystemResumeAutomatic" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OpenThread LIB "KERNEL32.DLL" ALIAS "OpenThread" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in DWORD dwThreadId
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION SetThreadPriority LIB "KERNEL32.DLL" ALIAS "SetThreadPriority" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 , BYVAL LONG _                        ' __in int nPriority
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetThreadPriorityBoost LIB "KERNEL32.DLL" ALIAS "SetThreadPriorityBoost" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 , BYVAL LONG _                        ' __in BOOL bDisablePriorityBoost
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetThreadPriorityBoost LIB "KERNEL32.DLL" ALIAS "GetThreadPriorityBoost" ( _
   BYVAL DWORD _                       ' __in  HANDLE hThread
 , BYREF LONG _                        ' __out PBOOL pDisablePriorityBoost
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetThreadPriority LIB "KERNEL32.DLL" ALIAS "GetThreadPriority" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 ) AS LONG                             ' int

DECLARE FUNCTION GetThreadTimes LIB "KERNEL32.DLL" ALIAS "GetThreadTimes" ( _
   BYVAL DWORD _                       ' __in  HANDLE hThread
 , BYREF FILETIME _                    ' __out LPFILETIME lpCreationTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpExitTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpKernelTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpUserTime
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0501

DECLARE FUNCTION GetThreadIOPendingFlag LIB "KERNEL32.DLL" ALIAS "GetThreadIOPendingFlag" ( _
   BYVAL DWORD _                       ' __in  HANDLE hThread
 , BYREF LONG _                        ' __out PBOOL  lpIOIsPending
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0501)

DECLARE SUB ExitThread LIB "KERNEL32.DLL" ALIAS "ExitThread" ( _
   BYVAL DWORD _                       ' __in DWORD dwExitCode
 )                                     ' VOID

DECLARE FUNCTION TerminateThread LIB "KERNEL32.DLL" ALIAS "TerminateThread" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 , BYVAL DWORD _                       ' __in DWORD dwExitCode
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetExitCodeThread LIB "KERNEL32.DLL" ALIAS "GetExitCodeThread" ( _
   BYVAL DWORD _                       ' __in  HANDLE hThread
 , BYREF DWORD _                       ' __out LPDWORD lpExitCode
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetThreadSelectorEntry LIB "KERNEL32.DLL" ALIAS "GetThreadSelectorEntry" ( _
   BYVAL DWORD _                       ' __in  HANDLE hThread
 , BYVAL DWORD _                       ' __in  DWORD dwSelector
 , BYREF LDT_ENTRY _                   ' __out LPLDT_ENTRY lpSelectorEntry
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetThreadExecutionState LIB "KERNEL32.DLL" ALIAS "SetThreadExecutionState" ( _
   BYVAL DWORD _                       ' __in EXECUTION_STATE esFlags
 ) AS DWORD                            ' EXECUTION_STATE

DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" ( _
   ) AS DWORD                          ' DWORD

DECLARE SUB SetLastError LIB "KERNEL32.DLL" ALIAS "SetLastError" ( _
   BYVAL DWORD _                       ' __in DWORD dwErrCode
 )                                     ' VOID

DECLARE SUB RestoreLastError LIB "KERNEL32.DLL" ALIAS "RestoreLastError" ( _
   BYVAL DWORD _                       ' __in DWORD dwErrCode
 )                                     ' VOID

'typedef VOID (WINAPI* PRESTORE_LAST_ERROR)(DWORD);
'#define RESTORE_LAST_ERROR_NAME_A      "RestoreLastError"
'#define RESTORE_LAST_ERROR_NAME_W     L"RestoreLastError"
'#define RESTORE_LAST_ERROR_NAME   TEXT("RestoreLastError")

$RESTORE_LAST_ERROR_NAME_A      = "RestoreLastError"
$RESTORE_LAST_ERROR_NAME        = "RestoreLastError"

'#endif

'#define HasOverlappedIoCompleted(lpOverlapped) (((DWORD)(lpOverlapped)->Internal) != STATUS_PENDING)

DECLARE FUNCTION GetOverlappedResult LIB "KERNEL32.DLL" ALIAS "GetOverlappedResult" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYREF OVERLAPPED _                  ' __in  LPOVERLAPPED lpOverlapped
 , BYREF LONG _                        ' __out LPDWORD lpNumberOfBytesTransferred
 , BYVAL LONG _                        ' __in  BOOL bWait
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateIoCompletionPort LIB "KERNEL32.DLL" ALIAS "CreateIoCompletionPort" ( _
   BYVAL DWORD _                       ' __in     HANDLE FileHandle
 , BYVAL DWORD _                       ' __in_opt HANDLE ExistingCompletionPort
 , BYVAL DWORD _                       ' __in     ULONG_PTR CompletionKey
 , BYVAL DWORD _                       ' __in     DWORD NumberOfConcurrentThreads
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetQueuedCompletionStatus LIB "KERNEL32.DLL" ALIAS "GetQueuedCompletionStatus" ( _
   BYVAL DWORD _                       ' __in  HANDLE CompletionPort
 , BYREF DWORD _                       ' __out LPDWORD lpNumberOfBytesTransferred
 , BYREF DWORD _                       ' __out PULONG_PTR lpCompletionKey
 , BYREF DWORD _                       ' __out LPOVERLAPPED *lpOverlapped
 , BYVAL DWORD _                       ' __in  DWORD dwMilliseconds
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE FUNCTION GetQueuedCompletionStatusEx LIB "KERNEL32.DLL" ALIAS "GetQueuedCompletionStatusEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE CompletionPort
 , BYREF OVERLAPPED_ENTRY _            ' __out_ecount_part(ulCount, *ulNumEntriesRemoved) LPOVERLAPPED_ENTRY lpCompletionPortEntries,
 , BYVAL DWORD _                       ' __in  ULONG ulCount
 , BYREF DWORD _                       ' __out PULONG ulNumEntriesRemoved
 , BYVAL DWORD _                       ' __in  DWORD dwMilliseconds
 , BYVAL LONG _                        ' __in  BOOL fAlertable
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION PostQueuedCompletionStatus LIB "KERNEL32.DLL" ALIAS "PostQueuedCompletionStatus" ( _
   BYVAL DWORD _                       ' __in     HANDLE CompletionPort
 , BYVAL DWORD _                       ' __in     DWORD dwNumberOfBytesTransferred
 , BYVAL DWORD _                       ' __in     ULONG_PTR dwCompletionKey
 , BYVAL DWORD _                       ' __in_opt LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

'//
'// The following flags allows an application to change
'// the semantics of IO completion notification.
'//

'//
'// Don't queue an entry to an associated completion port if returning success
'// synchronously.
'//
%FILE_SKIP_COMPLETION_PORT_ON_SUCCESS    = &H1?

'//
'// Don't set the file handle event on IO completion.
'//
%FILE_SKIP_SET_EVENT_ON_HANDLE           = &H2?

DECLARE FUNCTION SetFileCompletionNotificationModes LIB "KERNEL32.DLL" ALIAS "SetFileCompletionNotificationModes" ( _
   BYVAL DWORD _                       ' __in HANDLE FileHandle
 , BYVAL BYTE _                        ' __in UCHAR Flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFileIoOverlappedRange LIB "KERNEL32.DLL" ALIAS "SetFileIoOverlappedRange" ( _
   BYVAL DWORD _                       ' __in HANDLE FileHandle
 , BYVAL DWORD _                       ' __in PUCHAR OverlappedRangeStart
 , BYVAL DWORD _                       ' __in ULONG Length
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

%SEM_FAILCRITICALERRORS     = &H0001???
%SEM_NOALIGNMENTFAULTEXCEPT = &H0004???
%SEM_NOGPFAULTERRORBOX      = &H0002???
%SEM_NOOPENFILEERRORBOX     = &H8000???

DECLARE FUNCTION GetErrorMode LIB "KERNEL32.DLL" ALIAS "GetErrorMode" ( _
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetErrorMode LIB "KERNEL32.DLL" ALIAS "SetErrorMode" ( _
   BYVAL DWORD _                       ' __in UINT uMode
 ) AS DWORD                            ' UINT

DECLARE FUNCTION ReadProcessMemory LIB "KERNEL32.DLL" ALIAS "ReadProcessMemory" ( _
   BYVAL DWORD _                       ' __in      HANDLE hProcess
 , BYVAL LONG _                        ' __in      LPCVOID lpBaseAddress
 , BYREF ANY _                         ' __out_bcount_part(nSize, *lpNumberOfBytesRead) LPVOID lpBuffer
 , BYVAL DWORD _                       ' __in      SIZE_T nSize
 , BYREF LONG _                        ' __out_opt SIZE_T * lpNumberOfBytesRead
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WriteProcessMemory LIB "KERNEL32.DLL" ALIAS "WriteProcessMemory" ( _
   BYVAL DWORD _                       ' __in      HANDLE hProcess
 , BYVAL DWORD _                       ' __in      LPVOID lpBaseAddress
 , BYREF ANY _                         ' __in_bcount(nSize) LPCVOID lpBuffer
 , BYVAL DWORD _                       ' __in      SIZE_T nSize
 , BYREF DWORD _                       ' __out_opt SIZE_T * lpNumberOfBytesWritten
 ) AS LONG                             ' BOOL

'#if !defined(MIDL_PASS)

DECLARE FUNCTION GetThreadContext LIB "KERNEL32.DLL" ALIAS "GetThreadContext" ( _
   BYVAL DWORD _                       ' __in    HANDLE hThread
 , BYREF CONTEXT _                     ' __inout LPCONTEXT lpContext
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetThreadContext LIB "KERNEL32.DLL" ALIAS "SetThreadContext" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 , BYREF CONTEXT _                     ' __in CONST CONTEXT *lpContext
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Wow64GetThreadContext LIB "KERNEL32.DLL" ALIAS "Wow64GetThreadContext" ( _
   BYVAL DWORD _                       ' __in    HANDLE hThread
 , BYREF WOW64_CONTEXT _               ' __inout PWOW64_CONTEXT lpContext
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Wow64SetThreadContext LIB "KERNEL32.DLL" ALIAS "Wow64SetThreadContext" ( _
   BYVAL DWORD _                       ' __in    HANDLE hThread
 , BYREF WOW64_CONTEXT _               ' __in CONST WOW64_CONTEXT *lpContext
 ) AS LONG                             ' BOOL

'#endif

DECLARE FUNCTION SuspendThread LIB "KERNEL32.DLL" ALIAS "SuspendThread" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION Wow64SuspendThread LIB "KERNEL32.DLL" ALIAS "Wow64SuspendThread" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION ResumeThread LIB "KERNEL32.DLL" ALIAS "ResumeThread" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 ) AS DWORD                            ' DWORD

'#if(_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)

'typedef
'VOID
'(APIENTRY *PAPCFUNC)(
'    __in ULONG_PTR dwParam
'    );

DECLARE FUNCTION QueueUserAPC LIB "KERNEL32.DLL" ALIAS "QueueUserAPC" ( _
   BYVAL DWORD _                       ' __in PAPCFUNC pfnAPC
 , BYVAL DWORD _                       ' __in HANDLE hThread
 , BYVAL DWORD _                       ' __in ULONG_PTR dwData
 ) AS DWORD                            ' DWORD

'#endif /* _WIN32_WINNT >= 0x0400 || _WIN32_WINDOWS > 0x0400 */

'#if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)

DECLARE FUNCTION IsDebuggerPresent LIB "KERNEL32.DLL" ALIAS "IsDebuggerPresent" ( _
 ) AS LONG                             ' BOOL

'#endif

'#if _WIN32_WINNT >= 0x0501

DECLARE FUNCTION CheckRemoteDebuggerPresent LIB "KERNEL32.DLL" ALIAS "CheckRemoteDebuggerPresent" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF LONG _                        ' __out PBOOL pbDebuggerPresent
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0501)

DECLARE SUB DebugBreak LIB "KERNEL32.DLL" ALIAS "DebugBreak" ( _
 )                                     ' VOID

DECLARE FUNCTION WaitForDebugEvent LIB "KERNEL32.DLL" ALIAS "WaitForDebugEvent" ( _
   BYREF DEBUG_EVENT _                 ' __in LPDEBUG_EVENT lpDebugEvent
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ContinueDebugEvent LIB "KERNEL32.DLL" ALIAS "ContinueDebugEvent" ( _
   BYVAL DWORD _                       ' __in DWORD dwProcessId
 , BYVAL DWORD _                       ' __in DWORD dwThreadId
 , BYVAL DWORD _                       ' __in DWORD dwContinueStatus
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DebugActiveProcess LIB "KERNEL32.DLL" ALIAS "DebugActiveProcess" ( _
   BYVAL DWORD _                       ' __in DWORD dwProcessId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DebugActiveProcessStop LIB "KERNEL32.DLL" ALIAS "DebugActiveProcessStop" ( _
   BYVAL DWORD _                       ' __in DWORD dwProcessId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DebugSetProcessKillOnExit LIB "KERNEL32.DLL" ALIAS "DebugSetProcessKillOnExit" ( _
   BYVAL LONG _                        ' __in BOOL KillOnExit
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DebugBreakProcess LIB "KERNEL32.DLL" ALIAS "DebugBreakProcess" ( _
   BYVAL DWORD _                       ' __in HANDLE Process
 ) AS LONG                             ' BOOL

DECLARE SUB InitializeCriticalSection LIB "KERNEL32.DLL" ALIAS "InitializeCriticalSection" ( _
   BYREF CRITICAL_SECTION _            ' __out LPCRITICAL_SECTION lpCriticalSection
 )                                     ' VOID

DECLARE SUB EnterCriticalSection LIB "KERNEL32.DLL" ALIAS "EnterCriticalSection" ( _
   BYREF CRITICAL_SECTION _            ' __inout LPCRITICAL_SECTION lpCriticalSection
 )                                     ' VOID

DECLARE SUB LeaveCriticalSection LIB "KERNEL32.DLL" ALIAS "LeaveCriticalSection" ( _
   BYREF CRITICAL_SECTION _            ' __inout LPCRITICAL_SECTION lpCriticalSection
 )                                     ' VOID

'#if (_WIN32_WINNT >= 0x0403)

%CRITICAL_SECTION_NO_DEBUG_INFO  = %RTL_CRITICAL_SECTION_FLAG_NO_DEBUG_INFO

DECLARE FUNCTION InitializeCriticalSectionAndSpinCount LIB "KERNEL32.DLL" ALIAS "InitializeCriticalSectionAndSpinCount" ( _
   BYREF CRITICAL_SECTION _            ' __out LPCRITICAL_SECTION lpCriticalSection
 , BYVAL DWORD _                       ' DWORD
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCriticalSectionSpinCount LIB "KERNEL32.DLL" ALIAS "SetCriticalSectionSpinCount" ( _
   BYREF CRITICAL_SECTION _            ' __inout LPCRITICAL_SECTION lpCriticalSection
 , BYVAL DWORD _                       ' __in    DWORD dwSpinCount
 ) AS DWORD                            ' DWORD

'#endif

'#if(_WIN32_WINNT >= 0x0400)

DECLARE FUNCTION TryEnterCriticalSection LIB "KERNEL32.DLL" ALIAS "TryEnterCriticalSection" ( _
   BYREF CRITICAL_SECTION _            ' __inout LPCRITICAL_SECTION lpCriticalSection
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >= 0x0400 */

DECLARE SUB DeleteCriticalSection LIB "KERNEL32.DLL" ALIAS "DeleteCriticalSection" ( _
   BYREF CRITICAL_SECTION _            ' __inout LPCRITICAL_SECTION lpCriticalSection
 )                                     ' VOID

DECLARE FUNCTION SetEvent LIB "KERNEL32.DLL" ALIAS "SetEvent" ( _
   BYVAL DWORD _                       ' __in HANDLE hEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ResetEvent LIB "KERNEL32.DLL" ALIAS "ResetEvent" ( _
   BYVAL DWORD _                       ' __in HANDLE hEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PulseEvent LIB "KERNEL32.DLL" ALIAS "PulseEvent" ( _
   BYVAL DWORD _                       ' __in HANDLE hEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ReleaseSemaphore LIB "KERNEL32.DLL" ALIAS "ReleaseSemaphore" ( _
   BYVAL DWORD _                       ' __in      HANDLE hSemaphore
 , BYVAL LONG _                        ' __in      LONG lReleaseCount
 , BYREF LONG _                        ' __out_opt LPLONG lpPreviousCount
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ReleaseMutex LIB "KERNEL32.DLL" ALIAS "ReleaseMutex" ( _
   BYVAL DWORD _                       ' __in HANDLE hMutex
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WaitForSingleObject LIB "KERNEL32.DLL" ALIAS "WaitForSingleObject" ( _
   BYVAL DWORD _                       ' __in HANDLE hHandle
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WaitForMultipleObjects LIB "KERNEL32.DLL" ALIAS "WaitForMultipleObjects" ( _
   BYVAL DWORD _                       ' __in DWORD nCount
 , BYREF DWORD _                       ' __in_ecount(nCount) CONST HANDLE *lpHandles
 , BYVAL LONG _                        ' __in BOOL bWaitAll
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 ) AS DWORD                            ' DWORD

DECLARE SUB ApiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" ( _
   BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 )                                     ' VOID

DECLARE FUNCTION LoadResource LIB "KERNEL32.DLL" ALIAS "LoadResource" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in HRSRC hResInfo
 ) AS DWORD                            ' HGLOBAL

DECLARE FUNCTION SizeofResource LIB "KERNEL32.DLL" ALIAS "SizeofResource" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in HRSRC hResInfo
 ) AS LONG                             ' DWORD

DECLARE FUNCTION GlobalDeleteAtom LIB "KERNEL32.DLL" ALIAS "GlobalDeleteAtom" ( _
   BYVAL WORD _                        ' __in ATOM nAtom
 ) AS WORD                             ' ATOM

DECLARE FUNCTION InitAtomTable LIB "KERNEL32.DLL" ALIAS "InitAtomTable" ( _
   BYVAL DWORD _                       ' __in DWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteAtom LIB "KERNEL32.DLL" ALIAS "DeleteAtom" ( _
   BYVAL WORD _                        ' __in ATOM nAtom
 ) AS WORD                             ' ATOM

DECLARE FUNCTION SetHandleCount LIB "KERNEL32.DLL" ALIAS "SetHandleCount" ( _
   BYVAL DWORD _                       ' __in UINT uNumber
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetLogicalDrives LIB "KERNEL32.DLL" ALIAS "GetLogicalDrives" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION LockFile LIB "KERNEL32.DLL" ALIAS "LockFile" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL DWORD _                       ' __in DWORD dwFileOffsetLow
 , BYVAL DWORD _                       ' __in DWORD dwFileOffsetHigh
 , BYVAL DWORD _                       ' __in DWORD nNumberOfBytesToLockLow
 , BYVAL DWORD _                       ' __in DWORD nNumberOfBytesToLockHigh
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UnlockFile LIB "KERNEL32.DLL" ALIAS "UnlockFile" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL DWORD _                       ' __in DWORD dwFileOffsetLow
 , BYVAL DWORD _                       ' __in DWORD dwFileOffsetHigh
 , BYVAL DWORD _                       ' __in DWORD nNumberOfBytesToUnlockLow
 , BYVAL DWORD _                       ' __in DWORD nNumberOfBytesToUnlockHigh
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LockFileEx LIB "KERNEL32.DLL" ALIAS "LockFileEx" ( _
   BYVAL DWORD _                       ' __in       HANDLE hFile
 , BYVAL DWORD _                       ' __in       DWORD dwFlags
 , BYVAL DWORD _                       ' __reserved DWORD dwReserved
 , BYVAL DWORD _                       ' __in       DWORD nNumberOfBytesToLockLow
 , BYVAL DWORD _                       ' __in       DWORD nNumberOfBytesToLockHigh
 , BYREF OVERLAPPED _                  ' __inout    LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

%LOCKFILE_FAIL_IMMEDIATELY = &H00000001???
%LOCKFILE_EXCLUSIVE_LOCK   = &H00000002???

DECLARE FUNCTION UnlockFileEx LIB "KERNEL32.DLL" ALIAS "UnlockFileEx" ( _
   BYVAL DWORD _                       ' __in       HANDLE hFile
 , BYVAL DWORD _                       ' __reserved DWORD dwReserved
 , BYVAL DWORD _                       ' __in       DWORD nNumberOfBytesToUnlockLow
 , BYVAL DWORD _                       ' __in       DWORD nNumberOfBytesToUnlockHigh
 , BYREF OVERLAPPED _                  ' __inout    LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

TYPE BY_HANDLE_FILE_INFORMATION
   dwFileAttributes     AS DWORD      ' DWORD dwFileAttributes
   ftCreationTime       AS FILETIME   ' FILETIME ftCreationTime
   ftLastAccessTime     AS FILETIME   ' FILETIME ftLastAccessTime
   ftLastWriteTime      AS FILETIME   ' FILETIME ftLastWriteTime
   dwVolumeSerialNumber AS DWORD      ' DWORD dwVolumeSerialNumber
   nFileSizeHigh        AS DWORD      ' DWORD nFileSizeHigh
   nFileSizeLow         AS DWORD      ' DWORD nFileSizeLow
   nNumberOfLinks       AS DWORD      ' DWORD nNumberOfLinks
   nFileIndexHigh       AS DWORD      ' DWORD nFileIndexHigh
   nFileIndexLow        AS DWORD      ' DWORD nFileIndexLow
END TYPE

DECLARE FUNCTION GetFileInformationByHandle LIB "KERNEL32.DLL" ALIAS "GetFileInformationByHandle" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYREF BY_HANDLE_FILE_INFORMATION _  ' __out LPBY_HANDLE_FILE_INFORMATION lpFileInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileType LIB "KERNEL32.DLL" ALIAS "GetFileType" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetFileSize LIB "KERNEL32.DLL" ALIAS "GetFileSize" ( _
   BYVAL DWORD _                       ' __in      HANDLE hFile
 , BYREF LONG _                        ' __out_opt LPDWORD lpFileSizeHigh
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetFileSizeEx LIB "KERNEL32.DLL" ALIAS "GetFileSizeEx" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYREF QUAD _                        ' __out PLARGE_INTEGER lpFileSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetStdHandle LIB "KERNEL32.DLL" ALIAS "GetStdHandle" ( _
   BYVAL DWORD _                       ' __in DWORD nStdHandle
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION SetStdHandle LIB "KERNEL32.DLL" ALIAS "SetStdHandle" ( _
   BYVAL DWORD _                       ' __in DWORD nStdHandle
 , BYVAL DWORD _                       ' __in HANDLE hHandle
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE FUNCTION SetStdHandleEx LIB "KERNEL32.DLL" ALIAS "SetStdHandleEx" ( _
   BYVAL DWORD _                       ' __in DWORD nStdHandle
 , BYVAL DWORD _                       ' __in HANDLE hHandle
 , BYREF DWORD _                       ' __out_opt PHANDLE phPrevValue
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION WriteFile LIB "KERNEL32.DLL" ALIAS "WriteFile" ( _
   BYVAL DWORD _                       ' __in        HANDLE hFile
 , BYREF ANY _                         ' __in_bcount(nNumberOfBytesToWrite) LPCVOID lpBuffer
 , BYVAL DWORD _                       ' __in        DWORD nNumberOfBytesToWrite
 , BYREF DWORD _                       ' __out_opt   LPDWORD lpNumberOfBytesWritten
 , BYREF OVERLAPPED _                  ' __inout_opt LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ReadFile LIB "KERNEL32.DLL" ALIAS "ReadFile" ( _
   BYVAL DWORD _                       ' __in        HANDLE hFile
 , BYREF ANY _                         ' __out_bcount_part(nNumberOfBytesToRead, *lpNumberOfBytesRead) LPVOID lpBuffer
 , BYVAL DWORD _                       ' __in        DWORD nNumberOfBytesToRead
 , BYREF DWORD _                       ' __out_opt   LPDWORD lpNumberOfBytesRead
 , BYREF OVERLAPPED _                  ' __inout_opt LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FlushFileBuffers LIB "KERNEL32.DLL" ALIAS "FlushFileBuffers" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeviceIoControl LIB "KERNEL32.DLL" ALIAS "DeviceIoControl" ( _
   BYVAL DWORD _                       ' __in        HANDLE hDevice
 , BYVAL DWORD _                       ' __in        DWORD dwIoControlCode
 , BYREF ANY _                         ' __in_bcount_opt(nInBufferSize) LPVOID lpInBuffer
 , BYVAL DWORD _                       ' __in        DWORD nInBufferSize
 , BYREF ANY _                         ' __out_bcount_part_opt(nOutBufferSize, *lpBytesReturned) LPVOID lpOutBuffer
 , BYVAL DWORD _                       ' __in        DWORD nOutBufferSize
 , BYREF DWORD _                       ' __out_opt   LPDWORD lpBytesReturned
 , BYREF OVERLAPPED _                  ' __inout_opt LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RequestDeviceWakeup LIB "KERNEL32.DLL" ALIAS "RequestDeviceWakeup" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CancelDeviceWakeupRequest LIB "KERNEL32.DLL" ALIAS "CancelDeviceWakeupRequest" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDevicePowerState LIB "KERNEL32.DLL" ALIAS "GetDevicePowerState" ( _
   BYVAL DWORD _                       ' __in  HANDLE hDevice
 , BYREF DWORD _                       ' __out BOOL *pfOn
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetMessageWaitingIndicator LIB "KERNEL32.DLL" ALIAS "SetMessageWaitingIndicator" ( _
   BYVAL DWORD _                       ' __in HANDLE hMsgIndicator
 , BYVAL DWORD _                       ' __in ULONG ulMsgCount
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetEndOfFile LIB "KERNEL32.DLL" ALIAS "SetEndOfFile" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFilePointer LIB "KERNEL32.DLL" ALIAS "SetFilePointer" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFile
 , BYVAL LONG _                        ' __in     LONG lDistanceToMove
 , BYREF LONG _                        ' __in_opt PLONG lpDistanceToMoveHigh
 , BYVAL DWORD _                       ' __in     DWORD dwMoveMethod
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetFilePointerEx LIB "KERNEL32.DLL" ALIAS "SetFilePointerEx" ( _
   BYVAL DWORD _                       ' __in      HANDLE hFile
 , BYVAL QUAD _                        ' __in      LARGE_INTEGER liDistanceToMove
 , BYREF QUAD _                        ' __out_opt PLARGE_INTEGER lpNewFilePointer
 , BYVAL DWORD _                       ' __in      DWORD dwMoveMethod
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" ( _
   BYVAL DWORD _                       ' __inout HANDLE hFindFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileTime LIB "KERNEL32.DLL" ALIAS "GetFileTime" ( _
   BYVAL DWORD _                       ' __in      HANDLE hFile
 , BYREF FILETIME _                    ' __out_opt LPFILETIME lpCreationTime
 , BYREF FILETIME _                    ' __out_opt LPFILETIME lpLastAccessTime
 , BYREF FILETIME _                    ' __out_opt LPFILETIME lpLastWriteTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFileTime LIB "KERNEL32.DLL" ALIAS "SetFileTime" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFile
 , BYREF FILETIME _                    ' __in_opt CONST FILETIME *lpCreationTime
 , BYREF FILETIME _                    ' __in_opt CONST FILETIME *lpLastAccessTime
 , BYREF FILETIME _                    ' __in_opt CONST FILETIME *lpLastWriteTime
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0501

DECLARE FUNCTION SetFileValidData LIB "KERNEL32.DLL" ALIAS "SetFileValidData" ( _
   BYVAL DWORD  _                      ' __in HANDLE hFile
 , BYVAL QUAD _                        ' __in LONGLONG ValidDataLength
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION SetFileShortName LIB "KERNEL32.DLL" ALIAS "SetFileShortNameA" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYREF ASCIIZ _                      ' __in LPCSTR lpShortName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFileShortNameW LIB "KERNEL32.DLL" ALIAS "SetFileShortNameW" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL DWORD _                       ' __in LPCWSTR lpShortName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" ( _
   BYVAL DWORD _                       ' __in HANDLE hObject
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DuplicateHandle LIB "KERNEL32.DLL" ALIAS "DuplicateHandle" ( _
   BYVAL DWORD _                       ' __in        HANDLE hSourceProcessHandle
 , BYVAL DWORD _                       ' __in        HANDLE hSourceHandle
 , BYVAL DWORD _                       ' __in        HANDLE hTargetProcessHandle
 , BYREF DWORD _                       ' __deref_out LPHANDLE lpTargetHandle
 , BYVAL DWORD _                       ' __in        DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in        BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in        DWORD dwOptions
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetHandleInformation LIB "KERNEL32.DLL" ALIAS "GetHandleInformation" ( _
   BYVAL DWORD  _                      ' __in  HANDLE hObject
 , BYREF DWORD _                       ' __out LPDWORD lpdwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetHandleInformation LIB "KERNEL32.DLL" ALIAS "SetHandleInformation" ( _
   BYVAL DWORD _                       ' __in HANDLE hObject
 , BYVAL DWORD _                       ' __in DWORD dwMask
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

%HANDLE_FLAG_INHERIT             = &H00000001???
%HANDLE_FLAG_PROTECT_FROM_CLOSE  = &H00000002???

%HINSTANCE_ERROR = 32

DECLARE FUNCTION LoadModule LIB "KERNEL32.DLL" ALIAS "LoadModule" ( _
   BYREF ASCIIZ  _                     ' __in LPCSTR lpModuleName
 , BYREF ANY _                         ' __in LPVOID lpParameterBlock
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WinExec LIB "KERNEL32.DLL" ALIAS "WinExec" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpCmdLine
 , BYVAL DWORD _                       ' __in UINT uCmdShow
 ) AS DWORD                            ' UINT

DECLARE FUNCTION ClearCommBreak LIB "KERNEL32.DLL" ALIAS "ClearCommBreak" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ClearCommError LIB "KERNEL32.DLL" ALIAS "ClearCommError" ( _
   BYVAL DWORD _                       ' __in      HANDLE hFile
 , BYREF DWORD _                       ' __out_opt LPDWORD lpErrors
 , BYREF COMSTAT _                     ' __out_opt LPCOMSTAT lpStat
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetupComm LIB "KERNEL32.DLL" ALIAS "SetupComm" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL DWORD _                       ' __in DWORD dwInQueue
 , BYVAL DWORD _                       ' __in DWORD dwOutQueue
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EscapeCommFunction LIB "KERNEL32.DLL" ALIAS "EscapeCommFunction" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL DWORD _                       ' __in DWORD dwFunc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCommConfig LIB "KERNEL32.DLL" ALIAS "GetCommConfig" ( _
   BYVAL DWORD _                       ' __in      HANDLE hCommDev
 , BYREF COMMCONFIG _                  ' __out_opt LPCOMMCONFIG lpCC
 , BYREF DWORD _                       ' __inout   LPDWORD lpdwSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCommMask LIB "KERNEL32.DLL" ALIAS "GetCommMask" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYREF DWORD _                       ' __out LPDWORD lpEvtMask
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCommProperties LIB "KERNEL32.DLL" ALIAS "GetCommProperties" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYREF COMMPROP _                    ' __out LPCOMMPROP lpCommProp
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCommModemStatus LIB "KERNEL32.DLL" ALIAS "GetCommModemStatus" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYREF DWORD _                       ' __out LPDWORD lpModemStat
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCommState LIB "KERNEL32.DLL" ALIAS "GetCommState" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYREF DCB _                         ' __out LPDCB lpDCB
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCommTimeouts LIB "KERNEL32.DLL" ALIAS "GetCommTimeouts" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYREF COMMTIMEOUTS _                ' __out LPCOMMTIMEOUTS lpCommTimeouts
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PurgeComm LIB "KERNEL32.DLL" ALIAS "PurgeComm" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCommBreak LIB "KERNEL32.DLL" ALIAS "SetCommBreak" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCommConfig LIB "KERNEL32.DLL" ALIAS "SetCommConfig" ( _
   BYVAL DWORD _                       ' __in HANDLE hCommDev
 , BYREF COMMCONFIG  _                 ' __in_bcount(dwSize) LPCOMMCONFIG lpCC
 , BYVAL DWORD _                       ' __in DWORD dwSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCommMask LIB "KERNEL32.DLL" ALIAS "SetCommMask" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL DWORD _                       ' __in DWORD dwEvtMask
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCommState LIB "KERNEL32.DLL" ALIAS "SetCommState" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYREF DCB _                         ' __in LPDCB lpDCB
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCommTimeouts LIB "KERNEL32.DLL" ALIAS "SetCommTimeouts" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYREF COMMTIMEOUTS _                ' __in LPCOMMTIMEOUTS lpCommTimeouts
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TransmitCommChar LIB "KERNEL32.DLL" ALIAS "TransmitCommChar" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL BYTE _                        ' __in char cChar
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WaitCommEvent LIB "KERNEL32.DLL" ALIAS "WaitCommEvent" ( _
   BYVAL DWORD _                       ' __in        HANDLE hFile
 , BYREF DWORD _                       ' __inout     LPDWORD lpEvtMask
 , BYREF OVERLAPPED _                  ' __inout_opt LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetTapePosition LIB "KERNEL32.DLL" ALIAS "SetTapePosition" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 , BYVAL DWORD _                       ' __in DWORD dwPositionMethod
 , BYVAL DWORD _                       ' __in DWORD dwPartition
 , BYVAL DWORD _                       ' __in DWORD dwOffsetLow
 , BYVAL DWORD _                       ' __in DWORD dwOffsetHigh
 , BYVAL LONG _                        ' __in BOOL bImmediate
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetTapePosition LIB "KERNEL32.DLL" ALIAS "GetTapePosition" ( _
   BYVAL DWORD _                       ' __in  HANDLE hDevice
 , BYVAL DWORD _                       ' __in  DWORD dwPositionType
 , BYREF DWORD _                       ' __out LPDWORD lpdwPartition
 , BYREF DWORD _                       ' __out LPDWORD lpdwOffsetLow
 , BYREF DWORD _                       ' __out LPDWORD lpdwOffsetHigh
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION PrepareTape LIB "KERNEL32.DLL" ALIAS "PrepareTape" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 , BYVAL DWORD _                       ' __in DWORD dwOperation
 , BYVAL LONG _                        ' __in BOOL bImmediate
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION EraseTape LIB "KERNEL32.DLL" ALIAS "EraseTape" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 , BYVAL DWORD _                       ' __in DWORD dwEraseType
 , BYVAL LONG _                        ' __in BOOL bImmediate
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CreateTapePartition LIB "KERNEL32.DLL" ALIAS "CreateTapePartition" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 , BYVAL DWORD _                       ' __in DWORD dwPartitionMethod
 , BYVAL DWORD _                       ' __in DWORD dwCount
 , BYVAL DWORD _                       ' __in DWORD dwSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WriteTapemark LIB "KERNEL32.DLL" ALIAS "WriteTapemark" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 , BYVAL DWORD _                       ' __in DWORD dwTapemarkType
 , BYVAL DWORD _                       ' __in DWORD dwTapemarkCount
 , BYVAL LONG _                        ' __in BOOL bImmediate
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetTapeStatus LIB "KERNEL32.DLL" ALIAS "GetTapeStatus" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetTapeParameters LIB "KERNEL32.DLL" ALIAS "GetTapeParameters" ( _
   BYVAL DWORD _                       ' __in    HANDLE hDevice
 , BYVAL DWORD _                       ' __in    DWORD dwOperation
 , BYREF DWORD _                       ' __inout LPDWORD lpdwSize
 , BYREF ANY _                         ' __out_bcount(*lpdwSize) LPVOID lpTapeInformation
 ) AS DWORD                            ' DWORD

%GET_TAPE_MEDIA_INFORMATION = 0
%GET_TAPE_DRIVE_INFORMATION = 1

DECLARE FUNCTION SetTapeParameters LIB "KERNEL32.DLL" ALIAS "SetTapeParameters" ( _
   BYVAL DWORD _                       ' __in HANDLE hDevice
 , BYVAL DWORD _                       ' __in DWORD dwOperation
 , BYREF ANY _                         ' __in LPVOID lpTapeInformation
 ) AS DWORD                            ' DWORD

%SET_TAPE_MEDIA_INFORMATION = 0
%SET_TAPE_DRIVE_INFORMATION = 1

DECLARE FUNCTION WinBeep LIB "KERNEL32.DLL" ALIAS "Beep" ( _
   BYVAL DWORD _                       ' __in DWORD dwFreq
 , BYVAL DWORD _                       ' __in DWORD dwDuration
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MulDiv LIB "KERNEL32.DLL" ALIAS "MulDiv" ( _
   BYVAL LONG _                        ' __in int nNumber
 , BYVAL LONG _                        ' __in int nNumerator
 , BYVAL LONG _                        ' __in int nDenominator
 ) AS LONG                             ' int

DECLARE SUB GetSystemTime LIB "KERNEL32.DLL" ALIAS "GetSystemTime" ( _
   BYREF SYSTEMTIME _                  ' __out LPSYSTEMTIME lpSystemTime
 )                                     ' VOID

DECLARE SUB GetSystemTimeAsFileTime LIB "KERNEL32.DLL" ALIAS "GetSystemTimeAsFileTime" ( _
   BYREF FILETIME _                    ' __out LPFILETIME lpSystemTimeAsFileTime
 )                                     ' VOID

DECLARE FUNCTION SetSystemTime LIB "KERNEL32.DLL" ALIAS "SetSystemTime" ( _
   BYREF SYSTEMTIME _                  ' __in CONST SYSTEMTIME *lpSystemTime
 ) AS LONG                             ' BOOL

DECLARE SUB GetLocalTime LIB "KERNEL32.DLL" ALIAS "GetLocalTime" ( _
   BYREF SYSTEMTIME _                  ' __out LPSYSTEMTIME lpSystemTime
 )                                     ' VOID

DECLARE FUNCTION SetLocalTime LIB "KERNEL32.DLL" ALIAS "SetLocalTime" ( _
   BYREF SYSTEMTIME _                  ' __in CONST SYSTEMTIME *lpSystemTime
 ) AS LONG                             ' BOOL

DECLARE SUB GetSystemInfo LIB "KERNEL32.DLL" ALIAS "GetSystemInfo" ( _
   BYREF SYSTEM_INFO _                 ' __out LPSYSTEM_INFO lpSystemInfo
 )                                     ' VOID

'#if _WIN32_WINNT >= 0x0502

DECLARE FUNCTION SetSystemFileCacheSize LIB "KERNEL32.DLL" ALIAS "SetSystemFileCacheSize" ( _
   BYVAL DWORD _                       ' __in SIZE_T MinimumFileCacheSize
 , BYVAL DWORD _                       ' __in SIZE_T MaximumFileCacheSize
 , BYVAL DWORD _                       ' __in DWORD Flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSystemFileCacheSize LIB "KERNEL32.DLL" ALIAS "GetSystemFileCacheSize" ( _
   BYREF DWORD _                       ' __out PSIZE_T lpMinimumFileCacheSize
 , BYREF DWORD _                       ' __out PSIZE_T lpMaximumFileCacheSize
 , BYREF DWORD _                       ' __out PDWORD lpFlags
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0502)

'#if _WIN32_WINNT >= 0x0501

DECLARE FUNCTION GetSystemRegistryQuota LIB "KERNEL32.DLL" ALIAS "GetSystemRegistryQuota" ( _
   BYREF DWORD _                       ' __out_opt PDWORD pdwQuotaAllowed
 , BYREF DWORD _                       ' __out_opt PDWORD pdwQuotaUsed
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSystemTimes LIB "KERNEL32.DLL" ALIAS "GetSystemTimes" ( _
   BYREF FILETIME _                    ' __out_opt LPFILETIME lpIdleTime
 , BYREF FILETIME _                    ' __out_opt LPFILETIME lpKernelTime
 , BYREF FILETIME _                    ' __out_opt LPFILETIME lpUserTime
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0501)

'#if _WIN32_WINNT >= 0x0501

DECLARE SUB GetNativeSystemInfo LIB "KERNEL32.DLL" ALIAS "GetNativeSystemInfo" ( _
   BYREF SYSTEM_INFO _                 ' __out LPSYSTEM_INFO lpSystemInfo
 )                                     ' VOID

'#endif

DECLARE FUNCTION IsProcessorFeaturePresent LIB "KERNEL32.DLL" ALIAS "IsProcessorFeaturePresent" ( _
   BYVAL DWORD _                       ' __in DWORD ProcessorFeature
 ) AS LONG                             ' BOOL

TYPE TIME_ZONE_INFORMATION
   Bias         AS LONG              ' LONG Bias
   StandardName AS STRING * 32 * 2   ' WCHAR StandardName[ 32 ]
   StandardDate AS SYSTEMTIME        ' SYSTEMTIME StandardDate
   StandardBias AS LONG              ' LONG StandardBias
   DaylightName AS STRING * 32 * 2   ' WCHAR DaylightName[ 32 ]
   DaylightDate AS SYSTEMTIME        ' SYSTEMTIME DaylightDate
   DaylightBias AS LONG              ' LONG DaylightBias
END TYPE

TYPE DYNAMIC_TIME_ZONE_INFORMATION
   Bias         AS LONG                  ' LONG Bias
   StandardName AS STRING * 32 * 2       ' WCHAR StandardName[ 32 ]
   StandardDate AS SYSTEMTIME            ' SYSTEMTIME StandardDate
   StandardBias AS LONG                  ' LONG StandardBias
   DaylightName AS STRING * 32 * 2       ' WCHAR DaylightName[ 32 ]
   DaylightDate AS SYSTEMTIME            ' SYSTEMTIME DaylightDate
   DaylightBias AS LONG                  ' LONG DaylightBias
   TimeZoneKeyName AS STRING * 128 * 2   ' WCHAR
   DynamicDaylightTimeDisabled AS BYTE   ' BOOLEAN
END TYPE

DECLARE FUNCTION SystemTimeToTzSpecificLocalTime LIB "KERNEL32.DLL" ALIAS "SystemTimeToTzSpecificLocalTime" ( _
   BYREF TIME_ZONE_INFORMATION _       ' __in_opt LPTIME_ZONE_INFORMATION lpTimeZoneInformation
 , BYREF SYSTEMTIME _                  ' __in     LPSYSTEMTIME lpUniversalTime
 , BYREF SYSTEMTIME _                  ' __out    LPSYSTEMTIME lpLocalTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TzSpecificLocalTimeToSystemTime LIB "KERNEL32.DLL" ALIAS "TzSpecificLocalTimeToSystemTime" ( _
   BYREF TIME_ZONE_INFORMATION _       ' __in_opt LPTIME_ZONE_INFORMATION lpTimeZoneInformation
 , BYREF SYSTEMTIME _                  ' __in     LPSYSTEMTIME lpLocalTime
 , BYREF SYSTEMTIME _                  ' __out    LPSYSTEMTIME lpUniversalTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTimeZoneInformation LIB "KERNEL32.DLL" ALIAS "GetTimeZoneInformation" ( _
   BYREF TIME_ZONE_INFORMATION _       ' __out LPTIME_ZONE_INFORMATION lpTimeZoneInformation
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetTimeZoneInformation LIB "KERNEL32.DLL" ALIAS "SetTimeZoneInformation" ( _
   BYREF TIME_ZONE_INFORMATION _       ' __in CONST TIME_ZONE_INFORMATION *lpTimeZoneInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDynamicTimeZoneInformation LIB "KERNEL32.DLL" ALIAS "GetDynamicTimeZoneInformation" ( _
   BYREF DYNAMIC_TIME_ZONE_INFORMATION _ ' __out PDYNAMIC_TIME_ZONE_INFORMATION lpTimeZoneInformation
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetDynamicTimeZoneInformation LIB "KERNEL32.DLL" ALIAS "SetDynamicTimeZoneInformation" ( _
   BYREF DYNAMIC_TIME_ZONE_INFORMATION _ ' __in CONST DYNAMIC_TIME_ZONE_INFORMATION *lpTimeZoneInformation
 ) AS DWORD                            ' DWORD

'//
'// Routines to convert back and forth between system time and file time
'//

DECLARE FUNCTION SystemTimeToFileTime LIB "KERNEL32.DLL" ALIAS "SystemTimeToFileTime" ( _
   BYREF SYSTEMTIME _                  ' __in  CONST SYSTEMTIME *lpSystemTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpFileTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FileTimeToLocalFileTime LIB "KERNEL32.DLL" ALIAS "FileTimeToLocalFileTime" ( _
   BYREF FILETIME _                    ' __in  CONST FILETIME *lpFileTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpLocalFileTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LocalFileTimeToFileTime LIB "KERNEL32.DLL" ALIAS "LocalFileTimeToFileTime" ( _
   BYREF FILETIME _                    ' __in  CONST FILETIME *lpLocalFileTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpFileTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FileTimeToSystemTime LIB "KERNEL32.DLL" ALIAS "FileTimeToSystemTime" ( _
   BYREF FILETIME _                    ' __in  CONST FILETIME *lpFileTime
 , BYREF SYSTEMTIME _                  ' __out LPSYSTEMTIME lpSystemTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CompareFileTime LIB "KERNEL32.DLL" ALIAS "CompareFileTime" ( _
   BYREF FILETIME _                    ' __in CONST FILETIME *lpFileTime1
 , BYREF FILETIME _                    ' __in CONST FILETIME *lpFileTime2
 ) AS LONG                             ' LONG

DECLARE FUNCTION FileTimeToDosDateTime LIB "KERNEL32.DLL" ALIAS "FileTimeToDosDateTime" ( _
   BYREF FILETIME _                    ' __in  CONST FILETIME *lpFileTime
 , BYREF WORD _                        ' __out LPWORD lpFatDate
 , BYREF WORD _                        ' __out LPWORD lpFatTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DosDateTimeToFileTime LIB "KERNEL32.DLL" ALIAS "DosDateTimeToFileTime" ( _
   BYVAL WORD _                        ' __in  WORD wFatDate
 , BYVAL WORD _                        ' __in  WORD wFatTime
 , BYREF FILETIME _                    ' __out LPFILETIME lpFileTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetSystemTimeAdjustment LIB "KERNEL32.DLL" ALIAS "SetSystemTimeAdjustment" ( _
   BYVAL DWORD  _                      ' __in DWORD dwTimeAdjustment
 , BYVAL LONG _                        ' __in BOOL  bTimeAdjustmentDisabled
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSystemTimeAdjustment LIB "KERNEL32.DLL" ALIAS "GetSystemTimeAdjustment" ( _
   BYREF DWORD _                       ' __out PDWORD lpTimeAdjustment
 , BYREF DWORD _                       ' __out PDWORD lpTimeIncrement
 , BYREF LONG _                        ' __out PBOOL  lpTimeAdjustmentDisabled
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FormatMessage LIB "KERNEL32.DLL" ALIAS "FormatMessageA" ( _
   BYVAL DWORD _                       ' DWORD dwFlags
 , BYREF ANY _                         ' LPCVOID lpSource
 , BYVAL DWORD _                       ' DWORD dwMessageId
 , BYVAL DWORD _                       ' DWORD dwLanguageId
 , BYREF ASCIIZ _                      ' LPSTR lpBuffer
 , BYVAL DWORD _                       ' DWORD nSize
 , BYREF ANY _                         ' va_list *Arguments
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION FormatMessageW LIB "KERNEL32.DLL" ALIAS "FormatMessageW" ( _
   BYVAL DWORD _                       ' DWORD dwFlags
 , BYREF ANY _                         ' LPCVOID lpSource
 , BYVAL DWORD _                       ' DWORD dwMessageId
 , BYVAL DWORD _                       ' DWORD dwLanguageId
 , BYVAL DWORD _                       ' LPWSTR lpBuffer
 , BYVAL DWORD _                       ' DWORD nSize
 , BYREF ANY _                         ' va_list *Arguments
 ) AS DWORD                            ' DWORD

%FORMAT_MESSAGE_ALLOCATE_BUFFER = &H00000100???
%FORMAT_MESSAGE_IGNORE_INSERTS  = &H00000200???
%FORMAT_MESSAGE_FROM_STRING     = &H00000400???
%FORMAT_MESSAGE_FROM_HMODULE    = &H00000800???
%FORMAT_MESSAGE_FROM_SYSTEM     = &H00001000???
%FORMAT_MESSAGE_ARGUMENT_ARRAY  = &H00002000???
%FORMAT_MESSAGE_MAX_WIDTH_MASK  = &H000000FF???

DECLARE FUNCTION CreatePipe LIB "KERNEL32.DLL" ALIAS "CreatePipe" ( _
   BYREF DWORD _                       ' __out_ecount_full(1) PHANDLE hReadPipe
 , BYREF DWORD _                       ' __out_ecount_full(1) PHANDLE hWritePipe
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpPipeAttributes
 , BYVAL DWORD _                       ' __in     DWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ConnectNamedPipe LIB "KERNEL32.DLL" ALIAS "ConnectNamedPipe" ( _
   BYVAL DWORD _                       ' __in        HANDLE hNamedPipe
 , BYREF OVERLAPPED _                  ' __inout_opt LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DisconnectNamedPipe LIB "KERNEL32.DLL" ALIAS "DisconnectNamedPipe" ( _
   BYVAL DWORD _                       ' __in HANDLE hNamedPipe
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetNamedPipeHandleState LIB "KERNEL32.DLL" ALIAS "SetNamedPipeHandleState" ( _
   BYVAL DWORD _                       ' __in     HANDLE hNamedPipe
 , BYREF DWORD _                       ' __in_opt LPDWORD lpMode
 , BYREF DWORD _                       ' __in_opt LPDWORD lpMaxCollectionCount
 , BYREF DWORD _                       ' __in_opt LPDWORD lpCollectDataTimeout
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNamedPipeInfo LIB "KERNEL32.DLL" ALIAS "GetNamedPipeInfo" ( _
   BYVAL DWORD _                       ' __in      HANDLE hNamedPipe
 , BYREF DWORD _                       ' __out_opt LPDWORD lpFlags
 , BYREF DWORD _                       ' __out_opt LPDWORD lpOutBufferSize
 , BYREF DWORD _                       ' __out_opt LPDWORD lpInBufferSize
 , BYREF DWORD _                       ' __out_opt LPDWORD lpMaxInstances
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PeekNamedPipe LIB "KERNEL32.DLL" ALIAS "PeekNamedPipe" ( _
   BYVAL DWORD _                       ' __in      HANDLE hNamedPipe
 , BYREF ANY _                         ' __out_bcount_part_opt(nBufferSize, *lpBytesRead) LPVOID lpBuffer
 , BYVAL DWORD _                       ' __in      DWORD nBufferSize
 , BYREF DWORD _                       ' __out_opt LPDWORD lpBytesRead
 , BYREF DWORD _                       ' __out_opt LPDWORD lpTotalBytesAvail
 , BYREF DWORD _                       ' __out_opt LPDWORD lpBytesLeftThisMessage
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TransactNamedPipe LIB "KERNEL32.DLL" ALIAS "TransactNamedPipe" ( _
   BYVAL DWORD _                       ' __in        HANDLE hNamedPipe
 , BYREF ANY _                         ' __in_bcount_opt(nInBufferSize) LPVOID lpInBuffer
 , BYVAL DWORD _                       ' __in        DWORD nInBufferSize
 , BYREF ANY _                         ' __out_bcount_part_opt(nOutBufferSize, *lpBytesRead) LPVOID lpOutBuffer
 , BYVAL DWORD _                       ' __in        DWORD nOutBufferSize
 , BYREF DWORD _                       ' __out       LPDWORD lpBytesRead
 , BYREF OVERLAPPED _                  ' __inout_opt LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateMailslot LIB "KERNEL32.DLL" ALIAS "CreateMailslotA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD nMaxMessageSize
 , BYVAL DWORD _                       ' __in     DWORD lReadTimeout
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateMailslotW LIB "KERNEL32.DLL" ALIAS "CreateMailslotW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD nMaxMessageSize
 , BYVAL DWORD _                       ' __in     DWORD lReadTimeout
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetMailslotInfo LIB "KERNEL32.DLL" ALIAS "GetMailslotInfo" ( _
   BYVAL DWORD _                       ' __in      HANDLE hMailslot
 , BYREF DWORD _                       ' __out_opt LPDWORD lpMaxMessageSize
 , BYREF DWORD _                       ' __out_opt LPDWORD lpNextSize
 , BYREF DWORD _                       ' __out_opt LPDWORD lpMessageCount
 , BYREF DWORD _                       ' __out_opt LPDWORD lpReadTimeout
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetMailslotInfo LIB "KERNEL32.DLL" ALIAS "SetMailslotInfo" ( _
   BYVAL DWORD  _                      ' __in HANDLE hMailslot
 , BYVAL DWORD _                       ' __in DWORD lReadTimeout
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MapViewOfFile LIB "KERNEL32.DLL" ALIAS "MapViewOfFile" ( _
   BYVAL DWORD _                       ' __in HANDLE hFileMappingObject
 , BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL DWORD _                       ' __in DWORD dwFileOffsetHigh
 , BYVAL DWORD _                       ' __in DWORD dwFileOffsetLow
 , BYVAL DWORD _                       ' __in SIZE_T dwNumberOfBytesToMap
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION FlushViewOfFile LIB "KERNEL32.DLL" ALIAS "FlushViewOfFile" ( _
   BYVAL DWORD _                       ' __in LPCVOID lpBaseAddress
 , BYVAL DWORD _                       ' __in SIZE_T dwNumberOfBytesToFlush
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UnmapViewOfFile LIB "KERNEL32.DLL" ALIAS "UnmapViewOfFile" ( _
   BYVAL DWORD _                       ' __in LPCVOID lpBaseAddress
 ) AS LONG                             ' BOOL

'//
'// File Encryption API
'//

DECLARE FUNCTION EncryptFile LIB "ADVAPI32.DLL" ALIAS "EncryptFileA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EncryptFileW LIB "ADVAPI32.DLL" ALIAS "EncryptFileW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DecryptFile LIB "ADVAPI32.DLL" ALIAS "DecryptFileA" ( _
   BYREF ASCIIZ _                      ' __in       LPCSTR lpFileName
 , BYVAL DWORD _                       ' __reserved DWORD dwReserved
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DecryptFileW LIB "ADVAPI32.DLL" ALIAS "DecryptFileW" ( _
   BYVAL DWORD _                       ' __in       LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __reserved DWORD dwReserved
 ) AS LONG                             ' BOOL

'//
'//  Encryption Status Value
'//

%FILE_ENCRYPTABLE               = 0
%FILE_IS_ENCRYPTED              = 1
%FILE_SYSTEM_ATTR               = 2
%FILE_ROOT_DIR                  = 3
%FILE_SYSTEM_DIR                = 4
%FILE_UNKNOWN                   = 5
%FILE_SYSTEM_NOT_SUPPORT        = 6
%FILE_USER_DISALLOWED           = 7
%FILE_READ_ONLY                 = 8
%FILE_DIR_DISALLOWED            = 9

DECLARE FUNCTION FileEncryptionStatus LIB "ADVAPI32.DLL" ALIAS "FileEncryptionStatusA" ( _
   BYREF ASCIIZ  _                     ' __in  LPCSTR lpFileName
 , BYREF DWORD _                       ' __out LPDWORD  lpStatus
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FileEncryptionStatusW LIB "ADVAPI32.DLL" ALIAS "FileEncryptionStatusW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpFileName
 , BYREF DWORD _                       ' __out LPDWORD  lpStatus
 ) AS LONG                             ' BOOL

'//
'// Currently defined recovery flags
'//

%EFS_USE_RECOVERY_KEYS = &H1

'typedef
'DWORD
'(WINAPI *PFE_EXPORT_FUNC)(
'    __in_bcount(ulLength) PBYTE pbData,
'    __in_opt PVOID pvCallbackContext,
'    __in     ULONG ulLength
'    );

'typedef
'DWORD
'(WINAPI *PFE_IMPORT_FUNC)(
'    __out_bcount_part(*ulLength, *ulLength) PBYTE pbData,
'    __in_opt PVOID pvCallbackContext,
'    __inout  PULONG ulLength
'    );


'//
'//  OpenRaw flag values
'//

%CREATE_FOR_IMPORT  = 1
%CREATE_FOR_DIR     = 2
%OVERWRITE_HIDDEN   = 4
%EFSRPC_SECURE_ONLY = 8

DECLARE FUNCTION OpenEncryptedFileRaw LIB "ADVAPI32.DLL" ALIAS "OpenEncryptedFileRawA" ( _
   BYREF ASCIIZ _                      ' __in        LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in        ULONG    ulFlags
 , BYREF ANY _                         ' __deref_out PVOID   *pvContext
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION OpenEncryptedFileRawW LIB "ADVAPI32.DLL" ALIAS "OpenEncryptedFileRawW" ( _
   BYVAL DWORD _                       ' __in        LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in        ULONG    ulFlags
 , BYREF ANY _                         ' __deref_out PVOID   *pvContext
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION ReadEncryptedFileRaw LIB "ADVAPI32.DLL" ALIAS "ReadEncryptedFileRaw" ( _
   BYVAL DWORD _                       ' __in     PFE_EXPORT_FUNC pfExportCallback
 , BYVAL DWORD _                       ' __in_opt PVOID           pvCallbackContext
 , BYVAL DWORD _                       ' __in     PVOID           pvContext
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WriteEncryptedFileRaw LIB "ADVAPI32.DLL" ALIAS "WriteEncryptedFileRaw" ( _
   BYVAL DWORD _                       ' __in     PFE_IMPORT_FUNC pfImportCallback
 , BYVAL DWORD _                       ' __in_opt PVOID           pvCallbackContext
 , BYVAL DWORD _                       ' __in     PVOID           pvContext
 ) AS DWORD                            ' DWORD

DECLARE SUB CloseEncryptedFileRaw LIB "ADVAPI32.DLL" ALIAS "CloseEncryptedFileRaw" ( _
   BYVAL DWORD _                       ' __in PVOID           pvContext
 )                                     ' VOID

'//
'// _l Compat Functions
'//

DECLARE FUNCTION lstrcmp LIB "KERNEL32.DLL" ALIAS "lstrcmpA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpString1
 , BYREF ASCIIZ _                      ' __in LPCSTR lpString2
 ) AS LONG                             ' int

DECLARE FUNCTION lstrcmpW LIB "KERNEL32.DLL" ALIAS "lstrcmpW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpString1
 , BYVAL DWORD _                       ' __in LPCWSTR lpString2
 ) AS LONG                             ' int

DECLARE FUNCTION lstrcmpi LIB "KERNEL32.DLL" ALIAS "lstrcmpiA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpString1
 , BYREF ASCIIZ _                      ' __in LPCSTR lpString2
 ) AS LONG                             ' int

DECLARE FUNCTION lstrcmpiW LIB "KERNEL32.DLL" ALIAS "lstrcmpiW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpString1
 , BYVAL DWORD _                       ' __in LPCWSTR lpString2
 ) AS LONG                             ' int

DECLARE FUNCTION lstrcpyn LIB "KERNEL32.DLL" ALIAS "lstrcpynA" ( _
   BYREF ASCIIZ _                      ' __out_ecount(iMaxLength) LPSTR lpString1
 , BYREF ASCIIZ _                      ' __in LPCSTR lpString2
 , BYVAL LONG _                        ' __in int iMaxLength
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION lstrcpynW LIB "KERNEL32.DLL" ALIAS "lstrcpynW" ( _
   BYVAL DWORD _                       ' __out_ecount(iMaxLength) LPWSTR lpString1
 , BYVAL DWORD _                       ' __in LPCWSTR lpString2
 , BYVAL LONG _                        ' __in int iMaxLength
 ) AS DWORD                            ' LPWSTR

DECLARE FUNCTION lstrcpy LIB "KERNEL32.DLL" ALIAS "lstrcpyA" ( _
   BYREF ASCIIZ _                      ' __out LPSTR lpString1
 , BYREF ASCIIZ _                      ' __in  LPCSTR lpString2
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION lstrcpyW LIB "KERNEL32.DLL" ALIAS "lstrcpyW" ( _
   BYVAL DWORD _                       ' __out LPWSTR lpString1
 , BYVAL DWORD _                       ' __in  LPCWSTR lpString2
 ) AS DWORD                            ' LPWSTR

DECLARE FUNCTION lstrcat LIB "KERNEL32.DLL" ALIAS "lstrcatA" ( _
   BYREF ASCIIZ _                      ' __inout LPSTR lpString1
 , BYREF ASCIIZ _                      ' __in    LPCSTR lpString2
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION lstrcatW LIB "KERNEL32.DLL" ALIAS "lstrcatW" ( _
   BYVAL DWORD _                       ' __inout LPWSTR lpString1
 , BYVAL DWORD _                       ' __in    LPCWSTR lpString2
 ) AS DWORD                            ' LPWSTR

DECLARE FUNCTION lstrlen LIB "KERNEL32.DLL" ALIAS "lstrlenA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpString
 ) AS LONG                             ' int

DECLARE FUNCTION lstrlenw LIB "KERNEL32.DLL" ALIAS "lstrlenW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpString
 ) AS LONG                             ' int

DECLARE FUNCTION OpenFile LIB "KERNEL32.DLL" ALIAS "OpenFile" ( _
   BYREF ASCIIZ _                      '__in    LPCSTR lpFileName
 , BYREF OFSTRUCT _                    ' __inout LPOFSTRUCT lpReOpenBuff
 , BYVAL DWORD _                       ' __in    UINT uStyle
 ) AS DWORD                            ' HFILE

DECLARE FUNCTION lopen LIB "KERNEL32.DLL" ALIAS "_lopen" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpPathName0
 , BYVAL LONG _                        ' __in int iReadWrite
 ) AS DWORD                            ' HFILE

DECLARE FUNCTION lcreat LIB "KERNEL32.DLL" ALIAS "_lcreat" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpPathName
 , BYVAL LONG _                        ' __in int  iAttribute
 ) AS DWORD                            ' HFILE

DECLARE FUNCTION lread LIB "KERNEL32.DLL" ALIAS "_lread" ( _
   BYVAL DWORD _                       ' __in HFILE hFile
 , BYREF ANY _                         ' __out_bcount_part(uBytes, return) LPVOID lpBuffer
 , BYVAL DWORD _                       ' __in UINT uBytes
 ) AS DWORD                            ' UINT

DECLARE FUNCTION lwrite LIB "KERNEL32.DLL" ALIAS "_lwrite" ( _
   BYVAL DWORD _                       ' __in HFILE hFile
 , BYREF ASCIIZ _                      ' __in_bcount(uBytes) LPCCH lpBuffer
 , BYVAL DWORD _                       ' __in UINT uBytes
 ) AS DWORD                            ' UINT

DECLARE FUNCTION hread LIB "KERNEL32.DLL" ALIAS "_hread" ( _
   BYVAL DWORD _                       ' __in HFILE hFile
 , BYREF ANY _                         ' __out_bcount_part(lBytes, return) LPVOID lpBuffer
 , BYVAL LONG _                        ' __in long lBytes
 ) AS LONG                             ' LONG

DECLARE FUNCTION hwrite LIB "KERNEL32.DLL" ALIAS "_hwrite" ( _
   BYVAL DWORD _                       ' __in HFILE hFile
 , BYREF ASCIIZ _                      ' __in_bcount(lBytes) LPCCH lpBuffer
 , BYVAL LONG _                        ' __in long lBytes
 ) AS LONG                             ' LONG

DECLARE FUNCTION lclose LIB "KERNEL32.DLL" ALIAS "_lclose" ( _
   BYVAL DWORD _                       ' __in HFILE hFile
 ) AS DWORD                            ' HFILE

DECLARE FUNCTION llseek LIB "KERNEL32.DLL" ALIAS "_llseek" ( _
   BYVAL DWORD _                       ' __in HFILE hFile
 , BYVAL LONG _                        ' __in LONG lOffset
 , BYVAL LONG _                        ' __in int iOrigin
 ) AS LONG                             ' LONG

DECLARE FUNCTION IsTextUnicode LIB "ADVAPI32.DLL" ALIAS "IsTextUnicode" ( _
   BYVAL DWORD _                       ' __in_bcount(iSize) CONST VOID* lpv
 , BYVAL LONG _                        ' __in        int iSize
 , BYREF LONG _                        ' __inout_opt LPINT lpiResult
 ) AS LONG                             ' BOOL

%FLS_OUT_OF_INDEXES = &HFFFFFFFF???   ' ((DWORD)0xFFFFFFFF)

DECLARE FUNCTION FlsAlloc LIB "KERNEL32.DLL" ALIAS "FlsAlloc" ( _
   BYVAL DWORD _                       ' __in_opt PFLS_CALLBACK_FUNCTION lpCallback
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION FlsGetValue LIB "KERNEL32.DLL" ALIAS "FlsGetValue" ( _
   BYVAL DWORD _                       ' __in DWORD dwFlsIndex
 ) AS DWORD                            ' PVOID

DECLARE FUNCTION FlsSetValue LIB "KERNEL32.DLL" ALIAS "FlsSetValue" ( _
   BYVAL DWORD _                       ' __in     DWORD dwFlsIndex
 , BYVAL DWORD _                       ' __in_opt PVOID lpFlsData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FlsFree LIB "KERNEL32.DLL" ALIAS "FlsFree" ( _
   BYVAL DWORD _                       ' __in DWORD dwFlsIndex
 ) AS LONG                             ' BOOL

%TLS_OUT_OF_INDEXES = &HFFFFFFFF???   ' ((DWORD)0xFFFFFFFF)

DECLARE FUNCTION TlsAlloc LIB "KERNEL32.DLL" ALIAS "TlsAlloc" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION TlsGetValue LIB "KERNEL32.DLL" ALIAS "TlsGetValue" ( _
   BYVAL DWORD _                       ' __in DWORD dwTlsIndex
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION TlsSetValue LIB "KERNEL32.DLL" ALIAS "TlsSetValue" ( _
   BYVAL DWORD _                       ' __in     DWORD dwTlsIndex
 , BYVAL DWORD _                       ' __in_opt LPVOID lpTlsValue
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TlsFree LIB "KERNEL32.DLL" ALIAS "TlsFree" ( _
   BYVAL DWORD _                       ' __in DWORD dwTlsIndex
 ) AS LONG                             ' BOOL

'typedef
'VOID
'(WINAPI *LPOVERLAPPED_COMPLETION_ROUTINE)(
'    __in    DWORD dwErrorCode,
'    __in    DWORD dwNumberOfBytesTransfered,
'    __inout LPOVERLAPPED lpOverlapped
'    );

DECLARE FUNCTION SleepEx LIB "KERNEL32.DLL" ALIAS "SleepEx" ( _
   BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 , BYVAL LONG _                        ' __in BOOL bAlertable
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WaitForSingleObjectEx LIB "KERNEL32.DLL" ALIAS "WaitForSingleObjectEx" ( _
   BYVAL DWORD _                       ' __in HANDLE hHandle
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 , BYVAL LONG _                        ' __in BOOL bAlertable
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WaitForMultipleObjectsEx LIB "KERNEL32.DLL" ALIAS "WaitForMultipleObjectsEx" ( _
   BYVAL DWORD _                       ' __in DWORD nCount
 , BYREF DWORD _                       ' __in_ecount(nCount) CONST HANDLE *lpHandles
 , BYVAL LONG _                        ' __in BOOL bWaitAll
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 , BYVAL LONG _                        ' __in BOOL bAlertable
 ) AS DWORD                            ' DWORD

'#if(_WIN32_WINNT >= 0x0400)

DECLARE FUNCTION SignalObjectAndWait LIB "KERNEL32.DLL" ALIAS "SignalObjectAndWait" ( _
   BYVAL DWORD _                       ' __in HANDLE hObjectToSignal
 , BYVAL DWORD _                       ' __in HANDLE hObjectToWaitOn
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 , BYVAL LONG _                        ' __in BOOL bAlertable
 ) AS DWORD                            ' DWORD

'#endif /* _WIN32_WINNT >= 0x0400 */

DECLARE FUNCTION ReadFileEx LIB "KERNEL32.DLL" ALIAS "ReadFileEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFile
 , BYREF ANY _                         ' __out_bcount(nNumberOfBytesToRead) LPVOID lpBuffer
 , BYVAL DWORD _                       ' __in     DWORD nNumberOfBytesToRead
 , BYREF OVERLAPPED _                  ' __inout  LPOVERLAPPED lpOverlapped
 , BYVAL DWORD _                       ' __in_opt LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WriteFileEx LIB "KERNEL32.DLL" ALIAS "WriteFileEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFile
 , BYREF ANY _                         ' __in_bcount(nNumberOfBytesToWrite) LPCVOID lpBuffer
 , BYVAL DWORD _                       ' __in     DWORD nNumberOfBytesToWrite
 , BYREF OVERLAPPED _                  ' __inout  LPOVERLAPPED lpOverlapped
 , BYVAL DWORD _                       ' __in_opt LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BackupRead LIB "KERNEL32.DLL" ALIAS "BackupRead" ( _
   BYVAL DWORD _                       ' __in    HANDLE hFile
 , BYREF BYTE _                        ' __out_bcount_part(nNumberOfBytesToRead, *lpNumberOfBytesRead) LPBYTE lpBuffer
 , BYVAL DWORD _                       ' __in    DWORD nNumberOfBytesToRead
 , BYREF DWORD _                       ' __out   LPDWORD lpNumberOfBytesRead
 , BYVAL LONG _                        ' __in    BOOL bAbort
 , BYVAL LONG  _                       ' __in    BOOL bProcessSecurity
 , BYREF ANY _                         ' __inout LPVOID *lpContext
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BackupSeek LIB "KERNEL32.DLL" ALIAS "BackupSeek" ( _
   BYVAL DWORD _                       ' __in    HANDLE hFile
 , BYVAL DWORD _                       ' __in    DWORD  dwLowBytesToSeek
 , BYVAL DWORD _                       ' __in    DWORD  dwHighBytesToSeek
 , BYREF DWORD _                       ' __out   LPDWORD lpdwLowByteSeeked
 , BYREF DWORD _                       ' __out   LPDWORD lpdwHighByteSeeked
 , BYVAL DWORD _                       ' __inout LPVOID *lpContext
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BackupWrite LIB "KERNEL32.DLL" ALIAS "BackupWrite" ( _
   BYVAL DWORD _                       ' __in    HANDLE hFile
 , BYREF BYTE _                        ' __in_bcount(nNumberOfBytesToWrite) LPBYTE lpBuffer
 , BYVAL DWORD _                       ' __in    DWORD nNumberOfBytesToWrite
 , BYREF DWORD _                       ' __out   LPDWORD lpNumberOfBytesWritten
 , BYVAL LONG _                        ' __in    BOOL bAbort
 , BYVAL LONG _                        ' __in    BOOL bProcessSecurity
 , BYVAL DWORD _                       ' __inout LPVOID *lpContext
 ) AS LONG                             ' BOOL

'//
'//  Stream id structure
'//
TYPE WIN32_STREAM_ID
   dwStreamID         AS DWORD      ' DWORD          dwStreamId
   dwStreamAttributes AS DWORD      ' DWORD          dwStreamAttributes
   qsize              AS QUAD       ' LARGE_INTEGER  Size
   dwStreamNameSize   AS DWORD      ' DWORD          dwStreamNameSize
   cStreamName(0)     AS WORD       ' WCHAR          cStreamName[ ANYSIZE_ARRAY ]
END TYPE

'//
'//  Stream Ids
'//

%BACKUP_INVALID          = &H00000000???
%BACKUP_DATA             = &H00000001???
%BACKUP_EA_DATA          = &H00000002???
%BACKUP_SECURITY_DATA    = &H00000003???
%BACKUP_ALTERNATE_DATA   = &H00000004???
%BACKUP_LINK             = &H00000005???
%BACKUP_PROPERTY_DATA    = &H00000006???
%BACKUP_OBJECT_ID        = &H00000007???
%BACKUP_REPARSE_DATA     = &H00000008???
%BACKUP_SPARSE_BLOCK     = &H00000009???
%BACKUP_TXFS_DATA        = &H0000000a???

'//
'//  Stream Attributes
'//

%STREAM_NORMAL_ATTRIBUTE         = &H00000000???
%STREAM_MODIFIED_WHEN_READ       = &H00000001???
%STREAM_CONTAINS_SECURITY        = &H00000002???
%STREAM_CONTAINS_PROPERTIES      = &H00000004???
%STREAM_SPARSE_ATTRIBUTE         = &H00000008???

DECLARE FUNCTION ReadFileScatter LIB "KERNEL32.DLL" ALIAS "ReadFileScatter" ( _
   BYVAL DWORD _                       ' __in       HANDLE hFile
 , BYREF FILE_SEGMENT_ELEMENT _        ' __in       FILE_SEGMENT_ELEMENT aSegmentArray[]
 , BYVAL DWORD _                       ' __in       DWORD nNumberOfBytesToRead
 , BYVAL DWORD _                       ' __reserved LPDWORD lpReserved
 , BYREF DWORD _                       ' __inout    LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WriteFileGather LIB "KERNEL32.DLL" ALIAS "WriteFileGather" ( _
   BYVAL DWORD _                       ' __in       HANDLE hFile
 , BYREF FILE_SEGMENT_ELEMENT _        ' __in       FILE_SEGMENT_ELEMENT aSegmentArray[]
 , BYVAL DWORD _                       ' __in       DWORD nNumberOfBytesToWrite
 , BYVAL DWORD _                       ' __reserved LPDWORD lpReserved
 , BYREF DWORD _                       ' __inout    LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

'//
'// Dual Mode API below this line. Dual Mode Structures also included.
'//

%STARTF_USESHOWWINDOW    = &H00000001???
%STARTF_USESIZE          = &H00000002???
%STARTF_USEPOSITION      = &H00000004???
%STARTF_USECOUNTCHARS    = &H00000008???
%STARTF_USEFILLATTRIBUTE = &H00000010???
%STARTF_RUNFULLSCREEN    = &H00000020???     ' ignored for non-x86 platforms
%STARTF_FORCEONFEEDBACK  = &H00000040???
%STARTF_FORCEOFFFEEDBACK = &H00000080???
%STARTF_USESTDHANDLES    = &H00000100???
'#if(WINVER >= 0x0400)
%STARTF_USEHOTKEY        = &H00000200???
'#endif /* WINVER >= 0x0400 */

TYPE STARTUPINFOA
   cb              AS DWORD        ' DWORD   cb
   lpReserved      AS ASCIIZ PTR   ' LPSTR   lpReserved
   lpDesktop       AS ASCIIZ PTR   ' LPSTR   lpDesktop
   lpTitle         AS ASCIIZ PTR   ' LPSTR   lpTitle
   dwX             AS DWORD        ' DWORD   dwX
   dwY             AS DWORD        ' DWORD   dwY
   dwXSize         AS DWORD        ' DWORD   dwXSize
   dwYSize         AS DWORD        ' DWORD   dwYSize
   dwXCountChars   AS DWORD        ' DWORD   dwXCountChars
   dwYCountChars   AS DWORD        ' DWORD   dwYCountChars
   dwFillAttribute AS DWORD        ' DWORD   dwFillAttribute
   dwFlags         AS DWORD        ' DWORD   dwFlags
   wShowWindow     AS WORD         ' WORD    wShowWindow
   cbReserved2     AS WORD         ' WORD    cbReserved2
   lpReserved2     AS BYTE PTR     ' LPBYTE  lpReserved2
   hStdInput       AS DWORD        ' HANDLE  hStdInput
   hStdOutput      AS DWORD        ' HANDLE  hStdOutput
   hStdError       AS DWORD        ' HANDLE  hStdError
END TYPE

TYPE STARTUPINFOW
   cb              AS DWORD        ' DWORD   cb
   lpReserved      AS WORD PTR     ' LPWSTR  lpReserved
   lpDesktop       AS WORD PTR     ' LPWSTR  lpDesktop
   lpTitle         AS WORD PTR     ' LPWSTR  lpTitle
   dwX             AS DWORD        ' DWORD   dwX
   dwY             AS DWORD        ' DWORD   dwY
   dwXSize         AS DWORD        ' DWORD   dwXSize
   dwYSize         AS DWORD        ' DWORD   dwYSize
   dwXCountChars   AS DWORD        ' DWORD   dwXCountChars
   dwYCountChars   AS DWORD        ' DWORD   dwYCountChars
   dwFillAttribute AS DWORD        ' DWORD   dwFillAttribute
   dwFlags         AS DWORD        ' DWORD   dwFlags
   wShowWindow     AS WORD         ' WORD    wShowWindow
   cbReserved2     AS WORD         ' WORD    cbReserved2
   lpReserved2     AS BYTE PTR     ' LPBYTE  lpReserved2
   hStdInput       AS DWORD        ' HANDLE  hStdInput
   hStdOutput      AS DWORD        ' HANDLE  hStdOutput
   hStdError       AS DWORD        ' HANDLE  hStdError
END TYPE

MACRO STARTUPINFO = STARTUPINFOA

TYPE STARTUPINFOEXA
   StartupInfo AS STARTUPINFOA
   lpAttributeList AS DWORD   ' struct _PROC_THREAD_ATTRIBUTE_LIST *
END TYPE

TYPE STARTUPINFOEXW
   StartupInfo AS STARTUPINFOW
   lpAttributeList AS DWORD   ' struct _PROC_THREAD_ATTRIBUTE_LIST *
END TYPE

MACRO STARTUPINFOEX = STARTUPINFOEXA

%SHUTDOWN_NORETRY = &H00000001???

TYPE WIN32_FIND_DATAA
   dwFileAttributes   AS DWORD                ' DWORD dwFileAttributes
   ftCreationTime     AS FILETIME             ' FILETIME ftCreationTime
   ftLastAccessTime   AS FILETIME             ' FILETIME ftLastAccessTime
   ftLastWriteTime    AS FILETIME             ' FILETIME ftLastWriteTime
   nFileSizeHigh      AS DWORD                ' DWORD nFileSizeHigh
   nFileSizeLow       AS DWORD                ' DWORD nFileSizeLow
   dwReserved0        AS DWORD                ' DWORD dwReserved0
   dwReserved1        AS DWORD                ' DWORD dwReserved1
   cFileName          AS ASCIIZ * %MAX_PATH   ' CHAR   cFileName[ MAX_PATH ]
   cAlternateFileName AS ASCIIZ * 14          ' CHAR   cAlternateFileName[ 14 ]
END TYPE

TYPE WIN32_FIND_DATAW
   dwFileAttributes   AS DWORD                   ' DWORD dwFileAttributes
   ftCreationTime     AS FILETIME                ' FILETIME ftCreationTime
   ftLastAccessTime   AS FILETIME                ' FILETIME ftLastAccessTime
   ftLastWriteTime    AS FILETIME                ' FILETIME ftLastWriteTime
   nFileSizeHigh      AS DWORD                   ' DWORD nFileSizeHigh
   nFileSizeLow       AS DWORD                   ' DWORD nFileSizeLow
   dwReserved0        AS DWORD                   ' DWORD dwReserved0
   dwReserved1        AS DWORD                   ' DWORD dwReserved1
   cFileName          AS STRING * %MAX_PATH * 2  ' WCHAR  cFileName[ MAX_PATH ]
   cAlternateFileName AS STRING * 14 * 2         ' WCHAR  cAlternateFileName[ 14 ]
END TYPE

MACRO WIN32_FIND_DATA = WIN32_FIND_DATAA

TYPE WIN32_FILE_ATTRIBUTE_DATA
   dwFileAttributes AS DWORD      ' DWORD dwFileAttributes
   ftCreationTime   AS FILETIME   ' FILETIME ftCreationTime
   ftLastAccessTime AS FILETIME   ' FILETIME ftLastAccessTime
   ftLastWriteTime  AS FILETIME   ' FILETIME ftLastWriteTime
   nFileSizeHigh    AS DWORD      ' DWORD nFileSizeHigh
   nFileSizeLow     AS DWORD      ' DWORD nFileSizeLow
END TYPE

DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpMutexAttributes
 , BYVAL LONG _                        ' __in     BOOL bInitialOwner
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateMutexW LIB "KERNEL32.DLL" ALIAS "CreateMutexW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpMutexAttributes
 , BYVAL LONG _                        ' __in     BOOL bInitialOwner
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenMutex LIB "KERNEL32.DLL" ALIAS "OpenMutexA" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYREF ASCIIZ _                      ' __in LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenMutexW LIB "KERNEL32.DLL" ALIAS "OpenMutexW" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateEvent LIB "KERNEL32.DLL" ALIAS "CreateEventA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpEventAttributes
 , BYVAL LONG _                        ' __in     BOOL bManualReset
 , BYVAL LONG _                        ' __in     BOOL bInitialState
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateEventW LIB "KERNEL32.DLL" ALIAS "CreateEventW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpEventAttributes
 , BYVAL LONG _                        ' __in     BOOL bManualReset
 , BYVAL LONG _                        ' __in     BOOL bInitialState
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenEvent LIB "KERNEL32.DLL" ALIAS "OpenEventA" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYREF ASCIIZ _                      ' __in LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenEventW LIB "KERNEL32.DLL" ALIAS "OpenEventW" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateSemaphore LIB "KERNEL32.DLL" ALIAS "CreateSemaphoreA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSemaphoreAttributes
 , BYVAL LONG _                        ' __in     LONG lInitialCount
 , BYVAL LONG _                        ' __in     LONG lMaximumCount
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateSemaphoreW LIB "KERNEL32.DLL" ALIAS "CreateSemaphoreW" ( _
   BYREF SECURITY_ATTRIBUTES  _        ' __in_opt LPSECURITY_ATTRIBUTES lpSemaphoreAttributes
 , BYVAL LONG _                        ' __in     LONG lInitialCount
 , BYVAL LONG _                        ' __in     LONG lMaximumCount
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenSemaphore LIB "KERNEL32.DLL" ALIAS "OpenSemaphoreA" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYREF ASCIIZ _                      ' __in LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenSemaphoreW LIB "KERNEL32.DLL" ALIAS "OpenSemaphoreW" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

'#if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
'typedef
'VOID
'(APIENTRY *PTIMERAPCROUTINE)(
'    __in_opt LPVOID lpArgToCompletionRoutine,
'    __in     DWORD dwTimerLowValue,
'    __in     DWORD dwTimerHighValue
'    );

DECLARE FUNCTION CreateWaitableTimer LIB "KERNEL32.DLL" ALIAS "CreateWaitableTimerA" ( _
   BYREF SECURITY_ATTRIBUTES  _        ' __in_opt LPSECURITY_ATTRIBUTES lpTimerAttributes
 , BYVAL LONG _                        ' __in     BOOL bManualReset
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpTimerName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateWaitableTimerW LIB "KERNEL32.DLL" ALIAS "CreateWaitableTimerW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpTimerAttributes
 , BYVAL LONG _                        ' __in     BOOL bManualReset
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpTimerName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenWaitableTimer LIB "KERNEL32.DLL" ALIAS "OpenWaitableTimerA" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYREF ASCIIZ _                      ' __in LPCSTR lpTimerName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenWaitableTimerW LIB "KERNEL32.DLL" ALIAS "OpenWaitableTimerW" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in LPCWSTR lpTimerName
 ) AS DWORD                            ' HANDLE

' Note: Although the lpDueTime parameter is a QUAD, it is more practical to use
' a FILETIME structure. Therefore, the parameter as been declared BYREF ANY to
' allow passing a QUAD or a FILETIME structure.

DECLARE FUNCTION SetWaitableTimer LIB "KERNEL32.DLL" ALIAS "SetWaitableTimer" ( _
   BYVAL DWORD _                       ' __in     HANDLE hTimer
 , BYREF QUAD _                        ' __in     const LARGE_INTEGER *lpDueTime
 , BYVAL LONG _                        ' __in     LONG lPeriod
 , BYVAL DWORD _                       ' __in_opt PTIMERAPCROUTINE pfnCompletionRoutine
 , BYVAL DWORD _                       ' __in_opt LPVOID lpArgToCompletionRoutine
 , BYVAL LONG _                        ' __in     BOOL fResume
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CancelWaitableTimer LIB "KERNEL32.DLL" ALIAS "CancelWaitableTimer" ( _
   BYVAL DWORD _                       ' __in HANDLE hTimer
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

%CREATE_MUTEX_INITIAL_OWNER  = &H00000001???

DECLARE FUNCTION CreateMutexEx LIB "KERNEL32.DLL" ALIAS "CreateMutexExA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpMutexAttributes
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateMutexExW LIB "KERNEL32.DLL" ALIAS "CreateMutexExW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpMutexAttributes
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 ) AS DWORD                            ' HANDLE

%CREATE_EVENT_MANUAL_RESET   = &H00000001???
%CREATE_EVENT_INITIAL_SET    = &H00000002???

DECLARE FUNCTION CreateEventEx LIB "KERNEL32.DLL" ALIAS "CreateEventExA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpEventAttributes
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateEventExW LIB "KERNEL32.DLL" ALIAS "CreateEventExW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpEventAttributes
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateSemaphoreEx LIB "KERNEL32.DLL" ALIAS "CreateSemaphoreExA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSemaphoreAttributes
 , BYVAL LONG _                        ' __in        LONG lInitialCount
 , BYVAL LONG _                        ' __in        LONG lMaximumCount
 , BYREF ASCIIZ _                      ' __in_opt    LPCSTR lpName
 , BYVAL DWORD _                       ' __reserved  DWORD dwFlags
 , BYVAL DWORD _                       ' __in        DWORD dwDesiredAccess
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateSemaphoreExW LIB "KERNEL32.DLL" ALIAS "CreateSemaphoreExW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSemaphoreAttributes
 , BYVAL LONG _                        ' __in        LONG lInitialCount
 , BYVAL LONG _                        ' __in        LONG lMaximumCount
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpName
 , BYVAL DWORD _                       ' __reserved  DWORD dwFlags
 , BYVAL DWORD _                       ' __in        DWORD dwDesiredAccess
 ) AS DWORD                            ' HANDLE

%CREATE_WAITABLE_TIMER_MANUAL_RESET  = &H00000001???

DECLARE FUNCTION CreateWaitableTimerEx LIB "KERNEL32.DLL" ALIAS "CreateWaitableTimerExA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSemaphoreAttributes
 , BYREF ASCIIZ _                      ' __in_opt    LPCSTR lpTimerName
 , BYVAL DWORD _                       ' __reserved  DWORD dwFlags
 , BYVAL DWORD _                       ' __in        DWORD dwDesiredAccess
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateWaitableTimerExW LIB "KERNEL32.DLL" ALIAS "CreateWaitableTimerExW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSemaphoreAttributes
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpTimerName
 , BYVAL DWORD _                       ' __reserved  DWORD dwFlags
 , BYVAL DWORD _                       ' __in        DWORD dwDesiredAccess
 ) AS DWORD                            ' HANDLE

#ENDIF ' /* (_WIN32_WINNT >= 0x0600) */


'#endif /* (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400) */

DECLARE FUNCTION CreateFileMapping LIB "KERNEL32.DLL" ALIAS "CreateFileMappingA" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFile
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpFileMappingAttributes
 , BYVAL DWORD _                       ' __in     DWORD flProtect
 , BYVAL DWORD _                       ' __in     DWORD dwMaximumSizeHigh
 , BYVAL DWORD _                       ' __in     DWORD dwMaximumSizeLow
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateFileMappingW LIB "KERNEL32.DLL" ALIAS "CreateFileMappingW" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFile
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpFileMappingAttributes
 , BYVAL DWORD _                       ' __in     DWORD flProtect
 , BYVAL DWORD _                       ' __in     DWORD dwMaximumSizeHigh
 , BYVAL DWORD _                       ' __in     DWORD dwMaximumSizeLow
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION CreateFileMappingNuma LIB "KERNEL32.DLL" ALIAS "CreateFileMappingNumaA" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFile
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpFileMappingAttributes
 , BYVAL DWORD _                       ' __in     DWORD flProtect
 , BYVAL DWORD _                       ' __in     DWORD dwMaximumSizeHigh
 , BYVAL DWORD _                       ' __in     DWORD dwMaximumSizeLow
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD nndPreferred
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateFileMappingNumaW LIB "KERNEL32.DLL" ALIAS "CreateFileMappingNumaW" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFile
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpFileMappingAttributes
 , BYVAL DWORD _                       ' __in     DWORD flProtect
 , BYVAL DWORD _                       ' __in     DWORD dwMaximumSizeHigh
 , BYVAL DWORD _                       ' __in     DWORD dwMaximumSizeLow
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD nndPreferred
 ) AS DWORD                            ' HANDLE

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION OpenFileMapping LIB "KERNEL32.DLL" ALIAS "OpenFileMappingA" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYREF ASCIIZ _                      ' __in LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenFileMappingW LIB "KERNEL32.DLL" ALIAS "OpenFileMappingW" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetLogicalDriveStrings LIB "KERNEL32.DLL" ALIAS "GetLogicalDriveStringsA" ( _
   BYVAL DWORD _                       ' __in DWORD nBufferLength
 , BYREF ANY _                         ' __out_ecount_part_opt(nBufferLength, return + 1) LPSTR lpBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetLogicalDriveStringsW LIB "KERNEL32.DLL" ALIAS "GetLogicalDriveStringsW" ( _
   BYVAL DWORD _                       ' __in DWORD nBufferLength
 , BYREF ANY _                         ' __out_ecount_part_opt(nBufferLength, return + 1) LPWSTR lpBuffer
 ) AS DWORD                            ' DWORD

'#if _WIN32_WINNT >= 0x0501

' MEMORY_RESOURCE_NOTIFICATION_TYPE enum
%LowMemoryResourceNotification  = 0
%HighMemoryResourceNotification = 1

DECLARE FUNCTION CreateMemoryResourceNotification LIB "KERNEL32.DLL" ALIAS "CreateMemoryResourceNotification" ( _
   BYVAL DWORD _                       ' __in MEMORY_RESOURCE_NOTIFICATION_TYPE NotificationType
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION QueryMemoryResourceNotification LIB "KERNEL32.DLL" ALIAS "QueryMemoryResourceNotification" ( _
   BYVAL DWORD _                       ' __in  HANDLE ResourceNotificationHandle
 , BYREF LONG _                        ' __out PBOOL  ResourceState
 ) AS LONG                             ' BOOL

'#endif // _WIN32_WINNT >= 0x0501


DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpLibFileName
 ) AS DWORD                            ' HMODULE

DECLARE FUNCTION LoadLibraryW LIB "KERNEL32.DLL" ALIAS "LoadLibraryW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpLibFileName
 ) AS DWORD                            ' HMODULE

DECLARE FUNCTION LoadLibraryEx LIB "KERNEL32.DLL" ALIAS "LoadLibraryExA" ( _
   BYREF ASCIIZ _                      ' __in       LPCSTR lpLibFileName
 , BYVAL DWORD _                       ' __reserved HANDLE hFile
 , BYVAL DWORD _                       ' __in       DWORD dwFlags
 ) AS DWORD                            ' HMODULE

DECLARE FUNCTION LoadLibraryExW LIB "KERNEL32.DLL" ALIAS "LoadLibraryExW" ( _
   BYVAL DWORD _                       ' __in       LPCWSTR lpLibFileName
 , BYVAL DWORD _                       ' __reserved HANDLE hFile
 , BYVAL DWORD _                       ' __in       DWORD dwFlags
 ) AS DWORD                            ' HMODULE

%DONT_RESOLVE_DLL_REFERENCES        = &H00000001???
%LOAD_LIBRARY_AS_DATAFILE           = &H00000002???
%LOAD_WITH_ALTERED_SEARCH_PATH      = &H00000008???
%LOAD_IGNORE_CODE_AUTHZ_LEVEL       = &H00000010???
%LOAD_LIBRARY_AS_IMAGE_RESOURCE     = &H00000020???
%LOAD_LIBRARY_AS_DATAFILE_EXCLUSIVE = &H00000040???

DECLARE FUNCTION GetModuleFileName LIB "KERNEL32.DLL" ALIAS "GetModuleFileNameA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYREF ASCIIZ _                      ' __out_ecount_part(nSize, return + 1) LPCH lpFilename
 , BYVAL DWORD _                       ' __in     DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetModuleFileNameW LIB "KERNEL32.DLL" ALIAS "GetModuleFileNameW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __out_ecount_part(nSize, return + 1) LPWCH lpFilename
 , BYVAL DWORD _                       ' __in     DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpModuleName
 ) AS DWORD                            ' HMODULE

'#IF %DEF(%CCWIN)
'      FUNCTION GethInst () AS DWORD
'         FUNCTION = GetModuleHandle(BYVAL %NULL)
'      END FUNCTION
'#ENDIF

DECLARE FUNCTION GetModuleHandleW LIB "KERNEL32.DLL" ALIAS "GetModuleHandleW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpModuleName
 ) AS DWORD                            ' HMODULE

'#if !defined(RC_INVOKED)
'#if _WIN32_WINNT > 0x0500 || defined(WINBASE_DECLARE_GET_MODULE_HANDLE_EX) || ISOLATION_AWARE_ENABLED

%GET_MODULE_HANDLE_EX_FLAG_PIN                 = &H00000001???
%GET_MODULE_HANDLE_EX_FLAG_UNCHANGED_REFCOUNT  = &H00000002???
%GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS        = &H00000004???

'typedef
'BOOL
'(WINAPI*
'PGET_MODULE_HANDLE_EXA)(
'    __in        DWORD        dwFlags,
'    __in_opt    LPCSTR     lpModuleName,
'    __deref_out HMODULE*    phModule
'    );
'typedef

'BOOL
'(WINAPI*
'PGET_MODULE_HANDLE_EXW)(
'    __in        DWORD        dwFlags,
'    __in_opt    LPCWSTR     lpModuleName,
'    __deref_out HMODULE*    phModule
'    );

DECLARE FUNCTION GetModuleHandleEx LIB "KERNEL32.DLL" ALIAS "GetModuleHandleExA" ( _
   BYVAL DWORD _                       ' __in        DWORD    dwFlags
 , BYREF ASCIIZ _                      ' __in_opt    LPCSTR lpModuleName
 , BYREF DWORD _                       ' __out HMODULE* phModule
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetModuleHandleExW LIB "KERNEL32.DLL" ALIAS "GetModuleHandleExW" ( _
   BYVAL DWORD _                       ' __in        DWORD    dwFlags
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpModuleName
 , BYREF DWORD _                       ' __out HMODULE* phModule
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0502

DECLARE FUNCTION NeedCurrentDirectoryForExePath LIB "KERNEL32.DLL" ALIAS "NeedCurrentDirectoryForExePathA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR ExeName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION NeedCurrentDirectoryForExePathW LIB "KERNEL32.DLL" ALIAS "NeedCurrentDirectoryForExePathW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR ExeName
 ) AS LONG                             ' BOOL

'#endif

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

%PROCESS_NAME_NATIVE     = &H00000001???

DECLARE FUNCTION QueryFullProcessImageName LIB "KERNEL32.DLL" ALIAS "QueryFullProcessImageNameA" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYREF ASCIIZ _                      ' __out_ecount_part(*lpdwSize, *lpdwSize) LPSTR lpExeName
 , BYREF DWORD _                       ' __inout PDWORD lpdwSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION QueryFullProcessImageNameW LIB "KERNEL32.DLL" ALIAS "QueryFullProcessImageNameW" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __out_ecount_part(*lpdwSize, *lpdwSize) LPWSTR lpExeName
 , BYREF DWORD _                       ' __inout PDWORD lpdwSize
 ) AS LONG                             ' BOOL

#ENDIF


'//
'// Extended process and thread attribute support
'//

%PROC_THREAD_ATTRIBUTE_NUMBER    = &H0000FFFF???
%PROC_THREAD_ATTRIBUTE_THREAD    = &H00010000???  ' // Attribute may be used with thread creation
%PROC_THREAD_ATTRIBUTE_INPUT     = &H00020000???  ' // Attribute is input only
%PROC_THREAD_ATTRIBUTE_ADDITIVE  = &H00040000???  ' // Attribute may be "accumulated," e.g. bitmasks, counters, etc.

' enum PROC_THREAD_ATTRIBUTE_NUM
%ProcThreadAttributeParentProcess = 0
%ProcThreadAttributeExtendedFlags = 1
%ProcThreadAttributeHandleList    = 2
%ProcThreadAttributeMax           = 3

'#define ProcThreadAttributeValue(Number, Thread, Input, Additive) \
'    (((Number) & PROC_THREAD_ATTRIBUTE_NUMBER) | \
'     ((Thread != FALSE) ? PROC_THREAD_ATTRIBUTE_THREAD : 0) | \
'     ((Input != FALSE) ? PROC_THREAD_ATTRIBUTE_INPUT : 0) | \
'     ((Additive != FALSE) ? PROC_THREAD_ATTRIBUTE_ADDITIVE : 0))

'#define PROC_THREAD_ATTRIBUTE_PARENT_PROCESS \
'    ProcThreadAttributeValue (ProcThreadAttributeParentProcess, FALSE, TRUE, FALSE)
'#define PROC_THREAD_ATTRIBUTE_EXTENDED_FLAGS \
'    ProcThreadAttributeValue (ProcThreadAttributeExtendedFlags, FALSE, TRUE, TRUE)
'#define PROC_THREAD_ATTRIBUTE_HANDLE_LIST \
'    ProcThreadAttributeValue (ProcThreadAttributeHandleList, FALSE, TRUE, FALSE)

'typedef struct _PROC_THREAD_ATTRIBUTE_LIST *PPROC_THREAD_ATTRIBUTE_LIST, *LPPROC_THREAD_ATTRIBUTE_LIST;

DECLARE FUNCTION InitializeProcThreadAttributeList LIB "KERNEL32.DLL" ALIAS "InitializeProcThreadAttributeList" ( _
   BYREF DWORD _                       ' __out_xcount_opt(*lpSize) LPPROC_THREAD_ATTRIBUTE_LIST lpAttributeList
 , BYVAL DWORD _                       ' __in DWORD dwAttributeCount
 , BYVAL DWORD _                       ' __in __reserved DWORD dwFlags
 , BYREF DWORD _                       ' __inout PSIZE_T lpSize
 ) AS LONG                             ' BOOL

DECLARE SUB DeleteProcThreadAttributeList LIB "KERNEL32.DLL" ALIAS "DeleteProcThreadAttributeList" ( _
   BYREF DWORD _                       ' __inout LPPROC_THREAD_ATTRIBUTE_LIST lpAttributeList
 )                                     ' VOID

%PROC_THREAD_ATTRIBUTE_REPLACE_VALUE     = &H00000001???

DECLARE FUNCTION UpdateProcThreadAttribute LIB "KERNEL32.DLL" ALIAS "UpdateProcThreadAttribute" ( _
   BYREF DWORD _                       ' __inout LPPROC_THREAD_ATTRIBUTE_LIST lpAttributeList
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in DWORD_PTR Attribute
 , BYVAL DWORD _                       ' __in_bcount_opt(cbSize) PVOID lpValue
 , BYVAL DWORD _                       ' __in SIZE_T cbSize
 , BYREF DWORD _                       ' __out_bcount_opt(cbSize) PVOID lpPreviousValue
 , BYVAL DWORD _                       ' __in_opt PSIZE_T lpReturnSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateProcess LIB "KERNEL32.DLL" ALIAS "CreateProcessA" ( _
   BYREF ASCIIZ _                      ' __in_opt    LPCSTR lpApplicationName
 , BYREF ASCIIZ _                      ' __inout_opt LPSTR lpCommandLine
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpProcessAttributes
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpThreadAttributes
 , BYVAL LONG _                        ' __in        BOOL bInheritHandles
 , BYVAL DWORD _                       ' __in        DWORD dwCreationFlags
 , BYVAL DWORD _                       ' __in_opt    LPVOID lpEnvironment
 , BYREF ASCIIZ _                      ' __in_opt    LPCSTR lpCurrentDirectory
 , BYREF STARTUPINFOA _                ' __in        LPSTARTUPINFOA lpStartupInfo
 , BYREF PROCESS_INFORMATION _         ' LPPROCESS_INFORMATION lpProcessInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateProcessW LIB "KERNEL32.DLL" ALIAS "CreateProcessW" ( _
   BYVAL DWORD _                       ' __in_opt    LPCWSTR lpApplicationName
 , BYVAL DWORD _                       ' __inout_opt LPWSTR lpCommandLine
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpProcessAttributes
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpThreadAttributes
 , BYVAL LONG _                        ' __in        BOOL bInheritHandles
 , BYVAL DWORD _                       ' __in        DWORD dwCreationFlags
 , BYVAL DWORD _                       ' __in_opt    LPVOID lpEnvironment
 , BYVAL DWORD _                       ' __in_opt    LPVOID lpEnvironment
 , BYREF STARTUPINFOW _                ' __in        LPSTARTUPINFOW lpStartupInfo
 , BYREF PROCESS_INFORMATION _         ' LPPROCESS_INFORMATION lpProcessInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetProcessShutdownParameters LIB "KERNEL32.DLL" ALIAS "SetProcessShutdownParameters" ( _
   BYVAL DWORD _                       ' __in DWORD dwLevel
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcessShutdownParameters LIB "KERNEL32.DLL" ALIAS "GetProcessShutdownParameters" ( _
   BYREF DWORD _                       ' __out LPDWORD lpdwLevel
 , BYREF DWORD _                       ' __out LPDWORD lpdwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcessVersion LIB "KERNEL32.DLL" ALIAS "GetProcessVersion" ( _
   BYVAL DWORD _                       ' __in DWORD ProcessId
 ) AS DWORD                            ' DWORD

DECLARE SUB FatalAppExit LIB "KERNEL32.DLL" ALIAS "FatalAppExitA" ( _
   BYVAL DWORD _                       ' __in UINT uAction
 , BYREF ASCIIZ _                      ' __in LPCSTR lpMessageText
 )                                     ' VOID

DECLARE SUB FatalAppExitW LIB "KERNEL32.DLL" ALIAS "FatalAppExitW" ( _
   BYVAL DWORD _                       ' __in UINT uAction
 , BYVAL DWORD _                       ' __in LPCWSTR lpMessageText
 )                                     ' VOID

DECLARE SUB GetStartupInfo LIB "KERNEL32.DLL" ALIAS "GetStartupInfoA" ( _
   BYREF STARTUPINFOA _                ' __out LPSTARTUPINFOA lpStartupInfo
 )                                     ' VOID

DECLARE SUB GetStartupInfoW LIB "KERNEL32.DLL" ALIAS "GetStartupInfoW" ( _
   BYREF STARTUPINFOW _                ' __out LPSTARTUPINFOW lpStartupInfo
 )                                     ' VOID

DECLARE FUNCTION GetCommandLine LIB "KERNEL32.DLL" ALIAS "GetCommandLineA" ( _
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION GetCommandLineW LIB "KERNEL32.DLL" ALIAS "GetCommandLineW" ( _
 ) AS DWORD                            ' LPWSTR

DECLARE FUNCTION GetEnvironmentVariable LIB "KERNEL32.DLL" ALIAS "GetEnvironmentVariableA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpName
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nSize, return + 1) LPSTR lpBuffer
 , BYVAL DWORD _                       ' __in DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetEnvironmentVariableW LIB "KERNEL32.DLL" ALIAS "GetEnvironmentVariableW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpName
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nSize, return + 1) LPWSTR lpBuffer
 , BYVAL DWORD _                       ' __in DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetEnvironmentVariable LIB "KERNEL32.DLL" ALIAS "SetEnvironmentVariableA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpValue
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetEnvironmentVariableW LIB "KERNEL32.DLL" ALIAS "SetEnvironmentVariableW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpValue
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ExpandEnvironmentStrings LIB "KERNEL32.DLL" ALIAS "ExpandEnvironmentStringsA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpSrc
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nSize, return) LPSTR lpDst
 , BYVAL DWORD _                       ' __in DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION ExpandEnvironmentStringsW LIB "KERNEL32.DLL" ALIAS "ExpandEnvironmentStringsW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpSrc
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nSize, return) LPWSTR lpDst
 , BYVAL DWORD _                       ' __in DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetFirmwareEnvironmentVariable LIB "KERNEL32.DLL" ALIAS "GetFirmwareEnvironmentVariableA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpGuid
 , BYREF ANY _                         ' __out_bcount_part_opt(nSize, return) PVOID pBuffer
 , BYVAL DWORD _                       ' __in DWORD    nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetFirmwareEnvironmentVariableW LIB "KERNEL32.DLL" ALIAS "GetFirmwareEnvironmentVariableW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpName
 , BYVAL DWORD _                       ' __in LPCWSTR lpGuid
 , BYREF ANY _                         ' __out_bcount_part_opt(nSize, return) PVOID pBuffer
 , BYVAL DWORD _                       ' __in DWORD    nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetFirmwareEnvironmentVariable LIB "KERNEL32.DLL" ALIAS "SetFirmwareEnvironmentVariableA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpGuid
 , BYVAL DWORD _                       ' __in_bcount_opt(nSize) PVOID pValue
 , BYVAL DWORD _                       ' __in DWORD    nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFirmwareEnvironmentVariableW LIB "KERNEL32.DLL" ALIAS "SetFirmwareEnvironmentVariableW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpName
 , BYVAL DWORD _                       ' __in LPCWSTR lpGuid
 , BYVAL DWORD _                       ' __in_bcount_opt(nSize) PVOID pValue
 , BYVAL DWORD _                       ' __in DWORD    nSize
 ) AS LONG                             ' BOOL

DECLARE SUB OutputDebugString LIB "KERNEL32.DLL" ALIAS "OutputDebugStringA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpOutputString
 )                                     ' VOID

DECLARE SUB OutputDebugStringW LIB "KERNEL32.DLL" ALIAS "OutputDebugStringW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpOutputString
 )                                     ' VOID

DECLARE FUNCTION FindResource LIB "KERNEL32.DLL" ALIAS "FindResourceA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpType
 ) AS DWORD                            ' HRSRC

DECLARE FUNCTION FindResourceW LIB "KERNEL32.DLL" ALIAS "FindResourceW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in     LPCWSTR lpName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpType
 ) AS DWORD                            ' HRSRC

DECLARE FUNCTION FindResourceEx LIB "KERNEL32.DLL" ALIAS "FindResourceExA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpType
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpName
 , BYVAL WORD _                        ' __in     WORD    wLanguage
 ) AS DWORD                            ' HRSRC

DECLARE FUNCTION FindResourceExW LIB "KERNEL32.DLL" ALIAS "FindResourceExW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in     LPCWSTR lpType
 , BYVAL DWORD _                       ' __in     LPCWSTR lpName
 , BYVAL WORD _                        ' __in     WORD    wLanguage
 ) AS DWORD                            ' HRSRC

'typedef BOOL (CALLBACK* ENUMRESNAMEPROCA)(__in_opt HMODULE hModule, __in LPCSTR lpType,
'__in LPSTR lpName, __in LONG_PTR lParam);
'typedef BOOL (CALLBACK* ENUMRESNAMEPROCW)(__in_opt HMODULE hModule, __in LPCWSTR lpType,
'__in LPWSTR lpName, __in LONG_PTR lParam);

'typedef BOOL (CALLBACK* ENUMRESLANGPROCA)(__in_opt HMODULE hModule, __in LPCSTR lpType,
'__in LPCSTR lpName, __in WORD  wLanguage, __in LONG_PTR lParam);
'typedef BOOL (CALLBACK* ENUMRESLANGPROCW)(__in_opt HMODULE hModule, __in LPCWSTR lpType,
'__in LPCWSTR lpName, __in WORD  wLanguage, __in LONG_PTR lParam);

DECLARE FUNCTION EnumResourceTypes LIB "KERNEL32.DLL" ALIAS "EnumResourceTypesA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in     ENUMRESTYPEPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in     LONG_PTR lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceTypesW LIB "KERNEL32.DLL" ALIAS "EnumResourceTypesW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in     ENUMRESTYPEPROCW lpEnumFunc
 , BYVAL LONG _                        ' __in     LONG_PTR lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceNames LIB "KERNEL32.DLL" ALIAS "EnumResourceNamesA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpType
 , BYVAL DWORD _                       ' __in     ENUMRESNAMEPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in     LONG_PTR lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceNamesW LIB "KERNEL32.DLL" ALIAS "EnumResourceNamesW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in     LPCWSTR lpType
 , BYVAL DWORD _                       ' __in     ENUMRESNAMEPROCW lpEnumFunc
 , BYVAL LONG _                        ' __in     LONG_PTR lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceLanguages LIB "KERNEL32.DLL" ALIAS "EnumResourceLanguagesA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpType
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpName
 , BYVAL DWORD _                       ' __in     ENUMRESLANGPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in     LONG_PTR lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceLanguagesW LIB "KERNEL32.DLL" ALIAS "EnumResourceLanguagesW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in     LPCWSTR lpType
 , BYVAL DWORD _                       ' __in     LPCWSTR lpName
 , BYVAL DWORD _                       ' __in     ENUMRESLANGPROCW lpEnumFunc
 , BYVAL LONG _                        ' __in     LONG_PTR lParam
 ) AS LONG                             ' BOOL

%RESOURCE_ENUM_LN               = &H0001
%RESOURCE_ENUM_MUI              = &H0002
%RESOURCE_ENUM_MUI_SYSTEM       = &H0004
%RESOURCE_UPDATE_LN             = &H0010
%RESOURCE_UPDATE_MUI            = &H0020

DECLARE FUNCTION EnumResourceTypesEx LIB "KERNEL32.DLL" ALIAS "EnumResourceTypesExA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in ENUMRESTYPEPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in LONG_PTR lParam
 , BYVAL DWORD _                       ' DWORD dwFlags
 , BYVAL WORD _                        ' LANGID LangId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceTypesExW LIB "KERNEL32.DLL" ALIAS "EnumResourceTypesExW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in ENUMRESTYPEPROCW lpEnumFunc
 , BYVAL LONG _                        ' __in LONG_PTR lParam
 , BYVAL DWORD _                       ' DWORD dwFlags
 , BYVAL WORD _                        ' LANGID LangId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceNamesEx LIB "KERNEL32.DLL" ALIAS "EnumResourceNamesExA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYREF ASCIIZ _                      ' __in LPCSTR lpType
 , BYVAL DWORD _                       ' __in ENUMRESNAMEPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in LONG_PTR lParam
 , BYVAL DWORD _                       ' DWORD dwFlags
 , BYVAL WORD _                        ' LANGID LangId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceNamesExW LIB "KERNEL32.DLL" ALIAS "EnumResourceNamesExW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYREF ASCIIZ _                      ' __in LPCSTR lpType
 , BYVAL DWORD _                       ' __in ENUMRESNAMEPROCW lpEnumFunc
 , BYVAL LONG _                        ' __in LONG_PTR lParam
 , BYVAL DWORD _                       ' DWORD dwFlags
 , BYVAL WORD _                        ' LANGID LangId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceLanguagesEx LIB "KERNEL32.DLL" ALIAS "EnumResourceLanguagesExA" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYREF ASCIIZ _                      ' __in LPCSTR lpType
 , BYREF ASCIIZ _                      ' __in LPCSTR lpName
 , BYVAL DWORD _                       ' __in ENUMRESLANGPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in LONG_PTR lParam
 , BYVAL DWORD _                       ' DWORD dwFlags
 , BYVAL WORD _                        ' LANGID LangId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumResourceLanguagesExW LIB "KERNEL32.DLL" ALIAS "EnumResourceLanguagesExW" ( _
   BYVAL DWORD _                       ' __in_opt HMODULE hModule
 , BYVAL DWORD _                       ' __in LPCWSTR lpType
 , BYVAL DWORD _                       ' __in LPCWSTR lpName
 , BYVAL DWORD _                       ' __in ENUMRESLANGPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in LONG_PTR lParam
 , BYVAL DWORD _                       ' DWORD dwFlags
 , BYVAL WORD _                        ' LANGID LangId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BeginUpdateResource LIB "KERNEL32.DLL" ALIAS "BeginUpdateResourceA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR pFileName
 , BYVAL LONG _                        ' __in BOOL bDeleteExistingResources
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION BeginUpdateResourceW LIB "KERNEL32.DLL" ALIAS "BeginUpdateResourceW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR pFileName
 , BYVAL LONG _                        ' __in BOOL bDeleteExistingResources
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION UpdateResource LIB "KERNEL32.DLL" ALIAS "UpdateResourceA" ( _
   BYVAL DWORD _                       ' __in HANDLE hUpdate
 , BYREF ASCIIZ _                      ' __in LPCSTR lpType
 , BYREF ASCIIZ _                      ' __in LPCSTR lpName
 , BYVAL WORD _                        ' __in WORD wLanguage
 , BYREF ANY _                         ' __in_bcount_opt(cb) LPVOID lpData
 , BYVAL DWORD _                       ' __in DWORD c
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UpdateResourceW LIB "KERNEL32.DLL" ALIAS "UpdateResourceW" ( _
   BYVAL DWORD _                       ' __in HANDLE hUpdate
 , BYVAL DWORD _                       ' __in LPCWSTR lpType
 , BYVAL DWORD _                       ' __in LPCWSTR lpName
 , BYVAL WORD _                        ' __in WORD wLanguage
 , BYREF ANY _                         ' __in_bcount_opt(cb) LPVOID lpData
 , BYVAL DWORD _                       ' __in DWORD cb
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EndUpdateResource LIB "KERNEL32.DLL" ALIAS "EndUpdateResourceA" ( _
   BYVAL DWORD _                       ' __in HANDLE hUpdate
 , BYVAL LONG _                        ' __in BOOL   fDiscard
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EndUpdateResourceW LIB "KERNEL32.DLL" ALIAS "EndUpdateResourceW" ( _
   BYVAL DWORD _                       ' __in HANDLE hUpdate
 , BYVAL LONG _                        ' __in BOOL   fDiscard
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GlobalAddAtom LIB "KERNEL32.DLL" ALIAS "GlobalAddAtomA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpString
 ) AS WORD                             ' ATOM

DECLARE FUNCTION GlobalAddAtomW LIB "KERNEL32.DLL" ALIAS "GlobalAddAtomW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpString
 ) AS WORD                             ' ATOM

DECLARE FUNCTION GlobalFindAtom LIB "KERNEL32.DLL" ALIAS "GlobalFindAtomA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpString
 ) AS WORD                             ' ATOM

DECLARE FUNCTION GlobalFindAtomW LIB "KERNEL32.DLL" ALIAS "GlobalFindAtomW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpString
 ) AS WORD                             ' ATOM

DECLARE FUNCTION GlobalGetAtomName LIB "KERNEL32.DLL" ALIAS "GlobalGetAtomNameA" ( _
   BYVAL WORD _                        ' __in ATOM nAtom
 , BYREF ASCIIZ _                      ' __out_ecount_part(nSize, return + 1) LPSTR lpBuffer
 , BYVAL DWORD _                       ' __in int nSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GlobalGetAtomNameW LIB "KERNEL32.DLL" ALIAS "GlobalGetAtomNameW" ( _
   BYVAL WORD _                        ' __in ATOM nAtom
 , BYVAL DWORD _                       ' __out_ecount_part(nSize, return + 1) LPWSTR lpBuffer
 , BYVAL DWORD _                       ' __in int nSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION AddAtom LIB "KERNEL32.DLL" ALIAS "AddAtomA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpString
 ) AS WORD                             ' ATOM

DECLARE FUNCTION AddAtomW LIB "KERNEL32.DLL" ALIAS "AddAtomW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpString
 ) AS WORD                             ' ATOM

DECLARE FUNCTION FindAtom LIB "KERNEL32.DLL" ALIAS "FindAtomA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpString
 ) AS WORD                             ' ATOM

DECLARE FUNCTION FindAtomW LIB "KERNEL32.DLL" ALIAS "FindAtomW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpString
 ) AS WORD                             ' ATOM

DECLARE FUNCTION GetAtomName LIB "KERNEL32.DLL" ALIAS "GetAtomNameA" ( _
   BYVAL WORD _                        ' __in ATOM nAtom
 , BYREF ASCIIZ _                      ' __out_ecount_part(nSize, return + 1) LPSTR lpBuffer
 , BYVAL DWORD _                       ' __in int nSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetAtomNameW LIB "KERNEL32.DLL" ALIAS "GetAtomNameW" ( _
   BYVAL WORD _                        ' __in ATOM nAtom
 , BYVAL DWORD _                       ' __out_ecount_part(nSize, return + 1) LPWSTR lpBuffer
 , BYVAL DWORD _                       ' __in int nSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetProfileInt LIB "KERNEL32.DLL" ALIAS "GetProfileIntA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpKeyName
 , BYVAL LONG _                        ' __in INT nDefault
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetProfileIntW LIB "KERNEL32.DLL" ALIAS "GetProfileIntW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __in LPCWSTR lpKeyName
 , BYVAL LONG _                        ' __in INT nDefault
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetProfileString LIB "KERNEL32.DLL" ALIAS "GetProfileStringA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpKeyName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpDefault
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nSize, return + 1) LPSTR lpReturnedString
 , BYVAL DWORD _                       ' __in     DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetProfileStringW LIB "KERNEL32.DLL" ALIAS "GetProfileStringW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpKeyName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpDefault
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nSize, return + 1) LPWSTR lpReturnedString
 , BYVAL DWORD _                       ' __in     DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WriteProfileString LIB "KERNEL32.DLL" ALIAS "WriteProfileStringA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpKeyName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpString
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WriteProfileStringW LIB "KERNEL32.DLL" ALIAS "WriteProfileStringW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpKeyName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpString
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProfileSection LIB "KERNEL32.DLL" ALIAS "GetProfileSectionA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nSize, return + 1) LPSTR lpReturnedString
 , BYVAL DWORD _                       ' __in DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetProfileSectionW LIB "KERNEL32.DLL" ALIAS "GetProfileSectionW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nSize, return + 1) LPWSTR lpReturnedString
 , BYVAL DWORD _                       ' __in DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WriteProfileSection LIB "KERNEL32.DLL" ALIAS "WriteProfileSectionA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpString
 ) AS LONG                             ' LONG

DECLARE FUNCTION WriteProfileSectionW LIB "KERNEL32.DLL" ALIAS "WriteProfileSectionW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __in LPCWSTR lpString
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetPrivateProfileInt LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileIntA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpKeyName
 , BYVAL LONG _                        ' __in     INT nDefault
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpFileName
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetPrivateProfileIntW LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileIntW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpKeyName
 , BYVAL LONG _                        ' __in     INT nDefault
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpFileName
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetPrivateProfileString LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileStringA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpKeyName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpDefault
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nSize, return + 1) LPSTR lpReturnedString
 , BYVAL DWORD _                       ' __in     DWORD nSize
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpFileName
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetPrivateProfileStringW LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileStringW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpKeyName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpDefault
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nSize, return + 1) LPWSTR lpReturnedString
 , BYVAL DWORD _                       ' __in     DWORD nSize
 , BYVAL DWORD _                       ' __in     DWORD nSize
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WritePrivateProfileString LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileStringA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpKeyName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpString
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WritePrivateProfileStringW LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileStringW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpKeyName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpString
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetPrivateProfileSection LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileSectionA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nSize, return + 1) LPSTR lpReturnedString
 , BYVAL DWORD _                       ' __in     DWORD nSize
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpFileName
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetPrivateProfileSectionW LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileSectionW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nSize, return + 1) LPWSTR lpReturnedString
 , BYVAL DWORD _                       ' __in     DWORD nSize
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpFileName
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION WritePrivateProfileSection LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileSectionA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpAppName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpString
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WritePrivateProfileSectionW LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileSectionW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpAppName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpString
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetPrivateProfileSectionNames LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileSectionNamesA" ( _
   BYREF ASCIIZ _                      ' __out_ecount_part_opt(nSize, return + 1) LPSTR lpszReturnBuffer
 , BYVAL DWORD _                       ' __in     DWORD nSize
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpFileName
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetPrivateProfileSectionNamesW LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileSectionNamesW" ( _
   BYVAL DWORD _                       ' __out_ecount_part_opt(nSize, return + 1) LPWSTR lpszReturnBuffer
 , BYVAL DWORD _                       ' __in     DWORD nSize
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpFileName
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetPrivateProfileStruct LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileStructA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpszSection
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpszKey
 , BYREF ANY _                         ' __out_bcount_opt(uSizeStruct) LPVOID   lpStruct
 , BYVAL DWORD _                       ' __in     UINT     uSizeStruct
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR szFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetPrivateProfileStructW LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileStructW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpszSection
 , BYVAL DWORD _                       ' __in     LPCWSTR lpszKey
 , BYREF ANY _                         ' __out_bcount_opt(uSizeStruct) LPVOID   lpStruct
 , BYVAL DWORD _                       ' __in     UINT     uSizeStruct
 , BYVAL DWORD _                       ' __in_opt LPCWSTR szFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WritePrivateProfileStruct LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileStructA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpszSection
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpszKey
 , BYREF ANY _                         ' __in_bcount_opt(uSizeStruct) LPVOID lpStruct
 , BYVAL DWORD _                       ' __in     UINT     uSizeStruct
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR szFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WritePrivateProfileStructW LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileStructW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpszSection
 , BYVAL DWORD _                       ' __in     LPCWSTR lpszKey
 , BYREF ANY _                         ' __in_bcount_opt(uSizeStruct) LPVOID lpStruct
 , BYVAL DWORD _                       ' __in     UINT     uSizeStruct
 , BYVAL DWORD _                       ' __in_opt LPCWSTR szFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDriveType LIB "KERNEL32.DLL" ALIAS "GetDriveTypeA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpRootPathName
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetDriveTypeW LIB "KERNEL32.DLL" ALIAS "GetDriveTypeW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpRootPathName
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetSystemDirectory LIB "KERNEL32.DLL" ALIAS "GetSystemDirectoryA" ( _
   BYREF ASCIIZ _                      ' __out_ecount_part_opt(uSize, return + 1) LPSTR lpBuffer
 , BYVAL DWORD _                       ' __in UINT uSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetSystemDirectoryW LIB "KERNEL32.DLL" ALIAS "GetSystemDirectoryW" ( _
   BYVAL DWORD _                       ' __out_ecount_part_opt(uSize, return + 1) LPWSTR lpBuffer
 , BYVAL DWORD _                       ' __in UINT uSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetTempPath LIB "KERNEL32.DLL" ALIAS "GetTempPathA" ( _
   BYVAL LONG _                        ' __in DWORD nBufferLength
 , BYREF ASCIIZ _                      ' __out_ecount_part(nBufferLength, return + 1) LPSTR lpBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetTempPathW LIB "KERNEL32.DLL" ALIAS "GetTempPathW" ( _
   BYVAL LONG _                        ' __in DWORD nBufferLength
 , BYVAL DWORD _                       ' __out_ecount_part(nBufferLength, return + 1) LPWSTR lpBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetTempFileName LIB "KERNEL32.DLL" ALIAS "GetTempFileNameA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpPathName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpPrefixString
 , BYVAL DWORD _                       ' __in UINT uUnique
 , BYREF ASCIIZ _                      ' __out_ecount(MAX_PATH) LPSTR lpTempFileName
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetTempFileNameW LIB "KERNEL32.DLL" ALIAS "GetTempFileNameW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpPathName
 , BYVAL DWORD _                       ' __in LPCWSTR lpPrefixString
 , BYVAL DWORD _                       ' __in UINT uUnique
 , BYVAL DWORD _                       ' __out_ecount(MAX_PATH) LPWSTR lpTempFileName
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetWindowsDirectory LIB "KERNEL32.DLL" ALIAS "GetWindowsDirectoryA" ( _
   BYREF ASCIIZ _                      ' __out_ecount_part_opt(uSize, return + 1) LPSTR lpBuffer
 , BYVAL DWORD _                       ' __in UINT uSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetWindowsDirectoryW LIB "KERNEL32.DLL" ALIAS "GetWindowsDirectoryW" ( _
   BYVAL DWORD  _                      ' __out_ecount_part_opt(uSize, return + 1) LPWSTR lpBuffer
 , BYVAL DWORD _                       ' __in UINT uSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetSystemWindowsDirectory LIB "KERNEL32.DLL" ALIAS "GetSystemWindowsDirectoryA" ( _
   BYREF ASCIIZ  _                     ' __out_ecount_part_opt(uSize, return + 1) LPSTR lpBuffer
 , BYVAL DWORD _                       ' __in UINT uSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetSystemWindowsDirectoryW LIB "KERNEL32.DLL" ALIAS "GetSystemWindowsDirectoryW" ( _
   BYVAL DWORD  _                      ' __out_ecount_part_opt(uSize, return + 1) LPWSTR lpBuffer
 , BYVAL DWORD _                       ' __in UINT uSize
 ) AS DWORD                            ' UINT

'#if _WIN32_WINNT >= 0x0501 || defined(WINBASE_DECLARE_GET_SYSTEM_WOW64_DIRECTORY)

DECLARE FUNCTION GetSystemWow64Directory LIB "KERNEL32.DLL" ALIAS "GetSystemWow64DirectoryA" ( _
   BYREF ASCIIZ _                      ' __out_ecount_part_opt(uSize, return + 1) LPSTR lpBuffer
 , BYVAL DWORD _                       ' __in UINT uSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetSystemWow64DirectoryW LIB "KERNEL32.DLL" ALIAS "GetSystemWow64DirectoryW" ( _
   BYVAL DWORD _                       ' __out_ecount_part_opt(uSize, return + 1) LPSTR lpBuffer
 , BYVAL DWORD _                       ' __in UINT uSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION Wow64EnableWow64FsRedirection LIB "KERNEL32.DLL" ALIAS "Wow64EnableWow64FsRedirection" ( _
   BYVAL BYTE _                        ' __in BOOLEAN Wow64FsEnableRedirection
 ) AS BYTE                             ' BOOLEAN

DECLARE FUNCTION Wow64DisableWow64FsRedirection LIB "KERNEL32.DLL" ALIAS "Wow64DisableWow64FsRedirection" ( _
   BYREF ANY _                         ' __out PVOID *OldValue
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Wow64RevertWow64FsRedirection LIB "KERNEL32.DLL" ALIAS "Wow64RevertWow64FsRedirection" ( _
   BYVAL DWORD _                       ' __in PVOID OlValue
 ) AS LONG                             ' BOOL

'//
'// for GetProcAddress
'//
'typedef UINT (WINAPI* PGET_SYSTEM_WOW64_DIRECTORY_A)(__out_ecount_part_opt(uSize, return + 1) LPSTR lpBuffer, __in UINT uSize);
'typedef UINT (WINAPI* PGET_SYSTEM_WOW64_DIRECTORY_W)(__out_ecount_part_opt(uSize, return + 1) LPWSTR lpBuffer, __in UINT uSize);

'//
'// GetProcAddress only accepts GET_SYSTEM_WOW64_DIRECTORY_NAME_A_A,
'// GET_SYSTEM_WOW64_DIRECTORY_NAME_W_A, GET_SYSTEM_WOW64_DIRECTORY_NAME_T_A.
'// The others are if you want to use the strings in some other way.
'//
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_A_A      "GetSystemWow64DirectoryA"
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_A_W     L"GetSystemWow64DirectoryA"
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_A_T TEXT("GetSystemWow64DirectoryA")
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_W_A      "GetSystemWow64DirectoryW"
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_W_W     L"GetSystemWow64DirectoryW"
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_W_T TEXT("GetSystemWow64DirectoryW")

$GET_SYSTEM_WOW64_DIRECTORY_NAME_A_A = "GetSystemWow64DirectoryA"
$GET_SYSTEM_WOW64_DIRECTORY_NAME_A_T = "GetSystemWow64DirectoryA"
$GET_SYSTEM_WOW64_DIRECTORY_NAME_W_A = "GetSystemWow64DirectoryW"
$GET_SYSTEM_WOW64_DIRECTORY_NAME_W_T = "GetSystemWow64DirectoryW"

'#ifdef UNICODE
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_A GET_SYSTEM_WOW64_DIRECTORY_NAME_W_A
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_W GET_SYSTEM_WOW64_DIRECTORY_NAME_W_W
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_T GET_SYSTEM_WOW64_DIRECTORY_NAME_W_T
'#else
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_A GET_SYSTEM_WOW64_DIRECTORY_NAME_A_A
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_W GET_SYSTEM_WOW64_DIRECTORY_NAME_A_W
'#define GET_SYSTEM_WOW64_DIRECTORY_NAME_T_T GET_SYSTEM_WOW64_DIRECTORY_NAME_A_T
'#endif

'#endif // _WIN32_WINNT >= 0x0501
'#endif

DECLARE FUNCTION SetCurrentDirectory LIB "KERNEL32.DLL" ALIAS "SetCurrentDirectoryA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpPathName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCurrentDirectoryW LIB "KERNEL32.DLL" ALIAS "SetCurrentDirectoryW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpPathName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCurrentDirectory LIB "KERNEL32.DLL" ALIAS "GetCurrentDirectoryA" ( _
   BYVAL DWORD _                       ' __in DWORD nBufferLength
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nBufferLength, return + 1) LPSTR lpBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetCurrentDirectoryW LIB "KERNEL32.DLL" ALIAS "GetCurrentDirectoryW" ( _
   BYVAL DWORD _                       ' __in DWORD nBufferLength
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nBufferLength, return + 1) LPWSTR lpBuffer
 ) AS DWORD                            ' DWORD

'#if _WIN32_WINNT >= 0x0502

DECLARE FUNCTION SetDllDirectory LIB "KERNEL32.DLL" ALIAS "SetDllDirectoryA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpPathName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetDllDirectoryW LIB "KERNEL32.DLL" ALIAS "SetDllDirectoryW" ( _
   BYVAL DWORD _                       ' __in_opt LPCSTR lpPathName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDllDirectory LIB "KERNEL32.DLL" ALIAS "GetDllDirectory" ( _
   BYVAL DWORD _                       ' __in DWORD nBufferLength
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nBufferLength, return + 1) LPSTR lpBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetDllDirectoryW LIB "KERNEL32.DLL" ALIAS "GetDllDirectoryW" ( _
   BYVAL DWORD _                       ' __in DWORD nBufferLength
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nBufferLength, return + 1) LPWSTR lpBuffer
 ) AS DWORD                            ' DWORD

'#endif // _WIN32_WINNT >= 0x0502

DECLARE FUNCTION GetDiskFreeSpace LIB "KERNEL32.DLL" ALIAS "GetDiskFreeSpaceA" ( _
   BYREF ASCIIZ _                      ' __in_opt  LPCSTR lpRootPathName
 , BYREF DWORD _                       ' __out_opt LPDWORD lpSectorsPerCluster
 , BYREF DWORD _                       ' __out_opt LPDWORD lpBytesPerSector
 , BYREF DWORD _                       ' __out_opt LPDWORD lpNumberOfFreeClusters
 , BYREF DWORD _                       ' __out_opt LPDWORD lpTotalNumberOfClusters
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDiskFreeSpaceW LIB "KERNEL32.DLL" ALIAS "GetDiskFreeSpaceW" ( _
   BYVAL DWORD _                       ' __in_opt  LPCWSTR lpRootPathName
 , BYREF DWORD _                       ' __out_opt LPDWORD lpSectorsPerCluster
 , BYREF DWORD _                       ' __out_opt LPDWORD lpBytesPerSector
 , BYREF DWORD _                       ' __out_opt LPDWORD lpNumberOfFreeClusters
 , BYREF DWORD _                       ' __out_opt LPDWORD lpTotalNumberOfClusters
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDiskFreeSpaceEx LIB "KERNEL32.DLL" ALIAS "GetDiskFreeSpaceExA" ( _
   BYREF ASCIIZ _                      ' __in_opt  LPCSTR lpDirectoryName
 , BYREF QUAD _                        ' __out_opt PULARGE_INTEGER lpFreeBytesAvailableToCaller
 , BYREF QUAD _                        ' __out_opt PULARGE_INTEGER lpTotalNumberOfBytes
 , BYREF QUAD _                        ' __out_opt PULARGE_INTEGER lpTotalNumberOfFreeBytes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDiskFreeSpaceExW LIB "KERNEL32.DLL" ALIAS "GetDiskFreeSpaceExW" ( _
   BYVAL DWORD _                       ' __in_opt  LPCWSTR lpDirectoryName
 , BYREF QUAD _                        ' __out_opt PULARGE_INTEGER lpFreeBytesAvailableToCaller
 , BYREF QUAD _                        ' __out_opt PULARGE_INTEGER lpTotalNumberOfBytes
 , BYREF QUAD _                        ' __out_opt PULARGE_INTEGER lpTotalNumberOfFreeBytes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateDirectory LIB "KERNEL32.DLL" ALIAS "CreateDirectoryA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpPathName
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateDirectoryW LIB "KERNEL32.DLL" ALIAS "CreateDirectoryW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpPathName
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateDirectoryEx LIB "KERNEL32.DLL" ALIAS "CreateDirectoryExA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpTemplateDirectory
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpNewDirectory
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateDirectoryExW LIB "KERNEL32.DLL" ALIAS "CreateDirectoryExW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpTemplateDirectory
 , BYVAL DWORD _                       ' __in     LPCWSTR lpNewDirectory
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION CreateDirectoryTransacted LIB "KERNEL32.DLL" ALIAS "CreateDirectoryTransactedA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpTemplateDirectory
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpNewDirectory
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateDirectoryTransactedW LIB "KERNEL32.DLL" ALIAS "CreateDirectoryTransactedW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpTemplateDirectory
 , BYVAL DWORD _                       ' __in     LPCWSTR lpNewDirectory
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION RemoveDirectory LIB "KERNEL32.DLL" ALIAS "RemoveDirectoryA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpPathName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RemoveDirectoryW LIB "KERNEL32.DLL" ALIAS "RemoveDirectoryW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpPathName
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION RemoveDirectoryTransacted LIB "KERNEL32.DLL" ALIAS "RemoveDirectoryTransactedA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpPathName
 , BYVAL DWORD _                       ' __in HANDLE hTransaction
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RemoveDirectoryTransactedW LIB "KERNEL32.DLL" ALIAS "RemoveDirectoryTransactedW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpPathName
 , BYVAL DWORD _                       ' __in HANDLE hTransaction
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION GetFullPathName LIB "KERNEL32.DLL" ALIAS "GetFullPathNameA" ( _
   BYREF ASCIIZ _                      ' __in            LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in            DWORD nBufferLength
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nBufferLength, return + 1) LPSTR lpBuffer
 , BYREF ANY _                         ' __deref_opt_out LPSTR *lpFilePart
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetFullPathNameW LIB "KERNEL32.DLL" ALIAS "GetFullPathNameW" ( _
   BYVAL DWORD _                       ' __in            LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in            DWORD nBufferLength
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nBufferLength, return + 1) LPWSTR lpBuffer
 , BYREF ANY _                         ' __deref_opt_out LPWSTR *lpFilePart
 ) AS DWORD                            ' DWORD

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION GetFullPathNameTransacted LIB "KERNEL32.DLL" ALIAS "GetFullPathNameTransactedA" ( _
   BYREF ASCIIZ _                      ' __in            LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in            DWORD nBufferLength
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nBufferLength, return + 1) LPSTR lpBuffer
 , BYREF ANY _                         ' __deref_opt_out LPSTR *lpFilePart
 , BYVAL DWORD _                       ' __in            HANDLE hTransaction
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetFullPathNameTransactedW LIB "KERNEL32.DLL" ALIAS "GetFullPathNameTransactedW" ( _
   BYVAL DWORD _                       ' __in            LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in            DWORD nBufferLength
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nBufferLength, return + 1) LPWSTR lpBuffer
 , BYREF ANY _                         ' __deref_opt_out LPWSTR *lpFilePart
 , BYVAL DWORD _                       ' __in            HANDLE hTransaction
 ) AS DWORD                            ' DWORD


#ENDIF ' // _WIN32_WINNT >= 0x0600


%DDD_RAW_TARGET_PATH         = &H00000001???
%DDD_REMOVE_DEFINITION       = &H00000002???
%DDD_EXACT_MATCH_ON_REMOVE   = &H00000004???
%DDD_NO_BROADCAST_SYSTEM     = &H00000008???
%DDD_LUID_BROADCAST_DRIVE    = &H00000010???

DECLARE FUNCTION DefineDosDevice LIB "KERNEL32.DLL" ALIAS "DefineDosDeviceA" ( _
   BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpDeviceName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpTargetPath
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DefineDosDeviceW LIB "KERNEL32.DLL" ALIAS "DefineDosDeviceW" ( _
   BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in     LPCWSTR lpDeviceName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpTargetPath
 ) AS LONG                             ' BOOL

DECLARE FUNCTION QueryDosDevice LIB "KERNEL32.DLL" ALIAS "QueryDosDeviceA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpDeviceName
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(ucchMax, return) LPSTR lpTargetPath
 , BYVAL DWORD _                       ' __in     DWORD ucchMax
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION QueryDosDeviceW LIB "KERNEL32.DLL" ALIAS "QueryDosDeviceW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpDeviceName
 , BYVAL DWORD _                       ' __out_ecount_part_opt(ucchMax, return) LPWSTR lpTargetPath
 , BYVAL DWORD _                       ' __in     DWORD ucchMax
 ) AS DWORD                            ' DWORD

'#define EXPAND_LOCAL_DRIVES

DECLARE FUNCTION CreateFile LIB "KERNEL32.DLL" ALIAS "CreateFileA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 , BYVAL DWORD _                       ' __in     DWORD dwShareMode
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in     DWORD dwCreationDisposition
 , BYVAL DWORD _                       ' __in     DWORD dwFlagsAndAttributes
 , BYVAL DWORD _                       ' __in_opt HANDLE hTemplateFile
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateFileW LIB "KERNEL32.DLL" ALIAS "CreateFileW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 , BYVAL DWORD _                       ' __in     DWORD dwShareMode
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in     DWORD dwCreationDisposition
 , BYVAL DWORD _                       ' __in     DWORD dwFlagsAndAttributes
 , BYVAL DWORD _                       ' __in_opt HANDLE hTemplateFile
 ) AS DWORD                            ' HANDLE

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION CreateFileTransacted LIB "KERNEL32.DLL" ALIAS "CreateFileTransactedA" ( _
   BYREF ASCIIZ _                      ' __in       LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in       DWORD dwDesiredAccess
 , BYVAL DWORD _                       ' __in       DWORD dwShareMode
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt   LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in       DWORD dwCreationDisposition
 , BYVAL DWORD _                       ' __in       DWORD dwFlagsAndAttributes
 , BYVAL DWORD _                       ' __in_opt   HANDLE hTemplateFile
 , BYVAL DWORD _                       ' __in       HANDLE hTransaction
 , BYVAL DWORD _                       ' __in_opt   PUSHORT pusMiniVersion
 , BYVAL DWORD _                       ' __reserved PVOID  lpExtendedParameter
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateFileTransactedW LIB "KERNEL32.DLL" ALIAS "CreateFileTransactedW" ( _
   BYVAL DWORD _                       ' __in       LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in       DWORD dwDesiredAccess
 , BYVAL DWORD _                       ' __in       DWORD dwShareMode
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt   LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in       DWORD dwCreationDisposition
 , BYVAL DWORD _                       ' __in       DWORD dwFlagsAndAttributes
 , BYVAL DWORD _                       ' __in_opt   HANDLE hTemplateFile
 , BYVAL DWORD _                       ' __in       HANDLE hTransaction
 , BYVAL DWORD _                       ' __in_opt   PUSHORT pusMiniVersion
 , BYVAL DWORD _                       ' __reserved PVOID  lpExtendedParameter
 ) AS DWORD                            ' HANDLE

#ENDIF ' // _WIN32_WINNT >= 0x0600

'#if _WIN32_WINNT >= 0x0502

DECLARE FUNCTION ReOpenFile LIB "KERNEL32.DLL" ALIAS "ReOpenFile" ( _
   BYVAL DWORD _                       ' __in HANDLE  hOriginalFile
 , BYVAL DWORD _                       ' __in DWORD   dwDesiredAccess
 , BYVAL DWORD _                       ' __in DWORD   dwShareMode
 , BYVAL DWORD _                       ' __in DWORD   dwFlagsAndAttributes
 ) AS DWORD                            ' HANDLE

'#endif // _WIN32_WINNT >= 0x0502

DECLARE FUNCTION SetFileAttributes LIB "KERNEL32.DLL" ALIAS "SetFileAttributesA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in DWORD dwFileAttributes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFileAttributesW LIB "KERNEL32.DLL" ALIAS "SetFileAttributesW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in DWORD dwFileAttributes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileAttributes LIB "KERNEL32.DLL" ALIAS "GetFileAttributesA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpFileName
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetFileAttributesW LIB "KERNEL32.DLL" ALIAS "GetFileAttributesW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpFileName
 ) AS DWORD                            ' DWORD

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION SetFileAttributesTransacted LIB "KERNEL32.DLL" ALIAS "SetFileAttributesTransactedA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in     DWORD dwFileAttributes
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFileAttributesTransactedW LIB "KERNEL32.DLL" ALIAS "SetFileAttributesTransactedW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in     DWORD dwFileAttributes
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

' GET_FILEEX_INFO_LEVELS enum
%GetFileExInfoStandard = 0
%GetFileExMaxInfoLevel = 1

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION GetFileAttributesTransacted LIB "KERNEL32.DLL" ALIAS "GetFileAttributesTransactedA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in  GET_FILEEX_INFO_LEVELS fInfoLevelId
 , BYREF DWORD _                       ' __out LPVOID lpFileInformation
 , BYVAL DWORD _                       ' __in  HANDLE hTransaction
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileAttributesTransactedW LIB "KERNEL32.DLL" ALIAS "GetFileAttributesTransactedW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in  GET_FILEEX_INFO_LEVELS fInfoLevelId
 , BYREF DWORD _                       ' __out LPVOID lpFileInformation
 , BYVAL DWORD _                       ' __in  HANDLE hTransaction
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION GetFileAttributesEx LIB "KERNEL32.DLL" ALIAS "GetFileAttributesExA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpFileName
 , BYVAL LONG _                        ' __in  GET_FILEEX_INFO_LEVELS fInfoLevelId
 , BYREF ANY _                         ' __out LPVOID lpFileInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileAttributesExW LIB "KERNEL32.DLL" ALIAS "GetFileAttributesExW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpFileName
 , BYVAL LONG _                        ' __in  GET_FILEEX_INFO_LEVELS fInfoLevelId
 , BYREF ANY _                         ' __out LPVOID lpFileInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCompressedFileSize LIB "KERNEL32.DLL" ALIAS "GetCompressedFileSizeA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpFileName
 , BYREF DWORD _                       ' __out LPDWORD  lpFileSizeHigh
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetCompressedFileSizeW LIB "KERNEL32.DLL" ALIAS "GetCompressedFileSizeW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpFileName
 , BYREF DWORD _                       ' __out LPDWORD  lpFileSizeHigh
 ) AS DWORD                            ' DWORD

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION GetCompressedFileSizeTransacted LIB "KERNEL32.DLL" ALIAS "GetCompressedFileSizeTransactedA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpFileName
 , BYREF DWORD _                       ' __out LPDWORD  lpFileSizeHigh
 , BYVAL DWORD _                       ' __in  HANDLE hTransaction
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetCompressedFileSizeTransactedW LIB "KERNEL32.DLL" ALIAS "GetCompressedFileSizeTransactedW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpFileName
 , BYREF DWORD _                       ' __out LPDWORD  lpFileSizeHigh
 , BYVAL DWORD _                       ' __in  HANDLE hTransaction
 ) AS DWORD                            ' DWORD

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION DeleteFile LIB "KERNEL32.DLL" ALIAS "DeleteFileA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteFileW LIB "KERNEL32.DLL" ALIAS "DeleteFileW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpFileName
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION DeleteFileTransactedA LIB "KERNEL32.DLL" ALIAS "DeleteFileTransactedA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in HANDLE hTransaction
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteFileTransactedW LIB "KERNEL32.DLL" ALIAS "DeleteFileTransactedW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in HANDLE hTransaction
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

'#if _WIN32_WINNT >= 0x0501

DECLARE FUNCTION CheckNameLegalDOS8Dot3 LIB "KERNEL32.DLL" ALIAS "CheckNameLegalDOS8Dot3A" ( _
   BYREF ASCIIZ _                      ' __in      LPCSTR lpName
 , BYREF ASCIIZ _                      ' __out_ecount_opt(OemNameSize) LPSTR lpOemName
 , BYVAL DWORD _                       ' __in      DWORD OemNameSize
 , BYREF LONG _                        ' __out_opt PBOOL pbNameContainsSpaces OPTIONAL
 , BYREF LONG _                        ' __out     PBOOL pbNameLegal
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CheckNameLegalDOS8Dot3W LIB "KERNEL32.DLL" ALIAS "CheckNameLegalDOS8Dot3W" ( _
   BYVAL DWORD _                       ' __in      LPCWSTR lpName
 , BYREF ANY _                         ' __out_ecount_opt(OemNameSize) LPSTR lpOemName
 , BYVAL DWORD _                       ' __in      DWORD OemNameSize
 , BYREF LONG _                        ' __out_opt PBOOL pbNameContainsSpaces OPTIONAL
 , BYREF LONG _                        ' __out     PBOOL pbNameLegal
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0501)

'#if(_WIN32_WINNT >= 0x0400)
' FINDEX_INFO_LEVELS enum
%FindExInfoStandard = 0
%FindExInfoMaxInfoLevel = 1

' FINDEX_SEARCH_OPS enum
%FindExSearchNameMatch          = 0
%FindExSearchLimitToDirectories = 1
%FindExSearchLimitToDevices     = 2
%FindExSearchMaxSearchOp        = 3

%FIND_FIRST_EX_CASE_SENSITIVE = &H00000001???

DECLARE FUNCTION FindFirstFileEx LIB "KERNEL32.DLL" ALIAS "FindFirstFileExA" ( _
   BYREF ASCIIZ _                      ' __in       LPCSTR lpFileName
 , BYVAL LONG _                        ' __in       FINDEX_INFO_LEVELS fInfoLevelId
 , BYREF ANY _                         ' __out      LPVOID lpFindFileData
 , BYVAL LONG _                        ' __in       FINDEX_SEARCH_OPS fSearchOp
 , BYVAL DWORD _                       ' __reserved LPVOID lpSearchFilter
 , BYVAL DWORD _                       ' __in       DWORD dwAdditionalFlags
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindFirstFileExW LIB "KERNEL32.DLL" ALIAS "FindFirstFileExW" ( _
   BYVAL DWORD _                       ' __in       LPCWSTR lpFileName
 , BYVAL LONG _                        ' __in       FINDEX_INFO_LEVELS fInfoLevelId
 , BYREF ANY _                         ' __out      LPVOID lpFindFileData
 , BYVAL LONG _                        ' __in       FINDEX_SEARCH_OPS fSearchOp
 , BYVAL DWORD _                       ' __reserved LPVOID lpSearchFilter
 , BYVAL DWORD _                       ' __in       DWORD dwAdditionalFlags
 ) AS DWORD                            ' HANDLE

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION FindFirstFileTransacted LIB "KERNEL32.DLL" ALIAS "FindFirstFileTransactedA" ( _
   BYREF ASCIIZ _                      ' __in       LPCSTR lpFileName
 , BYVAL LONG _                        ' __in       FINDEX_INFO_LEVELS fInfoLevelId
 , BYREF ANY _                         ' __out      LPVOID lpFindFileData
 , BYVAL LONG _                        ' __in       FINDEX_SEARCH_OPS fSearchOp
 , BYVAL DWORD _                       ' __reserved LPVOID lpSearchFilter
 , BYVAL DWORD _                       ' __in       DWORD dwAdditionalFlags
 , BYVAL DWORD _                       ' __in       HANDLE hTransaction
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindFirstFileTransactedW LIB "KERNEL32.DLL" ALIAS "FindFirstFileTransactedW" ( _
   BYVAL DWORD _                       ' __in       LPCWSTR lpFileName
 , BYVAL LONG _                        ' __in       FINDEX_INFO_LEVELS fInfoLevelId
 , BYREF ANY _                         ' __out      LPVOID lpFindFileData
 , BYVAL LONG _                        ' __in       FINDEX_SEARCH_OPS fSearchOp
 , BYVAL DWORD _                       ' __reserved LPVOID lpSearchFilter
 , BYVAL DWORD _                       ' __in       DWORD dwAdditionalFlags
 , BYVAL DWORD _                       ' __in       HANDLE hTransaction
 ) AS DWORD                            ' HANDLE

#ENDIF

DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpFileName
 , BYREF WIN32_FIND_DATA _             ' __out LPWIN32_FIND_DATAA lpFindFileData
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindFirstFileW LIB "KERNEL32.DLL" ALIAS "FindFirstFileW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpFileName
 , BYREF WIN32_FIND_DATAW _            ' __out LPWIN32_FIND_DATAW lpFindFileData
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindNextFile LIB "KERNEL32.DLL" ALIAS "FindNextFileA" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFindFile
 , BYREF WIN32_FIND_DATA _             ' __out LPWIN32_FIND_DATAA lpFindFileData
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindNextFileW LIB "KERNEL32.DLL" ALIAS "FindNextFileW" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFindFile
 , BYREF WIN32_FIND_DATAW _            ' __out LPWIN32_FIND_DATAW lpFindFileData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SearchPath LIB "KERNEL32.DLL" ALIAS "SearchPathA" ( _
   BYREF ASCIIZ _                      ' __in_opt  LPCSTR lpPath
 , BYREF ASCIIZ _                      ' __in      LPCSTR lpFileName
 , BYREF ASCIIZ _                      ' __in_opt  LPCSTR lpExtension
 , BYVAL DWORD _                       ' __in      DWORD nBufferLength
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(nBufferLength, return + 1) LPSTR lpBuffer
 , BYREF ASCIIZ _                      ' __out_opt LPSTR *lpFilePart
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SearchPathW LIB "KERNEL32.DLL" ALIAS "SearchPathW" ( _
   BYVAL DWORD _                       ' __in_opt  LPCWSTR lpPath
 , BYVAL DWORD _                       ' __in      LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in_opt  LPCWSTR lpExtension
 , BYVAL DWORD _                       ' __in      DWORD nBufferLength
 , BYVAL DWORD _                       ' __out_ecount_part_opt(nBufferLength, return + 1) LPWSTR lpBuffer
 , BYREF ANY _                         ' __out_opt LPWSTR *lpFilePart
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CopyFile LIB "KERNEL32.DLL" ALIAS "CopyFileA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpExistingFileName
 , BYREF ASCIIZ _                      '__in LPCSTR lpNewFileName
 , BYVAL LONG _                        ' __in BOOL bFailIfExists
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CopyFileW LIB "KERNEL32.DLL" ALIAS "CopyFileW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpExistingFileName
 , BYVAL DWORD _                       ' __in LPCWSTR lpNewFileName
 , BYVAL LONG _                        ' __in BOOL bFailIfExists
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0400)
'typedef
'DWORD
'(WINAPI *LPPROGRESS_ROUTINE)(
'    __in     LARGE_INTEGER TotalFileSize,
'    __in     LARGE_INTEGER TotalBytesTransferred,
'    __in     LARGE_INTEGER StreamSize,
'    __in     LARGE_INTEGER StreamBytesTransferred,
'    __in     DWORD dwStreamNumber,
'    __in     DWORD dwCallbackReason,
'    __in     HANDLE hSourceFile,
'    __in     HANDLE hDestinationFile,
'    __in_opt LPVOID lpData
'    );

DECLARE FUNCTION CopyFileEx LIB "KERNEL32.DLL" ALIAS "CopyFileExA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpExistingFileName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpNewFileName
 , BYVAL DWORD _                       ' __in_opt LPPROGRESS_ROUTINE lpProgressRoutine
 , BYVAL DWORD _                       ' __in_opt LPVOID lpData
 , BYREF LONG _                        ' __in_opt LPBOOL pbCancel
 , BYVAL DWORD _                       ' __in     DWORD dwCopyFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CopyFileExW LIB "KERNEL32.DLL" ALIAS "CopyFileExW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpExistingFileName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpNewFileName
 , BYVAL DWORD _                       ' __in_opt LPPROGRESS_ROUTINE lpProgressRoutine
 , BYVAL DWORD  _                      ' __in_opt LPVOID lpData
 , BYVAL LONG  _                       ' __in_opt LPBOOL pbCancel
 , BYVAL DWORD _                       ' __in     DWORD dwCopyFlags
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION CopyFileTransacted LIB "KERNEL32.DLL" ALIAS "CopyFileTransactedA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpExistingFileName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpNewFileName
 , BYVAL DWORD _                       ' __in_opt LPPROGRESS_ROUTINE lpProgressRoutine
 , BYVAL DWORD _                       ' __in_opt LPVOID lpData
 , BYREF LONG _                        ' __in_opt LPBOOL pbCancel
 , BYVAL DWORD _                       ' __in     DWORD dwCopyFlags
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CopyFileTransactedW LIB "KERNEL32.DLL" ALIAS "CopyFileTransactedW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpExistingFileName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpNewFileName
 , BYVAL DWORD _                       ' __in_opt LPPROGRESS_ROUTINE lpProgressRoutine
 , BYVAL DWORD  _                      ' __in_opt LPVOID lpData
 , BYVAL LONG  _                       ' __in_opt LPBOOL pbCancel
 , BYVAL DWORD _                       ' __in     DWORD dwCopyFlags
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600
'#ENDIF ' /* _WIN32_WINNT >= 0x0400 */

DECLARE FUNCTION MoveFile LIB "KERNEL32.DLL" ALIAS "MoveFileA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpExistingFileName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpNewFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MoveFileW LIB "KERNEL32.DLL" ALIAS "MoveFileW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpExistingFileName
 , BYVAL DWORD _                       ' __in LPCWSTR lpNewFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MoveFileEx LIB "KERNEL32.DLL" ALIAS "MoveFileExA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpExistingFileName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpNewFileName
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MoveFileExW LIB "KERNEL32.DLL" ALIAS "MoveFileExW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpExistingFileName
 , BYVAL DWORD _                       ' __in LPCWSTR lpNewFileName
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION MoveFileWithProgress LIB "KERNEL32.DLL" ALIAS "MoveFileWithProgressA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpExistingFileName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpNewFileName
 , BYVAL DWORD _                       ' __in_opt LPPROGRESS_ROUTINE lpProgressRoutine
 , BYVAL DWORD _                       ' __in_opt LPVOID lpData
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MoveFileWithProgressW LIB "KERNEL32.DLL" ALIAS "MoveFileWithProgressW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpExistingFileName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpNewFileName
 , BYVAL DWORD _                       ' __in_opt LPPROGRESS_ROUTINE lpProgressRoutine
 , BYVAL DWORD  _                      ' __in_opt LPVOID lpData
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE FUNCTION MoveFileTransacted LIB "KERNEL32.DLL" ALIAS "MoveFileTransactedA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpExistingFileName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpNewFileName
 , BYVAL DWORD _                       ' __in_opt LPPROGRESS_ROUTINE lpProgressRoutine
 , BYVAL DWORD _                       ' __in_opt LPVOID lpData
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MoveFileTransactedW LIB "KERNEL32.DLL" ALIAS "MoveFileTransactedW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpExistingFileName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpNewFileName
 , BYVAL DWORD _                       ' __in_opt LPPROGRESS_ROUTINE lpProgressRoutine
 , BYVAL DWORD  _                      ' __in_opt LPVOID lpData
 , BYVAL DWORD _                       ' __in     DWORD dwFlags
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS LONG                             ' BOOL

#ENDIF ' // (_WIN32_WINNT >= 0x0600)

%MOVEFILE_REPLACE_EXISTING      = &H00000001???
%MOVEFILE_COPY_ALLOWED          = &H00000002???
%MOVEFILE_DELAY_UNTIL_REBOOT    = &H00000004???
%MOVEFILE_WRITE_THROUGH         = &H00000008???
'#if (_WIN32_WINNT >= 0x0500)
%MOVEFILE_CREATE_HARDLINK       = &H00000010???
%MOVEFILE_FAIL_IF_NOT_TRACKABLE = &H00000020???
'#endif // (_WIN32_WINNT >= 0x0500)


'#if (_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION ReplaceFile LIB "KERNEL32.DLL" ALIAS "ReplaceFileA" ( _
   BYREF ASCIIZ _                      ' __in       LPCSTR  lpReplacedFileName
 , BYREF ASCIIZ _                      ' __in       LPCSTR  lpReplacementFileName
 , BYREF ASCIIZ _                      ' __in_opt   LPCSTR  lpBackupFileName
 , BYVAL DWORD _                       ' __in       DWORD   dwReplaceFlags
 , BYVAL DWORD _                       ' __reserved LPVOID  lpExclude
 , BYVAL DWORD _                       ' __reserved LPVOID  lpReserved
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ReplaceFileW LIB "KERNEL32.DLL" ALIAS "ReplaceFileW" ( _
   BYVAL DWORD _                       ' __in       LPCSTR  lpReplacedFileName
 , BYVAL DWORD _                       ' __in       LPCSTR  lpReplacementFileName
 , BYVAL DWORD _                       ' __in_opt   LPCSTR  lpBackupFileName
 , BYVAL DWORD _                       ' __in       DWORD   dwReplaceFlags
 , BYVAL DWORD _                       ' __reserved LPVOID  lpExclude
 , BYVAL DWORD _                       ' __reserved LPVOID  lpReserved
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0500)
'//
'// API call to create hard links.
'//

DECLARE FUNCTION CreateHardLink LIB "KERNEL32.DLL" ALIAS "CreateHardLinkA" ( _
   BYREF ASCIIZ _                      ' __in       LPCSTR lpFileName
 , BYREF ASCIIZ _                      ' __in       LPCSTR lpExistingFileName
 , BYREF SECURITY_ATTRIBUTES _         ' __reserved LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateHardLinkW LIB "KERNEL32.DLL" ALIAS "CreateHardLinkW" ( _
   BYVAL DWORD _                       ' __in       LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in       LPCWSTR lpExistingFileName
 , BYREF SECURITY_ATTRIBUTES _         ' __reserved LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0500)

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600
'//
'// API call to create hard links.
'//

DECLARE FUNCTION CreateHardLinkTransacted LIB "KERNEL32.DLL" ALIAS "CreateHardLinkTransactedA" ( _
   BYREF ASCIIZ _                      ' __in       LPCSTR lpFileName
 , BYREF ASCIIZ _                      ' __in       LPCSTR lpExistingFileName
 , BYREF SECURITY_ATTRIBUTES _         ' __reserved LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in       HANDLE hTransaction
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateHardLinkTransactedW LIB "KERNEL32.DLL" ALIAS "CreateHardLinkTransactedW" ( _
   BYVAL DWORD _                       ' __in       LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in       LPCWSTR lpExistingFileName
 , BYREF SECURITY_ATTRIBUTES _         ' __reserved LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in       HANDLE hTransaction
 ) AS LONG                             ' BOOL

#ENDIF ' // (_WIN32_WINNT >= 0x0600)


'#if (_WIN32_WINNT >= 0x0501)

'//
'// API call to enumerate for streams within a file
'//

' STREAM_INFO_LEVELS enum
%FindStreamInfoStandard     = 0
%FindStreamInfoMaxInfoLevel = 1

TYPE WIN32_FIND_STREAM_DATA
   StreamSize  AS QUAD                            ' LARGE_INTEGER StreamSize
   cStreamName AS STRING * (%MAX_PATH + 36) * 2   ' WCHAR cStreamName[ MAX_PATH + 36 ]
END TYPE

DECLARE FUNCTION FindFirstStreamW LIB "KERNEL32.DLL" ALIAS "FindFirstStreamW" ( _
   BYVAL DWORD _                       ' __in       LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in       STREAM_INFO_LEVELS InfoLevel
 , BYREF ANY _                         ' __out      LPVOID lpFindStreamData
 , BYVAL DWORD _                       ' __reserved DWORD dwFlags
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindNextStreamW LIB "KERNEL32.DLL" ALIAS "FindNextStreamW" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFindStream
 , BYREF ANY _                         ' __out LPVOID lpFindStreamData
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0501)

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION FindFirstFileNameW LIB "KERNEL32.DLL" ALIAS "FindFirstFileNameW" ( _
   BYVAL DWORD _                       ' __in    LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in    DWORD dwFlags
 , BYREF DWORD _                       ' __inout LPDWORD StringLength
 , BYVAL DWORD _                       ' __inout_ecount(*StringLength) PWCHAR LinkName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindNextFileNameW LIB "KERNEL32.DLL" ALIAS "FindNextFileNameW" ( _
   BYVAL DWORD _                       ' __in    HANDLE hFindStream
 , BYVAL DWORD _                       ' __inout LPDWORD StringLength
 , BYVAL DWORD _                       ' __inout_ecount(*StringLength) PWCHAR LinkName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindFirstFileNameTransactedW LIB "KERNEL32.DLL" ALIAS "FindFirstFileNameTransactedW" ( _
   BYVAL DWORD _                       ' __in    LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in    DWORD dwFlags
 , BYREF DWORD _                       ' __inout LPDWORD StringLength
 , BYVAL DWORD _                       ' __inout_ecount(*StringLength) PWCHAR LinkName
 , BYVAL DWORD _                       ' __in_opt HANDLE hTransaction
 ) AS DWORD                            ' HANDLE

#ENDIF


DECLARE FUNCTION CreateNamedPipe LIB "KERNEL32.DLL" ALIAS "CreateNamedPipeA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD dwOpenMode
 , BYVAL DWORD _                       ' __in     DWORD dwPipeMode
 , BYVAL DWORD _                       ' __in     DWORD nMaxInstances
 , BYVAL DWORD _                       ' __in     DWORD nOutBufferSize
 , BYVAL DWORD _                       ' __in     DWORD nInBufferSize
 , BYVAL DWORD _                       ' __in     DWORD nDefaultTimeOut
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateNamedPipeW LIB "KERNEL32.DLL" ALIAS "CreateNamedPipeW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpName
 , BYVAL DWORD _                       ' __in     DWORD dwOpenMode
 , BYVAL DWORD _                       ' __in     DWORD dwPipeMode
 , BYVAL DWORD _                       ' __in     DWORD nMaxInstances
 , BYVAL DWORD _                       ' __in     DWORD nOutBufferSize
 , BYVAL DWORD _                       ' __in     DWORD nInBufferSize
 , BYVAL DWORD _                       ' __in     DWORD nDefaultTimeOut
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetNamedPipeHandleState LIB "KERNEL32.DLL" ALIAS "GetNamedPipeHandleStateA" ( _
   BYVAL DWORD _                       ' __in      HANDLE hNamedPipe
 , BYREF DWORD _                       ' __out_opt LPDWORD lpState
 , BYREF DWORD _                       ' __out_opt LPDWORD lpCurInstances
 , BYREF DWORD _                       ' __out_opt LPDWORD lpMaxCollectionCount
 , BYREF DWORD _                       ' __out_opt LPDWORD lpCollectDataTimeout
 , BYREF ASCIIZ _                      ' __out_ecount_opt(nMaxUserNameSize) LPSTR lpUserName
 , BYVAL DWORD _                       ' __in      DWORD nMaxUserNameSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNamedPipeHandleStateW LIB "KERNEL32.DLL" ALIAS "GetNamedPipeHandleStateW" ( _
   BYVAL DWORD _                       ' __in      HANDLE hNamedPipe
 , BYREF DWORD _                       ' __out_opt LPDWORD lpState
 , BYREF DWORD _                       ' __out_opt LPDWORD lpCurInstances
 , BYREF DWORD _                       ' __out_opt LPDWORD lpMaxCollectionCount
 , BYREF DWORD _                       ' __out_opt LPDWORD lpCollectDataTimeout
 , BYVAL DWORD _                       ' __out_ecount_opt(nMaxUserNameSize) LPWSTR lpUserName
 , BYVAL DWORD _                       ' __in      DWORD nMaxUserNameSize
 ) AS LONG                             ' LONG

DECLARE FUNCTION CallNamedPipe LIB "KERNEL32.DLL" ALIAS "CallNamedPipeA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpNamedPipeName
 , BYREF ANY _                         ' __in_bcount_opt(nInBufferSize) LPVOID lpInBuffer
 , BYVAL DWORD _                       ' __in  DWORD nInBufferSize
 , BYREF ANY _                         ' __out_bcount_part_opt(nOutBufferSize, *lpBytesRead) LPVOID lpOutBuffer
 , BYVAL DWORD _                       ' __in  DWORD nOutBufferSize
 , BYREF DWORD _                       ' __out LPDWORD lpBytesRead
 , BYVAL DWORD _                       ' __in  DWORD nTimeOut
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CallNamedPipeW LIB "KERNEL32.DLL" ALIAS "CallNamedPipeW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpNamedPipeName
 , BYREF ANY _                         ' __in_bcount_opt(nInBufferSize) LPVOID lpInBuffer
 , BYVAL DWORD _                       ' __in  DWORD nInBufferSize
 , BYREF ANY _                         ' __out_bcount_part_opt(nOutBufferSize, *lpBytesRead) LPVOID lpOutBuffer
 , BYVAL DWORD _                       ' __in  DWORD nOutBufferSize
 , BYREF DWORD _                       ' __out LPDWORD lpBytesRead
 , BYVAL DWORD _                       ' __in  DWORD nTimeOut
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WaitNamedPipe LIB "KERNEL32.DLL" ALIAS "WaitNamedPipeA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpNamedPipeName
 , BYVAL DWORD _                       ' __in DWORD nTimeOut
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WaitNamedPipeW LIB "KERNEL32.DLL" ALIAS "WaitNamedPipeW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpNamedPipeName
 , BYVAL DWORD _                       ' __in DWORD nTimeOut
 ) AS LONG                             ' BOOL

' enum PIPE_ATTRIBUTE_TYPE
%PipeAttribute           = 0
%PipeConnectionAttribute = 1
%PipeHandleAttribute     = 2

DECLARE FUNCTION GetNamedPipeAttribute LIB "KERNEL32.DLL" ALIAS "GetNamedPipeAttribute" ( _
   BYVAL DWORD _                       ' __in HANDLE Pipe
 , BYVAL DWORD _                       ' __in PIPE_ATTRIBUTE_TYPE AttributeType
 , BYREF ASCIIZ _                      ' __in PSTR AttributeName
 , BYREF ANY _                         ' __out_bcount(*AttributeValueLength) PVOID AttributeValue
 , BYREF DWORD _                       ' __inout PSIZE_T AttributeValueLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetNamedPipeAttribute LIB "KERNEL32.DLL" ALIAS "SetNamedPipeAttribute" ( _
   BYVAL DWORD _                       ' __in HANDLE Pipe
 , BYVAL DWORD _                       ' __in PIPE_ATTRIBUTE_TYPE AttributeType
 , BYREF ASCIIZ _                      ' __in PSTR AttributeName
 , BYREF ANY _                         ' __in PVOID AttributeValue
 , BYVAL DWORD _                       ' __in SIZE_T AttributeValueLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNamedPipeClientComputerName LIB "KERNEL32.DLL" ALIAS "GetNamedPipeClientComputerNameA" ( _
   BYVAL DWORD _                       ' __in HANDLE Pipe
 , BYREF ASCIIZ _                      ' __out_bcount(ClientComputerNameLength)  LPSTR ClientComputerName
 , BYVAL DWORD _                       ' __in ULONG ClientComputerNameLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNamedPipeClientComputerNameW LIB "KERNEL32.DLL" ALIAS "GetNamedPipeClientComputerNameW" ( _
   BYVAL DWORD _                       ' __in HANDLE Pipe
 , BYVAL DWORD _                       ' __out_bcount(ClientComputerNameLength)  LPWSTR ClientComputerName
 , BYVAL DWORD _                       ' __in ULONG ClientComputerNameLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNamedPipeClientProcessId LIB "KERNEL32.DLL" ALIAS "GetNamedPipeClientProcessId" ( _
   BYVAL DWORD _                       ' __in HANDLE Pipe
 , BYREF DWORD _                       ' __out PULONG ClientProcessId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNamedPipeClientSessionId LIB "KERNEL32.DLL" ALIAS "GetNamedPipeClientSessionId" ( _
   BYVAL DWORD _                       ' __in HANDLE Pipe
 , BYREF DWORD _                       ' __out PULONG ClientSessionId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNamedPipeServerProcessId LIB "KERNEL32.DLL" ALIAS "GetNamedPipeServerProcessId" ( _
   BYVAL DWORD _                       ' __in HANDLE Pipe
 , BYREF DWORD _                       ' __out PULONG ServerProcessId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNamedPipeServerSessionId LIB "KERNEL32.DLL" ALIAS "GetNamedPipeServerSessionId" ( _
   BYVAL DWORD _                       ' __in HANDLE Pipe
 , BYREF DWORD _                       ' __out PULONG ServerSessionId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetVolumeLabel LIB "KERNEL32.DLL" ALIAS "SetVolumeLabelA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpRootPathName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpVolumeName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetVolumeLabelW LIB "KERNEL32.DLL" ALIAS "SetVolumeLabelW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpRootPathName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpVolumeName
 ) AS LONG                             ' BOOL

DECLARE SUB SetFileApisToOEM LIB "KERNEL32.DLL" ALIAS "SetFileApisToOEM" ( _
 )                                     ' VOID

DECLARE SUB SetFileApisToANSI LIB "KERNEL32.DLL" ALIAS "SetFileApisToANSI" ( _
 )                                     ' VOID

DECLARE FUNCTION AreFileApisANSI LIB "KENEL32.DLL" ALIAS "AreFileApisANSI" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVolumeInformation LIB "KERNEL32.DLL" ALIAS "GetVolumeInformationA" ( _
   BYREF ASCIIZ _                      ' __in_opt  LPCSTR lpRootPathName
 , BYREF ASCIIZ _                      ' __out_ecount_opt(nVolumeNameSize) LPSTR lpVolumeNameBuffer
 , BYVAL DWORD _                       ' __in      DWORD nVolumeNameSize
 , BYREF DWORD _                       ' __out_opt LPDWORD lpVolumeSerialNumber
 , BYREF DWORD _                       ' __out_opt LPDWORD lpMaximumComponentLength
 , BYREF DWORD _                       ' __out_opt LPDWORD lpFileSystemFlags
 , BYREF ASCIIZ _                      ' __out_ecount_opt(nFileSystemNameSize) LPSTR lpFileSystemNameBuffer
 , BYVAL DWORD _                       ' __in      DWORD nFileSystemNameSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVolumeInformationW LIB "KERNEL32.DLL" ALIAS "GetVolumeInformationW" ( _
   BYVAL DWORD _                       ' __in_opt  LPCWSTR lpRootPathName
 , BYVAL DWORD _                       ' __out_ecount_opt(nVolumeNameSize) LPWSTR lpVolumeNameBuffer
 , BYVAL DWORD _                       ' __in      DWORD nVolumeNameSize
 , BYREF DWORD _                       ' __out_opt LPDWORD lpVolumeSerialNumber
 , BYREF DWORD _                       ' __out_opt LPDWORD lpMaximumComponentLength
 , BYREF DWORD _                       ' __out_opt LPDWORD lpFileSystemFlags
 , BYVAL DWORD _                       ' __out_ecount_opt(nFileSystemNameSize) LPWSTR lpFileSystemNameBuffer
 , BYVAL DWORD _                       ' __in      DWORD nFileSystemNameSize
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE FUNCTION GetVolumeInformationByHandleW LIB "KERNEL32.DLL" ALIAS "GetVolumeInformationByHandleW" ( _
   BYVAL DWORD _                       ' __in      HANDLE hFile
 , BYVAL DWORD _                       ' __out_ecount_opt(nVolumeNameSize) LPWSTR lpVolumeNameBuffer
 , BYVAL DWORD _                       ' __in      DWORD nVolumeNameSize
 , BYREF DWORD _                       ' __out_opt LPDWORD lpVolumeSerialNumber
 , BYREF DWORD _                       ' __out_opt LPDWORD lpMaximumComponentLength
 , BYREF DWORD _                       ' __out_opt LPDWORD lpFileSystemFlags
 , BYVAL DWORD _                       ' __out_ecount_opt(nFileSystemNameSize) LPWSTR lpFileSystemNameBuffer
 , BYVAL DWORD _                       ' __in      DWORD nFileSystemNameSize
 ) AS LONG                             ' BOOL

#ENDIF ' /* _WIN32_WINNT >=  0x0600 */

DECLARE FUNCTION CancelSynchronousIo LIB "KERNEL32.DLL" ALIAS "CancelSynchronousIo" ( _
   BYVAL DWORD _                       ' __in HANDLE hThread
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CancelIoEx LIB "KERNEL32.DLL" ALIAS "CancelIoEx" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYREF OVERLAPPED _                   __in_opt LPOVERLAPPED lpOverlapped
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CancelIo LIB "KERNEL32.DLL" ALIAS "CancelIo" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFileBandwidthReservation LIB "KERNEL32.DLL" ALIAS "SetFileBandwidthReservation" ( _
   BYVAL DWORD _                       ' __in  HANDLE  hFile
 , BYVAL DWORD _                       ' __in  DWORD   nPeriodMilliseconds
 , BYVAL DWORD _                       ' __in  DWORD   nBytesPerPeriod
 , BYVAL LONG _                        ' __in  BOOL    bDiscardable
 , BYREF DWORD _                       ' __out LPDWORD lpTransferSize
 , BYREF DWORD _                       ' __out LPDWORD lpNumOutstandingRequests
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileBandwidthReservation LIB "KERNEL32.DLL" ALIAS "GetFileBandwidthReservation" ( _
   BYVAL DWORD _                       ' __in  HANDLE  hFile
 , BYREF DWORD _                       ' __out LPDWORD lpPeriodMilliseconds
 , BYREF DWORD _                       ' __out LPDWORD lpBytesPerPeriod
 , BYREF DWORD _                       ' __out LPBOOL  pDiscardable
 , BYREF DWORD _                       ' __out LPDWORD lpTransferSize
 , BYREF DWORD _                       ' __out LPDWORD lpNumOutstandingRequests
 ) AS LONG                             ' BOOL

'//
'// Event logging APIs
'//

DECLARE FUNCTION ClearEventLog LIB "ADVAPI32.DLL" ALIAS "ClearEventLogA" ( _
   BYVAL DWORD _                       ' __in     HANDLE hEventLog
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpBackupFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ClearEventLogW LIB "ADVAPI32.DLL" ALIAS "ClearEventLogW" ( _
   BYVAL DWORD _                       ' __in     HANDLE hEventLog
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpBackupFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BackupEventLog LIB "ADVAPI32.DLL" ALIAS "BackupEventLogA" ( _
   BYVAL DWORD _                       ' __in HANDLE hEventLog
 , BYREF ASCIIZ _                      ' __in LPCSTR lpBackupFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BackupEventLogW LIB "ADVAPI32.DLL" ALIAS "BackupEventLogW" ( _
   BYVAL DWORD _                       ' __in HANDLE hEventLog
 , BYVAL DWORD _                       ' __in LPCWSTR lpBackupFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CloseEventLog LIB "ADVAPI32.DLL" ALIAS "CloseEventLog" ( _
   BYVAL DWORD _                       ' __in HANDLE hEventLog
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeregisterEventSource LIB "ADVAPI32.DLL" ALIAS "DeregisterEventSource" ( _
   BYVAL DWORD _                       ' __in HANDLE hEventLog
 ) AS LONG                             ' BOOL

DECLARE FUNCTION NotifyChangeEventLog LIB "ADVAPI32.DLL" ALIAS "NotifyChangeEventLog" ( _
   BYVAL DWORD _                       ' __in HANDLE  hEventLog
 , BYVAL DWORD _                       ' __in HANDLE  hEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNumberOfEventLogRecords LIB "ADVAPI32.DLL" ALIAS "GetNumberOfEventLogRecords" ( _
   BYVAL DWORD _                       ' __in  HANDLE hEventLog
 , BYREF DWORD _                       ' __out PDWORD NumberOfRecords
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetOldestEventLogRecord LIB "ADVAPI32.DLL" ALIAS "GetOldestEventLogRecord" ( _
   BYVAL DWORD _                       ' __in  HANDLE hEventLog
 , BYREF DWORD _                       ' __out PDWORD OldestRecord
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OpenEventLog LIB "ADVAPI32.DLL" ALIAS "OpenEventLogA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpUNCServerName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpSourceName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenEventLogW LIB "ADVAPI32.DLL" ALIAS "OpenEventLogW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpUNCServerName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpSourceName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION RegisterEventSource LIB "ADVAPI32.DLL" ALIAS "RegisterEventSourceA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpUNCServerName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpSourceName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION RegisterEventSourceW LIB "ADVAPI32.DLL" ALIAS "RegisterEventSourceW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpUNCServerName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpSourceName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenBackupEventLog LIB "ADVAPI32.DLL" ALIAS "OpenBackupEventLogA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpUNCServerName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpFileName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenBackupEventLogW LIB "ADVAPI32.DLL" ALIAS "OpenBackupEventLogW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpUNCServerName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpFileName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION ReadEventLog LIB "ADVAPI32.DLL" ALIAS "ReadEventLogA" ( _
   BYVAL DWORD _                       ' __in  HANDLE     hEventLog
 , BYVAL DWORD _                       ' __in  DWORD      dwReadFlags
 , BYVAL DWORD _                       ' __in  DWORD      dwRecordOffset
 , BYREF EVENTLOGRECORD _              ' __out_bcount_part(nNumberOfBytesToRead, *pnBytesRead) LPVOID lpBuffer
 , BYVAL DWORD _                       ' __in  DWORD      nNumberOfBytesToRead
 , BYREF DWORD _                       ' __out DWORD      *pnBytesRead
 , BYREF DWORD _                       ' __out DWORD      *pnMinNumberOfBytesNeeded
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ReadEventLogW LIB "ADVAPI32.DLL" ALIAS "ReadEventLogW" ( _
   BYVAL DWORD _                       ' __in  HANDLE     hEventLog
 , BYVAL DWORD _                       ' __in  DWORD      dwReadFlags
 , BYVAL DWORD _                       ' __in  DWORD      dwRecordOffset
 , BYREF EVENTLOGRECORD _              ' __out_bcount_part(nNumberOfBytesToRead, *pnBytesRead) LPVOID lpBuffer
 , BYVAL DWORD _                       ' __in  DWORD      nNumberOfBytesToRead
 , BYREF DWORD _                       ' __out DWORD      *pnBytesRead
 , BYREF DWORD _                       ' __out DWORD      *pnMinNumberOfBytesNeeded
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ReportEvent LIB "ADVAPI32.DLL" ALIAS "ReportEventA" ( _
   BYVAL DWORD _                       ' __in     HANDLE     hEventLog
 , BYVAL WORD _                        ' __in     WORD       wType
 , BYVAL WORD _                        ' __in     WORD       wCategory
 , BYVAL DWORD _                       ' __in     DWORD      dwEventID
 , BYVAL SID PTR _                     ' __in_opt PSID       lpUserSid
 , BYVAL WORD _                        ' __in     WORD       wNumStrings
 , BYVAL DWORD _                       ' __in     DWORD      dwDataSize
 , BYREF ANY _                         ' __in_opt LPCSTR    *lpStrings
 , BYREF ANY _                         ' __in_bcount_opt(dwDataSize) LPVOID lpRawData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ReportEventW LIB "ADVAPI32.DLL" ALIAS "ReportEventW" ( _
   BYVAL DWORD _                       ' __in     HANDLE     hEventLog
 , BYVAL WORD _                        ' __in     WORD       wType
 , BYVAL WORD _                        ' __in     WORD       wCategory
 , BYVAL DWORD _                       ' __in     DWORD      dwEventID
 , BYVAL SID PTR _                     ' __in_opt PSID       lpUserSid
 , BYVAL WORD _                        ' __in     WORD       wNumStrings
 , BYVAL DWORD _                       ' __in     DWORD      dwDataSize
 , BYREF ANY _                         ' __in_opt LPCWSTR   *lpStrings
 , BYREF ANY _                         ' __in_bcount_opt(dwDataSize) LPVOID lpRawData
 ) AS LONG                             ' BOOL

%EVENTLOG_FULL_INFO    = 0

TYPE EVENTLOG_FULL_INFORMATION
   dwFull AS DWORD                     ' DWORD    dwFull
END TYPE

DECLARE FUNCTION GetEventLogInformation LIB "KERNEL32.DLL" ALIAS "GetEventLogInformation" ( _
   BYVAL DWORD _                       ' __in  HANDLE     hEventLog
 , BYVAL DWORD _                       ' __in  DWORD      dwInfoLevel
 , BYREF ANY _                         ' __out_bcount_part(cbBufSize, *pcbBytesNeeded) LPVOID lpBuffer
 , BYVAL DWORD _                       ' __in  DWORD      cbBufSize
 , BYREF DWORD _                       ' __out LPDWORD    pcbBytesNeeded
 ) AS LONG                             ' BOOL

'//
'//
'// Security APIs
'//


DECLARE FUNCTION DuplicateToken LIB "ADVAPI32.DLL" ALIAS "DuplicateToken" ( _
   BYVAL DWORD _                       ' __in        HANDLE ExistingTokenHandle
 , BYREF LONG _                        ' __in        SECURITY_IMPERSONATION_LEVEL ImpersonationLevel
 , BYREF DWORD _                       ' __deref_out PHANDLE DuplicateTokenHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetKernelObjectSecurity LIB "ADVAPI32.DLL" ALIAS "GetKernelObjectSecurity" ( _
   BYVAL DWORD _                       ' __in  HANDLE Handle
 , BYVAL DWORD _                       ' __in  SECURITY_INFORMATION RequestedInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __out_bcount(nLength) PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL DWORD _                       ' __in  DWORD nLength
 , BYREF DWORD _                       ' __out LPDWORD lpnLengthNeeded
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ImpersonateNamedPipeClient LIB "ADVAPI32.DLL" ALIAS "ImpersonateNamedPipeClient" ( _
   BYVAL DWORD _                       ' __in HANDLE hNamedPipe
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ImpersonateSelf LIB "ADVAPI32.DLL" ALIAS "ImpersonateSelf" ( _
   BYVAL LONG _                        ' __in SECURITY_IMPERSONATION_LEVEL ImpersonationLevel
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RevertToSelf LIB "ADVAPI32.DLL" ALIAS "RevertToSelf" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetThreadToken LIB "ADVAPI32.DLL" ALIAS "SetThreadToken" ( _
   BYREF DWORD _                       ' __in_opt PHANDLE Thread
 , BYVAL DWORD _                       ' __in_opt HANDLE Token
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheck LIB "ADVAPI32.DLL" ALIAS "AccessCheck" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in    PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL DWORD _                       ' __in    HANDLE ClientToken
 , BYVAL DWORD _                       ' __in    DWORD DesiredAccess
 , BYREF GENERIC_MAPPING _             ' __in    PGENERIC_MAPPING GenericMapping
 , BYREF PRIVILEGE_SET _               ' __out_bcount_part(*PrivilegeSetLength, *PrivilegeSetLength) PPRIVILEGE_SET PrivilegeSet
 , BYREF DWORD _                       ' __inout LPDWORD PrivilegeSetLength
 , BYREF DWORD _                       ' __out   LPDWORD GrantedAccess
 , BYREF LONG _                        ' __out   LPBOOL AccessStatus
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION AccessCheckByType LIB "ADVAPI32.DLL" ALIAS "AccessCheckByType" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID PrincipalSelfSid
 , BYVAL SID PTR _                     ' __in     HANDLE ClientToken
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYREF OBJECT_TYPE_LIST _            ' __inout_ecount_opt(ObjectTypeListLength) POBJECT_TYPE_LIST ObjectTypeList
 , BYVAL DWORD _                       ' __in     DWORD ObjectTypeListLength
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYREF PRIVILEGE_SET _               ' __out_bcount_part(*PrivilegeSetLength, *PrivilegeSetLength) PPRIVILEGE_SET PrivilegeSet
 , BYREF DWORD _                       ' __inout  LPDWORD PrivilegeSetLength
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF LONG _                        ' __out    LPBOOL AccessStatus
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheckByTypeResultList LIB "ADVAPI32.DLL" ALIAS "AccessCheckByTypeResultList" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID PrincipalSelfSid
 , BYVAL DWORD _                       ' __in     HANDLE ClientToken
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYREF OBJECT_TYPE_LIST _            ' __inout_ecount_opt(ObjectTypeListLength) POBJECT_TYPE_LIST ObjectTypeList
 , BYVAL DWORD _                       ' __in     DWORD ObjectTypeListLength
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYREF PRIVILEGE_SET _               ' __out_bcount_part(*PrivilegeSetLength, *PrivilegeSetLength) PPRIVILEGE_SET PrivilegeSet
 , BYREF DWORD _                       ' __inout  LPDWORD PrivilegeSetLength
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccessList
 , BYREF DWORD _                       ' __out    LPDWORD AccessStatusList
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >=  0x0500 */

DECLARE FUNCTION OpenProcessToken LIB "ADVAPI32.DLL" ALIAS "OpenProcessToken" ( _
   BYVAL DWORD _                       ' __in        HANDLE ProcessHandle
 , BYVAL DWORD _                       ' __in        DWORD DesiredAccess
 , BYREF DWORD _                       ' __deref_out PHANDLE TokenHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OpenThreadToken LIB "ADVAPI32.DLL" ALIAS "OpenThreadToken" ( _
   BYVAL DWORD _                       ' __in        HANDLE ThreadHandle
 , BYVAL DWORD _                       ' __in        DWORD DesiredAccess
 , BYVAL LONG _                        ' __in        BOOL OpenAsSelf
 , BYREF DWORD _                       ' __deref_out PHANDLE TokenHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTokenInformation LIB "ADVAPI32.DLL" ALIAS "GetTokenInformation" ( _
   BYVAL DWORD _                       ' __in      HANDLE TokenHandle
 , BYVAL LONG _                        ' __in      TOKEN_INFORMATION_CLASS TokenInformationClass
 , BYREF ANY _                         ' __out_bcount_part_opt(TokenInformationLength, *ReturnLength) LPVOID TokenInformation
 , BYVAL DWORD _                       ' __in      DWORD TokenInformationLength
 , BYREF DWORD _                       ' __out_opt PDWORD ReturnLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetTokenInformation LIB "ADVAPI32.DLL" ALIAS "SetTokenInformation" ( _
   BYVAL DWORD _                       ' __in HANDLE TokenHandle
 , BYVAL LONG _                        ' __in TOKEN_INFORMATION_CLASS TokenInformationClass
 , BYREF ANY _                         ' __in_bcount(TokenInformationLength) LPVOID TokenInformation
 , BYVAL DWORD _                       ' __in DWORD TokenInformationLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AdjustTokenPrivileges LIB "ADVAPI32.DLL" ALIAS "AdjustTokenPrivileges" ( _
   BYVAL DWORD _                       ' __in      HANDLE TokenHandle
 , BYVAL LONG _                        ' __in      BOOL DisableAllPrivileges
 , BYREF TOKEN_PRIVILEGES _            ' __in_opt  PTOKEN_PRIVILEGES NewState
 , BYVAL DWORD _                       ' __in      DWORD BufferLength
 , BYREF TOKEN_PRIVILEGES _            ' __out_bcount_part_opt(BufferLength, *ReturnLength) PTOKEN_PRIVILEGES PreviousState
 , BYREF DWORD _                       ' __out_opt PDWORD ReturnLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AdjustTokenGroups LIB "ADVAPI32.DLL" ALIAS "AdjustTokenGroups" ( _
   BYVAL DWORD _                       ' __in      HANDLE TokenHandle
 , BYVAL LONG _                        ' __in      BOOL ResetToDefault
 , BYREF TOKEN_GROUPS _                ' __in_opt  PTOKEN_GROUPS NewState
 , BYVAL DWORD _                       ' __in      DWORD BufferLength
 , BYREF TOKEN_GROUPS _                ' __out_bcount_part_opt(BufferLength, *ReturnLength) PTOKEN_GROUPS PreviousState
 , BYREF DWORD _                       ' __out_opt PDWORD ReturnLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PrivilegeCheck LIB "ADVAPI32.DLL" ALIAS "PrivilegeCheck" ( _
   BYVAL LONG _                        ' __in    HANDLE ClientToken
 , BYREF PRIVILEGE_SET _               ' __inout PPRIVILEGE_SET RequiredPrivileges
 , BYREF LONG _                        ' __out   LPBOOL pfResult
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheckAndAuditAlarm LIB "ADVAPI32.DLL" ALIAS "AccessCheckAndAuditAlarmA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYREF ASCIIZ _                      ' __in     LPSTR ObjectTypeName
 , BYREF ASCIIZ _                      ' __in_opt LPSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF LONG _                        ' __out    LPBOOL AccessStatus
 , BYREF LONG _                        ' __out    LPBOOL pfGenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheckAndAuditAlarmW LIB "ADVAPI32.DLL" ALIAS "AccessCheckAndAuditAlarmW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYVAL DWORD _                       ' __in     LPWSTR ObjectTypeName
 , BYVAL DWORD _                       ' __in_opt LPWSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF LONG _                        ' __out    LPBOOL AccessStatus
 , BYREF LONG _                        ' __out    LPBOOL pfGenerateOnClose
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION AccessCheckByTypeAndAuditAlarm LIB "ADVAPI32.DLL" ALIAS "AccessCheckByTypeAndAuditAlarmA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYREF ASCIIZ _                      ' __in     LPCSTR ObjectTypeName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID PrincipalSelfSid
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYVAL LONG _                        ' __in     AUDIT_EVENT_TYPE AuditType
 , BYVAL DWORD _                       ' __in     DWORD Flags
 , BYREF OBJECT_TYPE_LIST _            ' __inout_ecount_opt(ObjectTypeListLength) POBJECT_TYPE_LIST ObjectTypeList
 , BYVAL DWORD _                       ' __in     DWORD ObjectTypeListLength
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF LONG _                        ' __out    LPBOOL AccessStatus
 , BYREF LONG _                        ' __out    LPBOOL pfGenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheckByTypeAndAuditAlarmW LIB "ADVAPI32.DLL" ALIAS "AccessCheckByTypeAndAuditAlarmW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYVAL DWORD _                       ' __in     LPCWSTR ObjectTypeName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID PrincipalSelfSid
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYVAL LONG _                        ' __in     AUDIT_EVENT_TYPE AuditType
 , BYVAL DWORD _                       ' __in     DWORD Flags
 , BYREF OBJECT_TYPE_LIST _            ' __inout_ecount_opt(ObjectTypeListLength) POBJECT_TYPE_LIST ObjectTypeList
 , BYVAL DWORD _                       ' __in     DWORD ObjectTypeListLength
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF LONG _                        ' __out    LPBOOL AccessStatus
 , BYREF LONG _                        ' __out    LPBOOL pfGenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheckByTypeResultListAndAuditAlarm LIB "ADVAPI32.DLL" ALIAS "AccessCheckByTypeResultListAndAuditAlarmA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYREF ASCIIZ _                      ' __in     LPCSTR ObjectTypeName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID PrincipalSelfSid
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYVAL LONG _                        ' __in     AUDIT_EVENT_TYPE AuditType
 , BYVAL DWORD _                       ' __in     DWORD Flags
 , BYREF OBJECT_TYPE_LIST _            ' __in     DWORD ObjectTypeListLength
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF DWORD _                       ' __out    LPDWORD AccessStatusList
 , BYREF LONG _                        ' __out    LPBOOL pfGenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheckByTypeResultListAndAuditAlarmW LIB "ADVAPI32.DLL" ALIAS "AccessCheckByTypeResultListAndAuditAlarmW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYVAL DWORD _                       ' __in     LPCWSTR ObjectTypeName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID PrincipalSelfSid
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYVAL LONG _                        ' __in     AUDIT_EVENT_TYPE AuditType
 , BYVAL DWORD _                       ' __in     DWORD Flags
 , BYREF OBJECT_TYPE_LIST _            ' __in     DWORD ObjectTypeListLength
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF DWORD _                       ' __out    LPDWORD AccessStatusList
 , BYREF LONG _                        ' __out    LPBOOL pfGenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheckByTypeResultListAndAuditAlarmByHandle LIB "ADVAPI32.DLL" ALIAS "AccessCheckByTypeResultListAndAuditAlarmByHandleA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYVAL DWORD _                       ' __in     HANDLE ClientToken
 , BYREF ASCIIZ _                      ' __in     LPCSTR ObjectTypeName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID PrincipalSelfSid
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYVAL LONG _                        ' __in     AUDIT_EVENT_TYPE AuditType
 , BYVAL DWORD _                       ' __in     DWORD Flags
 , BYREF OBJECT_TYPE_LIST _            ' __inout_ecount_opt(ObjectTypeListLength) POBJECT_TYPE_LIST ObjectTypeList
 , BYVAL DWORD _                       ' __in     DWORD ObjectTypeListLength
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF DWORD _                       ' __out    LPDWORD AccessStatusList
 , BYREF LONG _                        ' __out    LPBOOL pfGenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AccessCheckByTypeResultListAndAuditAlarmByHandleW LIB "ADVAPI32.DLL" ALIAS "AccessCheckByTypeResultListAndAuditAlarmByHandleW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYVAL DWORD _                       ' __in     HANDLE ClientToken
 , BYVAL DWORD _                       ' __in     LPCWSTR ObjectTypeName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID PrincipalSelfSid
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYVAL LONG _                        ' __in     AUDIT_EVENT_TYPE AuditType
 , BYVAL DWORD _                       ' __in     DWORD Flags
 , BYREF OBJECT_TYPE_LIST _            ' __inout_ecount_opt(ObjectTypeListLength) POBJECT_TYPE_LIST ObjectTypeList
 , BYVAL DWORD _                       ' __in     DWORD ObjectTypeListLength
 , BYREF GENERIC_MAPPING _             ' __in     PGENERIC_MAPPING GenericMapping
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYREF DWORD _                       ' __out    LPDWORD GrantedAccess
 , BYREF DWORD _                       ' __out    LPDWORD AccessStatusList
 , BYREF LONG _                        ' __out    LPBOOL pfGenerateOnClose
 ) AS LONG                             ' BOOL

'#endif //(_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION ObjectOpenAuditAlarm LIB "KERNEL32.DLL" ALIAS "ObjectOpenAuditAlarmA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYREF ASCIIZ _                      ' __in     LPSTR ObjectTypeName
 , BYREF ASCIIZ _                      ' __in_opt LPSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR _         ' __in     PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL DWORD _                       ' __in     HANDLE ClientToken
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYVAL DWORD _                       ' __in     DWORD GrantedAccess
 , BYREF PRIVILEGE_SET _               ' __in_opt PPRIVILEGE_SET Privileges
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYVAL LONG _                        ' __in     BOOL AccessGranted
 , BYREF LONG _                        ' __out    LPBOOL GenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ObjectOpenAuditAlarmW LIB "KERNEL32.DLL" ALIAS "ObjectOpenAuditAlarmW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR SubsystemName
 , BYVAL DWORD _                       ' __in     LPVOID HandleId
 , BYVAL DWORD _                       ' __in     LPWSTR ObjectTypeName
 , BYVAL DWORD _                       ' __in_opt LPWSTR ObjectName
 , BYREF SECURITY_DESCRIPTOR  _        ' __in     PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL DWORD _                       ' __in     HANDLE ClientToken
 , BYVAL DWORD _                       ' __in     DWORD DesiredAccess
 , BYVAL DWORD _                       ' __in     DWORD GrantedAccess
 , BYREF PRIVILEGE_SET _               ' __in_opt PPRIVILEGE_SET Privileges
 , BYVAL LONG _                        ' __in     BOOL ObjectCreation
 , BYVAL LONG _                        ' __in     BOOL AccessGranted
 , BYREF LONG _                        ' __out    LPBOOL GenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ObjectPrivilegeAuditAlarm LIB "ADVAPI32.DLL" ALIAS "ObjectPrivilegeAuditAlarmA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in LPVOID HandleId
 , BYVAL DWORD _                       ' __in HANDLE ClientToken
 , BYVAL DWORD _                       ' __in DWORD DesiredAccess
 , BYREF PRIVILEGE_SET _               ' __in PPRIVILEGE_SET Privileges
 , BYVAL LONG _                        ' __in BOOL AccessGranted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ObjectPrivilegeAuditAlarmW LIB "ADVAPI32.DLL" ALIAS "ObjectPrivilegeAuditAlarmW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR SubsystemName
 , BYVAL DWORD _                       ' __in LPVOID HandleId
 , BYVAL DWORD _                       ' __in HANDLE ClientToken
 , BYVAL DWORD _                       ' __in DWORD DesiredAccess
 , BYREF PRIVILEGE_SET _               ' __in PPRIVILEGE_SET Privileges
 , BYVAL LONG _                        ' __in BOOL AccessGranted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ObjectCloseAuditAlarm LIB "ADVAPI32.DLL" ALIAS "ObjectCloseAuditAlarmA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in LPVOID HandleId
 , BYVAL LONG _                        ' __in BOOL GenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ObjectCloseAuditAlarmW LIB "ADVAPI32.DLL" ALIAS "ObjectCloseAuditAlarmW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR SubsystemName
 , BYVAL DWORD _                       ' __in LPVOID HandleId
 , BYVAL LONG _                        ' __in BOOL GenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ObjectDeleteAuditAlarm LIB "ADVAPI32.DLL" ALIAS "ObjectDeleteAuditAlarmA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in LPVOID HandleId
 , BYVAL LONG _                        ' __in BOOL GenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ObjectDeleteAuditAlarmW LIB "ADVAPI32.DLL" ALIAS "ObjectDeleteAuditAlarmW" ( _
   BYVAL DWORD _                       ' __in LPCSTR SubsystemName
 , BYVAL DWORD _                       ' __in LPVOID HandleId
 , BYVAL LONG _                        ' __in BOOL GenerateOnClose
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PrivilegedServiceAuditAlarm LIB "ADVAPI32.DLL" ALIAS "PrivilegedServiceAuditAlarmA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR SubsystemName
 , BYREF ASCIIZ _                      ' __in LPCSTR ServiceName
 , BYVAL DWORD _                       ' __in HANDLE ClientToken
 , BYREF PRIVILEGE_SET _               ' __in PPRIVILEGE_SET Privileges
 , BYVAL LONG _                        ' __in BOOL AccessGranted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PrivilegedServiceAuditAlarmW LIB "ADVAPI32.DLL" ALIAS "PrivilegedServiceAuditAlarmW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR SubsystemName
 , BYVAL DWORD _                       ' __in LPCWSTR ServiceName
 , BYVAL DWORD _                       ' __in HANDLE ClientToken
 , BYREF PRIVILEGE_SET _               ' __in PPRIVILEGE_SET Privileges
 , BYVAL LONG _                        ' __in BOOL AccessGranted
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION IsWellKnownSid LIB "ADVAPI32.DLL" ALIAS "IsWellKnownSid" ( _
   BYVAL SID PTR _                     ' __in PSID pSid
 , BYVAL LONG _                        ' __in WELL_KNOWN_SID_TYPE WellKnownSidType
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateWellKnownSid LIB "ADVAPI32.DLL" ALIAS "CreateWellKnownSid" ( _
   BYVAL LONG _                        ' __in     WELL_KNOWN_SID_TYPE WellKnownSidType
 , BYVAL SID PTR _                     ' __in_opt PSID DomainSid
 , BYREF ANY _                         ' __out_bcount_part(*cbSid, *cbSid) PSID pSid
 , BYREF DWORD _                       ' __inout  DWORD *cbSid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EqualDomainSid LIB "ADVAPI32.DLL" ALIAS "EqualDomainSid" ( _
   BYVAL SID PTR _                     ' __in  PSID pSid1
 , BYVAL SID PTR _                     ' __in  PSID pSid2
 , BYREF LONG _                        ' __out BOOL *pfEqual
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetWindowsAccountDomainSid LIB "ADVAPI32.DLL" ALIAS "GetWindowsAccountDomainSid" ( _
   BYVAL SID PTR _                     ' __in    PSID pSid
 , BYREF ANY _                         ' __out_bcount_part_opt(*cbDomainSid, *cbDomainSid) PSID pDomainSid
 , BYREF DWORD _                       ' __inout DWORD* cbDomainSid
 ) AS LONG                             ' BOOL

'#endif //(_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION IsValidSid LIB "ADVAPI32.DLL" ALIAS "IsValidSid" ( _
   BYVAL SID PTR _                     ' __in PSID pSid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EqualSid LIB "ADVAPI32.DLL" ALIAS "EqualSid" ( _
   BYVAL SID PTR _                     ' __in PSID pSid1
 , BYVAL SID PTR _                     ' __in PSID pSid2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EqualPrefixSid LIB "ADVAPI32.DLL" ALIAS "EqualPrefixSid" ( _
   BYVAL SID PTR _                     ' __in PSID pSid1
 , BYVAL SID PTR _                     ' __in PSID pSid2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSidLengthRequired LIB "ADVAPI32.DLL" ALIAS "GetSidLengthRequired" ( _
   BYVAL BYTE _                        ' __in UCHAR nSubAuthorityCount
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION AllocateAndInitializeSid LIB "ADVAPI32.DLL" ALIAS "AllocateAndInitializeSid" ( _
   BYREF SID_IDENTIFIER_AUTHORITY _    ' __in        PSID_IDENTIFIER_AUTHORITY pIdentifierAuthority
 , BYVAL BYTE _                        ' __in        BYTE nSubAuthorityCount
 , BYVAL DWORD _                       ' __in        DWORD nSubAuthority0
 , BYVAL DWORD _                       ' __in        DWORD nSubAuthority1
 , BYVAL DWORD _                       ' __in        DWORD nSubAuthority2
 , BYVAL DWORD _                       ' __in        DWORD nSubAuthority3
 , BYVAL DWORD _                       ' __in        DWORD nSubAuthority4
 , BYVAL DWORD _                       ' __in        DWORD nSubAuthority5
 , BYVAL DWORD _                       ' __in        DWORD nSubAuthority6
 , BYVAL DWORD _                       ' __in        DWORD nSubAuthority7
 , BYREF ANY _                         ' __deref_out PSID *pSid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FreeSid LIB "ADVAPI32.DLL" ALIAS "FreeSid" ( _
   BYVAL SID PTR _                     ' __in PSID pSid
 ) AS DWORD                            ' PVOID

DECLARE FUNCTION InitializeSid LIB "ADVAPI32.DLL" ALIAS "InitializeSid" ( _
   BYVAL SID PTR _                     ' __out PSID Sid
 , BYREF SID_IDENTIFIER_AUTHORITY _    ' __in  PSID_IDENTIFIER_AUTHORITY pIdentifierAuthority
 , BYVAL BYTE _                        ' __in  BYTE nSubAuthorityCount
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSidIdentifierAuthority LIB "ADVAPI32.DLL" ALIAS "GetSidIdentifierAuthority" ( _
   BYVAL SID PTR _                     ' __in PSID pSid
 ) AS DWORD                            ' PSID_IDENTIFIER_AUTHORITY

DECLARE FUNCTION GetSidSubAuthority LIB "ADVAPI32.DLL" ALIAS "GetSidSubAuthority" ( _
   BYVAL SID PTR _                     ' __in PSID pSid
 , BYVAL DWORD _                       ' __in DWORD nSubAuthority
 ) AS DWORD                            ' PDWORD

DECLARE FUNCTION GetSidSubAuthorityCount LIB "ADVAPI32.DLL" ALIAS "GetSidSubAuthorityCount" ( _
   BYVAL SID PTR _                     ' __in PSID pSid
 ) AS DWORD                            ' PUCHAR

DECLARE FUNCTION GetLengthSid LIB "ADVAPI32.DLL" ALIAS "GetLengthSid" ( _
   BYVAL SID PTR _                     ' __in PSID pSid
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CopySid LIB "ADVAPI32.DLL" ALIAS "CopySid" ( _
   BYVAL DWORD _                       ' __in DWORD nDestinationSidLength
 , BYREF ANY _                         ' __out_bcount(nDestinationSidLength) PSID pDestinationSid
 , BYVAL SID PTR _                     ' __in PSID pSourceSid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AreAllAccessesGranted LIB "ADVAPI32.DLL" ALIAS "AreAllAccessesGranted" ( _
   BYVAL DWORD _                       ' __in DWORD GrantedAccess
 , BYVAL DWORD _                       ' __in DWORD DesiredAccess
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AreAnyAccessesGranted LIB "ADVAPI32.DLL" ALIAS "AreAnyAccessesGranted" ( _
   BYVAL DWORD _                       ' __in DWORD GrantedAccess
 , BYVAL DWORD _                       ' __in DWORD DesiredAccess
 ) AS LONG                             ' BOOL

DECLARE SUB MapGenericMask LIB "ADVAPI32.DLL" ALIAS "MapGenericMask" ( _
   BYREF DWORD _                       ' __inout PDWORD AccessMask
 , BYREF GENERIC_MAPPING _             ' __in    PGENERIC_MAPPING GenericMapping
 )                                     ' VOID

DECLARE FUNCTION IsValidAcl LIB "ADVAPI32.DLL" ALIAS "IsValidAcl" ( _
   BYVAL ACL PTR _                     ' __in PACL pAcl
 ) AS LONG                             ' BOOL

DECLARE FUNCTION InitializeAcl LIB "ADVAPI32.DLL" ALIAS "InitializeAcl" ( _
   BYVAL ACL PTR _                     ' __out_bcount(nAclLength) PACL pAcl
 , BYVAL DWORD _                       ' __in DWORD nAclLength
 , BYVAL DWORD _                       ' __in DWORD dwAclRevision
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetAclInformation LIB "ADVAPI32.DLL" ALIAS "GetAclInformation" ( _
   BYVAL ACL PTR _                     ' __in PACL pAcl
 , BYREF ANY _                         ' __out_bcount(nAclInformationLength) LPVOID pAclInformation
 , BYVAL DWORD _                       ' __in DWORD nAclInformationLength
 , BYVAL DWORD _                       ' __in ACL_INFORMATION_CLASS dwAclInformationClass
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetAclInformation LIB "ADVAPI32.DLL" ALIAS "SetAclInformation" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYREF ANY _                         ' __in_bcount(nAclInformationLength) LPVOID pAclInformation
 , BYVAL DWORD _                       ' __in    DWORD nAclInformationLength
 , BYVAL DWORD _                       ' __in    ACL_INFORMATION_CLASS dwAclInformationClass
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AddAce LIB "ADVAPI32.DLL" ALIAS "AddAce" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in    DWORD dwStartingAceIndex
 , BYREF ANY _                         ' __in_bcount(nAceListLength) LPVOID pAceList
 , BYVAL DWORD _                       ' __in    DWORD nAceListLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteAce LIB "ADVAPI32.DLL" ALIAS "DeleteAce" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceIndex
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetAce LIB "ADVAPI32.DLL" ALIAS "GetAce" ( _
   BYVAL ACL PTR _                     ' __in        PACL pAcl
 , BYVAL DWORD _                       ' __in        DWORD dwAceIndex
 , BYREF ANY _                         ' __deref_out LPVOID *pAce
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AddAccessAllowedAce LIB "ADVAPI32.DLL" ALIAS "AddAccessAllowedAce" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in    DWORD AccessMask
 , BYVAL SID PTR _                     ' __in    PSID pSid
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)
DECLARE FUNCTION AddAccessAllowedAceEx LIB "ADVAPI32.DLL" ALIAS "AddAccessAllowedAceEx" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in    DWORD AceFlags
 , BYVAL DWORD _                       ' __in    DWORD AccessMask
 , BYVAL SID PTR _                     ' __in    PSID pSid
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >=  0x0500 */

'#if(_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600
DECLARE FUNCTION AddMandatoryAce LIB "ADVAPI32.DLL" ALIAS "AddMandatoryAce" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in    DWORD AceFlags
 , BYVAL DWORD _                       ' __in    DWORD MandatoryPolicy
 , BYVAL SID PTR _                     ' __in    PSID pLabelSid
 ) AS LONG                             ' BOOL
#ENDIF ' /* _WIN32_WINNT >=  0x0600 */

DECLARE FUNCTION AddAccessDeniedAce LIB "ADVAPI32.DLL" ALIAS "AddAccessDeniedAce" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in    DWORD AccessMask
 , BYVAL SID PTR _                     ' __in    PSID pSid
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)
DECLARE FUNCTION AccessDeniedAceEx LIB "ADVAPI32.DLL" ALIAS "AccessDeniedAceEx" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in    DWORD AceFlags
 , BYVAL DWORD _                       ' __in    DWORD AccessMask
 , BYVAL SID PTR _                     ' __in    PSID pSid
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >=  0x0500 */

DECLARE FUNCTION AddAuditAccessAce LIB "ADVAPI32.DLL" ALIAS "AddAuditAccessAce" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in    DWORD dwAccessMask
 , BYVAL SID PTR _                     ' __in    PSID pSid
 , BYVAL LONG _                        ' __in    BOOL bAuditSuccess
 , BYVAL LONG _                        ' __in    BOOL bAuditFailure
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)
DECLARE FUNCTION AddAuditAccessAceEx LIB "ADVAPI32.DLL" ALIAS "AddAuditAccessAceEx" ( _
   BYVAL ACL PTR _                     ' __inout PACL pAcl
 , BYVAL DWORD _                       ' __in    DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in    DWORD AceFlags
 , BYVAL DWORD _                       ' __in    DWORD dwAccessMask
 , BYVAL SID PTR _                     ' __in    PSID pSid
 , BYVAL LONG _                        ' __in    BOOL bAuditSuccess
 , BYVAL LONG _                        ' __in    BOOL bAuditFailure
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AddAccessAllowedObjectAce LIB "ADVAPI32.DLL" ALIAS "AddAccessAllowedObjectAce" ( _
   BYVAL ACL PTR _                     ' __inout  PACL pAcl
 , BYVAL DWORD _                       ' __in     DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in     DWORD AceFlags
 , BYVAL DWORD _                       ' __in     DWORD AccessMask
 , BYREF GUID _                        ' __in_opt GUID *ObjectTypeGuid
 , BYREF GUID _                        ' __in_opt GUID *InheritedObjectTypeGuid
 , BYVAL SID PTR _                     ' __in     PSID pSid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AddAccessDeniedObjectAce LIB "ADVAPI32.DLL" ALIAS "AddAccessDeniedObjectAce" ( _
   BYVAL ACL PTR _                     ' __inout  PACL pAcl
 , BYVAL DWORD _                       ' __in     DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in     DWORD AceFlags
 , BYVAL DWORD _                       ' __in     DWORD AccessMask
 , BYREF GUID _                        ' __in_opt GUID *ObjectTypeGuid
 , BYREF GUID _                        ' __in_opt GUID *InheritedObjectTypeGuid
 , BYVAL SID PTR _                     ' __in     PSID pSid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AddAuditAccessObjectAce LIB "ADVAPI32.DLL" ALIAS "AddAuditAccessObjectAce" ( _
   BYVAL ACL PTR _                     ' __inout  PACL pAcl
 , BYVAL DWORD _                       ' __in     DWORD dwAceRevision
 , BYVAL DWORD _                       ' __in     DWORD AceFlags
 , BYVAL DWORD _                       ' __in     DWORD AccessMask
 , BYREF GUID _                        ' __in_opt GUID *ObjectTypeGuid
 , BYREF GUID _                        ' __in_opt GUID *InheritedObjectTypeGuid
 , BYVAL SID PTR _                     ' __in     PSID pSid
 , BYVAL LONG _                        ' __in     BOOL bAuditSuccess
 , BYVAL LONG _                        ' __in     BOOL bAuditFailure
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >=  0x0500 */

DECLARE FUNCTION FindFirstFreeAce LIB "ADVAPI32.DLL" ALIAS "FindFirstFreeAce" ( _
   BYVAL ACL PTR _                     ' __in        PACL pAcl
 , BYREF ANY _                         ' __deref_out LPVOID *pAce
 ) AS LONG                             ' BOOL

DECLARE FUNCTION InitializeSecurityDescriptor LIB "ADVAPI32.DLL" ALIAS "InitializeSecurityDescriptor" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __out PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL DWORD _                       ' __in  DWORD dwRevision
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsValidSecurityDescriptor LIB "ADVAPI32.DLL" ALIAS "IsValidSecurityDescriptor" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in PSECURITY_DESCRIPTOR pSecurityDescriptor
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsValidRelativeSecurityDescriptor LIB "ADVAPI32.DLL" ALIAS "IsValidRelativeSecurityDescriptor" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL DWORD _                       ' __in ULONG SecurityDescriptorLength
 , BYVAL DWORD _                       ' __in SECURITY_INFORMATION RequiredInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSecurityDescriptorLength LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorLength" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in PSECURITY_DESCRIPTOR pSecurityDescriptor
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetSecurityDescriptorControl LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorControl" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in  PSECURITY_DESCRIPTOR pSecurityDescriptor,
 , BYREF WORD _                        ' __out PSECURITY_DESCRIPTOR_CONTROL pControl
 , BYREF DWORD _                       ' __out LPDWORD lpdwRevision
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)
DECLARE FUNCTION SetSecurityDescriptorControl LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorControl" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAl WORD _                        ' __in SECURITY_DESCRIPTOR_CONTROL ControlBitsOfInterest
 , BYVAL WORD _                        ' __in SECURITY_DESCRIPTOR_CONTROL ControlBitsToSet
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >=  0x0500 */

DECLARE FUNCTION SetSecurityDescriptorDacl LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorDacl" ( _
   BYREF SECURITY_DESCRIPTOR  _        ' __inout  PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL LONG _                        ' __in     BOOL bDaclPresent
 , BYVAL ACL PTR _                     ' __in_opt PACL pDacl
 , BYVAL LONG _                        ' __in     BOOL bDaclDefaulted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSecurityDescriptorDacl LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorDacl" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in        PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYREF LONG _                        ' __out       LPBOOL lpbDaclPresent
 , BYREF ANY _                         ' __deref_out PACL *pDacl
 , BYREF LONG _                        ' __out       LPBOOL lpbDaclDefaulted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetSecurityDescriptorSacl LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorSacl" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __inout  PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL LONG _                        ' __in     BOOL bSaclPresent
 , BYVAL ACL PTR _                     ' __in_opt PACL pSacl
 , BYVAL LONG _                        ' __in     BOOL bSaclDefaulted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSecurityDescriptorSacl LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorSacl" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in        PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYREF LONG _                        ' __out       LPBOOL lpbSaclPresent
 , BYREF ANY _                         ' __deref_out PACL *pSacl
 , BYREF LONG _                        ' __out       LPBOOL lpbSaclDefaulted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetSecurityDescriptorOwner LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorOwner" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __inout  PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID pOwner
 , BYVAL LONG _                        ' __in     BOOL bOwnerDefaulted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSecurityDescriptorOwner LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorOwner" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in        PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYREF ANY _                         ' __deref_out PSID *pOwner
 , BYREF LONG _                        ' __out       LPBOOL lpbOwnerDefaulted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetSecurityDescriptorGroup LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorGroup" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __inout  PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL SID PTR _                     ' __in_opt PSID pGroup
 , BYVAL LONG _                        ' __in     BOOL bGroupDefaulted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSecurityDescriptorGroup LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorGroup" ( _
   BYREF SECURITY_DESCRIPTOR _         ' PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYREF ANY _                         ' __deref_out PSID *pGroup
 , BYREF LONG _                        ' __out       LPBOOL lpbGroupDefaulted
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetSecurityDescriptorRMControl LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorRMControl" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __inout  PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYVAL DWORD _                       ' __in_opt PUCHAR RMControl
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetSecurityDescriptorRMControl LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorRMControl" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in  PSECURITY_DESCRIPTOR SecurityDescriptor
 , BYREF DWORD _                       ' __out PUCHAR RMControl
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CreatePrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "CreatePrivateObjectSecurity" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in_opt    PSECURITY_DESCRIPTOR ParentDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __in_opt    PSECURITY_DESCRIPTOR CreatorDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __deref_out PSECURITY_DESCRIPTOR * NewDescriptor
 , BYVAL LONG _                        ' __in        BOOL IsDirectoryObject
 , BYVAL DWORD _                       ' __in_opt    HANDLE Token
 , BYREF GENERIC_MAPPING _             ' __in        PGENERIC_MAPPING GenericMapping
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION ConvertToAutoInheritPrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "ConvertToAutoInheritPrivateObjectSecurity" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in_opt    PSECURITY_DESCRIPTOR ParentDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __in        PSECURITY_DESCRIPTOR CurrentSecurityDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __deref_out PSECURITY_DESCRIPTOR *NewSecurityDescriptor
 , BYREF GUID _                        ' __in_opt    GUID *ObjectType
 , BYVAL BYTE _                        ' __in        BOOLEAN IsDirectoryObject
 , BYREF GENERIC_MAPPING _             ' __in        PGENERIC_MAPPING GenericMapping
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreatePrivateObjectSecurityEx LIB "ADVAPI32.DLL" ALIAS "CreatePrivateObjectSecurityEx" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in_opt    PSECURITY_DESCRIPTOR ParentDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __in_opt    PSECURITY_DESCRIPTOR CreatorDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __deref_out PSECURITY_DESCRIPTOR * NewDescriptor
 , BYREF GUID _                        ' __in_opt    GUID *ObjectType
 , BYVAL LONG _                        ' __in        BOOL IsContainerObject
 , BYVAL DWORD _                       ' __in        ULONG AutoInheritFlags
 , BYVAL DWORD _                       ' __in_opt    HANDLE Token
 , BYREF GENERIC_MAPPING _             ' __in        PGENERIC_MAPPING GenericMapping
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreatePrivateObjectSecurityWithMultipleInheritance LIB "ADVAPI32.DLL" ALIAS "CreatePrivateObjectSecurityWithMultipleInheritance" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in_opt    PSECURITY_DESCRIPTOR ParentDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __in_opt    PSECURITY_DESCRIPTOR CreatorDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __deref_out PSECURITY_DESCRIPTOR * NewDescriptor
 , BYREF GUID _                        ' __in_ecount_opt(GuidCount) GUID **ObjectTypes
 , BYVAL DWORD _                       ' __in        ULONG GuidCount
 , BYVAL LONG _                        ' __in        BOOL IsContainerObject
 , BYVAL DWORD _                       ' __in        ULONG AutoInheritFlags
 , BYVAL DWORD _                       ' __in_opt    HANDLE Token
 , BYREF GENERIC_MAPPING _             ' __in        PGENERIC_MAPPING GenericMapping
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >=  0x0500 */

DECLARE FUNCTION SetPrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "SetPrivateObjectSecurity" ( _
   BYVAL DWORD _                       ' SECURITY_INFORMATION SecurityInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __in          PSECURITY_DESCRIPTOR ModificationDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __deref_inout PSECURITY_DESCRIPTOR *ObjectsSecurityDescriptor
 , BYREF GENERIC_MAPPING _             ' __in          PGENERIC_MAPPING GenericMapping
 , BYVAL DWORD _                       ' __in_opt      HANDLE Token
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)
DECLARE FUNCTION SetPrivateObjectSecurityEx LIB "ADVAPI32.DLL" ALIAS "SetPrivateObjectSecurityEx" ( _
   BYVAL DWORD _                       ' __in          SECURITY_INFORMATION SecurityInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __in          PSECURITY_DESCRIPTOR ModificationDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __deref_inout PSECURITY_DESCRIPTOR *ObjectsSecurityDescriptor
 , BYVAL DWORD _                       ' __in          ULONG AutoInheritFlags
 , BYREF GENERIC_MAPPING _             ' __in          PGENERIC_MAPPING GenericMapping
 , BYVAL DWORD _                       ' __in_opt      HANDLE Token
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >=  0x0500 */

DECLARE FUNCTION GetPrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "GetPrivateObjectSecurity" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in  PSECURITY_DESCRIPTOR ObjectDescriptor
 , BYVAL LONG _                        ' __in  SECURITY_INFORMATION SecurityInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __out_bcount_part_opt(DescriptorLength, *ReturnLength) PSECURITY_DESCRIPTOR ResultantDescriptor
 , BYVAL DWORD _                       ' __in  DWORD DescriptorLength
 , BYREF DWORD _                       ' __out PDWORD ReturnLengt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DestroyPrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "DestroyPrivateObjectSecurity" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __deref PSECURITY_DESCRIPTOR * ObjectDescriptor
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MakeSelfRelativeSD LIB "ADVAPI32.DLL" ALIAS "MakeSelfRelativeSD" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in    PSECURITY_DESCRIPTOR pAbsoluteSecurityDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __out_bcount_part_opt(*lpdwBufferLength, *lpdwBufferLength) PSECURITY_DESCRIPTOR pSelfRelativeSecurityDescriptor
 , BYREF DWORD _                       ' __inout LPDWORD lpdwBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MakeAbsoluteSD LIB "ADVAPI32.DLL" ALIAS "MakeAbsoluteSD" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __in    PSECURITY_DESCRIPTOR pSelfRelativeSecurityDescriptor
 , BYREF SECURITY_DESCRIPTOR _         ' __out_bcount_part_opt(*lpdwAbsoluteSecurityDescriptorSize, *lpdwAbsoluteSecurityDescriptorSize) PSECURITY_DESCRIPTOR pAbsoluteSecurityDescriptor
 , BYREF DWORD _                       ' __inout LPDWORD lpdwAbsoluteSecurityDescriptorSize
 , BYREF ANY _                         ' __out_bcount_part_opt(*lpdwDaclSize, *lpdwDaclSize) PACL pDacl
 , BYREF DWORD _                       ' __inout LPDWORD lpdwDaclSize
 , BYREF ANY _                         ' __out_bcount_part_opt(*lpdwSaclSize, *lpdwSaclSize) PACL pSacl
 , BYREF DWORD _                       ' __inout LPDWORD lpdwSaclSize
 , BYREF ANY _                         ' __out_bcount_part_opt(*lpdwOwnerSize, *lpdwOwnerSize) PSID pOwner
 , BYREF DWORD _                       ' __inout LPDWORD lpdwOwnerSize
 , BYREF ANY _                         ' __out_bcount_part_opt(*lpdwPrimaryGroupSize, *lpdwPrimaryGroupSize) PSID pPrimaryGroup
 , BYREF DWORD _                       ' __inout LPDWORD lpdwPrimaryGroupSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MakeAbsoluteSD2 LIB "ADVAPI32.DLL" ALIAS "MakeAbsoluteSD2" ( _
   BYREF SECURITY_DESCRIPTOR _         ' __inout_bcount_part(*lpdwBufferSize, *lpdwBufferSize) PSECURITY_DESCRIPTOR pSelfRelativeSecurityDescriptor,
 , BYREF DWORD _                       ' __inout LPDWORD lpdwBufferSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION QuerySecurityAccessMask LIB "ADVAPI32.DLL" ALIAS "QuerySecurityAccessMask" ( _
   BYVAL DWORD _                       ' __in SECURITY_INFORMATION SecurityInformation
 , BYREF DWORD _                       ' __inout LPDWORD DesiredAccess
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFileSecurity LIB "ADVAPI32.DLL" ALIAS "SetFileSecurityA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in SECURITY_INFORMATION SecurityInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __in PSECURITY_DESCRIPTOR pSecurityDescriptor
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetFileSecurityW LIB "ADVAPI32.DLL" ALIAS "SetFileSecurityW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in SECURITY_INFORMATION SecurityInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __in PSECURITY_DESCRIPTOR pSecurityDescriptor
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileSecurity LIB "ADVAPI32.DLL" ALIAS "GetFileSecurityA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpFileName
 , BYVAL DWORD _                       ' __in  SECURITY_INFORMATION RequestedInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __out_bcount_part_opt(nLength, *lpnLengthNeeded) PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL DWORD _                       ' __in  DWORD nLength
 , BYREF DWORD _                       ' __out LPDWORD lpnLengthNeeded
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileSecurityW LIB "ADVAPI32.DLL" ALIAS "GetFileSecurityW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpFileName
 , BYVAL DWORD _                       ' __in  SECURITY_INFORMATION RequestedInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __out_bcount_part_opt(nLength, *lpnLengthNeeded) PSECURITY_DESCRIPTOR pSecurityDescriptor
 , BYVAL DWORD _                       ' __in  DWORD nLength
 , BYREF DWORD _                       ' __out LPDWORD lpnLengthNeeded
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetKernelObjectSecurity LIB "ADVAPI32.DLL" ALIAS "SetKernelObjectSecurity" ( _
   BYVAL DWORD _                       ' __in HANDLE Handle
 , BYVAL DWORD _                       ' __in SECURITY_INFORMATION SecurityInformation
 , BYREF SECURITY_DESCRIPTOR _         ' __in PSECURITY_DESCRIPTOR SecurityDescriptor
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindFirstChangeNotification LIB "KERNEL32.DLL" ALIAS "FindFirstChangeNotificationA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpPathName
 , BYVAL LONG _                        ' __in BOOL bWatchSubtree
 , BYVAL DWORD _                       ' __in DWORD dwNotifyFilter
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindFirstChangeNotificationW LIB "KERNEL32.DLL" ALIAS "FindFirstChangeNotificationW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpPathName
 , BYVAL LONG _                        ' __in BOOL bWatchSubtree
 , BYVAL DWORD _                       ' __in DWORD dwNotifyFilter
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindNextChangeNotification LIB "KERNEL32.DLL" ALIAS "FindNextChangeNotification" ( _
   BYVAL DWORD _                       ' __in HANDLE hChangeHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindCloseChangeNotification LIB "KERNEL32.DLL" ALIAS "FindCloseChangeNotification" ( _
   BYVAL DWORD _                       ' __in HANDLE hChangeHandle
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0400)
DECLARE FUNCTION ReadDirectoryChangesW LIB "KERNEL32.DLL" ALIAS "ReadDirectoryChangesW" ( _
   BYVAL DWORD _                       ' __in     HANDLE hDirectory
 , BYREF ANY _                         ' __out_bcount_part(nBufferLength, *lpBytesReturned) LPVOID lpBuffer,
 , BYVAL DWORD _                       ' __in     DWORD nBufferLength
 , BYVAL LONG _                        ' __in     BOOL bWatchSubtree
 , BYVAL DWORD _                       ' __in     DWORD dwNotifyFilter
 , BYREF DWORD _                       ' __out    LPDWORD lpBytesReturned
 , BYREF OVERLAPPED _                  ' __inout  LPOVERLAPPED lpOverlapped
 , BYVAL DWORD _                       ' __in_opt LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >= 0x0400 */

DECLARE FUNCTION VirtualLock LIB "KERNEL32.DLL" ALIAS "VirtualLock" ( _
   BYVAL DWORD _                       ' __in LPVOID lpAddress
 , BYVAL DWORD _                       ' __in SIZE_T dwSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION VirtualUnlock LIB "KERNEL32.DLL" ALIAS "VirtualUnlock" ( _
   BYVAL DWORD _                       ' __in LPVOID lpAddress
 , BYVAL DWORD _                       ' __in SIZE_T dwSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MapViewOfFileEx LIB "KERNEL32.DLL" ALIAS "MapViewOfFileEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFileMappingObject
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 , BYVAL DWORD _                       ' __in     DWORD dwFileOffsetHigh
 , BYVAL DWORD _                       ' __in     DWORD dwFileOffsetLow
 , BYVAL DWORD _                       ' __in     SIZE_T dwNumberOfBytesToMap
 , BYVAL DWORD _                       ' __in_opt LPVOID lpBaseAddress
 ) AS DWORD                            ' LPVOID

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION MapViewOfFileExNuma LIB "KERNEL32.DLL" ALIAS "MapViewOfFileExNuma" ( _
   BYVAL DWORD _                       ' __in     HANDLE hFileMappingObject
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 , BYVAL DWORD _                       ' __in     DWORD dwFileOffsetHigh
 , BYVAL DWORD _                       ' __in     DWORD dwFileOffsetLow
 , BYVAL DWORD _                       ' __in     SIZE_T dwNumberOfBytesToMap
 , BYVAL DWORD _                       ' __in_opt LPVOID lpBaseAddress
 , BYVAL DWORD _                       ' __in     DWORD nndPreferred
 ) AS DWORD                            ' LPVOID

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION SetPriorityClass LIB "KERNEL32.DLL" ALIAS "SetPriorityClass" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in DWORD dwPriorityClass
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetPriorityClass LIB "KERNEL32.DLL" ALIAS "GetPriorityClass" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION IsBadReadPtr LIB "KERNEL32.DLL" ALIAS "IsBadReadPtr" ( _
   BYVAL DWORD _                       ' __in_opt CONST VOID *lp
 , BYVAL DWORD _                       ' __in     UINT_PTR ucb
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsBadWritePtr LIB "KERNEL32.DLL" ALIAS "IsBadWritePtr" ( _
   BYVAL DWORD _                       ' __in_opt LPVOID lp
 , BYVAL DWORD _                       ' __in     UINT_PTR ucb
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsBadHugeReadPtr LIB "KERNEL32.DLL" ALIAS "IsBadHugeReadPtr" ( _
   BYVAL DWORD _                       ' __in_opt CONST VOID *lp
 , BYVAL DWORD _                       ' __in     UINT_PTR ucb
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsBadHugeWritePtr LIB "KERNEL32.DLL" ALIAS "IsBadHugeWritePtr" ( _
   BYVAL DWORD _                       ' __in_opt LPVOID lp
 , BYVAL DWORD _                       ' __in     UINT_PTR ucb
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsBadCodePtr LIB "KERNEL32.DLL" ALIAS "IsBadCodePtr" ( _
   BYVAL DWORD _                       ' __in_opt FARPROC lpfn
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsBadStringPtr LIB "KERNEL32.DLL" ALIAS "IsBadStringPtrA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpsz
 , BYVAL DWORD _                       ' __in     UINT_PTR ucchMax
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsBadStringPtrW LIB "KERNEL32.DLL" ALIAS "IsBadStringPtrW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpsz
 , BYVAL DWORD _                       ' __in     UINT_PTR ucchMax
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupAccountSid LIB "ADVAPI32.DLL" ALIAS "LookupAccountSidA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpSystemName
 , BYVAL SID PTR _                     ' __in PSID Sid
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(*cchName, *cchName + 1) LPSTR Name
 , BYREF DWORD _                       ' __inout  LPDWORD cchName
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(*cchReferencedDomainName, *cchReferencedDomainName + 1) LPSTR ReferencedDomainName,
 , BYREF DWORD _                       ' __inout LPDWORD cchReferencedDomainName
 , BYREF LONG _                        ' __out PSID_NAME_USE peUse
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupAccountSidW LIB "ADVAPI32.DLL" ALIAS "LookupAccountSidW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpSystemName
 , BYVAL SID PTR _                     ' __in PSID Sid
 , BYVAL DWORD _                       ' __out_ecount_part_opt(*cchName, *cchName + 1) LPWSTR Name
 , BYREF DWORD _                       ' __inout  LPDWORD cchName
 , BYVAL DWORD _                       ' __out_ecount_part_opt(*cchReferencedDomainName, *cchReferencedDomainName + 1) LPWSTR ReferencedDomainName,
 , BYREF DWORD _                       ' __inout LPDWORD cchReferencedDomainName
 , BYREF LONG _                        ' __out PSID_NAME_USE peUse
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupAccountName LIB "ADVAPI32.DLL" ALIAS "LookupAccountNameA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpSystemName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpAccountName
 , BYREF ANY _                         ' __out_bcount_part_opt(*cbSid, *cbSid) PSID Sid
 , BYREF DWORD _                       ' __inout  LPDWORD cbSid
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(*cchReferencedDomainName, *cchReferencedDomainName + 1) LPSTR ReferencedDomainName,
 , BYREF DWORD _                       ' __inout  LPDWORD cchReferencedDomainName
 , BYREF LONG _                        ' __out    PSID_NAME_USE peUse
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupAccountNameW LIB "ADVAPI32.DLL" ALIAS "LookupAccountNameW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpSystemName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpAccountName
 , BYREF ANY _                         ' __out_bcount_part_opt(*cbSid, *cbSid) PSID Sid
 , BYREF DWORD _                       ' __inout  LPDWORD cbSid
 , BYVAL DWORD _                       ' __out_ecount_part_opt(*cchReferencedDomainName, *cchReferencedDomainName + 1) LPWSTR ReferencedDomainName
 , BYREF DWORD _                       ' __inout  LPDWORD cchReferencedDomainName
 , BYREF LONG _                        ' __out    PSID_NAME_USE peUse
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupPrivilegeValue LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeValueA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpSystemName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpName
 , BYREF LUID _                        ' __out    PLUID   lpLuid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupPrivilegeValueW LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeValueW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpSystemName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpName
 , BYREF LUID _                        ' __out    PLUID   lpLuid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupPrivilegeName LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeNameA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpSystemName
 , BYREF LUID _                        ' __in     PLUID   lpLuid
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(*cchName, *cchName + 1) LPSTR lpName
 , BYREF DWORD _                       ' __inout  LPDWORD cchName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupPrivilegeNameW LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeNameW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpSystemName
 , BYREF LUID _                        ' __in     PLUID   lpLuid
 , BYVAL DWORD _                       ' __out_ecount_part_opt(*cchName, *cchName + 1) LPWSTR lpName
 , BYREF DWORD _                       ' __inout  LPDWORD cchName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupPrivilegeDisplayName LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeDisplayNameA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpSystemName
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpName
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(*cchDisplayName, *cchDisplayName + 1) LPSTR lpDisplayName
 , BYREF DWORD _                       ' __inout  LPDWORD cchDisplayName
 , BYREF DWORD _                       ' __out    LPDWORD lpLanguageId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupPrivilegeDisplayNameW LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeDisplayNameW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpSystemName
 , BYVAL DWORD _                       ' __in     LPCWSTR lpName
 , BYVAL DWORD _                       ' __out_ecount_part_opt(*cchDisplayName, *cchDisplayName + 1) LPWSTR lpDisplayName
 , BYREF DWORD _                       ' __inout  LPDWORD cchDisplayName
 , BYREF DWORD _                       ' __out    LPDWORD lpLanguageId
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AllocateLocallyUniqueId LIB "ADVAPI32.DLL" ALIAS "AllocateLocallyUniqueId" ( _
   BYREF LUID _                        ' __out PLUID Luid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BuildCommDCB LIB "KERNEL32.DLL" ALIAS "BuildCommDCBA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpDef
 , BYREF DCB _                         ' __out LPDCB lpDCB
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BuildCommDCBW LIB "KERNEL32.DLL" ALIAS "BuildCommDCBW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpDef
 , BYREF DCB _                         ' __out LPDCB lpDCB
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BuildCommDCBAndTimeouts LIB "KERNEL32.DLL" ALIAS "BuildCommDCBAndTimeoutsA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpDef
 , BYREF DCB _                         ' __out LPDCB lpDCB
 , BYREF COMMTIMEOUTS _                ' __out LPCOMMTIMEOUTS lpCommTimeouts
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BuildCommDCBAndTimeoutsW LIB "KERNEL32.DLL" ALIAS "BuildCommDCBAndTimeoutsW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpDef
 , BYREF DCB _                         ' __out LPDCB lpDCB
 , BYREF COMMTIMEOUTS _                ' __out LPCOMMTIMEOUTS lpCommTimeouts
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CommConfigDialog LIB "KERNEL32.DLL" ALIAS "CommConfigDialogA" ( _
   BYREF ASCIIZ _                      ' __in     LPCSTR lpszName
 , BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYREF COMMCONFIG _                  ' __inout  LPCOMMCONFIG lpCC
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CommConfigDialogW LIB "KERNEL32.DLL" ALIAS "CommConfigDialogW" ( _
   BYVAL DWORD _                       ' __in     LPCWSTR lpszName
 , BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYREF COMMCONFIG _                  ' __inout  LPCOMMCONFIG lpCC
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDefaultCommConfig LIB "KERNEL32.DLL" ALIAS "GetDefaultCommConfigA" ( _
   BYREF ASCIIZ _                      ' __in    LPCSTR lpszName
 , BYREF COMMCONFIG _                  ' __out_bcount_part(*lpdwSize, *lpdwSize) LPCOMMCONFIG lpCC
 , BYREF DWORD _                       ' __inout LPDWORD lpdwSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDefaultCommConfigW LIB "KERNEL32.DLL" ALIAS "GetDefaultCommConfigW" ( _
   BYVAL DWORD _                       ' __in    LPCWSTR lpszName
 , BYREF COMMCONFIG _                  ' __out_bcount_part(*lpdwSize, *lpdwSize) LPCOMMCONFIG lpCC
 , BYREF DWORD _                       ' __inout LPDWORD lpdwSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetDefaultCommConfig LIB "KERNEL32.DLL" ALIAS "SetDefaultCommConfigA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszName
 , BYREF COMMCONFIG _                  ' __in_bcount(dwSize) LPCOMMCONFIG lpCC
 , BYVAL DWORD _                       ' __in DWORD dwSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetDefaultCommConfigW LIB "KERNEL32.DLL" ALIAS "SetDefaultCommConfigW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszName
 , BYREF COMMCONFIG _                  ' __in_bcount(dwSize) LPCOMMCONFIG lpCC
 , BYVAL DWORD _                       ' __in DWORD dwSize
 ) AS LONG                             ' BOOL

%MAX_COMPUTERNAME_LENGTH = 15

DECLARE FUNCTION GetComputerName LIB "KERNEL32.DLL" ALIAS "GetComputerNameA" ( _
   BYREF ASCIIZ _                      ' __out_ecount_part(*nSize, *nSize + 1) LPSTR lpBuffer
 , BYREF DWORD _                       ' __inout LPDWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetComputerNameW LIB "KERNEL32.DLL" ALIAS "GetComputerNameW" ( _
   BYVAL DWORD _                       ' __out_ecount_part(*nSize, *nSize + 1) LPWSTR lpBuffer
 , BYREF DWORD _                       ' __inout LPDWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetComputerName LIB "KERNEL32.DLL" ALIAS "SetComputerNameA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpComputerName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetComputerNameW LIB "KERNEL32.DLL" ALIAS "SetComputerNameW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpComputerName
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0500)

' COMPUTER_NAME_FORMAT enum
%ComputerNameNetBIOS                   = 0
%ComputerNameDnsHostname               = 1
%ComputerNameDnsDomain                 = 2
%ComputerNameDnsFullyQualified         = 3
%ComputerNamePhysicalNetBIOS           = 4
%ComputerNamePhysicalDnsHostname       = 5
%ComputerNamePhysicalDnsDomain         = 6
%ComputerNamePhysicalDnsFullyQualified = 7
%ComputerNameMax                       = 8

DECLARE FUNCTION GetComputerNameEx LIB "KERNEL32.DLL" ALIAS "GetComputerNameExA" ( _
   BYVAL LONG _                        ' __in    COMPUTER_NAME_FORMAT NameType
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(*nSize, *nSize + 1) LPSTR lpBuffer
 , BYREF DWORD _                       ' __inout LPDWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetComputerNameExW LIB "KERNEL32.DLL" ALIAS "GetComputerNameExW" ( _
   BYVAL LONG _                        ' __in    COMPUTER_NAME_FORMAT NameType
 , BYVAL DWORD _                       ' __out_ecount_part_opt(*nSize, *nSize + 1) LPWSTR lpBuffer
 , BYREF DWORD _                       ' __inout LPDWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetComputerNameEx LIB "KERNEL32.DLL" ALIAS "SetComputerNameExA" ( _
   BYVAL LONG _                        ' __in COMPUTER_NAME_FORMAT NameType
 , BYREF ASCIIZ _                      ' __in LPCSTR lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetComputerNameExW LIB "KERNEL32.DLL" ALIAS "SetComputerNameExW" ( _
   BYVAL LONG _                        ' __in COMPUTER_NAME_FORMAT NameType
 , BYVAL DWORD _                       ' __in LPCWSTR lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DnsHostnameToComputerName LIB "KERNEL32.DLL" ALIAS "DnsHostnameToComputerNameA" ( _
   BYREF ASCIIZ _                      ' __in    LPCSTR Hostname
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(*nSize, *nSize + 1) LPSTR ComputerName
 , BYREF DWORD _                       ' __inout LPDWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DnsHostnameToComputerNameW LIB "KERNEL32.DLL" ALIAS "DnsHostnameToComputerNameW" ( _
   BYVAL DWORD _                       ' __in    LPCWSTR Hostname
 , BYVAL DWORD _                       ' __out_ecount_part_opt(*nSize, *nSize + 1) LPWSTR ComputerName
 , BYREF DWORD _                       ' __inout LPDWORD nSize
 ) AS LONG                             ' BOOL

'#endif // _WIN32_WINNT

DECLARE FUNCTION GetUserName LIB "ADVAPI32.DLL" ALIAS "GetUserNameA" ( _
   BYREF ASCIIZ _                      ' __out_ecount_part(*pcbBuffer, *pcbBuffer) LPSTR lpBuffer,
 , BYREF DWORD _                       ' __inout LPDWORD pcbBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetUserNameW LIB "ADVAPI32.DLL" ALIAS "GetUserNameW" ( _
   BYVAL DWORD _                       ' __out_ecount_part(*pcbBuffer, *pcbBuffer) LPWSTR lpBuffer
 , BYREF DWORD _                       ' __inout LPDWORD pcbBuffer
 ) AS LONG                             ' BOOL

'//
'// Logon Support APIs
'//

%LOGON32_LOGON_INTERACTIVE       = 2
%LOGON32_LOGON_NETWORK           = 3
%LOGON32_LOGON_BATCH             = 4
%LOGON32_LOGON_SERVICE           = 5
%LOGON32_LOGON_UNLOCK            = 7
'#if(_WIN32_WINNT >= 0x0500)
%LOGON32_LOGON_NETWORK_CLEARTEXT = 8
%LOGON32_LOGON_NEW_CREDENTIALS   = 9
'#endif // (_WIN32_WINNT >= 0x0500)

'#define LOGON32_PROVIDER_DEFAULT    0
'#define LOGON32_PROVIDER_WINNT35    1
'#if(_WIN32_WINNT >= 0x0400)
'#define LOGON32_PROVIDER_WINNT40    2
'#endif /* _WIN32_WINNT >= 0x0400 */
'#if(_WIN32_WINNT >= 0x0500)
'#define LOGON32_PROVIDER_WINNT50    3
'#endif // (_WIN32_WINNT >= 0x0500)

%LOGON32_PROVIDER_DEFAULT  = 0
%LOGON32_PROVIDER_WINNT35  = 1
%LOGON32_PROVIDER_WINNT40  = 2
%LOGON32_PROVIDER_WINNT50  = 3


DECLARE FUNCTION LogonUser LIB "ADVAPI32.DLL" ALIAS "LogonUserA" ( _
   BYREF ASCIIZ _                      ' __in        LPCSTR lpszUsername
 , BYREF ASCIIZ _                      ' __in_opt    LPCSTR lpszDomain
 , BYREF ASCIIZ _                      ' __in        LPCSTR lpszPassword
 , BYVAL DWORD _                       ' __in        DWORD dwLogonType
 , BYVAL DWORD _                       ' __in        DWORD dwLogonProvider
 , BYREF DWORD _                       ' __deref_out PHANDLE phToken
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LogonUserW LIB "ADVAPI32.DLL" ALIAS "LogonUserW" ( _
   BYVAL DWORD _                       ' __in        LPCWSTR lpszUsername
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpszDomain
 , BYVAL DWORD _                       ' __in        LPCWSTR lpszPassword
 , BYVAL DWORD _                       ' __in        DWORD dwLogonType
 , BYVAL DWORD _                       ' __in        DWORD dwLogonProvider
 , BYREF DWORD _                       ' __deref_out PHANDLE phToken
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LogonUserEx LIB "ADVAPI32.DLL" ALIAS "LogonUserExA" ( _
   BYREF ASCIIZ _                      ' __in            LPCSTR lpszUsername
 , BYREF ASCIIZ _                      ' __in_opt        LPCSTR lpszDomain
 , BYREF ASCIIZ _                      ' __in            LPCSTR lpszPassword
 , BYVAL DWORD _                       ' __in            DWORD dwLogonType
 , BYVAL DWORD _                       ' __in            DWORD dwLogonProvider
 , BYREF DWORD _                       ' __deref_opt_out PHANDLE phToken
 , BYREF ANY _                         ' __deref_opt_out PSID  *ppLogonSid
 , BYREF ANY _                         ' __deref_opt_out_bcount_full(*pdwProfileLength) PVOID *ppProfileBuffer
 , BYREF DWORD _                       ' __out_opt       LPDWORD pdwProfileLength
 , BYREF QUOTA_LIMITS _                ' __out_opt       PQUOTA_LIMITS pQuotaLimits
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LogonUserExW LIB "ADVAPI32.DLL" ALIAS "LogonUserExW" ( _
   BYVAL DWORD _                       ' __in            LPCWSTR lpszUsername
 , BYVAL DWORD _                       ' __in_opt        LPCWSTR lpszDomain
 , BYVAL DWORD _                       ' __in            LPCWSTR lpszPassword
 , BYVAL DWORD _                       ' __in            DWORD dwLogonType
 , BYVAL DWORD _                       ' __in            DWORD dwLogonProvider
 , BYREF DWORD _                       ' __deref_opt_out PHANDLE phToken
 , BYREF ANY _                         ' __deref_opt_out PSID  *ppLogonSid
 , BYREF ANY _                         ' __deref_opt_out_bcount_full(*pdwProfileLength) PVOID *ppProfileBuffer,
 , BYREF DWORD _                       ' __out_opt       LPDWORD pdwProfileLength
 , BYREF QUOTA_LIMITS _                ' __out_opt       PQUOTA_LIMITS pQuotaLimits
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ImpersonateLoggedOnUser LIB "ADVAPI32.DLL" ALIAS "ImpersonateLoggedOnUser" ( _
   BYVAL DWORD _                       ' __in HANDLE  hToken
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateProcessAsUser LIB "ADVAPI32.DLL" ALIAS "CreateProcessAsUserA" ( _
   BYVAL DWORD _                       ' __in_opt    HANDLE hToken
 , BYREF ASCIIZ _                      ' __in_opt    LPCSTR lpApplicationName
 , BYREF ASCIIZ _                      ' __inout_opt LPSTR lpCommandLine
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpProcessAttributes
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpThreadAttributes
 , BYVAL LONG _                        ' __in        BOOL bInheritHandles
 , BYVAL DWORD _                       ' __in        DWORD dwCreationFlags
 , BYVAL DWORD _                       ' __in_opt    LPVOID lpEnvironment
 , BYREF ASCIIZ _                      ' __in_opt    LPCSTR lpCurrentDirectory
 , BYREF STARTUPINFOA _                ' __in        LPSTARTUPINFOA lpStartupInfo
 , BYREF PROCESS_INFORMATION _         ' __out       LPPROCESS_INFORMATION lpProcessInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateProcessAsUserW LIB "ADVAPI32.DLL" ALIAS "CreateProcessAsUserW" ( _
   BYVAL DWORD _                       ' __in_opt    HANDLE hToken
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpApplicationName
 , BYVAL DWORD _                       ' __inout_opt LPWSTR lpCommandLine
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpProcessAttributes
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpThreadAttributes
 , BYVAL LONG _                        ' __in        BOOL bInheritHandles
 , BYVAL DWORD _                       ' __in        DWORD dwCreationFlags
 , BYVAL DWORD _                       ' __in_opt    LPVOID lpEnvironment
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpCurrentDirectory
 , BYREF STARTUPINFOW _                ' __in        LPSTARTUPINFOW lpStartupInfo
 , BYREF PROCESS_INFORMATION _         ' __out       LPPROCESS_INFORMATION lpProcessInformation
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)

'//
'// LogonFlags
'//
%LOGON_WITH_PROFILE         = &H00000001???
%LOGON_NETCREDENTIALS_ONLY  = &H00000002???
%LOGON_ZERO_PASSWORD_BUFFER = &H80000000???

DECLARE FUNCTION CreateProcessWithLogonW LIB "ADVAPI32.DLL" ALIAS "CreateProcessWithLogonW" ( _
   BYVAL DWORD _                       ' __in        LPCWSTR lpUsername
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpDomain
 , BYVAL DWORD _                       ' __in        LPCWSTR lpPassword
 , BYVAL DWORD _                       ' __in        DWORD dwLogonFlags
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpApplicationName
 , BYVAL DWORD _                       ' __inout_opt LPWSTR lpCommandLine
 , BYVAL DWORD _                       ' __in        DWORD dwCreationFlags
 , BYVAL DWORD _                       ' __in_opt    LPVOID lpEnvironment
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpCurrentDirectory
 , BYREF STARTUPINFOW _                ' __in        LPSTARTUPINFOW lpStartupInfo
 , BYREF PROCESS_INFORMATION _         ' __out       LPPROCESS_INFORMATION lpProcessInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateProcessWithTokenW LIB "ADVAPI32.DLL" ALIAS "CreateProcessWithTokenW" ( _
   BYVAL DWORD _                       ' __in        HANDLE hToken
 , BYVAL DWORD _                       ' __in        DWORD dwLogonFlags
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpApplicationName
 , BYVAL DWORD _                       ' __inout_opt LPWSTR lpCommandLine
 , BYVAL DWORD _                       ' __in        DWORD dwCreationFlags
 , BYVAL DWORD _                       ' __in_opt    LPVOID lpEnvironment
 , BYVAL DWORD _                       ' __in_opt    LPCWSTR lpCurrentDirectory
 , BYREF STARTUPINFOW _                ' __in        LPSTARTUPINFOW lpStartupInfo
 , BYREF PROCESS_INFORMATION _         ' __out       LPPROCESS_INFORMATION lpProcessInformation
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION ImpersonateAnonymousToken LIB "ADVAPI32.DLL" ALIAS "ImpersonateAnonymousToken" ( _
   BYVAL DWORD _                       ' __in HANDLE ThreadHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DuplicateTokenEx LIB "ADVAPI32.DLL" ALIAS "DuplicateTokenEx" ( _
   BYVAL DWORD _                       ' __in        HANDLE hExistingToken
 , BYVAL DWORD _                       ' __in        DWORD dwDesiredAccess
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt    LPSECURITY_ATTRIBUTES lpTokenAttributes
 , BYVAL LONG _                        ' __in        SECURITY_IMPERSONATION_LEVEL ImpersonationLevel
 , BYVAL LONG _                        ' __in        TOKEN_TYPE TokenType
 , BYREF DWORD _                       ' __deref_out PHANDLE phNewToken
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateRestrictedToken LIB "ADVAPI32.DLL" ALIAS "CreateRestrictedTokenA" ( _
   BYVAL DWORD _                       ' __in        HANDLE ExistingTokenHandle
 , BYVAL DWORD _                       ' __in        DWORD Flags
 , BYVAL DWORD _                       ' __in        DWORD DisableSidCount
 , BYREF SID_AND_ATTRIBUTES _          ' __in_ecount_opt(DisableSidCount) PSID_AND_ATTRIBUTES SidsToDisable
 , BYVAL DWORD _                       ' __in        DWORD DeletePrivilegeCount
 , BYREF LUID_AND_ATTRIBUTES _         ' __in_ecount_opt(DeletePrivilegeCount) PLUID_AND_ATTRIBUTES PrivilegesToDelete
 , BYVAL DWORD _                       ' __in        DWORD RestrictedSidCount
 , BYREF SID_AND_ATTRIBUTES _          ' __in_ecount_opt(RestrictedSidCount) PSID_AND_ATTRIBUTES SidsToRestrict
 , BYREF DWORD _                       ' __deref_out PHANDLE NewTokenHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsTokenRestricted LIB "ADVAPI32.DLL" ALIAS "IsTokenRestricted" ( _
   BYVAL DWORD _                       ' __in HANDLE TokenHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsTokenUntrusted LIB "ADVAPI32.DLL" ALIAS "IsTokenUntrusted" ( _
   BYVAL DWORD _                       ' __in HANDLE TokenHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CheckTokenMembership LIB "ADVAPI32.DLL" ALIAS "CheckTokenMembership" ( _
   BYVAL DWORD _                       ' __in_opt HANDLE TokenHandle
 , BYVAL SID PTR _                     ' __in     PSID SidToCheck
 , BYREF LONG _                        ' __out    PBOOL IsMember
 ) AS LONG                             ' BOOL

'//
'// Thread pool API's
'//

'#if (_WIN32_WINNT >= 0x0500)

'typedef WAITORTIMERCALLBACKFUNC WAITORTIMERCALLBACK ;

DECLARE FUNCTION RegisterWaitForSingleObject LIB "KERNEL32.DLL" ALIAS "RegisterWaitForSingleObject" ( _
   BYREF DWORD _                       ' __deref_out PHANDLE phNewWaitObject
 , BYVAL DWORD _                       ' __in        HANDLE hObject
 , BYVAL DWORD _                       ' __in        WAITORTIMERCALLBACK Callback
 , BYVAL DWORD _                       ' __in_opt    PVOID Context
 , BYVAL DWORD  _                      ' __in        ULONG dwMilliseconds
 , BYVAL DWORD _                       ' __in        ULONG dwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RegisterWaitForSingleObjectEx LIB "KERNEL32.DLL" ALIAS "RegisterWaitForSingleObjectEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE hObject
 , BYVAL DWORD _                       ' __in     WAITORTIMERCALLBACK Callback
 , BYVAL DWORD _                       ' __in_opt PVOID Context
 , BYVAL DWORD _                       ' __in     ULONG dwMilliseconds
 , BYVAL DWORD _                       ' __in     ULONG dwFlags
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION UnregisterWait LIB "KERNEL32.DLL" ALIAS "UnregisterWait" ( _
   BYVAL DWORD _                       ' __in HANDLE WaitHandle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UnregisterWaitEx LIB "KERNEL32.DLL" ALIAS "UnregisterWaitEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE WaitHandle
 , BYVAL DWORD _                       ' __in_opt HANDLE CompletionEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION QueueUserWorkItem LIB "KERNEL32.DLL" ALIAS "QueueUserWorkItem" ( _
   BYVAL DWORD _                       ' __in     LPTHREAD_START_ROUTINE Function
 , BYVAL DWORD _                       ' __in_opt PVOID Context
 , BYVAL DWORD _                       ' __in     ULONG Flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BindIoCompletionCallback LIB "KERNEL32.DLL" ALIAS "BindIoCompletionCallback" ( _
   BYVAL DWORD _                       ' __in HANDLE FileHandle
 , BYVAL DWORD _                       ' __in LPOVERLAPPED_COMPLETION_ROUTINE Function
 , BYVAL DWORD _                       ' __in ULONG Flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateTimerQueue LIB "KERNEL32.DLL" ALIAS "CreateTimerQueue" ( _
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateTimerQueueTimer LIB "KERNEL32.DLL" ALIAS "CreateTimerQueueTimer" ( _
   BYREF DWORD _                       ' __deref_out PHANDLE phNewTimer
 , BYVAL DWORD _                       ' __in_opt    HANDLE TimerQueue
 , BYVAL DWORD _                       ' __in        WAITORTIMERCALLBACK Callback
 , BYVAL DWORD _                       ' __in_opt    PVOID Parameter
 , BYVAL DWORD _                       ' __in        DWORD DueTime
 , BYVAL DWORD _                       ' __in        DWORD Period
 , BYVAL DWORD _                       ' __in        ULONG Flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ChangeTimerQueueTimer LIB "KERNEL32.DLL" ALIAS "ChangeTimerQueueTimer" ( _
   BYVAL DWORD _                       ' __in_opt HANDLE TimerQueue
 , BYREF DWORD _                       ' __inout  HANDLE Timer
 , BYVAL DWORD _                       ' __in     ULONG DueTime
 , BYVAL DWORD _                       ' __in     ULONG Period
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteTimerQueueTimer LIB "KERNEL32.DLL" ALIAS "DeleteTimerQueueTimer" ( _
   BYVAL DWORD _                       ' __in_opt HANDLE TimerQueue
 , BYVAL DWORD _                       ' __in     HANDLE Timer
 , BYVAL DWORD _                       ' __in_opt HANDLE CompletionEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteTimerQueueEx LIB "KERNEL32.DLL" ALIAS "DeleteTimerQueueEx" ( _
   BYVAL DWORD _                       ' __in     HANDLE TimerQueue
 , BYVAL DWORD _                       ' __in_opt HANDLE CompletionEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetTimerQueueTimer LIB "KERNEL32.DLL" ALIAS "SetTimerQueueTimer" ( _
   BYVAL DWORD _                       ' __in_opt HANDLE TimerQueue
 , BYVAL DWORD _                       ' __in     WAITORTIMERCALLBACK Callback
 , BYVAL DWORD _                       ' __in_opt PVOID Parameter
 , BYVAL DWORD _                       ' __in     DWORD DueTime
 , BYVAL DWORD _                       ' __in     DWORD Period
 , BYVAL LONG _                        ' __in     BOOL PreferIo
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CancelTimerQueueTimer LIB "KERNEL32.DLL" ALIAS "CancelTimerQueueTimer" ( _
   BYVAL DWORD _                       ' __in_opt HANDLE TimerQueue
 , BYVAL DWORD _                       ' __in     HANDLE Timer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteTimerQueue LIB "KERNEL32.DLL" ALIAS "DeleteTimerQueue" ( _
   BYVAL DWORD _                       ' __in HANDLE TimerQueue
 ) AS LONG                             ' BOOL

'#endif // _WIN32_WINNT

'#if (_WIN32_WINNT >= 0x0600)

'typedef VOID (WINAPI *PTP_WIN32_IO_CALLBACK)(
'    __inout     PTP_CALLBACK_INSTANCE Instance,
'    __inout_opt PVOID                 Context,
'    __inout_opt PVOID                 Overlapped,
'    __in        ULONG                 IoResult,
'    __in        ULONG_PTR             NumberOfBytesTransferred,
'    __inout     PTP_IO                Io
'    );

DECLARE FUNCTION CreateThreadpool LIB "KERNEL32.DLL" ALIAS "CreateThreadpool" ( _
   BYVAL DWORD _                       ' __reserved PVOID reserved
 ) AS DWORD                            ' PTP_POOL

DECLARE SUB SetThreadpoolThreadMaximum LIB "KERNEL32.DLL" ALIAS "SetThreadpoolThreadMaximum" ( _
   BYREF DWORD _                       ' __inout PTP_POOL ptpp
 , BYVAL DWORD _                       ' __in    DWORD    cthrdMost
 )                                     ' VOID

DECLARE FUNCTION SetThreadpoolThreadMinimum LIB "KERNEL32.DLL" ALIAS "SetThreadpoolThreadMinimum" ( _
   BYREF DWORD _                       ' __inout PTP_POOL ptpp
 , BYVAL DWORD _                       ' __in    DWORD    cthrdMic
 ) AS LONG                             ' BOOL

DECLARE SUB CloseThreadpool LIB "KERNEL32.DLL" ALIAS "CloseThreadpool" ( _
   BYREF DWORD _                       ' __inout PTP_POOL ptpp
 )                                     ' VOID

DECLARE FUNCTION CreateThreadpoolCleanupGroup LIB "KERNEL32.DLL" ALIAS "CreateThreadpoolCleanupGroup" ( _
 ) AS DWORD                            ' PTP_CLEANUP_GROUP

DECLARE SUB CloseThreadpoolCleanupGroup LIB "KERNEL32.DLL" ALIAS "CloseThreadpoolCleanupGroup" ( _
   BYREF DWORD _                       ' __inout PTP_CLEANUP_GROUP ptpcg
 )                                     ' VOID

'FORCEINLINE
'VOID
'InitializeThreadpoolEnvironment(
'    __out PTP_CALLBACK_ENVIRON pcbe
'    )
'{
'    TpInitializeCallbackEnviron(pcbe);
'}

MACRO InitializeThreadpoolEnvironment (pcbe)
   TpInitializeCallbackEnviron(pcbe)
END MACRO

'FORCEINLINE
'VOID
'SetThreadpoolCallbackPool(
'    __inout PTP_CALLBACK_ENVIRON pcbe,
'    __in    PTP_POOL             ptpp
'    )
'{
'    TpSetCallbackThreadpool(pcbe, ptpp);
'}

MACRO SetThreadpoolCallbackPool (pcbe, ptpp)
   TpSetCallbackThreadpool(pcbe, ptpp)
END MACRO

'FORCEINLINE
'VOID
'SetThreadpoolCallbackCleanupGroup(
'    __inout  PTP_CALLBACK_ENVIRON              pcbe,
'    __in     PTP_CLEANUP_GROUP                 ptpcg,
'    __in_opt PTP_CLEANUP_GROUP_CANCEL_CALLBACK pfng
'    )
'{
'    TpSetCallbackCleanupGroup(pcbe, ptpcg, pfng);
'}

MACRO SetThreadpoolCallbackCleanupGroup (pcbe, ptpcg, pfng)
   TpSetCallbackCleanupGroup(pcbe, ptpcg, pfng)
END MACRO

'FORCEINLINE
'VOID
'SetThreadpoolCallbackRunsLong(
'    __inout PTP_CALLBACK_ENVIRON pcbe
'    )
'{
'    TpSetCallbackLongFunction(pcbe);
'}

MACRO SetThreadpoolCallbackRunsLong (pcbe)
   TpSetCallbackLongFunction(pcbe)
END MACRO

'FORCEINLINE
'VOID
'SetThreadpoolCallbackLibrary(
'    __inout PTP_CALLBACK_ENVIRON pcbe,
'    __in    PVOID                mod
'    )
'{
'    TpSetCallbackRaceWithDll(pcbe, mod);
'}

MACRO SetThreadpoolCallbackLibrary (pcbe, xmod)
   TpSetCallbackRaceWithDll(pcbe, xmod)
END MACRO

'FORCEINLINE
'VOID
'DestroyThreadpoolEnvironment(
'    __inout PTP_CALLBACK_ENVIRON pcbe
'    )
'{
'    TpDestroyCallbackEnviron(pcbe);
'}

MACRO DestroyThreadpoolEnvironment (pcbe)
   TpDestroyCallbackEnviron(pcbe)
END MACRO

DECLARE SUB SetEventWhenCallbackReturns LIB "KERNEL32.DLL" ALIAS "SetEventWhenCallbackReturns" ( _
   BYREF DWORD _                       ' __inout PTP_CALLBACK_INSTANCE pci
 , BYVAL DWORD _                       ' __in    HANDLE                evt
 )                                     ' VOID

DECLARE SUB ReleaseSemaphoreWhenCallbackReturns LIB "KERNEL32.DLL" ALIAS "ReleaseSemaphoreWhenCallbackReturns" ( _
   BYREF DWORD _                       ' __inout PTP_CALLBACK_INSTANCE pci
 , BYVAL DWORD _                       ' __in    HANDLE                sem
 , BYVAL DWORD _                       ' __in    DWORD                 crel
 )                                     ' VOID

DECLARE SUB ReleaseMutexWhenCallbackReturns LIB "KERNEL32.DLL" ALIAS "ReleaseMutexWhenCallbackReturns" ( _
   BYREF DWORD _                       ' __inout PTP_CALLBACK_INSTANCE pci
 , BYVAL DWORD _                       ' __in    HANDLE                mut
 )                                     ' VOID

DECLARE SUB LeaveCriticalSectionWhenCallbackReturns LIB "KERNEL32.DLL" ALIAS "LeaveCriticalSectionWhenCallbackReturns" ( _
   BYREF DWORD _                       ' __inout PTP_CALLBACK_INSTANCE pci
 , BYREF CRITICAL_SECTION _            ' __inout PCRITICAL_SECTION     pcs
 )                                     ' VOID

DECLARE SUB FreeLibraryWhenCallbackReturns LIB "KERNEL32.DLL" ALIAS "FreeLibraryWhenCallbackReturns" ( _
   BYREF DWORD _                       ' __inout PTP_CALLBACK_INSTANCE pci
 , BYVAL DWORD _                       ' __in    HMODULE               mod
 )                                     ' VOID

DECLARE SUB CallbackMayRunLong LIB "KERNEL32.DLL" ALIAS "CallbackMayRunLong" ( _
   BYREF DWORD _                       ' __inout PTP_CALLBACK_INSTANCE pci
 )                                     ' VOID

DECLARE SUB DisassociateCurrentThreadFromCallback LIB "KERNEL32.DLL" ALIAS "DisassociateCurrentThreadFromCallback" ( _
   BYREF DWORD _                       ' __inout PTP_CALLBACK_INSTANCE pci
 )                                     ' VOID

DECLARE SUB TrySubmitThreadpoolCallback LIB "KERNEL32.DLL" ALIAS "TrySubmitThreadpoolCallback" ( _
   BYVAL DWORD _                        ' __in        PTP_SIMPLE_CALLBACK  pfns
 , BYREF ANY _                          ' __inout_opt PVOID                pv
 , BYREF TP_CALLBACK_ENVIRON _         ' __in_opt    PTP_CALLBACK_ENVIRON pcbe
 )                                     ' VOID

DECLARE FUNCTION CreateThreadpoolWork LIB "KERNEL32.DLL" ALIAS "CreateThreadpoolWork" ( _
   BYVAL DWORD _                       ' __in        PTP_WORK_CALLBACK    pfnwk
 , BYREF ANY _                         ' __inout_opt PVOID                pv
 , BYREF TP_CALLBACK_ENVIRON _         ' __in_opt    PTP_CALLBACK_ENVIRON pcbe
 ) AS DWORD                            ' PTP_WORK

DECLARE SUB SubmitThreadpoolWork LIB "KERNEL32.DLL" ALIAS "SubmitThreadpoolWork" ( _
   BYREF DWORD _                       ' __inout PTP_WORK pwk
 )                                     ' VOID

DECLARE SUB WaitForThreadpoolWorkCallbacks LIB "KERNEL32.DLL" ALIAS "WaitForThreadpoolWorkCallbacks" ( _
   BYREF DWORD _                       ' __inout PTP_WORK pwk
 , BYVAL LONG _                        ' __in    BOOL     fCancelPendingCallbacks
 )                                     ' VOID

DECLARE SUB CloseThreadpoolWork LIB "KERNEL32.DLL" ALIAS "CloseThreadpoolWork" ( _
   BYREF DWORD _                       ' __inout PTP_WORK pwk
 )                                     ' VOID

DECLARE FUNCTION CreateThreadpoolTimer LIB "KERNEL32.DLL" ALIAS "CreateThreadpoolTimer" ( _
   BYVAL DWORD _                       ' __in        PTP_TIMER_CALLBACK   pfnti
 , BYREF ANY _                         ' __inout_opt PVOID                pv
 , BYREF TP_CALLBACK_ENVIRON _         ' __in_opt    PTP_CALLBACK_ENVIRON pcbe
 ) AS DWORD                            ' PTP_TIMER

DECLARE SUB SetThreadpoolTimer LIB "KERNEL32.DLL" ALIAS "SetThreadpoolTimer" ( _
   BYREF DWORD _                       ' __inout  PTP_TIMER pti
 , BYREF FILETIME _                    ' __in_opt PFILETIME pftDueTime
 , BYVAL DWORD _                       ' __in     DWORD     msPeriod
 , BYVAL DWORD _                       ' __in_opt DWORD     msWindowLength
 )                                     ' VOID

DECLARE FUNCTION IsThreadpoolTimerSet LIB "KERNEL32.DLL" ALIAS "IsThreadpoolTimerSet" ( _
   BYREF DWORD _                       ' __inout PTP_TIMER pti
 ) AS LONG                             ' BOOL

DECLARE SUB WaitForThreadpoolTimerCallbacks LIB "KERNEL32.DLL" ALIAS "WaitForThreadpoolTimerCallbacks" ( _
   BYREF DWORD _                       ' __inout  PTP_TIMER pti
 , BYVAL LONG _                        ' __in    BOOL      fCancelPendingCallbacks
 )                                     ' VOID

DECLARE SUB CloseThreadpoolTimer LIB "KERNEL32.DLL" ALIAS "CloseThreadpoolTimer" ( _
   BYREF DWORD _                       ' __inout  PTP_TIMER pti
 )                                     ' VOID

DECLARE FUNCTION CreateThreadpoolWait LIB "KERNEL32.DLL" ALIAS "CreateThreadpoolWait" ( _
   BYVAL DWORD _                       ' __in        PTP_WAIT_CALLBACK    pfnwa
 , BYREF ANY _                         ' __inout_opt PVOID                pv
 , BYREF TP_CALLBACK_ENVIRON _         ' __in_opt    PTP_CALLBACK_ENVIRON pcbe
 ) AS DWORD                            ' PTP_WAIT

DECLARE SUB SetThreadpoolWait LIB "KERNEL32.DLL" ALIAS "SetThreadpoolWait" ( _
   BYREF DWORD _                       ' __inout  PTP_WAIT  pwa
 , BYVAL DWORD _                       ' __in_opt HANDLE    h
 , BYREF FILETIME _                    ' __in_opt PFILETIME pftTimeout
 )                                     ' VOID

DECLARE SUB WaitForThreadpoolWaitCallbacks LIB "KERNEL32.DLL" ALIAS "WaitForThreadpoolWaitCallbacks" ( _
   BYREF DWORD _                       ' __inout  PTP_WAIT  pwa
 , BYVAL LONG _                        ' __in    BOOL     fCancelPendingCallbacks
 )                                     ' VOID

DECLARE SUB CloseThreadpoolWait LIB "KERNEL32.DLL" ALIAS "CloseThreadpoolWait" ( _
   BYREF DWORD _                       ' __inout  PTP_WAIT  pwa
 )                                     ' VOID

DECLARE FUNCTION CreateThreadpoolIo LIB "KERNEL32.DLL" ALIAS "CreateThreadpoolIo" ( _
   BYVAL DWORD _                       ' __in        HANDLE                fl
 , BYVAL DWORD _                       ' __in        PTP_WIN32_IO_CALLBACK pfnio
 , BYREF ANY _                         ' __inout_opt PVOID                 pv
 , BYREF TP_CALLBACK_ENVIRON _         ' __in_opt    PTP_CALLBACK_ENVIRON  pcbe
 ) AS DWORD                            ' PTP_IO

DECLARE SUB StartThreadpoolIo LIB "KERNEL32.DLL" ALIAS "StartThreadpoolIo" ( _
   BYREF DWORD _                       ' __inout PTP_IO pio
 )                                     ' VOID

DECLARE SUB CancelThreadpoolIo LIB "KERNEL32.DLL" ALIAS "CancelThreadpoolIo" ( _
   BYREF DWORD _                       ' __inout PTP_IO pio
 )                                     ' VOID

DECLARE SUB WaitForThreadpoolIoCallbacks LIB "KERNEL32.DLL" ALIAS "WaitForThreadpoolIoCallbacks" ( _
   BYREF DWORD _                       ' __inout PTP_IO pio
 , BYVAL LONG _                        ' __in    BOOL   fCancelPendingCallbacks
 )                                     ' VOID

DECLARE SUB CloseThreadpoolIo LIB "KERNEL32.DLL" ALIAS "CloseThreadpoolIo" ( _
   BYREF DWORD _                       ' __inout PTP_IO pio
 )                                     ' VOID

'//
'//  Private Namespaces support
'//

DECLARE FUNCTION CreatePrivateNamespace LIB "KERNEL32.DLL" ALIAS "CreatePrivateNamespaceA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpPrivateNamespaceAttributes
 , BYVAL DWORD _                       ' __in     LPVOID lpBoundaryDescriptor
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpAliasPrefix
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreatePrivateNamespaceW LIB "KERNEL32.DLL" ALIAS "CreatePrivateNamespaceW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpPrivateNamespaceAttributes
 , BYVAL DWORD _                       ' __in     LPVOID lpBoundaryDescriptor
 , BYVAL DWORD _                       ' __in     LPCWSTR lpAliasPrefix
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenPrivateNamespace LIB "KERNEL32.DLL" ALIAS "OpenPrivateNamespaceA" ( _
   BYVAL DWORD _                       ' __in     LPVOID lpBoundaryDescriptor
 , BYREF ASCIIZ _                      ' __in     LPCSTR lpAliasPrefix
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenPrivateNamespaceW LIB "KERNEL32.DLL" ALIAS "OpenPrivateNamespaceW" ( _
   BYVAL DWORD _                       ' __in     LPVOID lpBoundaryDescriptor
 , BYVAL DWORD _                       ' __in     LPCWSTR lpAliasPrefix
 ) AS DWORD                            ' HANDLE

%PRIVATE_NAMESPACE_FLAG_DESTROY      = &H00000001???

DECLARE FUNCTION ClosePrivateNamespace LIB "KERNEL32.DLL" ALIAS "ClosePrivateNamespace" ( _
   BYVAL DWORD _                       ' __in HANDLE Handle
 , BYVAL DWORD _                       ' __in ULONG Flags
 ) AS BYTE                             ' BOOLEAN

'//
'//  Boundary descriptors support
'//

DECLARE FUNCTION CreateBoundaryDescriptor LIB "KERNEL32.DLL" ALIAS "CreateBoundaryDescriptorA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR Name
 , BYVAL DWORD _                       ' __in ULONG Flags
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateBoundaryDescriptorW LIB "KERNEL32.DLL" ALIAS "CreateBoundaryDescriptorW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR Name
 , BYVAL DWORD _                       ' __in ULONG Flags
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION AddSIDToBoundaryDescriptor LIB "KERNEL32.DLL" ALIAS "AddSIDToBoundaryDescriptor" ( _
   BYREF DWORD _                       ' __inout HANDLE * BoundaryDescriptor
 , BYVAL SID PTR _                     ' __in PSID RequiredSid
 ) AS LONG                             ' BOOL

DECLARE SUB DeleteBoundaryDescriptor LIB "KERNEL32.DLL" ALIAS "DeleteBoundaryDescriptor" ( _
   BYVAL DWORD _                       ' __in HANDLE BoundaryDescriptor
 )                                     ' VOID

'#endif // _WIN32_WINNT >= 0x0600

'#endif // _WIN32_WINNT >= 0x0500

'#if(_WIN32_WINNT >= 0x0400)
'//
'// Plug-and-Play API's
'//

%HW_PROFILE_GUIDLEN = 39    ' 36-characters plus NULL terminator
%MAX_PROFILE_LEN    = 80

%DOCKINFO_UNDOCKED      = &H1???
%DOCKINFO_DOCKED        = &H2???
%DOCKINFO_USER_SUPPLIED = &H4???
%DOCKINFO_USER_UNDOCKED = %DOCKINFO_USER_SUPPLIED OR %DOCKINFO_UNDOCKED
%DOCKINFO_USER_DOCKED   = %DOCKINFO_USER_SUPPLIED OR %DOCKINFO_DOCKED

TYPE HW_PROFILE_INFOA
  dwDockInfo      AS DWORD                              ' DWORD  dwDockInfo
  szHwProfileGuid AS ASCIIZ * %HW_PROFILE_GUIDLEN       ' CHAR   szHwProfileGuid[HW_PROFILE_GUIDLEN]
  szHwProfileName AS ASCIIZ * %MAX_PROFILE_LEN          ' CHAR   szHwProfileName[MAX_PROFILE_LEN]
END TYPE

TYPE HW_PROFILE_INFOW
  dwDockInfo      AS DWORD                              ' DWORD  dwDockInfo
  szHwProfileGuid AS STRING * %HW_PROFILE_GUIDLEN * 2   ' WCHAR  szHwProfileGuid[HW_PROFILE_GUIDLEN]
  szHwProfileName AS STRING * %MAX_PROFILE_LEN * 2      ' WCHAR  szHwProfileName[MAX_PROFILE_LEN]
END TYPE

MACRO HW_PROFILE_INFO = HW_PROFILE_INFOA

DECLARE FUNCTION GetCurrentHwProfile LIB "ADVAPI32.DLL" ALIAS "GetCurrentHwProfileA" ( _
   BYREF HW_PROFILE_INFOA _            ' __out LPHW_PROFILE_INFOA  lpHwProfileInfo
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCurrentHwProfileW LIB "ADVAPI32.DLL" ALIAS "GetCurrentHwProfileW" ( _
   BYREF HW_PROFILE_INFOW _            ' __out LPHW_PROFILE_INFOW  lpHwProfileInfo
 ) AS LONG                             ' BOOL

'//
'// Performance counter API's
'//

DECLARE FUNCTION QueryPerformanceCounter LIB "KERNEL32.DLL" ALIAS "QueryPerformanceCounter" ( _
   BYREF QUAD _                        ' __out LARGE_INTEGER *lpPerformanceCount
 ) AS LONG                             ' BOOL

DECLARE FUNCTION QueryPerformanceFrequency LIB "KERNEL32.DLL" ALIAS "QueryPerformanceFrequency" ( _
   BYREF QUAD _                        ' __out LARGE_INTEGER *lpFrequency
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVersionEx LIB "KERNEL32.DLL" ALIAS "GetVersionExA" ( _
   BYREF OSVERSIONINFOA _              ' __inout LPOSVERSIONINFOA lpVersionInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVersionExW LIB "KERNEL32.DLL" ALIAS "GetVersionExW" ( _
   BYREF OSVERSIONINFOW _              ' __inout LPOSVERSIONINFOW lpVersionInformation
 ) AS LONG                             ' BOOL

DECLARE FUNCTION VerifyVersionInfo LIB "KERNEL32.DLL" ALIAS "VerifyVersionInfoA" ( _
   BYREF OSVERSIONINFOEXA _            ' __inout LPOSVERSIONINFOEXA lpVersionInformation
 , BYVAL DWORD _                       ' __in    DWORD dwTypeMask
 , BYVAL QUAD _                        ' __in    DWORDLONG dwlConditionMask
 ) AS LONG                             ' BOOL

DECLARE FUNCTION VerifyVersionInfoW LIB "KERNEL32.DLL" ALIAS "VerifyVersionInfoW" ( _
   BYREF OSVERSIONINFOEXW _            ' __inout LPOSVERSIONINFOEXW lpVersionInformation
 , BYVAL DWORD _                       ' __in    DWORD dwTypeMask
 , BYVAL QUAD _                        ' __in    DWORDLONG dwlConditionMask
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE FUNCTION GetProductInfo LIB "KERNEL32.DLL" ALIAS "GetProductInfo" ( _
   BYVAL DWORD _                       ' __in  DWORD  dwOSMajorVersion
 , BYVAL DWORD _                       ' __in  DWORD  dwOSMinorVersion
 , BYVAL DWORD _                       ' __in  DWORD  dwSpMajorVersion
 , BYVAL DWORD _                       ' __in  DWORD  dwSpMinorVersion
 , BYREF DWORD _                       ' __out PDWORD pdwReturnedProductType
 ) AS LONG                             ' BOOL

#ENDIF

'// DOS and OS/2 Compatible Error Code definitions returned by the Win32 Base
'// API functions.
'//

'/************************************************************************
'*                                                                       *
'*   winerror.h --  error code definitions for the Win32 API functions   *
'*                                                                       *
'*   Copyright (c) Microsoft Corp.  All rights reserved.                 *
'*                                                                       *
'************************************************************************/

#IF NOT %DEF(%WINERROR_INC)
    %WINERROR_INC = 1

'#if defined (_MSC_VER) && (_MSC_VER > = 1020) && !defined(__mid&
'#pragma once
'#endif

'#ifndef FORCEINLINE
'#if (_MSC_VER > = 1200)
'%FORCEINLINE __forceinline
'#else
'%FORCEINLINE __inline
'#endif
'#endif

'#include <specstrings.h>

'//
'//  Values are 32 bit values laid out as follows:
'//
'//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
'//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
'//  +---+-+-+-----------------------+-------------------------------+
'//  |Sev|C|R|     Facility          |               Code            |
'//  +---+-+-+-----------------------+-------------------------------+
'//
'//  where
'//
'//      Sev - is the severity code
'//
'//          00 - Success
'//          01 - Informational
'//          10 - Warning
'//          11 - Error
'//
'//      C - is the Customer code flag
'//
'//      R - is a reserved bit
'//
'//      Facility - is the facility code
'//
'//      Code - is the facility's status code
'//
'//
'// Define the facility codes
'//
%FACILITY_WINRM                   = 51
%FACILITY_WINDOWSUPDATE           = 36
%FACILITY_WINDOWS_DEFENDER        = 80
%FACILITY_WINDOWS_CE              = 24
%FACILITY_WINDOWS                 = 8
%FACILITY_URT                     = 19
%FACILITY_UMI                     = 22
%FACILITY_TPM_SOFTWARE            = 41
%FACILITY_TPM_SERVICES            = 40
%FACILITY_SXS                     = 23
%FACILITY_STORAGE                 = 3
%FACILITY_STATE_MANAGEMENT        = 34
%FACILITY_SSPI                    = 9
%FACILITY_SCARD                   = 16
%FACILITY_SHELL                   = 39
%FACILITY_SETUPAPI                = 15
%FACILITY_SECURITY                = 9
%FACILITY_RPC                     = 1
%FACILITY_PLA                     = 48
%FACILITY_WIN32                   = 7
%FACILITY_CONTROL                 = 10
%FACILITY_NULL                    = 0
%FACILITY_NDIS                    = 52
%FACILITY_METADIRECTORY           = 35
%FACILITY_MSMQ                    = 14
%FACILITY_MEDIASERVER             = 13
%FACILITY_INTERNET                = 12
%FACILITY_ITF                     = 4
%FACILITY_USERMODE_HYPERVISOR     = 53
%FACILITY_HTTP                    = 25
%FACILITY_GRAPHICS                = 38
%FACILITY_FWP                     = 50
%FACILITY_FVE                     = 49
%FACILITY_USERMODE_FILTER_MANAGER = 31
%FACILITY_DPLAY                   = 21
%FACILITY_DISPATCH                = 2
%FACILITY_DIRECTORYSERVICE        = 37
%FACILITY_CONFIGURATION           = 33
%FACILITY_COMPLUS                 = 17
%FACILITY_USERMODE_COMMONLOG      = 26
%FACILITY_CMI                     = 54
%FACILITY_CERT                    = 11
%FACILITY_BACKGROUNDCOPY          = 32
%FACILITY_ACS                     = 20
%FACILITY_AAF                     = 18


'//
'// Define the severity codes
'//


'//
'// MessageId: ERROR_SUCCESS
'//
'// MessageText:
'//
'// The operation completed successfully.
'//
%ERROR_SUCCESS                    = 0&

%NO_ERROR                         = 0&   '// dderror
%SEC_E_OK                         = &H00000000&


'//
'// MessageId: ERROR_INVALID_FUNCTION
'//
'// MessageText:
'//
'// Incorrect function.
'//
%ERROR_INVALID_FUNCTION           = 1&    '// dderror

'//
'// MessageId: ERROR_FILE_NOT_FOUND
'//
'// MessageText:
'//
'// The system cannot find the file specified.
'//
%ERROR_FILE_NOT_FOUND             = 2&

'//
'// MessageId: ERROR_PATH_NOT_FOUND
'//
'// MessageText:
'//
'// The system cannot find the path specified.
'//
%ERROR_PATH_NOT_FOUND             = 3&

'//
'// MessageId: ERROR_TOO_MANY_OPEN_FILES
'//
'// MessageText:
'//
'// The system cannot open the file.
'//
%ERROR_TOO_MANY_OPEN_FILES        = 4&

'//
'// MessageId: ERROR_ACCESS_DENIED
'//
'// MessageText:
'//
'// Access is denied.
'//
%ERROR_ACCESS_DENIED              = 5&

'//
'// MessageId: ERROR_INVALID_HANDLE
'//
'// MessageText:
'//
'// The handle is invalid.
'//
%ERROR_INVALID_HANDLE             = 6&

'//
'// MessageId: ERROR_ARENA_TRASHED
'//
'// MessageText:
'//
'// The storage control blocks were destroyed.
'//
%ERROR_ARENA_TRASHED              = 7&

'//
'// MessageId: ERROR_NOT_ENOUGH_MEMORY
'//
'// MessageText:
'//
'// Not enough storage is available to process this command.
'//
%ERROR_NOT_ENOUGH_MEMORY          = 8&    '// dderror

'//
'// MessageId: ERROR_INVALID_BLOCK
'//
'// MessageText:
'//
'// The storage control block address is invalid.
'//
%ERROR_INVALID_BLOCK              = 9&

'//
'// MessageId: ERROR_BAD_ENVIRONMENT
'//
'// MessageText:
'//
'// The environment is incorrect.
'//
%ERROR_BAD_ENVIRONMENT            = 10&

'//
'// MessageId: ERROR_BAD_FORMAT
'//
'// MessageText:
'//
'// An attempt was made to load a program with an incorrect format.
'//
%ERROR_BAD_FORMAT                 = 11&

'//
'// MessageId: ERROR_INVALID_ACCESS
'//
'// MessageText:
'//
'// The access code is invalid.
'//
%ERROR_INVALID_ACCESS             = 12&

'//
'// MessageId: ERROR_INVALID_DATA
'//
'// MessageText:
'//
'// The data is invalid.
'//
%ERROR_INVALID_DATA               = 13&

'//
'// MessageId: ERROR_OUTOFMEMORY
'//
'// MessageText:
'//
'// Not enough storage is available to complete this operation.
'//
%ERROR_OUTOFMEMORY                = 14&

'//
'// MessageId: ERROR_INVALID_DRIVE
'//
'// MessageText:
'//
'// The system cannot find the drive specified.
'//
%ERROR_INVALID_DRIVE              = 15&

'//
'// MessageId: ERROR_CURRENT_DIRECTORY
'//
'// MessageText:
'//
'// The directory cannot be removed.
'//
%ERROR_CURRENT_DIRECTORY          = 16&

'//
'// MessageId: ERROR_NOT_SAME_DEVICE
'//
'// MessageText:
'//
'// The system cannot move the file to a different disk drive.
'//
%ERROR_NOT_SAME_DEVICE            = 17&

'//
'// MessageId: ERROR_NO_MORE_FILES
'//
'// MessageText:
'//
'// There are no more files.
'//
%ERROR_NO_MORE_FILES              = 18&

'//
'// MessageId: ERROR_WRITE_PROTECT
'//
'// MessageText:
'//
'// The media is write protected.
'//
%ERROR_WRITE_PROTECT              = 19&

'//
'// MessageId: ERROR_BAD_UNIT
'//
'// MessageText:
'//
'// The system cannot find the device specified.
'//
%ERROR_BAD_UNIT                   = 20&

'//
'// MessageId: ERROR_NOT_READY
'//
'// MessageText:
'//
'// The device is not ready.
'//
%ERROR_NOT_READY                  = 21&

'//
'// MessageId: ERROR_BAD_COMMAND
'//
'// MessageText:
'//
'// The device does not recognize the command.
'//
%ERROR_BAD_COMMAND                = 22&

'//
'// MessageId: ERROR_CRC
'//
'// MessageText:
'//
'// Data error (cyclic redundancy check).
'//
%ERROR_CRC                        = 23&

'//
'// MessageId: ERROR_BAD_LENGTH
'//
'// MessageText:
'//
'// The program issued a command but the command length is incorrect.
'//
%ERROR_BAD_LENGTH                 = 24&

'//
'// MessageId: ERROR_SEEK
'//
'// MessageText:
'//
'// The drive cannot locate a specific area or track on the disk.
'//
%ERROR_SEEK                       = 25&

'//
'// MessageId: ERROR_NOT_DOS_DISK
'//
'// MessageText:
'//
'// The specified disk or diskette cannot be accessed.
'//
%ERROR_NOT_DOS_DISK               = 26&

'//
'// MessageId: ERROR_SECTOR_NOT_FOUND
'//
'// MessageText:
'//
'// The drive cannot find the sector requested.
'//
%ERROR_SECTOR_NOT_FOUND           = 27&

'//
'// MessageId: ERROR_OUT_OF_PAPER
'//
'// MessageText:
'//
'// The printer is out of paper.
'//
%ERROR_OUT_OF_PAPER               = 28&

'//
'// MessageId: ERROR_WRITE_FAULT
'//
'// MessageText:
'//
'// The system cannot write to the specified device.
'//
%ERROR_WRITE_FAULT                = 29&

'//
'// MessageId: ERROR_READ_FAULT
'//
'// MessageText:
'//
'// The system cannot read from the specified device.
'//
%ERROR_READ_FAULT                 = 30&

'//
'// MessageId: ERROR_GEN_FAILURE
'//
'// MessageText:
'//
'// A device attached to the system is not functioning.
'//
%ERROR_GEN_FAILURE                = 31&

'//
'// MessageId: ERROR_SHARING_VIOLATION
'//
'// MessageText:
'//
'// The process cannot access the file because it is being used by another process.
'//
%ERROR_SHARING_VIOLATION          = 32&

'//
'// MessageId: ERROR_LOCK_VIOLATION
'//
'// MessageText:
'//
'// The process cannot access the file because another process has locked a portion of the file.
'//
%ERROR_LOCK_VIOLATION             = 33&

'//
'// MessageId: ERROR_WRONG_DISK
'//
'// MessageText:
'//
'// The wrong diskette is in the drive.
'// Insert %2 (Volume Serial Number: %3) into drive %1.
'//
%ERROR_WRONG_DISK                 = 34&

'//
'// MessageId: ERROR_SHARING_BUFFER_EXCEEDED
'//
'// MessageText:
'//
'// Too many files opened for sharing.
'//
%ERROR_SHARING_BUFFER_EXCEEDED    = 36&

'//
'// MessageId: ERROR_HANDLE_EOF
'//
'// MessageText:
'//
'// Reached the end of the file.
'//
%ERROR_HANDLE_EOF                 = 38&

'//
'// MessageId: ERROR_HANDLE_DISK_FULL
'//
'// MessageText:
'//
'// The disk is full.
'//
%ERROR_HANDLE_DISK_FULL           = 39&

'//
'// MessageId: ERROR_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The request is not supported.
'//
%ERROR_NOT_SUPPORTED              = 50&

'//
'// MessageId: ERROR_REM_NOT_LIST
'//
'// MessageText:
'//
'// Windows cannot find the network path. Verify that the network path is correct and the destination computer is not busy or turned off. If Windows still cannot find the network path, contact your network administrator.
'//
%ERROR_REM_NOT_LIST               = 51&

'//
'// MessageId: ERROR_DUP_NAME
'//
'// MessageText:
'//
'// You were not connected because a duplicate name exists on the network. If joining a domain, go to System in Control Panel to change the computer name and try again.  If joining a workgroup, choose another workgroup name.
'//
%ERROR_DUP_NAME                   = 52&

'//
'// MessageId: ERROR_BAD_NETPATH
'//
'// MessageText:
'//
'// The network path was not found.
'//
%ERROR_BAD_NETPATH                = 53&

'//
'// MessageId: ERROR_NETWORK_BUSY
'//
'// MessageText:
'//
'// The network is busy.
'//
%ERROR_NETWORK_BUSY               = 54&

'//
'// MessageId: ERROR_DEV_NOT_EXIST
'//
'// MessageText:
'//
'// The specified network resource or device is no longer available.
'//
%ERROR_DEV_NOT_EXIST              = 55&    '// dderror

'//
'// MessageId: ERROR_TOO_MANY_CMDS
'//
'// MessageText:
'//
'// The network BIOS command limit has been reached.
'//
%ERROR_TOO_MANY_CMDS              = 56&

'//
'// MessageId: ERROR_ADAP_HDW_ERR
'//
'// MessageText:
'//
'// A network adapter hardware error occurred.
'//
%ERROR_ADAP_HDW_ERR               = 57&

'//
'// MessageId: ERROR_BAD_NET_RESP
'//
'// MessageText:
'//
'// The specified server cannot perform the requested operation.
'//
%ERROR_BAD_NET_RESP               = 58&

'//
'// MessageId: ERROR_UNEXP_NET_ERR
'//
'// MessageText:
'//
'// An unexpected network error occurred.
'//
%ERROR_UNEXP_NET_ERR              = 59&

'//
'// MessageId: ERROR_BAD_REM_ADAP
'//
'// MessageText:
'//
'// The remote adapter is not compatible.
'//
%ERROR_BAD_REM_ADAP               = 60&

'//
'// MessageId: ERROR_PRINTQ_FULL
'//
'// MessageText:
'//
'// The printer queue is full.
'//
%ERROR_PRINTQ_FULL                = 61&

'//
'// MessageId: ERROR_NO_SPOOL_SPACE
'//
'// MessageText:
'//
'// Space to store the file waiting to be printed is not available on the server.
'//
%ERROR_NO_SPOOL_SPACE             = 62&

'//
'// MessageId: ERROR_PRINT_CANCELLED
'//
'// MessageText:
'//
'// Your file waiting to be printed was deleted.
'//
%ERROR_PRINT_CANCELLED            = 63&

'//
'// MessageId: ERROR_NETNAME_DELETED
'//
'// MessageText:
'//
'// The specified network name is no longer available.
'//
%ERROR_NETNAME_DELETED            = 64&

'//
'// MessageId: ERROR_NETWORK_ACCESS_DENIED
'//
'// MessageText:
'//
'// Network access is denied.
'//
%ERROR_NETWORK_ACCESS_DENIED      = 65&

'//
'// MessageId: ERROR_BAD_DEV_TYPE
'//
'// MessageText:
'//
'// The network resource type is not correct.
'//
%ERROR_BAD_DEV_TYPE               = 66&

'//
'// MessageId: ERROR_BAD_NET_NAME
'//
'// MessageText:
'//
'// The network name cannot be found.
'//
%ERROR_BAD_NET_NAME               = 67&

'//
'// MessageId: ERROR_TOO_MANY_NAMES
'//
'// MessageText:
'//
'// The name limit for the local computer network adapter card was exceeded.
'//
%ERROR_TOO_MANY_NAMES             = 68&

'//
'// MessageId: ERROR_TOO_MANY_SESS
'//
'// MessageText:
'//
'// The network BIOS session limit was exceeded.
'//
%ERROR_TOO_MANY_SESS              = 69&

'//
'// MessageId: ERROR_SHARING_PAUSED
'//
'// MessageText:
'//
'// The remote server has been paused or is in the process of being started.
'//
%ERROR_SHARING_PAUSED             = 70&

'//
'// MessageId: ERROR_REQ_NOT_ACCEP
'//
'// MessageText:
'//
'// No more connections can be made to this remote computer at this time because there are already as many connections as the computer can accept.
'//
%ERROR_REQ_NOT_ACCEP              = 71&

'//
'// MessageId: ERROR_REDIR_PAUSED
'//
'// MessageText:
'//
'// The specified printer or disk device has been paused.
'//
%ERROR_REDIR_PAUSED               = 72&

'//
'// MessageId: ERROR_FILE_EXISTS
'//
'// MessageText:
'//
'// The file exists.
'//
%ERROR_FILE_EXISTS                = 80&

'//
'// MessageId: ERROR_CANNOT_MAKE
'//
'// MessageText:
'//
'// The directory or file cannot be created.
'//
%ERROR_CANNOT_MAKE                = 82&

'//
'// MessageId: ERROR_FAIL_I24
'//
'// MessageText:
'//
'// Fail on INT 24.
'//
%ERROR_FAIL_I24                   = 83&

'//
'// MessageId: ERROR_OUT_OF_STRUCTURES
'//
'// MessageText:
'//
'// Storage to process this request is not available.
'//
%ERROR_OUT_OF_STRUCTURES          = 84&

'//
'// MessageId: ERROR_ALREADY_ASSIGNED
'//
'// MessageText:
'//
'// The local device name is already in use.
'//
%ERROR_ALREADY_ASSIGNED           = 85&

'//
'// MessageId: ERROR_INVALID_PASSWORD
'//
'// MessageText:
'//
'// The specified network password is not correct.
'//
%ERROR_INVALID_PASSWORD           = 86&

'//
'// MessageId: ERROR_INVALID_PARAMETER
'//
'// MessageText:
'//
'// The parameter is incorrect.
'//
%ERROR_INVALID_PARAMETER          = 87&    '// dderror

'//
'// MessageId: ERROR_NET_WRITE_FAULT
'//
'// MessageText:
'//
'// A write fault occurred on the network.
'//
%ERROR_NET_WRITE_FAULT            = 88&

'//
'// MessageId: ERROR_NO_PROC_SLOTS
'//
'// MessageText:
'//
'// The system cannot start another process at this time.
'//
%ERROR_NO_PROC_SLOTS              = 89&

'//
'// MessageId: ERROR_TOO_MANY_SEMAPHORES
'//
'// MessageText:
'//
'// Cannot create another system semaphore.
'//
%ERROR_TOO_MANY_SEMAPHORES        = 100&

'//
'// MessageId: ERROR_EXCL_SEM_ALREADY_OWNED
'//
'// MessageText:
'//
'// The exclusive semaphore is owned by another process.
'//
%ERROR_EXCL_SEM_ALREADY_OWNED     = 101&

'//
'// MessageId: ERROR_SEM_IS_SET
'//
'// MessageText:
'//
'// The semaphore is set and cannot be closed.
'//
%ERROR_SEM_IS_SET                 = 102&

'//
'// MessageId: ERROR_TOO_MANY_SEM_REQUESTS
'//
'// MessageText:
'//
'// The semaphore cannot be set again.
'//
%ERROR_TOO_MANY_SEM_REQUESTS      = 103&

'//
'// MessageId: ERROR_INVALID_AT_INTERRUPT_TIME
'//
'// MessageText:
'//
'// Cannot request exclusive semaphores at interrupt time.
'//
%ERROR_INVALID_AT_INTERRUPT_TIME  = 104&

'//
'// MessageId: ERROR_SEM_OWNER_DIED
'//
'// MessageText:
'//
'// The previous ownership of this semaphore has ended.
'//
%ERROR_SEM_OWNER_DIED             = 105&

'//
'// MessageId: ERROR_SEM_USER_LIMIT
'//
'// MessageText:
'//
'// Insert the diskette for drive %1.
'//
%ERROR_SEM_USER_LIMIT             = 106&

'//
'// MessageId: ERROR_DISK_CHANGE
'//
'// MessageText:
'//
'// The program stopped because an alternate diskette was not inserted.
'//
%ERROR_DISK_CHANGE                = 107&

'//
'// MessageId: ERROR_DRIVE_LOCKED
'//
'// MessageText:
'//
'// The disk is in use or locked by another process.
'//
%ERROR_DRIVE_LOCKED               = 108&

'//
'// MessageId: ERROR_BROKEN_PIPE
'//
'// MessageText:
'//
'// The pipe has been ended.
'//
%ERROR_BROKEN_PIPE                = 109&

'//
'// MessageId: ERROR_OPEN_FAILED
'//
'// MessageText:
'//
'// The system cannot open the device or file specified.
'//
%ERROR_OPEN_FAILED                = 110&

'//
'// MessageId: ERROR_BUFFER_OVERFLOW
'//
'// MessageText:
'//
'// The file name is too long.
'//
%ERROR_BUFFER_OVERFLOW            = 111&

'//
'// MessageId: ERROR_DISK_FULL
'//
'// MessageText:
'//
'// There is not enough space on the disk.
'//
%ERROR_DISK_FULL                  = 112&

'//
'// MessageId: ERROR_NO_MORE_SEARCH_HANDLES
'//
'// MessageText:
'//
'// No more internal file identifiers available.
'//
%ERROR_NO_MORE_SEARCH_HANDLES     = 113&

'//
'// MessageId: ERROR_INVALID_TARGET_HANDLE
'//
'// MessageText:
'//
'// The target internal file identifier is incorrect.
'//
%ERROR_INVALID_TARGET_HANDLE      = 114&

'//
'// MessageId: ERROR_INVALID_CATEGORY
'//
'// MessageText:
'//
'// The IOCTL call made by the application program is not correct.
'//
%ERROR_INVALID_CATEGORY           = 117&

'//
'// MessageId: ERROR_INVALID_VERIFY_SWITCH
'//
'// MessageText:
'//
'// The verify-on-write switch parameter value is not correct.
'//
%ERROR_INVALID_VERIFY_SWITCH      = 118&

'//
'// MessageId: ERROR_BAD_DRIVER_LEVEL
'//
'// MessageText:
'//
'// The system does not support the command requested.
'//
%ERROR_BAD_DRIVER_LEVEL           = 119&

'//
'// MessageId: ERROR_CALL_NOT_IMPLEMENTED
'//
'// MessageText:
'//
'// This function is not supported on this system.
'//
%ERROR_CALL_NOT_IMPLEMENTED       = 120&

'//
'// MessageId: ERROR_SEM_TIMEOUT
'//
'// MessageText:
'//
'// The semaphore timeout period has expired.
'//
%ERROR_SEM_TIMEOUT                = 121&

'//
'// MessageId: ERROR_INSUFFICIENT_BUFFER
'//
'// MessageText:
'//
'// The data area passed to a system call is too small.
'//
%ERROR_INSUFFICIENT_BUFFER        = 122&    '// dderror

'//
'// MessageId: ERROR_INVALID_NAME
'//
'// MessageText:
'//
'// The filename, directory name, or volume label syntax is incorrect.
'//
%ERROR_INVALID_NAME               = 123&    '// dderror

'//
'// MessageId: ERROR_INVALID_LEVEL
'//
'// MessageText:
'//
'// The system call level is not correct.
'//
%ERROR_INVALID_LEVEL              = 124&

'//
'// MessageId: ERROR_NO_VOLUME_LABEL
'//
'// MessageText:
'//
'// The disk has no volume label.
'//
%ERROR_NO_VOLUME_LABEL            = 125&

'//
'// MessageId: ERROR_MOD_NOT_FOUND
'//
'// MessageText:
'//
'// The specified module could not be found.
'//
%ERROR_MOD_NOT_FOUND              = 126&

'//
'// MessageId: ERROR_PROC_NOT_FOUND
'//
'// MessageText:
'//
'// The specified procedure could not be found.
'//
%ERROR_PROC_NOT_FOUND             = 127&

'//
'// MessageId: ERROR_WAIT_NO_CHILDREN
'//
'// MessageText:
'//
'// There are no child processes to wait for.
'//
%ERROR_WAIT_NO_CHILDREN           = 128&

'//
'// MessageId: ERROR_CHILD_NOT_COMPLETE
'//
'// MessageText:
'//
'// The %1 application cannot be run in Win32 mode.
'//
%ERROR_CHILD_NOT_COMPLETE         = 129&

'//
'// MessageId: ERROR_DIRECT_ACCESS_HANDLE
'//
'// MessageText:
'//
'// Attempt to use a file handle to an open disk partition for an operation other than raw disk I/O.
'//
%ERROR_DIRECT_ACCESS_HANDLE       = 130&

'//
'// MessageId: ERROR_NEGATIVE_SEEK
'//
'// MessageText:
'//
'// An attempt was made to move the file pointer before the beginning of the file.
'//
%ERROR_NEGATIVE_SEEK              = 131&

'//
'// MessageId: ERROR_SEEK_ON_DEVICE
'//
'// MessageText:
'//
'// The file pointer cannot be set on the specified device or file.
'//
%ERROR_SEEK_ON_DEVICE             = 132&

'//
'// MessageId: ERROR_IS_JOIN_TARGET
'//
'// MessageText:
'//
'// A JOIN or SUBST command cannot be used for a drive that contains previously joined drives.
'//
%ERROR_IS_JOIN_TARGET             = 133&

'//
'// MessageId: ERROR_IS_JOINED
'//
'// MessageText:
'//
'// An attempt was made to use a JOIN or SUBST command on a drive that has already been joined.
'//
%ERROR_IS_JOINED                  = 134&

'//
'// MessageId: ERROR_IS_SUBSTED
'//
'// MessageText:
'//
'// An attempt was made to use a JOIN or SUBST command on a drive that has already been substituted.
'//
%ERROR_IS_SUBSTED                 = 135&

'//
'// MessageId: ERROR_NOT_JOINED
'//
'// MessageText:
'//
'// The system tried to delete the JOIN of a drive that is not joined.
'//
%ERROR_NOT_JOINED                 = 136&

'//
'// MessageId: ERROR_NOT_SUBSTED
'//
'// MessageText:
'//
'// The system tried to delete the substitution of a drive that is not substituted.
'//
%ERROR_NOT_SUBSTED                = 137&

'//
'// MessageId: ERROR_JOIN_TO_JOIN
'//
'// MessageText:
'//
'// The system tried to join a drive to a directory on a joined drive.
'//
%ERROR_JOIN_TO_JOIN               = 138&

'//
'// MessageId: ERROR_SUBST_TO_SUBST
'//
'// MessageText:
'//
'// The system tried to substitute a drive to a directory on a substituted drive.
'//
%ERROR_SUBST_TO_SUBST             = 139&

'//
'// MessageId: ERROR_JOIN_TO_SUBST
'//
'// MessageText:
'//
'// The system tried to join a drive to a directory on a substituted drive.
'//
%ERROR_JOIN_TO_SUBST              = 140&

'//
'// MessageId: ERROR_SUBST_TO_JOIN
'//
'// MessageText:
'//
'// The system tried to SUBST a drive to a directory on a joined drive.
'//
%ERROR_SUBST_TO_JOIN              = 141&

'//
'// MessageId: ERROR_BUSY_DRIVE
'//
'// MessageText:
'//
'// The system cannot perform a JOIN or SUBST at this time.
'//
%ERROR_BUSY_DRIVE                 = 142&

'//
'// MessageId: ERROR_SAME_DRIVE
'//
'// MessageText:
'//
'// The system cannot join or substitute a drive to or for a directory on the same drive.
'//
%ERROR_SAME_DRIVE                 = 143&

'//
'// MessageId: ERROR_DIR_NOT_ROOT
'//
'// MessageText:
'//
'// The directory is not a subdirectory of the root directory.
'//
%ERROR_DIR_NOT_ROOT               = 144&

'//
'// MessageId: ERROR_DIR_NOT_EMPTY
'//
'// MessageText:
'//
'// The directory is not empty.
'//
%ERROR_DIR_NOT_EMPTY              = 145&

'//
'// MessageId: ERROR_IS_SUBST_PATH
'//
'// MessageText:
'//
'// The path specified is being used in a substitute.
'//
%ERROR_IS_SUBST_PATH              = 146&

'//
'// MessageId: ERROR_IS_JOIN_PATH
'//
'// MessageText:
'//
'// Not enough resources are available to process this command.
'//
%ERROR_IS_JOIN_PATH               = 147&

'//
'// MessageId: ERROR_PATH_BUSY
'//
'// MessageText:
'//
'// The path specified cannot be used at this time.
'//
%ERROR_PATH_BUSY                  = 148&

'//
'// MessageId: ERROR_IS_SUBST_TARGET
'//
'// MessageText:
'//
'// An attempt was made to join or substitute a drive for which a directory on the drive is the target of a previous substitute.
'//
%ERROR_IS_SUBST_TARGET            = 149&

'//
'// MessageId: ERROR_SYSTEM_TRACE
'//
'// MessageText:
'//
'// System trace information was not specified in your CONFIG.SYS file, or tracing is disallowed.
'//
%ERROR_SYSTEM_TRACE               = 150&

'//
'// MessageId: ERROR_INVALID_EVENT_COUNT
'//
'// MessageText:
'//
'// The number of specified semaphore events for DosMuxSemWait is not correct.
'//
%ERROR_INVALID_EVENT_COUNT        = 151&

'//
'// MessageId: ERROR_TOO_MANY_MUXWAITERS
'//
'// MessageText:
'//
'// DosMuxSemWait did not execute; too many semaphores are already set.
'//
%ERROR_TOO_MANY_MUXWAITERS        = 152&

'//
'// MessageId: ERROR_INVALID_LIST_FORMAT
'//
'// MessageText:
'//
'// The DosMuxSemWait list is not correct.
'//
%ERROR_INVALID_LIST_FORMAT        = 153&

'//
'// MessageId: ERROR_LABEL_TOO_LONG
'//
'// MessageText:
'//
'// The volume label you entered exceeds the label character limit of the target file system.
'//
%ERROR_LABEL_TOO_LONG             = 154&

'//
'// MessageId: ERROR_TOO_MANY_TCBS
'//
'// MessageText:
'//
'// Cannot create another thread.
'//
%ERROR_TOO_MANY_TCBS              = 155&

'//
'// MessageId: ERROR_SIGNAL_REFUSED
'//
'// MessageText:
'//
'// The recipient process has refused the signal.
'//
%ERROR_SIGNAL_REFUSED             = 156&

'//
'// MessageId: ERROR_DISCARDED
'//
'// MessageText:
'//
'// The segment is already discarded and cannot be locked.
'//
%ERROR_DISCARDED                  = 157&

'//
'// MessageId: ERROR_NOT_LOCKED
'//
'// MessageText:
'//
'// The segment is already unlocked.
'//
%ERROR_NOT_LOCKED                 = 158&

'//
'// MessageId: ERROR_BAD_THREADID_ADDR
'//
'// MessageText:
'//
'// The address for the thread ID is not correct.
'//
%ERROR_BAD_THREADID_ADDR          = 159&

'//
'// MessageId: ERROR_BAD_ARGUMENTS
'//
'// MessageText:
'//
'// One or more arguments are not correct.
'//
%ERROR_BAD_ARGUMENTS              = 160&

'//
'// MessageId: ERROR_BAD_PATHNAME
'//
'// MessageText:
'//
'// The specified path is invalid.
'//
%ERROR_BAD_PATHNAME               = 161&

'//
'// MessageId: ERROR_SIGNAL_PENDING
'//
'// MessageText:
'//
'// A signal is already pending.
'//
%ERROR_SIGNAL_PENDING             = 162&

'//
'// MessageId: ERROR_MAX_THRDS_REACHED
'//
'// MessageText:
'//
'// No more threads can be created in the system.
'//
%ERROR_MAX_THRDS_REACHED          = 164&

'//
'// MessageId: ERROR_LOCK_FAILED
'//
'// MessageText:
'//
'// Unable to lock a region of a file.
'//
%ERROR_LOCK_FAILED                = 167&

'//
'// MessageId: ERROR_BUSY
'//
'// MessageText:
'//
'// The requested resource is in use.
'//
%ERROR_BUSY                       = 170&    '// dderror

'//
'// MessageId: ERROR_CANCEL_VIOLATION
'//
'// MessageText:
'//
'// A lock request was not outstanding for the supplied cancel region.
'//
%ERROR_CANCEL_VIOLATION           = 173&

'//
'// MessageId: ERROR_ATOMIC_LOCKS_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The file system does not support atomic changes to the lock type.
'//
%ERROR_ATOMIC_LOCKS_NOT_SUPPORTED = 174&

'//
'// MessageId: ERROR_INVALID_SEGMENT_NUMBER
'//
'// MessageText:
'//
'// The system detected a segment number that was not correct.
'//
%ERROR_INVALID_SEGMENT_NUMBER     = 180&

'//
'// MessageId: ERROR_INVALID_ORDINAL
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_INVALID_ORDINAL            = 182&

'//
'// MessageId: ERROR_ALREADY_EXISTS
'//
'// MessageText:
'//
'// Cannot create a file when that file already exists.
'//
%ERROR_ALREADY_EXISTS             = 183&

'//
'// MessageId: ERROR_INVALID_FLAG_NUMBER
'//
'// MessageText:
'//
'// The flag passed is not correct.
'//
%ERROR_INVALID_FLAG_NUMBER        = 186&

'//
'// MessageId: ERROR_SEM_NOT_FOUND
'//
'// MessageText:
'//
'// The specified system semaphore name was not found.
'//
%ERROR_SEM_NOT_FOUND              = 187&

'//
'// MessageId: ERROR_INVALID_STARTING_CODESEG
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_INVALID_STARTING_CODESEG   = 188&

'//
'// MessageId: ERROR_INVALID_STACKSEG
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_INVALID_STACKSEG           = 189&

'//
'// MessageId: ERROR_INVALID_MODULETYPE
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_INVALID_MODULETYPE         = 190&

'//
'// MessageId: ERROR_INVALID_EXE_SIGNATURE
'//
'// MessageText:
'//
'// Cannot run %1 in Win32 mode.
'//
%ERROR_INVALID_EXE_SIGNATURE      = 191&

'//
'// MessageId: ERROR_EXE_MARKED_INVALID
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_EXE_MARKED_INVALID         = 192&

'//
'// MessageId: ERROR_BAD_EXE_FORMAT
'//
'// MessageText:
'//
'// %1 is not a valid Win32 application.
'//
%ERROR_BAD_EXE_FORMAT             = 193&

'//
'// MessageId: ERROR_ITERATED_DATA_EXCEEDS_64k
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_ITERATED_DATA_EXCEEDS_64k  = 194&

'//
'// MessageId: ERROR_INVALID_MINALLOCSIZE
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_INVALID_MINALLOCSIZE       = 195&

'//
'// MessageId: ERROR_DYNLINK_FROM_INVALID_RING
'//
'// MessageText:
'//
'// The operating system cannot run this application program.
'//
%ERROR_DYNLINK_FROM_INVALID_RING  = 196&

'//
'// MessageId: ERROR_IOPL_NOT_ENABLED
'//
'// MessageText:
'//
'// The operating system is not presently configured to run this application.
'//
%ERROR_IOPL_NOT_ENABLED           = 197&

'//
'// MessageId: ERROR_INVALID_SEGDPL
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_INVALID_SEGDPL             = 198&

'//
'// MessageId: ERROR_AUTODATASEG_EXCEEDS_64k
'//
'// MessageText:
'//
'// The operating system cannot run this application program.
'//
%ERROR_AUTODATASEG_EXCEEDS_64k    = 199&

'//
'// MessageId: ERROR_RING2SEG_MUST_BE_MOVABLE
'//
'// MessageText:
'//
'// The code segment cannot be greater than or equal to 64K.
'//
%ERROR_RING2SEG_MUST_BE_MOVABLE   = 200&

'//
'// MessageId: ERROR_RELOC_CHAIN_XEEDS_SEGLIM
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_RELOC_CHAIN_XEEDS_SEGLIM   = 201&

'//
'// MessageId: ERROR_INFLOOP_IN_RELOC_CHAIN
'//
'// MessageText:
'//
'// The operating system cannot run %1.
'//
%ERROR_INFLOOP_IN_RELOC_CHAIN     = 202&

'//
'// MessageId: ERROR_ENVVAR_NOT_FOUND
'//
'// MessageText:
'//
'// The system could not find the environment option that was entered.
'//
%ERROR_ENVVAR_NOT_FOUND           = 203&

'//
'// MessageId: ERROR_NO_SIGNAL_SENT
'//
'// MessageText:
'//
'// No process in the command subtree has a signal handler.
'//
%ERROR_NO_SIGNAL_SENT             = 205&

'//
'// MessageId: ERROR_FILENAME_EXCED_RANGE
'//
'// MessageText:
'//
'// The filename or extension is too long.
'//
%ERROR_FILENAME_EXCED_RANGE       = 206&

'//
'// MessageId: ERROR_RING2_STACK_IN_USE
'//
'// MessageText:
'//
'// The ring 2 stack is in use.
'//
%ERROR_RING2_STACK_IN_USE         = 207&

'//
'// MessageId: ERROR_META_EXPANSION_TOO_LONG
'//
'// MessageText:
'//
'// The global filename characters, * or ?, are entered incorrectly or too many global filename characters are specified.
'//
%ERROR_META_EXPANSION_TOO_LONG    = 208&

'//
'// MessageId: ERROR_INVALID_SIGNAL_NUMBER
'//
'// MessageText:
'//
'// The signal being posted is not correct.
'//
%ERROR_INVALID_SIGNAL_NUMBER      = 209&

'//
'// MessageId: ERROR_THREAD_1_INACTIVE
'//
'// MessageText:
'//
'// The signal handler cannot be set.
'//
%ERROR_THREAD_1_INACTIVE          = 210&

'//
'// MessageId: ERROR_LOCKED
'//
'// MessageText:
'//
'// The segment is locked and cannot be reallocated.
'//
%ERROR_LOCKED                     = 212&

'//
'// MessageId: ERROR_TOO_MANY_MODULES
'//
'// MessageText:
'//
'// Too many dynamic-link modules are attached to this program or dynamic-link module.
'//
%ERROR_TOO_MANY_MODULES           = 214&

'//
'// MessageId: ERROR_NESTING_NOT_ALLOWED
'//
'// MessageText:
'//
'// Cannot nest calls to LoadModule.
'//
%ERROR_NESTING_NOT_ALLOWED        = 215&

'//
'// MessageId: ERROR_EXE_MACHINE_TYPE_MISMATCH
'//
'// MessageText:
'//
'// This version of %1 is not compatible with the version of Windows you're running. Check your computer's system information to see whether you need a x86 (32-bit) or x64 (64-bit) version of the program, and then contact the software publisher.
'//
%ERROR_EXE_MACHINE_TYPE_MISMATCH = 216&

'//
'// MessageId: ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY
'//
'// MessageText:
'//
'// The image file %1 is signed, unable to modify.
'//
%ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY = 217&

'//
'// MessageId: ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY
'//
'// MessageText:
'//
'// The image file %1 is strong signed, unable to modify.
'//
%ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY = 218&

'//
'// MessageId: ERROR_FILE_CHECKED_OUT
'//
'// MessageText:
'//
'// This file is checked out or locked for editing by another user.
'//
%ERROR_FILE_CHECKED_OUT           = 220&

'//
'// MessageId: ERROR_CHECKOUT_REQUIRED
'//
'// MessageText:
'//
'// The file must be checked out before saving changes.
'//
%ERROR_CHECKOUT_REQUIRED          = 221&

'//
'// MessageId: ERROR_BAD_FILE_TYPE
'//
'// MessageText:
'//
'// The file type being saved or retrieved has been blocked.
'//
%ERROR_BAD_FILE_TYPE              = 222&

'//
'// MessageId: ERROR_FILE_TOO_LARGE
'//
'// MessageText:
'//
'// The file size exceeds the limit allowed and cannot be saved.
'//
%ERROR_FILE_TOO_LARGE             = 223&

'//
'// MessageId: ERROR_FORMS_AUTH_REQUIRED
'//
'// MessageText:
'//
'// Access Denied. Before opening files in this location, you must first browse to the web site and select the option to login automatically.
'//
%ERROR_FORMS_AUTH_REQUIRED        = 224&

'//
'// MessageId: ERROR_VIRUS_INFECTED
'//
'// MessageText:
'//
'// Operation did not complete successfully because the file contains a virus.
'//
%ERROR_VIRUS_INFECTED             = 225&

'//
'// MessageId: ERROR_VIRUS_DELETED
'//
'// MessageText:
'//
'// This file contains a virus and cannot be opened. Due to the nature of this virus, the file has been removed from this location.
'//
%ERROR_VIRUS_DELETED              = 226&

'//
'// MessageId: ERROR_PIPE_LOCAL
'//
'// MessageText:
'//
'// The pipe is local.
'//
%ERROR_PIPE_LOCAL                 = 229&

'//
'// MessageId: ERROR_BAD_PIPE
'//
'// MessageText:
'//
'// The pipe state is invalid.
'//
%ERROR_BAD_PIPE                   = 230&

'//
'// MessageId: ERROR_PIPE_BUSY
'//
'// MessageText:
'//
'// All pipe instances are busy.
'//
%ERROR_PIPE_BUSY                  = 231&

'//
'// MessageId: ERROR_NO_DATA
'//
'// MessageText:
'//
'// The pipe is being closed.
'//
%ERROR_NO_DATA                    = 232&

'//
'// MessageId: ERROR_PIPE_NOT_CONNECTED
'//
'// MessageText:
'//
'// No process is on the other end of the pipe.
'//
%ERROR_PIPE_NOT_CONNECTED         = 233&

'//
'// MessageId: ERROR_MORE_DATA
'//
'// MessageText:
'//
'// More data is available.
'//
%ERROR_MORE_DATA                  = 234&    '// dderror

'//
'// MessageId: ERROR_VC_DISCONNECTED
'//
'// MessageText:
'//
'// The session was canceled.
'//
%ERROR_VC_DISCONNECTED            = 240&

'//
'// MessageId: ERROR_INVALID_EA_NAME
'//
'// MessageText:
'//
'// The specified extended attribute name was invalid.
'//
%ERROR_INVALID_EA_NAME            = 254&

'//
'// MessageId: ERROR_EA_LIST_INCONSISTENT
'//
'// MessageText:
'//
'// The extended attributes are inconsistent.
'//
%ERROR_EA_LIST_INCONSISTENT       = 255&

'//
'// MessageId: WAIT_TIMEOUT
'//
'// MessageText:
'//
'// The wait operation timed out.
'//
%WAIT_TIMEOUT                     = 258&    '// dderror

'//
'// MessageId: ERROR_NO_MORE_ITEMS
'//
'// MessageText:
'//
'// No more data is available.
'//
%ERROR_NO_MORE_ITEMS              = 259&

'//
'// MessageId: ERROR_CANNOT_COPY
'//
'// MessageText:
'//
'// The copy functions cannot be used.
'//
%ERROR_CANNOT_COPY                = 266&

'//
'// MessageId: ERROR_DIRECTORY
'//
'// MessageText:
'//
'// The directory name is invalid.
'//
%ERROR_DIRECTORY                  = 267&

'//
'// MessageId: ERROR_EAS_DIDNT_FIT
'//
'// MessageText:
'//
'// The extended attributes did not fit in the buffer.
'//
%ERROR_EAS_DIDNT_FIT              = 275&

'//
'// MessageId: ERROR_EA_FILE_CORRUPT
'//
'// MessageText:
'//
'// The extended attribute file on the mounted file system is corrupt.
'//
%ERROR_EA_FILE_CORRUPT            = 276&

'//
'// MessageId: ERROR_EA_TABLE_FULL
'//
'// MessageText:
'//
'// The extended attribute table file is full.
'//
%ERROR_EA_TABLE_FULL              = 277&

'//
'// MessageId: ERROR_INVALID_EA_HANDLE
'//
'// MessageText:
'//
'// The specified extended attribute handle is invalid.
'//
%ERROR_INVALID_EA_HANDLE          = 278&

'//
'// MessageId: ERROR_EAS_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The mounted file system does not support extended attributes.
'//
%ERROR_EAS_NOT_SUPPORTED          = 282&

'//
'// MessageId: ERROR_NOT_OWNER
'//
'// MessageText:
'//
'// Attempt to release mutex not owned by caller.
'//
%ERROR_NOT_OWNER                  = 288&

'//
'// MessageId: ERROR_TOO_MANY_POSTS
'//
'// MessageText:
'//
'// Too many posts were made to a semaphore.
'//
%ERROR_TOO_MANY_POSTS             = 298&

'//
'// MessageId: ERROR_PARTIAL_COPY
'//
'// MessageText:
'//
'// Only part of a ReadProcessMemory or WriteProcessMemory request was completed.
'//
%ERROR_PARTIAL_COPY               = 299&

'//
'// MessageId: ERROR_OPLOCK_NOT_GRANTED
'//
'// MessageText:
'//
'// The oplock request is denied.
'//
%ERROR_OPLOCK_NOT_GRANTED         = 300&

'//
'// MessageId: ERROR_INVALID_OPLOCK_PROTOCOL
'//
'// MessageText:
'//
'// An invalid oplock acknowledgment was received by the system.
'//
%ERROR_INVALID_OPLOCK_PROTOCOL    = 301&

'//
'// MessageId: ERROR_DISK_TOO_FRAGMENTED
'//
'// MessageText:
'//
'// The volume is too fragmented to complete this operation.
'//
%ERROR_DISK_TOO_FRAGMENTED        = 302&

'//
'// MessageId: ERROR_DELETE_PENDING
'//
'// MessageText:
'//
'// The file cannot be opened because it is in the process of being deleted.
'//
%ERROR_DELETE_PENDING             = 303&

'//
'// MessageId: ERROR_MR_MID_NOT_FOUND
'//
'// MessageText:
'//
'// The system cannot find message text for message number 0x%1 in the message file for %2.
'//
%ERROR_MR_MID_NOT_FOUND           = 317&

'//
'// MessageId: ERROR_SCOPE_NOT_FOUND
'//
'// MessageText:
'//
'// The scope specified was not found.
'//
%ERROR_SCOPE_NOT_FOUND            = 318&

'//
'// MessageId: ERROR_FAIL_NOACTION_REBOOT
'//
'// MessageText:
'//
'// No action was taken as a system reboot is required.
'//
%ERROR_FAIL_NOACTION_REBOOT       = 350&

'//
'// MessageId: ERROR_FAIL_SHUTDOWN
'//
'// MessageText:
'//
'// The shutdown operation failed.
'//
%ERROR_FAIL_SHUTDOWN              = 351&

'//
'// MessageId: ERROR_FAIL_RESTART
'//
'// MessageText:
'//
'// The restart operation failed.
'//
%ERROR_FAIL_RESTART               = 352&

'//
'// MessageId: ERROR_MAX_SESSIONS_REACHED
'//
'// MessageText:
'//
'// The maximum number of sessions has been reached.
'//
%ERROR_MAX_SESSIONS_REACHED       = 353&

'//
'// MessageId: ERROR_THREAD_MODE_ALREADY_BACKGROUND
'//
'// MessageText:
'//
'// The thread is already in background processing mode.
'//
%ERROR_THREAD_MODE_ALREADY_BACKGROUND = 400&

'//
'// MessageId: ERROR_THREAD_MODE_NOT_BACKGROUND
'//
'// MessageText:
'//
'// The thread is not in background processing mode.
'//
%ERROR_THREAD_MODE_NOT_BACKGROUND = 401&

'//
'// MessageId: ERROR_PROCESS_MODE_ALREADY_BACKGROUND
'//
'// MessageText:
'//
'// The process is already in background processing mode.
'//
%ERROR_PROCESS_MODE_ALREADY_BACKGROUND = 402&

'//
'// MessageId: ERROR_PROCESS_MODE_NOT_BACKGROUND
'//
'// MessageText:
'//
'// The process is not in background processing mode.
'//
%ERROR_PROCESS_MODE_NOT_BACKGROUND = 403&

'//
'// MessageId: ERROR_INVALID_ADDRESS
'//
'// MessageText:
'//
'// Attempt to access invalid address.
'//
%ERROR_INVALID_ADDRESS            = 487&

'//
'// MessageId: ERROR_USER_PROFILE_LOAD
'//
'// MessageText:
'//
'// User profile cannot be loaded.
'//
%ERROR_USER_PROFILE_LOAD          = 500&

'//
'// MessageId: ERROR_ARITHMETIC_OVERFLOW
'//
'// MessageText:
'//
'// Arithmetic result exceeded 32 bits.
'//
%ERROR_ARITHMETIC_OVERFLOW        = 534&

'//
'// MessageId: ERROR_PIPE_CONNECTED
'//
'// MessageText:
'//
'// There is a process on other end of the pipe.
'//
%ERROR_PIPE_CONNECTED             = 535&

'//
'// MessageId: ERROR_PIPE_LISTENING
'//
'// MessageText:
'//
'// Waiting for a process to open the other end of the pipe.
'//
%ERROR_PIPE_LISTENING             = 536&

'//
'// MessageId: ERROR_VERIFIER_STOP
'//
'// MessageText:
'//
'// Application verifier has found an error in the current process.
'//
%ERROR_VERIFIER_STOP              = 537&

'//
'// MessageId: ERROR_ABIOS_ERROR
'//
'// MessageText:
'//
'// An error occurred in the ABIOS subsystem.
'//
%ERROR_ABIOS_ERROR                = 538&

'//
'// MessageId: ERROR_WX86_WARNING
'//
'// MessageText:
'//
'// A warning occurred in the WX86 subsystem.
'//
%ERROR_WX86_WARNING               = 539&

'//
'// MessageId: ERROR_WX86_ERROR
'//
'// MessageText:
'//
'// An error occurred in the WX86 subsystem.
'//
%ERROR_WX86_ERROR                 = 540&

'//
'// MessageId: ERROR_TIMER_NOT_CANCELED
'//
'// MessageText:
'//
'// An attempt was made to cancel or set a timer that has an associated APC and the subject thread is not the thread that originally set the timer with an associated APC routine.
'//
%ERROR_TIMER_NOT_CANCELED         = 541&

'//
'// MessageId: ERROR_UNWIND
'//
'// MessageText:
'//
'// Unwind exception code.
'//
%ERROR_UNWIND                     = 542&

'//
'// MessageId: ERROR_BAD_STACK
'//
'// MessageText:
'//
'// An invalid or unaligned stack was encountered during an unwind operation.
'//
%ERROR_BAD_STACK                  = 543&

'//
'// MessageId: ERROR_INVALID_UNWIND_TARGET
'//
'// MessageText:
'//
'// An invalid unwind target was encountered during an unwind operation.
'//
%ERROR_INVALID_UNWIND_TARGET      = 544&

'//
'// MessageId: ERROR_INVALID_PORT_ATTRIBUTES
'//
'// MessageText:
'//
'// Invalid Object Attributes specified to NtCreatePort or invalid Port Attributes specified to NtConnectPort
'//
%ERROR_INVALID_PORT_ATTRIBUTES    = 545&

'//
'// MessageId: ERROR_PORT_MESSAGE_TOO_LONG
'//
'// MessageText:
'//
'// Length of message passed to NtRequestPort or NtRequestWaitReplyPort was longer than the maximum message allowed by the port.
'//
%ERROR_PORT_MESSAGE_TOO_LONG      = 546&

'//
'// MessageId: ERROR_INVALID_QUOTA_LOWER
'//
'// MessageText:
'//
'// An attempt was made to lower a quota limit below the current usage.
'//
%ERROR_INVALID_QUOTA_LOWER        = 547&

'//
'// MessageId: ERROR_DEVICE_ALREADY_ATTACHED
'//
'// MessageText:
'//
'// An attempt was made to attach to a device that was already attached to another device.
'//
%ERROR_DEVICE_ALREADY_ATTACHED    = 548&

'//
'// MessageId: ERROR_INSTRUCTION_MISALIGNMENT
'//
'// MessageText:
'//
'// An attempt was made to execute an instruction at an unaligned address and the host system does not support unaligned instruction references.
'//
%ERROR_INSTRUCTION_MISALIGNMENT   = 549&

'//
'// MessageId: ERROR_PROFILING_NOT_STARTED
'//
'// MessageText:
'//
'// Profiling not started.
'//
%ERROR_PROFILING_NOT_STARTED      = 550&

'//
'// MessageId: ERROR_PROFILING_NOT_STOPPED
'//
'// MessageText:
'//
'// Profiling not stopped.
'//
%ERROR_PROFILING_NOT_STOPPED      = 551&

'//
'// MessageId: ERROR_COULD_NOT_INTERPRET
'//
'// MessageText:
'//
'// The passed ACL did not contain the minimum required information.
'//
%ERROR_COULD_NOT_INTERPRET        = 552&

'//
'// MessageId: ERROR_PROFILING_AT_LIMIT
'//
'// MessageText:
'//
'// The number of active profiling objects is at the maximum and no more may be started.
'//
%ERROR_PROFILING_AT_LIMIT         = 553&

'//
'// MessageId: ERROR_CANT_WAIT
'//
'// MessageText:
'//
'// Used to indicate that an operation cannot continue without blocking for I/O.
'//
%ERROR_CANT_WAIT                  = 554&

'//
'// MessageId: ERROR_CANT_TERMINATE_SELF
'//
'// MessageText:
'//
'// Indicates that a thread attempted to terminate itself by default (called NtTerminateThread with NUL& and it was the last thread in the current process.
'//
%ERROR_CANT_TERMINATE_SELF        = 555&

'//
'// MessageId: ERROR_UNEXPECTED_MM_CREATE_ERR
'//
'// MessageText:
'//
'// If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter.
'// In this case information is lost, however, the filter correctly handles the exception.
'//
%ERROR_UNEXPECTED_MM_CREATE_ERR   = 556&

'//
'// MessageId: ERROR_UNEXPECTED_MM_MAP_ERROR
'//
'// MessageText:
'//
'// If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter.
'// In this case information is lost, however, the filter correctly handles the exception.
'//
%ERROR_UNEXPECTED_MM_MAP_ERROR    = 557&

'//
'// MessageId: ERROR_UNEXPECTED_MM_EXTEND_ERR
'//
'// MessageText:
'//
'// If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter.
'// In this case information is lost, however, the filter correctly handles the exception.
'//
%ERROR_UNEXPECTED_MM_EXTEND_ERR   = 558&

'//
'// MessageId: ERROR_BAD_FUNCTION_TABLE
'//
'// MessageText:
'//
'// A malformed function table was encountered during an unwind operation.
'//
%ERROR_BAD_FUNCTION_TABLE         = 559&

'//
'// MessageId: ERROR_NO_GUID_TRANSLATION
'//
'// MessageText:
'//
'// Indicates that an attempt was made to assign protection to a file system file or directory and one of the SIDs in the security descriptor could not be translated into a GUID that could be stored by the file system.
'// This causes the protection attempt to fail, which may cause a file creation attempt to fail.
'//
%ERROR_NO_GUID_TRANSLATION        = 560&

'//
'// MessageId: ERROR_INVALID_LDT_SIZE
'//
'// MessageText:
'//
'// Indicates that an attempt was made to grow an LDT by setting its size, or that the size was not an even number of selectors.
'//
%ERROR_INVALID_LDT_SIZE           = 561&

'//
'// MessageId: ERROR_INVALID_LDT_OFFSET
'//
'// MessageText:
'//
'// Indicates that the starting value for the LDT information was not an integral multiple of the selector size.
'//
%ERROR_INVALID_LDT_OFFSET         = 563&

'//
'// MessageId: ERROR_INVALID_LDT_DESCRIPTOR
'//
'// MessageText:
'//
'// Indicates that the user supplied an invalid descriptor when trying to set up Ldt descriptors.
'//
%ERROR_INVALID_LDT_DESCRIPTOR     = 564&

'//
'// MessageId: ERROR_TOO_MANY_THREADS
'//
'// MessageText:
'//
'// Indicates a process has too many threads to perform the requested action. For example, assignment of a primary token may only be performed when a process has zero or one threads.
'//
%ERROR_TOO_MANY_THREADS           = 565&

'//
'// MessageId: ERROR_THREAD_NOT_IN_PROCESS
'//
'// MessageText:
'//
'// An attempt was made to operate on a thread within a specific process, but the thread specified is not in the process specified.
'//
%ERROR_THREAD_NOT_IN_PROCESS      = 566&

'//
'// MessageId: ERROR_PAGEFILE_QUOTA_EXCEEDED
'//
'// MessageText:
'//
'// Page file quota was exceeded.
'//
%ERROR_PAGEFILE_QUOTA_EXCEEDED    = 567&

'//
'// MessageId: ERROR_LOGON_SERVER_CONFLICT
'//
'// MessageText:
'//
'// The Netlogon service cannot start because another Netlogon service running in the domain conflicts with the specified role.
'//
%ERROR_LOGON_SERVER_CONFLICT      = 568&

'//
'// MessageId: ERROR_SYNCHRONIZATION_REQUIRED
'//
'// MessageText:
'//
'// The SAM database on a Windows Server is significantly out of synchronization with the copy on the Domain Controller. A complete synchronization is required.
'//
%ERROR_SYNCHRONIZATION_REQUIRED   = 569&

'//
'// MessageId: ERROR_NET_OPEN_FAILED
'//
'// MessageText:
'//
'// The NtCreateFile API failed. This error should never be returned to an application, it is a place holder for the Windows Lan Manager Redirector to use in its internal error mapping routines.
'//
%ERROR_NET_OPEN_FAILED            = 570&

'//
'// MessageId: ERROR_IO_PRIVILEGE_FAILED
'//
'// MessageText:
'//
'// {Privilege Failed}
'// The I/O permissions for the process could not be changed.
'//
%ERROR_IO_PRIVILEGE_FAILED        = 571&

'//
'// MessageId: ERROR_CONTROL_C_EXIT
'//
'// MessageText:
'//
'// {Application Exit by CTRL+C}
'// The application terminated as a result of a CTRL+C.
'//
%ERROR_CONTROL_C_EXIT             = 572&    '// winnt

'//
'// MessageId: ERROR_MISSING_SYSTEMFILE
'//
'// MessageText:
'//
'// {Missing System File}
'// The required system file %hs is bad or missing.
'//
%ERROR_MISSING_SYSTEMFILE         = 573&

'//
'// MessageId: ERROR_UNHANDLED_EXCEPTION
'//
'// MessageText:
'//
'// {Application Error}
'// The exception %s (0x%08&x) occurred in the application at location 0x%08&x.
'//
%ERROR_UNHANDLED_EXCEPTION        = 574&

'//
'// MessageId: ERROR_APP_INIT_FAILURE
'//
'// MessageText:
'//
'// {Application Error}
'// The application failed to initialize properly (0x%lx). Click OK to terminate the application.
'//
%ERROR_APP_INIT_FAILURE           = 575&

'//
'// MessageId: ERROR_PAGEFILE_CREATE_FAILED
'//
'// MessageText:
'//
'// {Unable to Create Paging File}
'// The creation of the paging file %hs failed (%lx). The requested size was %ld.
'//
%ERROR_PAGEFILE_CREATE_FAILED     = 576&

'//
'// MessageId: ERROR_INVALID_IMAGE_HASH
'//
'// MessageText:
'//
'// Windows cannot verify the digital signature for this file. A recent hardware or software change might have installed a file that is signed incorrectly or damaged, or that might be malicious software from an unknown source.
'//
%ERROR_INVALID_IMAGE_HASH         = 577&

'//
'// MessageId: ERROR_NO_PAGEFILE
'//
'// MessageText:
'//
'// {No Paging File Specified}
'// No paging file was specified in the system configuration.
'//
%ERROR_NO_PAGEFILE                = 578&

'//
'// MessageId: ERROR_ILLEGAL_FLOAT_CONTEXT
'//
'// MessageText:
'//
'// {EXCEPTION}
'// A real-mode application issued a floating-point instruction and floating-point hardware is not present.
'//
%ERROR_ILLEGAL_FLOAT_CONTEXT      = 579&

'//
'// MessageId: ERROR_NO_EVENT_PAIR
'//
'// MessageText:
'//
'// An event pair synchronization operation was performed using the thread specific client/server event pair object, but no event pair object was associated with the thread.
'//
%ERROR_NO_EVENT_PAIR              = 580&

'//
'// MessageId: ERROR_DOMAIN_CTRLR_CONFIG_ERROR
'//
'// MessageText:
'//
'// A Windows Server has an incorrect configuration.
'//
%ERROR_DOMAIN_CTRLR_CONFIG_ERROR = 581&

'//
'// MessageId: ERROR_ILLEGAL_CHARACTER
'//
'// MessageText:
'//
'// An illegal character was encountered. For a multi-byte character set this includes a lead byte without a succeeding trail byte. For the Unicode character set this includes the characters 0xFFFF and 0xFFFE.
'//
%ERROR_ILLEGAL_CHARACTER          = 582&

'//
'// MessageId: ERROR_UNDEFINED_CHARACTER
'//
'// MessageText:
'//
'// The Unicode character is not defined in the Unicode character set installed on the system.
'//
%ERROR_UNDEFINED_CHARACTER        = 583&

'//
'// MessageId: ERROR_FLOPPY_VOLUME
'//
'// MessageText:
'//
'// The paging file cannot be created on a floppy diskette.
'//
%ERROR_FLOPPY_VOLUME              = 584&

'//
'// MessageId: ERROR_BIOS_FAILED_TO_CONNECT_INTERRUPT
'//
'// MessageText:
'//
'// The system BIOS failed to connect a system interrupt to the device or bus for which the device is connected.
'//
%ERROR_BIOS_FAILED_TO_CONNECT_INTERRUPT = 585&

'//
'// MessageId: ERROR_BACKUP_CONTROLLER
'//
'// MessageText:
'//
'// This operation is only allowed for the Primary Domain Controller of the domain.
'//
%ERROR_BACKUP_CONTROLLER          = 586&

'//
'// MessageId: ERROR_MUTANT_LIMIT_EXCEEDED
'//
'// MessageText:
'//
'// An attempt was made to acquire a mutant such that its maximum count would have been exceeded.
'//
%ERROR_MUTANT_LIMIT_EXCEEDED      = 587&

'//
'// MessageId: ERROR_FS_DRIVER_REQUIRED
'//
'// MessageText:
'//
'// A volume has been accessed for which a file system driver is required that has not yet been loaded.
'//
%ERROR_FS_DRIVER_REQUIRED         = 588&

'//
'// MessageId: ERROR_CANNOT_LOAD_REGISTRY_FILE
'//
'// MessageText:
'//
'// {Registry File Failure}
'// The registry cannot load the hive (file):
'// %hs
'// or its log or alternate.
'// It is corrupt, absent, or not writable.
'//
%ERROR_CANNOT_LOAD_REGISTRY_FILE = 589&

'//
'// MessageId: ERROR_DEBUG_ATTACH_FAILED
'//
'// MessageText:
'//
'// {Unexpected Failure in DebugActiveProcess}
'// An unexpected failure occurred while processing a DebugActiveProcess API request. You may choose OK to terminate the process, or Cancel to ignore the error.
'//
%ERROR_DEBUG_ATTACH_FAILED        = 590&

'//
'// MessageId: ERROR_SYSTEM_PROCESS_TERMINATED
'//
'// MessageText:
'//
'// {Fatal System Error}
'// The %hs system process terminated unexpectedly with a status of 0x%08x (0x%08x 0x%08x).
'// The system has been shut down.
'//
%ERROR_SYSTEM_PROCESS_TERMINATED  = 591&

'//
'// MessageId: ERROR_DATA_NOT_ACCEPTED
'//
'// MessageText:
'//
'// {Data Not Accepted}
'// The TDI client could not handle the data received during an indication.
'//
%ERROR_DATA_NOT_ACCEPTED          = 592&

'//
'// MessageId: ERROR_VDM_HARD_ERROR
'//
'// MessageText:
'//
'// NTVDM encountered a hard error.
'//
%ERROR_VDM_HARD_ERROR             = 593&

'//
'// MessageId: ERROR_DRIVER_CANCEL_TIMEOUT
'//
'// MessageText:
'//
'// {Cancel Timeout}
'// The driver %hs failed to complete a cancelled I/O request in the allotted time.
'//
%ERROR_DRIVER_CANCEL_TIMEOUT      = 594&

'//
'// MessageId: ERROR_REPLY_MESSAGE_MISMATCH
'//
'// MessageText:
'//
'// {Reply Message Mismatch}
'// An attempt was made to reply to an LPC message, but the thread specified by the client ID in the message was not waiting on that message.
'//
%ERROR_REPLY_MESSAGE_MISMATCH     = 595&

'//
'// MessageId: ERROR_LOST_WRITEBEHIND_DATA
'//
'// MessageText:
'//
'// {Delayed Write Failed}
'// Windows was unable to save all the data for the file %hs. The data has been lost.
'// This error may be caused by a failure of your computer hardware or network connection. Please try to save this file elsewhere.
'//
%ERROR_LOST_WRITEBEHIND_DATA      = 596&

'//
'// MessageId: ERROR_CLIENT_SERVER_PARAMETERS_INVALID
'//
'// MessageText:
'//
'// The parameter(s) passed to the server in the client/server shared memory window were invalid. Too much data may have been put in the shared memory window.
'//
%ERROR_CLIENT_SERVER_PARAMETERS_INVALID = 597&

'//
'// MessageId: ERROR_NOT_TINY_STREAM
'//
'// MessageText:
'//
'// The stream is not a tiny stream.
'//
%ERROR_NOT_TINY_STREAM            = 598&

'//
'// MessageId: ERROR_STACK_OVERFLOW_READ
'//
'// MessageText:
'//
'// The request must be handled by the stack overflow code.
'//
%ERROR_STACK_OVERFLOW_READ        = 599&

'//
'// MessageId: ERROR_CONVERT_TO_LARGE
'//
'// MessageText:
'//
'// Internal OFS status codes indicating how an allocation operation is handled. Either it is retried after the containing onode is moved or the extent stream is converted to a large stream.
'//
%ERROR_CONVERT_TO_LARGE           = 600&

'//
'// MessageId: ERROR_FOUND_OUT_OF_SCOPE
'//
'// MessageText:
'//
'// The attempt to find the object found an object matching by ID on the volume but it is out of the scope of the handle used for the operation.
'//
%ERROR_FOUND_OUT_OF_SCOPE         = 601&

'//
'// MessageId: ERROR_ALLOCATE_BUCKET
'//
'// MessageText:
'//
'// The bucket array must be grown. Retry transaction after doing so.
'//
%ERROR_ALLOCATE_BUCKET            = 602&

'//
'// MessageId: ERROR_MARSHALL_OVERFLOW
'//
'// MessageText:
'//
'// The user/kernel marshalling buffer has overflowed.
'//
%ERROR_MARSHALL_OVERFLOW          = 603&

'//
'// MessageId: ERROR_INVALID_VARIANT
'//
'// MessageText:
'//
'// The supplied variant structure contains invalid data.
'//
%ERROR_INVALID_VARIANT            = 604&

'//
'// MessageId: ERROR_BAD_COMPRESSION_BUFFER
'//
'// MessageText:
'//
'// The specified buffer contains ill-formed data.
'//
%ERROR_BAD_COMPRESSION_BUFFER     = 605&

'//
'// MessageId: ERROR_AUDIT_FAILED
'//
'// MessageText:
'//
'// {Audit Failed}
'// An attempt to generate a security audit failed.
'//
%ERROR_AUDIT_FAILED               = 606&

'//
'// MessageId: ERROR_TIMER_RESOLUTION_NOT_SET
'//
'// MessageText:
'//
'// The timer resolution was not previously set by the current process.
'//
%ERROR_TIMER_RESOLUTION_NOT_SET   = 607&

'//
'// MessageId: ERROR_INSUFFICIENT_LOGON_INFO
'//
'// MessageText:
'//
'// There is insufficient account information to log you on.
'//
%ERROR_INSUFFICIENT_LOGON_INFO    = 608&

'//
'// MessageId: ERROR_BAD_DLL_ENTRYPOINT
'//
'// MessageText:
'//
'// {Invalid DLL Entrypoint}
'// The dynamic link library %hs is not written correctly. The stack pointer has been left in an inconsistent state.
'// The entrypoint should be declared as WINAPI or STDCALL. Select YES to fail the DLL load. Select NO to continue execution. Selecting NO may cause the application to operate incorrectly.
'//
%ERROR_BAD_DLL_ENTRYPOINT         = 609&

'//
'// MessageId: ERROR_BAD_SERVICE_ENTRYPOINT
'//
'// MessageText:
'//
'// {Invalid Service Callback Entrypoint}
'// The %hs service is not written correctly. The stack pointer has been left in an inconsistent state.
'// The callback entrypoint should be declared as WINAPI or STDCALL. Selecting OK will cause the service to continue operation. However, the service process may operate incorrectly.
'//
%ERROR_BAD_SERVICE_ENTRYPOINT     = 610&

'//
'// MessageId: ERROR_IP_ADDRESS_CONFLICT1
'//
'// MessageText:
'//
'// There is an IP address conflict with another system on the network
'//
%ERROR_IP_ADDRESS_CONFLICT1       = 611&

'//
'// MessageId: ERROR_IP_ADDRESS_CONFLICT2
'//
'// MessageText:
'//
'// There is an IP address conflict with another system on the network
'//
%ERROR_IP_ADDRESS_CONFLICT2       = 612&

'//
'// MessageId: ERROR_REGISTRY_QUOTA_LIMIT
'//
'// MessageText:
'//
'// {Low On Registry Space}
'// The system has reached the maximum size allowed for the system part of the registry. Additional storage requests will be ignored.
'//
%ERROR_REGISTRY_QUOTA_LIMIT       = 613&

'//
'// MessageId: ERROR_NO_CALLBACK_ACTIVE
'//
'// MessageText:
'//
'// A callback return system service cannot be executed when no callback is active.
'//
%ERROR_NO_CALLBACK_ACTIVE         = 614&

'//
'// MessageId: ERROR_PWD_TOO_SHORT
'//
'// MessageText:
'//
'// The password provided is too short to meet the policy of your user account.
'// Please choose a longer password.
'//
%ERROR_PWD_TOO_SHORT              = 615&

'//
'// MessageId: ERROR_PWD_TOO_RECENT
'//
'// MessageText:
'//
'// The policy of your user account does not allow you to change passwords too frequently.
'// This is done to prevent users from changing back to a familiar, but potentially discovered, password.
'// If you feel your password has been compromised then please contact your administrator immediately to have a new one assigned.
'//
%ERROR_PWD_TOO_RECENT             = 616&

'//
'// MessageId: ERROR_PWD_HISTORY_CONFLICT
'//
'// MessageText:
'//
'// You have attempted to change your password to one that you have used in the past.
'// The policy of your user account does not allow this. Please select a password that you have not previously used.
'//
%ERROR_PWD_HISTORY_CONFLICT       = 617&

'//
'// MessageId: ERROR_UNSUPPORTED_COMPRESSION
'//
'// MessageText:
'//
'// The specified compression format is unsupported.
'//
%ERROR_UNSUPPORTED_COMPRESSION    = 618&

'//
'// MessageId: ERROR_INVALID_HW_PROFILE
'//
'// MessageText:
'//
'// The specified hardware profile configuration is invalid.
'//
%ERROR_INVALID_HW_PROFILE         = 619&

'//
'// MessageId: ERROR_INVALID_PLUGPLAY_DEVICE_PATH
'//
'// MessageText:
'//
'// The specified Plug and Play registry device path is invalid.
'//
%ERROR_INVALID_PLUGPLAY_DEVICE_PATH = 620&

'//
'// MessageId: ERROR_QUOTA_LIST_INCONSISTENT
'//
'// MessageText:
'//
'// The specified quota list is internally inconsistent with its descriptor.
'//
%ERROR_QUOTA_LIST_INCONSISTENT    = 621&

'//
'// MessageId: ERROR_EVALUATION_EXPIRATION
'//
'// MessageText:
'//
'// {Windows Evaluation Notification}
'// The evaluation period for this installation of Windows has expired. This system will shutdown in 1 hour. To restore access to this installation of Windows, please upgrade this installation using a licensed distribution of this product.
'//
%ERROR_EVALUATION_EXPIRATION      = 622&

'//
'// MessageId: ERROR_ILLEGAL_DLL_RELOCATION
'//
'// MessageText:
'//
'// {Illegal System DLL Relocation}
'// The system DLL %hs was relocated in memory. The application will not run properly.
'// The relocation occurred because the DLL %hs occupied an address range reserved for Windows system DLLs. The vendor supplying the DLL should be contacted for a new DLL.
'//
%ERROR_ILLEGAL_DLL_RELOCATION     = 623&

'//
'// MessageId: ERROR_DLL_INIT_FAILED_LOGOFF
'//
'// MessageText:
'//
'// {DLL Initialization Failed}
'// The application failed to initialize because the window station is shutting down.
'//
%ERROR_DLL_INIT_FAILED_LOGOFF     = 624&

'//
'// MessageId: ERROR_VALIDATE_CONTINUE
'//
'// MessageText:
'//
'// The validation process needs to continue on to the next step.
'//
%ERROR_VALIDATE_CONTINUE          = 625&

'//
'// MessageId: ERROR_NO_MORE_MATCHES
'//
'// MessageText:
'//
'// There are no more matches for the current index enumeration.
'//
%ERROR_NO_MORE_MATCHES            = 626&

'//
'// MessageId: ERROR_RANGE_LIST_CONFLICT
'//
'// MessageText:
'//
'// The range could not be added to the range list because of a conflict.
'//
%ERROR_RANGE_LIST_CONFLICT        = 627&

'//
'// MessageId: ERROR_SERVER_SID_MISMATCH
'//
'// MessageText:
'//
'// The server process is running under a SID different than that required by client.
'//
%ERROR_SERVER_SID_MISMATCH        = 628&

'//
'// MessageId: ERROR_CANT_ENABLE_DENY_ONLY
'//
'// MessageText:
'//
'// A group marked use for deny only  cannot be enabled.
'//
%ERROR_CANT_ENABLE_DENY_ONLY      = 629&

'//
'// MessageId: ERROR_FLOAT_MULTIPLE_FAULTS
'//
'// MessageText:
'//
'// {EXCEPTION}
'// Multiple floating point faults.
'//
%ERROR_FLOAT_MULTIPLE_FAULTS      = 630&    '// winnt

'//
'// MessageId: ERROR_FLOAT_MULTIPLE_TRAPS
'//
'// MessageText:
'//
'// {EXCEPTION}
'// Multiple floating point traps.
'//
%ERROR_FLOAT_MULTIPLE_TRAPS       = 631&    '// winnt

'//
'// MessageId: ERROR_NOINTERFACE
'//
'// MessageText:
'//
'// The requested interface is not supported.
'//
%ERROR_NOINTERFACE                = 632&

'//
'// MessageId: ERROR_DRIVER_FAILED_SLEEP
'//
'// MessageText:
'//
'// {System Standby Failed}
'// The driver %hs does not support standby mode. Updating this driver may allow the system to go to standby mode.
'//
%ERROR_DRIVER_FAILED_SLEEP        = 633&

'//
'// MessageId: ERROR_CORRUPT_SYSTEM_FILE
'//
'// MessageText:
'//
'// The system file %1 has become corrupt and has been replaced.
'//
%ERROR_CORRUPT_SYSTEM_FILE        = 634&

'//
'// MessageId: ERROR_COMMITMENT_MINIMUM
'//
'// MessageText:
'//
'// {Virtual Memory Minimum Too Low}
'// Your system is low on virtual memory. Windows is increasing the size of your virtual memory paging file.
'// During this process, memory requests for some applications may be denied. For more information, see Help.
'//
%ERROR_COMMITMENT_MINIMUM         = 635&

'//
'// MessageId: ERROR_PNP_RESTART_ENUMERATION
'//
'// MessageText:
'//
'// A device was removed so enumeration must be restarted.
'//
%ERROR_PNP_RESTART_ENUMERATION    = 636&

'//
'// MessageId: ERROR_SYSTEM_IMAGE_BAD_SIGNATURE
'//
'// MessageText:
'//
'// {Fatal System Error}
'// The system image %s is not properly signed.
'// The file has been replaced with the signed file.
'// The system has been shut down.
'//
%ERROR_SYSTEM_IMAGE_BAD_SIGNATURE = 637&

'//
'// MessageId: ERROR_PNP_REBOOT_REQUIRED
'//
'// MessageText:
'//
'// Device will not start without a reboot.
'//
%ERROR_PNP_REBOOT_REQUIRED        = 638&

'//
'// MessageId: ERROR_INSUFFICIENT_POWER
'//
'// MessageText:
'//
'// There is not enough power to complete the requested operation.
'//
%ERROR_INSUFFICIENT_POWER         = 639&

'//
'// MessageId: ERROR_MULTIPLE_FAULT_VIOLATION
'//
'// MessageText:
'//
'//  ERROR_MULTIPLE_FAULT_VIOLATION
'//
%ERROR_MULTIPLE_FAULT_VIOLATION   = 640&

'//
'// MessageId: ERROR_SYSTEM_SHUTDOWN
'//
'// MessageText:
'//
'// The system is in the process of shutting down.
'//
%ERROR_SYSTEM_SHUTDOWN            = 641&

'//
'// MessageId: ERROR_PORT_NOT_SET
'//
'// MessageText:
'//
'// An attempt to remove a processes DebugPort was made, but a port was not already associated with the process.
'//
%ERROR_PORT_NOT_SET               = 642&

'//
'// MessageId: ERROR_DS_VERSION_CHECK_FAILURE
'//
'// MessageText:
'//
'// This version of Windows is not compatible with the behavior version of directory forest, domain or domain controller.
'//
%ERROR_DS_VERSION_CHECK_FAILURE   = 643&

'//
'// MessageId: ERROR_RANGE_NOT_FOUND
'//
'// MessageText:
'//
'// The specified range could not be found in the range list.
'//
%ERROR_RANGE_NOT_FOUND            = 644&

'//
'// MessageId: ERROR_NOT_SAFE_MODE_DRIVER
'//
'// MessageText:
'//
'// The driver was not loaded because the system is booting into safe mode.
'//
%ERROR_NOT_SAFE_MODE_DRIVER       = 646&

'//
'// MessageId: ERROR_FAILED_DRIVER_ENTRY
'//
'// MessageText:
'//
'// The driver was not loaded because it failed it's initialization call.
'//
%ERROR_FAILED_DRIVER_ENTRY        = 647&

'//
'// MessageId: ERROR_DEVICE_ENUMERATION_ERROR
'//
'// MessageText:
'//
'// The "%hs" encountered an error while applying power or reading the device configuration.
'// This may be caused by a failure of your hardware or by a poor connection.
'//
%ERROR_DEVICE_ENUMERATION_ERROR   = 648&

'//
'// MessageId: ERROR_MOUNT_POINT_NOT_RESOLVED
'//
'// MessageText:
'//
'// The create operation failed because the name contained at least one mount point which resolves to a volume to which the specified device object is not attached.
'//
%ERROR_MOUNT_POINT_NOT_RESOLVED   = 649&

'//
'// MessageId: ERROR_INVALID_DEVICE_OBJECT_PARAMETER
'//
'// MessageText:
'//
'// The device object parameter is either not a valid device object or is not attached to the volume specified by the file name.
'//
%ERROR_INVALID_DEVICE_OBJECT_PARAMETER = 650&

'//
'// MessageId: ERROR_MCA_OCCURED
'//
'// MessageText:
'//
'// A Machine Check Error has occurred. Please check the system eventlog for additional information.
'//
%ERROR_MCA_OCCURED                = 651&

'//
'// MessageId: ERROR_DRIVER_DATABASE_ERROR
'//
'// MessageText:
'//
'// There was error [%2] processing the driver database.
'//
%ERROR_DRIVER_DATABASE_ERROR      = 652&

'//
'// MessageId: ERROR_SYSTEM_HIVE_TOO_LARGE
'//
'// MessageText:
'//
'// System hive size has exceeded its limit.
'//
%ERROR_SYSTEM_HIVE_TOO_LARGE      = 653&

'//
'// MessageId: ERROR_DRIVER_FAILED_PRIOR_UNLOAD
'//
'// MessageText:
'//
'// The driver could not be loaded because a previous version of the driver is still in memory.
'//
%ERROR_DRIVER_FAILED_PRIOR_UNLOAD = 654&

'//
'// MessageId: ERROR_VOLSNAP_PREPARE_HIBERNATE
'//
'// MessageText:
'//
'// {Volume Shadow Copy Service}
'// Please wait while the Volume Shadow Copy Service prepares volume %hs for hibernation.
'//
%ERROR_VOLSNAP_PREPARE_HIBERNATE  = 655&

'//
'// MessageId: ERROR_HIBERNATION_FAILURE
'//
'// MessageText:
'//
'// The system has failed to hibernate (The error code is %hs). Hibernation will be disabled until the system is restarted.
'//
%ERROR_HIBERNATION_FAILURE        = 656&

'//
'// MessageId: ERROR_FILE_SYSTEM_LIMITATION
'//
'// MessageText:
'//
'// The requested operation could not be completed due to a file system limitation
'//
%ERROR_FILE_SYSTEM_LIMITATION     = 665&

'//
'// MessageId: ERROR_ASSERTION_FAILURE
'//
'// MessageText:
'//
'// An assertion failure has occurred.
'//
%ERROR_ASSERTION_FAILURE          = 668&

'//
'// MessageId: ERROR_ACPI_ERROR
'//
'// MessageText:
'//
'// An error occurred in the ACPI subsystem.
'//
%ERROR_ACPI_ERROR                 = 669&

'//
'// MessageId: ERROR_WOW_ASSERTION
'//
'// MessageText:
'//
'// WOW Assertion Error.
'//
%ERROR_WOW_ASSERTION              = 670&

'//
'// MessageId: ERROR_PNP_BAD_MPS_TABLE
'//
'// MessageText:
'//
'// A device is missing in the system BIOS MPS table. This device will not be used.
'// Please contact your system vendor for system BIOS update.
'//
%ERROR_PNP_BAD_MPS_TABLE          = 671&

'//
'// MessageId: ERROR_PNP_TRANSLATION_FAILED
'//
'// MessageText:
'//
'// A translator failed to translate resources.
'//
%ERROR_PNP_TRANSLATION_FAILED     = 672&

'//
'// MessageId: ERROR_PNP_IRQ_TRANSLATION_FAILED
'//
'// MessageText:
'//
'// A IRQ translator failed to translate resources.
'//
%ERROR_PNP_IRQ_TRANSLATION_FAILED = 673&

'//
'// MessageId: ERROR_PNP_INVALID_ID
'//
'// MessageText:
'//
'// Driver %2 returned invalid ID for a child device (%3).
'//
%ERROR_PNP_INVALID_ID             = 674&

'//
'// MessageId: ERROR_WAKE_SYSTEM_DEBUGGER
'//
'// MessageText:
'//
'// {Kernel Debugger Awakened}
'// the system debugger was awakened by an interrupt.
'//
%ERROR_WAKE_SYSTEM_DEBUGGER       = 675&

'//
'// MessageId: ERROR_HANDLES_CLOSED
'//
'// MessageText:
'//
'// {Handles Closed}
'// Handles to objects have been automatically closed as a result of the requested operation.
'//
%ERROR_HANDLES_CLOSED             = 676&

'//
'// MessageId: ERROR_EXTRANEOUS_INFORMATION
'//
'// MessageText:
'//
'// {Too Much Information}
'// The specified access control list (AC& contained more information than was expected.
'//
%ERROR_EXTRANEOUS_INFORMATION     = 677&

'//
'// MessageId: ERROR_RXACT_COMMIT_NECESSARY
'//
'// MessageText:
'//
'// This warning level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted.
'// The commit has NOT been completed, but has not been rolled back either (so it may still be committed if desired).
'//
%ERROR_RXACT_COMMIT_NECESSARY     = 678&

'//
'// MessageId: ERROR_MEDIA_CHECK
'//
'// MessageText:
'//
'// {Media Changed}
'// The media may have changed.
'//
%ERROR_MEDIA_CHECK                = 679&

'//
'// MessageId: ERROR_GUID_SUBSTITUTION_MADE
'//
'// MessageText:
'//
'// {GUID Substitution}
'// During the translation of a global identifier (GUID) to a Windows security ID (SID), no administratively-defined GUID prefix was found.
'// A substitute prefix was used, which will not compromise system security.
'// However, this may provide a more restrictive access than intended.
'//
%ERROR_GUID_SUBSTITUTION_MADE     = 680&

'//
'// MessageId: ERROR_STOPPED_ON_SYMLINK
'//
'// MessageText:
'//
'// The create operation stopped after reaching a symbolic link
'//
%ERROR_STOPPED_ON_SYMLINK         = 681&

'//
'// MessageId: ERROR_LONGJUMP
'//
'// MessageText:
'//
'// A long jump has been executed.
'//
%ERROR_LONGJUMP                   = 682&

'//
'// MessageId: ERROR_PLUGPLAY_QUERY_VETOED
'//
'// MessageText:
'//
'// The Plug and Play query operation was not successful.
'//
%ERROR_PLUGPLAY_QUERY_VETOED      = 683&

'//
'// MessageId: ERROR_UNWIND_CONSOLIDATE
'//
'// MessageText:
'//
'// A frame consolidation has been executed.
'//
%ERROR_UNWIND_CONSOLIDATE         = 684&

'//
'// MessageId: ERROR_REGISTRY_HIVE_RECOVERED
'//
'// MessageText:
'//
'// {Registry Hive Recovered}
'// Registry hive (file):
'// %hs
'// was corrupted and it has been recovered. Some data might have been lost.
'//
%ERROR_REGISTRY_HIVE_RECOVERED    = 685&

'//
'// MessageId: ERROR_DLL_MIGHT_BE_INSECURE
'//
'// MessageText:
'//
'// The application is attempting to run executable code from the module %hs. This may be insecure. An alternative, %hs, is available. Should the application use the secure module %hs?
'//
%ERROR_DLL_MIGHT_BE_INSECURE      = 686&

'//
'// MessageId: ERROR_DLL_MIGHT_BE_INCOMPATIBLE
'//
'// MessageText:
'//
'// The application is loading executable code from the module %hs. This is secure, but may be incompatible with previous releases of the operating system. An alternative, %hs, is available. Should the application use the secure module %hs?
'//
%ERROR_DLL_MIGHT_BE_INCOMPATIBLE  = 687&

'//
'// MessageId: ERROR_DBG_EXCEPTION_NOT_HANDLED
'//
'// MessageText:
'//
'// Debugger did not handle the exception.
'//
%ERROR_DBG_EXCEPTION_NOT_HANDLED  = 688&    '// winnt

'//
'// MessageId: ERROR_DBG_REPLY_LATER
'//
'// MessageText:
'//
'// Debugger will reply later.
'//
%ERROR_DBG_REPLY_LATER            = 689&

'//
'// MessageId: ERROR_DBG_UNABLE_TO_PROVIDE_HANDLE
'//
'// MessageText:
'//
'// Debugger cannot provide handle.
'//
%ERROR_DBG_UNABLE_TO_PROVIDE_HANDLE = 690&

'//
'// MessageId: ERROR_DBG_TERMINATE_THREAD
'//
'// MessageText:
'//
'// Debugger terminated thread.
'//
%ERROR_DBG_TERMINATE_THREAD       = 691&    '// winnt

'//
'// MessageId: ERROR_DBG_TERMINATE_PROCESS
'//
'// MessageText:
'//
'// Debugger terminated process.
'//
%ERROR_DBG_TERMINATE_PROCESS      = 692&    '// winnt

'//
'// MessageId: ERROR_DBG_CONTROL_C
'//
'// MessageText:
'//
'// Debugger got control C.
'//
%ERROR_DBG_CONTROL_C              = 693&    '// winnt

'//
'// MessageId: ERROR_DBG_PRINTEXCEPTION_C
'//
'// MessageText:
'//
'// Debugger printed exception on control C.
'//
%ERROR_DBG_PRINTEXCEPTION_C       = 694&

'//
'// MessageId: ERROR_DBG_RIPEXCEPTION
'//
'// MessageText:
'//
'// Debugger received RIP exception.
'//
%ERROR_DBG_RIPEXCEPTION           = 695&

'//
'// MessageId: ERROR_DBG_CONTROL_BREAK
'//
'// MessageText:
'//
'// Debugger received control break.
'//
%ERROR_DBG_CONTROL_BREAK          = 696&    '// winnt

'//
'// MessageId: ERROR_DBG_COMMAND_EXCEPTION
'//
'// MessageText:
'//
'// Debugger command communication exception.
'//
%ERROR_DBG_COMMAND_EXCEPTION      = 697&    '// winnt

'//
'// MessageId: ERROR_OBJECT_NAME_EXISTS
'//
'// MessageText:
'//
'// {Object Exists}
'// An attempt was made to create an object and the object name already existed.
'//
%ERROR_OBJECT_NAME_EXISTS         = 698&

'//
'// MessageId: ERROR_THREAD_WAS_SUSPENDED
'//
'// MessageText:
'//
'// {Thread Suspended}
'// A thread termination occurred while the thread was suspended. The thread was resumed, and termination proceeded.
'//
%ERROR_THREAD_WAS_SUSPENDED       = 699&

'//
'// MessageId: ERROR_IMAGE_NOT_AT_BASE
'//
'// MessageText:
'//
'// {Image Relocated}
'// An image file could not be mapped at the address specified in the image file. Local fixups must be performed on this image.
'//
%ERROR_IMAGE_NOT_AT_BASE          = 700&

'//
'// MessageId: ERROR_RXACT_STATE_CREATED
'//
'// MessageText:
'//
'// This informational level status indicates that a specified registry sub-tree transaction state did not yet exist and had to be created.
'//
%ERROR_RXACT_STATE_CREATED        = 701&

'//
'// MessageId: ERROR_SEGMENT_NOTIFICATION
'//
'// MessageText:
'//
'// {Segment Load}
'// A virtual DOS machine (VDM) is loading, unloading, or moving an MS-DOS or Win16 program segment image.
'// An exception is raised so a debugger can load, unload or track symbols and breakpoints within these 16-bit segments.
'//
%ERROR_SEGMENT_NOTIFICATION       = 702&    '// winnt

'//
'// MessageId: ERROR_BAD_CURRENT_DIRECTORY
'//
'// MessageText:
'//
'// {Invalid Current Directory}
'// The process cannot switch to the startup current directory %hs.
'// Select OK to set current directory to %hs, or select CANCEL to exit.
'//
%ERROR_BAD_CURRENT_DIRECTORY      = 703&

'//
'// MessageId: ERROR_FT_READ_RECOVERY_FROM_BACKUP
'//
'// MessageText:
'//
'// {Redundant Read}
'// To satisfy a read request, the NT fault-tolerant file system successfully read the requested data from a redundant copy.
'// This was done because the file system encountered a failure on a member of the fault-tolerant volume, but was unable to reassign the failing area of the device.
'//
%ERROR_FT_READ_RECOVERY_FROM_BACKUP = 704&

'//
'// MessageId: ERROR_FT_WRITE_RECOVERY
'//
'// MessageText:
'//
'// {Redundant Write}
'// To satisfy a write request, the NT fault-tolerant file system successfully wrote a redundant copy of the information.
'// This was done because the file system encountered a failure on a member of the fault-tolerant volume, but was not able to reassign the failing area of the device.
'//
%ERROR_FT_WRITE_RECOVERY          = 705&

'//
'// MessageId: ERROR_IMAGE_MACHINE_TYPE_MISMATCH
'//
'// MessageText:
'//
'// {Machine Type Mismatch}
'// The image file %hs is valid, but is for a machine type other than the current machine. Select OK to continue, or CANCEL to fail the DLL load.
'//
%ERROR_IMAGE_MACHINE_TYPE_MISMATCH = 706&

'//
'// MessageId: ERROR_RECEIVE_PARTIAL
'//
'// MessageText:
'//
'// {Partial Data Received}
'// The network transport returned partial data to its client. The remaining data will be sent later.
'//
%ERROR_RECEIVE_PARTIAL            = 707&

'//
'// MessageId: ERROR_RECEIVE_EXPEDITED
'//
'// MessageText:
'//
'// {Expedited Data Received}
'// The network transport returned data to its client that was marked as expedited by the remote system.
'//
%ERROR_RECEIVE_EXPEDITED          = 708&

'//
'// MessageId: ERROR_RECEIVE_PARTIAL_EXPEDITED
'//
'// MessageText:
'//
'// {Partial Expedited Data Received}
'// The network transport returned partial data to its client and this data was marked as expedited by the remote system. The remaining data will be sent later.
'//
%ERROR_RECEIVE_PARTIAL_EXPEDITED  = 709&

'//
'// MessageId: ERROR_EVENT_DONE
'//
'// MessageText:
'//
'// {TDI Event Done}
'// The TDI indication has completed successfully.
'//
%ERROR_EVENT_DONE                 = 710&

'//
'// MessageId: ERROR_EVENT_PENDING
'//
'// MessageText:
'//
'// {TDI Event Pending}
'// The TDI indication has entered the pending state.
'//
%ERROR_EVENT_PENDING              = 711&

'//
'// MessageId: ERROR_CHECKING_FILE_SYSTEM
'//
'// MessageText:
'//
'// Checking file system on %wZ
'//
%ERROR_CHECKING_FILE_SYSTEM       = 712&

'//
'// MessageId: ERROR_FATAL_APP_EXIT
'//
'// MessageText:
'//
'// {Fatal Application Exit}
'// %hs
'//
%ERROR_FATAL_APP_EXIT             = 713&

'//
'// MessageId: ERROR_PREDEFINED_HANDLE
'//
'// MessageText:
'//
'// The specified registry key is referenced by a predefined handle.
'//
%ERROR_PREDEFINED_HANDLE          = 714&

'//
'// MessageId: ERROR_WAS_UNLOCKED
'//
'// MessageText:
'//
'// {Page Unlocked}
'// The page protection of a locked page was changed to 'No Access' and the page was unlocked from memory and from the process.
'//
%ERROR_WAS_UNLOCKED               = 715&

'//
'// MessageId: ERROR_SERVICE_NOTIFICATION
'//
'// MessageText:
'//
'// %hs
'//
%ERROR_SERVICE_NOTIFICATION       = 716&

'//
'// MessageId: ERROR_WAS_LOCKED
'//
'// MessageText:
'//
'// {Page Locked}
'// One of the pages to lock was already locked.
'//
%ERROR_WAS_LOCKED                 = 717&

'//
'// MessageId: ERROR_LOG_HARD_ERROR
'//
'// MessageText:
'//
'// Application popup: %1 : %2
'//
%ERROR_LOG_HARD_ERROR             = 718&

'//
'// MessageId: ERROR_ALREADY_WIN32
'//
'// MessageText:
'//
'//  ERROR_ALREADY_WIN32
'//
%ERROR_ALREADY_WIN32              = 719&

'//
'// MessageId: ERROR_IMAGE_MACHINE_TYPE_MISMATCH_EXE
'//
'// MessageText:
'//
'// {Machine Type Mismatch}
'// The image file %hs is valid, but is for a machine type other than the current machine.
'//
%ERROR_IMAGE_MACHINE_TYPE_MISMATCH_EXE = 720&

'//
'// MessageId: ERROR_NO_YIELD_PERFORMED
'//
'// MessageText:
'//
'// A yield execution was performed and no thread was available to run.
'//
%ERROR_NO_YIELD_PERFORMED         = 721&

'//
'// MessageId: ERROR_TIMER_RESUME_IGNORED
'//
'// MessageText:
'//
'// The resumable flag to a timer API was ignored.
'//
%ERROR_TIMER_RESUME_IGNORED       = 722&

'//
'// MessageId: ERROR_ARBITRATION_UNHANDLED
'//
'// MessageText:
'//
'// The arbiter has deferred arbitration of these resources to its parent
'//
%ERROR_ARBITRATION_UNHANDLED      = 723&

'//
'// MessageId: ERROR_CARDBUS_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The inserted CardBus device cannot be started because of a configuration error on "%hs".
'//
%ERROR_CARDBUS_NOT_SUPPORTED      = 724&

'//
'// MessageId: ERROR_MP_PROCESSOR_MISMATCH
'//
'// MessageText:
'//
'// The CPUs in this multiprocessor system are not all the same revision level. To use all processors the operating system restricts itself to the features of the least capable processor in the system.
'// Should problems occur with this system, contact the CPU manufacturer to see if this mix of processors is supported.
'//
%ERROR_MP_PROCESSOR_MISMATCH      = 725&

'//
'// MessageId: ERROR_HIBERNATED
'//
'// MessageText:
'//
'// The system was put into hibernation.
'//
%ERROR_HIBERNATED                 = 726&

'//
'// MessageId: ERROR_RESUME_HIBERNATION
'//
'// MessageText:
'//
'// The system was resumed from hibernation.
'//
%ERROR_RESUME_HIBERNATION         = 727&

'//
'// MessageId: ERROR_FIRMWARE_UPDATED
'//
'// MessageText:
'//
'// Windows has detected that the system firmware (BIOS) was updated [previous firmware date = %2, current firmware date %3].
'//
%ERROR_FIRMWARE_UPDATED           = 728&

'//
'// MessageId: ERROR_DRIVERS_LEAKING_LOCKED_PAGES
'//
'// MessageText:
'//
'// A device driver is leaking locked I/O pages causing system degradation. The system has automatically enabled tracking code in order to try and catch the culprit.
'//
%ERROR_DRIVERS_LEAKING_LOCKED_PAGES = 729&

'//
'// MessageId: ERROR_WAKE_SYSTEM
'//
'// MessageText:
'//
'// The system has awoken
'//
%ERROR_WAKE_SYSTEM                = 730&

'//
'// MessageId: ERROR_WAIT_1
'//
'// MessageText:
'//
'//  ERROR_WAIT_1
'//
%ERROR_WAIT_1                     = 731&

'//
'// MessageId: ERROR_WAIT_2
'//
'// MessageText:
'//
'//  ERROR_WAIT_2
'//
%ERROR_WAIT_2                     = 732&

'//
'// MessageId: ERROR_WAIT_3
'//
'// MessageText:
'//
'//  ERROR_WAIT_3
'//
%ERROR_WAIT_3                     = 733&

'//
'// MessageId: ERROR_WAIT_63
'//
'// MessageText:
'//
'//  ERROR_WAIT_63
'//
%ERROR_WAIT_63                    = 734&

'//
'// MessageId: ERROR_ABANDONED_WAIT_0
'//
'// MessageText:
'//
'//  ERROR_ABANDONED_WAIT_0
'//
%ERROR_ABANDONED_WAIT_0           = 735&    '// winnt

'//
'// MessageId: ERROR_ABANDONED_WAIT_63
'//
'// MessageText:
'//
'//  ERROR_ABANDONED_WAIT_63
'//
%ERROR_ABANDONED_WAIT_63          = 736&

'//
'// MessageId: ERROR_USER_APC
'//
'// MessageText:
'//
'//  ERROR_USER_APC
'//
%ERROR_USER_APC                   = 737&    '// winnt

'//
'// MessageId: ERROR_KERNEL_APC
'//
'// MessageText:
'//
'//  ERROR_KERNEL_APC
'//
%ERROR_KERNEL_APC                 = 738&

'//
'// MessageId: ERROR_ALERTED
'//
'// MessageText:
'//
'//  ERROR_ALERTED
'//
%ERROR_ALERTED                    = 739&

'//
'// MessageId: ERROR_ELEVATION_REQUIRED
'//
'// MessageText:
'//
'// The requested operation requires elevation.
'//
%ERROR_ELEVATION_REQUIRED         = 740&

'//
'// MessageId: ERROR_REPARSE
'//
'// MessageText:
'//
'// A reparse should be performed by the Object Manager since the name of the file resulted in a symbolic link.
'//
%ERROR_REPARSE                    = 741&

'//
'// MessageId: ERROR_OPLOCK_BREAK_IN_PROGRESS
'//
'// MessageText:
'//
'// An open/create operation completed while an oplock break is underway.
'//
%ERROR_OPLOCK_BREAK_IN_PROGRESS   = 742&

'//
'// MessageId: ERROR_VOLUME_MOUNTED
'//
'// MessageText:
'//
'// A new volume has been mounted by a file system.
'//
%ERROR_VOLUME_MOUNTED             = 743&

'//
'// MessageId: ERROR_RXACT_COMMITTED
'//
'// MessageText:
'//
'// This success level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted.
'// The commit has now been completed.
'//
%ERROR_RXACT_COMMITTED            = 744&

'//
'// MessageId: ERROR_NOTIFY_CLEANUP
'//
'// MessageText:
'//
'// This indicates that a notify change request has been completed due to closing the handle which made the notify change request.
'//
%ERROR_NOTIFY_CLEANUP             = 745&

'//
'// MessageId: ERROR_PRIMARY_TRANSPORT_CONNECT_FAILED
'//
'// MessageText:
'//
'// {Connect Failure on Primary Transport}
'// An attempt was made to connect to the remote server %hs on the primary transport, but the connection failed.
'// The computer WAS able to connect on a secondary transport.
'//
%ERROR_PRIMARY_TRANSPORT_CONNECT_FAILED = 746&

'//
'// MessageId: ERROR_PAGE_FAULT_TRANSITION
'//
'// MessageText:
'//
'// Page fault was a transition fault.
'//
%ERROR_PAGE_FAULT_TRANSITION      = 747&

'//
'// MessageId: ERROR_PAGE_FAULT_DEMAND_ZERO
'//
'// MessageText:
'//
'// Page fault was a demand zero fault.
'//
%ERROR_PAGE_FAULT_DEMAND_ZERO     = 748&

'//
'// MessageId: ERROR_PAGE_FAULT_COPY_ON_WRITE
'//
'// MessageText:
'//
'// Page fault was a demand zero fault.
'//
%ERROR_PAGE_FAULT_COPY_ON_WRITE   = 749&

'//
'// MessageId: ERROR_PAGE_FAULT_GUARD_PAGE
'//
'// MessageText:
'//
'// Page fault was a demand zero fault.
'//
%ERROR_PAGE_FAULT_GUARD_PAGE      = 750&

'//
'// MessageId: ERROR_PAGE_FAULT_PAGING_FILE
'//
'// MessageText:
'//
'// Page fault was satisfied by reading from a secondary storage device.
'//
%ERROR_PAGE_FAULT_PAGING_FILE     = 751&

'//
'// MessageId: ERROR_CACHE_PAGE_LOCKED
'//
'// MessageText:
'//
'// Cached page was locked during operation.
'//
%ERROR_CACHE_PAGE_LOCKED          = 752&

'//
'// MessageId: ERROR_CRASH_DUMP
'//
'// MessageText:
'//
'// Crash dump exists in paging file.
'//
%ERROR_CRASH_DUMP                 = 753&

'//
'// MessageId: ERROR_BUFFER_ALL_ZEROS
'//
'// MessageText:
'//
'// Specified buffer contains all zeros.
'//
%ERROR_BUFFER_ALL_ZEROS           = 754&

'//
'// MessageId: ERROR_REPARSE_OBJECT
'//
'// MessageText:
'//
'// A reparse should be performed by the Object Manager since the name of the file resulted in a symbolic link.
'//
%ERROR_REPARSE_OBJECT             = 755&

'//
'// MessageId: ERROR_RESOURCE_REQUIREMENTS_CHANGED
'//
'// MessageText:
'//
'// The device has succeeded a query-stop and its resource requirements have changed.
'//
%ERROR_RESOURCE_REQUIREMENTS_CHANGED = 756&

'//
'// MessageId: ERROR_TRANSLATION_COMPLETE
'//
'// MessageText:
'//
'// The translator has translated these resources into the global space and no further translations should be performed.
'//
%ERROR_TRANSLATION_COMPLETE       = 757&

'//
'// MessageId: ERROR_NOTHING_TO_TERMINATE
'//
'// MessageText:
'//
'// A process being terminated has no threads to terminate.
'//
%ERROR_NOTHING_TO_TERMINATE       = 758&

'//
'// MessageId: ERROR_PROCESS_NOT_IN_JOB
'//
'// MessageText:
'//
'// The specified process is not part of a job.
'//
%ERROR_PROCESS_NOT_IN_JOB         = 759&

'//
'// MessageId: ERROR_PROCESS_IN_JOB
'//
'// MessageText:
'//
'// The specified process is part of a job.
'//
%ERROR_PROCESS_IN_JOB             = 760&

'//
'// MessageId: ERROR_VOLSNAP_HIBERNATE_READY
'//
'// MessageText:
'//
'// {Volume Shadow Copy Service}
'// The system is now ready for hibernation.
'//
%ERROR_VOLSNAP_HIBERNATE_READY    = 761&

'//
'// MessageId: ERROR_FSFILTER_OP_COMPLETED_SUCCESSFULLY
'//
'// MessageText:
'//
'// A file system or file system filter driver has successfully completed an FsFilter operation.
'//
%ERROR_FSFILTER_OP_COMPLETED_SUCCESSFULLY = 762&

'//
'// MessageId: ERROR_INTERRUPT_VECTOR_ALREADY_CONNECTED
'//
'// MessageText:
'//
'// The specified interrupt vector was already connected.
'//
%ERROR_INTERRUPT_VECTOR_ALREADY_CONNECTED = 763&

'//
'// MessageId: ERROR_INTERRUPT_STILL_CONNECTED
'//
'// MessageText:
'//
'// The specified interrupt vector is still connected.
'//
%ERROR_INTERRUPT_STILL_CONNECTED  = 764&

'//
'// MessageId: ERROR_WAIT_FOR_OPLOCK
'//
'// MessageText:
'//
'// An operation is blocked waiting for an oplock.
'//
%ERROR_WAIT_FOR_OPLOCK            = 765&

'//
'// MessageId: ERROR_DBG_EXCEPTION_HANDLED
'//
'// MessageText:
'//
'// Debugger handled exception
'//
%ERROR_DBG_EXCEPTION_HANDLED      = 766&    '// winnt

'//
'// MessageId: ERROR_DBG_CONTINUE
'//
'// MessageText:
'//
'// Debugger continued
'//
%ERROR_DBG_CONTINUE               = 767&    '// winnt

'//
'// MessageId: ERROR_CALLBACK_POP_STACK
'//
'// MessageText:
'//
'// An exception occurred in a user mode callback and the kernel callback frame should be removed.
'//
%ERROR_CALLBACK_POP_STACK         = 768&

'//
'// MessageId: ERROR_COMPRESSION_DISABLED
'//
'// MessageText:
'//
'// Compression is disabled for this volume.
'//
%ERROR_COMPRESSION_DISABLED       = 769&

'//
'// MessageId: ERROR_CANTFETCHBACKWARDS
'//
'// MessageText:
'//
'// The data provider cannot fetch backwards through a result set.
'//
%ERROR_CANTFETCHBACKWARDS         = 770&

'//
'// MessageId: ERROR_CANTSCROLLBACKWARDS
'//
'// MessageText:
'//
'// The data provider cannot scroll backwards through a result set.
'//
%ERROR_CANTSCROLLBACKWARDS        = 771&

'//
'// MessageId: ERROR_ROWSNOTRELEASED
'//
'// MessageText:
'//
'// The data provider requires that previously fetched data is released before asking for more data.
'//
%ERROR_ROWSNOTRELEASED            = 772&

'//
'// MessageId: ERROR_BAD_ACCESSOR_FLAGS
'//
'// MessageText:
'//
'// The data provider was not able to intrepret the flags set for a column binding in an accessor.
'//
%ERROR_BAD_ACCESSOR_FLAGS         = 773&

'//
'// MessageId: ERROR_ERRORS_ENCOUNTERED
'//
'// MessageText:
'//
'// One or more errors occurred while processing the request.
'//
%ERROR_ERRORS_ENCOUNTERED         = 774&

'//
'// MessageId: ERROR_NOT_CAPABLE
'//
'// MessageText:
'//
'// The implementation is not capable of performing the request.
'//
%ERROR_NOT_CAPABLE                = 775&

'//
'// MessageId: ERROR_REQUEST_OUT_OF_SEQUENCE
'//
'// MessageText:
'//
'// The client of a component requested an operation which is not valid given the state of the component instance.
'//
%ERROR_REQUEST_OUT_OF_SEQUENCE    = 776&

'//
'// MessageId: ERROR_VERSION_PARSE_ERROR
'//
'// MessageText:
'//
'// A version number could not be parsed.
'//
%ERROR_VERSION_PARSE_ERROR        = 777&

'//
'// MessageId: ERROR_BADSTARTPOSITION
'//
'// MessageText:
'//
'// The iterator's start position is invalid.
'//
%ERROR_BADSTARTPOSITION           = 778&

'//
'// MessageId: ERROR_MEMORY_HARDWARE
'//
'// MessageText:
'//
'// The hardware has reported an uncorrectable memory error.
'//
%ERROR_MEMORY_HARDWARE            = 779&

'//
'// MessageId: ERROR_DISK_REPAIR_DISABLED
'//
'// MessageText:
'//
'// The attempted operation required self healing to be enabled.
'//
%ERROR_DISK_REPAIR_DISABLED       = 780&

'//
'// MessageId: ERROR_INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE
'//
'// MessageText:
'//
'// The Desktop heap encountered an error while allocating session memory.
'// There is more information in the system event log.
'//
%ERROR_INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE = 781&

'//
'// MessageId: ERROR_SYSTEM_POWERSTATE_TRANSITION
'//
'// MessageText:
'//
'// The system powerstate is transitioning from %2 to %3.
'//
%ERROR_SYSTEM_POWERSTATE_TRANSITION = 782&

'//
'// MessageId: ERROR_SYSTEM_POWERSTATE_COMPLEX_TRANSITION
'//
'// MessageText:
'//
'// The system powerstate is transitioning from %2 to %3 but could enter %4.
'//
%ERROR_SYSTEM_POWERSTATE_COMPLEX_TRANSITION = 783&

'//
'// MessageId: ERROR_MCA_EXCEPTION
'//
'// MessageText:
'//
'// A thread is getting dispatched with MCA EXCEPTION because of MCA.
'//
%ERROR_MCA_EXCEPTION              = 784&

'//
'// MessageId: ERROR_ACCESS_AUDIT_BY_POLICY
'//
'// MessageText:
'//
'// Access to %1 is monitored by policy rule %2.
'//
%ERROR_ACCESS_AUDIT_BY_POLICY     = 785&

'//
'// MessageId: ERROR_ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY
'//
'// MessageText:
'//
'// Access to %1 has been restricted by your Administrator by policy rule %2.
'//
%ERROR_ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY = 786&

'//
'// MessageId: ERROR_ABANDON_HIBERFILE
'//
'// MessageText:
'//
'// A valid hibernation file has been invalidated and should be abandoned.
'//
%ERROR_ABANDON_HIBERFILE          = 787&

'//
'// MessageId: ERROR_LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED
'//
'// MessageText:
'//
'// {Delayed Write Failed}
'// Windows was unable to save all the data for the file %hs; the data has been lost.
'// This error may be caused by network connectivity issues. Please try to save this file elsewhere.
'//
%ERROR_LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED = 788&

'//
'// MessageId: ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR
'//
'// MessageText:
'//
'// {Delayed Write Failed}
'// Windows was unable to save all the data for the file %hs; the data has been lost.
'// This error was returned by the server on which the file exists. Please try to save this file elsewhere.
'//
%ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR = 789&

'//
'// MessageId: ERROR_LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR
'//
'// MessageText:
'//
'// {Delayed Write Failed}
'// Windows was unable to save all the data for the file %hs; the data has been lost.
'// This error may be caused if the device has been removed or the media is write-protected.
'//
%ERROR_LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR = 790&

'//
'// MessageId: ERROR_BAD_MCFG_TABLE
'//
'// MessageText:
'//
'// The resources required for this device conflict with the MCFG table.
'//
%ERROR_BAD_MCFG_TABLE             = 791&

'//
'// MessageId: ERROR_EA_ACCESS_DENIED
'//
'// MessageText:
'//
'// Access to the extended attribute was denied.
'//
%ERROR_EA_ACCESS_DENIED           = 994&

'//
'// MessageId: ERROR_OPERATION_ABORTED
'//
'// MessageText:
'//
'// The I/O operation has been aborted because of either a thread exit or an application request.
'//
%ERROR_OPERATION_ABORTED          = 995&

'//
'// MessageId: ERROR_IO_INCOMPLETE
'//
'// MessageText:
'//
'// Overlapped I/O event is not in a signaled state.
'//
%ERROR_IO_INCOMPLETE              = 996&

'//
'// MessageId: ERROR_IO_PENDING
'//
'// MessageText:
'//
'// Overlapped I/O operation is in progress.
'//
%ERROR_IO_PENDING                 = 997&    '// dderror

'//
'// MessageId: ERROR_NOACCESS
'//
'// MessageText:
'//
'// Invalid access to memory location.
'//
%ERROR_NOACCESS                   = 998&

'//
'// MessageId: ERROR_SWAPERROR
'//
'// MessageText:
'//
'// Error performing inpage operation.
'//
%ERROR_SWAPERROR                  = 999&

'//
'// MessageId: ERROR_STACK_OVERFLOW
'//
'// MessageText:
'//
'// Recursion too deep; the stack overflowed.
'//
%ERROR_STACK_OVERFLOW             = 1001&

'//
'// MessageId: ERROR_INVALID_MESSAGE
'//
'// MessageText:
'//
'// The window cannot act on the sent message.
'//
%ERROR_INVALID_MESSAGE            = 1002&

'//
'// MessageId: ERROR_CAN_NOT_COMPLETE
'//
'// MessageText:
'//
'// Cannot complete this function.
'//
%ERROR_CAN_NOT_COMPLETE           = 1003&

'//
'// MessageId: ERROR_INVALID_FLAGS
'//
'// MessageText:
'//
'// Invalid flags.
'//
%ERROR_INVALID_FLAGS              = 1004&

'//
'// MessageId: ERROR_UNRECOGNIZED_VOLUME
'//
'// MessageText:
'//
'// The volume does not contain a recognized file system.
'// Please make sure that all required file system drivers are loaded and that the volume is not corrupted.
'//
%ERROR_UNRECOGNIZED_VOLUME        = 1005&

'//
'// MessageId: ERROR_FILE_INVALID
'//
'// MessageText:
'//
'// The volume for a file has been externally altered so that the opened file is no longer valid.
'//
%ERROR_FILE_INVALID               = 1006&

'//
'// MessageId: ERROR_FULLSCREEN_MODE
'//
'// MessageText:
'//
'// The requested operation cannot be performed in full-screen mode.
'//
%ERROR_FULLSCREEN_MODE            = 1007&

'//
'// MessageId: ERROR_NO_TOKEN
'//
'// MessageText:
'//
'// An attempt was made to reference a token that does not exist.
'//
%ERROR_NO_TOKEN                   = 1008&

'//
'// MessageId: ERROR_BADDB
'//
'// MessageText:
'//
'// The configuration registry database is corrupt.
'//
%ERROR_BADDB                      = 1009&

'//
'// MessageId: ERROR_BADKEY
'//
'// MessageText:
'//
'// The configuration registry key is invalid.
'//
%ERROR_BADKEY                     = 1010&

'//
'// MessageId: ERROR_CANTOPEN
'//
'// MessageText:
'//
'// The configuration registry key could not be opened.
'//
%ERROR_CANTOPEN                   = 1011&

'//
'// MessageId: ERROR_CANTREAD
'//
'// MessageText:
'//
'// The configuration registry key could not be read.
'//
%ERROR_CANTREAD                   = 1012&

'//
'// MessageId: ERROR_CANTWRITE
'//
'// MessageText:
'//
'// The configuration registry key could not be written.
'//
%ERROR_CANTWRITE                  = 1013&

'//
'// MessageId: ERROR_REGISTRY_RECOVERED
'//
'// MessageText:
'//
'// One of the files in the registry database had to be recovered by use of a log or alternate copy. The recovery was successful.
'//
%ERROR_REGISTRY_RECOVERED         = 1014&

'//
'// MessageId: ERROR_REGISTRY_CORRUPT
'//
'// MessageText:
'//
'// The registry is corrupted. The structure of one of the files containing registry data is corrupted, or the system's memory image of the file is corrupted, or the file could not be recovered because the alternate copy or log was absent or corrupted.
'//
%ERROR_REGISTRY_CORRUPT           = 1015&

'//
'// MessageId: ERROR_REGISTRY_IO_FAILED
'//
'// MessageText:
'//
'// An I/O operation initiated by the registry failed unrecoverably. The registry could not read in, or write out, or flush, one of the files that contain the system's image of the registry.
'//
%ERROR_REGISTRY_IO_FAILED         = 1016&

'//
'// MessageId: ERROR_NOT_REGISTRY_FILE
'//
'// MessageText:
'//
'// The system has attempted to load or restore a file into the registry, but the specified file is not in a registry file format.
'//
%ERROR_NOT_REGISTRY_FILE          = 1017&

'//
'// MessageId: ERROR_KEY_DELETED
'//
'// MessageText:
'//
'// Illegal operation attempted on a registry key that has been marked for deletion.
'//
%ERROR_KEY_DELETED                = 1018&

'//
'// MessageId: ERROR_NO_LOG_SPACE
'//
'// MessageText:
'//
'// System could not allocate the required space in a registry log.
'//
%ERROR_NO_LOG_SPACE               = 1019&

'//
'// MessageId: ERROR_KEY_HAS_CHILDREN
'//
'// MessageText:
'//
'// Cannot create a symbolic link in a registry key that already has subkeys or values.
'//
%ERROR_KEY_HAS_CHILDREN           = 1020&

'//
'// MessageId: ERROR_CHILD_MUST_BE_VOLATILE
'//
'// MessageText:
'//
'// Cannot create a stable subkey under a volatile parent key.
'//
%ERROR_CHILD_MUST_BE_VOLATILE     = 1021&

'//
'// MessageId: ERROR_NOTIFY_ENUM_DIR
'//
'// MessageText:
'//
'// A notify change request is being completed and the information is not being returned in the caller's buffer. The caller now needs to enumerate the files to find the changes.
'//
%ERROR_NOTIFY_ENUM_DIR            = 1022&

'//
'// MessageId: ERROR_DEPENDENT_SERVICES_RUNNING
'//
'// MessageText:
'//
'// A stop control has been sent to a service that other running services are dependent on.
'//
%ERROR_DEPENDENT_SERVICES_RUNNING = 1051&

'//
'// MessageId: ERROR_INVALID_SERVICE_CONTROL
'//
'// MessageText:
'//
'// The requested control is not valid for this service.
'//
%ERROR_INVALID_SERVICE_CONTROL    = 1052&

'//
'// MessageId: ERROR_SERVICE_REQUEST_TIMEOUT
'//
'// MessageText:
'//
'// The service did not respond to the start or control request in a timely fashion.
'//
%ERROR_SERVICE_REQUEST_TIMEOUT    = 1053&

'//
'// MessageId: ERROR_SERVICE_NO_THREAD
'//
'// MessageText:
'//
'// A thread could not be created for the service.
'//
%ERROR_SERVICE_NO_THREAD          = 1054&

'//
'// MessageId: ERROR_SERVICE_DATABASE_LOCKED
'//
'// MessageText:
'//
'// The service database is locked.
'//
%ERROR_SERVICE_DATABASE_LOCKED    = 1055&

'//
'// MessageId: ERROR_SERVICE_ALREADY_RUNNING
'//
'// MessageText:
'//
'// An instance of the service is already running.
'//
%ERROR_SERVICE_ALREADY_RUNNING    = 1056&

'//
'// MessageId: ERROR_INVALID_SERVICE_ACCOUNT
'//
'// MessageText:
'//
'// The account name is invalid or does not exist, or the password is invalid for the account name specified.
'//
%ERROR_INVALID_SERVICE_ACCOUNT    = 1057&

'//
'// MessageId: ERROR_SERVICE_DISABLED
'//
'// MessageText:
'//
'// The service cannot be started, either because it is disabled or because it has no enabled devices associated with it.
'//
%ERROR_SERVICE_DISABLED           = 1058&

'//
'// MessageId: ERROR_CIRCULAR_DEPENDENCY
'//
'// MessageText:
'//
'// Circular service dependency was specified.
'//
%ERROR_CIRCULAR_DEPENDENCY        = 1059&

'//
'// MessageId: ERROR_SERVICE_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// The specified service does not exist as an installed service.
'//
%ERROR_SERVICE_DOES_NOT_EXIST     = 1060&

'//
'// MessageId: ERROR_SERVICE_CANNOT_ACCEPT_CTRL
'//
'// MessageText:
'//
'// The service cannot accept control messages at this time.
'//
%ERROR_SERVICE_CANNOT_ACCEPT_CTRL = 1061&

'//
'// MessageId: ERROR_SERVICE_NOT_ACTIVE
'//
'// MessageText:
'//
'// The service has not been started.
'//
%ERROR_SERVICE_NOT_ACTIVE         = 1062&

'//
'// MessageId: ERROR_FAILED_SERVICE_CONTROLLER_CONNECT
'//
'// MessageText:
'//
'// The service process could not connect to the service controller.
'//
%ERROR_FAILED_SERVICE_CONTROLLER_CONNECT = 1063&

'//
'// MessageId: ERROR_EXCEPTION_IN_SERVICE
'//
'// MessageText:
'//
'// An exception occurred in the service when handling the control request.
'//
%ERROR_EXCEPTION_IN_SERVICE       = 1064&

'//
'// MessageId: ERROR_DATABASE_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// The database specified does not exist.
'//
%ERROR_DATABASE_DOES_NOT_EXIST    = 1065&

'//
'// MessageId: ERROR_SERVICE_SPECIFIC_ERROR
'//
'// MessageText:
'//
'// The service has returned a service-specific error code.
'//
%ERROR_SERVICE_SPECIFIC_ERROR     = 1066&

'//
'// MessageId: ERROR_PROCESS_ABORTED
'//
'// MessageText:
'//
'// The process terminated unexpectedly.
'//
%ERROR_PROCESS_ABORTED            = 1067&

'//
'// MessageId: ERROR_SERVICE_DEPENDENCY_FAIL
'//
'// MessageText:
'//
'// The dependency service or group failed to start.
'//
%ERROR_SERVICE_DEPENDENCY_FAIL    = 1068&

'//
'// MessageId: ERROR_SERVICE_LOGON_FAILED
'//
'// MessageText:
'//
'// The service did not start due to a logon failure.
'//
%ERROR_SERVICE_LOGON_FAILED       = 1069&

'//
'// MessageId: ERROR_SERVICE_START_HANG
'//
'// MessageText:
'//
'// After starting, the service hung in a start-pending state.
'//
%ERROR_SERVICE_START_HANG         = 1070&

'//
'// MessageId: ERROR_INVALID_SERVICE_LOCK
'//
'// MessageText:
'//
'// The specified service database lock is invalid.
'//
%ERROR_INVALID_SERVICE_LOCK       = 1071&

'//
'// MessageId: ERROR_SERVICE_MARKED_FOR_DELETE
'//
'// MessageText:
'//
'// The specified service has been marked for deletion.
'//
%ERROR_SERVICE_MARKED_FOR_DELETE  = 1072&

'//
'// MessageId: ERROR_SERVICE_EXISTS
'//
'// MessageText:
'//
'// The specified service already exists.
'//
%ERROR_SERVICE_EXISTS             = 1073&

'//
'// MessageId: ERROR_ALREADY_RUNNING_LKG
'//
'// MessageText:
'//
'// The system is currently running with the last-known-good configuration.
'//
%ERROR_ALREADY_RUNNING_LKG        = 1074&

'//
'// MessageId: ERROR_SERVICE_DEPENDENCY_DELETED
'//
'// MessageText:
'//
'// The dependency service does not exist or has been marked for deletion.
'//
%ERROR_SERVICE_DEPENDENCY_DELETED = 1075&

'//
'// MessageId: ERROR_BOOT_ALREADY_ACCEPTED
'//
'// MessageText:
'//
'// The current boot has already been accepted for use as the last-known-good control set.
'//
%ERROR_BOOT_ALREADY_ACCEPTED      = 1076&

'//
'// MessageId: ERROR_SERVICE_NEVER_STARTED
'//
'// MessageText:
'//
'// No attempts to start the service have been made since the last boot.
'//
%ERROR_SERVICE_NEVER_STARTED      = 1077&

'//
'// MessageId: ERROR_DUPLICATE_SERVICE_NAME
'//
'// MessageText:
'//
'// The name is already in use as either a service name or a service display name.
'//
%ERROR_DUPLICATE_SERVICE_NAME     = 1078&

'//
'// MessageId: ERROR_DIFFERENT_SERVICE_ACCOUNT
'//
'// MessageText:
'//
'// The account specified for this service is different from the account specified for other services running in the same process.
'//
%ERROR_DIFFERENT_SERVICE_ACCOUNT  = 1079&

'//
'// MessageId: ERROR_CANNOT_DETECT_DRIVER_FAILURE
'//
'// MessageText:
'//
'// Failure actions can only be set for Win32 services, not for drivers.
'//
%ERROR_CANNOT_DETECT_DRIVER_FAILURE = 1080&

'//
'// MessageId: ERROR_CANNOT_DETECT_PROCESS_ABORT
'//
'// MessageText:
'//
'// This service runs in the same process as the service control manager.
'// Therefore, the service control manager cannot take action if this service's process terminates unexpectedly.
'//
%ERROR_CANNOT_DETECT_PROCESS_ABORT = 1081&

'//
'// MessageId: ERROR_NO_RECOVERY_PROGRAM
'//
'// MessageText:
'//
'// No recovery program has been configured for this service.
'//
%ERROR_NO_RECOVERY_PROGRAM        = 1082&

'//
'// MessageId: ERROR_SERVICE_NOT_IN_EXE
'//
'// MessageText:
'//
'// The executable program that this service is configured to run in does not implement the service.
'//
%ERROR_SERVICE_NOT_IN_EXE         = 1083&

'//
'// MessageId: ERROR_NOT_SAFEBOOT_SERVICE
'//
'// MessageText:
'//
'// This service cannot be started in Safe Mode
'//
%ERROR_NOT_SAFEBOOT_SERVICE       = 1084&

'//
'// MessageId: ERROR_END_OF_MEDIA
'//
'// MessageText:
'//
'// The physical end of the tape has been reached.
'//
%ERROR_END_OF_MEDIA               = 1100&

'//
'// MessageId: ERROR_FILEMARK_DETECTED
'//
'// MessageText:
'//
'// A tape access reached a filemark.
'//
%ERROR_FILEMARK_DETECTED          = 1101&

'//
'// MessageId: ERROR_BEGINNING_OF_MEDIA
'//
'// MessageText:
'//
'// The beginning of the tape or a partition was encountered.
'//
%ERROR_BEGINNING_OF_MEDIA         = 1102&

'//
'// MessageId: ERROR_SETMARK_DETECTED
'//
'// MessageText:
'//
'// A tape access reached the end of a set of files.
'//
%ERROR_SETMARK_DETECTED           = 1103&

'//
'// MessageId: ERROR_NO_DATA_DETECTED
'//
'// MessageText:
'//
'// No more data is on the tape.
'//
%ERROR_NO_DATA_DETECTED           = 1104&

'//
'// MessageId: ERROR_PARTITION_FAILURE
'//
'// MessageText:
'//
'// Tape could not be partitioned.
'//
%ERROR_PARTITION_FAILURE          = 1105&

'//
'// MessageId: ERROR_INVALID_BLOCK_LENGTH
'//
'// MessageText:
'//
'// When accessing a new tape of a multivolume partition, the current block size is incorrect.
'//
%ERROR_INVALID_BLOCK_LENGTH       = 1106&

'//
'// MessageId: ERROR_DEVICE_NOT_PARTITIONED
'//
'// MessageText:
'//
'// Tape partition information could not be found when loading a tape.
'//
%ERROR_DEVICE_NOT_PARTITIONED     = 1107&

'//
'// MessageId: ERROR_UNABLE_TO_LOCK_MEDIA
'//
'// MessageText:
'//
'// Unable to lock the media eject mechanism.
'//
%ERROR_UNABLE_TO_LOCK_MEDIA       = 1108&

'//
'// MessageId: ERROR_UNABLE_TO_UNLOAD_MEDIA
'//
'// MessageText:
'//
'// Unable to unload the media.
'//
%ERROR_UNABLE_TO_UNLOAD_MEDIA     = 1109&

'//
'// MessageId: ERROR_MEDIA_CHANGED
'//
'// MessageText:
'//
'// The media in the drive may have changed.
'//
%ERROR_MEDIA_CHANGED              = 1110&

'//
'// MessageId: ERROR_BUS_RESET
'//
'// MessageText:
'//
'// The I/O bus was reset.
'//
%ERROR_BUS_RESET                  = 1111&

'//
'// MessageId: ERROR_NO_MEDIA_IN_DRIVE
'//
'// MessageText:
'//
'// No media in drive.
'//
%ERROR_NO_MEDIA_IN_DRIVE          = 1112&

'//
'// MessageId: ERROR_NO_UNICODE_TRANSLATION
'//
'// MessageText:
'//
'// No mapping for the Unicode character exists in the target multi-byte code page.
'//
%ERROR_NO_UNICODE_TRANSLATION     = 1113&

'//
'// MessageId: ERROR_DLL_INIT_FAILED
'//
'// MessageText:
'//
'// A dynamic link library (DL& initialization routine failed.
'//
%ERROR_DLL_INIT_FAILED            = 1114&

'//
'// MessageId: ERROR_SHUTDOWN_IN_PROGRESS
'//
'// MessageText:
'//
'// A system shutdown is in progress.
'//
%ERROR_SHUTDOWN_IN_PROGRESS       = 1115&

'//
'// MessageId: ERROR_NO_SHUTDOWN_IN_PROGRESS
'//
'// MessageText:
'//
'// Unable to abort the system shutdown because no shutdown was in progress.
'//
%ERROR_NO_SHUTDOWN_IN_PROGRESS    = 1116&

'//
'// MessageId: ERROR_IO_DEVICE
'//
'// MessageText:
'//
'// The request could not be performed because of an I/O device error.
'//
%ERROR_IO_DEVICE                  = 1117&

'//
'// MessageId: ERROR_SERIAL_NO_DEVICE
'//
'// MessageText:
'//
'// No serial device was successfully initialized. The serial driver will unload.
'//
%ERROR_SERIAL_NO_DEVICE           = 1118&

'//
'// MessageId: ERROR_IRQ_BUSY
'//
'// MessageText:
'//
'// Unable to open a device that was sharing an interrupt request (IRQ) with other devices. At least one other device that uses that IRQ was already opened.
'//
%ERROR_IRQ_BUSY                   = 1119&

'//
'// MessageId: ERROR_MORE_WRITES
'//
'// MessageText:
'//
'// A serial I/O operation was completed by another write to the serial port.
'// (The IOCTL_SERIAL_XOFF_COUNTER reached zero.)
'//
%ERROR_MORE_WRITES                = 1120&

'//
'// MessageId: ERROR_COUNTER_TIMEOUT
'//
'// MessageText:
'//
'// A serial I/O operation completed because the timeout period expired.
'// (The IOCTL_SERIAL_XOFF_COUNTER did not reach zero.)
'//
%ERROR_COUNTER_TIMEOUT            = 1121&

'//
'// MessageId: ERROR_FLOPPY_ID_MARK_NOT_FOUND
'//
'// MessageText:
'//
'// No ID address mark was found on the floppy disk.
'//
%ERROR_FLOPPY_ID_MARK_NOT_FOUND   = 1122&

'//
'// MessageId: ERROR_FLOPPY_WRONG_CYLINDER
'//
'// MessageText:
'//
'// Mismatch between the floppy disk sector ID field and the floppy disk controller track address.
'//
%ERROR_FLOPPY_WRONG_CYLINDER      = 1123&

'//
'// MessageId: ERROR_FLOPPY_UNKNOWN_ERROR
'//
'// MessageText:
'//
'// The floppy disk controller reported an error that is not recognized by the floppy disk driver.
'//
%ERROR_FLOPPY_UNKNOWN_ERROR       = 1124&

'//
'// MessageId: ERROR_FLOPPY_BAD_REGISTERS
'//
'// MessageText:
'//
'// The floppy disk controller returned inconsistent results in its registers.
'//
%ERROR_FLOPPY_BAD_REGISTERS       = 1125&

'//
'// MessageId: ERROR_DISK_RECALIBRATE_FAILED
'//
'// MessageText:
'//
'// While accessing the hard disk, a recalibrate operation failed, even after retries.
'//
%ERROR_DISK_RECALIBRATE_FAILED    = 1126&

'//
'// MessageId: ERROR_DISK_OPERATION_FAILED
'//
'// MessageText:
'//
'// While accessing the hard disk, a disk operation failed even after retries.
'//
%ERROR_DISK_OPERATION_FAILED      = 1127&

'//
'// MessageId: ERROR_DISK_RESET_FAILED
'//
'// MessageText:
'//
'// While accessing the hard disk, a disk controller reset was needed, but even that failed.
'//
%ERROR_DISK_RESET_FAILED          = 1128&

'//
'// MessageId: ERROR_EOM_OVERFLOW
'//
'// MessageText:
'//
'// Physical end of tape encountered.
'//
%ERROR_EOM_OVERFLOW               = 1129&

'//
'// MessageId: ERROR_NOT_ENOUGH_SERVER_MEMORY
'//
'// MessageText:
'//
'// Not enough server storage is available to process this command.
'//
%ERROR_NOT_ENOUGH_SERVER_MEMORY   = 1130&

'//
'// MessageId: ERROR_POSSIBLE_DEADLOCK
'//
'// MessageText:
'//
'// A potential deadlock condition has been detected.
'//
%ERROR_POSSIBLE_DEADLOCK          = 1131&

'//
'// MessageId: ERROR_MAPPED_ALIGNMENT
'//
'// MessageText:
'//
'// The base address or the file offset specified does not have the proper alignment.
'//
%ERROR_MAPPED_ALIGNMENT           = 1132&

'//
'// MessageId: ERROR_SET_POWER_STATE_VETOED
'//
'// MessageText:
'//
'// An attempt to change the system power state was vetoed by another application or driver.
'//
%ERROR_SET_POWER_STATE_VETOED     = 1140&

'//
'// MessageId: ERROR_SET_POWER_STATE_FAILED
'//
'// MessageText:
'//
'// The system BIOS failed an attempt to change the system power state.
'//
%ERROR_SET_POWER_STATE_FAILED     = 1141&

'//
'// MessageId: ERROR_TOO_MANY_LINKS
'//
'// MessageText:
'//
'// An attempt was made to create more links on a file than the file system supports.
'//
%ERROR_TOO_MANY_LINKS             = 1142&

'//
'// MessageId: ERROR_OLD_WIN_VERSION
'//
'// MessageText:
'//
'// The specified program requires a newer version of Windows.
'//
%ERROR_OLD_WIN_VERSION            = 1150&

'//
'// MessageId: ERROR_APP_WRONG_OS
'//
'// MessageText:
'//
'// The specified program is not a Windows or MS-DOS program.
'//
%ERROR_APP_WRONG_OS               = 1151&

'//
'// MessageId: ERROR_SINGLE_INSTANCE_APP
'//
'// MessageText:
'//
'// Cannot start more than one instance of the specified program.
'//
%ERROR_SINGLE_INSTANCE_APP        = 1152&

'//
'// MessageId: ERROR_RMODE_APP
'//
'// MessageText:
'//
'// The specified program was written for an earlier version of Windows.
'//
%ERROR_RMODE_APP                  = 1153&

'//
'// MessageId: ERROR_INVALID_DLL
'//
'// MessageText:
'//
'// One of the library files needed to run this application is damaged.
'//
%ERROR_INVALID_DLL                = 1154&

'//
'// MessageId: ERROR_NO_ASSOCIATION
'//
'// MessageText:
'//
'// No application is associated with the specified file for this operation.
'//
%ERROR_NO_ASSOCIATION             = 1155&

'//
'// MessageId: ERROR_DDE_FAIL
'//
'// MessageText:
'//
'// An error occurred in sending the command to the application.
'//
%ERROR_DDE_FAIL                   = 1156&

'//
'// MessageId: ERROR_DLL_NOT_FOUND
'//
'// MessageText:
'//
'// One of the library files needed to run this application cannot be found.
'//
%ERROR_DLL_NOT_FOUND              = 1157&

'//
'// MessageId: ERROR_NO_MORE_USER_HANDLES
'//
'// MessageText:
'//
'// The current process has used all of its system allowance of handles for Window Manager objects.
'//
%ERROR_NO_MORE_USER_HANDLES       = 1158&

'//
'// MessageId: ERROR_MESSAGE_SYNC_ONLY
'//
'// MessageText:
'//
'// The message can be used only with synchronous operations.
'//
%ERROR_MESSAGE_SYNC_ONLY          = 1159&

'//
'// MessageId: ERROR_SOURCE_ELEMENT_EMPTY
'//
'// MessageText:
'//
'// The indicated source element has no media.
'//
%ERROR_SOURCE_ELEMENT_EMPTY       = 1160&

'//
'// MessageId: ERROR_DESTINATION_ELEMENT_FULL
'//
'// MessageText:
'//
'// The indicated destination element already contains media.
'//
%ERROR_DESTINATION_ELEMENT_FULL   = 1161&

'//
'// MessageId: ERROR_ILLEGAL_ELEMENT_ADDRESS
'//
'// MessageText:
'//
'// The indicated element does not exist.
'//
%ERROR_ILLEGAL_ELEMENT_ADDRESS    = 1162&

'//
'// MessageId: ERROR_MAGAZINE_NOT_PRESENT
'//
'// MessageText:
'//
'// The indicated element is part of a magazine that is not present.
'//
%ERROR_MAGAZINE_NOT_PRESENT       = 1163&

'//
'// MessageId: ERROR_DEVICE_REINITIALIZATION_NEEDED
'//
'// MessageText:
'//
'// The indicated device requires reinitialization due to hardware errors.
'//
%ERROR_DEVICE_REINITIALIZATION_NEEDED = 1164&    '// dderror

'//
'// MessageId: ERROR_DEVICE_REQUIRES_CLEANING
'//
'// MessageText:
'//
'// The device has indicated that cleaning is required before further operations are attempted.
'//
%ERROR_DEVICE_REQUIRES_CLEANING   = 1165&

'//
'// MessageId: ERROR_DEVICE_DOOR_OPEN
'//
'// MessageText:
'//
'// The device has indicated that its door is open.
'//
%ERROR_DEVICE_DOOR_OPEN           = 1166&

'//
'// MessageId: ERROR_DEVICE_NOT_CONNECTED
'//
'// MessageText:
'//
'// The device is not connected.
'//
%ERROR_DEVICE_NOT_CONNECTED       = 1167&

'//
'// MessageId: ERROR_NOT_FOUND
'//
'// MessageText:
'//
'// Element not found.
'//
%ERROR_NOT_FOUND                  = 1168&

'//
'// MessageId: ERROR_NO_MATCH
'//
'// MessageText:
'//
'// There was no match for the specified key in the index.
'//
%ERROR_NO_MATCH                   = 1169&

'//
'// MessageId: ERROR_SET_NOT_FOUND
'//
'// MessageText:
'//
'// The property set specified does not exist on the object.
'//
%ERROR_SET_NOT_FOUND              = 1170&

'//
'// MessageId: ERROR_POINT_NOT_FOUND
'//
'// MessageText:
'//
'// The point passed to GetMouseMovePoints is not in the buffer.
'//
%ERROR_POINT_NOT_FOUND            = 1171&

'//
'// MessageId: ERROR_NO_TRACKING_SERVICE
'//
'// MessageText:
'//
'// The tracking (workstation) service is not running.
'//
%ERROR_NO_TRACKING_SERVICE        = 1172&

'//
'// MessageId: ERROR_NO_VOLUME_ID
'//
'// MessageText:
'//
'// The Volume ID could not be found.
'//
%ERROR_NO_VOLUME_ID               = 1173&

'//
'// MessageId: ERROR_UNABLE_TO_REMOVE_REPLACED
'//
'// MessageText:
'//
'// Unable to remove the file to be replaced.
'//
%ERROR_UNABLE_TO_REMOVE_REPLACED  = 1175&

'//
'// MessageId: ERROR_UNABLE_TO_MOVE_REPLACEMENT
'//
'// MessageText:
'//
'// Unable to move the replacement file to the file to be replaced. The file to be replaced has retained its original name.
'//
%ERROR_UNABLE_TO_MOVE_REPLACEMENT = 1176&

'//
'// MessageId: ERROR_UNABLE_TO_MOVE_REPLACEMENT_2
'//
'// MessageText:
'//
'// Unable to move the replacement file to the file to be replaced. The file to be replaced has been renamed using the backup name.
'//
%ERROR_UNABLE_TO_MOVE_REPLACEMENT_2 = 1177&

'//
'// MessageId: ERROR_JOURNAL_DELETE_IN_PROGRESS
'//
'// MessageText:
'//
'// The volume change journal is being deleted.
'//
%ERROR_JOURNAL_DELETE_IN_PROGRESS = 1178&

'//
'// MessageId: ERROR_JOURNAL_NOT_ACTIVE
'//
'// MessageText:
'//
'// The volume change journal is not active.
'//
%ERROR_JOURNAL_NOT_ACTIVE         = 1179&

'//
'// MessageId: ERROR_POTENTIAL_FILE_FOUND
'//
'// MessageText:
'//
'// A file was found, but it may not be the correct file.
'//
%ERROR_POTENTIAL_FILE_FOUND       = 1180&

'//
'// MessageId: ERROR_JOURNAL_ENTRY_DELETED
'//
'// MessageText:
'//
'// The journal entry has been deleted from the journal.
'//
%ERROR_JOURNAL_ENTRY_DELETED      = 1181&

'//
'// MessageId: ERROR_SHUTDOWN_IS_SCHEDULED
'//
'// MessageText:
'//
'// A system shutdown has already been scheduled.
'//
%ERROR_SHUTDOWN_IS_SCHEDULED      = 1190&

'//
'// MessageId: ERROR_SHUTDOWN_USERS_LOGGED_ON
'//
'// MessageText:
'//
'// The system shutdown cannot be initiated because there are other users logged on to the computer.
'//
%ERROR_SHUTDOWN_USERS_LOGGED_ON   = 1191&

'//
'// MessageId: ERROR_BAD_DEVICE
'//
'// MessageText:
'//
'// The specified device name is invalid.
'//
%ERROR_BAD_DEVICE                 = 1200&

'//
'// MessageId: ERROR_CONNECTION_UNAVAIL
'//
'// MessageText:
'//
'// The device is not currently connected but it is a remembered connection.
'//
%ERROR_CONNECTION_UNAVAIL         = 1201&

'//
'// MessageId: ERROR_DEVICE_ALREADY_REMEMBERED
'//
'// MessageText:
'//
'// The local device name has a remembered connection to another network resource.
'//
%ERROR_DEVICE_ALREADY_REMEMBERED  = 1202&

'//
'// MessageId: ERROR_NO_NET_OR_BAD_PATH
'//
'// MessageText:
'//
'// The network path was either typed incorrectly, does not exist, or the network provider is not currently available. Please try retyping the path or contact your network administrator.
'//
%ERROR_NO_NET_OR_BAD_PATH         = 1203&

'//
'// MessageId: ERROR_BAD_PROVIDER
'//
'// MessageText:
'//
'// The specified network provider name is invalid.
'//
%ERROR_BAD_PROVIDER               = 1204&

'//
'// MessageId: ERROR_CANNOT_OPEN_PROFILE
'//
'// MessageText:
'//
'// Unable to open the network connection profile.
'//
%ERROR_CANNOT_OPEN_PROFILE        = 1205&

'//
'// MessageId: ERROR_BAD_PROFILE
'//
'// MessageText:
'//
'// The network connection profile is corrupted.
'//
%ERROR_BAD_PROFILE                = 1206&

'//
'// MessageId: ERROR_NOT_CONTAINER
'//
'// MessageText:
'//
'// Cannot enumerate a noncontainer.
'//
%ERROR_NOT_CONTAINER              = 1207&

'//
'// MessageId: ERROR_EXTENDED_ERROR
'//
'// MessageText:
'//
'// An extended error has occurred.
'//
%ERROR_EXTENDED_ERROR             = 1208&

'//
'// MessageId: ERROR_INVALID_GROUPNAME
'//
'// MessageText:
'//
'// The format of the specified group name is invalid.
'//
%ERROR_INVALID_GROUPNAME          = 1209&

'//
'// MessageId: ERROR_INVALID_COMPUTERNAME
'//
'// MessageText:
'//
'// The format of the specified computer name is invalid.
'//
%ERROR_INVALID_COMPUTERNAME       = 1210&

'//
'// MessageId: ERROR_INVALID_EVENTNAME
'//
'// MessageText:
'//
'// The format of the specified event name is invalid.
'//
%ERROR_INVALID_EVENTNAME          = 1211&

'//
'// MessageId: ERROR_INVALID_DOMAINNAME
'//
'// MessageText:
'//
'// The format of the specified domain name is invalid.
'//
%ERROR_INVALID_DOMAINNAME         = 1212&

'//
'// MessageId: ERROR_INVALID_SERVICENAME
'//
'// MessageText:
'//
'// The format of the specified service name is invalid.
'//
%ERROR_INVALID_SERVICENAME        = 1213&

'//
'// MessageId: ERROR_INVALID_NETNAME
'//
'// MessageText:
'//
'// The format of the specified network name is invalid.
'//
%ERROR_INVALID_NETNAME            = 1214&

'//
'// MessageId: ERROR_INVALID_SHARENAME
'//
'// MessageText:
'//
'// The format of the specified share name is invalid.
'//
%ERROR_INVALID_SHARENAME          = 1215&

'//
'// MessageId: ERROR_INVALID_PASSWORDNAME
'//
'// MessageText:
'//
'// The format of the specified password is invalid.
'//
%ERROR_INVALID_PASSWORDNAME       = 1216&

'//
'// MessageId: ERROR_INVALID_MESSAGENAME
'//
'// MessageText:
'//
'// The format of the specified message name is invalid.
'//
%ERROR_INVALID_MESSAGENAME        = 1217&

'//
'// MessageId: ERROR_INVALID_MESSAGEDEST
'//
'// MessageText:
'//
'// The format of the specified message destination is invalid.
'//
%ERROR_INVALID_MESSAGEDEST        = 1218&

'//
'// MessageId: ERROR_SESSION_CREDENTIAL_CONFLICT
'//
'// MessageText:
'//
'// Multiple connections to a server or shared resource by the same user, using more than one user name, are not allowed. Disconnect all previous connections to the server or shared resource and try again.
'//
%ERROR_SESSION_CREDENTIAL_CONFLICT = 1219&

'//
'// MessageId: ERROR_REMOTE_SESSION_LIMIT_EXCEEDED
'//
'// MessageText:
'//
'// An attempt was made to establish a session to a network server, but there are already too many sessions established to that server.
'//
%ERROR_REMOTE_SESSION_LIMIT_EXCEEDED = 1220&

'//
'// MessageId: ERROR_DUP_DOMAINNAME
'//
'// MessageText:
'//
'// The workgroup or domain name is already in use by another computer on the network.
'//
%ERROR_DUP_DOMAINNAME             = 1221&

'//
'// MessageId: ERROR_NO_NETWORK
'//
'// MessageText:
'//
'// The network is not present or not started.
'//
%ERROR_NO_NETWORK                 = 1222&

'//
'// MessageId: ERROR_CANCELLED
'//
'// MessageText:
'//
'// The operation was canceled by the user.
'//
%ERROR_CANCELLED                  = 1223&

'//
'// MessageId: ERROR_USER_MAPPED_FILE
'//
'// MessageText:
'//
'// The requested operation cannot be performed on a file with a user-mapped section open.
'//
%ERROR_USER_MAPPED_FILE           = 1224&

'//
'// MessageId: ERROR_CONNECTION_REFUSED
'//
'// MessageText:
'//
'// The remote computer refused the network connection.
'//
%ERROR_CONNECTION_REFUSED         = 1225&

'//
'// MessageId: ERROR_GRACEFUL_DISCONNECT
'//
'// MessageText:
'//
'// The network connection was gracefully closed.
'//
%ERROR_GRACEFUL_DISCONNECT        = 1226&

'//
'// MessageId: ERROR_ADDRESS_ALREADY_ASSOCIATED
'//
'// MessageText:
'//
'// The network transport endpoint already has an address associated with it.
'//
%ERROR_ADDRESS_ALREADY_ASSOCIATED = 1227&

'//
'// MessageId: ERROR_ADDRESS_NOT_ASSOCIATED
'//
'// MessageText:
'//
'// An address has not yet been associated with the network endpoint.
'//
%ERROR_ADDRESS_NOT_ASSOCIATED     = 1228&

'//
'// MessageId: ERROR_CONNECTION_INVALID
'//
'// MessageText:
'//
'// An operation was attempted on a nonexistent network connection.
'//
%ERROR_CONNECTION_INVALID         = 1229&

'//
'// MessageId: ERROR_CONNECTION_ACTIVE
'//
'// MessageText:
'//
'// An invalid operation was attempted on an active network connection.
'//
%ERROR_CONNECTION_ACTIVE          = 1230&

'//
'// MessageId: ERROR_NETWORK_UNREACHABLE
'//
'// MessageText:
'//
'// The network location cannot be reached. For information about network troubleshooting, see Windows Help.
'//
%ERROR_NETWORK_UNREACHABLE        = 1231&

'//
'// MessageId: ERROR_HOST_UNREACHABLE
'//
'// MessageText:
'//
'// The network location cannot be reached. For information about network troubleshooting, see Windows Help.
'//
%ERROR_HOST_UNREACHABLE           = 1232&

'//
'// MessageId: ERROR_PROTOCOL_UNREACHABLE
'//
'// MessageText:
'//
'// The network location cannot be reached. For information about network troubleshooting, see Windows Help.
'//
%ERROR_PROTOCOL_UNREACHABLE       = 1233&

'//
'// MessageId: ERROR_PORT_UNREACHABLE
'//
'// MessageText:
'//
'// No service is operating at the destination network endpoint on the remote system.
'//
%ERROR_PORT_UNREACHABLE           = 1234&

'//
'// MessageId: ERROR_REQUEST_ABORTED
'//
'// MessageText:
'//
'// The request was aborted.
'//
%ERROR_REQUEST_ABORTED            = 1235&

'//
'// MessageId: ERROR_CONNECTION_ABORTED
'//
'// MessageText:
'//
'// The network connection was aborted by the local system.
'//
%ERROR_CONNECTION_ABORTED         = 1236&

'//
'// MessageId: ERROR_RETRY
'//
'// MessageText:
'//
'// The operation could not be completed. A retry should be performed.
'//
%ERROR_RETRY                      = 1237&

'//
'// MessageId: ERROR_CONNECTION_COUNT_LIMIT
'//
'// MessageText:
'//
'// A connection to the server could not be made because the limit on the number of concurrent connections for this account has been reached.
'//
%ERROR_CONNECTION_COUNT_LIMIT     = 1238&

'//
'// MessageId: ERROR_LOGIN_TIME_RESTRICTION
'//
'// MessageText:
'//
'// Attempting to log in during an unauthorized time of day for this account.
'//
%ERROR_LOGIN_TIME_RESTRICTION     = 1239&

'//
'// MessageId: ERROR_LOGIN_WKSTA_RESTRICTION
'//
'// MessageText:
'//
'// The account is not authorized to log in from this station.
'//
%ERROR_LOGIN_WKSTA_RESTRICTION    = 1240&

'//
'// MessageId: ERROR_INCORRECT_ADDRESS
'//
'// MessageText:
'//
'// The network address could not be used for the operation requested.
'//
%ERROR_INCORRECT_ADDRESS          = 1241&

'//
'// MessageId: ERROR_ALREADY_REGISTERED
'//
'// MessageText:
'//
'// The service is already registered.
'//
%ERROR_ALREADY_REGISTERED         = 1242&

'//
'// MessageId: ERROR_SERVICE_NOT_FOUND
'//
'// MessageText:
'//
'// The specified service does not exist.
'//
%ERROR_SERVICE_NOT_FOUND          = 1243&

'//
'// MessageId: ERROR_NOT_AUTHENTICATED
'//
'// MessageText:
'//
'// The operation being requested was not performed because the user has not been authenticated.
'//
%ERROR_NOT_AUTHENTICATED          = 1244&

'//
'// MessageId: ERROR_NOT_LOGGED_ON
'//
'// MessageText:
'//
'// The operation being requested was not performed because the user has not logged on to the network.
'// The specified service does not exist.
'//
%ERROR_NOT_LOGGED_ON              = 1245&

'//
'// MessageId: ERROR_CONTINUE
'//
'// MessageText:
'//
'// Continue with work in progress.
'//
%ERROR_CONTINUE                   = 1246&    '// dderror

'//
'// MessageId: ERROR_ALREADY_INITIALIZED
'//
'// MessageText:
'//
'// An attempt was made to perform an initialization operation when initialization has already been completed.
'//
%ERROR_ALREADY_INITIALIZED        = 1247&

'//
'// MessageId: ERROR_NO_MORE_DEVICES
'//
'// MessageText:
'//
'// No more local devices.
'//
%ERROR_NO_MORE_DEVICES            = 1248&    '// dderror

'//
'// MessageId: ERROR_NO_SUCH_SITE
'//
'// MessageText:
'//
'// The specified site does not exist.
'//
%ERROR_NO_SUCH_SITE               = 1249&

'//
'// MessageId: ERROR_DOMAIN_CONTROLLER_EXISTS
'//
'// MessageText:
'//
'// A domain controller with the specified name already exists.
'//
%ERROR_DOMAIN_CONTROLLER_EXISTS   = 1250&

'//
'// MessageId: ERROR_ONLY_IF_CONNECTED
'//
'// MessageText:
'//
'// This operation is supported only when you are connected to the server.
'//
%ERROR_ONLY_IF_CONNECTED          = 1251&

'//
'// MessageId: ERROR_OVERRIDE_NOCHANGES
'//
'// MessageText:
'//
'// The group policy framework should call the extension even if there are no changes.
'//
%ERROR_OVERRIDE_NOCHANGES         = 1252&

'//
'// MessageId: ERROR_BAD_USER_PROFILE
'//
'// MessageText:
'//
'// The specified user does not have a valid profile.
'//
%ERROR_BAD_USER_PROFILE           = 1253&

'//
'// MessageId: ERROR_NOT_SUPPORTED_ON_SBS
'//
'// MessageText:
'//
'// This operation is not supported on a computer running Windows Server 2003 for Small Business Server
'//
%ERROR_NOT_SUPPORTED_ON_SBS       = 1254&

'//
'// MessageId: ERROR_SERVER_SHUTDOWN_IN_PROGRESS
'//
'// MessageText:
'//
'// The server machine is shutting down.
'//
%ERROR_SERVER_SHUTDOWN_IN_PROGRESS = 1255&

'//
'// MessageId: ERROR_HOST_DOWN
'//
'// MessageText:
'//
'// The remote system is not available. For information about network troubleshooting, see Windows Help.
'//
%ERROR_HOST_DOWN                  = 1256&

'//
'// MessageId: ERROR_NON_ACCOUNT_SID
'//
'// MessageText:
'//
'// The security identifier provided is not from an account domain.
'//
%ERROR_NON_ACCOUNT_SID            = 1257&

'//
'// MessageId: ERROR_NON_DOMAIN_SID
'//
'// MessageText:
'//
'// The security identifier provided does not have a domain component.
'//
%ERROR_NON_DOMAIN_SID             = 1258&

'//
'// MessageId: ERROR_APPHELP_BLOCK
'//
'// MessageText:
'//
'// AppHelp dialog canceled thus preventing the application from starting.
'//
%ERROR_APPHELP_BLOCK              = 1259&

'//
'// MessageId: ERROR_ACCESS_DISABLED_BY_POLICY
'//
'// MessageText:
'//
'// This program is blocked by group policy. For more information, contact your system administrator.
'//
%ERROR_ACCESS_DISABLED_BY_POLICY = 1260&

'//
'// MessageId: ERROR_REG_NAT_CONSUMPTION
'//
'// MessageText:
'//
'// A program attempt to use an invalid register value. Normally caused by an uninitialized register. This error is Itanium specific.
'//
%ERROR_REG_NAT_CONSUMPTION        = 1261&

'//
'// MessageId: ERROR_CSCSHARE_OFFLINE
'//
'// MessageText:
'//
'// The share is currently offline or does not exist.
'//
%ERROR_CSCSHARE_OFFLINE           = 1262&

'//
'// MessageId: ERROR_PKINIT_FAILURE
'//
'// MessageText:
'//
'// The kerberos protocol encountered an error while validating the KDC certificate during smartcard logon. There is more information in the system event log.
'//
%ERROR_PKINIT_FAILURE             = 1263&

'//
'// MessageId: ERROR_SMARTCARD_SUBSYSTEM_FAILURE
'//
'// MessageText:
'//
'// The kerberos protocol encountered an error while attempting to utilize the smartcard subsystem.
'//
%ERROR_SMARTCARD_SUBSYSTEM_FAILURE = 1264&

'//
'// MessageId: ERROR_DOWNGRADE_DETECTED
'//
'// MessageText:
'//
'// The system detected a possible attempt to compromise security. Please ensure that you can contact the server that authenticated you.
'//
%ERROR_DOWNGRADE_DETECTED         = 1265&

'//
'// Do not use ID's 1266 - 1270 as the symbolicNames have been moved to SEC_E_*
'//
'//
'// MessageId: ERROR_MACHINE_LOCKED
'//
'// MessageText:
'//
'// The machine is locked and cannot be shut down without the force option.
'//
%ERROR_MACHINE_LOCKED             = 1271&

'//
'// MessageId: ERROR_CALLBACK_SUPPLIED_INVALID_DATA
'//
'// MessageText:
'//
'// An application-defined callback gave invalid data when called.
'//
%ERROR_CALLBACK_SUPPLIED_INVALID_DATA = 1273&

'//
'// MessageId: ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED
'//
'// MessageText:
'//
'// The group policy framework should call the extension in the synchronous foreground policy refresh.
'//
%ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED = 1274&

'//
'// MessageId: ERROR_DRIVER_BLOCKED
'//
'// MessageText:
'//
'// This driver has been blocked from loading
'//
%ERROR_DRIVER_BLOCKED             = 1275&

'//
'// MessageId: ERROR_INVALID_IMPORT_OF_NON_DLL
'//
'// MessageText:
'//
'// A dynamic link library (DL& referenced a module that was neither a DLL nor the process's executable image.
'//
%ERROR_INVALID_IMPORT_OF_NON_DLL  = 1276&

'//
'// MessageId: ERROR_ACCESS_DISABLED_WEBBLADE
'//
'// MessageText:
'//
'// Windows cannot open this program since it has been disabled.
'//
%ERROR_ACCESS_DISABLED_WEBBLADE   = 1277&

'//
'// MessageId: ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER
'//
'// MessageText:
'//
'// Windows cannot open this program because the license enforcement system has been tampered with or become corrupted.
'//
%ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER = 1278&

'//
'// MessageId: ERROR_RECOVERY_FAILURE
'//
'// MessageText:
'//
'// A transaction recover failed.
'//
%ERROR_RECOVERY_FAILURE           = 1279&

'//
'// MessageId: ERROR_ALREADY_FIBER
'//
'// MessageText:
'//
'// The current thread has already been converted to a fiber.
'//
%ERROR_ALREADY_FIBER              = 1280&

'//
'// MessageId: ERROR_ALREADY_THREAD
'//
'// MessageText:
'//
'// The current thread has already been converted from a fiber.
'//
%ERROR_ALREADY_THREAD             = 1281&

'//
'// MessageId: ERROR_STACK_BUFFER_OVERRUN
'//
'// MessageText:
'//
'// The system detected an overrun of a stack-based buffer in this application. This overrun could potentially allow a malicious user to gain control of this application.
'//
%ERROR_STACK_BUFFER_OVERRUN       = 1282&

'//
'// MessageId: ERROR_PARAMETER_QUOTA_EXCEEDED
'//
'// MessageText:
'//
'// Data present in one of the parameters is more than the function can operate on.
'//
%ERROR_PARAMETER_QUOTA_EXCEEDED   = 1283&

'//
'// MessageId: ERROR_DEBUGGER_INACTIVE
'//
'// MessageText:
'//
'// An attempt to do an operation on a debug object failed because the object is in the process of being deleted.
'//
%ERROR_DEBUGGER_INACTIVE          = 1284&

'//
'// MessageId: ERROR_DELAY_LOAD_FAILED
'//
'// MessageText:
'//
'// An attempt to delay-load a .dll or get a function address in a delay-loaded .dll failed.
'//
%ERROR_DELAY_LOAD_FAILED          = 1285&

'//
'// MessageId: ERROR_VDM_DISALLOWED
'//
'// MessageText:
'//
'// %1 is a 16-bit application. You do not have permissions to execute 16-bit applications. Check your permissions with your system administrator.
'//
%ERROR_VDM_DISALLOWED             = 1286&

'//
'// MessageId: ERROR_UNIDENTIFIED_ERROR
'//
'// MessageText:
'//
'// Insufficient information exists to identify the cause of failure.
'//
%ERROR_UNIDENTIFIED_ERROR         = 1287&

'//
'// MessageId: ERROR_INVALID_CRUNTIME_PARAMETER
'//
'// MessageText:
'//
'// The parameter passed to a C runtime function is incorrect.
'//
%ERROR_INVALID_CRUNTIME_PARAMETER = 1288&

'//
'// MessageId: ERROR_BEYOND_VDL
'//
'// MessageText:
'//
'// The operation occurred beyond the valid data length of the file.
'//
%ERROR_BEYOND_VDL                 = 1289&

'//
'// MessageId: ERROR_INCOMPATIBLE_SERVICE_SID_TYPE
'//
'// MessageText:
'//
'// The service start failed since one or more services in the same process have an incompatible service SID type setting. A service with restricted service
'// SID type can only coexist in the same process with other services with a restricted SID type. If the service SID type for this service was just configured, the hosting process must be restarted in order to start this service.
'//
%ERROR_INCOMPATIBLE_SERVICE_SID_TYPE = 1290&

'//
'// MessageId: ERROR_DRIVER_PROCESS_TERMINATED
'//
'// MessageText:
'//
'// The process hosting the driver for this device has been terminated.
'//
%ERROR_DRIVER_PROCESS_TERMINATED  = 1291&

'//
'// MessageId: ERROR_IMPLEMENTATION_LIMIT
'//
'// MessageText:
'//
'// An operation attempted to exceed an implementation-defined limit.
'//
%ERROR_IMPLEMENTATION_LIMIT       = 1292&

'//
'// MessageId: ERROR_PROCESS_IS_PROTECTED
'//
'// MessageText:
'//
'// Either the target process, or the target thread's containing process, is a protected process.
'//
%ERROR_PROCESS_IS_PROTECTED       = 1293&

'//
'// MessageId: ERROR_SERVICE_NOTIFY_CLIENT_LAGGING
'//
'// MessageText:
'//
'// The service notification client is lagging too far behind the current state of services in the machine.
'//
%ERROR_SERVICE_NOTIFY_CLIENT_LAGGING = 1294&

'//
'// MessageId: ERROR_DISK_QUOTA_EXCEEDED
'//
'// MessageText:
'//
'// The requested file operation failed because the storage quota was exceeded.
'// To free up disk space, move files to a different location or delete unnecessary files. For more information, contact your system administrator.
'//
%ERROR_DISK_QUOTA_EXCEEDED        = 1295&

'//
'// MessageId: ERROR_CONTENT_BLOCKED
'//
'// MessageText:
'//
'// The requested file operation failed because the storage policy blocks that type of file. For more information, contact your system administrator.
'//
%ERROR_CONTENT_BLOCKED            = 1296&

'//
'// MessageId: ERROR_INCOMPATIBLE_SERVICE_PRIVILEGE
'//
'// MessageText:
'//
'// A privilege that the service requires to function properly does not exist in the service account configuration.
'// You may use the Services Microsoft Management Console (MMC) snap-in (services.msc) and the Local Security Settings MMC snap-in (secpol.msc) to view the service configuration and the account configuration.
'//
%ERROR_INCOMPATIBLE_SERVICE_PRIVILEGE = 1297&


'///////////////////////////////////////////////////
'//                                               //
'//             SECURITY Error codes              //
'//                                               //
'//                 = 1299 to 1399                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_INVALID_LABEL
'//
'// MessageText:
'//
'// Indicates a particular Security ID may not be assigned as the label of an object.
'//
%ERROR_INVALID_LABEL              = 1299&

'//
'// MessageId: ERROR_NOT_ALL_ASSIGNED
'//
'// MessageText:
'//
'// Not all privileges or groups referenced are assigned to the caller.
'//
%ERROR_NOT_ALL_ASSIGNED           = 1300&

'//
'// MessageId: ERROR_SOME_NOT_MAPPED
'//
'// MessageText:
'//
'// Some mapping between account names and security IDs was not done.
'//
%ERROR_SOME_NOT_MAPPED            = 1301&

'//
'// MessageId: ERROR_NO_QUOTAS_FOR_ACCOUNT
'//
'// MessageText:
'//
'// No system quota limits are specifically set for this account.
'//
%ERROR_NO_QUOTAS_FOR_ACCOUNT      = 1302&

'//
'// MessageId: ERROR_LOCAL_USER_SESSION_KEY
'//
'// MessageText:
'//
'// No encryption key is available. A well-known encryption key was returned.
'//
%ERROR_LOCAL_USER_SESSION_KEY     = 1303&

'//
'// MessageId: ERROR_NULL_LM_PASSWORD
'//
'// MessageText:
'//
'// The password is too complex to be converted to a LAN Manager password. The LAN Manager password returned is a NULL string.
'//
%ERROR_NULL_LM_PASSWORD           = 1304&

'//
'// MessageId: ERROR_UNKNOWN_REVISION
'//
'// MessageText:
'//
'// The revision level is unknown.
'//
%ERROR_UNKNOWN_REVISION           = 1305&

'//
'// MessageId: ERROR_REVISION_MISMATCH
'//
'// MessageText:
'//
'// Indicates two revision levels are incompatible.
'//
%ERROR_REVISION_MISMATCH          = 1306&

'//
'// MessageId: ERROR_INVALID_OWNER
'//
'// MessageText:
'//
'// This security ID may not be assigned as the owner of this object.
'//
%ERROR_INVALID_OWNER              = 1307&

'//
'// MessageId: ERROR_INVALID_PRIMARY_GROUP
'//
'// MessageText:
'//
'// This security ID may not be assigned as the primary group of an object.
'//
%ERROR_INVALID_PRIMARY_GROUP      = 1308&

'//
'// MessageId: ERROR_NO_IMPERSONATION_TOKEN
'//
'// MessageText:
'//
'// An attempt has been made to operate on an impersonation token by a thread that is not currently impersonating a client.
'//
%ERROR_NO_IMPERSONATION_TOKEN     = 1309&

'//
'// MessageId: ERROR_CANT_DISABLE_MANDATORY
'//
'// MessageText:
'//
'// The group may not be disabled.
'//
%ERROR_CANT_DISABLE_MANDATORY     = 1310&

'//
'// MessageId: ERROR_NO_LOGON_SERVERS
'//
'// MessageText:
'//
'// There are currently no logon servers available to service the logon request.
'//
%ERROR_NO_LOGON_SERVERS           = 1311&

'//
'// MessageId: ERROR_NO_SUCH_LOGON_SESSION
'//
'// MessageText:
'//
'// A specified logon session does not exist. It may already have been terminated.
'//
%ERROR_NO_SUCH_LOGON_SESSION      = 1312&

'//
'// MessageId: ERROR_NO_SUCH_PRIVILEGE
'//
'// MessageText:
'//
'// A specified privilege does not exist.
'//
%ERROR_NO_SUCH_PRIVILEGE          = 1313&

'//
'// MessageId: ERROR_PRIVILEGE_NOT_HELD
'//
'// MessageText:
'//
'// A required privilege is not held by the client.
'//
%ERROR_PRIVILEGE_NOT_HELD         = 1314&

'//
'// MessageId: ERROR_INVALID_ACCOUNT_NAME
'//
'// MessageText:
'//
'// The name provided is not a properly formed account name.
'//
%ERROR_INVALID_ACCOUNT_NAME       = 1315&

'//
'// MessageId: ERROR_USER_EXISTS
'//
'// MessageText:
'//
'// The specified account already exists.
'//
%ERROR_USER_EXISTS                = 1316&

'//
'// MessageId: ERROR_NO_SUCH_USER
'//
'// MessageText:
'//
'// The specified account does not exist.
'//
%ERROR_NO_SUCH_USER               = 1317&

'//
'// MessageId: ERROR_GROUP_EXISTS
'//
'// MessageText:
'//
'// The specified group already exists.
'//
%ERROR_GROUP_EXISTS               = 1318&

'//
'// MessageId: ERROR_NO_SUCH_GROUP
'//
'// MessageText:
'//
'// The specified group does not exist.
'//
%ERROR_NO_SUCH_GROUP              = 1319&

'//
'// MessageId: ERROR_MEMBER_IN_GROUP
'//
'// MessageText:
'//
'// Either the specified user account is already a member of the specified group, or the specified group cannot be deleted because it contains a member.
'//
%ERROR_MEMBER_IN_GROUP            = 1320&

'//
'// MessageId: ERROR_MEMBER_NOT_IN_GROUP
'//
'// MessageText:
'//
'// The specified user account is not a member of the specified group account.
'//
%ERROR_MEMBER_NOT_IN_GROUP        = 1321&

'//
'// MessageId: ERROR_LAST_ADMIN
'//
'// MessageText:
'//
'// The last remaining administration account cannot be disabled or deleted.
'//
%ERROR_LAST_ADMIN                 = 1322&

'//
'// MessageId: ERROR_WRONG_PASSWORD
'//
'// MessageText:
'//
'// Unable to update the password. The value provided as the current password is incorrect.
'//
%ERROR_WRONG_PASSWORD             = 1323&

'//
'// MessageId: ERROR_ILL_FORMED_PASSWORD
'//
'// MessageText:
'//
'// Unable to update the password. The value provided for the new password contains values that are not allowed in passwords.
'//
%ERROR_ILL_FORMED_PASSWORD        = 1324&

'//
'// MessageId: ERROR_PASSWORD_RESTRICTION
'//
'// MessageText:
'//
'// Unable to update the password. The value provided for the new password does not meet the length, complexity, or history requirements of the domain.
'//
%ERROR_PASSWORD_RESTRICTION       = 1325&

'//
'// MessageId: ERROR_LOGON_FAILURE
'//
'// MessageText:
'//
'// Logon failure: unknown user name or bad password.
'//
%ERROR_LOGON_FAILURE              = 1326&

'//
'// MessageId: ERROR_ACCOUNT_RESTRICTION
'//
'// MessageText:
'//
'// Logon failure: user account restriction. Possible reasons are blank passwords not allowed, logon hour restrictions, or a policy restriction has been enforced.
'//
%ERROR_ACCOUNT_RESTRICTION        = 1327&

'//
'// MessageId: ERROR_INVALID_LOGON_HOURS
'//
'// MessageText:
'//
'// Logon failure: account logon time restriction violation.
'//
%ERROR_INVALID_LOGON_HOURS        = 1328&

'//
'// MessageId: ERROR_INVALID_WORKSTATION
'//
'// MessageText:
'//
'// Logon failure: user not allowed to log on to this computer.
'//
%ERROR_INVALID_WORKSTATION        = 1329&

'//
'// MessageId: ERROR_PASSWORD_EXPIRED
'//
'// MessageText:
'//
'// Logon failure: the specified account password has expired.
'//
%ERROR_PASSWORD_EXPIRED           = 1330&

'//
'// MessageId: ERROR_ACCOUNT_DISABLED
'//
'// MessageText:
'//
'// Logon failure: account currently disabled.
'//
%ERROR_ACCOUNT_DISABLED           = 1331&

'//
'// MessageId: ERROR_NONE_MAPPED
'//
'// MessageText:
'//
'// No mapping between account names and security IDs was done.
'//
%ERROR_NONE_MAPPED                = 1332&

'//
'// MessageId: ERROR_TOO_MANY_LUIDS_REQUESTED
'//
'// MessageText:
'//
'// Too many local user identifiers (LUIDs) were requested at one time.
'//
%ERROR_TOO_MANY_LUIDS_REQUESTED   = 1333&

'//
'// MessageId: ERROR_LUIDS_EXHAUSTED
'//
'// MessageText:
'//
'// No more local user identifiers (LUIDs) are available.
'//
%ERROR_LUIDS_EXHAUSTED            = 1334&

'//
'// MessageId: ERROR_INVALID_SUB_AUTHORITY
'//
'// MessageText:
'//
'// The subauthority part of a security ID is invalid for this particular use.
'//
%ERROR_INVALID_SUB_AUTHORITY      = 1335&

'//
'// MessageId: ERROR_INVALID_ACL
'//
'// MessageText:
'//
'// The access control list (AC& structure is invalid.
'//
%ERROR_INVALID_ACL                = 1336&

'//
'// MessageId: ERROR_INVALID_SID
'//
'// MessageText:
'//
'// The security ID structure is invalid.
'//
%ERROR_INVALID_SID                = 1337&

'//
'// MessageId: ERROR_INVALID_SECURITY_DESCR
'//
'// MessageText:
'//
'// The security descriptor structure is invalid.
'//
%ERROR_INVALID_SECURITY_DESCR     = 1338&

'//
'// MessageId: ERROR_BAD_INHERITANCE_ACL
'//
'// MessageText:
'//
'// The inherited access control list (AC& or access control entry (ACE) could not be built.
'//
%ERROR_BAD_INHERITANCE_ACL        = 1340&

'//
'// MessageId: ERROR_SERVER_DISABLED
'//
'// MessageText:
'//
'// The server is currently disabled.
'//
%ERROR_SERVER_DISABLED            = 1341&

'//
'// MessageId: ERROR_SERVER_NOT_DISABLED
'//
'// MessageText:
'//
'// The server is currently enabled.
'//
%ERROR_SERVER_NOT_DISABLED        = 1342&

'//
'// MessageId: ERROR_INVALID_ID_AUTHORITY
'//
'// MessageText:
'//
'// The value provided was an invalid value for an identifier authority.
'//
%ERROR_INVALID_ID_AUTHORITY       = 1343&

'//
'// MessageId: ERROR_ALLOTTED_SPACE_EXCEEDED
'//
'// MessageText:
'//
'// No more memory is available for security information updates.
'//
%ERROR_ALLOTTED_SPACE_EXCEEDED    = 1344&

'//
'// MessageId: ERROR_INVALID_GROUP_ATTRIBUTES
'//
'// MessageText:
'//
'// The specified attributes are invalid, or incompatible with the attributes for the group as a whole.
'//
%ERROR_INVALID_GROUP_ATTRIBUTES   = 1345&

'//
'// MessageId: ERROR_BAD_IMPERSONATION_LEVEL
'//
'// MessageText:
'//
'// Either a required impersonation level was not provided, or the provided impersonation level is invalid.
'//
%ERROR_BAD_IMPERSONATION_LEVEL    = 1346&

'//
'// MessageId: ERROR_CANT_OPEN_ANONYMOUS
'//
'// MessageText:
'//
'// Cannot open an anonymous level security token.
'//
%ERROR_CANT_OPEN_ANONYMOUS        = 1347&

'//
'// MessageId: ERROR_BAD_VALIDATION_CLASS
'//
'// MessageText:
'//
'// The validation information class requested was invalid.
'//
%ERROR_BAD_VALIDATION_CLASS       = 1348&

'//
'// MessageId: ERROR_BAD_TOKEN_TYPE
'//
'// MessageText:
'//
'// The type of the token is inappropriate for its attempted use.
'//
%ERROR_BAD_TOKEN_TYPE             = 1349&

'//
'// MessageId: ERROR_NO_SECURITY_ON_OBJECT
'//
'// MessageText:
'//
'// Unable to perform a security operation on an object that has no associated security.
'//
%ERROR_NO_SECURITY_ON_OBJECT      = 1350&

'//
'// MessageId: ERROR_CANT_ACCESS_DOMAIN_INFO
'//
'// MessageText:
'//
'// Configuration information could not be read from the domain controller, either because the machine is unavailable, or access has been denied.
'//
%ERROR_CANT_ACCESS_DOMAIN_INFO    = 1351&

'//
'// MessageId: ERROR_INVALID_SERVER_STATE
'//
'// MessageText:
'//
'// The security account manager (SAM) or local security authority (LSA) server was in the wrong state to perform the security operation.
'//
%ERROR_INVALID_SERVER_STATE       = 1352&

'//
'// MessageId: ERROR_INVALID_DOMAIN_STATE
'//
'// MessageText:
'//
'// The domain was in the wrong state to perform the security operation.
'//
%ERROR_INVALID_DOMAIN_STATE       = 1353&

'//
'// MessageId: ERROR_INVALID_DOMAIN_ROLE
'//
'// MessageText:
'//
'// This operation is only allowed for the Primary Domain Controller of the domain.
'//
%ERROR_INVALID_DOMAIN_ROLE        = 1354&

'//
'// MessageId: ERROR_NO_SUCH_DOMAIN
'//
'// MessageText:
'//
'// The specified domain either does not exist or could not be contacted.
'//
%ERROR_NO_SUCH_DOMAIN             = 1355&

'//
'// MessageId: ERROR_DOMAIN_EXISTS
'//
'// MessageText:
'//
'// The specified domain already exists.
'//
%ERROR_DOMAIN_EXISTS              = 1356&

'//
'// MessageId: ERROR_DOMAIN_LIMIT_EXCEEDED
'//
'// MessageText:
'//
'// An attempt was made to exceed the limit on the number of domains per server.
'//
%ERROR_DOMAIN_LIMIT_EXCEEDED      = 1357&

'//
'// MessageId: ERROR_INTERNAL_DB_CORRUPTION
'//
'// MessageText:
'//
'// Unable to complete the requested operation because of either a catastrophic media failure or a data structure corruption on the disk.
'//
%ERROR_INTERNAL_DB_CORRUPTION     = 1358&

'//
'// MessageId: ERROR_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal error occurred.
'//
%ERROR_INTERNAL_ERROR             = 1359&

'//
'// MessageId: ERROR_GENERIC_NOT_MAPPED
'//
'// MessageText:
'//
'// Generic access types were contained in an access mask which should already be mapped to nongeneric types.
'//
%ERROR_GENERIC_NOT_MAPPED         = 1360&

'//
'// MessageId: ERROR_BAD_DESCRIPTOR_FORMAT
'//
'// MessageText:
'//
'// A security descriptor is not in the right format (absolute or self-relative).
'//
%ERROR_BAD_DESCRIPTOR_FORMAT      = 1361&

'//
'// MessageId: ERROR_NOT_LOGON_PROCESS
'//
'// MessageText:
'//
'// The requested action is restricted for use by logon processes only. The calling process has not registered as a logon process.
'//
%ERROR_NOT_LOGON_PROCESS          = 1362&

'//
'// MessageId: ERROR_LOGON_SESSION_EXISTS
'//
'// MessageText:
'//
'// Cannot start a new logon session with an ID that is already in use.
'//
%ERROR_LOGON_SESSION_EXISTS       = 1363&

'//
'// MessageId: ERROR_NO_SUCH_PACKAGE
'//
'// MessageText:
'//
'// A specified authentication package is unknown.
'//
%ERROR_NO_SUCH_PACKAGE            = 1364&

'//
'// MessageId: ERROR_BAD_LOGON_SESSION_STATE
'//
'// MessageText:
'//
'// The logon session is not in a state that is consistent with the requested operation.
'//
%ERROR_BAD_LOGON_SESSION_STATE    = 1365&

'//
'// MessageId: ERROR_LOGON_SESSION_COLLISION
'//
'// MessageText:
'//
'// The logon session ID is already in use.
'//
%ERROR_LOGON_SESSION_COLLISION    = 1366&

'//
'// MessageId: ERROR_INVALID_LOGON_TYPE
'//
'// MessageText:
'//
'// A logon request contained an invalid logon type value.
'//
%ERROR_INVALID_LOGON_TYPE         = 1367&

'//
'// MessageId: ERROR_CANNOT_IMPERSONATE
'//
'// MessageText:
'//
'// Unable to impersonate using a named pipe until data has been read from that pipe.
'//
%ERROR_CANNOT_IMPERSONATE         = 1368&

'//
'// MessageId: ERROR_RXACT_INVALID_STATE
'//
'// MessageText:
'//
'// The transaction state of a registry subtree is incompatible with the requested operation.
'//
%ERROR_RXACT_INVALID_STATE        = 1369&

'//
'// MessageId: ERROR_RXACT_COMMIT_FAILURE
'//
'// MessageText:
'//
'// An internal security database corruption has been encountered.
'//
%ERROR_RXACT_COMMIT_FAILURE       = 1370&

'//
'// MessageId: ERROR_SPECIAL_ACCOUNT
'//
'// MessageText:
'//
'// Cannot perform this operation on built-in accounts.
'//
%ERROR_SPECIAL_ACCOUNT            = 1371&

'//
'// MessageId: ERROR_SPECIAL_GROUP
'//
'// MessageText:
'//
'// Cannot perform this operation on this built-in special group.
'//
%ERROR_SPECIAL_GROUP              = 1372&

'//
'// MessageId: ERROR_SPECIAL_USER
'//
'// MessageText:
'//
'// Cannot perform this operation on this built-in special user.
'//
%ERROR_SPECIAL_USER               = 1373&

'//
'// MessageId: ERROR_MEMBERS_PRIMARY_GROUP
'//
'// MessageText:
'//
'// The user cannot be removed from a group because the group is currently the user's primary group.
'//
%ERROR_MEMBERS_PRIMARY_GROUP      = 1374&

'//
'// MessageId: ERROR_TOKEN_ALREADY_IN_USE
'//
'// MessageText:
'//
'// The token is already in use as a primary token.
'//
%ERROR_TOKEN_ALREADY_IN_USE       = 1375&

'//
'// MessageId: ERROR_NO_SUCH_ALIAS
'//
'// MessageText:
'//
'// The specified local group does not exist.
'//
%ERROR_NO_SUCH_ALIAS              = 1376&

'//
'// MessageId: ERROR_MEMBER_NOT_IN_ALIAS
'//
'// MessageText:
'//
'// The specified account name is not a member of the group.
'//
%ERROR_MEMBER_NOT_IN_ALIAS        = 1377&

'//
'// MessageId: ERROR_MEMBER_IN_ALIAS
'//
'// MessageText:
'//
'// The specified account name is already a member of the group.
'//
%ERROR_MEMBER_IN_ALIAS            = 1378&

'//
'// MessageId: ERROR_ALIAS_EXISTS
'//
'// MessageText:
'//
'// The specified local group already exists.
'//
%ERROR_ALIAS_EXISTS               = 1379&

'//
'// MessageId: ERROR_LOGON_NOT_GRANTED
'//
'// MessageText:
'//
'// Logon failure: the user has not been granted the requested logon type at this computer.
'//
%ERROR_LOGON_NOT_GRANTED          = 1380&

'//
'// MessageId: ERROR_TOO_MANY_SECRETS
'//
'// MessageText:
'//
'// The maximum number of secrets that may be stored in a single system has been exceeded.
'//
%ERROR_TOO_MANY_SECRETS           = 1381&

'//
'// MessageId: ERROR_SECRET_TOO_LONG
'//
'// MessageText:
'//
'// The length of a secret exceeds the maximum length allowed.
'//
%ERROR_SECRET_TOO_LONG            = 1382&

'//
'// MessageId: ERROR_INTERNAL_DB_ERROR
'//
'// MessageText:
'//
'// The local security authority database contains an internal inconsistency.
'//
%ERROR_INTERNAL_DB_ERROR          = 1383&

'//
'// MessageId: ERROR_TOO_MANY_CONTEXT_IDS
'//
'// MessageText:
'//
'// During a logon attempt, the user's security context accumulated too many security IDs.
'//
%ERROR_TOO_MANY_CONTEXT_IDS       = 1384&

'//
'// MessageId: ERROR_LOGON_TYPE_NOT_GRANTED
'//
'// MessageText:
'//
'// Logon failure: the user has not been granted the requested logon type at this computer.
'//
%ERROR_LOGON_TYPE_NOT_GRANTED     = 1385&

'//
'// MessageId: ERROR_NT_CROSS_ENCRYPTION_REQUIRED
'//
'// MessageText:
'//
'// A cross-encrypted password is necessary to change a user password.
'//
%ERROR_NT_CROSS_ENCRYPTION_REQUIRED = 1386&

'//
'// MessageId: ERROR_NO_SUCH_MEMBER
'//
'// MessageText:
'//
'// A member could not be added to or removed from the local group because the member does not exist.
'//
%ERROR_NO_SUCH_MEMBER             = 1387&

'//
'// MessageId: ERROR_INVALID_MEMBER
'//
'// MessageText:
'//
'// A new member could not be added to a local group because the member has the wrong account type.
'//
%ERROR_INVALID_MEMBER             = 1388&

'//
'// MessageId: ERROR_TOO_MANY_SIDS
'//
'// MessageText:
'//
'// Too many security IDs have been specified.
'//
%ERROR_TOO_MANY_SIDS              = 1389&

'//
'// MessageId: ERROR_LM_CROSS_ENCRYPTION_REQUIRED
'//
'// MessageText:
'//
'// A cross-encrypted password is necessary to change this user password.
'//
%ERROR_LM_CROSS_ENCRYPTION_REQUIRED = 1390&

'//
'// MessageId: ERROR_NO_INHERITANCE
'//
'// MessageText:
'//
'// Indicates an ACL contains no inheritable components.
'//
%ERROR_NO_INHERITANCE             = 1391&

'//
'// MessageId: ERROR_FILE_CORRUPT
'//
'// MessageText:
'//
'// The file or directory is corrupted and unreadable.
'//
%ERROR_FILE_CORRUPT               = 1392&

'//
'// MessageId: ERROR_DISK_CORRUPT
'//
'// MessageText:
'//
'// The disk structure is corrupted and unreadable.
'//
%ERROR_DISK_CORRUPT               = 1393&

'//
'// MessageId: ERROR_NO_USER_SESSION_KEY
'//
'// MessageText:
'//
'// There is no user session key for the specified logon session.
'//
%ERROR_NO_USER_SESSION_KEY        = 1394&

'//
'// MessageId: ERROR_LICENSE_QUOTA_EXCEEDED
'//
'// MessageText:
'//
'// The service being accessed is licensed for a particular number of connections.
'// No more connections can be made to the service at this time because there are already as many connections as the service can accept.
'//
%ERROR_LICENSE_QUOTA_EXCEEDED     = 1395&

'//
'// MessageId: ERROR_WRONG_TARGET_NAME
'//
'// MessageText:
'//
'// Logon Failure: The target account name is incorrect.
'//
%ERROR_WRONG_TARGET_NAME          = 1396&

'//
'// MessageId: ERROR_MUTUAL_AUTH_FAILED
'//
'// MessageText:
'//
'// Mutual Authentication failed. The server's password is out of date at the domain controller.
'//
%ERROR_MUTUAL_AUTH_FAILED         = 1397&

'//
'// MessageId: ERROR_TIME_SKEW
'//
'// MessageText:
'//
'// There is a time and/or date difference between the client and server.
'//
%ERROR_TIME_SKEW                  = 1398&

'//
'// MessageId: ERROR_CURRENT_DOMAIN_NOT_ALLOWED
'//
'// MessageText:
'//
'// This operation cannot be performed on the current domain.
'//
%ERROR_CURRENT_DOMAIN_NOT_ALLOWED = 1399&


'///////////////////////////////////////////////////
'//                                               //
'//              WinUser Error codes              //
'//                                               //
'//                 = 1400 to 1499                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_INVALID_WINDOW_HANDLE
'//
'// MessageText:
'//
'// Invalid window handle.
'//
%ERROR_INVALID_WINDOW_HANDLE      = 1400&

'//
'// MessageId: ERROR_INVALID_MENU_HANDLE
'//
'// MessageText:
'//
'// Invalid menu handle.
'//
%ERROR_INVALID_MENU_HANDLE        = 1401&

'//
'// MessageId: ERROR_INVALID_CURSOR_HANDLE
'//
'// MessageText:
'//
'// Invalid cursor handle.
'//
%ERROR_INVALID_CURSOR_HANDLE      = 1402&

'//
'// MessageId: ERROR_INVALID_ACCEL_HANDLE
'//
'// MessageText:
'//
'// Invalid accelerator table handle.
'//
%ERROR_INVALID_ACCEL_HANDLE       = 1403&

'//
'// MessageId: ERROR_INVALID_HOOK_HANDLE
'//
'// MessageText:
'//
'// Invalid hook handle.
'//
%ERROR_INVALID_HOOK_HANDLE        = 1404&

'//
'// MessageId: ERROR_INVALID_DWP_HANDLE
'//
'// MessageText:
'//
'// Invalid handle to a multiple-window position structure.
'//
%ERROR_INVALID_DWP_HANDLE         = 1405&

'//
'// MessageId: ERROR_TLW_WITH_WSCHILD
'//
'// MessageText:
'//
'// Cannot create a top-level child window.
'//
%ERROR_TLW_WITH_WSCHILD           = 1406&

'//
'// MessageId: ERROR_CANNOT_FIND_WND_CLASS
'//
'// MessageText:
'//
'// Cannot find window class.
'//
%ERROR_CANNOT_FIND_WND_CLASS      = 1407&

'//
'// MessageId: ERROR_WINDOW_OF_OTHER_THREAD
'//
'// MessageText:
'//
'// Invalid window; it belongs to other thread.
'//
%ERROR_WINDOW_OF_OTHER_THREAD     = 1408&

'//
'// MessageId: ERROR_HOTKEY_ALREADY_REGISTERED
'//
'// MessageText:
'//
'// Hot key is already registered.
'//
%ERROR_HOTKEY_ALREADY_REGISTERED = 1409&

'//
'// MessageId: ERROR_CLASS_ALREADY_EXISTS
'//
'// MessageText:
'//
'// Class already exists.
'//
%ERROR_CLASS_ALREADY_EXISTS       = 1410&

'//
'// MessageId: ERROR_CLASS_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// Class does not exist.
'//
%ERROR_CLASS_DOES_NOT_EXIST       = 1411&

'//
'// MessageId: ERROR_CLASS_HAS_WINDOWS
'//
'// MessageText:
'//
'// Class still has open windows.
'//
%ERROR_CLASS_HAS_WINDOWS          = 1412&

'//
'// MessageId: ERROR_INVALID_INDEX
'//
'// MessageText:
'//
'// Invalid index.
'//
%ERROR_INVALID_INDEX              = 1413&

'//
'// MessageId: ERROR_INVALID_ICON_HANDLE
'//
'// MessageText:
'//
'// Invalid icon handle.
'//
%ERROR_INVALID_ICON_HANDLE        = 1414&

'//
'// MessageId: ERROR_PRIVATE_DIALOG_INDEX
'//
'// MessageText:
'//
'// Using private DIALOG window words.
'//
%ERROR_PRIVATE_DIALOG_INDEX       = 1415&

'//
'// MessageId: ERROR_LISTBOX_ID_NOT_FOUND
'//
'// MessageText:
'//
'// The list box identifier was not found.
'//
%ERROR_LISTBOX_ID_NOT_FOUND       = 1416&

'//
'// MessageId: ERROR_NO_WILDCARD_CHARACTERS
'//
'// MessageText:
'//
'// No wildcards were found.
'//
%ERROR_NO_WILDCARD_CHARACTERS     = 1417&

'//
'// MessageId: ERROR_CLIPBOARD_NOT_OPEN
'//
'// MessageText:
'//
'// Thread does not have a clipboard open.
'//
%ERROR_CLIPBOARD_NOT_OPEN         = 1418&

'//
'// MessageId: ERROR_HOTKEY_NOT_REGISTERED
'//
'// MessageText:
'//
'// Hot key is not registered.
'//
%ERROR_HOTKEY_NOT_REGISTERED      = 1419&

'//
'// MessageId: ERROR_WINDOW_NOT_DIALOG
'//
'// MessageText:
'//
'// The window is not a valid dialog window.
'//
%ERROR_WINDOW_NOT_DIALOG          = 1420&

'//
'// MessageId: ERROR_CONTROL_ID_NOT_FOUND
'//
'// MessageText:
'//
'// Control ID not found.
'//
%ERROR_CONTROL_ID_NOT_FOUND       = 1421&

'//
'// MessageId: ERROR_INVALID_COMBOBOX_MESSAGE
'//
'// MessageText:
'//
'// Invalid message for a combo box because it does not have an edit control.
'//
%ERROR_INVALID_COMBOBOX_MESSAGE   = 1422&

'//
'// MessageId: ERROR_WINDOW_NOT_COMBOBOX
'//
'// MessageText:
'//
'// The window is not a combo box.
'//
%ERROR_WINDOW_NOT_COMBOBOX        = 1423&

'//
'// MessageId: ERROR_INVALID_EDIT_HEIGHT
'//
'// MessageText:
'//
'// Height must be less than 256.
'//
%ERROR_INVALID_EDIT_HEIGHT        = 1424&

'//
'// MessageId: ERROR_DC_NOT_FOUND
'//
'// MessageText:
'//
'// Invalid device context (DC) handle.
'//
%ERROR_DC_NOT_FOUND               = 1425&

'//
'// MessageId: ERROR_INVALID_HOOK_FILTER
'//
'// MessageText:
'//
'// Invalid hook procedure type.
'//
%ERROR_INVALID_HOOK_FILTER        = 1426&

'//
'// MessageId: ERROR_INVALID_FILTER_PROC
'//
'// MessageText:
'//
'// Invalid hook procedure.
'//
%ERROR_INVALID_FILTER_PROC        = 1427&

'//
'// MessageId: ERROR_HOOK_NEEDS_HMOD
'//
'// MessageText:
'//
'// Cannot set nonlocal hook without a module handle.
'//
%ERROR_HOOK_NEEDS_HMOD            = 1428&

'//
'// MessageId: ERROR_GLOBAL_ONLY_HOOK
'//
'// MessageText:
'//
'// This hook procedure can only be set globally.
'//
%ERROR_GLOBAL_ONLY_HOOK           = 1429&

'//
'// MessageId: ERROR_JOURNAL_HOOK_SET
'//
'// MessageText:
'//
'// The journal hook procedure is already installed.
'//
%ERROR_JOURNAL_HOOK_SET           = 1430&

'//
'// MessageId: ERROR_HOOK_NOT_INSTALLED
'//
'// MessageText:
'//
'// The hook procedure is not installed.
'//
%ERROR_HOOK_NOT_INSTALLED         = 1431&

'//
'// MessageId: ERROR_INVALID_LB_MESSAGE
'//
'// MessageText:
'//
'// Invalid message for single-selection list box.
'//
%ERROR_INVALID_LB_MESSAGE         = 1432&

'//
'// MessageId: ERROR_SETCOUNT_ON_BAD_LB
'//
'// MessageText:
'//
'// LB_SETCOUNT sent to non-lazy list box.
'//
%ERROR_SETCOUNT_ON_BAD_LB         = 1433&

'//
'// MessageId: ERROR_LB_WITHOUT_TABSTOPS
'//
'// MessageText:
'//
'// This list box does not support tab stops.
'//
%ERROR_LB_WITHOUT_TABSTOPS        = 1434&

'//
'// MessageId: ERROR_DESTROY_OBJECT_OF_OTHER_THREAD
'//
'// MessageText:
'//
'// Cannot destroy object created by another thread.
'//
%ERROR_DESTROY_OBJECT_OF_OTHER_THREAD = 1435&

'//
'// MessageId: ERROR_CHILD_WINDOW_MENU
'//
'// MessageText:
'//
'// Child windows cannot have menus.
'//
%ERROR_CHILD_WINDOW_MENU          = 1436&

'//
'// MessageId: ERROR_NO_SYSTEM_MENU
'//
'// MessageText:
'//
'// The window does not have a system menu.
'//
%ERROR_NO_SYSTEM_MENU             = 1437&

'//
'// MessageId: ERROR_INVALID_MSGBOX_STYLE
'//
'// MessageText:
'//
'// Invalid message box style.
'//
%ERROR_INVALID_MSGBOX_STYLE       = 1438&

'//
'// MessageId: ERROR_INVALID_SPI_VALUE
'//
'// MessageText:
'//
'// Invalid system-wide (SPI_*) parameter.
'//
%ERROR_INVALID_SPI_VALUE          = 1439&

'//
'// MessageId: ERROR_SCREEN_ALREADY_LOCKED
'//
'// MessageText:
'//
'// Screen already locked.
'//
%ERROR_SCREEN_ALREADY_LOCKED      = 1440&

'//
'// MessageId: ERROR_HWNDS_HAVE_DIFF_PARENT
'//
'// MessageText:
'//
'// All handles to windows in a multiple-window position structure must have the same parent.
'//
%ERROR_HWNDS_HAVE_DIFF_PARENT     = 1441&

'//
'// MessageId: ERROR_NOT_CHILD_WINDOW
'//
'// MessageText:
'//
'// The window is not a child window.
'//
%ERROR_NOT_CHILD_WINDOW           = 1442&

'//
'// MessageId: ERROR_INVALID_GW_COMMAND
'//
'// MessageText:
'//
'// Invalid GW_* command.
'//
%ERROR_INVALID_GW_COMMAND         = 1443&

'//
'// MessageId: ERROR_INVALID_THREAD_ID
'//
'// MessageText:
'//
'// Invalid thread identifier.
'//
%ERROR_INVALID_THREAD_ID          = 1444&

'//
'// MessageId: ERROR_NON_MDICHILD_WINDOW
'//
'// MessageText:
'//
'// Cannot process a message from a window that is not a multiple document interface (MDI) window.
'//
%ERROR_NON_MDICHILD_WINDOW        = 1445&

'//
'// MessageId: ERROR_POPUP_ALREADY_ACTIVE
'//
'// MessageText:
'//
'// Popup menu already active.
'//
%ERROR_POPUP_ALREADY_ACTIVE       = 1446&

'//
'// MessageId: ERROR_NO_SCROLLBARS
'//
'// MessageText:
'//
'// The window does not have scroll bars.
'//
%ERROR_NO_SCROLLBARS              = 1447&

'//
'// MessageId: ERROR_INVALID_SCROLLBAR_RANGE
'//
'// MessageText:
'//
'// Scroll bar range cannot be greater than MAXLONG.
'//
%ERROR_INVALID_SCROLLBAR_RANGE    = 1448&

'//
'// MessageId: ERROR_INVALID_SHOWWIN_COMMAND
'//
'// MessageText:
'//
'// Cannot show or remove the window in the way specified.
'//
%ERROR_INVALID_SHOWWIN_COMMAND    = 1449&

'//
'// MessageId: ERROR_NO_SYSTEM_RESOURCES
'//
'// MessageText:
'//
'// Insufficient system resources exist to complete the requested service.
'//
%ERROR_NO_SYSTEM_RESOURCES        = 1450&

'//
'// MessageId: ERROR_NONPAGED_SYSTEM_RESOURCES
'//
'// MessageText:
'//
'// Insufficient system resources exist to complete the requested service.
'//
%ERROR_NONPAGED_SYSTEM_RESOURCES = 1451&

'//
'// MessageId: ERROR_PAGED_SYSTEM_RESOURCES
'//
'// MessageText:
'//
'// Insufficient system resources exist to complete the requested service.
'//
%ERROR_PAGED_SYSTEM_RESOURCES     = 1452&

'//
'// MessageId: ERROR_WORKING_SET_QUOTA
'//
'// MessageText:
'//
'// Insufficient quota to complete the requested service.
'//
%ERROR_WORKING_SET_QUOTA          = 1453&

'//
'// MessageId: ERROR_PAGEFILE_QUOTA
'//
'// MessageText:
'//
'// Insufficient quota to complete the requested service.
'//
%ERROR_PAGEFILE_QUOTA             = 1454&

'//
'// MessageId: ERROR_COMMITMENT_LIMIT
'//
'// MessageText:
'//
'// The paging file is too small for this operation to complete.
'//
%ERROR_COMMITMENT_LIMIT           = 1455&

'//
'// MessageId: ERROR_MENU_ITEM_NOT_FOUND
'//
'// MessageText:
'//
'// A menu item was not found.
'//
%ERROR_MENU_ITEM_NOT_FOUND        = 1456&

'//
'// MessageId: ERROR_INVALID_KEYBOARD_HANDLE
'//
'// MessageText:
'//
'// Invalid keyboard layout handle.
'//
%ERROR_INVALID_KEYBOARD_HANDLE    = 1457&

'//
'// MessageId: ERROR_HOOK_TYPE_NOT_ALLOWED
'//
'// MessageText:
'//
'// Hook type not allowed.
'//
%ERROR_HOOK_TYPE_NOT_ALLOWED      = 1458&

'//
'// MessageId: ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION
'//
'// MessageText:
'//
'// This operation requires an interactive window station.
'//
%ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION = 1459&

'//
'// MessageId: ERROR_TIMEOUT
'//
'// MessageText:
'//
'// This operation returned because the timeout period expired.
'//
%ERROR_TIMEOUT                    = 1460&

'//
'// MessageId: ERROR_INVALID_MONITOR_HANDLE
'//
'// MessageText:
'//
'// Invalid monitor handle.
'//
%ERROR_INVALID_MONITOR_HANDLE     = 1461&

'//
'// MessageId: ERROR_INCORRECT_SIZE
'//
'// MessageText:
'//
'//  Incorrect size argument.
'//
%ERROR_INCORRECT_SIZE             = 1462&

'//
'// MessageId: ERROR_SYMLINK_CLASS_DISABLED
'//
'// MessageText:
'//
'// The symbolic link cannot be followed because its type is disabled.
'//
%ERROR_SYMLINK_CLASS_DISABLED     = 1463&

'//
'// MessageId: ERROR_SYMLINK_NOT_SUPPORTED
'//
'// MessageText:
'//
'// This application does not support the current operation on symbolic links.
'//
%ERROR_SYMLINK_NOT_SUPPORTED      = 1464&

'//
'// MessageId: ERROR_XML_PARSE_ERROR
'//
'// MessageText:
'//
'// Windows was unable to parse the requested XML data.
'//
%ERROR_XML_PARSE_ERROR            = 1465&

'//
'// MessageId: ERROR_XMLDSIG_ERROR
'//
'// MessageText:
'//
'// An error was encountered while processing an XML digital signature.
'//
%ERROR_XMLDSIG_ERROR              = 1466&

'//
'// MessageId: ERROR_RESTART_APPLICATION
'//
'// MessageText:
'//
'// This application must be restarted.
'//
%ERROR_RESTART_APPLICATION        = 1467&

'//
'// MessageId: ERROR_WRONG_COMPARTMENT
'//
'// MessageText:
'//
'// The caller made the connection request in the wrong routing compartment.
'//
%ERROR_WRONG_COMPARTMENT          = 1468&

'//
'// MessageId: ERROR_AUTHIP_FAILURE
'//
'// MessageText:
'//
'// There was an AuthIP failure when attempting to connect to the remote host.
'//
%ERROR_AUTHIP_FAILURE             = 1469&


'///////////////////////////////////////////////////
'//                                               //
'//             EventLog Error codes              //
'//                                               //
'//                 = 1500 to 1549                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_EVENTLOG_FILE_CORRUPT
'//
'// MessageText:
'//
'// The event log file is corrupted.
'//
%ERROR_EVENTLOG_FILE_CORRUPT      = 1500&

'//
'// MessageId: ERROR_EVENTLOG_CANT_START
'//
'// MessageText:
'//
'// No event log file could be opened, so the event logging service did not start.
'//
%ERROR_EVENTLOG_CANT_START        = 1501&

'//
'// MessageId: ERROR_LOG_FILE_FULL
'//
'// MessageText:
'//
'// The event log file is full.
'//
%ERROR_LOG_FILE_FULL              = 1502&

'//
'// MessageId: ERROR_EVENTLOG_FILE_CHANGED
'//
'// MessageText:
'//
'// The event log file has changed between read operations.
'//
%ERROR_EVENTLOG_FILE_CHANGED      = 1503&


'///////////////////////////////////////////////////
'//                                               //
'//            Class Scheduler Error codes        //
'//                                               //
'//                 = 1550 to 1599                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_INVALID_TASK_NAME
'//
'// MessageText:
'//
'// The specified task name is invalid.
'//
%ERROR_INVALID_TASK_NAME          = 1550&

'//
'// MessageId: ERROR_INVALID_TASK_INDEX
'//
'// MessageText:
'//
'// The specified task index is invalid.
'//
%ERROR_INVALID_TASK_INDEX         = 1551&

'//
'// MessageId: ERROR_THREAD_ALREADY_IN_TASK
'//
'// MessageText:
'//
'// The specified thread is already joining a task.
'//
%ERROR_THREAD_ALREADY_IN_TASK     = 1552&


'///////////////////////////////////////////////////
'//                                               //
'//                MSI Error codes                //
'//                                               //
'//                 = 1600 to 1699                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_INSTALL_SERVICE_FAILURE
'//
'// MessageText:
'//
'// The Windows Installer Service could not be accessed. This can occur if the Windows Installer is not correctly installed. Contact your support personnel for assistance.
'//
%ERROR_INSTALL_SERVICE_FAILURE    = 1601&

'//
'// MessageId: ERROR_INSTALL_USEREXIT
'//
'// MessageText:
'//
'// User cancelled installation.
'//
%ERROR_INSTALL_USEREXIT           = 1602&

'//
'// MessageId: ERROR_INSTALL_FAILURE
'//
'// MessageText:
'//
'// Fatal error during installation.
'//
%ERROR_INSTALL_FAILURE            = 1603&

'//
'// MessageId: ERROR_INSTALL_SUSPEND
'//
'// MessageText:
'//
'// Installation suspended, incomplete.
'//
%ERROR_INSTALL_SUSPEND            = 1604&

'//
'// MessageId: ERROR_UNKNOWN_PRODUCT
'//
'// MessageText:
'//
'// This action is only valid for products that are currently installed.
'//
%ERROR_UNKNOWN_PRODUCT            = 1605&

'//
'// MessageId: ERROR_UNKNOWN_FEATURE
'//
'// MessageText:
'//
'// Feature ID not registered.
'//
%ERROR_UNKNOWN_FEATURE            = 1606&

'//
'// MessageId: ERROR_UNKNOWN_COMPONENT
'//
'// MessageText:
'//
'// Component ID not registered.
'//
%ERROR_UNKNOWN_COMPONENT          = 1607&

'//
'// MessageId: ERROR_UNKNOWN_PROPERTY
'//
'// MessageText:
'//
'// Unknown property.
'//
%ERROR_UNKNOWN_PROPERTY           = 1608&

'//
'// MessageId: ERROR_INVALID_HANDLE_STATE
'//
'// MessageText:
'//
'// Handle is in an invalid state.
'//
%ERROR_INVALID_HANDLE_STATE       = 1609&

'//
'// MessageId: ERROR_BAD_CONFIGURATION
'//
'// MessageText:
'//
'// The configuration data for this product is corrupt. Contact your support personnel.
'//
%ERROR_BAD_CONFIGURATION          = 1610&

'//
'// MessageId: ERROR_INDEX_ABSENT
'//
'// MessageText:
'//
'// Component qualifier not present.
'//
%ERROR_INDEX_ABSENT               = 1611&

'//
'// MessageId: ERROR_INSTALL_SOURCE_ABSENT
'//
'// MessageText:
'//
'// The installation source for this product is not available. Verify that the source exists and that you can access it.
'//
%ERROR_INSTALL_SOURCE_ABSENT      = 1612&

'//
'// MessageId: ERROR_INSTALL_PACKAGE_VERSION
'//
'// MessageText:
'//
'// This installation package cannot be installed by the Windows Installer service. You must install a Windows service pack that contains a newer version of the Windows Installer service.
'//
%ERROR_INSTALL_PACKAGE_VERSION    = 1613&

'//
'// MessageId: ERROR_PRODUCT_UNINSTALLED
'//
'// MessageText:
'//
'// Product is uninstalled.
'//
%ERROR_PRODUCT_UNINSTALLED        = 1614&

'//
'// MessageId: ERROR_BAD_QUERY_SYNTAX
'//
'// MessageText:
'//
'// SQL query syntax invalid or unsupported.
'//
%ERROR_BAD_QUERY_SYNTAX           = 1615&

'//
'// MessageId: ERROR_INVALID_FIELD
'//
'// MessageText:
'//
'// Record field does not exist.
'//
%ERROR_INVALID_FIELD              = 1616&

'//
'// MessageId: ERROR_DEVICE_REMOVED
'//
'// MessageText:
'//
'// The device has been removed.
'//
%ERROR_DEVICE_REMOVED             = 1617&

'//
'// MessageId: ERROR_INSTALL_ALREADY_RUNNING
'//
'// MessageText:
'//
'// Another installation is already in progress. Complete that installation before proceeding with this install.
'//
%ERROR_INSTALL_ALREADY_RUNNING    = 1618&

'//
'// MessageId: ERROR_INSTALL_PACKAGE_OPEN_FAILED
'//
'// MessageText:
'//
'// This installation package could not be opened. Verify that the package exists and that you can access it, or contact the application vendor to verify that this is a valid Windows Installer package.
'//
%ERROR_INSTALL_PACKAGE_OPEN_FAILED = 1619&

'//
'// MessageId: ERROR_INSTALL_PACKAGE_INVALID
'//
'// MessageText:
'//
'// This installation package could not be opened. Contact the application vendor to verify that this is a valid Windows Installer package.
'//
%ERROR_INSTALL_PACKAGE_INVALID    = 1620&

'//
'// MessageId: ERROR_INSTALL_UI_FAILURE
'//
'// MessageText:
'//
'// There was an error starting the Windows Installer service user interface. Contact your support personnel.
'//
%ERROR_INSTALL_UI_FAILURE         = 1621&

'//
'// MessageId: ERROR_INSTALL_LOG_FAILURE
'//
'// MessageText:
'//
'// Error opening installation log file. Verify that the specified log file location exists and that you can write to it.
'//
%ERROR_INSTALL_LOG_FAILURE        = 1622&

'//
'// MessageId: ERROR_INSTALL_LANGUAGE_UNSUPPORTED
'//
'// MessageText:
'//
'// The language of this installation package is not supported by your system.
'//
%ERROR_INSTALL_LANGUAGE_UNSUPPORTED = 1623&

'//
'// MessageId: ERROR_INSTALL_TRANSFORM_FAILURE
'//
'// MessageText:
'//
'// Error applying transforms. Verify that the specified transform paths are valid.
'//
%ERROR_INSTALL_TRANSFORM_FAILURE = 1624&

'//
'// MessageId: ERROR_INSTALL_PACKAGE_REJECTED
'//
'// MessageText:
'//
'// This installation is forbidden by system policy. Contact your system administrator.
'//
%ERROR_INSTALL_PACKAGE_REJECTED   = 1625&

'//
'// MessageId: ERROR_FUNCTION_NOT_CALLED
'//
'// MessageText:
'//
'// Function could not be executed.
'//
%ERROR_FUNCTION_NOT_CALLED        = 1626&

'//
'// MessageId: ERROR_FUNCTION_FAILED
'//
'// MessageText:
'//
'// Function failed during execution.
'//
%ERROR_FUNCTION_FAILED            = 1627&

'//
'// MessageId: ERROR_INVALID_TABLE
'//
'// MessageText:
'//
'// Invalid or unknown table specified.
'//
%ERROR_INVALID_TABLE              = 1628&

'//
'// MessageId: ERROR_DATATYPE_MISMATCH
'//
'// MessageText:
'//
'// Data supplied is of wrong type.
'//
%ERROR_DATATYPE_MISMATCH          = 1629&

'//
'// MessageId: ERROR_UNSUPPORTED_TYPE
'//
'// MessageText:
'//
'// Data of this type is not supported.
'//
%ERROR_UNSUPPORTED_TYPE           = 1630&

'//
'// MessageId: ERROR_CREATE_FAILED
'//
'// MessageText:
'//
'// The Windows Installer service failed to start. Contact your support personnel.
'//
%ERROR_CREATE_FAILED              = 1631&

'//
'// MessageId: ERROR_INSTALL_TEMP_UNWRITABLE
'//
'// MessageText:
'//
'// The Temp folder is on a drive that is full or is inaccessible. Free up space on the drive or verify that you have write permission on the Temp folder.
'//
%ERROR_INSTALL_TEMP_UNWRITABLE    = 1632&

'//
'// MessageId: ERROR_INSTALL_PLATFORM_UNSUPPORTED
'//
'// MessageText:
'//
'// This installation package is not supported by this processor type. Contact your product vendor.
'//
%ERROR_INSTALL_PLATFORM_UNSUPPORTED = 1633&

'//
'// MessageId: ERROR_INSTALL_NOTUSED
'//
'// MessageText:
'//
'// Component not used on this computer.
'//
%ERROR_INSTALL_NOTUSED            = 1634&

'//
'// MessageId: ERROR_PATCH_PACKAGE_OPEN_FAILED
'//
'// MessageText:
'//
'// This update package could not be opened. Verify that the update package exists and that you can access it, or contact the application vendor to verify that this is a valid Windows Installer update package.
'//
%ERROR_PATCH_PACKAGE_OPEN_FAILED = 1635&

'//
'// MessageId: ERROR_PATCH_PACKAGE_INVALID
'//
'// MessageText:
'//
'// This update package could not be opened. Contact the application vendor to verify that this is a valid Windows Installer update package.
'//
%ERROR_PATCH_PACKAGE_INVALID      = 1636&

'//
'// MessageId: ERROR_PATCH_PACKAGE_UNSUPPORTED
'//
'// MessageText:
'//
'// This update package cannot be processed by the Windows Installer service. You must install a Windows service pack that contains a newer version of the Windows Installer service.
'//
%ERROR_PATCH_PACKAGE_UNSUPPORTED = 1637&

'//
'// MessageId: ERROR_PRODUCT_VERSION
'//
'// MessageText:
'//
'// Another version of this product is already installed. Installation of this version cannot continue. To configure or remove the existing version of this product, use Add/Remove Programs on the Control Panel.
'//
%ERROR_PRODUCT_VERSION            = 1638&

'//
'// MessageId: ERROR_INVALID_COMMAND_LINE
'//
'// MessageText:
'//
'// Invalid command line argument. Consult the Windows Installer SDK for detailed command line help.
'//
%ERROR_INVALID_COMMAND_LINE       = 1639&

'//
'// MessageId: ERROR_INSTALL_REMOTE_DISALLOWED
'//
'// MessageText:
'//
'// Only administrators have permission to add, remove, or configure server software during a Terminal services remote session. If you want to install or configure software on the server, contact your network administrator.
'//
%ERROR_INSTALL_REMOTE_DISALLOWED = 1640&

'//
'// MessageId: ERROR_SUCCESS_REBOOT_INITIATED
'//
'// MessageText:
'//
'// The requested operation completed successfully. The system will be restarted so the changes can take effect.
'//
%ERROR_SUCCESS_REBOOT_INITIATED   = 1641&

'//
'// MessageId: ERROR_PATCH_TARGET_NOT_FOUND
'//
'// MessageText:
'//
'// The upgrade cannot be installed by the Windows Installer service because the program to be upgraded may be missing, or the upgrade may update a different version of the program.
'// Verify that the program to be upgraded exists on your computer and that you have the correct upgrade.
'//
%ERROR_PATCH_TARGET_NOT_FOUND     = 1642&

'//
'// MessageId: ERROR_PATCH_PACKAGE_REJECTED
'//
'// MessageText:
'//
'// The update package is not permitted by software restriction policy.
'//
%ERROR_PATCH_PACKAGE_REJECTED     = 1643&

'//
'// MessageId: ERROR_INSTALL_TRANSFORM_REJECTED
'//
'// MessageText:
'//
'// One or more customizations are not permitted by software restriction policy.
'//
%ERROR_INSTALL_TRANSFORM_REJECTED = 1644&

'//
'// MessageId: ERROR_INSTALL_REMOTE_PROHIBITED
'//
'// MessageText:
'//
'// The Windows Installer does not permit installation from a Remote Desktop Connection.
'//
%ERROR_INSTALL_REMOTE_PROHIBITED = 1645&

'//
'// MessageId: ERROR_PATCH_REMOVAL_UNSUPPORTED
'//
'// MessageText:
'//
'// Uninstallation of the update package is not supported.
'//
%ERROR_PATCH_REMOVAL_UNSUPPORTED = 1646&

'//
'// MessageId: ERROR_UNKNOWN_PATCH
'//
'// MessageText:
'//
'// The update is not applied to this product.
'//
%ERROR_UNKNOWN_PATCH              = 1647&

'//
'// MessageId: ERROR_PATCH_NO_SEQUENCE
'//
'// MessageText:
'//
'// No valid sequence could be found for the set of updates.
'//
%ERROR_PATCH_NO_SEQUENCE          = 1648&

'//
'// MessageId: ERROR_PATCH_REMOVAL_DISALLOWED
'//
'// MessageText:
'//
'// Update removal was disallowed by policy.
'//
%ERROR_PATCH_REMOVAL_DISALLOWED   = 1649&

'//
'// MessageId: ERROR_INVALID_PATCH_XML
'//
'// MessageText:
'//
'// The XML update data is invalid.
'//
%ERROR_INVALID_PATCH_XML          = 1650&

'//
'// MessageId: ERROR_PATCH_MANAGED_ADVERTISED_PRODUCT
'//
'// MessageText:
'//
'// Windows Installer does not permit updating of managed advertised products. At least one feature of the product must be installed before applying the update.
'//
%ERROR_PATCH_MANAGED_ADVERTISED_PRODUCT = 1651&

'//
'// MessageId: ERROR_INSTALL_SERVICE_SAFEBOOT
'//
'// MessageText:
'//
'// The Windows Installer service is not accessible in Safe Mode. Please try again when your computer is not in Safe Mode or you can use System Restore to return your machine to a previous good state.
'//
%ERROR_INSTALL_SERVICE_SAFEBOOT   = 1652&


'///////////////////////////////////////////////////
'//                                               //
'//               RPC Error codes                 //
'//                                               //
'//                 = 1700 to 1999                //
'///////////////////////////////////////////////////

'//
'// MessageId: RPC_S_INVALID_STRING_BINDING
'//
'// MessageText:
'//
'// The string binding is invalid.
'//
%RPC_S_INVALID_STRING_BINDING     = 1700&

'//
'// MessageId: RPC_S_WRONG_KIND_OF_BINDING
'//
'// MessageText:
'//
'// The binding handle is not the correct type.
'//
%RPC_S_WRONG_KIND_OF_BINDING      = 1701&

'//
'// MessageId: RPC_S_INVALID_BINDING
'//
'// MessageText:
'//
'// The binding handle is invalid.
'//
%RPC_S_INVALID_BINDING            = 1702&

'//
'// MessageId: RPC_S_PROTSEQ_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The RPC protocol sequence is not supported.
'//
%RPC_S_PROTSEQ_NOT_SUPPORTED      = 1703&

'//
'// MessageId: RPC_S_INVALID_RPC_PROTSEQ
'//
'// MessageText:
'//
'// The RPC protocol sequence is invalid.
'//
%RPC_S_INVALID_RPC_PROTSEQ        = 1704&

'//
'// MessageId: RPC_S_INVALID_STRING_UUID
'//
'// MessageText:
'//
'// The string universal unique identifier (UUID) is invalid.
'//
%RPC_S_INVALID_STRING_UUID        = 1705&

'//
'// MessageId: RPC_S_INVALID_ENDPOINT_FORMAT
'//
'// MessageText:
'//
'// The endpoint format is invalid.
'//
%RPC_S_INVALID_ENDPOINT_FORMAT    = 1706&

'//
'// MessageId: RPC_S_INVALID_NET_ADDR
'//
'// MessageText:
'//
'// The network address is invalid.
'//
%RPC_S_INVALID_NET_ADDR           = 1707&

'//
'// MessageId: RPC_S_NO_ENDPOINT_FOUND
'//
'// MessageText:
'//
'// No endpoint was found.
'//
%RPC_S_NO_ENDPOINT_FOUND          = 1708&

'//
'// MessageId: RPC_S_INVALID_TIMEOUT
'//
'// MessageText:
'//
'// The timeout value is invalid.
'//
%RPC_S_INVALID_TIMEOUT            = 1709&

'//
'// MessageId: RPC_S_OBJECT_NOT_FOUND
'//
'// MessageText:
'//
'// The object universal unique identifier (UUID) was not found.
'//
%RPC_S_OBJECT_NOT_FOUND           = 1710&

'//
'// MessageId: RPC_S_ALREADY_REGISTERED
'//
'// MessageText:
'//
'// The object universal unique identifier (UUID) has already been registered.
'//
%RPC_S_ALREADY_REGISTERED         = 1711&

'//
'// MessageId: RPC_S_TYPE_ALREADY_REGISTERED
'//
'// MessageText:
'//
'// The type universal unique identifier (UUID) has already been registered.
'//
%RPC_S_TYPE_ALREADY_REGISTERED    = 1712&

'//
'// MessageId: RPC_S_ALREADY_LISTENING
'//
'// MessageText:
'//
'// The RPC server is already listening.
'//
%RPC_S_ALREADY_LISTENING          = 1713&

'//
'// MessageId: RPC_S_NO_PROTSEQS_REGISTERED
'//
'// MessageText:
'//
'// No protocol sequences have been registered.
'//
%RPC_S_NO_PROTSEQS_REGISTERED     = 1714&

'//
'// MessageId: RPC_S_NOT_LISTENING
'//
'// MessageText:
'//
'// The RPC server is not listening.
'//
%RPC_S_NOT_LISTENING              = 1715&

'//
'// MessageId: RPC_S_UNKNOWN_MGR_TYPE
'//
'// MessageText:
'//
'// The manager type is unknown.
'//
%RPC_S_UNKNOWN_MGR_TYPE           = 1716&

'//
'// MessageId: RPC_S_UNKNOWN_IF
'//
'// MessageText:
'//
'// The interface is unknown.
'//
%RPC_S_UNKNOWN_IF                 = 1717&

'//
'// MessageId: RPC_S_NO_BINDINGS
'//
'// MessageText:
'//
'// There are no bindings.
'//
%RPC_S_NO_BINDINGS                = 1718&

'//
'// MessageId: RPC_S_NO_PROTSEQS
'//
'// MessageText:
'//
'// There are no protocol sequences.
'//
%RPC_S_NO_PROTSEQS                = 1719&

'//
'// MessageId: RPC_S_CANT_CREATE_ENDPOINT
'//
'// MessageText:
'//
'// The endpoint cannot be created.
'//
%RPC_S_CANT_CREATE_ENDPOINT       = 1720&

'//
'// MessageId: RPC_S_OUT_OF_RESOURCES
'//
'// MessageText:
'//
'// Not enough resources are available to complete this operation.
'//
%RPC_S_OUT_OF_RESOURCES           = 1721&

'//
'// MessageId: RPC_S_SERVER_UNAVAILABLE
'//
'// MessageText:
'//
'// The RPC server is unavailable.
'//
%RPC_S_SERVER_UNAVAILABLE         = 1722&

'//
'// MessageId: RPC_S_SERVER_TOO_BUSY
'//
'// MessageText:
'//
'// The RPC server is too busy to complete this operation.
'//
%RPC_S_SERVER_TOO_BUSY            = 1723&

'//
'// MessageId: RPC_S_INVALID_NETWORK_OPTIONS
'//
'// MessageText:
'//
'// The network options are invalid.
'//
%RPC_S_INVALID_NETWORK_OPTIONS    = 1724&

'//
'// MessageId: RPC_S_NO_CALL_ACTIVE
'//
'// MessageText:
'//
'// There are no remote procedure calls active on this thread.
'//
%RPC_S_NO_CALL_ACTIVE             = 1725&

'//
'// MessageId: RPC_S_CALL_FAILED
'//
'// MessageText:
'//
'// The remote procedure call failed.
'//
%RPC_S_CALL_FAILED                = 1726&

'//
'// MessageId: RPC_S_CALL_FAILED_DNE
'//
'// MessageText:
'//
'// The remote procedure call failed and did not execute.
'//
%RPC_S_CALL_FAILED_DNE            = 1727&

'//
'// MessageId: RPC_S_PROTOCOL_ERROR
'//
'// MessageText:
'//
'// A remote procedure call (RPC) protocol error occurred.
'//
%RPC_S_PROTOCOL_ERROR             = 1728&

'//
'// MessageId: RPC_S_PROXY_ACCESS_DENIED
'//
'// MessageText:
'//
'// Access to the HTTP proxy is denied.
'//
%RPC_S_PROXY_ACCESS_DENIED        = 1729&

'//
'// MessageId: RPC_S_UNSUPPORTED_TRANS_SYN
'//
'// MessageText:
'//
'// The transfer syntax is not supported by the RPC server.
'//
%RPC_S_UNSUPPORTED_TRANS_SYN      = 1730&

'//
'// MessageId: RPC_S_UNSUPPORTED_TYPE
'//
'// MessageText:
'//
'// The universal unique identifier (UUID) type is not supported.
'//
%RPC_S_UNSUPPORTED_TYPE           = 1732&

'//
'// MessageId: RPC_S_INVALID_TAG
'//
'// MessageText:
'//
'// The tag is invalid.
'//
%RPC_S_INVALID_TAG                = 1733&

'//
'// MessageId: RPC_S_INVALID_BOUND
'//
'// MessageText:
'//
'// The array bounds are invalid.
'//
%RPC_S_INVALID_BOUND              = 1734&

'//
'// MessageId: RPC_S_NO_ENTRY_NAME
'//
'// MessageText:
'//
'// The binding does not contain an entry name.
'//
%RPC_S_NO_ENTRY_NAME              = 1735&

'//
'// MessageId: RPC_S_INVALID_NAME_SYNTAX
'//
'// MessageText:
'//
'// The name syntax is invalid.
'//
%RPC_S_INVALID_NAME_SYNTAX        = 1736&

'//
'// MessageId: RPC_S_UNSUPPORTED_NAME_SYNTAX
'//
'// MessageText:
'//
'// The name syntax is not supported.
'//
%RPC_S_UNSUPPORTED_NAME_SYNTAX    = 1737&

'//
'// MessageId: RPC_S_UUID_NO_ADDRESS
'//
'// MessageText:
'//
'// No network address is available to use to construct a universal unique identifier (UUID).
'//
%RPC_S_UUID_NO_ADDRESS            = 1739&

'//
'// MessageId: RPC_S_DUPLICATE_ENDPOINT
'//
'// MessageText:
'//
'// The endpoint is a duplicate.
'//
%RPC_S_DUPLICATE_ENDPOINT         = 1740&

'//
'// MessageId: RPC_S_UNKNOWN_AUTHN_TYPE
'//
'// MessageText:
'//
'// The authentication type is unknown.
'//
%RPC_S_UNKNOWN_AUTHN_TYPE         = 1741&

'//
'// MessageId: RPC_S_MAX_CALLS_TOO_SMALL
'//
'// MessageText:
'//
'// The maximum number of calls is too small.
'//
%RPC_S_MAX_CALLS_TOO_SMALL        = 1742&

'//
'// MessageId: RPC_S_STRING_TOO_LONG
'//
'// MessageText:
'//
'// The string is too long.
'//
%RPC_S_STRING_TOO_LONG            = 1743&

'//
'// MessageId: RPC_S_PROTSEQ_NOT_FOUND
'//
'// MessageText:
'//
'// The RPC protocol sequence was not found.
'//
%RPC_S_PROTSEQ_NOT_FOUND          = 1744&

'//
'// MessageId: RPC_S_PROCNUM_OUT_OF_RANGE
'//
'// MessageText:
'//
'// The procedure number is out of range.
'//
%RPC_S_PROCNUM_OUT_OF_RANGE       = 1745&

'//
'// MessageId: RPC_S_BINDING_HAS_NO_AUTH
'//
'// MessageText:
'//
'// The binding does not contain any authentication information.
'//
%RPC_S_BINDING_HAS_NO_AUTH        = 1746&

'//
'// MessageId: RPC_S_UNKNOWN_AUTHN_SERVICE
'//
'// MessageText:
'//
'// The authentication service is unknown.
'//
%RPC_S_UNKNOWN_AUTHN_SERVICE      = 1747&

'//
'// MessageId: RPC_S_UNKNOWN_AUTHN_LEVEL
'//
'// MessageText:
'//
'// The authentication level is unknown.
'//
%RPC_S_UNKNOWN_AUTHN_LEVEL        = 1748&

'//
'// MessageId: RPC_S_INVALID_AUTH_IDENTITY
'//
'// MessageText:
'//
'// The security context is invalid.
'//
%RPC_S_INVALID_AUTH_IDENTITY      = 1749&

'//
'// MessageId: RPC_S_UNKNOWN_AUTHZ_SERVICE
'//
'// MessageText:
'//
'// The authorization service is unknown.
'//
%RPC_S_UNKNOWN_AUTHZ_SERVICE      = 1750&

'//
'// MessageId: EPT_S_INVALID_ENTRY
'//
'// MessageText:
'//
'// The entry is invalid.
'//
%EPT_S_INVALID_ENTRY              = 1751&

'//
'// MessageId: EPT_S_CANT_PERFORM_OP
'//
'// MessageText:
'//
'// The server endpoint cannot perform the operation.
'//
%EPT_S_CANT_PERFORM_OP            = 1752&

'//
'// MessageId: EPT_S_NOT_REGISTERED
'//
'// MessageText:
'//
'// There are no more endpoints available from the endpoint mapper.
'//
%EPT_S_NOT_REGISTERED             = 1753&

'//
'// MessageId: RPC_S_NOTHING_TO_EXPORT
'//
'// MessageText:
'//
'// No interfaces have been exported.
'//
%RPC_S_NOTHING_TO_EXPORT          = 1754&

'//
'// MessageId: RPC_S_INCOMPLETE_NAME
'//
'// MessageText:
'//
'// The entry name is incomplete.
'//
%RPC_S_INCOMPLETE_NAME            = 1755&

'//
'// MessageId: RPC_S_INVALID_VERS_OPTION
'//
'// MessageText:
'//
'// The version option is invalid.
'//
%RPC_S_INVALID_VERS_OPTION        = 1756&

'//
'// MessageId: RPC_S_NO_MORE_MEMBERS
'//
'// MessageText:
'//
'// There are no more members.
'//
%RPC_S_NO_MORE_MEMBERS            = 1757&

'//
'// MessageId: RPC_S_NOT_ALL_OBJS_UNEXPORTED
'//
'// MessageText:
'//
'// There is nothing to unexport.
'//
%RPC_S_NOT_ALL_OBJS_UNEXPORTED    = 1758&

'//
'// MessageId: RPC_S_INTERFACE_NOT_FOUND
'//
'// MessageText:
'//
'// The interface was not found.
'//
%RPC_S_INTERFACE_NOT_FOUND        = 1759&

'//
'// MessageId: RPC_S_ENTRY_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The entry already exists.
'//
%RPC_S_ENTRY_ALREADY_EXISTS       = 1760&

'//
'// MessageId: RPC_S_ENTRY_NOT_FOUND
'//
'// MessageText:
'//
'// The entry is not found.
'//
%RPC_S_ENTRY_NOT_FOUND            = 1761&

'//
'// MessageId: RPC_S_NAME_SERVICE_UNAVAILABLE
'//
'// MessageText:
'//
'// The name service is unavailable.
'//
%RPC_S_NAME_SERVICE_UNAVAILABLE   = 1762&

'//
'// MessageId: RPC_S_INVALID_NAF_ID
'//
'// MessageText:
'//
'// The network address family is invalid.
'//
%RPC_S_INVALID_NAF_ID             = 1763&

'//
'// MessageId: RPC_S_CANNOT_SUPPORT
'//
'// MessageText:
'//
'// The requested operation is not supported.
'//
%RPC_S_CANNOT_SUPPORT             = 1764&

'//
'// MessageId: RPC_S_NO_CONTEXT_AVAILABLE
'//
'// MessageText:
'//
'// No security context is available to allow impersonation.
'//
%RPC_S_NO_CONTEXT_AVAILABLE       = 1765&

'//
'// MessageId: RPC_S_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal error occurred in a remote procedure call (RPC).
'//
%RPC_S_INTERNAL_ERROR             = 1766&

'//
'// MessageId: RPC_S_ZERO_DIVIDE
'//
'// MessageText:
'//
'// The RPC server attempted an integer division by zero.
'//
%RPC_S_ZERO_DIVIDE                = 1767&

'//
'// MessageId: RPC_S_ADDRESS_ERROR
'//
'// MessageText:
'//
'// An addressing error occurred in the RPC server.
'//
%RPC_S_ADDRESS_ERROR              = 1768&

'//
'// MessageId: RPC_S_FP_DIV_ZERO
'//
'// MessageText:
'//
'// A floating-point operation at the RPC server caused a division by zero.
'//
%RPC_S_FP_DIV_ZERO                = 1769&

'//
'// MessageId: RPC_S_FP_UNDERFLOW
'//
'// MessageText:
'//
'// A floating-point underflow occurred at the RPC server.
'//
%RPC_S_FP_UNDERFLOW               = 1770&

'//
'// MessageId: RPC_S_FP_OVERFLOW
'//
'// MessageText:
'//
'// A floating-point overflow occurred at the RPC server.
'//
%RPC_S_FP_OVERFLOW                = 1771&

'//
'// MessageId: RPC_X_NO_MORE_ENTRIES
'//
'// MessageText:
'//
'// The list of RPC servers available for the binding of auto handles has been exhausted.
'//
%RPC_X_NO_MORE_ENTRIES            = 1772&

'//
'// MessageId: RPC_X_SS_CHAR_TRANS_OPEN_FAIL
'//
'// MessageText:
'//
'// Unable to open the character translation table file.
'//
%RPC_X_SS_CHAR_TRANS_OPEN_FAIL    = 1773&

'//
'// MessageId: RPC_X_SS_CHAR_TRANS_SHORT_FILE
'//
'// MessageText:
'//
'// The file containing the character translation table has fewer than 512 bytes.
'//
%RPC_X_SS_CHAR_TRANS_SHORT_FILE   = 1774&

'//
'// MessageId: RPC_X_SS_IN_NULL_CONTEXT
'//
'// MessageText:
'//
'// A null context handle was passed from the client to the host during a remote procedure call.
'//
%RPC_X_SS_IN_NULL_CONTEXT         = 1775&

'//
'// MessageId: RPC_X_SS_CONTEXT_DAMAGED
'//
'// MessageText:
'//
'// The context handle changed during a remote procedure call.
'//
%RPC_X_SS_CONTEXT_DAMAGED         = 1777&

'//
'// MessageId: RPC_X_SS_HANDLES_MISMATCH
'//
'// MessageText:
'//
'// The binding handles passed to a remote procedure call do not match.
'//
%RPC_X_SS_HANDLES_MISMATCH        = 1778&

'//
'// MessageId: RPC_X_SS_CANNOT_GET_CALL_HANDLE
'//
'// MessageText:
'//
'// The stub is unable to get the remote procedure call handle.
'//
%RPC_X_SS_CANNOT_GET_CALL_HANDLE = 1779&

'//
'// MessageId: RPC_X_NULL_REF_POINTER
'//
'// MessageText:
'//
'// A null reference pointer was passed to the stub.
'//
%RPC_X_NULL_REF_POINTER           = 1780&

'//
'// MessageId: RPC_X_ENUM_VALUE_OUT_OF_RANGE
'//
'// MessageText:
'//
'// The enumeration value is out of range.
'//
%RPC_X_ENUM_VALUE_OUT_OF_RANGE    = 1781&

'//
'// MessageId: RPC_X_BYTE_COUNT_TOO_SMALL
'//
'// MessageText:
'//
'// The byte count is too small.
'//
%RPC_X_BYTE_COUNT_TOO_SMALL       = 1782&

'//
'// MessageId: RPC_X_BAD_STUB_DATA
'//
'// MessageText:
'//
'// The stub received bad data.
'//
%RPC_X_BAD_STUB_DATA              = 1783&

'//
'// MessageId: ERROR_INVALID_USER_BUFFER
'//
'// MessageText:
'//
'// The supplied user buffer is not valid for the requested operation.
'//
%ERROR_INVALID_USER_BUFFER        = 1784&

'//
'// MessageId: ERROR_UNRECOGNIZED_MEDIA
'//
'// MessageText:
'//
'// The disk media is not recognized. It may not be formatted.
'//
%ERROR_UNRECOGNIZED_MEDIA         = 1785&

'//
'// MessageId: ERROR_NO_TRUST_LSA_SECRET
'//
'// MessageText:
'//
'// The workstation does not have a trust secret.
'//
%ERROR_NO_TRUST_LSA_SECRET        = 1786&

'//
'// MessageId: ERROR_NO_TRUST_SAM_ACCOUNT
'//
'// MessageText:
'//
'// The security database on the server does not have a computer account for this workstation trust relationship.
'//
%ERROR_NO_TRUST_SAM_ACCOUNT       = 1787&

'//
'// MessageId: ERROR_TRUSTED_DOMAIN_FAILURE
'//
'// MessageText:
'//
'// The trust relationship between the primary domain and the trusted domain failed.
'//
%ERROR_TRUSTED_DOMAIN_FAILURE     = 1788&

'//
'// MessageId: ERROR_TRUSTED_RELATIONSHIP_FAILURE
'//
'// MessageText:
'//
'// The trust relationship between this workstation and the primary domain failed.
'//
%ERROR_TRUSTED_RELATIONSHIP_FAILURE = 1789&

'//
'// MessageId: ERROR_TRUST_FAILURE
'//
'// MessageText:
'//
'// The network logon failed.
'//
%ERROR_TRUST_FAILURE              = 1790&

'//
'// MessageId: RPC_S_CALL_IN_PROGRESS
'//
'// MessageText:
'//
'// A remote procedure call is already in progress for this thread.
'//
%RPC_S_CALL_IN_PROGRESS           = 1791&

'//
'// MessageId: ERROR_NETLOGON_NOT_STARTED
'//
'// MessageText:
'//
'// An attempt was made to logon, but the network logon service was not started.
'//
%ERROR_NETLOGON_NOT_STARTED       = 1792&

'//
'// MessageId: ERROR_ACCOUNT_EXPIRED
'//
'// MessageText:
'//
'// The user's account has expired.
'//
%ERROR_ACCOUNT_EXPIRED            = 1793&

'//
'// MessageId: ERROR_REDIRECTOR_HAS_OPEN_HANDLES
'//
'// MessageText:
'//
'// The redirector is in use and cannot be unloaded.
'//
%ERROR_REDIRECTOR_HAS_OPEN_HANDLES = 1794&

'//
'// MessageId: ERROR_PRINTER_DRIVER_ALREADY_INSTALLED
'//
'// MessageText:
'//
'// The specified printer driver is already installed.
'//
%ERROR_PRINTER_DRIVER_ALREADY_INSTALLED = 1795&

'//
'// MessageId: ERROR_UNKNOWN_PORT
'//
'// MessageText:
'//
'// The specified port is unknown.
'//
%ERROR_UNKNOWN_PORT               = 1796&

'//
'// MessageId: ERROR_UNKNOWN_PRINTER_DRIVER
'//
'// MessageText:
'//
'// The printer driver is unknown.
'//
%ERROR_UNKNOWN_PRINTER_DRIVER     = 1797&

'//
'// MessageId: ERROR_UNKNOWN_PRINTPROCESSOR
'//
'// MessageText:
'//
'// The print processor is unknown.
'//
%ERROR_UNKNOWN_PRINTPROCESSOR     = 1798&

'//
'// MessageId: ERROR_INVALID_SEPARATOR_FILE
'//
'// MessageText:
'//
'// The specified separator file is invalid.
'//
%ERROR_INVALID_SEPARATOR_FILE     = 1799&

'//
'// MessageId: ERROR_INVALID_PRIORITY
'//
'// MessageText:
'//
'// The specified priority is invalid.
'//
%ERROR_INVALID_PRIORITY           = 1800&

'//
'// MessageId: ERROR_INVALID_PRINTER_NAME
'//
'// MessageText:
'//
'// The printer name is invalid.
'//
%ERROR_INVALID_PRINTER_NAME       = 1801&

'//
'// MessageId: ERROR_PRINTER_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The printer already exists.
'//
%ERROR_PRINTER_ALREADY_EXISTS     = 1802&

'//
'// MessageId: ERROR_INVALID_PRINTER_COMMAND
'//
'// MessageText:
'//
'// The printer command is invalid.
'//
%ERROR_INVALID_PRINTER_COMMAND    = 1803&

'//
'// MessageId: ERROR_INVALID_DATATYPE
'//
'// MessageText:
'//
'// The specified datatype is invalid.
'//
%ERROR_INVALID_DATATYPE           = 1804&

'//
'// MessageId: ERROR_INVALID_ENVIRONMENT
'//
'// MessageText:
'//
'// The environment specified is invalid.
'//
%ERROR_INVALID_ENVIRONMENT        = 1805&

'//
'// MessageId: RPC_S_NO_MORE_BINDINGS
'//
'// MessageText:
'//
'// There are no more bindings.
'//
%RPC_S_NO_MORE_BINDINGS           = 1806&

'//
'// MessageId: ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT
'//
'// MessageText:
'//
'// The account used is an interdomain trust account. Use your global user account or local user account to access this server.
'//
%ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT = 1807&

'//
'// MessageId: ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT
'//
'// MessageText:
'//
'// The account used is a computer account. Use your global user account or local user account to access this server.
'//
%ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT = 1808&

'//
'// MessageId: ERROR_NOLOGON_SERVER_TRUST_ACCOUNT
'//
'// MessageText:
'//
'// The account used is a server trust account. Use your global user account or local user account to access this server.
'//
%ERROR_NOLOGON_SERVER_TRUST_ACCOUNT = 1809&

'//
'// MessageId: ERROR_DOMAIN_TRUST_INCONSISTENT
'//
'// MessageText:
'//
'// The name or security ID (SID) of the domain specified is inconsistent with the trust information for that domain.
'//
%ERROR_DOMAIN_TRUST_INCONSISTENT = 1810&

'//
'// MessageId: ERROR_SERVER_HAS_OPEN_HANDLES
'//
'// MessageText:
'//
'// The server is in use and cannot be unloaded.
'//
%ERROR_SERVER_HAS_OPEN_HANDLES    = 1811&

'//
'// MessageId: ERROR_RESOURCE_DATA_NOT_FOUND
'//
'// MessageText:
'//
'// The specified image file did not contain a resource section.
'//
%ERROR_RESOURCE_DATA_NOT_FOUND    = 1812&

'//
'// MessageId: ERROR_RESOURCE_TYPE_NOT_FOUND
'//
'// MessageText:
'//
'// The specified resource type cannot be found in the image file.
'//
%ERROR_RESOURCE_TYPE_NOT_FOUND    = 1813&

'//
'// MessageId: ERROR_RESOURCE_NAME_NOT_FOUND
'//
'// MessageText:
'//
'// The specified resource name cannot be found in the image file.
'//
%ERROR_RESOURCE_NAME_NOT_FOUND    = 1814&

'//
'// MessageId: ERROR_RESOURCE_LANG_NOT_FOUND
'//
'// MessageText:
'//
'// The specified resource language ID cannot be found in the image file.
'//
%ERROR_RESOURCE_LANG_NOT_FOUND    = 1815&

'//
'// MessageId: ERROR_NOT_ENOUGH_QUOTA
'//
'// MessageText:
'//
'// Not enough quota is available to process this command.
'//
%ERROR_NOT_ENOUGH_QUOTA           = 1816&

'//
'// MessageId: RPC_S_NO_INTERFACES
'//
'// MessageText:
'//
'// No interfaces have been registered.
'//
%RPC_S_NO_INTERFACES              = 1817&

'//
'// MessageId: RPC_S_CALL_CANCELLED
'//
'// MessageText:
'//
'// The remote procedure call was cancelled.
'//
%RPC_S_CALL_CANCELLED             = 1818&

'//
'// MessageId: RPC_S_BINDING_INCOMPLETE
'//
'// MessageText:
'//
'// The binding handle does not contain all required information.
'//
%RPC_S_BINDING_INCOMPLETE         = 1819&

'//
'// MessageId: RPC_S_COMM_FAILURE
'//
'// MessageText:
'//
'// A communications failure occurred during a remote procedure call.
'//
%RPC_S_COMM_FAILURE               = 1820&

'//
'// MessageId: RPC_S_UNSUPPORTED_AUTHN_LEVEL
'//
'// MessageText:
'//
'// The requested authentication level is not supported.
'//
%RPC_S_UNSUPPORTED_AUTHN_LEVEL    = 1821&

'//
'// MessageId: RPC_S_NO_PRINC_NAME
'//
'// MessageText:
'//
'// No principal name registered.
'//
%RPC_S_NO_PRINC_NAME              = 1822&

'//
'// MessageId: RPC_S_NOT_RPC_ERROR
'//
'// MessageText:
'//
'// The error specified is not a valid Windows RPC error code.
'//
%RPC_S_NOT_RPC_ERROR              = 1823&

'//
'// MessageId: RPC_S_UUID_LOCAL_ONLY
'//
'// MessageText:
'//
'// A UUID that is valid only on this computer has been allocated.
'//
%RPC_S_UUID_LOCAL_ONLY            = 1824&

'//
'// MessageId: RPC_S_SEC_PKG_ERROR
'//
'// MessageText:
'//
'// A security package specific error occurred.
'//
%RPC_S_SEC_PKG_ERROR              = 1825&

'//
'// MessageId: RPC_S_NOT_CANCELLED
'//
'// MessageText:
'//
'// Thread is not canceled.
'//
%RPC_S_NOT_CANCELLED              = 1826&

'//
'// MessageId: RPC_X_INVALID_ES_ACTION
'//
'// MessageText:
'//
'// Invalid operation on the encoding/decoding handle.
'//
%RPC_X_INVALID_ES_ACTION          = 1827&

'//
'// MessageId: RPC_X_WRONG_ES_VERSION
'//
'// MessageText:
'//
'// Incompatible version of the serializing package.
'//
%RPC_X_WRONG_ES_VERSION           = 1828&

'//
'// MessageId: RPC_X_WRONG_STUB_VERSION
'//
'// MessageText:
'//
'// Incompatible version of the RPC stub.
'//
%RPC_X_WRONG_STUB_VERSION         = 1829&

'//
'// MessageId: RPC_X_INVALID_PIPE_OBJECT
'//
'// MessageText:
'//
'// The RPC pipe object is invalid or corrupted.
'//
%RPC_X_INVALID_PIPE_OBJECT        = 1830&

'//
'// MessageId: RPC_X_WRONG_PIPE_ORDER
'//
'// MessageText:
'//
'// An invalid operation was attempted on an RPC pipe object.
'//
%RPC_X_WRONG_PIPE_ORDER           = 1831&

'//
'// MessageId: RPC_X_WRONG_PIPE_VERSION
'//
'// MessageText:
'//
'// Unsupported RPC pipe version.
'//
%RPC_X_WRONG_PIPE_VERSION         = 1832&

'//
'// MessageId: RPC_S_GROUP_MEMBER_NOT_FOUND
'//
'// MessageText:
'//
'// The group member was not found.
'//
%RPC_S_GROUP_MEMBER_NOT_FOUND     = 1898&

'//
'// MessageId: EPT_S_CANT_CREATE
'//
'// MessageText:
'//
'// The endpoint mapper database entry could not be created.
'//
%EPT_S_CANT_CREATE                = 1899&

'//
'// MessageId: RPC_S_INVALID_OBJECT
'//
'// MessageText:
'//
'// The object universal unique identifier (UUID) is the nil UUID.
'//
%RPC_S_INVALID_OBJECT             = 1900&

'//
'// MessageId: ERROR_INVALID_TIME
'//
'// MessageText:
'//
'// The specified time is invalid.
'//
%ERROR_INVALID_TIME               = 1901&

'//
'// MessageId: ERROR_INVALID_FORM_NAME
'//
'// MessageText:
'//
'// The specified form name is invalid.
'//
%ERROR_INVALID_FORM_NAME          = 1902&

'//
'// MessageId: ERROR_INVALID_FORM_SIZE
'//
'// MessageText:
'//
'// The specified form size is invalid.
'//
%ERROR_INVALID_FORM_SIZE          = 1903&

'//
'// MessageId: ERROR_ALREADY_WAITING
'//
'// MessageText:
'//
'// The specified printer handle is already being waited on
'//
%ERROR_ALREADY_WAITING            = 1904&

'//
'// MessageId: ERROR_PRINTER_DELETED
'//
'// MessageText:
'//
'// The specified printer has been deleted.
'//
%ERROR_PRINTER_DELETED            = 1905&

'//
'// MessageId: ERROR_INVALID_PRINTER_STATE
'//
'// MessageText:
'//
'// The state of the printer is invalid.
'//
%ERROR_INVALID_PRINTER_STATE      = 1906&

'//
'// MessageId: ERROR_PASSWORD_MUST_CHANGE
'//
'// MessageText:
'//
'// The user's password must be changed before logging on the first time.
'//
%ERROR_PASSWORD_MUST_CHANGE       = 1907&

'//
'// MessageId: ERROR_DOMAIN_CONTROLLER_NOT_FOUND
'//
'// MessageText:
'//
'// Could not find the domain controller for this domain.
'//
%ERROR_DOMAIN_CONTROLLER_NOT_FOUND = 1908&

'//
'// MessageId: ERROR_ACCOUNT_LOCKED_OUT
'//
'// MessageText:
'//
'// The referenced account is currently locked out and may not be logged on to.
'//
%ERROR_ACCOUNT_LOCKED_OUT         = 1909&

'//
'// MessageId: OR_INVALID_OXID
'//
'// MessageText:
'//
'// The object exporter specified was not found.
'//
%OR_INVALID_OXID                  = 1910&

'//
'// MessageId: OR_INVALID_OID
'//
'// MessageText:
'//
'// The object specified was not found.
'//
%OR_INVALID_OID                   = 1911&

'//
'// MessageId: OR_INVALID_SET
'//
'// MessageText:
'//
'// The object resolver set specified was not found.
'//
%OR_INVALID_SET                   = 1912&

'//
'// MessageId: RPC_S_SEND_INCOMPLETE
'//
'// MessageText:
'//
'// Some data remains to be sent in the request buffer.
'//
%RPC_S_SEND_INCOMPLETE            = 1913&

'//
'// MessageId: RPC_S_INVALID_ASYNC_HANDLE
'//
'// MessageText:
'//
'// Invalid asynchronous remote procedure call handle.
'//
%RPC_S_INVALID_ASYNC_HANDLE       = 1914&

'//
'// MessageId: RPC_S_INVALID_ASYNC_CALL
'//
'// MessageText:
'//
'// Invalid asynchronous RPC call handle for this operation.
'//
%RPC_S_INVALID_ASYNC_CALL         = 1915&

'//
'// MessageId: RPC_X_PIPE_CLOSED
'//
'// MessageText:
'//
'// The RPC pipe object has already been closed.
'//
%RPC_X_PIPE_CLOSED                = 1916&

'//
'// MessageId: RPC_X_PIPE_DISCIPLINE_ERROR
'//
'// MessageText:
'//
'// The RPC call completed before all pipes were processed.
'//
%RPC_X_PIPE_DISCIPLINE_ERROR      = 1917&

'//
'// MessageId: RPC_X_PIPE_EMPTY
'//
'// MessageText:
'//
'// No more data is available from the RPC pipe.
'//
%RPC_X_PIPE_EMPTY                 = 1918&

'//
'// MessageId: ERROR_NO_SITENAME
'//
'// MessageText:
'//
'// No site name is available for this machine.
'//
%ERROR_NO_SITENAME                = 1919&

'//
'// MessageId: ERROR_CANT_ACCESS_FILE
'//
'// MessageText:
'//
'// The file cannot be accessed by the system.
'//
%ERROR_CANT_ACCESS_FILE           = 1920&

'//
'// MessageId: ERROR_CANT_RESOLVE_FILENAME
'//
'// MessageText:
'//
'// The name of the file cannot be resolved by the system.
'//
%ERROR_CANT_RESOLVE_FILENAME      = 1921&

'//
'// MessageId: RPC_S_ENTRY_TYPE_MISMATCH
'//
'// MessageText:
'//
'// The entry is not of the expected type.
'//
%RPC_S_ENTRY_TYPE_MISMATCH        = 1922&

'//
'// MessageId: RPC_S_NOT_ALL_OBJS_EXPORTED
'//
'// MessageText:
'//
'// Not all object UUIDs could be exported to the specified entry.
'//
%RPC_S_NOT_ALL_OBJS_EXPORTED      = 1923&

'//
'// MessageId: RPC_S_INTERFACE_NOT_EXPORTED
'//
'// MessageText:
'//
'// Interface could not be exported to the specified entry.
'//
%RPC_S_INTERFACE_NOT_EXPORTED     = 1924&

'//
'// MessageId: RPC_S_PROFILE_NOT_ADDED
'//
'// MessageText:
'//
'// The specified profile entry could not be added.
'//
%RPC_S_PROFILE_NOT_ADDED          = 1925&

'//
'// MessageId: RPC_S_PRF_ELT_NOT_ADDED
'//
'// MessageText:
'//
'// The specified profile element could not be added.
'//
%RPC_S_PRF_ELT_NOT_ADDED          = 1926&

'//
'// MessageId: RPC_S_PRF_ELT_NOT_REMOVED
'//
'// MessageText:
'//
'// The specified profile element could not be removed.
'//
%RPC_S_PRF_ELT_NOT_REMOVED        = 1927&

'//
'// MessageId: RPC_S_GRP_ELT_NOT_ADDED
'//
'// MessageText:
'//
'// The group element could not be added.
'//
%RPC_S_GRP_ELT_NOT_ADDED          = 1928&

'//
'// MessageId: RPC_S_GRP_ELT_NOT_REMOVED
'//
'// MessageText:
'//
'// The group element could not be removed.
'//
%RPC_S_GRP_ELT_NOT_REMOVED        = 1929&

'//
'// MessageId: ERROR_KM_DRIVER_BLOCKED
'//
'// MessageText:
'//
'// The printer driver is not compatible with a policy enabled on your computer that blocks NT 4.0 drivers.
'//
%ERROR_KM_DRIVER_BLOCKED          = 1930&

'//
'// MessageId: ERROR_CONTEXT_EXPIRED
'//
'// MessageText:
'//
'// The context has expired and can no longer be used.
'//
%ERROR_CONTEXT_EXPIRED            = 1931&

'//
'// MessageId: ERROR_PER_USER_TRUST_QUOTA_EXCEEDED
'//
'// MessageText:
'//
'// The current user's delegated trust creation quota has been exceeded.
'//
%ERROR_PER_USER_TRUST_QUOTA_EXCEEDED = 1932&

'//
'// MessageId: ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED
'//
'// MessageText:
'//
'// The total delegated trust creation quota has been exceeded.
'//
%ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED = 1933&

'//
'// MessageId: ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED
'//
'// MessageText:
'//
'// The current user's delegated trust deletion quota has been exceeded.
'//
%ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED = 1934&

'//
'// MessageId: ERROR_AUTHENTICATION_FIREWALL_FAILED
'//
'// MessageText:
'//
'// Logon Failure: The machine you are logging onto is protected by an authentication firewall. The specified account is not allowed to authenticate to the machine.
'//
%ERROR_AUTHENTICATION_FIREWALL_FAILED = 1935&

'//
'// MessageId: ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED
'//
'// MessageText:
'//
'// Remote connections to the Print Spooler are blocked by a policy set on your machine.
'//
%ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED = 1936&

'//
'// MessageId: ERROR_NTLM_BLOCKED
'//
'// MessageText:
'//
'// Logon Failure: Authentication failed because NTLM authentication has been disabled.
'//
%ERROR_NTLM_BLOCKED               = 1937&


'///////////////////////////////////////////////////
'//                                               //
'//              OpenGL Error codes               //
'//                                               //
'//                 = 2000 to 2009                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_INVALID_PIXEL_FORMAT
'//
'// MessageText:
'//
'// The pixel format is invalid.
'//
%ERROR_INVALID_PIXEL_FORMAT       = 2000&

'//
'// MessageId: ERROR_BAD_DRIVER
'//
'// MessageText:
'//
'// The specified driver is invalid.
'//
%ERROR_BAD_DRIVER                 = 2001&

'//
'// MessageId: ERROR_INVALID_WINDOW_STYLE
'//
'// MessageText:
'//
'// The window style or class attribute is invalid for this operation.
'//
%ERROR_INVALID_WINDOW_STYLE       = 2002&

'//
'// MessageId: ERROR_METAFILE_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The requested metafile operation is not supported.
'//
%ERROR_METAFILE_NOT_SUPPORTED     = 2003&

'//
'// MessageId: ERROR_TRANSFORM_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The requested transformation operation is not supported.
'//
%ERROR_TRANSFORM_NOT_SUPPORTED    = 2004&

'//
'// MessageId: ERROR_CLIPPING_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The requested clipping operation is not supported.
'//
%ERROR_CLIPPING_NOT_SUPPORTED     = 2005&


'///////////////////////////////////////////////////
'//                                               //
'//       Image Color Management Error codes      //
'//                                               //
'//                 = 2010 to 2049                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_INVALID_CMM
'//
'// MessageText:
'//
'// The specified color management module is invalid.
'//
%ERROR_INVALID_CMM                = 2010&

'//
'// MessageId: ERROR_INVALID_PROFILE
'//
'// MessageText:
'//
'// The specified color profile is invalid.
'//
%ERROR_INVALID_PROFILE            = 2011&

'//
'// MessageId: ERROR_TAG_NOT_FOUND
'//
'// MessageText:
'//
'// The specified tag was not found.
'//
%ERROR_TAG_NOT_FOUND              = 2012&

'//
'// MessageId: ERROR_TAG_NOT_PRESENT
'//
'// MessageText:
'//
'// A required tag is not present.
'//
%ERROR_TAG_NOT_PRESENT            = 2013&

'//
'// MessageId: ERROR_DUPLICATE_TAG
'//
'// MessageText:
'//
'// The specified tag is already present.
'//
%ERROR_DUPLICATE_TAG              = 2014&

'//
'// MessageId: ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE
'//
'// MessageText:
'//
'// The specified color profile is not associated with the specified device.
'//
%ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE = 2015&

'//
'// MessageId: ERROR_PROFILE_NOT_FOUND
'//
'// MessageText:
'//
'// The specified color profile was not found.
'//
%ERROR_PROFILE_NOT_FOUND          = 2016&

'//
'// MessageId: ERROR_INVALID_COLORSPACE
'//
'// MessageText:
'//
'// The specified color space is invalid.
'//
%ERROR_INVALID_COLORSPACE         = 2017&

'//
'// MessageId: ERROR_ICM_NOT_ENABLED
'//
'// MessageText:
'//
'// Image Color Management is not enabled.
'//
%ERROR_ICM_NOT_ENABLED            = 2018&

'//
'// MessageId: ERROR_DELETING_ICM_XFORM
'//
'// MessageText:
'//
'// There was an error while deleting the color transform.
'//
%ERROR_DELETING_ICM_XFORM         = 2019&

'//
'// MessageId: ERROR_INVALID_TRANSFORM
'//
'// MessageText:
'//
'// The specified color transform is invalid.
'//
%ERROR_INVALID_TRANSFORM          = 2020&

'//
'// MessageId: ERROR_COLORSPACE_MISMATCH
'//
'// MessageText:
'//
'// The specified transform does not match the bitmap's color space.
'//
%ERROR_COLORSPACE_MISMATCH        = 2021&

'//
'// MessageId: ERROR_INVALID_COLORINDEX
'//
'// MessageText:
'//
'// The specified named color index is not present in the profile.
'//
%ERROR_INVALID_COLORINDEX         = 2022&

'//
'// MessageId: ERROR_PROFILE_DOES_NOT_MATCH_DEVICE
'//
'// MessageText:
'//
'// The specified profile is intended for a device of a different type than the specified device.
'//
%ERROR_PROFILE_DOES_NOT_MATCH_DEVICE = 2023&


'///////////////////////////////////////////////////
'//                                               //
'//             Winnet32 Error codes              //
'//                                               //
'//                 = 2100 to 2999                //
'//                                               //
'// The range 2100 through 2999 is reserved for   //
'// network status codes. See lmerr.h for a       //
'// complete listing                              //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_CONNECTED_OTHER_PASSWORD
'//
'// MessageText:
'//
'// The network connection was made successfully, but the user had to be prompted for a password other than the one originally specified.
'//
%ERROR_CONNECTED_OTHER_PASSWORD   = 2108&

'//
'// MessageId: ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT
'//
'// MessageText:
'//
'// The network connection was made successfully using default credentials.
'//
%ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT = 2109&

'//
'// MessageId: ERROR_BAD_USERNAME
'//
'// MessageText:
'//
'// The specified username is invalid.
'//
%ERROR_BAD_USERNAME               = 2202&

'//
'// MessageId: ERROR_NOT_CONNECTED
'//
'// MessageText:
'//
'// This network connection does not exist.
'//
%ERROR_NOT_CONNECTED              = 2250&

'//
'// MessageId: ERROR_OPEN_FILES
'//
'// MessageText:
'//
'// This network connection has files open or requests pending.
'//
%ERROR_OPEN_FILES                 = 2401&

'//
'// MessageId: ERROR_ACTIVE_CONNECTIONS
'//
'// MessageText:
'//
'// Active connections still exist.
'//
%ERROR_ACTIVE_CONNECTIONS         = 2402&

'//
'// MessageId: ERROR_DEVICE_IN_USE
'//
'// MessageText:
'//
'// The device is in use by an active process and cannot be disconnected.
'//
%ERROR_DEVICE_IN_USE              = 2404&


'///////////////////////////////////////////////////
'//                                               //
'//           Win32 Spooler Error codes           //
'//                                               //
'//                 = 3000 to 3049                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_UNKNOWN_PRINT_MONITOR
'//
'// MessageText:
'//
'// The specified print monitor is unknown.
'//
%ERROR_UNKNOWN_PRINT_MONITOR      = 3000&

'//
'// MessageId: ERROR_PRINTER_DRIVER_IN_USE
'//
'// MessageText:
'//
'// The specified printer driver is currently in use.
'//
%ERROR_PRINTER_DRIVER_IN_USE      = 3001&

'//
'// MessageId: ERROR_SPOOL_FILE_NOT_FOUND
'//
'// MessageText:
'//
'// The spool file was not found.
'//
%ERROR_SPOOL_FILE_NOT_FOUND       = 3002&

'//
'// MessageId: ERROR_SPL_NO_STARTDOC
'//
'// MessageText:
'//
'// A StartDocPrinter call was not issued.
'//
%ERROR_SPL_NO_STARTDOC            = 3003&

'//
'// MessageId: ERROR_SPL_NO_ADDJOB
'//
'// MessageText:
'//
'// An AddJob call was not issued.
'//
%ERROR_SPL_NO_ADDJOB              = 3004&

'//
'// MessageId: ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED
'//
'// MessageText:
'//
'// The specified print processor has already been installed.
'//
%ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED = 3005&

'//
'// MessageId: ERROR_PRINT_MONITOR_ALREADY_INSTALLED
'//
'// MessageText:
'//
'// The specified print monitor has already been installed.
'//
%ERROR_PRINT_MONITOR_ALREADY_INSTALLED = 3006&

'//
'// MessageId: ERROR_INVALID_PRINT_MONITOR
'//
'// MessageText:
'//
'// The specified print monitor does not have the required functions.
'//
%ERROR_INVALID_PRINT_MONITOR      = 3007&

'//
'// MessageId: ERROR_PRINT_MONITOR_IN_USE
'//
'// MessageText:
'//
'// The specified print monitor is currently in use.
'//
%ERROR_PRINT_MONITOR_IN_USE       = 3008&

'//
'// MessageId: ERROR_PRINTER_HAS_JOBS_QUEUED
'//
'// MessageText:
'//
'// The requested operation is not allowed when there are jobs queued to the printer.
'//
%ERROR_PRINTER_HAS_JOBS_QUEUED    = 3009&

'//
'// MessageId: ERROR_SUCCESS_REBOOT_REQUIRED
'//
'// MessageText:
'//
'// The requested operation is successful. Changes will not be effective until the system is rebooted.
'//
%ERROR_SUCCESS_REBOOT_REQUIRED    = 3010&

'//
'// MessageId: ERROR_SUCCESS_RESTART_REQUIRED
'//
'// MessageText:
'//
'// The requested operation is successful. Changes will not be effective until the service is restarted.
'//
%ERROR_SUCCESS_RESTART_REQUIRED   = 3011&

'//
'// MessageId: ERROR_PRINTER_NOT_FOUND
'//
'// MessageText:
'//
'// No printers were found.
'//
%ERROR_PRINTER_NOT_FOUND          = 3012&

'//
'// MessageId: ERROR_PRINTER_DRIVER_WARNED
'//
'// MessageText:
'//
'// The printer driver is known to be unreliable.
'//
%ERROR_PRINTER_DRIVER_WARNED      = 3013&

'//
'// MessageId: ERROR_PRINTER_DRIVER_BLOCKED
'//
'// MessageText:
'//
'// The printer driver is known to harm the system.
'//
%ERROR_PRINTER_DRIVER_BLOCKED     = 3014&

'//
'// MessageId: ERROR_PRINTER_DRIVER_PACKAGE_IN_USE
'//
'// MessageText:
'//
'// The specified printer driver package is currently in use.
'//
%ERROR_PRINTER_DRIVER_PACKAGE_IN_USE = 3015&

'//
'// MessageId: ERROR_CORE_DRIVER_PACKAGE_NOT_FOUND
'//
'// MessageText:
'//
'// Unable to find a core driver package that is required by the printer driver package.
'//
%ERROR_CORE_DRIVER_PACKAGE_NOT_FOUND = 3016&

'//
'// MessageId: ERROR_FAIL_REBOOT_REQUIRED
'//
'// MessageText:
'//
'// The requested operation failed. A system reboot is required to roll back changes made.
'//
%ERROR_FAIL_REBOOT_REQUIRED       = 3017&

'//
'// MessageId: ERROR_FAIL_REBOOT_INITIATED
'//
'// MessageText:
'//
'// The requested operation failed. A system reboot has been initiated to roll back changes made.
'//
%ERROR_FAIL_REBOOT_INITIATED      = 3018&

'//
'// MessageId: ERROR_PRINTER_DRIVER_DOWNLOAD_NEEDED
'//
'// MessageText:
'//
'// The specified printer driver was not found on the system and needs to be downloaded.
'//
%ERROR_PRINTER_DRIVER_DOWNLOAD_NEEDED = 3019&

'//
'// MessageId: ERROR_PRINT_JOB_RESTART_REQUIRED
'//
'// MessageText:
'//
'// The requested print job has failed to print. A print system update requires the job to be resubmitted.
'//
%ERROR_PRINT_JOB_RESTART_REQUIRED = 3020&


'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 3050 to 3899                //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//                IO Error Codes                 //
'//                                               //
'//                 = 3900 to 3999                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_IO_REISSUE_AS_CACHED
'//
'// MessageText:
'//
'// Reissue the given operation as a cached IO operation
'//
%ERROR_IO_REISSUE_AS_CACHED       = 3950&



'///////////////////////////////////////////////////
'//                                               //
'//                Wins Error codes               //
'//                                               //
'//                 = 4000 to 4049                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_WINS_INTERNAL
'//
'// MessageText:
'//
'// WINS encountered an error while processing the command.
'//
%ERROR_WINS_INTERNAL              = 4000&

'//
'// MessageId: ERROR_CAN_NOT_DEL_LOCAL_WINS
'//
'// MessageText:
'//
'// The local WINS cannot be deleted.
'//
%ERROR_CAN_NOT_DEL_LOCAL_WINS     = 4001&

'//
'// MessageId: ERROR_STATIC_INIT
'//
'// MessageText:
'//
'// The importation from the file failed.
'//
%ERROR_STATIC_INIT                = 4002&

'//
'// MessageId: ERROR_INC_BACKUP
'//
'// MessageText:
'//
'// The backup failed. Was a full backup done before?
'//
%ERROR_INC_BACKUP                 = 4003&

'//
'// MessageId: ERROR_FULL_BACKUP
'//
'// MessageText:
'//
'// The backup failed. Check the directory to which you are backing the database.
'//
%ERROR_FULL_BACKUP                = 4004&

'//
'// MessageId: ERROR_REC_NON_EXISTENT
'//
'// MessageText:
'//
'// The name does not exist in the WINS database.
'//
%ERROR_REC_NON_EXISTENT           = 4005&

'//
'// MessageId: ERROR_RPL_NOT_ALLOWED
'//
'// MessageText:
'//
'// Replication with a nonconfigured partner is not allowed.
'//
%ERROR_RPL_NOT_ALLOWED            = 4006&


'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 4050 to 4099                //
'///////////////////////////////////////////////////

'///////////////////////////////////////////////////
'//                                               //
'//               DHCP Error codes                //
'//                                               //
'//                 = 4100 to 4149                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_DHCP_ADDRESS_CONFLICT
'//
'// MessageText:
'//
'// The DHCP client has obtained an IP address that is already in use on the network. The local interface will be disabled until the DHCP client can obtain a new address.
'//
%ERROR_DHCP_ADDRESS_CONFLICT      = 4100&


'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 4150 to 4199                //
'///////////////////////////////////////////////////

'///////////////////////////////////////////////////
'//                                               //
'//               WMI Error codes                 //
'//                                               //
'//                 = 4200 to 4249                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_WMI_GUID_NOT_FOUND
'//
'// MessageText:
'//
'// The GUID passed was not recognized as valid by a WMI data provider.
'//
%ERROR_WMI_GUID_NOT_FOUND         = 4200&

'//
'// MessageId: ERROR_WMI_INSTANCE_NOT_FOUND
'//
'// MessageText:
'//
'// The instance name passed was not recognized as valid by a WMI data provider.
'//
%ERROR_WMI_INSTANCE_NOT_FOUND     = 4201&

'//
'// MessageId: ERROR_WMI_ITEMID_NOT_FOUND
'//
'// MessageText:
'//
'// The data item ID passed was not recognized as valid by a WMI data provider.
'//
%ERROR_WMI_ITEMID_NOT_FOUND       = 4202&

'//
'// MessageId: ERROR_WMI_TRY_AGAIN
'//
'// MessageText:
'//
'// The WMI request could not be completed and should be retried.
'//
%ERROR_WMI_TRY_AGAIN              = 4203&

'//
'// MessageId: ERROR_WMI_DP_NOT_FOUND
'//
'// MessageText:
'//
'// The WMI data provider could not be located.
'//
%ERROR_WMI_DP_NOT_FOUND           = 4204&

'//
'// MessageId: ERROR_WMI_UNRESOLVED_INSTANCE_REF
'//
'// MessageText:
'//
'// The WMI data provider references an instance set that has not been registered.
'//
%ERROR_WMI_UNRESOLVED_INSTANCE_REF = 4205&

'//
'// MessageId: ERROR_WMI_ALREADY_ENABLED
'//
'// MessageText:
'//
'// The WMI data block or event notification has already been enabled.
'//
%ERROR_WMI_ALREADY_ENABLED        = 4206&

'//
'// MessageId: ERROR_WMI_GUID_DISCONNECTED
'//
'// MessageText:
'//
'// The WMI data block is no longer available.
'//
%ERROR_WMI_GUID_DISCONNECTED      = 4207&

'//
'// MessageId: ERROR_WMI_SERVER_UNAVAILABLE
'//
'// MessageText:
'//
'// The WMI data service is not available.
'//
%ERROR_WMI_SERVER_UNAVAILABLE     = 4208&

'//
'// MessageId: ERROR_WMI_DP_FAILED
'//
'// MessageText:
'//
'// The WMI data provider failed to carry out the request.
'//
%ERROR_WMI_DP_FAILED              = 4209&

'//
'// MessageId: ERROR_WMI_INVALID_MOF
'//
'// MessageText:
'//
'// The WMI MOF information is not valid.
'//
%ERROR_WMI_INVALID_MOF            = 4210&

'//
'// MessageId: ERROR_WMI_INVALID_REGINFO
'//
'// MessageText:
'//
'// The WMI registration information is not valid.
'//
%ERROR_WMI_INVALID_REGINFO        = 4211&

'//
'// MessageId: ERROR_WMI_ALREADY_DISABLED
'//
'// MessageText:
'//
'// The WMI data block or event notification has already been disabled.
'//
%ERROR_WMI_ALREADY_DISABLED       = 4212&

'//
'// MessageId: ERROR_WMI_READ_ONLY
'//
'// MessageText:
'//
'// The WMI data item or data block is read only.
'//
%ERROR_WMI_READ_ONLY              = 4213&

'//
'// MessageId: ERROR_WMI_SET_FAILURE
'//
'// MessageText:
'//
'// The WMI data item or data block could not be changed.
'//
%ERROR_WMI_SET_FAILURE            = 4214&


'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 4250 to 4299                //
'///////////////////////////////////////////////////

'///////////////////////////////////////////////////
'//                                               //
'//        RSM (Media Services) Error codes       //
'//                                               //
'//                 = 4300 to 4349                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_INVALID_MEDIA
'//
'// MessageText:
'//
'// The media identifier does not represent a valid medium.
'//
%ERROR_INVALID_MEDIA              = 4300&

'//
'// MessageId: ERROR_INVALID_LIBRARY
'//
'// MessageText:
'//
'// The library identifier does not represent a valid library.
'//
%ERROR_INVALID_LIBRARY            = 4301&

'//
'// MessageId: ERROR_INVALID_MEDIA_POOL
'//
'// MessageText:
'//
'// The media pool identifier does not represent a valid media pool.
'//
%ERROR_INVALID_MEDIA_POOL         = 4302&

'//
'// MessageId: ERROR_DRIVE_MEDIA_MISMATCH
'//
'// MessageText:
'//
'// The drive and medium are not compatible or exist in different libraries.
'//
%ERROR_DRIVE_MEDIA_MISMATCH       = 4303&

'//
'// MessageId: ERROR_MEDIA_OFFLINE
'//
'// MessageText:
'//
'// The medium currently exists in an offline library and must be online to perform this operation.
'//
%ERROR_MEDIA_OFFLINE              = 4304&

'//
'// MessageId: ERROR_LIBRARY_OFFLINE
'//
'// MessageText:
'//
'// The operation cannot be performed on an offline library.
'//
%ERROR_LIBRARY_OFFLINE            = 4305&

'//
'// MessageId: ERROR_EMPTY
'//
'// MessageText:
'//
'// The library, drive, or media pool is empty.
'//
%ERROR_EMPTY                      = 4306&

'//
'// MessageId: ERROR_NOT_EMPTY
'//
'// MessageText:
'//
'// The library, drive, or media pool must be empty to perform this operation.
'//
%ERROR_NOT_EMPTY                  = 4307&

'//
'// MessageId: ERROR_MEDIA_UNAVAILABLE
'//
'// MessageText:
'//
'// No media is currently available in this media pool or library.
'//
%ERROR_MEDIA_UNAVAILABLE          = 4308&

'//
'// MessageId: ERROR_RESOURCE_DISABLED
'//
'// MessageText:
'//
'// A resource required for this operation is disabled.
'//
%ERROR_RESOURCE_DISABLED          = 4309&

'//
'// MessageId: ERROR_INVALID_CLEANER
'//
'// MessageText:
'//
'// The media identifier does not represent a valid cleaner.
'//
%ERROR_INVALID_CLEANER            = 4310&

'//
'// MessageId: ERROR_UNABLE_TO_CLEAN
'//
'// MessageText:
'//
'// The drive cannot be cleaned or does not support cleaning.
'//
%ERROR_UNABLE_TO_CLEAN            = 4311&

'//
'// MessageId: ERROR_OBJECT_NOT_FOUND
'//
'// MessageText:
'//
'// The object identifier does not represent a valid object.
'//
%ERROR_OBJECT_NOT_FOUND           = 4312&

'//
'// MessageId: ERROR_DATABASE_FAILURE
'//
'// MessageText:
'//
'// Unable to read from or write to the database.
'//
%ERROR_DATABASE_FAILURE           = 4313&

'//
'// MessageId: ERROR_DATABASE_FULL
'//
'// MessageText:
'//
'// The database is full.
'//
%ERROR_DATABASE_FULL              = 4314&

'//
'// MessageId: ERROR_MEDIA_INCOMPATIBLE
'//
'// MessageText:
'//
'// The medium is not compatible with the device or media pool.
'//
%ERROR_MEDIA_INCOMPATIBLE         = 4315&

'//
'// MessageId: ERROR_RESOURCE_NOT_PRESENT
'//
'// MessageText:
'//
'// The resource required for this operation does not exist.
'//
%ERROR_RESOURCE_NOT_PRESENT       = 4316&

'//
'// MessageId: ERROR_INVALID_OPERATION
'//
'// MessageText:
'//
'// The operation identifier is not valid.
'//
%ERROR_INVALID_OPERATION          = 4317&

'//
'// MessageId: ERROR_MEDIA_NOT_AVAILABLE
'//
'// MessageText:
'//
'// The media is not mounted or ready for use.
'//
%ERROR_MEDIA_NOT_AVAILABLE        = 4318&

'//
'// MessageId: ERROR_DEVICE_NOT_AVAILABLE
'//
'// MessageText:
'//
'// The device is not ready for use.
'//
%ERROR_DEVICE_NOT_AVAILABLE       = 4319&

'//
'// MessageId: ERROR_REQUEST_REFUSED
'//
'// MessageText:
'//
'// The operator or administrator has refused the request.
'//
%ERROR_REQUEST_REFUSED            = 4320&

'//
'// MessageId: ERROR_INVALID_DRIVE_OBJECT
'//
'// MessageText:
'//
'// The drive identifier does not represent a valid drive.
'//
%ERROR_INVALID_DRIVE_OBJECT       = 4321&

'//
'// MessageId: ERROR_LIBRARY_FULL
'//
'// MessageText:
'//
'// Library is full. No slot is available for use.
'//
%ERROR_LIBRARY_FULL               = 4322&

'//
'// MessageId: ERROR_MEDIUM_NOT_ACCESSIBLE
'//
'// MessageText:
'//
'// The transport cannot access the medium.
'//
%ERROR_MEDIUM_NOT_ACCESSIBLE      = 4323&

'//
'// MessageId: ERROR_UNABLE_TO_LOAD_MEDIUM
'//
'// MessageText:
'//
'// Unable to load the medium into the drive.
'//
%ERROR_UNABLE_TO_LOAD_MEDIUM      = 4324&

'//
'// MessageId: ERROR_UNABLE_TO_INVENTORY_DRIVE
'//
'// MessageText:
'//
'// Unable to retrieve the drive status.
'//
%ERROR_UNABLE_TO_INVENTORY_DRIVE = 4325&

'//
'// MessageId: ERROR_UNABLE_TO_INVENTORY_SLOT
'//
'// MessageText:
'//
'// Unable to retrieve the slot status.
'//
%ERROR_UNABLE_TO_INVENTORY_SLOT   = 4326&

'//
'// MessageId: ERROR_UNABLE_TO_INVENTORY_TRANSPORT
'//
'// MessageText:
'//
'// Unable to retrieve status about the transport.
'//
%ERROR_UNABLE_TO_INVENTORY_TRANSPORT = 4327&

'//
'// MessageId: ERROR_TRANSPORT_FULL
'//
'// MessageText:
'//
'// Cannot use the transport because it is already in use.
'//
%ERROR_TRANSPORT_FULL             = 4328&

'//
'// MessageId: ERROR_CONTROLLING_IEPORT
'//
'// MessageText:
'//
'// Unable to open or close the inject/eject port.
'//
%ERROR_CONTROLLING_IEPORT         = 4329&

'//
'// MessageId: ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA
'//
'// MessageText:
'//
'// Unable to eject the medium because it is in a drive.
'//
%ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA = 4330&

'//
'// MessageId: ERROR_CLEANER_SLOT_SET
'//
'// MessageText:
'//
'// A cleaner slot is already reserved.
'//
%ERROR_CLEANER_SLOT_SET           = 4331&

'//
'// MessageId: ERROR_CLEANER_SLOT_NOT_SET
'//
'// MessageText:
'//
'// A cleaner slot is not reserved.
'//
%ERROR_CLEANER_SLOT_NOT_SET       = 4332&

'//
'// MessageId: ERROR_CLEANER_CARTRIDGE_SPENT
'//
'// MessageText:
'//
'// The cleaner cartridge has performed the maximum number of drive cleanings.
'//
%ERROR_CLEANER_CARTRIDGE_SPENT    = 4333&

'//
'// MessageId: ERROR_UNEXPECTED_OMID
'//
'// MessageText:
'//
'// Unexpected on-medium identifier.
'//
%ERROR_UNEXPECTED_OMID            = 4334&

'//
'// MessageId: ERROR_CANT_DELETE_LAST_ITEM
'//
'// MessageText:
'//
'// The last remaining item in this group or resource cannot be deleted.
'//
%ERROR_CANT_DELETE_LAST_ITEM      = 4335&

'//
'// MessageId: ERROR_MESSAGE_EXCEEDS_MAX_SIZE
'//
'// MessageText:
'//
'// The message provided exceeds the maximum size allowed for this parameter.
'//
%ERROR_MESSAGE_EXCEEDS_MAX_SIZE   = 4336&

'//
'// MessageId: ERROR_VOLUME_CONTAINS_SYS_FILES
'//
'// MessageText:
'//
'// The volume contains system or paging files.
'//
%ERROR_VOLUME_CONTAINS_SYS_FILES = 4337&

'//
'// MessageId: ERROR_INDIGENOUS_TYPE
'//
'// MessageText:
'//
'// The media type cannot be removed from this library since at least one drive in the library reports it can support this media type.
'//
%ERROR_INDIGENOUS_TYPE            = 4338&

'//
'// MessageId: ERROR_NO_SUPPORTING_DRIVES
'//
'// MessageText:
'//
'// This offline media cannot be mounted on this system since no enabled drives are present which can be used.
'//
%ERROR_NO_SUPPORTING_DRIVES       = 4339&

'//
'// MessageId: ERROR_CLEANER_CARTRIDGE_INSTALLED
'//
'// MessageText:
'//
'// A cleaner cartridge is present in the tape library.
'//
%ERROR_CLEANER_CARTRIDGE_INSTALLED = 4340&

'//
'// MessageId: ERROR_IEPORT_FULL
'//
'// MessageText:
'//
'// Cannot use the ieport because it is not empty.
'//
%ERROR_IEPORT_FULL                = 4341&


'///////////////////////////////////////////////////
'//                                               //
'//       Remote Storage Service Error codes      //
'//                                               //
'//                 = 4350 to 4389                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_FILE_OFFLINE
'//
'// MessageText:
'//
'// This file is currently not available for use on this computer.
'//
%ERROR_FILE_OFFLINE               = 4350&

'//
'// MessageId: ERROR_REMOTE_STORAGE_NOT_ACTIVE
'//
'// MessageText:
'//
'// The remote storage service is not operational at this time.
'//
%ERROR_REMOTE_STORAGE_NOT_ACTIVE = 4351&

'//
'// MessageId: ERROR_REMOTE_STORAGE_MEDIA_ERROR
'//
'// MessageText:
'//
'// The remote storage service encountered a media error.
'//
%ERROR_REMOTE_STORAGE_MEDIA_ERROR = 4352&


'///////////////////////////////////////////////////
'//                                               //
'//           Reparse Point Error codes           //
'//                                               //
'//                 = 4390 to 4399                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_NOT_A_REPARSE_POINT
'//
'// MessageText:
'//
'// The file or directory is not a reparse point.
'//
%ERROR_NOT_A_REPARSE_POINT        = 4390&

'//
'// MessageId: ERROR_REPARSE_ATTRIBUTE_CONFLICT
'//
'// MessageText:
'//
'// The reparse point attribute cannot be set because it conflicts with an existing attribute.
'//
%ERROR_REPARSE_ATTRIBUTE_CONFLICT = 4391&

'//
'// MessageId: ERROR_INVALID_REPARSE_DATA
'//
'// MessageText:
'//
'// The data present in the reparse point buffer is invalid.
'//
%ERROR_INVALID_REPARSE_DATA       = 4392&

'//
'// MessageId: ERROR_REPARSE_TAG_INVALID
'//
'// MessageText:
'//
'// The tag present in the reparse point buffer is invalid.
'//
%ERROR_REPARSE_TAG_INVALID        = 4393&

'//
'// MessageId: ERROR_REPARSE_TAG_MISMATCH
'//
'// MessageText:
'//
'// There is a mismatch between the tag specified in the request and the tag present in the reparse point.
'//
'//
%ERROR_REPARSE_TAG_MISMATCH       = 4394&


'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 4400 to 4499                //
'///////////////////////////////////////////////////

'///////////////////////////////////////////////////
'//                                               //
'//    Single Instance Store (SIS) Error codes    //
'//                                               //
'//                 = 4500 to 4549                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_VOLUME_NOT_SIS_ENABLED
'//
'// MessageText:
'//
'// Single Instance Storage is not available on this volume.
'//
%ERROR_VOLUME_NOT_SIS_ENABLED     = 4500&

'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 4550 to 4599                //
'///////////////////////////////////////////////////

'///////////////////////////////////////////////////
'//                                               //
'//             Cluster Error codes               //
'//                                               //
'//                 = 5000 to 5999                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_DEPENDENT_RESOURCE_EXISTS
'//
'// MessageText:
'//
'// The operation cannot be completed because other resources are dependent on this resource.
'//
%ERROR_DEPENDENT_RESOURCE_EXISTS = 5001&

'//
'// MessageId: ERROR_DEPENDENCY_NOT_FOUND
'//
'// MessageText:
'//
'// The cluster resource dependency cannot be found.
'//
%ERROR_DEPENDENCY_NOT_FOUND       = 5002&

'//
'// MessageId: ERROR_DEPENDENCY_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The cluster resource cannot be made dependent on the specified resource because it is already dependent.
'//
%ERROR_DEPENDENCY_ALREADY_EXISTS = 5003&

'//
'// MessageId: ERROR_RESOURCE_NOT_ONLINE
'//
'// MessageText:
'//
'// The cluster resource is not online.
'//
%ERROR_RESOURCE_NOT_ONLINE        = 5004&

'//
'// MessageId: ERROR_HOST_NODE_NOT_AVAILABLE
'//
'// MessageText:
'//
'// A cluster node is not available for this operation.
'//
%ERROR_HOST_NODE_NOT_AVAILABLE    = 5005&

'//
'// MessageId: ERROR_RESOURCE_NOT_AVAILABLE
'//
'// MessageText:
'//
'// The cluster resource is not available.
'//
%ERROR_RESOURCE_NOT_AVAILABLE     = 5006&

'//
'// MessageId: ERROR_RESOURCE_NOT_FOUND
'//
'// MessageText:
'//
'// The cluster resource could not be found.
'//
%ERROR_RESOURCE_NOT_FOUND         = 5007&

'//
'// MessageId: ERROR_SHUTDOWN_CLUSTER
'//
'// MessageText:
'//
'// The cluster is being shut down.
'//
%ERROR_SHUTDOWN_CLUSTER           = 5008&

'//
'// MessageId: ERROR_CANT_EVICT_ACTIVE_NODE
'//
'// MessageText:
'//
'// A cluster node cannot be evicted from the cluster unless the node is down or it is the last node.
'//
%ERROR_CANT_EVICT_ACTIVE_NODE     = 5009&

'//
'// MessageId: ERROR_OBJECT_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The object already exists.
'//
%ERROR_OBJECT_ALREADY_EXISTS      = 5010&

'//
'// MessageId: ERROR_OBJECT_IN_LIST
'//
'// MessageText:
'//
'// The object is already in the list.
'//
%ERROR_OBJECT_IN_LIST             = 5011&

'//
'// MessageId: ERROR_GROUP_NOT_AVAILABLE
'//
'// MessageText:
'//
'// The cluster group is not available for any new requests.
'//
%ERROR_GROUP_NOT_AVAILABLE        = 5012&

'//
'// MessageId: ERROR_GROUP_NOT_FOUND
'//
'// MessageText:
'//
'// The cluster group could not be found.
'//
%ERROR_GROUP_NOT_FOUND            = 5013&

'//
'// MessageId: ERROR_GROUP_NOT_ONLINE
'//
'// MessageText:
'//
'// The operation could not be completed because the cluster group is not online.
'//
%ERROR_GROUP_NOT_ONLINE           = 5014&

'//
'// MessageId: ERROR_HOST_NODE_NOT_RESOURCE_OWNER
'//
'// MessageText:
'//
'// The operation failed because either the specified cluster node is not the owner of the resource, or the node
'// is not a possible owner of the resource.
'//
%ERROR_HOST_NODE_NOT_RESOURCE_OWNER = 5015&

'//
'// MessageId: ERROR_HOST_NODE_NOT_GROUP_OWNER
'//
'// MessageText:
'//
'// The operation failed because either the specified cluster node is not the owner of the group, or the node
'// is not a possible owner of the group.
'//
%ERROR_HOST_NODE_NOT_GROUP_OWNER = 5016&

'//
'// MessageId: ERROR_RESMON_CREATE_FAILED
'//
'// MessageText:
'//
'// The cluster resource could not be created in the specified resource monitor.
'//
%ERROR_RESMON_CREATE_FAILED       = 5017&

'//
'// MessageId: ERROR_RESMON_ONLINE_FAILED
'//
'// MessageText:
'//
'// The cluster resource could not be brought online by the resource monitor.
'//
%ERROR_RESMON_ONLINE_FAILED       = 5018&

'//
'// MessageId: ERROR_RESOURCE_ONLINE
'//
'// MessageText:
'//
'// The operation could not be completed because the cluster resource is online.
'//
%ERROR_RESOURCE_ONLINE            = 5019&

'//
'// MessageId: ERROR_QUORUM_RESOURCE
'//
'// MessageText:
'//
'// The cluster resource could not be deleted or brought offline because it is the quorum resource.
'//
%ERROR_QUORUM_RESOURCE            = 5020&

'//
'// MessageId: ERROR_NOT_QUORUM_CAPABLE
'//
'// MessageText:
'//
'// The cluster could not make the specified resource a quorum resource because it is not capable of being a quorum resource.
'//
%ERROR_NOT_QUORUM_CAPABLE         = 5021&

'//
'// MessageId: ERROR_CLUSTER_SHUTTING_DOWN
'//
'// MessageText:
'//
'// The cluster software is shutting down.
'//
%ERROR_CLUSTER_SHUTTING_DOWN      = 5022&

'//
'// MessageId: ERROR_INVALID_STATE
'//
'// MessageText:
'//
'// The group or resource is not in the correct state to perform the requested operation.
'//
%ERROR_INVALID_STATE              = 5023&

'//
'// MessageId: ERROR_RESOURCE_PROPERTIES_STORED
'//
'// MessageText:
'//
'// The properties were stored but not all changes will take effect until the next time the resource is brought online.
'//
%ERROR_RESOURCE_PROPERTIES_STORED = 5024&

'//
'// MessageId: ERROR_NOT_QUORUM_CLASS
'//
'// MessageText:
'//
'// The cluster could not make the specified resource a quorum resource because it does not belong to a shared storage class.
'//
%ERROR_NOT_QUORUM_CLASS           = 5025&

'//
'// MessageId: ERROR_CORE_RESOURCE
'//
'// MessageText:
'//
'// The cluster resource could not be deleted since it is a core resource.
'//
%ERROR_CORE_RESOURCE              = 5026&

'//
'// MessageId: ERROR_QUORUM_RESOURCE_ONLINE_FAILED
'//
'// MessageText:
'//
'// The quorum resource failed to come online.
'//
%ERROR_QUORUM_RESOURCE_ONLINE_FAILED = 5027&

'//
'// MessageId: ERROR_QUORUMLOG_OPEN_FAILED
'//
'// MessageText:
'//
'// The quorum log could not be created or mounted successfully.
'//
%ERROR_QUORUMLOG_OPEN_FAILED      = 5028&

'//
'// MessageId: ERROR_CLUSTERLOG_CORRUPT
'//
'// MessageText:
'//
'// The cluster log is corrupt.
'//
%ERROR_CLUSTERLOG_CORRUPT         = 5029&

'//
'// MessageId: ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE
'//
'// MessageText:
'//
'// The record could not be written to the cluster log since it exceeds the maximum size.
'//
%ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE = 5030&

'//
'// MessageId: ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE
'//
'// MessageText:
'//
'// The cluster log exceeds its maximum size.
'//
%ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE = 5031&

'//
'// MessageId: ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND
'//
'// MessageText:
'//
'// No checkpoint record was found in the cluster log.
'//
%ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND = 5032&

'//
'// MessageId: ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE
'//
'// MessageText:
'//
'// The minimum required disk space needed for logging is not available.
'//
%ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE = 5033&

'//
'// MessageId: ERROR_QUORUM_OWNER_ALIVE
'//
'// MessageText:
'//
'// The cluster node failed to take control of the quorum resource because the resource is owned by another active node.
'//
%ERROR_QUORUM_OWNER_ALIVE         = 5034&

'//
'// MessageId: ERROR_NETWORK_NOT_AVAILABLE
'//
'// MessageText:
'//
'// A cluster network is not available for this operation.
'//
%ERROR_NETWORK_NOT_AVAILABLE      = 5035&

'//
'// MessageId: ERROR_NODE_NOT_AVAILABLE
'//
'// MessageText:
'//
'// A cluster node is not available for this operation.
'//
%ERROR_NODE_NOT_AVAILABLE         = 5036&

'//
'// MessageId: ERROR_ALL_NODES_NOT_AVAILABLE
'//
'// MessageText:
'//
'// All cluster nodes must be running to perform this operation.
'//
%ERROR_ALL_NODES_NOT_AVAILABLE    = 5037&

'//
'// MessageId: ERROR_RESOURCE_FAILED
'//
'// MessageText:
'//
'// A cluster resource failed.
'//
%ERROR_RESOURCE_FAILED            = 5038&

'//
'// MessageId: ERROR_CLUSTER_INVALID_NODE
'//
'// MessageText:
'//
'// The cluster node is not valid.
'//
%ERROR_CLUSTER_INVALID_NODE       = 5039&

'//
'// MessageId: ERROR_CLUSTER_NODE_EXISTS
'//
'// MessageText:
'//
'// The cluster node already exists.
'//
%ERROR_CLUSTER_NODE_EXISTS        = 5040&

'//
'// MessageId: ERROR_CLUSTER_JOIN_IN_PROGRESS
'//
'// MessageText:
'//
'// A node is in the process of joining the cluster.
'//
%ERROR_CLUSTER_JOIN_IN_PROGRESS   = 5041&

'//
'// MessageId: ERROR_CLUSTER_NODE_NOT_FOUND
'//
'// MessageText:
'//
'// The cluster node was not found.
'//
%ERROR_CLUSTER_NODE_NOT_FOUND     = 5042&

'//
'// MessageId: ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND
'//
'// MessageText:
'//
'// The cluster local node information was not found.
'//
%ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND = 5043&

'//
'// MessageId: ERROR_CLUSTER_NETWORK_EXISTS
'//
'// MessageText:
'//
'// The cluster network already exists.
'//
%ERROR_CLUSTER_NETWORK_EXISTS     = 5044&

'//
'// MessageId: ERROR_CLUSTER_NETWORK_NOT_FOUND
'//
'// MessageText:
'//
'// The cluster network was not found.
'//
%ERROR_CLUSTER_NETWORK_NOT_FOUND = 5045&

'//
'// MessageId: ERROR_CLUSTER_NETINTERFACE_EXISTS
'//
'// MessageText:
'//
'// The cluster network interface already exists.
'//
%ERROR_CLUSTER_NETINTERFACE_EXISTS = 5046&

'//
'// MessageId: ERROR_CLUSTER_NETINTERFACE_NOT_FOUND
'//
'// MessageText:
'//
'// The cluster network interface was not found.
'//
%ERROR_CLUSTER_NETINTERFACE_NOT_FOUND = 5047&

'//
'// MessageId: ERROR_CLUSTER_INVALID_REQUEST
'//
'// MessageText:
'//
'// The cluster request is not valid for this object.
'//
%ERROR_CLUSTER_INVALID_REQUEST    = 5048&

'//
'// MessageId: ERROR_CLUSTER_INVALID_NETWORK_PROVIDER
'//
'// MessageText:
'//
'// The cluster network provider is not valid.
'//
%ERROR_CLUSTER_INVALID_NETWORK_PROVIDER = 5049&

'//
'// MessageId: ERROR_CLUSTER_NODE_DOWN
'//
'// MessageText:
'//
'// The cluster node is down.
'//
%ERROR_CLUSTER_NODE_DOWN          = 5050&

'//
'// MessageId: ERROR_CLUSTER_NODE_UNREACHABLE
'//
'// MessageText:
'//
'// The cluster node is not reachable.
'//
%ERROR_CLUSTER_NODE_UNREACHABLE   = 5051&

'//
'// MessageId: ERROR_CLUSTER_NODE_NOT_MEMBER
'//
'// MessageText:
'//
'// The cluster node is not a member of the cluster.
'//
%ERROR_CLUSTER_NODE_NOT_MEMBER    = 5052&

'//
'// MessageId: ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS
'//
'// MessageText:
'//
'// A cluster join operation is not in progress.
'//
%ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS = 5053&

'//
'// MessageId: ERROR_CLUSTER_INVALID_NETWORK
'//
'// MessageText:
'//
'// The cluster network is not valid.
'//
%ERROR_CLUSTER_INVALID_NETWORK    = 5054&

'//
'// MessageId: ERROR_CLUSTER_NODE_UP
'//
'// MessageText:
'//
'// The cluster node is up.
'//
%ERROR_CLUSTER_NODE_UP            = 5056&

'//
'// MessageId: ERROR_CLUSTER_IPADDR_IN_USE
'//
'// MessageText:
'//
'// The cluster IP address is already in use.
'//
%ERROR_CLUSTER_IPADDR_IN_USE      = 5057&

'//
'// MessageId: ERROR_CLUSTER_NODE_NOT_PAUSED
'//
'// MessageText:
'//
'// The cluster node is not paused.
'//
%ERROR_CLUSTER_NODE_NOT_PAUSED    = 5058&

'//
'// MessageId: ERROR_CLUSTER_NO_SECURITY_CONTEXT
'//
'// MessageText:
'//
'// No cluster security context is available.
'//
%ERROR_CLUSTER_NO_SECURITY_CONTEXT = 5059&

'//
'// MessageId: ERROR_CLUSTER_NETWORK_NOT_INTERNAL
'//
'// MessageText:
'//
'// The cluster network is not configured for internal cluster communication.
'//
%ERROR_CLUSTER_NETWORK_NOT_INTERNAL = 5060&

'//
'// MessageId: ERROR_CLUSTER_NODE_ALREADY_UP
'//
'// MessageText:
'//
'// The cluster node is already up.
'//
%ERROR_CLUSTER_NODE_ALREADY_UP    = 5061&

'//
'// MessageId: ERROR_CLUSTER_NODE_ALREADY_DOWN
'//
'// MessageText:
'//
'// The cluster node is already down.
'//
%ERROR_CLUSTER_NODE_ALREADY_DOWN = 5062&

'//
'// MessageId: ERROR_CLUSTER_NETWORK_ALREADY_ONLINE
'//
'// MessageText:
'//
'// The cluster network is already online.
'//
%ERROR_CLUSTER_NETWORK_ALREADY_ONLINE = 5063&

'//
'// MessageId: ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE
'//
'// MessageText:
'//
'// The cluster network is already offline.
'//
%ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE = 5064&

'//
'// MessageId: ERROR_CLUSTER_NODE_ALREADY_MEMBER
'//
'// MessageText:
'//
'// The cluster node is already a member of the cluster.
'//
%ERROR_CLUSTER_NODE_ALREADY_MEMBER = 5065&

'//
'// MessageId: ERROR_CLUSTER_LAST_INTERNAL_NETWORK
'//
'// MessageText:
'//
'// The cluster network is the only one configured for internal cluster communication between two or more active cluster nodes. The internal communication capability cannot be removed from the network.
'//
%ERROR_CLUSTER_LAST_INTERNAL_NETWORK = 5066&

'//
'// MessageId: ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS
'//
'// MessageText:
'//
'// One or more cluster resources depend on the network to provide service to clients. The client access capability cannot be removed from the network.
'//
%ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS = 5067&

'//
'// MessageId: ERROR_INVALID_OPERATION_ON_QUORUM
'//
'// MessageText:
'//
'// This operation cannot be performed on the cluster resource as it the quorum resource. You may not bring the quorum resource offline or modify its possible owners list.
'//
%ERROR_INVALID_OPERATION_ON_QUORUM = 5068&

'//
'// MessageId: ERROR_DEPENDENCY_NOT_ALLOWED
'//
'// MessageText:
'//
'// The cluster quorum resource is not allowed to have any dependencies.
'//
%ERROR_DEPENDENCY_NOT_ALLOWED     = 5069&

'//
'// MessageId: ERROR_CLUSTER_NODE_PAUSED
'//
'// MessageText:
'//
'// The cluster node is paused.
'//
%ERROR_CLUSTER_NODE_PAUSED        = 5070&

'//
'// MessageId: ERROR_NODE_CANT_HOST_RESOURCE
'//
'// MessageText:
'//
'// The cluster resource cannot be brought online. The owner node cannot run this resource.
'//
%ERROR_NODE_CANT_HOST_RESOURCE    = 5071&

'//
'// MessageId: ERROR_CLUSTER_NODE_NOT_READY
'//
'// MessageText:
'//
'// The cluster node is not ready to perform the requested operation.
'//
%ERROR_CLUSTER_NODE_NOT_READY     = 5072&

'//
'// MessageId: ERROR_CLUSTER_NODE_SHUTTING_DOWN
'//
'// MessageText:
'//
'// The cluster node is shutting down.
'//
%ERROR_CLUSTER_NODE_SHUTTING_DOWN = 5073&

'//
'// MessageId: ERROR_CLUSTER_JOIN_ABORTED
'//
'// MessageText:
'//
'// The cluster join operation was aborted.
'//
%ERROR_CLUSTER_JOIN_ABORTED       = 5074&

'//
'// MessageId: ERROR_CLUSTER_INCOMPATIBLE_VERSIONS
'//
'// MessageText:
'//
'// The cluster join operation failed due to incompatible software versions between the joining node and its sponsor.
'//
%ERROR_CLUSTER_INCOMPATIBLE_VERSIONS = 5075&

'//
'// MessageId: ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED
'//
'// MessageText:
'//
'// This resource cannot be created because the cluster has reached the limit on the number of resources it can monitor.
'//
%ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED = 5076&

'//
'// MessageId: ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED
'//
'// MessageText:
'//
'// The system configuration changed during the cluster join or form operation. The join or form operation was aborted.
'//
%ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED = 5077&

'//
'// MessageId: ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND
'//
'// MessageText:
'//
'// The specified resource type was not found.
'//
%ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND = 5078&

'//
'// MessageId: ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The specified node does not support a resource of this type. This may be due to version inconsistencies or due to the absence of the resource DLL on this node.
'//
%ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED = 5079&

'//
'// MessageId: ERROR_CLUSTER_RESNAME_NOT_FOUND
'//
'// MessageText:
'//
'// The specified resource name is not supported by this resource DLL. This may be due to a bad (or changed) name supplied to the resource DLL.
'//
%ERROR_CLUSTER_RESNAME_NOT_FOUND = 5080&

'//
'// MessageId: ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED
'//
'// MessageText:
'//
'// No authentication package could be registered with the RPC server.
'//
%ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED = 5081&

'//
'// MessageId: ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST
'//
'// MessageText:
'//
'// You cannot bring the group online because the owner of the group is not in the preferred list for the group. To change the owner node for the group, move the group.
'//
%ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST = 5082&

'//
'// MessageId: ERROR_CLUSTER_DATABASE_SEQMISMATCH
'//
'// MessageText:
'//
'// The join operation failed because the cluster database sequence number has changed or is incompatible with the locker node. This may happen during a join operation if the cluster database was changing during the join.
'//
%ERROR_CLUSTER_DATABASE_SEQMISMATCH = 5083&

'//
'// MessageId: ERROR_RESMON_INVALID_STATE
'//
'// MessageText:
'//
'// The resource monitor will not allow the fail operation to be performed while the resource is in its current state. This may happen if the resource is in a pending state.
'//
%ERROR_RESMON_INVALID_STATE       = 5084&

'//
'// MessageId: ERROR_CLUSTER_GUM_NOT_LOCKER
'//
'// MessageText:
'//
'// A non locker code got a request to reserve the lock for making global updates.
'//
%ERROR_CLUSTER_GUM_NOT_LOCKER     = 5085&

'//
'// MessageId: ERROR_QUORUM_DISK_NOT_FOUND
'//
'// MessageText:
'//
'// The quorum disk could not be located by the cluster service.
'//
%ERROR_QUORUM_DISK_NOT_FOUND      = 5086&

'//
'// MessageId: ERROR_DATABASE_BACKUP_CORRUPT
'//
'// MessageText:
'//
'// The backed up cluster database is possibly corrupt.
'//
%ERROR_DATABASE_BACKUP_CORRUPT    = 5087&

'//
'// MessageId: ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT
'//
'// MessageText:
'//
'// A DFS root already exists in this cluster node.
'//
%ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT = 5088&

'//
'// MessageId: ERROR_RESOURCE_PROPERTY_UNCHANGEABLE
'//
'// MessageText:
'//
'// An attempt to modify a resource property failed because it conflicts with another existing property.
'//
%ERROR_RESOURCE_PROPERTY_UNCHANGEABLE = 5089&

'/*
' Codes from 4300 through 5889 overlap with codes in ds\published\inc\apperr2.w.
' Do not add any more error codes in that range.
'*/
'//
'// MessageId: ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE
'//
'// MessageText:
'//
'// An operation was attempted that is incompatible with the current membership state of the node.
'//
%ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE = 5890&

'//
'// MessageId: ERROR_CLUSTER_QUORUMLOG_NOT_FOUND
'//
'// MessageText:
'//
'// The quorum resource does not contain the quorum log.
'//
%ERROR_CLUSTER_QUORUMLOG_NOT_FOUND = 5891&

'//
'// MessageId: ERROR_CLUSTER_MEMBERSHIP_HALT
'//
'// MessageText:
'//
'// The membership engine requested shutdown of the cluster service on this node.
'//
%ERROR_CLUSTER_MEMBERSHIP_HALT    = 5892&

'//
'// MessageId: ERROR_CLUSTER_INSTANCE_ID_MISMATCH
'//
'// MessageText:
'//
'// The join operation failed because the cluster instance ID of the joining node does not match the cluster instance ID of the sponsor node.
'//
%ERROR_CLUSTER_INSTANCE_ID_MISMATCH = 5893&

'//
'// MessageId: ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP
'//
'// MessageText:
'//
'// A matching cluster network for the specified IP address could not be found.
'//
%ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP = 5894&

'//
'// MessageId: ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH
'//
'// MessageText:
'//
'// The actual data type of the property did not match the expected data type of the property.
'//
%ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH = 5895&

'//
'// MessageId: ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP
'//
'// MessageText:
'//
'// The cluster node was evicted from the cluster successfully, but the node was not cleaned up. To determine what cleanup steps failed and how to recover, see the Failover Clustering application event log using Event Viewer.
'//
%ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP = 5896&

'//
'// MessageId: ERROR_CLUSTER_PARAMETER_MISMATCH
'//
'// MessageText:
'//
'// Two or more parameter values specified for a resource's properties are in conflict.
'//
%ERROR_CLUSTER_PARAMETER_MISMATCH = 5897&

'//
'// MessageId: ERROR_NODE_CANNOT_BE_CLUSTERED
'//
'// MessageText:
'//
'// This computer cannot be made a member of a cluster.
'//
%ERROR_NODE_CANNOT_BE_CLUSTERED   = 5898&

'//
'// MessageId: ERROR_CLUSTER_WRONG_OS_VERSION
'//
'// MessageText:
'//
'// This computer cannot be made a member of a cluster because it does not have the correct version of Windows installed.
'//
%ERROR_CLUSTER_WRONG_OS_VERSION   = 5899&

'//
'// MessageId: ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME
'//
'// MessageText:
'//
'// A cluster cannot be created with the specified cluster name because that cluster name is already in use. Specify a different name for the cluster.
'//
%ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME = 5900&

'//
'// MessageId: ERROR_CLUSCFG_ALREADY_COMMITTED
'//
'// MessageText:
'//
'// The cluster configuration action has already been committed.
'//
%ERROR_CLUSCFG_ALREADY_COMMITTED = 5901&

'//
'// MessageId: ERROR_CLUSCFG_ROLLBACK_FAILED
'//
'// MessageText:
'//
'// The cluster configuration action could not be rolled back.
'//
%ERROR_CLUSCFG_ROLLBACK_FAILED    = 5902&

'//
'// MessageId: ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT
'//
'// MessageText:
'//
'// The drive letter assigned to a system disk on one node conflicted with the drive letter assigned to a disk on another node.
'//
%ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT = 5903&

'//
'// MessageId: ERROR_CLUSTER_OLD_VERSION
'//
'// MessageText:
'//
'// One or more nodes in the cluster are running a version of Windows that does not support this operation.
'//
%ERROR_CLUSTER_OLD_VERSION        = 5904&

'//
'// MessageId: ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME
'//
'// MessageText:
'//
'// The name of the corresponding computer account doesn't match the Network Name for this resource.
'//
%ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME = 5905&

'//
'// MessageId: ERROR_CLUSTER_NO_NET_ADAPTERS
'//
'// MessageText:
'//
'// No network adapters are available.
'//
%ERROR_CLUSTER_NO_NET_ADAPTERS    = 5906&

'//
'// MessageId: ERROR_CLUSTER_POISONED
'//
'// MessageText:
'//
'// The cluster node has been poisoned.
'//
%ERROR_CLUSTER_POISONED           = 5907&

'//
'// MessageId: ERROR_CLUSTER_GROUP_MOVING
'//
'// MessageText:
'//
'// The group is unable to accept the request since it is moving to another node.
'//
%ERROR_CLUSTER_GROUP_MOVING       = 5908&

'//
'// MessageId: ERROR_CLUSTER_RESOURCE_TYPE_BUSY
'//
'// MessageText:
'//
'// The resource type cannot accept the request since is too busy performing another operation.
'//
%ERROR_CLUSTER_RESOURCE_TYPE_BUSY = 5909&

'//
'// MessageId: ERROR_RESOURCE_CALL_TIMED_OUT
'//
'// MessageText:
'//
'// The call to the cluster resource DLL timed out.
'//
%ERROR_RESOURCE_CALL_TIMED_OUT    = 5910&

'//
'// MessageId: ERROR_INVALID_CLUSTER_IPV6_ADDRESS
'//
'// MessageText:
'//
'// The address is not valid for an IPv6 Address resource. A global IPv6 address is required, and it must match a cluster network. Compatibility addresses are not permitted.
'//
%ERROR_INVALID_CLUSTER_IPV6_ADDRESS = 5911&

'//
'// MessageId: ERROR_CLUSTER_INTERNAL_INVALID_FUNCTION
'//
'// MessageText:
'//
'// An internal cluster error occurred. A call to an invalid function was attempted.
'//
%ERROR_CLUSTER_INTERNAL_INVALID_FUNCTION = 5912&

'//
'// MessageId: ERROR_CLUSTER_PARAMETER_OUT_OF_BOUNDS
'//
'// MessageText:
'//
'// A parameter value is out of acceptable range.
'//
%ERROR_CLUSTER_PARAMETER_OUT_OF_BOUNDS = 5913&

'//
'// MessageId: ERROR_CLUSTER_PARTIAL_SEND
'//
'// MessageText:
'//
'// A network error occurred while sending data to another node in the cluster. The number of bytes transmitted was less than required.
'//
%ERROR_CLUSTER_PARTIAL_SEND       = 5914&

'//
'// MessageId: ERROR_CLUSTER_REGISTRY_INVALID_FUNCTION
'//
'// MessageText:
'//
'// An invalid cluster registry operation was attempted.
'//
%ERROR_CLUSTER_REGISTRY_INVALID_FUNCTION = 5915&

'//
'// MessageId: ERROR_CLUSTER_INVALID_STRING_TERMINATION
'//
'// MessageText:
'//
'// An input string of characters is not properly terminated.
'//
%ERROR_CLUSTER_INVALID_STRING_TERMINATION = 5916&

'//
'// MessageId: ERROR_CLUSTER_INVALID_STRING_FORMAT
'//
'// MessageText:
'//
'// An input string of characters is not in a valid format for the data it represents.
'//
%ERROR_CLUSTER_INVALID_STRING_FORMAT = 5917&

'//
'// MessageId: ERROR_CLUSTER_DATABASE_TRANSACTION_IN_PROGRESS
'//
'// MessageText:
'//
'// An internal cluster error occurred. A cluster database transaction was attempted while a transaction was already in progress.
'//
%ERROR_CLUSTER_DATABASE_TRANSACTION_IN_PROGRESS = 5918&

'//
'// MessageId: ERROR_CLUSTER_DATABASE_TRANSACTION_NOT_IN_PROGRESS
'//
'// MessageText:
'//
'// An internal cluster error occurred. There was an attempt to commit a cluster database transaction while no transaction was in progress.
'//
%ERROR_CLUSTER_DATABASE_TRANSACTION_NOT_IN_PROGRESS = 5919&

'//
'// MessageId: ERROR_CLUSTER_NULL_DATA
'//
'// MessageText:
'//
'// An internal cluster error occurred. Data was not properly initialized.
'//
%ERROR_CLUSTER_NULL_DATA          = 5920&

'//
'// MessageId: ERROR_CLUSTER_PARTIAL_READ
'//
'// MessageText:
'//
'// An error occurred while reading from a stream of data. An unexpected number of bytes was returned.
'//
%ERROR_CLUSTER_PARTIAL_READ       = 5921&

'//
'// MessageId: ERROR_CLUSTER_PARTIAL_WRITE
'//
'// MessageText:
'//
'// An error occurred while writing to a stream of data. The required number of bytes could not be written.
'//
%ERROR_CLUSTER_PARTIAL_WRITE      = 5922&

'//
'// MessageId: ERROR_CLUSTER_CANT_DESERIALIZE_DATA
'//
'// MessageText:
'//
'// An error occurred while deserializing a stream of cluster data.
'//
%ERROR_CLUSTER_CANT_DESERIALIZE_DATA = 5923&

'//
'// MessageId: ERROR_DEPENDENT_RESOURCE_PROPERTY_CONFLICT
'//
'// MessageText:
'//
'// One or more property values for this resource are in conflict with one or more property values associated with its dependent resource(s).
'//
%ERROR_DEPENDENT_RESOURCE_PROPERTY_CONFLICT = 5924&

'//
'// MessageId: ERROR_CLUSTER_NO_QUORUM
'//
'// MessageText:
'//
'// A quorum of cluster nodes was not present to form a cluster.
'//
%ERROR_CLUSTER_NO_QUORUM          = 5925&

'//
'// MessageId: ERROR_CLUSTER_INVALID_IPV6_NETWORK
'//
'// MessageText:
'//
'// The cluster network is not valid for an IPv6 Address resource, or it does not match the configured address.
'//
%ERROR_CLUSTER_INVALID_IPV6_NETWORK = 5926&

'//
'// MessageId: ERROR_CLUSTER_INVALID_IPV6_TUNNEL_NETWORK
'//
'// MessageText:
'//
'// The cluster network is not valid for an IPv6 Tunnel resource. Check the configuration of the IP Address resource on which the IPv6 Tunnel resource depends.
'//
%ERROR_CLUSTER_INVALID_IPV6_TUNNEL_NETWORK = 5927&

'//
'// MessageId: ERROR_QUORUM_NOT_ALLOWED_IN_THIS_GROUP
'//
'// MessageText:
'//
'// Quorum resource cannot reside in the Available Storage group.
'//
%ERROR_QUORUM_NOT_ALLOWED_IN_THIS_GROUP = 5928&

'//
'// MessageId: ERROR_DEPENDENCY_TREE_TOO_COMPLEX
'//
'// MessageText:
'//
'// The dependencies for this resource are nested too deeply.
'//
%ERROR_DEPENDENCY_TREE_TOO_COMPLEX = 5929&

'//
'// MessageId: ERROR_EXCEPTION_IN_RESOURCE_CALL
'//
'// MessageText:
'//
'// The call into the resource DLL raised an unhandled exception.
'//
%ERROR_EXCEPTION_IN_RESOURCE_CALL = 5930&

'//
'// MessageId: ERROR_CLUSTER_RHS_FAILED_INITIALIZATION
'//
'// MessageText:
'//
'// The RHS process failed to initialize.
'//
%ERROR_CLUSTER_RHS_FAILED_INITIALIZATION = 5931&

'//
'// MessageId: ERROR_CLUSTER_NOT_INSTALLED
'//
'// MessageText:
'//
'// The Failover Clustering feature is not installed on this node.
'//
%ERROR_CLUSTER_NOT_INSTALLED      = 5932&

'//
'// MessageId: ERROR_CLUSTER_RESOURCES_MUST_BE_ONLINE_ON_THE_SAME_NODE
'//
'// MessageText:
'//
'// The resources must be online on the same node for this operation
'//
%ERROR_CLUSTER_RESOURCES_MUST_BE_ONLINE_ON_THE_SAME_NODE = 5933&


'///////////////////////////////////////////////////
'//                                               //
'//               EFS Error codes                 //
'//                                               //
'//                 = 6000 to 6099                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_ENCRYPTION_FAILED
'//
'// MessageText:
'//
'// The specified file could not be encrypted.
'//
%ERROR_ENCRYPTION_FAILED          = 6000&

'//
'// MessageId: ERROR_DECRYPTION_FAILED
'//
'// MessageText:
'//
'// The specified file could not be decrypted.
'//
%ERROR_DECRYPTION_FAILED          = 6001&

'//
'// MessageId: ERROR_FILE_ENCRYPTED
'//
'// MessageText:
'//
'// The specified file is encrypted and the user does not have the ability to decrypt it.
'//
%ERROR_FILE_ENCRYPTED             = 6002&

'//
'// MessageId: ERROR_NO_RECOVERY_POLICY
'//
'// MessageText:
'//
'// There is no valid encryption recovery policy configured for this system.
'//
%ERROR_NO_RECOVERY_POLICY         = 6003&

'//
'// MessageId: ERROR_NO_EFS
'//
'// MessageText:
'//
'// The required encryption driver is not loaded for this system.
'//
%ERROR_NO_EFS                     = 6004&

'//
'// MessageId: ERROR_WRONG_EFS
'//
'// MessageText:
'//
'// The file was encrypted with a different encryption driver than is currently loaded.
'//
%ERROR_WRONG_EFS                  = 6005&

'//
'// MessageId: ERROR_NO_USER_KEYS
'//
'// MessageText:
'//
'// There are no EFS keys defined for the user.
'//
%ERROR_NO_USER_KEYS               = 6006&

'//
'// MessageId: ERROR_FILE_NOT_ENCRYPTED
'//
'// MessageText:
'//
'// The specified file is not encrypted.
'//
%ERROR_FILE_NOT_ENCRYPTED         = 6007&

'//
'// MessageId: ERROR_NOT_EXPORT_FORMAT
'//
'// MessageText:
'//
'// The specified file is not in the defined EFS export format.
'//
%ERROR_NOT_EXPORT_FORMAT          = 6008&

'//
'// MessageId: ERROR_FILE_READ_ONLY
'//
'// MessageText:
'//
'// The specified file is read only.
'//
%ERROR_FILE_READ_ONLY             = 6009&

'//
'// MessageId: ERROR_DIR_EFS_DISALLOWED
'//
'// MessageText:
'//
'// The directory has been disabled for encryption.
'//
%ERROR_DIR_EFS_DISALLOWED         = 6010&

'//
'// MessageId: ERROR_EFS_SERVER_NOT_TRUSTED
'//
'// MessageText:
'//
'// The server is not trusted for remote encryption operation.
'//
%ERROR_EFS_SERVER_NOT_TRUSTED     = 6011&

'//
'// MessageId: ERROR_BAD_RECOVERY_POLICY
'//
'// MessageText:
'//
'// Recovery policy configured for this system contains invalid recovery certificate.
'//
%ERROR_BAD_RECOVERY_POLICY        = 6012&

'//
'// MessageId: ERROR_EFS_ALG_BLOB_TOO_BIG
'//
'// MessageText:
'//
'// The encryption algorithm used on the source file needs a bigger key buffer than the one on the destination file.
'//
%ERROR_EFS_ALG_BLOB_TOO_BIG       = 6013&

'//
'// MessageId: ERROR_VOLUME_NOT_SUPPORT_EFS
'//
'// MessageText:
'//
'// The disk partition does not support file encryption.
'//
%ERROR_VOLUME_NOT_SUPPORT_EFS     = 6014&

'//
'// MessageId: ERROR_EFS_DISABLED
'//
'// MessageText:
'//
'// This machine is disabled for file encryption.
'//
%ERROR_EFS_DISABLED               = 6015&

'//
'// MessageId: ERROR_EFS_VERSION_NOT_SUPPORT
'//
'// MessageText:
'//
'// A newer system is required to decrypt this encrypted file.
'//
%ERROR_EFS_VERSION_NOT_SUPPORT    = 6016&

'//
'// MessageId: ERROR_CS_ENCRYPTION_INVALID_SERVER_RESPONSE
'//
'// MessageText:
'//
'// The remote server sent an invalid response for a file being opened with Client Side Encryption.
'//
%ERROR_CS_ENCRYPTION_INVALID_SERVER_RESPONSE = 6017&

'//
'// MessageId: ERROR_CS_ENCRYPTION_UNSUPPORTED_SERVER
'//
'// MessageText:
'//
'// Client Side Encryption is not supported by the remote server even though it claims to support it.
'//
%ERROR_CS_ENCRYPTION_UNSUPPORTED_SERVER = 6018&

'//
'// MessageId: ERROR_CS_ENCRYPTION_EXISTING_ENCRYPTED_FILE
'//
'// MessageText:
'//
'// File is encrypted and should be opened in Client Side Encryption mode.
'//
%ERROR_CS_ENCRYPTION_EXISTING_ENCRYPTED_FILE = 6019&

'//
'// MessageId: ERROR_CS_ENCRYPTION_NEW_ENCRYPTED_FILE
'//
'// MessageText:
'//
'// A new encrypted file is being created and a $EFS needs to be provided.
'//
%ERROR_CS_ENCRYPTION_NEW_ENCRYPTED_FILE = 6020&

'//
'// MessageId: ERROR_CS_ENCRYPTION_FILE_NOT_CSE
'//
'// MessageText:
'//
'// The SMB client requested a CSE FSCTL on a non-CSE file.
'//
%ERROR_CS_ENCRYPTION_FILE_NOT_CSE = 6021&


'///////////////////////////////////////////////////
'//                                               //
'//              BROWSER Error codes              //
'//                                               //
'//                 = 6100 to 6199                //
'///////////////////////////////////////////////////

'// This message number is for historical purposes and cannot be changed or re-used.
'//
'// MessageId: ERROR_NO_BROWSER_SERVERS_FOUND
'//
'// MessageText:
'//
'// The list of servers for this workgroup is not currently available
'//
%ERROR_NO_BROWSER_SERVERS_FOUND   = 6118&


'///////////////////////////////////////////////////
'//                                               //
'//            Task Scheduler Error codes         //
'//            NET START must understand          //
'//                                               //
'//                 = 6200 to 6249                //
'///////////////////////////////////////////////////

'//
'// MessageId: SCHED_E_SERVICE_NOT_LOCALSYSTEM
'//
'// MessageText:
'//
'// The Task Scheduler service must be configured to run in the System account to function properly. Individual tasks may be configured to run in other accounts.
'//
%SCHED_E_SERVICE_NOT_LOCALSYSTEM = 6200&


'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 6250 to 6599                //
'///////////////////////////////////////////////////

'///////////////////////////////////////////////////
'//                                               //
'//         Common Log (CLFS) Error codes         //
'//                                               //
'//                 = 6600 to 6699                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_LOG_SECTOR_INVALID
'//
'// MessageText:
'//
'// Log service encountered an invalid log sector.
'//
%ERROR_LOG_SECTOR_INVALID         = 6600&

'//
'// MessageId: ERROR_LOG_SECTOR_PARITY_INVALID
'//
'// MessageText:
'//
'// Log service encountered a log sector with invalid block parity.
'//
%ERROR_LOG_SECTOR_PARITY_INVALID = 6601&

'//
'// MessageId: ERROR_LOG_SECTOR_REMAPPED
'//
'// MessageText:
'//
'// Log service encountered a remapped log sector.
'//
%ERROR_LOG_SECTOR_REMAPPED        = 6602&

'//
'// MessageId: ERROR_LOG_BLOCK_INCOMPLETE
'//
'// MessageText:
'//
'// Log service encountered a partial or incomplete log block.
'//
%ERROR_LOG_BLOCK_INCOMPLETE       = 6603&

'//
'// MessageId: ERROR_LOG_INVALID_RANGE
'//
'// MessageText:
'//
'// Log service encountered an attempt access data outside the active log range.
'//
%ERROR_LOG_INVALID_RANGE          = 6604&

'//
'// MessageId: ERROR_LOG_BLOCKS_EXHAUSTED
'//
'// MessageText:
'//
'// Log service user marshalling buffers are exhausted.
'//
%ERROR_LOG_BLOCKS_EXHAUSTED       = 6605&

'//
'// MessageId: ERROR_LOG_READ_CONTEXT_INVALID
'//
'// MessageText:
'//
'// Log service encountered an attempt read from a marshalling area with an invalid read context.
'//
%ERROR_LOG_READ_CONTEXT_INVALID   = 6606&

'//
'// MessageId: ERROR_LOG_RESTART_INVALID
'//
'// MessageText:
'//
'// Log service encountered an invalid log restart area.
'//
%ERROR_LOG_RESTART_INVALID        = 6607&

'//
'// MessageId: ERROR_LOG_BLOCK_VERSION
'//
'// MessageText:
'//
'// Log service encountered an invalid log block version.
'//
%ERROR_LOG_BLOCK_VERSION          = 6608&

'//
'// MessageId: ERROR_LOG_BLOCK_INVALID
'//
'// MessageText:
'//
'// Log service encountered an invalid log block.
'//
%ERROR_LOG_BLOCK_INVALID          = 6609&

'//
'// MessageId: ERROR_LOG_READ_MODE_INVALID
'//
'// MessageText:
'//
'// Log service encountered an attempt to read the log with an invalid read mode.
'//
%ERROR_LOG_READ_MODE_INVALID      = 6610&

'//
'// MessageId: ERROR_LOG_NO_RESTART
'//
'// MessageText:
'//
'// Log service encountered a log stream with no restart area.
'//
%ERROR_LOG_NO_RESTART             = 6611&

'//
'// MessageId: ERROR_LOG_METADATA_CORRUPT
'//
'// MessageText:
'//
'// Log service encountered a corrupted metadata file.
'//
%ERROR_LOG_METADATA_CORRUPT       = 6612&

'//
'// MessageId: ERROR_LOG_METADATA_INVALID
'//
'// MessageText:
'//
'// Log service encountered a metadata file that could not be created by the log file system.
'//
%ERROR_LOG_METADATA_INVALID       = 6613&

'//
'// MessageId: ERROR_LOG_METADATA_INCONSISTENT
'//
'// MessageText:
'//
'// Log service encountered a metadata file with inconsistent data.
'//
%ERROR_LOG_METADATA_INCONSISTENT = 6614&

'//
'// MessageId: ERROR_LOG_RESERVATION_INVALID
'//
'// MessageText:
'//
'// Log service encountered an attempt to erroneous allocate or dispose reservation space.
'//
%ERROR_LOG_RESERVATION_INVALID    = 6615&

'//
'// MessageId: ERROR_LOG_CANT_DELETE
'//
'// MessageText:
'//
'// Log service cannot delete log file or file system container.
'//
%ERROR_LOG_CANT_DELETE            = 6616&

'//
'// MessageId: ERROR_LOG_CONTAINER_LIMIT_EXCEEDED
'//
'// MessageText:
'//
'// Log service has reached the maximum allowable containers allocated to a log file.
'//
%ERROR_LOG_CONTAINER_LIMIT_EXCEEDED = 6617&

'//
'// MessageId: ERROR_LOG_START_OF_LOG
'//
'// MessageText:
'//
'// Log service has attempted to read or write backward past the start of the log.
'//
%ERROR_LOG_START_OF_LOG           = 6618&

'//
'// MessageId: ERROR_LOG_POLICY_ALREADY_INSTALLED
'//
'// MessageText:
'//
'// Log policy could not be installed because a policy of the same type is already present.
'//
%ERROR_LOG_POLICY_ALREADY_INSTALLED = 6619&

'//
'// MessageId: ERROR_LOG_POLICY_NOT_INSTALLED
'//
'// MessageText:
'//
'// Log policy in question was not installed at the time of the request.
'//
%ERROR_LOG_POLICY_NOT_INSTALLED   = 6620&

'//
'// MessageId: ERROR_LOG_POLICY_INVALID
'//
'// MessageText:
'//
'// The installed set of policies on the log is invalid.
'//
%ERROR_LOG_POLICY_INVALID         = 6621&

'//
'// MessageId: ERROR_LOG_POLICY_CONFLICT
'//
'// MessageText:
'//
'// A policy on the log in question prevented the operation from completing.
'//
%ERROR_LOG_POLICY_CONFLICT        = 6622&

'//
'// MessageId: ERROR_LOG_PINNED_ARCHIVE_TAIL
'//
'// MessageText:
'//
'// Log space cannot be reclaimed because the log is pinned by the archive tail.
'//
%ERROR_LOG_PINNED_ARCHIVE_TAIL    = 6623&

'//
'// MessageId: ERROR_LOG_RECORD_NONEXISTENT
'//
'// MessageText:
'//
'// Log record is not a record in the log file.
'//
%ERROR_LOG_RECORD_NONEXISTENT     = 6624&

'//
'// MessageId: ERROR_LOG_RECORDS_RESERVED_INVALID
'//
'// MessageText:
'//
'// Number of reserved log records or the adjustment of the number of reserved log records is invalid.
'//
%ERROR_LOG_RECORDS_RESERVED_INVALID = 6625&

'//
'// MessageId: ERROR_LOG_SPACE_RESERVED_INVALID
'//
'// MessageText:
'//
'// Reserved log space or the adjustment of the log space is invalid.
'//
%ERROR_LOG_SPACE_RESERVED_INVALID = 6626&

'//
'// MessageId: ERROR_LOG_TAIL_INVALID
'//
'// MessageText:
'//
'// An new or existing archive tail or base of the active log is invalid.
'//
%ERROR_LOG_TAIL_INVALID           = 6627&

'//
'// MessageId: ERROR_LOG_FULL
'//
'// MessageText:
'//
'// Log space is exhausted.
'//
%ERROR_LOG_FULL                   = 6628&

'//
'// MessageId: ERROR_COULD_NOT_RESIZE_LOG
'//
'// MessageText:
'//
'// The log could not be set to the requested size.
'//
%ERROR_COULD_NOT_RESIZE_LOG       = 6629&

'//
'// MessageId: ERROR_LOG_MULTIPLEXED
'//
'// MessageText:
'//
'// Log is multiplexed, no direct writes to the physical log is allowed.
'//
%ERROR_LOG_MULTIPLEXED            = 6630&

'//
'// MessageId: ERROR_LOG_DEDICATED
'//
'// MessageText:
'//
'// The operation failed because the log is a dedicated log.
'//
%ERROR_LOG_DEDICATED              = 6631&

'//
'// MessageId: ERROR_LOG_ARCHIVE_NOT_IN_PROGRESS
'//
'// MessageText:
'//
'// The operation requires an archive context.
'//
%ERROR_LOG_ARCHIVE_NOT_IN_PROGRESS = 6632&

'//
'// MessageId: ERROR_LOG_ARCHIVE_IN_PROGRESS
'//
'// MessageText:
'//
'// Log archival is in progress.
'//
%ERROR_LOG_ARCHIVE_IN_PROGRESS    = 6633&

'//
'// MessageId: ERROR_LOG_EPHEMERAL
'//
'// MessageText:
'//
'// The operation requires a non-ephemeral log, but the log is ephemeral.
'//
%ERROR_LOG_EPHEMERAL              = 6634&

'//
'// MessageId: ERROR_LOG_NOT_ENOUGH_CONTAINERS
'//
'// MessageText:
'//
'// The log must have at least two containers before it can be read from or written to.
'//
%ERROR_LOG_NOT_ENOUGH_CONTAINERS = 6635&

'//
'// MessageId: ERROR_LOG_CLIENT_ALREADY_REGISTERED
'//
'// MessageText:
'//
'// A log client has already registered on the stream.
'//
%ERROR_LOG_CLIENT_ALREADY_REGISTERED = 6636&

'//
'// MessageId: ERROR_LOG_CLIENT_NOT_REGISTERED
'//
'// MessageText:
'//
'// A log client has not been registered on the stream.
'//
%ERROR_LOG_CLIENT_NOT_REGISTERED = 6637&

'//
'// MessageId: ERROR_LOG_FULL_HANDLER_IN_PROGRESS
'//
'// MessageText:
'//
'// A request has already been made to handle the log full condition.
'//
%ERROR_LOG_FULL_HANDLER_IN_PROGRESS = 6638&

'//
'// MessageId: ERROR_LOG_CONTAINER_READ_FAILED
'//
'// MessageText:
'//
'// Log service enountered an error when attempting to read from a log container.
'//
%ERROR_LOG_CONTAINER_READ_FAILED = 6639&

'//
'// MessageId: ERROR_LOG_CONTAINER_WRITE_FAILED
'//
'// MessageText:
'//
'// Log service enountered an error when attempting to write to a log container.
'//
%ERROR_LOG_CONTAINER_WRITE_FAILED = 6640&

'//
'// MessageId: ERROR_LOG_CONTAINER_OPEN_FAILED
'//
'// MessageText:
'//
'// Log service enountered an error when attempting open a log container.
'//
%ERROR_LOG_CONTAINER_OPEN_FAILED = 6641&

'//
'// MessageId: ERROR_LOG_CONTAINER_STATE_INVALID
'//
'// MessageText:
'//
'// Log service enountered an invalid container state when attempting a requested action.
'//
%ERROR_LOG_CONTAINER_STATE_INVALID = 6642&

'//
'// MessageId: ERROR_LOG_STATE_INVALID
'//
'// MessageText:
'//
'// Log service is not in the correct state to perform a requested action.
'//
%ERROR_LOG_STATE_INVALID          = 6643&

'//
'// MessageId: ERROR_LOG_PINNED
'//
'// MessageText:
'//
'// Log space cannot be reclaimed because the log is pinned.
'//
%ERROR_LOG_PINNED                 = 6644&

'//
'// MessageId: ERROR_LOG_METADATA_FLUSH_FAILED
'//
'// MessageText:
'//
'// Log metadata flush failed.
'//
%ERROR_LOG_METADATA_FLUSH_FAILED = 6645&

'//
'// MessageId: ERROR_LOG_INCONSISTENT_SECURITY
'//
'// MessageText:
'//
'// Security on the log and its containers is inconsistent.
'//
%ERROR_LOG_INCONSISTENT_SECURITY = 6646&

'//
'// MessageId: ERROR_LOG_APPENDED_FLUSH_FAILED
'//
'// MessageText:
'//
'// Records were appended to the log or reservation changes were made, but the log could not be flushed.
'//
%ERROR_LOG_APPENDED_FLUSH_FAILED = 6647&

'//
'// MessageId: ERROR_LOG_PINNED_RESERVATION
'//
'// MessageText:
'//
'// The log is pinned due to reservation consuming most of the log space. Free some reserved records to make space available.
'//
%ERROR_LOG_PINNED_RESERVATION     = 6648&


'///////////////////////////////////////////////////
'//                                               //
'//           Transaction (KTM) Error codes       //
'//                                               //
'//                 = 6700 to 6799                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_INVALID_TRANSACTION
'//
'// MessageText:
'//
'// The transaction handle associated with this operation is not valid.
'//
%ERROR_INVALID_TRANSACTION        = 6700&

'//
'// MessageId: ERROR_TRANSACTION_NOT_ACTIVE
'//
'// MessageText:
'//
'// The requested operation was made in the context of a transaction that is no longer active.
'//
%ERROR_TRANSACTION_NOT_ACTIVE     = 6701&

'//
'// MessageId: ERROR_TRANSACTION_REQUEST_NOT_VALID
'//
'// MessageText:
'//
'// The requested operation is not valid on the Transaction object in its current state.
'//
%ERROR_TRANSACTION_REQUEST_NOT_VALID = 6702&

'//
'// MessageId: ERROR_TRANSACTION_NOT_REQUESTED
'//
'// MessageText:
'//
'// The caller has called a response API, but the response is not expected because the TM did not issue the corresponding request to the caller.
'//
%ERROR_TRANSACTION_NOT_REQUESTED = 6703&

'//
'// MessageId: ERROR_TRANSACTION_ALREADY_ABORTED
'//
'// MessageText:
'//
'// It is too late to perform the requested operation, since the Transaction has already been aborted.
'//
%ERROR_TRANSACTION_ALREADY_ABORTED = 6704&

'//
'// MessageId: ERROR_TRANSACTION_ALREADY_COMMITTED
'//
'// MessageText:
'//
'// It is too late to perform the requested operation, since the Transaction has already been committed.
'//
%ERROR_TRANSACTION_ALREADY_COMMITTED = 6705&

'//
'// MessageId: ERROR_TM_INITIALIZATION_FAILED
'//
'// MessageText:
'//
'// The Transaction Manager was unable to be successfully initialized. Transacted operations are not supported.
'//
%ERROR_TM_INITIALIZATION_FAILED   = 6706&

'//
'// MessageId: ERROR_RESOURCEMANAGER_READ_ONLY
'//
'// MessageText:
'//
'// The specified ResourceManager made no changes or updates to the resource under this transaction.
'//
%ERROR_RESOURCEMANAGER_READ_ONLY = 6707&

'//
'// MessageId: ERROR_TRANSACTION_NOT_JOINED
'//
'// MessageText:
'//
'// The resource manager has attempted to prepare a transaction that it has not successfully joined.
'//
%ERROR_TRANSACTION_NOT_JOINED     = 6708&

'//
'// MessageId: ERROR_TRANSACTION_SUPERIOR_EXISTS
'//
'// MessageText:
'//
'// The Transaction object already has a superior enlistment, and the caller attempted an operation that would have created a new superior. Only a single superior enlistment is allow.
'//
%ERROR_TRANSACTION_SUPERIOR_EXISTS = 6709&

'//
'// MessageId: ERROR_CRM_PROTOCOL_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The RM tried to register a protocol that already exists.
'//
%ERROR_CRM_PROTOCOL_ALREADY_EXISTS = 6710&

'//
'// MessageId: ERROR_TRANSACTION_PROPAGATION_FAILED
'//
'// MessageText:
'//
'// The attempt to propagate the Transaction failed.
'//
%ERROR_TRANSACTION_PROPAGATION_FAILED = 6711&

'//
'// MessageId: ERROR_CRM_PROTOCOL_NOT_FOUND
'//
'// MessageText:
'//
'// The requested propagation protocol was not registered as a CRM.
'//
%ERROR_CRM_PROTOCOL_NOT_FOUND     = 6712&

'//
'// MessageId: ERROR_TRANSACTION_INVALID_MARSHALL_BUFFER
'//
'// MessageText:
'//
'// The buffer passed in to PushTransaction or PullTransaction is not in a valid format.
'//
%ERROR_TRANSACTION_INVALID_MARSHALL_BUFFER = 6713&

'//
'// MessageId: ERROR_CURRENT_TRANSACTION_NOT_VALID
'//
'// MessageText:
'//
'// The current transaction context associated with the thread is not a valid handle to a transaction object.
'//
%ERROR_CURRENT_TRANSACTION_NOT_VALID = 6714&

'//
'// MessageId: ERROR_TRANSACTION_NOT_FOUND
'//
'// MessageText:
'//
'// The specified Transaction object could not be opened, because it was not found.
'//
%ERROR_TRANSACTION_NOT_FOUND      = 6715&

'//
'// MessageId: ERROR_RESOURCEMANAGER_NOT_FOUND
'//
'// MessageText:
'//
'// The specified ResourceManager object could not be opened, because it was not found.
'//
%ERROR_RESOURCEMANAGER_NOT_FOUND = 6716&

'//
'// MessageId: ERROR_ENLISTMENT_NOT_FOUND
'//
'// MessageText:
'//
'// The specified Enlistment object could not be opened, because it was not found.
'//
%ERROR_ENLISTMENT_NOT_FOUND       = 6717&

'//
'// MessageId: ERROR_TRANSACTIONMANAGER_NOT_FOUND
'//
'// MessageText:
'//
'// The specified TransactionManager object could not be opened, because it was not found.
'//
%ERROR_TRANSACTIONMANAGER_NOT_FOUND = 6718&

'//
'// MessageId: ERROR_TRANSACTIONMANAGER_NOT_ONLINE
'//
'// MessageText:
'//
'// The specified ResourceManager was unable to create an enlistment, because its associated TransactionManager is not online.
'//
%ERROR_TRANSACTIONMANAGER_NOT_ONLINE = 6719&

'//
'// MessageId: ERROR_TRANSACTIONMANAGER_RECOVERY_NAME_COLLISION
'//
'// MessageText:
'//
'// The specified TransactionManager was unable to create the objects contained in its logfile in the Ob namespace. Therefore, the TransactionManager was unable to recover.
'//
%ERROR_TRANSACTIONMANAGER_RECOVERY_NAME_COLLISION = 6720&

'//
'// MessageId: ERROR_TRANSACTION_NOT_ROOT
'//
'// MessageText:
'//
'// The call to create a superior Enlistment on this Transaction object could not be completed, because the Transaction object specified for the enlistment is a subordinate branch of the Transaction.
'// Only the root of the Transactoin can be enlisted on as a superior.
'//
%ERROR_TRANSACTION_NOT_ROOT       = 6721&

'//
'// MessageId: ERROR_TRANSACTION_OBJECT_EXPIRED
'//
'// MessageText:
'//
'// Because the associated transaction manager or resource manager has been closed, the handle is no longer valid.
'//
%ERROR_TRANSACTION_OBJECT_EXPIRED = 6722&

'//
'// MessageId: ERROR_TRANSACTION_RESPONSE_NOT_ENLISTED
'//
'// MessageText:
'//
'// The specified operation could not be performed on this Superior enlistment, because the enlistment was not created with the corresponding completion response in the NotificationMask.
'//
%ERROR_TRANSACTION_RESPONSE_NOT_ENLISTED = 6723&

'//
'// MessageId: ERROR_TRANSACTION_RECORD_TOO_LONG
'//
'// MessageText:
'//
'// The specified operation could not be performed, because the record that would be logged was too long.  This can occur because of two conditions:  either there are too many Enlistments on this Transaction,
'// or the combined RecoveryInformation being logged on behalf of those Enlistments is too long.
'//
%ERROR_TRANSACTION_RECORD_TOO_LONG = 6724&

'//
'// MessageId: ERROR_IMPLICIT_TRANSACTION_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Implicit transaction are not supported.
'//
%ERROR_IMPLICIT_TRANSACTION_NOT_SUPPORTED = 6725&

'//
'// MessageId: ERROR_TRANSACTION_INTEGRITY_VIOLATED
'//
'// MessageText:
'//
'// The kernel transaction manager had to abort or forget the transaction because it blocked forward progress.
'//
%ERROR_TRANSACTION_INTEGRITY_VIOLATED = 6726&


'///////////////////////////////////////////////////
'//                                               //
'//        Transactional File Services (TxF)      //
'//                  Error codes                  //
'//                                               //
'//                 = 6800 to 6899                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_TRANSACTIONAL_CONFLICT
'//
'// MessageText:
'//
'// The function attempted to use a name that is reserved for use by another transaction.
'//
%ERROR_TRANSACTIONAL_CONFLICT     = 6800&

'//
'// MessageId: ERROR_RM_NOT_ACTIVE
'//
'// MessageText:
'//
'// Transaction support within the specified file system resource manager is not started or was shutdown due to an error.
'//
%ERROR_RM_NOT_ACTIVE              = 6801&

'//
'// MessageId: ERROR_RM_METADATA_CORRUPT
'//
'// MessageText:
'//
'// The metadata of the RM has been corrupted. The RM will not function.
'//
%ERROR_RM_METADATA_CORRUPT        = 6802&

'//
'// MessageId: ERROR_DIRECTORY_NOT_RM
'//
'// MessageText:
'//
'// The specified directory does not contain a resource manager.
'//
%ERROR_DIRECTORY_NOT_RM           = 6803&

'//
'// MessageId: ERROR_TRANSACTIONS_UNSUPPORTED_REMOTE
'//
'// MessageText:
'//
'// The remote server or share does not support transacted file operations.
'//
%ERROR_TRANSACTIONS_UNSUPPORTED_REMOTE = 6805&

'//
'// MessageId: ERROR_LOG_RESIZE_INVALID_SIZE
'//
'// MessageText:
'//
'// The requested log size is invalid.
'//
%ERROR_LOG_RESIZE_INVALID_SIZE    = 6806&

'//
'// MessageId: ERROR_OBJECT_NO_LONGER_EXISTS
'//
'// MessageText:
'//
'// The object (file, stream, link) corresponding to the handle has been deleted by a Transaction Savepoint Rollback.
'//
%ERROR_OBJECT_NO_LONGER_EXISTS    = 6807&

'//
'// MessageId: ERROR_STREAM_MINIVERSION_NOT_FOUND
'//
'// MessageText:
'//
'// The specified file miniversion was not found for this transacted file open.
'//
%ERROR_STREAM_MINIVERSION_NOT_FOUND = 6808&

'//
'// MessageId: ERROR_STREAM_MINIVERSION_NOT_VALID
'//
'// MessageText:
'//
'// The specified file miniversion was found but has been invalidated. Most likely cause is a transaction savepoint rollback.
'//
%ERROR_STREAM_MINIVERSION_NOT_VALID = 6809&

'//
'// MessageId: ERROR_MINIVERSION_INACCESSIBLE_FROM_SPECIFIED_TRANSACTION
'//
'// MessageText:
'//
'// A miniversion may only be opened in the context of the transaction that created it.
'//
%ERROR_MINIVERSION_INACCESSIBLE_FROM_SPECIFIED_TRANSACTION = 6810&

'//
'// MessageId: ERROR_CANT_OPEN_MINIVERSION_WITH_MODIFY_INTENT
'//
'// MessageText:
'//
'// It is not possible to open a miniversion with modify access.
'//
%ERROR_CANT_OPEN_MINIVERSION_WITH_MODIFY_INTENT = 6811&

'//
'// MessageId: ERROR_CANT_CREATE_MORE_STREAM_MINIVERSIONS
'//
'// MessageText:
'//
'// It is not possible to create any more miniversions for this stream.
'//
%ERROR_CANT_CREATE_MORE_STREAM_MINIVERSIONS = 6812&

'//
'// MessageId: ERROR_REMOTE_FILE_VERSION_MISMATCH
'//
'// MessageText:
'//
'// The remote server sent mismatching version number or Fid for a file opened with transactions.
'//
%ERROR_REMOTE_FILE_VERSION_MISMATCH = 6814&

'//
'// MessageId: ERROR_HANDLE_NO_LONGER_VALID
'//
'// MessageText:
'//
'// The handle has been invalidated by a transaction. The most likely cause is the presence of memory mapping on a file or an open handle when the transaction ended or rolled back to savepoint.
'//
%ERROR_HANDLE_NO_LONGER_VALID     = 6815&

'//
'// MessageId: ERROR_NO_TXF_METADATA
'//
'// MessageText:
'//
'// There is no transaction metadata on the file.
'//
%ERROR_NO_TXF_METADATA            = 6816&

'//
'// MessageId: ERROR_LOG_CORRUPTION_DETECTED
'//
'// MessageText:
'//
'// The log data is corrupt.
'//
%ERROR_LOG_CORRUPTION_DETECTED    = 6817&

'//
'// MessageId: ERROR_CANT_RECOVER_WITH_HANDLE_OPEN
'//
'// MessageText:
'//
'// The file can't be recovered because there is a handle still open on it.
'//
%ERROR_CANT_RECOVER_WITH_HANDLE_OPEN = 6818&

'//
'// MessageId: ERROR_RM_DISCONNECTED
'//
'// MessageText:
'//
'// The transaction outcome is unavailable because the resource manager responsible for it has disconnected.
'//
%ERROR_RM_DISCONNECTED            = 6819&

'//
'// MessageId: ERROR_ENLISTMENT_NOT_SUPERIOR
'//
'// MessageText:
'//
'// The request was rejected because the enlistment in question is not a superior enlistment.
'//
%ERROR_ENLISTMENT_NOT_SUPERIOR    = 6820&

'//
'// MessageId: ERROR_RECOVERY_NOT_NEEDED
'//
'// MessageText:
'//
'// The transactional resource manager is already consistent. Recovery is not needed.
'//
%ERROR_RECOVERY_NOT_NEEDED        = 6821&

'//
'// MessageId: ERROR_RM_ALREADY_STARTED
'//
'// MessageText:
'//
'// The transactional resource manager has already been started.
'//
%ERROR_RM_ALREADY_STARTED         = 6822&

'//
'// MessageId: ERROR_FILE_IDENTITY_NOT_PERSISTENT
'//
'// MessageText:
'//
'// The file cannot be opened transactionally, because its identity depends on the outcome of an unresolved transaction.
'//
%ERROR_FILE_IDENTITY_NOT_PERSISTENT = 6823&

'//
'// MessageId: ERROR_CANT_BREAK_TRANSACTIONAL_DEPENDENCY
'//
'// MessageText:
'//
'// The operation cannot be performed because another transaction is depending on the fact that this property will not change.
'//
%ERROR_CANT_BREAK_TRANSACTIONAL_DEPENDENCY = 6824&

'//
'// MessageId: ERROR_CANT_CROSS_RM_BOUNDARY
'//
'// MessageText:
'//
'// The operation would involve a single file with two transactional resource managers and is therefore not allowed.
'//
%ERROR_CANT_CROSS_RM_BOUNDARY     = 6825&

'//
'// MessageId: ERROR_TXF_DIR_NOT_EMPTY
'//
'// MessageText:
'//
'// The $Txf directory must be empty for this operation to succeed.
'//
%ERROR_TXF_DIR_NOT_EMPTY          = 6826&

'//
'// MessageId: ERROR_INDOUBT_TRANSACTIONS_EXIST
'//
'// MessageText:
'//
'// The operation would leave a transactional resource manager in an inconsistent state and is therefore not allowed.
'//
%ERROR_INDOUBT_TRANSACTIONS_EXIST = 6827&

'//
'// MessageId: ERROR_TM_VOLATILE
'//
'// MessageText:
'//
'// The operation could not be completed because the transaction manager does not have a log.
'//
%ERROR_TM_VOLATILE                = 6828&

'//
'// MessageId: ERROR_ROLLBACK_TIMER_EXPIRED
'//
'// MessageText:
'//
'// A rollback could not be scheduled because a previously scheduled rollback has already executed or been queued for execution.
'//
%ERROR_ROLLBACK_TIMER_EXPIRED     = 6829&

'//
'// MessageId: ERROR_TXF_ATTRIBUTE_CORRUPT
'//
'// MessageText:
'//
'// The transactional metadata attribute on the file or directory is corrupt and unreadable.
'//
%ERROR_TXF_ATTRIBUTE_CORRUPT      = 6830&

'//
'// MessageId: ERROR_EFS_NOT_ALLOWED_IN_TRANSACTION
'//
'// MessageText:
'//
'// The encryption operation could not be completed because a transaction is active.
'//
%ERROR_EFS_NOT_ALLOWED_IN_TRANSACTION = 6831&

'//
'// MessageId: ERROR_TRANSACTIONAL_OPEN_NOT_ALLOWED
'//
'// MessageText:
'//
'// This object is not allowed to be opened in a transaction.
'//
%ERROR_TRANSACTIONAL_OPEN_NOT_ALLOWED = 6832&

'//
'// MessageId: ERROR_LOG_GROWTH_FAILED
'//
'// MessageText:
'//
'// An attempt to create space in the transactional resource manager's log failed. The failure status has been recorded in the event log.
'//
%ERROR_LOG_GROWTH_FAILED          = 6833&

'//
'// MessageId: ERROR_TRANSACTED_MAPPING_UNSUPPORTED_REMOTE
'//
'// MessageText:
'//
'// Memory mapping (creating a mapped section) a remote file under a transaction is not supported.
'//
%ERROR_TRANSACTED_MAPPING_UNSUPPORTED_REMOTE = 6834&

'//
'// MessageId: ERROR_TXF_METADATA_ALREADY_PRESENT
'//
'// MessageText:
'//
'// Transaction metadata is already present on this file and cannot be superseded.
'//
%ERROR_TXF_METADATA_ALREADY_PRESENT = 6835&

'//
'// MessageId: ERROR_TRANSACTION_SCOPE_CALLBACKS_NOT_SET
'//
'// MessageText:
'//
'// A transaction scope could not be entered because the scope handler has not been initialized.
'//
%ERROR_TRANSACTION_SCOPE_CALLBACKS_NOT_SET = 6836&

'//
'// MessageId: ERROR_TRANSACTION_REQUIRED_PROMOTION
'//
'// MessageText:
'//
'// Promotion was required in order to allow the resource manager to enlist, but the transaction was set to disallow it.
'//
%ERROR_TRANSACTION_REQUIRED_PROMOTION = 6837&

'//
'// MessageId: ERROR_CANNOT_EXECUTE_FILE_IN_TRANSACTION
'//
'// MessageText:
'//
'// This file is open for modification in an unresolved transaction and may be opened for execute only by a transacted reader.
'//
%ERROR_CANNOT_EXECUTE_FILE_IN_TRANSACTION = 6838&

'//
'// MessageId: ERROR_TRANSACTIONS_NOT_FROZEN
'//
'// MessageText:
'//
'// The request to thaw frozen transactions was ignored because transactions had not previously been frozen.
'//
%ERROR_TRANSACTIONS_NOT_FROZEN    = 6839&

'//
'// MessageId: ERROR_TRANSACTION_FREEZE_IN_PROGRESS
'//
'// MessageText:
'//
'// Transactions cannot be frozen because a freeze is already in progress.
'//
%ERROR_TRANSACTION_FREEZE_IN_PROGRESS = 6840&

'//
'// MessageId: ERROR_NOT_SNAPSHOT_VOLUME
'//
'// MessageText:
'//
'// The target volume is not a snapshot volume. This operation is only valid on a volume mounted as a snapshot.
'//
%ERROR_NOT_SNAPSHOT_VOLUME        = 6841&

'//
'// MessageId: ERROR_NO_SAVEPOINT_WITH_OPEN_FILES
'//
'// MessageText:
'//
'// The savepoint operation failed because files are open on the transaction. This is not permitted.
'//
%ERROR_NO_SAVEPOINT_WITH_OPEN_FILES = 6842&

'//
'// MessageId: ERROR_DATA_LOST_REPAIR
'//
'// MessageText:
'//
'// Windows has discovered corruption in a file, and that file has since been repaired. Data loss may have occurred.
'//
%ERROR_DATA_LOST_REPAIR           = 6843&

'//
'// MessageId: ERROR_SPARSE_NOT_ALLOWED_IN_TRANSACTION
'//
'// MessageText:
'//
'// The sparse operation could not be completed because a transaction is active on the file.
'//
%ERROR_SPARSE_NOT_ALLOWED_IN_TRANSACTION = 6844&

'//
'// MessageId: ERROR_TM_IDENTITY_MISMATCH
'//
'// MessageText:
'//
'// The call to create a TransactionManager object failed because the Tm Identity stored in the logfile does not match the Tm Identity that was passed in as an argument.
'//
%ERROR_TM_IDENTITY_MISMATCH       = 6845&

'//
'// MessageId: ERROR_FLOATED_SECTION
'//
'// MessageText:
'//
'// I/O was attempted on a section object that has been floated as a result of a transaction ending. There is no valid data.
'//
%ERROR_FLOATED_SECTION            = 6846&

'//
'// MessageId: ERROR_CANNOT_ACCEPT_TRANSACTED_WORK
'//
'// MessageText:
'//
'// The transactional resource manager cannot currently accept transacted work due to a transient condition such as low resources.
'//
%ERROR_CANNOT_ACCEPT_TRANSACTED_WORK = 6847&

'//
'// MessageId: ERROR_CANNOT_ABORT_TRANSACTIONS
'//
'// MessageText:
'//
'// The transactional resource manager had too many tranactions outstanding that could not be aborted. The transactional resource manger has been shut down.
'//
%ERROR_CANNOT_ABORT_TRANSACTIONS = 6848&

'//
'// MessageId: ERROR_BAD_CLUSTERS
'//
'// MessageText:
'//
'// The operation could not be completed due to bad clusters on disk.
'//
%ERROR_BAD_CLUSTERS               = 6849&

'//
'// MessageId: ERROR_COMPRESSION_NOT_ALLOWED_IN_TRANSACTION
'//
'// MessageText:
'//
'// The compression operation could not be completed because a transaction is active on the file.
'//
%ERROR_COMPRESSION_NOT_ALLOWED_IN_TRANSACTION = 6850&

'//
'// MessageId: ERROR_VOLUME_DIRTY
'//
'// MessageText:
'//
'// The operation could not be completed because the volume is dirty.  Please run chkdsk and try again.
'//
%ERROR_VOLUME_DIRTY               = 6851&

'//
'// MessageId: ERROR_NO_LINK_TRACKING_IN_TRANSACTION
'//
'// MessageText:
'//
'// The link tracking operation could not be completed because a transaction is active.
'//
%ERROR_NO_LINK_TRACKING_IN_TRANSACTION = 6852&

'//
'// MessageId: ERROR_OPERATION_NOT_SUPPORTED_IN_TRANSACTION
'//
'// MessageText:
'//
'// This operation cannot be performed in a transaction.
'//
%ERROR_OPERATION_NOT_SUPPORTED_IN_TRANSACTION = 6853&


'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 6900 to 6999                //
'///////////////////////////////////////////////////

'///////////////////////////////////////////////////
'//                                               //
'//          Terminal Server Error codes          //
'//                                               //
'//                 = 7000 to 7099                //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_CTX_WINSTATION_NAME_INVALID
'//
'// MessageText:
'//
'// The specified session name is invalid.
'//
%ERROR_CTX_WINSTATION_NAME_INVALID = 7001&

'//
'// MessageId: ERROR_CTX_INVALID_PD
'//
'// MessageText:
'//
'// The specified protocol driver is invalid.
'//
%ERROR_CTX_INVALID_PD             = 7002&

'//
'// MessageId: ERROR_CTX_PD_NOT_FOUND
'//
'// MessageText:
'//
'// The specified protocol driver was not found in the system path.
'//
%ERROR_CTX_PD_NOT_FOUND           = 7003&

'//
'// MessageId: ERROR_CTX_WD_NOT_FOUND
'//
'// MessageText:
'//
'// The specified terminal connection driver was not found in the system path.
'//
%ERROR_CTX_WD_NOT_FOUND           = 7004&

'//
'// MessageId: ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY
'//
'// MessageText:
'//
'// A registry key for event logging could not be created for this session.
'//
%ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY = 7005&

'//
'// MessageId: ERROR_CTX_SERVICE_NAME_COLLISION
'//
'// MessageText:
'//
'// A service with the same name already exists on the system.
'//
%ERROR_CTX_SERVICE_NAME_COLLISION = 7006&

'//
'// MessageId: ERROR_CTX_CLOSE_PENDING
'//
'// MessageText:
'//
'// A close operation is pending on the session.
'//
%ERROR_CTX_CLOSE_PENDING          = 7007&

'//
'// MessageId: ERROR_CTX_NO_OUTBUF
'//
'// MessageText:
'//
'// There are no free output buffers available.
'//
%ERROR_CTX_NO_OUTBUF              = 7008&

'//
'// MessageId: ERROR_CTX_MODEM_INF_NOT_FOUND
'//
'// MessageText:
'//
'// The MODEM.INF file was not found.
'//
%ERROR_CTX_MODEM_INF_NOT_FOUND    = 7009&

'//
'// MessageId: ERROR_CTX_INVALID_MODEMNAME
'//
'// MessageText:
'//
'// The modem name was not found in MODEM.INF.
'//
%ERROR_CTX_INVALID_MODEMNAME      = 7010&

'//
'// MessageId: ERROR_CTX_MODEM_RESPONSE_ERROR
'//
'// MessageText:
'//
'// The modem did not accept the command sent to it. Verify that the configured modem name matches the attached modem.
'//
%ERROR_CTX_MODEM_RESPONSE_ERROR   = 7011&

'//
'// MessageId: ERROR_CTX_MODEM_RESPONSE_TIMEOUT
'//
'// MessageText:
'//
'// The modem did not respond to the command sent to it. Verify that the modem is properly cabled and powered on.
'//
%ERROR_CTX_MODEM_RESPONSE_TIMEOUT = 7012&

'//
'// MessageId: ERROR_CTX_MODEM_RESPONSE_NO_CARRIER
'//
'// MessageText:
'//
'// Carrier detect has failed or carrier has been dropped due to disconnect.
'//
%ERROR_CTX_MODEM_RESPONSE_NO_CARRIER = 7013&

'//
'// MessageId: ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE
'//
'// MessageText:
'//
'// Dial tone not detected within the required time. Verify that the phone cable is properly attached and functional.
'//
%ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE = 7014&

'//
'// MessageId: ERROR_CTX_MODEM_RESPONSE_BUSY
'//
'// MessageText:
'//
'// Busy signal detected at remote site on callback.
'//
%ERROR_CTX_MODEM_RESPONSE_BUSY    = 7015&

'//
'// MessageId: ERROR_CTX_MODEM_RESPONSE_VOICE
'//
'// MessageText:
'//
'// Voice detected at remote site on callback.
'//
%ERROR_CTX_MODEM_RESPONSE_VOICE   = 7016&

'//
'// MessageId: ERROR_CTX_TD_ERROR
'//
'// MessageText:
'//
'// Transport driver error
'//
%ERROR_CTX_TD_ERROR               = 7017&

'//
'// MessageId: ERROR_CTX_WINSTATION_NOT_FOUND
'//
'// MessageText:
'//
'// The specified session cannot be found.
'//
%ERROR_CTX_WINSTATION_NOT_FOUND   = 7022&

'//
'// MessageId: ERROR_CTX_WINSTATION_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The specified session name is already in use.
'//
%ERROR_CTX_WINSTATION_ALREADY_EXISTS = 7023&

'//
'// MessageId: ERROR_CTX_WINSTATION_BUSY
'//
'// MessageText:
'//
'// The requested operation cannot be completed because the terminal connection is currently busy processing a connect, disconnect, reset, or delete operation.
'//
%ERROR_CTX_WINSTATION_BUSY        = 7024&

'//
'// MessageId: ERROR_CTX_BAD_VIDEO_MODE
'//
'// MessageText:
'//
'// An attempt has been made to connect to a session whose video mode is not supported by the current client.
'//
%ERROR_CTX_BAD_VIDEO_MODE         = 7025&

'//
'// MessageId: ERROR_CTX_GRAPHICS_INVALID
'//
'// MessageText:
'//
'// The application attempted to enable DOS graphics mode.
'// DOS graphics mode is not supported.
'//
%ERROR_CTX_GRAPHICS_INVALID       = 7035&

'//
'// MessageId: ERROR_CTX_LOGON_DISABLED
'//
'// MessageText:
'//
'// Your interactive logon privilege has been disabled.
'// Please contact your administrator.
'//
%ERROR_CTX_LOGON_DISABLED         = 7037&

'//
'// MessageId: ERROR_CTX_NOT_CONSOLE
'//
'// MessageText:
'//
'// The requested operation can be performed only on the system console.
'// This is most often the result of a driver or system DLL requiring direct console access.
'//
%ERROR_CTX_NOT_CONSOLE            = 7038&

'//
'// MessageId: ERROR_CTX_CLIENT_QUERY_TIMEOUT
'//
'// MessageText:
'//
'// The client failed to respond to the server connect message.
'//
%ERROR_CTX_CLIENT_QUERY_TIMEOUT   = 7040&

'//
'// MessageId: ERROR_CTX_CONSOLE_DISCONNECT
'//
'// MessageText:
'//
'// Disconnecting the console session is not supported.
'//
%ERROR_CTX_CONSOLE_DISCONNECT     = 7041&

'//
'// MessageId: ERROR_CTX_CONSOLE_CONNECT
'//
'// MessageText:
'//
'// Reconnecting a disconnected session to the console is not supported.
'//
%ERROR_CTX_CONSOLE_CONNECT        = 7042&

'//
'// MessageId: ERROR_CTX_SHADOW_DENIED
'//
'// MessageText:
'//
'// The request to control another session remotely was denied.
'//
%ERROR_CTX_SHADOW_DENIED          = 7044&

'//
'// MessageId: ERROR_CTX_WINSTATION_ACCESS_DENIED
'//
'// MessageText:
'//
'// The requested session access is denied.
'//
%ERROR_CTX_WINSTATION_ACCESS_DENIED = 7045&

'//
'// MessageId: ERROR_CTX_INVALID_WD
'//
'// MessageText:
'//
'// The specified terminal connection driver is invalid.
'//
%ERROR_CTX_INVALID_WD             = 7049&

'//
'// MessageId: ERROR_CTX_SHADOW_INVALID
'//
'// MessageText:
'//
'// The requested session cannot be controlled remotely.
'// This may be because the session is disconnected or does not currently have a user logged on.
'//
%ERROR_CTX_SHADOW_INVALID         = 7050&

'//
'// MessageId: ERROR_CTX_SHADOW_DISABLED
'//
'// MessageText:
'//
'// The requested session is not configured to allow remote control.
'//
%ERROR_CTX_SHADOW_DISABLED        = 7051&

'//
'// MessageId: ERROR_CTX_CLIENT_LICENSE_IN_USE
'//
'// MessageText:
'//
'// Your request to connect to this Terminal Server has been rejected. Your Terminal Server client license number is currently being used by another user.
'// Please call your system administrator to obtain a unique license number.
'//
%ERROR_CTX_CLIENT_LICENSE_IN_USE = 7052&

'//
'// MessageId: ERROR_CTX_CLIENT_LICENSE_NOT_SET
'//
'// MessageText:
'//
'// Your request to connect to this Terminal Server has been rejected. Your Terminal Server client license number has not been entered for this copy of the Terminal Server client.
'// Please contact your system administrator.
'//
%ERROR_CTX_CLIENT_LICENSE_NOT_SET = 7053&

'//
'// MessageId: ERROR_CTX_LICENSE_NOT_AVAILABLE
'//
'// MessageText:
'//
'// The number of connections to this computer is limited and all connections are in use right now.
'// Try connecting later or contact your system administrator.
'//
%ERROR_CTX_LICENSE_NOT_AVAILABLE = 7054&

'//
'// MessageId: ERROR_CTX_LICENSE_CLIENT_INVALID
'//
'// MessageText:
'//
'// The client you are using is not licensed to use this system. Your logon request is denied.
'//
%ERROR_CTX_LICENSE_CLIENT_INVALID = 7055&

'//
'// MessageId: ERROR_CTX_LICENSE_EXPIRED
'//
'// MessageText:
'//
'// The system license has expired. Your logon request is denied.
'//
%ERROR_CTX_LICENSE_EXPIRED        = 7056&

'//
'// MessageId: ERROR_CTX_SHADOW_NOT_RUNNING
'//
'// MessageText:
'//
'// Remote control could not be terminated because the specified session is not currently being remotely controlled.
'//
%ERROR_CTX_SHADOW_NOT_RUNNING     = 7057&

'//
'// MessageId: ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE
'//
'// MessageText:
'//
'// The remote control of the console was terminated because the display mode was changed. Changing the display mode in a remote control session is not supported.
'//
%ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE = 7058&

'//
'// MessageId: ERROR_ACTIVATION_COUNT_EXCEEDED
'//
'// MessageText:
'//
'// Activation has already been reset the maximum number of times for this installation. Your activation timer will not be cleared.
'//
%ERROR_ACTIVATION_COUNT_EXCEEDED = 7059&

'//
'// MessageId: ERROR_CTX_WINSTATIONS_DISABLED
'//
'// MessageText:
'//
'// Remote logins are currently disabled.
'//
%ERROR_CTX_WINSTATIONS_DISABLED   = 7060&

'//
'// MessageId: ERROR_CTX_ENCRYPTION_LEVEL_REQUIRED
'//
'// MessageText:
'//
'// You do not have the proper encryption level to access this Session.
'//
%ERROR_CTX_ENCRYPTION_LEVEL_REQUIRED = 7061&

'//
'// MessageId: ERROR_CTX_SESSION_IN_USE
'//
'// MessageText:
'//
'// The user %s\\%s is currently logged on to this computer. Only the current user or an administrator can log on to this computer.
'//
%ERROR_CTX_SESSION_IN_USE         = 7062&

'//
'// MessageId: ERROR_CTX_NO_FORCE_LOGOFF
'//
'// MessageText:
'//
'// The user %s\\%s is already logged on to the console of this computer. You do not have permission to log in at this time. To resolve this issue, contact %s\\%s and have them log off.
'//
%ERROR_CTX_NO_FORCE_LOGOFF        = 7063&

'//
'// MessageId: ERROR_CTX_ACCOUNT_RESTRICTION
'//
'// MessageText:
'//
'// Unable to log you on because of an account restriction.
'//
%ERROR_CTX_ACCOUNT_RESTRICTION    = 7064&

'//
'// MessageId: ERROR_RDP_PROTOCOL_ERROR
'//
'// MessageText:
'//
'// The RDP protocol component %2 detected an error in the protocol stream and has disconnected the client.
'//
%ERROR_RDP_PROTOCOL_ERROR         = 7065&

'//
'// MessageId: ERROR_CTX_CDM_CONNECT
'//
'// MessageText:
'//
'// The Client Drive Mapping Service Has Connected on Terminal Connection.
'//
%ERROR_CTX_CDM_CONNECT            = 7066&

'//
'// MessageId: ERROR_CTX_CDM_DISCONNECT
'//
'// MessageText:
'//
'// The Client Drive Mapping Service Has Disconnected on Terminal Connection.
'//
%ERROR_CTX_CDM_DISCONNECT         = 7067&

'//
'// MessageId: ERROR_CTX_SECURITY_LAYER_ERROR
'//
'// MessageText:
'//
'// The Terminal Server security layer detected an error in the protocol stream and has disconnected the client.
'//
%ERROR_CTX_SECURITY_LAYER_ERROR   = 7068&

'//
'// MessageId: ERROR_TS_INCOMPATIBLE_SESSIONS
'//
'// MessageText:
'//
'// The target session is incompatible with the current session.
'//
%ERROR_TS_INCOMPATIBLE_SESSIONS   = 7069&

'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                 = 7100 to 7499                //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//           Traffic Control Error Codes         //
'//                                               //
'//                  = 7500 to 7999               //
'//                                               //
'//            defined in: tcerror.h              //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//           Active Directory Error codes        //
'//                                               //
'//                 = 8000 to 8999                //
'///////////////////////////////////////////////////

'// *****************
'// FACILITY_FILE_REPLICATION_SERVICE
'// *****************
'//
'// MessageId: FRS_ERR_INVALID_API_SEQUENCE
'//
'// MessageText:
'//
'// The file replication service API was called incorrectly.
'//
%FRS_ERR_INVALID_API_SEQUENCE     = 8001&

'//
'// MessageId: FRS_ERR_STARTING_SERVICE
'//
'// MessageText:
'//
'// The file replication service cannot be started.
'//
%FRS_ERR_STARTING_SERVICE         = 8002&

'//
'// MessageId: FRS_ERR_STOPPING_SERVICE
'//
'// MessageText:
'//
'// The file replication service cannot be stopped.
'//
%FRS_ERR_STOPPING_SERVICE         = 8003&

'//
'// MessageId: FRS_ERR_INTERNAL_API
'//
'// MessageText:
'//
'// The file replication service API terminated the request.
'// The event log may have more information.
'//
%FRS_ERR_INTERNAL_API             = 8004&

'//
'// MessageId: FRS_ERR_INTERNAL
'//
'// MessageText:
'//
'// The file replication service terminated the request.
'// The event log may have more information.
'//
%FRS_ERR_INTERNAL                 = 8005&

'//
'// MessageId: FRS_ERR_SERVICE_COMM
'//
'// MessageText:
'//
'// The file replication service cannot be contacted.
'// The event log may have more information.
'//
%FRS_ERR_SERVICE_COMM             = 8006&

'//
'// MessageId: FRS_ERR_INSUFFICIENT_PRIV
'//
'// MessageText:
'//
'// The file replication service cannot satisfy the request because the user has insufficient privileges.
'// The event log may have more information.
'//
%FRS_ERR_INSUFFICIENT_PRIV        = 8007&

'//
'// MessageId: FRS_ERR_AUTHENTICATION
'//
'// MessageText:
'//
'// The file replication service cannot satisfy the request because authenticated RPC is not available.
'// The event log may have more information.
'//
%FRS_ERR_AUTHENTICATION           = 8008&

'//
'// MessageId: FRS_ERR_PARENT_INSUFFICIENT_PRIV
'//
'// MessageText:
'//
'// The file replication service cannot satisfy the request because the user has insufficient privileges on the domain controller.
'// The event log may have more information.
'//
%FRS_ERR_PARENT_INSUFFICIENT_PRIV = 8009&

'//
'// MessageId: FRS_ERR_PARENT_AUTHENTICATION
'//
'// MessageText:
'//
'// The file replication service cannot satisfy the request because authenticated RPC is not available on the domain controller.
'// The event log may have more information.
'//
%FRS_ERR_PARENT_AUTHENTICATION    = 8010&

'//
'// MessageId: FRS_ERR_CHILD_TO_PARENT_COMM
'//
'// MessageText:
'//
'// The file replication service cannot communicate with the file replication service on the domain controller.
'// The event log may have more information.
'//
%FRS_ERR_CHILD_TO_PARENT_COMM     = 8011&

'//
'// MessageId: FRS_ERR_PARENT_TO_CHILD_COMM
'//
'// MessageText:
'//
'// The file replication service on the domain controller cannot communicate with the file replication service on this computer.
'// The event log may have more information.
'//
%FRS_ERR_PARENT_TO_CHILD_COMM     = 8012&

'//
'// MessageId: FRS_ERR_SYSVOL_POPULATE
'//
'// MessageText:
'//
'// The file replication service cannot populate the system volume because of an internal error.
'// The event log may have more information.
'//
%FRS_ERR_SYSVOL_POPULATE          = 8013&

'//
'// MessageId: FRS_ERR_SYSVOL_POPULATE_TIMEOUT
'//
'// MessageText:
'//
'// The file replication service cannot populate the system volume because of an internal timeout.
'// The event log may have more information.
'//
%FRS_ERR_SYSVOL_POPULATE_TIMEOUT = 8014&

'//
'// MessageId: FRS_ERR_SYSVOL_IS_BUSY
'//
'// MessageText:
'//
'// The file replication service cannot process the request. The system volume is busy with a previous request.
'//
%FRS_ERR_SYSVOL_IS_BUSY           = 8015&

'//
'// MessageId: FRS_ERR_SYSVOL_DEMOTE
'//
'// MessageText:
'//
'// The file replication service cannot stop replicating the system volume because of an internal error.
'// The event log may have more information.
'//
%FRS_ERR_SYSVOL_DEMOTE            = 8016&

'//
'// MessageId: FRS_ERR_INVALID_SERVICE_PARAMETER
'//
'// MessageText:
'//
'// The file replication service detected an invalid parameter.
'//
%FRS_ERR_INVALID_SERVICE_PARAMETER = 8017&

'// *****************
'// FACILITY DIRECTORY SERVICE
'// *****************
%DS_S_SUCCESS = %NO_ERROR
'//
'// MessageId: ERROR_DS_NOT_INSTALLED
'//
'// MessageText:
'//
'// An error occurred while installing the directory service. For more information, see the event log.
'//
%ERROR_DS_NOT_INSTALLED           = 8200&

'//
'// MessageId: ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY
'//
'// MessageText:
'//
'// The directory service evaluated group memberships locally.
'//
%ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY = 8201&

'//
'// MessageId: ERROR_DS_NO_ATTRIBUTE_OR_VALUE
'//
'// MessageText:
'//
'// The specified directory service attribute or value does not exist.
'//
%ERROR_DS_NO_ATTRIBUTE_OR_VALUE   = 8202&

'//
'// MessageId: ERROR_DS_INVALID_ATTRIBUTE_SYNTAX
'//
'// MessageText:
'//
'// The attribute syntax specified to the directory service is invalid.
'//
%ERROR_DS_INVALID_ATTRIBUTE_SYNTAX = 8203&

'//
'// MessageId: ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED
'//
'// MessageText:
'//
'// The attribute type specified to the directory service is not defined.
'//
%ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED = 8204&

'//
'// MessageId: ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS
'//
'// MessageText:
'//
'// The specified directory service attribute or value already exists.
'//
%ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS = 8205&

'//
'// MessageId: ERROR_DS_BUSY
'//
'// MessageText:
'//
'// The directory service is busy.
'//
%ERROR_DS_BUSY                    = 8206&

'//
'// MessageId: ERROR_DS_UNAVAILABLE
'//
'// MessageText:
'//
'// The directory service is unavailable.
'//
%ERROR_DS_UNAVAILABLE             = 8207&

'//
'// MessageId: ERROR_DS_NO_RIDS_ALLOCATED
'//
'// MessageText:
'//
'// The directory service was unable to allocate a relative identifier.
'//
%ERROR_DS_NO_RIDS_ALLOCATED       = 8208&

'//
'// MessageId: ERROR_DS_NO_MORE_RIDS
'//
'// MessageText:
'//
'// The directory service has exhausted the pool of relative identifiers.
'//
%ERROR_DS_NO_MORE_RIDS            = 8209&

'//
'// MessageId: ERROR_DS_INCORRECT_ROLE_OWNER
'//
'// MessageText:
'//
'// The requested operation could not be performed because the directory service is not the master for that type of operation.
'//
%ERROR_DS_INCORRECT_ROLE_OWNER    = 8210&

'//
'// MessageId: ERROR_DS_RIDMGR_INIT_ERROR
'//
'// MessageText:
'//
'// The directory service was unable to initialize the subsystem that allocates relative identifiers.
'//
%ERROR_DS_RIDMGR_INIT_ERROR       = 8211&

'//
'// MessageId: ERROR_DS_OBJ_CLASS_VIOLATION
'//
'// MessageText:
'//
'// The requested operation did not satisfy one or more constraints associated with the class of the object.
'//
%ERROR_DS_OBJ_CLASS_VIOLATION     = 8212&

'//
'// MessageId: ERROR_DS_CANT_ON_NON_LEAF
'//
'// MessageText:
'//
'// The directory service can perform the requested operation only on a leaf object.
'//
%ERROR_DS_CANT_ON_NON_LEAF        = 8213&

'//
'// MessageId: ERROR_DS_CANT_ON_RDN
'//
'// MessageText:
'//
'// The directory service cannot perform the requested operation on the RDN attribute of an object.
'//
%ERROR_DS_CANT_ON_RDN             = 8214&

'//
'// MessageId: ERROR_DS_CANT_MOD_OBJ_CLASS
'//
'// MessageText:
'//
'// The directory service detected an attempt to modify the object class of an object.
'//
%ERROR_DS_CANT_MOD_OBJ_CLASS      = 8215&

'//
'// MessageId: ERROR_DS_CROSS_DOM_MOVE_ERROR
'//
'// MessageText:
'//
'// The requested cross-domain move operation could not be performed.
'//
%ERROR_DS_CROSS_DOM_MOVE_ERROR    = 8216&

'//
'// MessageId: ERROR_DS_GC_NOT_AVAILABLE
'//
'// MessageText:
'//
'// Unable to contact the global catalog server.
'//
%ERROR_DS_GC_NOT_AVAILABLE        = 8217&

'//
'// MessageId: ERROR_SHARED_POLICY
'//
'// MessageText:
'//
'// The policy object is shared and can only be modified at the root.
'//
%ERROR_SHARED_POLICY              = 8218&

'//
'// MessageId: ERROR_POLICY_OBJECT_NOT_FOUND
'//
'// MessageText:
'//
'// The policy object does not exist.
'//
%ERROR_POLICY_OBJECT_NOT_FOUND    = 8219&

'//
'// MessageId: ERROR_POLICY_ONLY_IN_DS
'//
'// MessageText:
'//
'// The requested policy information is only in the directory service.
'//
%ERROR_POLICY_ONLY_IN_DS          = 8220&

'//
'// MessageId: ERROR_PROMOTION_ACTIVE
'//
'// MessageText:
'//
'// A domain controller promotion is currently active.
'//
%ERROR_PROMOTION_ACTIVE           = 8221&

'//
'// MessageId: ERROR_NO_PROMOTION_ACTIVE
'//
'// MessageText:
'//
'// A domain controller promotion is not currently active
'//
%ERROR_NO_PROMOTION_ACTIVE        = 8222&

'// 8223 unused
'//
'// MessageId: ERROR_DS_OPERATIONS_ERROR
'//
'// MessageText:
'//
'// An operations error occurred.
'//
%ERROR_DS_OPERATIONS_ERROR        = 8224&

'//
'// MessageId: ERROR_DS_PROTOCOL_ERROR
'//
'// MessageText:
'//
'// A protocol error occurred.
'//
%ERROR_DS_PROTOCOL_ERROR          = 8225&

'//
'// MessageId: ERROR_DS_TIMELIMIT_EXCEEDED
'//
'// MessageText:
'//
'// The time limit for this request was exceeded.
'//
%ERROR_DS_TIMELIMIT_EXCEEDED      = 8226&

'//
'// MessageId: ERROR_DS_SIZELIMIT_EXCEEDED
'//
'// MessageText:
'//
'// The size limit for this request was exceeded.
'//
%ERROR_DS_SIZELIMIT_EXCEEDED      = 8227&

'//
'// MessageId: ERROR_DS_ADMIN_LIMIT_EXCEEDED
'//
'// MessageText:
'//
'// The administrative limit for this request was exceeded.
'//
%ERROR_DS_ADMIN_LIMIT_EXCEEDED    = 8228&

'//
'// MessageId: ERROR_DS_COMPARE_FALSE
'//
'// MessageText:
'//
'// The compare response was false.
'//
%ERROR_DS_COMPARE_FALSE           = 8229&

'//
'// MessageId: ERROR_DS_COMPARE_TRUE
'//
'// MessageText:
'//
'// The compare response was true.
'//
%ERROR_DS_COMPARE_TRUE            = 8230&

'//
'// MessageId: ERROR_DS_AUTH_METHOD_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The requested authentication method is not supported by the server.
'//
%ERROR_DS_AUTH_METHOD_NOT_SUPPORTED = 8231&

'//
'// MessageId: ERROR_DS_STRONG_AUTH_REQUIRED
'//
'// MessageText:
'//
'// A more secure authentication method is required for this server.
'//
%ERROR_DS_STRONG_AUTH_REQUIRED    = 8232&

'//
'// MessageId: ERROR_DS_INAPPROPRIATE_AUTH
'//
'// MessageText:
'//
'// Inappropriate authentication.
'//
%ERROR_DS_INAPPROPRIATE_AUTH      = 8233&

'//
'// MessageId: ERROR_DS_AUTH_UNKNOWN
'//
'// MessageText:
'//
'// The authentication mechanism is unknown.
'//
%ERROR_DS_AUTH_UNKNOWN            = 8234&

'//
'// MessageId: ERROR_DS_REFERRAL
'//
'// MessageText:
'//
'// A referral was returned from the server.
'//
%ERROR_DS_REFERRAL                = 8235&

'//
'// MessageId: ERROR_DS_UNAVAILABLE_CRIT_EXTENSION
'//
'// MessageText:
'//
'// The server does not support the requested critical extension.
'//
%ERROR_DS_UNAVAILABLE_CRIT_EXTENSION = 8236&

'//
'// MessageId: ERROR_DS_CONFIDENTIALITY_REQUIRED
'//
'// MessageText:
'//
'// This request requires a secure connection.
'//
%ERROR_DS_CONFIDENTIALITY_REQUIRED = 8237&

'//
'// MessageId: ERROR_DS_INAPPROPRIATE_MATCHING
'//
'// MessageText:
'//
'// Inappropriate matching.
'//
%ERROR_DS_INAPPROPRIATE_MATCHING = 8238&

'//
'// MessageId: ERROR_DS_CONSTRAINT_VIOLATION
'//
'// MessageText:
'//
'// A constraint violation occurred.
'//
%ERROR_DS_CONSTRAINT_VIOLATION    = 8239&

'//
'// MessageId: ERROR_DS_NO_SUCH_OBJECT
'//
'// MessageText:
'//
'// There is no such object on the server.
'//
%ERROR_DS_NO_SUCH_OBJECT          = 8240&

'//
'// MessageId: ERROR_DS_ALIAS_PROBLEM
'//
'// MessageText:
'//
'// There is an alias problem.
'//
%ERROR_DS_ALIAS_PROBLEM           = 8241&

'//
'// MessageId: ERROR_DS_INVALID_DN_SYNTAX
'//
'// MessageText:
'//
'// An invalid dn syntax has been specified.
'//
%ERROR_DS_INVALID_DN_SYNTAX       = 8242&

'//
'// MessageId: ERROR_DS_IS_LEAF
'//
'// MessageText:
'//
'// The object is a leaf object.
'//
%ERROR_DS_IS_LEAF                 = 8243&

'//
'// MessageId: ERROR_DS_ALIAS_DEREF_PROBLEM
'//
'// MessageText:
'//
'// There is an alias dereferencing problem.
'//
%ERROR_DS_ALIAS_DEREF_PROBLEM     = 8244&

'//
'// MessageId: ERROR_DS_UNWILLING_TO_PERFORM
'//
'// MessageText:
'//
'// The server is unwilling to process the request.
'//
%ERROR_DS_UNWILLING_TO_PERFORM    = 8245&

'//
'// MessageId: ERROR_DS_LOOP_DETECT
'//
'// MessageText:
'//
'// A loop has been detected.
'//
%ERROR_DS_LOOP_DETECT             = 8246&

'//
'// MessageId: ERROR_DS_NAMING_VIOLATION
'//
'// MessageText:
'//
'// There is a naming violation.
'//
%ERROR_DS_NAMING_VIOLATION        = 8247&

'//
'// MessageId: ERROR_DS_OBJECT_RESULTS_TOO_LARGE
'//
'// MessageText:
'//
'// The result set is too large.
'//
%ERROR_DS_OBJECT_RESULTS_TOO_LARGE = 8248&

'//
'// MessageId: ERROR_DS_AFFECTS_MULTIPLE_DSAS
'//
'// MessageText:
'//
'// The operation affects multiple DSAs
'//
%ERROR_DS_AFFECTS_MULTIPLE_DSAS   = 8249&

'//
'// MessageId: ERROR_DS_SERVER_DOWN
'//
'// MessageText:
'//
'// The server is not operational.
'//
%ERROR_DS_SERVER_DOWN             = 8250&

'//
'// MessageId: ERROR_DS_LOCAL_ERROR
'//
'// MessageText:
'//
'// A local error has occurred.
'//
%ERROR_DS_LOCAL_ERROR             = 8251&

'//
'// MessageId: ERROR_DS_ENCODING_ERROR
'//
'// MessageText:
'//
'// An encoding error has occurred.
'//
%ERROR_DS_ENCODING_ERROR          = 8252&

'//
'// MessageId: ERROR_DS_DECODING_ERROR
'//
'// MessageText:
'//
'// A decoding error has occurred.
'//
%ERROR_DS_DECODING_ERROR          = 8253&

'//
'// MessageId: ERROR_DS_FILTER_UNKNOWN
'//
'// MessageText:
'//
'// The search filter cannot be recognized.
'//
%ERROR_DS_FILTER_UNKNOWN          = 8254&

'//
'// MessageId: ERROR_DS_PARAM_ERROR
'//
'// MessageText:
'//
'// One or more parameters are illegal.
'//
%ERROR_DS_PARAM_ERROR             = 8255&

'//
'// MessageId: ERROR_DS_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The specified method is not supported.
'//
%ERROR_DS_NOT_SUPPORTED           = 8256&

'//
'// MessageId: ERROR_DS_NO_RESULTS_RETURNED
'//
'// MessageText:
'//
'// No results were returned.
'//
%ERROR_DS_NO_RESULTS_RETURNED     = 8257&

'//
'// MessageId: ERROR_DS_CONTROL_NOT_FOUND
'//
'// MessageText:
'//
'// The specified control is not supported by the server.
'//
%ERROR_DS_CONTROL_NOT_FOUND       = 8258&

'//
'// MessageId: ERROR_DS_CLIENT_LOOP
'//
'// MessageText:
'//
'// A referral loop was detected by the client.
'//
%ERROR_DS_CLIENT_LOOP             = 8259&

'//
'// MessageId: ERROR_DS_REFERRAL_LIMIT_EXCEEDED
'//
'// MessageText:
'//
'// The preset referral limit was exceeded.
'//
%ERROR_DS_REFERRAL_LIMIT_EXCEEDED = 8260&

'//
'// MessageId: ERROR_DS_SORT_CONTROL_MISSING
'//
'// MessageText:
'//
'// The search requires a SORT control.
'//
%ERROR_DS_SORT_CONTROL_MISSING    = 8261&

'//
'// MessageId: ERROR_DS_OFFSET_RANGE_ERROR
'//
'// MessageText:
'//
'// The search results exceed the offset range specified.
'//
%ERROR_DS_OFFSET_RANGE_ERROR      = 8262&

'//
'// MessageId: ERROR_DS_ROOT_MUST_BE_NC
'//
'// MessageText:
'//
'// The root object must be the head of a naming context. The root object cannot have an instantiated parent.
'//
%ERROR_DS_ROOT_MUST_BE_NC         = 8301&

'//
'// MessageId: ERROR_DS_ADD_REPLICA_INHIBITED
'//
'// MessageText:
'//
'// The add replica operation cannot be performed. The naming context must be writeable in order to create the replica.
'//
%ERROR_DS_ADD_REPLICA_INHIBITED   = 8302&

'//
'// MessageId: ERROR_DS_ATT_NOT_DEF_IN_SCHEMA
'//
'// MessageText:
'//
'// A reference to an attribute that is not defined in the schema occurred.
'//
%ERROR_DS_ATT_NOT_DEF_IN_SCHEMA   = 8303&

'//
'// MessageId: ERROR_DS_MAX_OBJ_SIZE_EXCEEDED
'//
'// MessageText:
'//
'// The maximum size of an object has been exceeded.
'//
%ERROR_DS_MAX_OBJ_SIZE_EXCEEDED   = 8304&

'//
'// MessageId: ERROR_DS_OBJ_STRING_NAME_EXISTS
'//
'// MessageText:
'//
'// An attempt was made to add an object to the directory with a name that is already in use.
'//
%ERROR_DS_OBJ_STRING_NAME_EXISTS = 8305&

'//
'// MessageId: ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA
'//
'// MessageText:
'//
'// An attempt was made to add an object of a class that does not have an RDN defined in the schema.
'//
%ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA = 8306&

'//
'// MessageId: ERROR_DS_RDN_DOESNT_MATCH_SCHEMA
'//
'// MessageText:
'//
'// An attempt was made to add an object using an RDN that is not the RDN defined in the schema.
'//
%ERROR_DS_RDN_DOESNT_MATCH_SCHEMA = 8307&

'//
'// MessageId: ERROR_DS_NO_REQUESTED_ATTS_FOUND
'//
'// MessageText:
'//
'// None of the requested attributes were found on the objects.
'//
%ERROR_DS_NO_REQUESTED_ATTS_FOUND = 8308&

'//
'// MessageId: ERROR_DS_USER_BUFFER_TO_SMALL
'//
'// MessageText:
'//
'// The user buffer is too small.
'//
%ERROR_DS_USER_BUFFER_TO_SMALL    = 8309&

'//
'// MessageId: ERROR_DS_ATT_IS_NOT_ON_OBJ
'//
'// MessageText:
'//
'// The attribute specified in the operation is not present on the object.
'//
%ERROR_DS_ATT_IS_NOT_ON_OBJ       = 8310&

'//
'// MessageId: ERROR_DS_ILLEGAL_MOD_OPERATION
'//
'// MessageText:
'//
'// Illegal modify operation. Some aspect of the modification is not permitted.
'//
%ERROR_DS_ILLEGAL_MOD_OPERATION   = 8311&

'//
'// MessageId: ERROR_DS_OBJ_TOO_LARGE
'//
'// MessageText:
'//
'// The specified object is too large.
'//
%ERROR_DS_OBJ_TOO_LARGE           = 8312&

'//
'// MessageId: ERROR_DS_BAD_INSTANCE_TYPE
'//
'// MessageText:
'//
'// The specified instance type is not valid.
'//
%ERROR_DS_BAD_INSTANCE_TYPE       = 8313&

'//
'// MessageId: ERROR_DS_MASTERDSA_REQUIRED
'//
'// MessageText:
'//
'// The operation must be performed at a master DSA.
'//
%ERROR_DS_MASTERDSA_REQUIRED      = 8314&

'//
'// MessageId: ERROR_DS_OBJECT_CLASS_REQUIRED
'//
'// MessageText:
'//
'// The object class attribute must be specified.
'//
%ERROR_DS_OBJECT_CLASS_REQUIRED   = 8315&

'//
'// MessageId: ERROR_DS_MISSING_REQUIRED_ATT
'//
'// MessageText:
'//
'// A required attribute is missing.
'//
%ERROR_DS_MISSING_REQUIRED_ATT    = 8316&

'//
'// MessageId: ERROR_DS_ATT_NOT_DEF_FOR_CLASS
'//
'// MessageText:
'//
'// An attempt was made to modify an object to include an attribute that is not legal for its class.
'//
%ERROR_DS_ATT_NOT_DEF_FOR_CLASS   = 8317&

'//
'// MessageId: ERROR_DS_ATT_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The specified attribute is already present on the object.
'//
%ERROR_DS_ATT_ALREADY_EXISTS      = 8318&

'// 8319 unused
'//
'// MessageId: ERROR_DS_CANT_ADD_ATT_VALUES
'//
'// MessageText:
'//
'// The specified attribute is not present, or has no values.
'//
%ERROR_DS_CANT_ADD_ATT_VALUES     = 8320&

'//
'// MessageId: ERROR_DS_SINGLE_VALUE_CONSTRAINT
'//
'// MessageText:
'//
'// Multiple values were specified for an attribute that can have only one value.
'//
%ERROR_DS_SINGLE_VALUE_CONSTRAINT = 8321&

'//
'// MessageId: ERROR_DS_RANGE_CONSTRAINT
'//
'// MessageText:
'//
'// A value for the attribute was not in the acceptable range of values.
'//
%ERROR_DS_RANGE_CONSTRAINT        = 8322&

'//
'// MessageId: ERROR_DS_ATT_VAL_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The specified value already exists.
'//
%ERROR_DS_ATT_VAL_ALREADY_EXISTS = 8323&

'//
'// MessageId: ERROR_DS_CANT_REM_MISSING_ATT
'//
'// MessageText:
'//
'// The attribute cannot be removed because it is not present on the object.
'//
%ERROR_DS_CANT_REM_MISSING_ATT    = 8324&

'//
'// MessageId: ERROR_DS_CANT_REM_MISSING_ATT_VAL
'//
'// MessageText:
'//
'// The attribute value cannot be removed because it is not present on the object.
'//
%ERROR_DS_CANT_REM_MISSING_ATT_VAL = 8325&

'//
'// MessageId: ERROR_DS_ROOT_CANT_BE_SUBREF
'//
'// MessageText:
'//
'// The specified root object cannot be a subref.
'//
%ERROR_DS_ROOT_CANT_BE_SUBREF     = 8326&

'//
'// MessageId: ERROR_DS_NO_CHAINING
'//
'// MessageText:
'//
'// Chaining is not permitted.
'//
%ERROR_DS_NO_CHAINING             = 8327&

'//
'// MessageId: ERROR_DS_NO_CHAINED_EVAL
'//
'// MessageText:
'//
'// Chained evaluation is not permitted.
'//
%ERROR_DS_NO_CHAINED_EVAL         = 8328&

'//
'// MessageId: ERROR_DS_NO_PARENT_OBJECT
'//
'// MessageText:
'//
'// The operation could not be performed because the object's parent is either uninstantiated or deleted.
'//
%ERROR_DS_NO_PARENT_OBJECT        = 8329&

'//
'// MessageId: ERROR_DS_PARENT_IS_AN_ALIAS
'//
'// MessageText:
'//
'// Having a parent that is an alias is not permitted. Aliases are leaf objects.
'//
%ERROR_DS_PARENT_IS_AN_ALIAS      = 8330&

'//
'// MessageId: ERROR_DS_CANT_MIX_MASTER_AND_REPS
'//
'// MessageText:
'//
'// The object and parent must be of the same type, either both masters or both replicas.
'//
%ERROR_DS_CANT_MIX_MASTER_AND_REPS = 8331&

'//
'// MessageId: ERROR_DS_CHILDREN_EXIST
'//
'// MessageText:
'//
'// The operation cannot be performed because child objects exist. This operation can only be performed on a leaf object.
'//
%ERROR_DS_CHILDREN_EXIST          = 8332&

'//
'// MessageId: ERROR_DS_OBJ_NOT_FOUND
'//
'// MessageText:
'//
'// Directory object not found.
'//
%ERROR_DS_OBJ_NOT_FOUND           = 8333&

'//
'// MessageId: ERROR_DS_ALIASED_OBJ_MISSING
'//
'// MessageText:
'//
'// The aliased object is missing.
'//
%ERROR_DS_ALIASED_OBJ_MISSING     = 8334&

'//
'// MessageId: ERROR_DS_BAD_NAME_SYNTAX
'//
'// MessageText:
'//
'// The object name has bad syntax.
'//
%ERROR_DS_BAD_NAME_SYNTAX         = 8335&

'//
'// MessageId: ERROR_DS_ALIAS_POINTS_TO_ALIAS
'//
'// MessageText:
'//
'// It is not permitted for an alias to refer to another alias.
'//
%ERROR_DS_ALIAS_POINTS_TO_ALIAS   = 8336&

'//
'// MessageId: ERROR_DS_CANT_DEREF_ALIAS
'//
'// MessageText:
'//
'// The alias cannot be dereferenced.
'//
%ERROR_DS_CANT_DEREF_ALIAS        = 8337&

'//
'// MessageId: ERROR_DS_OUT_OF_SCOPE
'//
'// MessageText:
'//
'// The operation is out of scope.
'//
%ERROR_DS_OUT_OF_SCOPE            = 8338&

'//
'// MessageId: ERROR_DS_OBJECT_BEING_REMOVED
'//
'// MessageText:
'//
'// The operation cannot continue because the object is in the process of being removed.
'//
%ERROR_DS_OBJECT_BEING_REMOVED    = 8339&

'//
'// MessageId: ERROR_DS_CANT_DELETE_DSA_OBJ
'//
'// MessageText:
'//
'// The DSA object cannot be deleted.
'//
%ERROR_DS_CANT_DELETE_DSA_OBJ     = 8340&

'//
'// MessageId: ERROR_DS_GENERIC_ERROR
'//
'// MessageText:
'//
'// A directory service error has occurred.
'//
%ERROR_DS_GENERIC_ERROR           = 8341&

'//
'// MessageId: ERROR_DS_DSA_MUST_BE_INT_MASTER
'//
'// MessageText:
'//
'// The operation can only be performed on an internal master DSA object.
'//
%ERROR_DS_DSA_MUST_BE_INT_MASTER = 8342&

'//
'// MessageId: ERROR_DS_CLASS_NOT_DSA
'//
'// MessageText:
'//
'// The object must be of class DSA.
'//
%ERROR_DS_CLASS_NOT_DSA           = 8343&

'//
'// MessageId: ERROR_DS_INSUFF_ACCESS_RIGHTS
'//
'// MessageText:
'//
'// Insufficient access rights to perform the operation.
'//
%ERROR_DS_INSUFF_ACCESS_RIGHTS    = 8344&

'//
'// MessageId: ERROR_DS_ILLEGAL_SUPERIOR
'//
'// MessageText:
'//
'// The object cannot be added because the parent is not on the list of possible superiors.
'//
%ERROR_DS_ILLEGAL_SUPERIOR        = 8345&

'//
'// MessageId: ERROR_DS_ATTRIBUTE_OWNED_BY_SAM
'//
'// MessageText:
'//
'// Access to the attribute is not permitted because the attribute is owned by the Security Accounts Manager (SAM).
'//
%ERROR_DS_ATTRIBUTE_OWNED_BY_SAM = 8346&

'//
'// MessageId: ERROR_DS_NAME_TOO_MANY_PARTS
'//
'// MessageText:
'//
'// The name has too many parts.
'//
%ERROR_DS_NAME_TOO_MANY_PARTS     = 8347&

'//
'// MessageId: ERROR_DS_NAME_TOO_LONG
'//
'// MessageText:
'//
'// The name is too long.
'//
%ERROR_DS_NAME_TOO_LONG           = 8348&

'//
'// MessageId: ERROR_DS_NAME_VALUE_TOO_LONG
'//
'// MessageText:
'//
'// The name value is too long.
'//
%ERROR_DS_NAME_VALUE_TOO_LONG     = 8349&

'//
'// MessageId: ERROR_DS_NAME_UNPARSEABLE
'//
'// MessageText:
'//
'// The directory service encountered an error parsing a name.
'//
%ERROR_DS_NAME_UNPARSEABLE        = 8350&

'//
'// MessageId: ERROR_DS_NAME_TYPE_UNKNOWN
'//
'// MessageText:
'//
'// The directory service cannot get the attribute type for a name.
'//
%ERROR_DS_NAME_TYPE_UNKNOWN       = 8351&

'//
'// MessageId: ERROR_DS_NOT_AN_OBJECT
'//
'// MessageText:
'//
'// The name does not identify an object; the name identifies a phantom.
'//
%ERROR_DS_NOT_AN_OBJECT           = 8352&

'//
'// MessageId: ERROR_DS_SEC_DESC_TOO_SHORT
'//
'// MessageText:
'//
'// The security descriptor is too short.
'//
%ERROR_DS_SEC_DESC_TOO_SHORT      = 8353&

'//
'// MessageId: ERROR_DS_SEC_DESC_INVALID
'//
'// MessageText:
'//
'// The security descriptor is invalid.
'//
%ERROR_DS_SEC_DESC_INVALID        = 8354&

'//
'// MessageId: ERROR_DS_NO_DELETED_NAME
'//
'// MessageText:
'//
'// Failed to create name for deleted object.
'//
%ERROR_DS_NO_DELETED_NAME         = 8355&

'//
'// MessageId: ERROR_DS_SUBREF_MUST_HAVE_PARENT
'//
'// MessageText:
'//
'// The parent of a new subref must exist.
'//
%ERROR_DS_SUBREF_MUST_HAVE_PARENT = 8356&

'//
'// MessageId: ERROR_DS_NCNAME_MUST_BE_NC
'//
'// MessageText:
'//
'// The object must be a naming context.
'//
%ERROR_DS_NCNAME_MUST_BE_NC       = 8357&

'//
'// MessageId: ERROR_DS_CANT_ADD_SYSTEM_ONLY
'//
'// MessageText:
'//
'// It is not permitted to add an attribute which is owned by the system.
'//
%ERROR_DS_CANT_ADD_SYSTEM_ONLY    = 8358&

'//
'// MessageId: ERROR_DS_CLASS_MUST_BE_CONCRETE
'//
'// MessageText:
'//
'// The class of the object must be structural; you cannot instantiate an abstract class.
'//
%ERROR_DS_CLASS_MUST_BE_CONCRETE = 8359&

'//
'// MessageId: ERROR_DS_INVALID_DMD
'//
'// MessageText:
'//
'// The schema object could not be found.
'//
%ERROR_DS_INVALID_DMD             = 8360&

'//
'// MessageId: ERROR_DS_OBJ_GUID_EXISTS
'//
'// MessageText:
'//
'// A local object with this GUID (dead or alive) already exists.
'//
%ERROR_DS_OBJ_GUID_EXISTS         = 8361&

'//
'// MessageId: ERROR_DS_NOT_ON_BACKLINK
'//
'// MessageText:
'//
'// The operation cannot be performed on a back link.
'//
%ERROR_DS_NOT_ON_BACKLINK         = 8362&

'//
'// MessageId: ERROR_DS_NO_CROSSREF_FOR_NC
'//
'// MessageText:
'//
'// The cross reference for the specified naming context could not be found.
'//
%ERROR_DS_NO_CROSSREF_FOR_NC      = 8363&

'//
'// MessageId: ERROR_DS_SHUTTING_DOWN
'//
'// MessageText:
'//
'// The operation could not be performed because the directory service is shutting down.
'//
%ERROR_DS_SHUTTING_DOWN           = 8364&

'//
'// MessageId: ERROR_DS_UNKNOWN_OPERATION
'//
'// MessageText:
'//
'// The directory service request is invalid.
'//
%ERROR_DS_UNKNOWN_OPERATION       = 8365&

'//
'// MessageId: ERROR_DS_INVALID_ROLE_OWNER
'//
'// MessageText:
'//
'// The role owner attribute could not be read.
'//
%ERROR_DS_INVALID_ROLE_OWNER      = 8366&

'//
'// MessageId: ERROR_DS_COULDNT_CONTACT_FSMO
'//
'// MessageText:
'//
'// The requested FSMO operation failed. The current FSMO holder could not be contacted.
'//
%ERROR_DS_COULDNT_CONTACT_FSMO    = 8367&

'//
'// MessageId: ERROR_DS_CROSS_NC_DN_RENAME
'//
'// MessageText:
'//
'// Modification of a DN across a naming context is not permitted.
'//
%ERROR_DS_CROSS_NC_DN_RENAME      = 8368&

'//
'// MessageId: ERROR_DS_CANT_MOD_SYSTEM_ONLY
'//
'// MessageText:
'//
'// The attribute cannot be modified because it is owned by the system.
'//
%ERROR_DS_CANT_MOD_SYSTEM_ONLY    = 8369&

'//
'// MessageId: ERROR_DS_REPLICATOR_ONLY
'//
'// MessageText:
'//
'// Only the replicator can perform this function.
'//
%ERROR_DS_REPLICATOR_ONLY         = 8370&

'//
'// MessageId: ERROR_DS_OBJ_CLASS_NOT_DEFINED
'//
'// MessageText:
'//
'// The specified class is not defined.
'//
%ERROR_DS_OBJ_CLASS_NOT_DEFINED   = 8371&

'//
'// MessageId: ERROR_DS_OBJ_CLASS_NOT_SUBCLASS
'//
'// MessageText:
'//
'// The specified class is not a subclass.
'//
%ERROR_DS_OBJ_CLASS_NOT_SUBCLASS = 8372&

'//
'// MessageId: ERROR_DS_NAME_REFERENCE_INVALID
'//
'// MessageText:
'//
'// The name reference is invalid.
'//
%ERROR_DS_NAME_REFERENCE_INVALID = 8373&

'//
'// MessageId: ERROR_DS_CROSS_REF_EXISTS
'//
'// MessageText:
'//
'// A cross reference already exists.
'//
%ERROR_DS_CROSS_REF_EXISTS        = 8374&

'//
'// MessageId: ERROR_DS_CANT_DEL_MASTER_CROSSREF
'//
'// MessageText:
'//
'// It is not permitted to delete a master cross reference.
'//
%ERROR_DS_CANT_DEL_MASTER_CROSSREF = 8375&

'//
'// MessageId: ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD
'//
'// MessageText:
'//
'// Subtree notifications are only supported on NC heads.
'//
%ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD = 8376&

'//
'// MessageId: ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX
'//
'// MessageText:
'//
'// Notification filter is too complex.
'//
%ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX = 8377&

'//
'// MessageId: ERROR_DS_DUP_RDN
'//
'// MessageText:
'//
'// Schema update failed: duplicate RDN.
'//
%ERROR_DS_DUP_RDN                 = 8378&

'//
'// MessageId: ERROR_DS_DUP_OID
'//
'// MessageText:
'//
'// Schema update failed: duplicate OID.
'//
%ERROR_DS_DUP_OID                 = 8379&

'//
'// MessageId: ERROR_DS_DUP_MAPI_ID
'//
'// MessageText:
'//
'// Schema update failed: duplicate MAPI identifier.
'//
%ERROR_DS_DUP_MAPI_ID             = 8380&

'//
'// MessageId: ERROR_DS_DUP_SCHEMA_ID_GUID
'//
'// MessageText:
'//
'// Schema update failed: duplicate schema-id GUID.
'//
%ERROR_DS_DUP_SCHEMA_ID_GUID      = 8381&

'//
'// MessageId: ERROR_DS_DUP_LDAP_DISPLAY_NAME
'//
'// MessageText:
'//
'// Schema update failed: duplicate LDAP display name.
'//
%ERROR_DS_DUP_LDAP_DISPLAY_NAME   = 8382&

'//
'// MessageId: ERROR_DS_SEMANTIC_ATT_TEST
'//
'// MessageText:
'//
'// Schema update failed: range-lower less than range upper.
'//
%ERROR_DS_SEMANTIC_ATT_TEST       = 8383&

'//
'// MessageId: ERROR_DS_SYNTAX_MISMATCH
'//
'// MessageText:
'//
'// Schema update failed: syntax mismatch.
'//
%ERROR_DS_SYNTAX_MISMATCH         = 8384&

'//
'// MessageId: ERROR_DS_EXISTS_IN_MUST_HAVE
'//
'// MessageText:
'//
'// Schema deletion failed: attribute is used in must-contain.
'//
%ERROR_DS_EXISTS_IN_MUST_HAVE     = 8385&

'//
'// MessageId: ERROR_DS_EXISTS_IN_MAY_HAVE
'//
'// MessageText:
'//
'// Schema deletion failed: attribute is used in may-contain.
'//
%ERROR_DS_EXISTS_IN_MAY_HAVE      = 8386&

'//
'// MessageId: ERROR_DS_NONEXISTENT_MAY_HAVE
'//
'// MessageText:
'//
'// Schema update failed: attribute in may-contain does not exist.
'//
%ERROR_DS_NONEXISTENT_MAY_HAVE    = 8387&

'//
'// MessageId: ERROR_DS_NONEXISTENT_MUST_HAVE
'//
'// MessageText:
'//
'// Schema update failed: attribute in must-contain does not exist.
'//
%ERROR_DS_NONEXISTENT_MUST_HAVE   = 8388&

'//
'// MessageId: ERROR_DS_AUX_CLS_TEST_FAIL
'//
'// MessageText:
'//
'// Schema update failed: class in aux-class list does not exist or is not an auxiliary class.
'//
%ERROR_DS_AUX_CLS_TEST_FAIL       = 8389&

'//
'// MessageId: ERROR_DS_NONEXISTENT_POSS_SUP
'//
'// MessageText:
'//
'// Schema update failed: class in poss-superiors does not exist.
'//
%ERROR_DS_NONEXISTENT_POSS_SUP    = 8390&

'//
'// MessageId: ERROR_DS_SUB_CLS_TEST_FAIL
'//
'// MessageText:
'//
'// Schema update failed: class in subclassof list does not exist or does not satisfy hierarchy rules.
'//
%ERROR_DS_SUB_CLS_TEST_FAIL       = 8391&

'//
'// MessageId: ERROR_DS_BAD_RDN_ATT_ID_SYNTAX
'//
'// MessageText:
'//
'// Schema update failed: Rdn-Att-Id has wrong syntax.
'//
%ERROR_DS_BAD_RDN_ATT_ID_SYNTAX   = 8392&

'//
'// MessageId: ERROR_DS_EXISTS_IN_AUX_CLS
'//
'// MessageText:
'//
'// Schema deletion failed: class is used as auxiliary class.
'//
%ERROR_DS_EXISTS_IN_AUX_CLS       = 8393&

'//
'// MessageId: ERROR_DS_EXISTS_IN_SUB_CLS
'//
'// MessageText:
'//
'// Schema deletion failed: class is used as sub class.
'//
%ERROR_DS_EXISTS_IN_SUB_CLS       = 8394&

'//
'// MessageId: ERROR_DS_EXISTS_IN_POSS_SUP
'//
'// MessageText:
'//
'// Schema deletion failed: class is used as poss superior.
'//
%ERROR_DS_EXISTS_IN_POSS_SUP      = 8395&

'//
'// MessageId: ERROR_DS_RECALCSCHEMA_FAILED
'//
'// MessageText:
'//
'// Schema update failed in recalculating validation cache.
'//
%ERROR_DS_RECALCSCHEMA_FAILED     = 8396&

'//
'// MessageId: ERROR_DS_TREE_DELETE_NOT_FINISHED
'//
'// MessageText:
'//
'// The tree deletion is not finished. The request must be made again to continue deleting the tree.
'//
%ERROR_DS_TREE_DELETE_NOT_FINISHED = 8397&

'//
'// MessageId: ERROR_DS_CANT_DELETE
'//
'// MessageText:
'//
'// The requested delete operation could not be performed.
'//
%ERROR_DS_CANT_DELETE             = 8398&

'//
'// MessageId: ERROR_DS_ATT_SCHEMA_REQ_ID
'//
'// MessageText:
'//
'// Cannot read the governs class identifier for the schema record.
'//
%ERROR_DS_ATT_SCHEMA_REQ_ID       = 8399&

'//
'// MessageId: ERROR_DS_BAD_ATT_SCHEMA_SYNTAX
'//
'// MessageText:
'//
'// The attribute schema has bad syntax.
'//
%ERROR_DS_BAD_ATT_SCHEMA_SYNTAX   = 8400&

'//
'// MessageId: ERROR_DS_CANT_CACHE_ATT
'//
'// MessageText:
'//
'// The attribute could not be cached.
'//
%ERROR_DS_CANT_CACHE_ATT          = 8401&

'//
'// MessageId: ERROR_DS_CANT_CACHE_CLASS
'//
'// MessageText:
'//
'// The class could not be cached.
'//
%ERROR_DS_CANT_CACHE_CLASS        = 8402&

'//
'// MessageId: ERROR_DS_CANT_REMOVE_ATT_CACHE
'//
'// MessageText:
'//
'// The attribute could not be removed from the cache.
'//
%ERROR_DS_CANT_REMOVE_ATT_CACHE   = 8403&

'//
'// MessageId: ERROR_DS_CANT_REMOVE_CLASS_CACHE
'//
'// MessageText:
'//
'// The class could not be removed from the cache.
'//
%ERROR_DS_CANT_REMOVE_CLASS_CACHE = 8404&

'//
'// MessageId: ERROR_DS_CANT_RETRIEVE_DN
'//
'// MessageText:
'//
'// The distinguished name attribute could not be read.
'//
%ERROR_DS_CANT_RETRIEVE_DN        = 8405&

'//
'// MessageId: ERROR_DS_MISSING_SUPREF
'//
'// MessageText:
'//
'// No superior reference has been configured for the directory service. The directory service is therefore unable to issue referrals to objects outside this forest.
'//
%ERROR_DS_MISSING_SUPREF          = 8406&

'//
'// MessageId: ERROR_DS_CANT_RETRIEVE_INSTANCE
'//
'// MessageText:
'//
'// The instance type attribute could not be retrieved.
'//
%ERROR_DS_CANT_RETRIEVE_INSTANCE = 8407&

'//
'// MessageId: ERROR_DS_CODE_INCONSISTENCY
'//
'// MessageText:
'//
'// An internal error has occurred.
'//
%ERROR_DS_CODE_INCONSISTENCY      = 8408&

'//
'// MessageId: ERROR_DS_DATABASE_ERROR
'//
'// MessageText:
'//
'// A database error has occurred.
'//
%ERROR_DS_DATABASE_ERROR          = 8409&

'//
'// MessageId: ERROR_DS_GOVERNSID_MISSING
'//
'// MessageText:
'//
'// The attribute GOVERNSID is missing.
'//
%ERROR_DS_GOVERNSID_MISSING       = 8410&

'//
'// MessageId: ERROR_DS_MISSING_EXPECTED_ATT
'//
'// MessageText:
'//
'// An expected attribute is missing.
'//
%ERROR_DS_MISSING_EXPECTED_ATT    = 8411&

'//
'// MessageId: ERROR_DS_NCNAME_MISSING_CR_REF
'//
'// MessageText:
'//
'// The specified naming context is missing a cross reference.
'//
%ERROR_DS_NCNAME_MISSING_CR_REF   = 8412&

'//
'// MessageId: ERROR_DS_SECURITY_CHECKING_ERROR
'//
'// MessageText:
'//
'// A security checking error has occurred.
'//
%ERROR_DS_SECURITY_CHECKING_ERROR = 8413&

'//
'// MessageId: ERROR_DS_SCHEMA_NOT_LOADED
'//
'// MessageText:
'//
'// The schema is not loaded.
'//
%ERROR_DS_SCHEMA_NOT_LOADED       = 8414&

'//
'// MessageId: ERROR_DS_SCHEMA_ALLOC_FAILED
'//
'// MessageText:
'//
'// Schema allocation failed. Please check if the machine is running low on memory.
'//
%ERROR_DS_SCHEMA_ALLOC_FAILED     = 8415&

'//
'// MessageId: ERROR_DS_ATT_SCHEMA_REQ_SYNTAX
'//
'// MessageText:
'//
'// Failed to obtain the required syntax for the attribute schema.
'//
%ERROR_DS_ATT_SCHEMA_REQ_SYNTAX   = 8416&

'//
'// MessageId: ERROR_DS_GCVERIFY_ERROR
'//
'// MessageText:
'//
'// The global catalog verification failed. The global catalog is not available or does not support the operation. Some part of the directory is currently not available.
'//
%ERROR_DS_GCVERIFY_ERROR          = 8417&

'//
'// MessageId: ERROR_DS_DRA_SCHEMA_MISMATCH
'//
'// MessageText:
'//
'// The replication operation failed because of a schema mismatch between the servers involved.
'//
%ERROR_DS_DRA_SCHEMA_MISMATCH     = 8418&

'//
'// MessageId: ERROR_DS_CANT_FIND_DSA_OBJ
'//
'// MessageText:
'//
'// The DSA object could not be found.
'//
%ERROR_DS_CANT_FIND_DSA_OBJ       = 8419&

'//
'// MessageId: ERROR_DS_CANT_FIND_EXPECTED_NC
'//
'// MessageText:
'//
'// The naming context could not be found.
'//
%ERROR_DS_CANT_FIND_EXPECTED_NC   = 8420&

'//
'// MessageId: ERROR_DS_CANT_FIND_NC_IN_CACHE
'//
'// MessageText:
'//
'// The naming context could not be found in the cache.
'//
%ERROR_DS_CANT_FIND_NC_IN_CACHE   = 8421&

'//
'// MessageId: ERROR_DS_CANT_RETRIEVE_CHILD
'//
'// MessageText:
'//
'// The child object could not be retrieved.
'//
%ERROR_DS_CANT_RETRIEVE_CHILD     = 8422&

'//
'// MessageId: ERROR_DS_SECURITY_ILLEGAL_MODIFY
'//
'// MessageText:
'//
'// The modification was not permitted for security reasons.
'//
%ERROR_DS_SECURITY_ILLEGAL_MODIFY = 8423&

'//
'// MessageId: ERROR_DS_CANT_REPLACE_HIDDEN_REC
'//
'// MessageText:
'//
'// The operation cannot replace the hidden record.
'//
%ERROR_DS_CANT_REPLACE_HIDDEN_REC = 8424&

'//
'// MessageId: ERROR_DS_BAD_HIERARCHY_FILE
'//
'// MessageText:
'//
'// The hierarchy file is invalid.
'//
%ERROR_DS_BAD_HIERARCHY_FILE      = 8425&

'//
'// MessageId: ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED
'//
'// MessageText:
'//
'// The attempt to build the hierarchy table failed.
'//
%ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED = 8426&

'//
'// MessageId: ERROR_DS_CONFIG_PARAM_MISSING
'//
'// MessageText:
'//
'// The directory configuration parameter is missing from the registry.
'//
%ERROR_DS_CONFIG_PARAM_MISSING    = 8427&

'//
'// MessageId: ERROR_DS_COUNTING_AB_INDICES_FAILED
'//
'// MessageText:
'//
'// The attempt to count the address book indices failed.
'//
%ERROR_DS_COUNTING_AB_INDICES_FAILED = 8428&

'//
'// MessageId: ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED
'//
'// MessageText:
'//
'// The allocation of the hierarchy table failed.
'//
%ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED = 8429&

'//
'// MessageId: ERROR_DS_INTERNAL_FAILURE
'//
'// MessageText:
'//
'// The directory service encountered an internal failure.
'//
%ERROR_DS_INTERNAL_FAILURE        = 8430&

'//
'// MessageId: ERROR_DS_UNKNOWN_ERROR
'//
'// MessageText:
'//
'// The directory service encountered an unknown failure.
'//
%ERROR_DS_UNKNOWN_ERROR           = 8431&

'//
'// MessageId: ERROR_DS_ROOT_REQUIRES_CLASS_TOP
'//
'// MessageText:
'//
'// A root object requires a class of 'top'.
'//
%ERROR_DS_ROOT_REQUIRES_CLASS_TOP = 8432&

'//
'// MessageId: ERROR_DS_REFUSING_FSMO_ROLES
'//
'// MessageText:
'//
'// This directory server is shutting down, and cannot take ownership of new floating single-master operation roles.
'//
%ERROR_DS_REFUSING_FSMO_ROLES     = 8433&

'//
'// MessageId: ERROR_DS_MISSING_FSMO_SETTINGS
'//
'// MessageText:
'//
'// The directory service is missing mandatory configuration information, and is unable to determine the ownership of floating single-master operation roles.
'//
%ERROR_DS_MISSING_FSMO_SETTINGS   = 8434&

'//
'// MessageId: ERROR_DS_UNABLE_TO_SURRENDER_ROLES
'//
'// MessageText:
'//
'// The directory service was unable to transfer ownership of one or more floating single-master operation roles to other servers.
'//
%ERROR_DS_UNABLE_TO_SURRENDER_ROLES = 8435&

'//
'// MessageId: ERROR_DS_DRA_GENERIC
'//
'// MessageText:
'//
'// The replication operation failed.
'//
%ERROR_DS_DRA_GENERIC             = 8436&

'//
'// MessageId: ERROR_DS_DRA_INVALID_PARAMETER
'//
'// MessageText:
'//
'// An invalid parameter was specified for this replication operation.
'//
%ERROR_DS_DRA_INVALID_PARAMETER   = 8437&

'//
'// MessageId: ERROR_DS_DRA_BUSY
'//
'// MessageText:
'//
'// The directory service is too busy to complete the replication operation at this time.
'//
%ERROR_DS_DRA_BUSY                = 8438&

'//
'// MessageId: ERROR_DS_DRA_BAD_DN
'//
'// MessageText:
'//
'// The distinguished name specified for this replication operation is invalid.
'//
%ERROR_DS_DRA_BAD_DN              = 8439&

'//
'// MessageId: ERROR_DS_DRA_BAD_NC
'//
'// MessageText:
'//
'// The naming context specified for this replication operation is invalid.
'//
%ERROR_DS_DRA_BAD_NC              = 8440&

'//
'// MessageId: ERROR_DS_DRA_DN_EXISTS
'//
'// MessageText:
'//
'// The distinguished name specified for this replication operation already exists.
'//
%ERROR_DS_DRA_DN_EXISTS           = 8441&

'//
'// MessageId: ERROR_DS_DRA_INTERNAL_ERROR
'//
'// MessageText:
'//
'// The replication system encountered an internal error.
'//
%ERROR_DS_DRA_INTERNAL_ERROR      = 8442&

'//
'// MessageId: ERROR_DS_DRA_INCONSISTENT_DIT
'//
'// MessageText:
'//
'// The replication operation encountered a database inconsistency.
'//
%ERROR_DS_DRA_INCONSISTENT_DIT    = 8443&

'//
'// MessageId: ERROR_DS_DRA_CONNECTION_FAILED
'//
'// MessageText:
'//
'// The server specified for this replication operation could not be contacted.
'//
%ERROR_DS_DRA_CONNECTION_FAILED   = 8444&

'//
'// MessageId: ERROR_DS_DRA_BAD_INSTANCE_TYPE
'//
'// MessageText:
'//
'// The replication operation encountered an object with an invalid instance type.
'//
%ERROR_DS_DRA_BAD_INSTANCE_TYPE   = 8445&

'//
'// MessageId: ERROR_DS_DRA_OUT_OF_MEM
'//
'// MessageText:
'//
'// The replication operation failed to allocate memory.
'//
%ERROR_DS_DRA_OUT_OF_MEM          = 8446&

'//
'// MessageId: ERROR_DS_DRA_MAIL_PROBLEM
'//
'// MessageText:
'//
'// The replication operation encountered an error with the mail system.
'//
%ERROR_DS_DRA_MAIL_PROBLEM        = 8447&

'//
'// MessageId: ERROR_DS_DRA_REF_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The replication reference information for the target server already exists.
'//
%ERROR_DS_DRA_REF_ALREADY_EXISTS = 8448&

'//
'// MessageId: ERROR_DS_DRA_REF_NOT_FOUND
'//
'// MessageText:
'//
'// The replication reference information for the target server does not exist.
'//
%ERROR_DS_DRA_REF_NOT_FOUND       = 8449&

'//
'// MessageId: ERROR_DS_DRA_OBJ_IS_REP_SOURCE
'//
'// MessageText:
'//
'// The naming context cannot be removed because it is replicated to another server.
'//
%ERROR_DS_DRA_OBJ_IS_REP_SOURCE   = 8450&

'//
'// MessageId: ERROR_DS_DRA_DB_ERROR
'//
'// MessageText:
'//
'// The replication operation encountered a database error.
'//
%ERROR_DS_DRA_DB_ERROR            = 8451&

'//
'// MessageId: ERROR_DS_DRA_NO_REPLICA
'//
'// MessageText:
'//
'// The naming context is in the process of being removed or is not replicated from the specified server.
'//
%ERROR_DS_DRA_NO_REPLICA          = 8452&

'//
'// MessageId: ERROR_DS_DRA_ACCESS_DENIED
'//
'// MessageText:
'//
'// Replication access was denied.
'//
%ERROR_DS_DRA_ACCESS_DENIED       = 8453&

'//
'// MessageId: ERROR_DS_DRA_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The requested operation is not supported by this version of the directory service.
'//
%ERROR_DS_DRA_NOT_SUPPORTED       = 8454&

'//
'// MessageId: ERROR_DS_DRA_RPC_CANCELLED
'//
'// MessageText:
'//
'// The replication remote procedure call was cancelled.
'//
%ERROR_DS_DRA_RPC_CANCELLED       = 8455&

'//
'// MessageId: ERROR_DS_DRA_SOURCE_DISABLED
'//
'// MessageText:
'//
'// The source server is currently rejecting replication requests.
'//
%ERROR_DS_DRA_SOURCE_DISABLED     = 8456&

'//
'// MessageId: ERROR_DS_DRA_SINK_DISABLED
'//
'// MessageText:
'//
'// The destination server is currently rejecting replication requests.
'//
%ERROR_DS_DRA_SINK_DISABLED       = 8457&

'//
'// MessageId: ERROR_DS_DRA_NAME_COLLISION
'//
'// MessageText:
'//
'// The replication operation failed due to a collision of object names.
'//
%ERROR_DS_DRA_NAME_COLLISION      = 8458&

'//
'// MessageId: ERROR_DS_DRA_SOURCE_REINSTALLED
'//
'// MessageText:
'//
'// The replication source has been reinstalled.
'//
%ERROR_DS_DRA_SOURCE_REINSTALLED = 8459&

'//
'// MessageId: ERROR_DS_DRA_MISSING_PARENT
'//
'// MessageText:
'//
'// The replication operation failed because a required parent object is missing.
'//
%ERROR_DS_DRA_MISSING_PARENT      = 8460&

'//
'// MessageId: ERROR_DS_DRA_PREEMPTED
'//
'// MessageText:
'//
'// The replication operation was preempted.
'//
%ERROR_DS_DRA_PREEMPTED           = 8461&

'//
'// MessageId: ERROR_DS_DRA_ABANDON_SYNC
'//
'// MessageText:
'//
'// The replication synchronization attempt was abandoned because of a lack of updates.
'//
%ERROR_DS_DRA_ABANDON_SYNC        = 8462&

'//
'// MessageId: ERROR_DS_DRA_SHUTDOWN
'//
'// MessageText:
'//
'// The replication operation was terminated because the system is shutting down.
'//
%ERROR_DS_DRA_SHUTDOWN            = 8463&

'//
'// MessageId: ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET
'//
'// MessageText:
'//
'// Synchronization attempt failed because the destination DC is currently waiting to synchronize new partial attributes from source.
'// This condition is normal if a recent schema change modified the partial attribute set. The destination partial attribute set is not a subset of source partial attribute set.
'//
%ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET = 8464&

'//
'// MessageId: ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA
'//
'// MessageText:
'//
'// The replication synchronization attempt failed because a master replica attempted to sync from a partial replica.
'//
%ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA = 8465&

'//
'// MessageId: ERROR_DS_DRA_EXTN_CONNECTION_FAILED
'//
'// MessageText:
'//
'// The server specified for this replication operation was contacted, but that server was unable to contact an additional server needed to complete the operation.
'//
%ERROR_DS_DRA_EXTN_CONNECTION_FAILED = 8466&

'//
'// MessageId: ERROR_DS_INSTALL_SCHEMA_MISMATCH
'//
'// MessageText:
'//
'// The version of the directory service schema of the source forest is not compatible with the version of directory service on this computer.
'//
%ERROR_DS_INSTALL_SCHEMA_MISMATCH = 8467&

'//
'// MessageId: ERROR_DS_DUP_LINK_ID
'//
'// MessageText:
'//
'// Schema update failed: An attribute with the same link identifier already exists.
'//
%ERROR_DS_DUP_LINK_ID             = 8468&

'//
'// MessageId: ERROR_DS_NAME_ERROR_RESOLVING
'//
'// MessageText:
'//
'// Name translation: Generic processing error.
'//
%ERROR_DS_NAME_ERROR_RESOLVING    = 8469&

'//
'// MessageId: ERROR_DS_NAME_ERROR_NOT_FOUND
'//
'// MessageText:
'//
'// Name translation: Could not find the name or insufficient right to see name.
'//
%ERROR_DS_NAME_ERROR_NOT_FOUND    = 8470&

'//
'// MessageId: ERROR_DS_NAME_ERROR_NOT_UNIQUE
'//
'// MessageText:
'//
'// Name translation: Input name mapped to more than one output name.
'//
%ERROR_DS_NAME_ERROR_NOT_UNIQUE   = 8471&

'//
'// MessageId: ERROR_DS_NAME_ERROR_NO_MAPPING
'//
'// MessageText:
'//
'// Name translation: Input name found, but not the associated output format.
'//
%ERROR_DS_NAME_ERROR_NO_MAPPING   = 8472&

'//
'// MessageId: ERROR_DS_NAME_ERROR_DOMAIN_ONLY
'//
'// MessageText:
'//
'// Name translation: Unable to resolve completely, only the domain was found.
'//
%ERROR_DS_NAME_ERROR_DOMAIN_ONLY = 8473&

'//
'// MessageId: ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING
'//
'// MessageText:
'//
'// Name translation: Unable to perform purely syntactical mapping at the client without going out to the wire.
'//
%ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING = 8474&

'//
'// MessageId: ERROR_DS_CONSTRUCTED_ATT_MOD
'//
'// MessageText:
'//
'// Modification of a constructed attribute is not allowed.
'//
%ERROR_DS_CONSTRUCTED_ATT_MOD     = 8475&

'//
'// MessageId: ERROR_DS_WRONG_OM_OBJ_CLASS
'//
'// MessageText:
'//
'// The OM-Object-Class specified is incorrect for an attribute with the specified syntax.
'//
%ERROR_DS_WRONG_OM_OBJ_CLASS      = 8476&

'//
'// MessageId: ERROR_DS_DRA_REPL_PENDING
'//
'// MessageText:
'//
'// The replication request has been posted; waiting for reply.
'//
%ERROR_DS_DRA_REPL_PENDING        = 8477&

'//
'// MessageId: ERROR_DS_DS_REQUIRED
'//
'// MessageText:
'//
'// The requested operation requires a directory service, and none was available.
'//
%ERROR_DS_DS_REQUIRED             = 8478&

'//
'// MessageId: ERROR_DS_INVALID_LDAP_DISPLAY_NAME
'//
'// MessageText:
'//
'// The LDAP display name of the class or attribute contains non-ASCII characters.
'//
%ERROR_DS_INVALID_LDAP_DISPLAY_NAME = 8479&

'//
'// MessageId: ERROR_DS_NON_BASE_SEARCH
'//
'// MessageText:
'//
'// The requested search operation is only supported for base searches.
'//
%ERROR_DS_NON_BASE_SEARCH         = 8480&

'//
'// MessageId: ERROR_DS_CANT_RETRIEVE_ATTS
'//
'// MessageText:
'//
'// The search failed to retrieve attributes from the database.
'//
%ERROR_DS_CANT_RETRIEVE_ATTS      = 8481&

'//
'// MessageId: ERROR_DS_BACKLINK_WITHOUT_LINK
'//
'// MessageText:
'//
'// The schema update operation tried to add a backward link attribute that has no corresponding forward link.
'//
%ERROR_DS_BACKLINK_WITHOUT_LINK   = 8482&

'//
'// MessageId: ERROR_DS_EPOCH_MISMATCH
'//
'// MessageText:
'//
'// Source and destination of a cross-domain move do not agree on the object's epoch number. Either source or destination does not have the latest version of the object.
'//
%ERROR_DS_EPOCH_MISMATCH          = 8483&

'//
'// MessageId: ERROR_DS_SRC_NAME_MISMATCH
'//
'// MessageText:
'//
'// Source and destination of a cross-domain move do not agree on the object's current name. Either source or destination does not have the latest version of the object.
'//
%ERROR_DS_SRC_NAME_MISMATCH       = 8484&

'//
'// MessageId: ERROR_DS_SRC_AND_DST_NC_IDENTICAL
'//
'// MessageText:
'//
'// Source and destination for the cross-domain move operation are identical. Caller should use local move operation instead of cross-domain move operation.
'//
%ERROR_DS_SRC_AND_DST_NC_IDENTICAL = 8485&

'//
'// MessageId: ERROR_DS_DST_NC_MISMATCH
'//
'// MessageText:
'//
'// Source and destination for a cross-domain move are not in agreement on the naming contexts in the forest. Either source or destination does not have the latest version of the Partitions container.
'//
%ERROR_DS_DST_NC_MISMATCH         = 8486&

'//
'// MessageId: ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC
'//
'// MessageText:
'//
'// Destination of a cross-domain move is not authoritative for the destination naming context.
'//
%ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC = 8487&

'//
'// MessageId: ERROR_DS_SRC_GUID_MISMATCH
'//
'// MessageText:
'//
'// Source and destination of a cross-domain move do not agree on the identity of the source object. Either source or destination does not have the latest version of the source object.
'//
%ERROR_DS_SRC_GUID_MISMATCH       = 8488&

'//
'// MessageId: ERROR_DS_CANT_MOVE_DELETED_OBJECT
'//
'// MessageText:
'//
'// Object being moved across-domains is already known to be deleted by the destination server. The source server does not have the latest version of the source object.
'//
%ERROR_DS_CANT_MOVE_DELETED_OBJECT = 8489&

'//
'// MessageId: ERROR_DS_PDC_OPERATION_IN_PROGRESS
'//
'// MessageText:
'//
'// Another operation which requires exclusive access to the PDC FSMO is already in progress.
'//
%ERROR_DS_PDC_OPERATION_IN_PROGRESS = 8490&

'//
'// MessageId: ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD
'//
'// MessageText:
'//
'// A cross-domain move operation failed such that two versions of the moved object exist - one each in the source and destination domains. The destination object needs to be removed to restore the system to a consistent state.
'//
%ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD = 8491&

'//
'// MessageId: ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION
'//
'// MessageText:
'//
'// This object may not be moved across domain boundaries either because cross-domain moves for this class are disallowed, or the object has some special characteristics, e.g.: trust account or restricted RID, which prevent its move.
'//
%ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION = 8492&

'//
'// MessageId: ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS
'//
'// MessageText:
'//
'// Can't move objects with memberships across domain boundaries as once moved, this would violate the membership conditions of the account group. Remove the object from any account group memberships and retry.
'//
%ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS = 8493&

'//
'// MessageId: ERROR_DS_NC_MUST_HAVE_NC_PARENT
'//
'// MessageText:
'//
'// A naming context head must be the immediate child of another naming context head, not of an interior node.
'//
%ERROR_DS_NC_MUST_HAVE_NC_PARENT = 8494&

'//
'// MessageId: ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE
'//
'// MessageText:
'//
'// The directory cannot validate the proposed naming context name because it does not hold a replica of the naming context above the proposed naming context. Please ensure that the domain naming master role is held by a server that is configured
'// as a global catalog server, and that the server is up to date with its replication partners.
'// (Applies only to Windows 2000 Domain Naming masters)
'//
%ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE = 8495&

'//
'// MessageId: ERROR_DS_DST_DOMAIN_NOT_NATIVE
'//
'// MessageText:
'//
'// Destination domain must be in native mode.
'//
%ERROR_DS_DST_DOMAIN_NOT_NATIVE   = 8496&

'//
'// MessageId: ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER
'//
'// MessageText:
'//
'// The operation cannot be performed because the server does not have an infrastructure container in the domain of interest.
'//
%ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER = 8497&

'//
'// MessageId: ERROR_DS_CANT_MOVE_ACCOUNT_GROUP
'//
'// MessageText:
'//
'// Cross-domain move of non-empty account groups is not allowed.
'//
%ERROR_DS_CANT_MOVE_ACCOUNT_GROUP = 8498&

'//
'// MessageId: ERROR_DS_CANT_MOVE_RESOURCE_GROUP
'//
'// MessageText:
'//
'// Cross-domain move of non-empty resource groups is not allowed.
'//
%ERROR_DS_CANT_MOVE_RESOURCE_GROUP = 8499&

'//
'// MessageId: ERROR_DS_INVALID_SEARCH_FLAG
'//
'// MessageText:
'//
'// The search flags for the attribute are invalid. The ANR bit is valid only on attributes of Unicode or Teletex strings.
'//
%ERROR_DS_INVALID_SEARCH_FLAG     = 8500&

'//
'// MessageId: ERROR_DS_NO_TREE_DELETE_ABOVE_NC
'//
'// MessageText:
'//
'// Tree deletions starting at an object which has an NC head as a descendant are not allowed.
'//
%ERROR_DS_NO_TREE_DELETE_ABOVE_NC = 8501&

'//
'// MessageId: ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE
'//
'// MessageText:
'//
'// The directory service failed to lock a tree in preparation for a tree deletion because the tree was in use.
'//
%ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE = 8502&

'//
'// MessageId: ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE
'//
'// MessageText:
'//
'// The directory service failed to identify the list of objects to delete while attempting a tree deletion.
'//
%ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE = 8503&

'//
'// MessageId: ERROR_DS_SAM_INIT_FAILURE
'//
'// MessageText:
'//
'// Security Accounts Manager initialization failed because of the following error: %1.
'// Error Status: 0x%2. Click OK to shut down the system and reboot into Directory Services Restore Mode. Check the event log for detailed information.
'//
%ERROR_DS_SAM_INIT_FAILURE        = 8504&

'//
'// MessageId: ERROR_DS_SENSITIVE_GROUP_VIOLATION
'//
'// MessageText:
'//
'// Only an administrator can modify the membership list of an administrative group.
'//
%ERROR_DS_SENSITIVE_GROUP_VIOLATION = 8505&

'//
'// MessageId: ERROR_DS_CANT_MOD_PRIMARYGROUPID
'//
'// MessageText:
'//
'// Cannot change the primary group ID of a domain controller account.
'//
%ERROR_DS_CANT_MOD_PRIMARYGROUPID = 8506&

'//
'// MessageId: ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD
'//
'// MessageText:
'//
'// An attempt is made to modify the base schema.
'//
%ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD = 8507&

'//
'// MessageId: ERROR_DS_NONSAFE_SCHEMA_CHANGE
'//
'// MessageText:
'//
'// Adding a new mandatory attribute to an existing class, deleting a mandatory attribute from an existing class, or adding an optional attribute
'// to the special class Top that is not a backlink attribute (directly or through inheritance, for example, by adding or deleting an auxiliary class) is not allowed.
'//
%ERROR_DS_NONSAFE_SCHEMA_CHANGE   = 8508&

'//
'// MessageId: ERROR_DS_SCHEMA_UPDATE_DISALLOWED
'//
'// MessageText:
'//
'// Schema update is not allowed on this DC because the DC is not the schema FSMO Role Owner.
'//
%ERROR_DS_SCHEMA_UPDATE_DISALLOWED = 8509&

'//
'// MessageId: ERROR_DS_CANT_CREATE_UNDER_SCHEMA
'//
'// MessageText:
'//
'// An object of this class cannot be created under the schema container. You can only create attribute-schema and class-schema objects under the schema container.
'//
%ERROR_DS_CANT_CREATE_UNDER_SCHEMA = 8510&

'//
'// MessageId: ERROR_DS_INSTALL_NO_SRC_SCH_VERSION
'//
'// MessageText:
'//
'// The replica/child install failed to get the objectVersion attribute on the schema container on the source DC. Either the attribute is missing on the schema container or the credentials supplied do not have permission to read it.
'//
%ERROR_DS_INSTALL_NO_SRC_SCH_VERSION = 8511&

'//
'// MessageId: ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE
'//
'// MessageText:
'//
'// The replica/child install failed to read the objectVersion attribute in the SCHEMA section of the file schema.ini in the system32 directory.
'//
%ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE = 8512&

'//
'// MessageId: ERROR_DS_INVALID_GROUP_TYPE
'//
'// MessageText:
'//
'// The specified group type is invalid.
'//
%ERROR_DS_INVALID_GROUP_TYPE      = 8513&

'//
'// MessageId: ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN
'//
'// MessageText:
'//
'// You cannot nest global groups in a mixed domain if the group is security-enabled.
'//
%ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN = 8514&

'//
'// MessageId: ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN
'//
'// MessageText:
'//
'// You cannot nest local groups in a mixed domain if the group is security-enabled.
'//
%ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN = 8515&

'//
'// MessageId: ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER
'//
'// MessageText:
'//
'// A global group cannot have a local group as a member.
'//
%ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER = 8516&

'//
'// MessageId: ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER
'//
'// MessageText:
'//
'// A global group cannot have a universal group as a member.
'//
%ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER = 8517&

'//
'// MessageId: ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER
'//
'// MessageText:
'//
'// A universal group cannot have a local group as a member.
'//
%ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER = 8518&

'//
'// MessageId: ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER
'//
'// MessageText:
'//
'// A global group cannot have a cross-domain member.
'//
%ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER = 8519&

'//
'// MessageId: ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER
'//
'// MessageText:
'//
'// A local group cannot have another cross domain local group as a member.
'//
%ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER = 8520&

'//
'// MessageId: ERROR_DS_HAVE_PRIMARY_MEMBERS
'//
'// MessageText:
'//
'// A group with primary members cannot change to a security-disabled group.
'//
%ERROR_DS_HAVE_PRIMARY_MEMBERS    = 8521&

'//
'// MessageId: ERROR_DS_STRING_SD_CONVERSION_FAILED
'//
'// MessageText:
'//
'// The schema cache load failed to convert the string default SD on a class-schema object.
'//
%ERROR_DS_STRING_SD_CONVERSION_FAILED = 8522&

'//
'// MessageId: ERROR_DS_NAMING_MASTER_GC
'//
'// MessageText:
'//
'// Only DSAs configured to be Global Catalog servers should be allowed to hold the Domain Naming Master FSMO role. (Applies only to Windows 2000 servers)
'//
%ERROR_DS_NAMING_MASTER_GC        = 8523&

'//
'// MessageId: ERROR_DS_DNS_LOOKUP_FAILURE
'//
'// MessageText:
'//
'// The DSA operation is unable to proceed because of a DNS lookup failure.
'//
%ERROR_DS_DNS_LOOKUP_FAILURE      = 8524&

'//
'// MessageId: ERROR_DS_COULDNT_UPDATE_SPNS
'//
'// MessageText:
'//
'// While processing a change to the DNS Host Name for an object, the Service Principal Name values could not be kept in sync.
'//
%ERROR_DS_COULDNT_UPDATE_SPNS     = 8525&

'//
'// MessageId: ERROR_DS_CANT_RETRIEVE_SD
'//
'// MessageText:
'//
'// The Security Descriptor attribute could not be read.
'//
%ERROR_DS_CANT_RETRIEVE_SD        = 8526&

'//
'// MessageId: ERROR_DS_KEY_NOT_UNIQUE
'//
'// MessageText:
'//
'// The object requested was not found, but an object with that key was found.
'//
%ERROR_DS_KEY_NOT_UNIQUE          = 8527&

'//
'// MessageId: ERROR_DS_WRONG_LINKED_ATT_SYNTAX
'//
'// MessageText:
'//
'// The syntax of the linked attribute being added is incorrect. Forward links can only have syntax 2.5.5.1, 2.5.5.7, and 2.5.5.14, and backlinks can only have syntax 2.5.5.1
'//
%ERROR_DS_WRONG_LINKED_ATT_SYNTAX = 8528&

'//
'// MessageId: ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD
'//
'// MessageText:
'//
'// Security Account Manager needs to get the boot password.
'//
%ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD = 8529&

'//
'// MessageId: ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY
'//
'// MessageText:
'//
'// Security Account Manager needs to get the boot key from floppy disk.
'//
%ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY = 8530&

'//
'// MessageId: ERROR_DS_CANT_START
'//
'// MessageText:
'//
'// Directory Service cannot start.
'//
%ERROR_DS_CANT_START              = 8531&

'//
'// MessageId: ERROR_DS_INIT_FAILURE
'//
'// MessageText:
'//
'// Directory Services could not start.
'//
%ERROR_DS_INIT_FAILURE            = 8532&

'//
'// MessageId: ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION
'//
'// MessageText:
'//
'// The connection between client and server requires packet privacy or better.
'//
%ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION = 8533&

'//
'// MessageId: ERROR_DS_SOURCE_DOMAIN_IN_FOREST
'//
'// MessageText:
'//
'// The source domain may not be in the same forest as destination.
'//
%ERROR_DS_SOURCE_DOMAIN_IN_FOREST = 8534&

'//
'// MessageId: ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST
'//
'// MessageText:
'//
'// The destination domain must be in the forest.
'//
%ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST = 8535&

'//
'// MessageId: ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED
'//
'// MessageText:
'//
'// The operation requires that destination domain auditing be enabled.
'//
%ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED = 8536&

'//
'// MessageId: ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN
'//
'// MessageText:
'//
'// The operation couldn't locate a DC for the source domain.
'//
%ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN = 8537&

'//
'// MessageId: ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER
'//
'// MessageText:
'//
'// The source object must be a group or user.
'//
%ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER = 8538&

'//
'// MessageId: ERROR_DS_SRC_SID_EXISTS_IN_FOREST
'//
'// MessageText:
'//
'// The source object's SID already exists in destination forest.
'//
%ERROR_DS_SRC_SID_EXISTS_IN_FOREST = 8539&

'//
'// MessageId: ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH
'//
'// MessageText:
'//
'// The source and destination object must be of the same type.
'//
%ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH = 8540&

'//
'// MessageId: ERROR_SAM_INIT_FAILURE
'//
'// MessageText:
'//
'// Security Accounts Manager initialization failed because of the following error: %1.
'// Error Status: 0x%2. Click OK to shut down the system and reboot into Safe Mode. Check the event log for detailed information.
'//
%ERROR_SAM_INIT_FAILURE           = 8541&

'//
'// MessageId: ERROR_DS_DRA_SCHEMA_INFO_SHIP
'//
'// MessageText:
'//
'// Schema information could not be included in the replication request.
'//
%ERROR_DS_DRA_SCHEMA_INFO_SHIP    = 8542&

'//
'// MessageId: ERROR_DS_DRA_SCHEMA_CONFLICT
'//
'// MessageText:
'//
'// The replication operation could not be completed due to a schema incompatibility.
'//
%ERROR_DS_DRA_SCHEMA_CONFLICT     = 8543&

'//
'// MessageId: ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT
'//
'// MessageText:
'//
'// The replication operation could not be completed due to a previous schema incompatibility.
'//
%ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT = 8544&

'//
'// MessageId: ERROR_DS_DRA_OBJ_NC_MISMATCH
'//
'// MessageText:
'//
'// The replication update could not be applied because either the source or the destination has not yet received information regarding a recent cross-domain move operation.
'//
%ERROR_DS_DRA_OBJ_NC_MISMATCH     = 8545&

'//
'// MessageId: ERROR_DS_NC_STILL_HAS_DSAS
'//
'// MessageText:
'//
'// The requested domain could not be deleted because there exist domain controllers that still host this domain.
'//
%ERROR_DS_NC_STILL_HAS_DSAS       = 8546&

'//
'// MessageId: ERROR_DS_GC_REQUIRED
'//
'// MessageText:
'//
'// The requested operation can be performed only on a global catalog server.
'//
%ERROR_DS_GC_REQUIRED             = 8547&

'//
'// MessageId: ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY
'//
'// MessageText:
'//
'// A local group can only be a member of other local groups in the same domain.
'//
%ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY = 8548&

'//
'// MessageId: ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS
'//
'// MessageText:
'//
'// Foreign security principals cannot be members of universal groups.
'//
%ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS = 8549&

'//
'// MessageId: ERROR_DS_CANT_ADD_TO_GC
'//
'// MessageText:
'//
'// The attribute is not allowed to be replicated to the GC because of security reasons.
'//
%ERROR_DS_CANT_ADD_TO_GC          = 8550&

'//
'// MessageId: ERROR_DS_NO_CHECKPOINT_WITH_PDC
'//
'// MessageText:
'//
'// The checkpoint with the PDC could not be taken because there too many modifications being processed currently.
'//
%ERROR_DS_NO_CHECKPOINT_WITH_PDC = 8551&

'//
'// MessageId: ERROR_DS_SOURCE_AUDITING_NOT_ENABLED
'//
'// MessageText:
'//
'// The operation requires that source domain auditing be enabled.
'//
%ERROR_DS_SOURCE_AUDITING_NOT_ENABLED = 8552&

'//
'// MessageId: ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC
'//
'// MessageText:
'//
'// Security principal objects can only be created inside domain naming contexts.
'//
%ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC = 8553&

'//
'// MessageId: ERROR_DS_INVALID_NAME_FOR_SPN
'//
'// MessageText:
'//
'// A Service Principal Name (SPN) could not be constructed because the provided hostname is not in the necessary format.
'//
%ERROR_DS_INVALID_NAME_FOR_SPN    = 8554&

'//
'// MessageId: ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS
'//
'// MessageText:
'//
'// A Filter was passed that uses constructed attributes.
'//
%ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS = 8555&

'//
'// MessageId: ERROR_DS_UNICODEPWD_NOT_IN_QUOTES
'//
'// MessageText:
'//
'// The unicodePwd attribute value must be enclosed in double quotes.
'//
%ERROR_DS_UNICODEPWD_NOT_IN_QUOTES = 8556&

'//
'// MessageId: ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED
'//
'// MessageText:
'//
'// Your computer could not be joined to the domain. You have exceeded the maximum number of computer accounts you are allowed to create in this domain. Contact your system administrator to have this limit reset or increased.
'//
%ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED = 8557&

'//
'// MessageId: ERROR_DS_MUST_BE_RUN_ON_DST_DC
'//
'// MessageText:
'//
'// For security reasons, the operation must be run on the destination DC.
'//
%ERROR_DS_MUST_BE_RUN_ON_DST_DC   = 8558&

'//
'// MessageId: ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER
'//
'// MessageText:
'//
'// For security reasons, the source DC must be NT4SP4 or greater.
'//
%ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER = 8559&

'//
'// MessageId: ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ
'//
'// MessageText:
'//
'// Critical Directory Service System objects cannot be deleted during tree delete operations. The tree delete may have been partially performed.
'//
%ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ = 8560&

'//
'// MessageId: ERROR_DS_INIT_FAILURE_CONSOLE
'//
'// MessageText:
'//
'// Directory Services could not start because of the following error: %1.
'// Error Status: 0x%2. Please click OK to shutdown the system. You can use the recovery console to diagnose the system further.
'//
%ERROR_DS_INIT_FAILURE_CONSOLE    = 8561&

'//
'// MessageId: ERROR_DS_SAM_INIT_FAILURE_CONSOLE
'//
'// MessageText:
'//
'// Security Accounts Manager initialization failed because of the following error: %1.
'// Error Status: 0x%2. Please click OK to shutdown the system. You can use the recovery console to diagnose the system further.
'//
%ERROR_DS_SAM_INIT_FAILURE_CONSOLE = 8562&

'//
'// MessageId: ERROR_DS_FOREST_VERSION_TOO_HIGH
'//
'// MessageText:
'//
'// The version of the operating system installed is incompatible with the current forest functional level. You must upgrade to a new version of the operating system before this server can become a domain controller in this forest.
'//
%ERROR_DS_FOREST_VERSION_TOO_HIGH = 8563&

'//
'// MessageId: ERROR_DS_DOMAIN_VERSION_TOO_HIGH
'//
'// MessageText:
'//
'// The version of the operating system installed is incompatible with the current domain functional level. You must upgrade to a new version of the operating system before this server can become a domain controller in this domain.
'//
%ERROR_DS_DOMAIN_VERSION_TOO_HIGH = 8564&

'//
'// MessageId: ERROR_DS_FOREST_VERSION_TOO_LOW
'//
'// MessageText:
'//
'// The version of the operating system installed on this server no longer supports the current forest functional level. You must raise the forest functional level before this server can become a domain controller in this forest.
'//
%ERROR_DS_FOREST_VERSION_TOO_LOW = 8565&

'//
'// MessageId: ERROR_DS_DOMAIN_VERSION_TOO_LOW
'//
'// MessageText:
'//
'// The version of the operating system installed on this server no longer supports the current domain functional level. You must raise the domain functional level before this server can become a domain controller in this domain.
'//
%ERROR_DS_DOMAIN_VERSION_TOO_LOW = 8566&

'//
'// MessageId: ERROR_DS_INCOMPATIBLE_VERSION
'//
'// MessageText:
'//
'// The version of the operating system installed on this server is incompatible with the functional level of the domain or forest.
'//
%ERROR_DS_INCOMPATIBLE_VERSION    = 8567&

'//
'// MessageId: ERROR_DS_LOW_DSA_VERSION
'//
'// MessageText:
'//
'// The functional level of the domain (or forest) cannot be raised to the requested value, because there exist one or more domain controllers in the domain (or forest) that are at a lower incompatible functional level.
'//
%ERROR_DS_LOW_DSA_VERSION         = 8568&

'//
'// MessageId: ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN
'//
'// MessageText:
'//
'// The forest functional level cannot be raised to the requested value since one or more domains are still in mixed domain mode. All domains in the forest must be in native mode, for you to raise the forest functional level.
'//
%ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN = 8569&

'//
'// MessageId: ERROR_DS_NOT_SUPPORTED_SORT_ORDER
'//
'// MessageText:
'//
'// The sort order requested is not supported.
'//
%ERROR_DS_NOT_SUPPORTED_SORT_ORDER = 8570&

'//
'// MessageId: ERROR_DS_NAME_NOT_UNIQUE
'//
'// MessageText:
'//
'// The requested name already exists as a unique identifier.
'//
%ERROR_DS_NAME_NOT_UNIQUE         = 8571&

'//
'// MessageId: ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4
'//
'// MessageText:
'//
'// The machine account was created pre-NT4. The account needs to be recreated.
'//
%ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4 = 8572&

'//
'// MessageId: ERROR_DS_OUT_OF_VERSION_STORE
'//
'// MessageText:
'//
'// The database is out of version store.
'//
%ERROR_DS_OUT_OF_VERSION_STORE    = 8573&

'//
'// MessageId: ERROR_DS_INCOMPATIBLE_CONTROLS_USED
'//
'// MessageText:
'//
'// Unable to continue operation because multiple conflicting controls were used.
'//
%ERROR_DS_INCOMPATIBLE_CONTROLS_USED = 8574&

'//
'// MessageId: ERROR_DS_NO_REF_DOMAIN
'//
'// MessageText:
'//
'// Unable to find a valid security descriptor reference domain for this partition.
'//
%ERROR_DS_NO_REF_DOMAIN           = 8575&

'//
'// MessageId: ERROR_DS_RESERVED_LINK_ID
'//
'// MessageText:
'//
'// Schema update failed: The link identifier is reserved.
'//
%ERROR_DS_RESERVED_LINK_ID        = 8576&

'//
'// MessageId: ERROR_DS_LINK_ID_NOT_AVAILABLE
'//
'// MessageText:
'//
'// Schema update failed: There are no link identifiers available.
'//
%ERROR_DS_LINK_ID_NOT_AVAILABLE   = 8577&

'//
'// MessageId: ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER
'//
'// MessageText:
'//
'// An account group cannot have a universal group as a member.
'//
%ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER = 8578&

'//
'// MessageId: ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE
'//
'// MessageText:
'//
'// Rename or move operations on naming context heads or read-only objects are not allowed.
'//
%ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE = 8579&

'//
'// MessageId: ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC
'//
'// MessageText:
'//
'// Move operations on objects in the schema naming context are not allowed.
'//
%ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC = 8580&

'//
'// MessageId: ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG
'//
'// MessageText:
'//
'// A system flag has been set on the object and does not allow the object to be moved or renamed.
'//
%ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG = 8581&

'//
'// MessageId: ERROR_DS_MODIFYDN_WRONG_GRANDPARENT
'//
'// MessageText:
'//
'// This object is not allowed to change its grandparent container. Moves are not forbidden on this object, but are restricted to sibling containers.
'//
%ERROR_DS_MODIFYDN_WRONG_GRANDPARENT = 8582&

'//
'// MessageId: ERROR_DS_NAME_ERROR_TRUST_REFERRAL
'//
'// MessageText:
'//
'// Unable to resolve completely, a referral to another forest is generated.
'//
%ERROR_DS_NAME_ERROR_TRUST_REFERRAL = 8583&

'//
'// MessageId: ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER
'//
'// MessageText:
'//
'// The requested action is not supported on standard server.
'//
%ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER = 8584&

'//
'// MessageId: ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD
'//
'// MessageText:
'//
'// Could not access a partition of the directory service located on a remote server. Make sure at least one server is running for the partition in question.
'//
%ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD = 8585&

'//
'// MessageId: ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2
'//
'// MessageText:
'//
'// The directory cannot validate the proposed naming context (or partition) name because it does not hold a replica nor can it contact a replica of the naming context above the proposed naming context. Please ensure that the parent naming
'// context is properly registered in DNS, and at least one replica of this naming context is reachable by the Domain Naming master.
'//
%ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2 = 8586&

'//
'// MessageId: ERROR_DS_THREAD_LIMIT_EXCEEDED
'//
'// MessageText:
'//
'// The thread limit for this request was exceeded.
'//
%ERROR_DS_THREAD_LIMIT_EXCEEDED   = 8587&

'//
'// MessageId: ERROR_DS_NOT_CLOSEST
'//
'// MessageText:
'//
'// The Global catalog server is not in the closest site.
'//
%ERROR_DS_NOT_CLOSEST             = 8588&

'//
'// MessageId: ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF
'//
'// MessageText:
'//
'// The DS cannot derive a service principal name (SPN) with which to mutually authenticate the target server because the corresponding server object in the local DS database has no serverReference attribute.
'//
%ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF = 8589&

'//
'// MessageId: ERROR_DS_SINGLE_USER_MODE_FAILED
'//
'// MessageText:
'//
'// The Directory Service failed to enter single user mode.
'//
%ERROR_DS_SINGLE_USER_MODE_FAILED = 8590&

'//
'// MessageId: ERROR_DS_NTDSCRIPT_SYNTAX_ERROR
'//
'// MessageText:
'//
'// The Directory Service cannot parse the script because of a syntax error.
'//
%ERROR_DS_NTDSCRIPT_SYNTAX_ERROR = 8591&

'//
'// MessageId: ERROR_DS_NTDSCRIPT_PROCESS_ERROR
'//
'// MessageText:
'//
'// The Directory Service cannot process the script because of an error.
'//
%ERROR_DS_NTDSCRIPT_PROCESS_ERROR = 8592&

'//
'// MessageId: ERROR_DS_DIFFERENT_REPL_EPOCHS
'//
'// MessageText:
'//
'// The directory service cannot perform the requested operation because the servers
'// involved are of different replication epochs (which is usually related to a
'// domain rename that is in progress).
'//
%ERROR_DS_DIFFERENT_REPL_EPOCHS   = 8593&

'//
'// MessageId: ERROR_DS_DRS_EXTENSIONS_CHANGED
'//
'// MessageText:
'//
'// The directory service binding must be renegotiated due to a change in the server
'// extensions information.
'//
%ERROR_DS_DRS_EXTENSIONS_CHANGED = 8594&

'//
'// MessageId: ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR
'//
'// MessageText:
'//
'// Operation not allowed on a disabled cross ref.
'//
%ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR = 8595&

'//
'// MessageId: ERROR_DS_NO_MSDS_INTID
'//
'// MessageText:
'//
'// Schema update failed: No values for msDS-IntId are available.
'//
%ERROR_DS_NO_MSDS_INTID           = 8596&

'//
'// MessageId: ERROR_DS_DUP_MSDS_INTID
'//
'// MessageText:
'//
'// Schema update failed: Duplicate msDS-INtId. Retry the operation.
'//
%ERROR_DS_DUP_MSDS_INTID          = 8597&

'//
'// MessageId: ERROR_DS_EXISTS_IN_RDNATTID
'//
'// MessageText:
'//
'// Schema deletion failed: attribute is used in rDNAttID.
'//
%ERROR_DS_EXISTS_IN_RDNATTID      = 8598&

'//
'// MessageId: ERROR_DS_AUTHORIZATION_FAILED
'//
'// MessageText:
'//
'// The directory service failed to authorize the request.
'//
%ERROR_DS_AUTHORIZATION_FAILED    = 8599&

'//
'// MessageId: ERROR_DS_INVALID_SCRIPT
'//
'// MessageText:
'//
'// The Directory Service cannot process the script because it is invalid.
'//
%ERROR_DS_INVALID_SCRIPT          = 8600&

'//
'// MessageId: ERROR_DS_REMOTE_CROSSREF_OP_FAILED
'//
'// MessageText:
'//
'// The remote create cross reference operation failed on the Domain Naming Master FSMO. The operation's error is in the extended data.
'//
%ERROR_DS_REMOTE_CROSSREF_OP_FAILED = 8601&

'//
'// MessageId: ERROR_DS_CROSS_REF_BUSY
'//
'// MessageText:
'//
'// A cross reference is in use locally with the same name.
'//
%ERROR_DS_CROSS_REF_BUSY          = 8602&

'//
'// MessageId: ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN
'//
'// MessageText:
'//
'// The DS cannot derive a service principal name (SPN) with which to mutually authenticate the target server because the server's domain has been deleted from the forest.
'//
%ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN = 8603&

'//
'// MessageId: ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC
'//
'// MessageText:
'//
'// Writeable NCs prevent this DC from demoting.
'//
%ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC = 8604&

'//
'// MessageId: ERROR_DS_DUPLICATE_ID_FOUND
'//
'// MessageText:
'//
'// The requested object has a non-unique identifier and cannot be retrieved.
'//
%ERROR_DS_DUPLICATE_ID_FOUND      = 8605&

'//
'// MessageId: ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT
'//
'// MessageText:
'//
'// Insufficient attributes were given to create an object. This object may not exist because it may have been deleted and already garbage collected.
'//
%ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT = 8606&

'//
'// MessageId: ERROR_DS_GROUP_CONVERSION_ERROR
'//
'// MessageText:
'//
'// The group cannot be converted due to attribute restrictions on the requested group type.
'//
%ERROR_DS_GROUP_CONVERSION_ERROR = 8607&

'//
'// MessageId: ERROR_DS_CANT_MOVE_APP_BASIC_GROUP
'//
'// MessageText:
'//
'// Cross-domain move of non-empty basic application groups is not allowed.
'//
%ERROR_DS_CANT_MOVE_APP_BASIC_GROUP = 8608&

'//
'// MessageId: ERROR_DS_CANT_MOVE_APP_QUERY_GROUP
'//
'// MessageText:
'//
'// Cross-domain move of non-empty query based application groups is not allowed.
'//
%ERROR_DS_CANT_MOVE_APP_QUERY_GROUP = 8609&

'//
'// MessageId: ERROR_DS_ROLE_NOT_VERIFIED
'//
'// MessageText:
'//
'// The FSMO role ownership could not be verified because its directory partition has not replicated successfully with atleast one replication partner.
'//
%ERROR_DS_ROLE_NOT_VERIFIED       = 8610&

'//
'// MessageId: ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL
'//
'// MessageText:
'//
'// The target container for a redirection of a well known object container cannot already be a special container.
'//
%ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL = 8611&

'//
'// MessageId: ERROR_DS_DOMAIN_RENAME_IN_PROGRESS
'//
'// MessageText:
'//
'// The Directory Service cannot perform the requested operation because a domain rename operation is in progress.
'//
%ERROR_DS_DOMAIN_RENAME_IN_PROGRESS = 8612&

'//
'// MessageId: ERROR_DS_EXISTING_AD_CHILD_NC
'//
'// MessageText:
'//
'// The directory service detected a child partition below the requested partition name. The partition hierarchy must be created in a top down method.
'//
%ERROR_DS_EXISTING_AD_CHILD_NC    = 8613&

'//
'// MessageId: ERROR_DS_REPL_LIFETIME_EXCEEDED
'//
'// MessageText:
'//
'// The directory service cannot replicate with this server because the time since the last replication with this server has exceeded the tombstone lifetime.
'//
%ERROR_DS_REPL_LIFETIME_EXCEEDED = 8614&

'//
'// MessageId: ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER
'//
'// MessageText:
'//
'// The requested operation is not allowed on an object under the system container.
'//
%ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER = 8615&

'//
'// MessageId: ERROR_DS_LDAP_SEND_QUEUE_FULL
'//
'// MessageText:
'//
'// The LDAP servers network send queue has filled up because the client is not processing the results of it's requests fast enough. No more requests will be processed until the client catches up. 
'// If the client does not catch up then it will be disconnected.
'//
%ERROR_DS_LDAP_SEND_QUEUE_FULL    = 8616&

'//
'// MessageId: ERROR_DS_DRA_OUT_SCHEDULE_WINDOW
'//
'// MessageText:
'//
'// The scheduled replication did not take place because the system was too busy to execute the request within the schedule window. The replication queue is overloaded. Consider reducing the number
'// of partners or decreasing the scheduled replication frequency.
'//
%ERROR_DS_DRA_OUT_SCHEDULE_WINDOW = 8617&

'//
'// MessageId: ERROR_DS_POLICY_NOT_KNOWN
'//
'// MessageText:
'//
'// At this time, it cannot be determined if the branch replication policy is available on the hub domain controller. Please retry at a later time to account for replication latencies.
'//
%ERROR_DS_POLICY_NOT_KNOWN        = 8618&

'//
'// MessageId: ERROR_NO_SITE_SETTINGS_OBJECT
'//
'// MessageText:
'//
'// The site settings object for the specified site does not exist.
'//
%ERROR_NO_SITE_SETTINGS_OBJECT    = 8619&

'//
'// MessageId: ERROR_NO_SECRETS
'//
'// MessageText:
'//
'// The local account store does not contain secret material for the specified account.
'//
%ERROR_NO_SECRETS                 = 8620&

'//
'// MessageId: ERROR_NO_WRITABLE_DC_FOUND
'//
'// MessageText:
'//
'// Could not find a writable domain controller in the domain.
'//
%ERROR_NO_WRITABLE_DC_FOUND       = 8621&

'//
'// MessageId: ERROR_DS_NO_SERVER_OBJECT
'//
'// MessageText:
'//
'// The server object for the domain controller does not exist.
'//
%ERROR_DS_NO_SERVER_OBJECT        = 8622&

'//
'// MessageId: ERROR_DS_NO_NTDSA_OBJECT
'//
'// MessageText:
'//
'// The NTDS Settings object for the domain controller does not exist.
'//
%ERROR_DS_NO_NTDSA_OBJECT         = 8623&

'//
'// MessageId: ERROR_DS_NON_ASQ_SEARCH
'//
'// MessageText:
'//
'// The requested search operation is not supported for ASQ searches.
'//
%ERROR_DS_NON_ASQ_SEARCH          = 8624&

'//
'// MessageId: ERROR_DS_AUDIT_FAILURE
'//
'// MessageText:
'//
'// A required audit event could not be generated for the operation.
'//
%ERROR_DS_AUDIT_FAILURE           = 8625&

'//
'// MessageId: ERROR_DS_INVALID_SEARCH_FLAG_SUBTREE
'//
'// MessageText:
'//
'// The search flags for the attribute are invalid. The subtree index bit is valid only on single valued attributes.
'//
%ERROR_DS_INVALID_SEARCH_FLAG_SUBTREE = 8626&

'//
'// MessageId: ERROR_DS_INVALID_SEARCH_FLAG_TUPLE
'//
'// MessageText:
'//
'// The search flags for the attribute are invalid. The tuple index bit is valid only on attributes of Unicode strings.
'//
%ERROR_DS_INVALID_SEARCH_FLAG_TUPLE = 8627&

'//
'// MessageId: ERROR_DS_HIERARCHY_TABLE_TOO_DEEP
'//
'// MessageText:
'//
'// The address books are nested too deeply. Failed to build the hierarchy table.
'//
%ERROR_DS_HIERARCHY_TABLE_TOO_DEEP = 8628&


'///////////////////////////////////////////////////
'//                                               //
'//        End of Active Directory Error Codes    //
'//                                               //
'//                  = 8000 to  8999              //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//               DNS Error codes                 //
'//                                               //
'//                 = 9000 to 9999                //
'///////////////////////////////////////////////////

'// = ============================
'// Facility DNS Error Messages
'// = ============================

'//
'//  DNS response codes.
'//

%DNS_ERROR_RESPONSE_CODES_BASE = 9000

%DNS_ERROR_RCODE_NO_ERROR = %NO_ERROR

%DNS_ERROR_MASK = &H00002328 '// 9000 or DNS_ERROR_RESPONSE_CODES_BASE

'// DNS_ERROR_RCODE_FORMAT_ERROR          0x00002329
'//
'// MessageId: DNS_ERROR_RCODE_FORMAT_ERROR
'//
'// MessageText:
'//
'// DNS server unable to interpret format.
'//
%DNS_ERROR_RCODE_FORMAT_ERROR     = 9001&

'// DNS_ERROR_RCODE_SERVER_FAILURE        0x0000232a
'//
'// MessageId: DNS_ERROR_RCODE_SERVER_FAILURE
'//
'// MessageText:
'//
'// DNS server failure.
'//
%DNS_ERROR_RCODE_SERVER_FAILURE   = 9002&

'// DNS_ERROR_RCODE_NAME_ERROR            0x0000232b
'//
'// MessageId: DNS_ERROR_RCODE_NAME_ERROR
'//
'// MessageText:
'//
'// DNS name does not exist.
'//
%DNS_ERROR_RCODE_NAME_ERROR       = 9003&

'// DNS_ERROR_RCODE_NOT_IMPLEMENTED       0x0000232c
'//
'// MessageId: DNS_ERROR_RCODE_NOT_IMPLEMENTED
'//
'// MessageText:
'//
'// DNS request not supported by name server.
'//
%DNS_ERROR_RCODE_NOT_IMPLEMENTED = 9004&

'// DNS_ERROR_RCODE_REFUSED               0x0000232d
'//
'// MessageId: DNS_ERROR_RCODE_REFUSED
'//
'// MessageText:
'//
'// DNS operation refused.
'//
%DNS_ERROR_RCODE_REFUSED          = 9005&

'// DNS_ERROR_RCODE_YXDOMAIN              0x0000232e
'//
'// MessageId: DNS_ERROR_RCODE_YXDOMAIN
'//
'// MessageText:
'//
'// DNS name that ought not exist, does exist.
'//
%DNS_ERROR_RCODE_YXDOMAIN         = 9006&

'// DNS_ERROR_RCODE_YXRRSET               0x0000232f
'//
'// MessageId: DNS_ERROR_RCODE_YXRRSET
'//
'// MessageText:
'//
'// DNS RR set that ought not exist, does exist.
'//
%DNS_ERROR_RCODE_YXRRSET          = 9007&

'// DNS_ERROR_RCODE_NXRRSET               0x00002330
'//
'// MessageId: DNS_ERROR_RCODE_NXRRSET
'//
'// MessageText:
'//
'// DNS RR set that ought to exist, does not exist.
'//
%DNS_ERROR_RCODE_NXRRSET          = 9008&

'// DNS_ERROR_RCODE_NOTAUTH               0x00002331
'//
'// MessageId: DNS_ERROR_RCODE_NOTAUTH
'//
'// MessageText:
'//
'// DNS server not authoritative for zone.
'//
%DNS_ERROR_RCODE_NOTAUTH          = 9009&

'// DNS_ERROR_RCODE_NOTZONE               0x00002332
'//
'// MessageId: DNS_ERROR_RCODE_NOTZONE
'//
'// MessageText:
'//
'// DNS name in update or prereq is not in zone.
'//
%DNS_ERROR_RCODE_NOTZONE          = 9010&

'// DNS_ERROR_RCODE_BADSIG                0x00002338
'//
'// MessageId: DNS_ERROR_RCODE_BADSIG
'//
'// MessageText:
'//
'// DNS signature failed to verify.
'//
%DNS_ERROR_RCODE_BADSIG           = 9016&

'// DNS_ERROR_RCODE_BADKEY                0x00002339
'//
'// MessageId: DNS_ERROR_RCODE_BADKEY
'//
'// MessageText:
'//
'// DNS bad key.
'//
%DNS_ERROR_RCODE_BADKEY           = 9017&

'// DNS_ERROR_RCODE_BADTIME               0x0000233a
'//
'// MessageId: DNS_ERROR_RCODE_BADTIME
'//
'// MessageText:
'//
'// DNS signature validity expired.
'//
%DNS_ERROR_RCODE_BADTIME          = 9018&

%DNS_ERROR_RCODE_LAST = %DNS_ERROR_RCODE_BADTIME


'//
'//  Packet format
'//

%DNS_ERROR_PACKET_FMT_BASE = 9500

'// DNS_INFO_NO_RECORDS                   0x0000251d
'//
'// MessageId: DNS_INFO_NO_RECORDS
'//
'// MessageText:
'//
'// No records found for given DNS query.
'//
%DNS_INFO_NO_RECORDS              = 9501&

'// DNS_ERROR_BAD_PACKET                  0x0000251e
'//
'// MessageId: DNS_ERROR_BAD_PACKET
'//
'// MessageText:
'//
'// Bad DNS packet.
'//
%DNS_ERROR_BAD_PACKET             = 9502&

'// DNS_ERROR_NO_PACKET                   0x0000251f
'//
'// MessageId: DNS_ERROR_NO_PACKET
'//
'// MessageText:
'//
'// No DNS packet.
'//
%DNS_ERROR_NO_PACKET              = 9503&

'// DNS_ERROR_RCODE                       0x00002520
'//
'// MessageId: DNS_ERROR_RCODE
'//
'// MessageText:
'//
'// DNS error, check rcode.
'//
%DNS_ERROR_RCODE                  = 9504&

'// DNS_ERROR_UNSECURE_PACKET             0x00002521
'//
'// MessageId: DNS_ERROR_UNSECURE_PACKET
'//
'// MessageText:
'//
'// Unsecured DNS packet.
'//
%DNS_ERROR_UNSECURE_PACKET        = 9505&

%DNS_STATUS_PACKET_UNSECURE = %DNS_ERROR_UNSECURE_PACKET


'//
'//  General API errors
'//

%DNS_ERROR_NO_MEMORY            = %ERROR_OUTOFMEMORY
%DNS_ERROR_INVALID_NAME         = %ERROR_INVALID_NAME
%DNS_ERROR_INVALID_DATA         = %ERROR_INVALID_DATA

%DNS_ERROR_GENERAL_API_BASE = 9550

'// DNS_ERROR_INVALID_TYPE                0x0000254f
'//
'// MessageId: DNS_ERROR_INVALID_TYPE
'//
'// MessageText:
'//
'// Invalid DNS type.
'//
%DNS_ERROR_INVALID_TYPE           = 9551&

'// DNS_ERROR_INVALID_IP_ADDRESS          0x00002550
'//
'// MessageId: DNS_ERROR_INVALID_IP_ADDRESS
'//
'// MessageText:
'//
'// Invalid IP address.
'//
%DNS_ERROR_INVALID_IP_ADDRESS     = 9552&

'// DNS_ERROR_INVALID_PROPERTY            0x00002551
'//
'// MessageId: DNS_ERROR_INVALID_PROPERTY
'//
'// MessageText:
'//
'// Invalid property.
'//
%DNS_ERROR_INVALID_PROPERTY       = 9553&

'// DNS_ERROR_TRY_AGAIN_LATER             0x00002552
'//
'// MessageId: DNS_ERROR_TRY_AGAIN_LATER
'//
'// MessageText:
'//
'// Try DNS operation again later.
'//
%DNS_ERROR_TRY_AGAIN_LATER        = 9554&

'// DNS_ERROR_NOT_UNIQUE                  0x00002553
'//
'// MessageId: DNS_ERROR_NOT_UNIQUE
'//
'// MessageText:
'//
'// Record for given name and type is not unique.
'//
%DNS_ERROR_NOT_UNIQUE             = 9555&

'// DNS_ERROR_NON_RFC_NAME                0x00002554
'//
'// MessageId: DNS_ERROR_NON_RFC_NAME
'//
'// MessageText:
'//
'// DNS name does not comply with RFC specifications.
'//
%DNS_ERROR_NON_RFC_NAME           = 9556&

'// DNS_STATUS_FQDN                       0x00002555
'//
'// MessageId: DNS_STATUS_FQDN
'//
'// MessageText:
'//
'// DNS name is a fully-qualified DNS name.
'//
%DNS_STATUS_FQDN                  = 9557&

'// DNS_STATUS_DOTTED_NAME                0x00002556
'//
'// MessageId: DNS_STATUS_DOTTED_NAME
'//
'// MessageText:
'//
'// DNS name is dotted (multi-labe&.
'//
%DNS_STATUS_DOTTED_NAME           = 9558&

'// DNS_STATUS_SINGLE_PART_NAME           0x00002557
'//
'// MessageId: DNS_STATUS_SINGLE_PART_NAME
'//
'// MessageText:
'//
'// DNS name is a single-part name.
'//
%DNS_STATUS_SINGLE_PART_NAME      = 9559&

'// DNS_ERROR_INVALID_NAME_CHAR           0x00002558
'//
'// MessageId: DNS_ERROR_INVALID_NAME_CHAR
'//
'// MessageText:
'//
'// DNS name contains an invalid character.
'//
%DNS_ERROR_INVALID_NAME_CHAR      = 9560&

'// DNS_ERROR_NUMERIC_NAME                0x00002559
'//
'// MessageId: DNS_ERROR_NUMERIC_NAME
'//
'// MessageText:
'//
'// DNS name is entirely numeric.
'//
%DNS_ERROR_NUMERIC_NAME           = 9561&

'// DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER  0x0000255A
'//
'// MessageId: DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER
'//
'// MessageText:
'//
'// The operation requested is not permitted on a DNS root server.
'//
%DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER = 9562&

'// DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION  0x0000255B
'//
'// MessageId: DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION
'//
'// MessageText:
'//
'// The record could not be created because this part of the DNS namespace has been delegated to another server.
'//
%DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION = 9563&

'// DNS_ERROR_CANNOT_FIND_ROOT_HINTS  0x0000255C
'//
'// MessageId: DNS_ERROR_CANNOT_FIND_ROOT_HINTS
'//
'// MessageText:
'//
'// The DNS server could not find a set of root hints.
'//
%DNS_ERROR_CANNOT_FIND_ROOT_HINTS = 9564&

'// DNS_ERROR_INCONSISTENT_ROOT_HINTS  0x0000255D
'//
'// MessageId: DNS_ERROR_INCONSISTENT_ROOT_HINTS
'//
'// MessageText:
'//
'// The DNS server found root hints but they were not consistent across all adapters.
'//
%DNS_ERROR_INCONSISTENT_ROOT_HINTS = 9565&

'// DNS_ERROR_DWORD_VALUE_TOO_SMALL    0x0000255E
'//
'// MessageId: DNS_ERROR_DWORD_VALUE_TOO_SMALL
'//
'// MessageText:
'//
'// The specified value is too small for this parameter.
'//
%DNS_ERROR_DWORD_VALUE_TOO_SMALL = 9566&

'// DNS_ERROR_DWORD_VALUE_TOO_LARGE    0x0000255F
'//
'// MessageId: DNS_ERROR_DWORD_VALUE_TOO_LARGE
'//
'// MessageText:
'//
'// The specified value is too large for this parameter.
'//
%DNS_ERROR_DWORD_VALUE_TOO_LARGE = 9567&

'// DNS_ERROR_BACKGROUND_LOADING       0x00002560
'//
'// MessageId: DNS_ERROR_BACKGROUND_LOADING
'//
'// MessageText:
'//
'// This operation is not allowed while the DNS server is loading zones in the background. Please try again later.
'//
%DNS_ERROR_BACKGROUND_LOADING     = 9568&

'// DNS_ERROR_NOT_ALLOWED_ON_RODC      0x00002561
'//
'// MessageId: DNS_ERROR_NOT_ALLOWED_ON_RODC
'//
'// MessageText:
'//
'// The operation requested is not permitted on against a DNS server running on a read-only DC.
'//
%DNS_ERROR_NOT_ALLOWED_ON_RODC    = 9569&

'// DNS_ERROR_NOT_ALLOWED_UNDER_DNAME   0x00002562
'//
'// MessageId: DNS_ERROR_NOT_ALLOWED_UNDER_DNAME
'//
'// MessageText:
'//
'// No data is allowed to exist underneath a DNAME record.
'//
%DNS_ERROR_NOT_ALLOWED_UNDER_DNAME = 9570&


'//
'//  Zone errors
'//

%DNS_ERROR_ZONE_BASE = 9600

'// DNS_ERROR_ZONE_DOES_NOT_EXIST         0x00002581
'//
'// MessageId: DNS_ERROR_ZONE_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// DNS zone does not exist.
'//
%DNS_ERROR_ZONE_DOES_NOT_EXIST    = 9601&

'// DNS_ERROR_NO_ZONE_INFO                0x00002582
'//
'// MessageId: DNS_ERROR_NO_ZONE_INFO
'//
'// MessageText:
'//
'// DNS zone information not available.
'//
%DNS_ERROR_NO_ZONE_INFO           = 9602&

'// DNS_ERROR_INVALID_ZONE_OPERATION      0x00002583
'//
'// MessageId: DNS_ERROR_INVALID_ZONE_OPERATION
'//
'// MessageText:
'//
'// Invalid operation for DNS zone.
'//
%DNS_ERROR_INVALID_ZONE_OPERATION = 9603&

'// DNS_ERROR_ZONE_CONFIGURATION_ERROR    0x00002584
'//
'// MessageId: DNS_ERROR_ZONE_CONFIGURATION_ERROR
'//
'// MessageText:
'//
'// Invalid DNS zone configuration.
'//
%DNS_ERROR_ZONE_CONFIGURATION_ERROR = 9604&

'// DNS_ERROR_ZONE_HAS_NO_SOA_RECORD      0x00002585
'//
'// MessageId: DNS_ERROR_ZONE_HAS_NO_SOA_RECORD
'//
'// MessageText:
'//
'// DNS zone has no start of authority (SOA) record.
'//
%DNS_ERROR_ZONE_HAS_NO_SOA_RECORD = 9605&

'// DNS_ERROR_ZONE_HAS_NO_NS_RECORDS      0x00002586
'//
'// MessageId: DNS_ERROR_ZONE_HAS_NO_NS_RECORDS
'//
'// MessageText:
'//
'// DNS zone has no Name Server (NS) record.
'//
%DNS_ERROR_ZONE_HAS_NO_NS_RECORDS = 9606&

'// DNS_ERROR_ZONE_LOCKED                 0x00002587
'//
'// MessageId: DNS_ERROR_ZONE_LOCKED
'//
'// MessageText:
'//
'// DNS zone is locked.
'//
%DNS_ERROR_ZONE_LOCKED            = 9607&

'// DNS_ERROR_ZONE_CREATION_FAILED        0x00002588
'//
'// MessageId: DNS_ERROR_ZONE_CREATION_FAILED
'//
'// MessageText:
'//
'// DNS zone creation failed.
'//
%DNS_ERROR_ZONE_CREATION_FAILED   = 9608&

'// DNS_ERROR_ZONE_ALREADY_EXISTS         0x00002589
'//
'// MessageId: DNS_ERROR_ZONE_ALREADY_EXISTS
'//
'// MessageText:
'//
'// DNS zone already exists.
'//
%DNS_ERROR_ZONE_ALREADY_EXISTS    = 9609&

'// DNS_ERROR_AUTOZONE_ALREADY_EXISTS     0x0000258a
'//
'// MessageId: DNS_ERROR_AUTOZONE_ALREADY_EXISTS
'//
'// MessageText:
'//
'// DNS automatic zone already exists.
'//
%DNS_ERROR_AUTOZONE_ALREADY_EXISTS = 9610&

'// DNS_ERROR_INVALID_ZONE_TYPE           0x0000258b
'//
'// MessageId: DNS_ERROR_INVALID_ZONE_TYPE
'//
'// MessageText:
'//
'// Invalid DNS zone type.
'//
%DNS_ERROR_INVALID_ZONE_TYPE      = 9611&

'// DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP 0x0000258c
'//
'// MessageId: DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP
'//
'// MessageText:
'//
'// Secondary DNS zone requires master IP address.
'//
%DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP = 9612&

'// DNS_ERROR_ZONE_NOT_SECONDARY          0x0000258d
'//
'// MessageId: DNS_ERROR_ZONE_NOT_SECONDARY
'//
'// MessageText:
'//
'// DNS zone not secondary.
'//
%DNS_ERROR_ZONE_NOT_SECONDARY     = 9613&

'// DNS_ERROR_NEED_SECONDARY_ADDRESSES    0x0000258e
'//
'// MessageId: DNS_ERROR_NEED_SECONDARY_ADDRESSES
'//
'// MessageText:
'//
'// Need secondary IP address.
'//
%DNS_ERROR_NEED_SECONDARY_ADDRESSES = 9614&

'// DNS_ERROR_WINS_INIT_FAILED            0x0000258f
'//
'// MessageId: DNS_ERROR_WINS_INIT_FAILED
'//
'// MessageText:
'//
'// WINS initialization failed.
'//
%DNS_ERROR_WINS_INIT_FAILED       = 9615&

'// DNS_ERROR_NEED_WINS_SERVERS           0x00002590
'//
'// MessageId: DNS_ERROR_NEED_WINS_SERVERS
'//
'// MessageText:
'//
'// Need WINS servers.
'//
%DNS_ERROR_NEED_WINS_SERVERS      = 9616&

'// DNS_ERROR_NBSTAT_INIT_FAILED          0x00002591
'//
'// MessageId: DNS_ERROR_NBSTAT_INIT_FAILED
'//
'// MessageText:
'//
'// NBTSTAT initialization call failed.
'//
%DNS_ERROR_NBSTAT_INIT_FAILED     = 9617&

'// DNS_ERROR_SOA_DELETE_INVALID          0x00002592
'//
'// MessageId: DNS_ERROR_SOA_DELETE_INVALID
'//
'// MessageText:
'//
'// Invalid delete of start of authority (SOA)
'//
%DNS_ERROR_SOA_DELETE_INVALID     = 9618&

'// DNS_ERROR_FORWARDER_ALREADY_EXISTS    0x00002593
'//
'// MessageId: DNS_ERROR_FORWARDER_ALREADY_EXISTS
'//
'// MessageText:
'//
'// A conditional forwarding zone already exists for that name.
'//
%DNS_ERROR_FORWARDER_ALREADY_EXISTS = 9619&

'// DNS_ERROR_ZONE_REQUIRES_MASTER_IP     0x00002594
'//
'// MessageId: DNS_ERROR_ZONE_REQUIRES_MASTER_IP
'//
'// MessageText:
'//
'// This zone must be configured with one or more master DNS server IP addresses.
'//
%DNS_ERROR_ZONE_REQUIRES_MASTER_IP = 9620&

'// DNS_ERROR_ZONE_IS_SHUTDOWN            0x00002595
'//
'// MessageId: DNS_ERROR_ZONE_IS_SHUTDOWN
'//
'// MessageText:
'//
'// The operation cannot be performed because this zone is shutdown.
'//
%DNS_ERROR_ZONE_IS_SHUTDOWN       = 9621&


'//
'//  Datafile errors
'//

%DNS_ERROR_DATAFILE_BASE = 9650

'// DNS                                   0x000025b3
'//
'// MessageId: DNS_ERROR_PRIMARY_REQUIRES_DATAFILE
'//
'// MessageText:
'//
'// Primary DNS zone requires datafile.
'//
%DNS_ERROR_PRIMARY_REQUIRES_DATAFILE = 9651&

'// DNS                                   0x000025b4
'//
'// MessageId: DNS_ERROR_INVALID_DATAFILE_NAME
'//
'// MessageText:
'//
'// Invalid datafile name for DNS zone.
'//
%DNS_ERROR_INVALID_DATAFILE_NAME = 9652&

'// DNS                                   0x000025b5
'//
'// MessageId: DNS_ERROR_DATAFILE_OPEN_FAILURE
'//
'// MessageText:
'//
'// Failed to open datafile for DNS zone.
'//
%DNS_ERROR_DATAFILE_OPEN_FAILURE = 9653&

'// DNS                                   0x000025b6
'//
'// MessageId: DNS_ERROR_FILE_WRITEBACK_FAILED
'//
'// MessageText:
'//
'// Failed to write datafile for DNS zone.
'//
%DNS_ERROR_FILE_WRITEBACK_FAILED = 9654&

'// DNS                                   0x000025b7
'//
'// MessageId: DNS_ERROR_DATAFILE_PARSING
'//
'// MessageText:
'//
'// Failure while reading datafile for DNS zone.
'//
%DNS_ERROR_DATAFILE_PARSING       = 9655&


'//
'//  Database errors
'//

%DNS_ERROR_DATABASE_BASE = 9700

'// DNS_ERROR_RECORD_DOES_NOT_EXIST       0x000025e5
'//
'// MessageId: DNS_ERROR_RECORD_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// DNS record does not exist.
'//
%DNS_ERROR_RECORD_DOES_NOT_EXIST = 9701&

'// DNS_ERROR_RECORD_FORMAT               0x000025e6
'//
'// MessageId: DNS_ERROR_RECORD_FORMAT
'//
'// MessageText:
'//
'// DNS record format error.
'//
%DNS_ERROR_RECORD_FORMAT          = 9702&

'// DNS_ERROR_NODE_CREATION_FAILED        0x000025e7
'//
'// MessageId: DNS_ERROR_NODE_CREATION_FAILED
'//
'// MessageText:
'//
'// Node creation failure in DNS.
'//
%DNS_ERROR_NODE_CREATION_FAILED   = 9703&

'// DNS_ERROR_UNKNOWN_RECORD_TYPE         0x000025e8
'//
'// MessageId: DNS_ERROR_UNKNOWN_RECORD_TYPE
'//
'// MessageText:
'//
'// Unknown DNS record type.
'//
%DNS_ERROR_UNKNOWN_RECORD_TYPE    = 9704&

'// DNS_ERROR_RECORD_TIMED_OUT            0x000025e9
'//
'// MessageId: DNS_ERROR_RECORD_TIMED_OUT
'//
'// MessageText:
'//
'// DNS record timed out.
'//
%DNS_ERROR_RECORD_TIMED_OUT       = 9705&

'// DNS_ERROR_NAME_NOT_IN_ZONE            0x000025ea
'//
'// MessageId: DNS_ERROR_NAME_NOT_IN_ZONE
'//
'// MessageText:
'//
'// Name not in DNS zone.
'//
%DNS_ERROR_NAME_NOT_IN_ZONE       = 9706&

'// DNS_ERROR_CNAME_LOOP                  0x000025eb
'//
'// MessageId: DNS_ERROR_CNAME_LOOP
'//
'// MessageText:
'//
'// CNAME loop detected.
'//
%DNS_ERROR_CNAME_LOOP             = 9707&

'// DNS_ERROR_NODE_IS_CNAME               0x000025ec
'//
'// MessageId: DNS_ERROR_NODE_IS_CNAME
'//
'// MessageText:
'//
'// Node is a CNAME DNS record.
'//
%DNS_ERROR_NODE_IS_CNAME          = 9708&

'// DNS_ERROR_CNAME_COLLISION             0x000025ed
'//
'// MessageId: DNS_ERROR_CNAME_COLLISION
'//
'// MessageText:
'//
'// A CNAME record already exists for given name.
'//
%DNS_ERROR_CNAME_COLLISION        = 9709&

'// DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT    0x000025ee
'//
'// MessageId: DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT
'//
'// MessageText:
'//
'// Record only at DNS zone root.
'//
%DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT = 9710&

'// DNS_ERROR_RECORD_ALREADY_EXISTS       0x000025ef
'//
'// MessageId: DNS_ERROR_RECORD_ALREADY_EXISTS
'//
'// MessageText:
'//
'// DNS record already exists.
'//
%DNS_ERROR_RECORD_ALREADY_EXISTS = 9711&

'// DNS_ERROR_SECONDARY_DATA              0x000025f0
'//
'// MessageId: DNS_ERROR_SECONDARY_DATA
'//
'// MessageText:
'//
'// Secondary DNS zone data error.
'//
%DNS_ERROR_SECONDARY_DATA         = 9712&

'// DNS_ERROR_NO_CREATE_CACHE_DATA        0x000025f1
'//
'// MessageId: DNS_ERROR_NO_CREATE_CACHE_DATA
'//
'// MessageText:
'//
'// Could not create DNS cache data.
'//
%DNS_ERROR_NO_CREATE_CACHE_DATA   = 9713&

'// DNS_ERROR_NAME_DOES_NOT_EXIST         0x000025f2
'//
'// MessageId: DNS_ERROR_NAME_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// DNS name does not exist.
'//
%DNS_ERROR_NAME_DOES_NOT_EXIST    = 9714&

'// DNS_WARNING_PTR_CREATE_FAILED         0x000025f3
'//
'// MessageId: DNS_WARNING_PTR_CREATE_FAILED
'//
'// MessageText:
'//
'// Could not create pointer (PTR) record.
'//
%DNS_WARNING_PTR_CREATE_FAILED    = 9715&

'// DNS_WARNING_DOMAIN_UNDELETED          0x000025f4
'//
'// MessageId: DNS_WARNING_DOMAIN_UNDELETED
'//
'// MessageText:
'//
'// DNS domain was undeleted.
'//
%DNS_WARNING_DOMAIN_UNDELETED     = 9716&

'// DNS_ERROR_DS_UNAVAILABLE              0x000025f5
'//
'// MessageId: DNS_ERROR_DS_UNAVAILABLE
'//
'// MessageText:
'//
'// The directory service is unavailable.
'//
%DNS_ERROR_DS_UNAVAILABLE         = 9717&

'// DNS_ERROR_DS_ZONE_ALREADY_EXISTS      0x000025f6
'//
'// MessageId: DNS_ERROR_DS_ZONE_ALREADY_EXISTS
'//
'// MessageText:
'//
'// DNS zone already exists in the directory service.
'//
%DNS_ERROR_DS_ZONE_ALREADY_EXISTS = 9718&

'// DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE      0x000025f7
'//
'// MessageId: DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE
'//
'// MessageText:
'//
'// DNS server not creating or reading the boot file for the directory service integrated DNS zone.
'//
%DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE = 9719&

'// DNS_ERROR_NODE_IS_DNAME               0x000025f8
'//
'// MessageId: DNS_ERROR_NODE_IS_DNAME
'//
'// MessageText:
'//
'// Node is a DNAME DNS record.
'//
%DNS_ERROR_NODE_IS_DNAME          = 9720&

'// DNS_ERROR_DNAME_COLLISION             0x000025f9
'//
'// MessageId: DNS_ERROR_DNAME_COLLISION
'//
'// MessageText:
'//
'// A DNAME record already exists for given name.
'//
%DNS_ERROR_DNAME_COLLISION        = 9721&

'// DNS_ERROR_ALIAS_LOOP                  0x000025fa
'//
'// MessageId: DNS_ERROR_ALIAS_LOOP
'//
'// MessageText:
'//
'// An alias loop has been detected with either CNAME or DNAME records.
'//
%DNS_ERROR_ALIAS_LOOP             = 9722&


'//
'//  Operation errors
'//

%DNS_ERROR_OPERATION_BASE = 9750

'// DNS_INFO_AXFR_COMPLETE                0x00002617
'//
'// MessageId: DNS_INFO_AXFR_COMPLETE
'//
'// MessageText:
'//
'// DNS AXFR (zone transfer) complete.
'//
%DNS_INFO_AXFR_COMPLETE           = 9751&

'// DNS_ERROR_AXFR                        0x00002618
'//
'// MessageId: DNS_ERROR_AXFR
'//
'// MessageText:
'//
'// DNS zone transfer failed.
'//
%DNS_ERROR_AXFR                   = 9752&

'// DNS_INFO_ADDED_LOCAL_WINS             0x00002619
'//
'// MessageId: DNS_INFO_ADDED_LOCAL_WINS
'//
'// MessageText:
'//
'// Added local WINS server.
'//
%DNS_INFO_ADDED_LOCAL_WINS        = 9753&


'//
'//  Secure update
'//

%DNS_ERROR_SECURE_BASE = 9800

'// DNS_STATUS_CONTINUE_NEEDED            0x00002649
'//
'// MessageId: DNS_STATUS_CONTINUE_NEEDED
'//
'// MessageText:
'//
'// Secure update call needs to continue update request.
'//
%DNS_STATUS_CONTINUE_NEEDED       = 9801&


'//
'//  Setup errors
'//

%DNS_ERROR_SETUP_BASE = 9850

'// DNS_ERROR_NO_TCPIP                    0x0000267b
'//
'// MessageId: DNS_ERROR_NO_TCPIP
'//
'// MessageText:
'//
'// TCP/IP network protocol not installed.
'//
%DNS_ERROR_NO_TCPIP               = 9851&

'// DNS_ERROR_NO_DNS_SERVERS              0x0000267c
'//
'// MessageId: DNS_ERROR_NO_DNS_SERVERS
'//
'// MessageText:
'//
'// No DNS servers configured for local system.
'//
%DNS_ERROR_NO_DNS_SERVERS         = 9852&


'//
'//  Directory partition (DP) errors
'//

%DNS_ERROR_DP_BASE = 9900

'// DNS_ERROR_DP_DOES_NOT_EXIST           0x000026ad
'//
'// MessageId: DNS_ERROR_DP_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// The specified directory partition does not exist.
'//
%DNS_ERROR_DP_DOES_NOT_EXIST      = 9901&

'// DNS_ERROR_DP_ALREADY_EXISTS           0x000026ae
'//
'// MessageId: DNS_ERROR_DP_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The specified directory partition already exists.
'//
%DNS_ERROR_DP_ALREADY_EXISTS      = 9902&

'// DNS_ERROR_DP_NOT_ENLISTED             0x000026af
'//
'// MessageId: DNS_ERROR_DP_NOT_ENLISTED
'//
'// MessageText:
'//
'// This DNS server is not enlisted in the specified directory partition.
'//
%DNS_ERROR_DP_NOT_ENLISTED        = 9903&

'// DNS_ERROR_DP_ALREADY_ENLISTED         0x000026b0
'//
'// MessageId: DNS_ERROR_DP_ALREADY_ENLISTED
'//
'// MessageText:
'//
'// This DNS server is already enlisted in the specified directory partition.
'//
%DNS_ERROR_DP_ALREADY_ENLISTED    = 9904&

'// DNS_ERROR_DP_NOT_AVAILABLE            0x000026b1
'//
'// MessageId: DNS_ERROR_DP_NOT_AVAILABLE
'//
'// MessageText:
'//
'// The directory partition is not available at this time. Please wait a few minutes and try again.
'//
%DNS_ERROR_DP_NOT_AVAILABLE       = 9905&

'// DNS_ERROR_DP_FSMO_ERROR               0x000026b2
'//
'// MessageId: DNS_ERROR_DP_FSMO_ERROR
'//
'// MessageText:
'//
'// The application directory partition operation failed. The domain controller holding the domain naming master role is down or unable to service the request or is not running Windows Server 2003.
'//
%DNS_ERROR_DP_FSMO_ERROR          = 9906&


'///////////////////////////////////////////////////
'//                                               //
'//             End of DNS Error Codes            //
'//                                               //
'//                  = 9000 to 9999               //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//               WinSock Error Codes             //
'//                                               //
'//                 = 10000 to 11999              //
'///////////////////////////////////////////////////

'//
'// WinSock error codes are also defined in WinSock.h
'// and WinSock2.h, hence the IFDEF
'//
#IF NOT %DEF(%WSABASEERR)
%WSABASEERR = 10000&
'//
'// MessageId: WSAEINTR
'//
'// MessageText:
'//
'// A blocking operation was interrupted by a call to WSACancelBlockingCall.
'//
%WSAEINTR                         = 10004&

'//
'// MessageId: WSAEBADF
'//
'// MessageText:
'//
'// The file handle supplied is not valid.
'//
%WSAEBADF                         = 10009&

'//
'// MessageId: WSAEACCES
'//
'// MessageText:
'//
'// An attempt was made to access a socket in a way forbidden by its access permissions.
'//
%WSAEACCES                        = 10013&

'//
'// MessageId: WSAEFAULT
'//
'// MessageText:
'//
'// The system detected an invalid pointer address in attempting to use a pointer argument in a call.
'//
%WSAEFAULT                        = 10014&

'//
'// MessageId: WSAEINVAL
'//
'// MessageText:
'//
'// An invalid argument was supplied.
'//
%WSAEINVAL                        = 10022&

'//
'// MessageId: WSAEMFILE
'//
'// MessageText:
'//
'// Too many open sockets.
'//
%WSAEMFILE                        = 10024&

'//
'// MessageId: WSAEWOULDBLOCK
'//
'// MessageText:
'//
'// A non-blocking socket operation could not be completed immediately.
'//
%WSAEWOULDBLOCK                   = 10035&

'//
'// MessageId: WSAEINPROGRESS
'//
'// MessageText:
'//
'// A blocking operation is currently executing.
'//
%WSAEINPROGRESS                   = 10036&

'//
'// MessageId: WSAEALREADY
'//
'// MessageText:
'//
'// An operation was attempted on a non-blocking socket that already had an operation in progress.
'//
%WSAEALREADY                      = 10037&

'//
'// MessageId: WSAENOTSOCK
'//
'// MessageText:
'//
'// An operation was attempted on something that is not a socket.
'//
%WSAENOTSOCK                      = 10038&

'//
'// MessageId: WSAEDESTADDRREQ
'//
'// MessageText:
'//
'// A required address was omitted from an operation on a socket.
'//
%WSAEDESTADDRREQ                  = 10039&

'//
'// MessageId: WSAEMSGSIZE
'//
'// MessageText:
'//
'// A message sent on a datagram socket was larger than the internal message buffer or some other network limit, or the buffer used to receive a datagram into was smaller than the datagram itself.
'//
%WSAEMSGSIZE                      = 10040&

'//
'// MessageId: WSAEPROTOTYPE
'//
'// MessageText:
'//
'// A protocol was specified in the socket function call that does not support the semantics of the socket type requested.
'//
%WSAEPROTOTYPE                    = 10041&

'//
'// MessageId: WSAENOPROTOOPT
'//
'// MessageText:
'//
'// An unknown, invalid, or unsupported option or level was specified in a getsockopt or setsockopt call.
'//
%WSAENOPROTOOPT                   = 10042&

'//
'// MessageId: WSAEPROTONOSUPPORT
'//
'// MessageText:
'//
'// The requested protocol has not been configured into the system, or no implementation for it exists.
'//
%WSAEPROTONOSUPPORT               = 10043&

'//
'// MessageId: WSAESOCKTNOSUPPORT
'//
'// MessageText:
'//
'// The support for the specified socket type does not exist in this address family.
'//
%WSAESOCKTNOSUPPORT               = 10044&

'//
'// MessageId: WSAEOPNOTSUPP
'//
'// MessageText:
'//
'// The attempted operation is not supported for the type of object referenced.
'//
%WSAEOPNOTSUPP                    = 10045&

'//
'// MessageId: WSAEPFNOSUPPORT
'//
'// MessageText:
'//
'// The protocol family has not been configured into the system or no implementation for it exists.
'//
%WSAEPFNOSUPPORT                  = 10046&

'//
'// MessageId: WSAEAFNOSUPPORT
'//
'// MessageText:
'//
'// An address incompatible with the requested protocol was used.
'//
%WSAEAFNOSUPPORT                  = 10047&

'//
'// MessageId: WSAEADDRINUSE
'//
'// MessageText:
'//
'// Only one usage of each socket address (protocol/network address/port) is normally permitted.
'//
%WSAEADDRINUSE                    = 10048&

'//
'// MessageId: WSAEADDRNOTAVAIL
'//
'// MessageText:
'//
'// The requested address is not valid in its context.
'//
%WSAEADDRNOTAVAIL                 = 10049&

'//
'// MessageId: WSAENETDOWN
'//
'// MessageText:
'//
'// A socket operation encountered a dead network.
'//
%WSAENETDOWN                      = 10050&

'//
'// MessageId: WSAENETUNREACH
'//
'// MessageText:
'//
'// A socket operation was attempted to an unreachable network.
'//
%WSAENETUNREACH                   = 10051&

'//
'// MessageId: WSAENETRESET
'//
'// MessageText:
'//
'// The connection has been broken due to keep-alive activity detecting a failure while the operation was in progress.
'//
%WSAENETRESET                     = 10052&

'//
'// MessageId: WSAECONNABORTED
'//
'// MessageText:
'//
'// An established connection was aborted by the software in your host machine.
'//
%WSAECONNABORTED                  = 10053&

'//
'// MessageId: WSAECONNRESET
'//
'// MessageText:
'//
'// An existing connection was forcibly closed by the remote host.
'//
%WSAECONNRESET                    = 10054&

'//
'// MessageId: WSAENOBUFS
'//
'// MessageText:
'//
'// An operation on a socket could not be performed because the system lacked sufficient buffer space or because a queue was full.
'//
%WSAENOBUFS                       = 10055&

'//
'// MessageId: WSAEISCONN
'//
'// MessageText:
'//
'// A connect request was made on an already connected socket.
'//
%WSAEISCONN                       = 10056&

'//
'// MessageId: WSAENOTCONN
'//
'// MessageText:
'//
'// A request to send or receive data was disallowed because the socket is not connected and (when sending on a datagram socket using a sendto cal& no address was supplied.
'//
%WSAENOTCONN                      = 10057&

'//
'// MessageId: WSAESHUTDOWN
'//
'// MessageText:
'//
'// A request to send or receive data was disallowed because the socket had already been shut down in that direction with a previous shutdown call.
'//
%WSAESHUTDOWN                     = 10058&

'//
'// MessageId: WSAETOOMANYREFS
'//
'// MessageText:
'//
'// Too many references to some kernel object.
'//
%WSAETOOMANYREFS                  = 10059&

'//
'// MessageId: WSAETIMEDOUT
'//
'// MessageText:
'//
'// A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond.
'//
%WSAETIMEDOUT                     = 10060&

'//
'// MessageId: WSAECONNREFUSED
'//
'// MessageText:
'//
'// No connection could be made because the target machine actively refused it.
'//
%WSAECONNREFUSED                  = 10061&

'//
'// MessageId: WSAELOOP
'//
'// MessageText:
'//
'// Cannot translate name.
'//
%WSAELOOP                         = 10062&

'//
'// MessageId: WSAENAMETOOLONG
'//
'// MessageText:
'//
'// Name component or name was too long.
'//
%WSAENAMETOOLONG                  = 10063&

'//
'// MessageId: WSAEHOSTDOWN
'//
'// MessageText:
'//
'// A socket operation failed because the destination host was down.
'//
%WSAEHOSTDOWN                     = 10064&

'//
'// MessageId: WSAEHOSTUNREACH
'//
'// MessageText:
'//
'// A socket operation was attempted to an unreachable host.
'//
%WSAEHOSTUNREACH                  = 10065&

'//
'// MessageId: WSAENOTEMPTY
'//
'// MessageText:
'//
'// Cannot remove a directory that is not empty.
'//
%WSAENOTEMPTY                     = 10066&

'//
'// MessageId: WSAEPROCLIM
'//
'// MessageText:
'//
'// A Windows Sockets implementation may have a limit on the number of applications that may use it simultaneously.
'//
%WSAEPROCLIM                      = 10067&

'//
'// MessageId: WSAEUSERS
'//
'// MessageText:
'//
'// Ran out of quota.
'//
%WSAEUSERS                        = 10068&

'//
'// MessageId: WSAEDQUOT
'//
'// MessageText:
'//
'// Ran out of disk quota.
'//
%WSAEDQUOT                        = 10069&

'//
'// MessageId: WSAESTALE
'//
'// MessageText:
'//
'// File handle reference is no longer available.
'//
%WSAESTALE                        = 10070&

'//
'// MessageId: WSAEREMOTE
'//
'// MessageText:
'//
'// Item is not available locally.
'//
%WSAEREMOTE                       = 10071&

'//
'// MessageId: WSASYSNOTREADY
'//
'// MessageText:
'//
'// WSAStartup cannot function at this time because the underlying system it uses to provide network services is currently unavailable.
'//
%WSASYSNOTREADY                   = 10091&

'//
'// MessageId: WSAVERNOTSUPPORTED
'//
'// MessageText:
'//
'// The Windows Sockets version requested is not supported.
'//
%WSAVERNOTSUPPORTED               = 10092&

'//
'// MessageId: WSANOTINITIALISED
'//
'// MessageText:
'//
'// Either the application has not called WSAStartup, or WSAStartup failed.
'//
%WSANOTINITIALISED                = 10093&

'//
'// MessageId: WSAEDISCON
'//
'// MessageText:
'//
'// Returned by WSARecv or WSARecvFrom to indicate the remote party has initiated a graceful shutdown sequence.
'//
%WSAEDISCON                       = 10101&

'//
'// MessageId: WSAENOMORE
'//
'// MessageText:
'//
'// No more results can be returned by WSALookupServiceNext.
'//
%WSAENOMORE                       = 10102&

'//
'// MessageId: WSAECANCELLED
'//
'// MessageText:
'//
'// A call to WSALookupServiceEnd was made while this call was still processing. The call has been canceled.
'//
%WSAECANCELLED                    = 10103&

'//
'// MessageId: WSAEINVALIDPROCTABLE
'//
'// MessageText:
'//
'// The procedure call table is invalid.
'//
%WSAEINVALIDPROCTABLE             = 10104&

'//
'// MessageId: WSAEINVALIDPROVIDER
'//
'// MessageText:
'//
'// The requested service provider is invalid.
'//
%WSAEINVALIDPROVIDER              = 10105&

'//
'// MessageId: WSAEPROVIDERFAILEDINIT
'//
'// MessageText:
'//
'// The requested service provider could not be loaded or initialized.
'//
%WSAEPROVIDERFAILEDINIT           = 10106&

'//
'// MessageId: WSASYSCALLFAILURE
'//
'// MessageText:
'//
'// A system call that should never fail has failed.
'//
%WSASYSCALLFAILURE                = 10107&

'//
'// MessageId: WSASERVICE_NOT_FOUND
'//
'// MessageText:
'//
'// No such service is known. The service cannot be found in the specified name space.
'//
%WSASERVICE_NOT_FOUND             = 10108&

'//
'// MessageId: WSATYPE_NOT_FOUND
'//
'// MessageText:
'//
'// The specified class was not found.
'//
%WSATYPE_NOT_FOUND                = 10109&

'//
'// MessageId: WSA_E_NO_MORE
'//
'// MessageText:
'//
'// No more results can be returned by WSALookupServiceNext.
'//
%WSA_E_NO_MORE                    = 10110&

'//
'// MessageId: WSA_E_CANCELLED
'//
'// MessageText:
'//
'// A call to WSALookupServiceEnd was made while this call was still processing. The call has been canceled.
'//
%WSA_E_CANCELLED                  = 10111&

'//
'// MessageId: WSAEREFUSED
'//
'// MessageText:
'//
'// A database query failed because it was actively refused.
'//
%WSAEREFUSED                      = 10112&

'//
'// MessageId: WSAHOST_NOT_FOUND
'//
'// MessageText:
'//
'// No such host is known.
'//
%WSAHOST_NOT_FOUND                = 11001&

'//
'// MessageId: WSATRY_AGAIN
'//
'// MessageText:
'//
'// This is usually a temporary error during hostname resolution and means that the local server did not receive a response from an authoritative server.
'//
%WSATRY_AGAIN                     = 11002&

'//
'// MessageId: WSANO_RECOVERY
'//
'// MessageText:
'//
'// A non-recoverable error occurred during a database lookup.
'//
%WSANO_RECOVERY                   = 11003&

'//
'// MessageId: WSANO_DATA
'//
'// MessageText:
'//
'// The requested name is valid, but no data of the requested type was found.
'//
%WSANO_DATA                       = 11004&

'//
'// MessageId: WSA_QOS_RECEIVERS
'//
'// MessageText:
'//
'// At least one reserve has arrived.
'//
%WSA_QOS_RECEIVERS                = 11005&

'//
'// MessageId: WSA_QOS_SENDERS
'//
'// MessageText:
'//
'// At least one path has arrived.
'//
%WSA_QOS_SENDERS                  = 11006&

'//
'// MessageId: WSA_QOS_NO_SENDERS
'//
'// MessageText:
'//
'// There are no senders.
'//
%WSA_QOS_NO_SENDERS               = 11007&

'//
'// MessageId: WSA_QOS_NO_RECEIVERS
'//
'// MessageText:
'//
'// There are no receivers.
'//
%WSA_QOS_NO_RECEIVERS             = 11008&

'//
'// MessageId: WSA_QOS_REQUEST_CONFIRMED
'//
'// MessageText:
'//
'// Reserve has been confirmed.
'//
%WSA_QOS_REQUEST_CONFIRMED        = 11009&

'//
'// MessageId: WSA_QOS_ADMISSION_FAILURE
'//
'// MessageText:
'//
'// Error due to lack of resources.
'//
%WSA_QOS_ADMISSION_FAILURE        = 11010&

'//
'// MessageId: WSA_QOS_POLICY_FAILURE
'//
'// MessageText:
'//
'// Rejected for administrative reasons - bad credentials.
'//
%WSA_QOS_POLICY_FAILURE           = 11011&

'//
'// MessageId: WSA_QOS_BAD_STYLE
'//
'// MessageText:
'//
'// Unknown or conflicting style.
'//
%WSA_QOS_BAD_STYLE                = 11012&

'//
'// MessageId: WSA_QOS_BAD_OBJECT
'//
'// MessageText:
'//
'// Problem with some part of the filterspec or providerspecific buffer in general.
'//
%WSA_QOS_BAD_OBJECT               = 11013&

'//
'// MessageId: WSA_QOS_TRAFFIC_CTRL_ERROR
'//
'// MessageText:
'//
'// Problem with some part of the flowspec.
'//
%WSA_QOS_TRAFFIC_CTRL_ERROR       = 11014&

'//
'// MessageId: WSA_QOS_GENERIC_ERROR
'//
'// MessageText:
'//
'// General QOS error.
'//
%WSA_QOS_GENERIC_ERROR            = 11015&

'//
'// MessageId: WSA_QOS_ESERVICETYPE
'//
'// MessageText:
'//
'// An invalid or unrecognized service type was found in the flowspec.
'//
%WSA_QOS_ESERVICETYPE             = 11016&

'//
'// MessageId: WSA_QOS_EFLOWSPEC
'//
'// MessageText:
'//
'// An invalid or inconsistent flowspec was found in the QOS structure.
'//
%WSA_QOS_EFLOWSPEC                = 11017&

'//
'// MessageId: WSA_QOS_EPROVSPECBUF
'//
'// MessageText:
'//
'// Invalid QOS provider-specific buffer.
'//
%WSA_QOS_EPROVSPECBUF             = 11018&

'//
'// MessageId: WSA_QOS_EFILTERSTYLE
'//
'// MessageText:
'//
'// An invalid QOS filter style was used.
'//
%WSA_QOS_EFILTERSTYLE             = 11019&

'//
'// MessageId: WSA_QOS_EFILTERTYPE
'//
'// MessageText:
'//
'// An invalid QOS filter type was used.
'//
%WSA_QOS_EFILTERTYPE              = 11020&

'//
'// MessageId: WSA_QOS_EFILTERCOUNT
'//
'// MessageText:
'//
'// An incorrect number of QOS FILTERSPECs were specified in the FLOWDESCRIPTOR.
'//
%WSA_QOS_EFILTERCOUNT             = 11021&

'//
'// MessageId: WSA_QOS_EOBJLENGTH
'//
'// MessageText:
'//
'// An object with an invalid ObjectLength field was specified in the QOS provider-specific buffer.
'//
%WSA_QOS_EOBJLENGTH               = 11022&

'//
'// MessageId: WSA_QOS_EFLOWCOUNT
'//
'// MessageText:
'//
'// An incorrect number of flow descriptors was specified in the QOS structure.
'//
%WSA_QOS_EFLOWCOUNT               = 11023&

'//
'// MessageId: WSA_QOS_EUNKOWNPSOBJ
'//
'// MessageText:
'//
'// An unrecognized object was found in the QOS provider-specific buffer.
'//
%WSA_QOS_EUNKOWNPSOBJ             = 11024&

'//
'// MessageId: WSA_QOS_EPOLICYOBJ
'//
'// MessageText:
'//
'// An invalid policy object was found in the QOS provider-specific buffer.
'//
%WSA_QOS_EPOLICYOBJ               = 11025&

'//
'// MessageId: WSA_QOS_EFLOWDESC
'//
'// MessageText:
'//
'// An invalid QOS flow descriptor was found in the flow descriptor list.
'//
%WSA_QOS_EFLOWDESC                = 11026&

'//
'// MessageId: WSA_QOS_EPSFLOWSPEC
'//
'// MessageText:
'//
'// An invalid or inconsistent flowspec was found in the QOS provider specific buffer.
'//
%WSA_QOS_EPSFLOWSPEC              = 11027&

'//
'// MessageId: WSA_QOS_EPSFILTERSPEC
'//
'// MessageText:
'//
'// An invalid FILTERSPEC was found in the QOS provider-specific buffer.
'//
%WSA_QOS_EPSFILTERSPEC            = 11028&

'//
'// MessageId: WSA_QOS_ESDMODEOBJ
'//
'// MessageText:
'//
'// An invalid shape discard mode object was found in the QOS provider specific buffer.
'//
%WSA_QOS_ESDMODEOBJ               = 11029&

'//
'// MessageId: WSA_QOS_ESHAPERATEOBJ
'//
'// MessageText:
'//
'// An invalid shaping rate object was found in the QOS provider-specific buffer.
'//
%WSA_QOS_ESHAPERATEOBJ            = 11030&

'//
'// MessageId: WSA_QOS_RESERVED_PETYPE
'//
'// MessageText:
'//
'// A reserved policy element was found in the QOS provider-specific buffer.
'//
%WSA_QOS_RESERVED_PETYPE          = 11031&

#ENDIF '// defined(WSABASEERR)

'///////////////////////////////////////////////////
'//                                               //
'//           End of WinSock Error Codes          //
'//                                               //
'//                 = 10000 to 11999              //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//                  Available                    //
'//                                               //
'//                = 12000 to 129999              //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//           Start of IPSec Error codes          //
'//                                               //
'//                 = 13000 to 13999              //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_IPSEC_QM_POLICY_EXISTS
'//
'// MessageText:
'//
'// The specified quick mode policy already exists.
'//
%ERROR_IPSEC_QM_POLICY_EXISTS     = 13000&

'//
'// MessageId: ERROR_IPSEC_QM_POLICY_NOT_FOUND
'//
'// MessageText:
'//
'// The specified quick mode policy was not found.
'//
%ERROR_IPSEC_QM_POLICY_NOT_FOUND = 13001&

'//
'// MessageId: ERROR_IPSEC_QM_POLICY_IN_USE
'//
'// MessageText:
'//
'// The specified quick mode policy is being used.
'//
%ERROR_IPSEC_QM_POLICY_IN_USE     = 13002&

'//
'// MessageId: ERROR_IPSEC_MM_POLICY_EXISTS
'//
'// MessageText:
'//
'// The specified main mode policy already exists.
'//
%ERROR_IPSEC_MM_POLICY_EXISTS     = 13003&

'//
'// MessageId: ERROR_IPSEC_MM_POLICY_NOT_FOUND
'//
'// MessageText:
'//
'// The specified main mode policy was not found
'//
%ERROR_IPSEC_MM_POLICY_NOT_FOUND = 13004&

'//
'// MessageId: ERROR_IPSEC_MM_POLICY_IN_USE
'//
'// MessageText:
'//
'// The specified main mode policy is being used.
'//
%ERROR_IPSEC_MM_POLICY_IN_USE     = 13005&

'//
'// MessageId: ERROR_IPSEC_MM_FILTER_EXISTS
'//
'// MessageText:
'//
'// The specified main mode filter already exists.
'//
%ERROR_IPSEC_MM_FILTER_EXISTS     = 13006&

'//
'// MessageId: ERROR_IPSEC_MM_FILTER_NOT_FOUND
'//
'// MessageText:
'//
'// The specified main mode filter was not found.
'//
%ERROR_IPSEC_MM_FILTER_NOT_FOUND = 13007&

'//
'// MessageId: ERROR_IPSEC_TRANSPORT_FILTER_EXISTS
'//
'// MessageText:
'//
'// The specified transport mode filter already exists.
'//
%ERROR_IPSEC_TRANSPORT_FILTER_EXISTS = 13008&

'//
'// MessageId: ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND
'//
'// MessageText:
'//
'// The specified transport mode filter does not exist.
'//
%ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND = 13009&

'//
'// MessageId: ERROR_IPSEC_MM_AUTH_EXISTS
'//
'// MessageText:
'//
'// The specified main mode authentication list exists.
'//
%ERROR_IPSEC_MM_AUTH_EXISTS       = 13010&

'//
'// MessageId: ERROR_IPSEC_MM_AUTH_NOT_FOUND
'//
'// MessageText:
'//
'// The specified main mode authentication list was not found.
'//
%ERROR_IPSEC_MM_AUTH_NOT_FOUND    = 13011&

'//
'// MessageId: ERROR_IPSEC_MM_AUTH_IN_USE
'//
'// MessageText:
'//
'// The specified main mode authentication list is being used.
'//
%ERROR_IPSEC_MM_AUTH_IN_USE       = 13012&

'//
'// MessageId: ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND
'//
'// MessageText:
'//
'// The specified default main mode policy was not found.
'//
%ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND = 13013&

'//
'// MessageId: ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND
'//
'// MessageText:
'//
'// The specified default main mode authentication list was not found.
'//
%ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND = 13014&

'//
'// MessageId: ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND
'//
'// MessageText:
'//
'// The specified default quick mode policy was not found.
'//
%ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND = 13015&

'//
'// MessageId: ERROR_IPSEC_TUNNEL_FILTER_EXISTS
'//
'// MessageText:
'//
'// The specified tunnel mode filter exists.
'//
%ERROR_IPSEC_TUNNEL_FILTER_EXISTS = 13016&

'//
'// MessageId: ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND
'//
'// MessageText:
'//
'// The specified tunnel mode filter was not found.
'//
%ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND = 13017&

'//
'// MessageId: ERROR_IPSEC_MM_FILTER_PENDING_DELETION
'//
'// MessageText:
'//
'// The Main Mode filter is pending deletion.
'//
%ERROR_IPSEC_MM_FILTER_PENDING_DELETION = 13018&

'//
'// MessageId: ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION
'//
'// MessageText:
'//
'// The transport filter is pending deletion.
'//
%ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION = 13019&

'//
'// MessageId: ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION
'//
'// MessageText:
'//
'// The tunnel filter is pending deletion.
'//
%ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION = 13020&

'//
'// MessageId: ERROR_IPSEC_MM_POLICY_PENDING_DELETION
'//
'// MessageText:
'//
'// The Main Mode policy is pending deletion.
'//
%ERROR_IPSEC_MM_POLICY_PENDING_DELETION = 13021&

'//
'// MessageId: ERROR_IPSEC_MM_AUTH_PENDING_DELETION
'//
'// MessageText:
'//
'// The Main Mode authentication bundle is pending deletion.
'//
%ERROR_IPSEC_MM_AUTH_PENDING_DELETION = 13022&

'//
'// MessageId: ERROR_IPSEC_QM_POLICY_PENDING_DELETION
'//
'// MessageText:
'//
'// The Quick Mode policy is pending deletion.
'//
%ERROR_IPSEC_QM_POLICY_PENDING_DELETION = 13023&

'//
'// MessageId: WARNING_IPSEC_MM_POLICY_PRUNED
'//
'// MessageText:
'//
'// The Main Mode policy was successfully added, but some of the requested offers are not supported.
'//
%WARNING_IPSEC_MM_POLICY_PRUNED   = 13024&

'//
'// MessageId: WARNING_IPSEC_QM_POLICY_PRUNED
'//
'// MessageText:
'//
'// The Quick Mode policy was successfully added, but some of the requested offers are not supported.
'//
%WARNING_IPSEC_QM_POLICY_PRUNED   = 13025&

'//
'// MessageId: ERROR_IPSEC_IKE_NEG_STATUS_BEGIN
'//
'// MessageText:
'//
'//  ERROR_IPSEC_IKE_NEG_STATUS_BEGIN
'//
%ERROR_IPSEC_IKE_NEG_STATUS_BEGIN = 13800&

'//
'// MessageId: ERROR_IPSEC_IKE_AUTH_FAIL
'//
'// MessageText:
'//
'// IKE authentication credentials are unacceptable
'//
%ERROR_IPSEC_IKE_AUTH_FAIL        = 13801&

'//
'// MessageId: ERROR_IPSEC_IKE_ATTRIB_FAIL
'//
'// MessageText:
'//
'// IKE security attributes are unacceptable
'//
%ERROR_IPSEC_IKE_ATTRIB_FAIL      = 13802&

'//
'// MessageId: ERROR_IPSEC_IKE_NEGOTIATION_PENDING
'//
'// MessageText:
'//
'// IKE Negotiation in progress
'//
%ERROR_IPSEC_IKE_NEGOTIATION_PENDING = 13803&

'//
'// MessageId: ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR
'//
'// MessageText:
'//
'// General processing error
'//
%ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR = 13804&

'//
'// MessageId: ERROR_IPSEC_IKE_TIMED_OUT
'//
'// MessageText:
'//
'// Negotiation timed out
'//
%ERROR_IPSEC_IKE_TIMED_OUT        = 13805&

'//
'// MessageId: ERROR_IPSEC_IKE_NO_CERT
'//
'// MessageText:
'//
'// IKE failed to find valid machine certificate. Contact your Network Security Administrator about installing a valid certificate in the appropriate Certificate Store.
'//
%ERROR_IPSEC_IKE_NO_CERT          = 13806&

'//
'// MessageId: ERROR_IPSEC_IKE_SA_DELETED
'//
'// MessageText:
'//
'// IKE SA deleted by peer before establishment completed
'//
%ERROR_IPSEC_IKE_SA_DELETED       = 13807&

'//
'// MessageId: ERROR_IPSEC_IKE_SA_REAPED
'//
'// MessageText:
'//
'// IKE SA deleted before establishment completed
'//
%ERROR_IPSEC_IKE_SA_REAPED        = 13808&

'//
'// MessageId: ERROR_IPSEC_IKE_MM_ACQUIRE_DROP
'//
'// MessageText:
'//
'// Negotiation request sat in Queue too long
'//
%ERROR_IPSEC_IKE_MM_ACQUIRE_DROP = 13809&

'//
'// MessageId: ERROR_IPSEC_IKE_QM_ACQUIRE_DROP
'//
'// MessageText:
'//
'// Negotiation request sat in Queue too long
'//
%ERROR_IPSEC_IKE_QM_ACQUIRE_DROP = 13810&

'//
'// MessageId: ERROR_IPSEC_IKE_QUEUE_DROP_MM
'//
'// MessageText:
'//
'// Negotiation request sat in Queue too long
'//
%ERROR_IPSEC_IKE_QUEUE_DROP_MM    = 13811&

'//
'// MessageId: ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM
'//
'// MessageText:
'//
'// Negotiation request sat in Queue too long
'//
%ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM = 13812&

'//
'// MessageId: ERROR_IPSEC_IKE_DROP_NO_RESPONSE
'//
'// MessageText:
'//
'// No response from peer
'//
%ERROR_IPSEC_IKE_DROP_NO_RESPONSE = 13813&

'//
'// MessageId: ERROR_IPSEC_IKE_MM_DELAY_DROP
'//
'// MessageText:
'//
'// Negotiation took too long
'//
%ERROR_IPSEC_IKE_MM_DELAY_DROP    = 13814&

'//
'// MessageId: ERROR_IPSEC_IKE_QM_DELAY_DROP
'//
'// MessageText:
'//
'// Negotiation took too long
'//
%ERROR_IPSEC_IKE_QM_DELAY_DROP    = 13815&

'//
'// MessageId: ERROR_IPSEC_IKE_ERROR
'//
'// MessageText:
'//
'// Unknown error occurred
'//
%ERROR_IPSEC_IKE_ERROR            = 13816&

'//
'// MessageId: ERROR_IPSEC_IKE_CRL_FAILED
'//
'// MessageText:
'//
'// Certificate Revocation Check failed
'//
%ERROR_IPSEC_IKE_CRL_FAILED       = 13817&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_KEY_USAGE
'//
'// MessageText:
'//
'// Invalid certificate key usage
'//
%ERROR_IPSEC_IKE_INVALID_KEY_USAGE = 13818&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_CERT_TYPE
'//
'// MessageText:
'//
'// Invalid certificate type
'//
%ERROR_IPSEC_IKE_INVALID_CERT_TYPE = 13819&

'//
'// MessageId: ERROR_IPSEC_IKE_NO_PRIVATE_KEY
'//
'// MessageText:
'//
'// IKE negotiation failed because the machine certificate used does not have a private key. IPsec certificates require a private key. Contact your Network Security administrator about replacing with a certificate that has a private key.
'//
%ERROR_IPSEC_IKE_NO_PRIVATE_KEY   = 13820&

'//
'// MessageId: ERROR_IPSEC_IKE_DH_FAIL
'//
'// MessageText:
'//
'// Failure in Diffie-Helman computation
'//
%ERROR_IPSEC_IKE_DH_FAIL          = 13822&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_HEADER
'//
'// MessageText:
'//
'// Invalid header
'//
%ERROR_IPSEC_IKE_INVALID_HEADER   = 13824&

'//
'// MessageId: ERROR_IPSEC_IKE_NO_POLICY
'//
'// MessageText:
'//
'// No policy configured
'//
%ERROR_IPSEC_IKE_NO_POLICY        = 13825&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_SIGNATURE
'//
'// MessageText:
'//
'// Failed to verify signature
'//
%ERROR_IPSEC_IKE_INVALID_SIGNATURE = 13826&

'//
'// MessageId: ERROR_IPSEC_IKE_KERBEROS_ERROR
'//
'// MessageText:
'//
'// Failed to authenticate using kerberos
'//
%ERROR_IPSEC_IKE_KERBEROS_ERROR   = 13827&

'//
'// MessageId: ERROR_IPSEC_IKE_NO_PUBLIC_KEY
'//
'// MessageText:
'//
'// Peer's certificate did not have a public key
'//
%ERROR_IPSEC_IKE_NO_PUBLIC_KEY    = 13828&

'// These must stay as a unit.
'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR
'//
'// MessageText:
'//
'// Error processing error payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR      = 13829&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_SA
'//
'// MessageText:
'//
'// Error processing SA payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_SA   = 13830&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_PROP
'//
'// MessageText:
'//
'// Error processing Proposal payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_PROP = 13831&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_TRANS
'//
'// MessageText:
'//
'// Error processing Transform payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_TRANS = 13832&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_KE
'//
'// MessageText:
'//
'// Error processing KE payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_KE   = 13833&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_ID
'//
'// MessageText:
'//
'// Error processing ID payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_ID   = 13834&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_CERT
'//
'// MessageText:
'//
'// Error processing Cert payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_CERT = 13835&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ
'//
'// MessageText:
'//
'// Error processing Certificate Request payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ = 13836&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_HASH
'//
'// MessageText:
'//
'// Error processing Hash payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_HASH = 13837&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_SIG
'//
'// MessageText:
'//
'// Error processing Signature payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_SIG = 13838&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_NONCE
'//
'// MessageText:
'//
'// Error processing Nonce payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_NONCE = 13839&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY
'//
'// MessageText:
'//
'// Error processing Notify payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY = 13840&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_DELETE
'//
'// MessageText:
'//
'// Error processing Delete Payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_DELETE = 13841&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR
'//
'// MessageText:
'//
'// Error processing VendorId payload
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR = 13842&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_PAYLOAD
'//
'// MessageText:
'//
'// Invalid payload received
'//
%ERROR_IPSEC_IKE_INVALID_PAYLOAD = 13843&

'//
'// MessageId: ERROR_IPSEC_IKE_LOAD_SOFT_SA
'//
'// MessageText:
'//
'// Soft SA loaded
'//
%ERROR_IPSEC_IKE_LOAD_SOFT_SA     = 13844&

'//
'// MessageId: ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN
'//
'// MessageText:
'//
'// Soft SA torn down
'//
%ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN = 13845&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_COOKIE
'//
'// MessageText:
'//
'// Invalid cookie received.
'//
%ERROR_IPSEC_IKE_INVALID_COOKIE   = 13846&

'//
'// MessageId: ERROR_IPSEC_IKE_NO_PEER_CERT
'//
'// MessageText:
'//
'// Peer failed to send valid machine certificate
'//
%ERROR_IPSEC_IKE_NO_PEER_CERT     = 13847&

'//
'// MessageId: ERROR_IPSEC_IKE_PEER_CRL_FAILED
'//
'// MessageText:
'//
'// Certification Revocation check of peer's certificate failed
'//
%ERROR_IPSEC_IKE_PEER_CRL_FAILED = 13848&

'//
'// MessageId: ERROR_IPSEC_IKE_POLICY_CHANGE
'//
'// MessageText:
'//
'// New policy invalidated SAs formed with old policy
'//
%ERROR_IPSEC_IKE_POLICY_CHANGE    = 13849&

'//
'// MessageId: ERROR_IPSEC_IKE_NO_MM_POLICY
'//
'// MessageText:
'//
'// There is no available Main Mode IKE policy.
'//
%ERROR_IPSEC_IKE_NO_MM_POLICY     = 13850&

'//
'// MessageId: ERROR_IPSEC_IKE_NOTCBPRIV
'//
'// MessageText:
'//
'// Failed to enabled TCB privilege.
'//
%ERROR_IPSEC_IKE_NOTCBPRIV        = 13851&

'//
'// MessageId: ERROR_IPSEC_IKE_SECLOADFAIL
'//
'// MessageText:
'//
'// Failed to load SECURITY.DLL.
'//
%ERROR_IPSEC_IKE_SECLOADFAIL      = 13852&

'//
'// MessageId: ERROR_IPSEC_IKE_FAILSSPINIT
'//
'// MessageText:
'//
'// Failed to obtain security function table dispatch address from SSPI.
'//
%ERROR_IPSEC_IKE_FAILSSPINIT      = 13853&

'//
'// MessageId: ERROR_IPSEC_IKE_FAILQUERYSSP
'//
'// MessageText:
'//
'// Failed to query Kerberos package to obtain max token size.
'//
%ERROR_IPSEC_IKE_FAILQUERYSSP     = 13854&

'//
'// MessageId: ERROR_IPSEC_IKE_SRVACQFAIL
'//
'// MessageText:
'//
'// Failed to obtain Kerberos server credentials for ISAKMP/ERROR_IPSEC_IKE service. Kerberos authentication will not function. The most likely reason for this is lack of domain membership. This is normal if your computer is a member of a workgroup.
'//
%ERROR_IPSEC_IKE_SRVACQFAIL       = 13855&

'//
'// MessageId: ERROR_IPSEC_IKE_SRVQUERYCRED
'//
'// MessageText:
'//
'// Failed to determine SSPI principal name for ISAKMP/ERROR_IPSEC_IKE service (QueryCredentialsAttributes).
'//
%ERROR_IPSEC_IKE_SRVQUERYCRED     = 13856&

'//
'// MessageId: ERROR_IPSEC_IKE_GETSPIFAIL
'//
'// MessageText:
'//
'// Failed to obtain new SPI for the inbound SA from Ipsec driver. The most common cause for this is that the driver does not have the correct filter. Check your policy to verify the filters.
'//
%ERROR_IPSEC_IKE_GETSPIFAIL       = 13857&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_FILTER
'//
'// MessageText:
'//
'// Given filter is invalid
'//
%ERROR_IPSEC_IKE_INVALID_FILTER   = 13858&

'//
'// MessageId: ERROR_IPSEC_IKE_OUT_OF_MEMORY
'//
'// MessageText:
'//
'// Memory allocation failed.
'//
%ERROR_IPSEC_IKE_OUT_OF_MEMORY    = 13859&

'//
'// MessageId: ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED
'//
'// MessageText:
'//
'// Failed to add Security Association to IPSec Driver. The most common cause for this is if the IKE negotiation took too long to complete. If the problem persists, reduce the load on the faulting machine.
'//
%ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED = 13860&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_POLICY
'//
'// MessageText:
'//
'// Invalid policy
'//
%ERROR_IPSEC_IKE_INVALID_POLICY   = 13861&

'//
'// MessageId: ERROR_IPSEC_IKE_UNKNOWN_DOI
'//
'// MessageText:
'//
'// Invalid DOI
'//
%ERROR_IPSEC_IKE_UNKNOWN_DOI      = 13862&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_SITUATION
'//
'// MessageText:
'//
'// Invalid situation
'//
%ERROR_IPSEC_IKE_INVALID_SITUATION = 13863&

'//
'// MessageId: ERROR_IPSEC_IKE_DH_FAILURE
'//
'// MessageText:
'//
'// Diffie-Hellman failure
'//
%ERROR_IPSEC_IKE_DH_FAILURE       = 13864&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_GROUP
'//
'// MessageText:
'//
'// Invalid Diffie-Hellman group
'//
%ERROR_IPSEC_IKE_INVALID_GROUP    = 13865&

'//
'// MessageId: ERROR_IPSEC_IKE_ENCRYPT
'//
'// MessageText:
'//
'// Error encrypting payload
'//
%ERROR_IPSEC_IKE_ENCRYPT          = 13866&

'//
'// MessageId: ERROR_IPSEC_IKE_DECRYPT
'//
'// MessageText:
'//
'// Error decrypting payload
'//
%ERROR_IPSEC_IKE_DECRYPT          = 13867&

'//
'// MessageId: ERROR_IPSEC_IKE_POLICY_MATCH
'//
'// MessageText:
'//
'// Policy match error
'//
%ERROR_IPSEC_IKE_POLICY_MATCH     = 13868&

'//
'// MessageId: ERROR_IPSEC_IKE_UNSUPPORTED_ID
'//
'// MessageText:
'//
'// Unsupported ID
'//
%ERROR_IPSEC_IKE_UNSUPPORTED_ID   = 13869&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_HASH
'//
'// MessageText:
'//
'// Hash verification failed
'//
%ERROR_IPSEC_IKE_INVALID_HASH     = 13870&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_HASH_ALG
'//
'// MessageText:
'//
'// Invalid hash algorithm
'//
%ERROR_IPSEC_IKE_INVALID_HASH_ALG = 13871&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_HASH_SIZE
'//
'// MessageText:
'//
'// Invalid hash size
'//
%ERROR_IPSEC_IKE_INVALID_HASH_SIZE = 13872&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG
'//
'// MessageText:
'//
'// Invalid encryption algorithm
'//
%ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG = 13873&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_AUTH_ALG
'//
'// MessageText:
'//
'// Invalid authentication algorithm
'//
%ERROR_IPSEC_IKE_INVALID_AUTH_ALG = 13874&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_SIG
'//
'// MessageText:
'//
'// Invalid certificate signature
'//
%ERROR_IPSEC_IKE_INVALID_SIG      = 13875&

'//
'// MessageId: ERROR_IPSEC_IKE_LOAD_FAILED
'//
'// MessageText:
'//
'// Load failed
'//
%ERROR_IPSEC_IKE_LOAD_FAILED      = 13876&

'//
'// MessageId: ERROR_IPSEC_IKE_RPC_DELETE
'//
'// MessageText:
'//
'// Deleted via RPC call
'//
%ERROR_IPSEC_IKE_RPC_DELETE       = 13877&

'//
'// MessageId: ERROR_IPSEC_IKE_BENIGN_REINIT
'//
'// MessageText:
'//
'// Temporary state created to perform reinit. This is not a real failure.
'//
%ERROR_IPSEC_IKE_BENIGN_REINIT    = 13878&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY
'//
'// MessageText:
'//
'// The lifetime value received in the Responder Lifetime Notify is below the Windows 2000 configured minimum value. Please fix the policy on the peer machine.
'//
%ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY = 13879&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN
'//
'// MessageText:
'//
'// Key length in certificate is too small for configured security requirements.
'//
%ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN = 13881&

'//
'// MessageId: ERROR_IPSEC_IKE_MM_LIMIT
'//
'// MessageText:
'//
'// Max number of established MM SAs to peer exceeded.
'//
%ERROR_IPSEC_IKE_MM_LIMIT         = 13882&

'//
'// MessageId: ERROR_IPSEC_IKE_NEGOTIATION_DISABLED
'//
'// MessageText:
'//
'// IKE received a policy that disables negotiation.
'//
%ERROR_IPSEC_IKE_NEGOTIATION_DISABLED = 13883&

'//
'// MessageId: ERROR_IPSEC_IKE_QM_LIMIT
'//
'// MessageText:
'//
'// Reached maximum quick mode limit for the main mode. New main mode will be started.
'//
%ERROR_IPSEC_IKE_QM_LIMIT         = 13884&

'//
'// MessageId: ERROR_IPSEC_IKE_MM_EXPIRED
'//
'// MessageText:
'//
'// Main mode SA lifetime expired or peer sent a main mode delete.
'//
%ERROR_IPSEC_IKE_MM_EXPIRED       = 13885&

'//
'// MessageId: ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID
'//
'// MessageText:
'//
'// Main mode SA assumed to be invalid because peer stopped responding.
'//
%ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID = 13886&

'//
'// MessageId: ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH
'//
'// MessageText:
'//
'// Certificate doesn't chain to a trusted root in IPsec policy.
'//
%ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH = 13887&

'//
'// MessageId: ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID
'//
'// MessageText:
'//
'// Received unexpected message ID.
'//
%ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID = 13888&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD
'//
'// MessageText:
'//
'// Received invalid authentication offers.
'//
%ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD = 13889&

'//
'// MessageId: ERROR_IPSEC_IKE_DOS_COOKIE_SENT
'//
'// MessageText:
'//
'// Sent DOS cookie notify to intiator.
'//
%ERROR_IPSEC_IKE_DOS_COOKIE_SENT = 13890&

'//
'// MessageId: ERROR_IPSEC_IKE_SHUTTING_DOWN
'//
'// MessageText:
'//
'// IKE service is shutting down.
'//
%ERROR_IPSEC_IKE_SHUTTING_DOWN    = 13891&

'//
'// MessageId: ERROR_IPSEC_IKE_CGA_AUTH_FAILED
'//
'// MessageText:
'//
'// Could not verify binding between CGA address and certificate.
'//
%ERROR_IPSEC_IKE_CGA_AUTH_FAILED = 13892&

'//
'// MessageId: ERROR_IPSEC_IKE_PROCESS_ERR_NATOA
'//
'// MessageText:
'//
'// Error processing NatOA payload.
'//
%ERROR_IPSEC_IKE_PROCESS_ERR_NATOA = 13893&

'//
'// MessageId: ERROR_IPSEC_IKE_INVALID_MM_FOR_QM
'//
'// MessageText:
'//
'// Parameters of the main mode are invalid for this quick mode.
'//
%ERROR_IPSEC_IKE_INVALID_MM_FOR_QM = 13894&

'//
'// MessageId: ERROR_IPSEC_IKE_QM_EXPIRED
'//
'// MessageText:
'//
'// Quick mode SA was expired by IPsec driver.
'//
%ERROR_IPSEC_IKE_QM_EXPIRED       = 13895&

'//
'// MessageId: ERROR_IPSEC_IKE_TOO_MANY_FILTERS
'//
'// MessageText:
'//
'// Too many dynamically added IKEEXT filters were detected.
'//
%ERROR_IPSEC_IKE_TOO_MANY_FILTERS = 13896&

'//
'// MessageId: ERROR_IPSEC_IKE_NEG_STATUS_END
'//
'// MessageText:
'//
'//  ERROR_IPSEC_IKE_NEG_STATUS_END
'//
%ERROR_IPSEC_IKE_NEG_STATUS_END   = 13897&

'//
'// Following error codes are returned by IPsec kernel.
'//
'//
'// MessageId: ERROR_IPSEC_BAD_SPI
'//
'// MessageText:
'//
'// The SPI in the packet does not match a valid IPsec SA.
'//
%ERROR_IPSEC_BAD_SPI              = 13910&

'//
'// MessageId: ERROR_IPSEC_SA_LIFETIME_EXPIRED
'//
'// MessageText:
'//
'// Packet was received on an IPsec SA whose lifetime has expired.
'//
%ERROR_IPSEC_SA_LIFETIME_EXPIRED = 13911&

'//
'// MessageId: ERROR_IPSEC_WRONG_SA
'//
'// MessageText:
'//
'// Packet was received on an IPsec SA that doesn't match the packet characteristics.
'//
%ERROR_IPSEC_WRONG_SA             = 13912&

'//
'// MessageId: ERROR_IPSEC_REPLAY_CHECK_FAILED
'//
'// MessageText:
'//
'// Packet sequence number replay check failed.
'//
%ERROR_IPSEC_REPLAY_CHECK_FAILED = 13913&

'//
'// MessageId: ERROR_IPSEC_INVALID_PACKET
'//
'// MessageText:
'//
'// IPsec header and/or trailer in the packet is invalid.
'//
%ERROR_IPSEC_INVALID_PACKET       = 13914&

'//
'// MessageId: ERROR_IPSEC_INTEGRITY_CHECK_FAILED
'//
'// MessageText:
'//
'// IPsec integrity check failed.
'//
%ERROR_IPSEC_INTEGRITY_CHECK_FAILED = 13915&

'//
'// MessageId: ERROR_IPSEC_CLEAR_TEXT_DROP
'//
'// MessageText:
'//
'// IPsec dropped a clear text packet.
'//
%ERROR_IPSEC_CLEAR_TEXT_DROP      = 13916&


'///////////////////////////////////////////////////
'//                                               //
'//           End of IPSec Error codes            //
'//                                               //
'//                 = 13000 to 13999              //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//         Start of Side By Side Error Codes     //
'//                                               //
'//                 = 14000 to 14999              //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_SXS_SECTION_NOT_FOUND
'//
'// MessageText:
'//
'// The requested section was not present in the activation context.
'//
%ERROR_SXS_SECTION_NOT_FOUND      = 14000&

'//
'// MessageId: ERROR_SXS_CANT_GEN_ACTCTX
'//
'// MessageText:
'//
'// The application has failed to start because its side-by-side configuration is incorrect. Please see the application event log for more detail.
'//
%ERROR_SXS_CANT_GEN_ACTCTX        = 14001&

'//
'// MessageId: ERROR_SXS_INVALID_ACTCTXDATA_FORMAT
'//
'// MessageText:
'//
'// The application binding data format is invalid.
'//
%ERROR_SXS_INVALID_ACTCTXDATA_FORMAT = 14002&

'//
'// MessageId: ERROR_SXS_ASSEMBLY_NOT_FOUND
'//
'// MessageText:
'//
'// The referenced assembly is not installed on your system.
'//
%ERROR_SXS_ASSEMBLY_NOT_FOUND     = 14003&

'//
'// MessageId: ERROR_SXS_MANIFEST_FORMAT_ERROR
'//
'// MessageText:
'//
'// The manifest file does not begin with the required tag and format information.
'//
%ERROR_SXS_MANIFEST_FORMAT_ERROR = 14004&

'//
'// MessageId: ERROR_SXS_MANIFEST_PARSE_ERROR
'//
'// MessageText:
'//
'// The manifest file contains one or more syntax errors.
'//
%ERROR_SXS_MANIFEST_PARSE_ERROR   = 14005&

'//
'// MessageId: ERROR_SXS_ACTIVATION_CONTEXT_DISABLED
'//
'// MessageText:
'//
'// The application attempted to activate a disabled activation context.
'//
%ERROR_SXS_ACTIVATION_CONTEXT_DISABLED = 14006&

'//
'// MessageId: ERROR_SXS_KEY_NOT_FOUND
'//
'// MessageText:
'//
'// The requested lookup key was not found in any active activation context.
'//
%ERROR_SXS_KEY_NOT_FOUND          = 14007&

'//
'// MessageId: ERROR_SXS_VERSION_CONFLICT
'//
'// MessageText:
'//
'// A component version required by the application conflicts with another component version already active.
'//
%ERROR_SXS_VERSION_CONFLICT       = 14008&

'//
'// MessageId: ERROR_SXS_WRONG_SECTION_TYPE
'//
'// MessageText:
'//
'// The type requested activation context section does not match the query API used.
'//
%ERROR_SXS_WRONG_SECTION_TYPE     = 14009&

'//
'// MessageId: ERROR_SXS_THREAD_QUERIES_DISABLED
'//
'// MessageText:
'//
'// Lack of system resources has required isolated activation to be disabled for the current thread of execution.
'//
%ERROR_SXS_THREAD_QUERIES_DISABLED = 14010&

'//
'// MessageId: ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET
'//
'// MessageText:
'//
'// An attempt to set the process default activation context failed because the process default activation context was already set.
'//
%ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET = 14011&

'//
'// MessageId: ERROR_SXS_UNKNOWN_ENCODING_GROUP
'//
'// MessageText:
'//
'// The encoding group identifier specified is not recognized.
'//
%ERROR_SXS_UNKNOWN_ENCODING_GROUP = 14012&

'//
'// MessageId: ERROR_SXS_UNKNOWN_ENCODING
'//
'// MessageText:
'//
'// The encoding requested is not recognized.
'//
%ERROR_SXS_UNKNOWN_ENCODING       = 14013&

'//
'// MessageId: ERROR_SXS_INVALID_XML_NAMESPACE_URI
'//
'// MessageText:
'//
'// The manifest contains a reference to an invalid URI.
'//
%ERROR_SXS_INVALID_XML_NAMESPACE_URI = 14014&

'//
'// MessageId: ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED
'//
'// MessageText:
'//
'// The application manifest contains a reference to a dependent assembly which is not installed
'//
%ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED = 14015&

'//
'// MessageId: ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED
'//
'// MessageText:
'//
'// The manifest for an assembly used by the application has a reference to a dependent assembly which is not installed
'//
%ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED = 14016&

'//
'// MessageId: ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE
'//
'// MessageText:
'//
'// The manifest contains an attribute for the assembly identity which is not valid.
'//
%ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE = 14017&

'//
'// MessageId: ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE
'//
'// MessageText:
'//
'// The manifest is missing the required default namespace specification on the assembly element.
'//
%ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE = 14018&

'//
'// MessageId: ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE
'//
'// MessageText:
'//
'// The manifest has a default namespace specified on the assembly element but its value is not "urn:schemas-microsoft-com:asm.v1".
'//
%ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE = 14019&

'//
'// MessageId: ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT
'//
'// MessageText:
'//
'// The private manifest probed has crossed reparse-point-associated path
'//
%ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT = 14020&

'//
'// MessageId: ERROR_SXS_DUPLICATE_DLL_NAME
'//
'// MessageText:
'//
'// Two or more components referenced directly or indirectly by the application manifest have files by the same name.
'//
%ERROR_SXS_DUPLICATE_DLL_NAME     = 14021&

'//
'// MessageId: ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME
'//
'// MessageText:
'//
'// Two or more components referenced directly or indirectly by the application manifest have window classes with the same name.
'//
%ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME = 14022&

'//
'// MessageId: ERROR_SXS_DUPLICATE_CLSID
'//
'// MessageText:
'//
'// Two or more components referenced directly or indirectly by the application manifest have the same COM server CLSIDs.
'//
%ERROR_SXS_DUPLICATE_CLSID        = 14023&

'//
'// MessageId: ERROR_SXS_DUPLICATE_IID
'//
'// MessageText:
'//
'// Two or more components referenced directly or indirectly by the application manifest have proxies for the same COM interface IIDs.
'//
%ERROR_SXS_DUPLICATE_IID          = 14024&

'//
'// MessageId: ERROR_SXS_DUPLICATE_TLBID
'//
'// MessageText:
'//
'// Two or more components referenced directly or indirectly by the application manifest have the same COM type library TLBIDs.
'//
%ERROR_SXS_DUPLICATE_TLBID        = 14025&

'//
'// MessageId: ERROR_SXS_DUPLICATE_PROGID
'//
'// MessageText:
'//
'// Two or more components referenced directly or indirectly by the application manifest have the same COM ProgIDs.
'//
%ERROR_SXS_DUPLICATE_PROGID       = 14026&

'//
'// MessageId: ERROR_SXS_DUPLICATE_ASSEMBLY_NAME
'//
'// MessageText:
'//
'// Two or more components referenced directly or indirectly by the application manifest are different versions of the same component which is not permitted.
'//
%ERROR_SXS_DUPLICATE_ASSEMBLY_NAME = 14027&

'//
'// MessageId: ERROR_SXS_FILE_HASH_MISMATCH
'//
'// MessageText:
'//
'// A component's file does not match the verification information present in the component manifest.
'//
%ERROR_SXS_FILE_HASH_MISMATCH     = 14028&

'//
'// MessageId: ERROR_SXS_POLICY_PARSE_ERROR
'//
'// MessageText:
'//
'// The policy manifest contains one or more syntax errors.
'//
%ERROR_SXS_POLICY_PARSE_ERROR     = 14029&

'//
'// MessageId: ERROR_SXS_XML_E_MISSINGQUOTE
'//
'// MessageText:
'//
'// Manifest Parse Error : A string literal was expected, but no opening quote character was found.
'//
%ERROR_SXS_XML_E_MISSINGQUOTE     = 14030&

'//
'// MessageId: ERROR_SXS_XML_E_COMMENTSYNTAX
'//
'// MessageText:
'//
'// Manifest Parse Error : Incorrect syntax was used in a comment.
'//
%ERROR_SXS_XML_E_COMMENTSYNTAX    = 14031&

'//
'// MessageId: ERROR_SXS_XML_E_BADSTARTNAMECHAR
'//
'// MessageText:
'//
'// Manifest Parse Error : A name was started with an invalid character.
'//
%ERROR_SXS_XML_E_BADSTARTNAMECHAR = 14032&

'//
'// MessageId: ERROR_SXS_XML_E_BADNAMECHAR
'//
'// MessageText:
'//
'// Manifest Parse Error : A name contained an invalid character.
'//
%ERROR_SXS_XML_E_BADNAMECHAR      = 14033&

'//
'// MessageId: ERROR_SXS_XML_E_BADCHARINSTRING
'//
'// MessageText:
'//
'// Manifest Parse Error : A string literal contained an invalid character.
'//
%ERROR_SXS_XML_E_BADCHARINSTRING = 14034&

'//
'// MessageId: ERROR_SXS_XML_E_XMLDECLSYNTAX
'//
'// MessageText:
'//
'// Manifest Parse Error : Invalid syntax for an xml declaration.
'//
%ERROR_SXS_XML_E_XMLDECLSYNTAX    = 14035&

'//
'// MessageId: ERROR_SXS_XML_E_BADCHARDATA
'//
'// MessageText:
'//
'// Manifest Parse Error : An Invalid character was found in text content.
'//
%ERROR_SXS_XML_E_BADCHARDATA      = 14036&

'//
'// MessageId: ERROR_SXS_XML_E_MISSINGWHITESPACE
'//
'// MessageText:
'//
'// Manifest Parse Error : Required white space was missing.
'//
%ERROR_SXS_XML_E_MISSINGWHITESPACE = 14037&

'//
'// MessageId: ERROR_SXS_XML_E_EXPECTINGTAGEND
'//
'// MessageText:
'//
'// Manifest Parse Error : The character '>' was expected.
'//
%ERROR_SXS_XML_E_EXPECTINGTAGEND = 14038&

'//
'// MessageId: ERROR_SXS_XML_E_MISSINGSEMICOLON
'//
'// MessageText:
'//
'// Manifest Parse Error : A semi colon character was expected.
'//
%ERROR_SXS_XML_E_MISSINGSEMICOLON = 14039&

'//
'// MessageId: ERROR_SXS_XML_E_UNBALANCEDPAREN
'//
'// MessageText:
'//
'// Manifest Parse Error : Unbalanced parentheses.
'//
%ERROR_SXS_XML_E_UNBALANCEDPAREN = 14040&

'//
'// MessageId: ERROR_SXS_XML_E_INTERNALERROR
'//
'// MessageText:
'//
'// Manifest Parse Error : Internal error.
'//
%ERROR_SXS_XML_E_INTERNALERROR    = 14041&

'//
'// MessageId: ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE
'//
'// MessageText:
'//
'// Manifest Parse Error : Whitespace is not allowed at this location.
'//
%ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE = 14042&

'//
'// MessageId: ERROR_SXS_XML_E_INCOMPLETE_ENCODING
'//
'// MessageText:
'//
'// Manifest Parse Error : End of file reached in invalid state for current encoding.
'//
%ERROR_SXS_XML_E_INCOMPLETE_ENCODING = 14043&

'//
'// MessageId: ERROR_SXS_XML_E_MISSING_PAREN
'//
'// MessageText:
'//
'// Manifest Parse Error : Missing parenthesis.
'//
%ERROR_SXS_XML_E_MISSING_PAREN    = 14044&

'//
'// MessageId: ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE
'//
'// MessageText:
'//
'// Manifest Parse Error : A single or double closing quote character (\' or \") is missing.
'//
%ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE = 14045&

'//
'// MessageId: ERROR_SXS_XML_E_MULTIPLE_COLONS
'//
'// MessageText:
'//
'// Manifest Parse Error : Multiple colons are not allowed in a name.
'//
%ERROR_SXS_XML_E_MULTIPLE_COLONS = 14046&

'//
'// MessageId: ERROR_SXS_XML_E_INVALID_DECIMAL
'//
'// MessageText:
'//
'// Manifest Parse Error : Invalid character for decimal digit.
'//
%ERROR_SXS_XML_E_INVALID_DECIMAL = 14047&

'//
'// MessageId: ERROR_SXS_XML_E_INVALID_HEXIDECIMAL
'//
'// MessageText:
'//
'// Manifest Parse Error : Invalid character for hexidecimal digit.
'//
%ERROR_SXS_XML_E_INVALID_HEXIDECIMAL = 14048&

'//
'// MessageId: ERROR_SXS_XML_E_INVALID_UNICODE
'//
'// MessageText:
'//
'// Manifest Parse Error : Invalid unicode character value for this platform.
'//
%ERROR_SXS_XML_E_INVALID_UNICODE = 14049&

'//
'// MessageId: ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK
'//
'// MessageText:
'//
'// Manifest Parse Error : Expecting whitespace or '?'.
'//
%ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK = 14050&

'//
'// MessageId: ERROR_SXS_XML_E_UNEXPECTEDENDTAG
'//
'// MessageText:
'//
'// Manifest Parse Error : End tag was not expected at this location.
'//
%ERROR_SXS_XML_E_UNEXPECTEDENDTAG = 14051&

'//
'// MessageId: ERROR_SXS_XML_E_UNCLOSEDTAG
'//
'// MessageText:
'//
'// Manifest Parse Error : The following tags were not closed: %1.
'//
%ERROR_SXS_XML_E_UNCLOSEDTAG      = 14052&

'//
'// MessageId: ERROR_SXS_XML_E_DUPLICATEATTRIBUTE
'//
'// MessageText:
'//
'// Manifest Parse Error : Duplicate attribute.
'//
%ERROR_SXS_XML_E_DUPLICATEATTRIBUTE = 14053&

'//
'// MessageId: ERROR_SXS_XML_E_MULTIPLEROOTS
'//
'// MessageText:
'//
'// Manifest Parse Error : Only one top level element is allowed in an XML document.
'//
%ERROR_SXS_XML_E_MULTIPLEROOTS    = 14054&

'//
'// MessageId: ERROR_SXS_XML_E_INVALIDATROOTLEVEL
'//
'// MessageText:
'//
'// Manifest Parse Error : Invalid at the top level of the document.
'//
%ERROR_SXS_XML_E_INVALIDATROOTLEVEL = 14055&

'//
'// MessageId: ERROR_SXS_XML_E_BADXMLDECL
'//
'// MessageText:
'//
'// Manifest Parse Error : Invalid xml declaration.
'//
%ERROR_SXS_XML_E_BADXMLDECL       = 14056&

'//
'// MessageId: ERROR_SXS_XML_E_MISSINGROOT
'//
'// MessageText:
'//
'// Manifest Parse Error : XML document must have a top level element.
'//
%ERROR_SXS_XML_E_MISSINGROOT      = 14057&

'//
'// MessageId: ERROR_SXS_XML_E_UNEXPECTEDEOF
'//
'// MessageText:
'//
'// Manifest Parse Error : Unexpected end of file.
'//
%ERROR_SXS_XML_E_UNEXPECTEDEOF    = 14058&

'//
'// MessageId: ERROR_SXS_XML_E_BADPEREFINSUBSET
'//
'// MessageText:
'//
'// Manifest Parse Error : Parameter entities cannot be used inside markup declarations in an internal subset.
'//
%ERROR_SXS_XML_E_BADPEREFINSUBSET = 14059&

'//
'// MessageId: ERROR_SXS_XML_E_UNCLOSEDSTARTTAG
'//
'// MessageText:
'//
'// Manifest Parse Error : Element was not closed.
'//
%ERROR_SXS_XML_E_UNCLOSEDSTARTTAG = 14060&

'//
'// MessageId: ERROR_SXS_XML_E_UNCLOSEDENDTAG
'//
'// MessageText:
'//
'// Manifest Parse Error : End element was missing the character '>'.
'//
%ERROR_SXS_XML_E_UNCLOSEDENDTAG   = 14061&

'//
'// MessageId: ERROR_SXS_XML_E_UNCLOSEDSTRING
'//
'// MessageText:
'//
'// Manifest Parse Error : A string literal was not closed.
'//
%ERROR_SXS_XML_E_UNCLOSEDSTRING   = 14062&

'//
'// MessageId: ERROR_SXS_XML_E_UNCLOSEDCOMMENT
'//
'// MessageText:
'//
'// Manifest Parse Error : A comment was not closed.
'//
%ERROR_SXS_XML_E_UNCLOSEDCOMMENT = 14063&

'//
'// MessageId: ERROR_SXS_XML_E_UNCLOSEDDECL
'//
'// MessageText:
'//
'// Manifest Parse Error : A declaration was not closed.
'//
%ERROR_SXS_XML_E_UNCLOSEDDECL     = 14064&

'//
'// MessageId: ERROR_SXS_XML_E_UNCLOSEDCDATA
'//
'// MessageText:
'//
'// Manifest Parse Error : A CDATA section was not closed.
'//
%ERROR_SXS_XML_E_UNCLOSEDCDATA    = 14065&

'//
'// MessageId: ERROR_SXS_XML_E_RESERVEDNAMESPACE
'//
'// MessageText:
'//
'// Manifest Parse Error : The namespace prefix is not allowed to start with the reserved string "xml".
'//
%ERROR_SXS_XML_E_RESERVEDNAMESPACE = 14066&

'//
'// MessageId: ERROR_SXS_XML_E_INVALIDENCODING
'//
'// MessageText:
'//
'// Manifest Parse Error : System does not support the specified encoding.
'//
%ERROR_SXS_XML_E_INVALIDENCODING = 14067&

'//
'// MessageId: ERROR_SXS_XML_E_INVALIDSWITCH
'//
'// MessageText:
'//
'// Manifest Parse Error : Switch from current encoding to specified encoding not supported.
'//
%ERROR_SXS_XML_E_INVALIDSWITCH    = 14068&

'//
'// MessageId: ERROR_SXS_XML_E_BADXMLCASE
'//
'// MessageText:
'//
'// Manifest Parse Error : The name 'xml' is reserved and must be lower case.
'//
%ERROR_SXS_XML_E_BADXMLCASE       = 14069&

'//
'// MessageId: ERROR_SXS_XML_E_INVALID_STANDALONE
'//
'// MessageText:
'//
'// Manifest Parse Error : The standalone attribute must have the value 'yes' or 'no'.
'//
%ERROR_SXS_XML_E_INVALID_STANDALONE = 14070&

'//
'// MessageId: ERROR_SXS_XML_E_UNEXPECTED_STANDALONE
'//
'// MessageText:
'//
'// Manifest Parse Error : The standalone attribute cannot be used in external entities.
'//
%ERROR_SXS_XML_E_UNEXPECTED_STANDALONE = 14071&

'//
'// MessageId: ERROR_SXS_XML_E_INVALID_VERSION
'//
'// MessageText:
'//
'// Manifest Parse Error : Invalid version number.
'//
%ERROR_SXS_XML_E_INVALID_VERSION = 14072&

'//
'// MessageId: ERROR_SXS_XML_E_MISSINGEQUALS
'//
'// MessageText:
'//
'// Manifest Parse Error : Missing equals sign between attribute and attribute value.
'//
%ERROR_SXS_XML_E_MISSINGEQUALS    = 14073&

'//
'// MessageId: ERROR_SXS_PROTECTION_RECOVERY_FAILED
'//
'// MessageText:
'//
'// Assembly Protection Error : Unable to recover the specified assembly.
'//
%ERROR_SXS_PROTECTION_RECOVERY_FAILED = 14074&

'//
'// MessageId: ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT
'//
'// MessageText:
'//
'// Assembly Protection Error : The public key for an assembly was too short to be allowed.
'//
%ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT = 14075&

'//
'// MessageId: ERROR_SXS_PROTECTION_CATALOG_NOT_VALID
'//
'// MessageText:
'//
'// Assembly Protection Error : The catalog for an assembly is not valid, or does not match the assembly's manifest.
'//
%ERROR_SXS_PROTECTION_CATALOG_NOT_VALID = 14076&

'//
'// MessageId: ERROR_SXS_UNTRANSLATABLE_HRESULT
'//
'// MessageText:
'//
'// An HRESULT could not be translated to a corresponding Win32 error code.
'//
%ERROR_SXS_UNTRANSLATABLE_HRESULT = 14077&

'//
'// MessageId: ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING
'//
'// MessageText:
'//
'// Assembly Protection Error : The catalog for an assembly is missing.
'//
%ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING = 14078&

'//
'// MessageId: ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE
'//
'// MessageText:
'//
'// The supplied assembly identity is missing one or more attributes which must be present in this context.
'//
%ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE = 14079&

'//
'// MessageId: ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME
'//
'// MessageText:
'//
'// The supplied assembly identity has one or more attribute names that contain characters not permitted in XML names.
'//
%ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME = 14080&

'//
'// MessageId: ERROR_SXS_ASSEMBLY_MISSING
'//
'// MessageText:
'//
'// The referenced assembly could not be found.
'//
%ERROR_SXS_ASSEMBLY_MISSING       = 14081&

'//
'// MessageId: ERROR_SXS_CORRUPT_ACTIVATION_STACK
'//
'// MessageText:
'//
'// The activation context activation stack for the running thread of execution is corrupt.
'//
%ERROR_SXS_CORRUPT_ACTIVATION_STACK = 14082&

'//
'// MessageId: ERROR_SXS_CORRUPTION
'//
'// MessageText:
'//
'// The application isolation metadata for this process or thread has become corrupt.
'//
%ERROR_SXS_CORRUPTION             = 14083&

'//
'// MessageId: ERROR_SXS_EARLY_DEACTIVATION
'//
'// MessageText:
'//
'// The activation context being deactivated is not the most recently activated one.
'//
%ERROR_SXS_EARLY_DEACTIVATION     = 14084&

'//
'// MessageId: ERROR_SXS_INVALID_DEACTIVATION
'//
'// MessageText:
'//
'// The activation context being deactivated is not active for the current thread of execution.
'//
%ERROR_SXS_INVALID_DEACTIVATION   = 14085&

'//
'// MessageId: ERROR_SXS_MULTIPLE_DEACTIVATION
'//
'// MessageText:
'//
'// The activation context being deactivated has already been deactivated.
'//
%ERROR_SXS_MULTIPLE_DEACTIVATION = 14086&

'//
'// MessageId: ERROR_SXS_PROCESS_TERMINATION_REQUESTED
'//
'// MessageText:
'//
'// A component used by the isolation facility has requested to terminate the process.
'//
%ERROR_SXS_PROCESS_TERMINATION_REQUESTED = 14087&

'//
'// MessageId: ERROR_SXS_RELEASE_ACTIVATION_CONTEXT
'//
'// MessageText:
'//
'// A kernel mode component is releasing a reference on an activation context.
'//
%ERROR_SXS_RELEASE_ACTIVATION_CONTEXT = 14088&

'//
'// MessageId: ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY
'//
'// MessageText:
'//
'// The activation context of system default assembly could not be generated.
'//
%ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY = 14089&

'//
'// MessageId: ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE
'//
'// MessageText:
'//
'// The value of an attribute in an identity is not within the legal range.
'//
%ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE = 14090&

'//
'// MessageId: ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME
'//
'// MessageText:
'//
'// The name of an attribute in an identity is not within the legal range.
'//
%ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME = 14091&

'//
'// MessageId: ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE
'//
'// MessageText:
'//
'// An identity contains two definitions for the same attribute.
'//
%ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE = 14092&

'//
'// MessageId: ERROR_SXS_IDENTITY_PARSE_ERROR
'//
'// MessageText:
'//
'// The identity string is malformed. This may be due to a trailing comma, more than two unnamed attributes, missing attribute name or missing attribute value.
'//
%ERROR_SXS_IDENTITY_PARSE_ERROR   = 14093&

'//
'// MessageId: ERROR_MALFORMED_SUBSTITUTION_STRING
'//
'// MessageText:
'//
'// A string containing localized substitutable content was malformed. Either a dollar sign ($) was follwed by something other than a left parenthesis or another dollar sign or an substitution's right parenthesis was not found.
'//
%ERROR_MALFORMED_SUBSTITUTION_STRING = 14094&

'//
'// MessageId: ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN
'//
'// MessageText:
'//
'// The public key token does not correspond to the public key specified.
'//
%ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN = 14095&

'//
'// MessageId: ERROR_UNMAPPED_SUBSTITUTION_STRING
'//
'// MessageText:
'//
'// A substitution string had no mapping.
'//
%ERROR_UNMAPPED_SUBSTITUTION_STRING = 14096&

'//
'// MessageId: ERROR_SXS_ASSEMBLY_NOT_LOCKED
'//
'// MessageText:
'//
'// The component must be locked before making the request.
'//
%ERROR_SXS_ASSEMBLY_NOT_LOCKED    = 14097&

'//
'// MessageId: ERROR_SXS_COMPONENT_STORE_CORRUPT
'//
'// MessageText:
'//
'// The component store has been corrupted.
'//
%ERROR_SXS_COMPONENT_STORE_CORRUPT = 14098&

'//
'// MessageId: ERROR_ADVANCED_INSTALLER_FAILED
'//
'// MessageText:
'//
'// An advanced installer failed during setup or servicing.
'//
%ERROR_ADVANCED_INSTALLER_FAILED = 14099&

'//
'// MessageId: ERROR_XML_ENCODING_MISMATCH
'//
'// MessageText:
'//
'// The character encoding in the XML declaration did not match the encoding used in the document.
'//
%ERROR_XML_ENCODING_MISMATCH      = 14100&

'//
'// MessageId: ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT
'//
'// MessageText:
'//
'// The identities of the manifests are identical but their contents are different.
'//
%ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT = 14101&

'//
'// MessageId: ERROR_SXS_IDENTITIES_DIFFERENT
'//
'// MessageText:
'//
'// The component identities are different.
'//
%ERROR_SXS_IDENTITIES_DIFFERENT   = 14102&

'//
'// MessageId: ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT
'//
'// MessageText:
'//
'// The assembly is not a deployment.
'//
%ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT = 14103&

'//
'// MessageId: ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY
'//
'// MessageText:
'//
'// The file is not a part of the assembly.
'//
%ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY = 14104&

'//
'// MessageId: ERROR_SXS_MANIFEST_TOO_BIG
'//
'// MessageText:
'//
'// The size of the manifest exceeds the maximum allowed.
'//
%ERROR_SXS_MANIFEST_TOO_BIG       = 14105&

'//
'// MessageId: ERROR_SXS_SETTING_NOT_REGISTERED
'//
'// MessageText:
'//
'// The setting is not registered.
'//
%ERROR_SXS_SETTING_NOT_REGISTERED = 14106&

'//
'// MessageId: ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE
'//
'// MessageText:
'//
'// One or more required members of the transaction are not present.
'//
%ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE = 14107&

'//
'// MessageId: ERROR_SMI_PRIMITIVE_INSTALLER_FAILED
'//
'// MessageText:
'//
'// The SMI primitive installer failed during setup or servicing.
'//
%ERROR_SMI_PRIMITIVE_INSTALLER_FAILED = 14108&

'//
'// MessageId: ERROR_GENERIC_COMMAND_FAILED
'//
'// MessageText:
'//
'// A generic command executable returned a result that indicates failure.
'//
%ERROR_GENERIC_COMMAND_FAILED     = 14109&

'//
'// MessageId: ERROR_SXS_FILE_HASH_MISSING
'//
'// MessageText:
'//
'// A component is missing file verification information in its manifest.
'//
%ERROR_SXS_FILE_HASH_MISSING      = 14110&


'///////////////////////////////////////////////////
'//                                               //
'//           End of Side By Side Error Codes     //
'//                                               //
'//                 = 14000 to 14999              //
'///////////////////////////////////////////////////


'///////////////////////////////////////////////////
'//                                               //
'//           Start of WinEvt Error codes         //
'//                                               //
'//                 = 15000 to 15079              //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_EVT_INVALID_CHANNEL_PATH
'//
'// MessageText:
'//
'// The specified channel path is invalid.
'//
%ERROR_EVT_INVALID_CHANNEL_PATH   = 15000&

'//
'// MessageId: ERROR_EVT_INVALID_QUERY
'//
'// MessageText:
'//
'// The specified query is invalid.
'//
%ERROR_EVT_INVALID_QUERY          = 15001&

'//
'// MessageId: ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND
'//
'// MessageText:
'//
'// The publisher metadata cannot be found in the resource.
'//
%ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND = 15002&

'//
'// MessageId: ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND
'//
'// MessageText:
'//
'// The template for an event definition cannot be found in the resource (error = %1).
'//
%ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND = 15003&

'//
'// MessageId: ERROR_EVT_INVALID_PUBLISHER_NAME
'//
'// MessageText:
'//
'// The specified publisher name is invalid.
'//
%ERROR_EVT_INVALID_PUBLISHER_NAME = 15004&

'//
'// MessageId: ERROR_EVT_INVALID_EVENT_DATA
'//
'// MessageText:
'//
'// The event data raised by the publisher is not compatible with the event template definition in the publisher's manifest
'//
%ERROR_EVT_INVALID_EVENT_DATA     = 15005&

'//
'// MessageId: ERROR_EVT_CHANNEL_NOT_FOUND
'//
'// MessageText:
'//
'// The specified channel could not be found. Check channel configuration.
'//
%ERROR_EVT_CHANNEL_NOT_FOUND      = 15007&

'//
'// MessageId: ERROR_EVT_MALFORMED_XML_TEXT
'//
'// MessageText:
'//
'// The specified xml text was not well-formed. See Extended Error for more details.
'//
%ERROR_EVT_MALFORMED_XML_TEXT     = 15008&

'//
'// MessageId: ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL
'//
'// MessageText:
'//
'// The caller is trying to subscribe to a direct channel which is not allowed. The events for a direct channel go directly to a logfile and cannot be subscribed to.
'//
%ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL = 15009&

'//
'// MessageId: ERROR_EVT_CONFIGURATION_ERROR
'//
'// MessageText:
'//
'// Configuration error.
'//
%ERROR_EVT_CONFIGURATION_ERROR    = 15010&

'//
'// MessageId: ERROR_EVT_QUERY_RESULT_STALE
'//
'// MessageText:
'//
'// The query result is stale / invalid. This may be due to the log being cleared or rolling over after the query result was created. Users should handle this code by releasing the query result object and reissuing the query.
'//
%ERROR_EVT_QUERY_RESULT_STALE     = 15011&

'//
'// MessageId: ERROR_EVT_QUERY_RESULT_INVALID_POSITION
'//
'// MessageText:
'//
'// Query result is currently at an invalid position.
'//
%ERROR_EVT_QUERY_RESULT_INVALID_POSITION = 15012&

'//
'// MessageId: ERROR_EVT_NON_VALIDATING_MSXML
'//
'// MessageText:
'//
'// Registered MSXML doesn't support validation.
'//
%ERROR_EVT_NON_VALIDATING_MSXML   = 15013&

'//
'// MessageId: ERROR_EVT_FILTER_ALREADYSCOPED
'//
'// MessageText:
'//
'// An expression can only be followed by a change of scope operation if it itself evaluates to a node set and is not already part of some other change of scope operation.
'//
%ERROR_EVT_FILTER_ALREADYSCOPED   = 15014&

'//
'// MessageId: ERROR_EVT_FILTER_NOTELTSET
'//
'// MessageText:
'//
'// Can't perform a step operation from a term that does not represent an element set.
'//
%ERROR_EVT_FILTER_NOTELTSET       = 15015&

'//
'// MessageId: ERROR_EVT_FILTER_INVARG
'//
'// MessageText:
'//
'// Left hand side arguments to binary operators must be either attributes, nodes or variables and right hand side arguments must be constants.
'//
%ERROR_EVT_FILTER_INVARG          = 15016&

'//
'// MessageId: ERROR_EVT_FILTER_INVTEST
'//
'// MessageText:
'//
'// A step operation must involve either a node test or, in the case of a predicate, an algebraic expression against which to test each node in the node set identified by the preceeding node set can be evaluated.
'//
%ERROR_EVT_FILTER_INVTEST         = 15017&

'//
'// MessageId: ERROR_EVT_FILTER_INVTYPE
'//
'// MessageText:
'//
'// This data type is currently unsupported.
'//
%ERROR_EVT_FILTER_INVTYPE         = 15018&

'//
'// MessageId: ERROR_EVT_FILTER_PARSEERR
'//
'// MessageText:
'//
'// A syntax error occurred at position %1!d!
'//
%ERROR_EVT_FILTER_PARSEERR        = 15019&

'//
'// MessageId: ERROR_EVT_FILTER_UNSUPPORTEDOP
'//
'// MessageText:
'//
'// This operator is unsupported by this implementation of the filter.
'//
%ERROR_EVT_FILTER_UNSUPPORTEDOP   = 15020&

'//
'// MessageId: ERROR_EVT_FILTER_UNEXPECTEDTOKEN
'//
'// MessageText:
'//
'// The token encountered was unexpected.
'//
%ERROR_EVT_FILTER_UNEXPECTEDTOKEN = 15021&

'//
'// MessageId: ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL
'//
'// MessageText:
'//
'// The requested operation cannot be performed over an enabled direct channel. The channel must first be disabled before performing the requested operation.
'//
%ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL = 15022&

'//
'// MessageId: ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE
'//
'// MessageText:
'//
'// Channel property %1!s! contains invalid value. The value has invalid type, is outside of valid range, can't be updated or is not supported by this type of channel.
'//
%ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE = 15023&

'//
'// MessageId: ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE
'//
'// MessageText:
'//
'// Publisher property %1!s! contains invalid value. The value has invalid type, is outside of valid range, can't be updated or is not supported by this type of publisher.
'//
%ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE = 15024&

'//
'// MessageId: ERROR_EVT_CHANNEL_CANNOT_ACTIVATE
'//
'// MessageText:
'//
'// The channel fails to activate.
'//
%ERROR_EVT_CHANNEL_CANNOT_ACTIVATE = 15025&

'//
'// MessageId: ERROR_EVT_FILTER_TOO_COMPLEX
'//
'// MessageText:
'//
'// The xpath expression exceeded supported complexity. Please symplify it or split it into two or more simple expressions.
'//
%ERROR_EVT_FILTER_TOO_COMPLEX     = 15026&

'//
'// MessageId: ERROR_EVT_MESSAGE_NOT_FOUND
'//
'// MessageText:
'//
'// the message resource is present but the message is not found in the string/message table
'//
%ERROR_EVT_MESSAGE_NOT_FOUND      = 15027&

'//
'// MessageId: ERROR_EVT_MESSAGE_ID_NOT_FOUND
'//
'// MessageText:
'//
'// The message id for the desired message could not be found.
'//
%ERROR_EVT_MESSAGE_ID_NOT_FOUND   = 15028&

'//
'// MessageId: ERROR_EVT_UNRESOLVED_VALUE_INSERT
'//
'// MessageText:
'//
'// The substitution string for insert index (%1) could not be found.
'//
%ERROR_EVT_UNRESOLVED_VALUE_INSERT = 15029&

'//
'// MessageId: ERROR_EVT_UNRESOLVED_PARAMETER_INSERT
'//
'// MessageText:
'//
'// The description string for parameter reference (%1) could not be found.
'//
%ERROR_EVT_UNRESOLVED_PARAMETER_INSERT = 15030&

'//
'// MessageId: ERROR_EVT_MAX_INSERTS_REACHED
'//
'// MessageText:
'//
'// The maximum number of replacements has been reached.
'//
%ERROR_EVT_MAX_INSERTS_REACHED    = 15031&

'//
'// MessageId: ERROR_EVT_EVENT_DEFINITION_NOT_FOUND
'//
'// MessageText:
'//
'// The event definition could not be found for event id (%1).
'//
%ERROR_EVT_EVENT_DEFINITION_NOT_FOUND = 15032&

'//
'// MessageId: ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND
'//
'// MessageText:
'//
'// The locale specific resource for the desired message is not present.
'//
%ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND = 15033&

'//
'// MessageId: ERROR_EVT_VERSION_TOO_OLD
'//
'// MessageText:
'//
'// The resource is too old to be compatible.
'//
%ERROR_EVT_VERSION_TOO_OLD        = 15034&

'//
'// MessageId: ERROR_EVT_VERSION_TOO_NEW
'//
'// MessageText:
'//
'// The resource is too new to be compatible.
'//
%ERROR_EVT_VERSION_TOO_NEW        = 15035&

'//
'// MessageId: ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY
'//
'// MessageText:
'//
'// The channel at index %1!d! of the query can't be opened.
'//
%ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY = 15036&

'//
'// MessageId: ERROR_EVT_PUBLISHER_DISABLED
'//
'// MessageText:
'//
'// The publisher has been disabled and its resource is not avaiable.  This
'// usually occurs when the publisher is in the process of being uninstalled
'// or upgraded.
'//
%ERROR_EVT_PUBLISHER_DISABLED     = 15037&

'//
'// MessageId: ERROR_EVT_FILTER_OUT_OF_RANGE
'//
'// MessageText:
'//
'// Attempted to create a numeric type that is outside of its valid range.
'//
%ERROR_EVT_FILTER_OUT_OF_RANGE    = 15038&


'///////////////////////////////////////////////////
'//                                               //
'//           Start of Wecsvc Error codes         //
'//                                               //
'//                 = 15080 to 15099              //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE
'//
'// MessageText:
'//
'// The subscription fails to activate.
'//
%ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE = 15080&

'//
'// MessageId: ERROR_EC_LOG_DISABLED
'//
'// MessageText:
'//
'// The log of the subscription is in disabled state, and can not be used to forward events to. The log must first be enabled before the subscription can be activated.
'//
%ERROR_EC_LOG_DISABLED            = 15081&

'//
'// MessageId: ERROR_EC_CIRCULAR_FORWARDING
'//
'// MessageText:
'//
'// When forwarding events from local machine to itself, the query of the subscription can't contain target log of the subscription.
'//
%ERROR_EC_CIRCULAR_FORWARDING     = 15082&

'//
'// MessageId: ERROR_EC_CREDSTORE_FULL
'//
'// MessageText:
'//
'// The credential store that is used to save credentials is full.
'//
%ERROR_EC_CREDSTORE_FULL          = 15083&

'//
'// MessageId: ERROR_EC_CRED_NOT_FOUND
'//
'// MessageText:
'//
'// The credential used by this subscription can't be found in credential store.
'//
%ERROR_EC_CRED_NOT_FOUND          = 15084&

'//
'// MessageId: ERROR_EC_NO_ACTIVE_CHANNEL
'//
'// MessageText:
'//
'// No active channel is found for the query.
'//
%ERROR_EC_NO_ACTIVE_CHANNEL       = 15085&


'///////////////////////////////////////////////////
'//                                               //
'//           Start of MUI Error codes            //
'//                                               //
'//                 = 15100 to 15199              //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_MUI_FILE_NOT_FOUND
'//
'// MessageText:
'//
'// The resource loader failed to find MUI file.
'//
%ERROR_MUI_FILE_NOT_FOUND         = 15100&

'//
'// MessageId: ERROR_MUI_INVALID_FILE
'//
'// MessageText:
'//
'// The resource loader failed to load MUI file because the file fail to pass validation.
'//
%ERROR_MUI_INVALID_FILE           = 15101&

'//
'// MessageId: ERROR_MUI_INVALID_RC_CONFIG
'//
'// MessageText:
'//
'// The RC Manifest is corrupted with garbage data or unsupported version or missing required item.
'//
%ERROR_MUI_INVALID_RC_CONFIG      = 15102&

'//
'// MessageId: ERROR_MUI_INVALID_LOCALE_NAME
'//
'// MessageText:
'//
'// The RC Manifest has invalid culture name.
'//
%ERROR_MUI_INVALID_LOCALE_NAME    = 15103&

'//
'// MessageId: ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME
'//
'// MessageText:
'//
'// The RC Manifest has invalid ultimatefallback name.
'//
%ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME = 15104&

'//
'// MessageId: ERROR_MUI_FILE_NOT_LOADED
'//
'// MessageText:
'//
'// The resource loader cache doesn't have loaded MUI entry.
'//
%ERROR_MUI_FILE_NOT_LOADED        = 15105&

'//
'// MessageId: ERROR_RESOURCE_ENUM_USER_STOP
'//
'// MessageText:
'//
'// User stopped resource enumeration.
'//
%ERROR_RESOURCE_ENUM_USER_STOP    = 15106&

'//
'// MessageId: ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED
'//
'// MessageText:
'//
'// UI language installation failed.
'//
%ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED = 15107&

'//
'// MessageId: ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME
'//
'// MessageText:
'//
'// Locale installation failed.
'//
%ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME = 15108&


'///////////////////////////////////////////////////
'//                                               //
'// Start of Monitor Configuration API error codes//
'//                                               //
'//                 = 15200 to 15249              //
'///////////////////////////////////////////////////

'//
'// MessageId: ERROR_MCA_INVALID_CAPABILITIES_STRING
'//
'// MessageText:
'//
'// The monitor returned a DDC/CI capabilities string that did not comply with the ACCESS.bus 3.0, DDC/CI 1.1 or MCCS 2 Revision 1 specification.
'//
%ERROR_MCA_INVALID_CAPABILITIES_STRING = 15200&

'//
'// MessageId: ERROR_MCA_INVALID_VCP_VERSION
'//
'// MessageText:
'//
'// The monitor's VCP Version (0xDF) VCP code returned an invalid version value.
'//
%ERROR_MCA_INVALID_VCP_VERSION    = 15201&

'//
'// MessageId: ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION
'//
'// MessageText:
'//
'// The monitor does not comply with the MCCS specification it claims to support.
'//
%ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION = 15202&

'//
'// MessageId: ERROR_MCA_MCCS_VERSION_MISMATCH
'//
'// MessageText:
'//
'// The MCCS version in a monitor's mccs_ver capability does not match the MCCS version the monitor reports when the VCP Version (0xDF) VCP code is used.
'//
%ERROR_MCA_MCCS_VERSION_MISMATCH = 15203&

'//
'// MessageId: ERROR_MCA_UNSUPPORTED_MCCS_VERSION
'//
'// MessageText:
'//
'// The Monitor Configuration API only works with monitors that support the MCCS 1.0 specification, MCCS 2.0 specification or the MCCS 2.0 Revision 1 specification.
'//
%ERROR_MCA_UNSUPPORTED_MCCS_VERSION = 15204&

'//
'// MessageId: ERROR_MCA_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal Monitor Configuration API error occurred.
'//
%ERROR_MCA_INTERNAL_ERROR         = 15205&

'//
'// MessageId: ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED
'//
'// MessageText:
'//
'// The monitor returned an invalid monitor technology type. CRT, Plasma and LCD (TFT) are examples of monitor technology types. This error implies that the monitor violated the MCCS 2.0 or MCCS 2.0 Revision 1 specification.
'//
%ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED = 15206&

'//
'// MessageId: ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE
'//
'// MessageText:
'//
'// The caller of SetMonitorColorTemperature specified a color temperature that the current monitor did not support. This error implies that the monitor violated the MCCS 2.0 or MCCS 2.0 Revision 1 specification.
'//
%ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE = 15207&


'//////////////////////////////////////////////////
'//                                              //
'// End of Monitor Configuration API error codes //
'//                                              //
'//                = 15200 to 15249              //
'//                                              //
'//////////////////////////////////////////////////
'//////////////////////////////////////////////////
'//                                              //
'//         Start of Syspart error codes         //
'//                = 15250 - 15299               //
'//                                              //
'//////////////////////////////////////////////////

'//
'// MessageId: ERROR_AMBIGUOUS_SYSTEM_DEVICE
'//
'// MessageText:
'//
'// The requested system device cannot be identified due to multiple indistinguishable devices potentially matching the identification criteria.
'//
%ERROR_AMBIGUOUS_SYSTEM_DEVICE    = 15250&

'//
'// MessageId: ERROR_SYSTEM_DEVICE_NOT_FOUND
'//
'// MessageText:
'//
'// The requested system device cannot be found.
'//
%ERROR_SYSTEM_DEVICE_NOT_FOUND    = 15299&

'////////////////////////////////////
'//                                //
'//     COM Error Codes            //
'//                                //
'////////////////////////////////////


'//
'// The return value of COM functions and methods is an HRESULT.
'// This is not a handle to anything, but is merely a 32-bit value
'// with several fields encoded in the value. The parts of an
'// HRESULT are shown below.
'//
'// Many of the macros and functions below were orginally defined to
'// operate on SCODEs. SCODEs are no longer used. The macros are
'// still present for compatibility and easy porting of Win16 code.
'// Newly written code should use the HRESULT macros and functions.
'//

'//
'//  HRESULTs are 32 bit values layed out as follows:
'//
'//   = 3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
'//   = 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
'//  +-+-+-+-+-+---------------------+-------------------------------+
'//  |S|R|C|N|r|    Facility         |               Code            |
'//  +-+-+-+-+-+---------------------+-------------------------------+
'//
'//  where
'//
'//      S - Severity - indicates success/fail
'//
'//          0 - Success
'//          = 1 - Fail (COERROR)
'//
'//      R - reserved portion of the facility code, corresponds to NT's
'//              second severity bit.
'//
'//      C - reserved portion of the facility code, corresponds to NT's
'//              C field.
'//
'//      N - reserved portion of the facility code. Used to indicate a
'//              mapped NT status value.
'//
'//      r - reserved portion of the facility code. Reserved for internal
'//              use. Used to indicate HRESULT values that are not status
'//              values, but are instead message ids for display strings.
'//
'//      Facility - is the facility code
'//
'//      Code - is the facility's status code
'//

'//
'// Severity values
'//

%SEVERITY_SUCCESS    = 0
%SEVERITY_ERROR      = 1

%FACILITY_NT_BIT                 = &H10000000

%NOERROR            = 0

%E_UNEXPECTED                     = &H8000FFFF&

'#if defined(_WIN32) && !defined(_MAC)
'//
'// MessageId: E_NOTIMPL
'//
'// MessageText:
'//
'// Not implemented
'//
%E_NOTIMPL                        = &H80004001&

'//
'// MessageId: E_OUTOFMEMORY
'//
'// MessageText:
'//
'// Ran out of memory
'//
%E_OUTOFMEMORY                    = &H8007000E&

'//
'// MessageId: E_INVALIDARG
'//
'// MessageText:
'//
'// One or more arguments are invalid
'//
%E_INVALIDARG                     = &H80070057&

'//
'// MessageId: E_NOINTERFACE
'//
'// MessageText:
'//
'// No such interface supported
'//
%E_NOINTERFACE                    = &H80004002&

'//
'// MessageId: E_POINTER
'//
'// MessageText:
'//
'// Invalid pointer
'//
%E_POINTER                        = &H80004003&

'//
'// MessageId: E_HANDLE
'//
'// MessageText:
'//
'// Invalid handle
'//
%E_HANDLE                         = &H80070006&

'//
'// MessageId: E_ABORT
'//
'// MessageText:
'//
'// Operation aborted
'//
%E_ABORT                          = &H80004004&

'//
'// MessageId: E_FAIL
'//
'// MessageText:
'//
'// Unspecified error
'//
%E_FAIL                           = &H80004005&

'//
'// MessageId: E_ACCESSDENIED
'//
'// MessageText:
'//
'// General access denied error
'//
%E_ACCESSDENIED                   = &H80070005&

'#endif '//WIN32

'//
'// MessageId: E_PENDING
'//
'// MessageText:
'//
'// The data necessary to complete this operation is not yet available.
'//
%E_PENDING                        = &H8000000A&

'//
'// MessageId: CO_E_INIT_TLS
'//
'// MessageText:
'//
'// Thread local storage failure
'//
%CO_E_INIT_TLS                    = &H80004006&

'//
'// MessageId: CO_E_INIT_SHARED_ALLOCATOR
'//
'// MessageText:
'//
'// Get shared memory allocator failure
'//
%CO_E_INIT_SHARED_ALLOCATOR       = &H80004007&

'//
'// MessageId: CO_E_INIT_MEMORY_ALLOCATOR
'//
'// MessageText:
'//
'// Get memory allocator failure
'//
%CO_E_INIT_MEMORY_ALLOCATOR       = &H80004008&

'//
'// MessageId: CO_E_INIT_CLASS_CACHE
'//
'// MessageText:
'//
'// Unable to initialize class cache
'//
%CO_E_INIT_CLASS_CACHE            = &H80004009&

'//
'// MessageId: CO_E_INIT_RPC_CHANNEL
'//
'// MessageText:
'//
'// Unable to initialize RPC services
'//
%CO_E_INIT_RPC_CHANNEL            = &H8000400A&

'//
'// MessageId: CO_E_INIT_TLS_SET_CHANNEL_CONTROL
'//
'// MessageText:
'//
'// Cannot set thread local storage channel control
'//
%CO_E_INIT_TLS_SET_CHANNEL_CONTROL = &H8000400B&

'//
'// MessageId: CO_E_INIT_TLS_CHANNEL_CONTROL
'//
'// MessageText:
'//
'// Could not allocate thread local storage channel control
'//
%CO_E_INIT_TLS_CHANNEL_CONTROL    = &H8000400C&

'//
'// MessageId: CO_E_INIT_UNACCEPTED_USER_ALLOCATOR
'//
'// MessageText:
'//
'// The user supplied memory allocator is unacceptable
'//
%CO_E_INIT_UNACCEPTED_USER_ALLOCATOR = &H8000400D&

'//
'// MessageId: CO_E_INIT_SCM_MUTEX_EXISTS
'//
'// MessageText:
'//
'// The OLE service mutex already exists
'//
%CO_E_INIT_SCM_MUTEX_EXISTS       = &H8000400E&

'//
'// MessageId: CO_E_INIT_SCM_FILE_MAPPING_EXISTS
'//
'// MessageText:
'//
'// The OLE service file mapping already exists
'//
%CO_E_INIT_SCM_FILE_MAPPING_EXISTS = &H8000400F&

'//
'// MessageId: CO_E_INIT_SCM_MAP_VIEW_OF_FILE
'//
'// MessageText:
'//
'// Unable to map view of file for OLE service
'//
%CO_E_INIT_SCM_MAP_VIEW_OF_FILE   = &H80004010&

'//
'// MessageId: CO_E_INIT_SCM_EXEC_FAILURE
'//
'// MessageText:
'//
'// Failure attempting to launch OLE service
'//
%CO_E_INIT_SCM_EXEC_FAILURE       = &H80004011&

'//
'// MessageId: CO_E_INIT_ONLY_SINGLE_THREADED
'//
'// MessageText:
'//
'// There was an attempt to call CoInitialize a second time while single threaded
'//
%CO_E_INIT_ONLY_SINGLE_THREADED   = &H80004012&

'//
'// MessageId: CO_E_CANT_REMOTE
'//
'// MessageText:
'//
'// A Remote activation was necessary but was not allowed
'//
%CO_E_CANT_REMOTE                 = &H80004013&

'//
'// MessageId: CO_E_BAD_SERVER_NAME
'//
'// MessageText:
'//
'// A Remote activation was necessary but the server name provided was invalid
'//
%CO_E_BAD_SERVER_NAME             = &H80004014&

'//
'// MessageId: CO_E_WRONG_SERVER_IDENTITY
'//
'// MessageText:
'//
'// The class is configured to run as a security id different from the caller
'//
%CO_E_WRONG_SERVER_IDENTITY       = &H80004015&

'//
'// MessageId: CO_E_OLE1DDE_DISABLED
'//
'// MessageText:
'//
'// Use of Ole1 services requiring DDE windows is disabled
'//
%CO_E_OLE1DDE_DISABLED            = &H80004016&

'//
'// MessageId: CO_E_RUNAS_SYNTAX
'//
'// MessageText:
'//
'// A RunAs specification must be <domain name>\<user name> or simply <user name>
'//
%CO_E_RUNAS_SYNTAX                = &H80004017&

'//
'// MessageId: CO_E_CREATEPROCESS_FAILURE
'//
'// MessageText:
'//
'// The server process could not be started. The pathname may be incorrect.
'//
%CO_E_CREATEPROCESS_FAILURE       = &H80004018&

'//
'// MessageId: CO_E_RUNAS_CREATEPROCESS_FAILURE
'//
'// MessageText:
'//
'// The server process could not be started as the configured identity. The pathname may be incorrect or unavailable.
'//
%CO_E_RUNAS_CREATEPROCESS_FAILURE = &H80004019&

'//
'// MessageId: CO_E_RUNAS_LOGON_FAILURE
'//
'// MessageText:
'//
'// The server process could not be started because the configured identity is incorrect. Check the username and password.
'//
%CO_E_RUNAS_LOGON_FAILURE         = &H8000401A&

'//
'// MessageId: CO_E_LAUNCH_PERMSSION_DENIED
'//
'// MessageText:
'//
'// The client is not allowed to launch this server.
'//
%CO_E_LAUNCH_PERMSSION_DENIED     = &H8000401B&

'//
'// MessageId: CO_E_START_SERVICE_FAILURE
'//
'// MessageText:
'//
'// The service providing this server could not be started.
'//
%CO_E_START_SERVICE_FAILURE       = &H8000401C&

'//
'// MessageId: CO_E_REMOTE_COMMUNICATION_FAILURE
'//
'// MessageText:
'//
'// This computer was unable to communicate with the computer providing the server.
'//
%CO_E_REMOTE_COMMUNICATION_FAILURE = &H8000401D&

'//
'// MessageId: CO_E_SERVER_START_TIMEOUT
'//
'// MessageText:
'//
'// The server did not respond after being launched.
'//
%CO_E_SERVER_START_TIMEOUT        = &H8000401E&

'//
'// MessageId: CO_E_CLSREG_INCONSISTENT
'//
'// MessageText:
'//
'// The registration information for this server is inconsistent or incomplete.
'//
%CO_E_CLSREG_INCONSISTENT         = &H8000401F&

'//
'// MessageId: CO_E_IIDREG_INCONSISTENT
'//
'// MessageText:
'//
'// The registration information for this interface is inconsistent or incomplete.
'//
%CO_E_IIDREG_INCONSISTENT         = &H80004020&

'//
'// MessageId: CO_E_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The operation attempted is not supported.
'//
%CO_E_NOT_SUPPORTED               = &H80004021&

'//
'// MessageId: CO_E_RELOAD_DLL
'//
'// MessageText:
'//
'// A dll must be loaded.
'//
%CO_E_RELOAD_DLL                  = &H80004022&

'//
'// MessageId: CO_E_MSI_ERROR
'//
'// MessageText:
'//
'// A Microsoft Software Installer error was encountered.
'//
%CO_E_MSI_ERROR                   = &H80004023&

'//
'// MessageId: CO_E_ATTEMPT_TO_CREATE_OUTSIDE_CLIENT_CONTEXT
'//
'// MessageText:
'//
'// The specified activation could not occur in the client context as specified.
'//
%CO_E_ATTEMPT_TO_CREATE_OUTSIDE_CLIENT_CONTEXT = &H80004024&

'//
'// MessageId: CO_E_SERVER_PAUSED
'//
'// MessageText:
'//
'// Activations on the server are paused.
'//
%CO_E_SERVER_PAUSED               = &H80004025&

'//
'// MessageId: CO_E_SERVER_NOT_PAUSED
'//
'// MessageText:
'//
'// Activations on the server are not paused.
'//
%CO_E_SERVER_NOT_PAUSED           = &H80004026&

'//
'// MessageId: CO_E_CLASS_DISABLED
'//
'// MessageText:
'//
'// The component or application containing the component has been disabled.
'//
%CO_E_CLASS_DISABLED              = &H80004027&

'//
'// MessageId: CO_E_CLRNOTAVAILABLE
'//
'// MessageText:
'//
'// The common language runtime is not available
'//
%CO_E_CLRNOTAVAILABLE             = &H80004028&

'//
'// MessageId: CO_E_ASYNC_WORK_REJECTED
'//
'// MessageText:
'//
'// The thread-pool rejected the submitted asynchronous work.
'//
%CO_E_ASYNC_WORK_REJECTED         = &H80004029&

'//
'// MessageId: CO_E_SERVER_INIT_TIMEOUT
'//
'// MessageText:
'//
'// The server started, but did not finish initializing in a timely fashion.
'//
%CO_E_SERVER_INIT_TIMEOUT         = &H8000402A&

'//
'// MessageId: CO_E_NO_SECCTX_IN_ACTIVATE
'//
'// MessageText:
'//
'// Unable to complete the call since there is no COM+ security context inside IObjectControl.Activate.
'//
%CO_E_NO_SECCTX_IN_ACTIVATE       = &H8000402B&

'//
'// MessageId: CO_E_TRACKER_CONFIG
'//
'// MessageText:
'//
'// The provided tracker configuration is invalid
'//
%CO_E_TRACKER_CONFIG              = &H80004030&

'//
'// MessageId: CO_E_THREADPOOL_CONFIG
'//
'// MessageText:
'//
'// The provided thread pool configuration is invalid
'//
%CO_E_THREADPOOL_CONFIG           = &H80004031&

'//
'// MessageId: CO_E_SXS_CONFIG
'//
'// MessageText:
'//
'// The provided side-by-side configuration is invalid
'//
%CO_E_SXS_CONFIG                  = &H80004032&

'//
'// MessageId: CO_E_MALFORMED_SPN
'//
'// MessageText:
'//
'// The server principal name (SPN) obtained during security negotiation is malformed.
'//
%CO_E_MALFORMED_SPN               = &H80004033&


'//
'// Success codes
'//
%S_OK                                   = 0&
%S_FALSE                                = 1&

'// ******************
'// FACILITY_ITF
'// ******************

'//
'// Codes 0x0-0x01ff are reserved for the OLE group of
'// interfaces.
'//


'//
'// Generic OLE errors that may be returned by many inerfaces
'//

%OLE_E_FIRST = &H80040000&
%OLE_E_LAST  = &H800400FF&
%OLE_S_FIRST = &H00040000&
%OLE_S_LAST  = &H000400FF&

'//
'// Old OLE errors
'//
'//
'// MessageId: OLE_E_OLEVERB
'//
'// MessageText:
'//
'// Invalid OLEVERB structure
'//
%OLE_E_OLEVERB                    = &H80040000&

'//
'// MessageId: OLE_E_ADVF
'//
'// MessageText:
'//
'// Invalid advise flags
'//
%OLE_E_ADVF                       = &H80040001&

'//
'// MessageId: OLE_E_ENUM_NOMORE
'//
'// MessageText:
'//
'// Can't enumerate any more, because the associated data is missing
'//
%OLE_E_ENUM_NOMORE                = &H80040002&

'//
'// MessageId: OLE_E_ADVISENOTSUPPORTED
'//
'// MessageText:
'//
'// This implementation doesn't take advises
'//
%OLE_E_ADVISENOTSUPPORTED         = &H80040003&

'//
'// MessageId: OLE_E_NOCONNECTION
'//
'// MessageText:
'//
'// There is no connection for this connection ID
'//
%OLE_E_NOCONNECTION               = &H80040004&

'//
'// MessageId: OLE_E_NOTRUNNING
'//
'// MessageText:
'//
'// Need to run the object to perform this operation
'//
%OLE_E_NOTRUNNING                 = &H80040005&

'//
'// MessageId: OLE_E_NOCACHE
'//
'// MessageText:
'//
'// There is no cache to operate on
'//
%OLE_E_NOCACHE                    = &H80040006&

'//
'// MessageId: OLE_E_BLANK
'//
'// MessageText:
'//
'// Uninitialized object
'//
%OLE_E_BLANK                      = &H80040007&

'//
'// MessageId: OLE_E_CLASSDIFF
'//
'// MessageText:
'//
'// Linked object's source class has changed
'//
%OLE_E_CLASSDIFF                  = &H80040008&

'//
'// MessageId: OLE_E_CANT_GETMONIKER
'//
'// MessageText:
'//
'// Not able to get the moniker of the object
'//
%OLE_E_CANT_GETMONIKER            = &H80040009&

'//
'// MessageId: OLE_E_CANT_BINDTOSOURCE
'//
'// MessageText:
'//
'// Not able to bind to the source
'//
%OLE_E_CANT_BINDTOSOURCE          = &H8004000A&

'//
'// MessageId: OLE_E_STATIC
'//
'// MessageText:
'//
'// Object is static; operation not allowed
'//
%OLE_E_STATIC                     = &H8004000B&

'//
'// MessageId: OLE_E_PROMPTSAVECANCELLED
'//
'// MessageText:
'//
'// User canceled out of save dialog
'//
%OLE_E_PROMPTSAVECANCELLED        = &H8004000C&

'//
'// MessageId: OLE_E_INVALIDRECT
'//
'// MessageText:
'//
'// Invalid rectangle
'//
%OLE_E_INVALIDRECT                = &H8004000D&

'//
'// MessageId: OLE_E_WRONGCOMPOBJ
'//
'// MessageText:
'//
'// compobj.dll is too old for the ole2.dll initialized
'//
%OLE_E_WRONGCOMPOBJ               = &H8004000E&

'//
'// MessageId: OLE_E_INVALIDHWND
'//
'// MessageText:
'//
'// Invalid window handle
'//
%OLE_E_INVALIDHWND                = &H8004000F&

'//
'// MessageId: OLE_E_NOT_INPLACEACTIVE
'//
'// MessageText:
'//
'// Object is not in any of the inplace active states
'//
%OLE_E_NOT_INPLACEACTIVE          = &H80040010&

'//
'// MessageId: OLE_E_CANTCONVERT
'//
'// MessageText:
'//
'// Not able to convert object
'//
%OLE_E_CANTCONVERT                = &H80040011&

'//
'// MessageId: OLE_E_NOSTORAGE
'//
'// MessageText:
'//
'// Not able to perform the operation because object is not given storage yet
'//
%OLE_E_NOSTORAGE                  = &H80040012&

'//
'// MessageId: DV_E_FORMATETC
'//
'// MessageText:
'//
'// Invalid FORMATETC structure
'//
%DV_E_FORMATETC                   = &H80040064&

'//
'// MessageId: DV_E_DVTARGETDEVICE
'//
'// MessageText:
'//
'// Invalid DVTARGETDEVICE structure
'//
%DV_E_DVTARGETDEVICE              = &H80040065&

'//
'// MessageId: DV_E_STGMEDIUM
'//
'// MessageText:
'//
'// Invalid STDGMEDIUM structure
'//
%DV_E_STGMEDIUM                   = &H80040066&

'//
'// MessageId: DV_E_STATDATA
'//
'// MessageText:
'//
'// Invalid STATDATA structure
'//
%DV_E_STATDATA                    = &H80040067&

'//
'// MessageId: DV_E_LINDEX
'//
'// MessageText:
'//
'// Invalid lindex
'//
%DV_E_LINDEX                      = &H80040068&

'//
'// MessageId: DV_E_TYMED
'//
'// MessageText:
'//
'// Invalid tymed
'//
%DV_E_TYMED                       = &H80040069&

'//
'// MessageId: DV_E_CLIPFORMAT
'//
'// MessageText:
'//
'// Invalid clipboard format
'//
%DV_E_CLIPFORMAT                  = &H8004006A&

'//
'// MessageId: DV_E_DVASPECT
'//
'// MessageText:
'//
'// Invalid aspect(s)
'//
%DV_E_DVASPECT                    = &H8004006B&

'//
'// MessageId: DV_E_DVTARGETDEVICE_SIZE
'//
'// MessageText:
'//
'// tdSize parameter of the DVTARGETDEVICE structure is invalid
'//
%DV_E_DVTARGETDEVICE_SIZE         = &H8004006C&

'//
'// MessageId: DV_E_NOIVIEWOBJECT
'//
'// MessageText:
'//
'// Object doesn't support IViewObject interface
'//
%DV_E_NOIVIEWOBJECT               = &H8004006D&

%DRAGDROP_E_FIRST = &H80040100&
%DRAGDROP_E_LAST  = &H8004010F&
%DRAGDROP_S_FIRST = &H00040100&
%DRAGDROP_S_LAST  = &H0004010F&
'//
'// MessageId: DRAGDROP_E_NOTREGISTERED
'//
'// MessageText:
'//
'// Trying to revoke a drop target that has not been registered
'//
%DRAGDROP_E_NOTREGISTERED         = &H80040100&

'//
'// MessageId: DRAGDROP_E_ALREADYREGISTERED
'//
'// MessageText:
'//
'// This window has already been registered as a drop target
'//
%DRAGDROP_E_ALREADYREGISTERED     = &H80040101&

'//
'// MessageId: DRAGDROP_E_INVALIDHWND
'//
'// MessageText:
'//
'// Invalid window handle
'//
%DRAGDROP_E_INVALIDHWND           = &H80040102&

%CLASSFACTORY_E_FIRST  = &H80040110&
%CLASSFACTORY_E_LAST   = &H8004011F&
%CLASSFACTORY_S_FIRST  = &H00040110&
%CLASSFACTORY_S_LAST   = &H0004011F&
'//
'// MessageId: CLASS_E_NOAGGREGATION
'//
'// MessageText:
'//
'// Class does not support aggregation (or class object is remote)
'//
%CLASS_E_NOAGGREGATION            = &H80040110&

'//
'// MessageId: CLASS_E_CLASSNOTAVAILABLE
'//
'// MessageText:
'//
'// ClassFactory cannot supply requested class
'//
%CLASS_E_CLASSNOTAVAILABLE        = &H80040111&

'//
'// MessageId: CLASS_E_NOTLICENSED
'//
'// MessageText:
'//
'// Class is not licensed for use
'//
%CLASS_E_NOTLICENSED              = &H80040112&

%MARSHAL_E_FIRST  = &H80040120&
%MARSHAL_E_LAST   = &H8004012F&
%MARSHAL_S_FIRST  = &H00040120&
%MARSHAL_S_LAST   = &H0004012F&
%DATA_E_FIRST     = &H80040130&
%DATA_E_LAST      = &H8004013F&
%DATA_S_FIRST     = &H00040130&
%DATA_S_LAST      = &H0004013F&
%VIEW_E_FIRST     = &H80040140&
%VIEW_E_LAST      = &H8004014F&
%VIEW_S_FIRST     = &H00040140&
%VIEW_S_LAST      = &H0004014F&
'//
'// MessageId: VIEW_E_DRAW
'//
'// MessageText:
'//
'// Error drawing view
'//
%VIEW_E_DRAW                      = &H80040140&

%REGDB_E_FIRST     = &H80040150&
%REGDB_E_LAST      = &H8004015F&
%REGDB_S_FIRST     = &H00040150&
%REGDB_S_LAST      = &H0004015F&
'//
'// MessageId: REGDB_E_READREGDB
'//
'// MessageText:
'//
'// Could not read key from registry
'//
%REGDB_E_READREGDB                = &H80040150&

'//
'// MessageId: REGDB_E_WRITEREGDB
'//
'// MessageText:
'//
'// Could not write key to registry
'//
%REGDB_E_WRITEREGDB               = &H80040151&

'//
'// MessageId: REGDB_E_KEYMISSING
'//
'// MessageText:
'//
'// Could not find the key in the registry
'//
%REGDB_E_KEYMISSING               = &H80040152&

'//
'// MessageId: REGDB_E_INVALIDVALUE
'//
'// MessageText:
'//
'// Invalid value for registry
'//
%REGDB_E_INVALIDVALUE             = &H80040153&

'//
'// MessageId: REGDB_E_CLASSNOTREG
'//
'// MessageText:
'//
'// Class not registered
'//
%REGDB_E_CLASSNOTREG              = &H80040154&

'//
'// MessageId: REGDB_E_IIDNOTREG
'//
'// MessageText:
'//
'// Interface not registered
'//
%REGDB_E_IIDNOTREG                = &H80040155&

'//
'// MessageId: REGDB_E_BADTHREADINGMODEL
'//
'// MessageText:
'//
'// Threading model entry is not valid
'//
%REGDB_E_BADTHREADINGMODEL        = &H80040156&

%CAT_E_FIRST     = &H80040160&
%CAT_E_LAST      = &H80040161&
'//
'// MessageId: CAT_E_CATIDNOEXIST
'//
'// MessageText:
'//
'// CATID does not exist
'//
%CAT_E_CATIDNOEXIST               = &H80040160&

'//
'// MessageId: CAT_E_NODESCRIPTION
'//
'// MessageText:
'//
'// Description not found
'//
%CAT_E_NODESCRIPTION              = &H80040161&

'////////////////////////////////////
'//                                //
'//     Class Store Error Codes    //
'//                                //
'////////////////////////////////////
%CS_E_FIRST     = &H80040164&
%CS_E_LAST      = &H8004016F&
'//
'// MessageId: CS_E_PACKAGE_NOTFOUND
'//
'// MessageText:
'//
'// No package in the software installation data in the Active Directory meets this criteria.
'//
%CS_E_PACKAGE_NOTFOUND            = &H80040164&

'//
'// MessageId: CS_E_NOT_DELETABLE
'//
'// MessageText:
'//
'// Deleting this will break the referential integrity of the software installation data in the Active Directory.
'//
%CS_E_NOT_DELETABLE               = &H80040165&

'//
'// MessageId: CS_E_CLASS_NOTFOUND
'//
'// MessageText:
'//
'// The CLSID was not found in the software installation data in the Active Directory.
'//
%CS_E_CLASS_NOTFOUND              = &H80040166&

'//
'// MessageId: CS_E_INVALID_VERSION
'//
'// MessageText:
'//
'// The software installation data in the Active Directory is corrupt.
'//
%CS_E_INVALID_VERSION             = &H80040167&

'//
'// MessageId: CS_E_NO_CLASSSTORE
'//
'// MessageText:
'//
'// There is no software installation data in the Active Directory.
'//
%CS_E_NO_CLASSSTORE               = &H80040168&

'//
'// MessageId: CS_E_OBJECT_NOTFOUND
'//
'// MessageText:
'//
'// There is no software installation data object in the Active Directory.
'//
%CS_E_OBJECT_NOTFOUND             = &H80040169&

'//
'// MessageId: CS_E_OBJECT_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The software installation data object in the Active Directory already exists.
'//
%CS_E_OBJECT_ALREADY_EXISTS       = &H8004016A&

'//
'// MessageId: CS_E_INVALID_PATH
'//
'// MessageText:
'//
'// The path to the software installation data in the Active Directory is not correct.
'//
%CS_E_INVALID_PATH                = &H8004016B&

'//
'// MessageId: CS_E_NETWORK_ERROR
'//
'// MessageText:
'//
'// A network error interrupted the operation.
'//
%CS_E_NETWORK_ERROR               = &H8004016C&

'//
'// MessageId: CS_E_ADMIN_LIMIT_EXCEEDED
'//
'// MessageText:
'//
'// The size of this object exceeds the maximum size set by the Administrator.
'//
%CS_E_ADMIN_LIMIT_EXCEEDED        = &H8004016D&

'//
'// MessageId: CS_E_SCHEMA_MISMATCH
'//
'// MessageText:
'//
'// The schema for the software installation data in the Active Directory does not match the required schema.
'//
%CS_E_SCHEMA_MISMATCH             = &H8004016E&

'//
'// MessageId: CS_E_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An error occurred in the software installation data in the Active Directory.
'//
%CS_E_INTERNAL_ERROR              = &H8004016F&

%CACHE_E_FIRST     = &H80040170&
%CACHE_E_LAST      = &H8004017F&
%CACHE_S_FIRST     = &H00040170&
%CACHE_S_LAST      = &H0004017F&
'//
'// MessageId: CACHE_E_NOCACHE_UPDATED
'//
'// MessageText:
'//
'// Cache not updated
'//
%CACHE_E_NOCACHE_UPDATED          = &H80040170&

%OLEOBJ_E_FIRST     = &H80040180&
%OLEOBJ_E_LAST      = &H8004018F&
%OLEOBJ_S_FIRST     = &H00040180&
%OLEOBJ_S_LAST      = &H0004018F&
'//
'// MessageId: OLEOBJ_E_NOVERBS
'//
'// MessageText:
'//
'// No verbs for OLE object
'//
%OLEOBJ_E_NOVERBS                 = &H80040180&

'//
'// MessageId: OLEOBJ_E_INVALIDVERB
'//
'// MessageText:
'//
'// Invalid verb for OLE object
'//
%OLEOBJ_E_INVALIDVERB             = &H80040181&

%CLIENTSITE_E_FIRST     = &H80040190&
%CLIENTSITE_E_LAST      = &H8004019F&
%CLIENTSITE_S_FIRST     = &H00040190&
%CLIENTSITE_S_LAST      = &H0004019F&
'//
'// MessageId: INPLACE_E_NOTUNDOABLE
'//
'// MessageText:
'//
'// Undo is not available
'//
%INPLACE_E_NOTUNDOABLE            = &H800401A0&

'//
'// MessageId: INPLACE_E_NOTOOLSPACE
'//
'// MessageText:
'//
'// Space for tools is not available
'//
%INPLACE_E_NOTOOLSPACE            = &H800401A1&

%INPLACE_E_FIRST   = &H800401A0&
%INPLACE_E_LAST    = &H800401AF&
%INPLACE_S_FIRST   = &H000401A0&
%INPLACE_S_LAST    = &H000401AF&
%ENUM_E_FIRST      = &H800401B0&
%ENUM_E_LAST       = &H800401BF&
%ENUM_S_FIRST      = &H000401B0&
%ENUM_S_LAST       = &H000401BF&
%CONVERT10_E_FIRST = &H800401C0&
%CONVERT10_E_LAST  = &H800401CF&
%CONVERT10_S_FIRST = &H000401C0&
%CONVERT10_S_LAST  = &H000401CF&
'//
'// MessageId: CONVERT10_E_OLESTREAM_GET
'//
'// MessageText:
'//
'// OLESTREAM Get method failed
'//
%CONVERT10_E_OLESTREAM_GET        = &H800401C0&

'//
'// MessageId: CONVERT10_E_OLESTREAM_PUT
'//
'// MessageText:
'//
'// OLESTREAM Put method failed
'//
%CONVERT10_E_OLESTREAM_PUT        = &H800401C1&

'//
'// MessageId: CONVERT10_E_OLESTREAM_FMT
'//
'// MessageText:
'//
'// Contents of the OLESTREAM not in correct format
'//
%CONVERT10_E_OLESTREAM_FMT        = &H800401C2&

'//
'// MessageId: CONVERT10_E_OLESTREAM_BITMAP_TO_DIB
'//
'// MessageText:
'//
'// There was an error in a Windows GDI call while converting the bitmap to a DIB
'//
%CONVERT10_E_OLESTREAM_BITMAP_TO_DIB = &H800401C3&

'//
'// MessageId: CONVERT10_E_STG_FMT
'//
'// MessageText:
'//
'// Contents of the IStorage not in correct format
'//
%CONVERT10_E_STG_FMT              = &H800401C4&

'//
'// MessageId: CONVERT10_E_STG_NO_STD_STREAM
'//
'// MessageText:
'//
'// Contents of IStorage is missing one of the standard streams
'//
%CONVERT10_E_STG_NO_STD_STREAM    = &H800401C5&

'//
'// MessageId: CONVERT10_E_STG_DIB_TO_BITMAP
'//
'// MessageText:
'//
'// There was an error in a Windows GDI call while converting the DIB to a bitmap.
'//
'//
%CONVERT10_E_STG_DIB_TO_BITMAP    = &H800401C6&

%CLIPBRD_E_FIRST        = &H800401D0&
%CLIPBRD_E_LAST         = &H800401DF&
%CLIPBRD_S_FIRST        = &H000401D0&
%CLIPBRD_S_LAST         = &H000401DF&
'//
'// MessageId: CLIPBRD_E_CANT_OPEN
'//
'// MessageText:
'//
'// OpenClipboard Failed
'//
%CLIPBRD_E_CANT_OPEN              = &H800401D0&

'//
'// MessageId: CLIPBRD_E_CANT_EMPTY
'//
'// MessageText:
'//
'// EmptyClipboard Failed
'//
%CLIPBRD_E_CANT_EMPTY             = &H800401D1&

'//
'// MessageId: CLIPBRD_E_CANT_SET
'//
'// MessageText:
'//
'// SetClipboard Failed
'//
%CLIPBRD_E_CANT_SET               = &H800401D2&

'//
'// MessageId: CLIPBRD_E_BAD_DATA
'//
'// MessageText:
'//
'// Data on clipboard is invalid
'//
%CLIPBRD_E_BAD_DATA               = &H800401D3&

'//
'// MessageId: CLIPBRD_E_CANT_CLOSE
'//
'// MessageText:
'//
'// CloseClipboard Failed
'//
%CLIPBRD_E_CANT_CLOSE             = &H800401D4&

%MK_E_FIRST        = &H800401E0&
%MK_E_LAST         = &H800401EF&
%MK_S_FIRST        = &H000401E0&
%MK_S_LAST         = &H000401EF&
'//
'// MessageId: MK_E_CONNECTMANUALLY
'//
'// MessageText:
'//
'// Moniker needs to be connected manually
'//
%MK_E_CONNECTMANUALLY             = &H800401E0&

'//
'// MessageId: MK_E_EXCEEDEDDEADLINE
'//
'// MessageText:
'//
'// Operation exceeded deadline
'//
%MK_E_EXCEEDEDDEADLINE            = &H800401E1&

'//
'// MessageId: MK_E_NEEDGENERIC
'//
'// MessageText:
'//
'// Moniker needs to be generic
'//
%MK_E_NEEDGENERIC                 = &H800401E2&

'//
'// MessageId: MK_E_UNAVAILABLE
'//
'// MessageText:
'//
'// Operation unavailable
'//
%MK_E_UNAVAILABLE                 = &H800401E3&

'//
'// MessageId: MK_E_SYNTAX
'//
'// MessageText:
'//
'// Invalid syntax
'//
%MK_E_SYNTAX                      = &H800401E4&

'//
'// MessageId: MK_E_NOOBJECT
'//
'// MessageText:
'//
'// No object for moniker
'//
%MK_E_NOOBJECT                    = &H800401E5&

'//
'// MessageId: MK_E_INVALIDEXTENSION
'//
'// MessageText:
'//
'// Bad extension for file
'//
%MK_E_INVALIDEXTENSION            = &H800401E6&

'//
'// MessageId: MK_E_INTERMEDIATEINTERFACENOTSUPPORTED
'//
'// MessageText:
'//
'// Intermediate operation failed
'//
%MK_E_INTERMEDIATEINTERFACENOTSUPPORTED = &H800401E7&

'//
'// MessageId: MK_E_NOTBINDABLE
'//
'// MessageText:
'//
'// Moniker is not bindable
'//
%MK_E_NOTBINDABLE                 = &H800401E8&

'//
'// MessageId: MK_E_NOTBOUND
'//
'// MessageText:
'//
'// Moniker is not bound
'//
%MK_E_NOTBOUND                    = &H800401E9&

'//
'// MessageId: MK_E_CANTOPENFILE
'//
'// MessageText:
'//
'// Moniker cannot open file
'//
%MK_E_CANTOPENFILE                = &H800401EA&

'//
'// MessageId: MK_E_MUSTBOTHERUSER
'//
'// MessageText:
'//
'// User input required for operation to succeed
'//
%MK_E_MUSTBOTHERUSER              = &H800401EB&

'//
'// MessageId: MK_E_NOINVERSE
'//
'// MessageText:
'//
'// Moniker class has no inverse
'//
%MK_E_NOINVERSE                   = &H800401EC&

'//
'// MessageId: MK_E_NOSTORAGE
'//
'// MessageText:
'//
'// Moniker does not refer to storage
'//
%MK_E_NOSTORAGE                   = &H800401ED&

'//
'// MessageId: MK_E_NOPREFIX
'//
'// MessageText:
'//
'// No common prefix
'//
%MK_E_NOPREFIX                    = &H800401EE&

'//
'// MessageId: MK_E_ENUMERATION_FAILED
'//
'// MessageText:
'//
'// Moniker could not be enumerated
'//
%MK_E_ENUMERATION_FAILED          = &H800401EF&

%CO_E_FIRST        = &H800401F0&
%CO_E_LAST         = &H800401FF&
%CO_S_FIRST        = &H000401F0&
%CO_S_LAST         = &H000401FF&
'//
'// MessageId: CO_E_NOTINITIALIZED
'//
'// MessageText:
'//
'// CoInitialize has not been called.
'//
%CO_E_NOTINITIALIZED              = &H800401F0&

'//
'// MessageId: CO_E_ALREADYINITIALIZED
'//
'// MessageText:
'//
'// CoInitialize has already been called.
'//
%CO_E_ALREADYINITIALIZED          = &H800401F1&

'//
'// MessageId: CO_E_CANTDETERMINECLASS
'//
'// MessageText:
'//
'// Class of object cannot be determined
'//
%CO_E_CANTDETERMINECLASS          = &H800401F2&

'//
'// MessageId: CO_E_CLASSSTRING
'//
'// MessageText:
'//
'// Invalid class string
'//
%CO_E_CLASSSTRING                 = &H800401F3&

'//
'// MessageId: CO_E_IIDSTRING
'//
'// MessageText:
'//
'// Invalid interface string
'//
%CO_E_IIDSTRING                   = &H800401F4&

'//
'// MessageId: CO_E_APPNOTFOUND
'//
'// MessageText:
'//
'// Application not found
'//
%CO_E_APPNOTFOUND                 = &H800401F5&

'//
'// MessageId: CO_E_APPSINGLEUSE
'//
'// MessageText:
'//
'// Application cannot be run more than once
'//
%CO_E_APPSINGLEUSE                = &H800401F6&

'//
'// MessageId: CO_E_ERRORINAPP
'//
'// MessageText:
'//
'// Some error in application program
'//
%CO_E_ERRORINAPP                  = &H800401F7&

'//
'// MessageId: CO_E_DLLNOTFOUND
'//
'// MessageText:
'//
'// DLL for class not found
'//
%CO_E_DLLNOTFOUND                 = &H800401F8&

'//
'// MessageId: CO_E_ERRORINDLL
'//
'// MessageText:
'//
'// Error in the DLL
'//
%CO_E_ERRORINDLL                  = &H800401F9&

'//
'// MessageId: CO_E_WRONGOSFORAPP
'//
'// MessageText:
'//
'// Wrong OS or OS version for application
'//
%CO_E_WRONGOSFORAPP               = &H800401FA&

'//
'// MessageId: CO_E_OBJNOTREG
'//
'// MessageText:
'//
'// Object is not registered
'//
%CO_E_OBJNOTREG                   = &H800401FB&

'//
'// MessageId: CO_E_OBJISREG
'//
'// MessageText:
'//
'// Object is already registered
'//
%CO_E_OBJISREG                    = &H800401FC&

'//
'// MessageId: CO_E_OBJNOTCONNECTED
'//
'// MessageText:
'//
'// Object is not connected to server
'//
%CO_E_OBJNOTCONNECTED             = &H800401FD&

'//
'// MessageId: CO_E_APPDIDNTREG
'//
'// MessageText:
'//
'// Application was launched but it didn't register a class factory
'//
%CO_E_APPDIDNTREG                 = &H800401FE&

'//
'// MessageId: CO_E_RELEASED
'//
'// MessageText:
'//
'// Object has been released
'//
%CO_E_RELEASED                    = &H800401FF&

%EVENT_E_FIRST        = &H80040200&
%EVENT_E_LAST         = &H8004021F&
%EVENT_S_FIRST        = &H00040200&
%EVENT_S_LAST         = &H0004021F&
'//
'// MessageId: EVENT_S_SOME_SUBSCRIBERS_FAILED
'//
'// MessageText:
'//
'// An event was able to invoke some but not all of the subscribers
'//
%EVENT_S_SOME_SUBSCRIBERS_FAILED  = &H00040200&

'//
'// MessageId: EVENT_E_ALL_SUBSCRIBERS_FAILED
'//
'// MessageText:
'//
'// An event was unable to invoke any of the subscribers
'//
%EVENT_E_ALL_SUBSCRIBERS_FAILED   = &H80040201&

'//
'// MessageId: EVENT_S_NOSUBSCRIBERS
'//
'// MessageText:
'//
'// An event was delivered but there were no subscribers
'//
%EVENT_S_NOSUBSCRIBERS            = &H00040202&

'//
'// MessageId: EVENT_E_QUERYSYNTAX
'//
'// MessageText:
'//
'// A syntax error occurred trying to evaluate a query string
'//
%EVENT_E_QUERYSYNTAX              = &H80040203&

'//
'// MessageId: EVENT_E_QUERYFIELD
'//
'// MessageText:
'//
'// An invalid field name was used in a query string
'//
%EVENT_E_QUERYFIELD               = &H80040204&

'//
'// MessageId: EVENT_E_INTERNALEXCEPTION
'//
'// MessageText:
'//
'// An unexpected exception was raised
'//
%EVENT_E_INTERNALEXCEPTION        = &H80040205&

'//
'// MessageId: EVENT_E_INTERNALERROR
'//
'// MessageText:
'//
'// An unexpected internal error was detected
'//
%EVENT_E_INTERNALERROR            = &H80040206&

'//
'// MessageId: EVENT_E_INVALID_PER_USER_SID
'//
'// MessageText:
'//
'// The owner SID on a per-user subscription doesn't exist
'//
%EVENT_E_INVALID_PER_USER_SID     = &H80040207&

'//
'// MessageId: EVENT_E_USER_EXCEPTION
'//
'// MessageText:
'//
'// A user-supplied component or subscriber raised an exception
'//
%EVENT_E_USER_EXCEPTION           = &H80040208&

'//
'// MessageId: EVENT_E_TOO_MANY_METHODS
'//
'// MessageText:
'//
'// An interface has too many methods to fire events from
'//
%EVENT_E_TOO_MANY_METHODS         = &H80040209&

'//
'// MessageId: EVENT_E_MISSING_EVENTCLASS
'//
'// MessageText:
'//
'// A subscription cannot be stored unless its event class already exists
'//
%EVENT_E_MISSING_EVENTCLASS       = &H8004020A&

'//
'// MessageId: EVENT_E_NOT_ALL_REMOVED
'//
'// MessageText:
'//
'// Not all the objects requested could be removed
'//
%EVENT_E_NOT_ALL_REMOVED          = &H8004020B&

'//
'// MessageId: EVENT_E_COMPLUS_NOT_INSTALLED
'//
'// MessageText:
'//
'// COM+ is required for this operation, but is not installed
'//
%EVENT_E_COMPLUS_NOT_INSTALLED    = &H8004020C&

'//
'// MessageId: EVENT_E_CANT_MODIFY_OR_DELETE_UNCONFIGURED_OBJECT
'//
'// MessageText:
'//
'// Cannot modify or delete an object that was not added using the COM+ Admin SDK
'//
%EVENT_E_CANT_MODIFY_OR_DELETE_UNCONFIGURED_OBJECT = &H8004020D&

'//
'// MessageId: EVENT_E_CANT_MODIFY_OR_DELETE_CONFIGURED_OBJECT
'//
'// MessageText:
'//
'// Cannot modify or delete an object that was added using the COM+ Admin SDK
'//
%EVENT_E_CANT_MODIFY_OR_DELETE_CONFIGURED_OBJECT = &H8004020E&

'//
'// MessageId: EVENT_E_INVALID_EVENT_CLASS_PARTITION
'//
'// MessageText:
'//
'// The event class for this subscription is in an invalid partition
'//
%EVENT_E_INVALID_EVENT_CLASS_PARTITION = &H8004020F&

'//
'// MessageId: EVENT_E_PER_USER_SID_NOT_LOGGED_ON
'//
'// MessageText:
'//
'// The owner of the PerUser subscription is not logged on to the system specified
'//
%EVENT_E_PER_USER_SID_NOT_LOGGED_ON = &H80040210&

%XACT_E_FIRST   = &H8004D000&
%XACT_E_LAST    = &H8004D029&
%XACT_S_FIRST   = &H0004D000&
%XACT_S_LAST    = &H0004D010&
'//
'// MessageId: XACT_E_ALREADYOTHERSINGLEPHASE
'//
'// MessageText:
'//
'// Another single phase resource manager has already been enlisted in this transaction.
'//
%XACT_E_ALREADYOTHERSINGLEPHASE   = &H8004D000&

'//
'// MessageId: XACT_E_CANTRETAIN
'//
'// MessageText:
'//
'// A retaining commit or abort is not supported
'//
%XACT_E_CANTRETAIN                = &H8004D001&

'//
'// MessageId: XACT_E_COMMITFAILED
'//
'// MessageText:
'//
'// The transaction failed to commit for an unknown reason. The transaction was aborted.
'//
%XACT_E_COMMITFAILED              = &H8004D002&

'//
'// MessageId: XACT_E_COMMITPREVENTED
'//
'// MessageText:
'//
'// Cannot call commit on this transaction object because the calling application did not initiate the transaction.
'//
%XACT_E_COMMITPREVENTED           = &H8004D003&

'//
'// MessageId: XACT_E_HEURISTICABORT
'//
'// MessageText:
'//
'// Instead of committing, the resource heuristically aborted.
'//
%XACT_E_HEURISTICABORT            = &H8004D004&

'//
'// MessageId: XACT_E_HEURISTICCOMMIT
'//
'// MessageText:
'//
'// Instead of aborting, the resource heuristically committed.
'//
%XACT_E_HEURISTICCOMMIT           = &H8004D005&

'//
'// MessageId: XACT_E_HEURISTICDAMAGE
'//
'// MessageText:
'//
'// Some of the states of the resource were committed while others were aborted, likely because of heuristic decisions.
'//
%XACT_E_HEURISTICDAMAGE           = &H8004D006&

'//
'// MessageId: XACT_E_HEURISTICDANGER
'//
'// MessageText:
'//
'// Some of the states of the resource may have been committed while others may have been aborted, likely because of heuristic decisions.
'//
%XACT_E_HEURISTICDANGER           = &H8004D007&

'//
'// MessageId: XACT_E_ISOLATIONLEVEL
'//
'// MessageText:
'//
'// The requested isolation level is not valid or supported.
'//
%XACT_E_ISOLATIONLEVEL            = &H8004D008&

'//
'// MessageId: XACT_E_NOASYNC
'//
'// MessageText:
'//
'// The transaction manager doesn't support an asynchronous operation for this method.
'//
%XACT_E_NOASYNC                   = &H8004D009&

'//
'// MessageId: XACT_E_NOENLIST
'//
'// MessageText:
'//
'// Unable to enlist in the transaction.
'//
%XACT_E_NOENLIST                  = &H8004D00A&

'//
'// MessageId: XACT_E_NOISORETAIN
'//
'// MessageText:
'//
'// The requested semantics of retention of isolation across retaining commit and abort boundaries cannot be supported by this transaction implementation, or isoFlags was not equal to zero.
'//
%XACT_E_NOISORETAIN               = &H8004D00B&

'//
'// MessageId: XACT_E_NORESOURCE
'//
'// MessageText:
'//
'// There is no resource presently associated with this enlistment
'//
%XACT_E_NORESOURCE                = &H8004D00C&

'//
'// MessageId: XACT_E_NOTCURRENT
'//
'// MessageText:
'//
'// The transaction failed to commit due to the failure of optimistic concurrency control in at least one of the resource managers.
'//
%XACT_E_NOTCURRENT                = &H8004D00D&

'//
'// MessageId: XACT_E_NOTRANSACTION
'//
'// MessageText:
'//
'// The transaction has already been implicitly or explicitly committed or aborted
'//
%XACT_E_NOTRANSACTION             = &H8004D00E&

'//
'// MessageId: XACT_E_NOTSUPPORTED
'//
'// MessageText:
'//
'// An invalid combination of flags was specified
'//
%XACT_E_NOTSUPPORTED              = &H8004D00F&

'//
'// MessageId: XACT_E_UNKNOWNRMGRID
'//
'// MessageText:
'//
'// The resource manager id is not associated with this transaction or the transaction manager.
'//
%XACT_E_UNKNOWNRMGRID             = &H8004D010&

'//
'// MessageId: XACT_E_WRONGSTATE
'//
'// MessageText:
'//
'// This method was called in the wrong state
'//
%XACT_E_WRONGSTATE                = &H8004D011&

'//
'// MessageId: XACT_E_WRONGUOW
'//
'// MessageText:
'//
'// The indicated unit of work does not match the unit of work expected by the resource manager.
'//
%XACT_E_WRONGUOW                  = &H8004D012&

'//
'// MessageId: XACT_E_XTIONEXISTS
'//
'// MessageText:
'//
'// An enlistment in a transaction already exists.
'//
%XACT_E_XTIONEXISTS               = &H8004D013&

'//
'// MessageId: XACT_E_NOIMPORTOBJECT
'//
'// MessageText:
'//
'// An import object for the transaction could not be found.
'//
%XACT_E_NOIMPORTOBJECT            = &H8004D014&

'//
'// MessageId: XACT_E_INVALIDCOOKIE
'//
'// MessageText:
'//
'// The transaction cookie is invalid.
'//
%XACT_E_INVALIDCOOKIE             = &H8004D015&

'//
'// MessageId: XACT_E_INDOUBT
'//
'// MessageText:
'//
'// The transaction status is in doubt. A communication failure occurred, or a transaction manager or resource manager has failed
'//
%XACT_E_INDOUBT                   = &H8004D016&

'//
'// MessageId: XACT_E_NOTIMEOUT
'//
'// MessageText:
'//
'// A time-out was specified, but time-outs are not supported.
'//
%XACT_E_NOTIMEOUT                 = &H8004D017&

'//
'// MessageId: XACT_E_ALREADYINPROGRESS
'//
'// MessageText:
'//
'// The requested operation is already in progress for the transaction.
'//
%XACT_E_ALREADYINPROGRESS         = &H8004D018&

'//
'// MessageId: XACT_E_ABORTED
'//
'// MessageText:
'//
'// The transaction has already been aborted.
'//
%XACT_E_ABORTED                   = &H8004D019&

'//
'// MessageId: XACT_E_LOGFULL
'//
'// MessageText:
'//
'// The Transaction Manager returned a log full error.
'//
%XACT_E_LOGFULL                   = &H8004D01A&

'//
'// MessageId: XACT_E_TMNOTAVAILABLE
'//
'// MessageText:
'//
'// The Transaction Manager is not available.
'//
%XACT_E_TMNOTAVAILABLE            = &H8004D01B&

'//
'// MessageId: XACT_E_CONNECTION_DOWN
'//
'// MessageText:
'//
'// A connection with the transaction manager was lost.
'//
%XACT_E_CONNECTION_DOWN           = &H8004D01C&

'//
'// MessageId: XACT_E_CONNECTION_DENIED
'//
'// MessageText:
'//
'// A request to establish a connection with the transaction manager was denied.
'//
%XACT_E_CONNECTION_DENIED         = &H8004D01D&

'//
'// MessageId: XACT_E_REENLISTTIMEOUT
'//
'// MessageText:
'//
'// Resource manager reenlistment to determine transaction status timed out.
'//
%XACT_E_REENLISTTIMEOUT           = &H8004D01E&

'//
'// MessageId: XACT_E_TIP_CONNECT_FAILED
'//
'// MessageText:
'//
'// This transaction manager failed to establish a connection with another TIP transaction manager.
'//
%XACT_E_TIP_CONNECT_FAILED        = &H8004D01F&

'//
'// MessageId: XACT_E_TIP_PROTOCOL_ERROR
'//
'// MessageText:
'//
'// This transaction manager encountered a protocol error with another TIP transaction manager.
'//
%XACT_E_TIP_PROTOCOL_ERROR        = &H8004D020&

'//
'// MessageId: XACT_E_TIP_PULL_FAILED
'//
'// MessageText:
'//
'// This transaction manager could not propagate a transaction from another TIP transaction manager.
'//
%XACT_E_TIP_PULL_FAILED           = &H8004D021&

'//
'// MessageId: XACT_E_DEST_TMNOTAVAILABLE
'//
'// MessageText:
'//
'// The Transaction Manager on the destination machine is not available.
'//
%XACT_E_DEST_TMNOTAVAILABLE       = &H8004D022&

'//
'// MessageId: XACT_E_TIP_DISABLED
'//
'// MessageText:
'//
'// The Transaction Manager has disabled its support for TIP.
'//
%XACT_E_TIP_DISABLED              = &H8004D023&

'//
'// MessageId: XACT_E_NETWORK_TX_DISABLED
'//
'// MessageText:
'//
'// The transaction manager has disabled its support for remote/network transactions.
'//
%XACT_E_NETWORK_TX_DISABLED       = &H8004D024&

'//
'// MessageId: XACT_E_PARTNER_NETWORK_TX_DISABLED
'//
'// MessageText:
'//
'// The partner transaction manager has disabled its support for remote/network transactions.
'//
%XACT_E_PARTNER_NETWORK_TX_DISABLED = &H8004D025&

'//
'// MessageId: XACT_E_XA_TX_DISABLED
'//
'// MessageText:
'//
'// The transaction manager has disabled its support for XA transactions.
'//
%XACT_E_XA_TX_DISABLED            = &H8004D026&

'//
'// MessageId: XACT_E_UNABLE_TO_READ_DTC_CONFIG
'//
'// MessageText:
'//
'// MSDTC was unable to read its configuration information.
'//
%XACT_E_UNABLE_TO_READ_DTC_CONFIG = &H8004D027&

'//
'// MessageId: XACT_E_UNABLE_TO_LOAD_DTC_PROXY
'//
'// MessageText:
'//
'// MSDTC was unable to load the dtc proxy dll.
'//
%XACT_E_UNABLE_TO_LOAD_DTC_PROXY  = &H8004D028&

'//
'// MessageId: XACT_E_ABORTING
'//
'// MessageText:
'//
'// The local transaction has aborted.
'//
%XACT_E_ABORTING                  = &H8004D029&

'//
'// TXF & CRM errors start 4d080.
'//
'// MessageId: XACT_E_CLERKNOTFOUND
'//
'// MessageText:
'//
'//  XACT_E_CLERKNOTFOUND
'//
%XACT_E_CLERKNOTFOUND             = &H8004D080&

'//
'// MessageId: XACT_E_CLERKEXISTS
'//
'// MessageText:
'//
'//  XACT_E_CLERKEXISTS
'//
%XACT_E_CLERKEXISTS               = &H8004D081&

'//
'// MessageId: XACT_E_RECOVERYINPROGRESS
'//
'// MessageText:
'//
'//  XACT_E_RECOVERYINPROGRESS
'//
%XACT_E_RECOVERYINPROGRESS        = &H8004D082&

'//
'// MessageId: XACT_E_TRANSACTIONCLOSED
'//
'// MessageText:
'//
'//  XACT_E_TRANSACTIONCLOSED
'//
%XACT_E_TRANSACTIONCLOSED         = &H8004D083&

'//
'// MessageId: XACT_E_INVALIDLSN
'//
'// MessageText:
'//
'//  XACT_E_INVALIDLSN
'//
%XACT_E_INVALIDLSN                = &H8004D084&

'//
'// MessageId: XACT_E_REPLAYREQUEST
'//
'// MessageText:
'//
'//  XACT_E_REPLAYREQUEST
'//
%XACT_E_REPLAYREQUEST             = &H8004D085&

'// Begin XACT_DTC_CONSTANTS enumerated values defined in txdtc.h

'// SymbolicName=XACT_E_CONNECTION_REQUEST_DENIED
'//
'// MessageId: 0x8004D100& (No symbolic name defined)
'//
'// MessageText:
'//
'// The request to connect to the specified transaction coordinator was denied.
'//


'// SymbolicName=XACT_E_TOOMANY_ENLISTMENTS
'//
'// MessageId: 0x8004D101& (No symbolic name defined)
'//
'// MessageText:
'//
'// The maximum number of enlistments for the specified transaction has been reached.
'//


'// SymbolicName=XACT_E_DUPLICATE_GUID
'//
'// MessageId: 0x8004D102& (No symbolic name defined)
'//
'// MessageText:
'//
'// A resource manager with the same identifier is already registered with the specified transaction coordinator.
'//


'// SymbolicName=XACT_E_NOTSINGLEPHASE
'//
'// MessageId: 0x8004D103& (No symbolic name defined)
'//
'// MessageText:
'//
'// The prepare request given was not eligible for single phase optimizations.
'//


'// SymbolicName=XACT_E_RECOVERYALREADYDONE
'//
'// MessageId: 0x8004D104& (No symbolic name defined)
'//
'// MessageText:
'//
'// RecoveryComplete has already been called for the given resource manager.
'//


'// SymbolicName=XACT_E_PROTOCOL
'//
'// MessageId: 0x8004D105& (No symbolic name defined)
'//
'// MessageText:
'//
'// The interface call made was incorrect for the current state of the protocol.
'//


'// SymbolicName=XACT_E_RM_FAILURE
'//
'// MessageId: 0x8004D106& (No symbolic name defined)
'//
'// MessageText:
'//
'// xa_open call failed for the XA resource.
'//


'// SymbolicName=XACT_E_RECOVERY_FAILED
'//
'// MessageId: 0x8004D107& (No symbolic name defined)
'//
'// MessageText:
'//
'// xa_recover call failed for the XA resource.
'//


'// SymbolicName=XACT_E_LU_NOT_FOUND
'//
'// MessageId: 0x8004D108& (No symbolic name defined)
'//
'// MessageText:
'//
'// The Logical Unit of Work specified cannot be found.
'//


'// SymbolicName=XACT_E_DUPLICATE_LU
'//
'// MessageId: 0x8004D109& (No symbolic name defined)
'//
'// MessageText:
'//
'// The specified Logical Unit of Work already exists.
'//


'// SymbolicName=XACT_E_LU_NOT_CONNECTED
'//
'// MessageId: 0x8004D10AL (No symbolic name defined)
'//
'// MessageText:
'//
'// Subordinate creation failed. The specified Logical Unit of Work was not connected.
'//


'// SymbolicName=XACT_E_DUPLICATE_TRANSID
'//
'// MessageId: 0x8004D10BL (No symbolic name defined)
'//
'// MessageText:
'//
'// A transaction with the given identifier already exists.
'//


'// SymbolicName=XACT_E_LU_BUSY
'//
'// MessageId: 0x8004D10CL (No symbolic name defined)
'//
'// MessageText:
'//
'// The resource is in use.
'//


'// SymbolicName=XACT_E_LU_NO_RECOVERY_PROCESS
'//
'// MessageId: 0x8004D10DL (No symbolic name defined)
'//
'// MessageText:
'//
'// The LU Recovery process is down.
'//


'// SymbolicName=XACT_E_LU_DOWN
'//
'// MessageId: 0x8004D10EL (No symbolic name defined)
'//
'// MessageText:
'//
'// The remote session was lost.
'//


'// SymbolicName=XACT_E_LU_RECOVERING
'//
'// MessageId: 0x8004D10FL (No symbolic name defined)
'//
'// MessageText:
'//
'// The resource is currently recovering.
'//


'// SymbolicName=XACT_E_LU_RECOVERY_MISMATCH
'//
'// MessageId: 0x8004D110& (No symbolic name defined)
'//
'// MessageText:
'//
'// There was a mismatch in driving recovery.
'//


'// SymbolicName=XACT_E_RM_UNAVAILABLE
'//
'// MessageId: 0x8004D111& (No symbolic name defined)
'//
'// MessageText:
'//
'// An error occurred with the XA resource.
'//


'// End XACT_DTC_CONSTANTS enumerated values defined in txdtc.h

'//
'// OleTx Success codes.
'//
'//
'// MessageId: XACT_S_ASYNC
'//
'// MessageText:
'//
'// An asynchronous operation was specified. The operation has begun, but its outcome is not known yet.
'//
%XACT_S_ASYNC                     = &H0004D000&

'//
'// MessageId: XACT_S_DEFECT
'//
'// MessageText:
'//
'//  XACT_S_DEFECT
'//
%XACT_S_DEFECT                    = &H0004D001&

'//
'// MessageId: XACT_S_READONLY
'//
'// MessageText:
'//
'// The method call succeeded because the transaction was read-only.
'//
%XACT_S_READONLY                  = &H0004D002&

'//
'// MessageId: XACT_S_SOMENORETAIN
'//
'// MessageText:
'//
'// The transaction was successfully aborted. However, this is a coordinated transaction, and some number of enlisted resources were aborted outright because they could not support abort-retaining semantics
'//
%XACT_S_SOMENORETAIN              = &H0004D003&

'//
'// MessageId: XACT_S_OKINFORM
'//
'// MessageText:
'//
'// No changes were made during this call, but the sink wants another chance to look if any other sinks make further changes.
'//
%XACT_S_OKINFORM                  = &H0004D004&

'//
'// MessageId: XACT_S_MADECHANGESCONTENT
'//
'// MessageText:
'//
'// The sink is content and wishes the transaction to proceed. Changes were made to one or more resources during this call.
'//
%XACT_S_MADECHANGESCONTENT        = &H0004D005&

'//
'// MessageId: XACT_S_MADECHANGESINFORM
'//
'// MessageText:
'//
'// The sink is for the moment and wishes the transaction to proceed, but if other changes are made following this return by other event sinks then this sink wants another chance to look
'//
%XACT_S_MADECHANGESINFORM         = &H0004D006&

'//
'// MessageId: XACT_S_ALLNORETAIN
'//
'// MessageText:
'//
'// The transaction was successfully aborted. However, the abort was non-retaining.
'//
%XACT_S_ALLNORETAIN               = &H0004D007&

'//
'// MessageId: XACT_S_ABORTING
'//
'// MessageText:
'//
'// An abort operation was already in progress.
'//
%XACT_S_ABORTING                  = &H0004D008&

'//
'// MessageId: XACT_S_SINGLEPHASE
'//
'// MessageText:
'//
'// The resource manager has performed a single-phase commit of the transaction.
'//
%XACT_S_SINGLEPHASE               = &H0004D009&

'//
'// MessageId: XACT_S_LOCALLY_OK
'//
'// MessageText:
'//
'// The local transaction has not aborted.
'//
%XACT_S_LOCALLY_OK                = &H0004D00A&

'//
'// MessageId: XACT_S_LASTRESOURCEMANAGER
'//
'// MessageText:
'//
'// The resource manager has requested to be the coordinator (last resource manager) for the transaction.
'//
%XACT_S_LASTRESOURCEMANAGER       = &H0004D010&

%CONTEXT_E_FIRST        = &H8004E000&
%CONTEXT_E_LAST         = &H8004E02F&
%CONTEXT_S_FIRST        = &H0004E000&
%CONTEXT_S_LAST         = &H0004E02F&
'//
'// MessageId: CONTEXT_E_ABORTED
'//
'// MessageText:
'//
'// The root transaction wanted to commit, but transaction aborted
'//
%CONTEXT_E_ABORTED                = &H8004E002&

'//
'// MessageId: CONTEXT_E_ABORTING
'//
'// MessageText:
'//
'// You made a method call on a COM+ component that has a transaction that has already aborted or in the process of aborting.
'//
%CONTEXT_E_ABORTING               = &H8004E003&

'//
'// MessageId: CONTEXT_E_NOCONTEXT
'//
'// MessageText:
'//
'// There is no MTS object context
'//
%CONTEXT_E_NOCONTEXT              = &H8004E004&

'//
'// MessageId: CONTEXT_E_WOULD_DEADLOCK
'//
'// MessageText:
'//
'// The component is configured to use synchronization and this method call would cause a deadlock to occur.
'//
%CONTEXT_E_WOULD_DEADLOCK         = &H8004E005&

'//
'// MessageId: CONTEXT_E_SYNCH_TIMEOUT
'//
'// MessageText:
'//
'// The component is configured to use synchronization and a thread has timed out waiting to enter the context.
'//
%CONTEXT_E_SYNCH_TIMEOUT          = &H8004E006&

'//
'// MessageId: CONTEXT_E_OLDREF
'//
'// MessageText:
'//
'// You made a method call on a COM+ component that has a transaction that has already committed or aborted.
'//
%CONTEXT_E_OLDREF                 = &H8004E007&

'//
'// MessageId: CONTEXT_E_ROLENOTFOUND
'//
'// MessageText:
'//
'// The specified role was not configured for the application
'//
%CONTEXT_E_ROLENOTFOUND           = &H8004E00C&

'//
'// MessageId: CONTEXT_E_TMNOTAVAILABLE
'//
'// MessageText:
'//
'// COM+ was unable to talk to the Microsoft Distributed Transaction Coordinator
'//
%CONTEXT_E_TMNOTAVAILABLE         = &H8004E00F&

'//
'// MessageId: CO_E_ACTIVATIONFAILED
'//
'// MessageText:
'//
'// An unexpected error occurred during COM+ Activation.
'//
%CO_E_ACTIVATIONFAILED            = &H8004E021&

'//
'// MessageId: CO_E_ACTIVATIONFAILED_EVENTLOGGED
'//
'// MessageText:
'//
'// COM+ Activation failed. Check the event log for more information
'//
%CO_E_ACTIVATIONFAILED_EVENTLOGGED = &H8004E022&

'//
'// MessageId: CO_E_ACTIVATIONFAILED_CATALOGERROR
'//
'// MessageText:
'//
'// COM+ Activation failed due to a catalog or configuration error.
'//
%CO_E_ACTIVATIONFAILED_CATALOGERROR = &H8004E023&

'//
'// MessageId: CO_E_ACTIVATIONFAILED_TIMEOUT
'//
'// MessageText:
'//
'// COM+ activation failed because the activation could not be completed in the specified amount of time.
'//
%CO_E_ACTIVATIONFAILED_TIMEOUT    = &H8004E024&

'//
'// MessageId: CO_E_INITIALIZATIONFAILED
'//
'// MessageText:
'//
'// COM+ Activation failed because an initialization function failed. Check the event log for more information.
'//
%CO_E_INITIALIZATIONFAILED        = &H8004E025&

'//
'// MessageId: CONTEXT_E_NOJIT
'//
'// MessageText:
'//
'// The requested operation requires that JIT be in the current context and it is not
'//
%CONTEXT_E_NOJIT                  = &H8004E026&

'//
'// MessageId: CONTEXT_E_NOTRANSACTION
'//
'// MessageText:
'//
'// The requested operation requires that the current context have a Transaction, and it does not
'//
%CONTEXT_E_NOTRANSACTION          = &H8004E027&

'//
'// MessageId: CO_E_THREADINGMODEL_CHANGED
'//
'// MessageText:
'//
'// The components threading model has changed after install into a COM+ Application. Please re-install component.
'//
%CO_E_THREADINGMODEL_CHANGED      = &H8004E028&

'//
'// MessageId: CO_E_NOIISINTRINSICS
'//
'// MessageText:
'//
'// IIS intrinsics not available. Start your work with IIS.
'//
%CO_E_NOIISINTRINSICS             = &H8004E029&

'//
'// MessageId: CO_E_NOCOOKIES
'//
'// MessageText:
'//
'// An attempt to write a cookie failed.
'//
%CO_E_NOCOOKIES                   = &H8004E02A&

'//
'// MessageId: CO_E_DBERROR
'//
'// MessageText:
'//
'// An attempt to use a database generated a database specific error.
'//
%CO_E_DBERROR                     = &H8004E02B&

'//
'// MessageId: CO_E_NOTPOOLED
'//
'// MessageText:
'//
'// The COM+ component you created must use object pooling to work.
'//
%CO_E_NOTPOOLED                   = &H8004E02C&

'//
'// MessageId: CO_E_NOTCONSTRUCTED
'//
'// MessageText:
'//
'// The COM+ component you created must use object construction to work correctly.
'//
%CO_E_NOTCONSTRUCTED              = &H8004E02D&

'//
'// MessageId: CO_E_NOSYNCHRONIZATION
'//
'// MessageText:
'//
'// The COM+ component requires synchronization, and it is not configured for it.
'//
%CO_E_NOSYNCHRONIZATION           = &H8004E02E&

'//
'// MessageId: CO_E_ISOLEVELMISMATCH
'//
'// MessageText:
'//
'// The TxIsolation Level property for the COM+ component being created is stronger than the TxIsolationLevel for the "root" component for the transaction. The creation failed.
'//
%CO_E_ISOLEVELMISMATCH            = &H8004E02F&

'//
'// MessageId: CO_E_CALL_OUT_OF_TX_SCOPE_NOT_ALLOWED
'//
'// MessageText:
'//
'// The component attempted to make a cross-context call between invocations of EnterTransactionScopeand ExitTransactionScope. This is not allowed. Cross-context calls cannot be made while inside of a transaction scope.
'//
%CO_E_CALL_OUT_OF_TX_SCOPE_NOT_ALLOWED = &H8004E030&

'//
'// MessageId: CO_E_EXIT_TRANSACTION_SCOPE_NOT_CALLED
'//
'// MessageText:
'//
'// The component made a call to EnterTransactionScope, but did not make a corresponding call to ExitTransactionScope before returning.
'//
%CO_E_EXIT_TRANSACTION_SCOPE_NOT_CALLED = &H8004E031&

'//
'// Old OLE Success Codes
'//
'//
'// MessageId: OLE_S_USEREG
'//
'// MessageText:
'//
'// Use the registry database to provide the requested information
'//
%OLE_S_USEREG                     = &H00040000&

'//
'// MessageId: OLE_S_STATIC
'//
'// MessageText:
'//
'// Success, but static
'//
%OLE_S_STATIC                     = &H00040001&

'//
'// MessageId: OLE_S_MAC_CLIPFORMAT
'//
'// MessageText:
'//
'// Macintosh clipboard format
'//
%OLE_S_MAC_CLIPFORMAT             = &H00040002&

'//
'// MessageId: DRAGDROP_S_DROP
'//
'// MessageText:
'//
'// Successful drop took place
'//
%DRAGDROP_S_DROP                  = &H00040100&

'//
'// MessageId: DRAGDROP_S_CANCEL
'//
'// MessageText:
'//
'// Drag-drop operation canceled
'//
%DRAGDROP_S_CANCEL                = &H00040101&

'//
'// MessageId: DRAGDROP_S_USEDEFAULTCURSORS
'//
'// MessageText:
'//
'// Use the default cursor
'//
%DRAGDROP_S_USEDEFAULTCURSORS     = &H00040102&

'//
'// MessageId: DATA_S_SAMEFORMATETC
'//
'// MessageText:
'//
'// Data has same FORMATETC
'//
%DATA_S_SAMEFORMATETC             = &H00040130&

'//
'// MessageId: VIEW_S_ALREADY_FROZEN
'//
'// MessageText:
'//
'// View is already frozen
'//
%VIEW_S_ALREADY_FROZEN            = &H00040140&

'//
'// MessageId: CACHE_S_FORMATETC_NOTSUPPORTED
'//
'// MessageText:
'//
'// FORMATETC not supported
'//
%CACHE_S_FORMATETC_NOTSUPPORTED   = &H00040170&

'//
'// MessageId: CACHE_S_SAMECACHE
'//
'// MessageText:
'//
'// Same cache
'//
%CACHE_S_SAMECACHE                = &H00040171&

'//
'// MessageId: CACHE_S_SOMECACHES_NOTUPDATED
'//
'// MessageText:
'//
'// Some cache(s) not updated
'//
%CACHE_S_SOMECACHES_NOTUPDATED    = &H00040172&

'//
'// MessageId: OLEOBJ_S_INVALIDVERB
'//
'// MessageText:
'//
'// Invalid verb for OLE object
'//
%OLEOBJ_S_INVALIDVERB             = &H00040180&

'//
'// MessageId: OLEOBJ_S_CANNOT_DOVERB_NOW
'//
'// MessageText:
'//
'// Verb number is valid but verb cannot be done now
'//
%OLEOBJ_S_CANNOT_DOVERB_NOW       = &H00040181&

'//
'// MessageId: OLEOBJ_S_INVALIDHWND
'//
'// MessageText:
'//
'// Invalid window handle passed
'//
%OLEOBJ_S_INVALIDHWND             = &H00040182&

'//
'// MessageId: INPLACE_S_TRUNCATED
'//
'// MessageText:
'//
'// Message is too long; some of it had to be truncated before displaying
'//
%INPLACE_S_TRUNCATED              = &H000401A0&

'//
'// MessageId: CONVERT10_S_NO_PRESENTATION
'//
'// MessageText:
'//
'// Unable to convert OLESTREAM to IStorage
'//
%CONVERT10_S_NO_PRESENTATION      = &H000401C0&

'//
'// MessageId: MK_S_REDUCED_TO_SELF
'//
'// MessageText:
'//
'// Moniker reduced to itself
'//
%MK_S_REDUCED_TO_SELF             = &H000401E2&

'//
'// MessageId: MK_S_ME
'//
'// MessageText:
'//
'// Common prefix is this moniker
'//
%MK_S_ME                          = &H000401E4&

'//
'// MessageId: MK_S_HIM
'//
'// MessageText:
'//
'// Common prefix is input moniker
'//
%MK_S_HIM                         = &H000401E5&

'//
'// MessageId: MK_S_US
'//
'// MessageText:
'//
'// Common prefix is both monikers
'//
%MK_S_US                          = &H000401E6&

'//
'// MessageId: MK_S_MONIKERALREADYREGISTERED
'//
'// MessageText:
'//
'// Moniker is already registered in running object table
'//
%MK_S_MONIKERALREADYREGISTERED    = &H000401E7&

'//
'// Task Scheduler errors
'//
'//
'// MessageId: SCHED_S_TASK_READY
'//
'// MessageText:
'//
'// The task is ready to run at its next scheduled time.
'//
%SCHED_S_TASK_READY               = &H00041300&

'//
'// MessageId: SCHED_S_TASK_RUNNING
'//
'// MessageText:
'//
'// The task is currently running.
'//
%SCHED_S_TASK_RUNNING             = &H00041301&

'//
'// MessageId: SCHED_S_TASK_DISABLED
'//
'// MessageText:
'//
'// The task will not run at the scheduled times because it has been disabled.
'//
%SCHED_S_TASK_DISABLED            = &H00041302&

'//
'// MessageId: SCHED_S_TASK_HAS_NOT_RUN
'//
'// MessageText:
'//
'// The task has not yet run.
'//
%SCHED_S_TASK_HAS_NOT_RUN         = &H00041303&

'//
'// MessageId: SCHED_S_TASK_NO_MORE_RUNS
'//
'// MessageText:
'//
'// There are no more runs scheduled for this task.
'//
%SCHED_S_TASK_NO_MORE_RUNS        = &H00041304&

'//
'// MessageId: SCHED_S_TASK_NOT_SCHEDULED
'//
'// MessageText:
'//
'// One or more of the properties that are needed to run this task on a schedule have not been set.
'//
%SCHED_S_TASK_NOT_SCHEDULED       = &H00041305&

'//
'// MessageId: SCHED_S_TASK_TERMINATED
'//
'// MessageText:
'//
'// The last run of the task was terminated by the user.
'//
%SCHED_S_TASK_TERMINATED          = &H00041306&

'//
'// MessageId: SCHED_S_TASK_NO_VALID_TRIGGERS
'//
'// MessageText:
'//
'// Either the task has no triggers or the existing triggers are disabled or not set.
'//
%SCHED_S_TASK_NO_VALID_TRIGGERS   = &H00041307&

'//
'// MessageId: SCHED_S_EVENT_TRIGGER
'//
'// MessageText:
'//
'// Event triggers don't have set run times.
'//
%SCHED_S_EVENT_TRIGGER            = &H00041308&

'//
'// MessageId: SCHED_E_TRIGGER_NOT_FOUND
'//
'// MessageText:
'//
'// Trigger not found.
'//
%SCHED_E_TRIGGER_NOT_FOUND        = &H80041309&

'//
'// MessageId: SCHED_E_TASK_NOT_READY
'//
'// MessageText:
'//
'// One or more of the properties that are needed to run this task have not been set.
'//
%SCHED_E_TASK_NOT_READY           = &H8004130A&

'//
'// MessageId: SCHED_E_TASK_NOT_RUNNING
'//
'// MessageText:
'//
'// There is no running instance of the task.
'//
%SCHED_E_TASK_NOT_RUNNING         = &H8004130B&

'//
'// MessageId: SCHED_E_SERVICE_NOT_INSTALLED
'//
'// MessageText:
'//
'// The Task Scheduler Service is not installed on this computer.
'//
%SCHED_E_SERVICE_NOT_INSTALLED    = &H8004130C&

'//
'// MessageId: SCHED_E_CANNOT_OPEN_TASK
'//
'// MessageText:
'//
'// The task object could not be opened.
'//
%SCHED_E_CANNOT_OPEN_TASK         = &H8004130D&

'//
'// MessageId: SCHED_E_INVALID_TASK
'//
'// MessageText:
'//
'// The object is either an invalid task object or is not a task object.
'//
%SCHED_E_INVALID_TASK             = &H8004130E&

'//
'// MessageId: SCHED_E_ACCOUNT_INFORMATION_NOT_SET
'//
'// MessageText:
'//
'// No account information could be found in the Task Scheduler security database for the task indicated.
'//
%SCHED_E_ACCOUNT_INFORMATION_NOT_SET = &H8004130F&

'//
'// MessageId: SCHED_E_ACCOUNT_NAME_NOT_FOUND
'//
'// MessageText:
'//
'// Unable to establish existence of the account specified.
'//
%SCHED_E_ACCOUNT_NAME_NOT_FOUND   = &H80041310&

'//
'// MessageId: SCHED_E_ACCOUNT_DBASE_CORRUPT
'//
'// MessageText:
'//
'// Corruption was detected in the Task Scheduler security database; the database has been reset.
'//
%SCHED_E_ACCOUNT_DBASE_CORRUPT    = &H80041311&

'//
'// MessageId: SCHED_E_NO_SECURITY_SERVICES
'//
'// MessageText:
'//
'// Task Scheduler security services are available only on Windows NT.
'//
%SCHED_E_NO_SECURITY_SERVICES     = &H80041312&

'//
'// MessageId: SCHED_E_UNKNOWN_OBJECT_VERSION
'//
'// MessageText:
'//
'// The task object version is either unsupported or invalid.
'//
%SCHED_E_UNKNOWN_OBJECT_VERSION   = &H80041313&

'//
'// MessageId: SCHED_E_UNSUPPORTED_ACCOUNT_OPTION
'//
'// MessageText:
'//
'// The task has been configured with an unsupported combination of account settings and run time options.
'//
%SCHED_E_UNSUPPORTED_ACCOUNT_OPTION = &H80041314&

'//
'// MessageId: SCHED_E_SERVICE_NOT_RUNNING
'//
'// MessageText:
'//
'// The Task Scheduler Service is not running.
'//
%SCHED_E_SERVICE_NOT_RUNNING      = &H80041315&

'//
'// MessageId: SCHED_E_UNEXPECTEDNODE
'//
'// MessageText:
'//
'// The task XML contains an unexpected node.
'//
%SCHED_E_UNEXPECTEDNODE           = &H80041316&

'//
'// MessageId: SCHED_E_NAMESPACE
'//
'// MessageText:
'//
'// The task XML contains an element or attribute from an unexpected namespace.
'//
%SCHED_E_NAMESPACE                = &H80041317&

'//
'// MessageId: SCHED_E_INVALIDVALUE
'//
'// MessageText:
'//
'// The task XML contains a value which is incorrectly formatted or out of range.
'//
%SCHED_E_INVALIDVALUE             = &H80041318&

'//
'// MessageId: SCHED_E_MISSINGNODE
'//
'// MessageText:
'//
'// The task XML is missing a required element or attribute.
'//
%SCHED_E_MISSINGNODE              = &H80041319&

'//
'// MessageId: SCHED_E_MALFORMEDXML
'//
'// MessageText:
'//
'// The task XML is malformed.
'//
%SCHED_E_MALFORMEDXML             = &H8004131A&

'//
'// MessageId: SCHED_S_SOME_TRIGGERS_FAILED
'//
'// MessageText:
'//
'// The task is registered, but not all specified triggers will start the task.
'//
%SCHED_S_SOME_TRIGGERS_FAILED     = &H0004131B&

'//
'// MessageId: SCHED_S_BATCH_LOGON_PROBLEM
'//
'// MessageText:
'//
'// The task is registered, but may fail to start. Batch logon privilege needs to be enabled for the task principal.
'//
%SCHED_S_BATCH_LOGON_PROBLEM      = &H0004131C&

'//
'// MessageId: SCHED_E_TOO_MANY_NODES
'//
'// MessageText:
'//
'// The task XML contains too many nodes of the same type.
'//
%SCHED_E_TOO_MANY_NODES           = &H8004131D&

'//
'// MessageId: SCHED_E_PAST_END_BOUNDARY
'//
'// MessageText:
'//
'// The task cannot be started after the trigger's end boundary.
'//
%SCHED_E_PAST_END_BOUNDARY        = &H8004131E&

'//
'// MessageId: SCHED_E_ALREADY_RUNNING
'//
'// MessageText:
'//
'// An instance of this task is already running.
'//
%SCHED_E_ALREADY_RUNNING          = &H8004131F&

'//
'// MessageId: SCHED_E_USER_NOT_LOGGED_ON
'//
'// MessageText:
'//
'// The task will not run because the user is not logged on.
'//
%SCHED_E_USER_NOT_LOGGED_ON       = &H80041320&

'//
'// MessageId: SCHED_E_INVALID_TASK_HASH
'//
'// MessageText:
'//
'// The task image is corrupt or has been tampered with.
'//
%SCHED_E_INVALID_TASK_HASH        = &H80041321&

'//
'// MessageId: SCHED_E_SERVICE_NOT_AVAILABLE
'//
'// MessageText:
'//
'// The Task Scheduler service is not available.
'//
%SCHED_E_SERVICE_NOT_AVAILABLE    = &H80041322&

'//
'// MessageId: SCHED_E_SERVICE_TOO_BUSY
'//
'// MessageText:
'//
'// The Task Scheduler service is too busy to handle your request. Please try again later.
'//
%SCHED_E_SERVICE_TOO_BUSY         = &H80041323&

'//
'// MessageId: SCHED_E_TASK_ATTEMPTED
'//
'// MessageText:
'//
'// The Task Scheduler service attempted to run the task, but the task did not run due to one of the constraints in the task definition.
'//
%SCHED_E_TASK_ATTEMPTED           = &H80041324&

'//
'// MessageId: SCHED_S_TASK_QUEUED
'//
'// MessageText:
'//
'// The Task Scheduler service has asked the task to run.
'//
%SCHED_S_TASK_QUEUED              = &H00041325&

'//
'// MessageId: SCHED_E_TASK_DISABLED
'//
'// MessageText:
'//
'// The task is disabled.
'//
%SCHED_E_TASK_DISABLED            = &H80041326&

'//
'// MessageId: SCHED_E_TASK_NOT_V1_COMPAT
'//
'// MessageText:
'//
'// The task has properties that are not compatible with previous versions of Windows.
'//
%SCHED_E_TASK_NOT_V1_COMPAT       = &H80041327&

'//
'// MessageId: SCHED_E_START_ON_DEMAND
'//
'// MessageText:
'//
'// The task settings do not allow the task to start on demand.
'//
%SCHED_E_START_ON_DEMAND          = &H80041328&

'// ******************
'// FACILITY_WINDOWS
'// ******************
'//
'// Codes 0x0-0x01ff are reserved for the OLE group of
'// interfaces.
'//
'//
'// MessageId: CO_E_CLASS_CREATE_FAILED
'//
'// MessageText:
'//
'// Attempt to create a class object failed
'//
%CO_E_CLASS_CREATE_FAILED         = &H80080001&

'//
'// MessageId: CO_E_SCM_ERROR
'//
'// MessageText:
'//
'// OLE service could not bind object
'//
%CO_E_SCM_ERROR                   = &H80080002&

'//
'// MessageId: CO_E_SCM_RPC_FAILURE
'//
'// MessageText:
'//
'// RPC communication failed with OLE service
'//
%CO_E_SCM_RPC_FAILURE             = &H80080003&

'//
'// MessageId: CO_E_BAD_PATH
'//
'// MessageText:
'//
'// Bad path to object
'//
%CO_E_BAD_PATH                    = &H80080004&

'//
'// MessageId: CO_E_SERVER_EXEC_FAILURE
'//
'// MessageText:
'//
'// Server execution failed
'//
%CO_E_SERVER_EXEC_FAILURE         = &H80080005&

'//
'// MessageId: CO_E_OBJSRV_RPC_FAILURE
'//
'// MessageText:
'//
'// OLE service could not communicate with the object server
'//
%CO_E_OBJSRV_RPC_FAILURE          = &H80080006&

'//
'// MessageId: MK_E_NO_NORMALIZED
'//
'// MessageText:
'//
'// Moniker path could not be normalized
'//
%MK_E_NO_NORMALIZED               = &H80080007&

'//
'// MessageId: CO_E_SERVER_STOPPING
'//
'// MessageText:
'//
'// Object server is stopping when OLE service contacts it
'//
%CO_E_SERVER_STOPPING             = &H80080008&

'//
'// MessageId: MEM_E_INVALID_ROOT
'//
'// MessageText:
'//
'// An invalid root block pointer was specified
'//
%MEM_E_INVALID_ROOT               = &H80080009&

'//
'// MessageId: MEM_E_INVALID_LINK
'//
'// MessageText:
'//
'// An allocation chain contained an invalid link pointer
'//
%MEM_E_INVALID_LINK               = &H80080010&

'//
'// MessageId: MEM_E_INVALID_SIZE
'//
'// MessageText:
'//
'// The requested allocation size was too large
'//
%MEM_E_INVALID_SIZE               = &H80080011&

'//
'// MessageId: CO_S_NOTALLINTERFACES
'//
'// MessageText:
'//
'// Not all the requested interfaces were available
'//
%CO_S_NOTALLINTERFACES            = &H00080012&

'//
'// MessageId: CO_S_MACHINENAMENOTFOUND
'//
'// MessageText:
'//
'// The specified machine name was not found in the cache.
'//
%CO_S_MACHINENAMENOTFOUND         = &H00080013&

'//
'// MessageId: CO_E_MISSING_DISPLAYNAME
'//
'// MessageText:
'//
'// The activation requires a display name to be present under the CLSID key.
'//
%CO_E_MISSING_DISPLAYNAME         = &H80080015&

'//
'// MessageId: CO_E_RUNAS_VALUE_MUST_BE_AAA
'//
'// MessageText:
'//
'// The activation requires that the RunAs value for the application is Activate As Activator.
'//
%CO_E_RUNAS_VALUE_MUST_BE_AAA     = &H80080016&

'//
'// MessageId: CO_E_ELEVATION_DISABLED
'//
'// MessageText:
'//
'// The class is not configured to support Elevated activation.
'//
%CO_E_ELEVATION_DISABLED          = &H80080017&

'// ******************
'// FACILITY_DISPATCH
'// ******************
'//
'// MessageId: DISP_E_UNKNOWNINTERFACE
'//
'// MessageText:
'//
'// Unknown interface.
'//
%DISP_E_UNKNOWNINTERFACE          = &H80020001&

'//
'// MessageId: DISP_E_MEMBERNOTFOUND
'//
'// MessageText:
'//
'// Member not found.
'//
%DISP_E_MEMBERNOTFOUND            = &H80020003&

'//
'// MessageId: DISP_E_PARAMNOTFOUND
'//
'// MessageText:
'//
'// Parameter not found.
'//
%DISP_E_PARAMNOTFOUND             = &H80020004&

'//
'// MessageId: DISP_E_TYPEMISMATCH
'//
'// MessageText:
'//
'// Type mismatch.
'//
%DISP_E_TYPEMISMATCH              = &H80020005&

'//
'// MessageId: DISP_E_UNKNOWNNAME
'//
'// MessageText:
'//
'// Unknown name.
'//
%DISP_E_UNKNOWNNAME               = &H80020006&

'//
'// MessageId: DISP_E_NONAMEDARGS
'//
'// MessageText:
'//
'// No named arguments.
'//
%DISP_E_NONAMEDARGS               = &H80020007&

'//
'// MessageId: DISP_E_BADVARTYPE
'//
'// MessageText:
'//
'// Bad variable type.
'//
%DISP_E_BADVARTYPE                = &H80020008&

'//
'// MessageId: DISP_E_EXCEPTION
'//
'// MessageText:
'//
'// Exception occurred.
'//
%DISP_E_EXCEPTION                 = &H80020009&

'//
'// MessageId: DISP_E_OVERFLOW
'//
'// MessageText:
'//
'// Out of present range.
'//
%DISP_E_OVERFLOW                  = &H8002000A&

'//
'// MessageId: DISP_E_BADINDEX
'//
'// MessageText:
'//
'// Invalid index.
'//
%DISP_E_BADINDEX                  = &H8002000B&

'//
'// MessageId: DISP_E_UNKNOWNLCID
'//
'// MessageText:
'//
'// Unknown language.
'//
%DISP_E_UNKNOWNLCID               = &H8002000C&

'//
'// MessageId: DISP_E_ARRAYISLOCKED
'//
'// MessageText:
'//
'// Memory is locked.
'//
%DISP_E_ARRAYISLOCKED             = &H8002000D&

'//
'// MessageId: DISP_E_BADPARAMCOUNT
'//
'// MessageText:
'//
'// Invalid number of parameters.
'//
%DISP_E_BADPARAMCOUNT             = &H8002000E&

'//
'// MessageId: DISP_E_PARAMNOTOPTIONAL
'//
'// MessageText:
'//
'// Parameter not optional.
'//
%DISP_E_PARAMNOTOPTIONAL          = &H8002000F&

'//
'// MessageId: DISP_E_BADCALLEE
'//
'// MessageText:
'//
'// Invalid callee.
'//
%DISP_E_BADCALLEE                 = &H80020010&

'//
'// MessageId: DISP_E_NOTACOLLECTION
'//
'// MessageText:
'//
'// Does not support a collection.
'//
%DISP_E_NOTACOLLECTION            = &H80020011&

'//
'// MessageId: DISP_E_DIVBYZERO
'//
'// MessageText:
'//
'// Division by zero.
'//
%DISP_E_DIVBYZERO                 = &H80020012&

'//
'// MessageId: DISP_E_BUFFERTOOSMALL
'//
'// MessageText:
'//
'// Buffer too small
'//
%DISP_E_BUFFERTOOSMALL            = &H80020013&

'//
'// MessageId: TYPE_E_BUFFERTOOSMALL
'//
'// MessageText:
'//
'// Buffer too small.
'//
%TYPE_E_BUFFERTOOSMALL            = &H80028016&

'//
'// MessageId: TYPE_E_FIELDNOTFOUND
'//
'// MessageText:
'//
'// Field name not defined in the record.
'//
%TYPE_E_FIELDNOTFOUND             = &H80028017&

'//
'// MessageId: TYPE_E_INVDATAREAD
'//
'// MessageText:
'//
'// Old format or invalid type library.
'//
%TYPE_E_INVDATAREAD               = &H80028018&

'//
'// MessageId: TYPE_E_UNSUPFORMAT
'//
'// MessageText:
'//
'// Old format or invalid type library.
'//
%TYPE_E_UNSUPFORMAT               = &H80028019&

'//
'// MessageId: TYPE_E_REGISTRYACCESS
'//
'// MessageText:
'//
'// Error accessing the OLE registry.
'//
%TYPE_E_REGISTRYACCESS            = &H8002801C&

'//
'// MessageId: TYPE_E_LIBNOTREGISTERED
'//
'// MessageText:
'//
'// Library not registered.
'//
%TYPE_E_LIBNOTREGISTERED          = &H8002801D&

'//
'// MessageId: TYPE_E_UNDEFINEDTYPE
'//
'// MessageText:
'//
'// Bound to unknown type.
'//
%TYPE_E_UNDEFINEDTYPE             = &H80028027&

'//
'// MessageId: TYPE_E_QUALIFIEDNAMEDISALLOWED
'//
'// MessageText:
'//
'// Qualified name disallowed.
'//
%TYPE_E_QUALIFIEDNAMEDISALLOWED   = &H80028028&

'//
'// MessageId: TYPE_E_INVALIDSTATE
'//
'// MessageText:
'//
'// Invalid forward reference, or reference to uncompiled type.
'//
%TYPE_E_INVALIDSTATE              = &H80028029&

'//
'// MessageId: TYPE_E_WRONGTYPEKIND
'//
'// MessageText:
'//
'// Type mismatch.
'//
%TYPE_E_WRONGTYPEKIND             = &H8002802A&

'//
'// MessageId: TYPE_E_ELEMENTNOTFOUND
'//
'// MessageText:
'//
'// Element not found.
'//
%TYPE_E_ELEMENTNOTFOUND           = &H8002802B&

'//
'// MessageId: TYPE_E_AMBIGUOUSNAME
'//
'// MessageText:
'//
'// Ambiguous name.
'//
%TYPE_E_AMBIGUOUSNAME             = &H8002802C&

'//
'// MessageId: TYPE_E_NAMECONFLICT
'//
'// MessageText:
'//
'// Name already exists in the library.
'//
%TYPE_E_NAMECONFLICT              = &H8002802D&

'//
'// MessageId: TYPE_E_UNKNOWNLCID
'//
'// MessageText:
'//
'// Unknown LCID.
'//
%TYPE_E_UNKNOWNLCID               = &H8002802E&

'//
'// MessageId: TYPE_E_DLLFUNCTIONNOTFOUND
'//
'// MessageText:
'//
'// Function not defined in specified DLL.
'//
%TYPE_E_DLLFUNCTIONNOTFOUND       = &H8002802F&

'//
'// MessageId: TYPE_E_BADMODULEKIND
'//
'// MessageText:
'//
'// Wrong module kind for the operation.
'//
%TYPE_E_BADMODULEKIND             = &H800288BD&

'//
'// MessageId: TYPE_E_SIZETOOBIG
'//
'// MessageText:
'//
'// Size may not exceed 64K.
'//
%TYPE_E_SIZETOOBIG                = &H800288C5&

'//
'// MessageId: TYPE_E_DUPLICATEID
'//
'// MessageText:
'//
'// Duplicate ID in inheritance hierarchy.
'//
%TYPE_E_DUPLICATEID               = &H800288C6&

'//
'// MessageId: TYPE_E_INVALIDID
'//
'// MessageText:
'//
'// Incorrect inheritance depth in standard OLE hmember.
'//
%TYPE_E_INVALIDID                 = &H800288CF&

'//
'// MessageId: TYPE_E_TYPEMISMATCH
'//
'// MessageText:
'//
'// Type mismatch.
'//
%TYPE_E_TYPEMISMATCH              = &H80028CA0&

'//
'// MessageId: TYPE_E_OUTOFBOUNDS
'//
'// MessageText:
'//
'// Invalid number of arguments.
'//
%TYPE_E_OUTOFBOUNDS               = &H80028CA1&

'//
'// MessageId: TYPE_E_IOERROR
'//
'// MessageText:
'//
'// I/O Error.
'//
%TYPE_E_IOERROR                   = &H80028CA2&

'//
'// MessageId: TYPE_E_CANTCREATETMPFILE
'//
'// MessageText:
'//
'// Error creating unique tmp file.
'//
%TYPE_E_CANTCREATETMPFILE         = &H80028CA3&

'//
'// MessageId: TYPE_E_CANTLOADLIBRARY
'//
'// MessageText:
'//
'// Error loading type library/DLL.
'//
%TYPE_E_CANTLOADLIBRARY           = &H80029C4A&

'//
'// MessageId: TYPE_E_INCONSISTENTPROPFUNCS
'//
'// MessageText:
'//
'// Inconsistent property functions.
'//
%TYPE_E_INCONSISTENTPROPFUNCS     = &H80029C83&

'//
'// MessageId: TYPE_E_CIRCULARTYPE
'//
'// MessageText:
'//
'// Circular dependency between types/modules.
'//
%TYPE_E_CIRCULARTYPE              = &H80029C84&

'// ******************
'// FACILITY_STORAGE
'// ******************
'//
'// MessageId: STG_E_INVALIDFUNCTION
'//
'// MessageText:
'//
'// Unable to perform requested operation.
'//
%STG_E_INVALIDFUNCTION            = &H80030001&

'//
'// MessageId: STG_E_FILENOTFOUND
'//
'// MessageText:
'//
'// %1 could not be found.
'//
%STG_E_FILENOTFOUND               = &H80030002&

'//
'// MessageId: STG_E_PATHNOTFOUND
'//
'// MessageText:
'//
'// The path %1 could not be found.
'//
%STG_E_PATHNOTFOUND               = &H80030003&

'//
'// MessageId: STG_E_TOOMANYOPENFILES
'//
'// MessageText:
'//
'// There are insufficient resources to open another file.
'//
%STG_E_TOOMANYOPENFILES           = &H80030004&

'//
'// MessageId: STG_E_ACCESSDENIED
'//
'// MessageText:
'//
'// Access Denied.
'//
%STG_E_ACCESSDENIED               = &H80030005&

'//
'// MessageId: STG_E_INVALIDHANDLE
'//
'// MessageText:
'//
'// Attempted an operation on an invalid object.
'//
%STG_E_INVALIDHANDLE              = &H80030006&

'//
'// MessageId: STG_E_INSUFFICIENTMEMORY
'//
'// MessageText:
'//
'// There is insufficient memory available to complete operation.
'//
%STG_E_INSUFFICIENTMEMORY         = &H80030008&

'//
'// MessageId: STG_E_INVALIDPOINTER
'//
'// MessageText:
'//
'// Invalid pointer error.
'//
%STG_E_INVALIDPOINTER             = &H80030009&

'//
'// MessageId: STG_E_NOMOREFILES
'//
'// MessageText:
'//
'// There are no more entries to return.
'//
%STG_E_NOMOREFILES                = &H80030012&

'//
'// MessageId: STG_E_DISKISWRITEPROTECTED
'//
'// MessageText:
'//
'// Disk is write-protected.
'//
%STG_E_DISKISWRITEPROTECTED       = &H80030013&

'//
'// MessageId: STG_E_SEEKERROR
'//
'// MessageText:
'//
'// An error occurred during a seek operation.
'//
%STG_E_SEEKERROR                  = &H80030019&

'//
'// MessageId: STG_E_WRITEFAULT
'//
'// MessageText:
'//
'// A disk error occurred during a write operation.
'//
%STG_E_WRITEFAULT                 = &H8003001D&

'//
'// MessageId: STG_E_READFAULT
'//
'// MessageText:
'//
'// A disk error occurred during a read operation.
'//
%STG_E_READFAULT                  = &H8003001E&

'//
'// MessageId: STG_E_SHAREVIOLATION
'//
'// MessageText:
'//
'// A share violation has occurred.
'//
%STG_E_SHAREVIOLATION             = &H80030020&

'//
'// MessageId: STG_E_LOCKVIOLATION
'//
'// MessageText:
'//
'// A lock violation has occurred.
'//
%STG_E_LOCKVIOLATION              = &H80030021&

'//
'// MessageId: STG_E_FILEALREADYEXISTS
'//
'// MessageText:
'//
'// %1 already exists.
'//
%STG_E_FILEALREADYEXISTS          = &H80030050&

'//
'// MessageId: STG_E_INVALIDPARAMETER
'//
'// MessageText:
'//
'// Invalid parameter error.
'//
%STG_E_INVALIDPARAMETER           = &H80030057&

'//
'// MessageId: STG_E_MEDIUMFULL
'//
'// MessageText:
'//
'// There is insufficient disk space to complete operation.
'//
%STG_E_MEDIUMFULL                 = &H80030070&

'//
'// MessageId: STG_E_PROPSETMISMATCHED
'//
'// MessageText:
'//
'// Illegal write of non-simple property to simple property set.
'//
%STG_E_PROPSETMISMATCHED          = &H800300F0&

'//
'// MessageId: STG_E_ABNORMALAPIEXIT
'//
'// MessageText:
'//
'// An API call exited abnormally.
'//
%STG_E_ABNORMALAPIEXIT            = &H800300FA&

'//
'// MessageId: STG_E_INVALIDHEADER
'//
'// MessageText:
'//
'// The file %1 is not a valid compound file.
'//
%STG_E_INVALIDHEADER              = &H800300FB&

'//
'// MessageId: STG_E_INVALIDNAME
'//
'// MessageText:
'//
'// The name %1 is not valid.
'//
%STG_E_INVALIDNAME                = &H800300FC&

'//
'// MessageId: STG_E_UNKNOWN
'//
'// MessageText:
'//
'// An unexpected error occurred.
'//
%STG_E_UNKNOWN                    = &H800300FD&

'//
'// MessageId: STG_E_UNIMPLEMENTEDFUNCTION
'//
'// MessageText:
'//
'// That function is not implemented.
'//
%STG_E_UNIMPLEMENTEDFUNCTION      = &H800300FE&

'//
'// MessageId: STG_E_INVALIDFLAG
'//
'// MessageText:
'//
'// Invalid flag error.
'//
%STG_E_INVALIDFLAG                = &H800300FF&

'//
'// MessageId: STG_E_INUSE
'//
'// MessageText:
'//
'// Attempted to use an object that is busy.
'//
%STG_E_INUSE                      = &H80030100&

'//
'// MessageId: STG_E_NOTCURRENT
'//
'// MessageText:
'//
'// The storage has been changed since the last commit.
'//
%STG_E_NOTCURRENT                 = &H80030101&

'//
'// MessageId: STG_E_REVERTED
'//
'// MessageText:
'//
'// Attempted to use an object that has ceased to exist.
'//
%STG_E_REVERTED                   = &H80030102&

'//
'// MessageId: STG_E_CANTSAVE
'//
'// MessageText:
'//
'// Can't save.
'//
%STG_E_CANTSAVE                   = &H80030103&

'//
'// MessageId: STG_E_OLDFORMAT
'//
'// MessageText:
'//
'// The compound file %1 was produced with an incompatible version of storage.
'//
%STG_E_OLDFORMAT                  = &H80030104&

'//
'// MessageId: STG_E_OLDDLL
'//
'// MessageText:
'//
'// The compound file %1 was produced with a newer version of storage.
'//
%STG_E_OLDDLL                     = &H80030105&

'//
'// MessageId: STG_E_SHAREREQUIRED
'//
'// MessageText:
'//
'// Share.exe or equivalent is required for operation.
'//
%STG_E_SHAREREQUIRED              = &H80030106&

'//
'// MessageId: STG_E_NOTFILEBASEDSTORAGE
'//
'// MessageText:
'//
'// Illegal operation called on non-file based storage.
'//
%STG_E_NOTFILEBASEDSTORAGE        = &H80030107&

'//
'// MessageId: STG_E_EXTANTMARSHALLINGS
'//
'// MessageText:
'//
'// Illegal operation called on object with extant marshallings.
'//
%STG_E_EXTANTMARSHALLINGS         = &H80030108&

'//
'// MessageId: STG_E_DOCFILECORRUPT
'//
'// MessageText:
'//
'// The docfile has been corrupted.
'//
%STG_E_DOCFILECORRUPT             = &H80030109&

'//
'// MessageId: STG_E_BADBASEADDRESS
'//
'// MessageText:
'//
'// OLE32.DLL has been loaded at the wrong address.
'//
%STG_E_BADBASEADDRESS             = &H80030110&

'//
'// MessageId: STG_E_DOCFILETOOLARGE
'//
'// MessageText:
'//
'// The compound file is too large for the current implementation
'//
%STG_E_DOCFILETOOLARGE            = &H80030111&

'//
'// MessageId: STG_E_NOTSIMPLEFORMAT
'//
'// MessageText:
'//
'// The compound file was not created with the STGM_SIMPLE flag
'//
%STG_E_NOTSIMPLEFORMAT            = &H80030112&

'//
'// MessageId: STG_E_INCOMPLETE
'//
'// MessageText:
'//
'// The file download was aborted abnormally. The file is incomplete.
'//
%STG_E_INCOMPLETE                 = &H80030201&

'//
'// MessageId: STG_E_TERMINATED
'//
'// MessageText:
'//
'// The file download has been terminated.
'//
%STG_E_TERMINATED                 = &H80030202&

'//
'// MessageId: STG_S_CONVERTED
'//
'// MessageText:
'//
'// The underlying file was converted to compound file format.
'//
%STG_S_CONVERTED                  = &H00030200&

'//
'// MessageId: STG_S_BLOCK
'//
'// MessageText:
'//
'// The storage operation should block until more data is available.
'//
%STG_S_BLOCK                      = &H00030201&

'//
'// MessageId: STG_S_RETRYNOW
'//
'// MessageText:
'//
'// The storage operation should retry immediately.
'//
%STG_S_RETRYNOW                   = &H00030202&

'//
'// MessageId: STG_S_MONITORING
'//
'// MessageText:
'//
'// The notified event sink will not influence the storage operation.
'//
%STG_S_MONITORING                 = &H00030203&

'//
'// MessageId: STG_S_MULTIPLEOPENS
'//
'// MessageText:
'//
'// Multiple opens prevent consolidated. (commit succeeded).
'//
%STG_S_MULTIPLEOPENS              = &H00030204&

'//
'// MessageId: STG_S_CONSOLIDATIONFAILED
'//
'// MessageText:
'//
'// Consolidation of the storage file failed. (commit succeeded).
'//
%STG_S_CONSOLIDATIONFAILED        = &H00030205&

'//
'// MessageId: STG_S_CANNOTCONSOLIDATE
'//
'// MessageText:
'//
'// Consolidation of the storage file is inappropriate. (commit succeeded).
'//
%STG_S_CANNOTCONSOLIDATE          = &H00030206&

'/*++

' MessageId's 0x0305 - 0x031f (inclusive) are reserved for **STORAGE**
' copy protection errors.

'--*/
'//
'// MessageId: STG_E_STATUS_COPY_PROTECTION_FAILURE
'//
'// MessageText:
'//
'// Generic Copy Protection Error.
'//
%STG_E_STATUS_COPY_PROTECTION_FAILURE = &H80030305&

'//
'// MessageId: STG_E_CSS_AUTHENTICATION_FAILURE
'//
'// MessageText:
'//
'// Copy Protection Error - DVD CSS Authentication failed.
'//
%STG_E_CSS_AUTHENTICATION_FAILURE = &H80030306&

'//
'// MessageId: STG_E_CSS_KEY_NOT_PRESENT
'//
'// MessageText:
'//
'// Copy Protection Error - The given sector does not have a valid CSS key.
'//
%STG_E_CSS_KEY_NOT_PRESENT        = &H80030307&

'//
'// MessageId: STG_E_CSS_KEY_NOT_ESTABLISHED
'//
'// MessageText:
'//
'// Copy Protection Error - DVD session key not established.
'//
%STG_E_CSS_KEY_NOT_ESTABLISHED    = &H80030308&

'//
'// MessageId: STG_E_CSS_SCRAMBLED_SECTOR
'//
'// MessageText:
'//
'// Copy Protection Error - The read failed because the sector is encrypted.
'//
%STG_E_CSS_SCRAMBLED_SECTOR       = &H80030309&

'//
'// MessageId: STG_E_CSS_REGION_MISMATCH
'//
'// MessageText:
'//
'// Copy Protection Error - The current DVD's region does not correspond to the region setting of the drive.
'//
%STG_E_CSS_REGION_MISMATCH        = &H8003030A&

'//
'// MessageId: STG_E_RESETS_EXHAUSTED
'//
'// MessageText:
'//
'// Copy Protection Error - The drive's region setting may be permanent or the number of user resets has been exhausted.
'//
%STG_E_RESETS_EXHAUSTED           = &H8003030B&

'/*++

' MessageId's 0x0305 - 0x031f (inclusive) are reserved for **STORAGE**
' copy protection errors.

'--*/
'// ******************
'// FACILITY_RPC
'// ******************
'//
'// Codes 0x0-0x11 are propagated from 16 bit OLE.
'//
'//
'// MessageId: RPC_E_CALL_REJECTED
'//
'// MessageText:
'//
'// Call was rejected by callee.
'//
%RPC_E_CALL_REJECTED              = &H80010001&

'//
'// MessageId: RPC_E_CALL_CANCELED
'//
'// MessageText:
'//
'// Call was canceled by the message filter.
'//
%RPC_E_CALL_CANCELED              = &H80010002&

'//
'// MessageId: RPC_E_CANTPOST_INSENDCALL
'//
'// MessageText:
'//
'// The caller is dispatching an intertask SendMessage call and cannot call out via PostMessage.
'//
%RPC_E_CANTPOST_INSENDCALL        = &H80010003&

'//
'// MessageId: RPC_E_CANTCALLOUT_INASYNCCALL
'//
'// MessageText:
'//
'// The caller is dispatching an asynchronous call and cannot make an outgoing call on behalf of this call.
'//
%RPC_E_CANTCALLOUT_INASYNCCALL    = &H80010004&

'//
'// MessageId: RPC_E_CANTCALLOUT_INEXTERNALCALL
'//
'// MessageText:
'//
'// It is illegal to call out while inside message filter.
'//
%RPC_E_CANTCALLOUT_INEXTERNALCALL = &H80010005&

'//
'// MessageId: RPC_E_CONNECTION_TERMINATED
'//
'// MessageText:
'//
'// The connection terminated or is in a bogus state and cannot be used any more. Other connections are still valid.
'//
%RPC_E_CONNECTION_TERMINATED      = &H80010006&

'//
'// MessageId: RPC_E_SERVER_DIED
'//
'// MessageText:
'//
'// The callee (server [not server application]) is not available and disappeared; all connections are invalid. The call may have executed.
'//
%RPC_E_SERVER_DIED                = &H80010007&

'//
'// MessageId: RPC_E_CLIENT_DIED
'//
'// MessageText:
'//
'// The caller (client) disappeared while the callee (server) was processing a call.
'//
%RPC_E_CLIENT_DIED                = &H80010008&

'//
'// MessageId: RPC_E_INVALID_DATAPACKET
'//
'// MessageText:
'//
'// The data packet with the marshalled parameter data is incorrect.
'//
%RPC_E_INVALID_DATAPACKET         = &H80010009&

'//
'// MessageId: RPC_E_CANTTRANSMIT_CALL
'//
'// MessageText:
'//
'// The call was not transmitted properly; the message queue was full and was not emptied after yielding.
'//
%RPC_E_CANTTRANSMIT_CALL          = &H8001000A&

'//
'// MessageId: RPC_E_CLIENT_CANTMARSHAL_DATA
'//
'// MessageText:
'//
'// The client (caller) cannot marshall the parameter data - low memory, etc.
'//
%RPC_E_CLIENT_CANTMARSHAL_DATA    = &H8001000B&

'//
'// MessageId: RPC_E_CLIENT_CANTUNMARSHAL_DATA
'//
'// MessageText:
'//
'// The client (caller) cannot unmarshall the return data - low memory, etc.
'//
%RPC_E_CLIENT_CANTUNMARSHAL_DATA  = &H8001000C&

'//
'// MessageId: RPC_E_SERVER_CANTMARSHAL_DATA
'//
'// MessageText:
'//
'// The server (callee) cannot marshall the return data - low memory, etc.
'//
%RPC_E_SERVER_CANTMARSHAL_DATA    = &H8001000D&

'//
'// MessageId: RPC_E_SERVER_CANTUNMARSHAL_DATA
'//
'// MessageText:
'//
'// The server (callee) cannot unmarshall the parameter data - low memory, etc.
'//
%RPC_E_SERVER_CANTUNMARSHAL_DATA  = &H8001000E&

'//
'// MessageId: RPC_E_INVALID_DATA
'//
'// MessageText:
'//
'// Received data is invalid; could be server or client data.
'//
%RPC_E_INVALID_DATA               = &H8001000F&

'//
'// MessageId: RPC_E_INVALID_PARAMETER
'//
'// MessageText:
'//
'// A particular parameter is invalid and cannot be (un)marshalled.
'//
%RPC_E_INVALID_PARAMETER          = &H80010010&

'//
'// MessageId: RPC_E_CANTCALLOUT_AGAIN
'//
'// MessageText:
'//
'// There is no second outgoing call on same channel in DDE conversation.
'//
%RPC_E_CANTCALLOUT_AGAIN          = &H80010011&

'//
'// MessageId: RPC_E_SERVER_DIED_DNE
'//
'// MessageText:
'//
'// The callee (server [not server application]) is not available and disappeared; all connections are invalid. The call did not execute.
'//
%RPC_E_SERVER_DIED_DNE            = &H80010012&

'//
'// MessageId: RPC_E_SYS_CALL_FAILED
'//
'// MessageText:
'//
'// System call failed.
'//
%RPC_E_SYS_CALL_FAILED            = &H80010100&

'//
'// MessageId: RPC_E_OUT_OF_RESOURCES
'//
'// MessageText:
'//
'// Could not allocate some required resource (memory, events, ...)
'//
%RPC_E_OUT_OF_RESOURCES           = &H80010101&

'//
'// MessageId: RPC_E_ATTEMPTED_MULTITHREAD
'//
'// MessageText:
'//
'// Attempted to make calls on more than one thread in single threaded mode.
'//
%RPC_E_ATTEMPTED_MULTITHREAD      = &H80010102&

'//
'// MessageId: RPC_E_NOT_REGISTERED
'//
'// MessageText:
'//
'// The requested interface is not registered on the server object.
'//
%RPC_E_NOT_REGISTERED             = &H80010103&

'//
'// MessageId: RPC_E_FAULT
'//
'// MessageText:
'//
'// RPC could not call the server or could not return the results of calling the server.
'//
%RPC_E_FAULT                      = &H80010104&

'//
'// MessageId: RPC_E_SERVERFAULT
'//
'// MessageText:
'//
'// The server threw an exception.
'//
%RPC_E_SERVERFAULT                = &H80010105&

'//
'// MessageId: RPC_E_CHANGED_MODE
'//
'// MessageText:
'//
'// Cannot change thread mode after it is set.
'//
%RPC_E_CHANGED_MODE               = &H80010106&

'//
'// MessageId: RPC_E_INVALIDMETHOD
'//
'// MessageText:
'//
'// The method called does not exist on the server.
'//
%RPC_E_INVALIDMETHOD              = &H80010107&

'//
'// MessageId: RPC_E_DISCONNECTED
'//
'// MessageText:
'//
'// The object invoked has disconnected from its clients.
'//
%RPC_E_DISCONNECTED               = &H80010108&

'//
'// MessageId: RPC_E_RETRY
'//
'// MessageText:
'//
'// The object invoked chose not to process the call now. Try again later.
'//
%RPC_E_RETRY                      = &H80010109&

'//
'// MessageId: RPC_E_SERVERCALL_RETRYLATER
'//
'// MessageText:
'//
'// The message filter indicated that the application is busy.
'//
%RPC_E_SERVERCALL_RETRYLATER      = &H8001010A&

'//
'// MessageId: RPC_E_SERVERCALL_REJECTED
'//
'// MessageText:
'//
'// The message filter rejected the call.
'//
%RPC_E_SERVERCALL_REJECTED        = &H8001010B&

'//
'// MessageId: RPC_E_INVALID_CALLDATA
'//
'// MessageText:
'//
'// A call control interfaces was called with invalid data.
'//
%RPC_E_INVALID_CALLDATA           = &H8001010C&

'//
'// MessageId: RPC_E_CANTCALLOUT_ININPUTSYNCCALL
'//
'// MessageText:
'//
'// An outgoing call cannot be made since the application is dispatching an input-synchronous call.
'//
%RPC_E_CANTCALLOUT_ININPUTSYNCCALL = &H8001010D&

'//
'// MessageId: RPC_E_WRONG_THREAD
'//
'// MessageText:
'//
'// The application called an interface that was marshalled for a different thread.
'//
%RPC_E_WRONG_THREAD               = &H8001010E&

'//
'// MessageId: RPC_E_THREAD_NOT_INIT
'//
'// MessageText:
'//
'// CoInitialize has not been called on the current thread.
'//
%RPC_E_THREAD_NOT_INIT            = &H8001010F&

'//
'// MessageId: RPC_E_VERSION_MISMATCH
'//
'// MessageText:
'//
'// The version of OLE on the client and server machines does not match.
'//
%RPC_E_VERSION_MISMATCH           = &H80010110&

'//
'// MessageId: RPC_E_INVALID_HEADER
'//
'// MessageText:
'//
'// OLE received a packet with an invalid header.
'//
%RPC_E_INVALID_HEADER             = &H80010111&

'//
'// MessageId: RPC_E_INVALID_EXTENSION
'//
'// MessageText:
'//
'// OLE received a packet with an invalid extension.
'//
%RPC_E_INVALID_EXTENSION          = &H80010112&

'//
'// MessageId: RPC_E_INVALID_IPID
'//
'// MessageText:
'//
'// The requested object or interface does not exist.
'//
%RPC_E_INVALID_IPID               = &H80010113&

'//
'// MessageId: RPC_E_INVALID_OBJECT
'//
'// MessageText:
'//
'// The requested object does not exist.
'//
%RPC_E_INVALID_OBJECT             = &H80010114&

'//
'// MessageId: RPC_S_CALLPENDING
'//
'// MessageText:
'//
'// OLE has sent a request and is waiting for a reply.
'//
%RPC_S_CALLPENDING                = &H80010115&

'//
'// MessageId: RPC_S_WAITONTIMER
'//
'// MessageText:
'//
'// OLE is waiting before retrying a request.
'//
%RPC_S_WAITONTIMER                = &H80010116&

'//
'// MessageId: RPC_E_CALL_COMPLETE
'//
'// MessageText:
'//
'// Call context cannot be accessed after call completed.
'//
%RPC_E_CALL_COMPLETE              = &H80010117&

'//
'// MessageId: RPC_E_UNSECURE_CALL
'//
'// MessageText:
'//
'// Impersonate on unsecure calls is not supported.
'//
%RPC_E_UNSECURE_CALL              = &H80010118&

'//
'// MessageId: RPC_E_TOO_LATE
'//
'// MessageText:
'//
'// Security must be initialized before any interfaces are marshalled or unmarshalled. It cannot be changed once initialized.
'//
%RPC_E_TOO_LATE                   = &H80010119&

'//
'// MessageId: RPC_E_NO_GOOD_SECURITY_PACKAGES
'//
'// MessageText:
'//
'// No security packages are installed on this machine or the user is not logged on or there are no compatible security packages between the client and server.
'//
%RPC_E_NO_GOOD_SECURITY_PACKAGES  = &H8001011A&

'//
'// MessageId: RPC_E_ACCESS_DENIED
'//
'// MessageText:
'//
'// Access is denied.
'//
%RPC_E_ACCESS_DENIED              = &H8001011B&

'//
'// MessageId: RPC_E_REMOTE_DISABLED
'//
'// MessageText:
'//
'// Remote calls are not allowed for this process.
'//
%RPC_E_REMOTE_DISABLED            = &H8001011C&

'//
'// MessageId: RPC_E_INVALID_OBJREF
'//
'// MessageText:
'//
'// The marshaled interface data packet (OBJREF) has an invalid or unknown format.
'//
%RPC_E_INVALID_OBJREF             = &H8001011D&

'//
'// MessageId: RPC_E_NO_CONTEXT
'//
'// MessageText:
'//
'// No context is associated with this call. This happens for some custom marshalled calls and on the client side of the call.
'//
%RPC_E_NO_CONTEXT                 = &H8001011E&

'//
'// MessageId: RPC_E_TIMEOUT
'//
'// MessageText:
'//
'// This operation returned because the timeout period expired.
'//
%RPC_E_TIMEOUT                    = &H8001011F&

'//
'// MessageId: RPC_E_NO_SYNC
'//
'// MessageText:
'//
'// There are no synchronize objects to wait on.
'//
%RPC_E_NO_SYNC                    = &H80010120&

'//
'// MessageId: RPC_E_FULLSIC_REQUIRED
'//
'// MessageText:
'//
'// Full subject issuer chain SSL principal name expected from the server.
'//
%RPC_E_FULLSIC_REQUIRED           = &H80010121&

'//
'// MessageId: RPC_E_INVALID_STD_NAME
'//
'// MessageText:
'//
'// Principal name is not a valid MSSTD name.
'//
%RPC_E_INVALID_STD_NAME           = &H80010122&

'//
'// MessageId: CO_E_FAILEDTOIMPERSONATE
'//
'// MessageText:
'//
'// Unable to impersonate DCOM client
'//
%CO_E_FAILEDTOIMPERSONATE         = &H80010123&

'//
'// MessageId: CO_E_FAILEDTOGETSECCTX
'//
'// MessageText:
'//
'// Unable to obtain server's security context
'//
%CO_E_FAILEDTOGETSECCTX           = &H80010124&

'//
'// MessageId: CO_E_FAILEDTOOPENTHREADTOKEN
'//
'// MessageText:
'//
'// Unable to open the access token of the current thread
'//
%CO_E_FAILEDTOOPENTHREADTOKEN     = &H80010125&

'//
'// MessageId: CO_E_FAILEDTOGETTOKENINFO
'//
'// MessageText:
'//
'// Unable to obtain user info from an access token
'//
%CO_E_FAILEDTOGETTOKENINFO        = &H80010126&

'//
'// MessageId: CO_E_TRUSTEEDOESNTMATCHCLIENT
'//
'// MessageText:
'//
'// The client who called IAccessControl::IsAccessPermitted was not the trustee provided to the method
'//
%CO_E_TRUSTEEDOESNTMATCHCLIENT    = &H80010127&

'//
'// MessageId: CO_E_FAILEDTOQUERYCLIENTBLANKET
'//
'// MessageText:
'//
'// Unable to obtain the client's security blanket
'//
%CO_E_FAILEDTOQUERYCLIENTBLANKET  = &H80010128&

'//
'// MessageId: CO_E_FAILEDTOSETDACL
'//
'// MessageText:
'//
'// Unable to set a discretionary ACL into a security descriptor
'//
%CO_E_FAILEDTOSETDACL             = &H80010129&

'//
'// MessageId: CO_E_ACCESSCHECKFAILED
'//
'// MessageText:
'//
'// The system function, AccessCheck, returned false
'//
%CO_E_ACCESSCHECKFAILED           = &H8001012A&

'//
'// MessageId: CO_E_NETACCESSAPIFAILED
'//
'// MessageText:
'//
'// Either NetAccessDel or NetAccessAdd returned an error code.
'//
%CO_E_NETACCESSAPIFAILED          = &H8001012B&

'//
'// MessageId: CO_E_WRONGTRUSTEENAMESYNTAX
'//
'// MessageText:
'//
'// One of the trustee strings provided by the user did not conform to the <Domain>\<Name> syntax and it was not the "*" string
'//
%CO_E_WRONGTRUSTEENAMESYNTAX      = &H8001012C&

'//
'// MessageId: CO_E_INVALIDSID
'//
'// MessageText:
'//
'// One of the security identifiers provided by the user was invalid
'//
%CO_E_INVALIDSID                  = &H8001012D&

'//
'// MessageId: CO_E_CONVERSIONFAILED
'//
'// MessageText:
'//
'// Unable to convert a wide character trustee string to a multibyte trustee string
'//
%CO_E_CONVERSIONFAILED            = &H8001012E&

'//
'// MessageId: CO_E_NOMATCHINGSIDFOUND
'//
'// MessageText:
'//
'// Unable to find a security identifier that corresponds to a trustee string provided by the user
'//
%CO_E_NOMATCHINGSIDFOUND          = &H8001012F&

'//
'// MessageId: CO_E_LOOKUPACCSIDFAILED
'//
'// MessageText:
'//
'// The system function, LookupAccountSID, failed
'//
%CO_E_LOOKUPACCSIDFAILED          = &H80010130&

'//
'// MessageId: CO_E_NOMATCHINGNAMEFOUND
'//
'// MessageText:
'//
'// Unable to find a trustee name that corresponds to a security identifier provided by the user
'//
%CO_E_NOMATCHINGNAMEFOUND         = &H80010131&

'//
'// MessageId: CO_E_LOOKUPACCNAMEFAILED
'//
'// MessageText:
'//
'// The system function, LookupAccountName, failed
'//
%CO_E_LOOKUPACCNAMEFAILED         = &H80010132&

'//
'// MessageId: CO_E_SETSERLHNDLFAILED
'//
'// MessageText:
'//
'// Unable to set or reset a serialization handle
'//
%CO_E_SETSERLHNDLFAILED           = &H80010133&

'//
'// MessageId: CO_E_FAILEDTOGETWINDIR
'//
'// MessageText:
'//
'// Unable to obtain the Windows directory
'//
%CO_E_FAILEDTOGETWINDIR           = &H80010134&

'//
'// MessageId: CO_E_PATHTOOLONG
'//
'// MessageText:
'//
'// Path too long
'//
%CO_E_PATHTOOLONG                 = &H80010135&

'//
'// MessageId: CO_E_FAILEDTOGENUUID
'//
'// MessageText:
'//
'// Unable to generate a uuid.
'//
%CO_E_FAILEDTOGENUUID             = &H80010136&

'//
'// MessageId: CO_E_FAILEDTOCREATEFILE
'//
'// MessageText:
'//
'// Unable to create file
'//
%CO_E_FAILEDTOCREATEFILE          = &H80010137&

'//
'// MessageId: CO_E_FAILEDTOCLOSEHANDLE
'//
'// MessageText:
'//
'// Unable to close a serialization handle or a file handle.
'//
%CO_E_FAILEDTOCLOSEHANDLE         = &H80010138&

'//
'// MessageId: CO_E_EXCEEDSYSACLLIMIT
'//
'// MessageText:
'//
'// The number of ACEs in an ACL exceeds the system limit.
'//
%CO_E_EXCEEDSYSACLLIMIT           = &H80010139&

'//
'// MessageId: CO_E_ACESINWRONGORDER
'//
'// MessageText:
'//
'// Not all the DENY_ACCESS ACEs are arranged in front of the GRANT_ACCESS ACEs in the stream.
'//
%CO_E_ACESINWRONGORDER            = &H8001013A&

'//
'// MessageId: CO_E_INCOMPATIBLESTREAMVERSION
'//
'// MessageText:
'//
'// The version of ACL format in the stream is not supported by this implementation of IAccessControl
'//
%CO_E_INCOMPATIBLESTREAMVERSION   = &H8001013B&

'//
'// MessageId: CO_E_FAILEDTOOPENPROCESSTOKEN
'//
'// MessageText:
'//
'// Unable to open the access token of the server process
'//
%CO_E_FAILEDTOOPENPROCESSTOKEN    = &H8001013C&

'//
'// MessageId: CO_E_DECODEFAILED
'//
'// MessageText:
'//
'// Unable to decode the ACL in the stream provided by the user
'//
%CO_E_DECODEFAILED                = &H8001013D&

'//
'// MessageId: CO_E_ACNOTINITIALIZED
'//
'// MessageText:
'//
'// The COM IAccessControl object is not initialized
'//
%CO_E_ACNOTINITIALIZED            = &H8001013F&

'//
'// MessageId: CO_E_CANCEL_DISABLED
'//
'// MessageText:
'//
'// Call Cancellation is disabled
'//
%CO_E_CANCEL_DISABLED             = &H80010140&

'//
'// MessageId: RPC_E_UNEXPECTED
'//
'// MessageText:
'//
'// An internal error occurred.
'//
%RPC_E_UNEXPECTED                 = &H8001FFFF&



'//////////////////////////////////////
'//                                  //
'// Additional Security Status Codes //
'//                                  //
'// Facility=Security                //
'//                                  //
'//////////////////////////////////////


'//
'// MessageId: ERROR_AUDITING_DISABLED
'//
'// MessageText:
'//
'// The specified event is currently not being audited.
'//
%ERROR_AUDITING_DISABLED          = &HC0090001&

'//
'// MessageId: ERROR_ALL_SIDS_FILTERED
'//
'// MessageText:
'//
'// The SID filtering operation removed all SIDs.
'//
%ERROR_ALL_SIDS_FILTERED          = &HC0090002&

'//
'// MessageId: ERROR_BIZRULES_NOT_ENABLED
'//
'// MessageText:
'//
'// Business rule scripts are disabled for the calling application.
'//
%ERROR_BIZRULES_NOT_ENABLED       = &HC0090003&



'/////////////////////////////////////////////
'//                                         //
'// end of Additional Security Status Codes //
'//                                         //
'/////////////////////////////////////////////



 '/////////////////
 '//
 '//  FACILITY_SSPI
 '//
 '/////////////////

'//
'// MessageId: NTE_BAD_UID
'//
'// MessageText:
'//
'// Bad UID.
'//
%NTE_BAD_UID                      = &H80090001&

'//
'// MessageId: NTE_BAD_HASH
'//
'// MessageText:
'//
'// Bad Hash.
'//
%NTE_BAD_HASH                     = &H80090002&

'//
'// MessageId: NTE_BAD_KEY
'//
'// MessageText:
'//
'// Bad Key.
'//
%NTE_BAD_KEY                      = &H80090003&

'//
'// MessageId: NTE_BAD_LEN
'//
'// MessageText:
'//
'// Bad Length.
'//
%NTE_BAD_LEN                      = &H80090004&

'//
'// MessageId: NTE_BAD_DATA
'//
'// MessageText:
'//
'// Bad Data.
'//
%NTE_BAD_DATA                     = &H80090005&

'//
'// MessageId: NTE_BAD_SIGNATURE
'//
'// MessageText:
'//
'// Invalid Signature.
'//
%NTE_BAD_SIGNATURE                = &H80090006&

'//
'// MessageId: NTE_BAD_VER
'//
'// MessageText:
'//
'// Bad Version of provider.
'//
%NTE_BAD_VER                      = &H80090007&

'//
'// MessageId: NTE_BAD_ALGID
'//
'// MessageText:
'//
'// Invalid algorithm specified.
'//
%NTE_BAD_ALGID                    = &H80090008&

'//
'// MessageId: NTE_BAD_FLAGS
'//
'// MessageText:
'//
'// Invalid flags specified.
'//
%NTE_BAD_FLAGS                    = &H80090009&

'//
'// MessageId: NTE_BAD_TYPE
'//
'// MessageText:
'//
'// Invalid type specified.
'//
%NTE_BAD_TYPE                     = &H8009000A&

'//
'// MessageId: NTE_BAD_KEY_STATE
'//
'// MessageText:
'//
'// Key not valid for use in specified state.
'//
%NTE_BAD_KEY_STATE                = &H8009000B&

'//
'// MessageId: NTE_BAD_HASH_STATE
'//
'// MessageText:
'//
'// Hash not valid for use in specified state.
'//
%NTE_BAD_HASH_STATE               = &H8009000C&

'//
'// MessageId: NTE_NO_KEY
'//
'// MessageText:
'//
'// Key does not exist.
'//
%NTE_NO_KEY                       = &H8009000D&

'//
'// MessageId: NTE_NO_MEMORY
'//
'// MessageText:
'//
'// Insufficient memory available for the operation.
'//
%NTE_NO_MEMORY                    = &H8009000E&

'//
'// MessageId: NTE_EXISTS
'//
'// MessageText:
'//
'// Object already exists.
'//
%NTE_EXISTS                       = &H8009000F&

'//
'// MessageId: NTE_PERM
'//
'// MessageText:
'//
'// Access denied.
'//
%NTE_PERM                         = &H80090010&

'//
'// MessageId: NTE_NOT_FOUND
'//
'// MessageText:
'//
'// Object was not found.
'//
%NTE_NOT_FOUND                    = &H80090011&

'//
'// MessageId: NTE_DOUBLE_ENCRYPT
'//
'// MessageText:
'//
'// Data already encrypted.
'//
%NTE_DOUBLE_ENCRYPT               = &H80090012&

'//
'// MessageId: NTE_BAD_PROVIDER
'//
'// MessageText:
'//
'// Invalid provider specified.
'//
%NTE_BAD_PROVIDER                 = &H80090013&

'//
'// MessageId: NTE_BAD_PROV_TYPE
'//
'// MessageText:
'//
'// Invalid provider type specified.
'//
%NTE_BAD_PROV_TYPE                = &H80090014&

'//
'// MessageId: NTE_BAD_PUBLIC_KEY
'//
'// MessageText:
'//
'// Provider's public key is invalid.
'//
%NTE_BAD_PUBLIC_KEY               = &H80090015&

'//
'// MessageId: NTE_BAD_KEYSET
'//
'// MessageText:
'//
'// Keyset does not exist
'//
%NTE_BAD_KEYSET                   = &H80090016&

'//
'// MessageId: NTE_PROV_TYPE_NOT_DEF
'//
'// MessageText:
'//
'// Provider type not defined.
'//
%NTE_PROV_TYPE_NOT_DEF            = &H80090017&

'//
'// MessageId: NTE_PROV_TYPE_ENTRY_BAD
'//
'// MessageText:
'//
'// Provider type as registered is invalid.
'//
%NTE_PROV_TYPE_ENTRY_BAD          = &H80090018&

'//
'// MessageId: NTE_KEYSET_NOT_DEF
'//
'// MessageText:
'//
'// The keyset is not defined.
'//
%NTE_KEYSET_NOT_DEF               = &H80090019&

'//
'// MessageId: NTE_KEYSET_ENTRY_BAD
'//
'// MessageText:
'//
'// Keyset as registered is invalid.
'//
%NTE_KEYSET_ENTRY_BAD             = &H8009001A&

'//
'// MessageId: NTE_PROV_TYPE_NO_MATCH
'//
'// MessageText:
'//
'// Provider type does not match registered value.
'//
%NTE_PROV_TYPE_NO_MATCH           = &H8009001B&

'//
'// MessageId: NTE_SIGNATURE_FILE_BAD
'//
'// MessageText:
'//
'// The digital signature file is corrupt.
'//
%NTE_SIGNATURE_FILE_BAD           = &H8009001C&

'//
'// MessageId: NTE_PROVIDER_DLL_FAIL
'//
'// MessageText:
'//
'// Provider DLL failed to initialize correctly.
'//
%NTE_PROVIDER_DLL_FAIL            = &H8009001D&

'//
'// MessageId: NTE_PROV_DLL_NOT_FOUND
'//
'// MessageText:
'//
'// Provider DLL could not be found.
'//
%NTE_PROV_DLL_NOT_FOUND           = &H8009001E&

'//
'// MessageId: NTE_BAD_KEYSET_PARAM
'//
'// MessageText:
'//
'// The Keyset parameter is invalid.
'//
%NTE_BAD_KEYSET_PARAM             = &H8009001F&

'//
'// MessageId: NTE_FAIL
'//
'// MessageText:
'//
'// An internal error occurred.
'//
%NTE_FAIL                         = &H80090020&

'//
'// MessageId: NTE_SYS_ERR
'//
'// MessageText:
'//
'// A base error occurred.
'//
%NTE_SYS_ERR                      = &H80090021&

'//
'// MessageId: NTE_SILENT_CONTEXT
'//
'// MessageText:
'//
'// Provider could not perform the action since the context was acquired as silent.
'//
%NTE_SILENT_CONTEXT               = &H80090022&

'//
'// MessageId: NTE_TOKEN_KEYSET_STORAGE_FULL
'//
'// MessageText:
'//
'// The security token does not have storage space available for an additional container.
'//
%NTE_TOKEN_KEYSET_STORAGE_FULL    = &H80090023&

'//
'// MessageId: NTE_TEMPORARY_PROFILE
'//
'// MessageText:
'//
'// The profile for the user is a temporary profile.
'//
%NTE_TEMPORARY_PROFILE            = &H80090024&

'//
'// MessageId: NTE_FIXEDPARAMETER
'//
'// MessageText:
'//
'// The key parameters could not be set because the CSP uses fixed parameters.
'//
%NTE_FIXEDPARAMETER               = &H80090025&

'//
'// MessageId: NTE_INVALID_HANDLE
'//
'// MessageText:
'//
'// The supplied handle is invalid.
'//
%NTE_INVALID_HANDLE               = &H80090026&

'//
'// MessageId: NTE_INVALID_PARAMETER
'//
'// MessageText:
'//
'// The parameter is incorrect.
'//
%NTE_INVALID_PARAMETER            = &H80090027&

'//
'// MessageId: NTE_BUFFER_TOO_SMALL
'//
'// MessageText:
'//
'// The buffer supplied to a function was too small.
'//
%NTE_BUFFER_TOO_SMALL             = &H80090028&

'//
'// MessageId: NTE_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The requested operation is not supported.
'//
%NTE_NOT_SUPPORTED                = &H80090029&

'//
'// MessageId: NTE_NO_MORE_ITEMS
'//
'// MessageText:
'//
'// No more data is available.
'//
%NTE_NO_MORE_ITEMS                = &H8009002A&

'//
'// MessageId: NTE_BUFFERS_OVERLAP
'//
'// MessageText:
'//
'// The supplied buffers overlap incorrectly.
'//
%NTE_BUFFERS_OVERLAP              = &H8009002B&

'//
'// MessageId: NTE_DECRYPTION_FAILURE
'//
'// MessageText:
'//
'// The specified data could not be decrypted.
'//
%NTE_DECRYPTION_FAILURE           = &H8009002C&

'//
'// MessageId: NTE_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal consistency check failed.
'//
%NTE_INTERNAL_ERROR               = &H8009002D&

'//
'// MessageId: NTE_UI_REQUIRED
'//
'// MessageText:
'//
'// This operation requires input from the user.
'//
%NTE_UI_REQUIRED                  = &H8009002E&

'//
'// MessageId: NTE_HMAC_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The cryptographic provider does not support HMAC.
'//
%NTE_HMAC_NOT_SUPPORTED           = &H8009002F&

'//
'// MessageId: SEC_E_INSUFFICIENT_MEMORY
'//
'// MessageText:
'//
'// Not enough memory is available to complete this request
'//
%SEC_E_INSUFFICIENT_MEMORY        = &H80090300&

'//
'// MessageId: SEC_E_INVALID_HANDLE
'//
'// MessageText:
'//
'// The handle specified is invalid
'//
%SEC_E_INVALID_HANDLE             = &H80090301&

'//
'// MessageId: SEC_E_UNSUPPORTED_FUNCTION
'//
'// MessageText:
'//
'// The function requested is not supported
'//
%SEC_E_UNSUPPORTED_FUNCTION       = &H80090302&

'//
'// MessageId: SEC_E_TARGET_UNKNOWN
'//
'// MessageText:
'//
'// The specified target is unknown or unreachable
'//
%SEC_E_TARGET_UNKNOWN             = &H80090303&

'//
'// MessageId: SEC_E_INTERNAL_ERROR
'//
'// MessageText:
'//
'// The Local Security Authority cannot be contacted
'//
%SEC_E_INTERNAL_ERROR             = &H80090304&

'//
'// MessageId: SEC_E_SECPKG_NOT_FOUND
'//
'// MessageText:
'//
'// The requested security package does not exist
'//
%SEC_E_SECPKG_NOT_FOUND           = &H80090305&

'//
'// MessageId: SEC_E_NOT_OWNER
'//
'// MessageText:
'//
'// The caller is not the owner of the desired credentials
'//
%SEC_E_NOT_OWNER                  = &H80090306&

'//
'// MessageId: SEC_E_CANNOT_INSTALL
'//
'// MessageText:
'//
'// The security package failed to initialize, and cannot be installed
'//
%SEC_E_CANNOT_INSTALL             = &H80090307&

'//
'// MessageId: SEC_E_INVALID_TOKEN
'//
'// MessageText:
'//
'// The token supplied to the function is invalid
'//
%SEC_E_INVALID_TOKEN              = &H80090308&

'//
'// MessageId: SEC_E_CANNOT_PACK
'//
'// MessageText:
'//
'// The security package is not able to marshall the logon buffer, so the logon attempt has failed
'//
%SEC_E_CANNOT_PACK                = &H80090309&

'//
'// MessageId: SEC_E_QOP_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The per-message Quality of Protection is not supported by the security package
'//
%SEC_E_QOP_NOT_SUPPORTED          = &H8009030A&

'//
'// MessageId: SEC_E_NO_IMPERSONATION
'//
'// MessageText:
'//
'// The security context does not allow impersonation of the client
'//
%SEC_E_NO_IMPERSONATION           = &H8009030B&

'//
'// MessageId: SEC_E_LOGON_DENIED
'//
'// MessageText:
'//
'// The logon attempt failed
'//
%SEC_E_LOGON_DENIED               = &H8009030C&

'//
'// MessageId: SEC_E_UNKNOWN_CREDENTIALS
'//
'// MessageText:
'//
'// The credentials supplied to the package were not recognized
'//
%SEC_E_UNKNOWN_CREDENTIALS        = &H8009030D&

'//
'// MessageId: SEC_E_NO_CREDENTIALS
'//
'// MessageText:
'//
'// No credentials are available in the security package
'//
%SEC_E_NO_CREDENTIALS             = &H8009030E&

'//
'// MessageId: SEC_E_MESSAGE_ALTERED
'//
'// MessageText:
'//
'// The message or signature supplied for verification has been altered
'//
%SEC_E_MESSAGE_ALTERED            = &H8009030F&

'//
'// MessageId: SEC_E_OUT_OF_SEQUENCE
'//
'// MessageText:
'//
'// The message supplied for verification is out of sequence
'//
%SEC_E_OUT_OF_SEQUENCE            = &H80090310&

'//
'// MessageId: SEC_E_NO_AUTHENTICATING_AUTHORITY
'//
'// MessageText:
'//
'// No authority could be contacted for authentication.
'//
%SEC_E_NO_AUTHENTICATING_AUTHORITY = &H80090311&

'//
'// MessageId: SEC_I_CONTINUE_NEEDED
'//
'// MessageText:
'//
'// The function completed successfully, but must be called again to complete the context
'//
%SEC_I_CONTINUE_NEEDED            = &H00090312&

'//
'// MessageId: SEC_I_COMPLETE_NEEDED
'//
'// MessageText:
'//
'// The function completed successfully, but CompleteToken must be called
'//
%SEC_I_COMPLETE_NEEDED            = &H00090313&

'//
'// MessageId: SEC_I_COMPLETE_AND_CONTINUE
'//
'// MessageText:
'//
'// The function completed successfully, but both CompleteToken and this function must be called to complete the context
'//
%SEC_I_COMPLETE_AND_CONTINUE      = &H00090314&

'//
'// MessageId: SEC_I_LOCAL_LOGON
'//
'// MessageText:
'//
'// The logon was completed, but no network authority was available. The logon was made using locally known information
'//
%SEC_I_LOCAL_LOGON                = &H00090315&

'//
'// MessageId: SEC_E_BAD_PKGID
'//
'// MessageText:
'//
'// The requested security package does not exist
'//
%SEC_E_BAD_PKGID                  = &H80090316&

'//
'// MessageId: SEC_E_CONTEXT_EXPIRED
'//
'// MessageText:
'//
'// The context has expired and can no longer be used.
'//
%SEC_E_CONTEXT_EXPIRED            = &H80090317&

'//
'// MessageId: SEC_I_CONTEXT_EXPIRED
'//
'// MessageText:
'//
'// The context has expired and can no longer be used.
'//
%SEC_I_CONTEXT_EXPIRED            = &H00090317&

'//
'// MessageId: SEC_E_INCOMPLETE_MESSAGE
'//
'// MessageText:
'//
'// The supplied message is incomplete. The signature was not verified.
'//
%SEC_E_INCOMPLETE_MESSAGE         = &H80090318&

'//
'// MessageId: SEC_E_INCOMPLETE_CREDENTIALS
'//
'// MessageText:
'//
'// The credentials supplied were not complete, and could not be verified. The context could not be initialized.
'//
%SEC_E_INCOMPLETE_CREDENTIALS     = &H80090320&

'//
'// MessageId: SEC_E_BUFFER_TOO_SMALL
'//
'// MessageText:
'//
'// The buffers supplied to a function was too small.
'//
%SEC_E_BUFFER_TOO_SMALL           = &H80090321&

'//
'// MessageId: SEC_I_INCOMPLETE_CREDENTIALS
'//
'// MessageText:
'//
'// The credentials supplied were not complete, and could not be verified. Additional information can be returned from the context.
'//
%SEC_I_INCOMPLETE_CREDENTIALS     = &H00090320&

'//
'// MessageId: SEC_I_RENEGOTIATE
'//
'// MessageText:
'//
'// The context data must be renegotiated with the peer.
'//
%SEC_I_RENEGOTIATE                = &H00090321&

'//
'// MessageId: SEC_E_WRONG_PRINCIPAL
'//
'// MessageText:
'//
'// The target principal name is incorrect.
'//
%SEC_E_WRONG_PRINCIPAL            = &H80090322&

'//
'// MessageId: SEC_I_NO_LSA_CONTEXT
'//
'// MessageText:
'//
'// There is no LSA mode context associated with this context.
'//
%SEC_I_NO_LSA_CONTEXT             = &H00090323&

'//
'// MessageId: SEC_E_TIME_SKEW
'//
'// MessageText:
'//
'// The clocks on the client and server machines are skewed.
'//
%SEC_E_TIME_SKEW                  = &H80090324&

'//
'// MessageId: SEC_E_UNTRUSTED_ROOT
'//
'// MessageText:
'//
'// The certificate chain was issued by an authority that is not trusted.
'//
%SEC_E_UNTRUSTED_ROOT             = &H80090325&

'//
'// MessageId: SEC_E_ILLEGAL_MESSAGE
'//
'// MessageText:
'//
'// The message received was unexpected or badly formatted.
'//
%SEC_E_ILLEGAL_MESSAGE            = &H80090326&

'//
'// MessageId: SEC_E_CERT_UNKNOWN
'//
'// MessageText:
'//
'// An unknown error occurred while processing the certificate.
'//
%SEC_E_CERT_UNKNOWN               = &H80090327&

'//
'// MessageId: SEC_E_CERT_EXPIRED
'//
'// MessageText:
'//
'// The received certificate has expired.
'//
%SEC_E_CERT_EXPIRED               = &H80090328&

'//
'// MessageId: SEC_E_ENCRYPT_FAILURE
'//
'// MessageText:
'//
'// The specified data could not be encrypted.
'//
%SEC_E_ENCRYPT_FAILURE            = &H80090329&

'//
'// MessageId: SEC_E_DECRYPT_FAILURE
'//
'// MessageText:
'//
'// The specified data could not be decrypted.
'//
'//
%SEC_E_DECRYPT_FAILURE            = &H80090330&

'//
'// MessageId: SEC_E_ALGORITHM_MISMATCH
'//
'// MessageText:
'//
'// The client and server cannot communicate, because they do not possess a common algorithm.
'//
%SEC_E_ALGORITHM_MISMATCH         = &H80090331&

'//
'// MessageId: SEC_E_SECURITY_QOS_FAILED
'//
'// MessageText:
'//
'// The security context could not be established due to a failure in the requested quality of service (e.g. mutual authentication or delegation).
'//
%SEC_E_SECURITY_QOS_FAILED        = &H80090332&

'//
'// MessageId: SEC_E_UNFINISHED_CONTEXT_DELETED
'//
'// MessageText:
'//
'// A security context was deleted before the context was completed. This is considered a logon failure.
'//
%SEC_E_UNFINISHED_CONTEXT_DELETED = &H80090333&

'//
'// MessageId: SEC_E_NO_TGT_REPLY
'//
'// MessageText:
'//
'// The client is trying to negotiate a context and the server requires user-to-user but didn't send a TGT reply.
'//
%SEC_E_NO_TGT_REPLY               = &H80090334&

'//
'// MessageId: SEC_E_NO_IP_ADDRESSES
'//
'// MessageText:
'//
'// Unable to accomplish the requested task because the local machine does not have any IP addresses.
'//
%SEC_E_NO_IP_ADDRESSES            = &H80090335&

'//
'// MessageId: SEC_E_WRONG_CREDENTIAL_HANDLE
'//
'// MessageText:
'//
'// The supplied credential handle does not match the credential associated with the security context.
'//
%SEC_E_WRONG_CREDENTIAL_HANDLE    = &H80090336&

'//
'// MessageId: SEC_E_CRYPTO_SYSTEM_INVALID
'//
'// MessageText:
'//
'// The crypto system or checksum function is invalid because a required function is unavailable.
'//
%SEC_E_CRYPTO_SYSTEM_INVALID      = &H80090337&

'//
'// MessageId: SEC_E_MAX_REFERRALS_EXCEEDED
'//
'// MessageText:
'//
'// The number of maximum ticket referrals has been exceeded.
'//
%SEC_E_MAX_REFERRALS_EXCEEDED     = &H80090338&

'//
'// MessageId: SEC_E_MUST_BE_KDC
'//
'// MessageText:
'//
'// The local machine must be a Kerberos KDC (domain controller) and it is not.
'//
%SEC_E_MUST_BE_KDC                = &H80090339&

'//
'// MessageId: SEC_E_STRONG_CRYPTO_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The other end of the security negotiation is requires strong crypto but it is not supported on the local machine.
'//
%SEC_E_STRONG_CRYPTO_NOT_SUPPORTED = &H8009033A&

'//
'// MessageId: SEC_E_TOO_MANY_PRINCIPALS
'//
'// MessageText:
'//
'// The KDC reply contained more than one principal name.
'//
%SEC_E_TOO_MANY_PRINCIPALS        = &H8009033B&

'//
'// MessageId: SEC_E_NO_PA_DATA
'//
'// MessageText:
'//
'// Expected to find PA data for a hint of what etype to use, but it was not found.
'//
%SEC_E_NO_PA_DATA                 = &H8009033C&

'//
'// MessageId: SEC_E_PKINIT_NAME_MISMATCH
'//
'// MessageText:
'//
'// The client certificate does not contain a valid UPN, or does not match the client name
'// in the logon request. Please contact your administrator.
'//
%SEC_E_PKINIT_NAME_MISMATCH       = &H8009033D&

'//
'// MessageId: SEC_E_SMARTCARD_LOGON_REQUIRED
'//
'// MessageText:
'//
'// Smartcard logon is required and was not used.
'//
%SEC_E_SMARTCARD_LOGON_REQUIRED   = &H8009033E&

'//
'// MessageId: SEC_E_SHUTDOWN_IN_PROGRESS
'//
'// MessageText:
'//
'// A system shutdown is in progress.
'//
%SEC_E_SHUTDOWN_IN_PROGRESS       = &H8009033F&

'//
'// MessageId: SEC_E_KDC_INVALID_REQUEST
'//
'// MessageText:
'//
'// An invalid request was sent to the KDC.
'//
%SEC_E_KDC_INVALID_REQUEST        = &H80090340&

'//
'// MessageId: SEC_E_KDC_UNABLE_TO_REFER
'//
'// MessageText:
'//
'// The KDC was unable to generate a referral for the service requested.
'//
%SEC_E_KDC_UNABLE_TO_REFER        = &H80090341&

'//
'// MessageId: SEC_E_KDC_UNKNOWN_ETYPE
'//
'// MessageText:
'//
'// The encryption type requested is not supported by the KDC.
'//
%SEC_E_KDC_UNKNOWN_ETYPE          = &H80090342&

'//
'// MessageId: SEC_E_UNSUPPORTED_PREAUTH
'//
'// MessageText:
'//
'// An unsupported preauthentication mechanism was presented to the kerberos package.
'//
%SEC_E_UNSUPPORTED_PREAUTH        = &H80090343&

'//
'// MessageId: SEC_E_DELEGATION_REQUIRED
'//
'// MessageText:
'//
'// The requested operation cannot be completed. The computer must be trusted for delegation and the current user account must be configured to allow delegation.
'//
%SEC_E_DELEGATION_REQUIRED        = &H80090345&

'//
'// MessageId: SEC_E_BAD_BINDINGS
'//
'// MessageText:
'//
'// Client's supplied SSPI channel bindings were incorrect.
'//
%SEC_E_BAD_BINDINGS               = &H80090346&

'//
'// MessageId: SEC_E_MULTIPLE_ACCOUNTS
'//
'// MessageText:
'//
'// The received certificate was mapped to multiple accounts.
'//
%SEC_E_MULTIPLE_ACCOUNTS          = &H80090347&

'//
'// MessageId: SEC_E_NO_KERB_KEY
'//
'// MessageText:
'//
'//  SEC_E_NO_KERB_KEY
'//
%SEC_E_NO_KERB_KEY                = &H80090348&

'//
'// MessageId: SEC_E_CERT_WRONG_USAGE
'//
'// MessageText:
'//
'// The certificate is not valid for the requested usage.
'//
%SEC_E_CERT_WRONG_USAGE           = &H80090349&

'//
'// MessageId: SEC_E_DOWNGRADE_DETECTED
'//
'// MessageText:
'//
'// The system detected a possible attempt to compromise security. Please ensure that you can contact the server that authenticated you.
'//
%SEC_E_DOWNGRADE_DETECTED         = &H80090350&

'//
'// MessageId: SEC_E_SMARTCARD_CERT_REVOKED
'//
'// MessageText:
'//
'// The smartcard certificate used for authentication has been revoked. Please contact your system administrator. There may be additional information in the event log.
'//
%SEC_E_SMARTCARD_CERT_REVOKED     = &H80090351&

'//
'// MessageId: SEC_E_ISSUING_CA_UNTRUSTED
'//
'// MessageText:
'//
'// An untrusted certificate authority was detected While processing the smartcard certificate used for authentication. Please contact your system administrator.
'//
%SEC_E_ISSUING_CA_UNTRUSTED       = &H80090352&

'//
'// MessageId: SEC_E_REVOCATION_OFFLINE_C
'//
'// MessageText:
'//
'// The revocation status of the smartcard certificate used for
'// authentication could not be determined. Please contact your system administrator.
'//
%SEC_E_REVOCATION_OFFLINE_C       = &H80090353&

'//
'// MessageId: SEC_E_PKINIT_CLIENT_FAILURE
'//
'// MessageText:
'//
'// The smartcard certificate used for authentication was not trusted. Please contact your system administrator.
'//
%SEC_E_PKINIT_CLIENT_FAILURE      = &H80090354&

'//
'// MessageId: SEC_E_SMARTCARD_CERT_EXPIRED
'//
'// MessageText:
'//
'// The smartcard certificate used for authentication has expired. Please contact your system administrator.
'//
%SEC_E_SMARTCARD_CERT_EXPIRED     = &H80090355&

'//
'// MessageId: SEC_E_NO_S4U_PROT_SUPPORT
'//
'// MessageText:
'//
'// The Kerberos subsystem encountered an error. A service for user protocol request was made against a domain controller which does not support service for user.
'//
%SEC_E_NO_S4U_PROT_SUPPORT        = &H80090356&

'//
'// MessageId: SEC_E_CROSSREALM_DELEGATION_FAILURE
'//
'// MessageText:
'//
'// An attempt was made by this server to make a Kerberos constrained delegation request for a target outside of the server's realm. This is not supported, and indicates a misconfiguration on this server's allowed to delegate to list.
'// Please contact your administrator.
'//
%SEC_E_CROSSREALM_DELEGATION_FAILURE = &H80090357&

'//
'// MessageId: SEC_E_REVOCATION_OFFLINE_KDC
'//
'// MessageText:
'//
'// The revocation status of the domain controller certificate used for smartcard authentication could not be determined. There is additional information in the system event log. Please contact your system administrator.
'//
%SEC_E_REVOCATION_OFFLINE_KDC     = &H80090358&

'//
'// MessageId: SEC_E_ISSUING_CA_UNTRUSTED_KDC
'//
'// MessageText:
'//
'// An untrusted certificate authority was detected while processing the domain controller certificate used for authentication. There is additional information in the system event log. Please contact your system administrator.
'//
%SEC_E_ISSUING_CA_UNTRUSTED_KDC   = &H80090359&

'//
'// MessageId: SEC_E_KDC_CERT_EXPIRED
'//
'// MessageText:
'//
'// The domain controller certificate used for smartcard logon has expired. Please contact your system administrator with the contents of your system event log.
'//
%SEC_E_KDC_CERT_EXPIRED           = &H8009035A&

'//
'// MessageId: SEC_E_KDC_CERT_REVOKED
'//
'// MessageText:
'//
'// The domain controller certificate used for smartcard logon has been revoked. Please contact your system administrator with the contents of your system event log.
'//
%SEC_E_KDC_CERT_REVOKED           = &H8009035B&

'//
'// MessageId: SEC_I_SIGNATURE_NEEDED
'//
'// MessageText:
'//
'// A signature operation must be performed before the user can authenticate.
'//
%SEC_I_SIGNATURE_NEEDED           = &H0009035C&

'//
'// MessageId: SEC_E_INVALID_PARAMETER
'//
'// MessageText:
'//
'// One or more of the parameters passed to the function was invalid.
'//
%SEC_E_INVALID_PARAMETER          = &H8009035D&

'//
'// MessageId: SEC_E_DELEGATION_POLICY
'//
'// MessageText:
'//
'// Client policy does not allow credential delegation to target server.
'//
%SEC_E_DELEGATION_POLICY          = &H8009035E&

'//
'// MessageId: SEC_E_POLICY_NLTM_ONLY
'//
'// MessageText:
'//
'// Client policy does not allow credential delegation to target server with NLTM only authentication.
'//
%SEC_E_POLICY_NLTM_ONLY           = &H8009035F&

'//
'// MessageId: SEC_I_NO_RENEGOTIATION
'//
'// MessageText:
'//
'// The recipient rejected the renegotiation request.
'//
%SEC_I_NO_RENEGOTIATION           = &H00090360&

'//
'// Provided for backwards compatibility
'//

%SEC_E_NO_SPM = %SEC_E_INTERNAL_ERROR
%SEC_E_NOT_SUPPORTED = %SEC_E_UNSUPPORTED_FUNCTION

'//
'// MessageId: CRYPT_E_MSG_ERROR
'//
'// MessageText:
'//
'// An error occurred while performing an operation on a cryptographic message.
'//
%CRYPT_E_MSG_ERROR                = &H80091001&

'//
'// MessageId: CRYPT_E_UNKNOWN_ALGO
'//
'// MessageText:
'//
'// Unknown cryptographic algorithm.
'//
%CRYPT_E_UNKNOWN_ALGO             = &H80091002&

'//
'// MessageId: CRYPT_E_OID_FORMAT
'//
'// MessageText:
'//
'// The object identifier is poorly formatted.
'//
%CRYPT_E_OID_FORMAT               = &H80091003&

'//
'// MessageId: CRYPT_E_INVALID_MSG_TYPE
'//
'// MessageText:
'//
'// Invalid cryptographic message type.
'//
%CRYPT_E_INVALID_MSG_TYPE         = &H80091004&

'//
'// MessageId: CRYPT_E_UNEXPECTED_ENCODING
'//
'// MessageText:
'//
'// Unexpected cryptographic message encoding.
'//
%CRYPT_E_UNEXPECTED_ENCODING      = &H80091005&

'//
'// MessageId: CRYPT_E_AUTH_ATTR_MISSING
'//
'// MessageText:
'//
'// The cryptographic message does not contain an expected authenticated attribute.
'//
%CRYPT_E_AUTH_ATTR_MISSING        = &H80091006&

'//
'// MessageId: CRYPT_E_HASH_VALUE
'//
'// MessageText:
'//
'// The hash value is not correct.
'//
%CRYPT_E_HASH_VALUE               = &H80091007&

'//
'// MessageId: CRYPT_E_INVALID_INDEX
'//
'// MessageText:
'//
'// The index value is not valid.
'//
%CRYPT_E_INVALID_INDEX            = &H80091008&

'//
'// MessageId: CRYPT_E_ALREADY_DECRYPTED
'//
'// MessageText:
'//
'// The content of the cryptographic message has already been decrypted.
'//
%CRYPT_E_ALREADY_DECRYPTED        = &H80091009&

'//
'// MessageId: CRYPT_E_NOT_DECRYPTED
'//
'// MessageText:
'//
'// The content of the cryptographic message has not been decrypted yet.
'//
%CRYPT_E_NOT_DECRYPTED            = &H8009100A&

'//
'// MessageId: CRYPT_E_RECIPIENT_NOT_FOUND
'//
'// MessageText:
'//
'// The enveloped-data message does not contain the specified recipient.
'//
%CRYPT_E_RECIPIENT_NOT_FOUND      = &H8009100B&

'//
'// MessageId: CRYPT_E_CONTROL_TYPE
'//
'// MessageText:
'//
'// Invalid control type.
'//
%CRYPT_E_CONTROL_TYPE             = &H8009100C&

'//
'// MessageId: CRYPT_E_ISSUER_SERIALNUMBER
'//
'// MessageText:
'//
'// Invalid issuer and/or serial number.
'//
%CRYPT_E_ISSUER_SERIALNUMBER      = &H8009100D&

'//
'// MessageId: CRYPT_E_SIGNER_NOT_FOUND
'//
'// MessageText:
'//
'// Cannot find the original signer.
'//
%CRYPT_E_SIGNER_NOT_FOUND         = &H8009100E&

'//
'// MessageId: CRYPT_E_ATTRIBUTES_MISSING
'//
'// MessageText:
'//
'// The cryptographic message does not contain all of the requested attributes.
'//
%CRYPT_E_ATTRIBUTES_MISSING       = &H8009100F&

'//
'// MessageId: CRYPT_E_STREAM_MSG_NOT_READY
'//
'// MessageText:
'//
'// The streamed cryptographic message is not ready to return data.
'//
%CRYPT_E_STREAM_MSG_NOT_READY     = &H80091010&

'//
'// MessageId: CRYPT_E_STREAM_INSUFFICIENT_DATA
'//
'// MessageText:
'//
'// The streamed cryptographic message requires more data to complete the decode operation.
'//
%CRYPT_E_STREAM_INSUFFICIENT_DATA = &H80091011&

'//
'// MessageId: CRYPT_I_NEW_PROTECTION_REQUIRED
'//
'// MessageText:
'//
'// The protected data needs to be re-protected.
'//
%CRYPT_I_NEW_PROTECTION_REQUIRED  = &H00091012&

'//
'// MessageId: CRYPT_E_BAD_LEN
'//
'// MessageText:
'//
'// The length specified for the output data was insufficient.
'//
%CRYPT_E_BAD_LEN                  = &H80092001&

'//
'// MessageId: CRYPT_E_BAD_ENCODE
'//
'// MessageText:
'//
'// An error occurred during encode or decode operation.
'//
%CRYPT_E_BAD_ENCODE               = &H80092002&

'//
'// MessageId: CRYPT_E_FILE_ERROR
'//
'// MessageText:
'//
'// An error occurred while reading or writing to a file.
'//
%CRYPT_E_FILE_ERROR               = &H80092003&

'//
'// MessageId: CRYPT_E_NOT_FOUND
'//
'// MessageText:
'//
'// Cannot find object or property.
'//
%CRYPT_E_NOT_FOUND                = &H80092004&

'//
'// MessageId: CRYPT_E_EXISTS
'//
'// MessageText:
'//
'// The object or property already exists.
'//
%CRYPT_E_EXISTS                   = &H80092005&

'//
'// MessageId: CRYPT_E_NO_PROVIDER
'//
'// MessageText:
'//
'// No provider was specified for the store or object.
'//
%CRYPT_E_NO_PROVIDER              = &H80092006&

'//
'// MessageId: CRYPT_E_SELF_SIGNED
'//
'// MessageText:
'//
'// The specified certificate is self signed.
'//
%CRYPT_E_SELF_SIGNED              = &H80092007&

'//
'// MessageId: CRYPT_E_DELETED_PREV
'//
'// MessageText:
'//
'// The previous certificate or CRL context was deleted.
'//
%CRYPT_E_DELETED_PREV             = &H80092008&

'//
'// MessageId: CRYPT_E_NO_MATCH
'//
'// MessageText:
'//
'// Cannot find the requested object.
'//
%CRYPT_E_NO_MATCH                 = &H80092009&

'//
'// MessageId: CRYPT_E_UNEXPECTED_MSG_TYPE
'//
'// MessageText:
'//
'// The certificate does not have a property that references a private key.
'//
%CRYPT_E_UNEXPECTED_MSG_TYPE      = &H8009200A&

'//
'// MessageId: CRYPT_E_NO_KEY_PROPERTY
'//
'// MessageText:
'//
'// Cannot find the certificate and private key for decryption.
'//
%CRYPT_E_NO_KEY_PROPERTY          = &H8009200B&

'//
'// MessageId: CRYPT_E_NO_DECRYPT_CERT
'//
'// MessageText:
'//
'// Cannot find the certificate and private key to use for decryption.
'//
%CRYPT_E_NO_DECRYPT_CERT          = &H8009200C&

'//
'// MessageId: CRYPT_E_BAD_MSG
'//
'// MessageText:
'//
'// Not a cryptographic message or the cryptographic message is not formatted correctly.
'//
%CRYPT_E_BAD_MSG                  = &H8009200D&

'//
'// MessageId: CRYPT_E_NO_SIGNER
'//
'// MessageText:
'//
'// The signed cryptographic message does not have a signer for the specified signer index.
'//
%CRYPT_E_NO_SIGNER                = &H8009200E&

'//
'// MessageId: CRYPT_E_PENDING_CLOSE
'//
'// MessageText:
'//
'// Final closure is pending until additional frees or closes.
'//
%CRYPT_E_PENDING_CLOSE            = &H8009200F&

'//
'// MessageId: CRYPT_E_REVOKED
'//
'// MessageText:
'//
'// The certificate is revoked.
'//
%CRYPT_E_REVOKED                  = &H80092010&

'//
'// MessageId: CRYPT_E_NO_REVOCATION_DLL
'//
'// MessageText:
'//
'// No Dll or exported function was found to verify revocation.
'//
%CRYPT_E_NO_REVOCATION_DLL        = &H80092011&

'//
'// MessageId: CRYPT_E_NO_REVOCATION_CHECK
'//
'// MessageText:
'//
'// The revocation function was unable to check revocation for the certificate.
'//
%CRYPT_E_NO_REVOCATION_CHECK      = &H80092012&

'//
'// MessageId: CRYPT_E_REVOCATION_OFFLINE
'//
'// MessageText:
'//
'// The revocation function was unable to check revocation because the revocation server was offline.
'//
%CRYPT_E_REVOCATION_OFFLINE       = &H80092013&

'//
'// MessageId: CRYPT_E_NOT_IN_REVOCATION_DATABASE
'//
'// MessageText:
'//
'// The certificate is not in the revocation server's database.
'//
%CRYPT_E_NOT_IN_REVOCATION_DATABASE = &H80092014&

'//
'// MessageId: CRYPT_E_INVALID_NUMERIC_STRING
'//
'// MessageText:
'//
'// The string contains a non-numeric character.
'//
%CRYPT_E_INVALID_NUMERIC_STRING   = &H80092020&

'//
'// MessageId: CRYPT_E_INVALID_PRINTABLE_STRING
'//
'// MessageText:
'//
'// The string contains a non-printable character.
'//
%CRYPT_E_INVALID_PRINTABLE_STRING = &H80092021&

'//
'// MessageId: CRYPT_E_INVALID_IA5_STRING
'//
'// MessageText:
'//
'// The string contains a character not in the 7 bit ASCII character set.
'//
%CRYPT_E_INVALID_IA5_STRING       = &H80092022&

'//
'// MessageId: CRYPT_E_INVALID_X500_STRING
'//
'// MessageText:
'//
'// The string contains an invalid X500 name attribute key, oid, value or delimiter.
'//
%CRYPT_E_INVALID_X500_STRING      = &H80092023&

'//
'// MessageId: CRYPT_E_NOT_CHAR_STRING
'//
'// MessageText:
'//
'// The dwValueType for the CERT_NAME_VALUE is not one of the character strings. Most likely it is either a CERT_RDN_ENCODED_BLOB or CERT_TDN_OCTED_STRING.
'//
%CRYPT_E_NOT_CHAR_STRING          = &H80092024&

'//
'// MessageId: CRYPT_E_FILERESIZED
'//
'// MessageText:
'//
'// The Put operation cannot continue. The file needs to be resized. However, there is already a signature present. A complete signing operation must be done.
'//
%CRYPT_E_FILERESIZED              = &H80092025&

'//
'// MessageId: CRYPT_E_SECURITY_SETTINGS
'//
'// MessageText:
'//
'// The cryptographic operation failed due to a local security option setting.
'//
%CRYPT_E_SECURITY_SETTINGS        = &H80092026&

'//
'// MessageId: CRYPT_E_NO_VERIFY_USAGE_DLL
'//
'// MessageText:
'//
'// No DLL or exported function was found to verify subject usage.
'//
%CRYPT_E_NO_VERIFY_USAGE_DLL      = &H80092027&

'//
'// MessageId: CRYPT_E_NO_VERIFY_USAGE_CHECK
'//
'// MessageText:
'//
'// The called function was unable to do a usage check on the subject.
'//
%CRYPT_E_NO_VERIFY_USAGE_CHECK    = &H80092028&

'//
'// MessageId: CRYPT_E_VERIFY_USAGE_OFFLINE
'//
'// MessageText:
'//
'// Since the server was offline, the called function was unable to complete the usage check.
'//
%CRYPT_E_VERIFY_USAGE_OFFLINE     = &H80092029&

'//
'// MessageId: CRYPT_E_NOT_IN_CTL
'//
'// MessageText:
'//
'// The subject was not found in a Certificate Trust List (CT&.
'//
%CRYPT_E_NOT_IN_CTL               = &H8009202A&

'//
'// MessageId: CRYPT_E_NO_TRUSTED_SIGNER
'//
'// MessageText:
'//
'// None of the signers of the cryptographic message or certificate trust list is trusted.
'//
%CRYPT_E_NO_TRUSTED_SIGNER        = &H8009202B&

'//
'// MessageId: CRYPT_E_MISSING_PUBKEY_PARA
'//
'// MessageText:
'//
'// The public key's algorithm parameters are missing.
'//
%CRYPT_E_MISSING_PUBKEY_PARA      = &H8009202C&

'//
'// MessageId: CRYPT_E_OSS_ERROR
'//
'// MessageText:
'//
'// OSS Certificate encode/decode error code base
'//
'// See asn1code.h for a definition of the OSS runtime errors. The OSS
'// error values are offset by CRYPT_E_OSS_ERROR.
'//
%CRYPT_E_OSS_ERROR                = &H80093000&

'//
'// MessageId: OSS_MORE_BUF
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Output Buffer is too small.
'//
%OSS_MORE_BUF                     = &H80093001&

'//
'// MessageId: OSS_NEGATIVE_UINTEGER
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Signed integer is encoded as a unsigned integer.
'//
%OSS_NEGATIVE_UINTEGER            = &H80093002&

'//
'// MessageId: OSS_PDU_RANGE
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Unknown ASN.1 data type.
'//
%OSS_PDU_RANGE                    = &H80093003&

'//
'// MessageId: OSS_MORE_INPUT
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Output buffer is too small, the decoded data has been truncated.
'//
%OSS_MORE_INPUT                   = &H80093004&

'//
'// MessageId: OSS_DATA_ERROR
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_DATA_ERROR                   = &H80093005&

'//
'// MessageId: OSS_BAD_ARG
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid argument.
'//
%OSS_BAD_ARG                      = &H80093006&

'//
'// MessageId: OSS_BAD_VERSION
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Encode/Decode version mismatch.
'//
%OSS_BAD_VERSION                  = &H80093007&

'//
'// MessageId: OSS_OUT_MEMORY
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Out of memory.
'//
%OSS_OUT_MEMORY                   = &H80093008&

'//
'// MessageId: OSS_PDU_MISMATCH
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Encode/Decode Error.
'//
%OSS_PDU_MISMATCH                 = &H80093009&

'//
'// MessageId: OSS_LIMITED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Internal Error.
'//
%OSS_LIMITED                      = &H8009300A&

'//
'// MessageId: OSS_BAD_PTR
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_BAD_PTR                      = &H8009300B&

'//
'// MessageId: OSS_BAD_TIME
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_BAD_TIME                     = &H8009300C&

'//
'// MessageId: OSS_INDEFINITE_NOT_SUPPORTED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Unsupported BER indefinite-length encoding.
'//
%OSS_INDEFINITE_NOT_SUPPORTED     = &H8009300D&

'//
'// MessageId: OSS_MEM_ERROR
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Access violation.
'//
%OSS_MEM_ERROR                    = &H8009300E&

'//
'// MessageId: OSS_BAD_TABLE
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_BAD_TABLE                    = &H8009300F&

'//
'// MessageId: OSS_TOO_LONG
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_TOO_LONG                     = &H80093010&

'//
'// MessageId: OSS_CONSTRAINT_VIOLATED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_CONSTRAINT_VIOLATED          = &H80093011&

'//
'// MessageId: OSS_FATAL_ERROR
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Internal Error.
'//
%OSS_FATAL_ERROR                  = &H80093012&

'//
'// MessageId: OSS_ACCESS_SERIALIZATION_ERROR
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Multi-threading conflict.
'//
%OSS_ACCESS_SERIALIZATION_ERROR   = &H80093013&

'//
'// MessageId: OSS_NULL_TBL
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_NULL_TBL                     = &H80093014&

'//
'// MessageId: OSS_NULL_FCN
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_NULL_FCN                     = &H80093015&

'//
'// MessageId: OSS_BAD_ENCRULES
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_BAD_ENCRULES                 = &H80093016&

'//
'// MessageId: OSS_UNAVAIL_ENCRULES
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Encode/Decode function not implemented.
'//
%OSS_UNAVAIL_ENCRULES             = &H80093017&

'//
'// MessageId: OSS_CANT_OPEN_TRACE_WINDOW
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Trace file error.
'//
%OSS_CANT_OPEN_TRACE_WINDOW       = &H80093018&

'//
'// MessageId: OSS_UNIMPLEMENTED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Function not implemented.
'//
%OSS_UNIMPLEMENTED                = &H80093019&

'//
'// MessageId: OSS_OID_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_OID_DLL_NOT_LINKED           = &H8009301A&

'//
'// MessageId: OSS_CANT_OPEN_TRACE_FILE
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Trace file error.
'//
%OSS_CANT_OPEN_TRACE_FILE         = &H8009301B&

'//
'// MessageId: OSS_TRACE_FILE_ALREADY_OPEN
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Trace file error.
'//
%OSS_TRACE_FILE_ALREADY_OPEN      = &H8009301C&

'//
'// MessageId: OSS_TABLE_MISMATCH
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_TABLE_MISMATCH               = &H8009301D&

'//
'// MessageId: OSS_TYPE_NOT_SUPPORTED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Invalid data.
'//
%OSS_TYPE_NOT_SUPPORTED           = &H8009301E&

'//
'// MessageId: OSS_REAL_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_REAL_DLL_NOT_LINKED          = &H8009301F&

'//
'// MessageId: OSS_REAL_CODE_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_REAL_CODE_NOT_LINKED         = &H80093020&

'//
'// MessageId: OSS_OUT_OF_RANGE
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_OUT_OF_RANGE                 = &H80093021&

'//
'// MessageId: OSS_COPIER_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_COPIER_DLL_NOT_LINKED        = &H80093022&

'//
'// MessageId: OSS_CONSTRAINT_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_CONSTRAINT_DLL_NOT_LINKED    = &H80093023&

'//
'// MessageId: OSS_COMPARATOR_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_COMPARATOR_DLL_NOT_LINKED    = &H80093024&

'//
'// MessageId: OSS_COMPARATOR_CODE_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_COMPARATOR_CODE_NOT_LINKED   = &H80093025&

'//
'// MessageId: OSS_MEM_MGR_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_MEM_MGR_DLL_NOT_LINKED       = &H80093026&

'//
'// MessageId: OSS_PDV_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_PDV_DLL_NOT_LINKED           = &H80093027&

'//
'// MessageId: OSS_PDV_CODE_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_PDV_CODE_NOT_LINKED          = &H80093028&

'//
'// MessageId: OSS_API_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_API_DLL_NOT_LINKED           = &H80093029&

'//
'// MessageId: OSS_BERDER_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_BERDER_DLL_NOT_LINKED        = &H8009302A&

'//
'// MessageId: OSS_PER_DLL_NOT_LINKED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_PER_DLL_NOT_LINKED           = &H8009302B&

'//
'// MessageId: OSS_OPEN_TYPE_ERROR
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Program link error.
'//
%OSS_OPEN_TYPE_ERROR              = &H8009302C&

'//
'// MessageId: OSS_MUTEX_NOT_CREATED
'//
'// MessageText:
'//
'// OSS ASN.1 Error: System resource error.
'//
%OSS_MUTEX_NOT_CREATED            = &H8009302D&

'//
'// MessageId: OSS_CANT_CLOSE_TRACE_FILE
'//
'// MessageText:
'//
'// OSS ASN.1 Error: Trace file error.
'//
%OSS_CANT_CLOSE_TRACE_FILE        = &H8009302E&

'//
'// MessageId: CRYPT_E_ASN1_ERROR
'//
'// MessageText:
'//
'// ASN1 Certificate encode/decode error code base.
'//
'// The ASN1 error values are offset by CRYPT_E_ASN1_ERROR.
'//
%CRYPT_E_ASN1_ERROR               = &H80093100&

'//
'// MessageId: CRYPT_E_ASN1_INTERNAL
'//
'// MessageText:
'//
'// ASN1 internal encode or decode error.
'//
%CRYPT_E_ASN1_INTERNAL            = &H80093101&

'//
'// MessageId: CRYPT_E_ASN1_EOD
'//
'// MessageText:
'//
'// ASN1 unexpected end of data.
'//
%CRYPT_E_ASN1_EOD                 = &H80093102&

'//
'// MessageId: CRYPT_E_ASN1_CORRUPT
'//
'// MessageText:
'//
'// ASN1 corrupted data.
'//
%CRYPT_E_ASN1_CORRUPT             = &H80093103&

'//
'// MessageId: CRYPT_E_ASN1_LARGE
'//
'// MessageText:
'//
'// ASN1 value too large.
'//
%CRYPT_E_ASN1_LARGE               = &H80093104&

'//
'// MessageId: CRYPT_E_ASN1_CONSTRAINT
'//
'// MessageText:
'//
'// ASN1 constraint violated.
'//
%CRYPT_E_ASN1_CONSTRAINT          = &H80093105&

'//
'// MessageId: CRYPT_E_ASN1_MEMORY
'//
'// MessageText:
'//
'// ASN1 out of memory.
'//
%CRYPT_E_ASN1_MEMORY              = &H80093106&

'//
'// MessageId: CRYPT_E_ASN1_OVERFLOW
'//
'// MessageText:
'//
'// ASN1 buffer overflow.
'//
%CRYPT_E_ASN1_OVERFLOW            = &H80093107&

'//
'// MessageId: CRYPT_E_ASN1_BADPDU
'//
'// MessageText:
'//
'// ASN1 function not supported for this PDU.
'//
%CRYPT_E_ASN1_BADPDU              = &H80093108&

'//
'// MessageId: CRYPT_E_ASN1_BADARGS
'//
'// MessageText:
'//
'// ASN1 bad arguments to function call.
'//
%CRYPT_E_ASN1_BADARGS             = &H80093109&

'//
'// MessageId: CRYPT_E_ASN1_BADREAL
'//
'// MessageText:
'//
'// ASN1 bad real value.
'//
%CRYPT_E_ASN1_BADREAL             = &H8009310A&

'//
'// MessageId: CRYPT_E_ASN1_BADTAG
'//
'// MessageText:
'//
'// ASN1 bad tag value met.
'//
%CRYPT_E_ASN1_BADTAG              = &H8009310B&

'//
'// MessageId: CRYPT_E_ASN1_CHOICE
'//
'// MessageText:
'//
'// ASN1 bad choice value.
'//
%CRYPT_E_ASN1_CHOICE              = &H8009310C&

'//
'// MessageId: CRYPT_E_ASN1_RULE
'//
'// MessageText:
'//
'// ASN1 bad encoding rule.
'//
%CRYPT_E_ASN1_RULE                = &H8009310D&

'//
'// MessageId: CRYPT_E_ASN1_UTF8
'//
'// MessageText:
'//
'// ASN1 bad unicode (UTF8).
'//
%CRYPT_E_ASN1_UTF8                = &H8009310E&

'//
'// MessageId: CRYPT_E_ASN1_PDU_TYPE
'//
'// MessageText:
'//
'// ASN1 bad PDU type.
'//
%CRYPT_E_ASN1_PDU_TYPE            = &H80093133&

'//
'// MessageId: CRYPT_E_ASN1_NYI
'//
'// MessageText:
'//
'// ASN1 not yet implemented.
'//
%CRYPT_E_ASN1_NYI                 = &H80093134&

'//
'// MessageId: CRYPT_E_ASN1_EXTENDED
'//
'// MessageText:
'//
'// ASN1 skipped unknown extension(s).
'//
%CRYPT_E_ASN1_EXTENDED            = &H80093201&

'//
'// MessageId: CRYPT_E_ASN1_NOEOD
'//
'// MessageText:
'//
'// ASN1 end of data expected
'//
%CRYPT_E_ASN1_NOEOD               = &H80093202&

'//
'// MessageId: CERTSRV_E_BAD_REQUESTSUBJECT
'//
'// MessageText:
'//
'// The request subject name is invalid or too long.
'//
%CERTSRV_E_BAD_REQUESTSUBJECT     = &H80094001&

'//
'// MessageId: CERTSRV_E_NO_REQUEST
'//
'// MessageText:
'//
'// The request does not exist.
'//
%CERTSRV_E_NO_REQUEST             = &H80094002&

'//
'// MessageId: CERTSRV_E_BAD_REQUESTSTATUS
'//
'// MessageText:
'//
'// The request's current status does not allow this operation.
'//
%CERTSRV_E_BAD_REQUESTSTATUS      = &H80094003&

'//
'// MessageId: CERTSRV_E_PROPERTY_EMPTY
'//
'// MessageText:
'//
'// The requested property value is empty.
'//
%CERTSRV_E_PROPERTY_EMPTY         = &H80094004&

'//
'// MessageId: CERTSRV_E_INVALID_CA_CERTIFICATE
'//
'// MessageText:
'//
'// The certification authority's certificate contains invalid data.
'//
%CERTSRV_E_INVALID_CA_CERTIFICATE = &H80094005&

'//
'// MessageId: CERTSRV_E_SERVER_SUSPENDED
'//
'// MessageText:
'//
'// Certificate service has been suspended for a database restore operation.
'//
%CERTSRV_E_SERVER_SUSPENDED       = &H80094006&

'//
'// MessageId: CERTSRV_E_ENCODING_LENGTH
'//
'// MessageText:
'//
'// The certificate contains an encoded length that is potentially incompatible with older enrollment software.
'//
%CERTSRV_E_ENCODING_LENGTH        = &H80094007&

'//
'// MessageId: CERTSRV_E_ROLECONFLICT
'//
'// MessageText:
'//
'// The operation is denied. The user has multiple roles assigned and the certification authority is configured to enforce role separation.
'//
%CERTSRV_E_ROLECONFLICT           = &H80094008&

'//
'// MessageId: CERTSRV_E_RESTRICTEDOFFICER
'//
'// MessageText:
'//
'// The operation is denied. It can only be performed by a certificate manager that is allowed to manage certificates for the current requester.
'//
%CERTSRV_E_RESTRICTEDOFFICER      = &H80094009&

'//
'// MessageId: CERTSRV_E_KEY_ARCHIVAL_NOT_CONFIGURED
'//
'// MessageText:
'//
'// Cannot archive private key. The certification authority is not configured for key archival.
'//
%CERTSRV_E_KEY_ARCHIVAL_NOT_CONFIGURED = &H8009400A&

'//
'// MessageId: CERTSRV_E_NO_VALID_KRA
'//
'// MessageText:
'//
'// Cannot archive private key. The certification authority could not verify one or more key recovery certificates.
'//
%CERTSRV_E_NO_VALID_KRA           = &H8009400B&

'//
'// MessageId: CERTSRV_E_BAD_REQUEST_KEY_ARCHIVAL
'//
'// MessageText:
'//
'// The request is incorrectly formatted. The encrypted private key must be in an unauthenticated attribute in an outermost signature.
'//
%CERTSRV_E_BAD_REQUEST_KEY_ARCHIVAL = &H8009400C&

'//
'// MessageId: CERTSRV_E_NO_CAADMIN_DEFINED
'//
'// MessageText:
'//
'// At least one security principal must have the permission to manage this CA.
'//
%CERTSRV_E_NO_CAADMIN_DEFINED     = &H8009400D&

'//
'// MessageId: CERTSRV_E_BAD_RENEWAL_CERT_ATTRIBUTE
'//
'// MessageText:
'//
'// The request contains an invalid renewal certificate attribute.
'//
%CERTSRV_E_BAD_RENEWAL_CERT_ATTRIBUTE = &H8009400E&

'//
'// MessageId: CERTSRV_E_NO_DB_SESSIONS
'//
'// MessageText:
'//
'// An attempt was made to open a Certification Authority database session, but there are already too many active sessions. The server may need to be configured to allow additional sessions.
'//
%CERTSRV_E_NO_DB_SESSIONS         = &H8009400F&

'//
'// MessageId: CERTSRV_E_ALIGNMENT_FAULT
'//
'// MessageText:
'//
'// A memory reference caused a data alignment fault.
'//
%CERTSRV_E_ALIGNMENT_FAULT        = &H80094010&

'//
'// MessageId: CERTSRV_E_ENROLL_DENIED
'//
'// MessageText:
'//
'// The permissions on this certification authority do not allow the current user to enroll for certificates.
'//
%CERTSRV_E_ENROLL_DENIED          = &H80094011&

'//
'// MessageId: CERTSRV_E_TEMPLATE_DENIED
'//
'// MessageText:
'//
'// The permissions on the certificate template do not allow the current user to enroll for this type of certificate.
'//
%CERTSRV_E_TEMPLATE_DENIED        = &H80094012&

'//
'// MessageId: CERTSRV_E_DOWNLEVEL_DC_SSL_OR_UPGRADE
'//
'// MessageText:
'//
'// The contacted domain controller cannot support signed LDAP traffic. Update the domain controller or configure Certificate Services to use SSL for Active Directory access.
'//
%CERTSRV_E_DOWNLEVEL_DC_SSL_OR_UPGRADE = &H80094013&

'//
'// MessageId: CERTSRV_E_UNSUPPORTED_CERT_TYPE
'//
'// MessageText:
'//
'// The requested certificate template is not supported by this CA.
'//
%CERTSRV_E_UNSUPPORTED_CERT_TYPE  = &H80094800&

'//
'// MessageId: CERTSRV_E_NO_CERT_TYPE
'//
'// MessageText:
'//
'// The request contains no certificate template information.
'//
%CERTSRV_E_NO_CERT_TYPE           = &H80094801&

'//
'// MessageId: CERTSRV_E_TEMPLATE_CONFLICT
'//
'// MessageText:
'//
'// The request contains conflicting template information.
'//
%CERTSRV_E_TEMPLATE_CONFLICT      = &H80094802&

'//
'// MessageId: CERTSRV_E_SUBJECT_ALT_NAME_REQUIRED
'//
'// MessageText:
'//
'// The request is missing a required Subject Alternate name extension.
'//
%CERTSRV_E_SUBJECT_ALT_NAME_REQUIRED = &H80094803&

'//
'// MessageId: CERTSRV_E_ARCHIVED_KEY_REQUIRED
'//
'// MessageText:
'//
'// The request is missing a required private key for archival by the server.
'//
%CERTSRV_E_ARCHIVED_KEY_REQUIRED  = &H80094804&

'//
'// MessageId: CERTSRV_E_SMIME_REQUIRED
'//
'// MessageText:
'//
'// The request is missing a required SMIME capabilities extension.
'//
%CERTSRV_E_SMIME_REQUIRED         = &H80094805&

'//
'// MessageId: CERTSRV_E_BAD_RENEWAL_SUBJECT
'//
'// MessageText:
'//
'// The request was made on behalf of a subject other than the caller. The certificate template must be configured to require at least one signature to authorize the request.
'//
%CERTSRV_E_BAD_RENEWAL_SUBJECT    = &H80094806&

'//
'// MessageId: CERTSRV_E_BAD_TEMPLATE_VERSION
'//
'// MessageText:
'//
'// The request template version is newer than the supported template version.
'//
%CERTSRV_E_BAD_TEMPLATE_VERSION   = &H80094807&

'//
'// MessageId: CERTSRV_E_TEMPLATE_POLICY_REQUIRED
'//
'// MessageText:
'//
'// The template is missing a required signature policy attribute.
'//
%CERTSRV_E_TEMPLATE_POLICY_REQUIRED = &H80094808&

'//
'// MessageId: CERTSRV_E_SIGNATURE_POLICY_REQUIRED
'//
'// MessageText:
'//
'// The request is missing required signature policy information.
'//
%CERTSRV_E_SIGNATURE_POLICY_REQUIRED = &H80094809&

'//
'// MessageId: CERTSRV_E_SIGNATURE_COUNT
'//
'// MessageText:
'//
'// The request is missing one or more required signatures.
'//
%CERTSRV_E_SIGNATURE_COUNT        = &H8009480A&

'//
'// MessageId: CERTSRV_E_SIGNATURE_REJECTED
'//
'// MessageText:
'//
'// One or more signatures did not include the required application or issuance policies. The request is missing one or more required valid signatures.
'//
%CERTSRV_E_SIGNATURE_REJECTED     = &H8009480B&

'//
'// MessageId: CERTSRV_E_ISSUANCE_POLICY_REQUIRED
'//
'// MessageText:
'//
'// The request is missing one or more required signature issuance policies.
'//
%CERTSRV_E_ISSUANCE_POLICY_REQUIRED = &H8009480C&

'//
'// MessageId: CERTSRV_E_SUBJECT_UPN_REQUIRED
'//
'// MessageText:
'//
'// The UPN is unavailable and cannot be added to the Subject Alternate name.
'//
%CERTSRV_E_SUBJECT_UPN_REQUIRED   = &H8009480D&

'//
'// MessageId: CERTSRV_E_SUBJECT_DIRECTORY_GUID_REQUIRED
'//
'// MessageText:
'//
'// The Active Directory GUID is unavailable and cannot be added to the Subject Alternate name.
'//
%CERTSRV_E_SUBJECT_DIRECTORY_GUID_REQUIRED = &H8009480E&

'//
'// MessageId: CERTSRV_E_SUBJECT_DNS_REQUIRED
'//
'// MessageText:
'//
'// The DNS name is unavailable and cannot be added to the Subject Alternate name.
'//
%CERTSRV_E_SUBJECT_DNS_REQUIRED   = &H8009480F&

'//
'// MessageId: CERTSRV_E_ARCHIVED_KEY_UNEXPECTED
'//
'// MessageText:
'//
'// The request includes a private key for archival by the server, but key archival is not enabled for the specified certificate template.
'//
%CERTSRV_E_ARCHIVED_KEY_UNEXPECTED = &H80094810&

'//
'// MessageId: CERTSRV_E_KEY_LENGTH
'//
'// MessageText:
'//
'// The public key does not meet the minimum size required by the specified certificate template.
'//
%CERTSRV_E_KEY_LENGTH             = &H80094811&

'//
'// MessageId: CERTSRV_E_SUBJECT_EMAIL_REQUIRED
'//
'// MessageText:
'//
'// The EMail name is unavailable and cannot be added to the Subject or Subject Alternate name.
'//
%CERTSRV_E_SUBJECT_EMAIL_REQUIRED = &H80094812&

'//
'// MessageId: CERTSRV_E_UNKNOWN_CERT_TYPE
'//
'// MessageText:
'//
'// One or more certificate templates to be enabled on this certification authority could not be found.
'//
%CERTSRV_E_UNKNOWN_CERT_TYPE      = &H80094813&

'//
'// MessageId: CERTSRV_E_CERT_TYPE_OVERLAP
'//
'// MessageText:
'//
'// The certificate template renewal period is longer than the certificate validity period. The template should be reconfigured or the CA certificate renewed.
'//
%CERTSRV_E_CERT_TYPE_OVERLAP      = &H80094814&

'//
'// MessageId: CERTSRV_E_TOO_MANY_SIGNATURES
'//
'// MessageText:
'//
'// The certificate template requires too many RA signatures. Only one RA signature is allowed.
'//
%CERTSRV_E_TOO_MANY_SIGNATURES    = &H80094815&

'//
'// The range 0x5000-0x51ff is reserved for XENROLL errors.
'//
'//
'// MessageId: XENROLL_E_KEY_NOT_EXPORTABLE
'//
'// MessageText:
'//
'// The key is not exportable.
'//
%XENROLL_E_KEY_NOT_EXPORTABLE     = &H80095000&

'//
'// MessageId: XENROLL_E_CANNOT_ADD_ROOT_CERT
'//
'// MessageText:
'//
'// You cannot add the root CA certificate into your local store.
'//
%XENROLL_E_CANNOT_ADD_ROOT_CERT   = &H80095001&

'//
'// MessageId: XENROLL_E_RESPONSE_KA_HASH_NOT_FOUND
'//
'// MessageText:
'//
'// The key archival hash attribute was not found in the response.
'//
%XENROLL_E_RESPONSE_KA_HASH_NOT_FOUND = &H80095002&

'//
'// MessageId: XENROLL_E_RESPONSE_UNEXPECTED_KA_HASH
'//
'// MessageText:
'//
'// An unexpected key archival hash attribute was found in the response.
'//
%XENROLL_E_RESPONSE_UNEXPECTED_KA_HASH = &H80095003&

'//
'// MessageId: XENROLL_E_RESPONSE_KA_HASH_MISMATCH
'//
'// MessageText:
'//
'// There is a key archival hash mismatch between the request and the response.
'//
%XENROLL_E_RESPONSE_KA_HASH_MISMATCH = &H80095004&

'//
'// MessageId: XENROLL_E_KEYSPEC_SMIME_MISMATCH
'//
'// MessageText:
'//
'// Signing certificate cannot include SMIME extension.
'//
%XENROLL_E_KEYSPEC_SMIME_MISMATCH = &H80095005&

'//
'// MessageId: TRUST_E_SYSTEM_ERROR
'//
'// MessageText:
'//
'// A system-level error occurred while verifying trust.
'//
%TRUST_E_SYSTEM_ERROR             = &H80096001&

'//
'// MessageId: TRUST_E_NO_SIGNER_CERT
'//
'// MessageText:
'//
'// The certificate for the signer of the message is invalid or not found.
'//
%TRUST_E_NO_SIGNER_CERT           = &H80096002&

'//
'// MessageId: TRUST_E_COUNTER_SIGNER
'//
'// MessageText:
'//
'// One of the counter signatures was invalid.
'//
%TRUST_E_COUNTER_SIGNER           = &H80096003&

'//
'// MessageId: TRUST_E_CERT_SIGNATURE
'//
'// MessageText:
'//
'// The signature of the certificate cannot be verified.
'//
%TRUST_E_CERT_SIGNATURE           = &H80096004&

'//
'// MessageId: TRUST_E_TIME_STAMP
'//
'// MessageText:
'//
'// The timestamp signature and/or certificate could not be verified or is malformed.
'//
%TRUST_E_TIME_STAMP               = &H80096005&

'//
'// MessageId: TRUST_E_BAD_DIGEST
'//
'// MessageText:
'//
'// The digital signature of the object did not verify.
'//
%TRUST_E_BAD_DIGEST               = &H80096010&

'//
'// MessageId: TRUST_E_BASIC_CONSTRAINTS
'//
'// MessageText:
'//
'// A certificate's basic constraint extension has not been observed.
'//
%TRUST_E_BASIC_CONSTRAINTS        = &H80096019&

'//
'// MessageId: TRUST_E_FINANCIAL_CRITERIA
'//
'// MessageText:
'//
'// The certificate does not meet or contain the Authenticode(tm) financial extensions.
'//
%TRUST_E_FINANCIAL_CRITERIA       = &H8009601E&

'//
'//  Error codes for mssipotf.dll
'//  Most of the error codes can only occur when an error occurs
'//    during font file signing
'//
'//
'//
'// MessageId: MSSIPOTF_E_OUTOFMEMRANGE
'//
'// MessageText:
'//
'// Tried to reference a part of the file outside the proper range.
'//
%MSSIPOTF_E_OUTOFMEMRANGE         = &H80097001&

'//
'// MessageId: MSSIPOTF_E_CANTGETOBJECT
'//
'// MessageText:
'//
'// Could not retrieve an object from the file.
'//
%MSSIPOTF_E_CANTGETOBJECT         = &H80097002&

'//
'// MessageId: MSSIPOTF_E_NOHEADTABLE
'//
'// MessageText:
'//
'// Could not find the head table in the file.
'//
%MSSIPOTF_E_NOHEADTABLE           = &H80097003&

'//
'// MessageId: MSSIPOTF_E_BAD_MAGICNUMBER
'//
'// MessageText:
'//
'// The magic number in the head table is incorrect.
'//
%MSSIPOTF_E_BAD_MAGICNUMBER       = &H80097004&

'//
'// MessageId: MSSIPOTF_E_BAD_OFFSET_TABLE
'//
'// MessageText:
'//
'// The offset table has incorrect values.
'//
%MSSIPOTF_E_BAD_OFFSET_TABLE      = &H80097005&

'//
'// MessageId: MSSIPOTF_E_TABLE_TAGORDER
'//
'// MessageText:
'//
'// Duplicate table tags or tags out of alphabetical order.
'//
%MSSIPOTF_E_TABLE_TAGORDER        = &H80097006&

'//
'// MessageId: MSSIPOTF_E_TABLE_LONGWORD
'//
'// MessageText:
'//
'// A table does not start on a long word boundary.
'//
%MSSIPOTF_E_TABLE_LONGWORD        = &H80097007&

'//
'// MessageId: MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT
'//
'// MessageText:
'//
'// First table does not appear after header information.
'//
%MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT = &H80097008&

'//
'// MessageId: MSSIPOTF_E_TABLES_OVERLAP
'//
'// MessageText:
'//
'// Two or more tables overlap.
'//
%MSSIPOTF_E_TABLES_OVERLAP        = &H80097009&

'//
'// MessageId: MSSIPOTF_E_TABLE_PADBYTES
'//
'// MessageText:
'//
'// Too many pad bytes between tables or pad bytes are not 0.
'//
%MSSIPOTF_E_TABLE_PADBYTES        = &H8009700A&

'//
'// MessageId: MSSIPOTF_E_FILETOOSMALL
'//
'// MessageText:
'//
'// File is too small to contain the last table.
'//
%MSSIPOTF_E_FILETOOSMALL          = &H8009700B&

'//
'// MessageId: MSSIPOTF_E_TABLE_CHECKSUM
'//
'// MessageText:
'//
'// A table checksum is incorrect.
'//
%MSSIPOTF_E_TABLE_CHECKSUM        = &H8009700C&

'//
'// MessageId: MSSIPOTF_E_FILE_CHECKSUM
'//
'// MessageText:
'//
'// The file checksum is incorrect.
'//
%MSSIPOTF_E_FILE_CHECKSUM         = &H8009700D&

'//
'// MessageId: MSSIPOTF_E_FAILED_POLICY
'//
'// MessageText:
'//
'// The signature does not have the correct attributes for the policy.
'//
%MSSIPOTF_E_FAILED_POLICY         = &H80097010&

'//
'// MessageId: MSSIPOTF_E_FAILED_HINTS_CHECK
'//
'// MessageText:
'//
'// The file did not pass the hints check.
'//
%MSSIPOTF_E_FAILED_HINTS_CHECK    = &H80097011&

'//
'// MessageId: MSSIPOTF_E_NOT_OPENTYPE
'//
'// MessageText:
'//
'// The file is not an OpenType file.
'//
%MSSIPOTF_E_NOT_OPENTYPE          = &H80097012&

'//
'// MessageId: MSSIPOTF_E_FILE
'//
'// MessageText:
'//
'// Failed on a file operation (open, map, read, write).
'//
%MSSIPOTF_E_FILE                  = &H80097013&

'//
'// MessageId: MSSIPOTF_E_CRYPT
'//
'// MessageText:
'//
'// A call to a CryptoAPI function failed.
'//
%MSSIPOTF_E_CRYPT                 = &H80097014&

'//
'// MessageId: MSSIPOTF_E_BADVERSION
'//
'// MessageText:
'//
'// There is a bad version number in the file.
'//
%MSSIPOTF_E_BADVERSION            = &H80097015&

'//
'// MessageId: MSSIPOTF_E_DSIG_STRUCTURE
'//
'// MessageText:
'//
'// The structure of the DSIG table is incorrect.
'//
%MSSIPOTF_E_DSIG_STRUCTURE        = &H80097016&

'//
'// MessageId: MSSIPOTF_E_PCONST_CHECK
'//
'// MessageText:
'//
'// A check failed in a partially constant table.
'//
%MSSIPOTF_E_PCONST_CHECK          = &H80097017&

'//
'// MessageId: MSSIPOTF_E_STRUCTURE
'//
'// MessageText:
'//
'// Some kind of structural error.
'//
%MSSIPOTF_E_STRUCTURE             = &H80097018&

'//
'// MessageId: ERROR_CRED_REQUIRES_CONFIRMATION
'//
'// MessageText:
'//
'// The requested credential requires confirmation.
'//
%ERROR_CRED_REQUIRES_CONFIRMATION = &H80097019&

%NTE_OP_OK =  0

'//
'// Note that additional FACILITY_SSPI errors are in issperr.h
'//
'// ******************
'// FACILITY_CERT
'// ******************
'//
'// MessageId: TRUST_E_PROVIDER_UNKNOWN
'//
'// MessageText:
'//
'// Unknown trust provider.
'//
%TRUST_E_PROVIDER_UNKNOWN         = &H800B0001&

'//
'// MessageId: TRUST_E_ACTION_UNKNOWN
'//
'// MessageText:
'//
'// The trust verification action specified is not supported by the specified trust provider.
'//
%TRUST_E_ACTION_UNKNOWN           = &H800B0002&

'//
'// MessageId: TRUST_E_SUBJECT_FORM_UNKNOWN
'//
'// MessageText:
'//
'// The form specified for the subject is not one supported or known by the specified trust provider.
'//
%TRUST_E_SUBJECT_FORM_UNKNOWN     = &H800B0003&

'//
'// MessageId: TRUST_E_SUBJECT_NOT_TRUSTED
'//
'// MessageText:
'//
'// The subject is not trusted for the specified action.
'//
%TRUST_E_SUBJECT_NOT_TRUSTED      = &H800B0004&

'//
'// MessageId: DIGSIG_E_ENCODE
'//
'// MessageText:
'//
'// Error due to problem in ASN.1 encoding process.
'//
%DIGSIG_E_ENCODE                  = &H800B0005&

'//
'// MessageId: DIGSIG_E_DECODE
'//
'// MessageText:
'//
'// Error due to problem in ASN.1 decoding process.
'//
%DIGSIG_E_DECODE                  = &H800B0006&

'//
'// MessageId: DIGSIG_E_EXTENSIBILITY
'//
'// MessageText:
'//
'// Reading / writing Extensions where Attributes are appropriate, and visa versa.
'//
%DIGSIG_E_EXTENSIBILITY           = &H800B0007&

'//
'// MessageId: DIGSIG_E_CRYPTO
'//
'// MessageText:
'//
'// Unspecified cryptographic failure.
'//
%DIGSIG_E_CRYPTO                  = &H800B0008&

'//
'// MessageId: PERSIST_E_SIZEDEFINITE
'//
'// MessageText:
'//
'// The size of the data could not be determined.
'//
%PERSIST_E_SIZEDEFINITE           = &H800B0009&

'//
'// MessageId: PERSIST_E_SIZEINDEFINITE
'//
'// MessageText:
'//
'// The size of the indefinite-sized data could not be determined.
'//
%PERSIST_E_SIZEINDEFINITE         = &H800B000A&

'//
'// MessageId: PERSIST_E_NOTSELFSIZING
'//
'// MessageText:
'//
'// This object does not read and write self-sizing data.
'//
%PERSIST_E_NOTSELFSIZING          = &H800B000B&

'//
'// MessageId: TRUST_E_NOSIGNATURE
'//
'// MessageText:
'//
'// No signature was present in the subject.
'//
%TRUST_E_NOSIGNATURE              = &H800B0100&

'//
'// MessageId: CERT_E_EXPIRED
'//
'// MessageText:
'//
'// A required certificate is not within its validity period when verifying against the current system clock or the timestamp in the signed file.
'//
%CERT_E_EXPIRED                   = &H800B0101&

'//
'// MessageId: CERT_E_VALIDITYPERIODNESTING
'//
'// MessageText:
'//
'// The validity periods of the certification chain do not nest correctly.
'//
%CERT_E_VALIDITYPERIODNESTING     = &H800B0102&

'//
'// MessageId: CERT_E_ROLE
'//
'// MessageText:
'//
'// A certificate that can only be used as an end-entity is being used as a CA or visa versa.
'//
%CERT_E_ROLE                      = &H800B0103&

'//
'// MessageId: CERT_E_PATHLENCONST
'//
'// MessageText:
'//
'// A path length constraint in the certification chain has been violated.
'//
%CERT_E_PATHLENCONST              = &H800B0104&

'//
'// MessageId: CERT_E_CRITICAL
'//
'// MessageText:
'//
'// A certificate contains an unknown extension that is marked 'critical'.
'//
%CERT_E_CRITICAL                  = &H800B0105&

'//
'// MessageId: CERT_E_PURPOSE
'//
'// MessageText:
'//
'// A certificate being used for a purpose other than the ones specified by its CA.
'//
%CERT_E_PURPOSE                   = &H800B0106&

'//
'// MessageId: CERT_E_ISSUERCHAINING
'//
'// MessageText:
'//
'// A parent of a given certificate in fact did not issue that child certificate.
'//
%CERT_E_ISSUERCHAINING            = &H800B0107&

'//
'// MessageId: CERT_E_MALFORMED
'//
'// MessageText:
'//
'// A certificate is missing or has an empty value for an important field, such as a subject or issuer name.
'//
%CERT_E_MALFORMED                 = &H800B0108&

'//
'// MessageId: CERT_E_UNTRUSTEDROOT
'//
'// MessageText:
'//
'// A certificate chain processed, but terminated in a root certificate which is not trusted by the trust provider.
'//
%CERT_E_UNTRUSTEDROOT             = &H800B0109&

'//
'// MessageId: CERT_E_CHAINING
'//
'// MessageText:
'//
'// A certificate chain could not be built to a trusted root authority.
'//
%CERT_E_CHAINING                  = &H800B010A&

'//
'// MessageId: TRUST_E_FAIL
'//
'// MessageText:
'//
'// Generic trust failure.
'//
%TRUST_E_FAIL                     = &H800B010B&

'//
'// MessageId: CERT_E_REVOKED
'//
'// MessageText:
'//
'// A certificate was explicitly revoked by its issuer.
'//
%CERT_E_REVOKED                   = &H800B010C&

'//
'// MessageId: CERT_E_UNTRUSTEDTESTROOT
'//
'// MessageText:
'//
'// The certification path terminates with the test root which is not trusted with the current policy settings.
'//
%CERT_E_UNTRUSTEDTESTROOT         = &H800B010D&

'//
'// MessageId: CERT_E_REVOCATION_FAILURE
'//
'// MessageText:
'//
'// The revocation process could not continue - the certificate(s) could not be checked.
'//
%CERT_E_REVOCATION_FAILURE        = &H800B010E&

'//
'// MessageId: CERT_E_CN_NO_MATCH
'//
'// MessageText:
'//
'// The certificate's CN name does not match the passed value.
'//
%CERT_E_CN_NO_MATCH               = &H800B010F&

'//
'// MessageId: CERT_E_WRONG_USAGE
'//
'// MessageText:
'//
'// The certificate is not valid for the requested usage.
'//
%CERT_E_WRONG_USAGE               = &H800B0110&

'//
'// MessageId: TRUST_E_EXPLICIT_DISTRUST
'//
'// MessageText:
'//
'// The certificate was explicitly marked as untrusted by the user.
'//
%TRUST_E_EXPLICIT_DISTRUST        = &H800B0111&

'//
'// MessageId: CERT_E_UNTRUSTEDCA
'//
'// MessageText:
'//
'// A certification chain processed correctly, but one of the CA certificates is not trusted by the policy provider.
'//
%CERT_E_UNTRUSTEDCA               = &H800B0112&

'//
'// MessageId: CERT_E_INVALID_POLICY
'//
'// MessageText:
'//
'// The certificate has invalid policy.
'//
%CERT_E_INVALID_POLICY            = &H800B0113&

'//
'// MessageId: CERT_E_INVALID_NAME
'//
'// MessageText:
'//
'// The certificate has an invalid name. The name is not included in the permitted list or is explicitly excluded.
'//
%CERT_E_INVALID_NAME              = &H800B0114&

'// *****************
'// FACILITY_SETUPAPI
'// *****************
'//
'// Since these error codes aren't in the standard Win32 range (i.e., 0-64K), define a
'// macro to map either Win32 or SetupAPI error codes into an HRESULT.
'//
'#define HRESULT_FROM_SETUPAPI(x) ((((x) & (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR)) = = (APPLICATION_ERROR_MASK|ERROR_SEVERITY_ERROR)) \
'                                 ? ((HRESULT) (((x) & 0x0000FFFF) | (FACILITY_SETUPAPI << 16) | 0x80000000))                               \
'                                 : HRESULT_FROM_WIN32(x))

'    FUNCTION HRESULT_FROM_SETUPAPI (BYVAL x AS LONG) AS LONG
'        IF (((x) AND (&H20000000??? OR &HC0000000???)) =  (&H20000000??? OR &HC0000000???)) THEN
'            FUNCTION =  (((x) AND &H0000FFFF) OR (%FACILITY_SETUPAPI * &H10000) OR &H80000000???)
'        ELSE
'            FUNCTION =  HRESULT_FROM_WIN32(x)
'        END IF
'    END FUNCTION
'//
'// MessageId: SPAPI_E_EXPECTED_SECTION_NAME
'//
'// MessageText:
'//
'// A non-empty line was encountered in the INF before the start of a section.
'//
%SPAPI_E_EXPECTED_SECTION_NAME    = &H800F0000&

'//
'// MessageId: SPAPI_E_BAD_SECTION_NAME_LINE
'//
'// MessageText:
'//
'// A section name marker in the INF is not complete, or does not exist on a line by itself.
'//
%SPAPI_E_BAD_SECTION_NAME_LINE    = &H800F0001&

'//
'// MessageId: SPAPI_E_SECTION_NAME_TOO_LONG
'//
'// MessageText:
'//
'// An INF section was encountered whose name exceeds the maximum section name length.
'//
%SPAPI_E_SECTION_NAME_TOO_LONG    = &H800F0002&

'//
'// MessageId: SPAPI_E_GENERAL_SYNTAX
'//
'// MessageText:
'//
'// The syntax of the INF is invalid.
'//
%SPAPI_E_GENERAL_SYNTAX           = &H800F0003&

'//
'// MessageId: SPAPI_E_WRONG_INF_STYLE
'//
'// MessageText:
'//
'// The style of the INF is different than what was requested.
'//
%SPAPI_E_WRONG_INF_STYLE          = &H800F0100&

'//
'// MessageId: SPAPI_E_SECTION_NOT_FOUND
'//
'// MessageText:
'//
'// The required section was not found in the INF.
'//
%SPAPI_E_SECTION_NOT_FOUND        = &H800F0101&

'//
'// MessageId: SPAPI_E_LINE_NOT_FOUND
'//
'// MessageText:
'//
'// The required line was not found in the INF.
'//
%SPAPI_E_LINE_NOT_FOUND           = &H800F0102&

'//
'// MessageId: SPAPI_E_NO_BACKUP
'//
'// MessageText:
'//
'// The files affected by the installation of this file queue have not been backed up for uninstall.
'//
%SPAPI_E_NO_BACKUP                = &H800F0103&

'//
'// MessageId: SPAPI_E_NO_ASSOCIATED_CLASS
'//
'// MessageText:
'//
'// The INF or the device information set or element does not have an associated install class.
'//
%SPAPI_E_NO_ASSOCIATED_CLASS      = &H800F0200&

'//
'// MessageId: SPAPI_E_CLASS_MISMATCH
'//
'// MessageText:
'//
'// The INF or the device information set or element does not match the specified install class.
'//
%SPAPI_E_CLASS_MISMATCH           = &H800F0201&

'//
'// MessageId: SPAPI_E_DUPLICATE_FOUND
'//
'// MessageText:
'//
'// An existing device was found that is a duplicate of the device being manually installed.
'//
%SPAPI_E_DUPLICATE_FOUND          = &H800F0202&

'//
'// MessageId: SPAPI_E_NO_DRIVER_SELECTED
'//
'// MessageText:
'//
'// There is no driver selected for the device information set or element.
'//
%SPAPI_E_NO_DRIVER_SELECTED       = &H800F0203&

'//
'// MessageId: SPAPI_E_KEY_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// The requested device registry key does not exist.
'//
%SPAPI_E_KEY_DOES_NOT_EXIST       = &H800F0204&

'//
'// MessageId: SPAPI_E_INVALID_DEVINST_NAME
'//
'// MessageText:
'//
'// The device instance name is invalid.
'//
%SPAPI_E_INVALID_DEVINST_NAME     = &H800F0205&

'//
'// MessageId: SPAPI_E_INVALID_CLASS
'//
'// MessageText:
'//
'// The install class is not present or is invalid.
'//
%SPAPI_E_INVALID_CLASS            = &H800F0206&

'//
'// MessageId: SPAPI_E_DEVINST_ALREADY_EXISTS
'//
'// MessageText:
'//
'// The device instance cannot be created because it already exists.
'//
%SPAPI_E_DEVINST_ALREADY_EXISTS   = &H800F0207&

'//
'// MessageId: SPAPI_E_DEVINFO_NOT_REGISTERED
'//
'// MessageText:
'//
'// The operation cannot be performed on a device information element that has not been registered.
'//
%SPAPI_E_DEVINFO_NOT_REGISTERED   = &H800F0208&

'//
'// MessageId: SPAPI_E_INVALID_REG_PROPERTY
'//
'// MessageText:
'//
'// The device property code is invalid.
'//
%SPAPI_E_INVALID_REG_PROPERTY     = &H800F0209&

'//
'// MessageId: SPAPI_E_NO_INF
'//
'// MessageText:
'//
'// The INF from which a driver list is to be built does not exist.
'//
%SPAPI_E_NO_INF                   = &H800F020A&

'//
'// MessageId: SPAPI_E_NO_SUCH_DEVINST
'//
'// MessageText:
'//
'// The device instance does not exist in the hardware tree.
'//
%SPAPI_E_NO_SUCH_DEVINST          = &H800F020B&

'//
'// MessageId: SPAPI_E_CANT_LOAD_CLASS_ICON
'//
'// MessageText:
'//
'// The icon representing this install class cannot be loaded.
'//
%SPAPI_E_CANT_LOAD_CLASS_ICON     = &H800F020C&

'//
'// MessageId: SPAPI_E_INVALID_CLASS_INSTALLER
'//
'// MessageText:
'//
'// The class installer registry entry is invalid.
'//
%SPAPI_E_INVALID_CLASS_INSTALLER  = &H800F020D&

'//
'// MessageId: SPAPI_E_DI_DO_DEFAULT
'//
'// MessageText:
'//
'// The class installer has indicated that the default action should be performed for this installation request.
'//
%SPAPI_E_DI_DO_DEFAULT            = &H800F020E&

'//
'// MessageId: SPAPI_E_DI_NOFILECOPY
'//
'// MessageText:
'//
'// The operation does not require any files to be copied.
'//
%SPAPI_E_DI_NOFILECOPY            = &H800F020F&

'//
'// MessageId: SPAPI_E_INVALID_HWPROFILE
'//
'// MessageText:
'//
'// The specified hardware profile does not exist.
'//
%SPAPI_E_INVALID_HWPROFILE        = &H800F0210&

'//
'// MessageId: SPAPI_E_NO_DEVICE_SELECTED
'//
'// MessageText:
'//
'// There is no device information element currently selected for this device information set.
'//
%SPAPI_E_NO_DEVICE_SELECTED       = &H800F0211&

'//
'// MessageId: SPAPI_E_DEVINFO_LIST_LOCKED
'//
'// MessageText:
'//
'// The operation cannot be performed because the device information set is locked.
'//
%SPAPI_E_DEVINFO_LIST_LOCKED      = &H800F0212&

'//
'// MessageId: SPAPI_E_DEVINFO_DATA_LOCKED
'//
'// MessageText:
'//
'// The operation cannot be performed because the device information element is locked.
'//
%SPAPI_E_DEVINFO_DATA_LOCKED      = &H800F0213&

'//
'// MessageId: SPAPI_E_DI_BAD_PATH
'//
'// MessageText:
'//
'// The specified path does not contain any applicable device INFs.
'//
%SPAPI_E_DI_BAD_PATH              = &H800F0214&

'//
'// MessageId: SPAPI_E_NO_CLASSINSTALL_PARAMS
'//
'// MessageText:
'//
'// No class installer parameters have been set for the device information set or element.
'//
%SPAPI_E_NO_CLASSINSTALL_PARAMS   = &H800F0215&

'//
'// MessageId: SPAPI_E_FILEQUEUE_LOCKED
'//
'// MessageText:
'//
'// The operation cannot be performed because the file queue is locked.
'//
%SPAPI_E_FILEQUEUE_LOCKED         = &H800F0216&

'//
'// MessageId: SPAPI_E_BAD_SERVICE_INSTALLSECT
'//
'// MessageText:
'//
'// A service installation section in this INF is invalid.
'//
%SPAPI_E_BAD_SERVICE_INSTALLSECT  = &H800F0217&

'//
'// MessageId: SPAPI_E_NO_CLASS_DRIVER_LIST
'//
'// MessageText:
'//
'// There is no class driver list for the device information element.
'//
%SPAPI_E_NO_CLASS_DRIVER_LIST     = &H800F0218&

'//
'// MessageId: SPAPI_E_NO_ASSOCIATED_SERVICE
'//
'// MessageText:
'//
'// The installation failed because a function driver was not specified for this device instance.
'//
%SPAPI_E_NO_ASSOCIATED_SERVICE    = &H800F0219&

'//
'// MessageId: SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE
'//
'// MessageText:
'//
'// There is presently no default device interface designated for this interface class.
'//
%SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE = &H800F021A&

'//
'// MessageId: SPAPI_E_DEVICE_INTERFACE_ACTIVE
'//
'// MessageText:
'//
'// The operation cannot be performed because the device interface is currently active.
'//
%SPAPI_E_DEVICE_INTERFACE_ACTIVE  = &H800F021B&

'//
'// MessageId: SPAPI_E_DEVICE_INTERFACE_REMOVED
'//
'// MessageText:
'//
'// The operation cannot be performed because the device interface has been removed from the system.
'//
%SPAPI_E_DEVICE_INTERFACE_REMOVED = &H800F021C&

'//
'// MessageId: SPAPI_E_BAD_INTERFACE_INSTALLSECT
'//
'// MessageText:
'//
'// An interface installation section in this INF is invalid.
'//
%SPAPI_E_BAD_INTERFACE_INSTALLSECT = &H800F021D&

'//
'// MessageId: SPAPI_E_NO_SUCH_INTERFACE_CLASS
'//
'// MessageText:
'//
'// This interface class does not exist in the system.
'//
%SPAPI_E_NO_SUCH_INTERFACE_CLASS  = &H800F021E&

'//
'// MessageId: SPAPI_E_INVALID_REFERENCE_STRING
'//
'// MessageText:
'//
'// The reference string supplied for this interface device is invalid.
'//
%SPAPI_E_INVALID_REFERENCE_STRING = &H800F021F&

'//
'// MessageId: SPAPI_E_INVALID_MACHINENAME
'//
'// MessageText:
'//
'// The specified machine name does not conform to UNC naming conventions.
'//
%SPAPI_E_INVALID_MACHINENAME      = &H800F0220&

'//
'// MessageId: SPAPI_E_REMOTE_COMM_FAILURE
'//
'// MessageText:
'//
'// A general remote communication error occurred.
'//
%SPAPI_E_REMOTE_COMM_FAILURE      = &H800F0221&

'//
'// MessageId: SPAPI_E_MACHINE_UNAVAILABLE
'//
'// MessageText:
'//
'// The machine selected for remote communication is not available at this time.
'//
%SPAPI_E_MACHINE_UNAVAILABLE      = &H800F0222&

'//
'// MessageId: SPAPI_E_NO_CONFIGMGR_SERVICES
'//
'// MessageText:
'//
'// The Plug and Play service is not available on the remote machine.
'//
%SPAPI_E_NO_CONFIGMGR_SERVICES    = &H800F0223&

'//
'// MessageId: SPAPI_E_INVALID_PROPPAGE_PROVIDER
'//
'// MessageText:
'//
'// The property page provider registry entry is invalid.
'//
%SPAPI_E_INVALID_PROPPAGE_PROVIDER = &H800F0224&

'//
'// MessageId: SPAPI_E_NO_SUCH_DEVICE_INTERFACE
'//
'// MessageText:
'//
'// The requested device interface is not present in the system.
'//
%SPAPI_E_NO_SUCH_DEVICE_INTERFACE = &H800F0225&

'//
'// MessageId: SPAPI_E_DI_POSTPROCESSING_REQUIRED
'//
'// MessageText:
'//
'// The device's co-installer has additional work to perform after installation is complete.
'//
%SPAPI_E_DI_POSTPROCESSING_REQUIRED = &H800F0226&

'//
'// MessageId: SPAPI_E_INVALID_COINSTALLER
'//
'// MessageText:
'//
'// The device's co-installer is invalid.
'//
%SPAPI_E_INVALID_COINSTALLER      = &H800F0227&

'//
'// MessageId: SPAPI_E_NO_COMPAT_DRIVERS
'//
'// MessageText:
'//
'// There are no compatible drivers for this device.
'//
%SPAPI_E_NO_COMPAT_DRIVERS        = &H800F0228&

'//
'// MessageId: SPAPI_E_NO_DEVICE_ICON
'//
'// MessageText:
'//
'// There is no icon that represents this device or device type.
'//
%SPAPI_E_NO_DEVICE_ICON           = &H800F0229&

'//
'// MessageId: SPAPI_E_INVALID_INF_LOGCONFIG
'//
'// MessageText:
'//
'// A logical configuration specified in this INF is invalid.
'//
%SPAPI_E_INVALID_INF_LOGCONFIG    = &H800F022A&

'//
'// MessageId: SPAPI_E_DI_DONT_INSTALL
'//
'// MessageText:
'//
'// The class installer has denied the request to install or upgrade this device.
'//
%SPAPI_E_DI_DONT_INSTALL          = &H800F022B&

'//
'// MessageId: SPAPI_E_INVALID_FILTER_DRIVER
'//
'// MessageText:
'//
'// One of the filter drivers installed for this device is invalid.
'//
%SPAPI_E_INVALID_FILTER_DRIVER    = &H800F022C&

'//
'// MessageId: SPAPI_E_NON_WINDOWS_NT_DRIVER
'//
'// MessageText:
'//
'// The driver selected for this device does not support Windows Vista.
'//
%SPAPI_E_NON_WINDOWS_NT_DRIVER    = &H800F022D&

'//
'// MessageId: SPAPI_E_NON_WINDOWS_DRIVER
'//
'// MessageText:
'//
'// The driver selected for this device does not support Windows.
'//
%SPAPI_E_NON_WINDOWS_DRIVER       = &H800F022E&

'//
'// MessageId: SPAPI_E_NO_CATALOG_FOR_OEM_INF
'//
'// MessageText:
'//
'// The third-party INF does not contain digital signature information.
'//
%SPAPI_E_NO_CATALOG_FOR_OEM_INF   = &H800F022F&

'//
'// MessageId: SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE
'//
'// MessageText:
'//
'// An invalid attempt was made to use a device installation file queue for verification of digital signatures relative to other platforms.
'//
%SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE = &H800F0230&

'//
'// MessageId: SPAPI_E_NOT_DISABLEABLE
'//
'// MessageText:
'//
'// The device cannot be disabled.
'//
%SPAPI_E_NOT_DISABLEABLE          = &H800F0231&

'//
'// MessageId: SPAPI_E_CANT_REMOVE_DEVINST
'//
'// MessageText:
'//
'// The device could not be dynamically removed.
'//
%SPAPI_E_CANT_REMOVE_DEVINST      = &H800F0232&

'//
'// MessageId: SPAPI_E_INVALID_TARGET
'//
'// MessageText:
'//
'// Cannot copy to specified target.
'//
%SPAPI_E_INVALID_TARGET           = &H800F0233&

'//
'// MessageId: SPAPI_E_DRIVER_NONNATIVE
'//
'// MessageText:
'//
'// Driver is not intended for this platform.
'//
%SPAPI_E_DRIVER_NONNATIVE         = &H800F0234&

'//
'// MessageId: SPAPI_E_IN_WOW64
'//
'// MessageText:
'//
'// Operation not allowed in WOW64.
'//
%SPAPI_E_IN_WOW64                 = &H800F0235&

'//
'// MessageId: SPAPI_E_SET_SYSTEM_RESTORE_POINT
'//
'// MessageText:
'//
'// The operation involving unsigned file copying was rolled back, so that a system restore point could be set.
'//
%SPAPI_E_SET_SYSTEM_RESTORE_POINT = &H800F0236&

'//
'// MessageId: SPAPI_E_INCORRECTLY_COPIED_INF
'//
'// MessageText:
'//
'// An INF was copied into the Windows INF directory in an improper manner.
'//
%SPAPI_E_INCORRECTLY_COPIED_INF   = &H800F0237&

'//
'// MessageId: SPAPI_E_SCE_DISABLED
'//
'// MessageText:
'//
'// The Security Configuration Editor (SCE) APIs have been disabled on this Embedded product.
'//
%SPAPI_E_SCE_DISABLED             = &H800F0238&

'//
'// MessageId: SPAPI_E_UNKNOWN_EXCEPTION
'//
'// MessageText:
'//
'// An unknown exception was encountered.
'//
%SPAPI_E_UNKNOWN_EXCEPTION        = &H800F0239&

'//
'// MessageId: SPAPI_E_PNP_REGISTRY_ERROR
'//
'// MessageText:
'//
'// A problem was encountered when accessing the Plug and Play registry database.
'//
%SPAPI_E_PNP_REGISTRY_ERROR       = &H800F023A&

'//
'// MessageId: SPAPI_E_REMOTE_REQUEST_UNSUPPORTED
'//
'// MessageText:
'//
'// The requested operation is not supported for a remote machine.
'//
%SPAPI_E_REMOTE_REQUEST_UNSUPPORTED = &H800F023B&

'//
'// MessageId: SPAPI_E_NOT_AN_INSTALLED_OEM_INF
'//
'// MessageText:
'//
'// The specified file is not an installed OEM INF.
'//
%SPAPI_E_NOT_AN_INSTALLED_OEM_INF = &H800F023C&

'//
'// MessageId: SPAPI_E_INF_IN_USE_BY_DEVICES
'//
'// MessageText:
'//
'// One or more devices are presently installed using the specified INF.
'//
%SPAPI_E_INF_IN_USE_BY_DEVICES    = &H800F023D&

'//
'// MessageId: SPAPI_E_DI_FUNCTION_OBSOLETE
'//
'// MessageText:
'//
'// The requested device install operation is obsolete.
'//
%SPAPI_E_DI_FUNCTION_OBSOLETE     = &H800F023E&

'//
'// MessageId: SPAPI_E_NO_AUTHENTICODE_CATALOG
'//
'// MessageText:
'//
'// A file could not be verified because it does not have an associated catalog signed via Authenticode(tm).
'//
%SPAPI_E_NO_AUTHENTICODE_CATALOG  = &H800F023F&

'//
'// MessageId: SPAPI_E_AUTHENTICODE_DISALLOWED
'//
'// MessageText:
'//
'// Authenticode(tm) signature verification is not supported for the specified INF.
'//
%SPAPI_E_AUTHENTICODE_DISALLOWED  = &H800F0240&

'//
'// MessageId: SPAPI_E_AUTHENTICODE_TRUSTED_PUBLISHER
'//
'// MessageText:
'//
'// The INF was signed with an Authenticode(tm) catalog from a trusted publisher.
'//
%SPAPI_E_AUTHENTICODE_TRUSTED_PUBLISHER = &H800F0241&

'//
'// MessageId: SPAPI_E_AUTHENTICODE_TRUST_NOT_ESTABLISHED
'//
'// MessageText:
'//
'// The publisher of an Authenticode(tm) signed catalog has not yet been established as trusted.
'//
%SPAPI_E_AUTHENTICODE_TRUST_NOT_ESTABLISHED = &H800F0242&

'//
'// MessageId: SPAPI_E_AUTHENTICODE_PUBLISHER_NOT_TRUSTED
'//
'// MessageText:
'//
'// The publisher of an Authenticode(tm) signed catalog was not established as trusted.
'//
%SPAPI_E_AUTHENTICODE_PUBLISHER_NOT_TRUSTED = &H800F0243&

'//
'// MessageId: SPAPI_E_SIGNATURE_OSATTRIBUTE_MISMATCH
'//
'// MessageText:
'//
'// The software was tested for compliance with Windows Logo requirements on a different version of Windows, and may not be compatible with this version.
'//
%SPAPI_E_SIGNATURE_OSATTRIBUTE_MISMATCH = &H800F0244&

'//
'// MessageId: SPAPI_E_ONLY_VALIDATE_VIA_AUTHENTICODE
'//
'// MessageText:
'//
'// The file may only be validated by a catalog signed via Authenticode(tm).
'//
%SPAPI_E_ONLY_VALIDATE_VIA_AUTHENTICODE = &H800F0245&

'//
'// MessageId: SPAPI_E_DEVICE_INSTALLER_NOT_READY
'//
'// MessageText:
'//
'// One of the installers for this device cannot perform the installation at this time.
'//
%SPAPI_E_DEVICE_INSTALLER_NOT_READY = &H800F0246&

'//
'// MessageId: SPAPI_E_DRIVER_STORE_ADD_FAILED
'//
'// MessageText:
'//
'// A problem was encountered while attempting to add the driver to the store.
'//
%SPAPI_E_DRIVER_STORE_ADD_FAILED  = &H800F0247&

'//
'// MessageId: SPAPI_E_DEVICE_INSTALL_BLOCKED
'//
'// MessageText:
'//
'// The installation of this device is forbidden by system policy. Contact your system administrator.
'//
%SPAPI_E_DEVICE_INSTALL_BLOCKED   = &H800F0248&

'//
'// MessageId: SPAPI_E_DRIVER_INSTALL_BLOCKED
'//
'// MessageText:
'//
'// The installation of this driver is forbidden by system policy. Contact your system administrator.
'//
%SPAPI_E_DRIVER_INSTALL_BLOCKED   = &H800F0249&

'//
'// MessageId: SPAPI_E_WRONG_INF_TYPE
'//
'// MessageText:
'//
'// The specified INF is the wrong type for this operation.
'//
%SPAPI_E_WRONG_INF_TYPE           = &H800F024A&

'//
'// MessageId: SPAPI_E_FILE_HASH_NOT_IN_CATALOG
'//
'// MessageText:
'//
'// The hash for the file is not present in the specified catalog file. The file is likely corrupt or the victim of tampering.
'//
%SPAPI_E_FILE_HASH_NOT_IN_CATALOG = &H800F024B&

'//
'// MessageId: SPAPI_E_DRIVER_STORE_DELETE_FAILED
'//
'// MessageText:
'//
'// A problem was encountered while attempting to delete the driver from the store.
'//
%SPAPI_E_DRIVER_STORE_DELETE_FAILED = &H800F024C&

'//
'// MessageId: SPAPI_E_UNRECOVERABLE_STACK_OVERFLOW
'//
'// MessageText:
'//
'// An unrecoverable stack overflow was encountered.
'//
%SPAPI_E_UNRECOVERABLE_STACK_OVERFLOW = &H800F0300&

'//
'// MessageId: SPAPI_E_ERROR_NOT_INSTALLED
'//
'// MessageText:
'//
'// No installed components were detected.
'//
%SPAPI_E_ERROR_NOT_INSTALLED      = &H800F1000&

'// *****************
'// FACILITY_SCARD
'// *****************
'//
'// = ============================
'// Facility SCARD Error Messages
'// = ============================
'//
%SCARD_S_SUCCESS = %NO_ERROR
'//
'// MessageId: SCARD_F_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal consistency check failed.
'//
%SCARD_F_INTERNAL_ERROR           = &H80100001&

'//
'// MessageId: SCARD_E_CANCELLED
'//
'// MessageText:
'//
'// The action was cancelled by an SCardCancel request.
'//
%SCARD_E_CANCELLED                = &H80100002&

'//
'// MessageId: SCARD_E_INVALID_HANDLE
'//
'// MessageText:
'//
'// The supplied handle was invalid.
'//
%SCARD_E_INVALID_HANDLE           = &H80100003&

'//
'// MessageId: SCARD_E_INVALID_PARAMETER
'//
'// MessageText:
'//
'// One or more of the supplied parameters could not be properly interpreted.
'//
%SCARD_E_INVALID_PARAMETER        = &H80100004&

'//
'// MessageId: SCARD_E_INVALID_TARGET
'//
'// MessageText:
'//
'// Registry startup information is missing or invalid.
'//
%SCARD_E_INVALID_TARGET           = &H80100005&

'//
'// MessageId: SCARD_E_NO_MEMORY
'//
'// MessageText:
'//
'// Not enough memory available to complete this command.
'//
%SCARD_E_NO_MEMORY                = &H80100006&

'//
'// MessageId: SCARD_F_WAITED_TOO_LONG
'//
'// MessageText:
'//
'// An internal consistency timer has expired.
'//
%SCARD_F_WAITED_TOO_LONG          = &H80100007&

'//
'// MessageId: SCARD_E_INSUFFICIENT_BUFFER
'//
'// MessageText:
'//
'// The data buffer to receive returned data is too small for the returned data.
'//
%SCARD_E_INSUFFICIENT_BUFFER      = &H80100008&

'//
'// MessageId: SCARD_E_UNKNOWN_READER
'//
'// MessageText:
'//
'// The specified reader name is not recognized.
'//
%SCARD_E_UNKNOWN_READER           = &H80100009&

'//
'// MessageId: SCARD_E_TIMEOUT
'//
'// MessageText:
'//
'// The user-specified timeout value has expired.
'//
%SCARD_E_TIMEOUT                  = &H8010000A&

'//
'// MessageId: SCARD_E_SHARING_VIOLATION
'//
'// MessageText:
'//
'// The smart card cannot be accessed because of other connections outstanding.
'//
%SCARD_E_SHARING_VIOLATION        = &H8010000B&

'//
'// MessageId: SCARD_E_NO_SMARTCARD
'//
'// MessageText:
'//
'// The operation requires a Smart Card, but no Smart Card is currently in the device.
'//
%SCARD_E_NO_SMARTCARD             = &H8010000C&

'//
'// MessageId: SCARD_E_UNKNOWN_CARD
'//
'// MessageText:
'//
'// The specified smart card name is not recognized.
'//
%SCARD_E_UNKNOWN_CARD             = &H8010000D&

'//
'// MessageId: SCARD_E_CANT_DISPOSE
'//
'// MessageText:
'//
'// The system could not dispose of the media in the requested manner.
'//
%SCARD_E_CANT_DISPOSE             = &H8010000E&

'//
'// MessageId: SCARD_E_PROTO_MISMATCH
'//
'// MessageText:
'//
'// The requested protocols are incompatible with the protocol currently in use with the smart card.
'//
%SCARD_E_PROTO_MISMATCH           = &H8010000F&

'//
'// MessageId: SCARD_E_NOT_READY
'//
'// MessageText:
'//
'// The reader or smart card is not ready to accept commands.
'//
%SCARD_E_NOT_READY                = &H80100010&

'//
'// MessageId: SCARD_E_INVALID_VALUE
'//
'// MessageText:
'//
'// One or more of the supplied parameters values could not be properly interpreted.
'//
%SCARD_E_INVALID_VALUE            = &H80100011&

'//
'// MessageId: SCARD_E_SYSTEM_CANCELLED
'//
'// MessageText:
'//
'// The action was cancelled by the system, presumably to log off or shut down.
'//
%SCARD_E_SYSTEM_CANCELLED         = &H80100012&

'//
'// MessageId: SCARD_F_COMM_ERROR
'//
'// MessageText:
'//
'// An internal communications error has been detected.
'//
%SCARD_F_COMM_ERROR               = &H80100013&

'//
'// MessageId: SCARD_F_UNKNOWN_ERROR
'//
'// MessageText:
'//
'// An internal error has been detected, but the source is unknown.
'//
%SCARD_F_UNKNOWN_ERROR            = &H80100014&

'//
'// MessageId: SCARD_E_INVALID_ATR
'//
'// MessageText:
'//
'// An ATR obtained from the registry is not a valid ATR string.
'//
%SCARD_E_INVALID_ATR              = &H80100015&

'//
'// MessageId: SCARD_E_NOT_TRANSACTED
'//
'// MessageText:
'//
'// An attempt was made to end a non-existent transaction.
'//
%SCARD_E_NOT_TRANSACTED           = &H80100016&

'//
'// MessageId: SCARD_E_READER_UNAVAILABLE
'//
'// MessageText:
'//
'// The specified reader is not currently available for use.
'//
%SCARD_E_READER_UNAVAILABLE       = &H80100017&

'//
'// MessageId: SCARD_P_SHUTDOWN
'//
'// MessageText:
'//
'// The operation has been aborted to allow the server application to exit.
'//
%SCARD_P_SHUTDOWN                 = &H80100018&

'//
'// MessageId: SCARD_E_PCI_TOO_SMALL
'//
'// MessageText:
'//
'// The PCI Receive buffer was too small.
'//
%SCARD_E_PCI_TOO_SMALL            = &H80100019&

'//
'// MessageId: SCARD_E_READER_UNSUPPORTED
'//
'// MessageText:
'//
'// The reader driver does not meet minimal requirements for support.
'//
%SCARD_E_READER_UNSUPPORTED       = &H8010001A&

'//
'// MessageId: SCARD_E_DUPLICATE_READER
'//
'// MessageText:
'//
'// The reader driver did not produce a unique reader name.
'//
%SCARD_E_DUPLICATE_READER         = &H8010001B&

'//
'// MessageId: SCARD_E_CARD_UNSUPPORTED
'//
'// MessageText:
'//
'// The smart card does not meet minimal requirements for support.
'//
%SCARD_E_CARD_UNSUPPORTED         = &H8010001C&

'//
'// MessageId: SCARD_E_NO_SERVICE
'//
'// MessageText:
'//
'// The Smart card resource manager is not running.
'//
%SCARD_E_NO_SERVICE               = &H8010001D&

'//
'// MessageId: SCARD_E_SERVICE_STOPPED
'//
'// MessageText:
'//
'// The Smart card resource manager has shut down.
'//
%SCARD_E_SERVICE_STOPPED          = &H8010001E&

'//
'// MessageId: SCARD_E_UNEXPECTED
'//
'// MessageText:
'//
'// An unexpected card error has occurred.
'//
%SCARD_E_UNEXPECTED               = &H8010001F&

'//
'// MessageId: SCARD_E_ICC_INSTALLATION
'//
'// MessageText:
'//
'// No Primary Provider can be found for the smart card.
'//
%SCARD_E_ICC_INSTALLATION         = &H80100020&

'//
'// MessageId: SCARD_E_ICC_CREATEORDER
'//
'// MessageText:
'//
'// The requested order of object creation is not supported.
'//
%SCARD_E_ICC_CREATEORDER          = &H80100021&

'//
'// MessageId: SCARD_E_UNSUPPORTED_FEATURE
'//
'// MessageText:
'//
'// This smart card does not support the requested feature.
'//
%SCARD_E_UNSUPPORTED_FEATURE      = &H80100022&

'//
'// MessageId: SCARD_E_DIR_NOT_FOUND
'//
'// MessageText:
'//
'// The identified directory does not exist in the smart card.
'//
%SCARD_E_DIR_NOT_FOUND            = &H80100023&

'//
'// MessageId: SCARD_E_FILE_NOT_FOUND
'//
'// MessageText:
'//
'// The identified file does not exist in the smart card.
'//
%SCARD_E_FILE_NOT_FOUND           = &H80100024&

'//
'// MessageId: SCARD_E_NO_DIR
'//
'// MessageText:
'//
'// The supplied path does not represent a smart card directory.
'//
%SCARD_E_NO_DIR                   = &H80100025&

'//
'// MessageId: SCARD_E_NO_FILE
'//
'// MessageText:
'//
'// The supplied path does not represent a smart card file.
'//
%SCARD_E_NO_FILE                  = &H80100026&

'//
'// MessageId: SCARD_E_NO_ACCESS
'//
'// MessageText:
'//
'// Access is denied to this file.
'//
%SCARD_E_NO_ACCESS                = &H80100027&

'//
'// MessageId: SCARD_E_WRITE_TOO_MANY
'//
'// MessageText:
'//
'// The smartcard does not have enough memory to store the information.
'//
%SCARD_E_WRITE_TOO_MANY           = &H80100028&

'//
'// MessageId: SCARD_E_BAD_SEEK
'//
'// MessageText:
'//
'// There was an error trying to set the smart card file object pointer.
'//
%SCARD_E_BAD_SEEK                 = &H80100029&

'//
'// MessageId: SCARD_E_INVALID_CHV
'//
'// MessageText:
'//
'// The supplied PIN is incorrect.
'//
%SCARD_E_INVALID_CHV              = &H8010002A&

'//
'// MessageId: SCARD_E_UNKNOWN_RES_MNG
'//
'// MessageText:
'//
'// An unrecognized error code was returned from a layered component.
'//
%SCARD_E_UNKNOWN_RES_MNG          = &H8010002B&

'//
'// MessageId: SCARD_E_NO_SUCH_CERTIFICATE
'//
'// MessageText:
'//
'// The requested certificate does not exist.
'//
%SCARD_E_NO_SUCH_CERTIFICATE      = &H8010002C&

'//
'// MessageId: SCARD_E_CERTIFICATE_UNAVAILABLE
'//
'// MessageText:
'//
'// The requested certificate could not be obtained.
'//
%SCARD_E_CERTIFICATE_UNAVAILABLE  = &H8010002D&

'//
'// MessageId: SCARD_E_NO_READERS_AVAILABLE
'//
'// MessageText:
'//
'// Cannot find a smart card reader.
'//
%SCARD_E_NO_READERS_AVAILABLE     = &H8010002E&

'//
'// MessageId: SCARD_E_COMM_DATA_LOST
'//
'// MessageText:
'//
'// A communications error with the smart card has been detected. Retry the operation.
'//
%SCARD_E_COMM_DATA_LOST           = &H8010002F&

'//
'// MessageId: SCARD_E_NO_KEY_CONTAINER
'//
'// MessageText:
'//
'// The requested key container does not exist on the smart card.
'//
%SCARD_E_NO_KEY_CONTAINER         = &H80100030&

'//
'// MessageId: SCARD_E_SERVER_TOO_BUSY
'//
'// MessageText:
'//
'// The Smart card resource manager is too busy to complete this operation.
'//
%SCARD_E_SERVER_TOO_BUSY          = &H80100031&

'//
'// These are warning codes.
'//
'//
'// MessageId: SCARD_W_UNSUPPORTED_CARD
'//
'// MessageText:
'//
'// The reader cannot communicate with the smart card, due to ATR configuration conflicts.
'//
%SCARD_W_UNSUPPORTED_CARD         = &H80100065&

'//
'// MessageId: SCARD_W_UNRESPONSIVE_CARD
'//
'// MessageText:
'//
'// The smart card is not responding to a reset.
'//
%SCARD_W_UNRESPONSIVE_CARD        = &H80100066&

'//
'// MessageId: SCARD_W_UNPOWERED_CARD
'//
'// MessageText:
'//
'// Power has been removed from the smart card, so that further communication is not possible.
'//
%SCARD_W_UNPOWERED_CARD           = &H80100067&

'//
'// MessageId: SCARD_W_RESET_CARD
'//
'// MessageText:
'//
'// The smart card has been reset, so any shared state information is invalid.
'//
%SCARD_W_RESET_CARD               = &H80100068&

'//
'// MessageId: SCARD_W_REMOVED_CARD
'//
'// MessageText:
'//
'// The smart card has been removed, so that further communication is not possible.
'//
%SCARD_W_REMOVED_CARD             = &H80100069&

'//
'// MessageId: SCARD_W_SECURITY_VIOLATION
'//
'// MessageText:
'//
'// Access was denied because of a security violation.
'//
%SCARD_W_SECURITY_VIOLATION       = &H8010006A&

'//
'// MessageId: SCARD_W_WRONG_CHV
'//
'// MessageText:
'//
'// The card cannot be accessed because the wrong PIN was presented.
'//
%SCARD_W_WRONG_CHV                = &H8010006B&

'//
'// MessageId: SCARD_W_CHV_BLOCKED
'//
'// MessageText:
'//
'// The card cannot be accessed because the maximum number of PIN entry attempts has been reached.
'//
%SCARD_W_CHV_BLOCKED              = &H8010006C&

'//
'// MessageId: SCARD_W_EOF
'//
'// MessageText:
'//
'// The end of the smart card file has been reached.
'//
%SCARD_W_EOF                      = &H8010006D&

'//
'// MessageId: SCARD_W_CANCELLED_BY_USER
'//
'// MessageText:
'//
'// The action was cancelled by the user.
'//
%SCARD_W_CANCELLED_BY_USER        = &H8010006E&

'//
'// MessageId: SCARD_W_CARD_NOT_AUTHENTICATED
'//
'// MessageText:
'//
'// No PIN was presented to the smart card.
'//
%SCARD_W_CARD_NOT_AUTHENTICATED   = &H8010006F&

'//
'// MessageId: SCARD_W_CACHE_ITEM_NOT_FOUND
'//
'// MessageText:
'//
'// The requested item could not be found in the cache.
'//
%SCARD_W_CACHE_ITEM_NOT_FOUND     = &H80100070&

'//
'// MessageId: SCARD_W_CACHE_ITEM_STALE
'//
'// MessageText:
'//
'// The requested cache item is too old and was deleted from the cache.
'//
%SCARD_W_CACHE_ITEM_STALE         = &H80100071&

'//
'// MessageId: SCARD_W_CACHE_ITEM_TOO_BIG
'//
'// MessageText:
'//
'// The new cache item exceeds the maximum per-item size defined for the cache.
'//
%SCARD_W_CACHE_ITEM_TOO_BIG       = &H80100072&

'// *****************
'// FACILITY_COMPLUS
'// *****************
'//
'// = ==============================
'// Facility COMPLUS Error Messages
'// = ==============================
'//
'//
'// The following are the subranges  within the COMPLUS facility
'// 0x400 - 0x4ff               COMADMIN_E_CAT
'// 0x600 - 0x6ff               COMQC errors
'// 0x700 - 0x7ff               MSDTC errors
'// 0x800 - 0x8ff               Other COMADMIN errors
'//
'// COMPLUS Admin errors
'//
'//
'// MessageId: COMADMIN_E_OBJECTERRORS
'//
'// MessageText:
'//
'// Errors occurred accessing one or more objects - the ErrorInfo collection may have more detail
'//
%COMADMIN_E_OBJECTERRORS          = &H80110401&

'//
'// MessageId: COMADMIN_E_OBJECTINVALID
'//
'// MessageText:
'//
'// One or more of the object's properties are missing or invalid
'//
%COMADMIN_E_OBJECTINVALID         = &H80110402&

'//
'// MessageId: COMADMIN_E_KEYMISSING
'//
'// MessageText:
'//
'// The object was not found in the catalog
'//
%COMADMIN_E_KEYMISSING            = &H80110403&

'//
'// MessageId: COMADMIN_E_ALREADYINSTALLED
'//
'// MessageText:
'//
'// The object is already registered
'//
%COMADMIN_E_ALREADYINSTALLED      = &H80110404&

'//
'// MessageId: COMADMIN_E_APP_FILE_WRITEFAIL
'//
'// MessageText:
'//
'// Error occurred writing to the application file
'//
%COMADMIN_E_APP_FILE_WRITEFAIL    = &H80110407&

'//
'// MessageId: COMADMIN_E_APP_FILE_READFAIL
'//
'// MessageText:
'//
'// Error occurred reading the application file
'//
%COMADMIN_E_APP_FILE_READFAIL     = &H80110408&

'//
'// MessageId: COMADMIN_E_APP_FILE_VERSION
'//
'// MessageText:
'//
'// Invalid version number in application file
'//
%COMADMIN_E_APP_FILE_VERSION      = &H80110409&

'//
'// MessageId: COMADMIN_E_BADPATH
'//
'// MessageText:
'//
'// The file path is invalid
'//
%COMADMIN_E_BADPATH               = &H8011040A&

'//
'// MessageId: COMADMIN_E_APPLICATIONEXISTS
'//
'// MessageText:
'//
'// The application is already installed
'//
%COMADMIN_E_APPLICATIONEXISTS     = &H8011040B&

'//
'// MessageId: COMADMIN_E_ROLEEXISTS
'//
'// MessageText:
'//
'// The role already exists
'//
%COMADMIN_E_ROLEEXISTS            = &H8011040C&

'//
'// MessageId: COMADMIN_E_CANTCOPYFILE
'//
'// MessageText:
'//
'// An error occurred copying the file
'//
%COMADMIN_E_CANTCOPYFILE          = &H8011040D&

'//
'// MessageId: COMADMIN_E_NOUSER
'//
'// MessageText:
'//
'// One or more users are not valid
'//
%COMADMIN_E_NOUSER                = &H8011040F&

'//
'// MessageId: COMADMIN_E_INVALIDUSERIDS
'//
'// MessageText:
'//
'// One or more users in the application file are not valid
'//
%COMADMIN_E_INVALIDUSERIDS        = &H80110410&

'//
'// MessageId: COMADMIN_E_NOREGISTRYCLSID
'//
'// MessageText:
'//
'// The component's CLSID is missing or corrupt
'//
%COMADMIN_E_NOREGISTRYCLSID       = &H80110411&

'//
'// MessageId: COMADMIN_E_BADREGISTRYPROGID
'//
'// MessageText:
'//
'// The component's progID is missing or corrupt
'//
%COMADMIN_E_BADREGISTRYPROGID     = &H80110412&

'//
'// MessageId: COMADMIN_E_AUTHENTICATIONLEVEL
'//
'// MessageText:
'//
'// Unable to set required authentication level for update request
'//
%COMADMIN_E_AUTHENTICATIONLEVEL   = &H80110413&

'//
'// MessageId: COMADMIN_E_USERPASSWDNOTVALID
'//
'// MessageText:
'//
'// The identity or password set on the application is not valid
'//
%COMADMIN_E_USERPASSWDNOTVALID    = &H80110414&

'//
'// MessageId: COMADMIN_E_CLSIDORIIDMISMATCH
'//
'// MessageText:
'//
'// Application file CLSIDs or IIDs do not match corresponding DLLs
'//
%COMADMIN_E_CLSIDORIIDMISMATCH    = &H80110418&

'//
'// MessageId: COMADMIN_E_REMOTEINTERFACE
'//
'// MessageText:
'//
'// Interface information is either missing or changed
'//
%COMADMIN_E_REMOTEINTERFACE       = &H80110419&

'//
'// MessageId: COMADMIN_E_DLLREGISTERSERVER
'//
'// MessageText:
'//
'// DllRegisterServer failed on component install
'//
%COMADMIN_E_DLLREGISTERSERVER     = &H8011041A&

'//
'// MessageId: COMADMIN_E_NOSERVERSHARE
'//
'// MessageText:
'//
'// No server file share available
'//
%COMADMIN_E_NOSERVERSHARE         = &H8011041B&

'//
'// MessageId: COMADMIN_E_DLLLOADFAILED
'//
'// MessageText:
'//
'// DLL could not be loaded
'//
%COMADMIN_E_DLLLOADFAILED         = &H8011041D&

'//
'// MessageId: COMADMIN_E_BADREGISTRYLIBID
'//
'// MessageText:
'//
'// The registered TypeLib ID is not valid
'//
%COMADMIN_E_BADREGISTRYLIBID      = &H8011041E&

'//
'// MessageId: COMADMIN_E_APPDIRNOTFOUND
'//
'// MessageText:
'//
'// Application install directory not found
'//
%COMADMIN_E_APPDIRNOTFOUND        = &H8011041F&

'//
'// MessageId: COMADMIN_E_REGISTRARFAILED
'//
'// MessageText:
'//
'// Errors occurred while in the component registrar
'//
%COMADMIN_E_REGISTRARFAILED       = &H80110423&

'//
'// MessageId: COMADMIN_E_COMPFILE_DOESNOTEXIST
'//
'// MessageText:
'//
'// The file does not exist
'//
%COMADMIN_E_COMPFILE_DOESNOTEXIST = &H80110424&

'//
'// MessageId: COMADMIN_E_COMPFILE_LOADDLLFAIL
'//
'// MessageText:
'//
'// The DLL could not be loaded
'//
%COMADMIN_E_COMPFILE_LOADDLLFAIL  = &H80110425&

'//
'// MessageId: COMADMIN_E_COMPFILE_GETCLASSOBJ
'//
'// MessageText:
'//
'// GetClassObject failed in the DLL
'//
%COMADMIN_E_COMPFILE_GETCLASSOBJ  = &H80110426&

'//
'// MessageId: COMADMIN_E_COMPFILE_CLASSNOTAVAIL
'//
'// MessageText:
'//
'// The DLL does not support the components listed in the TypeLib
'//
%COMADMIN_E_COMPFILE_CLASSNOTAVAIL = &H80110427&

'//
'// MessageId: COMADMIN_E_COMPFILE_BADTLB
'//
'// MessageText:
'//
'// The TypeLib could not be loaded
'//
%COMADMIN_E_COMPFILE_BADTLB       = &H80110428&

'//
'// MessageId: COMADMIN_E_COMPFILE_NOTINSTALLABLE
'//
'// MessageText:
'//
'// The file does not contain components or component information
'//
%COMADMIN_E_COMPFILE_NOTINSTALLABLE = &H80110429&

'//
'// MessageId: COMADMIN_E_NOTCHANGEABLE
'//
'// MessageText:
'//
'// Changes to this object and its sub-objects have been disabled
'//
%COMADMIN_E_NOTCHANGEABLE         = &H8011042A&

'//
'// MessageId: COMADMIN_E_NOTDELETEABLE
'//
'// MessageText:
'//
'// The delete function has been disabled for this object
'//
%COMADMIN_E_NOTDELETEABLE         = &H8011042B&

'//
'// MessageId: COMADMIN_E_SESSION
'//
'// MessageText:
'//
'// The server catalog version is not supported
'//
%COMADMIN_E_SESSION               = &H8011042C&

'//
'// MessageId: COMADMIN_E_COMP_MOVE_LOCKED
'//
'// MessageText:
'//
'// The component move was disallowed, because the source or destination application is either a system application or currently locked against changes
'//
%COMADMIN_E_COMP_MOVE_LOCKED      = &H8011042D&

'//
'// MessageId: COMADMIN_E_COMP_MOVE_BAD_DEST
'//
'// MessageText:
'//
'// The component move failed because the destination application no longer exists
'//
%COMADMIN_E_COMP_MOVE_BAD_DEST    = &H8011042E&

'//
'// MessageId: COMADMIN_E_REGISTERTLB
'//
'// MessageText:
'//
'// The system was unable to register the TypeLib
'//
%COMADMIN_E_REGISTERTLB           = &H80110430&

'//
'// MessageId: COMADMIN_E_SYSTEMAPP
'//
'// MessageText:
'//
'// This operation cannot be performed on the system application
'//
%COMADMIN_E_SYSTEMAPP             = &H80110433&

'//
'// MessageId: COMADMIN_E_COMPFILE_NOREGISTRAR
'//
'// MessageText:
'//
'// The component registrar referenced in this file is not available
'//
%COMADMIN_E_COMPFILE_NOREGISTRAR  = &H80110434&

'//
'// MessageId: COMADMIN_E_COREQCOMPINSTALLED
'//
'// MessageText:
'//
'// A component in the same DLL is already installed
'//
%COMADMIN_E_COREQCOMPINSTALLED    = &H80110435&

'//
'// MessageId: COMADMIN_E_SERVICENOTINSTALLED
'//
'// MessageText:
'//
'// The service is not installed
'//
%COMADMIN_E_SERVICENOTINSTALLED   = &H80110436&

'//
'// MessageId: COMADMIN_E_PROPERTYSAVEFAILED
'//
'// MessageText:
'//
'// One or more property settings are either invalid or in conflict with each other
'//
%COMADMIN_E_PROPERTYSAVEFAILED    = &H80110437&

'//
'// MessageId: COMADMIN_E_OBJECTEXISTS
'//
'// MessageText:
'//
'// The object you are attempting to add or rename already exists
'//
%COMADMIN_E_OBJECTEXISTS          = &H80110438&

'//
'// MessageId: COMADMIN_E_COMPONENTEXISTS
'//
'// MessageText:
'//
'// The component already exists
'//
%COMADMIN_E_COMPONENTEXISTS       = &H80110439&

'//
'// MessageId: COMADMIN_E_REGFILE_CORRUPT
'//
'// MessageText:
'//
'// The registration file is corrupt
'//
%COMADMIN_E_REGFILE_CORRUPT       = &H8011043B&

'//
'// MessageId: COMADMIN_E_PROPERTY_OVERFLOW
'//
'// MessageText:
'//
'// The property value is too large
'//
%COMADMIN_E_PROPERTY_OVERFLOW     = &H8011043C&

'//
'// MessageId: COMADMIN_E_NOTINREGISTRY
'//
'// MessageText:
'//
'// Object was not found in registry
'//
%COMADMIN_E_NOTINREGISTRY         = &H8011043E&

'//
'// MessageId: COMADMIN_E_OBJECTNOTPOOLABLE
'//
'// MessageText:
'//
'// This object is not poolable
'//
%COMADMIN_E_OBJECTNOTPOOLABLE     = &H8011043F&

'//
'// MessageId: COMADMIN_E_APPLID_MATCHES_CLSID
'//
'// MessageText:
'//
'// A CLSID with the same GUID as the new application ID is already installed on this machine
'//
%COMADMIN_E_APPLID_MATCHES_CLSID  = &H80110446&

'//
'// MessageId: COMADMIN_E_ROLE_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// A role assigned to a component, interface, or method did not exist in the application
'//
%COMADMIN_E_ROLE_DOES_NOT_EXIST   = &H80110447&

'//
'// MessageId: COMADMIN_E_START_APP_NEEDS_COMPONENTS
'//
'// MessageText:
'//
'// You must have components in an application in order to start the application
'//
%COMADMIN_E_START_APP_NEEDS_COMPONENTS = &H80110448&

'//
'// MessageId: COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM
'//
'// MessageText:
'//
'// This operation is not enabled on this platform
'//
%COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM = &H80110449&

'//
'// MessageId: COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY
'//
'// MessageText:
'//
'// Application Proxy is not exportable
'//
%COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY = &H8011044A&

'//
'// MessageId: COMADMIN_E_CAN_NOT_START_APP
'//
'// MessageText:
'//
'// Failed to start application because it is either a library application or an application proxy
'//
%COMADMIN_E_CAN_NOT_START_APP     = &H8011044B&

'//
'// MessageId: COMADMIN_E_CAN_NOT_EXPORT_SYS_APP
'//
'// MessageText:
'//
'// System application is not exportable
'//
%COMADMIN_E_CAN_NOT_EXPORT_SYS_APP = &H8011044C&

'//
'// MessageId: COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT
'//
'// MessageText:
'//
'// Cannot subscribe to this component (the component may have been imported)
'//
%COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT = &H8011044D&

'//
'// MessageId: COMADMIN_E_EVENTCLASS_CANT_BE_SUBSCRIBER
'//
'// MessageText:
'//
'// An event class cannot also be a subscriber component
'//
%COMADMIN_E_EVENTCLASS_CANT_BE_SUBSCRIBER = &H8011044E&

'//
'// MessageId: COMADMIN_E_LIB_APP_PROXY_INCOMPATIBLE
'//
'// MessageText:
'//
'// Library applications and application proxies are incompatible
'//
%COMADMIN_E_LIB_APP_PROXY_INCOMPATIBLE = &H8011044F&

'//
'// MessageId: COMADMIN_E_BASE_PARTITION_ONLY
'//
'// MessageText:
'//
'// This function is valid for the base partition only
'//
%COMADMIN_E_BASE_PARTITION_ONLY   = &H80110450&

'//
'// MessageId: COMADMIN_E_START_APP_DISABLED
'//
'// MessageText:
'//
'// You cannot start an application that has been disabled
'//
%COMADMIN_E_START_APP_DISABLED    = &H80110451&

'//
'// MessageId: COMADMIN_E_CAT_DUPLICATE_PARTITION_NAME
'//
'// MessageText:
'//
'// The specified partition name is already in use on this computer
'//
%COMADMIN_E_CAT_DUPLICATE_PARTITION_NAME = &H80110457&

'//
'// MessageId: COMADMIN_E_CAT_INVALID_PARTITION_NAME
'//
'// MessageText:
'//
'// The specified partition name is invalid. Check that the name contains at least one visible character
'//
%COMADMIN_E_CAT_INVALID_PARTITION_NAME = &H80110458&

'//
'// MessageId: COMADMIN_E_CAT_PARTITION_IN_USE
'//
'// MessageText:
'//
'// The partition cannot be deleted because it is the default partition for one or more users
'//
%COMADMIN_E_CAT_PARTITION_IN_USE  = &H80110459&

'//
'// MessageId: COMADMIN_E_FILE_PARTITION_DUPLICATE_FILES
'//
'// MessageText:
'//
'// The partition cannot be exported, because one or more components in the partition have the same file name
'//
%COMADMIN_E_FILE_PARTITION_DUPLICATE_FILES = &H8011045A&

'//
'// MessageId: COMADMIN_E_CAT_IMPORTED_COMPONENTS_NOT_ALLOWED
'//
'// MessageText:
'//
'// Applications that contain one or more imported components cannot be installed into a non-base partition
'//
%COMADMIN_E_CAT_IMPORTED_COMPONENTS_NOT_ALLOWED = &H8011045B&

'//
'// MessageId: COMADMIN_E_AMBIGUOUS_APPLICATION_NAME
'//
'// MessageText:
'//
'// The application name is not unique and cannot be resolved to an application id
'//
%COMADMIN_E_AMBIGUOUS_APPLICATION_NAME = &H8011045C&

'//
'// MessageId: COMADMIN_E_AMBIGUOUS_PARTITION_NAME
'//
'// MessageText:
'//
'// The partition name is not unique and cannot be resolved to a partition id
'//
%COMADMIN_E_AMBIGUOUS_PARTITION_NAME = &H8011045D&

'//
'// MessageId: COMADMIN_E_REGDB_NOTINITIALIZED
'//
'// MessageText:
'//
'// The COM+ registry database has not been initialized
'//
%COMADMIN_E_REGDB_NOTINITIALIZED  = &H80110472&

'//
'// MessageId: COMADMIN_E_REGDB_NOTOPEN
'//
'// MessageText:
'//
'// The COM+ registry database is not open
'//
%COMADMIN_E_REGDB_NOTOPEN         = &H80110473&

'//
'// MessageId: COMADMIN_E_REGDB_SYSTEMERR
'//
'// MessageText:
'//
'// The COM+ registry database detected a system error
'//
%COMADMIN_E_REGDB_SYSTEMERR       = &H80110474&

'//
'// MessageId: COMADMIN_E_REGDB_ALREADYRUNNING
'//
'// MessageText:
'//
'// The COM+ registry database is already running
'//
%COMADMIN_E_REGDB_ALREADYRUNNING  = &H80110475&

'//
'// MessageId: COMADMIN_E_MIG_VERSIONNOTSUPPORTED
'//
'// MessageText:
'//
'// This version of the COM+ registry database cannot be migrated
'//
%COMADMIN_E_MIG_VERSIONNOTSUPPORTED = &H80110480&

'//
'// MessageId: COMADMIN_E_MIG_SCHEMANOTFOUND
'//
'// MessageText:
'//
'// The schema version to be migrated could not be found in the COM+ registry database
'//
%COMADMIN_E_MIG_SCHEMANOTFOUND    = &H80110481&

'//
'// MessageId: COMADMIN_E_CAT_BITNESSMISMATCH
'//
'// MessageText:
'//
'// There was a type mismatch between binaries
'//
%COMADMIN_E_CAT_BITNESSMISMATCH   = &H80110482&

'//
'// MessageId: COMADMIN_E_CAT_UNACCEPTABLEBITNESS
'//
'// MessageText:
'//
'// A binary of unknown or invalid type was provided
'//
%COMADMIN_E_CAT_UNACCEPTABLEBITNESS = &H80110483&

'//
'// MessageId: COMADMIN_E_CAT_WRONGAPPBITNESS
'//
'// MessageText:
'//
'// There was a type mismatch between a binary and an application
'//
%COMADMIN_E_CAT_WRONGAPPBITNESS   = &H80110484&

'//
'// MessageId: COMADMIN_E_CAT_PAUSE_RESUME_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The application cannot be paused or resumed
'//
%COMADMIN_E_CAT_PAUSE_RESUME_NOT_SUPPORTED = &H80110485&

'//
'// MessageId: COMADMIN_E_CAT_SERVERFAULT
'//
'// MessageText:
'//
'// The COM+ Catalog Server threw an exception during execution
'//
%COMADMIN_E_CAT_SERVERFAULT       = &H80110486&

'//
'// COMPLUS Queued component errors
'//
'//
'// MessageId: COMQC_E_APPLICATION_NOT_QUEUED
'//
'// MessageText:
'//
'// Only COM+ Applications marked "queued" can be invoked using the "queue" moniker
'//
%COMQC_E_APPLICATION_NOT_QUEUED   = &H80110600&

'//
'// MessageId: COMQC_E_NO_QUEUEABLE_INTERFACES
'//
'// MessageText:
'//
'// At least one interface must be marked "queued" in order to create a queued component instance with the "queue" moniker
'//
%COMQC_E_NO_QUEUEABLE_INTERFACES  = &H80110601&

'//
'// MessageId: COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE
'//
'// MessageText:
'//
'// MSMQ is required for the requested operation and is not installed
'//
%COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE = &H80110602&

'//
'// MessageId: COMQC_E_NO_IPERSISTSTREAM
'//
'// MessageText:
'//
'// Unable to marshal an interface that does not support IPersistStream
'//
%COMQC_E_NO_IPERSISTSTREAM        = &H80110603&

'//
'// MessageId: COMQC_E_BAD_MESSAGE
'//
'// MessageText:
'//
'// The message is improperly formatted or was damaged in transit
'//
%COMQC_E_BAD_MESSAGE              = &H80110604&

'//
'// MessageId: COMQC_E_UNAUTHENTICATED
'//
'// MessageText:
'//
'// An unauthenticated message was received by an application that accepts only authenticated messages
'//
%COMQC_E_UNAUTHENTICATED          = &H80110605&

'//
'// MessageId: COMQC_E_UNTRUSTED_ENQUEUER
'//
'// MessageText:
'//
'// The message was requeued or moved by a user not in the "QC Trusted User" role
'//
%COMQC_E_UNTRUSTED_ENQUEUER       = &H80110606&

'//
'// The range 0x700-0x7ff is reserved for MSDTC errors.
'//
'//
'// MessageId: MSDTC_E_DUPLICATE_RESOURCE
'//
'// MessageText:
'//
'// Cannot create a duplicate resource of type Distributed Transaction Coordinator
'//
%MSDTC_E_DUPLICATE_RESOURCE       = &H80110701&

'//
'// More COMADMIN errors from 0x8**
'//
'//
'// MessageId: COMADMIN_E_OBJECT_PARENT_MISSING
'//
'// MessageText:
'//
'// One of the objects being inserted or updated does not belong to a valid parent collection
'//
%COMADMIN_E_OBJECT_PARENT_MISSING = &H80110808&

'//
'// MessageId: COMADMIN_E_OBJECT_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// One of the specified objects cannot be found
'//
%COMADMIN_E_OBJECT_DOES_NOT_EXIST = &H80110809&

'//
'// MessageId: COMADMIN_E_APP_NOT_RUNNING
'//
'// MessageText:
'//
'// The specified application is not currently running
'//
%COMADMIN_E_APP_NOT_RUNNING       = &H8011080A&

'//
'// MessageId: COMADMIN_E_INVALID_PARTITION
'//
'// MessageText:
'//
'// The partition(s) specified are not valid.
'//
%COMADMIN_E_INVALID_PARTITION     = &H8011080B&

'//
'// MessageId: COMADMIN_E_SVCAPP_NOT_POOLABLE_OR_RECYCLABLE
'//
'// MessageText:
'//
'// COM+ applications that run as NT service may not be pooled or recycled
'//
%COMADMIN_E_SVCAPP_NOT_POOLABLE_OR_RECYCLABLE = &H8011080D&

'//
'// MessageId: COMADMIN_E_USER_IN_SET
'//
'// MessageText:
'//
'// One or more users are already assigned to a local partition set.
'//
%COMADMIN_E_USER_IN_SET           = &H8011080E&

'//
'// MessageId: COMADMIN_E_CANTRECYCLELIBRARYAPPS
'//
'// MessageText:
'//
'// Library applications may not be recycled.
'//
%COMADMIN_E_CANTRECYCLELIBRARYAPPS = &H8011080F&

'//
'// MessageId: COMADMIN_E_CANTRECYCLESERVICEAPPS
'//
'// MessageText:
'//
'// Applications running as NT services may not be recycled.
'//
%COMADMIN_E_CANTRECYCLESERVICEAPPS = &H80110811&

'//
'// MessageId: COMADMIN_E_PROCESSALREADYRECYCLED
'//
'// MessageText:
'//
'// The process has already been recycled.
'//
%COMADMIN_E_PROCESSALREADYRECYCLED = &H80110812&

'//
'// MessageId: COMADMIN_E_PAUSEDPROCESSMAYNOTBERECYCLED
'//
'// MessageText:
'//
'// A paused process may not be recycled.
'//
%COMADMIN_E_PAUSEDPROCESSMAYNOTBERECYCLED = &H80110813&

'//
'// MessageId: COMADMIN_E_CANTMAKEINPROCSERVICE
'//
'// MessageText:
'//
'// Library applications may not be NT services.
'//
%COMADMIN_E_CANTMAKEINPROCSERVICE = &H80110814&

'//
'// MessageId: COMADMIN_E_PROGIDINUSEBYCLSID
'//
'// MessageText:
'//
'// The ProgID provided to the copy operation is invalid. The ProgID is in use by another registered CLSID.
'//
%COMADMIN_E_PROGIDINUSEBYCLSID    = &H80110815&

'//
'// MessageId: COMADMIN_E_DEFAULT_PARTITION_NOT_IN_SET
'//
'// MessageText:
'//
'// The partition specified as default is not a member of the partition set.
'//
%COMADMIN_E_DEFAULT_PARTITION_NOT_IN_SET = &H80110816&

'//
'// MessageId: COMADMIN_E_RECYCLEDPROCESSMAYNOTBEPAUSED
'//
'// MessageText:
'//
'// A recycled process may not be paused.
'//
%COMADMIN_E_RECYCLEDPROCESSMAYNOTBEPAUSED = &H80110817&

'//
'// MessageId: COMADMIN_E_PARTITION_ACCESSDENIED
'//
'// MessageText:
'//
'// Access to the specified partition is denied.
'//
%COMADMIN_E_PARTITION_ACCESSDENIED = &H80110818&

'//
'// MessageId: COMADMIN_E_PARTITION_MSI_ONLY
'//
'// MessageText:
'//
'// Only Application Files (*.MSI files) can be installed into partitions.
'//
%COMADMIN_E_PARTITION_MSI_ONLY    = &H80110819&

'//
'// MessageId: COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_1_0_FORMAT
'//
'// MessageText:
'//
'// Applications containing one or more legacy components may not be exported to 1.0 format.
'//
%COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_1_0_FORMAT = &H8011081A&

'//
'// MessageId: COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_NONBASE_PARTITIONS
'//
'// MessageText:
'//
'// Legacy components may not exist in non-base partitions.
'//
%COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_NONBASE_PARTITIONS = &H8011081B&

'//
'// MessageId: COMADMIN_E_COMP_MOVE_SOURCE
'//
'// MessageText:
'//
'// A component cannot be moved (or copied) from the System Application, an application proxy or a non-changeable application
'//
%COMADMIN_E_COMP_MOVE_SOURCE      = &H8011081C&

'//
'// MessageId: COMADMIN_E_COMP_MOVE_DEST
'//
'// MessageText:
'//
'// A component cannot be moved (or copied) to the System Application, an application proxy or a non-changeable application
'//
%COMADMIN_E_COMP_MOVE_DEST        = &H8011081D&

'//
'// MessageId: COMADMIN_E_COMP_MOVE_PRIVATE
'//
'// MessageText:
'//
'// A private component cannot be moved (or copied) to a library application or to the base partition
'//
%COMADMIN_E_COMP_MOVE_PRIVATE     = &H8011081E&

'//
'// MessageId: COMADMIN_E_BASEPARTITION_REQUIRED_IN_SET
'//
'// MessageText:
'//
'// The Base Application Partition exists in all partition sets and cannot be removed.
'//
%COMADMIN_E_BASEPARTITION_REQUIRED_IN_SET = &H8011081F&

'//
'// MessageId: COMADMIN_E_CANNOT_ALIAS_EVENTCLASS
'//
'// MessageText:
'//
'// Alas, Event Class components cannot be aliased.
'//
%COMADMIN_E_CANNOT_ALIAS_EVENTCLASS = &H80110820&

'//
'// MessageId: COMADMIN_E_PRIVATE_ACCESSDENIED
'//
'// MessageText:
'//
'// Access is denied because the component is private.
'//
%COMADMIN_E_PRIVATE_ACCESSDENIED  = &H80110821&

'//
'// MessageId: COMADMIN_E_SAFERINVALID
'//
'// MessageText:
'//
'// The specified SAFER level is invalid.
'//
%COMADMIN_E_SAFERINVALID          = &H80110822&

'//
'// MessageId: COMADMIN_E_REGISTRY_ACCESSDENIED
'//
'// MessageText:
'//
'// The specified user cannot write to the system registry
'//
%COMADMIN_E_REGISTRY_ACCESSDENIED = &H80110823&

'//
'// MessageId: COMADMIN_E_PARTITIONS_DISABLED
'//
'// MessageText:
'//
'// COM+ partitions are currently disabled.
'//
%COMADMIN_E_PARTITIONS_DISABLED   = &H80110824&

'// ***********************
'// FACILITY_USERMODE_FILTER_MANAGER
'// ***********************
'//
'//  Translation macro for converting:
'//     NTSTATUS  --> HRESULT
'//
'#define FILTER_HRESULT_FROM_FLT_NTSTATUS(x) ((HRESULT) (((x) & 0x8000FFFF) | (FACILITY_USERMODE_FILTER_MANAGER << 16)))

'    FUNCTION FILTER_HRESULT_FROM_FLT_NTSTATUS (BYVAL x AS LONG) AS LONG
'      FUNCTION =  BITS(LONG, (x AND &H8000FFFF???) OR (%FACILITY_USERMODE_FILTER_MANAGER * &H10000))
'    END FUNCTION

'//
'// MessageId: ERROR_FLT_IO_COMPLETE
'//
'// MessageText:
'//
'// The IO was completed by a filter.
'//
%ERROR_FLT_IO_COMPLETE            = &H001F0001&

'//
'// MessageId: ERROR_FLT_NO_HANDLER_DEFINED
'//
'// MessageText:
'//
'// A handler was not defined by the filter for this operation.
'//
%ERROR_FLT_NO_HANDLER_DEFINED     = &H801F0001&

'//
'// MessageId: ERROR_FLT_CONTEXT_ALREADY_DEFINED
'//
'// MessageText:
'//
'// A context is already defined for this object.
'//
%ERROR_FLT_CONTEXT_ALREADY_DEFINED = &H801F0002&

'//
'// MessageId: ERROR_FLT_INVALID_ASYNCHRONOUS_REQUEST
'//
'// MessageText:
'//
'// Asynchronous requests are not valid for this operation.
'//
%ERROR_FLT_INVALID_ASYNCHRONOUS_REQUEST = &H801F0003&

'//
'// MessageId: ERROR_FLT_DISALLOW_FAST_IO
'//
'// MessageText:
'//
'// Disallow the Fast IO path for this operation.
'//
%ERROR_FLT_DISALLOW_FAST_IO       = &H801F0004&

'//
'// MessageId: ERROR_FLT_INVALID_NAME_REQUEST
'//
'// MessageText:
'//
'// An invalid name request was made. The name requested cannot be retrieved at this time.
'//
%ERROR_FLT_INVALID_NAME_REQUEST   = &H801F0005&

'//
'// MessageId: ERROR_FLT_NOT_SAFE_TO_POST_OPERATION
'//
'// MessageText:
'//
'// Posting this operation to a worker thread for further processing is not safe at this time because it could lead to a system deadlock.
'//
%ERROR_FLT_NOT_SAFE_TO_POST_OPERATION = &H801F0006&

'//
'// MessageId: ERROR_FLT_NOT_INITIALIZED
'//
'// MessageText:
'//
'// The Filter Manager was not initialized when a filter tried to register. Make sure that the Filter Manager is getting loaded as a driver.
'//
%ERROR_FLT_NOT_INITIALIZED        = &H801F0007&

'//
'// MessageId: ERROR_FLT_FILTER_NOT_READY
'//
'// MessageText:
'//
'// The filter is not ready for attachment to volumes because it has not finished initializing (FltStartFiltering has not been called).
'//
%ERROR_FLT_FILTER_NOT_READY       = &H801F0008&

'//
'// MessageId: ERROR_FLT_POST_OPERATION_CLEANUP
'//
'// MessageText:
'//
'// The filter must cleanup any operation specific context at this time because it is being removed from the system before the operation is completed by the lower drivers.
'//
%ERROR_FLT_POST_OPERATION_CLEANUP = &H801F0009&

'//
'// MessageId: ERROR_FLT_INTERNAL_ERROR
'//
'// MessageText:
'//
'// The Filter Manager had an internal error from which it cannot recover, therefore the operation has been failed. This is usually the result of a filter returning an invalid value from a pre-operation callback.
'//
%ERROR_FLT_INTERNAL_ERROR         = &H801F000A&

'//
'// MessageId: ERROR_FLT_DELETING_OBJECT
'//
'// MessageText:
'//
'// The object specified for this action is in the process of being deleted, therefore the action requested cannot be completed at this time.
'//
%ERROR_FLT_DELETING_OBJECT        = &H801F000B&

'//
'// MessageId: ERROR_FLT_MUST_BE_NONPAGED_POOL
'//
'// MessageText:
'//
'// Non-paged pool must be used for this type of context.
'//
%ERROR_FLT_MUST_BE_NONPAGED_POOL  = &H801F000C&

'//
'// MessageId: ERROR_FLT_DUPLICATE_ENTRY
'//
'// MessageText:
'//
'// A duplicate handler definition has been provided for an operation.
'//
%ERROR_FLT_DUPLICATE_ENTRY        = &H801F000D&

'//
'// MessageId: ERROR_FLT_CBDQ_DISABLED
'//
'// MessageText:
'//
'// The callback data queue has been disabled.
'//
%ERROR_FLT_CBDQ_DISABLED          = &H801F000E&

'//
'// MessageId: ERROR_FLT_DO_NOT_ATTACH
'//
'// MessageText:
'//
'// Do not attach the filter to the volume at this time.
'//
%ERROR_FLT_DO_NOT_ATTACH          = &H801F000F&

'//
'// MessageId: ERROR_FLT_DO_NOT_DETACH
'//
'// MessageText:
'//
'// Do not detach the filter from the volume at this time.
'//
%ERROR_FLT_DO_NOT_DETACH          = &H801F0010&

'//
'// MessageId: ERROR_FLT_INSTANCE_ALTITUDE_COLLISION
'//
'// MessageText:
'//
'// An instance already exists at this altitude on the volume specified.
'//
%ERROR_FLT_INSTANCE_ALTITUDE_COLLISION = &H801F0011&

'//
'// MessageId: ERROR_FLT_INSTANCE_NAME_COLLISION
'//
'// MessageText:
'//
'// An instance already exists with this name on the volume specified.
'//
%ERROR_FLT_INSTANCE_NAME_COLLISION = &H801F0012&

'//
'// MessageId: ERROR_FLT_FILTER_NOT_FOUND
'//
'// MessageText:
'//
'// The system could not find the filter specified.
'//
%ERROR_FLT_FILTER_NOT_FOUND       = &H801F0013&

'//
'// MessageId: ERROR_FLT_VOLUME_NOT_FOUND
'//
'// MessageText:
'//
'// The system could not find the volume specified.
'//
%ERROR_FLT_VOLUME_NOT_FOUND       = &H801F0014&

'//
'// MessageId: ERROR_FLT_INSTANCE_NOT_FOUND
'//
'// MessageText:
'//
'// The system could not find the instance specified.
'//
%ERROR_FLT_INSTANCE_NOT_FOUND     = &H801F0015&

'//
'// MessageId: ERROR_FLT_CONTEXT_ALLOCATION_NOT_FOUND
'//
'// MessageText:
'//
'// No registered context allocation definition was found for the given request.
'//
%ERROR_FLT_CONTEXT_ALLOCATION_NOT_FOUND = &H801F0016&

'//
'// MessageId: ERROR_FLT_INVALID_CONTEXT_REGISTRATION
'//
'// MessageText:
'//
'// An invalid parameter was specified during context registration.
'//
%ERROR_FLT_INVALID_CONTEXT_REGISTRATION = &H801F0017&

'//
'// MessageId: ERROR_FLT_NAME_CACHE_MISS
'//
'// MessageText:
'//
'// The name requested was not found in Filter Manager's name cache and could not be retrieved from the file system.
'//
%ERROR_FLT_NAME_CACHE_MISS        = &H801F0018&

'//
'// MessageId: ERROR_FLT_NO_DEVICE_OBJECT
'//
'// MessageText:
'//
'// The requested device object does not exist for the given volume.
'//
%ERROR_FLT_NO_DEVICE_OBJECT       = &H801F0019&

'//
'// MessageId: ERROR_FLT_VOLUME_ALREADY_MOUNTED
'//
'// MessageText:
'//
'// The specified volume is already mounted.
'//
%ERROR_FLT_VOLUME_ALREADY_MOUNTED = &H801F001A&

'//
'// MessageId: ERROR_FLT_ALREADY_ENLISTED
'//
'// MessageText:
'//
'// The specified Transaction Context is already enlisted in a transaction
'//
%ERROR_FLT_ALREADY_ENLISTED       = &H801F001B&

'//
'// MessageId: ERROR_FLT_CONTEXT_ALREADY_LINKED
'//
'// MessageText:
'//
'// The specifiec context is already attached to another object
'//
%ERROR_FLT_CONTEXT_ALREADY_LINKED = &H801F001C&

'//
'// MessageId: ERROR_FLT_NO_WAITER_FOR_REPLY
'//
'// MessageText:
'//
'// No waiter is present for the filter's reply to this message.
'//
%ERROR_FLT_NO_WAITER_FOR_REPLY    = &H801F0020&

'//
'// = ==============================
'// Facility Graphics Error Messages
'// = ==============================
'//
'//
'// The following are the subranges within the Graphics facility
'//
'// 0x0000 - 0x0fff     Display Driver Loader driver & Video Port errors (displdr.sys, videoprt.sys)
'// 0x1000 - 0x1fff     Monitor Class Function driver errors             (monitor.sys)
'// 0x2000 - 0x2fff     Windows Graphics Kernel Subsystem errors         (dxgkrnl.sys)
'// 0x3000 - 0x3fff               Desktop Window Manager errors
'//   0x2000 - 0x20ff      Common errors
'//   0x2100 - 0x21ff      Video Memory Manager (VidMM) subsystem errors
'//   0x2200 - 0x22ff      Video GPU Scheduler (VidSch) subsystem errors
'//   0x2300 - 0x23ff      Video Display Mode Management (VidDMM) subsystem errors
'//
'// Display Driver Loader driver & Video Port errors {0x0000..0x0fff}
'//
'//
'// MessageId: ERROR_HUNG_DISPLAY_DRIVER_THREAD
'//
'// MessageText:
'//
'// {Display Driver Stopped Responding}
'// The %hs display driver has stopped working normally. Save your work and reboot the system to restore full display functionality.
'// The next time you reboot the machine a dialog will be displayed giving you a chance to report this failure to Microsoft.
'//
%ERROR_HUNG_DISPLAY_DRIVER_THREAD = &H80260001&

'//
'// Desktop Window Manager errors {0x3000..0x3fff}
'//
'//
'// MessageId: DWM_E_COMPOSITIONDISABLED
'//
'// MessageText:
'//
'// {Desktop composition is disabled}
'// The operation could not be completed because desktop composition is disabled.
'//
%DWM_E_COMPOSITIONDISABLED        = &H80263001&

'//
'// MessageId: DWM_E_REMOTING_NOT_SUPPORTED
'//
'// MessageText:
'//
'// {Some desktop composition APIs are not supported while remoting}
'// The operation is not supported while running in a remote session.
'//
%DWM_E_REMOTING_NOT_SUPPORTED     = &H80263002&

'//
'// MessageId: DWM_E_NO_REDIRECTION_SURFACE_AVAILABLE
'//
'// MessageText:
'//
'// {No DWM redirection surface is available}
'// The DWM was unable to provide a redireciton surface to complete the DirectX present.
'//
%DWM_E_NO_REDIRECTION_SURFACE_AVAILABLE = &H80263003&

'//
'// MessageId: DWM_E_NOT_QUEUING_PRESENTS
'//
'// MessageText:
'//
'// {DWM is not queuing presents for the specified window}
'// The window specified is not currently using queued presents.
'//
%DWM_E_NOT_QUEUING_PRESENTS       = &H80263004&

'//
'// Monitor class function driver errors {0x1000..0x1fff}
'//
'//
'// MessageId: ERROR_MONITOR_NO_DESCRIPTOR
'//
'// MessageText:
'//
'// Monitor descriptor could not be obtained.
'//
%ERROR_MONITOR_NO_DESCRIPTOR      = &H80261001&

'//
'// MessageId: ERROR_MONITOR_UNKNOWN_DESCRIPTOR_FORMAT
'//
'// MessageText:
'//
'// Format of the obtained monitor descriptor is not supported by this release.
'//
%ERROR_MONITOR_UNKNOWN_DESCRIPTOR_FORMAT = &H80261002&

'//
'// MessageId: ERROR_MONITOR_INVALID_DESCRIPTOR_CHECKSUM
'//
'// MessageText:
'//
'// Checksum of the obtained monitor descriptor is invalid.
'//
%ERROR_MONITOR_INVALID_DESCRIPTOR_CHECKSUM = &HC0261003&

'//
'// MessageId: ERROR_MONITOR_INVALID_STANDARD_TIMING_BLOCK
'//
'// MessageText:
'//
'// Monitor descriptor contains an invalid standard timing block.
'//
%ERROR_MONITOR_INVALID_STANDARD_TIMING_BLOCK = &HC0261004&

'//
'// MessageId: ERROR_MONITOR_WMI_DATABLOCK_REGISTRATION_FAILED
'//
'// MessageText:
'//
'// WMI data block registration failed for one of the MSMonitorClass WMI subclasses.
'//
%ERROR_MONITOR_WMI_DATABLOCK_REGISTRATION_FAILED = &HC0261005&

'//
'// MessageId: ERROR_MONITOR_INVALID_SERIAL_NUMBER_MONDSC_BLOCK
'//
'// MessageText:
'//
'// Provided monitor descriptor block is either corrupted or does not contain monitor's detailed serial number.
'//
%ERROR_MONITOR_INVALID_SERIAL_NUMBER_MONDSC_BLOCK = &HC0261006&

'//
'// MessageId: ERROR_MONITOR_INVALID_USER_FRIENDLY_MONDSC_BLOCK
'//
'// MessageText:
'//
'// Provided monitor descriptor block is either corrupted or does not contain monitor's user friendly name.
'//
%ERROR_MONITOR_INVALID_USER_FRIENDLY_MONDSC_BLOCK = &HC0261007&

'//
'// MessageId: ERROR_MONITOR_NO_MORE_DESCRIPTOR_DATA
'//
'// MessageText:
'//
'// There is no monitor descriptor data at the specified (offset, size) region.
'//
%ERROR_MONITOR_NO_MORE_DESCRIPTOR_DATA = &HC0261008&

'//
'// MessageId: ERROR_MONITOR_INVALID_DETAILED_TIMING_BLOCK
'//
'// MessageText:
'//
'// Monitor descriptor contains an invalid detailed timing block.
'//
%ERROR_MONITOR_INVALID_DETAILED_TIMING_BLOCK = &HC0261009&

'//
'// Windows Graphics Kernel Subsystem errors {0x2000..0x2fff}
'//
'// TODO: Add DXG Win32 errors here
'//
'// Common errors {0x2000..0x20ff}
'//
'//
'// MessageId: ERROR_GRAPHICS_NOT_EXCLUSIVE_MODE_OWNER
'//
'// MessageText:
'//
'// Exclusive mode ownership is needed to create unmanaged primary allocation.
'//
%ERROR_GRAPHICS_NOT_EXCLUSIVE_MODE_OWNER = &HC0262000&

'//
'// MessageId: ERROR_GRAPHICS_INSUFFICIENT_DMA_BUFFER
'//
'// MessageText:
'//
'// The driver needs more DMA buffer space in order to complete the requested operation.
'//
%ERROR_GRAPHICS_INSUFFICIENT_DMA_BUFFER = &HC0262001&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_DISPLAY_ADAPTER
'//
'// MessageText:
'//
'// Specified display adapter handle is invalid.
'//
%ERROR_GRAPHICS_INVALID_DISPLAY_ADAPTER = &HC0262002&

'//
'// MessageId: ERROR_GRAPHICS_ADAPTER_WAS_RESET
'//
'// MessageText:
'//
'// Specified display adapter and all of its state has been reset.
'//
%ERROR_GRAPHICS_ADAPTER_WAS_RESET = &HC0262003&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_DRIVER_MODEL
'//
'// MessageText:
'//
'// The driver stack doesn't match the expected driver model.
'//
%ERROR_GRAPHICS_INVALID_DRIVER_MODEL = &HC0262004&

'//
'// MessageId: ERROR_GRAPHICS_PRESENT_MODE_CHANGED
'//
'// MessageText:
'//
'// Present happened but ended up into the changed desktop mode
'//
%ERROR_GRAPHICS_PRESENT_MODE_CHANGED = &HC0262005&

'//
'// MessageId: ERROR_GRAPHICS_PRESENT_OCCLUDED
'//
'// MessageText:
'//
'// Nothing to present due to desktop occlusion
'//
%ERROR_GRAPHICS_PRESENT_OCCLUDED  = &HC0262006&

'//
'// MessageId: ERROR_GRAPHICS_PRESENT_DENIED
'//
'// MessageText:
'//
'// Not able to present due to denial of desktop access
'//
%ERROR_GRAPHICS_PRESENT_DENIED    = &HC0262007&

'//
'// MessageId: ERROR_GRAPHICS_CANNOTCOLORCONVERT
'//
'// MessageText:
'//
'// Not able to present with color convertion
'//
%ERROR_GRAPHICS_CANNOTCOLORCONVERT = &HC0262008&

'//
'// MessageId: ERROR_GRAPHICS_DRIVER_MISMATCH
'//
'// MessageText:
'//
'// The kernel driver detected a version mismatch between it and the user mode driver.
'//
%ERROR_GRAPHICS_DRIVER_MISMATCH   = &HC0262009&

'//
'// MessageId: ERROR_GRAPHICS_PARTIAL_DATA_POPULATED
'//
'// MessageText:
'//
'// Specified buffer is not big enough to contain entire requested dataset. Partial data populated upto the size of the buffer.
'// Caller needs to provide buffer of size as specified in the partially populated buffer's content (interface specific).
'//
%ERROR_GRAPHICS_PARTIAL_DATA_POPULATED = &H4026200A&

'//
'// Video Memory Manager (VidMM) subsystem errors {0x2100..0x21ff}
'//
'//
'// MessageId: ERROR_GRAPHICS_NO_VIDEO_MEMORY
'//
'// MessageText:
'//
'// Not enough video memory available to complete the operation.
'//
%ERROR_GRAPHICS_NO_VIDEO_MEMORY   = &HC0262100&

'//
'// MessageId: ERROR_GRAPHICS_CANT_LOCK_MEMORY
'//
'// MessageText:
'//
'// Couldn't probe and lock the underlying memory of an allocation.
'//
%ERROR_GRAPHICS_CANT_LOCK_MEMORY  = &HC0262101&

'//
'// MessageId: ERROR_GRAPHICS_ALLOCATION_BUSY
'//
'// MessageText:
'//
'// The allocation is currently busy.
'//
%ERROR_GRAPHICS_ALLOCATION_BUSY   = &HC0262102&

'//
'// MessageId: ERROR_GRAPHICS_TOO_MANY_REFERENCES
'//
'// MessageText:
'//
'// An object being referenced has reach the maximum reference count already and can't be reference further.
'//
%ERROR_GRAPHICS_TOO_MANY_REFERENCES = &HC0262103&

'//
'// MessageId: ERROR_GRAPHICS_TRY_AGAIN_LATER
'//
'// MessageText:
'//
'// A problem couldn't be solved due to some currently existing condition. The problem should be tried again later.
'//
%ERROR_GRAPHICS_TRY_AGAIN_LATER   = &HC0262104&

'//
'// MessageId: ERROR_GRAPHICS_TRY_AGAIN_NOW
'//
'// MessageText:
'//
'// A problem couldn't be solved due to some currently existing condition. The problem should be tried again immediately.
'//
%ERROR_GRAPHICS_TRY_AGAIN_NOW     = &HC0262105&

'//
'// MessageId: ERROR_GRAPHICS_ALLOCATION_INVALID
'//
'// MessageText:
'//
'// The allocation is invalid.
'//
%ERROR_GRAPHICS_ALLOCATION_INVALID = &HC0262106&

'//
'// MessageId: ERROR_GRAPHICS_UNSWIZZLING_APERTURE_UNAVAILABLE
'//
'// MessageText:
'//
'// No more unswizzling aperture are currently available.
'//
%ERROR_GRAPHICS_UNSWIZZLING_APERTURE_UNAVAILABLE = &HC0262107&

'//
'// MessageId: ERROR_GRAPHICS_UNSWIZZLING_APERTURE_UNSUPPORTED
'//
'// MessageText:
'//
'// The current allocation can't be unswizzled by an aperture.
'//
%ERROR_GRAPHICS_UNSWIZZLING_APERTURE_UNSUPPORTED = &HC0262108&

'//
'// MessageId: ERROR_GRAPHICS_CANT_EVICT_PINNED_ALLOCATION
'//
'// MessageText:
'//
'// The request failed because a pinned allocation can't be evicted.
'//
%ERROR_GRAPHICS_CANT_EVICT_PINNED_ALLOCATION = &HC0262109&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_ALLOCATION_USAGE
'//
'// MessageText:
'//
'// The allocation can't be used from it's current segment location for the specified operation.
'//
%ERROR_GRAPHICS_INVALID_ALLOCATION_USAGE = &HC0262110&

'//
'// MessageId: ERROR_GRAPHICS_CANT_RENDER_LOCKED_ALLOCATION
'//
'// MessageText:
'//
'// A locked allocation can't be used in the current command buffer.
'//
%ERROR_GRAPHICS_CANT_RENDER_LOCKED_ALLOCATION = &HC0262111&

'//
'// MessageId: ERROR_GRAPHICS_ALLOCATION_CLOSED
'//
'// MessageText:
'//
'// The allocation being referenced has been closed permanently.
'//
%ERROR_GRAPHICS_ALLOCATION_CLOSED = &HC0262112&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_ALLOCATION_INSTANCE
'//
'// MessageText:
'//
'// An invalid allocation instance is being referenced.
'//
%ERROR_GRAPHICS_INVALID_ALLOCATION_INSTANCE = &HC0262113&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_ALLOCATION_HANDLE
'//
'// MessageText:
'//
'// An invalid allocation handle is being referenced.
'//
%ERROR_GRAPHICS_INVALID_ALLOCATION_HANDLE = &HC0262114&

'//
'// MessageId: ERROR_GRAPHICS_WRONG_ALLOCATION_DEVICE
'//
'// MessageText:
'//
'// The allocation being referenced doesn't belong to the current device.
'//
%ERROR_GRAPHICS_WRONG_ALLOCATION_DEVICE = &HC0262115&

'//
'// MessageId: ERROR_GRAPHICS_ALLOCATION_CONTENT_LOST
'//
'// MessageText:
'//
'// The specified allocation lost its content.
'//
%ERROR_GRAPHICS_ALLOCATION_CONTENT_LOST = &HC0262116&

'//
'// Video GPU Scheduler (VidSch) subsystem errors {0x2200..0x22ff}
'//
'//
'// MessageId: ERROR_GRAPHICS_GPU_EXCEPTION_ON_DEVICE
'//
'// MessageText:
'//
'// GPU exception is detected on the given device. The device is not able to be scheduled.
'//
%ERROR_GRAPHICS_GPU_EXCEPTION_ON_DEVICE = &HC0262200&

'//
'// Video Present Network Management (VidPNMgr) subsystem errors {0x2300..0x23ff}
'//
'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDPN_TOPOLOGY
'//
'// MessageText:
'//
'// Specified VidPN topology is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDPN_TOPOLOGY = &HC0262300&

'//
'// MessageId: ERROR_GRAPHICS_VIDPN_TOPOLOGY_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Specified VidPN topology is valid but is not supported by this model of the display adapter.
'//
%ERROR_GRAPHICS_VIDPN_TOPOLOGY_NOT_SUPPORTED = &HC0262301&

'//
'// MessageId: ERROR_GRAPHICS_VIDPN_TOPOLOGY_CURRENTLY_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Specified VidPN topology is valid but is not supported by the display adapter at this time, due to current allocation of its resources.
'//
%ERROR_GRAPHICS_VIDPN_TOPOLOGY_CURRENTLY_NOT_SUPPORTED = &HC0262302&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDPN
'//
'// MessageText:
'//
'// Specified VidPN handle is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDPN     = &HC0262303&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE
'//
'// MessageText:
'//
'// Specified video present source is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE = &HC0262304&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_TARGET
'//
'// MessageText:
'//
'// Specified video present target is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_TARGET = &HC0262305&

'//
'// MessageId: ERROR_GRAPHICS_VIDPN_MODALITY_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Specified VidPN modality is not supported (e.g. at least two of the pinned modes are not cofunctiona&.
'//
%ERROR_GRAPHICS_VIDPN_MODALITY_NOT_SUPPORTED = &HC0262306&

'//
'// MessageId: ERROR_GRAPHICS_MODE_NOT_PINNED
'//
'// MessageText:
'//
'// No mode is pinned on the specified VidPN source/target.
'//
%ERROR_GRAPHICS_MODE_NOT_PINNED   = &H00262307&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDPN_SOURCEMODESET
'//
'// MessageText:
'//
'// Specified VidPN source mode set is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDPN_SOURCEMODESET = &HC0262308&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDPN_TARGETMODESET
'//
'// MessageText:
'//
'// Specified VidPN target mode set is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDPN_TARGETMODESET = &HC0262309&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_FREQUENCY
'//
'// MessageText:
'//
'// Specified video signal frequency is invalid.
'//
%ERROR_GRAPHICS_INVALID_FREQUENCY = &HC026230A&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_ACTIVE_REGION
'//
'// MessageText:
'//
'// Specified video signal active region is invalid.
'//
%ERROR_GRAPHICS_INVALID_ACTIVE_REGION = &HC026230B&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_TOTAL_REGION
'//
'// MessageText:
'//
'// Specified video signal total region is invalid.
'//
%ERROR_GRAPHICS_INVALID_TOTAL_REGION = &HC026230C&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE_MODE
'//
'// MessageText:
'//
'// Specified video present source mode is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE_MODE = &HC0262310&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_TARGET_MODE
'//
'// MessageText:
'//
'// Specified video present target mode is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDEO_PRESENT_TARGET_MODE = &HC0262311&

'//
'// MessageId: ERROR_GRAPHICS_PINNED_MODE_MUST_REMAIN_IN_SET
'//
'// MessageText:
'//
'// Pinned mode must remain in the set on VidPN's cofunctional modality enumeration.
'//
%ERROR_GRAPHICS_PINNED_MODE_MUST_REMAIN_IN_SET = &HC0262312&

'//
'// MessageId: ERROR_GRAPHICS_PATH_ALREADY_IN_TOPOLOGY
'//
'// MessageText:
'//
'// Specified video present path is already in VidPN's topology.
'//
%ERROR_GRAPHICS_PATH_ALREADY_IN_TOPOLOGY = &HC0262313&

'//
'// MessageId: ERROR_GRAPHICS_MODE_ALREADY_IN_MODESET
'//
'// MessageText:
'//
'// Specified mode is already in the mode set.
'//
%ERROR_GRAPHICS_MODE_ALREADY_IN_MODESET = &HC0262314&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDEOPRESENTSOURCESET
'//
'// MessageText:
'//
'// Specified video present source set is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDEOPRESENTSOURCESET = &HC0262315&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDEOPRESENTTARGETSET
'//
'// MessageText:
'//
'// Specified video present target set is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDEOPRESENTTARGETSET = &HC0262316&

'//
'// MessageId: ERROR_GRAPHICS_SOURCE_ALREADY_IN_SET
'//
'// MessageText:
'//
'// Specified video present source is already in the video present source set.
'//
%ERROR_GRAPHICS_SOURCE_ALREADY_IN_SET = &HC0262317&

'//
'// MessageId: ERROR_GRAPHICS_TARGET_ALREADY_IN_SET
'//
'// MessageText:
'//
'// Specified video present target is already in the video present target set.
'//
%ERROR_GRAPHICS_TARGET_ALREADY_IN_SET = &HC0262318&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDPN_PRESENT_PATH
'//
'// MessageText:
'//
'// Specified VidPN present path is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDPN_PRESENT_PATH = &HC0262319&

'//
'// MessageId: ERROR_GRAPHICS_NO_RECOMMENDED_VIDPN_TOPOLOGY
'//
'// MessageText:
'//
'// Miniport has no recommendation for augmentation of the specified VidPN's topology.
'//
%ERROR_GRAPHICS_NO_RECOMMENDED_VIDPN_TOPOLOGY = &HC026231A&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGESET
'//
'// MessageText:
'//
'// Specified monitor frequency range set is invalid.
'//
%ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGESET = &HC026231B&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE
'//
'// MessageText:
'//
'// Specified monitor frequency range is invalid.
'//
%ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE = &HC026231C&

'//
'// MessageId: ERROR_GRAPHICS_FREQUENCYRANGE_NOT_IN_SET
'//
'// MessageText:
'//
'// Specified frequency range is not in the specified monitor frequency range set.
'//
%ERROR_GRAPHICS_FREQUENCYRANGE_NOT_IN_SET = &HC026231D&

'//
'// MessageId: ERROR_GRAPHICS_NO_PREFERRED_MODE
'//
'// MessageText:
'//
'// Specified mode set does not specify preference for one of its modes.
'//
%ERROR_GRAPHICS_NO_PREFERRED_MODE = &H0026231E&

'//
'// MessageId: ERROR_GRAPHICS_FREQUENCYRANGE_ALREADY_IN_SET
'//
'// MessageText:
'//
'// Specified frequency range is already in the specified monitor frequency range set.
'//
%ERROR_GRAPHICS_FREQUENCYRANGE_ALREADY_IN_SET = &HC026231F&

'//
'// MessageId: ERROR_GRAPHICS_STALE_MODESET
'//
'// MessageText:
'//
'// Specified mode set is stale. Please reacquire the new mode set.
'//
%ERROR_GRAPHICS_STALE_MODESET     = &HC0262320&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MONITOR_SOURCEMODESET
'//
'// MessageText:
'//
'// Specified monitor source mode set is invalid.
'//
%ERROR_GRAPHICS_INVALID_MONITOR_SOURCEMODESET = &HC0262321&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MONITOR_SOURCE_MODE
'//
'// MessageText:
'//
'// Specified monitor source mode is invalid.
'//
%ERROR_GRAPHICS_INVALID_MONITOR_SOURCE_MODE = &HC0262322&

'//
'// MessageId: ERROR_GRAPHICS_NO_RECOMMENDED_FUNCTIONAL_VIDPN
'//
'// MessageText:
'//
'// Miniport does not have any recommendation regarding the request to provide a functional VidPN given the current display adapter configuration.
'//
%ERROR_GRAPHICS_NO_RECOMMENDED_FUNCTIONAL_VIDPN = &HC0262323&

'//
'// MessageId: ERROR_GRAPHICS_MODE_ID_MUST_BE_UNIQUE
'//
'// MessageText:
'//
'// ID of the specified mode is already used by another mode in the set.
'//
%ERROR_GRAPHICS_MODE_ID_MUST_BE_UNIQUE = &HC0262324&

'//
'// MessageId: ERROR_GRAPHICS_EMPTY_ADAPTER_MONITOR_MODE_SUPPORT_INTERSECTION
'//
'// MessageText:
'//
'// System failed to determine a mode that is supported by both the display adapter and the monitor connected to it.
'//
%ERROR_GRAPHICS_EMPTY_ADAPTER_MONITOR_MODE_SUPPORT_INTERSECTION = &HC0262325&

'//
'// MessageId: ERROR_GRAPHICS_VIDEO_PRESENT_TARGETS_LESS_THAN_SOURCES
'//
'// MessageText:
'//
'// Number of video present targets must be greater than or equal to the number of video present sources.
'//
%ERROR_GRAPHICS_VIDEO_PRESENT_TARGETS_LESS_THAN_SOURCES = &HC0262326&

'//
'// MessageId: ERROR_GRAPHICS_PATH_NOT_IN_TOPOLOGY
'//
'// MessageText:
'//
'// Specified present path is not in VidPN's topology.
'//
%ERROR_GRAPHICS_PATH_NOT_IN_TOPOLOGY = &HC0262327&

'//
'// MessageId: ERROR_GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_SOURCE
'//
'// MessageText:
'//
'// Display adapter must have at least one video present source.
'//
%ERROR_GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_SOURCE = &HC0262328&

'//
'// MessageId: ERROR_GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_TARGET
'//
'// MessageText:
'//
'// Display adapter must have at least one video present target.
'//
%ERROR_GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_TARGET = &HC0262329&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MONITORDESCRIPTORSET
'//
'// MessageText:
'//
'// Specified monitor descriptor set is invalid.
'//
%ERROR_GRAPHICS_INVALID_MONITORDESCRIPTORSET = &HC026232A&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MONITORDESCRIPTOR
'//
'// MessageText:
'//
'// Specified monitor descriptor is invalid.
'//
%ERROR_GRAPHICS_INVALID_MONITORDESCRIPTOR = &HC026232B&

'//
'// MessageId: ERROR_GRAPHICS_MONITORDESCRIPTOR_NOT_IN_SET
'//
'// MessageText:
'//
'// Specified descriptor is not in the specified monitor descriptor set.
'//
%ERROR_GRAPHICS_MONITORDESCRIPTOR_NOT_IN_SET = &HC026232C&

'//
'// MessageId: ERROR_GRAPHICS_MONITORDESCRIPTOR_ALREADY_IN_SET
'//
'// MessageText:
'//
'// Specified descriptor is already in the specified monitor descriptor set.
'//
%ERROR_GRAPHICS_MONITORDESCRIPTOR_ALREADY_IN_SET = &HC026232D&

'//
'// MessageId: ERROR_GRAPHICS_MONITORDESCRIPTOR_ID_MUST_BE_UNIQUE
'//
'// MessageText:
'//
'// ID of the specified monitor descriptor is already used by another descriptor in the set.
'//
%ERROR_GRAPHICS_MONITORDESCRIPTOR_ID_MUST_BE_UNIQUE = &HC026232E&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDPN_TARGET_SUBSET_TYPE
'//
'// MessageText:
'//
'// Specified video present target subset type is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDPN_TARGET_SUBSET_TYPE = &HC026232F&

'//
'// MessageId: ERROR_GRAPHICS_RESOURCES_NOT_RELATED
'//
'// MessageText:
'//
'// Two or more of the specified resources are not related to each other, as defined by the interface semantics.
'//
%ERROR_GRAPHICS_RESOURCES_NOT_RELATED = &HC0262330&

'//
'// MessageId: ERROR_GRAPHICS_SOURCE_ID_MUST_BE_UNIQUE
'//
'// MessageText:
'//
'// ID of the specified video present source is already used by another source in the set.
'//
%ERROR_GRAPHICS_SOURCE_ID_MUST_BE_UNIQUE = &HC0262331&

'//
'// MessageId: ERROR_GRAPHICS_TARGET_ID_MUST_BE_UNIQUE
'//
'// MessageText:
'//
'// ID of the specified video present target is already used by another target in the set.
'//
%ERROR_GRAPHICS_TARGET_ID_MUST_BE_UNIQUE = &HC0262332&

'//
'// MessageId: ERROR_GRAPHICS_NO_AVAILABLE_VIDPN_TARGET
'//
'// MessageText:
'//
'// Specified VidPN source cannot be used because there is no available VidPN target to connect it to.
'//
%ERROR_GRAPHICS_NO_AVAILABLE_VIDPN_TARGET = &HC0262333&

'//
'// MessageId: ERROR_GRAPHICS_MONITOR_COULD_NOT_BE_ASSOCIATED_WITH_ADAPTER
'//
'// MessageText:
'//
'// Newly arrived monitor could not be associated with a display adapter.
'//
%ERROR_GRAPHICS_MONITOR_COULD_NOT_BE_ASSOCIATED_WITH_ADAPTER = &HC0262334&

'//
'// MessageId: ERROR_GRAPHICS_NO_VIDPNMGR
'//
'// MessageText:
'//
'// Display adapter in question does not have an associated VidPN manager.
'//
%ERROR_GRAPHICS_NO_VIDPNMGR       = &HC0262335&

'//
'// MessageId: ERROR_GRAPHICS_NO_ACTIVE_VIDPN
'//
'// MessageText:
'//
'// VidPN manager of the display adapter in question does not have an active VidPN.
'//
%ERROR_GRAPHICS_NO_ACTIVE_VIDPN   = &HC0262336&

'//
'// MessageId: ERROR_GRAPHICS_STALE_VIDPN_TOPOLOGY
'//
'// MessageText:
'//
'// Specified VidPN topology is stale. Please reacquire the new topology.
'//
%ERROR_GRAPHICS_STALE_VIDPN_TOPOLOGY = &HC0262337&

'//
'// MessageId: ERROR_GRAPHICS_MONITOR_NOT_CONNECTED
'//
'// MessageText:
'//
'// There is no monitor connected on the specified video present target.
'//
%ERROR_GRAPHICS_MONITOR_NOT_CONNECTED = &HC0262338&

'//
'// MessageId: ERROR_GRAPHICS_SOURCE_NOT_IN_TOPOLOGY
'//
'// MessageText:
'//
'// Specified source is not part of the specified VidPN's topology.
'//
%ERROR_GRAPHICS_SOURCE_NOT_IN_TOPOLOGY = &HC0262339&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_PRIMARYSURFACE_SIZE
'//
'// MessageText:
'//
'// Specified primary surface size is invalid.
'//
%ERROR_GRAPHICS_INVALID_PRIMARYSURFACE_SIZE = &HC026233A&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VISIBLEREGION_SIZE
'//
'// MessageText:
'//
'// Specified visible region size is invalid.
'//
%ERROR_GRAPHICS_INVALID_VISIBLEREGION_SIZE = &HC026233B&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_STRIDE
'//
'// MessageText:
'//
'// Specified stride is invalid.
'//
%ERROR_GRAPHICS_INVALID_STRIDE    = &HC026233C&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_PIXELFORMAT
'//
'// MessageText:
'//
'// Specified pixel format is invalid.
'//
%ERROR_GRAPHICS_INVALID_PIXELFORMAT = &HC026233D&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_COLORBASIS
'//
'// MessageText:
'//
'// Specified color basis is invalid.
'//
%ERROR_GRAPHICS_INVALID_COLORBASIS = &HC026233E&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_PIXELVALUEACCESSMODE
'//
'// MessageText:
'//
'// Specified pixel value access mode is invalid.
'//
%ERROR_GRAPHICS_INVALID_PIXELVALUEACCESSMODE = &HC026233F&

'//
'// MessageId: ERROR_GRAPHICS_TARGET_NOT_IN_TOPOLOGY
'//
'// MessageText:
'//
'// Specified target is not part of the specified VidPN's topology.
'//
%ERROR_GRAPHICS_TARGET_NOT_IN_TOPOLOGY = &HC0262340&

'//
'// MessageId: ERROR_GRAPHICS_NO_DISPLAY_MODE_MANAGEMENT_SUPPORT
'//
'// MessageText:
'//
'// Failed to acquire display mode management interface.
'//
%ERROR_GRAPHICS_NO_DISPLAY_MODE_MANAGEMENT_SUPPORT = &HC0262341&

'//
'// MessageId: ERROR_GRAPHICS_VIDPN_SOURCE_IN_USE
'//
'// MessageText:
'//
'// Specified VidPN source is already owned by a DMM client and cannot be used until that client releases it.
'//
%ERROR_GRAPHICS_VIDPN_SOURCE_IN_USE = &HC0262342&

'//
'// MessageId: ERROR_GRAPHICS_CANT_ACCESS_ACTIVE_VIDPN
'//
'// MessageText:
'//
'// Specified VidPN is active and cannot be accessed.
'//
%ERROR_GRAPHICS_CANT_ACCESS_ACTIVE_VIDPN = &HC0262343&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_PATH_IMPORTANCE_ORDINAL
'//
'// MessageText:
'//
'// Specified VidPN present path importance ordinal is invalid.
'//
%ERROR_GRAPHICS_INVALID_PATH_IMPORTANCE_ORDINAL = &HC0262344&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_PATH_CONTENT_GEOMETRY_TRANSFORMATION
'//
'// MessageText:
'//
'// Specified VidPN present path content geometry transformation is invalid.
'//
%ERROR_GRAPHICS_INVALID_PATH_CONTENT_GEOMETRY_TRANSFORMATION = &HC0262345&

'//
'// MessageId: ERROR_GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Specified content geometry transformation is not supported on the respective VidPN present path.
'//
%ERROR_GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_SUPPORTED = &HC0262346&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_GAMMA_RAMP
'//
'// MessageText:
'//
'// Specified gamma ramp is invalid.
'//
%ERROR_GRAPHICS_INVALID_GAMMA_RAMP = &HC0262347&

'//
'// MessageId: ERROR_GRAPHICS_GAMMA_RAMP_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Specified gamma ramp is not supported on the respective VidPN present path.
'//
%ERROR_GRAPHICS_GAMMA_RAMP_NOT_SUPPORTED = &HC0262348&

'//
'// MessageId: ERROR_GRAPHICS_MULTISAMPLING_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Multi-sampling is not supported on the respective VidPN present path.
'//
%ERROR_GRAPHICS_MULTISAMPLING_NOT_SUPPORTED = &HC0262349&

'//
'// MessageId: ERROR_GRAPHICS_MODE_NOT_IN_MODESET
'//
'// MessageText:
'//
'// Specified mode is not in the specified mode set.
'//
%ERROR_GRAPHICS_MODE_NOT_IN_MODESET = &HC026234A&

'//
'// MessageId: ERROR_GRAPHICS_DATASET_IS_EMPTY
'//
'// MessageText:
'//
'// Specified data set (e.g. mode set, frequency range set, descriptor set, topology, etc.) is empty.
'//
%ERROR_GRAPHICS_DATASET_IS_EMPTY  = &H0026234B&

'//
'// MessageId: ERROR_GRAPHICS_NO_MORE_ELEMENTS_IN_DATASET
'//
'// MessageText:
'//
'// Specified data set (e.g. mode set, frequency range set, descriptor set, topology, etc.) does not contain any more elements.
'//
%ERROR_GRAPHICS_NO_MORE_ELEMENTS_IN_DATASET = &H0026234C&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_VIDPN_TOPOLOGY_RECOMMENDATION_REASON
'//
'// MessageText:
'//
'// Specified VidPN topology recommendation reason is invalid.
'//
%ERROR_GRAPHICS_INVALID_VIDPN_TOPOLOGY_RECOMMENDATION_REASON = &HC026234D&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_PATH_CONTENT_TYPE
'//
'// MessageText:
'//
'// Specified VidPN present path content type is invalid.
'//
%ERROR_GRAPHICS_INVALID_PATH_CONTENT_TYPE = &HC026234E&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_COPYPROTECTION_TYPE
'//
'// MessageText:
'//
'// Specified VidPN present path copy protection type is invalid.
'//
%ERROR_GRAPHICS_INVALID_COPYPROTECTION_TYPE = &HC026234F&

'//
'// MessageId: ERROR_GRAPHICS_UNASSIGNED_MODESET_ALREADY_EXISTS
'//
'// MessageText:
'//
'// No more than one unassigned mode set can exist at any given time for a given VidPN source/target.
'//
%ERROR_GRAPHICS_UNASSIGNED_MODESET_ALREADY_EXISTS = &HC0262350&

'//
'// MessageId: ERROR_GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_PINNED
'//
'// MessageText:
'//
'// Specified content transformation is not pinned on the specified VidPN present path.
'//
%ERROR_GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_PINNED = &H00262351&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_SCANLINE_ORDERING
'//
'// MessageText:
'//
'// Specified scanline ordering type is invalid.
'//
%ERROR_GRAPHICS_INVALID_SCANLINE_ORDERING = &HC0262352&

'//
'// MessageId: ERROR_GRAPHICS_TOPOLOGY_CHANGES_NOT_ALLOWED
'//
'// MessageText:
'//
'// Topology changes are not allowed for the specified VidPN.
'//
%ERROR_GRAPHICS_TOPOLOGY_CHANGES_NOT_ALLOWED = &HC0262353&

'//
'// MessageId: ERROR_GRAPHICS_NO_AVAILABLE_IMPORTANCE_ORDINALS
'//
'// MessageText:
'//
'// All available importance ordinals are already used in specified topology.
'//
%ERROR_GRAPHICS_NO_AVAILABLE_IMPORTANCE_ORDINALS = &HC0262354&

'//
'// MessageId: ERROR_GRAPHICS_INCOMPATIBLE_PRIVATE_FORMAT
'//
'// MessageText:
'//
'// Specified primary surface has a different private format attribute than the current primary surface
'//
%ERROR_GRAPHICS_INCOMPATIBLE_PRIVATE_FORMAT = &HC0262355&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MODE_PRUNING_ALGORITHM
'//
'// MessageText:
'//
'// Specified mode pruning algorithm is invalid
'//
%ERROR_GRAPHICS_INVALID_MODE_PRUNING_ALGORITHM = &HC0262356&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MONITOR_CAPABILITY_ORIGIN
'//
'// MessageText:
'//
'// Specified monitor capability origin is invalid.
'//
%ERROR_GRAPHICS_INVALID_MONITOR_CAPABILITY_ORIGIN = &HC0262357&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE_CONSTRAINT
'//
'// MessageText:
'//
'// Specified monitor frequency range constraint is invalid.
'//
%ERROR_GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE_CONSTRAINT = &HC0262358&

'//
'// MessageId: ERROR_GRAPHICS_MAX_NUM_PATHS_REACHED
'//
'// MessageText:
'//
'// Maximum supported number of present paths has been reached.
'//
%ERROR_GRAPHICS_MAX_NUM_PATHS_REACHED = &HC0262359&

'//
'// MessageId: ERROR_GRAPHICS_CANCEL_VIDPN_TOPOLOGY_AUGMENTATION
'//
'// MessageText:
'//
'// Miniport requested that augmentation be cancelled for the specified source of the specified VidPN's topology.
'//
%ERROR_GRAPHICS_CANCEL_VIDPN_TOPOLOGY_AUGMENTATION = &HC026235A&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_CLIENT_TYPE
'//
'// MessageText:
'//
'// Specified client type was not recognized.
'//
%ERROR_GRAPHICS_INVALID_CLIENT_TYPE = &HC026235B&

'//
'// MessageId: ERROR_GRAPHICS_CLIENTVIDPN_NOT_SET
'//
'// MessageText:
'//
'// Client VidPN is not set on this adapter (e.g. no user mode initiated mode changes took place on this adapter yet).
'//
%ERROR_GRAPHICS_CLIENTVIDPN_NOT_SET = &HC026235C&

'//
'//   Port specific status codes {0x2400..0x24ff}
'//
'//
'// MessageId: ERROR_GRAPHICS_SPECIFIED_CHILD_ALREADY_CONNECTED
'//
'// MessageText:
'//
'// Specified display adapter child device already has an external device connected to it.
'//
%ERROR_GRAPHICS_SPECIFIED_CHILD_ALREADY_CONNECTED = &HC0262400&

'//
'// MessageId: ERROR_GRAPHICS_CHILD_DESCRIPTOR_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Specified display adapter child device does not support descriptor exposure.
'//
%ERROR_GRAPHICS_CHILD_DESCRIPTOR_NOT_SUPPORTED = &HC0262401&

'//
'// MessageId: ERROR_GRAPHICS_UNKNOWN_CHILD_STATUS
'//
'// MessageText:
'//
'// Child device presence was not reliably detected.
'//
%ERROR_GRAPHICS_UNKNOWN_CHILD_STATUS = &H4026242F&

'//
'// MessageId: ERROR_GRAPHICS_NOT_A_LINKED_ADAPTER
'//
'// MessageText:
'//
'// The display adapter is not linked to any other adapters.
'//
%ERROR_GRAPHICS_NOT_A_LINKED_ADAPTER = &HC0262430&

'//
'// MessageId: ERROR_GRAPHICS_LEADLINK_NOT_ENUMERATED
'//
'// MessageText:
'//
'// Lead adapter in a linked configuration was not enumerated yet.
'//
%ERROR_GRAPHICS_LEADLINK_NOT_ENUMERATED = &HC0262431&

'//
'// MessageId: ERROR_GRAPHICS_CHAINLINKS_NOT_ENUMERATED
'//
'// MessageText:
'//
'// Some chain adapters in a linked configuration were not enumerated yet.
'//
%ERROR_GRAPHICS_CHAINLINKS_NOT_ENUMERATED = &HC0262432&

'//
'// MessageId: ERROR_GRAPHICS_ADAPTER_CHAIN_NOT_READY
'//
'// MessageText:
'//
'// The chain of linked adapters is not ready to start because of an unknown failure.
'//
%ERROR_GRAPHICS_ADAPTER_CHAIN_NOT_READY = &HC0262433&

'//
'// MessageId: ERROR_GRAPHICS_CHAINLINKS_NOT_STARTED
'//
'// MessageText:
'//
'// An attempt was made to start a lead link display adapter when the chain links were not started yet.
'//
%ERROR_GRAPHICS_CHAINLINKS_NOT_STARTED = &HC0262434&

'//
'// MessageId: ERROR_GRAPHICS_CHAINLINKS_NOT_POWERED_ON
'//
'// MessageText:
'//
'// An attempt was made to power up a lead link display adapter when the chain links were powered down.
'//
%ERROR_GRAPHICS_CHAINLINKS_NOT_POWERED_ON = &HC0262435&

'//
'// MessageId: ERROR_GRAPHICS_INCONSISTENT_DEVICE_LINK_STATE
'//
'// MessageText:
'//
'// The adapter link was found to be in an inconsistent state. Not all adapters are in an expected PNP/Power state.
'//
%ERROR_GRAPHICS_INCONSISTENT_DEVICE_LINK_STATE = &HC0262436&

'//
'// MessageId: ERROR_GRAPHICS_LEADLINK_START_DEFERRED
'//
'// MessageText:
'//
'// Starting the leadlink adapter has been deferred temporarily.
'//
%ERROR_GRAPHICS_LEADLINK_START_DEFERRED = &H40262437&

'//
'// MessageId: ERROR_GRAPHICS_NOT_POST_DEVICE_DRIVER
'//
'// MessageText:
'//
'// The driver trying to start is not the same as the driver for the POSTed display adapter.
'//
%ERROR_GRAPHICS_NOT_POST_DEVICE_DRIVER = &HC0262438&

'//
'// MessageId: ERROR_GRAPHICS_POLLING_TOO_FREQUENTLY
'//
'// MessageText:
'//
'// The display adapter is being polled for children too frequently at the same polling level.
'//
%ERROR_GRAPHICS_POLLING_TOO_FREQUENTLY = &H40262439&

'//
'// MessageId: ERROR_GRAPHICS_START_DEFERRED
'//
'// MessageText:
'//
'// Starting the adapter has been deferred temporarily.
'//
%ERROR_GRAPHICS_START_DEFERRED    = &H4026243A&

'//
'// MessageId: ERROR_GRAPHICS_ADAPTER_ACCESS_NOT_EXCLUDED
'//
'// MessageText:
'//
'// An operation is being attempted that requires the display adapter to be in a quiescent state.
'//
%ERROR_GRAPHICS_ADAPTER_ACCESS_NOT_EXCLUDED = &HC026243B&

'//
'//   OPM, UAB and PVP specific error codes {0x2500..0x257f}
'//
'//
'// MessageId: ERROR_GRAPHICS_OPM_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The driver does not support OPM.
'//
%ERROR_GRAPHICS_OPM_NOT_SUPPORTED = &HC0262500&

'//
'// MessageId: ERROR_GRAPHICS_COPP_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The driver does not support COPP.
'//
%ERROR_GRAPHICS_COPP_NOT_SUPPORTED = &HC0262501&

'//
'// MessageId: ERROR_GRAPHICS_UAB_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The driver does not support UAB.
'//
%ERROR_GRAPHICS_UAB_NOT_SUPPORTED = &HC0262502&

'//
'// MessageId: ERROR_GRAPHICS_OPM_INVALID_ENCRYPTED_PARAMETERS
'//
'// MessageText:
'//
'// The specified encrypted parameters are invalid.
'//
%ERROR_GRAPHICS_OPM_INVALID_ENCRYPTED_PARAMETERS = &HC0262503&

'//
'// MessageId: ERROR_GRAPHICS_OPM_NO_VIDEO_OUTPUTS_EXIST
'//
'// MessageText:
'//
'// The GDI display device passed to this function does not have any active video outputs.
'//
%ERROR_GRAPHICS_OPM_NO_VIDEO_OUTPUTS_EXIST = &HC0262505&

'//
'// MessageId: ERROR_GRAPHICS_OPM_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal error caused this operation to fail.
'//
%ERROR_GRAPHICS_OPM_INTERNAL_ERROR = &HC026250B&

'//
'// MessageId: ERROR_GRAPHICS_OPM_INVALID_HANDLE
'//
'// MessageText:
'//
'// The function failed because the caller passed in an invalid OPM user mode handle.
'//
%ERROR_GRAPHICS_OPM_INVALID_HANDLE = &HC026250C&

'//
'// MessageId: ERROR_GRAPHICS_PVP_INVALID_CERTIFICATE_LENGTH
'//
'// MessageText:
'//
'// A certificate could not be returned because the certificate buffer passed to the function was too small.
'//
%ERROR_GRAPHICS_PVP_INVALID_CERTIFICATE_LENGTH = &HC026250E&

'//
'// MessageId: ERROR_GRAPHICS_OPM_SPANNING_MODE_ENABLED
'//
'// MessageText:
'//
'// A video output could not be created because the frame buffer is in spanning mode.
'//
%ERROR_GRAPHICS_OPM_SPANNING_MODE_ENABLED = &HC026250F&

'//
'// MessageId: ERROR_GRAPHICS_OPM_THEATER_MODE_ENABLED
'//
'// MessageText:
'//
'// A video output could not be created because the frame buffer is in theater mode.
'//
%ERROR_GRAPHICS_OPM_THEATER_MODE_ENABLED = &HC0262510&

'//
'// MessageId: ERROR_GRAPHICS_PVP_HFS_FAILED
'//
'// MessageText:
'//
'// The function failed because the display adapter's Hardware Functionality Scan failed to validate the graphics hardware.
'//
%ERROR_GRAPHICS_PVP_HFS_FAILED    = &HC0262511&

'//
'// MessageId: ERROR_GRAPHICS_OPM_INVALID_SRM
'//
'// MessageText:
'//
'// The HDCP System Renewability Message passed to this function did not comply with section 5 of the HDCP 1.1 specification.
'//
%ERROR_GRAPHICS_OPM_INVALID_SRM   = &HC0262512&

'//
'// MessageId: ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_HDCP
'//
'// MessageText:
'//
'// The video output cannot enable the High-bandwidth Digital Content Protection (HDCP) System because it does not support HDCP.
'//
%ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_HDCP = &HC0262513&

'//
'// MessageId: ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_ACP
'//
'// MessageText:
'//
'// The video output cannot enable Analogue Copy Protection (ACP) because it does not support ACP.
'//
%ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_ACP = &HC0262514&

'//
'// MessageId: ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_CGMSA
'//
'// MessageText:
'//
'// The video output cannot enable the Content Generation Management System Analogue (CGMS-A) protection technology because it does not support CGMS-A.
'//
%ERROR_GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_CGMSA = &HC0262515&

'//
'// MessageId: ERROR_GRAPHICS_OPM_HDCP_SRM_NEVER_SET
'//
'// MessageText:
'//
'// The IOPMVideoOutput::GetInformation method cannot return the version of the SRM being used because the application never successfully passed an SRM to the video output.
'//
%ERROR_GRAPHICS_OPM_HDCP_SRM_NEVER_SET = &HC0262516&

'//
'// MessageId: ERROR_GRAPHICS_OPM_RESOLUTION_TOO_HIGH
'//
'// MessageText:
'//
'// The IOPMVideoOutput::Configure method cannot enable the specified output protection technology because the output's screen resolution is too high.
'//
%ERROR_GRAPHICS_OPM_RESOLUTION_TOO_HIGH = &HC0262517&

'//
'// MessageId: ERROR_GRAPHICS_OPM_ALL_HDCP_HARDWARE_ALREADY_IN_USE
'//
'// MessageText:
'//
'// The IOPMVideoOutput::Configure method cannot enable HDCP because the display adapter's HDCP hardware is already being used by other physical outputs.
'//
%ERROR_GRAPHICS_OPM_ALL_HDCP_HARDWARE_ALREADY_IN_USE = &HC0262518&

'//
'// MessageId: ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_NO_LONGER_EXISTS
'//
'// MessageText:
'//
'// The operating system asynchronously destroyed this OPM video output because the operating system's state changed. This error typically occurs because the monitor PDO associated with this video output was removed, the monitor PDO associated with this
'// video output was stopped,
'// the video output's session became a
'// non-console session or the video output's desktop became an inactive desktop.
'//
%ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_NO_LONGER_EXISTS = &HC026251A&

'//
'// MessageId: ERROR_GRAPHICS_OPM_SESSION_TYPE_CHANGE_IN_PROGRESS
'//
'// MessageText:
'//
'// The method failed because the session is changing its type. No IOPMVideoOutput methods can be called when a session is changing its type. There are currently three types of sessions: console, disconnected and remote (RDP or ICA).
'//
%ERROR_GRAPHICS_OPM_SESSION_TYPE_CHANGE_IN_PROGRESS = &HC026251B&

'//
'// MessageId: ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_DOES_NOT_HAVE_COPP_SEMANTICS
'//
'// MessageText:
'//
'// Either the IOPMVideoOutput::COPPCompatibleGetInformation, IOPMVideoOutput::GetInformation, or IOPMVideoOutput::Configure method failed.  This error is only returned if a video output has OPM semantics.  IOPMVideoOutput::COPPCompatibleGetInformation
'// always returns this error if a video output has OPM semantics.
'//  IOPMVideoOutput::GetInformation returns this error code if the caller requested COPP specific information.
'//  IOPMVideoOutput::Configure returns this
'// error when the caller tries
'// to use a COPP specific command.
'//
%ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_DOES_NOT_HAVE_COPP_SEMANTICS = &HC026251C&

'//
'// MessageId: ERROR_GRAPHICS_OPM_INVALID_INFORMATION_REQUEST
'//
'// MessageText:
'//
'// The IOPMVideoOutput::GetInformation and IOPMVideoOutput::COPPCompatibleGetInformation methods return this error if the passed in sequence number is not the expected sequence number or the passed in OMAC value is invalid.
'//
%ERROR_GRAPHICS_OPM_INVALID_INFORMATION_REQUEST = &HC026251D&

'//
'// MessageId: ERROR_GRAPHICS_OPM_DRIVER_INTERNAL_ERROR
'//
'// MessageText:
'//
'// The method failed because an unexpected error occurred inside of a display driver.
'//
%ERROR_GRAPHICS_OPM_DRIVER_INTERNAL_ERROR = &HC026251E&

'//
'// MessageId: ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_DOES_NOT_HAVE_OPM_SEMANTICS
'//
'// MessageText:
'//
'// Either the IOPMVideoOutput::COPPCompatibleGetInformation, IOPMVideoOutput::GetInformation, or IOPMVideoOutput::Configure method failed.  This error is only returned if a video output has COPP semantics.
'//  IOPMVideoOutput::COPPCompatibleGetInformation returns this error code
'// if the caller requested OPM specific information.
'// IOPMVideoOutput::GetInformation always returns this error if a video output has COPP semantics.
'// IOPMVideoOutput::Configure returns this error when the caller tries to use an OPM specific command.
'//
%ERROR_GRAPHICS_OPM_VIDEO_OUTPUT_DOES_NOT_HAVE_OPM_SEMANTICS = &HC026251F&

'//
'// MessageId: ERROR_GRAPHICS_OPM_SIGNALING_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The IOPMVideoOutput::COPPCompatibleGetInformation or IOPMVideoOutput::Configure method failed because the display driver does not support the OPM_GET_ACP_AND_CGMSA_SIGNALING and OPM_SET_ACP_AND_CGMSA_SIGNALING GUIDs.
'//
%ERROR_GRAPHICS_OPM_SIGNALING_NOT_SUPPORTED = &HC0262520&

'//
'// MessageId: ERROR_GRAPHICS_OPM_INVALID_CONFIGURATION_REQUEST
'//
'// MessageText:
'//
'// The IOPMVideoOutput::Configure function returns this error code if the passed in sequence number is not the expected sequence number or the passed in OMAC value is invalid.
'//
%ERROR_GRAPHICS_OPM_INVALID_CONFIGURATION_REQUEST = &HC0262521&

'//
'//   Monitor Configuration API error codes {0x2580..0x25DF}
'//
'//
'// MessageId: ERROR_GRAPHICS_I2C_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The monitor connected to the specified video output does not have an I2C bus.
'//
%ERROR_GRAPHICS_I2C_NOT_SUPPORTED = &HC0262580&

'//
'// MessageId: ERROR_GRAPHICS_I2C_DEVICE_DOES_NOT_EXIST
'//
'// MessageText:
'//
'// No device on the I2C bus has the specified address.
'//
%ERROR_GRAPHICS_I2C_DEVICE_DOES_NOT_EXIST = &HC0262581&

'//
'// MessageId: ERROR_GRAPHICS_I2C_ERROR_TRANSMITTING_DATA
'//
'// MessageText:
'//
'// An error occurred while transmitting data to the device on the I2C bus.
'//
%ERROR_GRAPHICS_I2C_ERROR_TRANSMITTING_DATA = &HC0262582&

'//
'// MessageId: ERROR_GRAPHICS_I2C_ERROR_RECEIVING_DATA
'//
'// MessageText:
'//
'// An error occurred while receiving data from the device on the I2C bus.
'//
%ERROR_GRAPHICS_I2C_ERROR_RECEIVING_DATA = &HC0262583&

'//
'// MessageId: ERROR_GRAPHICS_DDCCI_VCP_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The monitor does not support the specified VCP code.
'//
%ERROR_GRAPHICS_DDCCI_VCP_NOT_SUPPORTED = &HC0262584&

'//
'// MessageId: ERROR_GRAPHICS_DDCCI_INVALID_DATA
'//
'// MessageText:
'//
'// The data received from the monitor is invalid.
'//
%ERROR_GRAPHICS_DDCCI_INVALID_DATA = &HC0262585&

'//
'// MessageId: ERROR_GRAPHICS_DDCCI_MONITOR_RETURNED_INVALID_TIMING_STATUS_BYTE
'//
'// MessageText:
'//
'// The function failed because a monitor returned an invalid Timing Status byte when the operating system used the DDC/CI Get Timing Report & Timing Message command to get a timing report from a monitor.
'//
%ERROR_GRAPHICS_DDCCI_MONITOR_RETURNED_INVALID_TIMING_STATUS_BYTE = &HC0262586&

'//
'// MessageId: ERROR_GRAPHICS_MCA_INVALID_CAPABILITIES_STRING
'//
'// MessageText:
'//
'// The monitor returned a DDC/CI capabilities string which did not comply with the ACCESS.bus 3.0, DDC/CI 1.1, or MCCS 2 Revision 1 specification.
'//
%ERROR_GRAPHICS_MCA_INVALID_CAPABILITIES_STRING = &HC0262587&

'//
'// MessageId: ERROR_GRAPHICS_MCA_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal Monitor Configuration API error occured.
'//
%ERROR_GRAPHICS_MCA_INTERNAL_ERROR = &HC0262588&

'//
'// MessageId: ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_COMMAND
'//
'// MessageText:
'//
'// An operation failed because a DDC/CI message had an invalid value in its command field.
'//
%ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_COMMAND = &HC0262589&

'//
'// MessageId: ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_LENGTH
'//
'// MessageText:
'//
'// An error occurred because the field length of a DDC/CI message contained an invalid value.
'//
%ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_LENGTH = &HC026258A&

'//
'// MessageId: ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_CHECKSUM
'//
'// MessageText:
'//
'// An error occurred because the checksum field in a DDC/CI message did not match the message's computed checksum value.  This error implies that the data was corrupted while it was being transmitted from a monitor to a computer.
'//
%ERROR_GRAPHICS_DDCCI_INVALID_MESSAGE_CHECKSUM = &HC026258B&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_PHYSICAL_MONITOR_HANDLE
'//
'// MessageText:
'//
'// This function failed because an invalid monitor handle was passed to it.
'//
%ERROR_GRAPHICS_INVALID_PHYSICAL_MONITOR_HANDLE = &HC026258C&

'//
'// MessageId: ERROR_GRAPHICS_MONITOR_NO_LONGER_EXISTS
'//
'// MessageText:
'//
'// The operating system asynchronously destroyed the monitor which corresponds to this handle because the operating system's state changed.  This error typically occurs because the monitor PDO associated with this handle was removed, the monitor
'// PDO associated with this handle was stopped, or a display mode change occurred.
'//  A display mode change occurs when windows
'// sends a WM_DISPLAYCHANGE windows message to applications.
'//
%ERROR_GRAPHICS_MONITOR_NO_LONGER_EXISTS = &HC026258D&

'//
'// MessageId: ERROR_GRAPHICS_DDCCI_CURRENT_CURRENT_VALUE_GREATER_THAN_MAXIMUM_VALUE
'//
'// MessageText:
'//
'// A continuous VCP code's current value is greater than its maximum value. This error code indicates that a monitor returned an invalid value.
'//
%ERROR_GRAPHICS_DDCCI_CURRENT_CURRENT_VALUE_GREATER_THAN_MAXIMUM_VALUE = &HC02625D8&

'//
'// MessageId: ERROR_GRAPHICS_MCA_INVALID_VCP_VERSION
'//
'// MessageText:
'//
'// The monitor's VCP Version (0xDF) VCP code returned an invalid version value.
'//
%ERROR_GRAPHICS_MCA_INVALID_VCP_VERSION = &HC02625D9&

'//
'// MessageId: ERROR_GRAPHICS_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION
'//
'// MessageText:
'//
'// The monitor does not comply with the MCCS specification it claims to support.
'//
%ERROR_GRAPHICS_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION = &HC02625DA&

'//
'// MessageId: ERROR_GRAPHICS_MCA_MCCS_VERSION_MISMATCH
'//
'// MessageText:
'//
'// The MCCS version in a monitor's mccs_ver capability does not match the MCCS version the monitor reports when the VCP Version (0xDF) VCP code is used.
'//
%ERROR_GRAPHICS_MCA_MCCS_VERSION_MISMATCH = &HC02625DB&

'//
'// MessageId: ERROR_GRAPHICS_MCA_UNSUPPORTED_MCCS_VERSION
'//
'// MessageText:
'//
'// The Monitor Configuration API only works with monitors which support the MCCS 1.0 specification, MCCS 2.0 specification or the MCCS 2.0 Revision 1 specification.
'//
%ERROR_GRAPHICS_MCA_UNSUPPORTED_MCCS_VERSION = &HC02625DC&

'//
'// MessageId: ERROR_GRAPHICS_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED
'//
'// MessageText:
'//
'// The monitor returned an invalid monitor technology type. CRT, Plasma and LCD (TFT) are examples of monitor technology types. This error implies that the monitor violated the MCCS 2.0 or MCCS 2.0 Revision 1 specification.
'//
%ERROR_GRAPHICS_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED = &HC02625DE&

'//
'// MessageId: ERROR_GRAPHICS_MCA_UNSUPPORTED_COLOR_TEMPERATURE
'//
'// MessageText:
'//
'// SetMonitorColorTemperature()'s caller passed a color temperature to it which the current monitor did not support. This error implies that the monitor violated the MCCS 2.0 or MCCS 2.0 Revision 1 specification.
'//
%ERROR_GRAPHICS_MCA_UNSUPPORTED_COLOR_TEMPERATURE = &HC02625DF&

'//
'//   OPM, UAB, PVP and DDC/CI shared error codes {0x25E0..0x25ff}
'//
'//
'// MessageId: ERROR_GRAPHICS_ONLY_CONSOLE_SESSION_SUPPORTED
'//
'// MessageText:
'//
'// This function can only be used if a program is running in the local console session. It cannot be used if the program is running on a remote desktop session or on a terminal server session.
'//
%ERROR_GRAPHICS_ONLY_CONSOLE_SESSION_SUPPORTED = &HC02625E0&

'//
'// MessageId: ERROR_GRAPHICS_NO_DISPLAY_DEVICE_CORRESPONDS_TO_NAME
'//
'// MessageText:
'//
'// This function cannot find an actual GDI display device which corresponds to the specified GDI display device name.
'//
%ERROR_GRAPHICS_NO_DISPLAY_DEVICE_CORRESPONDS_TO_NAME = &HC02625E1&

'//
'// MessageId: ERROR_GRAPHICS_DISPLAY_DEVICE_NOT_ATTACHED_TO_DESKTOP
'//
'// MessageText:
'//
'// The function failed because the specified GDI display device was not attached to the Windows desktop.
'//
%ERROR_GRAPHICS_DISPLAY_DEVICE_NOT_ATTACHED_TO_DESKTOP = &HC02625E2&

'//
'// MessageId: ERROR_GRAPHICS_MIRRORING_DEVICES_NOT_SUPPORTED
'//
'// MessageText:
'//
'// This function does not support GDI mirroring display devices because GDI mirroring display devices do not have any physical monitors associated with them.
'//
%ERROR_GRAPHICS_MIRRORING_DEVICES_NOT_SUPPORTED = &HC02625E3&

'//
'// MessageId: ERROR_GRAPHICS_INVALID_POINTER
'//
'// MessageText:
'//
'// The function failed because an invalid pointer parameter was passed to it.  A pointer parameter is invalid if it is NULL, points to an invalid address, points to a kernel mode address, or is not correctly aligned.
'//
%ERROR_GRAPHICS_INVALID_POINTER   = &HC02625E4&

'//
'// MessageId: ERROR_GRAPHICS_NO_MONITORS_CORRESPOND_TO_DISPLAY_DEVICE
'//
'// MessageText:
'//
'// The function failed because the specified GDI device did not have any monitors associated with it.
'//
%ERROR_GRAPHICS_NO_MONITORS_CORRESPOND_TO_DISPLAY_DEVICE = &HC02625E5&

'//
'// MessageId: ERROR_GRAPHICS_PARAMETER_ARRAY_TOO_SMALL
'//
'// MessageText:
'//
'// An array passed to the function cannot hold all of the data that the function must copy into the array.
'//
%ERROR_GRAPHICS_PARAMETER_ARRAY_TOO_SMALL = &HC02625E6&

'//
'// MessageId: ERROR_GRAPHICS_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal error caused an operation to fail.
'//
%ERROR_GRAPHICS_INTERNAL_ERROR    = &HC02625E7&

'//
'// MessageId: ERROR_GRAPHICS_SESSION_TYPE_CHANGE_IN_PROGRESS
'//
'// MessageText:
'//
'// The function failed because the current session is changing its type.  This function cannot be called when the current session is changing its type.  There are currently three types of sessions: console, disconnected and remote (RDP or ICA).
'//
%ERROR_GRAPHICS_SESSION_TYPE_CHANGE_IN_PROGRESS = &HC02605E8&

'//
'// = ==============================
'// TPM Services and TPM Software Error Messages
'// = ==============================
'//
'// The TPM services and TPM software facilities are used by the various
'// TPM software components. There are two facilities because the services
'// errors are within the TCG-defined error space and the software errors
'// are not.
'//
'// The following are the subranges within the TPM Services facility.
'// The TPM hardware errors are defined in the document
'// TPM Main Specification 1.2 Part 2 TPM Structures.
'// The TBS errors are slotted into the TCG error namespace at the TBS layer.
'//
'// 0x0000 - 0x08ff     TPM hardware errors
'// 0x4000 - 0x40ff     TPM Base Services errors (tbssvc.dl&
'//
'// The following are the subranges within the TPM Software facility. The TBS
'// has two classes of errors - those that can be returned (the public errors,
'// defined in the TBS spec), which are in the TPM services facility,  and
'// those that are internal or implementation specific, which are here in the
'// TPM software facility.
'//
'// 0x0000 - 0x00ff     TPM device driver errors (tpm.sys)
'// 0x0100 - 0x01ff     TPM API errors (tpmapi.lib)
'// 0x0200 - 0x02ff     TBS internal errors (tbssvc.dl&
'// 0x0300 - 0x03ff     TPM Physical Presence errors
'//
'//
'//   TPM hardware error codes {0x0000..0x08ff}
'//   This space is further subdivided into hardware errors, vendor-specific
'//   errors, and non-fatal errors.
'//
'//
'//  TPM hardware errors {0x0000..0x003ff}
'//
'//
'// MessageId: TPM_E_ERROR_MASK
'//
'// MessageText:
'//
'// This is an error mask to convert TPM hardware errors to win errors.
'//
%TPM_E_ERROR_MASK                 = &H80280000&

'//
'// MessageId: TPM_E_AUTHFAIL
'//
'// MessageText:
'//
'// Authentication failed.
'//
%TPM_E_AUTHFAIL                   = &H80280001&

'//
'// MessageId: TPM_E_BADINDEX
'//
'// MessageText:
'//
'// The index to a PCR, DIR or other register is incorrect.
'//
%TPM_E_BADINDEX                   = &H80280002&

'//
'// MessageId: TPM_E_BAD_PARAMETER
'//
'// MessageText:
'//
'// One or more parameter is bad.
'//
%TPM_E_BAD_PARAMETER              = &H80280003&

'//
'// MessageId: TPM_E_AUDITFAILURE
'//
'// MessageText:
'//
'// An operation completed successfully but the auditing of that operation failed.
'//
%TPM_E_AUDITFAILURE               = &H80280004&

'//
'// MessageId: TPM_E_CLEAR_DISABLED
'//
'// MessageText:
'//
'// The clear disable flag is set and all clear operations now require physical access.
'//
%TPM_E_CLEAR_DISABLED             = &H80280005&

'//
'// MessageId: TPM_E_DEACTIVATED
'//
'// MessageText:
'//
'// Activate the Trusted Platform Module (TPM).
'//
%TPM_E_DEACTIVATED                = &H80280006&

'//
'// MessageId: TPM_E_DISABLED
'//
'// MessageText:
'//
'// Enable the Trusted Platform Module (TPM).
'//
%TPM_E_DISABLED                   = &H80280007&

'//
'// MessageId: TPM_E_DISABLED_CMD
'//
'// MessageText:
'//
'// The target command has been disabled.
'//
%TPM_E_DISABLED_CMD               = &H80280008&

'//
'// MessageId: TPM_E_FAIL
'//
'// MessageText:
'//
'// The operation failed.
'//
%TPM_E_FAIL                       = &H80280009&

'//
'// MessageId: TPM_E_BAD_ORDINAL
'//
'// MessageText:
'//
'// The ordinal was unknown or inconsistent.
'//
%TPM_E_BAD_ORDINAL                = &H8028000A&

'//
'// MessageId: TPM_E_INSTALL_DISABLED
'//
'// MessageText:
'//
'// The ability to install an owner is disabled.
'//
%TPM_E_INSTALL_DISABLED           = &H8028000B&

'//
'// MessageId: TPM_E_INVALID_KEYHANDLE
'//
'// MessageText:
'//
'// The key handle cannot be intrepreted.
'//
%TPM_E_INVALID_KEYHANDLE          = &H8028000C&

'//
'// MessageId: TPM_E_KEYNOTFOUND
'//
'// MessageText:
'//
'// The key handle points to an invalid key.
'//
%TPM_E_KEYNOTFOUND                = &H8028000D&

'//
'// MessageId: TPM_E_INAPPROPRIATE_ENC
'//
'// MessageText:
'//
'// Unacceptable encryption scheme.
'//
%TPM_E_INAPPROPRIATE_ENC          = &H8028000E&

'//
'// MessageId: TPM_E_MIGRATEFAIL
'//
'// MessageText:
'//
'// Migration authorization failed.
'//
%TPM_E_MIGRATEFAIL                = &H8028000F&

'//
'// MessageId: TPM_E_INVALID_PCR_INFO
'//
'// MessageText:
'//
'// PCR information could not be interpreted.
'//
%TPM_E_INVALID_PCR_INFO           = &H80280010&

'//
'// MessageId: TPM_E_NOSPACE
'//
'// MessageText:
'//
'// No room to load key.
'//
%TPM_E_NOSPACE                    = &H80280011&

'//
'// MessageId: TPM_E_NOSRK
'//
'// MessageText:
'//
'// There is no Storage Root Key (SRK) set.
'//
%TPM_E_NOSRK                      = &H80280012&

'//
'// MessageId: TPM_E_NOTSEALED_BLOB
'//
'// MessageText:
'//
'// An encrypted blob is invalid or was not created by this TPM.
'//
%TPM_E_NOTSEALED_BLOB             = &H80280013&

'//
'// MessageId: TPM_E_OWNER_SET
'//
'// MessageText:
'//
'// The Trusted Platform Module (TPM) already has an owner.
'//
%TPM_E_OWNER_SET                  = &H80280014&

'//
'// MessageId: TPM_E_RESOURCES
'//
'// MessageText:
'//
'// The TPM has insufficient internal resources to perform the requested action.
'//
%TPM_E_RESOURCES                  = &H80280015&

'//
'// MessageId: TPM_E_SHORTRANDOM
'//
'// MessageText:
'//
'// A random string was too short.
'//
%TPM_E_SHORTRANDOM                = &H80280016&

'//
'// MessageId: TPM_E_SIZE
'//
'// MessageText:
'//
'// The TPM does not have the space to perform the operation.
'//
%TPM_E_SIZE                       = &H80280017&

'//
'// MessageId: TPM_E_WRONGPCRVAL
'//
'// MessageText:
'//
'// The named PCR value does not match the current PCR value.
'//
%TPM_E_WRONGPCRVAL                = &H80280018&

'//
'// MessageId: TPM_E_BAD_PARAM_SIZE
'//
'// MessageText:
'//
'// The paramSize argument to the command has the incorrect value .
'//
%TPM_E_BAD_PARAM_SIZE             = &H80280019&

'//
'// MessageId: TPM_E_SHA_THREAD
'//
'// MessageText:
'//
'// There is no existing SHA-1 thread.
'//
%TPM_E_SHA_THREAD                 = &H8028001A&

'//
'// MessageId: TPM_E_SHA_ERROR
'//
'// MessageText:
'//
'// The calculation is unable to proceed because the existing SHA-1 thread has already encountered an error.
'//
%TPM_E_SHA_ERROR                  = &H8028001B&

'//
'// MessageId: TPM_E_FAILEDSELFTEST
'//
'// MessageText:
'//
'// Self-test has failed and the TPM has shutdown.
'//
%TPM_E_FAILEDSELFTEST             = &H8028001C&

'//
'// MessageId: TPM_E_AUTH2FAIL
'//
'// MessageText:
'//
'// The authorization for the second key in a 2 key function failed authorization.
'//
%TPM_E_AUTH2FAIL                  = &H8028001D&

'//
'// MessageId: TPM_E_BADTAG
'//
'// MessageText:
'//
'// The tag value sent to for a command is invalid.
'//
%TPM_E_BADTAG                     = &H8028001E&

'//
'// MessageId: TPM_E_IOERROR
'//
'// MessageText:
'//
'// An IO error occurred transmitting information to the TPM.
'//
%TPM_E_IOERROR                    = &H8028001F&

'//
'// MessageId: TPM_E_ENCRYPT_ERROR
'//
'// MessageText:
'//
'// The encryption process had a problem.
'//
%TPM_E_ENCRYPT_ERROR              = &H80280020&

'//
'// MessageId: TPM_E_DECRYPT_ERROR
'//
'// MessageText:
'//
'// The decryption process did not complete.
'//
%TPM_E_DECRYPT_ERROR              = &H80280021&

'//
'// MessageId: TPM_E_INVALID_AUTHHANDLE
'//
'// MessageText:
'//
'// An invalid handle was used.
'//
%TPM_E_INVALID_AUTHHANDLE         = &H80280022&

'//
'// MessageId: TPM_E_NO_ENDORSEMENT
'//
'// MessageText:
'//
'// The TPM does not have an Endorsement Key (EK) installed.
'//
%TPM_E_NO_ENDORSEMENT             = &H80280023&

'//
'// MessageId: TPM_E_INVALID_KEYUSAGE
'//
'// MessageText:
'//
'// The usage of a key is not allowed.
'//
%TPM_E_INVALID_KEYUSAGE           = &H80280024&

'//
'// MessageId: TPM_E_WRONG_ENTITYTYPE
'//
'// MessageText:
'//
'// The submitted entity type is not allowed.
'//
%TPM_E_WRONG_ENTITYTYPE           = &H80280025&

'//
'// MessageId: TPM_E_INVALID_POSTINIT
'//
'// MessageText:
'//
'// The command was received in the wrong sequence relative to TPM_Init and a subsequent TPM_Startup.
'//
%TPM_E_INVALID_POSTINIT           = &H80280026&

'//
'// MessageId: TPM_E_INAPPROPRIATE_SIG
'//
'// MessageText:
'//
'// Signed data cannot include additional DER information.
'//
%TPM_E_INAPPROPRIATE_SIG          = &H80280027&

'//
'// MessageId: TPM_E_BAD_KEY_PROPERTY
'//
'// MessageText:
'//
'// The key properties in TPM_KEY_PARMs are not supported by this TPM.
'//
%TPM_E_BAD_KEY_PROPERTY           = &H80280028&

'//
'// MessageId: TPM_E_BAD_MIGRATION
'//
'// MessageText:
'//
'// The migration properties of this key are incorrect.
'//
%TPM_E_BAD_MIGRATION              = &H80280029&

'//
'// MessageId: TPM_E_BAD_SCHEME
'//
'// MessageText:
'//
'// The signature or encryption scheme for this key is incorrect or not permitted in this situation.
'//
%TPM_E_BAD_SCHEME                 = &H8028002A&

'//
'// MessageId: TPM_E_BAD_DATASIZE
'//
'// MessageText:
'//
'// The size of the data (or blob) parameter is bad or inconsistent with the referenced key.
'//
%TPM_E_BAD_DATASIZE               = &H8028002B&

'//
'// MessageId: TPM_E_BAD_MODE
'//
'// MessageText:
'//
'// A mode parameter is bad, such as capArea or subCapArea for TPM_GetCapability, phsicalPresence parameter for TPM_PhysicalPresence, or migrationType for TPM_CreateMigrationBlob.
'//
%TPM_E_BAD_MODE                   = &H8028002C&

'//
'// MessageId: TPM_E_BAD_PRESENCE
'//
'// MessageText:
'//
'// Either the physicalPresence or physicalPresenceLock bits have the wrong value.
'//
%TPM_E_BAD_PRESENCE               = &H8028002D&

'//
'// MessageId: TPM_E_BAD_VERSION
'//
'// MessageText:
'//
'// The TPM cannot perform this version of the capability.
'//
%TPM_E_BAD_VERSION                = &H8028002E&

'//
'// MessageId: TPM_E_NO_WRAP_TRANSPORT
'//
'// MessageText:
'//
'// The TPM does not allow for wrapped transport sessions.
'//
%TPM_E_NO_WRAP_TRANSPORT          = &H8028002F&

'//
'// MessageId: TPM_E_AUDITFAIL_UNSUCCESSFUL
'//
'// MessageText:
'//
'// TPM audit construction failed and the underlying command was returning a failure code also.
'//
%TPM_E_AUDITFAIL_UNSUCCESSFUL     = &H80280030&

'//
'// MessageId: TPM_E_AUDITFAIL_SUCCESSFUL
'//
'// MessageText:
'//
'// TPM audit construction failed and the underlying command was returning success.
'//
%TPM_E_AUDITFAIL_SUCCESSFUL       = &H80280031&

'//
'// MessageId: TPM_E_NOTRESETABLE
'//
'// MessageText:
'//
'// Attempt to reset a PCR register that does not have the resettable attribute.
'//
%TPM_E_NOTRESETABLE               = &H80280032&

'//
'// MessageId: TPM_E_NOTLOCAL
'//
'// MessageText:
'//
'// Attempt to reset a PCR register that requires locality and locality modifier not part of command transport.
'//
%TPM_E_NOTLOCAL                   = &H80280033&

'//
'// MessageId: TPM_E_BAD_TYPE
'//
'// MessageText:
'//
'// Make identity blob not properly typed.
'//
%TPM_E_BAD_TYPE                   = &H80280034&

'//
'// MessageId: TPM_E_INVALID_RESOURCE
'//
'// MessageText:
'//
'// When saving context identified resource type does not match actual resource.
'//
%TPM_E_INVALID_RESOURCE           = &H80280035&

'//
'// MessageId: TPM_E_NOTFIPS
'//
'// MessageText:
'//
'// The TPM is attempting to execute a command only available when in FIPS mode.
'//
%TPM_E_NOTFIPS                    = &H80280036&

'//
'// MessageId: TPM_E_INVALID_FAMILY
'//
'// MessageText:
'//
'// The command is attempting to use an invalid family ID.
'//
%TPM_E_INVALID_FAMILY             = &H80280037&

'//
'// MessageId: TPM_E_NO_NV_PERMISSION
'//
'// MessageText:
'//
'// The permission to manipulate the NV storage is not available.
'//
%TPM_E_NO_NV_PERMISSION           = &H80280038&

'//
'// MessageId: TPM_E_REQUIRES_SIGN
'//
'// MessageText:
'//
'// The operation requires a signed command.
'//
%TPM_E_REQUIRES_SIGN              = &H80280039&

'//
'// MessageId: TPM_E_KEY_NOTSUPPORTED
'//
'// MessageText:
'//
'// Wrong operation to load an NV key.
'//
%TPM_E_KEY_NOTSUPPORTED           = &H8028003A&

'//
'// MessageId: TPM_E_AUTH_CONFLICT
'//
'// MessageText:
'//
'// NV_LoadKey blob requires both owner and blob authorization.
'//
%TPM_E_AUTH_CONFLICT              = &H8028003B&

'//
'// MessageId: TPM_E_AREA_LOCKED
'//
'// MessageText:
'//
'// The NV area is locked and not writtable.
'//
%TPM_E_AREA_LOCKED                = &H8028003C&

'//
'// MessageId: TPM_E_BAD_LOCALITY
'//
'// MessageText:
'//
'// The locality is incorrect for the attempted operation.
'//
%TPM_E_BAD_LOCALITY               = &H8028003D&

'//
'// MessageId: TPM_E_READ_ONLY
'//
'// MessageText:
'//
'// The NV area is read only and can't be written to.
'//
%TPM_E_READ_ONLY                  = &H8028003E&

'//
'// MessageId: TPM_E_PER_NOWRITE
'//
'// MessageText:
'//
'// There is no protection on the write to the NV area.
'//
%TPM_E_PER_NOWRITE                = &H8028003F&

'//
'// MessageId: TPM_E_FAMILYCOUNT
'//
'// MessageText:
'//
'// The family count value does not match.
'//
%TPM_E_FAMILYCOUNT                = &H80280040&

'//
'// MessageId: TPM_E_WRITE_LOCKED
'//
'// MessageText:
'//
'// The NV area has already been written to.
'//
%TPM_E_WRITE_LOCKED               = &H80280041&

'//
'// MessageId: TPM_E_BAD_ATTRIBUTES
'//
'// MessageText:
'//
'// The NV area attributes conflict.
'//
%TPM_E_BAD_ATTRIBUTES             = &H80280042&

'//
'// MessageId: TPM_E_INVALID_STRUCTURE
'//
'// MessageText:
'//
'// The structure tag and version are invalid or inconsistent.
'//
%TPM_E_INVALID_STRUCTURE          = &H80280043&

'//
'// MessageId: TPM_E_KEY_OWNER_CONTROL
'//
'// MessageText:
'//
'// The key is under control of the TPM Owner and can only be evicted by the TPM Owner.
'//
%TPM_E_KEY_OWNER_CONTROL          = &H80280044&

'//
'// MessageId: TPM_E_BAD_COUNTER
'//
'// MessageText:
'//
'// The counter handle is incorrect.
'//
%TPM_E_BAD_COUNTER                = &H80280045&

'//
'// MessageId: TPM_E_NOT_FULLWRITE
'//
'// MessageText:
'//
'// The write is not a complete write of the area.
'//
%TPM_E_NOT_FULLWRITE              = &H80280046&

'//
'// MessageId: TPM_E_CONTEXT_GAP
'//
'// MessageText:
'//
'// The gap between saved context counts is too large.
'//
%TPM_E_CONTEXT_GAP                = &H80280047&

'//
'// MessageId: TPM_E_MAXNVWRITES
'//
'// MessageText:
'//
'// The maximum number of NV writes without an owner has been exceeded.
'//
%TPM_E_MAXNVWRITES                = &H80280048&

'//
'// MessageId: TPM_E_NOOPERATOR
'//
'// MessageText:
'//
'// No operator AuthData value is set.
'//
%TPM_E_NOOPERATOR                 = &H80280049&

'//
'// MessageId: TPM_E_RESOURCEMISSING
'//
'// MessageText:
'//
'// The resource pointed to by context is not loaded.
'//
%TPM_E_RESOURCEMISSING            = &H8028004A&

'//
'// MessageId: TPM_E_DELEGATE_LOCK
'//
'// MessageText:
'//
'// The delegate administration is locked.
'//
%TPM_E_DELEGATE_LOCK              = &H8028004B&

'//
'// MessageId: TPM_E_DELEGATE_FAMILY
'//
'// MessageText:
'//
'// Attempt to manage a family other then the delegated family.
'//
%TPM_E_DELEGATE_FAMILY            = &H8028004C&

'//
'// MessageId: TPM_E_DELEGATE_ADMIN
'//
'// MessageText:
'//
'// Delegation table management not enabled.
'//
%TPM_E_DELEGATE_ADMIN             = &H8028004D&

'//
'// MessageId: TPM_E_TRANSPORT_NOTEXCLUSIVE
'//
'// MessageText:
'//
'// There was a command executed outside of an exclusive transport session.
'//
%TPM_E_TRANSPORT_NOTEXCLUSIVE     = &H8028004E&

'//
'// MessageId: TPM_E_OWNER_CONTROL
'//
'// MessageText:
'//
'// Attempt to context save a owner evict controlled key.
'//
%TPM_E_OWNER_CONTROL              = &H8028004F&

'//
'// MessageId: TPM_E_DAA_RESOURCES
'//
'// MessageText:
'//
'// The DAA command has no resources availble to execute the command.
'//
%TPM_E_DAA_RESOURCES              = &H80280050&

'//
'// MessageId: TPM_E_DAA_INPUT_DATA0
'//
'// MessageText:
'//
'// The consistency check on DAA parameter inputData0 has failed.
'//
%TPM_E_DAA_INPUT_DATA0            = &H80280051&

'//
'// MessageId: TPM_E_DAA_INPUT_DATA1
'//
'// MessageText:
'//
'// The consistency check on DAA parameter inputData1 has failed.
'//
%TPM_E_DAA_INPUT_DATA1            = &H80280052&

'//
'// MessageId: TPM_E_DAA_ISSUER_SETTINGS
'//
'// MessageText:
'//
'// The consistency check on DAA_issuerSettings has failed.
'//
%TPM_E_DAA_ISSUER_SETTINGS        = &H80280053&

'//
'// MessageId: TPM_E_DAA_TPM_SETTINGS
'//
'// MessageText:
'//
'// The consistency check on DAA_tpmSpecific has failed.
'//
%TPM_E_DAA_TPM_SETTINGS           = &H80280054&

'//
'// MessageId: TPM_E_DAA_STAGE
'//
'// MessageText:
'//
'// The atomic process indicated by the submitted DAA command is not the expected process.
'//
%TPM_E_DAA_STAGE                  = &H80280055&

'//
'// MessageId: TPM_E_DAA_ISSUER_VALIDITY
'//
'// MessageText:
'//
'// The issuer's validity check has detected an inconsistency.
'//
%TPM_E_DAA_ISSUER_VALIDITY        = &H80280056&

'//
'// MessageId: TPM_E_DAA_WRONG_W
'//
'// MessageText:
'//
'// The consistency check on w has failed.
'//
%TPM_E_DAA_WRONG_W                = &H80280057&

'//
'// MessageId: TPM_E_BAD_HANDLE
'//
'// MessageText:
'//
'// The handle is incorrect.
'//
%TPM_E_BAD_HANDLE                 = &H80280058&

'//
'// MessageId: TPM_E_BAD_DELEGATE
'//
'// MessageText:
'//
'// Delegation is not correct.
'//
%TPM_E_BAD_DELEGATE               = &H80280059&

'//
'// MessageId: TPM_E_BADCONTEXT
'//
'// MessageText:
'//
'// The context blob is invalid.
'//
%TPM_E_BADCONTEXT                 = &H8028005A&

'//
'// MessageId: TPM_E_TOOMANYCONTEXTS
'//
'// MessageText:
'//
'// Too many contexts held by the TPM.
'//
%TPM_E_TOOMANYCONTEXTS            = &H8028005B&

'//
'// MessageId: TPM_E_MA_TICKET_SIGNATURE
'//
'// MessageText:
'//
'// Migration authority signature validation failure.
'//
%TPM_E_MA_TICKET_SIGNATURE        = &H8028005C&

'//
'// MessageId: TPM_E_MA_DESTINATION
'//
'// MessageText:
'//
'// Migration destination not authenticated.
'//
%TPM_E_MA_DESTINATION             = &H8028005D&

'//
'// MessageId: TPM_E_MA_SOURCE
'//
'// MessageText:
'//
'// Migration source incorrect.
'//
%TPM_E_MA_SOURCE                  = &H8028005E&

'//
'// MessageId: TPM_E_MA_AUTHORITY
'//
'// MessageText:
'//
'// Incorrect migration authority.
'//
%TPM_E_MA_AUTHORITY               = &H8028005F&

'//
'// MessageId: TPM_E_PERMANENTEK
'//
'// MessageText:
'//
'// Attempt to revoke the EK and the EK is not revocable.
'//
%TPM_E_PERMANENTEK                = &H80280061&

'//
'// MessageId: TPM_E_BAD_SIGNATURE
'//
'// MessageText:
'//
'// Bad signature of CMK ticket.
'//
%TPM_E_BAD_SIGNATURE              = &H80280062&

'//
'// MessageId: TPM_E_NOCONTEXTSPACE
'//
'// MessageText:
'//
'// There is no room in the context list for additional contexts.
'//
%TPM_E_NOCONTEXTSPACE             = &H80280063&

'//
'//  TPM vendor specific hardware errors {0x0400..0x04ff}
'//
'//
'// MessageId: TPM_E_COMMAND_BLOCKED
'//
'// MessageText:
'//
'// The command was blocked.
'//
%TPM_E_COMMAND_BLOCKED            = &H80280400&

'//
'// MessageId: TPM_E_INVALID_HANDLE
'//
'// MessageText:
'//
'// The specified handle was not found.
'//
%TPM_E_INVALID_HANDLE             = &H80280401&

'//
'// MessageId: TPM_E_DUPLICATE_VHANDLE
'//
'// MessageText:
'//
'// The TPM returned a duplicate handle and the command needs to be resubmitted.
'//
%TPM_E_DUPLICATE_VHANDLE          = &H80280402&

'//
'// MessageId: TPM_E_EMBEDDED_COMMAND_BLOCKED
'//
'// MessageText:
'//
'// The command within the transport was blocked.
'//
%TPM_E_EMBEDDED_COMMAND_BLOCKED   = &H80280403&

'//
'// MessageId: TPM_E_EMBEDDED_COMMAND_UNSUPPORTED
'//
'// MessageText:
'//
'// The command within the transport is not supported.
'//
%TPM_E_EMBEDDED_COMMAND_UNSUPPORTED = &H80280404&

'//
'//  TPM non-fatal hardware errors {0x0800..0x08ff}
'//
'//
'// MessageId: TPM_E_RETRY
'//
'// MessageText:
'//
'// The TPM is too busy to respond to the command immediately, but the command could be resubmitted at a later time.
'//
%TPM_E_RETRY                      = &H80280800&

'//
'// MessageId: TPM_E_NEEDS_SELFTEST
'//
'// MessageText:
'//
'// SelfTestFull has not been run.
'//
%TPM_E_NEEDS_SELFTEST             = &H80280801&

'//
'// MessageId: TPM_E_DOING_SELFTEST
'//
'// MessageText:
'//
'// The TPM is currently executing a full selftest.
'//
%TPM_E_DOING_SELFTEST             = &H80280802&

'//
'// MessageId: TPM_E_DEFEND_LOCK_RUNNING
'//
'// MessageText:
'//
'// The TPM is defending against dictionary attacks and is in a time-out period.
'//
%TPM_E_DEFEND_LOCK_RUNNING        = &H80280803&

'//
'//   TPM Base Services error codes {0x4000..0x40ff}
'//
'//
'// MessageId: TBS_E_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal software error has been detected.
'//
%TBS_E_INTERNAL_ERROR             = &H80284001&

'//
'// MessageId: TBS_E_BAD_PARAMETER
'//
'// MessageText:
'//
'// One or more input parameters is bad.
'//
%TBS_E_BAD_PARAMETER              = &H80284002&

'//
'// MessageId: TBS_E_INVALID_OUTPUT_POINTER
'//
'// MessageText:
'//
'// A specified output pointer is bad.
'//
%TBS_E_INVALID_OUTPUT_POINTER     = &H80284003&

'//
'// MessageId: TBS_E_INVALID_CONTEXT
'//
'// MessageText:
'//
'// The specified context handle does not refer to a valid context.
'//
%TBS_E_INVALID_CONTEXT            = &H80284004&

'//
'// MessageId: TBS_E_INSUFFICIENT_BUFFER
'//
'// MessageText:
'//
'// A specified output buffer is too small.
'//
%TBS_E_INSUFFICIENT_BUFFER        = &H80284005&

'//
'// MessageId: TBS_E_IOERROR
'//
'// MessageText:
'//
'// An error occurred while communicating with the TPM.
'//
%TBS_E_IOERROR                    = &H80284006&

'//
'// MessageId: TBS_E_INVALID_CONTEXT_PARAM
'//
'// MessageText:
'//
'// One or more context parameters is invalid.
'//
%TBS_E_INVALID_CONTEXT_PARAM      = &H80284007&

'//
'// MessageId: TBS_E_SERVICE_NOT_RUNNING
'//
'// MessageText:
'//
'// The TBS service is not running and could not be started.
'//
%TBS_E_SERVICE_NOT_RUNNING        = &H80284008&

'//
'// MessageId: TBS_E_TOO_MANY_TBS_CONTEXTS
'//
'// MessageText:
'//
'// A new context could not be created because there are too many open contexts.
'//
%TBS_E_TOO_MANY_TBS_CONTEXTS      = &H80284009&

'//
'// MessageId: TBS_E_TOO_MANY_RESOURCES
'//
'// MessageText:
'//
'// A new virtual resource could not be created because there are too many open
'// virtual resources.
'//
%TBS_E_TOO_MANY_RESOURCES         = &H8028400A&

'//
'// MessageId: TBS_E_SERVICE_START_PENDING
'//
'// MessageText:
'//
'// The TBS service has been started but is not yet running.
'//
%TBS_E_SERVICE_START_PENDING      = &H8028400B&

'//
'// MessageId: TBS_E_PPI_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The physical presence interface is not supported.
'//
%TBS_E_PPI_NOT_SUPPORTED          = &H8028400C&

'//
'// MessageId: TBS_E_COMMAND_CANCELED
'//
'// MessageText:
'//
'// The command was canceled.
'//
%TBS_E_COMMAND_CANCELED           = &H8028400D&

'//
'// MessageId: TBS_E_BUFFER_TOO_LARGE
'//
'// MessageText:
'//
'// The input or output buffer is too large.
'//
%TBS_E_BUFFER_TOO_LARGE           = &H8028400E&

'//
'// MessageId: TBS_E_TPM_NOT_FOUND
'//
'// MessageText:
'//
'// A compatible Trusted Platform Module (TPM) Security Device cannot be found on this computer.
'//
%TBS_E_TPM_NOT_FOUND              = &H8028400F&

'//
'// MessageId: TBS_E_SERVICE_DISABLED
'//
'// MessageText:
'//
'// The TBS service has been disabled.
'//
%TBS_E_SERVICE_DISABLED           = &H80284010&

'//
'//   TPM API error codes {0x0100..0x01ff}
'//
'//
'// MessageId: TPMAPI_E_INVALID_STATE
'//
'// MessageText:
'//
'// The command buffer is not in the correct state.
'//
%TPMAPI_E_INVALID_STATE           = &H80290100&

'//
'// MessageId: TPMAPI_E_NOT_ENOUGH_DATA
'//
'// MessageText:
'//
'// The command buffer does not contain enough data to satisfy the request.
'//
%TPMAPI_E_NOT_ENOUGH_DATA         = &H80290101&

'//
'// MessageId: TPMAPI_E_TOO_MUCH_DATA
'//
'// MessageText:
'//
'// The command buffer cannot contain any more data.
'//
%TPMAPI_E_TOO_MUCH_DATA           = &H80290102&

'//
'// MessageId: TPMAPI_E_INVALID_OUTPUT_POINTER
'//
'// MessageText:
'//
'// One or more output parameters was NULL or invalid.
'//
%TPMAPI_E_INVALID_OUTPUT_POINTER  = &H80290103&

'//
'// MessageId: TPMAPI_E_INVALID_PARAMETER
'//
'// MessageText:
'//
'// One or more input parameters is invalid.
'//
%TPMAPI_E_INVALID_PARAMETER       = &H80290104&

'//
'// MessageId: TPMAPI_E_OUT_OF_MEMORY
'//
'// MessageText:
'//
'// Not enough memory was available to satisfy the request.
'//
%TPMAPI_E_OUT_OF_MEMORY           = &H80290105&

'//
'// MessageId: TPMAPI_E_BUFFER_TOO_SMALL
'//
'// MessageText:
'//
'// The specified buffer was too small.
'//
%TPMAPI_E_BUFFER_TOO_SMALL        = &H80290106&

'//
'// MessageId: TPMAPI_E_INTERNAL_ERROR
'//
'// MessageText:
'//
'// An internal error was detected.
'//
%TPMAPI_E_INTERNAL_ERROR          = &H80290107&

'//
'// MessageId: TPMAPI_E_ACCESS_DENIED
'//
'// MessageText:
'//
'// The caller does not have the appropriate rights to perform the requested
'// operation.
'//
%TPMAPI_E_ACCESS_DENIED           = &H80290108&

'//
'// MessageId: TPMAPI_E_AUTHORIZATION_FAILED
'//
'// MessageText:
'//
'// The specified authorization information was invalid.
'//
%TPMAPI_E_AUTHORIZATION_FAILED    = &H80290109&

'//
'// MessageId: TPMAPI_E_INVALID_CONTEXT_HANDLE
'//
'// MessageText:
'//
'// The specified context handle was not valid.
'//
%TPMAPI_E_INVALID_CONTEXT_HANDLE  = &H8029010A&

'//
'// MessageId: TPMAPI_E_TBS_COMMUNICATION_ERROR
'//
'// MessageText:
'//
'// An error occurred while communicating with the TBS.
'//
%TPMAPI_E_TBS_COMMUNICATION_ERROR = &H8029010B&

'//
'// MessageId: TPMAPI_E_TPM_COMMAND_ERROR
'//
'// MessageText:
'//
'// The TPM returned an unexpected result.
'//
%TPMAPI_E_TPM_COMMAND_ERROR       = &H8029010C&

'//
'// MessageId: TPMAPI_E_MESSAGE_TOO_LARGE
'//
'// MessageText:
'//
'// The message was too large for the encoding scheme.
'//
%TPMAPI_E_MESSAGE_TOO_LARGE       = &H8029010D&

'//
'// MessageId: TPMAPI_E_INVALID_ENCODING
'//
'// MessageText:
'//
'// The encoding in the blob was not recognized.
'//
%TPMAPI_E_INVALID_ENCODING        = &H8029010E&

'//
'// MessageId: TPMAPI_E_INVALID_KEY_SIZE
'//
'// MessageText:
'//
'// The key size is not valid.
'//
%TPMAPI_E_INVALID_KEY_SIZE        = &H8029010F&

'//
'// MessageId: TPMAPI_E_ENCRYPTION_FAILED
'//
'// MessageText:
'//
'// The encryption operation failed.
'//
%TPMAPI_E_ENCRYPTION_FAILED       = &H80290110&

'//
'// MessageId: TPMAPI_E_INVALID_KEY_PARAMS
'//
'// MessageText:
'//
'// The key parameters structure was not valid
'//
%TPMAPI_E_INVALID_KEY_PARAMS      = &H80290111&

'//
'// MessageId: TPMAPI_E_INVALID_MIGRATION_AUTHORIZATION_BLOB
'//
'// MessageText:
'//
'// The requested supplied data does not appear to be a valid migration authorization blob.
'//
%TPMAPI_E_INVALID_MIGRATION_AUTHORIZATION_BLOB = &H80290112&

'//
'// MessageId: TPMAPI_E_INVALID_PCR_INDEX
'//
'// MessageText:
'//
'// The specified PCR index was invalid
'//
%TPMAPI_E_INVALID_PCR_INDEX       = &H80290113&

'//
'// MessageId: TPMAPI_E_INVALID_DELEGATE_BLOB
'//
'// MessageText:
'//
'// The data given does not appear to be a valid delegate blob.
'//
%TPMAPI_E_INVALID_DELEGATE_BLOB   = &H80290114&

'//
'// MessageId: TPMAPI_E_INVALID_CONTEXT_PARAMS
'//
'// MessageText:
'//
'// One or more of the specified context parameters was not valid.
'//
%TPMAPI_E_INVALID_CONTEXT_PARAMS  = &H80290115&

'//
'// MessageId: TPMAPI_E_INVALID_KEY_BLOB
'//
'// MessageText:
'//
'// The data given does not appear to be a valid key blob
'//
%TPMAPI_E_INVALID_KEY_BLOB        = &H80290116&

'//
'// MessageId: TPMAPI_E_INVALID_PCR_DATA
'//
'// MessageText:
'//
'// The specified PCR data was invalid.
'//
%TPMAPI_E_INVALID_PCR_DATA        = &H80290117&

'//
'// MessageId: TPMAPI_E_INVALID_OWNER_AUTH
'//
'// MessageText:
'//
'// The format of the owner auth data was invalid.
'//
%TPMAPI_E_INVALID_OWNER_AUTH      = &H80290118&

'//
'// MessageId: TPMAPI_E_FIPS_RNG_CHECK_FAILED
'//
'// MessageText:
'//
'// The random number generated did not pass FIPS RNG check.
'//
%TPMAPI_E_FIPS_RNG_CHECK_FAILED   = &H80290119&

'//
'//   TBS implementation error codes {0x0200..0x02ff}
'//
'//
'// MessageId: TBSIMP_E_BUFFER_TOO_SMALL
'//
'// MessageText:
'//
'// The specified buffer was too small.
'//
%TBSIMP_E_BUFFER_TOO_SMALL        = &H80290200&

'//
'// MessageId: TBSIMP_E_CLEANUP_FAILED
'//
'// MessageText:
'//
'// The context could not be cleaned up.
'//
%TBSIMP_E_CLEANUP_FAILED          = &H80290201&

'//
'// MessageId: TBSIMP_E_INVALID_CONTEXT_HANDLE
'//
'// MessageText:
'//
'// The specified context handle is invalid.
'//
%TBSIMP_E_INVALID_CONTEXT_HANDLE  = &H80290202&

'//
'// MessageId: TBSIMP_E_INVALID_CONTEXT_PARAM
'//
'// MessageText:
'//
'// An invalid context parameter was specified.
'//
%TBSIMP_E_INVALID_CONTEXT_PARAM   = &H80290203&

'//
'// MessageId: TBSIMP_E_TPM_ERROR
'//
'// MessageText:
'//
'// An error occurred while communicating with the TPM
'//
%TBSIMP_E_TPM_ERROR               = &H80290204&

'//
'// MessageId: TBSIMP_E_HASH_BAD_KEY
'//
'// MessageText:
'//
'// No entry with the specified key was found.
'//
%TBSIMP_E_HASH_BAD_KEY            = &H80290205&

'//
'// MessageId: TBSIMP_E_DUPLICATE_VHANDLE
'//
'// MessageText:
'//
'// The specified virtual handle matches a virtual handle already in use.
'//
%TBSIMP_E_DUPLICATE_VHANDLE       = &H80290206&

'//
'// MessageId: TBSIMP_E_INVALID_OUTPUT_POINTER
'//
'// MessageText:
'//
'// The pointer to the returned handle location was NULL or invalid
'//
%TBSIMP_E_INVALID_OUTPUT_POINTER  = &H80290207&

'//
'// MessageId: TBSIMP_E_INVALID_PARAMETER
'//
'// MessageText:
'//
'// One or more parameters is invalid
'//
%TBSIMP_E_INVALID_PARAMETER       = &H80290208&

'//
'// MessageId: TBSIMP_E_RPC_INIT_FAILED
'//
'// MessageText:
'//
'// The RPC subsystem could not be initialized.
'//
%TBSIMP_E_RPC_INIT_FAILED         = &H80290209&

'//
'// MessageId: TBSIMP_E_SCHEDULER_NOT_RUNNING
'//
'// MessageText:
'//
'// The TBS scheduler is not running.
'//
%TBSIMP_E_SCHEDULER_NOT_RUNNING   = &H8029020A&

'//
'// MessageId: TBSIMP_E_COMMAND_CANCELED
'//
'// MessageText:
'//
'// The command was canceled.
'//
%TBSIMP_E_COMMAND_CANCELED        = &H8029020B&

'//
'// MessageId: TBSIMP_E_OUT_OF_MEMORY
'//
'// MessageText:
'//
'// There was not enough memory to fulfill the request
'//
%TBSIMP_E_OUT_OF_MEMORY           = &H8029020C&

'//
'// MessageId: TBSIMP_E_LIST_NO_MORE_ITEMS
'//
'// MessageText:
'//
'// The specified list is empty, or the iteration has reached the end of the list.
'//
%TBSIMP_E_LIST_NO_MORE_ITEMS      = &H8029020D&

'//
'// MessageId: TBSIMP_E_LIST_NOT_FOUND
'//
'// MessageText:
'//
'// The specified item was not found in the list.
'//
%TBSIMP_E_LIST_NOT_FOUND          = &H8029020E&

'//
'// MessageId: TBSIMP_E_NOT_ENOUGH_SPACE
'//
'// MessageText:
'//
'// The TPM does not have enough space to load the requested resource.
'//
%TBSIMP_E_NOT_ENOUGH_SPACE        = &H8029020F&

'//
'// MessageId: TBSIMP_E_NOT_ENOUGH_TPM_CONTEXTS
'//
'// MessageText:
'//
'// There are too many TPM contexts in use.
'//
%TBSIMP_E_NOT_ENOUGH_TPM_CONTEXTS = &H80290210&

'//
'// MessageId: TBSIMP_E_COMMAND_FAILED
'//
'// MessageText:
'//
'// The TPM command failed.
'//
%TBSIMP_E_COMMAND_FAILED          = &H80290211&

'//
'// MessageId: TBSIMP_E_UNKNOWN_ORDINAL
'//
'// MessageText:
'//
'// The TBS does not recognize the specified ordinal.
'//
%TBSIMP_E_UNKNOWN_ORDINAL         = &H80290212&

'//
'// MessageId: TBSIMP_E_RESOURCE_EXPIRED
'//
'// MessageText:
'//
'// The requested resource is no longer available.
'//
%TBSIMP_E_RESOURCE_EXPIRED        = &H80290213&

'//
'// MessageId: TBSIMP_E_INVALID_RESOURCE
'//
'// MessageText:
'//
'// The resource type did not match.
'//
%TBSIMP_E_INVALID_RESOURCE        = &H80290214&

'//
'// MessageId: TBSIMP_E_NOTHING_TO_UNLOAD
'//
'// MessageText:
'//
'// No resources can be unloaded.
'//
%TBSIMP_E_NOTHING_TO_UNLOAD       = &H80290215&

'//
'// MessageId: TBSIMP_E_HASH_TABLE_FULL
'//
'// MessageText:
'//
'// No new entries can be added to the hash table.
'//
%TBSIMP_E_HASH_TABLE_FULL         = &H80290216&

'//
'// MessageId: TBSIMP_E_TOO_MANY_TBS_CONTEXTS
'//
'// MessageText:
'//
'// A new TBS context could not be created because there are too many open contexts.
'//
%TBSIMP_E_TOO_MANY_TBS_CONTEXTS   = &H80290217&

'//
'// MessageId: TBSIMP_E_TOO_MANY_RESOURCES
'//
'// MessageText:
'//
'// A new virtual resource could not be created because there are too many open virtual resources.
'//
%TBSIMP_E_TOO_MANY_RESOURCES      = &H80290218&

'//
'// MessageId: TBSIMP_E_PPI_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The physical presence interface is not supported.
'//
%TBSIMP_E_PPI_NOT_SUPPORTED       = &H80290219&

'//
'// MessageId: TBSIMP_E_TPM_INCOMPATIBLE
'//
'// MessageText:
'//
'// TBS is not compatible with the version of TPM found on the system.
'//
%TBSIMP_E_TPM_INCOMPATIBLE        = &H8029021A&

'//
'//   TPM Physical Presence implementation error codes {0x0300..0x03ff}
'//
'//
'// MessageId: TPM_E_PPI_ACPI_FAILURE
'//
'// MessageText:
'//
'// A general error was detected when attempting to acquire the BIOS's response to a Physical Presence command.
'//
%TPM_E_PPI_ACPI_FAILURE           = &H80290300&

'//
'// MessageId: TPM_E_PPI_USER_ABORT
'//
'// MessageText:
'//
'// The user failed to confirm the TPM operation request.
'//
%TPM_E_PPI_USER_ABORT             = &H80290301&

'//
'// MessageId: TPM_E_PPI_BIOS_FAILURE
'//
'// MessageText:
'//
'// The BIOS failure prevented the successful execution of the requested TPM operation (e.g. invalid TPM operation request, BIOS communication error with the TPM).
'//
%TPM_E_PPI_BIOS_FAILURE           = &H80290302&

'//
'// MessageId: TPM_E_PPI_NOT_SUPPORTED
'//
'// MessageText:
'//
'// The BIOS does not support the physical presence interface.
'//
%TPM_E_PPI_NOT_SUPPORTED          = &H80290303&

'//
'// = ======================================================
'// Facility Performance Logs & Alerts (PLA) Error Messages
'// = ======================================================
'//
'//
'// MessageId: PLA_E_DCS_NOT_FOUND
'//
'// MessageText:
'//
'// Data Collector Set was not found.
'//
%PLA_E_DCS_NOT_FOUND              = &H80300002&

'//
'// MessageId: PLA_E_DCS_IN_USE
'//
'// MessageText:
'//
'// The Data Collector Set or one of its dependencies is already in use.
'//
%PLA_E_DCS_IN_USE                 = &H803000AA&

'//
'// MessageId: PLA_E_TOO_MANY_FOLDERS
'//
'// MessageText:
'//
'// Unable to start Data Collector Set because there are too many folders.
'//
%PLA_E_TOO_MANY_FOLDERS           = &H80300045&

'//
'// MessageId: PLA_E_NO_MIN_DISK
'//
'// MessageText:
'//
'// Not enough free disk space to start Data Collector Set.
'//
%PLA_E_NO_MIN_DISK                = &H80300070&

'//
'// MessageId: PLA_E_DCS_ALREADY_EXISTS
'//
'// MessageText:
'//
'// Data Collector Set already exists.
'//
%PLA_E_DCS_ALREADY_EXISTS         = &H803000B7&

'//
'// MessageId: PLA_S_PROPERTY_IGNORED
'//
'// MessageText:
'//
'// Property value will be ignored.
'//
%PLA_S_PROPERTY_IGNORED           = &H00300100&

'//
'// MessageId: PLA_E_PROPERTY_CONFLICT
'//
'// MessageText:
'//
'// Property value conflict.
'//
%PLA_E_PROPERTY_CONFLICT          = &H80300101&

'//
'// MessageId: PLA_E_DCS_SINGLETON_REQUIRED
'//
'// MessageText:
'//
'// The current configuration for this Data Collector Set requires that it contain exactly one Data Collector.
'//
%PLA_E_DCS_SINGLETON_REQUIRED     = &H80300102&

'//
'// MessageId: PLA_E_CREDENTIALS_REQUIRED
'//
'// MessageText:
'//
'// A user account is required in order to commit the current Data Collector Set properties.
'//
%PLA_E_CREDENTIALS_REQUIRED       = &H80300103&

'//
'// MessageId: PLA_E_DCS_NOT_RUNNING
'//
'// MessageText:
'//
'// Data Collector Set is not running.
'//
%PLA_E_DCS_NOT_RUNNING            = &H80300104&

'//
'// MessageId: PLA_E_CONFLICT_INCL_EXCL_API
'//
'// MessageText:
'//
'// A conflict was detected in the list of include/exclude APIs. Do not specify the same API in both the include list and the exclude list.
'//
%PLA_E_CONFLICT_INCL_EXCL_API     = &H80300105&

'//
'// MessageId: PLA_E_NETWORK_EXE_NOT_VALID
'//
'// MessageText:
'//
'// The executable path you have specified refers to a network share or UNC path.
'//
%PLA_E_NETWORK_EXE_NOT_VALID      = &H80300106&

'//
'// MessageId: PLA_E_EXE_ALREADY_CONFIGURED
'//
'// MessageText:
'//
'// The executable path you have specified is already configured for API tracing.
'//
%PLA_E_EXE_ALREADY_CONFIGURED     = &H80300107&

'//
'// MessageId: PLA_E_EXE_PATH_NOT_VALID
'//
'// MessageText:
'//
'// The executable path you have specified does not exist. Verify that the specified path is correct.
'//
%PLA_E_EXE_PATH_NOT_VALID         = &H80300108&

'//
'// MessageId: PLA_E_DC_ALREADY_EXISTS
'//
'// MessageText:
'//
'// Data Collector already exists.
'//
%PLA_E_DC_ALREADY_EXISTS          = &H80300109&

'//
'// MessageId: PLA_E_DCS_START_WAIT_TIMEOUT
'//
'// MessageText:
'//
'// The wait for the Data Collector Set start notification has timed out.
'//
%PLA_E_DCS_START_WAIT_TIMEOUT     = &H8030010A&

'//
'// MessageId: PLA_E_DC_START_WAIT_TIMEOUT
'//
'// MessageText:
'//
'// The wait for the Data Collector to start has timed out.
'//
%PLA_E_DC_START_WAIT_TIMEOUT      = &H8030010B&

'//
'// MessageId: PLA_E_REPORT_WAIT_TIMEOUT
'//
'// MessageText:
'//
'// The wait for the report generation tool to finish has timed out.
'//
%PLA_E_REPORT_WAIT_TIMEOUT        = &H8030010C&

'//
'// MessageId: PLA_E_NO_DUPLICATES
'//
'// MessageText:
'//
'// Duplicate items are not allowed.
'//
%PLA_E_NO_DUPLICATES              = &H8030010D&

'//
'// MessageId: PLA_E_EXE_FULL_PATH_REQUIRED
'//
'// MessageText:
'//
'// When specifying the executable that you want to trace, you must specify a full path to the executable and not just a filename.
'//
%PLA_E_EXE_FULL_PATH_REQUIRED     = &H8030010E&

'//
'// MessageId: PLA_E_INVALID_SESSION_NAME
'//
'// MessageText:
'//
'// The session name provided is invalid.
'//
%PLA_E_INVALID_SESSION_NAME       = &H8030010F&

'//
'// MessageId: PLA_E_PLA_CHANNEL_NOT_ENABLED
'//
'// MessageText:
'//
'// The Event Log channel Microsoft-Windows-Diagnosis-PLA/Operational must be enabled to perform this operation.
'//
%PLA_E_PLA_CHANNEL_NOT_ENABLED    = &H80300110&

'//
'// MessageId: PLA_E_TASKSCHED_CHANNEL_NOT_ENABLED
'//
'// MessageText:
'//
'// The Event Log channel Microsoft-Windows-TaskScheduler must be enabled to perform this operation.
'//
%PLA_E_TASKSCHED_CHANNEL_NOT_ENABLED = &H80300111&

'//
'// MessageId: PLA_E_RULES_MANAGER_FAILED
'//
'// MessageText:
'//
'// The execution of the Rules Manager failed.
'//
%PLA_E_RULES_MANAGER_FAILED       = &H80300112&

'//
'// MessageId: PLA_E_CABAPI_FAILURE
'//
'// MessageText:
'//
'// An error occured while attemption to compress or extract the data.
'//
%PLA_E_CABAPI_FAILURE             = &H80300113&

'//
'// = ======================================================
'// Full Volume Encryption Error Messages
'// = ======================================================
'//
'//
'// MessageId: FVE_E_LOCKED_VOLUME
'//
'// MessageText:
'//
'// This volume is locked by BitLocker Drive Encryption. Return to the control panel to unlock volume.
'//
%FVE_E_LOCKED_VOLUME              = &H80310000&

'//
'// MessageId: FVE_E_NOT_ENCRYPTED
'//
'// MessageText:
'//
'// The volume is not encrypted, no key is available.
'//
%FVE_E_NOT_ENCRYPTED              = &H80310001&

'//
'// MessageId: FVE_E_NO_TPM_BIOS
'//
'// MessageText:
'//
'// The BIOS did not correctly communicate with the TPM. Contact the computer manufacturer for BIOS upgrade instructions.
'//
%FVE_E_NO_TPM_BIOS                = &H80310002&

'//
'// MessageId: FVE_E_NO_MBR_METRIC
'//
'// MessageText:
'//
'// The BIOS did not correctly communicate with the Master Boot Record (MBR). Contact the computer manufacturer for BIOS upgrade instructions.
'//
%FVE_E_NO_MBR_METRIC              = &H80310003&

'//
'// MessageId: FVE_E_NO_BOOTSECTOR_METRIC
'//
'// MessageText:
'//
'// If there is a bootable CD or DVD in your computer, remove it, restart the computer and turn on BitLocker again. If the problem persists contact the computer manufacturer for BIOS upgrade instructions.
'//
%FVE_E_NO_BOOTSECTOR_METRIC       = &H80310004&

'//
'// MessageId: FVE_E_NO_BOOTMGR_METRIC
'//
'// MessageText:
'//
'// You have an incompatible boot sector.  Update the boot manager (BOOTMGR).
'//
%FVE_E_NO_BOOTMGR_METRIC          = &H80310005&

'//
'// MessageId: FVE_E_WRONG_BOOTMGR
'//
'// MessageText:
'//
'// You have an incompatible boot manager. Update the boot manager (BOOTMGR).
'//
%FVE_E_WRONG_BOOTMGR              = &H80310006&

'//
'// MessageId: FVE_E_SECURE_KEY_REQUIRED
'//
'// MessageText:
'//
'// No secure key protector has been defined.
'//
%FVE_E_SECURE_KEY_REQUIRED        = &H80310007&

'//
'// MessageId: FVE_E_NOT_ACTIVATED
'//
'// MessageText:
'//
'// BitLocker Drive Encryption is not enabled on this volume. Turn on BitLocker.
'//
%FVE_E_NOT_ACTIVATED              = &H80310008&

'//
'// MessageId: FVE_E_ACTION_NOT_ALLOWED
'//
'// MessageText:
'//
'// BitLocker Drive Encryption could not perform requested action. This condition may occur when two requests are issued at the same time.
'//
%FVE_E_ACTION_NOT_ALLOWED         = &H80310009&

'//
'// MessageId: FVE_E_AD_SCHEMA_NOT_INSTALLED
'//
'// MessageText:
'//
'// The Active Directory Domain Services forest does not contain the required attributes and classes to host BitLocker Drive Encryption or Trusted Platform Module information.
'//
%FVE_E_AD_SCHEMA_NOT_INSTALLED    = &H8031000A&

'//
'// MessageId: FVE_E_AD_INVALID_DATATYPE
'//
'// MessageText:
'//
'// The type of the data obtained from Active Directory was not expected.
'//
%FVE_E_AD_INVALID_DATATYPE        = &H8031000B&

'//
'// MessageId: FVE_E_AD_INVALID_DATASIZE
'//
'// MessageText:
'//
'// The size of the data obtained from Active Directory was not expected.
'//
%FVE_E_AD_INVALID_DATASIZE        = &H8031000C&

'//
'// MessageId: FVE_E_AD_NO_VALUES
'//
'// MessageText:
'//
'// The attribute read from Active Directory has no (zero) values.
'//
%FVE_E_AD_NO_VALUES               = &H8031000D&

'//
'// MessageId: FVE_E_AD_ATTR_NOT_SET
'//
'// MessageText:
'//
'// The attribute was not set.
'//
%FVE_E_AD_ATTR_NOT_SET            = &H8031000E&

'//
'// MessageId: FVE_E_AD_GUID_NOT_FOUND
'//
'// MessageText:
'//
'// The specified GUID could not be found.
'//
%FVE_E_AD_GUID_NOT_FOUND          = &H8031000F&

'//
'// MessageId: FVE_E_BAD_INFORMATION
'//
'// MessageText:
'//
'// The control block for the encrypted volume is not valid.
'//
%FVE_E_BAD_INFORMATION            = &H80310010&

'//
'// MessageId: FVE_E_TOO_SMALL
'//
'// MessageText:
'//
'// The volume cannot be encrypted because it does not have enough free space.
'//
%FVE_E_TOO_SMALL                  = &H80310011&

'//
'// MessageId: FVE_E_SYSTEM_VOLUME
'//
'// MessageText:
'//
'// The volume cannot be encrypted because it contains system boot information.
'//
%FVE_E_SYSTEM_VOLUME              = &H80310012&

'//
'// MessageId: FVE_E_FAILED_WRONG_FS
'//
'// MessageText:
'//
'// The volume cannot be encrypted because the file system is not supported.
'//
%FVE_E_FAILED_WRONG_FS            = &H80310013&

'//
'// MessageId: FVE_E_FAILED_BAD_FS
'//
'// MessageText:
'//
'// The file system is corrupt. Run CHKDSK.
'//
%FVE_E_FAILED_BAD_FS              = &H80310014&

'//
'// MessageId: FVE_E_NOT_SUPPORTED
'//
'// MessageText:
'//
'// This volume cannot be encrypted.
'//
%FVE_E_NOT_SUPPORTED              = &H80310015&

'//
'// MessageId: FVE_E_BAD_DATA
'//
'// MessageText:
'//
'// Data supplied is malformed.
'//
%FVE_E_BAD_DATA                   = &H80310016&

'//
'// MessageId: FVE_E_VOLUME_NOT_BOUND
'//
'// MessageText:
'//
'// Volume is not bound to the system.
'//
%FVE_E_VOLUME_NOT_BOUND           = &H80310017&

'//
'// MessageId: FVE_E_TPM_NOT_OWNED
'//
'// MessageText:
'//
'// You must take ownership of the Trusted Platform Module (TPM).
'//
%FVE_E_TPM_NOT_OWNED              = &H80310018&

'//
'// MessageId: FVE_E_NOT_DATA_VOLUME
'//
'// MessageText:
'//
'// The volume specified is not a data volume.
'//
%FVE_E_NOT_DATA_VOLUME            = &H80310019&

'//
'// MessageId: FVE_E_AD_INSUFFICIENT_BUFFER
'//
'// MessageText:
'//
'// The buffer supplied to a function was insufficient to contain the returned data.
'//
%FVE_E_AD_INSUFFICIENT_BUFFER     = &H8031001A&

'//
'// MessageId: FVE_E_CONV_READ
'//
'// MessageText:
'//
'// A read operation failed while converting the volume.
'//
%FVE_E_CONV_READ                  = &H8031001B&

'//
'// MessageId: FVE_E_CONV_WRITE
'//
'// MessageText:
'//
'// A write operation failed while converting the volume.
'//
%FVE_E_CONV_WRITE                 = &H8031001C&

'//
'// MessageId: FVE_E_KEY_REQUIRED
'//
'// MessageText:
'//
'// One or more key protectors are required for this volume.
'//
%FVE_E_KEY_REQUIRED               = &H8031001D&

'//
'// MessageId: FVE_E_CLUSTERING_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Cluster configurations are not supported.
'//
%FVE_E_CLUSTERING_NOT_SUPPORTED   = &H8031001E&

'//
'// MessageId: FVE_E_VOLUME_BOUND_ALREADY
'//
'// MessageText:
'//
'// The volume is already bound to the system.
'//
%FVE_E_VOLUME_BOUND_ALREADY       = &H8031001F&

'//
'// MessageId: FVE_E_OS_NOT_PROTECTED
'//
'// MessageText:
'//
'// The operating system volume is not protected by BitLocker Drive Encryption.
'//
%FVE_E_OS_NOT_PROTECTED           = &H80310020&

'//
'// MessageId: FVE_E_PROTECTION_DISABLED
'//
'// MessageText:
'//
'// All protectors are effectively disabled (clear key exists).
'//
%FVE_E_PROTECTION_DISABLED        = &H80310021&

'//
'// MessageId: FVE_E_RECOVERY_KEY_REQUIRED
'//
'// MessageText:
'//
'// A recovery key protector is required.
'//
%FVE_E_RECOVERY_KEY_REQUIRED      = &H80310022&

'//
'// MessageId: FVE_E_FOREIGN_VOLUME
'//
'// MessageText:
'//
'// This volume cannot be bound to a TPM.
'//
%FVE_E_FOREIGN_VOLUME             = &H80310023&

'//
'// MessageId: FVE_E_OVERLAPPED_UPDATE
'//
'// MessageText:
'//
'// The control block for the encrypted volume was updated by another thread. Try again.
'//
%FVE_E_OVERLAPPED_UPDATE          = &H80310024&

'//
'// MessageId: FVE_E_TPM_SRK_AUTH_NOT_ZERO
'//
'// MessageText:
'//
'// The authorization data for the Storage Root Key (SRK) of the Trusted Platform Module (TPM) is not zero and is therefore incompatible with BitLocker.
'//
%FVE_E_TPM_SRK_AUTH_NOT_ZERO      = &H80310025&

'//
'// MessageId: FVE_E_FAILED_SECTOR_SIZE
'//
'// MessageText:
'//
'// The volume encryption algorithm cannot be used on this sector size.
'//
%FVE_E_FAILED_SECTOR_SIZE         = &H80310026&

'//
'// MessageId: FVE_E_FAILED_AUTHENTICATION
'//
'// MessageText:
'//
'// The recovery information provided does not match required recovery information to unlock the volume. Confirm the information and try again.
'//
%FVE_E_FAILED_AUTHENTICATION      = &H80310027&

'//
'// MessageId: FVE_E_NOT_OS_VOLUME
'//
'// MessageText:
'//
'// The volume specified is not the operating system volume.
'//
%FVE_E_NOT_OS_VOLUME              = &H80310028&

'//
'// MessageId: FVE_E_AUTOUNLOCK_ENABLED
'//
'// MessageText:
'//
'// BitLocker Drive Encryption cannot be turned off. Please turn off the auto unlock on all other volumes before turning off BitLocker on the current volume.
'//
%FVE_E_AUTOUNLOCK_ENABLED         = &H80310029&

'//
'// MessageId: FVE_E_WRONG_BOOTSECTOR
'//
'// MessageText:
'//
'// The system partition boot sector does not perform TPM measurements.
'//
%FVE_E_WRONG_BOOTSECTOR           = &H8031002A&

'//
'// MessageId: FVE_E_WRONG_SYSTEM_FS
'//
'// MessageText:
'//
'// BitLocker requires the file system to be NTFS. Convert the volume to NTFS, then enable BitLocker.
'//
%FVE_E_WRONG_SYSTEM_FS            = &H8031002B&

'//
'// MessageId: FVE_E_POLICY_PASSWORD_REQUIRED
'//
'// MessageText:
'//
'// Group policy requires a recovery password before encryption may begin.
'//
%FVE_E_POLICY_PASSWORD_REQUIRED   = &H8031002C&

'//
'// MessageId: FVE_E_CANNOT_SET_FVEK_ENCRYPTED
'//
'// MessageText:
'//
'// The volume encryption algorithm and key cannot be set on an encrypted volume.
'//
%FVE_E_CANNOT_SET_FVEK_ENCRYPTED  = &H8031002D&

'//
'// MessageId: FVE_E_CANNOT_ENCRYPT_NO_KEY
'//
'// MessageText:
'//
'// A key must be specified before encryption may begin.
'//
%FVE_E_CANNOT_ENCRYPT_NO_KEY      = &H8031002E&

'//
'// MessageId: FVE_E_BOOTABLE_CDDVD
'//
'// MessageText:
'//
'// BitLocker Drive Encryption detected bootable media (CD, DVD, or USB) in the computer. Remove the media and restart the computer.
'//
%FVE_E_BOOTABLE_CDDVD             = &H80310030&

'//
'// MessageId: FVE_E_PROTECTOR_EXISTS
'//
'// MessageText:
'//
'// An instance of this key protector already exists on the volume.
'//
%FVE_E_PROTECTOR_EXISTS           = &H80310031&

'//
'// MessageId: FVE_E_RELATIVE_PATH
'//
'// MessageText:
'//
'// The file cannot be saved to a relative path.
'//
%FVE_E_RELATIVE_PATH              = &H80310032&

'//
'// MessageId: FVE_E_PROTECTOR_NOT_FOUND
'//
'// MessageText:
'//
'// The specified key protector was not found on the volume. Try another key protector.
'//
%FVE_E_PROTECTOR_NOT_FOUND        = &H80310033&

'//
'// MessageId: FVE_E_INVALID_KEY_FORMAT
'//
'// MessageText:
'//
'// The recovery password file on the USB device is corrupt. Try another USB device.
'//
%FVE_E_INVALID_KEY_FORMAT         = &H80310034&

'//
'// MessageId: FVE_E_INVALID_PASSWORD_FORMAT
'//
'// MessageText:
'//
'// The format of the recovery password file is invalid. Select another recovery password and try again.
'//
%FVE_E_INVALID_PASSWORD_FORMAT    = &H80310035&

'//
'// MessageId: FVE_E_FIPS_RNG_CHECK_FAILED
'//
'// MessageText:
'//
'// The random number generator check test failed.
'//
%FVE_E_FIPS_RNG_CHECK_FAILED      = &H80310036&

'//
'// MessageId: FVE_E_FIPS_PREVENTS_RECOVERY_PASSWORD
'//
'// MessageText:
'//
'// The group policy setting requiring FIPS compliance prevented the recovery password from being generated or used. Please contact your domain administrator for more information.
'//
%FVE_E_FIPS_PREVENTS_RECOVERY_PASSWORD = &H80310037&

'//
'// MessageId: FVE_E_FIPS_PREVENTS_EXTERNAL_KEY_EXPORT
'//
'// MessageText:
'//
'// The group policy setting requiring FIPS compliance prevented the recovery password from being saved. Please contact your domain administrator for more information.
'//
%FVE_E_FIPS_PREVENTS_EXTERNAL_KEY_EXPORT = &H80310038&

'//
'// MessageId: FVE_E_NOT_DECRYPTED
'//
'// MessageText:
'//
'// The volume must be fully decrypted to complete this operation.
'//
%FVE_E_NOT_DECRYPTED              = &H80310039&

'//
'// MessageId: FVE_E_INVALID_PROTECTOR_TYPE
'//
'// MessageText:
'//
'// The specified key protector is not of the correct type.
'//
%FVE_E_INVALID_PROTECTOR_TYPE     = &H8031003A&

'//
'// MessageId: FVE_E_NO_PROTECTORS_TO_TEST
'//
'// MessageText:
'//
'// No TPM protectors exist on the volume to perform the hardware test.
'//
%FVE_E_NO_PROTECTORS_TO_TEST      = &H8031003B&

'//
'// MessageId: FVE_E_KEYFILE_NOT_FOUND
'//
'// MessageText:
'//
'// The BitLocker startup key or recovery password could not be read from the USB device. Ensure the USB device is plugged into the computer, then turn on BitLocker and try again. If the problem persists contact the computer
'// manufacturer for BIOS upgrade instructions.
'//
%FVE_E_KEYFILE_NOT_FOUND          = &H8031003C&

'//
'// MessageId: FVE_E_KEYFILE_INVALID
'//
'// MessageText:
'//
'// The BitLocker startup key or recovery password file is corrupt or invalid.
'//
%FVE_E_KEYFILE_INVALID            = &H8031003D&

'//
'// MessageId: FVE_E_KEYFILE_NO_VMK
'//
'// MessageText:
'//
'// The BitLocker encryption key could not be obtained from the startup key or recovery password.
'//
%FVE_E_KEYFILE_NO_VMK             = &H8031003E&

'//
'// MessageId: FVE_E_TPM_DISABLED
'//
'// MessageText:
'//
'// The Trusted Platform Module (TPM) is disabled.
'//
%FVE_E_TPM_DISABLED               = &H8031003F&

'//
'// MessageId: FVE_E_NOT_ALLOWED_IN_SAFE_MODE
'//
'// MessageText:
'//
'// BitLocker Drive Encryption can only be used for recovery purposes in Safe-Mode.
'//
%FVE_E_NOT_ALLOWED_IN_SAFE_MODE   = &H80310040&

'//
'// MessageId: FVE_E_TPM_INVALID_PCR
'//
'// MessageText:
'//
'// The Trusted Platform Module (TPM) was not able to unlock the volume because the system boot information changed.
'//
%FVE_E_TPM_INVALID_PCR            = &H80310041&

'//
'// MessageId: FVE_E_TPM_NO_VMK
'//
'// MessageText:
'//
'// The BitLocker encryption key could not be obtained from the Trusted Platform Module (TPM).
'//
%FVE_E_TPM_NO_VMK                 = &H80310042&

'//
'// MessageId: FVE_E_PIN_INVALID
'//
'// MessageText:
'//
'// The BitLocker encryption key could not be obtained from the Trusted Platform Module (TPM) and PIN.
'//
%FVE_E_PIN_INVALID                = &H80310043&

'//
'// MessageId: FVE_E_AUTH_INVALID_APPLICATION
'//
'// MessageText:
'//
'// A boot application has changed since BitLocker was enabled.
'//
%FVE_E_AUTH_INVALID_APPLICATION   = &H80310044&

'//
'// MessageId: FVE_E_AUTH_INVALID_CONFIG
'//
'// MessageText:
'//
'// The Boot Configuration Data (BCD) settings have changed since BitLocker was enabled.
'//
%FVE_E_AUTH_INVALID_CONFIG        = &H80310045&

'//
'// MessageId: FVE_E_FIPS_DISABLE_PROTECTION_NOT_ALLOWED
'//
'// MessageText:
'//
'// The group policy setting requiring FIPS compliance prevented BitLocker from being disabled. Please contact your domain administrator for more information.
'//
%FVE_E_FIPS_DISABLE_PROTECTION_NOT_ALLOWED = &H80310046&

'//
'// MessageId: FVE_E_FS_NOT_EXTENDED
'//
'// MessageText:
'//
'// The file system does not extend to the end of the volume.
'//
%FVE_E_FS_NOT_EXTENDED            = &H80310047&

'//
'// MessageId: FVE_E_FIRMWARE_TYPE_NOT_SUPPORTED
'//
'// MessageText:
'//
'// BitLocker Drive Encryption cannot be enabled on this computer. Contact the computer manufacturer for BIOS upgrade instructions.
'//
%FVE_E_FIRMWARE_TYPE_NOT_SUPPORTED = &H80310048&

'//
'// MessageId: FVE_E_NO_LICENSE
'//
'// MessageText:
'//
'// This Windows license does not support BitLocker Drive Encryption. To use BitLocker Drive Encryption, please upgrade your Windows license.
'//
%FVE_E_NO_LICENSE                 = &H80310049&

'//
'// MessageId: FVE_E_NOT_ON_STACK
'//
'// MessageText:
'//
'// Critical BitLocker Drive Encryption system files are not available. Use Windows Startup Repair to restore files.
'//
%FVE_E_NOT_ON_STACK               = &H8031004A&

'//
'// MessageId: FVE_E_FS_MOUNTED
'//
'// MessageText:
'//
'// This operation cannot be performed while the volume is in use.
'//
%FVE_E_FS_MOUNTED                 = &H8031004B&

'//
'// MessageId: FVE_E_TOKEN_NOT_IMPERSONATED
'//
'// MessageText:
'//
'// The access token associated with the current thread is not an impersonated token.
'//
%FVE_E_TOKEN_NOT_IMPERSONATED     = &H8031004C&

'//
'// MessageId: FVE_E_DRY_RUN_FAILED
'//
'// MessageText:
'//
'// The BitLocker encryption key could not be obtained.
'//
%FVE_E_DRY_RUN_FAILED             = &H8031004D&

'//
'// MessageId: FVE_E_REBOOT_REQUIRED
'//
'// MessageText:
'//
'// No action was taken as a system reboot is required.
'//
%FVE_E_REBOOT_REQUIRED            = &H8031004E&

'//
'// MessageId: FVE_E_DEBUGGER_ENABLED
'//
'// MessageText:
'//
'// Boot debugging is enabled.  Run bcdedit to turn it off.
'//
%FVE_E_DEBUGGER_ENABLED           = &H8031004F&

'//
'// MessageId: FVE_E_RAW_ACCESS
'//
'// MessageText:
'//
'// No action was taken as BitLocker Drive Encryption is in raw access mode.
'//
%FVE_E_RAW_ACCESS                 = &H80310050&

'//
'// MessageId: FVE_E_RAW_BLOCKED
'//
'// MessageText:
'//
'// BitLocker Drive Encryption cannot enter raw access mode for this volume.
'//
%FVE_E_RAW_BLOCKED                = &H80310051&

'//
'// MessageId: FVE_E_BCD_APPLICATIONS_PATH_INCORRECT
'//
'// MessageText:
'//
'// The path specified in the Boot Configuration Data (BCD) for a BitLocker Drive Encryption integrity-protected application is incorrect. Please verify and correct your BCD settings and try again.
'//
%FVE_E_BCD_APPLICATIONS_PATH_INCORRECT = &H80310052&

'//
'// MessageId: FVE_E_NOT_ALLOWED_IN_VERSION
'//
'// MessageText:
'//
'// BitLocker Drive Encryption can only be used for recovery purposes in this version of Windows.
'//
%FVE_E_NOT_ALLOWED_IN_VERSION     = &H80310053&

'//
'// = ======================================================
'// Windows Filtering Platform Error Messages
'// = ======================================================
'//
'//
'// MessageId: FWP_E_CALLOUT_NOT_FOUND
'//
'// MessageText:
'//
'// The callout does not exist.
'//
%FWP_E_CALLOUT_NOT_FOUND          = &H80320001&

'//
'// MessageId: FWP_E_CONDITION_NOT_FOUND
'//
'// MessageText:
'//
'// The filter condition does not exist.
'//
%FWP_E_CONDITION_NOT_FOUND        = &H80320002&

'//
'// MessageId: FWP_E_FILTER_NOT_FOUND
'//
'// MessageText:
'//
'// The filter does not exist.
'//
%FWP_E_FILTER_NOT_FOUND           = &H80320003&

'//
'// MessageId: FWP_E_LAYER_NOT_FOUND
'//
'// MessageText:
'//
'// The layer does not exist.
'//
%FWP_E_LAYER_NOT_FOUND            = &H80320004&

'//
'// MessageId: FWP_E_PROVIDER_NOT_FOUND
'//
'// MessageText:
'//
'// The provider does not exist.
'//
%FWP_E_PROVIDER_NOT_FOUND         = &H80320005&

'//
'// MessageId: FWP_E_PROVIDER_CONTEXT_NOT_FOUND
'//
'// MessageText:
'//
'// The provider context does not exist.
'//
%FWP_E_PROVIDER_CONTEXT_NOT_FOUND = &H80320006&

'//
'// MessageId: FWP_E_SUBLAYER_NOT_FOUND
'//
'// MessageText:
'//
'// The sublayer does not exist.
'//
%FWP_E_SUBLAYER_NOT_FOUND         = &H80320007&

'//
'// MessageId: FWP_E_NOT_FOUND
'//
'// MessageText:
'//
'// The object does not exist.
'//
%FWP_E_NOT_FOUND                  = &H80320008&

'//
'// MessageId: FWP_E_ALREADY_EXISTS
'//
'// MessageText:
'//
'// An object with that GUID or LUID already exists.
'//
%FWP_E_ALREADY_EXISTS             = &H80320009&

'//
'// MessageId: FWP_E_IN_USE
'//
'// MessageText:
'//
'// The object is referenced by other objects so cannot be deleted.
'//
%FWP_E_IN_USE                     = &H8032000A&

'//
'// MessageId: FWP_E_DYNAMIC_SESSION_IN_PROGRESS
'//
'// MessageText:
'//
'// The call is not allowed from within a dynamic session.
'//
%FWP_E_DYNAMIC_SESSION_IN_PROGRESS = &H8032000B&

'//
'// MessageId: FWP_E_WRONG_SESSION
'//
'// MessageText:
'//
'// The call was made from the wrong session so cannot be completed.
'//
%FWP_E_WRONG_SESSION              = &H8032000C&

'//
'// MessageId: FWP_E_NO_TXN_IN_PROGRESS
'//
'// MessageText:
'//
'// The call must be made from within an explicit transaction.
'//
%FWP_E_NO_TXN_IN_PROGRESS         = &H8032000D&

'//
'// MessageId: FWP_E_TXN_IN_PROGRESS
'//
'// MessageText:
'//
'// The call is not allowed from within an explicit transaction.
'//
%FWP_E_TXN_IN_PROGRESS            = &H8032000E&

'//
'// MessageId: FWP_E_TXN_ABORTED
'//
'// MessageText:
'//
'// The explicit transaction has been forcibly cancelled.
'//
%FWP_E_TXN_ABORTED                = &H8032000F&

'//
'// MessageId: FWP_E_SESSION_ABORTED
'//
'// MessageText:
'//
'// The session has been cancelled.
'//
%FWP_E_SESSION_ABORTED            = &H80320010&

'//
'// MessageId: FWP_E_INCOMPATIBLE_TXN
'//
'// MessageText:
'//
'// The call is not allowed from within a read-only transaction.
'//
%FWP_E_INCOMPATIBLE_TXN           = &H80320011&

'//
'// MessageId: FWP_E_TIMEOUT
'//
'// MessageText:
'//
'// The call timed out while waiting to acquire the transaction lock.
'//
%FWP_E_TIMEOUT                    = &H80320012&

'//
'// MessageId: FWP_E_NET_EVENTS_DISABLED
'//
'// MessageText:
'//
'// Collection of network diagnostic events is disabled.
'//
%FWP_E_NET_EVENTS_DISABLED        = &H80320013&

'//
'// MessageId: FWP_E_INCOMPATIBLE_LAYER
'//
'// MessageText:
'//
'// The operation is not supported by the specified layer.
'//
%FWP_E_INCOMPATIBLE_LAYER         = &H80320014&

'//
'// MessageId: FWP_E_KM_CLIENTS_ONLY
'//
'// MessageText:
'//
'// The call is allowed for kernel-mode callers only.
'//
%FWP_E_KM_CLIENTS_ONLY            = &H80320015&

'//
'// MessageId: FWP_E_LIFETIME_MISMATCH
'//
'// MessageText:
'//
'// The call tried to associate two objects with incompatible lifetimes.
'//
%FWP_E_LIFETIME_MISMATCH          = &H80320016&

'//
'// MessageId: FWP_E_BUILTIN_OBJECT
'//
'// MessageText:
'//
'// The object is built in so cannot be deleted.
'//
%FWP_E_BUILTIN_OBJECT             = &H80320017&

'//
'// MessageId: FWP_E_TOO_MANY_CALLOUTS
'//
'// MessageText:
'//
'// The maximum number of callouts has been reached.
'//
%FWP_E_TOO_MANY_CALLOUTS          = &H80320018&

'//
'// MessageId: FWP_E_NOTIFICATION_DROPPED
'//
'// MessageText:
'//
'// A notification could not be delivered because a message queue is at its maximum capacity.
'//
%FWP_E_NOTIFICATION_DROPPED       = &H80320019&

'//
'// MessageId: FWP_E_TRAFFIC_MISMATCH
'//
'// MessageText:
'//
'// The traffic parameters do not match those for the security association context.
'//
%FWP_E_TRAFFIC_MISMATCH           = &H8032001A&

'//
'// MessageId: FWP_E_INCOMPATIBLE_SA_STATE
'//
'// MessageText:
'//
'// The call is not allowed for the current security association state.
'//
%FWP_E_INCOMPATIBLE_SA_STATE      = &H8032001B&

'//
'// MessageId: FWP_E_NULL_POINTER
'//
'// MessageText:
'//
'// A required pointer is null.
'//
%FWP_E_NULL_POINTER               = &H8032001C&

'//
'// MessageId: FWP_E_INVALID_ENUMERATOR
'//
'// MessageText:
'//
'// An enumerator is not valid.
'//
%FWP_E_INVALID_ENUMERATOR         = &H8032001D&

'//
'// MessageId: FWP_E_INVALID_FLAGS
'//
'// MessageText:
'//
'// The flags field contains an invalid value.
'//
%FWP_E_INVALID_FLAGS              = &H8032001E&

'//
'// MessageId: FWP_E_INVALID_NET_MASK
'//
'// MessageText:
'//
'// A network mask is not valid.
'//
%FWP_E_INVALID_NET_MASK           = &H8032001F&

'//
'// MessageId: FWP_E_INVALID_RANGE
'//
'// MessageText:
'//
'// An FWP_RANGE is not valid.
'//
%FWP_E_INVALID_RANGE              = &H80320020&

'//
'// MessageId: FWP_E_INVALID_INTERVAL
'//
'// MessageText:
'//
'// The time interval is not valid.
'//
%FWP_E_INVALID_INTERVAL           = &H80320021&

'//
'// MessageId: FWP_E_ZERO_LENGTH_ARRAY
'//
'// MessageText:
'//
'// An array that must contain at least one element is zero length.
'//
%FWP_E_ZERO_LENGTH_ARRAY          = &H80320022&

'//
'// MessageId: FWP_E_NULL_DISPLAY_NAME
'//
'// MessageText:
'//
'// The displayData.name field cannot be null.
'//
%FWP_E_NULL_DISPLAY_NAME          = &H80320023&

'//
'// MessageId: FWP_E_INVALID_ACTION_TYPE
'//
'// MessageText:
'//
'// The action type is not one of the allowed action types for a filter.
'//
%FWP_E_INVALID_ACTION_TYPE        = &H80320024&

'//
'// MessageId: FWP_E_INVALID_WEIGHT
'//
'// MessageText:
'//
'// The filter weight is not valid.
'//
%FWP_E_INVALID_WEIGHT             = &H80320025&

'//
'// MessageId: FWP_E_MATCH_TYPE_MISMATCH
'//
'// MessageText:
'//
'// A filter condition contains a match type that is not compatible with the operands.
'//
%FWP_E_MATCH_TYPE_MISMATCH        = &H80320026&

'//
'// MessageId: FWP_E_TYPE_MISMATCH
'//
'// MessageText:
'//
'// An FWP_VALUE or FWPM_CONDITION_VALUE is of the wrong type.
'//
%FWP_E_TYPE_MISMATCH              = &H80320027&

'//
'// MessageId: FWP_E_OUT_OF_BOUNDS
'//
'// MessageText:
'//
'// An integer value is outside the allowed range.
'//
%FWP_E_OUT_OF_BOUNDS              = &H80320028&

'//
'// MessageId: FWP_E_RESERVED
'//
'// MessageText:
'//
'// A reserved field is non-zero.
'//
%FWP_E_RESERVED                   = &H80320029&

'//
'// MessageId: FWP_E_DUPLICATE_CONDITION
'//
'// MessageText:
'//
'// A filter cannot contain multiple conditions operating on a single field.
'//
%FWP_E_DUPLICATE_CONDITION        = &H8032002A&

'//
'// MessageId: FWP_E_DUPLICATE_KEYMOD
'//
'// MessageText:
'//
'// A policy cannot contain the same keying module more than once.
'//
%FWP_E_DUPLICATE_KEYMOD           = &H8032002B&

'//
'// MessageId: FWP_E_ACTION_INCOMPATIBLE_WITH_LAYER
'//
'// MessageText:
'//
'// The action type is not compatible with the layer.
'//
%FWP_E_ACTION_INCOMPATIBLE_WITH_LAYER = &H8032002C&

'//
'// MessageId: FWP_E_ACTION_INCOMPATIBLE_WITH_SUBLAYER
'//
'// MessageText:
'//
'// The action type is not compatible with the sublayer.
'//
%FWP_E_ACTION_INCOMPATIBLE_WITH_SUBLAYER = &H8032002D&

'//
'// MessageId: FWP_E_CONTEXT_INCOMPATIBLE_WITH_LAYER
'//
'// MessageText:
'//
'// The raw context or the provider context is not compatible with the layer.
'//
%FWP_E_CONTEXT_INCOMPATIBLE_WITH_LAYER = &H8032002E&

'//
'// MessageId: FWP_E_CONTEXT_INCOMPATIBLE_WITH_CALLOUT
'//
'// MessageText:
'//
'// The raw context or the provider context is not compatible with the callout.
'//
%FWP_E_CONTEXT_INCOMPATIBLE_WITH_CALLOUT = &H8032002F&

'//
'// MessageId: FWP_E_INCOMPATIBLE_AUTH_METHOD
'//
'// MessageText:
'//
'// The authentication method is not compatible with the policy type.
'//
%FWP_E_INCOMPATIBLE_AUTH_METHOD   = &H80320030&

'//
'// MessageId: FWP_E_INCOMPATIBLE_DH_GROUP
'//
'// MessageText:
'//
'// The Diffie-Hellman group is not compatible with the policy type.
'//
%FWP_E_INCOMPATIBLE_DH_GROUP      = &H80320031&

'//
'// MessageId: FWP_E_EM_NOT_SUPPORTED
'//
'// MessageText:
'//
'// An IKE policy cannot contain an Extended Mode policy.
'//
%FWP_E_EM_NOT_SUPPORTED           = &H80320032&

'//
'// MessageId: FWP_E_NEVER_MATCH
'//
'// MessageText:
'//
'// The enumeration template or subscription will never match any objects.
'//
%FWP_E_NEVER_MATCH                = &H80320033&

'//
'// MessageId: FWP_E_PROVIDER_CONTEXT_MISMATCH
'//
'// MessageText:
'//
'// The provider context is of the wrong type.
'//
%FWP_E_PROVIDER_CONTEXT_MISMATCH  = &H80320034&

'//
'// MessageId: FWP_E_INVALID_PARAMETER
'//
'// MessageText:
'//
'// The parameter is incorrect.
'//
%FWP_E_INVALID_PARAMETER          = &H80320035&

'//
'// MessageId: FWP_E_TOO_MANY_SUBLAYERS
'//
'// MessageText:
'//
'// The maximum number of sublayers has been reached.
'//
%FWP_E_TOO_MANY_SUBLAYERS         = &H80320036&

'//
'// MessageId: FWP_E_CALLOUT_NOTIFICATION_FAILED
'//
'// MessageText:
'//
'// The notification function for a callout returned an error.
'//
%FWP_E_CALLOUT_NOTIFICATION_FAILED = &H80320037&

'//
'// MessageId: FWP_E_INVALID_AUTH_TRANSFORM
'//
'// MessageText:
'//
'// The IPsec authentication transform is not valid.
'//
%FWP_E_INVALID_AUTH_TRANSFORM     = &H80320038&

'//
'// MessageId: FWP_E_INVALID_CIPHER_TRANSFORM
'//
'// MessageText:
'//
'// The IPsec cipher transform is not valid.
'//
%FWP_E_INVALID_CIPHER_TRANSFORM   = &H80320039&


'//
'// NDIS error codes (ndis.sys)
'//


'#ifdef RC_INVOKED
'#define _NDIS_ERROR_TYPEDEF_(_sc)  _sc
'#else // RC_INVOKED
'#define _NDIS_ERROR_TYPEDEF_(_sc)  (DWORD)(_sc)
'#endif // RC_INVOKED

'//
'// MessageId: ERROR_NDIS_INTERFACE_CLOSING
'//
'// MessageText:
'//
'// The binding to the network interface is being closed.
'//
%ERROR_NDIS_INTERFACE_CLOSING     = &H80340002&

'//
'// MessageId: ERROR_NDIS_BAD_VERSION
'//
'// MessageText:
'//
'// An invalid version was specified.
'//
%ERROR_NDIS_BAD_VERSION           = &H80340004&

'//
'// MessageId: ERROR_NDIS_BAD_CHARACTERISTICS
'//
'// MessageText:
'//
'// An invalid characteristics table was used.
'//
%ERROR_NDIS_BAD_CHARACTERISTICS   = &H80340005&

'//
'// MessageId: ERROR_NDIS_ADAPTER_NOT_FOUND
'//
'// MessageText:
'//
'// Failed to find the network interface or network interface is not ready.
'//
%ERROR_NDIS_ADAPTER_NOT_FOUND     = &H80340006&

'//
'// MessageId: ERROR_NDIS_OPEN_FAILED
'//
'// MessageText:
'//
'// Failed to open the network interface.
'//
%ERROR_NDIS_OPEN_FAILED           = &H80340007&

'//
'// MessageId: ERROR_NDIS_DEVICE_FAILED
'//
'// MessageText:
'//
'// Network interface has encountered an internal unrecoverable failure.
'//
%ERROR_NDIS_DEVICE_FAILED         = &H80340008&

'//
'// MessageId: ERROR_NDIS_MULTICAST_FULL
'//
'// MessageText:
'//
'// The multicast list on the network interface is full.
'//
%ERROR_NDIS_MULTICAST_FULL        = &H80340009&

'//
'// MessageId: ERROR_NDIS_MULTICAST_EXISTS
'//
'// MessageText:
'//
'// An attempt was made to add a duplicate multicast address to the list.
'//
%ERROR_NDIS_MULTICAST_EXISTS      = &H8034000A&

'//
'// MessageId: ERROR_NDIS_MULTICAST_NOT_FOUND
'//
'// MessageText:
'//
'// At attempt was made to remove a multicast address that was never added.
'//
%ERROR_NDIS_MULTICAST_NOT_FOUND   = &H8034000B&

'//
'// MessageId: ERROR_NDIS_REQUEST_ABORTED
'//
'// MessageText:
'//
'// Netowork interface aborted the request.
'//
%ERROR_NDIS_REQUEST_ABORTED       = &H8034000C&

'//
'// MessageId: ERROR_NDIS_RESET_IN_PROGRESS
'//
'// MessageText:
'//
'// Network interface can not process the request because it is being reset.
'//
%ERROR_NDIS_RESET_IN_PROGRESS     = &H8034000D&

'//
'// MessageId: ERROR_NDIS_NOT_SUPPORTED
'//
'// MessageText:
'//
'// Netword interface does not support this request.
'//
%ERROR_NDIS_NOT_SUPPORTED         = &H803400BB&

'//
'// MessageId: ERROR_NDIS_INVALID_PACKET
'//
'// MessageText:
'//
'// An attempt was made to send an invalid packet on a network interface.
'//
%ERROR_NDIS_INVALID_PACKET        = &H8034000F&

'//
'// MessageId: ERROR_NDIS_ADAPTER_NOT_READY
'//
'// MessageText:
'//
'// Network interface is not ready to complete this operation.
'//
%ERROR_NDIS_ADAPTER_NOT_READY     = &H80340011&

'//
'// MessageId: ERROR_NDIS_INVALID_LENGTH
'//
'// MessageText:
'//
'// The length of the buffer submitted for this operation is not valid.
'//
%ERROR_NDIS_INVALID_LENGTH        = &H80340014&

'//
'// MessageId: ERROR_NDIS_INVALID_DATA
'//
'// MessageText:
'//
'// The data used for this operation is not valid.
'//
%ERROR_NDIS_INVALID_DATA          = &H80340015&

'//
'// MessageId: ERROR_NDIS_BUFFER_TOO_SHORT
'//
'// MessageText:
'//
'// The length of buffer submitted for this operation is too small.
'//
%ERROR_NDIS_BUFFER_TOO_SHORT      = &H80340016&

'//
'// MessageId: ERROR_NDIS_INVALID_OID
'//
'// MessageText:
'//
'// Network interface does not support this OID (Object Identifier)
'//
%ERROR_NDIS_INVALID_OID           = &H80340017&

'//
'// MessageId: ERROR_NDIS_ADAPTER_REMOVED
'//
'// MessageText:
'//
'// The network interface has been removed.
'//
%ERROR_NDIS_ADAPTER_REMOVED       = &H80340018&

'//
'// MessageId: ERROR_NDIS_UNSUPPORTED_MEDIA
'//
'// MessageText:
'//
'// Network interface does not support this media type.
'//
%ERROR_NDIS_UNSUPPORTED_MEDIA     = &H80340019&

'//
'// MessageId: ERROR_NDIS_GROUP_ADDRESS_IN_USE
'//
'// MessageText:
'//
'// An attempt was made to remove a token ring group address that is in use by other components.
'//
%ERROR_NDIS_GROUP_ADDRESS_IN_USE  = &H8034001A&

'//
'// MessageId: ERROR_NDIS_FILE_NOT_FOUND
'//
'// MessageText:
'//
'// An attempt was made to map a file that can not be found.
'//
%ERROR_NDIS_FILE_NOT_FOUND        = &H8034001B&

'//
'// MessageId: ERROR_NDIS_ERROR_READING_FILE
'//
'// MessageText:
'//
'// An error occured while NDIS tried to map the file.
'//
%ERROR_NDIS_ERROR_READING_FILE    = &H8034001C&

'//
'// MessageId: ERROR_NDIS_ALREADY_MAPPED
'//
'// MessageText:
'//
'// An attempt was made to map a file that is alreay mapped.
'//
%ERROR_NDIS_ALREADY_MAPPED        = &H8034001D&

'//
'// MessageId: ERROR_NDIS_RESOURCE_CONFLICT
'//
'// MessageText:
'//
'// An attempt to allocate a hardware resource failed because the resource is used by another component.
'//
%ERROR_NDIS_RESOURCE_CONFLICT     = &H8034001E&

'//
'// MessageId: ERROR_NDIS_MEDIA_DISCONNECTED
'//
'// MessageText:
'//
'// The I/O operation failed because network media is disconnected or wireless access point is out of range.
'//
%ERROR_NDIS_MEDIA_DISCONNECTED    = &H8034001F&

'//
'// MessageId: ERROR_NDIS_INVALID_ADDRESS
'//
'// MessageText:
'//
'// The network address used in the request is invalid.
'//
%ERROR_NDIS_INVALID_ADDRESS       = &H80340022&

'//
'// MessageId: ERROR_NDIS_INVALID_DEVICE_REQUEST
'//
'// MessageText:
'//
'// The specified request is not a valid operation for the target device.
'//
%ERROR_NDIS_INVALID_DEVICE_REQUEST = &H80340010&

'//
'// MessageId: ERROR_NDIS_PAUSED
'//
'// MessageText:
'//
'// The offload operation on the network interface has been paused.
'//
%ERROR_NDIS_PAUSED                = &H8034002A&

'//
'// MessageId: ERROR_NDIS_INTERFACE_NOT_FOUND
'//
'// MessageText:
'//
'// Network interface was not found.
'//
%ERROR_NDIS_INTERFACE_NOT_FOUND   = &H8034002B&

'//
'// MessageId: ERROR_NDIS_UNSUPPORTED_REVISION
'//
'// MessageText:
'//
'// The revision number specified in the structure is not supported.
'//
%ERROR_NDIS_UNSUPPORTED_REVISION  = &H8034002C&

'//
'// MessageId: ERROR_NDIS_INVALID_PORT
'//
'// MessageText:
'//
'// The specified port does not exist on this network interface.
'//
%ERROR_NDIS_INVALID_PORT          = &H8034002D&

'//
'// MessageId: ERROR_NDIS_INVALID_PORT_STATE
'//
'// MessageText:
'//
'// The current state of the specified port on this network interface does not support the requested operation.
'//
%ERROR_NDIS_INVALID_PORT_STATE    = &H8034002E&

'//
'// MessageId: ERROR_NDIS_LOW_POWER_STATE
'//
'// MessageText:
'//
'// The miniport adapter is in low power state.
'//
%ERROR_NDIS_LOW_POWER_STATE       = &H8034002F&


'//
'// NDIS error codes (802.11 wireless LAN)
'//

'//
'// MessageId: ERROR_NDIS_DOT11_AUTO_CONFIG_ENABLED
'//
'// MessageText:
'//
'// The wireless local area network interface is in auto configuration mode and doesn't support the requested parameter change operation.
'//
%ERROR_NDIS_DOT11_AUTO_CONFIG_ENABLED = &H80342000&

'//
'// MessageId: ERROR_NDIS_DOT11_MEDIA_IN_USE
'//
'// MessageText:
'//
'// The wireless local area network interface is busy and can not perform the requested operation.
'//
%ERROR_NDIS_DOT11_MEDIA_IN_USE    = &H80342001&

'//
'// MessageId: ERROR_NDIS_DOT11_POWER_STATE_INVALID
'//
'// MessageText:
'//
'// The wireless local area network interface is power down and doesn't support the requested operation.
'//
%ERROR_NDIS_DOT11_POWER_STATE_INVALID = &H80342002&

'//
'// NDIS informational code (ndis.sys)
'//

'//
'// MessageId: ERROR_NDIS_INDICATION_REQUIRED
'//
'// MessageText:
'//
'// The request will be completed later by NDIS status indication.
'//
%ERROR_NDIS_INDICATION_REQUIRED   = &H00340001&

#ENDIF '//_WINERROR_

'/* Abnormal termination codes */

%TC_NORMAL  = 0
%TC_HARDERR = 1
%TC_GP_TRAP = 2
%TC_SIGNAL  = 3

'#if(WINVER >= 0x0400)
'//
'// Power Management APIs
'//

%AC_LINE_OFFLINE            = &H00?
%AC_LINE_ONLINE             = &H01?
%AC_LINE_BACKUP_POWER       = &H02?
%AC_LINE_UNKNOWN            = &HFF?

%BATTERY_FLAG_HIGH          = &H01?
%BATTERY_FLAG_LOW           = &H02?
%BATTERY_FLAG_CRITICAL      = &H04?
%BATTERY_FLAG_CHARGING      = &H08?
%BATTERY_FLAG_NO_BATTERY    = &H80?
%BATTERY_FLAG_UNKNOWN       = &HFF?

%BATTERY_PERCENTAGE_UNKNOWN = &HFF?

%BATTERY_LIFE_UNKNOWN       = &HFFFFFFFF???

TYPE SYSTEM_POWER_STATUS
   ACLineStatus        AS BYTE    ' BYTE ACLineStatus
   BatteryFlag         AS BYTE    ' BYTE BatteryFlag
   BatteryLifePercent  AS BYTE    ' BYTE BatteryLifePercent
   Reserved1           AS BYTE    ' BYTE Reserved1
   BatteryLifeTime     AS DWORD   ' DWORD BatteryLifeTime
   BatteryFullLifeTime AS DWORD   ' DWORD BatteryFullLifeTime
END TYPE

DECLARE FUNCTION GetSystemPowerStatus LIB "KERNEL32.DLL" ALIAS "GetSystemPowerStatus" ( _
   BYREF SYSTEM_POWER_STATUS _         ' __out LPSYSTEM_POWER_STATUS lpSystemPowerStatus
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetSystemPowerState LIB "KERNEL32.DLL" ALIAS "SetSystemPowerState" ( _
   BYVAL LONG _                        ' __in BOOL fSuspend
 , BYVAL LONG _                        ' __in BOOL fForce
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0400 */

'#if (_WIN32_WINNT >= 0x0500)
'//
'// Very Large Memory API Subset
'//

DECLARE FUNCTION AllocateUserPhysicalPages LIB "KERNEL32.DLL" ALIAS "AllocateUserPhysicalPages" ( _
   BYVAL DWORD _                       ' __in    HANDLE hProcess
 , BYREF DWORD _                       ' __inout PULONG_PTR NumberOfPages
 , BYREF DWORD _                       ' __out_ecount_part(*NumberOfPages, *NumberOfPages) PULONG_PTR PageArray
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0600
#IF %WINVER >= &H0600

DECLARE FUNCTION AllocateUserPhysicalPagesNuma LIB "KERNEL32.DLL" ALIAS "AllocateUserPhysicalPagesNuma" ( _
   BYVAL DWORD _                       ' __in    HANDLE hProcess
 , BYREF DWORD _                       ' __inout PULONG_PTR NumberOfPages
 , BYREF DWORD _                       ' __out_ecount_part(*NumberOfPages, *NumberOfPages) PULONG_PTR PageArray
 , BYVAL DWORD _                       ' __in    DWORD nndPreferred
 ) AS LONG                             ' BOOL

#ENDIF ' // _WIN32_WINNT >= 0x0600

DECLARE FUNCTION FreeUserPhysicalPages LIB "KERNEL32.DLL" ALIAS "FreeUserPhysicalPages" ( _
   BYVAL DWORD _                       ' __in    HANDLE hProcess
 , BYREF DWORD _                       ' __inout PULONG_PTR NumberOfPages
 , BYREF DWORD _                       ' __in_ecount(*NumberOfPages) PULONG_PTR PageArray
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MapUserPhysicalPages LIB "KERNEL32.DLL" ALIAS "MapUserPhysicalPages" ( _
   BYVAL DWORD _                       ' __in PVOID VirtualAddress
 , BYVAL DWORD _                       ' __in ULONG_PTR NumberOfPages
 , BYREF DWORD _                       ' __in_ecount_opt(NumberOfPages) PULONG_PTR PageArray
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MapUserPhysicalPagesScatter LIB "KERNEL32.DLL" ALIAS "MapUserPhysicalPagesScatter" ( _
   BYREF DWORD _                       ' __in_ecount(NumberOfPages) PVOID *VirtualAddresses
 , BYVAL DWORD _                       ' __in ULONG_PTR NumberOfPages
 , BYREF DWORD _                       ' __in_ecount_opt(NumberOfPages) PULONG_PTR PageArray
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateJobObject LIB "KERNEL32.DLL" ALIAS "CreateJobObjectA" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpJobAttributes
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateJobObjectW LIB "KERNEL32.DLL" ALIAS "CreateJobObjectW" ( _
   BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpJobAttributes
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenJobObject LIB "KERNEL32.DLL" ALIAS "OpenJobObjectA" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYREF ASCIIZ _                      ' __in LPCSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OpenJobObjectW LIB "KERNEL32.DLL" ALIAS "OpenJobObjectW" ( _
   BYVAL DWORD _                       ' __in DWORD dwDesiredAccess
 , BYVAL LONG _                        ' __in BOOL bInheritHandle
 , BYVAL DWORD _                       ' __in LPCWSTR lpName
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION AssignProcessToJobObject LIB "KERNEL32.DLL" ALIAS "AssignProcessToJobObject" ( _
   BYVAL DWORD _                       ' __in HANDLE hJob
 , BYVAL DWORD _                       ' __in HANDLE hProcess
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TerminateJobObject LIB "KERNEL32.DLL" ALIAS "TerminateJobObject" ( _
   BYVAL DWORD _                       ' __in HANDLE hJob
 , BYVAL DWORD _                       ' __in UINT uExitCode
 ) AS LONG                             ' BOOL

DECLARE FUNCTION QueryInformationJobObject LIB "KERNEL32.DLL" ALIAS "QueryInformationJobObject" ( _
   BYVAL DWORD _                       ' __in_opt  HANDLE hJob
 , BYVAL LONG _                        ' __in      JOBOBJECTINFOCLASS JobObjectInformationClass
 , BYREF ANY _                         ' __out_bcount_part(cbJobObjectInformationLength, *lpReturnLength) LPVOID lpJobObjectInformation
 , BYVAL DWORD _                       ' __in      DWORD cbJobObjectInformationLength
 , BYREF DWORD _                       ' __out_opt LPDWORD lpReturnLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetInformationJobObject LIB "KERNEL32.DLL" ALIAS "SetInformationJobObject" ( _
   BYVAL DWORD _                       ' __in HANDLE hJob
 , BYVAL LONG _                        ' __in JOBOBJECTINFOCLASS JobObjectInformationClass
 , BYREF ANY _                         ' __in_bcount(cbJobObjectInformationLength) LPVOID lpJobObjectInformation
 , BYVAL DWORD _                       ' __in DWORD cbJobObjectInformationLength
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION IsProcessInJob LIB "KERNEL32.DLL" ALIAS "IsProcessInJob" ( _
   BYVAL DWORD _                       ' __in     HANDLE ProcessHandle
 , BYVAL DWORD _                       ' __in_opt HANDLE JobHandle
 , BYREF LONG _                        ' __out    PBOOL Result
 ) AS LONG                             ' BOOL

'#endif

DECLARE FUNCTION CreateJobSet LIB "KERNEL32.DLL" ALIAS "CreateJobSet" ( _
   BYVAL DWORD _                       ' __in ULONG NumJob
 , BYREF JOB_SET_ARRAY _               ' __in_ecount(NumJob) PJOB_SET_ARRAY UserJobSet
 , BYVAL DWORD _                       ' __in ULONG Flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AddVectoredExceptionHandler LIB "KERNEL32.DLL" ALIAS "AddVectoredExceptionHandler" ( _
   BYVAL DWORD _                       ' __in ULONG First
 , BYVAL DWORD _                       ' __in PVECTORED_EXCEPTION_HANDLER Handler
 ) AS DWORD                            ' PVOID

DECLARE FUNCTION RemoveVectoredExceptionHandler LIB "KERNEL32.DLL" ALIAS "RemoveVectoredExceptionHandler" ( _
   BYVAL DWORD _                       ' __in PVOID Handle
 ) AS DWORD                            ' ULONG

DECLARE FUNCTION AddVectoredContinueHandler LIB "KERNEL32.DLL" ALIAS "AddVectoredContinueHandler" ( _
   BYVAL DWORD _                       ' __in ULONG First
 , BYVAL DWORD _                       ' __in PVECTORED_EXCEPTION_HANDLER Handler
 ) AS DWORD                            ' PVOID

DECLARE FUNCTION RemoveVectoredContinueHandler LIB "KERNEL32.DLL" ALIAS "RemoveVectoredContinueHandler" ( _
   BYVAL DWORD _                       ' __in PVOID Handle
 ) AS DWORD                            ' ULONG

'//
'// New Volume Mount Point API.
'//

DECLARE FUNCTION FindFirstVolume LIB "KERNEL32.DLL" ALIAS "FindFirstVolumeA" ( _
   BYREF ASCIIZ _                      ' __out_ecount(cchBufferLength) LPSTR lpszVolumeName
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindFirstVolumeW LIB "KERNEL32.DLL" ALIAS "FindFirstVolumeW" ( _
   BYVAL DWORD _                       ' __out_ecount(cchBufferLength) LPWSTR lpszVolumeName
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindNextVolume LIB "KERNEL32.DLL" ALIAS "FindNextVolumeA" ( _
   BYREF DWORD _                       ' __inout HANDLE hFindVolume
 , BYREF ASCIIZ _                      ' __out_ecount(cchBufferLength) LPSTR lpszVolumeName
 , BYVAL DWORD _                       ' __in    DWORD cchBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindNextVolumeW LIB "KERNEL32.DLL" ALIAS "FindNextVolumeW" ( _
   BYREF DWORD _                       ' __inout HANDLE hFindVolume
 , BYVAL DWORD _                       ' __out_ecount(cchBufferLength) LPWSTR lpszVolumeName
 , BYVAL DWORD _                       ' __in    DWORD cchBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindVolumeClose LIB "KERNEL32.DLL" ALIAS "FindVolumeClose" ( _
   BYVAL DWORD _                       ' __in HANDLE hFindVolume
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindFirstVolumeMountPoint LIB "KERNEL32.DLL" ALIAS "FindFirstVolumeMountPointA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszRootPathName
 , BYREF ASCIIZ _                      ' __out_ecount(cchBufferLength) LPSTR lpszVolumeMountPoint
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindFirstVolumeMountPointW LIB "KERNEL32.DLL" ALIAS "FindFirstVolumeMountPointW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszRootPathName
 , BYVAL DWORD _                       ' __out_ecount(cchBufferLength) LPWSTR lpszVolumeMountPoint
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION FindNextVolumeMountPoint LIB "KERNEL32.DLL" ALIAS "FindNextVolumeMountPointA" ( _
   BYVAL DWORD _                       ' __in HANDLE hFindVolumeMountPoint
 , BYREF ASCIIZ _                      ' __out_ecount(cchBufferLength) LPSTR lpszVolumeMountPoint
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindNextVolumeMountPointW LIB "KERNEL32.DLL" ALIAS "FindNextVolumeMountPointW" ( _
   BYVAL DWORD _                       ' __in HANDLE hFindVolumeMountPoint
 , BYVAL DWORD _                       ' __out_ecount(cchBufferLength) LPWSTR lpszVolumeMountPoint
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindVolumeMountPointClose LIB "KERNEL32.DLL" ALIAS "FindVolumeMountPointClose" ( _
   BYVAL DWORD _                       ' __in HANDLE hFindVolumeMountPoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetVolumeMountPoint LIB "KERNEL32.DLL" ALIAS "SetVolumeMountPointA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszVolumeMountPoint
 , BYREF ASCIIZ _                      ' __in LPCSTR lpszVolumeName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetVolumeMountPointW LIB "KERNEL32.DLL" ALIAS "SetVolumeMountPointW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszVolumeMountPoint
 , BYVAL DWORD _                       ' __in LPCWSTR lpszVolumeName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteVolumeMountPoint LIB "KERNEL32.DLL" ALIAS "DeleteVolumeMountPointA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszVolumeMountPoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteVolumeMountPointW LIB "KERNEL32.DLL" ALIAS "DeleteVolumeMountPointW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszVolumeMountPoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVolumeNameForVolumeMountPoint LIB "KERNEL32.DLL" ALIAS "GetVolumeNameForVolumeMountPointA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszVolumeMountPoint
 , BYREF ASCIIZ _                      ' __out_ecount(cchBufferLength) LPSTR lpszVolumeName
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVolumeNameForVolumeMountPointW LIB "KERNEL32.DLL" ALIAS "GetVolumeNameForVolumeMountPointW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszVolumeMountPoint
 , BYVAL DWORD _                       ' __out_ecount(cchBufferLength) LPWSTR lpszVolumeName
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVolumePathName LIB "KERNEL32.DLL" ALIAS "GetVolumePathNameA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszFileName
 , BYREF ASCIIZ _                      ' __out_ecount(cchBufferLength) LPSTR lpszVolumePathName
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVolumePathNameW LIB "KERNEL32.DLL" ALIAS "GetVolumePathNameW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszFileName
 , BYVAL DWORD _                       ' __out_ecount(cchBufferLength) LPWSTR lpszVolumePathName
 , BYVAL DWORD _                       ' __in DWORD cchBufferLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVolumePathNamesForVolumeName LIB "KERNEL32.DLL" ALIAS "GetVolumePathNamesForVolumeNameA" ( _
   BYREF ASCIIZ _                      ' __in  LPCSTR lpszVolumeName
 , BYREF ANY _                         ' __out_ecount_part_opt(cchBufferLength, *lpcchReturnLength) __nullnullterminated LPCH lpszVolumePathNames
 , BYVAL DWORD _                       ' __in  DWORD cchBufferLength
 , BYREF DWORD _                       ' __out PDWORD lpcchReturnLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetVolumePathNamesForVolumeNameW LIB "KERNEL32.DLL" ALIAS "GetVolumePathNamesForVolumeNameW" ( _
   BYVAL DWORD _                       ' __in  LPCWSTR lpszVolumeName
 , BYREF ANY _                         ' __out_ecount_part_opt(cchBufferLength, *lpcchReturnLength) __nullnullterminated LPWCH lpszVolumePathNames
 , BYVAL DWORD _                       ' __in  DWORD cchBufferLength
 , BYREF DWORD _                       ' __out PDWORD lpcchReturnLength
 ) AS LONG                             ' BOOL

'#endif

'#if (_WIN32_WINNT >= 0x0500) || (_WIN32_FUSION >= 0x0100) || ISOLATION_AWARE_ENABLED

%ACTCTX_FLAG_PROCESSOR_ARCHITECTURE_VALID    = &H00000001???
%ACTCTX_FLAG_LANGID_VALID                    = &H00000002???
%ACTCTX_FLAG_ASSEMBLY_DIRECTORY_VALID        = &H00000004???
%ACTCTX_FLAG_RESOURCE_NAME_VALID             = &H00000008???
%ACTCTX_FLAG_SET_PROCESS_DEFAULT             = &H00000010???
%ACTCTX_FLAG_APPLICATION_NAME_VALID          = &H00000020???
%ACTCTX_FLAG_SOURCE_IS_ASSEMBLYREF           = &H00000040???
%ACTCTX_FLAG_HMODULE_VALID                   = &H00000080???

TYPE ACTCTXA
   cbSize                 AS DWORD        ' ULONG       cbSize
   dwFlags                AS DWORD        ' DWORD       dwFlags
   lpSource               AS ASCIIZ PTR   ' LPCSTR      lpSource
   wProcessorArchitecture AS WORD         ' USHORT      wProcessorArchitecture
   wLangId                AS WORD         ' LANGID      wLangId
   lpAssemblyDirectory    AS ASCIIZ PTR   ' LPCSTR      lpAssemblyDirectory
   lpResourceName         AS ASCIIZ PTR   ' LPCSTR      lpResourceName
   lpApplicationName      AS ASCIIZ PTR   ' LPCSTR      lpApplicationName
   hModule                AS DWORD        ' HMODULE     hModule
END TYPE

TYPE ACTCTXW
   cbSize                 AS DWORD        ' ULONG       cbSize
   dwFlags                AS DWORD        ' DWORD       dwFlags
   lpSource               AS WORD PTR     ' LPWCSTR     lpSource
   wProcessorArchitecture AS WORD         ' USHORT      wProcessorArchitecture
   wLangId                AS WORD         ' LANGID      wLangId
   lpAssemblyDirectory    AS WORD PTR     ' LPWCSTR     lpAssemblyDirectory
   lpResourceName         AS WORD PTR     ' LPCWSTR     lpResourceName
   lpApplicationName      AS WORD PTR     ' LPCWSTR     lpApplicationName
   hModule                AS DWORD        ' HMODULE     hModule
END TYPE

MACRO ACTCTX = ACTCTXA

'#endif

'#if (_WIN32_WINNT >= 0x0500) || (_WIN32_FUSION >= 0x0100)


DECLARE FUNCTION CreateActCtx LIB "KERNEL32.DLL" ALIAS "CreateActCtxA" ( _
   BYREF ACTCTXA _                     ' __in PCACTCTXA pActCtx
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CreateActCtxW LIB "KERNEL32.DLL" ALIAS "CreateActCtxW" ( _
   BYREF ACTCTXW _                     ' __in PCACTCTXW pActCtx
 ) AS DWORD                            ' HANDLE

DECLARE SUB AddRefActCtx LIB "KERNEL32.DLL" ALIAS "AddRefActCtx" ( _
   BYREF DWORD _                       ' __inout HANDLE hActCtx
 )                                     ' VOID

DECLARE SUB ReleaseActCtx LIB "KERNEL32.DLL" ALIAS "ReleaseActCtx" ( _
   BYREF DWORD _                       ' __inout HANDLE hActCtx
 )                                     ' VOID

DECLARE FUNCTION ZombifyActCtx LIB "KERNEL32.DLL" ALIAS "ZombifyActCtx" ( _
   BYREF DWORD _                       ' __inout HANDLE hActCtx
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ActivateActCtx LIB "KERNEL32.DLL" ALIAS "ActivateActCtx" ( _
   BYREF DWORD _                       ' __inout HANDLE hActCtx
 , BYREF DWORD _                       ' __out   ULONG_PTR *lpCookie
 ) AS LONG                             ' BOOL

%DEACTIVATE_ACTCTX_FLAG_FORCE_EARLY_DEACTIVATION = &H00000001???

DECLARE FUNCTION DeactivateActCtx LIB "KERNEL32.DLL" ALIAS "DeactivateActCtx" ( _
   BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in ULONG_PTR ulCookie
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCurrentActCtx LIB "KERNEL32.DLL" ALIAS "GetCurrentActCtx" ( _
   BYREF DWORD _                       ' __deref_out HANDLE *lphActCtx
 ) AS LONG                             ' BOOL

'#endif

'#if (_WIN32_WINNT >= 0x0500) || (_WIN32_FUSION >= 0x0100) || ISOLATION_AWARE_ENABLED

TYPE ACTCTX_SECTION_KEYED_DATA_2600
   cbSize                    AS DWORD   ' ULONG cbSize
   ulDataFormatVersion       AS DWORD   ' ULONG ulDataFormatVersion
   lpData                    AS DWORD   ' PVOID lpData
   ulLength                  AS DWORD   ' ULONG ulLength
   lpSectionGlobalData       AS DWORD   ' PVOID lpSectionGlobalData
   ulSectionGlobalDataLength AS DWORD   ' ULONG ulSectionGlobalDataLength
   lpSectionBase             AS DWORD   ' PVOID lpSectionBase
   ulSectionTotalLength      AS DWORD   ' ULONG ulSectionTotalLength
   hActCtx                   AS DWORD   ' HANDLE hActCtx
   ulAssemblyRosterIndex     AS DWORD   ' ULONG ulAssemblyRosterIndex
END TYPE

TYPE ACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA
   lpInformation             AS DWORD   ' PVOID lpInformation
   lpSectionBase             AS DWORD   ' PVOID lpSectionBase
   ulSectionLength           AS DWORD   ' ULONG ulSectionLength
   lpSectionGlobalDataBase   AS DWORD   ' PVOID lpSectionGlobalDataBase
   ulSectionGlobalDataLength AS DWORD   ' ULONG ulSectionGlobalDataLength
END TYPE

TYPE ACTCTX_SECTION_KEYED_DATA
   cbSize                    AS DWORD   ' ULONG cbSize
   ulDataFormatVersion       AS DWORD   ' ULONG ulDataFormatVersion
   lpData                    AS DWORD   ' PVOID lpData
   ulLength                  AS DWORD   ' ULONG ulLength
   lpSectionGlobalData       AS DWORD   ' PVOID lpSectionGlobalData
   ulSectionGlobalDataLength AS DWORD   ' ULONG ulSectionGlobalDataLength
   lpSectionBase             AS DWORD   ' PVOID lpSectionBase
   ulSectionTotalLength      AS DWORD   ' ULONG ulSectionTotalLength
   hActCtx                   AS DWORD   ' HANDLE hActCtx
   ulAssemblyRosterIndex     AS DWORD   ' ULONG ulAssemblyRosterIndex
   '// 2600 stops here
   ulFlags                   AS DWORD   ' ULONG ulFlags
   AssemblyMetadata          AS ACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA   ' ACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA AssemblyMetadata
END TYPE

%FIND_ACTCTX_SECTION_KEY_RETURN_HACTCTX           = &H00000001???
%FIND_ACTCTX_SECTION_KEY_RETURN_FLAGS             = &H00000002???
%FIND_ACTCTX_SECTION_KEY_RETURN_ASSEMBLY_METADATA = &H00000004???

'#endif

'#if (_WIN32_WINNT >= 0x0500) || (_WIN32_FUSION >= 0x0100)

DECLARE FUNCTION FindActCtxSectionString LIB "KERNEL32.DLL" ALIAS "FindActCtxSectionStringA" ( _
   BYVAL DWORD _                       ' __in       DWORD dwFlags
 , BYREF GUID _                        ' __reserved const GUID *lpExtensionGuid
 , BYVAL DWORD _                       ' __in       ULONG ulSectionId
 , BYREF ASCIIZ _                      ' __in       LPCSTR lpStringToFind
 , BYREF ACTCTX_SECTION_KEYED_DATA _   ' __out      PACTCTX_SECTION_KEYED_DATA ReturnedData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindActCtxSectionStringW LIB "KERNEL32.DLL" ALIAS "FindActCtxSectionStringW" ( _
   BYVAL DWORD _                       ' __in       DWORD dwFlags
 , BYREF GUID _                        ' __reserved const GUID *lpExtensionGuid
 , BYVAL DWORD _                       ' __in       ULONG ulSectionId
 , BYVAL DWORD _                       ' __in       LPCWSTR lpStringToFind
 , BYREF ACTCTX_SECTION_KEYED_DATA _   ' __out      PACTCTX_SECTION_KEYED_DATA ReturnedData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindActCtxSectionGuid LIB "KERNEL32.DLL" ALIAS "FindActCtxSectionGuid" ( _
   BYVAL DWORD _                       ' __in       DWORD dwFlags
 , BYREF GUID _                        ' __reserved const GUID *lpExtensionGuid
 , BYVAL DWORD  _                      ' __in       ULONG ulSectionId
 , BYREF GUID  _                       ' __in_opt   const GUID *lpGuidToFind
 , BYREF ACTCTX_SECTION_KEYED_DATA _   ' __out      PACTCTX_SECTION_KEYED_DATA ReturnedData
 ) AS LONG                             ' BOOL

'#endif

'#if (_WIN32_WINNT >= 0x0500) || (_WIN32_FUSION >= 0x0100) || ISOLATION_AWARE_ENABLED

'#if !defined(RC_INVOKED) /* RC complains about long symbols in #ifs */
'#if !defined(ACTIVATION_CONTEXT_BASIC_INFORMATION_DEFINED)

TYPE ACTIVATION_CONTEXT_BASIC_INFORMATION
   hActCtx AS DWORD   ' HANDLE  hActCtx
   dwFlags AS DWORD   ' DWORD   dwFlags
END TYPE

%ACTIVATION_CONTEXT_BASIC_INFORMATION_DEFINED = 1

'#endif // !defined(ACTIVATION_CONTEXT_BASIC_INFORMATION_DEFINED)
'#endif

%QUERY_ACTCTX_FLAG_USE_ACTIVE_ACTCTX = &H00000004???
%QUERY_ACTCTX_FLAG_ACTCTX_IS_HMODULE = &H00000008???
%QUERY_ACTCTX_FLAG_ACTCTX_IS_ADDRESS = &H00000010???
%QUERY_ACTCTX_FLAG_NO_ADDREF         = &H80000000???

'#endif

'#if (_WIN32_WINNT >= 0x0500) || (_WIN32_FUSION >= 0x0100)


'//
'// switch (ulInfoClass)
'//
'//  case ActivationContextBasicInformation:
'//    pvSubInstance == NULL
'//    pvBuffer is of type PACTIVATION_CONTEXT_BASIC_INFORMATION
'//
'//  case ActivationContextDetailedInformation:
'//    pvSubInstance == NULL
'//    pvBuffer is of type PACTIVATION_CONTEXT_DETAILED_INFORMATION
'//
'//  case AssemblyDetailedInformationInActivationContext:
'//    pvSubInstance is of type PULONG
'//      *pvSubInstance < ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulAssemblyCount
'//    pvBuffer is of type PACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION
'//
'//  case FileInformationInAssemblyOfAssemblyInActivationContext:
'//    pvSubInstance is of type PACTIVATION_CONTEXT_QUERY_INDEX
'//      pvSubInstance->ulAssemblyIndex < ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulAssemblyCount
'//      pvSubInstance->ulFileIndexInAssembly < ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulFileCount
'//    pvBuffer is of type PASSEMBLY_FILE_DETAILED_INFORMATION
'//
'// String are placed after the structs.
'//

DECLARE FUNCTION QueryActCtxW LIB "KERNEL32.DLL" ALIAS "QueryActCtxW" ( _
   BYVAL DWORD _                       ' __in      DWORD dwFlags
 , BYVAL DWORD _                       ' __in      HANDLE hActCtx
 , BYVAL DWORD _                       ' __in_opt  PVOID pvSubInstance
 , BYVAL DWORD _                       ' __in      ULONG ulInfoClass
 , BYREF ANY _                         ' __out_bcount_part_opt(cbBuffer, *pcbWrittenOrRequired) PVOID pvBuffer
 , BYVAL DWORD _                       ' __in      SIZE_T cbBuffer
 , BYREF DWORD _                       ' __out_opt SIZE_T *pcbWrittenOrRequired
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT > 0x0500) || (_WIN32_FUSION >= 0x0100)

DECLARE FUNCTION ProcessIdToSessionId LIB "KERNEL32.DLL" ALIAS "ProcessIdToSessionId" ( _
   BYVAL DWORD _                       ' __in  DWORD dwProcessId
 , BYREF DWORD _                       ' __out DWORD *pSessionId
 ) AS LONG                             ' BOOL

'#if _WIN32_WINNT >= 0x0501

DECLARE FUNCTION WTSGetActiveConsoleSessionId LIB "KERNEL32.DLL" ALIAS "WTSGetActiveConsoleSessionId" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION IsWow64Process LIB "KERNEL32.DLL" ALIAS "IsWow64Process" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF LONG _                        ' __out PBOOL Wow64Process
 ) AS LONG                             ' BOOL

'#endif // (_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION GetLogicalProcessorInformation LIB "KERNEL32.DLL" ALIAS "GetLogicalProcessorInformation" ( _
   BYREF SYSTEM_LOGICAL_PROCESSOR_INFORMATION _  ' __out_bcount_part(*ReturnedLength, *ReturnedLength) PSYSTEM_LOGICAL_PROCESSOR_INFORMATION Buffer
 , BYREF DWORD _                       ' __inout PDWORD ReturnedLength
 ) AS LONG                             ' BOOL

'//
'// NUMA Information routines.
'//

DECLARE FUNCTION GetNumaHighestNodeNumber LIB "KERNEL32.DLL" ALIAS "GetNumaHighestNodeNumber" ( _
   BYREF DWORD _                       ' __out PULONG HighestNodeNumber
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNumaProcessorNode LIB "KERNEL32.DLL" ALIAS "GetNumaProcessorNode" ( _
   BYVAL BYTE _                        ' __in  UCHAR Processor
 , BYREF BYTE _                        ' __out PUCHAR NodeNumber
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNumaNodeProcessorMask LIB "KERNEL32.DLL" ALIAS "GetNumaNodeProcessorMask" ( _
   BYVAL BYTE _                        ' __in  UCHAR Node
 , BYREF QUAD _                        ' __out PULONGLONG ProcessorMask
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetNumaAvailableMemoryNode LIB "KERNEL32.DLL" ALIAS "GetNumaAvailableMemoryNode" ( _
   BYVAL BYTE _                        ' __in  UCHAR Node
 , BYREF QUAD _                        ' __out PULONGLONG AvailableBytes
 ) AS LONG                             ' BOOL


'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE FUNCTION GetNumaProximityNode LIB "KERNEL32.DLL" ALIAS "GetNumaProximityNode" ( _
   BYVAL DWORD _                       ' __in  ULONG ProximityId
 , BYREF BYTE _                        ' __out PUCHAR NodeNumber
 ) AS LONG                             ' BOOL

#ENDIF

'//
'// Application restart and data recovery callback
'//
'typedef DWORD (WINAPI *APPLICATION_RECOVERY_CALLBACK)(PVOID pvParameter);

'//
'// Max length of commandline in characters (including the NULL character that can be registered for restart)
'//
%RESTART_MAX_CMD_LINE   = 2048

'//
'// Do not restart the process for termination due to application crashes
'//
%RESTART_NO_CRASH       = 1

'//
'// Do not restart the process for termination due to application hangs
'//
%RESTART_NO_HANG        = 2

'//
'// Do not restart the process for termination due to patch installations
'//
%RESTART_NO_PATCH       = 4

'//
'// Do not restart the process when the system is rebooted because the
'//
%RESTART_NO_REBOOT      = 8

DECLARE FUNCTION RegisterApplicationRecoveryCallback LIB "KERNEL32.DLL" ALIAS "RegisterApplicationRecoveryCallback" ( _
   BYVAL DWORD _                       ' __in  APPLICATION_RECOVERY_CALLBACK pRecoveyCallback
 , BYVAL DWORD _                       ' __in_opt  PVOID pvParameter
 , BYVAL DWORD _                       ' __in DWORD dwPingInterval
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION UnregisterApplicationRecoveryCallback LIB "KERNEL32.DLL" ALIAS "UnregisterApplicationRecoveryCallback" ( _
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION RegisterApplicationRestart LIB "KERNEL32.DLL" ALIAS "RegisterApplicationRestart" ( _
   BYVAL DWORD _                       ' __in_opt PCWSTR pwzCommandline
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION UnregisterApplicationRestart LIB "KERNEL32.DLL" ALIAS "UnregisterApplicationRestart" ( _
 ) AS LONG                             ' HRESULT

%RECOVERY_DEFAULT_PING_INTERVAL = 5000
%RECOVERY_MAX_PING_INTERVAL     = (5 * 60 * 1000)

DECLARE FUNCTION GetApplicationRecoveryCallback LIB "KERNEL32.DLL" ALIAS "GetApplicationRecoveryCallback" ( _
   BYVAL DWORD _                       ' __in  HANDLE hProcess
 , BYREF DWORD _                       ' __out APPLICATION_RECOVERY_CALLBACK* pRecoveryCallback
 , BYREF ANY _                         ' __deref_opt_out_opt PVOID* ppvParameter
 , BYREF DWORD _                       ' __out_opt PDWORD pdwPingInterval
 , BYREF DWORD _                       ' __out_opt PDWORD pdwFlags
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION GetApplicationRestartSettings LIB "KERNEL32.DLL" ALIAS "GetApplicationRestartSettings" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __out_ecount_opt(*pcchSize) PWSTR pwzCommandline
 , BYREF DWORD _                       ' __inout PDWORD pcchSize
 , BYREF DWORD _                       ' __out_opt PDWORD pdwFlags
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION ApplicationRecoveryInProgress LIB "KERNEL32.DLL" ALIAS "ApplicationRecoveryInProgress" ( _
   BYREF LONG _                        '  __out PBOOL pbCancelled
 ) AS LONG                             ' HRESULT

DECLARE SUB ApplicationRecoveryFinished LIB "KERNEL32.DLL" ALIAS "ApplicationRecoveryFinished" ( _
   BYVAL LONG _                        ' __in BOOL bSuccess
 )                                     ' VOID

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

' enum FILE_INFO_BY_HANDLE_CLASS {
%FileBasicInfo                  = 0
%FileStandardInfo               = 1
%FileNameInfo                   = 2
%FileRenameInfo                 = 3
%FileDispositionInfo            = 4
%FileAllocationInfo             = 5
%FileEndOfFileInfo              = 6
%FileStreamInfo                 = 7
%FileCompressionInfo            = 8
%FileAttributeTagInfo           = 9
%FileIdBothDirectoryInfo        = 10
%FileIdBothDirectoryRestartInfo = 11
%FileIoPriorityHintInfo         = 12
%MaximumFileInfoByHandleClass   = 13

TYPE FILE_BASIC_INFO
   CreationTime   AS QUAD    ' LARGE_INTEGER
   LastAccessTime AS QUAD    ' LARGE_INTEGER
   LastWriteTime  AS QUAD    ' LARGE_INTEGER
   ChangeTime     AS QUAD    ' LARGE_INTEGER
   FileAttributes AS DWORD   ' DWORD
END TYPE

TYPE FILE_STANDARD_INFO
   AllocationSize AS QUAD    ' LARGE_INTEGER
   EndOfFile      AS QUAD    ' LARGE_INTEGER
   NumberOfLinks  AS DWORD   ' DWORD
   DeletePending  AS BYTE    ' BOOLEAN
   Directory      AS BYTE    ' BOOLEAN
END TYPE

TYPE FILE_NAME_INFO
   FileNameLength AS DWORD            ' DWORD
   FileName       AS STRING * 1 * 2   ' WCHAR - variable length
END TYPE

TYPE FILE_RENAME_INFO
   ReplaceIfExists AS BYTE             ' BOOLEAN
   RootDirectory   AS DWORD            ' HANDLE
   FileNameLength  AS DWORD            ' DWORD
   FileName        AS STRING * 1 * 2   ' WCHAR - variable length
END TYPE

TYPE FILE_ALLOCATION_INFO
   AllocationSize AS QUAD   ' LARGE_INTEGER
END TYPE

TYPE FILE_END_OF_FILE_INFO
   EndOfFile AS QUAD   ' LARGE_INTEGER
END TYPE

TYPE FILE_STREAM_INFO
   NextEntryOffset      AS DWORD            ' DWORD
   StreamNameLength     AS DWORD            ' DWORD
   StreamSize           AS QUAD             ' LARGE_INTEGER
   StreamAllocationSize AS QUAD             ' LARGE_INTEGER
   StreamName           AS STRING * 1 * 2   ' WCHAR - variable length
END TYPE

TYPE FILE_COMPRESSION_INFO
   CompressedFileSize   AS QUAD   ' LARGE_INTEGER
   CompressionFormat    AS WORD   ' WORD
   CompressionUnitShift AS BYTE   ' UCHAR
   ChunkShift           AS BYTE   ' UCHAR
   ClusterShift         AS BYTE   ' UCHAR
   Reserved(2)          AS BYTE   ' UCHAR
END TYPE

TYPE FILE_ATTRIBUTE_TAG_INFO
   FileAttributes AS DWORD   ' DWORD
   ReparseTag     AS DWORD   ' DWORD
END TYPE

TYPE FILE_DISPOSITION_INFO
   DeleteFile AS BYTE   ' BOOLEAN
END TYPE

TYPE FILE_ID_BOTH_DIR_INFO
   NextEntryOffset AS DWORD               ' DWORD
   FileIndex       AS DWORD               ' DWORD
   CreationTime    AS QUAD                ' LARGE_INTEGER
   LastAccessTime  AS QUAD                ' LARGE_INTEGER
   LastWriteTime   AS QUAD                ' LARGE_INTEGER
   ChangeTime      AS QUAD                ' LARGE_INTEGER
   EndOfFile       AS QUAD                ' LARGE_INTEGER
   AllocationSize  AS QUAD                ' LARGE_INTEGER
   FileAttributes  AS DWORD               ' DWORD
   FileNameLength  AS DWORD               ' DWORD
   EaSize          AS DWORD               ' DWORD
   ShortNameLength AS ASCIIZ PTR          ' CCHAR
   ShortName       AS STRING *   12 * 2   ' WCHAR
   FileId          AS QUAD                ' LARGE_INTEGER
   FileName        AS STRING *   1  * 2   ' WCHAR - variable length
END TYPE

' enum PRIORITY_HINT {
%IoPriorityHintVeryLow     = 0
%IoPriorityHintLow         = 1
%IoPriorityHintNormal      = 2
%MaximumIoPriorityHintType = 3

TYPE FILE_IO_PRIORITY_HINT_INFO
   PriorityHint AS DWORD   ' PRIORITY_HINT
END TYPE

DECLARE FUNCTION SetFileInformationByHandle LIB "KERNEL32.DLL" ALIAS "SetFileInformationByHandle" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYVAL DWORD _                       ' __in  FILE_INFO_BY_HANDLE_CLASS FileInformationClass
 , BYREF ANY _                         ' __in_bcount(dwBufferSize)  LPVOID lpFileInformation
 , BYVAL DWORD _                       ' __in  DWORD dwBufferSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFileInformationByHandleEx LIB "KERNEL32.DLL" ALIAS "GetFileInformationByHandleEx" ( _
   BYVAL DWORD _                       ' __in  HANDLE hFile
 , BYVAL DWORD _                       ' __in  FILE_INFO_BY_HANDLE_CLASS FileInformationClass
 , BYREF ANY _                         ' __out_bcount(dwBufferSize) LPVOID lpFileInformation
 , BYVAL DWORD _                       ' __in  DWORD dwBufferSize
 ) AS LONG                             ' BOOL

' enum FILE_ID_TYPE
%FileIdType        = 0
%ObjectIdType      = 1
%MaximumFileIdType = 2

UNION FILE_ID_DESCRIPTOR_UNION
   FileId   AS QUAD   ' LARGE_INTEGER
   ObjectId AS GUID   ' GUID
END UNION

TYPE FILE_ID_DESCRIPTOR
   dwSize AS DWORD   ' DWORD // Size of the struct
   Type   AS DWORD   ' FILE_ID_TYPE // Describes the type of identifier passed in.
   FILE_ID_DESCRIPTOR_UNION
END TYPE

DECLARE FUNCTION OpenFileById LIB "KERNEL32.DLL" ALIAS "OpenFileById" ( _
   BYVAL DWORD _                       ' __in     HANDLE hVolumeHint
 , BYREF FILE_ID_DESCRIPTOR _          ' __in     LPFILE_ID_DESCRIPTOR lpFileId
 , BYVAL DWORD _                       ' __in     DWORD dwDesiredAccess
 , BYVAL DWORD _                       ' __in     DWORD dwShareMode
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpSecurityAttributes
 , BYVAL DWORD _                       ' __in     DWORD dwFlagsAndAttributes
 ) AS DWORD                            ' HANDLE

#ENDIF   ' #if (_WIN32_WINNT >= 0x0600)

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

'//
'//  Flags to be passed into CREATE_SYMBOLIC_LINK
'//

%SYMBOLIC_LINK_FLAG_DIRECTORY            = &H1

%VALID_SYMBOLIC_LINK_FLAGS  = %SYMBOLIC_LINK_FLAG_DIRECTORY  ' // & whatever other flags we think of!

DECLARE FUNCTION CreateSymbolicLink LIB "KERNEL32.DLL" ALIAS "CreateSymbolicLinkA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpSymlinkFileName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpTargetFileName
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS BYTE                             ' BOOLEAN

DECLARE FUNCTION CreateSymbolicLinkW LIB "KERNEL32.DLL" ALIAS "CreateSymbolicLinkW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpSymlinkFileName
 , BYVAL DWORD _                       ' __in LPCWSTR lpTargetFileName
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS BYTE                             ' BOOLEAN

DECLARE FUNCTION CreateSymbolicLinkTransacted LIB "KERNEL32.DLL" ALIAS "CreateSymbolicLinkTransactedA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpSymlinkFileName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpTargetFileName
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS BYTE                             ' BOOLEAN

DECLARE FUNCTION CreateSymbolicLinkTransactedW LIB "KERNEL32.DLL" ALIAS "CreateSymbolicLinkTransactedW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpSymlinkFileName
 , BYVAL DWORD _                       ' __in LPCWSTR lpTargetFileName
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in     HANDLE hTransaction
 ) AS BYTE                             ' BOOLEAN

DECLARE FUNCTION GetFinalPathNameByHandle LIB "KERNEL32.DLL" ALIAS "GetFinalPathNameByHandleA" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYREF ASCIIZ _                      ' __out_ecount(cchFilePath) LPSTR lpszFilePath
 , BYVAL DWORD _                       ' __in DWORD cchFilePath
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetFinalPathNameByHandleW LIB "KERNEL32.DLL" ALIAS "GetFinalPathNameByHandleW" ( _
   BYVAL DWORD _                       ' __in HANDLE hFile
 , BYVAL DWORD _                       ' __out_ecount(cchFilePath) LPWSTR lpszFilePath
 , BYVAL DWORD _                       ' __in DWORD cchFilePath
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' DWORD

#ENDIF ' // (_WIN32_WINNT >= 0x0600)


'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600

DECLARE FUNCTION QueryActCtxSettingsW LIB "KERNEL32.DLL" ALIAS "QueryActCtxSettingsW" ( _
   BYVAL DWORD _                       ' __in_opt      DWORD dwFlags
 , BYVAL DWORD _                       ' __in_opt      HANDLE hActCtx
 , BYVAL DWORD _                       ' __in_opt      PCWSTR settingsNameSpace
 , BYVAL DWORD _                       ' __in          PCWSTR settingName
 , BYVAL DWORD _                       ' __out_bcount_part_opt(dwBuffer, *pdwWrittenOrRequired) PWSTR pvBuffer
 , BYVAL DWORD _                       ' __in          SIZE_T dwBuffer
 , BYREF DWORD _                       ' __out_opt     SIZE_T *pdwWrittenOrRequired
 ) AS LONG                             ' BOOL

#ENDIF   ' #if (_WIN32_WINNT >= 0x0600)

#ENDIF   ' #IF NOT %DEF(%WINBASE)


'/**************************************************************************
'*                                                                         *
'* wingdi.h -- GDI procedure declarations, constant definitions and macros *
'*                                                                         *
'* Copyright (c) Microsoft Corp. All rights reserved.                      *
'*                                                                         *
'**************************************************************************/

#IF NOT %DEF(%WINGDI_INC)
    %WINGDI_INC = 1

'#ifndef WINVER
'#define WINVER 0x0500   // version 5.0
'#endif /* WINVER */

'#IF NOT %DEF(%NOGDI) ' --------------------------------------------------------
'#ifndef NOGDI

#IF NOT %DEF(%NORASTEROPS) ' --------------------------------------------------
'#ifndef NORASTEROPS

'/* Binary raster ops */
%R2_BLACK       = 1  ' /*  0       */
%R2_NOTMERGEPEN = 2  ' /* DPon     */
%R2_MASKNOTPEN  = 3  ' /* DPna     */
%R2_NOTCOPYPEN  = 4  ' /* PN       */
%R2_MASKPENNOT  = 5  ' /* PDna     */
%R2_NOT         = 6  ' /* Dn       */
%R2_XORPEN      = 7  ' /* DPx      */
%R2_NOTMASKPEN  = 8  ' /* DPan     */
%R2_MASKPEN     = 9  ' /* DPa      */
%R2_NOTXORPEN   = 10 ' /* DPxn     */
%R2_NOP         = 11 ' /* D        */
%R2_MERGENOTPEN = 12 ' /* DPno     */
%R2_COPYPEN     = 13 ' /* P        */
%R2_MERGEPENNOT = 14 ' /* PDno     */
%R2_MERGEPEN    = 15 ' /* DPo      */
%R2_WHITE       = 16 ' /*  1       */
%R2_LAST        = 16

'/* Ternary raster operations */
%SRCCOPY     = &H00CC0020??? ' (DWORD) dest = source
%SRCPAINT    = &H00EE0086??? ' (DWORD) dest = source OR dest
%SRCAND      = &H008800C6??? ' (DWORD) dest = source AND dest
%SRCINVERT   = &H00660046??? ' (DWORD) dest = source XOR dest
%SRCERASE    = &H00440328??? ' (DWORD) dest = source AND (NOT dest )
%NOTSRCCOPY  = &H00330008??? ' (DWORD) dest = (NOT source)
%NOTSRCERASE = &H001100A6??? ' (DWORD) dest = (NOT src) AND (NOT dest)
%MERGECOPY   = &H00C000CA??? ' (DWORD) dest = (source AND pattern)
%MERGEPAINT  = &H00BB0226??? ' (DWORD) dest = (NOT source) OR dest
%PATCOPY     = &H00F00021??? ' (DWORD) dest = pattern
%PATPAINT    = &H00FB0A09??? ' (DWORD) dest = DPSnoo
%PATINVERT   = &H005A0049??? ' (DWORD) dest = pattern XOR dest
%DSTINVERT   = &H00550009??? ' (DWORD) dest = (NOT dest)
%BLACKNESS   = &H00000042??? ' (DWORD) dest = BLACK
%WHITENESS   = &H00FF0062??? ' (DWORD) dest = WHITE

'#if(WINVER >= 0x0500)
%NOMIRRORBITMAP      = &H80000000??? ' /* Do not Mirror the bitmap in this call */
%CAPTUREBLT          = &H40000000??? ' /* Include layered windows */
'#endif /* WINVER >= 0x0500 */

'/* Quaternary raster codes */
'#define MAKEROP4(fore,back) (DWORD)((((back) << 8) & 0xFF000000) | (fore))
'   FUNCTION MAKEROP4 (BYVAL dFore AS DWORD, BYVAL dBack AS DWORD) AS DWORD
'      SHIFT LEFT dBack, 8
'      dBack = (dBack AND &HFF000000???)
'      FUNCTION = (dBack OR dFore)
'   END FUNCTION

'#endif /* NORASTEROPS */
#ENDIF   ' #IF NOT %DEF(%NORASTEROPS) -----------------------------------------

'#define GDI_ERROR (0xFFFFFFFFL)
'#define HGDI_ERROR (LongToHandle(0xFFFFFFFFL))

%GDI_ERROR   = &HFFFFFFFF???
%HGDI_ERROR  = &HFFFFFFFF???

'/* Region Flags */
%RGN_ERROR     = 0
%NULLREGION    = 1
%SIMPLEREGION  = 2
%COMPLEXREGION = 3

'/* CombineRgn() Styles */
%RGN_AND  = 1
%RGN_OR   = 2
%RGN_XOR  = 3
%RGN_DIFF = 4
%RGN_COPY = 5
%RGN_MIN  = %RGN_AND
%RGN_MAX  = %RGN_COPY

'/* StretchBlt() Modes */
%BLACKONWHITE      = 1
%WHITEONBLACK      = 2
%COLORONCOLOR      = 3
%HALFTONE          = 4
%MAXSTRETCHBLTMODE = 4

'#if(WINVER >= 0x0400)
'/* New StretchBlt() Modes */
%STRETCH_ANDSCANS    = %BLACKONWHITE
%STRETCH_ORSCANS     = %WHITEONBLACK
%STRETCH_DELETESCANS = %COLORONCOLOR
%STRETCH_HALFTONE    = %HALFTONE
'#endif /* WINVER >= 0x0400 */

'/* PolyFill() Modes */
%ALTERNATE     = 1
%WINDING       = 2
%POLYFILL_LAST = 2

'/* Layout Orientation Options */
'#if(WINVER >= 0x0500)
%LAYOUT_RTL                         = &H00000001???  ' // Right to left
%LAYOUT_BTT                         = &H00000002???  ' // Bottom to top
%LAYOUT_VBH                         = &H00000004???  ' // Vertical before horizontal
%LAYOUT_ORIENTATIONMASK             = (%LAYOUT_RTL OR %LAYOUT_BTT OR %LAYOUT_VBH)
%LAYOUT_BITMAPORIENTATIONPRESERVED  = &H00000008???
'#endif /* WINVER >= 0x0500 */

'/* Text Alignment Options */
%TA_NOUPDATECP = 0
%TA_UPDATECP   = 1

%TA_LEFT       = 0
%TA_RIGHT      = 2
%TA_CENTER     = 6

'#define TA_TOP                       0
'#define TA_BOTTOM                    8
'#define TA_BASELINE                  24
'#if (WINVER >= 0x0400)
'#define TA_RTLREADING                256
'#define TA_MASK       (TA_BASELINE+TA_CENTER+TA_UPDATECP+TA_RTLREADING)
'#else
'#define TA_MASK       (TA_BASELINE+TA_CENTER+TA_UPDATECP)
'#endif

%TA_TOP        = 0
%TA_BOTTOM     = 8
%TA_BASELINE   = 24
%TA_RTLREADING = 256
%TA_MASK       = %TA_BASELINE + %TA_CENTER + %TA_UPDATECP + %TA_RTLREADING

%VTA_BASELINE  = %TA_BASELINE
%VTA_LEFT      = %TA_BOTTOM
%VTA_RIGHT     = %TA_TOP
%VTA_CENTER    = %TA_CENTER
%VTA_BOTTOM    = %TA_RIGHT
%VTA_TOP       = %TA_LEFT

%ETO_GRAYED         = 1
%ETO_OPAQUE         = 2
%ETO_CLIPPED        = 4
'#if(WINVER >= 0x0400)
%ETO_GLYPH_INDEX    = &H0010
%ETO_RTLREADING     = &H0080
%ETO_NUMERICSLOCAL  = &H0400
%ETO_NUMERICSLATIN  = &H0800
%ETO_IGNORELANGUAGE = &H1000
'#endif /* WINVER >= 0x0400 */
'#if (_WIN32_WINNT >= 0x0500)
%ETO_PDY            = &H2000
'#endif // (_WIN32_WINNT >= 0x0500)
'#if (_WIN32_WINNT >= _WIN32_WINNT_LONGHORN)
%ETO_REVERSE_INDEX_MAP = &H10000
'#endif

%ASPECT_FILTERING = &H0001

'/* Bounds Accumulation APIs */

%DCB_RESET      = &H0001
%DCB_ACCUMULATE = &H0002
%DCB_DIRTY      = %DCB_ACCUMULATE
%DCB_SET        = %DCB_RESET OR %DCB_ACCUMULATE
%DCB_ENABLE     = &H0004
%DCB_DISABLE    = &H0008

#IF NOT %DEF(%NOMETAFILE) ' ---------------------------------------------------
'#ifndef NOMETAFILE

'/* Metafile Functions */
%META_SETBKCOLOR            = &H0201
%META_SETBKMODE             = &H0102
%META_SETMAPMODE            = &H0103
%META_SETROP2               = &H0104
%META_SETRELABS             = &H0105
%META_SETPOLYFILLMODE       = &H0106
%META_SETSTRETCHBLTMODE     = &H0107
%META_SETTEXTCHAREXTRA      = &H0108
%META_SETTEXTCOLOR          = &H0209
%META_SETTEXTJUSTIFICATION  = &H020A
%META_SETWINDOWORG          = &H020B
%META_SETWINDOWEXT          = &H020C
%META_SETVIEWPORTORG        = &H020D
%META_SETVIEWPORTEXT        = &H020E
%META_OFFSETWINDOWORG       = &H020F
%META_SCALEWINDOWEXT        = &H0410
%META_OFFSETVIEWPORTORG     = &H0211
%META_SCALEVIEWPORTEXT      = &H0412
%META_LINETO                = &H0213
%META_MOVETO                = &H0214
%META_EXCLUDECLIPRECT       = &H0415
%META_INTERSECTCLIPRECT     = &H0416
%META_ARC                   = &H0817
%META_ELLIPSE               = &H0418
%META_FLOODFILL             = &H0419
%META_PIE                   = &H081A
%META_RECTANGLE             = &H041B
%META_ROUNDRECT             = &H061C
%META_PATBLT                = &H061D
%META_SAVEDC                = &H001E
%META_SETPIXEL              = &H041F
%META_OFFSETCLIPRGN         = &H0220
%META_TEXTOUT               = &H0521
%META_BITBLT                = &H0922
%META_STRETCHBLT            = &H0B23
%META_POLYGON               = &H0324
%META_POLYLINE              = &H0325
%META_ESCAPE                = &H0626
%META_RESTOREDC             = &H0127
%META_FILLREGION            = &H0228
%META_FRAMEREGION           = &H0429
%META_INVERTREGION          = &H012A
%META_PAINTREGION           = &H012B
%META_SELECTCLIPREGION      = &H012C
%META_SELECTOBJECT          = &H012D
%META_SETTEXTALIGN          = &H012E
%META_CHORD                 = &H0830
%META_SETMAPPERFLAGS        = &H0231
%META_EXTTEXTOUT            = &H0A32
%META_SETDIBTODEV           = &H0D33
%META_SELECTPALETTE         = &H0234
%META_REALIZEPALETTE        = &H0035
%META_ANIMATEPALETTE        = &H0436
%META_SETPALENTRIES         = &H0037
%META_POLYPOLYGON           = &H0538
%META_RESIZEPALETTE         = &H0139
%META_DIBBITBLT             = &H0940
%META_DIBSTRETCHBLT         = &H0B41
%META_DIBCREATEPATTERNBRUSH = &H0142
%META_STRETCHDIB            = &H0F43
%META_EXTFLOODFILL          = &H0548
'#if(WINVER >= 0x0500)
%META_SETLAYOUT             = &H0149
'#endif /* WINVER >= 0x0500 */
%META_DELETEOBJECT          = &H01F0
%META_CREATEPALETTE         = &H00F7
%META_CREATEPATTERNBRUSH    = &H01F9
%META_CREATEPENINDIRECT     = &H02FA
%META_CREATEFONTINDIRECT    = &H02FB
%META_CREATEBRUSHINDIRECT   = &H02FC
%META_CREATEREGION          = &H06FF

'#if(WINVER >= 0x0400)

TYPE DRAWPATRECT
   ptPosition AS POINTAPI   ' POINT
   ptSize   AS POINTAPI     ' POINT
   wStyle   AS WORD         ' WORD
   wPattern AS WORD         ' WORD
END TYPE

'#endif /* WINVER >= 0x0400 */

'#endif /* NOMETAFILE */
#ENDIF   ' #IF NOT %DEF(%NOMETAFILE) ------------------------------------------

'/* GDI Escapes */
%NEWFRAME                    = 1
%ABORTDOC                    = 2
%NEXTBAND                    = 3
%SETCOLORTABLE               = 4
%GETCOLORTABLE               = 5
%FLUSHOUTPUT                 = 6
%DRAFTMODE                   = 7
%QUERYESCSUPPORT             = 8
%SETABORTPROC                = 9
%STARTDOC                    = 10
%ENDDOC                      = 11
%GETPHYSPAGESIZE             = 12
%GETPRINTINGOFFSET           = 13
%GETSCALINGFACTOR            = 14
%MFCOMMENT                   = 15
%GETPENWIDTH                 = 16
%SETCOPYCOUNT                = 17
%SELECTPAPERSOURCE           = 18
%DEVICEDATA                  = 19
%PASSTHROUGH                 = 19
%GETTECHNOLGY                = 20
%GETTECHNOLOGY               = 20
%SETLINECAP                  = 21
%SETLINEJOIN                 = 22
%SETMITERLIMIT               = 23
%BANDINFO                    = 24
%DRAWPATTERNRECT             = 25
%GETVECTORPENSIZE            = 26
%GETVECTORBRUSHSIZE          = 27
%ENABLEDUPLEX                = 28
%GETSETPAPERBINS             = 29
%GETSETPRINTORIENT           = 30
%ENUMPAPERBINS               = 31
%SETDIBSCALING               = 32
%EPSPRINTING                 = 33
%ENUMPAPERMETRICS            = 34
%GETSETPAPERMETRICS          = 35
%POSTSCRIPT_DATA             = 37
%POSTSCRIPT_IGNORE           = 38
%MOUSETRAILS                 = 39
%GETDEVICEUNITS              = 42

%GETEXTENDEDTEXTMETRICS      = 256
%GETEXTENTTABLE              = 257
%GETPAIRKERNTABLE            = 258
%GETTRACKKERNTABLE           = 259
%EXTTEXTOUT                  = 512
%GETFACENAME                 = 513
%DOWNLOADFACE                = 514
%ENABLERELATIVEWIDTHS        = 768
%ENABLEPAIRKERNING           = 769
%SETKERNTRACK                = 770
%SETALLJUSTVALUES            = 771
%SETCHARSET                  = 772

%STRETCHBLT                  = 2048
%METAFILE_DRIVER             = 2049
%GETSETSCREENPARAMS          = 3072
%QUERYDIBSUPPORT             = 3073
%BEGIN_PATH                  = 4096
%CLIP_TO_PATH                = 4097
%END_PATH                    = 4098
%EXT_DEVICE_CAPS             = 4099
%RESTORE_CTM                 = 4100
%SAVE_CTM                    = 4101
%SET_ARC_DIRECTION           = 4102
%SET_BACKGROUND_COLOR        = 4103
%SET_POLY_MODE               = 4104
%SET_SCREEN_ANGLE            = 4105
%SET_SPREAD                  = 4106
%TRANSFORM_CTM               = 4107
%SET_CLIP_BOX                = 4108
%SET_BOUNDS                  = 4109
%SET_MIRROR_MODE             = 4110
%OPENCHANNEL                 = 4110
%DOWNLOADHEADER              = 4111
%CLOSECHANNEL                = 4112
%POSTSCRIPT_PASSTHROUGH      = 4115
%ENCAPSULATED_POSTSCRIPT     = 4116

%POSTSCRIPT_IDENTIFY         = 4117  ' /* new escape for NT5 pscript driver */
%POSTSCRIPT_INJECTION        = 4118  ' /* new escape for NT5 pscript driver */

%CHECKJPEGFORMAT             = 4119
%CHECKPNGFORMAT              = 4120

%GET_PS_FEATURESETTING       = 4121  ' /* new escape for NT5 pscript driver */

%GDIPLUS_TS_QUERYVER         = 4122  ' /* private escape */
%GDIPLUS_TS_RECORD           = 4123  ' /* private escape */

'/*
' * Return Values for MILCORE_TS_QUERYVER
' */

'#if (_WIN32_WINNT >= _WIN32_WINNT_LONGHORN)
%MILCORE_TS_QUERYVER_RESULT_FALSE = &H0
%MILCORE_TS_QUERYVER_RESULT_TRUE  = &H7FFFFFFF???
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_LONGHORN)

%SPCLPASSTHROUGH2            = 4568  ' /* new escape for NT5 pscript driver */

'/*
' * Parameters for POSTSCRIPT_IDENTIFY escape
' */

%PSIDENT_GDICENTRIC = 0
%PSIDENT_PSCENTRIC  = 1

'/*
' * Header structure for the input buffer to POSTSCRIPT_INJECTION escape
' */

TYPE PSINJECTDATA
   DataBytes      AS DWORD   ' DWORD // number of raw data bytes
   InjectionPoint AS DWORD   ' WORD  // injection point
   Flags          AS DWORD   ' WORD  // flags
   Reserved       AS DWORD   ' reserved field - must be 0
END TYPE

'/*
' * Constants for PSINJECTDATA.InjectionPoint field
' */

%PSINJECT_BEGINSTREAM               = 1
%PSINJECT_PSADOBE                   = 2
%PSINJECT_PAGESATEND                = 3
%PSINJECT_PAGES                     = 4

%PSINJECT_DOCNEEDEDRES              = 5
%PSINJECT_DOCSUPPLIEDRES            = 6
%PSINJECT_PAGEORDER                 = 7
%PSINJECT_ORIENTATION               = 8
%PSINJECT_BOUNDINGBOX               = 9
%PSINJECT_DOCUMENTPROCESSCOLORS     = 10

%PSINJECT_COMMENTS                   = 11
%PSINJECT_BEGINDEFAULTS              = 12
%PSINJECT_ENDDEFAULTS                = 13
%PSINJECT_BEGINPROLOG                = 14
%PSINJECT_ENDPROLOG                  = 15
%PSINJECT_BEGINSETUP                 = 16
%PSINJECT_ENDSETUP                   = 17
%PSINJECT_TRAILER                    = 18
%PSINJECT_EOF                        = 19
%PSINJECT_ENDSTREAM                  = 20
%PSINJECT_DOCUMENTPROCESSCOLORSATEND = 21

%PSINJECT_PAGENUMBER                = 100
%PSINJECT_BEGINPAGESETUP            = 101
%PSINJECT_ENDPAGESETUP              = 102
%PSINJECT_PAGETRAILER               = 103
%PSINJECT_PLATECOLOR                = 104

%PSINJECT_SHOWPAGE                  = 105
%PSINJECT_PAGEBBOX                  = 106
%PSINJECT_ENDPAGECOMMENTS           = 107

%PSINJECT_VMSAVE                    = 200
%PSINJECT_VMRESTORE                 = 201

'/*
' * Parameter for GET_PS_FEATURESETTING escape
' */

%FEATURESETTING_NUP                 = 0
%FEATURESETTING_OUTPUT              = 1
%FEATURESETTING_PSLEVEL             = 2
%FEATURESETTING_CUSTPAPER           = 3
%FEATURESETTING_MIRROR              = 4
%FEATURESETTING_NEGATIVE            = 5
%FEATURESETTING_PROTOCOL            = 6

'#if (_WIN32_WINNT >= _WIN32_WINNT_WINXP)
'//
'// The range of selectors between FEATURESETTING_PRIVATE_BEGIN and
'// FEATURESETTING_PRIVATE_END is reserved by Microsoft for private use
'//
%FEATURESETTING_PRIVATE_BEGIN = &H1000
%FEATURESETTING_PRIVATE_END   = &H1FFF
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_WINXP)

'/*
' * Information about output options
' */

TYPE PSFEATURE_OUTPUT
   bPageIndependent AS LONG   ' BOOL
   bSetPageDevice   AS LONG   ' BOOL
END TYPE

'/*
' * Information about custom paper size
' */

TYPE PSFEATURE_CUSTPAPER
   lOrientation  AS LONG
   lWidth        AS LONG
   lHeight       AS LONG
   lWidthOffset  AS LONG
   lHeightOffset AS LONG
END TYPE

'/* Value returned for FEATURESETTING_PROTOCOL */
%PSPROTOCOL_ASCII            = 0
%PSPROTOCOL_BCP              = 1
%PSPROTOCOL_TBCP             = 2
%PSPROTOCOL_BINARY           = 3

'/* Flag returned from QUERYDIBSUPPORT */
%QDI_SETDIBITS               = 1
%QDI_GETDIBITS               = 2
%QDI_DIBTOSCREEN             = 4
%QDI_STRETCHDIB              = 8

'/* Spooler Error Codes */
%SP_NOTREPORTED = &H4000
%SP_ERROR       = -1
%SP_APPABORT    = -2
%SP_USERABORT   = -3
%SP_OUTOFDISK   = -4
%SP_OUTOFMEMORY = -5

%PR_JOBSTATUS = &H0000

'/* Object Definitions for EnumObjects() */
%OBJ_PEN         = 1
%OBJ_BRUSH       = 2
%OBJ_DC          = 3
%OBJ_METADC      = 4
%OBJ_PAL         = 5
%OBJ_FONT        = 6
%OBJ_BITMAP      = 7
%OBJ_REGION      = 8
%OBJ_METAFILE    = 9
%OBJ_MEMDC       = 10
%OBJ_EXTPEN      = 11
%OBJ_ENHMETADC   = 12
%OBJ_ENHMETAFILE = 13
%OBJ_COLORSPACE  = 14

%GDI_OBJ_LAST    = %OBJ_COLORSPACE

'/* xform stuff */
%MWT_IDENTITY      = 1
%MWT_LEFTMULTIPLY  = 2
%MWT_RIGHTMULTIPLY = 3

%MWT_MIN = %MWT_IDENTITY
%MWT_MAX = %MWT_RIGHTMULTIPLY

'#define _XFORM_
TYPE XFORM
   eM11 AS SINGLE   ' FLOAT
   eM12 AS SINGLE   ' FLOAT
   eM21 AS SINGLE   ' FLOAT
   eM22 AS SINGLE   ' FLOAT
   eDx  AS SINGLE   ' FLOAT
   eDy  AS SINGLE   ' FLOAT
END TYPE

'/* Bitmap Header Definition */

TYPE BITMAP
   bmType       AS LONG       ' LONG
   bmWidth      AS LONG       ' LONG
   bmHeight     AS LONG       ' LONG
   bmWidthBytes AS LONG       ' LONG
   bmPlanes     AS WORD       ' WORD
   bmBitsPixel  AS WORD       ' WORD
   bmBits       AS BYTE PTR   ' LPVOID
END TYPE

'#include <pshpack1.h>
TYPE RGBTRIPLE BYTE
   rgbtBlue  AS BYTE
   rgbtGreen AS BYTE
   rgbtRed   AS BYTE
END TYPE
'#include <poppack.h>

#IF NOT %DEF(%RGBQUAD_DEFINED)
%RGBQUAD_DEFINED = 1
TYPE RGBQUAD
   rgbBlue     AS BYTE
   rgbGreen    AS BYTE
   rgbRed      AS BYTE
   rgbReserved AS BYTE
END TYPE
#ENDIF

'#if(WINVER >= 0x0400)

'/* Image Color Matching color definitions */

%CS_ENABLE           = &H00000001???
%CS_DISABLE          = &H00000002???
%CS_DELETE_TRANSFORM = &H00000003???

'/* Logcolorspace signature */

'#define LCS_SIGNATURE           'PSOC'
%LCS_SIGNATURE = &H50534f43     ' "PSOC"

'/* Logcolorspace lcsType values */

'#define LCS_sRGB                'sRGB'
'#define LCS_WINDOWS_COLOR_SPACE 'Win '  // Windows default color space

%LCS_sRGB                = &H73524742  ' "sRGB"
%LCS_WINDOWS_COLOR_SPACE = &H57696e20  ' "Win "  ' Windows default color space

'typedef LONG   LCSCSTYPE;
%LCS_CALIBRATED_RGB      = &H00000000???

'typedef LONG    LCSGAMUTMATCH;
%LCS_GM_BUSINESS         = &H00000001???
%LCS_GM_GRAPHICS         = &H00000002???
%LCS_GM_IMAGES           = &H00000004???
%LCS_GM_ABS_COLORIMETRIC = &H00000008???

'/* ICM Defines for results from CheckColorInGamut() */
%CM_OUT_OF_GAMUT = 255
%CM_IN_GAMUT     = 0

'/* UpdateICMRegKey Constants               */
%ICM_ADDPROFILE          = 1
%ICM_DELETEPROFILE       = 2
%ICM_QUERYPROFILE        = 3
%ICM_SETDEFAULTPROFILE   = 4
%ICM_REGISTERICMATCHER   = 5
%ICM_UNREGISTERICMATCHER = 6
%ICM_QUERYMATCH          = 7

'/* Macros to retrieve CMYK values from a COLORREF */
'#define GetKValue(cmyk)      ((BYTE)(cmyk))
'#define GetYValue(cmyk)      ((BYTE)((cmyk)>> 8))
'#define GetMValue(cmyk)      ((BYTE)((cmyk)>>16))
'#define GetCValue(cmyk)      ((BYTE)((cmyk)>>24))

'#define CMYK(c,m,y,k)       ((COLORREF)((((BYTE)(k)|((WORD)((BYTE)(y))<<8))|(((DWORD)(BYTE)(m))<<16))|(((DWORD)(BYTE)(c))<<24)))

'   FUNCTION GetKValue (BYVAL dwCMYK AS DWORD) AS BYTE
'      FUNCTION = (dwCMYK AND &HFF???)
'   END FUNCTION

'   FUNCTION GetYValue (BYVAL dwCMYK AS DWORD) AS BYTE
'      SHIFT RIGHT dwCMYK, 8
'      FUNCTION = (dwCMYK AND &HFF???)
'   END FUNCTION

'   FUNCTION GetMValue (BYVAL dwCMYK AS DWORD) AS BYTE
'      SHIFT RIGHT dwCMYK, 16
'      FUNCTION = (dwCMYK AND &HFF???)
'   END FUNCTION

'   FUNCTION GetCValue (BYVAL dwCMYK AS DWORD) AS BYTE
'      SHIFT RIGHT dwCMYK, 24
'      FUNCTION = (dwCMYK AND &HFF???)
'   END FUNCTION

'   FUNCTION CMYK (BYVAL c AS BYTE, BYVAL m AS BYTE, BYVAL y AS BYTE, BYVAL k AS BYTE) AS DWORD
'      LOCAL dwCMYKtmp AS DWORD
'      LOCAL dwCMYKacc AS DWORD
'      dwCMYKacc = c
'      SHIFT LEFT dwCMYKacc, 24
'      dwCMYKtmp = m
'      SHIFT LEFT dwCMYKtmp, 16
'      dwCMYKacc = (dwCMYKacc OR dwCMYKtmp)
'      dwCMYKtmp = y
'      SHIFT LEFT dwCMYKtmp, 8
'      FUNCTION= (dwCMYKacc OR dwCMYKtmp OR k)
'   END FUNCTION

'typedef long            FXPT16DOT16, FAR *LPFXPT16DOT16;
'typedef long            FXPT2DOT30, FAR *LPFXPT2DOT30;

'/* ICM Color Definitions */
'// The following two structures are used for defining RGB's in terms of CIEXYZ.

TYPE CIEXYZ
   ciexyzX AS LONG   ' FXPT2DOT30
   ciexyzY AS LONG   ' FXPT2DOT30
   ciexyzZ AS LONG   ' FXPT2DOT30
END TYPE

TYPE CIEXYZTRIPLE
   ciexyzRed   AS CIEXYZ
   ciexyzGreen AS CIEXYZ
   ciexyBlue   AS CIEXYZ
END TYPE

'// The next structures the logical color space. Unlike pens and brushes,
'// but like palettes, there is only one way to create a LogColorSpace.
'// A pointer to it must be passed, its elements can't be pushed as
'// arguments.

TYPE LOGCOLORSPACEA
   lcsSignature  AS DWORD                   ' DWORD
   lcsVersion    AS DWORD                   ' DWORD
   lcsSize       AS DWORD                   ' DWORD
   lcsCSType     AS LONG                    ' LCSCSTYPE
   lcsIntent     AS LONG                    ' LCSGAMUTMATCH
   lcsEndPoints  AS CIEXYZTRIPLE            ' CIEXYZTRIPLE
   lcsGammaRed   AS DWORD                   ' DWORD
   lcsGammaGreen AS DWORD                   ' DWORD
   lcsGammaBlue  AS DWORD                   ' DWORD
   lcsFileName   AS ASCIIZ * %MAX_PATH      ' CHAR   lcsFilename[MAX_PATH]
END TYPE

TYPE LOGCOLORSPACEW
   lcsSignature  AS DWORD                   ' DWORD
   lcsVersion    AS DWORD                   ' DWORD
   lcsSize       AS DWORD                   ' DWORD
   lcsCSType     AS LONG                    ' LCSCSTYPE
   lcsIntent     AS LONG                    ' LCSGAMUTMATCH
   lcsEndPoints  AS CIEXYZTRIPLE            ' CIEXYZTRIPLE
   lcsGammaRed   AS DWORD                   ' DWORD
   lcsGammaGreen AS DWORD                   ' DWORD
   lcsGammaBlue  AS DWORD                   ' DWORD
   lcsFileName   AS ASCIIZ * %MAX_PATH * 2  ' WCHAR   lcsFilename[MAX_PATH]
END TYPE

MACRO LOGCOLORSPACE = LOGCOLORSPACEA

'#endif /* WINVER >= 0x0400 */

'/* structures for defining DIBs */
TYPE BITMAPCOREHEADER
   bcSize     AS DWORD
   bcWidth    AS WORD
   bcHeight   AS WORD
   bcPlanes   AS WORD
   bcBitCount AS WORD
END TYPE

TYPE BITMAPINFOHEADER
   biSize          AS DWORD
   biWidth         AS LONG
   biHeight        AS LONG
   biPlanes        AS WORD
   biBitCount      AS WORD
   biCompression   AS DWORD
   biSizeImage     AS DWORD
   biXPelsPerMeter AS LONG
   biYPelsPerMeter AS LONG
   biClrUsed       AS DWORD
   biClrImportant  AS DWORD
END TYPE

'#if(WINVER >= 0x0400)
TYPE BITMAPV4HEADER
   bV4Size          AS DWORD
   bV4Width         AS LONG
   bV4Height        AS LONG
   bV4Planes        AS WORD
   bV4BitCount      AS WORD
   bV4Compression   AS DWORD
   bV4SizeImage     AS DWORD
   bV4XPelsPerMeter AS LONG
   bV4YPelsPerMeter AS LONG
   bV4ClrUsed       AS DWORD
   bV4ClrImportant  AS DWORD
   bV4RedMask       AS DWORD
   bV4GreenMask     AS DWORD
   bV4BlueMask      AS DWORD
   bV4AlphaMask     AS DWORD
   bV4CSType        AS DWORD
   bV4Endpoints     AS CIEXYZTRIPLE
   bV4GammaRed      AS DWORD
   bV4GammaGreen    AS DWORD
   bV4GammaBlue     AS DWORD
END TYPE
'#endif /* WINVER >= 0x0400 */

'#if (WINVER >= 0x0500)
TYPE BITMAPV5HEADER
   bV5Size          AS DWORD
   bV5Width         AS LONG
   bV5Height        AS LONG
   bV5Planes        AS WORD
   bV5BitCount      AS WORD
   bV5Compression   AS DWORD
   bV5SizeImage     AS DWORD
   bV5XPelsPerMeter AS LONG
   bV5YPelsPerMeter AS LONG
   bV5ClrUsed       AS DWORD
   bV5ClrImportant  AS DWORD
   bV5RedMask       AS DWORD
   bV5GreenMask     AS DWORD
   bV5BlueMask      AS DWORD
   bV5AlphaMask     AS DWORD
   bV5CSType        AS DWORD
   bV5Endpoints     AS CIEXYZTRIPLE
   bV5GammaRed      AS DWORD
   bV5GammaGreen    AS DWORD
   bV5GammaBlue     AS DWORD
   bV5Intent        AS DWORD
   bV5ProfileData   AS DWORD
   bV5ProfileSize   AS DWORD
   bV5Reserved      AS DWORD
END TYPE

'// Values for bV5CSType
'#define PROFILE_LINKED          'LINK'
'#define PROFILE_EMBEDDED        'MBED'

%PROFILE_LINKED   = &H4c494e4b  ' "LINK"
%PROFILE_EMBEDDED = &H4d424544  ' "MBED"
'#endif

'/* constants for the biCompression field */
%BI_RGB       = 0&
%BI_RLE8      = 1&
%BI_RLE4      = 2&
%BI_BITFIELDS = 3&
%BI_JPEG      = 4&
%BI_PNG       = 5&
'#if (_WIN32_WINNT >= 0x0400)
'#endif

TYPE BITMAPINFO
   bmiHeader     AS BITMAPINFOHEADER
   bmiColors (0) AS RGBQUAD            ' RGBQUAD
END TYPE

TYPE BITMAPCOREINFO
   bmciHeader    AS BITMAPCOREHEADER
   bmciColors(0) AS RGBTRIPLE          ' RGBTRIPLE bmciColors[1]
END TYPE

'#include <pshpack2.h>
TYPE BITMAPFILEHEADER WORD
   bfType      AS WORD
   bfSize      AS DWORD
   bfReserved1 AS WORD
   bfReserved2 AS WORD
   bfOffBits   AS DWORD
END TYPE
'#include <poppack.h>

'#define MAKEPOINTS(l)       (*((POINTS FAR *)&(l)))

'#if(WINVER >= 0x0400)
#IF NOT %DEF(%NOFONTSIG)   ' --------------------------------------------------
'#ifndef NOFONTSIG
TYPE FONTSIGNATURE
   fsUsb(3) AS DWORD
   fsCsb(1) AS DWORD
END TYPE

TYPE CHARSETINFO
   ciCharset AS DWORD           ' UINT
   ciACP     AS DWORD           ' UINT
   fs        AS FONTSIGNATURE   ' FONTSIGNATURE
END TYPE

%TCI_SRCCHARSET  = 1
%TCI_SRCCODEPAGE = 2
%TCI_SRCFONTSIG  = 3
'#if (_WIN32_WINNT >= _WIN32_WINNT_WINXP)
%TCI_SRCLOCALE   = &H1000
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_WINXP)

TYPE LOCALESIGNATURE
   lsUsb         (3) AS DWORD
   lsCsbDefault  (1) AS DWORD
   lsCsbSupported(1) AS DWORD
END TYPE

'#endif
#ENDIF   ' #IF NOT %DEF(%NOFONTSIG)   -----------------------------------------
'#endif /* WINVER >= 0x0400 */

#IF NOT %DEF(%NOMETAFILE) ' ---------------------------------------------------
'#ifndef NOMETAFILE

'/* Clipboard Metafile Picture Structure */
TYPE HANDLETABLE
   objectHandle(0) AS DWORD   ' HGDIOBJ objectHandle[1]
END TYPE

TYPE METARECORD
   rdSize     AS DWORD   ' DWORD
   rdFunction AS WORD    ' WORD
   rdParm(0)  AS WORD    ' WORD  rdParm[1]
END TYPE

TYPE METAFILEPICT
   mm   AS LONG    ' LONG
   xExt AS LONG    ' LONG
   yExt AS LONG    ' LONG
   hMF  AS DWORD   ' HMETAFILE
END TYPE

'#include <pshpack2.h>
TYPE METAHEADER WORD
   mtType         AS WORD
   mtHeaderSize   AS WORD
   mtVersion      AS WORD
   mtSize         AS DWORD
   mtNoObjects    AS WORD
   mtMaxRecord    AS DWORD
   mtNoParameters AS WORD
END TYPE

'#include <poppack.h>

TYPE ENHMETARECORD
   iType    AS DWORD   ' DWORD
   nSize    AS DWORD   ' DWORD
   dParm(0) AS DWORD   ' DWORD   dParm[1]
END TYPE

TYPE ENHMETAHEADER
   iType          AS DWORD   ' DWORD // Record type EMR_HEADER
   nSize          AS DWORD   ' DWORD // Record size in bytes. This may be greater
                             '       // than the sizeof(ENHMETAHEADER).
   rclBounds      AS RECTL   ' RECTL // Inclusive-inclusive bounds in device units
   rclFrame       AS RECTL   ' RECTL // Inclusive-inclusive Picture Frame of metafile in .01 mm units
   dSignature     AS DWORD   ' DWORD // Signature. Must be ENHMETA_SIGNATURE.
   nVersion       AS DWORD   ' DWORD // Version number
   nBytes         AS DWORD   ' DWORD // Size of the metafile in bytes
   nRecords       AS DWORD   ' DWORD // Number of records in the metafile
   nHandles       AS WORD    ' WORD  // Number of handles in the handle table
                             '       // Handle index zero is reserved.
   sReserved      AS WORD    ' WORD  // Reserved. Must be zero.
   nDescription   AS DWORD   ' DWORD // Number of chars in the unicode description string
                             '       // This is 0 if there is no description string
   offDescription AS DWORD   ' DWORD // Offset to the metafile description record.
                             '       // This is 0 if there is no description string
   nPalEntries    AS DWORD   ' DWORD // Number of entries in the metafile palette.
   szlDevice      AS SIZEL   ' SIZEL // Size of the reference device in pels
   szlMillimeters AS SIZEL   ' SIZEL // Size of the reference device in millimeters
'#if(WINVER >= 0x0400)
   cbPixelFormat  AS DWORD   ' DWORD // Size of PIXELFORMATDESCRIPTOR information
                             '       // This is 0 if no pixel format is set
   offPixelFormat AS DWORD   ' DWORD // Offset to PIXELFORMATDESCRIPTOR
                             '       // This is 0 if no pixel format is set
   bOpenGL        AS DWORD   ' DWORD // TRUE if OpenGL commands are present in
                             '       // the metafile, otherwise FALSE
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0500)
   szlMicrometers AS SIZEL   ' SIZEL // Size of the reference device in micrometers
'#endif /* WINVER >= 0x0500 */
END TYPE

'#endif /* NOMETAFILE */
#ENDIF   ' #IF NOT %DEF(%NOMETAFILE) ------------------------------------------

#IF NOT %DEF(%NOTEXTMETRIC) ' -------------------------------------------------
'#ifndef NOTEXTMETRIC

'/* tmPitchAndFamily flags */
%TMPF_FIXED_PITCH = &H01
%TMPF_VECTOR      = &H02
%TMPF_DEVICE      = &H08
%TMPF_TRUETYPE    = &H04

'//
'// BCHAR definition for APPs
'//
#IF NOT %DEF(%TEXTMETRIC_DEFINED) '--------------------------------------------
%TEXTMETRIC_DEFINED = 1
'#include <pshpack4.h>
TYPE TEXTMETRICA
   tmHeight           AS LONG
   tmAscent           AS LONG
   tmDescent          AS LONG
   tmInternalLeading  AS LONG
   tmExternalLeading  AS LONG
   tmAveCharWidth     AS LONG
   tmMaxCharWidth     AS LONG
   tmWeight           AS LONG
   tmOverhang         AS LONG
   tmDigitizedAspectX AS LONG
   tmDigitizedAspectY AS LONG
   tmFirstChar        AS BYTE
   tmLastChar         AS BYTE
   tmDefaultChar      AS BYTE
   tmBreakChar        AS BYTE
   tmItalic           AS BYTE
   tmUnderlined       AS BYTE
   tmStruckOut        AS BYTE
   tmPitchAndFamily   AS BYTE
   tmCharSet          AS BYTE
END TYPE

%TEXTMETRICW_DEFINED = 1
TYPE TEXTMETRICW
   tmHeight           AS LONG
   tmAscent           AS LONG
   tmDescent          AS LONG
   tmInternalLeading  AS LONG
   tmExternalLeading  AS LONG
   tmAveCharWidth     AS LONG
   tmMaxCharWidth     AS LONG
   tmWeight           AS LONG
   tmOverhang         AS LONG
   tmDigitizedAspectX AS LONG
   tmDigitizedAspectY AS LONG
   tmFirstChar        AS WORD   ' WCHAR
   tmLastChar         AS WORD   ' WCHAR
   tmDefaultChar      AS WORD   ' WCHAR
   tmBreakChar        AS WORD   ' WCHAR
   tmItalic           AS BYTE
   tmUnderlined       AS BYTE
   tmStruckOut        AS BYTE
   tmPitchAndFamily   AS BYTE
   tmCharSet          AS BYTE
END TYPE

MACRO TEXTMETRIC = TEXTMETRICA
'#include <poppack.h>
#ENDIF   ' #IF NOT %DEF(%TEXTMETRIC_DEFINED) ----------------------------------

'/* ntmFlags field flags */
%NTM_REGULAR        = &H00000040???
%NTM_BOLD           = &H00000020???
%NTM_ITALIC         = &H00000001???

'/* new in NT 5.0 */

%NTM_NONNEGATIVE_AC = &H00010000???
%NTM_OPENTYPE       = &H00020000???
%NTM_MULTIPLEMASTER = &H00040000???
%NTM_MM_INSTANCE    = &H00080000???
%NTM_TYPE1          = &H00100000???
%NTM_DSIG           = &H00200000???

'#include <pshpack4.h>
TYPE NEWTEXTMETRICA
   tmHeight           AS LONG
   tmAscent           AS LONG
   tmDescent          AS LONG
   tmInternalLeading  AS LONG
   tmExternalLeading  AS LONG
   tmAveCharWidth     AS LONG
   tmMaxCharWidth     AS LONG
   tmWeight           AS LONG
   tmOverhang         AS LONG
   tmDigitizedAspectX AS LONG
   tmDigitizedAspectY AS LONG
   tmFirstChar        AS BYTE
   tmLastChar         AS BYTE
   tmDefaultChar      AS BYTE
   tmBreakChar        AS BYTE
   tmItalic           AS BYTE
   tmUnderlined       AS BYTE
   tmStruckOut        AS BYTE
   tmPitchAndFamily   AS BYTE
   tmCharSet          AS BYTE
   ntmFlags           AS DWORD   ' DWORD
   ntmSizeEM          AS DWORD   ' UINT
   ntmCellHeight      AS DWORD   ' UINT
   ntmAveWidth        AS DWORD   ' UINT
END TYPE

TYPE NEWTEXTMETRICW
   tmHeight           AS LONG
   tmAscent           AS LONG
   tmDescent          AS LONG
   tmInternalLeading  AS LONG
   tmExternalLeading  AS LONG
   tmAveCharWidth     AS LONG
   tmMaxCharWidth     AS LONG
   tmWeight           AS LONG
   tmOverhang         AS LONG
   tmDigitizedAspectX AS LONG
   tmDigitizedAspectY AS LONG
   tmFirstChar        AS WORD    ' WCHAR
   tmLastChar         AS WORD    ' WCHAR
   tmDefaultChar      AS WORD    ' WCHAR
   tmBreakChar        AS WORD    ' WCHAR
   tmItalic           AS BYTE
   tmUnderlined       AS BYTE
   tmStruckOut        AS BYTE
   tmPitchAndFamily   AS BYTE
   tmCharSet          AS BYTE
   ntmFlags           AS DWORD   ' DWORD
   ntmSizeEM          AS DWORD   ' UINT
   ntmCellHeight      AS DWORD   ' UINT
   ntmAveWidth        AS DWORD   ' UINT
END TYPE

MACRO NEWTEXTMETRIC = NEWTEXTMETRICA
'#include <poppack.h>

'#if(WINVER >= 0x0400)
TYPE NEWTEXTMETRICEXA
   ntmTm      AS NEWTEXTMETRIC
   ntmFontSig AS FONTSIGNATURE
END TYPE

TYPE NEWTEXTMETRICEXW
   ntmTm      AS NEWTEXTMETRICW
   ntmFontSig AS FONTSIGNATURE
END TYPE

MACRO NEWTEXTMETRICEX = NEWTEXTMETRICEXA
'#endif /* WINVER >= 0x0400 */

'#endif /* NOTEXTMETRIC */
#ENDIF   ' #IF NOT %DEF(%NOTEXTMETRIC) ----------------------------------------
'/* GDI Logical Objects: */

'/* Pel Array */
TYPE PELARRAY
   paXCount AS LONG
   paYCount AS LONG
   paXExt   AS LONG
   paYExt   AS LONG
   paRGBs   AS BYTE
END TYPE

'/* Logical Brush (or Pattern) */
TYPE LOGBRUSH
   lbStyle AS DWORD   ' UINT
   lbColor AS DWORD   ' COLORREF
   lbHatch AS DWORD   ' ULONG_PTR
END TYPE

TYPE LOGBRUSH32
   lbStyle AS DWORD   ' UINT
   lbColor AS DWORD   ' COLORREF
   lbHatch AS DWORD   ' ULONG
END TYPE

'typedef LOGBRUSH             PATTERN;
'typedef PATTERN             *PPATTERN;
'typedef PATTERN NEAR        *NPPATTERN;
'typedef PATTERN FAR         *LPPATTERN;

'/* Logical Pen */
TYPE LOGPEN
   lopnStyle AS DWORD      ' UINT
   lopnWidth AS POINTAPI   ' POINT
   lopnColor AS DWORD      ' COLORREF
END TYPE

TYPE EXTLOGPEN
   elpPenStyle      AS DWORD   ' DWORD
   elpWidth         AS DWORD   ' DWORD
   elpBrushStyle    AS DWORD   ' UINT
   elpColor         AS DWORD   ' COLORREF
   elpHatch         AS DWORD   ' ULONG_PTR
   elpNumEntries    AS DWORD   ' DWORD
   elpStyleEntry(0) AS DWORD   ' DWORD elpStyleEntry[1]
END TYPE

#IF NOT %DEF(%LOGPALETTE_DEFINED) '--------------------------------------------
%LOGPALETTE_DEFINED = 1
TYPE LOGPALETTE
  palVersion     AS WORD
  palNumEntries  AS WORD
  palPalEntry(0) AS PALETTEENTRY   ' PALETTEENTRY palPalEntry[1]
END TYPE

'#endif // !_LOGPALETTE_DEFINED
#ENDIF   ' #IF NOT %DEF(%LOGPALETTE_DEFINED) ----------------------------------

'/* Logical Font */
%LF_FACESIZE     = 32

TYPE LOGFONTA
   lfHeight         AS LONG
   lfWidth          AS LONG
   lfEscapement     AS LONG
   lfOrientation    AS LONG
   lfWeight         AS LONG
   lfItalic         AS BYTE
   lfUnderline      AS BYTE
   lfStrikeOut      AS BYTE
   lfCharSet        AS BYTE
   lfOutPrecision   AS BYTE
   lfClipPrecision  AS BYTE
   lfQuality        AS BYTE
   lfPitchAndFamily AS BYTE
   lfFaceName       AS ASCIIZ * %LF_FACESIZE   ' CHAR lfFaceName[LF_FACESIZE]
END TYPE

TYPE LOGFONTW
   lfHeight         AS LONG
   lfWidth          AS LONG
   lfEscapement     AS LONG
   lfOrientation    AS LONG
   lfWeight         AS LONG
   lfItalic         AS BYTE
   lfUnderline      AS BYTE
   lfStrikeOut      AS BYTE
   lfCharSet        AS BYTE
   lfOutPrecision   AS BYTE
   lfClipPrecision  AS BYTE
   lfQuality        AS BYTE
   lfPitchAndFamily AS BYTE
   lfFaceName       AS STRING * %LF_FACESIZE * 2   ' WCHAR lfFaceName[LF_FACESIZE]
END TYPE

MACRO LOGFONT = LOGFONTA

%LF_FULLFACESIZE = 64

'/* Structure passed to FONTENUMPROC */
'typedef struct tagENUMLOGFONTA
'{
'    LOGFONTA elfLogFont;
'    BYTE     elfFullName[LF_FULLFACESIZE];
'    BYTE     elfStyle[LF_FACESIZE];
'} ENUMLOGFONTA, FAR* LPENUMLOGFONTA;

TYPE ENUMLOGFONTA
   elfLogFont  AS LOGFONTA
   elfFullName AS ASCIIZ * %LF_FULLFACESIZE
   elfStyle    AS ASCIIZ * %LF_FACESIZE
END TYPE

'/* Structure passed to FONTENUMPROC */
'typedef struct tagENUMLOGFONTW
'{
'    LOGFONTW elfLogFont;
'    WCHAR    elfFullName[LF_FULLFACESIZE];
'    WCHAR    elfStyle[LF_FACESIZE];
'} ENUMLOGFONTW, FAR* LPENUMLOGFONTW;

TYPE ENUMLOGFONTW
   elfLogFont  AS LOGFONTW
   elfFullName AS STRING * %LF_FULLFACESIZE * 2
   elfStyle    AS STRING * %LF_FACESIZE * 2
END TYPE

MACRO ENUMLOGFONT = ENUMLOGFONTA

'#if(WINVER >= 0x0400)
'typedef struct tagENUMLOGFONTEXA
'{
'    LOGFONTA    elfLogFont;
'    BYTE        elfFullName[LF_FULLFACESIZE];
'    BYTE        elfStyle[LF_FACESIZE];
'    BYTE        elfScript[LF_FACESIZE];
'} ENUMLOGFONTEXA, FAR *LPENUMLOGFONTEXA;

TYPE ENUMLOGFONTEXA
   elfLogFont  AS LOGFONTA
   elfFullName AS ASCIIZ  * %LF_FULLFACESIZE
   elfStyle    AS ASCIIZ  * %LF_FACESIZE
   elfScript   AS ASCIIZ  * %LF_FACESIZE
END TYPE

'typedef struct tagENUMLOGFONTEXW
'{
'    LOGFONTW    elfLogFont;
'    WCHAR       elfFullName[LF_FULLFACESIZE];
'    WCHAR       elfStyle[LF_FACESIZE];
'    WCHAR       elfScript[LF_FACESIZE];
'} ENUMLOGFONTEXW, FAR *LPENUMLOGFONTEXW;

TYPE ENUMLOGFONTEXW
   elfLogFont  AS LOGFONTW
   elfFullName AS STRING  * %LF_FULLFACESIZE * 2
   elfStyle    AS STRING  * %LF_FACESIZE * 2
   elfScript   AS STRING  * %LF_FACESIZE * 2
END TYPE

MACRO ENUMLOGFONTEX = ENUMLOGFONTEXA

'#endif /* WINVER >= 0x0400 */

%OUT_DEFAULT_PRECIS        = 0
%OUT_STRING_PRECIS         = 1
%OUT_CHARACTER_PRECIS      = 2
%OUT_STROKE_PRECIS         = 3
%OUT_TT_PRECIS             = 4
%OUT_DEVICE_PRECIS         = 5
%OUT_RASTER_PRECIS         = 6
%OUT_TT_ONLY_PRECIS        = 7
%OUT_OUTLINE_PRECIS        = 8
%OUT_SCREEN_OUTLINE_PRECIS = 9
%OUT_PS_ONLY_PRECIS        = 10

'#define CLIP_DEFAULT_PRECIS     0
'#define CLIP_CHARACTER_PRECIS   1
'#define CLIP_STROKE_PRECIS      2
'#define CLIP_MASK               0xf
'#define CLIP_LH_ANGLES          (1<<4)
'#define CLIP_TT_ALWAYS          (2<<4)
'#if (_WIN32_WINNT >= _WIN32_WINNT_LONGHORN)
'#define CLIP_DFA_DISABLE        (4<<4)
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_LONGHORN)
'#define CLIP_EMBEDDED           (8<<4)

%CLIP_DEFAULT_PRECIS   = 0
%CLIP_CHARACTER_PRECIS = 1
%CLIP_STROKE_PRECIS    = 2
%CLIP_MASK             = &HF
%CLIP_LH_ANGLES        = &H10   ' 16
%CLIP_TT_ALWAYS        = &H20   ' 32
'#if (_WIN32_WINNT >= _WIN32_WINNT_LONGHORN)
%CLIP_DFA_DISABLE      = &H40   ' 64
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_LONGHORN)
%CLIP_EMBEDDED         = &H80   ' 128

%DEFAULT_QUALITY        = 0
%DRAFT_QUALITY          = 1
%PROOF_QUALITY          = 2
'#if(WINVER >= 0x0400)
%NONANTIALIASED_QUALITY = 3
%ANTIALIASED_QUALITY    = 4
'#endif /* WINVER >= 0x0400 */

'#if (_WIN32_WINNT >= _WIN32_WINNT_WINXP)
%CLEARTYPE_QUALITY      = 5
%CLEARTYPE_NATURAL_QUALITY = 6
'#endif

%DEFAULT_PITCH   = 0
%FIXED_PITCH     = 1
%VARIABLE_PITCH  = 2
'#if(WINVER >= 0x0400)
%MONO_FONT       = 8
'#endif /* WINVER >= 0x0400 */

%ANSI_CHARSET        = 0
%DEFAULT_CHARSET     = 1
%SYMBOL_CHARSET      = 2
%SHIFTJIS_CHARSET    = 128
%HANGEUL_CHARSET     = 129
%HANGUL_CHARSET      = 129
%GB2312_CHARSET      = 134
%CHINESEBIG5_CHARSET = 136
%OEM_CHARSET         = 255
'#if(WINVER >= 0x0400)
%JOHAB_CHARSET       = 130
%HEBREW_CHARSET      = 177
%ARABIC_CHARSET      = 178
%GREEK_CHARSET       = 161
%TURKISH_CHARSET     = 162
%VIETNAMESE_CHARSET  = 163
%THAI_CHARSET        = 222
%EASTEUROPE_CHARSET  = 238
%RUSSIAN_CHARSET     = 204

%MAC_CHARSET         = 77
%BALTIC_CHARSET      = 186

%FS_LATIN1      = &H00000001???
%FS_LATIN2      = &H00000002???
%FS_CYRILLIC    = &H00000004???
%FS_GREEK       = &H00000008???
%FS_TURKISH     = &H00000010???
%FS_HEBREW      = &H00000020???
%FS_ARABIC      = &H00000040???
%FS_BALTIC      = &H00000080???
%FS_VIETNAMESE  = &H00000100???
%FS_THAI        = &H00010000???
%FS_JISJAPAN    = &H00020000???
%FS_CHINESESIMP = &H00040000???
%FS_WANSUNG     = &H00080000???
%FS_CHINESETRAD = &H00100000???
%FS_JOHAB       = &H00200000???
%FS_SYMBOL      = &H80000000???
'#endif /* WINVER >= 0x0400 */

'/* Font Families */
'#define FF_DONTCARE         (0<<4)  /* Don't care or don't know. */
'#define FF_ROMAN            (1<<4)  /* Variable stroke width, serifed. */
'                                    /* Times Roman, Century Schoolbook, etc. */
'#define FF_SWISS            (2<<4)  /* Variable stroke width, sans-serifed. */
'                                    /* Helvetica, Swiss, etc. */
'#define FF_MODERN           (3<<4)  /* Constant stroke width, serifed or sans-serifed. */
'                                    /* Pica, Elite, Courier, etc. */
'#define FF_SCRIPT           (4<<4)  /* Cursive, etc. */
'#define FF_DECORATIVE       (5<<4)  /* Old English, etc. */

%FF_DONTCARE   = 0    ' Don't care or don't know.
%FF_ROMAN      = 16   ' Variable stroke width, serifed.
%FF_SWISS      = 32   ' Variable stroke width, sans-serifed.
%FF_MODERN     = 48   ' Constant stroke width, serifed or sans-serifed.
%FF_SCRIPT     = 64   ' Cursive, etc.
%FF_DECORATIVE = 80   ' Old English, etc.

'/* Font Weights */
%FW_DONTCARE   = 0
%FW_THIN       = 100
%FW_EXTRALIGHT = 200
%FW_LIGHT      = 300
%FW_NORMAL     = 400
%FW_MEDIUM     = 500
%FW_SEMIBOLD   = 600
%FW_BOLD       = 700
%FW_EXTRABOLD  = 800
%FW_HEAVY      = 900

%FW_ULTRALIGHT = %FW_EXTRALIGHT
%FW_REGULAR    = %FW_NORMAL
%FW_DEMIBOLD   = %FW_SEMIBOLD
%FW_ULTRABOLD  = %FW_EXTRABOLD
%FW_BLACK      = %FW_HEAVY

%PANOSE_COUNT               = 10
%PAN_FAMILYTYPE_INDEX       = 0
%PAN_SERIFSTYLE_INDEX       = 1
%PAN_WEIGHT_INDEX           = 2
%PAN_PROPORTION_INDEX       = 3
%PAN_CONTRAST_INDEX         = 4
%PAN_STROKEVARIATION_INDEX  = 5
%PAN_ARMSTYLE_INDEX         = 6
%PAN_LETTERFORM_INDEX       = 7
%PAN_MIDLINE_INDEX          = 8
%PAN_XHEIGHT_INDEX          = 9

%PAN_CULTURE_LATIN          = 0

TYPE PANOSE
   ulculture        AS LONG
   bFamilyType      AS BYTE
   bSerifStyle      AS BYTE
   bWeight          AS BYTE
   bProportion      AS BYTE
   bContrast        AS BYTE
   bStrokeVariation AS BYTE
   bArmStyle        AS BYTE
   bLetterform      AS BYTE
   bMidline         AS BYTE
   bXHeight         AS BYTE
END TYPE

%PAN_ANY                     = 0  ' Any
%PAN_NO_FIT                  = 1  ' No Fit

%PAN_FAMILY_TEXT_DISPLAY     = 2  ' Text and Display
%PAN_FAMILY_SCRIPT           = 3  ' Script
%PAN_FAMILY_DECORATIVE       = 4  ' Decorative
%PAN_FAMILY_PICTORIAL        = 5  ' Pictorial

%PAN_SERIF_COVE              = 2  ' Cove
%PAN_SERIF_OBTUSE_COVE       = 3  ' Obtuse Cove
%PAN_SERIF_SQUARE_COVE       = 4  ' Square Cove
%PAN_SERIF_OBTUSE_SQUARE_COVE= 5  ' Obtuse Square Cove
%PAN_SERIF_SQUARE            = 6  ' Square
%PAN_SERIF_THIN              = 7  ' Thin
%PAN_SERIF_BONE              = 8  ' Bone
%PAN_SERIF_EXAGGERATED       = 9  ' Exaggerated
%PAN_SERIF_TRIANGLE          = 10 ' Triangle
%PAN_SERIF_NORMAL_SANS       = 11 ' Normal Sans
%PAN_SERIF_OBTUSE_SANS       = 12 ' Obtuse Sans
%PAN_SERIF_PERP_SANS         = 13 ' Prep Sans
%PAN_SERIF_FLARED            = 14 ' Flared
%PAN_SERIF_ROUNDED           = 15 ' Rounded

%PAN_WEIGHT_VERY_LIGHT       = 2  ' Very Light
%PAN_WEIGHT_LIGHT            = 3  ' Light
%PAN_WEIGHT_THIN             = 4  ' Thin
%PAN_WEIGHT_BOOK             = 5  ' Book
%PAN_WEIGHT_MEDIUM           = 6  ' Medium
%PAN_WEIGHT_DEMI             = 7  ' Demi
%PAN_WEIGHT_BOLD             = 8  ' Bold
%PAN_WEIGHT_HEAVY            = 9  ' Heavy
%PAN_WEIGHT_BLACK            = 10 ' Black
%PAN_WEIGHT_NORD             = 11 ' Nord

%PAN_PROP_OLD_STYLE          = 2  ' Old Style
%PAN_PROP_MODERN             = 3  ' Modern
%PAN_PROP_EVEN_WIDTH         = 4  ' Even Width
%PAN_PROP_EXPANDED           = 5  ' Expanded
%PAN_PROP_CONDENSED          = 6  ' Condensed
%PAN_PROP_VERY_EXPANDED      = 7  ' Very Expanded
%PAN_PROP_VERY_CONDENSED     = 8  ' Very Condensed
%PAN_PROP_MONOSPACED         = 9  ' Monospaced

%PAN_CONTRAST_NONE           = 2  ' None
%PAN_CONTRAST_VERY_LOW       = 3  ' Very Low
%PAN_CONTRAST_LOW            = 4  ' Low
%PAN_CONTRAST_MEDIUM_LOW     = 5  ' Medium Low
%PAN_CONTRAST_MEDIUM         = 6  ' Medium
%PAN_CONTRAST_MEDIUM_HIGH    = 7  ' Mediim High
%PAN_CONTRAST_HIGH           = 8  ' High
%PAN_CONTRAST_VERY_HIGH      = 9  ' Very High

%PAN_STROKE_GRADUAL_DIAG     = 2  ' Gradual/Diagonal
%PAN_STROKE_GRADUAL_TRAN     = 3  ' Gradual/Transitional
%PAN_STROKE_GRADUAL_VERT     = 4  ' Gradual/Vertical
%PAN_STROKE_GRADUAL_HORZ     = 5  ' Gradual/Horizontal
%PAN_STROKE_RAPID_VERT       = 6  ' Rapid/Vertical
%PAN_STROKE_RAPID_HORZ       = 7  ' Rapid/Horizontal
%PAN_STROKE_INSTANT_VERT     = 8  ' Instant/Vertical

%PAN_STRAIGHT_ARMS_HORZ          = 2  ' Straight Arms/Horizontal
%PAN_STRAIGHT_ARMS_WEDGE         = 3  ' Straight Arms/Wedge
%PAN_STRAIGHT_ARMS_VERT          = 4  ' Straight Arms/Vertical
%PAN_STRAIGHT_ARMS_SINGLE_SERIF  = 5  ' Straight Arms/Single-Serif
%PAN_STRAIGHT_ARMS_DOUBLE_SERIF  = 6  ' Straight Arms/Double-Serif
%PAN_BENT_ARMS_HORZ              = 7  ' Non-Straight Arms/Horizontal
%PAN_BENT_ARMS_WEDGE             = 8  ' Non-Straight Arms/Wedge
%PAN_BENT_ARMS_VERT              = 9  ' Non-Straight Arms/Vertical
%PAN_BENT_ARMS_SINGLE_SERIF      = 10 ' Non-Straight Arms/Single-Serif
%PAN_BENT_ARMS_DOUBLE_SERIF      = 11 ' Non-Straight Arms/Double-Serif

%PAN_LETT_NORMAL_CONTACT     = 2  ' Normal/Contact
%PAN_LETT_NORMAL_WEIGHTED    = 3  ' Normal/Weighted
%PAN_LETT_NORMAL_BOXED       = 4  ' Normal/Boxed
%PAN_LETT_NORMAL_FLATTENED   = 5  ' Normal/Flattened
%PAN_LETT_NORMAL_ROUNDED     = 6  ' Normal/Rounded
%PAN_LETT_NORMAL_OFF_CENTER  = 7  ' Normal/Off Center
%PAN_LETT_NORMAL_SQUARE      = 8  ' Normal/Square
%PAN_LETT_OBLIQUE_CONTACT    = 9  ' Oblique/Contact
%PAN_LETT_OBLIQUE_WEIGHTED   = 10 ' Oblique/Weighted
%PAN_LETT_OBLIQUE_BOXED      = 11 ' Oblique/Boxed
%PAN_LETT_OBLIQUE_FLATTENED  = 12 ' Oblique/Flattened
%PAN_LETT_OBLIQUE_ROUNDED    = 13 ' Oblique/Rounded
%PAN_LETT_OBLIQUE_OFF_CENTER = 14 ' Oblique/Off Center
%PAN_LETT_OBLIQUE_SQUARE     = 15 ' Oblique/Square

%PAN_MIDLINE_STANDARD_TRIMMED = 2  ' Standard/Trimmed
%PAN_MIDLINE_STANDARD_POINTED = 3  ' Standard/Pointed
%PAN_MIDLINE_STANDARD_SERIFED = 4  ' Standard/Serifed
%PAN_MIDLINE_HIGH_TRIMMED     = 5  ' High/Trimmed
%PAN_MIDLINE_HIGH_POINTED     = 6  ' High/Pointed
%PAN_MIDLINE_HIGH_SERIFED     = 7  ' High/Serifed
%PAN_MIDLINE_CONSTANT_TRIMMED = 8  ' Constant/Trimmed
%PAN_MIDLINE_CONSTANT_POINTED = 9  ' Constant/Pointed
%PAN_MIDLINE_CONSTANT_SERIFED = 10 ' Constant/Serifed
%PAN_MIDLINE_LOW_TRIMMED      = 11 ' Low/Trimmed
%PAN_MIDLINE_LOW_POINTED      = 12 ' Low/Pointed
%PAN_MIDLINE_LOW_SERIFED      = 13 ' Low/Serifed

%PAN_XHEIGHT_CONSTANT_SMALL  = 2  ' Constant/Small
%PAN_XHEIGHT_CONSTANT_STD    = 3  ' Constant/Standard
%PAN_XHEIGHT_CONSTANT_LARGE  = 4  ' Constant/Large
%PAN_XHEIGHT_DUCKING_SMALL   = 5  ' Ducking/Small
%PAN_XHEIGHT_DUCKING_STD     = 6  ' Ducking/Standard
%PAN_XHEIGHT_DUCKING_LARGE   = 7  ' Ducking/Large

%ELF_VENDOR_SIZE   = 4

'/* The extended logical font       */
'/* An extension of the ENUMLOGFONT */

TYPE EXTLOGFONTA
   elfLogFont   AS LOGFONTA
   elfFullName  AS ASCIIZ * %LF_FULLFACESIZE   ' BYTE
   elfStyle     AS ASCIIZ * %LF_FACESIZE       ' BYTE
   elfVersion   AS DWORD   ' DWORD /* 0 for the first release of NT */
   elfStyleSize AS DWORD   ' DWORD
   elfMatch     AS DWORD   ' DWORD
   elfReserved  AS DWORD   ' DWORD
   elfVendorId  AS ASCIIZ * %ELF_VENDOR_SIZE   ' BYTE
   elfCulture   AS DWORD   ' DWORD /* 0 for Latin                   */
   elfPanose    AS PANOSE
END TYPE

TYPE EXTLOGFONTW
   elfLogFont   AS LOGFONTW
   elfFullName  AS STRING  * %LF_FULLFACESIZE * 2   ' WCHAR
   elfStyle     AS STRING  * %LF_FACESIZE * 2       ' WCHAR
   elfVersion   AS DWORD   ' DWORD /* 0 for the first release of NT */
   elfStyleSize AS DWORD   ' DWORD
   elfMatch     AS DWORD   ' DWORD
   elfReserved  AS DWORD   ' DWORD
   elfVendorId  AS STRING  * %ELF_VENDOR_SIZE       ' WCHAR
   elfCulture   AS DWORD   ' DWORD /* 0 for Latin                   */
   elfPanose    AS PANOSE
END TYPE

MACRO EXTLOGFONT = EXTLOGFONTA

%ELF_VERSION       = 0
%ELF_CULTURE_LATIN = 0

'/* EnumFonts Masks */
%RASTER_FONTTYPE   = &H0001
%DEVICE_FONTTYPE   = &H002
%TRUETYPE_FONTTYPE = &H004

'#define RGB(r,g,b)          ((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))
'#define PALETTERGB(r,g,b)   (0x02000000 | RGB(r,g,b))
'#define PALETTEINDEX(i)     ((COLORREF)(0x01000000 | (DWORD)(WORD)(i)))

'   FUNCTION PALETTERGB (BYVAL bRed AS BYTE, BYVAL bGreen AS BYTE, BYVAL bBlue AS BYTE) AS DWORD
'      FUNCTION = (&H02000000??? OR RGB(bRed, bGreen, bBlue))
'   END FUNCTION

'   FUNCTION PALETTEINDEX (BYVAL ix AS WORD) AS DWORD
'      FUNCTION = (&H01000000??? OR CDWD(ix))
'   END FUNCTION

'/* palette entry flags */

%PC_RESERVED   = &H01  ' palette index used for animation
%PC_EXPLICIT   = &H02  ' palette index is explicit to device
%PC_NOCOLLAPSE = &H04  ' do not match color to system palette

'#define GetRValue(rgb)      (LOBYTE(rgb))
'#define GetGValue(rgb)      (LOBYTE(((WORD)(rgb)) >> 8))
'#define GetBValue(rgb)      (LOBYTE((rgb)>>16))

'   FUNCTION GetRValue (BYVAL drgb AS DWORD) AS BYTE
'      FUNCTION = (drgb AND &H000000FF???)
'   END FUNCTION

'   FUNCTION GetGValue (BYVAL drgb AS DWORD) AS BYTE
'      SHIFT RIGHT drgb, 8
'      FUNCTION = (drgb AND &H000000FF???)
'   END FUNCTION

'   FUNCTION GetBValue (BYVAL drgb AS DWORD) AS BYTE
'      SHIFT RIGHT drgb, 16
'      FUNCTION = (drgb AND &H000000FF???)
'   END FUNCTION


'/* Background Modes */
%TRANSPARENT = 1
%OPAQUE      = 2
%BKMODE_LAST = 2

'/* Graphics Modes */
%GM_COMPATIBLE = 1
%GM_ADVANCED   = 2
%GM_LAST       = 2

'/* PolyDraw and GetPath point types */
%PT_CLOSEFIGURE = &H01
%PT_LINETO      = &H02
%PT_BEZIERTO    = &H04
%PT_MOVETO      = &H06

'/* Mapping Modes */
%MM_TEXT         = 1
%MM_LOMETRIC     = 2
%MM_HIMETRIC     = 3
%MM_LOENGLISH    = 4
%MM_HIENGLISH    = 5
%MM_TWIPS        = 6
%MM_ISOTROPIC    = 7
%MM_ANISOTROPIC  = 8

'/* Min and Max Mapping Mode values */
%MM_MIN            = %MM_TEXT
%MM_MAX            = %MM_ANISOTROPIC
%MM_MAX_FIXEDSCALE = %MM_TWIPS

'/* Coordinate Modes */
%ABSOLUTE = 1
%RELATIVE = 2

'/* Stock Logical Objects */
%WHITE_BRUSH         = 0
%LTGRAY_BRUSH        = 1
%GRAY_BRUSH          = 2
%DKGRAY_BRUSH        = 3
%BLACK_BRUSH         = 4
%NULL_BRUSH          = 5
%HOLLOW_BRUSH        = %NULL_BRUSH
%WHITE_PEN           = 6
%BLACK_PEN           = 7
%NULL_PEN            = 8
%OEM_FIXED_FONT      = 10
%ANSI_FIXED_FONT     = 11
%ANSI_VAR_FONT       = 12
%SYSTEM_FONT         = 13
%DEVICE_DEFAULT_FONT = 14
%DEFAULT_PALETTE     = 15
%SYSTEM_FIXED_FONT   = 16

'#if(WINVER >= 0x0400)
%DEFAULT_GUI_FONT    = 17
'#endif /* WINVER >= 0x0400 */

'#if (_WIN32_WINNT >= 0x0500)
%DC_BRUSH            = 18
%DC_PEN              = 19
'#endif

'#if (_WIN32_WINNT >= 0x0500)
'#define STOCK_LAST          19
%STOCK_LAST          = 19  ' depending on Windows version, may be 16, 17 or 19
'#elif (WINVER >= 0x0400)
'#define STOCK_LAST          17
'#else
'#define STOCK_LAST          16
'#endif

%CLR_INVALID         = &HFFFFFFFF???  ' some Microsoft docs claim this is &HFFFF, but it's not

'/* Brush Styles */
%BS_SOLID            = 0
%BS_NULL             = 1
%BS_HOLLOW           = %BS_NULL
%BS_HATCHED          = 2
%BS_PATTERN          = 3
%BS_INDEXED          = 4
%BS_DIBPATTERN       = 5
%BS_DIBPATTERNPT     = 6
%BS_PATTERN8X8       = 7
%BS_DIBPATTERN8X8    = 8
%BS_MONOPATTERN      = 9

'/* Hatch Styles */
%HS_HORIZONTAL       = 0     ' -----
%HS_VERTICAL         = 1     ' |||||
%HS_FDIAGONAL        = 2     ' \\\\\
%HS_BDIAGONAL        = 3     ' -----
%HS_CROSS            = 4     ' +++++
%HS_DIAGCROSS        = 5     ' xxxxx

'/* Pen Styles */
%PS_SOLID            = 0
%PS_DASH             = 1     ' -------
%PS_DOT              = 2     ' .......
%PS_DASHDOT          = 3     ' _._._._
%PS_DASHDOTDOT       = 4     ' _.._.._
%PS_NULL             = 5
%PS_INSIDEFRAME      = 6
%PS_USERSTYLE        = 7
%PS_ALTERNATE        = 8
%PS_STYLE_MASK       = &H0000000F???

%PS_ENDCAP_ROUND     = &H00000000???
%PS_ENDCAP_SQUARE    = &H00000100???
%PS_ENDCAP_FLAT      = &H00000200???
%PS_ENDCAP_MASK      = &H00000F00???

%PS_JOIN_ROUND       = &H00000000???
%PS_JOIN_BEVEL       = &H00001000???
%PS_JOIN_MITER       = &H00002000???
%PS_JOIN_MASK        = &H0000F000???

%PS_COSMETIC         = &H00000000???
%PS_GEOMETRIC        = &H00010000???
%PS_TYPE_MASK        = &H000F0000???

%AD_COUNTERCLOCKWISE = 1
%AD_CLOCKWISE        = 2

'/* Device Parameters for GetDeviceCaps() */
%DRIVERVERSION  = 0    ' Device driver version
%TECHNOLOGY     = 2    ' Device classification
%HORZSIZE       = 4    ' Horizontal size in millimeters
%VERTSIZE       = 6    ' Vertical size in millimeters
%HORZRES        = 8    ' Horizontal width in pixels
%VERTRES        = 10   ' Vertical width in pixels
%BITSPIXEL      = 12   ' Number of bits per pixel
%PLANES         = 14   ' Number of planes
%NUMBRUSHES     = 16   ' Number of brushes the device has
%NUMPENS        = 18   ' Number of pens the device has
%NUMMARKERS     = 20   ' Number of markers the device has
%NUMFONTS       = 22   ' Number of fonts the device has
%NUMCOLORS      = 24   ' Number of colors the device supports
%PDEVICESIZE    = 26   ' Size required for device descriptor
%CURVECAPS      = 28   ' Curve capabilities
%LINECAPS       = 30   ' Line capabilities
%POLYGONALCAPS  = 32   ' Polygonal capabilities
%TEXTCAPS       = 34   ' Text capabilities
%CLIPCAPS       = 36   ' Clipping capabilities
%RASTERCAPS     = 38   ' Bitblt capabilities
%ASPECTX        = 40   ' Length of the X leg
%ASPECTY        = 42   ' Length of the Y leg
%ASPECTXY       = 44   ' Length of the hypotenuse

%LOGPIXELSX     = 88   ' Logical pixels/inch in X
%LOGPIXELSY     = 90   ' Logical pixels/inch in Y

%SIZEPALETTE    = 104  ' Number of entries in physical palette
%NUMRESERVED    = 106  ' Number of reserved entries in palette
%COLORRES       = 108  ' Actual color resolution

'// Printing related DeviceCaps. These replace the appropriate Escapes

%PHYSICALWIDTH   = 110  ' Physical Width in device units
%PHYSICALHEIGHT  = 111  ' Physical Height in device units
%PHYSICALOFFSETX = 112  ' Physical Printable Area x margin
%PHYSICALOFFSETY = 113  ' Physical Printable Area y margin
%SCALINGFACTORX  = 114  ' Scaling factor x
%SCALINGFACTORY  = 115  ' Scaling factor y

'// Display driver specific

%VREFRESH       = 116  ' Current vertical refresh rate of the
                       ' display device (for displays only) in Hz
%DESKTOPVERTRES = 117  ' Horizontal width of entire desktop in pixels
%DESKTOPHORZRES = 118  ' Vertical height of entire desktop in pixels
%BLTALIGNMENT   = 119  ' Preferred blt alignment

'#if(WINVER >= 0x0500)
%SHADEBLENDCAPS = 120   ' Shading and blending caps
%COLORMGMTCAPS  = 121   ' Color Management caps
'#endif /* WINVER >= 0x0500 */

#IF NOT %DEF(%NOGDICAPMASKS) ' ------------------------------------------------
'#ifndef NOGDICAPMASKS

'/* Device Capability Masks: */

'/* Device Technologies */
%DT_PLOTTER    = 0     ' Vector plotter
%DT_RASDISPLAY = 1     ' Raster display
%DT_RASPRINTER = 2     ' Raster printer
%DT_RASCAMERA  = 3     ' Raster camera
%DT_CHARSTREAM = 4     ' Character-stream, PLP
%DT_METAFILE   = 5     ' Metafile, VDM
%DT_DISPFILE   = 6     ' Display-file

'/* Curve Capabilities */
%CC_NONE       = 0     ' Curves not supported
%CC_CIRCLES    = 1     ' Can do circles
%CC_PIE        = 2     ' Can do pie wedges
%CC_CHORD      = 4     ' Can do chord arcs
%CC_ELLIPSES   = 8     ' Can do ellipese
%CC_WIDE       = 16    ' Can do wide lines
%CC_STYLED     = 32    ' Can do styled lines
%CC_WIDESTYLED = 64    ' Can do wide styled lines
%CC_INTERIORS  = 128   ' Can do interiors
%CC_ROUNDRECT  = 256   '

'/* Line Capabilities */
%LC_NONE       = 0     ' Lines not supported
%LC_POLYLINE   = 2     ' Can do polylines
%LC_MARKER     = 4     ' Can do markers
%LC_POLYMARKER = 8     ' Can do polymarkers
%LC_WIDE       = 16    ' Can do wide lines
%LC_STYLED     = 32    ' Can do styled lines
%LC_WIDESTYLED = 64    ' Can do wide styled lines
%LC_INTERIORS  = 128   ' Can do interiors

'/* Polygonal Capabilities */
%PC_NONE         = 0     ' Polygonals not supported
%PC_POLYGON      = 1     ' Can do polygons
%PC_RECTANGLE    = 2     ' Can do rectangles
%PC_WINDPOLYGON  = 4     ' Can do winding polygons
%PC_TRAPEZOID    = 4     ' Can do trapezoids
%PC_SCANLINE     = 8     ' Can do scanlines
%PC_WIDE         = 16    ' Can do wide borders
%PC_STYLED       = 32    ' Can do styled borders
%PC_WIDESTYLED   = 64    ' Can do wide styled borders
%PC_INTERIORS    = 128   ' Can do interiors
%PC_POLYPOLYGON  = 256   ' Can do polypolygons
%PC_PATHS        = 512   ' Can do paths

'/* Clipping Capabilities */
%CP_NONE         = 0     ' No clipping of output
%CP_RECTANGLE    = 1     ' Output clipped to rects
%CP_REGION       = 2     ' obsolete

'/* Text Capabilities */
%TC_OP_CHARACTER = &H00000001  ' Can do OutputPrecision   CHARACTER
%TC_OP_STROKE    = &H00000002  ' Can do OutputPrecision   STROKE
%TC_CP_STROKE    = &H00000004  ' Can do ClipPrecision     STROKE
%TC_CR_90        = &H00000008  ' Can do CharRotAbility    90
%TC_CR_ANY       = &H00000010  ' Can do CharRotAbility    ANY
%TC_SF_X_YINDEP  = &H00000020  ' Can do ScaleFreedom      X_YINDEPENDENT
%TC_SA_DOUBLE    = &H00000040  ' Can do ScaleAbility      DOUBLE
%TC_SA_INTEGER   = &H00000080  ' Can do ScaleAbility      INTEGER
%TC_SA_CONTIN    = &H00000100  ' Can do ScaleAbility      CONTINUOUS
%TC_EA_DOUBLE    = &H00000200  ' Can do EmboldenAbility   DOUBLE
%TC_IA_ABLE      = &H00000400  ' Can do ItalisizeAbility  ABLE
%TC_UA_ABLE      = &H00000800  ' Can do UnderlineAbility  ABLE
%TC_SO_ABLE      = &H00001000  ' Can do StrikeOutAbility  ABLE
%TC_RA_ABLE      = &H00002000  ' Can do RasterFontAble    ABLE
%TC_VA_ABLE      = &H00004000  ' Can do VectorFontAble    ABLE
%TC_RESERVED     = &H00008000
%TC_SCROLLBLT    = &H00010000  ' Don't do text scroll with blt

'#endif /* NOGDICAPMASKS */
#ENDIF   ' #IF NOT %DEF(%NOGDICAPMASKS) ---------------------------------------

'/* Raster Capabilities */
%RC_NONE         = 0
%RC_BITBLT       = 1       ' Can do standard BLT.
%RC_BANDING      = 2       ' Device requires banding support
%RC_SCALING      = 4       ' Device requires scaling support
%RC_BITMAP64     = 8       ' Device can support >64K bitmap
%RC_GDI20_OUTPUT = &H00000010  ' has 2.0 output calls
%RC_GDI20_STATE  = &H00000020
%RC_SAVEBITMAP   = &H00000040
%RC_DI_BITMAP    = &H00000080  ' supports DIB to memory
%RC_PALETTE      = &H00000100  ' supports a palette
%RC_DIBTODEV     = &H00000200  ' supports DIBitsToDevice
%RC_BIGFONT      = &H00000400  ' supports >64K fonts
%RC_STRETCHBLT   = &H00000800  ' supports StretchBlt
%RC_FLOODFILL    = &H00001000  ' supports FloodFill
%RC_STRETCHDIB   = &H00002000  ' supports StretchDIBits
%RC_OP_DX_OUTPUT = &H00004000
%RC_DEVBITS      = &H00008000

'#if(WINVER >= 0x0500)

'/* Shading and blending caps */
%SB_NONE          = &H00000000
%SB_CONST_ALPHA   = &H00000001
%SB_PIXEL_ALPHA   = &H00000002
%SB_PREMULT_ALPHA = &H00000004

%SB_GRAD_RECT     = &H00000010
%SB_GRAD_TRI      = &H00000020

'/* Color Management caps */
%CM_NONE          = &H00000000
%CM_DEVICE_ICM    = &H00000001
%CM_GAMMA_RAMP    = &H00000002
%CM_CMYK_COLOR    = &H00000004

'#endif /* WINVER >= 0x0500 */


'/* DIB color table identifiers */

%DIB_RGB_COLORS      = 0 ' color table in RGBs
%DIB_PAL_COLORS      = 1 ' color table in palette indices

'/* constants for Get/SetSystemPaletteUse() */

%SYSPAL_ERROR       = 0
%SYSPAL_STATIC      = 1
%SYSPAL_NOSTATIC    = 2
%SYSPAL_NOSTATIC256 = 3

'/* constants for CreateDIBitmap */
%CBM_INIT           = 4     ' initialize bitmap

'/* ExtFloodFill style flags */
%FLOODFILLBORDER    = 0
%FLOODFILLSURFACE   = 1

'/* size of a device name string */
'#define CCHDEVICENAME 32
%CCHDEVICENAME = 32

'/* size of a form name string */
'#define CCHFORMNAME 32
%CCHFORMNAME = 32

'typedef struct _devicemodeA {
'    BYTE   dmDeviceName[CCHDEVICENAME];
'    WORD dmSpecVersion;
'    WORD dmDriverVersion;
'    WORD dmSize;
'    WORD dmDriverExtra;
'    DWORD dmFields;
'    union {
'      /* printer only fields */
'      struct {
'        short dmOrientation;
'        short dmPaperSize;
'        short dmPaperLength;
'        short dmPaperWidth;
'        short dmScale;
'        short dmCopies;
'        short dmDefaultSource;
'        short dmPrintQuality;
'      };
'      /* display only fields */
'      struct {
'        POINTL dmPosition;
'        DWORD  dmDisplayOrientation;
'        DWORD  dmDisplayFixedOutput;
'      };
'    };
'    short dmColor;
'    short dmDuplex;
'    short dmYResolution;
'    short dmTTOption;
'    short dmCollate;
'    BYTE   dmFormName[CCHFORMNAME];
'    WORD   dmLogPixels;
'    DWORD  dmBitsPerPel;
'    DWORD  dmPelsWidth;
'    DWORD  dmPelsHeight;
'    union {
'        DWORD  dmDisplayFlags;
'        DWORD  dmNup;
'    };
'    DWORD  dmDisplayFrequency;
'#if(WINVER >= 0x0400)
'    DWORD  dmICMMethod;
'    DWORD  dmICMIntent;
'    DWORD  dmMediaType;
'    DWORD  dmDitherType;
'    DWORD  dmReserved1;
'    DWORD  dmReserved2;
'#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
'    DWORD  dmPanningWidth;
'    DWORD  dmPanningHeight;
'#endif
'#endif /* WINVER >= 0x0400 */
'} DEVMODEA, *PDEVMODEA, *NPDEVMODEA, *LPDEVMODEA;

TYPE DEVMODEA
   dmDeviceName       AS ASCIIZ * %CCHDEVICENAME
   dmSpecVersion      AS WORD
   dmDriverVersion    AS WORD
   dmSize             AS WORD
   dmDriverExtra      AS WORD
   dmFields           AS DWORD
   dmOrientation      AS INTEGER
   dmPaperSize        AS INTEGER
   dmPaperLength      AS INTEGER
   dmPaperWidth       AS INTEGER
   dmScale            AS INTEGER
   dmCopies           AS INTEGER
   dmDefaultSource    AS INTEGER
   dmPrintQuality     AS INTEGER
   dmColor            AS INTEGER
   dmDuplex           AS INTEGER
   dmYResolution      AS INTEGER
   dmTTOption         AS INTEGER
   dmCollate          AS INTEGER
   dmFormName         AS ASCIIZ * %CCHFORMNAME
   dmLogPixels        AS WORD
   dmBitsPerPel       AS DWORD
   dmPelsWidth        AS DWORD
   dmPelsHeight       AS DWORD
   dmDisplayFlags     AS DWORD
   dmDisplayFrequency AS DWORD
   dmICMMethod        AS DWORD
   dmICMIntent        AS DWORD
   dmMediaType        AS DWORD
   dmDitherType       AS DWORD
   dmICCManufacturer  AS DWORD
   dmICCModel         AS DWORD
   dmPanningWidth     AS DWORD
   dmPanningHeight    AS DWORD
END TYPE

'typedef struct _devicemodeW {
'    WCHAR  dmDeviceName[CCHDEVICENAME];
'    WORD dmSpecVersion;
'    WORD dmDriverVersion;
'    WORD dmSize;
'    WORD dmDriverExtra;
'    DWORD dmFields;
'    union {
'      /* printer only fields */
'      struct {
'        short dmOrientation;
'        short dmPaperSize;
'        short dmPaperLength;
'        short dmPaperWidth;
'        short dmScale;
'        short dmCopies;
'        short dmDefaultSource;
'        short dmPrintQuality;
'      };
'      /* display only fields */
'      struct {
'        POINTL dmPosition;
'        DWORD  dmDisplayOrientation;
'        DWORD  dmDisplayFixedOutput;
'      };
'    };
'    short dmColor;
'    short dmDuplex;
'    short dmYResolution;
'    short dmTTOption;
'    short dmCollate;
'    WCHAR  dmFormName[CCHFORMNAME];
'    WORD   dmLogPixels;
'    DWORD  dmBitsPerPel;
'    DWORD  dmPelsWidth;
'    DWORD  dmPelsHeight;
'    union {
'        DWORD  dmDisplayFlags;
'        DWORD  dmNup;
'    };
'    DWORD  dmDisplayFrequency;
'#if(WINVER >= 0x0400)
'    DWORD  dmICMMethod;
'    DWORD  dmICMIntent;
'    DWORD  dmMediaType;
'    DWORD  dmDitherType;
'    DWORD  dmReserved1;
'    DWORD  dmReserved2;
'#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
'    DWORD  dmPanningWidth;
'    DWORD  dmPanningHeight;
'#endif

TYPE DEVMODEW
   dmDeviceName       AS STRING * %CCHDEVICENAME * 2
   dmSpecVersion      AS WORD
   dmDriverVersion    AS WORD
   dmSize             AS WORD
   dmDriverExtra      AS WORD
   dmFields           AS DWORD
   dmOrientation      AS INTEGER
   dmPaperSize        AS INTEGER
   dmPaperLength      AS INTEGER
   dmPaperWidth       AS INTEGER
   dmScale            AS INTEGER
   dmCopies           AS INTEGER
   dmDefaultSource    AS INTEGER
   dmPrintQuality     AS INTEGER
   dmColor            AS INTEGER
   dmDuplex           AS INTEGER
   dmYResolution      AS INTEGER
   dmTTOption         AS INTEGER
   dmCollate          AS INTEGER
   dmFormName         AS STRING * %CCHFORMNAME * 2
   dmLogPixels        AS WORD
   dmBitsPerPel       AS DWORD
   dmPelsWidth        AS DWORD
   dmPelsHeight       AS DWORD
   dmDisplayFlags     AS DWORD
   dmDisplayFrequency AS DWORD
   dmICMMethod        AS DWORD
   dmICMIntent        AS DWORD
   dmMediaType        AS DWORD
   dmDitherType       AS DWORD
   dmICCManufacturer  AS DWORD
   dmICCModel         AS DWORD
   dmPanningWidth     AS DWORD
   dmPanningHeight    AS DWORD
END TYPE

MACRO DEVMODE = DEVMODEA

'#endif /* WINVER >= 0x0400 */

'/* current version of specification */
'#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
'#define DM_SPECVERSION 0x0401
%DM_SPECVERSION = &H0401
'#elif (WINVER >= 0x0400)
'#define DM_SPECVERSION 0x0400
'#else
'#define DM_SPECVERSION 0x0320
'#endif /* WINVER */

'/* field selection bits */
%DM_ORIENTATION        = &H00000001???
%DM_PAPERSIZE          = &H00000002???
%DM_PAPERLENGTH        = &H00000004???
%DM_PAPERWIDTH         = &H00000008???
%DM_SCALE              = &H00000010???
'#if(WINVER >= 0x0500)
%DM_POSITION           = &H00000020???
%DM_NUP                = &H00000040???
'#endif /* WINVER >= 0x0500 */
'#if(WINVER >= 0x0501)
%DM_DISPLAYORIENTATION = &H00000080???
'#endif /* WINVER >= 0x0501 */
%DM_COPIES             = &H00000100???
%DM_DEFAULTSOURCE      = &H00000200???
%DM_PRINTQUALITY       = &H00000400???
%DM_COLOR              = &H00000800???
%DM_DUPLEX             = &H00001000???
%DM_YRESOLUTION        = &H00002000???
%DM_TTOPTION           = &H00004000???
%DM_COLLATE            = &H00008000???
%DM_FORMNAME           = &H00010000???
%DM_LOGPIXELS          = &H00020000???
%DM_BITSPERPEL         = &H00040000???
%DM_PELSWIDTH          = &H00080000???
%DM_PELSHEIGHT         = &H00100000???
%DM_DISPLAYFLAGS       = &H00200000???
%DM_DISPLAYFREQUENCY   = &H00400000???
'#if(WINVER >= 0x0400)
%DM_ICMMETHOD          = &H00800000???  ' *** MSDN claims a different value here!
%DM_ICMINTENT          = &H01000000???  ' *** MSDN claims a different value here!
%DM_MEDIATYPE          = &H02000000???  ' *** MSDN claims a different value here!
%DM_DITHERTYPE         = &H04000000???  ' *** MSDN claims a different value here!
%DM_PANNINGWIDTH       = &H08000000???
%DM_PANNINGHEIGHT      = &H10000000???
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0501)
%DM_DISPLAYFIXEDOUTPUT = &H20000000???
'#endif /* WINVER >= 0x0501 */

'/* orientation selections */
%DMORIENT_PORTRAIT  = 1
%DMORIENT_LANDSCAPE = 2

'/* paper selections */
%DMPAPER_LETTER              = 1
%DMPAPER_FIRST               = %DMPAPER_LETTER  ' Letter 8 1/2 x 11 in
%DMPAPER_LETTERSMALL         = 2    ' Letter Small 8 1/2 x 11 in
%DMPAPER_TABLOID             = 3    ' Tabloid 11 x 17 in
%DMPAPER_LEDGER              = 4    ' Ledger 17 x 11 in
%DMPAPER_LEGAL               = 5    ' Legal 8 1/2 x 14 in
%DMPAPER_STATEMENT           = 6    ' Statement 5 1/2 x 8 1/2 in
%DMPAPER_EXECUTIVE           = 7    ' Executive 7 1/4 x 10 1/2 in
%DMPAPER_A3                  = 8    ' A3 297 x 420 mm
%DMPAPER_A4                  = 9    ' A4 210 x 297 mm
%DMPAPER_A4SMALL             = 10   ' A4 Small 210 x 297 mm
%DMPAPER_A5                  = 11   ' A5 148 x 210 mm
%DMPAPER_B4                  = 12   ' B4 250 x 354
%DMPAPER_B5                  = 13   ' B5 182 x 257 mm
%DMPAPER_FOLIO               = 14   ' Folio 8 1/2 x 13 in
%DMPAPER_QUARTO              = 15   ' Quarto 215 x 275 mm
%DMPAPER_10X14               = 16   ' 1&H14 in
%DMPAPER_11X17               = 17   ' 11x17 in
%DMPAPER_NOTE                = 18   ' Note 8 1/2 x 11 in
%DMPAPER_ENV_9               = 19   ' Envelope #9 3 7/8 x 8 7/8
%DMPAPER_ENV_10              = 20   ' Envelope #10 4 1/8 x 9 1/2
%DMPAPER_ENV_11              = 21   ' Envelope #11 4 1/2 x 10 3/8
%DMPAPER_ENV_12              = 22   ' Envelope #12 4 \276 x 11
%DMPAPER_ENV_14              = 23   ' Envelope #14 5 x 11 1/2
%DMPAPER_CSHEET              = 24   ' C size sheet
%DMPAPER_DSHEET              = 25   ' D size sheet
%DMPAPER_ESHEET              = 26   ' E size sheet
%DMPAPER_ENV_DL              = 27   ' Envelope DL 110 x 220mm
%DMPAPER_ENV_C5              = 28   ' Envelope C5 162 x 229 mm
%DMPAPER_ENV_C3              = 29   ' Envelope C3  324 x 458 mm
%DMPAPER_ENV_C4              = 30   ' Envelope C4  229 x 324 mm
%DMPAPER_ENV_C6              = 31   ' Envelope C6  114 x 162 mm
%DMPAPER_ENV_C65             = 32   ' Envelope C65 114 x 229 mm
%DMPAPER_ENV_B4              = 33   ' Envelope B4  250 x 353 mm
%DMPAPER_ENV_B5              = 34   ' Envelope B5  176 x 250 mm
%DMPAPER_ENV_B6              = 35   ' Envelope B6  176 x 125 mm
%DMPAPER_ENV_ITALY           = 36   ' Envelope 110 x 230 mm
%DMPAPER_ENV_MONARCH         = 37   ' Envelope Monarch 3.875 x 7.5 in
%DMPAPER_ENV_PERSONAL        = 38   ' 6 3/4 Envelope 3 5/8 x 6 1/2 in
%DMPAPER_FANFOLD_US          = 39   ' US Std Fanfold 14 7/8 x 11 in
%DMPAPER_FANFOLD_STD_GERMAN  = 40   ' German Std Fanfold 8 1/2 x 12 in
%DMPAPER_FANFOLD_LGL_GERMAN  = 41   ' German Legal Fanfold 8 1/2 x 13 in
'#if(WINVER >= 0x0400)
%DMPAPER_ISO_B4              = 42   ' B4 (ISO) 250 x 353 mm
%DMPAPER_JAPANESE_POSTCARD   = 43   ' Japanese Postcard 100 x 148 mm
%DMPAPER_9X11                = 44   ' 9 x 11 in
%DMPAPER_10X11               = 45   ' 10 x 11 in
%DMPAPER_15X11               = 46   ' 15 x 11 in
%DMPAPER_ENV_INVITE          = 47   ' Envelope Invite 220 x 220 mm
%DMPAPER_RESERVED_48         = 48   ' RESERVED--DO NOT USE
%DMPAPER_RESERVED_49         = 49   ' RESERVED--DO NOT USE
%DMPAPER_LETTER_EXTRA        = 50   ' Letter Extra 9 \275 x 12 in
%DMPAPER_LEGAL_EXTRA         = 51   ' Legal Extra 9 \275 x 15 in
%DMPAPER_TABLOID_EXTRA       = 52   ' Tabloid Extra 11.69 x 18 in
%DMPAPER_A4_EXTRA            = 53   ' A4 Extra 9.27 x 12.69 in
%DMPAPER_LETTER_TRANSVERSE   = 54   ' Letter Transverse 8 \275 x 11 in
%DMPAPER_A4_TRANSVERSE       = 55   ' A4 Transverse 210 x 297 mm
%DMPAPER_LETTER_EXTRA_TRANSVERSE = 56 ' Letter Extra Transverse 9\275 x 12 in
%DMPAPER_A_PLUS              = 57   ' SuperA/SuperA/A4 227 x 356 mm
%DMPAPER_B_PLUS              = 58   ' SuperB/SuperB/A3 305 x 487 mm
%DMPAPER_LETTER_PLUS         = 59   ' Letter Plus 8.5 x 12.69 in
%DMPAPER_A4_PLUS             = 60   ' A4 Plus 210 x 330 mm
%DMPAPER_A5_TRANSVERSE       = 61   ' A5 Transverse 148 x 210 mm
%DMPAPER_B5_TRANSVERSE       = 62   ' B5 (JIS) Transverse 182 x 257 mm
%DMPAPER_A3_EXTRA            = 63   ' A3 Extra 322 x 445 mm
%DMPAPER_A5_EXTRA            = 64   ' A5 Extra 174 x 235 mm
%DMPAPER_B5_EXTRA            = 65   ' B5 (ISO) Extra 201 x 276 mm
%DMPAPER_A2                  = 66   ' A2 420 x 594 mm
%DMPAPER_A3_TRANSVERSE       = 67   ' A3 Transverse 297 x 420 mm
%DMPAPER_A3_EXTRA_TRANSVERSE = 68   ' A3 Extra Transverse 322 x 445 mm
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
%DMPAPER_DBL_JAPANESE_POSTCARD = 69 ' Japanese Double Postcard 200 x 148 mm
%DMPAPER_A6                  = 70  ' A6 105 x 148 mm
%DMPAPER_JENV_KAKU2          = 71  ' Japanese Envelope Kaku #2
%DMPAPER_JENV_KAKU3          = 72  ' Japanese Envelope Kaku #3
%DMPAPER_JENV_CHOU3          = 73  ' Japanese Envelope Chou #3
%DMPAPER_JENV_CHOU4          = 74  ' Japanese Envelope Chou #4
%DMPAPER_LETTER_ROTATED      = 75  ' Letter Rotated 11 x 8 1/2 11 in
%DMPAPER_A3_ROTATED          = 76  ' A3 Rotated 420 x 297 mm
%DMPAPER_A4_ROTATED          = 77  ' A4 Rotated 297 x 210 mm
%DMPAPER_A5_ROTATED          = 78  ' A5 Rotated 210 x 148 mm
%DMPAPER_B4_JIS_ROTATED      = 79  ' B4 (JIS) Rotated 364 x 257 mm
%DMPAPER_B5_JIS_ROTATED      = 80  ' B5 (JIS) Rotated 257 x 182 mm
%DMPAPER_JAPANESE_POSTCARD_ROTATED = 81 ' Japanese Postcard Rotated 148 x 100 mm
%DMPAPER_DBL_JAPANESE_POSTCARD_ROTATED = 82 ' Double Japanese Postcard Rotated 148 x 200 mm
%DMPAPER_A6_ROTATED          = 83  ' A6 Rotated 148 x 105 mm
%DMPAPER_JENV_KAKU2_ROTATED  = 84  ' Japanese Envelope Kaku #2 Rotated
%DMPAPER_JENV_KAKU3_ROTATED  = 85  ' Japanese Envelope Kaku #3 Rotated
%DMPAPER_JENV_CHOU3_ROTATED  = 86  ' Japanese Envelope Chou #3 Rotated
%DMPAPER_JENV_CHOU4_ROTATED  = 87  ' Japanese Envelope Chou #4 Rotated
%DMPAPER_B6_JIS              = 88  ' B6 (JIS) 128 x 182 mm
%DMPAPER_B6_JIS_ROTATED      = 89  ' B6 (JIS) Rotated 182 x 128 mm
%DMPAPER_12X11               = 90  ' 12 x 11 in
%DMPAPER_JENV_YOU4           = 91  ' Japanese Envelope You #4
%DMPAPER_JENV_YOU4_ROTATED   = 92  ' Japanese Envelope You #4 Rotated
%DMPAPER_P16K                = 93  ' PRC 16K 146 x 215 mm
%DMPAPER_P32K                = 94  ' PRC 32K 97 x 151 mm
%DMPAPER_P32KBIG             = 95  ' PRC 32K(Big) 97 x 151 mm
%DMPAPER_PENV_1              = 96  ' PRC Envelope #1 102 x 165 mm
%DMPAPER_PENV_2              = 97  ' PRC Envelope #2 102 x 176 mm
%DMPAPER_PENV_3              = 98  ' PRC Envelope #3 125 x 176 mm
%DMPAPER_PENV_4              = 99  ' PRC Envelope #4 110 x 208 mm
%DMPAPER_PENV_5              = 100 ' PRC Envelope #5 110 x 220 mm
%DMPAPER_PENV_6              = 101 ' PRC Envelope #6 120 x 230 mm
%DMPAPER_PENV_7              = 102 ' PRC Envelope #7 160 x 230 mm
%DMPAPER_PENV_8              = 103 ' PRC Envelope #8 120 x 309 mm
%DMPAPER_PENV_9              = 104 ' PRC Envelope #9 229 x 324 mm
%DMPAPER_PENV_10             = 105 ' PRC Envelope #10 324 x 458 mm
%DMPAPER_P16K_ROTATED        = 106 ' PRC 16K Rotated
%DMPAPER_P32K_ROTATED        = 107 ' PRC 32K Rotated
%DMPAPER_P32KBIG_ROTATED     = 108 ' PRC 32K(Big) Rotated
%DMPAPER_PENV_1_ROTATED      = 109 ' PRC Envelope #1 Rotated 165 x 102 mm
%DMPAPER_PENV_2_ROTATED      = 110 ' PRC Envelope #2 Rotated 176 x 102 mm
%DMPAPER_PENV_3_ROTATED      = 111 ' PRC Envelope #3 Rotated 176 x 125 mm
%DMPAPER_PENV_4_ROTATED      = 112 ' PRC Envelope #4 Rotated 208 x 110 mm
%DMPAPER_PENV_5_ROTATED      = 113 ' PRC Envelope #5 Rotated 220 x 110 mm
%DMPAPER_PENV_6_ROTATED      = 114 ' PRC Envelope #6 Rotated 230 x 120 mm
%DMPAPER_PENV_7_ROTATED      = 115 ' PRC Envelope #7 Rotated 230 x 160 mm
%DMPAPER_PENV_8_ROTATED      = 116 ' PRC Envelope #8 Rotated 309 x 120 mm
%DMPAPER_PENV_9_ROTATED      = 117 ' PRC Envelope #9 Rotated 324 x 229 mm
%DMPAPER_PENV_10_ROTATED     = 118 ' PRC Envelope #10 Rotated 458 x 324 mm
'#endif /* WINVER >= 0x0500 */

'#if (WINVER >= 0x0500)
'#define DMPAPER_LAST                DMPAPER_PENV_10_ROTATED
%DMPAPER_LAST = %DMPAPER_PENV_10_ROTATED
'#elif (WINVER >= 0x0400)
'#define DMPAPER_LAST                DMPAPER_A3_EXTRA_TRANSVERSE
'#else
'#define DMPAPER_LAST                DMPAPER_FANFOLD_LGL_GERMAN
'#endif

%DMPAPER_USER                = 256

'/* bin selections */
%DMBIN_UPPER         = 1
%DMBIN_FIRST         = %DMBIN_UPPER
%DMBIN_ONLYONE       = 1
%DMBIN_LOWER         = 2
%DMBIN_MIDDLE        = 3
%DMBIN_MANUAL        = 4
%DMBIN_ENVELOPE      = 5
%DMBIN_ENVMANUAL     = 6
%DMBIN_AUTO          = 7
%DMBIN_TRACTOR       = 8
%DMBIN_SMALLFMT      = 9
%DMBIN_LARGEFMT      = 10
%DMBIN_LARGECAPACITY = 11
%DMBIN_CASSETTE      = 14
%DMBIN_FORMSOURCE    = 15
%DMBIN_LAST          = %DMBIN_FORMSOURCE

%DMBIN_USER          = 256  ' device specific bins start here

'/* print qualities */
%DMRES_DRAFT  = -1
%DMRES_LOW    = -2
%DMRES_MEDIUM = -3
%DMRES_HIGH   = -4

'/* color enable/disable for color printers */
%DMCOLOR_MONOCHROME = 1
%DMCOLOR_COLOR      = 2

'/* duplex enable */
%DMDUP_SIMPLEX    = 1
%DMDUP_VERTICAL   = 2
%DMDUP_HORIZONTAL = 3

%DMTT_BITMAP           = 1  ' print TT fonts as graphics
%DMTT_DOWNLOAD         = 2  ' download TT fonts as soft fonts
%DMTT_SUBDEV           = 3  ' substitute device fonts for TT fonts
'#if(WINVER >= 0x0400)
%DMTT_DOWNLOAD_OUTLINE = 4  ' download TT fonts as outline soft fonts
'#endif /* WINVER >= 0x0400 */

'/* Collation selections */
%DMCOLLATE_FALSE = 0
%DMCOLLATE_TRUE  = 1

'#if(WINVER >= 0x0501)
'/* DEVMODE dmDisplayOrientation specifiations */
%DMDO_DEFAULT   = 0
%DMDO_90        = 1
%DMDO_180       = 2
%DMDO_270       = 3

'/* DEVMODE dmDisplayFixedOutput specifiations */
%DMDFO_DEFAULT  = 0
%DMDFO_STRETCH  = 1
%DMDFO_CENTER   = 2
'#endif /* WINVER >= 0x0501 */

'/* DEVMODE dmDisplayFlags flags */

'// #define DM_GRAYSCALE            0x00000001 /* This flag is no longer valid */
'// #define DM_INTERLACED           0x00000002 /* This flag is no longer valid */
'%DM_GRAYSCALE            = &H00000001   ' /* This flag is no longer valid */
%DM_INTERLACED           = &H00000002
%DMDISPLAYFLAGS_TEXTMODE = 4

'/* dmNup , multiple logical page per physical page options */
%DMNUP_SYSTEM       = 1
%DMNUP_ONEUP        = 2

'#if(WINVER >= 0x0400)
'/* ICM methods */
%DMICMMETHOD_NONE   = 1     ' ICM disabled
%DMICMMETHOD_SYSTEM = 2     ' ICM handled by system
%DMICMMETHOD_DRIVER = 3     ' ICM handled by driver
%DMICMMETHOD_DEVICE = 4     ' ICM handled by device

'#define DMICMMETHOD_USER  256   /* Device-specific methods start here */
%DMICMMETHOD_USER   = 256   ' Device-specific methods start here

'/* ICM Intents */
%DMICM_SATURATE         = 1   ' Maximize color saturation
%DMICM_CONTRAST         = 2   ' Maximize color contrast
%DMICM_COLORIMETRIC     = 3   ' Use specific color metric
%DMICM_ABS_COLORIMETRIC = 4   ' Use specific color metric

%DMICM_USER             = 256 ' Device-specific intents start here

'/* Media types */

%DMMEDIA_STANDARD     = 1   ' Standard paper
%DMMEDIA_GLOSSY       = 2   ' Glossy paper
%DMMEDIA_TRANSPARENCY = 3   ' Transparency

%DMMEDIA_USER         = 256 ' Device-specific media start here

'/* Dither types */
%DMDITHER_NONE           = 1   ' No dithering
%DMDITHER_COARSE         = 2   ' Dither with a coarse brush
%DMDITHER_FINE           = 3   ' Dither with a fine brush
%DMDITHER_LINEART        = 4   ' LineArt dithering
%DMDITHER_ERRORDIFFUSION = 5   ' LineArt dithering
%DMDITHER_RESERVED6      = 6   ' LineArt dithering
%DMDITHER_RESERVED7      = 7   ' LineArt dithering
%DMDITHER_RESERVED8      = 8   ' LineArt dithering
%DMDITHER_RESERVED9      = 9   ' LineArt dithering
%DMDITHER_GRAYSCALE      = 10  ' Device does grayscaling

'#define DMDITHER_USER     256   /* Device-specific dithers start here */
%DMDITHER_USER           = 256 ' Device-specific dithers start here
'#endif /* WINVER >= 0x0400 */

TYPE DISPLAY_DEVICEA
   cb           AS DWORD              ' DWORD  cb
   DeviceName   AS ASCIIZ * 32        ' CHAR   DeviceName[32]
   DeviceString AS ASCIIZ * 128       ' CHAR   DeviceString[128]
   StateFlags   AS DWORD              ' DWORD  StateFlags
   DeviceID     AS ASCIIZ * 128       ' CHAR   DeviceID[128]
   DeviceKey    AS ASCIIZ * 128       ' CHAR   DeviceKey[128]
END TYPE

TYPE DISPLAY_DEVICEW
   cb           AS DWORD              ' DWORD  cb
   DeviceName   AS STRING * 32 * 2    ' WCHAR  DeviceName[32]
   DeviceString AS STRING * 128 * 2   ' WCHAR  DeviceString[128]
   StateFlags   AS DWORD              ' DWORD  StateFlags
   DeviceID     AS STRING * 128 * 2   ' WCHAR  DeviceID[128]
   DeviceKey    AS STRING * 128 * 2   ' WCHAR  DeviceKey[128]
END TYPE

MACRO DISPLAY_DEVICE = DISPLAY_DEVICEA

%DISPLAY_DEVICE_ATTACHED_TO_DESKTOP = &H00000001???
%DISPLAY_DEVICE_MULTI_DRIVER        = &H00000002???
%DISPLAY_DEVICE_PRIMARY_DEVICE      = &H00000004???
%DISPLAY_DEVICE_MIRRORING_DRIVER    = &H00000008???
%DISPLAY_DEVICE_VGA_COMPATIBLE      = &H00000010???
'#if (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)
%DISPLAY_DEVICE_REMOVABLE           = &H00000020???
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)
%DISPLAY_DEVICE_MODESPRUNED         = &H08000000???
'#if (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)
%DISPLAY_DEVICE_REMOTE              = &H04000000???
%DISPLAY_DEVICE_DISCONNECT          = &H02000000???
'#endif
%DISPLAY_DEVICE_TS_COMPATIBLE       = &H00200000???
'#if (_WIN32_WINNT >= _WIN32_WINNT_LONGHORN)
%DISPLAY_DEVICE_UNSAFE_MODES_ON     = &H00080000???
'#endif

'/* Child device state */
'#if (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)
%DISPLAY_DEVICE_ACTIVE              = &H00000001???
%DISPLAY_DEVICE_ATTACHED            = &H00000002???
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)

'/* GetRegionData/ExtCreateRegion */

%RDH_RECTANGLES = 1

TYPE RGNDATAHEADER
   dwSize   AS DWORD
   iType    AS DWORD
   nCount   AS DWORD
   nRgnSize AS DWORD
   rcBound  AS RECT
END TYPE

TYPE RGNDATA
   rdh AS RGNDATAHEADER   ' RGNDATAHEADER   rdh
   Buffer AS STRING * 1   ' char            Buffer[1]
END TYPE

'/* for GetRandomRgn */
%SYSRGN = 4

TYPE ABC
   abcA AS LONG    ' int
   abcB AS DWORD   ' UINT
   abcC AS LONG    ' int
END TYPE

TYPE ABCFLOAT
   abcfA AS SINGLE   ' FLOAT
   abcfB AS SINGLE   ' FLOAT
   abcfC AS SINGLE   ' FLOAT
END TYPE

#IF NOT %DEF(%NOTEXTMETRIC) ' -------------------------------------------------
'#ifndef NOTEXTMETRIC

'#ifdef _MAC
'#include "pshpack4.h"
'#endif
'typedef struct _OUTLINETEXTMETRICA {
'    UINT    otmSize;
'    TEXTMETRICA otmTextMetrics;
'    BYTE    otmFiller;
'    PANOSE  otmPanoseNumber;
'    UINT    otmfsSelection;
'    UINT    otmfsType;
'     int    otmsCharSlopeRise;
'     int    otmsCharSlopeRun;
'     int    otmItalicAngle;
'    UINT    otmEMSquare;
'     int    otmAscent;
'     int    otmDescent;
'    UINT    otmLineGap;
'    UINT    otmsCapEmHeight;
'    UINT    otmsXHeight;
'    RECT    otmrcFontBox;
'     int    otmMacAscent;
'     int    otmMacDescent;
'    UINT    otmMacLineGap;
'    UINT    otmusMinimumPPEM;
'    POINT   otmptSubscriptSize;
'    POINT   otmptSubscriptOffset;
'    POINT   otmptSuperscriptSize;
'    POINT   otmptSuperscriptOffset;
'    UINT    otmsStrikeoutSize;
'     int    otmsStrikeoutPosition;
'     int    otmsUnderscoreSize;
'     int    otmsUnderscorePosition;
'    PSTR    otmpFamilyName;
'    PSTR    otmpFaceName;
'    PSTR    otmpStyleName;
'    PSTR    otmpFullName;
'} OUTLINETEXTMETRICA, *POUTLINETEXTMETRICA, NEAR *NPOUTLINETEXTMETRICA, FAR *LPOUTLINETEXTMETRICA;

TYPE OUTLINETEXTMETRICA
   otmSize                AS DWORD
   otmTextMetrics         AS TEXTMETRICA
   otmFiller              AS BYTE
   otmPanoseNumber        AS PANOSE
   otmfsSelection         AS DWORD
   otmfsType              AS DWORD
   otmsCharSlopeRise      AS LONG
   otmsCharSlopeRun       AS LONG
   otmItalicAngle         AS LONG
   otmEMSquare            AS DWORD
   otmAscent              AS LONG
   otmDescent             AS LONG
   otmLineGap             AS DWORD
   otmsCapEmHeight        AS DWORD
   otmsXHeight            AS DWORD
   otmrcFontBox           AS RECT
   otmMacAscent           AS LONG
   otmMacDescent          AS LONG
   otmMacLineGap          AS DWORD
   otmusMinimumPPEM       AS DWORD
   otmptSubscriptSize     AS POINTAPI
   otmptSubscriptOffset   AS POINTAPI
   otmptSuperscriptSize   AS POINTAPI
   otmptSuperscriptOffset AS POINTAPI
   otmsStrikeoutSize      AS DWORD
   otmsStrikeoutPosition  AS LONG
   otmsUnderscorePosition AS LONG
   otmsUnderscoreSize     AS LONG
   otmpFamilyName         AS ASCIIZ     PTR
   otmpFaceName           AS ASCIIZ     PTR
   otmpStyleName          AS ASCIIZ     PTR
   otmpFullName           AS ASCIIZ     PTR
END TYPE

'typedef struct _OUTLINETEXTMETRICW {
'    UINT    otmSize;
'    TEXTMETRICW otmTextMetrics;
'    BYTE    otmFiller;
'    PANOSE  otmPanoseNumber;
'    UINT    otmfsSelection;
'    UINT    otmfsType;
'     int    otmsCharSlopeRise;
'     int    otmsCharSlopeRun;
'     int    otmItalicAngle;
'    UINT    otmEMSquare;
'     int    otmAscent;
'     int    otmDescent;
'    UINT    otmLineGap;
'    UINT    otmsCapEmHeight;
'    UINT    otmsXHeight;
'    RECT    otmrcFontBox;
'     int    otmMacAscent;
'     int    otmMacDescent;
'    UINT    otmMacLineGap;
'    UINT    otmusMinimumPPEM;
'    POINT   otmptSubscriptSize;
'    POINT   otmptSubscriptOffset;
'    POINT   otmptSuperscriptSize;
'    POINT   otmptSuperscriptOffset;
'    UINT    otmsStrikeoutSize;
'     int    otmsStrikeoutPosition;
'     int    otmsUnderscoreSize;
'     int    otmsUnderscorePosition;
'    PSTR    otmpFamilyName;
'    PSTR    otmpFaceName;
'    PSTR    otmpStyleName;
'    PSTR    otmpFullName;
'} OUTLINETEXTMETRICW, *POUTLINETEXTMETRICW, NEAR *NPOUTLINETEXTMETRICW, FAR *LPOUTLINETEXTMETRICW;

TYPE OUTLINETEXTMETRICW
   otmSize                AS DWORD
   otmTextMetrics         AS TEXTMETRICW
   otmFiller              AS BYTE
   otmPanoseNumber        AS PANOSE
   otmfsSelection         AS DWORD
   otmfsType              AS DWORD
   otmsCharSlopeRise      AS LONG
   otmsCharSlopeRun       AS LONG
   otmItalicAngle         AS LONG
   otmEMSquare            AS DWORD
   otmAscent              AS LONG
   otmDescent             AS LONG
   otmLineGap             AS DWORD
   otmsCapEmHeight        AS DWORD
   otmsXHeight            AS DWORD
   otmrcFontBox           AS RECT
   otmMacAscent           AS LONG
   otmMacDescent          AS LONG
   otmMacLineGap          AS DWORD
   otmusMinimumPPEM       AS DWORD
   otmptSubscriptSize     AS POINTAPI
   otmptSubscriptOffset   AS POINTAPI
   otmptSuperscriptSize   AS POINTAPI
   otmptSuperscriptOffset AS POINTAPI
   otmsStrikeoutSize      AS DWORD
   otmsStrikeoutPosition  AS LONG
   otmsUnderscorePosition AS LONG
   otmsUnderscoreSize     AS LONG
   otmpFamilyName         AS WORD PTR
   otmpFaceName           AS WORD PTR
   otmpStyleName          AS WORD PTR
   otmpFullName           AS WORD PTR
END TYPE

MACRO OUTLINETEXTMETRIC = OUTLINETEXTMETRICA

'#endif /* NOTEXTMETRIC */
#ENDIF   ' #IF NOT %DEF(%NOTEXTMETRIC) ----------------------------------------

TYPE POLYTEXTA
   x       AS LONG         ' int
   y       AS LONG         ' int
   n       AS DWORD        ' UINT
   lpStr   AS ASCIIZ PTR   ' LPCSTR
   uiFlags AS DWORD        ' UINT
   rcl     AS RECT         ' RECT
   pdx     AS LONG PTR     ' INT*
END TYPE

TYPE POLYTEXTW
   x       AS LONG       ' int
   y       AS LONG       ' int
   n       AS DWORD      ' UINT
   lpStr   AS WORD PTR   ' LPCWSTR
   uiFlags AS DWORD      ' UINT
   rcl     AS RECT       ' RECT
   pdx     AS LONG PTR   ' int*
END TYPE

MACRO POLYTEXT = POLYTEXTA

TYPE FIXED
   fract AS WORD      ' WORD
   value AS INTEGER   ' short
END TYPE

TYPE MAT2
  eM11 AS FIXED
  eM12 AS FIXED
  eM21 AS FIXED
  eM22 AS FIXED
END TYPE

TYPE GLYPHMETRICS
  gmBlackBoxX     AS DWORD      ' UINT
  gmBlackBoxY     AS DWORD      ' UINT
  gmptGlyphOrigin AS POINTAPI   ' POINT
  gmCellIncX      AS INTEGER    ' short
  gmCellIncY      AS INTEGER    ' short
END TYPE

'//  GetGlyphOutline constants

%GGO_METRICS      = 0
%GGO_BITMAP       = 1
%GGO_NATIVE       = 2
%GGO_BEZIER       = 3

'#if(WINVER >= 0x0400)
%GGO_GRAY2_BITMAP = 4
%GGO_GRAY4_BITMAP = 5
%GGO_GRAY8_BITMAP = 6
%GGO_GLYPH_INDEX  = &H0080
'#endif /* WINVER >= 0x0400 */

'#if (_WIN32_WINNT >= 0x0500)
%GGO_UNHINTED     = &H0100
'#endif // (_WIN32_WINNT >= 0x0500)

%TT_POLYGON_TYPE = 24

%TT_PRIM_LINE    = 1
%TT_PRIM_QSPLINE = 2
%TT_PRIM_CSPLINE = 3

TYPE POINTFX
   x AS FIXED
   y AS FIXED
END TYPE

TYPE TTPOLYCURVE
   wType   AS WORD      ' WORD
   cpfx    AS WORD      ' WORD
   apfx(0) AS POINTFX   ' POINTFX apfx[1]
END TYPE

TYPE TTPOLYGONHEADER
   cb       AS DWORD
   dwType   AS DWORD
   pfxStart AS POINTFX
END TYPE

'#if(WINVER >= 0x0400)
%GCP_DBCS            = &H00000001???
%GCP_REORDER         = &H00000002???
%GCP_USEKERNING      = &H00000008???
%GCP_GLYPHSHAPE      = &H00000010???
%GCP_LIGATE          = &H00000020???
%GCP_DIACRITIC       = &H00000100???
%GCP_KASHIDA         = &H00000400???
%GCP_ERROR           = &H00008000???
%FLI_MASK            = &H0000103B???

%GCP_JUSTIFY         = &H00010000???
'%GCP_NODIACRITICS    = &H00020000???
%FLI_GLYPHS          = &H00040000???
%GCP_CLASSIN         = &H00080000???
%GCP_MAXEXTENT       = &H00100000???
%GCP_JUSTIFYIN       = &H00200000???
%GCP_DISPLAYZWG      = &H00400000???
%GCP_SYMSWAPOFF      = &H00800000???
%GCP_NUMERICOVERRIDE = &H01000000???
%GCP_NEUTRALOVERRIDE = &H02000000???
%GCP_NUMERICSLATIN   = &H04000000???
%GCP_NUMERICSLOCAL   = &H08000000???

%GCPCLASS_LATIN                  = 1
%GCPCLASS_HEBREW                 = 2
%GCPCLASS_ARABIC                 = 2
%GCPCLASS_NEUTRAL                = 3
%GCPCLASS_LOCALNUMBER            = 4
%GCPCLASS_LATINNUMBER            = 5
%GCPCLASS_LATINNUMERICTERMINATOR = 6
%GCPCLASS_LATINNUMERICSEPARATOR  = 7
%GCPCLASS_NUMERICSEPARATOR       = 8
%GCPCLASS_PREBOUNDRTL            = &H80
%GCPCLASS_PREBOUNDLTR            = &H40
%GCPCLASS_POSTBOUNDLTR           = &H20
%GCPCLASS_POSTBOUNDRTL           = &H10

%GCPGLYPH_LINKBEFORE = &H8000???
%GCPGLYPH_LINKAFTER  = &H4000???

TYPE GCP_RESULTSA
   lStructSize AS DWORD        ' DWORD
   lpOutString AS ASCIIZ PTR   ' LPSTR
   lpOrder     AS DWORD  PTR   ' UINT FAR*
   lpDx        AS LONG   PTR   ' int FAR*
   lpCaretPos  AS LONG   PTR   ' int FAR*
   lpClass     AS ASCIIZ PTR   ' LPSTR
   lpGlyphs    AS WORD   PTR   ' LPWSTR
   nGlyphs     AS DWORD        ' UINT
   nMaxFit     AS LONG         ' int
END TYPE

TYPE GCP_RESULTSW
   lStructSize AS DWORD        ' DWORD
   lpOutString AS WORD   PTR   ' LPWSTR
   lpOrder     AS DWORD  PTR   ' UINT FAR*
   lpDx        AS LONG   PTR   ' int FAR*
   lpCaretPos  AS LONG   PTR   ' int FAR*
   lpClass     AS WORD   PTR   ' LPWSTR
   lpGlyphs    AS WORD   PTR   ' LPWSTR
   nGlyphs     AS DWORD        ' UINT
   nMaxFit     AS LONG         ' int
END TYPE

MACRO GCP_RESULTS = GCP_RESULTSA

TYPE RASTERIZER_STATUS
   nSize       AS INTEGER   ' short
   wFlags      AS INTEGER   ' short
   nLanguageID AS INTEGER   ' short
END TYPE

'/* bits defined in wFlags of RASTERIZER_STATUS */
%TT_AVAILABLE    = &H0001%
%TT_ENABLED      = &H0002%

'/* Pixel format descriptor */
TYPE PIXELFORMATDESCRIPTOR
   nSize           AS WORD
   nVersion        AS WORD
   dwFlags         AS DWORD
   iPixelType      AS BYTE
   cColorBits      AS BYTE
   cRedBits        AS BYTE
   cRedShift       AS BYTE
   cGreenBits      AS BYTE
   cGreenShift     AS BYTE
   cBlueBits       AS BYTE
   cBlueShift      AS BYTE
   cAlphaBits      AS BYTE
   cAlphaShift     AS BYTE
   cAccumBits      AS BYTE
   cAccumRedBits   AS BYTE
   cAccumGreenBits AS BYTE
   cAccumBlueBits  AS BYTE
   cAccumAlphaBits AS BYTE
   cDepthBits      AS BYTE
   cStencilBits    AS BYTE
   cAuxBuffers     AS BYTE
   iLayerType      AS BYTE
   bReserved       AS BYTE
   dwLayerMask     AS DWORD
   dwVisibleMask   AS DWORD
   dwDamageMask    AS DWORD
END TYPE

'/* pixel types */
%PFD_TYPE_RGBA       = 0
%PFD_TYPE_COLORINDEX = 1

'/* layer types */
%PFD_MAIN_PLANE     = 0
%PFD_OVERLAY_PLANE  = 1
%PFD_UNDERLAY_PLANE = -1

'/* PIXELFORMATDESCRIPTOR flags */
%PFD_DOUBLEBUFFER          = &H00000001???
%PFD_STEREO                = &H00000002???
%PFD_DRAW_TO_WINDOW        = &H00000004???
%PFD_DRAW_TO_BITMAP        = &H00000008???
%PFD_SUPPORT_GDI           = &H00000010???
%PFD_SUPPORT_OPENGL        = &H00000020???
%PFD_GENERIC_FORMAT        = &H00000040???
%PFD_NEED_PALETTE          = &H00000080???
%PFD_NEED_SYSTEM_PALETTE   = &H00000100???
%PFD_SWAP_EXCHANGE         = &H00000200???
%PFD_SWAP_COPY             = &H00000400???
%PFD_SWAP_LAYER_BUFFERS    = &H00000800???
%PFD_GENERIC_ACCELERATED   = &H00001000???
%PFD_SUPPORT_DIRECTDRAW    = &H00002000???
%PFD_DIRECT3D_ACCELERATED  = &H00004000???
%PFD_SUPPORT_COMPOSITION   = &H00008000???

'/* PIXELFORMATDESCRIPTOR flags for use in ChoosePixelFormat only */
%PFD_DEPTH_DONTCARE        = &H20000000???
%PFD_DOUBLEBUFFER_DONTCARE = &H40000000???
%PFD_STEREO_DONTCARE       = &H80000000???

'#ifdef STRICT
'#if !defined(NOTEXTMETRIC)
'typedef int (CALLBACK* OLDFONTENUMPROCA)(CONST LOGFONTA *, CONST TEXTMETRICA *, DWORD, LPARAM);
'typedef int (CALLBACK* OLDFONTENUMPROCW)(CONST LOGFONTW *, CONST TEXTMETRICW *, DWORD, LPARAM);

'typedef int (CALLBACK* GOBJENUMPROC)(LPVOID, LPARAM);
'typedef VOID (CALLBACK* LINEDDAPROC)(int, int, LPARAM);
'#else
'typedef FARPROC OLDFONTENUMPROC;
'typedef FARPROC FONTENUMPROCA;
'typedef FARPROC FONTENUMPROCW;
'typedef FARPROC GOBJENUMPROC;
'typedef FARPROC LINEDDAPROC;
'#endif


DECLARE FUNCTION AddFontResource LIB "GDI32.DLL" ALIAS "AddFontResourceA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR
 ) AS LONG                             ' int

DECLARE FUNCTION AddFontResourceW LIB "GDI32.DLL" ALIAS "AddFontResourceW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR
 ) AS LONG                             ' int

DECLARE FUNCTION AnimatePalette LIB "GDI32.DLL" ALIAS "AnimatePalette" ( _
   BYVAL DWORD _                       ' __in HPALETTE hPal
 , BYVAL DWORD _                       ' __in UINT iStartIndex
 , BYVAL DWORD _                       ' __in   UINT cEntries
 , BYREF PALETTEENTRY _                ' __in_ecount(cEntries) CONST PALETTEENTRY * ppe)
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Arc LIB "GDI32.DLL" ALIAS "Arc" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x1
 , BYVAL LONG _                        ' __in int y1
 , BYVAL LONG _                        ' __in int x2
 , BYVAL LONG _                        ' __in int y2
 , BYVAL LONG _                        ' __in int x3
 , BYVAL LONG _                        ' __in int y3
 , BYVAL LONG _                        ' __in int x4
 , BYVAL LONG _                        ' __in int y4
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BitBlt LIB "GDI32.DLL" ALIAS "BitBlt" ( _
   BYVAL DWORD _                       ' __in HDC hdc,
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 , BYVAL DWORD _                       ' __in_opt HDC hdcSrc
 , BYVAL LONG _                        ' __in int x1
 , BYVAL LONG _                        ' __in int y1
 , BYVAL DWORD _                       ' __in DWORD rop
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CancelDC LIB "GDI32.DLL" ALIAS "CancelDC" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Chord LIB "GDI32.DLL" ALIAS "Chord" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x1
 , BYVAL LONG _                        ' __in int y1
 , BYVAL LONG _                        ' __in int x2
 , BYVAL LONG _                        ' __in int y2
 , BYVAL LONG _                        ' __in int x3
 , BYVAL LONG _                        ' __in int y3
 , BYVAL LONG _                        ' __in int x4
 , BYVAL LONG _                        ' __in int y4
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ChoosePixelFormat LIB "GDI32.DLL" ALIAS "ChoosePixelFormat" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF PIXELFORMATDESCRIPTOR _       ' __in CONST PIXELFORMATDESCRIPTOR *ppfd
 ) AS LONG                             ' int

DECLARE FUNCTION CloseMetaFile LIB "GDI32.DLL" ALIAS "CloseMetaFile" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' HMETAFILE

DECLARE FUNCTION CombineRgn LIB "GDI32.DLL" ALIAS "CombineRgn" ( _
   BYVAL DWORD _                       ' __in_opt HRGN hrgnDst
 , BYVAL DWORD _                       ' __in_opt HRGN hrgnSrc1
 , BYVAL DWORD _                       ' __in_opt HRGN hrgnSrc2
 , BYVAL LONG _                        ' __in int iMode
 ) AS LONG                             ' int

DECLARE FUNCTION CopyMetaFile LIB "GDI32.DLL" ALIAS "CopyMetaFileA" ( _
   BYVAL DWORD _                       ' __in HMETAFILE
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR
 ) AS DWORD                            ' HMETAFILE

DECLARE FUNCTION CopyMetaFileW LIB "GDI32.DLL" ALIAS "CopyMetaFileW" ( _
   BYVAL DWORD _                       ' __in HMETAFILE
 , BYVAL DWORD _                       ' __in_opt LPCWSTR
 ) AS DWORD                            ' HMETAFILE

DECLARE FUNCTION CreateBitmap LIB "GDI32.DLL" ALIAS "CreateBitmap" ( _
   BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYVAL DWORD _                       ' __in UINT nPlanes
 , BYVAL DWORD _                       ' __in UINT nBitCount
 , BYREF ANY _                         ' __in_opt CONST VOID *lpBits
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION CreateBitmapIndirect LIB "GDI32.DLL" ALIAS "CreateBitmapIndirect" ( _
   BYREF BITMAP _                      ' __in CONST BITMAP *pbm
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION CreateBrushIndirect LIB "GDI32.DLL" ALIAS "CreateBrushIndirect" ( _
   BYREF LOGBRUSH _                    ' __in CONST LOGBRUSH *plbrush
 ) AS DWORD                            ' HBRUSH

DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION CreateDiscardableBitmap LIB "GDI32.DLL" ALIAS "CreateDiscardableBitmap" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" ( _
   BYVAL DWORD _                       ' __in_opt HDC hdc
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreateDC LIB "GDI32.DLL" ALIAS "CreateDCA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR pwszDriver
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR pwszDevice
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR pszPort
 , BYREF DEVMODEA _                    ' __in_opt CONST DEVMODEA * pdm
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreateDCW LIB "GDI32.DLL" ALIAS "CreateDCW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR pwszDriver
 , BYVAL DWORD _                       ' __in_opt LPCWSTR pwszDevice
 , BYVAL DWORD _                       ' __in_opt LPCWSTR pszPort
 , BYREF DEVMODEW _                    ' __in_opt CONST DEVMODEW * pdm
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreateDIBitmap LIB "GDI32.DLL" ALIAS "CreateDIBitmap" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF BITMAPINFOHEADER _            ' __in_opt CONST BITMAPINFOHEADER *pbmih
 , BYVAL DWORD _                       ' __in DWORD flInit
 , BYREF ANY _                         ' __in_opt CONST VOID *pjBits
 , BYREF BITMAPINFO _                  ' __in_opt CONST BITMAPINFO *pbmi
 , BYVAL DWORD _                       ' __in UINT iUsage
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION CreateDIBPatternBrush LIB "GDI32.DLL" ALIAS "CreateDIBPatternBrush" ( _
   BYVAL DWORD _                       ' __in HGLOBAL h
 , BYVAL DWORD _                       ' __in UINT iUsage
 ) AS DWORD                            ' HBRUSH

DECLARE FUNCTION CreateDIBPatternBrushPt LIB "GDI32.DLL" ALIAS "CreateDIBPatternBrushPt" ( _
   BYREF ANY _                         ' __in CONST VOID *lpPackedDIB
 , BYVAL DWORD _                       ' __in UINT iUsage
 ) AS DWORD                            ' HBRUSH

DECLARE FUNCTION CreateEllipticRgn LIB "GDI32.DLL" ALIAS "CreateEllipticRgn" ( _
   BYVAL LONG _                        ' __in int x1
 , BYVAL LONG _                        ' __in int y1
 , BYVAL LONG _                        ' __in int x2
 , BYVAL LONG _                        ' __in int y2
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION CreateEllipticRgnIndirect LIB "GDI32.DLL" ALIAS "CreateEllipticRgnIndirect" ( _
   BYREF RECT _                        ' __in CONST RECT *lprect
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION CreateFontIndirect LIB "GDI32.DLL" ALIAS "CreateFontIndirectA" ( _
   BYREF LOGFONTA _                    ' __in CONST LOGFONTA *lplf
 ) AS DWORD                            ' HFONT

DECLARE FUNCTION CreateFontIndirectW LIB "GDI32.DLL" ALIAS "CreateFontIndirectW" ( _
   BYREF LOGFONTW _                    ' __in CONST LOGFONTW *lplf
 ) AS DWORD                            ' HFONT

DECLARE FUNCTION CreateFont LIB "GDI32.DLL" ALIAS "CreateFontA" ( _
   BYVAL LONG _                        ' __in int cHeight
 , BYVAL LONG _                        ' __in int cWidth
 , BYVAL LONG _                        ' __in int cEscapement
 , BYVAL LONG _                        ' __in int cOrientation
 , BYVAL LONG _                        ' __in int cWeight
 , BYVAL DWORD _                       ' __in DWORD bItalic
 , BYVAL DWORD _                       ' __in DWORD bUnderline
 , BYVAL DWORD _                       ' __in DWORD bStrikeOut
 , BYVAL DWORD _                       ' __in DWORD iCharSet
 , BYVAL DWORD _                       ' __in DWORD iOutPrecision
 , BYVAL DWORD _                       ' __in DWORD iClipPrecision
 , BYVAL DWORD _                       ' __in DWORD iQuality
 , BYVAL DWORD _                       ' __in DWORD iPitchAndFamily
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR pszFaceName
 ) AS DWORD                            ' HFONT

DECLARE FUNCTION CreateFontW LIB "GDI32.DLL" ALIAS "CreateFontW" ( _
   BYVAL LONG _                        ' __in int cHeight
 , BYVAL LONG _                        ' __in int cWidth
 , BYVAL LONG _                        ' __in int cEscapement
 , BYVAL LONG _                        ' __in int cOrientation
 , BYVAL LONG _                        ' __in int cWeight
 , BYVAL DWORD _                       ' __in DWORD bItalic
 , BYVAL DWORD _                       ' __in DWORD bUnderline
 , BYVAL DWORD _                       ' __in DWORD bStrikeOut
 , BYVAL DWORD _                       ' __in DWORD iCharSet
 , BYVAL DWORD _                       ' __in DWORD iOutPrecision
 , BYVAL DWORD _                       ' __in DWORD iClipPrecision
 , BYVAL DWORD _                       ' __in DWORD iQuality
 , BYVAL DWORD _                       ' __in DWORD iPitchAndFamily
 , BYVAL DWORD _                       ' __in_opt LPCWSTR pszFaceName
 ) AS DWORD                            ' HFONT

DECLARE FUNCTION CreateHatchBrush LIB "GDI32.DLL" ALIAS "CreateHatchBrush" ( _
   BYVAL LONG _                        ' __in int iHatch
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' HBRUSH

DECLARE FUNCTION CreateIC LIB "GDI32.DLL" ALIAS "CreateICA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR pszDriver
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR pszDevice
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR pszPort
 , BYREF DEVMODEA _                    ' __in_opt CONST DEVMODEA * pdm
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreateICW LIB "GDI32.DLL" ALIAS "CreateICW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR pszDriver
 , BYVAL DWORD _                       ' __in_opt LPCWSTR pszDevice
 , BYVAL DWORD _                       ' __in_opt LPCWSTR pszPort
 , BYREF DEVMODEW _                    ' __in_opt CONST DEVMODEW * pdm
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreateMetaFile LIB "GDI32.DLL" ALIAS "CreateMetaFileA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR pszFile
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreateMetaFileW LIB "GDI32.DLL" ALIAS "CreateMetaFileW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR pszFile
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreatePalette LIB "GDI32.DLL" ALIAS "CreatePalette" ( _
   BYREF LOGPALETTE _                  ' __in CONST LOGPALETTE * plpal
 ) AS DWORD                            ' HPALETTE

DECLARE FUNCTION CreatePen LIB "GDI32.DLL" ALIAS "CreatePen" ( _
   BYVAL LONG _                        ' __in int iStyle
 , BYVAL LONG _                        ' __in int cWidth
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' HPEN

DECLARE FUNCTION CreatePenIndirect LIB "GDI32.DLL" ALIAS "CreatePenIndirect" ( _
   BYREF LOGPEN _                      ' __in CONST LOGPEN *plpen
 ) AS DWORD                            ' HPEN

DECLARE FUNCTION CreatePolyPolygonRgn LIB "GDI32.DLL" ALIAS "CreatePolyPolygonRgn" ( _
   BYREF POINTAPI _                    ' __in CONST POINT *pptl
 , BYREF LONG _                        ' __in CONST INT  *pc
 , BYVAL LONG _                        ' __in int cPoly
 , BYVAL LONG _                        ' __in int iMode
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION CreatePatternBrush LIB "GDI32.DLL" ALIAS "CreatePatternBrush" ( _
   BYVAL DWORD _                       ' __in HBITMAP hbm
 ) AS DWORD                            ' HBRUSH

DECLARE FUNCTION CreateRectRgn LIB "GDI32.DLL" ALIAS "CreateRectRgn" ( _
   BYVAL LONG _                        ' __in int x1
 , BYVAL LONG _                        ' __in int y1
 , BYVAL LONG _                        ' __in int x2
 , BYVAL LONG _                        ' __in int y2
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION CreateRectRgnIndirect LIB "GDI32.DLL" ALIAS "CreateRectRgnIndirect" ( _
   BYREF RECT _                        ' __in CONST RECT *lprect
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION CreateRoundRectRgn LIB "GDI32.DLL" ALIAS "CreateRoundRectRgn" ( _
   BYVAL LONG _                        ' __in int x1
 , BYVAL LONG _                        ' __in int y1
 , BYVAL LONG _                        ' __in int x2
 , BYVAL LONG _                        ' __in int y2
 , BYVAL LONG _                        ' __in int w
 , BYVAL LONG _                        ' __in int h
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION CreateScalableFontResource LIB "GDI32.DLL" ALIAS "CreateScalableFontResourceA" ( _
   BYVAL DWORD _                       ' __in DWORD fdwHidden
 , BYREF ASCIIZ _                      ' __in LPCSTR lpszFont
 , BYREF ASCIIZ _                      ' __in LPCSTR lpszFile
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpszPath
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateScalableFontResourceW LIB "GDI32.DLL" ALIAS "CreateScalableFontResourceW" ( _
   BYVAL DWORD _                       ' __in DWORD fdwHidden
 , BYVAL DWORD _                       ' __in LPCWSTR lpszFont
 , BYVAL DWORD _                       ' __in LPCWSTR lpszFile
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpszPath
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateSolidBrush LIB "GDI32.DLL" ALIAS "CreateSolidBrush" ( _
   BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' HBRUSH

DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteMetaFile LIB "GDI32.DLL" ALIAS "DeleteMetaFile" ( _
   BYVAL DWORD _                       ' __in HMETAFILE hmf
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" ( _
   BYVAL DWORD _                       ' __in HGDIOBJ ho
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DescribePixelFormat LIB "GDI32.DLL" ALIAS "DescribePixelFormat" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int iPixelFormat
 , BYVAL DWORD _                       ' __in UINT nBytes
 , BYREF PIXELFORMATDESCRIPTOR _       ' __out_bcount_opt(nBytes) LPPIXELFORMATDESCRIPTOR ppfd
 ) AS LONG                             ' int

'/* define types of pointers to ExtDeviceMode() and DeviceCapabilities()
' * functions for Win 3.1 compatibility
' */

'typedef UINT   (CALLBACK* LPFNDEVMODE)(HWND, HMODULE, LPDEVMODE, LPSTR, LPSTR, LPDEVMODE, LPSTR, UINT);

'typedef DWORD  (CALLBACK* LPFNDEVCAPS)(LPSTR, LPSTR, UINT, LPSTR, LPDEVMODE);

'/* mode selections for the device mode function */
%DM_UPDATE            = 1
%DM_COPY              = 2
%DM_PROMPT            = 4
%DM_MODIFY            = 8

%DM_IN_BUFFER         = %DM_MODIFY
%DM_IN_PROMPT         = %DM_PROMPT
%DM_OUT_BUFFER        = %DM_COPY
%DM_OUT_DEFAULT       = %DM_UPDATE

'/* device capabilities indices */
%DC_FIELDS            = 1
%DC_PAPERS            = 2
%DC_PAPERSIZE         = 3
%DC_MINEXTENT         = 4
%DC_MAXEXTENT         = 5
%DC_BINS              = 6
%DC_DUPLEX            = 7
%DC_SIZE              = 8
%DC_EXTRA             = 9
%DC_VERSION           = 10
%DC_DRIVER            = 11
%DC_BINNAMES          = 12
%DC_ENUMRESOLUTIONS   = 13
%DC_FILEDEPENDENCIES  = 14
%DC_TRUETYPE          = 15
%DC_PAPERNAMES        = 16
%DC_ORIENTATION       = 17
%DC_COPIES            = 18
'#if(WINVER >= 0x0400)
%DC_BINADJUST         = 19
%DC_EMF_COMPLIANT     = 20
%DC_DATATYPE_PRODUCED = 21
%DC_COLLATE           = 22
%DC_MANUFACTURER      = 23
%DC_MODEL             = 24
'#endif  /*  WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
%DC_PERSONALITY         = 25
%DC_PRINTRATE           = 26
%DC_PRINTRATEUNIT       = 27
%PRINTRATEUNIT_PPM      = 1
%PRINTRATEUNIT_CPS      = 2
%PRINTRATEUNIT_LPM      = 3
%PRINTRATEUNIT_IPM      = 4
%DC_PRINTERMEM          = 28
%DC_MEDIAREADY          = 29
%DC_STAPLE              = 30
%DC_PRINTRATEPPM        = 31
%DC_COLORDEVICE         = 32
%DC_NUP                 = 33
'#if (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)
%DC_MEDIATYPENAMES      = 34
%DC_MEDIATYPES          = 35
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)
'#endif /* WINVER >= 0x0500 */

'/* bit fields of the return value (DWORD) for DC_TRUETYPE */
%DCTT_BITMAP             = &H0000001???
%DCTT_DOWNLOAD           = &H0000002???
%DCTT_SUBDEV             = &H0000004???
'#if(WINVER >= = &H0400)
%DCTT_DOWNLOAD_OUTLINE   = &H0000008???

'/* return values for DC_BINADJUST */
%DCBA_FACEUPNONE       = &H0000
%DCBA_FACEUPCENTER     = &H0001
%DCBA_FACEUPLEFT       = &H0002
%DCBA_FACEUPRIGHT      = &H0003
%DCBA_FACEDOWNNONE     = &H0100
%DCBA_FACEDOWNCENTER   = &H0101
%DCBA_FACEDOWNLEFT     = &H0102
%DCBA_FACEDOWNRIGHT    = &H0103
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION DeviceCapabilities LIB "WINSPOOL.DRV" ALIAS "DeviceCapabilitiesA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR pDevice
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR pPort
 , BYVAL WORD _                        ' __in WORD fwCapability
 , BYREF ASCIIZ _                      ' __out_opt LPSTR pOutput
 , BYREF DEVMODEA _                    ' __in_opt CONST DEVMODEA * pDevMode
 ) AS LONG                             ' int

DECLARE FUNCTION DeviceCapabilitiesW LIB "WINSPOOL.DRV" ALIAS "DeviceCapabilitiesW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR pDevice
 , BYVAL DWORD _                       ' __in_opt LPCWSTR pPort
 , BYVAL WORD _                        ' __in WORD fwCapability
 , BYREF DWORD _                       ' __out_opt LPWSTR pOutput
 , BYREF DEVMODEW _                    ' __in_opt CONST DEVMODEW * pDevMode
 ) AS LONG                             ' int

DECLARE FUNCTION DrawEscape LIB "GDI32.DLL" ALIAS "DrawEscape" ( _
   BYVAL DWORD _                       ' __in HDC    hdc
 , BYVAL LONG _                        ' __in int    iEscape
 , BYVAL LONG _                        ' __in int    cjIn
 , BYREF ASCIIZ _                      ' __in_bcount_opt(cjIn) LPCSTR lpIn
 ) AS LONG                             ' int

DECLARE FUNCTION Ellipse LIB "GDI32.DLL" ALIAS "Ellipse" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int left
 , BYVAL LONG _                        ' __in int top
 , BYVAL LONG _                        ' __in int right
 , BYVAL LONG _                        ' __in int bottom
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0400)
DECLARE FUNCTION EnumFontFamiliesEx LIB "GDI32.DLL" ALIAS "EnumFontFamiliesExA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF LOGFONTA _                    ' __in LPLOGFONTA lpLogfont
 , BYVAL DWORD _                       ' __in FONTENUMPROCA lpProc
 , BYVAL LONG _                        ' __in LPARAM lParam
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' int

DECLARE FUNCTION EnumFontFamiliesExW LIB "GDI32.DLL" ALIAS "EnumFontFamiliesExW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF LOGFONTW  _                   ' __in LPLOGFONTW lpLogfont
 , BYVAL DWORD _                       ' __in FONTENUMPROCW lpProc
 , BYVAL LONG _                        ' __in LPARAM lParam
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' int

DECLARE FUNCTION EnumFontFamilies LIB "GDI32.DLL" ALIAS "EnumFontFamiliesA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpLogfont
 , BYVAL DWORD _                       ' __in FONTENUMPROCA lpProc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' int

DECLARE FUNCTION EnumFontFamiliesW LIB "GDI32.DLL" ALIAS "EnumFontFamiliesW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpLogfont
 , BYVAL DWORD _                       ' __in FONTENUMPROCW lpProc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' int

DECLARE FUNCTION EnumFonts LIB "GDI32.DLL" ALIAS "EnumFontsA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpLogfont
 , BYVAL DWORD _                       ' __in FONTENUMPROCA lpProc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' int

DECLARE FUNCTION EnumFontsW LIB "GDI32.DLL" ALIAS "EnumFontsW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpLogfont
 , BYVAL DWORD _                       ' __in FONTENUMPROCW lpProc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' int

DECLARE FUNCTION EnumObjects LIB "GDI32.DLL" ALIAS "EnumObjects" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int nType
 , BYVAL DWORD _                       ' __in GOBJENUMPROC lpFunc
 , BYREF ANY _                         ' __in LPVOID lParam
 ) AS LONG                             ' int

DECLARE FUNCTION EqualRgn LIB "GDI32.DLL" ALIAS "EqualRgn" ( _
   BYVAL DWORD _                       ' __in HRGN hrgn1
 , BYVAL DWORD _                       ' __in HRGN hrgn2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Escape LIB "GDI32.DLL" ALIAS "Escape" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int iEscape
 , BYVAL LONG _                        ' __in int cjIn
 , BYREF ASCIIZ _                      ' __in_bcount_opt(cjIn) LPCSTR pvIn
 , BYREF ANY _                         ' __out_opt LPVOID pvOut
 ) AS LONG                             ' int

DECLARE FUNCTION ExtEscape LIB "GDI32.DLL" ALIAS "ExtEscape" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int iEscape
 , BYVAL LONG _                        ' __in int cjInput
 , BYREF ASCIIZ _                      ' __in_bcount_opt(cjInput) LPCSTR lpInData
 , BYVAL LONG _                        ' __in int cjOutput
 , BYREF ASCIIZ _                      ' __out_bcount_opt(cjOutput) LPSTR lpOutData
 ) AS LONG                             ' int

DECLARE FUNCTION ExcludeClipRect LIB "GDI32.DLL" ALIAS "ExcludeClipRect" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int left
 , BYVAL LONG _                        ' __in int top
 , BYVAL LONG _                        ' __in int right
 , BYVAL LONG _                        ' __in int bottom
 ) AS LONG                             ' int

DECLARE FUNCTION ExtCreateRegion LIB "GDI32.DLL" ALIAS "ExtCreateRegion" ( _
   BYREF XFORM _                       ' __in_opt CONST XFORM * lpx
 , BYVAL DWORD _                       ' __in DWORD nCount
 , BYREF RGNDATA _                     ' __in_bcount(nCount) CONST RGNDATA * lpData
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION ExtFloodFill LIB "GDI32.DLL" ALIAS "ExtFloodFill" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in COLORREF color
 , BYVAL DWORD _                       ' __in UINT type
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FillRgn LIB "GDI32.DLL" ALIAS "FillRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HRGN hrgn
 , BYVAL DWORD _                       ' __in HBRUSH hbr
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FloodFill LIB "GDI32.DLL" ALIAS "FloodFill" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FrameRgn LIB "GDI32.DLL" ALIAS "FrameRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HRGN hrgn
 , BYVAL DWORD _                       ' __in HBRUSH hbr
 , BYVAL LONG _                        ' __in int w
 , BYVAL LONG _                        ' __in int h
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetROP2 LIB "GDI32.DLL" ALIAS "GetROP2" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetAspectRatioFilterEx LIB "GDI32.DLL" ALIAS "GetAspectRatioFilterEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF APISIZE _                     ' __out LPSIZE lpsize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetBkColor LIB "GDI32.DLL" ALIAS "GetBkColor" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' COLORREF

'#if (_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION GetDCBrushColor LIB "GDI32.DLL" ALIAS "GetDCBrushColor" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' COLORREF

DECLARE FUNCTION GetDCPenColor LIB "GDI32.DLL" ALIAS "GetDCPenColor" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' COLORREF

'#endif

DECLARE FUNCTION GetBkMode LIB "GDI32.DLL" ALIAS "GetBkMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetBitmapBits LIB "GDI32.DLL" ALIAS "GetBitmapBits" ( _
   BYVAL DWORD _                       ' __in HBITMAP hbit
 , BYVAL LONG _                        ' __in LONG cb
 , BYREF ANY _                         ' __out_bcount(cb) LPVOID lpvBits
 ) AS LONG                             ' LONG

DECLARE FUNCTION GetBitmapDimensionEx LIB "GDI32.DLL" ALIAS "GetBitmapDimensionEx" ( _
   BYVAL DWORD _                       ' __in HBITMAP hbit
 , BYREF APISIZE _                     ' __out LPSIZE lpsize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetBoundsRect LIB "GDI32.DLL" ALIAS "GetBoundsRect" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF RECT _                        ' __out LPRECT lprect
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetBrushOrgEx LIB "GDI32.DLL" ALIAS "GetBrushOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __out LPPOINT lppt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharWidth LIB "GDI32.DLL" ALIAS "GetCharWidthA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT iFirst
 , BYVAL DWORD _                       ' __in UINT iLast
 , BYREF LONG _                        ' __out_ecount(iLast + 1 - iFirst) LPINT lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharWidthW LIB "GDI32.DLL" ALIAS "GetCharWidthW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT iFirst
 , BYVAL DWORD _                       ' __in UINT iLast
 , BYREF LONG _                        ' __out_ecount(iLast + 1 - iFirst) LPINT lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharWidth32 LIB "GDI32.DLL" ALIAS "GetCharWidth32A" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT iFirst
 , BYVAL DWORD _                       ' __in UINT iLast
 , BYREF LONG _                        ' __out_ecount(iLast + 1 - iFirst) LPINT lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharWidth32W LIB "GDI32.DLL" ALIAS "GetCharWidth32W" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT iFirst
 , BYVAL DWORD _                       ' __in UINT iLast
 , BYREF LONG _                        ' __out_ecount(iLast + 1 - iFirst) LPINT lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharWidthFloat LIB "GDI32.DLL" ALIAS "GetCharWidthFloatA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT iFirst
 , BYVAL DWORD _                       ' __in UINT iLast
 , BYREF SINGLE _                      ' __out_ecount(iLast + 1 - iFirst) PFLOAT lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharWidthFloatW LIB "GDI32.DLL" ALIAS "GetCharWidthFloatW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT iFirst
 , BYVAL DWORD _                       ' __in UINT iLast
 , BYREF SINGLE _                      ' __out_ecount(iLast + 1 - iFirst) PFLOAT lpBuffer
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharABCWidths LIB "GDI32.DLL" ALIAS "GetCharABCWidthsA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT wFirst
 , BYVAL DWORD _                       ' __in UINT wLast
 , BYREF ABC _                         ' __out_ecount(wLast - wFirst + 1) LPABC lpABC
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharABCWidthsW LIB "GDI32.DLL" ALIAS "GetCharABCWidthsW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT wFirst
 , BYVAL DWORD _                       ' __in UINT wLast
 , BYREF ABC _                         ' __out_ecount(wLast - wFirst + 1) LPABC lpABC
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharABCWidthsFloat LIB "GDI32.DLL" ALIAS "GetCharABCWidthsFloatA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT iFirst
 , BYVAL DWORD _                       ' __in UINT iLast
 , BYREF ABCFLOAT _                    ' __out_ecount(iLast + 1 - iFirst) LPABCFLOAT lpABC
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharABCWidthsFloatW LIB "GDI32.DLL" ALIAS "GetCharABCWidthsFloatW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT iFirst
 , BYVAL DWORD _                       ' __in UINT iLast
 , BYREF ABCFLOAT _                    ' __out_ecount(iLast + 1 - iFirst) LPABCFLOAT lpABC
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetClipBox LIB "GDI32.DLL" ALIAS "GetClipBox" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF RECT _                        ' __out LPRECT lprect
 ) AS LONG                             ' int

DECLARE FUNCTION GetClipRgn LIB "GDI32.DLL" ALIAS "GetClipRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HRGN hrgn
 ) AS LONG                             ' int

DECLARE FUNCTION GetMetaRgn LIB "GDI32.DLL" ALIAS "GetMetaRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HRGN hrgn
 ) AS LONG                             ' int

DECLARE FUNCTION GetCurrentObject LIB "GDI32.DLL" ALIAS "GetCurrentObject" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT type
 ) AS DWORD                            ' HGDIOBJ

DECLARE FUNCTION GetCurrentPositionEx LIB "GDI32.DLL" ALIAS "GetCurrentPositionEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __out LPPOINT lppt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDeviceCaps LIB "GDI32.DLL" ALIAS "GetDeviceCaps" ( _
   BYVAL DWORD _                       ' __in_opt HDC hdc
 , BYVAL LONG _                        ' __in int index
 ) AS LONG                             ' int

DECLARE FUNCTION GetDIBits LIB "GDI32.DLL" ALIAS "GetDIBits" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HBITMAP hbm
 , BYVAL DWORD _                       ' __in UINT start
 , BYVAL DWORD _                       ' __in UINT cLines
 , BYREF ANY _                         ' __out_opt LPVOID lpvBits
 , BYREF BITMAPINFO _                  ' __inout LPBITMAPINFO lpbmi
 , BYVAL DWORD _                       ' __in UINT usage
 ) AS LONG                             ' int

DECLARE FUNCTION GetFontData LIB "GDI32.DLL" ALIAS "GetFontData" ( _
   BYVAL DWORD _                       ' __in HDC     hdc
 , BYVAL DWORD _                       ' __in DWORD   dwTable
 , BYVAL DWORD _                       ' __in DWORD   dwOffset
 , BYREF ANY _                         ' __out_bcount_part_opt(cjBuffer, return) PVOID pvBuffer
 , BYVAL DWORD _                       ' __in DWORD   cjBuffer
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetGlyphOutline LIB "GDI32.DLL" ALIAS "GetGlyphOutlineA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT uChar
 , BYVAL DWORD _                       ' __in UINT fuFormat
 , BYREF GLYPHMETRICS _                ' __out LPGLYPHMETRICS lpgm
 , BYVAL DWORD _                       ' __in DWORD cjBuffer
 , BYREF ANY _                         ' __out_bcount_opt(cjBuffer) LPVOID pvBuffer
 , BYREF MAT2 _                        ' __in CONST MAT2 *lpmat2
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetGlyphOutlineW LIB "GDI32.DLL" ALIAS "GetGlyphOutlineW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT uChar
 , BYVAL DWORD _                       ' __in UINT fuFormat
 , BYREF GLYPHMETRICS _                ' __out LPGLYPHMETRICS lpgm
 , BYVAL DWORD _                       ' __in DWORD cjBuffer
 , BYREF ANY _                         ' __out_bcount_opt(cjBuffer) LPVOID pvBuffer
 , BYREF MAT2 _                        ' __in CONST MAT2 *lpmat2
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetGraphicsMode LIB "GDI32.DLL" ALIAS "GetGraphicsMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetMapMode LIB "GDI32.DLL" ALIAS "GetMapMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetMetaFileBitsEx LIB "GDI32.DLL" ALIAS "GetMetaFileBitsEx" ( _
   BYVAL DWORD _                       ' __in HMETAFILE hMF
 , BYVAL DWORD _                       ' __in UINT cbBuffer
 , BYREF ANY _                         ' __out_bcount_opt(cbBuffer) LPVOID lpData
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetMetaFile LIB "GDI32.DLL" ALIAS "GetMetaFileA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpName
 ) AS DWORD                            ' HMETAFILE

DECLARE FUNCTION GetMetaFileW LIB "GDI32.DLL" ALIAS "GetMetaFileW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpName
 ) AS DWORD                            ' HMETAFILE

DECLARE FUNCTION GetNearestColor LIB "GDI32.DLL" ALIAS "GetNearestColor" ( _
   BYVAL DWORD  _                      ' __in HDC hdc
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' COLORREF

DECLARE FUNCTION GetNearestPaletteIndex LIB "GDI32.DLL" ALIAS "GetNearestPaletteIndex" ( _
   BYVAL DWORD _                       ' __in HPALETTE h
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetObjectType LIB "GDI32.DLL" ALIAS "GetObjectType" ( _
   BYVAL DWORD _                       ' __in HGDIOBJ h
 ) AS DWORD                            ' DWORD

#IF NOT %DEF(%NOTEXTMETRIC) ' -------------------------------------------------
'#ifndef NOTEXTMETRIC

DECLARE FUNCTION GetOutlineTextMetrics LIB "GDI32.DLL" ALIAS "GetOutlineTextMetricsA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT cjCopy
 , BYREF OUTLINETEXTMETRICA _          ' __out_bcount_opt(cjCopy) LPOUTLINETEXTMETRICA potm
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetOutlineTextMetricsW LIB "GDI32.DLL" ALIAS "GetOutlineTextMetricsW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT cjCopy
 , BYREF OUTLINETEXTMETRICW _          ' __out_bcount_opt(cjCopy) LPOUTLINETEXTMETRICW potm
 ) AS DWORD                            ' UINT

'#endif /* NOTEXTMETRIC */
#ENDIF   ' #IF NOT %DEF(%NOTEXTMETRIC) ----------------------------------------

DECLARE FUNCTION GetPaletteEntries LIB "GDI32.DLL" ALIAS "GetPaletteEntries" ( _
   BYVAL DWORD _                       ' __in HPALETTE hpal
 , BYVAL DWORD _                       ' __in UINT iStart
 , BYVAL DWORD _                       ' __in UINT cEntries
 , BYREF PALETTEENTRY _                ' __out_ecount(cEntries) LPPALETTEENTRY pPalEntries
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetPixel LIB "GDI32.DLL" ALIAS "GetPixel" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 ) AS DWORD                            ' COLORREF

DECLARE FUNCTION GetPixelFormat LIB "GDI32.DLL" ALIAS "GetPixelFormat" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetPolyFillMode LIB "GDI32.DLL" ALIAS "GetPolyFillMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetRasterizerCaps LIB "GDI32.DLL" ALIAS "GetRasterizerCaps" ( _
   BYREF RASTERIZER_STATUS _           ' __out_bcount(cjBytes) LPRASTERIZER_STATUS lpraststat
 , BYVAL DWORD _                       ' __in UINT cjBytes
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetRandomRgn LIB "GDI32.DLL" ALIAS "GetRandomRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HRGN hrgn
 , BYVAL LONG _                        ' __in INT i
 ) AS LONG                             ' int

DECLARE FUNCTION GetRegionData LIB "GDI32.DLL" ALIAS "GetRegionData" ( _
   BYVAL DWORD _                       ' __in HRGN hrgn
 , BYVAL DWORD _                       ' __in DWORD nCount
 , BYREF RGNDATA _                     ' __out_bcount_part_opt(nCount, return) LPRGNDATA lpRgnData
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetRgnBox LIB "GDI32.DLL" ALIAS "GetRgnBox" ( _
   BYVAL DWORD _                       ' __in HRGN hrgn
 , BYREF RECT _                        ' __out LPRECT lprc
 ) AS LONG                             ' int

DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" ( _
   BYVAL LONG _                        ' __in int i
 ) AS DWORD                            ' HGDIOBJ

DECLARE FUNCTION GetStretchBltMode LIB "GDI32.DLL" ALIAS "GetStretchBltMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetSystemPaletteEntries LIB "GDI32.DLL" ALIAS "GetSystemPaletteEntries" ( _
   BYVAL DWORD _                       ' __in HDC  hdc
 , BYVAL DWORD _                       ' __in UINT iStart
 , BYVAL DWORD _                       ' __in UINT cEntries
 , BYREF PALETTEENTRY _                ' __out_ecount_opt(cEntries) LPPALETTEENTRY pPalEntries
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetSystemPaletteUse LIB "GDI32.DLL" ALIAS "GetSystemPaletteUse" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetTextCharacterExtra LIB "GDI32.DLL" ALIAS "GetTextCharacterExtra" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetTextAlign LIB "GDI32.DLL" ALIAS "GetTextAlign" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetTextColor LIB "GDI32.DLL" ALIAS "GetTextColor" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' COLORREF

DECLARE FUNCTION GetTextExtentPoint LIB "GDI32.DLL" ALIAS "GetTextExtentPointA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in_ecount(c) LPCSTR lpString
 , BYVAL LONG _                        ' __in int c
 , BYREF APISIZE _                     ' __out LPSIZE lpsz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTextExtentPointW LIB "GDI32.DLL" ALIAS "GetTextExtentPointW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_ecount(c) LPCWSTR lpString
 , BYVAL LONG _                        ' __in int c
 , BYREF APISIZE _                     ' __out LPSIZE lpsz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTextExtentPoint32 LIB "GDI32.DLL" ALIAS "GetTextExtentPoint32A" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in_ecount(c) LPCSTR lpString
 , BYVAL LONG _                        ' __in int c
 , BYREF APISIZE _                     ' __out LPSIZE psizl
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTextExtentPoint32W LIB "GDI32.DLL" ALIAS "GetTextExtentPoint32W" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_ecount(c) LPCWSTR lpString
 , BYVAL LONG _                        ' __in int c
 , BYREF APISIZE _                     ' __out LPSIZE psizl
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTextExtentExPoint LIB "GDI32.DLL" ALIAS "GetTextExtentExPointA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in_ecount(cchString) LPCSTR lpszString
 , BYVAL LONG _                        ' __in int cchString
 , BYVAL LONG _                        ' __in int nMaxExtent
 , BYREF LONG _                        ' __out_opt LPINT lpnFit
 , BYREF LONG _                        ' __out_ecount_part_opt (cchString, *lpnFit) LPINT lpnDx
 , BYREF APISIZE _                     ' __out LPSIZE lpSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTextExtentExPointW LIB "GDI32.DLL" ALIAS "GetTextExtentExPointW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_ecount(cchString) LPCWSTR lpszString
 , BYVAL LONG _                        ' __in int cchString
 , BYVAL LONG _                        ' __in int nMaxExtent
 , BYREF LONG _                        ' __out_opt LPINT lpnFit
 , BYREF LONG _                        ' __out_ecount_part_opt (cchString, *lpnFit) LPINT lpnDx
 , BYREF APISIZE _                     ' __out LPSIZE lpSize
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0400)
DECLARE FUNCTION GetTextCharset LIB "GDI32.DLL" ALIAS "GetTextCharset" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetTextCharsetInfo LIB "GDI32.DLL" ALIAS "GetTextCharsetInfo" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF FONTSIGNATURE _               ' __out_opt LPFONTSIGNATURE lpSig
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' int

DECLARE FUNCTION TranslateCharsetInfo LIB "GDI32.DLL" ALIAS "TranslateCharsetInfo" ( _
   BYREF DWORD _                       ' __inout DWORD FAR *lpSrc
 , BYREF CHARSETINFO _                 ' __out LPCHARSETINFO lpCs
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetFontLanguageInfo LIB "GDI32.DLL" ALIAS "GetFontLanguageInfo" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetCharacterPlacement LIB "GDI32.DLL" ALIAS "GetCharacterPlacementA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in_ecount(nCount) LPCSTR lpString
 , BYVAL LONG _                        ' __in int nCount
 , BYVAL LONG _                        ' __in int nMexExtent
 , BYREF GCP_RESULTSA _                ' __inout LPGCP_RESULTSA lpResults
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetCharacterPlacementW LIB "GDI32.DLL" ALIAS "GetCharacterPlacementW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_ecount(nCount) LPCWSTR lpString
 , BYVAL LONG _                        ' __in int nCount
 , BYVAL LONG _                        ' __in int nMexExtent
 , BYREF GCP_RESULTSW _                ' __inout LPGCP_RESULTSW lpResults
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' DWORD

'#if (_WIN32_WINNT >= 0x0500)

TYPE WCRANGE
   wcLow   AS WORD   ' WCHAR
   cGlyphs AS WORD   ' USHORT
END TYPE

TYPE GLYPHSET
   cbThis           AS DWORD     ' DWORD
   flAccel          AS DWORD     ' DWORD
   cGlyphsSupported AS DWORD     ' DWORD
   cRanges          AS DWORD     ' DWORD
   ranges(0)        AS WCRANGE   ' WCRANGE  ranges[1]
END TYPE

'/* flAccel flags for the GLYPHSET structure above */

%GS_8BIT_INDICES     = &H00000001???

'/* flags for GetGlyphIndices */

%GGI_MARK_NONEXISTING_GLYPHS  = &H0001???

DECLARE FUNCTION GetFontUnicodeRanges LIB "GDI32.DLL" ALIAS "GetFontUnicodeRanges" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ANY _                         ' __out_opt LPGLYPHSET lpgs
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetGlyphIndices LIB "GDI32.DLL" ALIAS "GetGlyphIndicesA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in_ecount(c) LPCSTR lpstr
 , BYVAL LONG _                        ' __in int c
 , BYREF WORD _                        ' __out_ecount(c) LPWORD pgi
 , BYVAL DWORD  _                      ' __in DWORD fl
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetGlyphIndicesW LIB "GDI32.DLL" ALIAS "GetGlyphIndicesW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_ecount(c) LPCWSTR lpstr
 , BYVAL LONG _                        ' __in int c
 , BYREF WORD _                        ' __out_ecount(c) LPWORD pgi
 , BYVAL DWORD _                       ' __in DWORD fl
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetTextExtentPointI LIB "GDI32.DLL" ALIAS "GetTextExtentPointI" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF WORD _                        ' __in_ecount(cgi) LPWORD pgiIn
 , BYVAL LONG _                        ' __in int cgi
 , BYREF SIZEL _                       ' __out LPSIZE psize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTextExtentExPointI LIB "GDI32.DLL" ALIAS "GetTextExtentExPointI" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF WORD _                        ' __in_ecount(cwchString) LPWORD lpwszString
 , BYVAL LONG _                        ' __in int cwchString
 , BYVAL LONG _                        ' __in int nMaxExtent
 , BYREF LONG _                        ' __out_opt LPINT lpnFit
 , BYREF LONG _                        ' __out_ecount_part_opt(cwchString, *lpnFit) LPINT lpnDx
 , BYREF APISIZE _                     ' __out LPSIZE lpSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharWidthI LIB "GDI32.DLL" ALIAS "GetCharWidthI" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT giFirst
 , BYVAL DWORD _                       ' __in UINT cgi
 , BYREF WORD _                        ' __in_ecount_opt(cgi) LPWORD pgi
 , BYREF LONG _                        ' __out_ecount(cgi) LPINT piWidths
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCharABCWidthsI LIB "GDI32.DLL" ALIAS "GetCharABCWidthsI" ( _
   BYVAL DWORD _                       ' __in HDC    hdc
 , BYVAL DWORD _                       ' __in UINT   giFirst
 , BYVAL DWORD _                       ' __in UINT   cgi
 , BYREF WORD _                        ' __in_ecount_opt(cgi) LPWORD pgi
 , BYREF ABC _                         ' __out_ecount(cgi) LPABC  pabc
 ) AS LONG                             ' BOOL

'#define STAMP_DESIGNVECTOR  (0x8000000 + 'd' + ('v' << 8))
'#define STAMP_AXESLIST      (0x8000000 + 'a' + ('l' << 8))
'#define MM_MAX_NUMAXES      16

%STAMP_DESIGNVECTOR = &H08007664   ' (0x8000000 + 'd' + ('v' << 8))
%STAMP_AXESLIST     = &H08006C61   ' (0x8000000 + 'a' + ('l' << 8))
%MM_MAX_NUMAXES     = 16

TYPE DESIGNVECTOR
  dvReserved AS DWORD                     ' DWORD
  dvNumAxes  AS DWORD                     ' DWORD
  dvValues(%MM_MAX_NUMAXES - 1) AS LONG   ' LONG   dvValues[MM_MAX_NUMAXES]
END TYPE

DECLARE FUNCTION AddFontResourceEx LIB "GDI32.DLL" ALIAS "AddFontResourceExA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR name
 , BYVAL DWORD _                       ' __in DWORD fl
 , BYVAL DWORD _                       ' __reserved PVOID res
 ) AS LONG                             ' int

DECLARE FUNCTION AddFontResourceExW LIB "GDI32.DLL" ALIAS "AddFontResourceExW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR name
 , BYVAL DWORD _                       ' __in DWORD fl
 , BYVAL DWORD _                       ' __reserved PVOID res
 ) AS LONG                             ' int

DECLARE FUNCTION RemoveFontResourceEx LIB "GDI32.DLL" ALIAS "RemoveFontResourceExA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR name
 , BYVAL DWORD _                       ' __in DWORD fl
 , BYVAL DWORD _                       ' __reserved PVOID pdv
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RemoveFontResourceExW LIB "GDI32.DLL" ALIAS "RemoveFontResourceExW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR name
 , BYVAL DWORD _                       ' __in DWORD fl
 , BYVAL DWORD _                       ' __reserved PVOID pdv
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AddFontMemResourceEx LIB "GDI32.DLL" ALIAS "AddFontMemResourceEx" ( _
   BYVAL DWORD _                       ' __in_bcount(cjSize) PVOID pFileView
 , BYVAL DWORD _                       ' __in DWORD cjSize
 , BYVAL DWORD _                       ' __reserved PVOID pvResrved
 , BYREF DWORD _                       ' __in DWORD* pNumFonts
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION RemoveFontMemResourceEx LIB "GDI32.DLL" ALIAS "RemoveFontMemResourceEx" ( _
   BYVAL DWORD _                       ' __in HANDLE h
 ) AS LONG                             ' BOOL

%FR_PRIVATE  = &H10
%FR_NOT_ENUM = &H20

'// The actual size of the DESIGNVECTOR and ENUMLOGFONTEXDV structures
'// is determined by dvNumAxes,
'// MM_MAX_NUMAXES only detemines the maximal size allowed

%MM_MAX_AXES_NAMELEN = 16

TYPE AXISINFOA
   axMinValue AS LONG                            ' LONG
   axMaxValue AS LONG                            ' LONG
   axAxisName AS ASCIIZ * %MM_MAX_AXES_NAMELEN   ' BYTE   axAxisName[MM_MAX_AXES_NAMELEN]
END TYPE

TYPE AXISINFOW
   axMinValue AS LONG                                ' LONG
   axMaxValue AS LONG                                ' LONG
   axAxisName AS STRING * %MM_MAX_AXES_NAMELEN * 2   ' WCHAR  axAxisName[MM_MAX_AXES_NAMELEN]
END TYPE

MACRO AXISINFO = AXISINFOA

TYPE AXESLISTA
   axlReserved AS DWORD                            ' DWORD
   axlNumAxes  AS DWORD                            ' DWORD
   axlAxisInfo (%MM_MAX_NUMAXES - 1) AS AXISINFO   ' AXISINFOA axlAxisInfo[MM_MAX_NUMAXES]
END TYPE

TYPE AXESLISTW
   axlReserved AS DWORD                             ' DWORD
   axlNumAxes  AS DWORD                             ' DWORD
   axlAxisInfo (%MM_MAX_NUMAXES - 1) AS AXISINFOW   ' AXISINFOW axlAxisInfo[MM_MAX_NUMAXES]
END TYPE

MACRO AXESLIST = AXESLISTA

'// The actual size of the AXESLIST and ENUMTEXTMETRIC structure is
'// determined by axlNumAxes,
'// MM_MAX_NUMAXES only detemines the maximal size allowed

TYPE ENUMLOGFONTEXDVA
   elfEnumLogfontEx AS ENUMLOGFONTEX
   elfDesignVector  AS DESIGNVECTOR
END TYPE

TYPE ENUMLOGFONTEXDVW
   elfEnumLogfontEx AS ENUMLOGFONTEXW
   elfDesignVector  AS DESIGNVECTOR
END TYPE

MACRO ENUMLOGFONTEXDV = ENUMLOGFONTEXDVA

DECLARE FUNCTION CreateFontIndirectEx LIB "GDI32.DLL" ALIAS "CreateFontIndirectExA" ( _
   BYREF ENUMLOGFONTEXDVA _            ' __in CONST ENUMLOGFONTEXDVA *
 ) AS DWORD                            ' HFONT

DECLARE FUNCTION CreateFontIndirectExW LIB "GDI32.DLL" ALIAS "CreateFontIndirectExW" ( _
   BYREF ENUMLOGFONTEXDVW _            ' __in CONST ENUMLOGFONTEXDVW *
 ) AS DWORD                            ' HFONT

#IF NOT %DEF(%NOTEXTMETRIC) ' -------------------------------------------------
'#ifndef NOTEXTMETRIC

TYPE ENUMTEXTMETRICA
   etmNewTextMetricEx AS NEWTEXTMETRICEX
   etmAxesList        AS AXESLIST
END TYPE

TYPE ENUMTEXTMETRICW
   etmNewTextMetricEx AS NEWTEXTMETRICEXW
   etmAxesList        AS AXESLISTW
END TYPE

MACRO ENUMTEXTMETRIC = ENUMTEXTMETRICA

'#endif /* NOTEXTMETRIC */
#ENDIF   ' #IF NOT %DEF(%NOTEXTMETRIC) ----------------------------------------

'#endif // (_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION GetViewportExtEx LIB "GDI32.DLL" ALIAS "GetViewportExtEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF APISIZE _                     ' __out LPSIZE lpsize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetViewportOrgEx LIB "GDI32.DLL" ALIAS "GetViewportOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __out LPPOINT lppoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetWindowExtEx LIB "GDI32.DLL" ALIAS "GetWindowExtEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF APISIZE _                     ' __out LPSIZE lpsize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetWindowOrgEx LIB "GDI32.DLL" ALIAS "GetWindowOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __out LPPOINT lppoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IntersectClipRect LIB "GDI32.DLL" ALIAS "IntersectClipRect" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int left
 , BYVAL LONG _                        ' __in int top
 , BYVAL LONG _                        ' __in int right
 , BYVAL LONG _                        ' __in int bottom
 ) AS LONG                             ' int

DECLARE FUNCTION InvertRgn LIB "GDI32.DLL" ALIAS "InvertRgn" ( _
   BYVAL DWORD  _                      ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HRGN hrgn
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LineDDA LIB "GDI32.DLL" ALIAS "LineDDA" ( _
   BYVAL LONG _                        ' __in int xStart
 , BYVAL LONG _                        ' __in int yStart
 , BYVAL LONG _                        ' __in int xEnd
 , BYVAL LONG _                        ' __in int yEnd
 , BYVAL DWORD _                       ' __in LINEDDAPROC lpProc
 , BYVAL LONG _                        ' __in_opt LPARAM data
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LineTo LIB "GDI32.DLL" ALIAS "LineTo" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MaskBlt LIB "GDI32.DLL" ALIAS "MaskBlt" ( _
   BYVAL DWORD _                       ' __in HDC hdcDest
 , BYVAL LONG _                        ' __in int xDest
 , BYVAL LONG _                        ' __in int yDest
 , BYVAL LONG _                        ' __in int width
 , BYVAL LONG _                        ' __in int height
 , BYVAL DWORD _                       ' __in HDC hdcSrc
 , BYVAL LONG _                        ' __in int xSrc
 , BYVAL LONG _                        ' __in int ySrc
 , BYVAL DWORD _                       ' __in HBITMAP hbmMask
 , BYVAL LONG _                        ' __in int xMask
 , BYVAL LONG _                        ' __in int yMask
 , BYVAL DWORD _                       ' __in DWORD rop
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PlgBlt LIB "GDI32.DLL" ALIAS "PlgBlt" ( _
   BYVAL DWORD _                       ' __in HDC hdcDest
 , BYREF POINTAPI _                    ' __in_ecount(3) CONST POINT * lpPoint
 , BYVAL DWORD _                       ' __in HDC hdcSrc
 , BYVAL LONG _                        ' __in int xSrc
 , BYVAL LONG _                        ' __in int ySrc
 , BYVAL LONG _                        ' __in int width
 , BYVAL LONG _                        ' __in int height
 , BYVAL DWORD _                       ' __in_opt HBITMAP hbmMask
 , BYVAL LONG _                        ' __in int xMask
 , BYVAL LONG _                        ' __in int yMask
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OffsetClipRgn LIB "GDI32.DLL" ALIAS "OffsetClipRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 ) AS LONG                             ' int

DECLARE FUNCTION OffsetRgn LIB "GDI32.DLL" ALIAS "OffsetRgn" ( _
   BYVAL DWORD _                       ' __in HRGN hrgn
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 ) AS LONG                             ' int

DECLARE FUNCTION PatBlt LIB "GDI32.DLL" ALIAS "PatBlt" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL LONG _                        ' __in int w
 , BYVAL LONG _                        ' __in int h
 , BYVAL DWORD _                       ' __in DWORD rop
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Pie LIB "GDI32.DLL" ALIAS "Pie" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int left
 , BYVAL LONG _                        ' __in int top
 , BYVAL LONG _                        ' __in int right
 , BYVAL LONG _                        ' __in int bottom
 , BYVAL LONG _                        ' __in int xr1
 , BYVAL LONG _                        ' __in int yr1
 , BYVAL LONG _                        ' __in int xr2
 , BYVAL LONG _                        ' __in int yr2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PlayMetaFile LIB "GDI32.DLL" ALIAS "PlayMetaFile" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HMETAFILE hmf
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PaintRgn LIB "GDI32.DLL" ALIAS "PaintRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HRGN hrgn
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PolyPolygon LIB "GDI32.DLL" ALIAS "PolyPolygon" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __in CONST POINT *apt
 , BYREF LONG _                        ' __in_ecount(csz) CONST INT *asz
 , BYVAL LONG _                        ' __in int csz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PtInRegion LIB "GDI32.DLL" ALIAS "PtInRegion" ( _
   BYVAL DWORD _                       ' __in HRGN hrgn
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PtVisible LIB "GDI32.DLL" ALIAS "PtVisible" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RectInRegion LIB "GDI32.DLL" ALIAS "RectInRegion" ( _
   BYVAL DWORD _                       ' __in HRGN hrgn
 , BYREF RECT _                        ' __in CONST RECT * lprect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RectVisible LIB "GDI32.DLL" ALIAS "RectVisible" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF RECT _                        ' __in CONST RECT * lprect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Rectangle LIB "GDI32.DLL" ALIAS "Rectangle" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int left
 , BYVAL LONG _                        ' __in int top
 , BYVAL LONG _                        ' __in int right
 , BYVAL LONG _                        ' __in int bottom
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RestoreDC LIB "GDI32.DLL" ALIAS "RestoreDC" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int nSavedDC
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ResetDC LIB "GDI32.DLL" ALIAS "ResetDCA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF DEVMODEA _                    ' __in CONST DEVMODEA * lpdm
 ) AS DWORD                            ' HDC

DECLARE FUNCTION ResetDCW LIB "GDI32.DLL" ALIAS "ResetDCW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF DEVMODEW _                    ' __in CONST DEVMODEW * lpdm
 ) AS DWORD                            ' HDC

DECLARE FUNCTION RealizePalette LIB "GDI32.DLL" ALIAS "RealizePalette" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' UINT

DECLARE FUNCTION RemoveFontResource LIB "GDI32.DLL" ALIAS "RemoveFontResourceA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RemoveFontResourceW LIB "GDI32.DLL" ALIAS "RemoveFontResourceW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RoundRect LIB "GDI32.DLL" ALIAS "RoundRect" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int left
 , BYVAL LONG _                        ' __in int top
 , BYVAL LONG _                        ' __in int right
 , BYVAL LONG _                        ' __in int bottom
 , BYVAL LONG _                        ' __in int width
 , BYVAL LONG _                        ' __in int height
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ResizePalette LIB "GDI32.DLL" ALIAS "ResizePalette" ( _
   BYVAL DWORD _                       ' __in HPALETTE hpal
 , BYVAL DWORD _                       ' __in UINT n
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SaveDC LIB "GDI32.DLL" ALIAS "SaveDC" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION SelectClipRgn LIB "GDI32.DLL" ALIAS "SelectClipRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_opt HRGN hrgn
 ) AS LONG                             ' int

DECLARE FUNCTION ExtSelectClipRgn LIB "GDI32.DLL" ALIAS "ExtSelectClipRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_opt HRGN hrgn
 , BYVAL LONG _                        ' __in int mode
 ) AS LONG                             ' int

DECLARE FUNCTION SetMetaRgn LIB "GDI32.DLL" ALIAS "SetMetaRgn" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HGDIOBJ h
 ) AS DWORD                            ' HGDIOBJ

DECLARE FUNCTION SelectPalette LIB "GDI32.DLL" ALIAS "SelectPalette" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HPALETTE hPal
 , BYVAL LONG _                        ' __in BOOL bForceBkgd
 ) AS DWORD                            ' HPALETTE

DECLARE FUNCTION SetBkColor LIB "GDI32.DLL" ALIAS "SetBkColor" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' COLORREF

'#if (_WIN32_WINNT >= 0x0500)
DECLARE FUNCTION SetDCBrushColor LIB "GDI32.DLL" ALIAS "SetDCBrushColor" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' COLORREF

DECLARE FUNCTION SetDCPenColor LIB "GDI32.DLL" ALIAS "SetDCPenColor" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' COLORREF
'#endif

DECLARE FUNCTION SetBkMode LIB "GDI32.DLL" ALIAS "SetBkMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int mode
 ) AS LONG                             ' int

DECLARE FUNCTION SetBitmapBits LIB "GDI32.DLL" ALIAS "SetBitmapBits" ( _
   BYVAL DWORD _                       ' __in HBITMAP hbm
 , BYVAL DWORD _                       ' __in DWORD cb
 , BYREF ANY _                         ' __in_bcount(cb) CONST VOID *pvBits
 ) AS LONG                             ' LONG

DECLARE FUNCTION SetBoundsRect LIB "GDI32.DLL" ALIAS "SetBoundsRect" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF RECT _                        ' __in_opt CONST RECT * lprect
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetDIBits LIB "GDI32.DLL" ALIAS "SetDIBits" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HBITMAP hbm
 , BYVAL DWORD _                       ' __in UINT start
 , BYVAL DWORD _                       ' __in UINT cLines
 , BYREF ANY _                         ' __in CONST VOID *lpBits
 , BYREF BITMAPINFO _                  ' __in CONST BITMAPINFO * lpbmi
 , BYVAL DWORD _                       ' __in UINT ColorUse
 ) AS LONG                             ' int

DECLARE FUNCTION SetDIBitsToDevice LIB "GDI32.DLL" ALIAS "SetDIBitsToDevice" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int xDest
 , BYVAL LONG _                        ' __in int yDest
 , BYVAL DWORD _                       ' __in DWORD w
 , BYVAL DWORD _                       ' __in DWORD h
 , BYVAL LONG _                        ' __in int xSrc
 , BYVAL LONG _                        ' __in int ySrc
 , BYVAL DWORD _                       ' __in UINT StartScan
 , BYVAL DWORD _                       ' __in UINT cLines
 , BYREF ANY _                         ' __in CONST VOID * lpvBits
 , BYREF BITMAPINFO _                  ' __in CONST BITMAPINFO * lpbmi
 , BYVAL DWORD _                       ' __in UINT ColorUse
 ) AS LONG                             ' int

DECLARE FUNCTION SetMapperFlags LIB "GDI32.DLL" ALIAS "SetMapperFlags" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in DWORD flags
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetGraphicsMode LIB "GDI32.DLL" ALIAS "SetGraphicsMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int iMode
 ) AS LONG                             ' int

DECLARE FUNCTION SetMapMode LIB "GDI32.DLL" ALIAS "SetMapMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int iMode
 ) AS LONG                             ' int

'#if(WINVER >= 0x0500)
DECLARE FUNCTION SetLayout LIB "GDI32.DLL" ALIAS "SetLayout" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in DWORD l
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetLayout LIB "GDI32.DLL" ALIAS "GetLayout" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' DWORD
'#endif /* WINVER >= 0x0500 */

DECLARE FUNCTION SetMetaFileBitsEx LIB "GDI32.DLL" ALIAS "SetMetaFileBitsEx" ( _
   BYVAL DWORD _                       ' __in UINT cbBuffer
 , BYREF BYTE _                        ' __in_bcount(cbBuffer) CONST BYTE *lpData
 ) AS DWORD                            ' HMETAFILE

DECLARE FUNCTION SetPaletteEntries LIB "GDI32.DLL" ALIAS "SetPaletteEntries" ( _
   BYVAL DWORD _                       ' __in HPALETTE hpal
 , BYVAL DWORD _                       ' __in UINT iStart
 , BYVAL DWORD _                       ' __in UINT cEntries
 , BYREF PALETTEENTRY _                ' __in_ecount(cEntries) CONST PALETTEENTRY *pPalEntries)
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetPixel LIB "GDI32.DLL" ALIAS "SetPixel" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' COLORREF

DECLARE FUNCTION SetPixelV LIB "GDI32.DLL" ALIAS "SetPixelV" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetPixelFormat LIB "GDI32.DLL" ALIAS "SetPixelFormat" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int format
 , BYREF PIXELFORMATDESCRIPTOR _       ' __in CONST PIXELFORMATDESCRIPTOR * ppfd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetPolyFillMode LIB "GDI32.DLL" ALIAS "SetPolyFillMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int mode
 ) AS LONG                             ' int

DECLARE FUNCTION StretchBlt LIB "GDI32.DLL" ALIAS "StretchBlt" ( _
   BYVAL DWORD _                       ' __in HDC hdcDest
 , BYVAL LONG _                        ' __in int xDest
 , BYVAL LONG _                        ' __in int yDest
 , BYVAL LONG _                        ' __in int wDest
 , BYVAL LONG _                        ' __in int hDest
 , BYVAL DWORD _                       ' __in HDC hdcSrc
 , BYVAL LONG _                        ' __in int xSrc
 , BYVAL LONG _                        ' __in int ySrc
 , BYVAL LONG _                        ' __in int wSrc
 , BYVAL LONG _                        ' __in int hSrc
 , BYVAL DWORD _                       ' __in DWORD rop
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetRectRgn LIB "GDI32.DLL" ALIAS "SetRectRgn" ( _
   BYVAL DWORD _                       ' __in HRGN hrgn
 , BYVAL LONG _                        ' __in int left
 , BYVAL LONG _                        ' __in int top
 , BYVAL LONG _                        ' __in int right
 , BYVAL LONG _                        ' __in int bottom
 ) AS LONG                             ' BOOL

DECLARE FUNCTION StretchDIBits LIB "GDI32.DLL" ALIAS "StretchDIBits" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int xDest
 , BYVAL LONG _                        ' __in int yDest
 , BYVAL LONG _                        ' __in int DestWidth
 , BYVAL LONG _                        ' __in int DestHeight
 , BYVAL LONG _                        ' __in int xSrc
 , BYVAL LONG _                        ' __in int ySrc
 , BYVAL LONG _                        ' __in int SrcWidth
 , BYVAL LONG _                        ' __in int SrcHeight
 , BYREF ANY _                         ' __in CONST VOID * lpBits
 , BYREF BITMAPINFO _                  ' __in CONST BITMAPINFO * lpbmi
 , BYVAL DWORD _                       ' __in UINT iUsage
 , BYVAL DWORD _                       ' __in DWORD rop
 ) AS LONG                             ' int

DECLARE FUNCTION SetROP2 LIB "GDI32.DLL" ALIAS "SetROP2" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int rop2
 ) AS LONG                             ' int

DECLARE FUNCTION SetStretchBltMode LIB "GDI32.DLL" ALIAS "SetStretchBltMode" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int mode)
 ) AS LONG                             ' int

DECLARE FUNCTION SetSystemPaletteUse LIB "GDI32.DLL" ALIAS "SetSystemPaletteUse" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT use
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetTextCharacterExtra LIB "GDI32.DLL" ALIAS "SetTextCharacterExtra" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int extra
 ) AS LONG                             ' int

DECLARE FUNCTION SetTextColor LIB "GDI32.DLL" ALIAS "SetTextColor" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in COLORREF color
 ) AS DWORD                            ' COLORREF

DECLARE FUNCTION SetTextAlign LIB "GDI32.DLL" ALIAS "SetTextAlign" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT align
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetTextJustification LIB "GDI32.DLL" ALIAS "SetTextJustification" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int extra
 , BYVAL LONG _                        ' __in int count
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UpdateColors LIB "GDI32.DLL" ALIAS "UpdateColors" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

'#if (WINVER >= 0x0400)

'#ifdef  COMBOX_SANDBOX

'#if (_WIN32_WINNT >= 0x0600)

'typedef PVOID   (WINAPI *GDIMARSHALLOC)(DWORD dwSize, __in LPVOID pGdiRef);

'typedef HRESULT (WINAPI *DDRAWMARSHCALLBACKMARSHAL)(__in HGDIOBJ hGdiObj, __in LPVOID pGdiRef, __out LPVOID *ppDDrawRef);
'typedef HRESULT (WINAPI *DDRAWMARSHCALLBACKUNMARSHAL)(__in LPVOID pData, __out HDC *phdc, __out LPVOID *ppDDrawRef);
'typedef HRESULT (WINAPI *DDRAWMARSHCALLBACKRELEASE)(__in LPVOID pDDrawRef);

%GDIREGISTERDDRAWPACKETVERSION   = &H1

TYPE GDIREGISTERDDRAWPACKET
   dwSize         AS DWORD   ' DWORD
   dwVersion      AS DWORD   ' DWORD
   pfnDdMarshal   AS DWORD   ' DDRAWMARSHCALLBACKMARSHAL
   pfnDdUnmarshal AS DWORD   ' DDRAWMARSHCALLBACKUNMARSHAL
   pfnDdRelease   AS DWORD   ' DDRAWMARSHCALLBACKRELEASE
END TYPE

'WINGDIAPI BOOL    WINAPI   GdiRegisterDdraw(__in PGDIREGISTERDDRAWPACKET pPacket, __out GDIMARSHALLOC *ppfnGdiAlloc);

'WINGDIAPI ULONG   WINAPI   GdiMarshalSize(VOID);
'WINGDIAPI VOID    WINAPI   GdiMarshal(DWORD dwProcessIdTo, __in HGDIOBJ hGdiObj, __inout PVOID pData, ULONG ulFlags);
'WINGDIAPI HGDIOBJ WINAPI   GdiUnmarshal(__in PVOID pData, ULONG ulFlags);

'#endif // (_WIN32_WINNT >= 0x0600)

'#endif  // COMBOX_SANDBOX

'#if (WINVER >= 0x0400)

'//
'// image blt
'//

'typedef USHORT COLOR16;

TYPE TRIVERTEX
   x     AS LONG   ' LONG
   y     AS LONG   ' LONG
   Red   AS WORD   ' COLOR16
   Green AS WORD   ' COLOR16
   Blue  AS WORD   ' COLOR16
   Alpha AS WORD   ' COLOR16
END TYPE

TYPE GRADIENT_TRIANGLE
   Vertex1 AS DWORD   ' ULONG
   Vertex2 AS DWORD   ' ULONG
   Vertex3 AS DWORD   ' ULONG
END TYPE

TYPE GRADIENT_RECT
   UpperLeft  AS DWORD   ' ULONG
   LowerRight AS DWORD   ' ULONG
END TYPE

TYPE BLENDFUNCTION
   BlendOp             AS BYTE
   BlendFlags          AS BYTE
   SourceConstantAlpha AS BYTE
   AlphaFormat         AS BYTE
END TYPE

'//
'// currentlly defined blend function
'//

%AC_SRC_OVER             = &H00

'//
'// alpha format flags
'//

%AC_SRC_ALPHA            = &H01

' Note: The last parameter is declared as DWORD in PB's WIN32API.INC
' because eralier versions of PB couldn't pass an structure by value.
' This forced the use of CVDWD to convert the four byte structure in a DWORD.
DECLARE FUNCTION AlphaBlend LIB "MSIMG32.DLL" ALIAS "AlphaBlend" ( _
   BYVAL DWORD _                       ' __in HDC hdcDest
 , BYVAL LONG _                        ' __in int xoriginDest
 , BYVAL LONG _                        ' __in int yoriginDest
 , BYVAL LONG _                        ' __in int wDest
 , BYVAL LONG _                        ' __in int hDest
 , BYVAL DWORD _                       ' __in HDC hdcSrc
 , BYVAL LONG _                        ' __in int xoriginSrc
 , BYVAL LONG _                        ' __in int yoriginSrc
 , BYVAL LONG _                        ' __in int wSrc
 , BYVAL LONG _                        ' __in int hSrc
 , BYVAL BLENDFUNCTION _               ' __in BLENDFUNCTION ftn
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TransparentBlt LIB "MSIMG32.DLL" ALIAS "TransparentBlt" ( _
   BYVAL DWORD _                       ' __in HDC hdcDest
 , BYVAL LONG _                        ' __in int xoriginDest
 , BYVAL LONG _                        ' __in int yoriginDest
 , BYVAL LONG _                        ' __in int wDest
 , BYVAL DWORD _                       ' __in int hDest
 , BYVAL DWORD _                       ' __in HDC hdcSrc
 , BYVAL LONG _                        ' __in int xoriginSrc
 , BYVAL LONG _                        ' __in int yoriginSrc
 , BYVAL LONG _                        ' __in int wSrc
 , BYVAL LONG _                        ' __in int hSrc
 , BYVAL DWORD _                       ' __in UINT crTransparent
 ) AS LONG                             ' BOOL

'//
'// gradient drawing modes
'//

%GRADIENT_FILL_RECT_H   = &H00000000???
%GRADIENT_FILL_RECT_V   = &H00000001???
%GRADIENT_FILL_TRIANGLE = &H00000002???
%GRADIENT_FILL_OP_FLAG  = &H000000ff???

DECLARE FUNCTION GradientFill LIB "MSIMG32.DLL" ALIAS "GradientFill" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF TRIVERTEX _                   ' __in_ecount(nVertex) PTRIVERTEX pVertex
 , BYVAL DWORD _                       ' __in ULONG nVertex
 , BYREF ANY _                         ' __in PVOID pMesh
 , BYVAL DWORD _                       ' __in ULONG nMesh
 , BYVAL DWORD _                       ' __in ULONG ulMode
 ) AS LONG                             ' BOOL

'#endif

'#if (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)


'WINGDIAPI BOOL  WINAPI GdiAlphaBlend(__in HDC hdcDest, __in int xoriginDest, __in int yoriginDest, __in int wDest, __in int hDest, __in HDC hdcSrc, __in int xoriginSrc, __in int yoriginSrc, __in int wSrc, __in int hSrc, __in BLENDFUNCTION ftn);
DECLARE FUNCTION GdiAlphaBlend LIB "GDI32.DLL" ALIAS "GdiAlphaBlend" ( _
   BYVAL DWORD _                       ' __in HDC hdcDest
 , BYVAL LONG _                        ' __in int xoriginDest
 , BYVAL LONG _                        ' __in int yoriginDest
 , BYVAL LONG _                        ' __in int wDest
 , BYVAL LONG _                        ' __in int hDest
 , BYVAL DWORD _                       ' __in HDC hdcSrc
 , BYVAL LONG _                        ' __in int xoriginSrc
 , BYVAL LONG _                        ' __in int yoriginSrc
 , BYVAL LONG _                        ' __in int wSrc
 , BYVAL LONG _                        ' __in int hSrc
 , BYVAL BLENDFUNCTION _               ' __in BLENDFUNCTION ftn
 ) AS LONG                             ' BOOL

'WINGDIAPI BOOL  WINAPI GdiTransparentBlt(__in HDC hdcDest,__in int xoriginDest, __in int yoriginDest, __in int wDest, __in int hDest, __in HDC hdcSrc,
'                                           __in int xoriginSrc, __in int yoriginSrc, __in int wSrc, __in int hSrc, __in UINT crTransparent);
DECLARE FUNCTION GdiTransparentBlt LIB "GDI32.DLL" ALIAS "GdiTransparentBlt" ( _
   BYVAL DWORD _                       ' __in HDC hdcDest
 , BYVAL LONG _                        ' __in int xoriginDest
 , BYVAL LONG _                        ' __in int yoriginDest
 , BYVAL LONG _                        ' __in int wDest
 , BYVAL DWORD _                       ' __in int hDest
 , BYVAL DWORD _                       ' __in HDC hdcSrc
 , BYVAL LONG _                        ' __in int xoriginSrc
 , BYVAL LONG _                        ' __in int yoriginSrc
 , BYVAL LONG _                        ' __in int wSrc
 , BYVAL LONG _                        ' __in int hSrc
 , BYVAL DWORD _                       ' __in UINT crTransparent
 ) AS LONG                             ' BOOL

'WINGDIAPI BOOL  WINAPI GdiGradientFill( __in HDC hdc,
'                                        __in_ecount(nVertex) PTRIVERTEX pVertex,
'                                        __in ULONG nVertex,
'                                        __in PVOID pMesh,
'                                        __in ULONG nCount,
'                                        __in ULONG ulMode);
DECLARE FUNCTION GdiGradientFill LIB "GDI32.DLL" ALIAS "GdiGradientFill" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF TRIVERTEX _                   ' __in_ecount(nVertex) PTRIVERTEX pVertex
 , BYVAL DWORD _                       ' __in ULONG nVertex
 , BYREF ANY _                         ' __in PVOID pMesh
 , BYVAL DWORD _                       ' __in ULONG nMesh
 , BYVAL DWORD _                       ' __in ULONG ulMode
 ) AS LONG                             ' BOOL

'#endif

#IF NOT %DEF(%NOMETAFILE) ' ---------------------------------------------------
'#ifndef NOMETAFILE

DECLARE FUNCTION PlayMetaFileRecord LIB "GDI32.DLL" ALIAS "PlayMetaFileRecord" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF HANDLETABLE _                 ' __in_ecount(noObjs) LPHANDLETABLE lpHandleTable
 , BYREF METARECORD _                  ' __in LPMETARECORD lpMR
 , BYVAL DWORD _                       ' __in UINT noObjs
 ) AS LONG                             ' BOOL

'typedef int (CALLBACK* MFENUMPROC)( __in HDC hdc, __in_ecount(nObj) HANDLETABLE FAR* lpht, __in METARECORD FAR* lpMR, __in int nObj, __in_opt LPARAM param);

DECLARE FUNCTION EnumMetaFile LIB "GDI32.DLL" ALIAS "EnumMetaFile" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HMETAFILE hmf
 , BYVAL DWORD _                       ' __in MFENUMPROC proc
 , BYVAL LONG _                        ' __in_opt LPARAM param
 ) AS LONG                             ' BOOL

'typedef int (CALLBACK* ENHMFENUMPROC)(__in HDC hdc, __in_ecount(nHandles) HANDLETABLE FAR* lpht, __in CONST ENHMETARECORD * lpmr, __in int hHandles, __in_opt LPARAM data);

'// Enhanced Metafile Function Declarations

DECLARE FUNCTION CloseEnhMetaFile LIB "GDI32.DLL" ALIAS "CloseEnhMetaFile" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' HENHMETAFILE

DECLARE FUNCTION CopyEnhMetaFile LIB "GDI32.DLL" ALIAS "CopyEnhMetaFileA" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hEnh
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpFileName
 ) AS DWORD                            ' HENHMETAFILE

DECLARE FUNCTION CopyEnhMetaFileW LIB "GDI32.DLL" ALIAS "CopyEnhMetaFileW" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hEnh
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpFileName
 ) AS DWORD                            ' HENHMETAFILE

DECLARE FUNCTION CreateEnhMetaFile LIB "GDI32.DLL" ALIAS "CreateEnhMetaFileA" ( _
   BYVAL DWORD _                       ' __in_opt HDC hdc
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpFilename
 , BYREF RECT _                        ' __in_opt CONST RECT *lprc
 , BYREF ASCIIZ _                      ' _in_opt LPCSTR lpDesc
 ) AS DWORD                            ' HDC

DECLARE FUNCTION CreateEnhMetaFileW LIB "GDI32.DLL" ALIAS "CreateEnhMetaFileW" ( _
   BYVAL DWORD _                       ' __in_opt HDC hdc
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpFilename
 , BYREF RECT _                        ' __in_opt CONST RECT *lprc
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpDesc
 ) AS DWORD                            ' HDC

DECLARE FUNCTION DeleteEnhMetaFile LIB "GDI32.DLL" ALIAS "DeleteEnhMetaFile" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hmf
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumEnhMetaFile LIB "GDI32.DLL" ALIAS "EnumEnhMetaFile" ( _
   BYVAL DWORD _                       ' __in_opt HDC hdc
 , BYVAL DWORD _                       ' __in HENHMETAFILE hmf
 , BYVAL DWORD _                       ' __in ENHMFENUMPROC proc
 , BYREF ANY _                         ' __in_opt LPVOID param
 , BYREF RECT _                        ' __in_opt CONST RECT * lpRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetEnhMetaFile LIB "GDI32.DLL" ALIAS "GetEnhMetaFileA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpName
 ) AS DWORD                            ' HENHMETAFILE

DECLARE FUNCTION GetEnhMetaFileW LIB "GDI32.DLL" ALIAS "GetEnhMetaFileW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpName
 ) AS DWORD                            ' HENHMETAFILE

DECLARE FUNCTION GetEnhMetaFileBits LIB "GDI32.DLL" ALIAS "GetEnhMetaFileBits" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hEMF
 , BYVAL DWORD _                       ' __in UINT nSize
 , BYREF BYTE _                        ' __out_bcount_opt(nSize) LPBYTE lpData
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetEnhMetaFileDescription LIB "GDI32.DLL" ALIAS "GetEnhMetaFileDescriptionA" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hemf
 , BYVAL DWORD _                       ' __in UINT cchBuffer
 , BYREF ASCIIZ _                      ' __out_ecount_opt(cchBuffer
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetEnhMetaFileDescriptionW LIB "GDI32.DLL" ALIAS "GetEnhMetaFileDescriptionW" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hemf
 , BYVAL DWORD _                       ' __in UINT cchBuffer
 , BYREF ANY _                         ' __out_ecount_opt(cchBuffer)
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetEnhMetaFileHeader LIB "GDI32.DLL" ALIAS "GetEnhMetaFileHeader" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hemf
 , BYVAL DWORD _                       ' __in UINT nSize
 , BYREF ENHMETAHEADER _               ' __out_bcount_opt(nSize) LPENHMETAHEADER lpEnhMetaHeader
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetEnhMetaFilePaletteEntries LIB "GDI32.DLL" ALIAS "GetEnhMetaFilePaletteEntries" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hemf
 , BYVAL DWORD _                       ' __in UINT nNumEntries
 , BYREF PALETTEENTRY _                ' __out_ecount_opt(nNumEntries) LPPALETTEENTRY lpPaletteEntries
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetEnhMetaFilePixelFormat LIB "GDI32.DLL" ALIAS "GetEnhMetaFilePixelFormat" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hemf
 , BYVAL DWORD _                       ' __in UINT cbBuffer
 , BYREF PIXELFORMATDESCRIPTOR _       ' __out_bcount_opt(cbBuffer) PIXELFORMATDESCRIPTOR *ppfd
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetWinMetaFileBits LIB "GDI32.DLL" ALIAS "GetWinMetaFileBits" ( _
   BYVAL DWORD _                       ' __in HENHMETAFILE hemf
 , BYVAL DWORD _                       ' __in UINT cbData16
 , BYREF BYTE _                        ' __out_bcount_opt(cbData16) LPBYTE pData16
 , BYVAL LONG _                        ' __in INT iMapMode
 , BYVAL DWORD _                       ' __in HDC hdcRef
 ) AS DWORD                            ' UINT

DECLARE FUNCTION PlayEnhMetaFile LIB "GDI32.DLL" ALIAS "PlayEnhMetaFile" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HENHMETAFILE hmf
 , BYREF RECT _                        ' __in CONST RECT * lprect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PlayEnhMetaFileRecord LIB "GDI32.DLL" ALIAS "PlayEnhMetaFileRecord" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF HANDLETABLE _                 ' __in_ecount(cht) LPHANDLETABLE pht
 , BYREF ENHMETARECORD _               ' __in CONST ENHMETARECORD *pmr
 , BYVAL DWORD _                       ' __in UINT cht
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetEnhMetaFileBits LIB "GDI32.DLL" ALIAS "SetEnhMetaFileBits" ( _
   BYVAL DWORD _                       ' __in UINT nSize
 , BYREF BYTE _                        ' __in_bcount(nSize) CONST BYTE * pb
 ) AS DWORD                            ' HENHMETAFILE

DECLARE FUNCTION SetWinMetaFileBits LIB "GDI32.DLL" ALIAS "SetWinMetaFileBits" ( _
   BYVAL DWORD _                       ' __in UINT nSize
 , BYREF BYTE _                        ' __in_bcount(nSize) CONST BYTE *lpMeta16Data
 , BYVAL DWORD _                       ' __in_opt HDC hdcRef,
 , BYREF METAFILEPICT _                ' __in_opt CONST METAFILEPICT *lpMFP
 ) AS DWORD                            ' HENHMETAFILE

DECLARE FUNCTION GdiComment LIB "GDI32.DLL" ALIAS "GdiComment" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in UINT nSize
 , BYREF BYTE _                        ' __in_bcount(nSize) CONST BYTE *lpData
 ) AS LONG                             ' BOOL

'#endif  /* NOMETAFILE */
#ENDIF   ' #IF NOT %DEF(%NOMETAFILE) ------------------------------------------

#IF NOT %DEF(%NOTEXTMETRIC) ' -------------------------------------------------
'#ifndef NOTEXTMETRIC

DECLARE FUNCTION GetTextMetrics LIB "GDI32.DLL" ALIAS "GetTextMetricsA" ( _
   BYVAL hdc AS DWORD _                ' __in HDC hdc
 , BYREF lpMetrics AS TEXTMETRICA _    ' __out LPTEXTMETRICA lptm
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTextMetricsW LIB "GDI32.DLL" ALIAS "GetTextMetricsW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF TEXTMETRICW _                 ' __out LPTEXTMETRICW lptm
 ) AS LONG                             ' BOOL

#ENDIF   ' #IF NOT %DEF(%NOTEXTMETRIC) ' --------------------------------------

'/* new GDI */

TYPE DIBSECTION
  dsBm           AS BITMAP
  dsBmih         AS BITMAPINFOHEADER
  dsBitfields(2) AS DWORD   ' DWORD  dsBitfields[3]
  dshSection     AS DWORD   ' HANDLE
  dsOffset       AS DWORD
END TYPE

DECLARE FUNCTION AngleArc LIB "GDI32.DLL" ALIAS "AngleArc" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in DWORD r
 , BYVAL SINGLE _                      ' __in FLOAT StartAngle
 , BYVAL SINGLE _                      ' __in FLOAT SweepAngle
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PolyPolyline LIB "GDI32.DLL" ALIAS "PolyPolyline" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __in CONST POINT *apt
 , BYREF DWORD _                       ' __in_ecount(csz) CONST DWORD *asz
 , BYVAL DWORD _                       ' __in DWORD csz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetWorldTransform LIB "GDI32.DLL" ALIAS "GetWorldTransform" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF XFORM _                       ' __out LPXFORM lpxf
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetWorldTransform LIB "GDI32.DLL" ALIAS "SetWorldTransform" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF XFORM _                       ' __in CONST XFORM * lpxf
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ModifyWorldTransform LIB "GDI32.DLL" ALIAS "ModifyWorldTransform" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF XFORM _                       ' __in_opt CONST XFORM * lpxf
 , BYVAL DWORD _                       ' __in DWORD mode
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CombineTransform LIB "GDI32.DLL" ALIAS "CombineTransform" ( _
   BYREF XFORM _                       ' __out LPXFORM lpxfOut
 , BYREF XFORM _                       ' __in CONST XFORM *lpxf1
 , BYREF XFORM _                       ' __in CONST XFORM *lpxf2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateDIBSection LIB "GDI32.DLL" ALIAS "CreateDIBSection" ( _
   BYVAL DWORD _                       ' __in_opt HDC hdc
 , BYREF BITMAPINFO _                  ' __in CONST BITMAPINFO *lpbmi
 , BYVAL DWORD _                       ' __in UINT usage
 , BYVAL DWORD _                       ' __deref_opt_out VOID **ppvBits
 , BYVAL DWORD _                       ' __in_opt HANDLE hSection
 , BYVAL DWORD _                       ' __in DWORD offset)
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION GetDIBColorTable LIB "GDI32.DLL" ALIAS "GetDIBColorTable" ( _
   BYVAL DWORD _                       ' __in HDC  hdc
 , BYVAL DWORD _                       ' __in UINT iStart
 , BYVAL DWORD _                       ' __in UINT cEntries
 , BYREF RGBQUAD _                     ' __out_ecount(cEntries) RGBQUAD *prgbq
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetDIBColorTable LIB "GDI32.DLL" ALIAS "SetDIBColorTable" ( _
   BYVAL DWORD _                       ' __in HDC  hdc
 , BYVAL DWORD _                       ' __in UINT iStart
 , BYVAL DWORD _                       ' __in UINT cEntries
 , BYREF RGBQUAD _                     ' __in_ecount(cEntries) CONST RGBQUAD *prgbq
 ) AS DWORD                            ' UINT

'/* Flags value for COLORADJUSTMENT */
%CA_NEGATIVE   = &H0001??
%CA_LOG_FILTER = &H0002??

'/* IlluminantIndex values */
%ILLUMINANT_DEVICE_DEFAULT = 0
%ILLUMINANT_A              = 1
%ILLUMINANT_B              = 2
%ILLUMINANT_C              = 3
%ILLUMINANT_D50            = 4
%ILLUMINANT_D55            = 5
%ILLUMINANT_D65            = 6
%ILLUMINANT_D75            = 7
%ILLUMINANT_F2             = 8
%ILLUMINANT_MAX_INDEX      = %ILLUMINANT_F2

%ILLUMINANT_TUNGSTEN       = %ILLUMINANT_A
%ILLUMINANT_DAYLIGHT       = %ILLUMINANT_C
%ILLUMINANT_FLUORESCENT    = %ILLUMINANT_F2
%ILLUMINANT_NTSC           = %ILLUMINANT_C

'/* Min and max for RedGamma, GreenGamma, BlueGamma */
'#define RGB_GAMMA_MIN               (WORD)02500
'#define RGB_GAMMA_MAX               (WORD)65000

%RGB_GAMMA_MIN = 2500??
%RGB_GAMMA_MAX = 65000??

'/* Min and max for ReferenceBlack and ReferenceWhite */
'#define REFERENCE_WHITE_MIN         (WORD)6000
'#define REFERENCE_WHITE_MAX         (WORD)10000
'#define REFERENCE_BLACK_MIN         (WORD)0
'#define REFERENCE_BLACK_MAX         (WORD)4000

%REFERENCE_WHITE_MIN = 6000??
%REFERENCE_WHITE_MAX = 10000??
%REFERENCE_BLACK_MIN = 0??
%REFERENCE_BLACK_MAX = 4000??

'/* Min and max for Contrast, Brightness, Colorfulness, RedGreenTint */
'#define COLOR_ADJ_MIN               (SHORT)-100
'#define COLOR_ADJ_MAX               (SHORT)100

%COLOR_ADJ_MIN = -100%
%COLOR_ADJ_MAX = 100%

TYPE COLORADJUSTMENT
   caSize            AS WORD
   caFlags           AS WORD
   caIlluminantIndex AS WORD
   caRedGamma        AS WORD
   caGreenGamma      AS WORD
   caBlueGamma       AS WORD
   caReferenceBlack  AS WORD
   caReferenceWhite  AS WORD
   caContrast        AS INTEGER   ' SHORT
   caBrightness      AS INTEGER   ' SHORT
   caColorfulness    AS INTEGER   ' SHORT
   caRedGreenTint    AS INTEGER   ' SHORT
END TYPE

DECLARE FUNCTION SetColorAdjustment LIB "GDI32.DLL" ALIAS "SetColorAdjustment" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF COLORADJUSTMENT _             ' __in CONST COLORADJUSTMENT *lpca
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetColorAdjustment LIB "GDI32.DLL" ALIAS "GetColorAdjustment" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF COLORADJUSTMENT _             ' __out LPCOLORADJUSTMENT lpca
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateHalftonePalette LIB "GDI32.DLL" ALIAS "CreateHalftonePalette" ( _
   BYVAL DWORD _                       ' __in_opt HDC hdc
 ) AS DWORD                            ' HPALETTE

'#ifdef STRICT
'typedef BOOL (CALLBACK* ABORTPROC)( __in HDC, __in int);
'#else
'typedef FARPROC ABORTPROC;
'#endif

TYPE DOCINFOA
   cbSize       AS LONG         ' int
   lpszDocName  AS ASCIIZ PTR   ' LPCSTR
   lpszOutput   AS ASCIIZ PTR   ' LPCSTR
'#if (WINVER >= 0x0400)
   lpszDataType AS ASCIIZ PTR   ' LPCSTR
   fwType       AS DWORD        ' DWORD
'#endif /* WINVER */
END TYPE

TYPE DOCINFOW
   cbSize       AS LONG       ' int
   lpszDocName  AS WORD PTR   ' LPCWSTR
   lpszOutput   AS WORD PTR   ' LPCWSTR
'#if (WINVER >= 0x0400)
   lpszDataType AS WORD PTR   ' LPCWSTR
   fwType       AS DWORD      ' DWORD
'#endif /* WINVER */
END TYPE

MACRO DOCINFO = DOCINFOA

'#if(WINVER >= 0x0400)
%DI_APPBANDING            = &H00000001???
%DI_ROPS_READ_DESTINATION = &H00000002???
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION StartDoc LIB "GDI32.DLL" ALIAS "StartDocA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF DOCINFOA _                    ' __in CONST DOCINFOA *lpdi
 ) AS LONG                             ' int

DECLARE FUNCTION StartDocW LIB "GDI32.DLL" ALIAS "StartDocW" ( _
   BYVAL DWORD _                       ' __in HDC hdc,
 , BYREF DOCINFOW _                    ' __in CONST DOCINFOW *lpdi
 ) AS LONG                             ' int

DECLARE FUNCTION EndDoc LIB "GDI32.DLL" ALIAS "EndDoc" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION StartPage LIB "GDI32.DLL" ALIAS "StartPage" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION EndPage LIB "GDI32.DLL" ALIAS "EndPage" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION AbortDoc LIB "GDI32.DLL" ALIAS "AbortDoc" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION SetAbortProc LIB "GDI32.DLL" ALIAS "SetAbortProc" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in ABORTPROC proc
 ) AS LONG                             ' int

DECLARE FUNCTION AbortPath LIB "GDI32.DLL" ALIAS "AbortPath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ArcTo LIB "GDI32.DLL" ALIAS "ArcTo" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int left
 , BYVAL LONG _                        ' __in int top
 , BYVAL LONG _                        ' __in int right
 , BYVAL LONG _                        ' __in int bottom
 , BYVAL LONG _                        ' __in int xr1
 , BYVAL LONG _                        ' __in int yr1
 , BYVAL LONG _                        ' __in int xr2
 , BYVAL LONG _                        ' __in int yr2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BeginPath LIB "GDI32.DLL" ALIAS "BeginPath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CloseFigure LIB "GDI32.DLL" ALIAS "CloseFigure" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EndPath LIB "GDI32.DLL" ALIAS "EndPath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FillPath LIB "GDI32.DLL" ALIAS "FillPath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FlattenPath LIB "GDI32.DLL" ALIAS "FlattenPath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetPath LIB "GDI32.DLL" ALIAS "GetPath" ( _
   BYVAL DWORD _                       ' _in HDC hdc
 , BYREF POINTAPI _                    ' __out_ecount(cpt) LPPOINT apt
 , BYREF BYTE _                        ' __out_ecount(cpt) LPBYTE aj
 , BYVAL DWORD _                       ' int cpt
 ) AS LONG                             ' int

DECLARE FUNCTION PathToRegion LIB "GDI32.DLL" ALIAS "PathToRegion" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION PolyDraw LIB "GDI32.DLL" ALIAS "PolyDraw" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __in_ecount(cpt) CONST POINT * apt
 , BYREF BYTE _                        ' __in_ecount(cpt) CONST BYTE * aj
 , BYVAL LONG _                        ' __in int cpt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SelectClipPath LIB "GDI32.DLL" ALIAS "SelectClipPath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int mode
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetArcDirection LIB "GDI32.DLL" ALIAS "SetArcDirection" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int dir
 ) AS LONG                             ' int

DECLARE FUNCTION SetMiterLimit LIB "GDI32.DLL" ALIAS "SetMiterLimit" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL SINGLE  _                     ' __in FLOAT limit
 , BYREF SINGLE _                      ' __out_opt PFLOAT old
 ) AS LONG                             ' BOOL

DECLARE FUNCTION StrokeAndFillPath LIB "GDI32.DLL" ALIAS "StrokeAndFillPath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION StrokePath LIB "GDI32.DLL" ALIAS "StrokePath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WidenPath LIB "GDI32.DLL" ALIAS "WidenPath" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ExtCreatePen LIB "GDI32.DLL" ALIAS "ExtCreatePen" ( _
   BYVAL DWORD _                       ' __in DWORD iPenStyle
 , BYVAL DWORD _                       ' __in DWORD cWidth
 , BYREF LOGBRUSH _                    ' __in CONST LOGBRUSH *plbrush
 , BYVAL DWORD _                       ' __in DWORD cStyle
 , BYREF DWORD _                       ' __in_ecount_opt(cStyle) CONST DWORD *pstyle
 ) AS DWORD                            ' HPEN

DECLARE FUNCTION GetMiterLimit LIB "GDI32.DLL" ALIAS "GetMiterLimit" ( _
   BYVAL DWORD  _                      ' __in HDC hdc
 , BYREF SINGLE _                      ' __out PFLOAT plimit
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetArcDirection LIB "GDI32.DLL" ALIAS "GetArcDirection" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' int

DECLARE FUNCTION GetObject LIB "GDI32.DLL" ALIAS "GetObjectA" ( _
   BYVAL DWORD _                       ' __in HANDLE h
 , BYVAL LONG _                        ' __in int c
 , BYREF ANY _                         ' __out_bcount_opt(c) LPVOID pv
 ) AS LONG                             ' int

DECLARE FUNCTION GetObjectW LIB "GDI32.DLL" ALIAS "GetObjectW" ( _
   BYVAL DWORD _                       ' __in HANDLE h
 , BYVAL LONG _                        ' __in int c
 , BYREF ANY _                         ' __out_bcount_opt(c) LPVOID pv
 ) AS LONG                             ' int

DECLARE FUNCTION MoveToEx LIB "GDI32.DLL" ALIAS "MoveToEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF POINTAPI _                    ' __out_opt LPPOINT lppt
 ) AS LONG                             ' BOOL

'   FUNCTION MoveTo (BYVAL hDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
'      FUNCTION = MoveToEx(hDC, x, y, BYVAL %NULL)
'   END FUNCTION

DECLARE FUNCTION TextOut LIB "GDI32.DLL" ALIAS "TextOutA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF ASCIIZ  _                     ' __in_ecount(c) LPCSTR lpString
 , BYVAL LONG _                        ' __in int c
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TextOutW LIB "GDI32.DLL" ALIAS "TextOutW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in_ecount(c) LPCWSTR lpString
 , BYVAL LONG _                        ' __in int c
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ExtTextOut LIB "GDI32.DLL" ALIAS "ExtTextOutA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in UINT options
 , BYREF RECT _                        ' __in_opt CONST RECT * lprect
 , BYREF ASCIIZ _                      ' __in_ecount(c) LPCSTR lpString
 , BYVAL DWORD _                       ' __in UINT c
 , BYREF LONG _                        ' __in_ecount_opt(c) CONST INT * lpDx
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ExtTextOutW LIB "GDI32.DLL" ALIAS "ExtTextOutW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in UINT options
 , BYREF RECT _                        ' __in_opt CONST RECT * lprect
 , BYVAL DWORD _                       ' __in_ecount(c) LPCWSTR lpString
 , BYVAL DWORD _                       ' __in UINT c
 , BYREF LONG _                        ' __in_ecount_opt(c) CONST INT * lpDx
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PolyTextOut LIB "GDI32.DLL" ALIAS "PolyTextOutA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POLYTEXT _                    ' __in_ecount(nstrings) CONST POLYTEXTA * ppt
 , BYREF LONG _                        ' __in int nstrings
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PolyTextOutW LIB "GDI32.DLL" ALIAS "PolyTextOutW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POLYTEXT _                    ' __in_ecount(nstrings) CONST POLYTEXTW * ppt
 , BYREF LONG _                        ' __in int nstrings
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreatePolygonRgn LIB "GDI32.DLL" ALIAS "CreatePolygonRgn" ( _
   BYREF POINTAPI _                    ' __in_ecount(cPoint) CONST POINT *pptl
 , BYVAL LONG _                        ' __in int cPoint
 , BYVAL LONG _                        ' __in int iMode
 ) AS DWORD                            ' HRGN

DECLARE FUNCTION DPtoLP LIB "GDI32.DLL" ALIAS "DPtoLP" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __inout_ecount(c) LPPOINT lppt
 , BYVAL LONG _                        ' __in int c
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LPtoDP LIB "GDI32.DLL" ALIAS "LPtoDP" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __inout_ecount(c) LPPOINT lppt
 , BYVAL LONG _                        ' __in int c
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Polygon LIB "GDI32.DLL" ALIAS "Polygon" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __in_ecount(cpt) CONST POINT *apt
 , BYVAL LONG _                        ' __in int cpt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION Polyline LIB "GDI32.DLL" ALIAS "Polyline" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __in_ecount(cpt) CONST POINT *apt
 , BYVAL LONG _                        ' __in int cpt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PolyBezier LIB "GDI32.DLL" ALIAS "PolyBezier" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __in_ecount(cpt) CONST POINT * apt
 , BYVAL DWORD _                       ' __in DWORD cpt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PolyBezierTo LIB "GDI32.DLL" ALIAS "PolyBezierTo" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __in_ecount(cpt) CONST POINT * apt
 , BYVAL DWORD _                       ' __in DWORD cpt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PolylineTo LIB "GDI32.DLL" ALIAS "PolylineTo" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __in_ecount(cpt) CONST POINT * apt
 , BYVAL DWORD _                       ' __in DWORD cpt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetViewportExtEx LIB "GDI32.DLL" ALIAS "SetViewportExtEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF APISIZE _                     ' __out_opt LPSIZE lpsz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetViewportOrgEx LIB "GDI32.DLL" ALIAS "SetViewportOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF POINTAPI _                    ' __out_opt LPPOINT lppt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetWindowExtEx LIB "GDI32.DLL" ALIAS "SetWindowExtEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF APISIZE _                     ' __out_opt LPSIZE lpsz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetWindowOrgEx LIB "GDI32.DLL" ALIAS "SetWindowOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF POINTAPI _                    ' __out_opt LPPOINT lppt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OffsetViewportOrgEx LIB "GDI32.DLL" ALIAS "OffsetViewportOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF POINTAPI _                    ' __out_opt LPPOINT lppt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OffsetWindowOrgEx LIB "GDI32.DLL" ALIAS "OffsetWindowOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF POINTAPI _                    ' __out_opt LPPOINT lppt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ScaleViewportExtEx LIB "GDI32.DLL" ALIAS "ScaleViewportExtEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int xn
 , BYVAL LONG _                        ' __in int dx
 , BYVAL LONG _                        ' __in int yn
 , BYVAL LONG _                        ' __in int yd
 , BYREF APISIZE _                     ' __out_opt LPSIZE lpsz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ScaleWindowExtEx LIB "GDI32.DLL" ALIAS "ScaleWindowExtEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int xn
 , BYVAL LONG _                        ' __in int xd
 , BYVAL LONG _                        ' __in int yn
 , BYVAL LONG _                        ' __in int yd
 , BYREF APISIZE _                     ' __out_opt LPSIZE lpsz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetBitmapDimensionEx LIB "GDI32.DLL" ALIAS "SetBitmapDimensionEx" ( _
   BYVAL DWORD _                       ' __in HBITMAP hbm
 , BYVAL LONG _                        ' __in int w
 , BYVAL LONG _                        ' __in int h
 , BYREF APISIZE _                     ' __out_opt LPSIZE lpsz
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetBrushOrgEx LIB "GDI32.DLL" ALIAS "SetBrushOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF POINTAPI _                    ' __out_opt LPPOINT lppt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetTextFace LIB "GDI32.DLL" ALIAS "GetTextFaceA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int c
 , BYREF ASCIIZ _                      ' __out_ecount_part_opt(c, return)  LPSTR lpName
 ) AS LONG                             ' int

DECLARE FUNCTION GetTextFaceW LIB "GDI32.DLL" ALIAS "GetTextFaceW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int c
 , BYVAL DWORD _                       ' __out_ecount_part_opt(c, return)  LPWSTR lpName
 ) AS LONG                             ' int

%FONTMAPPER_MAX = 10

TYPE KERNINGPAIR
   wFirst      AS WORD   ' WORD
   wSecond     AS WORD   ' WORD
   iKernAmount AS LONG   ' int
END TYPE

DECLARE FUNCTION GetKerningPairs LIB "GDI32.DLL" ALIAS "GetKerningPairsA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in DWORD nPairs
 , BYREF KERNINGPAIR _                 ' __out_ecount_part_opt(nPairs, return) LPKERNINGPAIR   lpKernPair
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetKerningPairsW LIB "GDI32.DLL" ALIAS "GetKerningPairsW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in DWORD nPairs
 , BYREF KERNINGPAIR _                 ' __out_ecount_part_opt(nPairs, return) LPKERNINGPAIR   lpKernPair
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetDCOrgEx LIB "GDI32.DLL" ALIAS "GetDCOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF POINTAPI _                    ' __out LPPOINT lppt
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FixBrushOrgEx LIB "GDI32.DLL" ALIAS "FixBrushOrgEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF POINTAPI _                    ' __in_opt LPPOINT ptl
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UnrealizeObject LIB "GDI32.DLL" ALIAS "UnrealizeObject" ( _
   BYVAL DWORD _                       ' __in HGDIOBJ h
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GdiFlush LIB "GDI32.DLL" ALIAS "GdiFlush" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GdiSetBatchLimit LIB "GDI32.DLL" ALIAS "GdiSetBatchLimit" ( _
   BYVAL DWORD _                       ' __in DWORD dw
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GdiGetBatchLimit LIB "GDI32.DLL" ALIAS "GdiGetBatchLimit" ( _
 ) AS DWORD                            ' DWORD

'#if(WINVER >= 0x0400)

%ICM_OFF            = 1
%ICM_ON             = 2
%ICM_QUERY          = 3
%ICM_DONE_OUTSIDEDC = 4

'typedef int (CALLBACK* ICMENUMPROCA)(LPSTR, LPARAM);
'typedef int (CALLBACK* ICMENUMPROCW)(LPWSTR, LPARAM);

DECLARE FUNCTION SetICMMode LIB "GDI32.DLL" ALIAS "SetICMMode" ( _
   BYVAL DWORD  _                      ' __in HDC hdc
 , BYVAL LONG _                        ' __in int mode
 ) AS LONG                             ' int

DECLARE FUNCTION CheckColorsInGamut LIB "GDI32.DLL" ALIAS "CheckColorsInGamut" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF RGBTRIPLE _                   ' __in_ecount(nCount) __typefix(LPRGBTRIPLE) LPVOID lpRGBTriple
 , BYREF ANY _                         ' __out_bcount(nCount) LPVOID dlpBuffer
 , BYVAL DWORD _                       ' __in DWORD nCount
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetColorSpace LIB "GDI32.DLL" ALIAS "GetColorSpace" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS DWORD                            ' HCOLORSPACE

DECLARE FUNCTION GetLogColorSpace LIB "GDI32.DLL" ALIAS "GetLogColorSpaceA" ( _
   BYVAL DWORD _                       ' __in HCOLORSPACE hColorSpace
 , BYREF LOGCOLORSPACEA _              ' __out_bcount(nSize) LPLOGCOLORSPACEA lpBuffer
 , BYVAL DWORD _                       ' __in DWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetLogColorSpaceW LIB "GDI32.DLL" ALIAS "GetLogColorSpaceW" ( _
   BYVAL DWORD _                       ' __in HCOLORSPACE hColorSpace
 , BYREF LOGCOLORSPACEW _              ' __out_bcount(nSize) LPLOGCOLORSPACEW lpBuffer
 , BYVAL DWORD _                       ' _in DWORD nSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CreateColorSpace LIB "GDI32.DLL" ALIAS "CreateColorSpaceA" ( _
   BYREF LOGCOLORSPACEA _              ' __in LPLOGCOLORSPACEA lplcs
 ) AS DWORD                            ' HCOLORSPACE

DECLARE FUNCTION CreateColorSpaceW LIB "GDI32.DLL" ALIAS "CreateColorSpaceW" ( _
   BYREF LOGCOLORSPACEW _              ' __in LPLOGCOLORSPACEW lplcs
 ) AS DWORD                            ' HCOLORSPACE

DECLARE FUNCTION SetColorSpace LIB "GDI32.DLL" ALIAS "SetColorSpace" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HCOLORSPACE hcs
 ) AS DWORD                            ' HCOLORSPACE

DECLARE FUNCTION DeleteColorSpace LIB "GDI32.DLL" ALIAS "DeleteColorSpace" ( _
   BYVAL DWORD _                       ' __in HCOLORSPACE hcs
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetICMProfile LIB "GDI32.DLL" ALIAS "GetICMProfileA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __inout LPDWORD pBufSize
 , BYREF ASCIIZ _                      ' __out_ecount_opt(*pBufSize) LPSTR pszFilename
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetICMProfileW LIB "GDI32.DLL" ALIAS "GetICMProfileW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __inout LPDWORD pBufSize
 , BYREF ANY _                         ' __out_ecount_opt(*pBufSize) LPWSTR pszFilename
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetICMProfile LIB "GDI32.DLL" ALIAS "SetICMProfileA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in LPSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetICMProfileW LIB "GDI32.DLL" ALIAS "SetICMProfileW" ( _
   BYVAL DWORD  _                      ' __in HDC hdc
 , BYVAL DWORD _                       ' __in LPWSTR lpFileName
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDeviceGammaRamp LIB "GDI32.DLL" ALIAS "GetDeviceGammaRamp" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ANY _                         ' __out_bcount(3*256*2) LPVOID lpRamp
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetDeviceGammaRamp LIB "GDI32.DLL" ALIAS "SetDeviceGammaRamp" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ANY _                         ' __in_bcount(3*256*2)  LPVOID lpRamp
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ColorMatchToTarget LIB "GDI32.DLL" ALIAS "ColorMatchToTarget" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD  _                      ' __in HDC hdcTarget
 , BYVAL DWORD _                       ' __in DWORD action
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumICMProfiles LIB "GDI32.DLL" ALIAS "EnumICMProfilesA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in ICMENUMPROCA proc
 , BYVAL LONG _                        ' __in_opt LPARAM param
 ) AS LONG                             ' int

DECLARE FUNCTION EnumICMProfilesW LIB "GDI32.DLL" ALIAS "EnumICMProfilesW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in ICMENUMPROCW proc
 , BYVAL LONG _                        ' __in_opt LPARAM param
 ) AS LONG                             ' int

DECLARE FUNCTION UpdateICMRegKey LIB "GDI32.DLL" ALIAS "UpdateICMRegKeyA" ( _
   BYVAL DWORD _                       ' __reserved DWORD reserved
 , BYREF ASCIIZ _                      ' __in LPSTR lpszCMID
 , BYREF ASCIIZ _                      ' __in LPSTR lpszFileName
 , BYVAL DWORD _                       ' __in UINT command
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UpdateICMRegKeyW LIB "GDI32.DLL" ALIAS "UpdateICMRegKeyW" ( _
   BYVAL DWORD _                       ' __reserved DWORD reserved
 , BYVAL DWORD _                       ' __in LPSTR lpszCMID
 , BYVAL DWORD _                       ' __in LPSTR lpszFileName
 , BYVAL DWORD _                       ' __in UINT command
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0400 */

'#if (WINVER >= 0x0500)
DECLARE FUNCTION ColorCorrectPalette LIB "GDI32.DLL" ALIAS "ColorCorrectPalette" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in HPALETTE hPal
 , BYVAL DWORD _                       ' __in DWORD deFirst
 , BYVAL DWORD _                       ' __in DWORD num
 ) AS LONG                             ' LONG
'#endif

#IF NOT %DEF(%NOMETAFILE) ' ---------------------------------------------------
'#ifndef NOMETAFILE

'// Enhanced metafile constants.

'#ifndef _MAC
'#define ENHMETA_SIGNATURE       0x464D4520
%ENHMETA_SIGNATURE = &H464D4520
'#else
'#define ENHMETA_SIGNATURE       0x20454D46
'#endif

'// Stock object flag used in the object handle index in the enhanced
'// metafile records.
'// E.g. The object handle index (META_STOCK_OBJECT | BLACK_BRUSH)
'// represents the stock object BLACK_BRUSH.

%ENHMETA_STOCK_OBJECT = &H80000000???

'// Enhanced metafile record types.

%EMR_HEADER                  = 1
%EMR_POLYBEZIER              = 2
%EMR_POLYGON                 = 3
%EMR_POLYLINE                = 4
%EMR_POLYBEZIERTO            = 5
%EMR_POLYLINETO              = 6
%EMR_POLYPOLYLINE            = 7
%EMR_POLYPOLYGON             = 8
%EMR_SETWINDOWEXTEX          = 9
%EMR_SETWINDOWORGEX          = 10
%EMR_SETVIEWPORTEXTEX        = 11
%EMR_SETVIEWPORTORGEX        = 12
%EMR_SETBRUSHORGEX           = 13
%EMR_EOF                     = 14
%EMR_SETPIXELV               = 15
%EMR_SETMAPPERFLAGS          = 16
%EMR_SETMAPMODE              = 17
%EMR_SETBKMODE               = 18
%EMR_SETPOLYFILLMODE         = 19
%EMR_SETROP2                 = 20
%EMR_SETSTRETCHBLTMODE       = 21
%EMR_SETTEXTALIGN            = 22
%EMR_SETCOLORADJUSTMENT      = 23
%EMR_SETTEXTCOLOR            = 24
%EMR_SETBKCOLOR              = 25
%EMR_OFFSETCLIPRGN           = 26
%EMR_MOVETOEX                = 27
%EMR_SETMETARGN              = 28
%EMR_EXCLUDECLIPRECT         = 29
%EMR_INTERSECTCLIPRECT       = 30
%EMR_SCALEVIEWPORTEXTEX      = 31
%EMR_SCALEWINDOWEXTEX        = 32
%EMR_SAVEDC                  = 33
%EMR_RESTOREDC               = 34
%EMR_SETWORLDTRANSFORM       = 35
%EMR_MODIFYWORLDTRANSFORM    = 36
%EMR_SELECTOBJECT            = 37
%EMR_CREATEPEN               = 38
%EMR_CREATEBRUSHINDIRECT     = 39
%EMR_DELETEOBJECT            = 40
%EMR_ANGLEARC                = 41
%EMR_ELLIPSE                 = 42
%EMR_RECTANGLE               = 43
%EMR_ROUNDRECT               = 44
%EMR_ARC                     = 45
%EMR_CHORD                   = 46
%EMR_PIE                     = 47
%EMR_SELECTPALETTE           = 48
%EMR_CREATEPALETTE           = 49
%EMR_SETPALETTEENTRIES       = 50
%EMR_RESIZEPALETTE           = 51
%EMR_REALIZEPALETTE          = 52
%EMR_EXTFLOODFILL            = 53
%EMR_LINETO                  = 54
%EMR_ARCTO                   = 55
%EMR_POLYDRAW                = 56
%EMR_SETARCDIRECTION         = 57
%EMR_SETMITERLIMIT           = 58
%EMR_BEGINPATH               = 59
%EMR_ENDPATH                 = 60
%EMR_CLOSEFIGURE             = 61
%EMR_FILLPATH                = 62
%EMR_STROKEANDFILLPATH       = 63
%EMR_STROKEPATH              = 64
%EMR_FLATTENPATH             = 65
%EMR_WIDENPATH               = 66
%EMR_SELECTCLIPPATH          = 67
%EMR_ABORTPATH               = 68

%EMR_GDICOMMENT              = 70
%EMR_FILLRGN                 = 71
%EMR_FRAMERGN                = 72
%EMR_INVERTRGN               = 73
%EMR_PAINTRGN                = 74
%EMR_EXTSELECTCLIPRGN        = 75
%EMR_BITBLT                  = 76
%EMR_STRETCHBLT              = 77
%EMR_MASKBLT                 = 78
%EMR_PLGBLT                  = 79
%EMR_SETDIBITSTODEVICE       = 80
%EMR_STRETCHDIBITS           = 81
%EMR_EXTCREATEFONTINDIRECTW  = 82
%EMR_EXTTEXTOUTA             = 83
%EMR_EXTTEXTOUTW             = 84
%EMR_POLYBEZIER16            = 85
%EMR_POLYGON16               = 86
%EMR_POLYLINE16              = 87
%EMR_POLYBEZIERTO16          = 88
%EMR_POLYLINETO16            = 89
%EMR_POLYPOLYLINE16          = 90
%EMR_POLYPOLYGON16           = 91
%EMR_POLYDRAW16              = 92
%EMR_CREATEMONOBRUSH         = 93
%EMR_CREATEDIBPATTERNBRUSHPT = 94
%EMR_EXTCREATEPEN            = 95
%EMR_POLYTEXTOUTA            = 96
%EMR_POLYTEXTOUTW            = 97

'#if(WINVER >= 0x0400)
%EMR_SETICMMODE              = 98
%EMR_CREATECOLORSPACE        = 99
%EMR_SETCOLORSPACE           = 100
%EMR_DELETECOLORSPACE        = 101
%EMR_GLSRECORD               = 102
%EMR_GLSBOUNDEDRECORD        = 103
%EMR_PIXELFORMAT             = 104
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
%EMR_DRAWESCAPE              = 105
%EMR_EXTESCAPE               = 106
%EMR_STARTDOC                = 107
%EMR_SMALLTEXTOUT            = 108
%EMR_FORCEUFIMAPPING         = 109
%EMR_NAMEDESCAPE             = 110
%EMR_COLORCORRECTPALETTE     = 111
%EMR_SETICMPROFILEA          = 112
%EMR_SETICMPROFILEW          = 113
%EMR_ALPHABLEND              = 114
%EMR_ALPHADIBBLEND           = 115
%EMR_TRANSPARENTBLT          = 116
'#if (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)
%EMR_TRANSPARENTDIB          = 117
'#endif // (_WIN32_WINNT >= _WIN32_WINNT_WIN2K)
%EMR_GRADIENTFILL            = 118
%EMR_SETLINKEDUFIS           = 119
%EMR_SETTEXTJUSTIFICATION    = 120
%EMR_COLORMATCHTOTARGETW     = 121
%EMR_CREATECOLORSPACEW       = 122
'#endif /* WINVER >= 0x0500 */

%EMR_MIN                     = 1

'#if (WINVER >= 0x0500)
'#define EMR_MAX                        122
'#elif (WINVER >= 0x0400)
'#define EMR_MAX                        104
'#else
'#define EMR_MAX                         97
'#endif

%EMR_MAX                     = 122 ' depending on Windows version, may be 97, 104, or 120 (so far)

'// Base record type for the enhanced metafile.

TYPE EMR
   iType AS DWORD  ' DWORD // Enhanced metafile record type
   nSize AS DWORD  ' DWORD // Length of the record in bytes. Must be a multiple of 4.
END TYPE

'// Base text record type for the enhanced metafile.

TYPE EMRTEXT
   ptlReference AS POINTL
   nChars       AS DWORD
   offString    AS DWORD
   fOptions     AS DWORD
   rcl          AS RECTL
   offDx        AS DWORD
END TYPE

'// Record structures for the enhanced metafile.

TYPE EMRABORTPATH
   emr AS EMR
END TYPE

TYPE EMRBEGINPATH
   emr AS EMR
END TYPE

TYPE EMRENDPATH
   emr AS EMR
END TYPE

TYPE EMRCLOSEFIGURE
   emr AS EMR
END TYPE

TYPE EMRFLATTENPATH
   emr AS EMR
END TYPE

TYPE EMRWIDENPATH
   emr AS EMR
END TYPE

TYPE EMRSETMETARGN
   emr AS EMR
END TYPE

TYPE EMREMRSAVEDC
   emr AS EMR
END TYPE

TYPE EMRREALIZEPALETTE
   emr AS EMR
END TYPE

TYPE EMRSELECTCLIPPATH
   emr   AS EMR
   iMode AS DWORD
END TYPE

TYPE EMRSETBKMODE
   emr   AS EMR
   iMode AS DWORD
END TYPE

TYPE EMRSETMAPMODE
   emr   AS EMR
   iMode AS DWORD
END TYPE

TYPE EMRSETPOLYFILLMODE
   emr   AS EMR
   iMode AS DWORD
END TYPE

TYPE EMRSETROP2
   emr   AS EMR
   iMode AS DWORD
END TYPE

TYPE EMRSETSTRETCHBLTMODE
   emr   AS EMR
   iMode AS DWORD
END TYPE

TYPE EMRSETTEXTALIGN
   emr   AS EMR
   iMode AS DWORD
END TYPE

TYPE EMRSETMITERLIMIT
   emr         AS EMR
   eMiterLimit AS SINGLE
END TYPE

TYPE EMRRESTOREDC
   er        AS EMR
   iRelative AS LONG   ' Specifies a relative instance
END TYPE

TYPE EMRSETARCDIRECTION
   emr           AS EMR
   iArcDirection AS DWORD ' Specifies the arc direction in the advanced graphics mode
END TYPE

TYPE EMRSETMAPPERFLAGS
   er      AS EMR
   dwFlags AS DWORD
END TYPE

TYPE EMRSETTEXTCOLOR
   emr     AS EMR
   crColor AS DWORD
END TYPE

MACRO EMRSETBKCOLOR = EMRSETTEXTCOLOR

TYPE EMRSELECTOBJECT
   emr      AS EMR
   ihObject AS DWORD  ' Object handle index
END TYPE

MACRO EMRDELETEOBJECT = EMRSELECTOBJECT

TYPE EMRSELECTPALETTE
   emr   AS EMR
   ihPal AS DWORD    ' Palette handle index, background mode only
END TYPE

TYPE EMRRESIZEPALETTE
   emr      AS EMR
   ihPal    AS DWORD    ' Palette handle index
   cEntries AS DWORD
END TYPE

TYPE EMRSETPALETTEENTRIES
   emr            AS EMR
   ihPal          AS DWORD         ' // Palette handle index
   iStart         AS DWORD
   cEntries       AS DWORD
   aPalEntries(0) AS PALETTEENTRY  ' PALETTEENTRY aPalEntries[1];// The peFlags fields do not contain any flags
END TYPE

TYPE EMRSETCOLORADJUSTMENT
   emr             AS EMR
   ColorAdjustment AS ColorAdjustment
END TYPE

TYPE EMRGDICOMMENT
   emr      AS EMR
   cbData   AS DWORD   ' // Size of data in bytes
   xData(0) AS BYTE    ' BYTE    Data[1]
END TYPE

TYPE EMREOF
   emr           AS EMR
   nPalEntries   AS DWORD   ' Number of palette entries
   offPalEntries AS DWORD   ' Offset to the palette entries
   nSizeLast     AS DWORD   ' Same as nSize and must be the last DWORD
                            ' of the record. The palette entries, if they
                            ' exist, precede this field.
END TYPE

TYPE EMRLINETO
   emr AS EMR
   ptl AS POINTL
END TYPE

MACRO EMRMOVETOEX = EMRLINETO

TYPE EMROFFSETCLIPRGN
   emr       AS EMR
   ptlOffset AS POINTL
END TYPE

TYPE EMRFILLPATH
   emr       AS EMR
   rclBounds AS RECTL    ' inclusive-inclusive bounds in device units
END TYPE

MACRO EMRSTROKEANDFILLPATH = EMRFILLPATH
MACRO EMRSTROKEPATH = EMRFILLPATH

TYPE EMREXCLUDECLIPRECT
   emr     AS EMR
   rclClip AS RECTL
END TYPE

MACRO EMRINTERSECTCLIPRECT = EMREXCLUDECLIPRECT

TYPE EMRSETVIEWPORTORGEX
   emr       AS EMR
   ptlOrigin AS POINTL
END TYPE

MACRO EMRSETWINDOWORGEX = EMRSETVIEWPORTORGEX
MACRO EMRSETBRUSHORGEX = EMRSETVIEWPORTORGEX

TYPE EMRSETVIEWPORTEXTEX
   emr       AS EMR
   szlExtent AS SIZEL
END TYPE

MACRO EMRSETWINDOWEXTEX = EMRSETVIEWPORTEXTEX

TYPE EMRSCALEVIEWPORTEXTEX
   emr    AS EMR
   xNum   AS LONG
   xDenom AS LONG
   yNum   AS LONG
   yDemon AS LONG
END TYPE

MACRO EMRSCALEWINDOWEXTEX = EMRSCALEVIEWPORTEXTEX

TYPE EMRSETWORLDTRANSFORM
   emr   AS EMR
   xform AS XFORM
END TYPE

TYPE EMRMODIFYWORLDTRANSFORM
   emr   AS EMR
   xform AS XFORM
   iMode AS DWORD
END TYPE

TYPE EMRSETPIXELV
   emr      AS EMR
   ptlPixel AS POINTL
   crColor  AS DWORD
END TYPE

TYPE EMREXTFLOODFILL
   emr      AS EMR
   ptlStart AS POINTL
   crColor  AS DWORD
   iMode    AS DWORD
END TYPE

TYPE EMRELLIPSE
   emr    AS EMR
   rclBox AS RECTL    ' Inclusive-inclusive bounding rectangle
END TYPE

MACRO EMRRECTANGLE = EMRELLIPSE

TYPE EMRROUNDRECT
   emr       AS EMR
   rclBox    AS RECTL    ' Inclusive-inclusive bounding rectangle
   szlCorner AS SIZEL
END TYPE

TYPE EMRARC
   emr      AS EMR
   rclBox   AS RECTL    ' Inclusive-inclusive bounding rectangle
   ptlStart AS POINTL
   ptlEnd   AS POINTL
END TYPE

MACRO EMRARCTO = EMRARC
MACRO EMRCHORD = EMRARC
MACRO EMRPIE   = EMRARC

TYPE EMRANGLEARC
   emr         AS EMR
   ptlCenter   AS POINTL
   nRadius     AS LONG
   eStartAngle AS SINGLE
   eSweepAngle AS SINGLE
END TYPE

TYPE EMRPOLYLINE
   emr       AS EMR
   rclBounds AS RECTL   ' Inclusive-inclusive bounds in device units
   cptl      AS DWORD
   aptl(0)   AS POINTL  ' POINTL  aptl[1]
END TYPE

MACRO EMRPOLYBEZIER   = EMRPOLYLINE
MACRO EMRPOLYGON      = EMRPOLYLINE
MACRO EMRPOLYBEZIERTO = EMRPOLYLINE
MACRO EMRPOLYLINETO   = EMRPOLYLINE

TYPE EMRPOLYLINE16
   emr       AS emr
   rclBounds AS RECTL    ' // Inclusive-inclusive bounds in device units
   cpts      AS DWORD
   aptl(0)   AS POINTL   ' POINTS  apts[1]
END TYPE

MACRO EMRPOLYBEZIER16 = EMRPOLYLINE16
MACRO EMRPOLYGON16 = EMRPOLYLINE16
MACRO EMRPOLYBEZIERTO16 = EMRPOLYLINE16
MACRO EMRPOLYLINETO16 = EMRPOLYLINE16

TYPE EMRPOLYDRAW
   emr        AS EMR
   rclBounds  AS RECTL    ' Inclusive-inclusive bounds in device units
   cptl       AS DWORD    ' Number of points
   aptl(0)    AS POINTL   ' POINTL  aptl[1]     // Array of points
   abTypes(0) AS BYTE     ' BYTE    abTypes[1]  // Array of point types
END TYPE

TYPE EMRPOLYDRAW16
   emr        AS EMR
   rclBounds  AS RECTL    ' Inclusive-inclusive bounds in device units
   cpts       AS DWORD    ' Number of points
   apts(0)    AS POINTS   ' POINTS  apts[1]     // Array of points
   abTypes(0) AS BYTE     ' BYTE    abTypes[1]  // Array of point types
END TYPE

TYPE EMRPOLYPOLYLINE
   emr            AS EMR
   rclBounds      AS RECTL    ' Inclusive-inclusive bounds in device units
   nPolys         AS DWORD    ' Number of polys
   cptl           AS DWORD    ' Total number of points in all polys
   aPolyCounts(0) AS DWORD    ' DWORD   aPolyCounts[1] // Array of point counts for each poly
   aptl(0)        AS POINTL   ' POINTL  aptl[1];       // Array of points
END TYPE

MACRO EMRPOLYPOLYGON = EMRPOLYPOLYLINE

TYPE EMRPOLYPOLYLINE16
   emr            AS EMR
   rclBounds      AS RECTL    ' Inclusive-inclusive bounds in device units
   nPolys         AS DWORD    ' Number of polys
   cpts           AS DWORD    ' Total number of points in all polys
   aPolyCounts(0) AS DWORD    ' DWORD   aPolyCounts[1] // Array of point counts for each poly
   apts(0)        AS POINTS   ' POINTS  apts[1]        // Array of points
END TYPE

MACRO EMRPOLYPOLYGON16 = EMRPOLYPOLYLINE16

TYPE EMRINVERTRGN
   emr        AS EMR
   rclBounds  AS RECTL   ' Inclusive-inclusive bounds in device units
   cbRgnData  AS DWORD   ' Size of region data in bytes
   RgnData(0) AS BYTE    ' BYTE    RgnData[1]
END TYPE

MACRO EMRPAINTRGN = EMRINVERTRGN

TYPE EMRFILLRGN
   emr        AS EMR
   rclBounds  AS RECTL    ' Inclusive-inclusive bounds in device units
   cbRgnData  AS DWORD    ' Size of region data in bytes
   ihBrush    AS DWORD    ' Brush handle index
   RgnData(0) AS BYTE     ' BYTE    RgnData[1]
END TYPE

TYPE EMRFRAMERGN
   emr        AS EMR
   rclBounds  AS RECTL   ' Inclusive-inclusive bounds in device units
   cbRgnData  AS DWORD   ' Size of region data in bytes
   ihBrush    AS DWORD   ' Brush handle index
   szlStroke  AS SIZEL
   RgnData(0) AS BYTE    ' BYTE    RgnData[1]
END TYPE

TYPE EMREXTSELECTCLIPRGN
   emr        AS EMR
   cbRgnData  AS DWORD   ' Size of region data in bytes
   iMode      AS DWORD
   RgnData(0) AS BYTE    ' BYTE    RgnData[1];
END TYPE

TYPE EMREXTTEXTOUTA
   emr           AS EMR
   rclBounds     AS RECTL     ' Inclusive-inclusive bounds in device units
   iGraphicsMode AS DWORD     ' Current graphics mode
   exScale       AS SINGLE    ' X and Y scales from Page units to .01mm units
   eyScale       AS SINGLE    '  if graphics mode is %GM_COMPATIBLE.
   pemrtext      AS EMRTEXT   ' This is followed by the string and spacing array
END TYPE

MACRO EMREXTTEXTOUTW = EMREXTTEXTOUTA
MACRO EMREXTTEXTOUT = EMREXTTEXTOUTA

TYPE EMRPOLYTEXTOUTA
   emr           AS EMR
   rclBounds     AS RECTL     ' Inclusive-inclusive bounds in device units
   iGraphicsMode AS DWORD     ' Current graphics mode
   exScale       AS SINGLE    ' X and Y scales from Page units to .01mm units
   eyScale       AS SINGLE    '  if graphics mode is %GM_COMPATIBLE.
   cStrings      AS LONG
   aemrtext(0)   AS EMRTEXT   ' EMRTEXT aemrtext[1]  // Array of EMRTEXT structures.  This is
                              '                      // followed by the strings and spacing arrays.
END TYPE

MACRO EMRPOLYTEXTOUTW = EMRPOLYTEXTOUTA
MACRO EMRPOLYTEXTOUT = EMRPOLYTEXTOUTA

TYPE EMRBITBLT
   emr          AS EMR
   rclBounds    AS RECTL   ' Inclusive-inclusive bounds in device units
   xDest        AS LONG
   yDest        AS LONG
   cxDest       AS LONG
   cyDest       AS LONG
   dwRop        AS DWORD
   xSrc         AS LONG
   ySrc         AS LONG
   xformSrc     AS XFORM   ' Source DC transform
   crBkColorSrc AS DWORD   ' Source DC BkColor in RGB
   iUsageSrc    AS DWORD   ' Source bitmap info color table usage (%DIB_RGB_COLORS)
   offBmiSrc    AS DWORD   ' Offset to the source BITMAPINFO structure
   cbBmiSrc     AS DWORD   ' Size of the source BITMAPINFO structure
   offBitsSrc   AS DWORD   ' Offset to the source bitmap bits
   cbBitsSrc    AS DWORD   ' Size of the source bitmap bits
END TYPE

TYPE EMRSTRETCHBLT
   emr          AS EMR
   rclBounds    AS RECTL   ' Inclusive-inclusive bounds in device units
   xDest        AS LONG
   yDest        AS LONG
   cxDest       AS LONG
   cyDest       AS LONG
   dwRop        AS DWORD
   xSrc         AS LONG
   ySrc         AS LONG
   xformSrc     AS XFORM   ' Source DC transform
   crBkColorSrc AS DWORD   ' Source DC BkColor in RGB
   iUsageSrc    AS DWORD   ' Source bitmap info color table usage (%DIB_RGB_COLORS)
   offBmiSrc    AS DWORD   ' Offset to the source BITMAPINFO structure
   cbBmiSrc     AS DWORD   ' Size of the source BITMAPINFO structure
   offBitsSrc   AS DWORD   ' Offset to the source bitmap bits
   cbBitsSrc    AS DWORD   ' Size of the source bitmap bits
   cxSrc        AS LONG
   cySrc        AS LONG
END TYPE

TYPE EMRMASKBLT
   emr          AS EMR
   rclBounds    AS RECTL   ' Inclusive-inclusive bounds in device units
   xDest        AS LONG
   yDest        AS LONG
   cxDest       AS LONG
   cyDest       AS LONG
   dwRop        AS DWORD
   xSrc2        AS LONG
   cyDest2      AS LONG
   dwRop2       AS LONG
   xSrc         AS LONG
   ySrc         AS LONG
   xformSrc     AS XFORM   ' Source DC transform
   crBkColorSrc AS DWORD   ' Source DC BkColor in RGB
   iUsageSrc    AS DWORD   ' Source bitmap info color table usage (%DIB_RGB_COLORS)
   offBmiSrc    AS DWORD   ' Offset to the source BITMAPINFO structure
   cbBmiSrc     AS DWORD   ' Size of the source BITMAPINFO structure
   offBitsSrc   AS DWORD   ' Offset to the source bitmap bits
   cbBitsSrc    AS DWORD   ' Size of the source bitmap bits
   xMask        AS LONG
   yMask        AS LONG
   iUsageMask   AS DWORD   ' Mask bitmap info color table usage
   offBmiMask   AS DWORD   ' Offset to the mask BITMAPINFO structure if any
   cbBmiMask    AS DWORD   ' Size of the mask BITMAPINFO structure if any
   offBitsMask  AS DWORD   ' Offset to the mask bitmap bits if any
   cbBitsMask   AS DWORD   ' Size of the mask bitmap bits if any
END TYPE

TYPE EMRPLGBLT
   emr          AS EMR
   rclBounds    AS RECTL            ' Inclusive-inclusive bounds in device units
   aptlDest(2)  AS POINTL
   xSrc         AS LONG
   ySrc         AS LONG
   cxSrc        AS LONG
   cySrc        AS LONG
   xformSrc     AS XFORM            ' Source DC transform
   crBkColorSrc AS DWORD            ' Source DC BkColor in RGB
   iUsageSrc    AS DWORD            ' Source bitmap info color table usage (%DIB_RGB_COLORS)
   offBmiSrc    AS DWORD            ' Offset to the source BITMAPINFO structure
   cbBmiSrc     AS DWORD            ' Size of the source BITMAPINFO structure
   offBitsSrc   AS DWORD            ' Offset to the source bitmap bits
   cbBitsSrc    AS DWORD            ' Size of the source bitmap bits
   xMask        AS LONG
   yMask        AS LONG
   iUsageMask   AS DWORD            ' Mask bitmap info color table usage
   offBmiMask   AS DWORD            ' Offset to the mask BITMAPINFO structure if any
   cbBmiMask    AS DWORD            ' Size of the mask BITMAPINFO structure if any
   offBitsMask  AS DWORD            ' Offset to the mask bitmap bits if any
   cbBitsMask   AS DWORD            ' Size of the mask bitmap bits if any
END TYPE

TYPE EMRSETDIBITSTODEVICE
   emr        AS EMR
   rclBounds  AS RECTL   ' Inclusive-inclusive bounds in device units
   xDest      AS LONG
   yDest      AS LONG
   xSrc       AS LONG
   ySrc       AS LONG
   cxSrc      AS LONG
   cySrc      AS LONG
   offBmiSrc  AS DWORD   ' Offset to the source BITMAPINFO structure
   cbBmiSrc   AS DWORD   ' Size of the source BITMAPINFO structure
   offBitsSrc AS DWORD   ' Offset to the source bitmap bits
   cbBitsSrc  AS DWORD   ' Size of the source bitmap bits
   iUsageSrc  AS DWORD   ' Source bitmap info color table usage
   iStartScan AS DWORD
   cScans     AS DWORD
END TYPE

TYPE EMRSTRETCHDIBITS
   emr        AS EMR
   rclBounds  AS RECTL   ' Inclusive-inclusive bounds in device units
   xDest      AS LONG
   yDest      AS LONG
   xSrc       AS LONG
   ySrc       AS LONG
   cxSrc      AS LONG
   cySrc      AS LONG
   offBmiSrc  AS DWORD   ' Offset to the source BITMAPINFO structure
   cbBmiSrc   AS DWORD   ' Size of the source BITMAPINFO structure
   offBitsSrc AS DWORD   ' Offset to the source bitmap bits
   cbBitsSrc  AS DWORD   ' Size of the source bitmap bits
   iUsageSrc  AS DWORD   ' Source bitmap info color table usage
   dwRop      AS DWORD
   cxDest     AS LONG
   cyDest     AS LONG
END TYPE

TYPE EMREXTCREATEFONTINDIRECTA
   emr    AS emr
   ihFont AS DWORD
   elfw   AS EXTLOGFONTA
END TYPE

TYPE EMREXTCREATEFONTINDIRECTW
   emr    AS emr
   ihFont AS DWORD
   elfw   AS EXTLOGFONTW
END TYPE

MACRO EMREXTCREATEFONTINDIRECT = EMREXTCREATEFONTINDIRECTA

TYPE EMRCREATEPALETTE    ' fake type
   emr   AS EMR
   ihPal AS DWORD        ' Palette handle index
   lgpl  AS LOGPALETTE   ' The peFlags fields in the palette entries
                         ' do not contain any flags
END TYPE

TYPE EMRCREATEPEN
   emr   AS EMR
   ihPen AS DWORD    ' Pen handle index
   lopn  AS LOGPEN
END TYPE

TYPE EMREXTCREATEPEN
   emr     AS EMR
   ihPen   AS DWORD       ' Pen handle index
   offBmi  AS DWORD       ' Offset to the BITMAPINFO structure if any
   cbBmi   AS DWORD       ' Size of the BITMAPINFO structure if any
                          ' The bitmap info is followed by the bitmap bits
                          ' to form a packed DIB.
   offBits AS DWORD       ' Offset to the brush bitmap bits if any
   cbBits  AS DWORD       ' Size of the brush bitmap bits if any
   elp     AS EXTLOGPEN   ' The extended pen with the style array
END TYPE

TYPE EMRCREATEBRUSHINDIRECT
   emr     AS EMR
   ihBrush AS DWORD      ' Brush handle index
   lb      AS LOGBRUSH   ' The style must be %BS_SOLID, %BS_HOLLOW, %BS_NULL or
                         ' %BS_HATCHED.
END TYPE

TYPE EMRCREATEMONOBRUSH
   emr     AS EMR
   ihBrush AS DWORD   ' Brush handle index
   iUsage  AS DWORD   ' Bitmap info color table usage
   offBmi  AS DWORD   ' Offset to the BITMAPINFO structure
   cbBmi   AS DWORD   ' Size of the BITMAPINFO structure
   offBits AS DWORD   ' Offset to the bitmap bits
   cbBits  AS DWORD   ' Size of the bitmap bits
END TYPE

TYPE EMRCREATEDIBPATTERNBRUSHPT
   emr     AS EMR
   ihBursh AS DWORD   ' Brush handle index
   iUsage  AS DWORD   ' Bitmap info color table usage
   offBmi  AS DWORD   ' Offset to the BITMAPINFO structure
   cbBmi   AS DWORD   ' Size of the BITMAPINFO structure
                      ' The bitmap info is followed by the bitmap bits
                      ' to form a packed DIB.
   offBits AS DWORD   ' Offset to the bitmap bits
   cbBits  AS DWORD   ' Size of the bitmap bits
END TYPE

TYPE EMRFORMAT
   dSignature AS DWORD   ' Format signature, e.g. %ENHMETA_SIGNATURE.
   nVersion   AS DWORD   ' Format version number.
   cbData     AS DWORD   ' Size of data in bytes.
   offData    AS DWORD   ' Offset to data from %GDICOMMENT_IDENTIFIER.
                         ' It must begin at a DWORD offset.
END TYPE

'#if(WINVER >= 0x0400)

TYPE EMRGLSRECORD
   emr      AS EMR
   cbData   AS DWORD   ' // Size of data in bytes
   bData(0) AS BYTE    ' BYTE    Data[1]
END TYPE

TYPE EMRGLSBOUNDEDRECORD
   emr       AS EMR
   rclBounds AS RECTL   ' Bounds in recording coordinates
   cbData    AS DWORD   ' Size of data in bytes
   bData(0)  AS BYTE    ' BYTE    Data[1]
END TYPE

TYPE EMRPIXELFORMAT
   emr  AS EMR
   pfd  AS PIXELFORMATDESCRIPTOR
END TYPE

TYPE EMRCREATECOLORSPACE
   emr  AS EMR
   ihCS AS DWORD        ' ColorSpace handle index
   lcs  AS LOGCOLORSPACE
END TYPE

TYPE EMRSETCOLORSPACE
   emr  AS EMR
   ihCS AS DWORD    ' ColorSpace handle index
END TYPE

MACRO EMRSELECTCOLORSPACE = EMRSETCOLORSPACE
MACRO EMRDELETECOLORSPACE = EMRSETCOLORSPACE

'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)

TYPE EMREXTESCAPE
   emr        AS EMR
   iEscape    AS LONG           ' // Escape code
   cbEscData  AS LONG           ' // Size of escape data
   EscData(0) AS BYTE           ' // Escape data
END TYPE

TYPE EMRDRAWESCAPE
   emr        AS EMR
   iEscape    AS LONG           ' // Escape code
   cbEscData  AS LONG           ' // Size of escape data
   EscData(0) AS BYTE           ' // Escape data
END TYPE

TYPE EMRNAMEDESCAPE
   emr        AS EMR
   iEscape    AS LONG  ' // Escape code
   cbDriver   AS LONG  ' // Size   of   driver name
   cbEscData  AS LONG  ' // Size   of   escape data
   EscData(0) AS BYTE  ' // Driver name and    Escape data
END TYPE

%SETICMPROFILE_EMBEDED = &H00000001???

TYPE EMRSETICMPROFILEA
   emr      AS EMR
   dwFlags  AS DWORD   ' flags
   cbName   AS DWORD   ' Size of desired profile name
   cbData   AS DWORD   ' Size of raw profile data if attached
   bData(0) AS BYTE    ' BYTE    Data[1] // Array size is cbName + cbData
END TYPE

MACRO EMRSETICMPROFILEW = EMRSETICMPROFILEA
MACRO EMRSETICMPROFILE  = EMRSETICMPROFILEA

%CREATECOLORSPACE_EMBEDED        = &H00000001???

TYPE EMRCREATECOLORSPACEW
   emr     AS EMR
   ihCS    AS DWORD            ' // ColorSpace handle index
   lcs     AS LOGCOLORSPACEW   ' // Unicode version of logical color space structure
   dwFlags AS DWORD            ' // flags
   cbData  AS DWORD            ' // size of raw source profile data if attached
   Data(0) AS BYTE             ' BYTE Data[1] // Array size is cbData
END TYPE

%COLORMATCHTOTARGET_EMBEDED      = &H00000001???

TYPE EMRCOLORMATCHTOTARGET
   emr      AS EMR
   dwAction AS DWORD   ' // CS_ENABLE, CS_DISABLE or CS_DELETE_TRANSFORM
   dwFlags  AS DWORD   ' // flags
   cbName   AS DWORD   ' // Size of desired target profile name
   cbData   AS DWORD   ' // Size of raw target profile data if attached
   Data(0)  AS BYTE    ' BYTE Data[1] // Array size is cbName + cbData
END TYPE

TYPE EMRCOLORCORRECTPALETTE
   emr         AS EMR
   ihPalette   AS DWORD   ' // Palette handle index
   nFirstEntry AS DWORD   ' // Index of first entry to correct
   nPalEntries AS DWORD   ' // Number of palette entries to correct
   nReserved   AS DWORD   ' // Reserved
END TYPE

TYPE EMRALPHABLEND
   emr          AS EMR
   rclBounds    AS RECTL   ' Inclusive-inclusive bounds in device units
   xDest        AS LONG
   yDest        AS LONG
   cxDest       AS LONG
   cyDest       AS LONG
   dwRop        AS DWORD
   xSrc         AS LONG
   ySrc         AS LONG
   xformSrc     AS XFORM   ' Source DC transform
   crBkColorSrc AS DWORD   ' Source DC BkColor in RGB
   iUsageSrc    AS DWORD   ' Source bitmap info color table usage (%DIB_RGB_COLORS)
   offBmiSrc    AS DWORD   ' Offset to the source BITMAPINFO structure
   cbBmiSrc     AS DWORD   ' Size of the source BITMAPINFO structure
   offBitsSrc   AS DWORD   ' Offset to the source bitmap bits
   cbBitsSrc    AS DWORD   ' Size of the source bitmap bits
   cxSrc        AS LONG
   cySrc        AS LONG
END TYPE

TYPE EMRGRADIENTFILL
   emr       AS EMR
   rclBounds AS RECTL       ' Inclusive-inclusive bounds in device units
   nVer      AS DWORD
   nTri      AS DWORD
   ulMode    AS DWORD
   Ver(0)    AS TRIVERTEX   ' TRIVERTEX Ver[1]
END TYPE

TYPE EMRTRANSPARENTBLT
   emr          AS EMR
   rclBounds    AS RECTL   ' Inclusive-inclusive bounds in device units
   xDest        AS LONG
   yDest        AS LONG
   cxDest       AS LONG
   cyDest       AS LONG
   dwRop        AS DWORD
   xSrc         AS LONG
   ySrc         AS LONG
   xformSrc     AS XFORM   ' Source DC transform
   crBkColorSrc AS DWORD   ' COLORREF // Source DC BkColor in RGB
   iUsageSrc    AS DWORD   ' Source bitmap info color table usage (%DIB_RGB_COLORS)
   offBmiSrc    AS DWORD   ' Offset to the source BITMAPINFO structure
   cbBmiSrc     AS DWORD   ' Size of the source BITMAPINFO structure
   offBitsSrc   AS DWORD   ' Offset to the source bitmap bits
   cbBitsSrc    AS DWORD   ' Size of the source bitmap bits
   cxSrc        AS LONG
   cySrc        AS LONG
END TYPE


'#endif /* WINVER >= 0x0500 */

%GDICOMMENT_IDENTIFIER       = &H43494447???
%GDICOMMENT_WINDOWS_METAFILE = &H80000001???
%GDICOMMENT_BEGINGROUP       = &H00000002???
%GDICOMMENT_ENDGROUP         = &H00000003???
%GDICOMMENT_MULTIFORMATS     = &H40000004???
%EPS_SIGNATURE               = &H46535045???
%GDICOMMENT_UNICODE_STRING   = &H00000040???
%GDICOMMENT_UNICODE_END      = &H00000080???

'#endif  /* NOMETAFILE */
#ENDIF   ' #IF NOT %DEF(%NOMETAFILE) ------------------------------------------


'// OpenGL wgl prototypes

DECLARE FUNCTION wglCopyContext LIB "OPENGL32.DLL" ALIAS "wglCopyContext" ( _
   BYVAL DWORD _                       ' HGLRC hglrcSrc
 , BYVAL DWORD _                       ' HGLRC hglrcDst
 , BYVAL DWORD _                       ' UINT  mask
 ) AS LONG                             ' BOOL

DECLARE FUNCTION wglCreateContext LIB "OPENGL32.DLL" ALIAS "wglCreateContext" ( _
   BYVAL DWORD _                       ' HDC hdc
 ) AS DWORD                            ' HGLRC

DECLARE FUNCTION wglCreateLayerContext LIB "OPENGL32.DLL" ALIAS "wglCreateLayerContext" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL LONG _                        ' int iLayerPlane
 ) AS DWORD                            ' HGLRC

DECLARE FUNCTION wglDeleteContext LIB "OPENGL32.DLL" ALIAS "wglDeleteContext" ( _
   BYVAL DWORD _                       ' HGLRC hglrc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION wglGetCurrentContext LIB "OPENGL32.DLL" ALIAS "wglGetCurrentContext" ( _
 ) AS DWORD                            ' HGLRC

DECLARE FUNCTION wglGetCurrentDC LIB "OPENGL32.DLL" ALIAS "wglGetCurrentDC" ( _
 ) AS DWORD                            ' HDC

DECLARE FUNCTION wglGetProcAddress LIB "OPENGL32.DLL" ALIAS "wglGetProcAddress" ( _
   BYREF ASCIIZ _                      ' LPCSTR lpszProc
 ) AS DWORD                            ' PROC

DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL DWORD _                       ' HGLRC hglrc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION wglShareLists LIB "OPENGL32.DLL" ALIAS "wglShareLists" ( _
   BYVAL DWORD  _                      ' HGLRC hglrc1
 , BYVAL DWORD _                       ' HGLRC hglrc2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION wglUseFontBitmaps LIB "OPENGL32.DLL" ALIAS "wglUseFontBitmapsA" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL DWORD _                       ' DWORD dFirst
 , BYVAL DWORD _                       ' DWORD dCount
 , BYVAL DWORD _                       ' DWORD dListBase
 ) AS LONG                             ' BOOL

DECLARE FUNCTION wglUseFontBitmapsW LIB "OPENGL32.DLL" ALIAS "wglUseFontBitmapsW" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL DWORD _                       ' DWORD dFirst
 , BYVAL DWORD _                       ' DWORD dCount
 , BYVAL DWORD _                       ' DWORD dListBase
 ) AS LONG                             ' BOOL

' ** NOTE ** Microsoft incorrectly documents SwapBuffers as being in OPENGL32.DLL
DECLARE FUNCTION SwapBuffers LIB "GDI32.DLL" ALIAS "SwapBuffers" ( _
   BYVAL DWORD _                       ' HDC hdc
 ) AS LONG                             ' BOOL

TYPE POINTFLOAT
   x AS SINGLE
   y AS SINGLE
END TYPE

TYPE GLYPHMETRICSFLOAT
   gmfBlackBoxX     AS SINGLE
   gmfBlackBoxY     AS SINGLE
   gmfptGlyphOrigin AS POINTFLOAT
   gmfCellIncX      AS SINGLE
   gmfCellIncY      AS SINGLE
END TYPE

%WGL_FONT_LINES    = 0
%WGL_FONT_POLYGONS = 1

DECLARE FUNCTION wglUseFontOutlines LIB "OPENGL32.DLL" ALIAS "wglUseFontOutlinesA" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL DWORD _                       ' DWORD dFirst
 , BYVAL DWORD _                       ' DWORD dCount
 , BYVAL DWORD _                       ' DWORD dListBase
 , BYVAL SINGLE _                      ' FLOAT deviation
 , BYVAL SINGLE  _                     ' FLOAT extrusion
 , BYVAL LONG _                        ' int iFormat
 , BYREF GLYPHMETRICSFLOAT _           ' LPGLYPHMETRICSFLOAT lpgmf
 ) AS LONG                             ' BOOL

DECLARE FUNCTION wglUseFontOutlinesW LIB "OPENGL32.DLL" ALIAS "wglUseFontOutlinesW" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL DWORD _                       ' DWORD dFirst
 , BYVAL DWORD _                       ' DWORD dCount
 , BYVAL DWORD _                       ' DWORD dListBase
 , BYVAL SINGLE _                      ' FLOAT deviation
 , BYVAL SINGLE _                      ' FLOAT extrusion
 , BYVAL LONG _                        ' int iFormat
 , BYREF GLYPHMETRICSFLOAT _           ' LPGLYPHMETRICSFLOAT lpgmf
 ) AS LONG                             ' BOOL

'/* Layer plane descriptor */
TYPE LAYERPLANEDESCRIPTOR
   nSize           AS WORD
   nVersion        AS WORD
   dwFlags         AS DWORD
   iPixelType      AS BYTE
   cColorBits      AS BYTE
   cRedBits        AS BYTE
   cRedShift       AS BYTE
   cGreenBits      AS BYTE
   cGreenShift     AS BYTE
   cBlueBits       AS BYTE
   cBlueShift      AS BYTE
   cAlphaBits      AS BYTE
   cAlphaShift     AS BYTE
   cAccumBits      AS BYTE
   cAccumRedBits   AS BYTE
   cAccumGreenBits AS BYTE
   cAccumBlueBits  AS BYTE
   cAccumAlphaBits AS BYTE
   cDepthBits      AS BYTE
   cStencilBits    AS BYTE
   cAuxBuffers     AS BYTE
   iLayerPlane     AS BYTE
   bReserved       AS BYTE
   crTransparent   AS DWORD
END TYPE

'/* LAYERPLANEDESCRIPTOR flags */
%LPD_DOUBLEBUFFER   = &H00000001???
%LPD_STEREO         = &H00000002???
%LPD_SUPPORT_GDI    = &H00000010???
%LPD_SUPPORT_OPENGL = &H00000020???
%LPD_SHARE_DEPTH    = &H00000040???
%LPD_SHARE_STENCIL  = &H00000080???
%LPD_SHARE_ACCUM    = &H00000100???
%LPD_SWAP_EXCHANGE  = &H00000200???
%LPD_SWAP_COPY      = &H00000400???
%LPD_TRANSPARENT    = &H00001000???

'#define LPD_TYPE_RGBA        0
'#define LPD_TYPE_COLORINDEX  1

%LPD_TYPE_RGBA       = 0
%LPD_TYPE_COLORINDEX = 1

'/* wglSwapLayerBuffers flags */
%WGL_SWAP_MAIN_PLANE = &H00000001???
%WGL_SWAP_OVERLAY1   = &H00000002???
%WGL_SWAP_OVERLAY2   = &H00000004???
%WGL_SWAP_OVERLAY3   = &H00000008???
%WGL_SWAP_OVERLAY4   = &H00000010???
%WGL_SWAP_OVERLAY5   = &H00000020???
%WGL_SWAP_OVERLAY6   = &H00000040???
%WGL_SWAP_OVERLAY7   = &H00000080???
%WGL_SWAP_OVERLAY8   = &H00000100???
%WGL_SWAP_OVERLAY9   = &H00000200???
%WGL_SWAP_OVERLAY10  = &H00000400???
%WGL_SWAP_OVERLAY11  = &H00000800???
%WGL_SWAP_OVERLAY12  = &H00001000???
%WGL_SWAP_OVERLAY13  = &H00002000???
%WGL_SWAP_OVERLAY14  = &H00004000???
%WGL_SWAP_OVERLAY15  = &H00008000???
%WGL_SWAP_UNDERLAY1  = &H00010000???
%WGL_SWAP_UNDERLAY2  = &H00020000???
%WGL_SWAP_UNDERLAY3  = &H00040000???
%WGL_SWAP_UNDERLAY4  = &H00080000???
%WGL_SWAP_UNDERLAY5  = &H00100000???
%WGL_SWAP_UNDERLAY6  = &H00200000???
%WGL_SWAP_UNDERLAY7  = &H00400000???
%WGL_SWAP_UNDERLAY8  = &H00800000???
%WGL_SWAP_UNDERLAY9  = &H01000000???
%WGL_SWAP_UNDERLAY10 = &H02000000???
%WGL_SWAP_UNDERLAY11 = &H04000000???
%WGL_SWAP_UNDERLAY12 = &H08000000???
%WGL_SWAP_UNDERLAY13 = &H10000000???
%WGL_SWAP_UNDERLAY14 = &H20000000???
%WGL_SWAP_UNDERLAY15 = &H40000000???

DECLARE FUNCTION wglDescribeLayerPlane LIB "OPENGL32.DLL" ALIAS "wglDescribeLayerPlane" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL LONG _                        ' int iPixelFormat
 , BYVAL LONG _                        ' int iLayerPlane
 , BYVAL DWORD _                       ' UINT nBytes
 , BYREF LAYERPLANEDESCRIPTOR _        ' LPLAYERPLANEDESCRIPTOR plpd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION wglSetLayerPaletteEntries LIB "OPENGL32.DLL" ALIAS "wglSetLayerPaletteEntries" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL LONG _                        ' int iLayerPlane
 , BYVAL LONG _                        ' int iStart
 , BYVAL LONG _                        ' int cEntries
 , BYREF DWORD _                       ' CONST COLORREF * pcr
 ) AS LONG                             ' int

DECLARE FUNCTION wglGetLayerPaletteEntries LIB "OPENGL32.DLL" ALIAS "wglGetLayerPaletteEntries" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL LONG _                        ' int iLayerPlane
 , BYVAL LONG _                        ' int iStart
 , BYVAL LONG _                        ' int cEntries
 , BYREF DWORD _                       ' COLORREF * pcr
 ) AS LONG                             ' int

DECLARE FUNCTION wglRealizeLayerPalette LIB "OPENGL32.DLL" ALIAS "wglRealizeLayerPalette" ( _
   BYVAL DWORD _                       ' HDC hdc
 , BYVAL LONG _                        ' int iLayerPlane
 , BYVAL LONG _                        ' BOOL fRealize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION wglSwapLayerBuffers LIB "OPENGL32.DLL" ALIAS "wglSwapLayerBuffers" ( _
   BYVAL DWORD  _                      ' HDC hdc
 , BYVAL DWORD _                       ' UINT dfPlanes
 ) AS LONG                             ' BOOL

'#if (WINVER >= 0x0500)

TYPE WGLSWAP
   hdc     AS DWORD   ' HDC
   uiFlags AS DWORD   ' UINT
END TYPE

%WGL_SWAPMULTIPLE_MAX = 16

DECLARE FUNCTION wglSwapMultipleBuffers LIB "OPENGL32.DLL" ALIAS "wglSwapMultipleBuffers" ( _
   BYVAL DWORD _                       ' UINT
 , BYREF WGLSWAP _                     ' CONST WGLSWAP *
 ) AS DWORD                            ' DWORD

'#endif // (WINVER >= 0x0500)

'#endif /* NOGDI */
'#ENDIF   ' #IF NOT %DEF(%NOGDI) -----------------------------------------------

#ENDIF   ' WINGDI

'/****************************************************************************
'*                                                                           *
'* winuser.h -- USER procedure declarations, constant definitions and macros *
'*                                                                           *
'* Copyright (c) Microsoft Corporation. All rights reserved.                          *
'*                                                                           *
'****************************************************************************/

#IF NOT %DEF(%WINUSER_INC)
    %WINUSER_INC = 1

'//
'// Define API decoration for direct importing of DLL references.
'//

'#ifndef WINVER
'#define WINVER  0x0500      /* version 5.0 */
'#endif /* !WINVER */

'#include <stdarg.h>

'#IF NOT %DEF(%NOUSER) ' -------------------------------------------------------
'#ifndef NOUSER

'typedef HANDLE HDWP;
'typedef VOID MENUTEMPLATEA;
'typedef VOID MENUTEMPLATEW;

'typedef LRESULT (CALLBACK* WNDPROC)(HWND, UINT, WPARAM, LPARAM);

'typedef INT_PTR (CALLBACK* DLGPROC)(HWND, UINT, WPARAM, LPARAM);
'typedef VOID (CALLBACK* TIMERPROC)(HWND, UINT, UINT_PTR, DWORD);
'typedef BOOL (CALLBACK* GRAYSTRINGPROC)(HDC, LPARAM, int);
'typedef BOOL (CALLBACK* WNDENUMPROC)(HWND, LPARAM);
'typedef LRESULT (CALLBACK* HOOKPROC)(int code, WPARAM wParam, LPARAM lParam);
'typedef VOID (CALLBACK* SENDASYNCPROC)(HWND, UINT, ULONG_PTR, LRESULT);

'typedef BOOL (CALLBACK* PROPENUMPROCA)(HWND, LPCSTR, HANDLE);
'typedef BOOL (CALLBACK* PROPENUMPROCW)(HWND, LPCWSTR, HANDLE);

'typedef BOOL (CALLBACK* PROPENUMPROCEXA)(HWND, LPSTR, HANDLE, ULONG_PTR);
'typedef BOOL (CALLBACK* PROPENUMPROCEXW)(HWND, LPWSTR, HANDLE, ULONG_PTR);

'typedef int (CALLBACK* EDITWORDBREAKPROCA)(LPSTR lpch, int ichCurrent, int cch, int code);
'typedef int (CALLBACK* EDITWORDBREAKPROCW)(LPWSTR lpch, int ichCurrent, int cch, int code);

'#if(WINVER >= 0x0400)
'typedef BOOL (CALLBACK* DRAWSTATEPROC)(HDC hdc, LPARAM lData, WPARAM wData, int cx, int cy);
'#endif /* WINVER >= 0x0400 */
'#else /* !STRICT */

'#define IS_INTRESOURCE(_r) ((((ULONG_PTR)(_r)) >> 16) == 0)
'#define MAKEINTRESOURCEA(i) ((LPSTR)((ULONG_PTR)((WORD)(i))))
'#define MAKEINTRESOURCEW(i) ((LPWSTR)((ULONG_PTR)((WORD)(i))))

'   FUNCTION IS_INTRESOURCE (BYVAL dwInteger AS DWORD) AS LONG
'      SHIFT RIGHT dwInteger, 16
'      FUNCTION = (dwInteger = 0)
'   END FUNCTION
'   FUNCTION MAKEINTRESOURCE (BYVAL wInteger AS WORD) AS DWORD
'      FUNCTION = MAK(DWORD, wInteger, 0)
'   END FUNCTION

'/*
' * Queue status flags for GetQueueStatus() and MsgWaitForMultipleObjects()
' */
%QS_KEY            = &H0001???
%QS_MOUSEMOVE      = &H0002???
%QS_MOUSEBUTTON    = &H0004???
%QS_POSTMESSAGE    = &H0008???
%QS_TIMER          = &H0010???
%QS_PAINT          = &H0020???
%QS_SENDMESSAGE    = &H0040???
%QS_HOTKEY         = &H0080???
%QS_ALLPOSTMESSAGE = &H0100???
'#if(_WIN32_WINNT >= 0x0501)
%QS_RAWINPUT       = &H0400???
'#endif /* _WIN32_WINNT >= 0x0501 */

%QS_MOUSE          = %QS_MOUSEMOVE OR %QS_MOUSEBUTTON

'#if (_WIN32_WINNT >= 0x0501)
'#define QS_INPUT           (QS_MOUSE         | \
'                            QS_KEY           | \
'                            QS_RAWINPUT)
'#else
'#define QS_INPUT           (QS_MOUSE         | \
'                            QS_KEY)
'#endif // (_WIN32_WINNT >= 0x0501)

%QS_INPUT          = %QS_MOUSE OR %QS_KEY
%QS_INPUTXP        = %QS_MOUSE OR %QS_KEY OR %QS_RAWINPUT ' Windows XP and later

%QS_ALLEVENTS      = %QS_INPUT OR %QS_POSTMESSAGE OR %QS_TIMER OR %QS_PAINT OR %QS_HOTKEY

%QS_ALLINPUT       = %QS_INPUT OR %QS_POSTMESSAGE OR %QS_TIMER OR %QS_PAINT OR %QS_HOTKEY OR %QS_SENDMESSAGE

%USER_TIMER_MAXIMUM  = &H7FFFFFFF???
%USER_TIMER_MINIMUM  = &H0000000A???

'#IF NOT %DEF(%NORESOURCE) ' ---------------------------------------------------
'#ifndef NORESOURCE

'/*
' * Predefined Resource Types
' */
'#define RT_CURSOR           MAKEINTRESOURCE(1)
'#define RT_BITMAP           MAKEINTRESOURCE(2)
'#define RT_ICON             MAKEINTRESOURCE(3)
'#define RT_MENU             MAKEINTRESOURCE(4)
'#define RT_DIALOG           MAKEINTRESOURCE(5)
'#define RT_STRING           MAKEINTRESOURCE(6)
'#define RT_FONTDIR          MAKEINTRESOURCE(7)
'#define RT_FONT             MAKEINTRESOURCE(8)
'#define RT_ACCELERATOR      MAKEINTRESOURCE(9)
'#define RT_RCDATA           MAKEINTRESOURCE(10)
'#define RT_MESSAGETABLE     MAKEINTRESOURCE(11)

%RT_CURSOR       = 1??
%RT_BITMAP       = 2??
%RT_ICON         = 3??
%RT_MENU         = 4??
%RT_DIALOG       = 5??
%RT_STRING       = 6??
%RT_FONTDIR      = 7??
%RT_FONT         = 8??
%RT_ACCELERATOR  = 9??
%RT_RCDATA       = 10??
%RT_MESSAGETABLE = 11??

'#define DIFFERENCE     11
'#define RT_GROUP_CURSOR MAKEINTRESOURCE((ULONG_PTR)RT_CURSOR + DIFFERENCE)
'#define RT_GROUP_ICON   MAKEINTRESOURCE((ULONG_PTR)RT_ICON + DIFFERENCE)
'#define RT_VERSION      MAKEINTRESOURCE(16)
'#define RT_DLGINCLUDE   MAKEINTRESOURCE(17)
'#if(WINVER >= 0x0400)
'#define RT_PLUGPLAY     MAKEINTRESOURCE(19)
'#define RT_VXD          MAKEINTRESOURCE(20)
'#define RT_ANICURSOR    MAKEINTRESOURCE(21)
'#define RT_ANIICON      MAKEINTRESOURCE(22)
'#endif /* WINVER >= 0x0400 */
'#define RT_HTML         MAKEINTRESOURCE(23)
'#ifdef RC_INVOKED
'#define RT_MANIFEST                        24
'#define CREATEPROCESS_MANIFEST_RESOURCE_ID  1
'#define ISOLATIONAWARE_MANIFEST_RESOURCE_ID 2
'#define ISOLATIONAWARE_NOSTATICIMPORT_MANIFEST_RESOURCE_ID 3
'#define MINIMUM_RESERVED_MANIFEST_RESOURCE_ID 1   /* inclusive */
'#define MAXIMUM_RESERVED_MANIFEST_RESOURCE_ID 16  /* inclusive */
'#else  /* RC_INVOKED */
'#define RT_MANIFEST                        MAKEINTRESOURCE(24)
'#define CREATEPROCESS_MANIFEST_RESOURCE_ID MAKEINTRESOURCE( 1)
'#define ISOLATIONAWARE_MANIFEST_RESOURCE_ID MAKEINTRESOURCE(2)
'#define ISOLATIONAWARE_NOSTATICIMPORT_MANIFEST_RESOURCE_ID MAKEINTRESOURCE(3)
'#define MINIMUM_RESERVED_MANIFEST_RESOURCE_ID MAKEINTRESOURCE( 1 /*inclusive*/)
'#define MAXIMUM_RESERVED_MANIFEST_RESOURCE_ID MAKEINTRESOURCE(16 /*inclusive*/)
'#endif /* RC_INVOKED */

%DIFFERENCE      = 11??
%RT_GROUP_CURSOR = 12??
%RT_GROUP_ICON   = 14??
%RT_VERSION      = 16??
%RT_DLGINCLUDE   = 17??
%RT_PLUGPLAY     = 19??
%RT_VXD          = 20??
%RT_ANICURSOR    = 21??
%RT_ANIICON      = 22??
%RT_HTML         = 23??
%RT_MANIFEST     = 24??
%CREATEPROCESS_MANIFEST_RESOURCE_ID  = 1??
%ISOLATIONAWARE_MANIFEST_RESOURCE_ID = 2??
%ISOLATIONAWARE_NOSTATICIMPORT_MANIFEST_RESOURCE_ID = 3??
%MINIMUM_RESERVED_MANIFEST_RESOURCE_ID = 1??    ' /* inclusive */
%MAXIMUM_RESERVED_MANIFEST_RESOURCE_ID = 16??  ' /* inclusive */
'#ENDIF ' #IF NOT %DEF(%NORESOURCE) --------------------------------------------

DECLARE FUNCTION wvsprintf LIB "USER32.DLL" ALIAS "wvsprintfA" ( _
   BYREF ASCIIZ _                      ' __out LPSTR
 , BYREF ASCIIZ _                      ' __in __format_string LPCSTR
 , BYREF ANY _                         ' __in va_list arglist
 ) AS LONG                             ' int

DECLARE FUNCTION wvsprintfW LIB "USER32.DLL" ALIAS "wvsprintfW" ( _
   BYVAL DWORD _                       ' __out LPWSTR
 , BYVAL DWORD _                       ' __in __format_string LPCWSTR
 , BYREF ANY _                         ' __in va_list arglist
 ) AS LONG                             ' int

DECLARE FUNCTION wsprintf CDECL LIB "USER32.DLL" ALIAS "wsprintfA" ( _
   BYREF ASCIIZ _                      ' __out LPSTR
 , BYREF ASCIIZ _                      ' __in __format_string LPCSTR
 , BYREF ANY _                         ' ...
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 ) AS LONG                             ' int

DECLARE FUNCTION wsprintfW CDECL LIB "USER32.DLL" ALIAS "wsprintfW" ( _
   BYVAL DWORD _                       ' __out LPWSTR
 , BYVAL DWORD _                       ' __in __format_string LPCWSTR
 , BYREF ANY _                         ' ...
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 , OPTIONAL BYREF ANY _
 ) AS LONG                             ' int

'/*
' * SPI_SETDESKWALLPAPER defined constants
' */
'#define SETWALLPAPER_DEFAULT    ((LPWSTR)-1)
%SETWALLPAPER_DEFAULT = &HFFFFFFFF???

'#IF NOT %DEF(%NOSCROLL) '------------------------------------------------------
'#ifndef NOSCROLL

'/*
' * Scroll Bar Constants
' */
%SB_HORZ = 0&
%SB_VERT = 1&
%SB_CTL  = 2&
%SB_BOTH = 3&

'/*
' * Scroll Bar Commands
' */
%SB_LINEUP        = 0&
%SB_LINELEFT      = 0&
%SB_LINEDOWN      = 1&
%SB_LINERIGHT     = 1&
%SB_PAGEUP        = 2&
%SB_PAGELEFT      = 2&
%SB_PAGEDOWN      = 3&
%SB_PAGERIGHT     = 3&
%SB_THUMBPOSITION = 4&
%SB_THUMBTRACK    = 5&
%SB_TOP           = 6&
%SB_LEFT          = 6&
%SB_BOTTOM        = 7&
%SB_RIGHT         = 7&
%SB_ENDSCROLL     = 8&

'#endif /* !NOSCROLL */
'#ENDIF ' #IF NOT %DEF(%NOSCROLL) ----------------------------------------------

'#IF NOT %DEF(%NOSHOWWINDOW) '--------------------------------------------------
'#ifndef NOSHOWWINDOW

'/*
' * ShowWindow() Commands
' */
%SW_HIDE            = 0&
%SW_SHOWNORMAL      = 1&
%SW_NORMAL          = 1&
%SW_SHOWMINIMIZED   = 2&
%SW_SHOWMAXIMIZED   = 3&
%SW_MAXIMIZE        = 3&
%SW_SHOWNOACTIVATE  = 4&
%SW_SHOW            = 5&
%SW_MINIMIZE        = 6&
%SW_SHOWMINNOACTIVE = 7&
%SW_SHOWNA          = 8&
%SW_RESTORE         = 9&
%SW_SHOWDEFAULT     = 10&
%SW_FORCEMINIMIZE   = 11&
%SW_MAX             = 11&

'/*
' * Old ShowWindow() Commands
' */
%HIDE_WINDOW         = 0&
%SHOW_OPENWINDOW     = 1&
%SHOW_ICONWINDOW     = 2&
%SHOW_FULLSCREEN     = 3&
%SHOW_OPENNOACTIVATE = 4&

'/*
' * Identifiers for the WM_SHOWWINDOW message
' */
%SW_PARENTCLOSING = 1&
%SW_OTHERZOOM     = 2&
%SW_PARENTOPENING = 3&
%SW_OTHERUNZOOM   = 4&

'#endif /* !NOSHOWWINDOW */
'#ENDIF '#IF NOT %DEF(%NOSHOWWINDOW) '------------------------------------------

'#if(WINVER >= 0x0500)
'/*
' * AnimateWindow() Commands
' */
%AW_HOR_POSITIVE = &H00000001???
%AW_HOR_NEGATIVE = &H00000002???
%AW_VER_POSITIVE = &H00000004???
%AW_VER_NEGATIVE = &H00000008???
%AW_CENTER       = &H00000010???
%AW_HIDE         = &H00010000???
%AW_ACTIVATE     = &H00020000???
%AW_SLIDE        = &H00040000???
%AW_BLEND        = &H00080000???

'#endif /* WINVER >= 0x0500 */


'/*
' * WM_KEYUP/DOWN/CHAR HIWORD(lParam) flags
' */
%KF_EXTENDED = &H0100???
%KF_DLGMODE  = &H0800???
%KF_MENUMODE = &H1000???
%KF_ALTDOWN  = &H2000???
%KF_REPEAT   = &H4000???
%KF_UP       = &H8000???

'#IF NOT %DEF(%NOVIRTUALKEYCODES) '---------------------------------------------
'#ifndef NOVIRTUALKEYCODES

'/*
' * Virtual Keys, Standard Set
' */
%VK_LBUTTON    = &H01&
%VK_RBUTTON    = &H02&
%VK_CANCEL     = &H03&
%VK_MBUTTON    = &H04&    ' NOT contiguous with L RBUTTON

'#if(_WIN32_WINNT >= 0x0500)
%VK_XBUTTON1   = &H05&    ' NOT contiguous with L & RBUTTON
%VK_XBUTTON2   = &H06&    ' NOT contiguous with L & RBUTTON
'#endif /* _WIN32_WINNT >= 0x0500 */

'/*
' * 0x07 : unassigned
' */

%VK_BACK       = &H08&
%VK_TAB        = &H09&

'/*
' * 0x0A - 0x0B : reserved
' */

%VK_CLEAR      = &H0C&
%VK_RETURN     = &H0D&

%VK_SHIFT      = &H10&
%VK_CONTROL    = &H11&
%VK_MENU       = &H12&
%VK_PAUSE      = &H13&
%VK_CAPITAL    = &H14&

%VK_KANA       = &H15&
%VK_HANGEUL    = &H15&  ' old name - should be here for compatibility
%VK_HANGUL     = &H15&
%VK_JUNJA      = &H17&
%VK_FINAL      = &H18&
%VK_HANJA      = &H19&
%VK_KANJI      = &H19&

%VK_ESCAPE     = &H1B&

%VK_CONVERT    = &H1C&
%VK_NONCONVERT = &H1D&
%VK_ACCEPT     = &H1E&
%VK_MODECHANGE = &H1F&

%VK_SPACE      = &H20&
%VK_PGUP       = &H21&
%VK_PRIOR      = &H21&
%VK_NEXT       = &H22&
%VK_PGDN       = &H22&
%VK_END        = &H23&
%VK_HOME       = &H24&
%VK_LEFT       = &H25&
%VK_UP         = &H26&
%VK_RIGHT      = &H27&
%VK_DOWN       = &H28&
%VK_SELECT     = &H29&
%VK_PRINT      = &H2A&
%VK_EXECUTE    = &H2B&
%VK_SNAPSHOT   = &H2C&
%VK_INSERT     = &H2D&
%VK_DELETE     = &H2E&
%VK_HELP       = &H2F&

'/*
' * VK_0 - VK_9 are the same as ASCII '0' - '9' (0x30 - 0x39)
' * 0x40 : unassigned
' * VK_A - VK_Z are the same as ASCII 'A' - 'Z' (0x41 - 0x5A)
' */

%VK_0          = &H30&
%VK_1          = &H31&
%VK_2          = &H32&
%VK_3          = &H33&
%VK_4          = &H34&
%VK_5          = &H35&
%VK_6          = &H36&
%VK_7          = &H37&
%VK_8          = &H38&
%VK_9          = &H39&
%VK_A          = &H41&
%VK_B          = &H42&
%VK_C          = &H43&
%VK_D          = &H44&
%VK_E          = &H45&
%VK_F          = &H46&
%VK_G          = &H47&
%VK_H          = &H48&
%VK_I          = &H49&
%VK_J          = &H4A&
%VK_K          = &H4B&
%VK_L          = &H4C&
%VK_M          = &H4D&
%VK_N          = &H4E&
%VK_O          = &H4F&
%VK_P          = &H50&
%VK_Q          = &H51&
%VK_R          = &H52&
%VK_S          = &H53&
%VK_T          = &H54&
%VK_U          = &H55&
%VK_V          = &H56&
%VK_W          = &H57&
%VK_X          = &H58&
%VK_Y          = &H59&
%VK_Z          = &H5A&

%VK_LWIN       = &H5B&
%VK_RWIN       = &H5C&
%VK_APPS       = &H5D&

'/*
' * 0x5E : reserved
' */

%VK_SLEEP      = &H5F&

%VK_NUMPAD0    = &H60&
%VK_NUMPAD1    = &H61&
%VK_NUMPAD2    = &H62&
%VK_NUMPAD3    = &H63&
%VK_NUMPAD4    = &H64&
%VK_NUMPAD5    = &H65&
%VK_NUMPAD6    = &H66&
%VK_NUMPAD7    = &H67&
%VK_NUMPAD8    = &H68&
%VK_NUMPAD9    = &H69&
%VK_MULTIPLY   = &H6A&
%VK_ADD        = &H6B&
%VK_SEPARATOR  = &H6C&
%VK_SUBTRACT   = &H6D&
%VK_DECIMAL    = &H6E&
%VK_DIVIDE     = &H6F&
%VK_F1         = &H70&
%VK_F2         = &H71&
%VK_F3         = &H72&
%VK_F4         = &H73&
%VK_F5         = &H74&
%VK_F6         = &H75&
%VK_F7         = &H76&
%VK_F8         = &H77&
%VK_F9         = &H78&
%VK_F10        = &H79&
%VK_F11        = &H7A&
%VK_F12        = &H7B&
%VK_F13        = &H7C&
%VK_F14        = &H7D&
%VK_F15        = &H7E&
%VK_F16        = &H7F&
%VK_F17        = &H80&
%VK_F18        = &H81&
%VK_F19        = &H82&
%VK_F20        = &H83&
%VK_F21        = &H84&
%VK_F22        = &H85&
%VK_F23        = &H86&
%VK_F24        = &H87&

'/*
' * 0x88 - 0x8F : unassigned
' */

%VK_NUMLOCK    = &H90&
%VK_SCROLL     = &H91&

'/*
' * NEC PC-9800 kbd definitions
' */
%VK_OEM_NEC_EQUAL  = &H92&   ' "=" key on numpad

'/*
' * Fujitsu/OASYS kbd definitions
' */
%VK_OEM_FJ_JISHO   = &H92&   ' "Dictionary" key
%VK_OEM_FJ_MASSHOU = &H93&   ' "Unregister word" key
%VK_OEM_FJ_TOUROKU = &H94&   ' "Register word" key
%VK_OEM_FJ_LOYA    = &H95&   ' "Left OYAYUBI" key
%VK_OEM_FJ_ROYA    = &H96&   ' "Right OYAYUBI" key

'/*
' * 0x97 - 0x9F : unassigned
' */

'/*
' * VK_L* & VK_R* - left and right Alt, Ctrl and Shift virtual keys.
' * Used only as parameters to GetAsyncKeyState() and GetKeyState().
' * No other API or message will distinguish left and right keys in this way.
' */
%VK_LSHIFT   = &HA0&
%VK_RSHIFT   = &HA1&
%VK_LCONTROL = &HA2&
%VK_RCONTROL = &HA3&
%VK_LMENU    = &HA4&
%VK_RMENU    = &HA5&

'#if(_WIN32_WINNT >= 0x0500)
%VK_BROWSER_BACK        = &HA6&
%VK_BROWSER_FORWARD     = &HA7&
%VK_BROWSER_REFRESH     = &HA8&
%VK_BROWSER_STOP        = &HA9&
%VK_BROWSER_SEARCH      = &HAA&
%VK_BROWSER_FAVORITES   = &HAB&
%VK_BROWSER_HOME        = &HAC&

%VK_VOLUME_MUTE         = &HAD&
%VK_VOLUME_DOWN         = &HAE&
%VK_VOLUME_UP           = &HAF&
%VK_MEDIA_NEXT_TRACK    = &HB0&
%VK_MEDIA_PREV_TRACK    = &HB1&
%VK_MEDIA_STOP          = &HB2&
%VK_MEDIA_PLAY_PAUSE    = &HB3&
%VK_LAUNCH_MAIL         = &HB4&
%VK_LAUNCH_MEDIA_SELECT = &HB5&
%VK_LAUNCH_APP1         = &HB6&
%VK_LAUNCH_APP2         = &HB7&

'#endif /* _WIN32_WINNT >= 0x0500 */

'/*
' * 0xB8 - 0xB9 : reserved
' */

%VK_OEM_1        = &HBA&   ' ";:" for US
%VK_OEM_PLUS     = &HBB&   ' "+" any country
%VK_OEM_COMMA    = &HBC&   ' "," any country
%VK_OEM_MINUS    = &HBD&   ' "-" any country
%VK_OEM_PERIOD   = &HBE&   ' "." any country
%VK_OEM_2        = &HBF&   ' "/?" for US
%VK_OEM_3        = &HC0&   ' "`~" for US

'/*
' * 0xC1 - 0xD7 : reserved
' */

'/*
' * 0xD8 - 0xDA : unassigned
' */

%VK_OEM_4        = &HDB&  ' "[{" for US
%VK_OEM_5        = &HDC&  ' "\|" for US
%VK_OEM_6        = &HDD&  ' "]}" for US
%VK_OEM_7        = &HDE&  ' """" for US
%VK_OEM_8        = &HDF&

'/*
' * 0xE0 : reserved
' */

'/*
' * Various extended or enhanced keyboards
' */
%VK_OEM_AX       = &HE1&  ' "AX" key on Japanese AX kbd
%VK_OEM_102      = &HE2&  ' "<>" or "\|" on RT 102-key kbd.
%VK_ICO_HELP     = &HE3&  ' Help key on ICO
%VK_ICO_00       = &HE4&  ' 00 key on ICO

'#if(WINVER >= 0x0400)
%VK_PROCESSKEY   = &HE5&
'#endif /* WINVER >= 0x0400 */

%VK_ICO_CLEAR    = &HE6


'#if(_WIN32_WINNT >= 0x0500)
%VK_PACKET       = &HE7&
'#endif /* _WIN32_WINNT >= 0x0500 */

'/*
' * 0xE8 : unassigned
' */

'/*
' * Nokia/Ericsson definitions
' */
%VK_OEM_RESET    = &HE9&
%VK_OEM_JUMP     = &HEA&
%VK_OEM_PA1      = &HEB&
%VK_OEM_PA2      = &HEC&
%VK_OEM_PA3      = &HED&
%VK_OEM_WSCTRL   = &HEE&
%VK_OEM_CUSEL    = &HEF&
%VK_OEM_ATTN     = &HF0&
%VK_OEM_FINISH   = &HF1&
%VK_OEM_COPY     = &HF2&
%VK_OEM_AUTO     = &HF3&
%VK_OEM_ENLW     = &HF4&
%VK_OEM_BACKTAB  = &HF5&

%VK_ATTN         = &HF6&
%VK_CRSEL        = &HF7&
%VK_EXSEL        = &HF8&
%VK_EREOF        = &HF9&
%VK_PLAY         = &HFA&
%VK_ZOOM         = &HFB&
%VK_NONAME       = &HFC&
%VK_PA1          = &HFD&
%VK_OEM_CLEAR    = &HFE&

'/*
' * 0xFF : reserved
' */

'#endif /* !NOVIRTUALKEYCODES */
'#ENDIF '#IF NOT %DEF(%NOVIRTUALKEYCODES) '-------------------------------------

'#IF NOT %DEF(%NOWH) '---------------------------------------------
'#ifndef NOWH

'/*
' * SetWindowsHook() codes
' */
%WH_MIN             = -1&
%WH_MSGFILTER       = -1&
%WH_JOURNALRECORD   = 0&
%WH_JOURNALPLAYBACK = 1&
%WH_KEYBOARD        = 2&
%WH_GETMESSAGE      = 3&
%WH_CALLWNDPROC     = 4&
%WH_CBT             = 5&
%WH_SYSMSGFILTER    = 6&
%WH_MOUSE           = 7&

'#if defined(_WIN32_WINDOWS)
%WH_HARDWARE        = 8&
'#endif

%WH_DEBUG           = 9&
%WH_SHELL           = 10&
%WH_FOREGROUNDIDLE  = 11&

'#if(WINVER >= 0x0400)
%WH_CALLWNDPROCRET  = 12&
'#endif /* WINVER >= 0x0400 */

'#if (_WIN32_WINNT >= 0x0400)
%WH_KEYBOARD_LL     = 13&
%WH_MOUSE_LL        = 14&
'#endif // (_WIN32_WINNT >= 0x0400)

'#if(WINVER >= 0x0400)
'#if (_WIN32_WINNT >= 0x0400)
'#define WH_MAX             14
'#else
'#define WH_MAX             12
'#endif // (_WIN32_WINNT >= 0x0400)
'#else
'#define WH_MAX             11
'#endif
%WH_MAX             = 14&   ' depending on Windows version

%WH_MINHOOK         = %WH_MIN
%WH_MAXHOOK         = %WH_MAX

'/*
' * Hook Codes
' */
%HC_ACTION      = 0&
%HC_GETNEXT     = 1&
%HC_SKIP        = 2&
%HC_NOREMOVE    = 3&
%HC_NOREM       = %HC_NOREMOVE
%HC_SYSMODALON  = 4&
%HC_SYSMODALOFF = 5&

'/*
' * CBT Hook Codes
' */
%HCBT_MOVESIZE     = 0&
%HCBT_MINMAX       = 1&
%HCBT_QS           = 2&
%HCBT_CREATEWND    = 3&
%HCBT_DESTROYWND   = 4&
%HCBT_ACTIVATE     = 5&
%HCBT_CLICKSKIPPED = 6&
%HCBT_KEYSKIPPED   = 7&
%HCBT_SYSCOMMAND   = 8&
%HCBT_SETFOCUS     = 9&

'/*
' * HCBT_ACTIVATE structure pointed to by lParam
' */

TYPE CBTACTIVATESTRUCT
   fMouse     AS LONG    ' BOOL    fMouse
   hWndActive AS DWORD   ' HWND    hWndActive
END TYPE

'#if(_WIN32_WINNT >= 0x0501)
'/*
' * WTSSESSION_NOTIFICATION struct pointed by lParam, for WM_WTSSESSION_CHANGE
' */

TYPE WTSSESSION_NOTIFICATION
   cbSize      AS DWORD   ' DWORD cbSize
   dwSessionId AS DWORD   ' DWORD dwSessionId
END TYPE

'/*
' * codes passed in WPARAM for WM_WTSSESSION_CHANGE
' */

%WTS_CONSOLE_CONNECT        = 1&
%WTS_CONSOLE_DISCONNECT     = 2&
%WTS_REMOTE_CONNECT         = 3&
%WTS_REMOTE_DISCONNECT      = 4&
%WTS_SESSION_LOGON          = 5&
%WTS_SESSION_LOGOFF         = 6&
%WTS_SESSION_LOCK           = 7&
%WTS_SESSION_UNLOCK         = 8&
%WTS_SESSION_REMOTE_CONTROL = 9&

'#endif /* _WIN32_WINNT >= 0x0501 */

'/*
' * WH_MSGFILTER Filter Proc Codes
' */
%MSGF_DIALOGBOX  = 0&
%MSGF_MESSAGEBOX = 1&
%MSGF_MENU       = 2&
%MSGF_MOVE       = 3&
%MSGF_SIZE       = 4&
%MSGF_SCROLLBAR  = 5&
%MSGF_NEXTWINDOW = 6&
%MSGF_MAX        = 8&
%MSGF_USER       = 4096&

'/*
' * Shell support
' */
%HSHELL_WINDOWCREATED       = 1&
%HSHELL_WINDOWDESTROYED     = 2&
%HSHELL_ACTIVATESHELLWINDOW = 3&

'#if(WINVER >= 0x0400)
%HSHELL_WINDOWACTIVATED     = 4&
%HSHELL_GETMINRECT          = 5&
%HSHELL_REDRAW              = 6&
%HSHELL_TASKMAN             = 7&
%HSHELL_LANGUAGE            = 8&
%HSHELL_SYSMENU             = 9&
%HSHELL_ENDTASK             = 10&

'#endif /* WINVER >= 0x0400 */
'#if(_WIN32_WINNT >= 0x0500)
%HSHELL_ACCESSIBILITYSTATE  = 11&
%HSHELL_APPCOMMAND          = 12&
'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(_WIN32_WINNT >= 0x0501)
%HSHELL_WINDOWREPLACED      = 13&
%HSHELL_WINDOWREPLACING     = 14&
'#endif /* _WIN32_WINNT >= 0x0501 */

%HSHELL_HIGHBIT            = &H8000???
%HSHELL_FLASH              = %HSHELL_REDRAW OR %HSHELL_HIGHBIT
%HSHELL_RUDEAPPACTIVATED   = %HSHELL_WINDOWACTIVATED OR %HSHELL_HIGHBIT

'#if(_WIN32_WINNT >= 0x0500)
'/* wparam for HSHELL_ACCESSIBILITYSTATE */
%ACCESS_STICKYKEYS = &H0001???
%ACCESS_FILTERKEYS = &H0002???
%ACCESS_MOUSEKEYS  = &H0003???


%APPCOMMAND_BROWSER_BACKWARD       = 1&
%APPCOMMAND_BROWSER_FORWARD        = 2&
%APPCOMMAND_BROWSER_REFRESH        = 3&
%APPCOMMAND_BROWSER_STOP           = 4&
%APPCOMMAND_BROWSER_SEARCH         = 5&
%APPCOMMAND_BROWSER_FAVORITES      = 6&
%APPCOMMAND_BROWSER_HOME           = 7&
%APPCOMMAND_VOLUME_MUTE            = 8&
%APPCOMMAND_VOLUME_DOWN            = 9&
%APPCOMMAND_VOLUME_UP              = 10&
%APPCOMMAND_MEDIA_NEXTTRACK        = 11&
%APPCOMMAND_MEDIA_PREVIOUSTRACK    = 12&
%APPCOMMAND_MEDIA_STOP             = 13&
%APPCOMMAND_MEDIA_PLAY_PAUSE       = 14&
%APPCOMMAND_LAUNCH_MAIL            = 15&
%APPCOMMAND_LAUNCH_MEDIA_SELECT    = 16&
%APPCOMMAND_LAUNCH_APP1            = 17&
%APPCOMMAND_LAUNCH_APP2            = 18&
%APPCOMMAND_BASS_DOWN              = 19&
%APPCOMMAND_BASS_BOOST             = 20&
%APPCOMMAND_BASS_UP                = 21&
%APPCOMMAND_TREBLE_DOWN            = 22&
%APPCOMMAND_TREBLE_UP              = 23&
'#if(_WIN32_WINNT >= 0x0501)
%APPCOMMAND_MICROPHONE_VOLUME_MUTE = 24&
%APPCOMMAND_MICROPHONE_VOLUME_DOWN = 25&
%APPCOMMAND_MICROPHONE_VOLUME_UP   = 26&
%APPCOMMAND_HELP                   = 27&
%APPCOMMAND_FIND                   = 28&
%APPCOMMAND_NEW                    = 29&
%APPCOMMAND_OPEN                   = 30&
%APPCOMMAND_CLOSE                  = 31&
%APPCOMMAND_SAVE                   = 32&
%APPCOMMAND_PRINT                  = 33&
%APPCOMMAND_UNDO                   = 34&
%APPCOMMAND_REDO                   = 35&
%APPCOMMAND_COPY                   = 36&
%APPCOMMAND_CUT                    = 37&
%APPCOMMAND_PASTE                  = 38&
%APPCOMMAND_REPLY_TO_MAIL          = 39&
%APPCOMMAND_FORWARD_MAIL           = 40&
%APPCOMMAND_SEND_MAIL              = 41&
%APPCOMMAND_SPELL_CHECK            = 42&
%APPCOMMAND_DICTATE_OR_COMMAND_CONTROL_TOGGLE = 43&
%APPCOMMAND_MIC_ON_OFF_TOGGLE      = 44&
%APPCOMMAND_CORRECTION_LIST        = 45&
%APPCOMMAND_MEDIA_PLAY             = 46&
%APPCOMMAND_MEDIA_PAUSE            = 47&
%APPCOMMAND_MEDIA_RECORD           = 48&
%APPCOMMAND_MEDIA_FAST_FORWARD     = 49&
%APPCOMMAND_MEDIA_REWIND           = 50&
%APPCOMMAND_MEDIA_CHANNEL_UP       = 51&
%APPCOMMAND_MEDIA_CHANNEL_DOWN     = 52&
'#endif /* _WIN32_WINNT >= 0x0501 */
'#if(_WIN32_WINNT >= 0x0600)
%APPCOMMAND_DELETE                 = 53&
%APPCOMMAND_DWM_FLIP3D             = 54&
'#endif /* _WIN32_WINNT >= 0x0600 */

%FAPPCOMMAND_MOUSE = &H8000??
%FAPPCOMMAND_KEY   = 0??
%FAPPCOMMAND_OEM   = &H1000??
%FAPPCOMMAND_MASK  = &HF000??

'#define GET_APPCOMMAND_LPARAM(lParam) ((short)(HIWORD(lParam) & ~FAPPCOMMAND_MASK))
'#define GET_DEVICE_LPARAM(lParam)     ((WORD)(HIWORD(lParam) & FAPPCOMMAND_MASK))
'#define GET_MOUSEORKEY_LPARAM         GET_DEVICE_LPARAM
'#define GET_FLAGS_LPARAM(lParam)      (LOWORD(lParam))
'#define GET_KEYSTATE_LPARAM(lParam)   GET_FLAGS_LPARAM(lParam)

MACRO GET_APPCOMMAND_LPARAM(lParam) = (HI(WORD, lParam) AND (NOT %FAPPCOMMAND_MASK)
MACRO GET_DEVICE_LPARAM(lParam)     = (HI(WORD, lParam) AND %FAPPCOMMAND_MASK)
MACRO GET_MOUSEORKEY_LPARAM         = GET_DEVICE_LPARAM
MACRO GET_FLAGS_LPARAM(lParam)      = LO(WORD, lParam)
MACRO GET_KEYSTATE_LPARAM(lParam)   = GET_FLAGS_LPARAM(lParam)

'#endif /* _WIN32_WINNT >= 0x0500 */

TYPE SHELLHOOKINFO
   hwnd AS DWORD   ' HWND    hwnd
   rc   AS RECT    ' RECT    rc
END TYPE

'/*
' * Message Structure used in Journaling
' */

TYPE EVENTMSG
   message AS DWORD   ' UINT    message
   paramL  AS DWORD   ' UINT    paramL
   paramH  AS DWORD   ' UINT    paramH
   time    AS DWORD   ' DWORD   time
   hwnd    AS DWORD   ' HWND    hwnd
END TYPE

'/*
' * Message structure used by WH_CALLWNDPROC
' */

TYPE CWPSTRUCT
   lParam  AS LONG    ' LPARAM  lParam
   wParam  AS LONG    ' WPARAM  wParam
   message AS DWORD   ' UINT    message
   hwnd    AS DWORD   ' HWND    hwnd
END TYPE

'#if(WINVER >= 0x0400)
'/*
' * Message structure used by WH_CALLWNDPROCRET
' */

TYPE CWPRETSTRUCT
   lResult AS LONG    ' LRESULT lResult
   lParam  AS LONG    ' LPARAM  lParam
   wParam  AS DWORD   ' WPARAM  wParam
   message AS DWORD   ' UINT    message
   hwnd    AS DWORD   ' HWND    hwnd
END TYPE

'#endif /* WINVER >= 0x0400 */

'#if (_WIN32_WINNT >= 0x0400)

'/*
' * Low level hook flags
' */

'#define LLKHF_EXTENDED       (KF_EXTENDED >> 8)
'#define LLKHF_INJECTED       0x00000010
'#define LLKHF_ALTDOWN        (KF_ALTDOWN >> 8)
'#define LLKHF_UP             (KF_UP >> 8)

%LLKHF_EXTENDED = &H00000001???
%LLKHF_INJECTED = &H00000010???
%LLKHF_ALTDOWN  = &H00000020???
%LLKHF_UP       = &H00000080???

%LLMHF_INJECTED = &H00000001???

'/*
' * Structure used by WH_KEYBOARD_LL
' */

TYPE KBDLLHOOKSTRUCT
   vkCode      AS DWORD   ' DWORD     vkCode
   scanCode    AS DWORD   ' DWORD     scanCode
   flags       AS DWORD   ' DWORD     flags
   time        AS DWORD   ' DWORD     time
   dwExtraInfo AS DWORD   ' ULONG_PTR dwExtraInfo
END TYPE

'/*
' * Structure used by WH_MOUSE_LL
' */

TYPE MSLLHOOKSTRUCT
   pt          AS POINTAPI   ' POINT     pt
   mouseData   AS DWORD      ' DWORD     mouseData
   flags       AS DWORD      ' DWORD     flags
   time        AS DWORD      ' DWORD     time
   dwExtraInfo AS DWORD      ' ULONG_PTR dwExtraInfo
END TYPE

'#endif // (_WIN32_WINNT >= 0x0400)

'/*
' * Structure used by WH_DEBUG
' */

TYPE DEBUGHOOKINFO
   idThread          AS DWORD   ' DWORD   idThread
   idThreadInstaller AS DWORD   ' DWORD   idThreadInstaller
   lParam            AS LONG    ' LPARAM  lParam
   wParam            AS DWORD   ' WPARAM  wParam
   code              AS LONG    ' int     code
END TYPE

'/*
' * Structure used by WH_MOUSE
' */

TYPE MOUSEHOOKSTRUCT
   pt           AS POINTAPI   ' POINT   pt
   hwnd         AS DWORD      ' HWND    hwnd
   wHitTestCode AS DWORD      ' UINT    wHitTestCode
   dwExtraInfo  AS DWORD      ' UINT    wHitTestCode
END TYPE

TYPE MOUSEHOOKSTRUCTEX
   MOUSEHOOKSTRUCT
   mouseData AS DWORD   ' DWORD   mouseData
END TYPE

'#endif
'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(WINVER >= 0x0400)
'/*
' * Structure used by WH_HARDWARE
' */

TYPE HARDWAREHOOKSTRUCT
   hwnd    AS DWORD   ' HWND    hwnd
   message AS DWORD   ' UINT    message
   wParam  AS DWORD   ' WPARAM  wParam
   lParam  AS LONG    ' LPARAM  lParam
END TYPE

'#endif /* WINVER >= 0x0400 */
'#endif /* !NOWH */

'#ENDIF '#IF NOT %DEF(%NOWH) '-------------------------------------

'/*
' * Keyboard Layout API
' */

%HKL_PREV = 0???
%HKL_NEXT = 1???

%KLF_ACTIVATE       = &H00000001???
%KLF_SUBSTITUTE_OK  = &H00000002???
%KLF_UNLOADPREVIOUS = &H00000004???
%KLF_REORDER        = &H00000008???
'#if(WINVER >= 0x0400)
%KLF_REPLACELANG    = &H00000010???
%KLF_NOTELLSHELL    = &H00000080???
'#endif /* WINVER >= 0x0400 */
'#endif /* WINVER >= 0x0400 */
%KLF_SETFORPROCESS  = &H00000100???
%KLF_SHIFTLOCK      = &H00010000???
%KLF_RESET          = &H40000000???
'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(WINVER >= 0x0500)
'/*
' * Bits in wParam of WM_INPUTLANGCHANGEREQUEST message
' */
%INPUTLANGCHANGE_SYSCHARSET = &H0001???
%INPUTLANGCHANGE_FORWARD    = &H0002???
%INPUTLANGCHANGE_BACKWARD   = &H0004???
'#endif /* WINVER >= 0x0500 */

'/*
' * Size of KeyboardLayoutName (number of characters), including nul terminator
' */
%KL_NAMELENGTH = 9

DECLARE FUNCTION LoadKeyboardLayout LIB "USER32.DLL" ALIAS "LoadKeyboardLayoutA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR pwszKLID
 , BYVAL DWORD _                       ' __in UINT Flags
 ) AS DWORD                            ' HKL

DECLARE FUNCTION LoadKeyboardLayoutW LIB "USER32.DLL" ALIAS "LoadKeyboardLayoutW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR pwszKLID
 , BYVAL DWORD _                       ' __in UINT Flags
 ) AS DWORD                            ' HKL

DECLARE FUNCTION ActivateKeyboardLayout LIB "USER32.DLL" ALIAS "ActivateKeyboardLayout" ( _
   BYVAL DWORD _                       ' __in HKL hkl
 , BYVAL DWORD _                       ' __in UINT Flags
 ) AS DWORD                            ' HKL

'#if(WINVER >= 0x0400)
DECLARE FUNCTION ToUnicodeEx LIB "USER32.DLL" ALIAS "ToUnicodeEx" ( _
   BYVAL DWORD _                       ' __in UINT wVirtKey
 , BYVAL DWORD _                       ' __in UINT wScanCode
 , BYREF BYTE _                        ' __in_bcount(256) CONST BYTE *lpKeyState
 , BYVAL DWORD _                       ' __out_ecount(cchBuff) LPWSTR pwszBuff
 , BYVAL LONG _                        ' __in int cchBuff
 , BYVAL DWORD _                       ' __in UINT wFlags,
 , BYVAL DWORD _                       ' __in_opt HKL dwhkl
 ) AS LONG                             ' int
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION UnloadKeyboardLayout LIB "USER32.DLL" ALIAS "UnloadKeyboardLayout" ( _
   BYVAL DWORD _                       ' __in HKL hkl
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetKeyboardLayoutName LIB "USER32.DLL" ALIAS "GetKeyboardLayoutNameA" ( _
   BYREF ASCIIZ _                      ' __out_ecount(KL_NAMELENGTH) LPSTR pwszKLID
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetKeyboardLayoutNameW LIB "USER32.DLL" ALIAS "GetKeyboardLayoutNameW" ( _
   BYVAL DWORD _                       ' __out_ecount(KL_NAMELENGTH) LPWSTR pwszKLID
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetKeyboardLayoutList LIB "USER32.DLL" ALIAS "GetKeyboardLayoutList" ( _
   BYVAL LONG _                        ' __in int nBuff
 , BYREF DWORD _                       ' __out_ecount_part_opt(nBuff, return) HKL FAR *lpList
 ) AS LONG                             ' int

DECLARE FUNCTION GetKeyboardLayout LIB "USER32.DLL" ALIAS "GetKeyboardLayout" ( _
   BYVAL DWORD _                       ' __in DWORD idThread
 ) AS DWORD                            ' HKL

'#if(WINVER >= 0x0500)

TYPE MOUSEMOVEPOINT
   x           AS LONG    ' int   x
   y           AS LONG    ' int   y
   time        AS DWORD   ' DWORD time
   dwExtraInfo AS DWORD   ' ULONG_PTR dwExtraInfo
END TYPE

'/*
' * Values for resolution parameter of GetMouseMovePointsEx
' */
%GMMP_USE_DISPLAY_POINTS         = 1&
%GMMP_USE_HIGH_RESOLUTION_POINTS = 2&

DECLARE FUNCTION GetMouseMovePointsEx LIB "USER32.DLL" ALIAS "GetMouseMovePointsEx" ( _
   BYVAL DWORD _                       ' __in UINT cbSize
 , BYREF MOUSEMOVEPOINT _              ' __in LPMOUSEMOVEPOINT lppt
 , BYREF MOUSEMOVEPOINT _              ' __out_ecount(nBufPoints) LPMOUSEMOVEPOINT lpptBuf
 , BYVAL LONG _                        ' __in int nBufPoints
 , BYVAL DWORD _                       ' __in DWORD resolution
 ) AS LONG                             ' int

'#endif /* WINVER >= 0x0500 */

'#IF NOT %DEF(%NODESKTOP) '----------------------------
'#ifndef NODESKTOP

'/*
' * Desktop-specific access flags
' */
%DESKTOP_READOBJECTS      = &H0001???
%DESKTOP_CREATEWINDOW     = &H0002???
%DESKTOP_CREATEMENU       = &H0004???
%DESKTOP_HOOKCONTROL      = &H0008???
%DESKTOP_JOURNALRECORD    = &H0010???
%DESKTOP_JOURNALPLAYBACK  = &H0020???
%DESKTOP_ENUMERATE        = &H0040???
%DESKTOP_WRITEOBJECTS     = &H0080???
%DESKTOP_SWITCHDESKTOP    = &H0100???

'/*
' * Desktop-specific control flags
' */
%DF_ALLOWOTHERACCOUNTHOOK = &H0001???

'#IF %DEF (%WINGDI_INC)
'#IF NOT %DEF(%NOGDI)
'#ifdef _WINGDI_
'#ifndef NOGDI

DECLARE FUNCTION CreateDesktop LIB "USER32.DLL" ALIAS "CreateDesktopA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszDesktop
 , BYREF ASCIIZ _                      ' __reserved LPCSTR lpszDevice
 , BYREF DEVMODEA _                    ' __reserved LPDEVMODEA pDevmode
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpsa
 ) AS DWORD                            ' HDESK

DECLARE FUNCTION CreateDesktopW LIB "USER32.DLL" ALIAS "CreateDesktopW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszDesktop
 , BYVAL DWORD _                       ' __reserved LPCWSTR lpszDevice
 , BYREF DEVMODEW _                    ' __reserved LPDEVMODEW pDevmode
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpsa
 ) AS DWORD                            ' HDESK

DECLARE FUNCTION CreateDesktopEx LIB "USER32.DLL" ALIAS "CreateDesktopExA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszDesktop
 , BYREF ASCIIZ _                      ' __reserved LPCSTR lpszDevice
 , BYREF DEVMODEA _                    ' __reserved LPDEVMODEA pDevmode
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpsa
 , BYVAL DWORD _                       ' __in ULONG ulHeapSize
 , BYVAL DWORD _                       ' __reserved PVOID pvoid
 ) AS DWORD                            ' HDESK

DECLARE FUNCTION CreateDesktopExW LIB "USER32.DLL" ALIAS "CreateDesktopExW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszDesktop
 , BYVAL DWORD _                       ' __reserved LPCWSTR lpszDevice
 , BYREF DEVMODEW _                    ' __reserved LPDEVMODEW pDevmode
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpsa
 , BYVAL DWORD _                       ' __in ULONG ulHeapSize
 , BYVAL DWORD _                       ' __reserved PVOID pvoid
 ) AS DWORD                            ' HDESK

'#endif /* NOGDI */
'#endif /* _WINGDI_ */

'#ENDIF    ' /* %NOGDI */
'#ENDIF    ' /* %WINGDI_INC */

DECLARE FUNCTION OpenDesktop LIB "USER32.DLL" ALIAS "OpenDesktopA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszDesktop
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL LONG _                        ' __in BOOL fInherit
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 ) AS DWORD                            ' HDESK

DECLARE FUNCTION OpenDesktopW LIB "USER32.DLL" ALIAS "OpenDesktopW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszDesktop
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL LONG _                        ' __in BOOL fInherit
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 ) AS DWORD                            ' HDESK

DECLARE FUNCTION OpenInputDesktop LIB "USER32.DLL" ALIAS "OpenInputDesktop" ( _
   BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL LONG _                        ' __in BOOL fInherit
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 ) AS DWORD                            ' HDESK

DECLARE FUNCTION EnumDesktops LIB "USER32.DLL" ALIAS "EnumDesktopsA" ( _
   BYVAL DWORD _                       ' __in_opt HWINSTA hwinsta
 , BYVAL DWORD _                       ' __in DESKTOPENUMPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumDesktopsW LIB "USER32.DLL" ALIAS "EnumDesktopsW" ( _
   BYVAL DWORD _                       ' __in_opt HWINSTA hwinsta
 , BYVAL DWORD _                       ' __in DESKTOPENUMPROCW lpEnumFunc
 , BYVAL LONG _                        ' __in LPARAM lParam)
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumDesktopWindows LIB "USER32.DLL" ALIAS "EnumDesktopWindows" ( _
   BYVAL DWORD _                       ' __in_opt HDESK hDesktop
 , BYVAL DWORD _                       ' __in WNDENUMPROC lpfn
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SwitchDesktop LIB "USER32.DLL" ALIAS "SwitchDesktop" ( _
   BYVAL DWORD _                       ' __in HDESK hDesktop
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetThreadDesktop LIB "USER32.DLL" ALIAS "SetThreadDesktop" ( _
   BYVAL DWORD _                       ' __in HDESK hDesktop
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CloseDesktop LIB "USER32.DLL" ALIAS "CloseDesktop" ( _
   BYVAL DWORD _                       ' __in HDESK hDesktop
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetThreadDesktop LIB "USER32.DLL" ALIAS "GetThreadDesktop" ( _
   BYVAL DWORD _                       ' __in DWORD dwThreadId
 ) AS DWORD                            ' HDESK

'#endif  /* !NODESKTOP */
'#ENDIF ' #IF NOT %DEF(%NODESKTOP) '-------------------

'#IF NOT %DEF(%NOWINDOWSTATION) '----------------------
'#ifndef NOWINDOWSTATION

'/*
' * Windowstation-specific access flags
' */
%WINSTA_ENUMDESKTOPS      = &H0001???
%WINSTA_READATTRIBUTES    = &H0002???
%WINSTA_ACCESSCLIPBOARD   = &H0004???
%WINSTA_CREATEDESKTOP     = &H0008???
%WINSTA_WRITEATTRIBUTES   = &H0010???
%WINSTA_ACCESSGLOBALATOMS = &H0020???
%WINSTA_EXITWINDOWS       = &H0040???
%WINSTA_ENUMERATE         = &H0100???
%WINSTA_READSCREEN        = &H0200???

%WINSTA_ALL_ACCESS        = %WINSTA_ENUMDESKTOPS OR %WINSTA_READATTRIBUTES OR %WINSTA_ACCESSCLIPBOARD OR _
                            %WINSTA_CREATEDESKTOP OR %WINSTA_WRITEATTRIBUTES OR %WINSTA_ACCESSGLOBALATOMS OR _
                            %WINSTA_EXITWINDOWS OR %WINSTA_ENUMERATE OR %WINSTA_READSCREEN

'/*
' * Windowstation creation flags.
' */
%CWF_CREATE_ONLY          = &H00000001???

'/*
' * Windowstation-specific attribute flags
' */
%WSF_VISIBLE              = &H0001???

DECLARE FUNCTION CreateWindowStation LIB "USER32.DLL" ALIAS "CreateWindowStationA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpwinsta
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpsa
 ) AS DWORD                            ' HWINSTA

DECLARE FUNCTION CreateWindowStationW LIB "USER32.DLL" ALIAS "CreateWindowStationW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpwinsta
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 , BYREF SECURITY_ATTRIBUTES _         ' __in_opt LPSECURITY_ATTRIBUTES lpsa
 ) AS DWORD                            ' HWINSTA

DECLARE FUNCTION OpenWindowStation LIB "USER32.DLL" ALIAS "OpenWindowStationA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszWinSta,
 , BYVAL LONG _                        ' __in BOOL fInherit
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 ) AS DWORD                            ' HWINSTA

DECLARE FUNCTION OpenWindowStationW LIB "USER32.DLL" ALIAS "OpenWindowStationW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszWinSta,
 , BYVAL LONG _                        ' __in BOOL fInherit
 , BYVAL DWORD _                       ' __in ACCESS_MASK dwDesiredAccess
 ) AS DWORD                            ' HWINSTA

DECLARE FUNCTION EnumWindowStations LIB "USER32.DLL" ALIAS "EnumWindowStationsA" ( _
   BYVAL DWORD _                       ' __in WINSTAENUMPROCA lpEnumFunc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumWindowStationsW LIB "USER32.DLL" ALIAS "EnumWindowStationsW" ( _
   BYVAL DWORD _                       ' __in WINSTAENUMPROCW lpEnumFunc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CloseWindowStation LIB "USER32.DLL" ALIAS "CloseWindowStation" ( _
   BYVAL DWORD _                       ' __in HWINSTA hWinSta
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetProcessWindowStation LIB "USER32.DLL" ALIAS "SetProcessWindowStation" ( _
   BYVAL DWORD _                       ' __in HWINSTA hWinSta
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProcessWindowStation LIB "USER32.DLL" ALIAS "GetProcessWindowStation" ( _
 ) AS DWORD                            ' HWINSTA

'#endif  /* !NOWINDOWSTATION */
'#ENDIF ' #IF NOT %DEF(%NOWINDOWSTATION) '-------------


'#IF NOT %DEF(%NOSECURITY) ' -----------------------------------
'#ifndef NOSECURITY

DECLARE FUNCTION SetUserObjectSecurity LIB "USER32.DLL" ALIAS "SetUserObjectSecurity" ( _
   BYVAL DWORD _                       ' __in HANDLE hObj
 , BYREF DWORD _                       ' __in PSECURITY_INFORMATION pSIRequested
 , BYREF SECURITY_DESCRIPTOR _         ' __in PSECURITY_DESCRIPTOR pSID
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetUserObjectSecurity LIB "USER32.DLL" ALIAS "GetUserObjectSecurity" ( _
   BYVAL DWORD _                       ' __in HANDLE hObj
 , BYREF DWORD _                       ' __in PSECURITY_INFORMATION pSIRequested
 , BYREF SECURITY_DESCRIPTOR _         ' __out_bcount_opt(nLength) PSECURITY_DESCRIPTOR pSID
 , BYVAL DWORD _                       ' __in DWORD nLength
 , BYREF DWORD _                       ' __out LPDWORD lpnLengthNeeded
 ) AS LONG                             ' BOOL

%UOI_FLAGS    = 1&
%UOI_NAME     = 2&
%UOI_TYPE     = 3&
%UOI_USER_SID = 4&
'#if(WINVER >= 0x0600)
%UOI_HEAPSIZE = 5&
%UOI_IO       = 6&
'#endif /* WINVER >= 0x0600 */

TYPE USEROBJECTFLAGS
   fInherit  AS LONG    ' BOOL fInherit
   fReserved AS LONG    ' BOOL fReserved
   dwFlags   AS DWORD   ' DWORD dwFlags
END TYPE

DECLARE FUNCTION GetUserObjectInformation LIB "USER32.DLL" ALIAS "GetUserObjectInformationA" ( _
   BYVAL DWORD _                       ' __in HANDLE hObj
 , BYVAL LONG _                        ' __in int nIndex
 , BYREF ANY _                         ' __out_bcount_opt(nLength) PVOID pvInfo
 , BYVAL DWORD _                       ' __in DWORD nLength
 , BYREF DWORD _                       ' __out_opt LPDWORD lpnLengthNeeded
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetUserObjectInformationW LIB "USER32.DLL" ALIAS "GetUserObjectInformationW" ( _
   BYVAL DWORD _                       ' __in HANDLE hObj
 , BYVAL LONG _                        ' __in int nIndex
 , BYREF ANY _                         ' __out_bcount_opt(nLength) PVOID pvInfo
 , BYVAL DWORD _                       ' __in DWORD nLength
 , BYREF DWORD _                       ' __out_opt LPDWORD lpnLengthNeeded
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetUserObjectInformation LIB "USER32.DLL" ALIAS "SetUserObjectInformationA" ( _
   BYVAL DWORD _                       ' __in HANDLE hObj
 , BYVAL LONG _                        ' __in int nIndex
 , BYREF ANY _                         ' __in_bcount(nLength) PVOID pvInfo
 , BYVAL DWORD _                       ' __in DWORD nLength)
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetUserObjectInformationW LIB "USER32.DLL" ALIAS "SetUserObjectInformationW" ( _
   BYVAL DWORD _                       ' __in HANDLE hObj
 , BYVAL LONG _                        ' __in int nIndex
 , BYREF ANY _                         ' __in_bcount(nLength) PVOID pvInfo
 , BYVAL DWORD _                       ' __in DWORD nLength
 ) AS LONG                             ' BOOL

'#endif  /* !NOSECURITY */
'#ENDIF ' #IF NOT %DEF(%NOSECURITY) '-------------------------------

'#if(WINVER >= 0x0400)
TYPE WNDCLASSEXA
   cbSize        AS DWORD        ' UINT        cbSize
   ' /* Win 3.x */
   style         AS DWORD        ' UINT        style
   lpfnWndProc   AS DWORD        ' WNDPROC     lpfnWndProc
   cbClsExtra    AS LONG         ' int         cbClsExtra
   cbWndExtra    AS LONG         ' int         cbWndExtra
   hInstance     AS DWORD        ' HINSTANCE   hInstance
   hIcon         AS DWORD        ' HICON       hIcon
   hCursor       AS DWORD        ' HCURSOR     hCursor
   hbrBackground AS DWORD        ' HBRUSH      hbrBackground
   lpszMenuName  AS ASCIIZ PTR   ' LPCSTR      lpszMenuName
   lpszClassName AS ASCIIZ PTR   ' LPCSTR      lpszClassName
   ' /* Win 4.0 */
   hIconSm       AS DWORD        ' HICON       hIconSm
END TYPE

'TYPE WNDCLASSEXW
'   cbSize        AS DWORD        ' UINT        cbSize
'   ' /* Win 3.x */
'   style         AS DWORD        ' UINT        style
'   lpfnWndProc   AS DWORD        ' WNDPROC     lpfnWndProc
'   cbClsExtra    AS LONG         ' int         cbClsExtra
'   cbWndExtra    AS LONG         ' int         cbWndExtra
'   hInstance     AS DWORD        ' HINSTANCE   hInstance
'   hIcon         AS DWORD        ' HICON       hIcon
'   hCursor       AS DWORD        ' HCURSOR     hCursor
'   hbrBackground AS DWORD        ' HBRUSH      hbrBackground
'   lpszMenuName  AS WORD PTR     ' LPCWSTR     lpszMenuName
'   lpszClassName AS WORD PTR     ' LPCWSTR     lpszClassName
'   ' /* Win 4.0 */
'   hIconSm       AS DWORD        ' HICON       hIconSm
'END TYPE

'MACRO WNDCLASSEX = WNDCLASSEXA

'#endif /* WINVER >= 0x0400 */

TYPE WNDCLASSA
   style         AS DWORD        ' UINT        style
   lpfnwndproc   AS DWORD        ' WNDPROC     lpfnWndProc
   cbClsextra    AS LONG         ' int         cbClsExtra
   cbWndExtra    AS LONG         ' int         cbWndExtra
   hInstance     AS DWORD        ' HINSTANCE   hInstance
   hIcon         AS DWORD        ' HICON       hIcon
   hCursor       AS DWORD        ' HCURSOR     hCursor
   hbrBackground AS DWORD        ' HBRUSH      hbrBackground
   lpszMenuName  AS ASCIIZ PTR   ' LPCSTR      lpszMenuName
   lpszClassName AS ASCIIZ PTR   ' LPCSTR      lpszClassName
END TYPE

TYPE WNDCLASSW
   style         AS DWORD        ' UINT        style
   lpfnwndproc   AS DWORD        ' WNDPROC     lpfnWndProc
   cbClsextra    AS LONG         ' int         cbClsExtra
   cbWndExtra    AS LONG         ' int         cbWndExtra
   hInstance     AS DWORD        ' HINSTANCE   hInstance
   hIcon         AS DWORD        ' HICON       hIcon
   hCursor       AS DWORD        ' HCURSOR     hCursor
   hbrBackground AS DWORD        ' HBRUSH      hbrBackground
   lpszMenuName  AS WORD PTR     ' LPCWSTR     lpszMenuName
   lpszClassName AS WORD PTR     ' LPCWSTR     lpszClassName
END TYPE

MACRO WNDCLASS = WNDCLASSA

DECLARE FUNCTION IsHungAppWindow LIB "USER32.DLL" ALIAS "IsHungAppWindow" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0501)

DECLARE SUB DisableProcessWindowsGhosting LIB "USER32.DLL" ALIAS "DisableProcessWindowsGhosting" ( _
 )                                     ' VOID
'#endif /* WINVER >= 0x0501 */

'#IF NOT %DEF(%NOMSG) '---------------------------------------------------------
'#ifndef NOMSG

'/*
' * Message structure
' */

#IF NOT %DEF(%MSG_DEFINED)
%MSG_DEFINED = 1
TYPE tagMSG
   hwnd    AS DWORD      ' HWND        hwnd
   message AS DWORD      ' UINT        message
   wParam  AS DWORD      ' WPARAM      wParam
   lParam  AS LONG       ' LPARAM      lParam
   time    AS DWORD      ' DWORD       time
   pt      AS POINTAPI   ' POINT       pt
END TYPE
#ENDIF

'#define POINTSTOPOINT(pt, pts)                          \
'        { (pt).x = (LONG)(SHORT)LOWORD(*(LONG*)&pts);   \
'          (pt).y = (LONG)(SHORT)HIWORD(*(LONG*)&pts); }

'#define POINTTOPOINTS(pt)      (MAKELONG((short)((pt).x), (short)((pt).y)))

'#define MAKEWPARAM(l, h)      ((WPARAM)(DWORD)MAKELONG(l, h))
'#define MAKELPARAM(l, h)      ((LPARAM)(DWORD)MAKELONG(l, h))
'#define MAKELRESULT(l, h)     ((LRESULT)(DWORD)MAKELONG(l, h))

MACRO MAKEWPARAM(l, h) = MAK(DWORD, l, h)
MACRO MAKELPARAM(l, h) = BITS&(MAK(DWORD, l, h))
MACRO MAKELRESULT(l, h) = BITS&(MAK(DWORD, l, h))

'#endif /* !NOMSG */
'#ENDIF    ' #IF NOT %DEF(%NOMSG) '---------------------------------------------

'#IF NOT %DEF(%NOWINOFFSETS) '--------------------------------------------------
'#ifndef NOWINOFFSETS

'/*
' * Window field offsets for GetWindowLong()
' */
%GWL_WNDPROC        = -4&
%GWL_HINSTANCE      = -6&
%GWL_HWNDPARENT     = -8&
%GWL_STYLE          = -16&
%GWL_EXSTYLE        = -20&
%GWL_USERDATA       = -21&
%GWL_ID             = -12&

%GWLP_WNDPROC       = -4&
%GWLP_HINSTANCE     = -6&
%GWLP_HWNDPARENT    = -8&
%GWLP_USERDATA      = -21&
%GWLP_ID            = -12&

'/*
' * Class field offsets for GetClassLong()
' */
%GCL_MENUNAME       = -8&
%GCL_HBRBACKGROUND  = -10&
%GCL_HCURSOR        = -12&
%GCL_HICON          = -14&
%GCL_HMODULE        = -16&
%GCL_CBWNDEXTRA     = -18&
%GCL_CBCLSEXTRA     = -20&
%GCL_WNDPROC        = -24&
%GCL_STYLE          = -26&
%GCW_ATOM           = -32&

'#if(WINVER >= 0x0400)
%GCL_HICONSM        = -34&
'#endif /* WINVER >= 0x0400 */

%GCLP_MENUNAME      = -8&
%GCLP_HBRBACKGROUND = -10&
%GCLP_HCURSOR       = -12&
%GCLP_HICON         = -14&
%GCLP_HMODULE       = -16&
%GCLP_WNDPROC       = -24&
%GCLP_HICONSM       = -34&

'#endif /* !NOWINOFFSETS */
'#ENDIF ' #IF NOT %DEF(%NOWINOFFSETS) '-----------------------------------------

'#IF NOT %DEF(%NOWINMESSAGES) '-------------------------------------------------
'#ifndef NOWINMESSAGES

'/*
' * Window Messages
' */

%WM_NULL     = &H0000???
%WM_CREATE   = &H0001???
%WM_DESTROY  = &H0002???
%WM_MOVE     = &H0003???
%WM_SIZE     = &H0005???

%WM_ACTIVATE = &H0006???

'/*
' * WM_ACTIVATE state values
' */
%WA_INACTIVE    = 0&
%WA_ACTIVE      = 1&
%WA_CLICKACTIVE = 2&

%WM_SETFOCUS         = &H0007???
%WM_KILLFOCUS        = &H0008???
%WM_ENABLE           = &H000A???
%WM_SETREDRAW        = &H000B???
%WM_SETTEXT          = &H000C???
%WM_GETTEXT          = &H000D???
%WM_GETTEXTLENGTH    = &H000E???
%WM_PAINT            = &H000F???
%WM_CLOSE            = &H0010???
'#ifndef _WIN32_WCE
%WM_QUERYENDSESSION  = &H0011???
%WM_QUERYOPEN        = &H0013???
%WM_ENDSESSION       = &H0016???
'#endif
%WM_QUIT             = &H0012???
%WM_ERASEBKGND       = &H0014???
%WM_SYSCOLORCHANGE   = &H0015???
%WM_SHOWWINDOW       = &H0018???
%WM_WININICHANGE     = &H001A???
%WM_SETTINGCHANGE    = %WM_WININICHANGE

'#endif /* WINVER >= 0x0400 */

%WM_DEVMODECHANGE    = &H001B???
%WM_ACTIVATEAPP      = &H001C???
%WM_FONTCHANGE       = &H001D???
%WM_TIMECHANGE       = &H001E???
%WM_CANCELMODE       = &H001F???
%WM_SETCURSOR        = &H0020???
%WM_MOUSEACTIVATE    = &H0021???
%WM_CHILDACTIVATE    = &H0022???
%WM_QUEUESYNC        = &H0023???

%WM_GETMINMAXINFO    = &H0024???

'/*
' * Struct pointed to by WM_GETMINMAXINFO lParam
' */

TYPE MINMAXINFO
   ptReserved     AS POINTAPI   ' POINT ptReserved
   ptMaxSize      AS POINTAPI   ' POINT ptMaxSize
   ptMaxPosition  AS POINTAPI   ' POINT ptMaxPosition
   ptMinTrackSize AS POINTAPI   ' POINT ptMinTrackSize
   ptMaxTrackSize AS POINTAPI   ' POINT ptMaxTrackSize
END TYPE

%WM_PAINTICON            = &H0026???
%WM_ICONERASEBKGND       = &H0027???
%WM_NEXTDLGCTL           = &H0028???
%WM_SPOOLERSTATUS        = &H002A???
%WM_DRAWITEM             = &H002B???
%WM_MEASUREITEM          = &H002C???
%WM_DELETEITEM           = &H002D???
%WM_VKEYTOITEM           = &H002E???
%WM_CHARTOITEM           = &H002F???
%WM_SETFONT              = &H0030???
%WM_GETFONT              = &H0031???
%WM_SETHOTKEY            = &H0032???
%WM_GETHOTKEY            = &H0033???
%WM_QUERYDRAGICON        = &H0037???
%WM_COMPAREITEM          = &H0039???
'#if(WINVER >= 0x0500)
'#ifndef _WIN32_WCE
%WM_GETOBJECT            = &H003D???
'#endif
'#endif /* WINVER >= 0x0500 */
%WM_COMPACTING           = &H0041???
%WM_OTHERWINDOWCREATED   = &H0042???  ' no longer suported
%WM_OTHERWINDOWDESTROYED = &H0043???  ' no longer suported
%WM_COMMNOTIFY           = &H0044???  ' no longer suported
%WM_WINDOWPOSCHANGING    = &H0046???
%WM_WINDOWPOSCHANGED     = &H0047???

'#define WM_POWER                        0x0048
%WM_POWER                = &H0048???

'/*
' * wParam for WM_POWER window message and DRV_POWER driver notification
' */
%PWR_OK             = 1&
%PWR_FAIL           = -1&
%PWR_SUSPENDREQUEST = 1&
%PWR_SUSPENDRESUME  = 2&
%PWR_CRITICALRESUME = 3&

%WM_COPYDATA                   = &H004A???
%WM_CANCELJOURNAL              = &H004B???

'/*
' * lParam of WM_COPYDATA message points to...
' */

TYPE COPYDATASTRUCT
   dwData AS DWORD   ' ULONG_PTR dwData
   cbData AS DWORD   ' DWORD cbData
   lpData AS DWORD   ' PVOID lpData
END TYPE

'#if(WINVER >= 0x0400)
TYPE MDINEXTMENU
   hmenuIn   AS DWORD   ' HMENU   hmenuIn
   hmenuNext AS DWORD   ' HMENU   hmenuNext
   hwndNext  AS DWORD   ' HWND    hwndNext
END TYPE
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0400)
%WM_NOTIFY                     = &H004E???
%WM_INPUTLANGUAGECHANGEREQUEST = &H0050???
%WM_INPUTLANGCHANGEREQUEST     = &H0050???
%WM_INPUTLANGUAGECHANGE        = &H0051???
%WM_INPUTLANGCHANGE            = &H0051???
%WM_TCARD                      = &H0052???
%WM_HELP                       = &H0053???
%WM_USERCHANGED                = &H0054???
%WM_NOTIFYFORMAT               = &H0055???

%NFR_ANSI            = 1&
%NFR_UNICODE         = 2&
%NF_QUERY            = 3&
%NF_REQUERY          = 4&

%WM_CONTEXTMENU      = &H007B???
%WM_STYLECHANGING    = &H007C???
%WM_STYLECHANGED     = &H007D???
%WM_DISPLAYCHANGE    = &H007E???
%WM_GETICON          = &H007F???
%WM_SETICON          = &H0080???

%WM_NCCREATE         = &H0081???
%WM_NCDESTROY        = &H0082???
%WM_NCCALCSIZE       = &H0083???
%WM_NCHITTEST        = &H0084???
%WM_NCPAINT          = &H0085???
%WM_NCACTIVATE       = &H0086???
%WM_GETDLGCODE       = &H0087???
'#ifndef _WIN32_WCE
%WM_SYNCPAINT        = &H0088???
'#endif
%WM_NCMOUSEMOVE      = &H00A0???
%WM_NCLBUTTONDOWN    = &H00A1???
%WM_NCLBUTTONUP      = &H00A2???
%WM_NCLBUTTONDBLCLK  = &H00A3???
%WM_NCRBUTTONDOWN    = &H00A4???
%WM_NCRBUTTONUP      = &H00A5???
%WM_NCRBUTTONDBLCLK  = &H00A6???
%WM_NCMBUTTONDOWN    = &H00A7???
%WM_NCMBUTTONUP      = &H00A8???
%WM_NCMBUTTONDBLCLK  = &H00A9???

'#if(_WIN32_WINNT >= 0x0500)
%WM_NCXBUTTONDOWN    = &H00AB???
%WM_NCXBUTTONUP      = &H00AC???
%WM_NCXBUTTONDBLCLK  = &H00AD???
'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(_WIN32_WINNT >= 0x0501)
%WM_INPUT_DEVICE_CHANGE = &H00FE???
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(_WIN32_WINNT >= 0x0501)
%WM_INPUT            = &H00FF???
'#endif /* _WIN32_WINNT >= 0x0501 */

%WM_KEYFIRST         = &H0100???
%WM_KEYDOWN          = &H0100???
%WM_KEYUP            = &H0101???
%WM_CHAR             = &H0102???
%WM_DEADCHAR         = &H0103???
%WM_SYSKEYDOWN       = &H0104???
%WM_SYSKEYUP         = &H0105???
%WM_SYSCHAR          = &H0106???
%WM_SYSDEADCHAR      = &H0107???
'#if(_WIN32_WINNT >= 0x0501)
%WM_UNICHAR          = &H0109???
%WM_KEYLAST          = &H0109???
%UNICODE_NOCHAR      = &HFFFF???
'#else
'#define WM_KEYLAST                      0x0108
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(WINVER >= 0x0400)
%WM_IME_STARTCOMPOSITION = &H010D???
%WM_IME_ENDCOMPOSITION   = &H010E???
%WM_IME_COMPOSITION      = &H010F???
%WM_IME_KEYLAST          = &H010F???
'#endif /* WINVER >= 0x0400 */

%WM_INITDIALOG       = &H0110???
%WM_COMMAND          = &H0111???
%WM_SYSCOMMAND       = &H0112???
%WM_TIMER            = &H0113???
%WM_HSCROLL          = &H0114???
%WM_VSCROLL          = &H0115???
%WM_INITMENU         = &H0116???
%WM_INITMENUPOPUP    = &H0117???
%WM_MENUSELECT       = &H011F???
%WM_MENUCHAR         = &H0120???
%WM_ENTERIDLE        = &H0121???
'#if(WINVER >= 0x0500)
'#ifndef _WIN32_WCE
%WM_MENURBUTTONUP    = &H0122???
%WM_MENUDRAG         = &H0123???
%WM_MENUGETOBJECT    = &H0124???
%WM_UNINITMENUPOPUP  = &H0125???
%WM_MENUCOMMAND      = &H0126???
'#ifndef _WIN32_WCE
'#if(_WIN32_WINNT >= 0x0500)
%WM_CHANGEUISTATE    = &H0127???
%WM_UPDATEUISTATE    = &H0128???
%WM_QUERYUISTATE     = &H0129???

'/*
' * LOWORD(wParam) values in WM_*UISTATE*
' */

%UIS_SET        = 1&
%UIS_CLEAR      = 2&
%UIS_INITIALIZE = 3&

'/*
' * HIWORD(wParam) values in WM_*UISTATE*
' */
%UISF_HIDEFOCUS = &H1&
%UISF_HIDEACCEL = &H2&
'#if(_WIN32_WINNT >= 0x0501)
%UISF_ACTIVE    = &H4&
'#endif /* _WIN32_WINNT >= 0x0501 */
'#endif /* _WIN32_WINNT >= 0x0500 */
'#endif

'#endif
'#endif /* WINVER >= 0x0500 */

%WM_CTLCOLORMSGBOX   = &H0132???
%WM_CTLCOLOREDIT     = &H0133???
%WM_CTLCOLORLISTBOX  = &H0134???
%WM_CTLCOLORBTN      = &H0135???
%WM_CTLCOLORDLG      = &H0136???
%WM_CTLCOLORSCROLLBAR= &H0137???
%WM_CTLCOLORSTATIC   = &H0138???
%MN_GETHMENU         = &H01E1???

%WM_MOUSEFIRST       = &H0200???
%WM_MOUSEMOVE        = &H0200???
%WM_LBUTTONDOWN      = &H0201???
%WM_LBUTTONUP        = &H0202???
%WM_LBUTTONDBLCLK    = &H0203???
%WM_RBUTTONDOWN      = &H0204???
%WM_RBUTTONUP        = &H0205???
%WM_RBUTTONDBLCLK    = &H0206???
%WM_MBUTTONDOWN      = &H0207???
%WM_MBUTTONUP        = &H0208???
%WM_MBUTTONDBLCLK    = &H0209???
'#if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
%WM_MOUSEWHEEL       = &H020A???
'#endif
'#if (_WIN32_WINNT >= 0x0500)
%WM_XBUTTONDOWN      = &H020B???
%WM_XBUTTONUP        = &H020C???
%WM_XBUTTONDBLCLK    = &H020D???
'#endif
'#if (_WIN32_WINNT >= 0x0600)
'#define WM_MOUSEHWHEEL                  0x020E
%WM_MOUSEHWHEEL      = &H020E???   ' Windows Vista
'#endif

'#if (_WIN32_WINNT >= 0x0600)
'#IF %WINVER >= &H0600
'%WM_MOUSELAST                    = &H020E???
''#elif (_WIN32_WINNT >= 0x0500)
'#ELSEIF %WINVER >= &H0500
'%WM_MOUSELAST                    = &H020D???
''#elif (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
'#ELSEIF %WINVER >= &H0400 OR %WINVER > &H0400
'%WM_MOUSELAST                    = &H020A???
'#ELSE
'%WM_MOUSELAST                    = &H0209???
'#ENDIF ' /* (_WIN32_WINNT >= 0x0600) */

%WM_MOUSELAST                    = &H020D???   ' Predefined value in the PB compilers
%WM_MOUSELAST_VISTA              = &H020E???   ' to avoid namimg conlfict

'#if(_WIN32_WINNT >= 0x0400)
'/* Value for rolling one detent */
%WHEEL_DELTA                    = 120%
'#define GET_WHEEL_DELTA_WPARAM(wParam)  ((short)HIWORD(wParam))
MACRO GET_WHEEL_DELTA_WPARAM(wParam) = BITS%(HI(WORD, wParam))

'/* Setting to scroll one page for SPI_GET/SETWHEELSCROLLLINES */
'#define WHEEL_PAGESCROLL                (UINT_MAX)
%WHEEL_PAGESCROLL               = &HFFFFFFFF??? ' %UINT_MAX
'#endif /* _WIN32_WINNT >= 0x0400 */

'#if(_WIN32_WINNT >= 0x0500)
'#define GET_KEYSTATE_WPARAM(wParam)     (LOWORD(wParam))
'#define GET_NCHITTEST_WPARAM(wParam)    ((short)LOWORD(wParam))
'#define GET_XBUTTON_WPARAM(wParam)      (HIWORD(wParam))
MACRO GET_KEYSTATE_WPARAM(wParam)  = LO(WORD, wParam)
MACRO GET_NCHITTEST_WPARAM(wParam) = BITS%(LO(WORD, wParam))
MACRO GET_XBUTTON_WPARAM(wParam)   = HI(WORD, wParam)

'/* XButton values are WORD flags */
%XBUTTON1      = &H0001???
%XBUTTON2      = &H0002???
'/* Were there to be an XBUTTON3, its value would be 0x0004 */
'#endif /* _WIN32_WINNT >= 0x0500 */

%WM_PARENTNOTIFY     = &H0210???
%WM_ENTERMENULOOP    = &H0211???
%WM_EXITMENULOOP     = &H0212???

'#if(WINVER >= 0x0400)
%WM_NEXTMENU         = &H0213???
%WM_SIZING           = &H0214???
%WM_CAPTURECHANGED   = &H0215???
%WM_MOVING           = &H0216???
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0400)

%WM_POWERBROADCAST   = &H0218???

'#ifndef _WIN32_WCE
%PBT_APMQUERYSUSPEND         = &H0000???
%PBT_APMQUERYSTANDBY         = &H0001???

%PBT_APMQUERYSUSPENDFAILED   = &H0002???
%PBT_APMQUERYSTANDBYFAILED   = &H0003???

%PBT_APMSUSPEND              = &H0004???
%PBT_APMSTANDBY              = &H0005???

%PBT_APMRESUMECRITICAL       = &H0006???
%PBT_APMRESUMESUSPEND        = &H0007???
%PBT_APMRESUMESTANDBY        = &H0008???

%PBTF_APMRESUMEFROMFAILURE   = &H00000001???

%PBT_APMBATTERYLOW           = &H0009???
%PBT_APMPOWERSTATUSCHANGE    = &H000A???

%PBT_APMOEMEVENT             = &H000B???
%PBT_APMRESUMEAUTOMATIC      = &H0012???
'#if (_WIN32_WINNT >= 0x0502)
#IF NOT %DEF(%PBT_POWERSETTINGCHANGE)
%PBT_POWERSETTINGCHANGE      = &H8013???
TYPE POWERBROADCAST_SETTING
   PowerSetting AS GUID    ' GUID
   DataLength  AS DWORD   ' DWORD
   Data(0)     AS BYTE    ' UCHAR
END TYPE
#ENDIF ' // PBT_POWERSETTINGCHANGE
'#endif // (_WIN32_WINNT >= 0x0502)
'#endif

'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0400)
%WM_DEVICECHANGE     = &H0219???
'#endif /* WINVER >= 0x0400 */

%WM_MDICREATE        = &H0220???
%WM_MDIDESTROY       = &H0221???
%WM_MDIACTIVATE      = &H0222???
%WM_MDIRESTORE       = &H0223???
%WM_MDINEXT          = &H0224???
%WM_MDIMAXIMIZE      = &H0225???
%WM_MDITILE          = &H0226???
%WM_MDICASCADE       = &H0227???
%WM_MDIICONARRANGE   = &H0228???
%WM_MDIGETACTIVE     = &H0229???

%WM_MDISETMENU       = &H0230???
%WM_ENTERSIZEMOVE    = &H0231???
%WM_EXITSIZEMOVE     = &H0232???
%WM_DROPFILES        = &H0233???
%WM_MDIREFRESHMENU   = &H0234???

'#if(WINVER >= 0x0400)
%WM_IME_SETCONTEXT       = &H0281???
%WM_IME_NOTIFY           = &H0282???
%WM_IME_CONTROL          = &H0283???
%WM_IME_COMPOSITIONFULL  = &H0284???
%WM_IME_SELECT           = &H0285???
%WM_IME_CHAR             = &H0286???
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0500)
%WM_IME_REQUEST          = &H0288???
'#endif /* WINVER >= 0x0500 */
'#if(WINVER >= 0x0400)
%WM_IME_KEYDOWN          = &H0290???
%WM_IME_KEYUP            = &H0291???
'#endif /* WINVER >= 0x0400 */

'#if((_WIN32_WINNT >= 0x0400) || (WINVER >= 0x0500))
%WM_MOUSEHOVER        = &H02A1???
%WM_MOUSELEAVE        = &H02A3???
'#endif
'#if(WINVER >= 0x0500)
%WM_NCMOUSEHOVER      = &H02A0???
%WM_NCMOUSELEAVE      = &H02A2???
'#endif /* WINVER >= 0x0500 */

'#if(_WIN32_WINNT >= 0x0501)
%WM_WTSSESSION_CHANGE = &H02B1???

%WM_TABLET_FIRST      = &H02c0???
%WM_TABLET_LAST       = &H02df???
'#endif /* _WIN32_WINNT >= 0x0501 */

%WM_CUT               = &H0300???
%WM_COPY              = &H0301???
%WM_PASTE             = &H0302???
%WM_CLEAR             = &H0303???
%WM_UNDO              = &H0304???
%WM_RENDERFORMAT      = &H0305???
%WM_RENDERALLFORMATS  = &H0306???
%WM_DESTROYCLIPBOARD  = &H0307???
%WM_DRAWCLIPBOARD     = &H0308???
%WM_PAINTCLIPBOARD    = &H0309???
%WM_VSCROLLCLIPBOARD  = &H030A???
%WM_SIZECLIPBOARD     = &H030B???
%WM_ASKCBFORMATNAME   = &H030C???
%WM_CHANGECBCHAIN     = &H030D???
%WM_HSCROLLCLIPBOARD  = &H030E???
%WM_QUERYNEWPALETTE   = &H030F???
%WM_PALETTEISCHANGING = &H0310???
%WM_PALETTECHANGED    = &H0311???
%WM_HOTKEY            = &H0312???

'#if(WINVER >= 0x0400)
%WM_PRINT             = &H0317???
%WM_PRINTCLIENT       = &H0318???
'#endif /* WINVER >= 0x0400 */

'#if(_WIN32_WINNT >= 0x0500)
%WM_APPCOMMAND        = &H0319???
'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(_WIN32_WINNT >= 0x0501)
%WM_THEMECHANGED      = &H031A???
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(_WIN32_WINNT >= 0x0501)
%WM_CLIPBOARDUPDATE              = &H031D???
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(_WIN32_WINNT >= 0x0600)
%WM_DWMCOMPOSITIONCHANGED        = &H031E???
%WM_DWMNCRENDERINGCHANGED        = &H031F???
%WM_DWMCOLORIZATIONCOLORCHANGED  = &H0320???
%WM_DWMWINDOWMAXIMIZEDCHANGE     = &H0321???
'#endif /* _WIN32_WINNT >= 0x0600 */

'#if(WINVER >= 0x0600)
%WM_GETTITLEBARINFOEX            = &H033F???
'#endif /* WINVER >= 0x0600 */

'#if(WINVER >= 0x0400)

%WM_HANDHELDFIRST     = &H0358???
%WM_HANDHELDLAST      = &H035F???

%WM_AFXFIRST          = &H0360???
%WM_AFXLAST           = &H037F???
'#endif /* WINVER >= 0x0400 */

%WM_PENWINFIRST       = &H0380???
%WM_PENWINLAST        = &H038F???


'#if(WINVER >= 0x0400)
%WM_APP               = &H8000???
'#endif /* WINVER >= 0x0400 */


'/*
' * NOTE: All Message Numbers below 0x0400 are RESERVED.
' *
' * Private Window Messages Start Here:
' */
%WM_USER = &H0400???

'#if(WINVER >= 0x0400)

'/*  wParam for WM_SIZING message  */
%WMSZ_LEFT        = 1&
%WMSZ_RIGHT       = 2&
%WMSZ_TOP         = 3&
%WMSZ_TOPLEFT     = 4&
%WMSZ_TOPRIGHT    = 5&
%WMSZ_BOTTOM      = 6&
%WMSZ_BOTTOMLEFT  = 7&
%WMSZ_BOTTOMRIGHT = 8&

'#IF NOT %DEF(%NONCMESSAGES) ' -------------------------------------------------
'#ifndef NONCMESSAGES

'/*
' * WM_NCHITTEST and MOUSEHOOKSTRUCT Mouse Position Codes
' */
%HTERROR       = -2&
%HTTRANSPARENT = -1&
%HTNOWHERE     = 0&
%HTCLIENT      = 1&
%HTCAPTION     = 2&
%HTSYSMENU     = 3&
%HTGROWBOX     = 4&
%HTSIZE        = %HTGROWBOX
%HTMENU        = 5&
%HTHSCROLL     = 6&
%HTVSCROLL     = 7&
%HTMINBUTTON   = 8&
%HTMAXBUTTON   = 9&
%HTLEFT        = 10&
%HTRIGHT       = 11&
%HTTOP         = 12&
%HTTOPLEFT     = 13&
%HTTOPRIGHT    = 14&
%HTBOTTOM      = 15&
%HTBOTTOMLEFT  = 16&
%HTBOTTOMRIGHT = 17&
%HTBORDER      = 18&
%HTREDUCE      = %HTMINBUTTON
%HTZOOM        = %HTMAXBUTTON
%HTSIZEFIRST   = %HTLEFT
%HTSIZELAST    = %HTBOTTOMRIGHT
'#if(WINVER >= 0x0400)
%HTOBJECT      = 19&
%HTCLOSE       = 20&
%HTHELP        = 21&
'#endif /* WINVER >= 0x0400 */

'/*
' * SendMessageTimeout values
' */
%SMTO_NORMAL         = &H0000???
%SMTO_BLOCK          = &H0001???
%SMTO_ABORTIFHUNG    = &H0002???
'#if(WINVER >= 0x0500)
%SMTO_NOTIMEOUTIFNOTHUNG = &H0008???
'#endif /* WINVER >= 0x0500 */
'#if(WINVER >= 0x0600)
%SMTO_ERRORONEXIT    = &H0020???
'#endif /* WINVER >= 0x0600 */

'#endif /* !NONCMESSAGES */

'#ENDIF   ' #IF NOT %DEF(%NONCMESSAGES) ' --------------------------------------

'/*
' * WM_MOUSEACTIVATE Return Codes
' */
%MA_ACTIVATE         = 1&
%MA_ACTIVATEANDEAT   = 2&
%MA_NOACTIVATE       = 3&
%MA_NOACTIVATEANDEAT = 4&

'/*
' * WM_SETICON / WM_GETICON Type Codes
' */
%ICON_SMALL  = 0&
%ICON_BIG    = 1&
'#if(_WIN32_WINNT >= 0x0501)
%ICON_SMALL2 = 2&
'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION RegisterWindowMessage LIB "USER32.DLL" ALIAS "RegisterWindowMessageA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpString
 ) AS DWORD                            ' UINT

DECLARE FUNCTION RegisterWindowMessageW LIB "USER32.DLL" ALIAS "RegisterWindowMessageW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpString
 ) AS DWORD                            ' UINT

'/*
' * WM_SIZE message wParam values
' */
%SIZE_RESTORED  = 0&
%SIZE_MINIMIZED = 1&
%SIZE_MAXIMIZED = 2&
%SIZE_MAXSHOW   = 3&
%SIZE_MAXHIDE   = 4&

'/*
' * Obsolete constant names
' */
%SIZENORMAL     = %SIZE_RESTORED
%SIZEICONIC     = %SIZE_MINIMIZED
%SIZEFULLSCREEN = %SIZE_MAXIMIZED
%SIZEZOOMSHOW   = %SIZE_MAXSHOW
%SIZEZOOMHIDE   = %SIZE_MAXHIDE

'/*
' * WM_WINDOWPOSCHANGING/CHANGED struct pointed to by lParam
' */
TYPE WINDOWPOS
   hWnd            AS DWORD   ' HWND    hwnd
   hWndInsertAfter AS DWORD   ' HWND    hwndInsertAfter
   x               AS LONG    ' int     x
   y               AS LONG    ' int     y
   cx              AS LONG    ' int     cx
   cy              AS LONG    ' int     cy
   flags           AS DWORD   ' UINT    flags
END TYPE

'/*
' * WM_NCCALCSIZE parameter structure
' */

TYPE NCCALCSIZE_PARAMS
   rgrc (2) AS RECT            ' RECT       rgrc[3]
   lppos    AS WINDOWPOS PTR   ' PWINDOWPOS lppos
END TYPE

'/*
' * WM_NCCALCSIZE "window valid rect" return values
' */
%WVR_ALIGNTOP    = &H0010&
%WVR_ALIGNLEFT   = &H0020&
%WVR_ALIGNBOTTOM = &H0040&
%WVR_ALIGNRIGHT  = &H0080&
%WVR_HREDRAW     = &H0100&
%WVR_VREDRAW     = &H0200&
%WVR_REDRAW      = %WVR_HREDRAW OR %WVR_VREDRAW
%WVR_VALIDRECTS  = &H0400&

'#IF NOT %DEF(%NOKEYSTATES) ' --------------------------------------------------
'#ifndef NOKEYSTATES

'/*
' * Key State Masks for Mouse Messages
' */
%MK_LBUTTON  = &H0001??
%MK_RBUTTON  = &H0002??
%MK_SHIFT    = &H0004??
%MK_CONTROL  = &H0008??
%MK_MBUTTON  = &H0010??
'#if(_WIN32_WINNT >= 0x0500)
%MK_XBUTTON1 = &H0020??
%MK_XBUTTON2 = &H0040??
'#endif /* _WIN32_WINNT >= 0x0500 */

'#endif /* !NOKEYSTATES */
'#ENDIF   ' #IF NOT %DEF(%NOKEYSTATES) ' ---------------------------------------


'#if(_WIN32_WINNT >= 0x0400)
'#IF NOT %DEF(%NOTRACKMOUSEEVENT) ' --------------------------------------------
'#ifndef NOTRACKMOUSEEVENT

%TME_HOVER     = &H00000001???
%TME_LEAVE     = &H00000002???
'#if(WINVER >= 0x0500)
%TME_NONCLIENT = &H00000010???
'#endif /* WINVER >= 0x0500 */
%TME_QUERY     = &H40000000???
%TME_CANCEL    = &H80000000???

%HOVER_DEFAULT = &HFFFFFFFF???
'#endif /* _WIN32_WINNT >= 0x0400 */


'#if(_WIN32_WINNT >= 0x0400)

#IF NOT %DEF(%TRACKMOUSEEVENT_DEFINED)
%TRACKMOUSEEVENT_DEFINED = 1
TYPE tagTRACKMOUSEEVENT
   cbSize      AS DWORD
   dwFlags     AS DWORD
   hwndTrack   AS DWORD
   dwHoverTime AS DWORD
END TYPE
MACRO TRACKMOUSEEVENTAPI = tagTRACKMOUSEEVENT
' The EVENTTRACK name is used in PB's WIN32API.INC instead of tagTRACKMOUSEVENT
MACRO EVENTTRACK = tagTRACKMOUSEEVENT
#ENDIF

DECLARE FUNCTION TrackMouseEvent LIB "USER32.DLL" ALIAS "TrackMouseEvent" ( _
   BYREF tagTRACKMOUSEEVENT _          ' LPTRACKMOUSEEVENT lpEventTrack
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >= 0x0400 */

'#if(_WIN32_WINNT >= 0x0400)

'#endif /* !NOTRACKMOUSEEVENT */
'#ENDIF   ' #IF NOT %DEF(%NOTRACKMOUSEEVENT) ' ---------------------------------
'#endif /* _WIN32_WINNT >= 0x0400 */


'#endif /* !NOWINMESSAGES */
'#ENDIF ' #IF NOT %DEF(%NOWINMESSAGES) '----------------------------------------


'#IF NOT %DEF(%NOWINSTYLES) ' --------------------------------------------------
'#ifndef NOWINSTYLES

'/*
' * Window Styles
' */
%WS_OVERLAPPED         = &H00000000&
%WS_POPUP              = &H80000000&
%WS_CHILD              = &H40000000&
%WS_MINIMIZE           = &H20000000&
%WS_VISIBLE            = &H10000000&
%WS_DISABLED           = &H08000000&
%WS_CLIPSIBLINGS       = &H04000000&
%WS_CLIPCHILDREN       = &H02000000&
%WS_MAXIMIZE           = &H01000000&
%WS_CAPTION            = &H00C00000&  ' WS_BORDER OR WS_DLGFRAME
%WS_BORDER             = &H00800000&
%WS_DLGFRAME           = &H00400000&
%WS_VSCROLL            = &H00200000&
%WS_HSCROLL            = &H00100000&
%WS_SYSMENU            = &H00080000&
%WS_THICKFRAME         = &H00040000&
%WS_GROUP              = &H00020000&
%WS_TABSTOP            = &H00010000&

%WS_MINIMIZEBOX        = &H00020000&
%WS_MAXIMIZEBOX        = &H00010000&

%WS_TILED              = %WS_OVERLAPPED
%WS_ICONIC             = %WS_MINIMIZE
%WS_SIZEBOX            = %WS_THICKFRAME

'/*
' * Common Window Styles
' */
%WS_OVERLAPPEDWINDOW   = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%WS_TILEDWINDOW        = %WS_OVERLAPPEDWINDOW
%WS_POPUPWINDOW        = %WS_POPUP OR %WS_BORDER OR %WS_SYSMENU
%WS_CHILDWINDOW        = %WS_CHILD

'/*
' * Extended Window Styles
' */
%WS_EX_DLGMODALFRAME   = &H00000001&
%WS_EX_NOPARENTNOTIFY  = &H00000004&
%WS_EX_TOPMOST         = &H00000008&
%WS_EX_ACCEPTFILES     = &H00000010&
%WS_EX_TRANSPARENT     = &H00000020&
'#if(WINVER >= 0x0400)
%WS_EX_MDICHILD        = &H00000040&
%WS_EX_TOOLWINDOW      = &H00000080&
%WS_EX_SMCAPTION       = &H00000080&
%WS_EX_WINDOWEDGE      = &H00000100&
%WS_EX_CLIENTEDGE      = &H00000200&
%WS_EX_CONTEXTHELP     = &H00000400&
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0400)

%WS_EX_RIGHT           = &H00001000&
%WS_EX_LEFT            = &H00000000&
%WS_EX_RTLREADING      = &H00002000&
%WS_EX_LTRREADING      = &H00000000&
%WS_EX_LEFTSCROLLBAR   = &H00004000&
%WS_EX_RIGHTSCROLLBAR  = &H00000000&

%WS_EX_CONTROLPARENT   = &H00010000&
%WS_EX_STATICEDGE      = &H00020000&
%WS_EX_APPWINDOW       = &H00040000&

%WS_EX_OVERLAPPEDWINDOW = %WS_EX_WINDOWEDGE OR %WS_EX_CLIENTEDGE
%WS_EX_PALETTEWINDOW    = %WS_EX_WINDOWEDGE OR %WS_EX_TOOLWINDOW OR %WS_EX_TOPMOST

'#endif /* WINVER >= 0x0400 */

'#if(_WIN32_WINNT >= 0x0500)
%WS_EX_LAYERED         = &H00080000&

'#endif /* _WIN32_WINNT >= 0x0500 */


'#if(WINVER >= 0x0500)
%WS_EX_NOINHERITLAYOUT = &H00100000&
%WS_EX_LAYOUTRTL       = &H00400000&
'#endif /* WINVER >= 0x0500 */

'#if(_WIN32_WINNT >= 0x0501)
%WS_EX_COMPOSITED      = &H02000000&
'#endif /* _WIN32_WINNT >= 0x0501 */
'#if(_WIN32_WINNT >= 0x0500)
%WS_EX_NOACTIVATE      = &H08000000&
'#endif /* _WIN32_WINNT >= 0x0500 */


'/*
' * Class styles
' */
%CS_VREDRAW         = &H0001???
%CS_HREDRAW         = &H0002???
%CS_KEYCVTWINDOW    = &H0004???
%CS_DBLCLKS         = &H0008???
%CS_OWNDC           = &H0020???
%CS_CLASSDC         = &H0040???
%CS_PARENTDC        = &H0080???
%CS_NOKEYCVT        = &H0100???
%CS_NOCLOSE         = &H0200???
%CS_SAVEBITS        = &H0800???
%CS_BYTEALIGNCLIENT = &H1000???
%CS_BYTEALIGNWINDOW = &H2000???
%CS_PUBLICCLASS     = &H4000???
%CS_GLOBALCLASS     = %CS_PUBLICCLASS

%CS_IME             = &H00010000???
'#if(_WIN32_WINNT >= 0x0501)
%CS_DROPSHADOW      = &H00020000???
'#endif /* _WIN32_WINNT >= 0x0501 */

'#endif /* !NOWINSTYLES */
'#ENDIF ' #IF NOT %DEF(%NOWINSTYLES) '------------------------------------------

'#if(WINVER >= 0x0400)
'/* WM_PRINT flags */
%PRF_CHECKVISIBLE    = &H00000001???
%PRF_NONCLIENT       = &H00000002???
%PRF_CLIENT          = &H00000004???
%PRF_ERASEBKGND      = &H00000008???
%PRF_CHILDREN        = &H00000010???
%PRF_OWNED           = &H00000020???

'/* 3D border styles */
%BDR_RAISEDOUTER     = &H0001???
%BDR_SUNKENOUTER     = &H0002???
%BDR_RAISEDINNER     = &H0004???
%BDR_SUNKENINNER     = &H0008???

%BDR_OUTER           = %BDR_RAISEDOUTER OR %BDR_SUNKENOUTER
%BDR_INNER           = %BDR_RAISEDINNER OR %BDR_SUNKENINNER
%BDR_RAISED          = %BDR_RAISEDOUTER OR %BDR_RAISEDINNER
%BDR_SUNKEN          = %BDR_SUNKENOUTER OR %BDR_SUNKENINNER

%EDGE_RAISED         = %BDR_RAISEDOUTER OR %BDR_RAISEDINNER
%EDGE_SUNKEN         = %BDR_SUNKENOUTER OR %BDR_SUNKENINNER
%EDGE_ETCHED         = %BDR_SUNKENOUTER OR %BDR_RAISEDINNER
%EDGE_BUMP           = %BDR_RAISEDOUTER OR %BDR_SUNKENINNER

'/* Border flags */
%BF_LEFT             = &H0001???
%BF_TOP              = &H0002???
%BF_RIGHT            = &H0004???
%BF_BOTTOM           = &H0008???

%BF_TOPLEFT          = %BF_TOP OR %BF_LEFT
%BF_TOPRIGHT         = %BF_TOP OR %BF_RIGHT
%BF_BOTTOMLEFT       = %BF_BOTTOM OR %BF_LEFT
%BF_BOTTOMRIGHT      = %BF_BOTTOM OR %BF_RIGHT
%BF_RECT             = %BF_LEFT OR %BF_TOP OR %BF_RIGHT OR %BF_BOTTOM

%BF_DIAGONAL         = &H0010???

'// For diagonal lines, the BF_RECT flags specify the end point of the
'// vector bounded by the rectangle parameter.
%BF_DIAGONAL_ENDTOPRIGHT    = %BF_DIAGONAL OR %BF_TOP OR %BF_RIGHT
%BF_DIAGONAL_ENDTOPLEFT     = %BF_DIAGONAL OR %BF_TOP OR %BF_LEFT
%BF_DIAGONAL_ENDBOTTOMLEFT  = %BF_DIAGONAL OR %BF_BOTTOM OR %BF_LEFT
%BF_DIAGONAL_ENDBOTTOMRIGHT = %BF_DIAGONAL OR %BF_BOTTOM OR %BF_RIGHT

%BF_MIDDLE  = &H0800???  '* Fill in the middle
%BF_SOFT    = &H1000???  '* For softer buttons
%BF_ADJUST  = &H2000???  '* Calculate the space left over
%BF_FLAT    = &H4000???  '* For flat rather than 3D borders
%BF_MONO    = &H8000???  '* For monochrome borders

DECLARE FUNCTION DrawEdge LIB "USER32.DLL" ALIAS "DrawEdge" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF RECT _                        ' __inout LPRECT qrc
 , BYVAL DWORD _                       ' __in UINT edge
 , BYVAL DWORD _                       ' __in UINT grfFlags
 ) AS LONG                             ' BOOL

'/* flags for DrawFrameControl */

%DFC_CAPTION     = 1&
%DFC_MENU        = 2&
%DFC_SCROLL      = 3&
%DFC_BUTTON      = 4&
'#if(WINVER >= 0x0500)
%DFC_POPUPMENU   = 5&
'#endif /* WINVER >= 0x0500 */

%DFCS_CAPTIONCLOSE        = &H0000???
%DFCS_CAPTIONMIN          = &H0001???
%DFCS_CAPTIONMAX          = &H0002???
%DFCS_CAPTIONRESTORE      = &H0003???
%DFCS_CAPTIONHELP         = &H0004???

%DFCS_MENUARROW           = &H0000???
%DFCS_MENUCHECK           = &H0001???
%DFCS_MENUBULLET          = &H0002???
%DFCS_MENUARROWRIGHT      = &H0004???
%DFCS_SCROLLUP            = &H0000???
%DFCS_SCROLLDOWN          = &H0001???
%DFCS_SCROLLLEFT          = &H0002???
%DFCS_SCROLLRIGHT         = &H0003???
%DFCS_SCROLLCOMBOBOX      = &H0005???
%DFCS_SCROLLSIZEGRIP      = &H0008???
%DFCS_SCROLLSIZEGRIPRIGHT = &H0010???

%DFCS_BUTTONCHECK         = &H0000???
%DFCS_BUTTONRADIOIMAGE    = &H0001???
%DFCS_BUTTONRADIOMASK     = &H0002???
%DFCS_BUTTONRADIO         = &H0004???
%DFCS_BUTTON3STATE        = &H0008???
%DFCS_BUTTONPUSH          = &H0010???

%DFCS_INACTIVE            = &H0100???
%DFCS_PUSHED              = &H0200???
%DFCS_CHECKED             = &H0400???

'#if(WINVER >= 0x0500)
%DFCS_TRANSPARENT         = &H0800???
%DFCS_HOT                 = &H1000???
'#endif /* WINVER >= 0x0500 */

%DFCS_ADJUSTRECT          = &H2000???
%DFCS_FLAT                = &H4000???
%DFCS_MONO                = &H8000???

DECLARE FUNCTION DrawFrameControl LIB "USER32.DLL" ALIAS "DrawFrameControl" ( _
   BYVAL DWORD _                       ' __in HDC
 , BYREF RECT _                        ' __inout LPRECT
 , BYVAL DWORD _                       ' __in UINT
 , BYVAL DWORD _                       ' __in UINT
 ) AS LONG                             ' BOOL

'/* flags for DrawCaption */
%DC_ACTIVE   = &H0001???
%DC_SMALLCAP = &H0002???
%DC_ICON     = &H0004???
%DC_TEXT     = &H0008???
%DC_INBUTTON = &H0010???
'#if(WINVER >= 0x0500)
%DC_GRADIENT = &H0020???
'#endif /* WINVER >= 0x0500 */
'#if(_WIN32_WINNT >= 0x0501)
%DC_BUTTONS  = &H1000???
'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION DrawCaption LIB "USER32.DLL" ALIAS "DrawCaption" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL DWORD _                       ' __in HDC hdc
 , BYREF RECT _                        ' __in CONST RECT * lprect
 , BYVAL DWORD _                       ' __in UINT flags)
 ) AS LONG                             ' BOOL

'#define IDANI_OPEN          1
'#define IDANI_CAPTION       3
%IDANI_OPEN    = 1&
%IDANI_CAPTION = 3&

DECLARE FUNCTION DrawAnimatedRects LIB "USER32.DLL" ALIAS "DrawAnimatedRects" ( _
   BYVAL DWORD _                       ' __in_opt HWND hwnd
 , BYVAL LONG _                        ' __in int idAni
 , BYREF RECT _                        ' __in CONST RECT *lprcFrom
 , BYREF RECT _                        ' __in CONST RECT *lprcTo
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0400 */

'#IF NOT %DEF(%NOCLIPBOARD) ' --------------------------------------------------
'#ifndef NOCLIPBOARD

'/*
' * Predefined Clipboard Formats
' */
%CF_TEXT            =  1???
%CF_BITMAP          =  2???
%CF_METAFILEPICT    =  3???
%CF_SYLK            =  4???
%CF_DIF             =  5???
%CF_TIFF            =  6???
%CF_OEMTEXT         =  7???
%CF_DIB             =  8???
%CF_PALETTE         =  9???
%CF_PENDATA         = 10???
%CF_RIFF            = 11???
%CF_WAVE            = 12???
%CF_UNICODETEXT     = 13???
%CF_ENHMETAFILE     = 14???
'#if(WINVER >= 0x0400)
%CF_HDROP           = 15???
%CF_LOCALE          = 16???
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0500)
%CF_DIBV5           = 17???
'#endif /* WINVER >= 0x0500 */

'#if(WINVER >= 0x0500)
%CF_MAX             = 18???   ' varies by Windows version
'#elif(WINVER >= 0x0400)
'#define CF_MAX              17
'#else
'#define CF_MAX              15
'#endif

%CF_OWNERDISPLAY    = &H0080???
%CF_DSPTEXT         = &H0081???
%CF_DSPBITMAP       = &H0082???
%CF_DSPMETAFILEPICT = &H0083???
%CF_DSPENHMETAFILE  = &H008E???

'/*
' * "Private" formats don't get GlobalFree()'d
' */
%CF_PRIVATEFIRST    = &H0200???
%CF_PRIVATELAST     = &H02FF???

'/*
' * "GDIOBJ" formats do get DeleteObject()'d
' */
%CF_GDIOBJFIRST     = &H0300???
%CF_GDIOBJLAST      = &H03FF???

'#endif /* !NOCLIPBOARD */
'#ENDIF   ' #IF NOT %DEF(%NOCLIPBOARD) ' ---------------------------------------

'/*
' * Defines for the fVirt field of the Accelerator table structure.
' */
%FVIRTKEY   = &H01?        ' Assumed to be == TRUE
%FNOINVERT  = &H02?
%FSHIFT     = &H04?
%FCONTROL   = &H08?
%FALT       = &H10?

TYPE ACCELAPI WORD
   fVirt AS BYTE   ' BYTE   fVirt
   key   AS WORD   ' WORD   key
   cmd   AS WORD   ' WORD   cmd
END TYPE

TYPE PAINTSTRUCT
   hDC              AS DWORD   ' HDC         hdc
   fErase           AS LONG    ' BOOL        fErase
   rcPaint          AS RECT    ' RECT        rcPaint
   fRestore         AS LONG    ' BOOL        fRestore
   fIncUpdate       AS LONG    ' BOOL        fIncUpdate
   rgbReserved (31) AS BYTE    ' BYTE        rgbReserved[32]
END TYPE

TYPE CREATESTRUCTA
   lpCreateParams AS LONG          ' LPVOID      lpCreateParams
   hInstance      AS DWORD         ' HINSTANCE   hInstance
   hMenu          AS DWORD         ' HMENU       hMenu
   hwndParent     AS DWORD         ' HWND        hwndParent
   cy             AS LONG          ' int         cy
   cx             AS LONG          ' int         cx
   y              AS LONG          ' int         y
   x              AS LONG          ' int         x
   style          AS LONG          ' LONG        style
   lpszName       AS ASCIIZ PTR    ' LPCSTR      lpszName
   lpszClass      AS ASCIIZ PTR    ' LPCSTR      lpszClass
   dwExStyle      AS DWORD         ' DWORD       dwExStyle
END TYPE

TYPE CREATESTRUCTW
   lpCreateParams AS LONG          ' LPVOID      lpCreateParams
   hInstance      AS DWORD         ' HINSTANCE   hInstance
   hMenu          AS DWORD         ' HMENU       hMenu
   hwndParent     AS DWORD         ' HWND        hwndParent
   cy             AS LONG          ' int         cy
   cx             AS LONG          ' int         cx
   y              AS LONG          ' int         y
   x              AS LONG          ' int         x
   style          AS LONG          ' LONG        style
   lpszName       AS WORD PTR      ' LPCWSTR     lpszName
   lpszClass      AS WORD PTR      ' LPCWSTR     lpszClass
   dwExStyle      AS DWORD         ' DWORD       dwExStyle
END TYPE

MACRO CREATESTRUCT = CREATESTRUCTA

'/*
' * HCBT_CREATEWND parameters pointed to by lParam
' */

TYPE CBT_CREATEWNDA
   lpcs            AS CREATESTRUCTA PTR    ' struct tagCREATESTRUCTA *lpcs
   hWndInsertAfter AS DWORD               ' HWND hwndInsertAfter
END TYPE

TYPE CBT_CREATEWNDW
   lpcs            AS CREATESTRUCTW PTR   ' struct tagCREATESTRUCTW *lpcs
   hWndInsertAfter AS DWORD               ' HWND hwndInsertAfter
END TYPE

MACRO CBT_CREATEWND = CBT_CREATEWNDA

TYPE WINDOWPLACEMENT
   length           AS DWORD      ' UINT  length
   flags            AS DWORD      ' UINT  flags
   showCmd          AS DWORD      ' UINT  showCmd
   ptMinPosition    AS POINTAPI   ' POINT ptMinPosition
   ptMaxPosition    AS POINTAPI   ' POINT ptMaxPosition
   rcNormalPosition AS RECT       ' RECT  rcNormalPosition
END TYPE

%WPF_SETMINPOSITION       = &H0001???
%WPF_RESTORETOMAXIMIZED   = &H0002???
'#if(_WIN32_WINNT >= 0x0500)
%WPF_ASYNCWINDOWPLACEMENT = &H0004???
'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(WINVER >= 0x0400)
' code should be DWORD, but it is defined as LONG in PBWin 9 built-in structure
TYPE NMHDR
   hwndFrom AS DWORD   ' HWND      hwndFrom
   idfrom   AS DWORD   ' UINT_PTR  idFrom
   code     AS LONG    ' UINT      code;         // NM_ code
END TYPE

TYPE STYLESTRUCT
   styleOld AS DWORD   ' DWORD   styleOld
   styleNew AS DWORD   ' DWORD   styleNew
END TYPE
'#endif /* WINVER >= 0x0400 */

'/*
' * Owner draw control types
' */
%ODT_MENU      = 1&
%ODT_LISTBOX   = 2&
%ODT_COMBOBOX  = 3&
%ODT_BUTTON    = 4&
'#endif /* WINVER >= 0x0400 */
%ODT_STATIC    = 5&

'/*
' * Owner draw actions
' */
%ODA_DRAWENTIRE = &H0001???
%ODA_SELECT     = &H0002???
%ODA_FOCUS      = &H0004???

'/*
' * Owner draw state
' */
%ODS_SELECTED        = &H0001???
%ODS_GRAYED          = &H0002???
%ODS_DISABLED        = &H0004???
%ODS_CHECKED         = &H0008???
%ODS_FOCUS           = &H0010???
'#if(WINVER >= = &H0400)
%ODS_DEFAULT         = &H0020???
%ODS_COMBOBOXEDIT    = &H1000???
'#endif /* WINVER >= = &H0400 */
'#if(WINVER >= = &H0500)
%ODS_HOTLIGHT        = &H0040???
%ODS_INACTIVE        = &H0080???
'#if(_WIN32_WINNT >= = &H0500)
%ODS_NOACCEL         = &H0100???
%ODS_NOFOCUSRECT     = &H0200???
'#endif /* _WIN32_WINNT >= 0x0500 */
'#endif /* WINVER >= 0x0500 */

'/*
' * MEASUREITEMSTRUCT for ownerdraw
' */

TYPE MEASUREITEMSTRUCT
   CtlType    AS DWORD   ' UINT       CtlType
   CtlID      AS DWORD   ' UINT       CtlID
   itemID     AS DWORD   ' UINT       itemID
   itemWidth  AS DWORD   ' UINT       itemWidth
   itemHeight AS DWORD   ' UINT       itemHeight
   itemData   AS DWORD   ' ULONG_PTR  itemData
END TYPE

'/*
' * DRAWITEMSTRUCT for ownerdraw
' */

TYPE DRAWITEMSTRUCT
   CtlType    AS DWORD   ' UINT        CtlType
   CtlID      AS DWORD   ' UINT        CtlID
   itemID     AS DWORD   ' UINT        itemID
   itemAction AS DWORD   ' UINT        itemAction
   itemState  AS DWORD   ' UINT        itemState
   hwndItem   AS DWORD   ' HWND        hwndItem
   hDC        AS DWORD   ' HDC         hDC
   rcItem     AS RECT    ' RECT        rcItem
   itemData   AS DWORD   ' ULONG_PTR   itemData
END TYPE

'/*
' * DELETEITEMSTRUCT for ownerdraw
' */

TYPE DELETEITEMSTRUCT
   CtlType  AS DWORD   ' UINT       CtlType
   CtlID    AS DWORD   ' UINT       CtlID
   itemID   AS DWORD   ' UINT       itemID
   hwndItem AS LONG    ' HWND       hwndItem
   itemData AS DWORD   ' ULONG_PTR  itemData
END TYPE

'/*
' * COMPAREITEMSTUCT for ownerdraw sorting
' */

TYPE COMPAREITEMSTRUCT
   CtlType    AS DWORD   ' UINT        CtlType
   CtlID      AS DWORD   ' UINT        CtlID
   hwndItem   AS DWORD   ' HWND        hwndItem
   itemID1    AS DWORD   ' UINT        itemID1
   itemData1  AS DWORD   ' ULONG_PTR   itemData1
   itemID2    AS DWORD   ' UINT        itemID2
   itemData2  AS DWORD   ' ULONG_PTR   itemData2
   dwLocaleId AS DWORD   ' DWORD       dwLocaleId
END TYPE

'#IF NOT %DEF(%NOMSG) '---------------------------------------------------------
'#ifndef NOMSG

'/*
' * Message Function Templates
' */

DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" ( _
   BYREF tagMSG _                      ' __out LPMSG lpMsg
 , BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMin
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMax
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMessageW LIB "USER32.DLL" ALIAS "GetMessageW" ( _
   BYREF tagMSG _                      ' __out LPMSG lpMsg
 , BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMin
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMax
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" ( _
   BYREF tagMSG _                      ' __in CONST MSG *lpMsg
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" ( _
   BYREF tagMSG _                      ' __in CONST MSG *lpMsg
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION DispatchMessageW LIB "USER32.DLL" ALIAS "DispatchMessageW" ( _
   BYREF tagMSG _                      ' __in CONST MSG *lpMsg
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION SetMessageQueue LIB "USER32.DLL" ALIAS "SetMessageQueue" ( _
   BYVAL LONG _                        ' __in int cMessagesMax
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" ( _
   BYREF tagMSG _                      ' __out LPMSG lpMsg
 , BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMin
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMax
 , BYVAL DWORD _                       ' __in UINT wRemoveMsg
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PeekMessageW LIB "USER32.DLL" ALIAS "PeekMessageW" ( _
   BYREF tagMSG _                      ' __out LPMSG lpMsg
 , BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMin
 , BYVAL DWORD _                       ' __in UINT wMsgFilterMax
 , BYVAL DWORD _                       ' __in UINT wRemoveMsg
 ) AS LONG                             ' BOOL

'/*
' * PeekMessage() Options
' */
%PM_NOREMOVE       = &H0000???
%PM_REMOVE         = &H0001???
%PM_NOYIELD        = &H0002???
'#if(WINVER >= 0x0500)
%PM_QS_INPUT       = %QS_INPUT * 256
%PM_QS_POSTMESSAGE = (%QS_POSTMESSAGE OR %QS_HOTKEY OR %QS_TIMER) * 256
%PM_QS_PAINT       = %QS_PAINT * 256
%PM_QS_SENDMESSAGE = %QS_SENDMESSAGE * 256
'#endif /* WINVER >= 0x0500 */

'#endif /* !NOMSG */
'#ENDIF   ' #IF NOT %DEF(%NOMSG) '----------------------------------------------

DECLARE FUNCTION RegisterHotKey LIB "USER32.DLL" ALIAS "RegisterHotKey" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL LONG _                        ' __in int id
 , BYVAL LONG _                        ' __in UINT fsModifiers
 , BYVAL LONG _                        ' __in UINT vk
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UnregisterHotKey LIB "USER32.DLL" ALIAS "UnregisterHotKey" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL LONG _                        ' __in int id
 ) AS LONG                             ' BOOL

%MOD_ALT        = &H0001???
%MOD_CONTROL    = &H0002???
%MOD_SHIFT      = &H0004???
%MOD_WIN        = &H0008???

%IDHOT_SNAPWINDOW  = -1&    ' SHIFT-PRINTSCRN
%IDHOT_SNAPDESKTOP = -2&    ' PRINTSCRN

'#ifdef WIN_INTERNAL
'    #ifndef LSTRING
'    #define NOLSTRING
'    #endif /* LSTRING */
'    #ifndef LFILEIO
'    #define NOLFILEIO
'    #endif /* LFILEIO */
'#endif /* WIN_INTERNAL */

'#if(WINVER >= 0x0400)
%ENDSESSION_LOGOFF   = &H80000000???
%ENDSESSION_CRITICAL = &H40000000???
%ENDSESSION_CLOSEAPP = &H00000001???
'#endif /* WINVER >= 0x0400 */

%EWX_LOGOFF       = 0???
%EWX_SHUTDOWN     = &H00000001???
%EWX_REBOOT       = &H00000002???
%EWX_FORCE        = &H00000004???
%EWX_POWEROFF     = &H00000008???
'#if(_WIN32_WINNT >= 0x0500)
%EWX_FORCEIFHUNG  = &H00000010???
'#endif /* _WIN32_WINNT >= 0x0500 */
%EWX_QUICKRESOLVE = &H00000020???
'#if(_WIN32_WINNT >= 0x0600)
%EWX_RESTARTAPPS  = &H00000040???
'#endif /* _WIN32_WINNT >= 0x0600 */

DECLARE FUNCTION ExitWindowsEx LIB "USER32.DLL" ALIAS "ExitWindowsEx" ( _
   BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in DWORD dwReason
 ) AS LONG                             ' BOOL

'#define ExitWindows(dwReserved, Code) ExitWindowsEx(EWX_LOGOFF, 0xFFFFFFFF)
'FUNCTION ExitWindows (BYVAL dwReserved AS DWORD, BYVAL uReserved AS DWORD) AS LONG
'   FUNCTION = ExitWindowsEx(%EWX_LOGOFF, &HFFFFFFFF???)
'END FUNCTION

DECLARE FUNCTION SwapMouseButton LIB "USER32.DLL" ALIAS "SwapMouseButton" ( _
   BYVAL LONG _                        ' __in BOOL fSwap
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMessagePos LIB "USER32.DLL" ALIAS "GetMessagePos" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetMessageTime LIB "USER32.DLL" ALIAS "GetMessageTime" ( _
 ) AS LONG                             ' LONG

DECLARE FUNCTION GetMessageExtraInfo LIB "USER32.DLL" ALIAS "GetMessageExtraInfo" ( _
 ) AS LONG                             ' LPARAM

'#if(_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION IsWow64Message LIB "USER32.DLL" ALIAS "IsWow64Message" ( _
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(WINVER >= 0x0400)
DECLARE FUNCTION SetMessageExtraInfo LIB "USER32.DLL" ALIAS "SetMessageExtraInfo" ( _
   BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LPARAM
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION SendMessageW LIB "USER32.DLL" ALIAS "SendMessageW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam)
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION SendMessageTimeout LIB "USER32.DLL" ALIAS "SendMessageTimeoutA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 , BYVAL DWORD _                       ' __in UINT fuFlags
 , BYVAL DWORD _                       ' __in UINT uTimeout
 , BYREF DWORD _                       ' __out_opt PDWORD_PTR lpdwResult
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION SendMessageTimeoutW LIB "USER32.DLL" ALIAS "SendMessageTimeoutW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 , BYVAL DWORD _                       ' __in UINT fuFlags
 , BYVAL DWORD _                       ' __in UINT uTimeout
 , BYREF DWORD _                       ' __out_opt PDWORD_PTR lpdwResult
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION SendNotifyMessage LIB "USER32.DLL" ALIAS "SendNotifyMessageA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SendNotifyMessage LIB "USER32.DLL" ALIAS "SendNotifyMessageA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SendMessageCallback LIB "USER32.DLL" ALIAS "SendMessageCallbackA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 , BYVAL DWORD _                       ' __in SENDASYNCPROC lpResultCallBack
 , BYVAL DWORD _                       ' __in ULONG_PTR dwData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SendMessageCallbackW LIB "USER32.DLL" ALIAS "SendMessageCallbackW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 , BYVAL DWORD _                       ' __in SENDASYNCPROC lpResultCallBack
 , BYVAL DWORD _                       ' __in ULONG_PTR dwData
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0501)
TYPE BSMINFO
   cbSize AS DWORD   ' UINT  cbSize
   hdesk  AS DWORD   ' HDESK hdesk
   hwnd   AS DWORD   ' HWND  hwnd
   luid   AS LUID    ' LUID  luid
END TYPE

DECLARE FUNCTION BroadcastSystemMessageEx LIB "USER32.DLL" ALIAS "BroadcastSystemMessageExA" ( _
   BYVAL DWORD _                       ' __in DWORD flags
 , BYREF DWORD _                       ' __inout_opt LPDWORD lpInfo
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 , BYREF BSMINFO _                     ' __out_opt PBSMINFO pbsmInfo
 ) AS LONG                             ' long

DECLARE FUNCTION BroadcastSystemMessageExW LIB "USER32.DLL" ALIAS "BroadcastSystemMessageExW" ( _
   BYVAL DWORD _                       ' __in DWORD flags
 , BYREF DWORD _                       ' __inout_opt LPDWORD lpInfo
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 , BYREF BSMINFO _                     ' __out_opt PBSMINFO pbsmInfo
 ) AS LONG                             ' long

'#if(WINVER >= 0x0400)

'#if defined(_WIN32_WINNT)
DECLARE FUNCTION BroadcastSystemMessageA LIB "USER32.DLL" ALIAS "BroadcastSystemMessageA" ( _
   BYVAL DWORD _                       ' __in DWORD flags
 , BYREF DWORD _                       ' __inout_opt LPDWORD lpInfo
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' long

DECLARE FUNCTION BroadcastSystemMessageW LIB "USER32.DLL" ALIAS "BroadcastSystemMessageW" ( _
   BYVAL DWORD _                       ' __in DWORD flags
 , BYREF DWORD _                       ' __inout_opt LPDWORD lpInfo
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD  _                      ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' long

'// The Win95 version isn't A/W decorated
DECLARE FUNCTION BroadcastSystemMessage LIB "USER32.DLL" ALIAS "BroadcastSystemMessage" ( _
   BYVAL DWORD _                       ' __in DWORD flags
 , BYREF DWORD _                       ' __inout_opt LPDWORD lpInfo
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' long

'#endif

'//Broadcast Special Message Recipient list
%BSM_ALLCOMPONENTS       = &H00000000???
%BSM_VXDS                = &H00000001???
%BSM_NETDRIVER           = &H00000002???
%BSM_INSTALLABLEDRIVERS  = &H00000004???
%BSM_APPLICATIONS        = &H00000008???
%BSM_ALLDESKTOPS         = &H00000010???

'//Broadcast Special Message Flags
%BSF_QUERY               = &H00000001???
%BSF_IGNORECURRENTTASK   = &H00000002???
%BSF_FLUSHDISK           = &H00000004???
%BSF_NOHANG              = &H00000008???
%BSF_POSTMESSAGE         = &H00000010???
%BSF_FORCEIFHUNG         = &H00000020???
%BSF_NOTIMEOUTIFNOTHUNG  = &H00000040???
'#if(_WIN32_WINNT >= 0x0500)
%BSF_ALLOWSFW            = &H00000080???
%BSF_SENDNOTIFYMESSAGE   = &H00000100???
'#endif /* _WIN32_WINNT >= 0x0500 */
'#if(_WIN32_WINNT >= 0x0501)
%BSF_RETURNHDESK         = &H00000200???
%BSF_LUID                = &H00000400???
'#endif /* _WIN32_WINNT >= 0x0501 */

'#define BROADCAST_QUERY_DENY         0x424D5144  // Return this value to deny a query.
%BROADCAST_QUERY_DENY    = &H424D5144???  ' Return this value to deny a query.
'#endif /* WINVER >= 0x0400 */

'// RegisterDeviceNotification

'#if(WINVER >= 0x0500)
'typedef  PVOID           HDEVNOTIFY;
'typedef  HDEVNOTIFY     *PHDEVNOTIFY;

%DEVICE_NOTIFY_WINDOW_HANDLE         = &H00000000???
%DEVICE_NOTIFY_SERVICE_HANDLE        = &H00000001???
'#if(_WIN32_WINNT >= 0x0501)
%DEVICE_NOTIFY_ALL_INTERFACE_CLASSES = &H00000004???
'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION RegisterDeviceNotification LIB "USER32.DLL" ALIAS "RegisterDeviceNotificationA" ( _
   BYVAL DWORD _                       ' __in HANDLE hRecipient
 , BYVAL DWORD _                       ' __in LPVOID NotificationFilter
 , BYVAL DWORD _                       ' __in DWORD Flags
 ) AS DWORD                            ' HDEVNOTIFY

DECLARE FUNCTION RegisterDeviceNotificationW LIB "USER32.DLL" ALIAS "RegisterDeviceNotificationW" ( _
   BYVAL DWORD _                       ' __in HANDLE hRecipient
 , BYVAL DWORD _                       ' __in LPVOID NotificationFilter
 , BYVAL DWORD _                       ' __in DWORD Flags
 ) AS DWORD                            ' HDEVNOTIFY

DECLARE FUNCTION UnregisterDeviceNotification LIB "USER32.DLL" ALIAS "UnregisterDeviceNotification" ( _
   BYVAL DWORD _                       ' __in HDEVNOTIFY Handle
 ) AS LONG                             ' BOOL

'#if (_WIN32_WINNT >= 0x0502)
'typedef  PVOID           HPOWERNOTIFY;
'typedef  HPOWERNOTIFY   *PHPOWERNOTIFY;

DECLARE FUNCTION RegisterPowerSettingNotification LIB "USER32.DLL" ALIAS "RegisterPowerSettingNotification" ( _
   BYVAL DWORD _                       ' IN HANDLE hRecipient
 , BYREF GUID _                        ' IN LPCGUID PowerSettingGuid
 , BYVAL DWORD _                       ' IN DWORD Flags
 ) AS DWORD                            ' HPOWERNOTIFY

DECLARE FUNCTION UnregisterPowerSettingNotification LIB "USER32.DLL" ALIAS "UnregisterPowerSettingNotification" ( _
   BYVAL DWORD _                       ' IN HDEVNOTIFY Handle
 ) AS LONG                             ' BOOL
'#endif // (_WIN32_WINNT >= 0x0502)
'#endif /* WINVER >= 0x0500 */


DECLARE FUNCTION PostMessage LIB "USER32.DLL" ALIAS "PostMessageA" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD  _                      ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PostMessageW LIB "USER32.DLL" ALIAS "PostMessageW" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PostThreadMessage LIB "USER32.DLL" ALIAS "PostThreadMessageA" ( _
   BYVAL DWORD _                       ' __in DWORD idThread
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PostThreadMessageW LIB "USER32.DLL" ALIAS "PostThreadMessageW" ( _
   BYVAL DWORD _                       ' __in DWORD idThread
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

'#define PostAppMessageA(idThread, wMsg, wParam, lParam)\
'        PostThreadMessageA((DWORD)idThread, wMsg, wParam, lParam)
MACRO PostAppMessage(idThread, wMsg, wParam, lParam) = PostThreadMessage(idThread, wMsg, wParam, lParam)

'#define PostAppMessageW(idThread, wMsg, wParam, lParam)\
'        PostThreadMessageW((DWORD)idThread, wMsg, wParam, lParam)
MACRO PostAppMessageW(idThread, wMsg, wParam, lParam) = PostThreadMessageW(idThread, wMsg, wParam, lParam)

'/*
' * Special HWND value for use with PostMessage() and SendMessage()
' */
'#define HWND_BROADCAST  ((HWND)0xffff)
%HWND_BROADCAST = &HFFFFFFFF???

'#if(WINVER >= 0x0500)
'#define HWND_MESSAGE     ((HWND)-3)
%HWND_MESSAGE   = &HFFFFFFFD???
'#endif /* WINVER >= 0x0500 */

DECLARE FUNCTION AttachThreadInput LIB "USER32.DLL" ALIAS "AttachThreadInput" ( _
   BYVAL DWORD _                       ' __in DWORD idAttach
 , BYVAL DWORD _                       ' __in DWORD idAttachTo
 , BYVAL LONG _                        ' __in BOOL fAttach
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ReplyMessage LIB "USER32.DLL" ALIAS "ReplyMessage" ( _
   BYVAL LONG _                        ' __in LRESULT lResult
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WaitMessage LIB "USER32.DLL" ALIAS "WaitMessage" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WaitForInputIdle LIB "USER32.DLL" ALIAS "WaitForInputIdle" ( _
   BYVAL DWORD, _                      ' __in HANDLE hProcess
   BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION DefWindowProcW LIB "USER32.DLL" ALIAS "DefWindowProcW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" ( _
   BYVAL LONG _                        ' __in int nExitCode
 )                                     ' VOID

DECLARE FUNCTION CallWindowProc LIB "USER32.DLL" ALIAS "CallWindowProcA" ( _
   BYVAL DWORD _                       ' __in FARPROC lpPrevWndFunc
 , BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION CallWindowProcW LIB "USER32.DLL" ALIAS "CallWindowProcW" ( _
   BYVAL DWORD _                       ' __in FARPROC lpPrevWndFunc
 , BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION InSendMessage LIB "USER32.DLL" ALIAS "InSendMessage" ( _
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0500)
DECLARE FUNCTION InSendMessageEx LIB "USER32.DLL" ALIAS "InSendMessageEx" ( _
   BYVAL DWORD _                       ' __reserved LPVOID lpReserved
 ) AS DWORD                            ' DWORD

'/*
' * InSendMessageEx return value
' */
%ISMEX_NOSEND   = &H00000000???
%ISMEX_SEND     = &H00000001???
%ISMEX_NOTIFY   = &H00000002???
%ISMEX_CALLBACK = &H00000004???
%ISMEX_REPLIED  = &H00000008???

'#endif /* WINVER >= 0x0500 */

DECLARE FUNCTION GetDoubleClickTime LIB "USER32.DLL" ALIAS "GetDoubleClickTime" ( _
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetDoubleClickTime LIB "USER32.DLL" ALIAS "SetDoubleClickTime" ( _
   BYVAL DWORD _                       ' __in UINT
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RegisterClass LIB "USER32.DLL" ALIAS "RegisterClassA" ( _
   BYREF WNDCLASSA _                   ' __in CONST WNDCLASSA *lpWndClass
 ) AS WORD                             ' ATOM

DECLARE FUNCTION RegisterClassW LIB "USER32.DLL" ALIAS "RegisterClassW" ( _
   BYREF WNDCLASSW _                   ' __in CONST WNDCLASSW *lpWndClass)
 ) AS WORD                             ' ATOM

DECLARE FUNCTION UnregisterClass LIB "USER32.DLL" ALIAS "UnregisterClassA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpClassName
 , BYVAL DWORD _                       ' __in HINSTANCE hInstance
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UnregisterClassW LIB "USER32.DLL" ALIAS "UnregisterClassW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpClassName
 , BYVAL DWORD _                       ' __in HINSTANCE hInstance
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetClassInfo LIB "USER32.DLL" ALIAS "GetClassInfoA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpClassName
 , BYREF WNDCLASSA _                   ' __out LPWNDCLASSA lpWndClass
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetClassInfoW LIB "USER32.DLL" ALIAS "GetClassInfoW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in LPCWSTR lpClassName
 , BYREF WNDCLASSW _                   ' __out LPWNDCLASSW lpWndClass
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0400)
'DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" ( _
'   BYREF WNDCLASSEXA _                 ' __in CONST WNDCLASSEXA *
' ) AS WORD                             ' ATOM

'DECLARE FUNCTION RegisterClassExW LIB "USER32.DLL" ALIAS "RegisterClassExW" ( _
'   BYREF WNDCLASSEXW _                 ' __in CONST WNDCLASSEXW *
' ) AS WORD                             ' ATOM

'DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" ( _
'   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
' , BYREF ASCIIZ _                      ' __in LPCSTR lpszClass
' , BYREF WNDCLASSEXA _                 ' __out LPWNDCLASSEXA lpwcx
' ) AS LONG                             ' BOOL

'DECLARE FUNCTION GetClassInfoExW LIB "USER32.DLL" ALIAS "GetClassInfoExW" ( _
'   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
' , BYVAL DWORD _                       ' __in LPCWSTR lpszClass
' , BYREF WNDCLASSEXW _                 ' __out LPWNDCLASSEXW lpwcx
' ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0400 */

'#define CW_USEDEFAULT       ((int)0x80000000)
%CW_USEDEFAULT  = &H80000000&

'/*
' * Special value for CreateWindow, et al.
' */
'#define HWND_DESKTOP        ((HWND)0)
%HWND_DESKTOP   = 0???

'#if(_WIN32_WINNT >= 0x0501)
'typedef BOOLEAN (WINAPI * PREGISTERCLASSNAMEW)(LPCWSTR);
'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" ( _
   BYVAL DWORD _                       ' __in DWORD dwExStyle
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpClassName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpWindowName
 , BYVAL DWORD _                       ' __in DWORD dwStyle
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt HMENU hMenu
 , BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ANY _                         ' __in_opt LPVOID lpParam
 ) AS DWORD                            ' HWND

DECLARE FUNCTION CreateWindowExW LIB "USER32.DLL" ALIAS "CreateWindowExW" ( _
   BYVAL DWORD _                       ' __in DWORD dwExStyle
 , BYVAL DWORD _                       ' __in_opt LPCSTR lpClassName
 , BYVAL DWORD _                       ' __in_opt LPCSTR lpWindowName
 , BYVAL DWORD _                       ' __in DWORD dwStyle
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt HMENU hMenu
 , BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ANY _                         ' __in_opt LPVOID lpParam
 ) AS DWORD                            ' HWND

'#define CreateWindowA(lpClassName, lpWindowName, dwStyle, x, y,\
'nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam)\
'CreateWindowExA(0L, lpClassName, lpWindowName, dwStyle, x, y,\
'nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam)
'#define CreateWindowW(lpClassName, lpWindowName, dwStyle, x, y,\
'nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam)\
'CreateWindowExW(0L, lpClassName, lpWindowName, dwStyle, x, y,\
'nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam)

'#IF %DEF(%CCWIN)
'   FUNCTION CreateWindow (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL xx AS LONG, BYVAL yy AS LONG, BYVAL nWidth AS LONG, _
'            BYVAL nHeight AS LONG, BYVAL hwndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, BYVAL lpParam AS DWORD) AS LONG
'      FUNCTION = CreateWindowEx(0, lpClassName, lpWindowName, dwStyle, xx, yy, nWidth, nHeight, hWndParent, hMenu, hInstance, BYVAL lpParam)
'   END FUNCTION

'   FUNCTION CreateWindowW (BYVAL lpClassName AS DWORD, BYVAL lpWindowName AS DWORD, BYVAL dwStyle AS DWORD, BYVAL xx AS LONG, BYVAL yy AS LONG, BYVAL nWidth AS LONG, _
'            BYVAL nHeight AS LONG, BYVAL hwndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, BYVAL lpParam AS DWORD) AS LONG
'      FUNCTION = CreateWindowExW(0, lpClassName, lpWindowName, dwStyle, xx, yy, nWidth, nHeight, hWndParent, hMenu, hInstance, BYVAL lpParam)
'   END FUNCTION
'#ENDIF

DECLARE FUNCTION IsWindow LIB "USER32.DLL" ALIAS "IsWindow" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsMenu LIB "USER32.DLL" ALIAS "IsMenu" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsChild LIB "USER32.DLL" ALIAS "IsChild" ( _
   BYVAL DWORD _                       ' __in HWND hWndParent
 , BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DestroyWindow LIB "USER32.DLL" ALIAS "DestroyWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nCmdShow
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0500)
DECLARE FUNCTION AnimateWindow LIB "USER32.DLL" ALIAS "AnimateWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in DWORD dwTime
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL
'#endif /* WINVER >= 0x0500 */

'#if(_WIN32_WINNT >= 0x0500)
'#if defined(_WINGDI_) && !defined(NOGDI)

DECLARE FUNCTION UpdateLayeredWindow LIB "USER32.DLL" ALIAS "UpdateLayeredWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HDC hdcDst
 , BYREF POINTAPI _                    ' __in_opt POINT *pptDst
 , BYREF SIZEL _                       ' __in_opt SIZE *psize
 , BYVAL DWORD _                       ' __in_opt HDC hdcSrc
 , BYREF POINTAPI _                    ' __in_opt POINT *pptSrc
 , BYVAL DWORD _                       ' __in COLORREF crKey
 , BYREF BLENDFUNCTION _               ' __in_opt BLENDFUNCTION *pblend
 , BYVAL DWORD _                       ' __in_opt BLENDFUNCTION *pblend
 ) AS LONG                             ' BOOL

'/*
' * Layered Window Update information
' */
TYPE UPDATELAYEREDWINDOWINFO
   cbSize   AS DWORD               ' __in                DWORD               cbSize
   hdcDst   AS DWORD               ' __in_opt            HDC                 hdcDst
   pptDst   AS POINTAPI PTR        ' __in_ecount_opt(1)  POINT CONST         *pptDst
   psize    AS apiSIZE PTR         ' __in_ecount_opt(1)  SIZE CONST          *psize
   hdcSrc   AS DWORD               ' __in_opt            HDC                 hdcSrc
   pptSrc   AS POINTAPI PTR        ' __in_ecount_opt(1)  POINT CONST         *pptSrc
   crKey    AS DWORD               ' __in_opt            COLORREF            crKey
   pblend   AS BLENDFUNCTION PTR   ' __in_ecount_opt(1)  BLENDFUNCTION CONST *pblend
   dwFlags  AS DWORD               ' __in                DWORD               dwFlags
   prcDirty AS RECT PTR            ' __in_ecount_opt(1)  RECT CONST          *prcDirty
END TYPE

DECLARE FUNCTION UpdateLayeredWindowIndirect LIB "USER32,DLL" ALIAS "UpdateLayeredWindowIndirect" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF UPDATELAYEREDWINDOWINFO _     ' __in_ecount(1) UPDATELAYEREDWINDOWINFO CONST *pULWInfo
 ) AS LONG                             ' BOOL

'#endif

'#if(_WIN32_WINNT >= 0x0501)
DECLARE FUNCTION GetLayeredWindowAttributes LIB "USER32.DLL" ALIAS "GetLayeredWindowAttributes" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYREF DWORD _                       ' __out_opt COLORREF *pcrKey
 , BYREF BYTE _                        ' __out_opt BYTE *pbAlpha
 , BYREF DWORD _                       ' __out_opt DWORD *pdwFlags
 ) AS LONG                             ' BOOL

%PW_CLIENTONLY = &H00000001???

DECLARE FUNCTION PrintWindow LIB "USER32.DLL" ALIAS "PrintWindow" ( _
   BYVAL DWORD _                       ' __in  HWND hwnd
 , BYVAL DWORD _                       ' __in  HDC hdcBlt
 , BYVAL DWORD _                       ' __in  UINT nFlags
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION SetLayeredWindowAttributes LIB "USER32.DLL" ALIAS "SetLayeredWindowAttributes" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL DWORD _                       ' __in COLORREF crKey
 , BYVAL BYTE _                        ' __in BYTE bAlpha
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

%LWA_COLORKEY    = &H00000001???
%LWA_ALPHA       = &H00000002???

%ULW_COLORKEY    = &H00000001???
%ULW_ALPHA       = &H00000002???
%ULW_OPAQUE      = &H00000004???

%ULW_EX_NORESIZE = &H00000008???


'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(WINVER >= 0x0400)
DECLARE FUNCTION ShowWindowAsync LIB "USER32.DLL" ALIAS "ShowWindowAsync" ( _
   BYVAL DWORD _                       ' __in  HWND hWnd
 , BYVAL LONG _                        ' __in  int nCmdShow
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FlashWindow LIB "USER32.DLL" ALIAS "FlashWindow" ( _
   BYVAL DWORD _                       ' __in  HWND hWnd
 , BYVAL LONG _                        ' __in  BOOL bInvert
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0500)
TYPE FLASHWINFO
   cbSize    AS DWORD   ' UINT  cbSize
   hwnd      AS DWORD   ' HWND  hwnd
   dwFlags   AS DWORD   ' DWORD dwFlags
   uCount    AS DWORD   ' UINT  uCount
   dwTimeout AS DWORD   ' DWORD dwTimeout
END TYPE

DECLARE FUNCTION FlashWindowEx LIB "USER32.DLL" ALIAS "FlashWindowEx" ( _
   BYREF FLASHWINFO _                  ' __in PFLASHWINFO pfwi
 ) AS LONG                             ' BOOL

%FLASHW_STOP      = 0???
%FLASHW_CAPTION   = &H00000001???
%FLASHW_TRAY      = &H00000002???
%FLASHW_ALL       = %FLASHW_CAPTION OR %FLASHW_TRAY
%FLASHW_TIMER     = &H00000004???
%FLASHW_TIMERNOFG = &H0000000C???

'#endif /* WINVER >= 0x0500 */

DECLARE FUNCTION ShowOwnedPopups LIB "USER32.DLL" ALIAS "ShowOwnedPopups" ( _
   BYVAL DWORD _                       ' __in  HWND hWnd
 , BYVAL LONG _                        ' __in  BOOL fShow
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OpenIcon LIB "USER32.DLL" ALIAS "OpenIcon" ( _
   BYVAL DWORD _                       ' __in  HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CloseWindow LIB "USER32.DLL" ALIAS "CloseWindow" ( _
   BYVAL DWORD _                       ' __in  HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYVAL LONG _                        ' __in BOOL bRepaint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetWindowPos LIB "USER32.DLL" ALIAS "SetWindowPos" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HWND hWndInsertAfter
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetWindowPlacement LIB "USER32.DLL" ALIAS "GetWindowPlacement" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF WINDOWPLACEMENT _             ' __inout WINDOWPLACEMENT *lpwndpl
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetWindowPlacement LIB "USER32.DLL" ALIAS "SetWindowPlacement" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF WINDOWPLACEMENT _             ' __in CONST WINDOWPLACEMENT *lpwndpl
 ) AS LONG                             ' BOOL


'#IF NOT %DEF(%NODEFERWINDOWPOS) ' ---------------------------------------------
'#ifndef NODEFERWINDOWPOS

DECLARE FUNCTION BeginDeferWindowPos LIB "USER32.DLL" ALIAS "BeginDeferWindowPos" ( _
   BYVAL LONG _                        ' __in int nNumWindows
 ) AS DWORD                            ' HDWP

DECLARE FUNCTION DeferWindowPos LIB "USER32.DLL" ALIAS "DeferWindowPos" ( _
   BYVAL DWORD _                       ' __in HDWP hWinPosInfo
 , BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HWND hWndInsertAfter
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS DWORD                            ' HDWP

DECLARE FUNCTION EndDeferWindowPos LIB "USER32.DLL" ALIAS "EndDeferWindowPos" ( _
   BYVAL DWORD _                       ' __in HDWP hWinPosInfo
 ) AS LONG                             ' BOOL

'#endif /* !NODEFERWINDOWPOS */
'#ENDIF   ' #IF NOT %DEF(%NODEFERWINDOWPOS) ' ----------------------------------

DECLARE FUNCTION IsWindowVisible LIB "USER32.DLL" ALIAS "IsWindowVisible" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AnyPopup LIB "USER32.DLL" ALIAS "AnyPopup" ( _
 ) AS LONG                             ' VOID

DECLARE FUNCTION BringWindowToTop LIB "USER32.DLL" ALIAS "BringWindowToTop" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsZoomed LIB "USER32.DLL" ALIAS "IsZoomed" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

'/*
' * SetWindowPos Flags
' */
%SWP_NOSIZE         = &H0001???
%SWP_NOMOVE         = &H0002???
%SWP_NOZORDER       = &H0004???
%SWP_NOREDRAW       = &H0008???
%SWP_NOACTIVATE     = &H0010???
%SWP_FRAMECHANGED   = &H0020???  ' The frame changed: send WM_NCCALCSIZE
%SWP_SHOWWINDOW     = &H0040???
%SWP_HIDEWINDOW     = &H0080???
%SWP_NOCOPYBITS     = &H0100???
%SWP_NOOWNERZORDER  = &H0200???  ' Don't do owner Z ordering
%SWP_NOSENDCHANGING = &H0400???  ' Don't send WM_WINDOWPOSCHANGING

%SWP_DRAWFRAME      = %SWP_FRAMECHANGED
%SWP_NOREPOSITION   = %SWP_NOOWNERZORDER

'#if(WINVER >= 0x0400)
%SWP_DEFERERASE     = &H2000???
%SWP_ASYNCWINDOWPOS = &H4000???
'#endif /* WINVER >= 0x0400 */

%HWND_TOP       = 0???            ' ((HWND)0)
%HWND_BOTTOM    = 1???            ' ((HWND)1)
%HWND_TOPMOST   = &HFFFFFFFF???   ' ((HWND)-1)
%HWND_NOTOPMOST = &HFFFFFFFE???   ' ((HWND)-2)

'#IF NOT %DEF(%NOCTLMGR) ' -----------------------------------------------------
'#ifndef NOCTLMGR

'/*
' * WARNING:
' * The following structures must NOT be DWORD padded because they are
' * followed by strings, etc that do not have to be DWORD aligned.
' */
'#include <pshpack2.h>

'/*
' * original NT 32 bit dialog template:
' */
TYPE DLGTEMPLATEA
   style           AS DWORD     ' DWORD style
   dwExtendedStyle AS DWORD     ' DWORD dwExtendedStyle
   cdit            AS WORD      ' WORD  cdit
   x               AS INTEGER   ' short x
   y               AS INTEGER   ' short y
   cx              AS INTEGER   ' short cx
   cy              AS INTEGER   ' short cy
END TYPE

TYPE DLGTEMPLATEW
   style           AS DWORD     ' DWORD style
   dwExtendedStyle AS DWORD     ' DWORD dwExtendedStyle
   cdit            AS WORD      ' WORD  cdit
   x               AS INTEGER   ' short x
   y               AS INTEGER   ' short y
   cx              AS INTEGER   ' short cx
   cy              AS INTEGER   ' short cy
END TYPE

MACRO DLGTEMPLATE = DLGTEMPLATEA

'/*
' * 32 bit Dialog item template.
' */
TYPE DLGITEMTEMPLATEA
   style         AS DWORD     ' DWORD style
   ExtendedStyle AS DWORD     ' DWORD dwExtendedStyle
   x             AS INTEGER   ' short x
   y             AS INTEGER   ' short y
   cx            AS INTEGER   ' short cx
   cy            AS INTEGER   ' short cy
   id            AS WORD      ' WORD  id
END TYPE

TYPE DLGITEMTEMPLATEW
   style         AS DWORD     ' DWORD style
   ExtendedStyle AS DWORD     ' DWORD dwExtendedStyle
   x             AS INTEGER   ' short x
   y             AS INTEGER   ' short y
   cx            AS INTEGER   ' short cx
   cy            AS INTEGER   ' short cy
   id            AS WORD      ' WORD  id
END TYPE

MACRO DLGITEMTEMPLATE = DLGITEMTEMPLATEA

'#include <poppack.h> /* Resume normal packing */

DECLARE FUNCTION CreateDialogParam LIB "USER32.DLL" ALIAS "CreateDialogParamA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpTemplateName
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD  _                      ' __in_opt DLGPROC lpDialogFunc
 , BYVAL LONG _                        ' __in LPARAM dwInitParam
 ) AS DWORD                            ' HWND

DECLARE FUNCTION CreateDialogParamW LIB "USER32.DLL" ALIAS "CreateDialogParamW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in LPCWSTR lpTemplateName
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt DLGPROC lpDialogFunc
 , BYVAL LONG _                        ' __in LPARAM dwInitParam
 ) AS DWORD                            ' HWND

DECLARE FUNCTION CreateDialogIndirectParam LIB "USER32.DLL" ALIAS "CreateDialogIndirectParamA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF DLGTEMPLATEA _                ' __in LPCDLGTEMPLATEA lpTemplate
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt DLGPROC lpDialogFunc
 , BYVAL DWORD _                       ' __in LPARAM dwInitParam)
 ) AS DWORD                            ' HWND

DECLARE FUNCTION CreateDialogIndirectParamW LIB "USER32.DLL" ALIAS "CreateDialogIndirectParamW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF DLGTEMPLATEW _                ' __in LPCDLGTEMPLATEW lpTemplate
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt DLGPROC lpDialogFunc
 , BYVAL DWORD _                       ' __in LPARAM dwInitParam
 ) AS DWORD                            ' HWND

'#define CreateDialogA(hInstance, lpName, hWndParent, lpDialogFunc) \
'CreateDialogParamA(hInstance, lpName, hWndParent, lpDialogFunc, 0L)
'#define CreateDialogW(hInstance, lpName, hWndParent, lpDialogFunc) \
'CreateDialogParamW(hInstance, lpName, hWndParent, lpDialogFunc, 0L)

'#define CreateDialogIndirectA(hInstance, lpTemplate, hWndParent, lpDialogFunc) \
'CreateDialogIndirectParamA(hInstance, lpTemplate, hWndParent, lpDialogFunc, 0L)
'#define CreateDialogIndirectW(hInstance, lpTemplate, hWndParent, lpDialogFunc) \
'CreateDialogIndirectParamW(hInstance, lpTemplate, hWndParent, lpDialogFunc, 0L)

'#IF %DEF(%CCWIN)
 '     FUNCTION CreateDialogIndirect (BYVAL hInstance AS DWORD, BYREF lpTemplate AS DLGTEMPLATE, BYVAL hWndParent AS DWORD, BYVAL lpDialogFunc AS LONG) AS LONG
 '        FUNCTION = CreateDialogIndirectParam(hInstance, lpTemplate, hWndParent, lpDialogFunc, %NULL)
 '     END FUNCTION
'#ENDIF


'#IF %DEF(%CCWIN)
'   FUNCTION CreateDialog (BYVAL hInstance AS DWORD, BYREF lpName AS ASCIIZ, BYVAL hwndParent AS DWORD, BYVAL lpDialogFunc AS LONG) AS LONG
'      FUNCTION = CreateDialogParam(hInstance, lpName, hWndParent, lpDialogFunc, %NULL)
'   END FUNCTION
'#ENDIF

DECLARE FUNCTION DialogBoxParam LIB "USER32.DLL" ALIAS "DialogBoxParamA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpTemplateName
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt DLGPROC lpDialogFunc
 , BYVAL LONG _                        ' __in LPARAM dwInitParam
 ) AS LONG                             ' int_PTR

DECLARE FUNCTION DialogBoxParamW LIB "USER32.DLL" ALIAS "DialogBoxParamW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in LPCWSTR lpTemplateName
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt DLGPROC lpDialogFunc
 , BYVAL LONG _                        ' __in LPARAM dwInitParam
 ) AS LONG                             ' int_PTR

DECLARE FUNCTION DialogBoxIndirectParam LIB "USER32.DLL" ALIAS "DialogBoxIndirectParamA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF DLGTEMPLATEA _                ' __in LPCDLGTEMPLATEA hDialogTemplate
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt DLGPROC lpDialogFunc
 , BYVAL LONG _                        ' __in LPARAM dwInitParam
 ) AS LONG                             ' int_PTR

DECLARE FUNCTION DialogBoxIndirectParamW LIB "USER32.DLL" ALIAS "DialogBoxIndirectParamW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF DLGTEMPLATEW _                ' __in LPCDLGTEMPLATEW hDialogTemplate
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt DLGPROC lpDialogFunc
 , BYVAL LONG _                        ' __in LPARAM dwInitParam
 ) AS LONG                             ' int_PTR

'#define DialogBoxA(hInstance, lpTemplate, hWndParent, lpDialogFunc) \
'DialogBoxParamA(hInstance, lpTemplate, hWndParent, lpDialogFunc, 0L)
'#define DialogBoxW(hInstance, lpTemplate, hWndParent, lpDialogFunc) \
'DialogBoxParamW(hInstance, lpTemplate, hWndParent, lpDialogFunc, 0L)

'#define DialogBoxIndirectA(hInstance, lpTemplate, hWndParent, lpDialogFunc) \
'DialogBoxIndirectParamA(hInstance, lpTemplate, hWndParent, lpDialogFunc, 0L)
'#define DialogBoxIndirectW(hInstance, lpTemplate, hWndParent, lpDialogFunc) \
'DialogBoxIndirectParamW(hInstance, lpTemplate, hWndParent, lpDialogFunc, 0L)

'#IF %DEF(%CCWIN)
'   FUNCTION DialogBox (BYVAL hInstance AS DWORD, lpTemplateName AS ASCIIZ, BYVAL hwndParent AS DWORD, BYVAL lpDialogFunc AS LONG) AS LONG
'      FUNCTION = DialogBoxParam(hInstance, lpTemplateName, hWndParent, lpDialogFunc, 0)
'   END FUNCTION
'#ENDIF

'#IF %DEF(%CCWIN)
'      FUNCTION DialogBoxIndirect (BYVAL hInstance AS DWORD, BYREF hDialogTemplate AS DLGTEMPLATE, BYVAL hWndParent AS DWORD, BYVAL lpDialogFunc AS LONG) AS LONG
'         FUNCTION = DialogBoxIndirectParam(hInstance, hDialogTemplate, hWndParent, lpDialogFunc, 0)
'      END FUNCTION
'#ENDIF

DECLARE FUNCTION EndDialog LIB "USER32.DLL" ALIAS "EndDialog" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in INT_PTR nResult
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" ( _
   BYVAL DWORD _                       ' __in_opt HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 ) AS DWORD                            ' HWND

DECLARE FUNCTION SetDlgItemInt LIB "USER32.DLL" ALIAS "SetDlgItemInt" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 , BYVAL DWORD _                       ' __in UINT uValue
 , BYVAL LONG _                        ' __in BOOL bSigned
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDlgItemInt LIB "USER32.DLL" ALIAS "GetDlgItemInt" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 , BYREF LONG _                        ' __out_opt BOOL *lpTranslated
 , BYVAL LONG _                        ' __in BOOL bSigned
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetDlgItemText LIB "USER32.DLL" ALIAS "SetDlgItemTextA" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 , BYREF ASCIIZ _                      ' __in LPCSTR lpString
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetDlgItemTextW LIB "USER32.DLL" ALIAS "SetDlgItemTextW" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 , BYVAL DWORD _                       ' __in LPCWSTR lpString
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetDlgItemText LIB "USER32.DLL" ALIAS "GetDlgItemTextA" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 , BYREF ASCIIZ _                      ' __out_ecount(cchMax) LPSTR lpString
 , BYVAL LONG _                        ' __in int cchMax
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetDlgItemTextW LIB "USER32.DLL" ALIAS "GetDlgItemTextW" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 , BYVAL DWORD _                       ' __out_ecount(cchMax) LPWSTR lpString
 , BYVAL LONG _                        ' __in int cchMax
 ) AS DWORD                            ' UINT

DECLARE FUNCTION CheckDlgButton LIB "USER32.DLL" ALIAS "CheckDlgButton" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDButton
 , BYVAL DWORD _                       ' __in UINT uCheck
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CheckRadioButton LIB "USER32.DLL" ALIAS "CheckRadioButton" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDFirstButton
 , BYVAL LONG _                        ' __in int nIDLastButton
 , BYVAL LONG _                        ' __in int nIDCheckButton
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsDlgButtonChecked LIB "USER32.DLL" ALIAS "IsDlgButtonChecked" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDButton
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SendDlgItemMessage LIB "USER32.DLL" ALIAS "SendDlgItemMessageA" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION SendDlgItemMessageW LIB "USER32.DLL" ALIAS "SendDlgItemMessageW" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL LONG _                        ' __in int nIDDlgItem
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION GetNextDlgGroupItem LIB "USER32.DLL" ALIAS "GetNextDlgGroupItem" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL DWORD _                       ' __in_opt HWND hCtl
 , BYVAL LONG _                        ' __in BOOL bPrevious
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetNextDlgTabItem LIB "USER32.DLL" ALIAS "GetNextDlgTabItem" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL DWORD _                       ' __in_opt HWND hCtl
 , BYVAL LONG _                        ' __in BOOL bPrevious
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetDlgCtrlID LIB "USER32.DLL" ALIAS "GetDlgCtrlID" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' int

DECLARE FUNCTION GetDialogBaseUnits LIB "USER32.DLL" ALIAS "GetDialogBaseUnits" ( _
 ) AS LONG                             ' long

DECLARE FUNCTION DefDlgProcW LIB "USER32.DLL" ALIAS "DefDlgProcW" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL DWORD _                       ' __in UINT Msg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

'/*
' * Window extra byted needed for private dialog classes.
' */
'#ifndef _MAC
'#define DLGWINDOWEXTRA 30
%DLGWINDOWEXTRA = 30&
'#else
'#define DLGWINDOWEXTRA 48
'#define DLGWINDOWEXTRA 48
'#endif

'#endif /* !NOCTLMGR */
'#ENDIF   ' #IF NOT %DEF(%NOCTLMGR) ' ------------------------------------------

'#IF NOT %DEF(%NOMSG) '---------------------------------------------------------
'#ifndef NOMSG

DECLARE FUNCTION CallMsgFilter LIB "USER32.DLL" ALIAS "CallMsgFilterA" ( _
   BYREF tagMSG _                      ' __in LPMSG lpMsg
 , BYVAL LONG _                        ' __in int nCode
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CallMsgFilterW LIB "USER32.DLL" ALIAS "CallMsgFilterW" ( _
   BYREF tagMSG _                      ' __in LPMSG lpMsg
 , BYVAL LONG _                        ' __in int nCode
 ) AS LONG                             ' BOOL

'#endif /* !NOMSG */
'#ENDIF   ' #IF NOT %DEF(%NOMSG) '----------------------------------------------

'#IF NOT %DEF(%NOCLIPBOARD) ' --------------------------------------------------
'#ifndef NOCLIPBOARD

'/*
' * Clipboard Manager Functions
' */

DECLARE FUNCTION OpenClipboard LIB "USER32.DLL" ALIAS "OpenClipboard" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWndNewOwner
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CloseClipboard LIB "USER32.DLL" ALIAS "CloseClipboard" ( _
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0500)
DECLARE FUNCTION GetClipboardSequenceNumber LIB "USER32.DLL" ALIAS "GetClipboardSequenceNumber" ( _
 ) AS DWORD                            ' DWORD
'#endif /* WINVER >= 0x0500 */

DECLARE FUNCTION GetClipboardOwner LIB "USER32.DLL" ALIAS "GetClipboardOwner" ( _
 ) AS DWORD                            ' HWND

DECLARE FUNCTION SetClipboardViewer LIB "USER32.DLL" ALIAS "SetClipboardViewer" ( _
   BYVAL DWORD _                       ' __in HWND hWndNewViewer
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetClipboardViewer LIB "USER32.DLL" ALIAS "GetClipboardViewer" ( _
 ) AS DWORD                            ' HWND

DECLARE FUNCTION ChangeClipboardChain LIB "USER32.DLL" ALIAS "ChangeClipboardChain" ( _
   BYVAL DWORD _                       ' __in HWND hWndRemove
 , BYVAL DWORD _                       ' __in HWND hWndNewNext
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetClipboardData LIB "USER32.DLL" ALIAS "SetClipboardData" ( _
   BYVAL DWORD _                       ' __in UINT uFormat
 , BYVAL DWORD _                       ' __in_opt HANDLE hMem
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetClipboardData LIB "USER32.DLL" ALIAS "GetClipboardData" ( _
   BYVAL DWORD _                       ' __in UINT uFormat
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION RegisterClipboardFormat LIB "USER32.DLL" ALIAS "RegisterClipboardFormatA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszFormat
 ) AS DWORD                            ' UINT

DECLARE FUNCTION RegisterClipboardFormatW LIB "USER32.DLL" ALIAS "RegisterClipboardFormatW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszFormat
 ) AS DWORD                            ' UINT

DECLARE FUNCTION CountClipboardFormats LIB "USER32.DLL" ALIAS "CountClipboardFormats" ( _
 ) AS LONG                             ' int

DECLARE FUNCTION EnumClipboardFormats LIB "USER32.DLL" ALIAS "EnumClipboardFormats" ( _
   BYVAL DWORD _                       ' __in UINT format
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetClipboardFormatName LIB "USER32.DLL" ALIAS "GetClipboardFormatNameA" ( _
   BYVAL DWORD _                       ' __in UINT format
 , BYREF ASCIIZ _                      ' __out_ecount(cchMaxCount) LPSTR lpszFormatName
 , BYVAL LONG _                        ' __in int cchMaxCount
 ) AS LONG                             ' int

DECLARE FUNCTION GetClipboardFormatNameW LIB "USER32.DLL" ALIAS "GetClipboardFormatNameW" ( _
   BYVAL DWORD _                       ' __in UINT format
 , BYVAL DWORD _                       ' __out_ecount(cchMaxCount) LPWSTR lpszFormatName
 , BYVAL LONG _                        ' __in int cchMaxCount
 ) AS LONG                             ' int

DECLARE FUNCTION EmptyClipboard LIB "USER32.DLL" ALIAS "EmptyClipboard" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsClipboardFormatAvailable LIB "USER32.DLL" ALIAS "IsClipboardFormatAvailable" ( _
   BYVAL DWORD _                       ' __in UINT format
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetPriorityClipboardFormat LIB "USER32.DLL" ALIAS "GetPriorityClipboardFormat" ( _
   BYREF LONG _                        ' __in_ecount(cFormats) UINT *paFormatPriorityList
 , BYVAL LONG _                        ' __in int cFormats
 ) AS LONG                             ' int

DECLARE FUNCTION GetOpenClipboardWindow LIB "USER32.DLL" ALIAS "GetOpenClipboardWindow" ( _
 ) AS DWORD                            ' HWND

'#if(WINVER >= 0x0600)
DECLARE FUNCTION AddClipboardFormatListener LIB "USER32.DLL" ALIAS "AddClipboardFormatListener" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RemoveClipboardFormatListener LIB "USER32.DLL" ALIAS "RemoveClipboardFormatListener" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetUpdatedClipboardFormats LIB "USER32.DLL" ALIAS "GetUpdatedClipboardFormats" ( _
   BYREF DWORD _                       ' __out PUINT lpuiFormats
 , BYVAL DWORD _                       ' __in  UINT cFormats
 , BYREF DWORD _                       ' __out PUINT pcFormatsOut
 ) AS LONG                             ' BOOL
'#endif /* WINVER >= 0x0600 */

'#endif /* !NOCLIPBOARD */
'#ENDIF   ' #IF NOT %DEF(%NOCLIPBOARD) ' ---------------------------------------

'/*
' * Character Translation Routines
' */

DECLARE FUNCTION CharToOem LIB "USER32.DLL" ALIAS "CharToOemA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszSrc
 , BYREF ASCIIZ _                      ' __out LPSTR lpszDst
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CharToOemW LIB "USER32.DLL" ALIAS "CharToOemW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszSrc
 , BYREF ASCIIZ _                      ' __out LPSTR lpszDst
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OemToChar LIB "USER32.DLL" ALIAS "OemToCharA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszSrc
 , BYREF ASCIIZ _                      ' __out LPSTR lpszDst
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OemToCharW LIB "USER32.DLL" ALIAS "OemToCharW" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszSrc
 , BYREF DWORD _                       ' __out LPWSTR lpszDst
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CharToOemBuff LIB "USER32.DLL" ALIAS "CharToOemBuffA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszSrc
 , BYREF ASCIIZ _                      ' __out_ecount(cchDstLength) LPSTR lpszDst
 , BYVAL LONG _                        ' __in DWORD cchDstLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CharToOemBuffW LIB "USER32.DLL" ALIAS "CharToOemBuffW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszSrc
 , BYREF ASCIIZ _                      ' __out_ecount(cchDstLength) LPSTR lpszDst
 , BYVAL LONG _                        ' __in DWORD cchDstLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OemToCharBuff LIB "USER32.DLL" ALIAS "OemToCharBuffA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszSrc
 , BYREF ASCIIZ _                      ' __out_ecount(cchDstLength) LPSTR lpszDst
 , BYVAL LONG _                        ' __in DWORD cchDstLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OemToCharBuffW LIB "USER32.DLL" ALIAS "OemToCharBuffW" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpszSrc
 , BYVAL DWORD _                       ' __out_ecount(cchDstLength) LPWSTR lpszDst
 , BYVAL LONG _                        ' __in DWORD cchDstLength
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CharUpper LIB "USER32.DLL" ALIAS "CharUpperA" ( _
   BYREF ASCIIZ _                      ' __inout LPSTR lpsz
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION CharUpperW LIB "USER32.DLL" ALIAS "CharUpperW" ( _
   BYVAL DWORD _                       ' __inout LPWSTR lpsz
 ) AS DWORD                            ' LPWSTR

DECLARE FUNCTION CharUpperBuff LIB "USER32.DLL" ALIAS "CharUpperBuffA" ( _
   BYREF ASCIIZ  _                     ' __inout_ecount(cchLength) LPSTR lpsz
 , BYVAL LONG _                        ' __in DWORD cchLength
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CharUpperBuffW LIB "USER32.DLL" ALIAS "CharUpperBuffW" ( _
   BYVAL DWORD _                       ' __inout_ecount(cchLength) LPWSTR lpsz
 , BYVAL LONG _                        ' __in DWORD cchLength
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CharLower LIB "USER32.DLL" ALIAS "CharLowerA" ( _
   BYREF ASCIIZ _                      ' __inout LPSTR lpsz
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION CharLowerW LIB "USER32.DLL" ALIAS "CharLowerW" ( _
   BYVAL DWORD _                       ' __inout LPWSTR lpsz
 ) AS DWORD                            ' LPWSTR

DECLARE FUNCTION CharLowerBuff LIB "USER32.DLL" ALIAS "CharLowerBuffA" ( _
   BYREF ASCIIZ _                      ' __inout_ecount(cchLength) LPSTR lpsz
 , BYVAL DWORD _                       ' __in DWORD cchLength
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CharLowerBuffW LIB "USER32.DLL" ALIAS "CharLowerBuffW" ( _
   BYVAL DWORD _                       ' __inout_ecount(cchLength) LPWSTR lpsz
 , BYVAL DWORD _                       ' __in DWORD cchLength)
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CharNext LIB "USER32.DLL" ALIAS "CharNextA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpsz
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION CharNextW LIB "USER32.DLL" ALIAS "CharNextW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpsz
 ) AS DWORD                            ' LPWSTR

DECLARE FUNCTION CharPrev LIB "USER32.DLL" ALIAS "CharPrevA" ( _
   BYREF ASCIIZ  _                     ' __in LPCSTR lpszStart
 , BYREF ASCIIZ _                      ' __in LPCSTR lpszCurrent
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION CharPrevW LIB "USER32.DLL" ALIAS "CharPrevW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpszStart
 , BYVAL DWORD _                       ' __in LPCWSTR lpszCurrent
 ) AS DWORD                            ' LPWSTR

'#if(WINVER >= 0x0400)
DECLARE FUNCTION CharNextEx LIB "USER32.DLL" ALIAS "CharNextExA" ( _
   BYVAL WORD _                        ' __in WORD CodePage
 , BYREF ASCIIZ _                      ' __in LPCSTR lpCurrentChar
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' LPSTR

DECLARE FUNCTION CharPrevEx LIB "USER32.DLL" ALIAS "CharPrevExA" ( _
   BYVAL WORD _                        ' __in WORD CodePage
 , BYREF ASCIIZ _                      ' __in LPCSTR lpStart
 , BYREF ASCIIZ _                      ' __in LPCSTR lpCurrentChar
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' LPSTR
'#endif /* WINVER >= 0x0400 */

'/*
' * Compatibility defines for character translation routines
' */
'#define AnsiToOem CharToOemA
'#define OemToAnsi OemToCharA
'#define AnsiToOemBuff CharToOemBuffA
'#define OemToAnsiBuff OemToCharBuffA
'#define AnsiUpper CharUpperA
'#define AnsiUpperBuff CharUpperBuffA
'#define AnsiLower CharLowerA
'#define AnsiLowerBuff CharLowerBuffA
'#define AnsiNext CharNextA
'#define AnsiPrev CharPrevA

'#IF NOT %DEF(%NOLANGUAGE) ' ---------------------------------------------------
'#ifndef  NOLANGUAGE
'/*
' * Language dependent Routines
' */

DECLARE FUNCTION IsCharAlpha LIB "USER32.DLL" ALIAS "IsCharAlphaA" ( _
   BYVAL BYTE _                        ' __in CHAR ch
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsCharAlphaW LIB "USER32.DLL" ALIAS "IsCharAlphaW" ( _
   BYVAL WORD _                        ' __in WCHAR ch
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsCharAlphaNumeric LIB "USER32.DLL" ALIAS "IsCharAlphaNumericA" ( _
   BYVAL BYTE _                        ' __in CHAR ch)
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsCharAlphaNumericW LIB "USER32.DLL" ALIAS "IsCharAlphaNumericW" ( _
   BYVAL BYTE _                        ' __in WCHAR ch)
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsCharUpper LIB "USER32.DLL" ALIAS "IsCharUpperA" ( _
   BYVAL BYTE _                        ' __in CHAR ch)
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsCharUpperW LIB "USER32.DLL" ALIAS "IsCharUpperW" ( _
   BYVAL BYTE _                        ' __in WCHAR ch)
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsCharLower LIB "USER32.DLL" ALIAS "IsCharLowerA" ( _
   BYVAL BYTE _                        ' __in CHAR ch)
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsCharLowerW LIB "USER32.DLL" ALIAS "IsCharLowerW" ( _
   BYVAL BYTE _                        ' __in WCHAR ch)
 ) AS LONG                             ' BOOL

'#endif  /* !NOLANGUAGE */
'#ENDIF   ' #IF NOT %DEF(%NOLANGUAGE) ' ----------------------------------------

DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetActiveWindow LIB "USER32.DLL" ALIAS "GetActiveWindow" ( _
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" ( _
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetKBCodePage LIB "USER32.DLL" ALIAS "GetKBCodePage" ( _
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetKeyState LIB "USER32.DLL" ALIAS "GetKeyState" ( _
   BYVAL LONG _                        ' __in int nVirtKey
 ) AS INTEGER                          ' SHORT

DECLARE FUNCTION GetAsyncKeyState LIB "USER32.DLL" ALIAS "GetAsyncKeyState" ( _
   BYVAL LONG _                        ' __in int vKey
 ) AS INTEGER                          ' SHORT

DECLARE FUNCTION GetKeyboardState LIB "USER32.DLL" ALIAS "GetKeyboardState" ( _
   BYREF BYTE _                        ' __out_ecount(256) PBYTE lpKeyState
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetKeyboardState LIB "USER32.DLL" ALIAS "SetKeyboardState" ( _
   BYREF BYTE _                        ' __in_ecount(256) LPBYTE lpKeyState
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetKeyNameText LIB "USER32.DLL" ALIAS "GetKeyNameTextA" ( _
   BYVAL LONG _                        ' __in LONG lParam
 , BYREF ASCIIZ _                      ' __out_ecount(cchSize) LPSTR lpString
 , BYVAL DWORD _                       ' __in int cchSize
 ) AS LONG                             ' int

DECLARE FUNCTION GetKeyNameTextW LIB "USER32.DLL" ALIAS "GetKeyNameTextW" ( _
   BYVAL LONG _                        ' __in LONG lParam
 , BYVAL DWORD _                       ' __out_ecount(cchSize) LPWSTR lpString
 , BYVAL DWORD _                       ' __in int cchSize
 ) AS LONG                             ' int

DECLARE FUNCTION GetKeyboardType LIB "USER32.DLL" ALIAS "GetKeyboardType" ( _
   BYVAL LONG _                        ' __in int nTypeFlag
 ) AS LONG                             ' int

DECLARE FUNCTION ToAscii LIB "USER32.DLL" ALIAS "ToAscii" ( _
   BYVAL DWORD _                       ' __in UINT uVirtKey
 , BYVAL DWORD _                       ' __in UINT uScanCode
 , BYREF BYTE _                        ' __in_ecount_opt(256) CONST BYTE *lpKeyState
 , BYREF DWORD _                       ' __out LPWORD lpChar
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS LONG                             ' int

'#if(WINVER >= 0x0400)
DECLARE FUNCTION ToAsciiEx LIB "USER32.DLL" ALIAS "ToAsciiEx" ( _
   BYVAL DWORD _                       ' __in UINT uVirtKey
 , BYVAL DWORD _                       ' __in UINT uScanCode
 , BYREF ANY _                         ' __in_ecount_opt(256) CONST BYTE *lpKeyState
 , BYREF DWORD _                       ' __out LPWORD lpChar
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in_opt HKL dwhkl
 ) AS LONG                             ' int
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION ToUnicode LIB "USER32.DLL" ALIAS "ToUnicode" ( _
   BYVAL DWORD _                       ' __in UINT wVirtKey
 , BYVAL DWORD _                       ' __in UINT wScanCode
 , BYREF BYTE _                        ' __in_bcount_opt(256) CONST BYTE *lpKeyState
 , BYVAL DWORD _                       ' __out_ecount(cchBuff) LPWSTR pwszBuff
 , BYVAL LONG _                        ' __in int cchBuff
 , BYVAL DWORD _                       ' __in UINT wFlags
 ) AS LONG                             ' int

DECLARE FUNCTION OemKeyScan LIB "USER32.DLL" ALIAS "OemKeyScan" ( _
   BYVAL WORD _                        ' __in WORD wOemChar
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION VkKeyScan LIB "USER32.DLL" ALIAS "VkKeyScanA" ( _
   BYVAL BYTE _                        ' __in CHAR ch
 ) AS INTEGER                          ' SHORT

DECLARE FUNCTION VkKeyScanW LIB "USER32.DLL" ALIAS "VkKeyScanW" ( _
   BYVAL WORD _                        ' __in WCHAR ch
 ) AS INTEGER                          ' SHORT

'#if(WINVER >= 0x0400)

DECLARE FUNCTION VkKeyScanEx LIB "USER32.DLL" ALIAS "VkKeyScanExA" ( _
   BYVAL BYTE _                        ' __in CHAR ch
 , BYVAL DWORD _                       ' __in HKL dwhkl
 ) AS INTEGER                          ' SHORT

DECLARE FUNCTION VkKeyScanExW LIB "USER32.DLL" ALIAS "VkKeyScanExW" ( _
   BYVAL WORD _                        ' __in WCHAR ch
 , BYVAL DWORD _                       ' __in HKL dwhkl
 ) AS INTEGER                          ' SHORT

'#endif /* WINVER >= 0x0400 */

%KEYEVENTF_EXTENDEDKEY = &H0001???
%KEYEVENTF_KEYUP       = &H0002???
'#if(_WIN32_WINNT >= 0x0500)
%KEYEVENTF_UNICODE     = &H0004???
%KEYEVENTF_SCANCODE    = &H0008???
'#endif /* _WIN32_WINNT >= 0x0500 */

DECLARE SUB keybd_event LIB "USER32.DLL" ALIAS "keybd_event" ( _
   BYVAL BYTE _                        ' __in BYTE bVk
 , BYVAL BYTE _                        ' __in BYTE bScan
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in ULONG_PTR dwExtraInfo
 )                                     ' VOID

%MOUSEEVENTF_MOVE        = &H0001???   ' mouse move
%MOUSEEVENTF_LEFTDOWN    = &H0002???   ' left button down
%MOUSEEVENTF_LEFTUP      = &H0004???   ' left button up
%MOUSEEVENTF_RIGHTDOWN   = &H0008???   ' right button down
%MOUSEEVENTF_RIGHTUP     = &H0010???   ' right button up
%MOUSEEVENTF_MIDDLEDOWN  = &H0020???   ' middle button down
%MOUSEEVENTF_MIDDLEUP    = &H0040???   ' middle button up
%MOUSEEVENTF_XDOWN       = &H0080???   ' /* x button down */
%MOUSEEVENTF_XUP         = &H0100???   ' /* x button down */
%MOUSEEVENTF_WHEEL       = &H0800???   ' wheel button rolled
'#if (_WIN32_WINNT >= 0x0600)
'#define MOUSEEVENTF_HWHEEL      0x01000 /* hwheel button rolled */
%MOUSEEVENTF_HWHEEL_VISTA = &H01000???   ' /* hwheel button rolled */
'#endif
'#if(WINVER >= 0x0600)
%MOUSEEVENTF_MOVE_NOCOALESCE = &H2000???   ' /* do not coalesce mouse moves */
'#endif /* WINVER >= 0x0600 */
%MOUSEEVENTF_VIRTUALDESK = &H4000???   '/* map to entire virtual desktop */
%MOUSEEVENTF_ABSOLUTE    = &H8000???   ' absolute move

DECLARE SUB mouse_event LIB "USER32.DLL" ALIAS "mouse_event" ( _
   BYVAL DWORD _                       ' __in DWORD dwFlags
 , BYVAL DWORD _                       ' __in DWORD dx
 , BYVAL DWORD _                       ' __in DWORD dy
 , BYVAL DWORD _                       ' __in DWORD dwData
 , BYVAL DWORD _                       ' __in ULONG_PTR dwExtraInfo
 )                                     ' VOID

'#if (_WIN32_WINNT > 0x0400)

TYPE MOUSEINPUT
   dx          AS LONG    ' LONG    dx
   dy          AS LONG    ' LONG    dy
   mouseData   AS DWORD   ' DWORD   mouseData
   dwFlags     AS DWORD   ' DWORD   dwFlags
   time        AS DWORD   ' DWORD   time
   dwExtraInfo AS DWORD   ' ULONG_PTR dwExtraInfo
END TYPE

TYPE KEYBDINPUT
   wVk         AS WORD    ' WORD      wVk
   wScan       AS WORD    ' WORD      wScan
   dwFlags     AS DWORD   ' DWORD     dwFlags
   time        AS DWORD   ' DWORD     time
   dwExtraInfo AS DWORD   ' ULONG_PTR dwExtraInfo
END TYPE

TYPE HARDWAREINPUT
   uMsg    AS DWORD   ' DWORD   uMsg
   wParamL AS WORD    ' WORD    wParamL
   wParamH AS WORD    ' WORD    wParamH
END TYPE

%INPUT_MOUSE    = 0???
%INPUT_KEYBOARD = 1???
%INPUT_HARDWARE = 2???

'typedef struct tagINPUT {
'    DWORD   type;

'    union
'    {
'        MOUSEINPUT      mi;
'        KEYBDINPUT      ki;
'        HARDWAREINPUT   hi;
'    };
'} INPUT, *PINPUT, FAR* LPINPUT;

UNION INPUTAPI_UNION
   mi AS MOUSEINPUT      ' MOUSEINPUT    mi
   ki AS KEYBDINPUT      ' KEYBDINPUT    ki
   hi AS HARDWAREINPUT   ' HARDWAREINPUT hi
END UNION

TYPE INPUTAPI
   dtype AS DWORD
   INPUTAPI_UNION
END TYPE

MACRO ragINPUT = INPUTAPI

DECLARE FUNCTION SendInput LIB "USER32.DLL" ALIAS "SendInput" ( _
   BYVAL DWORD _                       ' __in UINT cInputs
 , BYREF INPUTAPI _                    ' __in_ecount(cInputs) LPINPUT pInputs
 , BYVAL LONG _                        ' __in int cbSize
 ) AS DWORD                            ' UINT

'#endif // (_WIN32_WINNT > 0x0400)

'#if(_WIN32_WINNT >= 0x0500)

TYPE LASTINPUTINFO
   cbSize AS DWORD   ' UINT cbSize
   dwTime AS DWORD   ' DWORD dwTime
END TYPE

DECLARE FUNCTION GetLastInputInfo LIB "USER32.DLL" ALIAS "GetLastInputInfo" ( _
   BYREF LASTINPUTINFO _               ' __out PLASTINPUTINFO plii
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >= 0x0500 */

DECLARE FUNCTION MapVirtualKey LIB "USER32.DLL" ALIAS "MapVirtualKeyA" ( _
   BYVAL DWORD _                       ' __in UINT uCode
 , BYVAL DWORD _                       ' __in UINT uMapType
 ) AS DWORD                            ' UINT

DECLARE FUNCTION MapVirtualKeyW LIB "USER32.DLL" ALIAS "MapVirtualKeyW" ( _
   BYVAL DWORD _                       ' __in UINT uCode
 , BYVAL DWORD _                       ' __in UINT uMapType
 ) AS DWORD                            ' UINT

'#if(WINVER >= 0x0400)

DECLARE FUNCTION MapVirtualKeyEx LIB "USER32.DLL" ALIAS "MapVirtualKeyExA" ( _
   BYVAL DWORD _                       ' __in UINT uCode
 , BYVAL DWORD _                       ' __in UINT uMapType
 , BYVAL DWORD _                       ' __in_opt HKL dwhkl
 ) AS DWORD                            ' UINT

DECLARE FUNCTION MapVirtualKeyExW LIB "USER32.DLL" ALIAS "MapVirtualKeyExW" ( _
   BYVAL DWORD _                       ' __in UINT uCode
 , BYVAL DWORD _                       ' __in UINT uMapType
 , BYVAL DWORD _                       ' __in_opt HKL dwhkl
 ) AS DWORD                            ' UINT

%MAPVK_VK_TO_VSC     = 0
%MAPVK_VSC_TO_VK     = 1
%MAPVK_VK_TO_CHAR    = 2
%MAPVK_VSC_TO_VK_EX  = 3
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0600)
%MAPVK_VK_TO_VSC_EX  = 4
'#endif /* WINVER >= 0x0600 */

DECLARE FUNCTION GetInputState LIB "USER32.DLL" ALIAS "GetInputState" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetQueueStatus LIB "USER32.DLL" ALIAS "GetQueueStatus" ( _
   BYVAL DWORD _                       ' __in UINT flags
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetCapture LIB "USER32.DLL" ALIAS "GetCapture" ( _
 ) AS DWORD                            ' HWND

DECLARE FUNCTION SetCapture LIB "USER32.DLL" ALIAS "SetCapture" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS DWORD                            ' HWND

DECLARE FUNCTION ReleaseCapture LIB "USER32.DLL" ALIAS "ReleaseCapture" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION MsgWaitForMultipleObjects LIB "USER32.DLL" ALIAS "MsgWaitForMultipleObjects" ( _
   BYVAL DWORD _                       ' __in DWORD nCount
 , BYREF DWORD _                       ' __in_ecount_opt(nCount) CONST HANDLE *pHandles
 , BYVAL LONG _                        ' __in BOOL fWaitAll
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 , BYVAL DWORD _                       ' __in DWORD dwWakeMask
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION MsgWaitForMultipleObjectsEx LIB "USER32.DLL" ALIAS "MsgWaitForMultipleObjectsEx" ( _
   BYVAL DWORD _                       ' __in DWORD nCount
 , BYREF DWORD _                       ' __in_ecount_opt(nCount) CONST HANDLE *pHandles
 , BYVAL DWORD _                       ' __in DWORD dwMilliseconds
 , BYVAL DWORD _                       ' __in DWORD dwWakeMask
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' DWORD

%MWMO_WAITALL        = &H0001???
%MWMO_ALERTABLE      = &H0002???
%MWMO_INPUTAVAILABLE = &H0004???

'/*
' * Windows Functions
' */

DECLARE FUNCTION SetTimer LIB "USER32.DLL" ALIAS "SetTimer" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT_PTR nIDEvent
 , BYVAL DWORD _                       ' __in UINT uElapse
 , BYVAL DWORD _                       ' __in_opt TIMERPROC lpTimerFunc
 ) AS DWORD                            ' UINT_PTR

DECLARE FUNCTION KillTimer LIB "USER32.DLL" ALIAS "KillTimer" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in UINT_PTR uIDEvent
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsWindowUnicode LIB "USER32.DLL" ALIAS "IsWindowUnicode" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnableWindow LIB "USER32.DLL" ALIAS "EnableWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in BOOL bEnable
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsWindowEnabled LIB "USER32.DLL" ALIAS "IsWindowEnabled" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LoadAccelerators LIB "USER32.DLL" ALIAS "LoadAcceleratorsA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpTableName
 ) AS DWORD                            ' HACCEL

DECLARE FUNCTION LoadAcceleratorsW LIB "USER32.DLL" ALIAS "LoadAcceleratorsW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in LPCWSTR lpTableName
 ) AS DWORD                            ' HACCEL

DECLARE FUNCTION CreateAcceleratorTable LIB "USER32.DLL" ALIAS "CreateAcceleratorTableA" ( _
   BYREF ACCELAPI _                    ' __in_ecount(cAccel) LPACCEL paccel
 , BYVAL LONG _                        ' __in int cAccel
 ) AS DWORD                            ' HACCEL

DECLARE FUNCTION CreateAcceleratorTableW LIB "USER32.DLL" ALIAS "CreateAcceleratorTableW" ( _
   BYREF ACCELAPI _                    ' __in_ecount(cAccel) LPACCEL paccel
 , BYVAL LONG _                        ' __in int cAccel
 ) AS DWORD                            ' HACCEL

DECLARE FUNCTION DestroyAcceleratorTable LIB "USER32.DLL" ALIAS "DestroyAcceleratorTable" ( _
   BYVAL DWORD _                       ' __in HACCEL hAccel
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CopyAcceleratorTable LIB "USER32.DLL" ALIAS "CopyAcceleratorTableA" ( _
   BYVAL DWORD _                       ' __in HACCEL hAccelSrc
 , BYREF ACCELAPI _                    ' __out_ecount_part_opt(cAccelEntries, return) LPACCEL lpAccelDst
 , BYVAL LONG _                        ' __in int cAccelEntries
 ) AS LONG                             ' int

DECLARE FUNCTION CopyAcceleratorTableW LIB "USER32.DLL" ALIAS "CopyAcceleratorTableW" ( _
   BYVAL DWORD _                       ' __in HACCEL hAccelSrc
 , BYREF ACCELAPI  _                   ' __out_ecount_part_opt(cAccelEntries, return) LPACCEL lpAccelDst
 , BYVAL LONG _                        ' __in int cAccelEntries
 ) AS LONG                             ' int

'#IF NOT %DEF(%NOMSG) '---------------------------------------------------------
'#ifndef NOMSG

DECLARE FUNCTION TranslateAccelerator LIB "USER32.DLL" ALIAS "TranslateAcceleratorA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in HACCEL hAccTable
 , BYREF tagMSG _                      ' __in LPMSG lpMsg
 ) AS LONG                             ' int

DECLARE FUNCTION TranslateAcceleratorW LIB "USER32.DLL" ALIAS "TranslateAcceleratorW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in HACCEL hAccTable
 , BYREF tagMSG _                      ' __in LPMSG lpMsg
 ) AS LONG                             ' int

'#endif /* !NOMSG */
'#ENDIF   ' #IF NOT %DEF(%NOMSG) '----------------------------------------------

'#IF NOT %DEF(%NOSYSMETRICS) ' -------------------------------------------------
'#ifndef NOSYSMETRICS

'/*
' * GetSystemMetrics() codes
' */

%SM_CXSCREEN            = 0&
%SM_CYSCREEN            = 1&
%SM_CXVSCROLL           = 2&
%SM_CYHSCROLL           = 3&
%SM_CYCAPTION           = 4&
%SM_CXBORDER            = 5&
%SM_CYBORDER            = 6&
%SM_CXDLGFRAME          = 7&
%SM_CYDLGFRAME          = 8&
%SM_CYVTHUMB            = 9&
%SM_CXHTHUMB            = 10&
%SM_CXICON              = 11&
%SM_CYICON              = 12&
%SM_CXCURSOR            = 13&
%SM_CYCURSOR            = 14&
%SM_CYMENU              = 15&
%SM_CXFULLSCREEN        = 16&
%SM_CYFULLSCREEN        = 17&
%SM_CYKANJIWINDOW       = 18&
%SM_MOUSEPRESENT        = 19&
%SM_CYVSCROLL           = 20&
%SM_CXHSCROLL           = 21&
%SM_DEBUG               = 22&
%SM_SWAPBUTTON          = 23&
%SM_RESERVED1           = 24&
%SM_RESERVED2           = 25&
%SM_RESERVED3           = 26&
%SM_RESERVED4           = 27&
%SM_CXMIN               = 28&
%SM_CYMIN               = 29&
%SM_CXSIZE              = 30&
%SM_CYSIZE              = 31&
%SM_CXFRAME             = 32&
%SM_CYFRAME             = 33&
%SM_CXMINTRACK          = 34&
%SM_CYMINTRACK          = 35&
%SM_CXDOUBLECLK         = 36&
%SM_CYDOUBLECLK         = 37&
%SM_CXICONSPACING       = 38&
%SM_CYICONSPACING       = 39&
%SM_MENUDROPALIGNMENT   = 40&
%SM_PENWINDOWS          = 41&
%SM_DBCSENABLED         = 42&
%SM_CMOUSEBUTTONS       = 43&

'#if(WINVER >= 0x0400)
%SM_CXFIXEDFRAME        = %SM_CXDLGFRAME  ' win40 name change
%SM_CYFIXEDFRAME        = %SM_CYDLGFRAME  ' win40 name change
%SM_CXSIZEFRAME         = %SM_CXFRAME     ' win40 name change
%SM_CYSIZEFRAME         = %SM_CYFRAME     ' win40 name change

%SM_SECURE              = 44&
%SM_CXEDGE              = 45&
%SM_CYEDGE              = 46&
%SM_CXMINSPACING        = 47&
%SM_CYMINSPACING        = 48&
%SM_CXSMICON            = 49&
%SM_CYSMICON            = 50&
%SM_CYSMCAPTION         = 51&
%SM_CXSMSIZE            = 52&
%SM_CYSMSIZE            = 53&
%SM_CXMENUSIZE          = 54&
%SM_CYMENUSIZE          = 55&
%SM_ARRANGE             = 56&
%SM_CXMINIMIZED         = 57&
%SM_CYMINIMIZED         = 58&
%SM_CXMAXTRACK          = 59&
%SM_CYMAXTRACK          = 60&
%SM_CXMAXIMIZED         = 61&
%SM_CYMAXIMIZED         = 62&
%SM_NETWORK             = 63&
%SM_CLEANBOOT           = 67&
%SM_CXDRAG              = 68&
%SM_CYDRAG              = 69&
'#endif /* WINVER >= 0x0400 */
%SM_SHOWSOUNDS          = 70&
'#if(WINVER >= 0x0400)
%SM_CXMENUCHECK         = 71&   ' Use instead of GetMenuCheckMarkDimensions()
%SM_CYMENUCHECK         = 72&
%SM_SLOWMACHINE         = 73&
%SM_MIDEASTENABLED      = 74&
'#endif /* WINVER >= 0x0400 */

'#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
%SM_MOUSEWHEELPRESENT   = 75&
'#endif
'#if(WINVER >= 0x0500)
%SM_XVIRTUALSCREEN      = 76&
%SM_YVIRTUALSCREEN      = 77&
%SM_CXVIRTUALSCREEN     = 78&
%SM_CYVIRTUALSCREEN     = 79&
%SM_CMONITORS           = 80&
%SM_SAMEDISPLAYFORMAT   = 81&
'#endif /* WINVER >= 0x0500 */
'#if(_WIN32_WINNT >= 0x0500)
%SM_IMMENABLED          = 82&
'#endif /* _WIN32_WINNT >= 0x0500 */
'#if(_WIN32_WINNT >= 0x0501)
%SM_CXFOCUSBORDER       = 83&
%SM_CYFOCUSBORDER       = 84&
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(_WIN32_WINNT >= 0x0501)
%SM_TABLETPC            = 86&
%SM_MEDIACENTER         = 87&
%SM_STARTER             = 88&
%SM_SERVERR2            = 89&
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(_WIN32_WINNT >= 0x0600)
%SM_MOUSEHORIZONTALWHEELPRESENT = 91
%SM_CXPADDEDBORDER              = 92
'#endif /* _WIN32_WINNT >= 0x0600 */

'#if (WINVER < 0x0500) && (!defined(_WIN32_WINNT) || (_WIN32_WINNT < 0x0400))
'#define SM_CMETRICS             76
'#elif WINVER == 0x500
'#define SM_CMETRICS             83
'#elif WINVER == 0x501
'#define SM_CMETRICS             90
'#else
'#define SM_CMETRICS             93
'#endif

%SM_CMETRICS            = 90&  ' varies by Windows version

'#if(WINVER >= 0x0500)
%SM_REMOTESESSION       = &H1000&

'#if(_WIN32_WINNT >= 0x0501)
%SM_SHUTTINGDOWN        = &H2000&
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(WINVER >= 0x0501)
%SM_REMOTECONTROL       = &H2001&
'#endif /* WINVER >= 0x0501 */

'#if(WINVER >= 0x0501)
%SM_CARETBLINKINGENABLED = &H2002&
'#endif /* WINVER >= 0x0501 */

'#endif /* WINVER >= 0x0500 */

DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" ( _
   BYVAL LONG _                        ' __in int nIndex
 ) AS LONG                             ' int

'#endif /* !NOSYSMETRICS */
'#ENDIF   ' #IF NOT %DEF(%NOSYSMETRICS) ' --------------------------------------

'#IF NOT %DEF(%NOMENUS) ' ------------------------------------------------------
'#ifndef NOMENUS

DECLARE FUNCTION LoadMenu LIB "USER32.DLL" ALIAS "LoadMenuA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpMenuName
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION LoadMenuW LIB "USER32.DLL" ALIAS "LoadMenuW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in LPCWSTR lpMenuName
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION LoadMenuIndirect LIB "USER32.DLL" ALIAS "LoadMenuIndirectA" ( _
   BYVAL DWORD _                       ' __in CONST MENUTEMPLATEA *lpMenuTemplate
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION LoadMenuIndirectW LIB "USER32.DLL" ALIAS "LoadMenuIndirectW" ( _
   BYVAL DWORD _                       ' __in CONST MENUTEMPLATEW *lpMenuTemplate
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION GetMenu LIB "USER32.DLL" ALIAS "GetMenu" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION SetMenu LIB "USER32.DLL" ALIAS "SetMenu" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HMENU hMenu
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ChangeMenu LIB "USER32.DLL" ALIAS "ChangeMenuA" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT cmd
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpszNewItem
 , BYVAL DWORD _                       ' __in UINT cmdInsert
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ChangeMenuW LIB "USER32.DLL" ALIAS "ChangeMenuW" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT cmd
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpszNewItem
 , BYVAL DWORD _                       ' __in UINT cmdInsert
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HiliteMenuItem LIB "USER32.DLL" ALIAS "HiliteMenuItem" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uIDHiliteItem
 , BYVAL DWORD _                       ' __in UINT uHilite
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMenuString LIB "USER32.DLL" ALIAS "GetMenuStringA" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uIDItem
 , BYREF ASCIIZ _                      ' __out_ecount_opt(cchMax) LPSTR lpString
 , BYVAL LONG _                        ' __in int cchMax
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS LONG                             ' int

DECLARE FUNCTION GetMenuStringW LIB "USER32.DLL" ALIAS "GetMenuStringW" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uIDItem
 , BYVAL DWORD _                       ' __out_ecount_opt(cchMax) LPWSTR lpString
 , BYVAL LONG _                        ' __in int cchMax
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS LONG                             ' int

DECLARE FUNCTION GetMenuState LIB "USER32.DLL" ALIAS "GetMenuState" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uId
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS DWORD                            ' UINT

DECLARE FUNCTION DrawMenuBar LIB "USER32.DLL" ALIAS "DrawMenuBar" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0501)
%PMB_ACTIVE = &H00000001???
'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION GetSystemMenu LIB "USER32.DLL" ALIAS "GetSystemMenu" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in BOOL bRevert
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION CreateMenu LIB "USER32.DLL" ALIAS "CreateMenu" ( _
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION CreatePopupMenu LIB "USER32.DLL" ALIAS "CreatePopupMenu" ( _
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION DestroyMenu LIB "USER32.DLL" ALIAS "DestroyMenu" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CheckMenuItem LIB "USER32.DLL" ALIAS "CheckMenuItem" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uIDCheckItem
 , BYVAL DWORD _                       ' __in UINT uCheck
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION EnableMenuItem LIB "USER32.DLL" ALIAS "EnableMenuItem" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uIDEnableItem
 , BYVAL DWORD _                       ' __in UINT uEnable
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetSubMenu LIB "USER32.DLL" ALIAS "GetSubMenu" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL LONG _                        ' __in int nPos
 ) AS DWORD                            ' HMENU

DECLARE FUNCTION GetMenuItemID LIB "USER32.DLL" ALIAS "GetMenuItemID" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL LONG _                        ' __in int nPos
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetMenuItemCount LIB "USER32.DLL" ALIAS "GetMenuItemCount" ( _
   BYVAL DWORD _                       ' __in_opt HMENU hMenu
 ) AS LONG                             ' int

DECLARE FUNCTION InsertMenu LIB "USER32.DLL" ALIAS "InsertMenuA" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uPosition
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in UINT_PTR uIDNewItem
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpNewItem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION InsertMenuW LIB "USER32.DLL" ALIAS "InsertMenuW" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uPosition
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in UINT_PTR uIDNewItem
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpNewItem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AppendMenu LIB "USER32.DLL" ALIAS "AppendMenuA" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in UINT_PTR uIDNewItem
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpNewItem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AppendMenuW LIB "USER32.DLL" ALIAS "AppendMenuW" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in UINT_PTR uIDNewItem
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpNewItem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ModifyMenu LIB "USER32.DLL" ALIAS "ModifyMenuA" ( _
   BYVAL DWORD _                       ' __in HMENU hMnu
 , BYVAL DWORD _                       ' __in UINT uPosition
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in UINT_PTR uIDNewItem
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpNewItem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ModifyMenuW LIB "USER32.DLL" ALIAS "ModifyMenuW" ( _
   BYVAL DWORD _                       ' __in HMENU hMnu
 , BYVAL DWORD _                       ' __in UINT uPosition
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in UINT_PTR uIDNewItem
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpNewItem
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RemoveMenu LIB "USER32.DLL" ALIAS "RemoveMenu" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uPosition
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeleteMenu LIB "USER32.DLL" ALIAS "DeleteMenu" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uPosition
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetMenuItemBitmaps LIB "USER32.DLL" ALIAS "SetMenuItemBitmaps" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uPosition
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL DWORD _                       ' __in_opt HBITMAP hBitmapUnchecked
 , BYVAL DWORD _                       ' __in_opt HBITMAP hBitmapChecked
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMenuCheckMarkDimensions LIB "USER32.DLL" ALIAS "GetMenuCheckMarkDimensions" ( _
 ) AS LONG                             ' long

DECLARE FUNCTION TrackPopupMenu LIB "USER32.DLL" ALIAS "TrackPopupMenu" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uFlags
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL LONG _                        ' __in int nReserved
 , BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF RECT _                        ' __in_opt CONST RECT *prcRect
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0400)
'/* return codes for WM_MENUCHAR */
%MNC_IGNORE  = 0&
%MNC_CLOSE   = 1&
%MNC_EXECUTE = 2&
%MNC_SELECT  = 3&

TYPE TPMPARAMS
   cbSize    AS DWORD   ' UINT    cbSize;     /* Size of structure */
   rcExclude AS RECT    ' RECT    rcExclude;  /* Screen coordinates of rectangle to exclude when positioning */
END TYPE

DECLARE FUNCTION TrackPopupMenuEx LIB "USER32.DLL" ALIAS "TrackPopupMenuEx" (_
   BYVAL DWORD _                       ' __in HMENU
 , BYVAL DWORD _                       ' __in UINT
 , BYVAL LONG _                        ' __in int
 , BYVAL LONG _                        ' __in int
 , BYVAL DWORD _                       ' __in HWND
 , BYREF TPMPARAMS _                   ' __in_opt LPTPMPARAMS
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)

%MNS_NOCHECK         = &H80000000???
%MNS_MODELESS        = &H40000000???
%MNS_DRAGDROP        = &H20000000???
%MNS_AUTODISMISS     = &H10000000???
%MNS_NOTIFYBYPOS     = &H08000000???
%MNS_CHECKORBMP      = &H04000000???

%MIM_MAXHEIGHT       = &H00000001???
%MIM_BACKGROUND      = &H00000002???
%MIM_HELPID          = &H00000004???
%MIM_MENUDATA        = &H00000008???
%MIM_STYLE           = &H00000010???
%MIM_APPLYTOSUBMENUS = &H80000000???

TYPE MENUINFO
   cbSize          AS DWORD   ' DWORD     cbSize
   fMask           AS DWORD   ' DWORD     fMask
   dwStyle         AS DWORD   ' DWORD     dwStyle
   cyMax           AS DWORD   ' UINT      cyMax
   hbrBack         AS DWORD   ' HBRUSH    hbrBack
   dwContextHelpID AS DWORD   ' DWORD     dwContextHelpID
   dwMenuData      AS DWORD   ' ULONG_PTR dwMenuData
END TYPE

DECLARE FUNCTION GetMenuInfo LIB "USER32.DLL" ALIAS "GetMenuInfo" ( _
   BYVAL DWORD _                       ' __in HMENU
 , BYREF MENUINFO _                    ' __inout LPMENUINFO
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetMenuInfo LIB "USER32.DLL" ALIAS "SetMenuInfo" ( _
   BYVAL DWORD _                       ' __in HMENU
 , BYREF MENUINFO _                    ' __in LPCMENUINFO
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EndMenu LIB "USER32.DLL" ALIAS "EndMenu" ( _
 ) AS LONG                             ' BOOL

'/*
' * WM_MENUDRAG return values.
' */

%MND_CONTINUE = 0&
%MND_ENDMENU  = 1&

TYPE MENUGETOBJECTINFO
   dwFlags AS DWORD   ' DWORD dwFlags
   uPos    AS DWORD   ' UINT uPos
   hmenu   AS DWORD   ' HMENU hmenu
   riid    AS DWORD   ' PVOID riid
   pvObj   AS DWORD   ' PVOID pvObj
END TYPE

'/*
' * MENUGETOBJECTINFO dwFlags values
' */
%MNGOF_TOPGAP     = &H00000001???
%MNGOF_BOTTOMGAP  = &H00000002???

'/*
' * WM_MENUGETOBJECT return values
' */
%MNGO_NOINTERFACE = &H00000000???
%MNGO_NOERROR     = &H00000001???
'#endif /* WINVER >= 0x0500 */

'#if(WINVER >= 0x0400)
%MIIM_STATE       = &H00000001???
%MIIM_ID          = &H00000002???
%MIIM_SUBMENU     = &H00000004???
%MIIM_CHECKMARKS  = &H00000008???
%MIIM_TYPE        = &H00000010???
%MIIM_DATA        = &H00000020???
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
%MIIM_STRING      = &H00000040???
%MIIM_BITMAP      = &H00000080???
%MIIM_FTYPE       = &H00000100???

%HBMMENU_CALLBACK        = &HFFFFFFFF??? ' ((HBITMAP) -1)
%HBMMENU_SYSTEM          =  1???         ' ((HBITMAP)  1)
%HBMMENU_MBAR_RESTORE    =  2???         ' ((HBITMAP)  2)
%HBMMENU_MBAR_MINIMIZE   =  3???         ' ((HBITMAP)  3)
%HBMMENU_MBAR_CLOSE      =  5???         ' ((HBITMAP)  5)
%HBMMENU_MBAR_CLOSE_D    =  6???         ' ((HBITMAP)  6)
%HBMMENU_MBAR_MINIMIZE_D =  7???         ' ((HBITMAP)  7)
%HBMMENU_POPUP_CLOSE     =  8???         ' ((HBITMAP)  8)
%HBMMENU_POPUP_RESTORE   =  9???         ' ((HBITMAP)  9)
%HBMMENU_POPUP_MAXIMIZE  = 10???         ' ((HBITMAP)  10)
%HBMMENU_POPUP_MINIMIZE  = 11???         ' ((HBITMAP)  11)
'#endif /* WINVER >= 0x0500 */

'#if(WINVER >= 0x0400)

TYPE MENUITEMINFOA
   cbSize        AS DWORD        ' UINT     cbSize
   fMask         AS DWORD        ' UINT     fMask
   fType         AS DWORD        ' UINT     fType;         // used if MIIM_TYPE (4.0) or MIIM_FTYPE (>4.0)
   fState        AS DWORD        ' UINT     fState;        // used if MIIM_STATE
   wID           AS DWORD        ' UINT     wID;           // used if MIIM_ID
   hSubMenu      AS DWORD        ' HMENU    hSubMenu;      // used if MIIM_SUBMENU
   hbmpChecked   AS DWORD        ' HBITMAP  hbmpChecked;   // used if MIIM_CHECKMARKS
   hbmpUnchecked AS DWORD        ' HBITMAP  hbmpUnchecked; // used if MIIM_CHECKMARKS
   dwItemData    AS DWORD        ' ULONG_PTR dwItemData;   // used if MIIM_DATA
   dwTypeData    AS ASCIIZ PTR   ' LPSTR    dwTypeData;    // used if MIIM_TYPE (4.0) or MIIM_STRING (>4.0)
   cch           AS DWORD        ' UINT     cch;           // used if MIIM_TYPE (4.0) or MIIM_STRING (>4.0)
'#if(WINVER >= 0x0500)
   hbmpItem      AS DWORD        ' HBITMAP  hbmpItem;      // used if MIIM_BITMAP
'#endif /* WINVER >= 0x0500 */
END TYPE

TYPE MENUITEMINFOW
   cbSize        AS DWORD        ' UINT     cbSize
   fMask         AS DWORD        ' UINT     fMask
   fType         AS DWORD        ' UINT     fType;         // used if MIIM_TYPE (4.0) or MIIM_FTYPE (>4.0)
   fState        AS DWORD        ' UINT     fState;        // used if MIIM_STATE
   wID           AS DWORD        ' UINT     wID;           // used if MIIM_ID
   hSubMenu      AS DWORD        ' HMENU    hSubMenu;      // used if MIIM_SUBMENU
   hbmpChecked   AS DWORD        ' HBITMAP  hbmpChecked;   // used if MIIM_CHECKMARKS
   hbmpUnchecked AS DWORD        ' HBITMAP  hbmpUnchecked; // used if MIIM_CHECKMARKS
   dwItemData    AS DWORD        ' ULONG_PTR dwItemData;   // used if MIIM_DATA
   dwTypeData    AS WORD PTR     ' LPWSTR   dwTypeData;    // used if MIIM_TYPE (4.0) or MIIM_STRING (>4.0)
   cch           AS DWORD        ' UINT     cch;           // used if MIIM_TYPE (4.0) or MIIM_STRING (>4.0)
'#if(WINVER >= 0x0500)
   hbmpItem      AS DWORD        ' HBITMAP  hbmpItem;      // used if MIIM_BITMAP
'#endif /* WINVER >= 0x0500 */
END TYPE

MACRO MENUITEMINFO = MENUITEMINFOA

DECLARE FUNCTION InsertMenuItem LIB "USER32.DLL" ALIAS "InsertMenuItemA" ( _
   BYVAL DWORD _                       ' __in HMENU hmenu
 , BYVAL DWORD _                       ' __in UINT item
 , BYVAL LONG _                        ' __in BOOL fByPosition
 , BYREF MENUITEMINFOA _               ' __in LPCMENUITEMINFOA lpmi
 ) AS LONG                             ' BOOL

DECLARE FUNCTION InsertMenuItemW LIB "USER32.DLL" ALIAS "InsertMenuItemW" ( _
   BYVAL DWORD _                       ' __in HMENU hmenu
 , BYVAL DWORD _                       ' __in UINT item
 , BYVAL LONG _                        ' __in BOOL fByPosition
 , BYREF MENUITEMINFOW _               ' __in LPCMENUITEMINFOW lpmi
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMenuItemInfo LIB "USER32.DLL" ALIAS "GetMenuItemInfoA" ( _
   BYVAL DWORD _                       ' __in HMENU hmenu
 , BYVAL DWORD _                       ' __in UINT item
 , BYVAL LONG _                        ' __in BOOL fByPosition
 , BYREF MENUITEMINFOA _               ' __inout LPMENUITEMINFOA lpmii
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMenuItemInfoW LIB "USER32.DLL" ALIAS "GetMenuItemInfoW" ( _
   BYVAL DWORD _                       ' __in HMENU hmenu
 , BYVAL DWORD _                       ' __in UINT item
 , BYVAL LONG _                        ' __in BOOL fByPosition
 , BYREF MENUITEMINFOW _               ' __inout LPMENUITEMINFOW lpmii
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetMenuItemInfo LIB "USER32.DLL" ALIAS "SetMenuItemInfoA" ( _
   BYVAL DWORD _                       ' __in HMENU hmenu
 , BYVAL DWORD _                       ' __in UINT item
 , BYVAL LONG _                        ' __in BOOL fByPositon
 , BYREF MENUITEMINFOA _               ' __in LPCMENUITEMINFOA lpmii
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetMenuItemInfoW LIB "USER32.DLL" ALIAS "SetMenuItemInfoW" ( _
   BYVAL DWORD _                       ' __in HMENU hmenu
 , BYVAL DWORD _                       ' __in UINT item
 , BYVAL LONG _                        ' __in BOOL fByPositon
 , BYREF MENUITEMINFOW _               ' __in LPCMENUITEMINFOW lpmii
 ) AS LONG                             ' BOOL

%GMDI_USEDISABLED    = &H0001???
%GMDI_GOINTOPOPUPS   = &H0002???

DECLARE FUNCTION GetMenuDefaultItem LIB "USER32.DLL" ALIAS "GetMenuDefaultItem" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT fByPos
 , BYVAL DWORD _                       ' __in UINT gmdiFlags
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetMenuDefaultItem LIB "USER32.DLL" ALIAS "SetMenuDefaultItem" ( _
   BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uItem
 , BYVAL DWORD _                       ' __in UINT fByPos
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMenuItemRect LIB "USER32.DLL" ALIAS "GetMenuItemRect" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in HMENU hMenu
 , BYVAL DWORD _                       ' __in UINT uItem
 , BYREF RECT _                        ' __out LPRECT lprcItem
 ) AS LONG                             ' BOOL


' Uses x, y for compatibility with PB's include file...
DECLARE FUNCTION MenuItemFromPoint LIB "USER32.DLL" ALIAS "MenuItemFromPoint" ( _
   BYVAL DWORD _                    ' __in_opt HWND hWnd
 , BYVAL DWORD _                    ' __in HMENU hMenu
 , BYVAL LONG _                     ' __in x
 , BYVAL LONG _                     ' __in y
 ) AS LONG                          ' int

' ... but it should be
'DECLARE FUNCTION MenuItemFromPoint LIB "USER32.DLL" ALIAS "MenuItemFromPoint" ( _
'   BYVAL DWORD _                    ' __in_opt HWND hWnd
' , BYVAL DWORD _                    ' __in HMENU hMenu
' , BYVAL POINTAPI _                 ' __in POINT ptScreen
' ) AS LONG                          ' int


'#endif /* WINVER >= 0x0400 */

'/*
' * Flags for TrackPopupMenu
' */
%TPM_LEFTBUTTON      = &H0000???
%TPM_RIGHTBUTTON     = &H0002???
%TPM_LEFTALIGN       = &H0000???
%TPM_CENTERALIGN     = &H0004???
%TPM_RIGHTALIGN      = &H0008???

'#if(WINVER >= 0x0400)
%TPM_TOPALIGN        = &H0000???
%TPM_VCENTERALIGN    = &H0010???
%TPM_BOTTOMALIGN     = &H0020???

%TPM_HORIZONTAL      = &H0000???  ' Horz alignment matters more
%TPM_VERTICAL        = &H0040???  ' Vert alignment matters more
%TPM_NONOTIFY        = &H0080???  ' Don't send any notification msgs
%TPM_RETURNCMD       = &H0100???
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
%TPM_RECURSE         = &H00001???
%TPM_HORPOSANIMATION = &H00400???
%TPM_HORNEGANIMATION = &H00800???
%TPM_VERPOSANIMATION = &H01000???
%TPM_VERNEGANIMATION = &H02000???
'#if(_WIN32_WINNT >= 0x0500)
%TPM_NOANIMATION     = &H04000???
'#endif /* _WIN32_WINNT >= 0x0500 */
'#if(_WIN32_WINNT >= 0x0501)
%TPM_LAYOUTRTL       = &H08000???
'#endif /* _WIN32_WINNT >= 0x0501 */
'#endif /* WINVER >= 0x0500 */


'#endif /* !NOMENUS */
'#ENDIF   ' #IF NOT %DEF(%NOMENUS) ' -------------------------------------------


'#if(WINVER >= 0x0400)
'//
'// Drag-and-drop support
'// Obsolete - use OLE instead
'//

TYPE DROPSTRUCT
   hwndSource    AS DWORD      ' HWND    hwndSource
   hwndSink      AS DWORD      ' HWND    hwndSink
   wFmt          AS DWORD      ' DWORD   wFmt
   dwData        AS DWORD      ' ULONG_PTR dwData
   ptDrop        AS POINTAPI   ' POINT   ptDrop
   dwControlData AS DWORD      ' DWORD   dwControlData
END TYPE

%DOF_EXECUTABLE = &H8001???      ' wFmt flags
%DOF_DOCUMENT   = &H8002???
%DOF_DIRECTORY  = &H8003???
%DOF_MULTIPLE   = &H8004???
%DOF_PROGMAN    = &H0001???
%DOF_SHELLDATA  = &H0002???

%DO_DROPFILE    = &H454C4946???
%DO_PRINTFILE   = &H544E5250???

DECLARE FUNCTION DragObject LIB "USER32.DLL" ALIAS "DragObject" ( _
   BYVAL DWORD _                       ' __in HWND hwndParent
 , BYVAL DWORD _                       ' __in HWND hwndFrom
 , BYVAL DWORD _                       ' __in UINT fmt
 , BYVAL DWORD _                       ' __in ULONG_PTR data
 , BYVAL DWORD _                       ' __in_opt HCURSOR hcur
 ) AS DWORD                            ' DWORD

' Uses x, y for compatibility with PB's include file...
DECLARE FUNCTION DragDetect LIB "USER32.DLL" ALIAS "DragDetect" ( _
   BYVAL DWORD _                      ' __in HWND hwnd
 , BYVAL x AS LONG _                  ' __in x
 , BYVAL y AS LONG _                  ' __in y
 ) AS LONG                            ' BOOL

' ... but it should be
'DECLARE FUNCTION DragDetect LIB "USER32.DLL" ALIAS "DragDetect" ( _
'   BYVAL DWORD _                      ' __in HWND hwnd
' , BYVAL POINTAPI _                   ' __in POINT pt
' ) AS LONG                            ' BOOL


'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION DrawIcon LIB "USER32.DLL" ALIAS "DrawIcon" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL DWORD _                       ' __in HICON hIcon
 ) AS LONG                             ' BOOL

'#IF NOT %DEF(%NODRAWTEXT) ' ---------------------------------------------------
'#ifndef NODRAWTEXT

'/*
' * DrawText() Format Flags
' */
%DT_TOP                  = &H00000000???
%DT_LEFT                 = &H00000000???
%DT_CENTER               = &H00000001???
%DT_RIGHT                = &H00000002???
%DT_VCENTER              = &H00000004???
%DT_BOTTOM               = &H00000008???
%DT_WORDBREAK            = &H00000010???
%DT_SINGLELINE           = &H00000020???
%DT_EXPANDTABS           = &H00000040???
%DT_TABSTOP              = &H00000080???
%DT_NOCLIP               = &H00000100???
%DT_EXTERNALLEADING      = &H00000200???
%DT_CALCRECT             = &H00000400???
%DT_NOPREFIX             = &H00000800???
%DT_INTERNAL             = &H00001000???

'#if(WINVER >= 0x0400)
%DT_EDITCONTROL          = &H00002000???
%DT_PATH_ELLIPSIS        = &H00004000???
%DT_END_ELLIPSIS         = &H00008000???
%DT_MODIFYSTRING         = &H00010000???
%DT_RTLREADING           = &H00020000???
%DT_WORD_ELLIPSIS        = &H00040000???
'#if(WINVER >= 0x0500)
%DT_NOFULLWIDTHCHARBREAK = &H00080000???
'#if(_WIN32_WINNT >= 0x0500)
%DT_HIDEPREFIX           = &H00100000???
%DT_PREFIXONLY           = &H00200000???
'#endif /* _WIN32_WINNT >= 0x0500 */
'#endif /* WINVER >= 0x0500 */

TYPE DRAWTEXTPARAMS
   cbSize        AS DWORD   ' UINT    cbSize
   iTabLength    AS LONG    ' int     iTabLength
   iLeftMargin   AS LONG    ' int     iLeftMargin
   iRightMargin  AS LONG    ' int     iRightMargin
   uiLengthDrawn AS DWORD   ' UINT    uiLengthDrawn
END TYPE

'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION DrawText LIB "USER32.DLL" ALIAS "DrawTextA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __inout_ecount(cchText) LPCSTR lpchText
 , BYVAL LONG _                        ' __in int cchText
 , BYREF RECT _                        ' __inout LPRECT lprc
 , BYVAL DWORD _                       ' __in UINT format
 ) AS LONG                             ' int

DECLARE FUNCTION DrawTextW LIB "USER32.DLL" ALIAS "DrawTextW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __inout_ecount(cchText) LPCWSTR lpchText
 , BYVAL LONG _                        ' __in int cchText
 , BYREF RECT _                        ' __inout LPRECT lprc
 , BYVAL DWORD _                       ' __in UINT format
 ) AS LONG                             ' int

'#if(WINVER >= 0x0400)

DECLARE FUNCTION DrawTextEx LIB "USER32.DLL" ALIAS "DrawTextExA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __inout_ecount(cchText) LPSTR lpchText
 , BYVAL LONG _                        ' __in int cchText
 , BYREF RECT _                        ' __inout LPRECT lprc
 , BYVAL DWORD _                       ' __in UINT format
 , BYREF DRAWTEXTPARAMS _              ' __in_opt LPDRAWTEXTPARAMS lpdtp
 ) AS LONG                             ' int

DECLARE FUNCTION DrawTextExW LIB "USER32.DLL" ALIAS "DrawTextExW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __inout_ecount(cchText) LPWSTR lpchText
 , BYVAL LONG _                        ' __in int cchText
 , BYREF RECT _                        ' __inout LPRECT lprc
 , BYVAL DWORD _                       ' __in UINT format
 , BYREF DRAWTEXTPARAMS _              ' __in_opt LPDRAWTEXTPARAMS lpdtp
 ) AS LONG                             ' int

'#endif /* !NODRAWTEXT */
'#ENDIF   ' #IF NOT %DEF(%NODRAWTEXT) ' ----------------------------------------

DECLARE FUNCTION GrayString LIB "USER32.DLL" ALIAS "GrayStringA" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 , BYVAL DWORD _                       ' __in_opt HBRUSH hBrush
 , BYVAL DWORD _                       ' __in_opt GRAYSTRINGPROC lpOutputFunc
 , BYVAL LONG _                        ' __in LPARAM lpData
 , BYVAL LONG _                        ' __in int nCount
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG  _                       ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GrayStringW LIB "USER32.DLL" ALIAS "GrayStringW" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 , BYVAL DWORD _                       ' __in_opt HBRUSH hBrush
 , BYVAL DWORD _                       ' __in_opt GRAYSTRINGPROC lpOutputFunc
 , BYVAL LONG _                        ' __in LPARAM lpData
 , BYVAL LONG _                        ' __in int nCount
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0400)
'/* Monolithic state-drawing routine */
'/* Image type */
%DST_COMPLEX    = &H0000???
%DST_TEXT       = &H0001???
%DST_PREFIXTEXT = &H0002???
%DST_ICON       = &H0003???
%DST_BITMAP     = &H0004???

'/* State type */
%DSS_NORMAL     = &H0000???
%DSS_UNION      = &H0010???  ' Gray string appearance
%DSS_DISABLED   = &H0020???
%DSS_MONO       = &H0080???
'#if(_WIN32_WINNT >= 0x0500)
%DSS_HIDEPREFIX = &H0200???
%DSS_PREFIXONLY = &H0400???
'#endif /* _WIN32_WINNT >= 0x0500 */
%DSS_RIGHT      = &H8000???

DECLARE FUNCTION DrawState LIB "USER32.DLL" ALIAS "DrawStateA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_opt HBRUSH hbrFore
 , BYVAL DWORD _                       ' __in_opt DRAWSTATEPROC qfnCallBack
 , BYVAL LONG _                        ' __in LPARAM lData
 , BYVAL DWORD _                       ' __in WPARAM wData
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DrawStateW LIB "USER32.DLL" ALIAS "DrawStateW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_opt HBRUSH hbrFore
 , BYVAL DWORD _                       ' __in_opt DRAWSTATEPROC qfnCallBack
 , BYVAL LONG _                        ' __in LPARAM lData
 , BYVAL DWORD _                       ' __in WPARAM wData
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 , BYVAL DWORD _                       ' __in UINT uFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION TabbedTextOut LIB "USER32.DLL" ALIAS "TabbedTextOutA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYREF ASCIIZ _                      ' __in_ecount(chCount) LPCSTR lpString
 , BYVAL LONG _                        ' __in int chCount
 , BYVAL LONG _                        ' __in int nTabPositions
 , BYREF LONG _                        ' __in_ecount_opt(nTabPositions) CONST INT *lpnTabStopPositions
 , BYVAL LONG _                        ' __in int nTabOrigin
 ) AS LONG                             ' long

DECLARE FUNCTION TabbedTextOutW LIB "USER32.DLL" ALIAS "TabbedTextOutW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int x
 , BYVAL LONG _                        ' __in int y
 , BYVAL DWORD _                       ' __in_ecount(chCount) LPCWSTR lpString
 , BYVAL LONG _                        ' __in int chCount
 , BYVAL LONG _                        ' __in int nTabPositions
 , BYREF LONG _                        ' __in_ecount_opt(nTabPositions) CONST INT *lpnTabStopPositions
 , BYVAL LONG _                        ' __in int nTabOrigin
 ) AS LONG                             ' long

DECLARE FUNCTION GetTabbedTextExtent LIB "USER32.DLL" ALIAS "GetTabbedTextExtentA" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYREF ASCIIZ _                      ' __in_ecount(chCount) LPCSTR lpString
 , BYVAL LONG _                        ' __in int chCount
 , BYVAL LONG _                        ' __in int nTabPositions
 , BYREF LONG _                        ' __in_ecount_opt(nTabPositions) CONST INT *lpnTabStopPositions
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetTabbedTextExtentW LIB "USER32.DLL" ALIAS "GetTabbedTextExtentW" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL DWORD _                       ' __in_ecount(chCount) LPCWSTR lpString
 , BYVAL LONG _                        ' __in int chCount
 , BYVAL LONG _                        ' __in int nTabPositions
 , BYREF LONG _                        ' __in_ecount_opt(nTabPositions) CONST INT *lpnTabStopPositions
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetActiveWindow LIB "USER32.DLL" ALIAS "SetActiveWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetForegroundWindow LIB "USER32.DLL" ALIAS "GetForegroundWindow" ( _
 ) AS DWORD                            ' HWND

'#if(WINVER >= 0x0400)

DECLARE FUNCTION PaintDesktop LIB "USER32.DLL" ALIAS "PaintDesktop" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 ) AS LONG                             ' BOOL

' Although you can access this function by using LoadLibrary and GetProcAddress
' combined in Microsoft Windows versions prior to Windows XP, the function is
' not accessible using the standard Include file and library linkage. The header
' files included in Windows XP Service Pack 1 (SP1) and Windows Server 2003
' document this function and make it accessible using the appropriate Include
' file and library linkage. However, this function is deprecated and not intended
' for general use. It is recommended that you do not use it in new programs
' because it might be altered or unavailable in subsequent versions of Windows.

DECLARE SUB SwitchToThisWindow LIB "USER32.DLL" ALIAS "SwitchToThisWindow" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL LONG _                        ' __in BOOL fUnknown
 )                                     ' VOID

'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION AllowSetForegroundWindow LIB "USER32.DLL" ALIAS "AllowSetForegroundWindow" ( _
   BYVAL DWORD _                       ' __in DWORD dwProcessId
 ) AS LONG                             ' BOOL

%ASFW_ANY = &HFFFFFFFF??? ' ((DWORD)-1)

DECLARE FUNCTION LockSetForegroundWindow LIB "USER32.DLL" ALIAS "LockSetForegroundWindow" ( _
   BYVAL DWORD _                       ' __in UINT uLockCode
 ) AS LONG                             ' BOOL

%LSFW_LOCK   = 1???
%LSFW_UNLOCK = 2???

'#endif /* _WIN32_WINNT >= 0x0500 */

DECLARE FUNCTION WindowFromDC LIB "USER32.DLL" ALIAS "WindowFromDC" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 ) AS DWORD                            ' HDC

DECLARE FUNCTION GetDCEx LIB "USER32.DLL" ALIAS "GetDCEx" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HRGN hrgnClip
 , BYVAL DWORD _                       ' __in DWORD flags
 ) AS DWORD                            ' HDC

'/*
' * GetDCEx() flags
' */
%DCX_WINDOW           = &H00000001???
%DCX_CACHE            = &H00000002???
%DCX_NORESETATTRS     = &H00000004???
%DCX_CLIPCHILDREN     = &H00000008???
%DCX_CLIPSIBLINGS     = &H00000010???
%DCX_PARENTCLIP       = &H00000020???
%DCX_EXCLUDERGN       = &H00000040???
%DCX_INTERSECTRGN     = &H00000080???
%DCX_EXCLUDEUPDATE    = &H00000100???
%DCX_INTERSECTUPDATE  = &H00000200???
%DCX_LOCKWINDOWUPDATE = &H00000400???

%DCX_VALIDATE         = &H00200000???

DECLARE FUNCTION GetWindowDC LIB "USER32.DLL" ALIAS "GetWindowDC" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 ) AS DWORD                            ' HDC

DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in HDC hDC
 ) AS LONG                             ' int

DECLARE FUNCTION BeginPaint LIB "USER32.DLL" ALIAS "BeginPaint" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF PAINTSTRUCT _                 ' __out LPPAINTSTRUCT lpPaint
 ) AS DWORD                            ' HDC

DECLARE FUNCTION EndPaint LIB "USER32.DLL" ALIAS "EndPaint" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF PAINTSTRUCT _                 ' __in CONST PAINTSTRUCT *lpPaint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetUpdateRect LIB "USER32.DLL" ALIAS "GetUpdateRect" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF RECT _                        ' __out_opt LPRECT lpRect
 , BYVAL LONG _                        ' __in BOOL bErase
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetUpdateRgn LIB "USER32.DLL" ALIAS "GetUpdateRgn" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in HRGN hRgn
 , BYVAL LONG _                        ' __in BOOL bErase
 ) AS LONG                             ' int

DECLARE FUNCTION SetWindowRgn LIB "USER32.DLL" ALIAS "SetWindowRgn" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HRGN hRgn
 , BYVAL LONG _                        ' __in BOOL bRedraw
 ) AS LONG                             ' int

DECLARE FUNCTION GetWindowRgn LIB "USER32.DLL" ALIAS "GetWindowRgn" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in HRGN hRgn
 ) AS LONG                             ' int

'#if(_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION GetWindowRgnBox LIB "USER32.DLL" ALIAS "GetWindowRgnBox" ( _
   BYVAL DWORD  _                      ' __in HWND hWnd
 , BYREF RECT _                        ' __out LPRECT lprc
 ) AS LONG                             ' int

'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION ExcludeUpdateRgn LIB "USER32.DLL" ALIAS "ExcludeUpdateRgn" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 , BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' int

DECLARE FUNCTION InvalidateRect LIB "USER32.DLL" ALIAS "InvalidateRect" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYREF RECT _                        ' __in_opt CONST RECT *lpRect
 , BYVAL LONG _                        ' __in BOOL bErase
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ValidateRect LIB "USER32.DLL" ALIAS "ValidateRect" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYREF RECT _                        ' __in_opt CONST RECT *lpRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION InvalidateRgn LIB "USER32.DLL" ALIAS "InvalidateRgn" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HRGN hRgn
 , BYVAL LONG _                        ' __in BOOL bErase
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ValidateRgn LIB "USER32.DLL" ALIAS "ValidateRgn" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HRGN hRgn
 ) AS LONG                             ' BOOL

DECLARE FUNCTION RedrawWindow LIB "USER32.DLL" ALIAS "RedrawWindow" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYREF RECT _                        ' __in_opt CONST RECT *lprcUpdate
 , BYVAL DWORD _                       ' __in_opt HRGN hrgnUpdate
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS LONG                             ' BOOL

'/*
' * RedrawWindow() flags
' */
%RDW_INVALIDATE      = &H0001???
%RDW_INTERNALPAINT   = &H0002???
%RDW_ERASE           = &H0004???

%RDW_VALIDATE        = &H0008???
%RDW_NOINTERNALPAINT = &H0010???
%RDW_NOERASE         = &H0020???

%RDW_NOCHILDREN      = &H0040???
%RDW_ALLCHILDREN     = &H0080???

%RDW_UPDATENOW       = &H0100???
%RDW_ERASENOW        = &H0200???

%RDW_FRAME           = &H0400???
%RDW_NOFRAME         = &H0800???


'/*
' * LockWindowUpdate API
' */

DECLARE FUNCTION LockWindowUpdate LIB "USER32.DLL" ALIAS "LockWindowUpdate" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWndLock
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ScrollWindow LIB "USER32.DLL" ALIAS "ScrollWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int XAmount
 , BYVAL LONG _                        ' __in int YAmount
 , BYREF RECT _                        ' __in_opt CONST RECT *lpRect
 , BYREF RECT _                        ' __in_opt CONST RECT *lpClipRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ScrollDC LIB "USER32.DLL" ALIAS "ScrollDC" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 , BYVAL LONG _                        ' __in int dx
 , BYVAL LONG _                        ' __in int dy
 , BYREF RECT _                        ' __in_opt CONST RECT *lprcScroll
 , BYREF RECT _                        ' __in_opt CONST RECT *lprcClip
 , BYVAL DWORD _                       ' __in_opt HRGN hrgnUpdate
 , BYREF RECT _                        ' __out_opt LPRECT lprcUpdate
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ScrollWindowEx LIB "USER32.DLL" ALIAS "ScrollWindowEx" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int dx
 , BYVAL LONG _                        ' __in int dy
 , BYREF RECT _                        ' __in_opt CONST RECT *prcScroll
 , BYREF RECT _                        ' __in_opt CONST RECT *prcClip
 , BYVAL DWORD _                       ' __in_opt HRGN hrgnUpdate
 , BYREF RECT _                        ' __out_opt LPRECT prcUpdate
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS LONG                             ' int

%SW_SCROLLCHILDREN = &H0001???   ' /* Scroll children within *lprcScroll. */
%SW_INVALIDATE     = &H0002???   ' /* Invalidate after scrolling */
%SW_ERASE          = &H0004???   ' /* If SW_INVALIDATE, don't send WM_ERASEBACKGROUND */
'#if(WINVER >= 0x0500)
%SW_SMOOTHSCROLL   = &H0010???   ' /* Use smooth scrolling */
'#endif /* WINVER >= 0x0500 */

'#IF NOT %DEF(%NOSCROLL) ' -----------------------------------------------------
'#ifndef NOSCROLL

DECLARE FUNCTION SetScrollPos LIB "USER32.DLL" ALIAS "SetScrollPos" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nBar
 , BYVAL LONG _                        ' __in int nPos
 , BYVAL LONG _                        ' __in BOOL bRedraw
 ) AS LONG                             ' int

DECLARE FUNCTION GetScrollPos LIB "USER32.DLL" ALIAS "GetScrollPos" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nBar
 ) AS LONG                             ' int

DECLARE FUNCTION SetScrollRange LIB "USER32.DLL" ALIAS "SetScrollRange" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nBar
 , BYVAL LONG _                        ' __in int nMinPos
 , BYVAL LONG _                        ' __in int nMaxPos
 , BYVAL LONG _                        ' __in BOOL bRedraw
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetScrollRange LIB "USER32.DLL" ALIAS "GetScrollRange" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nBar
 , BYREF LONG _                        ' __out LPINT lpMinPos
 , BYREF LONG _                        ' __out LPINT lpMaxPos
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ShowScrollBar LIB "USER32.DLL" ALIAS "ShowScrollBar" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int wBar
 , BYVAL LONG _                        ' __in BOOL bShow
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnableScrollBar LIB "USER32.DLL" ALIAS "EnableScrollBar" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT wSBflags
 , BYVAL DWORD _                       ' __in UINT wArrows
 ) AS LONG                             ' BOOL

'/*
' * EnableScrollBar() flags
' */
%ESB_ENABLE_BOTH   = &H0000???
%ESB_DISABLE_BOTH  = &H0003???

%ESB_DISABLE_LEFT  = &H0001???
%ESB_DISABLE_RIGHT = &H0002???

%ESB_DISABLE_UP    = &H0001???
%ESB_DISABLE_DOWN  = &H0002???

%ESB_DISABLE_LTUP  = %ESB_DISABLE_LEFT
%ESB_DISABLE_RTDN  = %ESB_DISABLE_RIGHT

'#endif  /* !NOSCROLL */
'#ENDIF   ' #IF NOT %DEF(%NOSCROLL) ' ------------------------------------------

DECLARE FUNCTION SetProp LIB "USER32.DLL" ALIAS "SetPropA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF ASCIIZ _                      ' __in LPCSTR lpString
 , BYVAL DWORD _                       ' __in_opt HANDLE hData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetPropW LIB "USER32.DLL" ALIAS "SetPropW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in LPCWSTR lpString
 , BYVAL DWORD _                       ' __in_opt HANDLE hData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetProp LIB "USER32.DLL" ALIAS "GetPropA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF ASCIIZ _                      ' __in LPCSTR lpString
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION GetPropW LIB "USER32.DLL" ALIAS "GetPropW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in LPCWSTR lpString
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION RemoveProp LIB "USER32.DLL" ALIAS "RemovePropA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF ASCIIZ _                      ' __in LPCSTR lpString
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION RemovePropW LIB "USER32.DLL" ALIAS "RemovePropW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in LPCWSTR lpString
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION EnumPropsEx LIB "USER32.DLL" ALIAS "EnumPropsExA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in PROPENUMPROCEXA lpEnumFunc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' int

DECLARE FUNCTION EnumPropsExW LIB "USER32.DLL" ALIAS "EnumPropsExW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in PROPENUMPROCEXW lpEnumFunc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' int

DECLARE FUNCTION EnumProps LIB "USER32.DLL" ALIAS "EnumPropsA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in PROPENUMPROCA lpEnumFunc
 ) AS LONG                             ' int

DECLARE FUNCTION EnumPropsW LIB "USER32.DLL" ALIAS "EnumPropsW" ( _
   BYVAL DWORD _                       ' __in HWND hWn
 , BYVAL DWORD _                       ' __in PROPENUMPROCW lpEnumFunc
 ) AS LONG                             ' int

DECLARE FUNCTION SetWindowText LIB "USER32.DLL" ALIAS "SetWindowTextA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpString
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetWindowTextW LIB "USER32.DLL" ALIAS "SetWindowTextW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpString
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF ASCIIZ _                      ' __out_ecount(nMaxCount) LPSTR lpString
 , BYVAL LONG _                        ' __in int nMaxCount
 ) AS LONG                             ' int

DECLARE FUNCTION GetWindowTextW LIB "USER32.DLL" ALIAS "GetWindowTextW" ( _
   BYVAL DWORD   _                     ' __in HWND hWnd
 , BYVAL DWORD _                       ' __out_ecount(nMaxCount) LPWSTR lpString
 , BYVAL LONG _                        ' __in int nMaxCount
 ) AS LONG                             ' int

DECLARE FUNCTION GetWindowTextLength LIB "USER32.DLL" ALIAS "GetWindowTextLengthA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' int

DECLARE FUNCTION GetWindowTextLengthW LIB "USER32.DLL" ALIAS "GetWindowTextLengthW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS LONG                             ' int

DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF RECT _                        ' __out LPRECT lpRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF RECT _                        ' __out LPRECT lpRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AdjustWindowRect LIB "USER32.DLL" ALIAS "AdjustWindowRect" ( _
   BYREF RECT _                        ' __inout LPRECT lpRect
 , BYVAL DWORD _                       ' __in DWORD dwStyle
 , BYVAL LONG _                        ' __in BOOL bMenu
 ) AS LONG                             ' BOOL

DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" ( _
   BYREF RECT _                        ' __inout LPRECT lpRect
 , BYVAL DWORD _                       ' __in DWORD dwStyle
 , BYVAL LONG _                        ' __in BOOL bMenu
 , BYVAL DWORD _                       ' __in DWORD dwExStyle
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0400)
%HELPINFO_WINDOW   = &H0001&
%HELPINFO_MENUITEM = &H0002&

TYPE HELPINFO
   cbSize       AS DWORD      ' UINT      cbSize        /* Size in bytes of this struct  */
   iContextType AS LONG       ' int       iContextType  /* Either HELPINFO_WINDOW or HELPINFO_MENUITEM */
   iCtrlId      AS LONG       ' int       iCtrlId       /* Control Id or a Menu item Id. */
   hItemHandle  AS DWORD      ' HANDLE    hItemHandle   /* hWnd of control or hMenu.     */
   dwContextId  AS DWORD      ' DWORD_PTR dwContextId   /* Context Id associated with this item */
   MousePos     AS POINTAPI   ' POINT     MousePos      /* Mouse Position in screen co-ordinates */
END TYPE

DECLARE FUNCTION SetWindowContextHelpId LIB "USER32.DLL" ALIAS "SetWindowContextHelpId" ( _
   BYVAL DWORD  _                      ' __in HWND
 , BYVAL DWORD _                       ' __in DWORD
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetWindowContextHelpId LIB "USER32.DLL" ALIAS "GetWindowContextHelpId" ( _
   BYVAL DWORD _                       ' __in HWND
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetMenuContextHelpId LIB "USER32.DLL" ALIAS "SetMenuContextHelpId" ( _
   BYVAL DWORD _                       ' __in HMENU
 , BYVAL DWORD _                       ' __in DWORD
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMenuContextHelpId LIB "USER32.DLL" ALIAS "GetMenuContextHelpId" ( _
   BYVAL DWORD _                       ' __in HMENU
 ) AS DWORD                            ' DWORD

'#endif /* WINVER >= 0x0400 */


'#IF NOT %DEF(%NOMB) ' ---------------------------------------------------------
'#ifndef NOMB

'/*
' * MessageBox() Flags
' */
%MB_OK                        = &H00000000???
%MB_OKCANCEL                  = &H00000001???
%MB_ABORTRETRYIGNORE          = &H00000002???
%MB_YESNOCANCEL               = &H00000003???
%MB_YESNO                     = &H00000004???
%MB_RETRYCANCEL               = &H00000005???
'#if(WINVER >= 0x0500)
%MB_CANCELTRYCONTINUE         = &H00000006???
'#endif /* WINVER >= 0x0500 */

%MB_ICONHAND                  = &H00000010???
%MB_ICONQUESTION              = &H00000020???
%MB_ICONEXCLAMATION           = &H00000030???
%MB_ICONASTERISK              = &H00000040???

'#if(WINVER >= 0x0400)
%MB_USERICON                  = &H00000080???
%MB_ICONWARNING               = %MB_ICONEXCLAMATION
%MB_ICONERROR                 = %MB_ICONHAND
'#endif /* WINVER >= 0x0400 */

%MB_ICONINFORMATION           = %MB_ICONASTERISK
%MB_ICONSTOP                  = %MB_ICONHAND

%MB_DEFBUTTON1                = &H00000000???
%MB_DEFBUTTON2                = &H00000100???
%MB_DEFBUTTON3                = &H00000200???
'#if(WINVER >= 0x0400)
%MB_DEFBUTTON4                = &H00000300???
'#endif /* WINVER >= 0x0400 */

%MB_APPLMODAL                 = &H00000000???
%MB_SYSTEMMODAL               = &H00001000???
%MB_TASKMODAL                 = &H00002000???
'#if(WINVER >= 0x0400)
%MB_HELP                      = &H00004000???  ' Help Button
'#endif /* WINVER >= 0x0400 */

%MB_NOFOCUS                   = &H00008000???
%MB_SETFOREGROUND             = &H00010000???
%MB_DEFAULT_DESKTOP_ONLY      = &H00020000???

%MB_TOPMOST                   = &H00040000???
%MB_RIGHT                     = &H00080000???
%MB_RTLREADING                = &H00100000???

'#endif /* WINVER >= 0x0400 */

'#ifdef _WIN32_WINNT
'#if (_WIN32_WINNT >= 0x0400)
'#define MB_SERVICE_NOTIFICATION          0x00200000L
'#else
'#define MB_SERVICE_NOTIFICATION          0x00040000L
'#endif
'#define MB_SERVICE_NOTIFICATION_NT3X     0x00040000L
'#endif

%MB_SERVICE_NOTIFICATION      = &H00200000???
%MB_SERVICE_NOTIFICATION_NT3X = &H00040000???

%MB_TYPEMASK                  = &H0000000F???
%MB_ICONMASK                  = &H000000F0???
%MB_DEFMASK                   = &H00000F00???
%MB_MODEMASK                  = &H00003000???
%MB_MISCMASK                  = &H0000C000???

DECLARE FUNCTION MessageBox LIB "USER32.DLL" ALIAS "MessageBoxA" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpText
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpCaption
 , BYVAL DWORD _                       ' __in UINT uType
 ) AS LONG                             ' int

DECLARE FUNCTION MessageBoxW LIB "USER32.DLL" ALIAS "MessageBoxW" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpText
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpCaption
 , BYVAL DWORD _                       ' __in UINT uType
 ) AS LONG                             ' int

DECLARE FUNCTION MessageBoxEx LIB "USER32.DLL" ALIAS "MessageBoxExA" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpText
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpCaption
 , BYVAL DWORD _                       ' __in UINT uType
 , BYVAL DWORD _                       ' __in WORD wLanguageId
 ) AS LONG                             ' int

DECLARE FUNCTION MessageBoxExW LIB "USER32.DLL" ALIAS "MessageBoxExW" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpText
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpCaption
 , BYVAL DWORD _                       ' __in UINT uType
 , BYVAL DWORD _                       ' __in WORD wLanguageId
 ) AS LONG                             ' int

'#if(WINVER >= 0x0400)

'typedef VOID (CALLBACK *MSGBOXCALLBACK)(LPHELPINFO lpHelpInfo);

TYPE MSGBOXPARAMSA
   cbSize             AS DWORD        ' UINT           cbSize
   hWndOwner          AS DWORD        ' HWND           hwndOwner
   hInstance          AS DWORD        ' HINSTANCE      hInstance
   lpszText           AS ASCIIZ PTR   ' LPCSTR         lpszText
   lpszCaption        AS ASCIIZ PTR   ' LPCSTR         lpszCaption
   dwStyle            AS DWORD        ' DWORD          dwStyle
   lpszIcon           AS ASCIIZ PTR   ' LPCSTR         lpszIcon
   dwContextHelpId    AS DWORD        ' DWORD_PTR      dwContextHelpId
   lpfnMsgBoxCallback AS LONG         ' MSGBOXCALLBACK lpfnMsgBoxCallback
   dwLanguageId       AS DWORD        ' DWORD          dwLanguageId
END TYPE

TYPE MSGBOXPARAMSW
   cbSize             AS DWORD        ' UINT           cbSize
   hWndOwner          AS DWORD        ' HWND           hwndOwner
   hInstance          AS DWORD        ' HINSTANCE      hInstance
   lpszText           AS WORD PTR     ' LPCWSTR        lpszText
   lpszCaption        AS WORD PTR     ' LPCWSTR        lpszCaption
   dwStyle            AS DWORD        ' DWORD          dwStyle
   lpszIcon           AS DWORD        ' LPCWSTR        lpszIcon
   dwContextHelpId    AS DWORD        ' DWORD_PTR      dwContextHelpId
   lpfnMsgBoxCallback AS LONG         ' MSGBOXCALLBACK lpfnMsgBoxCallback
   dwLanguageId       AS DWORD        ' DWORD          dwLanguageId
END TYPE

MACRO MSGBOXPARAMS  = MSGBOXPARAMSA

DECLARE FUNCTION MessageBoxIndirect LIB "USER32.DLL" ALIAS "MessageBoxIndirectA" ( _
   BYREF MSGBOXPARAMSA _               ' __in CONST MSGBOXPARAMSA * lpmbp
 ) AS LONG                             ' int

DECLARE FUNCTION MessageBoxIndirectW LIB "USER32.DLL" ALIAS "MessageBoxIndirectW" ( _
   BYREF MSGBOXPARAMSW _               ' __in CONST MSGBOXPARAMSW * lpmbp
 ) AS LONG                             ' int

DECLARE FUNCTION MessageBeep LIB "USER32.DLL" ALIAS "MessageBeep" ( _
   BYVAL DWORD _                       ' __in UINT uType
 ) AS LONG                             ' BOOL

'#endif /* !NOMB */
'#ENDIF   ' #IF NOT %DEF(%NOMB) ' ----------------------------------------------

DECLARE FUNCTION ShowCursor LIB "USER32.DLL" ALIAS "ShowCursor" ( _
   BYVAL LONG _                        ' __in BOOL bShow
 ) AS LONG                             ' int

DECLARE FUNCTION SetCursorPos LIB "USER32.DLL" ALIAS "SetCursorPos" ( _
   BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetPhysicalCursorPos LIB "USER32.DLL" ALIAS "SetPhysicalCursorPos" ( _
   BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCursor LIB "USER32.DLL" ALIAS "SetCursor" ( _
   BYVAL DWORD _                       ' __in_opt HCURSOR hCursor
 ) AS DWORD                            ' HCURSOR

DECLARE FUNCTION GetCursorPos LIB "USER32.DLL" ALIAS "GetCursorPos" ( _
   BYREF POINTAPI _                    ' __out LPPOINT lpPoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetPhysicalCursorPos LIB "USER32.DLL" ALIAS "GetPhysicalCursorPos" ( _
   BYREF POINTAPI _                    ' __out LPPOINT lpPoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ClipCursor LIB "USER32.DLL" ALIAS "ClipCursor" ( _
   BYREF RECT _                        ' __in_opt CONST RECT *lpRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetClipCursor LIB "USER32.DLL" ALIAS "GetClipCursor" ( _
   BYREF RECT _                        ' __out LPRECT lpRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCursor LIB "USER32.DLL" ALIAS "GetCursor" ( _
 ) AS DWORD                            ' HCURSOR

DECLARE FUNCTION CreateCaret LIB "USER32.DLL" ALIAS "CreateCaret" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HBITMAP hBitmap
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCaretBlinkTime LIB "USER32.DLL" ALIAS "GetCaretBlinkTime" ( _
 ) AS DWORD                            ' UINT

DECLARE FUNCTION SetCaretBlinkTime LIB "USER32.DLL" ALIAS "SetCaretBlinkTime" ( _
   BYVAL DWORD _                       ' __in UINT uMSeconds
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DestroyCaret LIB "USER32.DLL" ALIAS "DestroyCaret" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION HideCaret LIB "USER32.DLL" ALIAS "HideCaret" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ShowCaret LIB "USER32.DLL" ALIAS "ShowCaret" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetCaretPos LIB "USER32.DLL" ALIAS "SetCaretPos" ( _
   BYVAL LONG  _                       ' __in int X
 , BYVAL LONG _                        ' __in int Y
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetCaretPos LIB "USER32.DLL" ALIAS "GetCaretPos" ( _
   BYREF POINTAPI _                    ' __out LPPOINT lpPoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ClientToScreen LIB "USER32.DLL" ALIAS "ClientToScreen" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF POINTAPI _                    ' __inout LPPOINT lpPoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ScreenToClient LIB "USER32.DLL" ALIAS "ScreenToClient" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF POINTAPI _                    ' __inout LPPOINT lpPoint
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0600)
DECLARE FUNCTION LogicalToPhysicalPoint LIB "USER32.DLL" ALIAS "LogicalToPhysicalPoint" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF POINTAPI _                    ' __inout LPPOINT lpPoint
 ) AS LONG                             ' BOOL

DECLARE FUNCTION PhysicalToLogicalPoint LIB "USER32.DLL" ALIAS "PhysicalToLogicalPoint" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF POINTAPI _                    ' __inout LPPOINT lpPoint
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0600 */

DECLARE FUNCTION MapWindowPoints LIB "USER32.DLL" ALIAS "MapWindowPoints" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWndFrom
 , BYVAL DWORD _                       ' __in_opt HWND hWndTo
 , BYREF ANY _                         ' __inout_ecount(cPoints) LPPOINT lpPoints
 , BYVAL DWORD _                       ' __in UINT cPoints
 ) AS LONG                             ' int

' Uses x, y for compatibility with PB's include file...
DECLARE FUNCTION WindowFromPoint LIB "USER32.DLL" ALIAS "WindowFromPoint" ( _
   BYVAL LONG _                     ' __in x
 , BYVAL LONG _                     ' __in y
 ) AS DWORD                         ' HWND

' ... but it should be
'DECLARE FUNCTION WindowFromPoint LIB "USER32.DLL" ALIAS "WindowFromPoint" ( _
'   BYVAL POINTAPI _                 ' __in POINT Point
' ) AS DWORD                         ' HWND

'#if(WINVER >= 0x0600)
DECLARE FUNCTION WindowFromPhysicalPoint LIB "USER32.DLL" ALIAS "WindowFromPhysicalPoint" ( _
   BYVAL POINTAPI _                 ' __in POINT Point
 ) AS DWORD                         ' HWND
'#endif /* WINVER >= 0x0600 */

' Uses x, y for compatibility with PB's include file...
DECLARE FUNCTION ChildWindowFromPoint LIB "USER32.DLL" ALIAS "ChildWindowFromPoint" ( _
   BYVAL DWORD _                    ' __in HWND hWndParent
 , BYVAL LONG _                     ' __in x
 , BYVAL LONG _                     ' __in y
 ) AS DWORD                         ' HWND

' ... but it should be
'DECLARE FUNCTION ChildWindowFromPoint LIB "USER32.DLL" ALIAS "ChildWindowFromPoint" ( _
'   BYVAL DWORD _                    ' __in HWND hWndParent
' , BYVAL POINTAPI _                 ' __in POINT Point
' ) AS DWORD                         ' HWND

'#if(WINVER >= 0x0400)
%CWP_ALL             = &H0000???
%CWP_SKIPINVISIBLE   = &H0001???
%CWP_SKIPDISABLED    = &H0002???
%CWP_SKIPTRANSPARENT = &H0004???

' For consistency with ChildWindowFromPoint...
DECLARE FUNCTION ChildWindowFromPointEx LIB "USER32.DLL" ALIAS "ChildWindowFromPointEx" ( _
   BYVAL DWORD _                    ' __in HWND hwnd
 , BYVAL LONG _                     ' __in x
 , BYVAL LONG _                     ' __in y
 , BYVAL DWORD _                    ' __in UINT flags
 ) AS DWORD                         ' HWND

' ... but it should be
'DECLARE FUNCTION ChildWindowFromPointEx LIB "USER32.DLL" ALIAS "ChildWindowFromPointEx" ( _
'   BYVAL DWORD _                    ' __in HWND hwnd
' , BYVAL POINTAPI _                 ' __in POINT pt
' , BYVAL DWORD _                    ' __in UINT flags
' ) AS DWORD                         ' HWND

'#endif /* WINVER >= 0x0400 */

'#IF NOT %DEF(%NOCOLOR) ' ------------------------------------------------------
'#ifndef NOCOLOR

'/*
' * Color Types
' */
%CTLCOLOR_MSGBOX               = 0&
%CTLCOLOR_EDIT                 = 1&
%CTLCOLOR_LISTBOX              = 2&
%CTLCOLOR_BTN                  = 3&
%CTLCOLOR_DLG                  = 4&
%CTLCOLOR_SCROLLBAR            = 5&
%CTLCOLOR_STATIC               = 6&
%CTLCOLOR_MAX                  = 7&

%COLOR_SCROLLBAR               = 0&
%COLOR_BACKGROUND              = 1&
%COLOR_ACTIVECAPTION           = 2&
%COLOR_INACTIVECAPTION         = 3&
%COLOR_MENU                    = 4&
%COLOR_MSGBOX                  = 4&
%COLOR_WINDOW                  = 5&
%COLOR_WINDOWFRAME             = 6&
%COLOR_MENUTEXT                = 7&
%COLOR_MSGBOXTEXT              = 7&
%COLOR_WINDOWTEXT              = 8&
%COLOR_CAPTIONTEXT             = 9&
%COLOR_ACTIVEBORDER            = 10&
%COLOR_INACTIVEBORDER          = 11&
%COLOR_APPWORKSPACE            = 12&
%COLOR_HIGHLIGHT               = 13&
%COLOR_HIGHLIGHTTEXT           = 14&
%COLOR_BTNFACE                 = 15&
%COLOR_BTNSHADOW               = 16&
%COLOR_GRAYTEXT                = 17&
%COLOR_BTNTEXT                 = 18&
%COLOR_INACTIVECAPTIONTEXT     = 19&
%COLOR_BTNHIGHLIGHT            = 20&

'#if(WINVER >= 0x0400)
%COLOR_3DDKSHADOW              = 21&
%COLOR_3DLIGHT                 = 22&
%COLOR_INFOTEXT                = 23&
%COLOR_INFOBK                  = 24&
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
%COLOR_HOTLIGHT                = 26&
%COLOR_GRADIENTACTIVECAPTION   = 27&
%COLOR_GRADIENTINACTIVECAPTION = 28&
'#if(WINVER >= 0x0501)
%COLOR_MENUHILIGHT             = 29&
%COLOR_MENUBAR                 = 30&
'#endif /* WINVER >= 0x0501 */
'#endif /* WINVER >= 0x0500 */

'#if(WINVER >= 0x0400)
%COLOR_DESKTOP             = %COLOR_BACKGROUND
%COLOR_3DFACE              = %COLOR_BTNFACE
%COLOR_3DSHADOW            = %COLOR_BTNSHADOW
%COLOR_3DHIGHLIGHT         = %COLOR_BTNHIGHLIGHT
%COLOR_3DHILIGHT           = %COLOR_BTNHIGHLIGHT
%COLOR_BTNHILIGHT          = %COLOR_BTNHIGHLIGHT
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION GetSysColor LIB "USER32.DLL" ALIAS "GetSysColor" ( _
   BYVAL LONG _                        ' __in int nIndex
 ) AS DWORD                            ' DWORD

'#if(WINVER >= 0x0400)
DECLARE FUNCTION GetSysColorBrush LIB "USER32.DLL" ALIAS "GetSysColorBrush" ( _
   BYVAL LONG _                        ' __in int nIndex
 ) AS DWORD                            ' HBRUSH
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION SetSysColors LIB "USER32.DLL" ALIAS "SetSysColors" ( _
   BYVAL LONG _                        ' __in int cElements
 , BYREF LONG _                        ' __in_ecount(cElements) CONST INT * lpaElements
 , BYREF LONG _                        ' __in_ecount(cElements) CONST COLORREF * lpaRgbValues
 ) AS LONG                             ' BOOL

'#endif /* !NOCOLOR */
'#ENDIF   ' #IF NOT %DEF(%NOCOLOR) ' -------------------------------------------

DECLARE FUNCTION DrawFocusRect LIB "USER32.DLL" ALIAS "DrawFocusRect" ( _
   BYVAL DWORD  _                      ' __in HDC hDC
 , BYREF RECT _                        ' __in CONST RECT * lprc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FillRect LIB "USER32.DLL" ALIAS "FillRect" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 , BYREF RECT _                        ' __in CONST RECT *lprc
 , BYVAL DWORD _                       ' __in HBRUSH hbr
 ) AS LONG                             ' int

DECLARE FUNCTION FrameRect LIB "USER32.DLL" ALIAS "FrameRect" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 , BYREF RECT _                        ' __in CONST RECT *lprc
 , BYVAL DWORD _                       ' __in HBRUSH hbr
 ) AS LONG                             ' int

DECLARE FUNCTION InvertRect LIB "USER32.DLL" ALIAS "InvertRect" ( _
   BYVAL DWORD _                       ' __in HDC hDC
 , BYREF RECT _                        ' __in CONST RECT *lprc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" ( _
   BYREF RECT _                        ' __out LPRECT lprc
 , BYVAL LONG _                        ' __in int xLeft
 , BYVAL LONG _                        ' __in int yTop
 , BYVAL LONG _                        ' __in int xRight
 , BYVAL LONG _                        ' __in int yBottom
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetRectEmpty LIB "USER32.DLL" ALIAS "SetRectEmpty" ( _
   BYREF RECT _                        ' __out LPRECT lprc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CopyRect LIB "USER32.DLL" ALIAS "CopyRect" ( _
   BYREF RECT _                        ' __out LPRECT lprcDst
 , BYREF RECT _                        ' __in CONST RECT *lprcSrc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION InflateRect LIB "USER32.DLL" ALIAS "InflateRect" ( _
   BYREF RECT _                        ' __inout LPRECT lprc
 , BYVAL LONG _                        ' __in int dx
 , BYVAL LONG _                        ' __in int dy
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IntersectRect LIB "USER32.DLL" ALIAS "IntersectRect" ( _
   BYREF RECT _                        ' __out LPRECT lprcDst
 , BYREF RECT _                        ' __in CONST RECT *lprcSrc1
 , BYREF RECT _                        ' __in CONST RECT *lprcSrc2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION UnionRect LIB "USER32.DLL" ALIAS "UnionRect" ( _
   BYREF RECT _                        ' __out LPRECT lprcDst
 , BYREF RECT _                        ' __in CONST RECT *lprcSrc1
 , BYREF RECT _                        ' __in CONST RECT *lprcSrc2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SubtractRect LIB "USER32.DLL" ALIAS "SubtractRect" ( _
   BYREF RECT _                        ' __out LPRECT lprcDst
 , BYREF RECT _                        ' __in CONST RECT *lprcSrc1
 , BYREF RECT _                        ' __in CONST RECT *lprcSrc2
 ) AS LONG                             ' BOOL

DECLARE FUNCTION OffsetRect LIB "USER32.DLL" ALIAS "OffsetRect" ( _
   BYREF RECT _                        ' __inout LPRECT lprc
 , BYVAL LONG _                        '__in int dx
 , BYVAL LONG _                        ' __in int dy
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsRectEmpty LIB "USER32.DLL" ALIAS "IsRectEmpty" ( _
   BYREF RECT _                        ' __in CONST RECT *lprc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EqualRect LIB "USER32.DLL" ALIAS "EqualRect" ( _
   BYREF RECT _                        ' __in CONST RECT *lprc1
 , BYREF RECT _                        ' __in CONST RECT *lprc2
 ) AS LONG                             ' BOOL

' Uses x, y for compatibility with PB's include file...
DECLARE FUNCTION PtInRect LIB "USER32.DLL" ALIAS "PtInRect" ( _
   BYREF RECT _                        ' __in CONST RECT *lprc
 , BYVAL LONG _                        ' __in x
 , BYVAL LONG _                        ' __in y
 ) AS LONG                             ' BOOL

' ... but it should be
'DECLARE FUNCTION PtInRect LIB "USER32.DLL" ALIAS "PtInRect" ( _
'   BYREF RECT _                        ' __in CONST RECT *lprc
' , BYVAL POINTAPI _                    ' __in POINT pt
' ) AS LONG                             ' BOOL


'#IF NOT %DEF(%NOWINOFFSETS) ' -------------------------------------------------
'#ifndef NOWINOFFSETS

DECLARE FUNCTION GetWindowWord LIB "USER32.DLL" ALIAS "GetWindowWord" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 ) AS WORD                             ' WORD

DECLARE FUNCTION SetWindowWord LIB "USER32.DLL" ALIAS "SetWindowWord" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 , BYVAL WORD _                        ' __in WORD wNewWord
 ) AS WORD                             ' WORD

DECLARE FUNCTION GetWindowLong LIB "USER32.DLL" ALIAS "GetWindowLongA" ( _
   BYVAL DWORD  _                      ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 ) AS LONG                             ' long

DECLARE FUNCTION GetWindowLongW LIB "USER32.DLL" ALIAS "GetWindowLongW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 ) AS LONG                             ' long

DECLARE FUNCTION SetWindowLong LIB "USER32.DLL" ALIAS "SetWindowLongA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 , BYVAL LONG _                        ' __in LONG dwNewLong
 ) AS LONG                             ' long

DECLARE FUNCTION SetWindowLongW LIB "USER32.DLL" ALIAS "SetWindowLongW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 , BYVAL LONG _                        ' __in LONG dwNewLong
 ) AS LONG                             ' long

'#ifdef _WIN64

'DECLARE FUNCTION GetWindowLongPtr LIB "USER32.DLL" ALIAS "GetWindowLongPtrA" ( _
'   BYVAL DWORD _                       ' __in HWND hWnd
' , BYVAL LONG _                        ' __in int nIndex
' ) AS LONG                             ' long_PTR

'DECLARE FUNCTION GetWindowLongPtrW LIB "USER32.DLL" ALIAS "GetWindowLongPtrW" ( _
'   BYVAL DWORD _                       ' __in HWND hWnd
' , BYVAL LONG _                        ' __in int nIndex
' ) AS LONG                             ' long_PTR

'DECLARE FUNCTION SetWindowLongPtr LIB "USER32.DLL" ALIAS "SetWindowLongPtrA" ( _
'   BYVAL DWORD _                       ' __in HWND hWnd
' , BYVAL LONG _                        ' __in int nIndex
' , BYVAL LONG _                        ' __in LONG_PTR dwNewLong
' ) AS LONG                             ' LONG_PTR

'DECLARE FUNCTION SetWindowLongPtrW LIB "USER32.DLL" ALIAS "SetWindowLongPtrW" ( _
'   BYVAL DWORD _                       ' __in HWND hWnd
' , BYVAL LONG _                        ' __in int nIndex
' , BYVAL LONG _                        ' __in LONG_PTR dwNewLong
' ) AS LONG                             ' LONG_PTR

'#endif /* _WIN64 */

DECLARE FUNCTION GetClassWord LIB "USER32.DLL" ALIAS "GetClassWord" ( _
   BYVAL DWORD  _                      ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 ) AS WORD                             ' WORD

DECLARE FUNCTION SetClassWord LIB "USER32.DLL" ALIAS "SetClassWord" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 , BYVAL WORD _                        ' __in WORD wNewWord
 ) AS WORD                             ' WORD

DECLARE FUNCTION GetClassLong LIB "USER32.DLL" ALIAS "GetClassLongA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION GetClassLongW LIB "USER32.DLL" ALIAS "GetClassLongW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetClassLong LIB "USER32.DLL" ALIAS "SetClassLongA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 , BYVAL DWORD _                       ' __in LONG dwNewLong
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION SetClassLongW LIB "USER32.DLL" ALIAS "SetClassLongW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in int nIndex
 , BYVAL DWORD _                       ' __in LONG dwNewLong
 ) AS DWORD                            ' DWORD

'#ifdef _WIN64

'DECLARE FUNCTION GetClassLongPtr LIB "USER32.DLL" ALIAS "GetClassLongPtrA" ( _
'   BYVAL DWORD _                       ' __in HWND hWnd
' , BYVAL LONG _                        ' __in int nIndex
' ) AS DWORD                            ' ULONG_PTR

'DECLARE FUNCTION GetClassLongPtrW LIB "USER32.DLL" ALIAS "GetClassLongPtrW" ( _
'   BYVAL DWORD _                       ' __in HWND hWnd
' , BYVAL LONG _                        ' __in int nIndex
' ) AS DWORD                            ' ULONG_PTR

'DECLARE FUNCTION SetClassLongPtr LIB "USER32.DLL" ALIAS "SetClassLongPtrA" ( _
'   BYVAL DWORD _                       ' __in HWND hWnd
' , BYVAL LONG _                        ' __in int nIndex
' , BYVAL LONG _                        ' __in LONG_PTR dwNewLong
' ) AS DWORD                            ' ULONG_PTR

'DECLARE FUNCTION SetClassLongPtrW LIB "USER32.DLL" ALIAS "SetClassLongPtrW" ( _
'   BYVAL DWORD _                       ' __in HWND hWnd
' , BYVAL LONG _                        ' __in int nIndex
' , BYVAL LONG _                        ' __in LONG_PTR dwNewLong
' ) AS DWORD                            ' ULONG_PTR

'#endif /* _WIN64 */

'#endif /* !NOWINOFFSETS */
'#ENDIF   ' #IF NOT %DEF(%NOWINOFFSETS) ' --------------------------------------

'#if(WINVER >= 0x0500)

DECLARE FUNCTION GetProcessDefaultLayout LIB "USER32.DLL" ALIAS "GetProcessDefaultLayout" ( _
   BYREF DWORD _                       ' __out DWORD *pdwDefaultLayout
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetProcessDefaultLayout LIB "USER32.DLL" ALIAS "SetProcessDefaultLayout" ( _
   BYVAL DWORD _                       ' __in DWORD dwDefaultLayout
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0500 */

DECLARE FUNCTION GetDesktopWindow LIB "USER32.DLL" ALIAS "GetDesktopWindow" ( _
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetParent LIB "USER32.DLL" ALIAS "GetParent" ( _
   BYVAL hWnd AS DWORD _               ' __in HWND hWnd
 ) AS DWORD                            ' HWND

DECLARE FUNCTION SetParent LIB "USER32.DLL" ALIAS "SetParent" ( _
   BYVAL DWORD _                       ' __in HWND hWndChild
 , BYVAL DWORD _                       ' __in_opt HWND hWndNewParent
 ) AS DWORD                            ' HWND

DECLARE FUNCTION EnumChildWindows LIB "USER32.DLL" ALIAS "EnumChildWindows" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in WNDENUMPROC lpEnumFunc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpClassName
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpWindowName
 ) AS DWORD                            ' HWND

DECLARE FUNCTION FindWindowW LIB "USER32.DLL" ALIAS "FindWindowW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpClassName
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpWindowName
 ) AS DWORD                            ' HWND

'#if(WINVER >= 0x0400)

DECLARE FUNCTION FindWindowEx LIB "USER32.DLL" ALIAS "FindWindowExA" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt HWND hWndChildAfter
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpszClass
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpszWindow
 ) AS DWORD                            ' HWND

DECLARE FUNCTION FindWindowExW LIB "USER32.DLL" ALIAS "FindWindowExW" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt HWND hWndChildAfter
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpszClass
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpszWindow
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetShellWindow LIB "user32.dll" ALIAS "GetShellWindow" ( _
 ) AS DWORD                            ' HWND

'#endif /* WINVER >= 0x0400 */


DECLARE FUNCTION RegisterShellHookWindow LIB "user32.dll" ALIAS "RegisterShellHookWindow" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DeregisterShellHookWindow LIB "user32.dll" ALIAS "DeregisterShellHookWindow" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumWindows LIB "USER32.DLL" ALIAS "EnumWindows" ( _
   BYVAL DWORD _                       ' __in WNDENUMPROC lpEnumFunc
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumThreadWindows LIB "USER32.DLL" ALIAS "EnumThreadWindows" ( _
   BYVAL DWORD _                       ' __in DWORD dwThreadId
 , BYVAL DWORD _                       ' __in WNDENUMPROC lpfn
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' BOOL

'#define EnumTaskWindows(hTask, lpfn, lParam) EnumThreadWindows(HandleToUlong(hTask), lpfn, lParam)

MACRO EnumTaskWindows(hTask, lpfn, lParam) = EnumThreadWindows(hTask, lpfn, lParam)

DECLARE FUNCTION GetClassName LIB "USER32.DLL" ALIAS "GetClassNameA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF ASCIIZ _                      ' __out_ecount_part(nMaxCount, return) LPSTR lpClassName
 , BYVAL LONG _                        ' __in int nMaxCount
 ) AS LONG                             ' int

DECLARE FUNCTION GetClassNameW LIB "USER32.DLL" ALIAS "GetClassNameW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __out_ecount_part(nMaxCount, return) LPWSTR lpClassName
 , BYVAL LONG _                        ' __in int nMaxCount
 ) AS LONG                             ' int

DECLARE FUNCTION GetTopWindow LIB "USER32.DLL" ALIAS "GetTopWindow" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWnd
 ) AS DWORD                            ' HWND

DECLARE FUNCTION GetWindowThreadProcessId LIB "USER32.DLL" ALIAS "GetWindowThreadProcessId" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYREF DWORD _                       ' __out_opt LPDWORD lpdwProcessId
 ) AS DWORD                            ' DWORD

'#if(_WIN32_WINNT >= 0x0501)

DECLARE FUNCTION IsGUIThread LIB "USER32.DLL" ALIAS "IsGUIThread" ( _
   BYVAL LONG _                        ' __in BOOL bConvert
 ) AS LONG                             ' BOOL

'#endif /* _WIN32_WINNT >= 0x0501 */

'#define GetWindowTask(hWnd) \
'        ((HANDLE)(DWORD_PTR)GetWindowThreadProcessId(hWnd, NULL))

MACRO GetWindowTask(hWnd) = GetWindowThreadProcessId(hWnd, BYVAL %NULL)

DECLARE FUNCTION GetLastActivePopup LIB "USER32.DLL" ALIAS "GetLastActivePopup" ( _
   BYVAL DWORD _                       ' __in HWND hWnd)
 ) AS DWORD                            ' HWND

'/*
' * GetWindow() Constants
' */
%GW_HWNDFIRST    = 0???
%GW_HWNDLAST     = 1???
%GW_HWNDNEXT     = 2???
%GW_HWNDPREV     = 3???
%GW_OWNER        = 4???
%GW_CHILD        = 5???
'#if(WINVER <= 0x0400)
'%GW_MAX          = 5???
'#else
%GW_ENABLEDPOPUP = 6???
%GW_MAX          = 6???
'#endif

DECLARE FUNCTION GetWindow LIB "USER32.DLL" ALIAS "GetWindow" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT uCmd
 ) AS DWORD                            ' HWND

'#define GetNextWindow(hWnd, wCmd) GetWindow(hWnd, wCmd)
'#define GetSysModalWindow() (NULL)
'#define SetSysModalWindow(hWnd) (NULL)

'   FUNCTION GetNextWindow (BYVAL hWnd AS DWORD, BYVAL wCmd AS DWORD) AS DWORD
'      FUNCTION = GetWindow(hWnd, wCmd)
'   END FUNCTION

'#IF NOT %DEF(%NOWH) ' ---------------------------------------------------------
'#ifndef NOWH

DECLARE FUNCTION SetWindowsHook LIB "USER32.DLL" ALIAS "SetWindowsHookA" ( _
   BYVAL LONG _                        ' __in int nFilterType
 , BYVAL DWORD _                       ' __in HOOKPROC pfnFilterProc
 ) AS DWORD                            ' HHOOK

DECLARE FUNCTION SetWindowsHookW LIB "USER32.DLL" ALIAS "SetWindowsHookW" ( _
   BYVAL LONG _                        ' __in int nFilterType
 , BYVAL DWORD _                       ' __in HOOKPROC pfnFilterProc
 ) AS DWORD                            ' HHOOK

DECLARE FUNCTION UnhookWindowsHook LIB "USER32.DLL" ALIAS "UnhookWindowsHook" ( _
   BYVAL LONG _                        ' __in int nCode
 , BYVAL DWORD _                       ' __in HOOKPROC pfnFilterProc
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SetWindowsHookEx LIB "USER32.DLL" ALIAS "SetWindowsHookExA" ( _
   BYVAL LONG _                        ' __in int idHook
 , BYVAL DWORD _                       ' __in HOOKPROC lpfn
 , BYVAL DWORD _                       ' __in_opt HINSTANCE hmod
 , BYVAL DWORD _                       ' __in DWORD dwThreadId
 ) AS DWORD                            ' HHOOK

DECLARE FUNCTION SetWindowsHookEx LIB "USER32.DLL" ALIAS "SetWindowsHookExA" ( _
   BYVAL LONG _                        ' __in int idHook
 , BYVAL DWORD _                       ' __in HOOKPROC lpfn
 , BYVAL DWORD _                       ' __in_opt HINSTANCE hmod
 , BYVAL DWORD _                       ' __in DWORD dwThreadId
 ) AS DWORD                            ' HHOOK

DECLARE FUNCTION UnhookWindowsHookEx LIB "USER32.DLL" ALIAS "UnhookWindowsHookEx" ( _
   BYVAL DWORD _                       ' __in HHOOK hhk
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CallNextHookEx LIB "USER32.DLL" ALIAS "CallNextHookEx" ( _
   BYVAL DWORD _                       ' __in_opt HHOOK hhk,
 , BYVAL LONG _                        ' __in int nCode
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL DWORD _                       ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

'/*
' * Macros for source-level compatibility with old functions.
' */
'#define DefHookProc(nCode, wParam, lParam, phhk)\
'        CallNextHookEx((HHOOK)*phhk, nCode, wParam, lParam)
MACRO DefHookProc(nCode, wParam, lParam, phhk) = CallNextHookEx(phhk, nCode, wParam, lParam)

'#endif /* !NOWH */
'#ENDIF   ' #IF NOT %DEF(%NOWH) ' ----------------------------------------------

'#IF NOT %DEF(%NOMENUS) ' ------------------------------------------------------
'#ifndef NOMENUS


'/* ;win40  -- A lot of MF_* flags have been renamed as MFT_* and MFS_* flags */
'/*
' * Menu flags for Add/Check/EnableMenuItem()
' */
%MF_INSERT          = &H00000000???
%MF_CHANGE          = &H00000080???
%MF_APPEND          = &H00000100???
%MF_DELETE          = &H00000200???
%MF_REMOVE          = &H00001000???

%MF_BYCOMMAND       = &H00000000???
%MF_BYPOSITION      = &H00000400???

%MF_SEPARATOR       = &H00000800???

%MF_ENABLED         = &H00000000???
%MF_GRAYED          = &H00000001???
%MF_DISABLED        = &H00000002???

%MF_UNCHECKED       = &H00000000???
%MF_CHECKED         = &H00000008???
%MF_USECHECKBITMAPS = &H00000200???

%MF_STRING          = &H00000000???
%MF_BITMAP          = &H00000004???
%MF_OWNERDRAW       = &H00000100???

%MF_POPUP           = &H00000010???
%MF_MENUBARBREAK    = &H00000020???
%MF_MENUBREAK       = &H00000040???

%MF_UNHILITE        = &H00000000???
%MF_HILITE          = &H00000080???

'#if(WINVER >= 0x0400)
%MF_DEFAULT         = &H00001000???
'#endif /* WINVER >= 0x0400 */
%MF_SYSMENU         = &H00002000???
%MF_HELP            = &H00004000???
'#if(WINVER >= 0x0400)
%MF_RIGHTJUSTIFY    = &H00004000???
'#endif /* WINVER >= 0x0400 */

%MF_MOUSESELECT     = &H00008000???
'#if(WINVER >= 0x0400)
'%MF_END             = &H00000080???  ' /* Obsolete -- only used by old RES files */
'#endif /* WINVER >= 0x0400 */


'#if(WINVER >= 0x0400)
%MFT_STRING         = %MF_STRING
%MFT_BITMAP         = %MF_BITMAP
%MFT_MENUBARBREAK   = %MF_MENUBARBREAK
%MFT_MENUBREAK      = %MF_MENUBREAK
%MFT_OWNERDRAW      = %MF_OWNERDRAW
%MFT_RADIOCHECK     = &H00000200???
%MFT_SEPARATOR      = %MF_SEPARATOR
%MFT_RIGHTORDER     = &H00002000???
%MFT_RIGHTJUSTIFY   = %MF_RIGHTJUSTIFY

'/* Menu flags for Add/Check/EnableMenuItem() */
%MFS_GRAYED    = &H00000003???
%MFS_DISABLED  = %MFS_GRAYED
%MFS_CHECKED   = %MF_CHECKED
%MFS_HILITE    = %MF_HILITE
%MFS_ENABLED   = %MF_ENABLED
%MFS_UNCHECKED = %MF_UNCHECKED
%MFS_UNHILITE  = %MF_UNHILITE
%MFS_DEFAULT   = %MF_DEFAULT
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0400)

DECLARE FUNCTION CheckMenuRadioItem LIB "USER32.DLL" ALIAS "CheckMenuRadioItem" ( _
   BYVAL DWORD _                       ' __in HMENU hmenu
 , BYVAL DWORD _                       ' __in UINT first
 , BYVAL DWORD _                       ' __in UINT last
 , BYVAL DWORD _                       ' __in UINT check
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0400 */

'/*
' * Menu item resource format
' */

TYPE MENUITEMTEMPLATEHEADER
   versionNumber AS WORD   ' WORD versionNumber
   offset        AS WORD   ' WORD offset
END TYPE

TYPE MENUITEMTEMPLATE
   mtOption AS WORD   ' WORD mtOption
   mtID     AS WORD   ' WORD mtID
   mtString AS WORD   ' WCHAR mtString[1]
END TYPE

'#define MF_END             0x00000080L
%MF_END             = &H00000080???

'#endif /* !NOMENUS */
'#ENDIF   ' #IF NOT %DEF(%NOMENUS) ' -------------------------------------------

'#IF NOT %DEF(%NOSYSCOMMANDS) ' ------------------------------------------------
'#ifndef NOSYSCOMMANDS

'/*
' * System Menu Command Values
' */
%SC_SIZE         = &HF000???
%SC_MOVE         = &HF010???
%SC_MINIMIZE     = &HF020???
%SC_MAXIMIZE     = &HF030???
%SC_NEXTWINDOW   = &HF040???
%SC_PREVWINDOW   = &HF050???
%SC_CLOSE        = &HF060???
%SC_VSCROLL      = &HF070???
%SC_HSCROLL      = &HF080???
%SC_MOUSEMENU    = &HF090???
%SC_KEYMENU      = &HF100???
%SC_ARRANGE      = &HF110???
%SC_RESTORE      = &HF120???
%SC_TASKLIST     = &HF130???
%SC_SCREENSAVE   = &HF140???
%SC_HOTKEY       = &HF150???
'#if(WINVER >= 0x0400)
%SC_DEFAULT      = &HF160???
%SC_MONITORPOWER = &HF170???
%SC_CONTEXTHELP  = &HF180???
%SC_SEPARATOR    = &HF00F???
'#endif /* WINVER >= 0x0400 */

'/*
' * Obsolete names
' */
%SC_ICON        = %SC_MINIMIZE
%SC_ZOOM        = %SC_MAXIMIZE

'#endif /* !NOSYSCOMMANDS */
'#ENDIF   ' #IF NOT %DEF(%NOSYSCOMMANDS) ' -------------------------------------

'/*
' * Resource Loading Routines
' */

DECLARE FUNCTION LoadBitmap LIB "USER32.DLL" ALIAS "LoadBitmapA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpBitmapName
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION LoadBitmapW LIB "USER32.DLL" ALIAS "LoadBitmapW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in LPCWSTR lpBitmapName
 ) AS DWORD                            ' HBITMAP

DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpCursorName
 ) AS DWORD                            ' HCURSOR

DECLARE FUNCTION LoadCursorW LIB "USER32.DLL" ALIAS "LoadCursorW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in LPCWSTR lpCursorName
 ) AS DWORD                            ' HCURSOR

DECLARE FUNCTION LoadCursorFromFile LIB "USER32.DLL" ALIAS "LoadCursorFromFileA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpFileName
 ) AS DWORD                            ' HCURSOR

DECLARE FUNCTION LoadCursorFromFileW LIB "USER32.DLL" ALIAS "LoadCursorFromFileW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpFileName
 ) AS DWORD                            ' HCURSOR

DECLARE FUNCTION CreateCursor LIB "USER32.DLL" ALIAS "CreateCursor" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInst
 , BYVAL LONG _                        ' __in int xHotSpot
 , BYVAL LONG _                        ' __in int yHotSpot
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYREF ANY _                         ' __in CONST VOID *pvANDPlane
 , BYREF ANY _                         ' __in CONST VOID *pvXORPlane
 ) AS DWORD                            ' HCURSOR

DECLARE FUNCTION DestroyCursor LIB "USER32.DLL" ALIAS "DestroyCursor" ( _
   BYVAL DWORD _                       ' __in HCURSOR hCursor
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CopyCursor LIB "USER32.DLL" ALIAS "CopyCursor" ( _
   BYVAL DWORD _                       ' __in HCURSOR hCursor
 ) AS DWORD                            ' HCURSOR

'#endif

'/*
' * Standard Cursor IDs
' */
'#define IDC_ARROW           MAKEINTRESOURCE(32512)
'#define IDC_IBEAM           MAKEINTRESOURCE(32513)
'#define IDC_WAIT            MAKEINTRESOURCE(32514)
'#define IDC_CROSS           MAKEINTRESOURCE(32515)
'#define IDC_UPARROW         MAKEINTRESOURCE(32516)
'#define IDC_SIZE            MAKEINTRESOURCE(32640)  /* OBSOLETE: use IDC_SIZEALL */
'#define IDC_ICON            MAKEINTRESOURCE(32641)  /* OBSOLETE: use IDC_ARROW */
'#define IDC_SIZENWSE        MAKEINTRESOURCE(32642)
'#define IDC_SIZENESW        MAKEINTRESOURCE(32643)
'#define IDC_SIZEWE          MAKEINTRESOURCE(32644)
'#define IDC_SIZENS          MAKEINTRESOURCE(32645)
'#define IDC_SIZEALL         MAKEINTRESOURCE(32646)
'#define IDC_NO              MAKEINTRESOURCE(32648) /*not in win3.1 */
'#if(WINVER >= 0x0500)
'#define IDC_HAND            MAKEINTRESOURCE(32649)
'#endif /* WINVER >= 0x0500 */
'#define IDC_APPSTARTING     MAKEINTRESOURCE(32650) /*not in win3.1 */
'#if(WINVER >= 0x0400)
'#define IDC_HELP            MAKEINTRESOURCE(32651)
'#endif /* WINVER >= 0x0400 */

%IDC_ARROW        = 32512???
%IDC_IBEAM        = 32513???
%IDC_WAIT         = 32514???
%IDC_CROSS        = 32515???
%IDC_UPARROW      = 32516???
%IDC_SIZE         = 32640???
%IDC_ICON         = 32641???
%IDC_SIZENWSE     = 32642???
%IDC_SIZENESW     = 32643???
%IDC_SIZEWE       = 32644???
%IDC_SIZENS       = 32645???
%IDC_SIZEALL      = 32646???
%IDC_NO           = 32648???
'#if(WINVER >= 0x0500)
%IDC_HAND         = 32649???
'#endif /* WINVER >= 0x0500 */
%IDC_APPSTARTING  = 32650???
'#if(WINVER >= 0x0400)
%IDC_HELP         = 32651???
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION SetSystemCursor LIB "USER32.DLL" ALIAS "SetSystemCursor" ( _
   BYVAL DWORD _                       ' __in HCURSOR hcur
 , BYVAL LONG _                        ' __in DWORD id
 ) AS LONG                             ' BOOL

TYPE ICONINFO
   fIcon    AS LONG    ' BOOL    fIcon
   xHotspot AS DWORD   ' DWORD   xHotspot
   yHotspot AS DWORD   ' DWORD   yHotspot
   hbmMask  AS DWORD   ' HBITMAP hbmMask
   hbmColor AS DWORD   ' HBITMAP hbmColor
END TYPE

DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYREF ASCIIZ _                      ' __in LPCSTR lpIconName
 ) AS DWORD                            ' HICON

DECLARE FUNCTION LoadIconW LIB "USER32.DLL" ALIAS "LoadIconW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in LPCWSTR lpIconName
 ) AS DWORD                            ' HICON

DECLARE FUNCTION PrivateExtractIcons LIB "USER32.DLL" ALIAS "PrivateExtractIconsA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR szFileName
 , BYVAL LONG _                        ' __in int nIconIndex
 , BYVAL LONG _                        ' __in int cxIcon
 , BYVAL LONG _                        ' __in int cyIcon
 , BYREF DWORD _                       ' __out_ecount_part_opt(nIcons, return) HICON *phicon
 , BYREF DWORD _                       ' __out_ecount_part_opt(nIcons, return) UINT *piconid
 , BYVAL DWORD _                       ' __in UINT nIcons
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS DWORD                            ' UINT

DECLARE FUNCTION PrivateExtractIconsW LIB "USER32.DLL" ALIAS "PrivateExtractIconsW" ( _
   BYVAL DWORD  _                      ' __in LPCWSTR szFileName
 , BYVAL LONG _                        ' __in int nIconIndex
 , BYVAL LONG _                        ' __in int cxIcon
 , BYVAL LONG _                        ' __in int cyIcon
 , BYREF DWORD _                       ' __out_ecount_part_opt(nIcons, return) HICON *phicon
 , BYREF DWORD _                       ' __out_ecount_part_opt(nIcons, return) UINT *piconid
 , BYVAL DWORD _                       ' __in UINT nIcons
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS DWORD                            ' UINT

DECLARE FUNCTION CreateIcon LIB "USER32.DLL" ALIAS "CreateIcon" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYVAL BYTE _                        ' __in BYTE cPlanes
 , BYVAL BYTE _                        ' __in BYTE cBitsPixel
 , BYREF BYTE _                        ' __in CONST BYTE *lpbANDbits
 , BYREF BYTE _                        ' __in CONST BYTE *lpbXORbits
 ) AS DWORD                            ' HICON

DECLARE FUNCTION DestroyIcon LIB "USER32.DLL" ALIAS "DestroyIcon" ( _
   BYVAL DWORD _                       ' __in HICON hIcon
 ) AS LONG                             ' BOOL

DECLARE FUNCTION LookupIconIdFromDirectory LIB "USER32.DLL" ALIAS "LookupIconIdFromDirectory" ( _
   BYREF BYTE _                        ' __in PBYTE presbits
 , BYVAL LONG _                        ' __in BOOL fIcon
 ) AS LONG                             ' int

'#if(WINVER >= 0x0400)
DECLARE FUNCTION LookupIconIdFromDirectoryEx LIB "USER32.DLL" ALIAS "LookupIconIdFromDirectoryEx" ( _
   BYREF BYTE _                        ' __in PBYTE presbits
 , BYVAL LONG _                        ' __in BOOL fIcon
 , BYVAL LONG _                        ' __in int cxDesired
 , BYVAL LONG _                        ' __in int cyDesired
 , BYVAL DWORD _                       ' __in UINT Flags
 ) AS LONG                             ' int
'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION CreateIconFromResource LIB "USER32.DLL" ALIAS "CreateIconFromResource" ( _
   BYVAL DWORD _                       ' __in PBYTE presbits
 , BYVAL DWORD _                       ' __in DWORD dwResSize
 , BYVAL LONG _                        ' __in BOOL fIcon
 , BYVAL DWORD _                       ' __in DWORD dwVer
 ) AS DWORD                            ' HICON

'#if(WINVER >= 0x0400)

DECLARE FUNCTION CreateIconFromResourceEx LIB "USER32.DLL" ALIAS "CreateIconFromResourceEx" ( _
   BYVAL DWORD _                       ' __in PBYTE presbits
 , BYVAL DWORD _                       ' __in DWORD dwResSize
 , BYVAL LONG _                        ' __in BOOL fIcon
 , BYVAL DWORD _                       ' __in DWORD dwVer
 , BYVAL LONG _                        ' __in int cxDesired
 , BYVAL LONG _                        ' __in int cyDesired
 , BYVAL DWORD _                       ' __in UINT Flags
 ) AS DWORD                            ' HICON

'/* Icon/Cursor header */
'#endif /* WINVER >= 0x0400 */

TYPE CURSORSHAPE
   xHotSpot  AS LONG   ' int     xHotSpot
   yHotSpot  AS LONG   ' int     yHotSpot
   cx        AS LONG   ' int     cx
   cy        AS LONG   ' int     cy
   cbWidth   AS LONG   ' int     cbWidth
   Planes    AS BYTE   ' BYTE    Planes
   BitsPixel AS BYTE   ' BYTE    BitsPixel
END TYPE

%IMAGE_BITMAP      = 0???
%IMAGE_ICON        = 1???
%IMAGE_CURSOR      = 2???
'#if(WINVER >= 0x0400)
%IMAGE_ENHMETAFILE = 3???

%LR_DEFAULTCOLOR     = &H0000???
%LR_MONOCHROME       = &H0001???
%LR_COLOR            = &H0002???
%LR_COPYRETURNORG    = &H0004???
%LR_COPYDELETEORG    = &H0008???
%LR_LOADFROMFILE     = &H0010???
%LR_LOADTRANSPARENT  = &H0020???
%LR_DEFAULTSIZE      = &H0040???
%LR_VGACOLOR         = &H0080???
%LR_LOADMAP3DCOLORS  = &H1000???
%LR_CREATEDIBSECTION = &H2000???
%LR_COPYFROMRESOURCE = &H4000???
%LR_SHARED           = &H8000???

DECLARE FUNCTION LoadImage LIB "USER32.DLL" ALIAS "LoadImageA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInst
 , BYREF ASCIIZ _                      ' __in LPCSTR name
 , BYVAL DWORD _                       ' __in UINT type
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 , BYVAL DWORD _                       ' __in UINT fuLoad
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION LoadImageW LIB "USER32.DLL" ALIAS "LoadImageW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInst
 , BYVAL DWORD _                       ' __in LPCWSTR name
 , BYVAL DWORD _                       ' __in UINT type
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 , BYVAL DWORD _                       ' __in UINT fuLoad
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION CopyImage LIB "USER32.DLL" ALIAS "CopyImage" ( _
   BYVAL DWORD _                       ' __in HANDLE h
 , BYVAL DWORD _                       ' __in UINT type
 , BYVAL LONG _                        ' __in int cx
 , BYVAL LONG _                        ' __in int cy
 , BYVAL DWORD _                       ' __in UINT flags
 ) AS DWORD                            ' HANDLE

%DI_MASK           = &H0001???
%DI_IMAGE          = &H0002???
%DI_NORMAL         = &H0003???
%DI_COMPAT         = &H0004???
%DI_DEFAULTSIZE    = &H0008???
'#if(_WIN32_WINNT >= 0x0501)
%DI_NOMIRROR       = &H0010???
'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION DrawIconEx LIB "USER32.DLL" ALIAS "DrawIconEx" ( _
   BYVAL DWORD _                       ' __in HDC hdc
 , BYVAL LONG _                        ' __in int xLeft
 , BYVAL LONG _                        ' __in int yTop
 , BYVAL DWORD _                       ' __in HICON hIcon
 , BYVAL LONG _                        ' __in int cxWidth
 , BYVAL LONG _                        ' __in int cyWidth
 , BYVAL DWORD _                       ' __in UINT istepIfAniCur
 , BYVAL DWORD _                       ' __in_opt HBRUSH hbrFlickerFreeDraw
 , BYVAL DWORD _                       ' __in UINT diFlags
 ) AS LONG                             ' long

'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION CreateIconIndirect LIB "USER32.DLL" ALIAS "CreateIconIndirect" ( _
   BYREF ICONINFO _                    ' __in PICONINFO piconinfo
 ) AS DWORD                            ' HICON

DECLARE FUNCTION CopyIcon LIB "USER32.DLL" ALIAS "CopyIcon" ( _
   BYVAL DWORD _                       ' __in HICON hIcon
 ) AS DWORD                            ' HICON

DECLARE FUNCTION GetIconInfo LIB "USER32.DLL" ALIAS "GetIconInfo" ( _
   BYVAL DWORD, _                      ' __in HICON hIcon
   BYREF ICONINFO _                    ' __out PICONINFO piconinfo
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0600)
TYPE ICONINFOEXA
   cbSize    AS DWORD   ' DWORD
   fIcon     AS LONG    ' BOOL
   xHotspot  AS DWORD   ' DWORD
   yHotspot  AS DWORD   ' DWORD
   hbmMask   AS DWORD   ' HBITMAP
   hbmColor  AS DWORD   ' HBITMAP
   wResID    AS WORD    ' WORD
   szModName AS ASCIIZ * %MAX_PATH
   szResName AS ASCIIZ * %MAX_PATH
END TYPE

MACRO ICONINFOEX = ICONINFOEXA

TYPE ICONINFOEXW
   cbSize    AS DWORD   ' DWORD
   fIcon     AS LONG    ' BOOL
   xHotspot  AS DWORD   ' DWORD
   yHotspot  AS DWORD   ' DWORD
   hbmMask   AS DWORD   ' HBITMAP
   hbmColor  AS DWORD   ' HBITMAP
   wResID    AS WORD    ' WORD
   szModName AS STRING * %MAX_PATH * 2
   szResName AS STRING * %MAX_PATH * 2
END TYPE

DECLARE FUNCTION GetIconInfoEx LIB "USER32.DLL" ALIAS "GetIconInfoExA" ( _
   BYVAL DWORD _                       ' __in HICON hIcon
 , BYREF ICONINFOEXA _                 ' __out PICONINFOEXA piconinfo
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetIconInfoExW LIB "USER32.DLL" ALIAS "GetIconInfoExW" ( _
   BYVAL DWORD _                       ' __in HICON hIcon
 , BYREF ICONINFOEXW _                 ' __out PICONINFOEXW piconinfo
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >= 0x0600 */

'#if(WINVER >= 0x0400)
%RES_ICON   = 1??
%RES_CURSOR = 2??
'#endif /* WINVER >= 0x0400 */

'#ifdef OEMRESOURCE


'/*
' * OEM Resource Ordinal Numbers
' */
%OBM_CLOSE        = 32754???
%OBM_UPARROW      = 32753???
%OBM_DNARROW      = 32752???
%OBM_RGARROW      = 32751???
%OBM_LFARROW      = 32750???
%OBM_REDUCE       = 32749???
%OBM_ZOOM         = 32748???
%OBM_RESTORE      = 32747???
%OBM_REDUCED      = 32746???
%OBM_ZOOMD        = 32745???
%OBM_RESTORED     = 32744???
%OBM_UPARROWD     = 32743???
%OBM_DNARROWD     = 32742???
%OBM_RGARROWD     = 32741???
%OBM_LFARROWD     = 32740???
%OBM_MNARROW      = 32739???
%OBM_COMBO        = 32738???
%OBM_UPARROWI     = 32737???
%OBM_DNARROWI     = 32736???
%OBM_RGARROWI     = 32735???
%OBM_LFARROWI     = 32734???

%OBM_OLD_CLOSE    = 32767???
%OBM_SIZE         = 32766???
%OBM_OLD_UPARROW  = 32765???
%OBM_OLD_DNARROW  = 32764???
%OBM_OLD_RGARROW  = 32763???
%OBM_OLD_LFARROW  = 32762???
%OBM_BTSIZE       = 32761???
%OBM_CHECK        = 32760???
%OBM_CHECKBOXES   = 32759???
%OBM_BTNCORNERS   = 32758???
%OBM_OLD_REDUCE   = 32757???
%OBM_OLD_ZOOM     = 32756???
%OBM_OLD_RESTORE  = 32755???

%OCR_NORMAL       = 32512???
%OCR_IBEAM        = 32513???
%OCR_WAIT         = 32514???
%OCR_CROSS        = 32515???
%OCR_UP           = 32516???
%OCR_SIZE         = 32640???   ' OBSOLETE: use %OCR_SIZEALL
%OCR_ICON         = 32641???   ' OBSOLETE: use %OCR_NORMAL
%OCR_SIZENWSE     = 32642???
%OCR_SIZENESW     = 32643???
%OCR_SIZEWE       = 32644???
%OCR_SIZENS       = 32645???
%OCR_SIZEALL      = 32646???
%OCR_ICOCUR       = 32647???   ' OBSOLETE: use %OIC_WINLOGO
%OCR_NO           = 32648???
'#if(WINVER >= 0x0500)
%OCR_HAND         = 32649???
'#endif /* WINVER >= 0x0500 */
'#if(WINVER >= 0x0400)
%OCR_APPSTARTING  = 32650???
'#endif /* WINVER >= 0x0400 */

%OIC_SAMPLE       = 32512???
%OIC_HAND         = 32513???
%OIC_QUES         = 32514???
%OIC_BANG         = 32515???
%OIC_NOTE         = 32516???
'#if(WINVER >= 0x0400)
%OIC_WINLOGO      = 32517???
%OIC_WARNING      = %OIC_BANG
%OIC_ERROR        = %OIC_HAND
%OIC_INFORMATION  = %OIC_NOTE
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0600)
%OIC_SHIELD       = 32518???
'#endif /* WINVER >= 0x0600 */

'#endif /* OEMRESOURCE */

'#define ORD_LANGDRIVER    1     /* The ordinal number for the entry point of
'                                ** language drivers.
'                                */
%ORD_LANGDRIVER = 1& ' The ordinal number for the entry point of language drivers.

'#IF NOT %DEF(%NOICONS) ' ------------------------------------------------------
'#ifndef NOICONS

'/*
' * Standard Icon IDs
' */
'#ifdef RC_INVOKED
'#define IDI_APPLICATION     32512
'#define IDI_HAND            32513
'#define IDI_QUESTION        32514
'#define IDI_EXCLAMATION     32515
'#define IDI_ASTERISK        32516
'#if(WINVER >= 0x0400)
'#define IDI_WINLOGO         32517
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0600)
'#define IDI_SHIELD          32518
'#endif /* WINVER >= 0x0600 */
'#else
'#define IDI_APPLICATION     MAKEINTRESOURCE(32512)
'#define IDI_HAND            MAKEINTRESOURCE(32513)
'#define IDI_QUESTION        MAKEINTRESOURCE(32514)
'#define IDI_EXCLAMATION     MAKEINTRESOURCE(32515)
'#define IDI_ASTERISK        MAKEINTRESOURCE(32516)
'#if(WINVER >= 0x0400)
'#define IDI_WINLOGO         MAKEINTRESOURCE(32517)
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0600)
'#define IDI_SHIELD          MAKEINTRESOURCE(32518)
'#endif /* WINVER >= 0x0600 */
'#endif /* RC_INVOKED */

%IDI_APPLICATION = 32512???
%IDI_HAND        = 32513???
%IDI_QUESTION    = 32514???
%IDI_EXCLAMATION = 32515???
%IDI_ASTERISK    = 32516???
%IDI_WINLOGO     = 32517???
%IDI_SHIELD      = 32518???

'#if(WINVER >= 0x0400)
'#define IDI_WARNING     IDI_EXCLAMATION
'#define IDI_ERROR       IDI_HAND
'#define IDI_INFORMATION IDI_ASTERISK
%IDI_WARNING     = %IDI_EXCLAMATION
%IDI_ERROR       = %IDI_HAND
%IDI_INFORMATION = %IDI_ASTERISK
'#endif /* WINVER >= 0x0400 */

'#endif /* !NOICONS */
'#ENDIF   ' #IF NOT %DEF(%NOICONS) ' -------------------------------------------

DECLARE FUNCTION LoadString LIB "USER32.DLL" ALIAS "LoadStringA" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in UINT uID
 , BYREF ASCIIZ _                      ' __out_ecount(cchBufferMax) LPSTR lpBuffer
 , BYVAL LONG _                        ' __in int cchBufferMax
 ) AS LONG                             ' int

DECLARE FUNCTION LoadStringW LIB "USER32.DLL" ALIAS "LoadStringW" ( _
   BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL DWORD _                       ' __in UINT uID
 , BYVAL DWORD _                       ' __out_ecount(cchBufferMax) LPWSTR lpBuffer
 , BYVAL LONG _                        ' __in int cchBufferMax
 ) AS LONG                             ' int

'/*
' * Dialog Box Command IDs
' */
%IDOK       = 1???
%IDCANCEL   = 2???
%IDABORT    = 3???
%IDRETRY    = 4???
%IDIGNORE   = 5???
%IDYES      = 6???
%IDNO       = 7???
'#if(WINVER >= 0x0400)
%IDCLOSE    = 8???
%IDHELP     = 9???
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
%IDTRYAGAIN = 10???
%IDCONTINUE = 11???
'#endif /* WINVER >= 0x0500 */

'#if(WINVER >= 0x0501)
#IF NOT %DEF(%IDTIMEOUT)
%IDTIMEOUT  = 32000???
#ENDIF
'#endif /* WINVER >= 0x0501 */


'#IF NOT %DEF(%NOCTLMGR) ' -----------------------------------------------------
'#ifndef NOCTLMGR

'/*
' * Control Manager Structures and Definitions
' */

'#IF NOT %DEF(%NOWINSTYLES) ' --------------------------------------------------
'#ifndef NOWINSTYLES

'/*
' * Edit Control Styles
' */
%ES_LEFT        = &H0000???
%ES_CENTER      = &H0001???
%ES_RIGHT       = &H0002???
%ES_MULTILINE   = &H0004???
%ES_UPPERCASE   = &H0008???
%ES_LOWERCASE   = &H0010???
%ES_PASSWORD    = &H0020???
%ES_AUTOVSCROLL = &H0040???
%ES_AUTOHSCROLL = &H0080???
%ES_NOHIDESEL   = &H0100???
%ES_OEMCONVERT  = &H0400???
%ES_READONLY    = &H0800???
%ES_WANTRETURN  = &H1000???
'#if(WINVER >= 0x0400)
%ES_NUMBER      = &H2000???
'#endif /* WINVER >= 0x0400 */

'#endif /* !NOWINSTYLES */
'#ENDIF   ' #IF NOT %DEF(%NOWINSTYLES) ' ---------------------------------------

'/*
' * Edit Control Notification Codes
' */
%EN_SETFOCUS     = &H0100???
%EN_KILLFOCUS    = &H0200???
%EN_CHANGE       = &H0300???
%EN_UPDATE       = &H0400???
%EN_ERRSPACE     = &H0500???
%EN_MAXTEXT      = &H0501???
%EN_HSCROLL      = &H0601???
%EN_VSCROLL      = &H0602???

'#if(_WIN32_WINNT >= 0x0500)
%EN_ALIGN_LTR_EC = &H0700???
%EN_ALIGN_RTL_EC = &H0701???
'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(WINVER >= 0x0400)
'/* Edit control EM_SETMARGIN parameters */
%EC_LEFTMARGIN   = &H0001???
%EC_RIGHTMARGIN  = &H0002???
%EC_USEFONTINFO  = &HFFFF???
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
'/* wParam of EM_GET/SETIMESTATUS  */
%EMSIS_COMPOSITIONSTRING        = &H0001???

'/* lParam for EMSIS_COMPOSITIONSTRING  */
%EIMES_GETCOMPSTRATONCE         = &H0001???
%EIMES_CANCELCOMPSTRINFOCUS     = &H0002???
%EIMES_COMPLETECOMPSTRKILLFOCUS = &H0004???
'#endif /* WINVER >= 0x0500 */

'#IF NOT %DEF(%NOWINMESSAGES) ' ------------------------------------------------
'#ifndef NOWINMESSAGES

'/*
' * Edit Control Messages
' */
%EM_GETSEL              = &H00B0???
%EM_SETSEL              = &H00B1???
%EM_GETRECT             = &H00B2???
%EM_SETRECT             = &H00B3???
%EM_SETRECTNP           = &H00B4???
%EM_SCROLL              = &H00B5???
%EM_LINESCROLL          = &H00B6???
%EM_SCROLLCARET         = &H00B7???
%EM_GETMODIFY           = &H00B8???
%EM_SETMODIFY           = &H00B9???
%EM_GETLINECOUNT        = &H00BA???
%EM_LINEINDEX           = &H00BB???
%EM_SETHANDLE           = &H00BC???
%EM_GETHANDLE           = &H00BD???
%EM_GETTHUMB            = &H00BE???
%EM_LINELENGTH          = &H00C1???
%EM_REPLACESEL          = &H00C2???
%EM_GETLINE             = &H00C4???
%EM_LIMITTEXT           = &H00C5???
%EM_CANUNDO             = &H00C6???
%EM_UNDO                = &H00C7???
%EM_FMTLINES            = &H00C8???
%EM_LINEFROMCHAR        = &H00C9???
%EM_SETTABSTOPS         = &H00CB???
%EM_SETPASSWORDCHAR     = &H00CC???
%EM_EMPTYUNDOBUFFER     = &H00CD???
%EM_GETFIRSTVISIBLELINE = &H00CE???
%EM_SETREADONLY         = &H00CF???
%EM_SETWORDBREAKPROC    = &H00D0???
%EM_GETWORDBREAKPROC    = &H00D1???
%EM_GETPASSWORDCHAR     = &H00D2???
'#if(WINVER >= 0x0400)
%EM_SETMARGINS          = &H00D3???
%EM_GETMARGINS          = &H00D4???
%EM_SETLIMITTEXT        = %EM_LIMITTEXT
%EM_GETLIMITTEXT        = &H00D5???
%EM_POSFROMCHAR         = &H00D6???
%EM_CHARFROMPOS         = &H00D7???
'#endif /* WINVER >= 0x0400 */

'#if(WINVER >= 0x0500)
%EM_SETIMESTATUS        = &H00D8???
%EM_GETIMESTATUS        = &H00D9???
'#endif /* WINVER >= 0x0500 */

'#endif /* !NOWINMESSAGES */
'#ENDIF   ' #IF NOT %DEF(%NOWINMESSAGES) ' -------------------------------------

'/*
' * EDITWORDBREAKPROC code values
' */
%WB_LEFT        = 0&
%WB_RIGHT       = 1&
%WB_ISDELIMITER = 2&


'/*
' * Button Control Styles
' */
%BS_PUSHBUTTON      = &H00000000???
%BS_DEFPUSHBUTTON   = &H00000001???
%BS_DEFAULT         = %BS_DEFPUSHBUTTON
%BS_CHECKBOX        = &H00000002???
%BS_AUTOCHECKBOX    = &H00000003???
%BS_RADIOBUTTON     = &H00000004???
%BS_3STATE          = &H00000005???
%BS_AUTO3STATE      = &H00000006???
%BS_GROUPBOX        = &H00000007???
%BS_USERBUTTON      = &H00000008???
%BS_AUTORADIOBUTTON = &H00000009???
%BS_OWNERDRAW       = &H0000000B???
%BS_LEFTTEXT        = &H00000020???
'#if(WINVER >= 0x0400)
%BS_TEXT            = &H00000000???
%BS_ICON            = &H00000040???
%BS_BITMAP          = &H00000080???
%BS_LEFT            = &H00000100???
%BS_RIGHT           = &H00000200???
%BS_CENTER          = &H00000300???
%BS_TOP             = &H00000400???
%BS_BOTTOM          = &H00000800???
%BS_VCENTER         = &H00000C00???
%BS_PUSHLIKE        = &H00001000???
%BS_MULTILINE       = &H00002000???
%BS_NOTIFY          = &H00004000???
%BS_FLAT            = &H00008000???
%BS_RIGHTBUTTON     = %BS_LEFTTEXT
'#endif /* WINVER >= 0x0400 */

'/*
' * User Button Notification Codes
' */
%BN_CLICKED        = 0&
%BN_PAINT          = 1&
%BN_HILITE         = 2&
%BN_UNHILITE       = 3&
%BN_DISABLE        = 4&
%BN_DOUBLECLICKED  = 5&
'#if(WINVER >= 0x0400)
%BN_PUSHED         = %BN_HILITE
%BN_UNPUSHED       = %BN_UNHILITE
%BN_DBLCLK         = %BN_DOUBLECLICKED
%BN_SETFOCUS       = 6&
%BN_KILLFOCUS      = 7&
'#endif /* WINVER >= 0x0400 */

'/*
' * Button Control Messages
' */
%BM_GETCHECK       = &H00F0???
%BM_SETCHECK       = &H00F1???
%BM_GETSTATE       = &H00F2???
%BM_SETSTATE       = &H00F3???
%BM_SETSTYLE       = &H00F4???
'#if(WINVER >= 0x0400)
%BM_CLICK          = &H00F5???
%BM_GETIMAGE       = &H00F6???
%BM_SETIMAGE       = &H00F7???
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0600)
%BM_SETDONTCLICK   = &H00F8???
'#endif /* WINVER >= 0x0600 */

'#if(WINVER >= 0x0400)
%BST_UNCHECKED     = &H0000&
%BST_CHECKED       = &H0001&
%BST_INDETERMINATE = &H0002&
%BST_PUSHED        = &H0004&
%BST_FOCUS         = &H0008&
'#endif /* WINVER >= 0x0400 */


'/*
' * Static Control Constants
' */
%SS_LEFT            = &H00000000???
%SS_CENTER          = &H00000001???
%SS_RIGHT           = &H00000002???
%SS_ICON            = &H00000003???
%SS_BLACKRECT       = &H00000004???
%SS_GRAYRECT        = &H00000005???
%SS_WHITERECT       = &H00000006???
%SS_BLACKFRAME      = &H00000007???
%SS_GRAYFRAME       = &H00000008???
%SS_WHITEFRAME      = &H00000009???
%SS_USERITEM        = &H0000000A???
%SS_SIMPLE          = &H0000000B???
%SS_LEFTNOWORDWRAP  = &H0000000C???
'#if(WINVER >= 0x0400)
%SS_NOWORDWRAP      = %SS_LEFTNOWORDWRAP
%SS_OWNERDRAW       = &H0000000D???
%SS_BITMAP          = &H0000000E???
%SS_ENHMETAFILE     = &H0000000F???
%SS_ETCHEDHORZ      = &H00000010???
%SS_ETCHEDVERT      = &H00000011???
%SS_ETCHEDFRAME     = &H00000012???
%SS_TYPEMASK        = &H0000001F???
'#endif /* WINVER >= 0x0400 */
'#if(WINVER >= 0x0501)
%SS_REALSIZECONTROL = &H00000040???
'#endif /* WINVER >= 0x0501 */
%SS_NOPREFIX        = &H00000080???  ' Don't do "&" character translation
'#if(WINVER >= 0x0400)
%SS_NOTIFY          = &H00000100???
%SS_CENTERIMAGE     = &H00000200???
%SS_RIGHTJUST       = &H00000400???
%SS_REALSIZEIMAGE   = &H00000800???
%SS_REALSIZE        = %SS_REALSIZEIMAGE
%SS_SUNKEN          = &H00001000???
%SS_ENDELLIPSIS     = &H00004000???
%SS_PATHELLIPSIS    = &H00008000???
%SS_WORDELLIPSIS    = &H0000C000???
%SS_ELLIPSISMASK    = &H0000C000???
'#endif /* WINVER >= 0x0400 */

'#IF NOT %DEF(%NOWINMESSAGES) ' ------------------------------------------------
'#ifndef NOWINMESSAGES
'/*
' * Static Control Mesages
' */
%STM_SETICON  = &H0170???
%STM_GETICON  = &H0171???
'#if(WINVER >= 0x0400)
%STM_SETIMAGE = &H0172???
%STM_GETIMAGE = &H0173???
%STN_CLICKED  = 0&
%STN_DBLCLK   = 1&
%STN_ENABLE   = 2&
%STN_DISABLE  = 3&
'#endif /* WINVER >= 0x0400 */
%STM_MSGMAX   = &H0174???

'#endif /* !NOWINMESSAGES */
'#ENDIF   ' #IF NOT %DEF(%NOWINMESSAGES) ' -------------------------------------

'/*
' * Dialog window class
' */
'#define WC_DIALOG       (MAKEINTATOM(0x8002))
%WC_DIALOG = &H8002???

'/*
' * Get/SetWindowWord/Long offsets for use with WC_DIALOG windows
' */
%DWL_MSGRESULT = 0&
%DWL_DLGPROC   = 4&
%DWL_USER      = 8&

'#ifdef _WIN64

'#undef DWL_MSGRESULT
'#undef DWL_DLGPROC
'#undef DWL_USER

'#endif /* _WIN64 */

'#define DWLP_MSGRESULT  0
'#define DWLP_DLGPROC    DWLP_MSGRESULT + sizeof(LRESULT)
'#define DWLP_USER       DWLP_DLGPROC + sizeof(DLGPROC)

%DWLP_MSGRESULT  = 0
%DWLP_DLGPROC    = %DWLP_MSGRESULT + 4
%DWLP_USER       = %DWLP_DLGPROC + 4

'/*
' * Dialog Manager Routines
' */

'#IF NOT %DEF(%NOMSG) '---------------------------------------------------------
'#ifndef NOMSG

DECLARE FUNCTION IsDialogMessage LIB "USER32.DLL" ALIAS "IsDialogMessageA" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYREF tagMSG _                      ' __in LPMSG lpMsg
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsDialogMessageW LIB "USER32.DLL" ALIAS "IsDialogMessageW" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYREF tagMSG _                      ' __in LPMSG lpMsg
 ) AS LONG                             ' BOOL

'#endif /* !NOMSG */
'#ENDIF   ' #IF NOT %DEF(%NOMSG) '----------------------------------------------

DECLARE FUNCTION MapDialogRect LIB "USER32.DLL" ALIAS "MapDialogRect" ( _
   BYVAL DWORD  _                      ' __in HWND hDlg
 , BYREF RECT _                        ' __inout LPRECT lpRect
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DlgDirList LIB "USER32.DLL" ALIAS "DlgDirListA" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYREF ASCIIZ _                      ' __inout LPSTR lpPathSpec
 , BYVAL LONG _                        ' __in int nIDListBox
 , BYVAL LONG _                        ' __in int nIDStaticPath
 , BYVAL DWORD _                       ' __in UINT uFileType
 ) AS LONG                             ' int

DECLARE FUNCTION DlgDirListW LIB "USER32.DLL" ALIAS "DlgDirListW" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL DWORD _                       ' __inout LPWSTR lpPathSpec
 , BYVAL LONG _                        ' __in int nIDListBox
 , BYVAL LONG _                        ' __in int nIDStaticPath
 , BYVAL DWORD _                       ' __in UINT uFileType
 ) AS LONG                             ' int

'/*
' * DlgDirList, DlgDirListComboBox flags values
' */
%DDL_READWRITE = &H0000???
%DDL_READONLY  = &H0001???
%DDL_HIDDEN    = &H0002???
%DDL_SYSTEM    = &H0004???
%DDL_DIRECTORY = &H0010???
%DDL_ARCHIVE   = &H0020???

%DDL_POSTMSGS  = &H2000???
%DDL_DRIVES    = &H4000???
%DDL_EXCLUSIVE = &H8000???

DECLARE FUNCTION DlgDirSelectEx LIB "USER32.DLL" ALIAS "DlgDirSelectExA" ( _
   BYVAL DWORD _                       ' __in HWND hwndDlg
 , BYREF ASCIIZ  _                     ' __out_ecount(chCount) LPSTR lpString
 , BYVAL LONG _                        ' __in int chCount
 , BYVAL LONG _                        ' __in int idListBox
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DlgDirSelectExW LIB "USER32.DLL" ALIAS "DlgDirSelectExW" ( _
   BYVAL DWORD _                       ' __in HWND hwndDlg
 , BYVAL DWORD _                       ' __out_ecount(chCount) LPWSTR lpString
 , BYVAL LONG _                        ' __in int chCount
 , BYVAL LONG _                        ' __in int idListBox
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DlgDirListComboBox LIB "USER32.DLL" ALIAS "DlgDirListComboBoxA" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYREF ASCIIZ _                      ' __inout LPSTR lpPathSpec
 , BYVAL LONG _                        ' __in int nIDComboBox
 , BYVAL LONG _                        ' __in int nIDStaticPath
 , BYVAL DWORD _                       ' __in UINT uFiletype
 ) AS LONG                             ' int

DECLARE FUNCTION DlgDirListComboBoxW LIB "USER32.DLL" ALIAS "DlgDirListComboBoxW" ( _
   BYVAL DWORD _                       ' __in HWND hDlg
 , BYVAL DWORD _                       ' __inout LPWSTR lpPathSpec
 , BYVAL LONG _                        ' __in int nIDComboBox
 , BYVAL LONG _                        ' __in int nIDStaticPath
 , BYVAL DWORD _                       ' __in UINT uFiletype
 ) AS LONG                             ' int

DECLARE FUNCTION DlgDirSelectComboBoxEx LIB "USER32.DLL" ALIAS "DlgDirSelectComboBoxExA" ( _
   BYVAL DWORD _                       ' __in HWND hwndDlg
 , BYREF ASCIIZ _                      ' __out_ecount(cchOut) LPSTR lpString
 , BYVAL LONG _                        ' __in int cchOut
 , BYVAL LONG _                        ' __in int idComboBox
 ) AS LONG                             ' BOOL

DECLARE FUNCTION DlgDirSelectComboBoxExW LIB "USER32.DLL" ALIAS "DlgDirSelectComboBoxExW" ( _
   BYVAL DWORD _                       ' __in HWND hwndDlg
 , BYVAL DWORD _                       ' __out_ecount(cchOut) LPWSTR lpString
 , BYVAL LONG _                        ' __in int cchOut
 , BYVAL LONG _                        ' __in int idComboBox
 ) AS LONG                             ' BOOL

'/*
' * Dialog Styles
' */
%DS_ABSALIGN      = &H01???
%DS_SYSMODAL      = &H02???
%DS_LOCALEDIT     = &H20???   ' Edit items get Local storage.
%DS_SETFONT       = &H40???   ' User specified font for Dlg controls
%DS_MODALFRAME    = &H80???   ' Can be combined with WS_CAPTION
%DS_NOIDLEMSG     = &H100???  ' WM_ENTERIDLE message will not be sent
%DS_SETFOREGROUND = &H200???  ' not in win3.1
'#if(WINVER >= 0x0400)
%DS_3DLOOK        = &H0004???
%DS_FIXEDSYS      = &H0008???
%DS_NOFAILCREATE  = &H0010???
%DS_CONTROL       = &H0400???
%DS_CENTER        = &H0800???
%DS_CENTERMOUSE   = &H1000???
%DS_CONTEXTHELP   = &H2000???

%DS_SHELLFONT     = %DS_SETFONT OR %DS_FIXEDSYS
'#endif /* WINVER >= 0x0400 */

'#if(_WIN32_WCE >= 0x0500)
%DS_USEPIXELS     = &H8000???
'#endif

%DM_GETDEFID      = %WM_USER + 0
%DM_SETDEFID      = %WM_USER + 1

'#if(WINVER >= 0x0400)
%DM_REPOSITION    = %WM_USER + 2
'#endif /* WINVER >= 0x0400 */
'/*
' * Returned in HIWORD() of DM_GETDEFID result if msg is supported
' */
%DC_HASDEFID      = &H534B??

'/*
' * Dialog Codes
' */
%DLGC_WANTARROWS      = &H0001&    ' Control wants arrow keys
%DLGC_WANTTAB         = &H0002&    ' Control wants tab keys
%DLGC_WANTALLKEYS     = &H0004&    ' Control wants all keys
%DLGC_WANTMESSAGE     = &H0004&    ' Pass message to control
%DLGC_HASSETSEL       = &H0008&    ' Understands EM_SETSEL message
%DLGC_DEFPUSHBUTTON   = &H0010&    ' Default pushbutton
%DLGC_UNDEFPUSHBUTTON = &H0020&    ' Non-default pushbutton
%DLGC_RADIOBUTTON     = &H0040&    ' Radio button
%DLGC_WANTCHARS       = &H0080&    ' Want WM_CHAR messages
%DLGC_STATIC          = &H0100&    ' Static item: don't include
%DLGC_BUTTON          = &H2000&    ' Button item: can be checked

%LB_CTLCODE  = 0&

'/*
' * Listbox Return Values
' */
%LB_OKAY     = 0&
%LB_ERR      = -1&
%LB_ERRSPACE = -2&

'/*
'**  The idStaticPath parameter to DlgDirList can have the following values
'**  ORed if the list box should show other details of the files along with
'**  the name of the files;
'*/
'/* all other details also will be returned */


'/*
' * Listbox Notification Codes
' */
%LBN_ERRSPACE  = -2&
%LBN_SELCHANGE = 1&
%LBN_DBLCLK    = 2&
%LBN_SELCANCEL = 3&
%LBN_SETFOCUS  = 4&
%LBN_KILLFOCUS = 5&

'#IF NOT %DEF(%NOWINMESSAGES) ' ------------------------------------------------
'#ifndef NOWINMESSAGES

'/*
' * Listbox messages
' */
%LB_ADDSTRING           = &H180???
%LB_INSERTSTRING        = &H181???
%LB_DELETESTRING        = &H182???
%LB_SELITEMRANGEEX      = &H183???
%LB_RESETCONTENT        = &H184???
%LB_SETSEL              = &H185???
%LB_SETCURSEL           = &H186???
%LB_GETSEL              = &H187???
%LB_GETCURSEL           = &H188???
%LB_GETTEXT             = &H189???
%LB_GETTEXTLEN          = &H18A???
%LB_GETCOUNT            = &H18B???
%LB_SELECTSTRING        = &H18C???
%LB_DIR                 = &H18D???
%LB_GETTOPINDEX         = &H18E???
%LB_FINDSTRING          = &H18F???
%LB_GETSELCOUNT         = &H190???
%LB_GETSELITEMS         = &H191???
%LB_SETTABSTOPS         = &H192???
%LB_GETHORIZONTALEXTENT = &H193???
%LB_SETHORIZONTALEXTENT = &H194???
%LB_SETCOLUMNWIDTH      = &H195???
%LB_ADDFILE             = &H196???
%LB_SETTOPINDEX         = &H197???
%LB_GETITEMRECT         = &H198???
%LB_GETITEMDATA         = &H199???
%LB_SETITEMDATA         = &H19A???
%LB_SELITEMRANGE        = &H19B???
%LB_SETANCHORINDEX      = &H19C???
%LB_GETANCHORINDEX      = &H19D???
%LB_SETCARETINDEX       = &H19E???
%LB_GETCARETINDEX       = &H19F???
%LB_SETITEMHEIGHT       = &H1A0???
%LB_GETITEMHEIGHT       = &H1A1???
%LB_FINDSTRINGEXACT     = &H1A2???
%LB_SETLOCALE           = &H1A5???
%LB_GETLOCALE           = &H1A6???
%LB_SETCOUNT            = &H1A7???
'#if(WINVER >= 0x0400)
%LB_INITSTORAGE         = &H1A8???
%LB_ITEMFROMPOINT       = &H1A9???
'#endif /* WINVER >= 0x0400 */
'#if(_WIN32_WCE >= 0x0400)
%LB_MULTIPLEADDSTRING   = &H1B1???
'#endif

'#if(_WIN32_WINNT >= 0x0501)
%LB_GETLISTBOXINFO      = &H1B2???
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(_WIN32_WINNT >= 0x0501)
'#define LB_MSGMAX               0x01B3
'#elif(_WIN32_WCE >= 0x0400)
'#define LB_MSGMAX               0x01B1
'#elif(WINVER >= 0x0400)
'#define LB_MSGMAX               0x01B0
'#else
'#define LB_MSGMAX               0x01A8
'#endif

%LB_MSGMAX             = &H1B3???  ' depends on Windows version

'#endif /* !NOWINMESSAGES */
'#ENDIF   ' #IF NOT %DEF(%NOWINMESSAGES) ' -------------------------------------

'#IF NOT %DEF(%NOWINSTYLES) ' --------------------------------------------------
'#ifndef NOWINSTYLES

'/*
' * Listbox Styles
' */
%LBS_NOTIFY            = &H0001???
%LBS_SORT              = &H0002???
%LBS_NOREDRAW          = &H0004???
%LBS_MULTIPLESEL       = &H0008???
%LBS_OWNERDRAWFIXED    = &H0010???
%LBS_OWNERDRAWVARIABLE = &H0020???
%LBS_HASSTRINGS        = &H0040???
%LBS_USETABSTOPS       = &H0080???
%LBS_NOINTEGRALHEIGHT  = &H0100???
%LBS_MULTICOLUMN       = &H0200???
%LBS_WANTKEYBOARDINPUT = &H0400???
%LBS_EXTENDEDSEL       = &H0800???
%LBS_DISABLENOSCROLL   = &H1000???
%LBS_NODATA            = &H2000???
'#if(WINVER >= 0x0400)
%LBS_NOSEL             = &H4000???
'#endif /* WINVER >= 0x0400 */
%LBS_COMBOBOX          = &H8000???
%LBS_STANDARD          = %LBS_NOTIFY OR %LBS_SORT OR %WS_VSCROLL OR %WS_BORDER

'#endif /* !NOWINSTYLES */
'#ENDIF   ' #IF NOT %DEF(%NOWINSTYLES) ' ---------------------------------------


'/*
' * Combo Box return Values
' */
%CB_OKAY     = 0&
%CB_ERR      = -1&
%CB_ERRSPACE = -2&

'/*
' * Combo Box Notification Codes
' */
%CBN_ERRSPACE     = -1&
%CBN_SELCHANGE    = 1&
%CBN_DBLCLK       = 2&
%CBN_SETFOCUS     = 3&
%CBN_KILLFOCUS    = 4&
%CBN_EDITCHANGE   = 5&
%CBN_EDITUPDATE   = 6&
%CBN_DROPDOWN     = 7&
%CBN_CLOSEUP      = 8&
%CBN_SELENDOK     = 9&
%CBN_SELENDCANCEL = 10&
%CBN_SELCANCEL    = %CBN_SELENDCANCEL

'#IF NOT %DEF(%NOWINSTYLES) ' --------------------------------------------------
'#ifndef NOWINSTYLES

'/*
' * Combo Box styles
' */
%CBS_SIMPLE            = &H0001???
%CBS_DROPDOWN          = &H0002???
%CBS_DROPDOWNLIST      = &H0003???
%CBS_OWNERDRAWFIXED    = &H0010???
%CBS_OWNERDRAWVARIABLE = &H0020???
%CBS_AUTOHSCROLL       = &H0040???
%CBS_OEMCONVERT        = &H0080???
%CBS_SORT              = &H0100???
%CBS_HASSTRINGS        = &H0200???
%CBS_NOINTEGRALHEIGHT  = &H0400???
%CBS_DISABLENOSCROLL   = &H0800???
'#if(WINVER >= 0x0400)
%CBS_UPPERCASE         = &H2000???
%CBS_LOWERCASE         = &H4000???
'#endif /* WINVER >= 0x0400 */

'#endif  /* !NOWINSTYLES */
'#ENDIF   ' #IF NOT %DEF(%NOWINSTYLES) ' ---------------------------------------


'/*
' * Combo Box messages
' */
'#IF NOT %DEF(%NOWINMESSAGES) ' ------------------------------------------------
'#ifndef NOWINMESSAGES

%CB_GETEDITSEL            = &H0140???
%CB_LIMITTEXT             = &H0141???
%CB_SETEDITSEL            = &H0142???
%CB_ADDSTRING             = &H0143???
%CB_DELETESTRING          = &H0144???
%CB_DIR                   = &H0145???
%CB_GETCOUNT              = &H0146???
%CB_GETCURSEL             = &H0147???
%CB_GETLBTEXT             = &H0148???
%CB_GETLBTEXTLEN          = &H0149???
%CB_INSERTSTRING          = &H014A???
%CB_RESETCONTENT          = &H014B???
%CB_FINDSTRING            = &H014C???
%CB_SELECTSTRING          = &H014D???
%CB_SETCURSEL             = &H014E???
%CB_SHOWDROPDOWN          = &H014F???
%CB_GETITEMDATA           = &H0150???
%CB_SETITEMDATA           = &H0151???
%CB_GETDROPPEDCONTROLRECT = &H0152???
%CB_SETITEMHEIGHT         = &H0153???
%CB_GETITEMHEIGHT         = &H0154???
%CB_SETEXTENDEDUI         = &H0155???
%CB_GETEXTENDEDUI         = &H0156???
%CB_GETDROPPEDSTATE       = &H0157???
%CB_FINDSTRINGEXACT       = &H0158???
%CB_SETLOCALE             = &H0159???
%CB_GETLOCALE             = &H015A???
'#if(WINVER >= 0x0400)
%CB_GETTOPINDEX           = &H015B???
%CB_SETTOPINDEX           = &H015C???
%CB_GETHORIZONTALEXTENT   = &H015D???
%CB_SETHORIZONTALEXTENT   = &H015E???
%CB_GETDROPPEDWIDTH       = &H015F???
%CB_SETDROPPEDWIDTH       = &H0160???
%CB_INITSTORAGE           = &H0161???
'#if(_WIN32_WCE >= 0x0400)
%CB_MULTIPLEADDSTRING     = &H0163???
'#endif
'#endif /* WINVER >= 0x0400 */

'#if(_WIN32_WINNT >= 0x0501)
%CB_GETCOMBOBOXINFO       = &H0164???
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(_WIN32_WINNT >= 0x0501)
'#define CB_MSGMAX                   0x0165
'#elif(_WIN32_WCE >= 0x0400)
'#define CB_MSGMAX                   0x0163
'#elif(WINVER >= 0x0400)
'#define CB_MSGMAX                   0x0162
'#else
'#define CB_MSGMAX                   0x015B
'#endif

%CB_MSGMAX                = &H0165???  ' depends on Windows version

'#endif  /* !NOWINMESSAGES */
'#ENDIF   '   #IF NOT %DEF(%NOWINMESSAGES) ' -----------------------------------

'#IF NOT %DEF(%NOWINSTYLES) ' --------------------------------------------------
'#ifndef NOWINSTYLES

'/*
' * Scroll Bar Styles
' */
%SBS_HORZ                    = &H0000???
%SBS_VERT                    = &H0001???
%SBS_TOPALIGN                = &H0002???
%SBS_LEFTALIGN               = &H0002???
%SBS_BOTTOMALIGN             = &H0004???
%SBS_RIGHTALIGN              = &H0004???
%SBS_SIZEBOXTOPLEFTALIGN     = &H0002???
%SBS_SIZEBOXBOTTOMRIGHTALIGN = &H0004???
%SBS_SIZEBOX                 = &H0008???
'#if(WINVER >= 0x0400)
%SBS_SIZEGRIP                = &H0010???
'#endif /* WINVER >= 0x0400 */

'#endif /* !NOWINSTYLES */
'#ENDIF   '   #IF NOT %DEF(%NOWINSTYLES) ' -------------------------------------

'/*
' * Scroll bar messages
' */
'#ifndef NOWINMESSAGES
'#IF NOT %DEF(%NOWINMESSAGES) ' ------------------------------------------------

%SBM_SETPOS           = &H0E0??? ' not in win3.1
%SBM_GETPOS           = &H0E1??? ' not in win3.1
%SBM_SETRANGE         = &H0E2??? ' not in win3.1
%SBM_SETRANGEREDRAW   = &H0E6??? ' not in win3.1
%SBM_GETRANGE         = &H0E3??? ' not in win3.1
%SBM_ENABLE_ARROWS    = &H0E4??? ' not in win3.1
'#if(WINVER >= 0x0400)
%SBM_SETSCROLLINFO    = &H0E9???
%SBM_GETSCROLLINFO    = &H0EA???
'#endif /* WINVER >= 0x0400 */

'#if(_WIN32_WINNT >= 0x0501)
%SBM_GETSCROLLBARINFO = &H0EB???
'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(WINVER >= 0x0400)
%SIF_RANGE            = &H0001???
%SIF_PAGE             = &H0002???
%SIF_POS              = &H0004???
%SIF_DISABLENOSCROLL  = &H0008???
%SIF_TRACKPOS         = &H0010???
%SIF_ALL              = %SIF_RANGE OR %SIF_PAGE OR %SIF_POS OR %SIF_TRACKPOS

TYPE SCROLLINFO
   cbSize    AS DWORD   ' UINT    cbSize
   fMask     AS DWORD   ' UINT    fMask
   nMin      AS LONG    ' int     nMin
   nMax      AS LONG    ' int     nMax
   nPage     AS DWORD   ' UINT    nPage
   nPos      AS LONG    ' int     nPos
   nTrackPos AS LONG    ' int     nTrackPos
END TYPE


DECLARE FUNCTION SetScrollInfo LIB "USER32.DLL" ALIAS "SetScrollInfo" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL LONG _                        ' __in int nBar
 , BYREF SCROLLINFO _                  ' __in LPCSCROLLINFO lpsi
 , BYVAL LONG _                        ' __in BOOL redraw
 ) AS LONG                             ' int

DECLARE FUNCTION GetScrollInfo LIB "USER32.DLL" ALIAS "GetScrollInfo" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL LONG _                        ' __in int nBar
 , BYREF SCROLLINFO _                  ' __inout LPSCROLLINFO lpsi
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0400 */
'#endif /* !NOWINMESSAGES */
'#ENDIF   ' #IF NOT %DEF(%NOWINMESSAGES) ' -------------------------------------
'#endif /* !NOCTLMGR */
'#ENDIF   ' #IF NOT %DEF(%NOCTLMGR) ' ------------------------------------------

'#IF NOT %DEF(%NOMDI) ' --------------------------------------------------------
'#ifndef NOMDI

'/*
' * MDI client style bits
' */
%MDIS_ALLCHILDSTYLES = &H0001???

'/*
' * wParam Flags for WM_MDITILE and WM_MDICASCADE messages.
' */
%MDITILE_VERTICAL     = &H0000???
%MDITILE_HORIZONTAL   = &H0001???
%MDITILE_SKIPDISABLED = &H0002???
'#if(_WIN32_WINNT >= 0x0500)
%MDITILE_ZORDER       = &H0004???
'#endif /* _WIN32_WINNT >= 0x0500 */

TYPE MDICREATESTRUCTA
   szClass AS ASCIIZ PTR   ' LPCSTR  szClass
   szTitle AS ASCIIZ PTR   ' LPCSTR  szTitle
   hOwner  AS DWORD        ' HANDLE  hOwner
   x       AS LONG         ' int     x
   y       AS LONG         ' int     y
   cx      AS LONG         ' int     cx
   cy      AS LONG         ' int     cy
   style   AS DWORD        ' DWORD   style
   lParam  AS LONG         ' LPARAM  lParam
END TYPE

TYPE MDICREATESTRUCTW
   szClass AS WORD PTR     ' LPCWSTR szClass
   szTitle AS WORD PTR     ' LPCWSTR szTitle
   hOwner  AS DWORD        ' HANDLE  hOwner
   x       AS LONG         ' int     x
   y       AS LONG         ' int     y
   cx      AS LONG         ' int     cx
   cy      AS LONG         ' int     cy
   style   AS DWORD        ' DWORD   style
   lParam  AS LONG         ' LPARAM  lParam
END TYPE

MACRO MDICREATESTRUCT = MDICREATESTRUCTA

TYPE CLIENTCREATESTRUCT
   hWindowMenu  AS LONG    ' HANDLE hWindowMenu
   idFirstChild AS DWORD   ' UINT idFirstChild
END TYPE

DECLARE FUNCTION DefFrameProc LIB "USER32.DLL" ALIAS "DefFrameProcA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HWND hWndMDIClient
 , BYVAL DWORD _                       ' __in UINT uMsg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION DefFrameProcW LIB "USER32.DLL" ALIAS "DefFrameProcW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in_opt HWND hWndMDIClient
 , BYVAL DWORD _                       ' __in UINT uMsg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION DefMDIChildProc LIB "USER32.DLL" ALIAS "DefMDIChildProcA" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT uMsg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam)
 ) AS LONG                             ' LRESULT

DECLARE FUNCTION DefMDIChildProcW LIB "USER32.DLL" ALIAS "DefMDIChildProcW" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in UINT uMsg
 , BYVAL DWORD _                       ' __in WPARAM wParam
 , BYVAL LONG _                        ' __in LPARAM lParam)
 ) AS LONG                             ' LRESULT

'#IF NOT %DEF(%NOMSG) '---------------------------------------------------------
'#ifndef NOMSG

DECLARE FUNCTION TranslateMDISysAccel LIB "USER32.DLL" ALIAS "TranslateMDISysAccel" ( _
   BYVAL DWORD _                       ' __in HWND hWndClient
 , BYREF tagMSG _                      ' __in LPMSG lpMsg
 ) AS LONG                             ' BOOL

'#endif /* !NOMSG */
'#ENDIF   ' #IF NOT %DEF(%NOMSG) '----------------------------------------------

DECLARE FUNCTION ArrangeIconicWindows LIB "USER32.DLL" ALIAS "ArrangeIconicWindows" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 ) AS DWORD                            ' UINT

DECLARE FUNCTION CreateMDIWindow LIB "USER32.DLL" ALIAS "CreateMDIWindowA" ( _
   BYREF ASCIIZ _                      ' __in LPCSTR lpClassName
 , BYREF ASCIIZ _                      ' __in LPCSTR lpWindowName
 , BYVAL DWORD _                       ' __in DWORD dwStyle
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS DWORD                            ' HWND

DECLARE FUNCTION CreateMDIWindowW LIB "USER32.DLL" ALIAS "CreateMDIWindowW" ( _
   BYVAL DWORD _                       ' __in LPCWSTR lpClassName
 , BYVAL DWORD _                       ' __in LPCWSTR lpWindowName
 , BYVAL DWORD _                       ' __in DWORD dwStyle
 , BYVAL LONG _                        ' __in int X
 , BYVAL LONG _                        ' __in int Y
 , BYVAL LONG _                        ' __in int nWidth
 , BYVAL LONG _                        ' __in int nHeight
 , BYVAL DWORD _                       ' __in_opt HWND hWndParent
 , BYVAL DWORD _                       ' __in_opt HINSTANCE hInstance
 , BYVAL LONG _                        ' __in LPARAM lParam
 ) AS DWORD                            ' HWND

'#if(WINVER >= 0x0400)

DECLARE FUNCTION TileWindows LIB "USER32.DLL" ALIAS "TileWindows" ( _
   BYVAL DWORD _                       ' __in_opt HWND hwndParent
 , BYVAL DWORD _                       ' __in UINT wHow
 , BYREF RECT _                        ' __in_opt CONST RECT * lpRect
 , BYVAL DWORD _                       ' __in UINT cKids
 , BYREF DWORD _                       ' __in_ecount_opt(cKids) const HWND FAR * lpKids
 ) AS WORD                             ' WORD

DECLARE FUNCTION CascadeWindows LIB "USER32.DLL" ALIAS "CascadeWindows" ( _
   BYVAL DWORD _                       ' __in_opt HWND hwndParent
 , BYVAL DWORD _                       ' __in UINT wHow
 , BYREF RECT _                        ' __in_opt CONST RECT * lpRect
 , BYVAL DWORD _                       ' __in UINT cKids
 , BYREF DWORD _                       ' __in_ecount_opt(cKids) const HWND FAR * lpKids
 ) AS WORD                             ' WORD

'#endif /* WINVER >= 0x0400 */
'#endif /* !NOMDI */
'#ENDIF   ' #IF NOT %DEF(%NOMDI) ' ---------------------------------------------

'#endif /* !NOUSER */
'#ENDIF   ' #IF NOT %DEF(%NOUSER) ' --------------------------------------------

'/****** Help support ********************************************************/

'#IF NOT %DEF(%NOHELP) ' -------------------------------------------------------
'#ifndef NOHELP

'typedef DWORD HELPPOLY;

TYPE MULTIKEYHELPA
   mkSize      AS DWORD          ' DWORD  mkSize
   mkKeylist   AS STRING * 1     ' CHAR   mkKeylist
   szKeyphrase AS ASCIIZ * 253   ' CHAR   szKeyphrase[1]  ' ' arbitrary string length: change as needed
END TYPE

TYPE MULTIKEYHELPW
   mkSize      AS DWORD             ' DWORD  mkSize
   mkKeylist   AS STRING * 1 * 2    ' WCHAR  mkKeylist
   szKeyphrase AS STRING * 253 * 2  ' WCHAR  szKeyphrase[1]  ' ' arbitrary string length: change as needed
END TYPE

MACRO MULTIKEYHELP = MULTIKEYHELPA

TYPE HELPWININFOA
   wStructSize AS LONG        ' int  wStructSize
   x           AS LONG        ' int  x
   y           AS LONG        ' int  y
   dx          AS LONG        ' int  dx
   dy          AS LONG        ' int  dy
   wMax        AS LONG        ' int  wMax
   rgchMember  AS ASCIIZ * 2  ' CHAR   rgchMember[2]
END TYPE

TYPE HELPWININFOW
   wStructSize AS LONG           ' int  wStructSize
   x           AS LONG           ' int  x
   y           AS LONG           ' int  y
   dx          AS LONG           ' int  dx
   dy          AS LONG           ' int  dy
   wMax        AS LONG           ' int  wMax
   rgchMember  AS ASCIIZ * 2 * 2 ' CHAR   rgchMember[2]
END TYPE

MACRO HELPWININFO = HELPWININFOA

'/*
' * Commands to pass to WinHelp()
' */
%HELP_CONTEXT      = &H0001???    ' Display topic in ulTopic
%HELP_QUIT         = &H0002???    ' Terminate help
%HELP_INDEX        = &H0003???    ' Display index
%HELP_CONTENTS     = &H0003???
%HELP_HELPONHELP   = &H0004???    ' Display help on using help
%HELP_SETINDEX     = &H0005???    ' Set current Index for multi index help
%HELP_SETCONTENTS  = &H0005???
%HELP_CONTEXTPOPUP = &H0008???
%HELP_FORCEFILE    = &H0009???
%HELP_KEY          = &H0101???    ' Display topic for keyword in offabData
%HELP_COMMAND      = &H0102???
%HELP_PARTIALKEY   = &H0105???
%HELP_MULTIKEY     = &H0201???
%HELP_SETWINPOS    = &H0203???
'#if(WINVER >= 0x0400)
%HELP_CONTEXTMENU  = &H000a???
%HELP_FINDER       = &H000b???
%HELP_WM_HELP      = &H000c???
%HELP_SETPOPUP_POS = &H000d???

%HELP_TCARD              = &H8000???
%HELP_TCARD_DATA         = &H0010???
%HELP_TCARD_OTHER_CALLER = &H0011???

'// These are in winhelp.h in Win95.
%IDH_NO_HELP             = 28440???
%IDH_MISSING_CONTEXT     = 28441??? ' Control doesn't have matching help context
%IDH_GENERIC_HELP_BUTTON = 28442??? ' Property sheet help button
%IDH_OK                  = 28443???
%IDH_CANCEL              = 28444???
%IDH_HELP                = 28445???

'#endif /* WINVER >= 0x0400 */

DECLARE FUNCTION WinHelp LIB "USER32.DLL" ALIAS "WinHelpA" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWndMain
 , BYREF ASCIIZ _                      ' __in_opt LPCSTR lpszHelp
 , BYVAL DWORD _                       ' __in UINT uCommand
 , BYVAL DWORD _                       ' __in ULONG_PTR dwData
 ) AS LONG                             ' BOOL

DECLARE FUNCTION WinHelpW LIB "USER32.DLL" ALIAS "WinHelpW" ( _
   BYVAL DWORD _                       ' __in_opt HWND hWndMain
 , BYVAL DWORD _                       ' __in_opt LPCWSTR lpszHelp
 , BYVAL DWORD _                       ' __in UINT uCommand
 , BYVAL DWORD _                       ' __in ULONG_PTR dwData
 ) AS LONG                             ' BOOL

'#endif /* !NOHELP */
'#ENDIF   ' #IF NOT %DEF(%NOHELP) ' --------------------------------------------

'#if(WINVER >= 0x0500)

%GR_GDIOBJECTS  = 0&  ' Count of GDI objects
%GR_USEROBJECTS = 1&  ' Count of USER objects

DECLARE FUNCTION GetGuiResources LIB "USER32.DLL" ALIAS "GetGuiResources" ( _
   BYVAL DWORD _                       ' __in HANDLE hProcess
 , BYVAL DWORD _                       ' __in DWORD uiFlags)
 ) AS DWORD                            ' DWORD

'#endif /* WINVER >= 0x0500 */


'#IF NOT %DEF(%NOSYSPARAMSINFO) ' ----------------------------------------------
'#ifndef NOSYSPARAMSINFO

'/*
' * Parameter for SystemParametersInfo()
' */
%SPI_GETBEEP                 = &H0001???
%SPI_SETBEEP                 = &H0002???
%SPI_GETMOUSE                = &H0003???
%SPI_SETMOUSE                = &H0004???
%SPI_GETBORDER               = &H0005???
%SPI_SETBORDER               = &H0006???
%SPI_GETKEYBOARDSPEED        = &H000A???
%SPI_SETKEYBOARDSPEED        = &H000B???
%SPI_LANGDRIVER              = &H000C???
%SPI_ICONHORIZONTALSPACING   = &H000D???
%SPI_GETSCREENSAVETIMEOUT    = &H000E???
%SPI_SETSCREENSAVETIMEOUT    = &H000F???
%SPI_GETSCREENSAVEACTIVE     = &H0010???
%SPI_SETSCREENSAVEACTIVE     = &H0011???
%SPI_GETGRIDGRANULARITY      = &H0012???
%SPI_SETGRIDGRANULARITY      = &H0013???
%SPI_SETDESKWALLPAPER        = &H0014???
%SPI_SETDESKPATTERN          = &H0015???
%SPI_GETKEYBOARDDELAY        = &H0016???
%SPI_SETKEYBOARDDELAY        = &H0017???
%SPI_ICONVERTICALSPACING     = &H0018???
%SPI_GETICONTITLEWRAP        = &H0019???
%SPI_SETICONTITLEWRAP        = &H001A???
%SPI_GETMENUDROPALIGNMENT    = &H001B???
%SPI_SETMENUDROPALIGNMENT    = &H001C???
%SPI_SETDOUBLECLKWIDTH       = &H001D???
%SPI_SETDOUBLECLKHEIGHT      = &H001E???
%SPI_GETICONTITLELOGFONT     = &H001F???
%SPI_SETDOUBLECLICKTIME      = &H0020???
%SPI_SETMOUSEBUTTONSWAP      = &H0021???
%SPI_SETICONTITLELOGFONT     = &H0022???
%SPI_GETFASTTASKSWITCH       = &H0023???
%SPI_SETFASTTASKSWITCH       = &H0024???
'#if(WINVER >= = &H0400)
%SPI_SETDRAGFULLWINDOWS      = &H0025???
%SPI_GETDRAGFULLWINDOWS      = &H0026???
%SPI_GETNONCLIENTMETRICS     = &H0029???
%SPI_SETNONCLIENTMETRICS     = &H002A???
%SPI_GETMINIMIZEDMETRICS     = &H002B???
%SPI_SETMINIMIZEDMETRICS     = &H002C???
%SPI_GETICONMETRICS          = &H002D???
%SPI_SETICONMETRICS          = &H002E???
%SPI_SETWORKAREA             = &H002F???
%SPI_GETWORKAREA             = &H0030???
%SPI_SETPENWINDOWS           = &H0031???

%SPI_GETHIGHCONTRAST         = &H0042???
%SPI_SETHIGHCONTRAST         = &H0043???
%SPI_GETKEYBOARDPREF         = &H0044???
%SPI_SETKEYBOARDPREF         = &H0045???
%SPI_GETSCREENREADER         = &H0046???
%SPI_SETSCREENREADER         = &H0047???
%SPI_GETANIMATION            = &H0048???
%SPI_SETANIMATION            = &H0049???
%SPI_GETFONTSMOOTHING        = &H004A???
%SPI_SETFONTSMOOTHING        = &H004B???
%SPI_SETDRAGWIDTH            = &H004C???
%SPI_SETDRAGHEIGHT           = &H004D???
%SPI_SETHANDHELD             = &H004E???
%SPI_GETLOWPOWERTIMEOUT      = &H004F???
%SPI_GETPOWEROFFTIMEOUT      = &H0050???
%SPI_SETLOWPOWERTIMEOUT      = &H0051???
%SPI_SETPOWEROFFTIMEOUT      = &H0052???
%SPI_GETLOWPOWERACTIVE       = &H0053???
%SPI_GETPOWEROFFACTIVE       = &H0054???
%SPI_SETLOWPOWERACTIVE       = &H0055???
%SPI_SETPOWEROFFACTIVE       = &H0056???
%SPI_SETCURSORS              = &H0057???
%SPI_SETICONS                = &H0058???
%SPI_GETDEFAULTINPUTLANG     = &H0059???
%SPI_SETDEFAULTINPUTLANG     = &H005A???
%SPI_SETLANGTOGGLE           = &H005B???
%SPI_GETWINDOWSEXTENSION     = &H005C???
%SPI_SETMOUSETRAILS          = &H005D???
%SPI_GETMOUSETRAILS          = &H005E???
%SPI_SETSCREENSAVERRUNNING   = &H0061???
%SPI_SCREENSAVERRUNNING      = %SPI_SETSCREENSAVERRUNNING
'#endif /* WINVER >= = &H0400 */
%SPI_GETFILTERKEYS           = &H0032???
%SPI_SETFILTERKEYS           = &H0033???
%SPI_GETTOGGLEKEYS           = &H0034???
%SPI_SETTOGGLEKEYS           = &H0035???
%SPI_GETMOUSEKEYS            = &H0036???
%SPI_SETMOUSEKEYS            = &H0037???
%SPI_GETSHOWSOUNDS           = &H0038???
%SPI_SETSHOWSOUNDS           = &H0039???
%SPI_GETSTICKYKEYS           = &H003A???
%SPI_SETSTICKYKEYS           = &H003B???
%SPI_GETACCESSTIMEOUT        = &H003C???
%SPI_SETACCESSTIMEOUT        = &H003D???
'#if(WINVER >= = &H0400)
%SPI_GETSERIALKEYS           = &H003E???
%SPI_SETSERIALKEYS           = &H003F???
'#endif /* WINVER >= = &H0400 */
%SPI_GETSOUNDSENTRY          = &H0040???
%SPI_SETSOUNDSENTRY          = &H0041???
'#if(_WIN32_WINNT >= = &H0400)
%SPI_GETSNAPTODEFBUTTON      = &H005F???
%SPI_SETSNAPTODEFBUTTON      = &H0060???
'#endif /* _WIN32_WINNT >= = &H0400 */
'#if (_WIN32_WINNT >= = &H0400) || (_WIN32_WINDOWS > = &H0400)
%SPI_GETMOUSEHOVERWIDTH      = &H0062???
%SPI_SETMOUSEHOVERWIDTH      = &H0063???
%SPI_GETMOUSEHOVERHEIGHT     = &H0064???
%SPI_SETMOUSEHOVERHEIGHT     = &H0065???
%SPI_GETMOUSEHOVERTIME       = &H0066???
%SPI_SETMOUSEHOVERTIME       = &H0067???
%SPI_GETWHEELSCROLLLINES     = &H0068???
%SPI_SETWHEELSCROLLLINES     = &H0069???
%SPI_GETMENUSHOWDELAY        = &H006A???
%SPI_SETMENUSHOWDELAY        = &H006B???

'#if (_WIN32_WINNT >= 0x0600)
%SPI_GETWHEELSCROLLCHARS     = &H006C??
%SPI_SETWHEELSCROLLCHARS     = &H006D??
'#endif

%SPI_GETSHOWIMEUI            = &H006E???
%SPI_SETSHOWIMEUI            = &H006F???
'#endif

'#if(WINVER >= 0x0500)
%SPI_GETMOUSESPEED           = &H0070???
%SPI_SETMOUSESPEED           = &H0071???
%SPI_GETSCREENSAVERRUNNING   = &H0072???
%SPI_GETDESKWALLPAPER        = &H0073???
'#endif /* WINVER >= 0x0500 */

'#if(WINVER >= 0x0600)
%SPI_GETAUDIODESCRIPTION     = &H0074???
%SPI_SETAUDIODESCRIPTION     = &H0075???

%SPI_GETSCREENSAVESECURE     = &H0076???
%SPI_SETSCREENSAVESECURE     = &H0077???
'#endif /* WINVER >= 0x0600 */

'#if(WINVER >= 0x0500)

%SPI_GETACTIVEWINDOWTRACKING         = &H1000???
%SPI_SETACTIVEWINDOWTRACKING         = &H1001???
%SPI_GETMENUANIMATION                = &H1002???
%SPI_SETMENUANIMATION                = &H1003???
%SPI_GETCOMBOBOXANIMATION            = &H1004???
%SPI_SETCOMBOBOXANIMATION            = &H1005???
%SPI_GETLISTBOXSMOOTHSCROLLING       = &H1006???
%SPI_SETLISTBOXSMOOTHSCROLLING       = &H1007???
%SPI_GETGRADIENTCAPTIONS             = &H1008???
%SPI_SETGRADIENTCAPTIONS             = &H1009???
%SPI_GETKEYBOARDCUES                 = &H100A???
%SPI_SETKEYBOARDCUES                 = &H100B???
%SPI_GETMENUUNDERLINES               = %SPI_GETKEYBOARDCUES
%SPI_SETMENUUNDERLINES               = %SPI_SETKEYBOARDCUES
%SPI_GETACTIVEWNDTRKZORDER           = &H100C???
%SPI_SETACTIVEWNDTRKZORDER           = &H100D???
%SPI_GETHOTTRACKING                  = &H100E???
%SPI_SETHOTTRACKING                  = &H100F???
%SPI_GETMENUFADE                     = &H1012???
%SPI_SETMENUFADE                     = &H1013???
%SPI_GETSELECTIONFADE                = &H1014???
%SPI_SETSELECTIONFADE                = &H1015???
%SPI_GETTOOLTIPANIMATION             = &H1016???
%SPI_SETTOOLTIPANIMATION             = &H1017???
%SPI_GETTOOLTIPFADE                  = &H1018???
%SPI_SETTOOLTIPFADE                  = &H1019???
%SPI_GETCURSORSHADOW                 = &H101A???
%SPI_SETCURSORSHADOW                 = &H101B???
'#if(_WIN32_WINNT >= = &H0501)
%SPI_GETMOUSESONAR                   = &H101C???
%SPI_SETMOUSESONAR                   = &H101D???
%SPI_GETMOUSECLICKLOCK               = &H101E???
%SPI_SETMOUSECLICKLOCK               = &H101F???
%SPI_GETMOUSEVANISH                  = &H1020???
%SPI_SETMOUSEVANISH                  = &H1021???
%SPI_GETFLATMENU                     = &H1022???
%SPI_SETFLATMENU                     = &H1023???
%SPI_GETDROPSHADOW                   = &H1024???
%SPI_SETDROPSHADOW                   = &H1025???
%SPI_GETBLOCKSENDINPUTRESETS         = &H1026???
%SPI_SETBLOCKSENDINPUTRESETS         = &H1027???
'#endif /* _WIN32_WINNT >= = &H0501 */

%SPI_GETUIEFFECTS                    = &H103E???
%SPI_SETUIEFFECTS                    = &H103F???

'#if(_WIN32_WINNT >= 0x0600)
%SPI_GETDISABLEOVERLAPPEDCONTENT     = &H1040???
%SPI_SETDISABLEOVERLAPPEDCONTENT     = &H1041???
%SPI_GETCLIENTAREAANIMATION          = &H1042???
%SPI_SETCLIENTAREAANIMATION          = &H1043???
%SPI_GETCLEARTYPE                    = &H1048???
%SPI_SETCLEARTYPE                    = &H1049???
%SPI_GETSPEECHRECOGNITION            = &H104A???
%SPI_SETSPEECHRECOGNITION            = &H104B???
'#endif /* _WIN32_WINNT >= 0x0600 */

%SPI_GETFOREGROUNDLOCKTIMEOUT        = &H2000???
%SPI_SETFOREGROUNDLOCKTIMEOUT        = &H2001???
%SPI_GETACTIVEWNDTRKTIMEOUT          = &H2002???
%SPI_SETACTIVEWNDTRKTIMEOUT          = &H2003???
%SPI_GETFOREGROUNDFLASHCOUNT         = &H2004???
%SPI_SETFOREGROUNDFLASHCOUNT         = &H2005???
%SPI_GETCARETWIDTH                   = &H2006???
%SPI_SETCARETWIDTH                   = &H2007???

'#if(_WIN32_WINNT >= = &H0501)
%SPI_GETMOUSECLICKLOCKTIME           = &H2008???
%SPI_SETMOUSECLICKLOCKTIME           = &H2009???
%SPI_GETFONTSMOOTHINGTYPE            = &H200A???
%SPI_SETFONTSMOOTHINGTYPE            = &H200B???

'/* constants for SPI_GETFONTSMOOTHINGTYPE and SPI_SETFONTSMOOTHINGTYPE: */
%FE_FONTSMOOTHINGSTANDARD            = &H0001???
%FE_FONTSMOOTHINGCLEARTYPE           = &H0002???
%FE_FONTSMOOTHINGDOCKING             = &H8000???

%SPI_GETFONTSMOOTHINGCONTRAST        = &H200C???
%SPI_SETFONTSMOOTHINGCONTRAST        = &H200D???

%SPI_GETFOCUSBORDERWIDTH             = &H200E???
%SPI_SETFOCUSBORDERWIDTH             = &H200F???
%SPI_GETFOCUSBORDERHEIGHT            = &H2010???
%SPI_SETFOCUSBORDERHEIGHT            = &H2011???

%SPI_GETFONTSMOOTHINGORIENTATION     = &H2012???
%SPI_SETFONTSMOOTHINGORIENTATION     = &H2013???

'/* constants for SPI_GETFONTSMOOTHINGORIENTATION and SPI_SETFONTSMOOTHINGORIENTATION: */
%FE_FONTSMOOTHINGORIENTATIONBGR      = &H0000???
%FE_FONTSMOOTHINGORIENTATIONRGB      = &H0001???
'#endif /* _WIN32_WINNT >= = &H0501 */

'#if(_WIN32_WINNT >= 0x0600)
%SPI_GETMINIMUMHITRADIUS             = &H2014???
%SPI_SETMINIMUMHITRADIUS             = &H2015???
%SPI_GETMESSAGEDURATION              = &H2016???
%SPI_SETMESSAGEDURATION              = &H2017???
'#endif /* _WIN32_WINNT >= 0x0600 */

'#endif /* WINVER >= = &H0500 */


'/*
' * Flags
' */
%SPIF_UPDATEINIFILE    = &H0001???
%SPIF_SENDWININICHANGE = &H0002???
%SPIF_SENDCHANGE       = %SPIF_SENDWININICHANGE

%METRICS_USEDEFAULT = -1&

TYPE NONCLIENTMETRICSA
   cbSize           AS DWORD      ' UINT     cbSize
   iBorderWidth     AS LONG       ' int      iBorderWidth
   iScrollWidth     AS LONG       ' int      iScrollWidth
   iScrollHeight    AS LONG       ' int      iScrollHeight
   iCaptionWidth    AS LONG       ' int      iCaptionWidth
   iCaptionHeight   AS LONG       ' int      iCaptionHeight
   lfCaptionFont    AS LOGFONTA   ' LOGFONTA lfCaptionFont
   iSMCaptionWidth  AS LONG       ' int      iSmCaptionWidth
   iSMCaptionHeight AS LONG       ' int      iSmCaptionHeight
   lfSMCaptionFont  AS LOGFONTA   ' LOGFONTA lfSmCaptionFont
   iMenuWidth       AS LONG       ' int      iMenuWidth
   iMenuHeight      AS LONG       ' int      iMenuHeight
   lfMenuFont       AS LOGFONTA   ' LOGFONTA lfMenuFont
   lfStatusFont     AS LOGFONTA   ' LOGFONTA lfStatusFont
   lfMessageFont    AS LOGFONTA   ' LOGFONTA lfMessageFont
END TYPE

TYPE NONCLIENTMETRICSW
   cbSize           AS DWORD      ' UINT     cbSize
   iBorderWidth     AS LONG       ' int      iBorderWidth
   iScrollWidth     AS LONG       ' int      iScrollWidth
   iScrollHeight    AS LONG       ' int      iScrollHeight
   iCaptionWidth    AS LONG       ' int      iCaptionWidth
   iCaptionHeight   AS LONG       ' int      iCaptionHeight
   lfCaptionFont    AS LOGFONTW   ' LOGFONTW lfCaptionFont
   iSMCaptionWidth  AS LONG       ' int      iSmCaptionWidth
   iSMCaptionHeight AS LONG       ' int      iSmCaptionHeight
   lfSMCaptionFont  AS LOGFONTW   ' LOGFONTW lfSmCaptionFont
   iMenuWidth       AS LONG       ' int      iMenuWidth
   iMenuHeight      AS LONG       ' int      iMenuHeight
   lfMenuFont       AS LOGFONTW   ' LOGFONTW lfMenuFont
   lfStatusFont     AS LOGFONTW   ' LOGFONTW lfStatusFont
   lfMessageFont    AS LOGFONTW   ' LOGFONTW lfMessageFont
END TYPE

MACRO NONCLIENTMETRICS = NONCLIENTMETRICSA

%ARW_BOTTOMLEFT  = &H0000???
%ARW_BOTTOMRIGHT = &H0001???
%ARW_TOPLEFT     = &H0002???
%ARW_TOPRIGHT    = &H0003???
%ARW_STARTMASK   = &H0003???
%ARW_STARTRIGHT  = &H0001???
%ARW_STARTTOP    = &H0002???

%ARW_LEFT        = &H0000???
%ARW_RIGHT       = &H0000???
%ARW_UP          = &H0004???
%ARW_DOWN        = &H0004???
%ARW_HIDE        = &H0008???

TYPE MINIMIZEDMETRICS
   cbSize   AS DWORD   ' UINT    cbSize
   iWidth   AS LONG    ' int     iWidth
   iHorzGap AS LONG    ' int     iHorzGap
   iVertGap AS LONG    ' int     iVertGap
   iArrange AS LONG    ' int     iArrange
END TYPE

'#IF %DEF(%WINGDI) ' -----------------------------------------------------------
'#IF NOT %DEF(%NOGDI) ' --------------------------------------------------------
'#ifdef _WINGDI_
'#ifndef NOGDI

TYPE ICONMETRICSA
   cbSize       AS DWORD     ' UINT     cbSize
   iHorzSpacing AS LONG      ' int      iHorzSpacing
   iVertSpacing AS LONG      ' int      iVertSpacing
   iTitleWrap   AS LONG      ' int      iTitleWrap
   lfFont       AS LOGFONT   ' LOGFONTA lfFont
END TYPE

TYPE ICONMETRICSW
   cbSize       AS DWORD     ' UINT     cbSize
   iHorzSpacing AS LONG      ' int      iHorzSpacing
   iVertSpacing AS LONG      ' int      iVertSpacing
   iTitleWrap   AS LONG      ' int      iTitleWrap
   lfFont       AS LOGFONTW  ' LOGFONTW lfFont
END TYPE

MACRO ICONMETRICS = ICONMETRICSA

'#endif /* NOGDI */
'#endif /* _WINGDI_ */
'#ENDIF   ' #IF NOT %DEF(%NOGDI) ' ---------------------------------------------
'#ENDIF   ' #IF DEF(%WINGDI) ' -------------------------------------------------

TYPE ANIMATIONINFO
   cbSize      AS DWORD   ' UINT    cbSize
   iMinAnimate AS LONG    ' int     iMinAnimate
END TYPE

TYPE SERIALKEYSA
   cbSize         AS DWORD        ' UINT    cbSize
   dwFlags        AS DWORD        ' DWORD   dwFlags
   lpszActivePort AS ASCIIZ PTR   ' LPSTR   lpszActivePort
   lpszPort       AS ASCIIZ PTR   ' LPSTR   lpszPort
   iBaudRate      AS DWORD        ' UINT    iBaudRate
   iPortState     AS DWORD        ' UINT    iPortState
   iActive        AS DWORD        ' UINT    iActive
END TYPE

TYPE SERIALKEYSW
   cbSize         AS DWORD        ' UINT    cbSize
   dwFlags        AS DWORD        ' DWORD   dwFlags
   lpszActivePort AS WORD PTR     ' LPWSTR  lpszActivePort
   lpszPort       AS WORD PTR     ' LPWSTR  lpszPort
   iBaudRate      AS DWORD        ' UINT    iBaudRate
   iPortState     AS DWORD        ' UINT    iPortState
   iActive        AS DWORD        ' UINT    iActive
END TYPE

MACRO SERIALKEYS = SERIALKEYSA

'/* flags for SERIALKEYS dwFlags field */
%SERKF_SERIALKEYSON = &H00000001???
%SERKF_AVAILABLE    = &H00000002???
%SERKF_INDICATOR    = &H00000004???

TYPE HIGHCONTRASTA
   cbSize            AS DWORD        ' UINT    cbSize
   dwFlags           AS DWORD        ' DWORD   dwFlags
   lpszDefaultScheme AS ASCIIZ PTR   ' LPSTR   lpszDefaultScheme
END TYPE

TYPE HIGHCONTRASTW
   cbSize            AS DWORD        ' UINT    cbSize
   dwFlags           AS DWORD        ' DWORD   dwFlags
   lpszDefaultScheme AS WORD PTR     ' LPWSTR  lpszDefaultScheme
END TYPE

MACRO HIGHCONTRAST = HIGHCONTRASTA

'/* flags for HIGHCONTRAST dwFlags field */
%HCF_HIGHCONTRASTON       = &H00000001???
%HCF_AVAILABLE            = &H00000002???
%HCF_HOTKEYACTIVE         = &H00000004???
%HCF_CONFIRMHOTKEY        = &H00000008???
%HCF_HOTKEYSOUND          = &H00000010???
%HCF_INDICATOR            = &H00000020???
%HCF_HOTKEYAVAILABLE      = &H00000040???
%HCF_LOGONDESKTOP         = &H00000100???
%HCF_DEFAULTDESKTOP       = &H00000200???

'/* Flags for ChangeDisplaySettings */
%CDS_UPDATEREGISTRY       = &H00000001???
%CDS_TEST                 = &H00000002???
%CDS_FULLSCREEN           = &H00000004???
%CDS_GLOBAL               = &H00000008???
%CDS_SET_PRIMARY          = &H00000010???
%CDS_VIDEOPARAMETERS      = &H00000020???
'#if(WINVER >= 0x0600)
%CDS_ENABLE_UNSAFE_MODES  = &H00000100???
%CDS_DISABLE_UNSAFE_MODES = &H00000200???
'#endif /* WINVER >= 0x0600 */
%CDS_RESET                = &H40000000???
%CDS_NORESET              = &H10000000???

'/* Return values for ChangeDisplaySettings */
%DISP_CHANGE_SUCCESSFUL  =  0&
%DISP_CHANGE_RESTART     =  1&
%DISP_CHANGE_FAILED      = -1&
%DISP_CHANGE_BADMODE     = -2&
%DISP_CHANGE_NOTUPDATED  = -3&
%DISP_CHANGE_BADFLAGS    = -4&
%DISP_CHANGE_BADPARAM    = -5&
'#if(_WIN32_WINNT >= 0x0501)
%DISP_CHANGE_BADDUALVIEW = -6&
'#endif /* _WIN32_WINNT >= 0x0501 */

'#ifdef _WINGDI_
'#ifndef NOGDI

DECLARE FUNCTION ChangeDisplaySettings LIB "USER32.DLL" ALIAS "ChangeDisplaySettingsA" ( _
   BYREF DEVMODEA _                    ' __in_opt LPDEVMODEA lpDevMode
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' long

DECLARE FUNCTION ChangeDisplaySettingsW LIB "USER32.DLL" ALIAS "ChangeDisplaySettingsW" ( _
   BYREF DEVMODEW _                    ' __in_opt LPDEVMODEW lpDevMode
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' long

DECLARE FUNCTION ChangeDisplaySettingsEx LIB "USER32.DLL" ALIAS "ChangeDisplaySettingsExA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpszDeviceName
 , BYREF DEVMODEA _                    ' __in_opt LPDEVMODEA lpDevMode
 , BYVAL DWORD _                       ' __reserved HWND hwnd
 , BYVAL DWORD _                       ' __in DWORD dwflags
 , BYREF ANY _                         ' __in_opt LPVOID lParam
 ) AS LONG                             ' long

DECLARE FUNCTION ChangeDisplaySettingsExW LIB "USER32.DLL" ALIAS "ChangeDisplaySettingsExW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpszDeviceName
 , BYREF DEVMODEW _                    ' __in_opt LPDEVMODEW lpDevMode
 , BYVAL DWORD _                       ' __reserved HWND hwnd
 , BYVAL DWORD _                       ' __in DWORD dwflags
 , BYREF ANY _                         ' __in_opt LPVOID lParam
 ) AS LONG                             ' long

%ENUM_CURRENT_SETTINGS  = &HFFFFFFFF???   ' ((DWORD)-1)
%ENUM_REGISTRY_SETTINGS = &HFFFFFFFE???   ' ((DWORD)-2)

DECLARE FUNCTION EnumDisplaySettings LIB "USER32.DLL" ALIAS "EnumDisplaySettingsA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpszDeviceName
 , BYVAL DWORD _                       ' __in DWORD iModeNum
 , BYREF DEVMODEA _                    ' __out LPDEVMODEA lpDevMode
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumDisplaySettingsW LIB "USER32.DLL" ALIAS "EnumDisplaySettingsW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpszDeviceName
 , BYVAL DWORD _                       ' __in DWORD iModeNum
 , BYREF DEVMODEW _                    ' __out LPDEVMODEW lpDevMode
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0500)

DECLARE FUNCTION EnumDisplaySettingsEx LIB "USER32.DLL" ALIAS "EnumDisplaySettingsExA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpszDeviceName
 , BYVAL DWORD _                       ' __in DWORD iModeNum
 , BYREF DEVMODEA _                    ' __out LPDEVMODEA lpDevMode
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumDisplaySettingsExW LIB "USER32.DLL" ALIAS "EnumDisplaySettingsExW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpszDeviceName
 , BYVAL DWORD _                       ' __in DWORD iModeNum
 , BYREF DEVMODEW _                    ' __out LPDEVMODEW lpDevMode
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

'/* Flags for EnumDisplaySettingsEx */
%EDS_RAWMODE     = &H00000002???
%EDS_ROTATEDMODE = &H00000004???

DECLARE FUNCTION EnumDisplayDevices LIB "USER32.DLL" ALIAS "EnumDisplayDevicesA" ( _
   BYREF ASCIIZ _                      ' __in_opt LPCSTR lpDevice
 , BYVAL DWORD _                       ' __in DWORD iDevNum
 , BYREF DISPLAY_DEVICEA _             ' __inout PDISPLAY_DEVICEA lpDisplayDevice
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

DECLARE FUNCTION EnumDisplayDevicesW LIB "USER32.DLL" ALIAS "EnumDisplayDevicesW" ( _
   BYVAL DWORD _                       ' __in_opt LPCWSTR lpDevice
 , BYVAL DWORD _                       ' __in DWORD iDevNum
 , BYREF DISPLAY_DEVICEW _             ' __inout PDISPLAY_DEVICEW lpDisplayDevice
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS LONG                             ' BOOL

'#endif /* WINVER >= 0x0500 */

'#endif /* NOGDI */
'#endif /* _WINGDI_ */

DECLARE FUNCTION SystemParametersInfo LIB "USER32.DLL" ALIAS "SystemParametersInfoA" ( _
   BYVAL DWORD _                       ' __in UINT uiAction
 , BYVAL DWORD _                       ' __in UINT uiParam
 , BYREF ANY _                         ' __inout_opt PVOID pvParam
 , BYVAL DWORD _                       ' __in UINT fWinIni
 ) AS LONG                             ' BOOL

DECLARE FUNCTION SystemParametersInfoW LIB "USER32.DLL" ALIAS "SystemParametersInfoW" ( _
   BYVAL DWORD _                       ' __in UINT uiAction
 , BYVAL DWORD _                       ' __in UINT uiParam
 , BYREF ANY _                         ' __inout_opt PVOID pvParam
 , BYVAL DWORD _                       ' __in UINT fWinIni
 ) AS LONG                             ' BOOL

'#endif  /* !NOSYSPARAMSINFO  */
'#ENDIF   ' #IF NOT %DEF(%NOSYSPARAMSINFO) ' -----------------------------------

'/*
' * Accessibility support
' */

TYPE FILTERKEYS
   cbSize      AS DWORD   ' UINT  cbSize
   dwFlags     AS DWORD   ' DWORD dwFlags
   iWaitMSec   AS DWORD   ' DWORD iWaitMSec    // Acceptance Delay
   iDelayMSec  AS DWORD   ' DWORD iDelayMSec   // Delay Until Repeat
   iRepeatMSec AS DWORD   ' DWORD iRepeatMSec  // Repeat Rate
   iBounceMSec AS DWORD   ' DWORD iBounceMSec  // Debounce Time
END TYPE

'/*
' * FILTERKEYS dwFlags field
' */
%FKF_FILTERKEYSON    = &H00000001???
%FKF_AVAILABLE       = &H00000002???
%FKF_HOTKEYACTIVE    = &H00000004???
%FKF_CONFIRMHOTKEY   = &H00000008???
%FKF_HOTKEYSOUND     = &H00000010???
%FKF_INDICATOR       = &H00000020???
%FKF_CLICKON         = &H00000040???

TYPE STICKYKEYS
   cbSize  AS DWORD   ' UINT  cbSize
   dwFlags AS DWORD   ' DWORD dwFlags
END TYPE

'/*
' * STICKYKEYS dwFlags field
' */
%SKF_STICKYKEYSON    = &H00000001???
%SKF_AVAILABLE       = &H00000002???
%SKF_HOTKEYACTIVE    = &H00000004???
%SKF_CONFIRMHOTKEY   = &H00000008???
%SKF_HOTKEYSOUND     = &H00000010???
%SKF_INDICATOR       = &H00000020???
%SKF_AUDIBLEFEEDBACK = &H00000040???
%SKF_TRISTATE        = &H00000080???
%SKF_TWOKEYSOFF      = &H00000100???
'#if(_WIN32_WINNT >= 0x0500)
%SKF_LALTLATCHED     = &H10000000???
%SKF_LCTLLATCHED     = &H04000000???
%SKF_LSHIFTLATCHED   = &H01000000???
%SKF_RALTLATCHED     = &H20000000???
%SKF_RCTLLATCHED     = &H08000000???
%SKF_RSHIFTLATCHED   = &H02000000???
%SKF_LWINLATCHED     = &H40000000???
%SKF_RWINLATCHED     = &H80000000???
%SKF_LALTLOCKED      = &H00100000???
%SKF_LCTLLOCKED      = &H00040000???
%SKF_LSHIFTLOCKED    = &H00010000???
%SKF_RALTLOCKED      = &H00200000???
%SKF_RCTLLOCKED      = &H00080000???
%SKF_RSHIFTLOCKED    = &H00020000???
%SKF_LWINLOCKED      = &H00400000???
%SKF_RWINLOCKED      = &H00800000???
'#endif /* _WIN32_WINNT >= 0x0500 */

TYPE MOUSEKEYS
   cbSize          AS DWORD   ' UINT cbSize
   dwFlags         AS DWORD   ' DWORD dwFlags
   iMaxSpeed       AS DWORD   ' DWORD iMaxSpeed
   iTimeToMaxSpeed AS DWORD   ' DWORD iTimeToMaxSpeed
   iCtrlSpeed      AS DWORD   ' DWORD iCtrlSpeed
   dwReserved1     AS DWORD   ' DWORD dwReserved1
   dwReserved2     AS DWORD   ' DWORD dwReserved2
END TYPE

'/*
' * MOUSEKEYS dwFlags field
' */
%MKF_MOUSEKEYSON     = &H00000001???
%MKF_AVAILABLE       = &H00000002???
%MKF_HOTKEYACTIVE    = &H00000004???
%MKF_CONFIRMHOTKEY   = &H00000008???
%MKF_HOTKEYSOUND     = &H00000010???
%MKF_INDICATOR       = &H00000020???
%MKF_MODIFIERS       = &H00000040???
%MKF_REPLACENUMBERS  = &H00000080???
'#if(_WIN32_WINNT >= 0x0500)
%MKF_LEFTBUTTONSEL   = &H10000000???
%MKF_RIGHTBUTTONSEL  = &H20000000???
%MKF_LEFTBUTTONDOWN  = &H01000000???
%MKF_RIGHTBUTTONDOWN = &H02000000???
%MKF_MOUSEMODE       = &H80000000???
'#endif /* _WIN32_WINNT >= 0x0500 */

TYPE ACCESSTIMEOUT
   cbSize       AS DWORD   ' UINT  cbSize
   dwFlags      AS DWORD   ' DWORD dwFlags
   iTimeOutMSec AS DWORD   ' DWORD iTimeOutMSec
END TYPE

'/*
' * ACCESSTIMEOUT dwFlags field
' */
%ATF_TIMEOUTON     = &H00000001???
%ATF_ONOFFFEEDBACK = &H00000002???

'/* values for SOUNDSENTRY iFSGrafEffect field */
%SSGF_NONE    = 0???
%SSGF_DISPLAY = 3???

'/* values for SOUNDSENTRY iFSTextEffect field */
%SSTF_NONE    = 0???
%SSTF_CHARS   = 1???
%SSTF_BORDER  = 2???
%SSTF_DISPLAY = 3???

'/* values for SOUNDSENTRY iWindowsEffect field */
%SSWF_NONE    = 0???
%SSWF_TITLE   = 1???
%SSWF_WINDOW  = 2???
%SSWF_DISPLAY = 3???
%SSWF_CUSTOM  = 4???

TYPE SOUNDSENTRYA
   cbSize                 AS DWORD        ' UINT   cbSize
   dwFlags                AS DWORD        ' DWORD  dwFlags
   iFSTextEffect          AS DWORD        ' DWORD  iFSTextEffect
   iFSTextEffectMSec      AS DWORD        ' DWORD  iFSTextEffectMSec
   iFSTextEffectColorBits AS DWORD        ' DWORD  iFSTextEffectColorBits
   iFSGrafEffect          AS DWORD        ' DWORD  iFSGrafEffect
   iFSGrafEffectMSec      AS DWORD        ' DWORD  iFSGrafEffectMSec
   iFSGrafEffectColor     AS DWORD        ' DWORD  iFSGrafEffectColor
   iWindowsEffect         AS DWORD        ' DWORD  iWindowsEffect
   iWindowsEffectMSec     AS DWORD        ' DWORD  iWindowsEffectMSec
   lpszWindowsEffectDLL   AS ASCIIZ PTR   ' LPSTR  lpszWindowsEffectDLL
   iWindowsEffectOrdinal  AS DWORD        ' DWORD  iWindowsEffectOrdinal
END TYPE

TYPE SOUNDSENTRYW
   cbSize                 AS DWORD        ' UINT   cbSize
   dwFlags                AS DWORD        ' DWORD  dwFlags
   iFSTextEffect          AS DWORD        ' DWORD  iFSTextEffect
   iFSTextEffectMSec      AS DWORD        ' DWORD  iFSTextEffectMSec
   iFSTextEffectColorBits AS DWORD        ' DWORD  iFSTextEffectColorBits
   iFSGrafEffect          AS DWORD        ' DWORD  iFSGrafEffect
   iFSGrafEffectMSec      AS DWORD        ' DWORD  iFSGrafEffectMSec
   iFSGrafEffectColor     AS DWORD        ' DWORD  iFSGrafEffectColor
   iWindowsEffect         AS DWORD        ' DWORD  iWindowsEffect
   iWindowsEffectMSec     AS DWORD        ' DWORD  iWindowsEffectMSec
   lpszWindowsEffectDLL   AS WORD PTR     ' LPWSTR lpszWindowsEffectDLL
   iWindowsEffectOrdinal  AS DWORD        ' DWORD  iWindowsEffectOrdinal
END TYPE

MACRO SOUNDSENTRY = SOUNDSENTRYA

'/*
' * SOUNDSENTRY dwFlags field
' */
%SSF_SOUNDSENTRYON = &H00000001???
%SSF_AVAILABLE     = &H00000002???
%SSF_INDICATOR     = &H00000004???

TYPE TOGGLEKEYS
  cbSize  AS DWORD   ' UINT cbSize
  dwFlags AS DWORD   ' DWORD dwFlags
END TYPE

'/*
' * TOGGLEKEYS dwFlags field
' */
%TKF_TOGGLEKEYSON  = &H00000001???
%TKF_AVAILABLE     = &H00000002???
%TKF_HOTKEYACTIVE  = &H00000004???
%TKF_CONFIRMHOTKEY = &H00000008???
%TKF_HOTKEYSOUND   = &H00000010???
%TKF_INDICATOR     = &H00000020???

'#if(_WIN32_WINNT >= 0x0600)
TYPE AUDIODESCRIPTION
   cbSize  AS DWORD   ' UINT  // sizeof(AudioDescriptionType)
   Enabled AS LONG   ' BOOL  // On/Off
   Locale  AS DWORD   ' DWORD // locale ID for language
END TYPE
'#endif /* _WIN32_WINNT >= 0x0600 */

'/*
' * Set debug level
' */

DECLARE SUB SetDebugErrorLevel LIB "USER32.DLL" ALIAS "SetDebugErrorLevel" ( _
   BYVAL DWORD _                       ' __in DWORD dwLevel
 )                                     ' VOID

'/*
' * SetLastErrorEx() types.
' */

%SLE_ERROR      = &H00000001???
%SLE_MINORERROR = &H00000002???
%SLE_WARNING    = &H00000003???

DECLARE SUB SetLastErrorEx LIB "USER32.DLL" ALIAS "SetLastErrorEx" ( _
   BYVAL DWORD _                       ' __in DWORD dwErrCode
 , BYVAL DWORD _                       ' __in DWORD dwType
 )                                     ' VOID

DECLARE FUNCTION InternalGetWindowText LIB "USER32.DLL" ALIAS "InternalGetWindowText" ( _
   BYVAL DWORD _                       ' __in  HWND hWnd
 , BYVAL DWORD _                       ' __out LPWSTR pString
 , BYVAL LONG _                        ' __in int cchMaxCount
 ) AS LONG                             ' int

' Although you can access this function by using LoadLibrary and GetProcAddress
' combined in Microsoft Windows versions prior to Windows XP, the function is
' not accessible using the standard Include file and library linkage. The header
' files included in Windows XP Service Pack 1 (SP1) and Windows Server 2003
' document this function and make it accessible using the appropriate Include
' file and library linkage. However, this function is deprecated and not intended
' for general use. It is recommended that you do not use it in new programs
' because it might be altered or unavailable in subsequent versions of Windows.

'#if defined(WINNT)
DECLARE FUNCTION EndTask LIB "USER32.DLL" ALIAS "EndTask" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL LONG _                        ' __in BOOL fShutDown
 , BYVAL LONG _                        ' __in BOOL fForce
 ) AS LONG                             ' BOOL
'#endif

DECLARE FUNCTION CancelShutdown LIB "USER32.DLL" ALIAS "CancelShutdown" ( _
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0500)

'/*
' * Multimonitor API.
' */

%MONITOR_DEFAULTTONULL    = &H00000000???
%MONITOR_DEFAULTTOPRIMARY = &H00000001???
%MONITOR_DEFAULTTONEAREST = &H00000002???

' Uses x, y for compatibility with PB's include file...
DECLARE FUNCTION MonitorFromPoint LIB "USER32.DLL" ALIAS "MonitorFromPoint" ( _
   BYVAL LONG _                     ' __in x
 , BYVAL LONG _                     ' __in y
 , BYVAL DWORD _                    ' __in DWORD dwFlags
 ) AS DWORD                         ' HMONITOR

' ... but it should be
'DECLARE FUNCTION MonitorFromPoint LIB "USER32.DLL" ALIAS "MonitorFromPoint" ( _
'   BYVAL POINTAPI _                 ' __in POINT pt
' , BYVAL DWORD _                    ' __in DWORD dwFlags
' ) AS DWORD                         ' HMONITOR

DECLARE FUNCTION MonitorFromRect LIB "USER32.DLL" ALIAS "MonitorFromRect" ( _
   BYREF RECT _                        ' __in LPCRECT lprc
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' HMONITOR

DECLARE FUNCTION MonitorFromWindow LIB "USER32.DLL" ALIAS "MonitorFromWindow" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' HMONITOR

%MONITORINFOF_PRIMARY = &H00000001???

'#ifndef CCHDEVICENAME
'#define CCHDEVICENAME 32
#IF NOT %DEF(%CCHDEVICENAME)
%CCHDEVICENAME = 32&
#ENDIF
'#endif

TYPE MONITORINFO
   cbSize    AS DWORD   ' DWORD   cbSize
   rcMonitor AS RECT    ' RECT    rcMonitor
   rcWork    AS RECT    ' RECT    rcWork
   dwFlags   AS DWORD   ' DWORD   dwFlags
END TYPE

TYPE MONITORINFOEXA
   MONITORINFO
   szDevice AS ASCIIZ * %CCHDEVICENAME
END TYPE

TYPE MONITORINFOEXW
   MONITORINFO
   szDevice AS STRING * %CCHDEVICENAME * 2
END TYPE

MACRO MONITORINFOEX = MONITORINFOEXA

DECLARE FUNCTION GetMonitorInfo LIB "USER32.DLL" ALIAS "GetMonitorInfoA" ( _
   BYVAL DWORD _                       ' __in HMONITOR hMonitor
 , BYREF MONITORINFO _                 ' __inout LPMONITORINFO lpmi
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetMonitorInfoW LIB "USER32.DLL" ALIAS "GetMonitorInfoW" ( _
   BYVAL DWORD _                       ' __in HMONITOR hMonitor
 , BYREF MONITORINFO _                 ' __inout LPMONITORINFO lpmi
 ) AS LONG                             ' BOOL

'typedef BOOL (CALLBACK* MONITORENUMPROC)(HMONITOR, HDC, LPRECT, LPARAM);

DECLARE FUNCTION EnumDisplayMonitors LIB "USER32.DLL" ALIAS "EnumDisplayMonitors" ( _
   BYVAL DWORD _                      ' __in_opt HDC hdc
 , BYREF RECT _                       ' __in_opt LPCRECT lprcClip
 , BYVAL DWORD _                      ' __in MONITORENUMPROC lpfnEnum
 , BYVAL LONG _                       ' __in LPARAM dwData
 ) AS LONG                            ' BOOL

'#IF NOT %DEF(%NOWINABLE) ' ----------------------------------------------------
'#ifndef NOWINABLE

'/*
' * WinEvents - Active Accessibility hooks
' */

DECLARE SUB NotifyWinEvent LIB "USER32.DLL" ALIAS "NotifyWinEvent" ( _
   BYVAL DWORD _                       ' __in DWORD event
 , BYVAL DWORD _                       ' __in HWND  hwnd
 , BYVAL LONG _                        ' __in LONG  idObject
 , BYVAL LONG _                        ' __in LONG  idChild
 )                                     ' VOID

'typedef VOID (CALLBACK* WINEVENTPROC)(
'    HWINEVENTHOOK hWinEventHook,
'    DWORD         event,
'    HWND          hwnd,
'    LONG          idObject,
'    LONG          idChild,
'    DWORD         idEventThread,
'    DWORD         dwmsEventTime);

DECLARE FUNCTION SetWinEventHook LIB "USER32.DLL" ALIAS "SetWinEventHook" ( _
   BYVAL DWORD _                       ' __in DWORD eventMin
 , BYVAL DWORD _                       ' __in DWORD eventMax
 , BYVAL DWORD _                       ' __in_opt HMODULE hmodWinEventProc
 , BYVAL DWORD _                       ' __in WINEVENTPROC pfnWinEventProc
 , BYVAL DWORD _                       ' __in DWORD idProcess
 , BYVAL DWORD _                       ' __in DWORD idThread
 , BYVAL DWORD _                       ' __in DWORD dwFlags
 ) AS DWORD                            ' HWINEVENTHOOK

'#if(_WIN32_WINNT >= 0x0501)
DECLARE FUNCTION IsWinEventHookInstalled LIB "USER32.DLL" ALIAS "IsWinEventHookInstalled" ( _
   BYVAL DWORD _                       ' __in DWORD event
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >= 0x0501 */

'/*
' * dwFlags for SetWinEventHook
' */
%WINEVENT_OUTOFCONTEXT   = &H0000???  ' Events are ASYNC
%WINEVENT_SKIPOWNTHREAD  = &H0001???  ' Don't call back for events on installer's thread
%WINEVENT_SKIPOWNPROCESS = &H0002???  ' Don't call back for events on installer's process
%WINEVENT_INCONTEXT      = &H0004???  ' Events are SYNC, this causes your dll to be injected into every process

DECLARE FUNCTION UnhookWinEvent LIB "USER32.DLL" ALIAS "UnhookWinEvent" ( _
   BYVAL DWORD _                       ' __in HWINEVENTHOOK hWinEventHook
 ) AS LONG                             ' BOOL

%CHILDID_SELF      = 0&
%INDEXID_OBJECT    = 0&
%INDEXID_CONTAINER = 0&

'/*
' * Reserved IDs for system objects
' */
%OBJID_WINDOW            = &H00000000&   ' ((LONG)0x00000000)
%OBJID_SYSMENU           = &HFFFFFFFF&   ' ((LONG)0xFFFFFFFF)
%OBJID_TITLEBAR          = &HFFFFFFFE&   ' ((LONG)0xFFFFFFFE)
%OBJID_MENU              = &HFFFFFFFD&   ' ((LONG)0xFFFFFFFD)
%OBJID_CLIENT            = &HFFFFFFFC&   ' ((LONG)0xFFFFFFFC)
%OBJID_VSCROLL           = &HFFFFFFFB&   ' ((LONG)0xFFFFFFFB)
%OBJID_HSCROLL           = &HFFFFFFFA&   ' ((LONG)0xFFFFFFFA)
%OBJID_SIZEGRIP          = &HFFFFFFF9&   ' ((LONG)0xFFFFFFF9)
%OBJID_CARET             = &HFFFFFFF8&   ' ((LONG)0xFFFFFFF8)
%OBJID_CURSOR            = &HFFFFFFF7&   ' ((LONG)0xFFFFFFF7)
%OBJID_ALERT             = &HFFFFFFF6&   ' ((LONG)0xFFFFFFF6)
%OBJID_SOUND             = &HFFFFFFF5&   ' ((LONG)0xFFFFFFF5)
%OBJID_QUERYCLASSNAMEIDX = &HFFFFFFF4&   ' ((LONG)0xFFFFFFF4)
%OBJID_NATIVEOM          = &HFFFFFFF0&   ' ((LONG)0xFFFFFFF0)

'/*
' * EVENT DEFINITION
' */
%EVENT_MIN               = &H00000001???
%EVENT_MAX               = &H7FFFFFFF???

'/*
' *  EVENT_SYSTEM_SOUND
' *  Sent when a sound is played.  Currently nothing is generating this, we
' *  this event when a system sound (for menus, etc) is played.  Apps
' *  generate this, if accessible, when a private sound is played.  For
' *  example, if Mail plays a "New Mail" sound.
' *
' *  System Sounds:
' *  (Generated by PlaySoundEvent in USER itself)
' *      hwnd            is NULL
' *      idObject        is OBJID_SOUND
' *      idChild         is sound child ID if one
' *  App Sounds:
' *  (PlaySoundEvent won't generate notification; up to app)
' *      hwnd + idObject gets interface pointer to Sound object
' *      idChild identifies the sound in question
' *  are going to be cleaning up the SOUNDSENTRY feature in the control panel
' *  and will use this at that time.  Applications implementing WinEvents
' *  are perfectly welcome to use it.  Clients of IAccessible* will simply
' *  turn around and get back a non-visual object that describes the sound.
' */
%EVENT_SYSTEM_SOUND              = &H0001???

'/*
' * EVENT_SYSTEM_ALERT
' * System Alerts:
' * (Generated by MessageBox() calls for example)
' *      hwnd            is hwndMessageBox
' *      idObject        is OBJID_ALERT
' * App Alerts:
' * (Generated whenever)
' *      hwnd+idObject gets interface pointer to Alert
' */
%EVENT_SYSTEM_ALERT              = &H0002???

'/*
' * EVENT_SYSTEM_FOREGROUND
' * Sent when the foreground (active) window changes, even if it is changing
' * to another window in the same thread as the previous one.
' *      hwnd            is hwndNewForeground
' *      idObject        is OBJID_WINDOW
' *      idChild    is INDEXID_OBJECT
' */
%EVENT_SYSTEM_FOREGROUND         = &H0003???

'/*
' * Menu
' *      hwnd            is window (top level window or popup menu window)
' *      idObject        is ID of control (OBJID_MENU, OBJID_SYSMENU, OBJID_SELF for popup)
' *      idChild         is CHILDID_SELF
' *
' * EVENT_SYSTEM_MENUSTART
' * EVENT_SYSTEM_MENUEND
' * For MENUSTART, hwnd+idObject+idChild refers to the control with the menu bar,
' *  or the control bringing up the context menu.
' *
' * Sent when entering into and leaving from menu mode (system, app bar, and
' * track popups).
' */
%EVENT_SYSTEM_MENUSTART          = &H0004???
%EVENT_SYSTEM_MENUEND            = &H0005???

'/*
' * EVENT_SYSTEM_MENUPOPUPSTART
' * EVENT_SYSTEM_MENUPOPUPEND
' * Sent when a menu popup comes up and just before it is taken down.  Note
' * that for a call to TrackPopupMenu(), a client will see EVENT_SYSTEM_MENUSTART
' * followed almost immediately by EVENT_SYSTEM_MENUPOPUPSTART for the popup
' * being shown.
' *
' * For MENUPOPUP, hwnd+idObject+idChild refers to the NEW popup coming up, not the
' * parent item which is hierarchical.  You can get the parent menu/popup by
' * asking for the accParent object.
' */
%EVENT_SYSTEM_MENUPOPUPSTART     = &H0006???
%EVENT_SYSTEM_MENUPOPUPEND       = &H0007???

'/*
' * EVENT_SYSTEM_CAPTURESTART
' * EVENT_SYSTEM_CAPTUREEND
' * Sent when a window takes the capture and releases the capture.
' */
%EVENT_SYSTEM_CAPTURESTART       = &H0008???
%EVENT_SYSTEM_CAPTUREEND         = &H0009???

'/*
' * Move Size
' * EVENT_SYSTEM_MOVESIZESTART
' * EVENT_SYSTEM_MOVESIZEEND
' * Sent when a window enters and leaves move-size dragging mode.
' */
%EVENT_SYSTEM_MOVESIZESTART      = &H000A???
%EVENT_SYSTEM_MOVESIZEEND        = &H000B???

'/*
' * Context Help
' * EVENT_SYSTEM_CONTEXTHELPSTART
' * EVENT_SYSTEM_CONTEXTHELPEND
' * Sent when a window enters and leaves context sensitive help mode.
' */
%EVENT_SYSTEM_CONTEXTHELPSTART   = &H000C???
%EVENT_SYSTEM_CONTEXTHELPEND     = &H000D???

'/*
' * Drag & Drop
' * EVENT_SYSTEM_DRAGDROPSTART
' * EVENT_SYSTEM_DRAGDROPEND
' * Send the START notification just before going into drag&drop loop.  Send
' * the END notification just after canceling out.
' * Note that it is up to apps and OLE to generate this, since the system
' * doesn't know.  Like EVENT_SYSTEM_SOUND, it will be a while before this
' * is prevalent.
' */
%EVENT_SYSTEM_DRAGDROPSTART      = &H000E???
%EVENT_SYSTEM_DRAGDROPEND        = &H000F???

'/*
' * Dialog
' * Send the START notification right after the dialog is completely
' *  initialized and visible.  Send the END right before the dialog
' *  is hidden and goes away.
' * EVENT_SYSTEM_DIALOGSTART
' * EVENT_SYSTEM_DIALOGEND
' */
%EVENT_SYSTEM_DIALOGSTART        = &H0010???
%EVENT_SYSTEM_DIALOGEND          = &H0011???

'/*
' * EVENT_SYSTEM_SCROLLING
' * EVENT_SYSTEM_SCROLLINGSTART
' * EVENT_SYSTEM_SCROLLINGEND
' * Sent when beginning and ending the tracking of a scrollbar in a window,
' * and also for scrollbar controls.
' */
%EVENT_SYSTEM_SCROLLINGSTART     = &H0012???
%EVENT_SYSTEM_SCROLLINGEND       = &H0013???

'/*
' * Alt-Tab Window
' * Send the START notification right after the switch window is initialized
' * and visible.  Send the END right before it is hidden and goes away.
' * EVENT_SYSTEM_SWITCHSTART
' * EVENT_SYSTEM_SWITCHEND
' */
%EVENT_SYSTEM_SWITCHSTART        = &H0014???
%EVENT_SYSTEM_SWITCHEND          = &H0015???

'/*
' * EVENT_SYSTEM_MINIMIZESTART
' * EVENT_SYSTEM_MINIMIZEEND
' * Sent when a window minimizes and just before it restores.
' */
%EVENT_SYSTEM_MINIMIZESTART      = &H0016???
%EVENT_SYSTEM_MINIMIZEEND        = &H0017???

'#if(_WIN32_WINNT >= 0x0600)
%EVENT_SYSTEM_DESKTOPSWITCH      = &H0020???
'#endif /* _WIN32_WINNT >= 0x0600 */

'#if(_WIN32_WINNT >= 0x0501)
%EVENT_CONSOLE_CARET             = &H4001???
%EVENT_CONSOLE_UPDATE_REGION     = &H4002???
%EVENT_CONSOLE_UPDATE_SIMPLE     = &H4003???
%EVENT_CONSOLE_UPDATE_SCROLL     = &H4004???
%EVENT_CONSOLE_LAYOUT            = &H4005???
%EVENT_CONSOLE_START_APPLICATION = &H4006???
%EVENT_CONSOLE_END_APPLICATION   = &H4007???

'/*
' * Flags for EVENT_CONSOLE_START/END_APPLICATION.
' */
'#if defined(_WIN64)
'#define CONSOLE_APPLICATION_16BIT       0x0000
'#else
'#define CONSOLE_APPLICATION_16BIT       0x0001
'#endif
%CONSOLE_APPLICATION_16BIT       = &H0001???

'/*
' * Flags for EVENT_CONSOLE_CARET
' */
%CONSOLE_CARET_SELECTION         = &H0001???
%CONSOLE_CARET_VISIBLE           = &H0002???

%EVENT_OBJECT_CREATE                 = &H8000???  ' hwnd + ID + idChild is created item
%EVENT_OBJECT_DESTROY                = &H8001???  ' hwnd + ID + idChild is destroyed item
%EVENT_OBJECT_SHOW                   = &H8002???  ' hwnd + ID + idChild is shown item
%EVENT_OBJECT_HIDE                   = &H8003???  ' hwnd + ID + idChild is hidden item
%EVENT_OBJECT_REORDER                = &H8004???  ' hwnd + ID + idChild is parent of zordering children

'/*
' * NOTE:
' * Minimize the number of notifications!
' *
' * When you are hiding a parent object, obviously all child objects are no
' * longer visible on screen.  They still have the same "visible" status,
' * but are not truly visible.  Hence do not send HIDE notifications for the
' * children also.  One implies all.  The same goes for SHOW.
' */

%EVENT_OBJECT_FOCUS                  = &H8005???  ' hwnd + ID + idChild is focused item
%EVENT_OBJECT_SELECTION              = &H8006???  ' hwnd + ID + idChild is selected item (if only one), or idChild is OBJID_WINDOW if complex
%EVENT_OBJECT_SELECTIONADD           = &H8007???  ' hwnd + ID + idChild is item added
%EVENT_OBJECT_SELECTIONREMOVE        = &H8008???  ' hwnd + ID + idChild is item removed
%EVENT_OBJECT_SELECTIONWITHIN        = &H8009???  ' hwnd + ID + idChild is parent of changed selected items

%EVENT_OBJECT_STATECHANGE            = &H800A???  ' hwnd + ID + idChild is item w/ state change

'/*
' * Examples of when to send an EVENT_OBJECT_STATECHANGE include
' *      * It is being enabled/disabled (USER does for windows)
' *      * It is being pressed/released (USER does for buttons)
' *      * It is being checked/unchecked (USER does for radio/check buttons)
' */
%EVENT_OBJECT_LOCATIONCHANGE         = &H800B???  ' hwnd + ID + idChild is moved/sized item

'/*
' * Note:
' * A LOCATIONCHANGE is not sent for every child object when the parent
' * changes shape/moves.  Send one notification for the topmost object
' * that is changing.  For example, if the user resizes a top level window,
' * USER will generate a LOCATIONCHANGE for it, but not for the menu bar,
' * title bar, scrollbars, etc.  that are also changing shape/moving.
' *
' * In other words, it only generates LOCATIONCHANGE notifications for
' * real windows that are moving/sizing.  It will not generate a LOCATIONCHANGE
' * for every non-floating child window when the parent moves (the children are
' * logically moving also on screen, but not relative to the parent).
' *
' * Now, if the app itself resizes child windows as a result of being
' * sized, USER will generate LOCATIONCHANGEs for those dudes also because
' * it doesn't know better.
' *
' * Note also that USER will generate LOCATIONCHANGE notifications for two
' * non-window sys objects:
' *      (1) System caret
' *      (2) Cursor
' */

%EVENT_OBJECT_NAMECHANGE             = &H800C???  ' hwnd + ID + idChild is item w/ name change
%EVENT_OBJECT_DESCRIPTIONCHANGE      = &H800D???  ' hwnd + ID + idChild is item w/ desc change
%EVENT_OBJECT_VALUECHANGE            = &H800E???  ' hwnd + ID + idChild is item w/ value change
%EVENT_OBJECT_PARENTCHANGE           = &H800F???  ' hwnd + ID + idChild is item w/ new parent
%EVENT_OBJECT_HELPCHANGE             = &H8010???  ' hwnd + ID + idChild is item w/ help change
%EVENT_OBJECT_DEFACTIONCHANGE        = &H8011???  ' hwnd + ID + idChild is item w/ def action change
%EVENT_OBJECT_ACCELERATORCHANGE      = &H8012???  ' hwnd + ID + idChild is item w/ keybd accel change

'#if(_WIN32_WINNT >= 0x0600)
%EVENT_OBJECT_INVOKED                = &H8013???  ' // hwnd + ID + idChild is item invoked
%EVENT_OBJECT_TEXTSELECTIONCHANGED   = &H8014???  ' // hwnd + ID + idChild is item w? test selection change

'/*
' * EVENT_OBJECT_CONTENTSCROLLED
' * Sent when ending the scrolling of a window object.
' *
' * Unlike the similar event (EVENT_SYSTEM_SCROLLEND), this event will be
' * associated with the scrolling window itself. There is no difference
' * between horizontal or vertical scrolling.
' *
' * This event should be posted whenever scroll action is completed, including
' * when it is scrolled by scroll bars, mouse wheel, or keyboard navigations.
' *
' *   example:
' *          hwnd == window that is scrolling
' *          idObject == OBJID_CLIENT
' *          idChild == CHILDID_SELF
' */
%EVENT_OBJECT_CONTENTSCROLLED        = &H8015???
'#endif /* _WIN32_WINNT >= 0x0600 */

'/*
' * Child IDs
' */

'/*
' * System Sounds (idChild of system SOUND notification)
' */
%SOUND_SYSTEM_STARTUP          = 1&
%SOUND_SYSTEM_SHUTDOWN         = 2&
%SOUND_SYSTEM_BEEP             = 3&
%SOUND_SYSTEM_ERROR            = 4&
%SOUND_SYSTEM_QUESTION         = 5&
%SOUND_SYSTEM_WARNING          = 6&
%SOUND_SYSTEM_INFORMATION      = 7&
%SOUND_SYSTEM_MAXIMIZE         = 8&
%SOUND_SYSTEM_MINIMIZE         = 9&
%SOUND_SYSTEM_RESTOREUP        = 10&
%SOUND_SYSTEM_RESTOREDOWN      = 11&
%SOUND_SYSTEM_APPSTART         = 12&
%SOUND_SYSTEM_FAULT            = 13&
%SOUND_SYSTEM_APPEND           = 14&
%SOUND_SYSTEM_MENUCOMMAND      = 15&
%SOUND_SYSTEM_MENUPOPUP        = 16&
%CSOUND_SYSTEM                 = 16&

'/*
' * System Alerts (indexChild of system ALERT notification)
' */
%ALERT_SYSTEM_INFORMATIONAL    = 1&       ' MB_INFORMATION
%ALERT_SYSTEM_WARNING          = 2&       ' MB_WARNING
%ALERT_SYSTEM_ERROR            = 3&       ' MB_ERROR
%ALERT_SYSTEM_QUERY            = 4&       ' MB_QUESTION
%ALERT_SYSTEM_CRITICAL         = 5&       ' HardSysErrBox
%CALERT_SYSTEM                 = 6&

TYPE GUITHREADINFO
   cbSize        AS DWORD   ' DWORD   cbSize
   flags         AS DWORD   ' DWORD   flags
   hwndActive    AS DWORD   ' HWND    hwndActive
   hwndFocus     AS DWORD   ' HWND    hwndFocus
   hwndCapture   AS DWORD   ' HWND    hwndCapture
   hwndMenuOwner AS DWORD   ' HWND    hwndMenuOwner
   hwndMoveSize  AS DWORD   ' HWND    hwndMoveSize
   hwndCaret     AS DWORD   ' HWND    hwndCaret
   rcCaret       AS RECT    ' RECT    rcCaret
END TYPE

%GUI_CARETBLINKING   = &H00000001???
%GUI_INMOVESIZE      = &H00000002???
%GUI_INMENUMODE      = &H00000004???
%GUI_SYSTEMMENUMODE  = &H00000008???
%GUI_POPUPMENUMODE   = &H00000010???
'#if(_WIN32_WINNT >= 0x0501)
'#if defined(_WIN64)
'#define GUI_16BITTASK       0x00000000
'#else
'#define GUI_16BITTASK       0x00000020
'#endif
%GUI_16BITTASK       = &H00000020???

DECLARE FUNCTION GetGUIThreadInfo LIB "USER32.DLL" ALIAS "GetGUIThreadInfo" ( _
   BYVAL DWORD _                       ' __in DWORD idThread
 , BYREF GUITHREADINFO _               ' __inout PGUITHREADINFO pgui
 ) AS LONG                             ' BOOL

DECLARE FUNCTION BlockInput LIB "USER32.DLL" ALIAS "BlockInput" ( _
   BYVAL LONG _                        ' BOOL fBlockIt
 ) AS LONG                             ' BOOL

'#if(_WIN32_WINNT >= 0x0600)

%USER_DEFAULT_SCREEN_DPI = 96

DECLARE FUNCTION SetProcessDPIAware LIB "USER32.DLL" ALIAS "SetProcessDPIAware" ( _
 ) AS LONG                             ' BOOL

DECLARE FUNCTION IsProcessDPIAware LIB "USER32.DLL" ALIAS "IsProcessDPIAware" ( _
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >= 0x0600 */

DECLARE FUNCTION GetWindowModuleFileName LIB "USER32.DLL" ALIAS "GetWindowModuleFileNameA" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYREF ASCIIZ _                      ' __out_ecount_part(cchFileNameMax, return) LPSTR pszFileName
 , BYVAL DWORD _                       ' __in UINT cchFileNameMax
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetWindowModuleFileNameW LIB "USER32.DLL" ALIAS "GetWindowModuleFileNameW" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL DWORD _                       ' __out_ecount_part(cchFileNameMax, return) LPWSTR pszFileName
 , BYVAL DWORD _                       ' __in UINT cchFileNameMax
 ) AS DWORD                            ' UINT

'#ifndef NO_STATE_FLAGS
'#IF NOT %DEF(%NO_STATE_FLAGS)
%STATE_SYSTEM_UNAVAILABLE     = &H00000001???  ' Disabled
%STATE_SYSTEM_SELECTED        = &H00000002???
%STATE_SYSTEM_FOCUSED         = &H00000004???
%STATE_SYSTEM_PRESSED         = &H00000008???
%STATE_SYSTEM_CHECKED         = &H00000010???
%STATE_SYSTEM_MIXED           = &H00000020???  ' 3-state checkbox or toolbar button
%STATE_SYSTEM_INDETERMINATE   = %STATE_SYSTEM_MIXED
%STATE_SYSTEM_READONLY        = &H00000040???
%STATE_SYSTEM_HOTTRACKED      = &H00000080???
%STATE_SYSTEM_DEFAULT         = &H00000100???
%STATE_SYSTEM_EXPANDED        = &H00000200???
%STATE_SYSTEM_COLLAPSED       = &H00000400???
%STATE_SYSTEM_BUSY            = &H00000800???
%STATE_SYSTEM_FLOATING        = &H00001000???  ' Children "owned" not "contained" by parent
%STATE_SYSTEM_MARQUEED        = &H00002000???
%STATE_SYSTEM_ANIMATED        = &H00004000???
%STATE_SYSTEM_INVISIBLE       = &H00008000???
%STATE_SYSTEM_OFFSCREEN       = &H00010000???
%STATE_SYSTEM_SIZEABLE        = &H00020000???
%STATE_SYSTEM_MOVEABLE        = &H00040000???
%STATE_SYSTEM_SELFVOICING     = &H00080000???
%STATE_SYSTEM_FOCUSABLE       = &H00100000???
%STATE_SYSTEM_SELECTABLE      = &H00200000???
%STATE_SYSTEM_LINKED          = &H00400000???
%STATE_SYSTEM_TRAVERSED       = &H00800000???
%STATE_SYSTEM_MULTISELECTABLE = &H01000000???  ' Supports multiple selection
%STATE_SYSTEM_EXTSELECTABLE   = &H02000000???  ' Supports extended selection
%STATE_SYSTEM_ALERT_LOW       = &H04000000???  ' This information is of low priority
%STATE_SYSTEM_ALERT_MEDIUM    = &H08000000???  ' This information is of medium priority
%STATE_SYSTEM_ALERT_HIGH      = &H10000000???  ' This information is of high priority
%STATE_SYSTEM_PROTECTED       = &H20000000???  ' access to this is restricted
%STATE_SYSTEM_VALID           = &H3FFFFFFF???
'#ENDIF
'#endif

%CCHILDREN_TITLEBAR   = 5&
%CCHILDREN_SCROLLBAR  = 5&

'/*
' * Information about the global cursor.
' */

TYPE CURSORINFO
   cbSize      AS DWORD      ' DWORD   cbSize
   flags       AS DWORD      ' DWORD   flags
   hCursor     AS DWORD      ' HCURSOR hCursor
   ptScreenPos AS POINTAPI   ' POINT   ptScreenPos
END TYPE

%CURSOR_SHOWING    = &H00000001???

DECLARE FUNCTION GetCursorInfo LIB "USER32.DLL" ALIAS "GetCursorInfo" ( _
   BYREF CURSORINFO _                  ' __inout PCURSORINFO pci
 ) AS LONG                             ' BOOL

'/*
' * Window information snapshot
' */

TYPE WINDOWINFO
   cbSize          AS DWORD   ' DWORD cbSize
   rcWindow        AS RECT    ' RECT rcWindow
   rcClient        AS RECT    ' RECT rcClient
   dwStyle         AS DWORD   ' DWORD dwStyle
   dwExStyle       AS DWORD   ' DWORD dwExStyle
   dwWindowStatus  AS DWORD   ' DWORD dwWindowStatus
   cxWindowBorders AS DWORD   ' UINT cxWindowBorders
   cyWindowBorders AS DWORD   ' UINT cyWindowBorders
   atomWindowType  AS WORD    ' ATOM atomWindowType
   wCreatorVersion AS WORD    ' WORD wCreatorVersion
END TYPE

%WS_ACTIVECAPTION  = &H0001???

DECLARE FUNCTION GetWindowInfo LIB "USER32.DLL" ALIAS "GetWindowInfo" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYREF WINDOWINFO _                  ' __inout PWINDOWINFO pwi
 ) AS LONG                             ' BOOL

'/*
' * Titlebar information.
' */

TYPE TITLEBARINFO
   cbSize     AS DWORD                      ' DWORD cbSize
   rcTitleBar AS RECT                       ' RECT rcTitleBar
   rgstate (%CCHILDREN_TITLEBAR) AS DWORD   ' DWORD rgstate[CCHILDREN_TITLEBAR + 1]
END TYPE

DECLARE FUNCTION GetTitleBarInfo LIB "USER32.DLL" ALIAS "GetTitleBarInfo" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYREF TITLEBARINFO _                ' __inout PTITLEBARINFO pti
 ) AS LONG                             ' BOOL

'#if(WINVER >= 0x0600)
TYPE TITLEBARINFOEX
   cbSize                       AS DWORD
   rcTitleBar                   AS RECT
   rgstate(%CCHILDREN_TITLEBAR) AS DWORD
   rgrect(%CCHILDREN_TITLEBAR)  AS RECT
END TYPE
'#endif /* WINVER >= 0x0600 */

'/*
' * Menubar information
' */

TYPE MENUBARINFO
   cbSize      AS DWORD               ' DWORD cbSize
   rcBar       AS RECT                ' RECT rcBar;          // rect of bar, popup, item
   hMenu       AS DWORD               ' HMENU hMenu;         // real menu handle of bar, popup
   hwndMenu    AS DWORD               ' hwnd of item submenu if one
   fBarFocused AS BIT * 1 IN DWORD    ' BOOL fBarFocused:1;  // bar, popup has the focus
   fFocused    AS BIT * 1             ' BOOL fFocused:1;     // item has the focus
END TYPE

DECLARE FUNCTION GetMenuBarInfo LIB "USER32.DLL" ALIAS "GetMenuBarInfo" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL LONG _                        ' __in LONG idObject
 , BYVAL LONG _                        ' __in LONG idItem
 , BYREF MENUBARINFO _                 ' __inout PMENUBARINFO pmbi
 ) AS LONG                             ' BOOL

'/*
' * Scrollbar information
' */

TYPE SCROLLBARINFO
   cbSize        AS DWORD                    ' DWORD cbSize
   rcScrollBar   AS RECT                     ' RECT rcScrollBar
   dxyLineButton AS LONG                     ' int dxyLineButton
   xyThumbTop    AS LONG                     ' int xyThumbTop
   xyThumbBottom AS LONG                     ' int xyThumbBottom
   reserved      AS LONG                     ' int reserved
   rgstate (%CCHILDREN_SCROLLBAR) AS DWORD   ' DWORD rgstate[CCHILDREN_SCROLLBAR + 1]
END TYPE

DECLARE FUNCTION GetScrollBarInfo LIB "USER32.DLL" ALIAS "GetScrollBarInfo" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL LONG _                        ' __in LONG idObject
 , BYREF SCROLLBARINFO _               ' __inout PSCROLLBARINFO psbi
 ) AS LONG                             ' BOOL

'/*
' * Combobox information
' */

TYPE COMBOBOXINFO
   cbSize      AS DWORD   ' DWORD cbSize
   rcItem      AS RECT    ' RECT rcItem
   rcButton    AS RECT    ' RECT rcButton
   stateButton AS DWORD   ' DWORD stateButton
   hwndCombo   AS DWORD   ' HWND hwndCombo
   hwndItem    AS DWORD   ' HWND hwndItem
   hwndList    AS DWORD   ' HWND hwndList
END TYPE

DECLARE FUNCTION GetComboBoxInfo LIB "USER32.DLL" ALIAS "GetComboBoxInfo" ( _
   BYVAL DWORD _                       ' __in HWND hwndCombo
 , BYREF COMBOBOXINFO _                ' __inout PCOMBOBOXINFO pcbi
 ) AS LONG                             ' BOOL

'/*
' * The "real" ancestor window
' */
%GA_PARENT    = 1&
%GA_ROOT      = 2%
%GA_ROOTOWNER = 3&

DECLARE FUNCTION GetAncestor LIB "USER32.DLL" ALIAS "GetAncestor" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL DWORD _                       ' __in UINT gaFlags
 ) AS DWORD                            ' HWND

'/*
' * This gets the REAL child window at the point.  If it is in the dead
' * space of a group box, it will try a sibling behind it.  But static
' * fields will get returned.  In other words, it is kind of a cross between
' * ChildWindowFromPointEx and WindowFromPoint.
' */

' Uses x, y for compatibility with PB's include file...
DECLARE FUNCTION RealChildWindowFromPoint LIB "USER32.DLL" ALIAS "RealChildWindowFromPoint" ( _
   BYVAL DWORD _                    ' __in HWND hwndParent
 , BYVAL LONG _                     ' __in x
 , BYVAL LONG _                     ' __in y
 ) AS DWORD                         ' HWND

' ... but it should be
'DECLARE FUNCTION RealChildWindowFromPoint LIB "USER32.DLL" ALIAS "RealChildWindowFromPoint" ( _
'   BYVAL DWORD _                    ' __in HWND hwndParent
' , BYVAL POINTAPI _                 ' __in POINT ptParentClientCoords
' ) AS DWORD                         ' HWND

'/*
' * This gets the name of the window TYPE, not class.  This allows us to
' * recognize ThunderButton32 et al.
' */

DECLARE FUNCTION RealGetWindowClass LIB "USER32.DLL" ALIAS "RealGetWindowClassA" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYREF ASCIIZ _                      ' __out_ecount_part(cchClassNameMax, return) LPSTR ptszClassName
 , BYVAL DWORD _                       ' __in UINT cchClassNameMax
 ) AS DWORD                            ' UINT

'/*
' * This gets the name of the window TYPE, not class.  This allows us to
' * recognize ThunderButton32 et al.
' */

DECLARE FUNCTION RealGetWindowClassW LIB "USER32.DLL" ALIAS "RealGetWindowClassW" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 , BYVAL DWORD _                       ' __out_ecount_part(cchClassNameMax, return) LPWSTR ptszClassName
 , BYVAL DWORD _                       ' __in UINT cchClassNameMax
 ) AS DWORD                            ' UINT

'/*
' * Alt-Tab Switch window information.
' */

TYPE ALTTABINFO
   cbSize    AS DWORD      ' DWORD cbSize
   cItems    AS LONG       ' int cItems
   cColumns  AS LONG       ' int cColumns
   cRows     AS LONG       ' int cRows
   iColFocus AS LONG       ' int iColFocus
   iRowFocus AS LONG       ' int iRowFocus
   cxItem    AS LONG       ' int cxItem
   cyItem    AS LONG       ' int cyItem
   ptStart   AS POINTAPI   ' POINT ptStart
END TYPE

DECLARE FUNCTION GetAltTabInfo LIB "USER32.DLL" ALIAS "GetAltTabInfoA" ( _
   BYVAL DWORD _                       ' __in_opt HWND hwnd
 , BYVAL LONG _                        ' __in int iItem
 , BYREF ALTTABINFO  _                 ' __inout PALTTABINFO pati
 , BYREF ASCIIZ _                      ' __out_ecount_opt(cchItemText) LPSTR pszItemText
 , BYVAL DWORD _                       ' __in UINT cchItemText
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetAltTabInfoW LIB "USER32.DLL" ALIAS "GetAltTabInfoW" ( _
   BYVAL DWORD _                       ' __in_opt HWND hwnd
 , BYVAL LONG _                        ' __in int iItem
 , BYREF ALTTABINFO _                  ' __inout PALTTABINFO pati
 , BYVAL DWORD _                       ' __out_ecount_opt(cchItemText) LPWSTR pszItemText
 , BYVAL DWORD _                       ' __in UINT cchItemText
 ) AS LONG                             ' BOOL

'/*
' * Listbox information.
' * Returns the number of items per row.
' */

DECLARE FUNCTION GetListBoxInfo LIB "USER32.DLL" ALIAS "GetListBoxInfo" ( _
   BYVAL DWORD _                       ' __in HWND hwnd
 ) AS DWORD                            ' DWORD

'#endif /* NOWINABLE */
'#ENDIF   ' #IF NOT %DEF(%NOWINABLE) ' -----------------------------------------
'#endif /* WINVER >= 0x0500 */


'#if(_WIN32_WINNT >= 0x0500)
DECLARE FUNCTION LockWorkStation LIB "USER32.DLL" ALIAS "LockWorkStation" ( _
 ) AS LONG                             ' BOOL
'#endif /* _WIN32_WINNT >= 0x0500 */

'#if(_WIN32_WINNT >= 0x0500)

DECLARE FUNCTION UserHandleGrantAccess LIB "USER32.DLL" ALIAS "UserHandleGrantAccess" ( _
   BYVAL DWORD _                       ' __in HANDLE hUserHandle
 , BYVAL DWORD _                       ' __in HANDLE hJob
 , BYVAL LONG _                        ' __in BOOL   bGrant
 ) AS LONG                             ' BOOL


'/*
' * Use this macro to get the input code from wParam.
' */
'#define GET_RAWINPUT_CODE_WPARAM(wParam)    ((wParam) & 0xff)
MACRO GET_RAWINPUT_CODE_WPARAM(wParam) =  wParam AND %Hff

'/*
' * The input is in the regular message flow,
' * the app is required to call DefWindowProc
' * so that the system can perform clean ups.
' */
%RIM_INPUT     = 0&

'/*
' * The input is sink only. The app is expected
' * to behave nicely.
' */
%RIM_INPUTSINK = 1&

'/*
' * Raw Input data header
' */

TYPE RAWINPUTHEADER
   dwType  AS DWORD   ' DWORD dwType
   dwSize  AS DWORD   ' DWORD dwSize
   hDevice AS DWORD   ' HANDLE hDevice
   wParam  AS LONG    ' WPARAM wParam
END TYPE

'/*
' * Type of the raw input
' */
%RIM_TYPEMOUSE    = 0&
%RIM_TYPEKEYBOARD = 1&
%RIM_TYPEHID      = 2&


TYPE RAWMOUSEBUTTON
   usButtonFlags AS WORD
   usButtonData  AS WORD
END TYPE

UNION RAWMOUSEUNION
   ulButtons AS DWORD
   fd        AS RAWMOUSEBUTTON
END UNION

TYPE RAWMOUSE
   usFlags            AS WORD            ' indicator flags
   rm                 AS RAWMOUSEUNION   ' the transition state of the mouse buttons
   ulRawButtons       AS DWORD           ' the raw state of the mouse buttons
   lLastX             AS LONG            ' the signed relative or absolute motion in the X direction
   lLastY             AS LONG            ' the signed relative or absolute motion in the Y direction
   ulExtraInformation AS DWORD           ' device-specific additional information for the event
END TYPE

'/*
' * Define the mouse button state indicators.
' */

%RI_MOUSE_LEFT_BUTTON_DOWN   = &H0001??  ' Left Button changed to down.
%RI_MOUSE_LEFT_BUTTON_UP     = &H0002??  ' Left Button changed to up.
%RI_MOUSE_RIGHT_BUTTON_DOWN  = &H0004??  ' Right Button changed to down.
%RI_MOUSE_RIGHT_BUTTON_UP    = &H0008??  ' Right Button changed to up.
%RI_MOUSE_MIDDLE_BUTTON_DOWN = &H0010??  ' Middle Button changed to down.
%RI_MOUSE_MIDDLE_BUTTON_UP   = &H0020??  ' Middle Button changed to up.

%RI_MOUSE_BUTTON_1_DOWN      = %RI_MOUSE_LEFT_BUTTON_DOWN
%RI_MOUSE_BUTTON_1_UP        = %RI_MOUSE_LEFT_BUTTON_UP
%RI_MOUSE_BUTTON_2_DOWN      = %RI_MOUSE_RIGHT_BUTTON_DOWN
%RI_MOUSE_BUTTON_2_UP        = %RI_MOUSE_RIGHT_BUTTON_UP
%RI_MOUSE_BUTTON_3_DOWN      = %RI_MOUSE_MIDDLE_BUTTON_DOWN
%RI_MOUSE_BUTTON_3_UP        = %RI_MOUSE_MIDDLE_BUTTON_UP

%RI_MOUSE_BUTTON_4_DOWN      = &H0040??
%RI_MOUSE_BUTTON_4_UP        = &H0080??
%RI_MOUSE_BUTTON_5_DOWN      = &H0100??
%RI_MOUSE_BUTTON_5_UP        = &H0200??

'/*
' * If usButtonFlags has RI_MOUSE_WHEEL, the wheel delta is stored in usButtonData.
' * Take it as a signed value.
' */
%RI_MOUSE_WHEEL              = &H0400??

'/*
' * Define the mouse indicator flags.
' */
%MOUSE_MOVE_RELATIVE      = 0???
%MOUSE_MOVE_ABSOLUTE      = 1???
%MOUSE_VIRTUAL_DESKTOP    = &H02???  ' the coordinates are mapped to the virtual desktop
%MOUSE_ATTRIBUTES_CHANGED = &H04???  ' requery for mouse attributes
'#if(WINVER >= 0x0600)
%MOUSE_MOVE_NOCOALESCE    = &H08???  ' // do not coalesce mouse moves
'#endif /* WINVER >= 0x0600 */


TYPE RAWKEYBOARD
   MakeCode         AS WORD    ' the "make" scan code (key depression)
   Flags            AS WORD    ' the flags field indicates a "break" (key release) and other
   Reserved         AS WORD    ' miscellaneous scan code information defined in ntddkbd.h
   VKey             AS WORD    ' Windows message compatible information
   Message          AS DWORD
   ExtraInformation AS DWORD   ' device-specific additional information for the event
END TYPE

'/*
' * Define the keyboard overrun MakeCode.
' */

%KEYBOARD_OVERRUN_MAKE_CODE  = &HFF??

'/*
' * Define the keyboard input data Flags.
' */
%RI_KEY_MAKE             = 0??
%RI_KEY_BREAK            = 1??
%RI_KEY_E0               = 2??
%RI_KEY_E1               = 4??
%RI_KEY_TERMSRV_SET_LED  = 8??
%RI_KEY_TERMSRV_SHADOW   = &H10??

'/*
' * Raw format of the input from Human Input Devices
' */

TYPE RAWHID
   dwSizeHid    AS DWORD   ' DWORD dwSizeHid;    // byte size of each report
   dwCount      AS DWORD   ' DWORD dwCount;      // number of input packed
   bRawData (0) AS BYTE    ' BYTE  bRawData[1]
END TYPE

'/*
' * RAWINPUT data structure.
' */
'typedef struct tagRAWINPUT {
'    RAWINPUTHEADER header;
'    union {
'        RAWMOUSE    mouse;
'        RAWKEYBOARD keyboard;
'        RAWHID      hid;
'    } data;
'} RAWINPUT, *PRAWINPUT, *LPRAWINPUT;

UNION RAWINPUTUNION
   mouse     AS RAWMOUSE      ' RAWMOUSE    mouse
   keyboard  AS RAWKEYBOARD   ' RAWKEYBOARD keyboard
   hid       AS RAWHID        ' RAWHID      hid
END UNION

TYPE RAWINPUT
   header AS RAWINPUTHEADER
   data   AS RAWINPUTUNION
END TYPE

'#ifdef _WIN64
'#define RAWINPUT_ALIGN(x)   (((x) + sizeof(QWORD) - 1) & ~(sizeof(QWORD) - 1))
'#else   // _WIN64
'#define RAWINPUT_ALIGN(x)   (((x) + sizeof(DWORD) - 1) & ~(sizeof(DWORD) - 1))
'#endif  // _WIN64

'#define NEXTRAWINPUTBLOCK(ptr) ((PRAWINPUT)RAWINPUT_ALIGN((ULONG_PTR)((PBYTE)(ptr) + (ptr)->header.dwSize)))

'/*
' * Flags for GetRawInputData
' */

%RID_INPUT  = &H10000003???
%RID_HEADER = &H10000005???

DECLARE FUNCTION GetRawInputData LIB "USER32.DLL" ALIAS "GetRawInputData" ( _
   BYVAL DWORD _                       ' __in HRAWINPUT hRawInput
 , BYVAL DWORD _                       ' __in UINT uiCommand
 , BYREF ANY _                         ' __out_bcount_part_opt(*pcbSize, return) LPVOID pData
 , BYREF DWORD _                       ' __inout PUINT pcbSize
 , BYVAL DWORD _                       ' __in UINT cbSizeHeader
 ) AS DWORD                            ' UINT

'/*
' * Raw Input Device Information
' */
%RIDI_PREPARSEDDATA = &H20000005???
%RIDI_DEVICENAME    = &H20000007??? ' the return value is the character length, not the byte size
%RIDI_DEVICEINFO    = &H2000000b???

TYPE RID_DEVICE_INFO_MOUSE
   dwId              AS DWORD   ' DWORD dwId
   dwNumberOfButtons AS DWORD   ' DWORD dwNumberOfButtons
   dwSampleRate      AS DWORD   ' DWORD dwSampleRate
END TYPE

TYPE RID_DEVICE_INFO_KEYBOARD
   dwType                 AS DWORD   ' DWORD dwType
   dwSubType              AS DWORD   ' DWORD dwSubType
   dwKeyboardMode         AS DWORD   ' DWORD dwKeyboardMode
   dwNumberOfFunctionKeys AS DWORD   ' DWORD dwNumberOfFunctionKeys
   dwNumberOfIndicators   AS DWORD   ' DWORD dwNumberOfIndicators
   dwNumberOfKeysTotal    AS DWORD   ' DWORD dwNumberOfKeysTotal
END TYPE

TYPE RID_DEVICE_INFO_HID
   dwVendorId      AS DWORD   ' DWORD dwVendorId
   dwProductId     AS DWORD   ' DWORD dwProductId
   dwVersionNumber AS DWORD   ' DWORD dwVersionNumber
   ' Top level collection UsagePage and Usage
   usUsagePage     AS WORD    ' USHORT usUsagePage
   usUsage         AS WORD    ' USHORT usUsage
END TYPE

'typedef struct tagRID_DEVICE_INFO {
'    DWORD cbSize;
'    DWORD dwType;
'    union {
'        RID_DEVICE_INFO_MOUSE mouse;
'        RID_DEVICE_INFO_KEYBOARD keyboard;
'        RID_DEVICE_INFO_HID hid;
'    };
'} RID_DEVICE_INFO, *PRID_DEVICE_INFO, *LPRID_DEVICE_INFO;

UNION RID_DEVICE_INFO_UNION
   mouse    AS RID_DEVICE_INFO_MOUSE      ' RID_DEVICE_INFO_MOUSE mouse
   keyboard AS RID_DEVICE_INFO_KEYBOARD   ' RID_DEVICE_INFO_KEYBOARD keyboard
   hid      AS RID_DEVICE_INFO_HID        ' RID_DEVICE_INFO_HID hid
END UNION

TYPE RID_DEVICE_INFO
   cbSize AS DWORD                   ' DWORD cbSize
   dwType AS DWORD                   ' DWORD dwType
   RID_DEVICE_INFO_UNION
END TYPE

DECLARE FUNCTION GetRawInputDeviceInfo LIB "USER32.DLL" ALIAS "GetRawInputDeviceInfoA" ( _
   BYVAL DWORD _                       ' __in_opt HANDLE hDevice
 , BYVAL DWORD _                       ' __in UINT uiCommand
 , BYREF ANY _                         ' __inout_bcount_part_opt(*pcbSize, return) LPVOID pData
 , BYREF DWORD _                       ' __inout PUINT pcbSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION GetRawInputDeviceInfoW LIB "USER32.DLL" ALIAS "GetRawInputDeviceInfoW" ( _
   BYVAL DWORD _                       ' __in_opt HANDLE hDevice
 , BYVAL DWORD _                       ' __in UINT uiCommand
 , BYREF ANY _                         ' __inout_bcount_part_opt(*pcbSize, return) LPVOID pData
 , BYREF DWORD _                       ' __inout PUINT pcbSize
 ) AS DWORD                            ' UINT

'/*
' * Raw Input Bulk Read: GetRawInputBuffer
' */

DECLARE FUNCTION GetRawInputBuffer LIB "USER32.DLL" ALIAS "GetRawInputBuffer" ( _
   BYREF RAWINPUT _                    ' __out_bcount_opt(*pcbSize) PRAWINPUT pData
 , BYREF DWORD _                       ' __inout PUINT pcbSize
 , BYVAL DWORD _                       ' __in UINT cbSizeHeader
 ) AS DWORD                            ' UINT

'/*
' * Raw Input request APIs
' */

TYPE RAWINPUTDEVICE
   usUsagePage AS WORD    ' USHORT usUsagePage; // Toplevel collection UsagePage
   usUsage     AS WORD    ' USHORT usUsage;     // Toplevel collection Usage
   dwFlags     AS DWORD   ' DWORD dwFlags
   hwndTarget  AS DWORD   ' HWND hwndTarget;    // Target hwnd. NULL = follows keyboard focus
END TYPE

%RIDEV_REMOVE       = &H00000001???
%RIDEV_EXCLUDE      = &H00000010???
%RIDEV_PAGEONLY     = &H00000020???
%RIDEV_NOLEGACY     = &H00000030???
%RIDEV_CAPTUREMOUSE = &H00000200???  ' effective when mouse nolegacy is specified, otherwise it would be an error
%RIDEV_NOHOTKEYS    = &H00000200???  ' effective for keyboard.
%RIDEV_APPKEYS      = &H00000400???  ' effective for keyboard.
'#if(_WIN32_WINNT >= 0x0501)
%RIDEV_EXINPUTSINK  = &H00001000???
%RIDEV_DEVNOTIFY    = &H00002000???
'#endif /* _WIN32_WINNT >= 0x0501 */
%RIDEV_EXMODEMASK   = &H000000F0???

'#define RIDEV_EXMODE(mode)  ((mode) & RIDEV_EXMODEMASK)
MACRO RIDEV_EXMODE(mode) = mode AND %RIDEV_EXMODEMASK

'#if(_WIN32_WINNT >= 0x0501)
'/*
' * Flags for the WM_INPUT_DEVICE_CHANGE message.
' */
%GIDC_ARRIVAL            = 1
%GIDC_REMOVAL            = 2
'#define GET_DEVICE_CHANGE_LPARAM(lParam)  (LOWORD(lParam))
MACRO GET_DEVICE_CHANGE_LPARAM(lParam) = LO(WORD, lParam)
'#endif /* _WIN32_WINNT >= 0x0501 */

DECLARE FUNCTION RegisterRawInputDevices LIB "USER32.DLL" ALIAS "RegisterRawInputDevices" ( _
   BYREF RAWINPUTDEVICE _              ' __in_ecount(uiNumDevices) PCRAWINPUTDEVICE pRawInputDevices
 , BYVAL DWORD _                       ' __in UINT uiNumDevices
 , BYVAL DWORD _                       ' __in UINT cbSize
 ) AS LONG                             ' BOOL

DECLARE FUNCTION GetRegisteredRawInputDevices LIB "USER32.DLL" ALIAS "GetRegisteredRawInputDevices" ( _
   BYREF RAWINPUTDEVICE _              ' __out_ecount_opt( *puiNumDevices) PRAWINPUTDEVICE pRawInputDevices
 , BYREF DWORD _                       ' __inout PUINT puiNumDevices
 , BYVAL DWORD _                       ' __in UINT cbSize
 ) AS DWORD                            ' UINT

TYPE RAWINPUTDEVICELIST
   hDevice AS DWORD   ' HANDLE hDevice
   dwType  AS DWORD   ' DWORD dwType
END TYPE

DECLARE FUNCTION GetRawInputDeviceList LIB "USER32.DLL" ALIAS "GetRawInputDeviceList" ( _
   BYREF RAWINPUTDEVICELIST _          ' __out_ecount_opt(*puiNumDevices) PRAWINPUTDEVICELIST pRawInputDeviceList
 , BYREF DWORD _                       ' __inout PUINT puiNumDevices
 , BYVAL DWORD _                       ' __in UINT cbSize
 ) AS DWORD                            ' UINT

DECLARE FUNCTION DefRawInputProc LIB "USER32.DLL" ALIAS "DefRawInputProc" ( _
   BYREF RAWINPUT _                    ' __in_ecount(nInput) PRAWINPUT* paRawInput
 , BYVAL LONG _                        ' __in INT nInput
 , BYVAL DWORD _                       ' __in UINT cbSizeHeader
 ) AS LONG                             ' LRESULT

'#endif /* _WIN32_WINNT >= 0x0501 */

'#if(WINVER >= 0x0600)
%MSGFLT_ADD    = 1
%MSGFLT_REMOVE = 2

DECLARE FUNCTION ChangeWindowMessageFilter LIB "USER32.DLL" ALIAS "ChangeWindowMessageFilter" ( _
   BYVAL DWORD _                       ' __in UINT message
 , BYVAL DWORD _                       ' __in DWORD dwFlag
 ) AS LONG                             ' BOOL
'#endif /* WINVER >= 0x0600 */


%MAX_STR_BLOCKREASON = 256

DECLARE FUNCTION ShutdownBlockReasonCreate LIB "USER32.DLL" ALIAS "ShutdownBlockReasonCreate" ( _
   BYVAL DWORD _                       ' __in HWND hWnd
 , BYVAL DWORD _                       ' __in LPCWSTR pwszReason
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ShutdownBlockReasonQuery LIB "USER32.DLL" ALIAS "ShutdownBlockReasonQuery" ( _
   BYVAL DWORD _                       ' __in  HWND hWnd
 , BYVAL DWORD _                       ' __out LPWSTR pwszBuff
 , BYREF DWORD _                       ' __inout DWORD *pcchBuff
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ShutdownBlockReasonDestroy LIB "USER32.DLL" ALIAS "ShutdownBlockReasonDestroy" ( _
   BYVAL DWORD _                       ' __in  HWND hWnd
 ) AS LONG                             ' BOOL

#ENDIF   ' #IF NOT %DEF(%WINUSER_INC)


' =============================================================================

' File attributes
%Normal   = &B000000
%ReadOnly = &B000001
%Hidden   = &B000010
%System   = &B000100
%vLabel   = &B001000
%SubDir   = &B010000
%Archive  = &B100000

' =============================================================================
' These structures are not defined in any standard header file. The structures
' definitions are provided here to explain the format of an extended template
' for a dialog box.
' =============================================================================

'TYPE DLGTEMPLATEEX
'   dlgVer        AS WORD
'   signature     AS WORD
'   helpID        AS DWORD
'   exStyle       AS DWORD
'   wtyle         AS DWORD
'   cDlgItems     AS WORD
'   x             AS INTEGER
'   y             AS INTEGER
'   cx            AS INTEGER
'   cy            AS INTEGER
'   soMenu        AS STRING * 2   ' *** customize length for your dialog
'   soWindowClass AS STRING * 2   ' *** customize length for your dialog
'   title         AS STRING * 2   ' *** customize length for your dialog
'   pointsize     AS WORD         ' *** member only present if %DS_SETFONT or %DS_SHELLFONT
'   weight        AS WORD         ' *** member only present if %DS_SETFONT or %DS_SHELLFONT
'   italic        AS BYTE         ' *** member only present if %DS_SETFONT or %DS_SHELLFONT
'   charset       AS BYTE         ' *** member only present if %DS_SETFONT or %DS_SHELLFONT
'   typeface      AS STRING * 2   ' *** customize length for your dialog - member only present if %DS_SETFONT or %DS_SHELLFONT
'END TYPE

'TYPE DLGITEMTEMPLATEEX
'   helpID        AS DWORD
'   exStyle       AS DWORD
'   STYLE         AS DWORD
'   x             AS INTEGER
'   y             AS INTEGER
'   cx            AS INTEGER
'   cy            AS INTEGER
'   id            AS WORD
'   soWindowClass AS STRING * 2   ' *** customize length for your dialog
'   title         AS STRING * 2   ' *** customize length for your dialog
'   extraCount    AS WORD
'END TYPE

' =============================================================================


#ENDIF   ' %WINDOWS

#ENDIF   ' %WINDOWS_INC

'// Set packing to 8
'#include <pshpack8.h>


'//+---------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//  File:       objbase.h
'//
'//  Contents:   Component object model defintions.
'//
'//----------------------------------------------------------------------------

#IF NOT %DEF(%OBJBASE_INC)
    %OBJBASE_INC = 1

'//+-------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//--------------------------------------------------------------------------

#IF NOT %DEF(%OBJIDL_INC)
    %OBJIDL_INC = 1

TYPE COSERVERINFO
   dwReserved1 AS DWORD            ' DWORD dwReserved1
   pwszName    AS WORD PTR         ' LPWSTR pwszName
   pAuthInfo   AS COAUTHINFO PTR   ' COAUTHINFO *pAuthInfo
   dwReserved2 AS DWORD            ' DWORD dwReserved2
END TYPE


' ########################################################################################
' IMalloc interface
' IID = 00000002-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMalloc_INTERFACE_DEFINED)
    %IMalloc_INTERFACE_DEFINED = 1

$IID_IMalloc = GUID$("{00000002-0000-0000-C000-000000000046}")

INTERFACE IMalloc $IID_IMalloc

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Alloc ( _                           ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cb
   )                                          ' void
   ' =====================================================================================
   METHOD Realloc ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ void * pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   )                                          ' void
   ' =====================================================================================
   METHOD Free ( _                            ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ void * pv
   )                                          ' void
   ' =====================================================================================
   METHOD GetSize ( _                         ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ void * pv
   ) AS DWORD                                 ' ULONG
   ' =====================================================================================
   METHOD DidAlloc ( _                        ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ void * pv
   ) AS LONG                                  ' int
   ' =====================================================================================
   METHOD HeapMinimize ( _                    ' VTable offset = 32
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMalloc_INTERFACE_DEFINED__ */


' ########################################################################################
' IStdMarshalInfo interface
' IID = 00000018-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IStdMarshalInfo_INTERFACE_DEFINED)
    %IStdMarshalInfo_INTERFACE_DEFINED = 1

$IID_IStdMarshalInfo = GUID$("{00000018-0000-0000-C000-000000000046}")

INTERFACE IStdMarshalInfo $IID_IStdMarshalInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassForHandler ( _              ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYREF GUID _                             ' /* [out] */ CLSID *pClsid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IStdMarshalInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' IExternalConnection interface
' IID = 00000019-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IExternalConnection_INTERFACE_DEFINED)
    %IExternalConnection_INTERFACE_DEFINED = 1

' EXTCONN enum
%EXTCONN_STRONG   = &H1???
%EXTCONN_WEAK     = &H2???
%EXTCONN_CALLABLE = &H4???

$IID_IExternalConnection = GUID$("{00000019-0000-0000-C000-000000000046}")

INTERFACE IExternalConnection $IID_IExternalConnection

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddConnection ( _                   ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD extconn
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved
   ) AS DWORD                                 ' DWORD
   ' =====================================================================================
   METHOD ReleaseConnection ( _               ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD extconn
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved
   , BYVAL DWORD _                            ' /* [in] */ BOOL fLastReleaseCloses
   ) AS DWORD                                 ' DWORD
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IExternalConnection_INTERFACE_DEFINED__ */


TYPE MULTI_QI
   pIID AS GUID    ' const IID *pIID
   pItf AS DWORD   ' IUnknown *pItf
   hr   AS LONG    ' HRESULT hr
END TYPE


' ########################################################################################
' IMultiQI interface
' IID = 00000020-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMultiQI_INTERFACE_DEFINED)
    %IMultiQI_INTERFACE_DEFINED = 1

$IID_IMultiQI = GUID$("{00000020-0000-0000-C000-000000000046}")

INTERFACE IMultiQI $IID_IMultiQI

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryMultipleInterfaces ( _         ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cMQIs
   , BYREF MULTI_QI _                         ' /* [out][in] */ MULTI_QI *pMQIs
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMultiQI_INTERFACE_DEFINED__ */


' ########################################################################################
' IInternalUnknown interface
' IID = 00000021-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IInternalUnknown_INTERFACE_DEFINED)
    %IInternalUnknown_INTERFACE_DEFINED = 1

$IID_IInternalUnknown = GUID$("{00000021-0000-0000-C000-000000000046}")

INTERFACE IInternalUnknown $IID_IInternalUnknown

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryInternalInterface ( _          ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* IInternalUnknown_INTERFACE_DEFINED */


' ########################################################################################
' Interface name = IEnumUnknown
' IID = {00000100-0000-0000-C000-000000000046}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumUnknown_INTERFACE_DEFINED)
    %IEnumUnknown_INTERFACE_DEFINED = 1

$IID_IEnumUnknown = GUID$("{00000100-0000-0000-C000-000000000046}")

INTERFACE IEnumUnknown $IID_IEnumUnknown

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF IUnknown _                         ' /* [out] */ IUnknown * rgelt
   , BYREF DWORD _                            ' /* [out] */ ULONG * pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IUnknown _                         ' /* [out] */ IEnumUnknown** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumUnknown_INTERFACE_DEFINED__ */


' ########################################################################################
' IBindCtx interface
' IID = 0000000E-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IBindCtx_INTERFACE_DEFINED)
    %IBindCtx_INTERFACE_DEFINED = 1

TYPE BIND_OPTS
   cbStruct            AS DWORD   ' DWORD cbStruct
   grfFlags            AS DWORD   ' DWORD grfFlags
   grfMode             AS DWORD   ' DWORD grfMode
   dwTickCountDeadline AS DWORD   ' DWORD dwTickCountDeadline
END TYPE

TYPE BIND_OPTS2
   cbStruct            AS DWORD              ' DWORD cbStruct
   grfFlags            AS DWORD              ' DWORD grfFlags
   grfMode             AS DWORD              ' DWORD grfMode
   dwTickCountDeadline AS DWORD              ' DWORD dwTickCountDeadline
   dwTrackFlags        AS DWORD              ' DWORD dwTrackFlags
   dwClassContext      AS DWORD              ' DWORD dwClassContext
   locale              AS DWORD              ' LCID locale
   pServerInfo         AS COSERVERINFO PTR   ' COSERVERINFO *pServerInfo
END TYPE

' BIND_FLAGS enum
%BIND_MAYBOTHERUSER     = 1
%BIND_JUSTTESTEXISTENCE = 2

$IID_IBindCtx = GUID$("{0000000E-0000-0000-C000-000000000046}")

INTERFACE IBindCtx $IID_IBindCtx

   INHERIT IUnknown

   ' =====================================================================================
   METHOD RegisterObjectBound ( _             ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IUnknown * punk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RevokeObjectBound ( _               ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ IUnknown * punk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseBoundObjects ( _             ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetBindOptions ( _                  ' VTable offset = 24
     BYREF BIND_OPTS _                        ' /* [in] */ BIND_OPTS * pbindopts
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBindOptions ( _                  ' VTable offset = 28
     BYREF BIND_OPTS _                        ' /* [in] */ BIND_OPTS * pbindopts
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetRunningObjectTable ( _           ' VTable offset = 32
     BYREF IUnknown _                         ' /* [in] */ IRunningObjectTable ** pprot
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RegisterObjectParam ( _             ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszKey
   , BYVAL IUnknown _                         ' /* [in] */ IUnknown * punk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetObjectParam ( _                  ' VTable offset = 40
     BYREF DWORD _                            ' /* [in] */ LPOLESTR pszKey
   , BYREF IUnknown _                         ' /* [out] */ IUnknown ** ppunk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumObjectParam ( _                 ' VTable offset = 44
     BYREF IUnknown _                         ' /* [out] */ IEnumString ** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RevokeObjectParam ( _               ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IBindCtx_INTERFACE_DEFINED__ */


' ########################################################################################
' IEnumMoniker interface
' IID = 00000102-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumMoniker_INTERFACE_DEFINED)
    %IEnumMoniker_INTERFACE_DEFINED = 1

$IID_IEnumMoniker = GUID$("{00000102-0000-0000-C000-000000000046}")

INTERFACE IEnumMoniker $IID_IEnumMoniker

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF IUnknown _                         ' /* [out] */ IMoniker * rgelt
   , BYREF DWORD _                            ' /* [out] */ ULONG * pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumMoniker _                     ' /* [out] */ IEnumMoniker** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumMoniker_INTERFACE_DEFINED__ */


' ########################################################################################
' IRunnableObject interface
' IID = F29F6BC0-5021-11CE-AA15-00006901293F
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRunnableObject_INTERFACE_DEFINED)
    %IRunnableObject_INTERFACE_DEFINED = 1

$IID_IRunnableObject = GUID$("{00000126-0000-0000-C000-000000000046}")

INTERFACE IRunnableObject $IID_IRunnableObject

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetRunningClass ( _                 ' VTable offset = 12
     BYREF GUID _                             ' /* [out] */ LPCLSID lpClsid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Run ( _                             ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ LPBINDCTX pbc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsRunning ( _                       ' VTable offset = 20
     ) AS LONG                                ' BOOL
   ' =====================================================================================
   METHOD LockRunning ( _                     ' VTable offset = 24
     BYVAL LONG _                             ' /* [in] */ BOOL fLock
   , BYVAL LONG _                             ' /* [in] */ BOOL fLastUnlockCloses
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetContainedObject ( _              ' VTable offset = 28
     BYVAL LONG _                             ' /* [in] */ BOOL fContained
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRunnableObject_INTERFACE_DEFINED__ */


' ########################################################################################
' IRunningObjectTable interface
' IID = 00000010-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRunningObjectTable_INTERFACE_DEFINED)
    %IRunningObjectTable_INTERFACE_DEFINED = 1

$IID_IRunningObjectTable = GUID$("{00000010-0000-0000-C000-000000000046}")

INTERFACE IRunningObjectTable $IID_IRunningObjectTable

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Register ( _                        ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD grfFlags
   , BYVAL IUnknown _                         ' /* [in] */ IUnknown * punkObject
   , BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkObjectName
   , BYREF DWORD _                            ' /* [out] */ DWORD * pdwRegister
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Revoke ( _                          ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwRegister
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsRunning ( _                       ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkObjectName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetObject ( _                       ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkObjectName
   , BYREF IUnknown _                         ' /* [out] */ IUnknown ** ppunkObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD NoteChangeTime ( _                  ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ DWORD dwRegister
   , BYREF FILETIME _                         ' /* [in] */ FILETIME * pfiletime
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTimeOfLastChange ( _             ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkObjectName
   , BYREF FILETIME _                         ' /* [out] */ FILETIME * pfiletime
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumRunning ( _                     ' VTable offset = 36
     BYREF IUnknown _                         ' /* [out] */ IEnumMoniker ** ppenumMoniker
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRunningObjectTable_INTERFACE_DEFINED__ */


' ########################################################################################
' IPersist interface
' IID = 0000010C-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPersist_INTERFACE_DEFINED)
    %IPersist_INTERFACE_DEFINED = 1

$IID_IPersist = GUID$("{0000010C-0000-0000-C000-000000000046}")

INTERFACE IPersist $IID_IPersist

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
     BYREF GUID _                             ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersist_INTERFACE_DEFINED__ */


' ########################################################################################
' IPersistStream interface
' IID = 00000109-0000-0000-C000-000000000046
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IPersistStream_INTERFACE_DEFINED)
    %IPersistStream_INTERFACE_DEFINED = 1

$IID_IPersistStream = GUID$("{00000109-0000-0000-C000-000000000046}")

INTERFACE IPersistStream $IID_IPersistStream

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
     BYREF GUID _                             ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsDirty ( _                         ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                            ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IStream * pStm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Save ( _                            ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IStream * pStm
   , BYVAL LONG _                             ' */ [in] */ BOOL fClearDirty
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSizeMax ( _                      ' VTable offset = 28
     BYREF QUAD _                             ' /* [out] */  ULARGE_INTEGER * pcbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersistStream_INTERFACE_DEFINED__ */


' ########################################################################################
' IMoniker interface
' IID = 0000000F-0000-0000-C000-000000000046
' Inherited interface = IPersistStream
' ########################################################################################

#IF NOT %DEF(%IMoniker_INTERFACE_DEFINED)
   %IMoniker_INTERFACE_DEFINED = 1

' MKSYS enum
%MKSYS_NONE             = 0
%MKSYS_GENERICCOMPOSITE = 1
%MKSYS_FILEMONIKER      = 2
%MKSYS_ANTIMONIKER      = 3
%MKSYS_ITEMMONIKER      = 4
%MKSYS_POINTERMONIKER   = 5
%MKSYS_CLASSMONIKER     = 7
%MKSYS_OBJREFMONIKER    = 8
%MKSYS_SESSIONMONIKER   = 9
%MKSYS_LUAMONIKER       = 10

' MKRREDUCE enum
%MKRREDUCE_ONE         = 196608 ' 3<<16
%MKRREDUCE_TOUSER      = 131072 ' 2<<16
%MKRREDUCE_THROUGHUSER = 65536  ' 1<<16
%MKRREDUCE_ALL         = 0

$IID_IMoniker = GUID$("{0000000F-0000-0000-C000-000000000046}")

INTERFACE IMoniker $IID_IMoniker

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
     BYREF GUID _                             ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsDirty ( _                         ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                            ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IStream * pStm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Save ( _                            ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IStream * pStm
   , BYVAL LONG _                             ' */ [in] */ BOOL fClearDirty
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSizeMax ( _                      ' VTable offset = 28
     BYREF QUAD _                             ' /* [out] */  ULARGE_INTEGER * pcbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BindToObject ( _                    ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx * pbc
   , BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkToLeft
   , BYREF GUID _                             ' /* [in] */ REFIID riidResult
   , BYREF IUnknown _                         ' /* [out] */ void ** ppvResult
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BindToStorage ( _                   ' VTable offset = 36
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx * pbc
   , BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkToLeft
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void ** ppvObj
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reduce ( _                          ' VTable offset = 40
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx * pbc
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwReduceHowFar
   , BYREF IUnknown _                         ' /* [in, out] */ IMoniker ** ppmkToLeft
   , BYREF IUnknown _                         ' /* [out] IMoniker ** ppmkReduced
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ComposeWith ( _                     ' VTable offset = 44
     BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkRight
   , BYVAL LONG _                             ' /* [in] */ BOOL fOnlyIfNotGeneric
   , BYREF IUnknown _                         ' /* [out] */ IMoniker ** ppmkComposite
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Enum ( _                            ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ BOOL fForward
   , BYREF IUnknown _                         ' /* [out] */ IEnumMoniker ** ppenumMoniker
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsEqual ( _                         ' VTable offset = 52
     BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkOtherMoniker
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Hash ( _                            ' VTable offset = 56
     BYVAL DWORD _                            ' /* [out] */ DWORD * pdwHash
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsRunning ( _                       ' VTable offset = 60
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx * pbc,
   , BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkToLeft
   , BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkNewlyRunning
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetTimeOfLastChange ( _             ' VTable offset = 64
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx * pbc,
   , BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkToLeft
   , BYREF FILETIME _                         ' /* [out] */ FILETIME * pFileTime
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Inverse ( _                         ' VTable offset = 68
     BYREF IUnknown _                         ' /* [out] */ IMoniker ** ppmk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CommonPrefixWith ( _                ' VTable offset = 72
     BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkOther
   , BYREF IUnknown _                         ' /* [out] */ IMoniker ** ppmkPrefix
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RelativePathTo ( _                  ' VTable offset = 76
     BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkOther
   , BYREF IUnknown _                         ' /* [out] */ IMoniker ** ppmkRelPath
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDisplayName ( _                  ' VTable offset = 80
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx * pbc,
   , BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkToLeft
   , BYREF DWORD _                            ' /* [out] */ LPOLESTR * ppszDisplayName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ParseDisplayName ( _                ' VTable offset = 84
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx * pbc,
   , BYVAL IUnknown _                         ' /* [in] */ IMoniker * pmkToLeft
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszDisplayName
   , BYREF LONG _                             ' /* [out] */ ULONG * pchEaten
   , BYREF IUnknown _                         ' /* [out] */ IMoniker ** ppmkOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsSystemMoniker ( _                 ' VTable offset = 88
     BYREF DWORD _                            ' /* [out] */ DWORD * pdwMksys
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMoniker_INTERFACE_DEFINED__ */


' ########################################################################################
' IROTData interface
' IID = F29F6BC0-5021-11CE-AA15-00006901293F
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IROTData_INTERFACE_DEFINED)
   %IROTData_INTERFACE_DEFINED = 1

$IID_IROTData = GUID$("{F29F6BC0-5021-11CE-AA15-00006901293F}")

INTERFACE IROTData $IID_IROTData

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetComparisonData ( _               ' VTable offset = 12
     BYVAL BYTE PTR _                         ' /* [out] */ byte *pbData
   , BYVAL DWORD _                            ' /* [in] */ ULONG cbMax
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcbData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IROTData_INTERFACE_DEFINED__ */


' ########################################################################################
' IEnumString interface
' IID = 00000101-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumString_INTERFACE_DEFINED)
    %IEnumString_INTERFACE_DEFINED = 1

$IID_IEnumString = GUID$("{00000101-0000-0000-C000-000000000046}")

INTERFACE IEnumString $IID_IEnumString

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF DWORD _                            ' /* [out] */ LPOLESTR * rgelt
   , BYREF DWORD _                            ' /* [out] */ ULONG * pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumString _                      ' /* [out] */ IEnumString** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumString_INTERFACE_DEFINED__ */


' ########################################################################################
' ISequentialStream interface
' IID = 0C733A30-2A1C-11CE-ADE5-00AA0044773D
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISequentialStream_INTERFACE_DEFINED)
    %ISequentialStream_INTERFACE_DEFINED = 1

$IID_ISequentialStream = GUID$("{0C733A30-2A1C-11CE-ADE5-00AA0044773D}")

INTERFACE ISequentialStream $IID_ISequentialStream

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Read ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [out] */ void* pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   , BYREF DWORD _                            ' /* [out] ULONG *pcbRead
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Write ( _                           ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ void const* pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcbWritten
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISequentialStream_INTERFACE_DEFINED__ */


' ########################################################################################
' IStream interface
' IID = 0000000C-0000-0000-C000-000000000046
' Inherited interface = ISequentialStream
' ########################################################################################

#IF NOT %DEF(%IStream_INTERFACE_DEFINED)
    %IStream_INTERFACE_DEFINED = 1

TYPE STATSTG
   pwcsName          AS WORD PTR   ' LPOLESTR pwcsName
   type              AS DWORD      ' DWORD type
   cbSize            AS QUAD       ' ULARGE_INTEGER cbSize
   mtime             AS FILETIME   ' FILETIME mtime
   ctime             AS FILETIME   ' FILETIME ctime
   atime             AS FILETIME   ' FILETIME atime
   grfMode           AS DWORD      ' DWORD grfMode
   grfLocksSupported AS DWORD      ' DWORD grfLocksSupported
   clsid             AS GUID       ' CLSID clsid
   grfStateBits      AS DWORD      ' DWORD grfStateBits
   reserved          AS DWORD      ' DWORD reserved
END TYPE

' STGTY enum
%STGTY_STORAGE   = 1
%STGTY_STREAM    = 2
%STGTY_LOCKBYTES = 3
%STGTY_PROPERTY  = 4

' STREAM_SEEK enum
%STREAM_SEEK_SET = 0
%STREAM_SEEK_CUR = 1
%STREAM_SEEK_END = 2

' LOCKTYPE enum
%LOCK_WRITE     = 1
%LOCK_EXCLUSIVE = 2
%LOCK_ONLYONCE  = 4

$IID_IStream = GUID$("{0000000C-0000-0000-C000-000000000046}")

INTERFACE IStream $IID_IStream

   INHERIT IUnknown

   ' =====================================================================================
   ' ISequentialStream Methods
   ' =====================================================================================
   METHOD Read ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [out] */ void* pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   , BYREF DWORD _                            ' /* [out] ULONG *pcbRead
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Write ( _                           ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ void const* pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcbWritten
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

   ' =====================================================================================
   ' IStream Methods
   ' =====================================================================================
   METHOD Seek ( _                            ' VTable offset = 20
     BYVAL QUAD _                             ' /* [in] */ LARGE_INTEGER dlibMove
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwOrigin
   , BYREF QUAD _                             ' /* [out] */ ULARGE_INTEGER* plibNewPosition
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetSize ( _                         ' VTable offset = 24
     BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER libNewSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CopyTo ( _                          ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IStream* pstm
   , BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER cb
   , BYREF QUAD _                             ' /* [out] */ ULARGE_INTEGER* pcbRead
   , BYREF QUAD _                             ' /* [out] */ ULARGE_INTEGER* pcbWritten
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Commit ( _                          ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ DWORD grfCommitFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Revert ( _                          ' VTable offset = 36
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LockRegion ( _                      ' VTable offset = 40
     BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER libOffset
   , BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER cb
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwLockType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UnlockRegion ( _                    ' VTable offset = 44
     BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER libOffset
   , BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER cb
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwLockType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Stat ( _                            ' VTable offset = 48
     BYREF STATSTG _                          ' /* [out] */ STATSTG* pstatstg
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfStatFlag
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 52
     BYREF IUnknown _                         ' /* [out] */ IStream** ppstm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IStream_INTERFACE_DEFINED__ */


' ########################################################################################
' IEnumSTATSTG interface
' IID = 0000000D-0000-0000-c000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumSTATSTG_INTERFACE_DEFINED)
   %IEnumSTATSTG_INTERFACE_DEFINED = 1

$IID_IEnumSTATSTG = GUID$("{0000000D-0000-0000-c000-000000000046}")

INTERFACE IEnumSTATSTG $IID_IEnumSTATSTG

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF STATSTG _                          ' /* [out] */ STATSTG* rgelt
   , BYREF DWORD _                            ' /* [out] */ ULONG* pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumSTATSTG _                     ' /* [out] */ IEnumSTATSTG** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumSTATSTG_INTERFACE_DEFINED__ */


' ########################################################################################
' IStorage interface
' IID = 0000000B-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IStorage_INTERFACE_DEFINED)
   %IStorage_INTERFACE_DEFINED = 1

TYPE RemSNB
   ulCntStr  AS DWORD   ' unsigned long ulCntStr
   ulCntChar AS DWORD   ' unsigned long ulCntChar
   rgString  AS DWORD   ' /* [size_is] */ OLECHAR rgString[ 1 ]
END TYPE

$IID_IStorage = GUID$("{0000000B-0000-0000-C000-000000000046}")

INTERFACE IStorage $IID_IStorage

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateStream ( _                    ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ const WCHAR* pwcsName
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfMode
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved1
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved2
   , BYREF IUnknown _                         ' /* [out] */ IStream** ppstm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OpenStream ( _                      ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ const WCHAR* pwcsName
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved1
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfMode
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved2
   , BYREF IUnknown _                         ' /* [out] */ IStream** ppstm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateStorage ( _                   ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ const WCHAR* pwcsName
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfMode
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved1
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved2
   , BYREF IUnknown _                         ' /* [out] */ IStorage** ppstg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OpenStorage ( _                     ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ const WCHAR* pwcsName
   , BYVAL IUnknown _                         ' /* [in] */ IStorage* pstgPriority
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfMode
   , BYVAL DWORD _                            ' /* [in] */ SNB snbExclude
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved
   , BYREF IUnknown _                         ' /* [out] */ IStorage** ppstg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CopyTo ( _                          ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ DWORD ciidExclude
   , BYVAL DWORD _                            ' /* [in] */ IID const* rgiidExclude
   , BYVAL DWORD _                            ' /* [in] */ SNB snbExclude
   , BYVAL DWORD _                            ' /* [in] */ IStorage* pstgDest
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD MoveElementTo ( _                   ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ const WCHAR* pwcsName
   , BYVAL IUnknown _                         ' /* [in] */ IStorage* pstgDest
   , BYVAL DWORD _                            ' /* [in] */ LPWSTR pwcsNewName
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Commit ( _                          ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ DWORD grfCommitFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Revert ( _                          ' VTable offset = 40
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumElements ( _                    ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ DWORD reserved1
   , BYVAL DWORD _                            ' /* [in] */ void* reserved2
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved3
   , BYREF IUnknown _                         ' /* [out] */ IEnumSTATSTG** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DestroyElement ( _                  ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ wchar* pwcsName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RenameElement ( _                   ' VTable offset = 52
     BYVAL DWORD _                            ' /* [in] */ const WCHAR* pwcsOldName
   , BYVAL DWORD _                            ' /* [in] */ const WCHAR* pwcsNewName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetElementTimes ( _                 ' VTable offset = 56
     BYVAL DWORD _                            ' /* [in] */ const WCHAR* pwcsName
   , BYREF FILETIME _                         ' /* [in] */ FILETIME const* pctime
   , BYREF FILETIME _                         ' /* [in] */ FILETIME const* patime
   , BYREF FILETIME _                         ' /* [in] */ FILETIME const* pmtime
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetClass ( _                        ' VTable offset = 60
     BYREF GUID _                             ' /* [in] */ REFCLSID clsid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetStateBits ( _                    ' VTable offset = 64
     BYVAL DWORD _                            ' /* [in] */ DWORD grfStateBits
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfMask
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Stat ( _                            ' VTable offset = 68
     BYREF STATSTG _                          ' /* [out] */ STATSTG* pstatstg
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfStatFlag
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IStorage_INTERFACE_DEFINED__ */


' ########################################################################################
' IPersistFile interface
' IID = 0000010B-0000-0000-C000-000000000046
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IPersistFile_INTERFACE_DEFINED)
    %IPersistFile_INTERFACE_DEFINED = 1

$IID_IPersistFile = GUID$("{0000010B-0000-0000-C000-000000000046}")

INTERFACE IPersistFile $IID_IPersistFile

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
     BYREF GUID _                             ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsDirty ( _                         ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                            ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszFileName
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Save ( _                            ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszFileName
   , BYVAL LONG _                             ' /* [in] */ BOOL fRemember
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SaveCompleted ( _                   ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszFileName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCurFile ( _                      ' VTable offset = 32
     BYREF DWORD _                            ' /* [out] */ LPOLESTR *ppszFileName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersistFile_INTERFACE_DEFINED__ */


' ########################################################################################
' IPersistStorage interface
' IID = 0000010A-0000-0000-C000-000000000046
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IPersistStorage_INTERFACE_DEFINED)
    %IPersistStorage_INTERFACE_DEFINED = 1

$IID_IPersistStorage = GUID$("{0000010A-0000-0000-C000-000000000046}")

INTERFACE IPersistStorage $IID_IPersistStorage

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
      BYREF GUID _                            ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsDirty ( _                         ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InitNew ( _                         ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IStorage *pStg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                            ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IStorage *pStg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Save ( _                            ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IStorage *pStgSave
   , BYVAL LONG _                             ' /* [in] */ BOOL fSameAsLoad
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SaveCompleted ( _                   ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ IStorage *pStgNew
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD HandsOffStorage ( _                 ' VTable offset = 36
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersistStorage_INTERFACE_DEFINED__ */


' ########################################################################################
' ILockBytes interface
' IID = 0000000A-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ILockBytes_INTERFACE_DEFINED)
    %ILockBytes_INTERFACE_DEFINED = 1

$IID_ILockBytes = GUID$("{0000000A-0000-0000-C000-000000000046}")

INTERFACE ILockBytes $IID_ILockBytes

   INHERIT IUnknown

   ' =====================================================================================
   METHOD ReadAt ( _                          ' VTable offset = 12
     BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER ulOffset
   , BYVAL DWORD _                            ' /* [in] */ void* pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   , BYREF DWORD _                            ' /* [out] */ ULONG* pcbRead
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD WriteAt ( _                         ' VTable offset = 16
     BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER ulOffset
   , BYVAL DWORD _                            ' /* [in] */ void* pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   , BYREF DWORD _                            ' /* [out] */ ULONG* pcbWritten
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Flush ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetSize ( _                         ' VTable offset = 24
     BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER cb
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LockRegion ( _                      ' VTable offset = 28
     BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER libOffset
   , BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER cb
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwLockType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UnlockRegion ( _                    ' VTable offset = 32
     BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER libOffset
   , BYVAL QUAD _                             ' /* [in] */ ULARGE_INTEGER cb
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwLockType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Stat ( _                            ' VTable offset = 36
     BYREF STATSTG _                          ' /* [out] */ STATSTG* pstatstg
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfStatFlag
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ILockBytes_INTERFACE_DEFINED__ */


' ########################################################################################
' IEnumFORMATETC interface
' IID = 00000103-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumFORMATETC_INTERFACE_DEFINED)
    %IEnumFORMATETC_INTERFACE_DEFINED = 1

TYPE DVTARGETDEVICE
   tdSize             AS DWORD  ' DWORD tdSize
   tdDriverNameOffset AS WORD   ' WORD tdDriverNameOffset
   tdDeviceNameOffset AS WORD   ' WORD tdDeviceNameOffset
   tdPortNameOffset   AS WORD   ' WORD tdPortNameOffset
   tdExtDevmodeOffset AS WORD   ' WORD tdExtDevmodeOffset
   tdData(0)          AS BYTE   ' /* [size_is] */ BYTE tdData[ 1 ]
END TYPE

TYPE FORMATETC
   cfFormat AS DWORD                ' CLIPFORMAT cfFormat
   ptd      AS DVTARGETDEVICE PTR   ' /* [unique] */ DVTARGETDEVICE *ptd
   dwAspect AS DWORD                ' DWORD dwAspect
   lindex   AS LONG                 ' LONG lindex
   tymed    AS DWORD                ' DWORD tymed
END TYPE

$IID_IEnumFORMATETC = GUID$("{00000103-0000-0000-C000-000000000046}")

INTERFACE IEnumFORMATETC $IID_IEnumFORMATETC

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF FORMATETC _                        ' /* [out] */ FORMATETC * rgelt
   , BYREF DWORD _                            ' /* [out] */ ULONG * pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
      BYREF IUnknown _                        ' /* [out] */ IenumFORMATETC** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumFORMATETC_INTERFACE_DEFINED__ */


' ########################################################################################
' IEnumSTATDATA interface
' IID = 00000105-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumSTATDATA_INTERFACE_DEFINED)
    %IEnumSTATDATA_INTERFACE_DEFINED = 1

' ADVF enum
%ADVF_NODATA            = 1
%ADVF_PRIMEFIRST        = 2
%ADVF_ONLYONCE          = 4
%ADVF_DATAONSTOP        = 64
%ADVFCACHE_NOHANDLER    = 8
%ADVFCACHE_FORCEBUILTIN = 16
%ADVFCACHE_ONSAVE       = 32

TYPE STATDATA
   tFormatetc   AS FORMATETC   ' FORMATETC formatetc
   grfAdvf      AS DWORD       ' DWORD advf
   pIAdvSink    AS DWORD       ' /* [unique] */ IAdviseSink *pAdvSink
   dwConnection AS DWORD       ' DWORD dwConnection
END TYPE

$IID_IEnumSTATDATA = GUID$("{00000105-0000-0000-C000-000000000046}")

INTERFACE IEnumSTATDATA $IID_IEnumSTATDATA

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF STATDATA _                         ' /* [out] */ STATDATA rgelt
   , BYREF DWORD _                            ' /* [out] */ ULONG * pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumSTATDATA _                    ' /* [out] */ IEnumSTATDATA **ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumSTATDATA_INTERFACE_DEFINED__ */


' ########################################################################################
' IRootStorage interface
' IID = 00000012-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRootStorage_INTERFACE_DEFINED)
    %IRootStorage_INTERFACE_DEFINED = 1

$IID_IRootStorage = GUID$("{00000012-0000-0000-C000-000000000046}")

INTERFACE IRootStorage $IID_IRootStorage

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SwitchToFile ( _                    ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRootStorage_INTERFACE_DEFINED__ */


' ########################################################################################
' IAdviseSink interface
' IID = 0000010F-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAdviseSink_INTERFACE_DEFINED)
    %IAdviseSink_INTERFACE_DEFINED = 1

' TYMED enum
%TYMED_HGLOBAL  = 1
%TYMED_FILE     = 2
%TYMED_ISTREAM  = 4
%TYMED_ISTORAGE = 8
%TYMED_GDI      = 16
%TYMED_MFPICT   = 32
%TYMED_ENHMF    = 64
%TYMED_NULL     = 0

UNION STGMEDIUMDATA
  hBitmap        AS DWORD      ' HBITMAP hBitmap
  hMetaFilePict  AS DWORD      ' HMETAFILEPICT hMetaFilePict
  hEnhMetaFile   AS DWORD      ' HENHMETAFILE hEnhMetaFile
  hGlobal        AS DWORD      ' HGLOBAL hGlobal
  lpszFileName   AS WORD PTR   ' LPOLESTR lpszFileName
  pstm           AS DWORD      ' IStream *lpszFileName
  pstg           AS DWORD      ' IStorage *pstg
END UNION

TYPE STGMEDIUM
  tymed          AS DWORD   ' DWORD tymed
  STGMEDIUMDATA
  pUnkForRelease AS DWORD   ' IUnknown *pUnkForRelease
END TYPE

$IID_IAdviseSink = GUID$("{0000010F-0000-0000-C000-000000000046}")

INTERFACE IAdviseSink $IID_IAdviseSink

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnDataChange ( _                    ' VTable offset = 12
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pFormatetc
   , BYREF STGMEDIUM _                        ' /* [in] */ STGMEDIUM *pStgmed
   )                                          ' void
   ' =====================================================================================
   METHOD OnViewChange ( _                    ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   )                                          ' void
   ' =====================================================================================
   METHOD OnRename ( _                        ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IMoniker *pmk
   )                                          ' void
   ' =====================================================================================
   METHOD OnSave ( _                          ' VTable offset = 24
   )                                          ' void
   ' =====================================================================================
   METHOD OnClose ( _                         ' VTable offset = 28
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAdviseSink_INTERFACE_DEFINED__ */


' ########################################################################################
' AsyncIAdviseSink interface
' IID = 00000150-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%AsyncIAdviseSink_INTERFACE_DEFINED)
    %AsyncIAdviseSink_INTERFACE_DEFINED = 1

$IID_AsyncIAdviseSink = GUID$("{00000150-0000-0000-C000-000000000046}")

INTERFACE AsyncIAdviseSink $IID_AsyncIAdviseSink

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Begin_OnDataChange ( _              ' VTable offset = 12
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pFormatetc
   , BYREF STGMEDIUM _                        ' /* [in] */ STGMEDIUM *pStgmed
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnDataChange ( _             ' VTable offset = 16
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnViewChange ( _              ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnViewChange ( _             ' VTable offset = 24
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnRename ( _                  ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IMoniker *pmk
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnRename ( _                 ' VTable offset = 32
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnSave ( _                    ' VTable offset = 36
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnSave ( _                   ' VTable offset = 40
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnClose ( _                   ' VTable offset = 44
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnClose ( _                  ' VTable offset = 48
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __AsyncIAdviseSink_INTERFACE_DEFINED__ */


' ########################################################################################
' IAdviseSink2 interface
' IID = 00000125-0000-0000-C000-000000000046
' Inherited interface = IAdviseSink
' ########################################################################################

#IF NOT %DEF(%IAdviseSink2_INTERFACE_DEFINED)
    %IAdviseSink2_INTERFACE_DEFINED = 1

$IID_IAdviseSink2 = GUID$("{00000125-0000-0000-C000-000000000046}")

INTERFACE IAdviseSink2 $IID_IAdviseSink2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnDataChange ( _                    ' VTable offset = 12
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pFormatetc
   , BYREF STGMEDIUM _                        ' /* [in] */ STGMEDIUM *pStgmed
   )                                          ' void
   ' =====================================================================================
   METHOD OnViewChange ( _                    ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   )                                          ' void
   ' =====================================================================================
   METHOD OnRename ( _                        ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IMoniker *pmk
   )                                          ' void
   ' =====================================================================================
   METHOD OnSave ( _                          ' VTable offset = 24
   )                                          ' void
   ' =====================================================================================
   METHOD OnClose ( _                         ' VTable offset = 28
   )                                          ' void
   ' =====================================================================================
   METHOD OnLinkSrcChange ( _                 ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ IMoniker *pmk
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAdviseSink2_INTERFACE_DEFINED__ */


' ########################################################################################
' AsyncIAdviseSink2 interface
' IID = 00000151-0000-0000-C000-000000000046
' Inherited interface = AsyncIAdviseSink
' ########################################################################################

#IF NOT %DEF(%AsyncIAdviseSink2_INTERFACE_DEFINED)
    %AsyncIAdviseSink2_INTERFACE_DEFINED = 1

$IID_AsyncIAdviseSink2 = GUID$("{00000151-0000-0000-C000-000000000046}")

INTERFACE AsyncIAdviseSink2 $IID_AsyncIAdviseSink2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Begin_OnDataChange ( _              ' VTable offset = 12
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pFormatetc
   , BYREF STGMEDIUM _                        ' /* [in] */ STGMEDIUM *pStgmed
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnDataChange ( _             ' VTable offset = 16
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnViewChange ( _              ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnViewChange ( _             ' VTable offset = 24
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnRename ( _                  ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IMoniker *pmk
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnRename ( _                 ' VTable offset = 32
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnSave ( _                    ' VTable offset = 36
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnSave ( _                   ' VTable offset = 40
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnClose ( _                   ' VTable offset = 44
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnClose ( _                  ' VTable offset = 48
   )                                          ' void
   ' =====================================================================================
   METHOD Begin_OnLinkSrcChange ( _           ' VTable offset = 52
     BYVAL IUnknown _                         ' /* [unique][in] */ IMoniker *pmk
   )                                          ' void
   ' =====================================================================================
   METHOD Finish_OnLinkSrcChange ( _          ' VTable offset = 56
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __AsyncIAdviseSink2_INTERFACE_DEFINED__ */


' ########################################################################################
' IDataObject interface
' IID = 0000010E-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDataObject_INTERFACE_DEFINED)
    %IDataObject_INTERFACE_DEFINED = 1

' DATADIR enum
%DATADIR_GET = 1
%DATADIR_SET = 2

$IID_IDataObject = GUID$("{0000010E-0000-0000-C000-000000000046}")

INTERFACE IDataObject $IID_IDataObject

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetData ( _                         ' VTable offset = 12
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pformatetcIn
   , BYREF STGMEDIUM _                        ' /* [out] */ STGMEDIUM *pmedium
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDataHere ( _                     ' VTable offset = 16
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pformatetc
   , BYREF STGMEDIUM _                        ' /* [out][in] */ STGMEDIUM *pmedium
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD QueryGetData ( _                    ' VTable offset = 20
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pformatetc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCanonicalFormatEtc ( _           ' VTable offset = 24
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pformatetcIn
   , BYREF FORMATETC _                        ' /* [out] */ FORMATETC *pformatetcOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetData ( _                         ' VTable offset = 28
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pformatetc
   , BYREF STGMEDIUM _                        ' /* [in] */ STGMEDIUM *pmedium
   , BYVAL LONG _                             ' /* [in] */ BOOL fRelease
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumFormatEtc ( _                   ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDirection
   , BYREF IUnknown _                         ' /* [out] */ IEnumFORMATETC **ppenumFormatEtc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DAdvise ( _                         ' VTable offset = 36
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pformatetc
   , BYVAL DWORD _                            ' /* [in] */ DWORD advf
   , BYVAL IUnknown _                         ' /* [in] */ IAdviseSink *pAdvSink
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DUnadvise ( _                       ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ DWORD dwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumDAdvise ( _                     ' VTable offset = 44
     BYREF IUnknown _                         ' /* [out] */ IEnumSTATDATA **ppenumAdvise
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDataObject_INTERFACE_DEFINED__ */


' ########################################################################################
' IDataAdviseHolder interface
' IID = 00000110-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDataAdviseHolder_INTERFACE_DEFINED)
    %IDataAdviseHolder_INTERFACE_DEFINED = 1

$IID_IDataAdviseHolder = GUID$("{00000110-0000-0000-C000-000000000046}")

INTERFACE IDataAdviseHolder $IID_IDataAdviseHolder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Advise ( _                          ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IDataObject *pDataObject
   , BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pFetc
   , BYVAL DWORD _                            ' /* [in] */ DWORD advf
   , BYVAL IUnknown _                         ' /* [in] */ IAdviseSink *pAdvise
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unadvise ( _                        ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumAdvise ( _                      ' VTable offset = 20
     BYREF IUnknown _                         ' /* [in] */ IEnumSTATDATA **ppenumAdvise
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SendOnDataChange ( _                ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IDataObject *pDataObject
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwReserved
   , BYVAL DWORD _                            ' /* [in] */ DWORD advf
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDataAdviseHolder_INTERFACE_DEFINED__ */


' ########################################################################################
' IMessageFilter interface
' IID = 00000016-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMessageFilter_INTERFACE_DEFINED)
    %IMessageFilter_INTERFACE_DEFINED = 1

' CALLTYPE enum
%CALLTYPE_TOPLEVEL             = 1
%CALLTYPE_NESTED               = 2
%CALLTYPE_ASYNC                = 3
%CALLTYPE_TOPLEVEL_CALLPENDING = 4
%CALLTYPE_ASYNC_CALLPENDING    = 5

' SERVERCALL enum
%SERVERCALL_ISHANDLED  = 0
%SERVERCALL_REJECTED   = 1
%SERVERCALL_RETRYLATER = 2

' PENDINGTYPE enum
%PENDINGTYPE_TOPLEVEL = 1
%PENDINGTYPE_NESTED   = 2

' PENDINGMSG enum
%PENDINGMSG_CANCELCALL     = 0
%PENDINGMSG_WAITNOPROCESS  = 1
%PENDINGMSG_WAITDEFPROCESS = 2

TYPE INTERFACEINFO
   pUnk    AS DWORD   ' IUnknown *pUnk
   iid     AS GUID    ' IID iid
   wMethod AS WORD    ' WORD wMethod
END TYPE

$IID_IMessageFilter = GUID$("{00000016-0000-0000-C000-000000000046}")

INTERFACE IMessageFilter $IID_IMessageFilter

   INHERIT IUnknown

   ' =====================================================================================
   METHOD HandleInComingCall ( _              ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwCallType
   , BYVAL DWORD _                            ' /* [in] */ HTASK htaskCaller
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwTickCount
   , BYREF INTERFACEINFO _                    ' /* [in] */ LPINTERFACEINFO lpInterfaceInfo
   ) AS DWORD                                 ' DWORD
   ' =====================================================================================
   METHOD RetryRejectedCall ( _               ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ HTASK htaskCallee
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwTickCount
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwRejectType
   ) AS DWORD                                 ' DWORD
   ' =====================================================================================
   METHOD MessagePending ( _                  ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ HTASK htaskCallee
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwTickCount
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwPendingType
   ) AS DWORD                                 ' DWORD
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMessageFilter_INTERFACE_DEFINED__ */


' ########################################################################################
' IRpcChannelBuffer interface
' IID = D5F56B60-593B-101A-B569-08002B2DBF7A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRpcChannelBuffer_INTERFACE_DEFINED)
    %IRpcChannelBuffer_INTERFACE_DEFINED = 1

TYPE RPCOLEMESSAGE
   reserved1          AS DWORD   ' void *reserved1
   dataRepresentation AS DWORD   ' RPCOLEDATAREP dataRepresentation
   pBuffer            AS DWORD   ' void *Buffer
   cbBuffer           AS DWORD   ' ULONG cbBuffer
   iMethod            AS DWORD   ' ULONG iMethod
   reserved2(4)       AS DWORD   ' void *reserved2[ 5 ]
   rpcFlags           AS DWORD   ' ULONG rpcFlags
END TYPE

$IID_IRpcChannelBuffer = GUID$("{D5F56B60-593B-101A-B569-08002B2DBF7A}")

INTERFACE IRpcChannelBuffer $IID_IRpcChannelBuffer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetBuffer ( _                       ' VTable offset = 12
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SendReceive ( _                     ' VTable offset = 16
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMessage
   , BYREF DWORD _                            ' /* [out] */ ULONG *pStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FreeBuffer ( _                      ' VTable offset = 20
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDestCtx ( _                      ' VTable offset = 24
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwDestContext
   , BYREF IUnknown _                         ' /* [out] */ void **ppvDestContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsConnected ( _                     ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRpcChannelBuffer_INTERFACE_DEFINED__ */


' ########################################################################################
' IRpcChannelBuffer2 interface
' IID = D5F56B60-593B-101A-B569-08002B2DBF7A
' Inherited interface = IRpcChannelBuffer
' ########################################################################################

#IF NOT %DEF(%IRpcChannelBuffer2_INTERFACE_DEFINED)
    %IRpcChannelBuffer2_INTERFACE_DEFINED = 1

$IID_IRpcChannelBuffer2 = GUID$("{594F31D0-7F19-11D0-B194-00A0C90DC8BF}")

INTERFACE IRpcChannelBuffer2 $IID_IRpcChannelBuffer2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetBuffer ( _                       ' VTable offset = 12
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SendReceive ( _                     ' VTable offset = 16
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMessage
   , BYREF DWORD _                            ' /* [out] */ ULONG *pStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FreeBuffer ( _                      ' VTable offset = 20
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDestCtx ( _                      ' VTable offset = 24
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwDestContext
   , BYREF IUnknown _                         ' /* [out] */ void **ppvDestContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsConnected ( _                     ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetProtocolVersion ( _              ' VTable offset = 32
     BYREF DWORD _                            ' /* [out][in] */ DWORD *pdwVersion
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRpcChannelBuffer2_INTERFACE_DEFINED__ */


' ########################################################################################
' IAsyncRpcChannelBuffer interface
' IID = a5029fb6-3c34-11d1-9c99-00c04fb998aa
' Inherited interface = IRpcChannelBuffer2
' ########################################################################################

#IF NOT %DEF(%IAsyncRpcChannelBuffer_INTERFACE_DEFINED)
    %IAsyncRpcChannelBuffer_INTERFACE_DEFINED = 1

$IID_IAsyncRpcChannelBuffer = GUID$("{a5029fb6-3c34-11d1-9c99-00c04fb998aa}")

INTERFACE IAsyncRpcChannelBuffer $IID_IAsyncRpcChannelBuffer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetBuffer ( _                       ' VTable offset = 12
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SendReceive ( _                     ' VTable offset = 16
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMessage
   , BYREF DWORD _                            ' /* [out] */ ULONG *pStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FreeBuffer ( _                      ' VTable offset = 20
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDestCtx ( _                      ' VTable offset = 24
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwDestContext
   , BYREF IUnknown _                         ' /* [out] */ void **ppvDestContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsConnected ( _                     ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetProtocolVersion ( _              ' VTable offset = 32
     BYREF DWORD _                            ' /* [out][in] */ DWORD *pdwVersion
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Send ( _                            ' VTable offset = 36
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMsg
   , BYVAL IUnknown _                         ' /* [in] */ ISynchronize *pSync
   , BYREF DWORD _                            ' /* [out] */ ULONG *pulStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Receive ( _                         ' VTable offset = 40
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMsg
   , BYREF DWORD _                            ' /* [out] */ ULONG *pulStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDestCtxEx ( _                    ' VTable offset = 44
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMsg
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwDestContext
   , BYREF IUnknown _                         ' /* [out] */ void **ppvDestContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAsyncRpcChannelBuffer_INTERFACE_DEFINED__ */


' ########################################################################################
' IRpcChannelBuffer3 interface
' IID = 25B15600-0115-11d0-BF0D-00AA00B8DFD2
' Inherited interface = IRpcChannelBuffer2
' ########################################################################################

#IF NOT %DEF(%IRpcChannelBuffer3_INTERFACE_DEFINED)
    %IRpcChannelBuffer3_INTERFACE_DEFINED = 1

$IID_IRpcChannelBuffer3 = GUID$("{25B15600-0115-11d0-BF0D-00AA00B8DFD2}")

INTERFACE IRpcChannelBuffer3 $IID_IRpcChannelBuffer3

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetBuffer ( _                       ' VTable offset = 12
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SendReceive ( _                     ' VTable offset = 16
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMessage
   , BYREF DWORD _                            ' /* [out] */ ULONG *pStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FreeBuffer ( _                      ' VTable offset = 20
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDestCtx ( _                      ' VTable offset = 24
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwDestContext
   , BYREF IUnknown _                         ' /* [out] */ void **ppvDestContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsConnected ( _                     ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetProtocolVersion ( _              ' VTable offset = 32
     BYREF DWORD _                            ' /* [out][in] */ DWORD *pdwVersion
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Send ( _                            ' VTable offset = 36
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMessage
   , BYREF DWORD _                            ' /* [out] */ ULONG *pulStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Receive ( _                         ' VTable offset = 40
     BYREF RPCOLEMESSAGE _                    ' /* [out][in] */ RPCOLEMESSAGE *pMessage
   , BYVAL DWORD _                            ' /* [in] */ ULONG ulSize
   , BYREF DWORD _                            ' /* [out] */ ULONG *pulStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Cancel ( _                          ' VTable offset = 44
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCallContext ( _                  ' VTable offset = 48
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **pInterface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDestCtxEx ( _                    ' VTable offset = 52
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwDestContext
   , BYREF IUnknown _                         ' /* [out] */ void **ppvDestContext
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetState ( _                        ' VTable offset = 56
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   , BYREF DWORD _                            ' /* [out] */ DWORD *pState
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RegisterAsync ( _                   ' VTable offset = 60
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMessage
   , BYVAL IUnknown _                         ' /* [in] */ IAsyncManager *pAsyncMgr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRpcChannelBuffer3_INTERFACE_DEFINED__ */


' ########################################################################################
' IRpcSyntaxNegotiate interface
' IID = 58a08519-24c8-4935-b482-3fd823333a4f
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRpcSyntaxNegotiate_INTERFACE_DEFINED)
    %IRpcSyntaxNegotiate_INTERFACE_DEFINED = 1

$IID_IRpcSyntaxNegotiate = GUID$("{58a08519-24c8-4935-b482-3fd823333a4f}")

INTERFACE IRpcSyntaxNegotiate $IID_IRpcSyntaxNegotiate

   INHERIT IUnknown

   ' =====================================================================================
   METHOD NegotiateSyntax ( _                 ' VTable offset = 12
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMsg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRpcSyntaxNegotiate_INTERFACE_DEFINED__ */


' ########################################################################################
' IRpcProxyBuffer interface
' IID = D5F56A34-593B-101A-B569-08002B2DBF7A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRpcProxyBuffer_INTERFACE_DEFINED)
    %IRpcProxyBuffer_INTERFACE_DEFINED = 1

$IID_IRpcProxyBuffer = GUID$("{D5F56A34-593B-101A-B569-08002B2DBF7A}")

INTERFACE IRpcProxyBuffer $IID_IRpcProxyBuffer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Connect ( _                         ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [unique][in] */ IRpcChannelBuffer *pRpcChannelBuffer
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Disconnect ( _                      ' VTable offset = 16
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRpcProxyBuffer_INTERFACE_DEFINED__ */


' ########################################################################################
' IRpcStubBuffer interface
' IID = D5F56AFC-593B-101A-B569-08002B2DBF7A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRpcStubBuffer_INTERFACE_DEFINED)
    %IRpcStubBuffer_INTERFACE_DEFINED = 1

$IID_IRpcStubBuffer = GUID$("{D5F56AFC-593B-101A-B569-08002B2DBF7A}")

INTERFACE IRpcStubBuffer $IID_IRpcStubBuffer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Connect ( _                           ' VTable offset = 12
     BYVAL IUnknown _                           ' /* [in] */ IUnknown *pUnkServer
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================
   METHOD Disconnect ( _                        ' VTable offset = 16
   )                                            ' void
   ' =====================================================================================
   METHOD Invoke ( _                            ' VTable offset = 20
     BYREF RPCOLEMESSAGE _                      ' /* [in] */ RPCOLEMESSAGE *_prpcmsg
   , BYVAL IUnknown _                           ' /* [in] */ IRpcChannelBuffer *_pRpcChannelBuffer
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================
   METHOD IsIIDSupported ( _                    ' VTable offset = 24
     BYREF GUID _                               ' /* [in] */ REFIID riid
   ) AS IRpcStubBuffer                          ' IRpcStubBuffer *
   ' =====================================================================================
   METHOD CountRefs ( _                         ' VTable offset = 28
   ) AS DWORD                                   ' ULONG
   ' =====================================================================================
   METHOD DebugServerQueryInterface ( _  ' VTable offset = 32
     BYREF IUnknown _                           ' /* [out] */ void **ppv
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================
   METHOD DebugServerRelease ( _                ' VTable offset = 36
     BYVAL DWORD _                              ' /* [in] */ void *pv
   )                                            ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRpcStubBuffer_INTERFACE_DEFINED__ */


' ########################################################################################
' IPSFactoryBuffer interface
' IID = D5F569D0-593B-101A-B569-08002B2DBF7A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPSFactoryBuffer_INTERFACE_DEFINED)
    %IPSFactoryBuffer_INTERFACE_DEFINED = 1

$IID_IPSFactoryBuffer = GUID$("{D5F569D0-593B-101A-B569-08002B2DBF7A}")

INTERFACE IPSFactoryBuffer $IID_IPSFactoryBuffer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateProxy ( _                     ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnkOuter
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ IRpcProxyBuffer **ppProxy
   , BYREF IUnknown _                         ' /* [out] */ void **ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateStub ( _                      ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnkServer
   , BYREF IUnknown _                         ' /* [out] */ IRpcStubBuffer **ppStub
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPSFactoryBuffer_INTERFACE_DEFINED__ */


' ########################################################################################
' IChannelHook interface
' IID = 1008c4a0-7613-11cf-9af1-0020af6e72f4
' Inherited interface = IUnknown
' ########################################################################################

'#if  (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
'// This interface is only valid on Windows NT 4.0

'typedef struct SChannelHookCallInfo
'    {
'    IID iid;
'    DWORD cbSize;
'    GUID uCausality;
'    DWORD dwServerPid;
'    DWORD iMethod;
'    void *pObject;
'    }    SChannelHookCallInfo;

'TYPE SChannelHookCallInfo
'   iid         AS GUID
'   cbSize      AS DWORD
'   uCausality  AS GUID
'   dwServerPid AS DWORD
'   iMethod     AS DWORD
'   pObject     AS DWORD
'END TYPE

'#IF NOT %DEF(%IChannelHook_INTERFACE_DEFINED)
'    %IChannelHook_INTERFACE_DEFINED = 1

'$IID_IChannelHook = GUID$("{1008c4a0-7613-11cf-9af1-0020af6e72f4}")

'    MIDL_INTERFACE("1008c4a0-7613-11cf-9af1-0020af6e72f4")
'    IChannelHook : public IUnknown
'    {
'    public:
'        virtual void STDMETHODCALLTYPE ClientGetSize(
'            /* [in] */ REFGUID uExtent,
'            /* [in] */ REFIID riid,
'            /* [out] */ ULONG *pDataSize) = 0;

'        virtual void STDMETHODCALLTYPE ClientFillBuffer(
'            /* [in] */ REFGUID uExtent,
'            /* [in] */ REFIID riid,
'            /* [out][in] */ ULONG *pDataSize,
'            /* [in] */ void *pDataBuffer) = 0;

'        virtual void STDMETHODCALLTYPE ClientNotify(
'            /* [in] */ REFGUID uExtent,
'            /* [in] */ REFIID riid,
'            /* [in] */ ULONG cbDataSize,
'            /* [in] */ void *pDataBuffer,
'            /* [in] */ DWORD lDataRep,
'            /* [in] */ HRESULT hrFault) = 0;

'        virtual void STDMETHODCALLTYPE ServerNotify(
'            /* [in] */ REFGUID uExtent,
'            /* [in] */ REFIID riid,
'            /* [in] */ ULONG cbDataSize,
'            /* [in] */ void *pDataBuffer,
'            /* [in] */ DWORD lDataRep) = 0;

'        virtual void STDMETHODCALLTYPE ServerGetSize(
'            /* [in] */ REFGUID uExtent,
'            /* [in] */ REFIID riid,
'            /* [in] */ HRESULT hrFault,
'            /* [out] */ ULONG *pDataSize) = 0;

'        virtual void STDMETHODCALLTYPE ServerFillBuffer(
'            /* [in] */ REFGUID uExtent,
'            /* [in] */ REFIID riid,
'            /* [out][in] */ ULONG *pDataSize,
'            /* [in] */ void *pDataBuffer,
'            /* [in] */ HRESULT hrFault) = 0;

'    };

'#ENDIF   ' /* __IChannelHook_INTERFACE_DEFINED__ */


'// Well-known Property Set Format IDs
'extern const FMTID FMTID_SummaryInformation;
'extern const FMTID FMTID_DocSummaryInformation;
'extern const FMTID FMTID_UserDefinedProperties;
'extern const FMTID FMTID_DiscardableInformation;
'extern const FMTID FMTID_ImageSummaryInformation;
'extern const FMTID FMTID_AudioSummaryInformation;
'extern const FMTID FMTID_VideoSummaryInformation;
'extern const FMTID FMTID_MediaFileSummaryInformation;

'#if  (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
'// This interface is only valid on Windows NT 4.0


' ########################################################################################
' IClientSecurity interface
' IID = 0000013D-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IClientSecurity_INTERFACE_DEFINED)
    %IClientSecurity_INTERFACE_DEFINED = 1

TYPE SOLE_AUTHENTICATION_SERVICE
   dwAuthnSvc     AS DWORD   ' DWORD dwAuthnSvc
   dwAuthzSvc     AS DWORD   ' DWORD dwAuthzSvc
   pPrincipalName AS DWORD   ' OLECHAR *pPrincipalName
   hr             AS LONG    ' HRESULT hr
END TYPE

' EOLE_AUTHENTICATION_CAPABILITIES enum
%EOAC_NONE              = &H0
%EOAC_MUTUAL_AUTH       = &H1
%EOAC_SECURE_REFS       = &H2
%EOAC_ACCESS_CONTROL    = &H4
%EOAC_APPID             = &H8
%EOAC_DYNAMIC           = &H10
%EOAC_STATIC_CLOAKING   = &H20
%EOAC_DYNAMIC_CLOAKING  = &H40
%EOAC_ANY_AUTHORITY     = &H80
%EOAC_MAKE_FULLSIC      = &H100
%EOAC_REQUIRE_FULLSIC   = &H200
%EOAC_AUTO_IMPERSONATE  = &H400
%EOAC_DEFAULT           = &H800
%EOAC_NO_CUSTOM_MARSHAL = &H2000
%EOAC_DISABLE_AAA       = &H1000

'#define   COLE_DEFAULT_PRINCIPAL   ( ( OLECHAR * )-1 )
'#define   COLE_DEFAULT_AUTHINFO   ( ( void * )-1 )

%COLE_DEFAULT_PRINCIPAL = &HFFFFFFFF???
%COLE_DEFAULT_AUTHINFO  = &HFFFFFFFF???

TYPE SOLE_AUTHENTICATION_INFO
   dwAuthnSvc AS DWORD       ' DWORD dwAuthnSvc
   dwAuthzSvc AS DWORD       ' DWORD dwAuthzSvc
   pAuthInfo  AS DWORD PTR   ' void *pAuthInfo
END TYPE

TYPE SOLE_AUTHENTICATION_LIST
   cAuthInfo AS DWORD                          ' DWORD cAuthInfo
   aAuthInfo AS SOLE_AUTHENTICATION_INFO PTR   ' SOLE_AUTHENTICATION_INFO *aAuthInfo
END TYPE

$IID_IClientSecurity = GUID$("{0000013D-0000-0000-C000-000000000046}")

INTERFACE IClientSecurity $IID_IClientSecurity

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryBlanket ( _                    ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IUnknown * pProxy
   , BYREF DWORD _                            ' /* [out] */ DWORD * pAuthnSvc
   , BYREF DWORD _                            ' /* [out] */ DWORD * pAuthzSvc
   , BYREF DWORD _                            ' /* [out] */ OLECHAR ** pServerPrincName,
   , BYREF DWORD _                            ' /* [out] */ DWORD * pAuthnLevel
   , BYREF DWORD _                            ' /* [out] */ DWORD * pImpLevel
   , BYREF DWORD _                            ' /* [out] */ RPC_AUTH_IDENTITY_HANDLE * pAuthInfo
   , BYREF DWORD _                            ' /* [out] */ DWORD * pCapabilities
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetBlanket ( _                      ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ IUnknown * pProxy
   , BYVAL DWORD _                            ' /* [out] */ DWORD dwAuthnSvc
   , BYVAL DWORD _                            ' /* [out] */ DWORD dwAuthzSvc
   , BYVAL DWORD _                            ' /* [out] */ OLECHAR * pServerPrincName,
   , BYVAL DWORD _                            ' /* [out] */ DWORD dwAuthnLevel
   , BYVAL DWORD _                            ' /* [out] */ DWORD dwImpLevel
   , BYVAL DWORD _                            ' /* [out] */ RPC_AUTH_IDENTITY_HANDLE pAuthInfo
   , BYVAL DWORD _                            ' /* [out] */ DWORD dwCapabilities
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CopyProxy ( _                       ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IUnknown * pProxy
   , BYREF IUnknown _                         ' /* [out] */ IUnknown ** ppCopy
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IClientSecurity_INTERFACE_DEFINED__ */


' ########################################################################################
' IServerSecurity interface
' IID = 0000013E-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IServerSecurity_INTERFACE_DEFINED)
    %IServerSecurity_INTERFACE_DEFINED = 1

$IID_IServerSecurity = GUID$("{0000013E-0000-0000-C000-000000000046}")

INTERFACE IServerSecurity $IID_IServerSecurity

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryBlanket ( _                    ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ DWORD *pAuthnSvc
   , BYREF DWORD _                            ' /* [out] */ DWORD *pAuthzSvc
   , BYREF DWORD _                            ' /* [out] */ OLECHAR **pServerPrincName
   , BYREF DWORD _                            ' /* [out] */ DWORD *pAuthnLevel
   , BYREF DWORD _                            ' /* [out] */ DWORD *pImpLevel
   , BYREF DWORD _                            ' /* [out] */ void **pPrivs
   , BYREF DWORD _                            ' /* [out][in] */ DWORD *pCapabilities
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ImpersonateClient ( _               ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RevertToSelf ( _                    ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsImpersonating ( _                 ' VTable offset = 25
   ) AS LONG                                  ' BOOL
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IServerSecurity_INTERFACE_DEFINED__ */


' ########################################################################################
' IClassActivator interface
' IID = 00000140-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IClassActivator_INTERFACE_DEFINED)
    %IClassActivator_INTERFACE_DEFINED = 1

$IID_IClassActivator = GUID$("{00000140-0000-0000-C000-000000000046}")

INTERFACE IClassActivator $IID_IClassActivator

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassObject ( _                  ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFCLSID * pClassID
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwClsContext
   , BYVAL DWORD _                            ' /* [in] */ LCID locale
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void ** ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IClassActivator_INTERFACE_DEFINED__ */


' ########################################################################################
' IRpcOptions interface
' IID = 00000144-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRpcOptions_INTERFACE_DEFINED)
    %IRpcOptions_INTERFACE_DEFINED = 1

$IID_IRpcOptions = GUID$("{00000144-0000-0000-C000-000000000046}")

INTERFACE IRpcOptions $IID_IRpcOptions

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Set ( _                             ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IUnknown *pPrx
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwProperty
   , BYVAL DWORD _                            ' /* [in] */ ULONG_PTR dwValue
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Query ( _                           ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ IUnknown *pPrx
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwProperty
   , BYREF DWORD _                            ' /* [out] */ ULONG_PTR *pdwValue
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRpcOptions_INTERFACE_DEFINED__ */


' __MIDL___MIDL_itf_objidl_0055_0001 enum
%COMBND_RPCTIMEOUT      = &H1
%COMBND_SERVER_LOCALITY = &H2

' __MIDL___MIDL_itf_objidl_0055_0002 enum
%SERVER_LOCALITY_PROCESS_LOCAL   = 0
%SERVER_LOCALITY_MACHINE_LOCAL   = 1
%SERVER_LOCALITY_REMOTE          = 2


' ########################################################################################
' IFillLockBytes interface
' IID = 99CAF010-415E-11CF-8814-00AA00B569F5
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IFillLockBytes_INTERFACE_DEFINED)
    %IFillLockBytes_INTERFACE_DEFINED = 1

$IID_IFillLockBytes = GUID$("{99CAF010-415E-11CF-8814-00AA00B569F5}")

INTERFACE IFillLockBytes $IID_IFillLockBytes

   INHERIT IUnknown

   ' =====================================================================================
   METHOD FillAppend ( _                      ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ void const* pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   , BYREF DWORD _                            ' /* [out] */ ULONG* pcbWritten
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FillAt ( _                          ' VTable offset = 16
     BYVAL ulOffset AS QUAD _                 ' /* [in] */ ULARGE_INTEGER uIOffset
   , BYVAL pv AS DWORD _                      ' /* [in] */ void const* pv
   , BYVAL cb AS DWORD _                      ' /* [in] */ ULONG cb
   , BYREF pcbWritten AS DWORD _              ' /* [out] */ ULONG* pcbWritten
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFillSize ( _                     ' VTable offset = 20
     BYVAL ulSize AS QUAD _                   ' /* [in] */ ULARGE_INTEGER uISize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Terminate ( _                       ' VTable offset = 24
     BYVAL bCanceled AS LONG _                ' /* [in] */ BOOL bCanceled
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFillLockBytes_INTERFACE_DEFINED__ */


' ########################################################################################
' IProgressNotify interface
' IID = A9D758A0-4617-11CF-95FC-00AA00680DB4
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IProgressNotify_INTERFACE_DEFINED)
    %IProgressNotify_INTERFACE_DEFINED = 1

$IID_IProgressNotify = GUID$("{A9D758A0-4617-11CF-95FC-00AA00680DB4}")

INTERFACE IProgressNotify $IID_IProgressNotify

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnProgress ( _                      ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwProgressCurrent
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwProgressMaximum
   , BYVAL LONG _                             ' /* [in] */ BOOL fAccurate
   , BYVAL LONG _                             ' /* [in] */ BOOL fOwner
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IProgressNotify_INTERFACE_DEFINED__ */


' ########################################################################################
' ILayoutStorage interface
' IID = 0E6D4D90-6738-11CF-9608-00AA00680DB4
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ILayoutStorage_INTERFACE_DEFINED)
    %ILayoutStorage_INTERFACE_DEFINED = 1

TYPE StorageLayout
   LayoutType      AS DWORD      ' DWORD LayoutType
   pwcsElementName AS WORD PTR   ' OLECHAR *pwcsElementName
   cOffset         AS QUAD       ' LARGE_INTEGER cOffset
   cBytes          AS QUAD       ' LARGE_INTEGER cBytes
END TYPE

$IID_ILayoutStorage = GUID$("{0E6D4D90-6738-11CF-9608-00AA00680DB4}")

INTERFACE ILayoutStorage $IID_ILayoutStorage

   INHERIT IUnknown

   ' =====================================================================================
   METHOD LayoutScript ( _                        ' VTable offset = 12
     BYVAL StorageLayout _                        ' /* [in] */ StorageLayout* pStorageLayout
   , BYVAL DWORD _                                ' /* [in] */ DWORD nEntries
   , BYVAL DWORD _                                ' /* [in] */ DWORD glfInterleavedFlag
   ) AS LONG                                      ' HRESULT
   ' =====================================================================================
   METHOD BeginMonitor ( _                        ' VTable offset = 16
   ) AS LONG                                      ' HRESULT
   ' =====================================================================================
   METHOD EndMonitor ( _                          ' VTable offset = 20
   ) AS LONG                                      ' HRESULT
   ' =====================================================================================
   METHOD ReLayoutDocfile ( _                     ' VTable offset = 24
     BYVAL DWORD _                                ' /* [in] */ OLECHAR* pwcsNewDfName
   ) AS LONG                                      ' HRESULT
   ' =====================================================================================
   METHOD ReLayoutDocfileOnILockBytes ( _  ' VTable offset = 28
     BYVAL DWORD _                                ' /* [in] */ OLECHAR* pwcsNewDfName
   ) AS LONG                                      ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ILayoutStorage_INTERFACE_DEFINED__ */


' ########################################################################################
' IBlockingLock interface
' IID = 30F3D47A-6447-11D1-8E3C-00C04FB9386D
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IBlockingLock_INTERFACE_DEFINED)
    %IBlockingLock_INTERFACE_DEFINED = 1

$IID_IBlockingLock = GUID$("{30F3D47A-6447-11D1-8E3C-00C04FB9386D}")

INTERFACE IBlockingLock $IID_IBlockingLock

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Lock ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwTimeout
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unlock ( _                          ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IBlockingLock_INTERFACE_DEFINED__ */


' ########################################################################################
' ITimeAndNoticeControl interface
' IID = BC0BF6AE-8878-11D1-83E9-00C04FC2C6D4
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ITimeAndNoticeControl_INTERFACE_DEFINED)
    %ITimeAndNoticeControl_INTERFACE_DEFINED = 1

$IID_ITimeAndNoticeControl = GUID$("{BC0BF6AE-8878-11D1-83E9-00C04FC2C6D4}")

INTERFACE ITimeAndNoticeControl $IID_ITimeAndNoticeControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SuppressChanges ( _                 ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD res1
   , BYVAL DWORD _                            ' /* [in] */ DWORD res2
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ITimeAndNoticeControl_INTERFACE_DEFINED__ */


' ########################################################################################
' IOplockStorage interface
' IID = 8D19C834-8879-11D1-83E9-00C04FC2C6D4
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOplockStorage_INTERFACE_DEFINED)
    %IOplockStorage_INTERFACE_DEFINED = 1

$IID_IOplockStorage = GUID$("{8D19C834-8879-11D1-83E9-00C04FC2C6D4}")

INTERFACE IOplockStorage $IID_IOplockStorage

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateStorageEx ( _                 ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ LPCWSTR pwcsName
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfMode
   , BYVAL DWORD _                            ' /* [in] */ DWORD stgfmt
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfAttrs
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [iid_is][out] */ void **ppstgOpen
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OpenStorageEx ( _                   ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ LPCWSTR pwcsName
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfMode
   , BYVAL DWORD _                            ' /* [in] */ DWORD stgfmt
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfAttrs
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [iid_is][out] */ void **ppstgOpen
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOplockStorage_INTERFACE_DEFINED__ */


' ########################################################################################
' ISurrogate interface
' IID = 00000022-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISurrogate_INTERFACE_DEFINED)
    %ISurrogate_INTERFACE_DEFINED = 1

$IID_ISurrogate = GUID$("{00000022-0000-0000-C000-000000000046}")

INTERFACE ISurrogate $IID_ISurrogate

   INHERIT IUnknown

   ' =====================================================================================
   METHOD LoadDllServer ( _                   ' VTable offset = 12
     BYREF rclsid AS GUID _                   ' /* [in] */ REFCLSID Clsid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FreeSurrogate ( _                   ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISurrogate_INTERFACE_DEFINED__ */


' ########################################################################################
' IGlobalInterfaceTable interface
' IID = 00000146-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IGlobalInterfaceTable_INTERFACE_DEFINED)
    %IGlobalInterfaceTable_INTERFACE_DEFINED = 1

$IID_IGlobalInterfaceTable = GUID$("{00000146-0000-0000-C000-000000000046}")

INTERFACE IGlobalInterfaceTable $IID_IGlobalInterfaceTable

   INHERIT IUnknown

   ' =====================================================================================
   METHOD RegisterInterfaceInGlobal ( _         ' VTable offset = 12
     BYVAL IUnknown _                           ' /* [in] */ IUnknown * pUnk
   , BYREF GUID _                               ' /* [in] */ REFIID riid
   , BYREF DWORD _                              ' /* [out] */ DWORD * pdwCookie
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================
   METHOD RevokeInterfaceFromGlobal ( _         ' VTable offset = 16
     BYVAL DWORD _                              ' /* [in] */ DWORD dwCookie
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================
   METHOD GetInterfaceFromGlobal ( _            ' VTable offset = 20
     BYVAL DWORD _                              ' /* [in] */ DWORD  dwCookie
   , BYREF GUID _                               ' /* [in] */ REFIID  riid
   , BYREF IUnknown _                           ' /* [out] */ void ** ppv
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IGlobalInterfaceTable_INTERFACE_DEFINED__ */


' ########################################################################################
' IDirectWriterLock interface
' IID = 0E6D4D92-6738-11CF-9608-00AA00680DB4
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDirectWriterLock_INTERFACE_DEFINED)
    %IDirectWriterLock_INTERFACE_DEFINED = 1

$IID_IDirectWriterLock = GUID$("{0E6D4D92-6738-11CF-9608-00AA00680DB4}")

INTERFACE IDirectWriterLock $IID_IDirectWriterLock

   INHERIT IUnknown

   ' =====================================================================================
   METHOD WaitForWriteAccess ( _              ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszFile
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseWriteAccess ( _              ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD HaveWriteAccess ( _                 ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDirectWriterLock_INTERFACE_DEFINED__ */


' ########################################################################################
' ISynchronize interface
' IID = 00000030-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISynchronize_INTERFACE_DEFINED)
    %ISynchronize_INTERFACE_DEFINED = 1

$IID_ISynchronize = GUID$("{00000030-0000-0000-C000-000000000046}")

INTERFACE ISynchronize $IID_ISynchronize

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Wait ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwMilliseconds
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Signal ( _                          ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISynchronize_INTERFACE_DEFINED__ */


' ########################################################################################
' ISynchronizeHandle interface
' IID = 00000031-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISynchronizeHandle_INTERFACE_DEFINED)
   %ISynchronizeHandle_INTERFACE_DEFINED = 1

$IID_ISynchronizeHandle = GUID$("{00000031-0000-0000-C000-000000000046}")

INTERFACE ISynchronizeHandle $IID_ISynchronizeHandle

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetHandle ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ HANDLE *ph
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   '  /* __ISynchronizeHandle_INTERFACE_DEFINED__ */


' ########################################################################################
' ISynchronizeEvent interface
' IID = 00000032-0000-0000-C000-000000000046
' Inherited interface = ISynchronizeHandle
' ########################################################################################

#IF NOT %DEF(%ISynchronizeEvent_INTERFACE_DEFINED)
    %ISynchronizeEvent_INTERFACE_DEFINED = 1

$IID_ISynchronizeEvent = GUID$("{00000032-0000-0000-C000-000000000046}")

INTERFACE ISynchronizeEvent $IID_ISynchronizeEvent

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetHandle ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ HANDLE *ph
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetEventHandle ( _                  ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ HANDLE *ph
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISynchronizeEvent_INTERFACE_DEFINED__ */


' ########################################################################################
' ISynchronizeContainer interface
' IID = 00000033-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISynchronizeContainer_INTERFACE_DEFINED)
    %ISynchronizeContainer_INTERFACE_DEFINED = 1

$IID_ISynchronizeContainer = GUID$("{00000033-0000-0000-C000-000000000046}")

INTERFACE ISynchronizeContainer $IID_ISynchronizeContainer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddSynchronize ( _                  ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ ISynchronize *pSync
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD WaitMultiple ( _                    ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwTimeOut
   , BYREF IUnknown _                         ' /* [out] */ ISynchronize **ppSync
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISynchronizeContainer_INTERFACE_DEFINED__ */


' ########################################################################################
' ISynchronizeMutex interface
' IID = 00000025-0000-0000-C000-000000000046
' Inherited interface = ISynchronize
' ########################################################################################

#IF NOT %DEF(%ISynchronizeMutex_INTERFACE_DEFINED)
    %ISynchronizeMutex_INTERFACE_DEFINED = 1

$IID_ISynchronizeMutex = GUID$("{00000025-0000-0000-C000-000000000046}")

INTERFACE ISynchronizeMutex $IID_ISynchronizeMutex

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Wait ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwMilliseconds
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Signal ( _                          ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseMutex ( _                    ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISynchronizeMutex_INTERFACE_DEFINED__ */


' ########################################################################################
' ICancelMethodCalls interface
' IID = 00000029-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICancelMethodCalls_INTERFACE_DEFINED)
    %ICancelMethodCalls_INTERFACE_DEFINED = 1

$IID_ICancelMethodCalls = GUID$("{00000029-0000-0000-C000-000000000046}")

INTERFACE ICancelMethodCalls $IID_ICancelMethodCalls

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Cancel ( _                          ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG ulSeconds
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TestCancel ( _                      ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICancelMethodCalls_INTERFACE_DEFINED__ */


' ########################################################################################
' IAsyncManager interface
' IID = 0000002A-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAsyncManager_INTERFACE_DEFINED)
    %IAsyncManager_INTERFACE_DEFINED = 1

' DCOM_CALL_STATE enum
%DCOM_NONE          = 0
%DCOM_CALL_COMPLETE = &H1
%DCOM_CALL_CANCELED = &H2

$IID_IAsyncManager = GUID$("{0000002A-0000-0000-C000-000000000046}")

INTERFACE IAsyncManager $IID_IAsyncManager

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CompleteCall ( _                    ' VTable offset = 12
     BYVAL LONG _                             ' /* [in] */ HRESULT Result
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCallContext ( _                  ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **pInterface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetState ( _                        ' VTable offset = 20
     BYREF DWORD _                            ' /* [out] */ ULONG *pulStateFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAsyncManager_INTERFACE_DEFINED__ */


' ########################################################################################
' ICallFactory interface
' IID = 1C733A30-2A1C-11CE-ADE5-00AA0044773D
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICallFactory_INTERFACE_DEFINED)
   %ICallFactory_INTERFACE_DEFINED = 1

$IID_ICallFactory = GUID$("{1C733A30-2A1C-11CE-ADE5-00AA0044773D}")

INTERFACE ICallFactory $IID_ICallFactory

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateCall ( _                      ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid1
   , BYVAL IUnknown _                         ' /* [in] */ IUnknown * pUnk
   , BYREF GUID _                             ' /* [in] */ REFIID riid2
   , BYREF IUnknown _                         ' /* [out] */ IUnknown ** ppObj
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICallFactory_INTERFACE_DEFINED__ */


' ########################################################################################
' IRpcHelper interface
' IID = 00000149-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRpcHelper_INTERFACE_DEFINED)
   %IRpcHelper_INTERFACE_DEFINED = 1

$IID_IRpcHelper = GUID$("{00000149-0000-0000-C000-000000000046}")

INTERFACE IRpcHelper $IID_IRpcHelper

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetDCOMProtocolVersion ( _          ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ DWORD *pComVersion
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetIIDFromOBJREF ( _                ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ void *pObjRef
   , BYREF GUID _                             ' /* [out] */ IID **piid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRpcHelper_INTERFACE_DEFINED__ */


' ########################################################################################
' IReleaseMarshalBuffers interface
' IID = EB0CB9E8-7996-11D2-872E-0000F8080859
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IReleaseMarshalBuffers_INTERFACE_DEFINED)
   %IReleaseMarshalBuffers_INTERFACE_DEFINED = 1

$IID_IReleaseMarshalBuffers = GUID$("{EB0CB9E8-7996-11D2-872E-0000F8080859}")

INTERFACE IReleaseMarshalBuffers $IID_IReleaseMarshalBuffers

   INHERIT IUnknown

   ' =====================================================================================
   METHOD ReleaseMarshalBuffer ( _            ' VTable offset = 12
     BYREF RPCOLEMESSAGE _                    ' /* [in] */ RPCOLEMESSAGE *pMsg
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   , BYVAL IUnknown _                         ' /* [unique][in] */ IUnknown *pChnl
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IReleaseMarshalBuffers_INTERFACE_DEFINED__ */


' ########################################################################################
' IWaitMultiple interface
' IID = 0000002B-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IWaitMultiple_INTERFACE_DEFINED)
   %IWaitMultiple_INTERFACE_DEFINED = 1

$IID_IWaitMultiple = GUID$("{0000002B-0000-0000-C000-000000000046}")

INTERFACE IWaitMultiple $IID_IWaitMultiple

   INHERIT IUnknown

   ' =====================================================================================
   METHOD WaitMultiple ( _                    ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD timeout,
   , BYREF IUnknown _                         ' /* [out] */ ISynchronize **pSync) = 0;
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddSynchronize ( _                  ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ ISynchronize *pSync
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWaitMultiple_INTERFACE_DEFINED__ */


' ########################################################################################
' IUrlMon interface
' IID = 00000026-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' This interface supports the VSIP infrastructure and is not intended to be used directly
' from your code.
' ########################################################################################

#IF NOT %DEF(%IUrlMon_INTERFACE_DEFINED)
   %IUrlMon_INTERFACE_DEFINED = 1

$IID_IUrlMon = GUID$("{00000026-0000-0000-C000-000000000046}")

INTERFACE IUrlMon $IID_IUrlMon

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AsyncGetClassBits ( _               ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFCLSID rclsid
   , BYVAL DWORD _                            ' /* [unique][in] */ LPCWSTR pszTYPE
   , BYVAL DWORD _                            ' /* [unique][in] */ LPCWSTR pszExt
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwFileVersionMS
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwFileVersionLS
   , BYVAL DWORD _                            ' /* [unique][in] */ LPCWSTR pszCodeBase
   , BYVAL IUnknown _                         ' /* [in] */ IBindCtx *pbc
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwClassContext
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ DWORD flags) = 0;
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IUrlMon_INTERFACE_DEFINED__ */


' ########################################################################################
' IForegroundTransfer interface
' IID = 00000145-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IForegroundTransfer_INTERFACE_DEFINED)
    %IForegroundTransfer_INTERFACE_DEFINED = 1

$IID_IForegroundTransfer = GUID$("{00000145-0000-0000-C000-000000000046}")

INTERFACE IForegroundTransfer $IID_IForegroundTransfer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AllowForegroundTransfer ( _         ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ void *lpvReserved
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IForegroundTransfer_INTERFACE_DEFINED__ */


' ########################################################################################
' IAddrTrackingControl interface
' IID = 00000147-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAddrTrackingControl_INTERFACE_DEFINED)
    %IAddrTrackingControl_INTERFACE_DEFINED = 1

$IID_IAddrTrackingControl = GUID$("{00000147-0000-0000-C000-000000000046}")

INTERFACE IAddrTrackingControl $IID_IAddrTrackingControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD EnableCOMDynamicAddrTracking ( _    ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DisableCOMDynamicAddrTracking ( _   ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAddrTrackingControl_INTERFACE_DEFINED__ */


' ########################################################################################
' IAddrExclusionControl interface
' IID = 00000148-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAddrExclusionControl_INTERFACE_DEFINED)
    %IAddrExclusionControl_INTERFACE_DEFINED = 1

$IID_IAddrExclusionControl = GUID$("{00000148-0000-0000-C000-000000000046}")

INTERFACE IAddrExclusionControl $IID_IAddrExclusionControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCurrentAddrExclusionList ( _     ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppEnumerator
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateAddrExclusionList ( _         ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ IUnknown *pEnumerator
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAddrExclusionControl_INTERFACE_DEFINED__ */


' ########################################################################################
' IPipeByte interface
' IID = DB2F3ACA-2F86-11D1-8E04-00C04FB9989A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPipeByte_INTERFACE_DEFINED)
    %IPipeByte_INTERFACE_DEFINED = 1

$IID_IPipeByte = GUID$("{DB2F3ACA-2F86-11D1-8E04-00C04FB9989A}")

INTERFACE IPipeByte $IID_IPipeByte

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Pull ( _                            ' VTable offset = 12
     BYVAL BYTE PTR _                         ' /* [out] */ BYTE *buf
   , BYVAL DWORD _                            ' /* [in] */ ULONG cRequest
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcReturned
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Push ( _                            ' VTable offset = 16
     BYVAL BYTE PTR _                         ' /* [in] */ BYTE *buf
   , BYVAL DWORD _                            ' /* [in] */ ULONG cSent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPipeByte_INTERFACE_DEFINED__ */


' ########################################################################################
' AsyncIPipeByte interface
' IID = DB2F3ACB-2F86-11D1-8E04-00C04FB9989A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%AsyncIPipeByte_INTERFACE_DEFINED)
    %AsyncIPipeByte_INTERFACE_DEFINED = 1

$IID_AsyncIPipeByte = GUID$("{DB2F3ACB-2F86-11D1-8E04-00C04FB9989A}")

INTERFACE AsyncIPipeByte $IID_AsyncIPipeByte

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Begin_Pull ( _                      ' VTable offset = 12
     BYVAL cRequest AS DWORD _                ' /* [in] */ ULONG cRequest
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Finish_Pull ( _                     ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Begin_Push ( _                      ' VTable offset = 20
      BYVAL BYTE PTR _                        ' /* [in] */ BYTE *buf
   ,  BYVAL DWORD _                           ' /* [in] */ ULONG cSent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Finish_Push ( _                     ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __AsyncIPipeByte_INTERFACE_DEFINED__ */


' ########################################################################################
' IPipeLong interface
' IID = DB2F3ACC-2F86-11D1-8E04-00C04FB9989A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPipeLong_INTERFACE_DEFINED)
    %IPipeLong_INTERFACE_DEFINED = 1

$IID_IPipeLong = GUID$("{DB2F3ACC-2F86-11D1-8E04-00C04FB9989A}")

INTERFACE IPipeLong $IID_IPipeLong

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Pull ( _                            ' VTable offset = 12
     BYREF LONG _                             ' /* [out] */ LONG *buf
   , BYVAL DWORD _                            ' /* [in] */ ULONG cRequest
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcReturned
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Push ( _                            ' VTable offset = 16
     BYREF LONG _                             ' /* [in] */ LONG *buf
   , BYVAL DWORD _                            ' /* [in] */ ULONG cSent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPipeLong_INTERFACE_DEFINED__ */

' ########################################################################################
' AsyncIPipeLong interface
' IID = DB2F3ACD-2F86-11D1-8E04-00C04FB9989A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%AsyncIPipeLong_INTERFACE_DEFINED)
    %AsyncIPipeLong_INTERFACE_DEFINED = 1

$IID_AsyncIPipeLong = GUID$("{DB2F3ACD-2F86-11D1-8E04-00C04FB9989A}")

INTERFACE AsyncIPipeLong $IID_AsyncIPipeLong

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Begin_Pull ( _                      ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cRequest
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Finish_Pull ( _                     ' VTable offset = 16
     BYREF LONG _                             ' /* [out] */ LONG *buf
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcReturned
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Begin_Push ( _                      ' VTable offset = 20
     BYREF LONG _                             ' /* [in] */ LONG *buf
   , BYVAL DWORD _                            ' /* [in] */ ULONG cSent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Finish_Push ( _                     ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __AsyncIPipeLong_INTERFACE_DEFINED__ */


' ########################################################################################
' IThumbnailExtractor interface
' IID = 969DC708-5C76-11D1-8D86-0000F804B057
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IThumbnailExtractor_INTERFACE_DEFINED)
    %IThumbnailExtractor_INTERFACE_DEFINED = 1

$IID_IThumbnailExtractor = GUID$("{969DC708-5C76-11D1-8D86-0000F804B057}")

INTERFACE IThumbnailExtractor $IID_IThumbnailExtractor

   INHERIT IUnknown

   ' =====================================================================================
   METHOD ExtractThumbnail ( _                ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IStorage *pStg
   , BYVAL DWORD _                            ' /* [in] */ ULONG ulLength
   , BYVAL DWORD _                            ' /* [in] */ ULONG ulHeight
   , BYREF DWORD _                            ' /* [out] */ ULONG *pulOutputLength
   , BYREF DWORD _                            ' /* [out] */ ULONG *pulOutputHeight
   , BYREF DWORD _                            ' /* [out] */ HBITMAP *phOutputBitmap
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnFileUpdated ( _                   ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ IStorage *pStg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IThumbnailExtractor_INTERFACE_DEFINED__ */


' ########################################################################################
' IDummyHICONIncluder interface
' IID = 947990de-cc28-11d2-a0f7-00805f858fb1
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDummyHICONIncluder_INTERFACE_DEFINED)
    %IDummyHICONIncluder_INTERFACE_DEFINED = 1

$IID_IDummyHICONIncluder = GUID$("{947990de-cc28-11d2-a0f7-00805f858fb1}")

INTERFACE IDummyHICONIncluder $IID_IDummyHICONIncluder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Dummy ( _                           ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ HICON h1
   , BYREF DWORD _                            ' /* [in] */ HDC h2
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDummyHICONIncluder_INTERFACE_DEFINED__ */


'#if defined USE_COM_CONTEXT_DEF || defined BUILDTYPE_COMSVCS || defined _OLE32_

'typedef DWORD CPFLAGS;

TYPE ContextProperty
   policyId AS GUID    ' GUID policyId
   flags    AS DWORD   ' CPFLAGS flags
   pUnk     AS DWORD   ' /* [unique] */ IUnknown *pUnk
END TYPE


' ########################################################################################
' IEnumContextProps interface
' IID = 000001C1-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumContextProps_INTERFACE_DEFINED)
    %IEnumContextProps_INTERFACE_DEFINED = 1

$IID_IEnumContextProps = GUID$("{000001C1-0000-0000-C000-000000000046}")

INTERFACE IEnumContextProps $IID_IEnumContextProps

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF ContextProperty _                  ' /* [out] */ ContextProperty *pContextProperties
   , BYREF DWORD _                            ' /* [out] */ ULONG *pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IUnknown _                         ' /* [out] */ IEnumContextProps **ppEnumContextProps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Count ( _                           ' VTable offset = 28
     BYREF DWORD _                            ' /* [out] */ ULONG *pcelt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumContextProps_INTERFACE_DEFINED__ */


' ########################################################################################
' IContext interface
' IID = 000001C0-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IContext_INTERFACE_DEFINED)
   %IContext_INTERFACE_DEFINED = 1

$IID_IContext = GUID$("{000001C0-0000-0000-C000-000000000046}")

INTERFACE IContext $IID_IContext

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetProperty ( _                     ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFGUID rPolicyId
   , BYVAL DWORD _                            ' /* [in] */ CPFLAGS flags
   , BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RemoveProperty ( _                  ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFGUID rPolicyId
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetProperty ( _                     ' VTable offset = 20
     BYREF GUID _                             ' /* [in] */ REFGUID rGuid
   , BYREF DWORD _                            ' /* [out] */ CPFLAGS *pFlags
   , BYREF IUnknown _                         ' /* [out] */ IUnknown **ppUnk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumContextProps ( _                ' VTable offset = 24
     BYREF IUnknown _                         ' /* [out] */ IEnumContextProps **ppEnumContextProps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IContext_INTERFACE_DEFINED__ */


' ########################################################################################
' IObjContext interface
' IID = 000001C6-0000-0000-C000-000000000046
' Inherited interface = IContext
' ########################################################################################

#IF NOT %DEF(%IObjContext_INTERFACE_DEFINED)
   %IObjContext_INTERFACE_DEFINED = 1

$IID_IObjContext = GUID$("{000001C6-0000-0000-C000-000000000046}")

INTERFACE IObjContext $IID_IObjContext

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetProperty ( _                     ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFGUID rPolicyId
   , BYVAL DWORD _                            ' /* [in] */ CPFLAGS flags
   , BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RemoveProperty ( _                  ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFGUID rPolicyId
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetProperty ( _                     ' VTable offset = 20
     BYREF GUID _                             ' /* [in] */ REFGUID rGuid
   , BYREF DWORD _                            ' /* [out] */ CPFLAGS *pFlags
   , BYREF IUnknown _                         ' /* [out] */ IUnknown **ppUnk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumContextProps ( _                ' VTable offset = 24
     BYREF IUnknown _                         ' /* [out] */ IEnumContextProps **ppEnumContextProps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reserved1 ( _                       ' VTable offset = 12
   )                                          ' void
   ' =====================================================================================
   METHOD Reserved2 ( _                       ' VTable offset = 16
   )                                          ' void
   ' =====================================================================================
   METHOD Reserved3 ( _                       ' VTable offset = 20
   )                                          ' void
   ' =====================================================================================
   METHOD Reserved4 ( _                       ' VTable offset = 24
   )                                          ' void
   ' =====================================================================================
   METHOD Reserved5 ( _                       ' VTable offset = 28
   )                                          ' void
   ' =====================================================================================
   METHOD Reserved6 ( _                       ' VTable offset = 32
   )                                          ' void
   ' =====================================================================================
   METHOD Reserved7 ( _                       ' VTable offset = 36
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IObjContext_INTERFACE_DEFINED__ */


' ApplicationType enum
%ServerApplication  = 0
%LibraryApplication = %ServerApplication + 1

' ShutdownType enum
%IdleShutdown       = 0
%ForcedShutdown     = %IdleShutdown + 1


' ########################################################################################
' IProcessLock interface
' IID = 000001D5-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ProcessLock_INTERFACE_DEFINED)
    %ProcessLock_INTERFACE_DEFINED = 1

$IID_IProcessLock = GUID$("{000001D5-0000-0000-C000-000000000046}")

INTERFACE IProcessLock $IID_IProcessLock

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddRefOnProcess ( _                 ' VTable offset = 12
   ) AS DWORD                                 ' ULONG
   ' =====================================================================================
   METHOD ReleaseRefOnProcess ( _             ' VTable offset = 16
   ) AS DWORD                                 ' ULONG
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IProcessLock_INTERFACE_DEFINED__ */


' ########################################################################################
' ISurrogateService interface
' IID = 000001D4-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISurrogateService_INTERFACE_DEFINED)
    %ISurrogateService_INTERFACE_DEFINED = 1

$IID_ISurrogateService = GUID$("{000001D4-0000-0000-C000-000000000046}")

INTERFACE ISurrogateService $IID_ISurrogateService

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Init ( _                            ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFGUID rguidProcessID
   , BYVAL IUnknown _                         ' /* [in] */ IProcessLock *pProcessLock
   , BYREF LONG _                             ' /* [out] */ BOOL *pfApplicationAware
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ApplicationLaunch ( _               ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFGUID rguidApplID
   , BYVAL DWORD _                            ' /* [in] */ ApplicationType appType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ApplicationFree ( _                 ' VTable offset = 20
     BYREF GUID _                             ' /* [in] */ REFGUID rguidApplID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CatalogRefresh ( _                  ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ ULONG ulReserved
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ProcessShutdown ( _                 ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ ShutdownType shutdownType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISurrogateService_INTERFACE_DEFINED__ */


' APTTYPE enum
%APTTYPE_CURRENT = -1
%APTTYPE_STA     = 0
%APTTYPE_MTA     = 1
%APTTYPE_NA      = 2
%APTTYPE_MAINSTA = 3

' THDTYPE enum
%THDTYPE_BLOCKMESSAGES   = 0
%THDTYPE_PROCESSMESSAGES = 1

'typedef DWORD APARTMENTID;


' ########################################################################################
' IComThreadingInfo interface
' IID = 000001CE-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IComThreadingInfo_INTERFACE_DEFINED)
    %IComThreadingInfo_INTERFACE_DEFINED = 1

$IID_IComThreadingInfo = GUID$("{000001CE-0000-0000-C000-000000000046}")

INTERFACE IComThreadingInfo $IID_IComThreadingInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCurrentApartmentType ( _           ' VTable offset = 12
     BYREF DWORD _                              ' /* [out] */ APTTYPE *pAptType
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentThreadType ( _              ' VTable offset = 16
     BYREF DWORD _                              ' /* [out] */ THDTYPE *pThreadType
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentLogicalThreadId ( _         ' VTable offset = 20
     BYREF GUID _                               ' /* [out] */ GUID *pguidLogicalThreadId
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================
   METHOD SetCurrentLogicalThreadId ( _         ' VTable offset = 24
     BYREF GUID _                               ' /* [in] */ REFGUID rguid
   ) AS LONG                                    ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IComThreadingInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' IProcessInitControl interface
' IID = 72380D55-8D2B-43A3-8513-2B6EF31434E9
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IProcessInitControl_INTERFACE_DEFINED)
    %IProcessInitControl_INTERFACE_DEFINED = 1

$IID_IProcessInitControl = GUID$("{72380D55-8D2B-43A3-8513-2B6EF31434E9}")

INTERFACE IProcessInitControl $IID_IProcessInitControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD ResetInitializerTimeout ( _         ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwSecondsRemaining
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IProcessInitControl_INTERFACE_DEFINED__ */


' ########################################################################################
' IInitializeSpy interface
' IID = 00000034-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IInitializeSpy_INTERFACE_DEFINED)
    %IInitializeSpy_INTERFACE_DEFINED = 1

$IID_IInitializeSpy = GUID$("{00000034-0000-0000-C000-000000000046}")

INTERFACE IInitializeSpy $IID_IInitializeSpy

   INHERIT IUnknown

   ' =====================================================================================
   METHOD PreInitialize ( _                   ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwCoInit
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwCurThreadAptRefs
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PostInitialize ( _                  ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ HRESULT hrCoInit
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwCoInit
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwNewThreadAptRefs
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PreUninitialize ( _                 ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ DWORD dwCurThreadAptRefs
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PostUninitialize ( _                ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ DWORD dwNewThreadAptRefs
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IInitializeSpy_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%OBJIDL_INC)


'/****** Additional basic types **********************************************/

'#include <stdlib.h>

'#define LISet32(li, v) ((li).HighPart = ((LONG) (v)) < 0 ? -1 : 0, (li).LowPart = (v))
'#define ULISet32(li, v) ((li).HighPart = 0, (li).LowPart = (v))

%CLSCTX_INPROC = %CLSCTX_INPROC_SERVER OR %CLSCTX_INPROC_HANDLER

#IF %DEF(%WIN32_DCOM) ' // DCOM
%CLSCTX_ALL    = %CLSCTX_INPROC_SERVER OR %CLSCTX_INPROC_HANDLER OR %CLSCTX_LOCAL_SERVER OR %CLSCTX_REMOTE_SERVER
%CLSCTX_SERVER = %CLSCTX_INPROC_SERVER OR %CLSCTX_LOCAL_SERVER OR %CLSCTX_REMOTE_SERVER
#ELSE
%CLSCTX_ALL    = %CLSCTX_INPROC_SERVER OR %CLSCTX_INPROC_HANDLER OR %CLSCTX_LOCAL_SERVER
%CLSCTX_SERVER = %CLSCTX_INPROC_SERVER OR %CLSCTX_LOCAL_SERVER
#ENDIF   ' // DCOM

'// class registration flags; passed to CoRegisterClassObject
' REGCLS enum
%REGCLS_SINGLEUSE      = 0   ' // class object only generates one instance
%REGCLS_MULTIPLEUSE    = 1   ' // same class object genereates multiple inst.
                             ' // and local automatically goes into inproc tbl.
%REGCLS_MULTI_SEPARATE = 2   ' // multiple use, but separate control over each context.
%REGCLS_SUSPENDED      = 4   ' // register is as suspended, will be activated
                             ' // when app calls CoResumeClassObjects
%REGCLS_SURROGATE      = 8   ' // must be used when a surrogate process
                             ' // is registering a class object that will be
                             ' // loaded in the surrogate

'// interface marshaling definitions
%MARSHALINTERFACE_MIN = 500     ' // minimum number of bytes for interface marshl


'//
'// Common typedefs for paramaters used in Storage API's, gleamed from storage.h
'// Also contains Storage error codes, which should be moved into the storage
'// idl files.
'//


%CWCSTORAGENAME = 32

'/* Storage instantiation modes */
%STGM_DIRECT           = &H00000000???
%STGM_TRANSACTED       = &H00010000???
%STGM_DIRECT_SWMR      = &H00400000???
%STGM_SIMPLE           = &H08000000???

%STGM_READ             = &H00000000???
%STGM_WRITE            = &H00000001???
%STGM_READWRITE        = &H00000002???

%STGM_SHARE_DENY_NONE  = &H00000040???
%STGM_SHARE_DENY_READ  = &H00000030???
%STGM_SHARE_DENY_WRITE = &H00000020???
%STGM_SHARE_EXCLUSIVE  = &H00000010???

%STGM_PRIORITY         = &H00040000???
%STGM_DELETEONRELEASE  = &H04000000???
'#if (WINVER >= 400)
%STGM_NOSCRATCH        = &H00100000???
'#endif /* WINVER */

%STGM_CREATE           = &H00001000???
%STGM_CONVERT          = &H00020000???
%STGM_FAILIFTHERE      = &H00000000???

%STGM_NOSNAPSHOT       = &H00200000???
'#if (_WIN32_WINNT >= 0x0500)
%STGM_DIRECT_SWMR      = &H00400000???
'#endif

'/*  flags for internet asyncronous and layout docfile */
%ASYNC_MODE_COMPATIBILITY    = &H00000001???
%ASYNC_MODE_DEFAULT          = &H00000000???

%STGTY_REPEAT                = &H00000100???
%STG_TOEND                   = &HFFFFFFFF???

%STG_LAYOUT_SEQUENTIAL       = &H00000000???
%STG_LAYOUT_INTERLEAVED      = &H00000001???

%STGFMT_STORAGE              = 0
%STGFMT_NATIVE               = 1
%STGFMT_FILE                 = 3
%STGFMT_ANY                  = 4
%STGFMT_DOCFILE              = 5

'// This is a legacy define to allow old component to builds
%STGFMT_DOCUMENT             = 0

'// COM initialization flags; passed to CoInitialize.
' COINIT enum
%COINIT_APARTMENTTHREADED = &H2???
#IF %DEF(%WIN32_DCOM) ' // DCOM
'  // These constants are only valid on Windows NT 4.0
%COINIT_MULTITHREADED     = &H0???   ' // OLE calls objects on any thread.
%COINIT_DISABLE_OLE1DDE   = &H4???   ' // Don't use DDE for Ole1 support.
%COINIT_SPEED_OVER_MEMORY = &H8???   ' // Trade memory for speed.
#ENDIF   ' // DCOM


'/****** STD Object API Prototypes *****************************************/

DECLARE FUNCTION CoBuildVersion LIB "OLE32.DLL" ALIAS "CoBuildVersion" ( _
 ) AS DWORD                            ' DWORD

'/* init/uninit */

DECLARE FUNCTION CoInitialize LIB "OLE32.DLL" ALIAS "CoInitialize" ( _
   BYVAL DWORD _                       ' [in] LPVOID pvReserved
 ) AS LONG                             ' HRESULT

DECLARE SUB CoUninitialize LIB "OLE32.DLL" ALIAS "CoUninitialize" ( _
 )                                     ' void

DECLARE FUNCTION CoGetMalloc LIB "OLE32.DLL" ALIAS "CoGetMalloc" ( _
   BYVAL DWORD _                       ' [in] DWORD dwMemContext
 , BYREF IUnknown _                    ' [out] LPMALLOC * ppMalloc
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetCurrentProcess LIB "OLE32.DLL" ALIAS "CoGetCurrentProcess" ( _
 ) AS DWORD                            ' DWORD

DECLARE FUNCTION CoRegisterMallocSpy LIB "OLE32.DLL" ALIAS "CoRegisterMallocSpy" ( _
   BYVAL IUnknown _                    ' [in] LPMALLOCSPY pMallocSpy
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoRevokeMallocSpy LIB "OLE32.DLL" ALIAS "CoRevokeMallocSpy" ( _
 ) AS LONG                             ' HRESULT

' This function is obsolete. Refer to CoGetMalloc.
'WINOLEAPI  CoCreateStandardMalloc(IN DWORD memctx, OUT IMalloc FAR* FAR* ppMalloc);

'#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
DECLARE FUNCTION CoInitializeEx LIB "OLE32.DLL" ALIAS "CoInitializeEx" ( _
   BYVAL DWORD _                       ' [in] void * pvReserved
 , BYVAL DWORD _                       ' [in] DWORD dwCoInit
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetCallerTID LIB "OLE32.DLL" ALIAS "CoGetCallerTID" ( _
   BYREF DWORD _                       ' [out] LPDWORD lpdwTID
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetCurrentLogicalThreadId LIB "OLE32.DLL" ALIAS "CoGetCurrentLogicalThreadId" ( _
   BYREF GUID _                        ' __out GUID *pguid
 ) AS LONG                             ' HRESULT
'#endif // DCOM

'#if (_WIN32_WINNT >= 0x0501)
DECLARE FUNCTION CoRegisterInitializeSpy LIB "OLE32.DLL" ALIAS "CoRegisterInitializeSpy" ( _
   BYVAL IUnknown _                    ' [in] LPINITIALIZESPY lpInitializeSpy
 , BYVAL QUAD _                        ' [in] ULARGE_INTEGER * pUliCookie
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoRevokeInitializeSpy LIB "OLE32.DLL" ALIAS "CoRevokeInitializeSpy" ( _
   BYVAL QUAD _                        ' [in] ULARGE_INTEGER uliCookie
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetContextToken LIB "OLE32.DLL" ALIAS "CoGetContextToken" ( _
   BYREF ANY _                         ' [out] ULONG_PTR * pToken
 ) AS LONG                             ' HRESULT

'// COM System Security Descriptors (used when the corresponding registry
'// entries are absent)
' COMSD enum
%SD_LAUNCHPERMISSIONS  = 0     ' // Machine wide launch permissions
%SD_ACCESSPERMISSIONS  = 1     ' // Machine wide acesss permissions
%SD_LAUNCHRESTRICTIONS = 2     ' // Machine wide launch limits
%SD_ACCESSRESTRICTIONS = 3     ' // Machine wide access limits

DECLARE FUNCTION CoGetSystemSecurityPermissions LIB "OLE32.DLL" ALIAS "CoGetSystemSecurityPermissions" ( _
   BYVAL LONG _                        ' COMSD comSDType
 , BYREF SECURITY_DESCRIPTOR _         ' PSECURITY_DESCRIPTOR *ppSD
 ) AS LONG                             ' HRESULT

'#endif

'#if DBG == 1
'WINOLEAPI_(ULONG) DebugCoGetRpcFault( void );
'WINOLEAPI_(void) DebugCoSetRpcFault( ULONG );
'#endif

'#if (_WIN32_WINNT >= 0x0500)

TYPE SOleTlsDataPublic
   pvReserved0(1) AS DWORD PTR
   dwReserved0(2) AS DWORD
   pvReserved1(0) AS DWORD PTR
   dwReserved1(2) AS DWORD
   pvReserved2(3) AS DWORD PTR
   dwReserved2(0) AS DWORD
   pCurrentCtx    AS DWORD PTR
END TYPE

TYPE SOleTlsData
   pvReserved (1) AS DWORD PTR   ' void * pvReserved0[2]
   dwReserved0(2) AS DWORD       ' DWORD  dwReserved0[3]
   pvReserved1(0) AS DWORD PTR   ' void * pvReserved1[1]
   dwReserved1(2) AS DWORD       ' DWORD  dwReserved1[3]
   pvReserved2(3) AS DWORD PTR   ' void * pvReserved2[4]
   dwReserved2(0) AS DWORD       ' DWORD  dwReserved2[1]
   pCurrentCtx    AS DWORD PTR   ' void * pCurrentCtx
END TYPE


'#endif

'/* COM+ APIs */

DECLARE FUNCTION CoGetObjectContext LIB "OLE32.DLL" ALIAS "CoGetObjectContext" ( _
   BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] LPVOID ** ppv
 ) AS LONG                             ' HRESULT

'/* register/revoke/get class objects */

DECLARE FUNCTION CoGetClassObject LIB "OLE32.DLL" ALIAS "CoGetClassObject" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYVAL DWORD _                       ' [in] DWORD dwClsContext
 , BYREF COSERVERINFO _                ' [in] COSERVERINFO * pServerInfo
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] LPVOID * ppv
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoRegisterClassObject LIB "OLE32.DLL" ALIAS "CoRegisterClassObject" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 , BYVAL DWORD _                       ' [in] DWORD dwClsContext
 , BYVAL DWORD _                       ' [in] DWORD flags
 , BYREF DWORD _                       ' [out] LPDWORD  lpdwRegister
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoRevokeClassObject LIB "OLE32.DLL" ALIAS "CoRevokeClassObject" ( _
   BYVAL DWORD _                       ' [in] DWORD dwRegister
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoResumeClassObjects LIB "OLE32.DLL" ALIAS "CoResumeClassObjects" ( _
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoSuspendClassObjects LIB "OLE32.DLL" ALIAS "CoSuspendClassObjects" ( _
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoAddRefServerProcess LIB "OLE32.DLL" ALIAS "CoAddRefServerProcess" ( _
 ) AS DWORD                            ' ULONG

DECLARE FUNCTION CoReleaseServerProcess LIB "OLE32.DLL" ALIAS "CoReleaseServerProcess" ( _
 ) AS DWORD                            ' ULONG

DECLARE FUNCTION CoGetPSClsid LIB "OLE32.DLL" ALIAS "CoGetPSClsid" ( _
   BYREF GUID _                        ' [in] REFIID riid
 , BYREF GUID _                        ' [out] CLSID * pclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoRegisterPSClsid LIB "OLE32.DLL" ALIAS "CoRegisterPSClsid" ( _
   BYREF GUID _                        ' [in] REFIID riid
 , BYREF GUID _                        ' [in] REFCLSID rclsid
 ) AS LONG                             ' HRESULT

'// Registering surrogate processes
DECLARE FUNCTION CoRegisterSurrogate LIB "OLE32.DLL" ALIAS "CoRegisterSurrogate" ( _
   BYVAL IUnknown _                    ' [in] ISurrogate * pSurrogate
 ) AS LONG                             ' HRESULT

'/* marshaling interface pointers */

DECLARE FUNCTION CoGetMarshalSizeMax LIB "OLE32.DLL" ALIAS "CoGetMarshalSizeMax" ( _
   BYREF DWORD _                       ' [out] ULONG * pulSize
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 , BYVAL DWORD _                       ' [in] DWORD dwDestContext
 , BYVAL DWORD _                       ' [in] LPVOID pvDestContext
 , BYVAL DWORD _                       ' [in] DWORD mshlflags
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoMarshalInterface LIB "OLE32.DLL" ALIAS "CoMarshalInterface" ( _
   BYVAL IUnknown _                    ' [in] IStream * pStm,
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 , BYVAL DWORD _                       ' [in] DWORD dwDestContext
 , BYVAL DWORD _                       ' [in] void * pvDestContext
 , BYVAL DWORD _                       ' [in] DWORD mshlflags
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoUnmarshalInterface LIB "OLE32.DLL" ALIAS "CoUnmarshalInterface" ( _
   BYVAL IUnknown _                    ' [in] IStream * pStm
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] void ** ppv
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoMarshalHresult LIB "OLE32.DLL" ALIAS "CoMarshalHresult" ( _
   BYVAL IUnknown _                    ' [in] IStream * pStm
 , BYVAL LONG _                        ' [in] HRESULT hresult
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoUnmarshalHresult LIB "OLE32.DLL" ALIAS "CoUnmarshalHresult" ( _
   BYVAL IUnknown _                    ' [in] LPSTREAM pStm
 , BYREF DWORD _                       ' [out] HRESULT * phresult
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoReleaseMarshalData LIB "OLE32.DLL" ALIAS "CoReleaseMarshalData" ( _
   BYVAL IUnknown _                    ' [in] IStream * pStm
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoDisconnectObject LIB "OLE32.DLL" ALIAS "CoDisconnectObject" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 , BYVAL DWORD _                       ' [in] DWORD dwReserved
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoLockObjectExternal LIB "OLE32.DLL" ALIAS "CoLockObjectExternal" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 , BYVAL LONG _                        ' [in] BOOL fLock
 , BYVAL LONG _                        ' [in] BOOL fLastUnlockReleases
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetStandardMarshal LIB "OLE32.DLL" ALIAS "CoGetStandardMarshal" ( _
   BYREF GUID _                        ' [in] REFIID riid
 , BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 , BYVAL DWORD _                       ' [in] DWORD dwDestContext
 , BYVAL DWORD _                       ' [in] LPVOID pvDestContext
 , BYVAL DWORD _                       ' [in] DWORD mshlflags
 , BYREF IUnknown _                    ' [out] LPMARSHAL * ppMarshal
 ) AS LONG                             ' HRESULT


DECLARE FUNCTION CoGetStdMarshalEx LIB "OLE32.DLL" ALIAS "CoGetStdMarshalEx" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pUnkOuter
 , BYVAL DWORD _                       ' [in] DWORD dwSMEXFlags
 , BYREF IUnknown _                    ' [out] IUnknown ** ppUnkInner
 ) AS LONG                             ' HRESULT

'/* flags for CoGetStdMarshalEx */
%SMEXF_SERVER     = &H01???       ' // server side aggregated std marshaler
%SMEXF_HANDLER    = &H02???       ' // client side (handler) agg std marshaler

DECLARE FUNCTION CoIsHandlerConnected LIB "OLE32.DLL" ALIAS "CoIsHandlerConnected" ( _
   BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnk
 ) AS LONG                             ' BOOL

'// Apartment model inter-thread interface passing helpers
DECLARE FUNCTION CoMarshalInterThreadInterfaceInStream LIB "OLE32.DLL" ALIAS "CoMarshalInterThreadInterfaceInStream" ( _
   BYREF GUID _                        ' [in] REFIID riid
 , BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnk
 , BYREF IUnknown _                    ' [out] LPSTREAM * ppStm
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetInterfaceAndReleaseStream LIB "OLE32.DLL" ALIAS "CoGetInterfaceAndReleaseStream" ( _
   BYVAL IUnknown _                    ' [in] LPSTREAM pStm
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] LPVOID * ppv
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoCreateFreeThreadedMarshaler LIB "OLE32.DLL" ALIAS "CoCreateFreeThreadedMarshaler" ( _
   BYVAL IUnknown _                    ' [in] LPUNKNOWN punkOuter
 , BYREF IUnknown _                    ' [out] LPUNKNOWN * ppunkMarshaler
 ) AS LONG                             ' HRESULT

'/* dll loading helpers; keeps track of ref counts and unloads all on exit */

DECLARE FUNCTION CoLoadLibrary LIB "OLE32.DLL" ALIAS "CoLoadLibrary" ( _
   BYVAL DWORD _                       ' [in] LPOLESTR lpszLibName
 , BYVAL LONG _                        ' [in] BOOL bAutoFree
 ) AS DWORD                            ' HINSTANCE

DECLARE SUB CoFreeLibrary LIB "OLE32.DLL" ALIAS "CoFreeLibrary" ( _
   BYVAL hInstance AS DWORD _          ' [in] HINSTANCE hInst
 )                                     ' void

DECLARE SUB CoFreeAllLibraries LIB "OLE32.DLL" ALIAS "CoFreeAllLibraries" ( _
 )                                     ' void

DECLARE SUB CoFreeUnusedLibraries LIB "OLE32.DLL" ALIAS "CoFreeUnusedLibraries" ( _
 )                                     ' void

'#if  (_WIN32_WINNT >= 0x0501)
DECLARE SUB CoFreeUnusedLibrariesEx LIB "OLE32.DLL" ALIAS "CoFreeUnusedLibraries" ( _
   BYVAL DWORD _                       ' [in] DWORD dwUnloadDelay
 , BYVAL DWORD _                       ' [in] DWORD dwReserved
 )                                     ' void
'#endif

'#if (_WIN32_WINNT >= 0x0600)
#IF %WINVER >= &H0600
DECLARE FUNCTION CoDisconnectContext LIB "OLE32.DLL" ALIAS "CoDisconnectContext" ( _
   BYVAL DWORD _                       ' [in] DWORD dwTimeout
 ) AS DWORD                            ' HINSTANCE
#ENDIF

'#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM

'/* Call Security. */

DECLARE FUNCTION CoInitializeSecurity LIB "OLE32.DLL" ALIAS "CoInitializeSecurity" ( _
   BYREF SECURITY_DESCRIPTOR _         ' [in] PSECURITY_DESCRIPTOR pVoid
 , BYVAL LONG _                        ' [in] LONG cAuthSvc
 , BYREF SOLE_AUTHENTICATION_SERVICE _ ' [in] SOLE_AUTHENTICATION_SERVICE * asAuthSvc [array]
 , BYVAL DWORD _                       ' [in] void * pReserved1
 , BYVAL DWORD _                       ' [in] DWORD dwAuthnLevel
 , BYVAL DWORD _                       ' [in] DWORD dwImpLevel
 , BYREF SOLE_AUTHENTICATION_LIST _    ' [in] SOLE_AUTHENTICATION_LIST * pAuthList [array]
 , BYVAL DWORD _                       ' [in] DWORD dwCapabilities
 , BYVAL DWORD _                       ' [in] void * pReserved3
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetCallContext LIB "OLE32.DLL" ALIAS "CoGetCallContext" ( _
   BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] void ** ppInterface
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoQueryProxyBlanket LIB "OLE32.DLL" ALIAS "CoQueryProxyBlanket" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pProxy
 , BYREF DWORD _                       ' [out] DWORD * pAuthnSvc
 , BYREF DWORD _                       ' [out] DWORD * pAuthzSvc
 , BYREF DWORD _                       ' [out] OLECHAR ** pServerPrincName
 , BYREF DWORD _                       ' [out] DWORD * pAuthnLevel
 , BYREF DWORD _                       ' [out] DWORD * pImpLevel
 , BYREF DWORD _                       ' [out] RPC_AUTH_IDENTITY_HANDLE * ppAuthInfo
 , BYREF DWORD _                       ' [out] DWORD * pCapabilities
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoSetProxyBlanket LIB "OLE32.DLL" ALIAS "CoSetProxyBlanket" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pProxy
 , BYVAL DWORD _                       ' [in] DWORD dwAuthnSvc
 , BYVAL DWORD _                       ' [in] DWORD dwAuthzSvc
 , BYVAL DWORD _                       ' [in] WCHAR * pServerPrincName
 , BYVAL DWORD _                       ' [in] DWORD dwAuthnLevel
 , BYVAL DWORD _                       ' [in] DWORD dwImpLevel
 , BYVAL DWORD _                       ' [in] RPC_AUTH_IDENTITY_HANDLE pAuthInfo
 , BYVAL DWORD _                       ' [in] DWORD dwCapabilities
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoCopyProxy LIB "OLE32.DLL" ALIAS "CoCopyProxy" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pProxy
 , BYREF IUnknown _                    ' [out] IUnknown ** ppCopy
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoQueryClientBlanket LIB "OLE32.DLL" ALIAS "CoQueryClientBlanket" ( _
   BYREF DWORD _                       ' [out] DWORD * pAuthnSvc
 , BYREF DWORD _                       ' [out] DWORD * pAuthzSvc
 , BYREF DWORD _                       ' [out] OLECHAR ** pServerPrincName
 , BYREF DWORD _                       ' [out] DWORD * pAuthnLevel
 , BYREF DWORD _                       ' [out] DWORD * pImpLevel
 , BYREF DWORD _                       ' [out] RPC_AUTHZ_HANDLE * pPrivs
 , BYREF DWORD _                       ' [out] DWORD * pCapabilities
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoImpersonateClient LIB "OLE32.DLL" ALIAS "CoImpersonateClient" ( _
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoRevertToSelf LIB "OLE32.DLL" ALIAS "CoRevertToSelf" ( _
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoQueryAuthenticationServices LIB "OLE32.DLL" ALIAS "CoQueryAuthenticationServices" ( _
   BYREF DWORD _                       ' [in] DWORD * pcAuthSvc
 , BYREF DWORD _                       ' [out] SOLE_AUTHENTICATION_SERVICE ** asAuthSvc
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoSwitchCallContext LIB "OLE32.DLL" ALIAS "CoSwitchCallContext" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pNewObject
 , BYREF IUnknown _                    ' [out] IUnknown ** ppOldObject
 ) AS LONG                             ' HRESULT

%COM_RIGHTS_EXECUTE         = 1
%COM_RIGHTS_EXECUTE_LOCAL   = 2
%COM_RIGHTS_EXECUTE_REMOTE  = 4
%COM_RIGHTS_ACTIVATE_LOCAL  = 8
%COM_RIGHTS_ACTIVATE_REMOTE = 16

'#endif // DCOM

'/* helper for creating instances */

DECLARE FUNCTION CoCreateInstance LIB "OLE32.DLL" ALIAS "CoCreateInstance" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnkOuter
 , BYVAL DWORD _                       ' [in] DWORD dwClsContext
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] LPVOID * ppv
 ) AS LONG                             ' HRESULT

'#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM

DECLARE FUNCTION CoGetInstanceFromFile LIB "OLE32.DLL" ALIAS "CoGetInstanceFromFile" ( _
   BYREF COSERVERINFO _                ' [in] COSERVERINFO * pServerInfo
 , BYREF GUID _                        ' [in] CLSID * pclsid
 , BYVAL IUnknown _                    ' [in] IUnknown * punkOuter
 , BYVAL DWORD _                       ' [in] DWORD dwClsCtx
 , BYVAL DWORD _                       ' [in] DWORD grfMode
 , BYVAL DWORD _                       ' [in] OLECHAR * szName
 , BYVAL DWORD _                       ' [in] ULONG cmq
 , BYREF MULTI_QI _                    ' [in] MULTI_QI * rgmqResults [array]
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetInstanceFromIStorage LIB "OLE32.DLL" ALIAS "CoGetInstanceFromIStorage" ( _
   BYREF COSERVERINFO _                ' [in] COSERVERINFO * pServerInfo
 , BYREF GUID _                        ' [in] CLSID * pclsid
 , BYVAL IUnknown _                    ' [in] IUnknown * punkOuter
 , BYVAL DWORD _                       ' [in] DWORD dwClsCtx
 , BYVAL IUnknown _                    ' [in] IStorage * pstg
 , BYVAL DWORD _                       ' [in] ULONG cmq
 , BYREF MULTI_QI _                    ' [in] MULTI_QI * rgmqResults
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoCreateInstanceEx LIB "OLE32.DLL" ALIAS "CoCreateInstanceEx" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYVAL IUnknown _                    ' [in] IUnknown * punkOuter
 , BYVAL DWORD _                       ' [in] DWORD dwClsCtx
 , BYREF COSERVERINFO _                ' [in] COSERVERINFO * pServerInfo
 , BYVAL LONG _                        ' [in] ULONG cmq
 , BYREF MULTI_QI _                    ' [in] MULTI_QI * pResults [array]
 ) AS LONG                             ' HRESULT

'#endif // DCOM

'/* Call related APIs */
'#if (_WIN32_WINNT >= 0x0500 ) || defined(_WIN32_DCOM) // DCOM

DECLARE FUNCTION CoGetCancelObject LIB "OLE32.DLL" ALIAS "CoGetCancelObject" ( _
   BYVAL DWORD _                       ' [in] DWORD dwThreadID
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] void ** ppUnk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoSetCancelObject LIB "OLE32.DLL" ALIAS "CoSetCancelObject" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoCancelCall LIB "OLE32.DLL" ALIAS "CoCancelCall" ( _
   BYVAL DWORD _                       ' [in] DWORD dwThreadID
 , BYVAL DWORD _                       ' [in] ULONG ulTimeout
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoTestCancel LIB "OLE32.DLL" ALIAS "CoTestCancel" ( _
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoEnableCallCancellation LIB "OLE32.DLL" ALIAS "CoEnableCallCancellation" ( _
   BYVAL DWORD _                       ' [in] LPVOID pvReserved
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoDisableCallCancellation LIB "OLE32.DLL" ALIAS "CoDisableCallCancellation" ( _
   BYVAL DWORD _                       ' [in] LPVOID pvReserved
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoAllowSetForegroundWindow LIB "OLE32.DLL" ALIAS "CoAllowSetForegroundWindow" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 , BYVAL DWORD _                       ' [in] LPVOID lpvReserved
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION DcomChannelSetHResult LIB "OLE32.DLL" ALIAS "DcomChannelSetHResult" ( _
   BYVAL DWORD _                       ' [in] LPVOID pvReserved
 , BYVAL DWORD _                       ' IN ULONG* pulReserved
 , BYVAL LONG _                        ' IN HRESULT appsHR
 ) AS LONG                             ' HRESULT

'#endif

'/* other helpers */

DECLARE FUNCTION StringFromCLSID LIB "OLE32.DLL" ALIAS "StringFromCLSID" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYREF DWORD _                       ' [out] LPOLESTR * ppsz
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CLSIDFromString LIB "OLE32.DLL" ALIAS "CLSIDFromString" ( _
   BYVAL DWORD _                       ' [in] LPOLESTR lpsz
 , BYREF GUID _                        ' [out] LPCLSID pclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StringFromIID LIB "OLE32.DLL" ALIAS "StringFromIID" ( _
   BYREF GUID _                        ' [in] REFIID rclsid
 , BYREF DWORD _                       ' [out] LPOLESTR * lplpsz
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION IIDFromString LIB "OLE32.DLL" ALIAS "IIDFromtString" ( _
   BYVAL DWORD _                       ' [in] LPOLESTR lpsz
 , BYREF GUID _                        ' [out] LPIID lpiid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoIsOle1Class LIB "OLE32.DLL" ALIAS "CoIsOle1Class" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 ) AS LONG                             ' BOOL

DECLARE FUNCTION ProgIDFromCLSID LIB "OLE32.DLL" ALIAS "ProgIDFromCLSID" ( _
   BYREF GUID _                        ' [in] REFCLSID clsid
 , BYREF DWORD _                       ' [out] LPOLESTR * lplpszProgID
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CLSIDFromProgID LIB "OLE32.DLL" ALIAS "CLSIDFromProgID" ( _
   BYVAL DWORD _                       ' [in] LPCOLESTR lpszProgID
 , BYREF GUID _                        ' [out] LPCLSID pclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CLSIDFromProgIDEx LIB "OLE32.DLL" ALIAS "CLSIDFromProgIDEx" ( _
   BYVAL DWORD _                       ' [in] LPCOLESTR lpszProgID
 , BYREF GUID _                        ' [out] LPCLSID pclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StringFromGUID2 LIB "OLE32.DLL" ALIAS "StringFromGUID2" ( _
   BYREF GUID _                        ' [in] REFGUID rguid
 , BYREF DWORD _                       ' [out] LPOLESTR lpsz
 , BYVAL LONG _                        ' [in] int cchMax
 ) AS LONG                             ' int

DECLARE FUNCTION CoCreateGuid LIB "OLE32.DLL" ALIAS "CoCreateGuid" ( _
   BYREF GUID _                        ' [out] GUID * pguid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoFileTimeToDosDateTime LIB "OLE32.DLL" ALIAS "CoFileTimeToDosDateTime" ( _
   BYREF FILETIME _                    ' [in] FILETIME * lpFileTime
 , BYREF WORD _                        ' [out] LPWORD lpDosDate
 , BYREF WORD _                        ' [out] LPWORD lpDosTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CoDosDateTimeToFileTime LIB "OLE32.DLL" ALIAS "CoDosDateTimeToFileTime" ( _
   BYVAL WORD _                        ' [in] WORD nDosDate
 , BYVAL WORD _                        ' [in] WORD nDosTime
 , BYREF FILETIME _                    ' [out] FILETIME * lpFileTime
 ) AS LONG                             ' BOOL

DECLARE FUNCTION CoFileTimeNow LIB "OLE32.DLL" ALIAS "CoFileTimeNow" ( _
   BYREF FILETIME _                    ' [out] FILETIME * lpFileTime
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoRegisterMessageFilter LIB "OLE32.DLL" ALIAS "CoRegisterMessageFilter" ( _
   BYVAL IUnknown _                    ' [in] LPMESSAGEFILTER lpMessageFilter
 , BYREF IUnknown _                    ' [out] LPMESSAGEFILTER * lplpMessageFilter
 ) AS LONG                             ' HRESULT

'#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
DECLARE FUNCTION CoRegisterChannelHook LIB "OLE32.DLL" ALIAS "CoRegisterChannelHook" ( _
   BYREF GUID _                        ' [in] REFGUID ExtensionUuid
 , BYVAL IUnknown _                    ' IChannelHook *pChannelHook
 ) AS LONG                             ' HRESULT
'#endif // DCOM


'#IF %DEF(%WIN32_DCOM)  ' // DCOM

'#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
'/* Synchronization API */

DECLARE FUNCTION CoWaitForMultipleHandles LIB "OLE32.DLL" ALIAS "CoWaitForMultipleHandles" ( _
   BYVAL DWORD _                       ' [in] DWORD dwFlags
 , BYVAL DWORD _                       ' [in] DWORD dwTimeout
 , BYVAL DWORD _                       ' [in] ULONG cHandles
 , BYVAL DWORD _                       ' [in] LPHANDLE pHandles
 , BYREF DWORD _                       ' [out] LPDWORD lpdwindex
 ) AS LONG                             ' HRESULT

'/* Flags for Synchronization API and Classes */

' enum COWAIT_FLAGS
%COWAIT_WAITALL        = 1
%COWAIT_ALERTABLE      = 2
%COWAIT_INPUTAVAILABLE = 4

'#endif // DCOM
'#ENDIF  ' // DCOM

'/* for flushing OLESCM remote binding handles */

'#if  (_WIN32_WINNT >= 0x0501)
DECLARE FUNCTION CoInvalidateRemoteMachineBindings LIB "OLE32.DLL" ALIAS "CoInvalidateRemoteMachineBindings" ( _
   BYVAL DWORD _                       ' [in] LPOLESTR pszMachineName
 ) AS LONG                             ' HRESULT
'#endif

'/* TreatAs APIS */

DECLARE FUNCTION CoGetTreatAsClass LIB "OLE32.DLL" ALIAS "CoGetTreatAsClass" ( _
   BYREF GUID _                        ' [in] REFCLSID clsidOld
 , BYREF GUID _                        ' [out] LPCLSID pclsidNew
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoTreatAsClass LIB "OLE32.DLL" ALIAS "CoTreatAsClass" ( _
   BYREF GUID _                        ' [in] REFCLSID clsidOld,
 , BYREF GUID _                        ' [out] REFCLSID clsidNew
 ) AS LONG                             ' HRESULT


'/* the server dlls must define their DllGetClassObject and DllCanUnloadNow
' * to match these; the typedefs are located here to ensure all are changed at
' * the same time.
' */

'typedef HRESULT (STDAPICALLTYPE * LPFNGETCLASSOBJECT) (REFCLSID, REFIID, LPVOID *);

'typedef HRESULT (STDAPICALLTYPE * LPFNCANUNLOADNOW)(void);

'STDAPI  DllGetClassObject(IN REFCLSID rclsid, IN REFIID riid, OUT LPVOID FAR* ppv);

'STDAPI  DllCanUnloadNow(void);

'DECLARE FUNCTION DllGetClassObject (BYREF rclsid AS GUID, BYREF riid AS GUID, BYREF ppv AS ANY) AS LONG
'DECLARE FUNCTION DllCanUnloadNow () AS LONG


'/****** Default Memory Allocation ******************************************/
DECLARE FUNCTION CoTaskMemAlloc LIB "OLE32.DLL" ALIAS "CoTaskMemAlloc" ( _
   BYVAL DWORD _                       ' [in] ULONG cb
 ) AS DWORD                            ' LPVOID

DECLARE FUNCTION CoTaskMemRealloc LIB "OLE32.DLL" ALIAS "CoTaskMemRealloc" ( _
   BYVAL DWORD _                       ' [in] LPVOID pv
 , BYVAL DWORD _                       ' [in] ULONG cb
 ) AS DWORD                            ' LPVOID

DECLARE SUB CoTaskMemFree LIB "OLE32.DLL" ALIAS "CoTaskMemFree" ( _
   BYVAL DWORD _                       ' [in] void * pv
 )                                     ' void

'/****** DV APIs ***********************************************************/

'/* This function is declared in objbase.h and ole2.h */
DECLARE FUNCTION CreateDataAdviseHolder LIB "OLE32.DLL" ALIAS "CreateDataAdviseHolder" ( _
   BYREF IUnknown _                    ' [out] IDataAdviseHolder **ppDAHolder
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateDataCache LIB "OLE32.DLL" ALIAS "CreateDataCache" ( _
   BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnkOuter
 , BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] LPVOID FAR *ppvObj
 ) AS LONG                             ' HRESULT


'/****** Storage API Prototypes ********************************************/


DECLARE FUNCTION StgCreateDocFile LIB "OLE32.DLL" ALIAS "StgCreateDocfile" ( _
   BYVAL DWORD _                       ' [in] const WCHAR* pwcsName
 , BYVAL DWORD _                       ' [in] DWORD grfMode
 , BYVAL DWORD _                       ' [in] DWORD reserved
 , BYREF IUnknown _                    ' [out] IStorage** ppstgOpen
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgCreateDocfileOnILockBytes LIB "OLE32.DLL" ALIAS "StgCreateDocfileOnILockBytes" ( _
   BYVAL IUnknown _                    ' [in] ILockBytes* plkbyt
 , BYVAL DWORD _                       ' [in] DWORD grfMode
 , BYVAL DWORD _                       ' [in] DWORD reserved
 , BYREF IUnknown _                    ' [out] IStorage** ppstgOpen
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgOpenStorage LIB "OLE32.DLL" ALIAS "StgOpenStorage" ( _
   BYVAL DWORD _                       ' [in] const WCHAR* pwcsName
 , BYVAL IUnknown _                    ' [in] IStorage* pstgPriority
 , BYVAL DWORD _                       ' [in] DWORD grfMode
 , BYVAL DWORD _                       ' [in] SNB snbExclude
 , BYVAL DWORD _                       ' [in] DWORD reserved
 , BYREF IUnknown _                    ' [out] IStorage** ppstgOpen
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgOpenStorageOnILockBytes LIB "OLE32.DLL" ALIAS "StgOpenStorageOnILockBytes" ( _
   BYVAL IUnknown _                    ' [in] ILockBytes* plkbyt
 , BYVAL IUnknown _                    ' [in] IStorage* pStgPriority
 , BYVAL DWORD _                       ' [in] DWORD grfMode
 , BYVAL DWORD _                       ' [in] SNB snbExclude
 , BYVAL DWORD _                       ' [in] DWORD reserved
 , BYREF IUnknown _                    ' [out] IStorage** ppstgOpen
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgIsStorageFile LIB "OLE32.DLL" ALIAS "StgIsStorageFile" ( _
   BYVAL DWORD _                       ' [in] const WCHAR* pwcsName
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgIsStorageILockBytes LIB "OLE32.DLL" ALIAS "StgIsStorageILockBytes" ( _
   BYVAL IUnknown _                    ' [in] ILockBytes* plkbyt
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgSetTimes LIB "OLE32.DLL" ALIAS "StgSetTimes" ( _
   BYVAL DWORD _                       ' [in] WCHAR const* lpszName
 , BYREF FILETIME _                    ' [in] FILETIME const* pctime
 , BYREF FILETIME _                    ' [in] FILETIME const* patime
 , BYREF FILETIME _                    ' [in] FILETIME const* pmtime
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgOpenAsyncDocfileOnIFillLockBytes LIB "OLE32.DLL" ALIAS "StgOpenAsyncDocfileOnIFillLockBytes" ( _
   BYVAL IUnknown _                    ' [in] IFillLockBytes* ppflb
 , BYVAL DWORD _                       ' [in] DWORD grfmode
 , BYVAL DWORD _                       ' [in] DWORD asyncFlags
 , BYREF IUnknown _                    ' [out] IStorage** ppstgOpen
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgGetIFillLockBytesOnILockBytes LIB "OLE32.DLL" ALIAS "StgGetIFillLockBytesOnILockBytes" ( _
   BYVAL IUnknown _                    ' [in] ILockBytes* pilb
 , BYREF IUnknown _                    ' [out] IFillLockBytes** ppflb
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION StgGetIFillLockBytesOnFile LIB "OLE32.DLL" ALIAS "StgGetIFillLockBytesOnFile" ( _
   BYVAL DWORD _                       ' [in] OLECHAR* pwcsName
 , BYREF IUnknown _                    ' [out] IFillLockBytes** ppflb
 ) AS LONG                             ' HRESULT

' Note  Do not use this function. Use the IStorage::CopyTo method instead.
' CopyTo can be used to layout a docfile, thus improving performance in most scenarios.
'WINOLEAPI StgOpenLayoutDocfile(IN OLECHAR const *pwcsDfName,
'             IN  DWORD grfMode,
'             IN  DWORD reserved,
'             OUT IStorage **ppstgOpen);

'// STG initialization options for StgCreateStorageEx and StgOpenStorageEx
'#if _WIN32_WINNT == 0x500
'#define STGOPTIONS_VERSION 1
'#elif _WIN32_WINNT > 0x500
'#define STGOPTIONS_VERSION 2
'#else
'#define STGOPTIONS_VERSION 0
'#endif

'typedef struct tagSTGOPTIONS
'{
'    USHORT usVersion;            // Versions 1 and 2 supported
'    USHORT reserved;             // must be 0 for padding
'    ULONG ulSectorSize;          // docfile header sector size (512)
'#if STGOPTIONS_VERSION >= 2
'    const WCHAR *pwcsTemplateFile;  // version 2 or above
'#endif
'} STGOPTIONS;

TYPE STGOPTIONS
   usVersion        AS WORD
   reserved         AS WORD
   ulSectorSize     AS DWORD
   pwcsTemplateFile AS DWORD
END TYPE

TYPE STGOPTIONS1
   usVersion        AS WORD
   reserved         AS WORD
   ulSectorSize     AS DWORD
END TYPE

TYPE STGOPTIONS2
   usVersion        AS WORD
   reserved         AS WORD
   ulSectorSize     AS DWORD
   pwcsTemplateFile AS DWORD
END TYPE

' NOTE: The pStgOptions parameter as been declared as ANY to allow to pass an STGOPTIONS1
' or an STGOPTIONS2 structure.

DECLARE FUNCTION StgCreateStorageEx LIB "OLE32.DLL" ALIAS "StgCreateStorageEx" ( _
   BYVAL DWORD _                       ' [in] const WCHAR* pwcsName
 , BYVAL DWORD _                       ' [in] DWORD grfMode
 , BYVAL DWORD _                       ' [in] STGFMT stgfmt
 , BYVAL DWORD _                       ' [in] DWORD grfAttrs
 , BYREF ANY _                         ' [in] STGOPTIONS* pStgOptions
 , BYVAL DWORD _                       ' [in] void* reserved2
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] void** ppObjectOpen
 ) AS LONG                             ' HRESULT

' NOTE: The pStgOptions parameter as been declared as ANY to allow to pass an STGOPTIONS1
' or an STGOPTIONS2 structure.

DECLARE FUNCTION StgOpenStorageEx LIB "OLE32.DLL" ALIAS "StgOpenStorageEx" ( _
   BYVAL DWORD _                       ' [in] const WCHAR* pwcsName
 , BYVAL DWORD _                       ' [in] DWORD grfMode
 , BYVAL DWORD _                       ' [in] STGFMT stgfmt
 , BYVAL DWORD _                       ' [in] DWORD grfAttrs
 , BYREF ANY _                         ' [in] STGOPTIONS* pStgOptions
 , BYVAL DWORD _                       ' [in] void* reserved2
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] void** ppObjectOpen
 ) AS LONG                             ' HRESULT

'//
'//  Moniker APIs
'//

DECLARE FUNCTION BindMoniker LIB "OLE32.DLL" ALIAS "BindMoniker" ( _
   BYVAL IUnknown _                    ' [in] LPMONIKER pmk
 , BYVAL DWORD _                       ' [in] DWORD grfOpt
 , BYREF GUID _                        ' [in] REFIID iidResult
 , BYREF ANY _                         ' [out] LPVOID FAR * ppvResult
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoInstall LIB "OLE32.DLL" ALIAS "CoInstall" ( _
   BYVAL IUnknown _                    ' [in] IBindCtx * pbc
 , BYVAL DWORD _                       ' [in] DWORD dwFlags
 , BYREF uCLSSPEC _                    ' [in] uCLSSPEC * pClassSpec
 , BYVAL QUERYCONTEXT _                ' [in] QUERYCONTEXT * pQuery
 , BYVAL DWORD _                       ' [in] LPWSTR pszCodeBase
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CoGetObject LIB "OLE32.DLL" ALIAS "CoGetObject" ( _
   BYVAL DWORD _                       ' [in] LPCWSTR pszName
 , BYREF BIND_OPTS _                   ' [in] BIND_OPTS * pBindOptions
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] void ** ppv
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION MkParseDisplayName LIB "OLE32.DLL" ALIAS "MkParseDisplayName" ( _
   BYVAL IUnknown _                    ' [in] LPBC pbc
 , BYVAL DWORD _                       ' [in] LPCOLESTR szUserName
 , BYREF DWORD _                       ' [out] ULONG FAR * pchEaten
 , BYREF IUnknown _                    ' [out] LPMONIKER FAR * ppmk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION MonikerRelativePathTo LIB "OLE32.DLL" ALIAS "MonikerRelativePathTo" ( _
   BYVAL IUnknown _                    ' [in] LPMONIKER pmkSrc
 , BYVAL IUnknown _                    ' [in] LPMONIKER pmkDest
 , BYREF IUnknown _                    ' [out] LPMONIKER FAR * ppmkRelPath
 , BYVAL LONG _                        ' [in] BOOL dwReserved
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION MonikerCommonPrefixWith LIB "OLE32.DLL" ALIAS "MonikerCommonPrefixWith" ( _
   BYVAL pmkThis AS IUnknown _         ' [in] LPMONIKER pmkThis
 , BYVAL pmkOther AS IUnknown _        ' [in] LPMONIKER pmkOther
 , BYREF ppmkCommon AS IUnknown _      ' [out] LPMONIKER FAR * ppmkCommon
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateBindCtx LIB "OLE32.DLL" ALIAS "CreateBindCtx" ( _
   BYVAL DWORD _                       ' [in] DWORD reserved
 , BYREF IUnknown _                    ' [out] LPBC FAR * ppbc
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateGenericComposite LIB "OLE32.DLL" ALIAS "CreateGenericComposite" ( _
   BYVAL IUnknown _                    ' [in] LPMONIKER pmkFirst
 , BYVAL IUnknown _                    ' [in] LPMONIKER pmkRest
 , BYREF IUnknown _                    ' [out] LPMONIKER FAR * ppmkComposite
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION GetClassFile LIB "OLE32.DLL" ALIAS "GetClassFile" ( _
   BYVAL DWORD _                       ' [in] LPCWSTR szFileName
 , BYREF GUID _                        ' [out] CLSID * pclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateClassMoniker LIB "OLE32.DLL" ALIAS "CreateClassMoniker" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYREF IUnknown _                    ' [out] IMoniker ** ppmk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateFileMoniker LIB "OLE32.DLL" ALIAS "CreateFileMoniker" ( _
   BYVAL DWORD _                       ' [in] LPCOLESTR lpszPathName
 , BYREF IUnknown _                    ' [out] LPMONIKER FAR * ppmk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateItemMoniker LIB "OLE32.DLL" ALIAS "CreateItemMoniker" ( _
   BYVAL DWORD _                       ' [in] LPCOLESTR lpszDelim
 , BYVAL DWORD _                       ' [in] LPCOLESTR lpszItem
 , BYREF IUnknown _                    ' [out] LPMONIKER FAR * ppmk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateAntiMoniker LIB "OLE32.DLL" ALIAS "CreateAntiMoniker" ( __
   BYREF IUnknown _                    ' [out] LPMONIKER FAR * ppmk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreatePointerMoniker LIB "OLE32.DLL" ALIAS "CreatePointerMoniker" ( _
   BYVAL DWORD _                       ' [in] LPUNKNOWN punk
 , BYREF IUnknown _                    ' [out] LPMONIKER FAR * ppmk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateObjrefMoniker LIB "OLE32.DLL" ALIAS "CreateObjrefMoniker" ( _
   BYVAL DWORD _                       ' [in] LPUNKNOWN pUnk
 , BYREF IUnknown _                    ' [out] LPMONIKER * ppMk
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION GetRunningObjectTable LIB "OLE32.DLL" ALIAS "GetRunningObjectTable" ( _
   BYVAL DWORD _                       ' [in] DWORD reserved
 , BYREF IUnknown _                    ' [out] LPRUNNINGOBJECTTABLE * pprot
 ) AS LONG                             ' HRESULT

'//
'// Standard Progress Indicator impolementation
'//

DECLARE FUNCTION CreateStdProgressIndicator LIB "OLE32.DLL" ALIAS "CreateStdProgressIndicator" ( _
   BYVAL DWORD _                       ' [in] HWND hwndParent
 , BYVAL DWORD _                       ' [in] LPCOLESTR pszTitle
 , BYVAL IUnknown _                    ' [in] IBindStatusCallback * pIbscCaller
 , BYREF IUnknown _                    ' [out] OUT IBindStatusCallback ** ppIbsc
 ) AS LONG                             ' HRESULT


#ENDIF   ' #IF NOT %DEF(%OBJBASE_INC)


'// View OBJECT Error Codes

%E_DRAW                  = %VIEW_E_DRAW

'// IDataObject Error Codes
%DATA_E_FORMATETC        = %DV_E_FORMATETC


'// Common stuff gleamed from OLE.2,

'/* verbs */
%OLEIVERB_PRIMARY          =  0&
%OLEIVERB_SHOW             = -1&
%OLEIVERB_OPEN             = -2&
%OLEIVERB_HIDE             = -3&
%OLEIVERB_UIACTIVATE       = -4&
%OLEIVERB_INPLACEACTIVATE  = -5&
%OLEIVERB_DISCARDUNDOSTATE = -6&
%OLEIVERB_PROPERTIES       = -7&

'// for OleCreateEmbeddingHelper flags; roles in low word; options in high word
%EMBDHLP_INPROC_HANDLER    = &H0000???
%EMBDHLP_INPROC_SERVER     = &H0001???
%EMBDHLP_CREATENOW         = &H00000000???
%EMBDHLP_DELAYCREATE       = &H00010000???

'/* extended create function flags */
%OLECREATE_LEAVERUNNING    = &H00000001???

'/* pull in the MIDL generated header */

'//+-------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//--------------------------------------------------------------------------

#IF NOT %DEF(%OLEIDL_INC)
    %OLEIDL_INC = 1

' The following structures must be placed before including ole2.inc
TYPE OLEINPLACEFRAMEINFO
   cb            AS DWORD   ' UINT
   fMDIApp       AS LONG    ' BOOL
   hwndFrame     AS DWORD   ' HWND
   haccel        AS DWORD   ' HACCEL
   cAccelEntries AS DWORD   ' UINT
END TYPE

TYPE OLEMENUGROUPWIDTHS
   lWidth(5) AS LONG   ' LONG width[ 6 ]
END TYPE


' ########################################################################################
' IOleAdviseHolder interface
' IID = 00000111-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleAdviseHolder_INTERFACE_DEFINED)
    %IOleAdviseHolder_INTERFACE_DEFINED = 1

$IID_IOleAdviseHolder = GUID$("{00000111-0000-0000-C000-000000000046}")

INTERFACE IOleAdviseHolder $IID_IOleAdviseHolder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Advise ( _                          ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IAdviseSink *pAdvise
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unadvise ( _                        ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumAdvise ( _                      ' VTable offset = 20
     BYREF IUnknown _                         ' /* [out] */ IEnumSTATDATA **ppenumAdvise
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SendOnRename ( _                    ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IMoniker *pmk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SendOnSave ( _                      ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SendOnClose ( _                     ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleAdviseHolder_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleCache interface
' IID = 0000011e-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleCache_INTERFACE_DEFINED)
    %IOleCache_INTERFACE_DEFINED = 1

$IID_IOleCache = GUID$("{0000011E-0000-0000-C000-000000000046}")

INTERFACE IOleCache $IID_IOleCache

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Cache ( _                           ' VTable offset = 12
     BYREF FORMATETC _                        ' /* [unique][in] */ FORMATETC *pformatetc
   , BYVAL DWORD _                            ' /* [in] */ DWORD advf
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Uncache ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumCache ( _                       ' VTable offset = 20
     BYREF IUnknown _                         ' /* [out] */ IEnumSTATDATA **ppenumSTATDATA
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InitCache ( _                       ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IDataObject *pDataObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetData ( _                         ' VTable offset = 28
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pformatetc
   , BYREF STGMEDIUM _                        ' /* [in] */ STGMEDIUM *pmedium
   , BYVAL LONG _                             ' /* [in] */ BOOL fRelease
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleCache_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleCache2 interface
' IID = 00000128-0000-0000-C000-000000000046
' Inherited interface = IOleCache
' ########################################################################################

#IF NOT %DEF(%IOleCache2_INTERFACE_DEFINED)
    %IOleCache2_INTERFACE_DEFINED = 1

%UPDFCACHE_NODATACACHE          = &H1???
%UPDFCACHE_ONSAVECACHE          = &H2???
%UPDFCACHE_ONSTOPCACHE          = &H4???
%UPDFCACHE_NORMALCACHE          = &H8???
%UPDFCACHE_IFBLANK              = &H10???
%UPDFCACHE_ONLYIFBLANK          = &H80000000???
%UPDFCACHE_IFBLANKORONSAVECACHE = %UPDFCACHE_IFBLANK OR %UPDFCACHE_ONSAVECACHE
%UPDFCACHE_ALL                  = &H7FFFFFFF???
%UPDFCACHE_ALLBUTNODATACACHE    = &HFFFFFFFE???

' DISCARDCACHE enum
%DISCARDCACHE_SAVEIFDIRTY       = 0
%DISCARDCACHE_NOSAVE            = 1

$IID_IOleCache2 = GUID$("{00000128-0000-0000-C000-000000000046}")

INTERFACE IOleCache2 $IID_IOleCache2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Cache ( _                           ' VTable offset = 12
     BYREF FORMATETC _                        ' /* [unique][in] */ FORMATETC *pformatetc
   , BYVAL DWORD _                            ' /* [in] */ DWORD advf
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Uncache ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumCache ( _                       ' VTable offset = 20
     BYREF IUnknown _                         ' /* [out] */ IEnumSTATDATA **ppenumSTATDATA
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InitCache ( _                       ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IDataObject *pDataObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetData ( _                         ' VTable offset = 28
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pformatetc
   , BYREF STGMEDIUM _                        ' /* [in] */ STGMEDIUM *pmedium
   , BYVAL LONG _                             ' /* [in] */ BOOL fRelease
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateCache ( _                     ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ LPDATAOBJECT pDataObject
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfUpdf
   , BYVAL DWORD _                            ' /* [in] */ LPVOID pReserved
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DiscardCache ( _                    ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDiscardOptions
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleCache2_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleCacheControl interface
' IID = 00000129-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleCacheControl_INTERFACE_DEFINED)
    %IOleCacheControl_INTERFACE_DEFINED = 1

$IID_IOleCacheControl = GUID$("{00000129-0000-0000-C000-000000000046}")

INTERFACE IOleCacheControl $IID_IOleCacheControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnRun ( _                           ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ LPDATAOBJECT pDataObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnStop ( _                          ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleCacheControl_INTERFACE_DEFINED__ */


' ########################################################################################
' IParseDisplayName interface
' IID = 0000011a-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IParseDisplayName_INTERFACE_DEFINED)
    %IParseDisplayName_INTERFACE_DEFINED = 1

$IID_IParseDisplayName = GUID$("{0000011A-0000-0000-C000-000000000046}")

INTERFACE IParseDisplayName $IID_IParseDisplayName

   INHERIT IUnknown

   ' =====================================================================================
   METHOD ParseDisplayName ( _                ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx *pbc
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszDisplayName
   , BYREF DWORD _                            ' /* [out] */ ULONG *pchEaten
   , BYREF IUnknown _                         ' /* [out] */ IMoniker **ppmkOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IParseDisplayName_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleContainer interface
' IID = 0000011b-0000-0000-C000-000000000046
' Inherited interface = IParseDisplayName
' ########################################################################################

#IF NOT %DEF(%IOleContainer_INTERFACE_DEFINED)
    %IOleContainer_INTERFACE_DEFINED = 1

$IID_IOleContainer = GUID$("{0000011B-0000-0000-C000-000000000046}")

INTERFACE IOleContainer $IID_IOleContainer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD ParseDisplayName ( _                ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx *pbc
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszDisplayName
   , BYREF DWORD _                            ' /* [out] */ ULONG *pchEaten
   , BYREF IUnknown _                         ' /* [out] */ IMoniker **ppmkOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumObjects ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD grfFlags
   , BYREF IUnknown _                         ' /* [out] */ IEnumUnknown **ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LockContainer ( _                   ' VTable offset = 20
     BYVAL LONG _                             ' /* [in] */ BOOL fLock
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleContainer_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleClientSite interface
' IID = 00000118-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleClientSite_INTERFACE_DEFINED)
    %IOleClientSite_INTERFACE_DEFINED = 1

$IID_IOleClientSite = GUID$("{00000118-0000-0000-C000-000000000046}")

INTERFACE IOleClientSite $IID_IOleClientSite

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SaveObject ( _                      ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMoniker ( _                      ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAssign
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwWhichMoniker
   , BYREF IUnknown _                         ' /* [out] */ IMoniker ** ppmk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetContainer ( _                    ' VTable offset = 20
     BYREF IUnknown _                         ' /* [out] */ IMoniker ** ppmk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ShowObject ( _                      ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnShowWindow ( _                    ' VTable offset = 28
     BYVAL LONG _                             ' /* [in] */ BOOL fShow
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RequestNewObjectLayout ( _   ' VTable offset = 32
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleClientSite_INTERFACE_DEFINED__ */

' NOTE: The PowerBASIC built-in definition differes in the following methods:

'   ' =====================================================================================
'   METHOD GetMoniker ( _                      ' VTable offset = 16
'     BYVAL DWORD _                            ' /* [in] */ DWORD dwAssign
'   , BYVAL DWORD _                            ' /* [in] */ DWORD dwWhichMoniker
'   , BYREF DWORD _                            ' /* [out] */ IMoniker ** ppmk
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   ' =====================================================================================
'   METHOD GetContainer ( _                    ' VTable offset = 20
'     BYREF DWORD _                            ' /* [out] */ IMoniker ** ppmk
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================


' ########################################################################################
' IOleObject interface
' IID = 00000112-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleObject_INTERFACE_DEFINED)
    %IOleObject_INTERFACE_DEFINED = 1

' OLEGETMONIKER enum
%OLEGETMONIKER_ONLYIFTHERE = 1
%OLEGETMONIKER_FORCEASSIGN = 2
%OLEGETMONIKER_UNASSIGN    = 3
%OLEGETMONIKER_TEMPFORUSER = 4

' OLEWHICHMK enum
%OLEWHICHMK_CONTAINER = 1
%OLEWHICHMK_OBJREL    = 2
%OLEWHICHMK_OBJFULL   = 3

' USERCLASSTYPE enum
%USERCLASSTYPE_FULL    = 1
%USERCLASSTYPE_SHORT   = 2
%USERCLASSTYPE_APPNAME = 3

' OLEMISC enum
%OLEMISC_RECOMPOSEONRESIZE            = &H1???
%OLEMISC_ONLYICONIC                   = &H2???
%OLEMISC_INSERTNOTREPLACE             = &H4???
%OLEMISC_STATIC                       = &H8???
%OLEMISC_CANTLINKINSIDE               = &H10???
%OLEMISC_CANLINKBYOLE1                = &H20???
%OLEMISC_ISLINKOBJECT                 = &H40???
%OLEMISC_INSIDEOUT                    = &H80???
%OLEMISC_ACTIVATEWHENVISIBLE          = &H100???
%OLEMISC_RENDERINGISDEVICEINDEPENDENT = &H200???
%OLEMISC_INVISIBLEATRUNTIME           = &H400???
%OLEMISC_ALWAYSRUN                    = &H800???
%OLEMISC_ACTSLIKEBUTTON               = &H1000???
%OLEMISC_ACTSLIKELABEL                = &H2000???
%OLEMISC_NOUIACTIVATE                 = &H4000???
%OLEMISC_ALIGNABLE                    = &H8000???
%OLEMISC_SIMPLEFRAME                  = &H10000???
%OLEMISC_SETCLIENTSITEFIRST           = &H20000???
%OLEMISC_IMEMODE                      = &H40000???
%OLEMISC_IGNOREACTIVATEWHENVISIBLE    = &H80000???
%OLEMISC_WANTSTOMENUMERGE             = &H100000???
%OLEMISC_SUPPORTSMULTILEVELUNDO       = &H200000???

' OLECLOSE enum
%OLECLOSE_SAVEIFDIRTY = 0
%OLECLOSE_NOSAVE      = 1
%OLECLOSE_PROMPTSAVE  = 2

$IID_IOleObject = GUID$("{00000112-0000-0000-C000-000000000046}")

INTERFACE IOleObject $IID_IOleObject

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetClientSite ( _                   ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IOleClientSite *pClientSite
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetClientSite ( _                   ' VTable offset = 16
     BYREF IUnknown _                         ' /* [out] */ IOleClientSite **ppClientSite
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHostNames ( _                    ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szContainerApp
   , BYVAL DWORD _                            ' /* [in] */ LPCOLESTR szContainerObj
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Close ( _                           ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ DWORD dwSaveOption
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetMoniker ( _                      ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ DWORD dwWhichMoniker
   , BYVAL DWORD _                            ' /* [in] */ IMoniker *pmk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMoniker ( _                      ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAssign
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwWhichMoniker
   , BYREF IUnknown _                         ' /* [out] */ IMoniker **pmk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InitFromData ( _                    ' VTable offset = 36
     BYVAL IUnknown _                         ' /* [in] */ IDataObject *pDataObject
   , BYVAL LONG _                             ' /* [in] */ BOOL fCreation
   , OPTIONAL BYVAL DWORD _                   ' /* [in] */ DWORD dwReserved
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetClipboardData ( _                ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ DWORD dwReserved
   , BYREF IUnknown _                         ' /* [out] */ IDataObject **ppDataObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DoVerb ( _                          ' VTable offset = 44
     BYVAL LONG _                             ' /* [in] */ LONG iVerb
   , BYREF tagMsg _                           ' /* [in] */ LPMSG lpmsg
   , BYVAL IUnknown _                         ' /* [in] */ IOleClientSite *pActiveSite
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ HWND hwndParent
   , BYREF RECT _                             ' /* [in] */ LPCRECT lprcPosRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumVerbs ( _                       ' VTable offset = 48
     BYREF IUnknown _                         ' /* [out] */ IEnumOleVerb **ppEnumOleVerb
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Update ( _                          ' VTable offset = 52
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsUpToDate ( _                      ' VTable offset = 56
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetUserClassID ( _                  ' VTable offset = 60
     BYREF GUID _ _                           ' /* [in] */ CLSID *pClsid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetUserType ( _                     ' VTable offset = 64
     BYVAL DWORD _                            ' /* [in] */ DWORD dwFormOfType
   , BYREF DWORD _                            ' /* [out] */ LPOLESTR *pszUserType
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetExtent ( _                       ' VTable offset = 68
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYREF SIZEL _                            ' /* [in] */ SIZEL *psizel
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetExtent ( _                       ' VTable offset = 72
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYREF SIZEL _                            ' /* [out] */ SIZEL *psizel
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Advise ( _                          ' VTable offset = 76
     BYVAL IUnknown _                         ' /* [in] */ IAdviseSink *pAdvSink
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unadvise ( _                        ' VTable offset = 80
     BYVAL DWORD _                            ' /* [in] */ DWORD dwConnection
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumAdvise ( _                      ' VTable offset = 84
     BYREF IUnknown _                         ' /* [out] */ IEnumSTATDATA **ppenumAdvise
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMiscStatus ( _                   ' VTable offset = 88
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetColorScheme ( _                  ' VTable offset = 92
     BYREF LOGPALETTE _                       ' /* [in] */ LOGPALETTE *pLogpal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleObject_INTERFACE_DEFINED__ */


#IF NOT %DEF(%IOLETypes_INTERFACE_DEFINED)
    %IOLETypes_INTERFACE_DEFINED = 1

' OLERENDER enum
%OLERENDER_NONE   = 0
%OLERENDER_DRAW   = 1
%OLERENDER_FORMAT = 2
%OLERENDER_ASIS   = 3

TYPE OBJECTDESCRIPTOR
   cbSize             AS DWORD           ' ULONG
   clsid              AS GUID            ' CLSID
   dwDrawAspect       AS DWORD           ' DWORD
   tsizel             AS SIZEL           ' SIZEL
   tpointl            AS POINTL   ' POINTL
   dwStatus           AS DWORD           ' DWORD
   dwFullUserTypeName AS DWORD           ' DWORD
   dwSrcOfCopy        AS DWORD           ' DWORD
END TYPE

#ENDIF   ' /* __IOLETypes_INTERFACE_DEFINED__ */

' ########################################################################################
' IOleWindow interface
' IID = 00000114-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleWindow_INTERFACE_DEFINED)
    %IOleWindow_INTERFACE_DEFINED = 1

$IID_IOleWindow = GUID$("{00000114-0000-0000-C000-000000000046}")

INTERFACE IOleWindow $IID_IOleWindow

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetWindow ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [in] */ HWND * phwnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ContextSensitiveHelp ( _            ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fEnterMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleWindow_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleLink interface
' IID = 0000011d-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleLink_INTERFACE_DEFINED)
    %IOleLink_INTERFACE_DEFINED = 1

' OLEUPDATE enum
%OLEUPDATE_ALWAYS = 1
%OLEUPDATE_ONCALL = 3

' OLELINKBIND enum
%OLELINKBIND_EVENIFCLASSDIFF = 1

$IID_IOleLink = GUID$("{0000011D-0000-0000-C000-000000000046}")

INTERFACE IOleLink $IID_IOleLink

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetUpdateOptions ( _                ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwUpdateOpt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetUpdateOptions ( _                ' VTable offset = 16
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwUpdateOpt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetSourceMoniker ( _                ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IMoniker *pmk
   , BYREF GUID _                             ' /* [in] */ REFCLSID rclsid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSourceMoniker ( _                ' VTable offset = 24
     BYREF IUnknown _                         ' /* [out] */ IMoniker **ppmk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetSourceDisplayName ( _            ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszStatusText
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSourceDisplayName ( _            ' VTable offset = 32
     BYREF DWORD _                            ' /* [out] */ LPOLESTR *ppszDisplayName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BindToSource ( _                    ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ DWORD bindflags
   , BYVAL IUnknown _                         ' /* [in] */ IBindCtx *pbc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BindIfRunning ( _                   ' VTable offset = 40
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBoundSource ( _                  ' VTable offset = 44
     BYREF IUnknown _                         ' /* [out] */ IUnknown **ppunk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UnbindSource ( _                    ' VTable offset = 48
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Update ( _                          ' VTable offset = 52
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx *pbc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleLink_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleItemContainer interface
' IID = 0000011c-0000-0000-C000-000000000046
' Inherited interface = IOleContainer
' ########################################################################################

#IF NOT %DEF(%IOleItemContainer_INTERFACE_DEFINED)
    %IOleItemContainer_INTERFACE_DEFINED = 1

' BINDSPEED enum
%BINDSPEED_INDEFINITE = 1
%BINDSPEED_MODERATE   = 2
%BINDSPEED_IMMEDIATE  = 3

' OLECONTF enum
%OLECONTF_EMBEDDINGS    = 1
%OLECONTF_LINKS         = 2
%OLECONTF_OTHERS        = 4
%OLECONTF_ONLYUSER      = 8
%OLECONTF_ONLYIFRUNNING = 16

$IID_IOleItemContainer = GUID$("{0000011C-0000-0000-C000-000000000046}")

INTERFACE IOleItemContainer $IID_IOleItemContainer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD ParseDisplayName ( _                ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IBindCtx *pbc
   , BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszDisplayName
   , BYREF DWORD _                            ' /* [out] */ ULONG *pchEaten
   , BYREF IUnknown _                         ' /* [out] */ IMoniker **ppmkOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumObjects ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD grfFlags
   , BYREF IUnknown _                         ' /* [out] */ IEnumUnknown **ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LockContainer ( _                   ' VTable offset = 20
     BYVAL LONG _                             ' /* [in] */ BOOL fLock
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetObject ( _                       ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszItem
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwSpeedNeeded
   , BYVAL IUnknown _                         ' /* [in] */ IBindCtx *pbc
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppvObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetObjectStorage ( _                ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszItem
   , BYVAL IUnknown _                         ' /* [in] */ IBindCtx *pbc
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppvStorage
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsRunning ( _                       ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ LPOLESTR pszItem
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleItemContainer_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleInPlaceUIWindow interface
' IID = 00000115-0000-0000-C000-000000000046
' Inherited interface = IOleWindow
' ########################################################################################

#IF NOT %DEF(%IOleInPlaceUIWindow_INTERFACE_DEFINED)
    %IOleInPlaceUIWindow_INTERFACE_DEFINED = 1

'typedef RECT BORDERWIDTHS;

TYPE BORDERWIDTHS
   nLeft   AS LONG
   nTop    AS LONG
   nRight  AS LONG
   nBottom AS LONG
END TYPE

$IID_IOleInPlaceUIWindow = GUID$("{00000115-0000-0000-C000-000000000046}")

INTERFACE IOleInPlaceUIWindow $IID_IOleInPlaceUIWindow

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetWindow ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [in] */ HWND * phwnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ContextSensitiveHelp ( _            ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fEnterMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBorder ( _                       ' VTable offset = 20
     BYREF BORDERWIDTHS _                     ' /* [in] */ LPCBORDERWIDTHS pborderwidths
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RequestBorderSpace ( _              ' VTable offset = 24
     BYREF BORDERWIDTHS _                     ' /* [in] */ LPCBORDERWIDTHS pborderwidths
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetBorderSpace ( _                  ' VTable offset = 28
     BYREF BORDERWIDTHS _                     ' /* [in] */ LPCBORDERWIDTHS pborderwidths
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetActiveObject ( _                 ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ IOleInPlaceActiveObject *pActiveObject
   , BYVAL DWORD _                            ' /* [in] */ */ LPCOLESTR pszObjName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleInPlaceUIWindow_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleInPlaceActiveObject interface
' IID = 00000117-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleInPlaceActiveObject_INTERFACE_DEFINED)
    %IOleInPlaceActiveObject_INTERFACE_DEFINED = 1

$IID_IOleInPlaceActiveObject = GUID$("{00000117-0000-0000-C000-000000000046}")

INTERFACE IOleInPlaceActiveObject $IID_IOleInPlaceActiveObject

   INHERIT IUnknown

   ' =====================================================================================
   METHOD TranslateAccelerator ( _            ' VTable offset = 12
     BYREF tagMsg _                           ' /* [in] */ LPMSG lpmsg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnFrameWindowActivate  ( _   ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fActivate
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnDocWindowActivate  ( _            ' VTable offset = 20
     BYVAL LONG _                             ' /* [in] */ BOOL fActivate
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ResizeBorder  ( _                   ' VTable offset = 24
     BYREF RECT _                             ' /* [in] */ LPCRECT prcBorder
   , BYVAL IUnknown _                         ' /* [in] */ IOleInPlaceUIWindow pUIWindow
   , BYVAL LONG _                             ' /* [in] */ BOOL fFrameWindow
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnableModeless  ( _                 ' VTable offset = 28
     BYVAL LONG _                             ' /* [in] */ BOOL fEnable
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   '/* __IOleInPlaceActiveObject_INTERFACE_DEFINED__

' ########################################################################################
' IOleInPlaceFrame interface
' IID = 00000116-0000-0000-C000-000000000046
' Inherited interface = IOleInPlaceUIWindow
' ########################################################################################

#IF NOT %DEF(%IOleInPlaceFrame_INTERFACE_DEFINED)
    %IOleInPlaceFrame_INTERFACE_DEFINED = 1

'typedef HGLOBAL HOLEMENU;

$IID_IOleInPlaceFrame = GUID$("{00000116-0000-0000-C000-000000000046}")

INTERFACE IOleInPlaceFrame $IID_IOleInPlaceFrame

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetWindow ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [in] */ HWND * phwnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ContextSensitiveHelp ( _            ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fEnterMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBorder ( _                       ' VTable offset = 20
     BYREF BORDERWIDTHS _                     ' /* [in] */ LPCBORDERWIDTHS pborderwidths
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RequestBorderSpace ( _              ' VTable offset = 24
     BYREF BORDERWIDTHS _                     ' /* [in] */ LPCBORDERWIDTHS pborderwidths
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetBorderSpace ( _                  ' VTable offset = 28
     BYREF BORDERWIDTHS _                     ' /* [in] */ LPCBORDERWIDTHS pborderwidths
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetActiveObject ( _                 ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ IOleInPlaceActiveObject *pActiveObject
   , BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszObjName
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InsertMenus ( _                     ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ HMENU hmenuShared
   , BYREF OLEMENUGROUPWIDTHS _               ' /* [out] [in] */ LPOLEMENUGROUPWIDTHS lpMenuWidths
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetMenu ( _                         ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ HMENU hmenuShared
   , BYVAL DWORD _                            ' /* [in] */ HOLEMENU holemenu
   , BYVAL DWORD _                            ' /* [in] */ HWND hwndActiveObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RemoveMenus ( _                     ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ HMENU hmenuShared
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetStatusText ( _                   ' VTable offset = 52
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszStatusText
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnableModeless ( _                  ' VTable offset = 56
     BYVAL LONG _                             ' /* [in] */ BOOL fEnable
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TranslateAccelerator ( _            ' VTable offset = 60
     BYREF tagMSG _                           ' /* [in] */ LPMSG lpmsg
   , BYVAL WORD _                             ' /* [in] */ WORD wID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleInPlaceFrame_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleInPlaceObject interface
' IID = 00000113-0000-0000-C000-000000000046
' Inherited interface = IOleWindow
' ########################################################################################

#IF NOT %DEF(%IOleInPlaceObject_INTERFACE_DEFINED)
    %IOleInPlaceObject_INTERFACE_DEFINED = 1

$IID_IOleInPlaceObject = GUID$("{00000113-0000-0000-C000-000000000046}")

INTERFACE IOleInPlaceObject $IID_IOleInPlaceObject

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetWindow ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [in] */ HWND * phwnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ContextSensitiveHelp ( _            ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fEnterMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InPlaceDeactivate ( _               ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UIDeactivate ( _                    ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetObjectRects ( _                  ' VTable offset = 28
     BYREF RECT _                             ' /* [in] */ LPCRECT lprcPosRect
   , BYREF RECT _                             ' /* [in] */ LPCRECT lprcClipRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReactivateAndUndo ( _               ' VTable offset = 32
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleInPlaceObject_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleInPlaceSite interface
' IID = 00000119-0000-0000-C000-000000000046
' Inherited interface = IOleWindow
' ########################################################################################

#IF NOT %DEF(%IOleInPlaceSite_INTERFACE_DEFINED)
    %IOleInPlaceSite_INTERFACE_DEFINED = 1

$IID_IOleInPlaceSite = GUID$("{00000119-0000-0000-C000-000000000046}")

INTERFACE IOleInPlaceSite $IID_IOleInPlaceSite

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetWindow ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [in] */ HWND * phwnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ContextSensitiveHelp ( _            ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fEnterMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CanInPlaceActivate ( _              ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceActivate ( _               ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnUIActivate ( _                    ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetWindowContext ( _                ' VTable offset = 32
     BYREF IUnknown _                         ' /* [out] */ IOleInPlaceFrame **ppFrame
   , BYREF IUnknown _                         ' /* [out] */ IOleInPlaceUIWindow **ppDoc
   , BYREF RECT _                             ' /* [out] */ LPRECT lprcPosRect
   , BYREF RECT _                             ' /* [out] */ LPRECT lprcClipRect
   , BYREF OLEINPLACEFRAMEINFO _              ' /* [out][in] */ LPOLEINPLACEFRAMEINFO lpFrameInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Scroll ( _                          ' VTable offset = 36
     BYREF APISIZE _                          ' /* [in] */ SIZE scrollExtant
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnUIDeactivate ( _                  ' VTable offset = 40
     BYVAL LONG _                             ' /* [in] */ BOOL fUndoable
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceDeactivate ( _             ' VTable offset = 44
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DiscardUndoState ( _                ' VTable offset = 48
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeactivateAndUndo ( _               ' VTable offset = 52
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnPosRectChange ( _                 ' VTable offset = 56
     BYREF RECT _                             ' /* [in] */ LPCRECT lprcPosRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleInPlaceSite_INTERFACE_DEFINED__ */


' ########################################################################################
' IContinue interface
' IID = 0000012A-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IContinue_INTERFACE_DEFINED)
    %IContinue_INTERFACE_DEFINED = 1

$IID_IContinue = GUID$("{0000012A-0000-0000-C000-000000000046}")

INTERFACE IContinue $IID_IContinue

   INHERIT IUnknown

   ' =====================================================================================
   METHOD FContinue ( _                       ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IContinue_INTERFACE_DEFINED__ */


' ########################################################################################
' IViewObject interface
' IID = 0000010d-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IViewObject_INTERFACE_DEFINED)
    %IViewObject_INTERFACE_DEFINED = 1

$IID_IViewObject = GUID$("{0000010d-0000-0000-C000-000000000046}")

INTERFACE IViewObject $IID_IViewObject

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Draw ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYVAL DWORD _                            ' /* [in] */ HDC hicTargetDev
   , BYVAL DWORD _                            ' /* [in] */ HDC hdcDraw
   , BYREF RECTL _                            ' /* [in] */ LPCRECTL lprcBounds
   , BYREF RECTL _                            ' /* [in] */ LPCRECTL lprcWBounds
   , BYVAL DWORD _                            ' /* [in] */ BOOL ( STDMETHODCALLTYPE *pfnContinue )(ULONG_PTR dwContinue)
   , BYVAL DWORD _                            ' /* [in] */ ULONG_PTR dwContinue
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetColorSet ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYVAL DWORD _                            ' /* [in] */ HDC hicTargetDev
   , BYREF LOGPALETTE _                       ' /* [out] */ LOGPALETTE **ppColorSet
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Freeze ( _                          ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwFreeze
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unfreeze ( _                        ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ DWORD dwFreeze
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetAdvise ( _                       ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ DWORD aspect
   , BYVAL DWORD _                            ' /* [in] */ DWORD advf
   , BYVAL IUnknown _                         ' /* [in] */ IAdviseSink *pAdvSink
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAdvise ( _                       ' VTable offset = 32
     BYREF DWORD _                            ' /* [out] */ DWORD *pAspects
   , BYREF DWORD _                            ' /* [out] */ DWORD *pAdvf
   , BYREF IUnknown _                         ' /* [out] */ IAdviseSink **ppAdvSink
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IViewObject_INTERFACE_DEFINED__ */


' ########################################################################################
' IViewObject2 interface
' IID = 00000127-0000-0000-C000-000000000046
' Inherited interface = IViewObject
' ########################################################################################

#IF NOT %DEF(%IViewObject2_INTERFACE_DEFINED)
    %IViewObject2_INTERFACE_DEFINED = 1

$IID_IViewObject2 = GUID$("{00000127-0000-0000-C000-000000000046}")

INTERFACE IViewObject2 $IID_IViewObject2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Draw ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYVAL DWORD _                            ' /* [in] */ HDC hicTargetDev
   , BYVAL DWORD _                            ' /* [in] */ HDC hdcDraw
   , BYREF RECTL _                            ' /* [in] */ LPCRECTL lprcBounds
   , BYREF RECTL _                            ' /* [in] */ LPCRECTL lprcWBounds
   , BYVAL DWORD _                            ' /* [in] */ BOOL ( STDMETHODCALLTYPE *pfnContinue )(ULONG_PTR dwContinue)
   , BYVAL DWORD _                            ' /* [in] */ ULONG_PTR dwContinue
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetColorSet ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYVAL DWORD _                            ' /* [in] */ HDC hicTargetDev
   , BYREF LOGPALETTE _                       ' /* [out] */ LOGPALETTE **ppColorSet
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Freeze ( _                          ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwFreeze
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unfreeze ( _                        ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ DWORD dwFreeze
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetAdvise ( _                       ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ DWORD aspect
   , BYVAL DWORD _                            ' /* [in] */ DWORD advf
   , BYVAL IUnknown _                         ' /* [in] */ IAdviseSink *pAdvSink
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAdvise ( _                       ' VTable offset = 32
     BYREF DWORD _                            ' /* [out] */ DWORD *pAspects
   , BYREF DWORD _                            ' /* [out] */ DWORD *pAdvf
   , BYREF IUnknown _                         ' /* [out] */ IAdviseSink **ppAdvSink
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetExtent ( _                       ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYREF DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYREF SIZEL _                            ' /* [out] */ LPSIZEL lpsizel
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IViewObject2_INTERFACE_DEFINED__ */


' ########################################################################################
' IDropSource interface
' IID = 00000121-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDropSource_INTERFACE_DEFINED)
    %IDropSource_INTERFACE_DEFINED = 1

$IID_IDropSource = GUID$("{00000121-0000-0000-C000-000000000046}")

INTERFACE IDropSource $IID_IDropSource

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryContinueDrag ( _               ' VTable offset = 12
     BYVAL LONG _                             ' /* [in] */ BOOL fEscapePressed
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfKeyState
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GiveFeedback ( _                    ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwEffect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDropSource_INTERFACE_DEFINED__ */


' ########################################################################################
' IDropTarget interface
' IID = 00000122-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDropTarget_INTERFACE_DEFINED)
    %IDropTarget_INTERFACE_DEFINED = 1

%MK_ALT = &H20

%DROPEFFECT_NONE   = 0
%DROPEFFECT_COPY   = 1
%DROPEFFECT_MOVE   = 2
%DROPEFFECT_LINK   = 4
%DROPEFFECT_SCROLL = &H80000000???

'// default inset-width of the hot zone, in pixels
'//   typical use: GetProfileInt("windows","DragScrollInset",DD_DEFSCROLLINSET)
%DD_DEFSCROLLINSET = 11

'// default delay before scrolling, in milliseconds
'//   typical use: GetProfileInt("windows","DragScrollDelay",DD_DEFSCROLLDELAY)
%DD_DEFSCROLLDELAY = 50

'// default scroll interval, in milliseconds
'//   typical use: GetProfileInt("windows","DragScrollInterval", DD_DEFSCROLLINTERVAL)
%DD_DEFSCROLLINTERVAL = 50

'// default delay before dragging should start, in milliseconds
'//   typical use: GetProfileInt("windows", "DragDelay", DD_DEFDRAGDELAY)
%DD_DEFDRAGDELAY = 200

'// default minimum distance (radius) before dragging should start, in pixels
'//   typical use: GetProfileInt("windows", "DragMinDist", DD_DEFDRAGMINDIST)
%DD_DEFDRAGMINDIST = 2

$IID_IDropTarget = GUID$("{00000122-0000-0000-C000-000000000046}")

INTERFACE IDropTarget $IID_IDropTarget

   INHERIT IUnknown

   ' =====================================================================================
   METHOD DragEnter ( _                       ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IDataObject *pDataObj
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfKeyState
   , BYREF POINTL _                           ' /* [in] */ POINTL pt
   , BYREF DWORD _                            ' /* [out][in] */ DWORD *pdwEffect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DragOver ( _                        ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD grfKeyState
   , BYREF POINTL _                           ' /* [in] */ POINTL pt
   , BYREF DWORD _                            ' /* [out][in] */ DWORD *pdwEffect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DragLeave ( _                       ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Drop ( _                            ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IDataObject *pDataObj
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfKeyState
   , BYREF POINTL _                           ' /* [in] */ POINTL pt
   , BYREF DWORD _                            ' /* [out][in] */ DWORD *pdwEffect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDropTarget_INTERFACE_DEFINED__ */


' ########################################################################################
' IDropSourceNotify interface
' IID = 0000012B-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDropSourceNotify_INTERFACE_DEFINED)
    %IDropSourceNotify_INTERFACE_DEFINED = 1

$IID_IDropSourceNotify = GUID$("{0000012B-0000-0000-C000-000000000046}")

INTERFACE IDropSourceNotify $IID_IDropSourceNotify

   INHERIT IUnknown

   ' =====================================================================================
   METHOD DragEnterTarget ( _                 ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ HWND hwndTarget
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DragLeaveTarget ( _                 ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDropSourceNotify_INTERFACE_DEFINED__ */


' ########################################################################################
' IEnumOLEVERB interface
' IID = 00000100-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumOLEVERB_INTERFACE_DEFINED)
    %IEnumOLEVERB_INTERFACE_DEFINED = 1

'typedef struct tagOLEVERB
'    {
'    LONG lVerb;
'    LPOLESTR lpszVerbName;
'    DWORD fuFlags;
'    DWORD grfAttribs;
'    }    OLEVERB;

TYPE OLEVERB
   lVerb        AS LONG              ' LONG
   lpszVerbName AS WORD PTR   ' LPOLESTR
   fuFlags      AS DWORD             ' DWORD
   grfAttribs   AS DWORD             ' DWORD
END TYPE

' OLEVERBATTRIB enum
%OLEVERBATTRIB_NEVERDIRTIES    = 1
%OLEVERBATTRIB_ONCONTAINERMENU = 2

$IID_IEnumOLEVERB = GUID$("{00000104-0000-0000-C000-000000000046}")

INTERFACE IEnumOLEVERB $IID_IEnumOLEVERB

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF IUnknown _                         ' /* [out] */ LPOLEVERB rgelt
   , BYREF DWORD _                            ' /* [out] */ ULONG * pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumOLEVERB _                     ' /* [out] */ IEnumOLEVERB **ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumOLEVERB_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%OLEIDL_INC)


'/****** DV APIs ***********************************************************/


'/* This function is declared in objbase.h and ole2.h.
'   IsolationAware support is via objbase.h.
'*/
'#if    !defined(ISOLATION_AWARE_ENABLED) \
'    || !ISOLATION_AWARE_ENABLED \
'    || !defined(_OBJBASE_H_) \
'    || !defined(CreateDataAdviseHolder)
'WINOLEAPI CreateDataAdviseHolder(OUT LPDATAADVISEHOLDER FAR* ppDAHolder);
'#endif


'/****** OLE API Prototypes ************************************************/

DECLARE FUNCTION OleBuildVersion LIB "OLE32.DLL" ALIAS "OleBuildVersion" ( _
 ) AS DWORD                            ' DWORD

'/* helper functions */
DECLARE FUNCTION ReadClassStg LIB "OLE32.DLL" ALIAS "ReadClassStg" ( _
   BYVAL IUnknown _                    ' [in] IStorage* pStg
 , BYREF GUID _                        ' [out] CLSID* pclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION WriteClassStg LIB "OLE32.DLL" ALIAS "WriteClassStg" ( _
   BYVAL IUnknown _                    ' [in] IStorage* pStg
 , BYREF GUID _                        ' [in] REFCLSID rclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION ReadClassStm LIB "OLE32.DLL" ALIAS "ReadClassStm" ( _
   BYVAL IUnknown _                    ' [in] IStream* pStm
 , BYREF GUID _                        ' [out] CLSID* pclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION WriteClassStm LIB "OLE32.DLL" ALIAS "WriteClassStm" ( _
   BYVAL IUnknown _                    ' [in] IStream* pStm
 , BYREF GUID _                        ' [in] REFCLSID rclsid
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION WriteFmtUserTypeStg LIB "OLE32.DLL" ALIAS "WriteFmtUserTypeStg" ( _
   BYVAL IUnknown _                    ' [in] IStorage* pStg
 , BYVAL DWORD _                       ' [in] CLIPFORMAT cf
 , BYVAL DWORD _                       ' [in] LPWSTR* lpszUserType
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION ReadFmtUserTypeStg LIB "OLE32.DLL" ALIAS "ReadFmtUserTypeStg" ( _
   BYVAL IUnknown _                    ' [in] IStorage* pStg
 , BYREF DWORD _                       ' [out] CLIPFORMAT* pcf
 , BYREF DWORD _                       ' [out] LPWSTR* lplpszUserType
 ) AS LONG                             ' HRESULT


'/* init/term */

DECLARE FUNCTION OleInitialize LIB "OLE32.DLL" ALIAS "OleInitialize" ( _
   BYVAL DWORD _                       ' [in] LPVOID pvReserved
 ) AS LONG                             ' HRESULT

DECLARE SUB OleUninitialize LIB "OLE32.DLL" ALIAS "OleUninitialize" ( _
 )                                     ' void


'/* APIs to query whether (Embedded/Linked) object can be created from
'   the data object */

DECLARE FUNCTION OleQueryLinkFromData LIB "OLE32.DLL" ALIAS "OleQueryLinkFromData" ( _
   BYVAL IUnknown _                    ' [in] IDataObject * pSrcDataObject
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleQueryCreateFromData LIB "OLE32.DLL" ALIAS "OleQueryCreateFromData" ( _
   BYVAL IUnknown _                    ' [in] IDataObject * pSrcDataObject
 ) AS LONG                             ' HRESULT


'/* Object creation APIs */

DECLARE FUNCTION OleCreate LIB "OLE32.DLL" ALIAS "OleCreate" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYREF FORMATETC _                   ' [in] FORMATETC * pFormatEtc
 , BYVAL IUnknown _                    ' [in] IOleClientSite * pClientSite
 , BYVAL IUnknown _                    ' [in] IStorage * pStg
 , BYREF ANY _                         ' [out] void ** ppvObject
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateEx LIB "OLE32.DLL" ALIAS "OleCreateEx" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD dwFlags
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYVAL DWORD _                       ' [in] ULONG cFormats
 , BYREF DWORD _                       ' [in] DWORD rgAdvf [array]
 , BYREF FORMATETC _                   ' [in] LPFORMATETC rgFormatEtc [array]
 , BYVAL IUnknown _                    ' [in] LPADVISESINK pAdviseSink
 , BYREF DWORD _                       ' [out] DWORD* rgdwConnection [array]
 , BYVAL IUnknown _                    ' [in] LPOLECLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateFromData LIB "OLE32.DLL" ALIAS "OleCreateFromData" ( _
   BYVAL IUnknown _                    ' [in] LPDATAOBJECT pSrcDataObj
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYREF FORMATETC _                   ' [in] LPFORMATETC pFormatEtc
 , BYVAL IUnknown _                    ' [in] LPOLECLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateFromDataEx LIB "OLE32.DLL" ALIAS "OleCreateFromDataEx" ( _
   BYVAL IUnknown _                    ' [in] LPDATAOBJECT pSrcDataObj
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD dwFlags
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYVAL DWORD _                       ' [in] ULONG cFormats
 , BYREF DWORD _                       ' [in] DWORD rgAdvf [array]
 , BYREF FORMATETC _                   ' [in] LPFORMATETC rgFormatEtc [array]
 , BYVAL IUnknown _                    ' [in] LPADVISESINK pAdviseSink
 , BYREF DWORD _                       ' [out] DWORD FAR* rgdwConnection [array]
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateLinkFromData LIB "OLE32.DLL" ALIAS "OleCreateLinkFromData" ( _
   BYVAL IUnknown _                    ' [in] LPDATAOBJECT pSrcDataObj
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYREF FORMATETC _                   ' [in] LPFORMATETC pFormatEtc
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateLinkFromDataEx LIB "OLE32.DLL" ALIAS "OleCreateLinkFromDataEx" ( _
   BYVAL IUnknown _                    ' [in] LPDATAOBJECT pSrcDataObj
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD dwFlags
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYVAL DWORD _                       ' [in] ULONG cFormats
 , BYREF DWORD _                       ' [in] DWORD rgAdvf [array]
 , BYREF FORMATETC _                   ' [in] LPFORMATETC rgFormatEtc [array]
 , BYVAL IUnknown _                    ' [in] LPADVISESINK pAdviseSink
 , BYREF DWORD _                       ' [out] DWORD FAR* rgdwConnection [array]
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateStaticFromData LIB "OLE32.DLL" ALIAS "OleCreateStaticFromData" ( _
   BYVAL IUnknown _                    ' [in] LPDATAOBJECT pSrcDataObj
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYVAL FORMATETC _                   ' [in] LPFORMATETC pFormatEtc
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateLink LIB "OLE32.DLL" ALIAS "OleCreateLink" ( _
   BYVAL IUnknown _                    ' [in] LPMONIKER pmkLinkSrc
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYREF FORMATETC _                   ' [in] LPFORMATETC pFormatEtc
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateLinkEx LIB "OLE32.DLL" ALIAS "OleCreateLinkEx" ( _
   BYVAL IUnknown _                    ' [in] LPMONIKER pmkLinkSrc
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD dwFlags
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYVAL DWORD _                       ' [in] ULONG cFormats
 , BYREF DWORD _                       ' [in] DWORD* rgAdvf
 , BYREF FORMATETC _                   ' [in] LPFORMATETC pFormatEtc
 , BYVAL IUnknown _                    ' [in] IAdviseSink FAR* lpAdviseSink
 , BYREF DWORD _                       ' [out] DWORD FAR* rgdwConnection
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateLinkToFile LIB "OLE32.DLL" ALIAS "OleCreateLinkToFile" ( _
   BYVAL DWORD _                       ' [in] LPWSTR lpszFileName
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYREF FORMATETC _                   ' [in] LPFORMATETC pFormatEtc
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateLinkToFileEx LIB "OLE32.DLL" ALIAS "OleCreateLinkToFileEx" ( _
   BYVAL DWORD _                       ' [in] LPWSTR lpszFileName
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD dwFlags
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYVAL DWORD _                       ' [in] ULONG cFormats
 , BYREF DWORD _                       ' [in] DWORD rgAdvf [array]
 , BYREF FORMATETC _                   ' [in] LPFORMATETC rgFormatEtc [array]
 , BYVAL IUnknown _                    ' [in] LPADVISESINK pAdviseSink
 , BYREF DWORD _                       ' [out] DWORD FAR* rgdwConnection [array]
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateFromFile LIB "OLE32.DLL" ALIAS "OleCreateFromFile" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYVAL DWORD _                       ' [in] LPCOLESTR lpszFileName
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYREF FORMATETC _                   ' [in] LPFORMATETC pFormatEtc
 , BYVAL IUnknown _                    ' [in] LPOLECLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateFromFileEx LIB "OLE32.DLL" ALIAS "OleCreateFromFileEx" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYVAL DWORD _                       ' [in] LPCOLESTR lpszFileName
 , BYREF GUID _                        ' [in] REFIID riid
 , BYVAL DWORD _                       ' [in] DWORD dwFlags
 , BYVAL DWORD _                       ' [in] DWORD renderopt
 , BYVAL DWORD _                       ' [in] ULONG cFormats
 , BYREF DWORD _                       ' [in] DWORD rgAdvf [array]
 , BYREF FORMATETC _                   ' [in] LPFORMATETC rgFormatEtc [array]
 , BYVAL IUnknown _                    ' [in] LPADVISESINK pAdviseSink
 , BYREF DWORD _                       ' [out] DWORD FAR* rgdwConnection [array]
 , BYVAL IUnknown _                    ' [in] LPCLIENTSITE pClientSite
 , BYVAL IUnknown _                    ' [in] LPSTORAGE pStg
 , BYREF ANY _                         ' [out] LPVOID FAR* ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleLoad LIB "OLE32.DLL" ALIAS "OleLoad" ( _
   BYVAL IUnknown, _                   ' [in] IStorage * pStg
   BYREF GUID _                        ' [in] REFIID riid
 , BYVAL IUnknown _                    ' [in] IOleClientSite * pClientSite
 , BYREF ANY _                         ' [out] LPVOID * ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleSave LIB "OLE32.DLL" ALIAS "OleSave" ( _
   BYVAL IUnknown _                    ' [in] IPersistStorage * pPS
 , BYVAL IUnknown _                    ' [in] IStorage * pStg
 , BYVAL LONG _                        ' [in] BOOL fSameAsLoad
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleLoadFromStream LIB "OLE32.DLL" ALIAS "OleLoadFromStream" ( _
   BYVAL IUnknown _                    ' [in] IStream * pStm
 , BYREF GUID _                        ' [in] REFIID iidInterface
 , BYREF ANY _                         ' [out] void ** ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleSaveToStream LIB "OLE32.DLL" ALIAS "OleSaveToStream" ( _
   BYVAL IUnknown _                    ' [in] IPersistStream * pPStm
 , BYVAL IUnknown _                    ' [in] IStream * pStm
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleSetContainedObject LIB "OLE32.DLL" ALIAS "OleSetContainedObject" ( _
   BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnk
 , BYVAL LONG _                        ' [in] BOOL fContained
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleNoteObjectVisible LIB "OLE32.DLL" ALIAS "OleNoteObjectVisible" ( _
   BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnknown
 , BYVAL LONG _                        ' [in] BOOL fVisible
 ) AS LONG                             ' HRESULT


'/* Drag/Drop APIs */

DECLARE FUNCTION RegisterDragDrop LIB "OLE32.DLL" ALIAS "RegisterDragDrop" ( _
   BYVAL DWORD _                       ' [in] HWND hwnd
 , BYVAL IUnknown _                    ' [in] IDropTarget * pDropTarget
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION RevokeDragDrop LIB "OLE32.DLL" ALIAS "RevokeDragDrop" ( _
   BYVAL DWORD _                       ' [in] HWND hwnd
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION DoDragDrop LIB "OLE32.DLL" ALIAS "DoDragDrop" ( _
   BYVAL IUnknown _                    ' [in] IDataObject * pDataObject
 , BYVAL IUnknown _                    ' [in] IDropSource * pDropSource
 , BYVAL DWORD _                       ' [in] DWORD dwOKEffect
 , BYREF DWORD _                       ' [out] DWORD * pdwEffect
 ) AS LONG                             ' HRESULT

'/* Clipboard APIs */

DECLARE FUNCTION OleSetClipboard LIB "OLE32.DLL" ALIAS "OleSetClipboard" ( _
   BYVAL IUnknown _                    ' [in] IDataObject * pDataObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleGetClipboard LIB "OLE32.DLL" ALIAS "OleGetClipboard" ( _
   BYREF IUnknown _                    ' [out] IDataObject ** ppDataObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleFlushClipboard LIB "OLE32.DLL" ALIAS "OleFlushClipboard" ( _
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleIsCurrentClipboard LIB "OLE32.DLL" ALIAS "OleIsCurrentClipboard" ( _
   BYVAL IUnknown _                    ' [in] IDataObject * pDataObject
 ) AS LONG                             ' HRESULT


'/* InPlace Editing APIs */

DECLARE FUNCTION OleCreateMenuDescriptor LIB "OLE32.DLL" ALIAS "OleCreateMenuDescriptor" ( _
   BYVAL DWORD _                       ' [in] HMENU hmenuCombined
 , BYREF OLEMENUGROUPWIDTHS _          ' [in] LPOLEMENUGROUPWIDTHS lpMenuWidths
 ) AS DWORD                            ' HOLEMENU

DECLARE FUNCTION OleSetMenuDescriptor LIB "OLE32.DLL" ALIAS "OleSetMenuDescriptor" ( _
   BYVAL DWORD _                       ' [in] HOLEMENU holemenu
 , BYVAL DWORD _                       ' [in] HWND hwndFrame
 , BYVAL DWORD _                       ' [in] HWND hwndActiveObject
 , BYVAL IUnknown _                    ' [in] LPOLEINPLACEFRAME lpFrame
 , BYVAL IUnknown _                    ' [in] LPOLEINPLACEACTIVEOBJECT lpActiveObj
 ) AS LONG                             ' HRESULT

DECLARE SUB OleDestroyMenuDescriptor LIB "OLE32.DLL" ALIAS "OleDestroyMenuDescriptor" ( _
   BYVAL DWORD _                       ' [in] HOLEMENU holemenu
 )                                     ' void

DECLARE FUNCTION OleTranslateAccelerator LIB "OLE32.DLL" ALIAS "OleTranslateAccelerator" ( _
   BYVAL IUnknown _                    ' [in] LPOLEINPLACEFRAME lpFrame
 , BYVAL OLEINPLACEFRAMEINFO _         ' [in] LPOLEINPLACEFRAMEINFO lpFrameInfo
 , BYREF tagMsg _                      ' [in] LPMSG lpmsg
 ) AS LONG                             ' HRESULT

'/* Helper APIs */
DECLARE FUNCTION OleDuplicateData LIB "OLE32.DLL" ALIAS "OleDuplicateData" ( _
   BYVAL DWORD _                       ' [in] HANDLE hSrc
 , BYVAL DWORD _                       ' [in] CLIPFORMAT cfFormat
 , BYVAL DWORD _                       ' [in] UINT uiFlags
 ) AS DWORD                            ' HANDLE

DECLARE FUNCTION OleDraw LIB "OLE32.DLL" ALIAS "OleDraw" ( _
   BYVAL IUnknown _                    ' [in] IUnknown * pUnk
 , BYVAL DWORD _                       ' [in] DWORD dwAspect
 , BYVAL DWORD _                       ' [in] HDC hdcDraw
 , BYREF RECT _                        ' [in] LPCRECT lprcBounds
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleRun LIB "OLE32.DLL" ALIAS "OleRun" ( _
   BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnknown
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleIsRunning LIB "OLE32.DLL" ALIAS "OleIsRunning" ( _
   BYVAL IUnknown _                    ' [in] LPOLEOBJECT pObject
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleLockRunning LIB "OLE32.DLL" ALIAS "OleLockRunning" ( _
   BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnknown
 , BYVAL LONG _                        ' [in] BOOL fLock
 , BYVAL LONG _                        ' [in] BOOL fLastUnlockCloses
 ) AS LONG                             ' HRESULT

DECLARE SUB ReleaseStgMedium LIB "OLE32.DLL" ALIAS "ReleaseStgMedium" ( _
   BYREF STGMEDIUM _                   ' [in] STGMEDIUM * pmedium
 )                                     ' void

DECLARE FUNCTION CreateOleAdviseHolder LIB "OLE32.DLL" ALIAS "CreateOleAdviseHolder" ( _
   BYREF IUnknown _                    ' [out] LPOLEADVISEHOLDER FAR* ppOAHolder
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateDefaultHandler LIB "OLE32.DLL" ALIAS "OleCreateDefaultHandler" ( _
   BYREF GUID _                        ' [in] REFCLSID clsid
 , BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnkOuter
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] LPVOID FAR * ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleCreateEmbeddingHelper LIB "OLE32.DLL" ALIAS "OleCreateEmbeddingHelper" ( _
   BYREF GUID _                        ' [in] REFCLSID clsid
 , BYVAL IUnknown _                    ' [in] LPUNKNOWN pUnkOuter
 , BYVAL DWORD _                       ' [in] DWORD flags
 , BYVAL IUnknown _                    ' [in] LPCLASSFACTORY pCF
 , BYREF GUID _                        ' [in] REFIID riid
 , BYREF ANY _                         ' [out] LPVOID * ppvObj
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION IsAccelerator LIB "OLE32.DLL" ALIAS "IsAccelerator" ( _
   BYVAL DWORD _                       ' [in] HACCEL hAccel
 , BYVAL LONG _                        ' [in] INT cAccelEntries
 , BYREF tagMsg _                      ' [in] LPMSG lpMsg
 , BYREF WORD _                        ' [out] WORD * lpwCmd
 ) AS LONG                             ' BOOL

'/* Icon extraction Helper APIs */

DECLARE FUNCTION OleGetIconOfFile LIB "OLE32.DLL" ALIAS "OleGetIconOfFile" ( _
   BYVAL DWORD _                       ' [in] LPOLESTR lpszPath
 , BYVAL LONG _                        ' [in] BOOL fUseFileAsLabel
 ) AS DWORD                            ' HGLOBAL

DECLARE FUNCTION OleGetIconOfClass LIB "OLE32.DLL" ALIAS "OleGetIconOfClass" ( _
   BYREF GUID _                        ' [in] REFCLSID rclsid
 , BYVAL DWORD _                       ' [in] LPOLESTR lpszLabel
 , BYVAL LONG _                        ' [in] BOOL fUseTypeAsLabel
 ) AS DWORD                            ' HGLOBAL

DECLARE FUNCTION OleMetafilePictFromIconAndLabel LIB "OLE32.DLL" ALIAS "OleMetafilePictFromIconAndLabel" ( _
   BYVAL DWORD _                       ' [in] HICON hIcon
 , BYVAL DWORD _                       ' [in] LPOLESTR lpszLabel
 , BYVAL DWORD _                       ' [in] LPOLESTR lpszSourceFile
 , BYVAL DWORD _                       ' [in] UINT iIconIndex
 ) AS DWORD                            ' HGLOBAL


'/* Registration Database Helper APIs */

DECLARE FUNCTION OleRegGetUserType LIB "OLE32.DLL" ALIAS "OleRegGetUserType" ( _
   BYREF GUID _                        ' [in] REFCLSID clsid
 , BYVAL DWORD _                       ' [in] DWORD dwFormOfType
 , BYREF DWORD _                       ' [out] LPOLESTR * pszUserType
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleRegGetMiscStatus LIB "OLE32.DLL" ALIAS "OleRegGetMiscStatus" ( _
   BYREF GUID _                        ' [in] REFCLSID clsid
 , BYVAL DWORD _                       ' [in] DWORD dwAspect
 , BYREF DWORD _                       ' [out] DWORD * pdwStatus
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleRegEnumFormatEtc LIB "OLE32.DLL" ALIAS "OleRegEnumFormatEtc" ( _
   BYREF GUID _                        ' [in] REFCLSID clsid
 , BYVAL DWORD _                       ' [in] DWORD dwDirection
 , BYREF IUnknown _                    ' [out] LPENUMFORMATETC * ppenumFormatetc
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleRegEnumVerbs LIB "OLE32.DLL" ALIAS "OleRegEnumVerbs" ( _
   BYREF GUID _                        ' [in] REFCLSID clsid
 , BYREF IUnknown _                    ' [out] LPENUMOLEVERB * ppenumOleVerb
 ) AS LONG                             ' HRESULT

'/* OLE 1.0 conversion APIS */

'/***** OLE 1.0 OLESTREAM declarations *************************************/

'typedef struct _OLESTREAM FAR*  LPOLESTREAM;

'typedef struct _OLESTREAMVTBL
'{
'    DWORD (CALLBACK* Get)(LPOLESTREAM, void FAR*, DWORD);
'    DWORD (CALLBACK* Put)(LPOLESTREAM, const void FAR*, DWORD);
'} OLESTREAMVTBL;
'typedef  OLESTREAMVTBL FAR*  LPOLESTREAMVTBL;

'typedef struct _OLESTREAM
'{
'    LPOLESTREAMVTBL lpstbl;
'} OLESTREAM;


DECLARE FUNCTION OleConvertOLESTREAMToIStorage LIB "OLE32.DLL" ALIAS "OleConvertOLESTREAMToIStorage" ( _
   BYREF ANY _                         ' [in] LPOLESTREAM lpolestream
 , BYREF IUnknown _                    ' [out] IStorage* pstg
 , BYREF DVTARGETDEVICE _              ' [in] const DVTARGETDEVICE* ptd
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleConvertIStorageToOLESTREAM LIB "OLE32.DLL" ALIAS "OleConvertIStorageToOLESTREAM" ( _
   BYVAL IUnknown _                    ' [in] IStorage* pStg
 , BYREF ANY _                         ' [out] LPOLESTREAM lpolestream
 ) AS LONG                             ' HRESULT

'/* Storage Utility APIs */

DECLARE FUNCTION GetHGlobalFromILockBytes LIB "OLE32.DLL" ALIAS "GetHGlobalFromILockBytes" ( _
   BYVAL IUnknown _                    ' [in] ILockBytes* pLkbyt
 , BYREF DWORD _                       ' [out] HGLOBAL* phglobal
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateILockBytesOnHGlobal LIB "OLE32.DLL" ALIAS "CreateILockBytesOnHGlobal" ( _
   BYVAL DWORD _                       ' [in] HGLOBL hGlobal
 , BYVAL LONG _                        ' [in] BOOL fDeleteOnRelease
 , BYREF IUnknown _                    ' [out] ILockBytes** ppLkbyt
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION GetHGlobalFromStream LIB "OLE32.DLL" ALIAS "GetHGlobalFromStream" ( _
   BYVAL IUnknown _                    ' [in] IStream* pstm
 , BYREF DWORD _                       ' [out] HGLOBAL* phglobal
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION CreateStreamOnHGlobal LIB "OLE32.DLL" ALIAS "CreateStreamOnHGlobal" ( _
   BYVAL DWORD _                       ' [in] HGLOBL hGlobal
 , BYVAL LONG _                        ' [in] BOOL fDeleteOnRelease
 , BYREF IUnknown _                    ' [out] LPSTREAM* ppstm
 ) AS LONG                             ' HRESULT

'/* ConvertTo APIS */

DECLARE FUNCTION OleDoAutoConvert LIB "OLE32.DLL" ALIAS "OleDoAutoConvert" ( _
   BYVAL IUnknown _                    ' [in] IStorage * pStg
 , BYREF GUID _                        ' [out] LPCLSID pClsidNew
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleGetAutoConvert LIB "OLE32.DLL" ALIAS "OleGetAutoConvert" ( _
   BYREF GUID _                        ' [in] REFCLSID clsidOld
 , BYREF GUID _                        ' [out] LPCLSID pClsidNew
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleSetAutoConvert LIB "OLE32.DLL" ALIAS "OleSetAutoConvert" ( _
   BYREF GUID _                        ' [in] REFCLSID clsidOld
 , BYREF GUID _                        ' [out] REFCLSID clsidNew
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION GetConvertStg LIB "OLE32.DLL" ALIAS "GetConvertStg" ( _
   BYVAL IUnknown _                    ' [in] IStorage* pStg
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION SetConvertStg LIB "OLE32.DLL" ALIAS "SetConvertStg" ( _
   BYVAL IUnknown _                    ' [in] IStorage* pStg
 , BYVAL LONG _                        ' [in] BOOL fConvert
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleConvertIStorageToOLESTREAMEx LIB "OLE32.DLL" ALIAS "OleConvertIStorageToOLESTREAMEx" ( _
   BYVAL IUnknown _                    ' [in] IStorage* pStg
 , BYVAL DWORD _                       ' [in] CLIPFORMAT cfFormat
 , BYVAL LONG _                        ' [in] LONG lWidth
 , BYVAL LONG _                        ' [in] LONG lHeight
 , BYVAL DWORD _                       ' [in] DWORD dwSize
 , BYREF STGMEDIUM _                   ' [in] STGMEDIUM pmedium
 , BYREF ANY _                         ' [out] LPOLESTREAM lpolestm
 ) AS LONG                             ' HRESULT

DECLARE FUNCTION OleConvertOLESTREAMToIStorageEx LIB "OLE32.DLL" ALIAS "OleConvertOLESTREAMToIStorageEx" ( _
   BYREF ANY _                         ' [in] LPOLESTREAM lpolestm
 , BYREF IUnknown _                    ' [out] IStorage* pstg
 , BYREF DWORD _                       ' [out] CLIPFORMAT* pcfFormat
 , BYREF LONG _                        ' [out] LONG* plWidth
 , BYREF LONG _                        ' [out] LONG* plHeight
 , BYREF DWORD _                       ' [out] DWORD* pdwSize
 , BYREF STGMEDIUM _                   ' [out] STGMEDIUM pmedium
 ) AS LONG                             ' HRESULT


#ENDIF   ' #IF NOT %DEF(%OLE2_INC)

'//+-------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//--------------------------------------------------------------------------

#IF NOT %DEF(%OBJIDL_INC)
    %OBJIDL_INC = 1

TYPE COSERVERINFO
   dwReserved1 AS DWORD            ' DWORD dwReserved1
   pwszName    AS WORD PTR         ' LPWSTR pwszName
   pAuthInfo   AS COAUTHINFO PTR   ' COAUTHINFO *pAuthInfo
   dwReserved2 AS DWORD            ' DWORD dwReserved2
END TYPE

' ########################################################################################
' IMarshal interface
' IID = 00000003-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMarshal_INTERFACE_DEFINED)
    %IMarshal_INTERFACE_DEFINED = 1

$IID_IMarshal = GUID$("{00000003-0000-0000-C000-000000000046}")

INTERFACE IMarshal $IID_IMarshal

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetUnmarshalClass ( _               ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   , BYREF GUID _                             ' /* [out] */ CLSID *pCid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMarshalSizeMax ( _               ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   , BYREF DWORD _                            ' /* [out] */ DWORD *pSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD MarshalInterface ( _                ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UnmarshalInterface ( _              ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseMarshalData ( _              ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DisconnectObject ( _                ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ DWORD dwReserved
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMarshal_INTERFACE_DEFINED__ */


' ########################################################################################
' IMarshal2 interface
' IID = 000001CF-0000-0000-C000-000000000046
' Inherited interface = IMarshal
' ########################################################################################

#IF NOT %DEF(%IMarshal2_INTERFACE_DEFINED)
    %IMarshal2_INTERFACE_DEFINED = 1

$IID_IMarshal2 = GUID$("{000001CF-0000-0000-C000-000000000046}")

INTERFACE IMarshal2 $IID_IMarshal2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetUnmarshalClass ( _               ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   , BYREF GUID _                             ' /* [out] */ CLSID *pCid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMarshalSizeMax ( _               ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   , BYREF DWORD _                            ' /* [out] */ DWORD *pSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD MarshalInterface ( _                ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [unique][in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UnmarshalInterface ( _              ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseMarshalData ( _              ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DisconnectObject ( _                ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ DWORD dwReserved
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMarshal2_INTERFACE_DEFINED__ */



' ########################################################################################
' ICancelMethodCalls interface
' IID = 00000029-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICancelMethodCalls_INTERFACE_DEFINED)
    %ICancelMethodCalls_INTERFACE_DEFINED = 1

$IID_ICancelMethodCalls = GUID$("{00000029-0000-0000-C000-000000000046}")

INTERFACE ICancelMethodCalls $IID_ICancelMethodCalls

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Cancel ( _                          ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG ulSeconds
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TestCancel ( _                      ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICancelMethodCalls_INTERFACE_DEFINED__ */

' ########################################################################################
' IAddrTrackingControl interface
' IID = 00000147-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAddrTrackingControl_INTERFACE_DEFINED)
    %IAddrTrackingControl_INTERFACE_DEFINED = 1

$IID_IAddrTrackingControl = GUID$("{00000147-0000-0000-C000-000000000046}")

INTERFACE IAddrTrackingControl $IID_IAddrTrackingControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD EnableCOMDynamicAddrTracking ( _    ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DisableCOMDynamicAddrTracking ( _   ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAddrTrackingControl_INTERFACE_DEFINED__ */


#ENDIF   ' #IF NOT %DEF(%OBJIDL_INC)

#ENDIF   ' #IF NOT %DEF(%OAIDL_INC)


' ########################################################################################
' IUnknown interface
' IID = 00000000-0000-C000-0000000000000046
' NOTE: Renamed because of conflicts with the built-in PB definition.
' ########################################################################################

#IF NOT %DEF(%IUnknown_INTERFACE_DEFINED)
    %IUnknown_INTERFACE_DEFINED = 1

$IID_IUnknown = GUID$("{00000000-0000-0000-C000-000000000046}")

'INTERFACE IUnknown $IID_IUnknown

'   ' =====================================================================================
'   METHOD QueryInterface ( _                  ' VTable offset = 12
'     BYREF GUID _                             ' /* [in] */ REFIID iid
'   , BYREF Iunknown _                         ' /* [out] */ void ** ppvObject
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD AddRef ( _                          ' VTable offset = 14
'   ) AS DWORD                                 ' ULONG
'   ' =====================================================================================
'   METHOD Release ( _                         ' VTable offset = 16
'   ) AS DWORD                                 ' ULONG
'   ' =====================================================================================

'END INTERFACE

#ENDIF  ' /* __IUnknown_INTERFACE_DEFINED__ */


' ########################################################################################
' AsyncIUnknown interface
' IID = 000E0000-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%AsyncIUnknown_INTERFACE_DEFINED)
    %AsyncIUnknown_INTERFACE_DEFINED = 1

$IID_AsyncIUnknown = GUID$("{000E0000-0000-0000-C000-000000000046}")

#ENDIF   ' /* __AsyncIUnknown_INTERFACE_DEFINED__ */


' ########################################################################################
' IClassFactory interface
' IID = 00000001-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' NOTE: Renamed because of conflicts with the built-in PB definition.
' ########################################################################################

#IF NOT %DEF(%IClassFactory_INTERFACE_DEFINED)
    %IClassFactory_INTERFACE_DEFINED = 1

$IID_IClassFactory = GUID$("{00000001-0000-0000-C000-000000000046}")

INTERFACE COM_IClassFactory $IID_IClassFactory

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateInstance ( _                  ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnkOuter
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppvObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LockServer ( _                      ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fLock
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IClassFactory_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%UNKNWN_INC)

'//+-------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//--------------------------------------------------------------------------

#IF NOT %DEF(%OBJIDL_INC)
    %OBJIDL_INC = 1

TYPE COSERVERINFO
   dwReserved1 AS DWORD            ' DWORD dwReserved1
   pwszName    AS WORD PTR         ' LPWSTR pwszName
   pAuthInfo   AS COAUTHINFO PTR   ' COAUTHINFO *pAuthInfo
   dwReserved2 AS DWORD            ' DWORD dwReserved2
END TYPE

' ########################################################################################
' IMarshal interface
' IID = 00000003-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMarshal_INTERFACE_DEFINED)
    %IMarshal_INTERFACE_DEFINED = 1

$IID_IMarshal = GUID$("{00000003-0000-0000-C000-000000000046}")

INTERFACE IMarshal $IID_IMarshal

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetUnmarshalClass ( _               ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   , BYREF GUID _                             ' /* [out] */ CLSID *pCid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMarshalSizeMax ( _               ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   , BYREF DWORD _                            ' /* [out] */ DWORD *pSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD MarshalInterface ( _                ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UnmarshalInterface ( _              ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseMarshalData ( _              ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DisconnectObject ( _                ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ DWORD dwReserved
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMarshal_INTERFACE_DEFINED__ */


' ########################################################################################
' IMarshal2 interface
' IID = 000001CF-0000-0000-C000-000000000046
' Inherited interface = IMarshal
' ########################################################################################

#IF NOT %DEF(%IMarshal2_INTERFACE_DEFINED)
    %IMarshal2_INTERFACE_DEFINED = 1

$IID_IMarshal2 = GUID$("{000001CF-0000-0000-C000-000000000046}")

INTERFACE IMarshal2 $IID_IMarshal2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetUnmarshalClass ( _               ' VTable offset = 12
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   , BYREF GUID _                             ' /* [out] */ CLSID *pCid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMarshalSizeMax ( _               ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   , BYREF DWORD _                            ' /* [out] */ DWORD *pSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD MarshalInterface ( _                ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL DWORD _                            ' /* [unique][in] */ void *pv
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwDestContext
   , BYVAL DWORD _                            ' /* [in] */ void *pvDestContext
   , BYVAL DWORD _                            ' /* [in] */ DWORD mshlflags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UnmarshalInterface ( _              ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppv
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseMarshalData ( _              ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IStream *pStm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DisconnectObject ( _                ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ DWORD dwReserved
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMarshal2_INTERFACE_DEFINED__ */


' ########################################################################################
' IMalloc interface
' IID = 00000002-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMalloc_INTERFACE_DEFINED)
    %IMalloc_INTERFACE_DEFINED = 1

$IID_IMalloc = GUID$("{00000002-0000-0000-C000-000000000046}")

INTERFACE IMalloc $IID_IMalloc

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Alloc ( _                           ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cb
   )                                          ' void
   ' =====================================================================================
   METHOD Realloc ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ void * pv
   , BYVAL DWORD _                            ' /* [in] */ ULONG cb
   )                                          ' void
   ' =====================================================================================
   METHOD Free ( _                            ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ void * pv
   )                                          ' void
   ' =====================================================================================
   METHOD GetSize ( _                         ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ void * pv
   ) AS DWORD                                 ' ULONG
   ' =====================================================================================
   METHOD DidAlloc ( _                        ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ void * pv
   ) AS LONG                                  ' int
   ' =====================================================================================
   METHOD HeapMinimize ( _                    ' VTable offset = 32
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMalloc_INTERFACE_DEFINED__ */


' ########################################################################################
' IMallocSpy interface
' IID = 0000001D-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMallocSpy_INTERFACE_DEFINED)
    %IMallocSpy_INTERFACE_DEFINED = 1

$IID_IMallocSpy = GUID$("{0000001D-0000-0000-C000-000000000046}")

INTERFACE IMallocSpy $IID_IMallocSpy

   INHERIT IUnknown

   ' =====================================================================================
   METHOD PreAlloc ( _                        ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cbRequest
   ) AS DWORD                                 ' ULONG
   ' =====================================================================================
   METHOD PostAlloc ( _                       ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ void *pActual
   )                                          ' void
   ' =====================================================================================
   METHOD PreFree ( _                         ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ void *pRequest
   , BYVAL LONG _                             ' /* [in] */ BOOL fSpyed
   )                                          ' void
   ' =====================================================================================
   METHOD PostFree ( _                        ' VTable offset = 24
     BYVAL LONG _                             ' /* [in] */ BOOL fSpyed
   )                                          ' void
   ' =====================================================================================
   METHOD PreRealloc ( _                      ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ void *pRequest
   , BYVAL DWORD _                            ' /* [in] */ ULONG cbRequest
   , BYREF DWORD _                            ' /* [out] */ void **ppNewRequest
   , BYVAL LONG _                             ' /* [in] */ BOOL fSpyed
   )                                          ' ULONG
   ' =====================================================================================
   METHOD PostRealloc ( _                     ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ void *pActual
   , BYVAL LONG _                             ' /* [in] */ BOOL fSpyed
   )                                          ' void
   ' =====================================================================================
   METHOD PreGetSize ( _                      ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ void *pRequest
   , BYVAL LONG _                             ' /* [in] */ BOOL fSpyed
   )                                          ' void
   ' =====================================================================================
   METHOD PostGetSize ( _                     ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ ULONG cbActual
   , BYVAL LONG _                             ' /* [in] */ BOOL fSpyed
   )                                          ' ULONG
   ' =====================================================================================
   METHOD PreDidAlloc ( _                     ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ void *pRequest
   , BYVAL LONG _                             ' /* [in] */ BOOL fSpyed
   )                                          ' void
   ' =====================================================================================
   METHOD PostDidAlloc ( _                    ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ void *pRequest
   , BYVAL LONG _                             ' /* [in] */ BOOL fSpyed
   , BYVAL LONG _                             ' /* [in] */ int fActual
   )                                          ' LONG
   ' =====================================================================================
   METHOD PreHeapMinimize ( _                 ' VTable offset = 52
   )                                          ' void
   ' =====================================================================================
   METHOD PostHeapMinimize ( _                ' VTable offset = 56
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMallocSpy_INTERFACE_DEFINED__ */


' ########################################################################################
' IExternalConnection interface
' IID = 00000019-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IExternalConnection_INTERFACE_DEFINED)
    %IExternalConnection_INTERFACE_DEFINED = 1

' EXTCONN enum
%EXTCONN_STRONG   = &H1???
%EXTCONN_WEAK     = &H2???
%EXTCONN_CALLABLE = &H4???

$IID_IExternalConnection = GUID$("{00000019-0000-0000-C000-000000000046}")

INTERFACE IExternalConnection $IID_IExternalConnection

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddConnection ( _                   ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD extconn
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved
   ) AS DWORD                                 ' DWORD
   ' =====================================================================================
   METHOD ReleaseConnection ( _               ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD extconn
   , BYVAL DWORD _                            ' /* [in] */ DWORD reserved
   , BYVAL DWORD _                            ' /* [in] */ BOOL fLastReleaseCloses
   ) AS DWORD                                 ' DWORD
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IExternalConnection_INTERFACE_DEFINED__ */


' ########################################################################################
' AsyncIMultiQI interface
' IID = 000E0020-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%AsyncIMultiQI_INTERFACE_DEFINED)
    %AsyncIMultiQI_INTERFACE_DEFINED = 1

$IID_AsyncIMultiQI = GUID$("{000E0020-0000-0000-C000-000000000046}")

INTERFACE AsyncIMultiQI $IID_AsyncIMultiQI

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Begin_QueryMultipleInterfaces ( _   ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cMQIs
   , BYREF MULTI_QI _                         ' /* [out][in] */ MULTI_QI *pMQIs
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Finish_QueryMultipleInterfaces ( _  ' VTable offset = 16
     BYREF MULTI_QI _                         ' /* [out][in] */ MULTI_QI *pMQIs
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __AsyncIMultiQI_INTERFACE_DEFINED__ */


' ########################################################################################
' ICancelMethodCalls interface
' IID = 00000029-0000-0000-C000-000000000046
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICancelMethodCalls_INTERFACE_DEFINED)
    %ICancelMethodCalls_INTERFACE_DEFINED = 1

$IID_ICancelMethodCalls = GUID$("{00000029-0000-0000-C000-000000000046}")

INTERFACE ICancelMethodCalls $IID_ICancelMethodCalls

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Cancel ( _                          ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG ulSeconds
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TestCancel ( _                      ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICancelMethodCalls_INTERFACE_DEFINED__ */



' ########################################################################################
' IPipeDouble interface
' IID = DB2F3ACE-2F86-11D1-8E04-00C04FB9989A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPipeDouble_INTERFACE_DEFINED)
    %IPipeDouble_INTERFACE_DEFINED = 1

$IID_IPipeDouble = GUID$("{DB2F3ACE-2F86-11D1-8E04-00C04FB9989A}")

INTERFACE IPipeDouble $IID_IPipeDouble

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Pull ( _                            ' VTable offset = 12
     BYREF DOUBLE _                           ' /* [out] */ DOUBLE *buf
   , BYVAL DWORD _                            ' /* [in] */ ULONG cRequest
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcReturned
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Push ( _                            ' VTable offset = 16
     BYREF DOUBLE _                           ' /* [in] */ DOUBLE *buf
   , BYVAL DWORD _                            ' /* [in] */ ULONG cSent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPipeDouble_INTERFACE_DEFINED__ */


' ########################################################################################
' AsyncIPipeDouble interface
' IID = DB2F3ACF-2F86-11D1-8E04-00C04FB9989A
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%AsyncIPipeDouble_INTERFACE_DEFINED)
    %AsyncIPipeDouble_INTERFACE_DEFINED = 1

$IID_AsyncIPipeDouble = GUID$("{DB2F3ACF-2F86-11D1-8E04-00C04FB9989A}")

INTERFACE AsyncIPipeDouble $IID_AsyncIPipeDouble

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Begin_Pull ( _                      ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cRequest
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Finish_Pull ( _                     ' VTable offset = 16
     BYREF DOUBLE _                           ' /* [out] */ DOUBLE *buf
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcReturned
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Begin_Push ( _                      ' VTable offset = 20
     BYREF DOUBLE _                           ' /* [in] */ DOUBLE *buf
   , BYVAL DWORD _                            ' /* [in] */ ULONG cSent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Finish_Push ( _                     ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __AsyncIPipeDouble_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%OBJIDL_INC)

'//+-------------------------------------------------------------------------
'//
'//  Microsoft Windows
'//  Copyright (c) Microsoft Corporation. All rights reserved.
'//
'//--------------------------------------------------------------------------

#IF NOT %DEF(%OCIDL_INC)
    %OCIDL_INC = 1

'/* header files for imported files */

#IF NOT %DEF(%IOleControlTypes_INTERFACE_DEFINED)
    %IOleControlTypes_INTERFACE_DEFINED = 1

' UASFLAGS enum
%UAS_NORMAL         = 0
%UAS_BLOCKED        = &H1
%UAS_NOPARENTENABLE = &H2
%UAS_MASK           = &H3

'/* State values for the DISPID_READYSTATE property */

' READYSTATE enum
%READYSTATE_UNINITIALIZED = 0
%READYSTATE_LOADING       = 1
%READYSTATE_LOADED        = 2
%READYSTATE_INTERACTIVE   = 3
%READYSTATE_COMPLETE      = 4

#ENDIF   ' /* __IOleControlTypes_INTERFACE_DEFINED__ */

' ########################################################################################
' IEnumConnections interface
' IID = B196B287-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumConnections_INTERFACE_DEFINED)
    %IEnumConnections_INTERFACE_DEFINED = 1

TYPE CONNECTDATA
   pUnk     AS DWORD   ' IUnknown *pUnk
   dwCookie AS DWORD   ' DWORD dwCookie
END TYPE

$IID_IEnumConnections = GUID$("{B196B287-BAB4-101A-B69C-00AA00341D07}")

INTERFACE IEnumConnections $IID_IEnumConnections

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cConnections
   , BYREF CONNECTDATA _                      ' /* [out] */ CONNECTDATA * rgpcd
   , BYREF DWORD _                            ' /* [out] */ ULONG * pcFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumConnections _                 ' /* [out] */ IEnumConnections** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumConnections_INTERFACE_DEFINED__ */


' ########################################################################################
' IConnectionPoint interface (as built into the PowerBASIC compiler)
' IID = B196B286-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' NOTE: Renamed because of conflicts with the built-in PB definition.
' ########################################################################################

#IF NOT %DEF(%IConnectionPoint_INTERFACE_DEFINED)
   %IConnectionPoint_INTERFACE_DEFINED = 1

$IID_IConnectionPoint = GUID$("{B196B286-BAB4-101A-B69C-00AA00341D07}")

INTERFACE COM_IConnectionPoint $IID_IConnectionPoint

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetConnectionInterface ( _          ' VTable offset = 12
     BYREF pIID AS GUID _                     ' /* [out] */ IID *pIID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetConnectionPointContainer ( _     ' VTable offset = 16
     BYREF ppCPC AS IUnknown _                ' /* [out] */ IConnectionPointContainer **ppCPC)
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Advise ( _                          ' VTable offset = 20
     BYVAL pUnkSink AS IUnknown _             ' /* [in] */ IUnknown *pUnkSink
   , BYREF pdwCookie AS DWORD _               ' /* [out] */ DWORD *pdwCookie
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unadvise ( _                        ' VTable offset = 24
     BYVAL dwCookie AS DWORD _                ' /* [in] */ DWORD dwCookie
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumConnections ( _                 ' VTable offset = 28
     BYREF ppEnum AS IUnknown _               ' /* [out] */ IEnumConnections **ppEnum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IConnectionPoint_INTERFACE_DEFINED__ */

' *** As built into the PowerBASIC compiler ***

'INTERFACE IConnectionPoint $IID_IConnectionPoint

'   INHERIT IUnknown

'   ' =====================================================================================
'   METHOD GetConnectionInterface ( _          ' VTable offset = 12
'     BYREF pIID AS GUID _                     ' /* [out] */ IID *pIID
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD GetConnectionPointContainer ( _     ' VTable offset = 16
'     BYREF ppCPC AS DWORD _                   ' /* [out] */ IConnectionPointContainer **ppCPC)
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD Advise ( _                          ' VTable offset = 20
'     BYREF pUnkSink AS DWORD _                ' /* [in] */ IUnknown *pUnkSink
'   , BYREF pdwCookie AS DWORD _               ' /* [out] */ DWORD *pdwCookie
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD Unadvise ( _                        ' VTable offset = 24
'     BYVAL dwCookie AS DWORD _                ' /* [in] */ DWORD dwCookie
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD EnumConnections ( _                 ' VTable offset = 28
'     BYREF ppEnum AS DWORD _                  ' /* [out] */ IEnumConnections **ppEnum
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================

'END INTERFACE


' ########################################################################################
' IEnumConnectionPoints interface
' IID = B196B285-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumConnectionPoints_INTERFACE_DEFINED)
    %IEnumConnectionPoints_INTERFACE_DEFINED = 1

$IID_IEnumConnectionPoints = GUID$("{B196B285-BAB4-101A-B69C-00AA00341D07}")

INTERFACE IEnumConnectionPoints $IID_IEnumConnectionPoints

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   , BYREF IUnknown _                         ' /* [out] */ IConnectionPoint * rgelt
   , BYREF DWORD _                            ' /* [out] */ ULONG * pceltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG celt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumConnectionPoints _            ' /* [out] */ IEnumConnectionPoints** ppenum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumConnectionPoints_INTERFACE_DEFINED__ */


' ########################################################################################
' IConnectionPointContainer interface (as built into the PowerBASIC compiler)
' IID = B196B284-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' NOTE: Renamed because of conflicts with the built-in PB definition.
' ########################################################################################


#IF NOT %DEF(%IConnectionPointContainer_INTERFACE_DEFINED)
    %IConnectionPointContainer_INTERFACE_DEFINED = 1

$IID_IConnectionPointContainer = GUID$("{B196B284-BAB4-101A-B69C-00AA00341D07}")

INTERFACE COM_IConnectionPointContainer $IID_IConnectionPointContainer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD EnumConnectionPoints ( _            ' VTable offset = 12
     BYREF ppEnum AS IUnknown _               ' /* [out] */ IEnumConnectionPoints **ppEnum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FindConnectionPoint ( _             ' VTable offset = 14
     BYREF riid AS DWORD _                    ' /* [in] */ REFIID riid
   , BYREF ppCP AS IUnknown _                 ' /* [out] */ IConnectionPoint **ppCP
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IConnectionPointContainer_INTERFACE_DEFINED__ */

' *** As built into the PowerBASIC compiler ***

'INTERFACE IConnectionPointContainer $IID_IConnectionPointContainer


'   INHERIT IUnknown

'   ' =====================================================================================
'   METHOD EnumConnectionPoints ( _            ' VTable offset = 12
'     BYREF ppEnum AS DWORD _                  ' /* [out] */ IEnumConnectionPoints **ppEnum
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================
'   METHOD FindConnectionPoint ( _             ' VTable offset = 14
'     BYREF riid AS DWORD _                    ' /* [in] */ REFIID riid
'   , BYREF ppCP AS DWORD _                    ' /* [out] */ IConnectionPoint **ppCP
'   ) AS LONG                                  ' HRESULT
'   ' =====================================================================================

'END INTERFACE


' ########################################################################################
' IClassFactory2 interface
' IID = B196B28F-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IClassFactory
' ########################################################################################

#IF NOT %DEF(%IClassFactory2_INTERFACE_DEFINED)
    %IClassFactory2_INTERFACE_DEFINED = 1

TYPE LICINFO
   cbLicInfo        AS DWORD   ' LONG cbLicInfo
   fRuntimeKeyAvail AS LONG    ' BOOL fRuntimeKeyAvail
   fLicVerified     AS LONG    ' BOOL fLicVerified
END TYPE

$IID_IClassFactory2 = GUID$("{B196B28F-BAB4-101A-B69C-00AA00341D07}")

INTERFACE IClassFactory2 $IID_IClassFactory2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateInstance ( _                  ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IUnknown * pUnkOuter
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void ** ppvObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LockServer ( _                      ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fLock
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetLicInfo ( _                      ' VTable offset = 20
     BYREF LICINFO _                          ' /* [in] */ LICINFO * pLicInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RequestLicKey ( _                   ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ DWORD dwReserved
   , BYREF STRING _                           ' /* [out] */ BSTR * pbstrKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateInstanceLic ( _               ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IUnknown * pUnkOuter
   , BYVAL IUnknown _                         ' /* [in] */ IUnknown * pUnkReserved
   , BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYVAL STRING _                           ' /* [in] */ BSTR bstrKey
   , BYREF IUnknown _                         ' /* [out] */ void ** ppvObject
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IClassFactory2_INTERFACE_DEFINED__ */


' ########################################################################################
' IProvideClassInfo interface
' IID = B196B283-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IProvideClassInfo_INTERFACE_DEFINED)
    %IProvideClassInfo_INTERFACE_DEFINED = 1

$IID_IProvideClassInfo = GUID$("{B196B283-BAB4-101A-B69C-00AA00341D07}")

INTERFACE IProvideClassInfo $IID_IProvideClassInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassInfo ( _                    ' VTable offset = 12
     BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTI
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IProvideClassInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' IProvideClassInfo2 interface
' IID = A6BC3AC0-DBAA-11CE-9DE3-00AA004BB851
' Inherited interface = IProvideClassInfo
' ########################################################################################

#IF NOT %DEF(%IProvideClassInfo2_INTERFACE_DEFINED)
    %IProvideClassInfo2_INTERFACE_DEFINED = 1

' GUIDKINF enum
%GUIDKIND_DEFAULT_SOURCE_DISP_IID = 1

$IID_IProvideClassInfo2 = GUID$("{A6BC3AC0-DBAA-11CE-9DE3-00AA004BB851}")

INTERFACE IProvideClassInfo2 $IID_IProvideClassInfo2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassInfo ( _                    ' VTable offset = 12
     BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTI
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetGUID ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwGuidKind
   , BYREF GUID _                             ' /* [out] */ GUID *pGUID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IProvideClassInfo2_INTERFACE_DEFINED__ */


' ########################################################################################
' IProvideMultipleClassInfo interface
' IID = A7ABA9C1-8983-11cf-8F20-00805F2CD064
' Inherited interface = IProvideClassInfo2
' ########################################################################################

#IF NOT %DEF(%IProvideMultipleClassInfo_INTERFACE_DEFINED)
    %IProvideMultipleClassInfo_INTERFACE_DEFINED = 1

%MULTICLASSINFO_GETTYPEINFO           = &H00000001???
%MULTICLASSINFO_GETNUMRESERVEDDISPIDS = &H00000002???
%MULTICLASSINFO_GETIIDPRIMARY         = &H00000004???
%MULTICLASSINFO_GETIIDSOURCE          = &H00000008???
%TIFLAGS_EXTENDDISPATCHONLY           = &H00000001???

$IID_IProvideMultipleClassInfo = GUID$("{A7ABA9C1-8983-11CF-8F20-00805F2CD064}")

INTERFACE IProvideMultipleClassInfo $IID_IProvideMultipleClassInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassInfo ( _                    ' VTable offset = 12
     BYREF IUnknown _                         ' /* [out] */ ITypeInfo **ppTI
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetGUID ( _                         ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwGuidKind
   , BYREF GUID _                             ' /* [out] */ GUID *pGUID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMultiTypeInfoCount ( _           ' VTable offset = 20
     BYREF DWORD _                            ' /* [out] */ ULONG *pcti
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetInfoOfIndex ( _                  ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ ULONG iti
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                         ' /* [out] */ ITypeInfo **pptiCoClass
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwTIFlags
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcdispidReserved
   , BYREF GUID _                             ' /* [out] */ IID *piidPrimary
   , BYREF GUID _                             ' /* [out] */ IID *piidSource
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IProvideMultipleClassInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleControl interface
' IID = B196B288-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleControl_INTERFACE_DEFINED)
    %IOleControl_INTERFACE_DEFINED = 1

TYPE CONTROLINFO DWORD   ' // Must be DWORD aligned
   cb      AS DWORD    ' ULONG cb
   hAccel  AS DWORD    ' HACCEL hAccel
   cAccel  AS WORD     ' USHORT cAccel
   dwFlags AS DWORD    ' DWORD dwFlags
END TYPE

' CTRLINFO enum
%CTRLINFO_EATS_RETURN = 1
%CTRLINFO_EATS_ESCAPE = 2

$IID_IOleControl = GUID$("{B196B288-BAB4-101A-B69C-00AA00341D07}")

INTERFACE IOleControl $IID_IOleControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetControlInfo ( _                  ' VTable offset = 12
     BYREF CONTROLINFO _                      ' /* [out] */ CONTROLINFO *pCI
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnMnemonic ( _                      ' VTable offset = 16
     BYREF tagMSG _                           ' /* [in] */ MSG *pMsg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnAmbientPropertyChange ( _         ' VTable offset = 20
     BYVAL LONG _                             ' /* [in] */ DISPID dispID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FreezeEvents ( _                    ' VTable offset = 24
     BYVAL LONG _                             ' /* [in] */ BOOL bFreeze
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleControl_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleControlSite interface
' IID = B196B289-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleControlSite_INTERFACE_DEFINED)
    %IOleControlSite_INTERFACE_DEFINED = 1

TYPE POINTF
   x AS SINGLE   ' FLOAT x
   y AS SINGLE   ' FLOAT y
END TYPE

' XFORMCOORDS enum
%XFORMCOORDS_POSITION            = &H1???
%XFORMCOORDS_SIZE                = &H2???
%XFORMCOORDS_HIMETRICTOCONTAINER = &H4???
%XFORMCOORDS_CONTAINERTOHIMETRIC = &H8???
%XFORMCOORDS_EVENTCOMPAT         = &H10???

' KEYMODIFIERS enum
' The KEYMODIFIERS enumeration values are flags used in calls to
' IOleControlSite::TranslateAccelerator to describe additional keyboard states that can
' modify the meaning of the keyboard messages that are also passed into
' IOleControlSite.TranslateAccelerator.
%KEYMOD_SHIFT   = &H00000001???
%KEYMOD_CONTROL = &H00000002???
%KEYMOD_ALT     = &H00000004???


$IID_IOleControlSite = GUID$("{B196B289-BAB4-101A-B69C-00AA00341D07}")

INTERFACE IOleControlSite $IID_IOleControlSite

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnControlInfoChanged ( _            ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LockInPlaceActive ( _               ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fLock
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetExtendedControl ( _              ' VTable offset = 20
     BYREF IDispatch _                        ' /* [out] */ IDispatch **ppDisp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TransformCoords ( _                 ' VTable offset = 24
     BYREF POINTL _                           ' /* [out][in] */ POINTL *pPtlHimetric
   , BYREF POINTF _                           ' /* [out][in] */ POINTF *pPtfContainer
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TranslateAccelerator ( _            ' VTable offset = 28
     BYREF tagMSG _                           ' /* [in] */ MSG *pMsg
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfModifiers
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnFocus ( _                         ' VTable offset = 32
     BYVAL LONG _                             ' /* [in] */ BOOL fGotFocus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ShowPropertyFrame ( _               ' VTable offset = 36
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleControlSite_INTERFACE_DEFINED__ */


' ########################################################################################
' IPropertyPage interface
' IID = B196B28D-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPropertyPage_INTERFACE_DEFINED)
    %IPropertyPage_INTERFACE_DEFINED = 1

TYPE PROPPAGEINFO
   cb            AS DWORD      ' ULONG cb
   pszTitle      AS WORD PTR   ' LPOLESTR pszTitle
   nsize         AS SIZEL      ' SIZE size
   pszDocString  AS WORD PTR   ' LPOLESTR pszDocString
   pszHelpFile   AS WORD PTR   ' LPOLESTR pszHelpFile
   dwHelpContext AS DWORD      ' DWORD dwHelpContext
END TYPE

$IID_IPropertyPage = GUID$("{B196B28D-BAB4-101A-B69C-00AA00341D07}")

INTERFACE IPropertyPage $IID_IPropertyPage

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetPageSite ( _                     ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IPropertyPageSite *pPageSite
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Activate ( _                        ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ HWND hWndParent
   , BYREF RECT _                             ' /* [in] */ LPCRECT pRect
   , BYVAL LONG _                             ' /* [in] */ BOOL bModal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Deactivate ( _                      ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPageInfo ( _                     ' VTable offset = 24
     BYREF PROPPAGEINFO _                     ' /* [out] */ PROPPAGEINFO *pPageInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetObjects ( _                      ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ ULONG cObjects
   , BYREF IUnknown _                         ' /* [in] */ IUnknown **ppUnk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Show ( _                            ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ UINT nCmdShow
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Move ( _                            ' VTable offset = 36
     BYREF RECT _                             ' /* [in] */ LPCRECT pRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsPageDirty ( _                     ' VTable offset = 40
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Apply ( _                           ' VTable offset = 44
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Help ( _                            ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszHelpDir
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TranslateAccelerator ( _            ' VTable offset = 52
     BYREF tagMSG _                           ' /* [in] */ MSG *pMsg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPropertyPage_INTERFACE_DEFINED__ */


' ########################################################################################
' IPropertyPage2 interface
' IID = 01E44665-24AC-101B-84ED-08002B2EC713
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPropertyPage2_INTERFACE_DEFINED)
    %IPropertyPage2_INTERFACE_DEFINED = 1

$IID_IPropertyPage2 = GUID$("{01E44665-24AC-101B-84ED-08002B2EC713}")

INTERFACE IPropertyPage2 $IID_IPropertyPage2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetPageSite ( _                     ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IPropertyPageSite *pPageSite
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Activate ( _                        ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ HWND hWndParent
   , BYREF RECT _                             ' /* [in] */ LPCRECT pRect
   , BYVAL LONG _                             ' /* [in] */ BOOL bModal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Deactivate ( _                      ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPageInfo ( _                     ' VTable offset = 24
     BYREF PROPPAGEINFO _                     ' /* [out] */ PROPPAGEINFO *pPageInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetObjects ( _                      ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ ULONG cObjects
   , BYREF IUnknown _                         ' /* [in] */ IUnknown **ppUnk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Show ( _                            ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ UINT nCmdShow
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Move ( _                            ' VTable offset = 36
     BYREF RECT _                             ' /* [in] */ LPCRECT pRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsPageDirty ( _                     ' VTable offset = 40
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Apply ( _                           ' VTable offset = 44
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Help ( _                            ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pszHelpDir
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TranslateAccelerator ( _            ' VTable offset = 52
     BYREF tagMSG _                           ' /* [in] */ MSG *pMsg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EditProperty ( _                    ' VTable offset = 56
     BYVAL LONG _                             ' /* [in] */ DISPID dispID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPropertyPage2_INTERFACE_DEFINED__ */


' ########################################################################################
' IPropertyPageSite interface
' IID = B196B28C-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#if not %DEF(%IPropertyPageSite_INTERFACE_DEFINED)
    %IPropertyPageSite_INTERFACE_DEFINED = 1

' PROPPAGESTATUS enum
%PROPPAGESTATUS_DIRTY    = &H1
%PROPPAGESTATUS_VALIDATE = &H2
%PROPPAGESTATUS_CLEAN    = &H4

$IID_IPropertyPageSite = GUID$("{B196B28C-BAB4-101A-B69C-00AA00341D07}")

INTERFACE IPropertyPageSite $IID_IPropertyPageSite

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnStatusChange ( _                  ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetLocaleID ( _                     ' VTable offset = 16
     BYREF DWORD _                            ' /* [out] */ LCID *pLocaleID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPageContainer ( _                ' VTable offset = 20
     BYREF IUnknown _                         ' /* [out] */ IUnknown **ppUnk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TranslateAccelerator ( _            ' VTable offset = 24
     BYREF tagMSG _                           ' /* [in] */ MSG *pMsg
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPropertyPageSite_INTERFACE_DEFINED__ */


' ########################################################################################
' IPropertyNotifySink interface
' IID = 9BFBBC02-EFF1-101A-84ED-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPropertyNotifySink_INTERFACE_DEFINED)
    %IPropertyNotifySink_INTERFACE_DEFINED = 1

$IID_IPropertyNotifySink = GUID$("{9BFBBC02-EFF1-101A-84ED-00AA00341D07}")

INTERFACE IPropertyNotifySink $IID_IPropertyNotifySink

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnChanged ( _                       ' VTable offset = 12
     BYVAL LONG _                             ' /* [in] */ DISPID dispID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnRequestEdit ( _                   ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ DISPID dispID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPropertyNotifySink_INTERFACE_DEFINED__ */


' ########################################################################################
' ISpecifyPropertyPages interface
' IID = B196B28B-BAB4-101A-B69C-00AA00341D07
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISpecifyPropertyPages_INTERFACE_DEFINED)
    %ISpecifyPropertyPages_INTERFACE_DEFINED = 1

TYPE CAUUID
   cElems AS DWORD      ' ULONG cElems
   pElems AS GUID PTR   ' /* [size_is] */ GUID *pElems
END TYPE

$IID_ISpecifyPropertyPages = GUID$("{B196B28B-BAB4-101A-B69C-00AA00341D07}")

INTERFACE ISpecifyPropertyPages $IID_ISpecifyPropertyPages

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetPages ( _                        ' VTable offset = 12
     BYREF CAUUID _                           ' /* [out] */ CAUUID *pPages
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISpecifyPropertyPages_INTERFACE_DEFINED__ */


' ########################################################################################
' IPersistMemory interface
' IID = BD1AE5E0-A6AE-11CE-BD37-504200C10000
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IPersistMemory_INTERFACE_DEFINED)
    %IPersistMemory_INTERFACE_DEFINED = 1

$IID_IPersistMemory = GUID$("{BD1AE5E0-A6AE-11CE-BD37-504200C10000}")

INTERFACE IPersistMemory $IID_IPersistMemory

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
      BYREF GUID _                            ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsDirty ( _                         ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                            ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ LPVOID pMem
   , BYVAL DWORD _                            ' /* [in] */ ULONG cbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Save ( _                            ' VTable offset = 24
     BYVAL DWORD _                            ' /* [out] */ LPVOID pMem
   , BYVAL LONG _                             ' /* [in] */ BOOL fClearDirty
   , BYVAL DWORD _                            ' /* [in] */ ULONG cbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSizeMax ( _                      ' VTable offset = 28
     BYREF DWORD _                            ' /* [out] */ ULONG *pCbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InitNew ( _                         ' VTable offset = 32
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersistMemory_INTERFACE_DEFINED__ */


' ########################################################################################
' IPersistStreamInit interface
' IID = 7FD52380-4E07-101B-AE2D-08002B2EC713
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IPersistStreamInit_INTERFACE_DEFINED)
    %IPersistStreamInit_INTERFACE_DEFINED = 1

$IID_IPersistStreamInit = GUID$("{7FD52380-4E07-101B-AE2D-08002B2EC713}")

INTERFACE IPersistStreamInit $IID_IPersistStreamInit

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
     BYREF GUID _                             ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsDirty ( _                         ' VTable offset = 16
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                            ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IStream * pStm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Save ( _                            ' VTable offset = 24
     BYVAL IUnknown _                         ' /* [in] */ IStream * pStm
   , BYVAL LONG _                             ' */ [in] */ BOOL fClearDirty
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSizeMax ( _                      ' VTable offset = 28
     BYREF QUAD _                             ' /* [out] */  ULARGE_INTEGER * pcbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InitNew ( _                         ' VTable offset = 32
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersistStreamInit_INTERFACE_DEFINED__ */


' ########################################################################################
' IPersistPropertyBag interface
' IID = 37D84F60-42CB-11CE-8135-00AA004BB851
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IPersistPropertyBag_INTERFACE_DEFINED)
    %IPersistPropertyBag_INTERFACE_DEFINED = 1

$IID_IPersistPropertyBag = GUID$("{37D84F60-42CB-11CE-8135-00AA004BB851}")

INTERFACE IPersistPropertyBag $IID_IPersistPropertyBag

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
      BYREF GUID _                            ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InitNew ( _                         ' VTable offset = 14
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                            ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ IPropertyBag *pPropBag
   , BYVAL IUnknown _                         ' /* [in] */ IErrorLog *pErrorLog
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersistPropertyBag_INTERFACE_DEFINED__ */


' ########################################################################################
' ISimpleFrameSite interface
' IID = 742B0E01-14E6-101B-914E-00AA00300CAB
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISimpleFrameSite_INTERFACE_DEFINED)
    %ISimpleFrameSite_INTERFACE_DEFINED = 1

$IID_ISimpleFrameSite = GUID$("{742B0E01-14E6-101B-914E-00AA00300CAB}")

INTERFACE ISimpleFrameSite $IID_ISimpleFrameSite

   INHERIT IUnknown

   ' =====================================================================================
   METHOD PreMessageFilter ( _                ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ HWND hWnd
   , BYVAL DWORD _                            ' /* [in] */ UINT msg,
   , BYVAL DWORD _                            ' /* [in] */ WPARAM wp
   , BYVAL LONG _                             ' /* [in] */ LPARAM lp
   , BYREF LONG _                             ' /* [out] */ LRESULT *plResult
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwCookie
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PostMessageFilter ( _               ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ HWND hWnd
   , BYVAL DWORD _                            ' /* [in] */ UINT msg,
   , BYVAL DWORD _                            ' /* [in] */ WPARAM wp
   , BYVAL LONG _                             ' /* [in] */ LPARAM lp
   , BYREF LONG _                             ' /* [out] */ LRESULT *plResult
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwCookie
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISimpleFrameSite_INTERFACE_DEFINED__ */


' ########################################################################################
' IFont interface
' IID = BEF6E002-A874-101A-8BBA-00AA00300CAB
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IFont_INTERFACE_DEFINED)
    %IFont_INTERFACE_DEFINED = 1

$IID_IFont = GUID$("{BEF6E002-A874-101A-8BBA-00AA00300CAB}")

INTERFACE IFont $IID_IFont

   INHERIT IUnknown

   ' =====================================================================================
   METHOD get_Name ( _                        ' VTable offset = 12
     BYREF STRING _                           ' /* [out] */ BSTR* pname
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_Name ( _                        ' VTable offset = 16
     BYVAL STRING _                           ' /* [in] */ BSTR pname
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Size ( _                        ' VTable offset = 20
     BYREF CUR _                              ' /* [out] */ CY* psize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_Size ( _                        ' VTable offset = 24
     BYVAL CUR _                              ' /* [in] */ CY psize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Bold ( _                        ' VTable offset = 28
     BYREF LONG _                             ' /* [out] */ BOOL* pbold
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_Bold ( _                        ' VTable offset = 32
     BYVAL LONG _                             ' /* [in] */ BOOL pbold
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Italic ( _                      ' VTable offset = 36
     BYREF LONG _                             ' /* [out] */ BOOL* pitalic
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_Italic ( _                      ' VTable offset = 40
     BYVAL LONG _                             ' /* [in] */ BOOL pitalic
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Underline ( _                   ' VTable offset = 44
     BYREF LONG _                             ' /* [out] */ BOOL* pitalic
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_Underline ( _                   ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ BOOL pitalic
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Strikethrough ( _               ' VTable offset = 52
     BYREF LONG _                             ' /* [out] */ BOOL* pstrikethrough
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_Strikethrough ( _               ' VTable offset = 56
     BYVAL LONG _                             ' /* [in] */ BOOL pstrikethrough
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Weight ( _                      ' VTable offset = 60
     BYREF INTEGER _                          ' /* [out] */ short* weight
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_Weight ( _                      ' VTable offset = 64
     BYVAL INTEGER _                          ' /* [in] */ short weight
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Charset ( _                     ' VTable offset = 68
     BYREF INTEGER _                          ' /* [out] */ short* pcharset
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_Charset ( _                     ' VTable offset = 72
     BYVAL INTEGER _                          ' /* [in] */ short pcharset
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_hFont ( _                       ' VTable offset = 76
     BYREF DWORD _                            ' /* [out] */ HFONT* phfont
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 80
     BYREF IFont _                            ' /* [out] */ IFont** ppfont
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsEqual ( _                         ' VTable offset = 84
     BYREF IFont _                            ' /* [in] */ IFont* pFontOther
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetRatio ( _                        ' VTable offset = 88
     BYVAL LONG _                             ' /* [in] */ long cyLogical
   , BYVAL LONG _                             ' /* [in] */ long cyHimetric
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD QueryTextMetrics ( _                ' VTable offset = 92
     BYREF TEXTMETRIC _                       ' /* [in] */ TEXTMETRICOLE* ptm
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddRefHfont ( _                     ' VTable offset = 96
     BYVAL DWORD _                            ' /* [in] */ HFONT hfont
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseHfont ( _                    ' VTable offset = 100
     BYVAL DWORD _                            ' /* [in] */ HFONT hfont
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHdc ( _                          ' VTable offset = 104
     BYVAL DWORD _                            ' /* [in] */ HDC hdc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFont_INTERFACE_DEFINED__ */


' ########################################################################################
' IPicture interface
' IID = 7BF80980-BF32-101A-8BBB-00AA00300CAB
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPicture_INTERFACE_DEFINED)
    %IPicture_INTERFACE_DEFINED = 1

' PICTUREATTRIBUTES enum
%PICTURE_SCALABLE    = &H1
%PICTURE_TRANSPARENT = &H2

$IID_IPicture = GUID$("{7BF80980-BF32-101A-8BBB-00AA00300CAB}")

INTERFACE IPicture $IID_IPicture

   INHERIT IUnknown

   ' =====================================================================================
   METHOD get_Handle ( _                      ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ OLE_HANDLE* phandle
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_hPal ( _                        ' VTable offset = 16
     BYREF DWORD _                            ' /* [out] */ OLE_HANDLE* phpal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Type ( _                        ' VTable offset = 20
     BYREF INTEGER _                          ' /* [out] */ short* ptype
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Width ( _                       ' VTable offset = 24
     BYREF LONG _                             ' /* [out] */ OLE_XSIZE_HIMETRIC* pwidth
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Height ( _                      ' VTable offset = 28
     BYREF LONG _                             ' /* [out] */ OLE_YSIZE_HIMETRIC* pheight
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Render ( _                          ' VTable offset = 32
     BYVAL LONG _                             ' /* [in] */ HDC hdc
   , BYVAL LONG _                             ' /* [in] */ long x
   , BYVAL LONG _                             ' /* [in] */ long y
   , BYVAL LONG _                             ' /* [in] */ long cx
   , BYVAL LONG _                             ' /* [in] */ long cy
   , BYVAL LONG _                             ' /* [in] */ OLE_XPOS_HIMETRIC xSrc,
   , BYVAL LONG _                             ' /* [in] */ OLE_YPOS_HIMETRIC ySrc
   , BYVAL LONG _                             ' /* [in] */ OLE_XSIZE_HIMETRIC cxSrc,
   , BYVAL LONG _                             ' /* [in] */ OLE_YSIZE_HIMETRIC cySrc
   , BYREF RECT _                             ' /* [in] */ LPCRECT prcWBounds
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD set_hPal ( _                        ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ OLE_HANDLE hpal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_CurDC ( _                       ' VTable offset = 40
     BYREF DWORD _                            ' /* [out] */ HDC* phdcOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SelectPicture ( _                   ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ HDC hdcIn
   , BYREF DWORD _                            ' /* [in] */ HDC* phdcOut
   , BYREF DWORD _                            ' /* [in] */ OLE_HANDLE* phbmpOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_KeepOriginalFormat ( _   ' VTable offset = 48
     BYREF LONG _                             ' /* [in] */ BOOL* pfkeep
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_KeepOriginalFormat ( _   ' VTable offset = 52
     BYVAL LONG _                             ' /* [in] */ BOOL pfkeep
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PictureChanged ( _                  ' VTable offset = 56
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SaveAsFile ( _                      ' VTable offset = 60
     BYVAL IUnknown _                         ' /* [in] */ IStream * pstream
   , BYVAL LONG _                             ' /* [in] */ BOOL fSaveMemCopy
   , BYREF LONG _                             ' /* [out] */ LONG* pcbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Attributes ( _                  ' VTable offset = 64
     BYREF DWORD _                            ' /* [out] */ DWORD* pdwAttr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPicture_INTERFACE_DEFINED__ */


' ########################################################################################
' IPicture2 interface
' IID = F5185DD8-2012-4B0B-AAD9-F052C6BD482B
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPicture2_INTERFACE_DEFINED)
    %IPicture_INTERFACE_DEFINED = 1

$IID_IPicture2 = GUID$("{F5185DD8-2012-4B0B-AAD9-F052C6BD482B}")

INTERFACE IPicture2 $IID_IPicture2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD get_Handle ( _                      ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ HHANDLE* phandle
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_hPal ( _                        ' VTable offset = 16
     BYREF DWORD _                            ' /* [out] */ HHANDLE* phpal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Type ( _                        ' VTable offset = 20
     BYREF INTEGER _                          ' /* [out] */ short* ptype
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Width ( _                       ' VTable offset = 24
     BYREF LONG _                             ' /* [out] */ OLE_XSIZE_HIMETRIC* pwidth
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Height ( _                      ' VTable offset = 28
     BYREF LONG _                             ' /* [out] */ OLE_YSIZE_HIMETRIC* pheight
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Render ( _                          ' VTable offset = 32
     BYVAL LONG _                             ' /* [in] */ HDC hdc
   , BYVAL LONG _                             ' /* [in] */ long x
   , BYVAL LONG _                             ' /* [in] */ long y
   , BYVAL LONG _                             ' /* [in] */ long cx
   , BYVAL LONG _                             ' /* [in] */ long cy
   , BYVAL LONG _                             ' /* [in] */ OLE_XPOS_HIMETRIC xSrc,
   , BYVAL LONG _                             ' /* [in] */ OLE_YPOS_HIMETRIC ySrc
   , BYVAL LONG _                             ' /* [in] */ OLE_XSIZE_HIMETRIC cxSrc,
   , BYVAL LONG _                             ' /* [in] */ OLE_YSIZE_HIMETRIC cySrc
   , BYREF RECT _                             ' /* [in] */ LPCRECT prcWBounds
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD set_hPal ( _                        ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ HHANDLE hpal
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_CurDC ( _                       ' VTable offset = 40
     BYREF DWORD _                            ' /* [out] */ HDC* phdcOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SelectPicture ( _                   ' VTable offset = 44
     BYVAL DWORD _                            ' /* [in] */ HDC hdcIn
   , BYREF DWORD _                            ' /* [in] */ HDC* phdcOut
   , BYREF DWORD _                            ' /* [in] */ HHANDLE* phbmpOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_KeepOriginalFormat ( _   ' VTable offset = 48
     BYREF LONG _                             ' /* [in] */ BOOL* pfkeep
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD put_KeepOriginalFormat ( _   ' VTable offset = 52
     BYVAL LONG _                             ' /* [in] */ BOOL pfkeep
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PictureChanged ( _                  ' VTable offset = 56
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SaveAsFile ( _                      ' VTable offset = 60
     BYVAL IUnknown _                         ' /* [in] */ IStream * pstream
   , BYVAL LONG _                             ' /* [in] */ BOOL fSaveMemCopy
   , BYREF LONG _                             ' /* [out] */ LONG* pcbSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD get_Attributes ( _                  ' VTable offset = 64
     BYREF DWORD _                            ' /* [out] */ DWORD* pdwAttr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPicture2_INTERFACE_DEFINED__ */

' ########################################################################################
' IFontEventsDisp interface
' IID = 4EF6100A-AF88-11D0-9846-00C04FC29993
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IFontEventsDisp_INTERFACE_DEFINED)
    %IFontEventsDisp_INTERFACE_DEFINED = 1

$IID_IFontEventsDisp = GUID$("{4EF6100A-AF88-11D0-9846-00C04FC29993}")

INTERFACE IFontEventsDisp $IID_IFontEventsDisp

   INHERIT IDispatch

END INTERFACE

#ENDIF   ' /* __IFontEventsDisp_INTERFACE_DEFINED__ */


' ########################################################################################
' IFontDisp interface
' IID = BEF6E003-A874-101A-8BBA-00AA00300CAB
' Inherited interface = IDispatch
' Note: This interface is a wrapper on top of the IFont interface. You can use it
' calling the Invoke method or casting it to an object variable declared as StdFont.
' The definition for the StdFont interface is included in olectl.inc.
' ########################################################################################

#IF NOT %DEF(%IFontDisp_INTERFACE_DEFINED)
    %IFontDisp_INTERFACE_DEFINED = 1

$IID_IFontDisp = GUID$("{BEF6E003-A874-101A-8BBA-00AA00300CAB}")

INTERFACE IFontDisp $IID_IFontDisp

   INHERIT IDispatch

END INTERFACE

#ENDIF   ' /* __IFontDisp_INTERFACE_DEFINED__ */


' ########################################################################################
' IPictureDisp interface
' IID = 7BF80981-BF32-101A-8BBB-00AA00300CAB
' Inherited interface = IDispatch
' Note: This interface is a wrapper on top of the IPicture interface. You can use it
' calling the Invoke method or casting it to an object variable declared as StdPicture.
' The definition for the StdPicture interface is included in olectl.inc.
' ########################################################################################

#IF NOT %DEF(%IPictureDisp_INTERFACE_DEFINED)
    %IPictureDisp_INTERFACE_DEFINED = 1

$IID_IPictureDisp = GUID$("{7BF80981-BF32-101A-8BBB-00AA00300CAB}")

INTERFACE IPictureDisp $IID_IPictureDisp

   INHERIT IDispatch

END INTERFACE

#ENDIF    ' /* __IPictureDisp_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleInPlaceObjectWindowless interface
' IID = 1C2056CC-5EF4-101B-8BC8-00AA003E3B29
' Inherited interface = IOleInPlaceObject
' ########################################################################################

#IF NOT %DEF(%IOleInPlaceObjectWindowless_INTERFACE_DEFINED)
    %IOleInPlaceObjectWindowless_INTERFACE_DEFINED = 1

$IID_IOleInPlaceObjectWindowless = GUID$("{1C2056CC-5EF4-101B-8BC8-00AA003E3B29}")

INTERFACE IOleInPlaceObjectWindowless $IID_IOleInPlaceObjectWindowless

   INHERIT IUnknown

   ' =====================================================================================
   ' IOleInPlaceObject methods
   ' =====================================================================================
   METHOD GetWindow ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [in] */ HWND * phwnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ContextSensitiveHelp ( _     ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fEnterMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InPlaceDeactivate ( _               ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UIDeactivate ( _                    ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetObjectRects ( _                  ' VTable offset = 28
     BYREF RECT _                             ' /* [in] */ LPCRECT lprcPosRect
   , BYREF RECT _                             ' /* [in] */ LPCRECT lprcClipRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReactivateAndUndo ( _               ' VTable offset = 32
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

   ' =====================================================================================
   ' IOleInPlaceObjectWindowless methods
   ' =====================================================================================
   METHOD OnWindowMessage ( _                 ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ UINT msg
   , BYVAL DWORD _                            ' /* [in] */ WPARAM wParam
   , BYVAL LONG _                             ' /* [in] */ LPARAM lParam
   , BYREF LONG _                             ' /* [out] */ LRESULT *plResult
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDropTarget ( _                   ' VTable offset = 40
     BYREF IUnknown _                         ' /* [out] */ IDropTarget **ppDropTarget
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleInPlaceObjectWindowless_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleInPlaceSiteEx interface
' IID = 9C2CAD80-3424-11CF-B670-00AA004CD6D8
' Inherited interface = IOleInPlaceSite
' ########################################################################################

#IF NOT %DEF(%IOleInPlaceSiteEx_INTERFACE_DEFINED)
    %IOleInPlaceSiteEx_INTERFACE_DEFINED = 1

' ACTIVATEFLAGS enum
%ACTIVATE_WINDOWLESS = 1

$IID_IOleInPlaceSiteEx = GUID$("{9C2CAD80-3424-11CF-B670-00AA004CD6D8}")

INTERFACE IOleInPlaceSiteEx $IID_IOleInPlaceSiteEx

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetWindow ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [in] */ HWND * phwnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ContextSensitiveHelp ( _     ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fEnterMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CanInPlaceActivate ( _              ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceActivate ( _               ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnUIActivate ( _                    ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetWindowContext ( _                ' VTable offset = 32
     BYREF IUnknown _                         ' /* [out] */ IOleInPlaceFrame **ppFrame
   , BYREF IUnknown _                         ' /* [out] */ IOleInPlaceUIWindow **ppDoc
   , BYREF RECT _                             ' /* [out] */ LPRECT lprcPosRect
   , BYREF RECT _                             ' /* [out] */ LPRECT lprcClipRect
   , BYREF OLEINPLACEFRAMEINFO _              ' /* [out][in] */ LPOLEINPLACEFRAMEINFO lpFrameInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Scroll ( _                          ' VTable offset = 36
     BYREF APISIZE _                          ' /* [in] */ SIZE scrollExtant
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnUIDeactivate ( _                  ' VTable offset = 40
     BYVAL LONG _                             ' /* [in] */ BOOL fUndoable
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceDeactivate ( _             ' VTable offset = 44
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DiscardUndoState ( _                ' VTable offset = 48
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeactivateAndUndo ( _               ' VTable offset = 52
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnPosRectChange ( _                 ' VTable offset = 56
     BYREF RECT _                             ' /* [in] */ LPCRECT lprcPosRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceActivateEx ( _             ' VTable offset = 60
     BYREF LONG _                             ' /* [out] */ BOOL *pfNoRedraw
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceDeactivateEx ( _    ' VTable offset = 64
     BYVAL LONG _                             ' /* [in] */ BOOL fNoRedraw
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RequestUIActivate ( _               ' VTable offset = 68
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleInPlaceSiteEx_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleInPlaceSiteWindowless interface
' IID = 922EADA0-3424-11CF-B670-00AA004CD6D8
' Inherited interface = IOleInPlaceSiteEx
' ########################################################################################

#IF NOT %DEF(%IOleInPlaceSiteWindowless_INTERFACE_DEFINED)
    %IOleInPlaceSiteWindowless_INTERFACE_DEFINED = 1

' OLEDCFLAGS enum
%OLEDC_NODRAW     = &H1
%OLEDC_PAINTBKGND = &H2
%OLEDC_OFFSCREEN  = &H4

$IID_IOleInPlaceSiteWindowless = GUID$("{922EADA0-3424-11CF-B670-00AA004CD6D8}")

INTERFACE IOleInPlaceSiteWindowless $IID_IOleInPlaceSiteWindowless

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetWindow ( _                       ' VTable offset = 12
     BYREF DWORD _                            ' /* [in] */ HWND * phwnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ContextSensitiveHelp ( _     ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ BOOL fEnterMode
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CanInPlaceActivate ( _              ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceActivate ( _               ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnUIActivate ( _                    ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetWindowContext ( _                ' VTable offset = 32
     BYREF IUnknown _                         ' /* [out] */ IOleInPlaceFrame **ppFrame
   , BYREF IUnknown _                         ' /* [out] */ IOleInPlaceUIWindow **ppDoc
   , BYREF RECT _                             ' /* [out] */ LPRECT lprcPosRect
   , BYREF RECT _                             ' /* [out] */ LPRECT lprcClipRect
   , BYREF OLEINPLACEFRAMEINFO _              ' /* [out][in] */ LPOLEINPLACEFRAMEINFO lpFrameInfo
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Scroll ( _                          ' VTable offset = 36
     BYREF APISIZE _                          ' /* [in] */ SIZE scrollExtant
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnUIDeactivate ( _                  ' VTable offset = 40
     BYVAL LONG _                             ' /* [in] */ BOOL fUndoable
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceDeactivate ( _             ' VTable offset = 44
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DiscardUndoState ( _                ' VTable offset = 48
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeactivateAndUndo ( _               ' VTable offset = 52
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnPosRectChange ( _                 ' VTable offset = 56
     BYREF RECT _                             ' /* [in] */ LPCRECT lprcPosRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceActivateEx ( _             ' VTable offset = 60
     BYREF LONG _                             ' /* [out] */ BOOL *pfNoRedraw
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInPlaceDeactivateEx ( _    ' VTable offset = 64
     BYVAL LONG _                             ' /* [in] */ BOOL fNoRedraw
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RequestUIActivate ( _               ' VTable offset = 68
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CanWindowlessActivate ( _    ' VTable offset = 72
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCapture ( _                      ' VTable offset = 76
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetCapture ( _                      ' VTable offset = 80
     BYVAL LONG _                             ' /* [in] */ BOOL fCapture
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFocus ( _                        ' VTable offset = 84
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetFocus ( _                        ' VTable offset = 88
     BYVAL LONG _                             ' /* [in] */ BOOL fFocus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDC ( _                           ' VTable offset = 92
     BYREF RECT _                             ' /* [in] */ LPCRECT pRect
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfFlags
   , BYREF DWORD _                            ' /* [out] */ HDC *phDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseDC ( _                       ' VTable offset = 96
     BYVAL DWORD _                            ' /* [in] */ HDC hDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InvalidateRect ( _                  ' VTable offset = 100
     BYREF RECT _                             ' /* [in] */ LPCRECT pRect
   , BYVAL LONG _                             ' /* [in] */ BOOL fErase
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InvalidateRgn ( _                   ' VTable offset = 104
     BYVAL DWORD _                            ' /* [in] */ HRGN hRGN
   , BYVAL LONG _                             ' /* [in] */ BOOL fErase
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ScrollRect ( _                      ' VTable offset = 108
     BYVAL LONG _                             ' /* [in] */ INT dx
   , BYVAL LONG _                             ' /* [in] */ INT dy
   , BYREF RECT _                             ' /* [in] */ LPCRECT pRectScroll
   , BYREF RECT _                             ' /* [in] */ LPCRECT pRectClip
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AdjustRect ( _                      ' VTable offset = 112
     BYREF RECT _                             ' /* [out][in] */ LPRECT prc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnDefWindowMessage ( _              ' VTable offset = 114
     BYVAL DWORD _                            ' /* [in] */ UINT msg
   , BYVAL DWORD _                            ' /* [in] */ WPARAM wParam
   , BYVAL LONG _                             ' /* [in] */ LPARAM lParam
   , BYREF LONG _                             ' /* [out] */ LRESULT *plResult
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleInPlaceSiteWindowless_INTERFACE_DEFINED__ */


' ########################################################################################
' IViewObjectEx interface
' IID = 3AF24292-0C96-11CE-A0CF-00AA00600AB8
' Inherited interface = IViewObject2
' ########################################################################################

#IF NOT %DEF(%IViewObjectEx_INTERFACE_DEFINED)
    %IViewObjectEx_INTERFACE_DEFINED = 1

' VIEWSTATUS enum
%VIEWSTATUS_OPAQUE              = 1
%VIEWSTATUS_SOLIDBKGND          = 2
%VIEWSTATUS_DVASPECTOPAQUE      = 4
%VIEWSTATUS_DVASPECTTRANSPARENT = 8
%VIEWSTATUS_SURFACE             = 16
%VIEWSTATUS_3DSURFACE           = 32

' HITRESULT enum
%HITRESULT_OUTSIDE     = 0
%HITRESULT_TRANSPARENT = 1
%HITRESULT_CLOSE       = 2
%HITRESULT_HIT         = 3

' DVASPECT2 enum
%DVASPECT_OPAQUE      = 16
%DVASPECT_TRANSPARENT = 32

TYPE DVEXTENTINFO
   cb            AS DWORD   ' ULONG cb
   dwExtentMode  AS DWORD   ' DWORD dwExtentMode
   sizelProposed AS SIZEL   ' SIZEL sizelProposed
END TYPE

' DVEXTENTMODE enum
%DVEXTENT_CONTENT  = 0
%DVEXTENT_INTEGRAL = 1

' DVASPECTINFOFLAG enum
%DVASPECTINFOFLAG_CANOPTIMIZE = 1

TYPE DVASPECTINFO
   cb      AS DWORD   ' ULONG cb
   dwFlags AS DWORD   ' DWORD dwFlags
END TYPE

$IID_IViewObjectEx = GUID$("{3AF24292-0C96-11CE-A0CF-00AA00600AB8}")

INTERFACE IViewObjectEx $IID_IViewObjectEx

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Draw ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYVAL DWORD _                            ' /* [in] */ HDC hicTargetDev
   , BYVAL DWORD _                            ' /* [in] */ HDC hdcDraw
   , BYREF RECTL _                            ' /* [in] */ LPCRECTL lprcBounds
   , BYREF RECTL _                            ' /* [in] */ LPCRECTL lprcWBounds
   , BYVAL DWORD _                            ' /* [in] */ BOOL ( STDMETHODCALLTYPE *pfnContinue )(ULONG_PTR dwContinue)
   , BYVAL DWORD _                            ' /* [in] */ ULONG_PTR dwContinue
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetColorSet ( _                     ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYVAL DWORD _                            ' /* [in] */ HDC hicTargetDev
   , BYREF LOGPALETTE _                       ' /* [out] */ LOGPALETTE **ppColorSet
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Freeze ( _                          ' VTable offset = 20
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYVAL DWORD _                            ' /* [in] */ void *pvAspect
   , BYREF DWORD _                            ' /* [out] */ DWORD *pdwFreeze
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unfreeze ( _                        ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ DWORD dwFreeze
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetAdvise ( _                       ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ DWORD aspect
   , BYVAL DWORD _                            ' /* [in] */ DWORD advf
   , BYVAL IUnknown _                         ' /* [in] */ IAdviseSink *pAdvSink
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAdvise ( _                       ' VTable offset = 32
     BYREF DWORD _                            ' /* [out] */ DWORD *pAspects
   , BYREF DWORD _                            ' /* [out] */ DWORD *pAdvf
   , BYREF IUnknown _                         ' /* [out] */ IAdviseSink **ppAdvSink
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetExtent ( _                       ' VTable offset = 36
     BYVAL DWORD _                            ' /* [in] */ DWORD dwDrawAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   , BYREF DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYREF SIZEL _                            ' /* [out] */ LPSIZEL lpsizel
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetRect ( _                         ' VTable offset = 40
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYREF RECTL _                            ' /* [out] */ LPRECTL pRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetViewStatus ( _                   ' VTable offset = 44
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD QueryHitPoint ( _                   ' VTable offset = 48
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYREF RECT _                             ' /* [in] */ LPCRECT pRectBounds
   , BYREF POINTAPI _                         ' /* [in] */ POINT ptlLoc
   , BYVAL LONG _                             ' /* [in] */ LONG lCloseHint
   , BYREF DWORD _                            ' /* [out] */ DWORD *pHitResult
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD QueryHitRect ( _                    ' VTable offset = 52
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYREF RECT _                             ' /* [in] */ LPCRECT pRectBounds
   , BYREF RECT _                             ' /* [in] */ LPCRECT pRectLoc
   , BYVAL LONG _                             ' /* [in] */ LONG lCloseHint
   , BYREF DWORD _                            ' /* [out] */ DWORD *pHitResult
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetNaturalExtent ( _                ' VTable offset = 56
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYVAL DVTARGETDEVICE _                   ' /* [in] */ DVTARGETDEVICE *ptd
   , BYREF RECT _                             ' /* [in] */ LPCRECT pRectBounds
   , BYVAL DWORD _                            ' /* [in] */ HDC hicTargetDev
   , BYREF DVEXTENTINFO _                     ' /* [in] */ DVEXTENTINFO *pExtentInfo
   , BYREF SIZEL _                            ' /* [out] */ LPSIZEL pSizel
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IViewObjectEx_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleUndoUnit interface
' IID = 894AD3B0-EF97-11CE-9BC9-00AA00608E01
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleUndoUnit_INTERFACE_DEFINED)
    %IOleUndoUnit_INTERFACE_DEFINED = 1

$IID_IOleUndoUnit = GUID$("{894AD3B0-EF97-11CE-9BC9-00AA00608E01}")

INTERFACE IOleUndoUnit $IID_IOleUndoUnit

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Do ( _                              ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IOleUndoManager *pUndoManager
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDescription ( _                  ' VTable offset = 16
     BYREF STRING _                           ' /* [out] */ BSTR *pBstr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetUnitType ( _                     ' VTable offset = 20
     BYREF GUID _                             ' /* [out] */ CLSID *pClsid
   , BYREF LONG _                             ' /* [out] */ LONG *plID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnNextAdd ( _                       ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleUndoUnit_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleParentUndoUnit interface
' IID = A1FAF330-EF97-11CE-9BC9-00AA00608E01
' Inherited interface = IOleUndoUnit
' ########################################################################################

#IF NOT %DEF(%IOleParentUndoUnit_INTERFACE_DEFINED)
    %IOleParentUndoUnit_INTERFACE_DEFINED = 1

$IID_IOleParentUndoUnit = GUID$("{A1FAF330-EF97-11CE-9BC9-00AA00608E01}")

INTERFACE IOleParentUndoUnit $IID_IOleParentUndoUnit

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Do ( _                              ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IOleUndoManager *pUndoManager
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDescription ( _                  ' VTable offset = 16
     BYREF STRING _                           ' /* [out] */ BSTR *pBstr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetUnitType ( _                     ' VTable offset = 20
     BYREF GUID _                             ' /* [out] */ CLSID *pClsid
   , BYREF LONG _                             ' /* [out] */ LONG *plID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnNextAdd ( _                       ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Open ( _                            ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IOleParentUndoUnit *pPUU
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Close ( _                           ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ IOleParentUndoUnit *pPUU
   , BYVAL LONG _                             ' /* [in] */ BOOL fCommit
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Add ( _                             ' VTable offset = 36
     BYVAL IUnknown _                         ' /* [in] */ IOleUndoUnit *pUU
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FindUnit ( _                        ' VTable offset = 40
     BYVAL IUnknown _                         ' /* [in] */ IOleUndoUnit *pUU
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetParentState ( _                  ' VTable offset = 44
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwState
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleParentUndoUnit_INTERFACE_DEFINED__ */


' ########################################################################################
' IEnumOleUndoUnits interface
' IID = B3E7C340-EF97-11CE-9BC9-00AA00608E01
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumOleUndoUnits_INTERFACE_DEFINED)
    %IEnumOleUndoUnits_INTERFACE_DEFINED = 1

$IID_IEnumOleUndoUnits = GUID$("{B3E7C340-EF97-11CE-9BC9-00AA00608E01}")

INTERFACE IEnumOleUndoUnits $IID_IEnumOleUndoUnits

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cElt
   , BYREF IUnknown _                         ' /* [out] */ IOleUndoUnit **rgElt
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcEltFetched
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                            ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG cElt
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                           ' VTable offset = 20
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                           ' VTable offset = 24
     BYREF IEnumOleUndoUnits _                ' /* [out] */ IEnumOleUndoUnits **ppEnum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumOleUndoUnits_INTERFACE_DEFINED__ */


' ########################################################################################
' IOleUndoManager interface
' IID = D001F200-EF97-11CE-9BC9-00AA00608E01
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOleUndoManager_INTERFACE_DEFINED)
    %IOleUndoManager_INTERFACE_DEFINED = 1

$IID_IOleUndoManager = GUID$("{D001F200-EF97-11CE-9BC9-00AA00608E01}")

INTERFACE IOleUndoManager $IID_IOleUndoManager

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Open ( _                            ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IOleParentUndoUnit *pPUU
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Close ( _                           ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ IOleParentUndoUnit *pPUU
   , BYVAL LONG _                             ' /* [in] */ BOOL fCommit
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OpAdd ( _                           ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IOleUndoUnit *pPUU
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetOpenParentState ( _              ' VTable offset = 24
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwState
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DiscardFrom ( _                     ' VTable offset = 28
     BYVAL IUnknown _                         ' /* [in] */ IOleUndoUnit *pUU
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UndoTo ( _                          ' VTable offset = 32
     BYVAL IUnknown _                         ' /* [in] */ IOleUndoUnit *pUU
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RedoTo ( _                          ' VTable offset = 36
     BYVAL IUnknown _                         ' /* [in] */ IOleUndoUnit *pUU
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumUndoable ( _                    ' VTable offset = 40
     BYREF IUnknown _                         ' /* [out] */ IEnumOleUndoUnits **ppEnum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumRedoable ( _                    ' VTable offset = 44
     BYREF IUnknown _                         ' /* [out] */ IEnumOleUndoUnits **ppEnum
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetLastUndoDescription ( _   ' VTable offset = 48
     BYREF STRING _                           ' /* [out] */ BSTR *pBstr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetLastRedoDescription ( _   ' VTable offset = 52
     BYREF STRING _                           ' /* [out] */ BSTR *pBstr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Enable ( _                          ' VTable offset = 56
     BYVAL LONG _                             ' /* [in] */ BOOL fEnable
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOleUndoManager_INTERFACE_DEFINED__ */


' ########################################################################################
' IPointerInactive interface
' IID = 55980BA0-35AA-11CF-B671-00AA004CD6D8
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPointerInactive_INTERFACE_DEFINED)
    %IPointerInactive_INTERFACE_DEFINED = 1

' POINTERINACTIVE enum
%POINTERINACTIVE_ACTIVATEONENTRY   = 1
%POINTERINACTIVE_DEACTIVATEONLEAVE = 2
%POINTERINACTIVE_ACTIVATEONDRAG    = 4

$IID_IPointerInactive = GUID$("{55980BA0-35AA-11CF-B671-00AA004CD6D8}")

INTERFACE IPointerInactive $IID_IPointerInactive

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetActivationPolicy ( _             ' VTable offset = 12
     BYREF DWORD _                            ' /* [out] */ DWORD *pdwPolicy
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInactiveMouseMove ( _             ' VTable offset = 16
     BYREF RECT _                             ' /* [in] */ LPCRECT pRectBounds
   , BYVAL LONG _                             ' /* [in] */ LONG x
   , BYVAL LONG _                             ' /* [in] */ LONG y
   , BYVAL DWORD _                            ' /* [in] */ DWORD grfKeyState
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnInactiveSetCursor ( _             ' VTable offset = 20
     BYREF RECT _                             ' /* [in] */ LPCRECT pRectBounds
   , BYVAL LONG _                             ' /* [in] */ LONG x
   , BYVAL LONG _                             ' /* [in] */ LONG y
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwMouseMsg
   , BYVAL LONG _                             ' /* [in] */ BOOL fSetAlways
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPointerInactive_INTERFACE_DEFINED__ */


' ########################################################################################
' IObjectWithSite interface
' IID = FC4801A3-2BA9-11CF-A229-00AA003D7352
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IObjectWithSite_INTERFACE_DEFINED)
    %IObjectWithSite_INTERFACE_DEFINED = 1

$IID_IObjectWithSite = GUID$("{FC4801A3-2BA9-11CF-A229-00AA003D7352}")

INTERFACE IObjectWithSite $IID_IObjectWithSite

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetSite ( _                         ' VTable offset = 12
     BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnkSite
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSite ( _                         ' VTable offset = 16
     BYREF GUID _                             ' /* [in] */ REFIID riid
   , BYREF IUnknown _                         ' /* [out] */ void **ppvSite
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IObjectWithSite_INTERFACE_DEFINED__ */


' ########################################################################################
' IPerPropertyBrowsing interface
' IID = 376BD3AA-3845-101B-84ED-08002B2EC713
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPerPropertyBrowsing_INTERFACE_DEFINED)
    %IPerPropertyBrowsing_INTERFACE_DEFINED = 1

TYPE CALPOLESTR
   cElems AS DWORD       ' ULONG cElems
   pElems AS WORD PTR    ' /* [size_is] */ LPOLESTR *pElems
END TYPE

TYPE CADWORD
   cElems AS DWORD       ' ULONG cElems
   pElems AS DWORD PTR   ' /* [size_is] */ DWORD *pElems
END TYPE

$IID_IPerPropertyBrowsing = GUID$("{376BD3AA-3845-101B-84ED-08002B2EC713}")

INTERFACE IPerPropertyBrowsing $IID_IPerPropertyBrowsing

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetDisplayString ( _                ' VTable offset = 12
     BYVAL LONG _                             ' /* [in] */ DISPID dispID
   , BYREF STRING _                           ' /* [out] */ BSTR *pBstr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD MapPropertyToPage ( _               ' VTable offset = 16
     BYVAL LONG _                             ' /* [in] */ DISPID dispID
   , BYREF GUID _                             ' /* [out] */ CLSID *pClsid
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPredefinedStrings ( _     ' VTable offset = 20
     BYVAL LONG _                             ' /* [in] */ DISPID dispID
   , BYREF CALPOLESTR _                       ' /* [out] */ CALPOLESTR *pCaStringsOut
   , BYREF CADWORD _                          ' /* [out] */ CADWORD *pCaCookiesOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPredefinedValue ( _              ' VTable offset = 24
     BYVAL LONG _                             ' /* [in] */ DISPID dispID
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwCookie
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pVarOut
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPerPropertyBrowsing_INTERFACE_DEFINED__ */


' ########################################################################################
' IPropertyBag2 interface
' IID = 22F55882-280B-11d0-A8A9-00A0C90C2004
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPropertyBag2_INTERFACE_DEFINED)
    %IPropertyBag2_INTERFACE_DEFINED = 1

' PROPBAG2_TYPE enum
%PROPBAG2_TYPE_UNDEFINED = 0
%PROPBAG2_TYPE_DATA      = 1
%PROPBAG2_TYPE_URL       = 2
%PROPBAG2_TYPE_OBJECT    = 3
%PROPBAG2_TYPE_STREAM    = 4
%PROPBAG2_TYPE_STORAGE   = 5
%PROPBAG2_TYPE_MONIKER   = 6

TYPE PROPBAG2
   dwType   AS DWORD       ' DWORD dwType
   vt       AS WORD        ' VARTYPE vt
   cfType   AS WORD        ' CLIPFORMAT cfType
   dwHint   AS DWORD       ' DWORD dwHint
   pstrName AS WORD PTR    ' LPOLESTR pstrName
   clsid    AS GUID        ' CLSID clsid
END TYPE

$IID_IPropertyBag2 = GUID$("{22F55882-280B-11D0-A8A9-00A0C90C2004}")

INTERFACE IPropertyBag2 $IID_IPropertyBag2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Read ( _                            ' VTable offset = 12
     BYVAL DWORD _                            ' /* [in] */ ULONG cProperties
   , BYREF PROPBAG2 _                         ' /* [in] */ PROPBAG2 *pPropBag
   , BYVAL IUnknown _                         ' /* [in] */ IErrorLog *pErrLog
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pvarValue
   , BYREF LONG _                             ' /* [out] */ HRESULT *phrError
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Write ( _                           ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ ULONG cProperties
   , BYREF PROPBAG2 _                         ' /* [in] */ PROPBAG2 *pPropBag
   , BYREF VARIANT _                          ' /* [out] */ VARIANT *pvarValue
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CountProperties ( _                 ' VTable offset = 20
     BYREF DWORD _                            ' /* [out] */ ULONG *pcProperties
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPropertyInfo ( _                 ' VTable offset = 24
     BYVAL DWORD _                            ' /* [in] */ ULONG iProperty
   , BYVAL DWORD _                            ' /* [in] */ ULONG cProperties
   , BYREF PROPBAG2 _                         ' /* [in] */ PROPBAG2 *pPropBag
   , BYREF DWORD _                            ' /* [out] */ ULONG *pcProperties
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD LoadObject ( _                      ' VTable offset = 28
     BYVAL DWORD _                            ' /* [in] */ LPCOLESTR pstrName
   , BYVAL DWORD _                            ' /* [in] */ DWORD dwHint
   , BYVAL IUnknown _                         ' /* [in] */ IUnknown *pUnkObject
   , BYVAL IUnknown _                         ' /* [in] */ IErrorLog *pErrLog
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPropertyBag2_INTERFACE_DEFINED__ */


' ########################################################################################
' IPersistPropertyBag2 interface
' IID = 37D84F60-42CB-11CE-8135-00AA004BB851
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IPersistPropertyBag2_INTERFACE_DEFINED)
    %IPersistPropertyBag2_INTERFACE_DEFINED = 1

$IID_IPersistPropertyBag2 = GUID$("{22F55881-280B-11D0-A8A9-00A0C90C2004}")

INTERFACE IPersistPropertyBag2 $IID_IPersistPropertyBag2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                      ' VTable offset = 12
      BYREF GUID _                            ' /* [out] */ CLSID * pClassID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InitNew ( _                         ' VTable offset = 14
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                            ' VTable offset = 16
     BYVAL IUnknown _                         ' /* [in] */ IPropertyBag *pPropBag
   , BYVAL IUnknown _                         ' /* [in] */ IErrorLog *pErrorLog
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Save ( _                            ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IPropertyBag2 *pPropBag
   , BYVAL LONG _                             ' /* [in] */ BOOL fClearDirty
   , BYVAL LONG _                             ' /* [in] */ BOOL fSaveAllProperties
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsDirty ( _                         ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersistPropertyBag2_INTERFACE_DEFINED__ */


' ########################################################################################
' IAdviseSinkEx interface
' IID = 0000010f-0000-0000-C000-000000000046
' Inherited interface = IAdviseSink
' ########################################################################################

#IF NOT %DEF(%IAdviseSinkEx_INTERFACE_DEFINED)
    %IAdviseSinkEx_INTERFACE_DEFINED = 1

$IID_IAdviseSinkEx = GUID$("{3AF24290-0C96-11CE-A0CF-00AA00600AB8}")

INTERFACE IAdviseSinkEx $IID_IAdviseSinkEx

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnDataChange ( _                    ' VTable offset = 12
     BYREF FORMATETC _                        ' /* [in] */ FORMATETC *pFormatetc
   , BYREF STGMEDIUM _                        ' /* [in] */ STGMEDIUM *pStgmed
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnViewChange ( _                    ' VTable offset = 16
     BYVAL DWORD _                            ' /* [in] */ DWORD dwAspect
   , BYVAL LONG _                             ' /* [in] */ LONG lindex
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnRename ( _                        ' VTable offset = 20
     BYVAL IUnknown _                         ' /* [in] */ IMoniker *pmk
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnSave ( _                          ' VTable offset = 24
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnClose ( _                         ' VTable offset = 28
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD OnViewStatusChange ( _              ' VTable offset = 32
     BYVAL DWORD _                            ' /* [in] */ DWORD dwViewStatus
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAdviseSinkEx_INTERFACE_DEFINED__ */


' ########################################################################################
' IQuickActivate interface
' IID = CF51ED10-62FE-11CF-BF86-00A0C9034836
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IQuickActivate_INTERFACE_DEFINED)
    %IQuickActivate_INTERFACE_DEFINED = 1

' QACONTAINERFLAGS enum
%QACONTAINER_SHOWHATCHING      = &H1
%QACONTAINER_SHOWGRABHANDLES   = &H2
%QACONTAINER_USERMODE          = &H4
%QACONTAINER_DISPLAYASDEFAULT  = &H8
%QACONTAINER_UIDEAD            = &H10
%QACONTAINER_AUTOCLIP          = &H20
%QACONTAINER_MESSAGEREFLECT    = &H40
%QACONTAINER_SUPPORTSMNEMONICS = &H80

TYPE QACONTAINER
   cbSize              AS DWORD       ' ULONG cbSize
   pClientSite         AS DWORD PTR   ' IOleClientSite *pClientSite
   pAdviseSink         AS DWORD PTR   ' IAdviseSinkEx *pAdviseSink
   pPropertyNotifySink AS DWORD PTR   ' IPropertyNotifySink *pPropertyNotifySink
   pUnkEventSink       AS DWORD PTR   ' IUnknown *pUnkEventSink
   dwAmbientFlags      AS DWORD       ' DWORD dwAmbientFlags
   colorFore           AS DWORD       ' OLE_COLOR colorFore
   colorBack           AS DWORD       ' OLE_COLOR colorBack
   pFont               AS DWORD PTR   ' IFont *pFont
   pUndoMgr            AS DWORD PTR   ' IOleUndoManager *pUndoMgr
   dwAppearance        AS DWORD       ' DWORD dwAppearance
   lcid                AS DWORD       ' LONG lcid
   hpal                AS DWORD       ' HPALETTE hpal
   pBindHost           AS DWORD PTR   ' IBindHost *pBindHost
   pOleControlSite     AS DWORD PTR   ' IOleControlSite *pOleControlSite
   pServiceProvider    AS DWORD PTR   ' IServiceProvider *pServiceProvider
END TYPE

TYPE QACONTROL
   cbSize                    AS DWORD   ' ULONG cbSize
   dwMiscStatus              AS DWORD   ' DWORD dwMiscStatus
   dwViewStatus              AS DWORD   ' DWORD dwViewStatus
   dwEventCookie             AS DWORD   ' DWORD dwEventCookie
   dwPropNotifyCookie        AS DWORD   ' DWORD dwPropNotifyCookie
   dwPointerActivationPolicy AS DWORD   ' DWORD dwPointerActivationPolicy
END TYPE

$IID_IQuickActivate = GUID$("{CF51ED10-62FE-11CF-BF86-00A0C9034836}")

INTERFACE IQuickActivate $IID_IQuickActivate

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QuickActivate ( _                   ' VTable offset = 12
     BYREF QACONTAINER _                      ' /* [in] */ QACONTAINER *pQaContainer
   , BYREF QACONTROL _                        ' /* [out][in] */ QACONTROL *pQaControl
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetContentExtent ( _                ' VTable offset = 16
     BYREF SIZEL _                            ' /* [in] */ LPSIZEL pSizel
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetContentExtent ( _                ' VTable offset = 20
     BYREF SIZEL _                            ' /* [out] */ LPSIZEL pSizel
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IQuickActivate_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%OCIDL_INC)

'/*==========================================================================;
' *
' *  Copyright (C) Microsoft Corporation.  All Rights Reserved.
' *
' *  File:       ddraw.h
' *  Content:    DirectDraw include file
' *
' ***************************************************************************/

#IF NOT %DEF(%DDRAW_INC)
    %DDRAW_INC = 1

'/*
' * If you wish an application built against the newest version of DirectDraw
' * to run against an older DirectDraw run time then define DIRECTDRAW_VERSION
' * to be the earlies version of DirectDraw you wish to run against. For,
' * example if you wish an application to run against a DX 3 runtime define
' * DIRECTDRAW_VERSION to be 0x0300.
' */
'#ifndef   DIRECTDRAW_VERSION
'#define   DIRECTDRAW_VERSION 0x0700
'#endif /* DIRECTDRAW_VERSION */

%DIRECTDRAW_VERSION = &H0700

%CO_E_NOTINITIALIZED = &H800401F0&

%FACDD = &H876

'FUNCTION MAKE_DDHRESULT (BYVAL code AS DWORD) AS DWORD
'   LOCAL sev AS DWORD
'   LOCAL fac AS DWORD
'   sev = 1
'   fac = &H878
'   SHIFT LEFT sev, 31
'   SHIFT LEFT fac, 16
'   FUNCTION = (sev OR fac OR code)
'END FUNCTION

%MAKE_DDHRESULT                       = &H88760000&   ' (-2005532672)



%FOURCC_DXT1 = &H827611204
%FOURCC_DXT2 = &H844388420
%FOURCC_DXT3 = &H861165636
%FOURCC_DXT4 = &H877942852
%FOURCC_DXT5 = &H894720068

'/*
' * GUIDS used by DirectDraw objects
' */

$CLSID_DirectDraw            = GUID$("{D7B70EE0-4340-11CF-B063-0020AFC2CD35}")
$CLSID_DirectDraw7           = GUID$("{3C305196-50DB-11D3-9CFE-00C04FD930C5}")
$CLSID_DirectDrawClipper     = GUID$("{593817A0-7DB3-11CF-A2DE-00AA00b93356}")
$IID_IDirectDraw             = GUID$("{6C14DB80-A733-11CE-A521-0020AF0BE560}")
$IID_IDirectDraw2            = GUID$("{B3A6F3E0-2B43-11CF-A2DE-00AA00B93356}")
$IID_IDirectDraw4            = GUID$("{9C59509A-39BD-11D1-8C4A-00C04FD930C5}")
$IID_IDirectDraw7            = GUID$("{15E65EC0-3B9C-11D2-B92F-00609797EA5B}")
$IID_IDirectDrawSurface      = GUID$("{6C14DB81-A733-11CE-A521-0020AF0BE560}")
$IID_IDirectDrawSurface2     = GUID$("{57805885-6EEC-11CF-9441-A82303C10E27}")
$IID_IDirectDrawSurface3     = GUID$("{DA044E00-69B2-11D0-A1D5-00AA00B8DFBB}")
$IID_IDirectDrawSurface4     = GUID$("{0B2B8630-AD35-11D0-8EA6-00609797EA5B}")
$IID_IDirectDrawSurface7     = GUID$("{06675A80-3B9B-11D2-B92F-00609797EA5B}")
$IID_IDirectDrawPalette      = GUID$("{6C14DB84-A733-11CE-A521-0020AF0BE560}")
$IID_IDirectDrawClipper      = GUID$("{6C14DB85-A733-11CE-A521-0020AF0BE560}")
$IID_IDirectDrawColorControl = GUID$("{4B9F0EE0-0D7E-11D0-9B06-00A0C903A3B8}")
$IID_IDirectDrawGammaControl = GUID$("{69C11C3E-B46B-11D1-AD7A-00C04FC29B4E}")


'/*
' * API's
' */

' ========================================================================================
' This function is superseded by the DirectDrawEnumerateEx function.
' The DirectDrawEnumerate function enumerates the primary DirectDraw display device and a
' non-display device, such as a 3-D accelerator that has no 2-D capabilities, if one is
' installed. The NULL entry always identifies the primary display device shared with GDI.
' ========================================================================================

DECLARE FUNCTION DirectDrawEnumerate LIB "DDRAW.DLL" ALIAS "DirectDrawEnumerateA" ( _
   BYVAL DWORD _                            ' /* [in] */ LPDDENUMCALLBACKA lpCallback
 , BYVAL DWORD _                            ' /* [in] */ LPVOID lpContext
 ) AS LONG                                  ' HRESULT

DECLARE FUNCTION DirectDrawEnumerateW LIB "DDRAW.DLL" ALIAS "DirectDrawEnumerateW" ( _
   BYVAL DWORD _                            ' /* [in] */ LPDDENUMCALLBACKW lpCallback
 , BYVAL DWORD _                            ' /* [in] */ LPVOID lpContext
 ) AS LONG                                  ' HRESULT

' ========================================================================================
' This function enumerates all DirectDraw devices installed on the system. The NULL entry
' always identifies the primary display device shared with GDI.
' ========================================================================================

DECLARE FUNCTION DirectDrawEnumerateEx LIB "DDRAW.DLL" ALIAS "DirectDrawEnumerateExA" ( _
   BYVAL DWORD _                            ' /* [in] */ LPDDENUMCALLBACKEXA lpCallback
 , BYVAL DWORD _                            ' /* [in] */ LPVOID lpContext
 , BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
 ) AS LONG                                  ' HRESULT

DECLARE FUNCTION DirectDrawEnumerateExW LIB "DDRAW.DLL" ALIAS "DirectDrawEnumerateExW" ( _
   BYVAL DWORD _                            ' /* [in] */ LPDDENUMCALLBACKEXW lpCallback
 , BYVAL DWORD _                            ' /* [in] */ LPVOID lpContext
 , BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
 ) AS LONG                                  ' HRESULT

' ========================================================================================
' The DirectDrawCreate function creates an instance of a DirectDraw object. A DirectDraw
' object created with this function does not support the newest set of Direct3D interfaces.
' To create a DirectDraw object capable of exposing the new features of Direct3D, use the
' DirectDrawCreateEx function.
' ========================================================================================

DECLARE FUNCTION DirectDrawCreate LIB "DDRAW.DLL" ALIAS "DirectDrawCreate" ( _
   BYREF GUID _                             ' /* [in] */ GUID FAR *lpGUID
 , BYREF IUnknown _                         ' /* [out] */ LPDIRECTDRAW FAR *lplpDD
 , BYVAL IUnknown _                         ' /* [in] */ IUnknown FAR *pUnkOuter
 ) AS LONG                                  ' HRESULT

' ========================================================================================
' The DirectDrawCreateEx function creates an instance of a DirectDraw object that supports
' the newest set of Direct3D interfaces. To use the new features of Direct3D in DirectX
' 7.0, create a DirectDraw object with this function.
' Note: This parameter must be set to IID_IDirectDraw7. This function fails and returns
' DDERR_INVALIDPARAMS if any other interface is specified.
' ========================================================================================

DECLARE FUNCTION DirectDrawCreateEx LIB "DDRAW.DLL" ALIAS "DirectDrawCreateEx" ( _
   BYREF GUID _                             ' /* [in] */ GUID FAR *lpGUID
 , BYREF IUnknown _                         ' /* [out] */ LPDIRECTDRAW FAR *lplpDD
 , BYREF GUID _                             ' /* [in] */ REFIID  iid
 , BYVAL IUnknown _                         ' /* [in] */ IUnknown FAR *pUnkOuter
 ) AS LONG                                  ' HRESULT

' ========================================================================================
' The DirectDrawCreateClipper function creates an instance of a DirectDrawClipper object
' not associated with a DirectDraw object.
' ========================================================================================

DECLARE FUNCTION DirectDrawCreateClipper LIB "DDRAW.DLL" ALIAS "DirectDrawCreateClipper" ( _
   BYVAL DWORD _                            ' /* [in] */ DWORD dwFlags
 , BYREF IUnknown _                         ' /* [out] */ LPDIRECTDRAWCLIPPER FAR *lplpDDClipper
 , BYVAL IUnknown _                         ' /* [in] */ IUnknown FAR *pUnkOuter
 ) AS LONG                                  ' HRESULT


' Callback function prototypes

'FUNCTION DDENUMCALLBACKA ( _
'   BYREF lpGUID AS GUID _                               ' /* [in] */ GUID FAR *lpGUID
' , BYREF lpDriverDescription AS ASCIIZ _                ' /* [in] */ LPSTR lpDriverDescription
' , BYREF lpDriverName AS ASCIIZ _                       ' /* [in] */ LPSTR lpDriverName
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' ) AS LONG

'FUNCTION DDENUMCALLBACKW ( _
'   BYREF lpGUID AS GUID _                               ' /* [in] */ GUID FAR *lpGUID
' , BYVAL lpDriverDescription AS DWORD _                 ' /* [in] */ LPWSTR lpDriverDescription
' , BYVAL lpDriverName AS DWORD _                        ' /* [in] */ LPWSTR lpDriverName
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' ) AS LONG

'FUNCTION DDENUMCALLBACKEXA ( _
'   BYREF lpGUID AS GUID _                               ' /* [in] */ GUID FAR *lpGUID
' , BYREF lpDriverDescription AS ASCIIZ _                ' /* [in] */ LPSTR lpDriverDescription
' , BYREF lpDriverName AS ASCIIZ _                       ' /* [in] */ LPSTR lpDriverName
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' , BYVAL hm AS DWORD _                                  ' /* [in] */ HMONITOR hm
' ) AS LONG

'FUNCTION DDENUMCALLBACKEXW ( _
'   BYREF lpGUID AS GUID _                               ' /* [in] */ GUID FAR *lpGUID
' , BYVAL lpDriverDescription AS DWORD _                 ' /* [in] */ LPWSTR lpDriverDescription
' , BYVAL lpDriverName AS DWORD _                        ' /* [in] */ LPWSTR lpDriverName
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' , BYVAL hm AS DWORD _                                  ' /* [in] */ HMONITOR hm
' ) AS LONG

'FUNCTION DIRECTDRAWENUMERATEEXA ( _
'   BYVAL lpCallback AS DWORD _                          ' /* [in] */ LPDDENUMCALLBACKEXA lpCallback
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' , BYVAL dwFlags AS DWORD _                             ' /* [in] */ DWORD dwFlags
' ) AS LONG

'FUNCTION DIRECTDRAWENUMERATEEXW ( _
'   BYVAL lpCallback AS DWORD _                          ' /* [in] */ LPDDENUMCALLBACKEXW lpCallback
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' , BYVAL dwFlags AS DWORD _                             ' /* [in] */ DWORD dwFlags
' ) AS LONG


'/*
' * Flags for DirectDrawEnumerateEx
' * DirectDrawEnumerateEx supercedes DirectDrawEnumerate. You must use GetProcAddress to
' * obtain a function pointer (of type LPDIRECTDRAWENUMERATEEX) to DirectDrawEnumerateEx.
' * By default, only the primary display device is enumerated.
' * DirectDrawEnumerate is equivalent to DirectDrawEnumerate(,,DDENUM_NONDISPLAYDEVICES)
' */

'/*
' * This flag causes enumeration of any GDI display devices which are part of
' * the Windows Desktop
' */
%DDENUM_ATTACHEDSECONDARYDEVICES     = &H00000001???

'/*
' * This flag causes enumeration of any GDI display devices which are not
' * part of the Windows Desktop
' */
%DDENUM_DETACHEDSECONDARYDEVICES     = &H00000002???

'/*
' * This flag causes enumeration of non-display devices
' */
%DDENUM_NONDISPLAYDEVICES            = &H00000004???


$REGSTR_KEY_DDHW_DESCRIPTION     = "Description"
$REGSTR_KEY_DDHW_DRIVERNAME      = "DriverName"
$REGSTR_PATH_DDHW                = "Hardware\DirectDrawDrivers"

%DDCREATE_HARDWAREONLY           = &H00000001???
%DDCREATE_EMULATIONONLY          = &H00000002???


' Callback function prototypes

'FUNCTION DDENUMMODESCALLBACK ( _
'   BYVAL lpDDSurfaceDesc AS DWORD _                     ' /* [in] */ LPDDSURFACEDESC lpDDSurfaceDesc
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' ) AS LONG

'FUNCTION DDENUMMODESCALLBACK2 ( _
'   BYVAL lpDDSurfaceDesc AS DWORD _                     ' /* [in] */ LPDDSURFACEDESC2 lpDDSurfaceDesc
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' ) AS LONG

'FUNCTION DDENUMSURFACESCALLBACK ( _
'   BYVAL lpDDSurface AS DWORD _                         ' /* [in] */ LPDIRECTDRAWSURFACE lpDDSurface
' , BYREF lpDDSurfaceDesc AS DDSURFACEDESC _             ' /* [in] */ LPDDSURFACEDESC lpDDSurfaceDesc
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' ) AS LONG

'FUNCTION DDENUMSURFACESCALLBACK2 ( _
'   BYVAL lpDDSurface AS DWORD _                         ' /* [in] */ LPDIRECTDRAWSURFACE4 lpDDSurface
' , BYREF lpDDSurfaceDesc AS DDSURFACEDESC _             ' /* [in] */ LPDDSURFACEDESC2 lpDDSurfaceDesc
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' ) AS LONG

'FUNCTION DDENUMSURFACESCALLBACK7 ( _
'   BYVAL lpDDSurface AS DWORD _                         ' /* [in] */ LPDIRECTDRAWSURFACE7 lpDDSurface
' , BYREF lpDDSurfaceDesc AS DDSURFACEDESC _             ' /* [in] */ LPDDSURFACEDESC2 lpDDSurfaceDesc
' , BYVAL lpContext AS DWORD _                           ' /* [in] */ LPVOID lpContext
' ) AS LONG


'/*
' * Generic pixel format with 8-bit RGB and alpha components
' */

TYPE DDARGB
   blue  AS BYTE                       ' BYTE blue
   green AS BYTE                       ' BYTE green
   red   AS BYTE                       ' BYTE red
   alpha AS BYTE                       ' BYTE alpha
END TYPE

'/*
' * This version of the structure remains for backwards source compatibility.
' * The DDARGB structure is the one that should be used for all DirectDraw APIs.
' */

TYPE DDRGBA
   red   AS BYTE                       ' BYTE red
   green AS BYTE                       ' BYTE green
   blue  AS BYTE                       ' BYTE blue
   alpha AS BYTE                       ' BYTE alpha
END TYPE

'/*
' * DDCOLORKEY
' */

TYPE DDCOLORKEY
   dwColorSpaceLowValue  AS DWORD     ' // low boundary of color space that is to
                                      ' // be treated as Color Key, inclusive
   dwColorSpaceHighValue AS DWORD     ' // high boundary of color space that is
                                      ' // to be treated as Color Key, inclusive
END TYPE

'/*
' * DDBLTFX
' * Used to pass override information to the DIRECTDRAWSURFACE callback Blt.
' */

UNION DDBLTFX_UNION_1
   dwZDestConst     AS DWORD           ' // Constant to use as Z buffer for dest
   lpDDSZBufferDest AS DWORD           ' // Surface to use as Z buffer for dest
END UNION

UNION DDBLTFX_UNION_2
   dwZSrcConst     AS DWORD            ' // Constant to use as Z buffer for src
   lpDDSZBufferSrc AS DWORD            ' // Surface to use as Z buffer for src
END UNION

UNION DDBLTFX_UNION_3
   dwAlphaDestConst AS DWORD           ' // Constant to use as Alpha Channel
   lpDDSAlphaDest   AS DWORD           ' // Surface to use as Alpha Channel
END UNION

UNION DDBLTFX_UNION_4
   dwAlphaSrcConst AS DWORD            ' // Constant to use as Alpha Channel
   lpDDSAlphaSrc   AS DWORD            ' // Surface to use as Alpha Channel
END UNION

UNION DDBLTFX_UNION_5
   dwFillColor  AS DWORD               ' // color in RGB or Palettized
   dwFillDepth  AS DWORD               ' // depth value for z-buffer
   dwFillPixel  AS DWORD               ' // pixel value for RGBA or RGBZ
   lpDDSPattern AS DWORD               ' // Surface to use as pattern
END UNION

TYPE DDBLTFX
   dwSize                   AS DWORD        ' // size of structure
   dwDDFX                   AS DWORD        ' // FX operations
   dwROP                    AS DWORD        ' // Win32 raster operations
   dwDDROP                  AS DWORD        ' // Raster operations new for DirectDraw
   dwRotationAngle          AS DWORD        ' // Rotation angle for blt
   dwZBufferOpCode          AS DWORD        ' // ZBuffer compares
   dwZBufferLow             AS DWORD        ' // Low limit of Z buffer
   dwZBufferHigh            AS DWORD        ' // High limit of Z buffer
   dwZBufferBaseDest        AS DWORD        ' // Destination base value
   dwZDestConstBitDepth     AS DWORD        ' // Bit depth used to specify Z constant for destination
   DDBLTFX_UNION_1
   dwZSrcConstBitDepth      AS DWORD        ' // Bit depth used to specify Z constant for source
   DDBLTFX_UNION_2
   dwAlphaEdgeBlendBitDepth AS DWORD        ' // Bit depth used to specify constant for alpha edge blend
   dwAlphaEdgeBlend         AS DWORD        ' // Alpha for edge blending
   dwReserved               AS DWORD
   dwAlphaDestConstBitDepth AS DWORD        ' // Bit depth used to specify alpha constant for destination
   DDBLTFX_UNION_3
   dwAlphaSrcConstBitDepth  AS DWORD        ' // Bit depth used to specify alpha constant for source
   DDBLTFX_UNION_4
   DDBLTFX_UNION_5
   ddckDestColorkey         AS DDCOLORKEY   ' // DestColorkey override
   ddckSrcColorkey          AS DDCOLORKEY   ' // SrcColorkey override
END TYPE


'/*
' * DDSCAPS
' */

TYPE DDSCAPS
   dwCaps AS DWORD                     ' // capabilities of surface wanted
END TYPE


'/*
' * DDOSCAPS
' */

TYPE DDOSCAPS
   dwCaps AS DWORD                     ' // capabilities of surface wanted
END TYPE


'/*
' * This structure is used internally by DirectDraw.
' */

UNION DDSCAPSEX_UNION
   dwCaps4       AS DWORD
   dwVolumeDepth AS DWORD
END UNION

TYPE DDSCAPSEX
   dwCaps2 AS DWORD
   dwCaps3 AS DWORD
   DDSCAPSEX_UNION
END TYPE


'/*
' * DDSCAPS2
' */

UNION DDSCAPS2_UNION
   dwCaps4       AS DWORD
   dwVolumeDepth AS DWORD
END UNION

TYPE DDSCAPS2
   dwCaps  AS DWORD        ' // capabilities of surface wanted
   dwCaps2 AS DWORD
   dwCaps3 AS DWORD
   DDSCAPS2_UNION
END TYPE

'/*
' * DDCAPS
' */
%DD_ROP_SPACE           = (256/32)     ' // space required to store ROP array

'/*
' * NOTE: Our choosen structure number scheme is to append a single digit to
' * the end of the structure giving the version that structure is associated
' * with.
' */

'/*
' * This structure represents the DDCAPS structure released in DirectDraw 1.0.  It is used internally
' * by DirectDraw to interpret caps passed into ddraw by drivers written prior to the release of DirectDraw 2.0.
' * New applications should use the DDCAPS structure defined below.
' */

TYPE DDCAPS_DX1
   dwSize                         AS DWORD       ' // size of the DDDRIVERCAPS structure
   dwCaps                         AS DWORD       ' // driver specific capabilities
   dwCaps2                        AS DWORD       ' // more driver specific capabilites
   dwCKeyCaps                     AS DWORD       ' // color key capabilities of the surface
   dwFXCaps                       AS DWORD       ' // driver specific stretching and effects capabilites
   dwFXAlphaCaps                  AS DWORD       ' // alpha driver specific capabilities
   dwPalCaps                      AS DWORD       ' // palette capabilities
   dwSVCaps                       AS DWORD       ' // stereo vision capabilities
   dwAlphaBltConstBitDepths       AS DWORD       ' // DDBD_2,4,8
   dwAlphaBltPixelBitDepths       AS DWORD       ' // DDBD_1,2,4,8
   dwAlphaBltSurfaceBitDepths     AS DWORD       ' // DDBD_1,2,4,8
   dwAlphaOverlayConstBitDepths   AS DWORD       ' // DDBD_2,4,8
   dwAlphaOverlayPixelBitDepths   AS DWORD       ' // DDBD_1,2,4,8
   dwAlphaOverlaySurfaceBitDepths AS DWORD       ' // DDBD_1,2,4,8
   dwZBufferBitDepths             AS DWORD       ' // DDBD_8,16,24,32
   dwVidMemTotal                  AS DWORD       ' // total amount of video memory
   dwVidMemFree                   AS DWORD       ' // amount of free video memory
   dwMaxVisibleOverlays           AS DWORD       ' // maximum number of visible overlays
   dwCurrVisibleOverlays          AS DWORD       ' // current number of visible overlays
   dwNumFourCCCodes               AS DWORD       ' // number of four cc codes
   dwAlignBoundarySrc             AS DWORD       ' // source rectangle alignment
   dwAlignSizeSrc                 AS DWORD       ' // source rectangle byte size
   dwAlignBoundaryDest            AS DWORD       ' // dest rectangle alignment
   dwAlignSizeDest                AS DWORD       ' // dest rectangle byte size
   dwAlignStrideAlign             AS DWORD       ' // stride alignment
   dwRops(%DD_ROP_SPACE-1)        AS DWORD       ' // ROPS supported
   tddsCaps                       AS DDSCAPS     ' // DDSCAPS structure has all the general capabilities
   dwMinOverlayStretch            AS DWORD       ' // minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxOverlayStretch            AS DWORD       ' // maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinLiveVideoStretch          AS DWORD       ' // OBSOLETE! This field remains for compatability reasons only
   dwMaxLiveVideoStretch          AS DWORD       ' // OBSOLETE! This field remains for compatability reasons only
   dwMinHwCodecStretch            AS DWORD       ' // OBSOLETE! This field remains for compatability reasons only
   dwMaxHwCodecStretch            AS DWORD       ' // OBSOLETE! This field remains for compatability reasons only
   dwReserved1                    AS DWORD       ' // reserved
   dwReserved2                    AS DWORD       ' // reserved
   dwReserved3                    AS DWORD       ' // reserved
END TYPE


'/*
' * This structure is the DDCAPS structure as it was in version 2 and 3 of Direct X.
' * It is present for back compatability.
' */

TYPE DDCAPS_DX3
   dwSize                         AS DWORD    ' // size of the DDDRIVERCAPS structure
   dwCaps                         AS DWORD    ' // driver specific capabilities
   dwCaps2                        AS DWORD    ' // more driver specific capabilites
   dwCKeyCaps                     AS DWORD    ' // color key capabilities of the surface
   dwFXCaps                       AS DWORD    ' // driver specific stretching and effects capabilites
   dwFXAlphaCaps                  AS DWORD    ' // alpha driver specific capabilities
   dwPalCaps                      AS DWORD    ' // palette capabilities
   dwSVCaps                       AS DWORD    ' // stereo vision capabilities
   dwAlphaBltConstBitDepths       AS DWORD    ' // DDBD_2,4,8
   dwAlphaBltPixelBitDepths       AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaBltSurfaceBitDepths     AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlayConstBitDepths   AS DWORD    ' // DDBD_2,4,8
   dwAlphaOverlayPixelBitDepths   AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlaySurfaceBitDepths AS DWORD    ' // DDBD_1,2,4,8
   dwZBufferBitDepths             AS DWORD    ' // DDBD_8,16,24,32
   dwVidMemTotal                  AS DWORD    ' // total amount of video memory
   dwVidMemFree                   AS DWORD    ' // amount of free video memory
   dwMaxVisibleOverlays           AS DWORD    ' // maximum number of visible overlays
   dwCurrVisibleOverlays          AS DWORD    ' // current number of visible overlays
   dwNumFourCCCodes               AS DWORD    ' // number of four cc codes
   dwAlignBoundarySrc             AS DWORD    ' // source rectangle alignment
   dwAlignSizeSrc                 AS DWORD    ' // source rectangle byte size
   dwAlignBoundaryDest            AS DWORD    ' // dest rectangle alignment
   dwAlignSizeDest                AS DWORD    ' // dest rectangle byte size
   dwAlignStrideAlign             AS DWORD    ' // stride alignment
   dwRops(%DD_ROP_SPACE-1)        AS DWORD    ' // ROPS supported
   tddsCaps                       AS DDSCAPS  ' // DDSCAPS structure has all the general capabilities
   dwMinOverlayStretch            AS DWORD    ' // minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxOverlayStretch            AS DWORD    ' // maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinLiveVideoStretch          AS DWORD    ' // minimum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxLiveVideoStretch          AS DWORD    ' // maximum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinHwCodecStretch            AS DWORD    ' // minimum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxHwCodecStretch            AS DWORD    ' // maximum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwReserved1                    AS DWORD    ' // reserved
   dwReserved2                    AS DWORD    ' // reserved
   dwReserved3                    AS DWORD    ' // reserved
   dwSVBCaps                      AS DWORD    ' // driver specific capabilities for System->Vmem blts
   dwSVBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->Vmem blts
   dwSVBFXCaps                    AS DWORD    ' // driver FX capabilities for System->Vmem blts
   dwSVBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->Vmem blts
   dwVSBCaps                      AS DWORD    ' // driver specific capabilities for Vmem->System blts
   dwVSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for Vmem->System blts
   dwVSBFXCaps                    AS DWORD    ' // driver FX capabilities for Vmem->System blts
   dwVSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for Vmem->System blts
   dwSSBCaps                      AS DWORD    ' // driver specific capabilities for System->System blts
   dwSSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->System blts
   dwSSBFXCaps                    AS DWORD    ' // driver FX capabilities for System->System blts
   dwSSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->System blts
   dwReserved4                    AS DWORD    ' // reserved
   dwReserved5                    AS DWORD    ' // reserved
   dwReserved6                    AS DWORD    ' // reserved
END TYPE


'/*
' * This structure is the DDCAPS structure as it was in version 5 of Direct X.
' * It is present for back compatability.
' */

TYPE DDCAPS_DX5
   dwSize                         AS DWORD    ' // size of the DDDRIVERCAPS structure
   dwCaps                         AS DWORD    ' // driver specific capabilities
   dwCaps2                        AS DWORD    ' // more driver specific capabilites
   dwCKeyCaps                     AS DWORD    ' // color key capabilities of the surface
   dwFXCaps                       AS DWORD    ' // driver specific stretching and effects capabilites
   dwFXAlphaCaps                  AS DWORD    ' // alpha driver specific capabilities
   dwPalCaps                      AS DWORD    ' // palette capabilities
   dwSVCaps                       AS DWORD    ' // stereo vision capabilities
   dwAlphaBltConstBitDepths       AS DWORD    ' // DDBD_2,4,8
   dwAlphaBltPixelBitDepths       AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaBltSurfaceBitDepths     AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlayConstBitDepths   AS DWORD    ' // DDBD_2,4,8
   dwAlphaOverlayPixelBitDepths   AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlaySurfaceBitDepths AS DWORD    ' // DDBD_1,2,4,8
   dwZBufferBitDepths             AS DWORD    ' // DDBD_8,16,24,32
   dwVidMemTotal                  AS DWORD    ' // total amount of video memory
   dwVidMemFree                   AS DWORD    ' // amount of free video memory
   dwMaxVisibleOverlays           AS DWORD    ' // maximum number of visible overlays
   dwCurrVisibleOverlays          AS DWORD    ' // current number of visible overlays
   dwNumFourCCCodes               AS DWORD    ' // number of four cc codes
   dwAlignBoundarySrc             AS DWORD    ' // source rectangle alignment
   dwAlignSizeSrc                 AS DWORD    ' // source rectangle byte size
   dwAlignBoundaryDest            AS DWORD    ' // dest rectangle alignment
   dwAlignSizeDest                AS DWORD    ' // dest rectangle byte size
   dwAlignStrideAlign             AS DWORD    ' // stride alignment
   dwRops(%DD_ROP_SPACE-1)        AS DWORD    ' // ROPS supported
   tddsCaps                       AS DDSCAPS  ' // DDSCAPS structure has all the general capabilities
   dwMinOverlayStretch            AS DWORD    ' // minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxOverlayStretch            AS DWORD    ' // maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinLiveVideoStretch          AS DWORD    ' // minimum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxLiveVideoStretch          AS DWORD    ' // maximum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinHwCodecStretch            AS DWORD    ' // minimum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxHwCodecStretch            AS DWORD    ' // maximum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwReserved1                    AS DWORD    ' // reserved
   dwReserved2                    AS DWORD    ' // reserved
   dwReserved3                    AS DWORD    ' // reserved
   dwSVBCaps                      AS DWORD    ' // driver specific capabilities for System->Vmem blts
   dwSVBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->Vmem blts
   dwSVBFXCaps                    AS DWORD    ' // driver FX capabilities for System->Vmem blts
   dwSVBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->Vmem blts
   dwVSBCaps                      AS DWORD    ' // driver specific capabilities for Vmem->System blts
   dwVSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for Vmem->System blts
   dwVSBFXCaps                    AS DWORD    ' // driver FX capabilities for Vmem->System blts
   dwVSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for Vmem->System blts
   dwSSBCaps                      AS DWORD    ' // driver specific capabilities for System->System blts
   dwSSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->System blts
   dwSSBFXCaps                    AS DWORD    ' // driver FX capabilities for System->System blts
   dwSSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->System blts
   '// Members added for DX5:
   dwMaxVideoPorts                AS DWORD    ' // maximum number of usable video ports
   dwCurrVideoPorts               AS DWORD    ' // current number of video ports used
   dwSVBCaps2                     AS DWORD    ' // more driver specific capabilities for System->Vmem blts
   dwNLVBCaps                     AS DWORD    ' // driver specific capabilities for non-local->local vidmem blts
   dwNLVBCaps2                    AS DWORD    ' // more driver specific capabilities non-local->local vidmem blts
   dwNLVBCKeyCaps                 AS DWORD    ' // driver color key capabilities for non-local->local vidmem blts
   dwNLVBFXCaps                   AS DWORD    ' // driver FX capabilities for non-local->local blts
   dwNLVBRops(%DD_ROP_SPACE-1)    AS DWORD    ' // ROPS supported for non-local->local blts
END TYPE


TYPE DDCAPS_DX6
   dwSize                         AS DWORD    ' // size of the DDDRIVERCAPS structure
   dwCaps                         AS DWORD    ' // driver specific capabilities
   dwCaps2                        AS DWORD    ' // more driver specific capabilites
   dwCKeyCaps                     AS DWORD    ' // color key capabilities of the surface
   dwFXCaps                       AS DWORD    ' // driver specific stretching and effects capabilites
   dwFXAlphaCaps                  AS DWORD    ' // alpha driver specific capabilities
   dwPalCaps                      AS DWORD    ' // palette capabilities
   dwSVCaps                       AS DWORD    ' // stereo vision capabilities
   dwAlphaBltConstBitDepths       AS DWORD    ' // DDBD_2,4,8
   dwAlphaBltPixelBitDepths       AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaBltSurfaceBitDepths     AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlayConstBitDepths   AS DWORD    ' // DDBD_2,4,8
   dwAlphaOverlayPixelBitDepths   AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlaySurfaceBitDepths AS DWORD    ' // DDBD_1,2,4,8
   dwZBufferBitDepths             AS DWORD    ' // DDBD_8,16,24,32
   dwVidMemTotal                  AS DWORD    ' // total amount of video memory
   dwVidMemFree                   AS DWORD    ' // amount of free video memory
   dwMaxVisibleOverlays           AS DWORD    ' // maximum number of visible overlays
   dwCurrVisibleOverlays          AS DWORD    ' // current number of visible overlays
   dwNumFourCCCodes               AS DWORD    ' // number of four cc codes
   dwAlignBoundarySrc             AS DWORD    ' // source rectangle alignment
   dwAlignSizeSrc                 AS DWORD    ' // source rectangle byte size
   dwAlignBoundaryDest            AS DWORD    ' // dest rectangle alignment
   dwAlignSizeDest                AS DWORD    ' // dest rectangle byte size
   dwAlignStrideAlign             AS DWORD    ' // stride alignment
   dwRops(%DD_ROP_SPACE-1)        AS DWORD    ' // ROPS supported
   tddsOldCaps                    AS DDSCAPS  ' // DDSCAPS structure has all the general capabilities
   dwMinOverlayStretch            AS DWORD    ' // minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxOverlayStretch            AS DWORD    ' // maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinLiveVideoStretch          AS DWORD    ' // minimum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxLiveVideoStretch          AS DWORD    ' // maximum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinHwCodecStretch            AS DWORD    ' // minimum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxHwCodecStretch            AS DWORD    ' // maximum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwReserved1                    AS DWORD    ' // reserved
   dwReserved2                    AS DWORD    ' // reserved
   dwReserved3                    AS DWORD    ' // reserved
   dwSVBCaps                      AS DWORD    ' // driver specific capabilities for System->Vmem blts
   dwSVBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->Vmem blts
   dwSVBFXCaps                    AS DWORD    ' // driver FX capabilities for System->Vmem blts
   dwSVBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->Vmem blts
   dwVSBCaps                      AS DWORD    ' // driver specific capabilities for Vmem->System blts
   dwVSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for Vmem->System blts
   dwVSBFXCaps                    AS DWORD    ' // driver FX capabilities for Vmem->System blts
   dwVSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for Vmem->System blts
   dwSSBCaps                      AS DWORD    ' // driver specific capabilities for System->System blts
   dwSSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->System blts
   dwSSBFXCaps                    AS DWORD    ' // driver FX capabilities for System->System blts
   dwSSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->System blts
   '// Members added for DX5:
   dwMaxVideoPorts                AS DWORD    ' // maximum number of usable video ports
   dwCurrVideoPorts               AS DWORD    ' // current number of video ports used
   dwSVBCaps2                     AS DWORD    ' // more driver specific capabilities for System->Vmem blts
   dwNLVBCaps                     AS DWORD    ' // driver specific capabilities for non-local->local vidmem blts
   dwNLVBCaps2                    AS DWORD    ' // more driver specific capabilities non-local->local vidmem blts
   dwNLVBCKeyCaps                 AS DWORD    ' // driver color key capabilities for non-local->local vidmem blts
   dwNLVBFXCaps                   AS DWORD    ' // driver FX capabilities for non-local->local blts
   dwNLVBRops(%DD_ROP_SPACE-1)    AS DWORD    ' // ROPS supported for non-local->local blts
   '// Members added for DX6 release
   tddsCaps                       AS DDSCAPS2 ' // Surface Caps
END TYPE

TYPE DDCAPS_DX7
   dwSize                         AS DWORD    ' // size of the DDDRIVERCAPS structure
   dwCaps                         AS DWORD    ' // driver specific capabilities
   dwCaps2                        AS DWORD    ' // more driver specific capabilites
   dwCKeyCaps                     AS DWORD    ' // color key capabilities of the surface
   dwFXCaps                       AS DWORD    ' // driver specific stretching and effects capabilites
   dwFXAlphaCaps                  AS DWORD    ' // alpha driver specific capabilities
   dwPalCaps                      AS DWORD    ' // palette capabilities
   dwSVCaps                       AS DWORD    ' // stereo vision capabilities
   dwAlphaBltConstBitDepths       AS DWORD    ' // DDBD_2,4,8
   dwAlphaBltPixelBitDepths       AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaBltSurfaceBitDepths     AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlayConstBitDepths   AS DWORD    ' // DDBD_2,4,8
   dwAlphaOverlayPixelBitDepths   AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlaySurfaceBitDepths AS DWORD    ' // DDBD_1,2,4,8
   dwZBufferBitDepths             AS DWORD    ' // DDBD_8,16,24,32
   dwVidMemTotal                  AS DWORD    ' // total amount of video memory
   dwVidMemFree                   AS DWORD    ' // amount of free video memory
   dwMaxVisibleOverlays           AS DWORD    ' // maximum number of visible overlays
   dwCurrVisibleOverlays          AS DWORD    ' // current number of visible overlays
   dwNumFourCCCodes               AS DWORD    ' // number of four cc codes
   dwAlignBoundarySrc             AS DWORD    ' // source rectangle alignment
   dwAlignSizeSrc                 AS DWORD    ' // source rectangle byte size
   dwAlignBoundaryDest            AS DWORD    ' // dest rectangle alignment
   dwAlignSizeDest                AS DWORD    ' // dest rectangle byte size
   dwAlignStrideAlign             AS DWORD    ' // stride alignment
   dwRops(%DD_ROP_SPACE-1)        AS DWORD    ' // ROPS supported
   tddsOldCaps                    AS DDSCAPS  ' // DDSCAPS structure has all the general capabilities
   dwMinOverlayStretch            AS DWORD    ' // minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxOverlayStretch            AS DWORD    ' // maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinLiveVideoStretch          AS DWORD    ' // minimum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxLiveVideoStretch          AS DWORD    ' // maximum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinHwCodecStretch            AS DWORD    ' // minimum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxHwCodecStretch            AS DWORD    ' // maximum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwReserved1                    AS DWORD    ' // reserved
   dwReserved2                    AS DWORD    ' // reserved
   dwReserved3                    AS DWORD    ' // reserved
   dwSVBCaps                      AS DWORD    ' // driver specific capabilities for System->Vmem blts
   dwSVBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->Vmem blts
   dwSVBFXCaps                    AS DWORD    ' // driver FX capabilities for System->Vmem blts
   dwSVBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->Vmem blts
   dwVSBCaps                      AS DWORD    ' // driver specific capabilities for Vmem->System blts
   dwVSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for Vmem->System blts
   dwVSBFXCaps                    AS DWORD    ' // driver FX capabilities for Vmem->System blts
   dwVSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for Vmem->System blts
   dwSSBCaps                      AS DWORD    ' // driver specific capabilities for System->System blts
   dwSSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->System blts
   dwSSBFXCaps                    AS DWORD    ' // driver FX capabilities for System->System blts
   dwSSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->System blts
   '// Members added for DX5:
   dwMaxVideoPorts                AS DWORD    ' // maximum number of usable video ports
   dwCurrVideoPorts               AS DWORD    ' // current number of video ports used
   dwSVBCaps2                     AS DWORD    ' // more driver specific capabilities for System->Vmem blts
   dwNLVBCaps                     AS DWORD    ' // driver specific capabilities for non-local->local vidmem blts
   dwNLVBCaps2                    AS DWORD    ' // more driver specific capabilities non-local->local vidmem blts
   dwNLVBCKeyCaps                 AS DWORD    ' // driver color key capabilities for non-local->local vidmem blts
   dwNLVBFXCaps                   AS DWORD    ' // driver FX capabilities for non-local->local blts
   dwNLVBRops(%DD_ROP_SPACE-1)    AS DWORD    ' // ROPS supported for non-local->local blts
   '// Members added for DX6 release
   tddsCaps                       AS DDSCAPS2 ' // Surface Caps
END TYPE

TYPE DDCAPS   ' DDCAPS_DX7
   dwSize                         AS DWORD    ' // size of the DDDRIVERCAPS structure
   dwCaps                         AS DWORD    ' // driver specific capabilities
   dwCaps2                        AS DWORD    ' // more driver specific capabilites
   dwCKeyCaps                     AS DWORD    ' // color key capabilities of the surface
   dwFXCaps                       AS DWORD    ' // driver specific stretching and effects capabilites
   dwFXAlphaCaps                  AS DWORD    ' // alpha driver specific capabilities
   dwPalCaps                      AS DWORD    ' // palette capabilities
   dwSVCaps                       AS DWORD    ' // stereo vision capabilities
   dwAlphaBltConstBitDepths       AS DWORD    ' // DDBD_2,4,8
   dwAlphaBltPixelBitDepths       AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaBltSurfaceBitDepths     AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlayConstBitDepths   AS DWORD    ' // DDBD_2,4,8
   dwAlphaOverlayPixelBitDepths   AS DWORD    ' // DDBD_1,2,4,8
   dwAlphaOverlaySurfaceBitDepths AS DWORD    ' // DDBD_1,2,4,8
   dwZBufferBitDepths             AS DWORD    ' // DDBD_8,16,24,32
   dwVidMemTotal                  AS DWORD    ' // total amount of video memory
   dwVidMemFree                   AS DWORD    ' // amount of free video memory
   dwMaxVisibleOverlays           AS DWORD    ' // maximum number of visible overlays
   dwCurrVisibleOverlays          AS DWORD    ' // current number of visible overlays
   dwNumFourCCCodes               AS DWORD    ' // number of four cc codes
   dwAlignBoundarySrc             AS DWORD    ' // source rectangle alignment
   dwAlignSizeSrc                 AS DWORD    ' // source rectangle byte size
   dwAlignBoundaryDest            AS DWORD    ' // dest rectangle alignment
   dwAlignSizeDest                AS DWORD    ' // dest rectangle byte size
   dwAlignStrideAlign             AS DWORD    ' // stride alignment
   dwRops(%DD_ROP_SPACE-1)        AS DWORD    ' // ROPS supported
   tddsOldCaps                    AS DDSCAPS  ' // DDSCAPS structure has all the general capabilities
   dwMinOverlayStretch            AS DWORD    ' // minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxOverlayStretch            AS DWORD    ' // maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinLiveVideoStretch          AS DWORD    ' // minimum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxLiveVideoStretch          AS DWORD    ' // maximum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMinHwCodecStretch            AS DWORD    ' // minimum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwMaxHwCodecStretch            AS DWORD    ' // maximum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
   dwReserved1                    AS DWORD    ' // reserved
   dwReserved2                    AS DWORD    ' // reserved
   dwReserved3                    AS DWORD    ' // reserved
   dwSVBCaps                      AS DWORD    ' // driver specific capabilities for System->Vmem blts
   dwSVBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->Vmem blts
   dwSVBFXCaps                    AS DWORD    ' // driver FX capabilities for System->Vmem blts
   dwSVBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->Vmem blts
   dwVSBCaps                      AS DWORD    ' // driver specific capabilities for Vmem->System blts
   dwVSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for Vmem->System blts
   dwVSBFXCaps                    AS DWORD    ' // driver FX capabilities for Vmem->System blts
   dwVSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for Vmem->System blts
   dwSSBCaps                      AS DWORD    ' // driver specific capabilities for System->System blts
   dwSSBCKeyCaps                  AS DWORD    ' // driver color key capabilities for System->System blts
   dwSSBFXCaps                    AS DWORD    ' // driver FX capabilities for System->System blts
   dwSSBRops(%DD_ROP_SPACE-1)     AS DWORD    ' // ROPS supported for System->System blts
   '// Members added for DX5:
   dwMaxVideoPorts                AS DWORD    ' // maximum number of usable video ports
   dwCurrVideoPorts               AS DWORD    ' // current number of video ports used
   dwSVBCaps2                     AS DWORD    ' // more driver specific capabilities for System->Vmem blts
   dwNLVBCaps                     AS DWORD    ' // driver specific capabilities for non-local->local vidmem blts
   dwNLVBCaps2                    AS DWORD    ' // more driver specific capabilities non-local->local vidmem blts
   dwNLVBCKeyCaps                 AS DWORD    ' // driver color key capabilities for non-local->local vidmem blts
   dwNLVBFXCaps                   AS DWORD    ' // driver FX capabilities for non-local->local blts
   dwNLVBRops(%DD_ROP_SPACE-1)    AS DWORD    ' // ROPS supported for non-local->local blts
   '// Members added for DX6 release
   tddsCaps                       AS DDSCAPS2 ' // Surface Caps
END TYPE


'/*
' * DDPIXELFORMAT
' */

UNION DDPIXELFORMAT_UNION_1
   dwRGBBitCount           AS DWORD   ' // how many bits per pixel
   dwYUVBitCount           AS DWORD   ' // how many bits per pixel
   dwZBufferBitDepth       AS DWORD   ' // how many total bits/pixel in z buffer (including any stencil bits)
   dwAlphaBitDepth         AS DWORD   ' // how many bits for alpha channels
   dwLuminanceBitCount     AS DWORD   ' // how many bits per pixel
   dwBumpBitCount          AS DWORD   ' // how many bits per "buxel", total
   dwPrivateFormatBitCount AS DWORD   ' // Bits per pixel of private driver formats. Only valid in texture
END UNION

UNION DDPIXELFORMAT_UNION_2
   dwRBitMask         AS DWORD   ' // mask for red bit
   dwYBitMask         AS DWORD   ' // mask for Y bits
   dwStencilBitDepth  AS DWORD   ' // how many stencil bits (note: dwZBufferBitDepth-dwStencilBitDepth is total Z-only bits)
   dwLuminanceBitMask AS DWORD   ' // mask for luminance bits
   dwBumpDuBitMask    AS DWORD   ' // mask for bump map U delta bits
   dwOperations       AS DWORD   ' // DDPF_D3DFORMAT Operations
END UNION

TYPE DDPIXELFORMAT_MultiSampleCaps
   wFlipMSTypes AS WORD   ' // Multisample methods supported via flip for this D3DFORMAT
   wBltMSTypes  AS WORD   ' // Multisample methods supported via blt for this D3DFORMAT
END TYPE

UNION DDPIXELFORMAT_UNION_3
   dwGBitMask      AS DWORD   ' // mask for green bits
   dwUBitMask      AS DWORD   ' // mask for U bits
   dwZBitMask      AS DWORD   ' // mask for Z bits
   dwBumpDvBitMask AS DWORD   ' // mask for bump map V delta bits
   DDPIXELFORMAT_MultiSampleCaps
END UNION

UNION DDPIXELFORMAT_UNION_4
   dwBBitMask             AS DWORD   ' // mask for blue bits
   dwVBitMask             AS DWORD   ' // mask for V bits
   dwStencilBitMask       AS DWORD   ' // mask for stencil bits
   dwBumpLuminanceBitMask AS DWORD   ' // mask for luminance in bump map
END UNION

UNION DDPIXELFORMAT_UNION_5
   dwRGBAlphaBitMask       AS DWORD   ' // mask for alpha channel
   dwYUVAlphaBitMask       AS DWORD   ' // mask for alpha channel
   dwLuminanceAlphaBitMask AS DWORD   ' // mask for alpha channel
   dwRGBZBitMask           AS DWORD   ' // mask for Z channel
   dwYUVZBitMask           AS DWORD   ' // mask for Z channel
END UNION

TYPE DDPIXELFORMAT
   dwSize   AS DWORD      ' // size of structure
   dwFlags  AS DWORD      ' // pixel format flags
   dwFourCC AS DWORD      ' // (FOURCC code)
   DDPIXELFORMAT_UNION_1
   DDPIXELFORMAT_UNION_2
   DDPIXELFORMAT_UNION_3
   DDPIXELFORMAT_UNION_4
   DDPIXELFORMAT_UNION_5
END TYPE

'/*
' * DDOVERLAYFX
' */

UNION DDOVERLAYFX_UNION_1
   dwAlphaDestConst AS DWORD           ' // Constant to use as alpha channel for dest
   lpDDSAlphaDest   AS DWORD           ' // Surface to use as alpha channel for dest
END UNION

UNION DDOVERLAYFX_UNION_2
   dwAlphaSrcConst AS DWORD            ' // Constant to use as alpha channel for src
   lpDDSAlphaSrc   AS DWORD            ' // Surface to use as alpha channel for src
END UNION

TYPE DDOVERLAYFX
   dwSize                   AS DWORD        ' // size of structure
   dwAlphaEdgeBlendBitDepth AS DWORD        ' // Bit depth used to specify constant for alpha edge blend
   dwAlphaEdgeBlend         AS DWORD        ' // Constant to use as alpha for edge blend
   dwReserved               AS DWORD
   dwAlphaDestConstBitDepth AS DWORD        ' // Bit depth used to specify alpha constant for destination
   DDOVERLAYFX_UNION_1
   dwAlphaSrcConstBitDepth  AS DWORD        ' // Bit depth used to specify alpha constant for source
   DDOVERLAYFX_UNION_2
   dckDestColorkey          AS DDCOLORKEY   ' // DestColorkey override
   dckSrcColorkey           AS DDCOLORKEY   ' // DestColorkey override
   dwDDFX                   AS DWORD        ' // Overlay FX
   dwFlags                  AS DWORD        ' // flags
END TYPE

'/*
' * DDBLTBATCH: BltBatch entry structure
' */
TYPE DDBLTBATCH
   lprDest   AS RECT  PTR   ' LPRECT
   lpDDSSrc  AS DWORD       ' LPDIRECTDRAWSURFACE
   lprSrc    AS RECT  PTR   ' LPRECT
   dwFlags   AS DWORD       ' DWORD
   lpDDBltFx AS DWORD       ' LPDDBLTFX
END TYPE

'/*
' * DDGAMMARAMP
' */

TYPE DDGAMMARAMP
   red   (255) AS WORD
   green (255) AS WORD
   blue  (255) AS WORD
END TYPE

'/*
' *  This is the structure within which DirectDraw returns data about the current graphics driver and chipset
' */

%MAX_DDDEVICEID_STRING          = 512

TYPE DDDEVICEIDENTIFIER
'    /*
'     * These elements are for presentation to the user only. They should not be used to identify particular
'     * drivers, since this is unreliable and many different strings may be associated with the same
'     * device, and the same driver from different vendors.
'     */
   szDriver AS ASCIIZ * %MAX_DDDEVICEID_STRING       ' char    szDriver[MAX_DDDEVICEID_STRING];
   szDescription AS ASCIIZ * %MAX_DDDEVICEID_STRING  ' char    szDescription[MAX_DDDEVICEID_STRING];
'    /*
'     * This element is the version of the DirectDraw/3D driver. It is legal to do <, > comparisons
'     * on the whole 64 bits. Caution should be exercised if you use this element to identify problematic
'     * drivers. It is recommended that guidDeviceIdentifier is used for this purpose.
'     *
'     * This version has the form:
'     *  wProduct = HIWORD(liDriverVersion.HighPart)
'     *  wVersion = LOWORD(liDriverVersion.HighPart)
'     *  wSubVersion = HIWORD(liDriverVersion.LowPart)
'     *  wBuild = LOWORD(liDriverVersion.LowPart)
'     */
'#ifdef _WIN32
   liDriverVersion AS QUAD           ' LARGE_INTEGER liDriverVersion;      /* Defined for applications and other 32 bit components */
'#else
'   dwDriverVersionLowPart AS DWORD   ' DWORD   dwDriverVersionLowPart;     /* Defined for 16 bit driver components */
'   dwDriverVersionHighPart AS DWORD  ' DWORD   dwDriverVersionHighPart;
'#endif

'    /*
'     * These elements can be used to identify particular chipsets. Use with extreme caution.
'     *   dwVendorId     Identifies the manufacturer. May be zero if unknown.
'     *   dwDeviceId     Identifies the type of chipset. May be zero if unknown.
'     *   dwSubSysId     Identifies the subsystem, typically this means the particular board. May be zero if unknown.
'     *   dwRevision     Identifies the revision level of the chipset. May be zero if unknown.
'     */
   dwVendorId AS DWORD
   dwDeviceId AS DWORD
   dwSubSysId AS DWORD
   dwRevision AS DWORD

'    /*
'     * This element can be used to check changes in driver/chipset. This GUID is a unique identifier for the
'     * driver/chipset pair. Use this element if you wish to track changes to the driver/chipset in order to
'     * reprofile the graphics subsystem.
'     * This element can also be used to identify particular problematic drivers.
'     */
   guidDeviceIdentifier AS GUID
END TYPE

TYPE DDDEVICEIDENTIFIER2
'    /*
'     * These elements are for presentation to the user only. They should not be used to identify particular
'     * drivers, since this is unreliable and many different strings may be associated with the same
'     * device, and the same driver from different vendors.
'     */
   szDriver AS ASCIIZ * %MAX_DDDEVICEID_STRING       ' char    szDriver[MAX_DDDEVICEID_STRING];
   szDescription AS ASCIIZ * %MAX_DDDEVICEID_STRING  ' char    szDescription[MAX_DDDEVICEID_STRING];

'    /*
'     * This element is the version of the DirectDraw/3D driver. It is legal to do <, > comparisons
'     * on the whole 64 bits. Caution should be exercised if you use this element to identify problematic
'     * drivers. It is recommended that guidDeviceIdentifier is used for this purpose.
'     *
'     * This version has the form:
'     *  wProduct = HIWORD(liDriverVersion.HighPart)
'     *  wVersion = LOWORD(liDriverVersion.HighPart)
'     *  wSubVersion = HIWORD(liDriverVersion.LowPart)
'     *  wBuild = LOWORD(liDriverVersion.LowPart)
'     */
'#ifdef _WIN32
   liDriverVersion AS QUAD       ' LARGE_INTEGER liDriverVersion;      /* Defined for applications and other 32 bit components */
'#else
'   DWORD   dwDriverVersionLowPart;     /* Defined for 16 bit driver components */
'   DWORD   dwDriverVersionHighPart;
'#endif

'    /*
'     * These elements can be used to identify particular chipsets. Use with extreme caution.
'     *   dwVendorId     Identifies the manufacturer. May be zero if unknown.
'     *   dwDeviceId     Identifies the type of chipset. May be zero if unknown.
'     *   dwSubSysId     Identifies the subsystem, typically this means the particular board. May be zero if unknown.
'     *   dwRevision     Identifies the revision level of the chipset. May be zero if unknown.
'     */
   dwVendorId AS DWORD
   dwDeviceId AS DWORD
   dwSubSysId AS DWORD
   dwRevision AS DWORD

'    /*
'     * This element can be used to check changes in driver/chipset. This GUID is a unique identifier for the
'     * driver/chipset pair. Use this element if you wish to track changes to the driver/chipset in order to
'     * reprofile the graphics subsystem.
'     * This element can also be used to identify particular problematic drivers.
'     */
   guidDeviceIdentifier AS GUID

'    /*
'     * This element is used to determine the Windows Hardware Quality Lab (WHQL)
'     * certification level for this driver/device pair.
'     */
   dwWHQLLevel AS DWORD

END TYPE

'/*
' * Flags for the IDirectDraw4::GetDeviceIdentifier method
' */

'/*
' * This flag causes GetDeviceIdentifier to return information about the host (typically 2D) adapter in a system equipped
' * with a stacked secondary 3D adapter. Such an adapter appears to the application as if it were part of the
' * host adapter, but is typically physcially located on a separate card. The stacked secondary's information is
' * returned when GetDeviceIdentifier's dwFlags field is zero, since this most accurately reflects the qualities
' * of the DirectDraw object involved.
' */
%DDGDI_GETHOSTIDENTIFIER        = &H00000001???

'/*
' * Macros for interpretting DDEVICEIDENTIFIER2.dwWHQLLevel
' */
'#define GET_WHQL_YEAR( dwWHQLLevel ) \
'    ( (dwWHQLLevel) / 0x10000 )
'#define GET_WHQL_MONTH( dwWHQLLevel ) \
'    ( ( (dwWHQLLevel) / 0x100 ) & 0x00ff )
'#define GET_WHQL_DAY( dwWHQLLevel ) \
'    ( (dwWHQLLevel) & 0xff )

MACRO GET_WHQL_YEAR(dwWHQLLevel) = dwWHQLLevel \ &H10000
MACRO GET_WHQL_MONTH(dwWHQLLevel) = (dwWHQLLevel \ &H100) AND &H00ff
MACRO GET_WHQL_DAY(dwWHQLLevel) = dwWHQLLevel AND &Hff


'/*
' * callbacks
' */
'typedef DWORD   (FAR PASCAL *LPCLIPPERCALLBACK)(LPDIRECTDRAWCLIPPER lpDDClipper, HWND hWnd, DWORD code, LPVOID lpContext );
'#ifdef STREAMING
'typedef DWORD   (FAR PASCAL *LPSURFACESTREAMINGCALLBACK)(DWORD);
'#endif

'DECLARE FUNCTION CLIPPERCALLBACK (BYVAL lpDDClipper AS DWORD, BYVAL hWnd AS DWORD, BYVAL dwCode AS DWORD, BYVAL lpContext AS DWORD) AS DWORD
'DECLARE FUNCTION SURFACESTREAMINGCALLBACK (BYVAL DWORD) AS DWORD

'/*
' * DDSURFACEDESC
' */

UNION DDSURFACEDESC_UNION_1
   lPitch       AS DWORD               ' // distance to start of next line (return value only)
   dwLinearSize AS DWORD               ' // Formless late-allocated optimized surface size
END UNION

UNION DDSURFACEDESC_UNION_2
   dwMipMapCount     AS DWORD          ' // number of mip-map levels requested
   dwZBufferBitDepth AS DWORD          ' // depth of Z buffer requested
   dwRefreshRate     AS DWORD          ' // refresh rate (used when display mode is described)
END UNION

TYPE DDSURFACEDESC
   dwSize                AS DWORD           ' // size of the DDSURFACEDESC structure
   dwFlags               AS DWORD           ' // determines what fields are valid
   dwHeight              AS DWORD           ' // height of surface to be created
   dwWidth               AS DWORD           ' // width of input surface
   DDSURFACEDESC_UNION_1
   dwBackBufferCount     AS DWORD           ' // number of back buffers requested
   DDSURFACEDESC_UNION_2
   dwAlphaBitDepth       AS DWORD           ' // depth of alpha buffer requested
   dwReserved            AS DWORD           ' // reserved
   lpSurface             AS DWORD           ' // pointer to the associated surface memory
   ddckCKDestOverlay     AS DDCOLORKEY      ' // color key for destination overlay use
   ddckCKDestBlt         AS DDCOLORKEY      ' // color key for destination blt use
   ddckCKSrcOverlay      AS DDCOLORKEY      ' // color key for source overlay use
   ddckCKSrcBlt          AS DDCOLORKEY      ' // color key for source blt use
   ddpfPixelFormat       AS DDPIXELFORMAT   '    // pixel format description of the surface
   ddsCaps               AS DDSCAPS         ' // direct draw surface capabilities
END TYPE

'/*
' * DDSURFACEDESC2
' */

UNION DDSURFACEDESC2_UNION_1
   lPitch       AS LONG                ' // distance to start of next line (return value only)
   dwLinearSize AS DWORD               ' // Formless late-allocated optimized surface size
END UNION

UNION DDSURFACEDESC2_UNION_5
   dwBackBufferCount AS DWORD          ' // number of back buffers requested
   dwDepth          AS DWORD           ' // the depth if this is a volume texture
END UNION

UNION DDSURFACEDESC2_UNION_2
   dwMipMapCount AS DWORD              ' // number of mip-map levels requestde
                                       ' // dwZBufferBitDepth removed, use ddpfPixelFormat one instead
   dwRefreshRate AS DWORD              ' // refresh rate (used when display mode is described)
   dwSrcVBHandle AS DWORD              ' // The source used in VB::Optimize
END UNION

UNION DDSURFACEDESC2_UNION_3
   ddckCKDestOverlay AS DDCOLORKEY     ' // color key for destination overlay use
   dwEmptyFaceColor  AS DWORD          ' // Physical color for empty cubemap faces
END UNION

UNION DDSURFACEDESC2_UNION_4
   ddpfPixelFormat AS DDPIXELFORMAT    ' // pixel format description of the surface
   dwFVF           AS DWORD            ' // vertex format description of vertex buffers
END UNION

TYPE DDSURFACEDESC2
   dwSize                 AS DWORD        ' // size of the DDSURFACEDESC structure
   dwFlags                AS DWORD        ' // determines what fields are valid
   dwHeight               AS DWORD        ' // height of surface to be created
   dwWidth                AS DWORD        ' // width of input surface
   DDSURFACEDESC2_UNION_1
   DDSURFACEDESC2_UNION_5
   DDSURFACEDESC2_UNION_2
   dwAlphaBitDepth        AS DWORD        ' // depth of alpha buffer requested
   dwReserved             AS DWORD        ' // reserved
   lpSurface              AS DWORD        ' // pointer to the associated surface memory
   DDSURFACEDESC2_UNION_3
   ddckCKDestBlt          AS DDCOLORKEY   ' // color key for destination blt use
   ddckCKSrcOverlay       AS DDCOLORKEY   ' // color key for source overlay use
   ddckCKSrcBlt           AS DDCOLORKEY   ' // color key for source blt use
   DDSURFACEDESC2_UNION_4
   ddsCaps                AS DDSCAPS2     ' // direct draw surface capabilities
   dwTextureStage         AS DWORD        ' // stage in multitexture cascade
END TYPE

'/*
' * ddsCaps field is valid.
' */
%DDSD_CAPS               = &H00000001???    ' // default

'/*
' * dwHeight field is valid.
' */
%DDSD_HEIGHT             = &H00000002???

'/*
' * dwWidth field is valid.
' */
%DDSD_WIDTH              = &H00000004???

'/*
' * lPitch is valid.
' */
%DDSD_PITCH              = &H00000008???

'/*
' * dwBackBufferCount is valid.
' */
%DDSD_BACKBUFFERCOUNT    = &H00000020???

'/*
' * dwZBufferBitDepth is valid.  (shouldnt be used in DDSURFACEDESC2)
' */
%DDSD_ZBUFFERBITDEPTH    = &H00000040???

'/*
' * dwAlphaBitDepth is valid.
' */
%DDSD_ALPHABITDEPTH      = &H00000080???


'/*
' * lpSurface is valid.
' */
%DDSD_LPSURFACE          = &H00000800???

'/*
' * ddpfPixelFormat is valid.
' */
%DDSD_PIXELFORMAT        = &H00001000???

'/*
' * ddckCKDestOverlay is valid.
' */
%DDSD_CKDESTOVERLAY      = &H00002000???

'/*
' * ddckCKDestBlt is valid.
' */
%DDSD_CKDESTBLT          = &H00004000???

'/*
' * ddckCKSrcOverlay is valid.
' */
%DDSD_CKSRCOVERLAY       = &H00008000???

'/*
' * ddckCKSrcBlt is valid.
' */
%DDSD_CKSRCBLT           = &H00010000???

'/*
' * dwMipMapCount is valid.
' */
%DDSD_MIPMAPCOUNT        = &H00020000???

' /*
'  * dwRefreshRate is valid
'  */
%DDSD_REFRESHRATE        = &H00040000???

'/*
' * dwLinearSize is valid
' */
%DDSD_LINEARSIZE         = &H00080000???

'/*
' * dwTextureStage is valid
' */
%DDSD_TEXTURESTAGE       = &H00100000???

'/*
' * dwFVF is valid
' */
%DDSD_FVF                = &H00200000???

'/*
' * dwSrcVBHandle is valid
' */
%DDSD_SRCVBHANDLE        = &H00400000???

'/*
' * dwDepth is valid
' */
%DDSD_DEPTH              = &H00800000???

'/*
' * All input fields are valid.
' */
%DDSD_ALL                = &H00FFF9EE???

'/*
' * DDOPTSURFACEDESC
' */

TYPE DDOPTSURFACEDESC
   dwSize             AS DWORD         ' // size of the DDOPTSURFACEDESC structure
   dwFlags            AS DWORD         ' // determines what fields are valid
   ddSCaps            AS DDSCAPS2      ' // Common caps like: Memory type
   ddOSCaps           AS DDOSCAPS      ' // Common caps like: Memory type
   guid               AS GUID          ' // Compression technique GUID
   dwCompressionRatio AS DWORD         ' // Compression ratio
END TYPE

'/*
' * guid field is valid.
' */
%DDOSD_GUID                  = &H00000001???

'/*
' * dwCompressionRatio field is valid.
' */
%DDOSD_COMPRESSION_RATIO     = &H00000002???

'/*
' * ddSCaps field is valid.
' */
%DDOSD_SCAPS                 = &H00000004???

'/*
' * ddOSCaps field is valid.
' */
%DDOSD_OSCAPS                = &H00000008???

'/*
' * All input fields are valid.
' */
%DDOSD_ALL                   = &H0000000f???

'/*
' * The surface's optimized pixelformat is compressed
' */
%DDOSDCAPS_OPTCOMPRESSED     = &H00000001???

'/*
' * The surface's optimized pixelformat is reordered
' */
%DDOSDCAPS_OPTREORDERED      = &H00000002???

'/*
' * The opt surface is a monolithic mipmap
' */
%DDOSDCAPS_MONOLITHICMIPMAP  = &H00000004???

'/*
' * The valid Surf caps:
' * #define DDSCAPS_SYSTEMMEMORY         0x00000800l
' * #define DDSCAPS_VIDEOMEMORY          0x00004000l
' * #define DDSCAPS_LOCALVIDMEM          0x10000000l
' * #define DDSCAPS_NONLOCALVIDMEM       0x20000000l
' */
%DDOSDCAPS_VALIDSCAPS         = &H30004800???

'/*
' * The valid OptSurf caps
' */
%DDOSDCAPS_VALIDOSCAPS        = &H00000007???


'/*
' * DDCOLORCONTROL
' */
TYPE DDCOLORCONTROL
   dwSize       AS DWORD
   dwFlags      AS DWORD
   lBrightness  AS LONG
   lContrast    AS LONG
   lHue         AS LONG
   lSaturation  AS LONG
   lSharpness   AS LONG
   lGamma       AS LONG
   lColorEnable AS LONG
   dwReserved1  AS DWORD
END TYPE


'/*
' * lBrightness field is valid.
' */
%DDCOLOR_BRIGHTNESS           = &H00000001???

'/*
' * lContrast field is valid.
' */
%DDCOLOR_CONTRAST             = &H00000002???

'/*
' * lHue field is valid.
' */
%DDCOLOR_HUE                  = &H00000004???

'/*
' * lSaturation field is valid.
' */
%DDCOLOR_SATURATION           = &H00000008???

'/*
' * lSharpness field is valid.
' */
%DDCOLOR_SHARPNESS            = &H00000010???

'/*
' * lGamma field is valid.
' */
%DDCOLOR_GAMMA                = &H00000020???

'/*
' * lColorEnable field is valid.
' */
%DDCOLOR_COLORENABLE          = &H00000040???



'/*============================================================================
' *
' * Direct Draw Capability Flags
' *
' * These flags are used to describe the capabilities of a given Surface.
' * All flags are bit flags.
' *
' *==========================================================================*/

'/****************************************************************************
' *
' * DIRECTDRAWSURFACE CAPABILITY FLAGS
' *
' ****************************************************************************/

'/*
' * This bit is reserved. It should not be specified.
' */
%DDSCAPS_RESERVED1                       = &H00000001???

'/*
' * Indicates that this surface contains alpha-only information.
' * (To determine if a surface is RGBA/YUVA, the pixel format must be
' * interrogated.)
' */
%DDSCAPS_ALPHA                           = &H00000002???

'/*
' * Indicates that this surface is a backbuffer.  It is generally
' * set by CreateSurface when the DDSCAPS_FLIP capability bit is set.
' * It indicates that this surface is THE back buffer of a surface
' * flipping structure.  DirectDraw supports N surfaces in a
' * surface flipping structure.  Only the surface that immediately
' * precedeces the DDSCAPS_FRONTBUFFER has this capability bit set.
' * The other surfaces are identified as back buffers by the presence
' * of the DDSCAPS_FLIP capability, their attachment order, and the
' * absence of the DDSCAPS_FRONTBUFFER and DDSCAPS_BACKBUFFER
' * capabilities.  The bit is sent to CreateSurface when a standalone
' * back buffer is being created.  This surface could be attached to
' * a front buffer and/or back buffers to form a flipping surface
' * structure after the CreateSurface call.  See AddAttachments for
' * a detailed description of the behaviors in this case.
' */
%DDSCAPS_BACKBUFFER                      = &H00000004???

'/*
' * Indicates a complex surface structure is being described.  A
' * complex surface structure results in the creation of more than
' * one surface.  The additional surfaces are attached to the root
' * surface.  The complex structure can only be destroyed by
' * destroying the root.
' */
%DDSCAPS_COMPLEX                         = &H00000008???

'/*
' * Indicates that this surface is a part of a surface flipping structure.
' * When it is passed to CreateSurface the DDSCAPS_FRONTBUFFER and
' * DDSCAP_BACKBUFFER bits are not set.  They are set by CreateSurface
' * on the resulting creations.  The dwBackBufferCount field in the
' * DDSURFACEDESC structure must be set to at least 1 in order for
' * the CreateSurface call to succeed.  The DDSCAPS_COMPLEX capability
' * must always be set with creating multiple surfaces through CreateSurface.
' */
%DDSCAPS_FLIP                            = &H00000010???

'/*
' * Indicates that this surface is THE front buffer of a surface flipping
' * structure.  It is generally set by CreateSurface when the DDSCAPS_FLIP
' * capability bit is set.
' * If this capability is sent to CreateSurface then a standalonw front buffer
' * is created.  This surface will not have the DDSCAPS_FLIP capability.
' * It can be attached to other back buffers to form a flipping structure.
' * See AddAttachments for a detailed description of the behaviors in this
' * case.
' */
%DDSCAPS_FRONTBUFFER                     = &H00000020???

'/*
' * Indicates that this surface is any offscreen surface that is not an overlay,
' * texture, zbuffer, front buffer, back buffer, or alpha surface.  It is used
' * to identify plain vanilla surfaces.
' */
%DDSCAPS_OFFSCREENPLAIN                  = &H00000040???

'/*
' * Indicates that this surface is an overlay.  It may or may not be directly visible
' * depending on whether or not it is currently being overlayed onto the primary
' * surface.  DDSCAPS_VISIBLE can be used to determine whether or not it is being
' * overlayed at the moment.
' */
%DDSCAPS_OVERLAY                         = &H00000080???

'/*
' * Indicates that unique DirectDrawPalette objects can be created and
' * attached to this surface.
' */
%DDSCAPS_PALETTE                         = &H00000100???

'/*
' * Indicates that this surface is the primary surface.  The primary
' * surface represents what the user is seeing at the moment.
' */
%DDSCAPS_PRIMARYSURFACE                  = &H00000200???


'/*
' * This flag used to be DDSCAPS_PRIMARYSURFACELEFT, which is now
' * obsolete.
' */
%DDSCAPS_RESERVED3                       = &H00000400???
%DDSCAPS_PRIMARYSURFACELEFT              = &H00000000???

'/*
' * Indicates that this surface memory was allocated in system memory
' */
%DDSCAPS_SYSTEMMEMORY                    = &H00000800???

'/*
' * Indicates that this surface can be used as a 3D texture.  It does not
' * indicate whether or not the surface is being used for that purpose.
' */
%DDSCAPS_TEXTURE                         = &H00001000???

'/*
' * Indicates that a surface may be a destination for 3D rendering.  This
' * bit must be set in order to query for a Direct3D Device Interface
' * from this surface.
' */
%DDSCAPS_3DDEVICE                        = &H00002000???

'/*
' * Indicates that this surface exists in video memory.
' */
%DDSCAPS_VIDEOMEMORY                     = &H00004000???

'/*
' * Indicates that changes made to this surface are immediately visible.
' * It is always set for the primary surface and is set for overlays while
' * they are being overlayed and texture maps while they are being textured.
' */
%DDSCAPS_VISIBLE                         = &H00008000???

'/*
' * Indicates that only writes are permitted to the surface.  Read accesses
' * from the surface may or may not generate a protection fault, but the
' * results of a read from this surface will not be meaningful.  READ ONLY.
' */
%DDSCAPS_WRITEONLY                       = &H00010000???

'/*
' * Indicates that this surface is a z buffer. A z buffer does not contain
' * displayable information.  Instead it contains bit depth information that is
' * used to determine which pixels are visible and which are obscured.
' */
%DDSCAPS_ZBUFFER                         = &H00020000???

'/*
' * Indicates surface will have a DC associated long term
' */
%DDSCAPS_OWNDC                           = &H00040000???

'/*
' * Indicates surface should be able to receive live video
' */
%DDSCAPS_LIVEVIDEO                       = &H00080000???

'/*
' * Indicates surface should be able to have a stream decompressed
' * to it by the hardware.
' */
%DDSCAPS_HWCODEC                         = &H00100000???

'/*
' * Surface is a ModeX surface.
' *
' */
%DDSCAPS_MODEX                           = &H00200000???

'/*
' * Indicates surface is one level of a mip-map. This surface will
' * be attached to other DDSCAPS_MIPMAP surfaces to form the mip-map.
' * This can be done explicitly, by creating a number of surfaces and
' * attaching them with AddAttachedSurface or by implicitly by CreateSurface.
' * If this bit is set then DDSCAPS_TEXTURE must also be set.
' */
%DDSCAPS_MIPMAP                          = &H00400000???

'/*
' * This bit is reserved. It should not be specified.
' */
%DDSCAPS_RESERVED2                       = &H00800000???


'/*
' * Indicates that memory for the surface is not allocated until the surface
' * is loaded (via the Direct3D texture Load() function).
' */
%DDSCAPS_ALLOCONLOAD                     = &H04000000???

'/*
' * Indicates that the surface will recieve data from a video port.
' */
%DDSCAPS_VIDEOPORT                       = &H08000000???

'/*
' * Indicates that a video memory surface is resident in true, local video
' * memory rather than non-local video memory. If this flag is specified then
' * so must DDSCAPS_VIDEOMEMORY. This flag is mutually exclusive with
' * DDSCAPS_NONLOCALVIDMEM.
' */
%DDSCAPS_LOCALVIDMEM                     = &H10000000???

'/*
' * Indicates that a video memory surface is resident in non-local video
' * memory rather than true, local video memory. If this flag is specified
' * then so must DDSCAPS_VIDEOMEMORY. This flag is mutually exclusive with
' * DDSCAPS_LOCALVIDMEM.
' */
%DDSCAPS_NONLOCALVIDMEM                  = &H20000000???

'/*
' * Indicates that this surface is a standard VGA mode surface, and not a
' * ModeX surface. (This flag will never be set in combination with the
' * DDSCAPS_MODEX flag).
' */
%DDSCAPS_STANDARDVGAMODE                 = &H40000000???

'/*
' * Indicates that this surface will be an optimized surface. This flag is
' * currently only valid in conjunction with the DDSCAPS_TEXTURE flag. The surface
' * will be created without any underlying video memory until loaded.
' */
%DDSCAPS_OPTIMIZED                       = &H80000000???

'/*
' * This bit is reserved
' */
%DDSCAPS2_RESERVED4                      = &H00000002???
%DDSCAPS2_HARDWAREDEINTERLACE            = &H00000000???

'/*
' * Indicates to the driver that this surface will be locked very frequently
' * (for procedural textures, dynamic lightmaps, etc). Surfaces with this cap
' * set must also have DDSCAPS_TEXTURE. This cap cannot be used with
' * DDSCAPS2_HINTSTATIC and DDSCAPS2_OPAQUE.
' */
%DDSCAPS2_HINTDYNAMIC                    = &H00000004???

'/*
' * Indicates to the driver that this surface can be re-ordered/retiled on
' * load. This operation will not change the size of the texture. It is
' * relatively fast and symmetrical, since the application may lock these
' * bits (although it will take a performance hit when doing so). Surfaces
' * with this cap set must also have DDSCAPS_TEXTURE. This cap cannot be
' * used with DDSCAPS2_HINTDYNAMIC and DDSCAPS2_OPAQUE.
' */
%DDSCAPS2_HINTSTATIC                     = &H00000008???

'/*
' * Indicates that the client would like this texture surface to be managed by the
' * DirectDraw/Direct3D runtime. Surfaces with this cap set must also have
' * DDSCAPS_TEXTURE set.
' */
%DDSCAPS2_TEXTUREMANAGE                  = &H00000010???

'/*
' * These bits are reserved for internal use */
%DDSCAPS2_RESERVED1                      = &H00000020???
%DDSCAPS2_RESERVED2                      = &H00000040???

'/*
' * Indicates to the driver that this surface will never be locked again.
' * The driver is free to optimize this surface via retiling and actual compression.
' * All calls to Lock() or Blts from this surface will fail. Surfaces with this
' * cap set must also have DDSCAPS_TEXTURE. This cap cannot be used with
' * DDSCAPS2_HINTDYNAMIC and DDSCAPS2_HINTSTATIC.
' */
%DDSCAPS2_OPAQUE                         = &H00000080???

'/*
' * Applications should set this bit at CreateSurface time to indicate that they
' * intend to use antialiasing. Only valid if DDSCAPS_3DDEVICE is also set.
' */
%DDSCAPS2_HINTANTIALIASING               = &H00000100???


'/*
' * This flag is used at CreateSurface time to indicate that this set of
' * surfaces is a cubic environment map
' */
%DDSCAPS2_CUBEMAP                        = &H00000200???

'/*
' * These flags preform two functions:
' * - At CreateSurface time, they define which of the six cube faces are
' *   required by the application.
' * - After creation, each face in the cubemap will have exactly one of these
' *   bits set.
' */
%DDSCAPS2_CUBEMAP_POSITIVEX              = &H00000400???
%DDSCAPS2_CUBEMAP_NEGATIVEX              = &H00000800???
%DDSCAPS2_CUBEMAP_POSITIVEY              = &H00001000???
%DDSCAPS2_CUBEMAP_NEGATIVEY              = &H00002000???
%DDSCAPS2_CUBEMAP_POSITIVEZ              = &H00004000???
%DDSCAPS2_CUBEMAP_NEGATIVEZ              = &H00008000???

'/*
' * This macro may be used to specify all faces of a cube map at CreateSurface time
' */
%DDSCAPS2_CUBEMAP_ALLFACES = ( %DDSCAPS2_CUBEMAP_POSITIVEX OR _
                               %DDSCAPS2_CUBEMAP_NEGATIVEX OR _
                               %DDSCAPS2_CUBEMAP_POSITIVEY OR _
                               %DDSCAPS2_CUBEMAP_NEGATIVEY OR _
                               %DDSCAPS2_CUBEMAP_POSITIVEZ OR _
                               %DDSCAPS2_CUBEMAP_NEGATIVEZ )

'/*
' * This flag is an additional flag which is present on mipmap sublevels from DX7 onwards
' * It enables easier use of GetAttachedSurface rather than EnumAttachedSurfaces for surface
' * constructs such as Cube Maps, wherein there are more than one mipmap surface attached
' * to the root surface.
' * This caps bit is ignored by CreateSurface
' */
%DDSCAPS2_MIPMAPSUBLEVEL                 = &H00010000???

'/* This flag indicates that the texture should be managed by D3D only */
%DDSCAPS2_D3DTEXTUREMANAGE               = &H00020000???

'/* This flag indicates that the managed surface can be safely lost */
%DDSCAPS2_DONOTPERSIST                   = &H00040000???

'/* indicates that this surface is part of a stereo flipping chain */
%DDSCAPS2_STEREOSURFACELEFT              = &H00080000???

'/*
' * Indicates that the surface is a volume.
' * Can be combined with DDSCAPS_MIPMAP to indicate a multi-level volume
' */
%DDSCAPS2_VOLUME                         = &H00200000???

'/*
' * Indicates that the surface may be locked multiple times by the application.
' * This cap cannot be used with DDSCAPS2_OPAQUE.
' */
%DDSCAPS2_NOTUSERLOCKABLE                = &H00400000???

'/*
' * Indicates that the vertex buffer data can be used to render points and
' * point sprites.
' */
%DDSCAPS2_POINTS                         = &H00800000???

'/*
' * Indicates that the vertex buffer data can be used to render rt pactches.
' */
%DDSCAPS2_RTPATCHES                      = &H01000000???

'/*
' * Indicates that the vertex buffer data can be used to render n patches.
' */
%DDSCAPS2_NPATCHES                       = &H02000000???

'/*
' * This bit is reserved for internal use
' */
%DDSCAPS2_RESERVED3                      = &H04000000???


'/*
' * Indicates that the contents of the backbuffer do not have to be preserved
' * the contents of the backbuffer after they are presented.
' */
%DDSCAPS2_DISCARDBACKBUFFER              = &H10000000???

'/*
' * Indicates that all surfaces in this creation chain should be given an alpha channel.
' * This flag will be set on primary surface chains that may have no explicit pixel format
' * (and thus take on the format of the current display mode).
' * The driver should infer that all these surfaces have a format having an alpha channel.
' * (e.g. assume D3DFMT_A8R8G8B8 if the display mode is x888.)
' */
%DDSCAPS2_ENABLEALPHACHANNEL             = &H20000000???

'/*
' * Indicates that all surfaces in this creation chain is extended primary surface format.
' * This flag will be set on extended primary surface chains that always have explicit pixel
' * format and the pixel format is typically GDI (Graphics Device Interface) couldn't handle,
' * thus only used with fullscreen application. (e.g. D3DFMT_A2R10G10B10 format)
' */
%DDSCAPS2_EXTENDEDFORMATPRIMARY          = &H40000000???

'/*
' * Indicates that all surfaces in this creation chain is additional primary surface.
' * This flag will be set on primary surface chains which must present on the adapter
' * id provided on dwCaps4. Typically this will be used to create secondary primary surface
' * on DualView display adapter.
' */
%DDSCAPS2_ADDITIONALPRIMARY              = &H80000000???

'/*
' * This is a mask that indicates the set of bits that may be set
' * at createsurface time to indicate number of samples per pixel
' * when multisampling
' */
%DDSCAPS3_MULTISAMPLE_MASK               = &H0000001F???

'/*
' * This is a mask that indicates the set of bits that may be set
' * at createsurface time to indicate the quality level of rendering
' * for the current number of samples per pixel
' */
%DDSCAPS3_MULTISAMPLE_QUALITY_MASK       = &H000000E0???
%DDSCAPS3_MULTISAMPLE_QUALITY_SHIFT      = 5

'/*
' * This bit is reserved for internal use
' */
%DDSCAPS3_RESERVED1                      = &H00000100???

'/*
' * This bit is reserved for internal use
' */
%DDSCAPS3_RESERVED2                      = &H00000200???

'/*
' * This indicates whether this surface has light-weight miplevels
' */
%DDSCAPS3_LIGHTWEIGHTMIPMAP              = &H00000400???

'/*
' * This indicates that the mipsublevels for this surface are auto-generated
' */
%DDSCAPS3_AUTOGENMIPMAP                  = &H00000800???

'/*
' * This indicates that the mipsublevels for this surface are auto-generated
' */
%DDSCAPS3_DMAP                           = &H00001000???


' /****************************************************************************
' *
' * DIRECTDRAW DRIVER CAPABILITY FLAGS
' *
' ****************************************************************************/

'/*
' * Display hardware has 3D acceleration.
' */
%DDCAPS_3D                       = &H00000001???

'/*
' * Indicates that DirectDraw will support only dest rectangles that are aligned
' * on DIRECTDRAWCAPS.dwAlignBoundaryDest boundaries of the surface, respectively.
' * READ ONLY.
' */
%DDCAPS_ALIGNBOUNDARYDEST        = &H00000002???

'/*
' * Indicates that DirectDraw will support only source rectangles  whose sizes in
' * BYTEs are DIRECTDRAWCAPS.dwAlignSizeDest multiples, respectively.  READ ONLY.
' */
%DDCAPS_ALIGNSIZEDEST            = &H00000004???

'/*
' * Indicates that DirectDraw will support only source rectangles that are aligned
' * on DIRECTDRAWCAPS.dwAlignBoundarySrc boundaries of the surface, respectively.
' * READ ONLY.
' */
%DDCAPS_ALIGNBOUNDARYSRC         = &H00000008???

'/*
' * Indicates that DirectDraw will support only source rectangles  whose sizes in
' * BYTEs are DIRECTDRAWCAPS.dwAlignSizeSrc multiples, respectively.  READ ONLY.
' */
%DDCAPS_ALIGNSIZESRC             = &H00000010???

'/*
' * Indicates that DirectDraw will create video memory surfaces that have a stride
' * alignment equal to DIRECTDRAWCAPS.dwAlignStride.  READ ONLY.
' */
%DDCAPS_ALIGNSTRIDE              = &H00000020???

'/*
' * Display hardware is capable of blt operations.
' */
%DDCAPS_BLT                      = &H00000040???

'/*
' * Display hardware is capable of asynchronous blt operations.
' */
%DDCAPS_BLTQUEUE                 = &H00000080???

'/*
' * Display hardware is capable of color space conversions during the blt operation.
' */
%DDCAPS_BLTFOURCC                = &H00000100???

'/*
' * Display hardware is capable of stretching during blt operations.
' */
%DDCAPS_BLTSTRETCH               = &H00000200???

'/*
' * Display hardware is shared with GDI.
' */
%DDCAPS_GDI                      = &H00000400???

'/*
' * Display hardware can overlay.
' */
%DDCAPS_OVERLAY                  = &H00000800???

'/*
' * Set if display hardware supports overlays but can not clip them.
' */
%DDCAPS_OVERLAYCANTCLIP          = &H00001000???

'/*
' * Indicates that overlay hardware is capable of color space conversions during
' * the overlay operation.
' */
%DDCAPS_OVERLAYFOURCC            = &H00002000???

'/*
' * Indicates that stretching can be done by the overlay hardware.
' */
%DDCAPS_OVERLAYSTRETCH           = &H00004000???

'/*
' * Indicates that unique DirectDrawPalettes can be created for DirectDrawSurfaces
' * other than the primary surface.
' */
%DDCAPS_PALETTE                  = &H00008000???

'/*
' * Indicates that palette changes can be syncd with the veritcal refresh.
' */
%DDCAPS_PALETTEVSYNC             = &H00010000???

'/*
' * Display hardware can return the current scan line.
' */
%DDCAPS_READSCANLINE             = &H00020000???


'/*
' * This flag used to bo DDCAPS_STEREOVIEW, which is now obsolete
' */
%DDCAPS_RESERVED1                = &H00040000???

'/*
' * Display hardware is capable of generating a vertical blank interrupt.
' */
%DDCAPS_VBI                      = &H00080000???

'/*
' * Supports the use of z buffers with blt operations.
' */
%DDCAPS_ZBLTS                    = &H00100000???

'/*
' * Supports Z Ordering of overlays.
' */
%DDCAPS_ZOVERLAYS                = &H00200000???

'/*
' * Supports color key
' */
%DDCAPS_COLORKEY                 = &H00400000???

'/*
' * Supports alpha surfaces
' */
%DDCAPS_ALPHA                    = &H00800000???

'/*
' * colorkey is hardware assisted(DDCAPS_COLORKEY will also be set)
' */
%DDCAPS_COLORKEYHWASSIST         = &H01000000???

'/*
' * no hardware support at all
' */
%DDCAPS_NOHARDWARE               = &H02000000???

'/*
' * Display hardware is capable of color fill with bltter
' */
%DDCAPS_BLTCOLORFILL             = &H04000000???

'/*
' * Display hardware is bank switched, and potentially very slow at
' * random access to VRAM.
' */
%DDCAPS_BANKSWITCHED             = &H08000000???

'/*
' * Display hardware is capable of depth filling Z-buffers with bltter
' */
%DDCAPS_BLTDEPTHFILL             = &H10000000???

'/*
' * Display hardware is capable of clipping while bltting.
' */
%DDCAPS_CANCLIP                  = &H20000000???

'/*
' * Display hardware is capable of clipping while stretch bltting.
' */
%DDCAPS_CANCLIPSTRETCHED         = &H40000000???

'/*
' * Display hardware is capable of bltting to or from system memory
' */
%DDCAPS_CANBLTSYSMEM             = &H80000000???


' /****************************************************************************
' *
' * MORE DIRECTDRAW DRIVER CAPABILITY FLAGS (dwCaps2)
' *
' ****************************************************************************/

'/*
' * Display hardware is certified
' */
%DDCAPS2_CERTIFIED              = &H00000001???

'/*
' * Driver cannot interleave 2D operations (lock and blt) to surfaces with
' * Direct3D rendering operations between calls to BeginScene() and EndScene()
' */
%DDCAPS2_NO2DDURING3DSCENE       = &H00000002???

'/*
' * Display hardware contains a video port
' */
%DDCAPS2_VIDEOPORT               = &H00000004???

'/*
' * The overlay can be automatically flipped according to the video port
' * VSYNCs, providing automatic doubled buffered display of video port
' * data using an overlay
' */
%DDCAPS2_AUTOFLIPOVERLAY         = &H00000008???

'/*
' * Overlay can display each field of interlaced data individually while
' * it is interleaved in memory without causing jittery artifacts.
' */
%DDCAPS2_CANBOBINTERLEAVED       = &H00000010???

'/*
' * Overlay can display each field of interlaced data individually while
' * it is not interleaved in memory without causing jittery artifacts.
' */
%DDCAPS2_CANBOBNONINTERLEAVED    = &H00000020???

'/*
' * The overlay surface contains color controls (brightness, sharpness, etc.)
' */
%DDCAPS2_COLORCONTROLOVERLAY     = &H00000040???

'/*
' * The primary surface contains color controls (gamma, etc.)
' */
%DDCAPS2_COLORCONTROLPRIMARY     = &H00000080???

'/*
' * RGBZ -> RGB supported for 16:16 RGB:Z
' */
%DDCAPS2_CANDROPZ16BIT           = &H00000100???

'/*
' * Driver supports non-local video memory.
' */
%DDCAPS2_NONLOCALVIDMEM          = &H00000200???

'/*
' * Dirver supports non-local video memory but has different capabilities for
' * non-local video memory surfaces. If this bit is set then so must
' * DDCAPS2_NONLOCALVIDMEM.
' */
%DDCAPS2_NONLOCALVIDMEMCAPS      = &H00000400???

'/*
' * Driver neither requires nor prefers surfaces to be pagelocked when performing
' * blts involving system memory surfaces
' */
%DDCAPS2_NOPAGELOCKREQUIRED      = &H00000800???

'/*
' * Driver can create surfaces which are wider than the primary surface
' */
%DDCAPS2_WIDESURFACES            = &H00001000???

'/*
' * Driver supports bob without using a video port by handling the
' * DDFLIP_ODD and DDFLIP_EVEN flags specified in Flip.
' */
%DDCAPS2_CANFLIPODDEVEN          = &H00002000???

'/*
' * Driver supports bob using hardware
' */
%DDCAPS2_CANBOBHARDWARE          = &H00004000???

'/*
' * Driver supports bltting any FOURCC surface to another surface of the same FOURCC
' */
%DDCAPS2_COPYFOURCC              = &H00008000???


'/*
' * Driver supports loadable gamma ramps for the primary surface
' */
%DDCAPS2_PRIMARYGAMMA            = &H00020000???

'/*
' * Driver can render in windowed mode.
' */
%DDCAPS2_CANRENDERWINDOWED       = &H00080000???

'/*
' * A calibrator is available to adjust the gamma ramp according to the
' * physical display properties so that the result will be identical on
' * all calibrated systems.
' */
%DDCAPS2_CANCALIBRATEGAMMA       = &H00100000???

'/*
' * Indicates that the driver will respond to DDFLIP_INTERVALn flags
' */
%DDCAPS2_FLIPINTERVAL            = &H00200000???

'/*
' * Indicates that the driver will respond to DDFLIP_NOVSYNC
' */
%DDCAPS2_FLIPNOVSYNC             = &H00400000???

'/*
' * Driver supports management of video memory, if this flag is ON,
' * driver manages the texture if requested with DDSCAPS2_TEXTUREMANAGE on
' * DirectX manages the texture if this flag is OFF and surface has DDSCAPS2_TEXTUREMANAGE on
' */
%DDCAPS2_CANMANAGETEXTURE        = &H00800000???

'/*
' * The Direct3D texture manager uses this cap to decide whether to put managed
' * surfaces in non-local video memory. If the cap is set, the texture manager will
' * put managed surfaces in non-local vidmem. Drivers that cannot texture from
' * local vidmem SHOULD NOT set this cap.
' */
%DDCAPS2_TEXMANINNONLOCALVIDMEM  = &H01000000???

'/*
' * Indicates that the driver supports DX7 type of stereo in at least one mode (which may
' * not necessarily be the current mode). Applications should use IDirectDraw7 (or higher)
' * ::EnumDisplayModes and check the DDSURFACEDESC.ddsCaps.dwCaps2 field for the presence of
' * DDSCAPS2_STEREOSURFACELEFT to check if a particular mode supports stereo. The application
' * can also use IDirectDraw7(or higher)::GetDisplayMode to check the current mode.
' */
%DDCAPS2_STEREO                  = &H02000000???

'/*
' * This caps bit is intended for internal DirectDraw use.
' * -It is only valid if DDCAPS2_NONLOCALVIDMEMCAPS is set.
' * -If this bit is set, then DDCAPS_CANBLTSYSMEM MUST be set by the driver (and
' *  all the assoicated system memory blt caps must be correct).
' * -It implies that the system->video blt caps in DDCAPS also apply to system to
' *  nonlocal blts. I.e. the dwSVBCaps, dwSVBCKeyCaps, dwSVBFXCaps and dwSVBRops
' *  members of DDCAPS (DDCORECAPS) are filled in correctly.
' * -Any blt from system to nonlocal memory that matches these caps bits will
' *  be passed to the driver.
' *
' * NOTE: This is intended to enable the driver itself to do efficient reordering
' * of textures. This is NOT meant to imply that hardware can write into AGP memory.
' * This operation is not currently supported.
' */
%DDCAPS2_SYSTONONLOCAL_AS_SYSTOLOCAL   = &H04000000???

'/*
' * was DDCAPS2_PUREHAL
' */
%DDCAPS2_RESERVED1                     = &H08000000???

'/*
' * Driver supports management of video memory, if this flag is ON,
' * driver manages the resource if requested with DDSCAPS2_TEXTUREMANAGE on
' * DirectX manages the resource if this flag is OFF and surface has DDSCAPS2_TEXTUREMANAGE on
' */
%DDCAPS2_CANMANAGERESOURCE             = &H10000000???

'/*
' * Driver supports dynamic textures. This will allow the application to set
' * D3DUSAGE_DYNAMIC (DDSCAPS2_HINTDYNAMIC for drivers) at texture create time.
' * Video memory dynamic textures WILL be lockable by applications. It is
' * expected that these locks will be very efficient (which implies that the
' * driver should always maintain a linear copy, a pointer to which can be
' * quickly handed out to the application).
' */
%DDCAPS2_DYNAMICTEXTURES               = &H20000000???

'/*
' * Driver supports auto-generation of mipmaps.
' */
%DDCAPS2_CANAUTOGENMIPMAP              = &H40000000???


'/****************************************************************************
' *
' * DIRECTDRAW FX ALPHA CAPABILITY FLAGS
' *
' ****************************************************************************/

'/*
' * Supports alpha blending around the edge of a source color keyed surface.
' * For Blt.
' */
%DDFXALPHACAPS_BLTALPHAEDGEBLEND         = &H00000001???

'/*
' * Supports alpha information in the pixel format.  The bit depth of alpha
' * information in the pixel format can be 1,2,4, or 8.  The alpha value becomes
' * more opaque as the alpha value increases.  (0 is transparent.)
' * For Blt.
' */
%DDFXALPHACAPS_BLTALPHAPIXELS            = &H00000002???

'/*
' * Supports alpha information in the pixel format.  The bit depth of alpha
' * information in the pixel format can be 1,2,4, or 8.  The alpha value
' * becomes more transparent as the alpha value increases.  (0 is opaque.)
' * This flag can only be set if DDCAPS_ALPHA is set.
' * For Blt.
' */
%DDFXALPHACAPS_BLTALPHAPIXELSNEG         = &H00000004???

'/*
' * Supports alpha only surfaces.  The bit depth of an alpha only surface can be
' * 1,2,4, or 8.  The alpha value becomes more opaque as the alpha value increases.
' * (0 is transparent.)
' * For Blt.
' */
%DDFXALPHACAPS_BLTALPHASURFACES          = &H00000008???

'/*
' * The depth of the alpha channel data can range can be 1,2,4, or 8.
' * The NEG suffix indicates that this alpha channel becomes more transparent
' * as the alpha value increases. (0 is opaque.)  This flag can only be set if
' * DDCAPS_ALPHA is set.
' * For Blt.
' */
%DDFXALPHACAPS_BLTALPHASURFACESNEG       = &H00000010???

'/*
' * Supports alpha blending around the edge of a source color keyed surface.
' * For Overlays.
' */
%DDFXALPHACAPS_OVERLAYALPHAEDGEBLEND     = &H00000020???

'/*
' * Supports alpha information in the pixel format.  The bit depth of alpha
' * information in the pixel format can be 1,2,4, or 8.  The alpha value becomes
' * more opaque as the alpha value increases.  (0 is transparent.)
' * For Overlays.
' */
%DDFXALPHACAPS_OVERLAYALPHAPIXELS        = &H00000040???

'/*
' * Supports alpha information in the pixel format.  The bit depth of alpha
' * information in the pixel format can be 1,2,4, or 8.  The alpha value
' * becomes more transparent as the alpha value increases.  (0 is opaque.)
' * This flag can only be set if DDCAPS_ALPHA is set.
' * For Overlays.
' */
%DDFXALPHACAPS_OVERLAYALPHAPIXELSNEG     = &H00000080???

'/*
' * Supports alpha only surfaces.  The bit depth of an alpha only surface can be
' * 1,2,4, or 8.  The alpha value becomes more opaque as the alpha value increases.
' * (0 is transparent.)
' * For Overlays.
' */
%DDFXALPHACAPS_OVERLAYALPHASURFACES      = &H00000100???

'/*
' * The depth of the alpha channel data can range can be 1,2,4, or 8.
' * The NEG suffix indicates that this alpha channel becomes more transparent
' * as the alpha value increases. (0 is opaque.)  This flag can only be set if
' * DDCAPS_ALPHA is set.
' * For Overlays.
' */
%DDFXALPHACAPS_OVERLAYALPHASURFACESNEG   = &H00000200???

'#if DIRECTDRAW_VERSION < = &H0600
'#endif  //DIRECTDRAW_VERSION


'/****************************************************************************
' *
' * DIRECTDRAW FX CAPABILITY FLAGS
' *
' ****************************************************************************/

'/*
' * Uses arithmetic operations to stretch and shrink surfaces during blt
' * rather than pixel doubling techniques.  Along the Y axis.
' */
%DDFXCAPS_BLTARITHSTRETCHY       = &H00000020???

'/*
' * Uses arithmetic operations to stretch during blt
' * rather than pixel doubling techniques.  Along the Y axis. Only
' * works for x1, x2, etc.
' */
%DDFXCAPS_BLTARITHSTRETCHYN      = &H00000010???

'/*
' * Supports mirroring left to right in blt.
' */
%DDFXCAPS_BLTMIRRORLEFTRIGHT     = &H00000040???

'/*
' * Supports mirroring top to bottom in blt.
' */
%DDFXCAPS_BLTMIRRORUPDOWN        = &H00000080???

'/*
' * Supports arbitrary rotation for blts.
' */
%DDFXCAPS_BLTROTATION            = &H00000100???

'/*
' * Supports 90 degree rotations for blts.
' */
%DDFXCAPS_BLTROTATION90          = &H00000200???

'/*
' * DirectDraw supports arbitrary shrinking of a surface along the
' * x axis (horizontal direction) for blts.
' */
%DDFXCAPS_BLTSHRINKX             = &H00000400???

'/*
' * DirectDraw supports integer shrinking (1x,2x,) of a surface
' * along the x axis (horizontal direction) for blts.
' */
%DDFXCAPS_BLTSHRINKXN            = &H00000800???

'/*
' * DirectDraw supports arbitrary shrinking of a surface along the
' * y axis (horizontal direction) for blts.
' */
%DDFXCAPS_BLTSHRINKY             = &H00001000???

'/*
' * DirectDraw supports integer shrinking (1x,2x,) of a surface
' * along the y axis (vertical direction) for blts.
' */
%DDFXCAPS_BLTSHRINKYN            = &H00002000???

'/*
' * DirectDraw supports arbitrary stretching of a surface along the
' * x axis (horizontal direction) for blts.
' */
%DDFXCAPS_BLTSTRETCHX            = &H00004000???

'/*
' * DirectDraw supports integer stretching (1x,2x,) of a surface
' * along the x axis (horizontal direction) for blts.
' */
%DDFXCAPS_BLTSTRETCHXN           = &H00008000???

'/*
' * DirectDraw supports arbitrary stretching of a surface along the
' * y axis (horizontal direction) for blts.
' */
%DDFXCAPS_BLTSTRETCHY            = &H00010000???

'/*
' * DirectDraw supports integer stretching (1x,2x,) of a surface
' * along the y axis (vertical direction) for blts.
' */
%DDFXCAPS_BLTSTRETCHYN           = &H00020000???

'/*
' * Uses arithmetic operations to stretch and shrink surfaces during
' * overlay rather than pixel doubling techniques.  Along the Y axis
' * for overlays.
' */
%DDFXCAPS_OVERLAYARITHSTRETCHY   = &H00040000???

'/*
' * Uses arithmetic operations to stretch surfaces during
' * overlay rather than pixel doubling techniques.  Along the Y axis
' * for overlays. Only works for x1, x2, etc.
' */
%DDFXCAPS_OVERLAYARITHSTRETCHYN  = &H00000008???

'/*
' * DirectDraw supports arbitrary shrinking of a surface along the
' * x axis (horizontal direction) for overlays.
' */
%DDFXCAPS_OVERLAYSHRINKX         = &H00080000???

'/*
' * DirectDraw supports integer shrinking (1x,2x,) of a surface
' * along the x axis (horizontal direction) for overlays.
' */
%DDFXCAPS_OVERLAYSHRINKXN        = &H00100000???

'/*
' * DirectDraw supports arbitrary shrinking of a surface along the
' * y axis (horizontal direction) for overlays.
' */
%DDFXCAPS_OVERLAYSHRINKY         = &H00200000???

'/*
' * DirectDraw supports integer shrinking (1x,2x,) of a surface
' * along the y axis (vertical direction) for overlays.
' */
%DDFXCAPS_OVERLAYSHRINKYN        = &H00400000???

'/*
' * DirectDraw supports arbitrary stretching of a surface along the
' * x axis (horizontal direction) for overlays.
' */
%DDFXCAPS_OVERLAYSTRETCHX        = &H00800000???

'/*
' * DirectDraw supports integer stretching (1x,2x,) of a surface
' * along the x axis (horizontal direction) for overlays.
' */
%DDFXCAPS_OVERLAYSTRETCHXN       = &H01000000???

'/*
' * DirectDraw supports arbitrary stretching of a surface along the
' * y axis (horizontal direction) for overlays.
' */
%DDFXCAPS_OVERLAYSTRETCHY        = &H02000000???

'/*
' * DirectDraw supports integer stretching (1x,2x,) of a surface
' * along the y axis (vertical direction) for overlays.
' */
%DDFXCAPS_OVERLAYSTRETCHYN       = &H04000000???

'/*
' * DirectDraw supports mirroring of overlays across the vertical axis
' */
%DDFXCAPS_OVERLAYMIRRORLEFTRIGHT = &H08000000???

'/*
' * DirectDraw supports mirroring of overlays across the horizontal axis
' */
%DDFXCAPS_OVERLAYMIRRORUPDOWN    = &H10000000???

'/*
' * DirectDraw supports deinterlacing of overlay surfaces
' */
%DDFXCAPS_OVERLAYDEINTERLACE      = &H20000000???

'/*
' * Driver can do alpha blending for blits.
' */
%DDFXCAPS_BLTALPHA               = &H00000001???


'/*
' * Driver can do surface-reconstruction filtering for warped blits.
' */
%DDFXCAPS_BLTFILTER              = %DDFXCAPS_BLTARITHSTRETCHY

'/*
' * Driver can do alpha blending for overlays.
' */
%DDFXCAPS_OVERLAYALPHA           = &H00000004???


'/*
' * Driver can do surface-reconstruction filtering for warped overlays.
' */
%DDFXCAPS_OVERLAYFILTER          = %DDFXCAPS_OVERLAYARITHSTRETCHY

'/****************************************************************************
' *
' * DIRECTDRAW STEREO VIEW CAPABILITIES
' *
' ****************************************************************************/

'/*
' * This flag used to be DDSVCAPS_ENIGMA, which is now obsolete
' */

%DDSVCAPS_RESERVED1              = &H00000001???

'/*
' * This flag used to be DDSVCAPS_FLICKER, which is now obsolete
' */
%DDSVCAPS_RESERVED2              = &H00000002???

'/*
' * This flag used to be DDSVCAPS_REDBLUE, which is now obsolete
' */
%DDSVCAPS_RESERVED3              = &H00000004???

'/*
' * This flag used to be DDSVCAPS_SPLIT, which is now obsolete
' */
%DDSVCAPS_RESERVED4              = &H00000008???

'/*
' * The stereo view is accomplished with switching technology
' */

%DDSVCAPS_STEREOSEQUENTIAL       = &H00000010???



'/****************************************************************************
' *
' * DIRECTDRAWPALETTE CAPABILITIES
' *
' ****************************************************************************/

'/*
' * Index is 4 bits.  There are sixteen color entries in the palette table.
' */
%DDPCAPS_4BIT                    = &H00000001???

'/*
' * Index is onto a 8 bit color index.  This field is only valid with the
' * DDPCAPS_1BIT, DDPCAPS_2BIT or DDPCAPS_4BIT capability and the target
' * surface is in 8bpp. Each color entry is one byte long and is an index
' * into destination surface's 8bpp palette.
' */
%DDPCAPS_8BITENTRIES             = &H00000002???

'/*
' * Index is 8 bits.  There are 256 color entries in the palette table.
' */
%DDPCAPS_8BIT                    = &H00000004???

'/*
' * Indicates that this DIRECTDRAWPALETTE should use the palette color array
' * passed into the lpDDColorArray parameter to initialize the DIRECTDRAWPALETTE
' * object.
' * This flag is obsolete. DirectDraw always initializes the color array from
' * the lpDDColorArray parameter. The definition remains for source-level
' * compatibility.
' */
%DDPCAPS_INITIALIZE              = &H00000000???

'/*
' * This palette is the one attached to the primary surface.  Changing this
' * table has immediate effect on the display unless DDPSETPAL_VSYNC is specified
' * and supported.
' */
%DDPCAPS_PRIMARYSURFACE          = &H00000010???

'/*
' * This palette is the one attached to the primary surface left.  Changing
' * this table has immediate effect on the display for the left eye unless
' * DDPSETPAL_VSYNC is specified and supported.
' */
%DDPCAPS_PRIMARYSURFACELEFT      = &H00000020???

'/*
' * This palette can have all 256 entries defined
' */
%DDPCAPS_ALLOW256                = &H00000040???

'/*
' * This palette can have modifications to it synced with the monitors
' * refresh rate.
' */
%DDPCAPS_VSYNC                   = &H00000080???

'/*
' * Index is 1 bit.  There are two color entries in the palette table.
' */
%DDPCAPS_1BIT                    = &H00000100???

'/*
' * Index is 2 bit.  There are four color entries in the palette table.
' */
%DDPCAPS_2BIT                    = &H00000200???

'/*
' * The peFlags member of PALETTEENTRY denotes an 8 bit alpha value
' */
%DDPCAPS_ALPHA                   = &H00000400???


'/****************************************************************************
' *
' * DIRECTDRAWPALETTE SETENTRY CONSTANTS
' *
' ****************************************************************************/


'/****************************************************************************
' *
' * DIRECTDRAWPALETTE GETENTRY CONSTANTS
' *
' ****************************************************************************/

'/* 0 is the only legal value */

'/****************************************************************************
' *
' * DIRECTDRAWSURFACE SETPRIVATEDATA CONSTANTS
' *
' ****************************************************************************/

'/*
' * The passed pointer is an IUnknown ptr. The cbData argument to SetPrivateData
' * must be set to sizeof(IUnknown*). DirectDraw will call AddRef through this
' * pointer and Release when the private data is destroyed. This includes when
' * the surface or palette is destroyed before such priovate data is destroyed.
' */
%DDSPD_IUNKNOWNPOINTER           = &H00000001???

'/*
' * Private data is only valid for the current state of the object,
' * as determined by the uniqueness value.
' */
%DDSPD_VOLATILE                  = &H00000002???


'/****************************************************************************
' *
' * DIRECTDRAWSURFACE SETPALETTE CONSTANTS
' *
' ****************************************************************************/


'/****************************************************************************
' *
' * DIRECTDRAW BITDEPTH CONSTANTS
' *
' * NOTE:  These are only used to indicate supported bit depths.   These
' * are flags only, they are not to be used as an actual bit depth.   The
' * absolute numbers 1, 2, 4, 8, 16, 24 and 32 are used to indicate actual
' * bit depths in a surface or for changing the display mode.
' *
' ****************************************************************************/

'/*
' * 1 bit per pixel.
' */
%DDBD_1                  = &H00004000???

'/*
' * 2 bits per pixel.
' */
%DDBD_2                  = &H00002000???

'/*
' * 4 bits per pixel.
' */
%DDBD_4                  = &H00001000???

'/*
' * 8 bits per pixel.
' */
%DDBD_8                  = &H00000800???

'/*
' * 16 bits per pixel.
' */
%DDBD_16                 = &H00000400???

'/*
' * 24 bits per pixel.
' */
%DDBD_24                 = &H00000200???

'/*
' * 32 bits per pixel.
' */
%DDBD_32                 = &H00000100???

'/****************************************************************************
' *
' * DIRECTDRAWSURFACE SET/GET COLOR KEY FLAGS
' *
' ****************************************************************************/

'/*
' * Set if the structure contains a color space.  Not set if the structure
' * contains a single color key.
' */
%DDCKEY_COLORSPACE       = &H00000001???

'/*
' * Set if the structure specifies a color key or color space which is to be
' * used as a destination color key for blt operations.
' */
%DDCKEY_DESTBLT          = &H00000002???

'/*
' * Set if the structure specifies a color key or color space which is to be
' * used as a destination color key for overlay operations.
' */
%DDCKEY_DESTOVERLAY      = &H00000004???

'/*
' * Set if the structure specifies a color key or color space which is to be
' * used as a source color key for blt operations.
' */
%DDCKEY_SRCBLT           = &H00000008???

'/*
' * Set if the structure specifies a color key or color space which is to be
' * used as a source color key for overlay operations.
' */
%DDCKEY_SRCOVERLAY       = &H00000010???


'/****************************************************************************
' *
' * DIRECTDRAW COLOR KEY CAPABILITY FLAGS
' *
' ****************************************************************************/

'/*
' * Supports transparent blting using a color key to identify the replaceable
' * bits of the destination surface for RGB colors.
' */
%DDCKEYCAPS_DESTBLT                      = &H00000001???

'/*
' * Supports transparent blting using a color space to identify the replaceable
' * bits of the destination surface for RGB colors.
' */
%DDCKEYCAPS_DESTBLTCLRSPACE              = &H00000002???

'/*
' * Supports transparent blting using a color space to identify the replaceable
' * bits of the destination surface for YUV colors.
' */
%DDCKEYCAPS_DESTBLTCLRSPACEYUV           = &H00000004???

'/*
' * Supports transparent blting using a color key to identify the replaceable
' * bits of the destination surface for YUV colors.
' */
%DDCKEYCAPS_DESTBLTYUV                   = &H00000008???

'/*
' * Supports overlaying using colorkeying of the replaceable bits of the surface
' * being overlayed for RGB colors.
' */
%DDCKEYCAPS_DESTOVERLAY                  = &H00000010???

'/*
' * Supports a color space as the color key for the destination for RGB colors.
' */
%DDCKEYCAPS_DESTOVERLAYCLRSPACE          = &H00000020???

'/*
' * Supports a color space as the color key for the destination for YUV colors.
' */
%DDCKEYCAPS_DESTOVERLAYCLRSPACEYUV       = &H00000040???

'/*
' * Supports only one active destination color key value for visible overlay
' * surfaces.
' */
%DDCKEYCAPS_DESTOVERLAYONEACTIVE         = &H00000080???

'/*
' * Supports overlaying using colorkeying of the replaceable bits of the
' * surface being overlayed for YUV colors.
' */
%DDCKEYCAPS_DESTOVERLAYYUV               = &H00000100???

'/*
' * Supports transparent blting using the color key for the source with
' * this surface for RGB colors.
' */
%DDCKEYCAPS_SRCBLT                       = &H00000200???

'/*
' * Supports transparent blting using a color space for the source with
' * this surface for RGB colors.
' */
%DDCKEYCAPS_SRCBLTCLRSPACE               = &H00000400???

'/*
' * Supports transparent blting using a color space for the source with
' * this surface for YUV colors.
' */
%DDCKEYCAPS_SRCBLTCLRSPACEYUV            = &H00000800???

'/*
' * Supports transparent blting using the color key for the source with
' * this surface for YUV colors.
' */
%DDCKEYCAPS_SRCBLTYUV                    = &H00001000???

'/*
' * Supports overlays using the color key for the source with this
' * overlay surface for RGB colors.
' */
%DDCKEYCAPS_SRCOVERLAY                   = &H00002000???

'/*
' * Supports overlays using a color space as the source color key for
' * the overlay surface for RGB colors.
' */
%DDCKEYCAPS_SRCOVERLAYCLRSPACE           = &H00004000???

'/*
' * Supports overlays using a color space as the source color key for
' * the overlay surface for YUV colors.
' */
%DDCKEYCAPS_SRCOVERLAYCLRSPACEYUV        = &H00008000???

'/*
' * Supports only one active source color key value for visible
' * overlay surfaces.
' */
%DDCKEYCAPS_SRCOVERLAYONEACTIVE          = &H00010000???

'/*
' * Supports overlays using the color key for the source with this
' * overlay surface for YUV colors.
' */
%DDCKEYCAPS_SRCOVERLAYYUV                = &H00020000???

'/*
' * there are no bandwidth trade-offs for using colorkey with an overlay
' */
%DDCKEYCAPS_NOCOSTOVERLAY                = &H00040000???


'/****************************************************************************
' *
' * DIRECTDRAW PIXELFORMAT FLAGS
' *
' ****************************************************************************/

'/*
' * The surface has alpha channel information in the pixel format.
' */
%DDPF_ALPHAPIXELS                        = &H00000001???

'/*
' * The pixel format contains alpha only information
' */
%DDPF_ALPHA                              = &H00000002???

'/*
' * The FourCC code is valid.
' */
%DDPF_FOURCC                             = &H00000004???

'/*
' * The surface is 4-bit color indexed.
' */
%DDPF_PALETTEINDEXED4                    = &H00000008???

'/*
' * The surface is indexed into a palette which stores indices
' * into the destination surface's 8-bit palette.
' */
%DDPF_PALETTEINDEXEDTO8                  = &H00000010???

'/*
' * The surface is 8-bit color indexed.
' */
%DDPF_PALETTEINDEXED8                    = &H00000020???

'/*
' * The RGB data in the pixel format structure is valid.
' */
%DDPF_RGB                                = &H00000040???

'/*
' * The surface will accept pixel data in the format specified
' * and compress it during the write.
' */
%DDPF_COMPRESSED                         = &H00000080???

'/*
' * The surface will accept RGB data and translate it during
' * the write to YUV data.  The format of the data to be written
' * will be contained in the pixel format structure.  The DDPF_RGB
' * flag will be set.
' */
%DDPF_RGBTOYUV                           = &H00000100???

'/*
' * pixel format is YUV - YUV data in pixel format struct is valid
' */
%DDPF_YUV                                = &H00000200???

'/*
' * pixel format is a z buffer only surface
' */
%DDPF_ZBUFFER                            = &H00000400???

'/*
' * The surface is 1-bit color indexed.
' */
%DDPF_PALETTEINDEXED1                    = &H00000800???

'/*
' * The surface is 2-bit color indexed.
' */
%DDPF_PALETTEINDEXED2                    = &H00001000???

'/*
' * The surface contains Z information in the pixels
' */
%DDPF_ZPIXELS                            = &H00002000???

'/*
' * The surface contains stencil information along with Z
' */
%DDPF_STENCILBUFFER                      = &H00004000???

'/*
' * Premultiplied alpha format -- the color components have been
' * premultiplied by the alpha component.
' */
%DDPF_ALPHAPREMULT                       = &H00008000???


'/*
' * Luminance data in the pixel format is valid.
' * Use this flag for luminance-only or luminance+alpha surfaces,
' * the bit depth is then ddpf.dwLuminanceBitCount.
' */
%DDPF_LUMINANCE                          = &H00020000???

'/*
' * Luminance data in the pixel format is valid.
' * Use this flag when hanging luminance off bumpmap surfaces,
' * the bit mask for the luminance portion of the pixel is then
' * ddpf.dwBumpLuminanceBitMask
' */
%DDPF_BUMPLUMINANCE                      = &H00040000???

'/*
' * Bump map dUdV data in the pixel format is valid.
' */
%DDPF_BUMPDUDV                           = &H00080000???


'/*===========================================================================
' *
' *
' * DIRECTDRAW CALLBACK FLAGS
' *
' *
' *==========================================================================*/

'/****************************************************************************
' *
' * DIRECTDRAW ENUMSURFACES FLAGS
' *
' ****************************************************************************/

'/*
' * Enumerate all of the surfaces that meet the search criterion.
' */
%DDENUMSURFACES_ALL                      = &H00000001???

'/*
' * A search hit is a surface that matches the surface description.
' */
%DDENUMSURFACES_MATCH                    = &H00000002???

'/*
' * A search hit is a surface that does not match the surface description.
' */
%DDENUMSURFACES_NOMATCH                  = &H00000004???

'/*
' * Enumerate the first surface that can be created which meets the search criterion.
' */
%DDENUMSURFACES_CANBECREATED             = &H00000008???

'/*
' * Enumerate the surfaces that already exist that meet the search criterion.
' */
%DDENUMSURFACES_DOESEXIST                = &H00000010???


'/****************************************************************************
' *
' * DIRECTDRAW SETDISPLAYMODE FLAGS
' *
' ****************************************************************************/

'/*
' * The desired mode is a standard VGA mode
' */
%DDSDM_STANDARDVGAMODE                   = &H00000001???


'/****************************************************************************
' *
' * DIRECTDRAW ENUMDISPLAYMODES FLAGS
' *
' ****************************************************************************/

'/*
' * Enumerate Modes with different refresh rates.  EnumDisplayModes guarantees
' * that a particular mode will be enumerated only once.  This flag specifies whether
' * the refresh rate is taken into account when determining if a mode is unique.
' */
%DDEDM_REFRESHRATES                      = &H00000001???

'/*
' * Enumerate VGA modes. Specify this flag if you wish to enumerate supported VGA
' * modes such as mode = &H13 in addition to the usual ModeX modes (which are always
' * enumerated if the application has previously called SetCooperativeLevel with the
' * DDSCL_ALLOWMODEX flag set).
' */
%DDEDM_STANDARDVGAMODES                  = &H00000002???


'/****************************************************************************
' *
' * DIRECTDRAW SETCOOPERATIVELEVEL FLAGS
' *
' ****************************************************************************/

'/*
' * Exclusive mode owner will be responsible for the entire primary surface.
' * GDI can be ignored. used with DD
' */
%DDSCL_FULLSCREEN                        = &H00000001???

'/*
' * allow CTRL_ALT_DEL to work while in fullscreen exclusive mode
' */
%DDSCL_ALLOWREBOOT                       = &H00000002???

'/*
' * prevents DDRAW from modifying the application window.
' * prevents DDRAW from minimize/restore the application window on activation.
' */
%DDSCL_NOWINDOWCHANGES                   = &H00000004???

'/*
' * app wants to work as a regular Windows application
' */
%DDSCL_NORMAL                            = &H00000008???

'/*
' * app wants exclusive access
' */
%DDSCL_EXCLUSIVE                         = &H00000010???


'/*
' * app can deal with non-windows display modes
' */
%DDSCL_ALLOWMODEX                        = &H00000040???

'/*
' * this window will receive the focus messages
' */
%DDSCL_SETFOCUSWINDOW                    = &H00000080???

'/*
' * this window is associated with the DDRAW object and will
' * cover the screen in fullscreen mode
' */
%DDSCL_SETDEVICEWINDOW                   = &H00000100???

'/*
' * app wants DDRAW to create a window to be associated with the
' * DDRAW object
' */
%DDSCL_CREATEDEVICEWINDOW                = &H00000200???

'/*
' * App explicitly asks DDRAW/D3D to be multithread safe. This makes D3D
' * take the global crtisec more frequently.
' */
%DDSCL_MULTITHREADED                     = &H00000400???

'/*
' * App specifies that it would like to keep the FPU set up for optimal Direct3D
' * performance (single precision and exceptions disabled) so Direct3D
' * does not need to explicitly set the FPU each time. This is assumed by
' * default in DirectX 7. See also DDSCL_FPUPRESERVE
' */
%DDSCL_FPUSETUP                          = &H00000800???

'/*
' * App specifies that it needs either double precision FPU or FPU exceptions
' * enabled. This makes Direct3D explicitly set the FPU state eah time it is
' * called. Setting the flag will reduce Direct3D performance. The flag is
' * assumed by default in DirectX 6 and earlier. See also DDSCL_FPUSETUP
' */
%DDSCL_FPUPRESERVE                       = &H00001000???


'/****************************************************************************
' *
' * DIRECTDRAW BLT FLAGS
' *
' ****************************************************************************/

'/*
' * Use the alpha information in the pixel format or the alpha channel surface
' * attached to the destination surface as the alpha channel for this blt.
' */
%DDBLT_ALPHADEST                         = &H00000001???

'/*
' * Use the dwConstAlphaDest field in the DDBLTFX structure as the alpha channel
' * for the destination surface for this blt.
' */
%DDBLT_ALPHADESTCONSTOVERRIDE            = &H00000002???

'/*
' * The NEG suffix indicates that the destination surface becomes more
' * transparent as the alpha value increases. (0 is opaque)
' */
%DDBLT_ALPHADESTNEG                      = &H00000004???

'/*
' * Use the lpDDSAlphaDest field in the DDBLTFX structure as the alpha
' * channel for the destination for this blt.
' */
%DDBLT_ALPHADESTSURFACEOVERRIDE          = &H00000008???

'/*
' * Use the dwAlphaEdgeBlend field in the DDBLTFX structure as the alpha channel
' * for the edges of the image that border the color key colors.
' */
%DDBLT_ALPHAEDGEBLEND                    = &H00000010???

'/*
' * Use the alpha information in the pixel format or the alpha channel surface
' * attached to the source surface as the alpha channel for this blt.
' */
%DDBLT_ALPHASRC                          = &H00000020???

'/*
' * Use the dwConstAlphaSrc field in the DDBLTFX structure as the alpha channel
' * for the source for this blt.
' */
%DDBLT_ALPHASRCCONSTOVERRIDE             = &H00000040???

'/*
' * The NEG suffix indicates that the source surface becomes more transparent
' * as the alpha value increases. (0 is opaque)
' */
%DDBLT_ALPHASRCNEG                       = &H00000080???

'/*
' * Use the lpDDSAlphaSrc field in the DDBLTFX structure as the alpha channel
' * for the source for this blt.
' */
%DDBLT_ALPHASRCSURFACEOVERRIDE           = &H00000100???

'/*
' * Do this blt asynchronously through the FIFO in the order received.  If
' * there is no room in the hardware FIFO fail the call.
' */
%DDBLT_ASYNC                             = &H00000200???

'/*
' * Uses the dwFillColor field in the DDBLTFX structure as the RGB color
' * to fill the destination rectangle on the destination surface with.
' */
%DDBLT_COLORFILL                         = &H00000400???

'/*
' * Uses the dwDDFX field in the DDBLTFX structure to specify the effects
' * to use for the blt.
' */
%DDBLT_DDFX                              = &H00000800???

'/*
' * Uses the dwDDROPS field in the DDBLTFX structure to specify the ROPS
' * that are not part of the Win32 API.
' */
%DDBLT_DDROPS                            = &H00001000???

'/*
' * Use the color key associated with the destination surface.
' */
%DDBLT_KEYDEST                           = &H00002000???

'/*
' * Use the dckDestColorkey field in the DDBLTFX structure as the color key
' * for the destination surface.
' */
%DDBLT_KEYDESTOVERRIDE                   = &H00004000???

'/*
' * Use the color key associated with the source surface.
' */
%DDBLT_KEYSRC                            = &H00008000???

'/*
' * Use the dckSrcColorkey field in the DDBLTFX structure as the color key
' * for the source surface.
' */
%DDBLT_KEYSRCOVERRIDE                    = &H00010000???

'/*
' * Use the dwROP field in the DDBLTFX structure for the raster operation
' * for this blt.  These ROPs are the same as the ones defined in the Win32 API.
' */
%DDBLT_ROP                               = &H00020000???

'/*
' * Use the dwRotationAngle field in the DDBLTFX structure as the angle
' * (specified in 1/100th of a degree) to rotate the surface.
' */
%DDBLT_ROTATIONANGLE                     = &H00040000???

'/*
' * Z-buffered blt using the z-buffers attached to the source and destination
' * surfaces and the dwZBufferOpCode field in the DDBLTFX structure as the
' * z-buffer opcode.
' */
%DDBLT_ZBUFFER                           = &H00080000???

'/*
' * Z-buffered blt using the dwConstDest Zfield and the dwZBufferOpCode field
' * in the DDBLTFX structure as the z-buffer and z-buffer opcode respectively
' * for the destination.
' */
%DDBLT_ZBUFFERDESTCONSTOVERRIDE          = &H00100000???

'/*
' * Z-buffered blt using the lpDDSDestZBuffer field and the dwZBufferOpCode
' * field in the DDBLTFX structure as the z-buffer and z-buffer opcode
' * respectively for the destination.
' */
%DDBLT_ZBUFFERDESTOVERRIDE               = &H00200000???

'/*
' * Z-buffered blt using the dwConstSrcZ field and the dwZBufferOpCode field
' * in the DDBLTFX structure as the z-buffer and z-buffer opcode respectively
' * for the source.
' */
%DDBLT_ZBUFFERSRCCONSTOVERRIDE           = &H00400000???

'/*
' * Z-buffered blt using the lpDDSSrcZBuffer field and the dwZBufferOpCode
' * field in the DDBLTFX structure as the z-buffer and z-buffer opcode
' * respectively for the source.
' */
%DDBLT_ZBUFFERSRCOVERRIDE                = &H00800000???

'/*
' * wait until the device is ready to handle the blt
' * this will cause blt to not return DDERR_WASSTILLDRAWING
' */
%DDBLT_WAIT                              = &H01000000???

'/*
' * Uses the dwFillDepth field in the DDBLTFX structure as the depth value
' * to fill the destination rectangle on the destination Z-buffer surface
' * with.
' */
%DDBLT_DEPTHFILL                         = &H02000000???


'/*
' * Return immediately (with DDERR_WASSTILLDRAWING) if the device is not
' * ready to schedule the blt at the time Blt() is called.
' */
%DDBLT_DONOTWAIT                         = &H08000000???

'/*
' * These flags indicate a presentation blt (i.e. a blt
' * that moves surface contents from an offscreen back buffer to the primary
' * surface). The driver is not allowed to "queue"  more than three such blts.
' * The "end" of the presentation blt is indicated, since the
' * blt may be clipped, in which case the runtime will call the driver with
' * several blts. All blts (even if not clipped) are tagged with DDBLT_PRESENTATION
' * and the last (even if not clipped) additionally with DDBLT_LAST_PRESENTATION.
' * Thus the true rule is that the driver must not schedule a DDBLT_PRESENTATION
' * blt if there are 3 or more DDBLT_PRESENTLAST blts in the hardware pipe.
' * If there are such blts in the pipe, the driver should return DDERR_WASSTILLDRAWING
' * until the oldest queued DDBLT_LAST_PRESENTATION blts has been retired (i.e. the
' * pixels have been actually written to the primary surface). Once the oldest blt
' * has been retired, the driver is free to schedule the current blt.
' * The goal is to provide a mechanism whereby the device's hardware queue never
' * gets more than 3 frames ahead of the frames being generated by the application.
' * When excessive queueing occurs, applications become unusable because the application
' * visibly lags user input, and such problems make windowed interactive applications impossible.
' * Some drivers may not have sufficient knowledge of their hardware's FIFO to know
' * when a certain blt has been retired. Such drivers should code cautiously, and
' * simply not allow any frames to be queued at all. DDBLT_LAST_PRESENTATION should cause
' * such drivers to return DDERR_WASSTILLDRAWING until the accelerator is completely
' * finished- exactly as if the application had called Lock on the source surface
' * before calling Blt.
' * In other words, the driver is allowed and encouraged to
' * generate as much latency as it can, but never more than 3 frames worth.
' * Implementation detail: Drivers should count blts against the SOURCE surface, not
' * against the primary surface. This enables multiple parallel windowed application
' * to function more optimally.
' * This flag is passed only to DX8 or higher drivers.
' *
' * APPLICATIONS DO NOT SET THESE FLAGS. THEY ARE SET BY THE DIRECTDRAW RUNTIME.
' *
' */
%DDBLT_PRESENTATION                      = &H10000000???
%DDBLT_LAST_PRESENTATION                 = &H20000000???

'/*
' * If DDBLT_EXTENDED_FLAGS is set, then the driver should re-interpret
' * other flags according to the definitions that follow.
' * For example, bit 0 (= &H00000001L) means DDBLT_ALPHADEST, unless
' * DDBLT_EXTENDED_FLAGS is also set, in which case bit 0 means
' * DDBLT_EXTENDED_LINEAR_CONTENT.
' * Only DirectX9 and higher drivers will be given extended blt flags.
' * Only flags explicitly mentioned here should be re-interpreted.
' * All other flags retain their original meanings.
' *
' * List of re-interpreted flags:
' *
' * Bit Hex value   New meaning                                  old meaning
' * ---------------------------------------------------------------
' *  2  = &H00000004  DDBLT_EXTENDED_LINEAR_CONTENT                DDBLT_ALPHADESTNEG
' *  4  = &H00000010  DDBLT_EXTENDED_PRESENTATION_STRETCHFACTOR    DDBLT_ALPHAEDGEBLEND
' *
' *
' * NOTE: APPLICATIONS SHOULD NOT SET THIS FLAG. THIS FLAG IS INTENDED
' * FOR USE BY THE DIRECT3D RUNTIME.
' */
%DDBLT_EXTENDED_FLAGS                    = &H40000000???

'/*
' * EXTENDED FLAG. SEE DEFINITION OF DDBLT_EXTENDED_FLAGS.
' * This flag indidcates that the source surface contains content in a
' * linear color space. The driver may perform gamma correction to the
' * desktop color space (i.e. sRGB, gamma 2.2) as part of this blt.
' * If the device can perform such a conversion as part of the copy,
' * the driver should also set D3DCAPS3_LINEAR_TO_SRGB_PRESENTATION
' *
' * NOTE: APPLICATIONS SHOULD NOT SET THIS FLAG. THIS FLAG IS INTENDED
' * FOR USE BY THE DIRECT3D RUNTIME. Use IDirect3DSwapChain9::Present
' * and specify D3DPRESENT_LINEAR_CONTENT in order to use this functionality.
' */
%DDBLT_EXTENDED_LINEAR_CONTENT           = &H00000004???


'/****************************************************************************
' *
' * BLTFAST FLAGS
' *
' ****************************************************************************/

%DDBLTFAST_NOCOLORKEY                    = &H00000000
%DDBLTFAST_SRCCOLORKEY                   = &H00000001
%DDBLTFAST_DESTCOLORKEY                  = &H00000002
%DDBLTFAST_WAIT                          = &H00000010
%DDBLTFAST_DONOTWAIT                     = &H00000020

'/****************************************************************************
' *
' * FLIP FLAGS
' *
' ****************************************************************************/

%DDFLIP_WAIT                          = &H00000001???

'/*
' * Indicates that the target surface contains the even field of video data.
' * This flag is only valid with an overlay surface.
' */
%DDFLIP_EVEN                          = &H00000002???

'/*
' * Indicates that the target surface contains the odd field of video data.
' * This flag is only valid with an overlay surface.
' */
%DDFLIP_ODD                           = &H00000004???

'/*
' * Causes DirectDraw to perform the physical flip immediately and return
' * to the application. Typically, what was the front buffer but is now the back
' * buffer will still be visible (depending on timing) until the next vertical
' * retrace. Subsequent operations involving the two flipped surfaces will
' * not check to see if the physical flip has finished (i.e. will not return
' * DDERR_WASSTILLDRAWING for that reason (but may for other reasons)).
' * This allows an application to perform Flips at a higher frequency than the
' * monitor refresh rate, but may introduce visible artifacts.
' * Only effective if DDCAPS2_FLIPNOVSYNC is set. If that bit is not set,
' * DDFLIP_NOVSYNC has no effect.
' */
%DDFLIP_NOVSYNC                       = &H00000008???


'/*
' * Flip Interval Flags. These flags indicate how many vertical retraces to wait between
' * each flip. The default is one. DirectDraw will return DDERR_WASSTILLDRAWING for each
' * surface involved in the flip until the specified number of vertical retraces has
' * ocurred. Only effective if DDCAPS2_FLIPINTERVAL is set. If that bit is not set,
' * DDFLIP_INTERVALn has no effect.
' */

'/*
' * DirectDraw will flip on every other vertical sync
' */
%DDFLIP_INTERVAL2                     = &H02000000???


'/*
' * DirectDraw will flip on every third vertical sync
' */
%DDFLIP_INTERVAL3                     = &H03000000???


'/*
' * DirectDraw will flip on every fourth vertical sync
' */
%DDFLIP_INTERVAL4                     = &H04000000???

'/*
' * DirectDraw will flip and display a main stereo surface
' */
%DDFLIP_STEREO                        = &H00000010???

'/*
' * On IDirectDrawSurface7 and higher interfaces, the default is DDFLIP_WAIT. If you wish
' * to override the default and use time when the accelerator is busy (as denoted by
' * the DDERR_WASSTILLDRAWING return code) then use DDFLIP_DONOTWAIT.
' */
%DDFLIP_DONOTWAIT                     = &H00000020???


'/****************************************************************************
' *
' * DIRECTDRAW SURFACE OVERLAY FLAGS
' *
' ****************************************************************************/

'/*
' * Use the alpha information in the pixel format or the alpha channel surface
' * attached to the destination surface as the alpha channel for the
' * destination overlay.
' */
%DDOVER_ALPHADEST                        = &H00000001???

'/*
' * Use the dwConstAlphaDest field in the DDOVERLAYFX structure as the
' * destination alpha channel for this overlay.
' */
%DDOVER_ALPHADESTCONSTOVERRIDE           = &H00000002???

'/*
' * The NEG suffix indicates that the destination surface becomes more
' * transparent as the alpha value increases.
' */
%DDOVER_ALPHADESTNEG                     = &H00000004???

'/*
' * Use the lpDDSAlphaDest field in the DDOVERLAYFX structure as the alpha
' * channel destination for this overlay.
' */
%DDOVER_ALPHADESTSURFACEOVERRIDE         = &H00000008???

'/*
' * Use the dwAlphaEdgeBlend field in the DDOVERLAYFX structure as the alpha
' * channel for the edges of the image that border the color key colors.
' */
%DDOVER_ALPHAEDGEBLEND                   = &H00000010???

'/*
' * Use the alpha information in the pixel format or the alpha channel surface
' * attached to the source surface as the source alpha channel for this overlay.
' */
%DDOVER_ALPHASRC                         = &H00000020???

'/*
' * Use the dwConstAlphaSrc field in the DDOVERLAYFX structure as the source
' * alpha channel for this overlay.
' */
%DDOVER_ALPHASRCCONSTOVERRIDE            = &H00000040???

'/*
' * The NEG suffix indicates that the source surface becomes more transparent
' * as the alpha value increases.
' */
%DDOVER_ALPHASRCNEG                      = &H00000080???

'/*
' * Use the lpDDSAlphaSrc field in the DDOVERLAYFX structure as the alpha channel
' * source for this overlay.
' */
%DDOVER_ALPHASRCSURFACEOVERRIDE          = &H00000100???

'/*
' * Turn this overlay off.
' */
%DDOVER_HIDE                             = &H00000200???

'/*
' * Use the color key associated with the destination surface.
' */
%DDOVER_KEYDEST                          = &H00000400???

'/*
' * Use the dckDestColorkey field in the DDOVERLAYFX structure as the color key
' * for the destination surface
' */
%DDOVER_KEYDESTOVERRIDE                  = &H00000800???

'/*
' * Use the color key associated with the source surface.
' */
%DDOVER_KEYSRC                           = &H00001000???

'/*
' * Use the dckSrcColorkey field in the DDOVERLAYFX structure as the color key
' * for the source surface.
' */
%DDOVER_KEYSRCOVERRIDE                   = &H00002000???

'/*
' * Turn this overlay on.
' */
%DDOVER_SHOW                             = &H00004000???

'/*
' * Add a dirty rect to an emulated overlayed surface.
' */
%DDOVER_ADDDIRTYRECT                     = &H00008000???

'/*
' * Redraw all dirty rects on an emulated overlayed surface.
' */
%DDOVER_REFRESHDIRTYRECTS                = &H00010000???

'/*
' * Redraw the entire surface on an emulated overlayed surface.
' */
%DDOVER_REFRESHALL                       = &H00020000???


'/*
' * Use the overlay FX flags to define special overlay FX
' */
%DDOVER_DDFX                             = &H00080000???

'/*
' * Autoflip the overlay when ever the video port autoflips
' */
%DDOVER_AUTOFLIP                         = &H00100000???

'/*
' * Display each field of video port data individually without
' * causing any jittery artifacts
' */
%DDOVER_BOB                              = &H00200000???

'/*
' * Indicates that bob/weave decisions should not be overridden by other
' * interfaces.
' */
%DDOVER_OVERRIDEBOBWEAVE                 = &H00400000???

'/*
' * Indicates that the surface memory is composed of interleaved fields.
' */
%DDOVER_INTERLEAVED                      = &H00800000???

'/*
' * Indicates that bob will be performed using hardware rather than
' * software or emulated.
' */
%DDOVER_BOBHARDWARE                      = &H01000000???

'/*
' * Indicates that overlay FX structure contains valid ARGB scaling factors.
' */
%DDOVER_ARGBSCALEFACTORS                 = &H02000000???

'/*
' * Indicates that ARGB scaling factors can be degraded to fit driver capabilities.
' */
%DDOVER_DEGRADEARGBSCALING               = &H04000000???


'/****************************************************************************
' *
' * DIRECTDRAWSURFACE LOCK FLAGS
' *
' ****************************************************************************/

'/*
' * The default.  Set to indicate that Lock should return a valid memory pointer
' * to the top of the specified rectangle.  If no rectangle is specified then a
' * pointer to the top of the surface is returned.
' */
%DDLOCK_SURFACEMEMORYPTR                 = &H00000000???    ' // default

'/*
' * Set to indicate that Lock should wait until it can obtain a valid memory
' * pointer before returning.  If this bit is set, Lock will never return
' * DDERR_WASSTILLDRAWING.
' */
%DDLOCK_WAIT                             = &H00000001???

'/*
' * Set if an event handle is being passed to Lock.  Lock will trigger the event
' * when it can return the surface memory pointer requested.
' */
%DDLOCK_EVENT                            = &H00000002???

'/*
' * Indicates that the surface being locked will only be read from.
' */
%DDLOCK_READONLY                         = &H00000010???

'/*
' * Indicates that the surface being locked will only be written to
' */
%DDLOCK_WRITEONLY                        = &H00000020???


'/*
' * Indicates that a system wide lock should not be taken when this surface
' * is locked. This has several advantages (cursor responsiveness, ability
' * to call more Windows functions, easier debugging) when locking video
' * memory surfaces. However, an application specifying this flag must
' * comply with a number of conditions documented in the help file.
' * Furthermore, this flag cannot be specified when locking the primary.
' */
%DDLOCK_NOSYSLOCK                        = &H00000800???

'/*
' * Used only with Direct3D Vertex Buffer Locks. Indicates that no vertices
' * that were referred to in Draw*PrimtiveVB calls since the start of the
' * frame (or the last lock without this flag) will be modified during the
' * lock. This can be useful when one is only appending data to the vertex
' * buffer
' */
%DDLOCK_NOOVERWRITE                      = &H00001000???

'/*
' * Indicates that no assumptions will be made about the contents of the
' * surface or vertex buffer during this lock.
' * This enables two things:
' * -    Direct3D or the driver may provide an alternative memory
' *      area as the vertex buffer. This is useful when one plans to clear the
' *      contents of the vertex buffer and fill in new data.
' * -    Drivers sometimes store surface data in a re-ordered format.
' *      When the application locks the surface, the driver is forced to un-re-order
' *      the surface data before allowing the application to see the surface contents.
' *      This flag is a hint to the driver that it can skip the un-re-ordering process
' *      since the application plans to overwrite every single pixel in the surface
' *      or locked rectangle (and so erase any un-re-ordered pixels anyway).
' *      Applications should always set this flag when they intend to overwrite the entire
' *      surface or locked rectangle.
' */
%DDLOCK_DISCARDCONTENTS                  = &H00002000???

' /*
'  * DDLOCK_OKTOSWAP is an older, less informative name for DDLOCK_DISCARDCONTENTS
'  */
%DDLOCK_OKTOSWAP                         = &H00002000???

'/*
' * On IDirectDrawSurface7 and higher interfaces, the default is DDLOCK_WAIT. If you wish
' * to override the default and use time when the accelerator is busy (as denoted by
' * the DDERR_WASSTILLDRAWING return code) then use DDLOCK_DONOTWAIT.
' */
%DDLOCK_DONOTWAIT                        = &H00004000???

'/*
' * This indicates volume texture lock with front and back specified.
' */
%DDLOCK_HASVOLUMETEXTUREBOXRECT          = &H00008000???

'/*
' * This indicates that the driver should not update dirty rect information for this lock.
' */
%DDLOCK_NODIRTYUPDATE                    = &H00010000???


'/****************************************************************************
' *
' * DIRECTDRAWSURFACE PAGELOCK FLAGS
' *
' ****************************************************************************/

'/*
' * No flags defined at present
' */


'/****************************************************************************
' *
' * DIRECTDRAWSURFACE PAGEUNLOCK FLAGS
' *
' ****************************************************************************/

'/*
' * No flags defined at present
' */


'/****************************************************************************
' *
' * DIRECTDRAWSURFACE BLT FX FLAGS
' *
' ****************************************************************************/

'/*
' * If stretching, use arithmetic stretching along the Y axis for this blt.
' */
%DDBLTFX_ARITHSTRETCHY                   = &H00000001???

'/*
' * Do this blt mirroring the surface left to right.  Spin the
' * surface around its y-axis.
' */
%DDBLTFX_MIRRORLEFTRIGHT                 = &H00000002???

'/*
' * Do this blt mirroring the surface up and down.  Spin the surface
' * around its x-axis.
' */
%DDBLTFX_MIRRORUPDOWN                    = &H00000004???

'/*
' * Schedule this blt to avoid tearing.
' */
%DDBLTFX_NOTEARING                       = &H00000008???

'/*
' * Do this blt rotating the surface one hundred and eighty degrees.
' */
%DDBLTFX_ROTATE180                       = &H00000010???

'/*
' * Do this blt rotating the surface two hundred and seventy degrees.
' */
%DDBLTFX_ROTATE270                       = &H00000020???

'/*
' * Do this blt rotating the surface ninety degrees.
' */
%DDBLTFX_ROTATE90                        = &H00000040???

'/*
' * Do this z blt using dwZBufferLow and dwZBufferHigh as  range values
' * specified to limit the bits copied from the source surface.
' */
%DDBLTFX_ZBUFFERRANGE                    = &H00000080???

'/*
' * Do this z blt adding the dwZBufferBaseDest to each of the sources z values
' * before comparing it with the desting z values.
' */
%DDBLTFX_ZBUFFERBASEDEST                 = &H00000100???

'/****************************************************************************
' *
' * DIRECTDRAWSURFACE OVERLAY FX FLAGS
' *
' ****************************************************************************/

'/*
' * If stretching, use arithmetic stretching along the Y axis for this overlay.
' */
%DDOVERFX_ARITHSTRETCHY                  = &H00000001???

'/*
' * Mirror the overlay across the vertical axis
' */
%DDOVERFX_MIRRORLEFTRIGHT                = &H00000002???

'/*
' * Mirror the overlay across the horizontal axis
' */
%DDOVERFX_MIRRORUPDOWN                   = &H00000004???

'/*
' * Deinterlace the overlay, if possible
' */
%DDOVERFX_DEINTERLACE                    = &H00000008???


'/****************************************************************************
' *
' * DIRECTDRAW WAITFORVERTICALBLANK FLAGS
' *
' ****************************************************************************/

'/*
' * return when the vertical blank interval begins
' */
%DDWAITVB_BLOCKBEGIN                     = &H00000001???

'/*
' * set up an event to trigger when the vertical blank begins
' */
%DDWAITVB_BLOCKBEGINEVENT                = &H00000002???

'/*
' * return when the vertical blank interval ends and display begins
' */
%DDWAITVB_BLOCKEND                       = &H00000004???

'/****************************************************************************
' *
' * DIRECTDRAW GETFLIPSTATUS FLAGS
' *
' ****************************************************************************/

'/*
' * is it OK to flip now?
' */
%DDGFS_CANFLIP                   = &H00000001???

'/*
' * is the last flip finished?
' */
%DDGFS_ISFLIPDONE                = &H00000002???

'/****************************************************************************
' *
' * DIRECTDRAW GETBLTSTATUS FLAGS
' *
' ****************************************************************************/

'/*
' * is it OK to blt now?
' */
%DDGBS_CANBLT                    = &H00000001???

'/*
' * is the blt to the surface finished?
' */
%DDGBS_ISBLTDONE                 = &H00000002???


'/****************************************************************************
' *
' * DIRECTDRAW ENUMOVERLAYZORDER FLAGS
' *
' ****************************************************************************/

'/*
' * Enumerate overlays back to front.
' */
%DDENUMOVERLAYZ_BACKTOFRONT      = &H00000000???

'/*
' * Enumerate overlays front to back
' */
%DDENUMOVERLAYZ_FRONTTOBACK      = &H00000001???

'/****************************************************************************
' *
' * DIRECTDRAW UPDATEOVERLAYZORDER FLAGS
' *
' ****************************************************************************/

'/*
' * Send overlay to front
' */
%DDOVERZ_SENDTOFRONT             = &H00000000???

'/*
' * Send overlay to back
' */
%DDOVERZ_SENDTOBACK              = &H00000001???

'/*
' * Move Overlay forward
' */
%DDOVERZ_MOVEFORWARD             = &H00000002???

'/*
' * Move Overlay backward
' */
%DDOVERZ_MOVEBACKWARD            = &H00000003???

'/*
' * Move Overlay in front of relative surface
' */
%DDOVERZ_INSERTINFRONTOF         = &H00000004???

'/*
' * Move Overlay in back of relative surface
' */
%DDOVERZ_INSERTINBACKOF          = &H00000005???


'/****************************************************************************
' *
' * DIRECTDRAW SETGAMMARAMP FLAGS
' *
' ****************************************************************************/

'/*
' * Request calibrator to adjust the gamma ramp according to the physical
' * properties of the display so that the result should appear identical
' * on all systems.
' */
%DDSGR_CALIBRATE                        = &H00000001???


'/****************************************************************************
' *
' * DIRECTDRAW STARTMODETEST FLAGS
' *
' ****************************************************************************/

'/*
' * Indicates that the mode being tested has passed
' */
%DDSMT_ISTESTREQUIRED                   = &H00000001???


'/****************************************************************************
' *
' * DIRECTDRAW EVALUATEMODE FLAGS
' *
' ****************************************************************************/

'/*
' * Indicates that the mode being tested has passed
' */
%DDEM_MODEPASSED                        = &H00000001???

'/*
' * Indicates that the mode being tested has failed
' */
%DDEM_MODEFAILED                        = &H00000002???


'/*===========================================================================
' *
' *
' * DIRECTDRAW RETURN CODES
' *
' * The return values from DirectDraw Commands and Surface that return an HRESULT
' * are codes from DirectDraw concerning the results of the action
' * requested by DirectDraw.
' *
' *==========================================================================*/

'/*
' * Status is OK
' *
' * Issued by: DirectDraw Commands and all callbacks
' */
%DD_OK                                  = %S_OK
%DD_FALSE                               = %S_FALSE

'/****************************************************************************
' *
' * DIRECTDRAW ENUMCALLBACK RETURN VALUES
' *
' * EnumCallback returns are used to control the flow of the DIRECTDRAW and
' * DIRECTDRAWSURFACE object enumerations.   They can only be returned by
' * enumeration callback routines.
' *
' ****************************************************************************/

'/*
' * stop the enumeration
' */
%DDENUMRET_CANCEL                       = 0

'/*
' * continue the enumeration
' */
%DDENUMRET_OK                           = 1

'/****************************************************************************
' *
' * DIRECTDRAW ERRORS
' *
' * Errors are represented by negative values and cannot be combined.
' *
' ****************************************************************************/

'/*
' * This object is already initialized
' */
%DDERR_ALREADYINITIALIZED               = %MAKE_DDHRESULT + &H5

'/*
' * This surface can not be attached to the requested surface.
' */
%DDERR_CANNOTATTACHSURFACE              = %MAKE_DDHRESULT + &H10

'/*
' * This surface can not be detached from the requested surface.
' */
%DDERR_CANNOTDETACHSURFACE              = %MAKE_DDHRESULT + &H20

'/*
' * Support is currently not available.
' */
%DDERR_CURRENTLYNOTAVAIL                = %MAKE_DDHRESULT + &H40

'/*
' * An exception was encountered while performing the requested operation
' */
%DDERR_EXCEPTION                        = %MAKE_DDHRESULT + &H55

'/*
' * Generic failure.
' */
%DDERR_GENERIC                          = %E_FAIL

'/*
' * Height of rectangle provided is not a multiple of reqd alignment
' */
%DDERR_HEIGHTALIGN                      = %MAKE_DDHRESULT + &H90

'/*
' * Unable to match primary surface creation request with existing
' * primary surface.
' */
%DDERR_INCOMPATIBLEPRIMARY              = %MAKE_DDHRESULT + &H95

'/*
' * One or more of the caps bits passed to the callback are incorrect.
' */
%DDERR_INVALIDCAPS                      = %MAKE_DDHRESULT + &H100

'/*
' * DirectDraw does not support provided Cliplist.
' */
%DDERR_INVALIDCLIPLIST                  = %MAKE_DDHRESULT + &H110

'/*
' * DirectDraw does not support the requested mode
' */
%DDERR_INVALIDMODE                      = %MAKE_DDHRESULT + &H120

'/*
' * DirectDraw received a pointer that was an invalid DIRECTDRAW object.
' */
%DDERR_INVALIDOBJECT                    = %MAKE_DDHRESULT + &H130

'/*
' * One or more of the parameters passed to the callback function are
' * incorrect.
' */
%DDERR_INVALIDPARAMS                    = %E_INVALIDARG

'/*
' * pixel format was invalid as specified
' */
%DDERR_INVALIDPIXELFORMAT               = %MAKE_DDHRESULT + &H145

'/*
' * Rectangle provided was invalid.
' */
%DDERR_INVALIDRECT                      = %MAKE_DDHRESULT + &H150

'/*
' * Operation could not be carried out because one or more surfaces are locked
' */
%DDERR_LOCKEDSURFACES                   = %MAKE_DDHRESULT + &H160

'/*
' * There is no 3D present.
' */
%DDERR_NO3D                             = %MAKE_DDHRESULT + &H170

'/*
' * Operation could not be carried out because there is no alpha accleration
' * hardware present or available.
' */
%DDERR_NOALPHAHW                        = %MAKE_DDHRESULT + &H180

'/*
' * Operation could not be carried out because there is no stereo
' * hardware present or available.
' */
%DDERR_NOSTEREOHARDWARE                 = %MAKE_DDHRESULT + &H181

'/*
' * Operation could not be carried out because there is no hardware
' * present which supports stereo surfaces
' */
%DDERR_NOSURFACELEFT                    = %MAKE_DDHRESULT + &H182



'/*
' * no clip list available
' */
%DDERR_NOCLIPLIST                       = %MAKE_DDHRESULT + &H205

'/*
' * Operation could not be carried out because there is no color conversion
' * hardware present or available.
' */
%DDERR_NOCOLORCONVHW                    = %MAKE_DDHRESULT + &H210

'/*
' * Create function called without DirectDraw object method SetCooperativeLevel
' * being called.
' */
%DDERR_NOCOOPERATIVELEVELSET            = %MAKE_DDHRESULT + &H212

'/*
' * Surface doesn't currently have a color key
' */
%DDERR_NOCOLORKEY                       = %MAKE_DDHRESULT + &H215

'/*
' * Operation could not be carried out because there is no hardware support
' * of the dest color key.
' */
%DDERR_NOCOLORKEYHW                     = %MAKE_DDHRESULT + &H220

'/*
' * No DirectDraw support possible with current display driver
' */
%DDERR_NODIRECTDRAWSUPPORT              = %MAKE_DDHRESULT + &H222

'/*
' * Operation requires the application to have exclusive mode but the
' * application does not have exclusive mode.
' */
%DDERR_NOEXCLUSIVEMODE                  = %MAKE_DDHRESULT + &H225

'/*
' * Flipping visible surfaces is not supported.
' */
%DDERR_NOFLIPHW                         = %MAKE_DDHRESULT + &H230

'/*
' * There is no GDI present.
' */
%DDERR_NOGDI                            = %MAKE_DDHRESULT + &H240

'/*
' * Operation could not be carried out because there is no hardware present
' * or available.
' */
%DDERR_NOMIRRORHW                       = %MAKE_DDHRESULT + &H250

'/*
' * Requested item was not found
' */
%DDERR_NOTFOUND                         = %MAKE_DDHRESULT + &H255

'/*
' * Operation could not be carried out because there is no overlay hardware
' * present or available.
' */
%DDERR_NOOVERLAYHW                      = %MAKE_DDHRESULT + &H260

'/*
' * Operation could not be carried out because the source and destination
' * rectangles are on the same surface and overlap each other.
' */
%DDERR_OVERLAPPINGRECTS                 = %MAKE_DDHRESULT + &H270

'/*
' * Operation could not be carried out because there is no appropriate raster
' * op hardware present or available.
' */
%DDERR_NORASTEROPHW                     = %MAKE_DDHRESULT + &H280

'/*
' * Operation could not be carried out because there is no rotation hardware
' * present or available.
' */
%DDERR_NOROTATIONHW                     = %MAKE_DDHRESULT + &H290

'/*
' * Operation could not be carried out because there is no hardware support
' * for stretching
' */
%DDERR_NOSTRETCHHW                      = %MAKE_DDHRESULT + &H310

'/*
' * DirectDrawSurface is not in 4 bit color palette and the requested operation
' * requires 4 bit color palette.
' */
%DDERR_NOT4BITCOLOR                     = %MAKE_DDHRESULT + &H316

'/*
' * DirectDrawSurface is not in 4 bit color index palette and the requested
' * operation requires 4 bit color index palette.
' */
%DDERR_NOT4BITCOLORINDEX                = %MAKE_DDHRESULT + &H317

'/*
' * DirectDraw Surface is not in 8 bit color mode and the requested operation
' * requires 8 bit color.
' */
%DDERR_NOT8BITCOLOR                     = %MAKE_DDHRESULT + &H320

'/*
' * Operation could not be carried out because there is no texture mapping
' * hardware present or available.
' */
%DDERR_NOTEXTUREHW                      = %MAKE_DDHRESULT + &H330

'/*
' * Operation could not be carried out because there is no hardware support
' * for vertical blank synchronized operations.
' */
%DDERR_NOVSYNCHW                        = %MAKE_DDHRESULT + &H335

'/*
' * Operation could not be carried out because there is no hardware support
' * for zbuffer blting.
' */
%DDERR_NOZBUFFERHW                      = %MAKE_DDHRESULT + &H340

'/*
' * Overlay surfaces could not be z layered based on their BltOrder because
' * the hardware does not support z layering of overlays.
' */
%DDERR_NOZOVERLAYHW                     = %MAKE_DDHRESULT + &H350

'/*
' * The hardware needed for the requested operation has already been
' * allocated.
' */
%DDERR_OUTOFCAPS                        = %MAKE_DDHRESULT + &H360

'/*
' * DirectDraw does not have enough memory to perform the operation.
' */
%DDERR_OUTOFMEMORY                      = %E_OUTOFMEMORY

'/*
' * DirectDraw does not have enough memory to perform the operation.
' */
%DDERR_OUTOFVIDEOMEMORY                 = %MAKE_DDHRESULT + &H380

'/*
' * hardware does not support clipped overlays
' */
%DDERR_OVERLAYCANTCLIP                  = %MAKE_DDHRESULT + &H382

'/*
' * Can only have ony color key active at one time for overlays
' */
%DDERR_OVERLAYCOLORKEYONLYONEACTIVE     = %MAKE_DDHRESULT + &H384

'/*
' * Access to this palette is being refused because the palette is already
' * locked by another thread.
' */
%DDERR_PALETTEBUSY                      = %MAKE_DDHRESULT + &H387

'/*
' * No src color key specified for this operation.
' */
%DDERR_COLORKEYNOTSET                   = %MAKE_DDHRESULT + &H400

'/*
' * This surface is already attached to the surface it is being attached to.
' */
%DDERR_SURFACEALREADYATTACHED           = %MAKE_DDHRESULT + &H410

'/*
' * This surface is already a dependency of the surface it is being made a
' * dependency of.
' */
%DDERR_SURFACEALREADYDEPENDENT          = %MAKE_DDHRESULT + &H420

'/*
' * Access to this surface is being refused because the surface is already
' * locked by another thread.
' */
%DDERR_SURFACEBUSY                      = %MAKE_DDHRESULT + &H430

'/*
' * Access to this surface is being refused because no driver exists
' * which can supply a pointer to the surface.
' * This is most likely to happen when attempting to lock the primary
' * surface when no DCI provider is present.
' * Will also happen on attempts to lock an optimized surface.
' */
%DDERR_CANTLOCKSURFACE                  = %MAKE_DDHRESULT + &H435

'/*
' * Access to Surface refused because Surface is obscured.
' */
%DDERR_SURFACEISOBSCURED                = %MAKE_DDHRESULT + &H440

'/*
' * Access to this surface is being refused because the surface is gone.
' * The DIRECTDRAWSURFACE object representing this surface should
' * have Restore called on it.
' */
%DDERR_SURFACELOST                      = %MAKE_DDHRESULT + &H450

'/*
' * The requested surface is not attached.
' */
%DDERR_SURFACENOTATTACHED               = %MAKE_DDHRESULT + &H460

'/*
' * Height requested by DirectDraw is too large.
' */
%DDERR_TOOBIGHEIGHT                     = %MAKE_DDHRESULT + &H470

'/*
' * Size requested by DirectDraw is too large --  The individual height and
' * width are OK.
' */
%DDERR_TOOBIGSIZE                       = %MAKE_DDHRESULT + &H480

'/*
' * Width requested by DirectDraw is too large.
' */
%DDERR_TOOBIGWIDTH                      = %MAKE_DDHRESULT + &H490

'/*
' * Action not supported.
' */
%DDERR_UNSUPPORTED                      = %E_NOTIMPL

'/*
' * Pixel format requested is unsupported by DirectDraw
' */
%DDERR_UNSUPPORTEDFORMAT                = %MAKE_DDHRESULT + &H510

'/*
' * Bitmask in the pixel format requested is unsupported by DirectDraw
' */
%DDERR_UNSUPPORTEDMASK                  = %MAKE_DDHRESULT + &H520

'/*
' * The specified stream contains invalid data
' */
%DDERR_INVALIDSTREAM                    = %MAKE_DDHRESULT + &H521

'/*
' * vertical blank is in progress
' */
%DDERR_VERTICALBLANKINPROGRESS          = %MAKE_DDHRESULT + &H537

'/*
' * Informs DirectDraw that the previous Blt which is transfering information
' * to or from this Surface is incomplete.
' */
%DDERR_WASSTILLDRAWING                  = %MAKE_DDHRESULT + &H540


'/*
' * The specified surface type requires specification of the COMPLEX flag
' */
%DDERR_DDSCAPSCOMPLEXREQUIRED           = %MAKE_DDHRESULT + &H542


'/*
' * Rectangle provided was not horizontally aligned on reqd. boundary
' */
%DDERR_XALIGN                           = %MAKE_DDHRESULT + &H560

'/*
' * The GUID passed to DirectDrawCreate is not a valid DirectDraw driver
' * identifier.
' */
%DDERR_INVALIDDIRECTDRAWGUID            = %MAKE_DDHRESULT + &H561

'/*
' * A DirectDraw object representing this driver has already been created
' * for this process.
' */
%DDERR_DIRECTDRAWALREADYCREATED         = %MAKE_DDHRESULT + &H562

'/*
' * A hardware only DirectDraw object creation was attempted but the driver
' * did not support any hardware.
' */
%DDERR_NODIRECTDRAWHW                   = %MAKE_DDHRESULT + &H563

'/*
' * this process already has created a primary surface
' */
%DDERR_PRIMARYSURFACEALREADYEXISTS      = %MAKE_DDHRESULT + &H564

'/*
' * software emulation not available.
' */
%DDERR_NOEMULATION                      = %MAKE_DDHRESULT + &H565

'/*
' * region passed to Clipper::GetClipList is too small.
' */
%DDERR_REGIONTOOSMALL                   = %MAKE_DDHRESULT + &H566

'/*
' * an attempt was made to set a clip list for a clipper objec that
' * is already monitoring an hwnd.
' */
%DDERR_CLIPPERISUSINGHWND               = %MAKE_DDHRESULT + &H567

'/*
' * No clipper object attached to surface object
' */
%DDERR_NOCLIPPERATTACHED                = %MAKE_DDHRESULT + &H568

'/*
' * Clipper notification requires an HWND or
' * no HWND has previously been set as the CooperativeLevel HWND.
' */
%DDERR_NOHWND                           = %MAKE_DDHRESULT + &H569

'/*
' * HWND used by DirectDraw CooperativeLevel has been subclassed,
' * this prevents DirectDraw from restoring state.
' */
%DDERR_HWNDSUBCLASSED                   = %MAKE_DDHRESULT + &H570

'/*
' * The CooperativeLevel HWND has already been set.
' * It can not be reset while the process has surfaces or palettes created.
' */
%DDERR_HWNDALREADYSET                   = %MAKE_DDHRESULT + &H571

'/*
' * No palette object attached to this surface.
' */
%DDERR_NOPALETTEATTACHED                = %MAKE_DDHRESULT + &H572

'/*
' * No hardware support for 16 or 256 color palettes.
' */
%DDERR_NOPALETTEHW                      = %MAKE_DDHRESULT + &H573

'/*
' * If a clipper object is attached to the source surface passed into a
' * BltFast call.
' */
%DDERR_BLTFASTCANTCLIP                  = %MAKE_DDHRESULT + &H574

'/*
' * No blter.
' */
%DDERR_NOBLTHW                          = %MAKE_DDHRESULT + &H575

'/*
' * No DirectDraw ROP hardware.
' */
%DDERR_NODDROPSHW                       = %MAKE_DDHRESULT + &H576

'/*
' * returned when GetOverlayPosition is called on a hidden overlay
' */
%DDERR_OVERLAYNOTVISIBLE                = %MAKE_DDHRESULT + &H577

'/*
' * returned when GetOverlayPosition is called on a overlay that UpdateOverlay
' * has never been called on to establish a destionation.
' */
%DDERR_NOOVERLAYDEST                    = %MAKE_DDHRESULT + &H578

'/*
' * returned when the position of the overlay on the destionation is no longer
' * legal for that destionation.
' */
%DDERR_INVALIDPOSITION                  = %MAKE_DDHRESULT + &H579

'/*
' * returned when an overlay member is called for a non-overlay surface
' */
%DDERR_NOTAOVERLAYSURFACE               = %MAKE_DDHRESULT + &H580

'/*
' * An attempt was made to set the cooperative level when it was already
' * set to exclusive.
' */
%DDERR_EXCLUSIVEMODEALREADYSET          = %MAKE_DDHRESULT + &H581

'/*
' * An attempt has been made to flip a surface that is not flippable.
' */
%DDERR_NOTFLIPPABLE                     = %MAKE_DDHRESULT + &H582

'/*
' * Can't duplicate primary & 3D surfaces, or surfaces that are implicitly
' * created.
' */
%DDERR_CANTDUPLICATE                    = %MAKE_DDHRESULT + &H583

'/*
' * Surface was not locked.  An attempt to unlock a surface that was not
' * locked at all, or by this process, has been attempted.
' */
%DDERR_NOTLOCKED                        = %MAKE_DDHRESULT + &H584

'/*
' * Windows can not create any more DCs, or a DC was requested for a paltte-indexed
' * surface when the surface had no palette AND the display mode was not palette-indexed
' * (in this case DirectDraw cannot select a proper palette into the DC)
' */
%DDERR_CANTCREATEDC                     = %MAKE_DDHRESULT + &H585

'/*
' * No DC was ever created for this surface.
' */
%DDERR_NODC                             = %MAKE_DDHRESULT + &H586

'/*
' * This surface can not be restored because it was created in a different
' * mode.
' */
%DDERR_WRONGMODE                        = %MAKE_DDHRESULT + &H587

'/*
' * This surface can not be restored because it is an implicitly created
' * surface.
' */
%DDERR_IMPLICITLYCREATED                = %MAKE_DDHRESULT + &H588

'/*
' * The surface being used is not a palette-based surface
' */
%DDERR_NOTPALETTIZED                    = %MAKE_DDHRESULT + &H589


'/*
' * The display is currently in an unsupported mode
' */
%DDERR_UNSUPPORTEDMODE                  = %MAKE_DDHRESULT + &H590

'/*
' * Operation could not be carried out because there is no mip-map
' * texture mapping hardware present or available.
' */
%DDERR_NOMIPMAPHW                       = %MAKE_DDHRESULT + &H591

'/*
' * The requested action could not be performed because the surface was of
' * the wrong type.
' */
%DDERR_INVALIDSURFACETYPE               = %MAKE_DDHRESULT + &H592


'/*
' * Device does not support optimized surfaces, therefore no video memory optimized surfaces
' */
%DDERR_NOOPTIMIZEHW                     = %MAKE_DDHRESULT + &H600

'/*
' * Surface is an optimized surface, but has not yet been allocated any memory
' */
%DDERR_NOTLOADED                        = %MAKE_DDHRESULT + &H601

'/*
' * Attempt was made to create or set a device window without first setting
' * the focus window
' */
%DDERR_NOFOCUSWINDOW                    = %MAKE_DDHRESULT + &H602

'/*
' * Attempt was made to set a palette on a mipmap sublevel
' */
%DDERR_NOTONMIPMAPSUBLEVEL              = %MAKE_DDHRESULT + &H603

'/*
' * A DC has already been returned for this surface. Only one DC can be
' * retrieved per surface.
' */
%DDERR_DCALREADYCREATED                 = %MAKE_DDHRESULT + &H620

'/*
' * An attempt was made to allocate non-local video memory from a device
' * that does not support non-local video memory.
' */
%DDERR_NONONLOCALVIDMEM                 = %MAKE_DDHRESULT + &H630

'/*
' * The attempt to page lock a surface failed.
' */
%DDERR_CANTPAGELOCK                     = %MAKE_DDHRESULT + &H640


'/*
' * The attempt to page unlock a surface failed.
' */
%DDERR_CANTPAGEUNLOCK                   = %MAKE_DDHRESULT + &H660

'/*
' * An attempt was made to page unlock a surface with no outstanding page locks.
' */
%DDERR_NOTPAGELOCKED                    = %MAKE_DDHRESULT + &H680

'/*
' * There is more data available than the specified buffer size could hold
' */
%DDERR_MOREDATA                         = %MAKE_DDHRESULT + &H690

'/*
' * The data has expired and is therefore no longer valid.
' */
%DDERR_EXPIRED                          = %MAKE_DDHRESULT + &H691

'/*
' * The mode test has finished executing.
' */
%DDERR_TESTFINISHED                     = %MAKE_DDHRESULT + &H692

'/*
' * The mode test has switched to a new mode.
' */
%DDERR_NEWMODE                          = %MAKE_DDHRESULT + &H693

'/*
' * D3D has not yet been initialized.
' */
%DDERR_D3DNOTINITIALIZED                = %MAKE_DDHRESULT + &H694

'/*
' * The video port is not active
' */
%DDERR_VIDEONOTACTIVE                   = %MAKE_DDHRESULT + &H695

'/*
' * The monitor does not have EDID data.
' */
%DDERR_NOMONITORINFORMATION             = %MAKE_DDHRESULT + &H696

'/*
' * The driver does not enumerate display mode refresh rates.
' */
%DDERR_NODRIVERSUPPORT                  = %MAKE_DDHRESULT + &H697

'/*
' * Surfaces created by one direct draw device cannot be used directly by
' * another direct draw device.
' */
%DDERR_DEVICEDOESNTOWNSURFACE           = %MAKE_DDHRESULT + &H699


'/*
' * An attempt was made to invoke an interface member of a DirectDraw object
' * created by CoCreateInstance() before it was initialized.
' */
%DDERR_NOTINITIALIZED                  = %CO_E_NOTINITIALIZED


' ########################################################################################
' Interface name = IDirectDraw
' Inherited interface = IUnknown
' ########################################################################################

INTERFACE IDirectDraw $IID_IDirectDraw

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Compact ( _                         ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateClipper ( _                   ' VTable offset = 16
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR *lplpDDClipper
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreatePalette ( _                   ' VTable offset = 20
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF PALETTEENTRY _                     ' LPPALETTEENTRY lpColorTable
   , BYREF IUnknown _                         ' LPDIRECTDRAWPALETTE FAR* lplpDDPalette
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateSurface ( _                   ' VTable offset = 24
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE FAR *lplpDDSurface
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DuplicateSurface ( _                ' VTable offset = 28
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSurface
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE lplpDupDDSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumDisplayModes ( _                ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' LPVOID lpContext,
   , BYVAL DWORD _                            ' LPDDENUMMODESCALLBACK lpEnumCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumSurfaces ( _                    ' VTable offset = 36
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSD
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FlipToGDISurface ( _                ' VTable offset = 40
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 44
     BYREF DDCAPS _                           ' LPDDCAPS lpDDDriverCaps
   , BYREF DDCAPS _                           ' LPDDCAPS lpDDHELCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDisplayMode ( _                  ' VTable offset = 48
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFourCCCodes ( _                  ' VTable offset = 52
     BYREF DWORD _                            ' DWORD FAR *lpNumCodes
   , BYREF DWORD _                            ' DWORD FAR *lpCodes
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetGDISurface ( _                   ' VTable offset = 56
     BYREF IUnknown _                         ' LPDIRECTDRAWSURFACE FAR *lplpGDIDDSSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMonitorFrequency ( _             ' VTable offset = 60
     BYREF DWORD _                            ' LPDWORD lpdwFrequency
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetScanLine ( _                     ' VTable offset = 64
     BYREF DWORD _                            ' LPDWORD lpdwScanLine
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetVerticalBlankStatus ( _          ' VTable offset = 68
     BYREF LONG _                             ' LPBOOL lpbIsInVB
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 72
      BYREF GUID _                            ' GUID FAR *lpGUID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RestoreDisplayMode ( _              ' VTable offset = 76
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetCooperativeLevel ( _             ' VTable offset = 80
     BYVAL DWORD _                            ' HWND hWnd
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDisplayMode ( _                  ' VTable offset = 84
     BYVAL DWORD _                            ' DWORD dwWidth
   , BYVAL DWORD _                            ' DWORD dwHeight
   , BYVAL DWORD _                            ' DWORD dwBpp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD WaitForVerticalBlank ( _            ' VTable offset = 88
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDraw


' ########################################################################################
' Interface name = IDirectDraw2
' Inherited interface = IDirectDraw
' ########################################################################################

INTERFACE IDirectDraw2 $IID_IDirectDraw2

   INHERIT IUnknown

   ' /*** IDirectDraw methods ***/
   ' =====================================================================================
   METHOD Compact ( _                         ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateClipper ( _                   ' VTable offset = 16
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR *lplpDDClipper
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreatePalette ( _                   ' VTable offset = 20
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF PALETTEENTRY _                     ' LPPALETTEENTRY lpColorTable
   , BYREF IUnknown _                         ' LPDIRECTDRAWPALETTE FAR* lplpDDPalette
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateSurface ( _                   ' VTable offset = 24
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE FAR *lplpDDSurface
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DuplicateSurface ( _                ' VTable offset = 28
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSurface
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE lplpDupDDSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumDisplayModes ( _                ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' LPVOID lpContext,
   , BYVAL DWORD _                            ' LPDDENUMMODESCALLBACK lpEnumCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumSurfaces ( _                    ' VTable offset = 36
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSD
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FlipToGDISurface ( _                ' VTable offset = 40
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 44
     BYREF DDCAPS _                           ' LPDDCAPS lpDDDriverCaps
   , BYREF DDCAPS _                           ' LPDDCAPS lpDDHELCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDisplayMode ( _                  ' VTable offset = 48
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFourCCCodes ( _                  ' VTable offset = 52
     BYREF DWORD _                            ' DWORD FAR *lpNumCodes
   , BYREF DWORD _                            ' DWORD FAR *lpCodes
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetGDISurface ( _                   ' VTable offset = 56
     BYREF IUnknown _                         ' LPDIRECTDRAWSURFACE FAR *lplpGDIDDSSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMonitorFrequency ( _             ' VTable offset = 60
     BYREF DWORD _                            ' LPDWORD lpdwFrequency
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetScanLine ( _                     ' VTable offset = 64
     BYREF DWORD _                            ' LPDWORD lpdwScanLine
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetVerticalBlankStatus ( _          ' VTable offset = 68
     BYREF LONG _                             ' LPBOOL lpbIsInVB
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 72
      BYREF GUID _                            ' GUID FAR *lpGUID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RestoreDisplayMode ( _              ' VTable offset = 76
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetCooperativeLevel ( _             ' VTable offset = 80
     BYVAL DWORD _                            ' HWND hWnd
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDisplayMode ( _                  ' VTable offset = 84
     BYVAL DWORD _                            ' DWORD dwWidth
   , BYVAL DWORD _                            ' DWORD dwHeight
   , BYVAL DWORD _                            ' DWORD dwBpp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD WaitForVerticalBlank ( _            ' VTable offset = 88
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** IDirectDraw2 methods ***/
   ' =====================================================================================
   METHOD GetAvailableVidMem ( _              ' VTable offset = 92
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   , BYREF DWORD _                            ' LPDWORD lpdwTotal
   , BYREF DWORD _                            ' LPDWORD lpdwFree
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDraw2


' ########################################################################################
' Interface name = IDirectDraw4
' Inherited interface = IDirectDraw2
' ########################################################################################

INTERFACE IDirectDraw4 $IID_IDirectDraw4

   INHERIT IUnknown

   ' /*** IDirectDraw methods ***/
   ' =====================================================================================
   METHOD Compact ( _                         ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateClipper ( _                   ' VTable offset = 16
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR *lplpDDClipper
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreatePalette ( _                   ' VTable offset = 20
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF PALETTEENTRY _                     ' LPPALETTEENTRY lpColorTable
   , BYREF IUnknown _                         ' LPDIRECTDRAWPALETTE FAR* lplpDDPalette
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateSurface ( _                   ' VTable offset = 24
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE FAR *lplpDDSurface
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DuplicateSurface ( _                ' VTable offset = 28
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSurface
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE lplpDupDDSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumDisplayModes ( _                ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' LPVOID lpContext,
   , BYVAL DWORD _                            ' LPDDENUMMODESCALLBACK lpEnumCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumSurfaces ( _                    ' VTable offset = 36
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSD
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FlipToGDISurface ( _                ' VTable offset = 40
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 44
     BYREF DDCAPS _                           ' LPDDCAPS lpDDDriverCaps
   , BYREF DDCAPS _                           ' LPDDCAPS lpDDHELCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDisplayMode ( _                  ' VTable offset = 48
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFourCCCodes ( _                  ' VTable offset = 52
     BYREF DWORD _                            ' DWORD FAR *lpNumCodes
   , BYREF DWORD _                            ' DWORD FAR *lpCodes
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetGDISurface ( _                   ' VTable offset = 56
     BYREF IUnknown _                         ' LPDIRECTDRAWSURFACE FAR *lplpGDIDDSSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMonitorFrequency ( _             ' VTable offset = 60
     BYREF DWORD _                            ' LPDWORD lpdwFrequency
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetScanLine ( _                     ' VTable offset = 64
     BYREF DWORD _                            ' LPDWORD lpdwScanLine
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetVerticalBlankStatus ( _          ' VTable offset = 68
     BYREF LONG _                             ' LPBOOL lpbIsInVB
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 72
     BYREF GUID _                             ' GUID FAR *lpGUID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RestoreDisplayMode ( _              ' VTable offset = 76
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetCooperativeLevel ( _             ' VTable offset = 80
     BYVAL DWORD _                            ' HWND hWnd
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDisplayMode ( _                  ' VTable offset = 84
     BYVAL DWORD _                            ' DWORD dwWidth
   , BYVAL DWORD _                            ' DWORD dwHeight
   , BYVAL DWORD _                            ' DWORD dwBpp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD WaitForVerticalBlank ( _            ' VTable offset = 88
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** IDirectDraw2 methods ***/
   ' =====================================================================================
   METHOD GetAvailableVidMem ( _              ' VTable offset = 92
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   , BYREF DWORD _                            ' LPDWORD lpdwTotal
   , BYREF DWORD _                            ' LPDWORD lpdwFree
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** IDirectDraw4 methods ***/
   ' =====================================================================================
   METHOD GetSurfaceFromDC ( _                ' VTable offset = 96
     BYVAL DWORD _                            ' HDC hdc
   , BYREF IUnknown _                         ' LPDIRECTDRAWSURFACE4 *lpDDS4
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RestoreAllSurfaces ( _              ' VTable offset = 100
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TestCooperativeLevel ( _            ' VTable offset = 104
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDeviceIdentifier ( _             ' VTable offset = 108
     BYREF DDDEVICEIDENTIFIER _               ' LPDDDEVICEIDENTIFIER lpdddi
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDraw4


' ########################################################################################
' Interface name = IDirectDraw7
' Inherited interface = IDirectDraw4
' ########################################################################################

INTERFACE IDirectDraw7 $IID_IDirectDraw7

   INHERIT IUnknown

   ' /*** IDirectDraw methods ***/
   ' =====================================================================================
   METHOD Compact ( _                         ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateClipper ( _                   ' VTable offset = 16
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR *lplpDDClipper
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreatePalette ( _                   ' VTable offset = 20
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF PALETTEENTRY _                     ' LPPALETTEENTRY lpColorTable
   , BYREF IUnknown _                         ' LPDIRECTDRAWPALETTE FAR* lplpDDPalette
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD CreateSurface ( _                   ' VTable offset = 24
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE FAR *lplpDDSurface
   , BYVAL IUnknown _                         ' IUnknown FAR *pUnkOuter
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DuplicateSurface ( _                ' VTable offset = 28
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSurface
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE lplpDupDDSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumDisplayModes ( _                ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' LPVOID lpContext,
   , BYVAL DWORD _                            ' LPDDENUMMODESCALLBACK lpEnumCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumSurfaces ( _                    ' VTable offset = 36
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSD
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FlipToGDISurface ( _                ' VTable offset = 40
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 44
     BYREF DDCAPS _                           ' LPDDCAPS lpDDDriverCaps
   , BYREF DDCAPS _                           ' LPDDCAPS lpDDHELCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDisplayMode ( _                  ' VTable offset = 48
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFourCCCodes ( _                  ' VTable offset = 52
     BYREF DWORD _                            ' DWORD FAR *lpNumCodes
   , BYREF DWORD _                            ' DWORD FAR *lpCodes
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetGDISurface ( _                   ' VTable offset = 56
     BYREF IUnknown _                         ' LPDIRECTDRAWSURFACE FAR *lplpGDIDDSSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetMonitorFrequency ( _             ' VTable offset = 60
     BYREF DWORD _                            ' LPDWORD lpdwFrequency
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetScanLine ( _                     ' VTable offset = 64
     BYREF DWORD _                            ' LPDWORD lpdwScanLine
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetVerticalBlankStatus ( _          ' VTable offset = 68
     BYREF LONG _                             ' LPBOOL lpbIsInVB
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 72
     BYREF GUID _                             ' GUID FAR *lpGUID
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RestoreDisplayMode ( _              ' VTable offset = 76
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetCooperativeLevel ( _             ' VTable offset = 80
     BYVAL DWORD _                            ' HWND hWnd
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetDisplayMode ( _                  ' VTable offset = 84
     BYVAL DWORD _                            ' DWORD dwWidth
   , BYVAL DWORD _                            ' DWORD dwHeight
   , BYVAL DWORD _                            ' DWORD dwBpp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD WaitForVerticalBlank ( _            ' VTable offset = 88
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** IDirectDraw2 methods ***/
   ' =====================================================================================
   METHOD GetAvailableVidMem ( _              ' VTable offset = 92
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   , BYREF DWORD _                            ' LPDWORD lpdwTotal
   , BYREF DWORD _                            ' LPDWORD lpdwFree
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** IDirectDraw4 methods ***/
   ' =====================================================================================
   METHOD GetSurfaceFromDC ( _                ' VTable offset = 96
     BYVAL DWORD _                            ' HDC hdc
   , BYREF IUnknown _                         ' LPDIRECTDRAWSURFACE4 *lpDDS4
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD RestoreAllSurfaces ( _              ' VTable offset = 100
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD TestCooperativeLevel ( _            ' VTable offset = 104
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDeviceIdentifier ( _             ' VTable offset = 108
     BYREF DDDEVICEIDENTIFIER _               ' LPDDDEVICEIDENTIFIER lpdddi
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** IDirectDraw7 methods ***/
   ' =====================================================================================
   METHOD StartModeTest ( _                   ' VTable offset = 112
     BYREF APISIZE _                          ' LPSIZE lpModesToTest
   , BYVAL DWORD _                            ' DWORD dwNumEntries
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EvaluateMode ( _                    ' VTable offset = 116
     BYVAL DWORD _                            ' DWORD  dwFlags
   , BYREF DWORD _                            ' DWORD  *pSecondsUntilTimeout
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDraw7

' ########################################################################################
' Interface name = IDirectDrawPalette
' Inherited interface = IUnknown
' ########################################################################################

INTERFACE IDirectDrawPalette $IID_IDirectDrawPalette

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 12
     BYREF DWORD _                            ' LPDWORD lpdwCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetEntries ( _                      ' VTable offset = 16
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' DWORD dwBase
   , BYVAL DWORD _                            ' DWORD dwNumEntries
   , BYREF PALETTEENTRY _                     ' LPPALETTEENTRY lpEntries
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 20
     BYVAL IUnknown _                         ' LPDIRECTDRAW lpDD
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF PALETTEENTRY _                     ' LPPALETTEENTRY lpDDColorTable
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetEntries ( _                      ' VTable offset = 24
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' DWORD dwStartingEntry
   , BYVAL DWORD _                            ' DWORD dwCount
   , BYREF PALETTEENTRY _                     ' LPPALETTEENTRY lpEntries
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawPalette


' ########################################################################################
' Interface name = IDirectDrawClipper
' Inherited interface = IUnknown
' ########################################################################################

INTERFACE IDirectDrawClipper $IID_IDirectDrawClipper

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClipList ( _                     ' VTable offset = 12
     BYREF RECT _                             ' LPRECT lpRect
   , BYREF RGNDATA _                          ' LPRGNDATA lpClipList
   , BYREF DWORD _                            ' LPDWORD lpdwSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetHWnd ( _                         ' VTable offset = 16
     BYREF DWORD _                            ' HWND FAR *lphWnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 20
     BYVAL IUnknown _                         ' LPDIRECTDRAW lpDD
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsClipListChanged ( _               ' VTable offset = 24
     BYREF LONG _                             ' BOOL FAR *lpbChanged
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetClipList ( _                     ' VTable offset = 28
     BYREF RGNDATA _                          ' LPRGNDATA lpClipList
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetHWnd ( _                         ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HWND hWnd
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawPalette


' ########################################################################################
' Interface name = IDirectDrawSurface
' Inherited interface = IUnknown
' ########################################################################################

INTERFACE IDirectDrawSurface $IID_IDirectDrawSurface

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddAttachedSurface ( _              ' VTable offset = 12
     BYVAL IDirectDrawSurface _               ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddOverlayDirtyRect ( _             ' VTable offset = 16
     BYREF RECT _                             ' LPRECT lpRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Blt ( _                             ' VTable offset = 20
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDBLTFX _                          ' LPDDBLTFX lpDDBltFX
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltBatch ( _                        ' VTable offset = 24
     BYREF DDBLTBATCH _                       ' LPDDBLTBATCH lpDDBltBatch
   , BYVAL DWORD _                            ' DWORD dwCount
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltFast ( _                         ' VTable offset = 28
     BYVAL DWORD _                            ' DWORD dwX
   , BYVAL DWORD _                            ' DWORD dwY
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwTrans
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteAttachedSurface ( _           ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumAttachedSurfaces ( _            ' VTable offset = 36
     BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumOverlayZOrders ( _              ' VTable offset = 40
     BYVAL DWORD _                            ' DWORD dwFlags,
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpfnCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Flip ( _                            ' VTable offset = 44
     BYVAL IDirectDrawSurface _               ' LPDIRECTDRAWSURFACE lpDDSurfaceTargetOverride
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAttachedSurface ( _              ' VTable offset = 48
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE FAR *lplpDDAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBltStatus ( _                    ' VTable offset = 52
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 56
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetClipper ( _                      ' VTable offset = 60
     BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR * lplpDDClippe
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetColorKey ( _                     ' VTable offset = 64
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDC ( _                           ' VTable offset = 68
     BYREF DWORD _                            ' HDCFAR *lphDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFlipStatus ( _                   ' VTable offset = 72
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetOverlayPosition ( _              ' VTable offset = 76
     BYREF LONG _                             ' LPLONG lplX
   , BYREF LONG _                             ' LPLONG lplY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPalette ( _                      ' VTable offset = 80
     BYREF IUnknown _                         ' LPLPDIRECTDRAWPALETTE lplpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPixelFormat ( _                  ' VTable offset = 84
     BYREF DDPIXELFORMAT _                    ' LPDDPIXELFORMAT lpDDPixelFormat
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSurfaceDesc ( _                  ' VTable offset = 88
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 92
     BYVAL IUnknown _                         ' LPDIRECTDRAW lpDD
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsLost ( _                          ' VTable offset = 96
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Lock ( _                            ' VTable offset = 100
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseDC ( _                       ' VTable offset = 104
     BYVAL DWORD _                            ' HDC hDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Restore ( _                         ' VTable offset = 108
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetClipper ( _                      ' VTable offset = 112
     BYVAL IUnknown _                         ' LPDIRECTDRAWCLIPPER lpDDClipper
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetColorKey ( _                     ' VTable offset = 116
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetOverlayPosition ( _              ' VTable offset = 120
     BYVAL LONG _                             ' LONG lX
   , BYVAL LONG _                             ' LONG lY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetPalette ( _                      ' VTable offset = 124
     BYVAL IUnknown _                         ' LPDIRECTDRAWPALETTE lpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unlock ( _                          ' VTable offset = 128
     BYVAL DWORD _                            ' LPVOID lpSurfaceData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlay ( _                   ' VTable offset = 132
     BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDDestSurface
   , BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDOVERLAYFX _                      ' LPDDOVERLAYFX lpDDOverlayFx
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayDisplay ( _            ' VTable offset = 136
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayZOrder ( _             ' VTable offset = 140
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSReference
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawSurface


' ########################################################################################
' Interface name = IDirectDrawSurface2
' Inherited interface = IDirectDrawSurface
' ########################################################################################

INTERFACE IDirectDrawSurface2 $IID_IDirectDrawSurface2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddAttachedSurface ( _              ' VTable offset = 12
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddOverlayDirtyRect ( _             ' VTable offset = 16
     BYREF RECT _                             ' LPRECT lpRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Blt ( _                             ' VTable offset = 20
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDBLTFX _                          ' LPDDBLTFX lpDDBltFX
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltBatch ( _                        ' VTable offset = 24
     BYREF DDBLTBATCH _                       ' LPDDBLTBATCH lpDDBltBatch
   , BYVAL DWORD _                            ' DWORD dwCount
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltFast ( _                         ' VTable offset = 28
     BYVAL DWORD _                            ' DWORD dwX
   , BYVAL DWORD _                            ' DWORD dwY
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwTrans
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteAttachedSurface ( _           ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumAttachedSurfaces ( _            ' VTable offset = 36
     BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumOverlayZOrders ( _              ' VTable offset = 40
     BYVAL DWORD _                            ' DWORD dwFlags,
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpfnCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Flip ( _                            ' VTable offset = 44
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSurfaceTargetOverride
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAttachedSurface ( _              ' VTable offset = 48
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE FAR *lplpDDAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBltStatus ( _                    ' VTable offset = 52
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 56
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetClipper ( _                      ' VTable offset = 60
     BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR * lplpDDClippe
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetColorKey ( _                     ' VTable offset = 64
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDC ( _                           ' VTable offset = 68
     BYREF DWORD _                            ' HDCFAR *lphDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFlipStatus ( _                   ' VTable offset = 72
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetOverlayPosition ( _              ' VTable offset = 76
     BYREF LONG _                             ' LPLONG lplX
   , BYREF LONG _                             ' LPLONG lplY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPalette ( _                      ' VTable offset = 80
     BYREF IUnknown _                         ' LPLPDIRECTDRAWPALETTE lplpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPixelFormat ( _                  ' VTable offset = 84
     BYREF DDPIXELFORMAT _                    ' LPDDPIXELFORMAT lpDDPixelFormat
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSurfaceDesc ( _                  ' VTable offset = 88
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 92
     BYVAL IDirectDraw _                      ' LPDIRECTDRAW lpDD
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsLost ( _                          ' VTable offset = 96
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Lock ( _                            ' VTable offset = 100
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseDC ( _                       ' VTable offset = 104
     BYVAL DWORD _                            ' HDC hDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Restore ( _                         ' VTable offset = 108
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetClipper ( _                      ' VTable offset = 112
     BYVAL IUnknown _                         ' LPDIRECTDRAWCLIPPER lpDDClipper
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetColorKey ( _                     ' VTable offset = 116
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetOverlayPosition ( _              ' VTable offset = 120
     BYVAL LONG _                             ' LONG lX
   , BYVAL LONG _                             ' LONG lY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetPalette ( _                      ' VTable offset = 124
     BYVAL IDirectDrawPalette _               ' LPDIRECTDRAWPALETTE lpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unlock ( _                          ' VTable offset = 128
     BYVAL DWORD _                            ' LPVOID lpSurfaceData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlay ( _                   ' VTable offset = 132
     BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDDestSurface
   , BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDOVERLAYFX _                      ' LPDDOVERLAYFX lpDDOverlayFx
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayDisplay ( _            ' VTable offset = 136
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayZOrder ( _             ' VTable offset = 140
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSReference
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the v2 interface ***/
   ' =====================================================================================
   METHOD GetDDInterface ( _                  ' VTable offset = 144
      BYREF IUnknown _                        ' LPVOID FAR* lplpDD
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PageLock ( _                        ' VTable offset = 148
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PageUnlock ( _                      ' VTable offset = 152
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawSurface2


' ########################################################################################
' Interface name = IDirectDrawSurface3
' Inherited interface = IDirectDrawSurface2
' ########################################################################################

INTERFACE IDirectDrawSurface3 $IID_IDirectDrawSurface3

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddAttachedSurface ( _              ' VTable offset = 12
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddOverlayDirtyRect ( _             ' VTable offset = 16
     BYREF RECT _                             ' LPRECT lpRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Blt ( _                             ' VTable offset = 20
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDBLTFX _                          ' LPDDBLTFX lpDDBltFX
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltBatch ( _                        ' VTable offset = 24
     BYREF DDBLTBATCH _                       ' LPDDBLTBATCH lpDDBltBatch
   , BYVAL DWORD _                            ' DWORD dwCount
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltFast ( _                         ' VTable offset = 28
     BYVAL DWORD _                            ' DWORD dwX
   , BYVAL DWORD _                            ' DWORD dwY
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwTrans
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteAttachedSurface ( _           ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumAttachedSurfaces ( _            ' VTable offset = 36
     BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumOverlayZOrders ( _              ' VTable offset = 40
     BYVAL DWORD _                            ' DWORD dwFlags,
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpfnCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Flip ( _                            ' VTable offset = 44
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSurfaceTargetOverride
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAttachedSurface ( _              ' VTable offset = 48
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE FAR *lplpDDAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBltStatus ( _                    ' VTable offset = 52
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 56
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetClipper ( _                      ' VTable offset = 60
     BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR * lplpDDClippe
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetColorKey ( _                     ' VTable offset = 64
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDC ( _                           ' VTable offset = 68
     BYREF DWORD _                            ' HDCFAR *lphDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFlipStatus ( _                   ' VTable offset = 72
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetOverlayPosition ( _              ' VTable offset = 76
     BYREF LONG _                             ' LPLONG lplX
   , BYREF LONG _                             ' LPLONG lplY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPalette ( _                      ' VTable offset = 80
     BYREF IUnknown _                         ' LPLPDIRECTDRAWPALETTE lplpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPixelFormat ( _                  ' VTable offset = 84
     BYREF DDPIXELFORMAT _                    ' LPDDPIXELFORMAT lpDDPixelFormat
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSurfaceDesc ( _                  ' VTable offset = 88
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 92
     BYVAL IUnknown _                         ' LPDIRECTDRAW lpDD
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsLost ( _                          ' VTable offset = 96
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Lock ( _                            ' VTable offset = 100
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseDC ( _                       ' VTable offset = 104
     BYVAL DWORD _                            ' HDC hDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Restore ( _                         ' VTable offset = 108
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetClipper ( _                      ' VTable offset = 112
     BYVAL IUnknown _                         ' LPDIRECTDRAWCLIPPER lpDDClipper
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetColorKey ( _                     ' VTable offset = 116
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetOverlayPosition ( _              ' VTable offset = 120
     BYVAL LONG _                             ' LONG lX
   , BYVAL LONG _                             ' LONG lY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetPalette ( _                      ' VTable offset = 124
     BYVAL IUnknown _                         ' LPDIRECTDRAWPALETTE lpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unlock ( _                          ' VTable offset = 128
     BYVAL DWORD _                            ' LPVOID lpSurfaceData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlay ( _                   ' VTable offset = 132
     BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDDestSurface
   , BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDOVERLAYFX _                      ' LPDDOVERLAYFX lpDDOverlayFx
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayDisplay ( _            ' VTable offset = 136
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayZOrder ( _             ' VTable offset = 140
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSReference
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the v2 interface ***/
   ' =====================================================================================
   METHOD GetDDInterface ( _                  ' VTable offset = 144
      BYREF IUnknown _                        ' LPVOID FAR* lplpDD
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PageLock ( _                        ' VTable offset = 148
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PageUnlock ( _                      ' VTable offset = 152
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the V3 interface ***/
   ' =====================================================================================
   METHOD SetSurfaceDesc ( _                  ' VTable offset = 156
     BYREF DDSURFACEDESC2 _                   ' LPDDSURFACEDESC2 lpddsd2
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawSurface3


' ########################################################################################
' Interface name = IDirectDrawSurface4
' Inherited interface = IDirectDrawSurface3
' ########################################################################################

INTERFACE IDirectDrawSurface4 $IID_IDirectDrawSurface4

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddAttachedSurface ( _              ' VTable offset = 12
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddOverlayDirtyRect ( _             ' VTable offset = 16
     BYREF RECT _                             ' LPRECT lpRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Blt ( _                             ' VTable offset = 20
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDBLTFX _                          ' LPDDBLTFX lpDDBltFX
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltBatch ( _                        ' VTable offset = 24
     BYREF DDBLTBATCH _                       ' LPDDBLTBATCH lpDDBltBatch
   , BYVAL DWORD _                            ' DWORD dwCount
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltFast ( _                         ' VTable offset = 28
     BYVAL DWORD _                            ' DWORD dwX
   , BYVAL DWORD _                            ' DWORD dwY
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwTrans
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteAttachedSurface ( _           ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumAttachedSurfaces ( _            ' VTable offset = 36
     BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumOverlayZOrders ( _              ' VTable offset = 40
     BYVAL DWORD _                            ' DWORD dwFlags,
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpfnCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Flip ( _                            ' VTable offset = 44
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSurfaceTargetOverride
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAttachedSurface ( _              ' VTable offset = 48
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE FAR *lplpDDAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBltStatus ( _                    ' VTable offset = 52
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 56
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetClipper ( _                      ' VTable offset = 60
     BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR * lplpDDClippe
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetColorKey ( _                     ' VTable offset = 64
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDC ( _                           ' VTable offset = 68
     BYREF DWORD _                            ' HDCFAR *lphDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFlipStatus ( _                   ' VTable offset = 72
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetOverlayPosition ( _              ' VTable offset = 76
     BYREF LONG _                             ' LPLONG lplX
   , BYREF LONG _                             ' LPLONG lplY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPalette ( _                      ' VTable offset = 80
     BYREF IUnknown _                         ' LPLPDIRECTDRAWPALETTE lplpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPixelFormat ( _                  ' VTable offset = 84
     BYREF DDPIXELFORMAT _                    ' LPDDPIXELFORMAT lpDDPixelFormat
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSurfaceDesc ( _                  ' VTable offset = 88
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 92
     BYVAL IUnknown _                         ' LPDIRECTDRAW lpDD
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsLost ( _                          ' VTable offset = 96
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Lock ( _                            ' VTable offset = 100
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseDC ( _                       ' VTable offset = 104
     BYVAL DWORD _                            ' HDC hDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Restore ( _                         ' VTable offset = 108
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetClipper ( _                      ' VTable offset = 112
     BYVAL IUnknown _                         ' LPDIRECTDRAWCLIPPER lpDDClipper
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetColorKey ( _                     ' VTable offset = 116
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetOverlayPosition ( _              ' VTable offset = 120
     BYVAL LONG _                             ' LONG lX
   , BYVAL LONG _                             ' LONG lY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetPalette ( _                      ' VTable offset = 124
     BYVAL IUnknown _                         ' LPDIRECTDRAWPALETTE lpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unlock ( _                          ' VTable offset = 128
     BYVAL DWORD _                            ' LPVOID lpSurfaceData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlay ( _                   ' VTable offset = 132
     BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDDestSurface
   , BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDOVERLAYFX _                      ' LPDDOVERLAYFX lpDDOverlayFx
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayDisplay ( _            ' VTable offset = 136
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayZOrder ( _             ' VTable offset = 140
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSReference
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the v2 interface ***/
   ' =====================================================================================
   METHOD GetDDInterface ( _                  ' VTable offset = 144
      BYREF IUnknown _                        ' LPVOID FAR* lplpDD
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PageLock ( _                        ' VTable offset = 148
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PageUnlock ( _                      ' VTable offset = 152
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the V3 interface ***/
   ' =====================================================================================
   METHOD SetSurfaceDesc ( _                  ' VTable offset = 156
     BYREF DDSURFACEDESC2 _                   ' LPDDSURFACEDESC2 lpddsd2
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the v4 interface ***/
   ' =====================================================================================
   METHOD SetPrivateData ( _                  ' VTable offset = 160
     BYREF GUID _                             ' REFGUID guidTag
   , BYVAL DWORD _                            ' LPVOID lpData
   , BYVAL DWORD _                            ' DWORD cbSize
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPrivateData ( _                  ' VTable offset = 164
     BYREF GUID _                             ' REFGUID guidTag
   , BYVAL DWORD _                            ' LPVOID lpBuffer
   , BYREF DWORD _                            ' LPDWORD lpcbBufferSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FreePrivateData ( _                 ' VTable offset = 168
     BYREF GUID _                             ' REFGUID guidTag
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetUniquenessValue ( _              ' VTable offset = 172
     BYREF DWORD _                            ' LPDWORD lpValue
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ChangeUniquenessValue ( _           ' VTable offset = 176
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawSurface4


' ########################################################################################
' Interface name = IDirectDrawSurface7
' Inherited interface = IDirectDrawSurface4
' ########################################################################################

INTERFACE IDirectDrawSurface7 $IID_IDirectDrawSurface7

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddAttachedSurface ( _              ' VTable offset = 12
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD AddOverlayDirtyRect ( _             ' VTable offset = 16
     BYREF RECT _                             ' LPRECT lpRect
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Blt ( _                             ' VTable offset = 20
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDBLTFX _                          ' LPDDBLTFX lpDDBltFX
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltBatch ( _                        ' VTable offset = 24
     BYREF DDBLTBATCH _                       ' LPDDBLTBATCH lpDDBltBatch
   , BYVAL DWORD _                            ' DWORD dwCount
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD BltFast ( _                         ' VTable offset = 28
     BYVAL DWORD _                            ' DWORD dwX
   , BYVAL DWORD _                            ' DWORD dwY
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSrcSurface
   , BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL DWORD _                            ' DWORD dwTrans
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD DeleteAttachedSurface ( _           ' VTable offset = 32
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumAttachedSurfaces ( _            ' VTable offset = 36
     BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD EnumOverlayZOrders ( _              ' VTable offset = 40
     BYVAL DWORD _                            ' DWORD dwFlags,
   , BYVAL DWORD _                            ' LPVOID lpContext
   , BYVAL DWORD _                            ' LPDDENUMSURFACESCALLBACK lpfnCallback
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Flip ( _                            ' VTable offset = 44
     BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSurfaceTargetOverride
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetAttachedSurface ( _              ' VTable offset = 48
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   , BYREF IUnknown _                         ' LPLPDIRECTDRAWSURFACE FAR *lplpDDAttachedSurface
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetBltStatus ( _                    ' VTable offset = 52
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetCaps ( _                         ' VTable offset = 56
     BYREF DDSCAPS _                          ' LPDDSCAPS lpDDSCaps
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetClipper ( _                      ' VTable offset = 60
     BYREF IUnknown _                         ' LPDIRECTDRAWCLIPPER FAR * lplpDDClippe
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetColorKey ( _                     ' VTable offset = 64
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetDC ( _                           ' VTable offset = 68
     BYREF DWORD _                            ' HDCFAR *lphDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetFlipStatus ( _                   ' VTable offset = 72
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetOverlayPosition ( _              ' VTable offset = 76
     BYREF LONG _                             ' LPLONG lplX
   , BYREF LONG _                             ' LPLONG lplY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPalette ( _                      ' VTable offset = 80
     BYREF IUnknown _                         ' LPLPDIRECTDRAWPALETTE lplpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPixelFormat ( _                  ' VTable offset = 84
     BYREF DDPIXELFORMAT _                    ' LPDDPIXELFORMAT lpDDPixelFormat
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetSurfaceDesc ( _                  ' VTable offset = 88
     BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Initialize ( _                      ' VTable offset = 92
     BYVAL IUnknown _                         ' LPDIRECTDRAW lpDD
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD IsLost ( _                          ' VTable offset = 96
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Lock ( _                            ' VTable offset = 100
     BYREF RECT _                             ' LPRECT lpDestRect
   , BYREF DDSURFACEDESC _                    ' LPDDSURFACEDESC lpDDSurfaceDesc
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL DWORD _                            ' HANDLE hEvent
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ReleaseDC ( _                       ' VTable offset = 104
     BYVAL DWORD _                            ' HDC hDC
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Restore ( _                         ' VTable offset = 108
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetClipper ( _                      ' VTable offset = 112
     BYVAL IUnknown _                         ' LPDIRECTDRAWCLIPPER lpDDClipper
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetColorKey ( _                     ' VTable offset = 116
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDCOLORKEY _                       ' LPDDCOLORKEY lpDDColorKey
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetOverlayPosition ( _              ' VTable offset = 120
     BYVAL LONG _                             ' LONG lX
   , BYVAL LONG _                             ' LONG lY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetPalette ( _                      ' VTable offset = 124
     BYVAL IUnknown _                         ' LPDIRECTDRAWPALETTE lpDDPalette
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Unlock ( _                          ' VTable offset = 128
     BYVAL DWORD _                            ' LPVOID lpSurfaceData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlay ( _                   ' VTable offset = 132
     BYREF RECT _                             ' LPRECT lpSrcRect
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDDestSurface
   , BYREF RECT _                             ' LPRECT lpDestRect
   , BYVAL DWORD _                            ' DWORD dwFlags
   , BYREF DDOVERLAYFX _                      ' LPDDOVERLAYFX lpDDOverlayFx
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayDisplay ( _            ' VTable offset = 136
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD UpdateOverlayZOrder ( _             ' VTable offset = 140
     BYVAL DWORD _                            ' DWORD dwFlags
   , BYVAL IUnknown _                         ' LPDIRECTDRAWSURFACE lpDDSReference
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the v2 interface ***/
   ' =====================================================================================
   METHOD GetDDInterface ( _                  ' VTable offset = 144
      BYREF IUnknown _                        ' LPVOID FAR* lplpDD
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PageLock ( _                        ' VTable offset = 148
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD PageUnlock ( _                      ' VTable offset = 152
     BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the V3 interface ***/
   ' =====================================================================================
   METHOD SetSurfaceDesc ( _                  ' VTable offset = 156
     BYREF DDSURFACEDESC2 _                   ' LPDDSURFACEDESC2 lpddsd2
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Added in the v4 interface ***/
   ' =====================================================================================
   METHOD SetPrivateData ( _                  ' VTable offset = 160
     BYREF GUID _                             ' REFGUID guidTag
   , BYVAL DWORD _                            ' LPVOID lpData
   , BYVAL DWORD _                            ' DWORD cbSize
   , BYVAL DWORD _                            ' DWORD dwFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPrivateData ( _                  ' VTable offset = 164
     BYREF GUID _                             ' REFGUID guidTag
   , BYVAL DWORD _                            ' LPVOID lpBuffer
   , BYREF DWORD _                            ' LPDWORD lpcbBufferSize
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD FreePrivateData ( _                 ' VTable offset = 168
     BYREF GUID _                             ' REFGUID guidTag
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetUniquenessValue ( _              ' VTable offset = 172
     BYREF DWORD _                            ' LPDWORD lpValue
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD ChangeUniquenessValue ( _           ' VTable offset = 176
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   ' /*** Moved Texture7 methods here ***/
   ' =====================================================================================
   METHOD SetPriority ( _                     ' VTable offset = 180
     BYVAL DWORD _                            ' DWORD dwPriority
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetPriority ( _                     ' VTable offset = 184
     BYVAL DWORD _                            ' LPDWORD lpdwPriority
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetLOD ( _                          ' VTable offset = 188
     BYVAL DWORD _                            ' DWORD dwMaxLOD
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetLOD ( _                          ' VTable offset = 192
     BYREF DWORD _                            ' LPDWORD lpdwMaxLOD
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawSurface7


' ########################################################################################
' Interface name = IDirectDrawColorControl
' Inherited interface = IUnknown
' ########################################################################################

INTERFACE IDirectDrawColorControl $IID_IDirectDrawColorControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetColorControls ( _                ' VTable offset = 12
     BYREF DDCOLORCONTROL _                   ' LPDDCOLORCONTROL lpColorControl
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetColorControls ( _                ' VTable offset = 16
     BYREF DDCOLORCONTROL _                   ' LPDDCOLORCONTROL lpColorControl
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawColorControl


' ########################################################################################
' Interface name = IDirectDrawGammaControl
' Inherited interface = IUnknown
' ########################################################################################

INTERFACE IDirectDrawGammaControl $IID_IDirectDrawGammaControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetGammaRamp ( _                    ' VTable offset = 12
     BYVAL DWORD _                            ' DWORD  dwFlags
   , BYREF DDGAMMARAMP _                      ' LPDDGAMMARAMP lpGammaRamp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetGammaRamp ( _                    ' VTable offset = 16
     BYVAL DWORD _                            ' DWORD  dwFlags
   , BYREF DDGAMMARAMP _                      ' LPDDGAMMARAMP lpGammaRamp
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE ' IDirectDrawGammaControl

#ENDIF   ' #IF NOT %DEF(%DDRAW_INC)

%CDEF_CLASS_DEFAULT          = &H0001???
%CDEF_BYPASS_CLASS_MANAGER   = &H0002???
%CDEF_MERIT_ABOVE_DO_NOT_USE = &H0008???
%CDEF_DEVMON_CMGR_DEVICE     = &H0010???
%CDEF_DEVMON_DMO             = &H0020???
%CDEF_DEVMON_PNP_DEVICE      = &H0040???
%CDEF_DEVMON_FILTER          = &H0080???
%CDEF_DEVMON_SELECTIVE_MASK  = &H00f0???


' ########################################################################################
' Interface name = ICreateDevEnum
' IID = {29840822-5B84-11D0-BD3B-00A0C911CE86}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICreateDevEnum_INTERFACE_DEFINED)
    %ICreateDevEnum_INTERFACE_DEFINED = 1

$IID_ICreateDevEnum = GUID$("{29840822-5B84-11D0-BD3B-00A0C911CE86}")

INTERFACE ICreateDevEnum $IID_ICreateDevEnum

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateClassEnumerator ( _         ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ REFCLSID clsidDeviceClass
   , BYREF IUnknown _                       ' /* [out] */ IEnumMoniker **ppEnumMoniker
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICreateDevEnum_INTERFACE_DEFINED__ */


%CHARS_IN_GUID = 39     ' // 128 bits, plus { - } punctuation and terminal null
                        '  // chars NOT BYTES in the standard representation
                        '  // e.g. {D3588AB0-0781-11ce-B03A-0020AF0BA770} + null

TYPE AM_MEDIA_TYPE
   majortype            AS GUID       ' GUID      majortype
   subtype              AS GUID       ' GUID      subtype
   bFixedSizeSamples    AS LONG       ' BOOL      bFixedSizeSamples
   bTemporalCompression AS LONG       ' BOOL      bTemporalCompression
   lSampleSize          AS DWORD      ' ULONG     lSampleSize
   formattype           AS GUID       ' GUID      formattype
   pUnk                 AS DWORD      ' IUnknown  *pUnk
   cbFormat             AS DWORD      ' ULONG     cbFormat
   pbFormat             AS BYTE PTR   ' [size_is(cbFormat)] BYTE *pbFormat
END TYPE

' enum PIN_DIRECTION
%PINDIR_INPUT  = 0
%PINDIR_OUTPUT = %PINDIR_INPUT + 1

%MAX_PIN_NAME    = 128
%MAX_FILTER_NAME = 128

'typedef LONGLONG REFERENCE_TIME;
'typedef double REFTIME;
'typedef DWORD_PTR HSEMAPHORE;
'typedef DWORD_PTR HEVENT;

TYPE ALLOCATOR_PROPERTIES
   cBuffers AS LONG                                     ' long cBuffers
   cbBuffer AS LONG                                     ' long cbBuffer
   cbAlign  AS LONG                                     ' long cbAlign
   cbPrefix AS LONG                                     ' long cbPrefix
END TYPE


' ########################################################################################
' Interface name = IPin
' IID = {56A86891-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPin_INTERFACE_DEFINED)
    %IPin_INTERFACE_DEFINED = 1

TYPE PIN_INFO
   pFilter AS DWORD PTR                                 ' IBaseFilter *pFilter
   dir     AS DWORD                                     ' PIN_DIRECTION dir
   achName AS STRING * 128 * 2                          ' WCHAR achName[ 128 ]
END TYPE

$IID_IPin = GUID$("{56A86891-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IPin $IID_IPin

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Connect ( _                       ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ IPin *pReceivePin
   , BYREF AM_MEDIA_TYPE _                  ' /* [out] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReceiveConnection ( _             ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ IPin *pConnector
   , BYREF AM_MEDIA_TYPE _                  ' /* [out] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Disconnect ( _                    ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ConnectedTo ( _                   ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IPin **ppPin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ConnectionMediaType ( _           ' VTable offset = 28
     BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QueryPinInfo ( _                  ' VTable offset = 32
     BYREF PIN_INFO _                       ' [out] PIN_INFO *pInfo
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QueryDirection ( _                ' VTable offset = 36
     BYREF LONG _                           ' /* [out] */ PIN_DIRECTION *pPinDir
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QueryId ( _                       ' VTable offset = 40
     BYREF DWORD _                          ' /* [out] */ LPWSTR *Id
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QueryAccept ( _                   ' VTable offset = 44
     BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumMediaTypes ( _                ' VTable offset = 48
     BYREF IUnknown _                       ' /* [out] */ IEnumMediaTypes **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QueryInternalConnections ( _      ' VTable offset = 52
     BYREF IUnknown _                       ' /* [out] */ IPin **apPin
   , BYREF DWORD _                          ' [in][out] ULONG *nPin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EndOfStream ( _                   ' VTable offset = 56
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD BeginFlush ( _                    ' VTable offset = 60
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EndFlush ( _                      ' VTable offset = 64
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD NewSegment ( _                    ' VTable offset = 68
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME tStart
   , BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME tStop
   , BYVAL DOUBLE _                         ' /* [in] */ double dRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPin_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IEnumPins
' IID = {56A86892-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumPins_INTERFACE_DEFINED)
    %IEnumPins_INTERFACE_DEFINED = 1

$IID_IEnumPins = GUID$("{56A86892-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IEnumPins $IID_IEnumPins

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                          ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ ULONG cPins
   , BYREF IUnknown _                       ' /* [out] */ IPin **ppPins
   , BYREF DWORD _                          ' /* [out] */ ULONG *pcFetched
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                          ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ ULONG cPins
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                         ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                         ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IEnumPins **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumPins_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IEnumMediaTypes
' IID = {89C31040-846B-11CE-97D3-00AA0055595A}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumMediaTypes_INTERFACE_DEFINED)
    %IEnumMediaTypes_INTERFACE_DEFINED = 1

$IID_IEnumMediaTypes = GUID$("{89C31040-846B-11CE-97D3-00AA0055595A}")

INTERFACE IEnumMediaTypes $IID_IEnumMediaTypes

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                          ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ ULONG cMediaTypes
   , BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE **ppMediaTypes
   , BYREF DWORD _                          ' /* [out] */ ULONG *pcFetched
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                          ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ ULONG cMediaTypes
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                         ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                         ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IEnumMediaTypes **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumMediaTypes_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IFilterGraph
' IID = {56A8689F-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IFilterGraph_INTERFACE_DEFINED)
    %IFilterGraph_INTERFACE_DEFINED = 1

$IID_IFilterGraph = GUID$("{56A8689F-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IFilterGraph $IID_IFilterGraph

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddFilter ( _                     ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYVAL DWORD _                          ' [in] LPCWSTR pName
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RemoveFilter ( _                  ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumFilters ( _                   ' VTable offset = 20
     BYREF IUnknown _                       ' /* [out] */ IEnumFilters **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FindFilterByName ( _              ' VTable offset = 24
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR pName
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ConnectDirect ( _                 ' VTable offset = 28
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IPin *ppinIn
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reconnect ( _                     ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Disconnect ( _                    ' VTable offset = 36
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDefaultSyncSource ( _          ' VTable offset = 40
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFilterGraph_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IEnumFilters
' IID = {56A86893-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumFilters_INTERFACE_DEFINED)
    %IEnumFilters_INTERFACE_DEFINED = 1

$IID_IEnumFilters = GUID$("{56A86893-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IEnumFilters $IID_IEnumFilters

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                          ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ ULONG cFilters
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppFilter
   , BYREF DWORD _                          ' /* [out] */ ULONG *pcFetched
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                          ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ ULONG cFilters
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                         ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                         ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IEnumFilters **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumFilters_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IMediaFilter
' IID = {56A86895-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IMediaFilter_INTERFACE_DEFINED)
    %IMediaFilter_INTERFACE_DEFINED = 1

$IID_IMediaFilter = GUID$("{56A86895-0AD4-11CE-B03A-0020AF0BA770}")

' enum FILTER_STATE
%State_Stopped = 1
%State_Paused  = 2
%State_Running = 3

INTERFACE IMediaFilter $IID_IMediaFilter

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                    ' VTable offset = 12
     BYREF GUID _                           ' /* [out] */ CLSID * pClassID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Stop ( _                          ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Pause ( _                         ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Run ( _                           ' VTable offset = 24
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME tStart
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetState ( _                      ' VTable offset = 28
     BYVAL DWORD _                          ' /* [in] */ DWORD dwMilliSecsTimeout
   , BYREF DWORD _                          ' /* [out] */ FILTER_STATE *State
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetSyncSource ( _                 ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IReferenceClock *pClock
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetSyncSource ( _                 ' VTable offset = 36
     BYREF IUnknown  _                      ' /* [out] */ IReferenceClock **pClock
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaFilter_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IBaseFilter
' IID = {56A86895-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IMediaFilter
' ########################################################################################

#IF NOT %DEF(%IBaseFilter_INTERFACE_DEFINED)
    %IBaseFilter_INTERFACE_DEFINED = 1

$IID_IBaseFilter = GUID$("{56A86895-0AD4-11CE-B03A-0020AF0BA770}")

TYPE FILTER_INFO
   achName AS STRING * %MAX_FILTER_NAME * 2             ' WCHAR achName[MAX_FILTER_NAME]
   pGraph  AS DWORD PTR                                 ' IFilterGraph *pGraph
END TYPE

INTERFACE IBaseFilter $IID_IBaseFilter

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                    ' VTable offset = 12
     BYREF GUID _                           ' /* [out] */ CLSID * pClassID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Stop ( _                          ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Pause ( _                         ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Run ( _                           ' VTable offset = 24
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME tStart
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetState ( _                      ' VTable offset = 28
     BYVAL DWORD _                          ' /* [in] */ DWORD dwMilliSecsTimeout
   , BYREF DWORD _                          ' /* [out] */ FILTER_STATE *State
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetSyncSource ( _                 ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IReferenceClock *pClock
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetSyncSource ( _                 ' VTable offset = 36
     BYREF IUnknown  _                      ' /* [out] */ IReferenceClock **pClock
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumPins ( _                      ' VTable offset = 40
     BYREF IUnknown _                       ' /* [out] */ IEnumPins **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FindPin ( _                       ' VTable offset = 44
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR Id
   , BYREF IUnknown _                       ' /* [out] */ IPin **ppPin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QueryFilterInfo ( _               ' VTable offset = 48
     BYREF FILTER_INFO _                    ' /* [out] */ FILTER_INFO *pInfo
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD JoinFilterGraph ( _               ' VTable offset = 52
     BYVAL IUnknown _                       ' /* [in] */ IFilterGraph *pGraph
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR pName
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QueryVendorInfo ( _               ' VTable offset = 56
     BYREF DWORD _                          ' /* [out] */ LPWSTR *pVendorInfo
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IBaseFilter_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IReferenceClock
' IID = {56A86897-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IReferenceClock_INTERFACE_DEFINED)
    %IReferenceClock_INTERFACE_DEFINED = 1

$IID_IReferenceClock = GUID$("{56A86897-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IReferenceClock $IID_IReferenceClock

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTime ( _                       ' VTable offset = 12
     BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *pTime
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AdviseTime ( _                    ' VTable offset = 16
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtBaseTime
   , BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtStreamTime
   , BYVAL DWORD _                          ' /* [in] */ HEVENT hEvent
   , BYREF DWORD _                          ' /* [out] */ DWORD_PTR *pdwAdviseCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AdvisePeriodic ( _                ' VTable offset = 20
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtStartTime
   , BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtPeriodTime
   , BYVAL DWORD _                          ' /* [in] */ HSEMAPHORE hSemaphore
   , BYREF DWORD _                          ' /* [out] */ DWORD_PTR *pdwAdviseCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Unadvise ( _                      ' VTable offset = 24
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwAdviseCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IReferenceClock_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IReferenceClock2
' IID = {36b73885-c2c8-11cf-8b46-00805f6cef60}
' Inherited interface = IReferenceClock
' ########################################################################################

#IF NOT %DEF(%IReferenceClock2_INTERFACE_DEFINED)
    %IReferenceClock2_INTERFACE_DEFINED = 1

$IID_IReferenceClock2 = GUID$("{36b73885-c2c8-11cf-8b46-00805f6cef60}")

INTERFACE IReferenceClock2 $IID_IReferenceClock2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTime ( _                       ' VTable offset = 12
     BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *pTime
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AdviseTime ( _                    ' VTable offset = 16
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtBaseTime
   , BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtStreamTime
   , BYVAL DWORD _                          ' /* [in] */ HEVENT hEvent
   , BYREF DWORD _                          ' /* [out] */ DWORD_PTR *pdwAdviseCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AdvisePeriodic ( _                ' VTable offset = 20
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtStartTime
   , BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtPeriodTime
   , BYVAL DWORD _                          ' /* [in] */ HSEMAPHORE hSemaphore
   , BYREF DWORD _                          ' /* [out] */ DWORD_PTR *pdwAdviseCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Unadvise ( _                      ' VTable offset = 24
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwAdviseCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IReferenceClock2_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IMediaSample
' IID = {56a8689a-0ad4-11ce-b03a-0020af0ba770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMediaSample_INTERFACE_DEFINED)
    %IMediaSample_INTERFACE_DEFINED = 1

$IID_IMediaSample = GUID$("{56a8689a-0ad4-11ce-b03a-0020af0ba770}")

INTERFACE IMediaSample $IID_IMediaSample

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetPointer ( _                    ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ BYTE **ppBuffer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetSize ( _                       ' VTable offset = 16
   ) AS LONG                                ' long
   ' =====================================================================================
   METHOD GetTime ( _                       ' VTable offset = 20
     BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *pTimeStart
   , BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *pTimeEnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTime ( _                       ' VTable offset = 24
     BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pTimeStart
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pTimeEnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsSyncPoint ( _                   ' VTable offset = 28
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetSyncPoint ( _                  ' VTable offset = 32
     BYVAL LONG _                           ' /* [in] */ BOOL bIsSyncPoint
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsPreroll ( _                     ' VTable offset = 36
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetPreroll ( _                    ' VTable offset = 40
     BYVAL bIsPreroll AS LONG _             ' /* [in] */ BOOL bIsPreroll
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetActualDataLength ( _           ' VTable offset = 44
   ) AS LONG                                ' long
   ' =====================================================================================
   METHOD SetActualDataLength ( _           ' VTable offset = 48
     BYVAL LONG _                           ' /* [in] */ long lLen
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMediaType ( _                  ' VTable offset = 52
     BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE **ppMediaType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetMediaType ( _                  ' VTable offset = 56
     BYREF AM_MEDIA_TYPE _                  ' /* [in] */ AM_MEDIA_TYPE *ppMediaType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsDiscontinuity ( _               ' VTable offset = 60
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDiscontinuity ( _              ' VTable offset = 64
     BYVAL LONG _                           ' /* [out] */ BOOL bDiscontinuity
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMediaTime ( _                  ' VTable offset = 68
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pTimeStart
   , BYREF QUAD _                           ' /* [out] */ LONGLONG *pTimeEnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetMediaTime ( _                  ' VTable offset = 72
     BYVAL QUAD _                           ' /* [in] */ LONGLONG *pTimeStart
   , BYVAL QUAD _                           ' /* [in] */ LONGLONG *pTimeEnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaSample_INTERFACE_DEFINED__*/


' enum AM_SAMPLE_PROPERTY_FLAGS
%AM_SAMPLE_SPLICEPOINT       = &H1
%AM_SAMPLE_PREROLL           = &H2
%AM_SAMPLE_DATADISCONTINUITY = &H4
%AM_SAMPLE_TYPECHANGED       = &H8
%AM_SAMPLE_TIMEVALID         = &H10
%AM_SAMPLE_TIMEDISCONTINUITY = &H40
%AM_SAMPLE_FLUSH_ON_PAUSE    = &H80
%AM_SAMPLE_STOPVALID         = &H100
%AM_SAMPLE_ENDOFSTREAM       = &H200
%AM_STREAM_MEDIA             = 0
%AM_STREAM_CONTROL           = 1

TYPE AM_SAMPLE2_PROPERTIES
   cbData              AS DWORD               ' DWORD cbData
   dwTypeSpecificFlags AS DWORD               ' DWORD dwTypeSpecificFlags
   dwSampleFlags       AS DWORD               ' DWORD dwSampleFlags
   lActual             AS LONG                ' LONG lActual
   tStart              AS QUAD                ' REFERENCE_TIME tStart
   tStop               AS QUAD                ' REFERENCE_TIME tStop
   dwStreamId          AS DWORD               ' DWORD dwStreamId
   pMediaType          AS AM_MEDIA_TYPE PTR   ' AM_MEDIA_TYPE *pMediaType
   pbBuffer            AS BYTE PTR            ' BYTE *pbBuffer
   cbBuffer            AS LONG                ' LONG cbBuffer
END TYPE

' ########################################################################################
' Interface name = IMediaSample2
' IID = {36b73884-c2c8-11cf-8b46-00805f6cef60}
' Inherited interface = IMediaSample
' ########################################################################################

#IF NOT %DEF(%IMediaSample2_INTERFACE_DEFINED)
    %IMediaSample2_INTERFACE_DEFINED = 1

$IID_IMediaSample2 = GUID$("{36b73884-c2c8-11cf-8b46-00805f6cef60}")

INTERFACE IMediaSample2 $IID_IMediaSample2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetPointer ( _                    ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ BYTE **ppBuffer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetSize ( _                       ' VTable offset = 16
   ) AS LONG                                ' long
   ' =====================================================================================
   METHOD GetTime ( _                       ' VTable offset = 20
     BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *pTimeStart
   , BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *pTimeEnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTime ( _                       ' VTable offset = 24
     BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pTimeStart
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pTimeEnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsSyncPoint ( _                   ' VTable offset = 28
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetSyncPoint ( _                  ' VTable offset = 32
     BYVAL LONG _                           ' /* [in] */ BOOL bIsSyncPoint
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsPreroll ( _                     ' VTable offset = 36
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetPreroll ( _                    ' VTable offset = 40
     BYVAL LONG _                           ' /* [in] */ BOOL bIsPreroll
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetActualDataLength ( _           ' VTable offset = 44
   ) AS LONG                                ' long
   ' =====================================================================================
   METHOD SetActualDataLength ( _           ' VTable offset = 48
     BYVAL LONG _                           ' /* [in] */ long lLen
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMediaType ( _                  ' VTable offset = 52
     BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE **ppMediaType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetMediaType ( _                  ' VTable offset = 56
     BYREF AM_MEDIA_TYPE _                  ' /* [in] */ AM_MEDIA_TYPE *ppMediaType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsDiscontinuity ( _               ' VTable offset = 60
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDiscontinuity ( _              ' VTable offset = 64
     BYVAL LONG _                           ' /* [out] */ BOOL bDiscontinuity
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMediaTime ( _                  ' VTable offset = 68
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pTimeStart
   , BYREF QUAD _                           ' /* [out] */ LONGLONG *pTimeEnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetMediaTime ( _                  ' VTable offset = 72
     BYVAL QUAD _                           ' /* [in] */ LONGLONG *pTimeStart
   , BYVAL QUAD _                           ' /* [in] */ LONGLONG *pTimeEnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetProperties ( _                 ' VTable offset = 76
     BYVAL DWORD _                          ' /* [in] */ DWORD cbProperties
   , BYVAL BYTE PTR _                       ' /* [out] */ BYTE *pbProperties
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetProperties ( _                 ' VTable offset = 80
     BYVAL DWORD _                          ' /* [in] */ DWORD cbProperties
   , BYVAL BYTE PTR _                       ' /* [in] */ const BYTE *pbProperties
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaSample2_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IMediaSample2Config
' IID = {68961E68-832B-41EA-BC91-63593F3E70E3}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMediaSample2Config_INTERFACE_DEFINED)
    %IMediaSample2Config_INTERFACE_DEFINED = 1

$IID_IMediaSample2Config = GUID$("{68961E68-832B-41EA-BC91-63593F3E70E3}")

INTERFACE IMediaSample2Config $IID_IMediaSample2Config

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetSurface ( _                    ' VTable offset = 12
     BYREF IUnknown _                       ' /* [out] */ IUnknown **ppDirect3DSurface9
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaSample2Config_INTERFACE_DEFINED__*/


%AM_GBF_PREVFRAMESKIPPED = 1
%AM_GBF_NOTASYNCPOINT    = 2
%AM_GBF_NOWAIT           = 4
%AM_GBF_NODDSURFACELOCK  = 8


' ########################################################################################
' Interface name = IMemAllocator
' IID = {56a8689c-0ad4-11ce-b03a-0020af0ba770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMemAllocator_INTERFACE_DEFINED)
    %IMemAllocator_INTERFACE_DEFINED = 1

$IID_IMemAllocator = GUID$("{56a8689c-0ad4-11ce-b03a-0020af0ba770}")

INTERFACE IMemAllocator $IID_IMemAllocator

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetProperties ( _                 ' VTable offset = 12
     BYREF ALLOCATOR_PROPERTIES _           ' /* [in] */ ALLOCATOR_PROPERTIES *pRequest
   , BYREF ALLOCATOR_PROPERTIES _           ' /* [out] */ ALLOCATOR_PROPERTIES *pActual
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetProperties ( _                 ' VTable offset = 16
     BYREF ALLOCATOR_PROPERTIES _           ' /* [out] */ ALLOCATOR_PROPERTIES *pProps
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Commit ( _                        ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Decommit ( _                      ' VTable offset = 24
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetBuffer ( _                     ' VTable offset = 28
     BYREF IUnknown _                       ' /* [out] */ IMediaSample **ppBuffer
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pStartTime
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pEndTime
   , BYREF DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReleaseBuffer ( _                 ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IMediaSample *pBuffer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMemAllocator_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IMemAllocatorCallbackTemp
' IID = {379a0cf0-c1de-11d2-abf5-00a0c905f375}
' Inherited interface = IMemAllocator
' ########################################################################################

#IF NOT %DEF(%IMemAllocatorCallbackTemp_INTERFACE_DEFINED)
    %IMemAllocatorCallbackTemp_INTERFACE_DEFINED = 1

$IID_IMemAllocatorCallbackTemp = GUID$("{379a0cf0-c1de-11d2-abf5-00a0c905f375}")

INTERFACE IMemAllocatorCallbackTemp $IID_IMemAllocatorCallbackTemp

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetProperties ( _                 ' VTable offset = 12
     BYREF ALLOCATOR_PROPERTIES _           ' /* [in] */ ALLOCATOR_PROPERTIES *pRequest
   , BYREF ALLOCATOR_PROPERTIES _           ' /* [out] */ ALLOCATOR_PROPERTIES *pActual
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetProperties ( _                 ' VTable offset = 16
     BYREF ALLOCATOR_PROPERTIES _           ' /* [out] */ ALLOCATOR_PROPERTIES *pProps
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Commit ( _                        ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Decommit ( _                      ' VTable offset = 24
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetBuffer ( _                     ' VTable offset = 28
     BYREF IUnknown _                       ' /* [out] */ IMediaSample **ppBuffer
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pStartTime
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pEndTime
   , BYREF DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReleaseBuffer ( _                 ' VTable offset = 32
     BYREF IUnknown _                       ' /* [in] */ IMediaSample *pBuffer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetNotify ( _                     ' VTable offset = 36
     BYVAL IUnknown _                       ' /* [in] */ IMemAllocatorNotifyCallbackTemp *pNotify
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetFreeCount ( _                  ' VTable offset = 40
     BYREF LONG _                           ' /* [out] */ LONG *plBuffersFree
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMemAllocatorCallbackTemp_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IMemAllocatorNotifyCallbackTemp
' IID = {92980b30-c1de-11d2-abf5-00a0c905f375}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMemAllocatorNotifyCallbackTemp_INTERFACE_DEFINED)
    %IMemAllocatorNotifyCallbackTemp_INTERFACE_DEFINED = 1

$IID_IMemAllocatorNotifyCallbackTemp = GUID$("{92980b30-c1de-11d2-abf5-00a0c905f375}")

INTERFACE IMemAllocatorNotifyCallbackTemp $IID_IMemAllocatorNotifyCallbackTemp

   INHERIT IUnknown

   ' =====================================================================================
   METHOD NotifyRelease ( _                 ' VTable offset = 12
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMemAllocatorNotifyCallbackTemp_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IMemInputPin
' IID = {56A8689D-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMemInputPin_INTERFACE_DEFINED)
    %IMemInputPin_INTERFACE_DEFINED = 1

$IID_IMemInputPin = GUID$("{56A8689D-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IMemInputPin $IID_IMemInputPin

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetAllocator ( _                  ' VTable offset = 12
     BYREF IUnknown _                       ' /* [out] */ IMemAllocator **ppAllocator
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD NotifyAllocator ( _               ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IMemAllocator *pAllocator
   , BYVAL LONG _                           ' /* [in] */ BOOL bReadOnly
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAllocatorRequirements ( _      ' VTable offset = 20
     BYREF ALLOCATOR_PROPERTIES _           ' /* [out] */ ALLOCATOR_PROPERTIES *pProps
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Receive ( _                       ' VTable offset = 28
     BYVAL IUnknown _                       ' /* [in] */ IMediaSample *pSample
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReceiveMultiple ( _               ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IMediaSample **pSamples
   , BYVAL LONG _                           ' /* [in] */ long nSamples
   , BYREF LONG _                           ' /* [out] */ long *nSamplesProcessed
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReceiveCanBlock ( _               ' VTable offset = 36
     ) AS LONG                              ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMemInputPin_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMovieSetup
' IID = {A3D8CEC0-7E5A-11CF-BBC5-00805F6CEF20}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMovieSetup_INTERFACE_DEFINED)
    %IAMovieSetup_INTERFACE_DEFINED = 1

$IID_IAMovieSetup = GUID$("{A3D8CEC0-7E5A-11CF-BBC5-00805F6CEF20}")

INTERFACE IAMovieSetup $IID_IAMovieSetup

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Register ( _                      ' VTable offset = 12
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Unregister ( _                    ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMovieSetup_INTERFACE_DEFINED__*/


' enum AM_SEEKING_SeekingFlags
%AM_SEEKING_NoPositioning          = 0
%AM_SEEKING_AbsolutePositioning    = &H1
%AM_SEEKING_RelativePositioning    = &H2
%AM_SEEKING_IncrementalPositioning = &H3
%AM_SEEKING_PositioningBitsMask    = &H3
%AM_SEEKING_SeekToKeyFrame         = &H4
%AM_SEEKING_ReturnTime             = &H8
%AM_SEEKING_Segment                = &H10
%AM_SEEKING_NoFlush                = &H20

' enum AM_SEEKING_SeekingCapabilities
%AM_SEEKING_CanSeekAbsolute        = &H1
%AM_SEEKING_CanSeekForwards        = &H2
%AM_SEEKING_CanSeekBackwards       = &H4
%AM_SEEKING_CanGetCurrentPos       = &H8
%AM_SEEKING_CanGetStopPos          = &H10
%AM_SEEKING_CanGetDuration         = &H20
%AM_SEEKING_CanPlayBackwards       = &H40
%AM_SEEKING_CanDoSegments          = &H80
%AM_SEEKING_Source                 = &H100


' ########################################################################################
' Interface name = IMediaSeeking
' IID = {36B73880-C2C8-11CF-8B46-00805F6CEF60}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMediaSeeking_INTERFACE_DEFINED)
    %IMediaSeeking_INTERFACE_DEFINED = 1

$IID_IMediaSeeking = GUID$("{36B73880-C2C8-11CF-8B46-00805F6CEF60}")

INTERFACE IMediaSeeking $IID_IMediaSeeking

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCapabilities ( _               ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ DWORD *pCapabilities
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CheckCapabilities ( _             ' VTable offset = 16
     BYREF DWORD _                          ' /* [out][in] */ DWORD *pCapabilities
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsFormatSupported ( _             ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ const GUID *pFormat
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QueryPreferredFormat ( _          ' VTable offset = 24
     BYREF GUID _                           ' /* [out] */ GUID *pFormat
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTimeFormat ( _                 ' VTable offset = 28
     BYREF GUID _                           ' /* [out] */ GUID *pFormat
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsUsingTimeFormat ( _             ' VTable offset = 32
     BYREF GUID _                           ' /* [in] */ const GUID *pFormat
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTimeFormat ( _                 ' VTable offset = 36
     BYREF GUID _                           ' /* [in] */ const GUID *pFormat
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDuration ( _                   ' VTable offset = 40
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pDuration
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetStopPosition ( _               ' VTable offset = 44
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pStop
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentPosition ( _            ' VTable offset = 48
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pCurrent
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ConvertTimeFormat ( _             ' VTable offset = 52
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pTarget
   , BYREF GUID _                           ' /* [in] */ const GUID *pTargetFormat
   , BYVAL QUAD _                           ' /* [in] */ LONGLONG Source
   , BYREF GUID _                           ' /* [in] */ const GUID *pSourceFormat
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetPositions ( _                  ' VTable offset = 56
     BYREF QUAD _                           ' /* [out][in] */ LONGLONG *pCurrent
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwCurrentFlags
   , BYREF QUAD _                           ' /* [out][in] */ LONGLONG *pStop
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwStopFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetPositions ( _                  ' VTable offset = 60
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pCurrent
   , BYREF QUAD _                           ' /* [out] */ LONGLONG *pStop
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAvailable ( _                  ' VTable offset = 64
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pEarliest
   , BYREF QUAD _                           ' /* [out] */ LONGLONG *pLatest
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetRate ( _                       ' VTable offset = 68
     BYVAL DOUBLE _                         ' /* [in] */ double dRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetRate ( _                       ' VTable offset = 72
     BYREF DOUBLE _                         ' /* [out] */ double *pdRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetPreroll ( _                    ' VTable offset = 76
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pllPreroll
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaSeeking_INTERFACE_DEFINED__*/


' AM_MEDIAEVENT_FLAGS
%AM_MEDIAEVENT_NONOTIFY = &H01

TYPE REGFILTER
   clsid AS GUID                                        ' CLSID Clsid
   Name  AS WORD PTR                                    ' LPWSTR Name
END TYPE


' ########################################################################################
' Interface name = IEnumRegFilters
' IID = {56A868A4-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumRegFilters_INTERFACE_DEFINED)
    %IEnumRegFilters_INTERFACE_DEFINED = 1

$IID_IEnumRegFilters = GUID$("{56A868A4-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IEnumRegFilters $IID_IEnumRegFilters

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                          ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ ULONG cFilters
   , BYREF REGFILTER _                      ' /* [out] */ REGFILTER **apRegFilter
   , BYREF DWORD _                          ' /* [out] */ ULONG *pcFetched
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                          ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ ULONG cFilters
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                         ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                         ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IEnumRegFilters **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumRegFilters_INTERFACE_DEFINED__*/


' enum Merit
%MERIT_PREFERRED     = &H800000
%MERIT_NORMAL        = &H600000
%MERIT_UNLIKELY      = &H400000
%MERIT_DO_NOT_USE    = &H200000
%MERIT_SW_COMPRESSOR = &H100000
%MERIT_HW_COMPRESSOR = &H100050


' ########################################################################################
' Interface name = IFilterMapper
' IID = {56A868A3-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IFilterMapper_INTERFACE_DEFINED)
    %IFilterMapper_INTERFACE_DEFINED = 1

$IID_IFilterMapper = GUID$("{56A868A3-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IFilterMapper $IID_IFilterMapper

   INHERIT IUnknown

   ' =====================================================================================
   METHOD RegisterFilter ( _                ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ CLSID clsid
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR Name
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwMerit
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterFilterInstance ( _        ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ CLSID clsid
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR Name
   , BYREF GUID _                           ' /* [out] */ CLSID *MRId
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterPin ( _                   ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ CLSID Filter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR Name
   , BYVAL LONG _                           ' /* [in] */ BOOL bRendered
   , BYVAL LONG _                           ' /* [in] */ BOOL bOutput
   , BYVAL LONG _                           ' /* [in] */ BOOL bZero
   , BYVAL LONG _                           ' /* [in] */ BOOL bMany
   , BYREF GUID _                           ' /* [in] */ CLSID ConnectsToFilter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR ConnectsToPin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterPinType ( _               ' VTable offset = 24
     BYREF GUID _                           ' /* [in] */ CLSID clsFilter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR strName
   , BYREF GUID _                           ' /* [in] */ CLSID clsMajorType
   , BYREF GUID _                           ' /* [in] */ CLSID clsSubType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnregisterFilter ( _              ' VTable offset = 28
     BYREF GUID _                           ' /* [in] */ CLSID Filter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnregisterFilterInstance ( _      ' VTable offset = 32
     BYREF GUID _                           ' /* [in] */ CLSID MRId
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnregisterPin ( _                 ' VTable offset = 36
     BYREF GUID _                           ' /* [in] */ CLSID Filter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR Name
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumMatchingFilters ( _           ' VTable offset = 40
     BYREF IUnknown _                       ' /* [out] */ IEnumRegFilters **ppEnum,
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwMerit
   , BYVAL LONG _                           ' /* [in] */ BOOL bInputNeeded
   , BYREF GUID _                           ' /* [in] */ CLSID clsInMaj
   , BYREF GUID _                           ' /* [in] */ CLSID clsInSub
   , BYVAL LONG _                           ' /* [in] */ BOOL bRender
   , BYVAL LONG _                           ' /* [in] */ BOOL bOututNeeded
   , BYREF GUID _                           ' /* [in] */ CLSID clsOutMaj
   , BYREF GUID _                           ' /* [in] */ CLSID clsOutSub
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFilterMapper_INTERFACE_DEFINED__*/


TYPE REGPINTYPES
   clsMajorType             AS GUID              ' const CLSID *clsMajorType
   clsMinorType             AS GUID              ' const CLSID *clsMinorType
END TYPE

TYPE REGFILTERPINS
   strName                  AS WORD PTR          ' LPWSTR strName
   bRendered                AS LONG              ' BOOL bRendered
   bOutput                  AS LONG              ' BOOL bOutput
   bZero                    AS LONG              ' BOOL bZero
   bMany                    AS LONG              ' BOOL bMany
   clsConnectsToFilter      AS GUID              ' const CLSID *clsConnectsToFilter
   strConnectsToPin         AS DWORD             ' const WCHAR *strConnectsToPin
   nMediaTypes              AS DWORD             ' UINT nMediaTypes
   lpMediaType              AS REGPINTYPES PTR   ' const REGPINTYPES *lpMediaType
END TYPE

TYPE REGPINMEDIUM
   clsMedium                AS GUID              ' CLSID clsMedium
   dw1                      AS DWORD             ' DWORD dw1
   dw2                      AS DWORD             ' DWORD dw2
END TYPE

' REG_PINFLAG Enumeration
%REG_PINFLAG_B_ZERO     = &H1
%REG_PINFLAG_B_RENDERER = &H2
%REG_PINFLAG_B_MANY     = &H4
%REG_PINFLAG_B_OUTPUT   = &H8

TYPE REGFILTERPINS2
   dwFlags                  AS DWORD             ' DWORD dwFlags
   cInstances               AS DWORD             ' UINT cInstances
   nMediaTypes              AS DWORD             ' UINT nMediaTypes
   lpMediaType              AS REGPINTYPES PTR   ' const REGPINTYPES *lpMediaType
   nMediums                 AS DWORD             ' UINT nMediums
   lpMedium                 AS REGPINMEDIUM PTR  ' const REGPINMEDIUM *lpMedium
   clsPinCategory           AS GUID              ' const CLSID *clsPinCategory
END TYPE

TYPE REGFILTER2_0
   cPins                   AS DWORD              ' ULONG cPins
   rgPins                  AS REGFILTERPINS PTR  ' const REGFILTERPINS *rgPins
END TYPE

TYPE REGFILTER2_1
   cPins2                  AS DWORD              ' ULONG cPins2
   rgPins2                 AS REGFILTERPINS2 PTR ' const REGFILTERPINS2 *rgPins2
END TYPE

UNION REGFILTER2_UNION
   REGFILTER2_0
   REGFILTER2_1
END UNION

TYPE REGFILTER2
   dwVersion              AS DWORD               ' DWORD dwVersion
   dwMerit                AS DWORD               ' DWORD dwMerit
   REGFILTER2_UNION
END TYPE


' ########################################################################################
' Interface name = IFilterMapper2
' IID = {56A868A3-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IFilterMapper2_INTERFACE_DEFINED)
    %IFilterMapper2_INTERFACE_DEFINED = 1

$IID_IFilterMapper2 = GUID$("{56A868A3-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IFilterMapper2 $IID_IFilterMapper2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateCategory ( _                ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ REFCLSID clsidCategory
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwCategoryMerit
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR Description
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnregisterFilter ( _              ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ const CLSID *pclsidCategory
   , BYVAL DWORD _                          ' /* [in] */ const OLECHAR *szInstance
   , BYREF GUID _                           ' /* [in] */ REFCLSID Filter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterFilter ( _                ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ REFCLSID clsidFilter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR Name
   , BYREF IUnknown _                       ' /* [out][in] */ IMoniker **ppMoniker
   , BYREF GUID _                           ' /* [in] */ const CLSID *pclsidCategory
   , BYVAL DWORD _                          ' /* [in] */ const OLECHAR *szInstance
   , BYREF REGFILTER2 _                     ' /* [in] */ const REGFILTER2 *prf2
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumMatchingFilters ( _           ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IEnumMoniker **ppEnum
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYVAL LONG _                           ' /* [in] */ BOOL bExactMatch
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwMerit
   , BYVAL LONG _                           ' /* [in] */ BOOL bInputNeeded
   , BYVAL DWORD _                          ' /* [in] */ DWORD cInputTypes
   , BYREF GUID _                           ' /* [in] */ const GUID *pInputTypes
   , BYREF REGPINMEDIUM _                   ' /* [in] */ const REGPINMEDIUM *pMedIn
   , BYREF GUID _                           ' /* [in] */ const CLSID *pPinCategoryIn
   , BYVAL LONG _                           ' /* [in] */ BOOL bRender
   , BYVAL LONG _                           ' /* [in] */ BOOL bOutputNeeded
   , BYVAL DWORD _                          ' /* [in] */ DWORD cOutputTypes
   , BYREF GUID _                           ' /* [in] */ const GUID *pOutputTypes
   , BYREF REGPINMEDIUM _                   ' /* [in] */ const REGPINMEDIUM *pMedOut
   , BYREF GUID _                           ' /* [in] */ const CLSID *pPinCategoryOut
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFilterMapper2_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IFilterMapper3
' IID = {B79BB0B1-33C1-11D1-ABE1-00A0C905F375}
' Inherited interface = IFilterMapper2
' ########################################################################################

#IF NOT %DEF(%IFilterMapper3_INTERFACE_DEFINED)
    %IFilterMapper3_INTERFACE_DEFINED = 1

$IID_IFilterMapper3 = GUID$("{B79BB0B1-33C1-11D1-ABE1-00A0C905F375}")

INTERFACE IFilterMapper3 $IID_IFilterMapper3

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateCategory ( _                ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ REFCLSID clsidCategory
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwCategoryMerit
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR Description
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnregisterFilter ( _              ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ const CLSID *pclsidCategory
   , BYVAL DWORD _                          ' /* [in] */ const OLECHAR *szInstance
   , BYREF GUID _                           ' /* [in] */ REFCLSID Filter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterFilter ( _                ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ REFCLSID clsidFilter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR Name
   , BYREF IUnknown _                       ' /* [out][in] */ IMoniker **ppMoniker
   , BYREF GUID _                           ' /* [in] */ const CLSID *pclsidCategory
   , BYVAL DWORD _                          ' /* [in] */ const OLECHAR *szInstance
   , BYREF REGFILTER2 _                     ' /* [in] */ const REGFILTER2 *prf2
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumMatchingFilters ( _           ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IEnumMoniker **ppEnum
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYVAL LONG _                           ' /* [in] */ BOOL bExactMatch
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwMerit
   , BYVAL LONG _                           ' /* [in] */ BOOL bInputNeeded
   , BYVAL DWORD _                          ' /* [in] */ DWORD cInputTypes
   , BYREF GUID _                           ' /* [in] */ const GUID *pInputTypes
   , BYREF REGPINMEDIUM _                   ' /* [in] */ const REGPINMEDIUM *pMedIn
   , BYREF GUID _                           ' /* [in] */ const CLSID *pPinCategoryIn
   , BYVAL LONG _                           ' /* [in] */ BOOL bRender
   , BYVAL LONG _                           ' /* [in] */ BOOL bOutputNeeded
   , BYVAL DWORD _                          ' /* [in] */ DWORD cOutputTypes
   , BYREF GUID _                           ' /* [in] */ const GUID *pOutputTypes
   , BYREF REGPINMEDIUM _                   ' /* [in] */ const REGPINMEDIUM *pMedOut
   , BYREF GUID _                           ' /* [in] */ const CLSID *pPinCategoryOut
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetICreateDevEnum ( _             ' VTable offset = 28
     BYREF IUnknown _                       ' /* [out] */ ICreateDevEnum **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFilterMapper3_INTERFACE_DEFINED__*/


' enum QualityMessageType
%QualityMessageType_Famine = 0
%QualityMessageType_Flood  = %QualityMessageType_Famine + 1

TYPE Quality
   Type       AS DWORD                 ' QualityMessageType Type
   Proportion AS LONG                  ' long Proportion
   Late       AS QUAD                  ' REFERENCE_TIME Late
   TimeStamp  AS QUAD                  ' REFERENCE_TIME TimeStamp
END TYPE


' ########################################################################################
' Interface name = IQualityControl
' IID = {56A868A5-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IQualityControl_INTERFACE_DEFINED)
    %IQualityControl_INTERFACE_DEFINED = 1

$IID_IQualityControl = GUID$("{56A868A5-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IQualityControl $IID_IQualityControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Notify ( _                        ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pSelf
   , BYVAL Quality _                        ' /* [in] */ Quality q
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetSink ( _                       ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IQualityControl *piqc
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IQualityControl_INTERFACE_DEFINED__*/


%CK_NOCOLORKEY         = 0
%CK_INDEX              = &H1
%CK_RGB                = &H2

TYPE COLORKEY
   KeyType        AS DWORD             ' DWORD KeyType
   PaletteIndex   AS DWORD             ' DWORD PaletteIndex
   LowColorValue  AS DWORD             ' COLORREF LowColorValue
   HighColorValue AS DWORD             ' COLORREF HighColorValue
END TYPE

%ADVISE_NONE           = 0
%ADVISE_CLIPPING       = &H1
%ADVISE_PALETTE        = &H2
%ADVISE_COLORKEY       = &H4
%ADVISE_POSITION       = &H8
%ADVISE_DISPLAY_CHANGE = &H10

%ADVISE_ALL  = %ADVISE_CLIPPING OR %ADVISE_PALETTE OR %ADVISE_COLORKEY OR %ADVISE_POSITION
%ADVISE_ALL2 = %ADVISE_ALL OR %ADVISE_DISPLAY_CHANGE

TYPE RGNDATAHEADER
   dwSize   AS DWORD
   iType    AS DWORD
   nCount   AS DWORD
   nRgnSize AS DWORD
   rcBound  AS RECT
END TYPE

TYPE RGNDATA
   rdh AS RGNDATAHEADER      ' RGNDATAHEADER rdh
   Buffer AS STRING * 1      ' char Buffer[ 1 ] - arbitrary-size buffer
END TYPE


' ########################################################################################
' Interface name = IOverlayNotify
' IID = {56A868A0-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOverlayNotify_INTERFACE_DEFINED)
    %IOverlayNotify_INTERFACE_DEFINED = 1

$IID_IOverlayNotify = GUID$("{56A868A0-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IOverlayNotify $IID_IOverlayNotify

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnPaletteChange ( _               ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwColors
   , BYREF PALETTEENTRY _                   ' /* [in] */ const PALETTEENTRY *pPalette
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnClipChange ( _                  ' VTable offset = 16
     BYREF RECT _                           ' /* [in] */ const RECT *pSourceRect
   , BYREF RECT _                           ' /* [in] */ const RECT *pDestinationRect
   , BYREF RGNDATA _                        ' /* [in] */ const RGNDATA *pRgnData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnColorKeyChange ( _              ' VTable offset = 20
     BYREF COLORKEY              _          ' /* [in] */ const COLORKEY *pColorKey
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnPositionChange ( _              ' VTable offset = 24
     BYREF RECT _                           ' /* [in] */ const RECT *pSourceRect
   , BYREF RECT _                           ' /* [in] */ const RECT *pDestinationRect
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOverlayNotify_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IOverlayNotify2
' IID = {680EFA10-D535-11D1-87C8-00A0C9223196}
' Inherited interface = IOverlayNotify
' ########################################################################################

#IF NOT %DEF(%IOverlayNotify2_INTERFACE_DEFINED)
    %IOverlayNotify2_INTERFACE_DEFINED = 1

$IID_IOverlayNotify2 = GUID$("{680EFA10-D535-11D1-87C8-00A0C9223196}")

INTERFACE IOverlayNotify2 $IID_IOverlayNotify2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnPaletteChange ( _               ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwColors
   , BYREF PALETTEENTRY _                   ' /* [in] */ const PALETTEENTRY *pPalette
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnClipChange ( _                  ' VTable offset = 16
     BYREF RECT _                           ' /* [in] */ const RECT *pSourceRect
   , BYREF RECT _                           ' /* [in] */ const RECT *pDestinationRect
   , BYREF RGNDATA _                        ' /* [in] */ const RGNDATA *pRgnData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnColorKeyChange ( _              ' VTable offset = 20
     BYREF COLORKEY _                       ' /* [in] */ const COLORKEY *pColorKey
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnPositionChange ( _              ' VTable offset = 24
     BYREF RECT _                           ' /* [in] */ const RECT *pSourceRect
   , BYREF RECT _                           ' /* [in] */ const RECT *pDestinationRect
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnDisplayChange ( _               ' VTable offset = 28
     BYVAL DWORD _                          ' /* [in] */ HMONITOR hMonitor
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOverlayNotify2_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IOverlay
' IID = {56A868A1-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IOverlay_INTERFACE_DEFINED)
    %IOverlay_INTERFACE_DEFINED = 1

$IID_IOverlay = GUID$("{56A868A1-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IOverlay $IID_IOverlay

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetPalette ( _                    ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwColors
   , BYREF PALETTEENTRY _                   ' /* [out] */ PALETTEENTRY **ppPalette
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetPalette ( _                    ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ DWORD dwColors
   , BYREF PALETTEENTRY _                   ' /* [in] */ PALETTEENTRY *ppPalette
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDefaultColorKey ( _            ' VTable offset = 20
     BYREF COLORKEY _                       ' /* [out] */ COLORKEY *pColorKey
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetColorKey ( _                   ' VTable offset = 24
     BYREF COLORKEY _                       ' /* [out] */ COLORKEY *pColorKey
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetColorKey ( _                   ' VTable offset = 28
     BYREF COLORKEY _                       ' /* [out][in] */ COLORKEY *pColorKey
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetWindowHandle ( _               ' VTable offset = 32
     BYREF DWORD _                          ' /* [out] */ HWND *pHwnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetClipList ( _                   ' VTable offset = 36
     BYREF RECT _                           ' /* [out] */ RECT *pSourceRect
   , BYREF RECT _                           ' /* [out] */ RECT *pDestinationRect
   , BYREF DWORD _                          ' /* [out] */ RGNDATA **ppRgnData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetVideoPosition ( _              ' VTable offset = 40
     BYREF RECT _                           ' /* [out] */ RECT *pSourceRect
   , BYREF RECT _                           ' /* [out] */ RECT *pDestinationRect
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Advise ( _                        ' VTable offset = 44
     BYVAL IUnknown _                       ' /* [in] */ IOverlayNotify *pOverlayNotify
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwInterests
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Unadvise ( _                      ' VTable offset = 48
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IOverlay_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IMediaEventSink
' IID = {56A868A2-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMediaEventSink_INTERFACE_DEFINED)
    %IMediaEventSink_INTERFACE_DEFINED = 1

$IID_IMediaEventSink = GUID$("{56A868A2-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IMediaEventSink $IID_IMediaEventSink

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Notify ( _                        ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long EventCode
   , BYVAL DWORD _                          ' /* [in] */ LONG_PTR EventParam1
   , BYVAL DWORD _                          ' /* [in] */ LONG_PTR EventParam2
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaEventSink_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IFileSourceFilter
' IID = {56A868A6-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IFileSourceFilter_INTERFACE_DEFINED)
    %IFileSourceFilter_INTERFACE_DEFINED = 1

$IID_IFileSourceFilter = GUID$("{56A868A6-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IFileSourceFilter $IID_IFileSourceFilter

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Load ( _                          ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ LPCOLESTR pszFileName
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurFile ( _                    ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ LPOLESTR *ppszFileName
   , BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFileSourceFilter_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IFileSinkFilter
' IID = {A2104830-7C70-11CF-8BCE-00AA00A3F1A6}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IFileSinkFilter_INTERFACE_DEFINED)
    %IFileSinkFilter_INTERFACE_DEFINED = 1

$IID_IFileSinkFilter = GUID$("{A2104830-7C70-11CF-8BCE-00AA00A3F1A6}")

INTERFACE IFileSinkFilter $IID_IFileSinkFilter

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetFileName ( _                   ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ LPCOLESTR pszFileName
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetFileName ( _                   ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ LPOLESTR *ppszFileName
   , BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFileSinkFilter_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IFileSinkFilter2
' IID = {00855B90-CE1B-11D0-BD4F-00A0C911CE86}
' Inherited interface = IFileSinkFilter
' ########################################################################################

#IF NOT %DEF(%IFileSinkFilter2_INTERFACE_DEFINED)
    %IFileSinkFilter2_INTERFACE_DEFINED = 1

$IID_IFileSinkFilter2 = GUID$("{00855B90-CE1B-11D0-BD4F-00A0C911CE86}")

INTERFACE IFileSinkFilter2 $IID_IFileSinkFilter2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetMode ( _                       ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMode ( _                       ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFileSinkFilter2_INTERFACE_DEFINED__*/


' AM_FILESINK_FLAGS enum
%AM_FILE_OVERWRITE = &H1


' ########################################################################################
' Interface name = IGraphBuilder
' IID = {56A868A9-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IFilterGraph
' ########################################################################################

#IF NOT %DEF(%IGraphBuilder_INTERFACE_DEFINED)
    %IGraphBuilder_INTERFACE_DEFINED = 1

$IID_IGraphBuilder = GUID$("{56A868A9-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IGraphBuilder $IID_IGraphBuilder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddFilter ( _                     ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR pName
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RemoveFilter ( _                  ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumFilters ( _                   ' VTable offset = 20
     BYREF IUnknown _                       ' /* [out] */ IEnumFilters **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FindFilterByName ( _              ' VTable offset = 24
     BYVAL DWORD _                          ' [in] LPCWSTR pName
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ConnectDirect ( _                 ' VTable offset = 28
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IPin *ppinIn
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reconnect ( _                     ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Disconnect ( _                    ' VTable offset = 36
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDefaultSyncSource ( _          ' VTable offset = 40
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Connect ( _                       ' VTable offset = 44
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IPin *ppinIn
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Render ( _                        ' VTable offset = 48
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RenderFile ( _                    ' VTable offset = 52
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFile
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrPlayList
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AddSourceFilter ( _               ' VTable offset = 56
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFileName
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFilterName
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetLogFile ( _                    ' VTable offset = 60
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR hFile
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Abort ( _                         ' VTable offset = 64
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ShouldOperationContinue ( _       ' VTable offset = 68
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IGraphBuilder_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = ICaptureGraphBuilder
' IID = {BF87B6E0-8C27-11D0-B3F0-00AA003761C5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICaptureGraphBuilder_INTERFACE_DEFINED)
    %ICaptureGraphBuilder_INTERFACE_DEFINED = 1

$IID_ICaptureGraphBuilder = GUID$("{BF87B6E0-8C27-11D0-B3F0-00AA003761C5}")

INTERFACE ICaptureGraphBuilder $IID_ICaptureGraphBuilder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetFiltergraph ( _                ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IGraphBuilder *pfg
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetFiltergraph ( _                ' VTable offset = 16
     BYREF IUnknown _                       ' /* [out] */ IGraphBuilder **ppfg
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetOutputFileName ( _             ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ const GUID *pType
   , BYVAL DWORD _                          ' /* [in] */ LPCOLESTR lpstrFile
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppf
   , BYREF IUnknown _                       ' /* [out] */ IFileSinkFilter **ppSink
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FindInterface ( _                 ' VTable offset = 24
     BYREF DWORD _                          ' /* [in] */ const GUID *pCategory
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pf
   , BYREF GUID _                           ' /* [in] */ REFIID riid
   , BYREF IUnknown _                       ' /* [out] */ void **ppint
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RenderStream ( _                  ' VTable offset = 28
     BYREF GUID _                           ' /* [in] */ const GUID *pCategory
   , BYVAL IUnknown _                       ' /* [in] */ IUnknown *pSource
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pfCompressor
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pfRenderer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ControlStream ( _                 ' VTable offset = 32
     BYREF GUID _                           ' /* [in] */ const GUID *pCategory
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pstart
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pstop
   , BYVAL WORD _                           ' /* [in] */ WORD wStartCookie
   , BYVAL WORD _                           ' /* [in] */ WORD wStopCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AllocCapFile ( _                  ' VTable offset = 36
     BYVAL DWORD _                          ' /* [in] */ LPCOLESTR lpstr
   , BYVAL QUAD _                           ' /* [in] */ DWORDLONG dwlSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CopyCaptureFile ( _               ' VTable offset = 40
     BYVAL DWORD _                          ' /* [in] */ LPOLESTR lpwstrOld
   , BYVAL DWORD _                          ' /* [in] */ LPOLESTR lpwstrNew
   , BYVAL LONG _                           ' /* [in] */ int fAllowEscAbort
   , BYVAL IUnknown _                       ' /* [in] */ IAMCopyCaptureFileProgress *pCallback
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICaptureGraphBuilder_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMCopyCaptureFileProgress
' IID = {670D1D20-A068-11D0-B3F0-00AA003761C5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMCopyCaptureFileProgress_INTERFACE_DEFINED)
    %IAMCopyCaptureFileProgress_INTERFACE_DEFINED = 1

$IID_IAMCopyCaptureFileProgress = GUID$("{670D1D20-A068-11D0-B3F0-00AA003761C5}")

INTERFACE IAMCopyCaptureFileProgress $IID_IAMCopyCaptureFileProgress

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Progress ( _                      ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ int iProgress
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMCopyCaptureFileProgress_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = ICaptureGraphBuilder2
' IID = {93E5A4E0-2D50-11D2-ABFA-00A0C9C6E38D}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICaptureGraphBuilder2_INTERFACE_DEFINED)
    %ICaptureGraphBuilder2_INTERFACE_DEFINED = 1

$IID_ICaptureGraphBuilder2 = GUID$("{93E5A4E0-2D50-11D2-ABFA-00A0C9C6E38D}")

INTERFACE ICaptureGraphBuilder2 $IID_ICaptureGraphBuilder2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetFiltergraph ( _                ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IGraphBuilder *pfg
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetFiltergraph ( _                ' VTable offset = 16
     BYREF IUnknown _                       ' /* [out] */ IGraphBuilder **ppfg
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetOutputFileName ( _             ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ const GUID *pType
   , BYVAL DWORD _                          ' /* [in] */ LPCOLESTR lpstrFile
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppf
   , BYREF IUnknown _                       ' /* [out] */ IFileSinkFilter **ppSink
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FindInterface ( _                 ' VTable offset = 24
     BYREF GUID _                           ' /* [in] */ const GUID *pCategory
   , BYREF GUID _                           ' /* [in] */ const GUID *pType
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pf
   , BYREF GUID _                           ' /* [in] */ REFIID riid
   , BYREF IUnknown _                       ' /* [out] */ void **ppint
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RenderStream ( _                  ' VTable offset = 28
     BYREF GUID _                           ' /* [in] */ const GUID *pCategory
   , BYREF GUID _                           ' /* [in] */ const GUID *pType
   , BYVAL IUnknown _                       ' /* [in] */ IUnknown *pSource
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pfCompressor
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pfRenderer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ControlStream ( _                 ' VTable offset = 32
     BYREF GUID _                           ' /* [in] */ const GUID *pCategory
   , BYREF GUID _                           ' /* [in] */ const GUID *pType
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pstart
   , BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *pstop
   , BYVAL WORD _                           ' /* [in] */ WORD wStartCookie
   , BYVAL WORD _                           ' /* [in] */ WORD wStopCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AllocCapFile ( _                  ' VTable offset = 36
     BYVAL DWORD _                          ' /* [in] */ LPCOLESTR lpstr
   , BYVAL QUAD _                           ' /* [in] */ DWORDLONG dwlSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CopyCaptureFile ( _               ' VTable offset = 40
     BYVAL DWORD _                          ' /* [in] */ LPOLESTR lpwstrOld
   , BYVAL DWORD _                          ' /* [in] */ LPOLESTR lpwstrNew
   , BYVAL LONG _                           ' /* [in] */ int fAllowEscAbort
   , BYVAL IUnknown _                       ' /* [in] */ IAMCopyCaptureFileProgress *pCallback
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FindPin ( _                       ' VTable offset = 44
     BYVAL IUnknown _                       ' /* [in] */ IUnknown *pSource
   , BYVAL DWORD _                          ' /* [in] */ PIN_DIRECTION pindir
   , BYREF GUID _                           ' /* [in] */ const GUID *pCategory
   , BYREF GUID _                           ' /* [in] */ const GUID *pType
   , BYVAL LONG _                           ' /* [in] */ BOOL fUnconnected
   , BYVAL LONG _                           ' /* [in] */ int num
   , BYREF IUnknown _                       ' /* [out] */ IPin **ppPin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICaptureGraphBuilder2_INTERFACE_DEFINED__*/


' AM_RENSDEREXFLAGS enum
%AM_RENDEREX_RENDERTOEXISTINGRENDERERS = &H1


' ########################################################################################
' Interface name = IFilterGraph2
' IID = {36b73882-c2c8-11cf-8b46-00805f6cef60}
' Inherited interface = IGraphBuilder
' ########################################################################################

#IF NOT %DEF(%IFilterGraph2_INTERFACE_DEFINED)
    %IFilterGraph2_INTERFACE_DEFINED = 1

$IID_IFilterGraph2 = GUID$("{36b73882-c2c8-11cf-8b46-00805f6cef60}")

INTERFACE IFilterGraph2 $IID_IFilterGraph2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddFilter ( _                     ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR pName
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RemoveFilter ( _                  ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumFilters ( _                   ' VTable offset = 20
     BYREF IUnknown _                       ' /* [out] */ IEnumFilters **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FindFilterByName ( _              ' VTable offset = 24
     BYVAL DWORD _                          ' [in] LPCWSTR pName
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ConnectDirect ( _                 ' VTable offset = 28
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IPin *ppinIn
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reconnect ( _                     ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Disconnect ( _                    ' VTable offset = 36
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDefaultSyncSource ( _          ' VTable offset = 40
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Connect ( _                       ' VTable offset = 44
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IPin *ppinIn
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Render ( _                        ' VTable offset = 48
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RenderFile ( _                    ' VTable offset = 52
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFile
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrPlayList
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AddSourceFilter ( _               ' VTable offset = 56
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFileName
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFilterName
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetLogFile ( _                    ' VTable offset = 60
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR hFile
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Abort ( _                         ' VTable offset = 64
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ShouldOperationContinue ( _       ' VTable offset = 68
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AddSourceFilterForMoniker ( _     ' VTable offset = 72
     BYVAL IUnknown _                       ' /* [in] */IMoniker *pMoniker
   , BYVAL IUnknown _                       ' /* [in] */IBindCtx *pCtx
   , BYVAL lpcwstrFilterName AS DWORD _     ' /* [in] */LPCWSTR lpcwstrFilterName
   , BYREF IUnknown _                       ' [out] IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReconnectEx ( _                   ' VTable offset = 76
     BYVAL IUnknown _                       ' /* [in] */IPin *ppin
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RenderEx ( _                      ' VTable offset = 80
     BYVAL IUnknown _                       ' /* [in] */IPin *pPinOut
   , BYVAL DWORD _                          ' /* [in] */DWORD dwFlags
   , BYVAL DWORD _                          ' /* [in][out] */ LPVOID pvContext
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFilterGraph2_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IFilterGraph3
' IID = {AAF38154-B80B-422F-91E6-B66467509A07}
' Inherited interface = IFilterGraph2
' ########################################################################################

#IF NOT %DEF(%IFilterGraph3_INTERFACE_DEFINED)
    %IFilterGraph3_INTERFACE_DEFINED = 1

$IID_IFilterGraph3 = GUID$("{AAF38154-B80B-422F-91E6-B66467509A07}")

INTERFACE IFilterGraph3 $IID_IFilterGraph3

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AddFilter ( _                     ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR pName
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RemoveFilter ( _                  ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumFilters ( _                   ' VTable offset = 20
     BYREF IUnknown _                       ' /* [out] */ IEnumFilters **ppEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FindFilterByName ( _              ' VTable offset = 24
     BYVAL DWORD _                          ' [in] LPCWSTR pName
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ConnectDirect ( _                 ' VTable offset = 28
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IPin *ppinIn
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reconnect ( _                     ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Disconnect ( _                    ' VTable offset = 36
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDefaultSyncSource ( _          ' VTable offset = 40
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Connect ( _                       ' VTable offset = 44
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IPin *ppinIn
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Render ( _                        ' VTable offset = 48
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RenderFile ( _                    ' VTable offset = 52
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFile
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrPlayList
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AddSourceFilter ( _               ' VTable offset = 56
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFileName
   , BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwstrFilterName
   , BYREF IUnknown _                       ' /* [out] */ IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetLogFile ( _                    ' VTable offset = 60
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR hFile
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Abort ( _                         ' VTable offset = 64
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ShouldOperationContinue ( _       ' VTable offset = 68
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AddSourceFilterForMoniker ( _     ' VTable offset = 72
     BYVAL IUnknown _                       ' /* [in] */IMoniker *pMoniker
   , BYVAL IUnknown _                       ' /* [in] */IBindCtx *pCtx
   , BYVAL lpcwstrFilterName AS DWORD _     ' /* [in] */LPCWSTR lpcwstrFilterName
   , BYREF IUnknown _                       ' [out] IBaseFilter **ppFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReconnectEx ( _                   ' VTable offset = 76
     BYVAL IUnknown _                       ' /* [in] */IPin *ppin
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RenderEx ( _                      ' VTable offset = 80
     BYVAL IUnknown _                       ' /* [in] */IPin *pPinOut
   , BYVAL DWORD _                          ' /* [in] */DWORD dwFlags
   , BYVAL DWORD _                          ' /* [in][out] */ LPVOID pvContext
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetSyncSourceEx ( _               ' VTable offset = 84
     BYVAL IUnknown _                       ' /* [in] */ IReferenceClock *pClockForMostOfFilterGraph
   , BYVAL IUnknown _                       ' /* [in] */ IReferenceClock *pClockForFilter
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFilterGraph3_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IStreamBuilder
' IID = {56A868BF-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IStreamBuilder_INTERFACE_DEFINED)
    %IStreamBuilder_INTERFACE_DEFINED = 1

$IID_IStreamBuilder = GUID$("{56A868BF-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IStreamBuilder $IID_IStreamBuilder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Render ( _                        ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IGraphBuilder *pGraph
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Backout ( _                       ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IPin *ppinOut
   , BYVAL IUnknown _                       ' /* [in] */ IGraphBuilder *pGraph
   ) AS LONG                                ' HRESULT
   ' =====================================================================================


END INTERFACE

#ENDIF   ' /* __IStreamBuilder_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAsyncReader
' IID = {56A868BF-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAsyncReader_INTERFACE_DEFINED)
    %IAsyncReader_INTERFACE_DEFINED = 1

$IID_IAsyncReader = GUID$("{56A868BF-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IAsyncReader $IID_IAsyncReader

   INHERIT IUnknown

   ' =====================================================================================
   METHOD RequestAllocator ( _              ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IMemAllocator *pPreferred
   , BYREF ALLOCATOR_PROPERTIES _           ' /* [in] */ ALLOCATOR_PROPERTIES *pProps
   , BYREF IUnknown _                       ' /* [out] */ IMemAllocator **ppActual
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Request ( _                       ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IMediaSample *pSample
   , BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwUser
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD WaitForNext ( _                   ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ DWORD dwTimeout
   , BYREF IUnknown _                       ' /* [out] */ IMediaSample **ppSample
   , BYREF DWORD _                          ' /* [out] */ DWORD_PTR *pdwUser
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SyncReadAligned ( _               ' VTable offset = 24
     BYVAL IUnknown _                       ' /* [in] */ IMediaSample *pSample
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SyncRead ( _                      ' VTable offset = 28
     BYVAL QUAD _                           ' /* [in] */ LONGLONG llPosition
   , BYVAL LONG _                           ' /* [in] */ LONG lLength
   , BYVAL BYTE PTR _                       ' /* [out] */ BYTE *pBuffer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Length ( _                        ' VTable offset = 32
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pTotal
   , BYREF QUAD _                           ' /* [out] */ LONGLONG *pAvailable
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD BeginFlush ( _                    ' VTable offset = 36
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EndFlush ( _                      ' VTable offset = 40
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAsyncReader_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IGraphVersion
' IID = {56A868AB-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IGraphVersion_INTERFACE_DEFINED)
    %IGraphVersion_INTERFACE_DEFINED = 1

$IID_IGraphVersion = GUID$("{56A868AB-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IGraphVersion $IID_IGraphVersion

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryVersion ( _                  ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ LONG *pVersion
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IGraphVersion_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IResourceConsumer
' IID = {56A868AD-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IResourceConsumer_INTERFACE_DEFINED)
    %IResourceConsumer_INTERFACE_DEFINED = 1

$IID_IResourceConsumer = GUID$("{56A868AD-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IResourceConsumer $IID_IResourceConsumer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AcquireResource ( _               ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ LONG idResource
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReleaseResource ( _               ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ LONG idResource
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IResourceConsumer_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IResourceManager
' IID = {56A868AC-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IResourceManager_INTERFACE_DEFINED)
    %IResourceManager_INTERFACE_DEFINED = 1

$IID_IResourceManager = GUID$("{56A868AC-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IResourceManager $IID_IResourceManager

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Register ( _                      ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR pName
   , BYVAL LONG _                           ' /* [in] */ LONG cResource
   , BYREF LONG _                           ' /* [out] */ LONG *plToken
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterGroup ( _                 ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR pName
   , BYVAL LONG _                           ' /* [in] */ LONG cResource
   , BYVAL LONG _                           ' /* [in] */ LONG *palTokens
   , BYREF LONG _                           ' /* [out] */ LONG *plToken
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RequestResource ( _               ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ LONG idResource
   , BYVAL IUnknown _                       ' /* [in] */ IUnknown *pFocusObject
   , BYVAL IUnknown _                       ' /* [in] */ IResourceConsumer *pConsumer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD NotifyAcquire ( _                 ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ LONG idResource
   , BYVAL IUnknown _                       ' /* [in] */ IResourceConsumer *pConsumer
   , BYVAL LONG _                           ' /* [in] */ HRESULT hr
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD NotifyRelease ( _                 ' VTable offset = 28
     BYVAL LONG _                           ' /* [in] */ LONG idResource
   , BYVAL IUnknown _                       ' /* [in] */ IResourceConsumer *pConsumer
   , BYVAL LONG _                           ' /* [in] */ BOOL bStillWant
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CancelRequest ( _                 ' VTable offset = 32
     BYVAL LONG _                           ' /* [in] */ LONG idResource
   , BYVAL IUnknown _                       ' /* [in] */ IResourceConsumer *pConsumer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetFocus ( _                      ' VTable offset = 36
     BYVAL IUnknown _                       ' /* [in] */ IUnknown *pFocusObject
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReleaseFocus ( _                  ' VTable offset = 40
     BYVAL IUnknown _                       ' /* [in] */ IUnknown *pFocusObject
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IResourceManager_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IDistributorNotify
' IID = {56A868AF-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDistributorNotify_INTERFACE_DEFINED)
    %IDistributorNotify_INTERFACE_DEFINED = 1

$IID_IDistributorNotify = GUID$("{56A868AF-0AD4-11CE-B03A-0020AF0BA770}")

INTERFACE IDistributorNotify $IID_IDistributorNotify

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Stop( _                           ' VTable offset = 12
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Pause ( _                         ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Run ( _                           ' VTable offset = 20
     BYVAL QUAD _                           ' REFERENCE_TIME tStart
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetSyncSource ( _                 ' VTable offset = 24
     BYVAL IUnknown _                       ' /* [in] */ IReferenceClock *pClock
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD NotifyGraphChange ( _             ' VTable offset = 28
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDistributorNotify_INTERFACE_DEFINED__*/


' enum AM_STREAM_INFO_FLAGS
%AM_STREAM_INFO_START_DEFINED   = &H1
%AM_STREAM_INFO_STOP_DEFINED    = &H2
%AM_STREAM_INFO_DISCARDING      = &H4
%AM_STREAM_INFO_STOP_SEND_EXTRA = &H10

TYPE AM_STREAM_INFO
   tStart        AS QUAD               ' REFERENCE_TIME tStart
   tStop         AS QUAD               ' REFERENCE_TIME tStop
   dwStartCookie AS DWORD              ' DWORD dwStartCookie
   dwStopCookie  AS DWORD              ' DWORD dwStopCookie
   dwFlags       AS DWORD              ' DWORD dwFlags
END TYPE


' ########################################################################################
' Interface name = IAMStreamControl
' IID = {36B73881-C2C8-11CF-8B46-00805F6CEF60}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMStreamControl_INTERFACE_DEFINED)
    %IAMStreamControl_INTERFACE_DEFINED = 1

$IID_IAMStreamControl = GUID$("{36B73881-C2C8-11CF-8B46-00805F6CEF60}")

INTERFACE IAMStreamControl $IID_IAMStreamControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD StartAt ( _                       ' VTable offset = 12
     BYREF QUAD _                           ' /* [in] */ const REFERENCE_TIME *ptStart
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD StopAt ( _                        ' VTable offset = 16
     BYREF QUAD _                           ' /* [in] */ const REFERENCE_TIME *ptStop
   , BYVAL LONG _                           ' /* [in] */ BOOL bSendExtra
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwCookie
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetInfo ( _                       ' VTable offset = 20
     BYREF DWORD _                          ' /* [out] */ AM_STREAM_INFO *pInfo
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMStreamControl_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = ISeekingPassThru
' IID = {36B73883-C2C8-11CF-8B46-00805F6CEF60}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ISeekingPassThru_INTERFACE_DEFINED)
    %ISeekingPassThru_INTERFACE_DEFINED = 1

$IID_ISeekingPassThru = GUID$("{36B73883-C2C8-11CF-8B46-00805F6CEF60}")

INTERFACE ISeekingPassThru $IID_ISeekingPassThru

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Init ( _                          ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ BOOL bSupportRendering
   , BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ISeekingPassThru_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMStreamConfig
' IID = {C6E13340-30AC-11D0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMStreamConfig_INTERFACE_DEFINED)
    %IAMStreamConfig_INTERFACE_DEFINED = 1

$IID_IAMStreamConfig = GUID$("{C6E13340-30AC-11D0-A18C-00A0C9118956}")

TYPE VIDEO_STREAM_CONFIG_CAPS
   guid               AS GUID          ' GUID guid
   VideoStandard      AS DWORD         ' ULONG VideoStandard
   InputSize          AS APISIZE       ' SIZE InputSize
   MinCroppingSize    AS APISIZE       ' SIZE MinCroppingSize
   MaxCroppingSize    AS APISIZE       ' SIZE MaxCroppingSize
   CropGranularityX   AS LONG          ' int CropGranularityX
   CropGranularityY   AS LONG          ' int CropGranularityY
   CropAlignX         AS LONG          ' int CropAlignX
   CropAlignY         AS LONG          ' int CropAlignY
   MinOutputSize      AS APISIZE       ' SIZE MinOutputSize
   MaxOutputSize      AS APISIZE       ' SIZE MaxOutputSize
   OutputGranularityX AS LONG          ' int OutputGranularityX
   OutputGranularityY AS LONG          ' int OutputGranularityY
   StretchTapsX       AS LONG          ' int StretchTapsX
   StretchTapsY       AS LONG          ' int StretchTapsY
   ShrinkTapsX        AS LONG          ' int ShrinkTapsX
   ShrinkTapsY        AS LONG          ' int ShrinkTapsY
   MinFrameInterval   AS QUAD          ' LONGLONG MinFrameInterval
   MaxFrameInterval   AS QUAD          ' LONGLONG MaxFrameInterval
   MinBitsPerSecond   AS LONG          ' LONG MinBitsPerSecond
   MaxBitsPerSecond   AS LONG          ' LONG MaxBitsPerSecond
END TYPE

TYPE AUDIO_STREAM_CONFIG_CAPS
   guid AS GUID   ' GUID guid
   MinimumChannels            AS DWORD   ' ULONG MinimumChannels
   MaximumChannels            AS DWORD   ' ULONG MaximumChannels
   ChannelsGranularity        AS DWORD   ' ChannelsGranularity
   MinimumBitsPerSample       AS DWORD   ' MinimumBitsPerSample
   MaximumBitsPerSample       AS DWORD   ' MaximumBitsPerSample
   BitsPerSampleGranularity   AS DWORD   ' BitsPerSampleGranularity
   MinimumSampleFrequency     AS DWORD   ' MinimumSampleFrequency
   MaximumSampleFrequency     AS DWORD   ' MaximumSampleFrequency
   SampleFrequencyGranularity AS DWORD   ' SampleFrequencyGranularity
END TYPE


INTERFACE IAMStreamConfig $IID_IAMStreamConfig

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetFormat ( _                     ' VTable offset = 12
     BYREF AM_MEDIA_TYPE _                  ' /* [in] */ AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetFormat ( _                     ' VTable offset = 16
     BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE **ppmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetNumberOfCapabilities ( _       ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ int *piCount
   , BYREF LONG _                           ' /* [out] */ int *piSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetStreamCaps ( _                 ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ int iIndex
   , BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE **ppmt
   , BYVAL BYTE PTR _                       ' /* [out] */ BYTE *pSCC
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMStreamConfig_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IConfigInterleaving
' IID = {BEE3D220-157B-11D0-BD23-00A0C911CE86}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IConfigInterleaving_INTERFACE_DEFINED)
    %IConfigInterleaving_INTERFACE_DEFINED = 1

$IID_IConfigInterleaving = GUID$("{BEE3D220-157B-11D0-BD23-00A0C911CE86}")

' enum InterleavingMode
%INTERLEAVE_NONE          = 0
%INTERLEAVE_CAPTURE       = %INTERLEAVE_NONE    + 1
%INTERLEAVE_FULL          = %INTERLEAVE_CAPTURE + 1
%INTERLEAVE_NONE_BUFFERED = %INTERLEAVE_FULL    + 1

INTERFACE IConfigInterleaving $IID_IConfigInterleaving

   INHERIT IUnknown

   ' =====================================================================================
   METHOD put_Mode ( _                      ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ InterleavingMode mode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Mode ( _                      ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ InterleavingMode *pmode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Interleaving ( _              ' VTable offset = 20
     BYREF QUAD _                           ' /* [in] */ const REFERENCE_TIME *prtInterleave
   , BYVAL QUAD _                           ' /* [in] */ const REFERENCE_TIME *prtPreroll
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Interleaving ( _              ' VTable offset = 24
     BYREF QUAD _                           ' /* [out] */ const REFERENCE_TIME *prtInterleave
   , BYREF QUAD _                           ' /* [out] */ const REFERENCE_TIME *prtPreroll
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IConfigInterleaving_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IConfigAviMux
' IID = {5ACD6AA0-F482-11CE-8B67-00AA00A3F1A6}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IConfigAviMux_INTERFACE_DEFINED)
    %IConfigAviMux_INTERFACE_DEFINED = 1

$IID_IConfigAviMux = GUID$("{5ACD6AA0-F482-11CE-8B67-00AA00A3F1A6}")

INTERFACE IConfigAviMux $IID_IConfigAviMux

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetMasterStream ( _               ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ LONG iStream
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMasterStream ( _               ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ LONG *pStream
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetOutputCompatibilityIndex ( _   ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ BOOL fOldIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetOutputCompatibilityIndex ( _   ' VTable offset = 24
     BYREF LONG _                           ' /* [out] */ BOOL *pfOldIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IConfigAviMux_INTERFACE_DEFINED__*/


' enum CompressionCaps
%CompressionCaps_CanQuality  = &H1
%CompressionCaps_CanCrunch   = &H2
%CompressionCaps_CanKeyFrame = &H4
%CompressionCaps_CanBFrame   = &H8
%CompressionCaps_CanWindow   = &H10


' ########################################################################################
' Interface name = IAMVideoCompression
' IID = {C6E13343-30AC-11d0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMVideoCompression_INTERFACE_DEFINED)
    %IAMVideoCompression_INTERFACE_DEFINED = 1

$IID_IAMVideoCompression = GUID$("{C6E13343-30AC-11d0-A18C-00A0C9118956}")

INTERFACE IAMVideoCompression $IID_IAMVideoCompression

   INHERIT IUnknown

   ' =====================================================================================
   METHOD put_KeyFrameRate ( _              ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long KeyFrameRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_KeyFrameRate ( _              ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ long *pKeyFrameRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_PFramesPerKeyFrame ( _        ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long PFramesPerKeyFrame
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_PFramesPerKeyFrame ( _        ' VTable offset = 24
     BYREF LONG _                           ' /* [out] */ long *pPFramesPerKeyFrame
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Quality ( _                   ' VTable offset = 28
     BYVAL DOUBLE _                         ' /* [in] */ double Quality
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Quality ( _                   ' VTable offset = 32
     BYREF DOUBLE _                         ' /* [out] */ double *pQuality
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_WindowSize ( _                ' VTable offset = 36
     BYVAL QUAD _                           ' /* [in] */ DWORDLONG WindowSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_WindowSize ( _                ' VTable offset = 40
     BYREF QUAD _                           ' /* [out] */ DWORDLONG *pWindowSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetInfo ( _                       ' VTable offset = 44
     BYREF DWORD _                          ' /* [out] */ WCHAR *pszVersion
   , BYREF LONG _                           ' /* [out][in] */ int *pcbVersion
   , BYREF DWORD _                          ' /* [out] */ LPWSTR pszDescription
   , BYREF LONG _                           ' /* [out][in] */ int *pcbDescription
   , BYREF LONG _                           ' /* [out] */ long *pDefaultKeyFrameRate
   , BYREF LONG _                           ' /* [out] */ long *pDefaultPFramesPerKey
   , BYREF DOUBLE _                         ' /* [out] */ double *pDefaultQuality
   , BYREF LONG _                           ' /* [out] */ long *pCapabilities
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OverrideKeyFrame ( _              ' VTable offset = 48
     BYVAL LONG _                           ' /* [in] */ long FrameNumber
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OverrideFrameSize ( _             ' VTable offset = 52
     BYVAL LONG _                           ' /* [in] */ long FrameNumber
   , BYVAL LONG _                           ' /* [in] */ long Size
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMVideoCompression_INTERFACE_DEFINED__*/

' enum VfwCaptureDialogs
%VfwCaptureDialog_Source       = &H1
%VfwCaptureDialog_Format       = &H2
%VfwCaptureDialog_Display      = &H4

' enum VfwCompressDialogs
%VfwCompressDialog_Config      = &H1
%VfwCompressDialog_About       = &H2
%VfwCompressDialog_QueryConfig = &H4
%VfwCompressDialog_QueryAbout  = &H8


' ########################################################################################
' Interface name = IAMVfwCaptureDialogs
' IID = {D8D715A0-6E5E-11D0-B3F0-00AA003761C5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMVfwCaptureDialogs_INTERFACE_DEFINED)
    %IAMVfwCaptureDialogs_INTERFACE_DEFINED = 1

$IID_IAMVfwCaptureDialogs = GUID$("{D8D715A0-6E5E-11D0-B3F0-00AA003761C5}")

INTERFACE IAMVfwCaptureDialogs $IID_IAMVfwCaptureDialogs

   INHERIT IUnknown

   ' =====================================================================================
   METHOD HasDialog ( _                     ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ int iDialog
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ShowDialog ( _                    ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ int iDialog
   , BYVAL DWORD _                          ' /* [in] */ HWND hwnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SendDriverMessage ( _             ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ int iDialog
   , BYVAL LONG _                           ' /* [in] */ int uMsg
   , BYVAL LONG _                           ' /* [in] */ long dw1
   , BYVAL LONG _                           ' /* [in] */ long dw2
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMVfwCaptureDialogs_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMVfwCompressDialogs
' IID = {D8D715A0-6E5E-11D0-B3F0-00AA003761C5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMVfwCompressDialogs_INTERFACE_DEFINED)
    %IAMVfwCompressDialogs_INTERFACE_DEFINED = 1

$IID_IAMVfwCompressDialogs = GUID$("{D8D715A0-6E5E-11D0-B3F0-00AA003761C5}")

INTERFACE IAMVfwCompressDialogs $IID_IAMVfwCompressDialogs

   INHERIT IUnknown

   ' =====================================================================================
   METHOD ShowDialog ( _                    ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ int iDialog
   , BYVAL DWORD _                          ' /* [in] */ HWND hwnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetState ( _                      ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ LPVOID pState
   , BYREF LONG _                           ' /* [out][in] */ int *pcbState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetState ( _                      ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ LPVOID pState
   , BYVAL LONG _                           ' /* [in] */ int cbState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SendDriverMessage ( _             ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ int uMsg
   , BYVAL LONG _                           ' /* [in] */ long dw1
   , BYVAL LONG _                           ' /* [in] */ long dw2
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMVfwCompressDialogs_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMDroppedFrames
' IID = {C6E13344-30AC-11D0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMDroppedFrames_INTERFACE_DEFINED)
    %IAMDroppedFrames_INTERFACE_DEFINED = 1

$IID_IAMDroppedFrames = GUID$("{C6E13344-30AC-11D0-A18C-00A0C9118956}")

INTERFACE IAMDroppedFrames $IID_IAMDroppedFrames

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetNumDropped ( _                 ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ long *plDropped
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetNumNotDropped ( _              ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ long *plNotDropped
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDroppedInfo ( _                ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long lSize
   , BYREF LONG _                           ' /* [out] */ long *plArray
   , BYREF LONG _                           ' /* [out] */ long *plNumCopied
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAverageFrameSize ( _           ' VTable offset = 24
     BYREF LONG _                           ' /* [out] */ long *plAverageSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMDroppedFrames_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMAudioInputMixer
' IID = {54C39221-8380-11D0-B3F0-00AA003761C5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMAudioInputMixer_INTERFACE_DEFINED)
    %IAMAudioInputMixer_INTERFACE_DEFINED = 1

'#define AMF_AUTOMATICGAIN -1.0
%AMF_AUTOMATICGAIN = -1

$IID_IAMAudioInputMixer = GUID$("{54C39221-8380-11D0-B3F0-00AA003761C5}")

INTERFACE IAMAudioInputMixer $IID_IAMAudioInputMixer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD put_Enable ( _                    ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ BOOL fEnable
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Enable ( _                    ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ BOOL *pfEnable
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Mono ( _                      ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ BOOL fMono
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Mono ( _                      ' VTable offset = 24
     BYREF LONG _                           ' /* [out] */ BOOL *pfMono
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_MixLevel ( _                  ' VTable offset = 28
     BYVAL DOUBLE _                         ' /* [in] */ double Level
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_MixLevel ( _                  ' VTable offset = 32
     BYREF DOUBLE _                         ' /* [out] */ double *pLevel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Pan ( _                       ' VTable offset = 36
     BYVAL DOUBLE _                         ' /* [in] */ double Pan
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Pan ( _                       ' VTable offset = 40
     BYREF DOUBLE _                         ' /* [out] */ double *pPan
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Loudness ( _                  ' VTable offset = 44
     BYVAL LONG _                           ' /* [in] */ BOOL fLoudness
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Loudness ( _                  ' VTable offset = 48
     BYREF LONG _                           ' /* [out] */ BOOL *pfLoudness
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Treble ( _                    ' VTable offset = 52
     BYVAL DOUBLE _                         ' /* [in] */ double Treble
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Treble ( _                    ' VTable offset = 56
     BYREF DOUBLE _                         ' /* [out] */ double *pTreble
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_TrebleRange ( _               ' VTable offset = 60
     BYREF DOUBLE _                         ' /* [out] */ double *pRange
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Bass ( _                      ' VTable offset = 64
     BYVAL DOUBLE _                         ' /* [in] */ double Bass
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Bass ( _                      ' VTable offset = 68
     BYREF DOUBLE _                         ' /* [out] */ double *pBass
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_BassRange ( _                 ' VTable offset = 72
     BYREF DOUBLE _                         ' /* [out] */ double *pRange
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMAudioInputMixer_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMBufferNegotiation
' IID = {56ED71A0-AF5F-11D0-B3F0-00AA003761C5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMBufferNegotiation_INTERFACE_DEFINED)
    %IAMBufferNegotiation_INTERFACE_DEFINED = 1

$IID_IAMBufferNegotiation = GUID$("{56ED71A0-AF5F-11D0-B3F0-00AA003761C5}")

INTERFACE IAMBufferNegotiation $IID_IAMBufferNegotiation

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SuggestAllocatorProperties ( _    ' VTable offset = 12
     BYREF ALLOCATOR_PROPERTIES _           ' /* [in] */ const ALLOCATOR_PROPERTIES *pprop
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAllocatorProperties ( _        ' VTable offset = 16
     BYREF ALLOCATOR_PROPERTIES _           ' /* [out] */ const ALLOCATOR_PROPERTIES *pprop
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMBufferNegotiation_INTERFACE_DEFINED__*/


' enum AnalogVideoStandard
%AnalogVideo_None        = 0
%AnalogVideo_NTSC_M      = &H1
%AnalogVideo_NTSC_M_J    = &H2
%AnalogVideo_NTSC_433    = &H4
%AnalogVideo_PAL_B       = &H10
%AnalogVideo_PAL_D       = &H20
%AnalogVideo_PAL_G       = &H40
%AnalogVideo_PAL_H       = &H80
%AnalogVideo_PAL_I       = &H100
%AnalogVideo_PAL_M       = &H200
%AnalogVideo_PAL_N       = &H400
%AnalogVideo_PAL_60      = &H800
%AnalogVideo_SECAM_B     = &H1000
%AnalogVideo_SECAM_D     = &H2000
%AnalogVideo_SECAM_G     = &H4000
%AnalogVideo_SECAM_H     = &H8000
%AnalogVideo_SECAM_K     = &H10000
%AnalogVideo_SECAM_K1    = &H20000
%AnalogVideo_SECAM_L     = &H40000
%AnalogVideo_SECAM_L1    = &H80000
%AnalogVideo_PAL_N_COMBO = &H100000

%AnalogVideoMask_MCE_NTSC  = ((((((%AnalogVideo_NTSC_M OR %AnalogVideo_NTSC_M_J ) OR %AnalogVideo_NTSC_433) OR %AnalogVideo_PAL_M) OR %AnalogVideo_PAL_N) OR %AnalogVideo_PAL_60) OR %AnalogVideo_PAL_N_COMBO)
%AnalogVideoMask_MCE_PAL   = ((((%AnalogVideo_PAL_B OR %AnalogVideo_PAL_D) OR %AnalogVideo_PAL_G) OR %AnalogVideo_PAL_H) OR %AnalogVideo_PAL_I)
%AnalogVideoMask_MCE_SECAM = (((((((%AnalogVideo_SECAM_B OR %AnalogVideo_SECAM_D) OR %AnalogVideo_SECAM_G) OR %AnalogVideo_SECAM_H) OR %AnalogVideo_SECAM_K) OR %AnalogVideo_SECAM_K1) OR %AnalogVideo_SECAM_L) OR %AnalogVideo_SECAM_L1)

' enum TunerInputType
%TunerInputCable         = 0
%TunerInputAntenna       = %TunerInputCable + 1

%AnalogVideo_NTSC_Mask   = &H00000007???
%AnalogVideo_PAL_Mask    = &H00100FF0???
%AnalogVideo_SECAM_Mask  = &H000FF000???

' enum VideoCopyProtectionType
%VideoCopyProtectionMacrovisionBasic = 0
%VideoCopyProtectionMacrovisionCBI   = %VideoCopyProtectionMacrovisionBasic + 1

' enum PhysicalConnectorType
%PhysConn_Video_Tuner           = 1
%PhysConn_Video_Composite       = %PhysConn_Video_Tuner          + 1
%PhysConn_Video_SVideo          = %PhysConn_Video_Composite       + 1
%PhysConn_Video_RGB             = %PhysConn_Video_SVideo          + 1
%PhysConn_Video_YRYBY           = %PhysConn_Video_RGB             + 1
%PhysConn_Video_SerialDigital   = %PhysConn_Video_YRYBY           + 1
%PhysConn_Video_ParallelDigital = %PhysConn_Video_SerialDigital   + 1
%PhysConn_Video_SCSI            = %PhysConn_Video_ParallelDigital + 1
%PhysConn_Video_AUX             = %PhysConn_Video_SCSI            + 1
%PhysConn_Video_1394            = %PhysConn_Video_AUX             + 1
%PhysConn_Video_USB             = %PhysConn_Video_1394            + 1
%PhysConn_Video_VideoDecoder    = %PhysConn_Video_USB             + 1
%PhysConn_Video_VideoEncoder    = %PhysConn_Video_VideoDecoder    + 1
%PhysConn_Video_SCART           = %PhysConn_Video_VideoEncoder    + 1
%PhysConn_Video_Black           = %PhysConn_Video_SCART           + 1
%PhysConn_Audio_Tuner           = &H1000
%PhysConn_Audio_Line            = %PhysConn_Audio_Tuner           + 1
%PhysConn_Audio_Mic             = %PhysConn_Audio_Line            + 1
%PhysConn_Audio_AESDigital      = %PhysConn_Audio_Mic             + 1
%PhysConn_Audio_SPDIFDigital    = %PhysConn_Audio_AESDigital      + 1
%PhysConn_Audio_SCSI            = %PhysConn_Audio_SPDIFDigital    + 1
%PhysConn_Audio_AUX             = %PhysConn_Audio_SCSI            + 1
%PhysConn_Audio_1394            = %PhysConn_Audio_AUX             + 1
%PhysConn_Audio_USB             = %PhysConn_Audio_1394            + 1
%PhysConn_Audio_AudioDecoder    = %PhysConn_Audio_USB             + 1


' ########################################################################################
' Interface name = IAMAnalogVideoDecoder
' IID = {C6E13350-30AC-11d0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMAnalogVideoDecoder_INTERFACE_DEFINED)
    %IAMAnalogVideoDecoder_INTERFACE_DEFINED = 1

$IID_IAMAnalogVideoDecoder = GUID$("{C6E13350-30AC-11d0-A18C-00A0C9118956}")

INTERFACE IAMAnalogVideoDecoder $IID_IAMAnalogVideoDecoder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD get_AvailableTVFormats ( _        ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ long *lAnalogVideoStandard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_TVFormat ( _                  ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long lAnalogVideoStandard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_TVFormat ( _                  ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ long *plAnalogVideoStandard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_HorizontalLocked ( _          ' VTable offset = 24
     BYREF LONG _                           ' /* [out] */ long *plLocked
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_VCRHorizontalLocking ( _      ' VTable offset = 28
     BYVAL LONG _                           ' /* [in] */ long lVCRHorizontalLocking
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_VCRHorizontalLocking ( _      ' VTable offset = 32
     BYREF LONG _                           ' /* [out] */ long *plVCRHorizontalLocking
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_NumberOfLines ( _             ' VTable offset = 36
     BYREF LONG _                           ' /* [out] */ long *plNumberOfLines
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_OutputEnable ( _              ' VTable offset = 40
     BYVAL LONG _                           ' /* [in] */ long lOutputEnable
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_OutputEnable ( _              ' VTable offset = 44
     BYREF LONG _                           ' /* [out] */ long *plOutputEnable
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMAnalogVideoDecoder_INTERFACE_DEFINED__*/


' enum VideoProcAmpProperty
%VideoProcAmp_Brightness            = 0
%VideoProcAmp_Contrast              = %VideoProcAmp_Brightness            + 1
%VideoProcAmp_Hue                   = %VideoProcAmp_Contrast              + 1
%VideoProcAmp_Saturation            = %VideoProcAmp_Hue                   + 1
%VideoProcAmp_Sharpness             = %VideoProcAmp_Saturation            + 1
%VideoProcAmp_Gamma                 = %VideoProcAmp_Sharpness             + 1
%VideoProcAmp_ColorEnable           = %VideoProcAmp_Gamma                 + 1
%VideoProcAmp_WhiteBalance          = %VideoProcAmp_ColorEnable           + 1
%VideoProcAmp_BacklightCompensation = %VideoProcAmp_WhiteBalance          + 1
%VideoProcAmp_Gain                  = %VideoProcAmp_BacklightCompensation + 1

' enum VideoProcAmpFlags
%VideoProcAmp_Flags_Auto            = &H1
%VideoProcAmp_Flags_Manual          = &H2


' ########################################################################################
' Interface name = IAMVideoProcAmp
' IID = {C6E13360-30AC-11D0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMVideoProcAmp_INTERFACE_DEFINED)
    %IAMVideoProcAmp_INTERFACE_DEFINED = 1

$IID_IAMVideoProcAmp = GUID$("{C6E13360-30AC-11D0-A18C-00A0C9118956}")

INTERFACE IAMVideoProcAmp $IID_IAMVideoProcAmp

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetRange ( _                      ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long Property
   , BYREF LONG _                           ' /* [out] */ long *pMin
   , BYREF LONG _                           ' /* [out] */ long *pMax
   , BYREF LONG _                           ' /* [out] */ long *pSteppingDelta
   , BYREF LONG _                           ' /* [out] */ long *pDefault
   , BYREF LONG _                           ' /* [out] */ long *pCapsFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Set ( _                           ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long Property
   , BYVAL LONG _                           ' /* [in] */ long lValue
   , BYVAL LONG _                           ' /* [in] */ long Flags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Get ( _                           ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long Property
   , BYREF LONG _                           ' /* [out] */ long *lValue
   , BYREF LONG _                           ' /* [out] */ long *Flags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMVideoProcAmp_INTERFACE_DEFINED__*/


' enum CameraControlProperty
%CameraControl_Pan      = 0
%CameraControl_Tilt     = %CameraControl_Pan      + 1
%CameraControl_Roll     = %CameraControl_Tilt     + 1
%CameraControl_Zoom     = %CameraControl_Roll     + 1
%CameraControl_Exposure = %CameraControl_Zoom     + 1
%CameraControl_Iris     = %CameraControl_Exposure + 1
%CameraControl_Focus    = %CameraControl_Iris     + 1

' enum CameraControlFlags
%CameraControl_Flags_Auto   = &H1
%CameraControl_Flags_Manual = &H2


' ########################################################################################
' Interface name = IAMCameraControl
' IID = {C6E13370-30AC-11D0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMCameraControl_INTERFACE_DEFINED)
    %IAMCameraControl_INTERFACE_DEFINED = 1

$IID_IAMCameraControl = GUID$("{C6E13370-30AC-11D0-A18C-00A0C9118956}")

INTERFACE IAMCameraControl $IID_IAMCameraControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetRange ( _                      ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long Property
   , BYREF LONG _                           ' /* [out] */ long *pMin
   , BYREF LONG _                           ' /* [out] */ long *pMax
   , BYREF LONG _                           ' /* [out] */ long *pSteppingDelta
   , BYREF LONG _                           ' /* [out] */ long *pDefault
   , BYREF LONG _                           ' /* [out] */ long *pCapsFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Set ( _                           ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long Property
   , BYVAL LONG _                           ' /* [in] */ long lValue
   , BYVAL LONG _                           ' /* [in] */ long Flags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Get ( _                           ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long Property
   , BYREF LONG _                           ' /* [out] */ long *lValue
   , BYREF LONG _                           ' /* [out] */ long *Flags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMCameraControl_INTERFACE_DEFINED__*/


' enum VideoControlFlags
%VideoControlFlag_FlipHorizontal        = &H1
%VideoControlFlag_FlipVertical          = &H2
%VideoControlFlag_ExternalTriggerEnable = &H4
%VideoControlFlag_Trigger               = &H8


' ########################################################################################
' Interface name = IAMVideoControl
' IID = {6A2E0670-28E4-11D0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMVideoControl_INTERFACE_DEFINED)
    %IAMVideoControl_INTERFACE_DEFINED = 1

$IID_IAMVideoControl = GUID$("{6A2E0670-28E4-11D0-A18C-00A0C9118956}")

INTERFACE IAMVideoControl $IID_IAMVideoControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCaps ( _                       ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
   , BYREF LONG _                           ' /* [out] */ long *pCapsFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetMode ( _                       ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
   , BYVAL LONG _                           ' /* [in] */ long Mode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMode ( _                       ' VTable offset = 20
     BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
   , BYREF LONG _                           ' /* [out] */ long *Mode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentActualFrameRate ( _     ' VTable offset = 24
     BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
   , BYREF QUAD _                           ' /* [out] */ LONGLONG *ActualFrameRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMaxAvailableFrameRate ( _      ' VTable offset = 28
     BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
   , BYVAL LONG _                           ' /* [in] */ long iIndex
   , BYREF APISIZE _                        ' /* [in] */ SIZE Dimensions
   , BYREF QUAD _                           ' /* [out] */ LONGLONG *MaxAvailableFrameRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetFrameRateList ( _              ' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
   , BYVAL LONG _                           ' /* [in] */ long iIndex
   , BYREF APISIZE _                        ' /* [in] */ SIZE Dimensions
   , BYREF LONG _                           ' /* [out] */ long *ListSize
   , BYREF QUAD _                           ' /* [out] */ LONGLONG **FrameRates
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMVideoControl_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMCrossbar
' IID = {C6E13380-30AC-11D0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMCrossbar_INTERFACE_DEFINED)
    %IAMCrossbar_INTERFACE_DEFINED = 1

$IID_IAMCrossbar = GUID$("{C6E13380-30AC-11D0-A18C-00A0C9118956}")

INTERFACE IAMCrossbar $IID_IAMCrossbar

   INHERIT IUnknown

   ' =====================================================================================
   METHOD get_PinCounts ( _                 ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ long *OutputPinCount
   , BYREF LONG _                           ' /* [out] */ long *InputPinCount
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CanRoute ( _                      ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long OutputPinIndex
   , BYVAL LONG _                           ' /* [in] */ long InputPinIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Route ( _                         ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long OutputPinIndex
   , BYVAL LONG _                           ' /* [in] */ long InputPinIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_IsRoutedTo ( _                ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long OutputPinIndex
   , BYREF LONG _                           ' /* [out] */ long *InputPinCount
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_CrossbarPinInfo ( _           ' VTable offset = 28
     BYVAL LONG _                           ' /* [in] */ BOOL IsInputPin
   , BYVAL LONG _                           ' /* [in] */ long PinIndex
   , BYREF LONG _                           ' /* [out] */ long *PinIndexRelated
   , BYREF LONG _                           ' /* [out] */ long *PhysicalType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMCrossbar_INTERFACE_DEFINED__*/


' enum AMTunerSubChannel
%AMTUNER_SUBCHAN_NO_TUNE     = -2
%AMTUNER_SUBCHAN_DEFAULT     = -1

' enum AMTunerSignalStrength
%AMTUNER_HASNOSIGNALSTRENGTH = -1
%AMTUNER_NOSIGNAL            = 0
%AMTUNER_SIGNALPRESENT       = 1

' enum AMTunerModeType
%AMTUNER_MODE_DEFAULT        = 0
%AMTUNER_MODE_TV             = &H1
%AMTUNER_MODE_FM_RADIO       = &H2
%AMTUNER_MODE_AM_RADIO       = &H4
%AMTUNER_MODE_DSS            = &H8

' enum AMTunerEventType
%AMTUNER_EVENT_CHANGED       = &H1


' ########################################################################################
' Interface name = IAMTuner
' IID = {211A8761-03AC-11D1-8D13-00AA00BD8339}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMTuner_INTERFACE_DEFINED)
    %IAMTuner_INTERFACE_DEFINED = 1

$IID_IAMTuner = GUID$("{211A8761-03AC-11D1-8D13-00AA00BD8339}")

INTERFACE IAMTuner $IID_IAMTuner

   INHERIT IUnknown

   ' =====================================================================================
   METHOD put_Channel ( _                   ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long lChannel
   , BYVAL LONG _                           ' /* [in] */ long lVideoSubChannel
   , BYVAL LONG _                           ' /* [in] */ long lAudioSubChannel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Channel ( _                   ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ long *plChannel
   , BYREF LONG _                           ' /* [out] */ long *plVideoSubChannel
   , BYREF LONG _                           ' /* [out] */ long *plAudioSubChannel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ChannelMinMax ( _                 ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ long *lChannelMin
   , BYREF LONG _                           ' /* [out] */ long *lChannelMax
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_CountryCode ( _               ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long lCountryCode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_CountryCode ( _               ' VTable offset = 28
     BYREF LONG _                           ' /* [out] */ long *plCountryCode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_TuningSpace ( _               ' VTable offset = 32
     BYVAL LONG _                           ' /* [in] */ long lTuningSpace
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_TuningSpace ( _               ' VTable offset = 36
     BYREF LONG _                           ' /* [out] */ long *plTuningSpace
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Logon ( _                         ' VTable offset = 40
     BYVAL DWORD _                          ' /* [in] */ HANDLE hCurrentUser
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Logout ( _                        ' VTable offset = 44
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SignalPresent ( _                 ' VTable offset = 48
     BYREF LONG _                           ' /* [out] */ long *plSignalStrength
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Mode ( _                      ' VTable offset = 52
     BYVAL DWORD _                          ' /* [in] */ AMTunerModeType lMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Mode ( _                      ' VTable offset = 56
     BYREF DWORD _                          ' /* [out] */ AMTunerModeType *plMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAvailableModes ( _             ' VTable offset = 60
     BYREF LONG _                           ' /* [out] */ long *plModes
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterNotificationCallBack ( _  ' VTable offset = 64
     BYVAL IUnknown _                       ' /* [in] */ IAMTunerNotification *pNotify
   , BYVAL LONG _                           ' /* [in] */ long lEvents
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnRegisterNotificationCallBack ( _' VTable offset = 68
     BYVAL IUnknown _                       ' /* [in] */ IAMTunerNotification *pNotify
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMTuner_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMTunerNotification
' IID = {211A8760-03AC-11D1-8D13-00AA00BD8339}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMTunerNotification_INTERFACE_DEFINED)
    %IAMTunerNotification_INTERFACE_DEFINED = 1

$IID_IAMTunerNotification = GUID$("{211A8760-03AC-11D1-8D13-00AA00BD8339}")

INTERFACE IAMTunerNotification $IID_IAMTunerNotification

   INHERIT IUnknown

   ' =====================================================================================
   METHOD put_Channel ( _                   ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ AMTunerEventType Event
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMTunerNotification_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMTVTuner
' IID = {211A8766-03AC-11D1-8D13-00AA00BD8339}
' Inherited interface = IAMTuner
' ########################################################################################

#IF NOT %DEF(%IAMTVTuner_INTERFACE_DEFINED)
    %IAMTVTuner_INTERFACE_DEFINED = 1

$IID_IAMTVTuner = GUID$("{211A8766-03AC-11D1-8D13-00AA00BD8339}")

INTERFACE IAMTVTuner $IID_IAMTVTuner

   INHERIT IUnknown

   ' =====================================================================================
   METHOD put_Channel ( _                   ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long lChannel
   , BYVAL LONG _                           ' /* [in] */ long lVideoSubChannel
   , BYVAL LONG _                           ' /* [in] */ long lAudioSubChannel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Channel ( _                   ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ long *plChannel
   , BYREF LONG _                           ' /* [out] */ long *plVideoSubChannel
   , BYREF LONG _                           ' /* [out] */ long *plAudioSubChannel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ChannelMinMax ( _                 ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ long *lChannelMin
   , BYREF LONG _                           ' /* [out] */ long *lChannelMax
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_CountryCode ( _               ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long lCountryCode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_CountryCode ( _               ' VTable offset = 28
     BYREF LONG _                           ' /* [out] */ long *plCountryCode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_TuningSpace ( _               ' VTable offset = 32
     BYVAL LONG _                           ' /* [in] */ long lTuningSpace
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_TuningSpace ( _               ' VTable offset = 36
     BYREF LONG _                           ' /* [out] */ long *plTuningSpace
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Logon ( _                         ' VTable offset = 40
     BYVAL DWORD _                          ' /* [in] */ HANDLE hCurrentUser
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Logout ( _                        ' VTable offset = 44
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SignalPresent ( _                 ' VTable offset = 48
     BYREF LONG _                           ' /* [out] */ long *plSignalStrength
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Mode ( _                      ' VTable offset = 52
     BYVAL DWORD _                          ' /* [in] */ AMTunerModeType lMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Mode ( _                      ' VTable offset = 56
     BYREF DWORD _                          ' /* [out] */ AMTunerModeType *plMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAvailableModes ( _             ' VTable offset = 60
     BYREF LONG _                           ' /* [out] */ long *plModes
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterNotificationCallBack ( _  ' VTable offset = 64
     BYVAL IUnknown _                       ' /* [in] */ IAMTunerNotification *pNotify
   , BYVAL LONG _                           ' /* [in] */ long lEvents
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnRegisterNotificationCallBack ( _' VTable offset = 68
     BYVAL IUnknown _                       ' /* [in] */ IAMTunerNotification *pNotify
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_AvailableTVFormats ( _        ' VTable offset = 72
     BYREF LONG _                           ' /* [out] */ long *lAnalogVideoStandard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_TVFormat ( _                  ' VTable offset = 76
     BYREF LONG _                           ' /* [out] */ long *lAnalogVideoStandard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AutoTune ( _                      ' VTable offset = 80
     BYVAL LONG _                           ' /* [in] */ long lChannel
   , BYREF LONG _                           ' /* [out] */ long *plFoundSignal
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD StoreAutoTune ( _                 ' VTable offset = 84
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_NumInputConnections ( _       ' VTable offset = 88
     BYREF LONG _                           ' /* [out] */ long *plNumInputConnections
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_InputType ( _                 ' VTable offset = 92
     BYVAL LONG _                           ' /* [in] */ long lIndex
   , BYVAL DWORD _                          ' /* [in] */ TunerInputType InputType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_InputType ( _                 ' VTable offset = 96
     BYVAL LONG _                           ' /* [in] */ long lIndex
   , BYREF DWORD _                          ' /* [out] */ TunerInputType *pInputType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_ConnectInput ( _              ' VTable offset = 100
     BYVAL LONG _                           ' /* [in] */ long lIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_ConnectInput ( _              ' VTable offset = 104
     BYREF LONG _                           ' /* [out] */ long *plIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_VideoFrequency ( _            ' VTable offset = 108
     BYREF LONG _                           ' /* [out] */ long *lFreq
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_AudioFrequency ( _            ' VTable offset = 112
     BYREF LONG _                           ' /* [out] */ long *lFreq
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMTVTuner_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IBPCSatelliteTuner
' IID = {211A8765-03AC-11D1-8D13-00AA00BD8339}
' Inherited interface = IAMTuner
' ########################################################################################

#IF NOT %DEF(%IBPCSatelliteTuner_INTERFACE_DEFINED)
    %IBPCSatelliteTuner_INTERFACE_DEFINED = 1

$IID_IBPCSatelliteTuner = GUID$("{211A8765-03AC-11D1-8D13-00AA00BD8339}")

INTERFACE IBPCSatelliteTuner $IID_IBPCSatelliteTuner

   INHERIT IUnknown

   ' =====================================================================================
   METHOD put_Channel ( _                   ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long lChannel
   , BYVAL LONG _                           ' /* [in] */ long lVideoSubChannel
   , BYVAL LONG _                           ' /* [in] */ long lAudioSubChannel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Channel ( _                   ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ long *plChannel
   , BYREF LONG _                           ' /* [out] */ long *plVideoSubChannel
   , BYREF LONG _                           ' /* [out] */ long *plAudioSubChannel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ChannelMinMax ( _                 ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ long *lChannelMin
   , BYREF LONG _                           ' /* [out] */ long *lChannelMax
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_CountryCode ( _               ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long lCountryCode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_CountryCode ( _               ' VTable offset = 28
     BYREF LONG _                           ' /* [out] */ long *plCountryCode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_TuningSpace ( _               ' VTable offset = 32
     BYVAL LONG _                           ' /* [in] */ long lTuningSpace
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_TuningSpace ( _               ' VTable offset = 36
     BYREF LONG _                           ' /* [out] */ long *plTuningSpace
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Logon ( _                         ' VTable offset = 40
     BYVAL DWORD _                          ' /* [in] */ HANDLE hCurrentUser
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Logout ( _                        ' VTable offset = 44
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SignalPresent ( _                 ' VTable offset = 48
     BYREF LONG _                           ' /* [out] */ long *plSignalStrength
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Mode ( _                      ' VTable offset = 52
     BYVAL DWORD _                          ' /* [in] */ AMTunerModeType lMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Mode ( _                      ' VTable offset = 56
     BYREF DWORD _                          ' /* [out] */ AMTunerModeType *plMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAvailableModes ( _             ' VTable offset = 60
     BYREF LONG _                           ' /* [out] */ long *plModes
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterNotificationCallBack ( _  ' VTable offset = 64
     BYVAL IUnknown _                       ' /* [in] */ IAMTunerNotification *pNotify
   , BYVAL LONG _                           ' /* [in] */ long lEvents
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnRegisterNotificationCallBack ( _' VTable offset = 68
     BYVAL IUnknown _                       ' /* [in] */ IAMTunerNotification *pNotify
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_DefaultSubChannelTypes ( _    ' VTable offset = 72
     BYREF LONG _                           ' /* [out] */ long *plDefaultVideoType
   , BYREF LONG _                           ' /* [out] */ long *plDefaultAudioType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_DefaultSubChannelTypes ( _    ' VTable offset = 76
     BYVAL LONG _                           ' /* [in] */ long lDefaultVideoType
   , BYVAL LONG _                           ' /* [in] */ long lDefaultAudioType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsTapingPermitted ( _             ' VTable offset = 80
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IBPCSatelliteTuner_INTERFACE_DEFINED__*/

' enum TVAudioMode
%AMTVAUDIO_MODE_MONO     = &H1
%AMTVAUDIO_MODE_STEREO   = &H2
%AMTVAUDIO_MODE_LANG_A   = &H10
%AMTVAUDIO_MODE_LANG_B   = &H20
%AMTVAUDIO_MODE_LANG_C   = &H40
%AMTVAUDIO_PRESET_STEREO = &H200
%AMTVAUDIO_PRESET_LANG_A = &H1000
%AMTVAUDIO_PRESET_LANG_B = &H2000
%AMTVAUDIO_PRESET_LANG_C = &H4000

' enum AMTVAudioEventType
%AMTVAUDIO_EVENT_CHANGED = &H1


' ########################################################################################
' Interface name = IAMTVAudio
' IID = {83EC1C30-23D1-11D1-99E6-00A0C9560266}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMTVAudio_INTERFACE_DEFINED)
    %IAMTVAudio_INTERFACE_DEFINED = 1

$IID_IAMTVAudio = GUID$("{83EC1C30-23D1-11D1-99E6-00A0C9560266}")

INTERFACE IAMTVAudio $IID_IAMTVAudio

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetHardwareSupportedTVAudioModes ( _          ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ long *plModes
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAvailableTVAudioModes ( _      ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ long *plModes
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_TVAudioMode ( _               ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ long *plMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_TVAudioMode ( _               ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long lMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterNotificationCallBack ( _  ' VTable offset = 28
     BYVAL IUnknown _                       ' /* [in] */ IAMTunerNotification *pNotify
   , BYVAL LONG _                           ' /* [in] */ long lEvents
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnRegisterNotificationCallBack ( _' VTable offset = 32
     BYVAL IUnknown _                       ' /* [in] */ IAMTunerNotification *pNotify
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMTVAudio_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMTVAudioNotification
' IID = {83EC1C33-23D1-11D1-99E6-00A0C9560266}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMTVAudioNotification_INTERFACE_DEFINED)
    %IAMTVAudioNotification_INTERFACE_DEFINED = 1

$IID_IAMTVAudioNotification = GUID$("{83EC1C33-23D1-11D1-99E6-00A0C9560266}")

INTERFACE IAMTVAudioNotification $IID_IAMTVAudioNotification

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnEvent ( _                       ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ AMTVAudioEventType Event
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMTVAudioNotification_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMAnalogVideoEncoder
' IID = {C6E133B0-30AC-11D0-A18C-00A0C9118956}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMAnalogVideoEncoder_INTERFACE_DEFINED)
    %IAMAnalogVideoEncoder_INTERFACE_DEFINED = 1

$IID_IAMAnalogVideoEncoder = GUID$("{C6E133B0-30AC-11D0-A18C-00A0C9118956}")

INTERFACE IAMAnalogVideoEncoder $IID_IAMAnalogVideoEncoder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD get_AvailableTVFormats ( _        ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ long *lAnalogVideoStandard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_TVFormat ( _                  ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long lAnalogVideoStandard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_TVFormat ( _                  ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ long *plAnalogVideoStandard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_CopyProtection ( _            ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long lVideoCopyProtection
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_CopyProtection ( _            ' VTable offset = 28
     BYREF LONG _                           ' /* [out] */ long *lVideoCopyProtection
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_CCEnable ( _                  ' VTable offset = 32
     BYVAL LONG _                           ' /* [in] */ long lCCEnable
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_CCEnable ( _                  ' VTable offset = 36
     BYREF LONG _                           ' /* [out] */ long *lCCEnable
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMAnalogVideoEncoder_INTERFACE_DEFINED__*/

' enum AMPROPERTY_PIN
%AMPROPERTY_PIN_CATEGORY = 0
%AMPROPERTY_PIN_MEDIUM   = %AMPROPERTY_PIN_CATEGORY + 1

#IF NOT %DEF(%IKsPropertySet)
   %IKsPropertySet = 1

%KSPROPERTY_SUPPORT_GET  = 1
%KSPROPERTY_SUPPORT_SET  = 2

' ########################################################################################
' Interface name = IKsPropertySet
' IID = {31EFAC30-515C-11D0-A9AA-00AA0061BE93}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IKsPropertySet_INTERFACE_DEFINED)
    %IKsPropertySet_INTERFACE_DEFINED = 1

$IID_IKsPropertySet = GUID$("{31EFAC30-515C-11D0-A9AA-00AA0061BE93}")

INTERFACE IKsPropertySet $IID_IKsPropertySet

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Set ( _                           ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ REFGUID guidPropSet
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwPropID
   , BYVAL DWORD _                          ' /* [in] */ LPVOID pInstanceData
   , BYVAL DWORD _                          ' /* [in] */ DWORD cbInstanceData
   , BYVAL DWORD _                          ' /* [in] */ LPVOID pPropData
   , BYVAL DWORD _                          ' /* [in] */ DWORD cbPropData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Get ( _                           ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ REFGUID guidPropSet
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwPropID
   , BYVAL DWORD _                          ' /* [in] */ LPVOID pInstanceData
   , BYVAL DWORD _                          ' /* [in] */ DWORD cbInstanceData
   , BYREF DWORD _                          ' /* [out] */ LPVOID pPropData
   , BYVAL DWORD _                          ' /* [in] */ DWORD cbPropData
   , BYREF DWORD _                          ' /* [out] */ DWORD *pcbReturned
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD QuerySupported ( _                ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ REFGUID guidPropSet
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwPropID
   , BYREF DWORD _                          ' /* [out] */ DWORD *pTypeSupport
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IKsPropertySet_INTERFACE_DEFINED__*/

#ENDIF   ' // _IKsPropertySet_


' ########################################################################################
' Interface name = IMediaPropertyBag
' IID = {6025A880-C0D5-11D0-BD4E-00A0C911CE86}
' Inherited interface = IPropertyBag
' ########################################################################################

#IF NOT %DEF(%IMediaPropertyBag_INTERFACE_DEFINED)
    %IMediaPropertyBag_INTERFACE_DEFINED = 1

$IID_IMediaPropertyBag = GUID$("{6025A880-C0D5-11D0-BD4E-00A0C911CE86}")

INTERFACE IMediaPropertyBag $IID_IMediaPropertyBag

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Read ( _                          ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ LPCOLESTR pszPropName
   , BYREF VARIANT _                        ' /* [in][out] */ VARIANT *pVar
   , BYVAL IUnknown _                       ' /* [in] */ IErrorLog *pErrorLog
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Write ( _                         ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ LPCOLESTR pszPropName
   , BYREF VARIANT _                        ' /* [in] */ VARIANT *pVar
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumProperty ( _                  ' VTable offset = 24
     BYVAL DWORD _                          ' /* [in] */ ULONG iProperty
   , BYREF VARIANT _                        ' /* [out][in] */ VARIANT *pvarPropertyName
   , BYREF VARIANT _                        ' /* [out][in] */ VARIANT *pvarPropertyValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaPropertyBag_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IPersistMediaPropertyBag
' IID = {5738E040-B67F-11D0-BD4D-00A0C911CE86}
' Inherited interface = IPersist
' ########################################################################################

#IF NOT %DEF(%IPersistMediaPropertyBag_INTERFACE_DEFINED)
    %IPersistMediaPropertyBag_INTERFACE_DEFINED = 1

$IID_IPersistMediaPropertyBag = GUID$("{5738E040-B67F-11D0-BD4D-00A0C911CE86}")

INTERFACE IPersistMediaPropertyBag $IID_IPersistMediaPropertyBag

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetClassID ( _                    ' VTable offset = 12
     BYREF GUID _                           ' /* [out] */ CLSID *pClassID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD InitNew ( _                       ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Load ( _                          ' VTable offset = 20
     BYVAL IUnknown _                       ' /* [in] */ IMediaPropertyBag *pPropBag
   , BYVAL IUnknown _                       ' /* [in] */ IErrorLog *pErrorLog
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Save ( _                          ' VTable offset = 24
     BYVAL IUnknown _                       ' /* [in] */ IMediaPropertyBag *pPropBag
   , BYVAL LONG _                           ' /* [in] */ BOOL fClearDirty
   , BYVAL LONG _                           ' /* [in] */ BOOL fSaveAllProperties
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPersistMediaPropertyBag_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMPhysicalPinInfo
' IID = {F938C991-3029-11CF-8C44-00AA006B6814}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMPhysicalPinInfo_INTERFACE_DEFINED)
    %IAMPhysicalPinInfo_INTERFACE_DEFINED = 1

$IID_IAMPhysicalPinInfo = GUID$("{F938C991-3029-11CF-8C44-00AA006B6814}")

INTERFACE IAMPhysicalPinInfo $IID_IAMPhysicalPinInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetPhysicalType ( _               ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ long *pType
   , BYREF DWORD _                          ' /* [out] */ LPOLESTR *ppszType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMPhysicalPinInfo_INTERFACE_DEFINED__*/


' ########################################################################################
' Interface name = IAMExtDevice
' IID = {B5730A90-1A2C-11CF-8C23-00AA006B6814}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMExtDevice_INTERFACE_DEFINED)
    %IAMExtDevice_INTERFACE_DEFINED = 1

$IID_IAMExtDevice = GUID$("{B5730A90-1A2C-11CF-8C23-00AA006B6814}")

INTERFACE IAMExtDevice $IID_IAMExtDevice

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCapability ( _                 ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long Capability
   , BYREF LONG _                           ' /* [out] */ long *pValue
   , BYREF DOUBLE _                         ' /* [out] */ double *pdblValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_ExternalDeviceID ( _          ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ LPOLESTR *ppszData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_ExternalDeviceVersion ( _     ' VTable offset = 20
     BYREF DWORD _                          ' /* [out] */ LPOLESTR *ppszData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_DevicePower ( _               ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long PowerMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_DevicePower ( _               ' VTable offset = 28
     BYREF LONG _                           ' /* [out] */ long *pPowerMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Calibrate ( _                     ' VTable offset = 32
     BYVAL DWORD _                          ' /* [in] */ HEVENT hEvent
   , BYVAL LONG _                           ' /* [in] */ long Mode
   , BYREF LONG _                           ' /* [out] */ long *pStatus
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_DevicePort ( _                ' VTable offset = 36
     BYVAL LONG _                           ' /* [in] */ long DevicePort
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_DevicePort ( _                ' VTable offset = 40
     BYREF LONG _                           ' /* [out] */ long *pDevicePort
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMExtDevice_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMExtTransport
' IID = {A03CD5F0-3045-11CF-8C44-00AA006B6814}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMExtTransport_INTERFACE_DEFINED)
    %IAMExtTransport_INTERFACE_DEFINED = 1

$IID_IAMExtTransport = GUID$("{A03CD5F0-3045-11CF-8C44-00AA006B6814}")

INTERFACE IAMExtTransport $IID_IAMExtTransport

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCapability ( _                 ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long Capability
   , BYREF LONG _                           ' /* [out] */ long *pValue
   , BYREF DOUBLE _                         ' /* [out] */ double *pdblValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_MediaState ( _                ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long State
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_MediaState ( _                ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ long *pState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_LocalControl ( _              ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long State
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_LocalControl ( _              ' VTable offset = 28
     BYREF LONG _                           ' /* [out] */ long *pState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetStatus ( _                     ' VTable offset = 32
     BYVAL LONG _                           ' /* [in] */ long StatusItem
   , BYREF LONG _                           ' /* [out] */ long *pValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTransportBasicParameters ( _   ' VTable offset = 36
     BYVAL LONG _                           ' /* [in] */ long Param
   , BYREF LONG _                           ' /* [out] */ long *pValue
   , BYREF DWORD _                          ' /* [out] */ LPOLESTR *ppszData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTransportBasicParameters ( _   ' VTable offset = 40
     BYVAL LONG _                           ' /* [in] */ long Param
   , BYVAL LONG _                           ' /* [in] */ long Value
   , BYVAL DWORD _                          ' /* [in] */ LPCOLESTR pszData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTransportVideoParameters ( _   ' VTable offset = 44
     BYVAl LONG _                           ' /* [in] */ long Param
   , BYREF LONG _                           ' /* [out] */ long *pValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTransportVideoParameters ( _   ' VTable offset = 48
     BYVAl LONG _                           ' /* [in] */ long Param
   , BYVAL LONG _                           ' /* [in] */ long Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTransportAudioParameters ( _   ' VTable offset = 52
     BYVAl LONG _                           ' /* [in] */ long Param
   , BYREF LONG _                           ' /* [out] */ long *pValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTransportAudioParameters ( _   ' VTable offset = 56
     BYVAl LONG _                           ' /* [in] */ long Param
   , BYVAL LONG _                           ' /* [in] */ long Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Mode ( _                      ' VTable offset = 60
     BYVAL LONG _                           ' /* [in] */ long Mode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Mode ( _                      ' VTable offset = 64
     BYREF LONG _                           ' /* [out] */ long *pMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_Rate ( _                      ' VTable offset = 68
     BYVAL DOUBLE _                         ' /* [in] */ double dblRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_Rate ( _                      ' VTable offset = 72
     BYREF DOUBLE _                         ' /* [out] */ double *pdblRate
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetChase ( _                      ' VTable offset = 76
     BYREF LONG _                           ' /* [out] */ long *pEnabled
   , BYREF LONG _                           ' /* [out] */ long *pOffset
   , BYREF DWORD _                          ' /* [out] */ HEVENT *phEvent
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetChase ( _                      ' VTable offset = 80
     BYVAL LONG _                           ' /* [in] */ long Enable
   , BYVAL LONG _                           ' /* [in] */ long Offset
   , BYVAL DWORD _                          ' /* [in] */ HEVENT hEvent
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetBump ( _                       ' VTable offset = 84
     BYREF LONG _                           ' /* [out] */ long *pSpeed
   , BYREF LONG _                           ' /* [out] */ long *pDuration
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetBump ( _                       ' VTable offset = 88
     BYVAL LONG _                           ' /* [in] */ long Speed
   , BYVAL LONG _                           ' /* [in] */ long Duration
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_AntiClogControl ( _           ' VTable offset = 92
     BYREF LONG _                           ' /* [out] */ long *pEnabled
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_AntiClogControl ( _           ' VTable offset = 96
     BYVAL LONG _                           ' /* [in] */ long Enable
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetEditPropertySet ( _            ' VTable offset = 100
     BYVAL LONG _                           ' /* [in] */ long EditID
   , BYREF LONG _                           ' /* [out] */ long *pState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetEditPropertySet ( _            ' VTable offset = 104
     BYREF LONG _                           ' /* [out][in] */ long *pEditID
   , BYVAL LONG _                           ' /* [in] */ long State
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetEditProperty ( _               ' VTable offset = 108
     BYVAL LONG _                           ' /* [in] */ long EditID
   , BYVAL LONG _                           ' /* [in] */ long Param
   , BYREF LONG _                           ' /* [out] */ long *pValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetEditProperty ( _               ' VTable offset = 112
     BYVAL LONG _                           ' /* [in] */ long EditID
   , BYVAL LONG _                           ' /* [in] */ long Param
   , BYVAL LONG _                           ' /* [in] */ long Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_EditStart ( _                 ' VTable offset = 116
     BYREF LONG _                           ' /* [out] */ long *pValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_EditStart ( _                 ' VTable offset = 120
     BYVAL LONG _                           ' /* [in] */ long Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMExtTransport_INTERFACE_DEFINED__ */

TYPE TIMECODESTRUCT
   wFrameRate  AS WORD
   wFrameFract AS WORD
   dwFrames    AS DWORD
END TYPE

UNION TIMECODE
   TIMECODESTRUCT
   qw AS QUAD
END UNION

TYPE TIMECODE_SAMPLE
   qwTick   AS QUAD
   timecode AS TIMECODE
   dwUser   AS DWORD
   dwFlags  AS DWORD
END TYPE


' ########################################################################################
' Interface name = IAMTimecodeReader
' IID = {9B496CE1-811B-11CF-8C77-00AA006B6814}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMTimecodeReader_INTERFACE_DEFINED)
    %IAMTimecodeReader_INTERFACE_DEFINED = 1

$IID_IAMTimecodeReader = GUID$("{9B496CE1-811B-11CF-8C77-00AA006B6814}")

INTERFACE IAMTimecodeReader $IID_IAMTimecodeReader

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTCRMode ( _                    ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long Param
   , BYREF LONG _                           ' /* [out] */ long *pValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTCRMode ( _                    ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long Param
   , BYVAL LONG _                           ' /* [in] */ long Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_VITCLine ( _                  ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long Line
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_VITCLine ( _                  ' VTable offset = 24
     BYREF LONG _                           ' /* [out] */ long *pLine
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTimecode ( _                   ' VTable offset = 28
     BYREF TIMECODE_SAMPLE _                ' /* [out] */ PTIMECODE_SAMPLE pTimecodeSample
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMTimecodeReader_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMTimecodeGenerator
' IID = {9B496CE0-811B-11CF-8C77-00AA006B6814}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMTimecodeGenerator_INTERFACE_DEFINED)
    %IAMTimecodeGenerator_INTERFACE_DEFINED = 1

$IID_IAMTimecodeGenerator = GUID$("{9B496CE0-811B-11CF-8C77-00AA006B6814}")

INTERFACE IAMTimecodeGenerator $IID_IAMTimecodeGenerator

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTCGMode ( _                    ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long Param
   , BYREF LONG _                           ' /* [out] */ long *pValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTCGMode ( _                    ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long Param
   , BYVAL LONG _                           ' /* [in] */ long Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_VITCLine ( _                  ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long Line
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD get_VITCLine ( _                  ' VTable offset = 24
     BYREF LONG _                           ' /* [out] */ long *pLine
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTimecode ( _                   ' VTable offset = 28
     BYREF TIMECODE_SAMPLE _                ' /* [in] */ PTIMECODE_SAMPLE pTimecodeSample
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTimecode ( _                   ' VTable offset = 32
     BYREF TIMECODE_SAMPLE _                ' /* [out] */ PTIMECODE_SAMPLE pTimecodeSample
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMTimecodeGenerator_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMTimecodeDisplay
' IID = {9B496CE2-811B-11CF-8C77-00AA006B6814}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMTimecodeDisplay_INTERFACE_DEFINED)
    %IAMTimecodeDisplay_INTERFACE_DEFINED = 1

$IID_IAMTimecodeDisplay = GUID$("{9B496CE2-811B-11CF-8C77-00AA006B6814}")

INTERFACE IAMTimecodeDisplay $IID_IAMTimecodeDisplay

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetTCDisplayEnable ( _            ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ long *pState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTCDisplayEnable ( _            ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long State
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTCDisplay ( _                  ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long Param
   , BYREF LONG _                           ' /* [out] */ long *pValue
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetTCDisplay ( _                  ' VTable offset = 24
     BYVAL LONG _                           ' /* [in] */ long Param
   , BYVAL LONG _                           ' /* [in] */ long Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMTimecodeDisplay_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMDevMemoryAllocator
' IID = {C6545BF0-E76B-11D0-BD52-00A0C911CE86}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMDevMemoryAllocator_INTERFACE_DEFINED)
    %IAMDevMemoryAllocator_INTERFACE_DEFINED = 1

$IID_IAMDevMemoryAllocator = GUID$("{C6545BF0-E76B-11D0-BD52-00A0C911CE86}")

INTERFACE IAMDevMemoryAllocator $IID_IAMDevMemoryAllocator

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetInfo ( _                       ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwcbTotalFree
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwcbLargestFree
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwcbTotalMemory
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwcbMinimumChunk
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CheckMemory ( _                   ' VTable offset = 16
     BYVAL BYTE PTR _                       ' /* [in] */ const BYTE *pBuffer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Alloc ( _                         ' VTable offset = 20
     BYREF DWORD _                          ' /* [out] */ BYTE **ppBuffer
   , BYREF DWORD _                          ' /* [out][in] */ DWORD *pdwcbBuffer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Free ( _                          ' VTable offset = 24
     BYVAL BYTE PTR _                       ' /* [in] */ BYTE *pBuffer
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDevMemoryObject ( _            ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IUnknown **ppUnkInnner
   , BYVAL IUnknown _                       ' /* [in] */ IUnknown *pUnkOuter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMDevMemoryAllocator_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMDevMemoryControl
' IID = {C6545BF1-E76B-11D0-BD52-00A0C911CE86}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMDevMemoryControl_INTERFACE_DEFINED)
    %IAMDevMemoryControl_INTERFACE_DEFINED = 1

$IID_IAMDevMemoryControl = GUID$("{C6545BF1-E76B-11D0-BD52-00A0C911CE86}")

INTERFACE IAMDevMemoryControl $IID_IAMDevMemoryControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryWriteSync ( _                ' VTable offset = 12
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD WriteSync ( _                     ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDevId ( _                      ' VTable offset = 20
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwDevId
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMDevMemoryControl_INTERFACE_DEFINED__ */


' enum AMSTREAMSELECTINFOFLAGS
%AMSTREAMSELECTINFO_ENABLED     = &H1
%AMSTREAMSELECTINFO_EXCLUSIVE   = &H2

' enum AMSTREAMSELECTENABLEFLAGS
%AMSTREAMSELECTENABLE_ENABLE    = &H1
%AMSTREAMSELECTENABLE_ENABLEALL = &H2


' ########################################################################################
' Interface name = IAMStreamSelect
' IID = {C1960960-17F5-11D1-ABE1-00A0C905F375}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMStreamSelect_INTERFACE_DEFINED)
    %IAMStreamSelect_INTERFACE_DEFINED = 1

$IID_IAMStreamSelect = GUID$("{C1960960-17F5-11D1-ABE1-00A0C905F375}")

INTERFACE IAMStreamSelect $IID_IAMStreamSelect

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Count ( _                         ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ DWORD *pcStreams
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Info ( _                          ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long lIndex
   , BYREF AM_MEDIA_TYPE _                  ' /* [out] */ AM_MEDIA_TYPE **ppmt
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwFlags
   , BYREF LONG _                           ' /* [out] */ LCID *plcid
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwGroup
   , BYREF DWORD _                          ' /* [out] */ WCHAR **ppszName
   , BYREF IUnknown _                       ' /* [out] */ IUnknown **ppObject
   , BYREF IUnknown _                       ' /* [out] */ IUnknown **ppUnk
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Enable ( _                        ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ long lIndex
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMStreamSelect_INTERFACE_DEFINED__ */


' enum _AMRESCTL_RESERVEFLAGS
%AMRESCTL_RESERVEFLAGS_RESERVE   = 0
%AMRESCTL_RESERVEFLAGS_UNRESERVE = &H1


' ########################################################################################
' Interface name = IAMResourceControl
' IID = {8389D2D0-77D7-11D1-ABE6-00A0C905F375}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMResourceControl_INTERFACE_DEFINED)
    %IAMResourceControl_INTERFACE_DEFINED = 1

$IID_IAMResourceControl = GUID$("{8389D2D0-77D7-11D1-ABE6-00A0C905F375}")

INTERFACE IAMResourceControl $IID_IAMResourceControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Reserve ( _                       ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYVAL DWORD _                          ' /* [in] */ PVOID pvReserved
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMResourceControl_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMClockAdjust
' IID = {4D5466B0-A49C-11D1-ABE8-00A0C905F375}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMClockAdjust_INTERFACE_DEFINED)
    %IAMClockAdjust_INTERFACE_DEFINED = 1

$IID_IAMClockAdjust = GUID$("{4D5466B0-A49C-11D1-ABE8-00A0C905F375}")

INTERFACE IAMClockAdjust $IID_IAMClockAdjust

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetClockDelta ( _                 ' VTable offset = 12
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtDelta
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMClockAdjust_INTERFACE_DEFINED__ */


' enum _AM_FILTER_MISC_FLAGS
%AM_FILTER_MISC_FLAGS_IS_RENDERER = &H1
%AM_FILTER_MISC_FLAGS_IS_SOURCE   = &H2


' ########################################################################################
' Interface name = IAMFilterMiscFlags
' IID = {2DD74950-A890-11D1-ABE8-00A0C905F375}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMFilterMiscFlags_INTERFACE_DEFINED)
    %IAMFilterMiscFlags_INTERFACE_DEFINED = 1

$IID_IAMFilterMiscFlags = GUID$("{2DD74950-A890-11D1-ABE8-00A0C905F375}")

INTERFACE IAMFilterMiscFlags $IID_IAMFilterMiscFlags

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetMiscFlags ( _                  ' VTable offset = 12
     ) AS DWORD                             ' ULONG
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMFilterMiscFlags_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDrawVideoImage
' IID = {48EFB120-AB49-11D2-AED2-00A0C995E8D5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDrawVideoImage_INTERFACE_DEFINED)
    %IDrawVideoImage_INTERFACE_DEFINED = 1

$IID_IDrawVideoImage = GUID$("{48EFB120-AB49-11D2-AED2-00A0C995E8D5}")

INTERFACE IDrawVideoImage $IID_IDrawVideoImage

   INHERIT IUnknown

   ' =====================================================================================
   METHOD DrawVideoImageBegin ( _           ' VTable offset = 12
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD DrawVideoImageEnd ( _             ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD DrawVideoImageDraw ( _            ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ HDC hdc
   , BYREF RECT _                           ' /* [in] */ LPRECT lprcSrc
   , BYREF RECT _                           ' /* [in] */ LPRECT lprcDst
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDrawVideoImage_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDecimateVideoImage
' IID = {2E5EA3E0-E924-11D2-B6DA-00A0C995E8DF}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDecimateVideoImage_INTERFACE_DEFINED)
    %IDecimateVideoImage_INTERFACE_DEFINED = 1

$IID_IDecimateVideoImage = GUID$("{2E5EA3E0-E924-11D2-B6DA-00A0C995E8DF}")

INTERFACE IDecimateVideoImage $IID_IDecimateVideoImage

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetDecimationImageSize ( _        ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ long lWidth
   , BYVAL LONG _                           ' /* [in] */ long lHeight
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ResetDecimationImageSize ( _      ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDecimateVideoImage_INTERFACE_DEFINED__ */


' enum DECIMATION_USAGE
%DECIMATION_LEGACY             = 0
%DECIMATION_USE_DECODER_ONLY   = %DECIMATION_LEGACY             + 1
%DECIMATION_USE_VIDEOPORT_ONLY = %DECIMATION_USE_DECODER_ONLY   + 1
%DECIMATION_USE_OVERLAY_ONLY   = %DECIMATION_USE_VIDEOPORT_ONLY + 1
%DECIMATION_DEFAULT            = %DECIMATION_USE_OVERLAY_ONLY   + 1


' ########################################################################################
' Interface name = IAMVideoDecimationProperties
' IID = {60D32930-13DA-11D3-9EC6-C4FCAEF5C7BE}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMVideoDecimationProperties_INTERFACE_DEFINED)
    %IAMVideoDecimationProperties_INTERFACE_DEFINED = 1

$IID_IAMVideoDecimationProperties = GUID$("{60D32930-13DA-11D3-9EC6-C4FCAEF5C7BE}")

INTERFACE IAMVideoDecimationProperties $IID_IAMVideoDecimationProperties

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryDecimationUsage ( _          ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ DECIMATION_USAGE *lpUsage
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDecimationUsage ( _            ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ DECIMATION_USAGE Usage
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMVideoDecimationProperties_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVideoFrameStep
' IID = {E46A9787-2B71-444D-A4B5-1FAB7B708D6A}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVideoFrameStep_INTERFACE_DEFINED)
    %IVideoFrameStep_INTERFACE_DEFINED = 1

$IID_IVideoFrameStep = GUID$("{E46A9787-2B71-444D-A4B5-1FAB7B708D6A}")

INTERFACE IVideoFrameStep $IID_IVideoFrameStep

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Step ( _                          ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwFrames
   , BYVAL IUnknown _                       ' /* [in] */ IUnknown *pStepObject
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CanStep ( _                       ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ long bMultiple
   , BYVAL IUnknown _                       ' /* [in] */ IUnknown *pStepObject
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CancelStep ( _                    ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVideoFrameStep_INTERFACE_DEFINED__ */


' enum AM_PUSHSOURCE_FLAGS
%AM_PUSHSOURCECAPS_INTERNAL_RM      = &H1???
%AM_PUSHSOURCECAPS_NOT_LIVE         = &H2???
%AM_PUSHSOURCECAPS_PRIVATE_CLOCK    = &H4???
%AM_PUSHSOURCEREQS_USE_STREAM_CLOCK = &H10000???
%AM_PUSHSOURCEREQS_USE_CLOCK_CHAIN  = &H20000???


' ########################################################################################
' Interface name = IAMLatency
' IID = {62EA93BA-EC62-11D2-B770-00C04FB6BD3D}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMLatency_INTERFACE_DEFINED)
    %IAMLatency_INTERFACE_DEFINED = 1

$IID_IAMLatency = GUID$("{62EA93BA-EC62-11D2-B770-00C04FB6BD3D}")

INTERFACE IAMLatency $IID_IAMLatency

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetLatency ( _                    ' VTable offset = 12
     BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *prtLatency
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMLatency_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMPushSource
' IID = {F185FE76-E64E-11D2-B76E-00C04FB6BD3D}
' Inherited interface = IAMLatency
' ########################################################################################

#IF NOT %DEF(%IAMPushSource_INTERFACE_DEFINED)
    %IAMPushSource_INTERFACE_DEFINED = 1

$IID_IAMPushSource = GUID$("{F185FE76-E64E-11D2-B76E-00C04FB6BD3D}")

INTERFACE IAMPushSource $IID_IAMPushSource

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetLatency ( _                    ' VTable offset = 12
     BYREF QUAD _                           ' /* [in] */ REFERENCE_TIME *prtLatency
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetPushSourceFlags ( _            ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ ULONG *pFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetPushSourceFlags ( _            ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ ULONG Flags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetStreamOffset ( _               ' VTable offset = 24
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtOffset
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetStreamOffset ( _               ' VTable offset = 28
     BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *prtOffset
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMaxStreamOffset ( _            ' VTable offset = 32
     BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *prtMaxOffset
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetMaxStreamOffset ( _            ' VTable offset = 37
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtMaxOffset
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMPushSource_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMDeviceRemoval
' IID = {F90A6130-B658-11D2-AE49-0000F8754B99}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMDeviceRemoval_INTERFACE_DEFINED)
    %IAMDeviceRemoval_INTERFACE_DEFINED = 1

$IID_IAMDeviceRemoval = GUID$("{F90A6130-B658-11D2-AE49-0000F8754B99}")

INTERFACE IAMDeviceRemoval $IID_IAMDeviceRemoval

   INHERIT IUnknown

   ' =====================================================================================
   METHOD DeviceInfo ( _                    ' VTable offset = 12
     BYREF GUID _                           ' /* [out] */ CLSID *pclsidInterfaceClass
   , BYREF DWORD _                          ' /* [out] */ WCHAR **pwszSymbolicLink
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reassociate ( _                   ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Disassociate ( _                  ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMDeviceRemoval_INTERFACE_DEFINED__ */


TYPE DVINFO
   dwDVAAuxSrc     AS DWORD
   dwDVAAuxCtl     AS DWORD
   dwDVAAuxSrc1    AS DWORD
   dwDVAAuxCtl1    AS DWORD
   dwDVVAuxSrc     AS DWORD
   dwDVVAuxCtl     AS DWORD
   dwDVReserved(1) AS DWORD
END TYPE

' enum DVENCODERRESOLUTION
%DVENCODERRESOLUTION_720x480 = 2012
%DVENCODERRESOLUTION_360x240 = 2013
%DVENCODERRESOLUTION_180x120 = 2014
%DVENCODERRESOLUTION_88x60   = 2015

' enum DVENCODERVIDEOFORMAT
%DVENCODERVIDEOFORMAT_NTSC   = 2000
%DVENCODERVIDEOFORMAT_PAL    = 2001

' enum DVENCODERFORMAT
%DVENCODERFORMAT_DVSD        = 2007
%DVENCODERFORMAT_DVHD        = 2008
%DVENCODERFORMAT_DVSL        = 2009


' ########################################################################################
' Interface name = IDVEnc
' IID = {D18E17A0-AACB-11D0-AFB0-00AA00B67A42}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDVEnc_INTERFACE_DEFINED)
    %IDVEnc_INTERFACE_DEFINED = 1

$IID_IDVEnc = GUID$("{D18E17A0-AACB-11D0-AFB0-00AA00B67A42}")

INTERFACE IDVEnc $IID_IDVEnc

   INHERIT IUnknown

   ' =====================================================================================
   METHOD get_IFormatResolution ( _         ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ int *VideoFormat
   , BYREF DWORD _                          ' /* [out] */ int *DVFormat
   , BYREF DWORD _                          ' /* [out] */ int *Resolution
   , BYVAL BYTE _                           ' /* [in] */ BYTE fDVInfo
   , BYREF DVINFO _                         ' /* [out] */ DVINFO *sDVInfo
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_IFormatResolution ( _         ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ int VideoFormat
   , BYVAL DWORD _                          ' /* [in] */ int DVFormat
   , BYVAL DWORD _                          ' /* [in] */ int Resolution
   , BYVAL BYTE _                           ' /* [in] */ BYTE fDVInfo
   , BYREF DVINFO _                         ' /* [in] */ DVINFO *sDVInfo
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDVEnc_INTERFACE_DEFINED__ */


' enum DVDECODERRESOLUTION
%DVDECODERRESOLUTION_720x480 = 1000
%DVDECODERRESOLUTION_360x240 = 1001
%DVDECODERRESOLUTION_180x120 = 1002
%DVDECODERRESOLUTION_88x60   = 1003

' enum DVRESOLUTION
%DVRESOLUTION_FULL           = 1000
%DVRESOLUTION_HALF           = 1001
%DVRESOLUTION_QUARTER        = 1002
%DVRESOLUTION_DC             = 1003


' ########################################################################################
' Interface name = IIPDVDec
' IID = {B8E8BD60-0BFE-11D0-AF91-00AA00B67A42}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IIPDVDec_INTERFACE_DEFINED)
    %IIPDVDec_INTERFACE_DEFINED = 1

$IID_IIPDVDec = GUID$("{B8E8BD60-0BFE-11D0-AF91-00AA00B67A42}")

INTERFACE IIPDVDec $IID_IIPDVDec

   INHERIT IUnknown

   ' =====================================================================================
   METHOD get_IPDisplay ( _                 ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ int *displayPix
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD put_IPDisplay ( _                 ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ int displayPix
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IIPDVDec_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDVRGB219
' IID = {58473A19-2BC8-4663-8012-25F81BABDDD1}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDVRGB219_INTERFACE_DEFINED)
    %IDVRGB219_INTERFACE_DEFINED = 1

$IID_IDVRGB219 = GUID$("{58473A19-2BC8-4663-8012-25F81BABDDD1}")

INTERFACE IDVRGB219 $IID_IDVRGB219

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetRGB219 ( _                     ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ BOOL bState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDVRGB219_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDVSplitter
' IID = {92A3A302-DA7C-4A1F-BA7E-1802BB5D2D02}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDVSplitter_INTERFACE_DEFINED)
    %IDVSplitter_INTERFACE_DEFINED = 1

$IID_IDVSplitter = GUID$("{92A3A302-DA7C-4A1F-BA7E-1802BB5D2D02}")

INTERFACE IDVSplitter $IID_IDVSplitter

   INHERIT IUnknown

   ' =====================================================================================
   METHOD DiscardAlternateVideoFrames ( _   ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ int nDiscard
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDVSplitter_INTERFACE_DEFINED__ */


' enum AM_AUDIO_RENDERER_STAT_PARAM
%AM_AUDREND_STAT_PARAM_BREAK_COUNT            = 1
%AM_AUDREND_STAT_PARAM_SLAVE_MODE             = %AM_AUDREND_STAT_PARAM_BREAK_COUNT            + 1
%AM_AUDREND_STAT_PARAM_SILENCE_DUR            = %AM_AUDREND_STAT_PARAM_SLAVE_MODE             + 1
%AM_AUDREND_STAT_PARAM_LAST_BUFFER_DUR        = %AM_AUDREND_STAT_PARAM_SILENCE_DUR            + 1
%AM_AUDREND_STAT_PARAM_DISCONTINUITIES        = %AM_AUDREND_STAT_PARAM_LAST_BUFFER_DUR        + 1
%AM_AUDREND_STAT_PARAM_SLAVE_RATE             = %AM_AUDREND_STAT_PARAM_DISCONTINUITIES        + 1
%AM_AUDREND_STAT_PARAM_SLAVE_DROPWRITE_DUR    = %AM_AUDREND_STAT_PARAM_SLAVE_RATE             + 1
%AM_AUDREND_STAT_PARAM_SLAVE_HIGHLOWERROR     = %AM_AUDREND_STAT_PARAM_SLAVE_DROPWRITE_DUR    + 1
%AM_AUDREND_STAT_PARAM_SLAVE_LASTHIGHLOWERROR = %AM_AUDREND_STAT_PARAM_SLAVE_HIGHLOWERROR     + 1
%AM_AUDREND_STAT_PARAM_SLAVE_ACCUMERROR       = %AM_AUDREND_STAT_PARAM_SLAVE_LASTHIGHLOWERROR + 1
%AM_AUDREND_STAT_PARAM_BUFFERFULLNESS         = %AM_AUDREND_STAT_PARAM_SLAVE_ACCUMERROR       + 1
%AM_AUDREND_STAT_PARAM_JITTER                 = %AM_AUDREND_STAT_PARAM_BUFFERFULLNESS         + 1


' ########################################################################################
' Interface name = IAMAudioRendererStats
' IID = {22320CB2-D41A-11D2-BF7C-D7CB9DF0BF93}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMAudioRendererStats_INTERFACE_DEFINED)
    %IAMAudioRendererStats_INTERFACE_DEFINED = 1

$IID_IAMAudioRendererStats = GUID$("{22320CB2-D41A-11D2-BF7C-D7CB9DF0BF93}")

INTERFACE IAMAudioRendererStats $IID_IAMAudioRendererStats

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetStatParam ( _                  ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwParam
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwParam1
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwParam2
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMAudioRendererStats_INTERFACE_DEFINED__ */


' enum AM_INTF_SEARCH_FLAGS
%AM_INTF_SEARCH_INPUT_PIN  = &H1???
%AM_INTF_SEARCH_OUTPUT_PIN = &H2???
%AM_INTF_SEARCH_FILTER     = &H4???


' ########################################################################################
' Interface name = IAMGraphStreams
' IID = {632105FA-072E-11D3-8AF9-00C04FB6BD3D}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMGraphStreams_INTERFACE_DEFINED)
    %IAMGraphStreams_INTERFACE_DEFINED = 1

$IID_IAMGraphStreams = GUID$("{632105FA-072E-11D3-8AF9-00C04FB6BD3D}")

INTERFACE IAMGraphStreams $IID_IAMGraphStreams

   INHERIT IUnknown

   ' =====================================================================================
   METHOD FindUpstreamInterface ( _         ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
   , BYREF GUID _                           ' /* [in] */ REFIID riid
   , BYREF IUnknown _                       ' /* [out] */ void **ppvInterface
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SyncUsingStreamOffset ( _         ' VTable offset = 16
     BYVAL LONG _                           ' /* [in] */ BOOL bUseStreamOffset
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetMaxGraphLatency ( _            ' VTable offset = 20
     BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtMaxGraphLatency
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMGraphStreams_INTERFACE_DEFINED__ */


' enum AMOVERLAYFX
%AMOVERFX_NOFX            = 0
%AMOVERFX_MIRRORLEFTRIGHT = &H2
%AMOVERFX_MIRRORUPDOWN    = &H4
%AMOVERFX_DEINTERLACE     = &H8


' ########################################################################################
' Interface name = IAMOverlayFX
' IID = {62FAE250-7E65-4460-BFC9-6398B322073C}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMOverlayFX_INTERFACE_DEFINED)
    %IAMOverlayFX_INTERFACE_DEFINED = 1

$IID_IAMOverlayFX = GUID$("{62FAE250-7E65-4460-BFC9-6398B322073C}")

INTERFACE IAMOverlayFX $IID_IAMOverlayFX

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryOverlayFXCaps ( _            ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ DWORD *lpdwOverlayFXCaps
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetOverlayFX ( _                  ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ DWORD dwOverlayFX
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetOverlayFX ( _                  ' VTable offset = 20
     BYREF DWORD _                          ' /* [out] */ DWORD *lpdwOverlayFX
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMOverlayFX_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMOpenProgress
' IID = {8E1C39A1-DE53-11CF-AA63-0080C744528D}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMOpenProgress_INTERFACE_DEFINED)
    %IAMOpenProgress_INTERFACE_DEFINED = 1

$IID_IAMOpenProgress = GUID$("{8E1C39A1-DE53-11CF-AA63-0080C744528D}")

INTERFACE IAMOpenProgress $IID_IAMOpenProgress

   INHERIT IUnknown

   ' =====================================================================================
   METHOD QueryProgress ( _                 ' VTable offset = 12
     BYREF QUAD _                           ' /* [out] */ LONGLONG *pllTotal
   , BYREF QUAD _                           ' /* [out] */ LONGLONG *pllCurrent
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AbortOperation ( _                ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMOpenProgress_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IMpeg2Demultiplexer
' IID = {436EEE9C-264F-4242-90E1-4E330C107512}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMpeg2Demultiplexer_INTERFACE_DEFINED)
    %IMpeg2Demultiplexer_INTERFACE_DEFINED = 1

$IID_IMpeg2Demultiplexer = GUID$("{436EEE9C-264F-4242-90E1-4E330C107512}")

INTERFACE IMpeg2Demultiplexer $IID_IMpeg2Demultiplexer

   INHERIT IUnknown

   ' =====================================================================================
   METHOD CreateOutputPin ( _               ' VTable offset = 12
     BYREF AM_MEDIA_TYPE _                  ' /* [in] */ AM_MEDIA_TYPE *pMediaType
   , BYVAL DWORD _                          ' /* [in] */ LPWSTR pszPinName
   , BYREF IUnknown _                       ' /* [out] */ IPin **ppIPin
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetOutputPinMediaType ( _         ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ LPWSTR pszPinName
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ AM_MEDIA_TYPE *pMediaType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD DeleteOutputPin ( _               ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ LPWSTR pszPinName
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMpeg2Demultiplexer_INTERFACE_DEFINED__ */


%MPEG2_PROGRAM_STREAM_MAP           = &H00000000???
%MPEG2_PROGRAM_ELEMENTARY_STREAM    = &H00000001???
%MPEG2_PROGRAM_DIRECTORY_PES_PACKET = &H00000002???
%MPEG2_PROGRAM_PACK_HEADER          = &H00000003???
%MPEG2_PROGRAM_PES_STREAM           = &H00000004???
%MPEG2_PROGRAM_SYSTEM_HEADER        = &H00000005???
%SUBSTREAM_FILTER_VAL_NONE          = &H10000000???

TYPE STREAM_ID_MAP
   stream_id              AS DWORD
   dwMediaSampleContent   AS DWORD
   ulSubstreamFilterValue AS DWORD
   iDataOffset            AS LONG
END TYPE


' ########################################################################################
' Interface name = IEnumStreamIdMap
' IID = {945C1566-6202-46FC-96C7-D87F289C6534}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEnumStreamIdMap_INTERFACE_DEFINED)
    %IEnumStreamIdMap_INTERFACE_DEFINED = 1

$IID_IEnumStreamIdMap = GUID$("{945C1566-6202-46FC-96C7-D87F289C6534}")

INTERFACE IEnumStreamIdMap $IID_IEnumStreamIdMap

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Next ( _                          ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ ULONG cRequest
   , BYREF STREAM_ID_MAP _                  ' /* [out][in] */ STREAM_ID_MAP *pStreamIdMap
   , BYREF DWORD _                          ' /* [out] */ ULONG *pcReceived
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Skip ( _                          ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ ULONG cRecords
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reset ( _                         ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Clone ( _                         ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IEnumStreamIdMap **ppIEnumStreamIdMap
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEnumStreamIdMap_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IMPEG2StreamIdMap
' IID = {D0E04C47-25B8-4369-925A-362A01D95444}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IMPEG2StreamIdMap_INTERFACE_DEFINED)
    %IMPEG2StreamIdMap_INTERFACE_DEFINED = 1

$IID_IMPEG2StreamIdMap = GUID$("{D0E04C47-25B8-4369-925A-362A01D95444}")

INTERFACE IMPEG2StreamIdMap $IID_IMPEG2StreamIdMap

   INHERIT IUnknown

   ' =====================================================================================
   METHOD MapStreamId ( _                   ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStreamId
   , BYVAL DWORD _                          ' /* [in] */ DWORD MediaSampleContent
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulSubstreamFilterValue
   , BYVAL LONG _                           ' /* [in] */ int iDataOffset
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnmapStreamId ( _                 ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ ULONG culStreamId
   , BYVAL DWORD _                          ' /* [in] */ ULONG *pulStreamId
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumStreamIdMap ( _               ' VTable offset = 20
     BYREF IUnknown _                       ' /* [out] */ IEnumStreamIdMap **ppIEnumStreamIdMap
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMPEG2StreamIdMap_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IRegisterServiceProvider
' IID = {7B3A2F01-0751-48DD-B556-004785171C54}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IRegisterServiceProvider_INTERFACE_DEFINED)
    %IRegisterServiceProvider_INTERFACE_DEFINED = 1

$IID_IRegisterServiceProvider = GUID$("{7B3A2F01-0751-48DD-B556-004785171C54}")

INTERFACE IRegisterServiceProvider $IID_IRegisterServiceProvider

   INHERIT IUnknown

   ' =====================================================================================
   METHOD RegisterService ( _               ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ REFGUID guidService
   , BYVAL IUnknown _                       ' /* [in] */ IUnknown *pUnkObject
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRegisterServiceProvider_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMClockSlave
' IID = {9FD52741-176D-4b36-8F51-CA8F933223BE}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMClockSlave_INTERFACE_DEFINED)
    %IAMClockSlave_INTERFACE_DEFINED = 1

$IID_IAMClockSlave = GUID$("{9FD52741-176D-4b36-8F51-CA8F933223BE}")

INTERFACE IAMClockSlave $IID_IAMClockSlave

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetErrorTolerance ( _             ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwTolerance
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetErrorTolerance ( _             ' VTable offset = 16
      BYREF DWORD _                         ' /* [out] */ DWORD *pdwTolerance
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMClockSlave_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMGraphBuilderCallback
' IID = {4995F511-9DDB-4F12-BD3B-F04611807B79}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMGraphBuilderCallback_INTERFACE_DEFINED)
    %IAMGraphBuilderCallback_INTERFACE_DEFINED = 1

$IID_IAMGraphBuilderCallback = GUID$("{4995F511-9DDB-4F12-BD3B-F04611807B79}")

INTERFACE IAMGraphBuilderCallback $IID_IAMGraphBuilderCallback

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SelectedFilter ( _                ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IMoniker *pMon
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CreatedFilter ( _                 ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFil
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMGraphBuilderCallback_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IAMFilterGraphCallback
' IID = {56A868FD-0AD4-11CE-B0A3-0020AF0BA770}
' Inherited interface = IUnknown
' The IAMFilterGraphCallback interface provides a callback mechanism during graph building.
' To use this interface, implement the interface in your application or client object.
' Query the Filter Graph Manager for the IObjectWithSite interface and call the
' IObjectWithSite::SetSite method with a pointer to your implementation of the interface.
' During graph building, if the Filter Graph Manager fails to render a pin, it calls the
' UnabletoRender method. The client can then take appropriate action, such as providing an
' error message for the user or registering a new filter.
' // Note: Because this interface was not defined as a proper interface it is
' //       supported under C++ only. Methods aren't stdcall.
' ########################################################################################

'#IF NOT %DEF(%IAMFilterGraphCallback)
'    %IAMFilterGraphCallback = 1

$IID_IAMFilterGraphCallback = GUID$("{56A868FD-0AD4-11CE-B0A3-0020AF0BA770}")

'INTERFACE IAMFilterGraphCallback $IID_IAMFilterGraphCallback

'   INHERIT IUnknown

'   ' =====================================================================================
'   METHOD UnableToRender ( _                ' VTable offset = 12
'     BYVAL IUnknown _                       ' /* [in] */ IPin *pPin
'   ) AS LONG                                ' HRESULT
'   ' =====================================================================================

'END INTERFACE

'#ENDIF   ' // _IAMFilterGraphCallback_


TYPE CodecAPIEventData
   guid        AS GUID
   dataLength  AS DWORD
   reserved(2) AS DWORD
END TYPE


' ########################################################################################
' Interface name = ICodecAPI
' IID = {901DB4C7-31CE-41A2-85DC-8FA0BF41B8DA}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%ICodecAPI_INTERFACE_DEFINED)
    %ICodecAPI_INTERFACE_DEFINED = 1

$IID_ICodecAPI = GUID$("{901DB4C7-31CE-41A2-85DC-8FA0BF41B8DA}")

INTERFACE ICodecAPI $IID_ICodecAPI

   INHERIT IUnknown

   ' =====================================================================================
   METHOD IsSupported ( _                   ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsModifiable ( _                  ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetParameterRange ( _             ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *ValueMin
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *ValueMax
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *SteppingDelta
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetParameterValues ( _            ' VTable offset = 24
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT **Values [array]
   , BYREF DWORD _                          ' /* [out] */ ULONG *ValuesCount
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDefaultValue ( _               ' VTable offset = 28
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetValue ( _                      ' VTable offset = 32
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetValue ( _                      ' VTable offset = 36
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [in] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RegisterForEvent ( _              ' VTable offset = 40
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYVAL LONG _                           ' /* [in] */ LONG_PTR userData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnregisterForEvent ( _            ' VTable offset = 44
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetAllDefaults ( _                ' VTable offset = 48
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetValueWithNotify ( _            ' VTable offset = 52
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [in] */ VARIANT *Value
   , BYREF GUID _                           ' /* [out] */ GUID **ChangedParam
   , BYREF DWORD _                          ' /* [out] */ ULONG *ChangedParamCount
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetAllDefaultsWithNotify ( _      ' VTable offset = 56
     BYREF GUID _                           ' /* [out] */ GUID **ChangedParam
   , BYREF DWORD _                          ' /* [out] */ ULONG *ChangedParamCount
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAllSettings ( _                ' VTable offset = 60
     BYVAL IUnknown _                       ' /* [in] */ IStream *pStream
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetAllSettings ( _                ' VTable offset = 64
     BYVAL IUnknown _                       ' /* [in] */ IStream *pStream
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetAllSettingsWithNotify ( _      ' VTable offset = 68
     BYVAL IUnknown _                       ' /* [in] */ IStream *pStream
   , BYREF GUID _                           ' /* [out] */ GUID **ChangedParam
   , BYREF DWORD _                          ' /* [out] */ ULONG *ChangedParamCount
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ICodecAPI_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IGetCapabilitiesKey
' IID = {A8809222-07BB-48EA-951C-33158100625B}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IGetCapabilitiesKey_INTERFACE_DEFINED)
    %IGetCapabilitiesKey_INTERFACE_DEFINED = 1

$IID_IGetCapabilitiesKey = GUID$("{A8809222-07BB-48EA-951C-33158100625B}")

INTERFACE IGetCapabilitiesKey $IID_IGetCapabilitiesKey

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCapabilitiesKey ( _            ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ HKEY *pHKey
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IGetCapabilitiesKey_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IEncoderAPI
' IID = {70423839-6ACC-4b23-B079-21DBF08156A5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IEncoderAPI_INTERFACE_DEFINED)
    %IEncoderAPI_INTERFACE_DEFINED = 1

$IID_IEncoderAPI = GUID$("{70423839-6ACC-4b23-B079-21DBF08156A5}")

INTERFACE IEncoderAPI $IID_IEncoderAPI

   INHERIT IUnknown

   ' =====================================================================================
   METHOD IsSupported ( _                   ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsAvailable ( _                   ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetParameterRange ( _             ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *ValueMin
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *ValueMax
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *SteppingDelta
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetParameterValues ( _            ' VTable offset = 24
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT **Values
   , BYREF DWORD _                          ' /* [out] */ ULONG *ValuesCount
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDefaultValue ( _               ' VTable offset = 28
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetValue ( _                      ' VTable offset = 32
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetValue ( _                      ' VTable offset = 36
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IEncoderAPI_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVideoEncoder
' IID = {02997C3B-8E1B-460E-9270-545E0DE9563E}
' Inherited interface = IEncoderAPI
' ########################################################################################

#IF NOT %DEF(%IVideoEncoder_INTERFACE_DEFINED)
    %IVideoEncoder_INTERFACE_DEFINED = 1

$IID_IVideoEncoder = GUID$("{02997C3B-8E1B-460E-9270-545E0DE9563E}")

INTERFACE IVideoEncoder $IID_IVideoEncoder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD IsSupported ( _                   ' VTable offset = 12
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsAvailable ( _                   ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetParameterRange ( _             ' VTable offset = 20
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *ValueMin
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *ValueMax
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *SteppingDelta
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetParameterValues ( _            ' VTable offset = 24
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT **Values
   , BYREF DWORD _                          ' /* [out] */ ULONG *ValuesCount
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDefaultValue ( _               ' VTable offset = 28
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetValue ( _                      ' VTable offset = 32
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetValue ( _                      ' VTable offset = 36
     BYREF GUID _                           ' /* [in] */ const GUID *Api
   , BYREF VARIANT _                        ' /* [out] */ VARIANT *Value
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVideoEncoder_INTERFACE_DEFINED__ */


#IF NOT %DEF(%ENCODER_API_DEFINES)
    %ENCODER_API_DEFINES = 1
' enum VIDEOENCODER_BITRATE_MODE
%ConstantBitRate        = 0
%VariableBitRateAverage = %ConstantBitRate        + 1
%VariableBitRatePeak    = %VariableBitRateAverage + 1
#ENDIF   ' // __ENCODER_API_DEFINES__

%AM_GETDECODERCAP_QUERY_VMR_SUPPORT  = &H00000001???
%VMR_NOTSUPPORTED                    = &H00000000???
%VMR_SUPPORTED                       = &H00000001???
%AM_QUERY_DECODER_VMR_SUPPORT        = &H00000001???
%AM_QUERY_DECODER_DXVA_1_SUPPORT     = &H00000002???
%AM_QUERY_DECODER_DVD_SUPPORT        = &H00000003???
%AM_QUERY_DECODER_ATSC_SD_SUPPORT    = &H00000004???
%AM_QUERY_DECODER_ATSC_HD_SUPPORT    = &H00000005???
%AM_GETDECODERCAP_QUERY_VMR9_SUPPORT = &H00000006???
%DECODER_CAP_NOTSUPPORTED            = &H00000000???
%DECODER_CAP_SUPPORTED               = &H00000001???


' ########################################################################################
' Interface name = IAMDecoderCaps
' IID = {C0DFF467-D499-4986-972B-E1D9090FA941}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMDecoderCaps_INTERFACE_DEFINED)
    %IAMDecoderCaps_INTERFACE_DEFINED = 1

$IID_IAMDecoderCaps = GUID$("{C0DFF467-D499-4986-972B-E1D9090FA941}")

INTERFACE IAMDecoderCaps $IID_IAMDecoderCaps

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetDecoderCaps ( _                ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwCapIndex
   , BYREF DWORD _                          ' /* [out] */ DWORD *lpdwCap
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMDecoderCaps_INTERFACE_DEFINED__ */

TYPE AMCOPPSignature
   Signature(255) AS BYTE
END TYPE

TYPE AMCOPPCommand
   macKDI            AS GUID
   guidCommandID     AS GUID
   dwSequence        AS DWORD
   cbSizeData        AS DWORD
   CommandData(4055) AS BYTE
END TYPE

TYPE AMCOPPStatusInput
   rApp                AS GUID
   guidStatusRequestID AS GUID
   dwSequence          AS DWORD
   cbSizeData          AS DWORD
   StatusData(4055)    AS BYTE
END TYPE

TYPE AMCOPPStatusOutput
   macKDI           AS GUID
   cbSizeData       AS DWORD
   COPPStatus(4075) AS BYTE
END TYPE

' ########################################################################################
' Interface name = IAMCertifiedOutputProtection
' IID = {6FEDED3E-0FF1-4901-A2F1-43F7012C8515}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IAMCertifiedOutputProtection_INTERFACE_DEFINED)
    %IAMCertifiedOutputProtection_INTERFACE_DEFINED = 1

$IID_IAMCertifiedOutputProtection = GUID$("{6FEDED3E-0FF1-4901-A2F1-43F7012C8515}")

INTERFACE IAMCertifiedOutputProtection $IID_IAMCertifiedOutputProtection

   INHERIT IUnknown

   ' =====================================================================================
   METHOD KeyExchange ( _                   ' VTable offset = 12
     BYREF GUID _                           ' /* [out] */ GUID *pRandom
   , BYREF DWORD _                          ' /* [out] */ BYTE **VarLenCertGH
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwLengthCertGH
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SessionSequenceStart ( _          ' VTable offset = 16
     BYREF AMCOPPSignature _                ' /* [in] */ AMCOPPSignature *pSig
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ProtectionCommand ( _             ' VTable offset = 20
     BYREF AMCOPPCommand _                  ' /* [in] */ const AMCOPPCommand *cmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ProtectionStatus ( _              ' VTable offset = 24
     BYREF AMCOPPStatusInput _              ' /* [in] */ const AMCOPPStatusInput *pStatusInput
   , BYREF AMCOPPStatusOutput _             ' /* [out] */ AMCOPPStatusOutput *pStatusOutput
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMCertifiedOutputProtection_INTERFACE_DEFINED__ */


' enum DVD_DOMAIN
%DVD_DOMAIN_FirstPlay         = 1
%DVD_DOMAIN_VideoManagerMenu  = %DVD_DOMAIN_FirstPlay         + 1
%DVD_DOMAIN_VideoTitleSetMenu = %DVD_DOMAIN_VideoManagerMenu  + 1
%DVD_DOMAIN_Title             = %DVD_DOMAIN_VideoTitleSetMenu + 1
%DVD_DOMAIN_Stop              = %DVD_DOMAIN_Title             + 1

' enum DVD_MENU_ID
%DVD_MENU_Title      = 2
%DVD_MENU_Root       = 3
%DVD_MENU_Subpicture = 4
%DVD_MENU_Audio      = 5
%DVD_MENU_Angle      = 6
%DVD_MENU_Chapter    = 7

' enum DVD_DISC_SIDE
%DVD_SIDE_A          = 1
%DVD_SIDE_B          = 2

' enum DVD_PREFERRED_DISPLAY_MODE
%DISPLAY_CONTENT_DEFAULT         = 0
%DISPLAY_16x9                    = 1
%DISPLAY_4x3_PANSCAN_PREFERRED   = 2
%DISPLAY_4x3_LETTERBOX_PREFERRED = 3

'typedef WORD DVD_REGISTER;
'typedef DVD_REGISTER GPRMARRAY[ 16 ];
'typedef DVD_REGISTER SPRMARRAY[ 24 ];

TYPE DVD_ATR
   ulCAT  AS DWORD          ' ULONG
   pbATRI AS STRING * 768   ' BYTE pbATRI[ 768 ]
END TYPE

'typedef BYTE DVD_VideoATR[ 2 ];
'typedef BYTE DVD_AudioATR[ 8 ];
'typedef BYTE DVD_SubpictureATR[ 6 ];

' enum DVD_FRAMERATE
%DVD_FPS_25        = 1
%DVD_FPS_30NonDrop = 3

TYPE DVD_TIMECODE
   Hours1        AS BIT * 4 IN DWORD  ' // Hours
   Hours10       AS BIT * 4           ' // Tens of Hours
   Minutes1      AS BIT * 4           ' // Minutes
   Minutes10     AS BIT * 4           ' // Tens of Minutes
   Seconds1      AS BIT * 4           ' // Seconds
   Seconds10     AS BIT * 4           ' // Tens of Seconds
   Frames1       AS BIT * 4           ' // Frames
   Frames10      AS BIT * 2           ' // Tens of Frames
   FrameRateCode AS BIT * 2           ' // use DVD_FRAMERATE to indicate frames/sec and drop/non-drop
END TYPE

' enum DVD_TIMECODE_FLAGS
%DVD_TC_FLAG_25fps        = &H1
%DVD_TC_FLAG_30fps        = &H2
%DVD_TC_FLAG_DropFrame    = &H4
%DVD_TC_FLAG_Interpolated = &H8

TYPE DVD_HMSF_TIMECODE
   bHours   AS BYTE
   bMinutes AS BYTE
   bSeconds AS BYTE
   bFrames  AS BYTE
END TYPE

TYPE DVD_PLAYBACK_LOCATION2
   TitleNum      AS DWORD
   ChapterNum    AS DWORD
   TimeCode      AS DVD_HMSF_TIMECODE
   TimeCodeFlags AS DWORD
END TYPE

TYPE DVD_PLAYBACK_LOCATION
   TitleNum   AS DWORD
   ChapterNum AS DWORD
   TimeCode   AS DWORD
END TYPE

'typedef DWORD VALID_UOP_SOMTHING_OR_OTHER;

' enum VALID_UOP_FLAG
%UOP_FLAG_Play_Title_Or_AtTime                   = &H1
%UOP_FLAG_Play_Chapter                           = &H2
%UOP_FLAG_Play_Title                             = &H4
%UOP_FLAG_Stop                                   = &H8
%UOP_FLAG_ReturnFromSubMenu                      = &H10
%UOP_FLAG_Play_Chapter_Or_AtTime                 = &H20
%UOP_FLAG_PlayPrev_Or_Replay_Chapter             = &H40
%UOP_FLAG_PlayNext_Chapter                       = &H80
%UOP_FLAG_Play_Forwards                          = &H100
%UOP_FLAG_Play_Backwards                         = &H200
%UOP_FLAG_ShowMenu_Title                         = &H400
%UOP_FLAG_ShowMenu_Root                          = &H800
%UOP_FLAG_ShowMenu_SubPic                        = &H1000
%UOP_FLAG_ShowMenu_Audio                         = &H2000
%UOP_FLAG_ShowMenu_Angle                         = &H4000
%UOP_FLAG_ShowMenu_Chapter                       = &H8000
%UOP_FLAG_Resume                                 = &H10000
%UOP_FLAG_Select_Or_Activate_Button              = &H20000
%UOP_FLAG_Still_Off                              = &H40000
%UOP_FLAG_Pause_On                               = &H80000
%UOP_FLAG_Select_Audio_Stream                    = &H100000
%UOP_FLAG_Select_SubPic_Stream                   = &H200000
%UOP_FLAG_Select_Angle                           = &H400000
%UOP_FLAG_Select_Karaoke_Audio_Presentation_Mode = &H800000
%UOP_FLAG_Select_Video_Mode_Preference           = &H1000000

' enum DVD_CMD_FLAGS
%DVD_CMD_FLAG_None              = 0
%DVD_CMD_FLAG_Flush             = &H1
%DVD_CMD_FLAG_SendEvents        = &H2
%DVD_CMD_FLAG_Block             = &H4
%DVD_CMD_FLAG_StartWhenRendered = &H8
%DVD_CMD_FLAG_EndAfterRendered  = &H10

' enum DVD_OPTION_FLAG
%DVD_ResetOnStop                     = 1
%DVD_NotifyParentalLevelChange       = 2
%DVD_HMSF_TimeCodeEvents             = 3
%DVD_AudioDuringFFwdRew              = 4
%DVD_EnableNonblockingAPIs           = 5
%DVD_CacheSizeInMB                   = 6
%DVD_EnablePortableBookmarks         = 7
%DVD_EnableExtendedCopyProtectErrors = 8

' enum DVD_RELATIVE_BUTTON
%DVD_Relative_Upper             = 1
%DVD_Relative_Lower             = 2
%DVD_Relative_Left              = 3
%DVD_Relative_Right             = 4

' enum DVD_PARENTAL_LEVEL
%DVD_PARENTAL_LEVEL_8           = &H8000
%DVD_PARENTAL_LEVEL_7           = &H4000
%DVD_PARENTAL_LEVEL_6           = &H2000
%DVD_PARENTAL_LEVEL_5           = &H1000
%DVD_PARENTAL_LEVEL_4           = &H800
%DVD_PARENTAL_LEVEL_3           = &H400
%DVD_PARENTAL_LEVEL_2           = &H200
%DVD_PARENTAL_LEVEL_1           = &H100

' enum DVD_AUDIO_LANG_EXT
%DVD_AUD_EXT_NotSpecified       = 0
%DVD_AUD_EXT_Captions           = 1
%DVD_AUD_EXT_VisuallyImpaired   = 2
%DVD_AUD_EXT_DirectorComments1  = 3
%DVD_AUD_EXT_DirectorComments2  = 4

' enum DVD_SUBPICTURE_LANG_EXT
%DVD_SP_EXT_NotSpecified              = 0
%DVD_SP_EXT_Caption_Normal            = 1
%DVD_SP_EXT_Caption_Big               = 2
%DVD_SP_EXT_Caption_Children          = 3
%DVD_SP_EXT_CC_Normal                 = 5
%DVD_SP_EXT_CC_Big                    = 6
%DVD_SP_EXT_CC_Children               = 7
%DVD_SP_EXT_Forced                    = 9
%DVD_SP_EXT_DirectorComments_Normal   = 13
%DVD_SP_EXT_DirectorComments_Big      = 14
%DVD_SP_EXT_DirectorComments_Children = 15

' enum DVD_AUDIO_APPMODE
%DVD_AudioMode_None     = 0
%DVD_AudioMode_Karaoke  = 1
%DVD_AudioMode_Surround = 2
%DVD_AudioMode_Other    = 3

' enum DVD_AUDIO_FORMAT
%DVD_AudioFormat_AC3       = 0
%DVD_AudioFormat_MPEG1     = 1
%DVD_AudioFormat_MPEG1_DRC = 2
%DVD_AudioFormat_MPEG2     = 3
%DVD_AudioFormat_MPEG2_DRC = 4
%DVD_AudioFormat_LPCM      = 5
%DVD_AudioFormat_DTS       = 6
%DVD_AudioFormat_SDDS      = 7
%DVD_AudioFormat_Other     = 8

' enum DVD_KARAOKE_DOWNMIX
%DVD_Mix_0to0 = &H1
%DVD_Mix_1to0 = &H2
%DVD_Mix_2to0 = &H4
%DVD_Mix_3to0 = &H8
%DVD_Mix_4to0 = &H10
%DVD_Mix_Lto0 = &H20
%DVD_Mix_Rto0 = &H40
%DVD_Mix_0to1 = &H100
%DVD_Mix_1to1 = &H200
%DVD_Mix_2to1 = &H400
%DVD_Mix_3to1 = &H800
%DVD_Mix_4to1 = &H1000
%DVD_Mix_Lto1 = &H2000
%DVD_Mix_Rto1 = &H4000

TYPE DVD_AudioAttributes
   AppMode              AS LONG    ' DVD_AUDIO_APPMODE
   AppModeData          AS BYTE    ' BYTE
   AudioFormat          AS LONG    ' DVD_AUDIO_FORMAT
   Language             AS DWORD   ' LCID
   LanguageExtension    AS LONG    ' DVD_AUDIO_LANG_EXT
   fHasMultichannelInfo AS LONG    ' BOOL
   dwFrequency          AS DWORD   ' DWORD
   bQuantization        AS BYTE    ' BYTE
   bNumberOfChannels    AS BYTE    ' BYTE
   dwReserved(1)        AS DWORD   ' DWORD dwReserved[ 2 ]
END TYPE

TYPE DVD_MUA_MixingInfo
   fMixTo0              AS LONG    ' BOOL
   fMixTo1              AS LONG    ' BOOL
   fMix0InPhase         AS LONG    ' BOOL
   fMix1InPhase         AS LONG    ' BOOL
   dwSpeakerPosition    AS DWORD   ' DWORD
END TYPE

TYPE DVD_MUA_Coeff
   log2_alpha AS DOUBLE
   log2_beta  AS DOUBLE
END TYPE

TYPE DVD_MultichannelAudioAttributes
   Info(7)  AS DVD_MUA_MixingInfo
   Coeff(7) AS DVD_MUA_Coeff
END TYPE

' enum DVD_KARAOKE_CONTENTS
%DVD_Karaoke_GuideVocal1  = &H1
%DVD_Karaoke_GuideVocal2  = &H2
%DVD_Karaoke_GuideMelody1 = &H4
%DVD_Karaoke_GuideMelody2 = &H8
%DVD_Karaoke_GuideMelodyA = &H10
%DVD_Karaoke_GuideMelodyB = &H20
%DVD_Karaoke_SoundEffectA = &H40
%DVD_Karaoke_SoundEffectB = &H80

' enum DVD_KARAOKE_ASSIGNMENT
%DVD_Assignment_reserved0 = 0
%DVD_Assignment_reserved1 = 1
%DVD_Assignment_LR        = 2
%DVD_Assignment_LRM       = 3
%DVD_Assignment_LR1       = 4
%DVD_Assignment_LRM1      = 5
%DVD_Assignment_LR12      = 6
%DVD_Assignment_LRM12     = 7

TYPE DVD_KaraokeAttributes
   bVersion                         AS BYTE
   fMasterOfCeremoniesInGuideVocal1 AS LONG
   fDuet                            AS LONG
   ChannelAssignment                AS LONG
   wChannelContents(7)              AS WORD
END TYPE

' enum DVD_VIDEO_COMPRESSION
%DVD_VideoCompression_Other   = 0
%DVD_VideoCompression_MPEG1   = 1
%DVD_VideoCompression_MPEG2   = 2

TYPE DVD_VideoAttributes
   fPanscanPermitted    AS LONG
   fLetterboxPermitted  AS LONG
   ulAspectX            AS DWORD
   ulAspectY            AS DWORD
   ulFrameRate          AS DWORD
   ulFrameHeight        AS DWORD
   Compression          AS LONG
   fLine21Field1InGOP   AS LONG
   fLine21Field2InGOP   AS LONG
   ulSourceResolutionX  AS DWORD
   ulSourceResolutionY  AS DWORD
   fIsSourceLetterboxed AS LONG
   fIsFilmMode          AS LONG
END TYPE

' enum DVD_SUBPICTURE_TYPE
%DVD_SPType_NotSpecified = 0
%DVD_SPType_Language     = 1
%DVD_SPType_Other        = 2

' enum DVD_SUBPICTURE_CODING
%DVD_SPCoding_RunLength = 0
%DVD_SPCoding_Extended  = 1
%DVD_SPCoding_Other     = 2

TYPE DVD_SubpictureAttributes
   Type              AS LONG    ' DVD_SUBPICTURE_TYPE
   CodingMode        AS LONG    ' DVD_SUBPICTURE_CODING
   Language          AS DWORD   ' LCID
   LanguageExtension AS LONG    ' DVD_SUBPICTURE_LANG_EXT
END TYPE

' enum DVD_TITLE_APPMODE
%DVD_AppMode_Not_Specified = 0
%DVD_AppMode_Karaoke       = 1
%VD_AppMode_Other          = 3

TYPE DVD_TitleAttributes
   AppMode                        AS LONG
   VideoAttributes                AS DVD_VideoAttributes
   ulNumberOfAudioStreams         AS DWORD
   AudioAttributes(7)             AS DVD_AudioAttributes
   MultichannelAudioAttributes(7) AS DVD_MultichannelAudioAttributes
   ulNumberOfSubpictureStreams    AS DWORD
   SubpictureAttributes(31)       AS DVD_SubpictureAttributes
END TYPE

TYPE DVD_MenuAttributes
   fCompatibleRegion(7) AS LONG
   VideoAttributes      AS DVD_VideoAttributes
   fAudioPresent        AS LONG
   AudioAttributes      AS DVD_AudioAttributes
   fSubpicturePresent   AS LONG
   SubpictureAttributes AS DVD_SubpictureAttributes
END TYPE


' ########################################################################################
' Interface name = IDvdControl
' IID = {A70EFE61-E2A3-11D0-A9BE-00AA0061BE93}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDvdControl_INTERFACE_DEFINED)
    %IDvdControl_INTERFACE_DEFINED = 1

$IID_IDvdControl = GUID$("{A70EFE61-E2A3-11D0-A9BE-00AA0061BE93}")

INTERFACE IDvdControl $IID_IDvdControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD TitlePlay ( _                     ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ChapterPlay ( _                   ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulChapter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD TimePlay ( _                      ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYVAL DWORD _                          ' /* [in] */ ULONG bcdTime
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD StopForResume ( _                 ' VTable offset = 24
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GoUp ( _                          ' VTable offset = 28
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD TimeSearch ( _                    ' VTable offset = 32
     BYVAL DWORD _                          ' /* [in] */ ULONG bcdTime
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ChapterSearch ( _                 ' VTable offset = 36
     BYVAL DWORD _                          ' /* [in] */ ULONG ulChapter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PrevPGSearch ( _                  ' VTable offset = 40
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD TopPGSearch ( _                   ' VTable offset = 44
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD NextPGSearch ( _                  ' VTable offset = 48
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ForwardScan ( _                   ' VTable offset = 52
     BYVAL DOUBLE _                         ' /* [in] */ double dwSpeed
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD BackwardScan ( _                  ' VTable offset = 56
     BYVAL DOUBLE _                         ' /* [in] */ double dwSpeed
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD MenuCall ( _                      ' VTable offset = 60
     BYVAL LONG _                           ' /* [in] */ DVD_MENU_ID MenuID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Resume ( _                        ' VTable offset = 64
     BYVAL LONG _                           ' /* [in] */ DVD_MENU_ID MenuID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UpperButtonSelect ( _             ' VTable offset = 68
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD LowerButtonSelect ( _             ' VTable offset = 72
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD LeftButtonSelect ( _              ' VTable offset = 76
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RightButtonSelect ( _             ' VTable offset = 80
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ButtonActivate ( _                ' VTable offset = 84
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ButtonSelectAndActivate ( _       ' VTable offset = 88
     BYVAL DWORD _                          ' /* [in] */ ULONG ulButton
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD StillOff ( _                      ' VTable offset = 92
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PauseOn ( _                       ' VTable offset = 96
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PauseOff ( _                      ' VTable offset = 100
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD MenuLanguageSelect ( _            ' VTable offset = 104
     BYVAL DWORD _                          ' /* [in] */ LCID Language
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AudioStreamChange ( _             ' VTable offset = 108
     BYVAL DWORD _                          ' /* [in] */ ULONG ulAudio
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SubpictureStreamChange ( _        ' VTable offset = 112
     BYVAL DWORD _                          ' /* [in] */ ULONG ulSubPicture
   , BYVAL LONG _                           ' /* [in] */ BOOL bDisplay
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AngleChange ( _                   ' VTable offset = 116
     BYVAL DWORD _                          ' /* [in] */ ULONG ulAngle
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ParentalLevelSelect ( _           ' VTable offset = 120
     BYVAL DWORD _                          ' /* [in] */ ULONG ulParentalLevel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ParentalCountrySelect ( _         ' VTable offset = 124
     BYVAL WORD _                           ' /* [in] */ WORD wCountry
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD KaraokeAudioPresentationModeChange ( _        ' VTable offset = 128
     BYVAL DWORD _                          ' /* [in] */ ULONG ulMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD VideoModePreferrence ( _          ' VTable offset = 132
     BYVAL DWORD _                          ' /* [in] */ ULONG ulPreferredDisplayMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetRoot ( _                       ' VTable offset = 136
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR pszPath
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD MouseActivate ( _                 ' VTable offset = 140
     BYREF POINTAPI _                       ' /* [in] */ POINT point
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD MouseSelect ( _                   ' VTable offset = 144
     BYREF POINTAPI _                       ' /* [in] */ POINT point
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ChapterPlayAutoStop ( _           ' VTable offset = 148
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulChapter
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulChaptersToPlay
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDvdControl_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDvdInfo
' IID = {A70EFE60-E2A3-11D0-A9BE-00AA0061BE93}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDvdInfo_INTERFACE_DEFINED)
    %IDvdInfo_INTERFACE_DEFINED = 1

$IID_IDvdInfo = GUID$("{A70EFE60-E2A3-11D0-A9BE-00AA0061BE93}")

INTERFACE IDvdInfo $IID_IDvdInfo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCurrentDomain ( _              ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ DVD_DOMAIN *pDomain
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentLocation ( _            ' VTable offset = 16
     BYREF DVD_PLAYBACK_LOCATION _          ' /* [out] */ DVD_PLAYBACK_LOCATION *pLocation
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTotalTitleTime ( _             ' VTable offset = 20
     BYREF DWORD _                          ' /* [out] */ ULONG *pulTotalTime
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentButton ( _              ' VTable offset = 24
     BYREF DWORD _                          ' /* [out] */ ULONG *pulButtonsAvailable
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCurrentButton
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentAngle ( _               ' VTable offset = 28
     BYREF DWORD _                          ' /* [out] */ ULONG *pulAnglesAvailable
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCurrentAngle
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentAudio ( _               ' VTable offset = 32
     BYREF DWORD _                          ' /* [out] */ ULONG *pulStreamsAvailable
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCurrentStream
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentSubpicture ( _          ' VTable offset = 36
     BYREF DWORD _                          ' /* [out] */ ULONG *pulStreamsAvailable
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCurrentStream
   , BYREF LONG _                           ' /* [out] */ BOOL *pIsDisabled
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentUOPS ( _                ' VTable offset = 40
     BYREF DWORD _                          ' /* [out] */ VALID_UOP_SOMTHING_OR_OTHER *pUOP
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAllSPRMs ( _                   ' VTable offset = 44
     BYREF DWORD _                          ' /* [out] */ SPRMARRAY *pRegisterArray [Array of 24 words]
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAllGPRMs ( _                   ' VTable offset = 48
     BYREF DWORD _                          ' /* [out] */ GPRMARRAY *pRegisterArray [Array of 16 words]
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAudioLanguage ( _              ' VTable offset = 52
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStream
   , BYREF DWORD _                          ' /* [out] */ LCID *pLanguage
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetSubpictureLanguage ( _         ' VTable offset = 56
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStream
   , BYREF DWORD _                          ' /* [out] */ LCID *pLanguage
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTitleAttributes ( _            ' VTable offset = 60
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYREF DVD_ATR _                        ' /* [out] */ DVD_ATR *pATR
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetVMGAttributes ( _              ' VTable offset = 64
     BYREF DVD_ATR _                        ' /* [out] */ DVD_ATR *pATR
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentVideoAttributes ( _     ' VTable offset = 68
     BYREF DVD_VideoAttributes _            ' /* [out] */ DVD_VideoAttributes *pATR
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentAudioAttributes ( _     ' VTable offset = 72
     BYREF BYTE _                           ' /* [out] */ DVD_AudioATR *pATR [Array of 8 bytes]
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentSubpictureAttributes ( _' VTable offset = 76
     BYREF BYTE _                           ' /* [out] */ DVD_SubpictureATR *pATR [Array of 6 bytes]
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentVolumeInfo ( _          ' VTable offset = 80
     BYREF DWORD _                          ' /* [out] */ ULONG *pulNumOfVol
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulThisVolNum
   , BYREF LONG _                           ' /* [out] */ DVD_DISC_SIDE *pSide
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulNumOfTitles
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDVDTextInfo ( _                ' VTable offset = 84
     BYVAL BYTE PTR _                       ' /* [out] */ BYTE *pTextManager
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulBufSize
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulActualSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetPlayerParentalLevel ( _        ' VTable offset = 88
     BYREF DWORD _                          ' /* [out] */ ULONG *pulParentalLevel
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCountryCode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetNumberOfChapters ( _           ' VTable offset = 92
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulNumberOfChapters
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTitleParentalLevels ( _        ' VTable offset = 96
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulParentalLevels
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetRoot ( _                       ' VTable offset = 100
     BYREF ASCIIZ _                         ' /* [out] */ LPSTR pRoot
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulBufSize
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulActualSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDvdInfo_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDvdCmd
' IID = {5A4A97E4-94EE-4A55-9751-74B5643AA27D}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDvdCmd_INTERFACE_DEFINED)
    %IDvdCmd_INTERFACE_DEFINED = 1

$IID_IDvdCmd = GUID$("{5A4A97E4-94EE-4A55-9751-74B5643AA27D}")

INTERFACE IDvdCmd $IID_IDvdCmd

   INHERIT IUnknown

   ' =====================================================================================
   METHOD WaitForStart ( _                  ' VTable offset = 12
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD WaitForEnd ( _                    ' VTable offset = 16
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDvdCmd_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDvdState
' IID = {86303D6D-1C4A-4087-AB42-F711167048EF}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDvdState_INTERFACE_DEFINED)
    %IDvdState_INTERFACE_DEFINED = 1

$IID_IDvdState = GUID$("{86303D6D-1C4A-4087-AB42-F711167048EF}")

INTERFACE IDvdState $IID_IDvdState

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetDiscID ( _                     ' VTable offset = 12
     BYREF QUAD _                           ' /* [out] */ ULONGLONG *pullUniqueID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetParentalLevel ( _              ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ ULONG *pulParentalLevel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDvdState_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDvdControl2
' IID = {33BC7430-EEC0-11D2-8201-00A0C9D74842}
' Inherited interface = IDvdControl
' ########################################################################################

#IF NOT %DEF(%IDvdControl2_INTERFACE_DEFINED)
    %IDvdControl2_INTERFACE_DEFINED = 1

$IID_IDvdControl2 = GUID$("{33BC7430-EEC0-11D2-8201-00A0C9D74842}")

INTERFACE IDvdControl2 $IID_IDvdControl2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD PlayTitle ( _                     ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayChapterInTitle ( _            ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulChapter
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayAtTimeInTitle ( _             ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYREF DVD_HMSF_TIMECODE _              ' /* [in] */ DVD_HMSF_TIMECODE *pStartTime
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Stop ( _                          ' VTable offset = 24
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReturnFromSubmenu ( _             ' VTable offset = 28
     BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayAtTime ( _                    ' VTable offset = 32
     BYREF DVD_HMSF_TIMECODE _              ' /* [in] */ DVD_HMSF_TIMECODE *pTime
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayChapter ( _                   ' VTable offset = 36
     BYVAL DWORD _                          ' /* [in] */ ULONG ulChapter
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayPrevChapter ( _               ' VTable offset = 40
     BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ReplayChapter ( _                 ' VTable offset = 44
     BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayNextChapter ( _               ' VTable offset = 48
     BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayForwards ( _                  ' VTable offset = 52
     BYVAL DOUBLE _                         ' /* [in] */ double dSpeed
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayBackwards ( _                 ' VTable offset = 56
     BYVAL DOUBLE _                         ' /* [in] */ double dSpeed
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ShowMenu ( _                      ' VTable offset = 60
     BYVAL LONG _                           ' /* [in] */ DVD_MENU_ID MenuID
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Resume ( _                        ' VTable offset = 64
     BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectRelativeButton ( _          ' VTable offset = 68
     BYVAL LONG _                           ' DVD_RELATIVE_BUTTON buttonDir
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ActivateButton ( _                ' VTable offset = 72
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectButton ( _                  ' VTable offset = 76
     BYVAL DWORD _                          ' /* [in] */ ULONG ulButton
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectAndActivateButton ( _       ' VTable offset = 80
     BYVAL DWORD _                          ' /* [in] */ ULONG ulButton
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD StillOff ( _                      ' VTable offset = 84
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Pause ( _                         ' VTable offset = 88
     BYVAL LONG _                           ' /* [in] */ BOOL bState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectAudioStream ( _             ' VTable offset = 92
     BYVAL DWORD _                          ' /* [in] */ ULONG ulAudio
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectSubpictureStream ( _        ' VTable offset = 96
     BYVAL DWORD _                          ' /* [in] */ ULONG ulSubPicture
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetSubpictureState ( _            ' VTable offset = 100
     BYVAL LONG _                           ' /* [in] */ BOOL bState
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectAngle ( _                   ' VTable offset = 104
     BYVAL DWORD _                          ' /* [in] */ ULONG ulAngle
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectParentalLevel ( _           ' VTable offset = 108
     BYVAL DWORD _                          ' /* [in] */ ULONG ulParentalLevel
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectParentalCountry ( _         ' VTable offset = 112
     BYREF BYTE _                           ' /* [in] */ BYTE bCountry[ 2 ]
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectKaraokeAudioPresentationMode ( _        ' VTable offset = 116
     BYVAL DWORD _                          ' /* [in] */ ULONG ulMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectVideoModePreference ( _     ' VTable offset = 120
     BYVAL DWORD _                          ' /* [in] */ ULONG ulPreferredDisplayMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDVDDirectory ( _               ' VTable offset = 124
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR pszwPath
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ActivateAtPosition ( _            ' VTable offset = 128
     BYVAL POINTAPI _                       ' /* [in] */ POINT point
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectAtPosition ( _              ' VTable offset = 132
     BYVAL POINTAPI _                       ' /* [in] */ POINT point
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayChaptersAutoStop ( _          ' VTable offset = 136
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulChapter
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulChaptersToPlay
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AcceptParentalLevelChange ( _     ' VTable offset = 140
     BYVAL LONG _                           ' /* [in] */ BOOL bAccept
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetOption ( _                     ' VTable offset = 144
     BYVAL LONG _                           ' /* [in] */ DVD_OPTION_FLAG flag
   , BYVAL LONG _                           ' /* [in] */ BOOL fState
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetState ( _                      ' VTable offset = 148
     BYVAL DWORD _                          ' /* [in] */ IDvdState *pState
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PlayPeriodInTitleAutoStop ( _     ' VTable offset = 152
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYVAL DVD_HMSF_TIMECODE _              ' /* [in] */ DVD_HMSF_TIMECODE *pStartTime
   , BYVAL DVD_HMSF_TIMECODE _              ' /* [in] */ DVD_HMSF_TIMECODE *pEndTime
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetGPRM ( _                       ' VTable offset = 156
     BYVAL DWORD _                          ' /* [in] */ ULONG ulIndex
   , BYVAL WORD _                           ' /* [in] */ WORD wValue
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **ppCmd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectDefaultMenuLanguage ( _     ' VTable offset = 160
     BYVAL DWORD _                          ' /* [in] */ LCID Language)
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectDefaultAudioLanguage ( _    ' VTable offset = 164
     BYVAL DWORD _                          ' /* [in] */ LCID Language)
   , BYVAL LONG _                           ' /* [in] */ DVD_AUDIO_LANG_EXT audioExtension
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SelectDefaultSubpictureLanguage ( _  ' VTable offset = 168
     BYVAL DWORD _                          ' /* [in] */ LCID Language)
   , BYVAL LONG _                           ' /* [in] */ DVD_SUBPICTURE_LANG_EXT subpictureExtension
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDvdControl2_INTERFACE_DEFINED__ */


' enum DVD_TextStringType
%DVD_Struct_Volume      = &H1
%DVD_Struct_Title       = &H2
%DVD_Struct_ParentalID  = &H3
%DVD_Struct_PartOfTitle = &H4
%DVD_Struct_Cell        = &H5
%DVD_Stream_Audio       = &H10
%DVD_Stream_Subpicture  = &H11
%DVD_Stream_Angle       = &H12
%DVD_Channel_Audio      = &H20
%DVD_General_Name       = &H30
%DVD_General_Comments   = &H31
%DVD_Title_Series       = &H38
%DVD_Title_Movie        = &H39
%DVD_Title_Video        = &H3a
%DVD_Title_Album        = &H3b
%DVD_Title_Song         = &H3c
%DVD_Title_Other        = &H3f
%DVD_Title_Sub_Series   = &H40
%DVD_Title_Sub_Movie    = &H41
%DVD_Title_Sub_Video    = &H42
%DVD_Title_Sub_Album    = &H43
%DVD_Title_Sub_Song     = &H44
%DVD_Title_Sub_Other    = &H47
%DVD_Title_Orig_Series  = &H48
%DVD_Title_Orig_Movie   = &H49
%DVD_Title_Orig_Video   = &H4a
%DVD_Title_Orig_Album   = &H4b
%DVD_Title_Orig_Song    = &H4c
%DVD_Title_Orig_Other   = &H4f
%DVD_Other_Scene        = &H50
%DVD_Other_Cut          = &H51
%DVD_Other_Take         = &H52

' enum DVD_TextCharSet
%DVD_CharSet_Unicode                       = 0
%DVD_CharSet_ISO646                        = 1
%DVD_CharSet_JIS_Roman_Kanji               = 2
%DVD_CharSet_ISO8859_1                     = 3
%DVD_CharSet_ShiftJIS_Kanji_Roman_Katakana = 4

%DVD_TITLE_MENU           = &H000
%DVD_STREAM_DATA_CURRENT  = &H800
%DVD_STREAM_DATA_VMGM     = &H400
%DVD_STREAM_DATA_VTSM     = &H401
%DVD_DEFAULT_AUDIO_STREAM = &H0f

TYPE DVD_DECODER_CAPS
   dwSize           AS DWORD
   dwAudioCaps      AS DWORD
   dFwdMaxRateVideo AS DOUBLE
   dFwdMaxRateAudio AS DOUBLE
   dFwdMaxRateSP    AS DOUBLE
   dBwdMaxRateVideo AS DOUBLE
   dBwdMaxRateAudio AS DOUBLE
   dBwdMaxRateSP    AS DOUBLE
   dwRes1           AS DWORD
   dwRes2           AS DWORD
   dwRes3           AS DWORD
   dwRes4           AS DWORD
END TYPE

%DVD_AUDIO_CAPS_AC3   = &H00000001???
%DVD_AUDIO_CAPS_MPEG2 = &H00000002???
%DVD_AUDIO_CAPS_LPCM  = &H00000004???
%DVD_AUDIO_CAPS_DTS   = &H00000008???
%DVD_AUDIO_CAPS_SDDS  = &H00000010???


' ########################################################################################
' Interface name = IDvdInfo2
' IID = {34151510-EEC0-11D2-8201-00A0C9D74842}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDvdInfo2_INTERFACE_DEFINED)
    %IDvdInfo2_INTERFACE_DEFINED = 1

$IID_IDvdInfo2 = GUID$("{34151510-EEC0-11D2-8201-00A0C9D74842}")

INTERFACE IDvdInfo2 $IID_IDvdInfo2

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetCurrentDomain ( _              ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ DVD_DOMAIN *pDomain
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentLocation ( _            ' VTable offset = 16
     BYREF DVD_PLAYBACK_LOCATION2 _         ' /* [out] */ DVD_PLAYBACK_LOCATION2 *pLocation
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTotalTitleTime ( _             ' VTable offset = 20
     BYREF DWORD _                          ' /* [out] */ ULONG *pulTotalTime
   , BYREF DWORD _                          ' /* [out] */ ULONG *ulTimeCodeFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentButton ( _              ' VTable offset = 24
     BYREF DWORD _                          ' /* [out] */ ULONG *pulButtonsAvailable
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCurrentButton
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentAngle ( _               ' VTable offset = 28
     BYREF DWORD _                          ' /* [out] */ ULONG *pulAnglesAvailable
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCurrentAngle
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentAudio ( _               ' VTable offset = 32
     BYREF DWORD _                          ' /* [out] */ ULONG *pulStreamsAvailable
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCurrentStream
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentSubpicture ( _          ' VTable offset = 36
     BYREF DWORD _                          ' /* [out] */ ULONG *pulStreamsAvailable
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulCurrentStream
   , BYREF LONG _                           ' /* [out] */ BOOL *pIsDisabled
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentUOPS ( _                ' VTable offset = 40
     BYREF DWORD _                          ' /* [out] */ VALID_UOP_SOMTHING_OR_OTHER *pUOP
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAllSPRMs ( _                   ' VTable offset = 44
     BYREF DWORD _                          ' /* [out] */ SPRMARRAY *pRegisterArray [Array of 24 words]
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAllGPRMs ( _                   ' VTable offset = 48
     BYREF DWORD _                          ' /* [out] */ GPRMARRAY *pRegisterArray [Array of 16 words]
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAudioLanguage ( _              ' VTable offset = 52
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStream
   , BYREF DWORD _                          ' /* [out] */ LCID *pLanguage
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetSubpictureLanguage ( _         ' VTable offset = 56
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStream
   , BYREF DWORD _                          ' /* [out] */ LCID *pLanguage
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTitleAttributes ( _            ' VTable offset = 60
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYREF DVD_MenuAttributes _             ' /* [out] */ DVD_MenuAttributes *pMenu
   , BYREF DVD_TitleAttributes _            ' /* [out] */ DVD_TitleAttributes *pTitle
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetVMGAttributes ( _              ' VTable offset = 64
     BYREF DVD_MenuAttributes _             ' /* [out] */ DVD_MenuAttributes *pATR
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentVideoAttributes ( _     ' VTable offset = 68
     BYREF DVD_VideoAttributes _            ' /* [out] */ DVD_VideoAttributes *pATR
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAudioAttributes ( _            ' VTable offset = 72
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStream
   , BYREF DVD_AudioAttributes _            ' /* [out] */ DVD_AudioAttributes *pATR
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetKaraokeAttributes ( _          ' VTable offset = 76
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStream
   , BYREF DVD_KaraokeAttributes _          ' /* [out] */ DVD_KaraokeAttributes *pAttributes
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetSubpictureAttributes ( _       ' VTable offset = 80
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStream
   , BYREF DVD_SubpictureAttributes _       ' /* [out] */ DVD_SubpictureAttributes *pATR
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDVDVolumeInfo ( _              ' VTable offset = 84
     BYREF DWORD _                          ' /* [out] */ ULONG *pulNumOfVolumes
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulVolume
   , BYREF LONG _                           ' /* [out] */ DVD_DISC_SIDE *pSide
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulNumOfTitles
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDVDTextNumberOfLanguages ( _   ' VTable offset = 88
     BYREF DWORD _                          ' /* [out] */ ULONG *pulNumOfLangs
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDVDTextLanguageInfo ( _        ' VTable offset = 92
     BYVAL DWORD _                          ' /* [in] */ ULONG ulLangIndex
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulNumOfStrings
   , BYREF DWORD _                          ' /* [out] */ LCID *pLangCode
   , BYREF LONG _                           ' /* [out] */ enum DVD_TextCharSet *pbCharacterSet
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDVDTextStringAsNative ( _      ' VTable offset = 96
     BYVAL DWORD _                          ' /* [in] */ ULONG ulLangIndex
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulStringIndex
   , BYVAL BYTE PTR _                       ' /* [out] */ BYTE *pbBuffer
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulMaxBufferSize
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulActualSize
   , BYREF LONG _                           ' /* [out] */ enum DVD_TextStringType *pType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDVDTextStringAsUnicode ( _     ' VTable offset = 100
     BYVAL DWORD _                          ' /* [in] */ ULONG ulLangIndex
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulStringIndex
   , BYREF DWORD _                          ' /* [out] */ WCHAR *pchwBuffer
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulMaxBufferSize
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulActualSize
   , BYREF LONG _                           ' /* [out] */ enum DVD_TextStringType *pType
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetPlayerParentalLevel ( _        ' VTable offset = 104
     BYREF DWORD _                          ' /* [out] */ ULONG *pulParentalLevel
   , BYREF BYTE _                           ' /* [out] */ BYTE pbCountryCode[ 2 ]
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetNumberOfChapters ( _           ' VTable offset = 108
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulNumOfChapters
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetTitleParentalLevels ( _        ' VTable offset = 112
     BYVAL DWORD _                          ' /* [in] */ ULONG ulTitle
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulParentalLevels
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDVDDirectory ( _               ' VTable offset = 116
     BYREF DWORD _                          ' /* [out] */ LPWSTR pszwPath
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulMaxSize
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulActualSize
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsAudioStreamEnabled ( _          ' VTable offset = 120
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStreamNum
   , BYREF LONG _                           ' /* [out] */ BOOL *pbEnabled
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDiscID ( _                     ' VTable offset = 124
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR pszwPath
   , BYREF QUAD _                           ' /* [out] */ ULONGLONG *pullDiscID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetState ( _                      ' VTable offset = 128
     BYREF IUnknown _                       ' /* [out] */ IDvdState **pStateData
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMenuLanguages ( _              ' VTable offset = 132
     BYREF DWORD _                          ' /* [out] */ LCID *pLanguages
   , BYVAL DWORD _                          ' /* [in] */ ULONG ulMaxLanguages
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulActualLanguages
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetButtonAtPosition ( _           ' VTable offset = 136
     BYREF POINTAPI _                       ' /* [in] */ POINT point
   , BYREF DWORD _                          ' /* [out] */ ULONG *pulButtonIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCmdFromEvent ( _               ' VTable offset = 140
     BYVAL LONG _                           ' /* [in] */ LONG_PTR lParam1
   , BYREF IUnknown _                       ' /* [out] */ IDvdCmd **pCmdObj
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDefaultMenuLanguage ( _        ' VTable offset = 144
     BYREF DWORD _                          ' /* [out] */ LCID *pLanguage
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDefaultAudioLanguage ( _       ' VTable offset = 148
     BYREF DWORD _                          ' /* [out] */ LCID *pLanguage
   , BYREF LONG _                           ' /* [out] */ DVD_AUDIO_LANG_EXT *pAudioExtension
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDefaultSubpictureLanguage ( _  ' VTable offset = 152
     BYREF DWORD _                          ' /* [out] */ LCID *pLanguage
   , BYREF LONG _                           ' /* [out] */ DVD_SUBPICTURE_LANG_EXT *pSubpictureExtension
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDecoderCaps ( _                ' VTable offset = 156
     BYREF DVD_DECODER_CAPS _               ' /* [out] */ DVD_DECODER_CAPS *pCaps
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetButtonRect ( _                 ' VTable offset = 160
     BYVAL DWORD _                          ' /* [in] */ ULONG ulButton
   , BYREF RECT _                           ' /* [out] */ RECT *pRect
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsSubpictureStreamEnabled ( _     ' VTable offset = 164
     BYVAL DWORD _                          ' /* [in] */ ULONG ulStreamNum
   , BYREF LONG _                           ' /* [out] */ BOOL *pbEnabled
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDvdInfo2_INTERFACE_DEFINED__ */


' enum AM_DVD_GRAPH_FLAGS
%AM_DVD_HWDEC_PREFER = &H1???
%AM_DVD_HWDEC_ONLY   = &H2???
%AM_DVD_SWDEC_PREFER = &H4???
%AM_DVD_SWDEC_ONLY   = &H8???
%AM_DVD_NOVPE        = &H100???
%AM_DVD_DO_NOT_CLEAR = &H200???
%AM_DVD_VMR9_ONLY    = &H800???
%AM_DVD_EVR_ONLY     = &H1000???

' enum AM_DVD_STREAM_FLAGS
%AM_DVD_STREAM_VIDEO  = &H1???
%AM_DVD_STREAM_AUDIO  = &H2???
%AM_DVD_STREAM_SUBPIC = &H4???

TYPE AM_DVD_RENDERSTATUS
   hrVPEStatus         AS LONG
   bDvdVolInvalid      AS LONG
   bDvdVolUnknown      AS LONG
   bNoLine21In         AS LONG
   bNoLine21Out        AS LONG
   iNumStreams         AS LONG
   iNumStreamsFailed   AS LONG
   dwFailedStreamsFlag AS DWORD
END TYPE


' ########################################################################################
' Interface name = IDvdGraphBuilder
' IID = {FCC152B6-F372-11D0-8E00-00C04FD7C08B}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDvdGraphBuilder_INTERFACE_DEFINED)
    %IDvdGraphBuilder_INTERFACE_DEFINED = 1

$IID_IDvdGraphBuilder = GUID$("{FCC152B6-F372-11D0-8E00-00C04FD7C08B}")

INTERFACE IDvdGraphBuilder $IID_IDvdGraphBuilder

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetFiltergraph ( _                ' VTable offset = 12
     BYREF IUnknown _                       ' /* [out] */ IGraphBuilder **ppGB
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDvdInterface ( _               ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ REFIID riid
   , BYREF IUnknown _                       ' /* [out] */ void **ppvIF
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RenderDvdVideoVolume ( _          ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ LPCWSTR lpcwszPathName
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYREF AM_DVD_RENDERSTATUS _            ' /* [out] */ AM_DVD_RENDERSTATUS *pStatus
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDvdGraphBuilder_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IDDrawExclModeVideo
' IID = {153ACC21-D83B-11D1-82BF-00A0C9696C8F}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDDrawExclModeVideo_INTERFACE_DEFINED)
    %IDDrawExclModeVideo_INTERFACE_DEFINED = 1

$IID_IDDrawExclModeVideo = GUID$("{153ACC21-D83B-11D1-82BF-00A0C9696C8F}")

INTERFACE IDDrawExclModeVideo $IID_IDDrawExclModeVideo

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetDDrawObject ( _                ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IDirectDraw *pDDrawObject
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDDrawObject ( _                ' VTable offset = 16
     BYREF IUnknown _                       ' /* [out] */ IDirectDraw **ppDDrawObject
   , BYREF LONG _                           ' /* [out] */ BOOL *pbUsingExternal
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDDrawSurface ( _               ' VTable offset = 20
     BYVAL IUnknown _                       ' /* [in] */ IDirectDrawSurface *pDDrawSurface
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDDrawSurface ( _               ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IDirectDrawSurface **ppDDrawSurface
   , BYREF LONG _                           ' /* [out] */ BOOL *pbUsingExternal
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDrawParameters ( _             ' VTable offset = 28
     BYREF RECT _                           ' /* [in] */ const RECT *prcSource
   , BYREF RECT _                           ' /* [in] */ const RECT *prcTarget
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetNativeVideoProps ( _           ' VTable offset = 32
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwVideoWidth
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwVideoHeight
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwPictAspectRatioX
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwPictAspectRatioY
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetCallbackInterface ( _          ' VTable offset = 36
     BYVAL IUnknown _                       ' /* [in] */ IDDrawExclModeVideoCallback *pCallback
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDDrawExclModeVideo_INTERFACE_DEFINED__ */


' AM_OVERLAY_NOTIFY_FLAGS
%AM_OVERLAY_NOTIFY_VISIBLE_CHANGE = &H1???
%AM_OVERLAY_NOTIFY_SOURCE_CHANGE  = &H2???
%AM_OVERLAY_NOTIFY_DEST_CHANGE    = &H4???


' ########################################################################################
' Interface name = IDDrawExclModeVideoCallback
' IID = {913C24A0-20AB-11D2-9038-00A0C9697298}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDDrawExclModeVideoCallback_INTERFACE_DEFINED)
    %IDDrawExclModeVideoCallback_INTERFACE_DEFINED = 1

$IID_IDDrawExclModeVideoCallback = GUID$("{913C24A0-20AB-11D2-9038-00A0C9697298}")

INTERFACE IDDrawExclModeVideoCallback $IID_IDDrawExclModeVideoCallback

   INHERIT IUnknown

   ' =====================================================================================
   METHOD OnUpdateOverlay ( _               ' VTable offset = 12
     BYVAL LONG _                           ' /* [in] */ BOOL bBefore
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYVAL LONG _                           ' /* [in] */ BOOL bOldVisible
   , BYREF RECT _                           ' /* [in] */ const RECT *prcOldSrc
   , BYREF RECT _                           ' /* [in] */ const RECT *prcOldDest
   , BYVAL LONG _                           ' /* [in] */ BOOL bNewVisible
   , BYREF RECT _                           ' /* [in] */ const RECT *prcNewSrc
   , BYREF RECT _                           ' /* [in] */ const RECT *prcNewDest
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnUpdateColorKey ( _              ' VTable offset = 16
     BYREF COLORKEY _                       ' /* [in] */ const COLORKEY *pKey
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwColor
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD OnUpdateSize ( _                  ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ DWORD dwWidth
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwHeight
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwARWidth
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwARHeight
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDDrawExclModeVideoCallback_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IPinConnection
' IID = {4A9A62D3-27D4-403D-91E9-89F540E55534}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPinConnection_INTERFACE_DEFINED)
    %IPinConnection_INTERFACE_DEFINED = 1

$IID_IPinConnection = GUID$("{4A9A62D3-27D4-403D-91E9-89F540E55534}")

INTERFACE IPinConnection $IID_IPinConnection

   INHERIT IUnknown

   ' =====================================================================================
   METHOD DynamicQueryAccept ( _            ' VTable offset = 12
     BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmt
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD NotifyEndOfStream ( _             ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ HANDLE hNotifyEvent
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD IsEndPin ( _                      ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD DynamicDisconnect ( _             ' VTable offset = 24
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPinConnection_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IPinFlowControl
' IID = {C56E9858-DBF3-4F6B-8119-384AF2060DEB}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IPinFlowControl_INTERFACE_DEFINED)
    %IPinFlowControl_INTERFACE_DEFINED = 1

$IID_IPinFlowControl = GUID$("{C56E9858-DBF3-4F6B-8119-384AF2060DEB}")

INTERFACE IPinFlowControl $IID_IPinFlowControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Block ( _                         ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwBlockFlags
   , BYVAL DWORD _                          ' /* [in] */ HANDLE hEvent
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPinFlowControl_INTERFACE_DEFINED__ */


' enum AM_PIN_FLOW_CONTROL_BLOCK_FLAGS
%AM_PIN_FLOW_CONTROL_BLOCK   = &H1

' enum AM_GRAPH_CONFIG_RECONNECT_FLAGS
%AM_GRAPH_CONFIG_RECONNECT_DIRECTCONNECT           = &H1
%AM_GRAPH_CONFIG_RECONNECT_CACHE_REMOVED_FILTERS   = &H2
%AM_GRAPH_CONFIG_RECONNECT_USE_ONLY_CACHED_FILTERS = &H4

' enum REM_FILTER_FLAGS
%REMFILTERF_LEAVECONNECTED   = &H1

' enum AM_FILTER_FLAGS
%AM_FILTER_FLAGS_REMOVABLE   = &H1


' ########################################################################################
' Interface name = IGraphConfig
' IID = {03A1EB8E-32BF-4245-8502-114D08A9CB88}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IGraphConfig_INTERFACE_DEFINED)
    %IGraphConfig_INTERFACE_DEFINED = 1

$IID_IGraphConfig = GUID$("{03A1EB8E-32BF-4245-8502-114D08A9CB88}")

INTERFACE IGraphConfig $IID_IGraphConfig

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Reconnect ( _                     ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IPin *pOutputPin
   , BYVAL IUnknown _                       ' /* [in] */ IPin *pInputPin
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ const AM_MEDIA_TYPE *pmtFirstConnection
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pUsingFilter
   , BYVAL DWORD _                          ' /* [in] */ HANDLE hAbortEvent
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD Reconfigure ( _                   ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IGraphConfigCallback *pCallback
   , BYVAL DWORD _                          ' /* [in] */ PVOID pvContext
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   , BYVAL DWORD _                          ' /* [in] */ HANDLE hAbortEvent
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AddFilterToCache ( _              ' VTable offset = 20
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD EnumCacheFilter ( _               ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ IEnumFilters **pEnum
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RemoveFilterFromCache ( _         ' VTable offset = 28
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetStartTime ( _                  ' VTable offset = 32
     BYREF QUAD _                           ' /* [out] */ REFERENCE_TIME *prtStart
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PushThroughData ( _               ' VTable offset = 36
     BYVAL IUnknown _                       ' /* [in] */ IPin *pOutputPin
   , BYVAL IUnknown _                       ' /* [in] */ IPinConnection *pConnection
   , BYVAL DWORD _                          ' /* [in] */ HANDLE hEventAbort
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetFilterFlags ( _                ' VTable offset = 40
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetFilterFlags ( _                ' VTable offset = 44
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RemoveFilterEx ( _                ' VTable offset = 48
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pFilter
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IGraphConfig_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IGraphConfigCallback
' IID = {ADE0FD60-D19D-11D2-ABF6-00A0C905F375}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IGraphConfigCallback_INTERFACE_DEFINED)
    %IGraphConfigCallback_INTERFACE_DEFINED = 1

$IID_IGraphConfigCallback = GUID$("{ADE0FD60-D19D-11D2-ABF6-00A0C905F375}")

INTERFACE IGraphConfigCallback $IID_IGraphConfigCallback

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Reconfigure ( _                   ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ PVOID pvContext
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IGraphConfigCallback_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IFilterChain
' IID = {DCFBDCF6-0DC2-45F5-9AB2-7C330EA09C29}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IFilterChain_INTERFACE_DEFINED)
    %IFilterChain_INTERFACE_DEFINED = 1

$IID_IFilterChain = GUID$("{DCFBDCF6-0DC2-45F5-9AB2-7C330EA09C29}")

INTERFACE IFilterChain $IID_IFilterChain

   INHERIT IUnknown

   ' =====================================================================================
   METHOD StartChain ( _                    ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pStartFilter
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pEndFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PauseChain ( _                    ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pStartFilter
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pEndFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD StopChain ( _                     ' VTable offset = 20
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pStartFilter
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pEndFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RemoveChain ( _                   ' VTable offset = 24
     BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pStartFilter
   , BYVAL IUnknown _                       ' /* [in] */ IBaseFilter *pEndFilter
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* C style interface */


'typedef DWORD *LPDIRECTDRAW7;
'typedef DWORD *LPDIRECTDRAWSURFACE7;
'typedef DWORD *LPDDPIXELFORMAT;
'typedef DWORD *LPBITMAPINFOHEADER;

' Already defined in DDRAW.INC with different variable names
'TYPE DDCOLORKEY
'   dw1 AS DWORD
'   dw2 AS DWORD
'END TYPE

' enum VMRPresentationFlags
%VMRSample_SyncPoint        = &H1???
%VMRSample_Preroll          = &H2???
%VMRSample_Discontinuity    = &H4???
%VMRSample_TimeValid        = &H8???
%VMRSample_SrcDstRectsValid = &H10???

TYPE VMRPRESENTATIONINFO
   dwFlags             AS DWORD     ' DWORD
   lpSurf              AS DWORD     ' LPDIRECTDRAWSURFACE7
   rtStart             AS QUAD      ' REFERENCE_TIME
   rtEnd               AS QUAD      ' REFERENCE_TIME
   szAspectRatio       AS APISIZE   ' SIZE
   rcSrc               AS RECT      ' RECT
   rcDst               AS RECT      ' RECT
   dwTypeSpecificFlags AS DWORD     ' DWORD
   dwInterlaceFlags    AS DWORD     ' DWORD
END TYPE


' ########################################################################################
' Interface name = IVMRImagePresenter
' IID = {CE704FE7-E71E-41FB-BAA2-C4403E1182F5}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRImagePresenter_INTERFACE_DEFINED)
    %IVMRImagePresenter_INTERFACE_DEFINED = 1

$IID_IVMRImagePresenter = GUID$("{CE704FE7-E71E-41FB-BAA2-C4403E1182F5}")

INTERFACE IVMRImagePresenter $IID_IVMRImagePresenter

   INHERIT IUnknown

   ' =====================================================================================
   METHOD StartPresenting ( _               ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwUserID
   , BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwUserID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD StopPresenting ( _                ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwUserID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PresentImage ( _                  ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwUserID
   , BYREF VMRPRESENTATIONINFO _            ' /* [in] */ VMRPRESENTATIONINFO *lpPresInfo
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRImagePresenter_INTERFACE_DEFINED__ */


' enum VMRSurfaceAllocationFlags
%AMAP_PIXELFORMAT_VALID = &H1
%AMAP_3D_TARGET         = &H2
%AMAP_ALLOW_SYSMEM      = &H4
%AMAP_FORCE_SYSMEM      = &H8
%AMAP_DIRECTED_FLIP     = &H10
%AMAP_DXVA_TARGET       = &H20

TYPE VMRALLOCATIONINFO
   dwFlags          AS DWORD                  ' DWORD
   lpHdr            AS BITMAPINFOHEADER PTR   ' LPBITMAPINFOHEADER
   lpPixFmt         AS DWORD                  ' LPDDPIXELFORMAT
   szAspectRatio    AS APISIZE                ' SIZE
   dwMinBuffers     AS DWORD                  ' DWORD
   dwMaxBuffers     AS DWORD                  ' DWORD
   dwInterlaceFlags AS DWORD                  ' DWORD
   szNativeSize     AS APISIZE                ' SIZE
END TYPE


' ########################################################################################
' Interface name = IVMRSurfaceAllocator
' IID = {31CE832E-4484-458B-8CCA-F4D7E3DB0B52}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRSurfaceAllocator_INTERFACE_DEFINED)
    %IVMRSurfaceAllocator_INTERFACE_DEFINED = 1

$IID_IVMRSurfaceAllocator = GUID$("{31CE832E-4484-458B-8CCA-F4D7E3DB0B52}")

INTERFACE IVMRSurfaceAllocator $IID_IVMRSurfaceAllocator

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AllocateSurface ( _               ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwUserID
   , BYREF VMRALLOCATIONINFO _              ' /* [in] */ VMRALLOCATIONINFO *lpAllocInfo
   , BYREF DWORD _                          ' /* [out][in] */ DWORD *lpdwActualBuffers
   , BYREF IUnknown _                       ' /* [out] */ LPDIRECTDRAWSURFACE7 *lplpSurface
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD FreeSurface ( _                   ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD PrepareSurface ( _                ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwUserID
   , BYVAL IUnknown _                       ' /* [in] */ LPDIRECTDRAWSURFACE7 lpSurface
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwSurfaceFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD AdviseNotify ( _                  ' VTable offset = 24
     BYVAL IUnknown _                       ' /* [in] */ IVMRSurfaceAllocatorNotify *lpIVMRSurfAllocNotify
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRSurfaceAllocator_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVMRSurfaceAllocatorNotify
' IID = {AADA05A8-5A4E-4729-AF0B-CEA27AED51E2}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRSurfaceAllocatorNotify_INTERFACE_DEFINED)
    %IVMRSurfaceAllocatorNotify_INTERFACE_DEFINED = 1

$IID_IVMRSurfaceAllocatorNotify = GUID$("{AADA05A8-5A4E-4729-AF0B-CEA27AED51E2}")

INTERFACE IVMRSurfaceAllocatorNotify $IID_IVMRSurfaceAllocatorNotify

   INHERIT IUnknown

   ' =====================================================================================
   METHOD AdviseSurfaceAllocator ( _        ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD_PTR dwUserID
   , BYVAL IUnknown _                       ' * [in] */ IVMRSurfaceAllocator *lpIVRMSurfaceAllocator
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDDrawDevice ( _                ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ LPDIRECTDRAW7 lpDDrawDevice
   , BYVAL DWORD _                          ' /* [in] */ HMONITOR hMonitor
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD ChangeDDrawDevice ( _             ' VTable offset = 20
     BYVAL IUnknown _                       ' /* [in] */ LPDIRECTDRAW7 lpDDrawDevice
   , BYVAL DWORD _                          ' /* [in] */ HMONITOR hMonitor
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RestoreDDrawSurfaces ( _          ' VTable offset = 24
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD NotifyEvent ( _                   ' VTable offset = 28
     BYVAL LONG _                           ' /* [in] */ LONG EventCode
   , BYVAL LONG _                           ' /* [in] */ LONG_PTR Param1
   , BYVAL LONG _                           ' /* [in] */ LONG_PTR Param2
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetBorderColor ( _                ' VTable offset = 36
     BYVAL DWORD _                          ' /* [in] */ COLORREF clrBorder
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRSurfaceAllocatorNotify_INTERFACE_DEFINED__ */


' enum VMR_ASPECT_RATIO_MODE
%VMR_ARMODE_NONE       = 0
%VMR_ARMODE_LETTER_BOX = %VMR_ARMODE_NONE + 1


' ########################################################################################
' Interface name = IVMRWindowlessControl
' IID = {0EB1088C-4DCD-46F0-878F-39DAE86A51B7}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRWindowlessControl_INTERFACE_DEFINED)
    %IVMRWindowlessControl_INTERFACE_DEFINED = 1

$IID_IVMRWindowlessControl = GUID$("{0EB1088C-4DCD-46F0-878F-39DAE86A51B7}")

INTERFACE IVMRWindowlessControl $IID_IVMRWindowlessControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetNativeVideoSize ( _            ' VTable offset = 12
     BYREF LONG _                           ' /* [out] */ LONG *lpWidth
   , BYREF LONG _                           ' /* [out] */ LONG *lpHeight
   , BYREF LONG _                           ' /* [out] */ LONG *lpARWidth
   , BYREF LONG _                           ' /* [out] */ LONG *lpARHeight
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMinIdealVideoSize ( _          ' VTable offset = 16
     BYREF LONG _                           ' /* [out] */ LONG *lpWidth
   , BYREF LONG _                           ' /* [out] */ LONG *lpHeight
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMaxIdealVideoSize ( _          ' VTable offset = 20
     BYREF LONG _                           ' /* [out] */ LONG *lpWidth
   , BYREF LONG _                           ' /* [out] */ LONG *lpHeight
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetVideoPosition ( _              ' VTable offset = 24
     BYREF RECT _                           ' /* [in] */ const LPRECT lpSRCRect
   , BYREF RECT _                           ' /* [in] */ const LPRECT lpDSTRect
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetVideoPosition ( _              ' VTable offset = 28
     BYREF RECT _                           ' /* [in] */ LPRECT lpSRCRect
   , BYREF RECT _                           ' /* [in] */ LPRECT lpDSTRect
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAspectRatioMode ( _            ' VTable offset = 32
     BYREF DWORD _                          ' /* [out] */ DWORD *lpAspectRatioMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetAspectRatioMode ( _            ' VTable offset = 36
     BYVAL DWORD _                          ' /* [in] */ DWORD AspectRatioMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetVideoClippingWindow ( _        ' VTable offset = 40
     BYVAL DWORD _                          ' /* [in] */ HWND hwnd
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD RepaintVideo ( _                  ' VTable offset = 44
     BYVAL DWORD _                          ' /* [in] */ HWND hwnd
   , BYVAL DWORD _                          ' /* [in] */ HDC hdc
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD DisplayModeChanged ( _            ' VTable offset = 48
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetCurrentImage ( _               ' VTable offset = 52
     BYREF DWORD _                          ' /* [out] */ BYTE **lpDib
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetBorderColor ( _                ' VTable offset = 56
     BYVAL DWORD _                          ' /* [in] */ COLORREF Clr
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetBorderColor ( _                ' VTable offset = 60
     BYREF DWORD _                          ' /* [out] */ COLORREF *lpClr
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetColorKey ( _                   ' VTable offset = 64
     BYVAL DWORD _                          ' /* [in] */ COLORREF Clr
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetColorKey ( _                   ' VTable offset = 68
     BYREF DWORD _                          ' /* [out] */ COLORREF *lpClr
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRWindowlessControl_INTERFACE_DEFINED__ */


' enum VMRMixerPrefs
%MixerPref_NoDecimation         = &H1
%MixerPref_DecimateOutput       = &H2
%MixerPref_ARAdjustXorY         = &H4
%MixerPref_DecimationReserved   = &H8
%MixerPref_DecimateMask         = &Hf
%MixerPref_BiLinearFiltering    = &H10
%MixerPref_PointFiltering       = &H20
%MixerPref_FilteringMask        = &Hf0
%MixerPref_RenderTargetRGB      = &H100
%MixerPref_RenderTargetYUV      = &H1000
%MixerPref_RenderTargetYUV420   = &H200
%MixerPref_RenderTargetYUV422   = &H400
%MixerPref_RenderTargetYUV444   = &H800
%MixerPref_RenderTargetReserved = &He000
%MixerPref_RenderTargetMask     = &Hff00
%MixerPref_DynamicSwitchToBOB   = &H10000
%MixerPref_DynamicDecimateBy2   = &H20000
%MixerPref_DynamicReserved      = &Hc0000
%MixerPref_DynamicMask          = &Hf0000

TYPE NORMALIZEDRECT
   left   AS SINGLE
   top    AS SINGLE
   right  AS SINGLE
   bottom AS SINGLE
END TYPE


' ########################################################################################
' Interface name = IVMRMixerControl
' IID = {1C1A17B0-BED0-415D-974B-DC6696131599}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRMixerControl_INTERFACE_DEFINED)
    %IVMRMixerControl_INTERFACE_DEFINED = 1

$IID_IVMRMixerControl = GUID$("{1C1A17B0-BED0-415D-974B-DC6696131599}")

INTERFACE IVMRMixerControl $IID_IVMRMixerControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetAlpha ( _                      ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYVAL SINGLE _                         ' /* [in] */ float Alpha
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAlpha ( _                      ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYREF SINGLE _                         ' /* [out] */ float *pAlpha
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetZOrder ( _                     ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwZ
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetZOrder ( _                     ' VTable offset = 24
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYREF DWORD _                          ' /* [out] */ DWORD *pZ
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetOutputRect ( _                 ' VTable offset = 28
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYREF NORMALIZEDRECT _                 ' /* [in] */ const NORMALIZEDRECT *pRect
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetOutputRect ( _                 ' VTable offset = 32
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYREF NORMALIZEDRECT _                 ' /* [out] */ NORMALIZEDRECT *pRect
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetBackgroundClr ( _              ' VTable offset = 36
     BYVAL DWORD _                          ' /* [in] */ COLORREF ClrBkg
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetBackgroundClr ( _              ' VTable offset = 40
     BYVAL DWORD _                          ' /* [in] */ COLORREF ClrBkg
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetMixingPrefs ( _                ' VTable offset = 44
     BYVAL DWORD _                          ' /* [in] */ DWORD dwMixerPrefs
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMixingPrefs ( _                ' VTable offset = 48
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwMixerPrefs
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRMixerControl_INTERFACE_DEFINED__ */


TYPE VMRGUID
   pGUID AS GUID PTR
   GUID  AS GUID
END TYPE

TYPE VMRMONITORINFO
   guid            AS VMRGUID            ' VMRGUID guid
   rcMonitor       AS RECT               ' RECT rcMonitor
   hMon            AS DWORD              ' HMONITOR hMon
   dwFlags         AS DWORD              ' DWORD dwFlags
   szDevice        AS STRING * 32 * 2    ' wchar_t szDevice[ 32 ]
   szDescription   AS STRING * 256 * 2   ' wchar_t szDescription[ 256 ]
   liDriverVersion AS QUAD               ' LARGE_INTEGER liDriverVersion
   dwVendorId      AS DWORD              ' DWORD dwVendorId
   dwDeviceId      AS DWORD              ' DWORD dwDeviceId
   dwSubSysId      AS DWORD              ' DWORD dwSubSysId
   dwRevision      AS DWORD              ' DWORD dwRevision
END TYPE


' ########################################################################################
' Interface name = IVMRMonitorConfig
' IID = {9CF0B1B6-FBAA-4B7F-88CF-CF1F130A0DCE}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRMonitorConfig_INTERFACE_DEFINED)
    %IVMRMonitorConfig_INTERFACE_DEFINED = 1

$IID_IVMRMonitorConfig = GUID$("{9CF0B1B6-FBAA-4B7F-88CF-CF1F130A0DCE}")

INTERFACE IVMRMonitorConfig $IID_IVMRMonitorConfig

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetMonitor ( _                    ' VTable offset = 12
     BYREF VMRGUID _                        ' /* [in] */ const VMRGUID *pGUID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetMonitor ( _                    ' VTable offset = 16
     BYREF VMRGUID _                        ' /* [out] */ VMRGUID *pGUI
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDefaultMonitor ( _             ' VTable offset = 20
     BYREF VMRGUID _                        ' /* [in] */ const VMRGUID *pGUID
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDefaultMonitor ( _             ' VTable offset = 24
     BYREF VMRGUID _                        ' /* [out] */ VMRGUID *pGUI
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAvailableMonitors ( _          ' VTable offset = 28
     BYREF VMRMONITORINFO _                 ' /* [out] */ VMRMONITORINFO *pInfo
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwMaxInfoArraySize
   , BYREF DWORD _                          ' /* [out] */ DWORD *pdwNumDevices
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRMonitorConfig_INTERFACE_DEFINED__ */


' enum VMRRenderPrefs
%RenderPrefs_RestrictToInitialMonitor     = 0
%RenderPrefs_ForceOffscreen               = &H1
%RenderPrefs_ForceOverlays                = &H2
%RenderPrefs_AllowOverlays                = 0
%RenderPrefs_AllowOffscreen               = 0
%RenderPrefs_DoNotRenderColorKeyAndBorder = &H8
%RenderPrefs_Reserved                     = &H10
%RenderPrefs_PreferAGPMemWhenMixing       = &H20
%RenderPrefs_Mask                         = &H3f

' enum VMRMode
%VMRMode_Windowed   = &H1
%VMRMode_Windowless = &H2
%VMRMode_Renderless = &H4
%VMRMode_Mask       = &H7

' enum __MIDL___MIDL_itf_strmif_0393_0003
%MAX_NUMBER_OF_STREAMS = 16


' ########################################################################################
' Interface name = IVMRFilterConfig
' IID = {9E5530C5-7034-48B4-BB46-0B8A6EFC8E36}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRFilterConfig_INTERFACE_DEFINED)
    %IVMRFilterConfig_INTERFACE_DEFINED = 1

$IID_IVMRFilterConfig = GUID$("{9E5530C5-7034-48B4-BB46-0B8A6EFC8E36}")

INTERFACE IVMRFilterConfig $IID_IVMRFilterConfig

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetImageCompositor ( _            ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IVMRImageCompositor *lpVMRImgCompositor
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetNumberOfStreams ( _            ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ DWORD dwMaxStreams
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetNumberOfStreams ( _            ' VTable offset = 20
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwMaxStreams
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetRenderingPrefs ( _             ' VTable offset = 24
     BYVAL DWORD _                          ' /* [in] */ DWORD dwRenderFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetRenderingPrefs ( _             ' VTable offset = 28
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwRenderFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetRenderingMode ( _              ' VTable offset = 32
     BYVAL DWORD _                          ' /* [in] */ DWORD Mode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetRenderingMode ( _              ' VTable offset = 36
     BYREF DWORD _                          ' /* [out] */ DWORD *pMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRFilterConfig_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVMRAspectRatioControl
' IID = {EDE80B5C-BAD6-4623-B537-65586C9F8DFD}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRAspectRatioControl_INTERFACE_DEFINED)
    %IVMRAspectRatioControl_INTERFACE_DEFINED = 1

$IID_IVMRAspectRatioControl = GUID$("{EDE80B5C-BAD6-4623-B537-65586C9F8DFD}")

INTERFACE IVMRAspectRatioControl $IID_IVMRAspectRatioControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetAspectRatioMode ( _            ' VTable offset = 12
     BYREF DWORD _                          ' /* [out] */ LPDWORD lpdwARMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetAspectRatioMode ( _            ' VTable offset = 16
     BYVAL DWORD _                          ' /* [in] */ DWORD dwARMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRAspectRatioControl_INTERFACE_DEFINED__ */


' enum VMRDeinterlacePrefs
%DeinterlacePref_NextBest = &H1
%DeinterlacePref_BOB      = &H2
%DeinterlacePref_Weave    = &H4
%DeinterlacePref_Mask     = &H7

' enum VMRDeinterlaceTech
%DeinterlaceTech_Unknown             = 0
%DeinterlaceTech_BOBLineReplicate    = &H1
%DeinterlaceTech_BOBVerticalStretch  = &H2
%DeinterlaceTech_MedianFiltering     = &H4
%DeinterlaceTech_EdgeFiltering       = &H10
%DeinterlaceTech_FieldAdaptive       = &H20
%DeinterlaceTech_PixelAdaptive       = &H40
%DeinterlaceTech_MotionVectorSteered = &H80

TYPE VMRFrequency
   dwNumerator   AS DWORD
   dwDenominator AS DWORD
END TYPE

TYPE VMRVideoDesc
   dwSize               AS DWORD
   dwSampleWidth        AS DWORD
   dwSampleHeight       AS DWORD
   SingleFieldPerSample AS LONG
   dwFourCC             AS DWORD
   InputSampleFreq      AS VMRFrequency
   OutputFrameFreq      AS VMRFrequency
END TYPE

TYPE VMRDeinterlaceCaps
   dwSize                    AS DWORD
   dwNumPreviousOutputFrames AS DWORD
   dwNumForwardRefSamples    AS DWORD
   dwNumBackwardRefSamples   AS DWORD
   DeinterlaceTechnology     AS LONG    ' VMRDeinterlaceTech enum
END TYPE


' ########################################################################################
' Interface name = IVMRDeinterlaceControl
' IID = {BB057577-0DB8-4E6A-87A7-1A8C9A505A0F}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRDeinterlaceControl_INTERFACE_DEFINED)
    %IVMRDeinterlaceControl_INTERFACE_DEFINED = 1

$IID_IVMRDeinterlaceControl = GUID$("{BB057577-0DB8-4E6A-87A7-1A8C9A505A0F}")

INTERFACE IVMRDeinterlaceControl $IID_IVMRDeinterlaceControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD GetNumberOfDeinterlaceModes ( _   ' VTable offset = 12
     BYREF VMRVideoDesc _                   ' /* [in] */ VMRVideoDesc *lpVideoDescription
   , BYREF DWORD _                          ' /* [out][in] */ LPDWORD lpdwNumDeinterlaceModes
   , BYREF GUID _                           ' /* [out] */ LPGUID lpDeinterlaceModes
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDeinterlaceModeCaps ( _        ' VTable offset = 16
     BYREF GUID _                           ' /* [in] */ LPGUID lpDeinterlaceMode
   , BYREF VMRVideoDesc _                   ' /* [in] */ VMRVideoDesc *lpVideoDescription
   , BYREF VMRDeinterlaceCaps _             ' /* [out][in] */ VMRDeinterlaceCaps *lpDeinterlaceCaps
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDeinterlaceMode ( _            ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYREF GUID _                           ' /* [out] */ LPGUID lpDeinterlaceMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDeinterlaceMode ( _            ' VTable offset = 24
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYREF GUID _                           ' /* [in] */ LPGUID lpDeinterlaceMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetDeinterlacePrefs ( _           ' VTable offset = 28
     BYREF DWORD _                          ' /* [out] */ LPDWORD lpdwDeinterlacePrefs
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetDeinterlacePrefs ( _           ' VTable offset = 32
     BYVAL DWORD _                          ' /* [in] */ DWORD dwDeinterlacePrefs
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetActualDeinterlaceMode ( _      ' VTable offset = 36
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStreamID
   , BYREF GUID _                           ' /* [out] */ LPGUID lpDeinterlaceMode
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRDeinterlaceControl_INTERFACE_DEFINED__ */


TYPE VMRALPHABITMAP
   dwFlags    AS DWORD           ' DWORD dwFlags
   hdc       AS DWORD            ' HDC hdc
   pDDS      AS DWORD            ' LPDIRECTDRAWSURFACE7 pDDS
   rSrc      AS RECT             ' RECT rSrc
   rDest     AS NORMALIZEDRECT   ' NORMALIZEDRECT rDest
   fAlpha    AS SINGLE           ' FLOAT fAlpha
   clrSrcKey AS DWORD            ' COLORREF clrSrcKey
END TYPE

%VMRBITMAP_DISABLE            = &H00000001???
%VMRBITMAP_HDC                = &H00000002???
%VMRBITMAP_ENTIREDDS          = &H00000004???
%VMRBITMAP_SRCCOLORKEY        = &H00000008???
%VMRBITMAP_SRCRECT            = &H00000010???


' ########################################################################################
' Interface name = IVMRMixerBitmap
' IID = {1E673275-0257-40AA-AF20-7C608D4A0428}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRMixerBitmap_INTERFACE_DEFINED)
    %IVMRMixerBitmap_INTERFACE_DEFINED = 1

$IID_IVMRMixerBitmap = GUID$("{1E673275-0257-40AA-AF20-7C608D4A0428}")

INTERFACE IVMRMixerBitmap $IID_IVMRMixerBitmap

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetAlphaBitmap ( _                ' VTable offset = 12
     BYREF VMRALPHABITMAP _                 ' /* [in] */ const VMRALPHABITMAP *pBmpParms
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UpdateAlphaBitmapParameters ( _   ' VTable offset = 16
     BYREF VMRALPHABITMAP _                 ' /* [in] */ const VMRALPHABITMAP *pBmpParms
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetAlphaBitmapParameters ( _      ' VTable offset = 20
     BYREF VMRALPHABITMAP _                 ' /* [out] */ VMRALPHABITMAP *pBmpParms
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRMixerBitmap_INTERFACE_DEFINED__ */


TYPE VMRVIDEOSTREAMINFO
   pddsVideoSurface AS DWORD            ' LPDIRECTDRAWSURFACE7 pddsVideoSurface
   dwWidth          AS DWORD            ' DWORD dwWidth
   dwHeight         AS DWORD            ' DWORD dwHeight
   dwStrmID         AS DWORD            ' DWORD dwStrmID
   fAlpha           AS SINGLE           ' FLOAT fAlpha
   ddClrKey         AS DDCOLORKEY       ' DDCOLORKEY ddClrKey
   rNormal          AS NORMALIZEDRECT   ' NORMALIZEDRECT rNormal
END TYPE


' ########################################################################################
' Interface name = IVMRImageCompositor
' IID = {7A4FB5AF-479F-4074-BB40-CE6722E43C82}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRImageCompositor_INTERFACE_DEFINED)
    %IVMRImageCompositor_INTERFACE_DEFINED = 1

$IID_IVMRImageCompositor = GUID$("{7A4FB5AF-479F-4074-BB40-CE6722E43C82}")

INTERFACE IVMRImageCompositor $IID_IVMRImageCompositor

   INHERIT IUnknown

   ' =====================================================================================
   METHOD InitCompositionTarget ( _         ' VTable offset = 12
     BYVAL IUnknown _                       ' /* [in] */ IUnknown *pD3DDevice
   , BYVAL IUnknown _                       ' /* [in] */ LPDIRECTDRAWSURFACE7 pddsRenderTarget
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD TermCompositionTarget ( _         ' VTable offset = 16
     BYVAL IUnknown _                       ' /* [in] */ IUnknown *pD3DDevice
   , BYVAL IUnknown _                       ' /* [in] */ LPDIRECTDRAWSURFACE7 pddsRenderTarget
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetStreamMediaType ( _            ' VTable offset = 20
     BYVAL DWORD _                          ' /* [in] */ DWORD dwStrmID
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ AM_MEDIA_TYPE *pmt
   , BYVAL LONG _                           ' /* [in] */ BOOL fTexture
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD CompositeImage ( _                ' VTable offset = 24
     BYVAL IUnknown _                       ' /* [in] */ IUnknown *pD3DDevice
   , BYVAL IUnknown _                       ' /* [in] */ LPDIRECTDRAWSURFACE7 pddsRenderTarget
   , BYREF AM_MEDIA_TYPE _                  ' /* [in] */ AM_MEDIA_TYPE *pmtRenderTarget
   , BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtStart
   , BYVAL QUAD _                           ' /* [in] */ REFERENCE_TIME rtEnd
   , BYVAL DWORD _                          ' /* [in] */ DWORD dwClrBkGnd
   , BYREF VMRVIDEOSTREAMINFO _             ' /* [in] */ VMRVIDEOSTREAMINFO *pVideoStreamInfo
   , BYVAL DWORD _                          ' /* [in] */ UINT cStreams
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRImageCompositor_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVMRVideoStreamControl
' IID = {058D1F11-2A54-4BEF-BD54-DF706626B727}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRVideoStreamControl_INTERFACE_DEFINED)
    %IVMRVideoStreamControl_INTERFACE_DEFINED = 1

$IID_IVMRVideoStreamControl = GUID$("{058D1F11-2A54-4BEF-BD54-DF706626B727}")

INTERFACE IVMRVideoStreamControl $IID_IVMRVideoStreamControl

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetColorKey ( _                   ' VTable offset = 12
     BYREF DDCOLORKEY _                     ' /* [in] */ LPDDCOLORKEY lpClrKey
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetColorKey ( _                   ' VTable offset = 16
     BYREF DDCOLORKEY _                     ' /* [out] */ LPDDCOLORKEY lpClrKey
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetStreamActiveState ( _          ' VTable offset = 20
     BYVAL LONG _                           ' /* [in] */ BOOL fActive
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetStreamActiveState ( _          ' VTable offset = 24
     BYREF LONG _                           ' /* [out] */ BOOL *lpfActive
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRVideoStreamControl_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVMRSurface
' IID = {A9849BBE-9EC8-4263-B764-62730F0D15D0}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRSurface_INTERFACE_DEFINED)
    %IVMRSurface_INTERFACE_DEFINED = 1

$IID_IVMRSurface = GUID$("{A9849BBE-9EC8-4263-B764-62730F0D15D0}")

INTERFACE IVMRSurface $IID_IVMRSurface

   INHERIT IUnknown

   ' =====================================================================================
   METHOD IsSurfaceLocked ( _               ' VTable offset = 12
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD LockSurface ( _                   ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ BYTE **lpSurface
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD UnlockSurface ( _                 ' VTable offset = 20
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetSurface ( _                    ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ LPDIRECTDRAWSURFACE7 *lplpSurface
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRSurface_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVMRImagePresenterConfig
' IID = {9F3A1C85-8555-49BA-935F-BE5B5B29D178}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVMRImagePresenterConfig_INTERFACE_DEFINED)
    %IVMRImagePresenterConfig_INTERFACE_DEFINED = 1

$IID_IVMRImagePresenterConfig = GUID$("{9F3A1C85-8555-49BA-935F-BE5B5B29D178}")

INTERFACE IVMRImagePresenterConfig $IID_IVMRImagePresenterConfig

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetRenderingPrefs ( _             ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwRenderFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetRenderingPrefs ( _             ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ DWORD *dwRenderFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRImagePresenterConfig_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVMRImagePresenterExclModeConfig
' IID = {E6F7CE40-4673-44F1-8F77-5499D68CB4EA}
' Inherited interface = IVMRImagePresenterConfig
' ########################################################################################

#IF NOT %DEF(%IVMRImagePresenterExclModeConfig_INTERFACE_DEFINED)
    %IVMRImagePresenterExclModeConfig_INTERFACE_DEFINED = 1

$IID_IVMRImagePresenterExclModeConfig = GUID$("{E6F7CE40-4673-44F1-8F77-5499D68CB4EA}")

INTERFACE IVMRImagePresenterExclModeConfig $IID_IVMRImagePresenterExclModeConfig

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetRenderingPrefs ( _             ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwRenderFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetRenderingPrefs ( _             ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ DWORD *dwRenderFlags
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD SetXlcModeDDObjAndPrimarySurface ( _          ' VTable offset = 20
     BYVAL IUnknown _                       ' /* [in] */ LPDIRECTDRAW7 lpDDObj
   , BYVAL IUnknown _                       ' /* [in] */ LPDIRECTDRAWSURFACE7 lpPrimarySurf
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetXlcModeDDObjAndPrimarySurface ( _          ' VTable offset = 24
     BYREF IUnknown _                       ' /* [out] */ LPDIRECTDRAW7 *lpDDObj
   , BYREF IUnknown _                       ' /* [out] */ LPDIRECTDRAWSURFACE7 *lpPrimarySurf
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVMRImagePresenterExclModeConfig_INTERFACE_DEFINED__ */


' ########################################################################################
' Interface name = IVPManager
' IID = {AAC18C18-E186-46D2-825D-A1F8DC8E395A}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IVPManager_INTERFACE_DEFINED)
    %IVPManager_INTERFACE_DEFINED = 1

$IID_IVPManager = GUID$("{AAC18C18-E186-46D2-825D-A1F8DC8E395A}")

INTERFACE IVPManager $IID_IVPManager

   INHERIT IUnknown

   ' =====================================================================================
   METHOD SetVideoPortIndex ( _             ' VTable offset = 12
     BYVAL DWORD _                          ' /* [in] */ DWORD dwVideoPortIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================
   METHOD GetVideoPortIndex ( _             ' VTable offset = 16
     BYREF DWORD _                          ' /* [out] */ DWORD *pdwVideoPortIndex
   ) AS LONG                                ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVPManager_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%STRMIF_INC)


'typedef double REFTIME;
'typedef LONG_PTR OAEVENT;
'typedef LONG_PTR OAHWND;
'typedef long OAFilterState;

' ========================================================================================
' ClsIDs (Class identifiers)
' ========================================================================================

$LIBID_QuartzTypeLib   = GUID$("{56A868B0-0AD4-11CE-B03A-0020AF0BA770}")
$CLSID_FilgraphManager = GUID$("{E436EBB3-524F-11CE-9F53-0020AF0BA770}")

' ========================================================================================
' IIDs (Interface identifiers)
' ========================================================================================

$IID_IAMCollection     = GUID$("{56A868B9-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IAMStats          = GUID$("{BC9BCF80-DCD2-11D2-ABF6-00A0C905F375}")
$IID_IBasicAudio       = GUID$("{56A868B3-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IBasicVideo       = GUID$("{56A868B5-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IBasicVideo2      = GUID$("{329BB360-F6EA-11D1-9038-00A0C9697298}")
$IID_IDeferredCommand  = GUID$("{56A868B8-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IFilterInfo       = GUID$("{56A868BA-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IMediaControl     = GUID$("{56A868B1-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IMediaEvent       = GUID$("{56A868B6-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IMediaEventEx     = GUID$("{56A868C0-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IMediaPosition    = GUID$("{56A868B2-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IMediaTypeInfo    = GUID$("{56A868BC-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IPinInfo          = GUID$("{56A868BD-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IQueueCommand     = GUID$("{56A868B7-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IRegFilterInfo    = GUID$("{56A868BB-0AD4-11CE-B03A-0020AF0BA770}")
$IID_IVideoWindow      = GUID$("{56A868B4-0AD4-11CE-B03A-0020AF0BA770}")

' ########################################################################################
' Interface name = IAMCollection
' IID = {56A868B9-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IAMCollection_INTERFACE_DEFINED)
    %IAMCollection_INTERFACE_DEFINED = 1

INTERFACE IAMCollection $IID_IAMCollection

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Count <1610743808> ( _        ' VTable offset = 28
   ) AS LONG                                  ' /* [retval][out] */ LONG *plCount
   ' =====================================================================================
   METHOD Item <1610743809> ( _               ' VTable offset = 32
     BYVAL LONG _                             ' /* [in] */ long lItem
   , BYREF IUnknown _                         ' /* [out] */ IUnknown **ppUnk
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET NewEnum_ <1610743810> ( _     ' VTable offset = 36
   ) AS IUnknown                              ' /* [retval][out] */ IUnknown **ppUnk
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMCollection_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IMediaControl
' IID = {56A868B1-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IMediaControl_INTERFACE_DEFINED)
    %IMediaControl_INTERFACE_DEFINED = 1

INTERFACE IMediaControl $IID_IMediaControl

   INHERIT IDispatch

   ' =====================================================================================
   METHOD Run <1610743808> ( _                ' VTable offset = 28
   )                                          ' void
   ' =====================================================================================
   METHOD Pause <1610743809> ( _              ' VTable offset = 32
   )                                          ' void
   ' =====================================================================================
   METHOD Stop <1610743810> ( _               ' VTable offset = 36
   )                                          ' void
   ' =====================================================================================
   METHOD GetState <1610743811> ( _           ' VTable offset = 40
     BYVAL LONG _                             ' /* [in] */ LONG msTimeout
   , BYREF LONG _                             ' /* [out] */ OAFilterState *pfs
   )                                          ' void
   ' =====================================================================================
   METHOD RenderFile <1610743812> ( _         ' VTable offset = 44
     BYVAL STRING _                           ' /* [in] */ BSTR strFilename
   )                                          ' void
   ' =====================================================================================
   METHOD AddSourceFilter <1610743813> ( _    ' VTable offset = 48
     BYVAL STRING _                           ' /* [in] */ BSTR strFilename
   , BYREF IDispatch _                        ' /* [out] */ IDispatch **ppUnk
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET FilterCollection <1610743814> ( _ ' VTable offset = 52
   ) AS IDispatch                             ' /* [retval][out] */ IDispatch **ppUnk
   ' =====================================================================================
   PROPERTY GET RegFilterCollection <1610743815> ( _ ' VTable offset = 56
   ) AS IDispatch                             ' /* [retval][out] */ IDispatch **ppUnk
   ' =====================================================================================
   METHOD StopWhenReady <1610743816> ( _      ' VTable offset = 60
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaControl_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IMediaEvent
' IID = {56A868B6-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IMediaEvent_INTERFACE_DEFINED)
    %IMediaEvent_INTERFACE_DEFINED = 1

INTERFACE IMediaEvent $IID_IMediaEvent

   INHERIT IDispatch

   ' =====================================================================================
   METHOD GetEventHandle <1610743808> ( _     ' VTable offset = 28
     BYREF LONG _                             ' /* [out] */ OAEVENT *hEvent
   )                                          ' void
   ' =====================================================================================
   METHOD GetEvent <1610743809> ( _           ' VTable offset = 32
     BYREF LONG _                             ' /* [out] */ long *lEventCode
   , BYREF LONG _                             ' /* [out] */ LONG_PTR *lParam1
   , BYREF LONG _                             ' /* [out] */ LONG_PTR *lParam2
   , BYVAL LONG _                             ' /* [in] */ long msTimeout
   )                                          ' void
   ' =====================================================================================
   METHOD WaitForCompletion <1610743810> ( _  ' VTable offset = 36
     BYVAL LONG _                             ' /* [in] */ long msTimeout
   , BYREF LONG _                             ' /* [out] */ long *pEvCode
   )                                          ' void
   ' =====================================================================================
   METHOD CancelDefaultHandling <1610743811> ( _ ' VTable offset = 40
     BYVAL LONG _                             ' /* [in] */ long lEvCode
   )                                          ' void
   ' =====================================================================================
   METHOD RestoreDefaultHandling <1610743812> ( _ ' VTable offset = 44
     BYVAL LONG _                             ' /* [in] */ long lEvCode
   )                                          ' void
   ' =====================================================================================
   METHOD FreeEventParams <1610743813> ( _    ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ long lEvCode
   , BYVAL LONG _                             ' /* [in] */ LONG_PTR lParam1
   , BYVAL LONG _                             ' /* [in] */ LONG_PTR lParam2
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaEvent_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IMediaEventEx
' IID = {56A868C0-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4096 [&H1000] [Dispatchable]
' Inherited interface = IMediaEvent
' ########################################################################################

#IF NOT %DEF(%IMediaEventEx_INTERFACE_DEFINED)
    %IMediaEventEx_INTERFACE_DEFINED = 1

INTERFACE IMediaEventEx $IID_IMediaEventEx

   INHERIT IDispatch

   ' =====================================================================================
   ' IMediaEvent Methods
   ' =====================================================================================
   METHOD GetEventHandle <1610743808> ( _     ' VTable offset = 28
     BYREF LONG _                             ' /* [out] */ OAEVENT *hEvent
   )                                          ' void
   ' =====================================================================================
   METHOD GetEvent <1610743809> ( _           ' VTable offset = 32
     BYREF LONG _                             ' /* [out] */ long *lEventCode
   , BYREF LONG _                             ' /* [out] */ LONG_PTR *lParam1
   , BYREF LONG _                             ' /* [out] */ LONG_PTR *lParam2
   , BYVAL LONG _                             ' /* [in] */ long msTimeout
   )                                          ' void
   ' =====================================================================================
   METHOD WaitForCompletion <1610743810> ( _  ' VTable offset = 36
     BYVAL LONG _                             ' /* [in] */ long msTimeout
   , BYREF LONG _                             ' /* [out] */ long *pEvCode
   )                                          ' void
   ' =====================================================================================
   METHOD CancelDefaultHandling <1610743811> ( _ ' VTable offset = 40
     BYVAL LONG _                             ' /* [in] */ long lEvCode
   )                                          ' void
   ' =====================================================================================
   METHOD RestoreDefaultHandling <1610743812> ( _ ' VTable offset = 44
     BYVAL LONG _                             ' /* [in] */ long lEvCode
   )                                          ' void
   ' =====================================================================================
   METHOD FreeEventParams <1610743813> ( _    ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ long lEvCode
   , BYVAL LONG _                             ' /* [in] */ LONG_PTR lParam1
   , BYVAL LONG _                             ' /* [in] */ LONG_PTR lParam2
   )                                          ' void
   ' =====================================================================================

   ' =====================================================================================
   ' IMediaEventEx Methods
   ' =====================================================================================
   METHOD SetNotifyWindow <1610809344> ( _    ' VTable offset = 52
     BYVAL DWORD _                            ' /* [in] */ OAHWND hwnd
   , BYVAL LONG _                             ' /* [in] */ long lMsg
   , BYVAL LONG _                             ' /* [in] */ LONG_PTR lInstanceData
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD SetNotifyFlags <1610809345> ( _     ' VTable offset = 56
     BYVAL LONG _                             ' /* [in] */ long lNoNotifyFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetNotifyFlags <1610809346> ( _     ' VTable offset = 60
     BYREF LONG _                             ' /* [out] */ long *lplNoNotifyFlags
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaEventEx_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IMediaPosition
' IID = {56A868B2-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IMediaPosition_INTERFACE_DEFINED)
    %IMediaPosition_INTERFACE_DEFINED = 1

INTERFACE IMediaPosition $IID_IMediaPosition

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Duration <1610743808> ( _     ' VTable offset = 28
   ) AS DOUBLE                                ' /* [retval][out] */ REFTIME *plength
   ' =====================================================================================
   PROPERTY SET CurrentPosition <1610743809> ( _ ' VTable offset = 32
     BYVAL DOUBLE _                           ' /* [in] */ REFTIME llTime
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET CurrentPosition <1610743809> ( _ ' VTable offset = 36
   ) AS DOUBLE                                ' /* [retval][out] */ REFTIME *pllTime
   ' =====================================================================================
   PROPERTY GET StopTime <1610743811> ( _     ' VTable offset = 40
   ) AS DOUBLE                                ' /* [retval][out] */ REFTIME *pllTime
   ' =====================================================================================
   PROPERTY SET StopTime <1610743811> ( _     ' VTable offset = 44
     BYVAL DOUBLE _                           ' /* [in] */ REFTIME llTime
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET PrerollTime <1610743813> ( _  ' VTable offset = 48
   ) AS DOUBLE                                ' /* [retval][out] */ REFTIME *pllTime
   ' =====================================================================================
   PROPERTY SET PrerollTime <1610743813> ( _  ' VTable offset = 52
     BYVAL DOUBLE _                           ' /* [in] */ REFTIME llTime
   )                                          ' void
   ' =====================================================================================
   PROPERTY SET Rate <1610743815> ( _         ' VTable offset = 56
     BYVAL DOUBLE _                           ' /* [in] */ double dRate
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Rate <1610743815> ( _         ' VTable offset = 60
   ) AS DOUBLE                                ' /* [retval][out] */ double *pdRate
   ' =====================================================================================
   METHOD CanSeekForward <1610743817> ( _     ' VTable offset = 64
   ) AS LONG                                  ' /* [retval][out] */ LONG *pCanSeekForward
   ' =====================================================================================
   METHOD CanSeekBackward <1610743818> ( _    ' VTable offset = 68
   ) AS LONG                                  ' /* [retval][out] */ LONG *pCanSeekBackward
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaPosition_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IBasicAudio
' IID = {56A868B3-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IBasicAudio_INTERFACE_DEFINED)
    %IBasicAudio_INTERFACE_DEFINED = 1

INTERFACE IBasicAudio $IID_IBasicAudio

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY SET Volume <1610743808> ( _       ' VTable offset = 28
     BYVAL LONG _                             ' /* [in] */ long lVolume
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Volume <1610743808> ( _       ' VTable offset = 32
   ) AS LONG                                  ' /* [retval][out] */ long *plVolume
   ' =====================================================================================
   PROPERTY SET Balance <1610743810> ( _      ' VTable offset = 36
     BYVAL LONG _                             ' /* [in] */ long lBalance
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Balance <1610743810> ( _      ' VTable offset = 40
   ) AS LONG                                  ' /* [retval][out] */ long *plBalance
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IBasicAudio_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IVideoWindow
' IID = {56A868B4-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IVideoWindow_INTERFACE_DEFINED)
    %IVideoWindow_INTERFACE_DEFINED = 1

INTERFACE IVideoWindow $IID_IVideoWindow

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY SET Caption <1610743808> ( _      ' VTable offset = 28
     BYVAL STRING _                           ' /* [in] */ BSTR strCaption
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Caption <1610743808> ( _      ' VTable offset = 32
   ) AS STRING                                ' /* [retval][out] */ BSTR *strCaption
   ' =====================================================================================
   PROPERTY SET WindowStyle <1610743810> ( _  ' VTable offset = 36
     BYVAL LONG _                             ' /* [in] */ long WindowStyle
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET WindowStyle <1610743810> ( _  ' VTable offset = 40
   ) AS LONG                                  ' /* [retval][out] */ long *WindowStyle
   ' =====================================================================================
   PROPERTY SET WindowStyleEx <1610743812> ( _ ' VTable offset = 44
     BYVAL LONG _                             ' /* [in] */ long WindowStyleEx
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET WindowStyleEx <1610743812> ( _ ' VTable offset = 48
   ) AS LONG                                  ' /* [retval][out] */ long *WindowStyleEx
   ' =====================================================================================
   PROPERTY SET AutoShow <1610743814> ( _     ' VTable offset = 52
     BYVAL LONG _                             ' /* [in] */ long AutoShow
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET AutoShow <1610743814> ( _     ' VTable offset = 56
   ) AS LONG                                  ' /* [retval][out] */ long *AutoShow
   ' =====================================================================================
   PROPERTY SET WindowState <1610743816> ( _  ' VTable offset = 60
     BYVAL LONG _                             ' /* [in] */ long WindowState
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET WindowState <1610743816> ( _  ' VTable offset = 64
   ) AS LONG                                  ' /* [retval][out] */ long *WindowState
   ' =====================================================================================
   PROPERTY SET BackgroundPalette <1610743818> ( _ ' VTable offset = 68
     BYVAL LONG _                             ' /* [in] */ long BackgroundPalette
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET BackgroundPalette <1610743818> ( _ ' VTable offset = 72
   ) AS LONG                                  ' /* [retval][out] */ long *pBackgroundPalette
   ' =====================================================================================
   PROPERTY SET Visible <1610743820> ( _      ' VTable offset = 76
     BYVAL LONG _                             ' /* [in] */ long Visible
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Visible <1610743820> ( _      ' VTable offset = 80
   ) AS LONG                                  ' /* [retval][out] */ long *pVisible
   ' =====================================================================================
   PROPERTY SET Left <1610743822> ( _         ' VTable offset = 84
     BYVAL LONG _                             ' /* [in] */ long Left
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Left <1610743822> ( _         ' VTable offset = 88
   ) AS LONG                                  ' /* [retval][out] */ long *pLeft
   ' =====================================================================================
   PROPERTY SET Width <1610743824> ( _        ' VTable offset = 92
     BYVAL LONG _                             ' /* [in] */ long Width
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Width <1610743824> ( _        ' VTable offset = 96
   ) AS LONG                                  ' /* [retval][out] */ long *pWidth
   ' =====================================================================================
   PROPERTY SET Top <1610743826> ( _          ' VTable offset = 100
     BYVAL LONG _                             ' /* [in] */ long Top
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Top <1610743826> ( _          ' VTable offset = 104
   ) AS LONG                                  ' /* [retval][out] */ long *pTop
   ' =====================================================================================
   PROPERTY SET Height <1610743828> ( _       ' VTable offset = 108
     BYVAL LONG _                             ' /* [in] */ long Height
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Height <1610743828> ( _       ' VTable offset = 112
   ) AS LONG                                  ' /* [retval][out] */ long *pHeight
   ' =====================================================================================
   PROPERTY SET Owner <1610743830> ( _        ' VTable offset = 116
     BYVAL DWORD _                            ' /* [in] */ OAHWND Owner
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Owner <1610743830> ( _        ' VTable offset = 120
   ) AS DWORD                                 ' /* [retval][out] */ OAHWND *Owner
   ' =====================================================================================
   PROPERTY SET MessageDrain <1610743832> ( _ ' VTable offset = 124
     BYVAL DWORD _                            ' /* [in] */ OAHWND Drain
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET MessageDrain <1610743832> ( _ ' VTable offset = 128
   ) AS DWORD                                 ' /* [retval][out] */ OAHWND *Drain
   ' =====================================================================================
   PROPERTY GET BorderColor <1610743834> ( _  ' VTable offset = 132
   ) AS LONG                                  ' /* [retval][out] */ long *Color
   ' =====================================================================================
   PROPERTY SET BorderColor <1610743834> ( _  ' VTable offset = 136
     BYVAL LONG _                             ' /* [in] */ long Color
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET FullScreenMode <1610743836> ( _ ' VTable offset = 140
   ) AS LONG                                  ' /* [retval][out] */ long *FullScreenMode
   ' =====================================================================================
   PROPERTY SET FullScreenMode <1610743836> ( _ ' VTable offset = 144
     BYVAL LONG _                             ' /* [in] */ long FullScreenMode
   )                                          ' void
   ' =====================================================================================
   METHOD SetWindowForeground <1610743838> ( _ ' VTable offset = 148
     BYVAL LONG _                             ' /* [in] */ long Focus
   )                                          ' void
   ' =====================================================================================
   METHOD NotifyOwnerMessage <1610743839> ( _ ' VTable offset = 152
     BYVAL DWORD _                            ' /* [in] */ OAHWND hwnd
   , BYVAL LONG _                             ' /* [in] */ long uMsg
   , BYVAL LONG _                             ' /* [in] */ LONG_PTR wParam
   , BYVAL LONG _                             ' /* [in] */ LONG_PTR lParam
   )                                          ' void
   ' =====================================================================================
   METHOD SetWindowPosition <1610743840> ( _  ' VTable offset = 156
     BYVAL LONG _                             ' /* [in] */ long Left
   , BYVAL LONG _                             ' /* [in] */ long Top
   , BYVAL LONG _                             ' /* [in] */ long Width
   , BYVAL LONG _                             ' /* [in] */ long Height
   )                                          ' void
   ' =====================================================================================
   METHOD GetWindowPosition <1610743841> ( _  ' VTable offset = 160
     BYREF LONG _                             ' /* [out] */ long *pLeft
   , BYREF LONG _                             ' /* [out] */ long *pTop
   , BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD GetMinIdealImageSize <1610743842> ( _ ' VTable offset = 164
     BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD GetMaxIdealImageSize <1610743843> ( _ ' VTable offset = 168
     BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD GetRestorePosition <1610743844> ( _ ' VTable offset = 172
     BYREF LONG _                             ' /* [out] */ long *pLeft
   , BYREF LONG _                             ' /* [out] */ long *pTop
   , BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD HideCursor <1610743845> ( _         ' VTable offset = 176
     BYVAL LONG _                             ' /* [in] */ long HideCursor
   )                                          ' void
   ' =====================================================================================
   METHOD IsCursorHidden <1610743846> ( _     ' VTable offset = 180
     BYREF LONG _                             ' /* [out] */ long *CursorHidden
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IVideoWindow_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IBasicVideo
' IID = {56A868B5-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IBasicVideo_INTERFACE_DEFINED)
    %IBasicVideo_INTERFACE_DEFINED = 1

INTERFACE IBasicVideo $IID_IBasicVideo

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET AvgTimePerFrame <1610743808> ( _ ' VTable offset = 28
   ) AS DOUBLE                                ' /* [retval][out] */ REFTIME *pAvgTimePerFrame
   ' =====================================================================================
   PROPERTY GET BitRate <1610743809> ( _      ' VTable offset = 32
   ) AS LONG                                  ' /* [retval][out] */ long *pBitRate
   ' =====================================================================================
   PROPERTY GET BitErrorRate <1610743810> ( _ ' VTable offset = 36
   ) AS LONG                                  ' /* [retval][out] */ long *pBitErrorRate
   ' =====================================================================================
   PROPERTY GET VideoWidth <1610743811> ( _   ' VTable offset = 40
   ) AS LONG                                  ' /* [retval][out] */ long *pVideoWidth
   ' =====================================================================================
   PROPERTY GET VideoHeight <1610743812> ( _  ' VTable offset = 44
   ) AS LONG                                  ' /* [retval][out] */ long *pVideoHeight
   ' =====================================================================================
   PROPERTY SET SourceLeft <1610743813> ( _   ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ long SourceLeft
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET SourceLeft <1610743813> ( _   ' VTable offset = 52
   ) AS LONG                                  ' /* [retval][out] */ long *pSourceLeft
   ' =====================================================================================
   PROPERTY SET SourceWidth <1610743815> ( _  ' VTable offset = 56
     BYVAL LONG _                             ' /* [in] */ long SourceWidth
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET SourceWidth <1610743815> ( _  ' VTable offset = 60
   ) AS LONG                                  ' /* [retval][out] */ long *pSourceWidth
   ' =====================================================================================
   PROPERTY SET SourceTop <1610743817> ( _    ' VTable offset = 64
     BYVAL LONG _                             ' /* [in] */ long SourceTop
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET SourceTop <1610743817> ( _    ' VTable offset = 68
   ) AS LONG                                  ' /* [retval][out] */ long *pSourceTop
   ' =====================================================================================
   PROPERTY SET SourceHeight <1610743819> ( _ ' VTable offset = 72
     BYVAL LONG _                             ' /* [in] */ long SourceHeight
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET SourceHeight <1610743819> ( _ ' VTable offset = 76
   ) AS LONG                                  ' /* [retval][out] */ long *pSourceHeight
   ' =====================================================================================
   PROPERTY SET DestinationLeft <1610743821> ( _ ' VTable offset = 80
     BYVAL LONG _                             ' /* [in] */ long DestinationLeft
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET DestinationLeft <1610743821> ( _ ' VTable offset = 84
   ) AS LONG                                  ' /* [retval][out] */ long *pDestinationLeft
   ' =====================================================================================
   PROPERTY SET DestinationWidth <1610743823> ( _ ' VTable offset = 88
     BYVAL LONG _                             ' /* [in] */ long DestinationWidth
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET DestinationWidth <1610743823> ( _ ' VTable offset = 92
   ) AS LONG                                  ' /* [retval][out] */ long *pDestinationWidth
   ' =====================================================================================
   PROPERTY SET DestinationTop <1610743825> ( _ ' VTable offset = 96
     BYVAL LONG _                             ' /* [in] */ long DestinationTop
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET DestinationTop <1610743825> ( _ ' VTable offset = 100
   ) AS LONG                                  ' /* [retval][out] */ long *pDestinationTop
   ' =====================================================================================
   PROPERTY SET DestinationHeight <1610743827> ( _ ' VTable offset = 104
     BYVAL LONG _                             ' /* [in] */ long DestinationHeight
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET DestinationHeight <1610743827> ( _ ' VTable offset = 108
   ) AS LONG                                  ' /* [retval][out] */ long *pDestinationHeight
   ' =====================================================================================
   METHOD SetSourcePosition <1610743829> ( _  ' VTable offset = 112
     BYVAL LONG _                             ' /* [in] */ long Left
   , BYVAL LONG _                             ' /* [in] */ long Top
   , BYVAL LONG _                             ' /* [in] */ long Width
   , BYVAL LONG _                             ' /* [in] */ long Height
   )                                          ' void
   ' =====================================================================================
   METHOD GetSourcePosition <1610743830> ( _  ' VTable offset = 116
     BYREF LONG _                             ' /* [out] */ long *pLeft
   , BYREF LONG _                             ' /* [out] */ long *pTop
   , BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD SetDefaultSourcePosition <1610743831> ( _ ' VTable offset = 120
   )                                          ' void
   ' =====================================================================================
   METHOD SetDestinationPosition <1610743832> ( _ ' VTable offset = 124
     BYVAL LONG _                             ' /* [in] */ long Left
   , BYVAL LONG _                             ' /* [in] */ long Top
   , BYVAL LONG _                             ' /* [in] */ long Width
   , BYVAL LONG _                             ' /* [in] */ long Height
   )                                          ' void
   ' =====================================================================================
   METHOD GetDestinationPosition <1610743833> ( _ ' VTable offset = 128
     BYREF LONG _                             ' /* [out] */ long *pLeft
   , BYREF LONG _                             ' /* [out] */ long *pTop
   , BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD SetDefaultDestinationPosition <1610743834> ( _ ' VTable offset = 132
   )                                          ' void
   ' =====================================================================================
   METHOD GetVideoSize <1610743835> ( _       ' VTable offset = 136
     BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD GetVideoPaletteEntries <1610743836> ( _ ' VTable offset = 140
     BYVAL LONG _                             ' /* [in] */ long StartIndex
   , BYVAL LONG _                             ' /* [in] */ long Entries
   , BYREF LONG _                             ' /* [out] */ long *pRetrieved
   , BYREF LONG _                             ' /* [out] */ long *pPalette
   )                                          ' void
   ' =====================================================================================
   METHOD GetCurrentImage <1610743837> ( _    ' VTable offset = 144
     BYREF LONG _                             ' /* [out][in] */ long *pBufferSize
   , BYREF LONG _                             ' /* [out] */ long *pDIBImage
   )                                          ' void
   ' =====================================================================================
   METHOD IsUsingDefaultSource <1610743838> ( _ ' VTable offset = 148
   )                                          ' void
   ' =====================================================================================
   METHOD IsUsingDefaultDestination <1610743839> ( _ ' VTable offset = 152
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IBasicVideo_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IBasicVideo2
' IID = {329BB360-F6EA-11D1-9038-00A0C9697298}
' Attributes = 4096 [&H1000] [Dispatchable]
' Inherited interface = IBasicVideo
' ########################################################################################

#IF NOT %DEF(%IBasicVideo2_INTERFACE_DEFINED)
    %IBasicVideo2_INTERFACE_DEFINED = 1

INTERFACE IBasicVideo2 $IID_IBasicVideo2

   INHERIT IDispatch

   ' =====================================================================================
   ' IBasicVideo Methods
   ' =====================================================================================
   PROPERTY GET AvgTimePerFrame <1610743808> ( _ ' VTable offset = 28
   ) AS DOUBLE                                ' /* [retval][out] */ REFTIME *pAvgTimePerFrame
   ' =====================================================================================
   PROPERTY GET BitRate <1610743809> ( _      ' VTable offset = 32
   ) AS LONG                                  ' /* [retval][out] */ long *pBitRate
   ' =====================================================================================
   PROPERTY GET BitErrorRate <1610743810> ( _ ' VTable offset = 36
   ) AS LONG                                  ' /* [retval][out] */ long *pBitErrorRate
   ' =====================================================================================
   PROPERTY GET VideoWidth <1610743811> ( _   ' VTable offset = 40
   ) AS LONG                                  ' /* [retval][out] */ long *pVideoWidth
   ' =====================================================================================
   PROPERTY GET VideoHeight <1610743812> ( _  ' VTable offset = 44
   ) AS LONG                                  ' /* [retval][out] */ long *pVideoHeight
   ' =====================================================================================
   PROPERTY SET SourceLeft <1610743813> ( _   ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ long SourceLeft
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET SourceLeft <1610743813> ( _   ' VTable offset = 52
   ) AS LONG                                  ' /* [retval][out] */ long *pSourceLeft
   ' =====================================================================================
   PROPERTY SET SourceWidth <1610743815> ( _  ' VTable offset = 56
     BYVAL LONG _                             ' /* [in] */ long SourceWidth
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET SourceWidth <1610743815> ( _  ' VTable offset = 60
   ) AS LONG                                  ' /* [retval][out] */ long *pSourceWidth
   ' =====================================================================================
   PROPERTY SET SourceTop <1610743817> ( _    ' VTable offset = 64
     BYVAL LONG _                             ' /* [in] */ long SourceTop
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET SourceTop <1610743817> ( _    ' VTable offset = 68
   ) AS LONG                                  ' /* [retval][out] */ long *pSourceTop
   ' =====================================================================================
   PROPERTY SET SourceHeight <1610743819> ( _ ' VTable offset = 72
     BYVAL LONG _                             ' /* [in] */ long SourceHeight
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET SourceHeight <1610743819> ( _ ' VTable offset = 76
   ) AS LONG                                  ' /* [retval][out] */ long *pSourceHeight
   ' =====================================================================================
   PROPERTY SET DestinationLeft <1610743821> ( _ ' VTable offset = 80
     BYVAL LONG _                             ' /* [in] */ long DestinationLeft
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET DestinationLeft <1610743821> ( _ ' VTable offset = 84
   ) AS LONG                                  ' /* [retval][out] */ long *pDestinationLeft
   ' =====================================================================================
   PROPERTY SET DestinationWidth <1610743823> ( _ ' VTable offset = 88
     BYVAL LONG _                             ' /* [in] */ long DestinationWidth
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET DestinationWidth <1610743823> ( _ ' VTable offset = 92
   ) AS LONG                                  ' /* [retval][out] */ long *pDestinationWidth
   ' =====================================================================================
   PROPERTY SET DestinationTop <1610743825> ( _ ' VTable offset = 96
     BYVAL LONG _                             ' /* [in] */ long DestinationTop
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET DestinationTop <1610743825> ( _ ' VTable offset = 100
   ) AS LONG                                  ' /* [retval][out] */ long *pDestinationTop
   ' =====================================================================================
   PROPERTY SET DestinationHeight <1610743827> ( _ ' VTable offset = 104
     BYVAL LONG _                             ' /* [in] */ long DestinationHeight
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET DestinationHeight <1610743827> ( _ ' VTable offset = 108
   ) AS LONG                                  ' /* [retval][out] */ long *pDestinationHeight
   ' =====================================================================================
   METHOD SetSourcePosition <1610743829> ( _  ' VTable offset = 112
     BYVAL LONG _                             ' /* [in] */ long Left
   , BYVAL LONG _                             ' /* [in] */ long Top
   , BYVAL LONG _                             ' /* [in] */ long Width
   , BYVAL LONG _                             ' /* [in] */ long Height
   )                                          ' void
   ' =====================================================================================
   METHOD GetSourcePosition <1610743830> ( _  ' VTable offset = 116
     BYREF LONG _                             ' /* [out] */ long *pLeft
   , BYREF LONG _                             ' /* [out] */ long *pTop
   , BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD SetDefaultSourcePosition <1610743831> ( _ ' VTable offset = 120
   )                                          ' void
   ' =====================================================================================
   METHOD SetDestinationPosition <1610743832> ( _ ' VTable offset = 124
     BYVAL LONG _                             ' /* [in] */ long Left
   , BYVAL LONG _                             ' /* [in] */ long Top
   , BYVAL LONG _                             ' /* [in] */ long Width
   , BYVAL LONG _                             ' /* [in] */ long Height
   )                                          ' void
   ' =====================================================================================
   METHOD GetDestinationPosition <1610743833> ( _ ' VTable offset = 128
     BYREF LONG _                             ' /* [out] */ long *pLeft
   , BYREF LONG _                             ' /* [out] */ long *pTop
   , BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD SetDefaultDestinationPosition <1610743834> ( _ ' VTable offset = 132
   )                                          ' void
   ' =====================================================================================
   METHOD GetVideoSize <1610743835> ( _       ' VTable offset = 136
     BYREF LONG _                             ' /* [out] */ long *pWidth
   , BYREF LONG _                             ' /* [out] */ long *pHeight
   )                                          ' void
   ' =====================================================================================
   METHOD GetVideoPaletteEntries <1610743836> ( _ ' VTable offset = 140
     BYVAL LONG _                             ' /* [in] */ long StartIndex
   , BYVAL LONG _                             ' /* [in] */ long Entries
   , BYREF LONG _                             ' /* [out] */ long *pRetrieved
   , BYREF LONG _                             ' /* [out] */ long *pPalette
   )                                          ' void
   ' =====================================================================================
   METHOD GetCurrentImage <1610743837> ( _    ' VTable offset = 144
     BYREF LONG _                             ' /* [out][in] */ long *pBufferSize
   , BYREF LONG _                             ' /* [out] */ long *pDIBImage
   )                                          ' void
   ' =====================================================================================
   METHOD IsUsingDefaultSource <1610743838> ( _ ' VTable offset = 148
   )                                          ' void
   ' =====================================================================================
   METHOD IsUsingDefaultDestination <1610743839> ( _ ' VTable offset = 152
   )                                          ' void
   ' =====================================================================================

   ' =====================================================================================
   ' IBasicVideo2 Methods
   ' =====================================================================================
   METHOD GetPreferredAspectRatio <1610809344> ( _ ' VTable offset = 156
     BYREF LONG _                             ' /* [out] */ long *plAspectX
   , BYREF LONG _                             ' /* [out] */ long *plAspectY
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IBasicVideo2_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IDeferredCommand
' IID = {56A868B8-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IDeferredCommand_INTERFACE_DEFINED)
    %IDeferredCommand_INTERFACE_DEFINED = 1

INTERFACE IDeferredCommand $IID_IDeferredCommand

   INHERIT IUnknown

   ' =====================================================================================
   METHOD Cancel ( _                          ' VTable offset = 12
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Confidence ( _                      ' VTable offset = 16
     BYREF LONG _                             ' /* [out] */ LONG *pConfidence
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD Postpone ( _                        ' VTable offset = 20
     BYVAL DOUBLE _                           ' /* [in] */ REFTIME newtime
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD GetHResult ( _                      ' VTable offset = 24
     BYREF LONG _                             ' /* [out] */ HRESULT *phrResult
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDeferredCommand_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IQueueCommand
' IID = {56A868B7-0AD4-11CE-B03A-0020AF0BA770}
' Inherited interface = IUnknown
' ########################################################################################

#IF NOT %DEF(%IQueueCommand_INTERFACE_DEFINED)
    %IQueueCommand_INTERFACE_DEFINED = 1

INTERFACE IQueueCommand $IID_IQueueCommand

   INHERIT IUnknown

   ' =====================================================================================
   METHOD InvokeAtStreamTime ( _              ' VTable offset = 12
     BYREF IUnknown _                         ' /* [out] */ IDeferredCommand **pCmd
   , BYVAL DOUBLE _                           ' /* [in] */ REFTIME time
   , BYREF GUID _                             ' /* [in] */ GUID *iid
   , BYVAL LONG _                             ' /* [in] */ long dispidMethod
   , BYVAL INTEGER _                          ' /* [in] */ short wFlags
   , BYVAL LONG _                             ' /* [in] */ long cArgs
   , BYREF VARIANT _                          ' /* [in] */ VARIANT *pDispParams
   , BYREF VARIANT _                          ' /* [out][in] */ VARIANT *pvarResult
   , BYREF INTEGER _                          ' /* [out] */ short *puArgErr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================
   METHOD InvokeAtPresentationTime ( _        ' VTable offset = 16
     BYREF IUnknown _                         ' /* [out] */ IDeferredCommand **pCmd
   , BYVAL DOUBLE _                           ' /* [in] */ REFTIME time
   , BYREF GUID _                             ' /* [in] */ GUID *iid
   , BYVAL LONG _                             ' /* [in] */ long dispidMethod
   , BYVAL INTEGER _                          ' /* [in] */ short wFlags
   , BYVAL LONG _                             ' /* [in] */ long cArgs
   , BYREF VARIANT _                          ' /* [in] */ VARIANT *pDispParams
   , BYREF VARIANT _                          ' /* [out][in] */ VARIANT *pvarResult
   , BYREF INTEGER _                          ' /* [out] */ short *puArgErr
   ) AS LONG                                  ' HRESULT
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IQueueCommand_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IFilterInfo
' IID = {56A868BA-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IFilterInfo_INTERFACE_DEFINED)
    %IFilterInfo_INTERFACE_DEFINED = 1

INTERFACE IFilterInfo $IID_IFilterInfo

   INHERIT IDispatch

   ' =====================================================================================
   METHOD FindPin <1610743808> ( _            ' VTable offset = 28
     BYVAL STRING _                           ' /* [in] */ BSTR strPinID
   , BYREF IDispatch _                        ' /* [out] */ IDispatch **ppUnk
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Name <1610743809> ( _         ' VTable offset = 32
   ) AS STRING                                ' /* [retval][out] */ BSTR *strName
   ' =====================================================================================
   PROPERTY GET VendorInfo <1610743810> ( _   ' VTable offset = 36
   ) AS STRING                                ' /* [retval][out] */ BSTR *strVendorInfo
   ' =====================================================================================
   PROPERTY GET Filter <1610743811> ( _       ' VTable offset = 40
   ) AS IUnknown                              ' /* [retval][out] */ IUnknown **ppUnk
   ' =====================================================================================
   PROPERTY GET Pins <1610743812> ( _         ' VTable offset = 44
   ) AS IDispatch                             ' /* [retval][out] */ IDispatch **ppUnk
   ' =====================================================================================
   PROPERTY GET IsFileSource <1610743813> ( _ ' VTable offset = 48
   ) AS LONG                                  ' /* [retval][out] */ LONG *pbIsSource
   ' =====================================================================================
   PROPERTY GET Filename <1610743814> ( _     ' VTable offset = 52
   ) AS STRING                                ' /* [retval][out] */ BSTR *pstrFilename
   ' =====================================================================================
   PROPERTY SET Filename <1610743814> ( _     ' VTable offset = 56
     BYVAL STRING _                           ' /* [in] */ BSTR strFilename
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFilterInfo_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IRegFilterInfo
' IID = {56A868BB-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IRegFilterInfo_INTERFACE_DEFINED)
    %IRegFilterInfo_INTERFACE_DEFINED = 1

INTERFACE IRegFilterInfo $IID_IRegFilterInfo

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Name <1610743808> ( _         ' VTable offset = 28
   ) AS STRING                                ' /* [retval][out] */ BSTR *strName
   ' =====================================================================================
   METHOD Filter <1610743809> ( _             ' VTable offset = 32
     BYREF IDispatch _                        ' /* [out] */ IDispatch **ppUnk
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IRegFilterInfo_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IMediaTypeInfo
' IID = {56A868BC-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IMediaTypeInfo_INTERFACE_DEFINED)
    %IMediaTypeInfo_INTERFACE_DEFINED = 1

INTERFACE IMediaTypeInfo $IID_IMediaTypeInfo

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Type <1610743808> ( _         ' VTable offset = 28
   ) AS STRING                                ' /* [retval][out] */ BSTR *strType
   ' =====================================================================================
   PROPERTY GET Subtype <1610743809> ( _      ' VTable offset = 32
   ) AS STRING                                ' /* [retval][out] */ BSTR *strType
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IMediaTypeInfo_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IPinInfo
' IID = {56A868BD-0AD4-11CE-B03A-0020AF0BA770}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IPinInfo_INTERFACE_DEFINED)
    %IPinInfo_INTERFACE_DEFINED = 1

INTERFACE IPinInfo $IID_IPinInfo

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Pin <1610743808> ( _          ' VTable offset = 28
   ) AS IPin                                  ' /* [retval][out] */ IUnknown **ppUnk
   ' =====================================================================================
   PROPERTY GET ConnectedTo <1610743809> ( _  ' VTable offset = 32
   ) AS IPinInfo                              ' /* [retval][out] */ IDispatch **ppDisp
   ' =====================================================================================
   PROPERTY GET ConnectionMediaType <1610743810> ( _ ' VTable offset = 36
   ) AS IMediaTypeInfo                        ' /* [retval][out] */ IDispatch **ppDisp
   ' =====================================================================================
   PROPERTY GET FilterInfo <1610743811> ( _   ' VTable offset = 40
   ) AS IFilterInfo                           ' /* [retval][out] */ IDispatch **ppDisp
   ' =====================================================================================
   PROPERTY GET Name <1610743812> ( _         ' VTable offset = 44
   ) AS STRING                                ' /* [retval][out] */ BSTR *strName
   ' =====================================================================================
   PROPERTY GET Direction <1610743813> ( _    ' VTable offset = 48
   ) AS LONG                                  ' /* [retval][out] */ LONG *ppDirection
   ' =====================================================================================
   PROPERTY GET PinID <1610743814> ( _        ' VTable offset = 52
   ) AS STRING                                ' /* [retval][out] */ BSTR *strPinID
   ' =====================================================================================
   PROPERTY GET MediaTypes <1610743815> ( _   ' VTable offset = 56
   ) AS IAMCollection                         ' /* [retval][out] */ IDispatch **ppDisp
   ' =====================================================================================
   METHOD Connect <1610743816> ( _            ' VTable offset = 60
     BYVAL IPinInfo _                         ' /* [in] */ IUnknown *pPin
   )                                          ' void
   ' =====================================================================================
   METHOD ConnectDirect <1610743817> ( _      ' VTable offset = 64
     BYVAL IPinInfo _                         ' /* [in] */ IUnknown *pPin
   )                                          ' void
   ' =====================================================================================
   METHOD ConnectWithType <1610743818> ( _    ' VTable offset = 68
     BYVAL IPinInfo _                         ' /* [in] */ IUnknown *pPin
   , BYVAL IMediaTypeInfo _                   ' /* [in] */ IDispatch *pMediaType
   )                                          ' void
   ' =====================================================================================
   METHOD Disconnect <1610743819> ( _         ' VTable offset = 72
   )                                          ' void
   ' =====================================================================================
   METHOD Render <1610743820> ( _             ' VTable offset = 76
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IPinInfo_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IAMStats
' IID = {BC9BCF80-DCD2-11D2-ABF6-00A0C905F375}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IAMStats_INTERFACE_DEFINED)
    %IAMStats_INTERFACE_DEFINED = 1

INTERFACE IAMStats $IID_IAMStats

   INHERIT IDispatch

   ' =====================================================================================
   METHOD Reset <1610743808> ( _              ' VTable offset = 28
   )                                          ' void
   ' =====================================================================================
   PROPERTY GET Count <1610743809> ( _        ' VTable offset = 32
   ) AS LONG                                  ' /* [retval][out] */ LONG *plCount
   ' =====================================================================================
   METHOD GetValueByIndex <1610743810> ( _    ' VTable offset = 36
     BYVAL LONG _                             ' /* [in] */ long lIndex
   , BYREF STRING _                           ' /* [out] */ BSTR *szName
   , BYREF LONG _                             ' /* [out] */ long *lCount
   , BYREF DOUBLE _                           ' /* [out] */ double *dLast
   , BYREF DOUBLE _                           ' /* [out] */ double *dAverage
   , BYREF DOUBLE _                           ' /* [out] */ double *dStdDev
   , BYREF DOUBLE _                           ' /* [out] */ double *dMin
   , BYREF DOUBLE _                           ' /* [out] */ double *dMax
   )                                          ' void
   ' =====================================================================================
   METHOD GetValueByName <1610743811> ( _     ' VTable offset = 40
     BYVAL STRING _                           ' /* [in] */ BSTR szName
   , BYREF LONG _                             ' /* [out] */ long *lIndex
   , BYREF LONG _                             ' /* [out] */ long *lCount
   , BYREF DOUBLE _                           ' /* [out] */ double *dLast
   , BYREF DOUBLE _                           ' /* [out] */ double *dAverage
   , BYREF DOUBLE _                           ' /* [out] */ double *dStdDev
   , BYREF DOUBLE _                           ' /* [out] */ double *dMin
   , BYREF DOUBLE _                           ' /* [out] */ double *dMax
   )                                          ' void
   ' =====================================================================================
   METHOD GetIndex <1610743812> ( _           ' VTable offset = 44
     BYVAL STRING _                           ' /* [in] */ BSTR szName
   , BYVAL LONG _                             ' /* [in] */ long lCreate
   , BYREF LONG _                             ' /* [out] */ long *plIndex
   )                                          ' void
   ' =====================================================================================
   METHOD AddValue <1610743813> ( _           ' VTable offset = 48
     BYVAL LONG _                             ' /* [in] */ long lIndex
   , BYVAL DOUBLE _                           ' /* [in] */ double dValue
   )                                          ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IAMStats_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%CONTROL_INC)
